/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */


/*
 * This file gives the function pointers declarations for all APIs
 * in _ACIT_API_TABLE and ACIT_OSM_API_TABLE structures. 
 */

typedef PACIT_VOID * PPACIT_VOID ;

/*
 * Typedefs for ACIT API functions
 */


typedef ACIT_STATUS (ACIT_GET_API_VERSION_T)(
    PACIT_VERSION);

typedef ACIT_STATUS (ACIT_INIT_CONTROLLER_WS_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_VOID);

typedef ACIT_STATUS (ACIT_INIT_TARGET_WS_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_TARGET_KEY,
    PACIT_VOID);

typedef ACIT_STATUS (ACIT_INIT_LUN_WS_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_TARGET_KEY,
    PACIT_LUN_KEY,
    PACIT_VOID);

typedef ACIT_STATUS (ACIT_INIT_IO_WS_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_IO_REQUEST,
    PACIT_IO_KEY,
    PACIT_VOID);

typedef ACIT_STATUS (ACIT_INIT_TMF_WS_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_TMF_REQUEST,
    PACIT_TMF_KEY,
    PACIT_VOID);

typedef ACIT_STATUS (ACIT_SET_OSM_API_TABLE_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_VOID,
    ACIT_UEXACT32);

typedef ACIT_STATUS (ACIT_INIT_CONFIGURABLE_PARAMS_T)(
    PACIT_CONTROLLER_KEY);

typedef ACIT_STATUS (ACIT_INIT_CONTROLLER_T)(
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32,
    PACIT_VOID);

typedef ACIT_STATUS (ACIT_STOP_CONTROLLER_T)(
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32);

typedef ACIT_STATUS (ACIT_DISCOVER_TARGETS_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_VOID);

typedef ACIT_STATUS (ACIT_ENABLE_IRQ_T)(
    PACIT_CONTROLLER_KEY);

typedef ACIT_STATUS (ACIT_DISABLE_IRQ_T)(
    PACIT_CONTROLLER_KEY);

typedef ACIT_STATUS (ACIT_PROCESS_IRQ_T)(
    PACIT_CONTROLLER_KEY);

typedef ACIT_STATUS (ACIT_PROCESS_MSI_IRQ_T)(
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32);

typedef ACIT_STATUS (ACIT_START_IO_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_IO_REQUEST);

typedef ACIT_STATUS (ACIT_START_TMF_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_TMF_REQUEST);

typedef ACIT_STATUS (ACIT_START_IOCTL_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_IOCTL_REQUEST);

typedef ACIT_STATUS (ACIT_PROCESS_TIMER_TICK_T)(
    PACIT_CONTROLLER_KEY);

typedef ACIT_STATUS (ACIT_SET_MEM_PARAMS_T)(
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32);

typedef ACIT_STATUS (ACIT_GET_MEM_PARAMS_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_UEXACT32);

typedef ACIT_STATUS (ACIT_GET_MEM_DESCRIPTOR_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_VOID,
    ACIT_UEXACT32,
    PACIT_VOID);

typedef ACIT_STATUS (ACIT_SET_MEM_DESCRIPTOR_T)(
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32,
    PACIT_VOID);

typedef ACIT_STATUS (ACIT_UPDATE_LUN_INFO_T) (
    PACIT_CONTROLLER_KEY,
    PACIT_TARGET_KEY,
    PACIT_LUN_KEY,
    PACIT_VOID);

typedef ACIT_STATUS (ACIT_GET_CAPABILITIES_T)(
    PACIT_CONTROLLER_KEY,
    PACIT_CAPABILITIES);

/*
 * Typedefs for OSM API functions
 */

typedef ACIT_UEXACT32 (OSM_GET_CONFIG_VALUE_T)  (
    PACIT_CONTROLLER_KEY,
    PACIT_CONFIG_PARAM);

typedef ACIT_UEXACT32 (OSM_COMPLETE_IO_T)       (
    PACIT_CONTROLLER_KEY,
    PACIT_IO_REQUEST);

typedef ACIT_UEXACT32 (OSM_COMPLETE_TMF_T)      (
    PACIT_CONTROLLER_KEY,
    PACIT_TMF_REQUEST);

typedef ACIT_UEXACT32 (OSM_COMPLETE_IOCTL_T)    (
    PACIT_CONTROLLER_KEY,
    PACIT_IOCTL_REQUEST);

typedef ACIT_UEXACT32 (OSM_ASYNC_EVENT_T)       (
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32,
    ACIT_UEXACT32,
    ACIT_UEXACT32);

typedef ACIT_UEXACT8  (OSM_READ8_T)             (
    PACIT_CONTROLLER_KEY,
    ACIT_REGISTER_HANDLE,
    ACIT_UEXACT32);

typedef ACIT_UEXACT16 (OSM_READ16_T)            (
    PACIT_CONTROLLER_KEY,
    ACIT_REGISTER_HANDLE,
    ACIT_UEXACT32);

typedef ACIT_UEXACT32 (OSM_READ32_T)            (
    PACIT_CONTROLLER_KEY,
    ACIT_REGISTER_HANDLE,
    ACIT_UEXACT32);

typedef ACIT_UEXACT32 (OSM_READ_BUFFER_T)       (
    PACIT_CONTROLLER_KEY,
    ACIT_REGISTER_HANDLE,
    ACIT_UEXACT32,
    PACIT_VOID,
    ACIT_UEXACT32);

typedef ACIT_VOID     (OSM_WRITE8_T)            (
    PACIT_CONTROLLER_KEY,
    ACIT_REGISTER_HANDLE,
    ACIT_UEXACT32,
    ACIT_UEXACT8);

typedef ACIT_VOID     (OSM_WRITE16_T)           (
    PACIT_CONTROLLER_KEY,
    ACIT_REGISTER_HANDLE,
    ACIT_UEXACT32,
    ACIT_UEXACT16);

typedef ACIT_VOID     (OSM_WRITE32_T)           (
    PACIT_CONTROLLER_KEY,
    ACIT_REGISTER_HANDLE,
    ACIT_UEXACT32,
    ACIT_UEXACT32);

typedef ACIT_UEXACT32 (OSM_WRITE_BUFFER_T)      (
    PACIT_CONTROLLER_KEY,
    ACIT_REGISTER_HANDLE,
    ACIT_UEXACT32,
    PACIT_VOID,
    ACIT_UEXACT32);

typedef ACIT_UEXACT32 (OSM_READ_CONFIG8_T )     (
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32,
    PACIT_UEXACT8);
typedef ACIT_UEXACT32 (OSM_READ_CONFIG16_T )    (
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32,
    PACIT_UEXACT16);

typedef ACIT_UEXACT32 (OSM_READ_CONFIG32_T )    (
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32,
    PACIT_UEXACT32);

typedef ACIT_UEXACT32 (OSM_READ_CONFIG_BUFFER_T )(
    PACIT_CONTROLLER_KEY);

typedef ACIT_UEXACT32 (OSM_WRITE_CONFIG8_T )    (
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32,
    ACIT_UEXACT8);

typedef ACIT_UEXACT32 (OSM_WRITE_CONFIG16_T )   (
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32,
    ACIT_UEXACT16);

typedef ACIT_UEXACT32 (OSM_WRITE_CONFIG32_T )   (
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32,
    ACIT_UEXACT32);

typedef ACIT_UEXACT32 (OSM_WRITE_CONFIG_BUFFER_T )(
    PACIT_CONTROLLER_KEY);

typedef ACIT_BUS_ADDRESS(OSM_GET_BUS_ADDRESS_T) (
    PACIT_CONTROLLER_KEY,
    PACIT_VOID,
    PACIT_VOID,
    PACIT_UEXACT32);

typedef ACIT_UEXACT32 (OSM_DELAY_TIMER_T)       (
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32);

typedef ACIT_UEXACT32 (OSM_MAP_IO_HANDLE_T)     (
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32,
    ACIT_UEXACT32,
    ACIT_UEXACT32,
    PACIT_BUS_ADDRESS,
    PPACIT_VOID,
    PACIT_REGISTER_HANDLE);

typedef ACIT_UEXACT32 (OSM_RELEASE_IO_HANDLE_T) (
    PACIT_CONTROLLER_KEY,
    ACIT_REGISTER_HANDLE);

typedef ACIT_UEXACT32 (OSM_SYNCHRONIZE_RANGE_T) (
    PACIT_CONTROLLER_KEY);

typedef ACIT_UEXACT32 (OSM_POLL_REGISTER_T)     (
    PACIT_CONTROLLER_KEY);

typedef ACIT_VOID     (OSM_LOG_ERROR_T)         (
    PACIT_CONTROLLER_KEY,
    ACIT_UEXACT32);

typedef ACIT_VOID     (OSM_LOG_EVENT_T)       (
    PACIT_CONTROLLER_KEY,
    PACIT_EVENT_LOG_ENTRY);
