/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */

                                                                                

/*++

    Filename:

        acitcfg.h

    Purpose:

        Header file for declaring all build time customization options. The
        definitions can be changed before compilation to add/remove 
        custom functionality from the ACIT library.
    

*/


//#include "sa.h"

#ifdef BE2ISCSI_DEBUG
#define ACIT_CFG_DEBUG_BUILD                (1)
#else
#define ACIT_CFG_DEBUG_BUILD                (0)
#endif

#define ACIT_CFG_CPU_LITTLE_ENDIAN          (1)

#define ACIT_CFG_CPU_BIG_ENDIAN             (0)

#define ACIT_CFG_MAX_CONTIGUOUS_MEM         (128*1024)

#define NEW_WRB_FORMAT                      (0)

#define ACIT_CFG_VASE_ENABLED               (0)
#define ACIT_CFG_SIMULATION                 (0)

#define ACIT_CFG_DEFAULT_ETO                (30)
#define ACIT_CFG_MAX_ETO                    (3600)

#define ACIT_CFG_DEFAULT_LDTO               (20)
#define ACIT_CFG_MAX_LDTO                   (3600)


#define ACIT_CFG_DEFAULT_LARGE_IO			(128)
#define ACIT_CFG_MAX_LARGE_IO				(512)

#define ACIT_CFG_DEFAULT_IM_POLICY 			(2)
#define ACIT_CFG_MAX_IM_POLICY				(4)

#define ACIT_CFG_INTERRUPT_REDIRECTION      (0)
#define ACIT_CFG_MAX_PARTITIONS             (1)
