/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0142
#ifndef __be2_gen_api_bmap_h__
#define __be2_gen_api_bmap_h__
#include "setypes.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_Rxf_Table
//
//   Accesses an RXF table for read or write operation. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// table_type         - The RXF table type to access. 
// start_offset       - The starting offset in the RXF table to access. 
// dword_count        - The number of dwords (4-bytes) to access. 
// p_data             - Pointer to destination or source data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_Rxf_Table (
   IN void*    function_context,
   IN u8       table_type,
   IN u16      start_offset,
   IN u32      dword_count,
   IN OUT u32* p_data,
   IN boolean  write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_MAC_Address_Table
//
//   Accesses the MAC address table for read or write operation. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// index              - The index of the MAC address table entry to access. 
// p_data             - Pointer to source or destination MAC address table entry data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_MAC_Address_Table (
   IN void*   function_context,
   IN u16     index,
   IN u32*    p_data,
   IN boolean write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_Multicast_Address_Table
//
//   Accesses the Multicast address table for read or write operation. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// index              - The index of the multicast hash address table entry to access. 
// p_data             - Pointer to source or destination Multicast address table entry
//                      data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_Multicast_Address_Table (
   IN void*   function_context,
   IN u16     index,
   IN u32*    p_data,
   IN boolean write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_VLAN_Table
//
//   Accesses the VLAN table for read or write operation. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// index              - The index of the VLAN table entry to access. 
// p_data             - Pointer to source or destination VLAN table entry data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_VLAN_Table (
   IN void*   function_context,
   IN u16     index,
   IN u32*    p_data,
   IN boolean write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_FCOE_Table
//
//   Accesses the Fibre Channel Over Etherent table for read or write operation. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// index              - The index of the FCOE table entry to access. 
// p_data             - Pointer to source or destination FCOE table entry data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_FCOE_Table (
   IN void*   function_context,
   IN u16     index,
   IN u32*    p_data,
   IN boolean write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_DA_Table
//
//   Accesses the Destination Address table for read or write operation. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// index              - The index of the DA table entry to access. 
// p_data             - Pointer to source or destination DA table entry data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_DA_Table (
   IN void*   function_context,
   IN u16     index,
   IN u32*    p_data,
   IN boolean write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_ACPI_Filter_Table
//
//   Accesses the ACPI Filter table for read or write operation. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// offset             - The dword offset of the ACPI Filter table entry to access. 
// p_data             - Pointer to source or destination ACPI Filter table entry data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_ACPI_Filter_Table (
   IN void*   function_context,
   IN u16     offset,
   IN u32*    p_data,
   IN boolean write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_XGMAC_Table
//
//   Accesses the XGMAC table for read or write operation. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// port               - The port number indicating which register space to access. 
// offset             - The dword offset of the XGMAC register to access. 
// p_data             - Pointer to destination or source data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_XGMAC_Table (
   IN void*   function_context,
   IN u8      port,
   IN u16     offset,
   IN u32*    p_data,
   IN boolean write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Post_MAC_Command
//
//   Issues an AMIIM command via the XGMAC register space. Useful to access the internal
//   PCS (in XAUI mode) or external PHY (in RGMII mode). 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// port               - The port number indicating which register space to access. 
// amiim_cmd          - The AMIIM command register value. Reference the A-XGMAC
//                      specification for details. 
// amiim_field        - The AMIIM field register value. Reference the A-XGMAC
//                      specification for details. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Post_MAC_Command (
   IN void* function_context,
   IN u8    port,
   IN u32   amiim_cmd,
   IN u32   amiim_field
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_Internal_PHY_Reg
//
//   Accesses a PHY register via the XGMAC. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// port               - The port number indicating which register space to access. 
// dev_addr           - The MDI0 device address value. 
// addr               - The MMD specific address. 
// p_data             - Pointer to the destination or source data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_Internal_PHY_Reg (
   IN void*   function_context,
   IN u8      port,
   IN u8      dev_addr,
   IN u16     addr,
   IN u16*    p_data,
   IN boolean write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_Internal_Gigabit_PHY_Reg
//
//   Accesses a PHY register via the XGMAC. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// port               - The port number indicating which register space to access. 
// addr               - The MMD specific address. 
// p_data             - Pointer to the destination or source data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_Internal_Gigabit_PHY_Reg (
   IN void*   function_context,
   IN u8      port,
   IN u16     addr,
   IN u16*    p_data,
   IN boolean write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Is_Link_Up
//
//   Queries if the link on a given port is up or not. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// port               - The port number. 
// if_module          - Designates the interface module type. 
// phy_type           - Designates the PHY type. 
// return return_type - Returns TRUE if the link is up, FALSE if the link is down. 
//---------------------------------------------------------------------------------------
STATIC INLINE boolean
BE2_Gen_Is_Link_Up (
   IN void* function_context,
   IN u8    port,
   IN u8    if_module,
   IN u8    phy_type
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Is_10Gb_Link_Up
//
//   Queries if the link on a given port is up or not. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// port               - The port number. 
// if_module          - Designates the interface module type. 
// phy_type           - Designates the PHY type. 
// return return_type - Returns TRUE if the link is up, FALSE if the link is down. 
//---------------------------------------------------------------------------------------
STATIC INLINE boolean
BE2_Gen_Is_10Gb_Link_Up (
   IN void* function_context,
   IN u8    port,
   IN u8    if_module,
   IN u8    phy_type
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_DT_Init
//
//   Program a Directory Table Entry. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// cra                - Cache request address. 
// host_memory        - TRUE for host memory physical address, FALSE for ddr physical
//                      address. 
// ats_flags          - Encoded PCI ATS flags. Valid values are defined in the
//                      DMA_ATS_ENUM enumeration. 
// p_phys_addr        - Phisical address representing the DT entry. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_DT_Init (
   IN void*   function_context,
   IN u32     cra,
   IN boolean host_memory,
   IN u8      ats_flags,
   IN u64*    p_phys_addr
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_DT
//
//   Access a Directory Table entry. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// index              - DT index to access. 
// p_phys_addr        - Pointer to phsyical address data. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_DT (
   IN void*   function_context,
   IN u16     index,
   IN u64*    p_phys_addr,
   IN boolean write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Invalidate_PTC_Entry
//
//   Invalidates a Protection Table Cache entry. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// cra                - Cache request address. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Invalidate_PTC_Entry (
   IN void* function_context,
   IN u32   cra
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Invalidate_UC_Entry
//
//   Invalidates a Unified Cache entry. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// cra                - Cache request address. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Invalidate_UC_Entry (
   IN void* function_context,
   IN u32   cra
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_DTE_PTE_Init
//
//   Initializer for Directory Table Entry or Page Table Entry. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_phys_addr        - Pointer to DTE or PTE data. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_DTE_PTE_Init (
   IN void* function_context,
   IN u64*  p_phys_addr
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_CQ_Context
//
//   Access CQ context. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// cq_id              - CQ ring ID. 
// p_ctx              - Pointer to CQ context structure. 
// write_flag         - TRUE to write context, FALSE to read context. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_CQ_Context (
   IN void*       function_context,
   IN u32         cq_id,
   IN CQ_CONTEXT* p_ctx,
   IN boolean     write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_EQ_Context
//
//   Access EQ context. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// eq_id              - EQ ring ID. 
// p_ctx              - Pointer to EQ context structure. 
// write_flag         - TRUE to write context, FALSE to read context. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_EQ_Context (
   IN void*       function_context,
   IN u32         eq_id,
   IN EQ_CONTEXT* p_ctx,
   IN boolean     write_flag
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_CEV_Phase_Reset
//
//   Causes CEV to reset the current phase for all EQs. This should be called after
//   reprogramming the EQ delay multiplier or phase value. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_CEV_Phase_Reset (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_CQ_Context_Construct
//
//   Initialize CQ context structure with common default values. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_ctx              - Pointer to context structure. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_CQ_Context_Construct (
   IN void*       function_context,
   IN CQ_CONTEXT* p_ctx
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_EQ_Context_Construct
//
//   Initialize EQ context structure with common default values. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_ctx              - Pointer to context structure. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_EQ_Context_Construct (
   IN void*       function_context,
   IN EQ_CONTEXT* p_ctx
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_TCP_Context_Construct
//
//   Initialize TCP context structure with common default values. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_ctx              - Pointer to context structure. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_TCP_Context_Construct (
   IN void*        function_context,
   IN TCP_CONTEXT* p_ctx
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_ETX_Context_Construct
//
//   Initialize ETX context structure with common default values. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_ctx              - Pointer to context structure. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_ETX_Context_Construct (
   IN void*        function_context,
   IN ETX_CONTEXT* p_ctx
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_TOE_Context_Construct
//
//   Initialize TOE context structure with common default values. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_ctx              - Pointer to context structure. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_TOE_Context_Construct (
   IN void*        function_context,
   IN TOE_CONTEXT* p_ctx
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Load_EP_Firmware
//
//   Loads BladeEngine embedded processor firmware. This function depends on the BE_CONFIG
//   literal value to determine proper firmware to load. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Load_EP_Firmware (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Wakeup_EPs
//
//   Brings embedded processors out of reset. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Wakeup_EPs (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Load_TPRE_Classification
//
//   Loads BladeEngine TPRE classification firmware. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Load_TPRE_Classification (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Load_TXULP_Classification
//
//   Loads BladeEngine TPRE classification firmware. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// txulp_number       - Indicates which TXULP to initialize (0, 1, or 2). 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Load_TXULP_Classification (
   IN void* function_context,
   IN u8    txulp_number
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_RAM_Init
//
//   Performs BladeEngine memory initialization. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_RAM_Init (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Registers_Init
//
//   Performs BladeEngine register initialization. This function depends on the BE_CONFIG
//   literal value to determine proper values for ULP registers. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Registers_Init (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Init_PHYs
//
//   Performs initialization of the PHY registers. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Init_PHYs (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Enable_UEs
//
//   Unmasks and enables unrecoverable errors sources. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Enable_UEs (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Init_Management_MAC
//
//   Initializes management MAC registers and enables the management MAC. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Init_Management_MAC (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_ERX_Ring_Init
//
//   Programs an Ethernet receive ring into BladeEngine2. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// ring_id            - ERX ring ID. 
// p_phys_addr        - Pointer to an array of two physical addresses representing the ERX
//                      ring. 
// pd_id_reg          - Protection domain configuration register value for the ERX ring. 
// cq_id              - Completion queue ID for the ERX ring. 
// mtu                - Maximum transmission unit value for the ERX ring. 
// rss_interface      - RSS interface number (if an RSS ring). 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_ERX_Ring_Init (
   IN void* function_context,
   IN u32   ring_id,
   IN u64*  p_phys_addr,
   IN u32   pd_id_reg,
   IN u32   cq_id,
   IN u32   mtu,
   IN u8    rss_interface
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_ERX_MTU_Config
//
//   Programs an Ethernet receive ring into BladeEngine2. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// ring_id            - ERX ring ID. 
// mtu                - Maximum transmission unit value for the ERX ring. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_ERX_MTU_Config (
   IN void* function_context,
   IN u32   ring_id,
   IN u32   mtu
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_GPIO_Set_Mode
//
//   This routine is used to set the GPI/GPO mode for a particular GPIO bit 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// gpio_bit           - Selects one of 64 available GPIO bits. 
// gpio_mode          - Selects a particular GPI or GPO mode. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_GPIO_Set_Mode (
   IN void* function_context,
   IN u8    gpio_bit,
   IN u8    gpio_mode
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_GPO_Set_Data
//
//   This routine is used to set the data value for a particular GPO bit. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// gpo_bit            - Selects one of 64 available GPO bits. 
// gpo_value          - GPO bit's data value (0 or 1). 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_GPO_Set_Data (
   IN void*   function_context,
   IN u8      gpo_bit,
   IN boolean gpo_value
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_GPI_Get_Data
//
//   This routine is used to get the data value for a particular GPI bit. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// gpi_bit            - Selects one of 64 available GPO bits. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE boolean
BE2_Gen_GPI_Get_Data (
   IN void* function_context,
   IN u8    gpi_bit
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_MDIO_Read_Reg
//
//   This routine returns the value of a PHY register. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// phy_addr           - PHY address. 
// reg_addr           - Register address. 
// port               - Physical port (0 or 1). 
// mdio_mode          - MDIO mode (0 for 10G and 1 for 1G). 
// return return_type - Read Data. 
//---------------------------------------------------------------------------------------
STATIC INLINE u16
BE2_Gen_MDIO_Read_Reg (
   IN void*   function_context,
   IN u8      phy_addr,
   IN u16     reg_addr,
   IN boolean port,
   IN u8      mdio_mode
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_MDIO_Write_Reg
//
//   This routine writes a PHY register. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// phy_addr           - PHY address. 
// reg_addr           - Register address. 
// port               - Physical port (0 or 1). 
// reg_data           - Data to write. 
// mdio_mode          - MDIO mode (0 for 10G and 1 for 1G). 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_MDIO_Write_Reg (
   IN void*   function_context,
   IN u8      phy_addr,
   IN u16     reg_addr,
   IN boolean port,
   IN u16     reg_data,
   IN u8      mdio_mode
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Phys_Port_Local_Fault
//
//   This routine is used to Enable/Disable a forced Fault. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// phys_port          - BE Port. 
// mode               - 1-Enable 0- Disable. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Phys_Port_Local_Fault (
   IN void* function_context,
   IN u8    phys_port,
   IN u8    mode
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Chip_Rev
//
//   Returns chip revision number. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - Chip revision number (0 | 1). 
//---------------------------------------------------------------------------------------
STATIC INLINE u32
BE2_Gen_Chip_Rev (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Is_ASIC
//
//   Determines if the adapter is an FPGA or ASIC. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// return return_type - Returns TRUE if an asic, FALSE otherwise.
//---------------------------------------------------------------------------------------
STATIC INLINE boolean
BE2_Gen_Is_ASIC (
   IN void* function_context
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Turn_Online
//
//   Updates either the online0 or online1 register to turn modules online. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// online1            - TRUE if the online1 PCICFG register should be written. FALSE if
//                      the online0 PCICFG register should be written. 
// value              - The 32-bit value to OR into the requested online register. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Turn_Online (
   IN void*   function_context,
   IN boolean online1,
   IN u32     value
);

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_Access_Context_Memory
//
//   Accesses chip context memory. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// byte_address       - Context memory byte address. 
// p_data             - Pointer to source or destination data. 
// byte_count         - Number of bytes to read or write. 
// write_flag         - TRUE for write access, FALSE for read access. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_Access_Context_Memory (
   IN void*   function_context,
   IN u32     byte_address,
   IN OUT u8* p_data,
   IN u32     byte_count,
   IN boolean write_flag
);


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __be2_gen_api_bmap_h__

