/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
//
#ifndef __be2_gen_constructor_h__
#define __be2_gen_constructor_h__

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_CQ_Context_Construct
//
//   Initialize CQ context structure with common default values. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_ctx              - Pointer to context structure. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_CQ_Context_Construct (
   IN void*       function_context,
   IN CQ_CONTEXT* p_ctx )
{
    u32 i;

    // Zero out the structure
    for (i = 0; i < sizeof(CQ_CONTEXT)/4; i++)
    {
        p_ctx->dw[i] = 0;
    }

    // FIXME TODO @@@ Fill in context structure with common defaults
    return;
}

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_EQ_Context_Construct
//
//   Initialize EQ context structure with common default values. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_ctx              - Pointer to context structure. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_EQ_Context_Construct (
   IN void*       function_context,
   IN EQ_CONTEXT* p_ctx )
{
    u32 i;

    // Zero out the structure
    for (i = 0; i < sizeof(EQ_CONTEXT)/4; i++)
    {
        p_ctx->dw[i] = 0;
    }

    // FIXME TODO @@@ Fill in context structure with common defaults
    return;
}

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_TCP_Context_Construct
//
//   Initialize TCP context structure with common default values. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_ctx              - Pointer to context structure. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_TCP_Context_Construct (
   IN void*        function_context,
   IN TCP_CONTEXT* p_ctx )
{
    u32 i;

    // Zero out the structure
    for (i = 0; i < sizeof(TCP_CONTEXT)/4; i++)
    {
        p_ctx->dw[i] = 0;
    }

    // FIXME TODO @@@ Fill in context structure with common defaults
    return;
}

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_ETX_Context_Construct
//
//   Initialize ETX context structure with common default values. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_ctx              - Pointer to context structure. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_ETX_Context_Construct (
   IN void*        function_context,
   IN ETX_CONTEXT* p_ctx )
{
    u32 i;

    // Zero out the structure
    for (i = 0; i < sizeof(ETX_CONTEXT)/4; i++)
    {
        p_ctx->dw[i] = 0;
    }

    // FIXME TODO @@@ Fill in context structure with common defaults
    return;
}

//---------------------------------------------------------------------------------------
// Function: BE2_Gen_TOE_Context_Construct
//
//   Initialize TOE context structure with common default values. 
//
// function_context   - Pointer passed in to client defined GEN macros. Not actively used
//                      by GEN source.
// p_ctx              - Pointer to context structure. 
// return return_type - 
//---------------------------------------------------------------------------------------
STATIC INLINE void
BE2_Gen_TOE_Context_Construct (
   IN void*        function_context,
   IN TOE_CONTEXT* p_ctx )
{
    u32 i;

    // Zero out the structure
    for (i = 0; i < sizeof(TOE_CONTEXT)/4; i++)
    {
        p_ctx->dw[i] = 0;
    }

    // FIXME TODO @@@ Fill in context structure with common defaults
    return;
}

#endif  // __be2_gen_constructor_h__

