/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __be3nic_v1_bmap_h__
#define __be3nic_v1_bmap_h__

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif


typedef struct _PHYS_ADDR_V1 {
   union {
      struct { 
         u32 lo;                                  // DWORD 0
         u32 hi;                                  // DWORD 1
      } SG_PACK ; // unnamed struct
      u32 dw[2]; // dword union
   }; // unnamed union
} SG_PACK PHYS_ADDR_V1, *PPHYS_ADDR_V1;

SG_C_ASSERT(__sizeof__PHYS_ADDR, sizeof (PHYS_ADDR_V1) == 8);


// --- IOCTL_SUBSYSTEMS ---
#define IOCTL_SUBSYSTEM_RSVD_V1         (0)       
#define IOCTL_SUBSYSTEM_COMMON_V1       (1)       
#define IOCTL_SUBSYSTEM_COMMON_ISCSI_V1 (2)       
#define IOCTL_SUBSYSTEM_ETH_V1          (3)       
#define IOCTL_SUBSYSTEM_TOE_V1          (4)       
#define IOCTL_SUBSYSTEM_PXE_UNDI_V1     (5)       
#define IOCTL_SUBSYSTEM_ISCSI_INI_V1    (6)       
#define IOCTL_SUBSYSTEM_ISCSI_TGT_V1    (7)       
#define IOCTL_SUBSYSTEM_MILI_PTL_V1     (8)       
#define IOCTL_SUBSYSTEM_MILI_TMD_V1     (9)       
#define IOCTL_SUBSYSTEM_RDMA_V1         (10)      
#define IOCTL_SUBSYSTEM_LOWLEVEL_V1     (11)      
#define IOCTL_SUBSYSTEM_COMMON_FCOE_V1  (12)      
#define IOCTL_SUBSYSTEM_LRO_V1          (13)      
#define IOCTL_SUBSYSTEM_DAL_V1          (14)      
#define IOCTL_SUBSYSTEM_LLDP_V1         (15)      
#define IOCTL_SUBSYSTEM_DCBX_V1         (16)      
#define IOCTL_SUBSYSTEM_DMTF_V1         (17)      
#define IOCTL_SUBSYSTEM_DIAG_V1         (18)      
#define IOCTL_SUBSYSTEM_VENDOR_V1       (19)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* ioctl_subsystems_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case IOCTL_SUBSYSTEM_RSVD_V1:
            return "IOCTL_SUBSYSTEM_RSVD_V1";
         case IOCTL_SUBSYSTEM_COMMON_V1:
            return "IOCTL_SUBSYSTEM_COMMON_V1";
         case IOCTL_SUBSYSTEM_COMMON_ISCSI_V1:
            return "IOCTL_SUBSYSTEM_COMMON_ISCSI_V1";
         case IOCTL_SUBSYSTEM_ETH_V1:
            return "IOCTL_SUBSYSTEM_ETH_V1";
         case IOCTL_SUBSYSTEM_TOE_V1:
            return "IOCTL_SUBSYSTEM_TOE_V1";
         case IOCTL_SUBSYSTEM_PXE_UNDI_V1:
            return "IOCTL_SUBSYSTEM_PXE_UNDI_V1";
         case IOCTL_SUBSYSTEM_ISCSI_INI_V1:
            return "IOCTL_SUBSYSTEM_ISCSI_INI_V1";
         case IOCTL_SUBSYSTEM_ISCSI_TGT_V1:
            return "IOCTL_SUBSYSTEM_ISCSI_TGT_V1";
         case IOCTL_SUBSYSTEM_MILI_PTL_V1:
            return "IOCTL_SUBSYSTEM_MILI_PTL_V1";
         case IOCTL_SUBSYSTEM_MILI_TMD_V1:
            return "IOCTL_SUBSYSTEM_MILI_TMD_V1";
         case IOCTL_SUBSYSTEM_RDMA_V1:
            return "IOCTL_SUBSYSTEM_RDMA_V1";
         case IOCTL_SUBSYSTEM_LOWLEVEL_V1:
            return "IOCTL_SUBSYSTEM_LOWLEVEL_V1";
         case IOCTL_SUBSYSTEM_COMMON_FCOE_V1:
            return "IOCTL_SUBSYSTEM_COMMON_FCOE_V1";
         case IOCTL_SUBSYSTEM_LRO_V1:
            return "IOCTL_SUBSYSTEM_LRO_V1";
         case IOCTL_SUBSYSTEM_DAL_V1:
            return "IOCTL_SUBSYSTEM_DAL_V1";
         case IOCTL_SUBSYSTEM_LLDP_V1:
            return "IOCTL_SUBSYSTEM_LLDP_V1";
         case IOCTL_SUBSYSTEM_DCBX_V1:
            return "IOCTL_SUBSYSTEM_DCBX_V1";
         case IOCTL_SUBSYSTEM_DMTF_V1:
            return "IOCTL_SUBSYSTEM_DMTF_V1";
         case IOCTL_SUBSYSTEM_DIAG_V1:
            return "IOCTL_SUBSYSTEM_DIAG_V1";
         case IOCTL_SUBSYSTEM_VENDOR_V1:
            return "IOCTL_SUBSYSTEM_VENDOR_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_SUBSYSTEM_OPCODES ---
#define OPCODE_COMMON_NTWK_MAC_QUERY_V1 (1)       
#define SUBSYSTEM_COMMON_NTWK_MAC_QUERY_V1 (1)    
#define SUBSYSTEM_COMMON_NTWK_MAC_SET_V1 (1)      
#define SUBSYSTEM_COMMON_NTWK_MULTICAST_SET_V1 (1) 
#define SUBSYSTEM_COMMON_NTWK_VLAN_CONFIG_V1 (1)  
#define SUBSYSTEM_COMMON_NTWK_LINK_STATUS_QUERY_V1 (1) 
#define SUBSYSTEM_COMMON_READ_FLASHROM_V1 (1)     
#define SUBSYSTEM_COMMON_WRITE_FLASHROM_V1 (1)    
#define SUBSYSTEM_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_V1 (1) 
#define SUBSYSTEM_COMMON_ADD_PAGE_TABLES_V1 (1)   
#define SUBSYSTEM_COMMON_REMOVE_PAGE_TABLES_V1 (1) 
#define SUBSYSTEM_COMMON_CQ_CREATE_V1   (1)       
#define SUBSYSTEM_COMMON_EQ_CREATE_V1   (1)       
#define SUBSYSTEM_COMMON_MCC_CREATE_V1  (1)       
#define SUBSYSTEM_COMMON_JELL_CONFIG_V1 (1)       
#define SUBSYSTEM_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_V1 (1) 
#define SUBSYSTEM_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_V1 (1) 
#define SUBSYSTEM_COMMON_POST_ZERO_BUFFER_V1 (1)  
#define SUBSYSTEM_COMMON_GET_QOS_V1     (1)       
#define SUBSYSTEM_COMMON_SET_QOS_V1     (1)       
#define SUBSYSTEM_COMMON_TCP_GET_STATISTICS_V1 (1) 
#define SUBSYSTEM_COMMON_SEEPROM_READ_V1 (1)      
#define SUBSYSTEM_COMMON_TCP_STATE_QUERY_V1 (1)   
#define SUBSYSTEM_COMMON_GET_CNTL_ATTRIBUTES_V1 (1) 
#define SUBSYSTEM_COMMON_NOP_V1         (1)       
#define SUBSYSTEM_COMMON_NTWK_RX_FILTER_V1 (1)    
#define SUBSYSTEM_COMMON_GET_FW_VERSION_V1 (1)    
#define SUBSYSTEM_COMMON_SET_FLOW_CONTROL_V1 (1)  
#define SUBSYSTEM_COMMON_GET_FLOW_CONTROL_V1 (1)  
#define SUBSYSTEM_COMMON_SET_TCP_PARAMETERS_V1 (1) 
#define SUBSYSTEM_COMMON_SET_FRAME_SIZE_V1 (1)    
#define SUBSYSTEM_COMMON_GET_FAT_V1     (1)       
#define SUBSYSTEM_COMMON_MODIFY_EQ_DELAY_V1 (1)   
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_DOMAINS_V1 (1) 
#define SUBSYSTEM_COMMON_GET_DOMAIN_CONFIG_V1 (1) 
#define SUBSYSTEM_COMMON_GET_PORT_EQUALIZATION_V1 (1) 
#define SUBSYSTEM_COMMON_SET_PORT_EQUALIZATION_V1 (1) 
#define SUBSYSTEM_COMMON_RED_CONFIG_V1  (1)       
#define SUBSYSTEM_COMMON_NTWK_INTERFACE_CREATE_V1 (1) 
#define SUBSYSTEM_COMMON_NTWK_INTERFACE_DESTROY_V1 (1) 
#define SUBSYSTEM_COMMON_CEV_MODIFY_MSI_MESSAGES_V1 (1) 
#define SUBSYSTEM_COMMON_MCC_DESTROY_V1 (1)       
#define SUBSYSTEM_COMMON_CQ_DESTROY_V1  (1)       
#define SUBSYSTEM_COMMON_EQ_DESTROY_V1  (1)       
#define SUBSYSTEM_COMMON_TCP_UPLOAD_V1  (1)       
#define SUBSYSTEM_COMMON_NTWK_SET_LINK_SPEED_V1 (1) 
#define SUBSYSTEM_COMMON_QUERY_FIRMWARE_CONFIG_V1 (1) 
#define SUBSYSTEM_COMMON_NTWK_PMAC_ADD_V1 (1)     
#define SUBSYSTEM_COMMON_NTWK_PMAC_DEL_V1 (1)     
#define SUBSYSTEM_COMMON_FUNCTION_RESET_V1 (1)    
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_PORT_V1 (1) 
#define SUBSYSTEM_COMMON_GET_PORT_CAPABILITY_V1 (1) 
#define SUBSYSTEM_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_V1 (1) 
#define SUBSYSTEM_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_V1 (1) 
#define SUBSYSTEM_COMMON_GET_BOOT_CONFIG_V1 (1)   
#define SUBSYSTEM_COMMON_SET_BOOT_CONFIG_V1 (1)   
#define SUBSYSTEM_COMMON_MANAGE_FAT_V1  (1)       
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_BEACON_V1 (1) 
#define SUBSYSTEM_COMMON_GET_BEACON_STATE_V1 (1)  
#define SUBSYSTEM_COMMON_GET_PORT_STATUS_V1 (1)   
#define SUBSYSTEM_COMMON_READ_PCI_CONFIG_SPACE_V1 (1) 
#define SUBSYSTEM_COMMON_READ_TRANSRECEIVER_DATA_V1 (1) 
#define SUBSYSTEM_COMMON_GET_OEM_ATTRIBUTES_V1 (1) 
#define SUBSYSTEM_COMMON_GET_PORT_NAME_V1 (1)     
#define SUBSYSTEM_COMMON_GET_CONFIG_SIGNATURE_V1 (1) 
#define SUBSYSTEM_COMMON_SET_CONFIG_SIGNATURE_V1 (1) 
#define SUBSYSTEM_COMMON_FUNCTION_LINK_CONFIG_V1 (1) 
#define SUBSYSTEM_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1 (1) 
#define SUBSYSTEM_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1 (1) 
#define SUBSYSTEM_COMMON_GET_PCI_FUNCTION_MAPPING_V1 (1) 
#define SUBSYSTEM_COMMON_QUERY_PERSONALITY_CHANGE_V1 (1) 
#define SUBSYSTEM_COMMON_QUERY_CHIP_SERIAL_NUMBER_V1 (1) 
#define SUBSYSTEM_COMMON_GET_NCSI_CONFIGURATION_V1 (1) 
#define SUBSYSTEM_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_V1 (1) 
#define SUBSYSTEM_COMMON_START_MANAGEMENT_SERVICE_V1 (1) 
#define SUBSYSTEM_COMMON_MCC_CREATE_EXT_V1 (1)    
#define SUBSYSTEM_COMMON_GET_VPD_DATA_V1 (1)      
#define SUBSYSTEM_COMMON_SET_VPD_DATA_V1 (1)      
#define SUBSYSTEM_COMMON_SET_FUNCTION_PRIVILEGES_V1 (1) 
#define SUBSYSTEM_COMMON_SET_VF_PORT_TYPE_V1 (1)  
#define SUBSYSTEM_COMMON_GET_PHY_DETAILS_V1 (1)   
#define SUBSYSTEM_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V1 (1) 
#define SUBSYSTEM_COMMON_GET_ADAPTER_ID_V1 (1)    
#define SUBSYSTEM_COMMON_GET_UPGRADE_FEATURES_V1 (1) 
#define SUBSYSTEM_COMMON_GET_INSTALLED_FEATURES_V1 (1) 
#define SUBSYSTEM_COMMON_GET_AVAILABLE_PERSONALITIES_V1 (1) 
#define SUBSYSTEM_COMMON_GET_CONFIGURED_PERSONALITY_V1 (1) 
#define SUBSYSTEM_COMMON_SEND_ACTIVATION_V1 (1)   
#define SUBSYSTEM_COMMON_RESET_LICENSES_V1 (1)    
#define SUBSYSTEM_COMMON_GET_FUNCTION_NAME_INFO_V1 (1) 
#define SUBSYSTEM_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_V1 (1) 
#define SUBSYSTEM_COMMON_GET_CAPABILITY_V1 (1)    
#define SUBSYSTEM_COMMON_SET_SWITCH_TYPE_V1 (1)   
#define SUBSYSTEM_COMMON_GET_EXT_FAT_CAPABILITES_V1 (1) 
#define SUBSYSTEM_COMMON_SET_EXT_FAT_CAPABILITES_V1 (1) 
#define SUBSYSTEM_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_V1 (1) 
#define SUBSYSTEM_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_V1 (1) 
#define SUBSYSTEM_COMMON_DMA_HOST_BUFFERS_V1 (1)  
#define SUBSYSTEM_COMMON_EXT_FAT_READ_STRING_TABLE_V1 (1) 
#define SUBSYSTEM_COMMON_POPULATE_SENSOR_CFG_INFO_V1 (1) 
#define SUBSYSTEM_COMMON_SET_TX_THROTTLE_V1 (1)   
#define SUBSYSTEM_COMMON_GET_TX_THROTTLE_V1 (1)   
#define SUBSYSTEM_COMMON_GET_FUNCTION_PRIVILEGES_V1 (1) 
#define SUBSYSTEM_COMMON_GET_HSW_CONFIG_V1 (1)    
#define SUBSYSTEM_COMMON_SET_HSW_CONFIG_V1 (1)    
#define OPCODE_COMMON_NTWK_MAC_SET_V1   (2)       
#define OPCODE_COMMON_NTWK_MULTICAST_SET_V1 (3)   
#define OPCODE_COMMON_NTWK_VLAN_CONFIG_V1 (4)     
#define OPCODE_COMMON_NTWK_LINK_STATUS_QUERY_V1 (5) 
#define OPCODE_COMMON_READ_FLASHROM_V1  (6)       
#define OPCODE_COMMON_WRITE_FLASHROM_V1 (7)       
#define OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_V1 (8) 
#define OPCODE_COMMON_ADD_PAGE_TABLES_V1 (9)      
#define OPCODE_COMMON_REMOVE_PAGE_TABLES_V1 (10)  
#define OPCODE_COMMON_CQ_CREATE_V1      (12)      
#define OPCODE_COMMON_EQ_CREATE_V1      (13)      
#define OPCODE_COMMON_MCC_CREATE_V1     (21)      
#define OPCODE_COMMON_JELL_CONFIG_V1    (22)      
#define OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_V1 (24) 
#define OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_V1 (25) 
#define OPCODE_COMMON_POST_ZERO_BUFFER_V1 (26)    
#define OPCODE_COMMON_GET_QOS_V1        (27)      
#define OPCODE_COMMON_SET_QOS_V1        (28)      
#define OPCODE_COMMON_TCP_GET_STATISTICS_V1 (29)  
#define OPCODE_COMMON_SEEPROM_READ_V1   (30)      
#define OPCODE_COMMON_TCP_STATE_QUERY_V1 (31)     
#define OPCODE_COMMON_GET_CNTL_ATTRIBUTES_V1 (32) 
#define OPCODE_COMMON_NOP_V1            (33)      
#define OPCODE_COMMON_NTWK_RX_FILTER_V1 (34)      
#define OPCODE_COMMON_GET_FW_VERSION_V1 (35)      
#define OPCODE_COMMON_SET_FLOW_CONTROL_V1 (36)    
#define OPCODE_COMMON_GET_FLOW_CONTROL_V1 (37)    
#define OPCODE_COMMON_SET_TCP_PARAMETERS_V1 (38)  
#define OPCODE_COMMON_SET_FRAME_SIZE_V1 (39)      
#define OPCODE_COMMON_GET_FAT_V1        (40)      
#define OPCODE_COMMON_MODIFY_EQ_DELAY_V1 (41)     
#define OPCODE_COMMON_ENABLE_DISABLE_DOMAINS_V1 (43) 
#define OPCODE_COMMON_GET_DOMAIN_CONFIG_V1 (44)   
#define OPCODE_COMMON_GET_PORT_EQUALIZATION_V1 (47) 
#define OPCODE_COMMON_SET_PORT_EQUALIZATION_V1 (48) 
#define OPCODE_COMMON_RED_CONFIG_V1     (49)      
#define OPCODE_COMMON_NTWK_INTERFACE_CREATE_V1 (50) 
#define OPCODE_COMMON_NTWK_INTERFACE_DESTROY_V1 (51) 
#define OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES_V1 (52) 
#define OPCODE_COMMON_MCC_DESTROY_V1    (53)      
#define OPCODE_COMMON_CQ_DESTROY_V1     (54)      
#define OPCODE_COMMON_EQ_DESTROY_V1     (55)      
#define OPCODE_COMMON_TCP_UPLOAD_V1     (56)      
#define OPCODE_COMMON_NTWK_SET_LINK_SPEED_V1 (57) 
#define OPCODE_COMMON_QUERY_FIRMWARE_CONFIG_V1 (58) 
#define OPCODE_COMMON_NTWK_PMAC_ADD_V1  (59)      
#define OPCODE_COMMON_NTWK_PMAC_DEL_V1  (60)      
#define OPCODE_COMMON_FUNCTION_RESET_V1 (61)      
#define OPCODE_COMMON_ENABLE_DISABLE_PORT_V1 (62) 
#define OPCODE_COMMON_GET_PORT_CAPABILITY_V1 (63) 
#define OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_V1 (64) 
#define OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_V1 (65) 
#define OPCODE_COMMON_GET_BOOT_CONFIG_V1 (66)     
#define OPCODE_COMMON_SET_BOOT_CONFIG_V1 (67)     
#define OPCODE_COMMON_MANAGE_FAT_V1     (68)      
#define OPCODE_COMMON_ENABLE_DISABLE_BEACON_V1 (69) 
#define OPCODE_COMMON_GET_BEACON_STATE_V1 (70)    
#define OPCODE_COMMON_GET_PORT_STATUS_V1 (71)     
#define OPCODE_COMMON_READ_PCI_CONFIG_SPACE_V1 (72) 
#define OPCODE_COMMON_READ_TRANSRECEIVER_DATA_V1 (73) 
#define OPCODE_COMMON_GET_OEM_ATTRIBUTES_V1 (76)  
#define OPCODE_COMMON_GET_PORT_NAME_V1  (77)      
#define OPCODE_COMMON_GET_CONFIG_SIGNATURE_V1 (78) 
#define OPCODE_COMMON_SET_CONFIG_SIGNATURE_V1 (79) 
#define OPCODE_COMMON_FUNCTION_LINK_CONFIG_V1 (80) 
#define OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1 (81) 
#define OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1 (82) 
#define OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING_V1 (83) 
#define OPCODE_COMMON_QUERY_PERSONALITY_CHANGE_V1 (84) 
#define OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER_V1 (85) 
#define OPCODE_COMMON_GET_NCSI_CONFIGURATION_V1 (86) 
#define OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_V1 (87) 
#define OPCODE_COMMON_START_MANAGEMENT_SERVICE_V1 (88) 
#define OPCODE_COMMON_MCC_CREATE_EXT_V1 (90)      
#define OPCODE_COMMON_GET_VPD_DATA_V1   (91)      
#define OPCODE_COMMON_SET_VPD_DATA_V1   (92)      
#define OPCODE_COMMON_SET_FUNCTION_PRIVILEGES_V1 (100) 
#define OPCODE_COMMON_SET_VF_PORT_TYPE_V1 (101)   
#define OPCODE_COMMON_GET_PHY_DETAILS_V1 (102)    
#define OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V1 (103) 
#define OPCODE_COMMON_GET_ADAPTER_ID_V1 (110)     
#define OPCODE_COMMON_GET_UPGRADE_FEATURES_V1 (111) 
#define OPCODE_COMMON_GET_INSTALLED_FEATURES_V1 (112) 
#define OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES_V1 (113) 
#define OPCODE_COMMON_GET_CONFIGURED_PERSONALITY_V1 (114) 
#define OPCODE_COMMON_SEND_ACTIVATION_V1 (115)    
#define OPCODE_COMMON_RESET_LICENSES_V1 (116)     
#define OPCODE_COMMON_GET_FUNCTION_NAME_INFO_V1 (120) 
#define OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_V1 (121) 
#define OPCODE_COMMON_GET_CAPABILITY_V1 (123)     
#define OPCODE_COMMON_SET_SWITCH_TYPE_V1 (124)    
#define OPCODE_COMMON_GET_EXT_FAT_CAPABILITES_V1 (125) 
#define OPCODE_COMMON_SET_EXT_FAT_CAPABILITES_V1 (126) 
#define OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_V1 (127) 
#define OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_V1 (128) 
#define OPCODE_COMMON_DMA_HOST_BUFFERS_V1 (129)   
#define OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE_V1 (130) 
#define OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO_V1 (131) 
#define OPCODE_COMMON_SET_TX_THROTTLE_V1 (132)    
#define OPCODE_COMMON_GET_TX_THROTTLE_V1 (133)    
#define OPCODE_COMMON_GET_HSW_CONFIG_V1 (152)     
#define OPCODE_COMMON_SET_HSW_CONFIG_V1 (153)     
#define OPCODE_COMMON_GET_FUNCTION_PRIVILEGES_V1 (170) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_NTWK_MAC_QUERY_V1:
            return "OPCODE_COMMON_NTWK_MAC_QUERY_V1";
         case OPCODE_COMMON_NTWK_MAC_SET_V1:
            return "OPCODE_COMMON_NTWK_MAC_SET_V1";
         case OPCODE_COMMON_NTWK_MULTICAST_SET_V1:
            return "OPCODE_COMMON_NTWK_MULTICAST_SET_V1";
         case OPCODE_COMMON_NTWK_VLAN_CONFIG_V1:
            return "OPCODE_COMMON_NTWK_VLAN_CONFIG_V1";
         case OPCODE_COMMON_NTWK_LINK_STATUS_QUERY_V1:
            return "OPCODE_COMMON_NTWK_LINK_STATUS_QUERY_V1";
         case OPCODE_COMMON_READ_FLASHROM_V1:
            return "OPCODE_COMMON_READ_FLASHROM_V1";
         case OPCODE_COMMON_WRITE_FLASHROM_V1:
            return "OPCODE_COMMON_WRITE_FLASHROM_V1";
         case OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_V1:
            return "OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_V1";
         case OPCODE_COMMON_ADD_PAGE_TABLES_V1:
            return "OPCODE_COMMON_ADD_PAGE_TABLES_V1";
         case OPCODE_COMMON_REMOVE_PAGE_TABLES_V1:
            return "OPCODE_COMMON_REMOVE_PAGE_TABLES_V1";
         case OPCODE_COMMON_CQ_CREATE_V1:
            return "OPCODE_COMMON_CQ_CREATE_V1";
         case OPCODE_COMMON_EQ_CREATE_V1:
            return "OPCODE_COMMON_EQ_CREATE_V1";
         case OPCODE_COMMON_MCC_CREATE_V1:
            return "OPCODE_COMMON_MCC_CREATE_V1";
         case OPCODE_COMMON_JELL_CONFIG_V1:
            return "OPCODE_COMMON_JELL_CONFIG_V1";
         case OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_V1:
            return "OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_V1";
         case OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_V1:
            return "OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_V1";
         case OPCODE_COMMON_POST_ZERO_BUFFER_V1:
            return "OPCODE_COMMON_POST_ZERO_BUFFER_V1";
         case OPCODE_COMMON_GET_QOS_V1:
            return "OPCODE_COMMON_GET_QOS_V1";
         case OPCODE_COMMON_SET_QOS_V1:
            return "OPCODE_COMMON_SET_QOS_V1";
         case OPCODE_COMMON_TCP_GET_STATISTICS_V1:
            return "OPCODE_COMMON_TCP_GET_STATISTICS_V1";
         case OPCODE_COMMON_SEEPROM_READ_V1:
            return "OPCODE_COMMON_SEEPROM_READ_V1";
         case OPCODE_COMMON_TCP_STATE_QUERY_V1:
            return "OPCODE_COMMON_TCP_STATE_QUERY_V1";
         case OPCODE_COMMON_GET_CNTL_ATTRIBUTES_V1:
            return "OPCODE_COMMON_GET_CNTL_ATTRIBUTES_V1";
         case OPCODE_COMMON_NOP_V1:
            return "OPCODE_COMMON_NOP_V1";
         case OPCODE_COMMON_NTWK_RX_FILTER_V1:
            return "OPCODE_COMMON_NTWK_RX_FILTER_V1";
         case OPCODE_COMMON_GET_FW_VERSION_V1:
            return "OPCODE_COMMON_GET_FW_VERSION_V1";
         case OPCODE_COMMON_SET_FLOW_CONTROL_V1:
            return "OPCODE_COMMON_SET_FLOW_CONTROL_V1";
         case OPCODE_COMMON_GET_FLOW_CONTROL_V1:
            return "OPCODE_COMMON_GET_FLOW_CONTROL_V1";
         case OPCODE_COMMON_SET_TCP_PARAMETERS_V1:
            return "OPCODE_COMMON_SET_TCP_PARAMETERS_V1";
         case OPCODE_COMMON_SET_FRAME_SIZE_V1:
            return "OPCODE_COMMON_SET_FRAME_SIZE_V1";
         case OPCODE_COMMON_GET_FAT_V1:
            return "OPCODE_COMMON_GET_FAT_V1";
         case OPCODE_COMMON_MODIFY_EQ_DELAY_V1:
            return "OPCODE_COMMON_MODIFY_EQ_DELAY_V1";
         case OPCODE_COMMON_ENABLE_DISABLE_DOMAINS_V1:
            return "OPCODE_COMMON_ENABLE_DISABLE_DOMAINS_V1";
         case OPCODE_COMMON_GET_DOMAIN_CONFIG_V1:
            return "OPCODE_COMMON_GET_DOMAIN_CONFIG_V1";
         case OPCODE_COMMON_GET_PORT_EQUALIZATION_V1:
            return "OPCODE_COMMON_GET_PORT_EQUALIZATION_V1";
         case OPCODE_COMMON_SET_PORT_EQUALIZATION_V1:
            return "OPCODE_COMMON_SET_PORT_EQUALIZATION_V1";
         case OPCODE_COMMON_RED_CONFIG_V1:
            return "OPCODE_COMMON_RED_CONFIG_V1";
         case OPCODE_COMMON_NTWK_INTERFACE_CREATE_V1:
            return "OPCODE_COMMON_NTWK_INTERFACE_CREATE_V1";
         case OPCODE_COMMON_NTWK_INTERFACE_DESTROY_V1:
            return "OPCODE_COMMON_NTWK_INTERFACE_DESTROY_V1";
         case OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES_V1:
            return "OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES_V1";
         case OPCODE_COMMON_MCC_DESTROY_V1:
            return "OPCODE_COMMON_MCC_DESTROY_V1";
         case OPCODE_COMMON_CQ_DESTROY_V1:
            return "OPCODE_COMMON_CQ_DESTROY_V1";
         case OPCODE_COMMON_EQ_DESTROY_V1:
            return "OPCODE_COMMON_EQ_DESTROY_V1";
         case OPCODE_COMMON_TCP_UPLOAD_V1:
            return "OPCODE_COMMON_TCP_UPLOAD_V1";
         case OPCODE_COMMON_NTWK_SET_LINK_SPEED_V1:
            return "OPCODE_COMMON_NTWK_SET_LINK_SPEED_V1";
         case OPCODE_COMMON_QUERY_FIRMWARE_CONFIG_V1:
            return "OPCODE_COMMON_QUERY_FIRMWARE_CONFIG_V1";
         case OPCODE_COMMON_NTWK_PMAC_ADD_V1:
            return "OPCODE_COMMON_NTWK_PMAC_ADD_V1";
         case OPCODE_COMMON_NTWK_PMAC_DEL_V1:
            return "OPCODE_COMMON_NTWK_PMAC_DEL_V1";
         case OPCODE_COMMON_FUNCTION_RESET_V1:
            return "OPCODE_COMMON_FUNCTION_RESET_V1";
         case OPCODE_COMMON_ENABLE_DISABLE_PORT_V1:
            return "OPCODE_COMMON_ENABLE_DISABLE_PORT_V1";
         case OPCODE_COMMON_GET_PORT_CAPABILITY_V1:
            return "OPCODE_COMMON_GET_PORT_CAPABILITY_V1";
         case OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_V1:
            return "OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_V1";
         case OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_V1:
            return "OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_V1";
         case OPCODE_COMMON_GET_BOOT_CONFIG_V1:
            return "OPCODE_COMMON_GET_BOOT_CONFIG_V1";
         case OPCODE_COMMON_SET_BOOT_CONFIG_V1:
            return "OPCODE_COMMON_SET_BOOT_CONFIG_V1";
         case OPCODE_COMMON_MANAGE_FAT_V1:
            return "OPCODE_COMMON_MANAGE_FAT_V1";
         case OPCODE_COMMON_ENABLE_DISABLE_BEACON_V1:
            return "OPCODE_COMMON_ENABLE_DISABLE_BEACON_V1";
         case OPCODE_COMMON_GET_BEACON_STATE_V1:
            return "OPCODE_COMMON_GET_BEACON_STATE_V1";
         case OPCODE_COMMON_GET_PORT_STATUS_V1:
            return "OPCODE_COMMON_GET_PORT_STATUS_V1";
         case OPCODE_COMMON_READ_PCI_CONFIG_SPACE_V1:
            return "OPCODE_COMMON_READ_PCI_CONFIG_SPACE_V1";
         case OPCODE_COMMON_READ_TRANSRECEIVER_DATA_V1:
            return "OPCODE_COMMON_READ_TRANSRECEIVER_DATA_V1";
         case OPCODE_COMMON_GET_OEM_ATTRIBUTES_V1:
            return "OPCODE_COMMON_GET_OEM_ATTRIBUTES_V1";
         case OPCODE_COMMON_GET_PORT_NAME_V1:
            return "OPCODE_COMMON_GET_PORT_NAME_V1";
         case OPCODE_COMMON_GET_CONFIG_SIGNATURE_V1:
            return "OPCODE_COMMON_GET_CONFIG_SIGNATURE_V1";
         case OPCODE_COMMON_SET_CONFIG_SIGNATURE_V1:
            return "OPCODE_COMMON_SET_CONFIG_SIGNATURE_V1";
         case OPCODE_COMMON_FUNCTION_LINK_CONFIG_V1:
            return "OPCODE_COMMON_FUNCTION_LINK_CONFIG_V1";
         case OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1:
            return "OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1";
         case OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1:
            return "OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1";
         case OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING_V1:
            return "OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING_V1";
         case OPCODE_COMMON_QUERY_PERSONALITY_CHANGE_V1:
            return "OPCODE_COMMON_QUERY_PERSONALITY_CHANGE_V1";
         case OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER_V1:
            return "OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER_V1";
         case OPCODE_COMMON_GET_NCSI_CONFIGURATION_V1:
            return "OPCODE_COMMON_GET_NCSI_CONFIGURATION_V1";
         case OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_V1:
            return "OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_V1";
         case OPCODE_COMMON_START_MANAGEMENT_SERVICE_V1:
            return "OPCODE_COMMON_START_MANAGEMENT_SERVICE_V1";
         case OPCODE_COMMON_MCC_CREATE_EXT_V1:
            return "OPCODE_COMMON_MCC_CREATE_EXT_V1";
         case OPCODE_COMMON_GET_VPD_DATA_V1:
            return "OPCODE_COMMON_GET_VPD_DATA_V1";
         case OPCODE_COMMON_SET_VPD_DATA_V1:
            return "OPCODE_COMMON_SET_VPD_DATA_V1";
         case OPCODE_COMMON_SET_FUNCTION_PRIVILEGES_V1:
            return "OPCODE_COMMON_SET_FUNCTION_PRIVILEGES_V1";
         case OPCODE_COMMON_SET_VF_PORT_TYPE_V1:
            return "OPCODE_COMMON_SET_VF_PORT_TYPE_V1";
         case OPCODE_COMMON_GET_PHY_DETAILS_V1:
            return "OPCODE_COMMON_GET_PHY_DETAILS_V1";
         case OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V1:
            return "OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V1";
         case OPCODE_COMMON_GET_ADAPTER_ID_V1:
            return "OPCODE_COMMON_GET_ADAPTER_ID_V1";
         case OPCODE_COMMON_GET_UPGRADE_FEATURES_V1:
            return "OPCODE_COMMON_GET_UPGRADE_FEATURES_V1";
         case OPCODE_COMMON_GET_INSTALLED_FEATURES_V1:
            return "OPCODE_COMMON_GET_INSTALLED_FEATURES_V1";
         case OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES_V1:
            return "OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES_V1";
         case OPCODE_COMMON_GET_CONFIGURED_PERSONALITY_V1:
            return "OPCODE_COMMON_GET_CONFIGURED_PERSONALITY_V1";
         case OPCODE_COMMON_SEND_ACTIVATION_V1:
            return "OPCODE_COMMON_SEND_ACTIVATION_V1";
         case OPCODE_COMMON_RESET_LICENSES_V1:
            return "OPCODE_COMMON_RESET_LICENSES_V1";
         case OPCODE_COMMON_GET_FUNCTION_NAME_INFO_V1:
            return "OPCODE_COMMON_GET_FUNCTION_NAME_INFO_V1";
         case OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_V1:
            return "OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_V1";
         case OPCODE_COMMON_GET_CAPABILITY_V1:
            return "OPCODE_COMMON_GET_CAPABILITY_V1";
         case OPCODE_COMMON_SET_SWITCH_TYPE_V1:
            return "OPCODE_COMMON_SET_SWITCH_TYPE_V1";
         case OPCODE_COMMON_GET_EXT_FAT_CAPABILITES_V1:
            return "OPCODE_COMMON_GET_EXT_FAT_CAPABILITES_V1";
         case OPCODE_COMMON_SET_EXT_FAT_CAPABILITES_V1:
            return "OPCODE_COMMON_SET_EXT_FAT_CAPABILITES_V1";
         case OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_V1:
            return "OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_V1";
         case OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_V1:
            return "OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_V1";
         case OPCODE_COMMON_DMA_HOST_BUFFERS_V1:
            return "OPCODE_COMMON_DMA_HOST_BUFFERS_V1";
         case OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE_V1:
            return "OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE_V1";
         case OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO_V1:
            return "OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO_V1";
         case OPCODE_COMMON_SET_TX_THROTTLE_V1:
            return "OPCODE_COMMON_SET_TX_THROTTLE_V1";
         case OPCODE_COMMON_GET_TX_THROTTLE_V1:
            return "OPCODE_COMMON_GET_TX_THROTTLE_V1";
         case OPCODE_COMMON_GET_HSW_CONFIG_V1:
            return "OPCODE_COMMON_GET_HSW_CONFIG_V1";
         case OPCODE_COMMON_SET_HSW_CONFIG_V1:
            return "OPCODE_COMMON_SET_HSW_CONFIG_V1";
         case OPCODE_COMMON_GET_FUNCTION_PRIVILEGES_V1:
            return "OPCODE_COMMON_GET_FUNCTION_PRIVILEGES_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_ISCSI_SUBSYSTEM_OPCODES ---
#define OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_V1 (1) 
#define SUBSYSTEM_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_V1 (2) 
#define OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_PING_V1 (2)   
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ARP_TABLE_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_ARP_TABLE_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_IFACE_CREATE_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_IFACE_DELETE_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_VLAN_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_PING_STATE_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_PING_STATE_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_IF_INFO_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CLEANUP_V1 (2)     
#define SUBSYSTEM_COMMON_ISCSI_ADD_8BYTE_LUN_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_READ_EVENT_LOG_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_DEFQ_CREATE_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_DEFQ_DESTROY_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_WRBQ_CREATE_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_WRBQ_DESTROY_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_MTU_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_MTU_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_V1 (2) 
#define SUBSYSTEM_COMMON_ISCSI_TCP_DISCONNECT_V1 (2) 
#define OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_V1 (3) 
#define OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_V1 (4) 
#define OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_V1 (5) 
#define OPCODE_COMMON_ISCSI_NTWK_PING_V1 (6)      
#define OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_V1 (7) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE_V1 (8) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE_V1 (9) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_V1 (10) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_V1 (11) 
#define OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE_V1 (12) 
#define OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE_V1 (13) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_VLAN_V1 (14) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE_V1 (15) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE_V1 (16) 
#define OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_V1 (17) 
#define OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_V1 (18) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_V1 (19) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_V1 (20) 
#define OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_V1 (21) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_V1 (22) 
#define OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_V1 (23) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_V1 (24) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO_V1 (25) 
#define OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_V1 (26) 
#define OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_V1 (27) 
#define OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_V1 (28) 
#define OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_V1 (29) 
#define OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_V1 (30) 
#define OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_V1 (31) 
#define OPCODE_COMMON_ISCSI_CLEANUP_V1  (59)      
#define OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN_V1 (60) 
#define OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_V1 (61) 
#define OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_V1 (62) 
#define OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG_V1 (63) 
#define OPCODE_COMMON_ISCSI_DEFQ_CREATE_V1 (64)   
#define OPCODE_COMMON_ISCSI_DEFQ_DESTROY_V1 (65)  
#define OPCODE_COMMON_ISCSI_WRBQ_CREATE_V1 (66)   
#define OPCODE_COMMON_ISCSI_WRBQ_DESTROY_V1 (67)  
#define OPCODE_COMMON_ISCSI_NTWK_SET_MTU_V1 (68)  
#define OPCODE_COMMON_ISCSI_NTWK_GET_MTU_V1 (69)  
#define OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_V1 (70) 
#define OPCODE_COMMON_ISCSI_TCP_DISCONNECT_V1 (71) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_iscsi_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_V1:
            return "OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_V1";
         case OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1:
            return "OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES_V1";
         case OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_V1:
            return "OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_V1";
         case OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_V1:
            return "OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_V1";
         case OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_V1:
            return "OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_V1";
         case OPCODE_COMMON_ISCSI_NTWK_PING_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_PING_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE_V1";
         case OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_V1";
         case OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_V1";
         case OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE_V1";
         case OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE_V1";
         case OPCODE_COMMON_ISCSI_NTWK_SET_VLAN_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_VLAN_V1";
         case OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE_V1";
         case OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_V1";
         case OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST_V1";
         case OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_V1";
         case OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_V1";
         case OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_V1";
         case OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_V1:
            return "OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS_V1";
         case OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_V1:
            return "OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS_V1";
         case OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_V1:
            return "OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_V1";
         case OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_V1:
            return "OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_V1";
         case OPCODE_COMMON_ISCSI_CLEANUP_V1:
            return "OPCODE_COMMON_ISCSI_CLEANUP_V1";
         case OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN_V1:
            return "OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN_V1";
         case OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_V1:
            return "OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_V1";
         case OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_V1:
            return "OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_V1";
         case OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG_V1:
            return "OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG_V1";
         case OPCODE_COMMON_ISCSI_DEFQ_CREATE_V1:
            return "OPCODE_COMMON_ISCSI_DEFQ_CREATE_V1";
         case OPCODE_COMMON_ISCSI_DEFQ_DESTROY_V1:
            return "OPCODE_COMMON_ISCSI_DEFQ_DESTROY_V1";
         case OPCODE_COMMON_ISCSI_WRBQ_CREATE_V1:
            return "OPCODE_COMMON_ISCSI_WRBQ_CREATE_V1";
         case OPCODE_COMMON_ISCSI_WRBQ_DESTROY_V1:
            return "OPCODE_COMMON_ISCSI_WRBQ_DESTROY_V1";
         case OPCODE_COMMON_ISCSI_NTWK_SET_MTU_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_MTU_V1";
         case OPCODE_COMMON_ISCSI_NTWK_GET_MTU_V1:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_MTU_V1";
         case OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_V1:
            return "OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_V1";
         case OPCODE_COMMON_ISCSI_TCP_DISCONNECT_V1:
            return "OPCODE_COMMON_ISCSI_TCP_DISCONNECT_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ISCSI_INI_SUBSYSTEM_OPCODES ---
#define OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_V1 (1) 
#define OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_V1 (2) 
#define OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_V1 (4) 
#define OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT_V1 (5) 
#define SUBSYSTEM_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_COUNT_V1 (6) 
#define OPCODE_ISCSI_INI_CFG_GET_HBA_NAME_V1 (6)  
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_NAME_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_SET_HBA_NAME_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_SET_HBA_TIME_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_CHAP_SECRET_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_SET_CHAP_SECRET_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_STATUS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_SESSIONS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_SESSION_LIST_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_A_SESSION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_CONFIGURATION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_SET_CONFIGURATION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_CLOSE_CONNECTION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_LOGIN_TARGET_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_LOGOUT_TARGET_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_SEND_TARGETS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_A_SESSION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_A_CONN_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_OFFLOAD_SESSION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_OFFLOAD_CONN_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BOOT_TARGET_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BOOT_TARGET_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BOOT_LUN_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BOOT_LUN_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_READ_WRITE_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SCSI_PASS_THRU_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_V1 (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_PCIE_INFO_V1 (6) 
#define OPCODE_ISCSI_INI_CFG_SET_HBA_NAME_V1 (7)  
#define OPCODE_ISCSI_INI_CFG_SET_HBA_TIME_V1 (8)  
#define OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET_V1 (9) 
#define OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET_V1 (10) 
#define OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS_V1 (11) 
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS_V1 (12) 
#define OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST_V1 (13) 
#define OPCODE_ISCSI_INI_SESSION_GET_A_SESSION_V1 (14) 
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_V1 (15) 
#define OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_V1 (16) 
#define OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION_V1 (17) 
#define OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_V1 (18) 
#define OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_V1 (19) 
#define OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_V1 (20) 
#define OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_V1 (21) 
#define OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION_V1 (22) 
#define OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET_V1 (23) 
#define OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET_V1 (24) 
#define OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_V1 (25) 
#define OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_V1 (26) 
#define OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_V1 (27) 
#define OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_V1 (28) 
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_V1 (29) 
#define OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_V1 (30) 
#define OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_V1 (31) 
#define OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_V1 (32) 
#define OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS_V1 (33) 
#define OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_V1 (34) 
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION_V1 (35) 
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_V1 (36) 
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN_V1 (37) 
#define OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_V1 (38) 
#define OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_V1 (39) 
#define OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_V1 (40) 
#define OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION_V1 (41) 
#define OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_V1 (42) 
#define OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN_V1 (43) 
#define OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_V1 (44) 
#define OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_V1 (45) 
#define OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_V1 (46) 
#define OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_V1 (47) 
#define OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_V1 (48) 
#define OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_V1 (49) 
#define OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_V1 (50) 
#define OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_V1 (51) 
#define OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET_V1 (52) 
#define OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET_V1 (53) 
#define OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN_V1 (54) 
#define OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN_V1 (55) 
#define OPCODE_ISCSI_INI_BOOT_READ_WRITE_V1 (56)  
#define OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_V1 (57) 
#define OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_V1 (58) 
#define OPCODE_ISCSI_INI_SCSI_PASS_THRU_V1 (59)   
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_V1 (60) 
#define OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_V1 (61) 
#define OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO_V1 (62) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* iscsi_ini_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_V1:
            return "OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_V1";
         case OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_V1:
            return "OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_V1";
         case OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_V1:
            return "OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_V1";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT_V1:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT_V1";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_NAME_V1:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_NAME_V1";
         case OPCODE_ISCSI_INI_CFG_SET_HBA_NAME_V1:
            return "OPCODE_ISCSI_INI_CFG_SET_HBA_NAME_V1";
         case OPCODE_ISCSI_INI_CFG_SET_HBA_TIME_V1:
            return "OPCODE_ISCSI_INI_CFG_SET_HBA_TIME_V1";
         case OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET_V1:
            return "OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET_V1";
         case OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET_V1:
            return "OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET_V1";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS_V1:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS_V1";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS_V1:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS_V1";
         case OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST_V1:
            return "OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST_V1";
         case OPCODE_ISCSI_INI_SESSION_GET_A_SESSION_V1:
            return "OPCODE_ISCSI_INI_SESSION_GET_A_SESSION_V1";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_V1:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_V1";
         case OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_V1:
            return "OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_V1";
         case OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION_V1:
            return "OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION_V1";
         case OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_V1:
            return "OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_V1";
         case OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_V1:
            return "OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_V1";
         case OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_V1:
            return "OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_V1";
         case OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_V1:
            return "OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_V1";
         case OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION_V1:
            return "OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION_V1";
         case OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET_V1:
            return "OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET_V1";
         case OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET_V1:
            return "OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET_V1";
         case OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_V1:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_V1";
         case OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_V1:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_V1";
         case OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_V1:
            return "OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_V1";
         case OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_V1:
            return "OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_V1";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_V1:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_V1";
         case OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_V1:
            return "OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_V1";
         case OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_V1:
            return "OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_V1";
         case OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_V1:
            return "OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_V1";
         case OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS_V1:
            return "OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS_V1";
         case OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_V1:
            return "OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_V1";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION_V1:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION_V1";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_V1:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_V1";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN_V1:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN_V1";
         case OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_V1:
            return "OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_V1";
         case OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_V1:
            return "OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_V1";
         case OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_V1:
            return "OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_V1";
         case OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION_V1:
            return "OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION_V1";
         case OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_V1:
            return "OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_V1";
         case OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN_V1:
            return "OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN_V1";
         case OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_V1:
            return "OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_V1";
         case OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_V1:
            return "OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_V1";
         case OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_V1:
            return "OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_V1";
         case OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_V1:
            return "OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_V1";
         case OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_V1:
            return "OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_V1";
         case OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_V1:
            return "OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_V1";
         case OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_V1:
            return "OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_V1";
         case OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_V1:
            return "OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_V1";
         case OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET_V1:
            return "OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET_V1";
         case OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET_V1:
            return "OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET_V1";
         case OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN_V1:
            return "OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN_V1";
         case OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN_V1:
            return "OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN_V1";
         case OPCODE_ISCSI_INI_BOOT_READ_WRITE_V1:
            return "OPCODE_ISCSI_INI_BOOT_READ_WRITE_V1";
         case OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_V1:
            return "OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_V1";
         case OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_V1:
            return "OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_V1";
         case OPCODE_ISCSI_INI_SCSI_PASS_THRU_V1:
            return "OPCODE_ISCSI_INI_SCSI_PASS_THRU_V1";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_V1:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_V1";
         case OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_V1:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_V1";
         case OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO_V1:
            return "OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ISCSI_TGT_SUBSYSTEM_OPCODES ---
#define OPCODE_ISCSI_TGT_START_LISTEN_SERVER_V1 (1) 
#define OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER_V1 (2) 
#define OPCODE_ISCSI_TGT_GET_CONNECTION_INFO_V1 (3) 
#define OPCODE_ISCSI_TGT_CONNECTION_REJECT_V1 (4) 
#define OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION_V1 (5) 
#define OPCODE_ISCSI_TGT_ISNS_SEND_PACKET_V1 (6)  
#define SUBSYSTEM_ISCSI_TGT_START_LISTEN_SERVER_V1 (7) 
#define SUBSYSTEM_ISCSI_TGT_STOP_LISTEN_SERVER_V1 (7) 
#define SUBSYSTEM_ISCSI_TGT_GET_CONNECTION_INFO_V1 (7) 
#define SUBSYSTEM_ISCSI_TGT_CONNECTION_REJECT_V1 (7) 
#define SUBSYSTEM_ISCSI_TGT_OFFLOAD_CONNECTION_V1 (7) 
#define SUBSYSTEM_ISCSI_TGT_ISNS_SEND_PACKET_V1 (7) 
#define OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION_V1 (7) 
#define SUBSYSTEM_ISCSI_TGT_INVALIDATE_CONNECTION_V1 (7) 
#define SUBSYSTEM_ISCSI_TGT_ADD_IP_ADDR_V1 (7)    
#define SUBSYSTEM_ISCSI_TGT_DELETE_IP_ADDR_V1 (7) 
#define SUBSYSTEM_ISCSI_TGT_LIST_IP_ADDR_V1 (7)   
#define SUBSYSTEM_ISCSI_TGT_START_ESI_LISTEN_V1 (7) 
#define SUBSYSTEM_ISCSI_TGT_STOP_ESI_LISTEN_V1 (7) 
#define SUBSYSTEM_ISCSI_TGT_SLP_REGISTER_V1 (7)   
#define SUBSYSTEM_ISCSI_TGT_SLP_DEREGISTER_V1 (7) 
#define OPCODE_ISCSI_TGT_ADD_IP_ADDR_V1 (8)       
#define OPCODE_ISCSI_TGT_DELETE_IP_ADDR_V1 (9)    
#define OPCODE_ISCSI_TGT_LIST_IP_ADDR_V1 (10)     
#define OPCODE_ISCSI_TGT_START_ESI_LISTEN_V1 (11) 
#define OPCODE_ISCSI_TGT_STOP_ESI_LISTEN_V1 (12)  
#define OPCODE_ISCSI_TGT_SLP_REGISTER_V1 (13)     
#define OPCODE_ISCSI_TGT_SLP_DEREGISTER_V1 (14)   

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* iscsi_tgt_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ISCSI_TGT_START_LISTEN_SERVER_V1:
            return "OPCODE_ISCSI_TGT_START_LISTEN_SERVER_V1";
         case OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER_V1:
            return "OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER_V1";
         case OPCODE_ISCSI_TGT_GET_CONNECTION_INFO_V1:
            return "OPCODE_ISCSI_TGT_GET_CONNECTION_INFO_V1";
         case OPCODE_ISCSI_TGT_CONNECTION_REJECT_V1:
            return "OPCODE_ISCSI_TGT_CONNECTION_REJECT_V1";
         case OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION_V1:
            return "OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION_V1";
         case OPCODE_ISCSI_TGT_ISNS_SEND_PACKET_V1:
            return "OPCODE_ISCSI_TGT_ISNS_SEND_PACKET_V1";
         case OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION_V1:
            return "OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION_V1";
         case OPCODE_ISCSI_TGT_ADD_IP_ADDR_V1:
            return "OPCODE_ISCSI_TGT_ADD_IP_ADDR_V1";
         case OPCODE_ISCSI_TGT_DELETE_IP_ADDR_V1:
            return "OPCODE_ISCSI_TGT_DELETE_IP_ADDR_V1";
         case OPCODE_ISCSI_TGT_LIST_IP_ADDR_V1:
            return "OPCODE_ISCSI_TGT_LIST_IP_ADDR_V1";
         case OPCODE_ISCSI_TGT_START_ESI_LISTEN_V1:
            return "OPCODE_ISCSI_TGT_START_ESI_LISTEN_V1";
         case OPCODE_ISCSI_TGT_STOP_ESI_LISTEN_V1:
            return "OPCODE_ISCSI_TGT_STOP_ESI_LISTEN_V1";
         case OPCODE_ISCSI_TGT_SLP_REGISTER_V1:
            return "OPCODE_ISCSI_TGT_SLP_REGISTER_V1";
         case OPCODE_ISCSI_TGT_SLP_DEREGISTER_V1:
            return "OPCODE_ISCSI_TGT_SLP_DEREGISTER_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- MILI_PTL_SUBSYSTEM_OPCODES ---
#define OPCODE_MILI_PTL_CREATE_PORTAL_V1 (1)      
#define OPCODE_MILI_PTL_DELETE_PORTAL_V1 (2)      
#define OPCODE_MILI_PTL_CREATE_PORTAL_GROUP_V1 (3) 
#define OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_V1 (4) 
#define OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_V1 (5) 
#define OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_V1 (6) 
#define OPCODE_MILI_PTL_ADD_TARGET_V1   (7)       
#define SUBSYSTEM_MILI_PTL_CREATE_PORTAL_V1 (8)   
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_V1 (8)   
#define SUBSYSTEM_MILI_PTL_CREATE_PORTAL_GROUP_V1 (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_GROUP_V1 (8) 
#define SUBSYSTEM_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_V1 (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_V1 (8) 
#define SUBSYSTEM_MILI_PTL_ADD_TARGET_V1 (8)      
#define OPCODE_MILI_PTL_DELETE_TARGET_V1 (8)      
#define SUBSYSTEM_MILI_PTL_DELETE_TARGET_V1 (8)   
#define SUBSYSTEM_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_V1 (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_V1 (8) 
#define SUBSYSTEM_MILI_PTL_SET_TARGET_LOGIN_PARAMS_V1 (8) 
#define SUBSYSTEM_MILI_PTL_START_LISTEN_SERVER_V1 (8) 
#define SUBSYSTEM_MILI_PTL_STOP_LISTEN_SERVER_V1 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_V1 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_V1 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_V1 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_V1 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_V1 (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_V1 (8) 
#define SUBSYSTEM_MILI_PTL_GET_ISCSI_SESSION_LIST_V1 (8) 
#define SUBSYSTEM_MILI_PTL_KILL_SESSION_V1 (8)    
#define OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_V1 (9) 
#define OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_V1 (10) 
#define OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS_V1 (11) 
#define OPCODE_MILI_PTL_START_LISTEN_SERVER_V1 (12) 
#define OPCODE_MILI_PTL_STOP_LISTEN_SERVER_V1 (13) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_V1 (14) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_V1 (15) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_V1 (16) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_V1 (17) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_V1 (18) 
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_V1 (19) 
#define OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST_V1 (20) 
#define OPCODE_MILI_PTL_KILL_SESSION_V1 (21)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mili_ptl_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_MILI_PTL_CREATE_PORTAL_V1:
            return "OPCODE_MILI_PTL_CREATE_PORTAL_V1";
         case OPCODE_MILI_PTL_DELETE_PORTAL_V1:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_V1";
         case OPCODE_MILI_PTL_CREATE_PORTAL_GROUP_V1:
            return "OPCODE_MILI_PTL_CREATE_PORTAL_GROUP_V1";
         case OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_V1:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_V1";
         case OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_V1:
            return "OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_V1";
         case OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_V1:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_V1";
         case OPCODE_MILI_PTL_ADD_TARGET_V1:
            return "OPCODE_MILI_PTL_ADD_TARGET_V1";
         case OPCODE_MILI_PTL_DELETE_TARGET_V1:
            return "OPCODE_MILI_PTL_DELETE_TARGET_V1";
         case OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_V1:
            return "OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_V1";
         case OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_V1:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_V1";
         case OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS_V1:
            return "OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS_V1";
         case OPCODE_MILI_PTL_START_LISTEN_SERVER_V1:
            return "OPCODE_MILI_PTL_START_LISTEN_SERVER_V1";
         case OPCODE_MILI_PTL_STOP_LISTEN_SERVER_V1:
            return "OPCODE_MILI_PTL_STOP_LISTEN_SERVER_V1";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_V1:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_V1";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_V1:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_V1";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_V1:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_V1";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_V1:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_V1";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_V1:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_V1";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_V1:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_V1";
         case OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST_V1:
            return "OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST_V1";
         case OPCODE_MILI_PTL_KILL_SESSION_V1:
            return "OPCODE_MILI_PTL_KILL_SESSION_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- MILI_TMD_SUBSYSTEM_OPCODES ---
#define OPCODE_MILI_TMD_ADD_TARGET_V1   (1)       
#define OPCODE_MILI_TMD_DELETE_TARGET_V1 (2)      
#define OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_V1 (3) 
#define OPCODE_MILI_TMD_ADD_INITIATOR_V1 (4)      
#define OPCODE_MILI_TMD_DELETE_INITIATOR_V1 (5)   
#define OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_V1 (6) 
#define OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET_V1 (7) 
#define OPCODE_MILI_TMD_DELETE_IT_BINDING_V1 (8)  
#define SUBSYSTEM_MILI_TMD_ADD_TARGET_V1 (9)      
#define SUBSYSTEM_MILI_TMD_DELETE_TARGET_V1 (9)   
#define SUBSYSTEM_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_V1 (9) 
#define SUBSYSTEM_MILI_TMD_ADD_INITIATOR_V1 (9)   
#define SUBSYSTEM_MILI_TMD_DELETE_INITIATOR_V1 (9) 
#define SUBSYSTEM_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_V1 (9) 
#define SUBSYSTEM_MILI_TMD_BIND_INITIATOR_TO_TARGET_V1 (9) 
#define SUBSYSTEM_MILI_TMD_DELETE_IT_BINDING_V1 (9) 
#define OPCODE_MILI_TMD_ACTIVATE_TARGET_V1 (9)    
#define SUBSYSTEM_MILI_TMD_ACTIVATE_TARGET_V1 (9) 
#define SUBSYSTEM_MILI_TMD_DEACTIVATE_TARGET_V1 (9) 
#define SUBSYSTEM_MILI_TMD_SET_INITIATOR_QOS_V1 (9) 
#define OPCODE_MILI_TMD_DEACTIVATE_TARGET_V1 (10) 
#define OPCODE_MILI_TMD_SET_INITIATOR_QOS_V1 (11) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mili_tmd_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_MILI_TMD_ADD_TARGET_V1:
            return "OPCODE_MILI_TMD_ADD_TARGET_V1";
         case OPCODE_MILI_TMD_DELETE_TARGET_V1:
            return "OPCODE_MILI_TMD_DELETE_TARGET_V1";
         case OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_V1:
            return "OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_V1";
         case OPCODE_MILI_TMD_ADD_INITIATOR_V1:
            return "OPCODE_MILI_TMD_ADD_INITIATOR_V1";
         case OPCODE_MILI_TMD_DELETE_INITIATOR_V1:
            return "OPCODE_MILI_TMD_DELETE_INITIATOR_V1";
         case OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_V1:
            return "OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_V1";
         case OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET_V1:
            return "OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET_V1";
         case OPCODE_MILI_TMD_DELETE_IT_BINDING_V1:
            return "OPCODE_MILI_TMD_DELETE_IT_BINDING_V1";
         case OPCODE_MILI_TMD_ACTIVATE_TARGET_V1:
            return "OPCODE_MILI_TMD_ACTIVATE_TARGET_V1";
         case OPCODE_MILI_TMD_DEACTIVATE_TARGET_V1:
            return "OPCODE_MILI_TMD_DEACTIVATE_TARGET_V1";
         case OPCODE_MILI_TMD_SET_INITIATOR_QOS_V1:
            return "OPCODE_MILI_TMD_SET_INITIATOR_QOS_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ETH_SUBSYSTEM_OPCODES ---
#define OPCODE_ETH_RSS_CONFIG_V1        (1)       
#define OPCODE_ETH_ACPI_CONFIG_V1       (2)       
#define SUBSYSTEM_ETH_RSS_CONFIG_V1     (3)       
#define SUBSYSTEM_ETH_ACPI_CONFIG_V1    (3)       
#define OPCODE_ETH_PROMISCUOUS_V1       (3)       
#define SUBSYSTEM_ETH_PROMISCUOUS_V1    (3)       
#define SUBSYSTEM_ETH_GET_STATISTICS_V1 (3)       
#define SUBSYSTEM_ETH_TX_CREATE_V1      (3)       
#define SUBSYSTEM_ETH_RX_CREATE_V1      (3)       
#define SUBSYSTEM_ETH_TX_DESTROY_V1     (3)       
#define SUBSYSTEM_ETH_RX_DESTROY_V1     (3)       
#define SUBSYSTEM_ETH_GET_QPGE_STATISTICS_V1 (3)  
#define SUBSYSTEM_ETH_ACPI_WOL_MAGIC_CONFIG_V1 (3) 
#define SUBSYSTEM_ETH_NETWORK_STATS_V1  (3)       
#define SUBSYSTEM_ETH_PG_FEATURE_QUERY_REQUEST_V1 (3) 
#define OPCODE_ETH_GET_STATISTICS_V1    (4)       
#define OPCODE_ETH_TX_CREATE_V1         (7)       
#define OPCODE_ETH_RX_CREATE_V1         (8)       
#define OPCODE_ETH_TX_DESTROY_V1        (9)       
#define OPCODE_ETH_RX_DESTROY_V1        (10)      
#define OPCODE_ETH_GET_QPGE_STATISTICS_V1 (11)    
#define OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG_V1 (12)  
#define OPCODE_ETH_NETWORK_STATS_V1     (13)      
#define OPCODE_ETH_PG_FEATURE_QUERY_REQUEST_V1 (23) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* eth_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ETH_RSS_CONFIG_V1:
            return "OPCODE_ETH_RSS_CONFIG_V1";
         case OPCODE_ETH_ACPI_CONFIG_V1:
            return "OPCODE_ETH_ACPI_CONFIG_V1";
         case OPCODE_ETH_PROMISCUOUS_V1:
            return "OPCODE_ETH_PROMISCUOUS_V1";
         case OPCODE_ETH_GET_STATISTICS_V1:
            return "OPCODE_ETH_GET_STATISTICS_V1";
         case OPCODE_ETH_TX_CREATE_V1:
            return "OPCODE_ETH_TX_CREATE_V1";
         case OPCODE_ETH_RX_CREATE_V1:
            return "OPCODE_ETH_RX_CREATE_V1";
         case OPCODE_ETH_TX_DESTROY_V1:
            return "OPCODE_ETH_TX_DESTROY_V1";
         case OPCODE_ETH_RX_DESTROY_V1:
            return "OPCODE_ETH_RX_DESTROY_V1";
         case OPCODE_ETH_GET_QPGE_STATISTICS_V1:
            return "OPCODE_ETH_GET_QPGE_STATISTICS_V1";
         case OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG_V1:
            return "OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG_V1";
         case OPCODE_ETH_NETWORK_STATS_V1:
            return "OPCODE_ETH_NETWORK_STATS_V1";
         case OPCODE_ETH_PG_FEATURE_QUERY_REQUEST_V1:
            return "OPCODE_ETH_PG_FEATURE_QUERY_REQUEST_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LRO_SUBSYSTEM_OPCODES ---
#define OPCODE_LRO_RING_CREATE_V1       (1)       
#define OPCODE_LRO_CONFIG_V1            (2)       
#define OPCODE_LRO_GET_STATISTICS_V1    (3)       
#define OPCODE_LRO_RING_DESTROY_V1      (4)       
#define SUBSYSTEM_LRO_RING_CREATE_V1    (13)      
#define SUBSYSTEM_LRO_CONFIG_V1         (13)      
#define SUBSYSTEM_LRO_GET_STATISTICS_V1 (13)      
#define SUBSYSTEM_LRO_RING_DESTROY_V1   (13)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lro_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LRO_RING_CREATE_V1:
            return "OPCODE_LRO_RING_CREATE_V1";
         case OPCODE_LRO_CONFIG_V1:
            return "OPCODE_LRO_CONFIG_V1";
         case OPCODE_LRO_GET_STATISTICS_V1:
            return "OPCODE_LRO_GET_STATISTICS_V1";
         case OPCODE_LRO_RING_DESTROY_V1:
            return "OPCODE_LRO_RING_DESTROY_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DAL_SUBSYSTEM_OPCODES ---
#define OPCODE_DAL_GET_PARAMETERS_V1    (1)       
#define OPCODE_DAL_DRIVER_LOAD_V1       (2)       
#define OPCODE_DAL_DRIVER_UNLOAD_V1     (3)       
#define OPCODE_DAL_QP_CREATE_V1         (4)       
#define OPCODE_DAL_QP_DESTROY_V1        (5)       
#define OPCODE_DAL_MR_REGISTER_V1       (6)       
#define OPCODE_DAL_MR_UNREGISTER_V1     (7)       
#define OPCODE_DAL_QP_MODIFY_RTS_V1     (8)       
#define OPCODE_DAL_QP_MODIFY_RTR_V1     (9)       
#define OPCODE_DAL_MULTICAST_JOIN_V1    (10)      
#define OPCODE_DAL_MULTICAST_LEAVE_V1   (11)      
#define SUBSYSTEM_DAL_GET_PARAMETERS_V1 (14)      
#define SUBSYSTEM_DAL_DRIVER_LOAD_V1    (14)      
#define SUBSYSTEM_DAL_DRIVER_UNLOAD_V1  (14)      
#define SUBSYSTEM_DAL_QP_CREATE_V1      (14)      
#define SUBSYSTEM_DAL_QP_DESTROY_V1     (14)      
#define SUBSYSTEM_DAL_MR_REGISTER_V1    (14)      
#define SUBSYSTEM_DAL_MR_UNREGISTER_V1  (14)      
#define SUBSYSTEM_DAL_QP_MODIFY_RTS_V1  (14)      
#define SUBSYSTEM_DAL_QP_MODIFY_RTR_V1  (14)      
#define SUBSYSTEM_DAL_MULTICAST_JOIN_V1 (14)      
#define SUBSYSTEM_DAL_MULTICAST_LEAVE_V1 (14)     

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dal_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DAL_GET_PARAMETERS_V1:
            return "OPCODE_DAL_GET_PARAMETERS_V1";
         case OPCODE_DAL_DRIVER_LOAD_V1:
            return "OPCODE_DAL_DRIVER_LOAD_V1";
         case OPCODE_DAL_DRIVER_UNLOAD_V1:
            return "OPCODE_DAL_DRIVER_UNLOAD_V1";
         case OPCODE_DAL_QP_CREATE_V1:
            return "OPCODE_DAL_QP_CREATE_V1";
         case OPCODE_DAL_QP_DESTROY_V1:
            return "OPCODE_DAL_QP_DESTROY_V1";
         case OPCODE_DAL_MR_REGISTER_V1:
            return "OPCODE_DAL_MR_REGISTER_V1";
         case OPCODE_DAL_MR_UNREGISTER_V1:
            return "OPCODE_DAL_MR_UNREGISTER_V1";
         case OPCODE_DAL_QP_MODIFY_RTS_V1:
            return "OPCODE_DAL_QP_MODIFY_RTS_V1";
         case OPCODE_DAL_QP_MODIFY_RTR_V1:
            return "OPCODE_DAL_QP_MODIFY_RTR_V1";
         case OPCODE_DAL_MULTICAST_JOIN_V1:
            return "OPCODE_DAL_MULTICAST_JOIN_V1";
         case OPCODE_DAL_MULTICAST_LEAVE_V1:
            return "OPCODE_DAL_MULTICAST_LEAVE_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- TOE_SUBSYSTEM_OPCODES ---
#define OPCODE_TOE_CONNECTION_OFFLOAD_V1 (1)      
#define OPCODE_TOE_CONNECTION_UPDATE_V1 (3)       
#define SUBSYSTEM_TOE_CONNECTION_OFFLOAD_V1 (4)   
#define SUBSYSTEM_TOE_CONNECTION_UPDATE_V1 (4)    
#define OPCODE_TOE_GET_STATISTICS_V1    (4)       
#define SUBSYSTEM_TOE_GET_STATISTICS_V1 (4)       
#define SUBSYSTEM_TOE_CONNECTION_QUERY_V1 (4)     
#define SUBSYSTEM_TOE_WRBQ_CREATE_V1    (4)       
#define SUBSYSTEM_TOE_RQ_CREATE_V1      (4)       
#define SUBSYSTEM_TOE_DEFQ_CREATE_V1    (4)       
#define SUBSYSTEM_TOE_WRBQ_DESTROY_V1   (4)       
#define SUBSYSTEM_TOE_RQ_DESTROY_V1     (4)       
#define SUBSYSTEM_TOE_DEFQ_DESTROY_V1   (4)       
#define OPCODE_TOE_CONNECTION_QUERY_V1  (5)       
#define OPCODE_TOE_WRBQ_CREATE_V1       (6)       
#define OPCODE_TOE_RQ_CREATE_V1         (7)       
#define OPCODE_TOE_DEFQ_CREATE_V1       (8)       
#define OPCODE_TOE_WRBQ_DESTROY_V1      (9)       
#define OPCODE_TOE_RQ_DESTROY_V1        (10)      
#define OPCODE_TOE_DEFQ_DESTROY_V1      (11)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* toe_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_TOE_CONNECTION_OFFLOAD_V1:
            return "OPCODE_TOE_CONNECTION_OFFLOAD_V1";
         case OPCODE_TOE_CONNECTION_UPDATE_V1:
            return "OPCODE_TOE_CONNECTION_UPDATE_V1";
         case OPCODE_TOE_GET_STATISTICS_V1:
            return "OPCODE_TOE_GET_STATISTICS_V1";
         case OPCODE_TOE_CONNECTION_QUERY_V1:
            return "OPCODE_TOE_CONNECTION_QUERY_V1";
         case OPCODE_TOE_WRBQ_CREATE_V1:
            return "OPCODE_TOE_WRBQ_CREATE_V1";
         case OPCODE_TOE_RQ_CREATE_V1:
            return "OPCODE_TOE_RQ_CREATE_V1";
         case OPCODE_TOE_DEFQ_CREATE_V1:
            return "OPCODE_TOE_DEFQ_CREATE_V1";
         case OPCODE_TOE_WRBQ_DESTROY_V1:
            return "OPCODE_TOE_WRBQ_DESTROY_V1";
         case OPCODE_TOE_RQ_DESTROY_V1:
            return "OPCODE_TOE_RQ_DESTROY_V1";
         case OPCODE_TOE_DEFQ_DESTROY_V1:
            return "OPCODE_TOE_DEFQ_DESTROY_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- PXE_UNDI_SUBSYSTEM_OPCODES ---
#define OPCODE_PXE_UNDI_CONTROL_V1      (1)       
#define OPCODE_PXE_UNDI_TRANSMIT_V1     (2)       
#define OPCODE_PXE_UNDI_RECEIVE_V1      (3)       
#define OPCODE_PXE_UNDI_GET_STATISTICS_V1 (4)     
#define SUBSYSTEM_PXE_UNDI_CONTROL_V1   (5)       
#define SUBSYSTEM_PXE_UNDI_TRANSMIT_V1  (5)       
#define SUBSYSTEM_PXE_UNDI_RECEIVE_V1   (5)       
#define SUBSYSTEM_PXE_UNDI_GET_STATISTICS_V1 (5)  
#define OPCODE_PXE_UNDI_SET_VLAN_V1     (5)       
#define SUBSYSTEM_PXE_UNDI_SET_VLAN_V1  (5)       
#define SUBSYSTEM_PXE_UNDI_GET_VLAN_V1  (5)       
#define OPCODE_PXE_UNDI_GET_VLAN_V1     (6)       

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* pxe_undi_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_PXE_UNDI_CONTROL_V1:
            return "OPCODE_PXE_UNDI_CONTROL_V1";
         case OPCODE_PXE_UNDI_TRANSMIT_V1:
            return "OPCODE_PXE_UNDI_TRANSMIT_V1";
         case OPCODE_PXE_UNDI_RECEIVE_V1:
            return "OPCODE_PXE_UNDI_RECEIVE_V1";
         case OPCODE_PXE_UNDI_GET_STATISTICS_V1:
            return "OPCODE_PXE_UNDI_GET_STATISTICS_V1";
         case OPCODE_PXE_UNDI_SET_VLAN_V1:
            return "OPCODE_PXE_UNDI_SET_VLAN_V1";
         case OPCODE_PXE_UNDI_GET_VLAN_V1:
            return "OPCODE_PXE_UNDI_GET_VLAN_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- RDMA_SUBSYSTEM_OPCODES ---
#define OPCODE_RDMA_QP_CREATE_V1        (1)       
#define OPCODE_RDMA_QP_QUERY_V1         (2)       
#define OPCODE_RDMA_QP_MODIFY_V1        (3)       
#define OPCODE_RDMA_CXN_OFFLOAD_V1      (4)       
#define OPCODE_RDMA_CXN_UPLOAD_V1       (5)       
#define OPCODE_RDMA_CXN_UPDATE_V1       (6)       
#define OPCODE_RDMA_ALLOC_NSMR_STAG_V1  (7)       
#define OPCODE_RDMA_NSMR_REGISTER_V1    (8)       
#define OPCODE_RDMA_NSMR_REREGISTER_V1  (9)       
#define SUBSYSTEM_RDMA_QP_CREATE_V1     (10)      
#define SUBSYSTEM_RDMA_QP_QUERY_V1      (10)      
#define SUBSYSTEM_RDMA_QP_MODIFY_V1     (10)      
#define SUBSYSTEM_RDMA_CXN_OFFLOAD_V1   (10)      
#define SUBSYSTEM_RDMA_CXN_UPLOAD_V1    (10)      
#define SUBSYSTEM_RDMA_CXN_UPDATE_V1    (10)      
#define SUBSYSTEM_RDMA_ALLOC_NSMR_STAG_V1 (10)    
#define SUBSYSTEM_RDMA_NSMR_REGISTER_V1 (10)      
#define SUBSYSTEM_RDMA_NSMR_REREGISTER_V1 (10)    
#define OPCODE_RDMA_ADD_TE_V1           (10)      
#define SUBSYSTEM_RDMA_ADD_TE_V1        (10)      
#define SUBSYSTEM_RDMA_SMR_REGISTER_V1  (10)      
#define SUBSYSTEM_RDMA_QUERY_MR_V1      (10)      
#define SUBSYSTEM_RDMA_STAG_DEALLOC_V1  (10)      
#define SUBSYSTEM_RDMA_MW_QUERY_V1      (10)      
#define SUBSYSTEM_RDMA_IPADDR_QUERY_V1  (10)      
#define SUBSYSTEM_RDMA_QP_DESTROY_V1    (10)      
#define OPCODE_RDMA_SMR_REGISTER_V1     (11)      
#define OPCODE_RDMA_QUERY_MR_V1         (12)      
#define OPCODE_RDMA_STAG_DEALLOC_V1     (13)      
#define OPCODE_RDMA_MW_QUERY_V1         (14)      
#define OPCODE_RDMA_IPADDR_QUERY_V1     (15)      
#define OPCODE_RDMA_QP_DESTROY_V1       (16)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* rdma_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_RDMA_QP_CREATE_V1:
            return "OPCODE_RDMA_QP_CREATE_V1";
         case OPCODE_RDMA_QP_QUERY_V1:
            return "OPCODE_RDMA_QP_QUERY_V1";
         case OPCODE_RDMA_QP_MODIFY_V1:
            return "OPCODE_RDMA_QP_MODIFY_V1";
         case OPCODE_RDMA_CXN_OFFLOAD_V1:
            return "OPCODE_RDMA_CXN_OFFLOAD_V1";
         case OPCODE_RDMA_CXN_UPLOAD_V1:
            return "OPCODE_RDMA_CXN_UPLOAD_V1";
         case OPCODE_RDMA_CXN_UPDATE_V1:
            return "OPCODE_RDMA_CXN_UPDATE_V1";
         case OPCODE_RDMA_ALLOC_NSMR_STAG_V1:
            return "OPCODE_RDMA_ALLOC_NSMR_STAG_V1";
         case OPCODE_RDMA_NSMR_REGISTER_V1:
            return "OPCODE_RDMA_NSMR_REGISTER_V1";
         case OPCODE_RDMA_NSMR_REREGISTER_V1:
            return "OPCODE_RDMA_NSMR_REREGISTER_V1";
         case OPCODE_RDMA_ADD_TE_V1:
            return "OPCODE_RDMA_ADD_TE_V1";
         case OPCODE_RDMA_SMR_REGISTER_V1:
            return "OPCODE_RDMA_SMR_REGISTER_V1";
         case OPCODE_RDMA_QUERY_MR_V1:
            return "OPCODE_RDMA_QUERY_MR_V1";
         case OPCODE_RDMA_STAG_DEALLOC_V1:
            return "OPCODE_RDMA_STAG_DEALLOC_V1";
         case OPCODE_RDMA_MW_QUERY_V1:
            return "OPCODE_RDMA_MW_QUERY_V1";
         case OPCODE_RDMA_IPADDR_QUERY_V1:
            return "OPCODE_RDMA_IPADDR_QUERY_V1";
         case OPCODE_RDMA_QP_DESTROY_V1:
            return "OPCODE_RDMA_QP_DESTROY_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LOWLEVEL_SUBSYSTEM_OPCODES ---
#define OPCODE_LOWLEVEL_CONFIG_DT_ENTRY_V1 (1)    
#define OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY_V1 (2) 
#define OPCODE_LOWLEVEL_ACCESS_MEMORY_V1 (3)      
#define OPCODE_LOWLEVEL_ACCESS_REGISTERS_V1 (4)   
#define OPCODE_LOWLEVEL_OFFLOAD_ENABLE_V1 (5)     
#define OPCODE_LOWLEVEL_CONFIG_TCP_STATE_V1 (6)   
#define OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER_V1 (7) 
#define OPCODE_LOWLEVEL_CONFIG_ISCSI_V1 (8)       
#define OPCODE_LOWLEVEL_CONFIG_TOE_V1   (9)       
#define OPCODE_LOWLEVEL_ISCSI_OFFLOAD_V1 (10)     
#define SUBSYSTEM_LOWLEVEL_CONFIG_DT_ENTRY_V1 (11) 
#define SUBSYSTEM_LOWLEVEL_INVALIDATE_PT_ENTRY_V1 (11) 
#define SUBSYSTEM_LOWLEVEL_ACCESS_MEMORY_V1 (11)  
#define SUBSYSTEM_LOWLEVEL_ACCESS_REGISTERS_V1 (11) 
#define SUBSYSTEM_LOWLEVEL_OFFLOAD_ENABLE_V1 (11) 
#define SUBSYSTEM_LOWLEVEL_CONFIG_TCP_STATE_V1 (11) 
#define SUBSYSTEM_LOWLEVEL_CONFIG_TEMPLATE_HEADER_V1 (11) 
#define SUBSYSTEM_LOWLEVEL_CONFIG_ISCSI_V1 (11)   
#define SUBSYSTEM_LOWLEVEL_CONFIG_TOE_V1 (11)     
#define SUBSYSTEM_LOWLEVEL_ISCSI_OFFLOAD_V1 (11)  
#define SUBSYSTEM_LOWLEVEL_MAP_UT_PAGES_V1 (11)   
#define SUBSYSTEM_LOWLEVEL_UNMAP_UT_PAGES_V1 (11) 
#define SUBSYSTEM_LOWLEVEL_MGMT_DEBUG_LEVEL_V1 (11) 
#define SUBSYSTEM_LOWLEVEL_MEASURE_DMA_BANDWIDTH_V1 (11) 
#define SUBSYSTEM_LOWLEVEL_HOST_DDR_DMA_V1 (11)   
#define SUBSYSTEM_LOWLEVEL_LOOPBACK_TEST_V1 (11)  
#define SUBSYSTEM_LOWLEVEL_SET_LOOPBACK_MODE_V1 (11) 
#define SUBSYSTEM_LOWLEVEL_GET_LOOPBACK_MODE_V1 (11) 
#define OPCODE_LOWLEVEL_MAP_UT_PAGES_V1 (13)      
#define OPCODE_LOWLEVEL_UNMAP_UT_PAGES_V1 (14)    
#define OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL_V1 (15)  
#define OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH_V1 (16) 
#define OPCODE_LOWLEVEL_HOST_DDR_DMA_V1 (17)      
#define OPCODE_LOWLEVEL_LOOPBACK_TEST_V1 (18)     
#define OPCODE_LOWLEVEL_SET_LOOPBACK_MODE_V1 (19) 
#define OPCODE_LOWLEVEL_GET_LOOPBACK_MODE_V1 (20) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lowlevel_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LOWLEVEL_CONFIG_DT_ENTRY_V1:
            return "OPCODE_LOWLEVEL_CONFIG_DT_ENTRY_V1";
         case OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY_V1:
            return "OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY_V1";
         case OPCODE_LOWLEVEL_ACCESS_MEMORY_V1:
            return "OPCODE_LOWLEVEL_ACCESS_MEMORY_V1";
         case OPCODE_LOWLEVEL_ACCESS_REGISTERS_V1:
            return "OPCODE_LOWLEVEL_ACCESS_REGISTERS_V1";
         case OPCODE_LOWLEVEL_OFFLOAD_ENABLE_V1:
            return "OPCODE_LOWLEVEL_OFFLOAD_ENABLE_V1";
         case OPCODE_LOWLEVEL_CONFIG_TCP_STATE_V1:
            return "OPCODE_LOWLEVEL_CONFIG_TCP_STATE_V1";
         case OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER_V1:
            return "OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER_V1";
         case OPCODE_LOWLEVEL_CONFIG_ISCSI_V1:
            return "OPCODE_LOWLEVEL_CONFIG_ISCSI_V1";
         case OPCODE_LOWLEVEL_CONFIG_TOE_V1:
            return "OPCODE_LOWLEVEL_CONFIG_TOE_V1";
         case OPCODE_LOWLEVEL_ISCSI_OFFLOAD_V1:
            return "OPCODE_LOWLEVEL_ISCSI_OFFLOAD_V1";
         case OPCODE_LOWLEVEL_MAP_UT_PAGES_V1:
            return "OPCODE_LOWLEVEL_MAP_UT_PAGES_V1";
         case OPCODE_LOWLEVEL_UNMAP_UT_PAGES_V1:
            return "OPCODE_LOWLEVEL_UNMAP_UT_PAGES_V1";
         case OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL_V1:
            return "OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL_V1";
         case OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH_V1:
            return "OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH_V1";
         case OPCODE_LOWLEVEL_HOST_DDR_DMA_V1:
            return "OPCODE_LOWLEVEL_HOST_DDR_DMA_V1";
         case OPCODE_LOWLEVEL_LOOPBACK_TEST_V1:
            return "OPCODE_LOWLEVEL_LOOPBACK_TEST_V1";
         case OPCODE_LOWLEVEL_SET_LOOPBACK_MODE_V1:
            return "OPCODE_LOWLEVEL_SET_LOOPBACK_MODE_V1";
         case OPCODE_LOWLEVEL_GET_LOOPBACK_MODE_V1:
            return "OPCODE_LOWLEVEL_GET_LOOPBACK_MODE_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_FCOE_SUBSYSTEM_OPCODES ---
#define OPCODE_COMMON_FCOE_WRBQ_CREATE_V1 (1)     
#define OPCODE_COMMON_FCOE_WRBQ_DESTROY_V1 (2)    
#define OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES_V1 (3) 
#define OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_V1 (4) 
#define OPCODE_COMMON_FCOE_DEFQ_CREATE_V1 (5)     
#define OPCODE_COMMON_FCOE_DEFQ_DESTROY_V1 (6)    
#define OPCODE_COMMON_FCOE_READ_FCF_TABLE_V1 (8)  
#define OPCODE_COMMON_FCOE_ADD_FCF_V1   (9)       
#define OPCODE_COMMON_FCOE_DELETE_FCF_V1 (10)     
#define OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES_V1 (11) 
#define SUBSYSTEM_COMMON_FCOE_WRBQ_CREATE_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_WRBQ_DESTROY_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_CFG_POST_SGL_PAGES_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_DEFQ_CREATE_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_DEFQ_DESTROY_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_READ_FCF_TABLE_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_ADD_FCF_V1 (12)     
#define SUBSYSTEM_COMMON_FCOE_DELETE_FCF_V1 (12)  
#define SUBSYSTEM_COMMON_FCOE_POST_HDR_TEMPLATES_V1 (12) 
#define OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_REMOVE_HDR_TEMPLATES_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_IO_INIT_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_REQUEST_COMPLETION_V1 (12) 
#define SUBSYSTEM_COMMON_FCOE_REDISCOVER_FCF_V1 (12) 
#define OPCODE_COMMON_FCOE_MBOX_IO_INIT_V1 (13)   
#define OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_V1 (14) 
#define OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION_V1 (15) 
#define OPCODE_COMMON_FCOE_REDISCOVER_FCF_V1 (16) 

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_fcoe_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_FCOE_WRBQ_CREATE_V1:
            return "OPCODE_COMMON_FCOE_WRBQ_CREATE_V1";
         case OPCODE_COMMON_FCOE_WRBQ_DESTROY_V1:
            return "OPCODE_COMMON_FCOE_WRBQ_DESTROY_V1";
         case OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES_V1:
            return "OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES_V1";
         case OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_V1:
            return "OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_V1";
         case OPCODE_COMMON_FCOE_DEFQ_CREATE_V1:
            return "OPCODE_COMMON_FCOE_DEFQ_CREATE_V1";
         case OPCODE_COMMON_FCOE_DEFQ_DESTROY_V1:
            return "OPCODE_COMMON_FCOE_DEFQ_DESTROY_V1";
         case OPCODE_COMMON_FCOE_READ_FCF_TABLE_V1:
            return "OPCODE_COMMON_FCOE_READ_FCF_TABLE_V1";
         case OPCODE_COMMON_FCOE_ADD_FCF_V1:
            return "OPCODE_COMMON_FCOE_ADD_FCF_V1";
         case OPCODE_COMMON_FCOE_DELETE_FCF_V1:
            return "OPCODE_COMMON_FCOE_DELETE_FCF_V1";
         case OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES_V1:
            return "OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES_V1";
         case OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES_V1:
            return "OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES_V1";
         case OPCODE_COMMON_FCOE_MBOX_IO_INIT_V1:
            return "OPCODE_COMMON_FCOE_MBOX_IO_INIT_V1";
         case OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_V1:
            return "OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_V1";
         case OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION_V1:
            return "OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION_V1";
         case OPCODE_COMMON_FCOE_REDISCOVER_FCF_V1:
            return "OPCODE_COMMON_FCOE_REDISCOVER_FCF_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LLDP_SUBSYSTEM_OPCODES ---
#define OPCODE_LLDP_GET_LLDP_CFG_V1     (1)       
#define OPCODE_LLDP_SET_LLDP_CFG_V1     (2)       
#define OPCODE_LLDP_GET_LLDP_STATS_V1   (3)       
#define SUBSYSTEM_LLDP_GET_LLDP_CFG_V1  (15)      
#define SUBSYSTEM_LLDP_SET_LLDP_CFG_V1  (15)      
#define SUBSYSTEM_LLDP_GET_LLDP_STATS_V1 (15)     

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lldp_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LLDP_GET_LLDP_CFG_V1:
            return "OPCODE_LLDP_GET_LLDP_CFG_V1";
         case OPCODE_LLDP_SET_LLDP_CFG_V1:
            return "OPCODE_LLDP_SET_LLDP_CFG_V1";
         case OPCODE_LLDP_GET_LLDP_STATS_V1:
            return "OPCODE_LLDP_GET_LLDP_STATS_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DCBX_SUBSYSTEM_OPCODES ---
#define OPCODE_DCBX_GET_DCBX_CFG_V1     (1)       
#define OPCODE_DCBX_SET_DCBX_CFG_V1     (2)       
#define OPCODE_DCBX_GET_DCBX_MIB_INFO_V1 (3)      
#define OPCODE_DCBX_GET_DCBX_MODE_V1    (4)       
#define OPCODE_DCBX_SET_DCBX_MODE_V1    (5)       
#define SUBSYSTEM_DCBX_GET_DCBX_CFG_V1  (16)      
#define SUBSYSTEM_DCBX_SET_DCBX_CFG_V1  (16)      
#define SUBSYSTEM_DCBX_GET_DCBX_MIB_INFO_V1 (16)  
#define SUBSYSTEM_DCBX_GET_DCBX_MODE_V1 (16)      
#define SUBSYSTEM_DCBX_SET_DCBX_MODE_V1 (16)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dcbx_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DCBX_GET_DCBX_CFG_V1:
            return "OPCODE_DCBX_GET_DCBX_CFG_V1";
         case OPCODE_DCBX_SET_DCBX_CFG_V1:
            return "OPCODE_DCBX_SET_DCBX_CFG_V1";
         case OPCODE_DCBX_GET_DCBX_MIB_INFO_V1:
            return "OPCODE_DCBX_GET_DCBX_MIB_INFO_V1";
         case OPCODE_DCBX_GET_DCBX_MODE_V1:
            return "OPCODE_DCBX_GET_DCBX_MODE_V1";
         case OPCODE_DCBX_SET_DCBX_MODE_V1:
            return "OPCODE_DCBX_SET_DCBX_MODE_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DMTF_SUBSYSTEM_OPCODES ---
#define OPCODE_DMTF_EXECUTE_CMD_V1      (1)       
#define SUBSYSTEM_DMTF_EXECUTE_CMD_V1   (17)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dmtf_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DMTF_EXECUTE_CMD_V1:
            return "OPCODE_DMTF_EXECUTE_CMD_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DIAG_SUBSYSTEM_OPCODES ---
#define OPCODE_DIAG_DMA_V1              (1)       
#define OPCODE_DIAG_MDIO_V1             (2)       
#define OPCODE_DIAG_NLB_V1              (3)       
#define OPCODE_DIAG_ATT_V1              (4)       
#define OPCODE_DIAG_GETMAC_V1           (5)       
#define OPCODE_DIAG_8051_CMD_V1         (6)       
#define OPCODE_DIAG_10GBASET_STATS_V1   (7)       
#define OPCODE_DIAG_RUN_10GBASET_SELFTEST_V1 (8)  
#define OPCODE_DIAG_SET_10GBASET_NVPVALUE_V1 (9)  
#define OPCODE_DIAG_RUN_TDR_V1          (10)      
#define SUBSYSTEM_DIAG_DMA_V1           (18)      
#define SUBSYSTEM_DIAG_MDIO_V1          (18)      
#define SUBSYSTEM_DIAG_NLB_V1           (18)      
#define SUBSYSTEM_DIAG_ATT_V1           (18)      
#define SUBSYSTEM_DIAG_GETMAC_V1        (18)      
#define SUBSYSTEM_DIAG_8051_CMD_V1      (18)      
#define SUBSYSTEM_DIAG_10GBASET_STATS_V1 (18)     
#define SUBSYSTEM_DIAG_RUN_10GBASET_SELFTEST_V1 (18) 
#define SUBSYSTEM_DIAG_SET_10GBASET_NVPVALUE_V1 (18) 
#define SUBSYSTEM_DIAG_RUN_TDR_V1       (18)      

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* diag_subsystem_opcodes_v1_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DIAG_DMA_V1:
            return "OPCODE_DIAG_DMA_V1";
         case OPCODE_DIAG_MDIO_V1:
            return "OPCODE_DIAG_MDIO_V1";
         case OPCODE_DIAG_NLB_V1:
            return "OPCODE_DIAG_NLB_V1";
         case OPCODE_DIAG_ATT_V1:
            return "OPCODE_DIAG_ATT_V1";
         case OPCODE_DIAG_GETMAC_V1:
            return "OPCODE_DIAG_GETMAC_V1";
         case OPCODE_DIAG_8051_CMD_V1:
            return "OPCODE_DIAG_8051_CMD_V1";
         case OPCODE_DIAG_10GBASET_STATS_V1:
            return "OPCODE_DIAG_10GBASET_STATS_V1";
         case OPCODE_DIAG_RUN_10GBASET_SELFTEST_V1:
            return "OPCODE_DIAG_RUN_10GBASET_SELFTEST_V1";
         case OPCODE_DIAG_SET_10GBASET_NVPVALUE_V1:
            return "OPCODE_DIAG_SET_10GBASET_NVPVALUE_V1";
         case OPCODE_DIAG_RUN_TDR_V1:
            return "OPCODE_DIAG_RUN_TDR_V1";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- VENDOR_SUBSYSTEM_OPCODES ---
#define OPCODE_VENDOR_SLI_V1            (1)       
#define SUBSYSTEM_VENDOR_SLI_V1         (19)      


typedef struct _IOCTL_REQUEST_HEADER_V1 {
   UEXACT8 opcode;
   UEXACT8 subsystem;
   UEXACT8 port_number;
   UEXACT8 domain;
   UEXACT32 timeout;
   UEXACT32 request_length;
   UEXACT8 version;
   UEXACT8 rsvd0[3];
} SG_PACK IOCTL_REQUEST_HEADER_V1, *PIOCTL_REQUEST_HEADER_V1;




typedef struct _IOCTL_RESPONSE_HEADER_V1 {
   UEXACT8 opcode;
   UEXACT8 subsystem;
   UEXACT8 rsvd0;
   UEXACT8 domain;
   UEXACT8 status;
   UEXACT8 additional_status;
   UEXACT16 rsvd1;
   UEXACT32 response_length;
   UEXACT32 actual_response_length;
} SG_PACK IOCTL_RESPONSE_HEADER_V1, *PIOCTL_RESPONSE_HEADER_V1;




typedef union _IOCTL_HEADER_V1 {
   IOCTL_REQUEST_HEADER_V1 request;
   IOCTL_RESPONSE_HEADER_V1 response;
} SG_PACK IOCTL_HEADER_V1, *PIOCTL_HEADER_V1;




typedef struct _EQ_DB_V1 {
   union {
      struct { 
         u32 qid : 9;                             // DWORD 0
         u32 ClearInt : 1;                        // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 num_popped : 13;                     // DWORD 0
         u32 rearm : 1;                           // DWORD 0
         u32 r2i_dly_mult_enc : 2;                // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK EQ_DB_V1, *PEQ_DB_V1;

SG_C_ASSERT(__sizeof__EQ_DB, sizeof (EQ_DB_V1) == 4);



typedef struct _CQ_DB_V1 {
   union {
      struct { 
         u32 qid : 10;                            // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 num_popped : 13;                     // DWORD 0
         u32 rearm : 1;                           // DWORD 0
         u32 irpt : 1;                            // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
      } SG_PACK ; // unnamed struct
      u32 dw; // dword union
   }; // unnamed union
} SG_PACK CQ_DB_V1, *PCQ_DB_V1;

SG_C_ASSERT(__sizeof__CQ_DB, sizeof (CQ_DB_V1) == 4);



typedef struct _ETH_RX_COMPL_V1 {
   union {
      struct { 
         u32 vlan_tag : 16;                       // DWORD 0
         u32 pktsize : 14;                        // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 ip_opt : 1;                          // DWORD 0
         u32 err : 1;                             // DWORD 1
         u32 rsshp : 1;                           // DWORD 1
         u32 ipf : 1;                             // DWORD 1
         u32 tcpf : 1;                            // DWORD 1
         u32 udpf : 1;                            // DWORD 1
         u32 ipcksm : 1;                          // DWORD 1
         u32 l4_cksm : 1;                         // DWORD 1
         u32 ip_version : 1;                      // DWORD 1
         u32 macdst : 7;                          // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 1
         u32 fragndx : 10;                        // DWORD 1
         u32 ct : 2;                              // DWORD 1
         u32 sw : 1;                              // DWORD 1
         u32 numfrags : 3;                        // DWORD 1
         u32 rss_flush : 1;                       // DWORD 2
         u32 cast_enc : 2;                        // DWORD 2
         u32 QnQ : 1;                             // DWORD 2
         u32 rss_bank : 1;                        // DWORD 2
         u32 port : 2;                            // DWORD 2
         u32 vntagp : 1;                          // DWORD 2
         u32 header_len : 8;                      // DWORD 2
         u32 header_split : 2;                    // DWORD 2
         u32 rsvd1 : 13;                          // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 rsshash;                             // DWORD 3
      } SG_PACK ; // unnamed struct
      u32 dw[4]; // dword union
   }; // unnamed union
} SG_PACK ETH_RX_COMPL_V1, *PETH_RX_COMPL_V1;

SG_C_ASSERT(__sizeof__ETH_RX_COMPL, sizeof (ETH_RX_COMPL_V1) == 16);


// --- HEADER_DMA_ENUM ---
#define HEADER_DMA_TO_HEADER_V1         (1)       
#define HEADER_DMA_TO_DATA_V1           (2)       
#define HEADER_DMA_TO_HEADER_AND_DATA_V1 (3)      

// --- HEADER_SPLIT_LOCATION_ENUM ---
#define HEADER_SPLIT_LOCATION_BEFORE_ULP_HEADER_V1 (0) 
#define HEADER_SPLIT_LOCATION_AFTER_ULP_HEADER_V1 (1) 
#define HEADER_SPLIT_LOCATION_FIXED_V1  (2)       

// --- NTWK_RX_FILTER_IF_FLAGS_ENUM ---
#define NTWK_RX_FILTER_IF_PROMISCUOUS_V1 (8)      
#define NTWK_RX_FILTER_IF_BROADCAST_V1  (16)      
#define NTWK_RX_FILTER_IF_UNTAGGED_V1   (32)      
#define NTWK_RX_FILTER_IF_VLAN_PROMISCUOUS_V1 (128) 
#define NTWK_RX_FILTER_IF_MCAST_PROMISCUOUS_V1 (512) 
#define NTWK_RX_FILTER_IF_PASS_L2_ERRORS_V1 (1024) 
#define NTWK_RX_FILTER_IF_PASS_L3L4_ERRORS_V1 (2048) 
#define NTWK_RX_FILTER_IF_MULTICAST_V1  (4096)    
#define NTWK_RX_FILTER_IF_MULTICAST_HASH_V1 (8192) 
#define NTWK_RX_FILTER_IF_HEADER_SPLIT_V1 (16384) 


typedef struct _IOCTL_ETH_RX_CREATE_V1 {
   union {
      struct { 
         IOCTL_HEADER_V1 header;
         union {
            struct {
               UEXACT16 cq_id;
               UEXACT8 frag_size;
               UEXACT8 num_pages;
               PHYS_ADDR_V1 pages[2];
               UEXACT32 interface_id;
               UEXACT16 max_frame_size;
               UEXACT16 rsvd0;
               UEXACT32 rss_queue;
               UEXACT8 header_split;
               UEXACT8 header_dma;
               UEXACT8 split_location;
               UEXACT8 dca;
               UEXACT16 header_size;
               UEXACT16 backfill;
               UEXACT16 fixed_split_location;
               UEXACT16 rsvd1;
            } request;
            struct {
               UEXACT16 id;
               UEXACT8 cpu_id;
               UEXACT8 ep_based_ring;
            } response;
         } params;
      } SG_PACK ; // unnamed struct
      u32 dw[15]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_RX_CREATE_V1, *PIOCTL_ETH_RX_CREATE_V1;

SG_C_ASSERT(__sizeof__IOCTL_ETH_RX_CREATE, sizeof (IOCTL_ETH_RX_CREATE_V1) == 60);



typedef struct _BE2_PORT_RXF_STATS_V1 {
   union {
      struct { 
         u32 rx_bytes_lsd;                        // DWORD 0
         u32 rx_bytes_msd;                        // DWORD 1
         u32 rx_ipv4_bytes_lsd;                   // DWORD 2
         u32 rx_ipv4_bytes_msd;                   // DWORD 3
         u32 rx_ipv6_bytes_lsd;                   // DWORD 4
         u32 rx_ipv6_bytes_msd;                   // DWORD 5
         u32 tx_bytes_lsd;                        // DWORD 6
         u32 tx_bytes_msd;                        // DWORD 7
         u32 rx_total_frames;                     // DWORD 8
         u32 rx_non_switched_unicast_frames;      // DWORD 9
         u32 rx_non_switched_multicast_frames;    // DWORD 10
         u32 rx_non_switched_broadcast_frames;    // DWORD 11
         u32 rx_crc_errors;                       // DWORD 12
         u32 rx_alignment_symbol_errors;          // DWORD 13
         u32 rx_pause_frames;                     // DWORD 14
         u32 rx_priority_pause_frames;            // DWORD 15
         u32 rx_control_frames;                   // DWORD 16
         u32 rx_in_range_errors;                  // DWORD 17
         u32 rx_out_range_errors;                 // DWORD 18
         u32 rx_frame_too_long;                   // DWORD 19
         u32 rx_address_match_errors;             // DWORD 20
         u32 rx_dropped_too_small;                // DWORD 21
         u32 rx_dropped_too_short;                // DWORD 22
         u32 rx_dropped_header_too_small;         // DWORD 23
         u32 rx_dropped_tcp_length;               // DWORD 24
         u32 rx_dropped_runt;                     // DWORD 25
         u32 rx_64_byte_packets;                  // DWORD 26
         u32 rx_65_127_byte_packets;              // DWORD 27
         u32 rx_128_256_byte_packets;             // DWORD 28
         u32 rx_256_511_byte_packets;             // DWORD 29
         u32 rx_512_1023_byte_packets;            // DWORD 30
         u32 rx_1024_1518_byte_packets;           // DWORD 31
         u32 rx_1519_2047_byte_packets;           // DWORD 32
         u32 rx_2048_4095_byte_packets;           // DWORD 33
         u32 rx_4096_8191_byte_packets;           // DWORD 34
         u32 rx_8192_9216_byte_packets;           // DWORD 35
         u32 rx_ip_checksum_errs;                 // DWORD 36
         u32 rx_tcp_checksum_errs;                // DWORD 37
         u32 rx_udp_checksum_errs;                // DWORD 38
         u32 rx_non_rss_packets;                  // DWORD 39
         u32 rx_ipv4_packets;                     // DWORD 40
         u32 rx_ipv6_packets;                     // DWORD 41
         u32 rx_chute1_packets;                   // DWORD 42
         u32 rx_chute2_packets;                   // DWORD 43
         u32 rx_chute3_packets;                   // DWORD 44
         u32 rx_management_packets;               // DWORD 45
         u32 rx_switched_unicast_packets;         // DWORD 46
         u32 rx_switched_multicast_packets;       // DWORD 47
         u32 rx_switched_broadcast_packets;       // DWORD 48
         u32 tx_unicastframes;                    // DWORD 49
         u32 tx_multicastframes;                  // DWORD 50
         u32 tx_broadcastframes;                  // DWORD 51
         u32 tx_pauseframes;                      // DWORD 52
         u32 tx_priority_pauseframes;             // DWORD 53
         u32 tx_controlframes;                    // DWORD 54
         u32 tx_64_byte_packets;                  // DWORD 55
         u32 tx_65_127_byte_packets;              // DWORD 56
         u32 tx_128_256_byte_packets;             // DWORD 57
         u32 tx_256_511_byteb_packets;            // DWORD 58
         u32 tx_512_1023_byte_packets;            // DWORD 59
         u32 tx_1024_1518_byte_packets;           // DWORD 60
         u32 tx_1519_2047_byte_packets;           // DWORD 61
         u32 tx_2048_4095_byte_packets;           // DWORD 62
         u32 tx_4096_8191_byte_packets;           // DWORD 63
         u32 tx_8192_9216_byte_packets;           // DWORD 64
         u32 rxpp_fifo_overflow_drop;             // DWORD 65
         u32 rx_input_fifo_overflow_drop;         // DWORD 66
         u32 pmem_fifo_overflow_drop;             // DWORD 67
         u32 jabber_events;                       // DWORD 68
         u32 vntag_wrong_dir;                     // DWORD 69
         u32 vntag_exceeds_vif;                   // DWORD 70
         u32 vntag_exceeds_vif_list;              // DWORD 71
      } SG_PACK ; // unnamed struct
      u32 dw[72]; // dword union
   }; // unnamed union
} SG_PACK BE2_PORT_RXF_STATS_V1, *PBE2_PORT_RXF_STATS_V1;

SG_C_ASSERT(__sizeof__BE2_PORT_RXF_STATS, sizeof (BE2_PORT_RXF_STATS_V1) == 288);



typedef struct _BE2_FCOE_PORT_STATS_V1 {
   union {
      struct { 
         u32 fcoe_bytes_received_lsd;             // DWORD 0
         u32 fcoe_bytes_received_msd;             // DWORD 1
         u32 rx_drops_payload_size;               // DWORD 2
         u32 rx_drops_crc;                        // DWORD 3
         u32 rx_drops_clipped_header;             // DWORD 4
         u32 fcoe_frames_received;                // DWORD 5
      } SG_PACK ; // unnamed struct
      u32 dw[6]; // dword union
   }; // unnamed union
} SG_PACK BE2_FCOE_PORT_STATS_V1, *PBE2_FCOE_PORT_STATS_V1;

SG_C_ASSERT(__sizeof__BE2_FCOE_PORT_STATS, sizeof (BE2_FCOE_PORT_STATS_V1) == 24);



typedef struct _BE2_RXF_STATS_V1 {
   union {
      struct { 
         BE2_PORT_RXF_STATS_V1 port[4];
         u32 management_rx_port_bytes;            // DWORD 288
         u32 management_tx_port_bytes;            // DWORD 289
         u32 rx_drops_no_pbuf;                    // DWORD 290
         u32 rx_drops_no_txpb;                    // DWORD 291
         u32 rx_drops_no_erx_descr;               // DWORD 292
         u32 rx_drops_no_tpre_descr;              // DWORD 293
         u32 management_rx_port_packets;          // DWORD 294
         u32 management_rx_port_pause_frames;     // DWORD 295
         u32 management_rx_port_errors;           // DWORD 296
         u32 management_tx_port_packets;          // DWORD 297
         u32 management_tx_port_pause;            // DWORD 298
         u32 mgmt_rx_port_pmem_fifo_overflow;     // DWORD 299
         u32 rx_drops_too_many_frags;             // DWORD 300
         u32 rx_drops_invalid_ring;               // DWORD 301
         u32 forwarded_packets;                   // DWORD 302
         u32 rx_drops_mtu;                        // DWORD 303
         u32 mgmt_rx_port_rxpp_fifo_overflow;     // DWORD 304
         u32 rxpp_drops_too_big_for_mgmt;         // DWORD 305
         BE2_FCOE_PORT_STATS_V1 fcoe_port[2];
      } SG_PACK ; // unnamed struct
      u32 dw[318]; // dword union
   }; // unnamed union
} SG_PACK BE2_RXF_STATS_V1, *PBE2_RXF_STATS_V1;

SG_C_ASSERT(__sizeof__BE2_RXF_STATS, sizeof (BE2_RXF_STATS_V1) == 1272);



typedef struct _BE2_TXP_SW_STAT_V1 {
   union {
      struct { 
         u32 packets;                             // DWORD 0
         u32 lsd;                                 // DWORD 1
         u32 msd;                                 // DWORD 2
      } SG_PACK ; // unnamed struct
      u32 dw[3]; // dword union
   }; // unnamed union
} SG_PACK BE2_TXP_SW_STAT_V1, *PBE2_TXP_SW_STAT_V1;

SG_C_ASSERT(__sizeof__BE2_TXP_SW_STAT, sizeof (BE2_TXP_SW_STAT_V1) == 12);



typedef struct _BE2_TXP_SW_COUNTERS_V1 {
   union {
      struct { 
         BE2_TXP_SW_STAT_V1 ct1pt0_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT_V1 ct1pt0_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT_V1 ct1pt0_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT_V1 ct1pt0_rexmt_ipv6_ctrs;
         BE2_TXP_SW_STAT_V1 ct1pt1_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT_V1 ct1pt1_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT_V1 ct1pt1_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT_V1 ct1pt1_rexmt_ipv6_ctrs;
         BE2_TXP_SW_STAT_V1 ct2pt0_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT_V1 ct2pt0_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT_V1 ct2pt0_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT_V1 ct2pt0_rexmt_ipv6_ctrs;
         BE2_TXP_SW_STAT_V1 ct2pt1_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT_V1 ct2pt1_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT_V1 ct2pt1_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT_V1 ct2pt1_rexmt_ipv6_ctrs;
      } SG_PACK ; // unnamed struct
      u32 dw[48]; // dword union
   }; // unnamed union
} SG_PACK BE2_TXP_SW_COUNTERS_V1, *PBE2_TXP_SW_COUNTERS_V1;

SG_C_ASSERT(__sizeof__BE2_TXP_SW_COUNTERS, sizeof (BE2_TXP_SW_COUNTERS_V1) == 192);



typedef struct _BE2_ERX_STATS_V1 {
   union {
      struct { 
         u32 rx_drops_no_fragments[68];           // DWORDS 0 to 67
         u32 debug_wdma_sent_hold;                // DWORD 68
         u32 debug_wdma_pbfree_sent_hold;         // DWORD 69
         u32 debug_wdma_zerobyte_pbfree_sent_hold; // DWORD 70
         u32 debug_pmem_pbuf_dealloc;             // DWORD 71
      } SG_PACK ; // unnamed struct
      u32 dw[72]; // dword union
   }; // unnamed union
} SG_PACK BE2_ERX_STATS_V1, *PBE2_ERX_STATS_V1;

SG_C_ASSERT(__sizeof__BE2_ERX_STATS, sizeof (BE2_ERX_STATS_V1) == 288);



typedef struct _BE2_PMEM_STATS_V1 {
   u32 eth_red_drops;
   u32 lro_red_drops;
   u32 ulp0_red_drops;
   u32 ulp1_red_drops;
   u32 rsvd0;
   u32 global_red_drops;
} SG_PACK BE2_PMEM_STATS_V1, *PBE2_PMEM_STATS_V1;




typedef struct _BE2_EP_STATS_V1 {
   u16 perf_idle_average;
   u16 perf_loading_average;
   u16 perf_busy_average;
   u16 perf_unloading_average;
   u16 perf_wt4bank_average;
   u16 perf_wt4unload_average;
} SG_PACK BE2_EP_STATS_V1, *PBE2_EP_STATS_V1;




typedef struct _MIB_ETH_STATISTICS_PARAMS_IN_V1 {
   UEXACT32 rsvd0;
} SG_PACK MIB_ETH_STATISTICS_PARAMS_IN_V1, *PMIB_ETH_STATISTICS_PARAMS_IN_V1;




typedef struct _BE2_HARDWARE_STATS_V1 {
   union {
      struct { 
         BE2_RXF_STATS_V1 rxf;
         BE2_TXP_SW_COUNTERS_V1 txp;
         BE2_ERX_STATS_V1 erx;
         BE2_PMEM_STATS_V1 pmem;
         BE2_EP_STATS_V1 ep[6];
      } SG_PACK ; // unnamed struct
      u32 dw[462]; // dword union
   }; // unnamed union
} SG_PACK BE2_HARDWARE_STATS_V1, *PBE2_HARDWARE_STATS_V1;

SG_C_ASSERT(__sizeof__BE2_HARDWARE_STATS, sizeof (BE2_HARDWARE_STATS_V1) == 1848);



typedef struct _MIB_ETH_STATISTICS_PARAMS_V1 {
   union {
      union { 
         MIB_ETH_STATISTICS_PARAMS_IN_V1 request;
         BE2_HARDWARE_STATS_V1 response;
      } SG_PACK ; // unnamed struct
      u32 dw[462]; // dword union
   }; // unnamed union
} SG_PACK MIB_ETH_STATISTICS_PARAMS_V1, *PMIB_ETH_STATISTICS_PARAMS_V1;

SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_PARAMS, sizeof (MIB_ETH_STATISTICS_PARAMS_V1) == 1848);



typedef struct _IOCTL_ETH_GET_STATISTICS_V1 {
   union {
      struct { 
         IOCTL_HEADER_V1 header;
         MIB_ETH_STATISTICS_PARAMS_V1 params;
      } SG_PACK ; // unnamed struct
      u32 dw[466]; // dword union
   }; // unnamed union
} SG_PACK IOCTL_ETH_GET_STATISTICS_V1, *PIOCTL_ETH_GET_STATISTICS_V1;

SG_C_ASSERT(__sizeof__IOCTL_ETH_GET_STATISTICS, sizeof (IOCTL_ETH_GET_STATISTICS_V1) == 1864);


// --- DRIVER_FUNCTION_CAPABILITIES_ENUMS ---
#define DRIVER_FUNCTION_CAPABILITY_SW_TIMESTAMPS_V1 (2) 
#define DRIVER_FUNCTION_CAPABILITY_BE3_NATIVE_ERX_API_V1 (4) 


typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V1 {
   UEXACT32 valid_capability_flags;
   UEXACT32 capability_flags;
   UEXACT8 sbz[212];
} SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V1, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V1;




typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V1 {
   UEXACT32 valid_capability_flags;
   UEXACT32 capability_flags;
   UEXACT8 sbz[212];
} SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V1, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V1;




typedef union _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V1 {
   SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V1 request;
   SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V1 response;
} SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V1, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V1;




typedef struct _IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V1 {
   IOCTL_HEADER_V1 header;
   SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V1 params;
} SG_PACK IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V1, *PIOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V1;



// --- SUPPORTED_MODES ---
#define TOE_MODE_V1                     (1)       
#define NIC_MODE_V1                     (2)       
#define RDMA_MODE_V1                    (4)       
#define VM_MODE_V1                      (8)       
#define ISCSI_INI_MODE_V1               (16)      
#define ISCSI_TGT_MODE_V1               (32)      
#define FCOE_INI_MODE_V1                (64)      
#define FCOE_TGT_MODE_V1                (128)     
#define DAL_MODE_V1                     (256)     
#define LRO_MODE_V1                     (512)     
#define FLEX10_MODE_V1                  (1024)    
#define NCSI_MODE_V1                    (2048)    
#define IPV6_MODE_V1                    (4096)    
#define BE2_COMPAT_MODE_V1              (8192)    
#define SRIOV_MODE_V1                   (16384)   
#define INVALID_MODE_V1                 (32768)   
#define BE3_COMPAT_MODE_V1              (65536)   
#define VNIC_MODE_V1                    (131072)  
#define VNTAG_MODE_V1                   (262144)  
#define UMC_MODE_V1                     (524288)  
#define UMC_DEF_EN_V1                   (1048576) 
#define ONE_GB_DEF_EN_V1                (2097152) 
#define VNIC_DEF_VALID_V1               (4194304) 
#define VNIC_DEF_EN_V1                  (8388608) 

// --- FUNCTION_PRIVILEGE_CATEGORY_ENUM ---
#define PRIV_DEFAULT_V1                 (1)       
#define PRIV_LNKQUERY_V1                (2)       
#define PRIV_LNKSTATS_V1                (4)       
#define PRIV_LNKMGMT_V1                 (8)       
#define PRIV_LNKDIAG_V1                 (16)      
#define PRIV_UTILQUERY_V1               (32)      
#define PRIV_FILTMGMT_V1                (64)      
#define PRIV_IFACEMGMT_V1               (128)     
#define PRIV_VHADM_V1                   (256)     
#define PRIV_DEVCFG_V1                  (512)     
#define PRIV_DEVSEC_V1                  (1024)    


typedef struct _GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1 {
   UEXACT32 rsvd0;
} SG_PACK GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1;




typedef struct _GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1 {
   UEXACT32 privilege_mask;
} SG_PACK GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1;




typedef union _GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1 {
   GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1 request;
   GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1 response;
} SG_PACK GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1;




typedef struct _IOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V1 {
   IOCTL_HEADER_V1 header;
   GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1 params;
} SG_PACK IOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V1, *PIOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V1;




#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __be3nic_v1_bmap_h__

