/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */

#ifndef __emul_gen_macros_h__
#define __emul_gen_macros_h__

//
// These macros are the common abstraction interface between the emulation and
// ARM firmware code.  These are required to share the initialization sequence
// code from the "gen" directory.  The shared functions start with BE_Gen_.
//

#ifndef BE_GEN_ASSERT
    #define BE_GEN_ASSERT SA_ASSERT
#endif

#ifndef BE_GEN_C_ASSERT
    #define BE_GEN_C_ASSERT SA_C_ASSERT
#endif

#define BE_GEN_DEBUG_PRINT(_str) \
    TRACE(DL_NOTE,(_str))

#define BE_GEN_WRITE_CTX(_context,_addr,_data,_bytes) \
    _be_mpuemul_write_ctx_mem ((PBE_FUNCTION_OBJECT)_context,_addr,_data,_bytes)

#define BE_GEN_PCI0_READ_ADDR(_context, _addr) \
    BePciCfgRead (((PBE_FUNCTION_OBJECT)_context)->sa_dev, (_addr), SA_DBG_CSTR(#_addr))

#define BE_GEN_PCI0_WRITE_ADDR(_context, _addr, _val) \
    BePciCfgWrite (((PBE_FUNCTION_OBJECT)_context)->sa_dev, (_addr), (_val), SA_DBG_CSTR(#_addr))

#define BE_GEN_CSR_WRITE_ADDR(_context,_addr,_val) \
    BeCsrWrite ((((PBE_FUNCTION_OBJECT)_context)->sa_dev), (_addr), (_val), SA_DBG_CSTR(#_addr))

#define BE_GEN_CSR_READ_ADDR(_context,_addr) \
    BeCsrRead ((((PBE_FUNCTION_OBJECT)_context)->sa_dev), (_addr), SA_DBG_CSTR(#_addr))

#endif // __emul_gen_macros_h__

