/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */

#ifndef __main_ioctl_h__
#define __main_ioctl_h__

enum USER_BECLIB_IOCTL_CODES {
    IOCTL_FUNCOBJ_CREATE = 0, /* Create function object */
    IOCTL_NUM_IOCTLS = 1 /* Number of ioctls supported */
};

#define BECLIB_IOCTL_MAGIC_NO (0xFFFF)

/* Structure definitions */
typedef struct __funcobj_create_io_buf {
    SA_IOCTL_CALL_CONTEXT ioctl_ctx;
    SA_DEV sa_dev;
    CHIPIF_UPCALL upcall;
    BE_FUNCTION_OBJECT function_object;
} funcobj_create_io_buf_t;

typedef struct __beclib_ioctl_info {
    u32 magic_no;
    u32 bufferLength;
} beclib_ioctl_info_t;

/* Macros */
/* Initialize ioctl context */
#define BECLIB_INIT_IOCTL_CALL_CONTEXT(ioctl_ctx, ioctl_func) {         \
    ASSERT(ioctl_func < IOCTL_NUM_IOCTLS);                              \
    sa_memset((PVOID)&ioctl_ctx, 0, sizeof(ioctl_ctx));                 \
    ioctl_ctx.magic = g_ioctl_info[ioctl_func].magic_no;                \
    ioctl_ctx.function = ioctl_func;                                    \
    ioctl_ctx.bufferLength = g_ioctl_info[ioctl_func].bufferLength;     \
}

/* Extern declarations */
extern beclib_ioctl_info_t g_ioctl_info[];

#endif /* __main_ioctl_h__ */
