/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __be_common_bmap_h__
#define __be_common_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "pcicfg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Physical Address.
   #if defined(SG_BMAP_UNION)
      typedef struct _PHYS_ADDR {
         union {
            struct { 
               u32 lo;                            // DWORD 0
               u32 hi;                            // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK PHYS_ADDR, *PPHYS_ADDR;

      SG_C_ASSERT(__sizeof__PHYS_ADDR, sizeof (PHYS_ADDR) == 8);

   #else
      typedef struct _PHYS_ADDR {
         u32 lo;                                  // DWORD 0
         u32 hi;                                  // DWORD 1
      } SG_PACK PHYS_ADDR, *PPHYS_ADDR;

      typedef union _PHYS_ADDR_UNION {
         PHYS_ADDR bits;
         u32 dw[2]; // dword union
      } SG_PACK PHYS_ADDR_UNION, *PPHYS_ADDR_UNION;

      SG_C_ASSERT(__sizeof__PHYS_ADDR_UNION, sizeof (PHYS_ADDR_UNION) == 8);
   #endif


#else
   // Physical Address.
   #if defined(SG_BMAP_UNION)
      typedef struct _PHYS_ADDR {
         union {
            struct { 
               u32 lo;                            // DWORD 0
               u32 hi;                            // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK PHYS_ADDR, *PPHYS_ADDR;

      SG_C_ASSERT(__sizeof__PHYS_ADDR, sizeof (PHYS_ADDR) == 8);

   #else
      typedef struct _PHYS_ADDR {
         u32 lo;                                  // DWORD 0
         u32 hi;                                  // DWORD 1
      } SG_PACK PHYS_ADDR, *PPHYS_ADDR;

      typedef union _PHYS_ADDR_UNION {
         PHYS_ADDR bits;
         u32 dw[2]; // dword union
      } SG_PACK PHYS_ADDR_UNION, *PPHYS_ADDR_UNION;

      SG_C_ASSERT(__sizeof__PHYS_ADDR_UNION, sizeof (PHYS_ADDR_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Virtual Address.
   #if defined(SG_BMAP_UNION)
      typedef struct _VIRT_ADDR {
         union {
            struct { 
               u32 lo;                            // DWORD 0
               u32 hi;                            // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK VIRT_ADDR, *PVIRT_ADDR;

      SG_C_ASSERT(__sizeof__VIRT_ADDR, sizeof (VIRT_ADDR) == 8);

   #else
      typedef struct _VIRT_ADDR {
         u32 lo;                                  // DWORD 0
         u32 hi;                                  // DWORD 1
      } SG_PACK VIRT_ADDR, *PVIRT_ADDR;

      typedef union _VIRT_ADDR_UNION {
         VIRT_ADDR bits;
         u32 dw[2]; // dword union
      } SG_PACK VIRT_ADDR_UNION, *PVIRT_ADDR_UNION;

      SG_C_ASSERT(__sizeof__VIRT_ADDR_UNION, sizeof (VIRT_ADDR_UNION) == 8);
   #endif


#else
   // Virtual Address.
   #if defined(SG_BMAP_UNION)
      typedef struct _VIRT_ADDR {
         union {
            struct { 
               u32 lo;                            // DWORD 0
               u32 hi;                            // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK VIRT_ADDR, *PVIRT_ADDR;

      SG_C_ASSERT(__sizeof__VIRT_ADDR, sizeof (VIRT_ADDR) == 8);

   #else
      typedef struct _VIRT_ADDR {
         u32 lo;                                  // DWORD 0
         u32 hi;                                  // DWORD 1
      } SG_PACK VIRT_ADDR, *PVIRT_ADDR;

      typedef union _VIRT_ADDR_UNION {
         VIRT_ADDR bits;
         u32 dw[2]; // dword union
      } SG_PACK VIRT_ADDR_UNION, *PVIRT_ADDR_UNION;

      SG_C_ASSERT(__sizeof__VIRT_ADDR_UNION, sizeof (VIRT_ADDR_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Scatter gather element.
   #if defined(SG_BMAP_UNION)
      typedef struct _SGE {
         union {
            struct { 
               u32 addr_lo;                       // DWORD 0
               u32 addr_hi;                       // DWORD 1
               u32 rsvd0[1];                      // DWORDS 2 to 2
               u32 rsvd1 : 16;                    // DWORD 3
               u32 len : 16;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK SGE, *PSGE;

      SG_C_ASSERT(__sizeof__SGE, sizeof (SGE) == 16);

   #else
      typedef struct _SGE {
         u32 addr_lo;                             // DWORD 0
         u32 addr_hi;                             // DWORD 1
         u32 rsvd0[1];                            // DWORDS 2 to 2
         u32 rsvd1 : 16;                          // DWORD 3
         u32 len : 16;                            // DWORD 3
      } SG_PACK SGE, *PSGE;

      typedef union _SGE_UNION {
         SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK SGE_UNION, *PSGE_UNION;

      SG_C_ASSERT(__sizeof__SGE_UNION, sizeof (SGE_UNION) == 16);
   #endif


#else
   // Scatter gather element.
   #if defined(SG_BMAP_UNION)
      typedef struct _SGE {
         union {
            struct { 
               u32 addr_lo;                       // DWORD 0
               u32 addr_hi;                       // DWORD 1
               u32 rsvd0[1];                      // DWORDS 2 to 2
               u32 len : 16;                      // DWORD 3
               u32 rsvd1 : 16;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK SGE, *PSGE;

      SG_C_ASSERT(__sizeof__SGE, sizeof (SGE) == 16);

   #else
      typedef struct _SGE {
         u32 addr_lo;                             // DWORD 0
         u32 addr_hi;                             // DWORD 1
         u32 rsvd0[1];                            // DWORDS 2 to 2
         u32 len : 16;                            // DWORD 3
         u32 rsvd1 : 16;                          // DWORD 3
      } SG_PACK SGE, *PSGE;

      typedef union _SGE_UNION {
         SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK SGE_UNION, *PSGE_UNION;

      SG_C_ASSERT(__sizeof__SGE_UNION, sizeof (SGE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // STAG.
   #if defined(SG_BMAP_UNION)
      typedef struct _STAG_D {
         union {
            struct { 
               u32 idx : 24;                      // DWORD 0
               u32 key : 8;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK STAG_D, *PSTAG_D;

      SG_C_ASSERT(__sizeof__STAG_D, sizeof (STAG_D) == 4);

   #else
      typedef struct _STAG_D {
         u32 idx : 24;                            // DWORD 0
         u32 key : 8;                             // DWORD 0
      } SG_PACK STAG_D, *PSTAG_D;

      typedef union _STAG_D_UNION {
         STAG_D bits;
         u32 dw; // dword union
      } SG_PACK STAG_D_UNION, *PSTAG_D_UNION;

      SG_C_ASSERT(__sizeof__STAG_D_UNION, sizeof (STAG_D_UNION) == 4);
   #endif


#else
   // STAG.
   #if defined(SG_BMAP_UNION)
      typedef struct _STAG_D {
         union {
            struct { 
               u32 key : 8;                       // DWORD 0
               u32 idx : 24;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK STAG_D, *PSTAG_D;

      SG_C_ASSERT(__sizeof__STAG_D, sizeof (STAG_D) == 4);

   #else
      typedef struct _STAG_D {
         u32 key : 8;                             // DWORD 0
         u32 idx : 24;                            // DWORD 0
      } SG_PACK STAG_D, *PSTAG_D;

      typedef union _STAG_D_UNION {
         STAG_D bits;
         u32 dw; // dword union
      } SG_PACK STAG_D_UNION, *PSTAG_D_UNION;

      SG_C_ASSERT(__sizeof__STAG_D_UNION, sizeof (STAG_D_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Protection Entry. This structure defines access rights to a memory region
   #if defined(SG_BMAP_UNION)
      typedef struct _PE {
         union {
            struct { 
               u32 pdid_or_qpid : 16;             // DWORD 0
               u32 reference_count : 16;          // DWORD 0
               u32 page_size : 8;                 // DWORD 1
               u32 rsvd2 : 4;                     // DWORD 1
               u32 rights : 4;                    // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 1
               u32 zero_based_TO : 1;             // DWORD 1
               u32 bind_enabled : 1;              // DWORD 1
               u32 memory_region : 1;             // DWORD 1
               u32 physical : 1;                  // DWORD 1
               u32 rsvd0 : 3;                     // DWORD 1
               u32 valid : 1;                     // DWORD 1
               STAG_D stag;
               u32 length;                        // DWORD 3
               VIRT_ADDR virt_address;
               PHYS_ADDR phys_address;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK PE, *PPE;

      SG_C_ASSERT(__sizeof__PE, sizeof (PE) == 32);

   #else
      typedef struct _PE {
         u32 pdid_or_qpid : 16;                   // DWORD 0
         u32 reference_count : 16;                // DWORD 0
         u32 page_size : 8;                       // DWORD 1
         u32 rsvd2 : 4;                           // DWORD 1
         u32 rights : 4;                          // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
         u32 zero_based_TO : 1;                   // DWORD 1
         u32 bind_enabled : 1;                    // DWORD 1
         u32 memory_region : 1;                   // DWORD 1
         u32 physical : 1;                        // DWORD 1
         u32 rsvd0 : 3;                           // DWORD 1
         u32 valid : 1;                           // DWORD 1
         STAG_D stag;
         u32 length;                              // DWORD 3
         VIRT_ADDR virt_address;
         PHYS_ADDR phys_address;
      } SG_PACK PE, *PPE;

      typedef union _PE_UNION {
         PE bits;
         u32 dw[8]; // dword union
      } SG_PACK PE_UNION, *PPE_UNION;

      SG_C_ASSERT(__sizeof__PE_UNION, sizeof (PE_UNION) == 32);
   #endif


#else
   // Protection Entry. This structure defines access rights to a memory region
   #if defined(SG_BMAP_UNION)
      typedef struct _PE {
         union {
            struct { 
               u32 reference_count : 16;          // DWORD 0
               u32 pdid_or_qpid : 16;             // DWORD 0
               u32 valid : 1;                     // DWORD 1
               u32 rsvd0 : 3;                     // DWORD 1
               u32 physical : 1;                  // DWORD 1
               u32 memory_region : 1;             // DWORD 1
               u32 bind_enabled : 1;              // DWORD 1
               u32 zero_based_TO : 1;             // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 1
               u32 rights : 4;                    // DWORD 1
               u32 rsvd2 : 4;                     // DWORD 1
               u32 page_size : 8;                 // DWORD 1
               STAG_D stag;
               u32 length;                        // DWORD 3
               VIRT_ADDR virt_address;
               PHYS_ADDR phys_address;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK PE, *PPE;

      SG_C_ASSERT(__sizeof__PE, sizeof (PE) == 32);

   #else
      typedef struct _PE {
         u32 reference_count : 16;                // DWORD 0
         u32 pdid_or_qpid : 16;                   // DWORD 0
         u32 valid : 1;                           // DWORD 1
         u32 rsvd0 : 3;                           // DWORD 1
         u32 physical : 1;                        // DWORD 1
         u32 memory_region : 1;                   // DWORD 1
         u32 bind_enabled : 1;                    // DWORD 1
         u32 zero_based_TO : 1;                   // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
         u32 rights : 4;                          // DWORD 1
         u32 rsvd2 : 4;                           // DWORD 1
         u32 page_size : 8;                       // DWORD 1
         STAG_D stag;
         u32 length;                              // DWORD 3
         VIRT_ADDR virt_address;
         PHYS_ADDR phys_address;
      } SG_PACK PE, *PPE;

      typedef union _PE_UNION {
         PE bits;
         u32 dw[8]; // dword union
      } SG_PACK PE_UNION, *PPE_UNION;

      SG_C_ASSERT(__sizeof__PE_UNION, sizeof (PE_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Translation Entry. This structure defines a list of physical addresses (PBL -
   // physical buffer list).
   #if defined(SG_BMAP_UNION)
      typedef struct _TE {
         union {
            struct { 
               PHYS_ADDR phys_address;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TE, *PTE;

      SG_C_ASSERT(__sizeof__TE, sizeof (TE) == 8);

   #else
      typedef struct _TE {
         PHYS_ADDR phys_address;
      } SG_PACK TE, *PTE;

      typedef union _TE_UNION {
         TE bits;
         u32 dw[2]; // dword union
      } SG_PACK TE_UNION, *PTE_UNION;

      SG_C_ASSERT(__sizeof__TE_UNION, sizeof (TE_UNION) == 8);
   #endif


#else
   // Translation Entry. This structure defines a list of physical addresses (PBL -
   // physical buffer list).
   #if defined(SG_BMAP_UNION)
      typedef struct _TE {
         union {
            struct { 
               PHYS_ADDR phys_address;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TE, *PTE;

      SG_C_ASSERT(__sizeof__TE, sizeof (TE) == 8);

   #else
      typedef struct _TE {
         PHYS_ADDR phys_address;
      } SG_PACK TE, *PTE;

      typedef union _TE_UNION {
         TE bits;
         u32 dw[2]; // dword union
      } SG_PACK TE_UNION, *PTE_UNION;

      SG_C_ASSERT(__sizeof__TE_UNION, sizeof (TE_UNION) == 8);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __be_common_bmap_h__

