/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __btlr_bmap_h__
#define __btlr_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Signals used to control the btlr. Default is all zeros, which indicates no masked
   // bits (i.e. full usage).
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_CTRL0 {
         union {
            struct { 
               u32 btlr_opaque_mask : 4;          // DWORD 0
               u32 btlr_cid_mask : 4;             // DWORD 0
               u32 stall_update_processing : 1;   // DWORD 0
               u32 stall_dbell_processing : 1;    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 btlr_indx_mask : 4;            // DWORD 0
               u32 btlr_ignore_pdid : 1;          // DWORD 0
               u32 btlr_ignore_fid : 1;           // DWORD 0
               u32 btlr_ignore_partial_fid : 1;   // DWORD 0
               u32 btlr_csrdbg_memsel : 2;        // DWORD 0
               u32 btlr_csrdbg_enable : 1;        // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_CTRL0, *PBTLR_CTRL0;

      SG_C_ASSERT(__sizeof__BTLR_CTRL0, sizeof (BTLR_CTRL0) == 4);

   #else
      typedef struct _BTLR_CTRL0 {
         u32 btlr_opaque_mask : 4;                // DWORD 0
         u32 btlr_cid_mask : 4;                   // DWORD 0
         u32 stall_update_processing : 1;         // DWORD 0
         u32 stall_dbell_processing : 1;          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 btlr_indx_mask : 4;                  // DWORD 0
         u32 btlr_ignore_pdid : 1;                // DWORD 0
         u32 btlr_ignore_fid : 1;                 // DWORD 0
         u32 btlr_ignore_partial_fid : 1;         // DWORD 0
         u32 btlr_csrdbg_memsel : 2;              // DWORD 0
         u32 btlr_csrdbg_enable : 1;              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK BTLR_CTRL0, *PBTLR_CTRL0;

      typedef union _BTLR_CTRL0_UNION {
         BTLR_CTRL0 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_CTRL0_UNION, *PBTLR_CTRL0_UNION;

      SG_C_ASSERT(__sizeof__BTLR_CTRL0_UNION, sizeof (BTLR_CTRL0_UNION) == 4);
   #endif


#else
   // Signals used to control the btlr. Default is all zeros, which indicates no masked
   // bits (i.e. full usage).
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_CTRL0 {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 btlr_csrdbg_enable : 1;        // DWORD 0
               u32 btlr_csrdbg_memsel : 2;        // DWORD 0
               u32 btlr_ignore_partial_fid : 1;   // DWORD 0
               u32 btlr_ignore_fid : 1;           // DWORD 0
               u32 btlr_ignore_pdid : 1;          // DWORD 0
               u32 btlr_indx_mask : 4;            // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 stall_dbell_processing : 1;    // DWORD 0
               u32 stall_update_processing : 1;   // DWORD 0
               u32 btlr_cid_mask : 4;             // DWORD 0
               u32 btlr_opaque_mask : 4;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_CTRL0, *PBTLR_CTRL0;

      SG_C_ASSERT(__sizeof__BTLR_CTRL0, sizeof (BTLR_CTRL0) == 4);

   #else
      typedef struct _BTLR_CTRL0 {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 btlr_csrdbg_enable : 1;              // DWORD 0
         u32 btlr_csrdbg_memsel : 2;              // DWORD 0
         u32 btlr_ignore_partial_fid : 1;         // DWORD 0
         u32 btlr_ignore_fid : 1;                 // DWORD 0
         u32 btlr_ignore_pdid : 1;                // DWORD 0
         u32 btlr_indx_mask : 4;                  // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 stall_dbell_processing : 1;          // DWORD 0
         u32 stall_update_processing : 1;         // DWORD 0
         u32 btlr_cid_mask : 4;                   // DWORD 0
         u32 btlr_opaque_mask : 4;                // DWORD 0
      } SG_PACK BTLR_CTRL0, *PBTLR_CTRL0;

      typedef union _BTLR_CTRL0_UNION {
         BTLR_CTRL0 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_CTRL0_UNION, *PBTLR_CTRL0_UNION;

      SG_C_ASSERT(__sizeof__BTLR_CTRL0_UNION, sizeof (BTLR_CTRL0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Signals used to control the btlr. Default is all zeros, which indicates no masked
   // bits (i.e. full usage). See individual field descriptions for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_CTRL1 {
         union {
            struct { 
               u32 btlr_base_offset : 16;         // DWORD 0
               u32 btlr_be : 8;                   // DWORD 0
               u32 btlr_stride : 4;               // DWORD 0
               u32 btlr_report_update_cid_oor : 1; // DWORD 0
               u32 btlr_pd0_promiscuous : 1;      // DWORD 0
               u32 btlr_check_numpost : 1;        // DWORD 0
               u32 btlr_ring : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_CTRL1, *PBTLR_CTRL1;

      SG_C_ASSERT(__sizeof__BTLR_CTRL1, sizeof (BTLR_CTRL1) == 4);

   #else
      typedef struct _BTLR_CTRL1 {
         u32 btlr_base_offset : 16;               // DWORD 0
         u32 btlr_be : 8;                         // DWORD 0
         u32 btlr_stride : 4;                     // DWORD 0
         u32 btlr_report_update_cid_oor : 1;      // DWORD 0
         u32 btlr_pd0_promiscuous : 1;            // DWORD 0
         u32 btlr_check_numpost : 1;              // DWORD 0
         u32 btlr_ring : 1;                       // DWORD 0
      } SG_PACK BTLR_CTRL1, *PBTLR_CTRL1;

      typedef union _BTLR_CTRL1_UNION {
         BTLR_CTRL1 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_CTRL1_UNION, *PBTLR_CTRL1_UNION;

      SG_C_ASSERT(__sizeof__BTLR_CTRL1_UNION, sizeof (BTLR_CTRL1_UNION) == 4);
   #endif


#else
   // Signals used to control the btlr. Default is all zeros, which indicates no masked
   // bits (i.e. full usage). See individual field descriptions for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_CTRL1 {
         union {
            struct { 
               u32 btlr_ring : 1;                 // DWORD 0
               u32 btlr_check_numpost : 1;        // DWORD 0
               u32 btlr_pd0_promiscuous : 1;      // DWORD 0
               u32 btlr_report_update_cid_oor : 1; // DWORD 0
               u32 btlr_stride : 4;               // DWORD 0
               u32 btlr_be : 8;                   // DWORD 0
               u32 btlr_base_offset : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_CTRL1, *PBTLR_CTRL1;

      SG_C_ASSERT(__sizeof__BTLR_CTRL1, sizeof (BTLR_CTRL1) == 4);

   #else
      typedef struct _BTLR_CTRL1 {
         u32 btlr_ring : 1;                       // DWORD 0
         u32 btlr_check_numpost : 1;              // DWORD 0
         u32 btlr_pd0_promiscuous : 1;            // DWORD 0
         u32 btlr_report_update_cid_oor : 1;      // DWORD 0
         u32 btlr_stride : 4;                     // DWORD 0
         u32 btlr_be : 8;                         // DWORD 0
         u32 btlr_base_offset : 16;               // DWORD 0
      } SG_PACK BTLR_CTRL1, *PBTLR_CTRL1;

      typedef union _BTLR_CTRL1_UNION {
         BTLR_CTRL1 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_CTRL1_UNION, *PBTLR_CTRL1_UNION;

      SG_C_ASSERT(__sizeof__BTLR_CTRL1_UNION, sizeof (BTLR_CTRL1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Signals used to control which CID range is valid for this instance of this doorbell.
   // Default is all zeros, which indicates no masked bits (i.e. full usage).
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_CTRL2 {
         union {
            struct { 
               u32 btlr_cid_end : 16;             // DWORD 0
               u32 btlr_cid_start : 16;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_CTRL2, *PBTLR_CTRL2;

      SG_C_ASSERT(__sizeof__BTLR_CTRL2, sizeof (BTLR_CTRL2) == 4);

   #else
      typedef struct _BTLR_CTRL2 {
         u32 btlr_cid_end : 16;                   // DWORD 0
         u32 btlr_cid_start : 16;                 // DWORD 0
      } SG_PACK BTLR_CTRL2, *PBTLR_CTRL2;

      typedef union _BTLR_CTRL2_UNION {
         BTLR_CTRL2 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_CTRL2_UNION, *PBTLR_CTRL2_UNION;

      SG_C_ASSERT(__sizeof__BTLR_CTRL2_UNION, sizeof (BTLR_CTRL2_UNION) == 4);
   #endif


#else
   // Signals used to control which CID range is valid for this instance of this doorbell.
   // Default is all zeros, which indicates no masked bits (i.e. full usage).
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_CTRL2 {
         union {
            struct { 
               u32 btlr_cid_start : 16;           // DWORD 0
               u32 btlr_cid_end : 16;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_CTRL2, *PBTLR_CTRL2;

      SG_C_ASSERT(__sizeof__BTLR_CTRL2, sizeof (BTLR_CTRL2) == 4);

   #else
      typedef struct _BTLR_CTRL2 {
         u32 btlr_cid_start : 16;                 // DWORD 0
         u32 btlr_cid_end : 16;                   // DWORD 0
      } SG_PACK BTLR_CTRL2, *PBTLR_CTRL2;

      typedef union _BTLR_CTRL2_UNION {
         BTLR_CTRL2 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_CTRL2_UNION, *PBTLR_CTRL2_UNION;

      SG_C_ASSERT(__sizeof__BTLR_CTRL2_UNION, sizeof (BTLR_CTRL2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control signal to enable the ALT functionality.
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_CTRL3 {
         union {
            struct { 
               u32 rsvd0 : 25;                    // DWORD 0
               u32 alt_bitloc : 5;                // DWORD 0
               u32 alt_force : 1;                 // DWORD 0
               u32 alt_en : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_CTRL3, *PBTLR_CTRL3;

      SG_C_ASSERT(__sizeof__BTLR_CTRL3, sizeof (BTLR_CTRL3) == 4);

   #else
      typedef struct _BTLR_CTRL3 {
         u32 rsvd0 : 25;                          // DWORD 0
         u32 alt_bitloc : 5;                      // DWORD 0
         u32 alt_force : 1;                       // DWORD 0
         u32 alt_en : 1;                          // DWORD 0
      } SG_PACK BTLR_CTRL3, *PBTLR_CTRL3;

      typedef union _BTLR_CTRL3_UNION {
         BTLR_CTRL3 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_CTRL3_UNION, *PBTLR_CTRL3_UNION;

      SG_C_ASSERT(__sizeof__BTLR_CTRL3_UNION, sizeof (BTLR_CTRL3_UNION) == 4);
   #endif


#else
   // Control signal to enable the ALT functionality.
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_CTRL3 {
         union {
            struct { 
               u32 alt_en : 1;                    // DWORD 0
               u32 alt_force : 1;                 // DWORD 0
               u32 alt_bitloc : 5;                // DWORD 0
               u32 rsvd0 : 25;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_CTRL3, *PBTLR_CTRL3;

      SG_C_ASSERT(__sizeof__BTLR_CTRL3, sizeof (BTLR_CTRL3) == 4);

   #else
      typedef struct _BTLR_CTRL3 {
         u32 alt_en : 1;                          // DWORD 0
         u32 alt_force : 1;                       // DWORD 0
         u32 alt_bitloc : 5;                      // DWORD 0
         u32 rsvd0 : 25;                          // DWORD 0
      } SG_PACK BTLR_CTRL3, *PBTLR_CTRL3;

      typedef union _BTLR_CTRL3_UNION {
         BTLR_CTRL3 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_CTRL3_UNION, *PBTLR_CTRL3_UNION;

      SG_C_ASSERT(__sizeof__BTLR_CTRL3_UNION, sizeof (BTLR_CTRL3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Contains information on why, and who may have caused a doorbell protection
   // violation. If no violation is pending, this is the live value of the Raw Doorbell
   // values.
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_VIOLATION0 {
         union {
            struct { 
               u32 btlr_violate_valid : 1;        // DWORD 0
               u32 btlr_violate_reason : 3;       // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 0
               u32 btlr_violate_fdid : 8;         // DWORD 0
               u32 btlr_violate_pdid : 9;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_VIOLATION0, *PBTLR_VIOLATION0;

      SG_C_ASSERT(__sizeof__BTLR_VIOLATION0, sizeof (BTLR_VIOLATION0) == 4);

   #else
      typedef struct _BTLR_VIOLATION0 {
         u32 btlr_violate_valid : 1;              // DWORD 0
         u32 btlr_violate_reason : 3;             // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 0
         u32 btlr_violate_fdid : 8;               // DWORD 0
         u32 btlr_violate_pdid : 9;               // DWORD 0
      } SG_PACK BTLR_VIOLATION0, *PBTLR_VIOLATION0;

      typedef union _BTLR_VIOLATION0_UNION {
         BTLR_VIOLATION0 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_VIOLATION0_UNION, *PBTLR_VIOLATION0_UNION;

      SG_C_ASSERT(__sizeof__BTLR_VIOLATION0_UNION, sizeof (BTLR_VIOLATION0_UNION) == 4);
   #endif


#else
   // Contains information on why, and who may have caused a doorbell protection
   // violation. If no violation is pending, this is the live value of the Raw Doorbell
   // values.
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_VIOLATION0 {
         union {
            struct { 
               u32 btlr_violate_pdid : 9;         // DWORD 0
               u32 btlr_violate_fdid : 8;         // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 btlr_violate_reason : 3;       // DWORD 0
               u32 btlr_violate_valid : 1;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_VIOLATION0, *PBTLR_VIOLATION0;

      SG_C_ASSERT(__sizeof__BTLR_VIOLATION0, sizeof (BTLR_VIOLATION0) == 4);

   #else
      typedef struct _BTLR_VIOLATION0 {
         u32 btlr_violate_pdid : 9;               // DWORD 0
         u32 btlr_violate_fdid : 8;               // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 btlr_violate_reason : 3;             // DWORD 0
         u32 btlr_violate_valid : 1;              // DWORD 0
      } SG_PACK BTLR_VIOLATION0, *PBTLR_VIOLATION0;

      typedef union _BTLR_VIOLATION0_UNION {
         BTLR_VIOLATION0 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_VIOLATION0_UNION, *PBTLR_VIOLATION0_UNION;

      SG_C_ASSERT(__sizeof__BTLR_VIOLATION0_UNION, sizeof (BTLR_VIOLATION0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Contains information on why, and who may have caused a doorbell protection
   // violation. Specifically it contains data written to the doorbell when the violation
   // occurred. If no violation is pending, this is the live value of the Raw Doorbell
   // values.
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_VIOLATION1 {
         union {
            struct { 
               u32 btlr_violate_data;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_VIOLATION1, *PBTLR_VIOLATION1;

      SG_C_ASSERT(__sizeof__BTLR_VIOLATION1, sizeof (BTLR_VIOLATION1) == 4);

   #else
      typedef struct _BTLR_VIOLATION1 {
         u32 btlr_violate_data;                   // DWORD 0
      } SG_PACK BTLR_VIOLATION1, *PBTLR_VIOLATION1;

      typedef union _BTLR_VIOLATION1_UNION {
         BTLR_VIOLATION1 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_VIOLATION1_UNION, *PBTLR_VIOLATION1_UNION;

      SG_C_ASSERT(__sizeof__BTLR_VIOLATION1_UNION, sizeof (BTLR_VIOLATION1_UNION) == 4);
   #endif


#else
   // Contains information on why, and who may have caused a doorbell protection
   // violation. Specifically it contains data written to the doorbell when the violation
   // occurred. If no violation is pending, this is the live value of the Raw Doorbell
   // values.
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_VIOLATION1 {
         union {
            struct { 
               u32 btlr_violate_data;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_VIOLATION1, *PBTLR_VIOLATION1;

      SG_C_ASSERT(__sizeof__BTLR_VIOLATION1, sizeof (BTLR_VIOLATION1) == 4);

   #else
      typedef struct _BTLR_VIOLATION1 {
         u32 btlr_violate_data;                   // DWORD 0
      } SG_PACK BTLR_VIOLATION1, *PBTLR_VIOLATION1;

      typedef union _BTLR_VIOLATION1_UNION {
         BTLR_VIOLATION1 bits;
         u32 dw; // dword union
      } SG_PACK BTLR_VIOLATION1_UNION, *PBTLR_VIOLATION1_UNION;

      SG_C_ASSERT(__sizeof__BTLR_VIOLATION1_UNION, sizeof (BTLR_VIOLATION1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of internal state of BTLR. Writing to this register causes sticky overflow
   // bits to clear.
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_DEBUG {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 proc_post_overflow : 1;        // DWORD 0
               u32 proc_post_underflow : 1;       // DWORD 0
               u32 dbell_post_overflow : 1;       // DWORD 0
               u32 dbell_post_underflow : 1;      // DWORD 0
               u32 update_fifo_pop_count : 4;     // DWORD 0
               u32 dbell_fifo_pop_count : 4;      // DWORD 0
               u32 procl_post_numfilled : 4;      // DWORD 0
               u32 dbell_post_numfilled : 4;      // DWORD 0
               u32 btlr_downstream_credit : 3;    // DWORD 0
               u32 btlr_state : 5;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_DEBUG, *PBTLR_DEBUG;

      SG_C_ASSERT(__sizeof__BTLR_DEBUG, sizeof (BTLR_DEBUG) == 4);

   #else
      typedef struct _BTLR_DEBUG {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 proc_post_overflow : 1;              // DWORD 0
         u32 proc_post_underflow : 1;             // DWORD 0
         u32 dbell_post_overflow : 1;             // DWORD 0
         u32 dbell_post_underflow : 1;            // DWORD 0
         u32 update_fifo_pop_count : 4;           // DWORD 0
         u32 dbell_fifo_pop_count : 4;            // DWORD 0
         u32 procl_post_numfilled : 4;            // DWORD 0
         u32 dbell_post_numfilled : 4;            // DWORD 0
         u32 btlr_downstream_credit : 3;          // DWORD 0
         u32 btlr_state : 5;                      // DWORD 0
      } SG_PACK BTLR_DEBUG, *PBTLR_DEBUG;

      typedef union _BTLR_DEBUG_UNION {
         BTLR_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK BTLR_DEBUG_UNION, *PBTLR_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__BTLR_DEBUG_UNION, sizeof (BTLR_DEBUG_UNION) == 4);
   #endif


#else
   // Debug of internal state of BTLR. Writing to this register causes sticky overflow
   // bits to clear.
   #if defined(SG_BMAP_UNION)
      typedef struct _BTLR_DEBUG {
         union {
            struct { 
               u32 btlr_state : 5;                // DWORD 0
               u32 btlr_downstream_credit : 3;    // DWORD 0
               u32 dbell_post_numfilled : 4;      // DWORD 0
               u32 procl_post_numfilled : 4;      // DWORD 0
               u32 dbell_fifo_pop_count : 4;      // DWORD 0
               u32 update_fifo_pop_count : 4;     // DWORD 0
               u32 dbell_post_underflow : 1;      // DWORD 0
               u32 dbell_post_overflow : 1;       // DWORD 0
               u32 proc_post_underflow : 1;       // DWORD 0
               u32 proc_post_overflow : 1;        // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK BTLR_DEBUG, *PBTLR_DEBUG;

      SG_C_ASSERT(__sizeof__BTLR_DEBUG, sizeof (BTLR_DEBUG) == 4);

   #else
      typedef struct _BTLR_DEBUG {
         u32 btlr_state : 5;                      // DWORD 0
         u32 btlr_downstream_credit : 3;          // DWORD 0
         u32 dbell_post_numfilled : 4;            // DWORD 0
         u32 procl_post_numfilled : 4;            // DWORD 0
         u32 dbell_fifo_pop_count : 4;            // DWORD 0
         u32 update_fifo_pop_count : 4;           // DWORD 0
         u32 dbell_post_underflow : 1;            // DWORD 0
         u32 dbell_post_overflow : 1;             // DWORD 0
         u32 proc_post_underflow : 1;             // DWORD 0
         u32 proc_post_overflow : 1;              // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK BTLR_DEBUG, *PBTLR_DEBUG;

      typedef union _BTLR_DEBUG_UNION {
         BTLR_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK BTLR_DEBUG_UNION, *PBTLR_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__BTLR_DEBUG_UNION, sizeof (BTLR_DEBUG_UNION) == 4);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __btlr_bmap_h__

