/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __common_context_bmap_h__
#define __common_context_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // This is the ring context structure. Each ring uses either this or the extended
   // version below.
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CONTEXT_CORE {
         union {
            struct { 
               u32 pdid_valid_n : 1;              // DWORD 0
               u32 pdid : 15;                     // DWORD 0
               u32 prod_index : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RING_CONTEXT_CORE, *PRING_CONTEXT_CORE;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_CORE, sizeof (RING_CONTEXT_CORE) == 4);

   #else
      typedef struct _RING_CONTEXT_CORE {
         u32 pdid_valid_n : 1;                    // DWORD 0
         u32 pdid : 15;                           // DWORD 0
         u32 prod_index : 16;                     // DWORD 0
      } SG_PACK RING_CONTEXT_CORE, *PRING_CONTEXT_CORE;

      typedef union _RING_CONTEXT_CORE_UNION {
         RING_CONTEXT_CORE bits;
         u32 dw; // dword union
      } SG_PACK RING_CONTEXT_CORE_UNION, *PRING_CONTEXT_CORE_UNION;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_CORE_UNION, sizeof (RING_CONTEXT_CORE_UNION) == 4);
   #endif


#else
   // This is the ring context structure. Each ring uses either this or the extended
   // version below.
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CONTEXT_CORE {
         union {
            struct { 
               u32 prod_index : 16;               // DWORD 0
               u32 pdid : 15;                     // DWORD 0
               u32 pdid_valid_n : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RING_CONTEXT_CORE, *PRING_CONTEXT_CORE;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_CORE, sizeof (RING_CONTEXT_CORE) == 4);

   #else
      typedef struct _RING_CONTEXT_CORE {
         u32 prod_index : 16;                     // DWORD 0
         u32 pdid : 15;                           // DWORD 0
         u32 pdid_valid_n : 1;                    // DWORD 0
      } SG_PACK RING_CONTEXT_CORE, *PRING_CONTEXT_CORE;

      typedef union _RING_CONTEXT_CORE_UNION {
         RING_CONTEXT_CORE bits;
         u32 dw; // dword union
      } SG_PACK RING_CONTEXT_CORE_UNION, *PRING_CONTEXT_CORE_UNION;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_CORE_UNION, sizeof (RING_CONTEXT_CORE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the extended ring context structure. Each ring uses either the RING_CONTEXT
   // structure of this extended version. If this structure is padded to 8 bytes using
   // static fields, context memory can be written on 8 byte boundaries, allowing faster
   // CTX access. If the padding is not static, context memory must be written using a
   // read-modified-write, which is less efficient. The BTLR_CTRL1 register controls the
   // write back behavior of this structure with the btlr_be bit field. 
   typedef struct _RING_CONTEXT_EXT {
      RING_CONTEXT_CORE core;
      u32 ring_size : 4;                          // DWORD 1
      u32 con_index : 16;                         // DWORD 1
   } SG_PACK RING_CONTEXT_EXT, *PRING_CONTEXT_EXT;



#else
   // This is the extended ring context structure. Each ring uses either the RING_CONTEXT
   // structure of this extended version. If this structure is padded to 8 bytes using
   // static fields, context memory can be written on 8 byte boundaries, allowing faster
   // CTX access. If the padding is not static, context memory must be written using a
   // read-modified-write, which is less efficient. The BTLR_CTRL1 register controls the
   // write back behavior of this structure with the btlr_be bit field. 
   typedef struct _RING_CONTEXT_EXT {
      RING_CONTEXT_CORE core;
      u32 con_index : 16;                         // DWORD 1
      u32 ring_size : 4;                          // DWORD 1
   } SG_PACK RING_CONTEXT_EXT, *PRING_CONTEXT_EXT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the extended ring context structure. Each ring uses either the RING_CONTEXT
   // structure of this extended version. If this structure is padded to 8 bytes using
   // static fields, context memory can be written on 8 byte boundaries, allowing faster
   // CTX access. If the padding is not static, context memory must be written using a
   // read-modified-write, which is less efficient. The BTLR_CTRL1 register controls the
   // write back behavior of this structure with the btlr_be bit field. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CONTEXT_EXT_REV {
         union {
            struct { 
               u32 rsvd1 : 8;                     // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 ring_size : 4;                 // DWORD 0
               u32 con_index : 16;                // DWORD 0
               RING_CONTEXT_CORE core;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RING_CONTEXT_EXT_REV, *PRING_CONTEXT_EXT_REV;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_EXT_REV, sizeof (RING_CONTEXT_EXT_REV) == 8);

   #else
      typedef struct _RING_CONTEXT_EXT_REV {
         u32 rsvd1 : 8;                           // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 con_index : 16;                      // DWORD 0
         RING_CONTEXT_CORE core;
      } SG_PACK RING_CONTEXT_EXT_REV, *PRING_CONTEXT_EXT_REV;

      typedef union _RING_CONTEXT_EXT_REV_UNION {
         RING_CONTEXT_EXT_REV bits;
         u32 dw[2]; // dword union
      } SG_PACK RING_CONTEXT_EXT_REV_UNION, *PRING_CONTEXT_EXT_REV_UNION;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_EXT_REV_UNION, sizeof (RING_CONTEXT_EXT_REV_UNION) == 8);
   #endif


#else
   // This is the extended ring context structure. Each ring uses either the RING_CONTEXT
   // structure of this extended version. If this structure is padded to 8 bytes using
   // static fields, context memory can be written on 8 byte boundaries, allowing faster
   // CTX access. If the padding is not static, context memory must be written using a
   // read-modified-write, which is less efficient. The BTLR_CTRL1 register controls the
   // write back behavior of this structure with the btlr_be bit field. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CONTEXT_EXT_REV {
         union {
            struct { 
               u32 con_index : 16;                // DWORD 0
               u32 ring_size : 4;                 // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 0
               RING_CONTEXT_CORE core;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RING_CONTEXT_EXT_REV, *PRING_CONTEXT_EXT_REV;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_EXT_REV, sizeof (RING_CONTEXT_EXT_REV) == 8);

   #else
      typedef struct _RING_CONTEXT_EXT_REV {
         u32 con_index : 16;                      // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 0
         RING_CONTEXT_CORE core;
      } SG_PACK RING_CONTEXT_EXT_REV, *PRING_CONTEXT_EXT_REV;

      typedef union _RING_CONTEXT_EXT_REV_UNION {
         RING_CONTEXT_EXT_REV bits;
         u32 dw[2]; // dword union
      } SG_PACK RING_CONTEXT_EXT_REV_UNION, *PRING_CONTEXT_EXT_REV_UNION;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_EXT_REV_UNION, sizeof (RING_CONTEXT_EXT_REV_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Physical Address.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELL_TBL_PA {
         union {
            struct { 
               u32 lo;                            // DWORD 0
               u32 hi;                            // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELL_TBL_PA, *PJELL_TBL_PA;

      SG_C_ASSERT(__sizeof__JELL_TBL_PA, sizeof (JELL_TBL_PA) == 8);

   #else
      typedef struct _JELL_TBL_PA {
         u32 lo;                                  // DWORD 0
         u32 hi;                                  // DWORD 1
      } SG_PACK JELL_TBL_PA, *PJELL_TBL_PA;

      typedef union _JELL_TBL_PA_UNION {
         JELL_TBL_PA bits;
         u32 dw[2]; // dword union
      } SG_PACK JELL_TBL_PA_UNION, *PJELL_TBL_PA_UNION;

      SG_C_ASSERT(__sizeof__JELL_TBL_PA_UNION, sizeof (JELL_TBL_PA_UNION) == 8);
   #endif


#else
   // Physical Address.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELL_TBL_PA {
         union {
            struct { 
               u32 lo;                            // DWORD 0
               u32 hi;                            // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELL_TBL_PA, *PJELL_TBL_PA;

      SG_C_ASSERT(__sizeof__JELL_TBL_PA, sizeof (JELL_TBL_PA) == 8);

   #else
      typedef struct _JELL_TBL_PA {
         u32 lo;                                  // DWORD 0
         u32 hi;                                  // DWORD 1
      } SG_PACK JELL_TBL_PA, *PJELL_TBL_PA;

      typedef union _JELL_TBL_PA_UNION {
         JELL_TBL_PA bits;
         u32 dw[2]; // dword union
      } SG_PACK JELL_TBL_PA_UNION, *PJELL_TBL_PA_UNION;

      SG_C_ASSERT(__sizeof__JELL_TBL_PA_UNION, sizeof (JELL_TBL_PA_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Head and Tail Pointers for Journal Entry linked lists.
   #if defined(SG_BMAP_UNION)
      typedef struct _JE_HEAD_TAIL {
         union {
            struct { 
               u32 ll_has_entries : 1;            // DWORD 0
               u32 je_tail : 15;                  // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 je_head : 15;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JE_HEAD_TAIL, *PJE_HEAD_TAIL;

      SG_C_ASSERT(__sizeof__JE_HEAD_TAIL, sizeof (JE_HEAD_TAIL) == 4);

   #else
      typedef struct _JE_HEAD_TAIL {
         u32 ll_has_entries : 1;                  // DWORD 0
         u32 je_tail : 15;                        // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 je_head : 15;                        // DWORD 0
      } SG_PACK JE_HEAD_TAIL, *PJE_HEAD_TAIL;

      typedef union _JE_HEAD_TAIL_UNION {
         JE_HEAD_TAIL bits;
         u32 dw; // dword union
      } SG_PACK JE_HEAD_TAIL_UNION, *PJE_HEAD_TAIL_UNION;

      SG_C_ASSERT(__sizeof__JE_HEAD_TAIL_UNION, sizeof (JE_HEAD_TAIL_UNION) == 4);
   #endif


#else
   // Head and Tail Pointers for Journal Entry linked lists.
   #if defined(SG_BMAP_UNION)
      typedef struct _JE_HEAD_TAIL {
         union {
            struct { 
               u32 je_head : 15;                  // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 je_tail : 15;                  // DWORD 0
               u32 ll_has_entries : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JE_HEAD_TAIL, *PJE_HEAD_TAIL;

      SG_C_ASSERT(__sizeof__JE_HEAD_TAIL, sizeof (JE_HEAD_TAIL) == 4);

   #else
      typedef struct _JE_HEAD_TAIL {
         u32 je_head : 15;                        // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 je_tail : 15;                        // DWORD 0
         u32 ll_has_entries : 1;                  // DWORD 0
      } SG_PACK JE_HEAD_TAIL, *PJE_HEAD_TAIL;

      typedef union _JE_HEAD_TAIL_UNION {
         JE_HEAD_TAIL bits;
         u32 dw; // dword union
      } SG_PACK JE_HEAD_TAIL_UNION, *PJE_HEAD_TAIL_UNION;

      SG_C_ASSERT(__sizeof__JE_HEAD_TAIL_UNION, sizeof (JE_HEAD_TAIL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The Journal Entry Linked List Entry (JELLE) is stored in context memory to maintain
   // the Journal Entry Linked List. There is one JELLE on-chip per journal entry (JE)
   // stored in host memory. 
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLE {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 link : 15;                     // DWORD 0
               u32 tcp_len : 16;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLE, *PJELLE;

      SG_C_ASSERT(__sizeof__JELLE, sizeof (JELLE) == 4);

   #else
      typedef struct _JELLE {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 link : 15;                           // DWORD 0
         u32 tcp_len : 16;                        // DWORD 0
      } SG_PACK JELLE, *PJELLE;

      typedef union _JELLE_UNION {
         JELLE bits;
         u32 dw; // dword union
      } SG_PACK JELLE_UNION, *PJELLE_UNION;

      SG_C_ASSERT(__sizeof__JELLE_UNION, sizeof (JELLE_UNION) == 4);
   #endif


#else
   // The Journal Entry Linked List Entry (JELLE) is stored in context memory to maintain
   // the Journal Entry Linked List. There is one JELLE on-chip per journal entry (JE)
   // stored in host memory. 
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLE {
         union {
            struct { 
               u32 tcp_len : 16;                  // DWORD 0
               u32 link : 15;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLE, *PJELLE;

      SG_C_ASSERT(__sizeof__JELLE, sizeof (JELLE) == 4);

   #else
      typedef struct _JELLE {
         u32 tcp_len : 16;                        // DWORD 0
         u32 link : 15;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK JELLE, *PJELLE;

      typedef union _JELLE_UNION {
         JELLE bits;
         u32 dw; // dword union
      } SG_PACK JELLE_UNION, *PJELLE_UNION;

      SG_C_ASSERT(__sizeof__JELLE_UNION, sizeof (JELLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a single 64 byte cacheline in the UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CACHE_ENTRY {
         union {
            struct { 
               u32 data[16];                      // DWORDS 0 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK UC_CACHE_ENTRY, *PUC_CACHE_ENTRY;

      SG_C_ASSERT(__sizeof__UC_CACHE_ENTRY, sizeof (UC_CACHE_ENTRY) == 64);

   #else
      typedef struct _UC_CACHE_ENTRY {
         u32 data[16];                            // DWORDS 0 to 15
      } SG_PACK UC_CACHE_ENTRY, *PUC_CACHE_ENTRY;

      typedef union _UC_CACHE_ENTRY_UNION {
         UC_CACHE_ENTRY bits;
         u32 dw[16]; // dword union
      } SG_PACK UC_CACHE_ENTRY_UNION, *PUC_CACHE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__UC_CACHE_ENTRY_UNION, sizeof (UC_CACHE_ENTRY_UNION) == 64);
   #endif


#else
   // This is a single 64 byte cacheline in the UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CACHE_ENTRY {
         union {
            struct { 
               u32 data[16];                      // DWORDS 0 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK UC_CACHE_ENTRY, *PUC_CACHE_ENTRY;

      SG_C_ASSERT(__sizeof__UC_CACHE_ENTRY, sizeof (UC_CACHE_ENTRY) == 64);

   #else
      typedef struct _UC_CACHE_ENTRY {
         u32 data[16];                            // DWORDS 0 to 15
      } SG_PACK UC_CACHE_ENTRY, *PUC_CACHE_ENTRY;

      typedef union _UC_CACHE_ENTRY_UNION {
         UC_CACHE_ENTRY bits;
         u32 dw[16]; // dword union
      } SG_PACK UC_CACHE_ENTRY_UNION, *PUC_CACHE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__UC_CACHE_ENTRY_UNION, sizeof (UC_CACHE_ENTRY_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a single 16 byte cacheline in the PT cache.
   #if defined(SG_BMAP_UNION)
      typedef struct _PT_CACHE_ENTRY {
         union {
            struct { 
               struct {
                  u32 lo;                         // DWORD 0
                  u32 hi;                         // DWORD 1
               } addr1;
               struct {
                  u32 lo;                         // DWORD 2
                  u32 hi;                         // DWORD 3
               } addr2;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK PT_CACHE_ENTRY, *PPT_CACHE_ENTRY;

      SG_C_ASSERT(__sizeof__PT_CACHE_ENTRY, sizeof (PT_CACHE_ENTRY) == 16);

   #else
      typedef struct _PT_CACHE_ENTRY {
         struct {
            u32 lo;                               // DWORD 0
            u32 hi;                               // DWORD 1
         } addr1;
         struct {
            u32 lo;                               // DWORD 2
            u32 hi;                               // DWORD 3
         } addr2;
      } SG_PACK PT_CACHE_ENTRY, *PPT_CACHE_ENTRY;

      typedef union _PT_CACHE_ENTRY_UNION {
         PT_CACHE_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK PT_CACHE_ENTRY_UNION, *PPT_CACHE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__PT_CACHE_ENTRY_UNION, sizeof (PT_CACHE_ENTRY_UNION) == 16);
   #endif


#else
   // This is a single 16 byte cacheline in the PT cache.
   #if defined(SG_BMAP_UNION)
      typedef struct _PT_CACHE_ENTRY {
         union {
            struct { 
               struct {
                  u32 lo;                         // DWORD 0
                  u32 hi;                         // DWORD 1
               } addr1;
               struct {
                  u32 lo;                         // DWORD 2
                  u32 hi;                         // DWORD 3
               } addr2;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK PT_CACHE_ENTRY, *PPT_CACHE_ENTRY;

      SG_C_ASSERT(__sizeof__PT_CACHE_ENTRY, sizeof (PT_CACHE_ENTRY) == 16);

   #else
      typedef struct _PT_CACHE_ENTRY {
         struct {
            u32 lo;                               // DWORD 0
            u32 hi;                               // DWORD 1
         } addr1;
         struct {
            u32 lo;                               // DWORD 2
            u32 hi;                               // DWORD 3
         } addr2;
      } SG_PACK PT_CACHE_ENTRY, *PPT_CACHE_ENTRY;

      typedef union _PT_CACHE_ENTRY_UNION {
         PT_CACHE_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK PT_CACHE_ENTRY_UNION, *PPT_CACHE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__PT_CACHE_ENTRY_UNION, sizeof (PT_CACHE_ENTRY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure represents a single cache element in the UC. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CACHE_ELEMENT {
         union {
            struct { 
               UC_CACHE_ENTRY set[4];
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK UC_CACHE_ELEMENT, *PUC_CACHE_ELEMENT;

      SG_C_ASSERT(__sizeof__UC_CACHE_ELEMENT, sizeof (UC_CACHE_ELEMENT) == 256);

   #else
      typedef struct _UC_CACHE_ELEMENT {
         UC_CACHE_ENTRY set[4];
      } SG_PACK UC_CACHE_ELEMENT, *PUC_CACHE_ELEMENT;

      typedef union _UC_CACHE_ELEMENT_UNION {
         UC_CACHE_ELEMENT bits;
         u32 dw[64]; // dword union
      } SG_PACK UC_CACHE_ELEMENT_UNION, *PUC_CACHE_ELEMENT_UNION;

      SG_C_ASSERT(__sizeof__UC_CACHE_ELEMENT_UNION, sizeof (UC_CACHE_ELEMENT_UNION) == 256);
   #endif


#else
   // This structure represents a single cache element in the UC. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CACHE_ELEMENT {
         union {
            struct { 
               UC_CACHE_ENTRY set[4];
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK UC_CACHE_ELEMENT, *PUC_CACHE_ELEMENT;

      SG_C_ASSERT(__sizeof__UC_CACHE_ELEMENT, sizeof (UC_CACHE_ELEMENT) == 256);

   #else
      typedef struct _UC_CACHE_ELEMENT {
         UC_CACHE_ENTRY set[4];
      } SG_PACK UC_CACHE_ELEMENT, *PUC_CACHE_ELEMENT;

      typedef union _UC_CACHE_ELEMENT_UNION {
         UC_CACHE_ELEMENT bits;
         u32 dw[64]; // dword union
      } SG_PACK UC_CACHE_ELEMENT_UNION, *PUC_CACHE_ELEMENT_UNION;

      SG_C_ASSERT(__sizeof__UC_CACHE_ELEMENT_UNION, sizeof (UC_CACHE_ELEMENT_UNION) == 256);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure represents a single cache line in the PTC. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PT_CACHE_ELEMENT {
         union {
            struct { 
               PT_CACHE_ENTRY set[8];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK PT_CACHE_ELEMENT, *PPT_CACHE_ELEMENT;

      SG_C_ASSERT(__sizeof__PT_CACHE_ELEMENT, sizeof (PT_CACHE_ELEMENT) == 128);

   #else
      typedef struct _PT_CACHE_ELEMENT {
         PT_CACHE_ENTRY set[8];
      } SG_PACK PT_CACHE_ELEMENT, *PPT_CACHE_ELEMENT;

      typedef union _PT_CACHE_ELEMENT_UNION {
         PT_CACHE_ELEMENT bits;
         u32 dw[32]; // dword union
      } SG_PACK PT_CACHE_ELEMENT_UNION, *PPT_CACHE_ELEMENT_UNION;

      SG_C_ASSERT(__sizeof__PT_CACHE_ELEMENT_UNION, sizeof (PT_CACHE_ELEMENT_UNION) == 128);
   #endif


#else
   // This structure represents a single cache line in the PTC. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PT_CACHE_ELEMENT {
         union {
            struct { 
               PT_CACHE_ENTRY set[8];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK PT_CACHE_ELEMENT, *PPT_CACHE_ELEMENT;

      SG_C_ASSERT(__sizeof__PT_CACHE_ELEMENT, sizeof (PT_CACHE_ELEMENT) == 128);

   #else
      typedef struct _PT_CACHE_ELEMENT {
         PT_CACHE_ENTRY set[8];
      } SG_PACK PT_CACHE_ELEMENT, *PPT_CACHE_ELEMENT;

      typedef union _PT_CACHE_ELEMENT_UNION {
         PT_CACHE_ELEMENT bits;
         u32 dw[32]; // dword union
      } SG_PACK PT_CACHE_ELEMENT_UNION, *PPT_CACHE_ELEMENT_UNION;

      SG_C_ASSERT(__sizeof__PT_CACHE_ELEMENT_UNION, sizeof (PT_CACHE_ELEMENT_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Placeholder for partial iscsi pdu crc in the Tx side
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CRC_CTX {
         union {
            struct { 
               u32 txPartialCRC0;                 // DWORD 0
               u32 txPartialCRC1;                 // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TXP_CRC_CTX, *PTXP_CRC_CTX;

      SG_C_ASSERT(__sizeof__TXP_CRC_CTX, sizeof (TXP_CRC_CTX) == 8);

   #else
      typedef struct _TXP_CRC_CTX {
         u32 txPartialCRC0;                       // DWORD 0
         u32 txPartialCRC1;                       // DWORD 1
      } SG_PACK TXP_CRC_CTX, *PTXP_CRC_CTX;

      typedef union _TXP_CRC_CTX_UNION {
         TXP_CRC_CTX bits;
         u32 dw[2]; // dword union
      } SG_PACK TXP_CRC_CTX_UNION, *PTXP_CRC_CTX_UNION;

      SG_C_ASSERT(__sizeof__TXP_CRC_CTX_UNION, sizeof (TXP_CRC_CTX_UNION) == 8);
   #endif


#else
   // Placeholder for partial iscsi pdu crc in the Tx side
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CRC_CTX {
         union {
            struct { 
               u32 txPartialCRC0;                 // DWORD 0
               u32 txPartialCRC1;                 // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TXP_CRC_CTX, *PTXP_CRC_CTX;

      SG_C_ASSERT(__sizeof__TXP_CRC_CTX, sizeof (TXP_CRC_CTX) == 8);

   #else
      typedef struct _TXP_CRC_CTX {
         u32 txPartialCRC0;                       // DWORD 0
         u32 txPartialCRC1;                       // DWORD 1
      } SG_PACK TXP_CRC_CTX, *PTXP_CRC_CTX;

      typedef union _TXP_CRC_CTX_UNION {
         TXP_CRC_CTX bits;
         u32 dw[2]; // dword union
      } SG_PACK TXP_CRC_CTX_UNION, *PTXP_CRC_CTX_UNION;

      SG_C_ASSERT(__sizeof__TXP_CRC_CTX_UNION, sizeof (TXP_CRC_CTX_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Placeholder for partial iscsi pdu crc in the Rx side
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_CRC_CTX {
         union {
            struct { 
               u32 rxPartialCRC;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_CRC_CTX, *PWDMA_CRC_CTX;

      SG_C_ASSERT(__sizeof__WDMA_CRC_CTX, sizeof (WDMA_CRC_CTX) == 4);

   #else
      typedef struct _WDMA_CRC_CTX {
         u32 rxPartialCRC;                        // DWORD 0
      } SG_PACK WDMA_CRC_CTX, *PWDMA_CRC_CTX;

      typedef union _WDMA_CRC_CTX_UNION {
         WDMA_CRC_CTX bits;
         u32 dw; // dword union
      } SG_PACK WDMA_CRC_CTX_UNION, *PWDMA_CRC_CTX_UNION;

      SG_C_ASSERT(__sizeof__WDMA_CRC_CTX_UNION, sizeof (WDMA_CRC_CTX_UNION) == 4);
   #endif


#else
   // Placeholder for partial iscsi pdu crc in the Rx side
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_CRC_CTX {
         union {
            struct { 
               u32 rxPartialCRC;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_CRC_CTX, *PWDMA_CRC_CTX;

      SG_C_ASSERT(__sizeof__WDMA_CRC_CTX, sizeof (WDMA_CRC_CTX) == 4);

   #else
      typedef struct _WDMA_CRC_CTX {
         u32 rxPartialCRC;                        // DWORD 0
      } SG_PACK WDMA_CRC_CTX, *PWDMA_CRC_CTX;

      typedef union _WDMA_CRC_CTX_UNION {
         WDMA_CRC_CTX bits;
         u32 dw; // dword union
      } SG_PACK WDMA_CRC_CTX_UNION, *PWDMA_CRC_CTX_UNION;

      SG_C_ASSERT(__sizeof__WDMA_CRC_CTX_UNION, sizeof (WDMA_CRC_CTX_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Placeholder for partial DIF bytes
   #if defined(SG_BMAP_UNION)
      typedef struct _DIF_CTX {
         union {
            struct { 
               u32 rxPartialDif[2];               // DWORDS 0 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK DIF_CTX, *PDIF_CTX;

      SG_C_ASSERT(__sizeof__DIF_CTX, sizeof (DIF_CTX) == 8);

   #else
      typedef struct _DIF_CTX {
         u32 rxPartialDif[2];                     // DWORDS 0 to 1
      } SG_PACK DIF_CTX, *PDIF_CTX;

      typedef union _DIF_CTX_UNION {
         DIF_CTX bits;
         u32 dw[2]; // dword union
      } SG_PACK DIF_CTX_UNION, *PDIF_CTX_UNION;

      SG_C_ASSERT(__sizeof__DIF_CTX_UNION, sizeof (DIF_CTX_UNION) == 8);
   #endif


#else
   // Placeholder for partial DIF bytes
   #if defined(SG_BMAP_UNION)
      typedef struct _DIF_CTX {
         union {
            struct { 
               u32 rxPartialDif[2];               // DWORDS 0 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK DIF_CTX, *PDIF_CTX;

      SG_C_ASSERT(__sizeof__DIF_CTX, sizeof (DIF_CTX) == 8);

   #else
      typedef struct _DIF_CTX {
         u32 rxPartialDif[2];                     // DWORDS 0 to 1
      } SG_PACK DIF_CTX, *PDIF_CTX;

      typedef union _DIF_CTX_UNION {
         DIF_CTX bits;
         u32 dw[2]; // dword union
      } SG_PACK DIF_CTX_UNION, *PDIF_CTX_UNION;

      SG_C_ASSERT(__sizeof__DIF_CTX_UNION, sizeof (DIF_CTX_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Array of iSCSI CRCs maintained by the Transmit Processor. Each entry in the array
   // corresponds to a particular iSCSI connection ID.
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_TXP_CRC_CTX {
         union {
            struct { 
               u32 txPartialCRC[2048];            // DWORDS 0 to 2047
            } SG_PACK ; // unnamed struct
            u32 dw[2048]; // dword union
         }; // unnamed union
      } SG_PACK TGT_TXP_CRC_CTX, *PTGT_TXP_CRC_CTX;

      SG_C_ASSERT(__sizeof__TGT_TXP_CRC_CTX, sizeof (TGT_TXP_CRC_CTX) == 8192);

   #else
      typedef struct _TGT_TXP_CRC_CTX {
         u32 txPartialCRC[2048];                  // DWORDS 0 to 2047
      } SG_PACK TGT_TXP_CRC_CTX, *PTGT_TXP_CRC_CTX;

      typedef union _TGT_TXP_CRC_CTX_UNION {
         TGT_TXP_CRC_CTX bits;
         u32 dw[2048]; // dword union
      } SG_PACK TGT_TXP_CRC_CTX_UNION, *PTGT_TXP_CRC_CTX_UNION;

      SG_C_ASSERT(__sizeof__TGT_TXP_CRC_CTX_UNION, sizeof (TGT_TXP_CRC_CTX_UNION) == 8192);
   #endif


#else
   // Array of iSCSI CRCs maintained by the Transmit Processor. Each entry in the array
   // corresponds to a particular iSCSI connection ID.
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_TXP_CRC_CTX {
         union {
            struct { 
               u32 txPartialCRC[2048];            // DWORDS 0 to 2047
            } SG_PACK ; // unnamed struct
            u32 dw[2048]; // dword union
         }; // unnamed union
      } SG_PACK TGT_TXP_CRC_CTX, *PTGT_TXP_CRC_CTX;

      SG_C_ASSERT(__sizeof__TGT_TXP_CRC_CTX, sizeof (TGT_TXP_CRC_CTX) == 8192);

   #else
      typedef struct _TGT_TXP_CRC_CTX {
         u32 txPartialCRC[2048];                  // DWORDS 0 to 2047
      } SG_PACK TGT_TXP_CRC_CTX, *PTGT_TXP_CRC_CTX;

      typedef union _TGT_TXP_CRC_CTX_UNION {
         TGT_TXP_CRC_CTX bits;
         u32 dw[2048]; // dword union
      } SG_PACK TGT_TXP_CRC_CTX_UNION, *PTGT_TXP_CRC_CTX_UNION;

      SG_C_ASSERT(__sizeof__TGT_TXP_CRC_CTX_UNION, sizeof (TGT_TXP_CRC_CTX_UNION) == 8192);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Array of iSCSI CRCs maintained by the Write DMA Processor. Each entry in the array
   // corresponds to a particular iSCSI connection ID.
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_WDMA_CRC_CTX {
         union {
            struct { 
               u32 rxPartialCRC[2048];            // DWORDS 0 to 2047
            } SG_PACK ; // unnamed struct
            u32 dw[2048]; // dword union
         }; // unnamed union
      } SG_PACK TGT_WDMA_CRC_CTX, *PTGT_WDMA_CRC_CTX;

      SG_C_ASSERT(__sizeof__TGT_WDMA_CRC_CTX, sizeof (TGT_WDMA_CRC_CTX) == 8192);

   #else
      typedef struct _TGT_WDMA_CRC_CTX {
         u32 rxPartialCRC[2048];                  // DWORDS 0 to 2047
      } SG_PACK TGT_WDMA_CRC_CTX, *PTGT_WDMA_CRC_CTX;

      typedef union _TGT_WDMA_CRC_CTX_UNION {
         TGT_WDMA_CRC_CTX bits;
         u32 dw[2048]; // dword union
      } SG_PACK TGT_WDMA_CRC_CTX_UNION, *PTGT_WDMA_CRC_CTX_UNION;

      SG_C_ASSERT(__sizeof__TGT_WDMA_CRC_CTX_UNION, sizeof (TGT_WDMA_CRC_CTX_UNION) == 8192);
   #endif


#else
   // Array of iSCSI CRCs maintained by the Write DMA Processor. Each entry in the array
   // corresponds to a particular iSCSI connection ID.
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_WDMA_CRC_CTX {
         union {
            struct { 
               u32 rxPartialCRC[2048];            // DWORDS 0 to 2047
            } SG_PACK ; // unnamed struct
            u32 dw[2048]; // dword union
         }; // unnamed union
      } SG_PACK TGT_WDMA_CRC_CTX, *PTGT_WDMA_CRC_CTX;

      SG_C_ASSERT(__sizeof__TGT_WDMA_CRC_CTX, sizeof (TGT_WDMA_CRC_CTX) == 8192);

   #else
      typedef struct _TGT_WDMA_CRC_CTX {
         u32 rxPartialCRC[2048];                  // DWORDS 0 to 2047
      } SG_PACK TGT_WDMA_CRC_CTX, *PTGT_WDMA_CRC_CTX;

      typedef union _TGT_WDMA_CRC_CTX_UNION {
         TGT_WDMA_CRC_CTX bits;
         u32 dw[2048]; // dword union
      } SG_PACK TGT_WDMA_CRC_CTX_UNION, *PTGT_WDMA_CRC_CTX_UNION;

      SG_C_ASSERT(__sizeof__TGT_WDMA_CRC_CTX_UNION, sizeof (TGT_WDMA_CRC_CTX_UNION) == 8192);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Array of iSCSI CRCs maintained by the Transmit Processor. Each entry in the array
   // corresponds to a particular iSCSI connection ID.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CRC_CTX_64CXN {
         union {
            struct { 
               u32 txPartialCRC[128];             // DWORDS 0 to 127
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK TXP_CRC_CTX_64CXN, *PTXP_CRC_CTX_64CXN;

      SG_C_ASSERT(__sizeof__TXP_CRC_CTX_64CXN, sizeof (TXP_CRC_CTX_64CXN) == 512);

   #else
      typedef struct _TXP_CRC_CTX_64CXN {
         u32 txPartialCRC[128];                   // DWORDS 0 to 127
      } SG_PACK TXP_CRC_CTX_64CXN, *PTXP_CRC_CTX_64CXN;

      typedef union _TXP_CRC_CTX_64CXN_UNION {
         TXP_CRC_CTX_64CXN bits;
         u32 dw[128]; // dword union
      } SG_PACK TXP_CRC_CTX_64CXN_UNION, *PTXP_CRC_CTX_64CXN_UNION;

      SG_C_ASSERT(__sizeof__TXP_CRC_CTX_64CXN_UNION, sizeof (TXP_CRC_CTX_64CXN_UNION) == 512);
   #endif


#else
   // Array of iSCSI CRCs maintained by the Transmit Processor. Each entry in the array
   // corresponds to a particular iSCSI connection ID.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CRC_CTX_64CXN {
         union {
            struct { 
               u32 txPartialCRC[128];             // DWORDS 0 to 127
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK TXP_CRC_CTX_64CXN, *PTXP_CRC_CTX_64CXN;

      SG_C_ASSERT(__sizeof__TXP_CRC_CTX_64CXN, sizeof (TXP_CRC_CTX_64CXN) == 512);

   #else
      typedef struct _TXP_CRC_CTX_64CXN {
         u32 txPartialCRC[128];                   // DWORDS 0 to 127
      } SG_PACK TXP_CRC_CTX_64CXN, *PTXP_CRC_CTX_64CXN;

      typedef union _TXP_CRC_CTX_64CXN_UNION {
         TXP_CRC_CTX_64CXN bits;
         u32 dw[128]; // dword union
      } SG_PACK TXP_CRC_CTX_64CXN_UNION, *PTXP_CRC_CTX_64CXN_UNION;

      SG_C_ASSERT(__sizeof__TXP_CRC_CTX_64CXN_UNION, sizeof (TXP_CRC_CTX_64CXN_UNION) == 512);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Array of iSCSI CRCs maintained by the Write DMA Processor. Each entry in the array
   // corresponds to a particular iSCSI connection ID.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_CRC_CTX_64CXN {
         union {
            struct { 
               u32 rxPartialCRC[128];             // DWORDS 0 to 127
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK WDMA_CRC_CTX_64CXN, *PWDMA_CRC_CTX_64CXN;

      SG_C_ASSERT(__sizeof__WDMA_CRC_CTX_64CXN, sizeof (WDMA_CRC_CTX_64CXN) == 512);

   #else
      typedef struct _WDMA_CRC_CTX_64CXN {
         u32 rxPartialCRC[128];                   // DWORDS 0 to 127
      } SG_PACK WDMA_CRC_CTX_64CXN, *PWDMA_CRC_CTX_64CXN;

      typedef union _WDMA_CRC_CTX_64CXN_UNION {
         WDMA_CRC_CTX_64CXN bits;
         u32 dw[128]; // dword union
      } SG_PACK WDMA_CRC_CTX_64CXN_UNION, *PWDMA_CRC_CTX_64CXN_UNION;

      SG_C_ASSERT(__sizeof__WDMA_CRC_CTX_64CXN_UNION, sizeof (WDMA_CRC_CTX_64CXN_UNION) == 512);
   #endif


#else
   // Array of iSCSI CRCs maintained by the Write DMA Processor. Each entry in the array
   // corresponds to a particular iSCSI connection ID.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_CRC_CTX_64CXN {
         union {
            struct { 
               u32 rxPartialCRC[128];             // DWORDS 0 to 127
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK WDMA_CRC_CTX_64CXN, *PWDMA_CRC_CTX_64CXN;

      SG_C_ASSERT(__sizeof__WDMA_CRC_CTX_64CXN, sizeof (WDMA_CRC_CTX_64CXN) == 512);

   #else
      typedef struct _WDMA_CRC_CTX_64CXN {
         u32 rxPartialCRC[128];                   // DWORDS 0 to 127
      } SG_PACK WDMA_CRC_CTX_64CXN, *PWDMA_CRC_CTX_64CXN;

      typedef union _WDMA_CRC_CTX_64CXN_UNION {
         WDMA_CRC_CTX_64CXN bits;
         u32 dw[128]; // dword union
      } SG_PACK WDMA_CRC_CTX_64CXN_UNION, *PWDMA_CRC_CTX_64CXN_UNION;

      SG_C_ASSERT(__sizeof__WDMA_CRC_CTX_64CXN_UNION, sizeof (WDMA_CRC_CTX_64CXN_UNION) == 512);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_OVFLOW_CTX {
         union {
            struct { 
               u32 data[128];                     // DWORDS 0 to 127
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK IPC_OVFLOW_CTX, *PIPC_OVFLOW_CTX;

      SG_C_ASSERT(__sizeof__IPC_OVFLOW_CTX, sizeof (IPC_OVFLOW_CTX) == 512);

   #else
      typedef struct _IPC_OVFLOW_CTX {
         u32 data[128];                           // DWORDS 0 to 127
      } SG_PACK IPC_OVFLOW_CTX, *PIPC_OVFLOW_CTX;

      typedef union _IPC_OVFLOW_CTX_UNION {
         IPC_OVFLOW_CTX bits;
         u32 dw[128]; // dword union
      } SG_PACK IPC_OVFLOW_CTX_UNION, *PIPC_OVFLOW_CTX_UNION;

      SG_C_ASSERT(__sizeof__IPC_OVFLOW_CTX_UNION, sizeof (IPC_OVFLOW_CTX_UNION) == 512);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_OVFLOW_CTX {
         union {
            struct { 
               u32 data[128];                     // DWORDS 0 to 127
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK IPC_OVFLOW_CTX, *PIPC_OVFLOW_CTX;

      SG_C_ASSERT(__sizeof__IPC_OVFLOW_CTX, sizeof (IPC_OVFLOW_CTX) == 512);

   #else
      typedef struct _IPC_OVFLOW_CTX {
         u32 data[128];                           // DWORDS 0 to 127
      } SG_PACK IPC_OVFLOW_CTX, *PIPC_OVFLOW_CTX;

      typedef union _IPC_OVFLOW_CTX_UNION {
         IPC_OVFLOW_CTX bits;
         u32 dw[128]; // dword union
      } SG_PACK IPC_OVFLOW_CTX_UNION, *PIPC_OVFLOW_CTX_UNION;

      SG_C_ASSERT(__sizeof__IPC_OVFLOW_CTX_UNION, sizeof (IPC_OVFLOW_CTX_UNION) == 512);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_HOLE_INFO_EXT {
         union {
            struct { 
               u32 ooo_start1;                    // DWORD 0
               u32 ooo_end1;                      // DWORD 1
               u32 ooo_start2;                    // DWORD 2
               u32 ooo_end2;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TCP_HOLE_INFO_EXT, *PTCP_HOLE_INFO_EXT;

      SG_C_ASSERT(__sizeof__TCP_HOLE_INFO_EXT, sizeof (TCP_HOLE_INFO_EXT) == 16);

   #else
      typedef struct _TCP_HOLE_INFO_EXT {
         u32 ooo_start1;                          // DWORD 0
         u32 ooo_end1;                            // DWORD 1
         u32 ooo_start2;                          // DWORD 2
         u32 ooo_end2;                            // DWORD 3
      } SG_PACK TCP_HOLE_INFO_EXT, *PTCP_HOLE_INFO_EXT;

      typedef union _TCP_HOLE_INFO_EXT_UNION {
         TCP_HOLE_INFO_EXT bits;
         u32 dw[4]; // dword union
      } SG_PACK TCP_HOLE_INFO_EXT_UNION, *PTCP_HOLE_INFO_EXT_UNION;

      SG_C_ASSERT(__sizeof__TCP_HOLE_INFO_EXT_UNION, sizeof (TCP_HOLE_INFO_EXT_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_HOLE_INFO_EXT {
         union {
            struct { 
               u32 ooo_start1;                    // DWORD 0
               u32 ooo_end1;                      // DWORD 1
               u32 ooo_start2;                    // DWORD 2
               u32 ooo_end2;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TCP_HOLE_INFO_EXT, *PTCP_HOLE_INFO_EXT;

      SG_C_ASSERT(__sizeof__TCP_HOLE_INFO_EXT, sizeof (TCP_HOLE_INFO_EXT) == 16);

   #else
      typedef struct _TCP_HOLE_INFO_EXT {
         u32 ooo_start1;                          // DWORD 0
         u32 ooo_end1;                            // DWORD 1
         u32 ooo_start2;                          // DWORD 2
         u32 ooo_end2;                            // DWORD 3
      } SG_PACK TCP_HOLE_INFO_EXT, *PTCP_HOLE_INFO_EXT;

      typedef union _TCP_HOLE_INFO_EXT_UNION {
         TCP_HOLE_INFO_EXT bits;
         u32 dw[4]; // dword union
      } SG_PACK TCP_HOLE_INFO_EXT_UNION, *PTCP_HOLE_INFO_EXT_UNION;

      SG_C_ASSERT(__sizeof__TCP_HOLE_INFO_EXT_UNION, sizeof (TCP_HOLE_INFO_EXT_UNION) == 16);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __common_context_bmap_h__

