/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __doorbells_bmap_h__
#define __doorbells_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "pcicfg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // The TX/RDMA send queue doorbell.
   #if defined(SG_BMAP_UNION)
      typedef struct _SQ_DB {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 numPosted : 14;                // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 cid : 11;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SQ_DB, *PSQ_DB;

      SG_C_ASSERT(__sizeof__SQ_DB, sizeof (SQ_DB) == 4);

   #else
      typedef struct _SQ_DB {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 numPosted : 14;                      // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 cid : 11;                            // DWORD 0
      } SG_PACK SQ_DB, *PSQ_DB;

      typedef union _SQ_DB_UNION {
         SQ_DB bits;
         u32 dw; // dword union
      } SG_PACK SQ_DB_UNION, *PSQ_DB_UNION;

      SG_C_ASSERT(__sizeof__SQ_DB_UNION, sizeof (SQ_DB_UNION) == 4);
   #endif


#else
   // The TX/RDMA send queue doorbell.
   #if defined(SG_BMAP_UNION)
      typedef struct _SQ_DB {
         union {
            struct { 
               u32 cid : 11;                      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 numPosted : 14;                // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SQ_DB, *PSQ_DB;

      SG_C_ASSERT(__sizeof__SQ_DB, sizeof (SQ_DB) == 4);

   #else
      typedef struct _SQ_DB {
         u32 cid : 11;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 numPosted : 14;                      // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK SQ_DB, *PSQ_DB;

      typedef union _SQ_DB_UNION {
         SQ_DB bits;
         u32 dw; // dword union
      } SG_PACK SQ_DB_UNION, *PSQ_DB_UNION;

      SG_C_ASSERT(__sizeof__SQ_DB_UNION, sizeof (SQ_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The receive queue doorbell.
   #if defined(SG_BMAP_UNION)
      typedef struct _RQ_DB {
         union {
            struct { 
               u32 numPosted : 8;                 // DWORD 0
               u32 Invalidate : 1;                // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
               u32 rq : 10;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RQ_DB, *PRQ_DB;

      SG_C_ASSERT(__sizeof__RQ_DB, sizeof (RQ_DB) == 4);

   #else
      typedef struct _RQ_DB {
         u32 numPosted : 8;                       // DWORD 0
         u32 Invalidate : 1;                      // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 rq : 10;                             // DWORD 0
      } SG_PACK RQ_DB, *PRQ_DB;

      typedef union _RQ_DB_UNION {
         RQ_DB bits;
         u32 dw; // dword union
      } SG_PACK RQ_DB_UNION, *PRQ_DB_UNION;

      SG_C_ASSERT(__sizeof__RQ_DB_UNION, sizeof (RQ_DB_UNION) == 4);
   #endif


#else
   // The receive queue doorbell.
   #if defined(SG_BMAP_UNION)
      typedef struct _RQ_DB {
         union {
            struct { 
               u32 rq : 10;                       // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
               u32 Invalidate : 1;                // DWORD 0
               u32 numPosted : 8;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RQ_DB, *PRQ_DB;

      SG_C_ASSERT(__sizeof__RQ_DB, sizeof (RQ_DB) == 4);

   #else
      typedef struct _RQ_DB {
         u32 rq : 10;                             // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 Invalidate : 1;                      // DWORD 0
         u32 numPosted : 8;                       // DWORD 0
      } SG_PACK RQ_DB, *PRQ_DB;

      typedef union _RQ_DB_UNION {
         RQ_DB bits;
         u32 dw; // dword union
      } SG_PACK RQ_DB_UNION, *PRQ_DB_UNION;

      SG_C_ASSERT(__sizeof__RQ_DB_UNION, sizeof (RQ_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The CQ doorbell. Software MUST set reserved fields in this descriptor to zero,
   // otherwise (CEV) hardware will not execute the doorbell (flagging a bad_db_qid error
   // instead). To ring an EQ doorbell use the address same as CQ_DB but with the format
   // as : EQ_DB 
   #if defined(SG_BMAP_UNION)
      typedef struct _CQ_DB {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rearm : 1;                     // DWORD 0
               u32 num_popped : 13;               // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 event : 1;                     // DWORD 0
               u32 qid : 10;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CQ_DB, *PCQ_DB;

      SG_C_ASSERT(__sizeof__CQ_DB, sizeof (CQ_DB) == 4);

   #else
      typedef struct _CQ_DB {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rearm : 1;                           // DWORD 0
         u32 num_popped : 13;                     // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 qid : 10;                            // DWORD 0
      } SG_PACK CQ_DB, *PCQ_DB;

      typedef union _CQ_DB_UNION {
         CQ_DB bits;
         u32 dw; // dword union
      } SG_PACK CQ_DB_UNION, *PCQ_DB_UNION;

      SG_C_ASSERT(__sizeof__CQ_DB_UNION, sizeof (CQ_DB_UNION) == 4);
   #endif


#else
   // The CQ doorbell. Software MUST set reserved fields in this descriptor to zero,
   // otherwise (CEV) hardware will not execute the doorbell (flagging a bad_db_qid error
   // instead). To ring an EQ doorbell use the address same as CQ_DB but with the format
   // as : EQ_DB 
   #if defined(SG_BMAP_UNION)
      typedef struct _CQ_DB {
         union {
            struct { 
               u32 qid : 10;                      // DWORD 0
               u32 event : 1;                     // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 num_popped : 13;               // DWORD 0
               u32 rearm : 1;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CQ_DB, *PCQ_DB;

      SG_C_ASSERT(__sizeof__CQ_DB, sizeof (CQ_DB) == 4);

   #else
      typedef struct _CQ_DB {
         u32 qid : 10;                            // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 num_popped : 13;                     // DWORD 0
         u32 rearm : 1;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK CQ_DB, *PCQ_DB;

      typedef union _CQ_DB_UNION {
         CQ_DB bits;
         u32 dw; // dword union
      } SG_PACK CQ_DB_UNION, *PCQ_DB_UNION;

      SG_C_ASSERT(__sizeof__CQ_DB_UNION, sizeof (CQ_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The EQ doorbell. Software MUST set reserved fields in this descriptor to zero,
   // otherwise (CEV) hardware will not execute the doorbell (flagging a bad_db_qid error
   // instead). Ring the Doorbell with the address same as CQ_DB.
   #if defined(SG_BMAP_UNION)
      typedef struct _EQ_DB {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rearm : 1;                     // DWORD 0
               u32 num_popped : 13;               // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 event : 1;                     // DWORD 0
               u32 ClearInt : 1;                  // DWORD 0
               u32 qid : 9;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EQ_DB, *PEQ_DB;

      SG_C_ASSERT(__sizeof__EQ_DB, sizeof (EQ_DB) == 4);

   #else
      typedef struct _EQ_DB {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rearm : 1;                           // DWORD 0
         u32 num_popped : 13;                     // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 ClearInt : 1;                        // DWORD 0
         u32 qid : 9;                             // DWORD 0
      } SG_PACK EQ_DB, *PEQ_DB;

      typedef union _EQ_DB_UNION {
         EQ_DB bits;
         u32 dw; // dword union
      } SG_PACK EQ_DB_UNION, *PEQ_DB_UNION;

      SG_C_ASSERT(__sizeof__EQ_DB_UNION, sizeof (EQ_DB_UNION) == 4);
   #endif


#else
   // The EQ doorbell. Software MUST set reserved fields in this descriptor to zero,
   // otherwise (CEV) hardware will not execute the doorbell (flagging a bad_db_qid error
   // instead). Ring the Doorbell with the address same as CQ_DB.
   #if defined(SG_BMAP_UNION)
      typedef struct _EQ_DB {
         union {
            struct { 
               u32 qid : 9;                       // DWORD 0
               u32 ClearInt : 1;                  // DWORD 0
               u32 event : 1;                     // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 num_popped : 13;               // DWORD 0
               u32 rearm : 1;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EQ_DB, *PEQ_DB;

      SG_C_ASSERT(__sizeof__EQ_DB, sizeof (EQ_DB) == 4);

   #else
      typedef struct _EQ_DB {
         u32 qid : 9;                             // DWORD 0
         u32 ClearInt : 1;                        // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 num_popped : 13;                     // DWORD 0
         u32 rearm : 1;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK EQ_DB, *PEQ_DB;

      typedef union _EQ_DB_UNION {
         EQ_DB bits;
         u32 dw; // dword union
      } SG_PACK EQ_DB_UNION, *PEQ_DB_UNION;

      SG_C_ASSERT(__sizeof__EQ_DB_UNION, sizeof (EQ_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Doorbell format used for a window update doorbell for TOE
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_WINUPD_DB {
         union {
            struct { 
               u32 byte_count : 16;               // DWORD 0
               u32 window_update : 1;             // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 qid : 11;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOE_WINUPD_DB, *PTOE_WINUPD_DB;

      SG_C_ASSERT(__sizeof__TOE_WINUPD_DB, sizeof (TOE_WINUPD_DB) == 4);

   #else
      typedef struct _TOE_WINUPD_DB {
         u32 byte_count : 16;                     // DWORD 0
         u32 window_update : 1;                   // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 qid : 11;                            // DWORD 0
      } SG_PACK TOE_WINUPD_DB, *PTOE_WINUPD_DB;

      typedef union _TOE_WINUPD_DB_UNION {
         TOE_WINUPD_DB bits;
         u32 dw; // dword union
      } SG_PACK TOE_WINUPD_DB_UNION, *PTOE_WINUPD_DB_UNION;

      SG_C_ASSERT(__sizeof__TOE_WINUPD_DB_UNION, sizeof (TOE_WINUPD_DB_UNION) == 4);
   #endif


#else
   // Doorbell format used for a window update doorbell for TOE
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_WINUPD_DB {
         union {
            struct { 
               u32 qid : 11;                      // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 window_update : 1;             // DWORD 0
               u32 byte_count : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOE_WINUPD_DB, *PTOE_WINUPD_DB;

      SG_C_ASSERT(__sizeof__TOE_WINUPD_DB, sizeof (TOE_WINUPD_DB) == 4);

   #else
      typedef struct _TOE_WINUPD_DB {
         u32 qid : 11;                            // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 window_update : 1;                   // DWORD 0
         u32 byte_count : 16;                     // DWORD 0
      } SG_PACK TOE_WINUPD_DB, *PTOE_WINUPD_DB;

      typedef union _TOE_WINUPD_DB_UNION {
         TOE_WINUPD_DB bits;
         u32 dw; // dword union
      } SG_PACK TOE_WINUPD_DB_UNION, *PTOE_WINUPD_DB_UNION;

      SG_C_ASSERT(__sizeof__TOE_WINUPD_DB_UNION, sizeof (TOE_WINUPD_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Preposted and default fragment doorbell for TOE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_RQ_DB {
         union {
            struct { 
               u32 rsvd1 : 5;                     // DWORD 0
               u32 numPosted : 11;                // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 qid : 11;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOE_RQ_DB, *PTOE_RQ_DB;

      SG_C_ASSERT(__sizeof__TOE_RQ_DB, sizeof (TOE_RQ_DB) == 4);

   #else
      typedef struct _TOE_RQ_DB {
         u32 rsvd1 : 5;                           // DWORD 0
         u32 numPosted : 11;                      // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 qid : 11;                            // DWORD 0
      } SG_PACK TOE_RQ_DB, *PTOE_RQ_DB;

      typedef union _TOE_RQ_DB_UNION {
         TOE_RQ_DB bits;
         u32 dw; // dword union
      } SG_PACK TOE_RQ_DB_UNION, *PTOE_RQ_DB_UNION;

      SG_C_ASSERT(__sizeof__TOE_RQ_DB_UNION, sizeof (TOE_RQ_DB_UNION) == 4);
   #endif


#else
   // Preposted and default fragment doorbell for TOE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_RQ_DB {
         union {
            struct { 
               u32 qid : 11;                      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 numPosted : 11;                // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOE_RQ_DB, *PTOE_RQ_DB;

      SG_C_ASSERT(__sizeof__TOE_RQ_DB, sizeof (TOE_RQ_DB) == 4);

   #else
      typedef struct _TOE_RQ_DB {
         u32 qid : 11;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 numPosted : 11;                      // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
      } SG_PACK TOE_RQ_DB, *PTOE_RQ_DB;

      typedef union _TOE_RQ_DB_UNION {
         TOE_RQ_DB bits;
         u32 dw; // dword union
      } SG_PACK TOE_RQ_DB_UNION, *PTOE_RQ_DB_UNION;

      SG_C_ASSERT(__sizeof__TOE_RQ_DB_UNION, sizeof (TOE_RQ_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Post WRB Queue Doorbell Register used by the host Storage stack to notify the
   // controller of a posted Work Request Block
   #if defined(SG_BMAP_UNION)
      typedef struct _SQ_LIST_DB {
         union {
            struct { 
               u32 numberPosted : 8;              // DWORD 0
               u32 wrb_index : 8;                 // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 wrb_cid : 11;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SQ_LIST_DB, *PSQ_LIST_DB;

      SG_C_ASSERT(__sizeof__SQ_LIST_DB, sizeof (SQ_LIST_DB) == 4);

   #else
      typedef struct _SQ_LIST_DB {
         u32 numberPosted : 8;                    // DWORD 0
         u32 wrb_index : 8;                       // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 wrb_cid : 11;                        // DWORD 0
      } SG_PACK SQ_LIST_DB, *PSQ_LIST_DB;

      typedef union _SQ_LIST_DB_UNION {
         SQ_LIST_DB bits;
         u32 dw; // dword union
      } SG_PACK SQ_LIST_DB_UNION, *PSQ_LIST_DB_UNION;

      SG_C_ASSERT(__sizeof__SQ_LIST_DB_UNION, sizeof (SQ_LIST_DB_UNION) == 4);
   #endif


#else
   // Post WRB Queue Doorbell Register used by the host Storage stack to notify the
   // controller of a posted Work Request Block
   #if defined(SG_BMAP_UNION)
      typedef struct _SQ_LIST_DB {
         union {
            struct { 
               u32 wrb_cid : 11;                  // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 wrb_index : 8;                 // DWORD 0
               u32 numberPosted : 8;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SQ_LIST_DB, *PSQ_LIST_DB;

      SG_C_ASSERT(__sizeof__SQ_LIST_DB, sizeof (SQ_LIST_DB) == 4);

   #else
      typedef struct _SQ_LIST_DB {
         u32 wrb_cid : 11;                        // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 wrb_index : 8;                       // DWORD 0
         u32 numberPosted : 8;                    // DWORD 0
      } SG_PACK SQ_LIST_DB, *PSQ_LIST_DB;

      typedef union _SQ_LIST_DB_UNION {
         SQ_LIST_DB bits;
         u32 dw; // dword union
      } SG_PACK SQ_LIST_DB_UNION, *PSQ_LIST_DB_UNION;

      SG_C_ASSERT(__sizeof__SQ_LIST_DB_UNION, sizeof (SQ_LIST_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Post WRB Queue Doorbell Register used by the host Storage stack to notify the
   // controller of a posted Work Request Block
   #if defined(SG_BMAP_UNION)
      typedef struct _WRB_POST_DB {
         union {
            struct { 
               u32 numberPosted : 8;              // DWORD 0
               u32 wrb_index : 8;                 // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 wrb_cid : 10;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WRB_POST_DB, *PWRB_POST_DB;

      SG_C_ASSERT(__sizeof__WRB_POST_DB, sizeof (WRB_POST_DB) == 4);

   #else
      typedef struct _WRB_POST_DB {
         u32 numberPosted : 8;                    // DWORD 0
         u32 wrb_index : 8;                       // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 wrb_cid : 10;                        // DWORD 0
      } SG_PACK WRB_POST_DB, *PWRB_POST_DB;

      typedef union _WRB_POST_DB_UNION {
         WRB_POST_DB bits;
         u32 dw; // dword union
      } SG_PACK WRB_POST_DB_UNION, *PWRB_POST_DB_UNION;

      SG_C_ASSERT(__sizeof__WRB_POST_DB_UNION, sizeof (WRB_POST_DB_UNION) == 4);
   #endif


#else
   // Post WRB Queue Doorbell Register used by the host Storage stack to notify the
   // controller of a posted Work Request Block
   #if defined(SG_BMAP_UNION)
      typedef struct _WRB_POST_DB {
         union {
            struct { 
               u32 wrb_cid : 10;                  // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 wrb_index : 8;                 // DWORD 0
               u32 numberPosted : 8;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WRB_POST_DB, *PWRB_POST_DB;

      SG_C_ASSERT(__sizeof__WRB_POST_DB, sizeof (WRB_POST_DB) == 4);

   #else
      typedef struct _WRB_POST_DB {
         u32 wrb_cid : 10;                        // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 wrb_index : 8;                       // DWORD 0
         u32 numberPosted : 8;                    // DWORD 0
      } SG_PACK WRB_POST_DB, *PWRB_POST_DB;

      typedef union _WRB_POST_DB_UNION {
         WRB_POST_DB bits;
         u32 dw; // dword union
      } SG_PACK WRB_POST_DB_UNION, *PWRB_POST_DB_UNION;

      SG_C_ASSERT(__sizeof__WRB_POST_DB_UNION, sizeof (WRB_POST_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Update Default PDU Queue Doorbell Register used to communicate to the controller
   // that the driver has stopped processing the queue and where in the queue it stopped,
   // this is a CQ Entry Type. Used by storage driver.
   #if defined(SG_BMAP_UNION)
      typedef struct _DEFAULT_PDU_DB {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 cqproc : 14;                   // DWORD 0
               u32 event : 1;                     // DWORD 0
               u32 rearm : 1;                     // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 qid : 10;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DEFAULT_PDU_DB, *PDEFAULT_PDU_DB;

      SG_C_ASSERT(__sizeof__DEFAULT_PDU_DB, sizeof (DEFAULT_PDU_DB) == 4);

   #else
      typedef struct _DEFAULT_PDU_DB {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 cqproc : 14;                         // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 rearm : 1;                           // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 qid : 10;                            // DWORD 0
      } SG_PACK DEFAULT_PDU_DB, *PDEFAULT_PDU_DB;

      typedef union _DEFAULT_PDU_DB_UNION {
         DEFAULT_PDU_DB bits;
         u32 dw; // dword union
      } SG_PACK DEFAULT_PDU_DB_UNION, *PDEFAULT_PDU_DB_UNION;

      SG_C_ASSERT(__sizeof__DEFAULT_PDU_DB_UNION, sizeof (DEFAULT_PDU_DB_UNION) == 4);
   #endif


#else
   // Update Default PDU Queue Doorbell Register used to communicate to the controller
   // that the driver has stopped processing the queue and where in the queue it stopped,
   // this is a CQ Entry Type. Used by storage driver.
   #if defined(SG_BMAP_UNION)
      typedef struct _DEFAULT_PDU_DB {
         union {
            struct { 
               u32 qid : 10;                      // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 rearm : 1;                     // DWORD 0
               u32 event : 1;                     // DWORD 0
               u32 cqproc : 14;                   // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DEFAULT_PDU_DB, *PDEFAULT_PDU_DB;

      SG_C_ASSERT(__sizeof__DEFAULT_PDU_DB, sizeof (DEFAULT_PDU_DB) == 4);

   #else
      typedef struct _DEFAULT_PDU_DB {
         u32 qid : 10;                            // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 rearm : 1;                           // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 cqproc : 14;                         // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK DEFAULT_PDU_DB, *PDEFAULT_PDU_DB;

      typedef union _DEFAULT_PDU_DB_UNION {
         DEFAULT_PDU_DB bits;
         u32 dw; // dword union
      } SG_PACK DEFAULT_PDU_DB_UNION, *PDEFAULT_PDU_DB_UNION;

      SG_C_ASSERT(__sizeof__DEFAULT_PDU_DB_UNION, sizeof (DEFAULT_PDU_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Management Command and Controller default fragment ring
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_DB {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 numPosted : 14;                // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 rid : 11;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MCC_DB, *PMCC_DB;

      SG_C_ASSERT(__sizeof__MCC_DB, sizeof (MCC_DB) == 4);

   #else
      typedef struct _MCC_DB {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 numPosted : 14;                      // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 rid : 11;                            // DWORD 0
      } SG_PACK MCC_DB, *PMCC_DB;

      typedef union _MCC_DB_UNION {
         MCC_DB bits;
         u32 dw; // dword union
      } SG_PACK MCC_DB_UNION, *PMCC_DB_UNION;

      SG_C_ASSERT(__sizeof__MCC_DB_UNION, sizeof (MCC_DB_UNION) == 4);
   #endif


#else
   // Management Command and Controller default fragment ring
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_DB {
         union {
            struct { 
               u32 rid : 11;                      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 numPosted : 14;                // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MCC_DB, *PMCC_DB;

      SG_C_ASSERT(__sizeof__MCC_DB, sizeof (MCC_DB) == 4);

   #else
      typedef struct _MCC_DB {
         u32 rid : 11;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 numPosted : 14;                      // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK MCC_DB, *PMCC_DB;

      typedef union _MCC_DB_UNION {
         MCC_DB bits;
         u32 dw; // dword union
      } SG_PACK MCC_DB_UNION, *PMCC_DB_UNION;

      SG_C_ASSERT(__sizeof__MCC_DB_UNION, sizeof (MCC_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GENERIC_DB {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GENERIC_DB, *PGENERIC_DB;

      SG_C_ASSERT(__sizeof__GENERIC_DB, sizeof (GENERIC_DB) == 4);

   #else
      typedef struct _GENERIC_DB {
         u32 data;                                // DWORD 0
      } SG_PACK GENERIC_DB, *PGENERIC_DB;

      typedef union _GENERIC_DB_UNION {
         GENERIC_DB bits;
         u32 dw; // dword union
      } SG_PACK GENERIC_DB_UNION, *PGENERIC_DB_UNION;

      SG_C_ASSERT(__sizeof__GENERIC_DB_UNION, sizeof (GENERIC_DB_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GENERIC_DB {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GENERIC_DB, *PGENERIC_DB;

      SG_C_ASSERT(__sizeof__GENERIC_DB, sizeof (GENERIC_DB) == 4);

   #else
      typedef struct _GENERIC_DB {
         u32 data;                                // DWORD 0
      } SG_PACK GENERIC_DB, *PGENERIC_DB;

      typedef union _GENERIC_DB_UNION {
         GENERIC_DB bits;
         u32 dw; // dword union
      } SG_PACK GENERIC_DB_UNION, *PGENERIC_DB_UNION;

      SG_C_ASSERT(__sizeof__GENERIC_DB_UNION, sizeof (GENERIC_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used for bootstrapping the Host interface. This register is used for driver
   // communication with the MPU when no MCC Rings exist.  The software must write this
   // register twice to post any MCC command. First, it writes the register with hi=1 and
   // the upper bits of the physical address for the MCC_MAILBOX structure. Software must
   // poll the ready bit until this is acknowledged. Then, sotware writes the register
   // with hi=0 with the lower bits in the address. It must poll the ready bit until the
   // MCC command is complete. Upon completion, the MCC_MAILBOX will contain a valid
   // completion queue entry. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_MAILBOX_DB {
         union {
            struct { 
               u32 address : 30;                  // DWORD 0
               u32 hi : 1;                        // DWORD 0
               u32 ready : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_MAILBOX_DB, *PMPU_MAILBOX_DB;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_DB, sizeof (MPU_MAILBOX_DB) == 4);

   #else
      typedef struct _MPU_MAILBOX_DB {
         u32 address : 30;                        // DWORD 0
         u32 hi : 1;                              // DWORD 0
         u32 ready : 1;                           // DWORD 0
      } SG_PACK MPU_MAILBOX_DB, *PMPU_MAILBOX_DB;

      typedef union _MPU_MAILBOX_DB_UNION {
         MPU_MAILBOX_DB bits;
         u32 dw; // dword union
      } SG_PACK MPU_MAILBOX_DB_UNION, *PMPU_MAILBOX_DB_UNION;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_DB_UNION, sizeof (MPU_MAILBOX_DB_UNION) == 4);
   #endif


#else
   // Used for bootstrapping the Host interface. This register is used for driver
   // communication with the MPU when no MCC Rings exist.  The software must write this
   // register twice to post any MCC command. First, it writes the register with hi=1 and
   // the upper bits of the physical address for the MCC_MAILBOX structure. Software must
   // poll the ready bit until this is acknowledged. Then, sotware writes the register
   // with hi=0 with the lower bits in the address. It must poll the ready bit until the
   // MCC command is complete. Upon completion, the MCC_MAILBOX will contain a valid
   // completion queue entry. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_MAILBOX_DB {
         union {
            struct { 
               u32 ready : 1;                     // DWORD 0
               u32 hi : 1;                        // DWORD 0
               u32 address : 30;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_MAILBOX_DB, *PMPU_MAILBOX_DB;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_DB, sizeof (MPU_MAILBOX_DB) == 4);

   #else
      typedef struct _MPU_MAILBOX_DB {
         u32 ready : 1;                           // DWORD 0
         u32 hi : 1;                              // DWORD 0
         u32 address : 30;                        // DWORD 0
      } SG_PACK MPU_MAILBOX_DB, *PMPU_MAILBOX_DB;

      typedef union _MPU_MAILBOX_DB_UNION {
         MPU_MAILBOX_DB bits;
         u32 dw; // dword union
      } SG_PACK MPU_MAILBOX_DB_UNION, *PMPU_MAILBOX_DB_UNION;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_DB_UNION, sizeof (MPU_MAILBOX_DB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   //  This is the protection domain doorbell register map. Note that while this map shows
   // doorbells for all Blade Engine supported protocols, not all of these may be valid in
   // a given function or protection domain. It is the responsibility of the application
   // accessing the doorbells to know which are valid. Each doorbell occupies 32 bytes of
   // space, but unless otherwise specified, only the first 4 bytes should be written.
   // </p>  There are 32 instances of these doorbells for the host and 31 virtual machines
   // respectively. The host and VMs will only map the doorbell pages belonging to its
   // protection domain. It will not be able to touch the doorbells for another VM. The
   // doorbells are the only registers directly accessible by a virtual machine.
   // Similarly, there are 511 additional doorbells for RDMA protection domains. PD 0 for
   // RDMA shares the same physical protection domain doorbell page as ETH/TOE/iSCSI. </p>
   #if defined(SG_BMAP_UNION)
      typedef struct _PROTECTION_DOMAIN_DBMAP {
         union {
            struct { 
               u32 rsvd0[16];                     // DWORDS 0 to 15
               GENERIC_DB txulp0_db;
               u32 rsvd1[7];                      // DWORDS 17 to 23
               GENERIC_DB txulp1_db;
               u32 rsvd2[7];                      // DWORDS 25 to 31
               GENERIC_DB txulp2_db;
               u32 rsvd3[7];                      // DWORDS 33 to 39
               GENERIC_DB rxulp0_db;
               u32 rsvd4[7];                      // DWORDS 41 to 47
               GENERIC_DB rxulp1_db;
               u32 rsvd5[7];                      // DWORDS 49 to 55
               GENERIC_DB rxulp2_db;
               u32 rsvd6[7];                      // DWORDS 57 to 63
               GENERIC_DB erx_db;
               u32 rsvd7[7];                      // DWORDS 65 to 71
               GENERIC_DB cq_db;
               u32 rsvd8[7];                      // DWORDS 73 to 79
               GENERIC_DB mpu_mcc_db;
               u32 rsvd9[7];                      // DWORDS 81 to 87
               GENERIC_DB mpu_mailbox_db;
               u32 rsvd10[935];                   // DWORDS 89 to 1023
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PROTECTION_DOMAIN_DBMAP, *PPROTECTION_DOMAIN_DBMAP;

      SG_C_ASSERT(__sizeof__PROTECTION_DOMAIN_DBMAP, sizeof (PROTECTION_DOMAIN_DBMAP) == 4096);

   #else
      typedef struct _PROTECTION_DOMAIN_DBMAP {
         u32 rsvd0[16];                           // DWORDS 0 to 15
         GENERIC_DB txulp0_db;
         u32 rsvd1[7];                            // DWORDS 17 to 23
         GENERIC_DB txulp1_db;
         u32 rsvd2[7];                            // DWORDS 25 to 31
         GENERIC_DB txulp2_db;
         u32 rsvd3[7];                            // DWORDS 33 to 39
         GENERIC_DB rxulp0_db;
         u32 rsvd4[7];                            // DWORDS 41 to 47
         GENERIC_DB rxulp1_db;
         u32 rsvd5[7];                            // DWORDS 49 to 55
         GENERIC_DB rxulp2_db;
         u32 rsvd6[7];                            // DWORDS 57 to 63
         GENERIC_DB erx_db;
         u32 rsvd7[7];                            // DWORDS 65 to 71
         GENERIC_DB cq_db;
         u32 rsvd8[7];                            // DWORDS 73 to 79
         GENERIC_DB mpu_mcc_db;
         u32 rsvd9[7];                            // DWORDS 81 to 87
         GENERIC_DB mpu_mailbox_db;
         u32 rsvd10[935];                         // DWORDS 89 to 1023
      } SG_PACK PROTECTION_DOMAIN_DBMAP, *PPROTECTION_DOMAIN_DBMAP;

      typedef union _PROTECTION_DOMAIN_DBMAP_UNION {
         PROTECTION_DOMAIN_DBMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PROTECTION_DOMAIN_DBMAP_UNION, *PPROTECTION_DOMAIN_DBMAP_UNION;

      SG_C_ASSERT(__sizeof__PROTECTION_DOMAIN_DBMAP_UNION, sizeof (PROTECTION_DOMAIN_DBMAP_UNION) == 4096);
   #endif


#else
   //  This is the protection domain doorbell register map. Note that while this map shows
   // doorbells for all Blade Engine supported protocols, not all of these may be valid in
   // a given function or protection domain. It is the responsibility of the application
   // accessing the doorbells to know which are valid. Each doorbell occupies 32 bytes of
   // space, but unless otherwise specified, only the first 4 bytes should be written.
   // </p>  There are 32 instances of these doorbells for the host and 31 virtual machines
   // respectively. The host and VMs will only map the doorbell pages belonging to its
   // protection domain. It will not be able to touch the doorbells for another VM. The
   // doorbells are the only registers directly accessible by a virtual machine.
   // Similarly, there are 511 additional doorbells for RDMA protection domains. PD 0 for
   // RDMA shares the same physical protection domain doorbell page as ETH/TOE/iSCSI. </p>
   #if defined(SG_BMAP_UNION)
      typedef struct _PROTECTION_DOMAIN_DBMAP {
         union {
            struct { 
               u32 rsvd0[16];                     // DWORDS 0 to 15
               GENERIC_DB txulp0_db;
               u32 rsvd1[7];                      // DWORDS 17 to 23
               GENERIC_DB txulp1_db;
               u32 rsvd2[7];                      // DWORDS 25 to 31
               GENERIC_DB txulp2_db;
               u32 rsvd3[7];                      // DWORDS 33 to 39
               GENERIC_DB rxulp0_db;
               u32 rsvd4[7];                      // DWORDS 41 to 47
               GENERIC_DB rxulp1_db;
               u32 rsvd5[7];                      // DWORDS 49 to 55
               GENERIC_DB rxulp2_db;
               u32 rsvd6[7];                      // DWORDS 57 to 63
               GENERIC_DB erx_db;
               u32 rsvd7[7];                      // DWORDS 65 to 71
               GENERIC_DB cq_db;
               u32 rsvd8[7];                      // DWORDS 73 to 79
               GENERIC_DB mpu_mcc_db;
               u32 rsvd9[7];                      // DWORDS 81 to 87
               GENERIC_DB mpu_mailbox_db;
               u32 rsvd10[935];                   // DWORDS 89 to 1023
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PROTECTION_DOMAIN_DBMAP, *PPROTECTION_DOMAIN_DBMAP;

      SG_C_ASSERT(__sizeof__PROTECTION_DOMAIN_DBMAP, sizeof (PROTECTION_DOMAIN_DBMAP) == 4096);

   #else
      typedef struct _PROTECTION_DOMAIN_DBMAP {
         u32 rsvd0[16];                           // DWORDS 0 to 15
         GENERIC_DB txulp0_db;
         u32 rsvd1[7];                            // DWORDS 17 to 23
         GENERIC_DB txulp1_db;
         u32 rsvd2[7];                            // DWORDS 25 to 31
         GENERIC_DB txulp2_db;
         u32 rsvd3[7];                            // DWORDS 33 to 39
         GENERIC_DB rxulp0_db;
         u32 rsvd4[7];                            // DWORDS 41 to 47
         GENERIC_DB rxulp1_db;
         u32 rsvd5[7];                            // DWORDS 49 to 55
         GENERIC_DB rxulp2_db;
         u32 rsvd6[7];                            // DWORDS 57 to 63
         GENERIC_DB erx_db;
         u32 rsvd7[7];                            // DWORDS 65 to 71
         GENERIC_DB cq_db;
         u32 rsvd8[7];                            // DWORDS 73 to 79
         GENERIC_DB mpu_mcc_db;
         u32 rsvd9[7];                            // DWORDS 81 to 87
         GENERIC_DB mpu_mailbox_db;
         u32 rsvd10[935];                         // DWORDS 89 to 1023
      } SG_PACK PROTECTION_DOMAIN_DBMAP, *PPROTECTION_DOMAIN_DBMAP;

      typedef union _PROTECTION_DOMAIN_DBMAP_UNION {
         PROTECTION_DOMAIN_DBMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PROTECTION_DOMAIN_DBMAP_UNION, *PPROTECTION_DOMAIN_DBMAP_UNION;

      SG_C_ASSERT(__sizeof__PROTECTION_DOMAIN_DBMAP_UNION, sizeof (PROTECTION_DOMAIN_DBMAP_UNION) == 4096);
   #endif


#endif
#ifdef SG_OMIT_64KB_STRUCTS
   typedef struct _BLADE_ENGINE_PCI0_DBMAP {
      u32 rsvd; // Dummy member for >=64kB struct
   } SG_PACK BLADE_ENGINE_PCI0_DBMAP, *PBLADE_ENGINE_PCI0_DBMAP;
#else
   #if defined(SG_REVERSE_ENDIAN)
      // The Blade Engine storage function (PCI function 0) requires 32 doorbell pages (up
      // to 32 protection domains). 
      #if defined(SG_BMAP_UNION)
         typedef struct _BLADE_ENGINE_PCI0_DBMAP {
            union {
               struct { 
                  PROTECTION_DOMAIN_DBMAP pci_func0_protection_domain_dbmap[32];
               } SG_PACK ; // unnamed struct
               u32 dw[32768]; // dword union
            }; // unnamed union
         } SG_PACK BLADE_ENGINE_PCI0_DBMAP, *PBLADE_ENGINE_PCI0_DBMAP;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_PCI0_DBMAP, sizeof (BLADE_ENGINE_PCI0_DBMAP) == 131072);

      #else
         typedef struct _BLADE_ENGINE_PCI0_DBMAP {
            PROTECTION_DOMAIN_DBMAP pci_func0_protection_domain_dbmap[32];
         } SG_PACK BLADE_ENGINE_PCI0_DBMAP, *PBLADE_ENGINE_PCI0_DBMAP;

         typedef union _BLADE_ENGINE_PCI0_DBMAP_UNION {
            BLADE_ENGINE_PCI0_DBMAP bits;
            u32 dw[32768]; // dword union
         } SG_PACK BLADE_ENGINE_PCI0_DBMAP_UNION, *PBLADE_ENGINE_PCI0_DBMAP_UNION;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_PCI0_DBMAP_UNION, sizeof (BLADE_ENGINE_PCI0_DBMAP_UNION) == 131072);
      #endif


   #else
      // The Blade Engine storage function (PCI function 0) requires 32 doorbell pages (up
      // to 32 protection domains). 
      #if defined(SG_BMAP_UNION)
         typedef struct _BLADE_ENGINE_PCI0_DBMAP {
            union {
               struct { 
                  PROTECTION_DOMAIN_DBMAP pci_func0_protection_domain_dbmap[32];
               } SG_PACK ; // unnamed struct
               u32 dw[32768]; // dword union
            }; // unnamed union
         } SG_PACK BLADE_ENGINE_PCI0_DBMAP, *PBLADE_ENGINE_PCI0_DBMAP;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_PCI0_DBMAP, sizeof (BLADE_ENGINE_PCI0_DBMAP) == 131072);

      #else
         typedef struct _BLADE_ENGINE_PCI0_DBMAP {
            PROTECTION_DOMAIN_DBMAP pci_func0_protection_domain_dbmap[32];
         } SG_PACK BLADE_ENGINE_PCI0_DBMAP, *PBLADE_ENGINE_PCI0_DBMAP;

         typedef union _BLADE_ENGINE_PCI0_DBMAP_UNION {
            BLADE_ENGINE_PCI0_DBMAP bits;
            u32 dw[32768]; // dword union
         } SG_PACK BLADE_ENGINE_PCI0_DBMAP_UNION, *PBLADE_ENGINE_PCI0_DBMAP_UNION;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_PCI0_DBMAP_UNION, sizeof (BLADE_ENGINE_PCI0_DBMAP_UNION) == 131072);
      #endif


   #endif
#endif // SG_OMIT_64KB_STRUCTS
#ifdef SG_OMIT_64KB_STRUCTS
   typedef struct _BLADE_ENGINE_PCI1_DBMAP {
      u32 rsvd; // Dummy member for >=64kB struct
   } SG_PACK BLADE_ENGINE_PCI1_DBMAP, *PBLADE_ENGINE_PCI1_DBMAP;
#else
   #if defined(SG_REVERSE_ENDIAN)
      // The Blade Engine network function (PCI function 1) requires 543 doorbell pages
      // (up to 32 for protection domain pages and an additional 511 specific to RDMA). 
      #if defined(SG_BMAP_UNION)
         typedef struct _BLADE_ENGINE_PCI1_DBMAP {
            union {
               struct { 
                  PROTECTION_DOMAIN_DBMAP pci_func1_protection_domain_dbmap[32];
                  PROTECTION_DOMAIN_DBMAP pci_func1_protection_domain_dbmap_rdma[511];
               } SG_PACK ; // unnamed struct
               u32 dw[556032]; // dword union
            }; // unnamed union
         } SG_PACK BLADE_ENGINE_PCI1_DBMAP, *PBLADE_ENGINE_PCI1_DBMAP;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_PCI1_DBMAP, sizeof (BLADE_ENGINE_PCI1_DBMAP) == 2224128);

      #else
         typedef struct _BLADE_ENGINE_PCI1_DBMAP {
            PROTECTION_DOMAIN_DBMAP pci_func1_protection_domain_dbmap[32];
            PROTECTION_DOMAIN_DBMAP pci_func1_protection_domain_dbmap_rdma[511];
         } SG_PACK BLADE_ENGINE_PCI1_DBMAP, *PBLADE_ENGINE_PCI1_DBMAP;

         typedef union _BLADE_ENGINE_PCI1_DBMAP_UNION {
            BLADE_ENGINE_PCI1_DBMAP bits;
            u32 dw[556032]; // dword union
         } SG_PACK BLADE_ENGINE_PCI1_DBMAP_UNION, *PBLADE_ENGINE_PCI1_DBMAP_UNION;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_PCI1_DBMAP_UNION, sizeof (BLADE_ENGINE_PCI1_DBMAP_UNION) == 2224128);
      #endif


   #else
      // The Blade Engine network function (PCI function 1) requires 543 doorbell pages
      // (up to 32 for protection domain pages and an additional 511 specific to RDMA). 
      #if defined(SG_BMAP_UNION)
         typedef struct _BLADE_ENGINE_PCI1_DBMAP {
            union {
               struct { 
                  PROTECTION_DOMAIN_DBMAP pci_func1_protection_domain_dbmap[32];
                  PROTECTION_DOMAIN_DBMAP pci_func1_protection_domain_dbmap_rdma[511];
               } SG_PACK ; // unnamed struct
               u32 dw[556032]; // dword union
            }; // unnamed union
         } SG_PACK BLADE_ENGINE_PCI1_DBMAP, *PBLADE_ENGINE_PCI1_DBMAP;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_PCI1_DBMAP, sizeof (BLADE_ENGINE_PCI1_DBMAP) == 2224128);

      #else
         typedef struct _BLADE_ENGINE_PCI1_DBMAP {
            PROTECTION_DOMAIN_DBMAP pci_func1_protection_domain_dbmap[32];
            PROTECTION_DOMAIN_DBMAP pci_func1_protection_domain_dbmap_rdma[511];
         } SG_PACK BLADE_ENGINE_PCI1_DBMAP, *PBLADE_ENGINE_PCI1_DBMAP;

         typedef union _BLADE_ENGINE_PCI1_DBMAP_UNION {
            BLADE_ENGINE_PCI1_DBMAP bits;
            u32 dw[556032]; // dword union
         } SG_PACK BLADE_ENGINE_PCI1_DBMAP_UNION, *PBLADE_ENGINE_PCI1_DBMAP_UNION;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_PCI1_DBMAP_UNION, sizeof (BLADE_ENGINE_PCI1_DBMAP_UNION) == 2224128);
      #endif


   #endif
#endif // SG_OMIT_64KB_STRUCTS

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __doorbells_bmap_h__

