/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ep_queue_bmap_h__
#define __ep_queue_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "headers_bmap.h"
#include "descriptors_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Unload Order Format. The EP hardware expects unload order lists to start on a 8
   // byte(64 bit) boundary
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_UNLOAD_ORDER {
         union {
            struct { 
               u32 seq : 2;                       // DWORD 0
               u32 fence : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 type : 4;                      // DWORD 0
               u32 address : 12;                  // DWORD 0
               u32 length : 12;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_UNLOAD_ORDER, *PEP_UNLOAD_ORDER;

      SG_C_ASSERT(__sizeof__EP_UNLOAD_ORDER, sizeof (EP_UNLOAD_ORDER) == 4);

   #else
      typedef struct _EP_UNLOAD_ORDER {
         u32 seq : 2;                             // DWORD 0
         u32 fence : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 type : 4;                            // DWORD 0
         u32 address : 12;                        // DWORD 0
         u32 length : 12;                         // DWORD 0
      } SG_PACK EP_UNLOAD_ORDER, *PEP_UNLOAD_ORDER;

      typedef union _EP_UNLOAD_ORDER_UNION {
         EP_UNLOAD_ORDER bits;
         u32 dw; // dword union
      } SG_PACK EP_UNLOAD_ORDER_UNION, *PEP_UNLOAD_ORDER_UNION;

      SG_C_ASSERT(__sizeof__EP_UNLOAD_ORDER_UNION, sizeof (EP_UNLOAD_ORDER_UNION) == 4);
   #endif


#else
   // Unload Order Format. The EP hardware expects unload order lists to start on a 8
   // byte(64 bit) boundary
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_UNLOAD_ORDER {
         union {
            struct { 
               u32 length : 12;                   // DWORD 0
               u32 address : 12;                  // DWORD 0
               u32 type : 4;                      // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 fence : 1;                     // DWORD 0
               u32 seq : 2;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_UNLOAD_ORDER, *PEP_UNLOAD_ORDER;

      SG_C_ASSERT(__sizeof__EP_UNLOAD_ORDER, sizeof (EP_UNLOAD_ORDER) == 4);

   #else
      typedef struct _EP_UNLOAD_ORDER {
         u32 length : 12;                         // DWORD 0
         u32 address : 12;                        // DWORD 0
         u32 type : 4;                            // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 fence : 1;                           // DWORD 0
         u32 seq : 2;                             // DWORD 0
      } SG_PACK EP_UNLOAD_ORDER, *PEP_UNLOAD_ORDER;

      typedef union _EP_UNLOAD_ORDER_UNION {
         EP_UNLOAD_ORDER bits;
         u32 dw; // dword union
      } SG_PACK EP_UNLOAD_ORDER_UNION, *PEP_UNLOAD_ORDER_UNION;

      SG_C_ASSERT(__sizeof__EP_UNLOAD_ORDER_UNION, sizeof (EP_UNLOAD_ORDER_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Fence Unload Order Format. Read the section on special unload orders for further
   // information.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_FENCE_UNLOAD_ORDER {
         union {
            struct { 
               u32 seq : 2;                       // DWORD 0
               u32 fence : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 fenced_queues : 16;            // DWORD 0
               u32 length : 12;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_FENCE_UNLOAD_ORDER, *PEP_FENCE_UNLOAD_ORDER;

      SG_C_ASSERT(__sizeof__EP_FENCE_UNLOAD_ORDER, sizeof (EP_FENCE_UNLOAD_ORDER) == 4);

   #else
      typedef struct _EP_FENCE_UNLOAD_ORDER {
         u32 seq : 2;                             // DWORD 0
         u32 fence : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 fenced_queues : 16;                  // DWORD 0
         u32 length : 12;                         // DWORD 0
      } SG_PACK EP_FENCE_UNLOAD_ORDER, *PEP_FENCE_UNLOAD_ORDER;

      typedef union _EP_FENCE_UNLOAD_ORDER_UNION {
         EP_FENCE_UNLOAD_ORDER bits;
         u32 dw; // dword union
      } SG_PACK EP_FENCE_UNLOAD_ORDER_UNION, *PEP_FENCE_UNLOAD_ORDER_UNION;

      SG_C_ASSERT(__sizeof__EP_FENCE_UNLOAD_ORDER_UNION, sizeof (EP_FENCE_UNLOAD_ORDER_UNION) == 4);
   #endif


#else
   // Fence Unload Order Format. Read the section on special unload orders for further
   // information.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_FENCE_UNLOAD_ORDER {
         union {
            struct { 
               u32 length : 12;                   // DWORD 0
               u32 fenced_queues : 16;            // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 fence : 1;                     // DWORD 0
               u32 seq : 2;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_FENCE_UNLOAD_ORDER, *PEP_FENCE_UNLOAD_ORDER;

      SG_C_ASSERT(__sizeof__EP_FENCE_UNLOAD_ORDER, sizeof (EP_FENCE_UNLOAD_ORDER) == 4);

   #else
      typedef struct _EP_FENCE_UNLOAD_ORDER {
         u32 length : 12;                         // DWORD 0
         u32 fenced_queues : 16;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 fence : 1;                           // DWORD 0
         u32 seq : 2;                             // DWORD 0
      } SG_PACK EP_FENCE_UNLOAD_ORDER, *PEP_FENCE_UNLOAD_ORDER;

      typedef union _EP_FENCE_UNLOAD_ORDER_UNION {
         EP_FENCE_UNLOAD_ORDER bits;
         u32 dw; // dword union
      } SG_PACK EP_FENCE_UNLOAD_ORDER_UNION, *PEP_FENCE_UNLOAD_ORDER_UNION;

      SG_C_ASSERT(__sizeof__EP_FENCE_UNLOAD_ORDER_UNION, sizeof (EP_FENCE_UNLOAD_ORDER_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_QCR_FORMAT {
         union {
            struct { 
               u32 not_classified : 1;            // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 hold_ack_immed_u1p1 : 1;       // DWORD 0
               u32 hold_ack_immed_u1p0 : 1;       // DWORD 0
               u32 ts_found : 1;                  // DWORD 0
               u32 valid_ack : 1;                 // DWORD 0
               u32 hold_ack_immed_u0p1 : 1;       // DWORD 0
               u32 hold_ack_immed_u0p0 : 1;       // DWORD 0
               u32 red_global : 1;                // DWORD 0
               u32 red_ulp2 : 1;                  // DWORD 0
               u32 red_ulp1 : 1;                  // DWORD 0
               u32 dbcred_check : 1;              // DWORD 0
               u32 header_prediction : 1;         // DWORD 0
               u32 rst : 1;                       // DWORD 0
               u32 ooo_fin : 1;                   // DWORD 0
               u32 fin : 1;                       // DWORD 0
               u32 dup_ack : 1;                   // DWORD 0
               u32 pure_ack : 1;                  // DWORD 0
               u32 in_line_plugs_hole : 1;        // DWORD 0
               u32 ooo_prepend : 1;               // DWORD 0
               u32 ooo_append : 1;                // DWORD 0
               u32 new_ooo : 1;                   // DWORD 0
               u32 ooo : 1;                       // DWORD 0
               u32 pure_in_line : 1;              // DWORD 0
               u32 in_line : 1;                   // DWORD 0
               u32 syn_seg : 1;                   // DWORD 0
               u32 reply_by_dropping : 1;         // DWORD 0
               u32 reply_with_ack : 1;            // DWORD 0
               u32 record_timestamp : 1;          // DWORD 0
               u32 acceptable_seqack : 1;         // DWORD 0
               u32 acceptable_ack : 1;            // DWORD 0
               u32 acceptable_seq : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_QCR_FORMAT, *PTPRE_QCR_FORMAT;

      SG_C_ASSERT(__sizeof__TPRE_QCR_FORMAT, sizeof (TPRE_QCR_FORMAT) == 4);

   #else
      typedef struct _TPRE_QCR_FORMAT {
         u32 not_classified : 1;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 hold_ack_immed_u1p1 : 1;             // DWORD 0
         u32 hold_ack_immed_u1p0 : 1;             // DWORD 0
         u32 ts_found : 1;                        // DWORD 0
         u32 valid_ack : 1;                       // DWORD 0
         u32 hold_ack_immed_u0p1 : 1;             // DWORD 0
         u32 hold_ack_immed_u0p0 : 1;             // DWORD 0
         u32 red_global : 1;                      // DWORD 0
         u32 red_ulp2 : 1;                        // DWORD 0
         u32 red_ulp1 : 1;                        // DWORD 0
         u32 dbcred_check : 1;                    // DWORD 0
         u32 header_prediction : 1;               // DWORD 0
         u32 rst : 1;                             // DWORD 0
         u32 ooo_fin : 1;                         // DWORD 0
         u32 fin : 1;                             // DWORD 0
         u32 dup_ack : 1;                         // DWORD 0
         u32 pure_ack : 1;                        // DWORD 0
         u32 in_line_plugs_hole : 1;              // DWORD 0
         u32 ooo_prepend : 1;                     // DWORD 0
         u32 ooo_append : 1;                      // DWORD 0
         u32 new_ooo : 1;                         // DWORD 0
         u32 ooo : 1;                             // DWORD 0
         u32 pure_in_line : 1;                    // DWORD 0
         u32 in_line : 1;                         // DWORD 0
         u32 syn_seg : 1;                         // DWORD 0
         u32 reply_by_dropping : 1;               // DWORD 0
         u32 reply_with_ack : 1;                  // DWORD 0
         u32 record_timestamp : 1;                // DWORD 0
         u32 acceptable_seqack : 1;               // DWORD 0
         u32 acceptable_ack : 1;                  // DWORD 0
         u32 acceptable_seq : 1;                  // DWORD 0
      } SG_PACK TPRE_QCR_FORMAT, *PTPRE_QCR_FORMAT;

      typedef union _TPRE_QCR_FORMAT_UNION {
         TPRE_QCR_FORMAT bits;
         u32 dw; // dword union
      } SG_PACK TPRE_QCR_FORMAT_UNION, *PTPRE_QCR_FORMAT_UNION;

      SG_C_ASSERT(__sizeof__TPRE_QCR_FORMAT_UNION, sizeof (TPRE_QCR_FORMAT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_QCR_FORMAT {
         union {
            struct { 
               u32 acceptable_seq : 1;            // DWORD 0
               u32 acceptable_ack : 1;            // DWORD 0
               u32 acceptable_seqack : 1;         // DWORD 0
               u32 record_timestamp : 1;          // DWORD 0
               u32 reply_with_ack : 1;            // DWORD 0
               u32 reply_by_dropping : 1;         // DWORD 0
               u32 syn_seg : 1;                   // DWORD 0
               u32 in_line : 1;                   // DWORD 0
               u32 pure_in_line : 1;              // DWORD 0
               u32 ooo : 1;                       // DWORD 0
               u32 new_ooo : 1;                   // DWORD 0
               u32 ooo_append : 1;                // DWORD 0
               u32 ooo_prepend : 1;               // DWORD 0
               u32 in_line_plugs_hole : 1;        // DWORD 0
               u32 pure_ack : 1;                  // DWORD 0
               u32 dup_ack : 1;                   // DWORD 0
               u32 fin : 1;                       // DWORD 0
               u32 ooo_fin : 1;                   // DWORD 0
               u32 rst : 1;                       // DWORD 0
               u32 header_prediction : 1;         // DWORD 0
               u32 dbcred_check : 1;              // DWORD 0
               u32 red_ulp1 : 1;                  // DWORD 0
               u32 red_ulp2 : 1;                  // DWORD 0
               u32 red_global : 1;                // DWORD 0
               u32 hold_ack_immed_u0p0 : 1;       // DWORD 0
               u32 hold_ack_immed_u0p1 : 1;       // DWORD 0
               u32 valid_ack : 1;                 // DWORD 0
               u32 ts_found : 1;                  // DWORD 0
               u32 hold_ack_immed_u1p0 : 1;       // DWORD 0
               u32 hold_ack_immed_u1p1 : 1;       // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 not_classified : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_QCR_FORMAT, *PTPRE_QCR_FORMAT;

      SG_C_ASSERT(__sizeof__TPRE_QCR_FORMAT, sizeof (TPRE_QCR_FORMAT) == 4);

   #else
      typedef struct _TPRE_QCR_FORMAT {
         u32 acceptable_seq : 1;                  // DWORD 0
         u32 acceptable_ack : 1;                  // DWORD 0
         u32 acceptable_seqack : 1;               // DWORD 0
         u32 record_timestamp : 1;                // DWORD 0
         u32 reply_with_ack : 1;                  // DWORD 0
         u32 reply_by_dropping : 1;               // DWORD 0
         u32 syn_seg : 1;                         // DWORD 0
         u32 in_line : 1;                         // DWORD 0
         u32 pure_in_line : 1;                    // DWORD 0
         u32 ooo : 1;                             // DWORD 0
         u32 new_ooo : 1;                         // DWORD 0
         u32 ooo_append : 1;                      // DWORD 0
         u32 ooo_prepend : 1;                     // DWORD 0
         u32 in_line_plugs_hole : 1;              // DWORD 0
         u32 pure_ack : 1;                        // DWORD 0
         u32 dup_ack : 1;                         // DWORD 0
         u32 fin : 1;                             // DWORD 0
         u32 ooo_fin : 1;                         // DWORD 0
         u32 rst : 1;                             // DWORD 0
         u32 header_prediction : 1;               // DWORD 0
         u32 dbcred_check : 1;                    // DWORD 0
         u32 red_ulp1 : 1;                        // DWORD 0
         u32 red_ulp2 : 1;                        // DWORD 0
         u32 red_global : 1;                      // DWORD 0
         u32 hold_ack_immed_u0p0 : 1;             // DWORD 0
         u32 hold_ack_immed_u0p1 : 1;             // DWORD 0
         u32 valid_ack : 1;                       // DWORD 0
         u32 ts_found : 1;                        // DWORD 0
         u32 hold_ack_immed_u1p0 : 1;             // DWORD 0
         u32 hold_ack_immed_u1p1 : 1;             // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 not_classified : 1;                  // DWORD 0
      } SG_PACK TPRE_QCR_FORMAT, *PTPRE_QCR_FORMAT;

      typedef union _TPRE_QCR_FORMAT_UNION {
         TPRE_QCR_FORMAT bits;
         u32 dw; // dword union
      } SG_PACK TPRE_QCR_FORMAT_UNION, *PTPRE_QCR_FORMAT_UNION;

      SG_C_ASSERT(__sizeof__TPRE_QCR_FORMAT_UNION, sizeof (TPRE_QCR_FORMAT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_PBUF_PACKET_HEADERS {
         union {
            struct { 
               ETH_HEADER eth_header;
               SNAP_HEADER snap_header;
               IP_HEADER ip_header;
               TCP_HEADER tcp_header;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_PBUF_PACKET_HEADERS, *PTPRE_PBUF_PACKET_HEADERS;

      SG_C_ASSERT(__sizeof__TPRE_PBUF_PACKET_HEADERS, sizeof (TPRE_PBUF_PACKET_HEADERS) == 64);

   #else
      typedef struct _TPRE_PBUF_PACKET_HEADERS {
         ETH_HEADER eth_header;
         SNAP_HEADER snap_header;
         IP_HEADER ip_header;
         TCP_HEADER tcp_header;
      } SG_PACK TPRE_PBUF_PACKET_HEADERS, *PTPRE_PBUF_PACKET_HEADERS;

      typedef union _TPRE_PBUF_PACKET_HEADERS_UNION {
         TPRE_PBUF_PACKET_HEADERS bits;
         u32 dw[16]; // dword union
      } SG_PACK TPRE_PBUF_PACKET_HEADERS_UNION, *PTPRE_PBUF_PACKET_HEADERS_UNION;

      SG_C_ASSERT(__sizeof__TPRE_PBUF_PACKET_HEADERS_UNION, sizeof (TPRE_PBUF_PACKET_HEADERS_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_PBUF_PACKET_HEADERS {
         union {
            struct { 
               ETH_HEADER eth_header;
               SNAP_HEADER snap_header;
               IP_HEADER ip_header;
               TCP_HEADER tcp_header;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_PBUF_PACKET_HEADERS, *PTPRE_PBUF_PACKET_HEADERS;

      SG_C_ASSERT(__sizeof__TPRE_PBUF_PACKET_HEADERS, sizeof (TPRE_PBUF_PACKET_HEADERS) == 64);

   #else
      typedef struct _TPRE_PBUF_PACKET_HEADERS {
         ETH_HEADER eth_header;
         SNAP_HEADER snap_header;
         IP_HEADER ip_header;
         TCP_HEADER tcp_header;
      } SG_PACK TPRE_PBUF_PACKET_HEADERS, *PTPRE_PBUF_PACKET_HEADERS;

      typedef union _TPRE_PBUF_PACKET_HEADERS_UNION {
         TPRE_PBUF_PACKET_HEADERS bits;
         u32 dw[16]; // dword union
      } SG_PACK TPRE_PBUF_PACKET_HEADERS_UNION, *PTPRE_PBUF_PACKET_HEADERS_UNION;

      SG_C_ASSERT(__sizeof__TPRE_PBUF_PACKET_HEADERS_UNION, sizeof (TPRE_PBUF_PACKET_HEADERS_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_IMM_ACK_DATA {
         union {
            struct { 
               TPRE_TPOST_IMMACK_D transmit_descr;
               TPRE_PBUF_PACKET_HEADERS packet_data;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_IMM_ACK_DATA, *PTPRE_IMM_ACK_DATA;

      SG_C_ASSERT(__sizeof__TPRE_IMM_ACK_DATA, sizeof (TPRE_IMM_ACK_DATA) == 72);

   #else
      typedef struct _TPRE_IMM_ACK_DATA {
         TPRE_TPOST_IMMACK_D transmit_descr;
         TPRE_PBUF_PACKET_HEADERS packet_data;
      } SG_PACK TPRE_IMM_ACK_DATA, *PTPRE_IMM_ACK_DATA;

      typedef union _TPRE_IMM_ACK_DATA_UNION {
         TPRE_IMM_ACK_DATA bits;
         u32 dw[18]; // dword union
      } SG_PACK TPRE_IMM_ACK_DATA_UNION, *PTPRE_IMM_ACK_DATA_UNION;

      SG_C_ASSERT(__sizeof__TPRE_IMM_ACK_DATA_UNION, sizeof (TPRE_IMM_ACK_DATA_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_IMM_ACK_DATA {
         union {
            struct { 
               TPRE_TPOST_IMMACK_D transmit_descr;
               TPRE_PBUF_PACKET_HEADERS packet_data;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_IMM_ACK_DATA, *PTPRE_IMM_ACK_DATA;

      SG_C_ASSERT(__sizeof__TPRE_IMM_ACK_DATA, sizeof (TPRE_IMM_ACK_DATA) == 72);

   #else
      typedef struct _TPRE_IMM_ACK_DATA {
         TPRE_TPOST_IMMACK_D transmit_descr;
         TPRE_PBUF_PACKET_HEADERS packet_data;
      } SG_PACK TPRE_IMM_ACK_DATA, *PTPRE_IMM_ACK_DATA;

      typedef union _TPRE_IMM_ACK_DATA_UNION {
         TPRE_IMM_ACK_DATA bits;
         u32 dw[18]; // dword union
      } SG_PACK TPRE_IMM_ACK_DATA_UNION, *PTPRE_IMM_ACK_DATA_UNION;

      SG_C_ASSERT(__sizeof__TPRE_IMM_ACK_DATA_UNION, sizeof (TPRE_IMM_ACK_DATA_UNION) == 72);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ep_queue_bmap_h__

