/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __erx_bmap_h__
#define __erx_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "pq_bmap.h"
#include "gencommon_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Ethernet RX Configuration
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_CFG_CSR {
         union {
            struct { 
               u32 rsvd2 : 5;                     // DWORD 0
               u32 ring_sram_init_done : 1;       // DWORD 0
               u32 rss_flush_sec_dma_echo : 1;    // DWORD 0
               u32 rss_flush_first_dma_echo : 1;  // DWORD 0
               u32 port1_def_ring : 1;            // DWORD 0
               u32 port0_def_ring : 1;            // DWORD 0
               u32 cev_swap_cntl : 2;             // DWORD 0
               u32 wdma_swap_cntl : 2;            // DWORD 0
               u32 rdma_swap_cntl : 2;            // DWORD 0
               u32 dis_pkt_rep : 1;               // DWORD 0
               u32 btlr_pd0_promiscuous : 1;      // DWORD 0
               u32 btlr_ignore_pdid : 1;          // DWORD 0
               u32 btlr_ignore_fid : 1;           // DWORD 0
               u32 btlr_ignore_partial_fid : 1;   // DWORD 0
               u32 slowdown_dbuf_prefetch : 1;    // DWORD 0
               u32 oord : 1;                      // DWORD 0
               u32 disable_dbuf_prefetch : 1;     // DWORD 0
               u32 intr_wm : 2;                   // DWORD 0
               u32 fetch_wm : 2;                  // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_CFG_CSR, *PERX_CFG_CSR;

      SG_C_ASSERT(__sizeof__ERX_CFG_CSR, sizeof (ERX_CFG_CSR) == 4);

   #else
      typedef struct _ERX_CFG_CSR {
         u32 rsvd2 : 5;                           // DWORD 0
         u32 ring_sram_init_done : 1;             // DWORD 0
         u32 rss_flush_sec_dma_echo : 1;          // DWORD 0
         u32 rss_flush_first_dma_echo : 1;        // DWORD 0
         u32 port1_def_ring : 1;                  // DWORD 0
         u32 port0_def_ring : 1;                  // DWORD 0
         u32 cev_swap_cntl : 2;                   // DWORD 0
         u32 wdma_swap_cntl : 2;                  // DWORD 0
         u32 rdma_swap_cntl : 2;                  // DWORD 0
         u32 dis_pkt_rep : 1;                     // DWORD 0
         u32 btlr_pd0_promiscuous : 1;            // DWORD 0
         u32 btlr_ignore_pdid : 1;                // DWORD 0
         u32 btlr_ignore_fid : 1;                 // DWORD 0
         u32 btlr_ignore_partial_fid : 1;         // DWORD 0
         u32 slowdown_dbuf_prefetch : 1;          // DWORD 0
         u32 oord : 1;                            // DWORD 0
         u32 disable_dbuf_prefetch : 1;           // DWORD 0
         u32 intr_wm : 2;                         // DWORD 0
         u32 fetch_wm : 2;                        // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
      } SG_PACK ERX_CFG_CSR, *PERX_CFG_CSR;

      typedef union _ERX_CFG_CSR_UNION {
         ERX_CFG_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_CFG_CSR_UNION, *PERX_CFG_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_CFG_CSR_UNION, sizeof (ERX_CFG_CSR_UNION) == 4);
   #endif


#else
   // Ethernet RX Configuration
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_CFG_CSR {
         union {
            struct { 
               u32 rsvd0 : 3;                     // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 fetch_wm : 2;                  // DWORD 0
               u32 intr_wm : 2;                   // DWORD 0
               u32 disable_dbuf_prefetch : 1;     // DWORD 0
               u32 oord : 1;                      // DWORD 0
               u32 slowdown_dbuf_prefetch : 1;    // DWORD 0
               u32 btlr_ignore_partial_fid : 1;   // DWORD 0
               u32 btlr_ignore_fid : 1;           // DWORD 0
               u32 btlr_ignore_pdid : 1;          // DWORD 0
               u32 btlr_pd0_promiscuous : 1;      // DWORD 0
               u32 dis_pkt_rep : 1;               // DWORD 0
               u32 rdma_swap_cntl : 2;            // DWORD 0
               u32 wdma_swap_cntl : 2;            // DWORD 0
               u32 cev_swap_cntl : 2;             // DWORD 0
               u32 port0_def_ring : 1;            // DWORD 0
               u32 port1_def_ring : 1;            // DWORD 0
               u32 rss_flush_first_dma_echo : 1;  // DWORD 0
               u32 rss_flush_sec_dma_echo : 1;    // DWORD 0
               u32 ring_sram_init_done : 1;       // DWORD 0
               u32 rsvd2 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_CFG_CSR, *PERX_CFG_CSR;

      SG_C_ASSERT(__sizeof__ERX_CFG_CSR, sizeof (ERX_CFG_CSR) == 4);

   #else
      typedef struct _ERX_CFG_CSR {
         u32 rsvd0 : 3;                           // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 fetch_wm : 2;                        // DWORD 0
         u32 intr_wm : 2;                         // DWORD 0
         u32 disable_dbuf_prefetch : 1;           // DWORD 0
         u32 oord : 1;                            // DWORD 0
         u32 slowdown_dbuf_prefetch : 1;          // DWORD 0
         u32 btlr_ignore_partial_fid : 1;         // DWORD 0
         u32 btlr_ignore_fid : 1;                 // DWORD 0
         u32 btlr_ignore_pdid : 1;                // DWORD 0
         u32 btlr_pd0_promiscuous : 1;            // DWORD 0
         u32 dis_pkt_rep : 1;                     // DWORD 0
         u32 rdma_swap_cntl : 2;                  // DWORD 0
         u32 wdma_swap_cntl : 2;                  // DWORD 0
         u32 cev_swap_cntl : 2;                   // DWORD 0
         u32 port0_def_ring : 1;                  // DWORD 0
         u32 port1_def_ring : 1;                  // DWORD 0
         u32 rss_flush_first_dma_echo : 1;        // DWORD 0
         u32 rss_flush_sec_dma_echo : 1;          // DWORD 0
         u32 ring_sram_init_done : 1;             // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
      } SG_PACK ERX_CFG_CSR, *PERX_CFG_CSR;

      typedef union _ERX_CFG_CSR_UNION {
         ERX_CFG_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_CFG_CSR_UNION, *PERX_CFG_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_CFG_CSR_UNION, sizeof (ERX_CFG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Internal Interrupt Status Register. This register indicates the source/cause of ERX
   // internally generated interrupts. This register records exceptions incurred by ERX in
   // the course of its normal processing. Note that these interrupts act on the on-chip
   // MPU, not the host. When a ERX_INTERNAL_ISR_CSR bit gets set and its equivalent Mask
   // bit in ERX_INTERNAL_IMR_CSR is cleared (enabled), MPU is interrupted. This register
   // has a clear-on-read functionality. If the ERX_INTERNAL_ISR_CSR is set, the register
   // bit is cleared when firmware/software reads it and the equivalent
   // ERX_INTERNAL_IMR_CSR bit is automatically set, disabling further MPU interrupts from
   // that source. Firmware/software re-arms the interrupt by writing ones to this
   // ERX_INTERNAL_ISR_CSR. When a one is written to this register, the equivalent
   // ERX_INTERNAL_IMR_CSR bit is cleared, enabling the interrupt.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_INTERNAL_ISR_CSR {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 db_wrong_q : 1;                // DWORD 0
               u32 db_inv_q : 1;                  // DWORD 0
               u32 frag_prot_vio : 1;             // DWORD 0
               u32 low_resource : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_INTERNAL_ISR_CSR, *PERX_INTERNAL_ISR_CSR;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_ISR_CSR, sizeof (ERX_INTERNAL_ISR_CSR) == 4);

   #else
      typedef struct _ERX_INTERNAL_ISR_CSR {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 db_wrong_q : 1;                      // DWORD 0
         u32 db_inv_q : 1;                        // DWORD 0
         u32 frag_prot_vio : 1;                   // DWORD 0
         u32 low_resource : 1;                    // DWORD 0
      } SG_PACK ERX_INTERNAL_ISR_CSR, *PERX_INTERNAL_ISR_CSR;

      typedef union _ERX_INTERNAL_ISR_CSR_UNION {
         ERX_INTERNAL_ISR_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_INTERNAL_ISR_CSR_UNION, *PERX_INTERNAL_ISR_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_ISR_CSR_UNION, sizeof (ERX_INTERNAL_ISR_CSR_UNION) == 4);
   #endif


#else
   // Internal Interrupt Status Register. This register indicates the source/cause of ERX
   // internally generated interrupts. This register records exceptions incurred by ERX in
   // the course of its normal processing. Note that these interrupts act on the on-chip
   // MPU, not the host. When a ERX_INTERNAL_ISR_CSR bit gets set and its equivalent Mask
   // bit in ERX_INTERNAL_IMR_CSR is cleared (enabled), MPU is interrupted. This register
   // has a clear-on-read functionality. If the ERX_INTERNAL_ISR_CSR is set, the register
   // bit is cleared when firmware/software reads it and the equivalent
   // ERX_INTERNAL_IMR_CSR bit is automatically set, disabling further MPU interrupts from
   // that source. Firmware/software re-arms the interrupt by writing ones to this
   // ERX_INTERNAL_ISR_CSR. When a one is written to this register, the equivalent
   // ERX_INTERNAL_IMR_CSR bit is cleared, enabling the interrupt.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_INTERNAL_ISR_CSR {
         union {
            struct { 
               u32 low_resource : 1;              // DWORD 0
               u32 frag_prot_vio : 1;             // DWORD 0
               u32 db_inv_q : 1;                  // DWORD 0
               u32 db_wrong_q : 1;                // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_INTERNAL_ISR_CSR, *PERX_INTERNAL_ISR_CSR;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_ISR_CSR, sizeof (ERX_INTERNAL_ISR_CSR) == 4);

   #else
      typedef struct _ERX_INTERNAL_ISR_CSR {
         u32 low_resource : 1;                    // DWORD 0
         u32 frag_prot_vio : 1;                   // DWORD 0
         u32 db_inv_q : 1;                        // DWORD 0
         u32 db_wrong_q : 1;                      // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK ERX_INTERNAL_ISR_CSR, *PERX_INTERNAL_ISR_CSR;

      typedef union _ERX_INTERNAL_ISR_CSR_UNION {
         ERX_INTERNAL_ISR_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_INTERNAL_ISR_CSR_UNION, *PERX_INTERNAL_ISR_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_ISR_CSR_UNION, sizeof (ERX_INTERNAL_ISR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Internal Interrupt Mask Register. Mask register for ERX internal interrupts to MPU
   // defined in ERX_INTERNAL_ISR_CSR. Firmware/software may enable or disable ERX
   // internal interrupts by writing a zero or one respectively to the relevant bits in
   // this register. Hardware automatically sets each ERX_INTERNAL_IMR_CSR bit when
   // firmware/software reads a one (an interrupt) from the equivalent bit in the
   // ERX_INTERNAL_ISR_CSR interrupt status register. Hardware automatically clears each
   // ERX_INTERNAL_IMR_CSR bit when firmware/software writes a one to the equivalent bit
   // in ERX_INTERNAL_ISR_CSR register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_INTERNAL_IMR_CSR {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 db_wrong_q : 1;                // DWORD 0
               u32 db_inv_q : 1;                  // DWORD 0
               u32 frag_prot_vio : 1;             // DWORD 0
               u32 low_resource : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_INTERNAL_IMR_CSR, *PERX_INTERNAL_IMR_CSR;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_IMR_CSR, sizeof (ERX_INTERNAL_IMR_CSR) == 4);

   #else
      typedef struct _ERX_INTERNAL_IMR_CSR {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 db_wrong_q : 1;                      // DWORD 0
         u32 db_inv_q : 1;                        // DWORD 0
         u32 frag_prot_vio : 1;                   // DWORD 0
         u32 low_resource : 1;                    // DWORD 0
      } SG_PACK ERX_INTERNAL_IMR_CSR, *PERX_INTERNAL_IMR_CSR;

      typedef union _ERX_INTERNAL_IMR_CSR_UNION {
         ERX_INTERNAL_IMR_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_INTERNAL_IMR_CSR_UNION, *PERX_INTERNAL_IMR_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_IMR_CSR_UNION, sizeof (ERX_INTERNAL_IMR_CSR_UNION) == 4);
   #endif


#else
   // Internal Interrupt Mask Register. Mask register for ERX internal interrupts to MPU
   // defined in ERX_INTERNAL_ISR_CSR. Firmware/software may enable or disable ERX
   // internal interrupts by writing a zero or one respectively to the relevant bits in
   // this register. Hardware automatically sets each ERX_INTERNAL_IMR_CSR bit when
   // firmware/software reads a one (an interrupt) from the equivalent bit in the
   // ERX_INTERNAL_ISR_CSR interrupt status register. Hardware automatically clears each
   // ERX_INTERNAL_IMR_CSR bit when firmware/software writes a one to the equivalent bit
   // in ERX_INTERNAL_ISR_CSR register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_INTERNAL_IMR_CSR {
         union {
            struct { 
               u32 low_resource : 1;              // DWORD 0
               u32 frag_prot_vio : 1;             // DWORD 0
               u32 db_inv_q : 1;                  // DWORD 0
               u32 db_wrong_q : 1;                // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_INTERNAL_IMR_CSR, *PERX_INTERNAL_IMR_CSR;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_IMR_CSR, sizeof (ERX_INTERNAL_IMR_CSR) == 4);

   #else
      typedef struct _ERX_INTERNAL_IMR_CSR {
         u32 low_resource : 1;                    // DWORD 0
         u32 frag_prot_vio : 1;                   // DWORD 0
         u32 db_inv_q : 1;                        // DWORD 0
         u32 db_wrong_q : 1;                      // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK ERX_INTERNAL_IMR_CSR, *PERX_INTERNAL_IMR_CSR;

      typedef union _ERX_INTERNAL_IMR_CSR_UNION {
         ERX_INTERNAL_IMR_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_INTERNAL_IMR_CSR_UNION, *PERX_INTERNAL_IMR_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_IMR_CSR_UNION, sizeof (ERX_INTERNAL_IMR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // These status bits inform the MPU what caused an internal interrupt.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_INTERNAL_INT_STATUS0_CSR {
         union {
            struct { 
               u32 ringid;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_INTERNAL_INT_STATUS0_CSR, *PERX_INTERNAL_INT_STATUS0_CSR;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS0_CSR, sizeof (ERX_INTERNAL_INT_STATUS0_CSR) == 4);

   #else
      typedef struct _ERX_INTERNAL_INT_STATUS0_CSR {
         u32 ringid;                              // DWORD 0
      } SG_PACK ERX_INTERNAL_INT_STATUS0_CSR, *PERX_INTERNAL_INT_STATUS0_CSR;

      typedef union _ERX_INTERNAL_INT_STATUS0_CSR_UNION {
         ERX_INTERNAL_INT_STATUS0_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_INTERNAL_INT_STATUS0_CSR_UNION, *PERX_INTERNAL_INT_STATUS0_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS0_CSR_UNION, sizeof (ERX_INTERNAL_INT_STATUS0_CSR_UNION) == 4);
   #endif


#else
   // These status bits inform the MPU what caused an internal interrupt.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_INTERNAL_INT_STATUS0_CSR {
         union {
            struct { 
               u32 ringid;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_INTERNAL_INT_STATUS0_CSR, *PERX_INTERNAL_INT_STATUS0_CSR;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS0_CSR, sizeof (ERX_INTERNAL_INT_STATUS0_CSR) == 4);

   #else
      typedef struct _ERX_INTERNAL_INT_STATUS0_CSR {
         u32 ringid;                              // DWORD 0
      } SG_PACK ERX_INTERNAL_INT_STATUS0_CSR, *PERX_INTERNAL_INT_STATUS0_CSR;

      typedef union _ERX_INTERNAL_INT_STATUS0_CSR_UNION {
         ERX_INTERNAL_INT_STATUS0_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_INTERNAL_INT_STATUS0_CSR_UNION, *PERX_INTERNAL_INT_STATUS0_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS0_CSR_UNION, sizeof (ERX_INTERNAL_INT_STATUS0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // These status bits inform the MPU what caused an internal interrupt. They are each
   // cleared by writing a 1 to them.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_INTERNAL_INT_STATUS1_CSR {
         union {
            struct { 
               u32 ringid;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_INTERNAL_INT_STATUS1_CSR, *PERX_INTERNAL_INT_STATUS1_CSR;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS1_CSR, sizeof (ERX_INTERNAL_INT_STATUS1_CSR) == 4);

   #else
      typedef struct _ERX_INTERNAL_INT_STATUS1_CSR {
         u32 ringid;                              // DWORD 0
      } SG_PACK ERX_INTERNAL_INT_STATUS1_CSR, *PERX_INTERNAL_INT_STATUS1_CSR;

      typedef union _ERX_INTERNAL_INT_STATUS1_CSR_UNION {
         ERX_INTERNAL_INT_STATUS1_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_INTERNAL_INT_STATUS1_CSR_UNION, *PERX_INTERNAL_INT_STATUS1_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS1_CSR_UNION, sizeof (ERX_INTERNAL_INT_STATUS1_CSR_UNION) == 4);
   #endif


#else
   // These status bits inform the MPU what caused an internal interrupt. They are each
   // cleared by writing a 1 to them.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_INTERNAL_INT_STATUS1_CSR {
         union {
            struct { 
               u32 ringid;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_INTERNAL_INT_STATUS1_CSR, *PERX_INTERNAL_INT_STATUS1_CSR;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS1_CSR, sizeof (ERX_INTERNAL_INT_STATUS1_CSR) == 4);

   #else
      typedef struct _ERX_INTERNAL_INT_STATUS1_CSR {
         u32 ringid;                              // DWORD 0
      } SG_PACK ERX_INTERNAL_INT_STATUS1_CSR, *PERX_INTERNAL_INT_STATUS1_CSR;

      typedef union _ERX_INTERNAL_INT_STATUS1_CSR_UNION {
         ERX_INTERNAL_INT_STATUS1_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_INTERNAL_INT_STATUS1_CSR_UNION, *PERX_INTERNAL_INT_STATUS1_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS1_CSR_UNION, sizeof (ERX_INTERNAL_INT_STATUS1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // These status bits inform the MPU what caused an internal interrupt.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_INTERNAL_INT_STATUS2_CSR {
         union {
            struct { 
               u32 rsvd2 : 4;                     // DWORD 0
               u32 rsvd1 : 12;                    // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 ringid_lowfrag : 12;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_INTERNAL_INT_STATUS2_CSR, *PERX_INTERNAL_INT_STATUS2_CSR;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS2_CSR, sizeof (ERX_INTERNAL_INT_STATUS2_CSR) == 4);

   #else
      typedef struct _ERX_INTERNAL_INT_STATUS2_CSR {
         u32 rsvd2 : 4;                           // DWORD 0
         u32 rsvd1 : 12;                          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 ringid_lowfrag : 12;                 // DWORD 0
      } SG_PACK ERX_INTERNAL_INT_STATUS2_CSR, *PERX_INTERNAL_INT_STATUS2_CSR;

      typedef union _ERX_INTERNAL_INT_STATUS2_CSR_UNION {
         ERX_INTERNAL_INT_STATUS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_INTERNAL_INT_STATUS2_CSR_UNION, *PERX_INTERNAL_INT_STATUS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS2_CSR_UNION, sizeof (ERX_INTERNAL_INT_STATUS2_CSR_UNION) == 4);
   #endif


#else
   // These status bits inform the MPU what caused an internal interrupt.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_INTERNAL_INT_STATUS2_CSR {
         union {
            struct { 
               u32 ringid_lowfrag : 12;           // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 rsvd1 : 12;                    // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_INTERNAL_INT_STATUS2_CSR, *PERX_INTERNAL_INT_STATUS2_CSR;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS2_CSR, sizeof (ERX_INTERNAL_INT_STATUS2_CSR) == 4);

   #else
      typedef struct _ERX_INTERNAL_INT_STATUS2_CSR {
         u32 ringid_lowfrag : 12;                 // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 rsvd1 : 12;                          // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
      } SG_PACK ERX_INTERNAL_INT_STATUS2_CSR, *PERX_INTERNAL_INT_STATUS2_CSR;

      typedef union _ERX_INTERNAL_INT_STATUS2_CSR_UNION {
         ERX_INTERNAL_INT_STATUS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_INTERNAL_INT_STATUS2_CSR_UNION, *PERX_INTERNAL_INT_STATUS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_INTERNAL_INT_STATUS2_CSR_UNION, sizeof (ERX_INTERNAL_INT_STATUS2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Index for programming the Base physical address for a page in the eth RQ ring and
   // Index for reading ERX Statisitics.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_RQ_RING_INDEX_CSR {
         union {
            struct { 
               u32 rsvd1 : 15;                    // DWORD 0
               u32 stat : 1;                      // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 index : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_RQ_RING_INDEX_CSR, *PERX_RQ_RING_INDEX_CSR;

      SG_C_ASSERT(__sizeof__ERX_RQ_RING_INDEX_CSR, sizeof (ERX_RQ_RING_INDEX_CSR) == 4);

   #else
      typedef struct _ERX_RQ_RING_INDEX_CSR {
         u32 rsvd1 : 15;                          // DWORD 0
         u32 stat : 1;                            // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 index : 8;                           // DWORD 0
      } SG_PACK ERX_RQ_RING_INDEX_CSR, *PERX_RQ_RING_INDEX_CSR;

      typedef union _ERX_RQ_RING_INDEX_CSR_UNION {
         ERX_RQ_RING_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_RQ_RING_INDEX_CSR_UNION, *PERX_RQ_RING_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_RQ_RING_INDEX_CSR_UNION, sizeof (ERX_RQ_RING_INDEX_CSR_UNION) == 4);
   #endif


#else
   // Index for programming the Base physical address for a page in the eth RQ ring and
   // Index for reading ERX Statisitics.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_RQ_RING_INDEX_CSR {
         union {
            struct { 
               u32 index : 8;                     // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 stat : 1;                      // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_RQ_RING_INDEX_CSR, *PERX_RQ_RING_INDEX_CSR;

      SG_C_ASSERT(__sizeof__ERX_RQ_RING_INDEX_CSR, sizeof (ERX_RQ_RING_INDEX_CSR) == 4);

   #else
      typedef struct _ERX_RQ_RING_INDEX_CSR {
         u32 index : 8;                           // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 stat : 1;                            // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK ERX_RQ_RING_INDEX_CSR, *PERX_RQ_RING_INDEX_CSR;

      typedef union _ERX_RQ_RING_INDEX_CSR_UNION {
         ERX_RQ_RING_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_RQ_RING_INDEX_CSR_UNION, *PERX_RQ_RING_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_RQ_RING_INDEX_CSR_UNION, sizeof (ERX_RQ_RING_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // the Base physical address for a page in the eth RQ ring as pointed to by
   // ERX_RQ_RING_INDEX_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_RQ_RING_BASE_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_RQ_RING_BASE_ADDR_CSR, *PERX_RQ_RING_BASE_ADDR_CSR;

      SG_C_ASSERT(__sizeof__ERX_RQ_RING_BASE_ADDR_CSR, sizeof (ERX_RQ_RING_BASE_ADDR_CSR) == 4);

   #else
      typedef struct _ERX_RQ_RING_BASE_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_RQ_RING_BASE_ADDR_CSR, *PERX_RQ_RING_BASE_ADDR_CSR;

      typedef union _ERX_RQ_RING_BASE_ADDR_CSR_UNION {
         ERX_RQ_RING_BASE_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_RQ_RING_BASE_ADDR_CSR_UNION, *PERX_RQ_RING_BASE_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_RQ_RING_BASE_ADDR_CSR_UNION, sizeof (ERX_RQ_RING_BASE_ADDR_CSR_UNION) == 4);
   #endif


#else
   // the Base physical address for a page in the eth RQ ring as pointed to by
   // ERX_RQ_RING_INDEX_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_RQ_RING_BASE_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_RQ_RING_BASE_ADDR_CSR, *PERX_RQ_RING_BASE_ADDR_CSR;

      SG_C_ASSERT(__sizeof__ERX_RQ_RING_BASE_ADDR_CSR, sizeof (ERX_RQ_RING_BASE_ADDR_CSR) == 4);

   #else
      typedef struct _ERX_RQ_RING_BASE_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_RQ_RING_BASE_ADDR_CSR, *PERX_RQ_RING_BASE_ADDR_CSR;

      typedef union _ERX_RQ_RING_BASE_ADDR_CSR_UNION {
         ERX_RQ_RING_BASE_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_RQ_RING_BASE_ADDR_CSR_UNION, *PERX_RQ_RING_BASE_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_RQ_RING_BASE_ADDR_CSR_UNION, sizeof (ERX_RQ_RING_BASE_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Index for programming the Header Memory base physical addresses for a single 4K
   // page. Used in conjuction with ERX_HEADERMEM_BASE_ADDR_LOWER_CSR and
   // ERX_HEADERMEM_BASE_ADDR_UPPER_CSR. The seqeunce to program the Header Memory base
   // address is: <OL>  - Write the ERX_HEADERMEM_INDEX_CSR with the appropriate index.  -
   // Write the ERX_HEADERMEM_BASE_ADDR_UPPER_CSR with upper dword of the page address.  -
   // Write the ERX_HEADERMEM_BASE_ADDR_LOWER_CSR with lower dword of the page address.
   // </ol>  The seqeunce to read out the Header Split RQ Base Address is: <OL>  - Write
   // the ERX_HEADERMEM_INDEX_CSR with the appropriate index.  - Read the
   // ERX_HEADERMEM_BASE_ADDR_UPPER_CSR with upper dword of the page address.  - Read the
   // ERX_HEADERMEM_BASE_ADDR_LOWER_CSR with lower dword of the page address. </ol> 
   // Breaking with this sequence can produce undesired results. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_HEADERMEM_INDEX_CSR {
         union {
            struct { 
               u32 rsvd0 : 21;                    // DWORD 0
               u32 index : 11;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_HEADERMEM_INDEX_CSR, *PERX_HEADERMEM_INDEX_CSR;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_INDEX_CSR, sizeof (ERX_HEADERMEM_INDEX_CSR) == 4);

   #else
      typedef struct _ERX_HEADERMEM_INDEX_CSR {
         u32 rsvd0 : 21;                          // DWORD 0
         u32 index : 11;                          // DWORD 0
      } SG_PACK ERX_HEADERMEM_INDEX_CSR, *PERX_HEADERMEM_INDEX_CSR;

      typedef union _ERX_HEADERMEM_INDEX_CSR_UNION {
         ERX_HEADERMEM_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_HEADERMEM_INDEX_CSR_UNION, *PERX_HEADERMEM_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_INDEX_CSR_UNION, sizeof (ERX_HEADERMEM_INDEX_CSR_UNION) == 4);
   #endif


#else
   // Index for programming the Header Memory base physical addresses for a single 4K
   // page. Used in conjuction with ERX_HEADERMEM_BASE_ADDR_LOWER_CSR and
   // ERX_HEADERMEM_BASE_ADDR_UPPER_CSR. The seqeunce to program the Header Memory base
   // address is: <OL>  - Write the ERX_HEADERMEM_INDEX_CSR with the appropriate index.  -
   // Write the ERX_HEADERMEM_BASE_ADDR_UPPER_CSR with upper dword of the page address.  -
   // Write the ERX_HEADERMEM_BASE_ADDR_LOWER_CSR with lower dword of the page address.
   // </ol>  The seqeunce to read out the Header Split RQ Base Address is: <OL>  - Write
   // the ERX_HEADERMEM_INDEX_CSR with the appropriate index.  - Read the
   // ERX_HEADERMEM_BASE_ADDR_UPPER_CSR with upper dword of the page address.  - Read the
   // ERX_HEADERMEM_BASE_ADDR_LOWER_CSR with lower dword of the page address. </ol> 
   // Breaking with this sequence can produce undesired results. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_HEADERMEM_INDEX_CSR {
         union {
            struct { 
               u32 index : 11;                    // DWORD 0
               u32 rsvd0 : 21;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_HEADERMEM_INDEX_CSR, *PERX_HEADERMEM_INDEX_CSR;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_INDEX_CSR, sizeof (ERX_HEADERMEM_INDEX_CSR) == 4);

   #else
      typedef struct _ERX_HEADERMEM_INDEX_CSR {
         u32 index : 11;                          // DWORD 0
         u32 rsvd0 : 21;                          // DWORD 0
      } SG_PACK ERX_HEADERMEM_INDEX_CSR, *PERX_HEADERMEM_INDEX_CSR;

      typedef union _ERX_HEADERMEM_INDEX_CSR_UNION {
         ERX_HEADERMEM_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_HEADERMEM_INDEX_CSR_UNION, *PERX_HEADERMEM_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_INDEX_CSR_UNION, sizeof (ERX_HEADERMEM_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The lower dword for the Header Memory base address associated with the value in
   // ERX_HEADERMEM_INDEX_CSR. Look at ERX_HEADERMEM_INDEX_CSR for more details
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_HEADERMEM_BASE_ADDR_LOWER_CSR {
         union {
            struct { 
               u32 lower;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_LOWER_CSR, *PERX_HEADERMEM_BASE_ADDR_LOWER_CSR;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_BASE_ADDR_LOWER_CSR, sizeof (ERX_HEADERMEM_BASE_ADDR_LOWER_CSR) == 4);

   #else
      typedef struct _ERX_HEADERMEM_BASE_ADDR_LOWER_CSR {
         u32 lower;                               // DWORD 0
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_LOWER_CSR, *PERX_HEADERMEM_BASE_ADDR_LOWER_CSR;

      typedef union _ERX_HEADERMEM_BASE_ADDR_LOWER_CSR_UNION {
         ERX_HEADERMEM_BASE_ADDR_LOWER_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_LOWER_CSR_UNION, *PERX_HEADERMEM_BASE_ADDR_LOWER_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_BASE_ADDR_LOWER_CSR_UNION, sizeof (ERX_HEADERMEM_BASE_ADDR_LOWER_CSR_UNION) == 4);
   #endif


#else
   // The lower dword for the Header Memory base address associated with the value in
   // ERX_HEADERMEM_INDEX_CSR. Look at ERX_HEADERMEM_INDEX_CSR for more details
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_HEADERMEM_BASE_ADDR_LOWER_CSR {
         union {
            struct { 
               u32 lower;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_LOWER_CSR, *PERX_HEADERMEM_BASE_ADDR_LOWER_CSR;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_BASE_ADDR_LOWER_CSR, sizeof (ERX_HEADERMEM_BASE_ADDR_LOWER_CSR) == 4);

   #else
      typedef struct _ERX_HEADERMEM_BASE_ADDR_LOWER_CSR {
         u32 lower;                               // DWORD 0
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_LOWER_CSR, *PERX_HEADERMEM_BASE_ADDR_LOWER_CSR;

      typedef union _ERX_HEADERMEM_BASE_ADDR_LOWER_CSR_UNION {
         ERX_HEADERMEM_BASE_ADDR_LOWER_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_LOWER_CSR_UNION, *PERX_HEADERMEM_BASE_ADDR_LOWER_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_BASE_ADDR_LOWER_CSR_UNION, sizeof (ERX_HEADERMEM_BASE_ADDR_LOWER_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The upper dword for the Header Memory base address associated with the value in
   // ERX_HEADERMEM_INDEX_CSR. Look at ERX_HEADERMEM_INDEX_CSR for more details
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_HEADERMEM_BASE_ADDR_UPPER_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_UPPER_CSR, *PERX_HEADERMEM_BASE_ADDR_UPPER_CSR;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_BASE_ADDR_UPPER_CSR, sizeof (ERX_HEADERMEM_BASE_ADDR_UPPER_CSR) == 4);

   #else
      typedef struct _ERX_HEADERMEM_BASE_ADDR_UPPER_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_UPPER_CSR, *PERX_HEADERMEM_BASE_ADDR_UPPER_CSR;

      typedef union _ERX_HEADERMEM_BASE_ADDR_UPPER_CSR_UNION {
         ERX_HEADERMEM_BASE_ADDR_UPPER_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_UPPER_CSR_UNION, *PERX_HEADERMEM_BASE_ADDR_UPPER_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_BASE_ADDR_UPPER_CSR_UNION, sizeof (ERX_HEADERMEM_BASE_ADDR_UPPER_CSR_UNION) == 4);
   #endif


#else
   // The upper dword for the Header Memory base address associated with the value in
   // ERX_HEADERMEM_INDEX_CSR. Look at ERX_HEADERMEM_INDEX_CSR for more details
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_HEADERMEM_BASE_ADDR_UPPER_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_UPPER_CSR, *PERX_HEADERMEM_BASE_ADDR_UPPER_CSR;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_BASE_ADDR_UPPER_CSR, sizeof (ERX_HEADERMEM_BASE_ADDR_UPPER_CSR) == 4);

   #else
      typedef struct _ERX_HEADERMEM_BASE_ADDR_UPPER_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_UPPER_CSR, *PERX_HEADERMEM_BASE_ADDR_UPPER_CSR;

      typedef union _ERX_HEADERMEM_BASE_ADDR_UPPER_CSR_UNION {
         ERX_HEADERMEM_BASE_ADDR_UPPER_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_HEADERMEM_BASE_ADDR_UPPER_CSR_UNION, *PERX_HEADERMEM_BASE_ADDR_UPPER_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_HEADERMEM_BASE_ADDR_UPPER_CSR_UNION, sizeof (ERX_HEADERMEM_BASE_ADDR_UPPER_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug ring register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_DEBUG_CSR {
         union {
            struct { 
               u32 vld : 1;                       // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 cons_index : 10;               // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 prod_index : 10;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_DEBUG_CSR, *PERX_DEBUG_CSR;

      SG_C_ASSERT(__sizeof__ERX_DEBUG_CSR, sizeof (ERX_DEBUG_CSR) == 4);

   #else
      typedef struct _ERX_DEBUG_CSR {
         u32 vld : 1;                             // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 cons_index : 10;                     // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 prod_index : 10;                     // DWORD 0
      } SG_PACK ERX_DEBUG_CSR, *PERX_DEBUG_CSR;

      typedef union _ERX_DEBUG_CSR_UNION {
         ERX_DEBUG_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_DEBUG_CSR_UNION, *PERX_DEBUG_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_DEBUG_CSR_UNION, sizeof (ERX_DEBUG_CSR_UNION) == 4);
   #endif


#else
   // Debug ring register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_DEBUG_CSR {
         union {
            struct { 
               u32 prod_index : 10;               // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 cons_index : 10;               // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 vld : 1;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_DEBUG_CSR, *PERX_DEBUG_CSR;

      SG_C_ASSERT(__sizeof__ERX_DEBUG_CSR, sizeof (ERX_DEBUG_CSR) == 4);

   #else
      typedef struct _ERX_DEBUG_CSR {
         u32 prod_index : 10;                     // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 cons_index : 10;                     // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 vld : 1;                             // DWORD 0
      } SG_PACK ERX_DEBUG_CSR, *PERX_DEBUG_CSR;

      typedef union _ERX_DEBUG_CSR_UNION {
         ERX_DEBUG_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_DEBUG_CSR_UNION, *PERX_DEBUG_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_DEBUG_CSR_UNION, sizeof (ERX_DEBUG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug ring register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_FRAG_DEBUG_CSR {
         union {
            struct { 
               u32 rsvd3 : 1;                     // DWORD 0
               u32 frags_avail : 7;               // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 rsvd1 : 10;                    // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 fetch_index : 10;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_FRAG_DEBUG_CSR, *PERX_FRAG_DEBUG_CSR;

      SG_C_ASSERT(__sizeof__ERX_FRAG_DEBUG_CSR, sizeof (ERX_FRAG_DEBUG_CSR) == 4);

   #else
      typedef struct _ERX_FRAG_DEBUG_CSR {
         u32 rsvd3 : 1;                           // DWORD 0
         u32 frags_avail : 7;                     // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 fetch_index : 10;                    // DWORD 0
      } SG_PACK ERX_FRAG_DEBUG_CSR, *PERX_FRAG_DEBUG_CSR;

      typedef union _ERX_FRAG_DEBUG_CSR_UNION {
         ERX_FRAG_DEBUG_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_FRAG_DEBUG_CSR_UNION, *PERX_FRAG_DEBUG_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_FRAG_DEBUG_CSR_UNION, sizeof (ERX_FRAG_DEBUG_CSR_UNION) == 4);
   #endif


#else
   // Debug ring register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_FRAG_DEBUG_CSR {
         union {
            struct { 
               u32 fetch_index : 10;              // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 rsvd1 : 10;                    // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 frags_avail : 7;               // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_FRAG_DEBUG_CSR, *PERX_FRAG_DEBUG_CSR;

      SG_C_ASSERT(__sizeof__ERX_FRAG_DEBUG_CSR, sizeof (ERX_FRAG_DEBUG_CSR) == 4);

   #else
      typedef struct _ERX_FRAG_DEBUG_CSR {
         u32 fetch_index : 10;                    // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 frags_avail : 7;                     // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK ERX_FRAG_DEBUG_CSR, *PERX_FRAG_DEBUG_CSR;

      typedef union _ERX_FRAG_DEBUG_CSR_UNION {
         ERX_FRAG_DEBUG_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_FRAG_DEBUG_CSR_UNION, *PERX_FRAG_DEBUG_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_FRAG_DEBUG_CSR_UNION, sizeof (ERX_FRAG_DEBUG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CQ ID for receives.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_CQID_CSR {
         union {
            struct { 
               u32 rsvd0 : 22;                    // DWORD 0
               u32 cqid : 10;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_CQID_CSR, *PERX_CQID_CSR;

      SG_C_ASSERT(__sizeof__ERX_CQID_CSR, sizeof (ERX_CQID_CSR) == 4);

   #else
      typedef struct _ERX_CQID_CSR {
         u32 rsvd0 : 22;                          // DWORD 0
         u32 cqid : 10;                           // DWORD 0
      } SG_PACK ERX_CQID_CSR, *PERX_CQID_CSR;

      typedef union _ERX_CQID_CSR_UNION {
         ERX_CQID_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_CQID_CSR_UNION, *PERX_CQID_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_CQID_CSR_UNION, sizeof (ERX_CQID_CSR_UNION) == 4);
   #endif


#else
   // CQ ID for receives.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_CQID_CSR {
         union {
            struct { 
               u32 cqid : 10;                     // DWORD 0
               u32 rsvd0 : 22;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_CQID_CSR, *PERX_CQID_CSR;

      SG_C_ASSERT(__sizeof__ERX_CQID_CSR, sizeof (ERX_CQID_CSR) == 4);

   #else
      typedef struct _ERX_CQID_CSR {
         u32 cqid : 10;                           // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
      } SG_PACK ERX_CQID_CSR, *PERX_CQID_CSR;

      typedef union _ERX_CQID_CSR_UNION {
         ERX_CQID_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_CQID_CSR_UNION, *PERX_CQID_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_CQID_CSR_UNION, sizeof (ERX_CQID_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Protection Domain ID for ethernet RQ rings.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_PDID_CSR {
         union {
            struct { 
               u32 valid_h : 1;                   // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 fragsize : 3;                  // DWORD 0
               u32 fid : 8;                       // DWORD 0
               u32 host_ddrl : 1;                 // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 pdid : 9;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_PDID_CSR, *PERX_PDID_CSR;

      SG_C_ASSERT(__sizeof__ERX_PDID_CSR, sizeof (ERX_PDID_CSR) == 4);

   #else
      typedef struct _ERX_PDID_CSR {
         u32 valid_h : 1;                         // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 fragsize : 3;                        // DWORD 0
         u32 fid : 8;                             // DWORD 0
         u32 host_ddrl : 1;                       // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 pdid : 9;                            // DWORD 0
      } SG_PACK ERX_PDID_CSR, *PERX_PDID_CSR;

      typedef union _ERX_PDID_CSR_UNION {
         ERX_PDID_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_PDID_CSR_UNION, *PERX_PDID_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_PDID_CSR_UNION, sizeof (ERX_PDID_CSR_UNION) == 4);
   #endif


#else
   // Protection Domain ID for ethernet RQ rings.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_PDID_CSR {
         union {
            struct { 
               u32 pdid : 9;                      // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 host_ddrl : 1;                 // DWORD 0
               u32 fid : 8;                       // DWORD 0
               u32 fragsize : 3;                  // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 valid_h : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_PDID_CSR, *PERX_PDID_CSR;

      SG_C_ASSERT(__sizeof__ERX_PDID_CSR, sizeof (ERX_PDID_CSR) == 4);

   #else
      typedef struct _ERX_PDID_CSR {
         u32 pdid : 9;                            // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 host_ddrl : 1;                       // DWORD 0
         u32 fid : 8;                             // DWORD 0
         u32 fragsize : 3;                        // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 valid_h : 1;                         // DWORD 0
      } SG_PACK ERX_PDID_CSR, *PERX_PDID_CSR;

      typedef union _ERX_PDID_CSR_UNION {
         ERX_PDID_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_PDID_CSR_UNION, *PERX_PDID_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_PDID_CSR_UNION, sizeof (ERX_PDID_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX provides an MTU check. All packets greater than the MTU size will be silently
   // discarded on a per ring basis. Setting the value to the default max size,
   // effectively disables the MTU check. Setting the MTU value to a POHR limit (like 32
   // bytes or less) will also cause unpredictable behavior. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_MTU_CSR {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 mtu : 14;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_MTU_CSR, *PERX_MTU_CSR;

      SG_C_ASSERT(__sizeof__ERX_MTU_CSR, sizeof (ERX_MTU_CSR) == 4);

   #else
      typedef struct _ERX_MTU_CSR {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 mtu : 14;                            // DWORD 0
      } SG_PACK ERX_MTU_CSR, *PERX_MTU_CSR;

      typedef union _ERX_MTU_CSR_UNION {
         ERX_MTU_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_MTU_CSR_UNION, *PERX_MTU_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_MTU_CSR_UNION, sizeof (ERX_MTU_CSR_UNION) == 4);
   #endif


#else
   // ERX provides an MTU check. All packets greater than the MTU size will be silently
   // discarded on a per ring basis. Setting the value to the default max size,
   // effectively disables the MTU check. Setting the MTU value to a POHR limit (like 32
   // bytes or less) will also cause unpredictable behavior. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_MTU_CSR {
         union {
            struct { 
               u32 mtu : 14;                      // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_MTU_CSR, *PERX_MTU_CSR;

      SG_C_ASSERT(__sizeof__ERX_MTU_CSR, sizeof (ERX_MTU_CSR) == 4);

   #else
      typedef struct _ERX_MTU_CSR {
         u32 mtu : 14;                            // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK ERX_MTU_CSR, *PERX_MTU_CSR;

      typedef union _ERX_MTU_CSR_UNION {
         ERX_MTU_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_MTU_CSR_UNION, *PERX_MTU_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_MTU_CSR_UNION, sizeof (ERX_MTU_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // debug register used to throttle PQ requests. All fields except for wdma suffer from
   // bug 9829 and may yield occational garbage results. Take data with grain of salt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_REQ_THROTTLE {
         union {
            struct { 
               u32 debug_cmp_underflow_pulse : 1; // DWORD 0
               u32 debug_cmp_overflow_pulse : 1;  // DWORD 0
               u32 debug_tpre_desc_underflow_pulse : 1; // DWORD 0
               u32 debug_tpre_desc_overflow_pulse : 1; // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 debug_dbuf_prefetch_state : 3; // DWORD 0
               u32 debug_tpre_desc_count : 3;     // DWORD 0
               u32 debug_cmp_desc_count : 4;      // DWORD 0
               u32 debug_buf_mngr_state : 2;      // DWORD 0
               u32 debug_pkt_cmp_state : 2;       // DWORD 0
               u32 cev_erx_full : 1;              // DWORD 0
               u32 rdma_erx_idmc_data_full : 1;   // DWORD 0
               u32 wdma_erx_idmc_data_full : 1;   // DWORD 0
               u32 completion_queue_full : 1;     // DWORD 0
               u32 debug_pkt_mgr_state : 3;       // DWORD 0
               u32 wdma : 4;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_REQ_THROTTLE, *PERX_REQ_THROTTLE;

      SG_C_ASSERT(__sizeof__ERX_REQ_THROTTLE, sizeof (ERX_REQ_THROTTLE) == 4);

   #else
      typedef struct _ERX_REQ_THROTTLE {
         u32 debug_cmp_underflow_pulse : 1;       // DWORD 0
         u32 debug_cmp_overflow_pulse : 1;        // DWORD 0
         u32 debug_tpre_desc_underflow_pulse : 1; // DWORD 0
         u32 debug_tpre_desc_overflow_pulse : 1;  // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 debug_dbuf_prefetch_state : 3;       // DWORD 0
         u32 debug_tpre_desc_count : 3;           // DWORD 0
         u32 debug_cmp_desc_count : 4;            // DWORD 0
         u32 debug_buf_mngr_state : 2;            // DWORD 0
         u32 debug_pkt_cmp_state : 2;             // DWORD 0
         u32 cev_erx_full : 1;                    // DWORD 0
         u32 rdma_erx_idmc_data_full : 1;         // DWORD 0
         u32 wdma_erx_idmc_data_full : 1;         // DWORD 0
         u32 completion_queue_full : 1;           // DWORD 0
         u32 debug_pkt_mgr_state : 3;             // DWORD 0
         u32 wdma : 4;                            // DWORD 0
      } SG_PACK ERX_REQ_THROTTLE, *PERX_REQ_THROTTLE;

      typedef union _ERX_REQ_THROTTLE_UNION {
         ERX_REQ_THROTTLE bits;
         u32 dw; // dword union
      } SG_PACK ERX_REQ_THROTTLE_UNION, *PERX_REQ_THROTTLE_UNION;

      SG_C_ASSERT(__sizeof__ERX_REQ_THROTTLE_UNION, sizeof (ERX_REQ_THROTTLE_UNION) == 4);
   #endif


#else
   // debug register used to throttle PQ requests. All fields except for wdma suffer from
   // bug 9829 and may yield occational garbage results. Take data with grain of salt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_REQ_THROTTLE {
         union {
            struct { 
               u32 wdma : 4;                      // DWORD 0
               u32 debug_pkt_mgr_state : 3;       // DWORD 0
               u32 completion_queue_full : 1;     // DWORD 0
               u32 wdma_erx_idmc_data_full : 1;   // DWORD 0
               u32 rdma_erx_idmc_data_full : 1;   // DWORD 0
               u32 cev_erx_full : 1;              // DWORD 0
               u32 debug_pkt_cmp_state : 2;       // DWORD 0
               u32 debug_buf_mngr_state : 2;      // DWORD 0
               u32 debug_cmp_desc_count : 4;      // DWORD 0
               u32 debug_tpre_desc_count : 3;     // DWORD 0
               u32 debug_dbuf_prefetch_state : 3; // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 debug_tpre_desc_overflow_pulse : 1; // DWORD 0
               u32 debug_tpre_desc_underflow_pulse : 1; // DWORD 0
               u32 debug_cmp_overflow_pulse : 1;  // DWORD 0
               u32 debug_cmp_underflow_pulse : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_REQ_THROTTLE, *PERX_REQ_THROTTLE;

      SG_C_ASSERT(__sizeof__ERX_REQ_THROTTLE, sizeof (ERX_REQ_THROTTLE) == 4);

   #else
      typedef struct _ERX_REQ_THROTTLE {
         u32 wdma : 4;                            // DWORD 0
         u32 debug_pkt_mgr_state : 3;             // DWORD 0
         u32 completion_queue_full : 1;           // DWORD 0
         u32 wdma_erx_idmc_data_full : 1;         // DWORD 0
         u32 rdma_erx_idmc_data_full : 1;         // DWORD 0
         u32 cev_erx_full : 1;                    // DWORD 0
         u32 debug_pkt_cmp_state : 2;             // DWORD 0
         u32 debug_buf_mngr_state : 2;            // DWORD 0
         u32 debug_cmp_desc_count : 4;            // DWORD 0
         u32 debug_tpre_desc_count : 3;           // DWORD 0
         u32 debug_dbuf_prefetch_state : 3;       // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 debug_tpre_desc_overflow_pulse : 1;  // DWORD 0
         u32 debug_tpre_desc_underflow_pulse : 1; // DWORD 0
         u32 debug_cmp_overflow_pulse : 1;        // DWORD 0
         u32 debug_cmp_underflow_pulse : 1;       // DWORD 0
      } SG_PACK ERX_REQ_THROTTLE, *PERX_REQ_THROTTLE;

      typedef union _ERX_REQ_THROTTLE_UNION {
         ERX_REQ_THROTTLE bits;
         u32 dw; // dword union
      } SG_PACK ERX_REQ_THROTTLE_UNION, *PERX_REQ_THROTTLE_UNION;

      SG_C_ASSERT(__sizeof__ERX_REQ_THROTTLE_UNION, sizeof (ERX_REQ_THROTTLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw unrecoverable error source bits. Write a 1 to clear 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_UE_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 ring_sram_init_ue : 1;         // DWORD 0
               u32 perr_frag_ue : 1;              // DWORD 0
               u32 perr_pkt_ue : 1;               // DWORD 0
               u32 addr_perr_ue : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_UE_SOURCE, *PERX_UE_SOURCE;

      SG_C_ASSERT(__sizeof__ERX_UE_SOURCE, sizeof (ERX_UE_SOURCE) == 4);

   #else
      typedef struct _ERX_UE_SOURCE {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 ring_sram_init_ue : 1;               // DWORD 0
         u32 perr_frag_ue : 1;                    // DWORD 0
         u32 perr_pkt_ue : 1;                     // DWORD 0
         u32 addr_perr_ue : 1;                    // DWORD 0
      } SG_PACK ERX_UE_SOURCE, *PERX_UE_SOURCE;

      typedef union _ERX_UE_SOURCE_UNION {
         ERX_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK ERX_UE_SOURCE_UNION, *PERX_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__ERX_UE_SOURCE_UNION, sizeof (ERX_UE_SOURCE_UNION) == 4);
   #endif


#else
   // Raw unrecoverable error source bits. Write a 1 to clear 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_UE_SOURCE {
         union {
            struct { 
               u32 addr_perr_ue : 1;              // DWORD 0
               u32 perr_pkt_ue : 1;               // DWORD 0
               u32 perr_frag_ue : 1;              // DWORD 0
               u32 ring_sram_init_ue : 1;         // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_UE_SOURCE, *PERX_UE_SOURCE;

      SG_C_ASSERT(__sizeof__ERX_UE_SOURCE, sizeof (ERX_UE_SOURCE) == 4);

   #else
      typedef struct _ERX_UE_SOURCE {
         u32 addr_perr_ue : 1;                    // DWORD 0
         u32 perr_pkt_ue : 1;                     // DWORD 0
         u32 perr_frag_ue : 1;                    // DWORD 0
         u32 ring_sram_init_ue : 1;               // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK ERX_UE_SOURCE, *PERX_UE_SOURCE;

      typedef union _ERX_UE_SOURCE_UNION {
         ERX_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK ERX_UE_SOURCE_UNION, *PERX_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__ERX_UE_SOURCE_UNION, sizeof (ERX_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for disabling unrecoverable error . Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_UE_ENABLE {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 ring_sram_init_ue : 1;         // DWORD 0
               u32 perr_frag_ue : 1;              // DWORD 0
               u32 perr_pkt_ue : 1;               // DWORD 0
               u32 addr_perr_ue : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_UE_ENABLE, *PERX_UE_ENABLE;

      SG_C_ASSERT(__sizeof__ERX_UE_ENABLE, sizeof (ERX_UE_ENABLE) == 4);

   #else
      typedef struct _ERX_UE_ENABLE {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 ring_sram_init_ue : 1;               // DWORD 0
         u32 perr_frag_ue : 1;                    // DWORD 0
         u32 perr_pkt_ue : 1;                     // DWORD 0
         u32 addr_perr_ue : 1;                    // DWORD 0
      } SG_PACK ERX_UE_ENABLE, *PERX_UE_ENABLE;

      typedef union _ERX_UE_ENABLE_UNION {
         ERX_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK ERX_UE_ENABLE_UNION, *PERX_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__ERX_UE_ENABLE_UNION, sizeof (ERX_UE_ENABLE_UNION) == 4);
   #endif


#else
   // Mask for disabling unrecoverable error . Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_UE_ENABLE {
         union {
            struct { 
               u32 addr_perr_ue : 1;              // DWORD 0
               u32 perr_pkt_ue : 1;               // DWORD 0
               u32 perr_frag_ue : 1;              // DWORD 0
               u32 ring_sram_init_ue : 1;         // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_UE_ENABLE, *PERX_UE_ENABLE;

      SG_C_ASSERT(__sizeof__ERX_UE_ENABLE, sizeof (ERX_UE_ENABLE) == 4);

   #else
      typedef struct _ERX_UE_ENABLE {
         u32 addr_perr_ue : 1;                    // DWORD 0
         u32 perr_pkt_ue : 1;                     // DWORD 0
         u32 perr_frag_ue : 1;                    // DWORD 0
         u32 ring_sram_init_ue : 1;               // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK ERX_UE_ENABLE, *PERX_UE_ENABLE;

      typedef union _ERX_UE_ENABLE_UNION {
         ERX_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK ERX_UE_ENABLE_UNION, *PERX_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__ERX_UE_ENABLE_UNION, sizeof (ERX_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The ERX supports a line analyzer mode that allows for some traffic to be written
   // directly to a debug array space in the host. This mode is discussed in full in the
   // RXF section, and if any discrepancies between here and the RXF section exist, the
   // RXF section takes precedence. Once the Enable bit is set, incomming traffic will be
   // written to the CSR specified Address until the CSR specified Length is written, OR
   // until the Enable bit is cleared. A poll of the Done bit will indicate when the SM
   // has been disabled due to the Enable going low, or the Line Analyzer Array filling
   // up. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_LINE_ANALYZER_ARRAY_CTRL_CSR {
         union {
            struct { 
               u32 in_prog : 1;                   // DWORD 0
               u32 rsvd0 : 21;                    // DWORD 0
               u32 fid : 8;                       // DWORD 0
               u32 host_ddrl : 1;                 // DWORD 0
               u32 enable : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CTRL_CSR, *PERX_LINE_ANALYZER_ARRAY_CTRL_CSR;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_CTRL_CSR, sizeof (ERX_LINE_ANALYZER_ARRAY_CTRL_CSR) == 4);

   #else
      typedef struct _ERX_LINE_ANALYZER_ARRAY_CTRL_CSR {
         u32 in_prog : 1;                         // DWORD 0
         u32 rsvd0 : 21;                          // DWORD 0
         u32 fid : 8;                             // DWORD 0
         u32 host_ddrl : 1;                       // DWORD 0
         u32 enable : 1;                          // DWORD 0
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CTRL_CSR, *PERX_LINE_ANALYZER_ARRAY_CTRL_CSR;

      typedef union _ERX_LINE_ANALYZER_ARRAY_CTRL_CSR_UNION {
         ERX_LINE_ANALYZER_ARRAY_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CTRL_CSR_UNION, *PERX_LINE_ANALYZER_ARRAY_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_CTRL_CSR_UNION, sizeof (ERX_LINE_ANALYZER_ARRAY_CTRL_CSR_UNION) == 4);
   #endif


#else
   // The ERX supports a line analyzer mode that allows for some traffic to be written
   // directly to a debug array space in the host. This mode is discussed in full in the
   // RXF section, and if any discrepancies between here and the RXF section exist, the
   // RXF section takes precedence. Once the Enable bit is set, incomming traffic will be
   // written to the CSR specified Address until the CSR specified Length is written, OR
   // until the Enable bit is cleared. A poll of the Done bit will indicate when the SM
   // has been disabled due to the Enable going low, or the Line Analyzer Array filling
   // up. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_LINE_ANALYZER_ARRAY_CTRL_CSR {
         union {
            struct { 
               u32 enable : 1;                    // DWORD 0
               u32 host_ddrl : 1;                 // DWORD 0
               u32 fid : 8;                       // DWORD 0
               u32 rsvd0 : 21;                    // DWORD 0
               u32 in_prog : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CTRL_CSR, *PERX_LINE_ANALYZER_ARRAY_CTRL_CSR;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_CTRL_CSR, sizeof (ERX_LINE_ANALYZER_ARRAY_CTRL_CSR) == 4);

   #else
      typedef struct _ERX_LINE_ANALYZER_ARRAY_CTRL_CSR {
         u32 enable : 1;                          // DWORD 0
         u32 host_ddrl : 1;                       // DWORD 0
         u32 fid : 8;                             // DWORD 0
         u32 rsvd0 : 21;                          // DWORD 0
         u32 in_prog : 1;                         // DWORD 0
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CTRL_CSR, *PERX_LINE_ANALYZER_ARRAY_CTRL_CSR;

      typedef union _ERX_LINE_ANALYZER_ARRAY_CTRL_CSR_UNION {
         ERX_LINE_ANALYZER_ARRAY_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CTRL_CSR_UNION, *PERX_LINE_ANALYZER_ARRAY_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_CTRL_CSR_UNION, sizeof (ERX_LINE_ANALYZER_ARRAY_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Lower 32 bits of the start address of the Line Analyzer (Spam) Array. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR, *PERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR, sizeof (ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR) == 4);

   #else
      typedef struct _ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR, *PERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR;

      typedef union _ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR_UNION {
         ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR_UNION, *PERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR_UNION, sizeof (ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR_UNION) == 4);
   #endif


#else
   // Lower 32 bits of the start address of the Line Analyzer (Spam) Array. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR, *PERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR, sizeof (ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR) == 4);

   #else
      typedef struct _ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR, *PERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR;

      typedef union _ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR_UNION {
         ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR_UNION, *PERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR_UNION, sizeof (ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Upper 32 bits of the start address of the Line Analyzer (Spam) Array. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR, *PERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR, sizeof (ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR) == 4);

   #else
      typedef struct _ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR, *PERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR;

      typedef union _ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR_UNION {
         ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR_UNION, *PERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR_UNION, sizeof (ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR_UNION) == 4);
   #endif


#else
   // Upper 32 bits of the start address of the Line Analyzer (Spam) Array. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR, *PERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR, sizeof (ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR) == 4);

   #else
      typedef struct _ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR, *PERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR;

      typedef union _ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR_UNION {
         ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR_UNION, *PERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR_UNION, sizeof (ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Max length (in bytes) of the Line Analyzer Array. When the array fills up, and the
   // last packet arrives whose size exceeds the Max Length, that packet is dropped and
   // the Line Analyzer Array Mode is disabled. Clear the Enable, and set it again to
   // restart the Array. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR, *PERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR, sizeof (ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR) == 4);

   #else
      typedef struct _ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR, *PERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR;

      typedef union _ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR_UNION {
         ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR_UNION, *PERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR_UNION, sizeof (ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR_UNION) == 4);
   #endif


#else
   // Max length (in bytes) of the Line Analyzer Array. When the array fills up, and the
   // last packet arrives whose size exceeds the Max Length, that packet is dropped and
   // the Line Analyzer Array Mode is disabled. Clear the Enable, and set it again to
   // restart the Array. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR, *PERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR, sizeof (ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR) == 4);

   #else
      typedef struct _ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR, *PERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR;

      typedef union _ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR_UNION {
         ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR_UNION, *PERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR_UNION, sizeof (ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Number of bytes in the current Line Analyzer Array. Note that this value includes
   // bytes that may be in transit to the Line Analyzer Array. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR, *PERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR, sizeof (ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR) == 4);

   #else
      typedef struct _ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR, *PERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR;

      typedef union _ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR_UNION {
         ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR_UNION, *PERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR_UNION, sizeof (ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR_UNION) == 4);
   #endif


#else
   // Number of bytes in the current Line Analyzer Array. Note that this value includes
   // bytes that may be in transit to the Line Analyzer Array. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR, *PERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR, sizeof (ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR) == 4);

   #else
      typedef struct _ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR, *PERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR;

      typedef union _ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR_UNION {
         ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR_UNION, *PERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR_UNION, sizeof (ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Indicates which RSS rings are associated with Intercface 0 and Interface 1. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_RSS_ASSOCIATION_CSR {
         union {
            struct { 
               u32 rsvd1 : 8;                     // DWORD 0
               u32 interface1 : 8;                // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 interface0 : 8;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_RSS_ASSOCIATION_CSR, *PERX_RSS_ASSOCIATION_CSR;

      SG_C_ASSERT(__sizeof__ERX_RSS_ASSOCIATION_CSR, sizeof (ERX_RSS_ASSOCIATION_CSR) == 4);

   #else
      typedef struct _ERX_RSS_ASSOCIATION_CSR {
         u32 rsvd1 : 8;                           // DWORD 0
         u32 interface1 : 8;                      // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 interface0 : 8;                      // DWORD 0
      } SG_PACK ERX_RSS_ASSOCIATION_CSR, *PERX_RSS_ASSOCIATION_CSR;

      typedef union _ERX_RSS_ASSOCIATION_CSR_UNION {
         ERX_RSS_ASSOCIATION_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_RSS_ASSOCIATION_CSR_UNION, *PERX_RSS_ASSOCIATION_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_RSS_ASSOCIATION_CSR_UNION, sizeof (ERX_RSS_ASSOCIATION_CSR_UNION) == 4);
   #endif


#else
   // Indicates which RSS rings are associated with Intercface 0 and Interface 1. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_RSS_ASSOCIATION_CSR {
         union {
            struct { 
               u32 interface0 : 8;                // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 interface1 : 8;                // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_RSS_ASSOCIATION_CSR, *PERX_RSS_ASSOCIATION_CSR;

      SG_C_ASSERT(__sizeof__ERX_RSS_ASSOCIATION_CSR, sizeof (ERX_RSS_ASSOCIATION_CSR) == 4);

   #else
      typedef struct _ERX_RSS_ASSOCIATION_CSR {
         u32 interface0 : 8;                      // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 interface1 : 8;                      // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 0
      } SG_PACK ERX_RSS_ASSOCIATION_CSR, *PERX_RSS_ASSOCIATION_CSR;

      typedef union _ERX_RSS_ASSOCIATION_CSR_UNION {
         ERX_RSS_ASSOCIATION_CSR bits;
         u32 dw; // dword union
      } SG_PACK ERX_RSS_ASSOCIATION_CSR_UNION, *PERX_RSS_ASSOCIATION_CSR_UNION;

      SG_C_ASSERT(__sizeof__ERX_RSS_ASSOCIATION_CSR_UNION, sizeof (ERX_RSS_ASSOCIATION_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ethernet receive CSRs. The offsets are relative to the start of the Ethernet RX
   // module.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_CSRMAP {
         union {
            struct { 
               ERX_CFG_CSR cfg;
               ERX_INTERNAL_ISR_CSR int_isr;
               ERX_INTERNAL_IMR_CSR int_imr;
               ERX_INTERNAL_INT_STATUS0_CSR int_stat0;
               ERX_INTERNAL_INT_STATUS2_CSR int_stat2;
               ERX_RQ_RING_INDEX_CSR addr_idx;
               ERX_RQ_RING_BASE_ADDR_CSR base_addr;
               ERX_CQID_CSR cqid[44];
               ERX_PDID_CSR pdid[44];
               ERX_MTU_CSR mtu[44];
               ERX_DEBUG_CSR debug[44];
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
                  PQ_DATA2_WRITE_CSR wrdata2;
                  PQ_DATA2_READ_CSR rddata2;
                  PQ_DATA3_WRITE_CSR wrdata3;
                  PQ_DATA3_READ_CSR rddata3;
               } rxpp_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } wdma_pq;
               GEN_CTXIF_DEBUG ctxif_debug;
               HWDBG_CSRMAP hwdbg;
               ERX_FRAG_DEBUG_CSR frag_debug[44];
               ERX_REQ_THROTTLE req_throttle;
               ERX_UE_SOURCE ue_source;
               ERX_UE_ENABLE ue_enable;
               ERX_LINE_ANALYZER_ARRAY_CTRL_CSR line_analyzer_array_ctrl;
               ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR line_analyzer_array_addr_lsw;
               ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR line_analyzer_array_addr_msw;
               ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR line_analyzer_array_max_len;
               ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR line_analyzer_array_curr_len;
               ERX_RSS_ASSOCIATION_CSR rss_association;
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK ERX_CSRMAP, *PERX_CSRMAP;

      SG_C_ASSERT(__sizeof__ERX_CSRMAP, sizeof (ERX_CSRMAP) == 1024);

   #else
      typedef struct _ERX_CSRMAP {
         ERX_CFG_CSR cfg;
         ERX_INTERNAL_ISR_CSR int_isr;
         ERX_INTERNAL_IMR_CSR int_imr;
         ERX_INTERNAL_INT_STATUS0_CSR int_stat0;
         ERX_INTERNAL_INT_STATUS2_CSR int_stat2;
         ERX_RQ_RING_INDEX_CSR addr_idx;
         ERX_RQ_RING_BASE_ADDR_CSR base_addr;
         ERX_CQID_CSR cqid[44];
         ERX_PDID_CSR pdid[44];
         ERX_MTU_CSR mtu[44];
         ERX_DEBUG_CSR debug[44];
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
            PQ_DATA2_WRITE_CSR wrdata2;
            PQ_DATA2_READ_CSR rddata2;
            PQ_DATA3_WRITE_CSR wrdata3;
            PQ_DATA3_READ_CSR rddata3;
         } rxpp_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } wdma_pq;
         GEN_CTXIF_DEBUG ctxif_debug;
         HWDBG_CSRMAP hwdbg;
         ERX_FRAG_DEBUG_CSR frag_debug[44];
         ERX_REQ_THROTTLE req_throttle;
         ERX_UE_SOURCE ue_source;
         ERX_UE_ENABLE ue_enable;
         ERX_LINE_ANALYZER_ARRAY_CTRL_CSR line_analyzer_array_ctrl;
         ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR line_analyzer_array_addr_lsw;
         ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR line_analyzer_array_addr_msw;
         ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR line_analyzer_array_max_len;
         ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR line_analyzer_array_curr_len;
         ERX_RSS_ASSOCIATION_CSR rss_association;
      } SG_PACK ERX_CSRMAP, *PERX_CSRMAP;

      typedef union _ERX_CSRMAP_UNION {
         ERX_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK ERX_CSRMAP_UNION, *PERX_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__ERX_CSRMAP_UNION, sizeof (ERX_CSRMAP_UNION) == 1024);
   #endif


#else
   // Ethernet receive CSRs. The offsets are relative to the start of the Ethernet RX
   // module.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_CSRMAP {
         union {
            struct { 
               ERX_CFG_CSR cfg;
               ERX_INTERNAL_ISR_CSR int_isr;
               ERX_INTERNAL_IMR_CSR int_imr;
               ERX_INTERNAL_INT_STATUS0_CSR int_stat0;
               ERX_INTERNAL_INT_STATUS2_CSR int_stat2;
               ERX_RQ_RING_INDEX_CSR addr_idx;
               ERX_RQ_RING_BASE_ADDR_CSR base_addr;
               ERX_CQID_CSR cqid[44];
               ERX_PDID_CSR pdid[44];
               ERX_MTU_CSR mtu[44];
               ERX_DEBUG_CSR debug[44];
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
                  PQ_DATA2_WRITE_CSR wrdata2;
                  PQ_DATA2_READ_CSR rddata2;
                  PQ_DATA3_WRITE_CSR wrdata3;
                  PQ_DATA3_READ_CSR rddata3;
               } rxpp_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } wdma_pq;
               GEN_CTXIF_DEBUG ctxif_debug;
               HWDBG_CSRMAP hwdbg;
               ERX_FRAG_DEBUG_CSR frag_debug[44];
               ERX_REQ_THROTTLE req_throttle;
               ERX_UE_SOURCE ue_source;
               ERX_UE_ENABLE ue_enable;
               ERX_LINE_ANALYZER_ARRAY_CTRL_CSR line_analyzer_array_ctrl;
               ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR line_analyzer_array_addr_lsw;
               ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR line_analyzer_array_addr_msw;
               ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR line_analyzer_array_max_len;
               ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR line_analyzer_array_curr_len;
               ERX_RSS_ASSOCIATION_CSR rss_association;
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK ERX_CSRMAP, *PERX_CSRMAP;

      SG_C_ASSERT(__sizeof__ERX_CSRMAP, sizeof (ERX_CSRMAP) == 1024);

   #else
      typedef struct _ERX_CSRMAP {
         ERX_CFG_CSR cfg;
         ERX_INTERNAL_ISR_CSR int_isr;
         ERX_INTERNAL_IMR_CSR int_imr;
         ERX_INTERNAL_INT_STATUS0_CSR int_stat0;
         ERX_INTERNAL_INT_STATUS2_CSR int_stat2;
         ERX_RQ_RING_INDEX_CSR addr_idx;
         ERX_RQ_RING_BASE_ADDR_CSR base_addr;
         ERX_CQID_CSR cqid[44];
         ERX_PDID_CSR pdid[44];
         ERX_MTU_CSR mtu[44];
         ERX_DEBUG_CSR debug[44];
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
            PQ_DATA2_WRITE_CSR wrdata2;
            PQ_DATA2_READ_CSR rddata2;
            PQ_DATA3_WRITE_CSR wrdata3;
            PQ_DATA3_READ_CSR rddata3;
         } rxpp_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } wdma_pq;
         GEN_CTXIF_DEBUG ctxif_debug;
         HWDBG_CSRMAP hwdbg;
         ERX_FRAG_DEBUG_CSR frag_debug[44];
         ERX_REQ_THROTTLE req_throttle;
         ERX_UE_SOURCE ue_source;
         ERX_UE_ENABLE ue_enable;
         ERX_LINE_ANALYZER_ARRAY_CTRL_CSR line_analyzer_array_ctrl;
         ERX_LINE_ANALYZER_ARRAY_ADDR_LSW_CSR line_analyzer_array_addr_lsw;
         ERX_LINE_ANALYZER_ARRAY_ADDR_MSW_CSR line_analyzer_array_addr_msw;
         ERX_LINE_ANALYZER_ARRAY_MAX_LEN_CSR line_analyzer_array_max_len;
         ERX_LINE_ANALYZER_ARRAY_CURR_LEN_CSR line_analyzer_array_curr_len;
         ERX_RSS_ASSOCIATION_CSR rss_association;
      } SG_PACK ERX_CSRMAP, *PERX_CSRMAP;

      typedef union _ERX_CSRMAP_UNION {
         ERX_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK ERX_CSRMAP_UNION, *PERX_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__ERX_CSRMAP_UNION, sizeof (ERX_CSRMAP_UNION) == 1024);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This struct describes the ERX stat layout if one where to sequentially read all the
   // available stat indices. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_ERX_STATS {
         union {
            struct { 
               u32 rx_drops_no_fragments[44];     // DWORDS 0 to 43
               u32 debug_wdma_sent_hold;          // DWORD 44
               u32 debug_wdma_pbfree_sent_hold;   // DWORD 45
               u32 debug_wdma_zerobyte_pbfree_sent_hold; // DWORD 46
               u32 debug_pmem_pbuf_dealloc;       // DWORD 47
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_ERX_STATS, *PBE2_ERX_STATS;

      SG_C_ASSERT(__sizeof__BE2_ERX_STATS, sizeof (BE2_ERX_STATS) == 192);

   #else
      typedef struct _BE2_ERX_STATS {
         u32 rx_drops_no_fragments[44];           // DWORDS 0 to 43
         u32 debug_wdma_sent_hold;                // DWORD 44
         u32 debug_wdma_pbfree_sent_hold;         // DWORD 45
         u32 debug_wdma_zerobyte_pbfree_sent_hold; // DWORD 46
         u32 debug_pmem_pbuf_dealloc;             // DWORD 47
      } SG_PACK BE2_ERX_STATS, *PBE2_ERX_STATS;

      typedef union _BE2_ERX_STATS_UNION {
         BE2_ERX_STATS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_ERX_STATS_UNION, *PBE2_ERX_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_ERX_STATS_UNION, sizeof (BE2_ERX_STATS_UNION) == 192);
   #endif


#else
   // This struct describes the ERX stat layout if one where to sequentially read all the
   // available stat indices. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_ERX_STATS {
         union {
            struct { 
               u32 rx_drops_no_fragments[44];     // DWORDS 0 to 43
               u32 debug_wdma_sent_hold;          // DWORD 44
               u32 debug_wdma_pbfree_sent_hold;   // DWORD 45
               u32 debug_wdma_zerobyte_pbfree_sent_hold; // DWORD 46
               u32 debug_pmem_pbuf_dealloc;       // DWORD 47
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_ERX_STATS, *PBE2_ERX_STATS;

      SG_C_ASSERT(__sizeof__BE2_ERX_STATS, sizeof (BE2_ERX_STATS) == 192);

   #else
      typedef struct _BE2_ERX_STATS {
         u32 rx_drops_no_fragments[44];           // DWORDS 0 to 43
         u32 debug_wdma_sent_hold;                // DWORD 44
         u32 debug_wdma_pbfree_sent_hold;         // DWORD 45
         u32 debug_wdma_zerobyte_pbfree_sent_hold; // DWORD 46
         u32 debug_pmem_pbuf_dealloc;             // DWORD 47
      } SG_PACK BE2_ERX_STATS, *PBE2_ERX_STATS;

      typedef union _BE2_ERX_STATS_UNION {
         BE2_ERX_STATS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_ERX_STATS_UNION, *PBE2_ERX_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_ERX_STATS_UNION, sizeof (BE2_ERX_STATS_UNION) == 192);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __erx_bmap_h__

