/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fc_device_context_bmap_h__
#define __fc_device_context_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "descriptors_bmap.h"
#include "headers_bmap.h"
#include "fc_enums_bmap.h"
#include "common_context_bmap.h"
#include "fc_common_host_struct_bmap.h"
#include "toe_context_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // The on-chip R2T context memory structure for FCoE write commands. RxULP copies the
   // 1st 4 DW of the corresponding ICD into the last 4 DW of this R2T.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_R2T {
         union {
            struct { 
               u32 rx_id : 16;                    // DWORD 0
               u32 sgl_icd_index : 16;            // DWORD 0
               u32 data_xfer_length;              // DWORD 1
               u32 buffer_offset;                 // DWORD 2
               u32 r2t_flip : 1;                  // DWORD 3
               u32 invalid : 1;                   // DWORD 3
               u32 ooo_r2t : 1;                   // DWORD 3
               u32 rsvd0 : 13;                    // DWORD 3
               u32 sb_index : 16;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_R2T, *PFC_R2T;

      SG_C_ASSERT(__sizeof__FC_R2T, sizeof (FC_R2T) == 16);

   #else
      typedef struct _FC_R2T {
         u32 rx_id : 16;                          // DWORD 0
         u32 sgl_icd_index : 16;                  // DWORD 0
         u32 data_xfer_length;                    // DWORD 1
         u32 buffer_offset;                       // DWORD 2
         u32 r2t_flip : 1;                        // DWORD 3
         u32 invalid : 1;                         // DWORD 3
         u32 ooo_r2t : 1;                         // DWORD 3
         u32 rsvd0 : 13;                          // DWORD 3
         u32 sb_index : 16;                       // DWORD 3
      } SG_PACK FC_R2T, *PFC_R2T;

      typedef union _FC_R2T_UNION {
         FC_R2T bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_R2T_UNION, *PFC_R2T_UNION;

      SG_C_ASSERT(__sizeof__FC_R2T_UNION, sizeof (FC_R2T_UNION) == 16);
   #endif


#else
   // The on-chip R2T context memory structure for FCoE write commands. RxULP copies the
   // 1st 4 DW of the corresponding ICD into the last 4 DW of this R2T.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_R2T {
         union {
            struct { 
               u32 sgl_icd_index : 16;            // DWORD 0
               u32 rx_id : 16;                    // DWORD 0
               u32 data_xfer_length;              // DWORD 1
               u32 buffer_offset;                 // DWORD 2
               u32 sb_index : 16;                 // DWORD 3
               u32 rsvd0 : 13;                    // DWORD 3
               u32 ooo_r2t : 1;                   // DWORD 3
               u32 invalid : 1;                   // DWORD 3
               u32 r2t_flip : 1;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_R2T, *PFC_R2T;

      SG_C_ASSERT(__sizeof__FC_R2T, sizeof (FC_R2T) == 16);

   #else
      typedef struct _FC_R2T {
         u32 sgl_icd_index : 16;                  // DWORD 0
         u32 rx_id : 16;                          // DWORD 0
         u32 data_xfer_length;                    // DWORD 1
         u32 buffer_offset;                       // DWORD 2
         u32 sb_index : 16;                       // DWORD 3
         u32 rsvd0 : 13;                          // DWORD 3
         u32 ooo_r2t : 1;                         // DWORD 3
         u32 invalid : 1;                         // DWORD 3
         u32 r2t_flip : 1;                        // DWORD 3
      } SG_PACK FC_R2T, *PFC_R2T;

      typedef union _FC_R2T_UNION {
         FC_R2T bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_R2T_UNION, *PFC_R2T_UNION;

      SG_C_ASSERT(__sizeof__FC_R2T_UNION, sizeof (FC_R2T_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Information associated with peer end port, indexed by Remote Port Index.
   #if defined(SG_BMAP_UNION)
      typedef struct _RPI_CONTEXT {
         union {
            struct { 
               u32 cisc : 1;                      // DWORD 0
               u32 init_e_d_tov : 3;              // DWORD 0
               u32 init_r_a_tov : 4;              // DWORD 0
               u32 my_fc_id : 24;                 // DWORD 0
               u32 invalid : 1;                   // DWORD 1
               u32 paused : 1;                    // DWORD 1
               u32 max_buf_size : 2;              // DWORD 1
               u32 rsvd0 : 1;                     // DWORD 1
               u32 init_rec_tov : 3;              // DWORD 1
               u32 peer_fc_id : 24;               // DWORD 1
               u32 vlan_info_user_priority : 3;   // DWORD 2
               u32 vlan_info_CFI : 1;             // DWORD 2
               u32 vlan_info_vlan_id : 12;        // DWORD 2
               u32 vft_info_priority : 3;         // DWORD 2
               u32 vft_info_VF_ID : 12;           // DWORD 2
               u32 vft_info_rsvd0 : 1;            // DWORD 2
               u32 rsvd1[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RPI_CONTEXT, *PRPI_CONTEXT;

      SG_C_ASSERT(__sizeof__RPI_CONTEXT, sizeof (RPI_CONTEXT) == 16);

   #else
      typedef struct _RPI_CONTEXT {
         u32 cisc : 1;                            // DWORD 0
         u32 init_e_d_tov : 3;                    // DWORD 0
         u32 init_r_a_tov : 4;                    // DWORD 0
         u32 my_fc_id : 24;                       // DWORD 0
         u32 invalid : 1;                         // DWORD 1
         u32 paused : 1;                          // DWORD 1
         u32 max_buf_size : 2;                    // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 1
         u32 init_rec_tov : 3;                    // DWORD 1
         u32 peer_fc_id : 24;                     // DWORD 1
         u32 vlan_info_user_priority : 3;         // DWORD 2
         u32 vlan_info_CFI : 1;                   // DWORD 2
         u32 vlan_info_vlan_id : 12;              // DWORD 2
         u32 vft_info_priority : 3;               // DWORD 2
         u32 vft_info_VF_ID : 12;                 // DWORD 2
         u32 vft_info_rsvd0 : 1;                  // DWORD 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
      } SG_PACK RPI_CONTEXT, *PRPI_CONTEXT;

      typedef union _RPI_CONTEXT_UNION {
         RPI_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK RPI_CONTEXT_UNION, *PRPI_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__RPI_CONTEXT_UNION, sizeof (RPI_CONTEXT_UNION) == 16);
   #endif


#else
   // Information associated with peer end port, indexed by Remote Port Index.
   #if defined(SG_BMAP_UNION)
      typedef struct _RPI_CONTEXT {
         union {
            struct { 
               u32 my_fc_id : 24;                 // DWORD 0
               u32 init_r_a_tov : 4;              // DWORD 0
               u32 init_e_d_tov : 3;              // DWORD 0
               u32 cisc : 1;                      // DWORD 0
               u32 peer_fc_id : 24;               // DWORD 1
               u32 init_rec_tov : 3;              // DWORD 1
               u32 rsvd0 : 1;                     // DWORD 1
               u32 max_buf_size : 2;              // DWORD 1
               u32 paused : 1;                    // DWORD 1
               u32 invalid : 1;                   // DWORD 1
               u32 vft_info_rsvd0 : 1;            // DWORD 2
               u32 vft_info_VF_ID : 12;           // DWORD 2
               u32 vft_info_priority : 3;         // DWORD 2
               u32 vlan_info_vlan_id : 12;        // DWORD 2
               u32 vlan_info_CFI : 1;             // DWORD 2
               u32 vlan_info_user_priority : 3;   // DWORD 2
               u32 rsvd1[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RPI_CONTEXT, *PRPI_CONTEXT;

      SG_C_ASSERT(__sizeof__RPI_CONTEXT, sizeof (RPI_CONTEXT) == 16);

   #else
      typedef struct _RPI_CONTEXT {
         u32 my_fc_id : 24;                       // DWORD 0
         u32 init_r_a_tov : 4;                    // DWORD 0
         u32 init_e_d_tov : 3;                    // DWORD 0
         u32 cisc : 1;                            // DWORD 0
         u32 peer_fc_id : 24;                     // DWORD 1
         u32 init_rec_tov : 3;                    // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 1
         u32 max_buf_size : 2;                    // DWORD 1
         u32 paused : 1;                          // DWORD 1
         u32 invalid : 1;                         // DWORD 1
         u32 vft_info_rsvd0 : 1;                  // DWORD 2
         u32 vft_info_VF_ID : 12;                 // DWORD 2
         u32 vft_info_priority : 3;               // DWORD 2
         u32 vlan_info_vlan_id : 12;              // DWORD 2
         u32 vlan_info_CFI : 1;                   // DWORD 2
         u32 vlan_info_user_priority : 3;         // DWORD 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
      } SG_PACK RPI_CONTEXT, *PRPI_CONTEXT;

      typedef union _RPI_CONTEXT_UNION {
         RPI_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK RPI_CONTEXT_UNION, *PRPI_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__RPI_CONTEXT_UNION, sizeof (RPI_CONTEXT_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Context for I/O when DIF is disabled. Green fields are constants, loaded by TxULP
   // only once when the context is created; pink fields are updated at run time by RxULP;
   // blue fields are updated at run time by TxULP; and white fields are updated at run
   // time by either ULP. All pink, blue, and white fields shall be initialized to zero.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ICD_CONTEXT {
         union {
            struct { 
               u32 request_tag : 16;              // DWORD 0
               u32 init_rec_tov : 3;              // DWORD 0
               u32 erp : 1;                       // DWORD 0
               u32 exchange_originator : 1;       // DWORD 0
               u32 inhibit_auto_abort : 1;        // DWORD 0
               u32 data_placement_offset : 10;    // DWORD 0
               u32 port : 1;                      // DWORD 1
               u32 init_e_d_tov : 3;              // DWORD 1
               u32 init_r_a_tov : 4;              // DWORD 1
               u32 my_fc_id : 24;                 // DWORD 1
               u32 rsvd0 : 8;                     // DWORD 2
               u32 peer_fc_id : 24;               // DWORD 2
               u32 rsvd1 : 8;                     // DWORD 3
               u32 expected_xfer_count : 24;      // DWORD 3
               u32 task_retry_id;                 // DWORD 4
               u32 abort_tag;                     // DWORD 5
               u32 await_els_reply_code : 2;      // DWORD 6
               u32 wrb_ring_id : 10;              // DWORD 6
               u32 cq_id : 10;                    // DWORD 6
               u32 command_iu_length : 10;        // DWORD 6
               u32 remote_x_id : 16;              // DWORD 7
               u32 expected_data_retransmission : 1; // DWORD 7
               u32 rx_abt : 1;                    // DWORD 7
               u32 rx_invalid : 1;                // DWORD 7
               u32 discard_fcp_frames : 1;        // DWORD 7
               u32 rx_r2t_enqueued : 1;           // DWORD 7
               u32 r2t_flip : 1;                  // DWORD 7
               u32 r2t_pidx : 10;                 // DWORD 7
               u32 cmd_tov : 8;                   // DWORD 8
               u32 e_d_tov : 8;                   // DWORD 8
               u32 rec_tov : 8;                   // DWORD 8
               u32 error_recovery_tov : 8;        // DWORD 8
               u32 rx_seq_cnt : 16;               // DWORD 9
               u32 secondary_abts_retry_allowed : 1; // DWORD 9
               u32 secondary_abts_sent : 1;       // DWORD 9
               u32 secondary_r_a_tov_enab : 1;    // DWORD 9
               u32 secondary_rrq_sent : 1;        // DWORD 9
               u32 delayed_abts : 1;              // DWORD 9
               u32 abts_retry_allowed : 1;        // DWORD 9
               u32 abts_sent : 1;                 // DWORD 9
               u32 rec_retry_allowed : 1;         // DWORD 9
               u32 rec_sent : 1;                  // DWORD 9
               u32 srr_sent : 1;                  // DWORD 9
               u32 paused : 1;                    // DWORD 9
               u32 delayed_abts_ipc : 1;          // DWORD 9
               u32 rpi_timewait : 1;              // DWORD 9
               u32 conf_iu_req : 1;               // DWORD 9
               u32 ooo_data_xfer : 1;             // DWORD 9
               u32 in_sequence : 1;               // DWORD 9
               u32 seq_id : 8;                    // DWORD 10
               u32 rx_total_bytes_xfer : 24;      // DWORD 10
               u32 rsvd2 : 8;                     // DWORD 11
               u32 rx_expected_relative_offset : 24; // DWORD 11
               u32 sctx : 1;                      // DWORD 12
               u32 dif_en : 1;                    // DWORD 12
               u32 max_buf_size : 2;              // DWORD 12
               u32 pv : 1;                        // DWORD 12
               u32 priority : 3;                  // DWORD 12
               u32 tx_total_bytes_xfer : 24;      // DWORD 12
               u32 rsvd3 : 7;                     // DWORD 13
               u32 single_frame_write : 1;        // DWORD 13
               u32 tx_expected_relative_offset : 24; // DWORD 13
               u32 cur_frag_offset : 16;          // DWORD 14
               u32 tx_abt : 1;                    // DWORD 14
               u32 invalid : 1;                   // DWORD 14
               u32 tx_r2t_completed : 1;          // DWORD 14
               u32 tx_r2t_dequeued : 1;           // DWORD 14
               u32 reset_ero : 1;                 // DWORD 14
               u32 ct : 2;                        // DWORD 14
               u32 cur_frag_ptr : 9;              // DWORD 14
               u32 tx_seq_cnt : 16;               // DWORD 15
               u32 rpi : 12;                      // DWORD 15
               u32 cmd_type : 4;                  // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_ICD_CONTEXT, *PFC_ICD_CONTEXT;

      SG_C_ASSERT(__sizeof__FC_ICD_CONTEXT, sizeof (FC_ICD_CONTEXT) == 64);

   #else
      typedef struct _FC_ICD_CONTEXT {
         u32 request_tag : 16;                    // DWORD 0
         u32 init_rec_tov : 3;                    // DWORD 0
         u32 erp : 1;                             // DWORD 0
         u32 exchange_originator : 1;             // DWORD 0
         u32 inhibit_auto_abort : 1;              // DWORD 0
         u32 data_placement_offset : 10;          // DWORD 0
         u32 port : 1;                            // DWORD 1
         u32 init_e_d_tov : 3;                    // DWORD 1
         u32 init_r_a_tov : 4;                    // DWORD 1
         u32 my_fc_id : 24;                       // DWORD 1
         u32 rsvd0 : 8;                           // DWORD 2
         u32 peer_fc_id : 24;                     // DWORD 2
         u32 rsvd1 : 8;                           // DWORD 3
         u32 expected_xfer_count : 24;            // DWORD 3
         u32 task_retry_id;                       // DWORD 4
         u32 abort_tag;                           // DWORD 5
         u32 await_els_reply_code : 2;            // DWORD 6
         u32 wrb_ring_id : 10;                    // DWORD 6
         u32 cq_id : 10;                          // DWORD 6
         u32 command_iu_length : 10;              // DWORD 6
         u32 remote_x_id : 16;                    // DWORD 7
         u32 expected_data_retransmission : 1;    // DWORD 7
         u32 rx_abt : 1;                          // DWORD 7
         u32 rx_invalid : 1;                      // DWORD 7
         u32 discard_fcp_frames : 1;              // DWORD 7
         u32 rx_r2t_enqueued : 1;                 // DWORD 7
         u32 r2t_flip : 1;                        // DWORD 7
         u32 r2t_pidx : 10;                       // DWORD 7
         u32 cmd_tov : 8;                         // DWORD 8
         u32 e_d_tov : 8;                         // DWORD 8
         u32 rec_tov : 8;                         // DWORD 8
         u32 error_recovery_tov : 8;              // DWORD 8
         u32 rx_seq_cnt : 16;                     // DWORD 9
         u32 secondary_abts_retry_allowed : 1;    // DWORD 9
         u32 secondary_abts_sent : 1;             // DWORD 9
         u32 secondary_r_a_tov_enab : 1;          // DWORD 9
         u32 secondary_rrq_sent : 1;              // DWORD 9
         u32 delayed_abts : 1;                    // DWORD 9
         u32 abts_retry_allowed : 1;              // DWORD 9
         u32 abts_sent : 1;                       // DWORD 9
         u32 rec_retry_allowed : 1;               // DWORD 9
         u32 rec_sent : 1;                        // DWORD 9
         u32 srr_sent : 1;                        // DWORD 9
         u32 paused : 1;                          // DWORD 9
         u32 delayed_abts_ipc : 1;                // DWORD 9
         u32 rpi_timewait : 1;                    // DWORD 9
         u32 conf_iu_req : 1;                     // DWORD 9
         u32 ooo_data_xfer : 1;                   // DWORD 9
         u32 in_sequence : 1;                     // DWORD 9
         u32 seq_id : 8;                          // DWORD 10
         u32 rx_total_bytes_xfer : 24;            // DWORD 10
         u32 rsvd2 : 8;                           // DWORD 11
         u32 rx_expected_relative_offset : 24;    // DWORD 11
         u32 sctx : 1;                            // DWORD 12
         u32 dif_en : 1;                          // DWORD 12
         u32 max_buf_size : 2;                    // DWORD 12
         u32 pv : 1;                              // DWORD 12
         u32 priority : 3;                        // DWORD 12
         u32 tx_total_bytes_xfer : 24;            // DWORD 12
         u32 rsvd3 : 7;                           // DWORD 13
         u32 single_frame_write : 1;              // DWORD 13
         u32 tx_expected_relative_offset : 24;    // DWORD 13
         u32 cur_frag_offset : 16;                // DWORD 14
         u32 tx_abt : 1;                          // DWORD 14
         u32 invalid : 1;                         // DWORD 14
         u32 tx_r2t_completed : 1;                // DWORD 14
         u32 tx_r2t_dequeued : 1;                 // DWORD 14
         u32 reset_ero : 1;                       // DWORD 14
         u32 ct : 2;                              // DWORD 14
         u32 cur_frag_ptr : 9;                    // DWORD 14
         u32 tx_seq_cnt : 16;                     // DWORD 15
         u32 rpi : 12;                            // DWORD 15
         u32 cmd_type : 4;                        // DWORD 15
      } SG_PACK FC_ICD_CONTEXT, *PFC_ICD_CONTEXT;

      typedef union _FC_ICD_CONTEXT_UNION {
         FC_ICD_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_ICD_CONTEXT_UNION, *PFC_ICD_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FC_ICD_CONTEXT_UNION, sizeof (FC_ICD_CONTEXT_UNION) == 64);
   #endif


#else
   // Context for I/O when DIF is disabled. Green fields are constants, loaded by TxULP
   // only once when the context is created; pink fields are updated at run time by RxULP;
   // blue fields are updated at run time by TxULP; and white fields are updated at run
   // time by either ULP. All pink, blue, and white fields shall be initialized to zero.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ICD_CONTEXT {
         union {
            struct { 
               u32 data_placement_offset : 10;    // DWORD 0
               u32 inhibit_auto_abort : 1;        // DWORD 0
               u32 exchange_originator : 1;       // DWORD 0
               u32 erp : 1;                       // DWORD 0
               u32 init_rec_tov : 3;              // DWORD 0
               u32 request_tag : 16;              // DWORD 0
               u32 my_fc_id : 24;                 // DWORD 1
               u32 init_r_a_tov : 4;              // DWORD 1
               u32 init_e_d_tov : 3;              // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 peer_fc_id : 24;               // DWORD 2
               u32 rsvd0 : 8;                     // DWORD 2
               u32 expected_xfer_count : 24;      // DWORD 3
               u32 rsvd1 : 8;                     // DWORD 3
               u32 task_retry_id;                 // DWORD 4
               u32 abort_tag;                     // DWORD 5
               u32 command_iu_length : 10;        // DWORD 6
               u32 cq_id : 10;                    // DWORD 6
               u32 wrb_ring_id : 10;              // DWORD 6
               u32 await_els_reply_code : 2;      // DWORD 6
               u32 r2t_pidx : 10;                 // DWORD 7
               u32 r2t_flip : 1;                  // DWORD 7
               u32 rx_r2t_enqueued : 1;           // DWORD 7
               u32 discard_fcp_frames : 1;        // DWORD 7
               u32 rx_invalid : 1;                // DWORD 7
               u32 rx_abt : 1;                    // DWORD 7
               u32 expected_data_retransmission : 1; // DWORD 7
               u32 remote_x_id : 16;              // DWORD 7
               u32 error_recovery_tov : 8;        // DWORD 8
               u32 rec_tov : 8;                   // DWORD 8
               u32 e_d_tov : 8;                   // DWORD 8
               u32 cmd_tov : 8;                   // DWORD 8
               u32 in_sequence : 1;               // DWORD 9
               u32 ooo_data_xfer : 1;             // DWORD 9
               u32 conf_iu_req : 1;               // DWORD 9
               u32 rpi_timewait : 1;              // DWORD 9
               u32 delayed_abts_ipc : 1;          // DWORD 9
               u32 paused : 1;                    // DWORD 9
               u32 srr_sent : 1;                  // DWORD 9
               u32 rec_sent : 1;                  // DWORD 9
               u32 rec_retry_allowed : 1;         // DWORD 9
               u32 abts_sent : 1;                 // DWORD 9
               u32 abts_retry_allowed : 1;        // DWORD 9
               u32 delayed_abts : 1;              // DWORD 9
               u32 secondary_rrq_sent : 1;        // DWORD 9
               u32 secondary_r_a_tov_enab : 1;    // DWORD 9
               u32 secondary_abts_sent : 1;       // DWORD 9
               u32 secondary_abts_retry_allowed : 1; // DWORD 9
               u32 rx_seq_cnt : 16;               // DWORD 9
               u32 rx_total_bytes_xfer : 24;      // DWORD 10
               u32 seq_id : 8;                    // DWORD 10
               u32 rx_expected_relative_offset : 24; // DWORD 11
               u32 rsvd2 : 8;                     // DWORD 11
               u32 tx_total_bytes_xfer : 24;      // DWORD 12
               u32 priority : 3;                  // DWORD 12
               u32 pv : 1;                        // DWORD 12
               u32 max_buf_size : 2;              // DWORD 12
               u32 dif_en : 1;                    // DWORD 12
               u32 sctx : 1;                      // DWORD 12
               u32 tx_expected_relative_offset : 24; // DWORD 13
               u32 single_frame_write : 1;        // DWORD 13
               u32 rsvd3 : 7;                     // DWORD 13
               u32 cur_frag_ptr : 9;              // DWORD 14
               u32 ct : 2;                        // DWORD 14
               u32 reset_ero : 1;                 // DWORD 14
               u32 tx_r2t_dequeued : 1;           // DWORD 14
               u32 tx_r2t_completed : 1;          // DWORD 14
               u32 invalid : 1;                   // DWORD 14
               u32 tx_abt : 1;                    // DWORD 14
               u32 cur_frag_offset : 16;          // DWORD 14
               u32 cmd_type : 4;                  // DWORD 15
               u32 rpi : 12;                      // DWORD 15
               u32 tx_seq_cnt : 16;               // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_ICD_CONTEXT, *PFC_ICD_CONTEXT;

      SG_C_ASSERT(__sizeof__FC_ICD_CONTEXT, sizeof (FC_ICD_CONTEXT) == 64);

   #else
      typedef struct _FC_ICD_CONTEXT {
         u32 data_placement_offset : 10;          // DWORD 0
         u32 inhibit_auto_abort : 1;              // DWORD 0
         u32 exchange_originator : 1;             // DWORD 0
         u32 erp : 1;                             // DWORD 0
         u32 init_rec_tov : 3;                    // DWORD 0
         u32 request_tag : 16;                    // DWORD 0
         u32 my_fc_id : 24;                       // DWORD 1
         u32 init_r_a_tov : 4;                    // DWORD 1
         u32 init_e_d_tov : 3;                    // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 peer_fc_id : 24;                     // DWORD 2
         u32 rsvd0 : 8;                           // DWORD 2
         u32 expected_xfer_count : 24;            // DWORD 3
         u32 rsvd1 : 8;                           // DWORD 3
         u32 task_retry_id;                       // DWORD 4
         u32 abort_tag;                           // DWORD 5
         u32 command_iu_length : 10;              // DWORD 6
         u32 cq_id : 10;                          // DWORD 6
         u32 wrb_ring_id : 10;                    // DWORD 6
         u32 await_els_reply_code : 2;            // DWORD 6
         u32 r2t_pidx : 10;                       // DWORD 7
         u32 r2t_flip : 1;                        // DWORD 7
         u32 rx_r2t_enqueued : 1;                 // DWORD 7
         u32 discard_fcp_frames : 1;              // DWORD 7
         u32 rx_invalid : 1;                      // DWORD 7
         u32 rx_abt : 1;                          // DWORD 7
         u32 expected_data_retransmission : 1;    // DWORD 7
         u32 remote_x_id : 16;                    // DWORD 7
         u32 error_recovery_tov : 8;              // DWORD 8
         u32 rec_tov : 8;                         // DWORD 8
         u32 e_d_tov : 8;                         // DWORD 8
         u32 cmd_tov : 8;                         // DWORD 8
         u32 in_sequence : 1;                     // DWORD 9
         u32 ooo_data_xfer : 1;                   // DWORD 9
         u32 conf_iu_req : 1;                     // DWORD 9
         u32 rpi_timewait : 1;                    // DWORD 9
         u32 delayed_abts_ipc : 1;                // DWORD 9
         u32 paused : 1;                          // DWORD 9
         u32 srr_sent : 1;                        // DWORD 9
         u32 rec_sent : 1;                        // DWORD 9
         u32 rec_retry_allowed : 1;               // DWORD 9
         u32 abts_sent : 1;                       // DWORD 9
         u32 abts_retry_allowed : 1;              // DWORD 9
         u32 delayed_abts : 1;                    // DWORD 9
         u32 secondary_rrq_sent : 1;              // DWORD 9
         u32 secondary_r_a_tov_enab : 1;          // DWORD 9
         u32 secondary_abts_sent : 1;             // DWORD 9
         u32 secondary_abts_retry_allowed : 1;    // DWORD 9
         u32 rx_seq_cnt : 16;                     // DWORD 9
         u32 rx_total_bytes_xfer : 24;            // DWORD 10
         u32 seq_id : 8;                          // DWORD 10
         u32 rx_expected_relative_offset : 24;    // DWORD 11
         u32 rsvd2 : 8;                           // DWORD 11
         u32 tx_total_bytes_xfer : 24;            // DWORD 12
         u32 priority : 3;                        // DWORD 12
         u32 pv : 1;                              // DWORD 12
         u32 max_buf_size : 2;                    // DWORD 12
         u32 dif_en : 1;                          // DWORD 12
         u32 sctx : 1;                            // DWORD 12
         u32 tx_expected_relative_offset : 24;    // DWORD 13
         u32 single_frame_write : 1;              // DWORD 13
         u32 rsvd3 : 7;                           // DWORD 13
         u32 cur_frag_ptr : 9;                    // DWORD 14
         u32 ct : 2;                              // DWORD 14
         u32 reset_ero : 1;                       // DWORD 14
         u32 tx_r2t_dequeued : 1;                 // DWORD 14
         u32 tx_r2t_completed : 1;                // DWORD 14
         u32 invalid : 1;                         // DWORD 14
         u32 tx_abt : 1;                          // DWORD 14
         u32 cur_frag_offset : 16;                // DWORD 14
         u32 cmd_type : 4;                        // DWORD 15
         u32 rpi : 12;                            // DWORD 15
         u32 tx_seq_cnt : 16;                     // DWORD 15
      } SG_PACK FC_ICD_CONTEXT, *PFC_ICD_CONTEXT;

      typedef union _FC_ICD_CONTEXT_UNION {
         FC_ICD_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_ICD_CONTEXT_UNION, *PFC_ICD_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FC_ICD_CONTEXT_UNION, sizeof (FC_ICD_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ICD information associated with transmit/write command processing. Should be
   // maintained in sync with the last 16 bytes of FC_ICD_CONTEXT.
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_ICD {
         union {
            struct { 
               u32 sctx : 1;                      // DWORD 0
               u32 dif_en : 1;                    // DWORD 0
               u32 max_buf_size : 2;              // DWORD 0
               u32 pv : 1;                        // DWORD 0
               u32 priority : 3;                  // DWORD 0
               u32 total_bytes_xfer : 24;         // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 1
               u32 single_frame_write : 1;        // DWORD 1
               u32 expected_relative_offset : 24; // DWORD 1
               u32 cur_frag_offset : 16;          // DWORD 2
               u32 tx_abt : 1;                    // DWORD 2
               u32 invalid : 1;                   // DWORD 2
               u32 tx_r2t_completed : 1;          // DWORD 2
               u32 tx_r2t_dequeued : 1;           // DWORD 2
               u32 reset_ero : 1;                 // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 cur_frag_ptr : 9;              // DWORD 2
               u32 seq_cnt : 16;                  // DWORD 3
               u32 rpi : 12;                      // DWORD 3
               u32 cmd_type : 4;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TX_ICD, *PTX_ICD;

      SG_C_ASSERT(__sizeof__TX_ICD, sizeof (TX_ICD) == 16);

   #else
      typedef struct _TX_ICD {
         u32 sctx : 1;                            // DWORD 0
         u32 dif_en : 1;                          // DWORD 0
         u32 max_buf_size : 2;                    // DWORD 0
         u32 pv : 1;                              // DWORD 0
         u32 priority : 3;                        // DWORD 0
         u32 total_bytes_xfer : 24;               // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 1
         u32 single_frame_write : 1;              // DWORD 1
         u32 expected_relative_offset : 24;       // DWORD 1
         u32 cur_frag_offset : 16;                // DWORD 2
         u32 tx_abt : 1;                          // DWORD 2
         u32 invalid : 1;                         // DWORD 2
         u32 tx_r2t_completed : 1;                // DWORD 2
         u32 tx_r2t_dequeued : 1;                 // DWORD 2
         u32 reset_ero : 1;                       // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 cur_frag_ptr : 9;                    // DWORD 2
         u32 seq_cnt : 16;                        // DWORD 3
         u32 rpi : 12;                            // DWORD 3
         u32 cmd_type : 4;                        // DWORD 3
      } SG_PACK TX_ICD, *PTX_ICD;

      typedef union _TX_ICD_UNION {
         TX_ICD bits;
         u32 dw[4]; // dword union
      } SG_PACK TX_ICD_UNION, *PTX_ICD_UNION;

      SG_C_ASSERT(__sizeof__TX_ICD_UNION, sizeof (TX_ICD_UNION) == 16);
   #endif


#else
   // ICD information associated with transmit/write command processing. Should be
   // maintained in sync with the last 16 bytes of FC_ICD_CONTEXT.
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_ICD {
         union {
            struct { 
               u32 total_bytes_xfer : 24;         // DWORD 0
               u32 priority : 3;                  // DWORD 0
               u32 pv : 1;                        // DWORD 0
               u32 max_buf_size : 2;              // DWORD 0
               u32 dif_en : 1;                    // DWORD 0
               u32 sctx : 1;                      // DWORD 0
               u32 expected_relative_offset : 24; // DWORD 1
               u32 single_frame_write : 1;        // DWORD 1
               u32 rsvd0 : 7;                     // DWORD 1
               u32 cur_frag_ptr : 9;              // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 reset_ero : 1;                 // DWORD 2
               u32 tx_r2t_dequeued : 1;           // DWORD 2
               u32 tx_r2t_completed : 1;          // DWORD 2
               u32 invalid : 1;                   // DWORD 2
               u32 tx_abt : 1;                    // DWORD 2
               u32 cur_frag_offset : 16;          // DWORD 2
               u32 cmd_type : 4;                  // DWORD 3
               u32 rpi : 12;                      // DWORD 3
               u32 seq_cnt : 16;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TX_ICD, *PTX_ICD;

      SG_C_ASSERT(__sizeof__TX_ICD, sizeof (TX_ICD) == 16);

   #else
      typedef struct _TX_ICD {
         u32 total_bytes_xfer : 24;               // DWORD 0
         u32 priority : 3;                        // DWORD 0
         u32 pv : 1;                              // DWORD 0
         u32 max_buf_size : 2;                    // DWORD 0
         u32 dif_en : 1;                          // DWORD 0
         u32 sctx : 1;                            // DWORD 0
         u32 expected_relative_offset : 24;       // DWORD 1
         u32 single_frame_write : 1;              // DWORD 1
         u32 rsvd0 : 7;                           // DWORD 1
         u32 cur_frag_ptr : 9;                    // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 reset_ero : 1;                       // DWORD 2
         u32 tx_r2t_dequeued : 1;                 // DWORD 2
         u32 tx_r2t_completed : 1;                // DWORD 2
         u32 invalid : 1;                         // DWORD 2
         u32 tx_abt : 1;                          // DWORD 2
         u32 cur_frag_offset : 16;                // DWORD 2
         u32 cmd_type : 4;                        // DWORD 3
         u32 rpi : 12;                            // DWORD 3
         u32 seq_cnt : 16;                        // DWORD 3
      } SG_PACK TX_ICD, *PTX_ICD;

      typedef union _TX_ICD_UNION {
         TX_ICD bits;
         u32 dw[4]; // dword union
      } SG_PACK TX_ICD_UNION, *PTX_ICD_UNION;

      SG_C_ASSERT(__sizeof__TX_ICD_UNION, sizeof (TX_ICD_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Saved Buffer Descriptor (reserved field overloaded with info. for multi-frame
   // XMIT_SEQUENCE64)
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_BUFFER_DESC {
         union {
            struct { 
               u32 frag_pa_hi;                    // DWORD 0
               u32 frag_pa_lo;                    // DWORD 1
               u32 request_tag : 16;              // DWORD 2
               u32 ox_id : 16;                    // DWORD 2
               u32 ddr : 1;                       // DWORD 3
               u32 cq_id : 12;                    // DWORD 3
               u32 rsvd0 : 2;                     // DWORD 3
               u32 frag_len : 17;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TX_BUFFER_DESC, *PTX_BUFFER_DESC;

      SG_C_ASSERT(__sizeof__TX_BUFFER_DESC, sizeof (TX_BUFFER_DESC) == 16);

   #else
      typedef struct _TX_BUFFER_DESC {
         u32 frag_pa_hi;                          // DWORD 0
         u32 frag_pa_lo;                          // DWORD 1
         u32 request_tag : 16;                    // DWORD 2
         u32 ox_id : 16;                          // DWORD 2
         u32 ddr : 1;                             // DWORD 3
         u32 cq_id : 12;                          // DWORD 3
         u32 rsvd0 : 2;                           // DWORD 3
         u32 frag_len : 17;                       // DWORD 3
      } SG_PACK TX_BUFFER_DESC, *PTX_BUFFER_DESC;

      typedef union _TX_BUFFER_DESC_UNION {
         TX_BUFFER_DESC bits;
         u32 dw[4]; // dword union
      } SG_PACK TX_BUFFER_DESC_UNION, *PTX_BUFFER_DESC_UNION;

      SG_C_ASSERT(__sizeof__TX_BUFFER_DESC_UNION, sizeof (TX_BUFFER_DESC_UNION) == 16);
   #endif


#else
   // Saved Buffer Descriptor (reserved field overloaded with info. for multi-frame
   // XMIT_SEQUENCE64)
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_BUFFER_DESC {
         union {
            struct { 
               u32 frag_pa_hi;                    // DWORD 0
               u32 frag_pa_lo;                    // DWORD 1
               u32 ox_id : 16;                    // DWORD 2
               u32 request_tag : 16;              // DWORD 2
               u32 frag_len : 17;                 // DWORD 3
               u32 rsvd0 : 2;                     // DWORD 3
               u32 cq_id : 12;                    // DWORD 3
               u32 ddr : 1;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TX_BUFFER_DESC, *PTX_BUFFER_DESC;

      SG_C_ASSERT(__sizeof__TX_BUFFER_DESC, sizeof (TX_BUFFER_DESC) == 16);

   #else
      typedef struct _TX_BUFFER_DESC {
         u32 frag_pa_hi;                          // DWORD 0
         u32 frag_pa_lo;                          // DWORD 1
         u32 ox_id : 16;                          // DWORD 2
         u32 request_tag : 16;                    // DWORD 2
         u32 frag_len : 17;                       // DWORD 3
         u32 rsvd0 : 2;                           // DWORD 3
         u32 cq_id : 12;                          // DWORD 3
         u32 ddr : 1;                             // DWORD 3
      } SG_PACK TX_BUFFER_DESC, *PTX_BUFFER_DESC;

      typedef union _TX_BUFFER_DESC_UNION {
         TX_BUFFER_DESC bits;
         u32 dw[4]; // dword union
      } SG_PACK TX_BUFFER_DESC_UNION, *PTX_BUFFER_DESC_UNION;

      SG_C_ASSERT(__sizeof__TX_BUFFER_DESC_UNION, sizeof (TX_BUFFER_DESC_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Information associated with default buffer queue/ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _Def_Buffer_Queue_Info {
         union {
            struct { 
               u32 type_match : 8;                // DWORD 0
               u32 r_ctl_match : 8;               // DWORD 0
               u32 type_mask : 8;                 // DWORD 0
               u32 r_ctl_mask : 8;                // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 1
               u32 ring_id : 16;                  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK Def_Buffer_Queue_Info, *PDef_Buffer_Queue_Info;

      SG_C_ASSERT(__sizeof__Def_Buffer_Queue_Info, sizeof (Def_Buffer_Queue_Info) == 8);

   #else
      typedef struct _Def_Buffer_Queue_Info {
         u32 type_match : 8;                      // DWORD 0
         u32 r_ctl_match : 8;                     // DWORD 0
         u32 type_mask : 8;                       // DWORD 0
         u32 r_ctl_mask : 8;                      // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 1
         u32 ring_id : 16;                        // DWORD 1
      } SG_PACK Def_Buffer_Queue_Info, *PDef_Buffer_Queue_Info;

      typedef union _Def_Buffer_Queue_Info_UNION {
         Def_Buffer_Queue_Info bits;
         u32 dw[2]; // dword union
      } SG_PACK Def_Buffer_Queue_Info_UNION, *PDef_Buffer_Queue_Info_UNION;

      SG_C_ASSERT(__sizeof__Def_Buffer_Queue_Info_UNION, sizeof (Def_Buffer_Queue_Info_UNION) == 8);
   #endif


#else
   // Information associated with default buffer queue/ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _Def_Buffer_Queue_Info {
         union {
            struct { 
               u32 r_ctl_mask : 8;                // DWORD 0
               u32 type_mask : 8;                 // DWORD 0
               u32 r_ctl_match : 8;               // DWORD 0
               u32 type_match : 8;                // DWORD 0
               u32 ring_id : 16;                  // DWORD 1
               u32 rsvd0 : 16;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK Def_Buffer_Queue_Info, *PDef_Buffer_Queue_Info;

      SG_C_ASSERT(__sizeof__Def_Buffer_Queue_Info, sizeof (Def_Buffer_Queue_Info) == 8);

   #else
      typedef struct _Def_Buffer_Queue_Info {
         u32 r_ctl_mask : 8;                      // DWORD 0
         u32 type_mask : 8;                       // DWORD 0
         u32 r_ctl_match : 8;                     // DWORD 0
         u32 type_match : 8;                      // DWORD 0
         u32 ring_id : 16;                        // DWORD 1
         u32 rsvd0 : 16;                          // DWORD 1
      } SG_PACK Def_Buffer_Queue_Info, *PDef_Buffer_Queue_Info;

      typedef union _Def_Buffer_Queue_Info_UNION {
         Def_Buffer_Queue_Info bits;
         u32 dw[2]; // dword union
      } SG_PACK Def_Buffer_Queue_Info_UNION, *PDef_Buffer_Queue_Info_UNION;

      SG_C_ASSERT(__sizeof__Def_Buffer_Queue_Info_UNION, sizeof (Def_Buffer_Queue_Info_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FC WRB send ring context. Each per FCF FC_CONTEXT will be associated with multiple
   // FC_WRB_RING_CONTEXT, txulp process WRB and R2T requests based on
   // FC_WRB_RING_CONTEXT.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_WRB_RING_CONTEXT {
         union {
            struct { 
               RING_CONTEXT_FC ring_context_fc;
               u32 excess_qos : 1;                // DWORD 2
               u32 no_remain_allowed : 1;         // DWORD 2
               u32 yellow_to_red_global : 1;      // DWORD 2
               u32 yellow_to_red_local : 1;       // DWORD 2
               u32 rsvd0 : 2;                     // DWORD 2
               u32 global_flow_id : 5;            // DWORD 2
               u32 local_flow_id : 5;             // DWORD 2
               u32 xri_end_lo_4bit : 4;           // DWORD 2
               u32 xri_start : 12;                // DWORD 2
               u32 r2t_pidx : 10;                 // DWORD 3
               u32 rx_r2t_valid : 1;              // DWORD 3
               u32 rsvd1 : 3;                     // DWORD 3
               u32 xri_end_hi_8bit : 8;           // DWORD 3
               u32 dq_id : 10;                    // DWORD 3
               TX_BUFFER_DESC saved_bd;
               TX_ICD icd;
               u32 rpi_start : 12;                // DWORD 12
               u32 cur_icd : 12;                  // DWORD 12
               u32 rsvd2 : 1;                     // DWORD 12
               u32 emulex_adapter : 1;            // DWORD 12
               u32 ctx_invalid : 1;               // DWORD 12
               u32 inhibit_auto_abort : 1;        // DWORD 12
               u32 target : 1;                    // DWORD 12
               u32 port : 1;                      // DWORD 12
               u32 vlan_dis : 1;                  // DWORD 12
               u32 ext_hdr : 1;                   // DWORD 12
               u32 rsvd3 : 2;                     // DWORD 13
               u32 unsend_sge : 1;                // DWORD 13
               u32 fence_count_decremented : 1;   // DWORD 13
               u32 tx_r2t_valid : 1;              // DWORD 13
               u32 tx_state : 3;                  // DWORD 13
               u32 cur_bytes_left : 24;           // DWORD 13
               u32 R_CTL : 8;                     // DWORD 14
               u32 Type : 8;                      // DWORD 14
               u32 DF_CTL : 8;                    // DWORD 14
               u32 LS : 1;                        // DWORD 14
               u32 ER : 1;                        // DWORD 14
               u32 FSeq : 1;                      // DWORD 14
               u32 rsvd4 : 2;                     // DWORD 14
               u32 SI : 1;                        // DWORD 14
               u32 PU : 2;                        // DWORD 14
               u32 rpi_end : 12;                  // DWORD 15
               u32 rsvd5 : 4;                     // DWORD 15
               u32 remote_x_id : 16;              // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_WRB_RING_CONTEXT, *PFC_WRB_RING_CONTEXT;

      SG_C_ASSERT(__sizeof__FC_WRB_RING_CONTEXT, sizeof (FC_WRB_RING_CONTEXT) == 64);

   #else
      typedef struct _FC_WRB_RING_CONTEXT {
         RING_CONTEXT_FC ring_context_fc;
         u32 excess_qos : 1;                      // DWORD 2
         u32 no_remain_allowed : 1;               // DWORD 2
         u32 yellow_to_red_global : 1;            // DWORD 2
         u32 yellow_to_red_local : 1;             // DWORD 2
         u32 rsvd0 : 2;                           // DWORD 2
         u32 global_flow_id : 5;                  // DWORD 2
         u32 local_flow_id : 5;                   // DWORD 2
         u32 xri_end_lo_4bit : 4;                 // DWORD 2
         u32 xri_start : 12;                      // DWORD 2
         u32 r2t_pidx : 10;                       // DWORD 3
         u32 rx_r2t_valid : 1;                    // DWORD 3
         u32 rsvd1 : 3;                           // DWORD 3
         u32 xri_end_hi_8bit : 8;                 // DWORD 3
         u32 dq_id : 10;                          // DWORD 3
         TX_BUFFER_DESC saved_bd;
         TX_ICD icd;
         u32 rpi_start : 12;                      // DWORD 12
         u32 cur_icd : 12;                        // DWORD 12
         u32 rsvd2 : 1;                           // DWORD 12
         u32 emulex_adapter : 1;                  // DWORD 12
         u32 ctx_invalid : 1;                     // DWORD 12
         u32 inhibit_auto_abort : 1;              // DWORD 12
         u32 target : 1;                          // DWORD 12
         u32 port : 1;                            // DWORD 12
         u32 vlan_dis : 1;                        // DWORD 12
         u32 ext_hdr : 1;                         // DWORD 12
         u32 rsvd3 : 2;                           // DWORD 13
         u32 unsend_sge : 1;                      // DWORD 13
         u32 fence_count_decremented : 1;         // DWORD 13
         u32 tx_r2t_valid : 1;                    // DWORD 13
         u32 tx_state : 3;                        // DWORD 13
         u32 cur_bytes_left : 24;                 // DWORD 13
         u32 R_CTL : 8;                           // DWORD 14
         u32 Type : 8;                            // DWORD 14
         u32 DF_CTL : 8;                          // DWORD 14
         u32 LS : 1;                              // DWORD 14
         u32 ER : 1;                              // DWORD 14
         u32 FSeq : 1;                            // DWORD 14
         u32 rsvd4 : 2;                           // DWORD 14
         u32 SI : 1;                              // DWORD 14
         u32 PU : 2;                              // DWORD 14
         u32 rpi_end : 12;                        // DWORD 15
         u32 rsvd5 : 4;                           // DWORD 15
         u32 remote_x_id : 16;                    // DWORD 15
      } SG_PACK FC_WRB_RING_CONTEXT, *PFC_WRB_RING_CONTEXT;

      typedef union _FC_WRB_RING_CONTEXT_UNION {
         FC_WRB_RING_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_WRB_RING_CONTEXT_UNION, *PFC_WRB_RING_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FC_WRB_RING_CONTEXT_UNION, sizeof (FC_WRB_RING_CONTEXT_UNION) == 64);
   #endif


#else
   // FC WRB send ring context. Each per FCF FC_CONTEXT will be associated with multiple
   // FC_WRB_RING_CONTEXT, txulp process WRB and R2T requests based on
   // FC_WRB_RING_CONTEXT.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_WRB_RING_CONTEXT {
         union {
            struct { 
               RING_CONTEXT_FC ring_context_fc;
               u32 xri_start : 12;                // DWORD 2
               u32 xri_end_lo_4bit : 4;           // DWORD 2
               u32 local_flow_id : 5;             // DWORD 2
               u32 global_flow_id : 5;            // DWORD 2
               u32 rsvd0 : 2;                     // DWORD 2
               u32 yellow_to_red_local : 1;       // DWORD 2
               u32 yellow_to_red_global : 1;      // DWORD 2
               u32 no_remain_allowed : 1;         // DWORD 2
               u32 excess_qos : 1;                // DWORD 2
               u32 dq_id : 10;                    // DWORD 3
               u32 xri_end_hi_8bit : 8;           // DWORD 3
               u32 rsvd1 : 3;                     // DWORD 3
               u32 rx_r2t_valid : 1;              // DWORD 3
               u32 r2t_pidx : 10;                 // DWORD 3
               TX_BUFFER_DESC saved_bd;
               TX_ICD icd;
               u32 ext_hdr : 1;                   // DWORD 12
               u32 vlan_dis : 1;                  // DWORD 12
               u32 port : 1;                      // DWORD 12
               u32 target : 1;                    // DWORD 12
               u32 inhibit_auto_abort : 1;        // DWORD 12
               u32 ctx_invalid : 1;               // DWORD 12
               u32 emulex_adapter : 1;            // DWORD 12
               u32 rsvd2 : 1;                     // DWORD 12
               u32 cur_icd : 12;                  // DWORD 12
               u32 rpi_start : 12;                // DWORD 12
               u32 cur_bytes_left : 24;           // DWORD 13
               u32 tx_state : 3;                  // DWORD 13
               u32 tx_r2t_valid : 1;              // DWORD 13
               u32 fence_count_decremented : 1;   // DWORD 13
               u32 unsend_sge : 1;                // DWORD 13
               u32 rsvd3 : 2;                     // DWORD 13
               u32 PU : 2;                        // DWORD 14
               u32 SI : 1;                        // DWORD 14
               u32 rsvd4 : 2;                     // DWORD 14
               u32 FSeq : 1;                      // DWORD 14
               u32 ER : 1;                        // DWORD 14
               u32 LS : 1;                        // DWORD 14
               u32 DF_CTL : 8;                    // DWORD 14
               u32 Type : 8;                      // DWORD 14
               u32 R_CTL : 8;                     // DWORD 14
               u32 remote_x_id : 16;              // DWORD 15
               u32 rsvd5 : 4;                     // DWORD 15
               u32 rpi_end : 12;                  // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_WRB_RING_CONTEXT, *PFC_WRB_RING_CONTEXT;

      SG_C_ASSERT(__sizeof__FC_WRB_RING_CONTEXT, sizeof (FC_WRB_RING_CONTEXT) == 64);

   #else
      typedef struct _FC_WRB_RING_CONTEXT {
         RING_CONTEXT_FC ring_context_fc;
         u32 xri_start : 12;                      // DWORD 2
         u32 xri_end_lo_4bit : 4;                 // DWORD 2
         u32 local_flow_id : 5;                   // DWORD 2
         u32 global_flow_id : 5;                  // DWORD 2
         u32 rsvd0 : 2;                           // DWORD 2
         u32 yellow_to_red_local : 1;             // DWORD 2
         u32 yellow_to_red_global : 1;            // DWORD 2
         u32 no_remain_allowed : 1;               // DWORD 2
         u32 excess_qos : 1;                      // DWORD 2
         u32 dq_id : 10;                          // DWORD 3
         u32 xri_end_hi_8bit : 8;                 // DWORD 3
         u32 rsvd1 : 3;                           // DWORD 3
         u32 rx_r2t_valid : 1;                    // DWORD 3
         u32 r2t_pidx : 10;                       // DWORD 3
         TX_BUFFER_DESC saved_bd;
         TX_ICD icd;
         u32 ext_hdr : 1;                         // DWORD 12
         u32 vlan_dis : 1;                        // DWORD 12
         u32 port : 1;                            // DWORD 12
         u32 target : 1;                          // DWORD 12
         u32 inhibit_auto_abort : 1;              // DWORD 12
         u32 ctx_invalid : 1;                     // DWORD 12
         u32 emulex_adapter : 1;                  // DWORD 12
         u32 rsvd2 : 1;                           // DWORD 12
         u32 cur_icd : 12;                        // DWORD 12
         u32 rpi_start : 12;                      // DWORD 12
         u32 cur_bytes_left : 24;                 // DWORD 13
         u32 tx_state : 3;                        // DWORD 13
         u32 tx_r2t_valid : 1;                    // DWORD 13
         u32 fence_count_decremented : 1;         // DWORD 13
         u32 unsend_sge : 1;                      // DWORD 13
         u32 rsvd3 : 2;                           // DWORD 13
         u32 PU : 2;                              // DWORD 14
         u32 SI : 1;                              // DWORD 14
         u32 rsvd4 : 2;                           // DWORD 14
         u32 FSeq : 1;                            // DWORD 14
         u32 ER : 1;                              // DWORD 14
         u32 LS : 1;                              // DWORD 14
         u32 DF_CTL : 8;                          // DWORD 14
         u32 Type : 8;                            // DWORD 14
         u32 R_CTL : 8;                           // DWORD 14
         u32 remote_x_id : 16;                    // DWORD 15
         u32 rsvd5 : 4;                           // DWORD 15
         u32 rpi_end : 12;                        // DWORD 15
      } SG_PACK FC_WRB_RING_CONTEXT, *PFC_WRB_RING_CONTEXT;

      typedef union _FC_WRB_RING_CONTEXT_UNION {
         FC_WRB_RING_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_WRB_RING_CONTEXT_UNION, *PFC_WRB_RING_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FC_WRB_RING_CONTEXT_UNION, sizeof (FC_WRB_RING_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FC context associated with FCF end points. Tpre processes incoming FCoE frame based
   // on one of the 64 FC_CONTEXT_MW looked up by FCoE CAM.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_CONTEXT {
         union {
            struct { 
               Def_Buffer_Queue_Info dq_info[4];
               u32 ctx_invalid : 1;               // DWORD 8
               u32 vlan_dis : 1;                  // DWORD 8
               u32 ext_hdr : 1;                   // DWORD 8
               u32 target : 1;                    // DWORD 8
               u32 pdid : 5;                      // DWORD 8
               u32 fcf_id : 7;                    // DWORD 8
               u32 src_fcf_mac_hi : 16;           // DWORD 8
               u32 src_fcf_mac_lo;                // DWORD 9
               u32 rsvd0[6];                      // DWORDS 10 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_CONTEXT, *PFC_CONTEXT;

      SG_C_ASSERT(__sizeof__FC_CONTEXT, sizeof (FC_CONTEXT) == 64);

   #else
      typedef struct _FC_CONTEXT {
         Def_Buffer_Queue_Info dq_info[4];
         u32 ctx_invalid : 1;                     // DWORD 8
         u32 vlan_dis : 1;                        // DWORD 8
         u32 ext_hdr : 1;                         // DWORD 8
         u32 target : 1;                          // DWORD 8
         u32 pdid : 5;                            // DWORD 8
         u32 fcf_id : 7;                          // DWORD 8
         u32 src_fcf_mac_hi : 16;                 // DWORD 8
         u32 src_fcf_mac_lo;                      // DWORD 9
         u32 rsvd0[6];                            // DWORDS 10 to 15
      } SG_PACK FC_CONTEXT, *PFC_CONTEXT;

      typedef union _FC_CONTEXT_UNION {
         FC_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_CONTEXT_UNION, *PFC_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FC_CONTEXT_UNION, sizeof (FC_CONTEXT_UNION) == 64);
   #endif


#else
   // FC context associated with FCF end points. Tpre processes incoming FCoE frame based
   // on one of the 64 FC_CONTEXT_MW looked up by FCoE CAM.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_CONTEXT {
         union {
            struct { 
               Def_Buffer_Queue_Info dq_info[4];
               u32 src_fcf_mac_hi : 16;           // DWORD 8
               u32 fcf_id : 7;                    // DWORD 8
               u32 pdid : 5;                      // DWORD 8
               u32 target : 1;                    // DWORD 8
               u32 ext_hdr : 1;                   // DWORD 8
               u32 vlan_dis : 1;                  // DWORD 8
               u32 ctx_invalid : 1;               // DWORD 8
               u32 src_fcf_mac_lo;                // DWORD 9
               u32 rsvd0[6];                      // DWORDS 10 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_CONTEXT, *PFC_CONTEXT;

      SG_C_ASSERT(__sizeof__FC_CONTEXT, sizeof (FC_CONTEXT) == 64);

   #else
      typedef struct _FC_CONTEXT {
         Def_Buffer_Queue_Info dq_info[4];
         u32 src_fcf_mac_hi : 16;                 // DWORD 8
         u32 fcf_id : 7;                          // DWORD 8
         u32 pdid : 5;                            // DWORD 8
         u32 target : 1;                          // DWORD 8
         u32 ext_hdr : 1;                         // DWORD 8
         u32 vlan_dis : 1;                        // DWORD 8
         u32 ctx_invalid : 1;                     // DWORD 8
         u32 src_fcf_mac_lo;                      // DWORD 9
         u32 rsvd0[6];                            // DWORDS 10 to 15
      } SG_PACK FC_CONTEXT, *PFC_CONTEXT;

      typedef union _FC_CONTEXT_UNION {
         FC_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_CONTEXT_UNION, *PFC_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FC_CONTEXT_UNION, sizeof (FC_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RPI/VPI/VFI/FCFI based FC header template address
   #if defined(SG_BMAP_UNION)
      typedef struct _HEADER_TEMPLATE_ADDRESS {
         union {
            struct { 
               u32 header_template_base_addr_hi;  // DWORD 0
               u32 header_template_base_addr_lo;  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK HEADER_TEMPLATE_ADDRESS, *PHEADER_TEMPLATE_ADDRESS;

      SG_C_ASSERT(__sizeof__HEADER_TEMPLATE_ADDRESS, sizeof (HEADER_TEMPLATE_ADDRESS) == 8);

   #else
      typedef struct _HEADER_TEMPLATE_ADDRESS {
         u32 header_template_base_addr_hi;        // DWORD 0
         u32 header_template_base_addr_lo;        // DWORD 1
      } SG_PACK HEADER_TEMPLATE_ADDRESS, *PHEADER_TEMPLATE_ADDRESS;

      typedef union _HEADER_TEMPLATE_ADDRESS_UNION {
         HEADER_TEMPLATE_ADDRESS bits;
         u32 dw[2]; // dword union
      } SG_PACK HEADER_TEMPLATE_ADDRESS_UNION, *PHEADER_TEMPLATE_ADDRESS_UNION;

      SG_C_ASSERT(__sizeof__HEADER_TEMPLATE_ADDRESS_UNION, sizeof (HEADER_TEMPLATE_ADDRESS_UNION) == 8);
   #endif


#else
   // RPI/VPI/VFI/FCFI based FC header template address
   #if defined(SG_BMAP_UNION)
      typedef struct _HEADER_TEMPLATE_ADDRESS {
         union {
            struct { 
               u32 header_template_base_addr_hi;  // DWORD 0
               u32 header_template_base_addr_lo;  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK HEADER_TEMPLATE_ADDRESS, *PHEADER_TEMPLATE_ADDRESS;

      SG_C_ASSERT(__sizeof__HEADER_TEMPLATE_ADDRESS, sizeof (HEADER_TEMPLATE_ADDRESS) == 8);

   #else
      typedef struct _HEADER_TEMPLATE_ADDRESS {
         u32 header_template_base_addr_hi;        // DWORD 0
         u32 header_template_base_addr_lo;        // DWORD 1
      } SG_PACK HEADER_TEMPLATE_ADDRESS, *PHEADER_TEMPLATE_ADDRESS;

      typedef union _HEADER_TEMPLATE_ADDRESS_UNION {
         HEADER_TEMPLATE_ADDRESS bits;
         u32 dw[2]; // dword union
      } SG_PACK HEADER_TEMPLATE_ADDRESS_UNION, *PHEADER_TEMPLATE_ADDRESS_UNION;

      SG_C_ASSERT(__sizeof__HEADER_TEMPLATE_ADDRESS_UNION, sizeof (HEADER_TEMPLATE_ADDRESS_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Allocated in context memory for ARM to convey some configuration information to FCoE
   // rxulp
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_CONFIG_INFO {
         union {
            struct { 
               u32 r2t_base_addr;                 // DWORD 0
               u32 def_cam_id_port1 : 6;          // DWORD 1
               u32 def_cam_id_port0 : 6;          // DWORD 1
               u32 rsvd0 : 20;                    // DWORD 1
               u32 ddr_header_template_base_addr; // DWORD 2
               u32 fc_cr_cookie;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_CONFIG_INFO, *PFC_CONFIG_INFO;

      SG_C_ASSERT(__sizeof__FC_CONFIG_INFO, sizeof (FC_CONFIG_INFO) == 16);

   #else
      typedef struct _FC_CONFIG_INFO {
         u32 r2t_base_addr;                       // DWORD 0
         u32 def_cam_id_port1 : 6;                // DWORD 1
         u32 def_cam_id_port0 : 6;                // DWORD 1
         u32 rsvd0 : 20;                          // DWORD 1
         u32 ddr_header_template_base_addr;       // DWORD 2
         u32 fc_cr_cookie;                        // DWORD 3
      } SG_PACK FC_CONFIG_INFO, *PFC_CONFIG_INFO;

      typedef union _FC_CONFIG_INFO_UNION {
         FC_CONFIG_INFO bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_CONFIG_INFO_UNION, *PFC_CONFIG_INFO_UNION;

      SG_C_ASSERT(__sizeof__FC_CONFIG_INFO_UNION, sizeof (FC_CONFIG_INFO_UNION) == 16);
   #endif


#else
   // Allocated in context memory for ARM to convey some configuration information to FCoE
   // rxulp
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_CONFIG_INFO {
         union {
            struct { 
               u32 r2t_base_addr;                 // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 1
               u32 def_cam_id_port0 : 6;          // DWORD 1
               u32 def_cam_id_port1 : 6;          // DWORD 1
               u32 ddr_header_template_base_addr; // DWORD 2
               u32 fc_cr_cookie;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_CONFIG_INFO, *PFC_CONFIG_INFO;

      SG_C_ASSERT(__sizeof__FC_CONFIG_INFO, sizeof (FC_CONFIG_INFO) == 16);

   #else
      typedef struct _FC_CONFIG_INFO {
         u32 r2t_base_addr;                       // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 1
         u32 def_cam_id_port0 : 6;                // DWORD 1
         u32 def_cam_id_port1 : 6;                // DWORD 1
         u32 ddr_header_template_base_addr;       // DWORD 2
         u32 fc_cr_cookie;                        // DWORD 3
      } SG_PACK FC_CONFIG_INFO, *PFC_CONFIG_INFO;

      typedef union _FC_CONFIG_INFO_UNION {
         FC_CONFIG_INFO bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_CONFIG_INFO_UNION, *PFC_CONFIG_INFO_UNION;

      SG_C_ASSERT(__sizeof__FC_CONFIG_INFO_UNION, sizeof (FC_CONFIG_INFO_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FCoE Receive Queue (RQ) Context
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_DEFAULT_PDU_CONTEXT {
         union {
            struct { 
               u32 rsvd1 : 8;                     // DWORD 0
               u32 ring_state : 4;                // DWORD 0
               u32 ring_size : 4;                 // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 dbuf_cindex : 13;              // DWORD 0
               u32 rx_pdid_valid : 1;             // DWORD 1
               u32 rx_pdid : 9;                   // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 rsvd2 : 1;                     // DWORD 1
               u32 dbuf_pindex : 13;              // DWORD 1
               u32 rsvd3 : 5;                     // DWORD 2
               u32 rx_pdid_not_valid : 1;         // DWORD 2
               u32 cq_id_recv : 10;               // DWORD 2
               u32 default_buffer_size : 16;      // DWORD 2
               u32 rsvd4[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_DEFAULT_PDU_CONTEXT, *PFCOE_DEFAULT_PDU_CONTEXT;

      SG_C_ASSERT(__sizeof__FCOE_DEFAULT_PDU_CONTEXT, sizeof (FCOE_DEFAULT_PDU_CONTEXT) == 16);

   #else
      typedef struct _FCOE_DEFAULT_PDU_CONTEXT {
         u32 rsvd1 : 8;                           // DWORD 0
         u32 ring_state : 4;                      // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 dbuf_cindex : 13;                    // DWORD 0
         u32 rx_pdid_valid : 1;                   // DWORD 1
         u32 rx_pdid : 9;                         // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 rsvd2 : 1;                           // DWORD 1
         u32 dbuf_pindex : 13;                    // DWORD 1
         u32 rsvd3 : 5;                           // DWORD 2
         u32 rx_pdid_not_valid : 1;               // DWORD 2
         u32 cq_id_recv : 10;                     // DWORD 2
         u32 default_buffer_size : 16;            // DWORD 2
         u32 rsvd4[1];                            // DWORDS 3 to 3
      } SG_PACK FCOE_DEFAULT_PDU_CONTEXT, *PFCOE_DEFAULT_PDU_CONTEXT;

      typedef union _FCOE_DEFAULT_PDU_CONTEXT_UNION {
         FCOE_DEFAULT_PDU_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK FCOE_DEFAULT_PDU_CONTEXT_UNION, *PFCOE_DEFAULT_PDU_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FCOE_DEFAULT_PDU_CONTEXT_UNION, sizeof (FCOE_DEFAULT_PDU_CONTEXT_UNION) == 16);
   #endif


#else
   // FCoE Receive Queue (RQ) Context
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_DEFAULT_PDU_CONTEXT {
         union {
            struct { 
               u32 dbuf_cindex : 13;              // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 ring_size : 4;                 // DWORD 0
               u32 ring_state : 4;                // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 0
               u32 dbuf_pindex : 13;              // DWORD 1
               u32 rsvd2 : 1;                     // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 rx_pdid : 9;                   // DWORD 1
               u32 rx_pdid_valid : 1;             // DWORD 1
               u32 default_buffer_size : 16;      // DWORD 2
               u32 cq_id_recv : 10;               // DWORD 2
               u32 rx_pdid_not_valid : 1;         // DWORD 2
               u32 rsvd3 : 5;                     // DWORD 2
               u32 rsvd4[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_DEFAULT_PDU_CONTEXT, *PFCOE_DEFAULT_PDU_CONTEXT;

      SG_C_ASSERT(__sizeof__FCOE_DEFAULT_PDU_CONTEXT, sizeof (FCOE_DEFAULT_PDU_CONTEXT) == 16);

   #else
      typedef struct _FCOE_DEFAULT_PDU_CONTEXT {
         u32 dbuf_cindex : 13;                    // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 ring_state : 4;                      // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 0
         u32 dbuf_pindex : 13;                    // DWORD 1
         u32 rsvd2 : 1;                           // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 rx_pdid : 9;                         // DWORD 1
         u32 rx_pdid_valid : 1;                   // DWORD 1
         u32 default_buffer_size : 16;            // DWORD 2
         u32 cq_id_recv : 10;                     // DWORD 2
         u32 rx_pdid_not_valid : 1;               // DWORD 2
         u32 rsvd3 : 5;                           // DWORD 2
         u32 rsvd4[1];                            // DWORDS 3 to 3
      } SG_PACK FCOE_DEFAULT_PDU_CONTEXT, *PFCOE_DEFAULT_PDU_CONTEXT;

      typedef union _FCOE_DEFAULT_PDU_CONTEXT_UNION {
         FCOE_DEFAULT_PDU_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK FCOE_DEFAULT_PDU_CONTEXT_UNION, *PFCOE_DEFAULT_PDU_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FCOE_DEFAULT_PDU_CONTEXT_UNION, sizeof (FCOE_DEFAULT_PDU_CONTEXT_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Per-domain IOPS/bytes counters maintained by FC TXULP for enforcing quality of
   // service. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_QOS_COUNTERS {
         union {
            struct { 
               u32 byte_count : 19;               // DWORD 0
               u32 iops_count : 13;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FC_QOS_COUNTERS, *PFC_QOS_COUNTERS;

      SG_C_ASSERT(__sizeof__FC_QOS_COUNTERS, sizeof (FC_QOS_COUNTERS) == 4);

   #else
      typedef struct _FC_QOS_COUNTERS {
         u32 byte_count : 19;                     // DWORD 0
         u32 iops_count : 13;                     // DWORD 0
      } SG_PACK FC_QOS_COUNTERS, *PFC_QOS_COUNTERS;

      typedef union _FC_QOS_COUNTERS_UNION {
         FC_QOS_COUNTERS bits;
         u32 dw; // dword union
      } SG_PACK FC_QOS_COUNTERS_UNION, *PFC_QOS_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__FC_QOS_COUNTERS_UNION, sizeof (FC_QOS_COUNTERS_UNION) == 4);
   #endif


#else
   // Per-domain IOPS/bytes counters maintained by FC TXULP for enforcing quality of
   // service. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_QOS_COUNTERS {
         union {
            struct { 
               u32 iops_count : 13;               // DWORD 0
               u32 byte_count : 19;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FC_QOS_COUNTERS, *PFC_QOS_COUNTERS;

      SG_C_ASSERT(__sizeof__FC_QOS_COUNTERS, sizeof (FC_QOS_COUNTERS) == 4);

   #else
      typedef struct _FC_QOS_COUNTERS {
         u32 iops_count : 13;                     // DWORD 0
         u32 byte_count : 19;                     // DWORD 0
      } SG_PACK FC_QOS_COUNTERS, *PFC_QOS_COUNTERS;

      typedef union _FC_QOS_COUNTERS_UNION {
         FC_QOS_COUNTERS bits;
         u32 dw; // dword union
      } SG_PACK FC_QOS_COUNTERS_UNION, *PFC_QOS_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__FC_QOS_COUNTERS_UNION, sizeof (FC_QOS_COUNTERS_UNION) == 4);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __fc_device_context_bmap_h__

