/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fw_exp_bmap_h__
#define __fw_exp_bmap_h__
#include "setypes.h"
#include "tpost_exp_bmap.h"
#include "tpre_exp_bmap.h"
#include "fcoetx_exp_bmap.h"
#include "fcoerx_exp_bmap.h"
#include "toetx_exp_bmap.h"
#include "toerx_exp_bmap.h"
#include "daltx_exp_bmap.h"
#include "dalrx_exp_bmap.h"
#include "be2_config_sg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // These parameters are used in the tcp receive offload engine. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_PARAMETERS {
         union {
            struct { 
               u32 num_holes_supported : 2;       // DWORD 0
               u32 persist_thresh : 6;            // DWORD 0
               u32 fin_wait2_ticks : 8;           // DWORD 0
               u32 push_timer_ticks : 8;          // DWORD 0
               u32 delayed_ack_ticks : 8;         // DWORD 0
               u32 idle_ticks : 8;                // DWORD 1
               u32 sws_prevention_ticks : 8;      // DWORD 1
               u32 dup_ack_threshold : 4;         // DWORD 1
               u32 max_warning_count : 4;         // DWORD 1
               u32 max_rxmt_count : 4;            // DWORD 1
               u32 ack_frequency : 4;             // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TCP_PARAMETERS, *PTCP_PARAMETERS;

      SG_C_ASSERT(__sizeof__TCP_PARAMETERS, sizeof (TCP_PARAMETERS) == 8);

   #else
      typedef struct _TCP_PARAMETERS {
         u32 num_holes_supported : 2;             // DWORD 0
         u32 persist_thresh : 6;                  // DWORD 0
         u32 fin_wait2_ticks : 8;                 // DWORD 0
         u32 push_timer_ticks : 8;                // DWORD 0
         u32 delayed_ack_ticks : 8;               // DWORD 0
         u32 idle_ticks : 8;                      // DWORD 1
         u32 sws_prevention_ticks : 8;            // DWORD 1
         u32 dup_ack_threshold : 4;               // DWORD 1
         u32 max_warning_count : 4;               // DWORD 1
         u32 max_rxmt_count : 4;                  // DWORD 1
         u32 ack_frequency : 4;                   // DWORD 1
      } SG_PACK TCP_PARAMETERS, *PTCP_PARAMETERS;

      typedef union _TCP_PARAMETERS_UNION {
         TCP_PARAMETERS bits;
         u32 dw[2]; // dword union
      } SG_PACK TCP_PARAMETERS_UNION, *PTCP_PARAMETERS_UNION;

      SG_C_ASSERT(__sizeof__TCP_PARAMETERS_UNION, sizeof (TCP_PARAMETERS_UNION) == 8);
   #endif


#else
   // These parameters are used in the tcp receive offload engine. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_PARAMETERS {
         union {
            struct { 
               u32 delayed_ack_ticks : 8;         // DWORD 0
               u32 push_timer_ticks : 8;          // DWORD 0
               u32 fin_wait2_ticks : 8;           // DWORD 0
               u32 persist_thresh : 6;            // DWORD 0
               u32 num_holes_supported : 2;       // DWORD 0
               u32 ack_frequency : 4;             // DWORD 1
               u32 max_rxmt_count : 4;            // DWORD 1
               u32 max_warning_count : 4;         // DWORD 1
               u32 dup_ack_threshold : 4;         // DWORD 1
               u32 sws_prevention_ticks : 8;      // DWORD 1
               u32 idle_ticks : 8;                // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TCP_PARAMETERS, *PTCP_PARAMETERS;

      SG_C_ASSERT(__sizeof__TCP_PARAMETERS, sizeof (TCP_PARAMETERS) == 8);

   #else
      typedef struct _TCP_PARAMETERS {
         u32 delayed_ack_ticks : 8;               // DWORD 0
         u32 push_timer_ticks : 8;                // DWORD 0
         u32 fin_wait2_ticks : 8;                 // DWORD 0
         u32 persist_thresh : 6;                  // DWORD 0
         u32 num_holes_supported : 2;             // DWORD 0
         u32 ack_frequency : 4;                   // DWORD 1
         u32 max_rxmt_count : 4;                  // DWORD 1
         u32 max_warning_count : 4;               // DWORD 1
         u32 dup_ack_threshold : 4;               // DWORD 1
         u32 sws_prevention_ticks : 8;            // DWORD 1
         u32 idle_ticks : 8;                      // DWORD 1
      } SG_PACK TCP_PARAMETERS, *PTCP_PARAMETERS;

      typedef union _TCP_PARAMETERS_UNION {
         TCP_PARAMETERS bits;
         u32 dw[2]; // dword union
      } SG_PACK TCP_PARAMETERS_UNION, *PTCP_PARAMETERS_UNION;

      SG_C_ASSERT(__sizeof__TCP_PARAMETERS_UNION, sizeof (TCP_PARAMETERS_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_UPDATE_DATA {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 reset_rt : 1;                  // DWORD 0
               u32 reset_cwnd : 1;                // DWORD 0
               u32 t_maxseg : 14;                 // DWORD 0
               u32 max_rt : 6;                    // DWORD 1
               u32 ka_probe_max : 4;              // DWORD 1
               u32 ka_timeout : 13;               // DWORD 1
               u32 ka_interval : 8;               // DWORD 1
               u32 restart_ka : 1;                // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TCP_UPDATE_DATA, *PTCP_UPDATE_DATA;

      SG_C_ASSERT(__sizeof__TCP_UPDATE_DATA, sizeof (TCP_UPDATE_DATA) == 8);

   #else
      typedef struct _TCP_UPDATE_DATA {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 reset_rt : 1;                        // DWORD 0
         u32 reset_cwnd : 1;                      // DWORD 0
         u32 t_maxseg : 14;                       // DWORD 0
         u32 max_rt : 6;                          // DWORD 1
         u32 ka_probe_max : 4;                    // DWORD 1
         u32 ka_timeout : 13;                     // DWORD 1
         u32 ka_interval : 8;                     // DWORD 1
         u32 restart_ka : 1;                      // DWORD 1
      } SG_PACK TCP_UPDATE_DATA, *PTCP_UPDATE_DATA;

      typedef union _TCP_UPDATE_DATA_UNION {
         TCP_UPDATE_DATA bits;
         u32 dw[2]; // dword union
      } SG_PACK TCP_UPDATE_DATA_UNION, *PTCP_UPDATE_DATA_UNION;

      SG_C_ASSERT(__sizeof__TCP_UPDATE_DATA_UNION, sizeof (TCP_UPDATE_DATA_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_UPDATE_DATA {
         union {
            struct { 
               u32 t_maxseg : 14;                 // DWORD 0
               u32 reset_cwnd : 1;                // DWORD 0
               u32 reset_rt : 1;                  // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 restart_ka : 1;                // DWORD 1
               u32 ka_interval : 8;               // DWORD 1
               u32 ka_timeout : 13;               // DWORD 1
               u32 ka_probe_max : 4;              // DWORD 1
               u32 max_rt : 6;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TCP_UPDATE_DATA, *PTCP_UPDATE_DATA;

      SG_C_ASSERT(__sizeof__TCP_UPDATE_DATA, sizeof (TCP_UPDATE_DATA) == 8);

   #else
      typedef struct _TCP_UPDATE_DATA {
         u32 t_maxseg : 14;                       // DWORD 0
         u32 reset_cwnd : 1;                      // DWORD 0
         u32 reset_rt : 1;                        // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 restart_ka : 1;                      // DWORD 1
         u32 ka_interval : 8;                     // DWORD 1
         u32 ka_timeout : 13;                     // DWORD 1
         u32 ka_probe_max : 4;                    // DWORD 1
         u32 max_rt : 6;                          // DWORD 1
      } SG_PACK TCP_UPDATE_DATA, *PTCP_UPDATE_DATA;

      typedef union _TCP_UPDATE_DATA_UNION {
         TCP_UPDATE_DATA bits;
         u32 dw[2]; // dword union
      } SG_PACK TCP_UPDATE_DATA_UNION, *PTCP_UPDATE_DATA_UNION;

      SG_C_ASSERT(__sizeof__TCP_UPDATE_DATA_UNION, sizeof (TCP_UPDATE_DATA_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_WINDOW_SHRINK_DATA {
         union {
            struct { 
               u32 window_shrink_start_seq;       // DWORD 0
               u32 window_shrink_bytes;           // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TCP_WINDOW_SHRINK_DATA, *PTCP_WINDOW_SHRINK_DATA;

      SG_C_ASSERT(__sizeof__TCP_WINDOW_SHRINK_DATA, sizeof (TCP_WINDOW_SHRINK_DATA) == 8);

   #else
      typedef struct _TCP_WINDOW_SHRINK_DATA {
         u32 window_shrink_start_seq;             // DWORD 0
         u32 window_shrink_bytes;                 // DWORD 1
      } SG_PACK TCP_WINDOW_SHRINK_DATA, *PTCP_WINDOW_SHRINK_DATA;

      typedef union _TCP_WINDOW_SHRINK_DATA_UNION {
         TCP_WINDOW_SHRINK_DATA bits;
         u32 dw[2]; // dword union
      } SG_PACK TCP_WINDOW_SHRINK_DATA_UNION, *PTCP_WINDOW_SHRINK_DATA_UNION;

      SG_C_ASSERT(__sizeof__TCP_WINDOW_SHRINK_DATA_UNION, sizeof (TCP_WINDOW_SHRINK_DATA_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_WINDOW_SHRINK_DATA {
         union {
            struct { 
               u32 window_shrink_start_seq;       // DWORD 0
               u32 window_shrink_bytes;           // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TCP_WINDOW_SHRINK_DATA, *PTCP_WINDOW_SHRINK_DATA;

      SG_C_ASSERT(__sizeof__TCP_WINDOW_SHRINK_DATA, sizeof (TCP_WINDOW_SHRINK_DATA) == 8);

   #else
      typedef struct _TCP_WINDOW_SHRINK_DATA {
         u32 window_shrink_start_seq;             // DWORD 0
         u32 window_shrink_bytes;                 // DWORD 1
      } SG_PACK TCP_WINDOW_SHRINK_DATA, *PTCP_WINDOW_SHRINK_DATA;

      typedef union _TCP_WINDOW_SHRINK_DATA_UNION {
         TCP_WINDOW_SHRINK_DATA bits;
         u32 dw[2]; // dword union
      } SG_PACK TCP_WINDOW_SHRINK_DATA_UNION, *PTCP_WINDOW_SHRINK_DATA_UNION;

      SG_C_ASSERT(__sizeof__TCP_WINDOW_SHRINK_DATA_UNION, sizeof (TCP_WINDOW_SHRINK_DATA_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _OUTER_VLAN_INFO {
         union {
            struct { 
               u32 outer_vlan_tag0 : 16;          // DWORD 0
               u32 outer_vlan_tag1 : 16;          // DWORD 0
               u32 outer_vlan_tag2 : 16;          // DWORD 1
               u32 outer_vlan_tag3 : 16;          // DWORD 1
               u32 outer_vlan_tag4 : 16;          // DWORD 2
               u32 outer_vlan_tag5 : 16;          // DWORD 2
               u32 outer_vlan_tag6 : 16;          // DWORD 3
               u32 outer_vlan_tag7 : 16;          // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK OUTER_VLAN_INFO, *POUTER_VLAN_INFO;

      SG_C_ASSERT(__sizeof__OUTER_VLAN_INFO, sizeof (OUTER_VLAN_INFO) == 16);

   #else
      typedef struct _OUTER_VLAN_INFO {
         u32 outer_vlan_tag0 : 16;                // DWORD 0
         u32 outer_vlan_tag1 : 16;                // DWORD 0
         u32 outer_vlan_tag2 : 16;                // DWORD 1
         u32 outer_vlan_tag3 : 16;                // DWORD 1
         u32 outer_vlan_tag4 : 16;                // DWORD 2
         u32 outer_vlan_tag5 : 16;                // DWORD 2
         u32 outer_vlan_tag6 : 16;                // DWORD 3
         u32 outer_vlan_tag7 : 16;                // DWORD 3
      } SG_PACK OUTER_VLAN_INFO, *POUTER_VLAN_INFO;

      typedef union _OUTER_VLAN_INFO_UNION {
         OUTER_VLAN_INFO bits;
         u32 dw[4]; // dword union
      } SG_PACK OUTER_VLAN_INFO_UNION, *POUTER_VLAN_INFO_UNION;

      SG_C_ASSERT(__sizeof__OUTER_VLAN_INFO_UNION, sizeof (OUTER_VLAN_INFO_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _OUTER_VLAN_INFO {
         union {
            struct { 
               u32 outer_vlan_tag1 : 16;          // DWORD 0
               u32 outer_vlan_tag0 : 16;          // DWORD 0
               u32 outer_vlan_tag3 : 16;          // DWORD 1
               u32 outer_vlan_tag2 : 16;          // DWORD 1
               u32 outer_vlan_tag5 : 16;          // DWORD 2
               u32 outer_vlan_tag4 : 16;          // DWORD 2
               u32 outer_vlan_tag7 : 16;          // DWORD 3
               u32 outer_vlan_tag6 : 16;          // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK OUTER_VLAN_INFO, *POUTER_VLAN_INFO;

      SG_C_ASSERT(__sizeof__OUTER_VLAN_INFO, sizeof (OUTER_VLAN_INFO) == 16);

   #else
      typedef struct _OUTER_VLAN_INFO {
         u32 outer_vlan_tag1 : 16;                // DWORD 0
         u32 outer_vlan_tag0 : 16;                // DWORD 0
         u32 outer_vlan_tag3 : 16;                // DWORD 1
         u32 outer_vlan_tag2 : 16;                // DWORD 1
         u32 outer_vlan_tag5 : 16;                // DWORD 2
         u32 outer_vlan_tag4 : 16;                // DWORD 2
         u32 outer_vlan_tag7 : 16;                // DWORD 3
         u32 outer_vlan_tag6 : 16;                // DWORD 3
      } SG_PACK OUTER_VLAN_INFO, *POUTER_VLAN_INFO;

      typedef union _OUTER_VLAN_INFO_UNION {
         OUTER_VLAN_INFO bits;
         u32 dw[4]; // dword union
      } SG_PACK OUTER_VLAN_INFO_UNION, *POUTER_VLAN_INFO_UNION;

      SG_C_ASSERT(__sizeof__OUTER_VLAN_INFO_UNION, sizeof (OUTER_VLAN_INFO_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each TXP stat contains a 32 bit frame counter and a 64 bit packet counter 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_SW_STAT {
         union {
            struct { 
               u32 packets;                       // DWORD 0
               u32 lsd;                           // DWORD 1
               u32 msd;                           // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_SW_STAT, *PBE2_TXP_SW_STAT;

      SG_C_ASSERT(__sizeof__BE2_TXP_SW_STAT, sizeof (BE2_TXP_SW_STAT) == 12);

   #else
      typedef struct _BE2_TXP_SW_STAT {
         u32 packets;                             // DWORD 0
         u32 lsd;                                 // DWORD 1
         u32 msd;                                 // DWORD 2
      } SG_PACK BE2_TXP_SW_STAT, *PBE2_TXP_SW_STAT;

      typedef union _BE2_TXP_SW_STAT_UNION {
         BE2_TXP_SW_STAT bits;
         u32 dw[3]; // dword union
      } SG_PACK BE2_TXP_SW_STAT_UNION, *PBE2_TXP_SW_STAT_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_SW_STAT_UNION, sizeof (BE2_TXP_SW_STAT_UNION) == 12);
   #endif


#else
   // Each TXP stat contains a 32 bit frame counter and a 64 bit packet counter 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_SW_STAT {
         union {
            struct { 
               u32 packets;                       // DWORD 0
               u32 lsd;                           // DWORD 1
               u32 msd;                           // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_SW_STAT, *PBE2_TXP_SW_STAT;

      SG_C_ASSERT(__sizeof__BE2_TXP_SW_STAT, sizeof (BE2_TXP_SW_STAT) == 12);

   #else
      typedef struct _BE2_TXP_SW_STAT {
         u32 packets;                             // DWORD 0
         u32 lsd;                                 // DWORD 1
         u32 msd;                                 // DWORD 2
      } SG_PACK BE2_TXP_SW_STAT, *PBE2_TXP_SW_STAT;

      typedef union _BE2_TXP_SW_STAT_UNION {
         BE2_TXP_SW_STAT bits;
         u32 dw[3]; // dword union
      } SG_PACK BE2_TXP_SW_STAT_UNION, *PBE2_TXP_SW_STAT_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_SW_STAT_UNION, sizeof (BE2_TXP_SW_STAT_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_SW_COUNTERS {
         union {
            struct { 
               BE2_TXP_SW_STAT ct1pt0_xmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct1pt0_xmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct1pt0_rexmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct1pt0_rexmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct1pt1_xmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct1pt1_xmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct1pt1_rexmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct1pt1_rexmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct2pt0_xmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct2pt0_xmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct2pt0_rexmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct2pt0_rexmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct2pt1_xmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct2pt1_xmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct2pt1_rexmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct2pt1_rexmt_ipv6_ctrs;
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_SW_COUNTERS, *PBE2_TXP_SW_COUNTERS;

      SG_C_ASSERT(__sizeof__BE2_TXP_SW_COUNTERS, sizeof (BE2_TXP_SW_COUNTERS) == 192);

   #else
      typedef struct _BE2_TXP_SW_COUNTERS {
         BE2_TXP_SW_STAT ct1pt0_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct1pt0_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct1pt0_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct1pt0_rexmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct1pt1_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct1pt1_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct1pt1_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct1pt1_rexmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct2pt0_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct2pt0_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct2pt0_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct2pt0_rexmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct2pt1_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct2pt1_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct2pt1_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct2pt1_rexmt_ipv6_ctrs;
      } SG_PACK BE2_TXP_SW_COUNTERS, *PBE2_TXP_SW_COUNTERS;

      typedef union _BE2_TXP_SW_COUNTERS_UNION {
         BE2_TXP_SW_COUNTERS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP_SW_COUNTERS_UNION, *PBE2_TXP_SW_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_SW_COUNTERS_UNION, sizeof (BE2_TXP_SW_COUNTERS_UNION) == 192);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_SW_COUNTERS {
         union {
            struct { 
               BE2_TXP_SW_STAT ct1pt0_xmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct1pt0_xmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct1pt0_rexmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct1pt0_rexmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct1pt1_xmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct1pt1_xmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct1pt1_rexmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct1pt1_rexmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct2pt0_xmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct2pt0_xmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct2pt0_rexmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct2pt0_rexmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct2pt1_xmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct2pt1_xmt_ipv6_ctrs;
               BE2_TXP_SW_STAT ct2pt1_rexmt_ipv4_ctrs;
               BE2_TXP_SW_STAT ct2pt1_rexmt_ipv6_ctrs;
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_SW_COUNTERS, *PBE2_TXP_SW_COUNTERS;

      SG_C_ASSERT(__sizeof__BE2_TXP_SW_COUNTERS, sizeof (BE2_TXP_SW_COUNTERS) == 192);

   #else
      typedef struct _BE2_TXP_SW_COUNTERS {
         BE2_TXP_SW_STAT ct1pt0_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct1pt0_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct1pt0_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct1pt0_rexmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct1pt1_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct1pt1_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct1pt1_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct1pt1_rexmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct2pt0_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct2pt0_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct2pt0_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct2pt0_rexmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct2pt1_xmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct2pt1_xmt_ipv6_ctrs;
         BE2_TXP_SW_STAT ct2pt1_rexmt_ipv4_ctrs;
         BE2_TXP_SW_STAT ct2pt1_rexmt_ipv6_ctrs;
      } SG_PACK BE2_TXP_SW_COUNTERS, *PBE2_TXP_SW_COUNTERS;

      typedef union _BE2_TXP_SW_COUNTERS_UNION {
         BE2_TXP_SW_COUNTERS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP_SW_COUNTERS_UNION, *PBE2_TXP_SW_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_SW_COUNTERS_UNION, sizeof (BE2_TXP_SW_COUNTERS_UNION) == 192);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP counter map for 8 function config 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP2_SW_COUNTERS {
         union {
            struct { 
               BE2_TXP_SW_STAT func0_xmt_ctrs;
               BE2_TXP_SW_STAT func0_rexmt_ctrs;
               BE2_TXP_SW_STAT func1_xmt_ctrs;
               BE2_TXP_SW_STAT func1_rexmt_ctrs;
               BE2_TXP_SW_STAT func2_xmt_ctrs;
               BE2_TXP_SW_STAT func2_rexmt_ctrs;
               BE2_TXP_SW_STAT func3_xmt_ctrs;
               BE2_TXP_SW_STAT func3_rexmt_ctrs;
               BE2_TXP_SW_STAT func4_xmt_ctrs;
               BE2_TXP_SW_STAT func4_rexmt_ctrs;
               BE2_TXP_SW_STAT func5_xmt_ctrs;
               BE2_TXP_SW_STAT func5_rexmt_ctrs;
               BE2_TXP_SW_STAT func6_xmt_ctrs;
               BE2_TXP_SW_STAT func6_rexmt_ctrs;
               BE2_TXP_SW_STAT func7_xmt_ctrs;
               BE2_TXP_SW_STAT func7_rexmt_ctrs;
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP2_SW_COUNTERS, *PBE2_TXP2_SW_COUNTERS;

      SG_C_ASSERT(__sizeof__BE2_TXP2_SW_COUNTERS, sizeof (BE2_TXP2_SW_COUNTERS) == 192);

   #else
      typedef struct _BE2_TXP2_SW_COUNTERS {
         BE2_TXP_SW_STAT func0_xmt_ctrs;
         BE2_TXP_SW_STAT func0_rexmt_ctrs;
         BE2_TXP_SW_STAT func1_xmt_ctrs;
         BE2_TXP_SW_STAT func1_rexmt_ctrs;
         BE2_TXP_SW_STAT func2_xmt_ctrs;
         BE2_TXP_SW_STAT func2_rexmt_ctrs;
         BE2_TXP_SW_STAT func3_xmt_ctrs;
         BE2_TXP_SW_STAT func3_rexmt_ctrs;
         BE2_TXP_SW_STAT func4_xmt_ctrs;
         BE2_TXP_SW_STAT func4_rexmt_ctrs;
         BE2_TXP_SW_STAT func5_xmt_ctrs;
         BE2_TXP_SW_STAT func5_rexmt_ctrs;
         BE2_TXP_SW_STAT func6_xmt_ctrs;
         BE2_TXP_SW_STAT func6_rexmt_ctrs;
         BE2_TXP_SW_STAT func7_xmt_ctrs;
         BE2_TXP_SW_STAT func7_rexmt_ctrs;
      } SG_PACK BE2_TXP2_SW_COUNTERS, *PBE2_TXP2_SW_COUNTERS;

      typedef union _BE2_TXP2_SW_COUNTERS_UNION {
         BE2_TXP2_SW_COUNTERS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP2_SW_COUNTERS_UNION, *PBE2_TXP2_SW_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP2_SW_COUNTERS_UNION, sizeof (BE2_TXP2_SW_COUNTERS_UNION) == 192);
   #endif


#else
   // TXP counter map for 8 function config 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP2_SW_COUNTERS {
         union {
            struct { 
               BE2_TXP_SW_STAT func0_xmt_ctrs;
               BE2_TXP_SW_STAT func0_rexmt_ctrs;
               BE2_TXP_SW_STAT func1_xmt_ctrs;
               BE2_TXP_SW_STAT func1_rexmt_ctrs;
               BE2_TXP_SW_STAT func2_xmt_ctrs;
               BE2_TXP_SW_STAT func2_rexmt_ctrs;
               BE2_TXP_SW_STAT func3_xmt_ctrs;
               BE2_TXP_SW_STAT func3_rexmt_ctrs;
               BE2_TXP_SW_STAT func4_xmt_ctrs;
               BE2_TXP_SW_STAT func4_rexmt_ctrs;
               BE2_TXP_SW_STAT func5_xmt_ctrs;
               BE2_TXP_SW_STAT func5_rexmt_ctrs;
               BE2_TXP_SW_STAT func6_xmt_ctrs;
               BE2_TXP_SW_STAT func6_rexmt_ctrs;
               BE2_TXP_SW_STAT func7_xmt_ctrs;
               BE2_TXP_SW_STAT func7_rexmt_ctrs;
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP2_SW_COUNTERS, *PBE2_TXP2_SW_COUNTERS;

      SG_C_ASSERT(__sizeof__BE2_TXP2_SW_COUNTERS, sizeof (BE2_TXP2_SW_COUNTERS) == 192);

   #else
      typedef struct _BE2_TXP2_SW_COUNTERS {
         BE2_TXP_SW_STAT func0_xmt_ctrs;
         BE2_TXP_SW_STAT func0_rexmt_ctrs;
         BE2_TXP_SW_STAT func1_xmt_ctrs;
         BE2_TXP_SW_STAT func1_rexmt_ctrs;
         BE2_TXP_SW_STAT func2_xmt_ctrs;
         BE2_TXP_SW_STAT func2_rexmt_ctrs;
         BE2_TXP_SW_STAT func3_xmt_ctrs;
         BE2_TXP_SW_STAT func3_rexmt_ctrs;
         BE2_TXP_SW_STAT func4_xmt_ctrs;
         BE2_TXP_SW_STAT func4_rexmt_ctrs;
         BE2_TXP_SW_STAT func5_xmt_ctrs;
         BE2_TXP_SW_STAT func5_rexmt_ctrs;
         BE2_TXP_SW_STAT func6_xmt_ctrs;
         BE2_TXP_SW_STAT func6_rexmt_ctrs;
         BE2_TXP_SW_STAT func7_xmt_ctrs;
         BE2_TXP_SW_STAT func7_rexmt_ctrs;
      } SG_PACK BE2_TXP2_SW_COUNTERS, *PBE2_TXP2_SW_COUNTERS;

      typedef union _BE2_TXP2_SW_COUNTERS_UNION {
         BE2_TXP2_SW_COUNTERS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP2_SW_COUNTERS_UNION, *PBE2_TXP2_SW_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP2_SW_COUNTERS_UNION, sizeof (BE2_TXP2_SW_COUNTERS_UNION) == 192);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP counter map for 8 function QPGE config 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP3_SW_COUNTERS {
         union {
            struct { 
               BE2_TXP_SW_STAT func0_ipv4_ctrs;
               BE2_TXP_SW_STAT func0_ipv6_ctrs;
               BE2_TXP_SW_STAT func1_ipv4_ctrs;
               BE2_TXP_SW_STAT func1_ipv6_ctrs;
               BE2_TXP_SW_STAT func2_ipv4_ctrs;
               BE2_TXP_SW_STAT func2_ipv6_ctrs;
               BE2_TXP_SW_STAT func3_ipv4_ctrs;
               BE2_TXP_SW_STAT func3_ipv6_ctrs;
               BE2_TXP_SW_STAT func4_ipv4_ctrs;
               BE2_TXP_SW_STAT func4_ipv6_ctrs;
               BE2_TXP_SW_STAT func5_ipv4_ctrs;
               BE2_TXP_SW_STAT func5_ipv6_ctrs;
               BE2_TXP_SW_STAT func6_ipv4_ctrs;
               BE2_TXP_SW_STAT func6_ipv6_ctrs;
               BE2_TXP_SW_STAT func7_ipv4_ctrs;
               BE2_TXP_SW_STAT func7_ipv6_ctrs;
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP3_SW_COUNTERS, *PBE2_TXP3_SW_COUNTERS;

      SG_C_ASSERT(__sizeof__BE2_TXP3_SW_COUNTERS, sizeof (BE2_TXP3_SW_COUNTERS) == 192);

   #else
      typedef struct _BE2_TXP3_SW_COUNTERS {
         BE2_TXP_SW_STAT func0_ipv4_ctrs;
         BE2_TXP_SW_STAT func0_ipv6_ctrs;
         BE2_TXP_SW_STAT func1_ipv4_ctrs;
         BE2_TXP_SW_STAT func1_ipv6_ctrs;
         BE2_TXP_SW_STAT func2_ipv4_ctrs;
         BE2_TXP_SW_STAT func2_ipv6_ctrs;
         BE2_TXP_SW_STAT func3_ipv4_ctrs;
         BE2_TXP_SW_STAT func3_ipv6_ctrs;
         BE2_TXP_SW_STAT func4_ipv4_ctrs;
         BE2_TXP_SW_STAT func4_ipv6_ctrs;
         BE2_TXP_SW_STAT func5_ipv4_ctrs;
         BE2_TXP_SW_STAT func5_ipv6_ctrs;
         BE2_TXP_SW_STAT func6_ipv4_ctrs;
         BE2_TXP_SW_STAT func6_ipv6_ctrs;
         BE2_TXP_SW_STAT func7_ipv4_ctrs;
         BE2_TXP_SW_STAT func7_ipv6_ctrs;
      } SG_PACK BE2_TXP3_SW_COUNTERS, *PBE2_TXP3_SW_COUNTERS;

      typedef union _BE2_TXP3_SW_COUNTERS_UNION {
         BE2_TXP3_SW_COUNTERS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP3_SW_COUNTERS_UNION, *PBE2_TXP3_SW_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP3_SW_COUNTERS_UNION, sizeof (BE2_TXP3_SW_COUNTERS_UNION) == 192);
   #endif


#else
   // TXP counter map for 8 function QPGE config 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP3_SW_COUNTERS {
         union {
            struct { 
               BE2_TXP_SW_STAT func0_ipv4_ctrs;
               BE2_TXP_SW_STAT func0_ipv6_ctrs;
               BE2_TXP_SW_STAT func1_ipv4_ctrs;
               BE2_TXP_SW_STAT func1_ipv6_ctrs;
               BE2_TXP_SW_STAT func2_ipv4_ctrs;
               BE2_TXP_SW_STAT func2_ipv6_ctrs;
               BE2_TXP_SW_STAT func3_ipv4_ctrs;
               BE2_TXP_SW_STAT func3_ipv6_ctrs;
               BE2_TXP_SW_STAT func4_ipv4_ctrs;
               BE2_TXP_SW_STAT func4_ipv6_ctrs;
               BE2_TXP_SW_STAT func5_ipv4_ctrs;
               BE2_TXP_SW_STAT func5_ipv6_ctrs;
               BE2_TXP_SW_STAT func6_ipv4_ctrs;
               BE2_TXP_SW_STAT func6_ipv6_ctrs;
               BE2_TXP_SW_STAT func7_ipv4_ctrs;
               BE2_TXP_SW_STAT func7_ipv6_ctrs;
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP3_SW_COUNTERS, *PBE2_TXP3_SW_COUNTERS;

      SG_C_ASSERT(__sizeof__BE2_TXP3_SW_COUNTERS, sizeof (BE2_TXP3_SW_COUNTERS) == 192);

   #else
      typedef struct _BE2_TXP3_SW_COUNTERS {
         BE2_TXP_SW_STAT func0_ipv4_ctrs;
         BE2_TXP_SW_STAT func0_ipv6_ctrs;
         BE2_TXP_SW_STAT func1_ipv4_ctrs;
         BE2_TXP_SW_STAT func1_ipv6_ctrs;
         BE2_TXP_SW_STAT func2_ipv4_ctrs;
         BE2_TXP_SW_STAT func2_ipv6_ctrs;
         BE2_TXP_SW_STAT func3_ipv4_ctrs;
         BE2_TXP_SW_STAT func3_ipv6_ctrs;
         BE2_TXP_SW_STAT func4_ipv4_ctrs;
         BE2_TXP_SW_STAT func4_ipv6_ctrs;
         BE2_TXP_SW_STAT func5_ipv4_ctrs;
         BE2_TXP_SW_STAT func5_ipv6_ctrs;
         BE2_TXP_SW_STAT func6_ipv4_ctrs;
         BE2_TXP_SW_STAT func6_ipv6_ctrs;
         BE2_TXP_SW_STAT func7_ipv4_ctrs;
         BE2_TXP_SW_STAT func7_ipv6_ctrs;
      } SG_PACK BE2_TXP3_SW_COUNTERS, *PBE2_TXP3_SW_COUNTERS;

      typedef union _BE2_TXP3_SW_COUNTERS_UNION {
         BE2_TXP3_SW_COUNTERS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP3_SW_COUNTERS_UNION, *PBE2_TXP3_SW_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP3_SW_COUNTERS_UNION, sizeof (BE2_TXP3_SW_COUNTERS_UNION) == 192);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Same as BE2_TXP_SW_COUNTERS but uses arrays. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_PORT_SW_COUNTERS {
         union {
            struct { 
               struct {
                  struct {
                     BE2_TXP_SW_STAT xmt_ipv4_ctrs;
                     BE2_TXP_SW_STAT xmt_ipv6_ctrs;
                     BE2_TXP_SW_STAT rexmt_ipv4_ctrs;
                     BE2_TXP_SW_STAT rexmt_ipv6_ctrs;
                  } port[2];
               } chute[2];
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_PORT_SW_COUNTERS, *PBE2_TXP_PORT_SW_COUNTERS;

      SG_C_ASSERT(__sizeof__BE2_TXP_PORT_SW_COUNTERS, sizeof (BE2_TXP_PORT_SW_COUNTERS) == 192);

   #else
      typedef struct _BE2_TXP_PORT_SW_COUNTERS {
         struct {
            struct {
               BE2_TXP_SW_STAT xmt_ipv4_ctrs;
               BE2_TXP_SW_STAT xmt_ipv6_ctrs;
               BE2_TXP_SW_STAT rexmt_ipv4_ctrs;
               BE2_TXP_SW_STAT rexmt_ipv6_ctrs;
            } port[2];
         } chute[2];
      } SG_PACK BE2_TXP_PORT_SW_COUNTERS, *PBE2_TXP_PORT_SW_COUNTERS;

      typedef union _BE2_TXP_PORT_SW_COUNTERS_UNION {
         BE2_TXP_PORT_SW_COUNTERS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP_PORT_SW_COUNTERS_UNION, *PBE2_TXP_PORT_SW_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_PORT_SW_COUNTERS_UNION, sizeof (BE2_TXP_PORT_SW_COUNTERS_UNION) == 192);
   #endif


#else
   // Same as BE2_TXP_SW_COUNTERS but uses arrays. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_PORT_SW_COUNTERS {
         union {
            struct { 
               struct {
                  struct {
                     BE2_TXP_SW_STAT xmt_ipv4_ctrs;
                     BE2_TXP_SW_STAT xmt_ipv6_ctrs;
                     BE2_TXP_SW_STAT rexmt_ipv4_ctrs;
                     BE2_TXP_SW_STAT rexmt_ipv6_ctrs;
                  } port[2];
               } chute[2];
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_PORT_SW_COUNTERS, *PBE2_TXP_PORT_SW_COUNTERS;

      SG_C_ASSERT(__sizeof__BE2_TXP_PORT_SW_COUNTERS, sizeof (BE2_TXP_PORT_SW_COUNTERS) == 192);

   #else
      typedef struct _BE2_TXP_PORT_SW_COUNTERS {
         struct {
            struct {
               BE2_TXP_SW_STAT xmt_ipv4_ctrs;
               BE2_TXP_SW_STAT xmt_ipv6_ctrs;
               BE2_TXP_SW_STAT rexmt_ipv4_ctrs;
               BE2_TXP_SW_STAT rexmt_ipv6_ctrs;
            } port[2];
         } chute[2];
      } SG_PACK BE2_TXP_PORT_SW_COUNTERS, *PBE2_TXP_PORT_SW_COUNTERS;

      typedef union _BE2_TXP_PORT_SW_COUNTERS_UNION {
         BE2_TXP_PORT_SW_COUNTERS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP_PORT_SW_COUNTERS_UNION, *PBE2_TXP_PORT_SW_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_PORT_SW_COUNTERS_UNION, sizeof (BE2_TXP_PORT_SW_COUNTERS_UNION) == 192);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Same as BE2_TXP2_SW_COUNTERS but uses an array. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_FUNC_SW_COUNTERS {
         union {
            struct { 
               struct {
                  BE2_TXP_SW_STAT xmt_ctrs;
                  BE2_TXP_SW_STAT rexmt_ctrs;
               } func[8];
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_FUNC_SW_COUNTERS, *PBE2_TXP_FUNC_SW_COUNTERS;

      SG_C_ASSERT(__sizeof__BE2_TXP_FUNC_SW_COUNTERS, sizeof (BE2_TXP_FUNC_SW_COUNTERS) == 192);

   #else
      typedef struct _BE2_TXP_FUNC_SW_COUNTERS {
         struct {
            BE2_TXP_SW_STAT xmt_ctrs;
            BE2_TXP_SW_STAT rexmt_ctrs;
         } func[8];
      } SG_PACK BE2_TXP_FUNC_SW_COUNTERS, *PBE2_TXP_FUNC_SW_COUNTERS;

      typedef union _BE2_TXP_FUNC_SW_COUNTERS_UNION {
         BE2_TXP_FUNC_SW_COUNTERS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP_FUNC_SW_COUNTERS_UNION, *PBE2_TXP_FUNC_SW_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_FUNC_SW_COUNTERS_UNION, sizeof (BE2_TXP_FUNC_SW_COUNTERS_UNION) == 192);
   #endif


#else
   // Same as BE2_TXP2_SW_COUNTERS but uses an array. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_FUNC_SW_COUNTERS {
         union {
            struct { 
               struct {
                  BE2_TXP_SW_STAT xmt_ctrs;
                  BE2_TXP_SW_STAT rexmt_ctrs;
               } func[8];
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_FUNC_SW_COUNTERS, *PBE2_TXP_FUNC_SW_COUNTERS;

      SG_C_ASSERT(__sizeof__BE2_TXP_FUNC_SW_COUNTERS, sizeof (BE2_TXP_FUNC_SW_COUNTERS) == 192);

   #else
      typedef struct _BE2_TXP_FUNC_SW_COUNTERS {
         struct {
            BE2_TXP_SW_STAT xmt_ctrs;
            BE2_TXP_SW_STAT rexmt_ctrs;
         } func[8];
      } SG_PACK BE2_TXP_FUNC_SW_COUNTERS, *PBE2_TXP_FUNC_SW_COUNTERS;

      typedef union _BE2_TXP_FUNC_SW_COUNTERS_UNION {
         BE2_TXP_FUNC_SW_COUNTERS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP_FUNC_SW_COUNTERS_UNION, *PBE2_TXP_FUNC_SW_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_FUNC_SW_COUNTERS_UNION, sizeof (BE2_TXP_FUNC_SW_COUNTERS_UNION) == 192);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __fw_exp_bmap_h__

