/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_common_iscsi_discovery_bmap_h__
#define __ioctl_common_iscsi_discovery_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DISCOVERY_PARAMS {
         union {
            struct { 
               MGMT_SLP_PARAMS slp_param;
               MGMT_ISNS_PARAMS isns_param;
            } SG_PACK ; // unnamed struct
            u32 dw[222]; // dword union
         }; // unnamed union
      } SG_PACK DISCOVERY_PARAMS, *PDISCOVERY_PARAMS;

      SG_C_ASSERT(__sizeof__DISCOVERY_PARAMS, sizeof (DISCOVERY_PARAMS) == 888);

   #else
      typedef struct _DISCOVERY_PARAMS {
         MGMT_SLP_PARAMS slp_param;
         MGMT_ISNS_PARAMS isns_param;
      } SG_PACK DISCOVERY_PARAMS, *PDISCOVERY_PARAMS;

      typedef union _DISCOVERY_PARAMS_UNION {
         DISCOVERY_PARAMS bits;
         u32 dw[222]; // dword union
      } SG_PACK DISCOVERY_PARAMS_UNION, *PDISCOVERY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__DISCOVERY_PARAMS_UNION, sizeof (DISCOVERY_PARAMS_UNION) == 888);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DISCOVERY_PARAMS {
         union {
            struct { 
               MGMT_SLP_PARAMS slp_param;
               MGMT_ISNS_PARAMS isns_param;
            } SG_PACK ; // unnamed struct
            u32 dw[222]; // dword union
         }; // unnamed union
      } SG_PACK DISCOVERY_PARAMS, *PDISCOVERY_PARAMS;

      SG_C_ASSERT(__sizeof__DISCOVERY_PARAMS, sizeof (DISCOVERY_PARAMS) == 888);

   #else
      typedef struct _DISCOVERY_PARAMS {
         MGMT_SLP_PARAMS slp_param;
         MGMT_ISNS_PARAMS isns_param;
      } SG_PACK DISCOVERY_PARAMS, *PDISCOVERY_PARAMS;

      typedef union _DISCOVERY_PARAMS_UNION {
         DISCOVERY_PARAMS bits;
         u32 dw[222]; // dword union
      } SG_PACK DISCOVERY_PARAMS_UNION, *PDISCOVERY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__DISCOVERY_PARAMS_UNION, sizeof (DISCOVERY_PARAMS_UNION) == 888);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl will set the initial parameters for SLP and iSNS modes of iSCSI
   // discovery. iSNS servers can be added to the iSNS Table using this Ioctl. Optionally,
   // the iSNS Servers can be located using DHCP. There can be maximum of 4 iSNS Servers
   // in the table.  Originator(s) : Management application  Implemented in: Firmware 
   // Return Values :  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_INVALID_ISNS_ADDRESS 
   typedef struct _IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS {
      IOCTL_HEADER header;
      DISCOVERY_PARAMS discovery_params;
   } SG_PACK IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS, *PIOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS;



#else
   // This Ioctl will set the initial parameters for SLP and iSNS modes of iSCSI
   // discovery. iSNS servers can be added to the iSNS Table using this Ioctl. Optionally,
   // the iSNS Servers can be located using DHCP. There can be maximum of 4 iSNS Servers
   // in the table.  Originator(s) : Management application  Implemented in: Firmware 
   // Return Values :  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_INVALID_ISNS_ADDRESS 
   typedef struct _IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS {
      IOCTL_HEADER header;
      DISCOVERY_PARAMS discovery_params;
   } SG_PACK IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS, *PIOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS;



#endif

typedef IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS IOCTL_ISCSI_COMMON_DISCOVERY_GET_PARAMETERS;


typedef IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS* PIOCTL_ISCSI_COMMON_DISCOVERY_GET_PARAMETERS;


typedef IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS IOCTL_ISCSI_COMMONI_DISCOVERY_SET_PARAMETERS;


typedef IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS* PIOCTL_ISCSI_COMMON_DISCOVERY_SET_PARAMETERS;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_common_iscsi_discovery_bmap_h__

