/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_eth_bmap_h__
#define __ioctl_eth_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "rxf_bmap.h"
#include "fw_exp_bmap.h"
#include "erx_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_PMEM_STATS {
         union {
            struct { 
               u32 eth_red_drops;
               u32 lro_red_drops;
               u32 ulp0_red_drops;
               u32 ulp1_red_drops;
               u32 rsvd0;
               u32 global_red_drops;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK BE2_PMEM_STATS, *PBE2_PMEM_STATS;

      SG_C_ASSERT(__sizeof__BE2_PMEM_STATS, sizeof (BE2_PMEM_STATS) == 24);

   #else
      typedef struct _BE2_PMEM_STATS {
         u32 eth_red_drops;
         u32 lro_red_drops;
         u32 ulp0_red_drops;
         u32 ulp1_red_drops;
         u32 rsvd0;
         u32 global_red_drops;
      } SG_PACK BE2_PMEM_STATS, *PBE2_PMEM_STATS;

      typedef union _BE2_PMEM_STATS_UNION {
         BE2_PMEM_STATS bits;
         u32 dw[6]; // dword union
      } SG_PACK BE2_PMEM_STATS_UNION, *PBE2_PMEM_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_PMEM_STATS_UNION, sizeof (BE2_PMEM_STATS_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_PMEM_STATS {
         union {
            struct { 
               u32 eth_red_drops;
               u32 lro_red_drops;
               u32 ulp0_red_drops;
               u32 ulp1_red_drops;
               u32 rsvd0;
               u32 global_red_drops;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK BE2_PMEM_STATS, *PBE2_PMEM_STATS;

      SG_C_ASSERT(__sizeof__BE2_PMEM_STATS, sizeof (BE2_PMEM_STATS) == 24);

   #else
      typedef struct _BE2_PMEM_STATS {
         u32 eth_red_drops;
         u32 lro_red_drops;
         u32 ulp0_red_drops;
         u32 ulp1_red_drops;
         u32 rsvd0;
         u32 global_red_drops;
      } SG_PACK BE2_PMEM_STATS, *PBE2_PMEM_STATS;

      typedef union _BE2_PMEM_STATS_UNION {
         BE2_PMEM_STATS bits;
         u32 dw[6]; // dword union
      } SG_PACK BE2_PMEM_STATS_UNION, *PBE2_PMEM_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_PMEM_STATS_UNION, sizeof (BE2_PMEM_STATS_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_ETH_STATISTICS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MIB_ETH_STATISTICS_PARAMS_IN, *PMIB_ETH_STATISTICS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_PARAMS_IN, sizeof (MIB_ETH_STATISTICS_PARAMS_IN) == 4);

   #else
      typedef struct _MIB_ETH_STATISTICS_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK MIB_ETH_STATISTICS_PARAMS_IN, *PMIB_ETH_STATISTICS_PARAMS_IN;

      typedef union _MIB_ETH_STATISTICS_PARAMS_IN_UNION {
         MIB_ETH_STATISTICS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK MIB_ETH_STATISTICS_PARAMS_IN_UNION, *PMIB_ETH_STATISTICS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_PARAMS_IN_UNION, sizeof (MIB_ETH_STATISTICS_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_ETH_STATISTICS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MIB_ETH_STATISTICS_PARAMS_IN, *PMIB_ETH_STATISTICS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_PARAMS_IN, sizeof (MIB_ETH_STATISTICS_PARAMS_IN) == 4);

   #else
      typedef struct _MIB_ETH_STATISTICS_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK MIB_ETH_STATISTICS_PARAMS_IN, *PMIB_ETH_STATISTICS_PARAMS_IN;

      typedef union _MIB_ETH_STATISTICS_PARAMS_IN_UNION {
         MIB_ETH_STATISTICS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK MIB_ETH_STATISTICS_PARAMS_IN_UNION, *PMIB_ETH_STATISTICS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_PARAMS_IN_UNION, sizeof (MIB_ETH_STATISTICS_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_HARDWARE_STATS {
         union {
            struct { 
               BE2_RXF_STATS rxf;
               BE2_TXP_SW_COUNTERS txp;
               BE2_ERX_STATS erx;
               BE2_PMEM_STATS pmem;
            } SG_PACK ; // unnamed struct
            u32 dw[265]; // dword union
         }; // unnamed union
      } SG_PACK BE2_HARDWARE_STATS, *PBE2_HARDWARE_STATS;

      SG_C_ASSERT(__sizeof__BE2_HARDWARE_STATS, sizeof (BE2_HARDWARE_STATS) == 1060);

   #else
      typedef struct _BE2_HARDWARE_STATS {
         BE2_RXF_STATS rxf;
         BE2_TXP_SW_COUNTERS txp;
         BE2_ERX_STATS erx;
         BE2_PMEM_STATS pmem;
      } SG_PACK BE2_HARDWARE_STATS, *PBE2_HARDWARE_STATS;

      typedef union _BE2_HARDWARE_STATS_UNION {
         BE2_HARDWARE_STATS bits;
         u32 dw[265]; // dword union
      } SG_PACK BE2_HARDWARE_STATS_UNION, *PBE2_HARDWARE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_HARDWARE_STATS_UNION, sizeof (BE2_HARDWARE_STATS_UNION) == 1060);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_HARDWARE_STATS {
         union {
            struct { 
               BE2_RXF_STATS rxf;
               BE2_TXP_SW_COUNTERS txp;
               BE2_ERX_STATS erx;
               BE2_PMEM_STATS pmem;
            } SG_PACK ; // unnamed struct
            u32 dw[265]; // dword union
         }; // unnamed union
      } SG_PACK BE2_HARDWARE_STATS, *PBE2_HARDWARE_STATS;

      SG_C_ASSERT(__sizeof__BE2_HARDWARE_STATS, sizeof (BE2_HARDWARE_STATS) == 1060);

   #else
      typedef struct _BE2_HARDWARE_STATS {
         BE2_RXF_STATS rxf;
         BE2_TXP_SW_COUNTERS txp;
         BE2_ERX_STATS erx;
         BE2_PMEM_STATS pmem;
      } SG_PACK BE2_HARDWARE_STATS, *PBE2_HARDWARE_STATS;

      typedef union _BE2_HARDWARE_STATS_UNION {
         BE2_HARDWARE_STATS bits;
         u32 dw[265]; // dword union
      } SG_PACK BE2_HARDWARE_STATS_UNION, *PBE2_HARDWARE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_HARDWARE_STATS_UNION, sizeof (BE2_HARDWARE_STATS_UNION) == 1060);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_ETH_STATISTICS_PARAMS {
         union {
            union { 
               MIB_ETH_STATISTICS_PARAMS_IN request;
               BE2_HARDWARE_STATS response;
            } SG_PACK ; // unnamed struct
            u32 dw[265]; // dword union
         }; // unnamed union
      } SG_PACK MIB_ETH_STATISTICS_PARAMS, *PMIB_ETH_STATISTICS_PARAMS;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_PARAMS, sizeof (MIB_ETH_STATISTICS_PARAMS) == 1060);

   #else
      typedef union _MIB_ETH_STATISTICS_PARAMS {
         MIB_ETH_STATISTICS_PARAMS_IN request;
         BE2_HARDWARE_STATS response;
      } SG_PACK MIB_ETH_STATISTICS_PARAMS, *PMIB_ETH_STATISTICS_PARAMS;

      typedef union _MIB_ETH_STATISTICS_PARAMS_UNION {
         MIB_ETH_STATISTICS_PARAMS bits;
         u32 dw[265]; // dword union
      } SG_PACK MIB_ETH_STATISTICS_PARAMS_UNION, *PMIB_ETH_STATISTICS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_PARAMS_UNION, sizeof (MIB_ETH_STATISTICS_PARAMS_UNION) == 1060);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_ETH_STATISTICS_PARAMS {
         union {
            union { 
               MIB_ETH_STATISTICS_PARAMS_IN request;
               BE2_HARDWARE_STATS response;
            } SG_PACK ; // unnamed struct
            u32 dw[265]; // dword union
         }; // unnamed union
      } SG_PACK MIB_ETH_STATISTICS_PARAMS, *PMIB_ETH_STATISTICS_PARAMS;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_PARAMS, sizeof (MIB_ETH_STATISTICS_PARAMS) == 1060);

   #else
      typedef union _MIB_ETH_STATISTICS_PARAMS {
         MIB_ETH_STATISTICS_PARAMS_IN request;
         BE2_HARDWARE_STATS response;
      } SG_PACK MIB_ETH_STATISTICS_PARAMS, *PMIB_ETH_STATISTICS_PARAMS;

      typedef union _MIB_ETH_STATISTICS_PARAMS_UNION {
         MIB_ETH_STATISTICS_PARAMS bits;
         u32 dw[265]; // dword union
      } SG_PACK MIB_ETH_STATISTICS_PARAMS_UNION, *PMIB_ETH_STATISTICS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_PARAMS_UNION, sizeof (MIB_ETH_STATISTICS_PARAMS_UNION) == 1060);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Query ethernet statistics. All domains may issue this IOCTL. The host domain drivers
   // may optionally reset internal statistic counters with a query. 
   typedef struct _IOCTL_ETH_GET_STATISTICS {
      IOCTL_HEADER header;
      MIB_ETH_STATISTICS_PARAMS params;
   } SG_PACK IOCTL_ETH_GET_STATISTICS, *PIOCTL_ETH_GET_STATISTICS;



#else
   // Query ethernet statistics. All domains may issue this IOCTL. The host domain drivers
   // may optionally reset internal statistic counters with a query. 
   typedef struct _IOCTL_ETH_GET_STATISTICS {
      IOCTL_HEADER header;
      MIB_ETH_STATISTICS_PARAMS params;
   } SG_PACK IOCTL_ETH_GET_STATISTICS, *PIOCTL_ETH_GET_STATISTICS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_RSS_CONFIG {
         union {
            struct { 
               UEXACT32 if_id;
               UEXACT16 enable_rss;
               UEXACT16 cpu_table_size_log2;
               UEXACT32 hash[10];
               UEXACT8 cpu_table[128];
               UEXACT8 flush;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[45]; // dword union
         }; // unnamed union
      } SG_PACK BE_RSS_CONFIG, *PBE_RSS_CONFIG;

      SG_C_ASSERT(__sizeof__BE_RSS_CONFIG, sizeof (BE_RSS_CONFIG) == 180);

   #else
      typedef struct _BE_RSS_CONFIG {
         UEXACT32 if_id;
         UEXACT16 enable_rss;
         UEXACT16 cpu_table_size_log2;
         UEXACT32 hash[10];
         UEXACT8 cpu_table[128];
         UEXACT8 flush;
         UEXACT8 rsvd0[3];
      } SG_PACK BE_RSS_CONFIG, *PBE_RSS_CONFIG;

      typedef union _BE_RSS_CONFIG_UNION {
         BE_RSS_CONFIG bits;
         u32 dw[45]; // dword union
      } SG_PACK BE_RSS_CONFIG_UNION, *PBE_RSS_CONFIG_UNION;

      SG_C_ASSERT(__sizeof__BE_RSS_CONFIG_UNION, sizeof (BE_RSS_CONFIG_UNION) == 180);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_RSS_CONFIG {
         union {
            struct { 
               UEXACT32 if_id;
               UEXACT16 enable_rss;
               UEXACT16 cpu_table_size_log2;
               UEXACT32 hash[10];
               UEXACT8 cpu_table[128];
               UEXACT8 flush;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[45]; // dword union
         }; // unnamed union
      } SG_PACK BE_RSS_CONFIG, *PBE_RSS_CONFIG;

      SG_C_ASSERT(__sizeof__BE_RSS_CONFIG, sizeof (BE_RSS_CONFIG) == 180);

   #else
      typedef struct _BE_RSS_CONFIG {
         UEXACT32 if_id;
         UEXACT16 enable_rss;
         UEXACT16 cpu_table_size_log2;
         UEXACT32 hash[10];
         UEXACT8 cpu_table[128];
         UEXACT8 flush;
         UEXACT8 rsvd0[3];
      } SG_PACK BE_RSS_CONFIG, *PBE_RSS_CONFIG;

      typedef union _BE_RSS_CONFIG_UNION {
         BE_RSS_CONFIG bits;
         u32 dw[45]; // dword union
      } SG_PACK BE_RSS_CONFIG_UNION, *PBE_RSS_CONFIG_UNION;

      SG_C_ASSERT(__sizeof__BE_RSS_CONFIG_UNION, sizeof (BE_RSS_CONFIG_UNION) == 180);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Configures or disables receive side scaling (RSS), which distributes ethernet
   // receive completions among (up to 4) completion queues. This is in addition to the
   // default ethernet receive completion queue. Presumably, the host driver processes
   // each completion queue with a DPC running on a different processor. This IOCTL can
   // only be issued by domain 0 network drivers. 
   typedef struct _IOCTL_ETH_RSS_CONFIG {
      IOCTL_HEADER header;
      union {
         BE_RSS_CONFIG request;
         struct {
            UEXACT8 rss_bank;
            UEXACT8 rsvd0[3];
         } response;
      } params;
   } SG_PACK IOCTL_ETH_RSS_CONFIG, *PIOCTL_ETH_RSS_CONFIG;



#else
   // Configures or disables receive side scaling (RSS), which distributes ethernet
   // receive completions among (up to 4) completion queues. This is in addition to the
   // default ethernet receive completion queue. Presumably, the host driver processes
   // each completion queue with a DPC running on a different processor. This IOCTL can
   // only be issued by domain 0 network drivers. 
   typedef struct _IOCTL_ETH_RSS_CONFIG {
      IOCTL_HEADER header;
      union {
         BE_RSS_CONFIG request;
         struct {
            UEXACT8 rss_bank;
            UEXACT8 rsvd0[3];
         } response;
      } params;
   } SG_PACK IOCTL_ETH_RSS_CONFIG, *PIOCTL_ETH_RSS_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_ETH_ACPI_CONFIG_PARAMS {
         union {
            struct { 
               UEXACT8 index;
               UEXACT8 port0;
               UEXACT8 port1;
               UEXACT8 magic_packet;
               UEXACT8 byte_pattern[128];
               UEXACT32 bit_mask[4];
            } SG_PACK ; // unnamed struct
            u32 dw[37]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_ETH_ACPI_CONFIG_PARAMS, *PIOCTL_ETH_ACPI_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_ETH_ACPI_CONFIG_PARAMS, sizeof (IOCTL_ETH_ACPI_CONFIG_PARAMS) == 148);

   #else
      typedef struct _IOCTL_ETH_ACPI_CONFIG_PARAMS {
         UEXACT8 index;
         UEXACT8 port0;
         UEXACT8 port1;
         UEXACT8 magic_packet;
         UEXACT8 byte_pattern[128];
         UEXACT32 bit_mask[4];
      } SG_PACK IOCTL_ETH_ACPI_CONFIG_PARAMS, *PIOCTL_ETH_ACPI_CONFIG_PARAMS;

      typedef union _IOCTL_ETH_ACPI_CONFIG_PARAMS_UNION {
         IOCTL_ETH_ACPI_CONFIG_PARAMS bits;
         u32 dw[37]; // dword union
      } SG_PACK IOCTL_ETH_ACPI_CONFIG_PARAMS_UNION, *PIOCTL_ETH_ACPI_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_ETH_ACPI_CONFIG_PARAMS_UNION, sizeof (IOCTL_ETH_ACPI_CONFIG_PARAMS_UNION) == 148);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_ETH_ACPI_CONFIG_PARAMS {
         union {
            struct { 
               UEXACT8 index;
               UEXACT8 port0;
               UEXACT8 port1;
               UEXACT8 magic_packet;
               UEXACT8 byte_pattern[128];
               UEXACT32 bit_mask[4];
            } SG_PACK ; // unnamed struct
            u32 dw[37]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_ETH_ACPI_CONFIG_PARAMS, *PIOCTL_ETH_ACPI_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_ETH_ACPI_CONFIG_PARAMS, sizeof (IOCTL_ETH_ACPI_CONFIG_PARAMS) == 148);

   #else
      typedef struct _IOCTL_ETH_ACPI_CONFIG_PARAMS {
         UEXACT8 index;
         UEXACT8 port0;
         UEXACT8 port1;
         UEXACT8 magic_packet;
         UEXACT8 byte_pattern[128];
         UEXACT32 bit_mask[4];
      } SG_PACK IOCTL_ETH_ACPI_CONFIG_PARAMS, *PIOCTL_ETH_ACPI_CONFIG_PARAMS;

      typedef union _IOCTL_ETH_ACPI_CONFIG_PARAMS_UNION {
         IOCTL_ETH_ACPI_CONFIG_PARAMS bits;
         u32 dw[37]; // dword union
      } SG_PACK IOCTL_ETH_ACPI_CONFIG_PARAMS_UNION, *PIOCTL_ETH_ACPI_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_ETH_ACPI_CONFIG_PARAMS_UNION, sizeof (IOCTL_ETH_ACPI_CONFIG_PARAMS_UNION) == 148);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Sets the magic packet or interesting packet byte pattern and mask for wake-on-lan.
   // Only host drivers are allowed to modify magic packet settings. Only the host
   // networking driver is allowed to modify the interesting packet byte pattern and mask
   // settings. 
   typedef struct _IOCTL_ETH_ACPI_CONFIG {
      IOCTL_HEADER header;
      union {
         IOCTL_ETH_ACPI_CONFIG_PARAMS request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_ACPI_CONFIG, *PIOCTL_ETH_ACPI_CONFIG;



#else
   // Sets the magic packet or interesting packet byte pattern and mask for wake-on-lan.
   // Only host drivers are allowed to modify magic packet settings. Only the host
   // networking driver is allowed to modify the interesting packet byte pattern and mask
   // settings. 
   typedef struct _IOCTL_ETH_ACPI_CONFIG {
      IOCTL_HEADER header;
      union {
         IOCTL_ETH_ACPI_CONFIG_PARAMS request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_ACPI_CONFIG, *PIOCTL_ETH_ACPI_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_PATTERN {
         union {
            struct { 
               UEXACT8 byte_pattern[128];
               UEXACT32 bit_masks[4];
            } SG_PACK ; // unnamed struct
            u32 dw[36]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_PATTERN, *PACPI_PATTERN;

      SG_C_ASSERT(__sizeof__ACPI_PATTERN, sizeof (ACPI_PATTERN) == 144);

   #else
      typedef struct _ACPI_PATTERN {
         UEXACT8 byte_pattern[128];
         UEXACT32 bit_masks[4];
      } SG_PACK ACPI_PATTERN, *PACPI_PATTERN;

      typedef union _ACPI_PATTERN_UNION {
         ACPI_PATTERN bits;
         u32 dw[36]; // dword union
      } SG_PACK ACPI_PATTERN_UNION, *PACPI_PATTERN_UNION;

      SG_C_ASSERT(__sizeof__ACPI_PATTERN_UNION, sizeof (ACPI_PATTERN_UNION) == 144);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_PATTERN {
         union {
            struct { 
               UEXACT8 byte_pattern[128];
               UEXACT32 bit_masks[4];
            } SG_PACK ; // unnamed struct
            u32 dw[36]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_PATTERN, *PACPI_PATTERN;

      SG_C_ASSERT(__sizeof__ACPI_PATTERN, sizeof (ACPI_PATTERN) == 144);

   #else
      typedef struct _ACPI_PATTERN {
         UEXACT8 byte_pattern[128];
         UEXACT32 bit_masks[4];
      } SG_PACK ACPI_PATTERN, *PACPI_PATTERN;

      typedef union _ACPI_PATTERN_UNION {
         ACPI_PATTERN bits;
         u32 dw[36]; // dword union
      } SG_PACK ACPI_PATTERN_UNION, *PACPI_PATTERN_UNION;

      SG_C_ASSERT(__sizeof__ACPI_PATTERN_UNION, sizeof (ACPI_PATTERN_UNION) == 144);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_WOL_MAGIC_CONFIG_PARAMS_IN {
         union {
            struct { 
               UEXACT8 acpi_num_patterns;
               UEXACT8 wol_enable;
               UEXACT8 query;
               UEXACT8 rsvd0;
               ACPI_PATTERN acpi_pattern[4];
               UEXACT8 mac_address[6];
               UEXACT8 rsvd1[2];
            } SG_PACK ; // unnamed struct
            u32 dw[147]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_IN, *PACPI_WOL_MAGIC_CONFIG_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_PARAMS_IN, sizeof (ACPI_WOL_MAGIC_CONFIG_PARAMS_IN) == 588);

   #else
      typedef struct _ACPI_WOL_MAGIC_CONFIG_PARAMS_IN {
         UEXACT8 acpi_num_patterns;
         UEXACT8 wol_enable;
         UEXACT8 query;
         UEXACT8 rsvd0;
         ACPI_PATTERN acpi_pattern[4];
         UEXACT8 mac_address[6];
         UEXACT8 rsvd1[2];
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_IN, *PACPI_WOL_MAGIC_CONFIG_PARAMS_IN;

      typedef union _ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_UNION {
         ACPI_WOL_MAGIC_CONFIG_PARAMS_IN bits;
         u32 dw[147]; // dword union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_UNION, *PACPI_WOL_MAGIC_CONFIG_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_UNION, sizeof (ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_UNION) == 588);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_WOL_MAGIC_CONFIG_PARAMS_IN {
         union {
            struct { 
               UEXACT8 acpi_num_patterns;
               UEXACT8 wol_enable;
               UEXACT8 query;
               UEXACT8 rsvd0;
               ACPI_PATTERN acpi_pattern[4];
               UEXACT8 mac_address[6];
               UEXACT8 rsvd1[2];
            } SG_PACK ; // unnamed struct
            u32 dw[147]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_IN, *PACPI_WOL_MAGIC_CONFIG_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_PARAMS_IN, sizeof (ACPI_WOL_MAGIC_CONFIG_PARAMS_IN) == 588);

   #else
      typedef struct _ACPI_WOL_MAGIC_CONFIG_PARAMS_IN {
         UEXACT8 acpi_num_patterns;
         UEXACT8 wol_enable;
         UEXACT8 query;
         UEXACT8 rsvd0;
         ACPI_PATTERN acpi_pattern[4];
         UEXACT8 mac_address[6];
         UEXACT8 rsvd1[2];
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_IN, *PACPI_WOL_MAGIC_CONFIG_PARAMS_IN;

      typedef union _ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_UNION {
         ACPI_WOL_MAGIC_CONFIG_PARAMS_IN bits;
         u32 dw[147]; // dword union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_UNION, *PACPI_WOL_MAGIC_CONFIG_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_UNION, sizeof (ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_UNION) == 588);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT {
         union {
            struct { 
               ACPI_PATTERN acpi_pattern[4];
            } SG_PACK ; // unnamed struct
            u32 dw[144]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT, *PACPI_WOL_MAGIC_CONFIG_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT, sizeof (ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT) == 576);

   #else
      typedef struct _ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT {
         ACPI_PATTERN acpi_pattern[4];
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT, *PACPI_WOL_MAGIC_CONFIG_PARAMS_OUT;

      typedef union _ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_UNION {
         ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT bits;
         u32 dw[144]; // dword union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_UNION, *PACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_UNION, sizeof (ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_UNION) == 576);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT {
         union {
            struct { 
               ACPI_PATTERN acpi_pattern[4];
            } SG_PACK ; // unnamed struct
            u32 dw[144]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT, *PACPI_WOL_MAGIC_CONFIG_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT, sizeof (ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT) == 576);

   #else
      typedef struct _ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT {
         ACPI_PATTERN acpi_pattern[4];
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT, *PACPI_WOL_MAGIC_CONFIG_PARAMS_OUT;

      typedef union _ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_UNION {
         ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT bits;
         u32 dw[144]; // dword union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_UNION, *PACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_UNION, sizeof (ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_UNION) == 576);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Configure the ACPI (Advanced Configuration and Power Interface), WoL (Wake on LAN) -
   // packet and Magic MAC capabilities. Only the host networking driver is allowed to
   // modify the interesting packet byte pattern, WoL capability and mask settings. Upto 4
   // such packet patterns are supported and to be shared first come first serve by all
   // active functions. The Magic packet congiguration for a given MAC address can be
   // enabled / disabled using this IOCTL. There are maximum of 2 MAC addresses per port
   // shared by all the functions on a first come first server basis. Only NIC host
   // adapters can issue this IOCTL. 
   typedef struct _IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG {
      IOCTL_HEADER header;
      union {
         ACPI_WOL_MAGIC_CONFIG_PARAMS_IN request;
         ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT response;
      } params;
   } SG_PACK IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG, *PIOCTL_ETH_ACPI_WOL_MAGIC_CONFIG;



#else
   // Configure the ACPI (Advanced Configuration and Power Interface), WoL (Wake on LAN) -
   // packet and Magic MAC capabilities. Only the host networking driver is allowed to
   // modify the interesting packet byte pattern, WoL capability and mask settings. Upto 4
   // such packet patterns are supported and to be shared first come first serve by all
   // active functions. The Magic packet congiguration for a given MAC address can be
   // enabled / disabled using this IOCTL. There are maximum of 2 MAC addresses per port
   // shared by all the functions on a first come first server basis. Only NIC host
   // adapters can issue this IOCTL. 
   typedef struct _IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG {
      IOCTL_HEADER header;
      union {
         ACPI_WOL_MAGIC_CONFIG_PARAMS_IN request;
         ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT response;
      } params;
   } SG_PACK IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG, *PIOCTL_ETH_ACPI_WOL_MAGIC_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN {
         union {
            struct { 
               UEXACT8 num_acpi_patterns;
               UEXACT8 rsvd0;
               UEXACT8 query_options;
               UEXACT8 rsvd1;
               UEXACT32 rsvd2;
               ACPI_PATTERN acpi_pattern[8];
               UEXACT8 mac_address[6];
               UEXACT8 rsvd3[2];
               UEXACT32 nd_dip_address[4];
               UEXACT32 arp_dip_address;
            } SG_PACK ; // unnamed struct
            u32 dw[297]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN, sizeof (ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN) == 1188);

   #else
      typedef struct _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN {
         UEXACT8 num_acpi_patterns;
         UEXACT8 rsvd0;
         UEXACT8 query_options;
         UEXACT8 rsvd1;
         UEXACT32 rsvd2;
         ACPI_PATTERN acpi_pattern[8];
         UEXACT8 mac_address[6];
         UEXACT8 rsvd3[2];
         UEXACT32 nd_dip_address[4];
         UEXACT32 arp_dip_address;
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN;

      typedef union _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_UNION {
         ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN bits;
         u32 dw[297]; // dword union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_UNION, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_UNION, sizeof (ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_UNION) == 1188);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN {
         union {
            struct { 
               UEXACT8 num_acpi_patterns;
               UEXACT8 rsvd0;
               UEXACT8 query_options;
               UEXACT8 rsvd1;
               UEXACT32 rsvd2;
               ACPI_PATTERN acpi_pattern[8];
               UEXACT8 mac_address[6];
               UEXACT8 rsvd3[2];
               UEXACT32 nd_dip_address[4];
               UEXACT32 arp_dip_address;
            } SG_PACK ; // unnamed struct
            u32 dw[297]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN, sizeof (ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN) == 1188);

   #else
      typedef struct _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN {
         UEXACT8 num_acpi_patterns;
         UEXACT8 rsvd0;
         UEXACT8 query_options;
         UEXACT8 rsvd1;
         UEXACT32 rsvd2;
         ACPI_PATTERN acpi_pattern[8];
         UEXACT8 mac_address[6];
         UEXACT8 rsvd3[2];
         UEXACT32 nd_dip_address[4];
         UEXACT32 arp_dip_address;
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN;

      typedef union _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_UNION {
         ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN bits;
         u32 dw[297]; // dword union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_UNION, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_UNION, sizeof (ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_UNION) == 1188);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 num_acpi_patterns;
               UEXACT8 acpi_patterns_total;
               UEXACT8 wol_capabilities;
               UEXACT8 acpi_capabilities;
               UEXACT8 arp_dip_total;
               UEXACT8 nd_dip_total;
               UEXACT8 rsvd0;
               UEXACT8 acpi_pattern_per_port;
               ACPI_PATTERN acpi_pattern[8];
               UEXACT8 mac_address[6];
               UEXACT8 rsvd1[2];
               UEXACT32 nd_dip_address[4];
               UEXACT32 arp_dip_address;
            } SG_PACK ; // unnamed struct
            u32 dw[297]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT, sizeof (ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT) == 1188);

   #else
      typedef struct _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT {
         UEXACT8 num_acpi_patterns;
         UEXACT8 acpi_patterns_total;
         UEXACT8 wol_capabilities;
         UEXACT8 acpi_capabilities;
         UEXACT8 arp_dip_total;
         UEXACT8 nd_dip_total;
         UEXACT8 rsvd0;
         UEXACT8 acpi_pattern_per_port;
         ACPI_PATTERN acpi_pattern[8];
         UEXACT8 mac_address[6];
         UEXACT8 rsvd1[2];
         UEXACT32 nd_dip_address[4];
         UEXACT32 arp_dip_address;
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT;

      typedef union _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_UNION {
         ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT bits;
         u32 dw[297]; // dword union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_UNION, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_UNION, sizeof (ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_UNION) == 1188);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 num_acpi_patterns;
               UEXACT8 acpi_patterns_total;
               UEXACT8 wol_capabilities;
               UEXACT8 acpi_capabilities;
               UEXACT8 arp_dip_total;
               UEXACT8 nd_dip_total;
               UEXACT8 rsvd0;
               UEXACT8 acpi_pattern_per_port;
               ACPI_PATTERN acpi_pattern[8];
               UEXACT8 mac_address[6];
               UEXACT8 rsvd1[2];
               UEXACT32 nd_dip_address[4];
               UEXACT32 arp_dip_address;
            } SG_PACK ; // unnamed struct
            u32 dw[297]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT, sizeof (ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT) == 1188);

   #else
      typedef struct _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT {
         UEXACT8 num_acpi_patterns;
         UEXACT8 acpi_patterns_total;
         UEXACT8 wol_capabilities;
         UEXACT8 acpi_capabilities;
         UEXACT8 arp_dip_total;
         UEXACT8 nd_dip_total;
         UEXACT8 rsvd0;
         UEXACT8 acpi_pattern_per_port;
         ACPI_PATTERN acpi_pattern[8];
         UEXACT8 mac_address[6];
         UEXACT8 rsvd1[2];
         UEXACT32 nd_dip_address[4];
         UEXACT32 arp_dip_address;
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT;

      typedef union _ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_UNION {
         ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT bits;
         u32 dw[297]; // dword union
      } SG_PACK ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_UNION, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_UNION, sizeof (ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_UNION) == 1188);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This command configures the ACPI (Advanced Configuration and Power Interface), WoL
   // (Wake on LAN) packet and Magic Packet capabilities. Only the SLI host networking
   // driver can configure the packet byte pattern, WoL capability and mask settings. This
   // command can enable/disable the Magic packet configuration for a given MAC address
   // among the set of MAC addresses allowed on the physical port. 
   typedef struct _IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_V1 {
      IOCTL_HEADER header;
      union {
         ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN request;
         ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT response;
      } params;
   } SG_PACK IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_V1, *PIOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_V1;



#else
   // This command configures the ACPI (Advanced Configuration and Power Interface), WoL
   // (Wake on LAN) packet and Magic Packet capabilities. Only the SLI host networking
   // driver can configure the packet byte pattern, WoL capability and mask settings. This
   // command can enable/disable the Magic packet configuration for a given MAC address
   // among the set of MAC addresses allowed on the physical port. 
   typedef struct _IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_V1 {
      IOCTL_HEADER header;
      union {
         ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN request;
         ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT response;
      } params;
   } SG_PACK IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_V1, *PIOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_V1;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Enables/Disables promiscuous ethernet receive mode. 
   typedef struct _IOCTL_ETH_PROMISCUOUS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT8 port0_promiscuous;
            UEXACT8 port1_promiscuous;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_PROMISCUOUS, *PIOCTL_ETH_PROMISCUOUS;



#else
   // Enables/Disables promiscuous ethernet receive mode. 
   typedef struct _IOCTL_ETH_PROMISCUOUS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT8 port0_promiscuous;
            UEXACT8 port1_promiscuous;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_PROMISCUOUS, *PIOCTL_ETH_PROMISCUOUS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating an Ethernet transmit ring.  An ETX ring contains ETH_WRB entries
   // (16 bytes each). An ETX ring must be at least 256 entries deep (corresponding to 1
   // page) and at most 2k entries deep (corresponding to 8 pages).  For Version 0 of the
   // IOCTL see IOCTL_ETH_TX_CREATE_V0. 
   typedef struct _IOCTL_ETH_TX_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT8 num_pages;
            UEXACT8 ulp_num;
            UEXACT8 type;
            UEXACT8 bound_port;
            ETX_CONTEXT context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 cid;
            UEXACT16 rid;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_TX_CREATE, *PIOCTL_ETH_TX_CREATE;



#else
   // IOCTL for creating an Ethernet transmit ring.  An ETX ring contains ETH_WRB entries
   // (16 bytes each). An ETX ring must be at least 256 entries deep (corresponding to 1
   // page) and at most 2k entries deep (corresponding to 8 pages).  For Version 0 of the
   // IOCTL see IOCTL_ETH_TX_CREATE_V0. 
   typedef struct _IOCTL_ETH_TX_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT8 num_pages;
            UEXACT8 ulp_num;
            UEXACT8 type;
            UEXACT8 bound_port;
            ETX_CONTEXT context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 cid;
            UEXACT16 rid;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_TX_CREATE, *PIOCTL_ETH_TX_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_CREATE_V1_PARAMS_IN {
         union {
            struct { 
               UEXACT8 num_pages;
               UEXACT8 rsvd0;
               UEXACT16 type;
               UEXACT16 iface_id;
               UEXACT8 queue_size;
               UEXACT8 rsvd1;
               UEXACT32 rsvd2;
               UEXACT16 cq_id;
               UEXACT16 rsvd3;
               UEXACT32 rsvd4[13];
               PHYS_ADDR pages[8];
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK TX_CREATE_V1_PARAMS_IN, *PTX_CREATE_V1_PARAMS_IN;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS_IN, sizeof (TX_CREATE_V1_PARAMS_IN) == 132);

   #else
      typedef struct _TX_CREATE_V1_PARAMS_IN {
         UEXACT8 num_pages;
         UEXACT8 rsvd0;
         UEXACT16 type;
         UEXACT16 iface_id;
         UEXACT8 queue_size;
         UEXACT8 rsvd1;
         UEXACT32 rsvd2;
         UEXACT16 cq_id;
         UEXACT16 rsvd3;
         UEXACT32 rsvd4[13];
         PHYS_ADDR pages[8];
      } SG_PACK TX_CREATE_V1_PARAMS_IN, *PTX_CREATE_V1_PARAMS_IN;

      typedef union _TX_CREATE_V1_PARAMS_IN_UNION {
         TX_CREATE_V1_PARAMS_IN bits;
         u32 dw[33]; // dword union
      } SG_PACK TX_CREATE_V1_PARAMS_IN_UNION, *PTX_CREATE_V1_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS_IN_UNION, sizeof (TX_CREATE_V1_PARAMS_IN_UNION) == 132);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_CREATE_V1_PARAMS_IN {
         union {
            struct { 
               UEXACT8 num_pages;
               UEXACT8 rsvd0;
               UEXACT16 type;
               UEXACT16 iface_id;
               UEXACT8 queue_size;
               UEXACT8 rsvd1;
               UEXACT32 rsvd2;
               UEXACT16 cq_id;
               UEXACT16 rsvd3;
               UEXACT32 rsvd4[13];
               PHYS_ADDR pages[8];
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK TX_CREATE_V1_PARAMS_IN, *PTX_CREATE_V1_PARAMS_IN;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS_IN, sizeof (TX_CREATE_V1_PARAMS_IN) == 132);

   #else
      typedef struct _TX_CREATE_V1_PARAMS_IN {
         UEXACT8 num_pages;
         UEXACT8 rsvd0;
         UEXACT16 type;
         UEXACT16 iface_id;
         UEXACT8 queue_size;
         UEXACT8 rsvd1;
         UEXACT32 rsvd2;
         UEXACT16 cq_id;
         UEXACT16 rsvd3;
         UEXACT32 rsvd4[13];
         PHYS_ADDR pages[8];
      } SG_PACK TX_CREATE_V1_PARAMS_IN, *PTX_CREATE_V1_PARAMS_IN;

      typedef union _TX_CREATE_V1_PARAMS_IN_UNION {
         TX_CREATE_V1_PARAMS_IN bits;
         u32 dw[33]; // dword union
      } SG_PACK TX_CREATE_V1_PARAMS_IN_UNION, *PTX_CREATE_V1_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS_IN_UNION, sizeof (TX_CREATE_V1_PARAMS_IN_UNION) == 132);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_CREATE_V1_PARAMS_OUT {
         union {
            struct { 
               UEXACT16 id;
               UEXACT16 rid;
               UEXACT32 doorbell_offset;
               UEXACT8 class_queue_id;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK TX_CREATE_V1_PARAMS_OUT, *PTX_CREATE_V1_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS_OUT, sizeof (TX_CREATE_V1_PARAMS_OUT) == 12);

   #else
      typedef struct _TX_CREATE_V1_PARAMS_OUT {
         UEXACT16 id;
         UEXACT16 rid;
         UEXACT32 doorbell_offset;
         UEXACT8 class_queue_id;
         UEXACT8 rsvd0[3];
      } SG_PACK TX_CREATE_V1_PARAMS_OUT, *PTX_CREATE_V1_PARAMS_OUT;

      typedef union _TX_CREATE_V1_PARAMS_OUT_UNION {
         TX_CREATE_V1_PARAMS_OUT bits;
         u32 dw[3]; // dword union
      } SG_PACK TX_CREATE_V1_PARAMS_OUT_UNION, *PTX_CREATE_V1_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS_OUT_UNION, sizeof (TX_CREATE_V1_PARAMS_OUT_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_CREATE_V1_PARAMS_OUT {
         union {
            struct { 
               UEXACT16 id;
               UEXACT16 rid;
               UEXACT32 doorbell_offset;
               UEXACT8 class_queue_id;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK TX_CREATE_V1_PARAMS_OUT, *PTX_CREATE_V1_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS_OUT, sizeof (TX_CREATE_V1_PARAMS_OUT) == 12);

   #else
      typedef struct _TX_CREATE_V1_PARAMS_OUT {
         UEXACT16 id;
         UEXACT16 rid;
         UEXACT32 doorbell_offset;
         UEXACT8 class_queue_id;
         UEXACT8 rsvd0[3];
      } SG_PACK TX_CREATE_V1_PARAMS_OUT, *PTX_CREATE_V1_PARAMS_OUT;

      typedef union _TX_CREATE_V1_PARAMS_OUT_UNION {
         TX_CREATE_V1_PARAMS_OUT bits;
         u32 dw[3]; // dword union
      } SG_PACK TX_CREATE_V1_PARAMS_OUT_UNION, *PTX_CREATE_V1_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS_OUT_UNION, sizeof (TX_CREATE_V1_PARAMS_OUT_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_CREATE_V1_PARAMS {
         union {
            union { 
               TX_CREATE_V1_PARAMS_IN request;
               TX_CREATE_V1_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK TX_CREATE_V1_PARAMS, *PTX_CREATE_V1_PARAMS;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS, sizeof (TX_CREATE_V1_PARAMS) == 132);

   #else
      typedef union _TX_CREATE_V1_PARAMS {
         TX_CREATE_V1_PARAMS_IN request;
         TX_CREATE_V1_PARAMS_OUT response;
      } SG_PACK TX_CREATE_V1_PARAMS, *PTX_CREATE_V1_PARAMS;

      typedef union _TX_CREATE_V1_PARAMS_UNION {
         TX_CREATE_V1_PARAMS bits;
         u32 dw[33]; // dword union
      } SG_PACK TX_CREATE_V1_PARAMS_UNION, *PTX_CREATE_V1_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS_UNION, sizeof (TX_CREATE_V1_PARAMS_UNION) == 132);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_CREATE_V1_PARAMS {
         union {
            union { 
               TX_CREATE_V1_PARAMS_IN request;
               TX_CREATE_V1_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK TX_CREATE_V1_PARAMS, *PTX_CREATE_V1_PARAMS;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS, sizeof (TX_CREATE_V1_PARAMS) == 132);

   #else
      typedef union _TX_CREATE_V1_PARAMS {
         TX_CREATE_V1_PARAMS_IN request;
         TX_CREATE_V1_PARAMS_OUT response;
      } SG_PACK TX_CREATE_V1_PARAMS, *PTX_CREATE_V1_PARAMS;

      typedef union _TX_CREATE_V1_PARAMS_UNION {
         TX_CREATE_V1_PARAMS bits;
         u32 dw[33]; // dword union
      } SG_PACK TX_CREATE_V1_PARAMS_UNION, *PTX_CREATE_V1_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__TX_CREATE_V1_PARAMS_UNION, sizeof (TX_CREATE_V1_PARAMS_UNION) == 132);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating an Ethernet transmit queue.  The IOCTL_ETH_TX_CREATE_V1 structure
   // format is indicated by the IOCTL_REQUEST_HEADER version field set to 1.  Note: The
   // version 0 command structure format is defined by IOCTL_ETH_TX_CREATE.  The IOCTL may
   // complete with the following status/additional_status codes:  -  -
   // MGMT_STATUS_SUCCESS -- the request completes successfully.  -
   // MGMT_STATUS_ILLEGAL_FIELD -- this indicates an invalid request parameter at the byte
   // offset specified in the additional_status response field.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_REQUEST -- the
   // IOCTL_REQUEST_HEADER version field indicates an unsupported version of the command
   // structure format.  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES --
   // there are no available Ethernet transmit queue IDs. 
   typedef struct _IOCTL_ETH_TX_CREATE_V1 {
      IOCTL_HEADER header;
      TX_CREATE_V1_PARAMS params;
   } SG_PACK IOCTL_ETH_TX_CREATE_V1, *PIOCTL_ETH_TX_CREATE_V1;



#else
   // IOCTL for creating an Ethernet transmit queue.  The IOCTL_ETH_TX_CREATE_V1 structure
   // format is indicated by the IOCTL_REQUEST_HEADER version field set to 1.  Note: The
   // version 0 command structure format is defined by IOCTL_ETH_TX_CREATE.  The IOCTL may
   // complete with the following status/additional_status codes:  -  -
   // MGMT_STATUS_SUCCESS -- the request completes successfully.  -
   // MGMT_STATUS_ILLEGAL_FIELD -- this indicates an invalid request parameter at the byte
   // offset specified in the additional_status response field.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_REQUEST -- the
   // IOCTL_REQUEST_HEADER version field indicates an unsupported version of the command
   // structure format.  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES --
   // there are no available Ethernet transmit queue IDs. 
   typedef struct _IOCTL_ETH_TX_CREATE_V1 {
      IOCTL_HEADER header;
      TX_CREATE_V1_PARAMS params;
   } SG_PACK IOCTL_ETH_TX_CREATE_V1, *PIOCTL_ETH_TX_CREATE_V1;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating an Ethernet receive ring.  An ERX ring contains ETH_RX_D entries
   // (8 bytes each). An ERX ring must be 1024 entries deep (corresponding to 2 pages). 
   typedef struct _IOCTL_ETH_RX_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cq_id;
            UEXACT8 frag_size;
            UEXACT8 num_pages;
            PHYS_ADDR pages[2];
            UEXACT32 interface_id;
            UEXACT16 max_frame_size;
            UEXACT16 rsvd0;
            UEXACT32 rss_queue;
         } request;
         struct {
            UEXACT16 id;
            UEXACT8 cpu_id;
            UEXACT8 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_RX_CREATE, *PIOCTL_ETH_RX_CREATE;



#else
   // IOCTL for creating an Ethernet receive ring.  An ERX ring contains ETH_RX_D entries
   // (8 bytes each). An ERX ring must be 1024 entries deep (corresponding to 2 pages). 
   typedef struct _IOCTL_ETH_RX_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cq_id;
            UEXACT8 frag_size;
            UEXACT8 num_pages;
            PHYS_ADDR pages[2];
            UEXACT32 interface_id;
            UEXACT16 max_frame_size;
            UEXACT16 rsvd0;
            UEXACT32 rss_queue;
         } request;
         struct {
            UEXACT16 id;
            UEXACT8 cpu_id;
            UEXACT8 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_RX_CREATE, *PIOCTL_ETH_RX_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying a Ethernet transmit ring. 
   typedef struct _IOCTL_ETH_TX_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_TX_DESTROY, *PIOCTL_ETH_TX_DESTROY;



#else
   // IOCTL for destroying a Ethernet transmit ring. 
   typedef struct _IOCTL_ETH_TX_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_TX_DESTROY, *PIOCTL_ETH_TX_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying a Ethernet receive ring. 
   typedef struct _IOCTL_ETH_RX_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 bypass_flush;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_RX_DESTROY, *PIOCTL_ETH_RX_DESTROY;



#else
   // IOCTL for destroying a Ethernet receive ring. 
   typedef struct _IOCTL_ETH_RX_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 bypass_flush;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_RX_DESTROY, *PIOCTL_ETH_RX_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   //  This is a consolidated set of stats that are typically used by a driver during
   // runtime.  Note that BladeEngine2 counts all TOE transmit and retransmit stats as
   // IPv4 if more than 1 physical function is loaded per port. The IPv6 stats will be
   // zero in this case. 
   typedef struct _NIC_TOE_STATS {
      UEXACT32 ToeTxIPv4Packets;
      UEXACT32 ToeTxIPv6Packets;
      UEXACT64 ToeTxIPv4Bytes;
      UEXACT64 ToeTxIPv6Bytes;
      UEXACT32 ToeTxIPv4RetransmitPackets;
      UEXACT32 ToeTxIPv6RetransmitPackets;
      UEXACT32 ToeTxIPv4RetransmitBytes;
      UEXACT32 ToeTxIPv6RetransmitBytes;
      UEXACT32 ToeRxIPv4Packets;
      UEXACT32 ToeRxIPv6Packets;
      UEXACT32 ToeRxIPv4Drops;
      UEXACT32 ToeRxIPv6Drops;
      UEXACT64 ToeRxIPv4Bytes;
      UEXACT64 ToeRxIPv6Bytes;
      UEXACT32 ToeTxAcks;
      UEXACT32 ToeTxDelayedAcks;
      UEXACT32 ToeTxWindowProbes;
      UEXACT32 ToeRxWindowUpdates;
      UEXACT32 ToeRxWindowProbes;
      UEXACT32 ToeRxOutOfOrderPackets;
      UEXACT32 ToeRxAcks;
      UEXACT32 ToeRxDuplicateAcks;
      UEXACT32 TxPauseFrames;
      UEXACT32 RxPauseFrames;
      UEXACT32 RxNoPacketMemoryDrops;
      UEXACT32 RedDrops;
      UEXACT32 EthRxDropsNoFragments;
      UEXACT32 RxCrcErrors;
      UEXACT32 RxAlignmentErrors;
      UEXACT32 RxJabbers;
      UEXACT32 RxRuntErrors;
      UEXACT32 RxFrameTooLongError;
      UEXACT32 RxEthLengthErrors;
      UEXACT32 RxIpHeaderError;
      UEXACT32 RxIpChecksumErrors;
      UEXACT32 RxTcpChecksumErrors;
      UEXACT32 RxUdpChecksumErrors;
      UEXACT64 TxControllerBytes;
      UEXACT64 RxControllerBytes;
      UEXACT32 rsvd0[9];
   } SG_PACK NIC_TOE_STATS, *PNIC_TOE_STATS;



#else
   //  This is a consolidated set of stats that are typically used by a driver during
   // runtime.  Note that BladeEngine2 counts all TOE transmit and retransmit stats as
   // IPv4 if more than 1 physical function is loaded per port. The IPv6 stats will be
   // zero in this case. 
   typedef struct _NIC_TOE_STATS {
      UEXACT32 ToeTxIPv4Packets;
      UEXACT32 ToeTxIPv6Packets;
      UEXACT64 ToeTxIPv4Bytes;
      UEXACT64 ToeTxIPv6Bytes;
      UEXACT32 ToeTxIPv4RetransmitPackets;
      UEXACT32 ToeTxIPv6RetransmitPackets;
      UEXACT32 ToeTxIPv4RetransmitBytes;
      UEXACT32 ToeTxIPv6RetransmitBytes;
      UEXACT32 ToeRxIPv4Packets;
      UEXACT32 ToeRxIPv6Packets;
      UEXACT32 ToeRxIPv4Drops;
      UEXACT32 ToeRxIPv6Drops;
      UEXACT64 ToeRxIPv4Bytes;
      UEXACT64 ToeRxIPv6Bytes;
      UEXACT32 ToeTxAcks;
      UEXACT32 ToeTxDelayedAcks;
      UEXACT32 ToeTxWindowProbes;
      UEXACT32 ToeRxWindowUpdates;
      UEXACT32 ToeRxWindowProbes;
      UEXACT32 ToeRxOutOfOrderPackets;
      UEXACT32 ToeRxAcks;
      UEXACT32 ToeRxDuplicateAcks;
      UEXACT32 TxPauseFrames;
      UEXACT32 RxPauseFrames;
      UEXACT32 RxNoPacketMemoryDrops;
      UEXACT32 RedDrops;
      UEXACT32 EthRxDropsNoFragments;
      UEXACT32 RxCrcErrors;
      UEXACT32 RxAlignmentErrors;
      UEXACT32 RxJabbers;
      UEXACT32 RxRuntErrors;
      UEXACT32 RxFrameTooLongError;
      UEXACT32 RxEthLengthErrors;
      UEXACT32 RxIpHeaderError;
      UEXACT32 RxIpChecksumErrors;
      UEXACT32 RxTcpChecksumErrors;
      UEXACT32 RxUdpChecksumErrors;
      UEXACT64 TxControllerBytes;
      UEXACT64 RxControllerBytes;
      UEXACT32 rsvd0[9];
   } SG_PACK NIC_TOE_STATS, *PNIC_TOE_STATS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for querying NIC/TOE stats for a given network function. 
   typedef struct _IOCTL_ETH_NETWORK_STATS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 query_toe;
         } request;
         struct {
            NIC_TOE_STATS stats;
         } response;
      } params;
      u32 rsvd0[1];                               // DWORDS 58 to 58
   } SG_PACK IOCTL_ETH_NETWORK_STATS, *PIOCTL_ETH_NETWORK_STATS;



#else
   // IOCTL for querying NIC/TOE stats for a given network function. 
   typedef struct _IOCTL_ETH_NETWORK_STATS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 query_toe;
         } request;
         struct {
            NIC_TOE_STATS stats;
         } response;
      } params;
      u32 rsvd0[1];                               // DWORDS 58 to 58
   } SG_PACK IOCTL_ETH_NETWORK_STATS, *PIOCTL_ETH_NETWORK_STATS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for querying PG capabilites required to configure the ETH stack for supporting
   // PFC/PG. Return codes:- If the query bit was set and none of the feature bits were
   // set, firmware will return MGMT_STATUS_ILLEGAL_REQUEST If query bit was not set and
   // none of the feature bits were set, firmware will return MGMT_STATUS_ILLEGAL_REQUEST
   // Firmware will return MGMT_STATUS_FAILED for all other errors. 
   typedef struct _IOCTL_ETH_PG_FEATURE_QUERY_REQUEST {
      IOCTL_HEADER header;
      union {
         struct {
            u32 rsvd0 : 31;                       // DWORD 4
            u32 query : 1;                        // DWORD 4
            u32 rsvd1 : 31;                       // DWORD 5
            u32 eth_pfc_pg_feature : 1;           // DWORD 5
         } request;
         struct {
            u32 rsvd0 : 31;                       // DWORD 4
            u32 eth_pfc_pg_feature : 1;           // DWORD 4
            u32 num_tx_rings;                     // DWORD 5
         } response;
      } params;
   } SG_PACK IOCTL_ETH_PG_FEATURE_QUERY_REQUEST, *PIOCTL_ETH_PG_FEATURE_QUERY_REQUEST;



#else
   // IOCTL for querying PG capabilites required to configure the ETH stack for supporting
   // PFC/PG. Return codes:- If the query bit was set and none of the feature bits were
   // set, firmware will return MGMT_STATUS_ILLEGAL_REQUEST If query bit was not set and
   // none of the feature bits were set, firmware will return MGMT_STATUS_ILLEGAL_REQUEST
   // Firmware will return MGMT_STATUS_FAILED for all other errors. 
   typedef struct _IOCTL_ETH_PG_FEATURE_QUERY_REQUEST {
      IOCTL_HEADER header;
      union {
         struct {
            u32 query : 1;                        // DWORD 4
            u32 rsvd0 : 31;                       // DWORD 4
            u32 eth_pfc_pg_feature : 1;           // DWORD 5
            u32 rsvd1 : 31;                       // DWORD 5
         } request;
         struct {
            u32 eth_pfc_pg_feature : 1;           // DWORD 4
            u32 rsvd0 : 31;                       // DWORD 4
            u32 num_tx_rings;                     // DWORD 5
         } response;
      } params;
   } SG_PACK IOCTL_ETH_PG_FEATURE_QUERY_REQUEST, *PIOCTL_ETH_PG_FEATURE_QUERY_REQUEST;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for querying mapping between eth tx ring's class_queue_id and ethernet traffic
   // priority. Every priority class will have a 3 bit class index returned with
   // IOCTL_ETH_TX_CREATE_V1 with type ETX_QUEUE_TYPE_PRIORITY bit was set in the type
   // field. Return codes:- If there are no ETH Tx rings created with
   // ETX_QUEUE_TYPE_PRIORITY firmware will return MGMT_STATUS_FAILED . 
   typedef struct _IOCTL_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP {
      IOCTL_HEADER header;
      union {
         struct {
            u32 rsvd0[1];                         // DWORDS 4 to 4
         } request;
         struct {
            UEXACT8 priority0_classq;
            UEXACT8 priority1_classq;
            UEXACT8 priority2_classq;
            UEXACT8 priority3_classq;
            UEXACT8 priority4_classq;
            UEXACT8 priority5_classq;
            UEXACT8 priority6_classq;
            UEXACT8 priority7_classq;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP, *PIOCTL_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP;



#else
   // IOCTL for querying mapping between eth tx ring's class_queue_id and ethernet traffic
   // priority. Every priority class will have a 3 bit class index returned with
   // IOCTL_ETH_TX_CREATE_V1 with type ETX_QUEUE_TYPE_PRIORITY bit was set in the type
   // field. Return codes:- If there are no ETH Tx rings created with
   // ETX_QUEUE_TYPE_PRIORITY firmware will return MGMT_STATUS_FAILED . 
   typedef struct _IOCTL_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP {
      IOCTL_HEADER header;
      union {
         struct {
            u32 rsvd0[1];                         // DWORDS 4 to 4
         } request;
         struct {
            UEXACT8 priority0_classq;
            UEXACT8 priority1_classq;
            UEXACT8 priority2_classq;
            UEXACT8 priority3_classq;
            UEXACT8 priority4_classq;
            UEXACT8 priority5_classq;
            UEXACT8 priority6_classq;
            UEXACT8 priority7_classq;
         } response;
      } params;
   } SG_PACK IOCTL_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP, *PIOCTL_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_eth_bmap_h__

