/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_flash_types_bmap_h__
#define __ioctl_flash_types_bmap_h__
#include "setypes.h"
#include "post_codes_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE2_FIS_DIR_ENTRY {
      UEXACT8 name[16];
      UEXACT32 flash_addr;
      UEXACT32 mem_addr;
      UEXACT32 length;
      UEXACT32 entry;
      UEXACT32 data_length;
   } SG_PACK BE2_FIS_DIR_ENTRY, *PBE2_FIS_DIR_ENTRY;



#else
   
   typedef struct _BE2_FIS_DIR_ENTRY {
      UEXACT8 name[16];
      UEXACT32 flash_addr;
      UEXACT32 mem_addr;
      UEXACT32 length;
      UEXACT32 entry;
      UEXACT32 data_length;
   } SG_PACK BE2_FIS_DIR_ENTRY, *PBE2_FIS_DIR_ENTRY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE2_IMAGE_INFO_T {
      UEXACT32 ImageId;
      UEXACT32 ImageOffset;
      UEXACT32 ImageLength;
      UEXACT32 ImageChecksum;
      UEXACT32 ImageVersion;
   } SG_PACK BE2_IMAGE_INFO_T, *PBE2_IMAGE_INFO_T;



#else
   
   typedef struct _BE2_IMAGE_INFO_T {
      UEXACT32 ImageId;
      UEXACT32 ImageOffset;
      UEXACT32 ImageLength;
      UEXACT32 ImageChecksum;
      UEXACT32 ImageVersion;
   } SG_PACK BE2_IMAGE_INFO_T, *PBE2_IMAGE_INFO_T;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE2_CONTROLLER_ID_T {
      UEXACT32 Vendor;
      UEXACT32 Device;
      UEXACT32 SubVendor;
      UEXACT32 SubDevice;
   } SG_PACK BE2_CONTROLLER_ID_T, *PBE2_CONTROLLER_ID_T;



#else
   
   typedef struct _BE2_CONTROLLER_ID_T {
      UEXACT32 Vendor;
      UEXACT32 Device;
      UEXACT32 SubVendor;
      UEXACT32 SubDevice;
   } SG_PACK BE2_CONTROLLER_ID_T, *PBE2_CONTROLLER_ID_T;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE2_FILE_HEADER_T {
      UEXACT8 FH_Signature[32];
      UEXACT32 FH_Checksum;
      UEXACT32 FH_Antidote;
      BE2_CONTROLLER_ID_T FH_ContrlId;
      UEXACT32 FH_FileLen;
      UEXACT32 FH_ChunkNum;
      UEXACT32 FH_TotalChunks;
      UEXACT32 FH_NumOfImgs;
      UEXACT8 FH_Build[24];
   } SG_PACK BE2_FILE_HEADER_T, *PBE2_FILE_HEADER_T;



#else
   
   typedef struct _BE2_FILE_HEADER_T {
      UEXACT8 FH_Signature[32];
      UEXACT32 FH_Checksum;
      UEXACT32 FH_Antidote;
      BE2_CONTROLLER_ID_T FH_ContrlId;
      UEXACT32 FH_FileLen;
      UEXACT32 FH_ChunkNum;
      UEXACT32 FH_TotalChunks;
      UEXACT32 FH_NumOfImgs;
      UEXACT8 FH_Build[24];
   } SG_PACK BE2_FILE_HEADER_T, *PBE2_FILE_HEADER_T;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE2_FLASHDIR_HEADER_TYPE {
      UEXACT32 flashdir_format_rev;
      UEXACT32 flashwide_checksum;
      UEXACT32 flashwide_antidote;
      UEXACT32 build_number;
      UEXACT8 UFIIdentifierString[128];
      UEXACT32 active_entry_mask;
      UEXACT32 valid_entry_mask;
      UEXACT32 original_content_mask;
      UEXACT32 rsvd0;
      UEXACT32 rsvd1;
      UEXACT32 rsvd2;
      UEXACT32 rsvd3;
      UEXACT32 rsvd4;
   } SG_PACK BE2_FLASHDIR_HEADER_TYPE, *PBE2_FLASHDIR_HEADER_TYPE;



#else
   
   typedef struct _BE2_FLASHDIR_HEADER_TYPE {
      UEXACT32 flashdir_format_rev;
      UEXACT32 flashwide_checksum;
      UEXACT32 flashwide_antidote;
      UEXACT32 build_number;
      UEXACT8 UFIIdentifierString[128];
      UEXACT32 active_entry_mask;
      UEXACT32 valid_entry_mask;
      UEXACT32 original_content_mask;
      UEXACT32 rsvd0;
      UEXACT32 rsvd1;
      UEXACT32 rsvd2;
      UEXACT32 rsvd3;
      UEXACT32 rsvd4;
   } SG_PACK BE2_FLASHDIR_HEADER_TYPE, *PBE2_FLASHDIR_HEADER_TYPE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Entry Type Definitions 
   typedef struct _BE2_FLASHDIR_ENTRY_TYPE {
      UEXACT32 entry_type;
      UEXACT32 offset;
      UEXACT32 pad_size;
      UEXACT32 image_size;
      UEXACT32 entry_checksum;
      UEXACT32 entry_point;
      UEXACT32 future_use1;
      UEXACT32 future_use2;
      UEXACT8 version_data[32];
   } SG_PACK BE2_FLASHDIR_ENTRY_TYPE, *PBE2_FLASHDIR_ENTRY_TYPE;



#else
   // Entry Type Definitions 
   typedef struct _BE2_FLASHDIR_ENTRY_TYPE {
      UEXACT32 entry_type;
      UEXACT32 offset;
      UEXACT32 pad_size;
      UEXACT32 image_size;
      UEXACT32 entry_checksum;
      UEXACT32 entry_point;
      UEXACT32 future_use1;
      UEXACT32 future_use2;
      UEXACT8 version_data[32];
   } SG_PACK BE2_FLASHDIR_ENTRY_TYPE, *PBE2_FLASHDIR_ENTRY_TYPE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Definition of the directory as a whole 
   typedef struct _BE2_FLASHDIR_TYPE {
      UEXACT8 flashdir_cookie[32];
      BE2_FLASHDIR_HEADER_TYPE flashdir_header;
      BE2_FLASHDIR_ENTRY_TYPE flashdir_entry[32];
   } SG_PACK BE2_FLASHDIR_TYPE, *PBE2_FLASHDIR_TYPE;



#else
   // Definition of the directory as a whole 
   typedef struct _BE2_FLASHDIR_TYPE {
      UEXACT8 flashdir_cookie[32];
      BE2_FLASHDIR_HEADER_TYPE flashdir_header;
      BE2_FLASHDIR_ENTRY_TYPE flashdir_entry[32];
   } SG_PACK BE2_FLASHDIR_TYPE, *PBE2_FLASHDIR_TYPE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _FIS_DIR_ENTRY {
      UEXACT8 name[16];
      UEXACT32 flash_addr;
      UEXACT32 mem_addr;
      UEXACT32 length;
      UEXACT32 entry;
      UEXACT32 data_length;
   } SG_PACK FIS_DIR_ENTRY, *PFIS_DIR_ENTRY;



#else
   
   typedef struct _FIS_DIR_ENTRY {
      UEXACT8 name[16];
      UEXACT32 flash_addr;
      UEXACT32 mem_addr;
      UEXACT32 length;
      UEXACT32 entry;
      UEXACT32 data_length;
   } SG_PACK FIS_DIR_ENTRY, *PFIS_DIR_ENTRY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IMAGE_HEADER_T {
      UEXACT32 ImageId;
      UEXACT32 ImageOffset;
      UEXACT32 ImageLength;
      UEXACT32 ImageChecksum;
      UEXACT8 ImageVersion[32];
   } SG_PACK IMAGE_HEADER_T, *PIMAGE_HEADER_T;



#else
   
   typedef struct _IMAGE_HEADER_T {
      UEXACT32 ImageId;
      UEXACT32 ImageOffset;
      UEXACT32 ImageLength;
      UEXACT32 ImageChecksum;
      UEXACT8 ImageVersion[32];
   } SG_PACK IMAGE_HEADER_T, *PIMAGE_HEADER_T;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _FILE_HEADER_T {
      UEXACT8 FH_Signature[52];
      UEXACT8 FH_UFI_Version[4];
      UEXACT32 FH_FileLen;
      UEXACT32 FH_Checksum;
      UEXACT32 FH_Antidote;
      UEXACT32 FH_NumOfImgs;
      UEXACT8 FH_Build[24];
      UEXACT8 rsvd0[32];
   } SG_PACK FILE_HEADER_T, *PFILE_HEADER_T;



#else
   
   typedef struct _FILE_HEADER_T {
      UEXACT8 FH_Signature[52];
      UEXACT8 FH_UFI_Version[4];
      UEXACT32 FH_FileLen;
      UEXACT32 FH_Checksum;
      UEXACT32 FH_Antidote;
      UEXACT32 FH_NumOfImgs;
      UEXACT8 FH_Build[24];
      UEXACT8 rsvd0[32];
   } SG_PACK FILE_HEADER_T, *PFILE_HEADER_T;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _CONTROLLER_ID_T {
      UEXACT32 Vendor;
      UEXACT32 Device;
      UEXACT32 SubVendor;
      UEXACT32 SubDevice;
   } SG_PACK CONTROLLER_ID_T, *PCONTROLLER_ID_T;



#else
   
   typedef struct _CONTROLLER_ID_T {
      UEXACT32 Vendor;
      UEXACT32 Device;
      UEXACT32 SubVendor;
      UEXACT32 SubDevice;
   } SG_PACK CONTROLLER_ID_T, *PCONTROLLER_ID_T;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _FLASHDIR_HEADER_TYPE {
      UEXACT32 flashdir_format_rev;
      UEXACT32 flashwide_checksum;
      UEXACT32 flashwide_antidote;
      UEXACT32 num_of_images;
      UEXACT8 UFIIdentifierString[128];
      UEXACT32 rsvd0;
      UEXACT32 rsvd1;
      UEXACT32 rsvd2;
      UEXACT32 rsvd3;
   } SG_PACK FLASHDIR_HEADER_TYPE, *PFLASHDIR_HEADER_TYPE;



#else
   
   typedef struct _FLASHDIR_HEADER_TYPE {
      UEXACT32 flashdir_format_rev;
      UEXACT32 flashwide_checksum;
      UEXACT32 flashwide_antidote;
      UEXACT32 num_of_images;
      UEXACT8 UFIIdentifierString[128];
      UEXACT32 rsvd0;
      UEXACT32 rsvd1;
      UEXACT32 rsvd2;
      UEXACT32 rsvd3;
   } SG_PACK FLASHDIR_HEADER_TYPE, *PFLASHDIR_HEADER_TYPE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Entry Type Definitions 
   typedef struct _FLASHDIR_ENTRY_TYPE {
      UEXACT32 entry_type;
      UEXACT32 offset;
      UEXACT32 max_size;
      UEXACT32 image_size;
      UEXACT32 entry_checksum;
      UEXACT32 entry_point;
      UEXACT32 future_use1;
      UEXACT32 future_use2;
      UEXACT8 version_data[32];
   } SG_PACK FLASHDIR_ENTRY_TYPE, *PFLASHDIR_ENTRY_TYPE;



#else
   // Entry Type Definitions 
   typedef struct _FLASHDIR_ENTRY_TYPE {
      UEXACT32 entry_type;
      UEXACT32 offset;
      UEXACT32 max_size;
      UEXACT32 image_size;
      UEXACT32 entry_checksum;
      UEXACT32 entry_point;
      UEXACT32 future_use1;
      UEXACT32 future_use2;
      UEXACT8 version_data[32];
   } SG_PACK FLASHDIR_ENTRY_TYPE, *PFLASHDIR_ENTRY_TYPE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Definition of the directory as a whole 
   typedef struct _FLASHDIR_TYPE {
      UEXACT8 flashdir_cookie[32];
      FLASHDIR_HEADER_TYPE flashdir_header;
      FLASHDIR_ENTRY_TYPE flashdir_entry[32];
   } SG_PACK FLASHDIR_TYPE, *PFLASHDIR_TYPE;



#else
   // Definition of the directory as a whole 
   typedef struct _FLASHDIR_TYPE {
      UEXACT8 flashdir_cookie[32];
      FLASHDIR_HEADER_TYPE flashdir_header;
      FLASHDIR_ENTRY_TYPE flashdir_entry[32];
   } SG_PACK FLASHDIR_TYPE, *PFLASHDIR_TYPE;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_flash_types_bmap_h__

