/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_tgt_bmap_h__
#define __ioctl_iscsi_tgt_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"
#include "ioctl_iscsi_target_discovery_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_ADD_IP_ADDR_PARAMS_IN {
         union {
            struct { 
               IP_ADDRESS_VLAN_FORMAT ip_addr_vlan;
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK TGT_ADD_IP_ADDR_PARAMS_IN, *PTGT_ADD_IP_ADDR_PARAMS_IN;

      SG_C_ASSERT(__sizeof__TGT_ADD_IP_ADDR_PARAMS_IN, sizeof (TGT_ADD_IP_ADDR_PARAMS_IN) == 44);

   #else
      typedef struct _TGT_ADD_IP_ADDR_PARAMS_IN {
         IP_ADDRESS_VLAN_FORMAT ip_addr_vlan;
      } SG_PACK TGT_ADD_IP_ADDR_PARAMS_IN, *PTGT_ADD_IP_ADDR_PARAMS_IN;

      typedef union _TGT_ADD_IP_ADDR_PARAMS_IN_UNION {
         TGT_ADD_IP_ADDR_PARAMS_IN bits;
         u32 dw[11]; // dword union
      } SG_PACK TGT_ADD_IP_ADDR_PARAMS_IN_UNION, *PTGT_ADD_IP_ADDR_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__TGT_ADD_IP_ADDR_PARAMS_IN_UNION, sizeof (TGT_ADD_IP_ADDR_PARAMS_IN_UNION) == 44);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_ADD_IP_ADDR_PARAMS_IN {
         union {
            struct { 
               IP_ADDRESS_VLAN_FORMAT ip_addr_vlan;
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK TGT_ADD_IP_ADDR_PARAMS_IN, *PTGT_ADD_IP_ADDR_PARAMS_IN;

      SG_C_ASSERT(__sizeof__TGT_ADD_IP_ADDR_PARAMS_IN, sizeof (TGT_ADD_IP_ADDR_PARAMS_IN) == 44);

   #else
      typedef struct _TGT_ADD_IP_ADDR_PARAMS_IN {
         IP_ADDRESS_VLAN_FORMAT ip_addr_vlan;
      } SG_PACK TGT_ADD_IP_ADDR_PARAMS_IN, *PTGT_ADD_IP_ADDR_PARAMS_IN;

      typedef union _TGT_ADD_IP_ADDR_PARAMS_IN_UNION {
         TGT_ADD_IP_ADDR_PARAMS_IN bits;
         u32 dw[11]; // dword union
      } SG_PACK TGT_ADD_IP_ADDR_PARAMS_IN_UNION, *PTGT_ADD_IP_ADDR_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__TGT_ADD_IP_ADDR_PARAMS_IN_UNION, sizeof (TGT_ADD_IP_ADDR_PARAMS_IN_UNION) == 44);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Use this IOCTL to set the IP address, subnet mask and any VLAN tags <break> This
   // IOCTL may return one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_INVALID_IPADDR - IP address format is invalid 
   typedef struct _IOCTL_ISCSI_TGT_ADD_IP_ADDR {
      IOCTL_HEADER header;
      TGT_ADD_IP_ADDR_PARAMS_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_ADD_IP_ADDR, *PIOCTL_ISCSI_TGT_ADD_IP_ADDR;



#else
   // Use this IOCTL to set the IP address, subnet mask and any VLAN tags <break> This
   // IOCTL may return one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_INVALID_IPADDR - IP address format is invalid 
   typedef struct _IOCTL_ISCSI_TGT_ADD_IP_ADDR {
      IOCTL_HEADER header;
      TGT_ADD_IP_ADDR_PARAMS_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_ADD_IP_ADDR, *PIOCTL_ISCSI_TGT_ADD_IP_ADDR;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_DELETE_IP_ADDR_PARAMS_IN {
         union {
            struct { 
               IP_ADDRESS_VLAN_FORMAT ip_addr_vlan;
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK TGT_DELETE_IP_ADDR_PARAMS_IN, *PTGT_DELETE_IP_ADDR_PARAMS_IN;

      SG_C_ASSERT(__sizeof__TGT_DELETE_IP_ADDR_PARAMS_IN, sizeof (TGT_DELETE_IP_ADDR_PARAMS_IN) == 44);

   #else
      typedef struct _TGT_DELETE_IP_ADDR_PARAMS_IN {
         IP_ADDRESS_VLAN_FORMAT ip_addr_vlan;
      } SG_PACK TGT_DELETE_IP_ADDR_PARAMS_IN, *PTGT_DELETE_IP_ADDR_PARAMS_IN;

      typedef union _TGT_DELETE_IP_ADDR_PARAMS_IN_UNION {
         TGT_DELETE_IP_ADDR_PARAMS_IN bits;
         u32 dw[11]; // dword union
      } SG_PACK TGT_DELETE_IP_ADDR_PARAMS_IN_UNION, *PTGT_DELETE_IP_ADDR_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__TGT_DELETE_IP_ADDR_PARAMS_IN_UNION, sizeof (TGT_DELETE_IP_ADDR_PARAMS_IN_UNION) == 44);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_DELETE_IP_ADDR_PARAMS_IN {
         union {
            struct { 
               IP_ADDRESS_VLAN_FORMAT ip_addr_vlan;
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK TGT_DELETE_IP_ADDR_PARAMS_IN, *PTGT_DELETE_IP_ADDR_PARAMS_IN;

      SG_C_ASSERT(__sizeof__TGT_DELETE_IP_ADDR_PARAMS_IN, sizeof (TGT_DELETE_IP_ADDR_PARAMS_IN) == 44);

   #else
      typedef struct _TGT_DELETE_IP_ADDR_PARAMS_IN {
         IP_ADDRESS_VLAN_FORMAT ip_addr_vlan;
      } SG_PACK TGT_DELETE_IP_ADDR_PARAMS_IN, *PTGT_DELETE_IP_ADDR_PARAMS_IN;

      typedef union _TGT_DELETE_IP_ADDR_PARAMS_IN_UNION {
         TGT_DELETE_IP_ADDR_PARAMS_IN bits;
         u32 dw[11]; // dword union
      } SG_PACK TGT_DELETE_IP_ADDR_PARAMS_IN_UNION, *PTGT_DELETE_IP_ADDR_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__TGT_DELETE_IP_ADDR_PARAMS_IN_UNION, sizeof (TGT_DELETE_IP_ADDR_PARAMS_IN_UNION) == 44);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Use this IOCTL to delete a previously set IP address <break> This IOCTL may return
   // one of the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_INVALID_IPADDR - No such IP address was added 
   typedef struct _IOCTL_ISCSI_TGT_DELETE_IP_ADDR {
      IOCTL_HEADER header;
      TGT_DELETE_IP_ADDR_PARAMS_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_DELETE_IP_ADDR, *PIOCTL_ISCSI_TGT_DELETE_IP_ADDR;



#else
   // Use this IOCTL to delete a previously set IP address <break> This IOCTL may return
   // one of the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_INVALID_IPADDR - No such IP address was added 
   typedef struct _IOCTL_ISCSI_TGT_DELETE_IP_ADDR {
      IOCTL_HEADER header;
      TGT_DELETE_IP_ADDR_PARAMS_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_DELETE_IP_ADDR, *PIOCTL_ISCSI_TGT_DELETE_IP_ADDR;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_LIST_IP_ADDR_PARAMS_OUT {
         union {
            struct { 
               UEXACT16 addr_count;
               UEXACT16 pad1;
               IP_ADDRESS_VLAN_FORMAT ip_addr_vlan[1];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS_OUT, *PTGT_LIST_IP_ADDR_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__TGT_LIST_IP_ADDR_PARAMS_OUT, sizeof (TGT_LIST_IP_ADDR_PARAMS_OUT) == 48);

   #else
      typedef struct _TGT_LIST_IP_ADDR_PARAMS_OUT {
         UEXACT16 addr_count;
         UEXACT16 pad1;
         IP_ADDRESS_VLAN_FORMAT ip_addr_vlan[1];
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS_OUT, *PTGT_LIST_IP_ADDR_PARAMS_OUT;

      typedef union _TGT_LIST_IP_ADDR_PARAMS_OUT_UNION {
         TGT_LIST_IP_ADDR_PARAMS_OUT bits;
         u32 dw[12]; // dword union
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS_OUT_UNION, *PTGT_LIST_IP_ADDR_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__TGT_LIST_IP_ADDR_PARAMS_OUT_UNION, sizeof (TGT_LIST_IP_ADDR_PARAMS_OUT_UNION) == 48);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_LIST_IP_ADDR_PARAMS_OUT {
         union {
            struct { 
               UEXACT16 addr_count;
               UEXACT16 pad1;
               IP_ADDRESS_VLAN_FORMAT ip_addr_vlan[1];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS_OUT, *PTGT_LIST_IP_ADDR_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__TGT_LIST_IP_ADDR_PARAMS_OUT, sizeof (TGT_LIST_IP_ADDR_PARAMS_OUT) == 48);

   #else
      typedef struct _TGT_LIST_IP_ADDR_PARAMS_OUT {
         UEXACT16 addr_count;
         UEXACT16 pad1;
         IP_ADDRESS_VLAN_FORMAT ip_addr_vlan[1];
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS_OUT, *PTGT_LIST_IP_ADDR_PARAMS_OUT;

      typedef union _TGT_LIST_IP_ADDR_PARAMS_OUT_UNION {
         TGT_LIST_IP_ADDR_PARAMS_OUT bits;
         u32 dw[12]; // dword union
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS_OUT_UNION, *PTGT_LIST_IP_ADDR_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__TGT_LIST_IP_ADDR_PARAMS_OUT_UNION, sizeof (TGT_LIST_IP_ADDR_PARAMS_OUT_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_LIST_IP_ADDR_PARAMS {
         union {
            union { 
               TGT_LIST_IP_ADDR_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS, *PTGT_LIST_IP_ADDR_PARAMS;

      SG_C_ASSERT(__sizeof__TGT_LIST_IP_ADDR_PARAMS, sizeof (TGT_LIST_IP_ADDR_PARAMS) == 48);

   #else
      typedef union _TGT_LIST_IP_ADDR_PARAMS {
         TGT_LIST_IP_ADDR_PARAMS_OUT response;
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS, *PTGT_LIST_IP_ADDR_PARAMS;

      typedef union _TGT_LIST_IP_ADDR_PARAMS_UNION {
         TGT_LIST_IP_ADDR_PARAMS bits;
         u32 dw[12]; // dword union
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS_UNION, *PTGT_LIST_IP_ADDR_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__TGT_LIST_IP_ADDR_PARAMS_UNION, sizeof (TGT_LIST_IP_ADDR_PARAMS_UNION) == 48);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TGT_LIST_IP_ADDR_PARAMS {
         union {
            union { 
               TGT_LIST_IP_ADDR_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS, *PTGT_LIST_IP_ADDR_PARAMS;

      SG_C_ASSERT(__sizeof__TGT_LIST_IP_ADDR_PARAMS, sizeof (TGT_LIST_IP_ADDR_PARAMS) == 48);

   #else
      typedef union _TGT_LIST_IP_ADDR_PARAMS {
         TGT_LIST_IP_ADDR_PARAMS_OUT response;
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS, *PTGT_LIST_IP_ADDR_PARAMS;

      typedef union _TGT_LIST_IP_ADDR_PARAMS_UNION {
         TGT_LIST_IP_ADDR_PARAMS bits;
         u32 dw[12]; // dword union
      } SG_PACK TGT_LIST_IP_ADDR_PARAMS_UNION, *PTGT_LIST_IP_ADDR_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__TGT_LIST_IP_ADDR_PARAMS_UNION, sizeof (TGT_LIST_IP_ADDR_PARAMS_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Use this IOCTL to retrieve a list of all IP addresses configured <break> This IOCTL
   // may return one of the following status values in the response  - MGMT_STATUS_SUCCESS
   typedef struct _IOCTL_ISCSI_TGT_LIST_IP_ADDR {
      IOCTL_HEADER header;
      TGT_LIST_IP_ADDR_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_LIST_IP_ADDR, *PIOCTL_ISCSI_TGT_LIST_IP_ADDR;



#else
   // Use this IOCTL to retrieve a list of all IP addresses configured <break> This IOCTL
   // may return one of the following status values in the response  - MGMT_STATUS_SUCCESS
   typedef struct _IOCTL_ISCSI_TGT_LIST_IP_ADDR {
      IOCTL_HEADER header;
      TGT_LIST_IP_ADDR_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_LIST_IP_ADDR, *PIOCTL_ISCSI_TGT_LIST_IP_ADDR;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONNECTION_INFO_PARAMS_IN {
         union {
            struct { 
               UEXACT32 connection_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CONNECTION_INFO_PARAMS_IN, *PGET_CONNECTION_INFO_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS_IN, sizeof (GET_CONNECTION_INFO_PARAMS_IN) == 4);

   #else
      typedef struct _GET_CONNECTION_INFO_PARAMS_IN {
         UEXACT32 connection_handle;
      } SG_PACK GET_CONNECTION_INFO_PARAMS_IN, *PGET_CONNECTION_INFO_PARAMS_IN;

      typedef union _GET_CONNECTION_INFO_PARAMS_IN_UNION {
         GET_CONNECTION_INFO_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_CONNECTION_INFO_PARAMS_IN_UNION, *PGET_CONNECTION_INFO_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS_IN_UNION, sizeof (GET_CONNECTION_INFO_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONNECTION_INFO_PARAMS_IN {
         union {
            struct { 
               UEXACT32 connection_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CONNECTION_INFO_PARAMS_IN, *PGET_CONNECTION_INFO_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS_IN, sizeof (GET_CONNECTION_INFO_PARAMS_IN) == 4);

   #else
      typedef struct _GET_CONNECTION_INFO_PARAMS_IN {
         UEXACT32 connection_handle;
      } SG_PACK GET_CONNECTION_INFO_PARAMS_IN, *PGET_CONNECTION_INFO_PARAMS_IN;

      typedef union _GET_CONNECTION_INFO_PARAMS_IN_UNION {
         GET_CONNECTION_INFO_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_CONNECTION_INFO_PARAMS_IN_UNION, *PGET_CONNECTION_INFO_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS_IN_UNION, sizeof (GET_CONNECTION_INFO_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONNECTION_INFO_PARAMS_OUT {
         union {
            struct { 
               IP_ADDRESS_FORMAT src_ip_addr;
               IP_ADDRESS_FORMAT dst_ip_addr;
               UEXACT16 src_port;
               UEXACT16 dst_port;
               UEXACT32 tcp_mss;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK GET_CONNECTION_INFO_PARAMS_OUT, *PGET_CONNECTION_INFO_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS_OUT, sizeof (GET_CONNECTION_INFO_PARAMS_OUT) == 56);

   #else
      typedef struct _GET_CONNECTION_INFO_PARAMS_OUT {
         IP_ADDRESS_FORMAT src_ip_addr;
         IP_ADDRESS_FORMAT dst_ip_addr;
         UEXACT16 src_port;
         UEXACT16 dst_port;
         UEXACT32 tcp_mss;
      } SG_PACK GET_CONNECTION_INFO_PARAMS_OUT, *PGET_CONNECTION_INFO_PARAMS_OUT;

      typedef union _GET_CONNECTION_INFO_PARAMS_OUT_UNION {
         GET_CONNECTION_INFO_PARAMS_OUT bits;
         u32 dw[14]; // dword union
      } SG_PACK GET_CONNECTION_INFO_PARAMS_OUT_UNION, *PGET_CONNECTION_INFO_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS_OUT_UNION, sizeof (GET_CONNECTION_INFO_PARAMS_OUT_UNION) == 56);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONNECTION_INFO_PARAMS_OUT {
         union {
            struct { 
               IP_ADDRESS_FORMAT src_ip_addr;
               IP_ADDRESS_FORMAT dst_ip_addr;
               UEXACT16 src_port;
               UEXACT16 dst_port;
               UEXACT32 tcp_mss;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK GET_CONNECTION_INFO_PARAMS_OUT, *PGET_CONNECTION_INFO_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS_OUT, sizeof (GET_CONNECTION_INFO_PARAMS_OUT) == 56);

   #else
      typedef struct _GET_CONNECTION_INFO_PARAMS_OUT {
         IP_ADDRESS_FORMAT src_ip_addr;
         IP_ADDRESS_FORMAT dst_ip_addr;
         UEXACT16 src_port;
         UEXACT16 dst_port;
         UEXACT32 tcp_mss;
      } SG_PACK GET_CONNECTION_INFO_PARAMS_OUT, *PGET_CONNECTION_INFO_PARAMS_OUT;

      typedef union _GET_CONNECTION_INFO_PARAMS_OUT_UNION {
         GET_CONNECTION_INFO_PARAMS_OUT bits;
         u32 dw[14]; // dword union
      } SG_PACK GET_CONNECTION_INFO_PARAMS_OUT_UNION, *PGET_CONNECTION_INFO_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS_OUT_UNION, sizeof (GET_CONNECTION_INFO_PARAMS_OUT_UNION) == 56);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONNECTION_INFO_PARAMS {
         union {
            union { 
               GET_CONNECTION_INFO_PARAMS_IN request;
               GET_CONNECTION_INFO_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK GET_CONNECTION_INFO_PARAMS, *PGET_CONNECTION_INFO_PARAMS;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS, sizeof (GET_CONNECTION_INFO_PARAMS) == 56);

   #else
      typedef union _GET_CONNECTION_INFO_PARAMS {
         GET_CONNECTION_INFO_PARAMS_IN request;
         GET_CONNECTION_INFO_PARAMS_OUT response;
      } SG_PACK GET_CONNECTION_INFO_PARAMS, *PGET_CONNECTION_INFO_PARAMS;

      typedef union _GET_CONNECTION_INFO_PARAMS_UNION {
         GET_CONNECTION_INFO_PARAMS bits;
         u32 dw[14]; // dword union
      } SG_PACK GET_CONNECTION_INFO_PARAMS_UNION, *PGET_CONNECTION_INFO_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS_UNION, sizeof (GET_CONNECTION_INFO_PARAMS_UNION) == 56);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONNECTION_INFO_PARAMS {
         union {
            union { 
               GET_CONNECTION_INFO_PARAMS_IN request;
               GET_CONNECTION_INFO_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK GET_CONNECTION_INFO_PARAMS, *PGET_CONNECTION_INFO_PARAMS;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS, sizeof (GET_CONNECTION_INFO_PARAMS) == 56);

   #else
      typedef union _GET_CONNECTION_INFO_PARAMS {
         GET_CONNECTION_INFO_PARAMS_IN request;
         GET_CONNECTION_INFO_PARAMS_OUT response;
      } SG_PACK GET_CONNECTION_INFO_PARAMS, *PGET_CONNECTION_INFO_PARAMS;

      typedef union _GET_CONNECTION_INFO_PARAMS_UNION {
         GET_CONNECTION_INFO_PARAMS bits;
         u32 dw[14]; // dword union
      } SG_PACK GET_CONNECTION_INFO_PARAMS_UNION, *PGET_CONNECTION_INFO_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_CONNECTION_INFO_PARAMS_UNION, sizeof (GET_CONNECTION_INFO_PARAMS_UNION) == 56);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The Target driver is expected to issue this IOCTL on receiving an
   // ASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED asynchronous message. <break> This IOCTL may
   // return one of the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_FAILED with additional status  -
   // MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE  - MGMT_ADDL_STATUS_CONN_RST - The ARM
   // firmware has received a TCP RST on this connection. The host driver must issue
   // IOCTL_ISCSI_TGT_CONNECTION_REJECT to release the socket before cleaning up the
   // related host structures. 
   typedef struct _IOCTL_ISCSI_TGT_GET_CONNECTION_INFO {
      IOCTL_HEADER header;
      GET_CONNECTION_INFO_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_GET_CONNECTION_INFO, *PIOCTL_ISCSI_TGT_GET_CONNECTION_INFO;



#else
   // The Target driver is expected to issue this IOCTL on receiving an
   // ASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED asynchronous message. <break> This IOCTL may
   // return one of the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_FAILED with additional status  -
   // MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE  - MGMT_ADDL_STATUS_CONN_RST - The ARM
   // firmware has received a TCP RST on this connection. The host driver must issue
   // IOCTL_ISCSI_TGT_CONNECTION_REJECT to release the socket before cleaning up the
   // related host structures. 
   typedef struct _IOCTL_ISCSI_TGT_GET_CONNECTION_INFO {
      IOCTL_HEADER header;
      GET_CONNECTION_INFO_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_GET_CONNECTION_INFO, *PIOCTL_ISCSI_TGT_GET_CONNECTION_INFO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _CONNECTION_REJECT_PARAMS_IN {
         union {
            struct { 
               UEXACT32 connection_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CONNECTION_REJECT_PARAMS_IN, *PCONNECTION_REJECT_PARAMS_IN;

      SG_C_ASSERT(__sizeof__CONNECTION_REJECT_PARAMS_IN, sizeof (CONNECTION_REJECT_PARAMS_IN) == 4);

   #else
      typedef struct _CONNECTION_REJECT_PARAMS_IN {
         UEXACT32 connection_handle;
      } SG_PACK CONNECTION_REJECT_PARAMS_IN, *PCONNECTION_REJECT_PARAMS_IN;

      typedef union _CONNECTION_REJECT_PARAMS_IN_UNION {
         CONNECTION_REJECT_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK CONNECTION_REJECT_PARAMS_IN_UNION, *PCONNECTION_REJECT_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__CONNECTION_REJECT_PARAMS_IN_UNION, sizeof (CONNECTION_REJECT_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _CONNECTION_REJECT_PARAMS_IN {
         union {
            struct { 
               UEXACT32 connection_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CONNECTION_REJECT_PARAMS_IN, *PCONNECTION_REJECT_PARAMS_IN;

      SG_C_ASSERT(__sizeof__CONNECTION_REJECT_PARAMS_IN, sizeof (CONNECTION_REJECT_PARAMS_IN) == 4);

   #else
      typedef struct _CONNECTION_REJECT_PARAMS_IN {
         UEXACT32 connection_handle;
      } SG_PACK CONNECTION_REJECT_PARAMS_IN, *PCONNECTION_REJECT_PARAMS_IN;

      typedef union _CONNECTION_REJECT_PARAMS_IN_UNION {
         CONNECTION_REJECT_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK CONNECTION_REJECT_PARAMS_IN_UNION, *PCONNECTION_REJECT_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__CONNECTION_REJECT_PARAMS_IN_UNION, sizeof (CONNECTION_REJECT_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _CONNECTION_REJECT_PARAMS {
         union {
            union { 
               CONNECTION_REJECT_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CONNECTION_REJECT_PARAMS, *PCONNECTION_REJECT_PARAMS;

      SG_C_ASSERT(__sizeof__CONNECTION_REJECT_PARAMS, sizeof (CONNECTION_REJECT_PARAMS) == 4);

   #else
      typedef union _CONNECTION_REJECT_PARAMS {
         CONNECTION_REJECT_PARAMS_IN request;
      } SG_PACK CONNECTION_REJECT_PARAMS, *PCONNECTION_REJECT_PARAMS;

      typedef union _CONNECTION_REJECT_PARAMS_UNION {
         CONNECTION_REJECT_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK CONNECTION_REJECT_PARAMS_UNION, *PCONNECTION_REJECT_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__CONNECTION_REJECT_PARAMS_UNION, sizeof (CONNECTION_REJECT_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _CONNECTION_REJECT_PARAMS {
         union {
            union { 
               CONNECTION_REJECT_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CONNECTION_REJECT_PARAMS, *PCONNECTION_REJECT_PARAMS;

      SG_C_ASSERT(__sizeof__CONNECTION_REJECT_PARAMS, sizeof (CONNECTION_REJECT_PARAMS) == 4);

   #else
      typedef union _CONNECTION_REJECT_PARAMS {
         CONNECTION_REJECT_PARAMS_IN request;
      } SG_PACK CONNECTION_REJECT_PARAMS, *PCONNECTION_REJECT_PARAMS;

      typedef union _CONNECTION_REJECT_PARAMS_UNION {
         CONNECTION_REJECT_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK CONNECTION_REJECT_PARAMS_UNION, *PCONNECTION_REJECT_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__CONNECTION_REJECT_PARAMS_UNION, sizeof (CONNECTION_REJECT_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Taget host drivers must use this IOCTL to inform the ARM firmware to close and free
   // the connection handle associated with this TCP connection whenever <break>  - The
   // host is unable to accept a cnxn (possibly because there are too many iSCSI
   // connections).  - A TCP RST was received on a connection before a the host driver
   // could accept/offload the connection In general, once a connection_handle is notified
   // to host driver, the ARM firmware will not free it (even after receiving a TCP RST)
   // till this IOCTL or IOCTL_ISCSI_TGT_OFFLOAD_CONNECTION is received. <break> This
   // IOCTL may return one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED with additional status
   // MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE 
   typedef struct _IOCTL_ISCSI_TGT_CONNECTION_REJECT {
      IOCTL_HEADER header;
      CONNECTION_REJECT_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_CONNECTION_REJECT, *PIOCTL_ISCSI_TGT_CONNECTION_REJECT;



#else
   // Taget host drivers must use this IOCTL to inform the ARM firmware to close and free
   // the connection handle associated with this TCP connection whenever <break>  - The
   // host is unable to accept a cnxn (possibly because there are too many iSCSI
   // connections).  - A TCP RST was received on a connection before a the host driver
   // could accept/offload the connection In general, once a connection_handle is notified
   // to host driver, the ARM firmware will not free it (even after receiving a TCP RST)
   // till this IOCTL or IOCTL_ISCSI_TGT_OFFLOAD_CONNECTION is received. <break> This
   // IOCTL may return one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED with additional status
   // MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE 
   typedef struct _IOCTL_ISCSI_TGT_CONNECTION_REJECT {
      IOCTL_HEADER header;
      CONNECTION_REJECT_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_CONNECTION_REJECT, *PIOCTL_ISCSI_TGT_CONNECTION_REJECT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOAD_CONNECTION_PARAMS_IN {
         union {
            struct { 
               UEXACT32 connection_handle;
               UEXACT16 cid;
               UEXACT16 cq_id;
               UEXACT8 hdr_ring_id;
               UEXACT8 data_ring_id;
               UEXACT16 chute;
               UEXACT32 tcp_window;
               PHYS_ADDR padd_buffer_pa;
               MGMT_TARGET_LOGIN_OPTIONS def_login_options;
            } SG_PACK ; // unnamed struct
            u32 dw[13]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOAD_CONNECTION_PARAMS_IN, *POFFLOAD_CONNECTION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__OFFLOAD_CONNECTION_PARAMS_IN, sizeof (OFFLOAD_CONNECTION_PARAMS_IN) == 52);

   #else
      typedef struct _OFFLOAD_CONNECTION_PARAMS_IN {
         UEXACT32 connection_handle;
         UEXACT16 cid;
         UEXACT16 cq_id;
         UEXACT8 hdr_ring_id;
         UEXACT8 data_ring_id;
         UEXACT16 chute;
         UEXACT32 tcp_window;
         PHYS_ADDR padd_buffer_pa;
         MGMT_TARGET_LOGIN_OPTIONS def_login_options;
      } SG_PACK OFFLOAD_CONNECTION_PARAMS_IN, *POFFLOAD_CONNECTION_PARAMS_IN;

      typedef union _OFFLOAD_CONNECTION_PARAMS_IN_UNION {
         OFFLOAD_CONNECTION_PARAMS_IN bits;
         u32 dw[13]; // dword union
      } SG_PACK OFFLOAD_CONNECTION_PARAMS_IN_UNION, *POFFLOAD_CONNECTION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__OFFLOAD_CONNECTION_PARAMS_IN_UNION, sizeof (OFFLOAD_CONNECTION_PARAMS_IN_UNION) == 52);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOAD_CONNECTION_PARAMS_IN {
         union {
            struct { 
               UEXACT32 connection_handle;
               UEXACT16 cid;
               UEXACT16 cq_id;
               UEXACT8 hdr_ring_id;
               UEXACT8 data_ring_id;
               UEXACT16 chute;
               UEXACT32 tcp_window;
               PHYS_ADDR padd_buffer_pa;
               MGMT_TARGET_LOGIN_OPTIONS def_login_options;
            } SG_PACK ; // unnamed struct
            u32 dw[13]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOAD_CONNECTION_PARAMS_IN, *POFFLOAD_CONNECTION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__OFFLOAD_CONNECTION_PARAMS_IN, sizeof (OFFLOAD_CONNECTION_PARAMS_IN) == 52);

   #else
      typedef struct _OFFLOAD_CONNECTION_PARAMS_IN {
         UEXACT32 connection_handle;
         UEXACT16 cid;
         UEXACT16 cq_id;
         UEXACT8 hdr_ring_id;
         UEXACT8 data_ring_id;
         UEXACT16 chute;
         UEXACT32 tcp_window;
         PHYS_ADDR padd_buffer_pa;
         MGMT_TARGET_LOGIN_OPTIONS def_login_options;
      } SG_PACK OFFLOAD_CONNECTION_PARAMS_IN, *POFFLOAD_CONNECTION_PARAMS_IN;

      typedef union _OFFLOAD_CONNECTION_PARAMS_IN_UNION {
         OFFLOAD_CONNECTION_PARAMS_IN bits;
         u32 dw[13]; // dword union
      } SG_PACK OFFLOAD_CONNECTION_PARAMS_IN_UNION, *POFFLOAD_CONNECTION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__OFFLOAD_CONNECTION_PARAMS_IN_UNION, sizeof (OFFLOAD_CONNECTION_PARAMS_IN_UNION) == 52);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOAD_CONNECTION_PARAMS {
         union {
            union { 
               OFFLOAD_CONNECTION_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[13]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOAD_CONNECTION_PARAMS, *POFFLOAD_CONNECTION_PARAMS;

      SG_C_ASSERT(__sizeof__OFFLOAD_CONNECTION_PARAMS, sizeof (OFFLOAD_CONNECTION_PARAMS) == 52);

   #else
      typedef union _OFFLOAD_CONNECTION_PARAMS {
         OFFLOAD_CONNECTION_PARAMS_IN request;
      } SG_PACK OFFLOAD_CONNECTION_PARAMS, *POFFLOAD_CONNECTION_PARAMS;

      typedef union _OFFLOAD_CONNECTION_PARAMS_UNION {
         OFFLOAD_CONNECTION_PARAMS bits;
         u32 dw[13]; // dword union
      } SG_PACK OFFLOAD_CONNECTION_PARAMS_UNION, *POFFLOAD_CONNECTION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__OFFLOAD_CONNECTION_PARAMS_UNION, sizeof (OFFLOAD_CONNECTION_PARAMS_UNION) == 52);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOAD_CONNECTION_PARAMS {
         union {
            union { 
               OFFLOAD_CONNECTION_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[13]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOAD_CONNECTION_PARAMS, *POFFLOAD_CONNECTION_PARAMS;

      SG_C_ASSERT(__sizeof__OFFLOAD_CONNECTION_PARAMS, sizeof (OFFLOAD_CONNECTION_PARAMS) == 52);

   #else
      typedef union _OFFLOAD_CONNECTION_PARAMS {
         OFFLOAD_CONNECTION_PARAMS_IN request;
      } SG_PACK OFFLOAD_CONNECTION_PARAMS, *POFFLOAD_CONNECTION_PARAMS;

      typedef union _OFFLOAD_CONNECTION_PARAMS_UNION {
         OFFLOAD_CONNECTION_PARAMS bits;
         u32 dw[13]; // dword union
      } SG_PACK OFFLOAD_CONNECTION_PARAMS_UNION, *POFFLOAD_CONNECTION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__OFFLOAD_CONNECTION_PARAMS_UNION, sizeof (OFFLOAD_CONNECTION_PARAMS_UNION) == 52);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The Target driver issues this IOCTL after retrieving connection-specific information
   // using IOCTL_ISCSI_TGT_GET_CONNECTION_INFO This call forces the ARM firmware to - <ul
   //  - Offloads the TCP connection context  - Programs default iSCSI parameters  - Sets
   // the CAM valid bit  - Sends a TCP window update (from NIC path) After the TCP windows
   // update is sent, the host driver should expect an iSCSI login PDU to be notified
   // possibly before the completion of this IOCTL. <break> This IOCTL may return one of
   // the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_FAILED with additional status  -
   // MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE  - MGMT_ADDL_STATUS_TGT_INVALID_CQID  -
   // MGMT_ADDL_STATUS_TGT_INVALID_CID  - MGMT_ADDL_STATUS_TGT_INVALID_CHUTE 
   typedef struct _IOCTL_ISCSI_TGT_OFFLOAD_CONNECTION {
      IOCTL_HEADER header;
      OFFLOAD_CONNECTION_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_OFFLOAD_CONNECTION, *PIOCTL_ISCSI_TGT_OFFLOAD_CONNECTION;



#else
   // The Target driver issues this IOCTL after retrieving connection-specific information
   // using IOCTL_ISCSI_TGT_GET_CONNECTION_INFO This call forces the ARM firmware to - <ul
   //  - Offloads the TCP connection context  - Programs default iSCSI parameters  - Sets
   // the CAM valid bit  - Sends a TCP window update (from NIC path) After the TCP windows
   // update is sent, the host driver should expect an iSCSI login PDU to be notified
   // possibly before the completion of this IOCTL. <break> This IOCTL may return one of
   // the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_FAILED with additional status  -
   // MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE  - MGMT_ADDL_STATUS_TGT_INVALID_CQID  -
   // MGMT_ADDL_STATUS_TGT_INVALID_CID  - MGMT_ADDL_STATUS_TGT_INVALID_CHUTE 
   typedef struct _IOCTL_ISCSI_TGT_OFFLOAD_CONNECTION {
      IOCTL_HEADER header;
      OFFLOAD_CONNECTION_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_OFFLOAD_CONNECTION, *PIOCTL_ISCSI_TGT_OFFLOAD_CONNECTION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _START_LISTEN_SERVER_IN {
         union {
            struct { 
               IP_ADDRESS_FORMAT server_ip;
               UEXACT32 tcp_port;
               UEXACT32 portal_key;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK START_LISTEN_SERVER_IN, *PSTART_LISTEN_SERVER_IN;

      SG_C_ASSERT(__sizeof__START_LISTEN_SERVER_IN, sizeof (START_LISTEN_SERVER_IN) == 32);

   #else
      typedef struct _START_LISTEN_SERVER_IN {
         IP_ADDRESS_FORMAT server_ip;
         UEXACT32 tcp_port;
         UEXACT32 portal_key;
      } SG_PACK START_LISTEN_SERVER_IN, *PSTART_LISTEN_SERVER_IN;

      typedef union _START_LISTEN_SERVER_IN_UNION {
         START_LISTEN_SERVER_IN bits;
         u32 dw[8]; // dword union
      } SG_PACK START_LISTEN_SERVER_IN_UNION, *PSTART_LISTEN_SERVER_IN_UNION;

      SG_C_ASSERT(__sizeof__START_LISTEN_SERVER_IN_UNION, sizeof (START_LISTEN_SERVER_IN_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _START_LISTEN_SERVER_IN {
         union {
            struct { 
               IP_ADDRESS_FORMAT server_ip;
               UEXACT32 tcp_port;
               UEXACT32 portal_key;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK START_LISTEN_SERVER_IN, *PSTART_LISTEN_SERVER_IN;

      SG_C_ASSERT(__sizeof__START_LISTEN_SERVER_IN, sizeof (START_LISTEN_SERVER_IN) == 32);

   #else
      typedef struct _START_LISTEN_SERVER_IN {
         IP_ADDRESS_FORMAT server_ip;
         UEXACT32 tcp_port;
         UEXACT32 portal_key;
      } SG_PACK START_LISTEN_SERVER_IN, *PSTART_LISTEN_SERVER_IN;

      typedef union _START_LISTEN_SERVER_IN_UNION {
         START_LISTEN_SERVER_IN bits;
         u32 dw[8]; // dword union
      } SG_PACK START_LISTEN_SERVER_IN_UNION, *PSTART_LISTEN_SERVER_IN_UNION;

      SG_C_ASSERT(__sizeof__START_LISTEN_SERVER_IN_UNION, sizeof (START_LISTEN_SERVER_IN_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Request the ARM firmware to start a listen server at the specific IP address and TCP
   // port. iSCSI Initiators are expected to open a TCP connection to this port. An
   // asynchronous notification will be issued to the host target driver whenever a new
   // connection is accepted. <break> This IOCTL may return one of the following status
   // values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_INVALID_TARGET_IPADDR -
   // This IP address is not configured. This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_ISCSI_TGT_START_LISTEN_SERVER {
      IOCTL_HEADER header;
      START_LISTEN_SERVER_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_START_LISTEN_SERVER, *PIOCTL_ISCSI_TGT_START_LISTEN_SERVER;



#else
   // Request the ARM firmware to start a listen server at the specific IP address and TCP
   // port. iSCSI Initiators are expected to open a TCP connection to this port. An
   // asynchronous notification will be issued to the host target driver whenever a new
   // connection is accepted. <break> This IOCTL may return one of the following status
   // values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_INVALID_TARGET_IPADDR -
   // This IP address is not configured. This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_ISCSI_TGT_START_LISTEN_SERVER {
      IOCTL_HEADER header;
      START_LISTEN_SERVER_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_START_LISTEN_SERVER, *PIOCTL_ISCSI_TGT_START_LISTEN_SERVER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _STOP_LISTEN_SERVER_IN {
         union {
            struct { 
               IP_ADDRESS_FORMAT server_ip;
               UEXACT32 tcp_port;
               UEXACT32 portal_key;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK STOP_LISTEN_SERVER_IN, *PSTOP_LISTEN_SERVER_IN;

      SG_C_ASSERT(__sizeof__STOP_LISTEN_SERVER_IN, sizeof (STOP_LISTEN_SERVER_IN) == 32);

   #else
      typedef struct _STOP_LISTEN_SERVER_IN {
         IP_ADDRESS_FORMAT server_ip;
         UEXACT32 tcp_port;
         UEXACT32 portal_key;
      } SG_PACK STOP_LISTEN_SERVER_IN, *PSTOP_LISTEN_SERVER_IN;

      typedef union _STOP_LISTEN_SERVER_IN_UNION {
         STOP_LISTEN_SERVER_IN bits;
         u32 dw[8]; // dword union
      } SG_PACK STOP_LISTEN_SERVER_IN_UNION, *PSTOP_LISTEN_SERVER_IN_UNION;

      SG_C_ASSERT(__sizeof__STOP_LISTEN_SERVER_IN_UNION, sizeof (STOP_LISTEN_SERVER_IN_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _STOP_LISTEN_SERVER_IN {
         union {
            struct { 
               IP_ADDRESS_FORMAT server_ip;
               UEXACT32 tcp_port;
               UEXACT32 portal_key;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK STOP_LISTEN_SERVER_IN, *PSTOP_LISTEN_SERVER_IN;

      SG_C_ASSERT(__sizeof__STOP_LISTEN_SERVER_IN, sizeof (STOP_LISTEN_SERVER_IN) == 32);

   #else
      typedef struct _STOP_LISTEN_SERVER_IN {
         IP_ADDRESS_FORMAT server_ip;
         UEXACT32 tcp_port;
         UEXACT32 portal_key;
      } SG_PACK STOP_LISTEN_SERVER_IN, *PSTOP_LISTEN_SERVER_IN;

      typedef union _STOP_LISTEN_SERVER_IN_UNION {
         STOP_LISTEN_SERVER_IN bits;
         u32 dw[8]; // dword union
      } SG_PACK STOP_LISTEN_SERVER_IN_UNION, *PSTOP_LISTEN_SERVER_IN_UNION;

      SG_C_ASSERT(__sizeof__STOP_LISTEN_SERVER_IN_UNION, sizeof (STOP_LISTEN_SERVER_IN_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Stops a listen server started on the specified IP address and port number using
   // IOCTL_ISCSI_TGT_START_LISTEN_SERVER. <break> This IOCTL may return one of the
   // following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_INVALID_TARGET_IPADDR - No listen server was started on this IP
   // address/port  - MGMT_STATUS_INVALID_TCPPORT - No listen server was started on this
   // port This IOCTL returns one of the following additional status values in the
   // response  - <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_ISCSI_TGT_STOP_LISTEN_SERVER {
      IOCTL_HEADER header;
      STOP_LISTEN_SERVER_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_STOP_LISTEN_SERVER, *PIOCTL_ISCSI_TGT_STOP_LISTEN_SERVER;



#else
   // Stops a listen server started on the specified IP address and port number using
   // IOCTL_ISCSI_TGT_START_LISTEN_SERVER. <break> This IOCTL may return one of the
   // following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_INVALID_TARGET_IPADDR - No listen server was started on this IP
   // address/port  - MGMT_STATUS_INVALID_TCPPORT - No listen server was started on this
   // port This IOCTL returns one of the following additional status values in the
   // response  - <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_ISCSI_TGT_STOP_LISTEN_SERVER {
      IOCTL_HEADER header;
      STOP_LISTEN_SERVER_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_STOP_LISTEN_SERVER, *PIOCTL_ISCSI_TGT_STOP_LISTEN_SERVER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _REGISTER_SLP_TARGET_IN {
         union {
            struct { 
               UEXACT8 target_name[224];
               IP_ADDRESS_FORMAT target_ip;
               UEXACT32 target_port;
            } SG_PACK ; // unnamed struct
            u32 dw[63]; // dword union
         }; // unnamed union
      } SG_PACK REGISTER_SLP_TARGET_IN, *PREGISTER_SLP_TARGET_IN;

      SG_C_ASSERT(__sizeof__REGISTER_SLP_TARGET_IN, sizeof (REGISTER_SLP_TARGET_IN) == 252);

   #else
      typedef struct _REGISTER_SLP_TARGET_IN {
         UEXACT8 target_name[224];
         IP_ADDRESS_FORMAT target_ip;
         UEXACT32 target_port;
      } SG_PACK REGISTER_SLP_TARGET_IN, *PREGISTER_SLP_TARGET_IN;

      typedef union _REGISTER_SLP_TARGET_IN_UNION {
         REGISTER_SLP_TARGET_IN bits;
         u32 dw[63]; // dword union
      } SG_PACK REGISTER_SLP_TARGET_IN_UNION, *PREGISTER_SLP_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__REGISTER_SLP_TARGET_IN_UNION, sizeof (REGISTER_SLP_TARGET_IN_UNION) == 252);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _REGISTER_SLP_TARGET_IN {
         union {
            struct { 
               UEXACT8 target_name[224];
               IP_ADDRESS_FORMAT target_ip;
               UEXACT32 target_port;
            } SG_PACK ; // unnamed struct
            u32 dw[63]; // dword union
         }; // unnamed union
      } SG_PACK REGISTER_SLP_TARGET_IN, *PREGISTER_SLP_TARGET_IN;

      SG_C_ASSERT(__sizeof__REGISTER_SLP_TARGET_IN, sizeof (REGISTER_SLP_TARGET_IN) == 252);

   #else
      typedef struct _REGISTER_SLP_TARGET_IN {
         UEXACT8 target_name[224];
         IP_ADDRESS_FORMAT target_ip;
         UEXACT32 target_port;
      } SG_PACK REGISTER_SLP_TARGET_IN, *PREGISTER_SLP_TARGET_IN;

      typedef union _REGISTER_SLP_TARGET_IN_UNION {
         REGISTER_SLP_TARGET_IN bits;
         u32 dw[63]; // dword union
      } SG_PACK REGISTER_SLP_TARGET_IN_UNION, *PREGISTER_SLP_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__REGISTER_SLP_TARGET_IN_UNION, sizeof (REGISTER_SLP_TARGET_IN_UNION) == 252);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Request the ARM firmware to register the target with the SLP(Service Location
   // Protocol) SA (Service Agent) running inside the ARM. Initiators can query for this
   // target using Findsrvs option in SLP UA (User Agent). <break> This IOCTL may return
   // one of the following status values in the response  - MGMT_STATUS_SUCCESS 
   typedef struct _IOCTL_ISCSI_TGT_SLP_REGISTER {
      IOCTL_HEADER header;
      REGISTER_SLP_TARGET_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_SLP_REGISTER, *PIOCTL_ISCSI_TGT_SLP_REGISTER;



#else
   // Request the ARM firmware to register the target with the SLP(Service Location
   // Protocol) SA (Service Agent) running inside the ARM. Initiators can query for this
   // target using Findsrvs option in SLP UA (User Agent). <break> This IOCTL may return
   // one of the following status values in the response  - MGMT_STATUS_SUCCESS 
   typedef struct _IOCTL_ISCSI_TGT_SLP_REGISTER {
      IOCTL_HEADER header;
      REGISTER_SLP_TARGET_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_SLP_REGISTER, *PIOCTL_ISCSI_TGT_SLP_REGISTER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DEREGISTER_SLP_TARGET_IN {
         union {
            struct { 
               UEXACT8 target_name[224];
               IP_ADDRESS_FORMAT target_ip;
               UEXACT32 target_port;
            } SG_PACK ; // unnamed struct
            u32 dw[63]; // dword union
         }; // unnamed union
      } SG_PACK DEREGISTER_SLP_TARGET_IN, *PDEREGISTER_SLP_TARGET_IN;

      SG_C_ASSERT(__sizeof__DEREGISTER_SLP_TARGET_IN, sizeof (DEREGISTER_SLP_TARGET_IN) == 252);

   #else
      typedef struct _DEREGISTER_SLP_TARGET_IN {
         UEXACT8 target_name[224];
         IP_ADDRESS_FORMAT target_ip;
         UEXACT32 target_port;
      } SG_PACK DEREGISTER_SLP_TARGET_IN, *PDEREGISTER_SLP_TARGET_IN;

      typedef union _DEREGISTER_SLP_TARGET_IN_UNION {
         DEREGISTER_SLP_TARGET_IN bits;
         u32 dw[63]; // dword union
      } SG_PACK DEREGISTER_SLP_TARGET_IN_UNION, *PDEREGISTER_SLP_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__DEREGISTER_SLP_TARGET_IN_UNION, sizeof (DEREGISTER_SLP_TARGET_IN_UNION) == 252);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DEREGISTER_SLP_TARGET_IN {
         union {
            struct { 
               UEXACT8 target_name[224];
               IP_ADDRESS_FORMAT target_ip;
               UEXACT32 target_port;
            } SG_PACK ; // unnamed struct
            u32 dw[63]; // dword union
         }; // unnamed union
      } SG_PACK DEREGISTER_SLP_TARGET_IN, *PDEREGISTER_SLP_TARGET_IN;

      SG_C_ASSERT(__sizeof__DEREGISTER_SLP_TARGET_IN, sizeof (DEREGISTER_SLP_TARGET_IN) == 252);

   #else
      typedef struct _DEREGISTER_SLP_TARGET_IN {
         UEXACT8 target_name[224];
         IP_ADDRESS_FORMAT target_ip;
         UEXACT32 target_port;
      } SG_PACK DEREGISTER_SLP_TARGET_IN, *PDEREGISTER_SLP_TARGET_IN;

      typedef union _DEREGISTER_SLP_TARGET_IN_UNION {
         DEREGISTER_SLP_TARGET_IN bits;
         u32 dw[63]; // dword union
      } SG_PACK DEREGISTER_SLP_TARGET_IN_UNION, *PDEREGISTER_SLP_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__DEREGISTER_SLP_TARGET_IN_UNION, sizeof (DEREGISTER_SLP_TARGET_IN_UNION) == 252);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Request the ARM firmware to de-register the target with the SLP(Service Location
   // Protocol) SA(Service Agent) running inside the ARM. <break> This IOCTL may return
   // one of the following status values in the response  - MGMT_STATUS_SUCCESS 
   typedef struct _IOCTL_ISCSI_TGT_SLP_DEREGISTER {
      IOCTL_HEADER header;
      DEREGISTER_SLP_TARGET_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_SLP_DEREGISTER, *PIOCTL_ISCSI_TGT_SLP_DEREGISTER;



#else
   // Request the ARM firmware to de-register the target with the SLP(Service Location
   // Protocol) SA(Service Agent) running inside the ARM. <break> This IOCTL may return
   // one of the following status values in the response  - MGMT_STATUS_SUCCESS 
   typedef struct _IOCTL_ISCSI_TGT_SLP_DEREGISTER {
      IOCTL_HEADER header;
      DEREGISTER_SLP_TARGET_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_SLP_DEREGISTER, *PIOCTL_ISCSI_TGT_SLP_DEREGISTER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_TGT_CONNECTION_PARAMS_IN {
         union {
            struct { 
               UEXACT32 connection_handle;
               UEXACT16 cid;
               UEXACT16 cleanup_type;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_IN, *PINVALIDATE_TGT_CONNECTION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__INVALIDATE_TGT_CONNECTION_PARAMS_IN, sizeof (INVALIDATE_TGT_CONNECTION_PARAMS_IN) == 8);

   #else
      typedef struct _INVALIDATE_TGT_CONNECTION_PARAMS_IN {
         UEXACT32 connection_handle;
         UEXACT16 cid;
         UEXACT16 cleanup_type;
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_IN, *PINVALIDATE_TGT_CONNECTION_PARAMS_IN;

      typedef union _INVALIDATE_TGT_CONNECTION_PARAMS_IN_UNION {
         INVALIDATE_TGT_CONNECTION_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_IN_UNION, *PINVALIDATE_TGT_CONNECTION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_TGT_CONNECTION_PARAMS_IN_UNION, sizeof (INVALIDATE_TGT_CONNECTION_PARAMS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_TGT_CONNECTION_PARAMS_IN {
         union {
            struct { 
               UEXACT32 connection_handle;
               UEXACT16 cid;
               UEXACT16 cleanup_type;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_IN, *PINVALIDATE_TGT_CONNECTION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__INVALIDATE_TGT_CONNECTION_PARAMS_IN, sizeof (INVALIDATE_TGT_CONNECTION_PARAMS_IN) == 8);

   #else
      typedef struct _INVALIDATE_TGT_CONNECTION_PARAMS_IN {
         UEXACT32 connection_handle;
         UEXACT16 cid;
         UEXACT16 cleanup_type;
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_IN, *PINVALIDATE_TGT_CONNECTION_PARAMS_IN;

      typedef union _INVALIDATE_TGT_CONNECTION_PARAMS_IN_UNION {
         INVALIDATE_TGT_CONNECTION_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_IN_UNION, *PINVALIDATE_TGT_CONNECTION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_TGT_CONNECTION_PARAMS_IN_UNION, sizeof (INVALIDATE_TGT_CONNECTION_PARAMS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_TGT_CONNECTION_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 connection_handle;
               UEXACT16 cid;
               UEXACT16 unused;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_OUT, *PINVALIDATE_TGT_CONNECTION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__INVALIDATE_TGT_CONNECTION_PARAMS_OUT, sizeof (INVALIDATE_TGT_CONNECTION_PARAMS_OUT) == 8);

   #else
      typedef struct _INVALIDATE_TGT_CONNECTION_PARAMS_OUT {
         UEXACT32 connection_handle;
         UEXACT16 cid;
         UEXACT16 unused;
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_OUT, *PINVALIDATE_TGT_CONNECTION_PARAMS_OUT;

      typedef union _INVALIDATE_TGT_CONNECTION_PARAMS_OUT_UNION {
         INVALIDATE_TGT_CONNECTION_PARAMS_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_OUT_UNION, *PINVALIDATE_TGT_CONNECTION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_TGT_CONNECTION_PARAMS_OUT_UNION, sizeof (INVALIDATE_TGT_CONNECTION_PARAMS_OUT_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_TGT_CONNECTION_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 connection_handle;
               UEXACT16 cid;
               UEXACT16 unused;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_OUT, *PINVALIDATE_TGT_CONNECTION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__INVALIDATE_TGT_CONNECTION_PARAMS_OUT, sizeof (INVALIDATE_TGT_CONNECTION_PARAMS_OUT) == 8);

   #else
      typedef struct _INVALIDATE_TGT_CONNECTION_PARAMS_OUT {
         UEXACT32 connection_handle;
         UEXACT16 cid;
         UEXACT16 unused;
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_OUT, *PINVALIDATE_TGT_CONNECTION_PARAMS_OUT;

      typedef union _INVALIDATE_TGT_CONNECTION_PARAMS_OUT_UNION {
         INVALIDATE_TGT_CONNECTION_PARAMS_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK INVALIDATE_TGT_CONNECTION_PARAMS_OUT_UNION, *PINVALIDATE_TGT_CONNECTION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_TGT_CONNECTION_PARAMS_OUT_UNION, sizeof (INVALIDATE_TGT_CONNECTION_PARAMS_OUT_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS {
         union {
            union { 
               INVALIDATE_TGT_CONNECTION_PARAMS_IN request;
               INVALIDATE_TGT_CONNECTION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS, *PIOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS, sizeof (IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS) == 8);

   #else
      typedef union _IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS {
         INVALIDATE_TGT_CONNECTION_PARAMS_IN request;
         INVALIDATE_TGT_CONNECTION_PARAMS_OUT response;
      } SG_PACK IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS, *PIOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS;

      typedef union _IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_UNION {
         IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_UNION, *PIOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_UNION, sizeof (IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS {
         union {
            union { 
               INVALIDATE_TGT_CONNECTION_PARAMS_IN request;
               INVALIDATE_TGT_CONNECTION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS, *PIOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS, sizeof (IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS) == 8);

   #else
      typedef union _IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS {
         INVALIDATE_TGT_CONNECTION_PARAMS_IN request;
         INVALIDATE_TGT_CONNECTION_PARAMS_OUT response;
      } SG_PACK IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS, *PIOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS;

      typedef union _IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_UNION {
         IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_UNION, *PIOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_UNION, sizeof (IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The target driver should use this command to invalidate a connection and optionally
   // send a TCP RST before terminating the connection and releasing all I/O requests and
   // other resources. The ARM firmware forwards this request to the EP firmware. The EP
   // firmware will clean up its internal data structures and issue a TCP reset if
   // IOCTL_ISCSI_CONNECTION_ISSUE_TCP_RST is set. <break> This IOCTL may return one of
   // the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_FAILED with additional status  -
   // MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE  - MGMT_ADDL_STATUS_TGT_INVALID_CID 
   typedef struct _IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION {
      IOCTL_HEADER header;
      IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION, *PIOCTL_ISCSI_TGT_INVALIDATE_CONNECTION;



#else
   // The target driver should use this command to invalidate a connection and optionally
   // send a TCP RST before terminating the connection and releasing all I/O requests and
   // other resources. The ARM firmware forwards this request to the EP firmware. The EP
   // firmware will clean up its internal data structures and issue a TCP reset if
   // IOCTL_ISCSI_CONNECTION_ISSUE_TCP_RST is set. <break> This IOCTL may return one of
   // the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_FAILED with additional status  -
   // MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE  - MGMT_ADDL_STATUS_TGT_INVALID_CID 
   typedef struct _IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION {
      IOCTL_HEADER header;
      IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION, *PIOCTL_ISCSI_TGT_INVALIDATE_CONNECTION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_CONN_QOS_PARAMS_IN {
         union {
            struct { 
               UEXACT16 cid;
               UEXACT16 QoS_category;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_CONN_QOS_PARAMS_IN, *PSET_CONN_QOS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_CONN_QOS_PARAMS_IN, sizeof (SET_CONN_QOS_PARAMS_IN) == 4);

   #else
      typedef struct _SET_CONN_QOS_PARAMS_IN {
         UEXACT16 cid;
         UEXACT16 QoS_category;
      } SG_PACK SET_CONN_QOS_PARAMS_IN, *PSET_CONN_QOS_PARAMS_IN;

      typedef union _SET_CONN_QOS_PARAMS_IN_UNION {
         SET_CONN_QOS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK SET_CONN_QOS_PARAMS_IN_UNION, *PSET_CONN_QOS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_CONN_QOS_PARAMS_IN_UNION, sizeof (SET_CONN_QOS_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_CONN_QOS_PARAMS_IN {
         union {
            struct { 
               UEXACT16 cid;
               UEXACT16 QoS_category;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_CONN_QOS_PARAMS_IN, *PSET_CONN_QOS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_CONN_QOS_PARAMS_IN, sizeof (SET_CONN_QOS_PARAMS_IN) == 4);

   #else
      typedef struct _SET_CONN_QOS_PARAMS_IN {
         UEXACT16 cid;
         UEXACT16 QoS_category;
      } SG_PACK SET_CONN_QOS_PARAMS_IN, *PSET_CONN_QOS_PARAMS_IN;

      typedef union _SET_CONN_QOS_PARAMS_IN_UNION {
         SET_CONN_QOS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK SET_CONN_QOS_PARAMS_IN_UNION, *PSET_CONN_QOS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_CONN_QOS_PARAMS_IN_UNION, sizeof (SET_CONN_QOS_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Use this IOCTL to set the QoS category for an offloaded iSCSI connection. <break>
   // This IOCTL will return MGMT_STATUS_SUCCESS 
   typedef struct _IOCTL_ISCSI_TGT_SET_CONN_QOS {
      IOCTL_HEADER header;
      SET_CONN_QOS_PARAMS_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_SET_CONN_QOS, *PIOCTL_ISCSI_TGT_SET_CONN_QOS;



#else
   // Use this IOCTL to set the QoS category for an offloaded iSCSI connection. <break>
   // This IOCTL will return MGMT_STATUS_SUCCESS 
   typedef struct _IOCTL_ISCSI_TGT_SET_CONN_QOS {
      IOCTL_HEADER header;
      SET_CONN_QOS_PARAMS_IN request;
   } SG_PACK IOCTL_ISCSI_TGT_SET_CONN_QOS, *PIOCTL_ISCSI_TGT_SET_CONN_QOS;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_tgt_bmap_h__

