/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_lowlevel_bmap_h__
#define __ioctl_lowlevel_bmap_h__
#include "setypes.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_common_bmap.h"
#include "host_struct_bmap.h"
#include "ioctl_toe_bmap.h"
#include "ep_queue_bmap.h"
#include "fc_device_context_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Reads or writes a range of directory table entries. 
   typedef struct _IOCTL_LOWLEVEL_CONFIG_DT_ENTRY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 dt_index;
            UEXACT8 write;
            UEXACT8 rsvd0;
            PHYS_ADDR pa;
         } request;
         struct {
            UEXACT32 rsvd0;
            PHYS_ADDR pa;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_CONFIG_DT_ENTRY, *PIOCTL_LOWLEVEL_CONFIG_DT_ENTRY;



#else
   // Reads or writes a range of directory table entries. 
   typedef struct _IOCTL_LOWLEVEL_CONFIG_DT_ENTRY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 dt_index;
            UEXACT8 write;
            UEXACT8 rsvd0;
            PHYS_ADDR pa;
         } request;
         struct {
            UEXACT32 rsvd0;
            PHYS_ADDR pa;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_CONFIG_DT_ENTRY, *PIOCTL_LOWLEVEL_CONFIG_DT_ENTRY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Invalidates a page table entry. 
   typedef struct _IOCTL_LOWLEVEL_INVALIDATE_PT_ENTRY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 cra;
         } request;
         struct {
            UEXACT32 cra;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_INVALIDATE_PT_ENTRY, *PIOCTL_LOWLEVEL_INVALIDATE_PT_ENTRY;



#else
   // Invalidates a page table entry. 
   typedef struct _IOCTL_LOWLEVEL_INVALIDATE_PT_ENTRY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 cra;
         } request;
         struct {
            UEXACT32 cra;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_INVALIDATE_PT_ENTRY, *PIOCTL_LOWLEVEL_INVALIDATE_PT_ENTRY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACCESS_MEMORY_REQUEST {
         union {
            struct { 
               UEXACT32 address;
               UEXACT16 length;
               UEXACT8 memory;
               UEXACT8 write;
               UEXACT32 data;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK ACCESS_MEMORY_REQUEST, *PACCESS_MEMORY_REQUEST;

      SG_C_ASSERT(__sizeof__ACCESS_MEMORY_REQUEST, sizeof (ACCESS_MEMORY_REQUEST) == 12);

   #else
      typedef struct _ACCESS_MEMORY_REQUEST {
         UEXACT32 address;
         UEXACT16 length;
         UEXACT8 memory;
         UEXACT8 write;
         UEXACT32 data;
      } SG_PACK ACCESS_MEMORY_REQUEST, *PACCESS_MEMORY_REQUEST;

      typedef union _ACCESS_MEMORY_REQUEST_UNION {
         ACCESS_MEMORY_REQUEST bits;
         u32 dw[3]; // dword union
      } SG_PACK ACCESS_MEMORY_REQUEST_UNION, *PACCESS_MEMORY_REQUEST_UNION;

      SG_C_ASSERT(__sizeof__ACCESS_MEMORY_REQUEST_UNION, sizeof (ACCESS_MEMORY_REQUEST_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACCESS_MEMORY_REQUEST {
         union {
            struct { 
               UEXACT32 address;
               UEXACT16 length;
               UEXACT8 memory;
               UEXACT8 write;
               UEXACT32 data;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK ACCESS_MEMORY_REQUEST, *PACCESS_MEMORY_REQUEST;

      SG_C_ASSERT(__sizeof__ACCESS_MEMORY_REQUEST, sizeof (ACCESS_MEMORY_REQUEST) == 12);

   #else
      typedef struct _ACCESS_MEMORY_REQUEST {
         UEXACT32 address;
         UEXACT16 length;
         UEXACT8 memory;
         UEXACT8 write;
         UEXACT32 data;
      } SG_PACK ACCESS_MEMORY_REQUEST, *PACCESS_MEMORY_REQUEST;

      typedef union _ACCESS_MEMORY_REQUEST_UNION {
         ACCESS_MEMORY_REQUEST bits;
         u32 dw[3]; // dword union
      } SG_PACK ACCESS_MEMORY_REQUEST_UNION, *PACCESS_MEMORY_REQUEST_UNION;

      SG_C_ASSERT(__sizeof__ACCESS_MEMORY_REQUEST_UNION, sizeof (ACCESS_MEMORY_REQUEST_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Reads or writes on-chip memories. This is a debug-only feature. 
   typedef struct _IOCTL_LOWLEVEL_ACCESS_MEMORY {
      IOCTL_HEADER header;
      union {
         ACCESS_MEMORY_REQUEST request;
         struct {
            UEXACT32 data;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_ACCESS_MEMORY, *PIOCTL_LOWLEVEL_ACCESS_MEMORY;



#else
   // Reads or writes on-chip memories. This is a debug-only feature. 
   typedef struct _IOCTL_LOWLEVEL_ACCESS_MEMORY {
      IOCTL_HEADER header;
      union {
         ACCESS_MEMORY_REQUEST request;
         struct {
            UEXACT32 data;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_ACCESS_MEMORY, *PIOCTL_LOWLEVEL_ACCESS_MEMORY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Describes a single register transaction via IOCTL_LOWLEVEL_ACCESS_REGISTERS 
   #if defined(SG_BMAP_UNION)
      typedef struct _ACCESS_REGISTERS_TRANSACTION {
         union {
            struct { 
               UEXACT16 offset;
               UEXACT8 rsvd0;
               UEXACT8 write;
               UEXACT32 data;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ACCESS_REGISTERS_TRANSACTION, *PACCESS_REGISTERS_TRANSACTION;

      SG_C_ASSERT(__sizeof__ACCESS_REGISTERS_TRANSACTION, sizeof (ACCESS_REGISTERS_TRANSACTION) == 8);

   #else
      typedef struct _ACCESS_REGISTERS_TRANSACTION {
         UEXACT16 offset;
         UEXACT8 rsvd0;
         UEXACT8 write;
         UEXACT32 data;
      } SG_PACK ACCESS_REGISTERS_TRANSACTION, *PACCESS_REGISTERS_TRANSACTION;

      typedef union _ACCESS_REGISTERS_TRANSACTION_UNION {
         ACCESS_REGISTERS_TRANSACTION bits;
         u32 dw[2]; // dword union
      } SG_PACK ACCESS_REGISTERS_TRANSACTION_UNION, *PACCESS_REGISTERS_TRANSACTION_UNION;

      SG_C_ASSERT(__sizeof__ACCESS_REGISTERS_TRANSACTION_UNION, sizeof (ACCESS_REGISTERS_TRANSACTION_UNION) == 8);
   #endif


#else
   // Describes a single register transaction via IOCTL_LOWLEVEL_ACCESS_REGISTERS 
   #if defined(SG_BMAP_UNION)
      typedef struct _ACCESS_REGISTERS_TRANSACTION {
         union {
            struct { 
               UEXACT16 offset;
               UEXACT8 rsvd0;
               UEXACT8 write;
               UEXACT32 data;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ACCESS_REGISTERS_TRANSACTION, *PACCESS_REGISTERS_TRANSACTION;

      SG_C_ASSERT(__sizeof__ACCESS_REGISTERS_TRANSACTION, sizeof (ACCESS_REGISTERS_TRANSACTION) == 8);

   #else
      typedef struct _ACCESS_REGISTERS_TRANSACTION {
         UEXACT16 offset;
         UEXACT8 rsvd0;
         UEXACT8 write;
         UEXACT32 data;
      } SG_PACK ACCESS_REGISTERS_TRANSACTION, *PACCESS_REGISTERS_TRANSACTION;

      typedef union _ACCESS_REGISTERS_TRANSACTION_UNION {
         ACCESS_REGISTERS_TRANSACTION bits;
         u32 dw[2]; // dword union
      } SG_PACK ACCESS_REGISTERS_TRANSACTION_UNION, *PACCESS_REGISTERS_TRANSACTION_UNION;

      SG_C_ASSERT(__sizeof__ACCESS_REGISTERS_TRANSACTION_UNION, sizeof (ACCESS_REGISTERS_TRANSACTION_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACCESS_REGISTERS_PAYLOAD {
         union {
            struct { 
               UEXACT32 num_requests;
               ACCESS_REGISTERS_TRANSACTION registers[27];
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK ACCESS_REGISTERS_PAYLOAD, *PACCESS_REGISTERS_PAYLOAD;

      SG_C_ASSERT(__sizeof__ACCESS_REGISTERS_PAYLOAD, sizeof (ACCESS_REGISTERS_PAYLOAD) == 220);

   #else
      typedef struct _ACCESS_REGISTERS_PAYLOAD {
         UEXACT32 num_requests;
         ACCESS_REGISTERS_TRANSACTION registers[27];
      } SG_PACK ACCESS_REGISTERS_PAYLOAD, *PACCESS_REGISTERS_PAYLOAD;

      typedef union _ACCESS_REGISTERS_PAYLOAD_UNION {
         ACCESS_REGISTERS_PAYLOAD bits;
         u32 dw[55]; // dword union
      } SG_PACK ACCESS_REGISTERS_PAYLOAD_UNION, *PACCESS_REGISTERS_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__ACCESS_REGISTERS_PAYLOAD_UNION, sizeof (ACCESS_REGISTERS_PAYLOAD_UNION) == 220);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ACCESS_REGISTERS_PAYLOAD {
         union {
            struct { 
               UEXACT32 num_requests;
               ACCESS_REGISTERS_TRANSACTION registers[27];
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK ACCESS_REGISTERS_PAYLOAD, *PACCESS_REGISTERS_PAYLOAD;

      SG_C_ASSERT(__sizeof__ACCESS_REGISTERS_PAYLOAD, sizeof (ACCESS_REGISTERS_PAYLOAD) == 220);

   #else
      typedef struct _ACCESS_REGISTERS_PAYLOAD {
         UEXACT32 num_requests;
         ACCESS_REGISTERS_TRANSACTION registers[27];
      } SG_PACK ACCESS_REGISTERS_PAYLOAD, *PACCESS_REGISTERS_PAYLOAD;

      typedef union _ACCESS_REGISTERS_PAYLOAD_UNION {
         ACCESS_REGISTERS_PAYLOAD bits;
         u32 dw[55]; // dword union
      } SG_PACK ACCESS_REGISTERS_PAYLOAD_UNION, *PACCESS_REGISTERS_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__ACCESS_REGISTERS_PAYLOAD_UNION, sizeof (ACCESS_REGISTERS_PAYLOAD_UNION) == 220);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Reads or writes on-chip registers. This is a debug-only feature. While this IOCTL
   // structure is shown in a format such that it can be an embedded IOCTL (limited to 27
   // register transactions), the registers array may contain more than 27 entries in a
   // non-embedded format. In either format, the num_requests field determines the number
   // of transactions. 
   typedef struct _IOCTL_LOWLEVEL_ACCESS_REGISTERS {
      IOCTL_HEADER header;
      union {
         ACCESS_REGISTERS_PAYLOAD request;
         ACCESS_REGISTERS_PAYLOAD response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_ACCESS_REGISTERS, *PIOCTL_LOWLEVEL_ACCESS_REGISTERS;



#else
   // Reads or writes on-chip registers. This is a debug-only feature. While this IOCTL
   // structure is shown in a format such that it can be an embedded IOCTL (limited to 27
   // register transactions), the registers array may contain more than 27 entries in a
   // non-embedded format. In either format, the num_requests field determines the number
   // of transactions. 
   typedef struct _IOCTL_LOWLEVEL_ACCESS_REGISTERS {
      IOCTL_HEADER header;
      union {
         ACCESS_REGISTERS_PAYLOAD request;
         ACCESS_REGISTERS_PAYLOAD response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_ACCESS_REGISTERS, *PIOCTL_LOWLEVEL_ACCESS_REGISTERS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Temporarily disables/reenables an offloaded connection. 
   typedef struct _IOCTL_LOWLEVEL_OFFLOAD_ENABLE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            MPU_OFFLOAD_CXN_ENTRY filter;
         } request;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_OFFLOAD_ENABLE, *PIOCTL_LOWLEVEL_OFFLOAD_ENABLE;



#else
   // Temporarily disables/reenables an offloaded connection. 
   typedef struct _IOCTL_LOWLEVEL_OFFLOAD_ENABLE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            MPU_OFFLOAD_CXN_ENTRY filter;
         } request;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_OFFLOAD_ENABLE, *PIOCTL_LOWLEVEL_OFFLOAD_ENABLE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Queries or updates the TCP connection state. The offload should be disabled before
   // updating the state. 
   typedef struct _IOCTL_LOWLEVEL_CONFIG_TCP_STATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 write;
            TCP_CONTEXT tcp;
         } request;
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            TCP_CONTEXT tcp;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_CONFIG_TCP_STATE, *PIOCTL_LOWLEVEL_CONFIG_TCP_STATE;



#else
   // Queries or updates the TCP connection state. The offload should be disabled before
   // updating the state. 
   typedef struct _IOCTL_LOWLEVEL_CONFIG_TCP_STATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 write;
            TCP_CONTEXT tcp;
         } request;
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            TCP_CONTEXT tcp;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_CONFIG_TCP_STATE, *PIOCTL_LOWLEVEL_CONFIG_TCP_STATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Queries or updates the TCP connection state. The offload should be disabled before
   // updating the state. 
   typedef struct _IOCTL_LOWLEVEL_CONFIG_TEMPLATE_HEADER {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 write;
            MPU_TEMPLATE_HEADER header;
         } request;
         struct {
            UEXACT32 rsvd0;
            MPU_TEMPLATE_HEADER header;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_CONFIG_TEMPLATE_HEADER, *PIOCTL_LOWLEVEL_CONFIG_TEMPLATE_HEADER;



#else
   // Queries or updates the TCP connection state. The offload should be disabled before
   // updating the state. 
   typedef struct _IOCTL_LOWLEVEL_CONFIG_TEMPLATE_HEADER {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 write;
            MPU_TEMPLATE_HEADER header;
         } request;
         struct {
            UEXACT32 rsvd0;
            MPU_TEMPLATE_HEADER header;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_CONFIG_TEMPLATE_HEADER, *PIOCTL_LOWLEVEL_CONFIG_TEMPLATE_HEADER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Queries or updates the iSCSI connection state. The offload should be disabled before
   // updating the state. 
   typedef struct _IOCTL_LOWLEVEL_CONFIG_ISCSI {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 write;
            ISCSI_CONTEXT context;
         } request;
         struct {
            UEXACT32 rsvd0;
            ISCSI_CONTEXT context;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_CONFIG_ISCSI, *PIOCTL_LOWLEVEL_CONFIG_ISCSI;



#else
   // Queries or updates the iSCSI connection state. The offload should be disabled before
   // updating the state. 
   typedef struct _IOCTL_LOWLEVEL_CONFIG_ISCSI {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 write;
            ISCSI_CONTEXT context;
         } request;
         struct {
            UEXACT32 rsvd0;
            ISCSI_CONTEXT context;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_CONFIG_ISCSI, *PIOCTL_LOWLEVEL_CONFIG_ISCSI;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Queries or updates the TOE connection state. The offload should be disabled before
   // updating the state. 
   typedef struct _IOCTL_LOWLEVEL_CONFIG_TOE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 write;
            TOE_CONTEXT context;
         } request;
         struct {
            UEXACT32 rsvd0;
            TOE_CONTEXT context;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_CONFIG_TOE, *PIOCTL_LOWLEVEL_CONFIG_TOE;



#else
   // Queries or updates the TOE connection state. The offload should be disabled before
   // updating the state. 
   typedef struct _IOCTL_LOWLEVEL_CONFIG_TOE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 write;
            TOE_CONTEXT context;
         } request;
         struct {
            UEXACT32 rsvd0;
            TOE_CONTEXT context;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_CONFIG_TOE, *PIOCTL_LOWLEVEL_CONFIG_TOE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Offloads a connection. 
   typedef struct _IOCTL_LOWLEVEL_ISCSI_OFFLOAD {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            MPU_TEMPLATE_HEADER header;
            TCP_CONTEXT tcp;
            MPU_OFFLOAD_CXN_ENTRY filter;
            ISCSI_CONTEXT context;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_ISCSI_OFFLOAD, *PIOCTL_LOWLEVEL_ISCSI_OFFLOAD;



#else
   // Offloads a connection. 
   typedef struct _IOCTL_LOWLEVEL_ISCSI_OFFLOAD {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            MPU_TEMPLATE_HEADER header;
            TCP_CONTEXT tcp;
            MPU_OFFLOAD_CXN_ENTRY filter;
            ISCSI_CONTEXT context;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_ISCSI_OFFLOAD, *PIOCTL_LOWLEVEL_ISCSI_OFFLOAD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Offloads a fcoe interface. 
   typedef struct _IOCTL_LOWLEVEL_FCOE_OFFLOAD {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            MPU_TEMPLATE_HEADER header;
            TCP_CONTEXT tcp;
            FCOE_TABLE_ENTRY filter;
            FC_CONTEXT context;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_FCOE_OFFLOAD, *PIOCTL_LOWLEVEL_FCOE_OFFLOAD;



#else
   // Offloads a fcoe interface. 
   typedef struct _IOCTL_LOWLEVEL_FCOE_OFFLOAD {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            MPU_TEMPLATE_HEADER header;
            TCP_CONTEXT tcp;
            FCOE_TABLE_ENTRY filter;
            FC_CONTEXT context;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_FCOE_OFFLOAD, *PIOCTL_LOWLEVEL_FCOE_OFFLOAD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Maps pages into the UT. 
   typedef struct _IOCTL_LOWLEVEL_MAP_UT_PAGES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            UEXACT32 cra;
            PHYS_ADDR pages[16];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_MAP_UT_PAGES, *PIOCTL_LOWLEVEL_MAP_UT_PAGES;



#else
   // Maps pages into the UT. 
   typedef struct _IOCTL_LOWLEVEL_MAP_UT_PAGES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            UEXACT32 cra;
            PHYS_ADDR pages[16];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_MAP_UT_PAGES, *PIOCTL_LOWLEVEL_MAP_UT_PAGES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unmaps pages from the UT. 
   typedef struct _IOCTL_LOWLEVEL_UNMAP_UT_PAGES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            UEXACT32 cra;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_UNMAP_UT_PAGES, *PIOCTL_LOWLEVEL_UNMAP_UT_PAGES;



#else
   // Unmaps pages from the UT. 
   typedef struct _IOCTL_LOWLEVEL_UNMAP_UT_PAGES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            UEXACT32 cra;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_UNMAP_UT_PAGES, *PIOCTL_LOWLEVEL_UNMAP_UT_PAGES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL can be used by drivers to control debug levels in the BladeEngine
   // management firmware. This is provided as a debugging tool only. The IOCTL returns
   // the previous settings in the response buffer. 
   typedef struct _IOCTL_LOWLEVEL_MGMT_DEBUG_LEVEL {
      IOCTL_HEADER header;
      union {
         struct {
            u32 print_level;
            u32 rsvd0;
            u32 store_level;
            u32 enable_disable_print;
            u32 enable_disable_store;
         } request;
         struct {
            u32 old_print_level;
            u32 rsvd0;
            u32 old_store_level;
            u32 old_enable_disable_print;
            u32 old_enable_disable_store;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_MGMT_DEBUG_LEVEL, *PIOCTL_LOWLEVEL_MGMT_DEBUG_LEVEL;



#else
   // This IOCTL can be used by drivers to control debug levels in the BladeEngine
   // management firmware. This is provided as a debugging tool only. The IOCTL returns
   // the previous settings in the response buffer. 
   typedef struct _IOCTL_LOWLEVEL_MGMT_DEBUG_LEVEL {
      IOCTL_HEADER header;
      union {
         struct {
            u32 print_level;
            u32 rsvd0;
            u32 store_level;
            u32 enable_disable_print;
            u32 enable_disable_store;
         } request;
         struct {
            u32 old_print_level;
            u32 rsvd0;
            u32 old_store_level;
            u32 old_enable_disable_print;
            u32 old_enable_disable_store;
         } response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_MGMT_DEBUG_LEVEL, *PIOCTL_LOWLEVEL_MGMT_DEBUG_LEVEL;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE {
         union {
            struct { 
               u32 transfer_size;
               u32 num_rmda_transfered;
               u32 num_wdma_transfered;
               u32 rdma_ticks;
               u32 wdma_ticks;
               u32 ioctl_ticks;
               u32 clock_speed;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE, *PIOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE, sizeof (IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE) == 28);

   #else
      typedef struct _IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE {
         u32 transfer_size;
         u32 num_rmda_transfered;
         u32 num_wdma_transfered;
         u32 rdma_ticks;
         u32 wdma_ticks;
         u32 ioctl_ticks;
         u32 clock_speed;
      } SG_PACK IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE, *PIOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE;

      typedef union _IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_UNION {
         IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_UNION, *PIOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_UNION, sizeof (IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_UNION) == 28);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE {
         union {
            struct { 
               u32 transfer_size;
               u32 num_rmda_transfered;
               u32 num_wdma_transfered;
               u32 rdma_ticks;
               u32 wdma_ticks;
               u32 ioctl_ticks;
               u32 clock_speed;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE, *PIOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE, sizeof (IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE) == 28);

   #else
      typedef struct _IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE {
         u32 transfer_size;
         u32 num_rmda_transfered;
         u32 num_wdma_transfered;
         u32 rdma_ticks;
         u32 wdma_ticks;
         u32 ioctl_ticks;
         u32 clock_speed;
      } SG_PACK IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE, *PIOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE;

      typedef union _IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_UNION {
         IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_UNION, *PIOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_UNION, sizeof (IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL allows running a DMA bandwidth test in the ARM firmware. It should only
   // be used for diagnostic system checks. This IOCTL will lock out all other processing
   // in the ARM and should only be used when the system is idle. The system should be
   // rebooted after using this IOCTL. 
   typedef struct _IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH {
      IOCTL_HEADER header;
      union {
         struct {
            u8 transaction_type;
            u8 rdma_target;
            u8 rdma_source;
            u8 wdma_source;
            u8 wdma_target;
            u8 enable_bidi;
            u16 rsvd0;
            u32 transfer_size;
            u32 number_transfers;
            u32 ioctl_measure;
            u32 ioctl_start;
            u32 ioctl_stop;
            PHYS_ADDR pa_read;
            PHYS_ADDR pa_write;
         } request;
         IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH, *PIOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH;



#else
   // This IOCTL allows running a DMA bandwidth test in the ARM firmware. It should only
   // be used for diagnostic system checks. This IOCTL will lock out all other processing
   // in the ARM and should only be used when the system is idle. The system should be
   // rebooted after using this IOCTL. 
   typedef struct _IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH {
      IOCTL_HEADER header;
      union {
         struct {
            u8 transaction_type;
            u8 rdma_target;
            u8 rdma_source;
            u8 wdma_source;
            u8 wdma_target;
            u8 enable_bidi;
            u16 rsvd0;
            u32 transfer_size;
            u32 number_transfers;
            u32 ioctl_measure;
            u32 ioctl_start;
            u32 ioctl_stop;
            PHYS_ADDR pa_read;
            PHYS_ADDR pa_write;
         } request;
         IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE response;
      } params;
   } SG_PACK IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH, *PIOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN {
         union {
            struct { 
               u32 loopback_type;
               u32 number_packets;
               u64 pattern;
               u32 src_port;
               u32 dest_port;
               u32 packet_size;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN) == 28);

   #else
      typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN {
         u32 loopback_type;
         u32 number_packets;
         u64 pattern;
         u32 src_port;
         u32 dest_port;
         u32 packet_size;
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN;

      typedef union _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_UNION {
         IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_UNION, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_UNION, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_UNION) == 28);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN {
         union {
            struct { 
               u32 loopback_type;
               u32 number_packets;
               u64 pattern;
               u32 src_port;
               u32 dest_port;
               u32 packet_size;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN) == 28);

   #else
      typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN {
         u32 loopback_type;
         u32 number_packets;
         u64 pattern;
         u32 src_port;
         u32 dest_port;
         u32 packet_size;
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN;

      typedef union _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_UNION {
         IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_UNION, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_UNION, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT {
         union {
            struct { 
               u32 status;
               u32 number_transfered;
               u32 number_received;
               u32 miscompare_offset;
               u32 num_ticks_completion;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT) == 20);

   #else
      typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT {
         u32 status;
         u32 number_transfered;
         u32 number_received;
         u32 miscompare_offset;
         u32 num_ticks_completion;
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT;

      typedef union _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_UNION {
         IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_UNION, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_UNION, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_UNION) == 20);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT {
         union {
            struct { 
               u32 status;
               u32 number_transfered;
               u32 number_received;
               u32 miscompare_offset;
               u32 num_ticks_completion;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT) == 20);

   #else
      typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT {
         u32 status;
         u32 number_transfered;
         u32 number_received;
         u32 miscompare_offset;
         u32 num_ticks_completion;
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT;

      typedef union _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_UNION {
         IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_UNION, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_UNION, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS {
         union {
            union { 
               IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN request;
               IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS) == 28);

   #else
      typedef union _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS {
         IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN request;
         IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT response;
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS;

      typedef union _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_UNION {
         IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_UNION, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_UNION, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_UNION) == 28);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS {
         union {
            union { 
               IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN request;
               IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS) == 28);

   #else
      typedef union _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS {
         IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN request;
         IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT response;
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS;

      typedef union _IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_UNION {
         IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_UNION, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_UNION, sizeof (IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL enables loopback tests at various levels. The loopback test provides
   // diagnostic capability to transmit and receive packets for a given loop back mode. 
   typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST {
      IOCTL_HEADER header;
      IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS params;
   } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST, *PIOCTL_LOWLEVEL_LOOPBACK_TEST;



#else
   // This IOCTL enables loopback tests at various levels. The loopback test provides
   // diagnostic capability to transmit and receive packets for a given loop back mode. 
   typedef struct _IOCTL_LOWLEVEL_LOOPBACK_TEST {
      IOCTL_HEADER header;
      IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS params;
   } SG_PACK IOCTL_LOWLEVEL_LOOPBACK_TEST, *PIOCTL_LOWLEVEL_LOOPBACK_TEST;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN {
         union {
            struct { 
               UEXACT64 pattern;
               UEXACT32 byte_count;
               UEXACT32 rsvd0;
               UEXACT8 send_buffer[4096];
               UEXACT8 rsvd1[4096];
            } SG_PACK ; // unnamed struct
            u32 dw[2052]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN) == 8208);

   #else
      typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN {
         UEXACT64 pattern;
         UEXACT32 byte_count;
         UEXACT32 rsvd0;
         UEXACT8 send_buffer[4096];
         UEXACT8 rsvd1[4096];
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN;

      typedef union _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_UNION {
         IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN bits;
         u32 dw[2052]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_UNION, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_UNION, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_UNION) == 8208);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN {
         union {
            struct { 
               UEXACT64 pattern;
               UEXACT32 byte_count;
               UEXACT32 rsvd0;
               UEXACT8 send_buffer[4096];
               UEXACT8 rsvd1[4096];
            } SG_PACK ; // unnamed struct
            u32 dw[2052]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN) == 8208);

   #else
      typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN {
         UEXACT64 pattern;
         UEXACT32 byte_count;
         UEXACT32 rsvd0;
         UEXACT8 send_buffer[4096];
         UEXACT8 rsvd1[4096];
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN;

      typedef union _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_UNION {
         IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN bits;
         u32 dw[2052]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_UNION, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_UNION, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_UNION) == 8208);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT {
         union {
            struct { 
               UEXACT64 pattern;
               UEXACT32 byte_count;
               UEXACT32 send_error;
               UEXACT8 rsvd0[4096];
               UEXACT8 recv_buffer[4096];
            } SG_PACK ; // unnamed struct
            u32 dw[2052]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT) == 8208);

   #else
      typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT {
         UEXACT64 pattern;
         UEXACT32 byte_count;
         UEXACT32 send_error;
         UEXACT8 rsvd0[4096];
         UEXACT8 recv_buffer[4096];
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT;

      typedef union _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_UNION {
         IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT bits;
         u32 dw[2052]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_UNION, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_UNION, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_UNION) == 8208);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT {
         union {
            struct { 
               UEXACT64 pattern;
               UEXACT32 byte_count;
               UEXACT32 send_error;
               UEXACT8 rsvd0[4096];
               UEXACT8 recv_buffer[4096];
            } SG_PACK ; // unnamed struct
            u32 dw[2052]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT) == 8208);

   #else
      typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT {
         UEXACT64 pattern;
         UEXACT32 byte_count;
         UEXACT32 send_error;
         UEXACT8 rsvd0[4096];
         UEXACT8 recv_buffer[4096];
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT;

      typedef union _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_UNION {
         IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT bits;
         u32 dw[2052]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_UNION, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_UNION, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_UNION) == 8208);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS {
         union {
            union { 
               IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN request;
               IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2052]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS) == 8208);

   #else
      typedef union _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS {
         IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN request;
         IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT response;
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS;

      typedef union _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_UNION {
         IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS bits;
         u32 dw[2052]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_UNION, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_UNION, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_UNION) == 8208);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS {
         union {
            union { 
               IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN request;
               IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2052]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS) == 8208);

   #else
      typedef union _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS {
         IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN request;
         IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT response;
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS;

      typedef union _IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_UNION {
         IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS bits;
         u32 dw[2052]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_UNION, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_UNION, sizeof (IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_UNION) == 8208);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL verifies the DMA path from host memory to DDR memory (forward path DMA)
   // and from DDR to host memory (reverse path DMA). The application fills the
   // send_buffer space with the a 64B pattern and posts the IOCTL. On IOCTL completion,
   // the application would pattern match the received pattern in response field with the
   // data in recv_buffer. Forward path DMA error is tracked by AMRfw and noted in the
   // send_error field. Reverse path DMA is tracked by the application as a result of
   // above mentioned pattern matching. 
   typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA {
      IOCTL_HEADER header;
      IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS params;
   } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA, *PIOCTL_LOWLEVEL_HOST_DDR_DMA;



#else
   // This IOCTL verifies the DMA path from host memory to DDR memory (forward path DMA)
   // and from DDR to host memory (reverse path DMA). The application fills the
   // send_buffer space with the a 64B pattern and posts the IOCTL. On IOCTL completion,
   // the application would pattern match the received pattern in response field with the
   // data in recv_buffer. Forward path DMA error is tracked by AMRfw and noted in the
   // send_error field. Reverse path DMA is tracked by the application as a result of
   // above mentioned pattern matching. 
   typedef struct _IOCTL_LOWLEVEL_HOST_DDR_DMA {
      IOCTL_HEADER header;
      IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS params;
   } SG_PACK IOCTL_LOWLEVEL_HOST_DDR_DMA, *PIOCTL_LOWLEVEL_HOST_DDR_DMA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN {
         union {
            struct { 
               u8 src_port;
               u8 dest_port;
               u8 loopback_mode;
               u8 loopback_state;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN {
         u8 src_port;
         u8 dest_port;
         u8 loopback_mode;
         u8 loopback_state;
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN;

      typedef union _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_UNION {
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_UNION, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_UNION, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN {
         union {
            struct { 
               u8 src_port;
               u8 dest_port;
               u8 loopback_mode;
               u8 loopback_state;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN {
         u8 src_port;
         u8 dest_port;
         u8 loopback_mode;
         u8 loopback_state;
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN;

      typedef union _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_UNION {
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_UNION, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_UNION, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT {
         union {
            struct { 
               u32 status;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT {
         u32 status;
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT;

      typedef union _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_UNION {
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_UNION, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_UNION, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT {
         union {
            struct { 
               u32 status;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT {
         u32 status;
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT;

      typedef union _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_UNION {
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_UNION, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_UNION, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS {
         union {
            union { 
               IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN request;
               IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS) == 4);

   #else
      typedef union _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS {
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN request;
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT response;
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS;

      typedef union _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_UNION {
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_UNION, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_UNION, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS {
         union {
            union { 
               IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN request;
               IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS) == 4);

   #else
      typedef union _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS {
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN request;
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT response;
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS;

      typedef union _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_UNION {
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_UNION, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_UNION, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL is for entering and exiting loopback mode . 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS params;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE) == 20);

   #else
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE {
         IOCTL_HEADER header;
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS params;
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE;

      typedef union _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_UNION {
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_UNION, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_UNION, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_UNION) == 20);
   #endif


#else
   // This IOCTL is for entering and exiting loopback mode . 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS params;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE) == 20);

   #else
      typedef struct _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE {
         IOCTL_HEADER header;
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS params;
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE;

      typedef union _IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_UNION {
         IOCTL_LOWLEVEL_SET_LOOPBACK_MODE bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_UNION, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_UNION, sizeof (IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN {
      UEXACT8 port_num;
   } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN;



#else
   
   typedef struct _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN {
      UEXACT8 port_num;
   } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 loopback_mode;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT, sizeof (IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT {
         UEXACT8 loopback_mode;
         UEXACT8 rsvd0[3];
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT;

      typedef union _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_UNION {
         IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_UNION, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_UNION, sizeof (IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 loopback_mode;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT, sizeof (IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT {
         UEXACT8 loopback_mode;
         UEXACT8 rsvd0[3];
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT;

      typedef union _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_UNION {
         IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_UNION, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_UNION, sizeof (IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS {
         union {
            union { 
               IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN request;
               IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS, sizeof (IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS) == 4);

   #else
      typedef union _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS {
         IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN request;
         IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT response;
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS;

      typedef union _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_UNION {
         IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_UNION, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_UNION, sizeof (IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS {
         union {
            union { 
               IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN request;
               IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS, sizeof (IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS) == 4);

   #else
      typedef union _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS {
         IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN request;
         IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT response;
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS;

      typedef union _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_UNION {
         IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_UNION, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_UNION, sizeof (IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL will report the current state of loopback mode on the selected port. 
   typedef struct _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE {
      IOCTL_HEADER header;
      IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS params;
   } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE;



#else
   // This IOCTL will report the current state of loopback mode on the selected port. 
   typedef struct _IOCTL_LOWLEVEL_GET_LOOPBACK_MODE {
      IOCTL_HEADER header;
      IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS params;
   } SG_PACK IOCTL_LOWLEVEL_GET_LOOPBACK_MODE, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_lowlevel_bmap_h__

