/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_lro_bmap_h__
#define __ioctl_lro_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating LRO Rx ring for a given interface.  An LRO ring contains
   // WCON_PM_CC entries (8 bytes each). LRO ring must be at most 1024 entries deep
   // (corresponding to 2 pages). The host driver in allocates double the size of the ring
   // in UT to account for the virtual LRO rings. 
   typedef struct _IOCTL_LRO_RING_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 interface_id;
            UEXACT16 lro_cq_id;
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            PHYS_ADDR pages[4];
            UEXACT32 page_size;
            UEXACT32 ulp_num;
         } request;
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LRO_RING_CREATE, *PIOCTL_LRO_RING_CREATE;



#else
   // IOCTL for creating LRO Rx ring for a given interface.  An LRO ring contains
   // WCON_PM_CC entries (8 bytes each). LRO ring must be at most 1024 entries deep
   // (corresponding to 2 pages). The host driver in allocates double the size of the ring
   // in UT to account for the virtual LRO rings. 
   typedef struct _IOCTL_LRO_RING_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 interface_id;
            UEXACT16 lro_cq_id;
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            PHYS_ADDR pages[4];
            UEXACT32 page_size;
            UEXACT32 ulp_num;
         } request;
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LRO_RING_CREATE, *PIOCTL_LRO_RING_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for enabling / disabling LRO traffic and configuring LRO parameters for a
   // given LRO interface. 
   typedef struct _IOCTL_LRO_CONFIG {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 interface_id;
            UEXACT16 mode;
            LRO_INTERFACE_PARAMS lro_params;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LRO_CONFIG, *PIOCTL_LRO_CONFIG;



#else
   // IOCTL for enabling / disabling LRO traffic and configuring LRO parameters for a
   // given LRO interface. 
   typedef struct _IOCTL_LRO_CONFIG {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 interface_id;
            UEXACT16 mode;
            LRO_INTERFACE_PARAMS lro_params;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LRO_CONFIG, *PIOCTL_LRO_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying an LRO ring. The LRO traffic must be disabled on the interface
   // associated with the LRO ring prior to destroying the ring. 
   typedef struct _IOCTL_LRO_RING_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LRO_RING_DESTROY, *PIOCTL_LRO_RING_DESTROY;



#else
   // IOCTL for destroying an LRO ring. The LRO traffic must be disabled on the interface
   // associated with the LRO ring prior to destroying the ring. 
   typedef struct _IOCTL_LRO_RING_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LRO_RING_DESTROY, *PIOCTL_LRO_RING_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for retrieving LRO statistics. 
   typedef struct _IOCTL_LRO_GET_STATISTICS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LRO_GET_STATISTICS, *PIOCTL_LRO_GET_STATISTICS;



#else
   // IOCTL for retrieving LRO statistics. 
   typedef struct _IOCTL_LRO_GET_STATISTICS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_LRO_GET_STATISTICS, *PIOCTL_LRO_GET_STATISTICS;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_lro_bmap_h__

