/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_toe_bmap_h__
#define __ioctl_toe_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"
#include "ioctl_common_bmap.h"
#include "fw_exp_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Offloads a connection. 
   typedef struct _IOCTL_TOE_CONNECTION_OFFLOAD {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 ip_version;
            MPU_TEMPLATE_HEADER header;
            TCP_CONTEXT tcp;
            TOE_CONTEXT context;
            MPU_OFFLOAD_CXN_ENTRY filter;
            UEXACT32 ka_probe_count;
            UEXACT32 ka_timeout_delta;
            UEXACT16 dq_id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_CONNECTION_OFFLOAD, *PIOCTL_TOE_CONNECTION_OFFLOAD;



#else
   // Offloads a connection. 
   typedef struct _IOCTL_TOE_CONNECTION_OFFLOAD {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 ip_version;
            MPU_TEMPLATE_HEADER header;
            TCP_CONTEXT tcp;
            TOE_CONTEXT context;
            MPU_OFFLOAD_CXN_ENTRY filter;
            UEXACT32 ka_probe_count;
            UEXACT32 ka_timeout_delta;
            UEXACT16 dq_id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_CONNECTION_OFFLOAD, *PIOCTL_TOE_CONNECTION_OFFLOAD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Uploads a given connection. Updates the template header and TCP state for an
   // offloaded connection. 
   typedef struct _IOCTL_TOE_CONNECTION_UPDATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT8 hdr_len;
            UEXACT8 rsvd0;
            TCP_UPDATE_DATA update_data;
            MPU_TEMPLATE_HEADER header;
            UEXACT32 recv_bufsize;
            UEXACT32 window_reduction;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_CONNECTION_UPDATE, *PIOCTL_TOE_CONNECTION_UPDATE;



#else
   // Uploads a given connection. Updates the template header and TCP state for an
   // offloaded connection. 
   typedef struct _IOCTL_TOE_CONNECTION_UPDATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT8 hdr_len;
            UEXACT8 rsvd0;
            TCP_UPDATE_DATA update_data;
            MPU_TEMPLATE_HEADER header;
            UEXACT32 recv_bufsize;
            UEXACT32 window_reduction;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_CONNECTION_UPDATE, *PIOCTL_TOE_CONNECTION_UPDATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Returns the current TCP state for the offloaded connection. Most likely the caller
   // will disable the offloaded connection before querying the state. 
   typedef struct _IOCTL_TOE_CONNECTION_QUERY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
         } request;
         struct {
            TCP_CONTEXT tcp;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_CONNECTION_QUERY, *PIOCTL_TOE_CONNECTION_QUERY;



#else
   // Returns the current TCP state for the offloaded connection. Most likely the caller
   // will disable the offloaded connection before querying the state. 
   typedef struct _IOCTL_TOE_CONNECTION_QUERY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
         } request;
         struct {
            TCP_CONTEXT tcp;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_CONNECTION_QUERY, *PIOCTL_TOE_CONNECTION_QUERY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure has all the IP Fragmentation/Reassembly Stats (per port) filled in by
   // the ARM. 
   typedef struct _BE_TOERX_MISC_STATS {
      UEXACT32 ipv4ReassembledPackets;
      UEXACT32 ipv4Fragmentation;
      UEXACT32 ipv4FragmentedPduCreates;
      UEXACT32 ipv4OverlappedFragCount;
      UEXACT32 ipv4OutOfOrderFragCount;
      UEXACT32 ipv4ReassemblyTimeout;
      UEXACT32 ipv6ReassembledPackets;
      UEXACT32 ipv6Fragmentation;
      UEXACT32 ipv6FragmentedPduCreates;
      UEXACT32 ipv6OverlappedFragCount;
      UEXACT32 ipv6OutofOrderFragCount;
      UEXACT32 ipv6ReassemblyTimeout;
   } SG_PACK BE_TOERX_MISC_STATS, *PBE_TOERX_MISC_STATS;



#else
   // This structure has all the IP Fragmentation/Reassembly Stats (per port) filled in by
   // the ARM. 
   typedef struct _BE_TOERX_MISC_STATS {
      UEXACT32 ipv4ReassembledPackets;
      UEXACT32 ipv4Fragmentation;
      UEXACT32 ipv4FragmentedPduCreates;
      UEXACT32 ipv4OverlappedFragCount;
      UEXACT32 ipv4OutOfOrderFragCount;
      UEXACT32 ipv4ReassemblyTimeout;
      UEXACT32 ipv6ReassembledPackets;
      UEXACT32 ipv6Fragmentation;
      UEXACT32 ipv6FragmentedPduCreates;
      UEXACT32 ipv6OverlappedFragCount;
      UEXACT32 ipv6OutofOrderFragCount;
      UEXACT32 ipv6ReassemblyTimeout;
   } SG_PACK BE_TOERX_MISC_STATS, *PBE_TOERX_MISC_STATS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TOE_STATS {
         union {
            struct { 
               BE_TOERX_STATS rx;
               BE_TOETX_STATS tx;
            } SG_PACK ; // unnamed struct
            u32 dw[512]; // dword union
         }; // unnamed union
      } SG_PACK BE_TOE_STATS, *PBE_TOE_STATS;

      SG_C_ASSERT(__sizeof__BE_TOE_STATS, sizeof (BE_TOE_STATS) == 2048);

   #else
      typedef struct _BE_TOE_STATS {
         BE_TOERX_STATS rx;
         BE_TOETX_STATS tx;
      } SG_PACK BE_TOE_STATS, *PBE_TOE_STATS;

      typedef union _BE_TOE_STATS_UNION {
         BE_TOE_STATS bits;
         u32 dw[512]; // dword union
      } SG_PACK BE_TOE_STATS_UNION, *PBE_TOE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TOE_STATS_UNION, sizeof (BE_TOE_STATS_UNION) == 2048);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TOE_STATS {
         union {
            struct { 
               BE_TOERX_STATS rx;
               BE_TOETX_STATS tx;
            } SG_PACK ; // unnamed struct
            u32 dw[512]; // dword union
         }; // unnamed union
      } SG_PACK BE_TOE_STATS, *PBE_TOE_STATS;

      SG_C_ASSERT(__sizeof__BE_TOE_STATS, sizeof (BE_TOE_STATS) == 2048);

   #else
      typedef struct _BE_TOE_STATS {
         BE_TOERX_STATS rx;
         BE_TOETX_STATS tx;
      } SG_PACK BE_TOE_STATS, *PBE_TOE_STATS;

      typedef union _BE_TOE_STATS_UNION {
         BE_TOE_STATS bits;
         u32 dw[512]; // dword union
      } SG_PACK BE_TOE_STATS_UNION, *PBE_TOE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TOE_STATS_UNION, sizeof (BE_TOE_STATS_UNION) == 2048);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_GET_STATISTICS_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  BE_TOE_STATS chute[3];
                  UEXACT32 toe_ulp_mask;
                  BE_TOERX_MISC_STATS rx_misc[2];
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[1561]; // dword union
         }; // unnamed union
      } SG_PACK TOE_GET_STATISTICS_PARAMS, *PTOE_GET_STATISTICS_PARAMS;

      SG_C_ASSERT(__sizeof__TOE_GET_STATISTICS_PARAMS, sizeof (TOE_GET_STATISTICS_PARAMS) == 6244);

   #else
      typedef union _TOE_GET_STATISTICS_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            BE_TOE_STATS chute[3];
            UEXACT32 toe_ulp_mask;
            BE_TOERX_MISC_STATS rx_misc[2];
         } response;
      } SG_PACK TOE_GET_STATISTICS_PARAMS, *PTOE_GET_STATISTICS_PARAMS;

      typedef union _TOE_GET_STATISTICS_PARAMS_UNION {
         TOE_GET_STATISTICS_PARAMS bits;
         u32 dw[1561]; // dword union
      } SG_PACK TOE_GET_STATISTICS_PARAMS_UNION, *PTOE_GET_STATISTICS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__TOE_GET_STATISTICS_PARAMS_UNION, sizeof (TOE_GET_STATISTICS_PARAMS_UNION) == 6244);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_GET_STATISTICS_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  BE_TOE_STATS chute[3];
                  UEXACT32 toe_ulp_mask;
                  BE_TOERX_MISC_STATS rx_misc[2];
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[1561]; // dword union
         }; // unnamed union
      } SG_PACK TOE_GET_STATISTICS_PARAMS, *PTOE_GET_STATISTICS_PARAMS;

      SG_C_ASSERT(__sizeof__TOE_GET_STATISTICS_PARAMS, sizeof (TOE_GET_STATISTICS_PARAMS) == 6244);

   #else
      typedef union _TOE_GET_STATISTICS_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            BE_TOE_STATS chute[3];
            UEXACT32 toe_ulp_mask;
            BE_TOERX_MISC_STATS rx_misc[2];
         } response;
      } SG_PACK TOE_GET_STATISTICS_PARAMS, *PTOE_GET_STATISTICS_PARAMS;

      typedef union _TOE_GET_STATISTICS_PARAMS_UNION {
         TOE_GET_STATISTICS_PARAMS bits;
         u32 dw[1561]; // dword union
      } SG_PACK TOE_GET_STATISTICS_PARAMS_UNION, *PTOE_GET_STATISTICS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__TOE_GET_STATISTICS_PARAMS_UNION, sizeof (TOE_GET_STATISTICS_PARAMS_UNION) == 6244);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Returns TOE-related statistics accross BladeEngine. 
   typedef struct _IOCTL_TOE_GET_STATISTICS {
      IOCTL_HEADER header;
      TOE_GET_STATISTICS_PARAMS params;
   } SG_PACK IOCTL_TOE_GET_STATISTICS, *PIOCTL_TOE_GET_STATISTICS;



#else
   // Returns TOE-related statistics accross BladeEngine. 
   typedef struct _IOCTL_TOE_GET_STATISTICS {
      IOCTL_HEADER header;
      TOE_GET_STATISTICS_PARAMS params;
   } SG_PACK IOCTL_TOE_GET_STATISTICS, *PIOCTL_TOE_GET_STATISTICS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating TOE default buffer ring.  A TOE default buffer queue contains
   // TOE_DEFBUFFER entries (8 bytes each). A TOE default buffer ring must be at least 512
   // entries deep (corresponding to 1 page) and at most 1k entries deep (corresponding to
   // 2 pages). 
   typedef struct _IOCTL_TOE_DEFQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT8 ulp_num;
            UEXACT8 rsvd0;
            TOE_DEFAULT_BUFFER context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_DEFQ_CREATE, *PIOCTL_TOE_DEFQ_CREATE;



#else
   // IOCTL for creating TOE default buffer ring.  A TOE default buffer queue contains
   // TOE_DEFBUFFER entries (8 bytes each). A TOE default buffer ring must be at least 512
   // entries deep (corresponding to 1 page) and at most 1k entries deep (corresponding to
   // 2 pages). 
   typedef struct _IOCTL_TOE_DEFQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT8 ulp_num;
            UEXACT8 rsvd0;
            TOE_DEFAULT_BUFFER context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_DEFQ_CREATE, *PIOCTL_TOE_DEFQ_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating TOE transmit ring. A TOE transmit ring contains TOE_WRB entries
   // (16 bytes each). The ring must be at least 256 entries deep (corresponding to 1
   // page) and at most 2k entries deep (corresponding to 8 pages). When the connection is
   // offloaded, the encoded ring size in the context must result in a ring fitting within
   // the number of pages posted with this IOCTL. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_UNAUTHORIZED_REQUEST -- the client is not authorized to create this
   // ring type.  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- this
   // ring type is either unavailable or all rings are already created. 
   typedef struct _IOCTL_TOE_WRBQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT8 ulp_num;
            UEXACT8 rsvd0;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_WRBQ_CREATE, *PIOCTL_TOE_WRBQ_CREATE;



#else
   // IOCTL for creating TOE transmit ring. A TOE transmit ring contains TOE_WRB entries
   // (16 bytes each). The ring must be at least 256 entries deep (corresponding to 1
   // page) and at most 2k entries deep (corresponding to 8 pages). When the connection is
   // offloaded, the encoded ring size in the context must result in a ring fitting within
   // the number of pages posted with this IOCTL. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_UNAUTHORIZED_REQUEST -- the client is not authorized to create this
   // ring type.  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- this
   // ring type is either unavailable or all rings are already created. 
   typedef struct _IOCTL_TOE_WRBQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT8 ulp_num;
            UEXACT8 rsvd0;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_WRBQ_CREATE, *PIOCTL_TOE_WRBQ_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating TOE preposted receive buffer ring for a given connection id.  A
   // TOE preposted buffer receive ring can only be created after a TOE transmit ring is
   // successfuly created. A TOE receive queue contains TOE_PREBUFFER entries (16 bytes
   // each). A TOE receive queue must be at least 256 entries deep (corresponding to 1
   // page) and at most 1k entries deep (corresponding to 4 pages). When the connection is
   // offloaded, the encoded ring size in the context must result in a ring fitting within
   // the number of pages posted with this IOCTL. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_UNAUTHORIZED_REQUEST -- the client is not authorized to create this
   // ring type.  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- this
   // ring type is either unavailable or all rings are already created. 
   typedef struct _IOCTL_TOE_RQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 num_pages;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_RQ_CREATE, *PIOCTL_TOE_RQ_CREATE;



#else
   // IOCTL for creating TOE preposted receive buffer ring for a given connection id.  A
   // TOE preposted buffer receive ring can only be created after a TOE transmit ring is
   // successfuly created. A TOE receive queue contains TOE_PREBUFFER entries (16 bytes
   // each). A TOE receive queue must be at least 256 entries deep (corresponding to 1
   // page) and at most 1k entries deep (corresponding to 4 pages). When the connection is
   // offloaded, the encoded ring size in the context must result in a ring fitting within
   // the number of pages posted with this IOCTL. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_UNAUTHORIZED_REQUEST -- the client is not authorized to create this
   // ring type.  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- this
   // ring type is either unavailable or all rings are already created. 
   typedef struct _IOCTL_TOE_RQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 num_pages;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_RQ_CREATE, *PIOCTL_TOE_RQ_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying a TOE transmit ring. The connection must be uploaded prior to
   // destroying the ring. If TOE preposted receive buffer ring was created in tandem with
   // the TOE transmit ring, the receive buffer ring must be destroyed first. 
   typedef struct _IOCTL_TOE_WRBQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_WRBQ_DESTROY, *PIOCTL_TOE_WRBQ_DESTROY;



#else
   // IOCTL for destroying a TOE transmit ring. The connection must be uploaded prior to
   // destroying the ring. If TOE preposted receive buffer ring was created in tandem with
   // the TOE transmit ring, the receive buffer ring must be destroyed first. 
   typedef struct _IOCTL_TOE_WRBQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_WRBQ_DESTROY, *PIOCTL_TOE_WRBQ_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying a TOE preposted buffer receive ring. The connection must be
   // uploaded prior to destroying the ring. 
   typedef struct _IOCTL_TOE_RQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_RQ_DESTROY, *PIOCTL_TOE_RQ_DESTROY;



#else
   // IOCTL for destroying a TOE preposted buffer receive ring. The connection must be
   // uploaded prior to destroying the ring. 
   typedef struct _IOCTL_TOE_RQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_RQ_DESTROY, *PIOCTL_TOE_RQ_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying a TOE default buffer receive ring. All TOE connections
   // associated with the default buffer receive ring must be uploaded prior to destroying
   // the ring. 
   typedef struct _IOCTL_TOE_DEFQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_DEFQ_DESTROY, *PIOCTL_TOE_DEFQ_DESTROY;



#else
   // IOCTL for destroying a TOE default buffer receive ring. All TOE connections
   // associated with the default buffer receive ring must be uploaded prior to destroying
   // the ring. 
   typedef struct _IOCTL_TOE_DEFQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_TOE_DEFQ_DESTROY, *PIOCTL_TOE_DEFQ_DESTROY;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_toe_bmap_h__

