/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __iscsi_context_bmap_h__
#define __iscsi_context_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "descriptors_bmap.h"
#include "iscsi_enums_bmap.h"
#include "common_context_bmap.h"
#include "iscsi_common_host_struct_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // The on-chip R2T context memory structure for iSCSI write commands. Note that for
   // each offloaded connection, an array of 32 R2T elements exists in that iSCSI
   // connection's context memory. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_R2T {
         union {
            struct { 
               u32 opcode : 4;                    // DWORD 0
               u32 valid2 : 1;                    // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
               u32 ttt;                           // DWORD 1
               u32 dataTransferLength : 20;       // DWORD 2
               u32 valid : 1;                     // DWORD 2
               u32 sgl_icd_index : 11;            // DWORD 2
               u32 bufferOffset;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_R2T, *PISCSI_R2T;

      SG_C_ASSERT(__sizeof__ISCSI_R2T, sizeof (ISCSI_R2T) == 16);

   #else
      typedef struct _ISCSI_R2T {
         u32 opcode : 4;                          // DWORD 0
         u32 valid2 : 1;                          // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
         u32 ttt;                                 // DWORD 1
         u32 dataTransferLength : 20;             // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 sgl_icd_index : 11;                  // DWORD 2
         u32 bufferOffset;                        // DWORD 3
      } SG_PACK ISCSI_R2T, *PISCSI_R2T;

      typedef union _ISCSI_R2T_UNION {
         ISCSI_R2T bits;
         u32 dw[4]; // dword union
      } SG_PACK ISCSI_R2T_UNION, *PISCSI_R2T_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_R2T_UNION, sizeof (ISCSI_R2T_UNION) == 16);
   #endif


#else
   // The on-chip R2T context memory structure for iSCSI write commands. Note that for
   // each offloaded connection, an array of 32 R2T elements exists in that iSCSI
   // connection's context memory. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_R2T {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 valid2 : 1;                    // DWORD 0
               u32 opcode : 4;                    // DWORD 0
               u32 ttt;                           // DWORD 1
               u32 sgl_icd_index : 11;            // DWORD 2
               u32 valid : 1;                     // DWORD 2
               u32 dataTransferLength : 20;       // DWORD 2
               u32 bufferOffset;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_R2T, *PISCSI_R2T;

      SG_C_ASSERT(__sizeof__ISCSI_R2T, sizeof (ISCSI_R2T) == 16);

   #else
      typedef struct _ISCSI_R2T {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 valid2 : 1;                          // DWORD 0
         u32 opcode : 4;                          // DWORD 0
         u32 ttt;                                 // DWORD 1
         u32 sgl_icd_index : 11;                  // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 dataTransferLength : 20;             // DWORD 2
         u32 bufferOffset;                        // DWORD 3
      } SG_PACK ISCSI_R2T, *PISCSI_R2T;

      typedef union _ISCSI_R2T_UNION {
         ISCSI_R2T bits;
         u32 dw[4]; // dword union
      } SG_PACK ISCSI_R2T_UNION, *PISCSI_R2T_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_R2T_UNION, sizeof (ISCSI_R2T_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The on-chip iSCSI context structure keeps track of per connection details for
   // processing an iSCSI commnad. Also, it keeps track of negotiated iSCSI parameters and
   // iSCSI mode specific fields. This structure is basically divided into Tx, Rx and
   // common fields. The contents of this structure differs for different mode of
   // operation. Color Code:  - orange : Hardware modified fields. Also, read only access
   // for EPs.  - green : iSCSI TX ULP read only accessed fields.  - brown : These fields
   // are copied from WRB structure and written into ICD structre. These fields are
   // maintained in iSCSI context sturcture for ICD context write optimization. These
   // fields will be written to ICD structure only once at the end of generating TX_D
   // descriptor. In case of crunch situation for iSCSI context memory space, these fields
   // can be utilised losing the optimization.  - blue : iSCSI TX ULP owned fields. Both
   // read/write access for iSCSI TX ULP.  - dark blue : Common read only fields for both
   // iSCSI TX ULP and RX ULP. Also, iSCSI TX ULP has write permission.  - yellow : Common
   // read only access fields.  - white : iSCSI RX ULP owned fields. Both read/write
   // access for iSCSI RX ULP.  - teal : Common read only fields for both iSCSI TX ULP and
   // RX ULP. Also, iSCSI RX ULP has write permission. iSCSI TX ULP has both read/write
   // permissions to common fields of iSCSI context, whereas iSCSI RX ULP has only read
   // permissions.  The following fields in iSCSI context structure should be initialized
   // by host driver while offloading the connection. Rest of the fields should be
   // initialized to zero.   - ring_context : With ring specific information.  -
   // maxSendDataSegmentLength : Negotiated value.  - firstburstLength : Negotiated value.
   //  - r2tConsumerIndex, r2tProducerIndex : 0  - tx_wrbindex_drv_msg,
   // rx_wrbindex_drv_msg : 0xFF  - ir2t, imd, ERL, DDE, HDE : Negotiated value.  -
   // exp_stat_sn : Expected status sequence number after login negotiation.  -
   // maxBurstLength : Negotiated value.  - complQueueID, defaultQueueID : Queue ID of
   // completion queue and default ring queue. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CONTEXT {
         union {
            struct { 
               RING_CONTEXT_ISCSI ring_context;
               u32 addr_hi_bhs;                   // DWORD 2
               u32 hde : 1;                       // DWORD 3
               u32 fbl : 14;                      // DWORD 3
               u32 max_snd_dsl : 17;              // DWORD 3
               u32 type : 4;                      // DWORD 4
               u32 over_run : 1;                  // DWORD 4
               u32 undr_run : 1;                  // DWORD 4
               u32 dmsg : 1;                      // DWORD 4
               u32 dsp : 1;                       // DWORD 4
               u32 wrb_idx : 8;                   // DWORD 4
               u32 rsvd0 : 1;                     // DWORD 4
               u32 lt : 1;                        // DWORD 4
               u32 lun : 14;                      // DWORD 4
               u32 addr_lo_bhs;                   // DWORD 5
               u32 ndr : 1;                       // DWORD 6
               u32 cic : 1;                       // DWORD 6
               u32 ipc_ooo_last : 1;              // DWORD 6
               u32 rsvd1 : 6;                     // DWORD 6
               u32 domain_id : 2;                 // DWORD 6
               u32 pbs : 1;                       // DWORD 6
               u32 dpdu_rid : 4;                  // DWORD 6
               u32 dcrp_tgl : 2;                  // DWORD 6
               u32 ooo_tx_hole_id : 1;            // DWORD 6
               u32 dde : 1;                       // DWORD 6
               u32 data_sn : 12;                  // DWORD 6
               u32 frag_offset : 16;              // DWORD 7
               u32 iscsi_ctxt_update : 1;         // DWORD 7
               u32 tx_state : 3;                  // DWORD 7
               u32 r2t_sn : 12;                   // DWORD 7
               u32 tx_curr_icd : 12;              // DWORD 8
               u32 tx_r2t_vld : 1;                // DWORD 8
               u32 bytes_left : 19;               // DWORD 8
               u32 r2t_ttt_pri_icd_resdCnt;       // DWORD 9
               u32 tx_wrb_idx_dmsg : 8;           // DWORD 10
               u32 icd_invld : 1;                 // DWORD 10
               u32 new_cnx : 1;                   // DWORD 10
               u32 invld : 1;                     // DWORD 10
               u32 mops : 1;                      // DWORD 10
               u32 ooo_last_ext : 1;              // DWORD 10
               u32 ooo_last : 10;                 // DWORD 10
               u32 curr_frag_ptr : 9;             // DWORD 10
               u32 tx_seq_num_dmsg;               // DWORD 11
               u32 stat_sn;                       // DWORD 12
               u32 mbl : 19;                      // DWORD 13
               u32 ooo_hole_id : 1;               // DWORD 13
               u32 ooo_replay : 1;                // DWORD 13
               u32 ooo_tail_ext : 1;              // DWORD 13
               u32 ooo_tail : 10;                 // DWORD 13
               u32 r2t_pidx : 7;                  // DWORD 14
               u32 compltonack : 1;               // DWORD 14
               u32 rsvd2 : 1;                     // DWORD 14
               u32 cq_id : 10;                    // DWORD 14
               u32 ir2t : 1;                      // DWORD 14
               u32 imm : 1;                       // DWORD 14
               u32 erl : 2;                       // DWORD 14
               u32 mode : 1;                      // DWORD 14
               u32 rx_wrb_idx_dmsg : 8;           // DWORD 14
               u32 rx_seq_num_dmsg;               // DWORD 15
               u32 partial_hdr[13];               // DWORDS 16 to 28
               u32 last_sol_pdu : 1;              // DWORD 29
               u32 icd_inv : 1;                   // DWORD 29
               u32 dif_mode : 2;                  // DWORD 29
               u32 icd_state : 2;                 // DWORD 29
               u32 partial_data : 10;             // DWORD 29
               u32 partial_dif : 4;               // DWORD 29
               u32 rx_state : 3;                  // DWORD 29
               u32 rx_r2t_vld : 1;                // DWORD 29
               u32 sop : 1;                       // DWORD 29
               u32 spl_pdu : 1;                   // DWORD 29
               u32 pdu_type : 1;                  // DWORD 29
               u32 pad_bytes : 2;                 // DWORD 29
               u32 crc_bytes : 3;                 // DWORD 29
               u32 rsvd3 : 1;                     // DWORD 30
               u32 partial_seg : 1;               // DWORD 30
               u32 dpdu_data_offset : 14;         // DWORD 30
               u32 dpdu_ref_hndl : 16;            // DWORD 30
               u32 rsvd4 : 2;                     // DWORD 31
               u32 hdr_bytes_left : 6;            // DWORD 31
               u32 pdu_bytes_rcvd : 24;           // DWORD 31
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CONTEXT, *PISCSI_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_CONTEXT, sizeof (ISCSI_CONTEXT) == 128);

   #else
      typedef struct _ISCSI_CONTEXT {
         RING_CONTEXT_ISCSI ring_context;
         u32 addr_hi_bhs;                         // DWORD 2
         u32 hde : 1;                             // DWORD 3
         u32 fbl : 14;                            // DWORD 3
         u32 max_snd_dsl : 17;                    // DWORD 3
         u32 type : 4;                            // DWORD 4
         u32 over_run : 1;                        // DWORD 4
         u32 undr_run : 1;                        // DWORD 4
         u32 dmsg : 1;                            // DWORD 4
         u32 dsp : 1;                             // DWORD 4
         u32 wrb_idx : 8;                         // DWORD 4
         u32 rsvd0 : 1;                           // DWORD 4
         u32 lt : 1;                              // DWORD 4
         u32 lun : 14;                            // DWORD 4
         u32 addr_lo_bhs;                         // DWORD 5
         u32 ndr : 1;                             // DWORD 6
         u32 cic : 1;                             // DWORD 6
         u32 ipc_ooo_last : 1;                    // DWORD 6
         u32 rsvd1 : 6;                           // DWORD 6
         u32 domain_id : 2;                       // DWORD 6
         u32 pbs : 1;                             // DWORD 6
         u32 dpdu_rid : 4;                        // DWORD 6
         u32 dcrp_tgl : 2;                        // DWORD 6
         u32 ooo_tx_hole_id : 1;                  // DWORD 6
         u32 dde : 1;                             // DWORD 6
         u32 data_sn : 12;                        // DWORD 6
         u32 frag_offset : 16;                    // DWORD 7
         u32 iscsi_ctxt_update : 1;               // DWORD 7
         u32 tx_state : 3;                        // DWORD 7
         u32 r2t_sn : 12;                         // DWORD 7
         u32 tx_curr_icd : 12;                    // DWORD 8
         u32 tx_r2t_vld : 1;                      // DWORD 8
         u32 bytes_left : 19;                     // DWORD 8
         u32 r2t_ttt_pri_icd_resdCnt;             // DWORD 9
         u32 tx_wrb_idx_dmsg : 8;                 // DWORD 10
         u32 icd_invld : 1;                       // DWORD 10
         u32 new_cnx : 1;                         // DWORD 10
         u32 invld : 1;                           // DWORD 10
         u32 mops : 1;                            // DWORD 10
         u32 ooo_last_ext : 1;                    // DWORD 10
         u32 ooo_last : 10;                       // DWORD 10
         u32 curr_frag_ptr : 9;                   // DWORD 10
         u32 tx_seq_num_dmsg;                     // DWORD 11
         u32 stat_sn;                             // DWORD 12
         u32 mbl : 19;                            // DWORD 13
         u32 ooo_hole_id : 1;                     // DWORD 13
         u32 ooo_replay : 1;                      // DWORD 13
         u32 ooo_tail_ext : 1;                    // DWORD 13
         u32 ooo_tail : 10;                       // DWORD 13
         u32 r2t_pidx : 7;                        // DWORD 14
         u32 compltonack : 1;                     // DWORD 14
         u32 rsvd2 : 1;                           // DWORD 14
         u32 cq_id : 10;                          // DWORD 14
         u32 ir2t : 1;                            // DWORD 14
         u32 imm : 1;                             // DWORD 14
         u32 erl : 2;                             // DWORD 14
         u32 mode : 1;                            // DWORD 14
         u32 rx_wrb_idx_dmsg : 8;                 // DWORD 14
         u32 rx_seq_num_dmsg;                     // DWORD 15
         u32 partial_hdr[13];                     // DWORDS 16 to 28
         u32 last_sol_pdu : 1;                    // DWORD 29
         u32 icd_inv : 1;                         // DWORD 29
         u32 dif_mode : 2;                        // DWORD 29
         u32 icd_state : 2;                       // DWORD 29
         u32 partial_data : 10;                   // DWORD 29
         u32 partial_dif : 4;                     // DWORD 29
         u32 rx_state : 3;                        // DWORD 29
         u32 rx_r2t_vld : 1;                      // DWORD 29
         u32 sop : 1;                             // DWORD 29
         u32 spl_pdu : 1;                         // DWORD 29
         u32 pdu_type : 1;                        // DWORD 29
         u32 pad_bytes : 2;                       // DWORD 29
         u32 crc_bytes : 3;                       // DWORD 29
         u32 rsvd3 : 1;                           // DWORD 30
         u32 partial_seg : 1;                     // DWORD 30
         u32 dpdu_data_offset : 14;               // DWORD 30
         u32 dpdu_ref_hndl : 16;                  // DWORD 30
         u32 rsvd4 : 2;                           // DWORD 31
         u32 hdr_bytes_left : 6;                  // DWORD 31
         u32 pdu_bytes_rcvd : 24;                 // DWORD 31
      } SG_PACK ISCSI_CONTEXT, *PISCSI_CONTEXT;

      typedef union _ISCSI_CONTEXT_UNION {
         ISCSI_CONTEXT bits;
         u32 dw[32]; // dword union
      } SG_PACK ISCSI_CONTEXT_UNION, *PISCSI_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CONTEXT_UNION, sizeof (ISCSI_CONTEXT_UNION) == 128);
   #endif


#else
   // The on-chip iSCSI context structure keeps track of per connection details for
   // processing an iSCSI commnad. Also, it keeps track of negotiated iSCSI parameters and
   // iSCSI mode specific fields. This structure is basically divided into Tx, Rx and
   // common fields. The contents of this structure differs for different mode of
   // operation. Color Code:  - orange : Hardware modified fields. Also, read only access
   // for EPs.  - green : iSCSI TX ULP read only accessed fields.  - brown : These fields
   // are copied from WRB structure and written into ICD structre. These fields are
   // maintained in iSCSI context sturcture for ICD context write optimization. These
   // fields will be written to ICD structure only once at the end of generating TX_D
   // descriptor. In case of crunch situation for iSCSI context memory space, these fields
   // can be utilised losing the optimization.  - blue : iSCSI TX ULP owned fields. Both
   // read/write access for iSCSI TX ULP.  - dark blue : Common read only fields for both
   // iSCSI TX ULP and RX ULP. Also, iSCSI TX ULP has write permission.  - yellow : Common
   // read only access fields.  - white : iSCSI RX ULP owned fields. Both read/write
   // access for iSCSI RX ULP.  - teal : Common read only fields for both iSCSI TX ULP and
   // RX ULP. Also, iSCSI RX ULP has write permission. iSCSI TX ULP has both read/write
   // permissions to common fields of iSCSI context, whereas iSCSI RX ULP has only read
   // permissions.  The following fields in iSCSI context structure should be initialized
   // by host driver while offloading the connection. Rest of the fields should be
   // initialized to zero.   - ring_context : With ring specific information.  -
   // maxSendDataSegmentLength : Negotiated value.  - firstburstLength : Negotiated value.
   //  - r2tConsumerIndex, r2tProducerIndex : 0  - tx_wrbindex_drv_msg,
   // rx_wrbindex_drv_msg : 0xFF  - ir2t, imd, ERL, DDE, HDE : Negotiated value.  -
   // exp_stat_sn : Expected status sequence number after login negotiation.  -
   // maxBurstLength : Negotiated value.  - complQueueID, defaultQueueID : Queue ID of
   // completion queue and default ring queue. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CONTEXT {
         union {
            struct { 
               RING_CONTEXT_ISCSI ring_context;
               u32 addr_hi_bhs;                   // DWORD 2
               u32 max_snd_dsl : 17;              // DWORD 3
               u32 fbl : 14;                      // DWORD 3
               u32 hde : 1;                       // DWORD 3
               u32 lun : 14;                      // DWORD 4
               u32 lt : 1;                        // DWORD 4
               u32 rsvd0 : 1;                     // DWORD 4
               u32 wrb_idx : 8;                   // DWORD 4
               u32 dsp : 1;                       // DWORD 4
               u32 dmsg : 1;                      // DWORD 4
               u32 undr_run : 1;                  // DWORD 4
               u32 over_run : 1;                  // DWORD 4
               u32 type : 4;                      // DWORD 4
               u32 addr_lo_bhs;                   // DWORD 5
               u32 data_sn : 12;                  // DWORD 6
               u32 dde : 1;                       // DWORD 6
               u32 ooo_tx_hole_id : 1;            // DWORD 6
               u32 dcrp_tgl : 2;                  // DWORD 6
               u32 dpdu_rid : 4;                  // DWORD 6
               u32 pbs : 1;                       // DWORD 6
               u32 domain_id : 2;                 // DWORD 6
               u32 rsvd1 : 6;                     // DWORD 6
               u32 ipc_ooo_last : 1;              // DWORD 6
               u32 cic : 1;                       // DWORD 6
               u32 ndr : 1;                       // DWORD 6
               u32 r2t_sn : 12;                   // DWORD 7
               u32 tx_state : 3;                  // DWORD 7
               u32 iscsi_ctxt_update : 1;         // DWORD 7
               u32 frag_offset : 16;              // DWORD 7
               u32 bytes_left : 19;               // DWORD 8
               u32 tx_r2t_vld : 1;                // DWORD 8
               u32 tx_curr_icd : 12;              // DWORD 8
               u32 r2t_ttt_pri_icd_resdCnt;       // DWORD 9
               u32 curr_frag_ptr : 9;             // DWORD 10
               u32 ooo_last : 10;                 // DWORD 10
               u32 ooo_last_ext : 1;              // DWORD 10
               u32 mops : 1;                      // DWORD 10
               u32 invld : 1;                     // DWORD 10
               u32 new_cnx : 1;                   // DWORD 10
               u32 icd_invld : 1;                 // DWORD 10
               u32 tx_wrb_idx_dmsg : 8;           // DWORD 10
               u32 tx_seq_num_dmsg;               // DWORD 11
               u32 stat_sn;                       // DWORD 12
               u32 ooo_tail : 10;                 // DWORD 13
               u32 ooo_tail_ext : 1;              // DWORD 13
               u32 ooo_replay : 1;                // DWORD 13
               u32 ooo_hole_id : 1;               // DWORD 13
               u32 mbl : 19;                      // DWORD 13
               u32 rx_wrb_idx_dmsg : 8;           // DWORD 14
               u32 mode : 1;                      // DWORD 14
               u32 erl : 2;                       // DWORD 14
               u32 imm : 1;                       // DWORD 14
               u32 ir2t : 1;                      // DWORD 14
               u32 cq_id : 10;                    // DWORD 14
               u32 rsvd2 : 1;                     // DWORD 14
               u32 compltonack : 1;               // DWORD 14
               u32 r2t_pidx : 7;                  // DWORD 14
               u32 rx_seq_num_dmsg;               // DWORD 15
               u32 partial_hdr[13];               // DWORDS 16 to 28
               u32 crc_bytes : 3;                 // DWORD 29
               u32 pad_bytes : 2;                 // DWORD 29
               u32 pdu_type : 1;                  // DWORD 29
               u32 spl_pdu : 1;                   // DWORD 29
               u32 sop : 1;                       // DWORD 29
               u32 rx_r2t_vld : 1;                // DWORD 29
               u32 rx_state : 3;                  // DWORD 29
               u32 partial_dif : 4;               // DWORD 29
               u32 partial_data : 10;             // DWORD 29
               u32 icd_state : 2;                 // DWORD 29
               u32 dif_mode : 2;                  // DWORD 29
               u32 icd_inv : 1;                   // DWORD 29
               u32 last_sol_pdu : 1;              // DWORD 29
               u32 dpdu_ref_hndl : 16;            // DWORD 30
               u32 dpdu_data_offset : 14;         // DWORD 30
               u32 partial_seg : 1;               // DWORD 30
               u32 rsvd3 : 1;                     // DWORD 30
               u32 pdu_bytes_rcvd : 24;           // DWORD 31
               u32 hdr_bytes_left : 6;            // DWORD 31
               u32 rsvd4 : 2;                     // DWORD 31
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CONTEXT, *PISCSI_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_CONTEXT, sizeof (ISCSI_CONTEXT) == 128);

   #else
      typedef struct _ISCSI_CONTEXT {
         RING_CONTEXT_ISCSI ring_context;
         u32 addr_hi_bhs;                         // DWORD 2
         u32 max_snd_dsl : 17;                    // DWORD 3
         u32 fbl : 14;                            // DWORD 3
         u32 hde : 1;                             // DWORD 3
         u32 lun : 14;                            // DWORD 4
         u32 lt : 1;                              // DWORD 4
         u32 rsvd0 : 1;                           // DWORD 4
         u32 wrb_idx : 8;                         // DWORD 4
         u32 dsp : 1;                             // DWORD 4
         u32 dmsg : 1;                            // DWORD 4
         u32 undr_run : 1;                        // DWORD 4
         u32 over_run : 1;                        // DWORD 4
         u32 type : 4;                            // DWORD 4
         u32 addr_lo_bhs;                         // DWORD 5
         u32 data_sn : 12;                        // DWORD 6
         u32 dde : 1;                             // DWORD 6
         u32 ooo_tx_hole_id : 1;                  // DWORD 6
         u32 dcrp_tgl : 2;                        // DWORD 6
         u32 dpdu_rid : 4;                        // DWORD 6
         u32 pbs : 1;                             // DWORD 6
         u32 domain_id : 2;                       // DWORD 6
         u32 rsvd1 : 6;                           // DWORD 6
         u32 ipc_ooo_last : 1;                    // DWORD 6
         u32 cic : 1;                             // DWORD 6
         u32 ndr : 1;                             // DWORD 6
         u32 r2t_sn : 12;                         // DWORD 7
         u32 tx_state : 3;                        // DWORD 7
         u32 iscsi_ctxt_update : 1;               // DWORD 7
         u32 frag_offset : 16;                    // DWORD 7
         u32 bytes_left : 19;                     // DWORD 8
         u32 tx_r2t_vld : 1;                      // DWORD 8
         u32 tx_curr_icd : 12;                    // DWORD 8
         u32 r2t_ttt_pri_icd_resdCnt;             // DWORD 9
         u32 curr_frag_ptr : 9;                   // DWORD 10
         u32 ooo_last : 10;                       // DWORD 10
         u32 ooo_last_ext : 1;                    // DWORD 10
         u32 mops : 1;                            // DWORD 10
         u32 invld : 1;                           // DWORD 10
         u32 new_cnx : 1;                         // DWORD 10
         u32 icd_invld : 1;                       // DWORD 10
         u32 tx_wrb_idx_dmsg : 8;                 // DWORD 10
         u32 tx_seq_num_dmsg;                     // DWORD 11
         u32 stat_sn;                             // DWORD 12
         u32 ooo_tail : 10;                       // DWORD 13
         u32 ooo_tail_ext : 1;                    // DWORD 13
         u32 ooo_replay : 1;                      // DWORD 13
         u32 ooo_hole_id : 1;                     // DWORD 13
         u32 mbl : 19;                            // DWORD 13
         u32 rx_wrb_idx_dmsg : 8;                 // DWORD 14
         u32 mode : 1;                            // DWORD 14
         u32 erl : 2;                             // DWORD 14
         u32 imm : 1;                             // DWORD 14
         u32 ir2t : 1;                            // DWORD 14
         u32 cq_id : 10;                          // DWORD 14
         u32 rsvd2 : 1;                           // DWORD 14
         u32 compltonack : 1;                     // DWORD 14
         u32 r2t_pidx : 7;                        // DWORD 14
         u32 rx_seq_num_dmsg;                     // DWORD 15
         u32 partial_hdr[13];                     // DWORDS 16 to 28
         u32 crc_bytes : 3;                       // DWORD 29
         u32 pad_bytes : 2;                       // DWORD 29
         u32 pdu_type : 1;                        // DWORD 29
         u32 spl_pdu : 1;                         // DWORD 29
         u32 sop : 1;                             // DWORD 29
         u32 rx_r2t_vld : 1;                      // DWORD 29
         u32 rx_state : 3;                        // DWORD 29
         u32 partial_dif : 4;                     // DWORD 29
         u32 partial_data : 10;                   // DWORD 29
         u32 icd_state : 2;                       // DWORD 29
         u32 dif_mode : 2;                        // DWORD 29
         u32 icd_inv : 1;                         // DWORD 29
         u32 last_sol_pdu : 1;                    // DWORD 29
         u32 dpdu_ref_hndl : 16;                  // DWORD 30
         u32 dpdu_data_offset : 14;               // DWORD 30
         u32 partial_seg : 1;                     // DWORD 30
         u32 rsvd3 : 1;                           // DWORD 30
         u32 pdu_bytes_rcvd : 24;                 // DWORD 31
         u32 hdr_bytes_left : 6;                  // DWORD 31
         u32 rsvd4 : 2;                           // DWORD 31
      } SG_PACK ISCSI_CONTEXT, *PISCSI_CONTEXT;

      typedef union _ISCSI_CONTEXT_UNION {
         ISCSI_CONTEXT bits;
         u32 dw[32]; // dword union
      } SG_PACK ISCSI_CONTEXT_UNION, *PISCSI_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CONTEXT_UNION, sizeof (ISCSI_CONTEXT_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The on-chip ICD context structure maintains command plus data placement specific
   // details. The BE iSCSI Initiator/target architecture supports 2K commands, with 256
   // commands outstanding per connection at any point of time. The ICD index are
   // maintained in host driver and one of the ICD gets statically allocated per request.
   // The iSCSI TX ULP populates the ICD structure upon receiving WRB request
   // ISCSI_TARGET_DATAIN_WRB from host driver. The ICD context struture will be valid for
   // life time of the command/request. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ICD_CONTEXT {
         union {
            struct { 
               u32 opcode : 4;                    // DWORD 0
               u32 O : 1;                         // DWORD 0
               u32 U : 1;                         // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 wrbindex : 8;                  // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 LUN : 14;                      // DWORD 0
               u32 cid : 10;                      // DWORD 1
               u32 run_len : 22;                  // DWORD 1
               u32 r2t_sn_xfr_length : 17;        // DWORD 2
               u32 lfbit : 1;                     // DWORD 2
               u32 r2tbit : 1;                    // DWORD 2
               u32 p_sgl_idx : 1;                 // DWORD 2
               u32 data_sn : 12;                  // DWORD 2
               u32 last_sol_pdu : 1;              // DWORD 3
               u32 icd_inv : 1;                   // DWORD 3
               u32 dif_mode : 2;                  // DWORD 3
               u32 icd_state : 2;                 // DWORD 3
               u32 partial_data : 10;             // DWORD 3
               u32 partial_dif : 4;               // DWORD 3
               u32 rsvd0 : 12;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ICD_CONTEXT, *PICD_CONTEXT;

      SG_C_ASSERT(__sizeof__ICD_CONTEXT, sizeof (ICD_CONTEXT) == 16);

   #else
      typedef struct _ICD_CONTEXT {
         u32 opcode : 4;                          // DWORD 0
         u32 O : 1;                               // DWORD 0
         u32 U : 1;                               // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 wrbindex : 8;                        // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 LUN : 14;                            // DWORD 0
         u32 cid : 10;                            // DWORD 1
         u32 run_len : 22;                        // DWORD 1
         u32 r2t_sn_xfr_length : 17;              // DWORD 2
         u32 lfbit : 1;                           // DWORD 2
         u32 r2tbit : 1;                          // DWORD 2
         u32 p_sgl_idx : 1;                       // DWORD 2
         u32 data_sn : 12;                        // DWORD 2
         u32 last_sol_pdu : 1;                    // DWORD 3
         u32 icd_inv : 1;                         // DWORD 3
         u32 dif_mode : 2;                        // DWORD 3
         u32 icd_state : 2;                       // DWORD 3
         u32 partial_data : 10;                   // DWORD 3
         u32 partial_dif : 4;                     // DWORD 3
         u32 rsvd0 : 12;                          // DWORD 3
      } SG_PACK ICD_CONTEXT, *PICD_CONTEXT;

      typedef union _ICD_CONTEXT_UNION {
         ICD_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK ICD_CONTEXT_UNION, *PICD_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ICD_CONTEXT_UNION, sizeof (ICD_CONTEXT_UNION) == 16);
   #endif


#else
   // The on-chip ICD context structure maintains command plus data placement specific
   // details. The BE iSCSI Initiator/target architecture supports 2K commands, with 256
   // commands outstanding per connection at any point of time. The ICD index are
   // maintained in host driver and one of the ICD gets statically allocated per request.
   // The iSCSI TX ULP populates the ICD structure upon receiving WRB request
   // ISCSI_TARGET_DATAIN_WRB from host driver. The ICD context struture will be valid for
   // life time of the command/request. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ICD_CONTEXT {
         union {
            struct { 
               u32 LUN : 14;                      // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 wrbindex : 8;                  // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 U : 1;                         // DWORD 0
               u32 O : 1;                         // DWORD 0
               u32 opcode : 4;                    // DWORD 0
               u32 run_len : 22;                  // DWORD 1
               u32 cid : 10;                      // DWORD 1
               u32 data_sn : 12;                  // DWORD 2
               u32 p_sgl_idx : 1;                 // DWORD 2
               u32 r2tbit : 1;                    // DWORD 2
               u32 lfbit : 1;                     // DWORD 2
               u32 r2t_sn_xfr_length : 17;        // DWORD 2
               u32 rsvd0 : 12;                    // DWORD 3
               u32 partial_dif : 4;               // DWORD 3
               u32 partial_data : 10;             // DWORD 3
               u32 icd_state : 2;                 // DWORD 3
               u32 dif_mode : 2;                  // DWORD 3
               u32 icd_inv : 1;                   // DWORD 3
               u32 last_sol_pdu : 1;              // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ICD_CONTEXT, *PICD_CONTEXT;

      SG_C_ASSERT(__sizeof__ICD_CONTEXT, sizeof (ICD_CONTEXT) == 16);

   #else
      typedef struct _ICD_CONTEXT {
         u32 LUN : 14;                            // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 wrbindex : 8;                        // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 U : 1;                               // DWORD 0
         u32 O : 1;                               // DWORD 0
         u32 opcode : 4;                          // DWORD 0
         u32 run_len : 22;                        // DWORD 1
         u32 cid : 10;                            // DWORD 1
         u32 data_sn : 12;                        // DWORD 2
         u32 p_sgl_idx : 1;                       // DWORD 2
         u32 r2tbit : 1;                          // DWORD 2
         u32 lfbit : 1;                           // DWORD 2
         u32 r2t_sn_xfr_length : 17;              // DWORD 2
         u32 rsvd0 : 12;                          // DWORD 3
         u32 partial_dif : 4;                     // DWORD 3
         u32 partial_data : 10;                   // DWORD 3
         u32 icd_state : 2;                       // DWORD 3
         u32 dif_mode : 2;                        // DWORD 3
         u32 icd_inv : 1;                         // DWORD 3
         u32 last_sol_pdu : 1;                    // DWORD 3
      } SG_PACK ICD_CONTEXT, *PICD_CONTEXT;

      typedef union _ICD_CONTEXT_UNION {
         ICD_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK ICD_CONTEXT_UNION, *PICD_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ICD_CONTEXT_UNION, sizeof (ICD_CONTEXT_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The on-chip ICD context structure maintains command plus data placement specific
   // details. The BE iSCSI Initiator/target architecture supports 2K commands, with 256
   // commands outstanding per connection at any point of time. The ICD index are
   // maintained in host driver and one of the ICD gets statically allocated per request.
   // The iSCSI TX ULP populates the ICD structure upon receiving WRB request
   // ISCSI_TARGET_DATAIN_WRB from host driver. The ICD context struture will be valid for
   // life time of the command/request. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ICD_DIF_CONTEXT {
         union {
            struct { 
               u32 opcode : 4;                    // DWORD 0
               u32 O : 1;                         // DWORD 0
               u32 U : 1;                         // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 wrbindex : 8;                  // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 LUN : 14;                      // DWORD 0
               u32 cid : 10;                      // DWORD 1
               u32 run_len : 22;                  // DWORD 1
               u32 r2t_sn_xfr_length : 17;        // DWORD 2
               u32 lfbit : 1;                     // DWORD 2
               u32 r2tbit : 1;                    // DWORD 2
               u32 p_sgl_idx : 1;                 // DWORD 2
               u32 data_sn : 12;                  // DWORD 2
               u32 last_sol_pdu : 1;              // DWORD 3
               u32 icd_inv : 1;                   // DWORD 3
               u32 dif_mode : 2;                  // DWORD 3
               u32 icd_state : 2;                 // DWORD 3
               u32 partial_data : 10;             // DWORD 3
               u32 partial_dif : 4;               // DWORD 3
               u32 rsvd0 : 12;                    // DWORD 3
               u32 partialcrc : 16;               // DWORD 4
               u32 metadata : 16;                 // DWORD 4
               u32 expreftag;                     // DWORD 5
               u32 ErrValid : 1;                  // DWORD 6
               u32 rsvd2 : 1;                     // DWORD 6
               u32 m : 2;                         // DWORD 6
               u32 bs : 2;                        // DWORD 6
               u32 rsvd1 : 6;                     // DWORD 6
               u32 dsbl_ref : 1;                  // DWORD 6
               u32 dsbl_meta : 1;                 // DWORD 6
               u32 dsbl_crc : 1;                  // DWORD 6
               u32 err : 1;                       // DWORD 6
               u32 runlen : 16;                   // DWORD 6
               u32 newreftag;                     // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK ICD_DIF_CONTEXT, *PICD_DIF_CONTEXT;

      SG_C_ASSERT(__sizeof__ICD_DIF_CONTEXT, sizeof (ICD_DIF_CONTEXT) == 32);

   #else
      typedef struct _ICD_DIF_CONTEXT {
         u32 opcode : 4;                          // DWORD 0
         u32 O : 1;                               // DWORD 0
         u32 U : 1;                               // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 wrbindex : 8;                        // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 LUN : 14;                            // DWORD 0
         u32 cid : 10;                            // DWORD 1
         u32 run_len : 22;                        // DWORD 1
         u32 r2t_sn_xfr_length : 17;              // DWORD 2
         u32 lfbit : 1;                           // DWORD 2
         u32 r2tbit : 1;                          // DWORD 2
         u32 p_sgl_idx : 1;                       // DWORD 2
         u32 data_sn : 12;                        // DWORD 2
         u32 last_sol_pdu : 1;                    // DWORD 3
         u32 icd_inv : 1;                         // DWORD 3
         u32 dif_mode : 2;                        // DWORD 3
         u32 icd_state : 2;                       // DWORD 3
         u32 partial_data : 10;                   // DWORD 3
         u32 partial_dif : 4;                     // DWORD 3
         u32 rsvd0 : 12;                          // DWORD 3
         u32 partialcrc : 16;                     // DWORD 4
         u32 metadata : 16;                       // DWORD 4
         u32 expreftag;                           // DWORD 5
         u32 ErrValid : 1;                        // DWORD 6
         u32 rsvd2 : 1;                           // DWORD 6
         u32 m : 2;                               // DWORD 6
         u32 bs : 2;                              // DWORD 6
         u32 rsvd1 : 6;                           // DWORD 6
         u32 dsbl_ref : 1;                        // DWORD 6
         u32 dsbl_meta : 1;                       // DWORD 6
         u32 dsbl_crc : 1;                        // DWORD 6
         u32 err : 1;                             // DWORD 6
         u32 runlen : 16;                         // DWORD 6
         u32 newreftag;                           // DWORD 7
      } SG_PACK ICD_DIF_CONTEXT, *PICD_DIF_CONTEXT;

      typedef union _ICD_DIF_CONTEXT_UNION {
         ICD_DIF_CONTEXT bits;
         u32 dw[8]; // dword union
      } SG_PACK ICD_DIF_CONTEXT_UNION, *PICD_DIF_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ICD_DIF_CONTEXT_UNION, sizeof (ICD_DIF_CONTEXT_UNION) == 32);
   #endif


#else
   // The on-chip ICD context structure maintains command plus data placement specific
   // details. The BE iSCSI Initiator/target architecture supports 2K commands, with 256
   // commands outstanding per connection at any point of time. The ICD index are
   // maintained in host driver and one of the ICD gets statically allocated per request.
   // The iSCSI TX ULP populates the ICD structure upon receiving WRB request
   // ISCSI_TARGET_DATAIN_WRB from host driver. The ICD context struture will be valid for
   // life time of the command/request. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ICD_DIF_CONTEXT {
         union {
            struct { 
               u32 LUN : 14;                      // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 wrbindex : 8;                  // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 U : 1;                         // DWORD 0
               u32 O : 1;                         // DWORD 0
               u32 opcode : 4;                    // DWORD 0
               u32 run_len : 22;                  // DWORD 1
               u32 cid : 10;                      // DWORD 1
               u32 data_sn : 12;                  // DWORD 2
               u32 p_sgl_idx : 1;                 // DWORD 2
               u32 r2tbit : 1;                    // DWORD 2
               u32 lfbit : 1;                     // DWORD 2
               u32 r2t_sn_xfr_length : 17;        // DWORD 2
               u32 rsvd0 : 12;                    // DWORD 3
               u32 partial_dif : 4;               // DWORD 3
               u32 partial_data : 10;             // DWORD 3
               u32 icd_state : 2;                 // DWORD 3
               u32 dif_mode : 2;                  // DWORD 3
               u32 icd_inv : 1;                   // DWORD 3
               u32 last_sol_pdu : 1;              // DWORD 3
               u32 metadata : 16;                 // DWORD 4
               u32 partialcrc : 16;               // DWORD 4
               u32 expreftag;                     // DWORD 5
               u32 runlen : 16;                   // DWORD 6
               u32 err : 1;                       // DWORD 6
               u32 dsbl_crc : 1;                  // DWORD 6
               u32 dsbl_meta : 1;                 // DWORD 6
               u32 dsbl_ref : 1;                  // DWORD 6
               u32 rsvd1 : 6;                     // DWORD 6
               u32 bs : 2;                        // DWORD 6
               u32 m : 2;                         // DWORD 6
               u32 rsvd2 : 1;                     // DWORD 6
               u32 ErrValid : 1;                  // DWORD 6
               u32 newreftag;                     // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK ICD_DIF_CONTEXT, *PICD_DIF_CONTEXT;

      SG_C_ASSERT(__sizeof__ICD_DIF_CONTEXT, sizeof (ICD_DIF_CONTEXT) == 32);

   #else
      typedef struct _ICD_DIF_CONTEXT {
         u32 LUN : 14;                            // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 wrbindex : 8;                        // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 U : 1;                               // DWORD 0
         u32 O : 1;                               // DWORD 0
         u32 opcode : 4;                          // DWORD 0
         u32 run_len : 22;                        // DWORD 1
         u32 cid : 10;                            // DWORD 1
         u32 data_sn : 12;                        // DWORD 2
         u32 p_sgl_idx : 1;                       // DWORD 2
         u32 r2tbit : 1;                          // DWORD 2
         u32 lfbit : 1;                           // DWORD 2
         u32 r2t_sn_xfr_length : 17;              // DWORD 2
         u32 rsvd0 : 12;                          // DWORD 3
         u32 partial_dif : 4;                     // DWORD 3
         u32 partial_data : 10;                   // DWORD 3
         u32 icd_state : 2;                       // DWORD 3
         u32 dif_mode : 2;                        // DWORD 3
         u32 icd_inv : 1;                         // DWORD 3
         u32 last_sol_pdu : 1;                    // DWORD 3
         u32 metadata : 16;                       // DWORD 4
         u32 partialcrc : 16;                     // DWORD 4
         u32 expreftag;                           // DWORD 5
         u32 runlen : 16;                         // DWORD 6
         u32 err : 1;                             // DWORD 6
         u32 dsbl_crc : 1;                        // DWORD 6
         u32 dsbl_meta : 1;                       // DWORD 6
         u32 dsbl_ref : 1;                        // DWORD 6
         u32 rsvd1 : 6;                           // DWORD 6
         u32 bs : 2;                              // DWORD 6
         u32 m : 2;                               // DWORD 6
         u32 rsvd2 : 1;                           // DWORD 6
         u32 ErrValid : 1;                        // DWORD 6
         u32 newreftag;                           // DWORD 7
      } SG_PACK ICD_DIF_CONTEXT, *PICD_DIF_CONTEXT;

      typedef union _ICD_DIF_CONTEXT_UNION {
         ICD_DIF_CONTEXT bits;
         u32 dw[8]; // dword union
      } SG_PACK ICD_DIF_CONTEXT_UNION, *PICD_DIF_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ICD_DIF_CONTEXT_UNION, sizeof (ICD_DIF_CONTEXT_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The ITT information stored per R2T request for validation. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_ITT {
         union {
            struct { 
               u32 itt;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_ITT, *PISCSI_ITT;

      SG_C_ASSERT(__sizeof__ISCSI_ITT, sizeof (ISCSI_ITT) == 4);

   #else
      typedef struct _ISCSI_ITT {
         u32 itt;                                 // DWORD 0
      } SG_PACK ISCSI_ITT, *PISCSI_ITT;

      typedef union _ISCSI_ITT_UNION {
         ISCSI_ITT bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_ITT_UNION, *PISCSI_ITT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_ITT_UNION, sizeof (ISCSI_ITT_UNION) == 4);
   #endif


#else
   // The ITT information stored per R2T request for validation. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_ITT {
         union {
            struct { 
               u32 itt;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_ITT, *PISCSI_ITT;

      SG_C_ASSERT(__sizeof__ISCSI_ITT, sizeof (ISCSI_ITT) == 4);

   #else
      typedef struct _ISCSI_ITT {
         u32 itt;                                 // DWORD 0
      } SG_PACK ISCSI_ITT, *PISCSI_ITT;

      typedef union _ISCSI_ITT_UNION {
         ISCSI_ITT bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_ITT_UNION, *PISCSI_ITT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_ITT_UNION, sizeof (ISCSI_ITT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Format of default buffer SG frag in default PDU default ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_DB_SGE {
         union {
            struct { 
               u32 addr_hi;                       // DWORD 0
               u32 addr_lo;                       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK CTX_DB_SGE, *PCTX_DB_SGE;

      SG_C_ASSERT(__sizeof__CTX_DB_SGE, sizeof (CTX_DB_SGE) == 8);

   #else
      typedef struct _CTX_DB_SGE {
         u32 addr_hi;                             // DWORD 0
         u32 addr_lo;                             // DWORD 1
      } SG_PACK CTX_DB_SGE, *PCTX_DB_SGE;

      typedef union _CTX_DB_SGE_UNION {
         CTX_DB_SGE bits;
         u32 dw[2]; // dword union
      } SG_PACK CTX_DB_SGE_UNION, *PCTX_DB_SGE_UNION;

      SG_C_ASSERT(__sizeof__CTX_DB_SGE_UNION, sizeof (CTX_DB_SGE_UNION) == 8);
   #endif


#else
   // Format of default buffer SG frag in default PDU default ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_DB_SGE {
         union {
            struct { 
               u32 addr_hi;                       // DWORD 0
               u32 addr_lo;                       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK CTX_DB_SGE, *PCTX_DB_SGE;

      SG_C_ASSERT(__sizeof__CTX_DB_SGE, sizeof (CTX_DB_SGE) == 8);

   #else
      typedef struct _CTX_DB_SGE {
         u32 addr_hi;                             // DWORD 0
         u32 addr_lo;                             // DWORD 1
      } SG_PACK CTX_DB_SGE, *PCTX_DB_SGE;

      typedef union _CTX_DB_SGE_UNION {
         CTX_DB_SGE bits;
         u32 dw[2]; // dword union
      } SG_PACK CTX_DB_SGE_UNION, *PCTX_DB_SGE_UNION;

      SG_C_ASSERT(__sizeof__CTX_DB_SGE_UNION, sizeof (CTX_DB_SGE_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Context memory bank used to get/store default PDU buffers from host default PDU
   // ring. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_DB_POOL {
         union {
            struct { 
               CTX_DB_SGE db_pool[4];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK CTX_DB_POOL, *PCTX_DB_POOL;

      SG_C_ASSERT(__sizeof__CTX_DB_POOL, sizeof (CTX_DB_POOL) == 32);

   #else
      typedef struct _CTX_DB_POOL {
         CTX_DB_SGE db_pool[4];
      } SG_PACK CTX_DB_POOL, *PCTX_DB_POOL;

      typedef union _CTX_DB_POOL_UNION {
         CTX_DB_POOL bits;
         u32 dw[8]; // dword union
      } SG_PACK CTX_DB_POOL_UNION, *PCTX_DB_POOL_UNION;

      SG_C_ASSERT(__sizeof__CTX_DB_POOL_UNION, sizeof (CTX_DB_POOL_UNION) == 32);
   #endif


#else
   // Context memory bank used to get/store default PDU buffers from host default PDU
   // ring. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_DB_POOL {
         union {
            struct { 
               CTX_DB_SGE db_pool[4];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK CTX_DB_POOL, *PCTX_DB_POOL;

      SG_C_ASSERT(__sizeof__CTX_DB_POOL, sizeof (CTX_DB_POOL) == 32);

   #else
      typedef struct _CTX_DB_POOL {
         CTX_DB_SGE db_pool[4];
      } SG_PACK CTX_DB_POOL, *PCTX_DB_POOL;

      typedef union _CTX_DB_POOL_UNION {
         CTX_DB_POOL bits;
         u32 dw[8]; // dword union
      } SG_PACK CTX_DB_POOL_UNION, *PCTX_DB_POOL_UNION;

      SG_C_ASSERT(__sizeof__CTX_DB_POOL_UNION, sizeof (CTX_DB_POOL_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Per-domain IOPS/bytes counters maintained by iSCSI TXULP for enforcing quality of
   // service. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_QOS_COUNTERS {
         union {
            struct { 
               u32 byte_count : 19;               // DWORD 0
               u32 iops_count : 13;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_QOS_COUNTERS, *PISCSI_QOS_COUNTERS;

      SG_C_ASSERT(__sizeof__ISCSI_QOS_COUNTERS, sizeof (ISCSI_QOS_COUNTERS) == 4);

   #else
      typedef struct _ISCSI_QOS_COUNTERS {
         u32 byte_count : 19;                     // DWORD 0
         u32 iops_count : 13;                     // DWORD 0
      } SG_PACK ISCSI_QOS_COUNTERS, *PISCSI_QOS_COUNTERS;

      typedef union _ISCSI_QOS_COUNTERS_UNION {
         ISCSI_QOS_COUNTERS bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_QOS_COUNTERS_UNION, *PISCSI_QOS_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_QOS_COUNTERS_UNION, sizeof (ISCSI_QOS_COUNTERS_UNION) == 4);
   #endif


#else
   // Per-domain IOPS/bytes counters maintained by iSCSI TXULP for enforcing quality of
   // service. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_QOS_COUNTERS {
         union {
            struct { 
               u32 iops_count : 13;               // DWORD 0
               u32 byte_count : 19;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_QOS_COUNTERS, *PISCSI_QOS_COUNTERS;

      SG_C_ASSERT(__sizeof__ISCSI_QOS_COUNTERS, sizeof (ISCSI_QOS_COUNTERS) == 4);

   #else
      typedef struct _ISCSI_QOS_COUNTERS {
         u32 iops_count : 13;                     // DWORD 0
         u32 byte_count : 19;                     // DWORD 0
      } SG_PACK ISCSI_QOS_COUNTERS, *PISCSI_QOS_COUNTERS;

      typedef union _ISCSI_QOS_COUNTERS_UNION {
         ISCSI_QOS_COUNTERS bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_QOS_COUNTERS_UNION, *PISCSI_QOS_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_QOS_COUNTERS_UNION, sizeof (ISCSI_QOS_COUNTERS_UNION) == 4);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __iscsi_context_bmap_h__

