/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __iscsi_target_host_struct_bmap_h__
#define __iscsi_target_host_struct_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "iscsi_enums_bmap.h"
#include "iscsi_common_host_struct_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_TARGET_CONTEXT_UPDATE_WRB {
         union {
            struct { 
               u32 type : 4;                      // DWORD 0
               u32 over_run : 1;                  // DWORD 0
               u32 undr_run : 1;                  // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 wrb_idx : 8;                   // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 lun : 14;                      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 1
               u32 maxBurstLength : 19;           // DWORD 1
               u32 ptr2NextWrb : 8;               // DWORD 1
               u32 maxSendDataSegmentLength : 17; // DWORD 2
               u32 rsvd1 : 15;                    // DWORD 2
               u32 sessionState : 3;              // DWORD 3
               u32 rsvd3 : 5;                     // DWORD 3
               u32 tx_wrbindex_drv_msg : 8;       // DWORD 3
               u32 rsvd2 : 2;                     // DWORD 3
               u32 firstBurstLength : 14;         // DWORD 3
               u32 compltonack : 1;               // DWORD 4
               u32 notpredblq : 2;                // DWORD 4
               u32 ir2t : 1;                      // DWORD 4
               u32 imd : 1;                       // DWORD 4
               u32 mode : 1;                      // DWORD 4
               u32 domainID : 5;                  // DWORD 4
               u32 ERL : 2;                       // DWORD 4
               u32 DDE : 1;                       // DWORD 4
               u32 HDE : 1;                       // DWORD 4
               u32 tx_jumbo : 1;                  // DWORD 4
               u32 rsvd4 : 16;                    // DWORD 4
               u32 stat_sn;                       // DWORD 5
               u32 pad_buffer_addr_hi;            // DWORD 6
               u32 pad_buffer_addr_lo;            // DWORD 7
               u32 pad_addr_hi;                   // DWORD 8
               u32 pad_addr_lo;                   // DWORD 9
               u32 rsvd5[1];                      // DWORDS 10 to 10
               u32 rsvd6[1];                      // DWORDS 11 to 11
               u32 rsvd7[1];                      // DWORDS 12 to 12
               u32 rsvd8[1];                      // DWORDS 13 to 13
               u32 rsvd9[1];                      // DWORDS 14 to 14
               u32 rsvd10[1];                     // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_TARGET_CONTEXT_UPDATE_WRB, *PISCSI_TARGET_CONTEXT_UPDATE_WRB;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_CONTEXT_UPDATE_WRB, sizeof (ISCSI_TARGET_CONTEXT_UPDATE_WRB) == 64);

   #else
      typedef struct _ISCSI_TARGET_CONTEXT_UPDATE_WRB {
         u32 type : 4;                            // DWORD 0
         u32 over_run : 1;                        // DWORD 0
         u32 undr_run : 1;                        // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 wrb_idx : 8;                         // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 lun : 14;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 1
         u32 maxBurstLength : 19;                 // DWORD 1
         u32 ptr2NextWrb : 8;                     // DWORD 1
         u32 maxSendDataSegmentLength : 17;       // DWORD 2
         u32 rsvd1 : 15;                          // DWORD 2
         u32 sessionState : 3;                    // DWORD 3
         u32 rsvd3 : 5;                           // DWORD 3
         u32 tx_wrbindex_drv_msg : 8;             // DWORD 3
         u32 rsvd2 : 2;                           // DWORD 3
         u32 firstBurstLength : 14;               // DWORD 3
         u32 compltonack : 1;                     // DWORD 4
         u32 notpredblq : 2;                      // DWORD 4
         u32 ir2t : 1;                            // DWORD 4
         u32 imd : 1;                             // DWORD 4
         u32 mode : 1;                            // DWORD 4
         u32 domainID : 5;                        // DWORD 4
         u32 ERL : 2;                             // DWORD 4
         u32 DDE : 1;                             // DWORD 4
         u32 HDE : 1;                             // DWORD 4
         u32 tx_jumbo : 1;                        // DWORD 4
         u32 rsvd4 : 16;                          // DWORD 4
         u32 stat_sn;                             // DWORD 5
         u32 pad_buffer_addr_hi;                  // DWORD 6
         u32 pad_buffer_addr_lo;                  // DWORD 7
         u32 pad_addr_hi;                         // DWORD 8
         u32 pad_addr_lo;                         // DWORD 9
         u32 rsvd5[1];                            // DWORDS 10 to 10
         u32 rsvd6[1];                            // DWORDS 11 to 11
         u32 rsvd7[1];                            // DWORDS 12 to 12
         u32 rsvd8[1];                            // DWORDS 13 to 13
         u32 rsvd9[1];                            // DWORDS 14 to 14
         u32 rsvd10[1];                           // DWORDS 15 to 15
      } SG_PACK ISCSI_TARGET_CONTEXT_UPDATE_WRB, *PISCSI_TARGET_CONTEXT_UPDATE_WRB;

      typedef union _ISCSI_TARGET_CONTEXT_UPDATE_WRB_UNION {
         ISCSI_TARGET_CONTEXT_UPDATE_WRB bits;
         u32 dw[16]; // dword union
      } SG_PACK ISCSI_TARGET_CONTEXT_UPDATE_WRB_UNION, *PISCSI_TARGET_CONTEXT_UPDATE_WRB_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_CONTEXT_UPDATE_WRB_UNION, sizeof (ISCSI_TARGET_CONTEXT_UPDATE_WRB_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_TARGET_CONTEXT_UPDATE_WRB {
         union {
            struct { 
               u32 lun : 14;                      // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 wrb_idx : 8;                   // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 undr_run : 1;                  // DWORD 0
               u32 over_run : 1;                  // DWORD 0
               u32 type : 4;                      // DWORD 0
               u32 ptr2NextWrb : 8;               // DWORD 1
               u32 maxBurstLength : 19;           // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 rsvd1 : 15;                    // DWORD 2
               u32 maxSendDataSegmentLength : 17; // DWORD 2
               u32 firstBurstLength : 14;         // DWORD 3
               u32 rsvd2 : 2;                     // DWORD 3
               u32 tx_wrbindex_drv_msg : 8;       // DWORD 3
               u32 rsvd3 : 5;                     // DWORD 3
               u32 sessionState : 3;              // DWORD 3
               u32 rsvd4 : 16;                    // DWORD 4
               u32 tx_jumbo : 1;                  // DWORD 4
               u32 HDE : 1;                       // DWORD 4
               u32 DDE : 1;                       // DWORD 4
               u32 ERL : 2;                       // DWORD 4
               u32 domainID : 5;                  // DWORD 4
               u32 mode : 1;                      // DWORD 4
               u32 imd : 1;                       // DWORD 4
               u32 ir2t : 1;                      // DWORD 4
               u32 notpredblq : 2;                // DWORD 4
               u32 compltonack : 1;               // DWORD 4
               u32 stat_sn;                       // DWORD 5
               u32 pad_buffer_addr_hi;            // DWORD 6
               u32 pad_buffer_addr_lo;            // DWORD 7
               u32 pad_addr_hi;                   // DWORD 8
               u32 pad_addr_lo;                   // DWORD 9
               u32 rsvd5[1];                      // DWORDS 10 to 10
               u32 rsvd6[1];                      // DWORDS 11 to 11
               u32 rsvd7[1];                      // DWORDS 12 to 12
               u32 rsvd8[1];                      // DWORDS 13 to 13
               u32 rsvd9[1];                      // DWORDS 14 to 14
               u32 rsvd10[1];                     // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_TARGET_CONTEXT_UPDATE_WRB, *PISCSI_TARGET_CONTEXT_UPDATE_WRB;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_CONTEXT_UPDATE_WRB, sizeof (ISCSI_TARGET_CONTEXT_UPDATE_WRB) == 64);

   #else
      typedef struct _ISCSI_TARGET_CONTEXT_UPDATE_WRB {
         u32 lun : 14;                            // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 wrb_idx : 8;                         // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 undr_run : 1;                        // DWORD 0
         u32 over_run : 1;                        // DWORD 0
         u32 type : 4;                            // DWORD 0
         u32 ptr2NextWrb : 8;                     // DWORD 1
         u32 maxBurstLength : 19;                 // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 rsvd1 : 15;                          // DWORD 2
         u32 maxSendDataSegmentLength : 17;       // DWORD 2
         u32 firstBurstLength : 14;               // DWORD 3
         u32 rsvd2 : 2;                           // DWORD 3
         u32 tx_wrbindex_drv_msg : 8;             // DWORD 3
         u32 rsvd3 : 5;                           // DWORD 3
         u32 sessionState : 3;                    // DWORD 3
         u32 rsvd4 : 16;                          // DWORD 4
         u32 tx_jumbo : 1;                        // DWORD 4
         u32 HDE : 1;                             // DWORD 4
         u32 DDE : 1;                             // DWORD 4
         u32 ERL : 2;                             // DWORD 4
         u32 domainID : 5;                        // DWORD 4
         u32 mode : 1;                            // DWORD 4
         u32 imd : 1;                             // DWORD 4
         u32 ir2t : 1;                            // DWORD 4
         u32 notpredblq : 2;                      // DWORD 4
         u32 compltonack : 1;                     // DWORD 4
         u32 stat_sn;                             // DWORD 5
         u32 pad_buffer_addr_hi;                  // DWORD 6
         u32 pad_buffer_addr_lo;                  // DWORD 7
         u32 pad_addr_hi;                         // DWORD 8
         u32 pad_addr_lo;                         // DWORD 9
         u32 rsvd5[1];                            // DWORDS 10 to 10
         u32 rsvd6[1];                            // DWORDS 11 to 11
         u32 rsvd7[1];                            // DWORDS 12 to 12
         u32 rsvd8[1];                            // DWORDS 13 to 13
         u32 rsvd9[1];                            // DWORDS 14 to 14
         u32 rsvd10[1];                           // DWORDS 15 to 15
      } SG_PACK ISCSI_TARGET_CONTEXT_UPDATE_WRB, *PISCSI_TARGET_CONTEXT_UPDATE_WRB;

      typedef union _ISCSI_TARGET_CONTEXT_UPDATE_WRB_UNION {
         ISCSI_TARGET_CONTEXT_UPDATE_WRB bits;
         u32 dw[16]; // dword union
      } SG_PACK ISCSI_TARGET_CONTEXT_UPDATE_WRB_UNION, *PISCSI_TARGET_CONTEXT_UPDATE_WRB_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_CONTEXT_UPDATE_WRB_UNION, sizeof (ISCSI_TARGET_CONTEXT_UPDATE_WRB_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI target solicited data place notify completion queue entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _T_SOL_CQE {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 hw_sts : 8;                    // DWORD 0
               u32 pdu_bytes_rcvd;                // DWORD 1
               u32 rsvd1 : 16;                    // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 code : 6;                      // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 rsvd2 : 23;                    // DWORD 3
               u32 wrb_index : 8;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK T_SOL_CQE, *PT_SOL_CQE;

      SG_C_ASSERT(__sizeof__T_SOL_CQE, sizeof (T_SOL_CQE) == 16);

   #else
      typedef struct _T_SOL_CQE {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 hw_sts : 8;                          // DWORD 0
         u32 pdu_bytes_rcvd;                      // DWORD 1
         u32 rsvd1 : 16;                          // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 code : 6;                            // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 rsvd2 : 23;                          // DWORD 3
         u32 wrb_index : 8;                       // DWORD 3
      } SG_PACK T_SOL_CQE, *PT_SOL_CQE;

      typedef union _T_SOL_CQE_UNION {
         T_SOL_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK T_SOL_CQE_UNION, *PT_SOL_CQE_UNION;

      SG_C_ASSERT(__sizeof__T_SOL_CQE_UNION, sizeof (T_SOL_CQE_UNION) == 16);
   #endif


#else
   // iSCSI target solicited data place notify completion queue entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _T_SOL_CQE {
         union {
            struct { 
               u32 hw_sts : 8;                    // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
               u32 pdu_bytes_rcvd;                // DWORD 1
               u32 code : 6;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 rsvd1 : 16;                    // DWORD 2
               u32 wrb_index : 8;                 // DWORD 3
               u32 rsvd2 : 23;                    // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK T_SOL_CQE, *PT_SOL_CQE;

      SG_C_ASSERT(__sizeof__T_SOL_CQE, sizeof (T_SOL_CQE) == 16);

   #else
      typedef struct _T_SOL_CQE {
         u32 hw_sts : 8;                          // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
         u32 pdu_bytes_rcvd;                      // DWORD 1
         u32 code : 6;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 rsvd1 : 16;                          // DWORD 2
         u32 wrb_index : 8;                       // DWORD 3
         u32 rsvd2 : 23;                          // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK T_SOL_CQE, *PT_SOL_CQE;

      typedef union _T_SOL_CQE_UNION {
         T_SOL_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK T_SOL_CQE_UNION, *PT_SOL_CQE_UNION;

      SG_C_ASSERT(__sizeof__T_SOL_CQE_UNION, sizeof (T_SOL_CQE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI target solicited data digest error completion queue entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _T_SOL_DATA_DIGEST_CQE {
         union {
            struct { 
               u32 bufferoffset;                  // DWORD 0
               u32 expStatSN;                     // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 2
               u32 FinalBit : 1;                  // DWORD 2
               u32 rsvd0 : 2;                     // DWORD 2
               u32 dataSN : 12;                   // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 code : 6;                      // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 sgl_icd_index : 12;            // DWORD 3
               u32 rsvd2 : 2;                     // DWORD 3
               u32 dataSegmentLength : 17;        // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK T_SOL_DATA_DIGEST_CQE, *PT_SOL_DATA_DIGEST_CQE;

      SG_C_ASSERT(__sizeof__T_SOL_DATA_DIGEST_CQE, sizeof (T_SOL_DATA_DIGEST_CQE) == 16);

   #else
      typedef struct _T_SOL_DATA_DIGEST_CQE {
         u32 bufferoffset;                        // DWORD 0
         u32 expStatSN;                           // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 2
         u32 FinalBit : 1;                        // DWORD 2
         u32 rsvd0 : 2;                           // DWORD 2
         u32 dataSN : 12;                         // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 code : 6;                            // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 sgl_icd_index : 12;                  // DWORD 3
         u32 rsvd2 : 2;                           // DWORD 3
         u32 dataSegmentLength : 17;              // DWORD 3
      } SG_PACK T_SOL_DATA_DIGEST_CQE, *PT_SOL_DATA_DIGEST_CQE;

      typedef union _T_SOL_DATA_DIGEST_CQE_UNION {
         T_SOL_DATA_DIGEST_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK T_SOL_DATA_DIGEST_CQE_UNION, *PT_SOL_DATA_DIGEST_CQE_UNION;

      SG_C_ASSERT(__sizeof__T_SOL_DATA_DIGEST_CQE_UNION, sizeof (T_SOL_DATA_DIGEST_CQE_UNION) == 16);
   #endif


#else
   // iSCSI target solicited data digest error completion queue entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _T_SOL_DATA_DIGEST_CQE {
         union {
            struct { 
               u32 bufferoffset;                  // DWORD 0
               u32 expStatSN;                     // DWORD 1
               u32 code : 6;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 dataSN : 12;                   // DWORD 2
               u32 rsvd0 : 2;                     // DWORD 2
               u32 FinalBit : 1;                  // DWORD 2
               u32 rsvd1 : 1;                     // DWORD 2
               u32 dataSegmentLength : 17;        // DWORD 3
               u32 rsvd2 : 2;                     // DWORD 3
               u32 sgl_icd_index : 12;            // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK T_SOL_DATA_DIGEST_CQE, *PT_SOL_DATA_DIGEST_CQE;

      SG_C_ASSERT(__sizeof__T_SOL_DATA_DIGEST_CQE, sizeof (T_SOL_DATA_DIGEST_CQE) == 16);

   #else
      typedef struct _T_SOL_DATA_DIGEST_CQE {
         u32 bufferoffset;                        // DWORD 0
         u32 expStatSN;                           // DWORD 1
         u32 code : 6;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 dataSN : 12;                         // DWORD 2
         u32 rsvd0 : 2;                           // DWORD 2
         u32 FinalBit : 1;                        // DWORD 2
         u32 rsvd1 : 1;                           // DWORD 2
         u32 dataSegmentLength : 17;              // DWORD 3
         u32 rsvd2 : 2;                           // DWORD 3
         u32 sgl_icd_index : 12;                  // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK T_SOL_DATA_DIGEST_CQE, *PT_SOL_DATA_DIGEST_CQE;

      typedef union _T_SOL_DATA_DIGEST_CQE_UNION {
         T_SOL_DATA_DIGEST_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK T_SOL_DATA_DIGEST_CQE_UNION, *PT_SOL_DATA_DIGEST_CQE_UNION;

      SG_C_ASSERT(__sizeof__T_SOL_DATA_DIGEST_CQE_UNION, sizeof (T_SOL_DATA_DIGEST_CQE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI connection invalidation completion queue entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _T_CNXINV_CQE {
         union {
            struct { 
               u32 db_addr_hi;                    // DWORD 0
               u32 db_addr_lo;                    // DWORD 1
               u32 index : 16;                    // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 code : 6;                      // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 rsvd0 : 14;                    // DWORD 3
               u32 partial_dsl : 17;              // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK T_CNXINV_CQE, *PT_CNXINV_CQE;

      SG_C_ASSERT(__sizeof__T_CNXINV_CQE, sizeof (T_CNXINV_CQE) == 16);

   #else
      typedef struct _T_CNXINV_CQE {
         u32 db_addr_hi;                          // DWORD 0
         u32 db_addr_lo;                          // DWORD 1
         u32 index : 16;                          // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 code : 6;                            // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 rsvd0 : 14;                          // DWORD 3
         u32 partial_dsl : 17;                    // DWORD 3
      } SG_PACK T_CNXINV_CQE, *PT_CNXINV_CQE;

      typedef union _T_CNXINV_CQE_UNION {
         T_CNXINV_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK T_CNXINV_CQE_UNION, *PT_CNXINV_CQE_UNION;

      SG_C_ASSERT(__sizeof__T_CNXINV_CQE_UNION, sizeof (T_CNXINV_CQE_UNION) == 16);
   #endif


#else
   // iSCSI connection invalidation completion queue entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _T_CNXINV_CQE {
         union {
            struct { 
               u32 db_addr_hi;                    // DWORD 0
               u32 db_addr_lo;                    // DWORD 1
               u32 code : 6;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 index : 16;                    // DWORD 2
               u32 partial_dsl : 17;              // DWORD 3
               u32 rsvd0 : 14;                    // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK T_CNXINV_CQE, *PT_CNXINV_CQE;

      SG_C_ASSERT(__sizeof__T_CNXINV_CQE, sizeof (T_CNXINV_CQE) == 16);

   #else
      typedef struct _T_CNXINV_CQE {
         u32 db_addr_hi;                          // DWORD 0
         u32 db_addr_lo;                          // DWORD 1
         u32 code : 6;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 index : 16;                          // DWORD 2
         u32 partial_dsl : 17;                    // DWORD 3
         u32 rsvd0 : 14;                          // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK T_CNXINV_CQE, *PT_CNXINV_CQE;

      typedef union _T_CNXINV_CQE_UNION {
         T_CNXINV_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK T_CNXINV_CQE_UNION, *PT_CNXINV_CQE_UNION;

      SG_C_ASSERT(__sizeof__T_CNXINV_CQE_UNION, sizeof (T_CNXINV_CQE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI command invalidation completion queue entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _T_CMNDINV_CQE {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 rsvd2 : 16;                    // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 code : 6;                      // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 rsvd3 : 19;                    // DWORD 3
               u32 sgl_icd_index : 12;            // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK T_CMNDINV_CQE, *PT_CMNDINV_CQE;

      SG_C_ASSERT(__sizeof__T_CMNDINV_CQE, sizeof (T_CMNDINV_CQE) == 16);

   #else
      typedef struct _T_CMNDINV_CQE {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 rsvd2 : 16;                          // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 code : 6;                            // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 rsvd3 : 19;                          // DWORD 3
         u32 sgl_icd_index : 12;                  // DWORD 3
      } SG_PACK T_CMNDINV_CQE, *PT_CMNDINV_CQE;

      typedef union _T_CMNDINV_CQE_UNION {
         T_CMNDINV_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK T_CMNDINV_CQE_UNION, *PT_CMNDINV_CQE_UNION;

      SG_C_ASSERT(__sizeof__T_CMNDINV_CQE_UNION, sizeof (T_CMNDINV_CQE_UNION) == 16);
   #endif


#else
   // iSCSI command invalidation completion queue entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _T_CMNDINV_CQE {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 code : 6;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 rsvd2 : 16;                    // DWORD 2
               u32 sgl_icd_index : 12;            // DWORD 3
               u32 rsvd3 : 19;                    // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK T_CMNDINV_CQE, *PT_CMNDINV_CQE;

      SG_C_ASSERT(__sizeof__T_CMNDINV_CQE, sizeof (T_CMNDINV_CQE) == 16);

   #else
      typedef struct _T_CMNDINV_CQE {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 code : 6;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 rsvd2 : 16;                          // DWORD 2
         u32 sgl_icd_index : 12;                  // DWORD 3
         u32 rsvd3 : 19;                          // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK T_CMNDINV_CQE, *PT_CMNDINV_CQE;

      typedef union _T_CMNDINV_CQE_UNION {
         T_CMNDINV_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK T_CMNDINV_CQE_UNION, *PT_CMNDINV_CQE_UNION;

      SG_C_ASSERT(__sizeof__T_CMNDINV_CQE_UNION, sizeof (T_CMNDINV_CQE_UNION) == 16);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __iscsi_target_host_struct_bmap_h__

