/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __pq_bmap_h__
#define __pq_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // The PQ command register provides an interface to enable/disable the PQ. It also
   // provides an interface to enable and disable other features supported by the PQ. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_CONTROL_CSR {
         union {
            struct { 
               u32 enqueue_status : 1;            // DWORD 0
               u32 w_status : 1;                  // DWORD 0
               u32 s_status : 1;                  // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 index : 8;                     // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 spot : 1;                      // DWORD 0
               u32 f_full : 1;                    // DWORD 0
               u32 mask : 1;                      // DWORD 0
               u32 rst : 1;                       // DWORD 0
               u32 f_discard : 1;                 // DWORD 0
               u32 f_stall : 1;                   // DWORD 0
               u32 en_empty : 1;                  // DWORD 0
               u32 en_discard : 1;                // DWORD 0
               u32 en_stall : 1;                  // DWORD 0
               u32 sel_index : 1;                 // DWORD 0
               u32 en_index : 1;                  // DWORD 0
               u32 en_count : 1;                  // DWORD 0
               u32 notfiy : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_CONTROL_CSR, *PPQ_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__PQ_CONTROL_CSR, sizeof (PQ_CONTROL_CSR) == 4);

   #else
      typedef struct _PQ_CONTROL_CSR {
         u32 enqueue_status : 1;                  // DWORD 0
         u32 w_status : 1;                        // DWORD 0
         u32 s_status : 1;                        // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 index : 8;                           // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 spot : 1;                            // DWORD 0
         u32 f_full : 1;                          // DWORD 0
         u32 mask : 1;                            // DWORD 0
         u32 rst : 1;                             // DWORD 0
         u32 f_discard : 1;                       // DWORD 0
         u32 f_stall : 1;                         // DWORD 0
         u32 en_empty : 1;                        // DWORD 0
         u32 en_discard : 1;                      // DWORD 0
         u32 en_stall : 1;                        // DWORD 0
         u32 sel_index : 1;                       // DWORD 0
         u32 en_index : 1;                        // DWORD 0
         u32 en_count : 1;                        // DWORD 0
         u32 notfiy : 1;                          // DWORD 0
      } SG_PACK PQ_CONTROL_CSR, *PPQ_CONTROL_CSR;

      typedef union _PQ_CONTROL_CSR_UNION {
         PQ_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_CONTROL_CSR_UNION, *PPQ_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_CONTROL_CSR_UNION, sizeof (PQ_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // The PQ command register provides an interface to enable/disable the PQ. It also
   // provides an interface to enable and disable other features supported by the PQ. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_CONTROL_CSR {
         union {
            struct { 
               u32 notfiy : 1;                    // DWORD 0
               u32 en_count : 1;                  // DWORD 0
               u32 en_index : 1;                  // DWORD 0
               u32 sel_index : 1;                 // DWORD 0
               u32 en_stall : 1;                  // DWORD 0
               u32 en_discard : 1;                // DWORD 0
               u32 en_empty : 1;                  // DWORD 0
               u32 f_stall : 1;                   // DWORD 0
               u32 f_discard : 1;                 // DWORD 0
               u32 rst : 1;                       // DWORD 0
               u32 mask : 1;                      // DWORD 0
               u32 f_full : 1;                    // DWORD 0
               u32 spot : 1;                      // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 index : 8;                     // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 s_status : 1;                  // DWORD 0
               u32 w_status : 1;                  // DWORD 0
               u32 enqueue_status : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_CONTROL_CSR, *PPQ_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__PQ_CONTROL_CSR, sizeof (PQ_CONTROL_CSR) == 4);

   #else
      typedef struct _PQ_CONTROL_CSR {
         u32 notfiy : 1;                          // DWORD 0
         u32 en_count : 1;                        // DWORD 0
         u32 en_index : 1;                        // DWORD 0
         u32 sel_index : 1;                       // DWORD 0
         u32 en_stall : 1;                        // DWORD 0
         u32 en_discard : 1;                      // DWORD 0
         u32 en_empty : 1;                        // DWORD 0
         u32 f_stall : 1;                         // DWORD 0
         u32 f_discard : 1;                       // DWORD 0
         u32 rst : 1;                             // DWORD 0
         u32 mask : 1;                            // DWORD 0
         u32 f_full : 1;                          // DWORD 0
         u32 spot : 1;                            // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 index : 8;                           // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 s_status : 1;                        // DWORD 0
         u32 w_status : 1;                        // DWORD 0
         u32 enqueue_status : 1;                  // DWORD 0
      } SG_PACK PQ_CONTROL_CSR, *PPQ_CONTROL_CSR;

      typedef union _PQ_CONTROL_CSR_UNION {
         PQ_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_CONTROL_CSR_UNION, *PPQ_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_CONTROL_CSR_UNION, sizeof (PQ_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register is read only, and is used to read the status of the transitions,
   // including overflow and underflow conditions.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_COUNT_CSR {
         union {
            struct { 
               u32 rsvd0 : 6;                     // DWORD 0
               u32 pqcnt_encode : 2;              // DWORD 0
               u32 pqcount : 8;                   // DWORD 0
               u32 total_depth : 8;               // DWORD 0
               u32 underflow : 1;                 // DWORD 0
               u32 overflow : 7;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_COUNT_CSR, *PPQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PQ_COUNT_CSR, sizeof (PQ_COUNT_CSR) == 4);

   #else
      typedef struct _PQ_COUNT_CSR {
         u32 rsvd0 : 6;                           // DWORD 0
         u32 pqcnt_encode : 2;                    // DWORD 0
         u32 pqcount : 8;                         // DWORD 0
         u32 total_depth : 8;                     // DWORD 0
         u32 underflow : 1;                       // DWORD 0
         u32 overflow : 7;                        // DWORD 0
      } SG_PACK PQ_COUNT_CSR, *PPQ_COUNT_CSR;

      typedef union _PQ_COUNT_CSR_UNION {
         PQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_COUNT_CSR_UNION, *PPQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_COUNT_CSR_UNION, sizeof (PQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // This register is read only, and is used to read the status of the transitions,
   // including overflow and underflow conditions.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_COUNT_CSR {
         union {
            struct { 
               u32 overflow : 7;                  // DWORD 0
               u32 underflow : 1;                 // DWORD 0
               u32 total_depth : 8;               // DWORD 0
               u32 pqcount : 8;                   // DWORD 0
               u32 pqcnt_encode : 2;              // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_COUNT_CSR, *PPQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PQ_COUNT_CSR, sizeof (PQ_COUNT_CSR) == 4);

   #else
      typedef struct _PQ_COUNT_CSR {
         u32 overflow : 7;                        // DWORD 0
         u32 underflow : 1;                       // DWORD 0
         u32 total_depth : 8;                     // DWORD 0
         u32 pqcount : 8;                         // DWORD 0
         u32 pqcnt_encode : 2;                    // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
      } SG_PACK PQ_COUNT_CSR, *PPQ_COUNT_CSR;

      typedef union _PQ_COUNT_CSR_UNION {
         PQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_COUNT_CSR_UNION, *PPQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_COUNT_CSR_UNION, sizeof (PQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register is write only and is similar to the write portion of the RWData.
   // However, instead writing to the head of the FIFO or the location indexed by the
   // Index register, the Enqueue register pushes a new entry onto the FIFO from the tail
   // (producer side). The Enqueue register is only 32 bits, so it uses the RWData 3, 2 or
   // 1 as the upper words of the data to be enqueued.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_ENQUEUE_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_ENQUEUE_CSR, *PPQ_ENQUEUE_CSR;

      SG_C_ASSERT(__sizeof__PQ_ENQUEUE_CSR, sizeof (PQ_ENQUEUE_CSR) == 4);

   #else
      typedef struct _PQ_ENQUEUE_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_ENQUEUE_CSR, *PPQ_ENQUEUE_CSR;

      typedef union _PQ_ENQUEUE_CSR_UNION {
         PQ_ENQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_ENQUEUE_CSR_UNION, *PPQ_ENQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_ENQUEUE_CSR_UNION, sizeof (PQ_ENQUEUE_CSR_UNION) == 4);
   #endif


#else
   // This register is write only and is similar to the write portion of the RWData.
   // However, instead writing to the head of the FIFO or the location indexed by the
   // Index register, the Enqueue register pushes a new entry onto the FIFO from the tail
   // (producer side). The Enqueue register is only 32 bits, so it uses the RWData 3, 2 or
   // 1 as the upper words of the data to be enqueued.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_ENQUEUE_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_ENQUEUE_CSR, *PPQ_ENQUEUE_CSR;

      SG_C_ASSERT(__sizeof__PQ_ENQUEUE_CSR, sizeof (PQ_ENQUEUE_CSR) == 4);

   #else
      typedef struct _PQ_ENQUEUE_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_ENQUEUE_CSR, *PPQ_ENQUEUE_CSR;

      typedef union _PQ_ENQUEUE_CSR_UNION {
         PQ_ENQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_ENQUEUE_CSR_UNION, *PPQ_ENQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_ENQUEUE_CSR_UNION, sizeof (PQ_ENQUEUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Writing RWData0 will trigger an event to write an entire word either to the head
   // (consumer side) of the FIFO or the data pointed to by the Index Register if in Index
   // Mode. This will destroy any data present at the head/index.  Note that data written
   // will have the lower 3 control bits in DATA0_WRITE, i.e. the EDS bits (empty,
   // discard, stall). This means to discard an element, write a 2 to the register
   // location, and that an entry with the lsbit set will be stalled (if the control
   // register is enabled).
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA0_WRITE_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA0_WRITE_CSR, *PPQ_DATA0_WRITE_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA0_WRITE_CSR, sizeof (PQ_DATA0_WRITE_CSR) == 4);

   #else
      typedef struct _PQ_DATA0_WRITE_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA0_WRITE_CSR, *PPQ_DATA0_WRITE_CSR;

      typedef union _PQ_DATA0_WRITE_CSR_UNION {
         PQ_DATA0_WRITE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA0_WRITE_CSR_UNION, *PPQ_DATA0_WRITE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA0_WRITE_CSR_UNION, sizeof (PQ_DATA0_WRITE_CSR_UNION) == 4);
   #endif


#else
   // Writing RWData0 will trigger an event to write an entire word either to the head
   // (consumer side) of the FIFO or the data pointed to by the Index Register if in Index
   // Mode. This will destroy any data present at the head/index.  Note that data written
   // will have the lower 3 control bits in DATA0_WRITE, i.e. the EDS bits (empty,
   // discard, stall). This means to discard an element, write a 2 to the register
   // location, and that an entry with the lsbit set will be stalled (if the control
   // register is enabled).
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA0_WRITE_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA0_WRITE_CSR, *PPQ_DATA0_WRITE_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA0_WRITE_CSR, sizeof (PQ_DATA0_WRITE_CSR) == 4);

   #else
      typedef struct _PQ_DATA0_WRITE_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA0_WRITE_CSR, *PPQ_DATA0_WRITE_CSR;

      typedef union _PQ_DATA0_WRITE_CSR_UNION {
         PQ_DATA0_WRITE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA0_WRITE_CSR_UNION, *PPQ_DATA0_WRITE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA0_WRITE_CSR_UNION, sizeof (PQ_DATA0_WRITE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to write bits 63:32 of the data for Enqueue or WriteData0
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA1_WRITE_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA1_WRITE_CSR, *PPQ_DATA1_WRITE_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA1_WRITE_CSR, sizeof (PQ_DATA1_WRITE_CSR) == 4);

   #else
      typedef struct _PQ_DATA1_WRITE_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA1_WRITE_CSR, *PPQ_DATA1_WRITE_CSR;

      typedef union _PQ_DATA1_WRITE_CSR_UNION {
         PQ_DATA1_WRITE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA1_WRITE_CSR_UNION, *PPQ_DATA1_WRITE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA1_WRITE_CSR_UNION, sizeof (PQ_DATA1_WRITE_CSR_UNION) == 4);
   #endif


#else
   // Used to write bits 63:32 of the data for Enqueue or WriteData0
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA1_WRITE_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA1_WRITE_CSR, *PPQ_DATA1_WRITE_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA1_WRITE_CSR, sizeof (PQ_DATA1_WRITE_CSR) == 4);

   #else
      typedef struct _PQ_DATA1_WRITE_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA1_WRITE_CSR, *PPQ_DATA1_WRITE_CSR;

      typedef union _PQ_DATA1_WRITE_CSR_UNION {
         PQ_DATA1_WRITE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA1_WRITE_CSR_UNION, *PPQ_DATA1_WRITE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA1_WRITE_CSR_UNION, sizeof (PQ_DATA1_WRITE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to write bits 95:64 of the data for Enqueue or WriteData0
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA2_WRITE_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA2_WRITE_CSR, *PPQ_DATA2_WRITE_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA2_WRITE_CSR, sizeof (PQ_DATA2_WRITE_CSR) == 4);

   #else
      typedef struct _PQ_DATA2_WRITE_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA2_WRITE_CSR, *PPQ_DATA2_WRITE_CSR;

      typedef union _PQ_DATA2_WRITE_CSR_UNION {
         PQ_DATA2_WRITE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA2_WRITE_CSR_UNION, *PPQ_DATA2_WRITE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA2_WRITE_CSR_UNION, sizeof (PQ_DATA2_WRITE_CSR_UNION) == 4);
   #endif


#else
   // Used to write bits 95:64 of the data for Enqueue or WriteData0
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA2_WRITE_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA2_WRITE_CSR, *PPQ_DATA2_WRITE_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA2_WRITE_CSR, sizeof (PQ_DATA2_WRITE_CSR) == 4);

   #else
      typedef struct _PQ_DATA2_WRITE_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA2_WRITE_CSR, *PPQ_DATA2_WRITE_CSR;

      typedef union _PQ_DATA2_WRITE_CSR_UNION {
         PQ_DATA2_WRITE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA2_WRITE_CSR_UNION, *PPQ_DATA2_WRITE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA2_WRITE_CSR_UNION, sizeof (PQ_DATA2_WRITE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to write bits 127:96 of the data for Enqueue or WriteData0
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA3_WRITE_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA3_WRITE_CSR, *PPQ_DATA3_WRITE_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA3_WRITE_CSR, sizeof (PQ_DATA3_WRITE_CSR) == 4);

   #else
      typedef struct _PQ_DATA3_WRITE_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA3_WRITE_CSR, *PPQ_DATA3_WRITE_CSR;

      typedef union _PQ_DATA3_WRITE_CSR_UNION {
         PQ_DATA3_WRITE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA3_WRITE_CSR_UNION, *PPQ_DATA3_WRITE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA3_WRITE_CSR_UNION, sizeof (PQ_DATA3_WRITE_CSR_UNION) == 4);
   #endif


#else
   // Used to write bits 127:96 of the data for Enqueue or WriteData0
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA3_WRITE_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA3_WRITE_CSR, *PPQ_DATA3_WRITE_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA3_WRITE_CSR, sizeof (PQ_DATA3_WRITE_CSR) == 4);

   #else
      typedef struct _PQ_DATA3_WRITE_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA3_WRITE_CSR, *PPQ_DATA3_WRITE_CSR;

      typedef union _PQ_DATA3_WRITE_CSR_UNION {
         PQ_DATA3_WRITE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA3_WRITE_CSR_UNION, *PPQ_DATA3_WRITE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA3_WRITE_CSR_UNION, sizeof (PQ_DATA3_WRITE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Reading the PQ_DATA0_READ_CSR registers returns either the data at the head
   // (consumer side) of the FIFO or the data pointed to by the Index Register if in Index
   // Mode. Reading the data does not affect the FIFO (i.e. no pop, discard, etc.) so
   // reading the RWData can be done multiple times and in any word order. DATA0 Returns
   // bits 31:0 of the FIFO entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA0_READ_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA0_READ_CSR, *PPQ_DATA0_READ_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA0_READ_CSR, sizeof (PQ_DATA0_READ_CSR) == 4);

   #else
      typedef struct _PQ_DATA0_READ_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA0_READ_CSR, *PPQ_DATA0_READ_CSR;

      typedef union _PQ_DATA0_READ_CSR_UNION {
         PQ_DATA0_READ_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA0_READ_CSR_UNION, *PPQ_DATA0_READ_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA0_READ_CSR_UNION, sizeof (PQ_DATA0_READ_CSR_UNION) == 4);
   #endif


#else
   // Reading the PQ_DATA0_READ_CSR registers returns either the data at the head
   // (consumer side) of the FIFO or the data pointed to by the Index Register if in Index
   // Mode. Reading the data does not affect the FIFO (i.e. no pop, discard, etc.) so
   // reading the RWData can be done multiple times and in any word order. DATA0 Returns
   // bits 31:0 of the FIFO entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA0_READ_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA0_READ_CSR, *PPQ_DATA0_READ_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA0_READ_CSR, sizeof (PQ_DATA0_READ_CSR) == 4);

   #else
      typedef struct _PQ_DATA0_READ_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA0_READ_CSR, *PPQ_DATA0_READ_CSR;

      typedef union _PQ_DATA0_READ_CSR_UNION {
         PQ_DATA0_READ_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA0_READ_CSR_UNION, *PPQ_DATA0_READ_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA0_READ_CSR_UNION, sizeof (PQ_DATA0_READ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DATA1 Returns bits 31:0 of the FIFO entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA1_READ_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA1_READ_CSR, *PPQ_DATA1_READ_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA1_READ_CSR, sizeof (PQ_DATA1_READ_CSR) == 4);

   #else
      typedef struct _PQ_DATA1_READ_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA1_READ_CSR, *PPQ_DATA1_READ_CSR;

      typedef union _PQ_DATA1_READ_CSR_UNION {
         PQ_DATA1_READ_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA1_READ_CSR_UNION, *PPQ_DATA1_READ_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA1_READ_CSR_UNION, sizeof (PQ_DATA1_READ_CSR_UNION) == 4);
   #endif


#else
   // DATA1 Returns bits 31:0 of the FIFO entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA1_READ_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA1_READ_CSR, *PPQ_DATA1_READ_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA1_READ_CSR, sizeof (PQ_DATA1_READ_CSR) == 4);

   #else
      typedef struct _PQ_DATA1_READ_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA1_READ_CSR, *PPQ_DATA1_READ_CSR;

      typedef union _PQ_DATA1_READ_CSR_UNION {
         PQ_DATA1_READ_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA1_READ_CSR_UNION, *PPQ_DATA1_READ_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA1_READ_CSR_UNION, sizeof (PQ_DATA1_READ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DATA2 Returns bits 31:0 of the FIFO entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA2_READ_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA2_READ_CSR, *PPQ_DATA2_READ_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA2_READ_CSR, sizeof (PQ_DATA2_READ_CSR) == 4);

   #else
      typedef struct _PQ_DATA2_READ_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA2_READ_CSR, *PPQ_DATA2_READ_CSR;

      typedef union _PQ_DATA2_READ_CSR_UNION {
         PQ_DATA2_READ_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA2_READ_CSR_UNION, *PPQ_DATA2_READ_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA2_READ_CSR_UNION, sizeof (PQ_DATA2_READ_CSR_UNION) == 4);
   #endif


#else
   // DATA2 Returns bits 31:0 of the FIFO entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA2_READ_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA2_READ_CSR, *PPQ_DATA2_READ_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA2_READ_CSR, sizeof (PQ_DATA2_READ_CSR) == 4);

   #else
      typedef struct _PQ_DATA2_READ_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA2_READ_CSR, *PPQ_DATA2_READ_CSR;

      typedef union _PQ_DATA2_READ_CSR_UNION {
         PQ_DATA2_READ_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA2_READ_CSR_UNION, *PPQ_DATA2_READ_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA2_READ_CSR_UNION, sizeof (PQ_DATA2_READ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DATA3 Returns bits 31:0 of the FIFO entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA3_READ_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA3_READ_CSR, *PPQ_DATA3_READ_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA3_READ_CSR, sizeof (PQ_DATA3_READ_CSR) == 4);

   #else
      typedef struct _PQ_DATA3_READ_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA3_READ_CSR, *PPQ_DATA3_READ_CSR;

      typedef union _PQ_DATA3_READ_CSR_UNION {
         PQ_DATA3_READ_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA3_READ_CSR_UNION, *PPQ_DATA3_READ_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA3_READ_CSR_UNION, sizeof (PQ_DATA3_READ_CSR_UNION) == 4);
   #endif


#else
   // DATA3 Returns bits 31:0 of the FIFO entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _PQ_DATA3_READ_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PQ_DATA3_READ_CSR, *PPQ_DATA3_READ_CSR;

      SG_C_ASSERT(__sizeof__PQ_DATA3_READ_CSR, sizeof (PQ_DATA3_READ_CSR) == 4);

   #else
      typedef struct _PQ_DATA3_READ_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PQ_DATA3_READ_CSR, *PPQ_DATA3_READ_CSR;

      typedef union _PQ_DATA3_READ_CSR_UNION {
         PQ_DATA3_READ_CSR bits;
         u32 dw; // dword union
      } SG_PACK PQ_DATA3_READ_CSR_UNION, *PPQ_DATA3_READ_CSR_UNION;

      SG_C_ASSERT(__sizeof__PQ_DATA3_READ_CSR_UNION, sizeof (PQ_DATA3_READ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 ptc_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 erx_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 uc_hwdbg_pqcntenc : 2;         // DWORD 0
               u32 rsvd0_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_PQ_HWDBG, *PRDMA_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__RDMA_PQ_HWDBG, sizeof (RDMA_PQ_HWDBG) == 8);

   #else
      typedef struct _RDMA_PQ_HWDBG {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 ptc_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 erx_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 uc_hwdbg_pqcntenc : 2;               // DWORD 0
         u32 rsvd0_array[1];                      // DWORDS 1 to 1
      } SG_PACK RDMA_PQ_HWDBG, *PRDMA_PQ_HWDBG;

      typedef union _RDMA_PQ_HWDBG_UNION {
         RDMA_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK RDMA_PQ_HWDBG_UNION, *PRDMA_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__RDMA_PQ_HWDBG_UNION, sizeof (RDMA_PQ_HWDBG_UNION) == 8);
   #endif


#else
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_PQ_HWDBG {
         union {
            struct { 
               u32 uc_hwdbg_pqcntenc : 2;         // DWORD 0
               u32 erx_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 ptc_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
               u32 rsvd0_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_PQ_HWDBG, *PRDMA_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__RDMA_PQ_HWDBG, sizeof (RDMA_PQ_HWDBG) == 8);

   #else
      typedef struct _RDMA_PQ_HWDBG {
         u32 uc_hwdbg_pqcntenc : 2;               // DWORD 0
         u32 erx_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 ptc_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
         u32 rsvd0_array[1];                      // DWORDS 1 to 1
      } SG_PACK RDMA_PQ_HWDBG, *PRDMA_PQ_HWDBG;

      typedef union _RDMA_PQ_HWDBG_UNION {
         RDMA_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK RDMA_PQ_HWDBG_UNION, *PRDMA_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__RDMA_PQ_HWDBG_UNION, sizeof (RDMA_PQ_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd1 : 20;                    // DWORD 0
               u32 erx_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 tpost_hwdbg_pqcntenc : 2;      // DWORD 0
               u32 uc_hwdbg_pqcntenc : 2;         // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK WDMA_PQ_HWDBG, *PWDMA_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__WDMA_PQ_HWDBG, sizeof (WDMA_PQ_HWDBG) == 8);

   #else
      typedef struct _WDMA_PQ_HWDBG {
         u32 rsvd1 : 20;                          // DWORD 0
         u32 erx_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 tpost_hwdbg_pqcntenc : 2;            // DWORD 0
         u32 uc_hwdbg_pqcntenc : 2;               // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK WDMA_PQ_HWDBG, *PWDMA_PQ_HWDBG;

      typedef union _WDMA_PQ_HWDBG_UNION {
         WDMA_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK WDMA_PQ_HWDBG_UNION, *PWDMA_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__WDMA_PQ_HWDBG_UNION, sizeof (WDMA_PQ_HWDBG_UNION) == 8);
   #endif


#else
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0 : 6;                     // DWORD 0
               u32 uc_hwdbg_pqcntenc : 2;         // DWORD 0
               u32 tpost_hwdbg_pqcntenc : 2;      // DWORD 0
               u32 erx_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 rsvd1 : 20;                    // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK WDMA_PQ_HWDBG, *PWDMA_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__WDMA_PQ_HWDBG, sizeof (WDMA_PQ_HWDBG) == 8);

   #else
      typedef struct _WDMA_PQ_HWDBG {
         u32 rsvd0 : 6;                           // DWORD 0
         u32 uc_hwdbg_pqcntenc : 2;               // DWORD 0
         u32 tpost_hwdbg_pqcntenc : 2;            // DWORD 0
         u32 erx_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 rsvd1 : 20;                          // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK WDMA_PQ_HWDBG, *PWDMA_PQ_HWDBG;

      typedef union _WDMA_PQ_HWDBG_UNION {
         WDMA_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK WDMA_PQ_HWDBG_UNION, *PWDMA_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__WDMA_PQ_HWDBG_UNION, sizeof (WDMA_PQ_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd1 : 18;                    // DWORD 0
               u32 txp_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK NDMA_PQ_HWDBG, *PNDMA_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__NDMA_PQ_HWDBG, sizeof (NDMA_PQ_HWDBG) == 8);

   #else
      typedef struct _NDMA_PQ_HWDBG {
         u32 rsvd1 : 18;                          // DWORD 0
         u32 txp_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK NDMA_PQ_HWDBG, *PNDMA_PQ_HWDBG;

      typedef union _NDMA_PQ_HWDBG_UNION {
         NDMA_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK NDMA_PQ_HWDBG_UNION, *PNDMA_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__NDMA_PQ_HWDBG_UNION, sizeof (NDMA_PQ_HWDBG_UNION) == 8);
   #endif


#else
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0 : 12;                    // DWORD 0
               u32 txp_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 rsvd1 : 18;                    // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK NDMA_PQ_HWDBG, *PNDMA_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__NDMA_PQ_HWDBG, sizeof (NDMA_PQ_HWDBG) == 8);

   #else
      typedef struct _NDMA_PQ_HWDBG {
         u32 rsvd0 : 12;                          // DWORD 0
         u32 txp_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 rsvd1 : 18;                          // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK NDMA_PQ_HWDBG, *PNDMA_PQ_HWDBG;

      typedef union _NDMA_PQ_HWDBG_UNION {
         NDMA_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK NDMA_PQ_HWDBG_UNION, *PNDMA_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__NDMA_PQ_HWDBG_UNION, sizeof (NDMA_PQ_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd1 : 12;                    // DWORD 0
               u32 uc_hwdbg_pqcntenc : 2;         // DWORD 0
               u32 txp_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 erx_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK CEV_PQ_HWDBG, *PCEV_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__CEV_PQ_HWDBG, sizeof (CEV_PQ_HWDBG) == 8);

   #else
      typedef struct _CEV_PQ_HWDBG {
         u32 rsvd1 : 12;                          // DWORD 0
         u32 uc_hwdbg_pqcntenc : 2;               // DWORD 0
         u32 txp_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 erx_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK CEV_PQ_HWDBG, *PCEV_PQ_HWDBG;

      typedef union _CEV_PQ_HWDBG_UNION {
         CEV_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK CEV_PQ_HWDBG_UNION, *PCEV_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__CEV_PQ_HWDBG_UNION, sizeof (CEV_PQ_HWDBG_UNION) == 8);
   #endif


#else
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0 : 14;                    // DWORD 0
               u32 erx_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 txp_hwdbg_pqcntenc : 2;        // DWORD 0
               u32 uc_hwdbg_pqcntenc : 2;         // DWORD 0
               u32 rsvd1 : 12;                    // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK CEV_PQ_HWDBG, *PCEV_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__CEV_PQ_HWDBG, sizeof (CEV_PQ_HWDBG) == 8);

   #else
      typedef struct _CEV_PQ_HWDBG {
         u32 rsvd0 : 14;                          // DWORD 0
         u32 erx_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 txp_hwdbg_pqcntenc : 2;              // DWORD 0
         u32 uc_hwdbg_pqcntenc : 2;               // DWORD 0
         u32 rsvd1 : 12;                          // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK CEV_PQ_HWDBG, *PCEV_PQ_HWDBG;

      typedef union _CEV_PQ_HWDBG_UNION {
         CEV_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK CEV_PQ_HWDBG_UNION, *PCEV_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__CEV_PQ_HWDBG_UNION, sizeof (CEV_PQ_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd1 : 10;                    // DWORD 0
               u32 ndma_hwdbg_pqcntenc : 2;       // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TXP_PQ_HWDBG, *PTXP_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__TXP_PQ_HWDBG, sizeof (TXP_PQ_HWDBG) == 8);

   #else
      typedef struct _TXP_PQ_HWDBG {
         u32 rsvd1 : 10;                          // DWORD 0
         u32 ndma_hwdbg_pqcntenc : 2;             // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK TXP_PQ_HWDBG, *PTXP_PQ_HWDBG;

      typedef union _TXP_PQ_HWDBG_UNION {
         TXP_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK TXP_PQ_HWDBG_UNION, *PTXP_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__TXP_PQ_HWDBG_UNION, sizeof (TXP_PQ_HWDBG_UNION) == 8);
   #endif


#else
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0 : 20;                    // DWORD 0
               u32 ndma_hwdbg_pqcntenc : 2;       // DWORD 0
               u32 rsvd1 : 10;                    // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TXP_PQ_HWDBG, *PTXP_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__TXP_PQ_HWDBG, sizeof (TXP_PQ_HWDBG) == 8);

   #else
      typedef struct _TXP_PQ_HWDBG {
         u32 rsvd0 : 20;                          // DWORD 0
         u32 ndma_hwdbg_pqcntenc : 2;             // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK TXP_PQ_HWDBG, *PTXP_PQ_HWDBG;

      typedef union _TXP_PQ_HWDBG_UNION {
         TXP_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK TXP_PQ_HWDBG_UNION, *PTXP_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__TXP_PQ_HWDBG_UNION, sizeof (TXP_PQ_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd1 : 8;                     // DWORD 0
               u32 jellm_hwdbg_pqcntenc : 2;      // DWORD 0
               u32 rsvd0 : 22;                    // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_PQ_HWDBG, *PTPRE_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__TPRE_PQ_HWDBG, sizeof (TPRE_PQ_HWDBG) == 8);

   #else
      typedef struct _TPRE_PQ_HWDBG {
         u32 rsvd1 : 8;                           // DWORD 0
         u32 jellm_hwdbg_pqcntenc : 2;            // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK TPRE_PQ_HWDBG, *PTPRE_PQ_HWDBG;

      typedef union _TPRE_PQ_HWDBG_UNION {
         TPRE_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK TPRE_PQ_HWDBG_UNION, *PTPRE_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__TPRE_PQ_HWDBG_UNION, sizeof (TPRE_PQ_HWDBG_UNION) == 8);
   #endif


#else
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0 : 22;                    // DWORD 0
               u32 jellm_hwdbg_pqcntenc : 2;      // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_PQ_HWDBG, *PTPRE_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__TPRE_PQ_HWDBG, sizeof (TPRE_PQ_HWDBG) == 8);

   #else
      typedef struct _TPRE_PQ_HWDBG {
         u32 rsvd0 : 22;                          // DWORD 0
         u32 jellm_hwdbg_pqcntenc : 2;            // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK TPRE_PQ_HWDBG, *PTPRE_PQ_HWDBG;

      typedef union _TPRE_PQ_HWDBG_UNION {
         TPRE_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK TPRE_PQ_HWDBG_UNION, *PTPRE_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__TPRE_PQ_HWDBG_UNION, sizeof (TPRE_PQ_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 wdma_pkt_mngr_hwdbg_pqcntenc : 2; // DWORD 0
               u32 erx_pkt_mngr_hwdbg_pqcntenc : 2; // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ERX_PQ_HWDBG, *PERX_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__ERX_PQ_HWDBG, sizeof (ERX_PQ_HWDBG) == 8);

   #else
      typedef struct _ERX_PQ_HWDBG {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 wdma_pkt_mngr_hwdbg_pqcntenc : 2;    // DWORD 0
         u32 erx_pkt_mngr_hwdbg_pqcntenc : 2;     // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK ERX_PQ_HWDBG, *PERX_PQ_HWDBG;

      typedef union _ERX_PQ_HWDBG_UNION {
         ERX_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK ERX_PQ_HWDBG_UNION, *PERX_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__ERX_PQ_HWDBG_UNION, sizeof (ERX_PQ_HWDBG_UNION) == 8);
   #endif


#else
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 erx_pkt_mngr_hwdbg_pqcntenc : 2; // DWORD 0
               u32 wdma_pkt_mngr_hwdbg_pqcntenc : 2; // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rsvd1_array[1];                // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ERX_PQ_HWDBG, *PERX_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__ERX_PQ_HWDBG, sizeof (ERX_PQ_HWDBG) == 8);

   #else
      typedef struct _ERX_PQ_HWDBG {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 erx_pkt_mngr_hwdbg_pqcntenc : 2;     // DWORD 0
         u32 wdma_pkt_mngr_hwdbg_pqcntenc : 2;    // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd1_array[1];                      // DWORDS 1 to 1
      } SG_PACK ERX_PQ_HWDBG, *PERX_PQ_HWDBG;

      typedef union _ERX_PQ_HWDBG_UNION {
         ERX_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK ERX_PQ_HWDBG_UNION, *PERX_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__ERX_PQ_HWDBG_UNION, sizeof (ERX_PQ_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1 : 16;                    // DWORD 1
               u32 uc_cdmc_hwdbg_pqcntenc : 2;    // DWORD 1
               u32 ptc_cdmc_hwdbg_pqcntenc : 2;   // DWORD 1
               u32 wdma_cdmc_hwdbg_pqcntenc : 2;  // DWORD 1
               u32 rdma_cdmc_hwdbg_pqcntenc : 2;  // DWORD 1
               u32 wdma_rel_hwdbg_pqcntenc : 2;   // DWORD 1
               u32 rdma_rel_hwdbg_pqcntenc : 2;   // DWORD 1
               u32 cev_hwdbg_pqcntenc : 2;        // DWORD 1
               u32 erx_hwdbg_pqcntenc : 2;        // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK UC_PQ_HWDBG, *PUC_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__UC_PQ_HWDBG, sizeof (UC_PQ_HWDBG) == 8);

   #else
      typedef struct _UC_PQ_HWDBG {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1 : 16;                          // DWORD 1
         u32 uc_cdmc_hwdbg_pqcntenc : 2;          // DWORD 1
         u32 ptc_cdmc_hwdbg_pqcntenc : 2;         // DWORD 1
         u32 wdma_cdmc_hwdbg_pqcntenc : 2;        // DWORD 1
         u32 rdma_cdmc_hwdbg_pqcntenc : 2;        // DWORD 1
         u32 wdma_rel_hwdbg_pqcntenc : 2;         // DWORD 1
         u32 rdma_rel_hwdbg_pqcntenc : 2;         // DWORD 1
         u32 cev_hwdbg_pqcntenc : 2;              // DWORD 1
         u32 erx_hwdbg_pqcntenc : 2;              // DWORD 1
      } SG_PACK UC_PQ_HWDBG, *PUC_PQ_HWDBG;

      typedef union _UC_PQ_HWDBG_UNION {
         UC_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK UC_PQ_HWDBG_UNION, *PUC_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__UC_PQ_HWDBG_UNION, sizeof (UC_PQ_HWDBG_UNION) == 8);
   #endif


#else
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 erx_hwdbg_pqcntenc : 2;        // DWORD 1
               u32 cev_hwdbg_pqcntenc : 2;        // DWORD 1
               u32 rdma_rel_hwdbg_pqcntenc : 2;   // DWORD 1
               u32 wdma_rel_hwdbg_pqcntenc : 2;   // DWORD 1
               u32 rdma_cdmc_hwdbg_pqcntenc : 2;  // DWORD 1
               u32 wdma_cdmc_hwdbg_pqcntenc : 2;  // DWORD 1
               u32 ptc_cdmc_hwdbg_pqcntenc : 2;   // DWORD 1
               u32 uc_cdmc_hwdbg_pqcntenc : 2;    // DWORD 1
               u32 rsvd1 : 16;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK UC_PQ_HWDBG, *PUC_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__UC_PQ_HWDBG, sizeof (UC_PQ_HWDBG) == 8);

   #else
      typedef struct _UC_PQ_HWDBG {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 erx_hwdbg_pqcntenc : 2;              // DWORD 1
         u32 cev_hwdbg_pqcntenc : 2;              // DWORD 1
         u32 rdma_rel_hwdbg_pqcntenc : 2;         // DWORD 1
         u32 wdma_rel_hwdbg_pqcntenc : 2;         // DWORD 1
         u32 rdma_cdmc_hwdbg_pqcntenc : 2;        // DWORD 1
         u32 wdma_cdmc_hwdbg_pqcntenc : 2;        // DWORD 1
         u32 ptc_cdmc_hwdbg_pqcntenc : 2;         // DWORD 1
         u32 uc_cdmc_hwdbg_pqcntenc : 2;          // DWORD 1
         u32 rsvd1 : 16;                          // DWORD 1
      } SG_PACK UC_PQ_HWDBG, *PUC_PQ_HWDBG;

      typedef union _UC_PQ_HWDBG_UNION {
         UC_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK UC_PQ_HWDBG_UNION, *PUC_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__UC_PQ_HWDBG_UNION, sizeof (UC_PQ_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1 : 12;                    // DWORD 1
               u32 rdma_hwdbg_pqcntenc : 2;       // DWORD 1
               u32 uc_hwdbg_pqcntenc : 2;         // DWORD 1
               u32 rsvd0_end : 16;                // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK PTC_PQ_HWDBG, *PPTC_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__PTC_PQ_HWDBG, sizeof (PTC_PQ_HWDBG) == 8);

   #else
      typedef struct _PTC_PQ_HWDBG {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1 : 12;                          // DWORD 1
         u32 rdma_hwdbg_pqcntenc : 2;             // DWORD 1
         u32 uc_hwdbg_pqcntenc : 2;               // DWORD 1
         u32 rsvd0_end : 16;                      // DWORD 1
      } SG_PACK PTC_PQ_HWDBG, *PPTC_PQ_HWDBG;

      typedef union _PTC_PQ_HWDBG_UNION {
         PTC_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK PTC_PQ_HWDBG_UNION, *PPTC_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__PTC_PQ_HWDBG_UNION, sizeof (PTC_PQ_HWDBG_UNION) == 8);
   #endif


#else
   // ERX PQ Encoded Count signals. Arranged so all chip PQ FIFO levels can be viewed at
   // once for performance / backpressure analysis. See PQ_COUNT_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_PQ_HWDBG {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd0_end : 16;                // DWORD 1
               u32 uc_hwdbg_pqcntenc : 2;         // DWORD 1
               u32 rdma_hwdbg_pqcntenc : 2;       // DWORD 1
               u32 rsvd1 : 12;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK PTC_PQ_HWDBG, *PPTC_PQ_HWDBG;

      SG_C_ASSERT(__sizeof__PTC_PQ_HWDBG, sizeof (PTC_PQ_HWDBG) == 8);

   #else
      typedef struct _PTC_PQ_HWDBG {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd0_end : 16;                      // DWORD 1
         u32 uc_hwdbg_pqcntenc : 2;               // DWORD 1
         u32 rdma_hwdbg_pqcntenc : 2;             // DWORD 1
         u32 rsvd1 : 12;                          // DWORD 1
      } SG_PACK PTC_PQ_HWDBG, *PPTC_PQ_HWDBG;

      typedef union _PTC_PQ_HWDBG_UNION {
         PTC_PQ_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK PTC_PQ_HWDBG_UNION, *PPTC_PQ_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__PTC_PQ_HWDBG_UNION, sizeof (PTC_PQ_HWDBG_UNION) == 8);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __pq_bmap_h__

