/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ptc_bmap_h__
#define __ptc_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "pq_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // This register offers general controls of the PTC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CONTROL_CSR {
         union {
            struct { 
               u32 rsvd2 : 8;                     // DWORD 0
               u32 ptc_rdma_throttle : 4;         // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rdma_swap_cntl : 2;            // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 en_host : 1;                   // DWORD 0
               u32 en_ptc : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CONTROL_CSR, *PPTC_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__PTC_CONTROL_CSR, sizeof (PTC_CONTROL_CSR) == 4);

   #else
      typedef struct _PTC_CONTROL_CSR {
         u32 rsvd2 : 8;                           // DWORD 0
         u32 ptc_rdma_throttle : 4;               // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rdma_swap_cntl : 2;                  // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 en_host : 1;                         // DWORD 0
         u32 en_ptc : 1;                          // DWORD 0
      } SG_PACK PTC_CONTROL_CSR, *PPTC_CONTROL_CSR;

      typedef union _PTC_CONTROL_CSR_UNION {
         PTC_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_CONTROL_CSR_UNION, *PPTC_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_CONTROL_CSR_UNION, sizeof (PTC_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // This register offers general controls of the PTC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CONTROL_CSR {
         union {
            struct { 
               u32 en_ptc : 1;                    // DWORD 0
               u32 en_host : 1;                   // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 rdma_swap_cntl : 2;            // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 ptc_rdma_throttle : 4;         // DWORD 0
               u32 rsvd2 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CONTROL_CSR, *PPTC_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__PTC_CONTROL_CSR, sizeof (PTC_CONTROL_CSR) == 4);

   #else
      typedef struct _PTC_CONTROL_CSR {
         u32 en_ptc : 1;                          // DWORD 0
         u32 en_host : 1;                         // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 rdma_swap_cntl : 2;                  // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 ptc_rdma_throttle : 4;               // DWORD 0
         u32 rsvd2 : 8;                           // DWORD 0
      } SG_PACK PTC_CONTROL_CSR, *PPTC_CONTROL_CSR;

      typedef union _PTC_CONTROL_CSR_UNION {
         PTC_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_CONTROL_CSR_UNION, *PPTC_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_CONTROL_CSR_UNION, sizeof (PTC_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The PTC Command register is used in conjunction with the CRA and the physical
   // address registers. To Initiate a command that applies to a cache line, the CRA is
   // first loaded with the request address followed by the command. For read operations,
   // the physical address will appear in the read_pa_lo and read_pa_hi registers when the
   // command completes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_COMMAND_CSR {
         union {
            struct { 
               u32 opaque_data : 16;              // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 pci_func : 1;                  // DWORD 0
               u32 rd : 1;                        // DWORD 0
               u32 invalidate : 1;                // DWORD 0
               u32 touch : 1;                     // DWORD 0
               u32 lock : 1;                      // DWORD 0
               u32 status : 1;                    // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_COMMAND_CSR, *PPTC_COMMAND_CSR;

      SG_C_ASSERT(__sizeof__PTC_COMMAND_CSR, sizeof (PTC_COMMAND_CSR) == 4);

   #else
      typedef struct _PTC_COMMAND_CSR {
         u32 opaque_data : 16;                    // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 pci_func : 1;                        // DWORD 0
         u32 rd : 1;                              // DWORD 0
         u32 invalidate : 1;                      // DWORD 0
         u32 touch : 1;                           // DWORD 0
         u32 lock : 1;                            // DWORD 0
         u32 status : 1;                          // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK PTC_COMMAND_CSR, *PPTC_COMMAND_CSR;

      typedef union _PTC_COMMAND_CSR_UNION {
         PTC_COMMAND_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_COMMAND_CSR_UNION, *PPTC_COMMAND_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_COMMAND_CSR_UNION, sizeof (PTC_COMMAND_CSR_UNION) == 4);
   #endif


#else
   // The PTC Command register is used in conjunction with the CRA and the physical
   // address registers. To Initiate a command that applies to a cache line, the CRA is
   // first loaded with the request address followed by the command. For read operations,
   // the physical address will appear in the read_pa_lo and read_pa_hi registers when the
   // command completes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_COMMAND_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 status : 1;                    // DWORD 0
               u32 lock : 1;                      // DWORD 0
               u32 touch : 1;                     // DWORD 0
               u32 invalidate : 1;                // DWORD 0
               u32 rd : 1;                        // DWORD 0
               u32 pci_func : 1;                  // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 opaque_data : 16;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_COMMAND_CSR, *PPTC_COMMAND_CSR;

      SG_C_ASSERT(__sizeof__PTC_COMMAND_CSR, sizeof (PTC_COMMAND_CSR) == 4);

   #else
      typedef struct _PTC_COMMAND_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 status : 1;                          // DWORD 0
         u32 lock : 1;                            // DWORD 0
         u32 touch : 1;                           // DWORD 0
         u32 invalidate : 1;                      // DWORD 0
         u32 rd : 1;                              // DWORD 0
         u32 pci_func : 1;                        // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 opaque_data : 16;                    // DWORD 0
      } SG_PACK PTC_COMMAND_CSR, *PPTC_COMMAND_CSR;

      typedef union _PTC_COMMAND_CSR_UNION {
         PTC_COMMAND_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_COMMAND_CSR_UNION, *PPTC_COMMAND_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_COMMAND_CSR_UNION, sizeof (PTC_COMMAND_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the cache address used with the command.
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_CSR {
         union {
            struct { 
               u32 cra;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_CSR, *PPTC_CRA_CSR;

      SG_C_ASSERT(__sizeof__PTC_CRA_CSR, sizeof (PTC_CRA_CSR) == 4);

   #else
      typedef struct _PTC_CRA_CSR {
         u32 cra;                                 // DWORD 0
      } SG_PACK PTC_CRA_CSR, *PPTC_CRA_CSR;

      typedef union _PTC_CRA_CSR_UNION {
         PTC_CRA_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_CSR_UNION, *PPTC_CRA_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_CSR_UNION, sizeof (PTC_CRA_CSR_UNION) == 4);
   #endif


#else
   // This is the cache address used with the command.
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_CSR {
         union {
            struct { 
               u32 cra;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_CSR, *PPTC_CRA_CSR;

      SG_C_ASSERT(__sizeof__PTC_CRA_CSR, sizeof (PTC_CRA_CSR) == 4);

   #else
      typedef struct _PTC_CRA_CSR {
         u32 cra;                                 // DWORD 0
      } SG_PACK PTC_CRA_CSR, *PPTC_CRA_CSR;

      typedef union _PTC_CRA_CSR_UNION {
         PTC_CRA_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_CSR_UNION, *PPTC_CRA_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_CSR_UNION, sizeof (PTC_CRA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The physical address as a result of a READ operation. If bit 0 of addr_lo is set,
   // the address is considered invalid. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_PHYS_ADDR_LO {
         union {
            struct { 
               u32 addr_lo;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_PHYS_ADDR_LO, *PPTC_PHYS_ADDR_LO;

      SG_C_ASSERT(__sizeof__PTC_PHYS_ADDR_LO, sizeof (PTC_PHYS_ADDR_LO) == 4);

   #else
      typedef struct _PTC_PHYS_ADDR_LO {
         u32 addr_lo;                             // DWORD 0
      } SG_PACK PTC_PHYS_ADDR_LO, *PPTC_PHYS_ADDR_LO;

      typedef union _PTC_PHYS_ADDR_LO_UNION {
         PTC_PHYS_ADDR_LO bits;
         u32 dw; // dword union
      } SG_PACK PTC_PHYS_ADDR_LO_UNION, *PPTC_PHYS_ADDR_LO_UNION;

      SG_C_ASSERT(__sizeof__PTC_PHYS_ADDR_LO_UNION, sizeof (PTC_PHYS_ADDR_LO_UNION) == 4);
   #endif


#else
   // The physical address as a result of a READ operation. If bit 0 of addr_lo is set,
   // the address is considered invalid. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_PHYS_ADDR_LO {
         union {
            struct { 
               u32 addr_lo;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_PHYS_ADDR_LO, *PPTC_PHYS_ADDR_LO;

      SG_C_ASSERT(__sizeof__PTC_PHYS_ADDR_LO, sizeof (PTC_PHYS_ADDR_LO) == 4);

   #else
      typedef struct _PTC_PHYS_ADDR_LO {
         u32 addr_lo;                             // DWORD 0
      } SG_PACK PTC_PHYS_ADDR_LO, *PPTC_PHYS_ADDR_LO;

      typedef union _PTC_PHYS_ADDR_LO_UNION {
         PTC_PHYS_ADDR_LO bits;
         u32 dw; // dword union
      } SG_PACK PTC_PHYS_ADDR_LO_UNION, *PPTC_PHYS_ADDR_LO_UNION;

      SG_C_ASSERT(__sizeof__PTC_PHYS_ADDR_LO_UNION, sizeof (PTC_PHYS_ADDR_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The physical address as a result of a READ operation
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_PHYS_ADDR_HI {
         union {
            struct { 
               u32 addr_lo;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_PHYS_ADDR_HI, *PPTC_PHYS_ADDR_HI;

      SG_C_ASSERT(__sizeof__PTC_PHYS_ADDR_HI, sizeof (PTC_PHYS_ADDR_HI) == 4);

   #else
      typedef struct _PTC_PHYS_ADDR_HI {
         u32 addr_lo;                             // DWORD 0
      } SG_PACK PTC_PHYS_ADDR_HI, *PPTC_PHYS_ADDR_HI;

      typedef union _PTC_PHYS_ADDR_HI_UNION {
         PTC_PHYS_ADDR_HI bits;
         u32 dw; // dword union
      } SG_PACK PTC_PHYS_ADDR_HI_UNION, *PPTC_PHYS_ADDR_HI_UNION;

      SG_C_ASSERT(__sizeof__PTC_PHYS_ADDR_HI_UNION, sizeof (PTC_PHYS_ADDR_HI_UNION) == 4);
   #endif


#else
   // The physical address as a result of a READ operation
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_PHYS_ADDR_HI {
         union {
            struct { 
               u32 addr_lo;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_PHYS_ADDR_HI, *PPTC_PHYS_ADDR_HI;

      SG_C_ASSERT(__sizeof__PTC_PHYS_ADDR_HI, sizeof (PTC_PHYS_ADDR_HI) == 4);

   #else
      typedef struct _PTC_PHYS_ADDR_HI {
         u32 addr_lo;                             // DWORD 0
      } SG_PACK PTC_PHYS_ADDR_HI, *PPTC_PHYS_ADDR_HI;

      typedef union _PTC_PHYS_ADDR_HI_UNION {
         PTC_PHYS_ADDR_HI bits;
         u32 dw; // dword union
      } SG_PACK PTC_PHYS_ADDR_HI_UNION, *PPTC_PHYS_ADDR_HI_UNION;

      SG_C_ASSERT(__sizeof__PTC_PHYS_ADDR_HI_UNION, sizeof (PTC_PHYS_ADDR_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Directory Table Index to program
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_DT_INDEX_CSR {
         union {
            struct { 
               u32 idx;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_DT_INDEX_CSR, *PPTC_DT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__PTC_DT_INDEX_CSR, sizeof (PTC_DT_INDEX_CSR) == 4);

   #else
      typedef struct _PTC_DT_INDEX_CSR {
         u32 idx;                                 // DWORD 0
      } SG_PACK PTC_DT_INDEX_CSR, *PPTC_DT_INDEX_CSR;

      typedef union _PTC_DT_INDEX_CSR_UNION {
         PTC_DT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_DT_INDEX_CSR_UNION, *PPTC_DT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_DT_INDEX_CSR_UNION, sizeof (PTC_DT_INDEX_CSR_UNION) == 4);
   #endif


#else
   // Directory Table Index to program
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_DT_INDEX_CSR {
         union {
            struct { 
               u32 idx;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_DT_INDEX_CSR, *PPTC_DT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__PTC_DT_INDEX_CSR, sizeof (PTC_DT_INDEX_CSR) == 4);

   #else
      typedef struct _PTC_DT_INDEX_CSR {
         u32 idx;                                 // DWORD 0
      } SG_PACK PTC_DT_INDEX_CSR, *PPTC_DT_INDEX_CSR;

      typedef union _PTC_DT_INDEX_CSR_UNION {
         PTC_DT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_DT_INDEX_CSR_UNION, *PPTC_DT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_DT_INDEX_CSR_UNION, sizeof (PTC_DT_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The index of the stat that needs to be read
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_STAT_INDEX_CSR {
         union {
            struct { 
               u32 index;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_STAT_INDEX_CSR, *PPTC_STAT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__PTC_STAT_INDEX_CSR, sizeof (PTC_STAT_INDEX_CSR) == 4);

   #else
      typedef struct _PTC_STAT_INDEX_CSR {
         u32 index;                               // DWORD 0
      } SG_PACK PTC_STAT_INDEX_CSR, *PPTC_STAT_INDEX_CSR;

      typedef union _PTC_STAT_INDEX_CSR_UNION {
         PTC_STAT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_STAT_INDEX_CSR_UNION, *PPTC_STAT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_STAT_INDEX_CSR_UNION, sizeof (PTC_STAT_INDEX_CSR_UNION) == 4);
   #endif


#else
   // The index of the stat that needs to be read
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_STAT_INDEX_CSR {
         union {
            struct { 
               u32 index;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_STAT_INDEX_CSR, *PPTC_STAT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__PTC_STAT_INDEX_CSR, sizeof (PTC_STAT_INDEX_CSR) == 4);

   #else
      typedef struct _PTC_STAT_INDEX_CSR {
         u32 index;                               // DWORD 0
      } SG_PACK PTC_STAT_INDEX_CSR, *PPTC_STAT_INDEX_CSR;

      typedef union _PTC_STAT_INDEX_CSR_UNION {
         PTC_STAT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_STAT_INDEX_CSR_UNION, *PPTC_STAT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_STAT_INDEX_CSR_UNION, sizeof (PTC_STAT_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The value of the statistics
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_STAT_VALUE_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_STAT_VALUE_CSR, *PPTC_STAT_VALUE_CSR;

      SG_C_ASSERT(__sizeof__PTC_STAT_VALUE_CSR, sizeof (PTC_STAT_VALUE_CSR) == 4);

   #else
      typedef struct _PTC_STAT_VALUE_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK PTC_STAT_VALUE_CSR, *PPTC_STAT_VALUE_CSR;

      typedef union _PTC_STAT_VALUE_CSR_UNION {
         PTC_STAT_VALUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_STAT_VALUE_CSR_UNION, *PPTC_STAT_VALUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_STAT_VALUE_CSR_UNION, sizeof (PTC_STAT_VALUE_CSR_UNION) == 4);
   #endif


#else
   // The value of the statistics
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_STAT_VALUE_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_STAT_VALUE_CSR, *PPTC_STAT_VALUE_CSR;

      SG_C_ASSERT(__sizeof__PTC_STAT_VALUE_CSR, sizeof (PTC_STAT_VALUE_CSR) == 4);

   #else
      typedef struct _PTC_STAT_VALUE_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK PTC_STAT_VALUE_CSR, *PPTC_STAT_VALUE_CSR;

      typedef union _PTC_STAT_VALUE_CSR_UNION {
         PTC_STAT_VALUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_STAT_VALUE_CSR_UNION, *PPTC_STAT_VALUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_STAT_VALUE_CSR_UNION, sizeof (PTC_STAT_VALUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The range counter index value to be read or modified
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_STAT_RANGE_INDEX_CSR {
         union {
            struct { 
               u32 range_index;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_STAT_RANGE_INDEX_CSR, *PPTC_STAT_RANGE_INDEX_CSR;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_INDEX_CSR, sizeof (PTC_STAT_RANGE_INDEX_CSR) == 4);

   #else
      typedef struct _PTC_STAT_RANGE_INDEX_CSR {
         u32 range_index;                         // DWORD 0
      } SG_PACK PTC_STAT_RANGE_INDEX_CSR, *PPTC_STAT_RANGE_INDEX_CSR;

      typedef union _PTC_STAT_RANGE_INDEX_CSR_UNION {
         PTC_STAT_RANGE_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_STAT_RANGE_INDEX_CSR_UNION, *PPTC_STAT_RANGE_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_INDEX_CSR_UNION, sizeof (PTC_STAT_RANGE_INDEX_CSR_UNION) == 4);
   #endif


#else
   // The range counter index value to be read or modified
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_STAT_RANGE_INDEX_CSR {
         union {
            struct { 
               u32 range_index;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_STAT_RANGE_INDEX_CSR, *PPTC_STAT_RANGE_INDEX_CSR;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_INDEX_CSR, sizeof (PTC_STAT_RANGE_INDEX_CSR) == 4);

   #else
      typedef struct _PTC_STAT_RANGE_INDEX_CSR {
         u32 range_index;                         // DWORD 0
      } SG_PACK PTC_STAT_RANGE_INDEX_CSR, *PPTC_STAT_RANGE_INDEX_CSR;

      typedef union _PTC_STAT_RANGE_INDEX_CSR_UNION {
         PTC_STAT_RANGE_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_STAT_RANGE_INDEX_CSR_UNION, *PPTC_STAT_RANGE_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_INDEX_CSR_UNION, sizeof (PTC_STAT_RANGE_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The start address of the CRA for range statistics
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_STAT_RANGE_START_CSR {
         union {
            struct { 
               u32 start;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_STAT_RANGE_START_CSR, *PPTC_STAT_RANGE_START_CSR;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_START_CSR, sizeof (PTC_STAT_RANGE_START_CSR) == 4);

   #else
      typedef struct _PTC_STAT_RANGE_START_CSR {
         u32 start;                               // DWORD 0
      } SG_PACK PTC_STAT_RANGE_START_CSR, *PPTC_STAT_RANGE_START_CSR;

      typedef union _PTC_STAT_RANGE_START_CSR_UNION {
         PTC_STAT_RANGE_START_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_STAT_RANGE_START_CSR_UNION, *PPTC_STAT_RANGE_START_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_START_CSR_UNION, sizeof (PTC_STAT_RANGE_START_CSR_UNION) == 4);
   #endif


#else
   // The start address of the CRA for range statistics
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_STAT_RANGE_START_CSR {
         union {
            struct { 
               u32 start;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_STAT_RANGE_START_CSR, *PPTC_STAT_RANGE_START_CSR;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_START_CSR, sizeof (PTC_STAT_RANGE_START_CSR) == 4);

   #else
      typedef struct _PTC_STAT_RANGE_START_CSR {
         u32 start;                               // DWORD 0
      } SG_PACK PTC_STAT_RANGE_START_CSR, *PPTC_STAT_RANGE_START_CSR;

      typedef union _PTC_STAT_RANGE_START_CSR_UNION {
         PTC_STAT_RANGE_START_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_STAT_RANGE_START_CSR_UNION, *PPTC_STAT_RANGE_START_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_START_CSR_UNION, sizeof (PTC_STAT_RANGE_START_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Client Weighted Arbitration Control Register. PTC's clients are serviced in
   // weighted-round-robin fashion.This register controls client weights. Each weight
   // gives the maximum number of consecutive client accesses serviced by PTC before it
   // moves on to service another client.
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_WEIGHT_ARB_CSR {
         union {
            struct { 
               u32 w1 : 16;                       // DWORD 0
               u32 w0 : 16;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_WEIGHT_ARB_CSR, *PPTC_WEIGHT_ARB_CSR;

      SG_C_ASSERT(__sizeof__PTC_WEIGHT_ARB_CSR, sizeof (PTC_WEIGHT_ARB_CSR) == 4);

   #else
      typedef struct _PTC_WEIGHT_ARB_CSR {
         u32 w1 : 16;                             // DWORD 0
         u32 w0 : 16;                             // DWORD 0
      } SG_PACK PTC_WEIGHT_ARB_CSR, *PPTC_WEIGHT_ARB_CSR;

      typedef union _PTC_WEIGHT_ARB_CSR_UNION {
         PTC_WEIGHT_ARB_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_WEIGHT_ARB_CSR_UNION, *PPTC_WEIGHT_ARB_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_WEIGHT_ARB_CSR_UNION, sizeof (PTC_WEIGHT_ARB_CSR_UNION) == 4);
   #endif


#else
   // Client Weighted Arbitration Control Register. PTC's clients are serviced in
   // weighted-round-robin fashion.This register controls client weights. Each weight
   // gives the maximum number of consecutive client accesses serviced by PTC before it
   // moves on to service another client.
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_WEIGHT_ARB_CSR {
         union {
            struct { 
               u32 w0 : 16;                       // DWORD 0
               u32 w1 : 16;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_WEIGHT_ARB_CSR, *PPTC_WEIGHT_ARB_CSR;

      SG_C_ASSERT(__sizeof__PTC_WEIGHT_ARB_CSR, sizeof (PTC_WEIGHT_ARB_CSR) == 4);

   #else
      typedef struct _PTC_WEIGHT_ARB_CSR {
         u32 w0 : 16;                             // DWORD 0
         u32 w1 : 16;                             // DWORD 0
      } SG_PACK PTC_WEIGHT_ARB_CSR, *PPTC_WEIGHT_ARB_CSR;

      typedef union _PTC_WEIGHT_ARB_CSR_UNION {
         PTC_WEIGHT_ARB_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_WEIGHT_ARB_CSR_UNION, *PPTC_WEIGHT_ARB_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_WEIGHT_ARB_CSR_UNION, sizeof (PTC_WEIGHT_ARB_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The end address of the CRA for range statistics
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_STAT_RANGE_END_CSR {
         union {
            struct { 
               u32 STAT_RANGE_END;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_STAT_RANGE_END_CSR, *PPTC_STAT_RANGE_END_CSR;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_END_CSR, sizeof (PTC_STAT_RANGE_END_CSR) == 4);

   #else
      typedef struct _PTC_STAT_RANGE_END_CSR {
         u32 STAT_RANGE_END;                      // DWORD 0
      } SG_PACK PTC_STAT_RANGE_END_CSR, *PPTC_STAT_RANGE_END_CSR;

      typedef union _PTC_STAT_RANGE_END_CSR_UNION {
         PTC_STAT_RANGE_END_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_STAT_RANGE_END_CSR_UNION, *PPTC_STAT_RANGE_END_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_END_CSR_UNION, sizeof (PTC_STAT_RANGE_END_CSR_UNION) == 4);
   #endif


#else
   // The end address of the CRA for range statistics
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_STAT_RANGE_END_CSR {
         union {
            struct { 
               u32 STAT_RANGE_END;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_STAT_RANGE_END_CSR, *PPTC_STAT_RANGE_END_CSR;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_END_CSR, sizeof (PTC_STAT_RANGE_END_CSR) == 4);

   #else
      typedef struct _PTC_STAT_RANGE_END_CSR {
         u32 STAT_RANGE_END;                      // DWORD 0
      } SG_PACK PTC_STAT_RANGE_END_CSR, *PPTC_STAT_RANGE_END_CSR;

      typedef union _PTC_STAT_RANGE_END_CSR_UNION {
         PTC_STAT_RANGE_END_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_STAT_RANGE_END_CSR_UNION, *PPTC_STAT_RANGE_END_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_STAT_RANGE_END_CSR_UNION, sizeof (PTC_STAT_RANGE_END_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The address in the CTX RAM where the PTC starts
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CACHE_START_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CACHE_START_ADDR_CSR, *PPTC_CACHE_START_ADDR_CSR;

      SG_C_ASSERT(__sizeof__PTC_CACHE_START_ADDR_CSR, sizeof (PTC_CACHE_START_ADDR_CSR) == 4);

   #else
      typedef struct _PTC_CACHE_START_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK PTC_CACHE_START_ADDR_CSR, *PPTC_CACHE_START_ADDR_CSR;

      typedef union _PTC_CACHE_START_ADDR_CSR_UNION {
         PTC_CACHE_START_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_CACHE_START_ADDR_CSR_UNION, *PPTC_CACHE_START_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_CACHE_START_ADDR_CSR_UNION, sizeof (PTC_CACHE_START_ADDR_CSR_UNION) == 4);
   #endif


#else
   // The address in the CTX RAM where the PTC starts
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CACHE_START_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CACHE_START_ADDR_CSR, *PPTC_CACHE_START_ADDR_CSR;

      SG_C_ASSERT(__sizeof__PTC_CACHE_START_ADDR_CSR, sizeof (PTC_CACHE_START_ADDR_CSR) == 4);

   #else
      typedef struct _PTC_CACHE_START_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK PTC_CACHE_START_ADDR_CSR, *PPTC_CACHE_START_ADDR_CSR;

      typedef union _PTC_CACHE_START_ADDR_CSR_UNION {
         PTC_CACHE_START_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_CACHE_START_ADDR_CSR_UNION, *PPTC_CACHE_START_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_CACHE_START_ADDR_CSR_UNION, sizeof (PTC_CACHE_START_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw unrecoverable error source bits, enabled by PTC_UE_ENABLE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_UE_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 fifo_oflow_error : 1;          // DWORD 0
               u32 fifo_uflow_error : 1;          // DWORD 0
               u32 tag_ram_perror : 1;            // DWORD 0
               u32 dt_parity_error : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_UE_SOURCE, *PPTC_UE_SOURCE;

      SG_C_ASSERT(__sizeof__PTC_UE_SOURCE, sizeof (PTC_UE_SOURCE) == 4);

   #else
      typedef struct _PTC_UE_SOURCE {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 fifo_oflow_error : 1;                // DWORD 0
         u32 fifo_uflow_error : 1;                // DWORD 0
         u32 tag_ram_perror : 1;                  // DWORD 0
         u32 dt_parity_error : 1;                 // DWORD 0
      } SG_PACK PTC_UE_SOURCE, *PPTC_UE_SOURCE;

      typedef union _PTC_UE_SOURCE_UNION {
         PTC_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK PTC_UE_SOURCE_UNION, *PPTC_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__PTC_UE_SOURCE_UNION, sizeof (PTC_UE_SOURCE_UNION) == 4);
   #endif


#else
   // Raw unrecoverable error source bits, enabled by PTC_UE_ENABLE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_UE_SOURCE {
         union {
            struct { 
               u32 dt_parity_error : 1;           // DWORD 0
               u32 tag_ram_perror : 1;            // DWORD 0
               u32 fifo_uflow_error : 1;          // DWORD 0
               u32 fifo_oflow_error : 1;          // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_UE_SOURCE, *PPTC_UE_SOURCE;

      SG_C_ASSERT(__sizeof__PTC_UE_SOURCE, sizeof (PTC_UE_SOURCE) == 4);

   #else
      typedef struct _PTC_UE_SOURCE {
         u32 dt_parity_error : 1;                 // DWORD 0
         u32 tag_ram_perror : 1;                  // DWORD 0
         u32 fifo_uflow_error : 1;                // DWORD 0
         u32 fifo_oflow_error : 1;                // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK PTC_UE_SOURCE, *PPTC_UE_SOURCE;

      typedef union _PTC_UE_SOURCE_UNION {
         PTC_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK PTC_UE_SOURCE_UNION, *PPTC_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__PTC_UE_SOURCE_UNION, sizeof (PTC_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for enabling unrecoverable error . Write a 1 to enable the relevant UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_UE_ENABLE {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 fifo_oflow_error : 1;          // DWORD 0
               u32 fifo_uflow_error : 1;          // DWORD 0
               u32 tag_ram_perror : 1;            // DWORD 0
               u32 dt_parity_error : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_UE_ENABLE, *PPTC_UE_ENABLE;

      SG_C_ASSERT(__sizeof__PTC_UE_ENABLE, sizeof (PTC_UE_ENABLE) == 4);

   #else
      typedef struct _PTC_UE_ENABLE {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 fifo_oflow_error : 1;                // DWORD 0
         u32 fifo_uflow_error : 1;                // DWORD 0
         u32 tag_ram_perror : 1;                  // DWORD 0
         u32 dt_parity_error : 1;                 // DWORD 0
      } SG_PACK PTC_UE_ENABLE, *PPTC_UE_ENABLE;

      typedef union _PTC_UE_ENABLE_UNION {
         PTC_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK PTC_UE_ENABLE_UNION, *PPTC_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__PTC_UE_ENABLE_UNION, sizeof (PTC_UE_ENABLE_UNION) == 4);
   #endif


#else
   // Mask for enabling unrecoverable error . Write a 1 to enable the relevant UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_UE_ENABLE {
         union {
            struct { 
               u32 dt_parity_error : 1;           // DWORD 0
               u32 tag_ram_perror : 1;            // DWORD 0
               u32 fifo_uflow_error : 1;          // DWORD 0
               u32 fifo_oflow_error : 1;          // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_UE_ENABLE, *PPTC_UE_ENABLE;

      SG_C_ASSERT(__sizeof__PTC_UE_ENABLE, sizeof (PTC_UE_ENABLE) == 4);

   #else
      typedef struct _PTC_UE_ENABLE {
         u32 dt_parity_error : 1;                 // DWORD 0
         u32 tag_ram_perror : 1;                  // DWORD 0
         u32 fifo_uflow_error : 1;                // DWORD 0
         u32 fifo_oflow_error : 1;                // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK PTC_UE_ENABLE, *PPTC_UE_ENABLE;

      typedef union _PTC_UE_ENABLE_UNION {
         PTC_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK PTC_UE_ENABLE_UNION, *PPTC_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__PTC_UE_ENABLE_UNION, sizeof (PTC_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The PTC TS_REQ register is used to query the TAG/State for a particular Index/Way in
   // PTC. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_TS_REQ_CSR {
         union {
            struct { 
               u32 rsvd1 : 21;                    // DWORD 0
               u32 way : 3;                       // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 index : 7;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_TS_REQ_CSR, *PPTC_TS_REQ_CSR;

      SG_C_ASSERT(__sizeof__PTC_TS_REQ_CSR, sizeof (PTC_TS_REQ_CSR) == 4);

   #else
      typedef struct _PTC_TS_REQ_CSR {
         u32 rsvd1 : 21;                          // DWORD 0
         u32 way : 3;                             // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 index : 7;                           // DWORD 0
      } SG_PACK PTC_TS_REQ_CSR, *PPTC_TS_REQ_CSR;

      typedef union _PTC_TS_REQ_CSR_UNION {
         PTC_TS_REQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_TS_REQ_CSR_UNION, *PPTC_TS_REQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_TS_REQ_CSR_UNION, sizeof (PTC_TS_REQ_CSR_UNION) == 4);
   #endif


#else
   // The PTC TS_REQ register is used to query the TAG/State for a particular Index/Way in
   // PTC. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_TS_REQ_CSR {
         union {
            struct { 
               u32 index : 7;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 way : 3;                       // DWORD 0
               u32 rsvd1 : 21;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_TS_REQ_CSR, *PPTC_TS_REQ_CSR;

      SG_C_ASSERT(__sizeof__PTC_TS_REQ_CSR, sizeof (PTC_TS_REQ_CSR) == 4);

   #else
      typedef struct _PTC_TS_REQ_CSR {
         u32 index : 7;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 way : 3;                             // DWORD 0
         u32 rsvd1 : 21;                          // DWORD 0
      } SG_PACK PTC_TS_REQ_CSR, *PPTC_TS_REQ_CSR;

      typedef union _PTC_TS_REQ_CSR_UNION {
         PTC_TS_REQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_TS_REQ_CSR_UNION, *PPTC_TS_REQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_TS_REQ_CSR_UNION, sizeof (PTC_TS_REQ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The PTC TS_RESP register is used to provide the response to TAG/State query for a
   // particular Index/Way in PTC. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_TS_RESP_CSR {
         union {
            struct { 
               u32 rsvd0 : 20;                    // DWORD 0
               u32 state : 4;                     // DWORD 0
               u32 tag : 8;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_TS_RESP_CSR, *PPTC_TS_RESP_CSR;

      SG_C_ASSERT(__sizeof__PTC_TS_RESP_CSR, sizeof (PTC_TS_RESP_CSR) == 4);

   #else
      typedef struct _PTC_TS_RESP_CSR {
         u32 rsvd0 : 20;                          // DWORD 0
         u32 state : 4;                           // DWORD 0
         u32 tag : 8;                             // DWORD 0
      } SG_PACK PTC_TS_RESP_CSR, *PPTC_TS_RESP_CSR;

      typedef union _PTC_TS_RESP_CSR_UNION {
         PTC_TS_RESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_TS_RESP_CSR_UNION, *PPTC_TS_RESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_TS_RESP_CSR_UNION, sizeof (PTC_TS_RESP_CSR_UNION) == 4);
   #endif


#else
   // The PTC TS_RESP register is used to provide the response to TAG/State query for a
   // particular Index/Way in PTC. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_TS_RESP_CSR {
         union {
            struct { 
               u32 tag : 8;                       // DWORD 0
               u32 state : 4;                     // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_TS_RESP_CSR, *PPTC_TS_RESP_CSR;

      SG_C_ASSERT(__sizeof__PTC_TS_RESP_CSR, sizeof (PTC_TS_RESP_CSR) == 4);

   #else
      typedef struct _PTC_TS_RESP_CSR {
         u32 tag : 8;                             // DWORD 0
         u32 state : 4;                           // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
      } SG_PACK PTC_TS_RESP_CSR, *PPTC_TS_RESP_CSR;

      typedef union _PTC_TS_RESP_CSR_UNION {
         PTC_TS_RESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_TS_RESP_CSR_UNION, *PPTC_TS_RESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_TS_RESP_CSR_UNION, sizeof (PTC_TS_RESP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The counter for UC requests in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TO_PTC_REQ_COUNT_CSR {
         union {
            struct { 
               u32 uc_to_ptc_req_count;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TO_PTC_REQ_COUNT_CSR, *PUC_TO_PTC_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TO_PTC_REQ_COUNT_CSR, sizeof (UC_TO_PTC_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TO_PTC_REQ_COUNT_CSR {
         u32 uc_to_ptc_req_count;                 // DWORD 0
      } SG_PACK UC_TO_PTC_REQ_COUNT_CSR, *PUC_TO_PTC_REQ_COUNT_CSR;

      typedef union _UC_TO_PTC_REQ_COUNT_CSR_UNION {
         UC_TO_PTC_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TO_PTC_REQ_COUNT_CSR_UNION, *PUC_TO_PTC_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TO_PTC_REQ_COUNT_CSR_UNION, sizeof (UC_TO_PTC_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // The counter for UC requests in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TO_PTC_REQ_COUNT_CSR {
         union {
            struct { 
               u32 uc_to_ptc_req_count;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TO_PTC_REQ_COUNT_CSR, *PUC_TO_PTC_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TO_PTC_REQ_COUNT_CSR, sizeof (UC_TO_PTC_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TO_PTC_REQ_COUNT_CSR {
         u32 uc_to_ptc_req_count;                 // DWORD 0
      } SG_PACK UC_TO_PTC_REQ_COUNT_CSR, *PUC_TO_PTC_REQ_COUNT_CSR;

      typedef union _UC_TO_PTC_REQ_COUNT_CSR_UNION {
         UC_TO_PTC_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TO_PTC_REQ_COUNT_CSR_UNION, *PUC_TO_PTC_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TO_PTC_REQ_COUNT_CSR_UNION, sizeof (UC_TO_PTC_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The counter for UC responses in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_UC_RESP_COUNT_CSR {
         union {
            struct { 
               u32 ptc_uc_resp_count;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_UC_RESP_COUNT_CSR, *PPTC_UC_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PTC_UC_RESP_COUNT_CSR, sizeof (PTC_UC_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _PTC_UC_RESP_COUNT_CSR {
         u32 ptc_uc_resp_count;                   // DWORD 0
      } SG_PACK PTC_UC_RESP_COUNT_CSR, *PPTC_UC_RESP_COUNT_CSR;

      typedef union _PTC_UC_RESP_COUNT_CSR_UNION {
         PTC_UC_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_UC_RESP_COUNT_CSR_UNION, *PPTC_UC_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_UC_RESP_COUNT_CSR_UNION, sizeof (PTC_UC_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // The counter for UC responses in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_UC_RESP_COUNT_CSR {
         union {
            struct { 
               u32 ptc_uc_resp_count;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_UC_RESP_COUNT_CSR, *PPTC_UC_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PTC_UC_RESP_COUNT_CSR, sizeof (PTC_UC_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _PTC_UC_RESP_COUNT_CSR {
         u32 ptc_uc_resp_count;                   // DWORD 0
      } SG_PACK PTC_UC_RESP_COUNT_CSR, *PPTC_UC_RESP_COUNT_CSR;

      typedef union _PTC_UC_RESP_COUNT_CSR_UNION {
         PTC_UC_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_UC_RESP_COUNT_CSR_UNION, *PPTC_UC_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_UC_RESP_COUNT_CSR_UNION, sizeof (PTC_UC_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The counter for CEV requests in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_TO_PTC_REQ_COUNT_CSR {
         union {
            struct { 
               u32 cev_to_ptc_req_count;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_TO_PTC_REQ_COUNT_CSR, *PCEV_TO_PTC_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__CEV_TO_PTC_REQ_COUNT_CSR, sizeof (CEV_TO_PTC_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _CEV_TO_PTC_REQ_COUNT_CSR {
         u32 cev_to_ptc_req_count;                // DWORD 0
      } SG_PACK CEV_TO_PTC_REQ_COUNT_CSR, *PCEV_TO_PTC_REQ_COUNT_CSR;

      typedef union _CEV_TO_PTC_REQ_COUNT_CSR_UNION {
         CEV_TO_PTC_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_TO_PTC_REQ_COUNT_CSR_UNION, *PCEV_TO_PTC_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_TO_PTC_REQ_COUNT_CSR_UNION, sizeof (CEV_TO_PTC_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // The counter for CEV requests in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_TO_PTC_REQ_COUNT_CSR {
         union {
            struct { 
               u32 cev_to_ptc_req_count;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_TO_PTC_REQ_COUNT_CSR, *PCEV_TO_PTC_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__CEV_TO_PTC_REQ_COUNT_CSR, sizeof (CEV_TO_PTC_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _CEV_TO_PTC_REQ_COUNT_CSR {
         u32 cev_to_ptc_req_count;                // DWORD 0
      } SG_PACK CEV_TO_PTC_REQ_COUNT_CSR, *PCEV_TO_PTC_REQ_COUNT_CSR;

      typedef union _CEV_TO_PTC_REQ_COUNT_CSR_UNION {
         CEV_TO_PTC_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_TO_PTC_REQ_COUNT_CSR_UNION, *PCEV_TO_PTC_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_TO_PTC_REQ_COUNT_CSR_UNION, sizeof (CEV_TO_PTC_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The counter for CEV responses in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CEV_RESP_COUNT_CSR {
         union {
            struct { 
               u32 ptc_cev_resp_count;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CEV_RESP_COUNT_CSR, *PPTC_CEV_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PTC_CEV_RESP_COUNT_CSR, sizeof (PTC_CEV_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _PTC_CEV_RESP_COUNT_CSR {
         u32 ptc_cev_resp_count;                  // DWORD 0
      } SG_PACK PTC_CEV_RESP_COUNT_CSR, *PPTC_CEV_RESP_COUNT_CSR;

      typedef union _PTC_CEV_RESP_COUNT_CSR_UNION {
         PTC_CEV_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_CEV_RESP_COUNT_CSR_UNION, *PPTC_CEV_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_CEV_RESP_COUNT_CSR_UNION, sizeof (PTC_CEV_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // The counter for CEV responses in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CEV_RESP_COUNT_CSR {
         union {
            struct { 
               u32 ptc_cev_resp_count;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CEV_RESP_COUNT_CSR, *PPTC_CEV_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PTC_CEV_RESP_COUNT_CSR, sizeof (PTC_CEV_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _PTC_CEV_RESP_COUNT_CSR {
         u32 ptc_cev_resp_count;                  // DWORD 0
      } SG_PACK PTC_CEV_RESP_COUNT_CSR, *PPTC_CEV_RESP_COUNT_CSR;

      typedef union _PTC_CEV_RESP_COUNT_CSR_UNION {
         PTC_CEV_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_CEV_RESP_COUNT_CSR_UNION, *PPTC_CEV_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_CEV_RESP_COUNT_CSR_UNION, sizeof (PTC_CEV_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The counter machine states in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_RDMA_IDMC_COUNT_CSR {
         union {
            struct { 
               u32 ptc_rdma_idmc_count;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_RDMA_IDMC_COUNT_CSR, *PPTC_RDMA_IDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PTC_RDMA_IDMC_COUNT_CSR, sizeof (PTC_RDMA_IDMC_COUNT_CSR) == 4);

   #else
      typedef struct _PTC_RDMA_IDMC_COUNT_CSR {
         u32 ptc_rdma_idmc_count;                 // DWORD 0
      } SG_PACK PTC_RDMA_IDMC_COUNT_CSR, *PPTC_RDMA_IDMC_COUNT_CSR;

      typedef union _PTC_RDMA_IDMC_COUNT_CSR_UNION {
         PTC_RDMA_IDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_RDMA_IDMC_COUNT_CSR_UNION, *PPTC_RDMA_IDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_RDMA_IDMC_COUNT_CSR_UNION, sizeof (PTC_RDMA_IDMC_COUNT_CSR_UNION) == 4);
   #endif


#else
   // The counter machine states in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_RDMA_IDMC_COUNT_CSR {
         union {
            struct { 
               u32 ptc_rdma_idmc_count;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_RDMA_IDMC_COUNT_CSR, *PPTC_RDMA_IDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PTC_RDMA_IDMC_COUNT_CSR, sizeof (PTC_RDMA_IDMC_COUNT_CSR) == 4);

   #else
      typedef struct _PTC_RDMA_IDMC_COUNT_CSR {
         u32 ptc_rdma_idmc_count;                 // DWORD 0
      } SG_PACK PTC_RDMA_IDMC_COUNT_CSR, *PPTC_RDMA_IDMC_COUNT_CSR;

      typedef union _PTC_RDMA_IDMC_COUNT_CSR_UNION {
         PTC_RDMA_IDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_RDMA_IDMC_COUNT_CSR_UNION, *PPTC_RDMA_IDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_RDMA_IDMC_COUNT_CSR_UNION, sizeof (PTC_RDMA_IDMC_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The counter machine states in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_RDMA_CDMC_COUNT_CSR {
         union {
            struct { 
               u32 ptc_rdma_cdmc_count;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_RDMA_CDMC_COUNT_CSR, *PPTC_RDMA_CDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PTC_RDMA_CDMC_COUNT_CSR, sizeof (PTC_RDMA_CDMC_COUNT_CSR) == 4);

   #else
      typedef struct _PTC_RDMA_CDMC_COUNT_CSR {
         u32 ptc_rdma_cdmc_count;                 // DWORD 0
      } SG_PACK PTC_RDMA_CDMC_COUNT_CSR, *PPTC_RDMA_CDMC_COUNT_CSR;

      typedef union _PTC_RDMA_CDMC_COUNT_CSR_UNION {
         PTC_RDMA_CDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_RDMA_CDMC_COUNT_CSR_UNION, *PPTC_RDMA_CDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_RDMA_CDMC_COUNT_CSR_UNION, sizeof (PTC_RDMA_CDMC_COUNT_CSR_UNION) == 4);
   #endif


#else
   // The counter machine states in PTC
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_RDMA_CDMC_COUNT_CSR {
         union {
            struct { 
               u32 ptc_rdma_cdmc_count;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_RDMA_CDMC_COUNT_CSR, *PPTC_RDMA_CDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PTC_RDMA_CDMC_COUNT_CSR, sizeof (PTC_RDMA_CDMC_COUNT_CSR) == 4);

   #else
      typedef struct _PTC_RDMA_CDMC_COUNT_CSR {
         u32 ptc_rdma_cdmc_count;                 // DWORD 0
      } SG_PACK PTC_RDMA_CDMC_COUNT_CSR, *PPTC_RDMA_CDMC_COUNT_CSR;

      typedef union _PTC_RDMA_CDMC_COUNT_CSR_UNION {
         PTC_RDMA_CDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PTC_RDMA_CDMC_COUNT_CSR_UNION, *PPTC_RDMA_CDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PTC_RDMA_CDMC_COUNT_CSR_UNION, sizeof (PTC_RDMA_CDMC_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR0 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR0, *PPTC_CRA_REMAP_CSR0;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR0, sizeof (PTC_CRA_REMAP_CSR0) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR0 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR0, *PPTC_CRA_REMAP_CSR0;

      typedef union _PTC_CRA_REMAP_CSR0_UNION {
         PTC_CRA_REMAP_CSR0 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR0_UNION, *PPTC_CRA_REMAP_CSR0_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR0_UNION, sizeof (PTC_CRA_REMAP_CSR0_UNION) == 4);
   #endif


#else
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR0 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR0, *PPTC_CRA_REMAP_CSR0;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR0, sizeof (PTC_CRA_REMAP_CSR0) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR0 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR0, *PPTC_CRA_REMAP_CSR0;

      typedef union _PTC_CRA_REMAP_CSR0_UNION {
         PTC_CRA_REMAP_CSR0 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR0_UNION, *PPTC_CRA_REMAP_CSR0_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR0_UNION, sizeof (PTC_CRA_REMAP_CSR0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR1 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR1, *PPTC_CRA_REMAP_CSR1;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR1, sizeof (PTC_CRA_REMAP_CSR1) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR1 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR1, *PPTC_CRA_REMAP_CSR1;

      typedef union _PTC_CRA_REMAP_CSR1_UNION {
         PTC_CRA_REMAP_CSR1 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR1_UNION, *PPTC_CRA_REMAP_CSR1_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR1_UNION, sizeof (PTC_CRA_REMAP_CSR1_UNION) == 4);
   #endif


#else
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR1 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR1, *PPTC_CRA_REMAP_CSR1;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR1, sizeof (PTC_CRA_REMAP_CSR1) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR1 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR1, *PPTC_CRA_REMAP_CSR1;

      typedef union _PTC_CRA_REMAP_CSR1_UNION {
         PTC_CRA_REMAP_CSR1 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR1_UNION, *PPTC_CRA_REMAP_CSR1_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR1_UNION, sizeof (PTC_CRA_REMAP_CSR1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR2 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR2, *PPTC_CRA_REMAP_CSR2;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR2, sizeof (PTC_CRA_REMAP_CSR2) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR2 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR2, *PPTC_CRA_REMAP_CSR2;

      typedef union _PTC_CRA_REMAP_CSR2_UNION {
         PTC_CRA_REMAP_CSR2 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR2_UNION, *PPTC_CRA_REMAP_CSR2_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR2_UNION, sizeof (PTC_CRA_REMAP_CSR2_UNION) == 4);
   #endif


#else
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR2 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR2, *PPTC_CRA_REMAP_CSR2;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR2, sizeof (PTC_CRA_REMAP_CSR2) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR2 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR2, *PPTC_CRA_REMAP_CSR2;

      typedef union _PTC_CRA_REMAP_CSR2_UNION {
         PTC_CRA_REMAP_CSR2 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR2_UNION, *PPTC_CRA_REMAP_CSR2_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR2_UNION, sizeof (PTC_CRA_REMAP_CSR2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR3 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR3, *PPTC_CRA_REMAP_CSR3;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR3, sizeof (PTC_CRA_REMAP_CSR3) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR3 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR3, *PPTC_CRA_REMAP_CSR3;

      typedef union _PTC_CRA_REMAP_CSR3_UNION {
         PTC_CRA_REMAP_CSR3 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR3_UNION, *PPTC_CRA_REMAP_CSR3_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR3_UNION, sizeof (PTC_CRA_REMAP_CSR3_UNION) == 4);
   #endif


#else
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR3 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR3, *PPTC_CRA_REMAP_CSR3;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR3, sizeof (PTC_CRA_REMAP_CSR3) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR3 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR3, *PPTC_CRA_REMAP_CSR3;

      typedef union _PTC_CRA_REMAP_CSR3_UNION {
         PTC_CRA_REMAP_CSR3 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR3_UNION, *PPTC_CRA_REMAP_CSR3_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR3_UNION, sizeof (PTC_CRA_REMAP_CSR3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR4 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR4, *PPTC_CRA_REMAP_CSR4;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR4, sizeof (PTC_CRA_REMAP_CSR4) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR4 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR4, *PPTC_CRA_REMAP_CSR4;

      typedef union _PTC_CRA_REMAP_CSR4_UNION {
         PTC_CRA_REMAP_CSR4 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR4_UNION, *PPTC_CRA_REMAP_CSR4_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR4_UNION, sizeof (PTC_CRA_REMAP_CSR4_UNION) == 4);
   #endif


#else
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR4 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR4, *PPTC_CRA_REMAP_CSR4;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR4, sizeof (PTC_CRA_REMAP_CSR4) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR4 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR4, *PPTC_CRA_REMAP_CSR4;

      typedef union _PTC_CRA_REMAP_CSR4_UNION {
         PTC_CRA_REMAP_CSR4 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR4_UNION, *PPTC_CRA_REMAP_CSR4_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR4_UNION, sizeof (PTC_CRA_REMAP_CSR4_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR5 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR5, *PPTC_CRA_REMAP_CSR5;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR5, sizeof (PTC_CRA_REMAP_CSR5) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR5 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR5, *PPTC_CRA_REMAP_CSR5;

      typedef union _PTC_CRA_REMAP_CSR5_UNION {
         PTC_CRA_REMAP_CSR5 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR5_UNION, *PPTC_CRA_REMAP_CSR5_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR5_UNION, sizeof (PTC_CRA_REMAP_CSR5_UNION) == 4);
   #endif


#else
   // This register offers general controls of the UC subblock. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CRA_REMAP_CSR5 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PTC_CRA_REMAP_CSR5, *PPTC_CRA_REMAP_CSR5;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR5, sizeof (PTC_CRA_REMAP_CSR5) == 4);

   #else
      typedef struct _PTC_CRA_REMAP_CSR5 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK PTC_CRA_REMAP_CSR5, *PPTC_CRA_REMAP_CSR5;

      typedef union _PTC_CRA_REMAP_CSR5_UNION {
         PTC_CRA_REMAP_CSR5 bits;
         u32 dw; // dword union
      } SG_PACK PTC_CRA_REMAP_CSR5_UNION, *PPTC_CRA_REMAP_CSR5_UNION;

      SG_C_ASSERT(__sizeof__PTC_CRA_REMAP_CSR5_UNION, sizeof (PTC_CRA_REMAP_CSR5_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Provides control over and access to the Page Table Cache. Insertions and removals of
   // page tables used by the UT are done via these registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CSRMAP {
         union {
            struct { 
               PTC_CONTROL_CSR control;
               PTC_COMMAND_CSR command;
               PTC_CRA_CSR cra;
               PTC_PHYS_ADDR_LO read_pa_lo;
               PTC_PHYS_ADDR_HI read_pa_hi;
               PTC_DT_INDEX_CSR dt_index;
               PTC_PHYS_ADDR_LO dt_pa_lo;
               PTC_PHYS_ADDR_HI dt_pa_hi;
               PTC_STAT_INDEX_CSR stat_index;
               PTC_STAT_VALUE_CSR stat_value;
               PTC_STAT_RANGE_INDEX_CSR stat_range_index;
               PTC_STAT_RANGE_START_CSR stat_range_start;
               PTC_STAT_RANGE_END_CSR stat_range_end;
               PTC_CACHE_START_ADDR_CSR ptc_cache_start_addr;
               PTC_UE_SOURCE ue_source;
               PTC_UE_ENABLE ue_enable;
               PTC_TS_REQ_CSR ts_req;
               PTC_TS_RESP_CSR ts_resp;
               PTC_CRA_REMAP_CSR0 bit5_0;
               PTC_CRA_REMAP_CSR1 bit11_6;
               PTC_CRA_REMAP_CSR2 bit17_12;
               PTC_CRA_REMAP_CSR3 bit23_18;
               PTC_CRA_REMAP_CSR4 bit29_24;
               PTC_CRA_REMAP_CSR5 bit31_30;
               UC_TO_PTC_REQ_COUNT_CSR uc_req_count_csr;
               PTC_UC_RESP_COUNT_CSR uc_resp_count_csr;
               CEV_TO_PTC_REQ_COUNT_CSR cev_req_count_csr;
               PTC_CEV_RESP_COUNT_CSR cev_resp_count_csr;
               PTC_RDMA_IDMC_COUNT_CSR ptcrdma_idmc_count_csr;
               PTC_RDMA_CDMC_COUNT_CSR ptcrdma_cdmc_count_csr;
               PTC_WEIGHT_ARB_CSR ptc_weight0_1;
               PTC_WEIGHT_ARB_CSR ptc_weight2_3;
               HWDBG_CSRMAP hwdbg;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } cev_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } uc_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } rdma_pq;
               u32 rsvd0[202];                    // DWORDS 54 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK PTC_CSRMAP, *PPTC_CSRMAP;

      SG_C_ASSERT(__sizeof__PTC_CSRMAP, sizeof (PTC_CSRMAP) == 1024);

   #else
      typedef struct _PTC_CSRMAP {
         PTC_CONTROL_CSR control;
         PTC_COMMAND_CSR command;
         PTC_CRA_CSR cra;
         PTC_PHYS_ADDR_LO read_pa_lo;
         PTC_PHYS_ADDR_HI read_pa_hi;
         PTC_DT_INDEX_CSR dt_index;
         PTC_PHYS_ADDR_LO dt_pa_lo;
         PTC_PHYS_ADDR_HI dt_pa_hi;
         PTC_STAT_INDEX_CSR stat_index;
         PTC_STAT_VALUE_CSR stat_value;
         PTC_STAT_RANGE_INDEX_CSR stat_range_index;
         PTC_STAT_RANGE_START_CSR stat_range_start;
         PTC_STAT_RANGE_END_CSR stat_range_end;
         PTC_CACHE_START_ADDR_CSR ptc_cache_start_addr;
         PTC_UE_SOURCE ue_source;
         PTC_UE_ENABLE ue_enable;
         PTC_TS_REQ_CSR ts_req;
         PTC_TS_RESP_CSR ts_resp;
         PTC_CRA_REMAP_CSR0 bit5_0;
         PTC_CRA_REMAP_CSR1 bit11_6;
         PTC_CRA_REMAP_CSR2 bit17_12;
         PTC_CRA_REMAP_CSR3 bit23_18;
         PTC_CRA_REMAP_CSR4 bit29_24;
         PTC_CRA_REMAP_CSR5 bit31_30;
         UC_TO_PTC_REQ_COUNT_CSR uc_req_count_csr;
         PTC_UC_RESP_COUNT_CSR uc_resp_count_csr;
         CEV_TO_PTC_REQ_COUNT_CSR cev_req_count_csr;
         PTC_CEV_RESP_COUNT_CSR cev_resp_count_csr;
         PTC_RDMA_IDMC_COUNT_CSR ptcrdma_idmc_count_csr;
         PTC_RDMA_CDMC_COUNT_CSR ptcrdma_cdmc_count_csr;
         PTC_WEIGHT_ARB_CSR ptc_weight0_1;
         PTC_WEIGHT_ARB_CSR ptc_weight2_3;
         HWDBG_CSRMAP hwdbg;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } cev_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } uc_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } rdma_pq;
         u32 rsvd0[202];                          // DWORDS 54 to 255
      } SG_PACK PTC_CSRMAP, *PPTC_CSRMAP;

      typedef union _PTC_CSRMAP_UNION {
         PTC_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK PTC_CSRMAP_UNION, *PPTC_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PTC_CSRMAP_UNION, sizeof (PTC_CSRMAP_UNION) == 1024);
   #endif


#else
   // Provides control over and access to the Page Table Cache. Insertions and removals of
   // page tables used by the UT are done via these registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_CSRMAP {
         union {
            struct { 
               PTC_CONTROL_CSR control;
               PTC_COMMAND_CSR command;
               PTC_CRA_CSR cra;
               PTC_PHYS_ADDR_LO read_pa_lo;
               PTC_PHYS_ADDR_HI read_pa_hi;
               PTC_DT_INDEX_CSR dt_index;
               PTC_PHYS_ADDR_LO dt_pa_lo;
               PTC_PHYS_ADDR_HI dt_pa_hi;
               PTC_STAT_INDEX_CSR stat_index;
               PTC_STAT_VALUE_CSR stat_value;
               PTC_STAT_RANGE_INDEX_CSR stat_range_index;
               PTC_STAT_RANGE_START_CSR stat_range_start;
               PTC_STAT_RANGE_END_CSR stat_range_end;
               PTC_CACHE_START_ADDR_CSR ptc_cache_start_addr;
               PTC_UE_SOURCE ue_source;
               PTC_UE_ENABLE ue_enable;
               PTC_TS_REQ_CSR ts_req;
               PTC_TS_RESP_CSR ts_resp;
               PTC_CRA_REMAP_CSR0 bit5_0;
               PTC_CRA_REMAP_CSR1 bit11_6;
               PTC_CRA_REMAP_CSR2 bit17_12;
               PTC_CRA_REMAP_CSR3 bit23_18;
               PTC_CRA_REMAP_CSR4 bit29_24;
               PTC_CRA_REMAP_CSR5 bit31_30;
               UC_TO_PTC_REQ_COUNT_CSR uc_req_count_csr;
               PTC_UC_RESP_COUNT_CSR uc_resp_count_csr;
               CEV_TO_PTC_REQ_COUNT_CSR cev_req_count_csr;
               PTC_CEV_RESP_COUNT_CSR cev_resp_count_csr;
               PTC_RDMA_IDMC_COUNT_CSR ptcrdma_idmc_count_csr;
               PTC_RDMA_CDMC_COUNT_CSR ptcrdma_cdmc_count_csr;
               PTC_WEIGHT_ARB_CSR ptc_weight0_1;
               PTC_WEIGHT_ARB_CSR ptc_weight2_3;
               HWDBG_CSRMAP hwdbg;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } cev_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } uc_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } rdma_pq;
               u32 rsvd0[202];                    // DWORDS 54 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK PTC_CSRMAP, *PPTC_CSRMAP;

      SG_C_ASSERT(__sizeof__PTC_CSRMAP, sizeof (PTC_CSRMAP) == 1024);

   #else
      typedef struct _PTC_CSRMAP {
         PTC_CONTROL_CSR control;
         PTC_COMMAND_CSR command;
         PTC_CRA_CSR cra;
         PTC_PHYS_ADDR_LO read_pa_lo;
         PTC_PHYS_ADDR_HI read_pa_hi;
         PTC_DT_INDEX_CSR dt_index;
         PTC_PHYS_ADDR_LO dt_pa_lo;
         PTC_PHYS_ADDR_HI dt_pa_hi;
         PTC_STAT_INDEX_CSR stat_index;
         PTC_STAT_VALUE_CSR stat_value;
         PTC_STAT_RANGE_INDEX_CSR stat_range_index;
         PTC_STAT_RANGE_START_CSR stat_range_start;
         PTC_STAT_RANGE_END_CSR stat_range_end;
         PTC_CACHE_START_ADDR_CSR ptc_cache_start_addr;
         PTC_UE_SOURCE ue_source;
         PTC_UE_ENABLE ue_enable;
         PTC_TS_REQ_CSR ts_req;
         PTC_TS_RESP_CSR ts_resp;
         PTC_CRA_REMAP_CSR0 bit5_0;
         PTC_CRA_REMAP_CSR1 bit11_6;
         PTC_CRA_REMAP_CSR2 bit17_12;
         PTC_CRA_REMAP_CSR3 bit23_18;
         PTC_CRA_REMAP_CSR4 bit29_24;
         PTC_CRA_REMAP_CSR5 bit31_30;
         UC_TO_PTC_REQ_COUNT_CSR uc_req_count_csr;
         PTC_UC_RESP_COUNT_CSR uc_resp_count_csr;
         CEV_TO_PTC_REQ_COUNT_CSR cev_req_count_csr;
         PTC_CEV_RESP_COUNT_CSR cev_resp_count_csr;
         PTC_RDMA_IDMC_COUNT_CSR ptcrdma_idmc_count_csr;
         PTC_RDMA_CDMC_COUNT_CSR ptcrdma_cdmc_count_csr;
         PTC_WEIGHT_ARB_CSR ptc_weight0_1;
         PTC_WEIGHT_ARB_CSR ptc_weight2_3;
         HWDBG_CSRMAP hwdbg;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } cev_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } uc_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } rdma_pq;
         u32 rsvd0[202];                          // DWORDS 54 to 255
      } SG_PACK PTC_CSRMAP, *PPTC_CSRMAP;

      typedef union _PTC_CSRMAP_UNION {
         PTC_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK PTC_CSRMAP_UNION, *PPTC_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PTC_CSRMAP_UNION, sizeof (PTC_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ptc_bmap_h__

