/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __qpge_stat_bmap_h__
#define __qpge_stat_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_eth_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // This structure defines the format of the QPGE Eth statistics packet 
   typedef struct _BE_QPGE_PORT_STAT {
      u32 bytes_rcvd_lsd;
      u32 bytes_rcvd_msd;
      u32 rx_unknown_cntrl_frame_count;
      u32 rx_pause_frame_count;
      u32 rx_cntrl_frame_count;
      u32 rx_frame_length_err_count;
      u32 rx_frame_dropped_count;
      u32 rx_frame_crc_err_count;
      u32 rx_multicast_frame_count;
      u32 rx_broadcast_frame_count;
      u32 rx_small_frame_err_count;
      u32 rx_alignment_err_count;
      u32 rx_packets_rcvd;
      u32 rx_rsvd0;
      u32 bytes_txmit_lsd;
      u32 bytes_txmit_msd;
      u32 packets_transmitted;
      u32 tx_multicast_frame_count;
      u32 tx_broadcast_frame_count;
      u32 tx_pause_frame_count;
      u32 tx_cntrl_frame_count;
      u32 tx_jumbo_frame_count;
   } SG_PACK BE_QPGE_PORT_STAT, *PBE_QPGE_PORT_STAT;



#else
   // This structure defines the format of the QPGE Eth statistics packet 
   typedef struct _BE_QPGE_PORT_STAT {
      u32 bytes_rcvd_lsd;
      u32 bytes_rcvd_msd;
      u32 rx_unknown_cntrl_frame_count;
      u32 rx_pause_frame_count;
      u32 rx_cntrl_frame_count;
      u32 rx_frame_length_err_count;
      u32 rx_frame_dropped_count;
      u32 rx_frame_crc_err_count;
      u32 rx_multicast_frame_count;
      u32 rx_broadcast_frame_count;
      u32 rx_small_frame_err_count;
      u32 rx_alignment_err_count;
      u32 rx_packets_rcvd;
      u32 rx_rsvd0;
      u32 bytes_txmit_lsd;
      u32 bytes_txmit_msd;
      u32 packets_transmitted;
      u32 tx_multicast_frame_count;
      u32 tx_broadcast_frame_count;
      u32 tx_pause_frame_count;
      u32 tx_cntrl_frame_count;
      u32 tx_jumbo_frame_count;
   } SG_PACK BE_QPGE_PORT_STAT, *PBE_QPGE_PORT_STAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure defines the format of the QPGE Eth statistics packet 
   typedef struct _BE_QPGE_STAT {
      u64 stat_hdr_0;
      u64 stat_hdr_1;
      u64 stat_hdr_2;
      u64 stat_hdr_3;
      u64 stat_hdr_4;
      u64 stat_hdr_5;
      u64 stat_hdr_6;
      u64 stat_hdr_7;
      u64 stat_hdr_8;
      u64 stat_hdr_rsvd0;
      u64 stat_hdr_rsvd1;
      BE_QPGE_PORT_STAT port[4];
   } SG_PACK BE_QPGE_STAT, *PBE_QPGE_STAT;



#else
   // This structure defines the format of the QPGE Eth statistics packet 
   typedef struct _BE_QPGE_STAT {
      u64 stat_hdr_0;
      u64 stat_hdr_1;
      u64 stat_hdr_2;
      u64 stat_hdr_3;
      u64 stat_hdr_4;
      u64 stat_hdr_5;
      u64 stat_hdr_6;
      u64 stat_hdr_7;
      u64 stat_hdr_8;
      u64 stat_hdr_rsvd0;
      u64 stat_hdr_rsvd1;
      BE_QPGE_PORT_STAT port[4];
   } SG_PACK BE_QPGE_STAT, *PBE_QPGE_STAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_ETH_STATISTICS_QPGE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS_IN, *PMIB_ETH_STATISTICS_QPGE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_QPGE_PARAMS_IN, sizeof (MIB_ETH_STATISTICS_QPGE_PARAMS_IN) == 4);

   #else
      typedef struct _MIB_ETH_STATISTICS_QPGE_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS_IN, *PMIB_ETH_STATISTICS_QPGE_PARAMS_IN;

      typedef union _MIB_ETH_STATISTICS_QPGE_PARAMS_IN_UNION {
         MIB_ETH_STATISTICS_QPGE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS_IN_UNION, *PMIB_ETH_STATISTICS_QPGE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_QPGE_PARAMS_IN_UNION, sizeof (MIB_ETH_STATISTICS_QPGE_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_ETH_STATISTICS_QPGE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS_IN, *PMIB_ETH_STATISTICS_QPGE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_QPGE_PARAMS_IN, sizeof (MIB_ETH_STATISTICS_QPGE_PARAMS_IN) == 4);

   #else
      typedef struct _MIB_ETH_STATISTICS_QPGE_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS_IN, *PMIB_ETH_STATISTICS_QPGE_PARAMS_IN;

      typedef union _MIB_ETH_STATISTICS_QPGE_PARAMS_IN_UNION {
         MIB_ETH_STATISTICS_QPGE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS_IN_UNION, *PMIB_ETH_STATISTICS_QPGE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_QPGE_PARAMS_IN_UNION, sizeof (MIB_ETH_STATISTICS_QPGE_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_QPGE_HARDWARE_STATS {
         union {
            struct { 
               BE_QPGE_STAT qpge_stat;
               BE2_TXP_SW_COUNTERS txp;
               BE2_ERX_STATS erx;
               BE2_PMEM_STATS pmem;
            } SG_PACK ; // unnamed struct
            u32 dw[212]; // dword union
         }; // unnamed union
      } SG_PACK BE2_QPGE_HARDWARE_STATS, *PBE2_QPGE_HARDWARE_STATS;

      SG_C_ASSERT(__sizeof__BE2_QPGE_HARDWARE_STATS, sizeof (BE2_QPGE_HARDWARE_STATS) == 848);

   #else
      typedef struct _BE2_QPGE_HARDWARE_STATS {
         BE_QPGE_STAT qpge_stat;
         BE2_TXP_SW_COUNTERS txp;
         BE2_ERX_STATS erx;
         BE2_PMEM_STATS pmem;
      } SG_PACK BE2_QPGE_HARDWARE_STATS, *PBE2_QPGE_HARDWARE_STATS;

      typedef union _BE2_QPGE_HARDWARE_STATS_UNION {
         BE2_QPGE_HARDWARE_STATS bits;
         u32 dw[212]; // dword union
      } SG_PACK BE2_QPGE_HARDWARE_STATS_UNION, *PBE2_QPGE_HARDWARE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_QPGE_HARDWARE_STATS_UNION, sizeof (BE2_QPGE_HARDWARE_STATS_UNION) == 848);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_QPGE_HARDWARE_STATS {
         union {
            struct { 
               BE_QPGE_STAT qpge_stat;
               BE2_TXP_SW_COUNTERS txp;
               BE2_ERX_STATS erx;
               BE2_PMEM_STATS pmem;
            } SG_PACK ; // unnamed struct
            u32 dw[212]; // dword union
         }; // unnamed union
      } SG_PACK BE2_QPGE_HARDWARE_STATS, *PBE2_QPGE_HARDWARE_STATS;

      SG_C_ASSERT(__sizeof__BE2_QPGE_HARDWARE_STATS, sizeof (BE2_QPGE_HARDWARE_STATS) == 848);

   #else
      typedef struct _BE2_QPGE_HARDWARE_STATS {
         BE_QPGE_STAT qpge_stat;
         BE2_TXP_SW_COUNTERS txp;
         BE2_ERX_STATS erx;
         BE2_PMEM_STATS pmem;
      } SG_PACK BE2_QPGE_HARDWARE_STATS, *PBE2_QPGE_HARDWARE_STATS;

      typedef union _BE2_QPGE_HARDWARE_STATS_UNION {
         BE2_QPGE_HARDWARE_STATS bits;
         u32 dw[212]; // dword union
      } SG_PACK BE2_QPGE_HARDWARE_STATS_UNION, *PBE2_QPGE_HARDWARE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_QPGE_HARDWARE_STATS_UNION, sizeof (BE2_QPGE_HARDWARE_STATS_UNION) == 848);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_ETH_STATISTICS_QPGE_PARAMS {
         union {
            union { 
               MIB_ETH_STATISTICS_QPGE_PARAMS_IN request;
               BE2_QPGE_HARDWARE_STATS response;
            } SG_PACK ; // unnamed struct
            u32 dw[212]; // dword union
         }; // unnamed union
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS, *PMIB_ETH_STATISTICS_QPGE_PARAMS;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_QPGE_PARAMS, sizeof (MIB_ETH_STATISTICS_QPGE_PARAMS) == 848);

   #else
      typedef union _MIB_ETH_STATISTICS_QPGE_PARAMS {
         MIB_ETH_STATISTICS_QPGE_PARAMS_IN request;
         BE2_QPGE_HARDWARE_STATS response;
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS, *PMIB_ETH_STATISTICS_QPGE_PARAMS;

      typedef union _MIB_ETH_STATISTICS_QPGE_PARAMS_UNION {
         MIB_ETH_STATISTICS_QPGE_PARAMS bits;
         u32 dw[212]; // dword union
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS_UNION, *PMIB_ETH_STATISTICS_QPGE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_QPGE_PARAMS_UNION, sizeof (MIB_ETH_STATISTICS_QPGE_PARAMS_UNION) == 848);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_ETH_STATISTICS_QPGE_PARAMS {
         union {
            union { 
               MIB_ETH_STATISTICS_QPGE_PARAMS_IN request;
               BE2_QPGE_HARDWARE_STATS response;
            } SG_PACK ; // unnamed struct
            u32 dw[212]; // dword union
         }; // unnamed union
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS, *PMIB_ETH_STATISTICS_QPGE_PARAMS;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_QPGE_PARAMS, sizeof (MIB_ETH_STATISTICS_QPGE_PARAMS) == 848);

   #else
      typedef union _MIB_ETH_STATISTICS_QPGE_PARAMS {
         MIB_ETH_STATISTICS_QPGE_PARAMS_IN request;
         BE2_QPGE_HARDWARE_STATS response;
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS, *PMIB_ETH_STATISTICS_QPGE_PARAMS;

      typedef union _MIB_ETH_STATISTICS_QPGE_PARAMS_UNION {
         MIB_ETH_STATISTICS_QPGE_PARAMS bits;
         u32 dw[212]; // dword union
      } SG_PACK MIB_ETH_STATISTICS_QPGE_PARAMS_UNION, *PMIB_ETH_STATISTICS_QPGE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__MIB_ETH_STATISTICS_QPGE_PARAMS_UNION, sizeof (MIB_ETH_STATISTICS_QPGE_PARAMS_UNION) == 848);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Query ethernet statistics. All domains may issue this IOCTL. The host domain drivers
   // may optionally reset internal statistic counters with a query. 
   typedef struct _IOCTL_ETH_GET_QPGE_STATISTICS {
      IOCTL_HEADER header;
      MIB_ETH_STATISTICS_QPGE_PARAMS params;
   } SG_PACK IOCTL_ETH_GET_QPGE_STATISTICS, *PIOCTL_ETH_GET_QPGE_STATISTICS;



#else
   // Query ethernet statistics. All domains may issue this IOCTL. The host domain drivers
   // may optionally reset internal statistic counters with a query. 
   typedef struct _IOCTL_ETH_GET_QPGE_STATISTICS {
      IOCTL_HEADER header;
      MIB_ETH_STATISTICS_QPGE_PARAMS params;
   } SG_PACK IOCTL_ETH_GET_QPGE_STATISTICS, *PIOCTL_ETH_GET_QPGE_STATISTICS;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __qpge_stat_bmap_h__

