/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __rdma_bmap_h__
#define __rdma_bmap_h__
#include "setypes.h"
#include "pq_bmap.h"
#include "hwdbg_reg_bmap.h"
#include "reg_enums_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Weighted Arbitration Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_WRR_ENTRY_CSR {
         union {
            struct { 
               u32 rsvd3 : 2;                     // DWORD 0
               u32 mpu_wt : 6;                    // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 ptc_wt : 6;                    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 uc_wt : 6;                     // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 erx_wt : 6;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_WRR_ENTRY_CSR, *PRDMA_WRR_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__RDMA_WRR_ENTRY_CSR, sizeof (RDMA_WRR_ENTRY_CSR) == 4);

   #else
      typedef struct _RDMA_WRR_ENTRY_CSR {
         u32 rsvd3 : 2;                           // DWORD 0
         u32 mpu_wt : 6;                          // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 ptc_wt : 6;                          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 uc_wt : 6;                           // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 erx_wt : 6;                          // DWORD 0
      } SG_PACK RDMA_WRR_ENTRY_CSR, *PRDMA_WRR_ENTRY_CSR;

      typedef union _RDMA_WRR_ENTRY_CSR_UNION {
         RDMA_WRR_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_WRR_ENTRY_CSR_UNION, *PRDMA_WRR_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_WRR_ENTRY_CSR_UNION, sizeof (RDMA_WRR_ENTRY_CSR_UNION) == 4);
   #endif


#else
   // Weighted Arbitration Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_WRR_ENTRY_CSR {
         union {
            struct { 
               u32 erx_wt : 6;                    // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 uc_wt : 6;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 ptc_wt : 6;                    // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 mpu_wt : 6;                    // DWORD 0
               u32 rsvd3 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_WRR_ENTRY_CSR, *PRDMA_WRR_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__RDMA_WRR_ENTRY_CSR, sizeof (RDMA_WRR_ENTRY_CSR) == 4);

   #else
      typedef struct _RDMA_WRR_ENTRY_CSR {
         u32 erx_wt : 6;                          // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 uc_wt : 6;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 ptc_wt : 6;                          // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 mpu_wt : 6;                          // DWORD 0
         u32 rsvd3 : 2;                           // DWORD 0
      } SG_PACK RDMA_WRR_ENTRY_CSR, *PRDMA_WRR_ENTRY_CSR;

      typedef union _RDMA_WRR_ENTRY_CSR_UNION {
         RDMA_WRR_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_WRR_ENTRY_CSR_UNION, *PRDMA_WRR_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_WRR_ENTRY_CSR_UNION, sizeof (RDMA_WRR_ENTRY_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_CTRL_CSR {
         union {
            struct { 
               u32 rsvd0 : 25;                    // DWORD 0
               u32 stall_on_error : 1;            // DWORD 0
               u32 auto_inc : 1;                  // DWORD 0
               u32 dbug_sel : 5;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_CTRL_CSR, *PRDMA_CTRL_CSR;

      SG_C_ASSERT(__sizeof__RDMA_CTRL_CSR, sizeof (RDMA_CTRL_CSR) == 4);

   #else
      typedef struct _RDMA_CTRL_CSR {
         u32 rsvd0 : 25;                          // DWORD 0
         u32 stall_on_error : 1;                  // DWORD 0
         u32 auto_inc : 1;                        // DWORD 0
         u32 dbug_sel : 5;                        // DWORD 0
      } SG_PACK RDMA_CTRL_CSR, *PRDMA_CTRL_CSR;

      typedef union _RDMA_CTRL_CSR_UNION {
         RDMA_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_CTRL_CSR_UNION, *PRDMA_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_CTRL_CSR_UNION, sizeof (RDMA_CTRL_CSR_UNION) == 4);
   #endif


#else
   // Debug Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_CTRL_CSR {
         union {
            struct { 
               u32 dbug_sel : 5;                  // DWORD 0
               u32 auto_inc : 1;                  // DWORD 0
               u32 stall_on_error : 1;            // DWORD 0
               u32 rsvd0 : 25;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_CTRL_CSR, *PRDMA_CTRL_CSR;

      SG_C_ASSERT(__sizeof__RDMA_CTRL_CSR, sizeof (RDMA_CTRL_CSR) == 4);

   #else
      typedef struct _RDMA_CTRL_CSR {
         u32 dbug_sel : 5;                        // DWORD 0
         u32 auto_inc : 1;                        // DWORD 0
         u32 stall_on_error : 1;                  // DWORD 0
         u32 rsvd0 : 25;                          // DWORD 0
      } SG_PACK RDMA_CTRL_CSR, *PRDMA_CTRL_CSR;

      typedef union _RDMA_CTRL_CSR_UNION {
         RDMA_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_CTRL_CSR_UNION, *PRDMA_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_CTRL_CSR_UNION, sizeof (RDMA_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RDMA Debug Status Register. This CSR is a read-only mux of multiple internal status
   // registers
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_STS_CSR {
         union {
            struct { 
               u32 status;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_STS_CSR, *PRDMA_STS_CSR;

      SG_C_ASSERT(__sizeof__RDMA_STS_CSR, sizeof (RDMA_STS_CSR) == 4);

   #else
      typedef struct _RDMA_STS_CSR {
         u32 status;                              // DWORD 0
      } SG_PACK RDMA_STS_CSR, *PRDMA_STS_CSR;

      typedef union _RDMA_STS_CSR_UNION {
         RDMA_STS_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_STS_CSR_UNION, *PRDMA_STS_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_STS_CSR_UNION, sizeof (RDMA_STS_CSR_UNION) == 4);
   #endif


#else
   // RDMA Debug Status Register. This CSR is a read-only mux of multiple internal status
   // registers
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_STS_CSR {
         union {
            struct { 
               u32 status;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_STS_CSR, *PRDMA_STS_CSR;

      SG_C_ASSERT(__sizeof__RDMA_STS_CSR, sizeof (RDMA_STS_CSR) == 4);

   #else
      typedef struct _RDMA_STS_CSR {
         u32 status;                              // DWORD 0
      } SG_PACK RDMA_STS_CSR, *PRDMA_STS_CSR;

      typedef union _RDMA_STS_CSR_UNION {
         RDMA_STS_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_STS_CSR_UNION, *PRDMA_STS_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_STS_CSR_UNION, sizeof (RDMA_STS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RDMA Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_UE_SOURCE_CSR {
         union {
            struct { 
               u32 rsvd0 : 29;                    // DWORD 0
               u32 sram_access_during_init : 1;   // DWORD 0
               u32 rdma_host_ue_source : 1;       // DWORD 0
               u32 rdma_parity_ue_source : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_UE_SOURCE_CSR, *PRDMA_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__RDMA_UE_SOURCE_CSR, sizeof (RDMA_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _RDMA_UE_SOURCE_CSR {
         u32 rsvd0 : 29;                          // DWORD 0
         u32 sram_access_during_init : 1;         // DWORD 0
         u32 rdma_host_ue_source : 1;             // DWORD 0
         u32 rdma_parity_ue_source : 1;           // DWORD 0
      } SG_PACK RDMA_UE_SOURCE_CSR, *PRDMA_UE_SOURCE_CSR;

      typedef union _RDMA_UE_SOURCE_CSR_UNION {
         RDMA_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_UE_SOURCE_CSR_UNION, *PRDMA_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_UE_SOURCE_CSR_UNION, sizeof (RDMA_UE_SOURCE_CSR_UNION) == 4);
   #endif


#else
   // RDMA Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_UE_SOURCE_CSR {
         union {
            struct { 
               u32 rdma_parity_ue_source : 1;     // DWORD 0
               u32 rdma_host_ue_source : 1;       // DWORD 0
               u32 sram_access_during_init : 1;   // DWORD 0
               u32 rsvd0 : 29;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_UE_SOURCE_CSR, *PRDMA_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__RDMA_UE_SOURCE_CSR, sizeof (RDMA_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _RDMA_UE_SOURCE_CSR {
         u32 rdma_parity_ue_source : 1;           // DWORD 0
         u32 rdma_host_ue_source : 1;             // DWORD 0
         u32 sram_access_during_init : 1;         // DWORD 0
         u32 rsvd0 : 29;                          // DWORD 0
      } SG_PACK RDMA_UE_SOURCE_CSR, *PRDMA_UE_SOURCE_CSR;

      typedef union _RDMA_UE_SOURCE_CSR_UNION {
         RDMA_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_UE_SOURCE_CSR_UNION, *PRDMA_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_UE_SOURCE_CSR_UNION, sizeof (RDMA_UE_SOURCE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RDMA Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_UE_ENABLE_CSR {
         union {
            struct { 
               u32 rsvd0 : 29;                    // DWORD 0
               u32 sram_access_during_init_en : 1; // DWORD 0
               u32 rdma_host_ue_enable : 1;       // DWORD 0
               u32 rdma_parity_ue_enable : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_UE_ENABLE_CSR, *PRDMA_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__RDMA_UE_ENABLE_CSR, sizeof (RDMA_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _RDMA_UE_ENABLE_CSR {
         u32 rsvd0 : 29;                          // DWORD 0
         u32 sram_access_during_init_en : 1;      // DWORD 0
         u32 rdma_host_ue_enable : 1;             // DWORD 0
         u32 rdma_parity_ue_enable : 1;           // DWORD 0
      } SG_PACK RDMA_UE_ENABLE_CSR, *PRDMA_UE_ENABLE_CSR;

      typedef union _RDMA_UE_ENABLE_CSR_UNION {
         RDMA_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_UE_ENABLE_CSR_UNION, *PRDMA_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_UE_ENABLE_CSR_UNION, sizeof (RDMA_UE_ENABLE_CSR_UNION) == 4);
   #endif


#else
   // RDMA Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_UE_ENABLE_CSR {
         union {
            struct { 
               u32 rdma_parity_ue_enable : 1;     // DWORD 0
               u32 rdma_host_ue_enable : 1;       // DWORD 0
               u32 sram_access_during_init_en : 1; // DWORD 0
               u32 rsvd0 : 29;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_UE_ENABLE_CSR, *PRDMA_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__RDMA_UE_ENABLE_CSR, sizeof (RDMA_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _RDMA_UE_ENABLE_CSR {
         u32 rdma_parity_ue_enable : 1;           // DWORD 0
         u32 rdma_host_ue_enable : 1;             // DWORD 0
         u32 sram_access_during_init_en : 1;      // DWORD 0
         u32 rsvd0 : 29;                          // DWORD 0
      } SG_PACK RDMA_UE_ENABLE_CSR, *PRDMA_UE_ENABLE_CSR;

      typedef union _RDMA_UE_ENABLE_CSR_UNION {
         RDMA_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_UE_ENABLE_CSR_UNION, *PRDMA_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_UE_ENABLE_CSR_UNION, sizeof (RDMA_UE_ENABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // UC Release Request Vector Register. When a client has RDMA issue a Release request
   // to UC at the end of a data transfer, the control DWORD portion of the UC_REQ_D
   // descriptor sent to UC is given by the content of this CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_UC_RELEASE_CSR {
         union {
            struct { 
               u32 rsvd0 : 17;                    // DWORD 0
               u32 pci_func : 1;                  // DWORD 0
               u32 cqe : 1;                       // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 req_opcode : 3;                // DWORD 0
               u32 drop : 1;                      // DWORD 0
               u32 req_type : 1;                  // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 p : 1;                         // DWORD 0
               u32 i : 1;                         // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_UC_RELEASE_CSR, *PRDMA_UC_RELEASE_CSR;

      SG_C_ASSERT(__sizeof__RDMA_UC_RELEASE_CSR, sizeof (RDMA_UC_RELEASE_CSR) == 4);

   #else
      typedef struct _RDMA_UC_RELEASE_CSR {
         u32 rsvd0 : 17;                          // DWORD 0
         u32 pci_func : 1;                        // DWORD 0
         u32 cqe : 1;                             // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 req_opcode : 3;                      // DWORD 0
         u32 drop : 1;                            // DWORD 0
         u32 req_type : 1;                        // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 p : 1;                               // DWORD 0
         u32 i : 1;                               // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
      } SG_PACK RDMA_UC_RELEASE_CSR, *PRDMA_UC_RELEASE_CSR;

      typedef union _RDMA_UC_RELEASE_CSR_UNION {
         RDMA_UC_RELEASE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_UC_RELEASE_CSR_UNION, *PRDMA_UC_RELEASE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_UC_RELEASE_CSR_UNION, sizeof (RDMA_UC_RELEASE_CSR_UNION) == 4);
   #endif


#else
   // UC Release Request Vector Register. When a client has RDMA issue a Release request
   // to UC at the end of a data transfer, the control DWORD portion of the UC_REQ_D
   // descriptor sent to UC is given by the content of this CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_UC_RELEASE_CSR {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 i : 1;                         // DWORD 0
               u32 p : 1;                         // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 req_type : 1;                  // DWORD 0
               u32 drop : 1;                      // DWORD 0
               u32 req_opcode : 3;                // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 cqe : 1;                       // DWORD 0
               u32 pci_func : 1;                  // DWORD 0
               u32 rsvd0 : 17;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_UC_RELEASE_CSR, *PRDMA_UC_RELEASE_CSR;

      SG_C_ASSERT(__sizeof__RDMA_UC_RELEASE_CSR, sizeof (RDMA_UC_RELEASE_CSR) == 4);

   #else
      typedef struct _RDMA_UC_RELEASE_CSR {
         u32 stall : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 i : 1;                               // DWORD 0
         u32 p : 1;                               // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 req_type : 1;                        // DWORD 0
         u32 drop : 1;                            // DWORD 0
         u32 req_opcode : 3;                      // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 cqe : 1;                             // DWORD 0
         u32 pci_func : 1;                        // DWORD 0
         u32 rsvd0 : 17;                          // DWORD 0
      } SG_PACK RDMA_UC_RELEASE_CSR, *PRDMA_UC_RELEASE_CSR;

      typedef union _RDMA_UC_RELEASE_CSR_UNION {
         RDMA_UC_RELEASE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_UC_RELEASE_CSR_UNION, *PRDMA_UC_RELEASE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_UC_RELEASE_CSR_UNION, sizeof (RDMA_UC_RELEASE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Zero Length (Dummy Read) Host Memory Address (Lower 32 Bits) Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_ZERODMA_HOST_ADDLSB_CSR {
         union {
            struct { 
               u32 host_lsb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_ZERODMA_HOST_ADDLSB_CSR, *PRDMA_ZERODMA_HOST_ADDLSB_CSR;

      SG_C_ASSERT(__sizeof__RDMA_ZERODMA_HOST_ADDLSB_CSR, sizeof (RDMA_ZERODMA_HOST_ADDLSB_CSR) == 4);

   #else
      typedef struct _RDMA_ZERODMA_HOST_ADDLSB_CSR {
         u32 host_lsb;                            // DWORD 0
      } SG_PACK RDMA_ZERODMA_HOST_ADDLSB_CSR, *PRDMA_ZERODMA_HOST_ADDLSB_CSR;

      typedef union _RDMA_ZERODMA_HOST_ADDLSB_CSR_UNION {
         RDMA_ZERODMA_HOST_ADDLSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, *PRDMA_ZERODMA_HOST_ADDLSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, sizeof (RDMA_ZERODMA_HOST_ADDLSB_CSR_UNION) == 4);
   #endif


#else
   // Zero Length (Dummy Read) Host Memory Address (Lower 32 Bits) Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_ZERODMA_HOST_ADDLSB_CSR {
         union {
            struct { 
               u32 host_lsb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_ZERODMA_HOST_ADDLSB_CSR, *PRDMA_ZERODMA_HOST_ADDLSB_CSR;

      SG_C_ASSERT(__sizeof__RDMA_ZERODMA_HOST_ADDLSB_CSR, sizeof (RDMA_ZERODMA_HOST_ADDLSB_CSR) == 4);

   #else
      typedef struct _RDMA_ZERODMA_HOST_ADDLSB_CSR {
         u32 host_lsb;                            // DWORD 0
      } SG_PACK RDMA_ZERODMA_HOST_ADDLSB_CSR, *PRDMA_ZERODMA_HOST_ADDLSB_CSR;

      typedef union _RDMA_ZERODMA_HOST_ADDLSB_CSR_UNION {
         RDMA_ZERODMA_HOST_ADDLSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, *PRDMA_ZERODMA_HOST_ADDLSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, sizeof (RDMA_ZERODMA_HOST_ADDLSB_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Zero Length (Dummy Read) Host Memory Address (Upper 32 Bits) Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_ZERODMA_HOST_ADDMSB_CSR {
         union {
            struct { 
               u32 host_msb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_ZERODMA_HOST_ADDMSB_CSR, *PRDMA_ZERODMA_HOST_ADDMSB_CSR;

      SG_C_ASSERT(__sizeof__RDMA_ZERODMA_HOST_ADDMSB_CSR, sizeof (RDMA_ZERODMA_HOST_ADDMSB_CSR) == 4);

   #else
      typedef struct _RDMA_ZERODMA_HOST_ADDMSB_CSR {
         u32 host_msb;                            // DWORD 0
      } SG_PACK RDMA_ZERODMA_HOST_ADDMSB_CSR, *PRDMA_ZERODMA_HOST_ADDMSB_CSR;

      typedef union _RDMA_ZERODMA_HOST_ADDMSB_CSR_UNION {
         RDMA_ZERODMA_HOST_ADDMSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, *PRDMA_ZERODMA_HOST_ADDMSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, sizeof (RDMA_ZERODMA_HOST_ADDMSB_CSR_UNION) == 4);
   #endif


#else
   // Zero Length (Dummy Read) Host Memory Address (Upper 32 Bits) Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_ZERODMA_HOST_ADDMSB_CSR {
         union {
            struct { 
               u32 host_msb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_ZERODMA_HOST_ADDMSB_CSR, *PRDMA_ZERODMA_HOST_ADDMSB_CSR;

      SG_C_ASSERT(__sizeof__RDMA_ZERODMA_HOST_ADDMSB_CSR, sizeof (RDMA_ZERODMA_HOST_ADDMSB_CSR) == 4);

   #else
      typedef struct _RDMA_ZERODMA_HOST_ADDMSB_CSR {
         u32 host_msb;                            // DWORD 0
      } SG_PACK RDMA_ZERODMA_HOST_ADDMSB_CSR, *PRDMA_ZERODMA_HOST_ADDMSB_CSR;

      typedef union _RDMA_ZERODMA_HOST_ADDMSB_CSR_UNION {
         RDMA_ZERODMA_HOST_ADDMSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK RDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, *PRDMA_ZERODMA_HOST_ADDMSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__RDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, sizeof (RDMA_ZERODMA_HOST_ADDMSB_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Local DDR Interface Control Register. Note that this register controls steering of
   // data transfers to/from local DDR memory for all three DMA engines (RDMA, NDMA,
   // WDMA).
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_CONTROL_CSR {
         union {
            struct { 
               u32 thx1138cya : 8;                // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 quiesce_ddr : 1;               // DWORD 0
               u32 ndma_slowdown : 1;             // DWORD 0
               u32 rdma_slowdown : 1;             // DWORD 0
               u32 limit_ndmaburst : 1;           // DWORD 0
               u32 limit_rdmaburst : 1;           // DWORD 0
               u32 disable_ndmaburst : 1;         // DWORD 0
               u32 disable_rdmaburst : 1;         // DWORD 0
               u32 dbg_regsel : 4;                // DWORD 0
               u32 override_wdmaburst : 1;        // DWORD 0
               u32 maxburst2 : 1;                 // DWORD 0
               u32 override_1k_burststop : 1;     // DWORD 0
               u32 override_lock : 1;             // DWORD 0
               u32 swap : 2;                      // DWORD 0
               u32 clear : 1;                     // DWORD 0
               u32 disable : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_CONTROL_CSR, *PDDR_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__DDR_CONTROL_CSR, sizeof (DDR_CONTROL_CSR) == 4);

   #else
      typedef struct _DDR_CONTROL_CSR {
         u32 thx1138cya : 8;                      // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 quiesce_ddr : 1;                     // DWORD 0
         u32 ndma_slowdown : 1;                   // DWORD 0
         u32 rdma_slowdown : 1;                   // DWORD 0
         u32 limit_ndmaburst : 1;                 // DWORD 0
         u32 limit_rdmaburst : 1;                 // DWORD 0
         u32 disable_ndmaburst : 1;               // DWORD 0
         u32 disable_rdmaburst : 1;               // DWORD 0
         u32 dbg_regsel : 4;                      // DWORD 0
         u32 override_wdmaburst : 1;              // DWORD 0
         u32 maxburst2 : 1;                       // DWORD 0
         u32 override_1k_burststop : 1;           // DWORD 0
         u32 override_lock : 1;                   // DWORD 0
         u32 swap : 2;                            // DWORD 0
         u32 clear : 1;                           // DWORD 0
         u32 disable : 1;                         // DWORD 0
      } SG_PACK DDR_CONTROL_CSR, *PDDR_CONTROL_CSR;

      typedef union _DDR_CONTROL_CSR_UNION {
         DDR_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_CONTROL_CSR_UNION, *PDDR_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_CONTROL_CSR_UNION, sizeof (DDR_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // Local DDR Interface Control Register. Note that this register controls steering of
   // data transfers to/from local DDR memory for all three DMA engines (RDMA, NDMA,
   // WDMA).
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_CONTROL_CSR {
         union {
            struct { 
               u32 disable : 1;                   // DWORD 0
               u32 clear : 1;                     // DWORD 0
               u32 swap : 2;                      // DWORD 0
               u32 override_lock : 1;             // DWORD 0
               u32 override_1k_burststop : 1;     // DWORD 0
               u32 maxburst2 : 1;                 // DWORD 0
               u32 override_wdmaburst : 1;        // DWORD 0
               u32 dbg_regsel : 4;                // DWORD 0
               u32 disable_rdmaburst : 1;         // DWORD 0
               u32 disable_ndmaburst : 1;         // DWORD 0
               u32 limit_rdmaburst : 1;           // DWORD 0
               u32 limit_ndmaburst : 1;           // DWORD 0
               u32 rdma_slowdown : 1;             // DWORD 0
               u32 ndma_slowdown : 1;             // DWORD 0
               u32 quiesce_ddr : 1;               // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 thx1138cya : 8;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_CONTROL_CSR, *PDDR_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__DDR_CONTROL_CSR, sizeof (DDR_CONTROL_CSR) == 4);

   #else
      typedef struct _DDR_CONTROL_CSR {
         u32 disable : 1;                         // DWORD 0
         u32 clear : 1;                           // DWORD 0
         u32 swap : 2;                            // DWORD 0
         u32 override_lock : 1;                   // DWORD 0
         u32 override_1k_burststop : 1;           // DWORD 0
         u32 maxburst2 : 1;                       // DWORD 0
         u32 override_wdmaburst : 1;              // DWORD 0
         u32 dbg_regsel : 4;                      // DWORD 0
         u32 disable_rdmaburst : 1;               // DWORD 0
         u32 disable_ndmaburst : 1;               // DWORD 0
         u32 limit_rdmaburst : 1;                 // DWORD 0
         u32 limit_ndmaburst : 1;                 // DWORD 0
         u32 rdma_slowdown : 1;                   // DWORD 0
         u32 ndma_slowdown : 1;                   // DWORD 0
         u32 quiesce_ddr : 1;                     // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 thx1138cya : 8;                      // DWORD 0
      } SG_PACK DDR_CONTROL_CSR, *PDDR_CONTROL_CSR;

      typedef union _DDR_CONTROL_CSR_UNION {
         DDR_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_CONTROL_CSR_UNION, *PDDR_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_CONTROL_CSR_UNION, sizeof (DDR_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Local DDR Address Range Start Low Register. Indicates the lower 32 bits of the start
   // of the rangeof off-chip system addresses that are to be mapped to the local DDR
   // interface. Anything equal or greater than this CSR value are local DDR addresses.
   // Only relevant when disable bit in DDR_CONTROL_CSR is cleared.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_RANGE_START_LOW_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_RANGE_START_LOW_CSR, *PDDR_RANGE_START_LOW_CSR;

      SG_C_ASSERT(__sizeof__DDR_RANGE_START_LOW_CSR, sizeof (DDR_RANGE_START_LOW_CSR) == 4);

   #else
      typedef struct _DDR_RANGE_START_LOW_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_RANGE_START_LOW_CSR, *PDDR_RANGE_START_LOW_CSR;

      typedef union _DDR_RANGE_START_LOW_CSR_UNION {
         DDR_RANGE_START_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_RANGE_START_LOW_CSR_UNION, *PDDR_RANGE_START_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_RANGE_START_LOW_CSR_UNION, sizeof (DDR_RANGE_START_LOW_CSR_UNION) == 4);
   #endif


#else
   // Local DDR Address Range Start Low Register. Indicates the lower 32 bits of the start
   // of the rangeof off-chip system addresses that are to be mapped to the local DDR
   // interface. Anything equal or greater than this CSR value are local DDR addresses.
   // Only relevant when disable bit in DDR_CONTROL_CSR is cleared.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_RANGE_START_LOW_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_RANGE_START_LOW_CSR, *PDDR_RANGE_START_LOW_CSR;

      SG_C_ASSERT(__sizeof__DDR_RANGE_START_LOW_CSR, sizeof (DDR_RANGE_START_LOW_CSR) == 4);

   #else
      typedef struct _DDR_RANGE_START_LOW_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_RANGE_START_LOW_CSR, *PDDR_RANGE_START_LOW_CSR;

      typedef union _DDR_RANGE_START_LOW_CSR_UNION {
         DDR_RANGE_START_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_RANGE_START_LOW_CSR_UNION, *PDDR_RANGE_START_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_RANGE_START_LOW_CSR_UNION, sizeof (DDR_RANGE_START_LOW_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Local DDR Address Range Start High Register. Indicates the upper 32 bits of the
   // start of the rangeof off-chip system addresses that are to be mapped to the local
   // DDR interface. Anything equal or greater than this CSR value are local DDR
   // addresses. Only relevant when disable bit in DDR_CONTROL_CSR is cleared.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_RANGE_START_HIGH_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_RANGE_START_HIGH_CSR, *PDDR_RANGE_START_HIGH_CSR;

      SG_C_ASSERT(__sizeof__DDR_RANGE_START_HIGH_CSR, sizeof (DDR_RANGE_START_HIGH_CSR) == 4);

   #else
      typedef struct _DDR_RANGE_START_HIGH_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_RANGE_START_HIGH_CSR, *PDDR_RANGE_START_HIGH_CSR;

      typedef union _DDR_RANGE_START_HIGH_CSR_UNION {
         DDR_RANGE_START_HIGH_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_RANGE_START_HIGH_CSR_UNION, *PDDR_RANGE_START_HIGH_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_RANGE_START_HIGH_CSR_UNION, sizeof (DDR_RANGE_START_HIGH_CSR_UNION) == 4);
   #endif


#else
   // Local DDR Address Range Start High Register. Indicates the upper 32 bits of the
   // start of the rangeof off-chip system addresses that are to be mapped to the local
   // DDR interface. Anything equal or greater than this CSR value are local DDR
   // addresses. Only relevant when disable bit in DDR_CONTROL_CSR is cleared.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_RANGE_START_HIGH_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_RANGE_START_HIGH_CSR, *PDDR_RANGE_START_HIGH_CSR;

      SG_C_ASSERT(__sizeof__DDR_RANGE_START_HIGH_CSR, sizeof (DDR_RANGE_START_HIGH_CSR) == 4);

   #else
      typedef struct _DDR_RANGE_START_HIGH_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_RANGE_START_HIGH_CSR, *PDDR_RANGE_START_HIGH_CSR;

      typedef union _DDR_RANGE_START_HIGH_CSR_UNION {
         DDR_RANGE_START_HIGH_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_RANGE_START_HIGH_CSR_UNION, *PDDR_RANGE_START_HIGH_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_RANGE_START_HIGH_CSR_UNION, sizeof (DDR_RANGE_START_HIGH_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Local DDR Address Range End Low Register. Indicates the lower 32 bits of the end of
   // the rangeof off-chip system addresses that are to be mapped to the local DDR
   // interface. Anything equal or lower than this CSR value are local DDR addresses. Only
   // relevant when disable bit in DDR_CONTROL_CSR is cleared.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_RANGE_END_LOW_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_RANGE_END_LOW_CSR, *PDDR_RANGE_END_LOW_CSR;

      SG_C_ASSERT(__sizeof__DDR_RANGE_END_LOW_CSR, sizeof (DDR_RANGE_END_LOW_CSR) == 4);

   #else
      typedef struct _DDR_RANGE_END_LOW_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_RANGE_END_LOW_CSR, *PDDR_RANGE_END_LOW_CSR;

      typedef union _DDR_RANGE_END_LOW_CSR_UNION {
         DDR_RANGE_END_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_RANGE_END_LOW_CSR_UNION, *PDDR_RANGE_END_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_RANGE_END_LOW_CSR_UNION, sizeof (DDR_RANGE_END_LOW_CSR_UNION) == 4);
   #endif


#else
   // Local DDR Address Range End Low Register. Indicates the lower 32 bits of the end of
   // the rangeof off-chip system addresses that are to be mapped to the local DDR
   // interface. Anything equal or lower than this CSR value are local DDR addresses. Only
   // relevant when disable bit in DDR_CONTROL_CSR is cleared.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_RANGE_END_LOW_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_RANGE_END_LOW_CSR, *PDDR_RANGE_END_LOW_CSR;

      SG_C_ASSERT(__sizeof__DDR_RANGE_END_LOW_CSR, sizeof (DDR_RANGE_END_LOW_CSR) == 4);

   #else
      typedef struct _DDR_RANGE_END_LOW_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_RANGE_END_LOW_CSR, *PDDR_RANGE_END_LOW_CSR;

      typedef union _DDR_RANGE_END_LOW_CSR_UNION {
         DDR_RANGE_END_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_RANGE_END_LOW_CSR_UNION, *PDDR_RANGE_END_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_RANGE_END_LOW_CSR_UNION, sizeof (DDR_RANGE_END_LOW_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Local DDR Address Range End High Register. Indicates the upper 32 bits of the end of
   // the rangeof off-chip system addresses that are to be mapped to the local DDR
   // interface. Anything equal or lower than this CSR value are local DDR addresses. Only
   // relevant when disable bit in DDR_CONTROL_CSR is cleared.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_RANGE_END_HIGH_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_RANGE_END_HIGH_CSR, *PDDR_RANGE_END_HIGH_CSR;

      SG_C_ASSERT(__sizeof__DDR_RANGE_END_HIGH_CSR, sizeof (DDR_RANGE_END_HIGH_CSR) == 4);

   #else
      typedef struct _DDR_RANGE_END_HIGH_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_RANGE_END_HIGH_CSR, *PDDR_RANGE_END_HIGH_CSR;

      typedef union _DDR_RANGE_END_HIGH_CSR_UNION {
         DDR_RANGE_END_HIGH_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_RANGE_END_HIGH_CSR_UNION, *PDDR_RANGE_END_HIGH_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_RANGE_END_HIGH_CSR_UNION, sizeof (DDR_RANGE_END_HIGH_CSR_UNION) == 4);
   #endif


#else
   // Local DDR Address Range End High Register. Indicates the upper 32 bits of the end of
   // the rangeof off-chip system addresses that are to be mapped to the local DDR
   // interface. Anything equal or lower than this CSR value are local DDR addresses. Only
   // relevant when disable bit in DDR_CONTROL_CSR is cleared.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_RANGE_END_HIGH_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_RANGE_END_HIGH_CSR, *PDDR_RANGE_END_HIGH_CSR;

      SG_C_ASSERT(__sizeof__DDR_RANGE_END_HIGH_CSR, sizeof (DDR_RANGE_END_HIGH_CSR) == 4);

   #else
      typedef struct _DDR_RANGE_END_HIGH_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_RANGE_END_HIGH_CSR, *PDDR_RANGE_END_HIGH_CSR;

      typedef union _DDR_RANGE_END_HIGH_CSR_UNION {
         DDR_RANGE_END_HIGH_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_RANGE_END_HIGH_CSR_UNION, *PDDR_RANGE_END_HIGH_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_RANGE_END_HIGH_CSR_UNION, sizeof (DDR_RANGE_END_HIGH_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt DDR Address Range Start Low Register. Indicates the lower 32 bits of the
   // start of the range of WDMA DDR writes that will trigger an interrupt to MPU. The
   // feature is most typically used to notify MPU of a write to a DDR-based EQ.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_EQRANGE_START_LOW_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_EQRANGE_START_LOW_CSR, *PDDR_EQRANGE_START_LOW_CSR;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_START_LOW_CSR, sizeof (DDR_EQRANGE_START_LOW_CSR) == 4);

   #else
      typedef struct _DDR_EQRANGE_START_LOW_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_EQRANGE_START_LOW_CSR, *PDDR_EQRANGE_START_LOW_CSR;

      typedef union _DDR_EQRANGE_START_LOW_CSR_UNION {
         DDR_EQRANGE_START_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_EQRANGE_START_LOW_CSR_UNION, *PDDR_EQRANGE_START_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_START_LOW_CSR_UNION, sizeof (DDR_EQRANGE_START_LOW_CSR_UNION) == 4);
   #endif


#else
   // Interrupt DDR Address Range Start Low Register. Indicates the lower 32 bits of the
   // start of the range of WDMA DDR writes that will trigger an interrupt to MPU. The
   // feature is most typically used to notify MPU of a write to a DDR-based EQ.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_EQRANGE_START_LOW_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_EQRANGE_START_LOW_CSR, *PDDR_EQRANGE_START_LOW_CSR;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_START_LOW_CSR, sizeof (DDR_EQRANGE_START_LOW_CSR) == 4);

   #else
      typedef struct _DDR_EQRANGE_START_LOW_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_EQRANGE_START_LOW_CSR, *PDDR_EQRANGE_START_LOW_CSR;

      typedef union _DDR_EQRANGE_START_LOW_CSR_UNION {
         DDR_EQRANGE_START_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_EQRANGE_START_LOW_CSR_UNION, *PDDR_EQRANGE_START_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_START_LOW_CSR_UNION, sizeof (DDR_EQRANGE_START_LOW_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt DDR Address Range Start High Register. Indicates the upper 32 bits of the
   // start of the range of WDMA DDR writes that will trigger an interrupt to MPU. The
   // feature is most typically used to notify MPU of a write to a DDR-based EQ.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_EQRANGE_START_HIGH_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_EQRANGE_START_HIGH_CSR, *PDDR_EQRANGE_START_HIGH_CSR;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_START_HIGH_CSR, sizeof (DDR_EQRANGE_START_HIGH_CSR) == 4);

   #else
      typedef struct _DDR_EQRANGE_START_HIGH_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_EQRANGE_START_HIGH_CSR, *PDDR_EQRANGE_START_HIGH_CSR;

      typedef union _DDR_EQRANGE_START_HIGH_CSR_UNION {
         DDR_EQRANGE_START_HIGH_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_EQRANGE_START_HIGH_CSR_UNION, *PDDR_EQRANGE_START_HIGH_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_START_HIGH_CSR_UNION, sizeof (DDR_EQRANGE_START_HIGH_CSR_UNION) == 4);
   #endif


#else
   // Interrupt DDR Address Range Start High Register. Indicates the upper 32 bits of the
   // start of the range of WDMA DDR writes that will trigger an interrupt to MPU. The
   // feature is most typically used to notify MPU of a write to a DDR-based EQ.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_EQRANGE_START_HIGH_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_EQRANGE_START_HIGH_CSR, *PDDR_EQRANGE_START_HIGH_CSR;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_START_HIGH_CSR, sizeof (DDR_EQRANGE_START_HIGH_CSR) == 4);

   #else
      typedef struct _DDR_EQRANGE_START_HIGH_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_EQRANGE_START_HIGH_CSR, *PDDR_EQRANGE_START_HIGH_CSR;

      typedef union _DDR_EQRANGE_START_HIGH_CSR_UNION {
         DDR_EQRANGE_START_HIGH_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_EQRANGE_START_HIGH_CSR_UNION, *PDDR_EQRANGE_START_HIGH_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_START_HIGH_CSR_UNION, sizeof (DDR_EQRANGE_START_HIGH_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt DDR Address Range End Low Register. Indicates the lower 32 bits of the
   // start of the range of WDMA DDR writes that will trigger an interrupt to MPU. The
   // feature is most typically used to notify MPU of a write to a DDR-based EQ.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_EQRANGE_END_LOW_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_EQRANGE_END_LOW_CSR, *PDDR_EQRANGE_END_LOW_CSR;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_END_LOW_CSR, sizeof (DDR_EQRANGE_END_LOW_CSR) == 4);

   #else
      typedef struct _DDR_EQRANGE_END_LOW_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_EQRANGE_END_LOW_CSR, *PDDR_EQRANGE_END_LOW_CSR;

      typedef union _DDR_EQRANGE_END_LOW_CSR_UNION {
         DDR_EQRANGE_END_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_EQRANGE_END_LOW_CSR_UNION, *PDDR_EQRANGE_END_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_END_LOW_CSR_UNION, sizeof (DDR_EQRANGE_END_LOW_CSR_UNION) == 4);
   #endif


#else
   // Interrupt DDR Address Range End Low Register. Indicates the lower 32 bits of the
   // start of the range of WDMA DDR writes that will trigger an interrupt to MPU. The
   // feature is most typically used to notify MPU of a write to a DDR-based EQ.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_EQRANGE_END_LOW_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_EQRANGE_END_LOW_CSR, *PDDR_EQRANGE_END_LOW_CSR;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_END_LOW_CSR, sizeof (DDR_EQRANGE_END_LOW_CSR) == 4);

   #else
      typedef struct _DDR_EQRANGE_END_LOW_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_EQRANGE_END_LOW_CSR, *PDDR_EQRANGE_END_LOW_CSR;

      typedef union _DDR_EQRANGE_END_LOW_CSR_UNION {
         DDR_EQRANGE_END_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_EQRANGE_END_LOW_CSR_UNION, *PDDR_EQRANGE_END_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_END_LOW_CSR_UNION, sizeof (DDR_EQRANGE_END_LOW_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt DDR Address Range End High Register. Indicates the upper 32 bits of the
   // start of the range of WDMA DDR writes that will trigger an interrupt to MPU. The
   // feature is most typically used to notify MPU of a write to a DDR-based EQ.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_EQRANGE_END_HIGH_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_EQRANGE_END_HIGH_CSR, *PDDR_EQRANGE_END_HIGH_CSR;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_END_HIGH_CSR, sizeof (DDR_EQRANGE_END_HIGH_CSR) == 4);

   #else
      typedef struct _DDR_EQRANGE_END_HIGH_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_EQRANGE_END_HIGH_CSR, *PDDR_EQRANGE_END_HIGH_CSR;

      typedef union _DDR_EQRANGE_END_HIGH_CSR_UNION {
         DDR_EQRANGE_END_HIGH_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_EQRANGE_END_HIGH_CSR_UNION, *PDDR_EQRANGE_END_HIGH_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_END_HIGH_CSR_UNION, sizeof (DDR_EQRANGE_END_HIGH_CSR_UNION) == 4);
   #endif


#else
   // Interrupt DDR Address Range End High Register. Indicates the upper 32 bits of the
   // start of the range of WDMA DDR writes that will trigger an interrupt to MPU. The
   // feature is most typically used to notify MPU of a write to a DDR-based EQ.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_EQRANGE_END_HIGH_CSR {
         union {
            struct { 
               u32 range;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_EQRANGE_END_HIGH_CSR, *PDDR_EQRANGE_END_HIGH_CSR;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_END_HIGH_CSR, sizeof (DDR_EQRANGE_END_HIGH_CSR) == 4);

   #else
      typedef struct _DDR_EQRANGE_END_HIGH_CSR {
         u32 range;                               // DWORD 0
      } SG_PACK DDR_EQRANGE_END_HIGH_CSR, *PDDR_EQRANGE_END_HIGH_CSR;

      typedef union _DDR_EQRANGE_END_HIGH_CSR_UNION {
         DDR_EQRANGE_END_HIGH_CSR bits;
         u32 dw; // dword union
      } SG_PACK DDR_EQRANGE_END_HIGH_CSR_UNION, *PDDR_EQRANGE_END_HIGH_CSR_UNION;

      SG_C_ASSERT(__sizeof__DDR_EQRANGE_END_HIGH_CSR_UNION, sizeof (DDR_EQRANGE_END_HIGH_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA2DDR Interceptor Debug 0 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_WDMA2DDR_DEBUG0 {
         union {
            struct { 
               u32 dbg_wdma_count : 16;           // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 wdma_rd_state : 2;             // DWORD 0
               u32 fourk_count_underflow : 1;     // DWORD 0
               u32 fourk_count_overflow : 1;      // DWORD 0
               u32 fourk_count : 10;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_WDMA2DDR_DEBUG0, *PDDR_WDMA2DDR_DEBUG0;

      SG_C_ASSERT(__sizeof__DDR_WDMA2DDR_DEBUG0, sizeof (DDR_WDMA2DDR_DEBUG0) == 4);

   #else
      typedef struct _DDR_WDMA2DDR_DEBUG0 {
         u32 dbg_wdma_count : 16;                 // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 wdma_rd_state : 2;                   // DWORD 0
         u32 fourk_count_underflow : 1;           // DWORD 0
         u32 fourk_count_overflow : 1;            // DWORD 0
         u32 fourk_count : 10;                    // DWORD 0
      } SG_PACK DDR_WDMA2DDR_DEBUG0, *PDDR_WDMA2DDR_DEBUG0;

      typedef union _DDR_WDMA2DDR_DEBUG0_UNION {
         DDR_WDMA2DDR_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK DDR_WDMA2DDR_DEBUG0_UNION, *PDDR_WDMA2DDR_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__DDR_WDMA2DDR_DEBUG0_UNION, sizeof (DDR_WDMA2DDR_DEBUG0_UNION) == 4);
   #endif


#else
   // WDMA2DDR Interceptor Debug 0 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_WDMA2DDR_DEBUG0 {
         union {
            struct { 
               u32 fourk_count : 10;              // DWORD 0
               u32 fourk_count_overflow : 1;      // DWORD 0
               u32 fourk_count_underflow : 1;     // DWORD 0
               u32 wdma_rd_state : 2;             // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 dbg_wdma_count : 16;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_WDMA2DDR_DEBUG0, *PDDR_WDMA2DDR_DEBUG0;

      SG_C_ASSERT(__sizeof__DDR_WDMA2DDR_DEBUG0, sizeof (DDR_WDMA2DDR_DEBUG0) == 4);

   #else
      typedef struct _DDR_WDMA2DDR_DEBUG0 {
         u32 fourk_count : 10;                    // DWORD 0
         u32 fourk_count_overflow : 1;            // DWORD 0
         u32 fourk_count_underflow : 1;           // DWORD 0
         u32 wdma_rd_state : 2;                   // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 dbg_wdma_count : 16;                 // DWORD 0
      } SG_PACK DDR_WDMA2DDR_DEBUG0, *PDDR_WDMA2DDR_DEBUG0;

      typedef union _DDR_WDMA2DDR_DEBUG0_UNION {
         DDR_WDMA2DDR_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK DDR_WDMA2DDR_DEBUG0_UNION, *PDDR_WDMA2DDR_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__DDR_WDMA2DDR_DEBUG0_UNION, sizeof (DDR_WDMA2DDR_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA2DDR Interceptor Debug 1 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_WDMA2DDR_DEBUG1 {
         union {
            struct { 
               u32 rsvd0 : 11;                    // DWORD 0
               u32 icm_state : 5;                 // DWORD 0
               u32 wdmawdata_underflow : 1;       // DWORD 0
               u32 wdmawdata_overflow : 1;        // DWORD 0
               u32 wdmawdata_numfilled : 6;       // DWORD 0
               u32 wdmareq_underflow : 1;         // DWORD 0
               u32 wdmareq_overflow : 1;          // DWORD 0
               u32 wdmareq_numfilled : 6;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_WDMA2DDR_DEBUG1, *PDDR_WDMA2DDR_DEBUG1;

      SG_C_ASSERT(__sizeof__DDR_WDMA2DDR_DEBUG1, sizeof (DDR_WDMA2DDR_DEBUG1) == 4);

   #else
      typedef struct _DDR_WDMA2DDR_DEBUG1 {
         u32 rsvd0 : 11;                          // DWORD 0
         u32 icm_state : 5;                       // DWORD 0
         u32 wdmawdata_underflow : 1;             // DWORD 0
         u32 wdmawdata_overflow : 1;              // DWORD 0
         u32 wdmawdata_numfilled : 6;             // DWORD 0
         u32 wdmareq_underflow : 1;               // DWORD 0
         u32 wdmareq_overflow : 1;                // DWORD 0
         u32 wdmareq_numfilled : 6;               // DWORD 0
      } SG_PACK DDR_WDMA2DDR_DEBUG1, *PDDR_WDMA2DDR_DEBUG1;

      typedef union _DDR_WDMA2DDR_DEBUG1_UNION {
         DDR_WDMA2DDR_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK DDR_WDMA2DDR_DEBUG1_UNION, *PDDR_WDMA2DDR_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__DDR_WDMA2DDR_DEBUG1_UNION, sizeof (DDR_WDMA2DDR_DEBUG1_UNION) == 4);
   #endif


#else
   // WDMA2DDR Interceptor Debug 1 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_WDMA2DDR_DEBUG1 {
         union {
            struct { 
               u32 wdmareq_numfilled : 6;         // DWORD 0
               u32 wdmareq_overflow : 1;          // DWORD 0
               u32 wdmareq_underflow : 1;         // DWORD 0
               u32 wdmawdata_numfilled : 6;       // DWORD 0
               u32 wdmawdata_overflow : 1;        // DWORD 0
               u32 wdmawdata_underflow : 1;       // DWORD 0
               u32 icm_state : 5;                 // DWORD 0
               u32 rsvd0 : 11;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_WDMA2DDR_DEBUG1, *PDDR_WDMA2DDR_DEBUG1;

      SG_C_ASSERT(__sizeof__DDR_WDMA2DDR_DEBUG1, sizeof (DDR_WDMA2DDR_DEBUG1) == 4);

   #else
      typedef struct _DDR_WDMA2DDR_DEBUG1 {
         u32 wdmareq_numfilled : 6;               // DWORD 0
         u32 wdmareq_overflow : 1;                // DWORD 0
         u32 wdmareq_underflow : 1;               // DWORD 0
         u32 wdmawdata_numfilled : 6;             // DWORD 0
         u32 wdmawdata_overflow : 1;              // DWORD 0
         u32 wdmawdata_underflow : 1;             // DWORD 0
         u32 icm_state : 5;                       // DWORD 0
         u32 rsvd0 : 11;                          // DWORD 0
      } SG_PACK DDR_WDMA2DDR_DEBUG1, *PDDR_WDMA2DDR_DEBUG1;

      typedef union _DDR_WDMA2DDR_DEBUG1_UNION {
         DDR_WDMA2DDR_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK DDR_WDMA2DDR_DEBUG1_UNION, *PDDR_WDMA2DDR_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__DDR_WDMA2DDR_DEBUG1_UNION, sizeof (DDR_WDMA2DDR_DEBUG1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RDMA2DDR/NDMA2DDR Interceptor Debug 0 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_RDMA2DDR_DEBUG0 {
         union {
            struct { 
               u32 dbg_count : 15;                // DWORD 0
               u32 one_req_in_prog : 1;           // DWORD 0
               u32 icm_state : 4;                 // DWORD 0
               u32 return_underflow : 1;          // DWORD 0
               u32 return_overflow : 1;           // DWORD 0
               u32 return_numfilled : 4;          // DWORD 0
               u32 req_underflow : 1;             // DWORD 0
               u32 req_overflow : 1;              // DWORD 0
               u32 req_numfilled : 4;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_RDMA2DDR_DEBUG0, *PDDR_RDMA2DDR_DEBUG0;

      SG_C_ASSERT(__sizeof__DDR_RDMA2DDR_DEBUG0, sizeof (DDR_RDMA2DDR_DEBUG0) == 4);

   #else
      typedef struct _DDR_RDMA2DDR_DEBUG0 {
         u32 dbg_count : 15;                      // DWORD 0
         u32 one_req_in_prog : 1;                 // DWORD 0
         u32 icm_state : 4;                       // DWORD 0
         u32 return_underflow : 1;                // DWORD 0
         u32 return_overflow : 1;                 // DWORD 0
         u32 return_numfilled : 4;                // DWORD 0
         u32 req_underflow : 1;                   // DWORD 0
         u32 req_overflow : 1;                    // DWORD 0
         u32 req_numfilled : 4;                   // DWORD 0
      } SG_PACK DDR_RDMA2DDR_DEBUG0, *PDDR_RDMA2DDR_DEBUG0;

      typedef union _DDR_RDMA2DDR_DEBUG0_UNION {
         DDR_RDMA2DDR_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK DDR_RDMA2DDR_DEBUG0_UNION, *PDDR_RDMA2DDR_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__DDR_RDMA2DDR_DEBUG0_UNION, sizeof (DDR_RDMA2DDR_DEBUG0_UNION) == 4);
   #endif


#else
   // RDMA2DDR/NDMA2DDR Interceptor Debug 0 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _DDR_RDMA2DDR_DEBUG0 {
         union {
            struct { 
               u32 req_numfilled : 4;             // DWORD 0
               u32 req_overflow : 1;              // DWORD 0
               u32 req_underflow : 1;             // DWORD 0
               u32 return_numfilled : 4;          // DWORD 0
               u32 return_overflow : 1;           // DWORD 0
               u32 return_underflow : 1;          // DWORD 0
               u32 icm_state : 4;                 // DWORD 0
               u32 one_req_in_prog : 1;           // DWORD 0
               u32 dbg_count : 15;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DDR_RDMA2DDR_DEBUG0, *PDDR_RDMA2DDR_DEBUG0;

      SG_C_ASSERT(__sizeof__DDR_RDMA2DDR_DEBUG0, sizeof (DDR_RDMA2DDR_DEBUG0) == 4);

   #else
      typedef struct _DDR_RDMA2DDR_DEBUG0 {
         u32 req_numfilled : 4;                   // DWORD 0
         u32 req_overflow : 1;                    // DWORD 0
         u32 req_underflow : 1;                   // DWORD 0
         u32 return_numfilled : 4;                // DWORD 0
         u32 return_overflow : 1;                 // DWORD 0
         u32 return_underflow : 1;                // DWORD 0
         u32 icm_state : 4;                       // DWORD 0
         u32 one_req_in_prog : 1;                 // DWORD 0
         u32 dbg_count : 15;                      // DWORD 0
      } SG_PACK DDR_RDMA2DDR_DEBUG0, *PDDR_RDMA2DDR_DEBUG0;

      typedef union _DDR_RDMA2DDR_DEBUG0_UNION {
         DDR_RDMA2DDR_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK DDR_RDMA2DDR_DEBUG0_UNION, *PDDR_RDMA2DDR_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__DDR_RDMA2DDR_DEBUG0_UNION, sizeof (DDR_RDMA2DDR_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Read (Data Structures) DMA Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_CSRMAP {
         union {
            struct { 
               RDMA_CTRL_CSR rdma_ctrl;
               RDMA_STS_CSR rdma_sts;
               RDMA_WRR_ENTRY_CSR rdma_wrr;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } uc_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } erx_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } ptc_pq;
               HWDBG_CSRMAP hwdbg;
               RDMA_UC_RELEASE_CSR rdma_uc_release_status;
               RDMA_UE_SOURCE_CSR ue_source;
               RDMA_UE_ENABLE_CSR ue_enable;
               RDMA_ZERODMA_HOST_ADDLSB_CSR rdma_zero_addr_lsb;
               RDMA_ZERODMA_HOST_ADDMSB_CSR rdma_zero_addr_msb;
               u32 rsvd0[230];                    // DWORDS 26 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_CSRMAP, *PRDMA_CSRMAP;

      SG_C_ASSERT(__sizeof__RDMA_CSRMAP, sizeof (RDMA_CSRMAP) == 1024);

   #else
      typedef struct _RDMA_CSRMAP {
         RDMA_CTRL_CSR rdma_ctrl;
         RDMA_STS_CSR rdma_sts;
         RDMA_WRR_ENTRY_CSR rdma_wrr;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } uc_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } erx_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } ptc_pq;
         HWDBG_CSRMAP hwdbg;
         RDMA_UC_RELEASE_CSR rdma_uc_release_status;
         RDMA_UE_SOURCE_CSR ue_source;
         RDMA_UE_ENABLE_CSR ue_enable;
         RDMA_ZERODMA_HOST_ADDLSB_CSR rdma_zero_addr_lsb;
         RDMA_ZERODMA_HOST_ADDMSB_CSR rdma_zero_addr_msb;
         u32 rsvd0[230];                          // DWORDS 26 to 255
      } SG_PACK RDMA_CSRMAP, *PRDMA_CSRMAP;

      typedef union _RDMA_CSRMAP_UNION {
         RDMA_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK RDMA_CSRMAP_UNION, *PRDMA_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__RDMA_CSRMAP_UNION, sizeof (RDMA_CSRMAP_UNION) == 1024);
   #endif


#else
   // Read (Data Structures) DMA Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_CSRMAP {
         union {
            struct { 
               RDMA_CTRL_CSR rdma_ctrl;
               RDMA_STS_CSR rdma_sts;
               RDMA_WRR_ENTRY_CSR rdma_wrr;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } uc_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } erx_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } ptc_pq;
               HWDBG_CSRMAP hwdbg;
               RDMA_UC_RELEASE_CSR rdma_uc_release_status;
               RDMA_UE_SOURCE_CSR ue_source;
               RDMA_UE_ENABLE_CSR ue_enable;
               RDMA_ZERODMA_HOST_ADDLSB_CSR rdma_zero_addr_lsb;
               RDMA_ZERODMA_HOST_ADDMSB_CSR rdma_zero_addr_msb;
               u32 rsvd0[230];                    // DWORDS 26 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_CSRMAP, *PRDMA_CSRMAP;

      SG_C_ASSERT(__sizeof__RDMA_CSRMAP, sizeof (RDMA_CSRMAP) == 1024);

   #else
      typedef struct _RDMA_CSRMAP {
         RDMA_CTRL_CSR rdma_ctrl;
         RDMA_STS_CSR rdma_sts;
         RDMA_WRR_ENTRY_CSR rdma_wrr;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } uc_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } erx_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } ptc_pq;
         HWDBG_CSRMAP hwdbg;
         RDMA_UC_RELEASE_CSR rdma_uc_release_status;
         RDMA_UE_SOURCE_CSR ue_source;
         RDMA_UE_ENABLE_CSR ue_enable;
         RDMA_ZERODMA_HOST_ADDLSB_CSR rdma_zero_addr_lsb;
         RDMA_ZERODMA_HOST_ADDMSB_CSR rdma_zero_addr_msb;
         u32 rsvd0[230];                          // DWORDS 26 to 255
      } SG_PACK RDMA_CSRMAP, *PRDMA_CSRMAP;

      typedef union _RDMA_CSRMAP_UNION {
         RDMA_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK RDMA_CSRMAP_UNION, *PRDMA_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__RDMA_CSRMAP_UNION, sizeof (RDMA_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __rdma_bmap_h__

