/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __rdma_context_bmap_h__
#define __rdma_context_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Context control structure for an RDMA Queue Pair
   #if defined(SG_BMAP_UNION)
      typedef struct _QP_CONTEXT {
         union {
            struct { 
               u32 sq_size : 3;                   // DWORD 0
               u32 valid1 : 1;                    // DWORD 0
               u32 pdid1 : 9;                     // DWORD 0
               u32 cqid_sq : 10;                  // DWORD 0
               u32 snd_prd : 9;                   // DWORD 0
               u32 func : 1;                      // DWORD 1
               u32 je_cur : 8;                    // DWORD 1
               u32 jrnl_match : 1;                // DWORD 1
               u32 rxmt : 1;                      // DWORD 1
               u32 currchiprequest : 1;           // DWORD 1
               u32 currdriverrequest : 1;         // DWORD 1
               u32 prev_te : 1;                   // DWORD 1
               u32 opcode : 4;                    // DWORD 1
               u32 d2p_pending : 1;               // DWORD 1
               u32 max_sge : 2;                   // DWORD 1
               u32 curr_sge : 2;                  // DWORD 1
               u32 tx_marker_off : 9;             // DWORD 1
               u32 tx_send_msn;                   // DWORD 2
               u32 tx_resp_bytes;                 // DWORD 3
               u32 tx_send_bytes;                 // DWORD 4
               u32 tx_rreq_msn;                   // DWORD 5
               u32 chip_seq_no;                   // DWORD 6
               u32 rsvd0 : 2;                     // DWORD 7
               u32 chip_wqe_idx : 14;             // DWORD 7
               u32 snd_csmr : 2;                  // DWORD 7
               u32 windows_bound : 14;            // DWORD 7
               u32 pdid2 : 9;                     // DWORD 8
               u32 rcv_prd : 9;                   // DWORD 8
               u32 valid2 : 1;                    // DWORD 8
               u32 rflags : 2;                    // DWORD 8
               u32 cqid_rq : 11;                  // DWORD 8
               u32 stake_seq_no;                  // DWORD 9
               u32 rsvd1 : 4;                     // DWORD 10
               u32 rrsq_cnt : 2;                  // DWORD 10
               u32 orrj_read : 2;                 // DWORD 10
               u32 orrj_write : 2;                // DWORD 10
               u32 stake_wqe_idx : 14;            // DWORD 10
               u32 irrj_oo_write : 2;             // DWORD 10
               u32 irrj_io_write : 2;             // DWORD 10
               u32 irrj_size : 2;                 // DWORD 10
               u32 irrj_read : 2;                 // DWORD 10
               u32 rx_send_msn;                   // DWORD 11
               u32 rx_rreq_msn;                   // DWORD 12
               u32 rcv_csmr : 9;                  // DWORD 13
               u32 rdma_state : 3;                // DWORD 13
               u32 error : 1;                     // DWORD 13
               u32 terminate : 1;                 // DWORD 13
               u32 fence : 1;                     // DWORD 13
               u32 flags : 8;                     // DWORD 13
               u32 rx_marker_off : 9;             // DWORD 13
               u32 exp_io_tcp_seq_no;             // DWORD 14
               u32 irrj_ddr_base_cra : 28;        // DWORD 15
               u32 rq_size : 4;                   // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK QP_CONTEXT, *PQP_CONTEXT;

      SG_C_ASSERT(__sizeof__QP_CONTEXT, sizeof (QP_CONTEXT) == 64);

   #else
      typedef struct _QP_CONTEXT {
         u32 sq_size : 3;                         // DWORD 0
         u32 valid1 : 1;                          // DWORD 0
         u32 pdid1 : 9;                           // DWORD 0
         u32 cqid_sq : 10;                        // DWORD 0
         u32 snd_prd : 9;                         // DWORD 0
         u32 func : 1;                            // DWORD 1
         u32 je_cur : 8;                          // DWORD 1
         u32 jrnl_match : 1;                      // DWORD 1
         u32 rxmt : 1;                            // DWORD 1
         u32 currchiprequest : 1;                 // DWORD 1
         u32 currdriverrequest : 1;               // DWORD 1
         u32 prev_te : 1;                         // DWORD 1
         u32 opcode : 4;                          // DWORD 1
         u32 d2p_pending : 1;                     // DWORD 1
         u32 max_sge : 2;                         // DWORD 1
         u32 curr_sge : 2;                        // DWORD 1
         u32 tx_marker_off : 9;                   // DWORD 1
         u32 tx_send_msn;                         // DWORD 2
         u32 tx_resp_bytes;                       // DWORD 3
         u32 tx_send_bytes;                       // DWORD 4
         u32 tx_rreq_msn;                         // DWORD 5
         u32 chip_seq_no;                         // DWORD 6
         u32 rsvd0 : 2;                           // DWORD 7
         u32 chip_wqe_idx : 14;                   // DWORD 7
         u32 snd_csmr : 2;                        // DWORD 7
         u32 windows_bound : 14;                  // DWORD 7
         u32 pdid2 : 9;                           // DWORD 8
         u32 rcv_prd : 9;                         // DWORD 8
         u32 valid2 : 1;                          // DWORD 8
         u32 rflags : 2;                          // DWORD 8
         u32 cqid_rq : 11;                        // DWORD 8
         u32 stake_seq_no;                        // DWORD 9
         u32 rsvd1 : 4;                           // DWORD 10
         u32 rrsq_cnt : 2;                        // DWORD 10
         u32 orrj_read : 2;                       // DWORD 10
         u32 orrj_write : 2;                      // DWORD 10
         u32 stake_wqe_idx : 14;                  // DWORD 10
         u32 irrj_oo_write : 2;                   // DWORD 10
         u32 irrj_io_write : 2;                   // DWORD 10
         u32 irrj_size : 2;                       // DWORD 10
         u32 irrj_read : 2;                       // DWORD 10
         u32 rx_send_msn;                         // DWORD 11
         u32 rx_rreq_msn;                         // DWORD 12
         u32 rcv_csmr : 9;                        // DWORD 13
         u32 rdma_state : 3;                      // DWORD 13
         u32 error : 1;                           // DWORD 13
         u32 terminate : 1;                       // DWORD 13
         u32 fence : 1;                           // DWORD 13
         u32 flags : 8;                           // DWORD 13
         u32 rx_marker_off : 9;                   // DWORD 13
         u32 exp_io_tcp_seq_no;                   // DWORD 14
         u32 irrj_ddr_base_cra : 28;              // DWORD 15
         u32 rq_size : 4;                         // DWORD 15
      } SG_PACK QP_CONTEXT, *PQP_CONTEXT;

      typedef union _QP_CONTEXT_UNION {
         QP_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK QP_CONTEXT_UNION, *PQP_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__QP_CONTEXT_UNION, sizeof (QP_CONTEXT_UNION) == 64);
   #endif


#else
   // Context control structure for an RDMA Queue Pair
   #if defined(SG_BMAP_UNION)
      typedef struct _QP_CONTEXT {
         union {
            struct { 
               u32 snd_prd : 9;                   // DWORD 0
               u32 cqid_sq : 10;                  // DWORD 0
               u32 pdid1 : 9;                     // DWORD 0
               u32 valid1 : 1;                    // DWORD 0
               u32 sq_size : 3;                   // DWORD 0
               u32 tx_marker_off : 9;             // DWORD 1
               u32 curr_sge : 2;                  // DWORD 1
               u32 max_sge : 2;                   // DWORD 1
               u32 d2p_pending : 1;               // DWORD 1
               u32 opcode : 4;                    // DWORD 1
               u32 prev_te : 1;                   // DWORD 1
               u32 currdriverrequest : 1;         // DWORD 1
               u32 currchiprequest : 1;           // DWORD 1
               u32 rxmt : 1;                      // DWORD 1
               u32 jrnl_match : 1;                // DWORD 1
               u32 je_cur : 8;                    // DWORD 1
               u32 func : 1;                      // DWORD 1
               u32 tx_send_msn;                   // DWORD 2
               u32 tx_resp_bytes;                 // DWORD 3
               u32 tx_send_bytes;                 // DWORD 4
               u32 tx_rreq_msn;                   // DWORD 5
               u32 chip_seq_no;                   // DWORD 6
               u32 windows_bound : 14;            // DWORD 7
               u32 snd_csmr : 2;                  // DWORD 7
               u32 chip_wqe_idx : 14;             // DWORD 7
               u32 rsvd0 : 2;                     // DWORD 7
               u32 cqid_rq : 11;                  // DWORD 8
               u32 rflags : 2;                    // DWORD 8
               u32 valid2 : 1;                    // DWORD 8
               u32 rcv_prd : 9;                   // DWORD 8
               u32 pdid2 : 9;                     // DWORD 8
               u32 stake_seq_no;                  // DWORD 9
               u32 irrj_read : 2;                 // DWORD 10
               u32 irrj_size : 2;                 // DWORD 10
               u32 irrj_io_write : 2;             // DWORD 10
               u32 irrj_oo_write : 2;             // DWORD 10
               u32 stake_wqe_idx : 14;            // DWORD 10
               u32 orrj_write : 2;                // DWORD 10
               u32 orrj_read : 2;                 // DWORD 10
               u32 rrsq_cnt : 2;                  // DWORD 10
               u32 rsvd1 : 4;                     // DWORD 10
               u32 rx_send_msn;                   // DWORD 11
               u32 rx_rreq_msn;                   // DWORD 12
               u32 rx_marker_off : 9;             // DWORD 13
               u32 flags : 8;                     // DWORD 13
               u32 fence : 1;                     // DWORD 13
               u32 terminate : 1;                 // DWORD 13
               u32 error : 1;                     // DWORD 13
               u32 rdma_state : 3;                // DWORD 13
               u32 rcv_csmr : 9;                  // DWORD 13
               u32 exp_io_tcp_seq_no;             // DWORD 14
               u32 rq_size : 4;                   // DWORD 15
               u32 irrj_ddr_base_cra : 28;        // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK QP_CONTEXT, *PQP_CONTEXT;

      SG_C_ASSERT(__sizeof__QP_CONTEXT, sizeof (QP_CONTEXT) == 64);

   #else
      typedef struct _QP_CONTEXT {
         u32 snd_prd : 9;                         // DWORD 0
         u32 cqid_sq : 10;                        // DWORD 0
         u32 pdid1 : 9;                           // DWORD 0
         u32 valid1 : 1;                          // DWORD 0
         u32 sq_size : 3;                         // DWORD 0
         u32 tx_marker_off : 9;                   // DWORD 1
         u32 curr_sge : 2;                        // DWORD 1
         u32 max_sge : 2;                         // DWORD 1
         u32 d2p_pending : 1;                     // DWORD 1
         u32 opcode : 4;                          // DWORD 1
         u32 prev_te : 1;                         // DWORD 1
         u32 currdriverrequest : 1;               // DWORD 1
         u32 currchiprequest : 1;                 // DWORD 1
         u32 rxmt : 1;                            // DWORD 1
         u32 jrnl_match : 1;                      // DWORD 1
         u32 je_cur : 8;                          // DWORD 1
         u32 func : 1;                            // DWORD 1
         u32 tx_send_msn;                         // DWORD 2
         u32 tx_resp_bytes;                       // DWORD 3
         u32 tx_send_bytes;                       // DWORD 4
         u32 tx_rreq_msn;                         // DWORD 5
         u32 chip_seq_no;                         // DWORD 6
         u32 windows_bound : 14;                  // DWORD 7
         u32 snd_csmr : 2;                        // DWORD 7
         u32 chip_wqe_idx : 14;                   // DWORD 7
         u32 rsvd0 : 2;                           // DWORD 7
         u32 cqid_rq : 11;                        // DWORD 8
         u32 rflags : 2;                          // DWORD 8
         u32 valid2 : 1;                          // DWORD 8
         u32 rcv_prd : 9;                         // DWORD 8
         u32 pdid2 : 9;                           // DWORD 8
         u32 stake_seq_no;                        // DWORD 9
         u32 irrj_read : 2;                       // DWORD 10
         u32 irrj_size : 2;                       // DWORD 10
         u32 irrj_io_write : 2;                   // DWORD 10
         u32 irrj_oo_write : 2;                   // DWORD 10
         u32 stake_wqe_idx : 14;                  // DWORD 10
         u32 orrj_write : 2;                      // DWORD 10
         u32 orrj_read : 2;                       // DWORD 10
         u32 rrsq_cnt : 2;                        // DWORD 10
         u32 rsvd1 : 4;                           // DWORD 10
         u32 rx_send_msn;                         // DWORD 11
         u32 rx_rreq_msn;                         // DWORD 12
         u32 rx_marker_off : 9;                   // DWORD 13
         u32 flags : 8;                           // DWORD 13
         u32 fence : 1;                           // DWORD 13
         u32 terminate : 1;                       // DWORD 13
         u32 error : 1;                           // DWORD 13
         u32 rdma_state : 3;                      // DWORD 13
         u32 rcv_csmr : 9;                        // DWORD 13
         u32 exp_io_tcp_seq_no;                   // DWORD 14
         u32 rq_size : 4;                         // DWORD 15
         u32 irrj_ddr_base_cra : 28;              // DWORD 15
      } SG_PACK QP_CONTEXT, *PQP_CONTEXT;

      typedef union _QP_CONTEXT_UNION {
         QP_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK QP_CONTEXT_UNION, *PQP_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__QP_CONTEXT_UNION, sizeof (QP_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Rdma Scatter/Gather Entry. This structure represents a single STag fragment.
   // Multiple SGEs are typically combined into an RDMA Scatter Gather List. Many RDMA
   // WQEs contain 1 or more SGEs.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_SGE {
         union {
            struct { 
               u32 stag;                          // DWORD 0
               u32 length;                        // DWORD 1
               u32 to[2];                         // DWORDS 2 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_SGE, *PRDMA_SGE;

      SG_C_ASSERT(__sizeof__RDMA_SGE, sizeof (RDMA_SGE) == 16);

   #else
      typedef struct _RDMA_SGE {
         u32 stag;                                // DWORD 0
         u32 length;                              // DWORD 1
         u32 to[2];                               // DWORDS 2 to 3
      } SG_PACK RDMA_SGE, *PRDMA_SGE;

      typedef union _RDMA_SGE_UNION {
         RDMA_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_SGE_UNION, *PRDMA_SGE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_SGE_UNION, sizeof (RDMA_SGE_UNION) == 16);
   #endif


#else
   // Rdma Scatter/Gather Entry. This structure represents a single STag fragment.
   // Multiple SGEs are typically combined into an RDMA Scatter Gather List. Many RDMA
   // WQEs contain 1 or more SGEs.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_SGE {
         union {
            struct { 
               u32 stag;                          // DWORD 0
               u32 length;                        // DWORD 1
               u32 to[2];                         // DWORDS 2 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_SGE, *PRDMA_SGE;

      SG_C_ASSERT(__sizeof__RDMA_SGE, sizeof (RDMA_SGE) == 16);

   #else
      typedef struct _RDMA_SGE {
         u32 stag;                                // DWORD 0
         u32 length;                              // DWORD 1
         u32 to[2];                               // DWORDS 2 to 3
      } SG_PACK RDMA_SGE, *PRDMA_SGE;

      typedef union _RDMA_SGE_UNION {
         RDMA_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_SGE_UNION, *PRDMA_SGE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_SGE_UNION, sizeof (RDMA_SGE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The RDMA Inbound Read Request Journal stores context for RDMA inbound read
   // operations. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_IRRJ {
         union {
            struct { 
               u32 sink_stag;                     // DWORD 0
               u32 sink_TO[2];                    // DWORDS 1 to 2
               u32 rsvd0 : 16;                    // DWORD 3
               u32 source_stag : 16;              // DWORD 3
               u32 source_TO[2];                  // DWORDS 4 to 5
               u32 rsvd1 : 1;                     // DWORD 6
               u32 valid : 1;                     // DWORD 6
               u32 length : 30;                   // DWORD 6
               u32 rsvd2[1];                      // DWORDS 7 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_IRRJ, *PRDMA_IRRJ;

      SG_C_ASSERT(__sizeof__RDMA_IRRJ, sizeof (RDMA_IRRJ) == 32);

   #else
      typedef struct _RDMA_IRRJ {
         u32 sink_stag;                           // DWORD 0
         u32 sink_TO[2];                          // DWORDS 1 to 2
         u32 rsvd0 : 16;                          // DWORD 3
         u32 source_stag : 16;                    // DWORD 3
         u32 source_TO[2];                        // DWORDS 4 to 5
         u32 rsvd1 : 1;                           // DWORD 6
         u32 valid : 1;                           // DWORD 6
         u32 length : 30;                         // DWORD 6
         u32 rsvd2[1];                            // DWORDS 7 to 7
      } SG_PACK RDMA_IRRJ, *PRDMA_IRRJ;

      typedef union _RDMA_IRRJ_UNION {
         RDMA_IRRJ bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_IRRJ_UNION, *PRDMA_IRRJ_UNION;

      SG_C_ASSERT(__sizeof__RDMA_IRRJ_UNION, sizeof (RDMA_IRRJ_UNION) == 32);
   #endif


#else
   // The RDMA Inbound Read Request Journal stores context for RDMA inbound read
   // operations. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_IRRJ {
         union {
            struct { 
               u32 sink_stag;                     // DWORD 0
               u32 sink_TO[2];                    // DWORDS 1 to 2
               u32 source_stag : 16;              // DWORD 3
               u32 rsvd0 : 16;                    // DWORD 3
               u32 source_TO[2];                  // DWORDS 4 to 5
               u32 length : 30;                   // DWORD 6
               u32 valid : 1;                     // DWORD 6
               u32 rsvd1 : 1;                     // DWORD 6
               u32 rsvd2[1];                      // DWORDS 7 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_IRRJ, *PRDMA_IRRJ;

      SG_C_ASSERT(__sizeof__RDMA_IRRJ, sizeof (RDMA_IRRJ) == 32);

   #else
      typedef struct _RDMA_IRRJ {
         u32 sink_stag;                           // DWORD 0
         u32 sink_TO[2];                          // DWORDS 1 to 2
         u32 source_stag : 16;                    // DWORD 3
         u32 rsvd0 : 16;                          // DWORD 3
         u32 source_TO[2];                        // DWORDS 4 to 5
         u32 length : 30;                         // DWORD 6
         u32 valid : 1;                           // DWORD 6
         u32 rsvd1 : 1;                           // DWORD 6
         u32 rsvd2[1];                            // DWORDS 7 to 7
      } SG_PACK RDMA_IRRJ, *PRDMA_IRRJ;

      typedef union _RDMA_IRRJ_UNION {
         RDMA_IRRJ bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_IRRJ_UNION, *PRDMA_IRRJ_UNION;

      SG_C_ASSERT(__sizeof__RDMA_IRRJ_UNION, sizeof (RDMA_IRRJ_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The RDMA WQE that is commonly used for SEND and WRITE . 
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_WQE {
         union {
            struct { 
               u32 curr_offset;                   // DWORD 0
               u32 remote_stag;                   // DWORD 1
               u32 to_0;                          // DWORD 2
               u32 to_1;                          // DWORD 3
               u32 stag;                          // DWORD 4
               u32 len;                           // DWORD 5
               u32 addr_lo;                       // DWORD 6
               u32 addr_hi;                       // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_WQE, *PRDMA_WQE;

      SG_C_ASSERT(__sizeof__RDMA_WQE, sizeof (RDMA_WQE) == 32);

   #else
      typedef struct _RDMA_WQE {
         u32 curr_offset;                         // DWORD 0
         u32 remote_stag;                         // DWORD 1
         u32 to_0;                                // DWORD 2
         u32 to_1;                                // DWORD 3
         u32 stag;                                // DWORD 4
         u32 len;                                 // DWORD 5
         u32 addr_lo;                             // DWORD 6
         u32 addr_hi;                             // DWORD 7
      } SG_PACK RDMA_WQE, *PRDMA_WQE;

      typedef union _RDMA_WQE_UNION {
         RDMA_WQE bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_WQE_UNION, *PRDMA_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_WQE_UNION, sizeof (RDMA_WQE_UNION) == 32);
   #endif


#else
   // The RDMA WQE that is commonly used for SEND and WRITE . 
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_WQE {
         union {
            struct { 
               u32 curr_offset;                   // DWORD 0
               u32 remote_stag;                   // DWORD 1
               u32 to_0;                          // DWORD 2
               u32 to_1;                          // DWORD 3
               u32 stag;                          // DWORD 4
               u32 len;                           // DWORD 5
               u32 addr_lo;                       // DWORD 6
               u32 addr_hi;                       // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_WQE, *PRDMA_WQE;

      SG_C_ASSERT(__sizeof__RDMA_WQE, sizeof (RDMA_WQE) == 32);

   #else
      typedef struct _RDMA_WQE {
         u32 curr_offset;                         // DWORD 0
         u32 remote_stag;                         // DWORD 1
         u32 to_0;                                // DWORD 2
         u32 to_1;                                // DWORD 3
         u32 stag;                                // DWORD 4
         u32 len;                                 // DWORD 5
         u32 addr_lo;                             // DWORD 6
         u32 addr_hi;                             // DWORD 7
      } SG_PACK RDMA_WQE, *PRDMA_WQE;

      typedef union _RDMA_WQE_UNION {
         RDMA_WQE bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_WQE_UNION, *PRDMA_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_WQE_UNION, sizeof (RDMA_WQE_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The RDMA WQE that is commonly used for SEND and WRITE . 
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HDR_WQE {
         union {
            struct { 
               u32 curr_offset;                   // DWORD 0
               u32 remote_stag;                   // DWORD 1
               u32 sge_count : 8;                 // DWORD 2
               u32 flags : 16;                    // DWORD 2
               u32 opcode : 8;                    // DWORD 2
               u32 rsvd0[1];                      // DWORDS 3 to 3
               u32 stag;                          // DWORD 4
               u32 len;                           // DWORD 5
               u32 addr_lo;                       // DWORD 6
               u32 addr_hi;                       // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HDR_WQE, *PRDMA_HDR_WQE;

      SG_C_ASSERT(__sizeof__RDMA_HDR_WQE, sizeof (RDMA_HDR_WQE) == 32);

   #else
      typedef struct _RDMA_HDR_WQE {
         u32 curr_offset;                         // DWORD 0
         u32 remote_stag;                         // DWORD 1
         u32 sge_count : 8;                       // DWORD 2
         u32 flags : 16;                          // DWORD 2
         u32 opcode : 8;                          // DWORD 2
         u32 rsvd0[1];                            // DWORDS 3 to 3
         u32 stag;                                // DWORD 4
         u32 len;                                 // DWORD 5
         u32 addr_lo;                             // DWORD 6
         u32 addr_hi;                             // DWORD 7
      } SG_PACK RDMA_HDR_WQE, *PRDMA_HDR_WQE;

      typedef union _RDMA_HDR_WQE_UNION {
         RDMA_HDR_WQE bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_HDR_WQE_UNION, *PRDMA_HDR_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HDR_WQE_UNION, sizeof (RDMA_HDR_WQE_UNION) == 32);
   #endif


#else
   // The RDMA WQE that is commonly used for SEND and WRITE . 
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HDR_WQE {
         union {
            struct { 
               u32 curr_offset;                   // DWORD 0
               u32 remote_stag;                   // DWORD 1
               u32 opcode : 8;                    // DWORD 2
               u32 flags : 16;                    // DWORD 2
               u32 sge_count : 8;                 // DWORD 2
               u32 rsvd0[1];                      // DWORDS 3 to 3
               u32 stag;                          // DWORD 4
               u32 len;                           // DWORD 5
               u32 addr_lo;                       // DWORD 6
               u32 addr_hi;                       // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HDR_WQE, *PRDMA_HDR_WQE;

      SG_C_ASSERT(__sizeof__RDMA_HDR_WQE, sizeof (RDMA_HDR_WQE) == 32);

   #else
      typedef struct _RDMA_HDR_WQE {
         u32 curr_offset;                         // DWORD 0
         u32 remote_stag;                         // DWORD 1
         u32 opcode : 8;                          // DWORD 2
         u32 flags : 16;                          // DWORD 2
         u32 sge_count : 8;                       // DWORD 2
         u32 rsvd0[1];                            // DWORDS 3 to 3
         u32 stag;                                // DWORD 4
         u32 len;                                 // DWORD 5
         u32 addr_lo;                             // DWORD 6
         u32 addr_hi;                             // DWORD 7
      } SG_PACK RDMA_HDR_WQE, *PRDMA_HDR_WQE;

      typedef union _RDMA_HDR_WQE_UNION {
         RDMA_HDR_WQE bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_HDR_WQE_UNION, *PRDMA_HDR_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HDR_WQE_UNION, sizeof (RDMA_HDR_WQE_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_ORRJ {
         union {
            struct { 
               u32 orrj_start_seq_num;            // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 1
               u32 read_req_only : 1;             // DWORD 1
               u32 event : 1;                     // DWORD 1
               u32 orrj_wqe_index : 14;           // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_ORRJ, *PRDMA_ORRJ;

      SG_C_ASSERT(__sizeof__RDMA_ORRJ, sizeof (RDMA_ORRJ) == 8);

   #else
      typedef struct _RDMA_ORRJ {
         u32 orrj_start_seq_num;                  // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 1
         u32 read_req_only : 1;                   // DWORD 1
         u32 event : 1;                           // DWORD 1
         u32 orrj_wqe_index : 14;                 // DWORD 1
      } SG_PACK RDMA_ORRJ, *PRDMA_ORRJ;

      typedef union _RDMA_ORRJ_UNION {
         RDMA_ORRJ bits;
         u32 dw[2]; // dword union
      } SG_PACK RDMA_ORRJ_UNION, *PRDMA_ORRJ_UNION;

      SG_C_ASSERT(__sizeof__RDMA_ORRJ_UNION, sizeof (RDMA_ORRJ_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_ORRJ {
         union {
            struct { 
               u32 orrj_start_seq_num;            // DWORD 0
               u32 orrj_wqe_index : 14;           // DWORD 1
               u32 event : 1;                     // DWORD 1
               u32 read_req_only : 1;             // DWORD 1
               u32 rsvd0 : 16;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_ORRJ, *PRDMA_ORRJ;

      SG_C_ASSERT(__sizeof__RDMA_ORRJ, sizeof (RDMA_ORRJ) == 8);

   #else
      typedef struct _RDMA_ORRJ {
         u32 orrj_start_seq_num;                  // DWORD 0
         u32 orrj_wqe_index : 14;                 // DWORD 1
         u32 event : 1;                           // DWORD 1
         u32 read_req_only : 1;                   // DWORD 1
         u32 rsvd0 : 16;                          // DWORD 1
      } SG_PACK RDMA_ORRJ, *PRDMA_ORRJ;

      typedef union _RDMA_ORRJ_UNION {
         RDMA_ORRJ bits;
         u32 dw[2]; // dword union
      } SG_PACK RDMA_ORRJ_UNION, *PRDMA_ORRJ_UNION;

      SG_C_ASSERT(__sizeof__RDMA_ORRJ_UNION, sizeof (RDMA_ORRJ_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RRSQ_ENTRY {
         union {
            struct { 
               u32 read_resp_seq_no;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RRSQ_ENTRY, *PRDMA_RRSQ_ENTRY;

      SG_C_ASSERT(__sizeof__RDMA_RRSQ_ENTRY, sizeof (RDMA_RRSQ_ENTRY) == 4);

   #else
      typedef struct _RDMA_RRSQ_ENTRY {
         u32 read_resp_seq_no;                    // DWORD 0
      } SG_PACK RDMA_RRSQ_ENTRY, *PRDMA_RRSQ_ENTRY;

      typedef union _RDMA_RRSQ_ENTRY_UNION {
         RDMA_RRSQ_ENTRY bits;
         u32 dw; // dword union
      } SG_PACK RDMA_RRSQ_ENTRY_UNION, *PRDMA_RRSQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RRSQ_ENTRY_UNION, sizeof (RDMA_RRSQ_ENTRY_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RRSQ_ENTRY {
         union {
            struct { 
               u32 read_resp_seq_no;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RRSQ_ENTRY, *PRDMA_RRSQ_ENTRY;

      SG_C_ASSERT(__sizeof__RDMA_RRSQ_ENTRY, sizeof (RDMA_RRSQ_ENTRY) == 4);

   #else
      typedef struct _RDMA_RRSQ_ENTRY {
         u32 read_resp_seq_no;                    // DWORD 0
      } SG_PACK RDMA_RRSQ_ENTRY, *PRDMA_RRSQ_ENTRY;

      typedef union _RDMA_RRSQ_ENTRY_UNION {
         RDMA_RRSQ_ENTRY bits;
         u32 dw; // dword union
      } SG_PACK RDMA_RRSQ_ENTRY_UNION, *PRDMA_RRSQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RRSQ_ENTRY_UNION, sizeof (RDMA_RRSQ_ENTRY_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Context control structures for RDMA ORRJ (4 Entries of 8 bytes) + RDMA RRSQ (4
   // Entries of 4 bytes each)
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RD_JRNLS {
         union {
            struct { 
               RDMA_ORRJ orrj[4];
               RDMA_RRSQ_ENTRY rrsq[4];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RD_JRNLS, *PRDMA_RD_JRNLS;

      SG_C_ASSERT(__sizeof__RDMA_RD_JRNLS, sizeof (RDMA_RD_JRNLS) == 48);

   #else
      typedef struct _RDMA_RD_JRNLS {
         RDMA_ORRJ orrj[4];
         RDMA_RRSQ_ENTRY rrsq[4];
      } SG_PACK RDMA_RD_JRNLS, *PRDMA_RD_JRNLS;

      typedef union _RDMA_RD_JRNLS_UNION {
         RDMA_RD_JRNLS bits;
         u32 dw[12]; // dword union
      } SG_PACK RDMA_RD_JRNLS_UNION, *PRDMA_RD_JRNLS_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RD_JRNLS_UNION, sizeof (RDMA_RD_JRNLS_UNION) == 48);
   #endif


#else
   // Context control structures for RDMA ORRJ (4 Entries of 8 bytes) + RDMA RRSQ (4
   // Entries of 4 bytes each)
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RD_JRNLS {
         union {
            struct { 
               RDMA_ORRJ orrj[4];
               RDMA_RRSQ_ENTRY rrsq[4];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RD_JRNLS, *PRDMA_RD_JRNLS;

      SG_C_ASSERT(__sizeof__RDMA_RD_JRNLS, sizeof (RDMA_RD_JRNLS) == 48);

   #else
      typedef struct _RDMA_RD_JRNLS {
         RDMA_ORRJ orrj[4];
         RDMA_RRSQ_ENTRY rrsq[4];
      } SG_PACK RDMA_RD_JRNLS, *PRDMA_RD_JRNLS;

      typedef union _RDMA_RD_JRNLS_UNION {
         RDMA_RD_JRNLS bits;
         u32 dw[12]; // dword union
      } SG_PACK RDMA_RD_JRNLS_UNION, *PRDMA_RD_JRNLS_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RD_JRNLS_UNION, sizeof (RDMA_RD_JRNLS_UNION) == 48);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __rdma_context_bmap_h__

