/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __tcp_context_bmap_h__
#define __tcp_context_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "headers_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // TCP connection context structure  Colour codes used for TCP_CONTEXT  - Light green :
   // These fields are modified by TPRE and accessed by timer, Tcp scheduler or window
   // update HW logic.  - Green : These fields are modified and used only by TPRE
   // firmware.  - Dark green : These fields are constants which do not change through out
   // the life time of the connection.  - Light blue : These fields are modified by TPOST
   // and accessed by hardware blocks.  - Blue : These fields are modified and used only
   // by TPOST firmware.  - Dark blue : These fields are constants which do not change
   // through out the life time of the connection. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_CONTEXT {
         union {
            struct { 
               u32 snd_max;                       // DWORD 0
               u32 snd_nxt;                       // DWORD 1
               u32 t_rxtshift : 4;                // DWORD 2
               u32 in_rxmt : 1;                   // DWORD 2
               u32 templ_hdr_in_ddr : 1;          // DWORD 2
               u32 journal_in_ddr : 1;            // DWORD 2
               u32 rxmt_ctr_snap : 5;             // DWORD 2
               u32 t_flags : 12;                  // DWORD 2
               u32 t_state : 8;                   // DWORD 2
               u32 last_ack_sent;                 // DWORD 3
               u32 tcp_rtts;                      // DWORD 4
               u32 t_rtseq;                       // DWORD 5
               u32 persist_cnt : 7;               // DWORD 6
               u32 rexmt_cnt : 4;                 // DWORD 6
               u32 rxmt_ctr : 5;                  // DWORD 6
               u32 ka_interval : 8;               // DWORD 6
               u32 ka_probe_max : 4;              // DWORD 6
               u32 ka_probe_cnt : 4;              // DWORD 6
               u32 last_wnd_update_sent;          // DWORD 7
               u32 ka_timeout : 11;               // DWORD 8
               u32 is_ipv6 : 1;                   // DWORD 8
               u32 timers_cleared : 1;            // DWORD 8
               u32 max_rt : 8;                    // DWORD 8
               u32 hdr_len : 7;                   // DWORD 8
               u32 ulp_id : 2;                    // DWORD 8
               u32 port_id1 : 2;                  // DWORD 8
               u32 rcv_last;                      // DWORD 9
               u32 persist_tmr : 8;               // DWORD 10
               u32 ka_interval_tmr : 8;           // DWORD 10
               u32 txidle_tmr : 8;                // DWORD 10
               u32 rexmt_tmr : 8;                 // DWORD 10
               u32 ka_tmr : 8;                    // DWORD 11
               u32 finwait2_tmr : 8;              // DWORD 11
               u32 delack_tmr : 8;                // DWORD 11
               u32 push_tmr : 8;                  // DWORD 11
               u32 rcv_nxt;                       // DWORD 12
               u32 ts_delta;                      // DWORD 13
               u32 tcp_vlan_id : 16;              // DWORD 14
               u32 cid : 16;                      // DWORD 14
               u32 recover;                       // DWORD 15
               u32 ts_recent_age;                 // DWORD 16
               u32 num_valid_holes : 2;           // DWORD 17
               u32 tpre_uploading : 1;            // DWORD 17
               u32 sack_blocks_count : 2;         // DWORD 17
               u32 cap_flags : 9;                 // DWORD 17
               u32 rcv_scale : 5;                 // DWORD 17
               u32 snd_scale : 5;                 // DWORD 17
               u32 ka_cnt : 8;                    // DWORD 17
               u32 t_dupacks : 8;                 // DWORD 18
               u32 pci_func : 4;                  // DWORD 18
               u32 delack_count : 4;              // DWORD 18
               u32 max_sndwnd : 16;               // DWORD 18
               u32 ts_recent;                     // DWORD 19
               u32 snd_una;                       // DWORD 20
               u32 rx_flags : 8;                  // DWORD 21
               u32 rx_state : 4;                  // DWORD 21
               u32 t_dupacks2 : 2;                // DWORD 21
               u32 port_id : 2;                   // DWORD 21
               u32 t_maxseg : 16;                 // DWORD 21
               u32 snd_cwnd;                      // DWORD 22
               u32 snd_last;                      // DWORD 23
               u32 rcv_ooend;                     // DWORD 24
               u32 rcv_oostart;                   // DWORD 25
               u32 ooo_rst : 1;                   // DWORD 26
               u32 pd_id : 6;                     // DWORD 26
               u32 jfree_outstanding : 4;         // DWORD 26
               u32 rx_rxmt_ctr : 5;               // DWORD 26
               u32 t_rtt_delta : 16;              // DWORD 26
               u32 bytes_acked;                   // DWORD 27
               u32 saved_una;                     // DWORD 28
               u32 t_rttvar : 16;                 // DWORD 29
               u32 t_srtt : 16;                   // DWORD 29
               u32 snd_wl1;                       // DWORD 30
               u32 snd_ssthresh;                  // DWORD 31
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK TCP_CONTEXT, *PTCP_CONTEXT;

      SG_C_ASSERT(__sizeof__TCP_CONTEXT, sizeof (TCP_CONTEXT) == 128);

   #else
      typedef struct _TCP_CONTEXT {
         u32 snd_max;                             // DWORD 0
         u32 snd_nxt;                             // DWORD 1
         u32 t_rxtshift : 4;                      // DWORD 2
         u32 in_rxmt : 1;                         // DWORD 2
         u32 templ_hdr_in_ddr : 1;                // DWORD 2
         u32 journal_in_ddr : 1;                  // DWORD 2
         u32 rxmt_ctr_snap : 5;                   // DWORD 2
         u32 t_flags : 12;                        // DWORD 2
         u32 t_state : 8;                         // DWORD 2
         u32 last_ack_sent;                       // DWORD 3
         u32 tcp_rtts;                            // DWORD 4
         u32 t_rtseq;                             // DWORD 5
         u32 persist_cnt : 7;                     // DWORD 6
         u32 rexmt_cnt : 4;                       // DWORD 6
         u32 rxmt_ctr : 5;                        // DWORD 6
         u32 ka_interval : 8;                     // DWORD 6
         u32 ka_probe_max : 4;                    // DWORD 6
         u32 ka_probe_cnt : 4;                    // DWORD 6
         u32 last_wnd_update_sent;                // DWORD 7
         u32 ka_timeout : 11;                     // DWORD 8
         u32 is_ipv6 : 1;                         // DWORD 8
         u32 timers_cleared : 1;                  // DWORD 8
         u32 max_rt : 8;                          // DWORD 8
         u32 hdr_len : 7;                         // DWORD 8
         u32 ulp_id : 2;                          // DWORD 8
         u32 port_id1 : 2;                        // DWORD 8
         u32 rcv_last;                            // DWORD 9
         u32 persist_tmr : 8;                     // DWORD 10
         u32 ka_interval_tmr : 8;                 // DWORD 10
         u32 txidle_tmr : 8;                      // DWORD 10
         u32 rexmt_tmr : 8;                       // DWORD 10
         u32 ka_tmr : 8;                          // DWORD 11
         u32 finwait2_tmr : 8;                    // DWORD 11
         u32 delack_tmr : 8;                      // DWORD 11
         u32 push_tmr : 8;                        // DWORD 11
         u32 rcv_nxt;                             // DWORD 12
         u32 ts_delta;                            // DWORD 13
         u32 tcp_vlan_id : 16;                    // DWORD 14
         u32 cid : 16;                            // DWORD 14
         u32 recover;                             // DWORD 15
         u32 ts_recent_age;                       // DWORD 16
         u32 num_valid_holes : 2;                 // DWORD 17
         u32 tpre_uploading : 1;                  // DWORD 17
         u32 sack_blocks_count : 2;               // DWORD 17
         u32 cap_flags : 9;                       // DWORD 17
         u32 rcv_scale : 5;                       // DWORD 17
         u32 snd_scale : 5;                       // DWORD 17
         u32 ka_cnt : 8;                          // DWORD 17
         u32 t_dupacks : 8;                       // DWORD 18
         u32 pci_func : 4;                        // DWORD 18
         u32 delack_count : 4;                    // DWORD 18
         u32 max_sndwnd : 16;                     // DWORD 18
         u32 ts_recent;                           // DWORD 19
         u32 snd_una;                             // DWORD 20
         u32 rx_flags : 8;                        // DWORD 21
         u32 rx_state : 4;                        // DWORD 21
         u32 t_dupacks2 : 2;                      // DWORD 21
         u32 port_id : 2;                         // DWORD 21
         u32 t_maxseg : 16;                       // DWORD 21
         u32 snd_cwnd;                            // DWORD 22
         u32 snd_last;                            // DWORD 23
         u32 rcv_ooend;                           // DWORD 24
         u32 rcv_oostart;                         // DWORD 25
         u32 ooo_rst : 1;                         // DWORD 26
         u32 pd_id : 6;                           // DWORD 26
         u32 jfree_outstanding : 4;               // DWORD 26
         u32 rx_rxmt_ctr : 5;                     // DWORD 26
         u32 t_rtt_delta : 16;                    // DWORD 26
         u32 bytes_acked;                         // DWORD 27
         u32 saved_una;                           // DWORD 28
         u32 t_rttvar : 16;                       // DWORD 29
         u32 t_srtt : 16;                         // DWORD 29
         u32 snd_wl1;                             // DWORD 30
         u32 snd_ssthresh;                        // DWORD 31
      } SG_PACK TCP_CONTEXT, *PTCP_CONTEXT;

      typedef union _TCP_CONTEXT_UNION {
         TCP_CONTEXT bits;
         u32 dw[32]; // dword union
      } SG_PACK TCP_CONTEXT_UNION, *PTCP_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__TCP_CONTEXT_UNION, sizeof (TCP_CONTEXT_UNION) == 128);
   #endif


#else
   // TCP connection context structure  Colour codes used for TCP_CONTEXT  - Light green :
   // These fields are modified by TPRE and accessed by timer, Tcp scheduler or window
   // update HW logic.  - Green : These fields are modified and used only by TPRE
   // firmware.  - Dark green : These fields are constants which do not change through out
   // the life time of the connection.  - Light blue : These fields are modified by TPOST
   // and accessed by hardware blocks.  - Blue : These fields are modified and used only
   // by TPOST firmware.  - Dark blue : These fields are constants which do not change
   // through out the life time of the connection. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_CONTEXT {
         union {
            struct { 
               u32 snd_max;                       // DWORD 0
               u32 snd_nxt;                       // DWORD 1
               u32 t_state : 8;                   // DWORD 2
               u32 t_flags : 12;                  // DWORD 2
               u32 rxmt_ctr_snap : 5;             // DWORD 2
               u32 journal_in_ddr : 1;            // DWORD 2
               u32 templ_hdr_in_ddr : 1;          // DWORD 2
               u32 in_rxmt : 1;                   // DWORD 2
               u32 t_rxtshift : 4;                // DWORD 2
               u32 last_ack_sent;                 // DWORD 3
               u32 tcp_rtts;                      // DWORD 4
               u32 t_rtseq;                       // DWORD 5
               u32 ka_probe_cnt : 4;              // DWORD 6
               u32 ka_probe_max : 4;              // DWORD 6
               u32 ka_interval : 8;               // DWORD 6
               u32 rxmt_ctr : 5;                  // DWORD 6
               u32 rexmt_cnt : 4;                 // DWORD 6
               u32 persist_cnt : 7;               // DWORD 6
               u32 last_wnd_update_sent;          // DWORD 7
               u32 port_id1 : 2;                  // DWORD 8
               u32 ulp_id : 2;                    // DWORD 8
               u32 hdr_len : 7;                   // DWORD 8
               u32 max_rt : 8;                    // DWORD 8
               u32 timers_cleared : 1;            // DWORD 8
               u32 is_ipv6 : 1;                   // DWORD 8
               u32 ka_timeout : 11;               // DWORD 8
               u32 rcv_last;                      // DWORD 9
               u32 rexmt_tmr : 8;                 // DWORD 10
               u32 txidle_tmr : 8;                // DWORD 10
               u32 ka_interval_tmr : 8;           // DWORD 10
               u32 persist_tmr : 8;               // DWORD 10
               u32 push_tmr : 8;                  // DWORD 11
               u32 delack_tmr : 8;                // DWORD 11
               u32 finwait2_tmr : 8;              // DWORD 11
               u32 ka_tmr : 8;                    // DWORD 11
               u32 rcv_nxt;                       // DWORD 12
               u32 ts_delta;                      // DWORD 13
               u32 cid : 16;                      // DWORD 14
               u32 tcp_vlan_id : 16;              // DWORD 14
               u32 recover;                       // DWORD 15
               u32 ts_recent_age;                 // DWORD 16
               u32 ka_cnt : 8;                    // DWORD 17
               u32 snd_scale : 5;                 // DWORD 17
               u32 rcv_scale : 5;                 // DWORD 17
               u32 cap_flags : 9;                 // DWORD 17
               u32 sack_blocks_count : 2;         // DWORD 17
               u32 tpre_uploading : 1;            // DWORD 17
               u32 num_valid_holes : 2;           // DWORD 17
               u32 max_sndwnd : 16;               // DWORD 18
               u32 delack_count : 4;              // DWORD 18
               u32 pci_func : 4;                  // DWORD 18
               u32 t_dupacks : 8;                 // DWORD 18
               u32 ts_recent;                     // DWORD 19
               u32 snd_una;                       // DWORD 20
               u32 t_maxseg : 16;                 // DWORD 21
               u32 port_id : 2;                   // DWORD 21
               u32 t_dupacks2 : 2;                // DWORD 21
               u32 rx_state : 4;                  // DWORD 21
               u32 rx_flags : 8;                  // DWORD 21
               u32 snd_cwnd;                      // DWORD 22
               u32 snd_last;                      // DWORD 23
               u32 rcv_ooend;                     // DWORD 24
               u32 rcv_oostart;                   // DWORD 25
               u32 t_rtt_delta : 16;              // DWORD 26
               u32 rx_rxmt_ctr : 5;               // DWORD 26
               u32 jfree_outstanding : 4;         // DWORD 26
               u32 pd_id : 6;                     // DWORD 26
               u32 ooo_rst : 1;                   // DWORD 26
               u32 bytes_acked;                   // DWORD 27
               u32 saved_una;                     // DWORD 28
               u32 t_srtt : 16;                   // DWORD 29
               u32 t_rttvar : 16;                 // DWORD 29
               u32 snd_wl1;                       // DWORD 30
               u32 snd_ssthresh;                  // DWORD 31
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK TCP_CONTEXT, *PTCP_CONTEXT;

      SG_C_ASSERT(__sizeof__TCP_CONTEXT, sizeof (TCP_CONTEXT) == 128);

   #else
      typedef struct _TCP_CONTEXT {
         u32 snd_max;                             // DWORD 0
         u32 snd_nxt;                             // DWORD 1
         u32 t_state : 8;                         // DWORD 2
         u32 t_flags : 12;                        // DWORD 2
         u32 rxmt_ctr_snap : 5;                   // DWORD 2
         u32 journal_in_ddr : 1;                  // DWORD 2
         u32 templ_hdr_in_ddr : 1;                // DWORD 2
         u32 in_rxmt : 1;                         // DWORD 2
         u32 t_rxtshift : 4;                      // DWORD 2
         u32 last_ack_sent;                       // DWORD 3
         u32 tcp_rtts;                            // DWORD 4
         u32 t_rtseq;                             // DWORD 5
         u32 ka_probe_cnt : 4;                    // DWORD 6
         u32 ka_probe_max : 4;                    // DWORD 6
         u32 ka_interval : 8;                     // DWORD 6
         u32 rxmt_ctr : 5;                        // DWORD 6
         u32 rexmt_cnt : 4;                       // DWORD 6
         u32 persist_cnt : 7;                     // DWORD 6
         u32 last_wnd_update_sent;                // DWORD 7
         u32 port_id1 : 2;                        // DWORD 8
         u32 ulp_id : 2;                          // DWORD 8
         u32 hdr_len : 7;                         // DWORD 8
         u32 max_rt : 8;                          // DWORD 8
         u32 timers_cleared : 1;                  // DWORD 8
         u32 is_ipv6 : 1;                         // DWORD 8
         u32 ka_timeout : 11;                     // DWORD 8
         u32 rcv_last;                            // DWORD 9
         u32 rexmt_tmr : 8;                       // DWORD 10
         u32 txidle_tmr : 8;                      // DWORD 10
         u32 ka_interval_tmr : 8;                 // DWORD 10
         u32 persist_tmr : 8;                     // DWORD 10
         u32 push_tmr : 8;                        // DWORD 11
         u32 delack_tmr : 8;                      // DWORD 11
         u32 finwait2_tmr : 8;                    // DWORD 11
         u32 ka_tmr : 8;                          // DWORD 11
         u32 rcv_nxt;                             // DWORD 12
         u32 ts_delta;                            // DWORD 13
         u32 cid : 16;                            // DWORD 14
         u32 tcp_vlan_id : 16;                    // DWORD 14
         u32 recover;                             // DWORD 15
         u32 ts_recent_age;                       // DWORD 16
         u32 ka_cnt : 8;                          // DWORD 17
         u32 snd_scale : 5;                       // DWORD 17
         u32 rcv_scale : 5;                       // DWORD 17
         u32 cap_flags : 9;                       // DWORD 17
         u32 sack_blocks_count : 2;               // DWORD 17
         u32 tpre_uploading : 1;                  // DWORD 17
         u32 num_valid_holes : 2;                 // DWORD 17
         u32 max_sndwnd : 16;                     // DWORD 18
         u32 delack_count : 4;                    // DWORD 18
         u32 pci_func : 4;                        // DWORD 18
         u32 t_dupacks : 8;                       // DWORD 18
         u32 ts_recent;                           // DWORD 19
         u32 snd_una;                             // DWORD 20
         u32 t_maxseg : 16;                       // DWORD 21
         u32 port_id : 2;                         // DWORD 21
         u32 t_dupacks2 : 2;                      // DWORD 21
         u32 rx_state : 4;                        // DWORD 21
         u32 rx_flags : 8;                        // DWORD 21
         u32 snd_cwnd;                            // DWORD 22
         u32 snd_last;                            // DWORD 23
         u32 rcv_ooend;                           // DWORD 24
         u32 rcv_oostart;                         // DWORD 25
         u32 t_rtt_delta : 16;                    // DWORD 26
         u32 rx_rxmt_ctr : 5;                     // DWORD 26
         u32 jfree_outstanding : 4;               // DWORD 26
         u32 pd_id : 6;                           // DWORD 26
         u32 ooo_rst : 1;                         // DWORD 26
         u32 bytes_acked;                         // DWORD 27
         u32 saved_una;                           // DWORD 28
         u32 t_srtt : 16;                         // DWORD 29
         u32 t_rttvar : 16;                       // DWORD 29
         u32 snd_wl1;                             // DWORD 30
         u32 snd_ssthresh;                        // DWORD 31
      } SG_PACK TCP_CONTEXT, *PTCP_CONTEXT;

      typedef union _TCP_CONTEXT_UNION {
         TCP_CONTEXT bits;
         u32 dw[32]; // dword union
      } SG_PACK TCP_CONTEXT_UNION, *PTCP_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__TCP_CONTEXT_UNION, sizeof (TCP_CONTEXT_UNION) == 128);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __tcp_context_bmap_h__

