/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __tcp_sack_bmap_h__
#define __tcp_sack_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "headers_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SACK {
         union {
            struct { 
               u32 seq_num;                       // DWORD 0
               u32 valid : 1;                     // DWORD 1
               u32 len : 31;                      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SACK, *PSACK;

      SG_C_ASSERT(__sizeof__SACK, sizeof (SACK) == 8);

   #else
      typedef struct _SACK {
         u32 seq_num;                             // DWORD 0
         u32 valid : 1;                           // DWORD 1
         u32 len : 31;                            // DWORD 1
      } SG_PACK SACK, *PSACK;

      typedef union _SACK_UNION {
         SACK bits;
         u32 dw[2]; // dword union
      } SG_PACK SACK_UNION, *PSACK_UNION;

      SG_C_ASSERT(__sizeof__SACK_UNION, sizeof (SACK_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SACK {
         union {
            struct { 
               u32 seq_num;                       // DWORD 0
               u32 len : 31;                      // DWORD 1
               u32 valid : 1;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SACK, *PSACK;

      SG_C_ASSERT(__sizeof__SACK, sizeof (SACK) == 8);

   #else
      typedef struct _SACK {
         u32 seq_num;                             // DWORD 0
         u32 len : 31;                            // DWORD 1
         u32 valid : 1;                           // DWORD 1
      } SG_PACK SACK, *PSACK;

      typedef union _SACK_UNION {
         SACK bits;
         u32 dw[2]; // dword union
      } SG_PACK SACK_UNION, *PSACK_UNION;

      SG_C_ASSERT(__sizeof__SACK_UNION, sizeof (SACK_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This area stores the SACK blocks in the received segments. These will be used by
   // txulp during re-transmit.. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SACK_BLOCKS {
         union {
            struct { 
               SACK sack_block[4];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK SACK_BLOCKS, *PSACK_BLOCKS;

      SG_C_ASSERT(__sizeof__SACK_BLOCKS, sizeof (SACK_BLOCKS) == 32);

   #else
      typedef struct _SACK_BLOCKS {
         SACK sack_block[4];
      } SG_PACK SACK_BLOCKS, *PSACK_BLOCKS;

      typedef union _SACK_BLOCKS_UNION {
         SACK_BLOCKS bits;
         u32 dw[8]; // dword union
      } SG_PACK SACK_BLOCKS_UNION, *PSACK_BLOCKS_UNION;

      SG_C_ASSERT(__sizeof__SACK_BLOCKS_UNION, sizeof (SACK_BLOCKS_UNION) == 32);
   #endif


#else
   // This area stores the SACK blocks in the received segments. These will be used by
   // txulp during re-transmit.. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SACK_BLOCKS {
         union {
            struct { 
               SACK sack_block[4];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK SACK_BLOCKS, *PSACK_BLOCKS;

      SG_C_ASSERT(__sizeof__SACK_BLOCKS, sizeof (SACK_BLOCKS) == 32);

   #else
      typedef struct _SACK_BLOCKS {
         SACK sack_block[4];
      } SG_PACK SACK_BLOCKS, *PSACK_BLOCKS;

      typedef union _SACK_BLOCKS_UNION {
         SACK_BLOCKS bits;
         u32 dw[8]; // dword union
      } SG_PACK SACK_BLOCKS_UNION, *PSACK_BLOCKS_UNION;

      SG_C_ASSERT(__sizeof__SACK_BLOCKS_UNION, sizeof (SACK_BLOCKS_UNION) == 32);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __tcp_sack_bmap_h__

