/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __tpre_exp_bmap_h__
#define __tpre_exp_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TPRE_FUNC_STATS {
         union {
            struct { 
               u32 ipv4_rx_bytes[8];              // DWORDS 0 to 7
               u32 ipv6_rx_bytes[8];              // DWORDS 8 to 15
               u32 ipv4_rx_frames[8];             // DWORDS 16 to 23
               u32 ipv6_rx_frames[8];             // DWORDS 24 to 31
               u32 rx_window_probes[8];           // DWORDS 32 to 39
               u32 rx_window_updates[8];          // DWORDS 40 to 47
               u32 rxmit_timeouts[8];             // DWORDS 48 to 55
               u32 ooo_packets[8];                // DWORDS 56 to 63
               u32 delayed_acks_sent[8];          // DWORDS 64 to 71
               u32 rx_acks[8];                    // DWORDS 72 to 79
               u32 rx_duplicate_acks[8];          // DWORDS 80 to 87
               u32 ipv4_drops[8];                 // DWORDS 88 to 95
               u32 ipv6_drops[8];                 // DWORDS 96 to 103
               u32 duplicate_rx_bytes;            // DWORD 104
               u32 partial_duplicate_rx_bytes;    // DWORD 105
               u32 bytes_after_window;            // DWORD 106
               u32 rx_prediction_segments;        // DWORD 107
               u32 cam_bug_drops;                 // DWORD 108
               u32 rx_dup_frames;                 // DWORD 109
               u32 paws_drops;                    // DWORD 110
               u32 rx_partial_duplicate_frames;   // DWORD 111
               u32 packets_after_window;          // DWORD 112
               u32 buffer_credit_drops;           // DWORD 113
               u32 rx_ack_too_much;               // DWORD 114
               u32 timeout_drops;                 // DWORD 115
               u32 ooo_disable_drops;             // DWORD 116
               u32 ooo_prepend_drops;             // DWORD 117
               u32 ooo_tt_replay_drops;           // DWORD 118
               u32 fast_retransmits;              // DWORD 119
               u32 syn_in_window;                 // DWORD 120
               u32 state_changes;                 // DWORD 121
               u32 tt_data_pack;                  // DWORD 122
               u32 tt_data_bytes;                 // DWORD 123
               u32 p0_immack_queue_full;          // DWORD 124
               u32 p1_immack_queue_full;          // DWORD 125
               u32 immacks;                       // DWORD 126
               u32 dbcred_return;                 // DWORD 127
               u32 rx_ack_too_old;                // DWORD 128
               u32 rxmt_complete;                 // DWORD 129
               u32 tcp_flush;                     // DWORD 130
               u32 tcp_update_ipc_cnt;            // DWORD 131
               u32 lro_red_discard_count;         // DWORD 132
               u32 lro_credit_discard_count;      // DWORD 133
               u32 lro_packet_count;              // DWORD 134
               u32 lro_singleton_count;           // DWORD 135
               u32 lro_chain_count;               // DWORD 136
               u32 lro_chainbreak_timeout;        // DWORD 137
               u32 lro_chainbreak_maxlen;         // DWORD 138
               u32 lro_chainbreak_maxpkts;        // DWORD 139
               u32 lro_chainbreak_singleton;      // DWORD 140
               u32 lro_chainbreak_collision;      // DWORD 141
               u32 lro_chainbreak_ooo;            // DWORD 142
               u32 lro_flush_count;               // DWORD 143
               u32 tpre_int_debug_stat_1;         // DWORD 144
               u32 tpre_int_debug_stat_2;         // DWORD 145
               u32 tpre_int_debug_stat_3;         // DWORD 146
               u32 tpre_int_debug_stat_4;         // DWORD 147
               u32 p0_rx_bytes;                   // DWORD 148
               u32 p1_rx_bytes;                   // DWORD 149
               u32 p0_rx_frames;                  // DWORD 150
               u32 p1_rx_frames;                  // DWORD 151
               u32 p0_rx_sequences;               // DWORD 152
               u32 p1_rx_sequences;               // DWORD 153
               u32 p0_XON_xmit_count;             // DWORD 154
               u32 p1_XON_xmit_count;             // DWORD 155
               u32 p0_XOFF_xmit_count;            // DWORD 156
               u32 p1_XOFF_xmit_count;            // DWORD 157
               u32 p0_XON_timer_pops;             // DWORD 158
               u32 p1_XON_timer_pops;             // DWORD 159
               u32 p0_EOFni_count;                // DWORD 160
               u32 p1_EOFni_count;                // DWORD 161
               u32 p0_EOFa_count;                 // DWORD 162
               u32 p1_EOFa_count;                 // DWORD 163
               u32 frame_type_count[13];          // DWORDS 164 to 176
               u32 frame_discard_count[8];        // DWORDS 177 to 184
               u32 rsvd0[7];                      // DWORDS 185 to 191
            } SG_PACK ; // unnamed struct
            u32 dw[192]; // dword union
         }; // unnamed union
      } SG_PACK BE_TPRE_FUNC_STATS, *PBE_TPRE_FUNC_STATS;

      SG_C_ASSERT(__sizeof__BE_TPRE_FUNC_STATS, sizeof (BE_TPRE_FUNC_STATS) == 768);

   #else
      typedef struct _BE_TPRE_FUNC_STATS {
         u32 ipv4_rx_bytes[8];                    // DWORDS 0 to 7
         u32 ipv6_rx_bytes[8];                    // DWORDS 8 to 15
         u32 ipv4_rx_frames[8];                   // DWORDS 16 to 23
         u32 ipv6_rx_frames[8];                   // DWORDS 24 to 31
         u32 rx_window_probes[8];                 // DWORDS 32 to 39
         u32 rx_window_updates[8];                // DWORDS 40 to 47
         u32 rxmit_timeouts[8];                   // DWORDS 48 to 55
         u32 ooo_packets[8];                      // DWORDS 56 to 63
         u32 delayed_acks_sent[8];                // DWORDS 64 to 71
         u32 rx_acks[8];                          // DWORDS 72 to 79
         u32 rx_duplicate_acks[8];                // DWORDS 80 to 87
         u32 ipv4_drops[8];                       // DWORDS 88 to 95
         u32 ipv6_drops[8];                       // DWORDS 96 to 103
         u32 duplicate_rx_bytes;                  // DWORD 104
         u32 partial_duplicate_rx_bytes;          // DWORD 105
         u32 bytes_after_window;                  // DWORD 106
         u32 rx_prediction_segments;              // DWORD 107
         u32 cam_bug_drops;                       // DWORD 108
         u32 rx_dup_frames;                       // DWORD 109
         u32 paws_drops;                          // DWORD 110
         u32 rx_partial_duplicate_frames;         // DWORD 111
         u32 packets_after_window;                // DWORD 112
         u32 buffer_credit_drops;                 // DWORD 113
         u32 rx_ack_too_much;                     // DWORD 114
         u32 timeout_drops;                       // DWORD 115
         u32 ooo_disable_drops;                   // DWORD 116
         u32 ooo_prepend_drops;                   // DWORD 117
         u32 ooo_tt_replay_drops;                 // DWORD 118
         u32 fast_retransmits;                    // DWORD 119
         u32 syn_in_window;                       // DWORD 120
         u32 state_changes;                       // DWORD 121
         u32 tt_data_pack;                        // DWORD 122
         u32 tt_data_bytes;                       // DWORD 123
         u32 p0_immack_queue_full;                // DWORD 124
         u32 p1_immack_queue_full;                // DWORD 125
         u32 immacks;                             // DWORD 126
         u32 dbcred_return;                       // DWORD 127
         u32 rx_ack_too_old;                      // DWORD 128
         u32 rxmt_complete;                       // DWORD 129
         u32 tcp_flush;                           // DWORD 130
         u32 tcp_update_ipc_cnt;                  // DWORD 131
         u32 lro_red_discard_count;               // DWORD 132
         u32 lro_credit_discard_count;            // DWORD 133
         u32 lro_packet_count;                    // DWORD 134
         u32 lro_singleton_count;                 // DWORD 135
         u32 lro_chain_count;                     // DWORD 136
         u32 lro_chainbreak_timeout;              // DWORD 137
         u32 lro_chainbreak_maxlen;               // DWORD 138
         u32 lro_chainbreak_maxpkts;              // DWORD 139
         u32 lro_chainbreak_singleton;            // DWORD 140
         u32 lro_chainbreak_collision;            // DWORD 141
         u32 lro_chainbreak_ooo;                  // DWORD 142
         u32 lro_flush_count;                     // DWORD 143
         u32 tpre_int_debug_stat_1;               // DWORD 144
         u32 tpre_int_debug_stat_2;               // DWORD 145
         u32 tpre_int_debug_stat_3;               // DWORD 146
         u32 tpre_int_debug_stat_4;               // DWORD 147
         u32 p0_rx_bytes;                         // DWORD 148
         u32 p1_rx_bytes;                         // DWORD 149
         u32 p0_rx_frames;                        // DWORD 150
         u32 p1_rx_frames;                        // DWORD 151
         u32 p0_rx_sequences;                     // DWORD 152
         u32 p1_rx_sequences;                     // DWORD 153
         u32 p0_XON_xmit_count;                   // DWORD 154
         u32 p1_XON_xmit_count;                   // DWORD 155
         u32 p0_XOFF_xmit_count;                  // DWORD 156
         u32 p1_XOFF_xmit_count;                  // DWORD 157
         u32 p0_XON_timer_pops;                   // DWORD 158
         u32 p1_XON_timer_pops;                   // DWORD 159
         u32 p0_EOFni_count;                      // DWORD 160
         u32 p1_EOFni_count;                      // DWORD 161
         u32 p0_EOFa_count;                       // DWORD 162
         u32 p1_EOFa_count;                       // DWORD 163
         u32 frame_type_count[13];                // DWORDS 164 to 176
         u32 frame_discard_count[8];              // DWORDS 177 to 184
         u32 rsvd0[7];                            // DWORDS 185 to 191
      } SG_PACK BE_TPRE_FUNC_STATS, *PBE_TPRE_FUNC_STATS;

      typedef union _BE_TPRE_FUNC_STATS_UNION {
         BE_TPRE_FUNC_STATS bits;
         u32 dw[192]; // dword union
      } SG_PACK BE_TPRE_FUNC_STATS_UNION, *PBE_TPRE_FUNC_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TPRE_FUNC_STATS_UNION, sizeof (BE_TPRE_FUNC_STATS_UNION) == 768);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TPRE_FUNC_STATS {
         union {
            struct { 
               u32 ipv4_rx_bytes[8];              // DWORDS 0 to 7
               u32 ipv6_rx_bytes[8];              // DWORDS 8 to 15
               u32 ipv4_rx_frames[8];             // DWORDS 16 to 23
               u32 ipv6_rx_frames[8];             // DWORDS 24 to 31
               u32 rx_window_probes[8];           // DWORDS 32 to 39
               u32 rx_window_updates[8];          // DWORDS 40 to 47
               u32 rxmit_timeouts[8];             // DWORDS 48 to 55
               u32 ooo_packets[8];                // DWORDS 56 to 63
               u32 delayed_acks_sent[8];          // DWORDS 64 to 71
               u32 rx_acks[8];                    // DWORDS 72 to 79
               u32 rx_duplicate_acks[8];          // DWORDS 80 to 87
               u32 ipv4_drops[8];                 // DWORDS 88 to 95
               u32 ipv6_drops[8];                 // DWORDS 96 to 103
               u32 duplicate_rx_bytes;            // DWORD 104
               u32 partial_duplicate_rx_bytes;    // DWORD 105
               u32 bytes_after_window;            // DWORD 106
               u32 rx_prediction_segments;        // DWORD 107
               u32 cam_bug_drops;                 // DWORD 108
               u32 rx_dup_frames;                 // DWORD 109
               u32 paws_drops;                    // DWORD 110
               u32 rx_partial_duplicate_frames;   // DWORD 111
               u32 packets_after_window;          // DWORD 112
               u32 buffer_credit_drops;           // DWORD 113
               u32 rx_ack_too_much;               // DWORD 114
               u32 timeout_drops;                 // DWORD 115
               u32 ooo_disable_drops;             // DWORD 116
               u32 ooo_prepend_drops;             // DWORD 117
               u32 ooo_tt_replay_drops;           // DWORD 118
               u32 fast_retransmits;              // DWORD 119
               u32 syn_in_window;                 // DWORD 120
               u32 state_changes;                 // DWORD 121
               u32 tt_data_pack;                  // DWORD 122
               u32 tt_data_bytes;                 // DWORD 123
               u32 p0_immack_queue_full;          // DWORD 124
               u32 p1_immack_queue_full;          // DWORD 125
               u32 immacks;                       // DWORD 126
               u32 dbcred_return;                 // DWORD 127
               u32 rx_ack_too_old;                // DWORD 128
               u32 rxmt_complete;                 // DWORD 129
               u32 tcp_flush;                     // DWORD 130
               u32 tcp_update_ipc_cnt;            // DWORD 131
               u32 lro_red_discard_count;         // DWORD 132
               u32 lro_credit_discard_count;      // DWORD 133
               u32 lro_packet_count;              // DWORD 134
               u32 lro_singleton_count;           // DWORD 135
               u32 lro_chain_count;               // DWORD 136
               u32 lro_chainbreak_timeout;        // DWORD 137
               u32 lro_chainbreak_maxlen;         // DWORD 138
               u32 lro_chainbreak_maxpkts;        // DWORD 139
               u32 lro_chainbreak_singleton;      // DWORD 140
               u32 lro_chainbreak_collision;      // DWORD 141
               u32 lro_chainbreak_ooo;            // DWORD 142
               u32 lro_flush_count;               // DWORD 143
               u32 tpre_int_debug_stat_1;         // DWORD 144
               u32 tpre_int_debug_stat_2;         // DWORD 145
               u32 tpre_int_debug_stat_3;         // DWORD 146
               u32 tpre_int_debug_stat_4;         // DWORD 147
               u32 p0_rx_bytes;                   // DWORD 148
               u32 p1_rx_bytes;                   // DWORD 149
               u32 p0_rx_frames;                  // DWORD 150
               u32 p1_rx_frames;                  // DWORD 151
               u32 p0_rx_sequences;               // DWORD 152
               u32 p1_rx_sequences;               // DWORD 153
               u32 p0_XON_xmit_count;             // DWORD 154
               u32 p1_XON_xmit_count;             // DWORD 155
               u32 p0_XOFF_xmit_count;            // DWORD 156
               u32 p1_XOFF_xmit_count;            // DWORD 157
               u32 p0_XON_timer_pops;             // DWORD 158
               u32 p1_XON_timer_pops;             // DWORD 159
               u32 p0_EOFni_count;                // DWORD 160
               u32 p1_EOFni_count;                // DWORD 161
               u32 p0_EOFa_count;                 // DWORD 162
               u32 p1_EOFa_count;                 // DWORD 163
               u32 frame_type_count[13];          // DWORDS 164 to 176
               u32 frame_discard_count[8];        // DWORDS 177 to 184
               u32 rsvd0[7];                      // DWORDS 185 to 191
            } SG_PACK ; // unnamed struct
            u32 dw[192]; // dword union
         }; // unnamed union
      } SG_PACK BE_TPRE_FUNC_STATS, *PBE_TPRE_FUNC_STATS;

      SG_C_ASSERT(__sizeof__BE_TPRE_FUNC_STATS, sizeof (BE_TPRE_FUNC_STATS) == 768);

   #else
      typedef struct _BE_TPRE_FUNC_STATS {
         u32 ipv4_rx_bytes[8];                    // DWORDS 0 to 7
         u32 ipv6_rx_bytes[8];                    // DWORDS 8 to 15
         u32 ipv4_rx_frames[8];                   // DWORDS 16 to 23
         u32 ipv6_rx_frames[8];                   // DWORDS 24 to 31
         u32 rx_window_probes[8];                 // DWORDS 32 to 39
         u32 rx_window_updates[8];                // DWORDS 40 to 47
         u32 rxmit_timeouts[8];                   // DWORDS 48 to 55
         u32 ooo_packets[8];                      // DWORDS 56 to 63
         u32 delayed_acks_sent[8];                // DWORDS 64 to 71
         u32 rx_acks[8];                          // DWORDS 72 to 79
         u32 rx_duplicate_acks[8];                // DWORDS 80 to 87
         u32 ipv4_drops[8];                       // DWORDS 88 to 95
         u32 ipv6_drops[8];                       // DWORDS 96 to 103
         u32 duplicate_rx_bytes;                  // DWORD 104
         u32 partial_duplicate_rx_bytes;          // DWORD 105
         u32 bytes_after_window;                  // DWORD 106
         u32 rx_prediction_segments;              // DWORD 107
         u32 cam_bug_drops;                       // DWORD 108
         u32 rx_dup_frames;                       // DWORD 109
         u32 paws_drops;                          // DWORD 110
         u32 rx_partial_duplicate_frames;         // DWORD 111
         u32 packets_after_window;                // DWORD 112
         u32 buffer_credit_drops;                 // DWORD 113
         u32 rx_ack_too_much;                     // DWORD 114
         u32 timeout_drops;                       // DWORD 115
         u32 ooo_disable_drops;                   // DWORD 116
         u32 ooo_prepend_drops;                   // DWORD 117
         u32 ooo_tt_replay_drops;                 // DWORD 118
         u32 fast_retransmits;                    // DWORD 119
         u32 syn_in_window;                       // DWORD 120
         u32 state_changes;                       // DWORD 121
         u32 tt_data_pack;                        // DWORD 122
         u32 tt_data_bytes;                       // DWORD 123
         u32 p0_immack_queue_full;                // DWORD 124
         u32 p1_immack_queue_full;                // DWORD 125
         u32 immacks;                             // DWORD 126
         u32 dbcred_return;                       // DWORD 127
         u32 rx_ack_too_old;                      // DWORD 128
         u32 rxmt_complete;                       // DWORD 129
         u32 tcp_flush;                           // DWORD 130
         u32 tcp_update_ipc_cnt;                  // DWORD 131
         u32 lro_red_discard_count;               // DWORD 132
         u32 lro_credit_discard_count;            // DWORD 133
         u32 lro_packet_count;                    // DWORD 134
         u32 lro_singleton_count;                 // DWORD 135
         u32 lro_chain_count;                     // DWORD 136
         u32 lro_chainbreak_timeout;              // DWORD 137
         u32 lro_chainbreak_maxlen;               // DWORD 138
         u32 lro_chainbreak_maxpkts;              // DWORD 139
         u32 lro_chainbreak_singleton;            // DWORD 140
         u32 lro_chainbreak_collision;            // DWORD 141
         u32 lro_chainbreak_ooo;                  // DWORD 142
         u32 lro_flush_count;                     // DWORD 143
         u32 tpre_int_debug_stat_1;               // DWORD 144
         u32 tpre_int_debug_stat_2;               // DWORD 145
         u32 tpre_int_debug_stat_3;               // DWORD 146
         u32 tpre_int_debug_stat_4;               // DWORD 147
         u32 p0_rx_bytes;                         // DWORD 148
         u32 p1_rx_bytes;                         // DWORD 149
         u32 p0_rx_frames;                        // DWORD 150
         u32 p1_rx_frames;                        // DWORD 151
         u32 p0_rx_sequences;                     // DWORD 152
         u32 p1_rx_sequences;                     // DWORD 153
         u32 p0_XON_xmit_count;                   // DWORD 154
         u32 p1_XON_xmit_count;                   // DWORD 155
         u32 p0_XOFF_xmit_count;                  // DWORD 156
         u32 p1_XOFF_xmit_count;                  // DWORD 157
         u32 p0_XON_timer_pops;                   // DWORD 158
         u32 p1_XON_timer_pops;                   // DWORD 159
         u32 p0_EOFni_count;                      // DWORD 160
         u32 p1_EOFni_count;                      // DWORD 161
         u32 p0_EOFa_count;                       // DWORD 162
         u32 p1_EOFa_count;                       // DWORD 163
         u32 frame_type_count[13];                // DWORDS 164 to 176
         u32 frame_discard_count[8];              // DWORDS 177 to 184
         u32 rsvd0[7];                            // DWORDS 185 to 191
      } SG_PACK BE_TPRE_FUNC_STATS, *PBE_TPRE_FUNC_STATS;

      typedef union _BE_TPRE_FUNC_STATS_UNION {
         BE_TPRE_FUNC_STATS bits;
         u32 dw[192]; // dword union
      } SG_PACK BE_TPRE_FUNC_STATS_UNION, *PBE_TPRE_FUNC_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TPRE_FUNC_STATS_UNION, sizeof (BE_TPRE_FUNC_STATS_UNION) == 768);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TPRE_HW_STATS {
         union {
            struct { 
               u32 rsvd2[49];                     // DWORDS 0 to 48
               u32 win_probes : 16;               // DWORD 49
               u32 rsvd0 : 16;                    // DWORD 49
               u32 partial_dup_acks;              // DWORD 50
               u32 dup_packets;                   // DWORD 51
               u32 ooo_packets_desc;              // DWORD 52
               u32 non_zero_packets;              // DWORD 53
               u32 rcv_ack_packets;               // DWORD 54
               u32 rx_total;                      // DWORD 55
               u32 rx_ulp2;                       // DWORD 56
               u32 rx_ulp1;                       // DWORD 57
               u32 rx_ulp0;                       // DWORD 58
               u32 rsvd1[1];                      // DWORDS 59 to 59
               u32 timer_drop : 16;               // DWORD 60
               u32 dup_acks : 16;                 // DWORD 60
               u32 red_ulp2 : 16;                 // DWORD 61
               u32 red_global : 16;               // DWORD 61
               u32 red_ulp0 : 16;                 // DWORD 62
               u32 red_ulp1 : 16;                 // DWORD 62
               u32 rsvd3[1];                      // DWORDS 63 to 63
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK BE_TPRE_HW_STATS, *PBE_TPRE_HW_STATS;

      SG_C_ASSERT(__sizeof__BE_TPRE_HW_STATS, sizeof (BE_TPRE_HW_STATS) == 256);

   #else
      typedef struct _BE_TPRE_HW_STATS {
         u32 rsvd2[49];                           // DWORDS 0 to 48
         u32 win_probes : 16;                     // DWORD 49
         u32 rsvd0 : 16;                          // DWORD 49
         u32 partial_dup_acks;                    // DWORD 50
         u32 dup_packets;                         // DWORD 51
         u32 ooo_packets_desc;                    // DWORD 52
         u32 non_zero_packets;                    // DWORD 53
         u32 rcv_ack_packets;                     // DWORD 54
         u32 rx_total;                            // DWORD 55
         u32 rx_ulp2;                             // DWORD 56
         u32 rx_ulp1;                             // DWORD 57
         u32 rx_ulp0;                             // DWORD 58
         u32 rsvd1[1];                            // DWORDS 59 to 59
         u32 timer_drop : 16;                     // DWORD 60
         u32 dup_acks : 16;                       // DWORD 60
         u32 red_ulp2 : 16;                       // DWORD 61
         u32 red_global : 16;                     // DWORD 61
         u32 red_ulp0 : 16;                       // DWORD 62
         u32 red_ulp1 : 16;                       // DWORD 62
         u32 rsvd3[1];                            // DWORDS 63 to 63
      } SG_PACK BE_TPRE_HW_STATS, *PBE_TPRE_HW_STATS;

      typedef union _BE_TPRE_HW_STATS_UNION {
         BE_TPRE_HW_STATS bits;
         u32 dw[64]; // dword union
      } SG_PACK BE_TPRE_HW_STATS_UNION, *PBE_TPRE_HW_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TPRE_HW_STATS_UNION, sizeof (BE_TPRE_HW_STATS_UNION) == 256);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TPRE_HW_STATS {
         union {
            struct { 
               u32 rsvd2[49];                     // DWORDS 0 to 48
               u32 rsvd0 : 16;                    // DWORD 49
               u32 win_probes : 16;               // DWORD 49
               u32 partial_dup_acks;              // DWORD 50
               u32 dup_packets;                   // DWORD 51
               u32 ooo_packets_desc;              // DWORD 52
               u32 non_zero_packets;              // DWORD 53
               u32 rcv_ack_packets;               // DWORD 54
               u32 rx_total;                      // DWORD 55
               u32 rx_ulp2;                       // DWORD 56
               u32 rx_ulp1;                       // DWORD 57
               u32 rx_ulp0;                       // DWORD 58
               u32 rsvd1[1];                      // DWORDS 59 to 59
               u32 dup_acks : 16;                 // DWORD 60
               u32 timer_drop : 16;               // DWORD 60
               u32 red_global : 16;               // DWORD 61
               u32 red_ulp2 : 16;                 // DWORD 61
               u32 red_ulp1 : 16;                 // DWORD 62
               u32 red_ulp0 : 16;                 // DWORD 62
               u32 rsvd3[1];                      // DWORDS 63 to 63
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK BE_TPRE_HW_STATS, *PBE_TPRE_HW_STATS;

      SG_C_ASSERT(__sizeof__BE_TPRE_HW_STATS, sizeof (BE_TPRE_HW_STATS) == 256);

   #else
      typedef struct _BE_TPRE_HW_STATS {
         u32 rsvd2[49];                           // DWORDS 0 to 48
         u32 rsvd0 : 16;                          // DWORD 49
         u32 win_probes : 16;                     // DWORD 49
         u32 partial_dup_acks;                    // DWORD 50
         u32 dup_packets;                         // DWORD 51
         u32 ooo_packets_desc;                    // DWORD 52
         u32 non_zero_packets;                    // DWORD 53
         u32 rcv_ack_packets;                     // DWORD 54
         u32 rx_total;                            // DWORD 55
         u32 rx_ulp2;                             // DWORD 56
         u32 rx_ulp1;                             // DWORD 57
         u32 rx_ulp0;                             // DWORD 58
         u32 rsvd1[1];                            // DWORDS 59 to 59
         u32 dup_acks : 16;                       // DWORD 60
         u32 timer_drop : 16;                     // DWORD 60
         u32 red_global : 16;                     // DWORD 61
         u32 red_ulp2 : 16;                       // DWORD 61
         u32 red_ulp1 : 16;                       // DWORD 62
         u32 red_ulp0 : 16;                       // DWORD 62
         u32 rsvd3[1];                            // DWORDS 63 to 63
      } SG_PACK BE_TPRE_HW_STATS, *PBE_TPRE_HW_STATS;

      typedef union _BE_TPRE_HW_STATS_UNION {
         BE_TPRE_HW_STATS bits;
         u32 dw[64]; // dword union
      } SG_PACK BE_TPRE_HW_STATS_UNION, *PBE_TPRE_HW_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TPRE_HW_STATS_UNION, sizeof (BE_TPRE_HW_STATS_UNION) == 256);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TPRE_STATS {
         union {
            struct { 
               BE_TPRE_FUNC_STATS func_stats;
               BE_TPRE_HW_STATS hw_stats;
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_TPRE_STATS, *PBE_TPRE_STATS;

      SG_C_ASSERT(__sizeof__BE_TPRE_STATS, sizeof (BE_TPRE_STATS) == 1024);

   #else
      typedef struct _BE_TPRE_STATS {
         BE_TPRE_FUNC_STATS func_stats;
         BE_TPRE_HW_STATS hw_stats;
      } SG_PACK BE_TPRE_STATS, *PBE_TPRE_STATS;

      typedef union _BE_TPRE_STATS_UNION {
         BE_TPRE_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_TPRE_STATS_UNION, *PBE_TPRE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TPRE_STATS_UNION, sizeof (BE_TPRE_STATS_UNION) == 1024);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TPRE_STATS {
         union {
            struct { 
               BE_TPRE_FUNC_STATS func_stats;
               BE_TPRE_HW_STATS hw_stats;
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_TPRE_STATS, *PBE_TPRE_STATS;

      SG_C_ASSERT(__sizeof__BE_TPRE_STATS, sizeof (BE_TPRE_STATS) == 1024);

   #else
      typedef struct _BE_TPRE_STATS {
         BE_TPRE_FUNC_STATS func_stats;
         BE_TPRE_HW_STATS hw_stats;
      } SG_PACK BE_TPRE_STATS, *PBE_TPRE_STATS;

      typedef union _BE_TPRE_STATS_UNION {
         BE_TPRE_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_TPRE_STATS_UNION, *PBE_TPRE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TPRE_STATS_UNION, sizeof (BE_TPRE_STATS_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __tpre_exp_bmap_h__

