/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ulp_context_bmap_h__
#define __ulp_context_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "headers_bmap.h"
#include "uc_bmap.h"
#include "mpu_local_mmr_bmap.h"
#include "reg_enums_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Transmit part of the ULP connection context structure. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ULP_TX_CONTEXT {
         union {
            struct { 
               u32 rsvd1 : 10;                    // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 tx_ring_size : 4;              // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 tx_cidx : 14;                  // DWORD 0
               u32 ctx_valid : 1;                 // DWORD 1
               u32 pd_id : 9;                     // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 pidx : 14;                     // DWORD 1
               u32 tx_class_bits : 16;            // DWORD 2
               u32 rsvd2 : 16;                    // DWORD 2
               u32 rsvd3[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ULP_TX_CONTEXT, *PULP_TX_CONTEXT;

      SG_C_ASSERT(__sizeof__ULP_TX_CONTEXT, sizeof (ULP_TX_CONTEXT) == 16);

   #else
      typedef struct _ULP_TX_CONTEXT {
         u32 rsvd1 : 10;                          // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 tx_ring_size : 4;                    // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 tx_cidx : 14;                        // DWORD 0
         u32 ctx_valid : 1;                       // DWORD 1
         u32 pd_id : 9;                           // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 pidx : 14;                           // DWORD 1
         u32 tx_class_bits : 16;                  // DWORD 2
         u32 rsvd2 : 16;                          // DWORD 2
         u32 rsvd3[1];                            // DWORDS 3 to 3
      } SG_PACK ULP_TX_CONTEXT, *PULP_TX_CONTEXT;

      typedef union _ULP_TX_CONTEXT_UNION {
         ULP_TX_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK ULP_TX_CONTEXT_UNION, *PULP_TX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ULP_TX_CONTEXT_UNION, sizeof (ULP_TX_CONTEXT_UNION) == 16);
   #endif


#else
   // Transmit part of the ULP connection context structure. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ULP_TX_CONTEXT {
         union {
            struct { 
               u32 tx_cidx : 14;                  // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 tx_ring_size : 4;              // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 rsvd1 : 10;                    // DWORD 0
               u32 pidx : 14;                     // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 pd_id : 9;                     // DWORD 1
               u32 ctx_valid : 1;                 // DWORD 1
               u32 rsvd2 : 16;                    // DWORD 2
               u32 tx_class_bits : 16;            // DWORD 2
               u32 rsvd3[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ULP_TX_CONTEXT, *PULP_TX_CONTEXT;

      SG_C_ASSERT(__sizeof__ULP_TX_CONTEXT, sizeof (ULP_TX_CONTEXT) == 16);

   #else
      typedef struct _ULP_TX_CONTEXT {
         u32 tx_cidx : 14;                        // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 tx_ring_size : 4;                    // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
         u32 pidx : 14;                           // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 pd_id : 9;                           // DWORD 1
         u32 ctx_valid : 1;                       // DWORD 1
         u32 rsvd2 : 16;                          // DWORD 2
         u32 tx_class_bits : 16;                  // DWORD 2
         u32 rsvd3[1];                            // DWORDS 3 to 3
      } SG_PACK ULP_TX_CONTEXT, *PULP_TX_CONTEXT;

      typedef union _ULP_TX_CONTEXT_UNION {
         ULP_TX_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK ULP_TX_CONTEXT_UNION, *PULP_TX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ULP_TX_CONTEXT_UNION, sizeof (ULP_TX_CONTEXT_UNION) == 16);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ulp_context_bmap_h__

