/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __vf_pcicfg_bmap_h__
#define __vf_pcicfg_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "mpu_local_mmr_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // VF Vendor and Device ID Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_ID_CSR {
         union {
            struct { 
               u32 deviceid : 16;                 // DWORD 0
               u32 vendorid : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_ID_CSR, *PVF_PCICFG_ID_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_ID_CSR, sizeof (VF_PCICFG_ID_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_ID_CSR {
         u32 deviceid : 16;                       // DWORD 0
         u32 vendorid : 16;                       // DWORD 0
      } SG_PACK VF_PCICFG_ID_CSR, *PVF_PCICFG_ID_CSR;

      typedef union _VF_PCICFG_ID_CSR_UNION {
         VF_PCICFG_ID_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_ID_CSR_UNION, *PVF_PCICFG_ID_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_ID_CSR_UNION, sizeof (VF_PCICFG_ID_CSR_UNION) == 4);
   #endif


#else
   // VF Vendor and Device ID Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_ID_CSR {
         union {
            struct { 
               u32 vendorid : 16;                 // DWORD 0
               u32 deviceid : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_ID_CSR, *PVF_PCICFG_ID_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_ID_CSR, sizeof (VF_PCICFG_ID_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_ID_CSR {
         u32 vendorid : 16;                       // DWORD 0
         u32 deviceid : 16;                       // DWORD 0
      } SG_PACK VF_PCICFG_ID_CSR, *PVF_PCICFG_ID_CSR;

      typedef union _VF_PCICFG_ID_CSR_UNION {
         VF_PCICFG_ID_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_ID_CSR_UNION, *PVF_PCICFG_ID_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_ID_CSR_UNION, sizeof (VF_PCICFG_ID_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Command and Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_COMMAND_STATUS_CSR {
         union {
            struct { 
               u32 dperr : 1;                     // DWORD 0
               u32 sserr : 1;                     // DWORD 0
               u32 rmabt : 1;                     // DWORD 0
               u32 rtabt : 1;                     // DWORD 0
               u32 stabt : 1;                     // DWORD 0
               u32 rsvd6 : 2;                     // DWORD 0
               u32 dpderr : 1;                    // DWORD 0
               u32 rsvd5 : 3;                     // DWORD 0
               u32 cap : 1;                       // DWORD 0
               u32 rsvd4 : 4;                     // DWORD 0
               u32 rsvd3 : 7;                     // DWORD 0
               u32 serren : 1;                    // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 perrsp : 1;                    // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 bmen : 1;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_COMMAND_STATUS_CSR, *PVF_PCICFG_COMMAND_STATUS_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_COMMAND_STATUS_CSR, sizeof (VF_PCICFG_COMMAND_STATUS_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_COMMAND_STATUS_CSR {
         u32 dperr : 1;                           // DWORD 0
         u32 sserr : 1;                           // DWORD 0
         u32 rmabt : 1;                           // DWORD 0
         u32 rtabt : 1;                           // DWORD 0
         u32 stabt : 1;                           // DWORD 0
         u32 rsvd6 : 2;                           // DWORD 0
         u32 dpderr : 1;                          // DWORD 0
         u32 rsvd5 : 3;                           // DWORD 0
         u32 cap : 1;                             // DWORD 0
         u32 rsvd4 : 4;                           // DWORD 0
         u32 rsvd3 : 7;                           // DWORD 0
         u32 serren : 1;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 perrsp : 1;                          // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 bmen : 1;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK VF_PCICFG_COMMAND_STATUS_CSR, *PVF_PCICFG_COMMAND_STATUS_CSR;

      typedef union _VF_PCICFG_COMMAND_STATUS_CSR_UNION {
         VF_PCICFG_COMMAND_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_COMMAND_STATUS_CSR_UNION, *PVF_PCICFG_COMMAND_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_COMMAND_STATUS_CSR_UNION, sizeof (VF_PCICFG_COMMAND_STATUS_CSR_UNION) == 4);
   #endif


#else
   // Command and Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_COMMAND_STATUS_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 bmen : 1;                      // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 perrsp : 1;                    // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 serren : 1;                    // DWORD 0
               u32 rsvd3 : 7;                     // DWORD 0
               u32 rsvd4 : 4;                     // DWORD 0
               u32 cap : 1;                       // DWORD 0
               u32 rsvd5 : 3;                     // DWORD 0
               u32 dpderr : 1;                    // DWORD 0
               u32 rsvd6 : 2;                     // DWORD 0
               u32 stabt : 1;                     // DWORD 0
               u32 rtabt : 1;                     // DWORD 0
               u32 rmabt : 1;                     // DWORD 0
               u32 sserr : 1;                     // DWORD 0
               u32 dperr : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_COMMAND_STATUS_CSR, *PVF_PCICFG_COMMAND_STATUS_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_COMMAND_STATUS_CSR, sizeof (VF_PCICFG_COMMAND_STATUS_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_COMMAND_STATUS_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 bmen : 1;                            // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 perrsp : 1;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 serren : 1;                          // DWORD 0
         u32 rsvd3 : 7;                           // DWORD 0
         u32 rsvd4 : 4;                           // DWORD 0
         u32 cap : 1;                             // DWORD 0
         u32 rsvd5 : 3;                           // DWORD 0
         u32 dpderr : 1;                          // DWORD 0
         u32 rsvd6 : 2;                           // DWORD 0
         u32 stabt : 1;                           // DWORD 0
         u32 rtabt : 1;                           // DWORD 0
         u32 rmabt : 1;                           // DWORD 0
         u32 sserr : 1;                           // DWORD 0
         u32 dperr : 1;                           // DWORD 0
      } SG_PACK VF_PCICFG_COMMAND_STATUS_CSR, *PVF_PCICFG_COMMAND_STATUS_CSR;

      typedef union _VF_PCICFG_COMMAND_STATUS_CSR_UNION {
         VF_PCICFG_COMMAND_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_COMMAND_STATUS_CSR_UNION, *PVF_PCICFG_COMMAND_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_COMMAND_STATUS_CSR_UNION, sizeof (VF_PCICFG_COMMAND_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Cache Line Size, Latency, PCI Header Type, and BIST Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_CACHE_TMR_HDR_BIST_CSR {
         union {
            struct { 
               u32 rsvd3 : 8;                     // DWORD 0
               u32 header_type : 8;               // DWORD 0
               u32 rsvd2 : 5;                     // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_CACHE_TMR_HDR_BIST_CSR, *PVF_PCICFG_CACHE_TMR_HDR_BIST_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CACHE_TMR_HDR_BIST_CSR, sizeof (VF_PCICFG_CACHE_TMR_HDR_BIST_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_CACHE_TMR_HDR_BIST_CSR {
         u32 rsvd3 : 8;                           // DWORD 0
         u32 header_type : 8;                     // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK VF_PCICFG_CACHE_TMR_HDR_BIST_CSR, *PVF_PCICFG_CACHE_TMR_HDR_BIST_CSR;

      typedef union _VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION {
         VF_PCICFG_CACHE_TMR_HDR_BIST_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION, *PVF_PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION, sizeof (VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION) == 4);
   #endif


#else
   // Cache Line Size, Latency, PCI Header Type, and BIST Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_CACHE_TMR_HDR_BIST_CSR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 rsvd2 : 5;                     // DWORD 0
               u32 header_type : 8;               // DWORD 0
               u32 rsvd3 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_CACHE_TMR_HDR_BIST_CSR, *PVF_PCICFG_CACHE_TMR_HDR_BIST_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CACHE_TMR_HDR_BIST_CSR, sizeof (VF_PCICFG_CACHE_TMR_HDR_BIST_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_CACHE_TMR_HDR_BIST_CSR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
         u32 header_type : 8;                     // DWORD 0
         u32 rsvd3 : 8;                           // DWORD 0
      } SG_PACK VF_PCICFG_CACHE_TMR_HDR_BIST_CSR, *PVF_PCICFG_CACHE_TMR_HDR_BIST_CSR;

      typedef union _VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION {
         VF_PCICFG_CACHE_TMR_HDR_BIST_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION, *PVF_PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION, sizeof (VF_PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Class Code and Revision ID Register. This register identifies the type of Device.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_CLASS_REV_CSR {
         union {
            struct { 
               u32 baseclass : 8;                 // DWORD 0
               u32 subclass : 8;                  // DWORD 0
               u32 prgintf : 8;                   // DWORD 0
               u32 rev : 8;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_CLASS_REV_CSR, *PVF_PCICFG_CLASS_REV_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CLASS_REV_CSR, sizeof (VF_PCICFG_CLASS_REV_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_CLASS_REV_CSR {
         u32 baseclass : 8;                       // DWORD 0
         u32 subclass : 8;                        // DWORD 0
         u32 prgintf : 8;                         // DWORD 0
         u32 rev : 8;                             // DWORD 0
      } SG_PACK VF_PCICFG_CLASS_REV_CSR, *PVF_PCICFG_CLASS_REV_CSR;

      typedef union _VF_PCICFG_CLASS_REV_CSR_UNION {
         VF_PCICFG_CLASS_REV_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_CLASS_REV_CSR_UNION, *PVF_PCICFG_CLASS_REV_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CLASS_REV_CSR_UNION, sizeof (VF_PCICFG_CLASS_REV_CSR_UNION) == 4);
   #endif


#else
   // Class Code and Revision ID Register. This register identifies the type of Device.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_CLASS_REV_CSR {
         union {
            struct { 
               u32 rev : 8;                       // DWORD 0
               u32 prgintf : 8;                   // DWORD 0
               u32 subclass : 8;                  // DWORD 0
               u32 baseclass : 8;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_CLASS_REV_CSR, *PVF_PCICFG_CLASS_REV_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CLASS_REV_CSR, sizeof (VF_PCICFG_CLASS_REV_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_CLASS_REV_CSR {
         u32 rev : 8;                             // DWORD 0
         u32 prgintf : 8;                         // DWORD 0
         u32 subclass : 8;                        // DWORD 0
         u32 baseclass : 8;                       // DWORD 0
      } SG_PACK VF_PCICFG_CLASS_REV_CSR, *PVF_PCICFG_CLASS_REV_CSR;

      typedef union _VF_PCICFG_CLASS_REV_CSR_UNION {
         VF_PCICFG_CLASS_REV_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_CLASS_REV_CSR_UNION, *PVF_PCICFG_CLASS_REV_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CLASS_REV_CSR_UNION, sizeof (VF_PCICFG_CLASS_REV_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Subsystem Vendor and ID (Function 0) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_SUBSYSTEM_ID_CSR {
         union {
            struct { 
               u32 subsys_id : 16;                // DWORD 0
               u32 subsys_vendor_id : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_SUBSYSTEM_ID_CSR, *PVF_PCICFG_SUBSYSTEM_ID_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_SUBSYSTEM_ID_CSR, sizeof (VF_PCICFG_SUBSYSTEM_ID_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_SUBSYSTEM_ID_CSR {
         u32 subsys_id : 16;                      // DWORD 0
         u32 subsys_vendor_id : 16;               // DWORD 0
      } SG_PACK VF_PCICFG_SUBSYSTEM_ID_CSR, *PVF_PCICFG_SUBSYSTEM_ID_CSR;

      typedef union _VF_PCICFG_SUBSYSTEM_ID_CSR_UNION {
         VF_PCICFG_SUBSYSTEM_ID_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_SUBSYSTEM_ID_CSR_UNION, *PVF_PCICFG_SUBSYSTEM_ID_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_SUBSYSTEM_ID_CSR_UNION, sizeof (VF_PCICFG_SUBSYSTEM_ID_CSR_UNION) == 4);
   #endif


#else
   // Subsystem Vendor and ID (Function 0) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_SUBSYSTEM_ID_CSR {
         union {
            struct { 
               u32 subsys_vendor_id : 16;         // DWORD 0
               u32 subsys_id : 16;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_SUBSYSTEM_ID_CSR, *PVF_PCICFG_SUBSYSTEM_ID_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_SUBSYSTEM_ID_CSR, sizeof (VF_PCICFG_SUBSYSTEM_ID_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_SUBSYSTEM_ID_CSR {
         u32 subsys_vendor_id : 16;               // DWORD 0
         u32 subsys_id : 16;                      // DWORD 0
      } SG_PACK VF_PCICFG_SUBSYSTEM_ID_CSR, *PVF_PCICFG_SUBSYSTEM_ID_CSR;

      typedef union _VF_PCICFG_SUBSYSTEM_ID_CSR_UNION {
         VF_PCICFG_SUBSYSTEM_ID_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_SUBSYSTEM_ID_CSR_UNION, *PVF_PCICFG_SUBSYSTEM_ID_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_SUBSYSTEM_ID_CSR_UNION, sizeof (VF_PCICFG_SUBSYSTEM_ID_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Capabilities List Pointer Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_CAP_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 capptr : 8;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_CAP_CSR, *PVF_PCICFG_CAP_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CAP_CSR, sizeof (VF_PCICFG_CAP_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_CAP_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 capptr : 8;                          // DWORD 0
      } SG_PACK VF_PCICFG_CAP_CSR, *PVF_PCICFG_CAP_CSR;

      typedef union _VF_PCICFG_CAP_CSR_UNION {
         VF_PCICFG_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_CAP_CSR_UNION, *PVF_PCICFG_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CAP_CSR_UNION, sizeof (VF_PCICFG_CAP_CSR_UNION) == 4);
   #endif


#else
   // Capabilities List Pointer Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_CAP_CSR {
         union {
            struct { 
               u32 capptr : 8;                    // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_CAP_CSR, *PVF_PCICFG_CAP_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CAP_CSR, sizeof (VF_PCICFG_CAP_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_CAP_CSR {
         u32 capptr : 8;                          // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK VF_PCICFG_CAP_CSR, *PVF_PCICFG_CAP_CSR;

      typedef union _VF_PCICFG_CAP_CSR_UNION {
         VF_PCICFG_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_CAP_CSR_UNION, *PVF_PCICFG_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CAP_CSR_UNION, sizeof (VF_PCICFG_CAP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express MSI-X Configuration Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_MSIX_CSR {
         union {
            struct { 
               u32 en : 1;                        // DWORD 0
               u32 funcmask : 1;                  // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 tablesize : 11;                // DWORD 0
               u32 nextptr : 8;                   // DWORD 0
               u32 capid : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_MSIX_CSR, *PVF_PCICFG_MSIX_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_CSR, sizeof (VF_PCICFG_MSIX_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_MSIX_CSR {
         u32 en : 1;                              // DWORD 0
         u32 funcmask : 1;                        // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 tablesize : 11;                      // DWORD 0
         u32 nextptr : 8;                         // DWORD 0
         u32 capid : 8;                           // DWORD 0
      } SG_PACK VF_PCICFG_MSIX_CSR, *PVF_PCICFG_MSIX_CSR;

      typedef union _VF_PCICFG_MSIX_CSR_UNION {
         VF_PCICFG_MSIX_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_MSIX_CSR_UNION, *PVF_PCICFG_MSIX_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_CSR_UNION, sizeof (VF_PCICFG_MSIX_CSR_UNION) == 4);
   #endif


#else
   // PCI Express MSI-X Configuration Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_MSIX_CSR {
         union {
            struct { 
               u32 capid : 8;                     // DWORD 0
               u32 nextptr : 8;                   // DWORD 0
               u32 tablesize : 11;                // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 funcmask : 1;                  // DWORD 0
               u32 en : 1;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_MSIX_CSR, *PVF_PCICFG_MSIX_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_CSR, sizeof (VF_PCICFG_MSIX_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_MSIX_CSR {
         u32 capid : 8;                           // DWORD 0
         u32 nextptr : 8;                         // DWORD 0
         u32 tablesize : 11;                      // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 funcmask : 1;                        // DWORD 0
         u32 en : 1;                              // DWORD 0
      } SG_PACK VF_PCICFG_MSIX_CSR, *PVF_PCICFG_MSIX_CSR;

      typedef union _VF_PCICFG_MSIX_CSR_UNION {
         VF_PCICFG_MSIX_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_MSIX_CSR_UNION, *PVF_PCICFG_MSIX_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_CSR_UNION, sizeof (VF_PCICFG_MSIX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MSI-X Table Offset Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_MSIX_TABLE_CSR {
         union {
            struct { 
               u32 offset : 29;                   // DWORD 0
               u32 tablebir : 3;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_MSIX_TABLE_CSR, *PVF_PCICFG_MSIX_TABLE_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_TABLE_CSR, sizeof (VF_PCICFG_MSIX_TABLE_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_MSIX_TABLE_CSR {
         u32 offset : 29;                         // DWORD 0
         u32 tablebir : 3;                        // DWORD 0
      } SG_PACK VF_PCICFG_MSIX_TABLE_CSR, *PVF_PCICFG_MSIX_TABLE_CSR;

      typedef union _VF_PCICFG_MSIX_TABLE_CSR_UNION {
         VF_PCICFG_MSIX_TABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_MSIX_TABLE_CSR_UNION, *PVF_PCICFG_MSIX_TABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_TABLE_CSR_UNION, sizeof (VF_PCICFG_MSIX_TABLE_CSR_UNION) == 4);
   #endif


#else
   // MSI-X Table Offset Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_MSIX_TABLE_CSR {
         union {
            struct { 
               u32 tablebir : 3;                  // DWORD 0
               u32 offset : 29;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_MSIX_TABLE_CSR, *PVF_PCICFG_MSIX_TABLE_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_TABLE_CSR, sizeof (VF_PCICFG_MSIX_TABLE_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_MSIX_TABLE_CSR {
         u32 tablebir : 3;                        // DWORD 0
         u32 offset : 29;                         // DWORD 0
      } SG_PACK VF_PCICFG_MSIX_TABLE_CSR, *PVF_PCICFG_MSIX_TABLE_CSR;

      typedef union _VF_PCICFG_MSIX_TABLE_CSR_UNION {
         VF_PCICFG_MSIX_TABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_MSIX_TABLE_CSR_UNION, *PVF_PCICFG_MSIX_TABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_TABLE_CSR_UNION, sizeof (VF_PCICFG_MSIX_TABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MSI-X PBA Offset Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_MSIX_PBA_CSR {
         union {
            struct { 
               u32 offset : 29;                   // DWORD 0
               u32 pbabir : 3;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_MSIX_PBA_CSR, *PVF_PCICFG_MSIX_PBA_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_PBA_CSR, sizeof (VF_PCICFG_MSIX_PBA_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_MSIX_PBA_CSR {
         u32 offset : 29;                         // DWORD 0
         u32 pbabir : 3;                          // DWORD 0
      } SG_PACK VF_PCICFG_MSIX_PBA_CSR, *PVF_PCICFG_MSIX_PBA_CSR;

      typedef union _VF_PCICFG_MSIX_PBA_CSR_UNION {
         VF_PCICFG_MSIX_PBA_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_MSIX_PBA_CSR_UNION, *PVF_PCICFG_MSIX_PBA_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_PBA_CSR_UNION, sizeof (VF_PCICFG_MSIX_PBA_CSR_UNION) == 4);
   #endif


#else
   // MSI-X PBA Offset Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_MSIX_PBA_CSR {
         union {
            struct { 
               u32 pbabir : 3;                    // DWORD 0
               u32 offset : 29;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_MSIX_PBA_CSR, *PVF_PCICFG_MSIX_PBA_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_PBA_CSR, sizeof (VF_PCICFG_MSIX_PBA_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_MSIX_PBA_CSR {
         u32 pbabir : 3;                          // DWORD 0
         u32 offset : 29;                         // DWORD 0
      } SG_PACK VF_PCICFG_MSIX_PBA_CSR, *PVF_PCICFG_MSIX_PBA_CSR;

      typedef union _VF_PCICFG_MSIX_PBA_CSR_UNION {
         VF_PCICFG_MSIX_PBA_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_MSIX_PBA_CSR_UNION, *PVF_PCICFG_MSIX_PBA_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_MSIX_PBA_CSR_UNION, sizeof (VF_PCICFG_MSIX_PBA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PF's VF Function Numeber
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_INT_CTRL_FUNCTION_NUM {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 hostintr : 1;                  // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
               u32 pf_function_num : 3;           // DWORD 0
               u32 vf_function_num : 8;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_INT_CTRL_FUNCTION_NUM, *PVF_PCICFG_INT_CTRL_FUNCTION_NUM;

      SG_C_ASSERT(__sizeof__VF_PCICFG_INT_CTRL_FUNCTION_NUM, sizeof (VF_PCICFG_INT_CTRL_FUNCTION_NUM) == 4);

   #else
      typedef struct _VF_PCICFG_INT_CTRL_FUNCTION_NUM {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 hostintr : 1;                        // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
         u32 pf_function_num : 3;                 // DWORD 0
         u32 vf_function_num : 8;                 // DWORD 0
      } SG_PACK VF_PCICFG_INT_CTRL_FUNCTION_NUM, *PVF_PCICFG_INT_CTRL_FUNCTION_NUM;

      typedef union _VF_PCICFG_INT_CTRL_FUNCTION_NUM_UNION {
         VF_PCICFG_INT_CTRL_FUNCTION_NUM bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_INT_CTRL_FUNCTION_NUM_UNION, *PVF_PCICFG_INT_CTRL_FUNCTION_NUM_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_INT_CTRL_FUNCTION_NUM_UNION, sizeof (VF_PCICFG_INT_CTRL_FUNCTION_NUM_UNION) == 4);
   #endif


#else
   // PF's VF Function Numeber
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_INT_CTRL_FUNCTION_NUM {
         union {
            struct { 
               u32 vf_function_num : 8;           // DWORD 0
               u32 pf_function_num : 3;           // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
               u32 hostintr : 1;                  // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_INT_CTRL_FUNCTION_NUM, *PVF_PCICFG_INT_CTRL_FUNCTION_NUM;

      SG_C_ASSERT(__sizeof__VF_PCICFG_INT_CTRL_FUNCTION_NUM, sizeof (VF_PCICFG_INT_CTRL_FUNCTION_NUM) == 4);

   #else
      typedef struct _VF_PCICFG_INT_CTRL_FUNCTION_NUM {
         u32 vf_function_num : 8;                 // DWORD 0
         u32 pf_function_num : 3;                 // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
         u32 hostintr : 1;                        // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK VF_PCICFG_INT_CTRL_FUNCTION_NUM, *PVF_PCICFG_INT_CTRL_FUNCTION_NUM;

      typedef union _VF_PCICFG_INT_CTRL_FUNCTION_NUM_UNION {
         VF_PCICFG_INT_CTRL_FUNCTION_NUM bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_INT_CTRL_FUNCTION_NUM_UNION, *PVF_PCICFG_INT_CTRL_FUNCTION_NUM_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_INT_CTRL_FUNCTION_NUM_UNION, sizeof (VF_PCICFG_INT_CTRL_FUNCTION_NUM_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_CAP_CSR {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 devport : 4;                   // DWORD 0
               u32 capver : 4;                    // DWORD 0
               u32 nextcap : 8;                   // DWORD 0
               u32 capid : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_CAP_CSR, *PVF_PCICFG_PCIE_CAP_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CAP_CSR, sizeof (VF_PCICFG_PCIE_CAP_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_CAP_CSR {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 devport : 4;                         // DWORD 0
         u32 capver : 4;                          // DWORD 0
         u32 nextcap : 8;                         // DWORD 0
         u32 capid : 8;                           // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_CAP_CSR, *PVF_PCICFG_PCIE_CAP_CSR;

      typedef union _VF_PCICFG_PCIE_CAP_CSR_UNION {
         VF_PCICFG_PCIE_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_CAP_CSR_UNION, *PVF_PCICFG_PCIE_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CAP_CSR_UNION, sizeof (VF_PCICFG_PCIE_CAP_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_CAP_CSR {
         union {
            struct { 
               u32 capid : 8;                     // DWORD 0
               u32 nextcap : 8;                   // DWORD 0
               u32 capver : 4;                    // DWORD 0
               u32 devport : 4;                   // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_CAP_CSR, *PVF_PCICFG_PCIE_CAP_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CAP_CSR, sizeof (VF_PCICFG_PCIE_CAP_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_CAP_CSR {
         u32 capid : 8;                           // DWORD 0
         u32 nextcap : 8;                         // DWORD 0
         u32 capver : 4;                          // DWORD 0
         u32 devport : 4;                         // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_CAP_CSR, *PVF_PCICFG_PCIE_CAP_CSR;

      typedef union _VF_PCICFG_PCIE_CAP_CSR_UNION {
         VF_PCICFG_PCIE_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_CAP_CSR_UNION, *PVF_PCICFG_PCIE_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CAP_CSR_UNION, sizeof (VF_PCICFG_PCIE_CAP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Device Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_DEVCAP_CSR {
         union {
            struct { 
               u32 rsvd4 : 3;                     // DWORD 0
               u32 FLR : 1;                       // DWORD 0
               u32 rsvd3 : 10;                    // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 ROLE_ERR_REP : 1;              // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 l1_lat : 3;                    // DWORD 0
               u32 lo_lat : 3;                    // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 payload : 3;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_DEVCAP_CSR, *PVF_PCICFG_PCIE_DEVCAP_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_DEVCAP_CSR, sizeof (VF_PCICFG_PCIE_DEVCAP_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_DEVCAP_CSR {
         u32 rsvd4 : 3;                           // DWORD 0
         u32 FLR : 1;                             // DWORD 0
         u32 rsvd3 : 10;                          // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 ROLE_ERR_REP : 1;                    // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 l1_lat : 3;                          // DWORD 0
         u32 lo_lat : 3;                          // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 payload : 3;                         // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_DEVCAP_CSR, *PVF_PCICFG_PCIE_DEVCAP_CSR;

      typedef union _VF_PCICFG_PCIE_DEVCAP_CSR_UNION {
         VF_PCICFG_PCIE_DEVCAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_DEVCAP_CSR_UNION, *PVF_PCICFG_PCIE_DEVCAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_DEVCAP_CSR_UNION, sizeof (VF_PCICFG_PCIE_DEVCAP_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Device Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_DEVCAP_CSR {
         union {
            struct { 
               u32 payload : 3;                   // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 lo_lat : 3;                    // DWORD 0
               u32 l1_lat : 3;                    // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 ROLE_ERR_REP : 1;              // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 rsvd3 : 10;                    // DWORD 0
               u32 FLR : 1;                       // DWORD 0
               u32 rsvd4 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_DEVCAP_CSR, *PVF_PCICFG_PCIE_DEVCAP_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_DEVCAP_CSR, sizeof (VF_PCICFG_PCIE_DEVCAP_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_DEVCAP_CSR {
         u32 payload : 3;                         // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 lo_lat : 3;                          // DWORD 0
         u32 l1_lat : 3;                          // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 ROLE_ERR_REP : 1;                    // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 rsvd3 : 10;                          // DWORD 0
         u32 FLR : 1;                             // DWORD 0
         u32 rsvd4 : 3;                           // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_DEVCAP_CSR, *PVF_PCICFG_PCIE_DEVCAP_CSR;

      typedef union _VF_PCICFG_PCIE_DEVCAP_CSR_UNION {
         VF_PCICFG_PCIE_DEVCAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_DEVCAP_CSR_UNION, *PVF_PCICFG_PCIE_DEVCAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_DEVCAP_CSR_UNION, sizeof (VF_PCICFG_PCIE_DEVCAP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Device Control/Status Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_CONTROL_STATUS_CSR {
         union {
            struct { 
               u32 rsvd1 : 10;                    // DWORD 0
               u32 TransPending : 1;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 UnsuppReqDetect : 1;           // DWORD 0
               u32 FatalErrDetect : 1;            // DWORD 0
               u32 NonFatalErrDetect : 1;         // DWORD 0
               u32 CorrErrDetect : 1;             // DWORD 0
               u32 INITIATE_FLR : 1;              // DWORD 0
               u32 Max_Read_Req_Size : 3;         // DWORD 0
               u32 EnableNoSnoop : 1;             // DWORD 0
               u32 AuxPwrPMEnable : 1;            // DWORD 0
               u32 PhantomFnEnable : 1;           // DWORD 0
               u32 ExtendTagFieldEnable : 1;      // DWORD 0
               u32 Max_Payload_Size : 3;          // DWORD 0
               u32 EnableRelaxOrder : 1;          // DWORD 0
               u32 UnsuppReqReportEn : 1;         // DWORD 0
               u32 FatalErrReportEn : 1;          // DWORD 0
               u32 NonFatalErrReportEn : 1;       // DWORD 0
               u32 CorrErrReportEn : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS_CSR, *PVF_PCICFG_PCIE_CONTROL_STATUS_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CONTROL_STATUS_CSR, sizeof (VF_PCICFG_PCIE_CONTROL_STATUS_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_CONTROL_STATUS_CSR {
         u32 rsvd1 : 10;                          // DWORD 0
         u32 TransPending : 1;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 UnsuppReqDetect : 1;                 // DWORD 0
         u32 FatalErrDetect : 1;                  // DWORD 0
         u32 NonFatalErrDetect : 1;               // DWORD 0
         u32 CorrErrDetect : 1;                   // DWORD 0
         u32 INITIATE_FLR : 1;                    // DWORD 0
         u32 Max_Read_Req_Size : 3;               // DWORD 0
         u32 EnableNoSnoop : 1;                   // DWORD 0
         u32 AuxPwrPMEnable : 1;                  // DWORD 0
         u32 PhantomFnEnable : 1;                 // DWORD 0
         u32 ExtendTagFieldEnable : 1;            // DWORD 0
         u32 Max_Payload_Size : 3;                // DWORD 0
         u32 EnableRelaxOrder : 1;                // DWORD 0
         u32 UnsuppReqReportEn : 1;               // DWORD 0
         u32 FatalErrReportEn : 1;                // DWORD 0
         u32 NonFatalErrReportEn : 1;             // DWORD 0
         u32 CorrErrReportEn : 1;                 // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS_CSR, *PVF_PCICFG_PCIE_CONTROL_STATUS_CSR;

      typedef union _VF_PCICFG_PCIE_CONTROL_STATUS_CSR_UNION {
         VF_PCICFG_PCIE_CONTROL_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS_CSR_UNION, *PVF_PCICFG_PCIE_CONTROL_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CONTROL_STATUS_CSR_UNION, sizeof (VF_PCICFG_PCIE_CONTROL_STATUS_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Device Control/Status Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_CONTROL_STATUS_CSR {
         union {
            struct { 
               u32 CorrErrReportEn : 1;           // DWORD 0
               u32 NonFatalErrReportEn : 1;       // DWORD 0
               u32 FatalErrReportEn : 1;          // DWORD 0
               u32 UnsuppReqReportEn : 1;         // DWORD 0
               u32 EnableRelaxOrder : 1;          // DWORD 0
               u32 Max_Payload_Size : 3;          // DWORD 0
               u32 ExtendTagFieldEnable : 1;      // DWORD 0
               u32 PhantomFnEnable : 1;           // DWORD 0
               u32 AuxPwrPMEnable : 1;            // DWORD 0
               u32 EnableNoSnoop : 1;             // DWORD 0
               u32 Max_Read_Req_Size : 3;         // DWORD 0
               u32 INITIATE_FLR : 1;              // DWORD 0
               u32 CorrErrDetect : 1;             // DWORD 0
               u32 NonFatalErrDetect : 1;         // DWORD 0
               u32 FatalErrDetect : 1;            // DWORD 0
               u32 UnsuppReqDetect : 1;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 TransPending : 1;              // DWORD 0
               u32 rsvd1 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS_CSR, *PVF_PCICFG_PCIE_CONTROL_STATUS_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CONTROL_STATUS_CSR, sizeof (VF_PCICFG_PCIE_CONTROL_STATUS_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_CONTROL_STATUS_CSR {
         u32 CorrErrReportEn : 1;                 // DWORD 0
         u32 NonFatalErrReportEn : 1;             // DWORD 0
         u32 FatalErrReportEn : 1;                // DWORD 0
         u32 UnsuppReqReportEn : 1;               // DWORD 0
         u32 EnableRelaxOrder : 1;                // DWORD 0
         u32 Max_Payload_Size : 3;                // DWORD 0
         u32 ExtendTagFieldEnable : 1;            // DWORD 0
         u32 PhantomFnEnable : 1;                 // DWORD 0
         u32 AuxPwrPMEnable : 1;                  // DWORD 0
         u32 EnableNoSnoop : 1;                   // DWORD 0
         u32 Max_Read_Req_Size : 3;               // DWORD 0
         u32 INITIATE_FLR : 1;                    // DWORD 0
         u32 CorrErrDetect : 1;                   // DWORD 0
         u32 NonFatalErrDetect : 1;               // DWORD 0
         u32 FatalErrDetect : 1;                  // DWORD 0
         u32 UnsuppReqDetect : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 TransPending : 1;                    // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS_CSR, *PVF_PCICFG_PCIE_CONTROL_STATUS_CSR;

      typedef union _VF_PCICFG_PCIE_CONTROL_STATUS_CSR_UNION {
         VF_PCICFG_PCIE_CONTROL_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS_CSR_UNION, *PVF_PCICFG_PCIE_CONTROL_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CONTROL_STATUS_CSR_UNION, sizeof (VF_PCICFG_PCIE_CONTROL_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Link Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_LINK_CAP_CSR {
         union {
            struct { 
               u32 PortNum : 8;                   // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 L1ExitLat : 3;                 // DWORD 0
               u32 L0sExitLat : 3;                // DWORD 0
               u32 ASPMSupport : 2;               // DWORD 0
               u32 MaxLinkWidth : 6;              // DWORD 0
               u32 MaxLinkSpeed : 4;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP_CSR, *PVF_PCICFG_PCIE_LINK_CAP_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_CAP_CSR, sizeof (VF_PCICFG_PCIE_LINK_CAP_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_LINK_CAP_CSR {
         u32 PortNum : 8;                         // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 L1ExitLat : 3;                       // DWORD 0
         u32 L0sExitLat : 3;                      // DWORD 0
         u32 ASPMSupport : 2;                     // DWORD 0
         u32 MaxLinkWidth : 6;                    // DWORD 0
         u32 MaxLinkSpeed : 4;                    // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP_CSR, *PVF_PCICFG_PCIE_LINK_CAP_CSR;

      typedef union _VF_PCICFG_PCIE_LINK_CAP_CSR_UNION {
         VF_PCICFG_PCIE_LINK_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP_CSR_UNION, *PVF_PCICFG_PCIE_LINK_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_CAP_CSR_UNION, sizeof (VF_PCICFG_PCIE_LINK_CAP_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Link Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_LINK_CAP_CSR {
         union {
            struct { 
               u32 MaxLinkSpeed : 4;              // DWORD 0
               u32 MaxLinkWidth : 6;              // DWORD 0
               u32 ASPMSupport : 2;               // DWORD 0
               u32 L0sExitLat : 3;                // DWORD 0
               u32 L1ExitLat : 3;                 // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 PortNum : 8;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP_CSR, *PVF_PCICFG_PCIE_LINK_CAP_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_CAP_CSR, sizeof (VF_PCICFG_PCIE_LINK_CAP_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_LINK_CAP_CSR {
         u32 MaxLinkSpeed : 4;                    // DWORD 0
         u32 MaxLinkWidth : 6;                    // DWORD 0
         u32 ASPMSupport : 2;                     // DWORD 0
         u32 L0sExitLat : 3;                      // DWORD 0
         u32 L1ExitLat : 3;                       // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 PortNum : 8;                         // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP_CSR, *PVF_PCICFG_PCIE_LINK_CAP_CSR;

      typedef union _VF_PCICFG_PCIE_LINK_CAP_CSR_UNION {
         VF_PCICFG_PCIE_LINK_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP_CSR_UNION, *PVF_PCICFG_PCIE_LINK_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_CAP_CSR_UNION, sizeof (VF_PCICFG_PCIE_LINK_CAP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Link Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_LINK_STATUS_CSR {
         union {
            struct { 
               u32 rsvd3 : 3;                     // DWORD 0
               u32 SlotClkConfig : 1;             // DWORD 0
               u32 LinkTrain : 1;                 // DWORD 0
               u32 LinkTrainErr : 1;              // DWORD 0
               u32 NegLinkWidth : 6;              // DWORD 0
               u32 LinkSpeed : 4;                 // DWORD 0
               u32 rsvd2 : 6;                     // DWORD 0
               u32 hw_autonomous_width_dis : 1;   // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ExtendSync : 1;                // DWORD 0
               u32 CommonClkConfig : 1;           // DWORD 0
               u32 RetrainLink : 1;               // DWORD 0
               u32 LinkDisable : 1;               // DWORD 0
               u32 ReadCmplBndry : 1;             // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ASPMCtl : 2;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS_CSR, *PVF_PCICFG_PCIE_LINK_STATUS_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_STATUS_CSR, sizeof (VF_PCICFG_PCIE_LINK_STATUS_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_LINK_STATUS_CSR {
         u32 rsvd3 : 3;                           // DWORD 0
         u32 SlotClkConfig : 1;                   // DWORD 0
         u32 LinkTrain : 1;                       // DWORD 0
         u32 LinkTrainErr : 1;                    // DWORD 0
         u32 NegLinkWidth : 6;                    // DWORD 0
         u32 LinkSpeed : 4;                       // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 hw_autonomous_width_dis : 1;         // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ExtendSync : 1;                      // DWORD 0
         u32 CommonClkConfig : 1;                 // DWORD 0
         u32 RetrainLink : 1;                     // DWORD 0
         u32 LinkDisable : 1;                     // DWORD 0
         u32 ReadCmplBndry : 1;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ASPMCtl : 2;                         // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS_CSR, *PVF_PCICFG_PCIE_LINK_STATUS_CSR;

      typedef union _VF_PCICFG_PCIE_LINK_STATUS_CSR_UNION {
         VF_PCICFG_PCIE_LINK_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS_CSR_UNION, *PVF_PCICFG_PCIE_LINK_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_STATUS_CSR_UNION, sizeof (VF_PCICFG_PCIE_LINK_STATUS_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Link Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_LINK_STATUS_CSR {
         union {
            struct { 
               u32 ASPMCtl : 2;                   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ReadCmplBndry : 1;             // DWORD 0
               u32 LinkDisable : 1;               // DWORD 0
               u32 RetrainLink : 1;               // DWORD 0
               u32 CommonClkConfig : 1;           // DWORD 0
               u32 ExtendSync : 1;                // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 hw_autonomous_width_dis : 1;   // DWORD 0
               u32 rsvd2 : 6;                     // DWORD 0
               u32 LinkSpeed : 4;                 // DWORD 0
               u32 NegLinkWidth : 6;              // DWORD 0
               u32 LinkTrainErr : 1;              // DWORD 0
               u32 LinkTrain : 1;                 // DWORD 0
               u32 SlotClkConfig : 1;             // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS_CSR, *PVF_PCICFG_PCIE_LINK_STATUS_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_STATUS_CSR, sizeof (VF_PCICFG_PCIE_LINK_STATUS_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_LINK_STATUS_CSR {
         u32 ASPMCtl : 2;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ReadCmplBndry : 1;                   // DWORD 0
         u32 LinkDisable : 1;                     // DWORD 0
         u32 RetrainLink : 1;                     // DWORD 0
         u32 CommonClkConfig : 1;                 // DWORD 0
         u32 ExtendSync : 1;                      // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 hw_autonomous_width_dis : 1;         // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 LinkSpeed : 4;                       // DWORD 0
         u32 NegLinkWidth : 6;                    // DWORD 0
         u32 LinkTrainErr : 1;                    // DWORD 0
         u32 LinkTrain : 1;                       // DWORD 0
         u32 SlotClkConfig : 1;                   // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS_CSR, *PVF_PCICFG_PCIE_LINK_STATUS_CSR;

      typedef union _VF_PCICFG_PCIE_LINK_STATUS_CSR_UNION {
         VF_PCICFG_PCIE_LINK_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS_CSR_UNION, *PVF_PCICFG_PCIE_LINK_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_STATUS_CSR_UNION, sizeof (VF_PCICFG_PCIE_LINK_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Device Capabilities 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_DEVCAP2_CSR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 cmpl_tmout_dis_sup : 1;        // DWORD 0
               u32 cmpl_tmout_sup : 4;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_DEVCAP2_CSR, *PVF_PCICFG_PCIE_DEVCAP2_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_DEVCAP2_CSR, sizeof (VF_PCICFG_PCIE_DEVCAP2_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_DEVCAP2_CSR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 cmpl_tmout_dis_sup : 1;              // DWORD 0
         u32 cmpl_tmout_sup : 4;                  // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_DEVCAP2_CSR, *PVF_PCICFG_PCIE_DEVCAP2_CSR;

      typedef union _VF_PCICFG_PCIE_DEVCAP2_CSR_UNION {
         VF_PCICFG_PCIE_DEVCAP2_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_DEVCAP2_CSR_UNION, *PVF_PCICFG_PCIE_DEVCAP2_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_DEVCAP2_CSR_UNION, sizeof (VF_PCICFG_PCIE_DEVCAP2_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Device Capabilities 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_DEVCAP2_CSR {
         union {
            struct { 
               u32 cmpl_tmout_sup : 4;            // DWORD 0
               u32 cmpl_tmout_dis_sup : 1;        // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_DEVCAP2_CSR, *PVF_PCICFG_PCIE_DEVCAP2_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_DEVCAP2_CSR, sizeof (VF_PCICFG_PCIE_DEVCAP2_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_DEVCAP2_CSR {
         u32 cmpl_tmout_sup : 4;                  // DWORD 0
         u32 cmpl_tmout_dis_sup : 1;              // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_DEVCAP2_CSR, *PVF_PCICFG_PCIE_DEVCAP2_CSR;

      typedef union _VF_PCICFG_PCIE_DEVCAP2_CSR_UNION {
         VF_PCICFG_PCIE_DEVCAP2_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_DEVCAP2_CSR_UNION, *PVF_PCICFG_PCIE_DEVCAP2_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_DEVCAP2_CSR_UNION, sizeof (VF_PCICFG_PCIE_DEVCAP2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Device Capabilities 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_CONTROL_STATUS2_CSR {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS2_CSR, *PVF_PCICFG_PCIE_CONTROL_STATUS2_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CONTROL_STATUS2_CSR, sizeof (VF_PCICFG_PCIE_CONTROL_STATUS2_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_CONTROL_STATUS2_CSR {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS2_CSR, *PVF_PCICFG_PCIE_CONTROL_STATUS2_CSR;

      typedef union _VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION {
         VF_PCICFG_PCIE_CONTROL_STATUS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION, *PVF_PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION, sizeof (VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Device Capabilities 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_CONTROL_STATUS2_CSR {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS2_CSR, *PVF_PCICFG_PCIE_CONTROL_STATUS2_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CONTROL_STATUS2_CSR, sizeof (VF_PCICFG_PCIE_CONTROL_STATUS2_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_CONTROL_STATUS2_CSR {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS2_CSR, *PVF_PCICFG_PCIE_CONTROL_STATUS2_CSR;

      typedef union _VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION {
         VF_PCICFG_PCIE_CONTROL_STATUS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION, *PVF_PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION, sizeof (VF_PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Link Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_LINK_CAP2_CSR {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP2_CSR, *PVF_PCICFG_PCIE_LINK_CAP2_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_CAP2_CSR, sizeof (VF_PCICFG_PCIE_LINK_CAP2_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_LINK_CAP2_CSR {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP2_CSR, *PVF_PCICFG_PCIE_LINK_CAP2_CSR;

      typedef union _VF_PCICFG_PCIE_LINK_CAP2_CSR_UNION {
         VF_PCICFG_PCIE_LINK_CAP2_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP2_CSR_UNION, *PVF_PCICFG_PCIE_LINK_CAP2_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_CAP2_CSR_UNION, sizeof (VF_PCICFG_PCIE_LINK_CAP2_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Link Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_LINK_CAP2_CSR {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP2_CSR, *PVF_PCICFG_PCIE_LINK_CAP2_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_CAP2_CSR, sizeof (VF_PCICFG_PCIE_LINK_CAP2_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_LINK_CAP2_CSR {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP2_CSR, *PVF_PCICFG_PCIE_LINK_CAP2_CSR;

      typedef union _VF_PCICFG_PCIE_LINK_CAP2_CSR_UNION {
         VF_PCICFG_PCIE_LINK_CAP2_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_LINK_CAP2_CSR_UNION, *PVF_PCICFG_PCIE_LINK_CAP2_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_CAP2_CSR_UNION, sizeof (VF_PCICFG_PCIE_LINK_CAP2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Link Status 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_LINK_STATUS2_CSR {
         union {
            struct { 
               u32 rsvd1 : 15;                    // DWORD 0
               u32 current_de_emphasis : 1;       // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS2_CSR, *PVF_PCICFG_PCIE_LINK_STATUS2_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_STATUS2_CSR, sizeof (VF_PCICFG_PCIE_LINK_STATUS2_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_LINK_STATUS2_CSR {
         u32 rsvd1 : 15;                          // DWORD 0
         u32 current_de_emphasis : 1;             // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS2_CSR, *PVF_PCICFG_PCIE_LINK_STATUS2_CSR;

      typedef union _VF_PCICFG_PCIE_LINK_STATUS2_CSR_UNION {
         VF_PCICFG_PCIE_LINK_STATUS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS2_CSR_UNION, *PVF_PCICFG_PCIE_LINK_STATUS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_STATUS2_CSR_UNION, sizeof (VF_PCICFG_PCIE_LINK_STATUS2_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Link Status 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PCIE_LINK_STATUS2_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 current_de_emphasis : 1;       // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS2_CSR, *PVF_PCICFG_PCIE_LINK_STATUS2_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_STATUS2_CSR, sizeof (VF_PCICFG_PCIE_LINK_STATUS2_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PCIE_LINK_STATUS2_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 current_de_emphasis : 1;             // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS2_CSR, *PVF_PCICFG_PCIE_LINK_STATUS2_CSR;

      typedef union _VF_PCICFG_PCIE_LINK_STATUS2_CSR_UNION {
         VF_PCICFG_PCIE_LINK_STATUS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PCIE_LINK_STATUS2_CSR_UNION, *PVF_PCICFG_PCIE_LINK_STATUS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PCIE_LINK_STATUS2_CSR_UNION, sizeof (VF_PCICFG_PCIE_LINK_STATUS2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register always need to return zeros. This space can't be used for any other
   // purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_RETURN_ZEROS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_RETURN_ZEROS, *PVF_PCICFG_RETURN_ZEROS;

      SG_C_ASSERT(__sizeof__VF_PCICFG_RETURN_ZEROS, sizeof (VF_PCICFG_RETURN_ZEROS) == 4);

   #else
      typedef struct _VF_PCICFG_RETURN_ZEROS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK VF_PCICFG_RETURN_ZEROS, *PVF_PCICFG_RETURN_ZEROS;

      typedef union _VF_PCICFG_RETURN_ZEROS_UNION {
         VF_PCICFG_RETURN_ZEROS bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_RETURN_ZEROS_UNION, *PVF_PCICFG_RETURN_ZEROS_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_RETURN_ZEROS_UNION, sizeof (VF_PCICFG_RETURN_ZEROS_UNION) == 4);
   #endif


#else
   // This register always need to return zeros. This space can't be used for any other
   // purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_RETURN_ZEROS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_RETURN_ZEROS, *PVF_PCICFG_RETURN_ZEROS;

      SG_C_ASSERT(__sizeof__VF_PCICFG_RETURN_ZEROS, sizeof (VF_PCICFG_RETURN_ZEROS) == 4);

   #else
      typedef struct _VF_PCICFG_RETURN_ZEROS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK VF_PCICFG_RETURN_ZEROS, *PVF_PCICFG_RETURN_ZEROS;

      typedef union _VF_PCICFG_RETURN_ZEROS_UNION {
         VF_PCICFG_RETURN_ZEROS bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_RETURN_ZEROS_UNION, *PVF_PCICFG_RETURN_ZEROS_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_RETURN_ZEROS_UNION, sizeof (VF_PCICFG_RETURN_ZEROS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host ERR Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_VF_ERR_A_INT_CSR {
         union {
            struct { 
               u32 err_intr;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_VF_ERR_A_INT_CSR, *PVF_PCICFG_PF_VF_ERR_A_INT_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_ERR_A_INT_CSR, sizeof (VF_PCICFG_PF_VF_ERR_A_INT_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_VF_ERR_A_INT_CSR {
         u32 err_intr;                            // DWORD 0
      } SG_PACK VF_PCICFG_PF_VF_ERR_A_INT_CSR, *PVF_PCICFG_PF_VF_ERR_A_INT_CSR;

      typedef union _VF_PCICFG_PF_VF_ERR_A_INT_CSR_UNION {
         VF_PCICFG_PF_VF_ERR_A_INT_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_VF_ERR_A_INT_CSR_UNION, *PVF_PCICFG_PF_VF_ERR_A_INT_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_ERR_A_INT_CSR_UNION, sizeof (VF_PCICFG_PF_VF_ERR_A_INT_CSR_UNION) == 4);
   #endif


#else
   // Host ERR Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_VF_ERR_A_INT_CSR {
         union {
            struct { 
               u32 err_intr;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_VF_ERR_A_INT_CSR, *PVF_PCICFG_PF_VF_ERR_A_INT_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_ERR_A_INT_CSR, sizeof (VF_PCICFG_PF_VF_ERR_A_INT_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_VF_ERR_A_INT_CSR {
         u32 err_intr;                            // DWORD 0
      } SG_PACK VF_PCICFG_PF_VF_ERR_A_INT_CSR, *PVF_PCICFG_PF_VF_ERR_A_INT_CSR;

      typedef union _VF_PCICFG_PF_VF_ERR_A_INT_CSR_UNION {
         VF_PCICFG_PF_VF_ERR_A_INT_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_VF_ERR_A_INT_CSR_UNION, *PVF_PCICFG_PF_VF_ERR_A_INT_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_ERR_A_INT_CSR_UNION, sizeof (VF_PCICFG_PF_VF_ERR_A_INT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host ERR Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_VF_ERR_B_INT_CSR {
         union {
            struct { 
               u32 err_intr;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_VF_ERR_B_INT_CSR, *PVF_PCICFG_PF_VF_ERR_B_INT_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_ERR_B_INT_CSR, sizeof (VF_PCICFG_PF_VF_ERR_B_INT_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_VF_ERR_B_INT_CSR {
         u32 err_intr;                            // DWORD 0
      } SG_PACK VF_PCICFG_PF_VF_ERR_B_INT_CSR, *PVF_PCICFG_PF_VF_ERR_B_INT_CSR;

      typedef union _VF_PCICFG_PF_VF_ERR_B_INT_CSR_UNION {
         VF_PCICFG_PF_VF_ERR_B_INT_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_VF_ERR_B_INT_CSR_UNION, *PVF_PCICFG_PF_VF_ERR_B_INT_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_ERR_B_INT_CSR_UNION, sizeof (VF_PCICFG_PF_VF_ERR_B_INT_CSR_UNION) == 4);
   #endif


#else
   // Host ERR Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_VF_ERR_B_INT_CSR {
         union {
            struct { 
               u32 err_intr;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_VF_ERR_B_INT_CSR, *PVF_PCICFG_PF_VF_ERR_B_INT_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_ERR_B_INT_CSR, sizeof (VF_PCICFG_PF_VF_ERR_B_INT_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_VF_ERR_B_INT_CSR {
         u32 err_intr;                            // DWORD 0
      } SG_PACK VF_PCICFG_PF_VF_ERR_B_INT_CSR, *PVF_PCICFG_PF_VF_ERR_B_INT_CSR;

      typedef union _VF_PCICFG_PF_VF_ERR_B_INT_CSR_UNION {
         VF_PCICFG_PF_VF_ERR_B_INT_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_VF_ERR_B_INT_CSR_UNION, *PVF_PCICFG_PF_VF_ERR_B_INT_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_ERR_B_INT_CSR_UNION, sizeof (VF_PCICFG_PF_VF_ERR_B_INT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host FLR Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_VF_FLR_INT_CSR {
         union {
            struct { 
               u32 FLR_intr;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_VF_FLR_INT_CSR, *PVF_PCICFG_PF_VF_FLR_INT_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_FLR_INT_CSR, sizeof (VF_PCICFG_PF_VF_FLR_INT_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_VF_FLR_INT_CSR {
         u32 FLR_intr;                            // DWORD 0
      } SG_PACK VF_PCICFG_PF_VF_FLR_INT_CSR, *PVF_PCICFG_PF_VF_FLR_INT_CSR;

      typedef union _VF_PCICFG_PF_VF_FLR_INT_CSR_UNION {
         VF_PCICFG_PF_VF_FLR_INT_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_VF_FLR_INT_CSR_UNION, *PVF_PCICFG_PF_VF_FLR_INT_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_FLR_INT_CSR_UNION, sizeof (VF_PCICFG_PF_VF_FLR_INT_CSR_UNION) == 4);
   #endif


#else
   // Host FLR Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_VF_FLR_INT_CSR {
         union {
            struct { 
               u32 FLR_intr;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_VF_FLR_INT_CSR, *PVF_PCICFG_PF_VF_FLR_INT_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_FLR_INT_CSR, sizeof (VF_PCICFG_PF_VF_FLR_INT_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_VF_FLR_INT_CSR {
         u32 FLR_intr;                            // DWORD 0
      } SG_PACK VF_PCICFG_PF_VF_FLR_INT_CSR, *PVF_PCICFG_PF_VF_FLR_INT_CSR;

      typedef union _VF_PCICFG_PF_VF_FLR_INT_CSR_UNION {
         VF_PCICFG_PF_VF_FLR_INT_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_VF_FLR_INT_CSR_UNION, *PVF_PCICFG_PF_VF_FLR_INT_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_VF_FLR_INT_CSR_UNION, sizeof (VF_PCICFG_PF_VF_FLR_INT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host ATS Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR {
         union {
            struct { 
               u32 ats_en_change_intr;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR, *PVF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR, sizeof (VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR {
         u32 ats_en_change_intr;                  // DWORD 0
      } SG_PACK VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR, *PVF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR;

      typedef union _VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_UNION {
         VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_UNION, *PVF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_UNION, sizeof (VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_UNION) == 4);
   #endif


#else
   // Host ATS Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR {
         union {
            struct { 
               u32 ats_en_change_intr;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR, *PVF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR, sizeof (VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR {
         u32 ats_en_change_intr;                  // DWORD 0
      } SG_PACK VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR, *PVF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR;

      typedef union _VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_UNION {
         VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_UNION, *PVF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_UNION, sizeof (VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host PF's VF Bus Master Enable Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_BME_CSR {
         union {
            struct { 
               u32 bme;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_BME_CSR, *PVF_PCICFG_PF_BME_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_BME_CSR, sizeof (VF_PCICFG_PF_BME_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_BME_CSR {
         u32 bme;                                 // DWORD 0
      } SG_PACK VF_PCICFG_PF_BME_CSR, *PVF_PCICFG_PF_BME_CSR;

      typedef union _VF_PCICFG_PF_BME_CSR_UNION {
         VF_PCICFG_PF_BME_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_BME_CSR_UNION, *PVF_PCICFG_PF_BME_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_BME_CSR_UNION, sizeof (VF_PCICFG_PF_BME_CSR_UNION) == 4);
   #endif


#else
   // Host PF's VF Bus Master Enable Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_BME_CSR {
         union {
            struct { 
               u32 bme;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_BME_CSR, *PVF_PCICFG_PF_BME_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_BME_CSR, sizeof (VF_PCICFG_PF_BME_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_BME_CSR {
         u32 bme;                                 // DWORD 0
      } SG_PACK VF_PCICFG_PF_BME_CSR, *PVF_PCICFG_PF_BME_CSR;

      typedef union _VF_PCICFG_PF_BME_CSR_UNION {
         VF_PCICFG_PF_BME_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_BME_CSR_UNION, *PVF_PCICFG_PF_BME_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_BME_CSR_UNION, sizeof (VF_PCICFG_PF_BME_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host ATS Enables Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_ATS_EN_CSR {
         union {
            struct { 
               u32 ats_en;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_ATS_EN_CSR, *PVF_PCICFG_PF_ATS_EN_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_ATS_EN_CSR, sizeof (VF_PCICFG_PF_ATS_EN_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_ATS_EN_CSR {
         u32 ats_en;                              // DWORD 0
      } SG_PACK VF_PCICFG_PF_ATS_EN_CSR, *PVF_PCICFG_PF_ATS_EN_CSR;

      typedef union _VF_PCICFG_PF_ATS_EN_CSR_UNION {
         VF_PCICFG_PF_ATS_EN_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_ATS_EN_CSR_UNION, *PVF_PCICFG_PF_ATS_EN_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_ATS_EN_CSR_UNION, sizeof (VF_PCICFG_PF_ATS_EN_CSR_UNION) == 4);
   #endif


#else
   // Host ATS Enables Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_PF_ATS_EN_CSR {
         union {
            struct { 
               u32 ats_en;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_PF_ATS_EN_CSR, *PVF_PCICFG_PF_ATS_EN_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_ATS_EN_CSR, sizeof (VF_PCICFG_PF_ATS_EN_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_PF_ATS_EN_CSR {
         u32 ats_en;                              // DWORD 0
      } SG_PACK VF_PCICFG_PF_ATS_EN_CSR, *PVF_PCICFG_PF_ATS_EN_CSR;

      typedef union _VF_PCICFG_PF_ATS_EN_CSR_UNION {
         VF_PCICFG_PF_ATS_EN_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_PF_ATS_EN_CSR_UNION, *PVF_PCICFG_PF_ATS_EN_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_PF_ATS_EN_CSR_UNION, sizeof (VF_PCICFG_PF_ATS_EN_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_HOST_INT_STATUS_CSR {
         union {
            struct { 
               u32 rsvd3 : 23;                    // DWORD 0
               u32 ats_en_change_intr : 1;        // DWORD 0
               u32 FLR_intr : 1;                  // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 err_b : 1;                     // DWORD 0
               u32 err_a : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_HOST_INT_STATUS_CSR, *PVF_PCICFG_HOST_INT_STATUS_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_STATUS_CSR, sizeof (VF_PCICFG_HOST_INT_STATUS_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_HOST_INT_STATUS_CSR {
         u32 rsvd3 : 23;                          // DWORD 0
         u32 ats_en_change_intr : 1;              // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 err_b : 1;                           // DWORD 0
         u32 err_a : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK VF_PCICFG_HOST_INT_STATUS_CSR, *PVF_PCICFG_HOST_INT_STATUS_CSR;

      typedef union _VF_PCICFG_HOST_INT_STATUS_CSR_UNION {
         VF_PCICFG_HOST_INT_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_HOST_INT_STATUS_CSR_UNION, *PVF_PCICFG_HOST_INT_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_STATUS_CSR_UNION, sizeof (VF_PCICFG_HOST_INT_STATUS_CSR_UNION) == 4);
   #endif


#else
   // Host Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_HOST_INT_STATUS_CSR {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 err_a : 1;                     // DWORD 0
               u32 err_b : 1;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 FLR_intr : 1;                  // DWORD 0
               u32 ats_en_change_intr : 1;        // DWORD 0
               u32 rsvd3 : 23;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_HOST_INT_STATUS_CSR, *PVF_PCICFG_HOST_INT_STATUS_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_STATUS_CSR, sizeof (VF_PCICFG_HOST_INT_STATUS_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_HOST_INT_STATUS_CSR {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 err_a : 1;                           // DWORD 0
         u32 err_b : 1;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 ats_en_change_intr : 1;              // DWORD 0
         u32 rsvd3 : 23;                          // DWORD 0
      } SG_PACK VF_PCICFG_HOST_INT_STATUS_CSR, *PVF_PCICFG_HOST_INT_STATUS_CSR;

      typedef union _VF_PCICFG_HOST_INT_STATUS_CSR_UNION {
         VF_PCICFG_HOST_INT_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_HOST_INT_STATUS_CSR_UNION, *PVF_PCICFG_HOST_INT_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_STATUS_CSR_UNION, sizeof (VF_PCICFG_HOST_INT_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host Interrupt Mask Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_HOST_INT_MASK_CSR {
         union {
            struct { 
               u32 rsvd4 : 23;                    // DWORD 0
               u32 ats_en_change_intr : 1;        // DWORD 0
               u32 FLR_intr : 1;                  // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 err_b : 1;                     // DWORD 0
               u32 err_a : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_HOST_INT_MASK_CSR, *PVF_PCICFG_HOST_INT_MASK_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_MASK_CSR, sizeof (VF_PCICFG_HOST_INT_MASK_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_HOST_INT_MASK_CSR {
         u32 rsvd4 : 23;                          // DWORD 0
         u32 ats_en_change_intr : 1;              // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 err_b : 1;                           // DWORD 0
         u32 err_a : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK VF_PCICFG_HOST_INT_MASK_CSR, *PVF_PCICFG_HOST_INT_MASK_CSR;

      typedef union _VF_PCICFG_HOST_INT_MASK_CSR_UNION {
         VF_PCICFG_HOST_INT_MASK_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_HOST_INT_MASK_CSR_UNION, *PVF_PCICFG_HOST_INT_MASK_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_MASK_CSR_UNION, sizeof (VF_PCICFG_HOST_INT_MASK_CSR_UNION) == 4);
   #endif


#else
   // Host Interrupt Mask Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_HOST_INT_MASK_CSR {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 err_a : 1;                     // DWORD 0
               u32 err_b : 1;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 FLR_intr : 1;                  // DWORD 0
               u32 ats_en_change_intr : 1;        // DWORD 0
               u32 rsvd4 : 23;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_HOST_INT_MASK_CSR, *PVF_PCICFG_HOST_INT_MASK_CSR;

      SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_MASK_CSR, sizeof (VF_PCICFG_HOST_INT_MASK_CSR) == 4);

   #else
      typedef struct _VF_PCICFG_HOST_INT_MASK_CSR {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 err_a : 1;                           // DWORD 0
         u32 err_b : 1;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 ats_en_change_intr : 1;              // DWORD 0
         u32 rsvd4 : 23;                          // DWORD 0
      } SG_PACK VF_PCICFG_HOST_INT_MASK_CSR, *PVF_PCICFG_HOST_INT_MASK_CSR;

      typedef union _VF_PCICFG_HOST_INT_MASK_CSR_UNION {
         VF_PCICFG_HOST_INT_MASK_CSR bits;
         u32 dw; // dword union
      } SG_PACK VF_PCICFG_HOST_INT_MASK_CSR_UNION, *PVF_PCICFG_HOST_INT_MASK_CSR_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_HOST_INT_MASK_CSR_UNION, sizeof (VF_PCICFG_HOST_INT_MASK_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express ARI Enhanced Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCIE_ARI_ENHANCED_CAP {
         union {
            struct { 
               u32 next_cap_offset : 12;          // DWORD 0
               u32 cap_version : 4;               // DWORD 0
               u32 ext_cap_id : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCIE_ARI_ENHANCED_CAP, *PVF_PCIE_ARI_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__VF_PCIE_ARI_ENHANCED_CAP, sizeof (VF_PCIE_ARI_ENHANCED_CAP) == 4);

   #else
      typedef struct _VF_PCIE_ARI_ENHANCED_CAP {
         u32 next_cap_offset : 12;                // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 ext_cap_id : 16;                     // DWORD 0
      } SG_PACK VF_PCIE_ARI_ENHANCED_CAP, *PVF_PCIE_ARI_ENHANCED_CAP;

      typedef union _VF_PCIE_ARI_ENHANCED_CAP_UNION {
         VF_PCIE_ARI_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK VF_PCIE_ARI_ENHANCED_CAP_UNION, *PVF_PCIE_ARI_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__VF_PCIE_ARI_ENHANCED_CAP_UNION, sizeof (VF_PCIE_ARI_ENHANCED_CAP_UNION) == 4);
   #endif


#else
   // PCI Express ARI Enhanced Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCIE_ARI_ENHANCED_CAP {
         union {
            struct { 
               u32 ext_cap_id : 16;               // DWORD 0
               u32 cap_version : 4;               // DWORD 0
               u32 next_cap_offset : 12;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCIE_ARI_ENHANCED_CAP, *PVF_PCIE_ARI_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__VF_PCIE_ARI_ENHANCED_CAP, sizeof (VF_PCIE_ARI_ENHANCED_CAP) == 4);

   #else
      typedef struct _VF_PCIE_ARI_ENHANCED_CAP {
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK VF_PCIE_ARI_ENHANCED_CAP, *PVF_PCIE_ARI_ENHANCED_CAP;

      typedef union _VF_PCIE_ARI_ENHANCED_CAP_UNION {
         VF_PCIE_ARI_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK VF_PCIE_ARI_ENHANCED_CAP_UNION, *PVF_PCIE_ARI_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__VF_PCIE_ARI_ENHANCED_CAP_UNION, sizeof (VF_PCIE_ARI_ENHANCED_CAP_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Alternative Routing ID Interpretation Extended Capability.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCIE_ARI_CAPABILITY {
         union {
            struct { 
               u32 rsvd1 : 16;                    // DWORD 0
               u32 next_fun_num : 8;              // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 acs_fg_capability : 1;         // DWORD 0
               u32 mfvc_fg_capability : 1;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCIE_ARI_CAPABILITY, *PVF_PCIE_ARI_CAPABILITY;

      SG_C_ASSERT(__sizeof__VF_PCIE_ARI_CAPABILITY, sizeof (VF_PCIE_ARI_CAPABILITY) == 4);

   #else
      typedef struct _VF_PCIE_ARI_CAPABILITY {
         u32 rsvd1 : 16;                          // DWORD 0
         u32 next_fun_num : 8;                    // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 acs_fg_capability : 1;               // DWORD 0
         u32 mfvc_fg_capability : 1;              // DWORD 0
      } SG_PACK VF_PCIE_ARI_CAPABILITY, *PVF_PCIE_ARI_CAPABILITY;

      typedef union _VF_PCIE_ARI_CAPABILITY_UNION {
         VF_PCIE_ARI_CAPABILITY bits;
         u32 dw; // dword union
      } SG_PACK VF_PCIE_ARI_CAPABILITY_UNION, *PVF_PCIE_ARI_CAPABILITY_UNION;

      SG_C_ASSERT(__sizeof__VF_PCIE_ARI_CAPABILITY_UNION, sizeof (VF_PCIE_ARI_CAPABILITY_UNION) == 4);
   #endif


#else
   // PCI Express Alternative Routing ID Interpretation Extended Capability.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCIE_ARI_CAPABILITY {
         union {
            struct { 
               u32 mfvc_fg_capability : 1;        // DWORD 0
               u32 acs_fg_capability : 1;         // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 next_fun_num : 8;              // DWORD 0
               u32 rsvd1 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCIE_ARI_CAPABILITY, *PVF_PCIE_ARI_CAPABILITY;

      SG_C_ASSERT(__sizeof__VF_PCIE_ARI_CAPABILITY, sizeof (VF_PCIE_ARI_CAPABILITY) == 4);

   #else
      typedef struct _VF_PCIE_ARI_CAPABILITY {
         u32 mfvc_fg_capability : 1;              // DWORD 0
         u32 acs_fg_capability : 1;               // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 next_fun_num : 8;                    // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 0
      } SG_PACK VF_PCIE_ARI_CAPABILITY, *PVF_PCIE_ARI_CAPABILITY;

      typedef union _VF_PCIE_ARI_CAPABILITY_UNION {
         VF_PCIE_ARI_CAPABILITY bits;
         u32 dw; // dword union
      } SG_PACK VF_PCIE_ARI_CAPABILITY_UNION, *PVF_PCIE_ARI_CAPABILITY_UNION;

      SG_C_ASSERT(__sizeof__VF_PCIE_ARI_CAPABILITY_UNION, sizeof (VF_PCIE_ARI_CAPABILITY_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express ATS Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCIE_ATS_ENHANCED_CAP {
         union {
            struct { 
               u32 next_cap_offset : 12;          // DWORD 0
               u32 cap_version : 4;               // DWORD 0
               u32 ext_cap_id : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCIE_ATS_ENHANCED_CAP, *PVF_PCIE_ATS_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__VF_PCIE_ATS_ENHANCED_CAP, sizeof (VF_PCIE_ATS_ENHANCED_CAP) == 4);

   #else
      typedef struct _VF_PCIE_ATS_ENHANCED_CAP {
         u32 next_cap_offset : 12;                // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 ext_cap_id : 16;                     // DWORD 0
      } SG_PACK VF_PCIE_ATS_ENHANCED_CAP, *PVF_PCIE_ATS_ENHANCED_CAP;

      typedef union _VF_PCIE_ATS_ENHANCED_CAP_UNION {
         VF_PCIE_ATS_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK VF_PCIE_ATS_ENHANCED_CAP_UNION, *PVF_PCIE_ATS_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__VF_PCIE_ATS_ENHANCED_CAP_UNION, sizeof (VF_PCIE_ATS_ENHANCED_CAP_UNION) == 4);
   #endif


#else
   // PCI Express ATS Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCIE_ATS_ENHANCED_CAP {
         union {
            struct { 
               u32 ext_cap_id : 16;               // DWORD 0
               u32 cap_version : 4;               // DWORD 0
               u32 next_cap_offset : 12;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCIE_ATS_ENHANCED_CAP, *PVF_PCIE_ATS_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__VF_PCIE_ATS_ENHANCED_CAP, sizeof (VF_PCIE_ATS_ENHANCED_CAP) == 4);

   #else
      typedef struct _VF_PCIE_ATS_ENHANCED_CAP {
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK VF_PCIE_ATS_ENHANCED_CAP, *PVF_PCIE_ATS_ENHANCED_CAP;

      typedef union _VF_PCIE_ATS_ENHANCED_CAP_UNION {
         VF_PCIE_ATS_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK VF_PCIE_ATS_ENHANCED_CAP_UNION, *PVF_PCIE_ATS_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__VF_PCIE_ATS_ENHANCED_CAP_UNION, sizeof (VF_PCIE_ATS_ENHANCED_CAP_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express ATS Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCIE_ATS_CAPABILITY {
         union {
            struct { 
               u32 ats_en : 1;                    // DWORD 0
               u32 rsvd2 : 10;                    // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 rsvd0 : 11;                    // DWORD 0
               u32 inval_queue_depth : 5;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCIE_ATS_CAPABILITY, *PVF_PCIE_ATS_CAPABILITY;

      SG_C_ASSERT(__sizeof__VF_PCIE_ATS_CAPABILITY, sizeof (VF_PCIE_ATS_CAPABILITY) == 4);

   #else
      typedef struct _VF_PCIE_ATS_CAPABILITY {
         u32 ats_en : 1;                          // DWORD 0
         u32 rsvd2 : 10;                          // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 rsvd0 : 11;                          // DWORD 0
         u32 inval_queue_depth : 5;               // DWORD 0
      } SG_PACK VF_PCIE_ATS_CAPABILITY, *PVF_PCIE_ATS_CAPABILITY;

      typedef union _VF_PCIE_ATS_CAPABILITY_UNION {
         VF_PCIE_ATS_CAPABILITY bits;
         u32 dw; // dword union
      } SG_PACK VF_PCIE_ATS_CAPABILITY_UNION, *PVF_PCIE_ATS_CAPABILITY_UNION;

      SG_C_ASSERT(__sizeof__VF_PCIE_ATS_CAPABILITY_UNION, sizeof (VF_PCIE_ATS_CAPABILITY_UNION) == 4);
   #endif


#else
   // PCI Express ATS Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCIE_ATS_CAPABILITY {
         union {
            struct { 
               u32 inval_queue_depth : 5;         // DWORD 0
               u32 rsvd0 : 11;                    // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 rsvd2 : 10;                    // DWORD 0
               u32 ats_en : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VF_PCIE_ATS_CAPABILITY, *PVF_PCIE_ATS_CAPABILITY;

      SG_C_ASSERT(__sizeof__VF_PCIE_ATS_CAPABILITY, sizeof (VF_PCIE_ATS_CAPABILITY) == 4);

   #else
      typedef struct _VF_PCIE_ATS_CAPABILITY {
         u32 inval_queue_depth : 5;               // DWORD 0
         u32 rsvd0 : 11;                          // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 rsvd2 : 10;                          // DWORD 0
         u32 ats_en : 1;                          // DWORD 0
      } SG_PACK VF_PCIE_ATS_CAPABILITY, *PVF_PCIE_ATS_CAPABILITY;

      typedef union _VF_PCIE_ATS_CAPABILITY_UNION {
         VF_PCIE_ATS_CAPABILITY bits;
         u32 dw; // dword union
      } SG_PACK VF_PCIE_ATS_CAPABILITY_UNION, *PVF_PCIE_ATS_CAPABILITY_UNION;

      SG_C_ASSERT(__sizeof__VF_PCIE_ATS_CAPABILITY_UNION, sizeof (VF_PCIE_ATS_CAPABILITY_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This PCI configuration space register map is for the Virtual Function. 
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_CSRMAP {
         union {
            struct { 
               VF_PCICFG_ID_CSR id;
               VF_PCICFG_COMMAND_STATUS_CSR cmd_status;
               VF_PCICFG_CLASS_REV_CSR class_rev;
               VF_PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
               u32 rsvd0[6];                      // DWORDS 4 to 9
               u32 rsvd1[1];                      // DWORDS 10 to 10
               VF_PCICFG_SUBSYSTEM_ID_CSR subsystem_id;
               u32 rsvd2[1];                      // DWORDS 12 to 12
               VF_PCICFG_CAP_CSR cap;
               u32 rsvd3[2];                      // DWORDS 14 to 15
               u32 rsvd4[2];                      // DWORDS 16 to 17
               VF_PCICFG_MSIX_CSR msix;
               VF_PCICFG_MSIX_TABLE_CSR msix_table_offset;
               VF_PCICFG_MSIX_PBA_CSR msix_pba_offset;
               u32 rsvd5[11];                     // DWORDS 21 to 31
               u32 rsvd6[16];                     // DWORDS 32 to 47
               VF_PCICFG_PCIE_CAP_CSR pcie_cap;
               VF_PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
               VF_PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
               VF_PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
               VF_PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
               VF_PCICFG_RETURN_ZEROS return_zeros[4];
               VF_PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
               VF_PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
               VF_PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
               VF_PCICFG_PCIE_LINK_STATUS2_CSR pcie_link_status2;
               VF_PCICFG_RETURN_ZEROS return_zeros_1[2];
               VF_PCICFG_INT_CTRL_FUNCTION_NUM host_int_ctrl_vf_fnum;
               VF_PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
               VF_PCIE_ARI_CAPABILITY pcie_ari_capability;
               u32 rsvd7[24];                     // DWORDS 66 to 89
               VF_PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
               VF_PCIE_ATS_CAPABILITY pcie_ats_capability;
               u32 rsvd8[1];                      // DWORDS 92 to 92
               VF_PCICFG_HOST_INT_STATUS_CSR host_int_status;
               VF_PCICFG_HOST_INT_MASK_CSR host_int_mask;
               u32 rsvd9[1];                      // DWORDS 95 to 95
               VF_PCICFG_PF_VF_FLR_INT_CSR host_pf_vf_flr_int;
               VF_PCICFG_PF_VF_ERR_A_INT_CSR host_pf_vf_err_a_int;
               VF_PCICFG_PF_VF_ERR_B_INT_CSR host_pf_vf_err_b_int;
               VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR host_pf_vf_ats_en_int;
               VF_PCICFG_PF_BME_CSR host_pf_vf_bme;
               VF_PCICFG_PF_ATS_EN_CSR host_pf_vf_ats_en;
               u32 rsvd10[18];                    // DWORDS 102 to 119
               u32 rsvd11[904];                   // DWORDS 120 to 1023
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_CSRMAP, *PVF_PCICFG_CSRMAP;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CSRMAP, sizeof (VF_PCICFG_CSRMAP) == 4096);

   #else
      typedef struct _VF_PCICFG_CSRMAP {
         VF_PCICFG_ID_CSR id;
         VF_PCICFG_COMMAND_STATUS_CSR cmd_status;
         VF_PCICFG_CLASS_REV_CSR class_rev;
         VF_PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
         u32 rsvd0[6];                            // DWORDS 4 to 9
         u32 rsvd1[1];                            // DWORDS 10 to 10
         VF_PCICFG_SUBSYSTEM_ID_CSR subsystem_id;
         u32 rsvd2[1];                            // DWORDS 12 to 12
         VF_PCICFG_CAP_CSR cap;
         u32 rsvd3[2];                            // DWORDS 14 to 15
         u32 rsvd4[2];                            // DWORDS 16 to 17
         VF_PCICFG_MSIX_CSR msix;
         VF_PCICFG_MSIX_TABLE_CSR msix_table_offset;
         VF_PCICFG_MSIX_PBA_CSR msix_pba_offset;
         u32 rsvd5[11];                           // DWORDS 21 to 31
         u32 rsvd6[16];                           // DWORDS 32 to 47
         VF_PCICFG_PCIE_CAP_CSR pcie_cap;
         VF_PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
         VF_PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
         VF_PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
         VF_PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
         VF_PCICFG_RETURN_ZEROS return_zeros[4];
         VF_PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
         VF_PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
         VF_PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
         VF_PCICFG_PCIE_LINK_STATUS2_CSR pcie_link_status2;
         VF_PCICFG_RETURN_ZEROS return_zeros_1[2];
         VF_PCICFG_INT_CTRL_FUNCTION_NUM host_int_ctrl_vf_fnum;
         VF_PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
         VF_PCIE_ARI_CAPABILITY pcie_ari_capability;
         u32 rsvd7[24];                           // DWORDS 66 to 89
         VF_PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
         VF_PCIE_ATS_CAPABILITY pcie_ats_capability;
         u32 rsvd8[1];                            // DWORDS 92 to 92
         VF_PCICFG_HOST_INT_STATUS_CSR host_int_status;
         VF_PCICFG_HOST_INT_MASK_CSR host_int_mask;
         u32 rsvd9[1];                            // DWORDS 95 to 95
         VF_PCICFG_PF_VF_FLR_INT_CSR host_pf_vf_flr_int;
         VF_PCICFG_PF_VF_ERR_A_INT_CSR host_pf_vf_err_a_int;
         VF_PCICFG_PF_VF_ERR_B_INT_CSR host_pf_vf_err_b_int;
         VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR host_pf_vf_ats_en_int;
         VF_PCICFG_PF_BME_CSR host_pf_vf_bme;
         VF_PCICFG_PF_ATS_EN_CSR host_pf_vf_ats_en;
         u32 rsvd10[18];                          // DWORDS 102 to 119
         u32 rsvd11[904];                         // DWORDS 120 to 1023
      } SG_PACK VF_PCICFG_CSRMAP, *PVF_PCICFG_CSRMAP;

      typedef union _VF_PCICFG_CSRMAP_UNION {
         VF_PCICFG_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK VF_PCICFG_CSRMAP_UNION, *PVF_PCICFG_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CSRMAP_UNION, sizeof (VF_PCICFG_CSRMAP_UNION) == 4096);
   #endif


#else
   // This PCI configuration space register map is for the Virtual Function. 
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_CSRMAP {
         union {
            struct { 
               VF_PCICFG_ID_CSR id;
               VF_PCICFG_COMMAND_STATUS_CSR cmd_status;
               VF_PCICFG_CLASS_REV_CSR class_rev;
               VF_PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
               u32 rsvd0[6];                      // DWORDS 4 to 9
               u32 rsvd1[1];                      // DWORDS 10 to 10
               VF_PCICFG_SUBSYSTEM_ID_CSR subsystem_id;
               u32 rsvd2[1];                      // DWORDS 12 to 12
               VF_PCICFG_CAP_CSR cap;
               u32 rsvd3[2];                      // DWORDS 14 to 15
               u32 rsvd4[2];                      // DWORDS 16 to 17
               VF_PCICFG_MSIX_CSR msix;
               VF_PCICFG_MSIX_TABLE_CSR msix_table_offset;
               VF_PCICFG_MSIX_PBA_CSR msix_pba_offset;
               u32 rsvd5[11];                     // DWORDS 21 to 31
               u32 rsvd6[16];                     // DWORDS 32 to 47
               VF_PCICFG_PCIE_CAP_CSR pcie_cap;
               VF_PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
               VF_PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
               VF_PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
               VF_PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
               VF_PCICFG_RETURN_ZEROS return_zeros[4];
               VF_PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
               VF_PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
               VF_PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
               VF_PCICFG_PCIE_LINK_STATUS2_CSR pcie_link_status2;
               VF_PCICFG_RETURN_ZEROS return_zeros_1[2];
               VF_PCICFG_INT_CTRL_FUNCTION_NUM host_int_ctrl_vf_fnum;
               VF_PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
               VF_PCIE_ARI_CAPABILITY pcie_ari_capability;
               u32 rsvd7[24];                     // DWORDS 66 to 89
               VF_PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
               VF_PCIE_ATS_CAPABILITY pcie_ats_capability;
               u32 rsvd8[1];                      // DWORDS 92 to 92
               VF_PCICFG_HOST_INT_STATUS_CSR host_int_status;
               VF_PCICFG_HOST_INT_MASK_CSR host_int_mask;
               u32 rsvd9[1];                      // DWORDS 95 to 95
               VF_PCICFG_PF_VF_FLR_INT_CSR host_pf_vf_flr_int;
               VF_PCICFG_PF_VF_ERR_A_INT_CSR host_pf_vf_err_a_int;
               VF_PCICFG_PF_VF_ERR_B_INT_CSR host_pf_vf_err_b_int;
               VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR host_pf_vf_ats_en_int;
               VF_PCICFG_PF_BME_CSR host_pf_vf_bme;
               VF_PCICFG_PF_ATS_EN_CSR host_pf_vf_ats_en;
               u32 rsvd10[18];                    // DWORDS 102 to 119
               u32 rsvd11[904];                   // DWORDS 120 to 1023
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_CSRMAP, *PVF_PCICFG_CSRMAP;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CSRMAP, sizeof (VF_PCICFG_CSRMAP) == 4096);

   #else
      typedef struct _VF_PCICFG_CSRMAP {
         VF_PCICFG_ID_CSR id;
         VF_PCICFG_COMMAND_STATUS_CSR cmd_status;
         VF_PCICFG_CLASS_REV_CSR class_rev;
         VF_PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
         u32 rsvd0[6];                            // DWORDS 4 to 9
         u32 rsvd1[1];                            // DWORDS 10 to 10
         VF_PCICFG_SUBSYSTEM_ID_CSR subsystem_id;
         u32 rsvd2[1];                            // DWORDS 12 to 12
         VF_PCICFG_CAP_CSR cap;
         u32 rsvd3[2];                            // DWORDS 14 to 15
         u32 rsvd4[2];                            // DWORDS 16 to 17
         VF_PCICFG_MSIX_CSR msix;
         VF_PCICFG_MSIX_TABLE_CSR msix_table_offset;
         VF_PCICFG_MSIX_PBA_CSR msix_pba_offset;
         u32 rsvd5[11];                           // DWORDS 21 to 31
         u32 rsvd6[16];                           // DWORDS 32 to 47
         VF_PCICFG_PCIE_CAP_CSR pcie_cap;
         VF_PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
         VF_PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
         VF_PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
         VF_PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
         VF_PCICFG_RETURN_ZEROS return_zeros[4];
         VF_PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
         VF_PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
         VF_PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
         VF_PCICFG_PCIE_LINK_STATUS2_CSR pcie_link_status2;
         VF_PCICFG_RETURN_ZEROS return_zeros_1[2];
         VF_PCICFG_INT_CTRL_FUNCTION_NUM host_int_ctrl_vf_fnum;
         VF_PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
         VF_PCIE_ARI_CAPABILITY pcie_ari_capability;
         u32 rsvd7[24];                           // DWORDS 66 to 89
         VF_PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
         VF_PCIE_ATS_CAPABILITY pcie_ats_capability;
         u32 rsvd8[1];                            // DWORDS 92 to 92
         VF_PCICFG_HOST_INT_STATUS_CSR host_int_status;
         VF_PCICFG_HOST_INT_MASK_CSR host_int_mask;
         u32 rsvd9[1];                            // DWORDS 95 to 95
         VF_PCICFG_PF_VF_FLR_INT_CSR host_pf_vf_flr_int;
         VF_PCICFG_PF_VF_ERR_A_INT_CSR host_pf_vf_err_a_int;
         VF_PCICFG_PF_VF_ERR_B_INT_CSR host_pf_vf_err_b_int;
         VF_PCICFG_PF_ATS_EN_CHANGE_INT_CSR host_pf_vf_ats_en_int;
         VF_PCICFG_PF_BME_CSR host_pf_vf_bme;
         VF_PCICFG_PF_ATS_EN_CSR host_pf_vf_ats_en;
         u32 rsvd10[18];                          // DWORDS 102 to 119
         u32 rsvd11[904];                         // DWORDS 120 to 1023
      } SG_PACK VF_PCICFG_CSRMAP, *PVF_PCICFG_CSRMAP;

      typedef union _VF_PCICFG_CSRMAP_UNION {
         VF_PCICFG_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK VF_PCICFG_CSRMAP_UNION, *PVF_PCICFG_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CSRMAP_UNION, sizeof (VF_PCICFG_CSRMAP_UNION) == 4096);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This PCI configuration space register map is for the Virtual Function. 
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_CSRMAP_PF_8VF {
         union {
            struct { 
               VF_PCICFG_CSRMAP pf_8vfs[8];
            } SG_PACK ; // unnamed struct
            u32 dw[8192]; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_CSRMAP_PF_8VF, *PVF_PCICFG_CSRMAP_PF_8VF;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CSRMAP_PF_8VF, sizeof (VF_PCICFG_CSRMAP_PF_8VF) == 32768);

   #else
      typedef struct _VF_PCICFG_CSRMAP_PF_8VF {
         VF_PCICFG_CSRMAP pf_8vfs[8];
      } SG_PACK VF_PCICFG_CSRMAP_PF_8VF, *PVF_PCICFG_CSRMAP_PF_8VF;

      typedef union _VF_PCICFG_CSRMAP_PF_8VF_UNION {
         VF_PCICFG_CSRMAP_PF_8VF bits;
         u32 dw[8192]; // dword union
      } SG_PACK VF_PCICFG_CSRMAP_PF_8VF_UNION, *PVF_PCICFG_CSRMAP_PF_8VF_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CSRMAP_PF_8VF_UNION, sizeof (VF_PCICFG_CSRMAP_PF_8VF_UNION) == 32768);
   #endif


#else
   // This PCI configuration space register map is for the Virtual Function. 
   #if defined(SG_BMAP_UNION)
      typedef struct _VF_PCICFG_CSRMAP_PF_8VF {
         union {
            struct { 
               VF_PCICFG_CSRMAP pf_8vfs[8];
            } SG_PACK ; // unnamed struct
            u32 dw[8192]; // dword union
         }; // unnamed union
      } SG_PACK VF_PCICFG_CSRMAP_PF_8VF, *PVF_PCICFG_CSRMAP_PF_8VF;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CSRMAP_PF_8VF, sizeof (VF_PCICFG_CSRMAP_PF_8VF) == 32768);

   #else
      typedef struct _VF_PCICFG_CSRMAP_PF_8VF {
         VF_PCICFG_CSRMAP pf_8vfs[8];
      } SG_PACK VF_PCICFG_CSRMAP_PF_8VF, *PVF_PCICFG_CSRMAP_PF_8VF;

      typedef union _VF_PCICFG_CSRMAP_PF_8VF_UNION {
         VF_PCICFG_CSRMAP_PF_8VF bits;
         u32 dw[8192]; // dword union
      } SG_PACK VF_PCICFG_CSRMAP_PF_8VF_UNION, *PVF_PCICFG_CSRMAP_PF_8VF_UNION;

      SG_C_ASSERT(__sizeof__VF_PCICFG_CSRMAP_PF_8VF_UNION, sizeof (VF_PCICFG_CSRMAP_PF_8VF_UNION) == 32768);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __vf_pcicfg_bmap_h__

