/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fc_device_context_amap_h__
#define __fc_device_context_amap_h__
#include "setypes.h"
#include "defines.h"
#include "descriptors.h"
#include "headers.h"
#include "fc_enums.h"
#include "common_context.h"
#include "fc_common_host_struct.h"
#include "toe_context.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- AWAIT_ELS_REPLY_CODES ---
#define AWAIT_NONE                      (0)       // Indicates we are not waiting for a
                                                  // reply.
#define AWAIT_REC_REPLY                 (1)       // Indicates we are awaiting an REC
                                                  // Reply.
#define AWAIT_SRR_REPLY                 (2)       // Indicates we are awaiting an SRR
                                                  // Reply.
#define AWAIT_RRQ_REPLY                 (3)       // Indicates we are awaiting an RRQ
                                                  // Reply.

typedef enum {
   ENUM_AWAIT_NONE = 0x0UL,
   ENUM_AWAIT_REC_REPLY = 0x1UL,
   ENUM_AWAIT_SRR_REPLY = 0x2UL,
   ENUM_AWAIT_RRQ_REPLY = 0x3UL
} AWAIT_ELS_REPLY_CODES;

// --- FC_NUM_DEF_BUFFER_QUEUE_INFO ---
#define NUM_DEF_BUFFER_QUEUE_INFO       (4)       

typedef enum {
   ENUM_NUM_DEF_BUFFER_QUEUE_INFO = 0x4UL
} FC_NUM_DEF_BUFFER_QUEUE_INFO;

// The on-chip R2T context memory structure for FCoE write commands. RxULP copies the 1st
// 4 DW of the corresponding ICD into the last 4 DW of this R2T.
typedef struct {
   BE_BIT sgl_icd_index[16];                      // DWORD 0
   BE_BIT rx_id[16];                              // DWORD 0
   BE_BIT data_xfer_length[32];                   // DWORD 1
   BE_BIT buffer_offset[32];                      // DWORD 2
   BE_BIT sb_index[16];                           // DWORD 3
   BE_BIT rsvd0[13];                              // DWORD 3
   BE_BIT ooo_r2t;                                // DWORD 3
   BE_BIT invalid;                                // DWORD 3
   BE_BIT r2t_flip;                               // DWORD 3
} SG_PACK BE_FC_R2T_AMAP;
typedef struct { u32 dw[4]; } FC_R2T_AMAP, *PFC_R2T_AMAP;


// Information associated with peer end port, indexed by Remote Port Index.
typedef struct {
   BE_BIT my_fc_id[24];                           // DWORD 0
   BE_BIT init_r_a_tov[4];                        // DWORD 0
   BE_BIT init_e_d_tov[3];                        // DWORD 0
   BE_BIT cisc;                                   // DWORD 0
   BE_BIT peer_fc_id[24];                         // DWORD 1
   BE_BIT init_rec_tov[3];                        // DWORD 1
   BE_BIT rsvd0;                                  // DWORD 1
   BE_BIT max_buf_size[2];                        // DWORD 1
   BE_BIT paused;                                 // DWORD 1
   BE_BIT invalid;                                // DWORD 1
   struct {
      BE_BIT rsvd0;                               // DWORD 2
      BE_BIT VF_ID[12];                           // DWORD 2
      BE_BIT priority[3];                         // DWORD 2
   } vft_info;
   struct {
      BE_BIT vlan_id[12];                         // DWORD 2
      BE_BIT CFI;                                 // DWORD 2
      BE_BIT user_priority[3];                    // DWORD 2
   } vlan_info;
   BE_BIT rsvd1[32];                              // DWORD 3
} SG_PACK BE_RPI_CONTEXT_AMAP;
typedef struct { u32 dw[4]; } RPI_CONTEXT_AMAP, *PRPI_CONTEXT_AMAP;


// Context for I/O when DIF is disabled. Green fields are constants, loaded by TxULP only
// once when the context is created; pink fields are updated at run time by RxULP; blue
// fields are updated at run time by TxULP; and white fields are updated at run time by
// either ULP. All pink, blue, and white fields shall be initialized to zero.
typedef struct {
   BE_BIT data_placement_offset[10];              // DWORD 0
   BE_BIT inhibit_auto_abort;                     // DWORD 0
   BE_BIT exchange_originator;                    // DWORD 0
   BE_BIT erp;                                    // DWORD 0
   BE_BIT init_rec_tov[3];                        // DWORD 0
   BE_BIT request_tag[16];                        // DWORD 0
   BE_BIT my_fc_id[24];                           // DWORD 1
   BE_BIT init_r_a_tov[4];                        // DWORD 1
   BE_BIT init_e_d_tov[3];                        // DWORD 1
   BE_BIT port;                                   // DWORD 1
   BE_BIT peer_fc_id[24];                         // DWORD 2
   BE_BIT rsvd0[8];                               // DWORD 2
   BE_BIT expected_xfer_count[24];                // DWORD 3
   BE_BIT rsvd1[8];                               // DWORD 3
   BE_BIT task_retry_id[32];                      // DWORD 4
   BE_BIT abort_tag[32];                          // DWORD 5
   BE_BIT command_iu_length[10];                  // DWORD 6
   BE_BIT cq_id[10];                              // DWORD 6
   BE_BIT wrb_ring_id[10];                        // DWORD 6
   BE_BIT await_els_reply_code[2];                // DWORD 6
   BE_BIT r2t_pidx[10];                           // DWORD 7
   BE_BIT r2t_flip;                               // DWORD 7
   BE_BIT rx_r2t_enqueued;                        // DWORD 7
   BE_BIT discard_fcp_frames;                     // DWORD 7
   BE_BIT rx_invalid;                             // DWORD 7
   BE_BIT rx_abt;                                 // DWORD 7
   BE_BIT expected_data_retransmission;           // DWORD 7
   BE_BIT remote_x_id[16];                        // DWORD 7
   BE_BIT error_recovery_tov[8];                  // DWORD 8
   BE_BIT rec_tov[8];                             // DWORD 8
   BE_BIT e_d_tov[8];                             // DWORD 8
   BE_BIT cmd_tov[8];                             // DWORD 8
   BE_BIT in_sequence;                            // DWORD 9
   BE_BIT ooo_data_xfer;                          // DWORD 9
   BE_BIT conf_iu_req;                            // DWORD 9
   BE_BIT rpi_timewait;                           // DWORD 9
   BE_BIT delayed_abts_ipc;                       // DWORD 9
   BE_BIT paused;                                 // DWORD 9
   BE_BIT srr_sent;                               // DWORD 9
   BE_BIT rec_sent;                               // DWORD 9
   BE_BIT rec_retry_allowed;                      // DWORD 9
   BE_BIT abts_sent;                              // DWORD 9
   BE_BIT abts_retry_allowed;                     // DWORD 9
   BE_BIT delayed_abts;                           // DWORD 9
   BE_BIT secondary_rrq_sent;                     // DWORD 9
   BE_BIT secondary_r_a_tov_enab;                 // DWORD 9
   BE_BIT secondary_abts_sent;                    // DWORD 9
   BE_BIT secondary_abts_retry_allowed;           // DWORD 9
   BE_BIT rx_seq_cnt[16];                         // DWORD 9
   BE_BIT rx_total_bytes_xfer[24];                // DWORD 10
   BE_BIT seq_id[8];                              // DWORD 10
   BE_BIT rx_expected_relative_offset[24];        // DWORD 11
   BE_BIT rsvd2[8];                               // DWORD 11
   BE_BIT tx_total_bytes_xfer[24];                // DWORD 12
   BE_BIT priority[3];                            // DWORD 12
   BE_BIT pv;                                     // DWORD 12
   BE_BIT max_buf_size[2];                        // DWORD 12
   BE_BIT dif_en;                                 // DWORD 12
   BE_BIT sctx;                                   // DWORD 12
   BE_BIT tx_expected_relative_offset[24];        // DWORD 13
   BE_BIT single_frame_write;                     // DWORD 13
   BE_BIT rsvd3[7];                               // DWORD 13
   BE_BIT cur_frag_ptr[9];                        // DWORD 14
   BE_BIT ct[2];                                  // DWORD 14
   BE_BIT reset_ero;                              // DWORD 14
   BE_BIT tx_r2t_dequeued;                        // DWORD 14
   BE_BIT tx_r2t_completed;                       // DWORD 14
   BE_BIT invalid;                                // DWORD 14
   BE_BIT tx_abt;                                 // DWORD 14
   BE_BIT cur_frag_offset[16];                    // DWORD 14
   BE_BIT cmd_type[4];                            // DWORD 15
   BE_BIT rpi[12];                                // DWORD 15
   BE_BIT tx_seq_cnt[16];                         // DWORD 15
} SG_PACK BE_FC_ICD_CONTEXT_AMAP;
typedef struct { u32 dw[16]; } FC_ICD_CONTEXT_AMAP, *PFC_ICD_CONTEXT_AMAP;


// ICD information associated with transmit/write command processing. Should be maintained
// in sync with the last 16 bytes of FC_ICD_CONTEXT.
typedef struct {
   BE_BIT total_bytes_xfer[24];                   // DWORD 0
   BE_BIT priority[3];                            // DWORD 0
   BE_BIT pv;                                     // DWORD 0
   BE_BIT max_buf_size[2];                        // DWORD 0
   BE_BIT dif_en;                                 // DWORD 0
   BE_BIT sctx;                                   // DWORD 0
   BE_BIT expected_relative_offset[24];           // DWORD 1
   BE_BIT single_frame_write;                     // DWORD 1
   BE_BIT rsvd0[7];                               // DWORD 1
   BE_BIT cur_frag_ptr[9];                        // DWORD 2
   BE_BIT ct[2];                                  // DWORD 2
   BE_BIT reset_ero;                              // DWORD 2
   BE_BIT tx_r2t_dequeued;                        // DWORD 2
   BE_BIT tx_r2t_completed;                       // DWORD 2
   BE_BIT invalid;                                // DWORD 2
   BE_BIT tx_abt;                                 // DWORD 2
   BE_BIT cur_frag_offset[16];                    // DWORD 2
   BE_BIT cmd_type[4];                            // DWORD 3
   BE_BIT rpi[12];                                // DWORD 3
   BE_BIT seq_cnt[16];                            // DWORD 3
} SG_PACK BE_TX_ICD_AMAP;
typedef struct { u32 dw[4]; } TX_ICD_AMAP, *PTX_ICD_AMAP;


// Saved Buffer Descriptor (reserved field overloaded with info. for multi-frame
// XMIT_SEQUENCE64)
typedef struct {
   BE_BIT frag_pa_hi[32];                         // DWORD 0
   BE_BIT frag_pa_lo[32];                         // DWORD 1
   BE_BIT ox_id[16];                              // DWORD 2
   BE_BIT request_tag[16];                        // DWORD 2
   BE_BIT frag_len[17];                           // DWORD 3
   BE_BIT rsvd0[2];                               // DWORD 3
   BE_BIT cq_id[12];                              // DWORD 3
   BE_BIT ddr;                                    // DWORD 3
} SG_PACK BE_TX_BUFFER_DESC_AMAP;
typedef struct { u32 dw[4]; } TX_BUFFER_DESC_AMAP, *PTX_BUFFER_DESC_AMAP;


// Information associated with default buffer queue/ring.
typedef struct {
   BE_BIT r_ctl_mask[8];                          // DWORD 0
   BE_BIT type_mask[8];                           // DWORD 0
   BE_BIT r_ctl_match[8];                         // DWORD 0
   BE_BIT type_match[8];                          // DWORD 0
   BE_BIT ring_id[16];                            // DWORD 1
   BE_BIT rsvd0[16];                              // DWORD 1
} SG_PACK BE_Def_Buffer_Queue_Info_AMAP;
typedef struct { u32 dw[2]; } Def_Buffer_Queue_Info_AMAP, *PDef_Buffer_Queue_Info_AMAP;


// FC WRB send ring context. Each per FCF FC_CONTEXT will be associated with multiple
// FC_WRB_RING_CONTEXT, txulp process WRB and R2T requests based on FC_WRB_RING_CONTEXT.
typedef struct {
   BE_RING_CONTEXT_FC_AMAP ring_context_fc;
   BE_BIT xri_start[12];                          // DWORD 2
   BE_BIT xri_end_lo_4bit[4];                     // DWORD 2
   BE_BIT local_flow_id[5];                       // DWORD 2
   BE_BIT global_flow_id[5];                      // DWORD 2
   BE_BIT rsvd0[2];                               // DWORD 2
   BE_BIT yellow_to_red_local;                    // DWORD 2
   BE_BIT yellow_to_red_global;                   // DWORD 2
   BE_BIT no_remain_allowed;                      // DWORD 2
   BE_BIT excess_qos;                             // DWORD 2
   BE_BIT dq_id[10];                              // DWORD 3
   BE_BIT xri_end_hi_8bit[8];                     // DWORD 3
   BE_BIT rsvd1[3];                               // DWORD 3
   BE_BIT rx_r2t_valid;                           // DWORD 3
   BE_BIT r2t_pidx[10];                           // DWORD 3
   BE_TX_BUFFER_DESC_AMAP saved_bd;
   BE_TX_ICD_AMAP icd;
   BE_BIT ext_hdr;                                // DWORD 12
   BE_BIT vlan_dis;                               // DWORD 12
   BE_BIT port;                                   // DWORD 12
   BE_BIT target;                                 // DWORD 12
   BE_BIT inhibit_auto_abort;                     // DWORD 12
   BE_BIT ctx_invalid;                            // DWORD 12
   BE_BIT emulex_adapter;                         // DWORD 12
   BE_BIT rsvd2;                                  // DWORD 12
   BE_BIT cur_icd[12];                            // DWORD 12
   BE_BIT rpi_start[12];                          // DWORD 12
   BE_BIT cur_bytes_left[24];                     // DWORD 13
   BE_BIT tx_state[3];                            // DWORD 13
   BE_BIT tx_r2t_valid;                           // DWORD 13
   BE_BIT fence_count_decremented;                // DWORD 13
   BE_BIT unsend_sge;                             // DWORD 13
   BE_BIT rsvd3[2];                               // DWORD 13
   BE_BIT PU[2];                                  // DWORD 14
   BE_BIT SI;                                     // DWORD 14
   BE_BIT rsvd4[2];                               // DWORD 14
   BE_BIT FSeq;                                   // DWORD 14
   BE_BIT ER;                                     // DWORD 14
   BE_BIT LS;                                     // DWORD 14
   BE_BIT DF_CTL[8];                              // DWORD 14
   BE_BIT Type[8];                                // DWORD 14
   BE_BIT R_CTL[8];                               // DWORD 14
   BE_BIT remote_x_id[16];                        // DWORD 15
   BE_BIT rsvd5[4];                               // DWORD 15
   BE_BIT rpi_end[12];                            // DWORD 15
} SG_PACK BE_FC_WRB_RING_CONTEXT_AMAP;
typedef struct { u32 dw[16]; } FC_WRB_RING_CONTEXT_AMAP, *PFC_WRB_RING_CONTEXT_AMAP;


// FC context associated with FCF end points. Tpre processes incoming FCoE frame based on
// one of the 64 FC_CONTEXT_MW looked up by FCoE CAM.
typedef struct {
   BE_Def_Buffer_Queue_Info_AMAP dq_info[4];
   BE_BIT src_fcf_mac_hi[16];                     // DWORD 8
   BE_BIT fcf_id[7];                              // DWORD 8
   BE_BIT pdid[5];                                // DWORD 8
   BE_BIT target;                                 // DWORD 8
   BE_BIT ext_hdr;                                // DWORD 8
   BE_BIT vlan_dis;                               // DWORD 8
   BE_BIT ctx_invalid;                            // DWORD 8
   BE_BIT src_fcf_mac_lo[32];                     // DWORD 9
   BE_BIT rsvd0[192];                             // DWORD 10
} SG_PACK BE_FC_CONTEXT_AMAP;
typedef struct { u32 dw[16]; } FC_CONTEXT_AMAP, *PFC_CONTEXT_AMAP;


// RPI/VPI/VFI/FCFI based FC header template address
typedef struct {
   BE_BIT header_template_base_addr_hi[32];       // DWORD 0
   BE_BIT header_template_base_addr_lo[32];       // DWORD 1
} SG_PACK BE_HEADER_TEMPLATE_ADDRESS_AMAP;
typedef struct { u32 dw[2]; } HEADER_TEMPLATE_ADDRESS_AMAP, *PHEADER_TEMPLATE_ADDRESS_AMAP;


// Allocated in context memory for ARM to convey some configuration information to FCoE
// rxulp
typedef struct {
   BE_BIT r2t_base_addr[32];                      // DWORD 0
   BE_BIT rsvd0[20];                              // DWORD 1
   BE_BIT def_cam_id_port0[6];                    // DWORD 1
   BE_BIT def_cam_id_port1[6];                    // DWORD 1
   BE_BIT ddr_header_template_base_addr[32];      // DWORD 2
   BE_BIT fc_cr_cookie[32];                       // DWORD 3
} SG_PACK BE_FC_CONFIG_INFO_AMAP;
typedef struct { u32 dw[4]; } FC_CONFIG_INFO_AMAP, *PFC_CONFIG_INFO_AMAP;


// FCoE Receive Queue (RQ) Context
typedef struct {
   BE_BIT dbuf_cindex[13];                        // DWORD 0
   BE_BIT port;                                   // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT ring_size[4];                           // DWORD 0
   BE_BIT ring_state[4];                          // DWORD 0
   BE_BIT rsvd1[8];                               // DWORD 0
   BE_BIT dbuf_pindex[13];                        // DWORD 1
   BE_BIT rsvd2;                                  // DWORD 1
   BE_BIT pci_func_id[8];                         // DWORD 1
   BE_BIT rx_pdid[9];                             // DWORD 1
   BE_BIT rx_pdid_valid;                          // DWORD 1
   BE_BIT default_buffer_size[16];                // DWORD 2
   BE_BIT cq_id_recv[10];                         // DWORD 2
   BE_BIT rx_pdid_not_valid;                      // DWORD 2
   BE_BIT rsvd3[5];                               // DWORD 2
   BE_BIT rsvd4[32];                              // DWORD 3
} SG_PACK BE_FCOE_DEFAULT_PDU_CONTEXT_AMAP;
typedef struct { u32 dw[4]; } FCOE_DEFAULT_PDU_CONTEXT_AMAP, *PFCOE_DEFAULT_PDU_CONTEXT_AMAP;


//          Per-domain IOPS/bytes counters maintained by FC TXULP for enforcing quality of
// service.     
typedef struct {
   BE_BIT iops_count[13];                         // DWORD 0
   BE_BIT byte_count[19];                         // DWORD 0
} SG_PACK BE_FC_QOS_COUNTERS_AMAP;
typedef struct { u32 dw[1]; } FC_QOS_COUNTERS_AMAP, *PFC_QOS_COUNTERS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __fc_device_context_amap_h__

