/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fc_enums_amap_h__
#define __fc_enums_amap_h__
#include "setypes.h"
#include "defines.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- CFG7_COMPILE_OPTIONS ---
#define CFG7_DEBUG_CHECKSUM_ICD         (0)       // Checksum ICD before unload and after
                                                  // load to catch corruption.
#define CFG7_SPLIT_R2T_RINGS            (0)       
#define ENABLE_PRIORITY_PAUSE           (0)       
#define CFG7_ENABLE_B2B_ICD             (1)       
#define CFG7_ENABLE_R2T_WDMA_RESP       (1)       
#define ABTS_PUP_D_ID                   (1)       

typedef enum {
   ENUM_CFG7_DEBUG_CHECKSUM_ICD = 0x0UL,
   ENUM_CFG7_SPLIT_R2T_RINGS = 0x0UL,
   ENUM_ENABLE_PRIORITY_PAUSE = 0x0UL,
   ENUM_CFG7_ENABLE_B2B_ICD = 0x1UL,
   ENUM_CFG7_ENABLE_R2T_WDMA_RESP = 0x1UL,
   ENUM_ABTS_PUP_D_ID = 0x1UL
} CFG7_COMPILE_OPTIONS;

// --- FC_XTENSA_TIMER_FREQ ---
// Global constant: Xtensa clock frequency
#define MICROSECONDS_PER_SECOND         (1000000) // 500 MHz
#define XTENSA_TIMER_FREQ               (500000000) // 500 MHz

typedef enum {
   ENUM_MICROSECONDS_PER_SECOND = 0xf4240UL,
   ENUM_XTENSA_TIMER_FREQ = 0x1dcd6500UL
} FC_XTENSA_TIMER_FREQ;

// --- FC_PRIORITY_PAUSE_CONSTANTS ---
// Global constants related to priority pause (credit management) mechanism
#define FC_XON_TIMER_COUNT              (3)       // Time to wait before sending XON when
                                                  // no frames are received, in timer
                                                  // intervals
#define FC_TMR_INTERVAL_US              (5)       // Hardware timer interval, in
                                                  // microseconds
#define FC_PORT_PDID_BASE               (8)       // PDID base for ports 0,1
#define FC_DBCRED_COST                  (9)       // Cost per frame
#define FC_XON_TIMER_US                 (15)      // Time to wait before sending XON when
                                                  // no frames are received, in
                                                  // microseconds
#define FC_CRED_RTN_THRESH              (25)      // Number of credits to accumulate
                                                  // before RxULP returns them to TPRE
#define FC_XOFF_LATENCY                 (80)      // Latency from the time TPRE determines
                                                  // it needs to send XOFF to the time the
                                                  // switch receives the XOFF, in terms of
                                                  // minimum size frames we must soak up.
                                                  // This is calculated as follows: a 2KB
                                                  // frame at 10Gbps will take
                                                  // approximately 2 us to be received. If
                                                  // it takes 10 us to transmit a pause
                                                  // frame, then 10/2 = 5 2KB frames will
                                                  // arrive and thus we need 5x9 = 45
                                                  // PBUFs to hold the frames without
                                                  // dropping them.
#define FC_DBCRED_CREDITS               (96)      // Total number of credits
#define FC_MIN_PBUFS_FOR_NIC            (160)     // Minumum number of PBUFs for NIC
                                                  // function(s)
#define FC_PARTITION_SIZE               (176)     // Size of an FCoE PMEM partition
#define FC_FCOE_PBUFS                   (352)     // Number of PBUFs set aside for FCoE
                                                  // function(s)
#define FC_PBUFS                        (512)     // Total number of PBUFs
#define FC_XON_TIMER_DELTA              (2500)    // Load value for hw timer

typedef enum {
   ENUM_FC_XON_TIMER_COUNT = 0x3UL,
   ENUM_FC_TMR_INTERVAL_US = 0x5UL,
   ENUM_FC_PORT_PDID_BASE = 0x8UL,
   ENUM_FC_DBCRED_COST = 0x9UL,
   ENUM_FC_XON_TIMER_US = 0xfUL,
   ENUM_FC_CRED_RTN_THRESH = 0x19UL,
   ENUM_FC_XOFF_LATENCY = 0x50UL,
   ENUM_FC_DBCRED_CREDITS = 0x60UL,
   ENUM_FC_MIN_PBUFS_FOR_NIC = 0xa0UL,
   ENUM_FC_PARTITION_SIZE = 0xb0UL,
   ENUM_FC_FCOE_PBUFS = 0x160UL,
   ENUM_FC_PBUFS = 0x200UL,
   ENUM_FC_XON_TIMER_DELTA = 0x9c4UL
} FC_PRIORITY_PAUSE_CONSTANTS;

// --- FC_ICD_UNDERLYING_CMD_TYPE ---
// FC (Emulex) underlying command types.
#define FCP_CMD_RCV_DATA                (0)       // 0000b = receive FCP data.
#define FCP_CMD_INI_MODE                (0)       // 0000b = FCP initiator mode.
#define FCP_CMD_DATA_DIR                (1)       // 0001b = mask for direction of data
                                                  // transfer
#define FCP_CMD_XMT_DATA                (1)       // 0001b = transmit FCP data.
#define FCP_CMD_INI_TGT                 (2)       // 0010b = mask for initiator/target
                                                  // mode
#define FCP_CMD_TGT_MODE                (2)       // 0010b = FCP target mode.

typedef enum {
   ENUM_FCP_CMD_RCV_DATA = 0x0UL,
   ENUM_FCP_CMD_INI_MODE = 0x0UL,
   ENUM_FCP_CMD_DATA_DIR = 0x1UL,
   ENUM_FCP_CMD_XMT_DATA = 0x1UL,
   ENUM_FCP_CMD_INI_TGT = 0x2UL,
   ENUM_FCP_CMD_TGT_MODE = 0x2UL
} FC_ICD_UNDERLYING_CMD_TYPE;

// --- FC_ICD_CMD_TYPE ---
// FC (Emulex) command type.
#define FCP_CMD_READ                    (0)       // 0000b = FCP initiator command with
                                                  // read or no data transfer.
#define FCP_CMD_WRITE                   (1)       // 0001b = FCP initiator command with
                                                  // write data transfer.
#define FCP_CMD_RECEIVE                 (2)       // 0010b = FCP target command with write
                                                  // data transfer.
#define FCP_CMD_SEND                    (3)       // 0011b = FCP target command with read
                                                  // data transfer.
#define FCP_CMD_RESP                    (4)       // 0100b = FCP target command response.
#define bNonFCP                         (8)       // 1000b = Mask for Non-FCP command.
#define bELS                            (4)       // 0100b = Mask for ELS request.
#define bRAW                            (2)       // 0010b = Mask for RAW FCoE request.
#define bFIP                            (1)       // 0001b = Mask for FIP request.
#define RAW_FCOE                        (10)      // 1010b = Raw FCoE transmit request.

typedef enum {
   ENUM_FCP_CMD_READ = 0x0UL,
   ENUM_FCP_CMD_WRITE = 0x1UL,
   ENUM_FCP_CMD_RECEIVE = 0x2UL,
   ENUM_FCP_CMD_SEND = 0x3UL,
   ENUM_FCP_CMD_RESP = 0x4UL,
   ENUM_bNonFCP = 0x8UL,
   ENUM_bELS = 0x4UL,
   ENUM_bRAW = 0x2UL,
   ENUM_bFIP = 0x1UL,
   ENUM_RAW_FCOE = 0xaUL
} FC_ICD_CMD_TYPE;

// --- FC_DERIVED_EXCHANGES ---
// FC exchanges derived from base (I/O) exchange ID
#define OX_ID_UPPER_BITS_IO             (0)       // Normal case (i.e. the original I/O
                                                  // itself)
#define OX_ID_UPPER_BITS_REC            (4096)    // Used for REC transmission
#define OX_ID_UPPER_BITS_SRR            (8192)    // Used for SRR transmission
#define OX_ID_UPPER_BITS_RRQ            (12288)   // Used for RRQ transmission
#define OX_ID_UPPER_BITS_HOST           (61440)   // Used for host-created exchanges that
                                                  // have no corresponding ICD
#define OX_ID_UPPER_BITS_MASK           (61440)   // Mask
#define OX_ID_UPPER_BITS_SHIFT          (12)      // Bit shift

typedef enum {
   ENUM_OX_ID_UPPER_BITS_IO = 0x0UL,
   ENUM_OX_ID_UPPER_BITS_REC = 0x1000UL,
   ENUM_OX_ID_UPPER_BITS_SRR = 0x2000UL,
   ENUM_OX_ID_UPPER_BITS_RRQ = 0x3000UL,
   ENUM_OX_ID_UPPER_BITS_HOST = 0xf000UL,
   ENUM_OX_ID_UPPER_BITS_MASK = 0xf000UL,
   ENUM_OX_ID_UPPER_BITS_SHIFT = 0xcUL
} FC_DERIVED_EXCHANGES;

// --- FC_CT_TYPES ---
// FC WRB CONTEXT_TAG types
#define CT_RPI                          (0)       // CONTEXT_TAG contains RPI
#define CT_VPI                          (1)       // CONTEXT_TAG contains VPI
#define CT_VFI                          (2)       // CONTEXT_TAG contains VFI
#define CT_FCFI                         (3)       // CONTEXT_TAG contains FCFI

typedef enum {
   ENUM_CT_RPI = 0x0UL,
   ENUM_CT_VPI = 0x1UL,
   ENUM_CT_VFI = 0x2UL,
   ENUM_CT_FCFI = 0x3UL
} FC_CT_TYPES;

// --- FC_PARAMETER_USAGE ---
// FC WRB PU values for the different usage of WRB.dword4 (parameter)
#define PU_NONE                         (0)       // Parameter not used
#define PU_OFFSET                       (1)       // Parameter is starting relative offset
#define PU_TRANSFER_COUNT               (2)       // Parameter is transfer count

typedef enum {
   ENUM_PU_NONE = 0x0UL,
   ENUM_PU_OFFSET = 0x1UL,
   ENUM_PU_TRANSFER_COUNT = 0x2UL
} FC_PARAMETER_USAGE;

// --- FC_ABT_CRITERIA ---
// FC abort scan 'criteria' definitions
#define CRITERIA_NONE                   (0)       // No criterion in effect.
#define CRITERIA_XRI_TAG                (1)       // To abort given XRI_TAG
#define CRITERIA_ABORT_TAG              (2)       // To abort given ABORT_TAG
#define CRITERIA_REQUEST_TAG            (3)       // To abort given REQUEST_TAG
#define CRITERIA_RPI_TAG                (4)       // To abort given RPI_TAG (via ARM
                                                  // mailbox command UNREG_RPI)
#define CRITERIA_XRI_RANGE              (5)       // To abort all XRIs in range (via ARM
                                                  // mailbox command Function Level Reset)

typedef enum {
   ENUM_CRITERIA_NONE = 0x0UL,
   ENUM_CRITERIA_XRI_TAG = 0x1UL,
   ENUM_CRITERIA_ABORT_TAG = 0x2UL,
   ENUM_CRITERIA_REQUEST_TAG = 0x3UL,
   ENUM_CRITERIA_RPI_TAG = 0x4UL,
   ENUM_CRITERIA_XRI_RANGE = 0x5UL
} FC_ABT_CRITERIA;

// --- FC_SEARCH_CRITERIA ---
// Define additional scan criteria
#define CRITERIA_PAUSE_IOS              (6)       // Pause all I/Os associated with the
                                                  // given port
#define CRITERIA_RESUME_RPI             (7)       // Resume all I/Os associated with the
                                                  // given RPI
#define CRITERIA_RESUME_VPI_VFI_FCFI    (8)       // Resume all I/Os not associated with
                                                  // an RPI (fc_icd.ct != 0)

typedef enum {
   ENUM_CRITERIA_PAUSE_IOS = 0x6UL,
   ENUM_CRITERIA_RESUME_RPI = 0x7UL,
   ENUM_CRITERIA_RESUME_VPI_VFI_FCFI = 0x8UL
} FC_SEARCH_CRITERIA;

// --- FC_LINK_STATUS ---
// Link status
#define FC_LINK_DOWN                    (0)       // A link down event has occurred
#define FC_LINK_UP                      (1)       // A link up event has occurred

typedef enum {
   ENUM_FC_LINK_DOWN = 0x0UL,
   ENUM_FC_LINK_UP = 0x1UL
} FC_LINK_STATUS;

// --- FC_PFC_STATUS ---
// Link status
#define FC_PFC_DISABLE                  (0)       // Disable PFC processing in the EPs
#define FC_PFC_ENABLE                   (1)       // Enable PFC processing in the EPs

typedef enum {
   ENUM_FC_PFC_DISABLE = 0x0UL,
   ENUM_FC_PFC_ENABLE = 0x1UL
} FC_PFC_STATUS;

// --- FC_ELS_ID ---
// Indicates which FIP encapsulated ELS command the ELS_REQUEST64_WQE request is to
// generate
#define ELS_ID_OTHER                    (0)       // Other ELS command
#define ELS_ID_LOGO                     (1)       // LOGO command
#define ELS_ID_FDISC                    (2)       // FDISC command
#define ELS_ID_FLOGI                    (3)       // FLOGI command

typedef enum {
   ENUM_ELS_ID_OTHER = 0x0UL,
   ENUM_ELS_ID_LOGO = 0x1UL,
   ENUM_ELS_ID_FDISC = 0x2UL,
   ENUM_ELS_ID_FLOGI = 0x3UL
} FC_ELS_ID;

// --- FC_ICD_WR_BIT ---
// Type of FC command FRAME.
#define FC_WRB_READ                     (0)       // FC Read command FRAME
#define FC_WRB_WRITE                    (1)       // FC Write command FRAME

typedef enum {
   ENUM_FC_WRB_READ = 0x0UL,
   ENUM_FC_WRB_WRITE = 0x1UL
} FC_ICD_WR_BIT;

// --- FC_WRB_INVALID_BIT ---
// WRB invalid bit
#define FC_WRB_VALID                    (0)       // WRB request is valid
#define FC_WRB_INVALID                  (1)       // WRB request is invalid

typedef enum {
   ENUM_FC_WRB_VALID = 0x0UL,
   ENUM_FC_WRB_INVALID = 0x1UL
} FC_WRB_INVALID_BIT;

// --- FC_DIF_BLK_SIZE ---
// All the supported DIF block sizes.
#define FC_BS_512_BYTES                 (0)       // Block size of 512 bytes
#define FC_BS_1024_BYTES                (1)       // Block size of 1024 bytes
#define FC_BS_4096_BYTES                (2)       // Block size of 4096 bytes

typedef enum {
   ENUM_FC_BS_512_BYTES = 0x0UL,
   ENUM_FC_BS_1024_BYTES = 0x1UL,
   ENUM_FC_BS_4096_BYTES = 0x2UL
} FC_DIF_BLK_SIZE;

// --- FC_DIF_MODES ---
// All the supported DIF modes.
#define FC_DIF_PASS_THRU                (0)       // Verify and pass the 8-byte DIF
                                                  // without modifying it
#define FC_DIF_REPLACE                  (1)       // Verify and replace the reference tag
                                                  // within the 8-byte DIF
#define FC_DIF_DELETE                   (2)       // Verify and remove the 8-byte DIF from
                                                  // the data stream
#define FC_DIF_INSERT                   (3)       // Insert the 8-byte DIF in the data
                                                  // stream

typedef enum {
   ENUM_FC_DIF_PASS_THRU = 0x0UL,
   ENUM_FC_DIF_REPLACE = 0x1UL,
   ENUM_FC_DIF_DELETE = 0x2UL,
   ENUM_FC_DIF_INSERT = 0x3UL
} FC_DIF_MODES;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __fc_enums_amap_h__

