/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __host_struct_amap_h__
#define __host_struct_amap_h__
#include "setypes.h"
#include "defines.h"
#include "headers.h"
#include "be_cm.h"
#include "rxf.h"
#include "descriptors.h"
#include "iscsi_initiator_host_struct.h"
#include "iscsi_target_host_struct.h"
#include "fc_enums.h"
#include "fc_common_host_struct.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// This is an LRO Completion Descriptor
typedef struct {
   BE_BIT tcp_ack_number[32];                     // DWORD 0
   BE_BIT tcp_timestamp_ecr[32];                  // DWORD 1
   BE_BIT tcp_window[16];                         // DWORD 2
   BE_BIT vlan_tag[16];                           // DWORD 2
   BE_BIT pktsize[16];                            // DWORD 3
   BE_BIT dupack_count[2];                        // DWORD 3
   BE_BIT qinq;                                   // DWORD 3
   BE_BIT tsopt;                                  // DWORD 3
   BE_BIT ip_version;                             // DWORD 3
   BE_BIT snap;                                   // DWORD 3
   BE_BIT tcp_push;                               // DWORD 3
   BE_BIT vtp;                                    // DWORD 3
   BE_BIT lro_flush;                              // DWORD 3
   BE_BIT lro_timer_pop;                          // DWORD 3
   BE_BIT cid[5];                                 // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_HW_LRO_COMPL_AMAP;
typedef struct { u32 dw[4]; } HW_LRO_COMPL_AMAP, *PHW_LRO_COMPL_AMAP;


// TOE Default Buffer Work Request Entry
typedef struct {
   BE_BIT frag_addr_hi[32];                       // DWORD 0
   BE_BIT frag_addr_lo[32];                       // DWORD 1
} SG_PACK BE_TOE_DEFBUFFER_AMAP;
typedef struct { u32 dw[2]; } TOE_DEFBUFFER_AMAP, *PTOE_DEFBUFFER_AMAP;


// --- TOE_PREBUFFER_TYPE ---
// The different WRB types posted in the TOE preposted buffer receive queue.
#define TOE_PREBUFFER_TYPE_HDR          (0)       
#define TOE_PREBUFFER_TYPE_DUMMY        (1)       
#define TOE_PREBUFFER_TYPE_SGE          (2)       

typedef enum {
   ENUM_TOE_PREBUFFER_TYPE_HDR = 0x0UL,
   ENUM_TOE_PREBUFFER_TYPE_DUMMY = 0x1UL,
   ENUM_TOE_PREBUFFER_TYPE_SGE = 0x2UL
} TOE_PREBUFFER_TYPE;

// TOE Preposted Buffer WRB.
typedef struct {
   BE_BIT frag_addr_hi[32];                       // DWORD 0
   BE_BIT frag_addr_lo[32];                       // DWORD 1
   BE_BIT sgl_bytes[31];                          // DWORD 2
   BE_BIT rsvd0;                                  // DWORD 2
   BE_BIT frag_len[20];                           // DWORD 3
   BE_BIT frag_cnt[8];                            // DWORD 3
   BE_BIT sgl_group_last;                         // DWORD 3
   BE_BIT rsvd1;                                  // DWORD 3
   BE_BIT push_mode;                              // DWORD 3
   BE_BIT rsvd2;                                  // DWORD 3
} SG_PACK BE_TOE_PREBUFFER_AMAP;
typedef struct { u32 dw[4]; } TOE_PREBUFFER_AMAP, *PTOE_PREBUFFER_AMAP;


// --- TOE_TX_ERROR_CODES ---
// Error codes received in TOE receive completions.
#define TCP_WARN_KEEPALIVE_PROBE        (1)       // Indicates that firmware is starting
                                                  // keepalive probes on account of the
                                                  // connection being idle for ka_timeout
                                                  // time.
#define TCP_ERROR_SYN_IN_WINDOW         (2)       // Indicates the connection was closed
                                                  // because we received a SYN in window.
#define TCP_ERROR_URGENT_RECEIVED       (19)      // Indicates that the connection was
                                                  // closed because an urgent packet was
                                                  // recieved on the connection,
                                                  // connection will transition to
                                                  // TCPS_CLOSED.
#define TCP_WARN_TIMEOUT_BACKOFF        (35)      // Indicates that the toe is backing off
                                                  // on retransmits, happens on every
                                                  // retransmit after the 3rd one for the
                                                  // connection. There will be no state
                                                  // change corresponding to this error
                                                  // code.
#define TCP_ERROR_KA_TIMED_OUT          (45)      // Indicates that the connection timed
                                                  // out. Occurs when we do not get a
                                                  // response to 'ka_probe_max' probes.
#define TCP_ERROR_RESET_RECEIVED        (53)      // Indicates that the connection was
                                                  // closed because a valid reset was
                                                  // received. Connection will transition
                                                  // to TCPS_CLOSED.
#define TCP_ERROR_TIMED_OUT             (60)      // Indicates that the connection timed
                                                  // out. Occurs after 12 retransmit
                                                  // attempts on the connection.
                                                  // Connectinon will transition to
                                                  // TCPS_CLOSED.
#define TCP_FINWAIT2_TIMED_OUT          (61)      // Indicates that the connection timed
                                                  // out in FINWAIT2 state. Connectinon
                                                  // will transition to TCPS_CLOSED.
#define TCP_WARN_MAX_RT_TIMED_OUT       (63)      // Indicates that the connection timed
                                                  // out b'cos of the retransmission time
                                                  // instead of count.

typedef enum {
   ENUM_TCP_WARN_KEEPALIVE_PROBE = 0x1UL,
   ENUM_TCP_ERROR_SYN_IN_WINDOW = 0x2UL,
   ENUM_TCP_ERROR_URGENT_RECEIVED = 0x13UL,
   ENUM_TCP_WARN_TIMEOUT_BACKOFF = 0x23UL,
   ENUM_TCP_ERROR_KA_TIMED_OUT = 0x2dUL,
   ENUM_TCP_ERROR_RESET_RECEIVED = 0x35UL,
   ENUM_TCP_ERROR_TIMED_OUT = 0x3cUL,
   ENUM_TCP_FINWAIT2_TIMED_OUT = 0x3dUL,
   ENUM_TCP_WARN_MAX_RT_TIMED_OUT = 0x3fUL
} TOE_TX_ERROR_CODES;

// --- TOE_COMPL_TYPE_ENUM ---
// Completion types for TOE TX and RX.
#define TX_COMPL_TYPE                   (0)       // Transmit completion.
#define RX_DF_COMPL_TYPE                (1)       // Default buffer completion.
#define RX_PP_COMPL_TYPE                (2)       // Preposted buffer completion.
#define RX_PA_COMPL_TYPE                (3)       // Packed default buffer completion.
#define STATE_CHANGE_TYPE               (4)       // State change notification.
#define TX_FLUSH_TYPE                   (5)       // Flush of transmit CQ after connection
                                                  // upload.
#define RX_FLUSH_TYPE                   (6)       // Flush of default buffer CQ after
                                                  // connection upload.
#define PREPOSTED_FLUSH_TYPE            (7)       // Flush of preposted buffer CQ after
                                                  // connection upload.

typedef enum {
   ENUM_TX_COMPL_TYPE = 0x0UL,
   ENUM_RX_DF_COMPL_TYPE = 0x1UL,
   ENUM_RX_PP_COMPL_TYPE = 0x2UL,
   ENUM_RX_PA_COMPL_TYPE = 0x3UL,
   ENUM_STATE_CHANGE_TYPE = 0x4UL,
   ENUM_TX_FLUSH_TYPE = 0x5UL,
   ENUM_RX_FLUSH_TYPE = 0x6UL,
   ENUM_PREPOSTED_FLUSH_TYPE = 0x7UL
} TOE_COMPL_TYPE_ENUM;

// This is TOE transmit completion descriptor follows the general TOE completion
// structure.  TOE completions of transmit and receive can occupy the same ring.
typedef struct {
   BE_BIT rsvd0[20];                              // DWORD 0
   BE_BIT wrb_index[12];                          // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT type[3];                                // DWORD 2
   BE_BIT rsvd2[3];                               // DWORD 2
   BE_BIT rsvd3[13];                              // DWORD 2
   BE_BIT ct[2];                                  // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT seqno[32];                              // DWORD 3
} SG_PACK BE_TOE_TX_COMPL_AMAP;
typedef struct { u32 dw[4]; } TOE_TX_COMPL_AMAP, *PTOE_TX_COMPL_AMAP;


// This is TOE receive completion descriptor follows the general TOE_COMPL structure. Toe
// completions of transmit and receive can occupy the same ring.
typedef struct {
   BE_BIT prepostoffs[20];                        // DWORD 0
   BE_BIT wrb_index[12];                          // DWORD 0
   BE_BIT bytesrx[20];                            // DWORD 1
   BE_BIT order[3];                               // DWORD 1
   BE_BIT ooo_hi[9];                              // DWORD 1
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT type[3];                                // DWORD 2
   BE_BIT push_timer;                             // DWORD 2
   BE_BIT fin;                                    // DWORD 2
   BE_BIT push_flag;                              // DWORD 2
   BE_BIT ooo_lo[13];                             // DWORD 2
   BE_BIT ct[2];                                  // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT seqno[32];                              // DWORD 3
} SG_PACK BE_TOE_RX_COMPL_AMAP;
typedef struct { u32 dw[4]; } TOE_RX_COMPL_AMAP, *PTOE_RX_COMPL_AMAP;


// This is TOE receive completion descriptor follows the general TOE_COMPL structure. Toe
// completions of transmit and receive can occupy the same ring.
typedef struct {
   BE_BIT hi[32];                                 // DWORD 0
   BE_BIT lo[32];                                 // DWORD 1
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT type[3];                                // DWORD 2
   BE_BIT push_timer;                             // DWORD 2
   BE_BIT fin;                                    // DWORD 2
   BE_BIT push_flag;                              // DWORD 2
   BE_BIT bytesrx[15];                            // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT seqno[32];                              // DWORD 3
} SG_PACK BE_TOE_PA_COMPL_AMAP;
typedef struct { u32 dw[4]; } TOE_PA_COMPL_AMAP, *PTOE_PA_COMPL_AMAP;


// This is TOE transmit completion descriptor follows the general TOE completion
// structure.  TOE completions of transmit and receive can occupy the same ring.
typedef struct {
   BE_BIT rsvd0[20];                              // DWORD 0
   BE_BIT wrb_index[12];                          // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT type[3];                                // DWORD 2
   BE_BIT rsvd2[3];                               // DWORD 2
   BE_BIT rsvd3[13];                              // DWORD 2
   BE_BIT ct[2];                                  // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT seqno[32];                              // DWORD 3
} SG_PACK BE_TOE_TX_FLUSH_COMPL_AMAP;
typedef struct { u32 dw[4]; } TOE_TX_FLUSH_COMPL_AMAP, *PTOE_TX_FLUSH_COMPL_AMAP;


// This is TOE receive completion descriptor follows the general TOE completion structure.
//  TOE completions of transmit and receive can occupy the same ring.
typedef struct {
   BE_BIT prepostoffs[20];                        // DWORD 0
   BE_BIT wrb_index[12];                          // DWORD 0
   BE_BIT bytesrx[20];                            // DWORD 1
   BE_BIT order[3];                               // DWORD 1
   BE_BIT rsvd0[9];                               // DWORD 1
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT type[3];                                // DWORD 2
   BE_BIT rsvd1[3];                               // DWORD 2
   BE_BIT rsvd2[13];                              // DWORD 2
   BE_BIT ct[2];                                  // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT seqno[32];                              // DWORD 3
} SG_PACK BE_TOE_RX_FLUSH_COMPL_AMAP;
typedef struct { u32 dw[4]; } TOE_RX_FLUSH_COMPL_AMAP, *PTOE_RX_FLUSH_COMPL_AMAP;



typedef struct {
   BE_BIT state[16];                              // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT wrb_index[12];                          // DWORD 0
   BE_BIT error_code[16];                         // DWORD 1
   BE_BIT rsvd1[16];                              // DWORD 1
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT type[3];                                // DWORD 2
   BE_BIT rsvd2[3];                               // DWORD 2
   BE_BIT rsvd3[13];                              // DWORD 2
   BE_BIT ct[2];                                  // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT seqno[32];                              // DWORD 3
} SG_PACK BE_TOE_STATE_COMPL_AMAP;
typedef struct { u32 dw[4]; } TOE_STATE_COMPL_AMAP, *PTOE_STATE_COMPL_AMAP;


// Solicited I/O request Completion Queue Entry.
typedef struct {
   BE_BIT HW_Status[8];                           // DWORD 0
   BE_BIT Status[8];                              // DWORD 0
   BE_BIT REQUEST_TAG[16];                        // DWORD 0
   BE_BIT TotalDataPlaced[32];                    // DWORD 1
   BE_BIT Parameter[32];                          // DWORD 2
   BE_BIT rsvd0[16];                              // DWORD 3
   BE_BIT Code[8];                                // DWORD 3
   BE_BIT Pri[3];                                 // DWORD 3
   BE_BIT PV;                                     // DWORD 3
   BE_BIT XB;                                     // DWORD 3
   BE_BIT rsvd1[2];                               // DWORD 3
   BE_BIT Valid;                                  // DWORD 3
} SG_PACK BE_FC_CQ_ENTRY_AMAP;
typedef struct { u32 dw[4]; } FC_CQ_ENTRY_AMAP, *PFC_CQ_ENTRY_AMAP;


// Aborted I/O Completion Queue Entry.
typedef struct {
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT Status[8];                              // DWORD 0
   BE_BIT rsvd1[16];                              // DWORD 0
   BE_BIT RJT_status[32];                         // DWORD 1
   BE_BIT XRI[16];                                // DWORD 2
   BE_BIT Remote_XID[16];                         // DWORD 2
   BE_BIT rsvd2[16];                              // DWORD 3
   BE_BIT Code[8];                                // DWORD 3
   BE_BIT rsvd3[4];                               // DWORD 3
   BE_BIT EO;                                     // DWORD 3
   BE_BIT BR;                                     // DWORD 3
   BE_BIT IA;                                     // DWORD 3
   BE_BIT Valid;                                  // DWORD 3
} SG_PACK BE_FC_XRI_ABORTED_CQE_AMAP;
typedef struct { u32 dw[4]; } FC_XRI_ABORTED_CQE_AMAP, *PFC_XRI_ABORTED_CQE_AMAP;


// Release WRBs Completion Queue Entry.
typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_BIT wrb_index[16];                          // DWORD 2
   BE_BIT WRBQ_ID[16];                            // DWORD 2
   BE_BIT rsvd2[16];                              // DWORD 3
   BE_BIT Code[8];                                // DWORD 3
   BE_BIT rsvd3[7];                               // DWORD 3
   BE_BIT Valid;                                  // DWORD 3
} SG_PACK BE_FC_RELEASE_WRBS_CQ_ENTRY_AMAP;
typedef struct { u32 dw[4]; } FC_RELEASE_WRBS_CQ_ENTRY_AMAP, *PFC_RELEASE_WRBS_CQ_ENTRY_AMAP;


// Unsolicited frame Completion Queue Entry for host.
typedef struct {
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT Status[8];                              // DWORD 0
   BE_BIT RBIndex[12];                            // DWORD 0
   BE_BIT rsvd1[4];                               // DWORD 0
   BE_BIT rsvd2[32];                              // DWORD 1
   BE_BIT FCF_ID[6];                              // DWORD 2
   BE_BIT RBQ_ID[10];                             // DWORD 2
   BE_BIT DataPlacementLength[16];                // DWORD 2
   BE_BIT SOFByte[8];                             // DWORD 3
   BE_BIT EOFByte[8];                             // DWORD 3
   BE_BIT Code[8];                                // DWORD 3
   BE_BIT HdrPlacementLength[6];                  // DWORD 3
   BE_BIT Port;                                   // DWORD 3
   BE_BIT Valid;                                  // DWORD 3
} SG_PACK BE_FC_DEFAULT_FRAME_CQ_ENTRY_AMAP;
typedef struct { u32 dw[4]; } FC_DEFAULT_FRAME_CQ_ENTRY_AMAP, *PFC_DEFAULT_FRAME_CQ_ENTRY_AMAP;


// Unsolicited frame Completion Queue Entry for ARM.
typedef struct {
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT Status[8];                              // DWORD 0
   BE_BIT RBIndex[12];                            // DWORD 0
   BE_BIT rsvd1[4];                               // DWORD 0
   BE_BIT rsvd2[32];                              // DWORD 1
   BE_BIT FCF_ID[6];                              // DWORD 2
   BE_BIT RBQ_ID[10];                             // DWORD 2
   BE_BIT DataPlacementLength[16];                // DWORD 2
   BE_BIT VTag[16];                               // DWORD 3
   BE_BIT Code[8];                                // DWORD 3
   BE_BIT rsvd3[5];                               // DWORD 3
   BE_BIT VTP;                                    // DWORD 3
   BE_BIT Port;                                   // DWORD 3
   BE_BIT Valid;                                  // DWORD 3
} SG_PACK BE_FC_ARM_DEFAULT_FRAME_CQ_ENTRY_AMAP;
typedef struct { u32 dw[4]; } FC_ARM_DEFAULT_FRAME_CQ_ENTRY_AMAP, *PFC_ARM_DEFAULT_FRAME_CQ_ENTRY_AMAP;


// Reply to IPC Completion Queue Entry for ARM.
typedef struct {
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT Status[8];                              // DWORD 0
   BE_BIT rsvd1[16];                              // DWORD 0
   BE_BIT rsvd2[32];                              // DWORD 1
   BE_BIT rsvd3[6];                               // DWORD 2
   BE_BIT RBQ_ID[10];                             // DWORD 2
   BE_BIT rsvd4[16];                              // DWORD 2
   BE_BIT rsvd5[16];                              // DWORD 3
   BE_BIT Code[8];                                // DWORD 3
   BE_BIT rsvd6[7];                               // DWORD 3
   BE_BIT Valid;                                  // DWORD 3
} SG_PACK BE_FC_ARM_IPC_REPLY_CQ_ENTRY_AMAP;
typedef struct { u32 dw[4]; } FC_ARM_IPC_REPLY_CQ_ENTRY_AMAP, *PFC_ARM_IPC_REPLY_CQ_ENTRY_AMAP;


//  		
typedef struct {
   BE_BIT BufferSize[24];                         // DWORD 0
   BE_BIT BufferType[8];                          // DWORD 0
   BE_BIT AddressLow[32];                         // DWORD 1
   BE_BIT AddressHigh[32];                        // DWORD 2
   BE_BIT IO_TAG32[32];                           // DWORD 3
   union {
      BE_BIT TransferLength[32];                  // DWORD 4
      struct {
         BE_BIT expected_xfer_count_lo[16];       // DWORD 4
         BE_BIT expected_xfer_count_hi[8];        // DWORD 4
         BE_BIT rsvd0[8];                         // DWORD 4
      } iwr_xfer_length;
      struct {
         BE_BIT D_ID[24];                         // DWORD 4
         BE_BIT rsvd0[8];                         // DWORD 4
      } xmit_els_rsp;
      struct {
         BE_BIT MM;                               // DWORD 4
         BE_BIT rsvd0[23];                        // DWORD 4
         BE_BIT CRITERIA[8];                      // DWORD 4
      } abort_close_extended;
      struct {
         BE_BIT Parameter[32];                    // DWORD 4
      } gen_request;
      struct {
         BE_BIT S_ID[24];                         // DWORD 4
         BE_BIT SP;                               // DWORD 4
         BE_BIT rsvd0[7];                         // DWORD 4
      } els_request;
   } word4;
   union {
      BE_BIT InitialTransferLength[32];           // DWORD 5
      struct {
         BE_BIT err_sgl_icd_index[16];            // DWORD 5
         BE_BIT err_RPI[16];                      // DWORD 5
      } abort_xri;
      struct {
         BE_BIT rsvd0[8];                         // DWORD 5
         BE_BIT DF_CTL[8];                        // DWORD 5
         BE_BIT TYPE[8];                          // DWORD 5
         BE_BIT R_CTL[8];                         // DWORD 5
      } gen_request;
      struct {
         BE_BIT D_ID[24];                         // DWORD 5
         BE_BIT rsvd0[8];                         // DWORD 5
      } els_request;
   } word5;
   BE_BIT sgl_icd_index[16];                      // DWORD 6
   BE_BIT CONTEXT_TAG[16];                        // DWORD 6
   BE_BIT AC;                                     // DWORD 7
   BE_BIT LE;                                     // DWORD 7
   BE_BIT BDE[2];                                 // DWORD 7
   BE_BIT Status[4];                              // DWORD 7
   BE_BIT Command[8];                             // DWORD 7
   BE_BIT ClassService[3];                        // DWORD 7
   BE_BIT rsvd0;                                  // DWORD 7
   BE_BIT PU[2];                                  // DWORD 7
   BE_BIT ERP;                                    // DWORD 7
   BE_BIT XS;                                     // DWORD 7
   BE_BIT Timer[8];                               // DWORD 7
   BE_BIT IO_TAG64_LOW[32];                       // DWORD 8
   BE_BIT IO_TAG64_HIGH[32];                      // DWORD 9
   BE_BIT rsvd1[16];                              // DWORD 10
   BE_BIT PRI[3];                                 // DWORD 10
   BE_BIT PV;                                     // DWORD 10
   BE_BIT rsvd2[3];                               // DWORD 10
   BE_BIT CCPE;                                   // DWORD 10
   BE_BIT CCP[8];                                 // DWORD 10
   BE_BIT cmd_type[4];                            // DWORD 11
   BE_BIT rsvd3[3];                               // DWORD 11
   BE_BIT flush_wrb;                              // DWORD 11
   BE_BIT rsvd4[8];                               // DWORD 11
   BE_BIT cq_id[10];                              // DWORD 11
   BE_BIT rsvd5[6];                               // DWORD 11
   BE_BIT rsvd6[128];                             // DWORD 12
} SG_PACK BE_FC_WRB_CONTEXT_SLI3_AMAP;
typedef struct { u32 dw[16]; } FC_WRB_CONTEXT_SLI3_AMAP, *PFC_WRB_CONTEXT_SLI3_AMAP;


//  		
typedef struct {
   BE_BIT BufferSize[24];                         // DWORD 0
   BE_BIT BufferType[8];                          // DWORD 0
   BE_BIT AddressLow[32];                         // DWORD 1
   BE_BIT AddressHigh[32];                        // DWORD 2
   union {
      BE_BIT PayloadLength[32];                   // DWORD 3
      struct {
         BE_BIT PayloadOffset[32];                // DWORD 3
      } tsend_trcv_xmitseq;
      struct {
         BE_BIT IA;                               // DWORD 3
         BE_BIT rsvd0[7];                         // DWORD 3
         BE_BIT Criteria[8];                      // DWORD 3
         BE_BIT rsvd1[16];                        // DWORD 3
      } abort;
   } word3;
   union {
      BE_BIT TransferLength[32];                  // DWORD 4
      struct {
         BE_BIT rsvd0[31];                        // DWORD 4
         BE_BIT DR;                               // DWORD 4
      } create_xri;
      struct {
         BE_BIT S_ID[24];                         // DWORD 4
         BE_BIT SP;                               // DWORD 4
         BE_BIT VF;                               // DWORD 4
         BE_BIT rsvd0[6];                         // DWORD 4
      } els_request;
      struct {
         BE_BIT relative_offset[32];              // DWORD 4
      } fcp_tsr;
      struct {
         BE_BIT expected_xfer_count_lo[16];       // DWORD 4
         BE_BIT expected_xfer_count_hi[8];        // DWORD 4
         BE_BIT rsvd0[8];                         // DWORD 4
      } iwr_xfer_length;
      struct {
         BE_BIT relative_offset[32];              // DWORD 4
      } genreq_xmitseq;
   } word4;
   union {
      BE_BIT InitialTransferLength[32];           // DWORD 5
      struct {
         BE_BIT Remote_ID[24];                    // DWORD 5
         BE_BIT rsvd0[8];                         // DWORD 5
      } abort_elsreq_elsrsp_blsrsp;
      struct {
         BE_BIT burst_length[32];                 // DWORD 5
      } fcp_tsr;
      struct {
         BE_BIT rsvd0[3];                         // DWORD 5
         BE_BIT LA;                               // DWORD 5
         BE_BIT rsvd1[4];                         // DWORD 5
         BE_BIT DF_CTL[8];                        // DWORD 5
         BE_BIT TYPE[8];                          // DWORD 5
         BE_BIT R_CTL[8];                         // DWORD 5
      } gen_request;
      struct {
         BE_BIT rsvd0[28];                        // DWORD 5
         BE_BIT PT[2];                            // DWORD 5
         BE_BIT AR;                               // DWORD 5
         BE_BIT XO;                               // DWORD 5
      } xmit_bls_rsp;
      struct {
         BE_BIT rsvd0[2];                         // DWORD 5
         BE_BIT SI;                               // DWORD 5
         BE_BIT LA;                               // DWORD 5
         BE_BIT rsvd1[3];                         // DWORD 5
         BE_BIT LS;                               // DWORD 5
         BE_BIT DF_CTL[8];                        // DWORD 5
         BE_BIT TYPE[8];                          // DWORD 5
         BE_BIT R_CTL[8];                         // DWORD 5
      } xmit_sequence;
   } word5;
   BE_BIT XRI_TAG[16];                            // DWORD 6
   BE_BIT CONTEXT_TAG[16];                        // DWORD 6
   BE_BIT rsvd0[2];                               // DWORD 7
   BE_BIT CT[2];                                  // DWORD 7
   BE_BIT Status[4];                              // DWORD 7
   BE_BIT Command[8];                             // DWORD 7
   BE_BIT ClassService[3];                        // DWORD 7
   BE_BIT IR;                                     // DWORD 7
   BE_BIT PU[2];                                  // DWORD 7
   BE_BIT ERP;                                    // DWORD 7
   BE_BIT LINK;                                   // DWORD 7
   BE_BIT Timer[8];                               // DWORD 7
   union {
      BE_BIT ABORT_TAG[32];                       // DWORD 8
      struct {
         BE_BIT T_TAG[32];                        // DWORD 8
      } abort;
   } word8;
   BE_BIT REQUEST_TAG[16];                        // DWORD 9
   BE_BIT OX_ID[16];                              // DWORD 9
   BE_BIT rsvd1[16];                              // DWORD 10
   BE_BIT PRI[3];                                 // DWORD 10
   BE_BIT PV;                                     // DWORD 10
   BE_BIT rsvd2;                                  // DWORD 10
   BE_BIT XC;                                     // DWORD 10
   BE_BIT SR;                                     // DWORD 10
   BE_BIT CCPE;                                   // DWORD 10
   BE_BIT CCP[8];                                 // DWORD 10
   BE_BIT cmd_type[4];                            // DWORD 11
   BE_BIT ELS_ID[2];                              // DWORD 11
   BE_BIT rsvd3;                                  // DWORD 11
   BE_BIT WQEC;                                   // DWORD 11
   BE_BIT rsvd4[8];                               // DWORD 11
   BE_BIT cq_id[10];                              // DWORD 11
   BE_BIT rsvd5[6];                               // DWORD 11
   union {
      struct {
         BE_BIT rsvd0;                            // DWORD 12
         BE_BIT VF_ID[12];                        // DWORD 12
         BE_BIT Priority[3];                      // DWORD 12
         BE_BIT rsvd1[16];                        // DWORD 12
      } els_request;
      struct {
         BE_BIT Xmit_Length[32];                  // DWORD 12
      } xmit_sequence;
   } word12;
   BE_BIT rsvd6[24];                              // DWORD 13
   BE_BIT Hop_Count[8];                           // DWORD 13
   BE_BIT rsvd7[64];                              // DWORD 14
} SG_PACK BE_FC_WRB_CONTEXT_AMAP;
typedef struct { u32 dw[16]; } FC_WRB_CONTEXT_AMAP, *PFC_WRB_CONTEXT_AMAP;


//  		
typedef struct {
   BE_BIT BufferSize[24];                         // DWORD 0
   BE_BIT BufferType[8];                          // DWORD 0
   BE_BIT AddressLow[32];                         // DWORD 1
   BE_BIT AddressHigh[32];                        // DWORD 2
   BE_BIT IO_TAG32[32];                           // DWORD 3
   BE_BIT TransferLength[32];                     // DWORD 4
   BE_BIT InitialTransferLength[32];              // DWORD 5
   BE_BIT sgl_icd_index[16];                      // DWORD 6
   BE_BIT CONTEXT_TAG[16];                        // DWORD 6
   BE_BIT AC;                                     // DWORD 7
   BE_BIT LE;                                     // DWORD 7
   BE_BIT BDE[2];                                 // DWORD 7
   BE_BIT Status[4];                              // DWORD 7
   BE_BIT Command[8];                             // DWORD 7
   BE_BIT ClassService[3];                        // DWORD 7
   BE_BIT rsvd0;                                  // DWORD 7
   BE_BIT PU[2];                                  // DWORD 7
   BE_BIT ERP;                                    // DWORD 7
   BE_BIT XS;                                     // DWORD 7
   BE_BIT Timer[8];                               // DWORD 7
   BE_BIT IO_TAG64_LOW[32];                       // DWORD 8
   BE_BIT IO_TAG64_HIGH[32];                      // DWORD 9
   BE_BIT EBDE_COUNT[8];                          // DWORD 10
   BE_BIT rsvd1[8];                               // DWORD 10
   BE_BIT PRI[3];                                 // DWORD 10
   BE_BIT PV;                                     // DWORD 10
   BE_BIT rsvd2[3];                               // DWORD 10
   BE_BIT CCPE;                                   // DWORD 10
   BE_BIT CCP[8];                                 // DWORD 10
   BE_BIT hdr_template_index[15];                 // DWORD 11
   BE_BIT WRBC;                                   // DWORD 11
   BE_BIT max_buf_size[12];                       // DWORD 11
   BE_BIT cont_inc_seq_cnt;                       // DWORD 11
   BE_BIT dif_en;                                 // DWORD 11
   BE_BIT cmd_type[2];                            // DWORD 11
   BE_BIT metadata[16];                           // DWORD 12
   BE_BIT rsvd3[16];                              // DWORD 12
   BE_BIT expreftag[32];                          // DWORD 13
   BE_BIT rsvd4[32];                              // DWORD 14
   BE_BIT newreftag[32];                          // DWORD 15
} SG_PACK BE_FC_DIF_WRB_CONTEXT_AMAP;
typedef struct { u32 dw[16]; } FC_DIF_WRB_CONTEXT_AMAP, *PFC_DIF_WRB_CONTEXT_AMAP;


// Scatter gather element
typedef struct {
   BE_BIT addr_hi[32];                            // DWORD 0
   BE_BIT addr_lo[32];                            // DWORD 1
   BE_BIT sge_offset[22];                         // DWORD 2
   BE_BIT rsvd0[9];                               // DWORD 2
   BE_BIT last_sge;                               // DWORD 2
   BE_BIT len[17];                                // DWORD 3
   BE_BIT rsvd1[15];                              // DWORD 3
} SG_PACK BE_FC_SGE_AMAP;
typedef struct { u32 dw[4]; } FC_SGE_AMAP, *PFC_SGE_AMAP;


// RRmsg sent from ARM to FC TXULP and carried as body of IPC between EPs
typedef struct {
   BE_BIT sgl_icd_index[11];                      // DWORD 0
   BE_BIT defpdu_invld;                           // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT invalidate_ref_handle[16];              // DWORD 0
   BE_BIT fc_ctx_invld;                           // DWORD 1
   BE_BIT icd_invld;                              // DWORD 1
   BE_BIT icd_free;                               // DWORD 1
   BE_BIT rsvd1[2];                               // DWORD 1
   BE_BIT wr;                                     // DWORD 1
   BE_BIT invld_resp;                             // DWORD 1
   BE_BIT rsvd2;                                  // DWORD 1
   BE_BIT upload;                                 // DWORD 1
   BE_BIT rsvd3[23];                              // DWORD 1
   BE_BIT partialBytesSent[24];                   // DWORD 2
   BE_BIT rsvd4[8];                               // DWORD 2
} SG_PACK BE_FC_RRMSG_AMAP;
typedef struct { u32 dw[3]; } FC_RRMSG_AMAP, *PFC_RRMSG_AMAP;


// This describes the layout for template headers
typedef struct {
   BE_ETH_HEADER_AMAP Eth;
   BE_IP_HEADER_AMAP Ip;
   BE_TCP_HEADER_AMAP Tcp;
} SG_PACK BE_TEMPLATE_HEADER_AMAP;
typedef struct { u32 dw[14]; } TEMPLATE_HEADER_AMAP, *PTEMPLATE_HEADER_AMAP;


// This describes the layout for template headers
typedef struct {
   BE_ETH_HEADER_AMAP Eth;
   BE_IPV6_HEADER_AMAP Ipv6;
   BE_TCP_HEADER_AMAP Tcp;
} SG_PACK BE_TEMPLATE_IPV6_HEADER_AMAP;
typedef struct { u32 dw[19]; } TEMPLATE_IPV6_HEADER_AMAP, *PTEMPLATE_IPV6_HEADER_AMAP;


// This describes the layout for template headers
typedef struct {
   BE_ETH_VLAN_HEADER_AMAP Eth;
   BE_IP_HEADER_AMAP Ip;
   BE_TCP_HEADER_AMAP Tcp;
} SG_PACK BE_TEMPLATE_VLAN_HEADER_AMAP;
typedef struct { u32 dw[15]; } TEMPLATE_VLAN_HEADER_AMAP, *PTEMPLATE_VLAN_HEADER_AMAP;


// This describes the layout for template headers
typedef struct {
   BE_ETH_VLAN_HEADER_AMAP Eth;
   BE_IPV6_HEADER_AMAP Ipv6;
   BE_TCP_HEADER_AMAP Tcp;
} SG_PACK BE_TEMPLATE_VLAN_IPV6_HEADER_AMAP;
typedef struct { u32 dw[20]; } TEMPLATE_VLAN_IPV6_HEADER_AMAP, *PTEMPLATE_VLAN_IPV6_HEADER_AMAP;


// This describes the layout for template headers
typedef struct {
   BE_ETH_HEADER_AMAP Eth;
   BE_SNAP_HEADER_AMAP Snap;
   BE_IP_HEADER_AMAP Ip;
   BE_TCP_HEADER_AMAP Tcp;
} SG_PACK BE_TEMPLATE_SNAP_HEADER_AMAP;
typedef struct { u32 dw[16]; } TEMPLATE_SNAP_HEADER_AMAP, *PTEMPLATE_SNAP_HEADER_AMAP;


// This describes the layout for template headers
typedef struct {
   BE_ETH_VLAN_HEADER_AMAP Eth;
   BE_SNAP_HEADER_AMAP Snap;
   BE_IP_HEADER_AMAP Ip;
   BE_TCP_HEADER_AMAP Tcp;
} SG_PACK BE_TEMPLATE_VLAN_SNAP_HEADER_AMAP;
typedef struct { u32 dw[17]; } TEMPLATE_VLAN_SNAP_HEADER_AMAP, *PTEMPLATE_VLAN_SNAP_HEADER_AMAP;


// This describes the layout for template headers
typedef struct {
   BE_ETH_HEADER_AMAP Eth;
   BE_IP_HEADER_AMAP Ip;
   BE_TCP_HEADER_AMAP Tcp;
   BE_TCP_TIMESTAMP_AMAP Timestamp;
} SG_PACK BE_TEMPLATE_HEADER_TS_AMAP;
typedef struct { u32 dw[17]; } TEMPLATE_HEADER_TS_AMAP, *PTEMPLATE_HEADER_TS_AMAP;


// This describes the layout for template headers
typedef struct {
   BE_ETH_HEADER_AMAP Eth;
   BE_IPV6_HEADER_AMAP Ipv6;
   BE_TCP_HEADER_AMAP Tcp;
   BE_TCP_TIMESTAMP_AMAP Timestamp;
} SG_PACK BE_TEMPLATE_IPV6_HEADER_TS_AMAP;
typedef struct { u32 dw[22]; } TEMPLATE_IPV6_HEADER_TS_AMAP, *PTEMPLATE_IPV6_HEADER_TS_AMAP;


// This describes the layout for template headers
typedef struct {
   BE_ETH_VLAN_HEADER_AMAP Eth;
   BE_IP_HEADER_AMAP Ip;
   BE_TCP_HEADER_AMAP Tcp;
   BE_TCP_TIMESTAMP_AMAP Timestamp;
} SG_PACK BE_TEMPLATE_VLAN_HEADER_TS_AMAP;
typedef struct { u32 dw[18]; } TEMPLATE_VLAN_HEADER_TS_AMAP, *PTEMPLATE_VLAN_HEADER_TS_AMAP;


// This describes the layout for template headers
typedef struct {
   BE_ETH_VLAN_HEADER_AMAP Eth;
   BE_IPV6_HEADER_AMAP Ipv6;
   BE_TCP_HEADER_AMAP Tcp;
   BE_TCP_TIMESTAMP_AMAP Timestamp;
} SG_PACK BE_TEMPLATE_VLAN_IPV6_HEADER_TS_AMAP;
typedef struct { u32 dw[23]; } TEMPLATE_VLAN_IPV6_HEADER_TS_AMAP, *PTEMPLATE_VLAN_IPV6_HEADER_TS_AMAP;


// --- CHIP_ID_TYPES ---
// Enumerations for various controller entities.
#define CHIP_ID_TYPE_EQ_ISCSI           (1)       
#define CHIP_ID_TYPE_EQ_NET             (2)       
#define CHIP_ID_TYPE_CQ                 (3)       
#define CHIP_ID_TYPE_TOE                (4)       
#define CHIP_ID_TYPE_ISCSI              (5)       
#define CHIP_ID_TYPE_ETX                (6)       
#define CHIP_ID_TYPE_ISCSI_DEFQ         (7)       
#define CHIP_ID_TYPE_TOE_DEFQ           (8)       

typedef enum {
   ENUM_CHIP_ID_TYPE_EQ_ISCSI = 0x1UL,
   ENUM_CHIP_ID_TYPE_EQ_NET = 0x2UL,
   ENUM_CHIP_ID_TYPE_CQ = 0x3UL,
   ENUM_CHIP_ID_TYPE_TOE = 0x4UL,
   ENUM_CHIP_ID_TYPE_ISCSI = 0x5UL,
   ENUM_CHIP_ID_TYPE_ETX = 0x6UL,
   ENUM_CHIP_ID_TYPE_ISCSI_DEFQ = 0x7UL,
   ENUM_CHIP_ID_TYPE_TOE_DEFQ = 0x8UL
} CHIP_ID_TYPES;

// This describes the layout for fip template headers
typedef struct {
   BE_FIP_FRAME_VLAN_AMAP fip_header;
   BE_FIP_FLOGI_DESCRIPTOR_AMAP fip_descriptor;
   BE_BIT rsvd0[64];                              // DWORD 14
} SG_PACK BE_FIP_TEMPLATE_HEADER_AMAP;
typedef struct { u32 dw[16]; } FIP_TEMPLATE_HEADER_AMAP, *PFIP_TEMPLATE_HEADER_AMAP;


// This describes the layout for mac address fip descriptor
typedef struct {
   BE_FIP_MAC_ADDR_DESCRIPTOR_AMAP fip_tail;
   BE_FIP_MAC_ADDR_DESCRIPTOR_AMAP fip_logo;
   BE_BIT rsvd0[384];                             // DWORD 4
} SG_PACK BE_FIP_MAC_DESCRIPTOR_TEMPLATE_AMAP;
typedef struct { u32 dw[16]; } FIP_MAC_DESCRIPTOR_TEMPLATE_AMAP, *PFIP_MAC_DESCRIPTOR_TEMPLATE_AMAP;


// This describes the layout for fcoe template headers
typedef struct {
   BE_FCOE_HEADER_VLAN_AMAP fcoe_header;
   BE_FC_HEADER_AMAP fc_header;
   BE_BIT rsvd0[64];                              // DWORD 14
} SG_PACK BE_FCOE_TEMPLATE_HEADER_AMAP;
typedef struct { u32 dw[16]; } FCOE_TEMPLATE_HEADER_AMAP, *PFCOE_TEMPLATE_HEADER_AMAP;


// This is the master template structure for fip operations used per FCF/VFI/VPI 
typedef struct {
   BE_FIP_TEMPLATE_HEADER_AMAP fip_template_flogi;
   BE_FIP_MAC_DESCRIPTOR_TEMPLATE_AMAP fip_mac_desc_template;
   BE_FCOE_TEMPLATE_HEADER_AMAP fcoe_template_1;
   BE_FIP_TEMPLATE_HEADER_AMAP fip_template_flogo;
} SG_PACK BE_FC_ELS_MASTER_TEMPLATE_AMAP;
typedef struct { u32 dw[64]; } FC_ELS_MASTER_TEMPLATE_AMAP, *PFC_ELS_MASTER_TEMPLATE_AMAP;


// --- WQE_OPERATION_ENUM ---
// Operation codes for an RDMA Work Queue Entry
#define WQE_OPERATION_SEND              (1)       // Send, Send with SE, Send with
                                                  // Invalidate, and Send with SE and
                                                  // invalidate
#define WQE_OPERATION_RECEIVE           (2)       // Receive
#define WQE_OPERATION_RDMA_WRITE        (3)       // RDMA Write
#define WQE_OPERATION_RDMA_READ         (4)       // RDMA Read, and RDMA Read with
                                                  // invalidate
#define WQE_OPERATION_RDMA_READ_RESPONSE (5)      // RDMA Read Response
#define WQE_OPERATION_TERMINATE         (6)       // Terminate
#define WQE_OPERATION_BIND              (7)       // Bind
#define WQE_OPERATION_LOCAL_INVALIDATE  (8)       // Invalidate Local STag
#define WQE_OPERATION_FAST_REGISTER     (9)       // Fast Register MR

typedef enum {
   ENUM_WQE_OPERATION_SEND = 0x1UL,
   ENUM_WQE_OPERATION_RECEIVE = 0x2UL,
   ENUM_WQE_OPERATION_RDMA_WRITE = 0x3UL,
   ENUM_WQE_OPERATION_RDMA_READ = 0x4UL,
   ENUM_WQE_OPERATION_RDMA_READ_RESPONSE = 0x5UL,
   ENUM_WQE_OPERATION_TERMINATE = 0x6UL,
   ENUM_WQE_OPERATION_BIND = 0x7UL,
   ENUM_WQE_OPERATION_LOCAL_INVALIDATE = 0x8UL,
   ENUM_WQE_OPERATION_FAST_REGISTER = 0x9UL
} WQE_OPERATION_ENUM;

// cqe flags map the same as wqe flags, not all are used, an additional SQ flag indicates
// which WQ relates to CQE
typedef struct {
   BE_BIT signal;                                 // DWORD 0
   BE_BIT solicited;                              // DWORD 0
   BE_BIT fence;                                  // DWORD 0
   BE_BIT invalidate;                             // DWORD 0
   BE_BIT va_addr;                                // DWORD 0
   BE_BIT local_read;                             // DWORD 0
   BE_BIT remote_read;                            // DWORD 0
   BE_BIT local_write;                            // DWORD 0
   BE_BIT remote_write;                           // DWORD 0
   BE_BIT bindable;                               // DWORD 0
   BE_BIT pbl_struct;                             // DWORD 0
   BE_BIT sq;                                     // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
} SG_PACK BE_CQE_FLAGS_AMAP;
typedef struct { u32 dw[1]; } CQE_FLAGS_AMAP, *PCQE_FLAGS_AMAP;


// --- WQE_FLAGS_ENUM ---
// RDMA WQE flag definitions.
#define WQE_FLAG_SIGNAL                 (1)       // Set value indicates Signaled
                                                  // Completion
#define WQE_FLAG_SOLICITED              (2)       // Set value indicates Solicited Event
#define WQE_FLAG_FENCE                  (4)       // Set value indicates Fence. Send,RDMA
                                                  // Write->Read Fence. Local
                                                  // Invalidate->Local Fence
#define WQE_FLAG_INVALIDATE             (8)       // Set value indicates STAG Invalidate
#define WQE_FLAG_VA_ADDR                (16)      // Set value indicates VA-based
                                                  // addressing
#define WQE_FLAG_LOCAL_READ             (32)      // Set value indicates local read access
                                                  // enable
#define WQE_FLAG_REMOTE_READ            (64)      // Set value indicates remote read
                                                  // access enable
#define WQE_FLAG_LOCAL_WRITE            (128)     // Set value indicates local write
                                                  // access enable
#define WQE_FLAG_REMOTE_WRITE           (256)     // Set value indicates remote write
                                                  // access enable
#define WQE_FLAG_BINDABLE               (512)     // Set value indicates Memory Window
                                                  // Binding enable
#define WQE_FLAG_PBL_STRUCT             (1024)    // Set value indicates Physical Buffer
                                                  // List valid

typedef enum {
   ENUM_WQE_FLAG_SIGNAL = 0x1UL,
   ENUM_WQE_FLAG_SOLICITED = 0x2UL,
   ENUM_WQE_FLAG_FENCE = 0x4UL,
   ENUM_WQE_FLAG_INVALIDATE = 0x8UL,
   ENUM_WQE_FLAG_VA_ADDR = 0x10UL,
   ENUM_WQE_FLAG_LOCAL_READ = 0x20UL,
   ENUM_WQE_FLAG_REMOTE_READ = 0x40UL,
   ENUM_WQE_FLAG_LOCAL_WRITE = 0x80UL,
   ENUM_WQE_FLAG_REMOTE_WRITE = 0x100UL,
   ENUM_WQE_FLAG_BINDABLE = 0x200UL,
   ENUM_WQE_FLAG_PBL_STRUCT = 0x400UL
} WQE_FLAGS_ENUM;

// RDMA Tx scatter/gather entry.  This structure represents a single STag fragment. 
// Multiple SGEs are typically combined into a single SendQ WQE.
typedef struct {
   BE_BIT length[32];                             // DWORD 0
   BE_BIT stag[32];                               // DWORD 1
   BE_BIT to_hi[32];                              // DWORD 2
   BE_BIT to_lo[32];                              // DWORD 3
} SG_PACK BE_RDMA_TX_SGE_AMAP;
typedef struct { u32 dw[4]; } RDMA_TX_SGE_AMAP, *PRDMA_TX_SGE_AMAP;


// This is a single self-contained unit of the WQE that can be fetched by BE in a single
// UC fetch cache-line.  A complete WQE can contain upto 4 of these WQE Units.
typedef struct {
   BE_BIT remote_stag[32];                        // DWORD 0
   BE_BIT op_code[8];                             // DWORD 1
   BE_BIT wqe_unit_count[8];                      // DWORD 1
   BE_BIT flags[16];                              // DWORD 1
   BE_BIT remote_to_hi[32];                       // DWORD 2
   BE_BIT remote_to_lo[32];                       // DWORD 3
   BE_RDMA_TX_SGE_AMAP sge;
} SG_PACK BE_RDMA_WQE_UNIT_AMAP;
typedef struct { u32 dw[8]; } RDMA_WQE_UNIT_AMAP, *PRDMA_WQE_UNIT_AMAP;


// This WQE is used to post a Send, Send with SE, Send with Invalidate, and Send with SE
// and Invalidate operations.
typedef struct {
   BE_RDMA_WQE_UNIT_AMAP wqe_unit[4];
} SG_PACK BE_RDMA_SEND_WQE_AMAP;
typedef struct { u32 dw[32]; } RDMA_SEND_WQE_AMAP, *PRDMA_SEND_WQE_AMAP;


// This WQE is used to post an RDMA Write operations.
typedef struct {
   BE_RDMA_WQE_UNIT_AMAP wqe_unit[4];
} SG_PACK BE_RDMA_WRITE_WQE_AMAP;
typedef struct { u32 dw[32]; } RDMA_WRITE_WQE_AMAP, *PRDMA_WRITE_WQE_AMAP;


// This WQE is used to post an RDMA Read operations.
typedef struct {
   BE_RDMA_WQE_UNIT_AMAP wqe_unit;
} SG_PACK BE_RDMA_READ_WQE_AMAP;
typedef struct { u32 dw[8]; } RDMA_READ_WQE_AMAP, *PRDMA_READ_WQE_AMAP;


// This WQE is used to post TERMINATE requests.
typedef struct {
   BE_RDMA_WQE_UNIT_AMAP wqe_unit;
} SG_PACK BE_RDMA_TERMINATE_WQE_AMAP;
typedef struct { u32 dw[8]; } RDMA_TERMINATE_WQE_AMAP, *PRDMA_TERMINATE_WQE_AMAP;


// This WQE is used to post memory window bind operations.
typedef struct {
   BE_BIT memory_region_stag[32];                 // DWORD 0
   BE_BIT op_code[8];                             // DWORD 1
   BE_BIT wqe_unit_count[8];                      // DWORD 1
   BE_BIT flags[16];                              // DWORD 1
   BE_BIT memory_window_stag[32];                 // DWORD 2
   BE_BIT memory_window_length[32];               // DWORD 3
   BE_BIT memory_region_virtual_address_hi[32];   // DWORD 4
   BE_BIT memory_region_virtual_address_lo[32];   // DWORD 5
} SG_PACK BE_RDMA_BIND_WQE_AMAP;
typedef struct { u32 dw[6]; } RDMA_BIND_WQE_AMAP, *PRDMA_BIND_WQE_AMAP;


// This WQE is used to post a non-shared memory fast register operations.
typedef struct {
   BE_BIT memory_region_stag[32];                 // DWORD 0
   BE_BIT op_code[8];                             // DWORD 1
   BE_BIT wqe_unit_count[8];                      // DWORD 1
   BE_BIT flags[16];                              // DWORD 1
   BE_BIT memory_region_virtual_address_hi[32];   // DWORD 2
   BE_BIT memory_region_virtual_address_lo[32];   // DWORD 3
   BE_BIT length[32];                             // DWORD 4
   BE_BIT cra[32];                                // DWORD 5
} SG_PACK BE_RDMA_FAST_REGISTER_WQE_AMAP;
typedef struct { u32 dw[6]; } RDMA_FAST_REGISTER_WQE_AMAP, *PRDMA_FAST_REGISTER_WQE_AMAP;


// Rdma Rx Scatter/Gather Entry. This structure represents a single STag fragment.
// Multiple SGEs are typically combined into an RDMA Scatter Gather List. Many RDMA WQEs
// contain 1 or more SGEs.
typedef struct {
   BE_BIT stag[32];                               // DWORD 0
   BE_BIT length[32];                             // DWORD 1
   BE_BIT to_hi[32];                              // DWORD 2
   BE_BIT to_lo[32];                              // DWORD 3
} SG_PACK BE_RDMA_RX_SGE_AMAP;
typedef struct { u32 dw[4]; } RDMA_RX_SGE_AMAP, *PRDMA_RX_SGE_AMAP;


// Rdma Rx wqe unit. This structure represents a single STag fragment. Multiple WQE Units
// are typically combined into an RDMA_RX_WQE (one unit in RDMA RCV Q . Four RDMA RX WQE
// UNITs are contained in one RDMA_RX_WQE
typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_BIT RxBufLength[32];                        // DWORD 2
   BE_BIT SgeCnt[2];                              // DWORD 3
   BE_BIT SgeIndx[2];                             // DWORD 3
   BE_BIT rsvd2[28];                              // DWORD 3
   BE_RDMA_RX_SGE_AMAP RxSge;
} SG_PACK BE_RDMA_RX_WQE_UNIT_AMAP;
typedef struct { u32 dw[8]; } RDMA_RX_WQE_UNIT_AMAP, *PRDMA_RX_WQE_UNIT_AMAP;


// ONe entry in RDMA Queue Pair's Receive Queue
typedef struct {
   BE_RDMA_RX_WQE_UNIT_AMAP RxWqeUnit[4];
} SG_PACK BE_RDMA_RX_WQE_AMAP;
typedef struct { u32 dw[32]; } RDMA_RX_WQE_AMAP, *PRDMA_RX_WQE_AMAP;


// This WQE is used to post an Receive request to the RQ
typedef struct {
   BE_RDMA_RX_SGE_AMAP receive_sgl[4];
} SG_PACK BE_RDMA_RECEIVE_WQE_AMAP;
typedef struct { u32 dw[16]; } RDMA_RECEIVE_WQE_AMAP, *PRDMA_RECEIVE_WQE_AMAP;


// --- RDMA_EQE_STATUS ---
// Completion codes for an RDMA Event Queue Entry
#define RDMA_EQE_STATUS_LLP_CLOSE_COMPLETE (0)    // The RDMA Stream has completed Closing
                                                  // and no SQ WQEs were flushed.
#define RDMA_EQE_STATUS_TERMINATE_RECEIVED (1)    // Terminate Message Received
#define RDMA_EQE_STATUS_LLP_CONNECTION_RESET (2)  // An incoming LLP Reset (e.g. RST on
                                                  // TCP) was received.
#define RDMA_EQE_STATUS_LLP_CONNECTION_LOST (3)   // The connection was lost
#define RDMA_EQE_STATUS_LLP_INVALID_SEGMENT_SIZE (4) // LLP Integrity Error: Segment size
                                                     // invalid
#define RDMA_EQE_STATUS_INVALID_CRC     (5)       // Invalid CRC
#define RDMA_EQE_STATUS_INVALID_FPDU    (6)       // Received MPA marker and 'Length'
                                                  // fields do not agree on the start of a
                                                  // FPDU 
#define RDMA_EQE_STATUS_INVALID_DDP_VERSION (7)   // Invalid DDP version - caused by an
                                                  // inbound segment
#define RDMA_EQE_STATUS_INVALID_RDMA_VERSION (8)  // Invalid RDMA version - caused by an
                                                  // inbound segment
#define RDMA_EQE_STATUS_INVALID_OPCODE  (9)       // Unexpected Opcode - caused by an
                                                  // inbound segment
#define RDMA_EQE_STATUS_INVALID_DDP_QUEUE_NUMBER (10) // Invalid DDP Queue Number - caused
                                                      // by an inbound segment
#define RDMA_EQE_STATUS_INVALID_RDMA_READ_REQ (11) // Invalid RDMA Read Request Message,
                                                   // RDMA Read not enabled - caused by an
                                                   // inbound segment
#define RDMA_EQE_STATUS_INVALID_RDMA_WRITE_REQ (12) // Invalid RDMA Write or RDMA Read
                                                    // Response Message, RDMA Write & RDMA
                                                    // Read Response not enabled - caused
                                                    // by an inbound segment. 
#define RDMA_EQE_STATUS_INVALID_RDMA_READ_SIZE (13) // Invalid RDMA Read Request Message,
                                                    // message size too small or Offset
                                                    // non-zero - caused by an inbound
                                                    // segment.
#define RDMA_EQE_STATUS_NO_L_BIT        (14)      // No 'L' bit when expected - caused by
                                                  // an inbound segment.
#define RDMA_EQE_STATUS_INVALID_STAG    (15)      // Invalid STag - caused by an inbound
                                                  // Tagged DDP segment not valid for this
                                                  // QP. This includes using the STag of
                                                  // zero, the STag was not associated
                                                  // with the QP or the STag was in the
                                                  // Invalid state.
#define RDMA_EQE_STATUS_BOUNDS_FAILURE  (16)      // Tagged Base and bounds violation -
                                                  // caused by an inbound Tagged segment
                                                  // attempted to access memory outside
                                                  // the limits assigned to the STag.
#define RDMA_EQE_STATUS_RIGHTS_FAILURE  (17)      // Tagged Access Rights violation -
                                                  // caused by an inbound segment
                                                  // referencing a Tagged Buffer which did
                                                  // not have the necessary memory Access
                                                  // Rights for the requested operation.
#define RDMA_EQE_STATUS_INVALID_PD      (18)      // Caused by an inbound segment
                                                  // referencing a Tagged Buffer which was
                                                  // not allowed to be referenced by QP.
#define RDMA_EQE_STATUS_WRAP_ERROR      (19)      // Caused by an inbound segment not
                                                  // targeting the RQ.
#define RDMA_EQE_STATUS_BAD_CLOSE       (20)      // The QP was in the Closing state when
                                                  // a Segment arrived.
#define RDMA_EQE_STATUS_BAD_LLP_CLOSE   (21)      // An attempt was made to close the RDMA
                                                  // Stream with work in progress. 
#define RDMA_EQE_STATUS_INVALID_RQ_MSN_RANGE (22) // MSN range not valid. Caused by an
                                                  // inbound segment targeting the RQ.
                                                  // Possibly due to Receive Queue being
                                                  // empty. 
#define RDMA_EQE_STATUS_RQ_MSN_GAP      (23)      // Invalid MSN - gap in MSN. Caused by
                                                  // an inbound segment targeting the RQ
#define RDMA_EQE_STATUS_IRRQ_NOT_TARGETED (24)    // Invalid MSN - too many RDMA Read
                                                  // Request Messages in progress - caused
                                                  // by an inbound segment not targeting
                                                  // the IRRQ. 
#define RDMA_EQE_STATUS_IRRQ_MSN_GAP    (25)      // Invalid MSN - gap in MSN - caused by
                                                  // an inbound segment not targeting the
                                                  // RQ
#define RDMA_EQE_STATUS_IRRQ_INVALID_MSN_RANGE (26) // Invalid MSN - range is not valid -
                                                    // caused by an inbound segment not
                                                    // targeting the RQ. 
#define RDMA_EQE_STATUS_IRRQ_INVALID_STAG (27)    // Invalid STag - Data Source STag
                                                  // determined to be invalid during RDMA
                                                  // Read Response processing.
#define RDMA_EQE_STATUS_IRRQ_BOUND_FAILURE (28)   // Tagged Base and bounds violation -
                                                  // This includes RDMA Read Request of a
                                                  // message larger than supported by the
                                                  // RNIC. It is detected accessing the
                                                  // Data Source during RDMA Read Response
                                                  // processing. 
#define RDMA_EQE_STATUS_IRRQ_ACCESS_VIOLATION (29) // Tagged Access Rights violation -
                                                   // Data Source Access Rights violation
                                                   // detected during RDMA Read Response
                                                   // processing. 
#define RDMA_EQE_STATUS_IRRQ_INVALID_PD (30)      // Tagged Invalid PD - Data Source PD
                                                  // violation detected during RDMA Read
                                                  // Response process
#define RDMA_EQE_STATUS_IRRQ_WRAP_ERROR (31)      // Wrap error - detected during RDMA
                                                  // Read Response processing. 
#define RDMA_EQE_STATUS_CQ_SQ_ERROR     (32)      // CQ Error - An error occurred on the
                                                  // CQ during a SQ completion
#define RDMA_EQE_STATUS_CQ_RQ_ERROR     (33)      // CQ Operation error - An error
                                                  // occurred on the CQ during a RQ
                                                  // completion.
#define RDMA_EQE_STATUS_CATASTROPHIC_ERROR (35)   // Local QP Catastrophic Error -
                                                  // occurred during processing.
#define RDMA_EQE_STATUS_CQ_OVERFLOW     (36)      // An overflow of the Completion Queue
                                                  // has been detected. This Error Code is
                                                  // OPTIONAL. 
#define RDMA_EQE_STATUS_CQ_OPERATIONAL_ERROR (37) // An error occurred on the CQ unrelated
                                                  // to a specific QP completion. 
#define RDMA_EQE_STATUS_QP_RQ_LIMIT_REACHED (39)  // The Limit value established for the
                                                  // QP's RQ has been reached.
#define RDMA_EQE_STATUS_RNIC_CATASTROPHIC_ERROR (41) // A problem occurred with the RNIC
                                                     // or its driver that renders the
                                                     // RNIC unable to reliably function. 

typedef enum {
   ENUM_RDMA_EQE_STATUS_LLP_CLOSE_COMPLETE = 0x0UL,
   ENUM_RDMA_EQE_STATUS_TERMINATE_RECEIVED = 0x1UL,
   ENUM_RDMA_EQE_STATUS_LLP_CONNECTION_RESET = 0x2UL,
   ENUM_RDMA_EQE_STATUS_LLP_CONNECTION_LOST = 0x3UL,
   ENUM_RDMA_EQE_STATUS_LLP_INVALID_SEGMENT_SIZE = 0x4UL,
   ENUM_RDMA_EQE_STATUS_INVALID_CRC = 0x5UL,
   ENUM_RDMA_EQE_STATUS_INVALID_FPDU = 0x6UL,
   ENUM_RDMA_EQE_STATUS_INVALID_DDP_VERSION = 0x7UL,
   ENUM_RDMA_EQE_STATUS_INVALID_RDMA_VERSION = 0x8UL,
   ENUM_RDMA_EQE_STATUS_INVALID_OPCODE = 0x9UL,
   ENUM_RDMA_EQE_STATUS_INVALID_DDP_QUEUE_NUMBER = 0xaUL,
   ENUM_RDMA_EQE_STATUS_INVALID_RDMA_READ_REQ = 0xbUL,
   ENUM_RDMA_EQE_STATUS_INVALID_RDMA_WRITE_REQ = 0xcUL,
   ENUM_RDMA_EQE_STATUS_INVALID_RDMA_READ_SIZE = 0xdUL,
   ENUM_RDMA_EQE_STATUS_NO_L_BIT = 0xeUL,
   ENUM_RDMA_EQE_STATUS_INVALID_STAG = 0xfUL,
   ENUM_RDMA_EQE_STATUS_BOUNDS_FAILURE = 0x10UL,
   ENUM_RDMA_EQE_STATUS_RIGHTS_FAILURE = 0x11UL,
   ENUM_RDMA_EQE_STATUS_INVALID_PD = 0x12UL,
   ENUM_RDMA_EQE_STATUS_WRAP_ERROR = 0x13UL,
   ENUM_RDMA_EQE_STATUS_BAD_CLOSE = 0x14UL,
   ENUM_RDMA_EQE_STATUS_BAD_LLP_CLOSE = 0x15UL,
   ENUM_RDMA_EQE_STATUS_INVALID_RQ_MSN_RANGE = 0x16UL,
   ENUM_RDMA_EQE_STATUS_RQ_MSN_GAP = 0x17UL,
   ENUM_RDMA_EQE_STATUS_IRRQ_NOT_TARGETED = 0x18UL,
   ENUM_RDMA_EQE_STATUS_IRRQ_MSN_GAP = 0x19UL,
   ENUM_RDMA_EQE_STATUS_IRRQ_INVALID_MSN_RANGE = 0x1aUL,
   ENUM_RDMA_EQE_STATUS_IRRQ_INVALID_STAG = 0x1bUL,
   ENUM_RDMA_EQE_STATUS_IRRQ_BOUND_FAILURE = 0x1cUL,
   ENUM_RDMA_EQE_STATUS_IRRQ_ACCESS_VIOLATION = 0x1dUL,
   ENUM_RDMA_EQE_STATUS_IRRQ_INVALID_PD = 0x1eUL,
   ENUM_RDMA_EQE_STATUS_IRRQ_WRAP_ERROR = 0x1fUL,
   ENUM_RDMA_EQE_STATUS_CQ_SQ_ERROR = 0x20UL,
   ENUM_RDMA_EQE_STATUS_CQ_RQ_ERROR = 0x21UL,
   ENUM_RDMA_EQE_STATUS_CATASTROPHIC_ERROR = 0x23UL,
   ENUM_RDMA_EQE_STATUS_CQ_OVERFLOW = 0x24UL,
   ENUM_RDMA_EQE_STATUS_CQ_OPERATIONAL_ERROR = 0x25UL,
   ENUM_RDMA_EQE_STATUS_QP_RQ_LIMIT_REACHED = 0x27UL,
   ENUM_RDMA_EQE_STATUS_RNIC_CATASTROPHIC_ERROR = 0x29UL
} RDMA_EQE_STATUS;

// --- RDMA_CQE_STATUS ---
// Completion codes for an RDMA Completion Queue Entry
#define RDMA_CQE_STATUS_SUCCESS         (0)       // The RNIC Operation was successful.
#define RDMA_CQE_STATUS_FLUSHED         (1)       // The Work Request was incomplete when
                                                  // the QP entered the Error state
#define RDMA_CQE_STATUS_INVALID_WQE     (2)       // The Work Request Element contained a
                                                  // format error
#define RDMA_CQE_STATUS_LOCAL_CATASTROPHIC_ERROR (3) // An error related to the QP
                                                     // occurred while processing the Work
                                                     // Request.
#define RDMA_CQE_STATUS_REMOTE_TERMINATION_ERROR (4) // A Terminate Message was received
                                                     // from the Remote Peer that appears
                                                     // to be related to the execution of
                                                     // this Work Request. The error type
                                                     // can be examined by looking at the
                                                     // Terminate Message buffer via Query
                                                     // QP.
#define RDMA_CQE_STATUS_INVALID_STAG    (5)       // An invalid STag was found in the
                                                  // local SGL. The STag was either not
                                                  // found allocated, bound, or registered
                                                  // in the RI, or an STag of zero was
                                                  // specified for a QP without Privileged
                                                  // rights, or referred to a Shared
                                                  // Memory Region, or the type of STag
                                                  // supplied was not allowed to be used
                                                  // in the specified operation.
#define RDMA_CQE_STATUS_BASE_AND_BOUNDS_VIOLATION (6) // The local SGL referenced an
                                                      // address beyond the limits
                                                      // specified for the MR or MW. This
                                                      // includes length errors. For a
                                                      // Bind, the MW was not wholly
                                                      // contained in the MR.
#define RDMA_CQE_STATUS_ACCESS_VIOLATION (7)      // The RNIC attempted to read or write
                                                  // to a local SGL MR or MW that did not
                                                  // provide appropriate Access Rights.
                                                  // For a Bind, the MW Access Rights were
                                                  // not compatible with the MR Access
                                                  // Rights
#define RDMA_CQE_STATUS_INVALID_PD      (8)       // For one of the STags specified in the
                                                  // Work Request the PD of the MR STag
                                                  // was not the same as the PD of the QP,
                                                  // or, the QP of the MW STag was not the
                                                  // same as QP.
#define RDMA_CQE_STATUS_WRAP_ERROR      (9)       // The specified Address or offset (TO
                                                  // or MO) added to the length of the
                                                  // operation resulted in a wrap beyond
                                                  // the machine-supported address.
#define RDMA_CQE_STATUS_BAD_INVALIDATE_STAG_ON_RQ (16) // The Invalidate STag on a Receive
                                                       // did not have a PD ID that
                                                       // matched the PD ID of the QP (for
                                                       // a MR) or a QP ID that matched
                                                       // the QP ID of the QP (for a MW).
                                                       // Or the STag did not have Access
                                                       // Rights to be invalidated
                                                       // remotely.
#define RDMA_CQE_STATUS_ZERO_RDMA_READ_RESOURCES (17) // The QP ORD value was set to zero.
#define RDMA_CQE_STATUS_QP_NOT_PRIVILEGED (18)    // The QP is not enabled to perform the
                                                  // Privileged WR.
#define RDMA_CQE_STATUS_INVALID_STAG_REGISTERED (19) // The STag was already registered or
                                                     // bound, when attempting to Register
                                                     // or Bind it.
#define RDMA_CQE_STATUS_INVALID_PAGE_SIZE (20)    // The page size requested was not
                                                  // supported by the RNIC.
#define RDMA_CQE_STATUS_INVALID_BUFFER_SIZE (21)  // Size not supported by the RNIC.
#define RDMA_CQE_STATUS_INVALID_PBL_ENTRY (22)    // for page mode, the entry must start
                                                  // on page size boundaries.
#define RDMA_CQE_STATUS_INVALID_FBO     (23)      // The FBO is larger than the physical
                                                  // buffer size.
#define RDMA_CQE_STATUS_INVALID_LENGTH_FAST_REGISTER (24) // Requested length is larger
                                                          // than supported by the buffer
                                                          // list during a fast register
                                                          // operation.
#define RDMA_CQE_STATUS_INVALID_ACCESS_RIGHTS (25) // Invalid Access Rights specified.
#define RDMA_CQE_STATUS_PBL_TOO_LONG    (32)      // Physical Buffer List too long.
#define RDMA_CQE_STATUS_INVALID_VIRTUAL_ADDRESS (33) // VA and FBO are not consistent.
#define RDMA_CQE_STATUS_INVALID_REGION  (34)      // The STag specified for the MR in the
                                                  // BIND request was invalid.
#define RDMA_CQE_STATUS_INVALID_WINDOW  (35)      // The STag specified for the MW in the
                                                  // BIND request was invalid.
#define RDMA_CQE_STATUS_INVALID_LENGTH  (36)      // The total size of the data to be
                                                  // moved as specified by the sum of the
                                                  // SGL elements, was larger than that
                                                  // supported by the RNIC.

typedef enum {
   ENUM_RDMA_CQE_STATUS_SUCCESS = 0x0UL,
   ENUM_RDMA_CQE_STATUS_FLUSHED = 0x1UL,
   ENUM_RDMA_CQE_STATUS_INVALID_WQE = 0x2UL,
   ENUM_RDMA_CQE_STATUS_LOCAL_CATASTROPHIC_ERROR = 0x3UL,
   ENUM_RDMA_CQE_STATUS_REMOTE_TERMINATION_ERROR = 0x4UL,
   ENUM_RDMA_CQE_STATUS_INVALID_STAG = 0x5UL,
   ENUM_RDMA_CQE_STATUS_BASE_AND_BOUNDS_VIOLATION = 0x6UL,
   ENUM_RDMA_CQE_STATUS_ACCESS_VIOLATION = 0x7UL,
   ENUM_RDMA_CQE_STATUS_INVALID_PD = 0x8UL,
   ENUM_RDMA_CQE_STATUS_WRAP_ERROR = 0x9UL,
   ENUM_RDMA_CQE_STATUS_BAD_INVALIDATE_STAG_ON_RQ = 0x10UL,
   ENUM_RDMA_CQE_STATUS_ZERO_RDMA_READ_RESOURCES = 0x11UL,
   ENUM_RDMA_CQE_STATUS_QP_NOT_PRIVILEGED = 0x12UL,
   ENUM_RDMA_CQE_STATUS_INVALID_STAG_REGISTERED = 0x13UL,
   ENUM_RDMA_CQE_STATUS_INVALID_PAGE_SIZE = 0x14UL,
   ENUM_RDMA_CQE_STATUS_INVALID_BUFFER_SIZE = 0x15UL,
   ENUM_RDMA_CQE_STATUS_INVALID_PBL_ENTRY = 0x16UL,
   ENUM_RDMA_CQE_STATUS_INVALID_FBO = 0x17UL,
   ENUM_RDMA_CQE_STATUS_INVALID_LENGTH_FAST_REGISTER = 0x18UL,
   ENUM_RDMA_CQE_STATUS_INVALID_ACCESS_RIGHTS = 0x19UL,
   ENUM_RDMA_CQE_STATUS_PBL_TOO_LONG = 0x20UL,
   ENUM_RDMA_CQE_STATUS_INVALID_VIRTUAL_ADDRESS = 0x21UL,
   ENUM_RDMA_CQE_STATUS_INVALID_REGION = 0x22UL,
   ENUM_RDMA_CQE_STATUS_INVALID_WINDOW = 0x23UL,
   ENUM_RDMA_CQE_STATUS_INVALID_LENGTH = 0x24UL
} RDMA_CQE_STATUS;

// Completion Queue Entry.  This format is used by both SQ and RQ CQEs.
typedef struct {
   BE_CQE_FLAGS_AMAP flags;
   BE_BIT qp_id[13];                              // DWORD 0
   BE_BIT order[3];                               // DWORD 0
   BE_BIT invalidated_stag[32];                   // DWORD 1
   BE_BIT bytes_received[31];                     // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT wqe_index[16];                          // DWORD 3
   BE_BIT op[8];                                  // DWORD 3
   BE_BIT status[8];                              // DWORD 3
} SG_PACK BE_RDMA_CQE_AMAP;
typedef struct { u32 dw[4]; } RDMA_CQE_AMAP, *PRDMA_CQE_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __host_struct_amap_h__

