/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_common_iscsi_discovery_amap_h__
#define __ioctl_common_iscsi_discovery_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_MGMT_SLP_PARAMS_AMAP slp_param;
   BE_MGMT_ISNS_PARAMS_AMAP isns_param;
} SG_PACK BE_DISCOVERY_PARAMS_AMAP;
typedef struct { u32 dw[222]; } DISCOVERY_PARAMS_AMAP, *PDISCOVERY_PARAMS_AMAP;


//              This Ioctl will set the initial parameters for SLP and iSNS modes of iSCSI
// discovery.              iSNS servers can be added to the iSNS Table using this Ioctl.
// Optionally,              the iSNS Servers can be located using DHCP. There can be
// maximum of 4 iSNS Servers              in the table.              <br>            
// <b>Originator(s)</b> : Management application             <br>            
// <b>Implemented in</b>: Firmware             <br>             <b>Return Values</b> :
// <ul>                                 <li>MGMT_STATUS_SUCCESS                           
//      <li>MGMT_STATUS_INVALID_ISNS_ADDRESS                             </ul>          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_DISCOVERY_PARAMS_AMAP discovery_params;
} SG_PACK BE_IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS_AMAP;
typedef struct { u32 dw[226]; } IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS_AMAP, *PIOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS_AMAP;



typedef IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS_AMAP IOCTL_ISCSI_COMMON_DISCOVERY_GET_PARAMETERS_AMAP;
typedef BE_IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS_AMAP BE_IOCTL_ISCSI_COMMON_DISCOVERY_GET_PARAMETERS_AMAP;


typedef IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS_AMAP* PIOCTL_ISCSI_COMMON_DISCOVERY_GET_PARAMETERS_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_COMMON_DISCOVERY_GET_PARAMETERS_AMAP;


typedef IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS_AMAP IOCTL_ISCSI_COMMONI_DISCOVERY_SET_PARAMETERS_AMAP;
typedef BE_IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS_AMAP BE_IOCTL_ISCSI_COMMONI_DISCOVERY_SET_PARAMETERS_AMAP;


typedef IOCTL_ISCSI_COMMON_DISCOVERY_PARAMETERS_AMAP* PIOCTL_ISCSI_COMMON_DISCOVERY_SET_PARAMETERS_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_COMMON_DISCOVERY_SET_PARAMETERS_AMAP;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_common_iscsi_discovery_amap_h__

