/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_common_iscsi_ipsec_amap_h__
#define __ioctl_common_iscsi_ipsec_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT32_AMAP xml_length;
   BE_UEXACT8_AMAP xml_data[65000];
} SG_PACK BE_IPSEC_DOWNLOAD_XML_PARAMS_IN_AMAP;
typedef struct { u32 dw[16251]; } IPSEC_DOWNLOAD_XML_PARAMS_IN_AMAP, *PIPSEC_DOWNLOAD_XML_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_DOWNLOAD_XML_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_DOWNLOAD_XML_PARAMS_OUT_AMAP, *PIPSEC_DOWNLOAD_XML_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_DOWNLOAD_XML_PARAMS_IN_AMAP request;
   BE_IPSEC_DOWNLOAD_XML_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_DOWNLOAD_XML_PARAMS_AMAP;
typedef struct { u32 dw[16251]; } IPSEC_DOWNLOAD_XML_PARAMS_AMAP, *PIPSEC_DOWNLOAD_XML_PARAMS_AMAP;


//  	    Only one XML file may be stored on a given BladeEngine.  This XML file contains
// the Security Policy Database (SPD). 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_DOWNLOAD_XML_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_DOWNLOAD_XML_AMAP;
typedef struct { u32 dw[16255]; } IOCTL_COMMON_ISCSI_IPSEC_DOWNLOAD_XML_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_DOWNLOAD_XML_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_DELETE_XML_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_DELETE_XML_PARAMS_IN_AMAP, *PIPSEC_DELETE_XML_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_DELETE_XML_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_DELETE_XML_PARAMS_OUT_AMAP, *PIPSEC_DELETE_XML_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_DELETE_XML_PARAMS_IN_AMAP request;
   BE_IPSEC_DELETE_XML_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_DELETE_XML_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IPSEC_DELETE_XML_PARAMS_AMAP, *PIPSEC_DELETE_XML_PARAMS_AMAP;


//  	    The XML may be deleted either through download of a zero byte XML file, or by
// using this IOCTL. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_DELETE_XML_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_DELETE_XML_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_IPSEC_DELETE_XML_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_DELETE_XML_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_GET_RX_STATS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_GET_RX_STATS_PARAMS_IN_AMAP, *PIPSEC_GET_RX_STATS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP bad_spi0;
   BE_UEXACT32_AMAP bad_spi1;
   BE_UEXACT32_AMAP bad_decrypt0;
   BE_UEXACT32_AMAP bad_decrypt1;
   BE_UEXACT32_AMAP bad_auth0;
   BE_UEXACT32_AMAP bad_auth1;
   BE_UEXACT32_AMAP good_replay0;
   BE_UEXACT32_AMAP good_replay1;
   BE_UEXACT32_AMAP esp_bytes0;
   BE_UEXACT32_AMAP esp_bytes1;
   BE_UEXACT32_AMAP ah_bytes0;
   BE_UEXACT32_AMAP ah_bytes1;
   BE_UEXACT32_AMAP time_stamp;
   BE_UEXACT32_AMAP auditlog_ts;
   BE_UEXACT32_AMAP auditlog_tss;
   BE_UEXACT32_AMAP auditlog_spi;
   BE_UEXACT32_AMAP auditlog_sn;
   BE_UEXACT32_AMAP auditlog_sa;
   BE_UEXACT32_AMAP auditlog_da;
} SG_PACK BE_IPSEC_GET_RX_STATS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[19]; } IPSEC_GET_RX_STATS_PARAMS_OUT_AMAP, *PIPSEC_GET_RX_STATS_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_GET_RX_STATS_PARAMS_IN_AMAP request;
   BE_IPSEC_GET_RX_STATS_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_GET_RX_STATS_PARAMS_AMAP;
typedef struct { u32 dw[19]; } IPSEC_GET_RX_STATS_PARAMS_AMAP, *PIPSEC_GET_RX_STATS_PARAMS_AMAP;


//  	    BE software and hardware make the following receive-side IPsec statistics
// available. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_GET_RX_STATS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_GET_RX_STATS_AMAP;
typedef struct { u32 dw[23]; } IOCTL_COMMON_ISCSI_IPSEC_GET_RX_STATS_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_GET_RX_STATS_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_GET_TX_STATS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_GET_TX_STATS_PARAMS_IN_AMAP, *PIPSEC_GET_TX_STATS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP esp_bytes0;
   BE_UEXACT32_AMAP esp_bytes1;
   BE_UEXACT32_AMAP ah_bytes0;
   BE_UEXACT32_AMAP ah_bytes1;
   BE_UEXACT32_AMAP time_stamp;
   BE_UEXACT32_AMAP auditlog_ts;
   BE_UEXACT32_AMAP auditlog_tss;
   BE_UEXACT32_AMAP auditlog_spi;
   BE_UEXACT32_AMAP auditlog_sn;
   BE_UEXACT32_AMAP auditlog_sa;
   BE_UEXACT32_AMAP auditlog_da;
} SG_PACK BE_IPSEC_GET_TX_STATS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[11]; } IPSEC_GET_TX_STATS_PARAMS_OUT_AMAP, *PIPSEC_GET_TX_STATS_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_GET_TX_STATS_PARAMS_IN_AMAP request;
   BE_IPSEC_GET_TX_STATS_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_GET_TX_STATS_PARAMS_AMAP;
typedef struct { u32 dw[11]; } IPSEC_GET_TX_STATS_PARAMS_AMAP, *PIPSEC_GET_TX_STATS_PARAMS_AMAP;


//  		BE software and hardware make the following transmit-side IPsec statistics
// available. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_GET_TX_STATS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_GET_TX_STATS_AMAP;
typedef struct { u32 dw[15]; } IOCTL_COMMON_ISCSI_IPSEC_GET_TX_STATS_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_GET_TX_STATS_AMAP;



typedef struct {
   BE_UEXACT8_AMAP group_name[128];
   BE_UEXACT8_AMAP certificate[8192];
   BE_UEXACT32_AMAP certificate_length;
} SG_PACK BE_IPSEC_ADD_CERTIFICATE_PARAMS_IN_AMAP;
typedef struct { u32 dw[2081]; } IPSEC_ADD_CERTIFICATE_PARAMS_IN_AMAP, *PIPSEC_ADD_CERTIFICATE_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_ADD_CERTIFICATE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ADD_CERTIFICATE_PARAMS_OUT_AMAP, *PIPSEC_ADD_CERTIFICATE_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_ADD_CERTIFICATE_PARAMS_IN_AMAP request;
   BE_IPSEC_ADD_CERTIFICATE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_ADD_CERTIFICATE_PARAMS_AMAP;
typedef struct { u32 dw[2081]; } IPSEC_ADD_CERTIFICATE_PARAMS_AMAP, *PIPSEC_ADD_CERTIFICATE_PARAMS_AMAP;


//  		This Ioctl will store a certificate for use with the Certificate Provider 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_ADD_CERTIFICATE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_ADD_CERTIFICATE_AMAP;
typedef struct { u32 dw[2085]; } IOCTL_COMMON_ISCSI_IPSEC_ADD_CERTIFICATE_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_ADD_CERTIFICATE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP group_name[128];
} SG_PACK BE_IPSEC_DEL_CERTIFICATE_PARAMS_IN_AMAP;
typedef struct { u32 dw[32]; } IPSEC_DEL_CERTIFICATE_PARAMS_IN_AMAP, *PIPSEC_DEL_CERTIFICATE_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_DEL_CERTIFICATE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_DEL_CERTIFICATE_PARAMS_OUT_AMAP, *PIPSEC_DEL_CERTIFICATE_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_DEL_CERTIFICATE_PARAMS_IN_AMAP request;
   BE_IPSEC_DEL_CERTIFICATE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_DEL_CERTIFICATE_PARAMS_AMAP;
typedef struct { u32 dw[32]; } IPSEC_DEL_CERTIFICATE_PARAMS_AMAP, *PIPSEC_DEL_CERTIFICATE_PARAMS_AMAP;


//  	     Remove a previously stored certificate 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_DEL_CERTIFICATE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_DEL_CERTIFICATE_AMAP;
typedef struct { u32 dw[36]; } IOCTL_COMMON_ISCSI_IPSEC_DEL_CERTIFICATE_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_DEL_CERTIFICATE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP group_name[128];
   BE_UEXACT8_AMAP private_key[4096];
   BE_UEXACT32_AMAP private_key_length;
} SG_PACK BE_IPSEC_ADD_PRIVATE_KEY_PARAMS_IN_AMAP;
typedef struct { u32 dw[1057]; } IPSEC_ADD_PRIVATE_KEY_PARAMS_IN_AMAP, *PIPSEC_ADD_PRIVATE_KEY_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_ADD_PRIVATE_KEY_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ADD_PRIVATE_KEY_PARAMS_OUT_AMAP, *PIPSEC_ADD_PRIVATE_KEY_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_ADD_PRIVATE_KEY_PARAMS_IN_AMAP request;
   BE_IPSEC_ADD_PRIVATE_KEY_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_ADD_PRIVATE_KEY_PARAMS_AMAP;
typedef struct { u32 dw[1057]; } IPSEC_ADD_PRIVATE_KEY_PARAMS_AMAP, *PIPSEC_ADD_PRIVATE_KEY_PARAMS_AMAP;


//  	    Store a private key for use with the Certificate Provider 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_ADD_PRIVATE_KEY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_ADD_PRIVATE_KEY_AMAP;
typedef struct { u32 dw[1061]; } IOCTL_COMMON_ISCSI_IPSEC_ADD_PRIVATE_KEY_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_ADD_PRIVATE_KEY_AMAP;



typedef struct {
   BE_UEXACT8_AMAP group_name[128];
} SG_PACK BE_IPSEC_DEL_PRIVATE_KEY_PARAMS_IN_AMAP;
typedef struct { u32 dw[32]; } IPSEC_DEL_PRIVATE_KEY_PARAMS_IN_AMAP, *PIPSEC_DEL_PRIVATE_KEY_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_DEL_PRIVATE_KEY_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_DEL_PRIVATE_KEY_PARAMS_OUT_AMAP, *PIPSEC_DEL_PRIVATE_KEY_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_DEL_PRIVATE_KEY_PARAMS_IN_AMAP request;
   BE_IPSEC_DEL_PRIVATE_KEY_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_DEL_PRIVATE_KEY_PARAMS_AMAP;
typedef struct { u32 dw[32]; } IPSEC_DEL_PRIVATE_KEY_PARAMS_AMAP, *PIPSEC_DEL_PRIVATE_KEY_PARAMS_AMAP;


//  	    Remove a previously stored private key 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_DEL_PRIVATE_KEY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_DEL_PRIVATE_KEY_AMAP;
typedef struct { u32 dw[36]; } IOCTL_COMMON_ISCSI_IPSEC_DEL_PRIVATE_KEY_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_DEL_PRIVATE_KEY_AMAP;



typedef struct {
   BE_UEXACT8_AMAP group_name[128];
   BE_UEXACT8_AMAP passphrase[128];
   BE_UEXACT32_AMAP passphrase_length;
} SG_PACK BE_IPSEC_ADD_PASSPHRASE_PARAMS_IN_AMAP;
typedef struct { u32 dw[65]; } IPSEC_ADD_PASSPHRASE_PARAMS_IN_AMAP, *PIPSEC_ADD_PASSPHRASE_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_ADD_PASSPHRASE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ADD_PASSPHRASE_PARAMS_OUT_AMAP, *PIPSEC_ADD_PASSPHRASE_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_ADD_PASSPHRASE_PARAMS_IN_AMAP request;
   BE_IPSEC_ADD_PASSPHRASE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_ADD_PASSPHRASE_PARAMS_AMAP;
typedef struct { u32 dw[65]; } IPSEC_ADD_PASSPHRASE_PARAMS_AMAP, *PIPSEC_ADD_PASSPHRASE_PARAMS_AMAP;


//  	    Store passphrase for use with the certificate provider  	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_ADD_PASSPHRASE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_ADD_PASSPHRASE_AMAP;
typedef struct { u32 dw[69]; } IOCTL_COMMON_ISCSI_IPSEC_ADD_PASSPHRASE_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_ADD_PASSPHRASE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP group_name[128];
} SG_PACK BE_IPSEC_DEL_PASSPHRASE_PARAMS_IN_AMAP;
typedef struct { u32 dw[32]; } IPSEC_DEL_PASSPHRASE_PARAMS_IN_AMAP, *PIPSEC_DEL_PASSPHRASE_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_DEL_PASSPHRASE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_DEL_PASSPHRASE_PARAMS_OUT_AMAP, *PIPSEC_DEL_PASSPHRASE_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_DEL_PASSPHRASE_PARAMS_IN_AMAP request;
   BE_IPSEC_DEL_PASSPHRASE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_DEL_PASSPHRASE_AMAP;
typedef struct { u32 dw[32]; } IPSEC_DEL_PASSPHRASE_AMAP, *PIPSEC_DEL_PASSPHRASE_AMAP;


//  	    Remove previously stored passphrase 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_DEL_PASSPHRASE_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_DEL_PASSPHRASE_AMAP;
typedef struct { u32 dw[36]; } IOCTL_COMMON_ISCSI_IPSEC_DEL_PASSPHRASE_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_DEL_PASSPHRASE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP enable;
} SG_PACK BE_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_PARAMS_IN_AMAP, *PIPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_PARAMS_OUT_AMAP, *PIPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_PARAMS_IN_AMAP request;
   BE_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_AMAP, *PIPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_AMAP;


//  	    Enable/disable flash encryption - default is disabled 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_GET_GROUP_NAMES_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_GET_GROUP_NAMES_IN_AMAP, *PIPSEC_GET_GROUP_NAMES_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP group_name_0[128];
   BE_UEXACT8_AMAP group_name_1[128];
   BE_UEXACT8_AMAP group_name_2[128];
   BE_UEXACT8_AMAP group_name_3[128];
} SG_PACK BE_IPSEC_GET_GROUP_NAMES_OUT_AMAP;
typedef struct { u32 dw[128]; } IPSEC_GET_GROUP_NAMES_OUT_AMAP, *PIPSEC_GET_GROUP_NAMES_OUT_AMAP;



typedef union {
   BE_IPSEC_GET_GROUP_NAMES_IN_AMAP request;
   BE_IPSEC_GET_GROUP_NAMES_OUT_AMAP response;
} SG_PACK BE_IPSEC_GET_GROUP_NAMES_AMAP;
typedef struct { u32 dw[128]; } IPSEC_GET_GROUP_NAMES_AMAP, *PIPSEC_GET_GROUP_NAMES_AMAP;


//  	    Get the group name associated with the triplet (cert, prv, pas).           Up to
// four groups may be stored. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_GET_GROUP_NAMES_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_GET_GROUP_NAMES_AMAP;
typedef struct { u32 dw[132]; } IOCTL_COMMON_ISCSI_IPSEC_GET_GROUP_NAMES_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_GET_GROUP_NAMES_AMAP;



typedef struct {
   BE_UEXACT32_AMAP group_number;
} SG_PACK BE_IPSEC_GET_SINGLE_GROUP_NAME_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_GET_SINGLE_GROUP_NAME_IN_AMAP, *PIPSEC_GET_SINGLE_GROUP_NAME_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP group_name[128];
} SG_PACK BE_IPSEC_GET_SINGLE_GROUP_NAME_OUT_AMAP;
typedef struct { u32 dw[32]; } IPSEC_GET_SINGLE_GROUP_NAME_OUT_AMAP, *PIPSEC_GET_SINGLE_GROUP_NAME_OUT_AMAP;



typedef union {
   BE_IPSEC_GET_SINGLE_GROUP_NAME_IN_AMAP request;
   BE_IPSEC_GET_SINGLE_GROUP_NAME_OUT_AMAP response;
} SG_PACK BE_IPSEC_GET_SINGLE_GROUP_NAME_AMAP;
typedef struct { u32 dw[32]; } IPSEC_GET_SINGLE_GROUP_NAME_AMAP, *PIPSEC_GET_SINGLE_GROUP_NAME_AMAP;


//  	    Get the group name associated with the triplet (cert, prv, pas). 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_GET_SINGLE_GROUP_NAME_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_GET_SINGLE_GROUP_NAME_AMAP;
typedef struct { u32 dw[36]; } IOCTL_COMMON_ISCSI_IPSEC_GET_SINGLE_GROUP_NAME_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_GET_SINGLE_GROUP_NAME_AMAP;



typedef struct {
   BE_UEXACT32_AMAP group_number;
   BE_UEXACT8_AMAP group_name[128];
} SG_PACK BE_IPSEC_ADD_GROUP_IN_AMAP;
typedef struct { u32 dw[33]; } IPSEC_ADD_GROUP_IN_AMAP, *PIPSEC_ADD_GROUP_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_ADD_GROUP_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ADD_GROUP_OUT_AMAP, *PIPSEC_ADD_GROUP_OUT_AMAP;



typedef union {
   BE_IPSEC_ADD_GROUP_IN_AMAP request;
   BE_IPSEC_ADD_GROUP_OUT_AMAP response;
} SG_PACK BE_IPSEC_ADD_GROUP_AMAP;
typedef struct { u32 dw[33]; } IPSEC_ADD_GROUP_AMAP, *PIPSEC_ADD_GROUP_AMAP;


//  	    Create a group for storing (cert, prv, pas). 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_ADD_GROUP_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_ADD_GROUP_AMAP;
typedef struct { u32 dw[37]; } IOCTL_COMMON_ISCSI_IPSEC_ADD_GROUP_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_ADD_GROUP_AMAP;



typedef struct {
   BE_UEXACT32_AMAP group_number;
   BE_UEXACT8_AMAP group_name[128];
} SG_PACK BE_IPSEC_DELETE_GROUP_IN_AMAP;
typedef struct { u32 dw[33]; } IPSEC_DELETE_GROUP_IN_AMAP, *PIPSEC_DELETE_GROUP_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_DELETE_GROUP_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_DELETE_GROUP_OUT_AMAP, *PIPSEC_DELETE_GROUP_OUT_AMAP;



typedef union {
   BE_IPSEC_DELETE_GROUP_IN_AMAP request;
   BE_IPSEC_DELETE_GROUP_OUT_AMAP response;
} SG_PACK BE_IPSEC_DELETE_GROUP_AMAP;
typedef struct { u32 dw[33]; } IPSEC_DELETE_GROUP_AMAP, *PIPSEC_DELETE_GROUP_AMAP;


//  	    Delete a group (cert, prv, pas) including the name.  Use a group number of 128 to
// delete a group by name. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_DELETE_GROUP_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_DELETE_GROUP_AMAP;
typedef struct { u32 dw[37]; } IOCTL_COMMON_ISCSI_IPSEC_DELETE_GROUP_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_DELETE_GROUP_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_QMSTATS_GROUP_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_QMSTATS_GROUP_IN_AMAP, *PIPSEC_QMSTATS_GROUP_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP active_sa0;
   BE_UEXACT32_AMAP active_sa1;
   BE_UEXACT32_AMAP pending_keyops0;
   BE_UEXACT32_AMAP pending_keyops1;
   BE_UEXACT32_AMAP key_adds0;
   BE_UEXACT32_AMAP key_adds1;
   BE_UEXACT32_AMAP key_dels0;
   BE_UEXACT32_AMAP key_dels1;
   BE_UEXACT32_AMAP rekeys0;
   BE_UEXACT32_AMAP rekeys1;
   BE_UEXACT32_AMAP active_tunnels0;
   BE_UEXACT32_AMAP active_tunnels1;
   BE_UEXACT32_AMAP bad_spi0;
   BE_UEXACT32_AMAP bad_spi1;
   BE_UEXACT32_AMAP not_decrypted0;
   BE_UEXACT32_AMAP not_decrypted1;
   BE_UEXACT32_AMAP not_authenticated0;
   BE_UEXACT32_AMAP not_authenticated1;
   BE_UEXACT32_AMAP replay_ok0;
   BE_UEXACT32_AMAP replay_ok1;
   BE_UEXACT32_AMAP esp_bytes_send0;
   BE_UEXACT32_AMAP esp_bytes_send1;
   BE_UEXACT32_AMAP esp_bytes_recv0;
   BE_UEXACT32_AMAP esp_bytes_recv1;
   BE_UEXACT32_AMAP ah_bytes_send0;
   BE_UEXACT32_AMAP ah_bytes_send1;
   BE_UEXACT32_AMAP ah_bytes_recv0;
   BE_UEXACT32_AMAP ah_bytes_recv1;
   BE_UEXACT32_AMAP transport_bytes_send0;
   BE_UEXACT32_AMAP transport_bytes_send1;
   BE_UEXACT32_AMAP transport_bytes_recv0;
   BE_UEXACT32_AMAP transport_bytes_recv1;
   BE_UEXACT32_AMAP tunnel_bytes_send0;
   BE_UEXACT32_AMAP tunnel_bytes_send1;
   BE_UEXACT32_AMAP tunnel_bytes_recv0;
   BE_UEXACT32_AMAP tunnel_bytes_recv1;
   BE_BIT rsvd0[32];                              // DWORD 36
} SG_PACK BE_IPSEC_QMSTATS_GROUP_OUT_AMAP;
typedef struct { u32 dw[37]; } IPSEC_QMSTATS_GROUP_OUT_AMAP, *PIPSEC_QMSTATS_GROUP_OUT_AMAP;



typedef union {
   BE_IPSEC_QMSTATS_GROUP_IN_AMAP request;
   BE_IPSEC_QMSTATS_GROUP_OUT_AMAP response;
} SG_PACK BE_IPSEC_GET_QMSTATS_AMAP;
typedef struct { u32 dw[37]; } IPSEC_GET_QMSTATS_AMAP, *PIPSEC_GET_QMSTATS_AMAP;


//  	    IKE Quick Mode statistics defined by Microsoft for WMI. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_GET_QMSTATS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_GET_QMSTATS_AMAP;
typedef struct { u32 dw[41]; } IOCTL_COMMON_ISCSI_IPSEC_GET_QMSTATS_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_GET_QMSTATS_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_MMSTATS_GROUP_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_MMSTATS_GROUP_IN_AMAP, *PIPSEC_MMSTATS_GROUP_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP active_acquire0;
   BE_UEXACT32_AMAP active_acquire1;
   BE_UEXACT32_AMAP active_receive0;
   BE_UEXACT32_AMAP active_receive1;
   BE_UEXACT32_AMAP acquire_fail0;
   BE_UEXACT32_AMAP acquire_fail1;
   BE_UEXACT32_AMAP receive_fail0;
   BE_UEXACT32_AMAP receive_fail1;
   BE_UEXACT32_AMAP send_fail0;
   BE_UEXACT32_AMAP send_fail1;
   BE_UEXACT32_AMAP acquire_heap0;
   BE_UEXACT32_AMAP acquire_heap1;
   BE_UEXACT32_AMAP receive_heap0;
   BE_UEXACT32_AMAP receive_heap1;
   BE_UEXACT32_AMAP negotiation_fail0;
   BE_UEXACT32_AMAP negotiation_fail1;
   BE_UEXACT32_AMAP auth_fail0;
   BE_UEXACT32_AMAP auth_fail1;
   BE_UEXACT32_AMAP invalid_cookie0;
   BE_UEXACT32_AMAP invalid_cookie1;
   BE_UEXACT32_AMAP ike_get_spi0;
   BE_UEXACT32_AMAP ike_get_spi1;
   BE_UEXACT32_AMAP key_add0;
   BE_UEXACT32_AMAP key_add1;
   BE_UEXACT32_AMAP key_update0;
   BE_UEXACT32_AMAP key_update1;
   BE_UEXACT32_AMAP get_spi_fail0;
   BE_UEXACT32_AMAP get_spi_fail1;
   BE_UEXACT32_AMAP key_add_fail0;
   BE_UEXACT32_AMAP key_add_fail1;
   BE_UEXACT32_AMAP key_update_fail0;
   BE_UEXACT32_AMAP key_update_fail1;
   BE_UEXACT32_AMAP conn_list_size0;
   BE_UEXACT32_AMAP conn_list_size1;
   BE_UEXACT32_AMAP main_mode0;
   BE_UEXACT32_AMAP main_mode1;
   BE_UEXACT32_AMAP quick_mode0;
   BE_UEXACT32_AMAP quick_mode1;
   BE_UEXACT32_AMAP invalid_pkt0;
   BE_UEXACT32_AMAP invalid_pkt1;
   BE_UEXACT32_AMAP soft_assoc0;
   BE_UEXACT32_AMAP soft_assoc1;
   BE_BIT rsvd0[32];                              // DWORD 42
} SG_PACK BE_IPSEC_MMSTATS_GROUP_OUT_AMAP;
typedef struct { u32 dw[43]; } IPSEC_MMSTATS_GROUP_OUT_AMAP, *PIPSEC_MMSTATS_GROUP_OUT_AMAP;



typedef union {
   BE_IPSEC_MMSTATS_GROUP_IN_AMAP request;
   BE_IPSEC_MMSTATS_GROUP_OUT_AMAP response;
} SG_PACK BE_IPSEC_GET_MMSTATS_AMAP;
typedef struct { u32 dw[43]; } IPSEC_GET_MMSTATS_AMAP, *PIPSEC_GET_MMSTATS_AMAP;


//  	    IKE Main Mode statistics defined by Microsoft for WMI. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_GET_MMSTATS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_GET_MMSTATS_AMAP;
typedef struct { u32 dw[47]; } IOCTL_COMMON_ISCSI_IPSEC_GET_MMSTATS_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_GET_MMSTATS_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_GET_STATE_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_GET_STATE_IN_AMAP, *PIPSEC_GET_STATE_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP xml_or_wmi;
   BE_UEXACT8_AMAP ike_ok;
   BE_UEXACT8_AMAP flash_loaded;
   BE_UEXACT32_AMAP total_tunnels;
   BE_UEXACT32_AMAP total_rules;
} SG_PACK BE_IPSEC_GET_STATE_OUT_AMAP;
typedef struct { u32 dw[3]; } IPSEC_GET_STATE_OUT_AMAP, *PIPSEC_GET_STATE_OUT_AMAP;



typedef union {
   BE_IPSEC_GET_STATE_IN_AMAP request;
   BE_IPSEC_GET_STATE_OUT_AMAP response;
} SG_PACK BE_IPSEC_GET_STATE_AMAP;
typedef struct { u32 dw[3]; } IPSEC_GET_STATE_AMAP, *PIPSEC_GET_STATE_AMAP;


//  	    Get the current state of the IKE. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_GET_STATE_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_GET_STATE_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_ISCSI_IPSEC_GET_STATE_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_GET_STATE_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_CLEAR_PSK_CACHE_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_CLEAR_PSK_CACHE_IN_AMAP, *PIPSEC_CLEAR_PSK_CACHE_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_CLEAR_PSK_CACHE_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_CLEAR_PSK_CACHE_OUT_AMAP, *PIPSEC_CLEAR_PSK_CACHE_OUT_AMAP;



typedef union {
   BE_IPSEC_CLEAR_PSK_CACHE_IN_AMAP request;
   BE_IPSEC_CLEAR_PSK_CACHE_OUT_AMAP response;
} SG_PACK BE_IPSEC_CLEAR_PSK_CACHE_AMAP;
typedef struct { u32 dw[1]; } IPSEC_CLEAR_PSK_CACHE_AMAP, *PIPSEC_CLEAR_PSK_CACHE_AMAP;


//  	    Clear out the PSK cache. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_CLEAR_PSK_CACHE_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_CLEAR_PSK_CACHE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_IPSEC_CLEAR_PSK_CACHE_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_CLEAR_PSK_CACHE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP port_num;
   BE_UEXACT8_AMAP id_type;
   BE_UEXACT32_AMAP id_len;
   BE_UEXACT8_AMAP id[256];
} SG_PACK BE_IPSEC_GET_PSK_IN_AMAP;
typedef struct { u32 dw[67]; } IPSEC_GET_PSK_IN_AMAP, *PIPSEC_GET_PSK_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP security_flags;
} SG_PACK BE_IPSEC_GET_PSK_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_GET_PSK_OUT_AMAP, *PIPSEC_GET_PSK_OUT_AMAP;



typedef union {
   BE_IPSEC_GET_PSK_IN_AMAP request;
   BE_IPSEC_GET_PSK_OUT_AMAP response;
} SG_PACK BE_IPSEC_GET_PSK_AMAP;
typedef struct { u32 dw[67]; } IPSEC_GET_PSK_AMAP, *PIPSEC_GET_PSK_AMAP;


//  	    Retrieve a PSK.  MS WMI calls currently omit the returned PSK. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_GET_PSK_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_GET_PSK_AMAP;
typedef struct { u32 dw[71]; } IOCTL_COMMON_ISCSI_IPSEC_GET_PSK_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_GET_PSK_AMAP;



typedef struct {
   BE_UEXACT8_AMAP guid[16];
} SG_PACK BE_IPSEC_SET_GUID_IN_AMAP;
typedef struct { u32 dw[4]; } IPSEC_SET_GUID_IN_AMAP, *PIPSEC_SET_GUID_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_SET_GUID_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_SET_GUID_OUT_AMAP, *PIPSEC_SET_GUID_OUT_AMAP;



typedef union {
   BE_IPSEC_SET_GUID_IN_AMAP request;
   BE_IPSEC_SET_GUID_OUT_AMAP response;
} SG_PACK BE_IPSEC_SET_GUID_AMAP;
typedef struct { u32 dw[4]; } IPSEC_SET_GUID_AMAP, *PIPSEC_SET_GUID_AMAP;


//  	    Sets a MS specific value.  No method to retrieve this. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_SET_GUID_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_SET_GUID_AMAP;
typedef struct { u32 dw[8]; } IOCTL_COMMON_ISCSI_IPSEC_SET_GUID_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_SET_GUID_AMAP;



typedef struct {
   BE_UEXACT32_AMAP port_num;
   BE_UEXACT32_AMAP security_flags;
   BE_UEXACT8_AMAP id_type;
   BE_UEXACT32_AMAP id_len;
   BE_UEXACT32_AMAP key_size;
   BE_UEXACT8_AMAP id[256];
   BE_UEXACT8_AMAP key[256];
} SG_PACK BE_IPSEC_SET_PSK_IN_AMAP;
typedef struct { u32 dw[133]; } IPSEC_SET_PSK_IN_AMAP, *PIPSEC_SET_PSK_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_SET_PSK_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_SET_PSK_OUT_AMAP, *PIPSEC_SET_PSK_OUT_AMAP;



typedef union {
   BE_IPSEC_SET_PSK_IN_AMAP request;
   BE_IPSEC_SET_PSK_OUT_AMAP response;
} SG_PACK BE_IPSEC_SET_PSK_AMAP;
typedef struct { u32 dw[133]; } IPSEC_SET_PSK_AMAP, *PIPSEC_SET_PSK_AMAP;


//  	    Sets a PSK for a particular IKE ID. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_SET_PSK_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_SET_PSK_AMAP;
typedef struct { u32 dw[137]; } IOCTL_COMMON_ISCSI_IPSEC_SET_PSK_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_SET_PSK_AMAP;



typedef struct {
   BE_UEXACT32_AMAP port_num;
   BE_UEXACT8_AMAP dest_ip[16];
   BE_UEXACT8_AMAP tunnel_mode_outer_address[16];
} SG_PACK BE_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_IN_AMAP;
typedef struct { u32 dw[9]; } IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_IN_AMAP, *PIPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_OUT_AMAP, *PIPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_OUT_AMAP;



typedef union {
   BE_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_IN_AMAP request;
   BE_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_OUT_AMAP response;
} SG_PACK BE_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_AMAP;
typedef struct { u32 dw[9]; } IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_AMAP, *PIPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_AMAP;


//  	    Sets the tunnel mode outer address. 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_AMAP;
typedef struct { u32 dw[13]; } IOCTL_COMMON_ISCSI_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_GET_SECURITY_CAPABILITIES_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_GET_SECURITY_CAPABILITIES_IN_AMAP, *PIPSEC_GET_SECURITY_CAPABILITIES_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP protect_iscsi;
   BE_UEXACT8_AMAP protect_isns;
   BE_UEXACT8_AMAP certificates_supported;
   BE_UEXACT32_AMAP encryption_count;
   BE_UEXACT32_AMAP encryption_types;
} SG_PACK BE_IPSEC_GET_SECURITY_CAPABILITIES_OUT_AMAP;
typedef struct { u32 dw[3]; } IPSEC_GET_SECURITY_CAPABILITIES_OUT_AMAP, *PIPSEC_GET_SECURITY_CAPABILITIES_OUT_AMAP;



typedef union {
   BE_IPSEC_GET_SECURITY_CAPABILITIES_IN_AMAP request;
   BE_IPSEC_GET_SECURITY_CAPABILITIES_OUT_AMAP response;
} SG_PACK BE_IPSEC_GET_SECURITY_CAPABILITIES_AMAP;
typedef struct { u32 dw[3]; } IPSEC_GET_SECURITY_CAPABILITIES_AMAP, *PIPSEC_GET_SECURITY_CAPABILITIES_AMAP;


//  	    MS WMI call to obtain general HBA IPsec information.  	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_GET_SECURITY_CAPABILITIES_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_GET_SECURITY_CAPABILITIES_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_ISCSI_IPSEC_GET_SECURITY_CAPABILITIES_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_GET_SECURITY_CAPABILITIES_AMAP;



typedef struct {
   BE_UEXACT32_AMAP key_size;
   BE_UEXACT32_AMAP key[256];
} SG_PACK BE_IPSEC_SET_GROUP_PSK_IN_AMAP;
typedef struct { u32 dw[257]; } IPSEC_SET_GROUP_PSK_IN_AMAP, *PIPSEC_SET_GROUP_PSK_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_SET_GROUP_PSK_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_SET_GROUP_PSK_OUT_AMAP, *PIPSEC_SET_GROUP_PSK_OUT_AMAP;



typedef union {
   BE_IPSEC_SET_GROUP_PSK_IN_AMAP request;
   BE_IPSEC_SET_GROUP_PSK_OUT_AMAP response;
} SG_PACK BE_IPSEC_SET_GROUP_PSK_AMAP;
typedef struct { u32 dw[257]; } IPSEC_SET_GROUP_PSK_AMAP, *PIPSEC_SET_GROUP_PSK_AMAP;


//  	    Sets the global PSK.  	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_SET_GROUP_PSK_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_SET_GROUP_PSK_AMAP;
typedef struct { u32 dw[261]; } IOCTL_COMMON_ISCSI_IPSEC_SET_GROUP_PSK_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_SET_GROUP_PSK_AMAP;



typedef struct {
   BE_UEXACT32_AMAP certificate_length;
   BE_UEXACT8_AMAP certificate[8192];
} SG_PACK BE_IPSEC_ADD_ROOT_CERTIFICATE_PARAMS_IN_AMAP;
typedef struct { u32 dw[2049]; } IPSEC_ADD_ROOT_CERTIFICATE_PARAMS_IN_AMAP, *PIPSEC_ADD_ROOT_CERTIFICATE_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_ADD_ROOT_CERTIFICATE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ADD_ROOT_CERTIFICATE_PARAMS_OUT_AMAP, *PIPSEC_ADD_ROOT_CERTIFICATE_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_ADD_ROOT_CERTIFICATE_PARAMS_IN_AMAP request;
   BE_IPSEC_ADD_ROOT_CERTIFICATE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_ADD_ROOT_CERTIFICATE_PARAMS_AMAP;
typedef struct { u32 dw[2049]; } IPSEC_ADD_ROOT_CERTIFICATE_PARAMS_AMAP, *PIPSEC_ADD_ROOT_CERTIFICATE_PARAMS_AMAP;


//  		This Ioctl will store a root certificate for use with the Certificate Provider 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_ADD_ROOT_CERTIFICATE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_ADD_ROOT_CERTIFICATE_AMAP;
typedef struct { u32 dw[2053]; } IOCTL_COMMON_ISCSI_IPSEC_ADD_ROOT_CERTIFICATE_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_ADD_ROOT_CERTIFICATE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP enable;
} SG_PACK BE_IPSEC_ENABLE_DISABLE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ENABLE_DISABLE_PARAMS_IN_AMAP, *PIPSEC_ENABLE_DISABLE_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IPSEC_ENABLE_DISABLE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ENABLE_DISABLE_PARAMS_OUT_AMAP, *PIPSEC_ENABLE_DISABLE_PARAMS_OUT_AMAP;



typedef union {
   BE_IPSEC_ENABLE_DISABLE_PARAMS_IN_AMAP request;
   BE_IPSEC_ENABLE_DISABLE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IPSEC_ENABLE_DISABLE_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IPSEC_ENABLE_DISABLE_PARAMS_AMAP, *PIPSEC_ENABLE_DISABLE_PARAMS_AMAP;


//  		This Ioctl will enable/disable IPsec software 	  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IPSEC_ENABLE_DISABLE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_AMAP, *PIOCTL_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_common_iscsi_ipsec_amap_h__

