/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_common_iscsi_ntwk_amap_h__
#define __ioctl_common_iscsi_ntwk_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT32_AMAP vlan_priority;
} SG_PACK BE_IFACE_CREATE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IFACE_CREATE_PARAMS_IN_AMAP, *PIFACE_CREATE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
} SG_PACK BE_IFACE_CREATE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IFACE_CREATE_PARAMS_OUT_AMAP, *PIFACE_CREATE_PARAMS_OUT_AMAP;



typedef union {
   BE_IFACE_CREATE_PARAMS_IN_AMAP request;
   BE_IFACE_CREATE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IFACE_CREATE_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IFACE_CREATE_PARAMS_AMAP, *PIFACE_CREATE_PARAMS_AMAP;


//               Creates an 'interface'. Interfaces will be IPv4/IPv6. After creating an  
//            inteface, use the returned interface-handle to              <ul>            
//     <li> Enable/disable DHCP based IP addresses                 <li> Set VLAN tag for
// the interface                 <li> Add/delete IP addresses for the interface (if DHCP
// server is not available)             </ul>             To delete an interface use
// [link]IOCTL_COMMON_ISCSI_NTWK_IFACE_DELETE[/link].                      
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IFACE_CREATE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_IFACE_CREATE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_NTWK_IFACE_CREATE_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_IFACE_CREATE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
} SG_PACK BE_IFACE_DELETE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IFACE_DELETE_PARAMS_IN_AMAP, *PIFACE_DELETE_PARAMS_IN_AMAP;


//              Deletes an IPv4/IPv6 interface. Use the interface handle returned by a
// call to              [link]IOCTL_COMMON_ISCSI_NTWK_IFACE_CREATE[/link].         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IFACE_DELETE_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_IFACE_DELETE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_NTWK_IFACE_DELETE_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_IFACE_DELETE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
   BE_UEXACT32_AMAP vlan_priority;
} SG_PACK BE_VLAN_SET_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } VLAN_SET_PARAMS_IN_AMAP, *PVLAN_SET_PARAMS_IN_AMAP;


//              Set the VLAN ID /priority tag for an interface. A given interface         
//    can have only one VLAN ID/priority setting. Create more interfaces             if
// more VLANs are required.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_VLAN_SET_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_SET_VLAN_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_ISCSI_NTWK_SET_VLAN_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_SET_VLAN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
   BE_UEXACT32_AMAP ip_type;
   BE_UEXACT32_AMAP flags;
   BE_UEXACT32_AMAP retry_count;
} SG_PACK BE_CONFIGURE_STATELESS_IP_ADDR_PARAMS_IN_AMAP;
typedef struct { u32 dw[4]; } CONFIGURE_STATELESS_IP_ADDR_PARAMS_IN_AMAP, *PCONFIGURE_STATELESS_IP_ADDR_PARAMS_IN_AMAP;


//  if the ip_type field is IP_TYPE_V4, DHCP will be performed and an V4 address          
//      will be attached           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_CONFIGURE_STATELESS_IP_ADDR_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_AMAP;
typedef struct { u32 dw[8]; } IOCTL_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
   BE_UEXACT32_AMAP ip_type;
} SG_PACK BE_RELEASE_STATELESS_IP_ADDR_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } RELEASE_STATELESS_IP_ADDR_PARAMS_IN_AMAP, *PRELEASE_STATELESS_IP_ADDR_PARAMS_IN_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_RELEASE_STATELESS_IP_ADDR_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
   BE_UEXACT32_AMAP retry_count;
   BE_UEXACT32_AMAP flags;
} SG_PACK BE_DISCOVER_ISNS_SERVER_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } DISCOVER_ISNS_SERVER_PARAMS_IN_AMAP, *PDISCOVER_ISNS_SERVER_PARAMS_IN_AMAP;


//  GET iSNS Server using DHCP.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_DISCOVER_ISNS_SERVER_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_DISCOVER_ISNS_SERVER_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_ISCSI_NTWK_DISCOVER_ISNS_SERVER_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_DISCOVER_ISNS_SERVER_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
} SG_PACK BE_GET_DISCOVERED_ISNS_SERVERS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_DISCOVERED_ISNS_SERVERS_PARAMS_IN_AMAP, *PGET_DISCOVERED_ISNS_SERVERS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP ip_address_count;
   BE_IP_ADDRESS_FORMAT_AMAP ip_address[1];
} SG_PACK BE_GET_DISCOVERED_ISNS_SERVERS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[7]; } GET_DISCOVERED_ISNS_SERVERS_PARAMS_OUT_AMAP, *PGET_DISCOVERED_ISNS_SERVERS_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_DISCOVERED_ISNS_SERVERS_PARAMS_IN_AMAP request;
   BE_GET_DISCOVERED_ISNS_SERVERS_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_DISCOVERED_ISNS_SERVERS_PARAMS_AMAP;
typedef struct { u32 dw[7]; } GET_DISCOVERED_ISNS_SERVERS_PARAMS_AMAP, *PGET_DISCOVERED_ISNS_SERVERS_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_DISCOVERED_ISNS_SERVERS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_GET_DISCOVERED_ISNS_SERVERS_AMAP;
typedef struct { u32 dw[11]; } IOCTL_COMMON_ISCSI_NTWK_GET_DISCOVERED_ISNS_SERVERS_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_GET_DISCOVERED_ISNS_SERVERS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP action;
   BE_UEXACT32_AMAP interface_hndl;
   BE_IP_ADDRESS_SUBNET_FORMAT_AMAP ip_address;
   BE_UEXACT32_AMAP status;
} SG_PACK BE_ISCSI_IP_ADDR_RECORD_AMAP;
typedef struct { u32 dw[13]; } ISCSI_IP_ADDR_RECORD_AMAP, *PISCSI_IP_ADDR_RECORD_AMAP;



typedef struct {
   BE_UEXACT32_AMAP record_entry_count;
   BE_ISCSI_IP_ADDR_RECORD_AMAP ip_record[1];
} SG_PACK BE_ISCSI_IP_ADDR_RECORD_PARAMS_AMAP;
typedef struct { u32 dw[14]; } ISCSI_IP_ADDR_RECORD_PARAMS_AMAP, *PISCSI_IP_ADDR_RECORD_PARAMS_AMAP;


//              Add an IP address to an interface. The interface handle is returned       
//      from [link]IOCTL_COMMON_ISCSI_NTWK_IFACE_CREATE[/link]         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_IP_ADDR_RECORD_PARAMS_AMAP ip_params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_AMAP;
typedef struct { u32 dw[18]; } IOCTL_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR_AMAP;



typedef struct {
   BE_UEXACT32_AMAP ip_type;
} SG_PACK BE_GET_DEFAULT_ROUTE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_DEFAULT_ROUTE_PARAMS_IN_AMAP, *PGET_DEFAULT_ROUTE_PARAMS_IN_AMAP;



typedef struct {
   BE_IP_ADDRESS_FORMAT_AMAP gateway;
} SG_PACK BE_GET_DEFAULT_ROUTE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[6]; } GET_DEFAULT_ROUTE_PARAMS_OUT_AMAP, *PGET_DEFAULT_ROUTE_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_DEFAULT_ROUTE_PARAMS_IN_AMAP request;
   BE_GET_DEFAULT_ROUTE_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_DEFAULT_ROUTE_PARAMS_AMAP;
typedef struct { u32 dw[6]; } GET_DEFAULT_ROUTE_PARAMS_AMAP, *PGET_DEFAULT_ROUTE_PARAMS_AMAP;


//              Default gateway per port can be added or deleted using this ioctl.        
//     IPType field inside IP_ADDRESS_FORMAT will tell IPv4/IPv6.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_DEFAULT_ROUTE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY_AMAP;



typedef struct {
   BE_UEXACT32_AMAP action;
   BE_IP_ADDRESS_FORMAT_AMAP gateway;
} SG_PACK BE_MODIFY_DEFAULT_ROUTE_PARAMS_IN_AMAP;
typedef struct { u32 dw[7]; } MODIFY_DEFAULT_ROUTE_PARAMS_IN_AMAP, *PMODIFY_DEFAULT_ROUTE_PARAMS_IN_AMAP;


//              Default gateway per port can be added or deleted using this ioctl.        
//     IPType field inside IP_ADDRESS_FORMAT will tell IPv4/IPv6.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MODIFY_DEFAULT_ROUTE_PARAMS_IN_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_AMAP;
typedef struct { u32 dw[11]; } IOCTL_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_ALL_IF_ID_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_ALL_IF_ID_PARAMS_IN_AMAP, *PGET_ALL_IF_ID_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP if_count;
   BE_UEXACT32_AMAP if_hndl_list[1];
} SG_PACK BE_GET_ALL_IF_ID_PARAMS_OUT_AMAP;
typedef struct { u32 dw[2]; } GET_ALL_IF_ID_PARAMS_OUT_AMAP, *PGET_ALL_IF_ID_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_ALL_IF_ID_PARAMS_IN_AMAP request;
   BE_GET_ALL_IF_ID_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_ALL_IF_ID_PARAMS_AMAP;
typedef struct { u32 dw[2]; } GET_ALL_IF_ID_PARAMS_AMAP, *PGET_ALL_IF_ID_PARAMS_AMAP;


//              This IOCTL lets management software get a list             of all
// interfaces created using [link]IOCTL_COMMON_ISCSI_NTWK_IFACE_CREATE[/link].         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_ALL_IF_ID_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_GET_ALL_IF_ID_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
   BE_UEXACT32_AMAP ip_type;
} SG_PACK BE_GET_IF_INFO_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } GET_IF_INFO_PARAMS_IN_AMAP, *PGET_IF_INFO_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
   BE_UEXACT32_AMAP vlan_priority;
   BE_UEXACT32_AMAP ip_address_count;
   BE_UEXACT32_AMAP dhcp_state;
   BE_IP_ADDRESS_SUBNET_FORMAT_AMAP ip_address[1];
} SG_PACK BE_GET_IF_INFO_PARAMS_OUT_AMAP;
typedef struct { u32 dw[14]; } GET_IF_INFO_PARAMS_OUT_AMAP, *PGET_IF_INFO_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_IF_INFO_PARAMS_IN_AMAP request;
   BE_GET_IF_INFO_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_IF_INFO_PARAMS_AMAP;
typedef struct { u32 dw[14]; } GET_IF_INFO_PARAMS_AMAP, *PGET_IF_INFO_PARAMS_AMAP;


//              Retrieve the following information for the given interface handle         
//    <ul>                 <li> IP address(es)                 <li> VLAN tag/priority - if
// applicable             </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_IF_INFO_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_GET_IF_INFO_AMAP;
typedef struct { u32 dw[18]; } IOCTL_COMMON_ISCSI_NTWK_GET_IF_INFO_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_GET_IF_INFO_AMAP;



typedef struct {
   BE_UEXACT32_AMAP control;
} SG_PACK BE_PING_CONTROL_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } PING_CONTROL_PARAMS_IN_AMAP, *PPING_CONTROL_PARAMS_IN_AMAP;


//              Enable or Disable ICMP ping for this port/function.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_PING_CONTROL_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_SET_PING_STATE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_NTWK_SET_PING_STATE_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_SET_PING_STATE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP control;
} SG_PACK BE_PING_CONTROL_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } PING_CONTROL_PARAMS_OUT_AMAP, *PPING_CONTROL_PARAMS_OUT_AMAP;


//              Enable or Disable ICMP ping for this port/function.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_PING_CONTROL_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_GET_PING_STATE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_NTWK_GET_PING_STATE_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_GET_PING_STATE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP mtu_val;
} SG_PACK BE_PORT_MTU_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } PORT_MTU_PARAMS_IN_AMAP, *PPORT_MTU_PARAMS_IN_AMAP;


//          IOCTL to set the Maximum Transmission Unit.          The management firmware
// applies the MTU setting to the port         associated with the client.                
//   <P>The IOCTL may fail with the following status/additional_status codes:         <UL>
//         <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the specified MTU
// value is invalid         </LI>        
// <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]              -- the client is not
// authorized to change the MTU         </LI>         <LI>[link]MGMT_STATUS_FAILED[/link]
// / [link]MGMT_ADDI_STATUS_INVALID_REQUEST[/link]              -- the port associated
// with the client does not have any device managed by the management firmware        
// </LI>         <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_REQUEST_REJECTED[/link]              -- the MTU change is
// rejected by the management firmware (likely the port is actively              in use by
// devices managed by the management firmware)         </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_PORT_MTU_PARAMS_IN_AMAP request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_SET_MTU_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_NTWK_SET_MTU_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_SET_MTU_AMAP;



typedef struct {
   BE_UEXACT32_AMAP mtu_val;
} SG_PACK BE_PORT_MTU_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } PORT_MTU_PARAMS_OUT_AMAP, *PPORT_MTU_PARAMS_OUT_AMAP;


//          IOCTL to get the Maximum Transmission Unit.          The management firmware
// returns the MTU setting of the port          associated with the client.               
//   <P>The IOCTL may fail with the following status/additional_status codes:         <UL>
//         <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_REQUEST[/link]              -- the port associated with
// the client does not have any device managed by the management firmware         </LI>   
//      </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } request;
      BE_PORT_MTU_PARAMS_OUT_AMAP response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_GET_MTU_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_NTWK_GET_MTU_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_GET_MTU_AMAP;



typedef struct {
   BE_UEXACT32_AMAP hop_limit;
   BE_UEXACT32_AMAP nd_reachable_time;
   BE_UEXACT32_AMAP nd_retransmit_time;
   BE_UEXACT32_AMAP nd_stale_timeout;
   BE_UEXACT32_AMAP nd_dup_addr_detection_count;
} SG_PACK BE_ISCSI_NTWK_IPV6_ATTRIBUTES_AMAP;
typedef struct { u32 dw[5]; } ISCSI_NTWK_IPV6_ATTRIBUTES_AMAP, *PISCSI_NTWK_IPV6_ATTRIBUTES_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
   BE_ISCSI_NTWK_IPV6_ATTRIBUTES_AMAP ipv6_attribs;
} SG_PACK BE_SET_IPV6_ATTRIBUTES_PARAMS_IN_AMAP;
typedef struct { u32 dw[6]; } SET_IPV6_ATTRIBUTES_PARAMS_IN_AMAP, *PSET_IPV6_ATTRIBUTES_PARAMS_IN_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_IPV6_ATTRIBUTES_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_hndl;
} SG_PACK BE_GET_IPV6_ATTRIBUTES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_IPV6_ATTRIBUTES_PARAMS_IN_AMAP, *PGET_IPV6_ATTRIBUTES_PARAMS_IN_AMAP;



typedef struct {
   BE_ISCSI_NTWK_IPV6_ATTRIBUTES_AMAP ipv6_attribs_response;
} SG_PACK BE_GET_IPV6_ATTRIBUTES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[5]; } GET_IPV6_ATTRIBUTES_PARAMS_OUT_AMAP, *PGET_IPV6_ATTRIBUTES_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_IPV6_ATTRIBUTES_PARAMS_IN_AMAP request;
   BE_GET_IPV6_ATTRIBUTES_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_IPV6_ATTRIBUTES_PARAMS_AMAP;
typedef struct { u32 dw[5]; } GET_IPV6_ATTRIBUTES_PARAMS_AMAP, *PGET_IPV6_ATTRIBUTES_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_IPV6_ATTRIBUTES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_AMAP;
typedef struct { u32 dw[9]; } IOCTL_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES_AMAP;



typedef struct {
   BE_IP_ADDRESS_FORMAT_AMAP ip_address;
} SG_PACK BE_PING_PARAMS_IN_AMAP;
typedef struct { u32 dw[6]; } PING_PARAMS_IN_AMAP, *PPING_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP ttl;
   BE_UEXACT32_AMAP ping_response_time;
} SG_PACK BE_PING_PARAMS_OUT_AMAP;
typedef struct { u32 dw[2]; } PING_PARAMS_OUT_AMAP, *PPING_PARAMS_OUT_AMAP;



typedef union {
   BE_PING_PARAMS_IN_AMAP request;
   BE_PING_PARAMS_OUT_AMAP response;
} SG_PACK BE_PING_PARAMS_AMAP;
typedef struct { u32 dw[6]; } PING_PARAMS_AMAP, *PPING_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_PING_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_PING_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_ISCSI_NTWK_PING_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_PING_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   struct {
      BE_UEXACT8_AMAP ipaddress_count;
      BE_BIT rsvd0[3][8];                         // DWORD 4
      BE_IP_ADDRESS_VLAN_FORMAT_AMAP ip_address_vlan_list[1];
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_IP_ADDRESS_VLAN_AMAP;
typedef struct { u32 dw[16]; } IOCTL_COMMON_ISCSI_NTWK_IP_ADDRESS_VLAN_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_IP_ADDRESS_VLAN_AMAP;



typedef IOCTL_COMMON_ISCSI_NTWK_IP_ADDRESS_VLAN_AMAP IOCTL_COMMON_ISCSI_NTWK_SET_IP_ADDRESS_VLAN_AMAP;
typedef BE_IOCTL_COMMON_ISCSI_NTWK_IP_ADDRESS_VLAN_AMAP BE_IOCTL_COMMON_ISCSI_NTWK_SET_IP_ADDRESS_VLAN_AMAP;


typedef IOCTL_COMMON_ISCSI_NTWK_IP_ADDRESS_VLAN_AMAP* PIOCTL_COMMON_ISCSI_NTWK_SET_IP_ADDRESS_VLAN_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_COMMON_ISCSI_NTWK_SET_IP_ADDRESS_VLAN_AMAP;


typedef IOCTL_COMMON_ISCSI_NTWK_IP_ADDRESS_VLAN_AMAP IOCTL_COMMON_ISCSI_NTWK_GET_IP_ADDRESS_VLAN_AMAP;
typedef BE_IOCTL_COMMON_ISCSI_NTWK_IP_ADDRESS_VLAN_AMAP BE_IOCTL_COMMON_ISCSI_NTWK_GET_IP_ADDRESS_VLAN_AMAP;


typedef IOCTL_COMMON_ISCSI_NTWK_IP_ADDRESS_VLAN_AMAP* PIOCTL_COMMON_ISCSI_NTWK_GET_IP_ADDRESS_VLAN_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_COMMON_ISCSI_NTWK_GET_IP_ADDRESS_VLAN_AMAP;


typedef struct {
   BE_UEXACT32_AMAP nic_port_count;
   BE_MGMT_NIC_PORT_INFO_AMAP nic_ports[1];
} SG_PACK BE_NIC_CONFIG_PARAMS_AMAP;
typedef struct { u32 dw[7]; } NIC_CONFIG_PARAMS_AMAP, *PNIC_CONFIG_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_NIC_CONFIG_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_NIC_CONFIG_AMAP;
typedef struct { u32 dw[11]; } IOCTL_COMMON_ISCSI_NTWK_NIC_CONFIG_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_NIC_CONFIG_AMAP;



typedef IOCTL_COMMON_ISCSI_NTWK_NIC_CONFIG_AMAP IOCTL_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_AMAP;
typedef BE_IOCTL_COMMON_ISCSI_NTWK_NIC_CONFIG_AMAP BE_IOCTL_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_AMAP;


typedef IOCTL_COMMON_ISCSI_NTWK_NIC_CONFIG_AMAP* PIOCTL_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_COMMON_ISCSI_NTWK_GET_NIC_CONFIG_AMAP;

// --- NTWK_ADD_DEL_FLAGS ---
// Defines Network Add and Del flags 
#define NTWK_ENTRY_ADD                  (1)       
#define NTWK_ENTRY_DEL                  (2)       

typedef enum {
   ENUM_NTWK_ENTRY_ADD = 0x1UL,
   ENUM_NTWK_ENTRY_DEL = 0x2UL
} NTWK_ADD_DEL_FLAGS;


typedef struct {
   BE_UEXACT32_AMAP arp_entry_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_ARP_TABLE_ENTRY_AMAP arp_entries[1];
} SG_PACK BE_GET_ARP_TABLE_PARAMS_AMAP;
typedef struct { u32 dw[12]; } GET_ARP_TABLE_PARAMS_AMAP, *PGET_ARP_TABLE_PARAMS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP arp_entry_type;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_ARP_TABLE_ENTRY_AMAP arp_entry;
} SG_PACK BE_EDIT_ARP_TABLE_PARAMS_AMAP;
typedef struct { u32 dw[12]; } EDIT_ARP_TABLE_PARAMS_AMAP, *PEDIT_ARP_TABLE_PARAMS_AMAP;



typedef union {
   BE_GET_ARP_TABLE_PARAMS_AMAP request;
   BE_EDIT_ARP_TABLE_PARAMS_AMAP response;
} SG_PACK BE_ARP_TABLE_PARAMS_AMAP;
typedef struct { u32 dw[12]; } ARP_TABLE_PARAMS_AMAP, *PARP_TABLE_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ARP_TABLE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_ARP_TABLE_AMAP;
typedef struct { u32 dw[16]; } IOCTL_COMMON_ISCSI_NTWK_ARP_TABLE_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_ARP_TABLE_AMAP;



typedef IOCTL_COMMON_ISCSI_NTWK_ARP_TABLE_AMAP IOCTL_COMMON_ISCSI_NTWK_GET_ARP_TABLE_AMAP;
typedef BE_IOCTL_COMMON_ISCSI_NTWK_ARP_TABLE_AMAP BE_IOCTL_COMMON_ISCSI_NTWK_GET_ARP_TABLE_AMAP;


typedef IOCTL_COMMON_ISCSI_NTWK_ARP_TABLE_AMAP* PIOCTL_COMMON_ISCSI_NTWK_GET_ARP_TABLE_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_COMMON_ISCSI_NTWK_GET_ARP_TABLE_AMAP;


typedef IOCTL_COMMON_ISCSI_NTWK_ARP_TABLE_AMAP IOCTL_COMMON_ISCSI_NTWK_SET_ARP_TABLE_AMAP;
typedef BE_IOCTL_COMMON_ISCSI_NTWK_ARP_TABLE_AMAP BE_IOCTL_COMMON_ISCSI_NTWK_SET_ARP_TABLE_AMAP;


typedef IOCTL_COMMON_ISCSI_NTWK_ARP_TABLE_AMAP* PIOCTL_COMMON_ISCSI_NTWK_SET_ARP_TABLE_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_COMMON_ISCSI_NTWK_SET_ARP_TABLE_AMAP;


typedef struct {
   BE_UEXACT32_AMAP route_entry_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_ROUTE_TABLE_ENTRY_AMAP route_entries[1];
} SG_PACK BE_GET_ROUTE_TABLE_PARAMS_AMAP;
typedef struct { u32 dw[18]; } GET_ROUTE_TABLE_PARAMS_AMAP, *PGET_ROUTE_TABLE_PARAMS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP route_entry_type;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_ROUTE_TABLE_ENTRY_AMAP route_entry;
} SG_PACK BE_EDIT_ROUTE_TABLE_PARAMS_AMAP;
typedef struct { u32 dw[18]; } EDIT_ROUTE_TABLE_PARAMS_AMAP, *PEDIT_ROUTE_TABLE_PARAMS_AMAP;



typedef union {
   BE_GET_ROUTE_TABLE_PARAMS_AMAP request;
   BE_EDIT_ROUTE_TABLE_PARAMS_AMAP response;
} SG_PACK BE_ROUTE_TABLE_PARAMS_AMAP;
typedef struct { u32 dw[18]; } ROUTE_TABLE_PARAMS_AMAP, *PROUTE_TABLE_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ROUTE_TABLE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_NTWK_ROUTE_TABLE_AMAP;
typedef struct { u32 dw[22]; } IOCTL_COMMON_ISCSI_NTWK_ROUTE_TABLE_AMAP, *PIOCTL_COMMON_ISCSI_NTWK_ROUTE_TABLE_AMAP;



typedef IOCTL_COMMON_ISCSI_NTWK_ROUTE_TABLE_AMAP IOCTL_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_AMAP;
typedef BE_IOCTL_COMMON_ISCSI_NTWK_ROUTE_TABLE_AMAP BE_IOCTL_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_AMAP;


typedef IOCTL_COMMON_ISCSI_NTWK_ROUTE_TABLE_AMAP* PIOCTL_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE_AMAP;


typedef IOCTL_COMMON_ISCSI_NTWK_ROUTE_TABLE_AMAP IOCTL_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_AMAP;
typedef BE_IOCTL_COMMON_ISCSI_NTWK_ROUTE_TABLE_AMAP BE_IOCTL_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_AMAP;


typedef IOCTL_COMMON_ISCSI_NTWK_ROUTE_TABLE_AMAP* PIOCTL_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE_AMAP;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_common_iscsi_ntwk_amap_h__

