/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_diag_amap_h__
#define __ioctl_diag_amap_h__
#include "setypes.h"
#include "ioctl_hdr.h"
#include "ioctl_common.h"
#include "host_struct.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- DIAG_DMA_MODE ---
#define DIAG_DMA_MODE_READ              (0)       // DMA from host memory to on-chip
                                                  // context memory.
#define DIAG_DMA_MODE_WRITE             (1)       // DMA from on-chip context memory to
                                                  // host memory.
#define DIAG_DMA_MODE_READ_WRITE        (2)       // DMA both directions in parallel.

typedef enum {
   ENUM_DIAG_DMA_MODE_READ = 0x0UL,
   ENUM_DIAG_DMA_MODE_WRITE = 0x1UL,
   ENUM_DIAG_DMA_MODE_READ_WRITE = 0x2UL
} DIAG_DMA_MODE;


typedef struct {
   BE_u32_AMAP bytes_per_write_dma;
   BE_u32_AMAP bytes_per_read_dma;
   BE_u32_AMAP num_write_dma;
   BE_u32_AMAP num_read_dma;
   BE_u32_AMAP start_stamp;
   BE_u32_AMAP end_stamp;
} SG_PACK BE_IOCTL_DIAG_DMA_RESPONSE_AMAP;
typedef struct { u32 dw[6]; } IOCTL_DIAG_DMA_RESPONSE_AMAP, *PIOCTL_DIAG_DMA_RESPONSE_AMAP;


//          This IOCTL allows running a DMA test in the ARM firmware.                 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_u32_AMAP dma_mode;
         BE_u32_AMAP num_dma;
         BE_u32_AMAP buffer_bytes;
         BE_PHYS_ADDR_AMAP pa[2];
      } request;
      BE_IOCTL_DIAG_DMA_RESPONSE_AMAP response;
   } params;
} SG_PACK BE_IOCTL_DIAG_DMA_AMAP;
typedef struct { u32 dw[11]; } IOCTL_DIAG_DMA_AMAP, *PIOCTL_DIAG_DMA_AMAP;



typedef struct {
   BE_u32_AMAP write;
   BE_u32_AMAP port;
   BE_u32_AMAP reg_no;
   BE_u32_AMAP phy_add;
   BE_u32_AMAP data;
   BE_u32_AMAP type;
} SG_PACK BE_IOCTL_DIAG_MDIO_RESPONSE_AMAP;
typedef struct { u32 dw[6]; } IOCTL_DIAG_MDIO_RESPONSE_AMAP, *PIOCTL_DIAG_MDIO_RESPONSE_AMAP;


//          This IOCTL allows running a MDIO test in the ARM firmware.                 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_u32_AMAP write;
         BE_u32_AMAP port;
         BE_u32_AMAP reg_no;
         BE_u32_AMAP phy_add;
         BE_u32_AMAP data;
         BE_u32_AMAP type;
      } request;
      BE_IOCTL_DIAG_MDIO_RESPONSE_AMAP response;
   } params;
} SG_PACK BE_IOCTL_DIAG_MDIO_AMAP;
typedef struct { u32 dw[10]; } IOCTL_DIAG_MDIO_AMAP, *PIOCTL_DIAG_MDIO_AMAP;



typedef struct {
   BE_u32_AMAP packets_outstanding;
   BE_u32_AMAP packets_txmit;
   BE_u32_AMAP packets_rcvd;
   BE_BIT rsvd0[4][32];                           // DWORD 3
} SG_PACK BE_IOCTL_DIAG_NLB_RESPONSE_AMAP;
typedef struct { u32 dw[7]; } IOCTL_DIAG_NLB_RESPONSE_AMAP, *PIOCTL_DIAG_NLB_RESPONSE_AMAP;


//          This IOCTL allows running a Network Loop back test in the ARM firmware.       
//          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_u32_AMAP no_of_sgs;
         BE_u32_AMAP src_port;
         BE_u32_AMAP dst_port;
         BE_PHYS_ADDR_AMAP pa[2];
      } request;
      BE_IOCTL_DIAG_NLB_RESPONSE_AMAP response;
   } params;
} SG_PACK BE_IOCTL_DIAG_NLB_AMAP;
typedef struct { u32 dw[11]; } IOCTL_DIAG_NLB_AMAP, *PIOCTL_DIAG_NLB_AMAP;



typedef struct {
   BE_u32_AMAP start_stamp;
   BE_u32_AMAP end_stamp;
} SG_PACK BE_IOCTL_DIAG_ATT_RESPONSE_AMAP;
typedef struct { u32 dw[2]; } IOCTL_DIAG_ATT_RESPONSE_AMAP, *PIOCTL_DIAG_ATT_RESPONSE_AMAP;


//          This IOCTL allows running a ARM timer test in the ARM firmware.               
//  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_u32_AMAP delay_time;
      } request;
      BE_IOCTL_DIAG_ATT_RESPONSE_AMAP response;
   } params;
} SG_PACK BE_IOCTL_DIAG_ATT_AMAP;
typedef struct { u32 dw[6]; } IOCTL_DIAG_ATT_AMAP, *PIOCTL_DIAG_ATT_AMAP;



typedef struct {
   BE_u8_AMAP macaddr[6];
} SG_PACK BE_IOCTL_DIAG_GETMAC_RESPONSE_AMAP;
typedef struct { u32 dw[2]; } IOCTL_DIAG_GETMAC_RESPONSE_AMAP, *PIOCTL_DIAG_GETMAC_RESPONSE_AMAP;


//          This IOCTL is for getting the mac address.                 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_u32_AMAP portno;
      } request;
      BE_IOCTL_DIAG_GETMAC_RESPONSE_AMAP response;
   } params;
} SG_PACK BE_IOCTL_DIAG_GETMAC_AMAP;
typedef struct { u32 dw[6]; } IOCTL_DIAG_GETMAC_AMAP, *PIOCTL_DIAG_GETMAC_AMAP;


//          This IOCTL is for Phy Reset.                 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_u32_AMAP port_num;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_DIAG_RESET_PHY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_DIAG_RESET_PHY_AMAP, *PIOCTL_DIAG_RESET_PHY_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_diag_amap_h__

