/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_eventlog_amap_h__
#define __ioctl_eventlog_amap_h__
#include "setypes.h"
#include "nativedefs.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- EVENT_SEVERITY_LEVEL ---
// Definition of severityLevel 
#define EVENT_INFORMATIONAL             (0)       // Used for general information and
                                                  // debug. 
#define EVENT_WARNING                   (1)       // Corrective action required for normal
                                                  // execution. 
#define EVENT_ERROR                     (2)       // Firmware may continue, but one of the
                                                  // operation has failed. 
#define EVENT_FATAL                     (3)       // Firmware may hang, need to contact
                                                  // hardware vendor 

typedef enum {
   ENUM_EVENT_INFORMATIONAL = 0x0UL,
   ENUM_EVENT_WARNING = 0x1UL,
   ENUM_EVENT_ERROR = 0x2UL,
   ENUM_EVENT_FATAL = 0x3UL
} EVENT_SEVERITY_LEVEL;


typedef struct {
   BE_UEXACT32_AMAP p1;
   BE_UEXACT32_AMAP p2;
   BE_UEXACT32_AMAP p3;
   BE_UEXACT32_AMAP p4;
   BE_UEXACT32_AMAP p5;
} SG_PACK BE_EVENTLOG_ENTRY_AMAP;
typedef struct { u32 dw[5]; } EVENTLOG_ENTRY_AMAP, *PEVENTLOG_ENTRY_AMAP;



typedef union {
   BE_EVENTLOG_ENTRY_AMAP event_entry;
   BE_EXACT8_AMAP err_str[48];
} SG_PACK BE_EVENTLOG_ENTRY_UNION_AMAP;
typedef struct { u32 dw[12]; } EVENTLOG_ENTRY_UNION_AMAP, *PEVENTLOG_ENTRY_UNION_AMAP;



typedef struct {
   BE_UEXACT16_AMAP error_code;
   BE_UEXACT16_AMAP padding1;
   BE_UEXACT32_AMAP time_stamp;
   BE_UEXACT32_AMAP seq_number;
   BE_UEXACT16_AMAP severity_level;
   BE_UEXACT16_AMAP padding2;
   BE_EVENTLOG_ENTRY_UNION_AMAP event;
} SG_PACK BE_EVENT_LOG_AMAP;
typedef struct { u32 dw[16]; } EVENT_LOG_AMAP, *PEVENT_LOG_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_eventlog_amap_h__

