/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_fcoe_amap_h__
#define __ioctl_fcoe_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"
#include "fc_device_context.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT32_AMAP cid;
} SG_PACK BE_FCOE_WRBQ_DESTROY_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } FCOE_WRBQ_DESTROY_PARAMS_IN_AMAP, *PFCOE_WRBQ_DESTROY_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_FCOE_WRBQ_DESTROY_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } FCOE_WRBQ_DESTROY_PARAMS_OUT_AMAP, *PFCOE_WRBQ_DESTROY_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_WRBQ_DESTROY_PARAMS_IN_AMAP request;
   BE_FCOE_WRBQ_DESTROY_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_WRBQ_DESTROY_PARAMS_AMAP;
typedef struct { u32 dw[1]; } FCOE_WRBQ_DESTROY_PARAMS_AMAP, *PFCOE_WRBQ_DESTROY_PARAMS_AMAP;


//          IOCTL for destroying a FCoE WRB ring.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_WRBQ_DESTROY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_WRBQ_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_FCOE_WRBQ_DESTROY_AMAP, *PIOCTL_COMMON_FCOE_WRBQ_DESTROY_AMAP;



typedef struct {
   BE_UEXACT16_AMAP num_pages;
   BE_UEXACT16_AMAP default_cq_id;
   BE_PHYS_ADDR_AMAP pages[4];
} SG_PACK BE_FCOE_WRBQ_CREATE_PARAMS_IN_AMAP;
typedef struct { u32 dw[9]; } FCOE_WRBQ_CREATE_PARAMS_IN_AMAP, *PFCOE_WRBQ_CREATE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT16_AMAP cid;
} SG_PACK BE_FCOE_WRBQ_CREATE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } FCOE_WRBQ_CREATE_PARAMS_OUT_AMAP, *PFCOE_WRBQ_CREATE_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_WRBQ_CREATE_PARAMS_IN_AMAP request;
   BE_FCOE_WRBQ_CREATE_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_WRBQ_CREATE_PARAMS_AMAP;
typedef struct { u32 dw[9]; } FCOE_WRBQ_CREATE_PARAMS_AMAP, *PFCOE_WRBQ_CREATE_PARAMS_AMAP;


//           IOCTL for creating FCoE WRB ring.          <P> A FCoE WRB ring must be
// atleast 128 entries deep (corresponding to 1 page) and at most 256 entries         
// deep (corresponding to 4 pages). When an interface is created for a VM, the encoded
// ring size in context          must result in a ring fitting within the number of pages
// posted with this IOCTL.          <p>The ARM will update the XRI_start,XRI_end,
// RPI_start and RPI_end in the FC WRB context memory when          this IOCTL is
// received.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_WRBQ_CREATE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_WRBQ_CREATE_AMAP;
typedef struct { u32 dw[13]; } IOCTL_COMMON_FCOE_WRBQ_CREATE_AMAP, *PIOCTL_COMMON_FCOE_WRBQ_CREATE_AMAP;


//          Number of valid pages in the pages array.         For each XRI (ICD), two
// pages MUST be supplied. If          the XRI(ICD) has an I/O size which requires        
// only one page worth of SGEs, then the second entry          should be set to NULL.     
//    
typedef struct {
   BE_PHYS_ADDR_AMAP sgl_page0;
   BE_PHYS_ADDR_AMAP sgl_page1;
} SG_PACK BE_FCOE_SGL_PAGES_AMAP;
typedef struct { u32 dw[4]; } FCOE_SGL_PAGES_AMAP, *PFCOE_SGL_PAGES_AMAP;



typedef struct {
   BE_UEXACT16_AMAP xri_start;
   BE_UEXACT16_AMAP xri_count;
   BE_FCOE_SGL_PAGES_AMAP pages[13];
} SG_PACK BE_FCOE_CFG_POST_SGL_PAGES_PARAMS_IN_AMAP;
typedef struct { u32 dw[53]; } FCOE_CFG_POST_SGL_PAGES_PARAMS_IN_AMAP, *PFCOE_CFG_POST_SGL_PAGES_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_FCOE_CFG_POST_SGL_PAGES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } FCOE_CFG_POST_SGL_PAGES_PARAMS_OUT_AMAP, *PFCOE_CFG_POST_SGL_PAGES_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_CFG_POST_SGL_PAGES_PARAMS_IN_AMAP request;
   BE_FCOE_CFG_POST_SGL_PAGES_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_CFG_POST_SGL_PAGES_PARAMS_AMAP;
typedef struct { u32 dw[53]; } FCOE_CFG_POST_SGL_PAGES_PARAMS_AMAP, *PFCOE_CFG_POST_SGL_PAGES_PARAMS_AMAP;


//          Maps pages of physical memory to be used for SGLs for each command. Despite
// the IOCTL         structure showing a fixed number of SGL page array elements, if a
// non-embedded IOCTL is         used the number of SGL pages posted may be larger than
// shown.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_CFG_POST_SGL_PAGES_PARAMS_AMAP params;
   BE_BIT rsvd0[64];                              // DWORD 57
} SG_PACK BE_IOCTL_COMMON_FCOE_CFG_POST_SGL_PAGES_AMAP;
typedef struct { u32 dw[59]; } IOCTL_COMMON_FCOE_CFG_POST_SGL_PAGES_AMAP, *PIOCTL_COMMON_FCOE_CFG_POST_SGL_PAGES_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_FCOE_CFG_REMOVE_SGL_PAGES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } FCOE_CFG_REMOVE_SGL_PAGES_PARAMS_IN_AMAP, *PFCOE_CFG_REMOVE_SGL_PAGES_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_FCOE_CFG_REMOVE_SGL_PAGES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } FCOE_CFG_REMOVE_SGL_PAGES_PARAMS_OUT_AMAP, *PFCOE_CFG_REMOVE_SGL_PAGES_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_CFG_REMOVE_SGL_PAGES_PARAMS_IN_AMAP request;
   BE_FCOE_CFG_REMOVE_SGL_PAGES_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_CFG_REMOVE_SGL_PAGES_PARAMS_AMAP;
typedef struct { u32 dw[1]; } FCOE_CFG_REMOVE_SGL_PAGES_PARAMS_AMAP, *PFCOE_CFG_REMOVE_SGL_PAGES_PARAMS_AMAP;


//              Unmaps all posted SGL pages owned by the physical function.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_CFG_REMOVE_SGL_PAGES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_AMAP, *PIOCTL_COMMON_FCOE_CFG_REMOVE_SGL_PAGES_AMAP;



typedef struct {
   BE_UEXACT16_AMAP num_pages;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_FCOE_DEFAULT_PDU_CONTEXT_AMAP context;
   BE_PHYS_ADDR_AMAP pages[8];
} SG_PACK BE_FCOE_DEFQ_CREATE_PARAMS_IN_AMAP;
typedef struct { u32 dw[21]; } FCOE_DEFQ_CREATE_PARAMS_IN_AMAP, *PFCOE_DEFQ_CREATE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT16_AMAP id;
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_FCOE_DEFQ_CREATE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } FCOE_DEFQ_CREATE_PARAMS_OUT_AMAP, *PFCOE_DEFQ_CREATE_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_DEFQ_CREATE_PARAMS_IN_AMAP request;
   BE_FCOE_DEFQ_CREATE_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_DEFQ_CREATE_PARAMS_AMAP;
typedef struct { u32 dw[21]; } FCOE_DEFQ_CREATE_PARAMS_AMAP, *PFCOE_DEFQ_CREATE_PARAMS_AMAP;


//                      IOCTL for creating FCoE default PDU ring. Use opcode
// [link]OPCODE_COMMON_FCOE_DEFQ_CREATE[/link].                                  <P>      
//               An FCoE default PDU ring must be at least 512 entries deep (corresponding
// to 1 page) and                      at most 4k entries deep (corresponding to 8 pages).
//                                  <P>The IOCTL may fail with the following
// status/additional_status codes:                     <UL>                        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]                                  -- the
// request parameter at the byte offset specified in the additional status response is
// invalid.                         </LI>                        
// <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]                                  --
// the client is not authorized to create this ring type.                         </LI>   
//                      <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]                                 
// -- this ring type is either unavailable or all rings are already created.              
//           </LI>                     </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_DEFQ_CREATE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_DEFQ_CREATE_AMAP;
typedef struct { u32 dw[25]; } IOCTL_COMMON_FCOE_DEFQ_CREATE_AMAP, *PIOCTL_COMMON_FCOE_DEFQ_CREATE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP id;
} SG_PACK BE_FCOE_DEFQ_DESTROY_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } FCOE_DEFQ_DESTROY_PARAMS_IN_AMAP, *PFCOE_DEFQ_DESTROY_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_FCOE_DEFQ_DESTROY_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } FCOE_DEFQ_DESTROY_PARAMS_OUT_AMAP, *PFCOE_DEFQ_DESTROY_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_DEFQ_DESTROY_PARAMS_IN_AMAP request;
   BE_FCOE_DEFQ_DESTROY_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_DEFQ_DESTROY_PARAMS_AMAP;
typedef struct { u32 dw[1]; } FCOE_DEFQ_DESTROY_PARAMS_AMAP, *PFCOE_DEFQ_DESTROY_PARAMS_AMAP;


//                       IOCTL for destroying an FCoE default PDU ring. Use opcode
// [link]OPCODE_COMMON_FCOE_DEFQ_DESTROY[/link].                                  <P>The
// IOCTL may fail with the following status/additional_status codes:                    
// <UL>                         <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]         
//                         -- the client is not authorized to destroy this ring.          
//               </LI>                     </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_DEFQ_DESTROY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_DEFQ_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_FCOE_DEFQ_DESTROY_AMAP, *PIOCTL_COMMON_FCOE_DEFQ_DESTROY_AMAP;



typedef struct {
   BE_UEXACT16_AMAP starting_rpi_index;
   BE_UEXACT16_AMAP num_pages;
   BE_PHYS_ADDR_AMAP pages[32];
} SG_PACK BE_FCOE_POST_HDR_TEMPLATES_PARAMS_IN_AMAP;
typedef struct { u32 dw[65]; } FCOE_POST_HDR_TEMPLATES_PARAMS_IN_AMAP, *PFCOE_POST_HDR_TEMPLATES_PARAMS_IN_AMAP;



typedef union {
   BE_FCOE_POST_HDR_TEMPLATES_PARAMS_IN_AMAP request;
} SG_PACK BE_FCOE_POST_HDR_TEMPLATES_PARAMS_AMAP;
typedef struct { u32 dw[65]; } FCOE_POST_HDR_TEMPLATES_PARAMS_AMAP, *PFCOE_POST_HDR_TEMPLATES_PARAMS_AMAP;


//            IOCTL for adding template header pages.            Use opcode
// [link]OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES[/link].                      <p>The IOCTL
// may fail with the following status/additional_status codes:           <ul>            
// <li>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]                -- the request parameter at
// the byte offset specified in the additional status response is invalid.            
// <li>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]                  -- the caller is not
// authorized to post the request.           </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_POST_HDR_TEMPLATES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_POST_HDR_TEMPLATES_AMAP;
typedef struct { u32 dw[69]; } IOCTL_COMMON_FCOE_POST_HDR_TEMPLATES_AMAP, *PIOCTL_COMMON_FCOE_POST_HDR_TEMPLATES_AMAP;


//            IOCTL for removing posted template header pages. All template header pages  
//         posted by the caller via [link]IOCTL_COMMON_FCOE_POST_HDR_TEMPLATES[/link]     
//       are removed from the HBA.           Use opcode
// [link]OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES[/link].                      <p>The IOCTL
// may fail with the following status/additional_status codes:           <ul>            
// <li>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]                -- the request parameter at
// the byte offset specified in the additional status response is invalid.            
// <li>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]                  -- the caller is not
// authorized to post the request.           </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
} SG_PACK BE_IOCTL_COMMON_FCOE_REMOVE_HDR_TEMPLATES_AMAP;
typedef struct { u32 dw[4]; } IOCTL_COMMON_FCOE_REMOVE_HDR_TEMPLATES_AMAP, *PIOCTL_COMMON_FCOE_REMOVE_HDR_TEMPLATES_AMAP;


// --- FCOE_COMMAND_CLEANUP_TYPE ---
#define IOCTL_FCOE_COMMAND_INVALIDATE   (1)       // Invalidate this command, a ABTS will
                                                  // follow 
#define IOCLT_FCOE_COMMAND_FREE         (2)       // Free this command 

typedef enum {
   ENUM_IOCTL_FCOE_COMMAND_INVALIDATE = 0x1UL,
   ENUM_IOCLT_FCOE_COMMAND_FREE = 0x2UL
} FCOE_COMMAND_CLEANUP_TYPE;

// --- IOCTL_FCOE_DEFINED_ENUM ---
#define FCOE_MAX_SGL_ICD_INVALIDATE     (128)     

typedef enum {
   ENUM_FCOE_MAX_SGL_ICD_INVALIDATE = 0x80UL
} IOCTL_FCOE_DEFINED_ENUM;

// --- FCOE_SGL_ICD_CLEANUP_STATUS ---
#define FCOE_SGL_ICD_CLEANUP_SUCCESS    (1)       // Invalidation was successful 
#define FCOE_SGL_ICD_NOT_FOUND          (2)       // Command not found 
#define FCOE_SGL_ICD_INVALIDATION_ERROR (3)       // error in invalidation process 

typedef enum {
   ENUM_FCOE_SGL_ICD_CLEANUP_SUCCESS = 0x1UL,
   ENUM_FCOE_SGL_ICD_NOT_FOUND = 0x2UL,
   ENUM_FCOE_SGL_ICD_INVALIDATION_ERROR = 0x3UL
} FCOE_SGL_ICD_CLEANUP_STATUS;


typedef struct {
   BE_UEXACT16_AMAP icd;
} SG_PACK BE_FCOE_INVALIDATE_COMMAND_TABLE_AMAP;
typedef struct { u32 dw[1]; } FCOE_INVALIDATE_COMMAND_TABLE_AMAP, *PFCOE_INVALIDATE_COMMAND_TABLE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP ref_handle;
   BE_UEXACT32_AMAP icd_count;
   BE_FCOE_INVALIDATE_COMMAND_TABLE_AMAP table[128];
   BE_UEXACT16_AMAP cleanup_type;
   BE_UEXACT16_AMAP unused;
} SG_PACK BE_FCOE_INVALIDATE_COMMANDS_PARAMS_IN_AMAP;
typedef struct { u32 dw[67]; } FCOE_INVALIDATE_COMMANDS_PARAMS_IN_AMAP, *PFCOE_INVALIDATE_COMMANDS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP ref_handle;
   BE_UEXACT32_AMAP icd_count;
   BE_UEXACT32_AMAP icd_status[128];
} SG_PACK BE_FCOE_INVALIDATE_COMMANDS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[130]; } FCOE_INVALIDATE_COMMANDS_PARAMS_OUT_AMAP, *PFCOE_INVALIDATE_COMMANDS_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_INVALIDATE_COMMANDS_PARAMS_IN_AMAP request;
   BE_FCOE_INVALIDATE_COMMANDS_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_INVALIDATE_COMMANDS_PARAMS_AMAP;
typedef struct { u32 dw[130]; } FCOE_INVALIDATE_COMMANDS_PARAMS_AMAP, *PFCOE_INVALIDATE_COMMANDS_PARAMS_AMAP;


//          This Ioctl can be used to <br>             <ol>                 <li>
// Invalidate one or more FCoE commands.                 <li> Request the EP firmware to
// force a command 'free' and release an SGL-ICD.             </ol>       
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_INVALIDATE_COMMANDS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_INVALIDATE_COMMANDS_AMAP;
typedef struct { u32 dw[134]; } IOCTL_COMMON_FCOE_INVALIDATE_COMMANDS_AMAP, *PIOCTL_COMMON_FCOE_INVALIDATE_COMMANDS_AMAP;



typedef struct {
   BE_UEXACT16_AMAP chute;
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_FCOE_CLEANUP_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } FCOE_CLEANUP_PARAMS_IN_AMAP, *PFCOE_CLEANUP_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_FCOE_CLEANUP_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } FCOE_CLEANUP_PARAMS_OUT_AMAP, *PFCOE_CLEANUP_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_CLEANUP_PARAMS_IN_AMAP request;
   BE_FCOE_CLEANUP_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_CLEANUP_PARAMS_AMAP;
typedef struct { u32 dw[1]; } FCOE_CLEANUP_PARAMS_AMAP, *PFCOE_CLEANUP_PARAMS_AMAP;


//              This Ioctl should be issued by FC drivers (Initiator or Target) before an
// unload/disable to                         allow the embedded processors to cleanup
// their data structures. This process is required only when                         the
// driver is expected to be reloaded without a power-cycle or reset.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_CLEANUP_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_CLEANUP_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_FCOE_CLEANUP_AMAP, *PIOCTL_COMMON_FCOE_CLEANUP_AMAP;


// --- FCF_ADDRESS_TYPE ---
// An FCF may support both FPMA and SPMA 
#define FCF_ADDRESS_TYPE_FPMA           (1)       // Fabric Provided Mac Address 
#define FCF_ADDRESS_TYPE_SPMA           (2)       // Server Provided Mac Address 

typedef enum {
   ENUM_FCF_ADDRESS_TYPE_FPMA = 0x1UL,
   ENUM_FCF_ADDRESS_TYPE_SPMA = 0x2UL
} FCF_ADDRESS_TYPE;


typedef struct {
   BE_UEXACT32_AMAP max_recv_size;
   BE_UEXACT32_AMAP fka_adv_period;
   BE_UEXACT32_AMAP fip_priority;
   BE_UEXACT8_AMAP fcf_mac_address[6];
   BE_UEXACT8_AMAP fcf_available;
   BE_UEXACT8_AMAP mac_address_provider;
   BE_UEXACT8_AMAP fabric_name_identifier[8];
   BE_UEXACT8_AMAP fc_map[3];
   BE_UEXACT8_AMAP fcf_valid;
   BE_UEXACT16_AMAP fcf_index;
   BE_UEXACT16_AMAP fcf_state;
   BE_UEXACT8_AMAP vlan_bitmap[512];
   BE_UEXACT8_AMAP fcoe_switch_name[8];
} SG_PACK BE_FCF_RECORD_AMAP;
typedef struct { u32 dw[139]; } FCF_RECORD_AMAP, *PFCF_RECORD_AMAP;



typedef struct {
   BE_UEXACT16_AMAP fcf_index;
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_COMMON_FCOE_READ_FCF_TABLE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } COMMON_FCOE_READ_FCF_TABLE_PARAMS_IN_AMAP, *PCOMMON_FCOE_READ_FCF_TABLE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP event_tag;
   BE_UEXACT16_AMAP next_valid_fcf_index;
   BE_BIT rsvd0[16];                              // DWORD 1
   BE_FCF_RECORD_AMAP fcf_entry[1];
} SG_PACK BE_COMMON_FCOE_READ_FCF_TABLE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[141]; } COMMON_FCOE_READ_FCF_TABLE_PARAMS_OUT_AMAP, *PCOMMON_FCOE_READ_FCF_TABLE_PARAMS_OUT_AMAP;



typedef union {
   BE_COMMON_FCOE_READ_FCF_TABLE_PARAMS_IN_AMAP request;
   BE_COMMON_FCOE_READ_FCF_TABLE_PARAMS_OUT_AMAP response;
} SG_PACK BE_COMMON_FCOE_READ_FCF_TABLE_PARAMS_AMAP;
typedef struct { u32 dw[141]; } COMMON_FCOE_READ_FCF_TABLE_PARAMS_AMAP, *PCOMMON_FCOE_READ_FCF_TABLE_PARAMS_AMAP;


//            The ARM firmware builds a database of FCFs based on FIP discovery.          
// This command allows a host driver or management software to retrieve           each
// valid entry from that table.           To fetch all the entries in the table -         
//  <ol>             <li> Set fcf_index=-1 in the request and call this IOCTL             
// <li> Check the ioctl status in the response.               <ul>                 <li> If
// the status is [link]MGMT_STATUS_SUCCESS[/link],                   <ul>                 
//    <li> The ioctl returned an FCF Record.                     <li> Check the
// next_valid_fcf_index field in the response.                     <li> If this field is
// set to -1, no more valid FCFs exist.                     <li> If next_valid_fcf_index
// is not -1 issue the next call to this IOCTL                            by setting
// fcf_index = next_valid_fcf_index.                    </ul>                 <li> if the
// ioctl status response is [link]MGMT_STATUS_NO_FCF_RECORDS[/link]                     no
// FCF record is returned. If this happens on the very first call                     with
// fcf_index=-1, no FCF records are present in the table.               </ul>          
// </ol>                      The call returns [link]MGMT_STATUS_SUCCESS[/link] if an
// FCF_RECORD           could be returned else [link]MGMT_STATUS_NO_FCF_RECORDS[/link] is
// returned;       
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_COMMON_FCOE_READ_FCF_TABLE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_READ_FCF_TABLE_AMAP;
typedef struct { u32 dw[145]; } IOCTL_COMMON_FCOE_READ_FCF_TABLE_AMAP, *PIOCTL_COMMON_FCOE_READ_FCF_TABLE_AMAP;



typedef struct {
   BE_UEXACT16_AMAP fcf_index;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_FCF_RECORD_AMAP fcf_entry;
} SG_PACK BE_COMMON_FCOE_ADD_FCF_PARAMS_IN_AMAP;
typedef struct { u32 dw[140]; } COMMON_FCOE_ADD_FCF_PARAMS_IN_AMAP, *PCOMMON_FCOE_ADD_FCF_PARAMS_IN_AMAP;


//            The ARM firmware builds a database of FCFs based on FIP discovery.          
// This command allows a host driver or management software to manually add            an
// FCF entry to the ARM's FCF database. This call may be           used when a switch does
// not support FIP.            <p>           The call returns
// [link]MGMT_STATUS_SUCCESS[/link] when the specified FCF table index           is
// available or unused. The [link]MGMT_STATUS_FCF_IN_USE[/link] status is returned        
//   if the index is currently used by an FCF for which the host has issued.        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_COMMON_FCOE_ADD_FCF_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_COMMON_FCOE_ADD_FCF_AMAP;
typedef struct { u32 dw[144]; } IOCTL_COMMON_FCOE_ADD_FCF_AMAP, *PIOCTL_COMMON_FCOE_ADD_FCF_AMAP;



typedef struct {
   BE_UEXACT16_AMAP fcf_count;
   BE_UEXACT16_AMAP fcf_indexes[1];
} SG_PACK BE_COMMON_FCOE_DELETE_FCF_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } COMMON_FCOE_DELETE_FCF_PARAMS_IN_AMAP, *PCOMMON_FCOE_DELETE_FCF_PARAMS_IN_AMAP;


//            Allows a host driver or management software to delete           an FCF entry
// from the ARM's FCF database. This call may be           used when            <ul>      
//       <li> The ARM sends an async message [link]ASYNC_EVENT_FCOE[/link]to             
// the host indicating the FCF table is full             <li> Host s/w decides that an FCF
// entry which was reported through             an [link]ASYNC_EVENT_FCOE[/link] will not
// be used.            </ul>           The deleted slot will be used by the ARM f/w when
// new FCFs are discovered.           <p>           The call returns
// [link]MGMT_STATUS_SUCCESS[/link] when the specified FCF table index           is
// available or unused. The [link]MGMT_STATUS_FCF_IN_USE[/link] status is returned        
//   if the index is currently used by an FCF. When fcf_index is not valid, expect the
// status            [link]MGMT_STATUS_ILLEGAL_FIELD[/link].                            
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_COMMON_FCOE_DELETE_FCF_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_COMMON_FCOE_DELETE_FCF_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_FCOE_DELETE_FCF_AMAP, *PIOCTL_COMMON_FCOE_DELETE_FCF_AMAP;



typedef struct {
   BE_UEXACT16_AMAP fcf_count;
   BE_BIT rsvd0[6][8];                            // DWORD 0
   BE_UEXACT16_AMAP fcf_indexes[1];
} SG_PACK BE_COMMON_FCOE_REDISCOVER_FCF_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } COMMON_FCOE_REDISCOVER_FCF_PARAMS_IN_AMAP, *PCOMMON_FCOE_REDISCOVER_FCF_PARAMS_IN_AMAP;


//  			Allows a host driver or management software to Invalidate the current 			FCF, and
// start new solicitation on specified FCF's or on all FCF's.  			<p> 			The call returns
// [link]MGMT_STATUS_SUCCESS[/link] when the specified FCF table index 			is valid and can
// be reset. When fcf_index is not valid firmware returns 
// 			[link]MGMT_STATUS_ILLEGAL_FIELD[/link].  	           	         		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_COMMON_FCOE_REDISCOVER_FCF_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_COMMON_FCOE_REDISCOVER_FCF_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_FCOE_REDISCOVER_FCF_AMAP, *PIOCTL_COMMON_FCOE_REDISCOVER_FCF_AMAP;


// --- MBOX_IO_COMPLETION_MODE ---
// Completion type expected by Host/BIOS. 
#define MBOX_IO_COMPLETION_MODE_NON_BLOCKING (1)  // If a CQ is available it will be
                                                  // rported else error code
                                                  // MGMT_STATUS_NO_CQE 
#define MBOX_IO_COMPLETION_MODE_BLOCKING (2)      // Block Ioctl until a CQ is available
                                                  // for ARM Firmware. 

typedef enum {
   ENUM_MBOX_IO_COMPLETION_MODE_NON_BLOCKING = 0x1UL,
   ENUM_MBOX_IO_COMPLETION_MODE_BLOCKING = 0x2UL
} MBOX_IO_COMPLETION_MODE;

// --- MBOX_IO_CQ_TYPE ---
// CQ type being posted to Host/BIOS. 
#define MBOX_IO_CQ_TYPE_NORMAL          (1)       // CQ related to the I/O request. 
#define MBOX_IO_CQ_TYPE_ASYNC           (2)       // Async CQ, can be link, FCF related. 

typedef enum {
   ENUM_MBOX_IO_CQ_TYPE_NORMAL = 0x1UL,
   ENUM_MBOX_IO_CQ_TYPE_ASYNC = 0x2UL
} MBOX_IO_CQ_TYPE;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_FCOE_MBOX_IO_INIT_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } FCOE_MBOX_IO_INIT_PARAMS_IN_AMAP, *PFCOE_MBOX_IO_INIT_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_FCOE_MBOX_IO_INIT_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } FCOE_MBOX_IO_INIT_PARAMS_OUT_AMAP, *PFCOE_MBOX_IO_INIT_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_MBOX_IO_INIT_PARAMS_IN_AMAP request;
   BE_FCOE_MBOX_IO_INIT_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_MBOX_IO_INIT_PARAMS_AMAP;
typedef struct { u32 dw[1]; } FCOE_MBOX_IO_INIT_PARAMS_AMAP, *PFCOE_MBOX_IO_INIT_PARAMS_AMAP;


//              This Ioctl should be issued by FC expansion BIOS prior to            
// issuing  calls to execute offloaded FCoE I/O requests.             The ARM firmware
// sets up a WRB queue and a corresponding CQ to              execute
// [link]IOCTL_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST[/link] and             
// [link]IOCTL_COMMON_FCOE_MBOX_REQUEST_COMPLETION[/link] IOCTLs.             To destroy
// these WRB and CQ rings use[link]IOCTL_COMMON_FUNCTION_RESET[/link].            
// Following Status Codes are Possible.             <UL>                
// <LI>[link]MGMT_STATUS_SUCCESS[/link]                          -- Command completed
// successfully.                 </LI>                                   
// <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]                          -- This
// Ioctl has already been already called for this function atleast once.                
// </LI>             </UL>                      
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_MBOX_IO_INIT_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_MBOX_IO_INIT_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_FCOE_MBOX_IO_INIT_AMAP, *PIOCTL_COMMON_FCOE_MBOX_IO_INIT_AMAP;



typedef struct {
   BE_UEXACT8_AMAP fcoe_wqe[64];
   BE_BIT rsvd0[16][8];                           // DWORD 16
   BE_MGMT_SG_TABLE_AMAP sg_list;
} SG_PACK BE_FCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_IN_AMAP;
typedef struct { u32 dw[26]; } FCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_IN_AMAP, *PFCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_FCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } FCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_OUT_AMAP, *PFCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_IN_AMAP request;
   BE_FCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_AMAP;
typedef struct { u32 dw[26]; } FCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_AMAP, *PFCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_AMAP;


//              It is assumed that the issuer has              <ul>                 <li>
// Requested the ARM f/w to setup WRB and CQ rings using                          
// [link]IOCTL_FCOE_MBOX_IO_INIT[/link]                 <li> Completed FCoE discovery
// using existing SLI mailbox commands and                              other FCoE
// specific IOCTLs and completed registration of FCFs, VFI/VPI                            
// and RPI to which I/Os are going to be issued.             </ul>             Following
// Status Codes are Possible.             <UL>                
// <LI>[link]MGMT_STATUS_SUCCESS[/link]                          -- Command completed
// successfully.                 </LI>                                   
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]                          -- One of the
// fields is invalid, ARM Firmware does not look at fcoe_wqe, so most likely              
//               the sg_list.                 </LI>             </UL>                     
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_MBOX_SUBMIT_IO_REQUEST_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_AMAP;
typedef struct { u32 dw[30]; } IOCTL_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_AMAP, *PIOCTL_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST_AMAP;



typedef struct {
   BE_UEXACT32_AMAP flags;
} SG_PACK BE_FCOE_MBOX_REQUEST_COMPLETION_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } FCOE_MBOX_REQUEST_COMPLETION_PARAMS_IN_AMAP, *PFCOE_MBOX_REQUEST_COMPLETION_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP cq_type;
   BE_UEXACT8_AMAP cqe[16];
} SG_PACK BE_FCOE_MBOX_REQUEST_COMPLETION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[5]; } FCOE_MBOX_REQUEST_COMPLETION_PARAMS_OUT_AMAP, *PFCOE_MBOX_REQUEST_COMPLETION_PARAMS_OUT_AMAP;



typedef union {
   BE_FCOE_MBOX_REQUEST_COMPLETION_PARAMS_IN_AMAP request;
   BE_FCOE_MBOX_REQUEST_COMPLETION_PARAMS_OUT_AMAP response;
} SG_PACK BE_FCOE_MBOX_REQUEST_COMPLETION_PARAMS_AMAP;
typedef struct { u32 dw[5]; } FCOE_MBOX_REQUEST_COMPLETION_PARAMS_AMAP, *PFCOE_MBOX_REQUEST_COMPLETION_PARAMS_AMAP;


//              Drivers or extension BIOS using the
// [link]IOCTL_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST[/link]             Following Status
// Codes are possible.             <UL>                
// <LI>[link]MGMT_STATUS_SUCCESS[/link]                          -- CQ is being reported
// in response.                 </LI>                                   
// <LI>[link]MGMT_STATUS_NO_CQE[/link]                          -- There is no outstanding
// CQ available with ARM to Report to Host/BIOS.                 </LI>             </UL>  
//                   
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FCOE_MBOX_REQUEST_COMPLETION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FCOE_MBOX_REQUEST_COMPLETION_AMAP;
typedef struct { u32 dw[9]; } IOCTL_COMMON_FCOE_MBOX_REQUEST_COMPLETION_AMAP, *PIOCTL_COMMON_FCOE_MBOX_REQUEST_COMPLETION_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_fcoe_amap_h__

