/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_boot_amap_h__
#define __ioctl_iscsi_ini_boot_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- BOOT_TARGET_CONFIGURATION ---
#define BOOT_TARGET_MANUALLY_CONFIGURED (1)       // Boot target is manually configured 
#define BOOT_TARGET_AUTO_DISCOVERED     (2)       // The firmware needs to discover the
                                                  // boot device itself 

typedef enum {
   ENUM_BOOT_TARGET_MANUALLY_CONFIGURED = 0x1UL,
   ENUM_BOOT_TARGET_AUTO_DISCOVERED = 0x2UL
} BOOT_TARGET_CONFIGURATION;

// --- AUTO_DISCOVER_CONFIGURATION ---
#define DISCOVER_BOOT_TARGET_USING_DHCP_PORT0 (1) // Discover Boot Target using DHCP on
                                                  // Port0 
#define DISCOVER_BOOT_TARGET_USING_DHCP_PORT1 (2) // Discover Boot Target using DHCP on
                                                  // Port1 

typedef enum {
   ENUM_DISCOVER_BOOT_TARGET_USING_DHCP_PORT0 = 0x1UL,
   ENUM_DISCOVER_BOOT_TARGET_USING_DHCP_PORT1 = 0x2UL
} AUTO_DISCOVER_CONFIGURATION;

// --- MGMT_BIOS_INT13_STATE ---
#define MGMT_HBA_INT13_DISABLED         (0)       
#define MGMT_HBA_INT13_ENABLED          (1)       

typedef enum {
   ENUM_MGMT_HBA_INT13_DISABLED = 0x0UL,
   ENUM_MGMT_HBA_INT13_ENABLED = 0x1UL
} MGMT_BIOS_INT13_STATE;

// --- MGMT_INT13_PER_FUNC ---
#define MGMT_HBA_INT13_FUN0             (1)       
#define MGMT_HBA_INT13_FUN1             (2)       
#define MGMT_HBA_INT13_FUN2             (4)       
#define MGMT_HBA_INT13_FUN3             (8)       
#define MGMT_HBA_INT13_FUN4             (16)      
#define MGMT_HBA_INT13_FUN5             (32)      
#define MGMT_HBA_INT13_FUN6             (64)      
#define MGMT_HBA_INT13_FUN7             (128)     

typedef enum {
   ENUM_MGMT_HBA_INT13_FUN0 = 0x1UL,
   ENUM_MGMT_HBA_INT13_FUN1 = 0x2UL,
   ENUM_MGMT_HBA_INT13_FUN2 = 0x4UL,
   ENUM_MGMT_HBA_INT13_FUN3 = 0x8UL,
   ENUM_MGMT_HBA_INT13_FUN4 = 0x10UL,
   ENUM_MGMT_HBA_INT13_FUN5 = 0x20UL,
   ENUM_MGMT_HBA_INT13_FUN6 = 0x40UL,
   ENUM_MGMT_HBA_INT13_FUN7 = 0x80UL
} MGMT_INT13_PER_FUNC;


typedef struct {
   BE_UEXACT32_AMAP boot_session_count;
   BE_UEXACT32_AMAP boot_session_handle;
} SG_PACK BE_GET_BOOT_TARGET_OUT_AMAP;
typedef struct { u32 dw[2]; } GET_BOOT_TARGET_OUT_AMAP, *PGET_BOOT_TARGET_OUT_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_BOOT_TARGET_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_INI_BOOT_GET_BOOT_TARGET_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ISCSI_INI_BOOT_GET_BOOT_TARGET_AMAP, *PIOCTL_ISCSI_INI_BOOT_GET_BOOT_TARGET_AMAP;


// --- BOOT_SECURITY_FLAG ---
#define BOOT_SECURITY_ENABLED           (1)       // Enabled 
#define BOOT_SECURITY_DISABLED          (2)       // Disabled 

typedef enum {
   ENUM_BOOT_SECURITY_ENABLED = 0x1UL,
   ENUM_BOOT_SECURITY_DISABLED = 0x2UL
} BOOT_SECURITY_FLAG;


typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP session_flags;
   BE_UEXACT32_AMAP ipsec_enabled;
   BE_UEXACT16_AMAP preshared_key_length;
   BE_UEXACT16_AMAP ipsec_id_length;
   BE_UEXACT8_AMAP preshared_key[256];
   BE_UEXACT8_AMAP id[256];
} SG_PACK BE_SET_BOOT_TARGET_IN_AMAP;
typedef struct { u32 dw[132]; } SET_BOOT_TARGET_IN_AMAP, *PSET_BOOT_TARGET_IN_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_BOOT_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_ISCSI_INI_BOOT_SET_BOOT_TARGET_AMAP;
typedef struct { u32 dw[136]; } IOCTL_ISCSI_INI_BOOT_SET_BOOT_TARGET_AMAP, *PIOCTL_ISCSI_INI_BOOT_SET_BOOT_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_GET_BOOT_LUN_IN_AMAP;
typedef struct { u32 dw[1]; } GET_BOOT_LUN_IN_AMAP, *PGET_BOOT_LUN_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP boot_lun[8];
} SG_PACK BE_GET_BOOT_LUN_OUT_AMAP;
typedef struct { u32 dw[2]; } GET_BOOT_LUN_OUT_AMAP, *PGET_BOOT_LUN_OUT_AMAP;



typedef union {
   BE_GET_BOOT_LUN_IN_AMAP request;
   BE_GET_BOOT_LUN_OUT_AMAP response;
} SG_PACK BE_GET_BOOT_LUN_AMAP;
typedef struct { u32 dw[2]; } GET_BOOT_LUN_AMAP, *PGET_BOOT_LUN_AMAP;


//              This ioctl will return the Boot LUN stored in the Flash ROM.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_BOOT_LUN_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_BOOT_GET_BOOT_LUN_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ISCSI_INI_BOOT_GET_BOOT_LUN_AMAP, *PIOCTL_ISCSI_INI_BOOT_GET_BOOT_LUN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT8_AMAP boot_lun[8];
} SG_PACK BE_SET_BOOT_LUN_IN_AMAP;
typedef struct { u32 dw[3]; } SET_BOOT_LUN_IN_AMAP, *PSET_BOOT_LUN_IN_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_BOOT_LUN_IN_AMAP request;
} SG_PACK BE_IOCTL_ISCSI_INI_BOOT_SET_BOOT_LUN_AMAP;
typedef struct { u32 dw[7]; } IOCTL_ISCSI_INI_BOOT_SET_BOOT_LUN_AMAP, *PIOCTL_ISCSI_INI_BOOT_SET_BOOT_LUN_AMAP;


// --- BIOS_DEFINED_ENUMS ---
#define MGMT_MAX_BIOS_SG_COUNT          (10)      // (240 - 16 (for ioctl_header) - 40)/16
                                                  // = 11.5 
#define MGMT_MAX_BIOS_IOCTL_SIZE        (240)     

typedef enum {
   ENUM_MGMT_MAX_BIOS_SG_COUNT = 0xaUL,
   ENUM_MGMT_MAX_BIOS_IOCTL_SIZE = 0xf0UL
} BIOS_DEFINED_ENUMS;

// --- IOCTL_DATA_DIRECTION ---
#define SCB_FLAG_XFER_FROM_DEVICE       (1)       // Read 
#define SCB_FLAG_XFER_TO_DEVICE         (2)       // Write 

typedef enum {
   ENUM_SCB_FLAG_XFER_FROM_DEVICE = 0x1UL,
   ENUM_SCB_FLAG_XFER_TO_DEVICE = 0x2UL
} IOCTL_DATA_DIRECTION;


typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT8_AMAP lun[8];
   BE_UEXACT8_AMAP cdb[16];
   BE_UEXACT8_AMAP data_direction_flag;
   BE_BIT rsvd0[3][8];                            // DWORD 7
   BE_MGMT_SG_TABLE_AMAP sgtable;
} SG_PACK BE_SCSI_READ_WRITE_PARAMS_IN_AMAP;
typedef struct { u32 dw[14]; } SCSI_READ_WRITE_PARAMS_IN_AMAP, *PSCSI_READ_WRITE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP scsi_status;
   BE_UEXACT8_AMAP iscsi_response;
   BE_UEXACT8_AMAP sense_buffer[18];
} SG_PACK BE_SCSI_READ_WRITE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[5]; } SCSI_READ_WRITE_PARAMS_OUT_AMAP, *PSCSI_READ_WRITE_PARAMS_OUT_AMAP;



typedef union {
   BE_SCSI_READ_WRITE_PARAMS_IN_AMAP request;
   BE_SCSI_READ_WRITE_PARAMS_OUT_AMAP response;
} SG_PACK BE_SCSI_READ_WRITE_PARAMS_AMAP;
typedef struct { u32 dw[14]; } SCSI_READ_WRITE_PARAMS_AMAP, *PSCSI_READ_WRITE_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SCSI_READ_WRITE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_BOOT_READ_WRITE_AMAP;
typedef struct { u32 dw[18]; } IOCTL_ISCSI_INI_BOOT_READ_WRITE_AMAP, *PIOCTL_ISCSI_INI_BOOT_READ_WRITE_AMAP;


// --- MGMT_REMOTE_CFG ---
#define DISABLE_REMOTE_CFG              (0)       
#define ENABLE_REMOTE_CFG               (1)       // ARM Firmware will perform ICDS
                                                  // protocol with switch to query its IP,
                                                  // TFTP Server IP and SLOT ID. And will
                                                  // TFTP the XML file from server, to
                                                  // configure BladeEngine.

typedef enum {
   ENUM_DISABLE_REMOTE_CFG = 0x0UL,
   ENUM_ENABLE_REMOTE_CFG = 0x1UL
} MGMT_REMOTE_CFG;

// --- MGMT_IBFT_CONFIGURATION ---
#define IBFT_ADDRESS_INVALID            (0)       
#define IBFT_ADDRESS_VALID              (1)       // IBFT address is present in
                                                  // ibft_pci_address 

typedef enum {
   ENUM_IBFT_ADDRESS_INVALID = 0x0UL,
   ENUM_IBFT_ADDRESS_VALID = 0x1UL
} MGMT_IBFT_CONFIGURATION;


typedef struct {
   BE_UEXACT8_AMAP discover_boottarget;
   BE_BIT rsvd0[3][8];                            // DWORD 0
   BE_UEXACT8_AMAP auto_discovery_flags;
   BE_BIT rsvd1[3][8];                            // DWORD 1
   BE_UEXACT8_AMAP bios_int13_enabled;
   BE_UEXACT8_AMAP int13_en_per_func;
   BE_BIT rsvd2[1][8];                            // DWORD 2
   BE_UEXACT8_AMAP ibft_addr_valid;
   BE_UEXACT8_AMAP remote_configuration;
   BE_UEXACT8_AMAP ibft_pci_address[3];
   BE_UEXACT32_AMAP bios_ver;
} SG_PACK BE_BIOS_PARAMS_AMAP;
typedef struct { u32 dw[5]; } BIOS_PARAMS_AMAP, *PBIOS_PARAMS_AMAP;


//          OPCODE_GET/SET_BIOS_CONFIGURAION : BIOS Only IOCTL              get/set BIOS
// configuration parms.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_BIOS_PARAMS_AMAP bios_configuration;
} SG_PACK BE_IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION_AMAP;
typedef struct { u32 dw[9]; } IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION_AMAP, *PIOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION_AMAP;



typedef IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION_AMAP IOCTL_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_AMAP;
typedef BE_IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION_AMAP BE_IOCTL_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_AMAP;


typedef IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION_AMAP* PIOCTL_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION_AMAP;


typedef IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION_AMAP IOCTL_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_AMAP;
typedef BE_IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION_AMAP BE_IOCTL_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_AMAP;


typedef IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION_AMAP* PIOCTL_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION_AMAP;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_ini_boot_amap_h__

