/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_discovery_amap_h__
#define __ioctl_iscsi_ini_discovery_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- MGMT_TGT_FLAG ---
#define MGMT_TGT_FLAG_MANUAL_CONFIGURED (1)       
#define MGMT_TGT_FLAG_SENDTARGETS_DISCOVERED (2)  
#define MGMT_TGT_FLAG_ISNS_DISCOVERED   (4)       
#define MGMT_TGT_FLAG_SLP_DISCOVERED    (8)       

typedef enum {
   ENUM_MGMT_TGT_FLAG_MANUAL_CONFIGURED = 0x1UL,
   ENUM_MGMT_TGT_FLAG_SENDTARGETS_DISCOVERED = 0x2UL,
   ENUM_MGMT_TGT_FLAG_ISNS_DISCOVERED = 0x4UL,
   ENUM_MGMT_TGT_FLAG_SLP_DISCOVERED = 0x8UL
} MGMT_TGT_FLAG;

// --- MGMT_TGT_DISCOVERY ---
#define MGMT_TGT_DISCOVERY_SKIP         (0)       // "The firmware return all targets that
                                                  // has been already discovered. The
                                                  // firmware doesn't need to perform
                                                  // discovery 
#define MGMT_TGT_DISCOVERY_ISNS_SLP     (1)       // "The firmware should perform iSNSLP
                                                  // discovery before returing the targets
                                                  // to the application 

typedef enum {
   ENUM_MGMT_TGT_DISCOVERY_SKIP = 0x0UL,
   ENUM_MGMT_TGT_DISCOVERY_ISNS_SLP = 0x1UL
} MGMT_TGT_DISCOVERY;


typedef struct {
   BE_UEXACT32_AMAP perform_discovery;
   BE_UEXACT32_AMAP target_flags;
} SG_PACK BE_GET_ALL_DISCOVERED_TARGET_ID_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } GET_ALL_DISCOVERED_TARGET_ID_PARAMS_IN_AMAP, *PGET_ALL_DISCOVERED_TARGET_ID_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_id;
   BE_UEXACT32_AMAP portal_count;
} SG_PACK BE_MGMT_TARGET_ID_PORTAL_COUNT_AMAP;
typedef struct { u32 dw[2]; } MGMT_TARGET_ID_PORTAL_COUNT_AMAP, *PMGMT_TARGET_ID_PORTAL_COUNT_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_count;
   BE_MGMT_TARGET_ID_PORTAL_COUNT_AMAP list[1];
} SG_PACK BE_GET_ALL_DISCOVERED_TARGET_ID_PARAMS_OUT_AMAP;
typedef struct { u32 dw[3]; } GET_ALL_DISCOVERED_TARGET_ID_PARAMS_OUT_AMAP, *PGET_ALL_DISCOVERED_TARGET_ID_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_ALL_DISCOVERED_TARGET_ID_PARAMS_IN_AMAP request;
   BE_GET_ALL_DISCOVERED_TARGET_ID_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_ALL_DISCOVERED_TARGET_ID_PARAMS_AMAP;
typedef struct { u32 dw[3]; } GET_ALL_DISCOVERED_TARGET_ID_PARAMS_AMAP, *PGET_ALL_DISCOVERED_TARGET_ID_PARAMS_AMAP;


//                  An application is expected to issue this call initially to get the
// target_count to                 estimate the total buffer required to transfer all the
// information from the firmware.                 If the required buffer size exceeds 64K
// the application can                  issue
// [link]IOCTL_ISCSI_INI_DISCOVERY_REPORT_A_TARGET[/link] and retrieve the information.
// for individual targets.                  <br>                 <b>Originator(s)</b> :
// Management application                 <br>                 <b>Implemented in</b>:
// Firmware                 <br>                 <b>Return Values</b> :
// MGMT_STATUS_SUCCESS              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_ALL_DISCOVERED_TARGET_ID_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_AMAP;
typedef struct { u32 dw[7]; } IOCTL_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_AMAP, *PIOCTL_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID_AMAP;



typedef struct {
   BE_UEXACT32_AMAP perform_discovery;
   BE_UEXACT32_AMAP target_flags;
} SG_PACK BE_REPORT_ALL_TARGETS_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } REPORT_ALL_TARGETS_PARAMS_IN_AMAP, *PREPORT_ALL_TARGETS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MGMT_TARGET_INFO_AMAP target_list[1];
} SG_PACK BE_REPORT_ALL_TARGETS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[206]; } REPORT_ALL_TARGETS_PARAMS_OUT_AMAP, *PREPORT_ALL_TARGETS_PARAMS_OUT_AMAP;



typedef union {
   BE_REPORT_ALL_TARGETS_PARAMS_IN_AMAP request;
   BE_REPORT_ALL_TARGETS_PARAMS_OUT_AMAP response;
} SG_PACK BE_REPORT_ALL_TARGETS_PARAMS_AMAP;
typedef struct { u32 dw[206]; } REPORT_ALL_TARGETS_PARAMS_AMAP, *PREPORT_ALL_TARGETS_PARAMS_AMAP;


//                  This Ioctls is used to trigger iSNS and SLP discovery to find targets
// in the network.                 Targets will be discovered only if iSNS and SLP
// services are currently enabled,                 and atleast one iSNS server is
// reachable by the firmware. If the target_count                 indicates that the
// buffer size required exceeds the limit for a single IOCTL, the                 
// application should use the [link]IOCTL_ISCSI_INI_DISCOVERY_REPORT_A_TARGET[/link] to
// retrieve                 individual target information.                  <br>          
//       <b>Originator(s)</b> : Management application                 <br>               
//  <b>Implemented in</b>: Firmware                 <br>                 <b>Return
// Values</b> : MGMT_STATUS_SUCCESS              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_REPORT_ALL_TARGETS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_AMAP;
typedef struct { u32 dw[210]; } IOCTL_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_AMAP, *PIOCTL_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_id;
} SG_PACK BE_REPORT_A_TARGET_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } REPORT_A_TARGET_PARAMS_IN_AMAP, *PREPORT_A_TARGET_PARAMS_IN_AMAP;



typedef struct {
   BE_MGMT_TARGET_INFO_AMAP target_info;
} SG_PACK BE_REPORT_A_TARGET_PARAMS_OUT_AMAP;
typedef struct { u32 dw[204]; } REPORT_A_TARGET_PARAMS_OUT_AMAP, *PREPORT_A_TARGET_PARAMS_OUT_AMAP;



typedef union {
   BE_REPORT_A_TARGET_PARAMS_IN_AMAP request;
   BE_REPORT_A_TARGET_PARAMS_OUT_AMAP response;
} SG_PACK BE_REPORT_A_TARGET_PARAMS_AMAP;
typedef struct { u32 dw[204]; } REPORT_A_TARGET_PARAMS_AMAP, *PREPORT_A_TARGET_PARAMS_AMAP;


//                   Management applications can use this Ioctl to retrieve target
// information for a                   given target_id.                 <br>              
//   <b>Originator(s)</b> : Management application                 <br>                
// <b>Implemented in</b>: Firmware                 <br>                 <b>Return
// Values</b> : MGMT_STATUS_SUCCESS              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_REPORT_A_TARGET_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_AMAP;
typedef struct { u32 dw[208]; } IOCTL_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_AMAP, *PIOCTL_ISCSI_INI_DISCOVERY_REPORT_A_TARGET_AMAP;



typedef struct {
   BE_MGMT_PORTAL_AMAP portal;
   BE_UEXACT32_AMAP pg_tag;
} SG_PACK BE_MGMT_ISCSI_DISCOVERED_PORTAL_ENTRY_AMAP;
typedef struct { u32 dw[8]; } MGMT_ISCSI_DISCOVERED_PORTAL_ENTRY_AMAP, *PMGMT_ISCSI_DISCOVERED_PORTAL_ENTRY_AMAP;



typedef struct {
   BE_UEXACT32_AMAP num_addr_entries;
   BE_UEXACT8_AMAP target_name[224];
   BE_MGMT_ISCSI_DISCOVERED_PORTAL_ENTRY_AMAP address_entry[1];
} SG_PACK BE_MGMT_ISCSI_SEND_TARGET_PARSED_DATA_AMAP;
typedef struct { u32 dw[65]; } MGMT_ISCSI_SEND_TARGET_PARSED_DATA_AMAP, *PMGMT_ISCSI_SEND_TARGET_PARSED_DATA_AMAP;


// --- PARSE_DATA_OPTIONS ---
#define DO_NOT_PARSE_DATA               (0)       // Return the raw data returned by the
                                                  // SendTargets command 
#define RETURN_PARSED_DATA              (1)       // Firmware will return the parsed Send
                                                  // Targets Data. 
#define RETURN_TGT_COUNT                (2)       // Firmware parses the SendTarget Data,
                                                  // logs-in to all the discovered targets
                                                  // and returns the number of targets 

typedef enum {
   ENUM_DO_NOT_PARSE_DATA = 0x0UL,
   ENUM_RETURN_PARSED_DATA = 0x1UL,
   ENUM_RETURN_TGT_COUNT = 0x2UL
} PARSE_DATA_OPTIONS;


typedef struct {
   BE_UEXACT32_AMAP target_count;
   BE_MGMT_ISCSI_SEND_TARGET_PARSED_DATA_AMAP target_data[1];
} SG_PACK BE_SEND_TARGETS_PARSED_DATA_AMAP;
typedef struct { u32 dw[66]; } SEND_TARGETS_PARSED_DATA_AMAP, *PSEND_TARGETS_PARSED_DATA_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP parse_data;
   BE_EXACT8_AMAP textkey[256];
} SG_PACK BE_ISCSI_SEND_TARGETS_PARAMS_IN_AMAP;
typedef struct { u32 dw[66]; } ISCSI_SEND_TARGETS_PARAMS_IN_AMAP, *PISCSI_SEND_TARGETS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP response_size;
   BE_UEXACT8_AMAP response_data[1];
} SG_PACK BE_SEND_TARGETS_RAW_DATA_AMAP;
typedef struct { u32 dw[2]; } SEND_TARGETS_RAW_DATA_AMAP, *PSEND_TARGETS_RAW_DATA_AMAP;



typedef union {
   BE_SEND_TARGETS_RAW_DATA_AMAP raw_data;
   BE_SEND_TARGETS_PARSED_DATA_AMAP parsed_data;
} SG_PACK BE_ISCSI_SEND_TARGETS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[66]; } ISCSI_SEND_TARGETS_PARAMS_OUT_AMAP, *PISCSI_SEND_TARGETS_PARAMS_OUT_AMAP;



typedef union {
   BE_ISCSI_SEND_TARGETS_PARAMS_IN_AMAP request;
   BE_ISCSI_SEND_TARGETS_PARAMS_OUT_AMAP response;
} SG_PACK BE_ISCSI_SEND_TARGETS_PARAMS_AMAP;
typedef struct { u32 dw[66]; } ISCSI_SEND_TARGETS_PARAMS_AMAP, *PISCSI_SEND_TARGETS_PARAMS_AMAP;


//                  This Ioctl results in an iSCSI Send Targets command to the target.
// This call                 should be sent after an iSCSI Discovery session is
// established with the target. Based on the settings of the 				'parse_data' flag this
// IOCTL can return - 				<ol>  					<li> the raw text information contained in the iSCSI
// response PDU from the Target. 					<li> the parsed output from the SendTargets
// response. 					<li> the count of targets contained in the processed SendTargets
// response. 				</ol>  				WMI calls expect raw data. The Serverengines MILI/SMCLP use
// the processed output. If the size of parsed data 				exceeds available buffer space,
// the requesting entity may uses the returned target count to iteratively  				call
// [link]IOCTL_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO[/link]. The ServerEngines iSCSI BIOS
// uses this approach. 				                  <br>                 <b>Originator(s)</b> :
// Management applications, BIOS                 <br>                 <b>Implemented
// in</b>: Firmware                 <br>                 <b>Return Values</b> :  <ul>     
//                                        <li>MGMT_STATUS_SUCCESS                         
//                    <li>MGMT_STATUS_INVALID_SESSION (session_handle is invalid)         
//                                    <li>MGMT_STATUS_FAILED - Text Command Failed (Event
// Log is to be checked for exact status)                                            
// <li>MGMT_STATUS_POLL_IOCTL_TIMEOUT - Command Timed out                                 
//        </ul>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_SEND_TARGETS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_DISCOVERY_SEND_TARGETS_AMAP;
typedef struct { u32 dw[70]; } IOCTL_ISCSI_INI_DISCOVERY_SEND_TARGETS_AMAP, *PIOCTL_ISCSI_INI_DISCOVERY_SEND_TARGETS_AMAP;


// --- RETRIEVE_TARGET_INFO_OPTIONS ---
#define RETURN_PORTAL_COUNT             (0)       // Return portal count for the given
                                                  // range of targets (target_index ->
                                                  // target_index + num_of_targets). 
#define RETURN_PORTAL_INFO_SINGLE_TARGET (1)      // Return portal information for a given
                                                  // target. num_of_targets MUST be set to
                                                  // 1. Set portal_index and
                                                  // num_of_portals appropriately 
#define RETURN_PORTAL_INFO_MULTIPLE_TARGETS (2)   // Return portal information for a given
                                                  // range of targets (num_of_targets)
                                                  // starting with target_index.
                                                  // portal_index and num_of_portals are
                                                  // ignored. 

typedef enum {
   ENUM_RETURN_PORTAL_COUNT = 0x0UL,
   ENUM_RETURN_PORTAL_INFO_SINGLE_TARGET = 0x1UL,
   ENUM_RETURN_PORTAL_INFO_MULTIPLE_TARGETS = 0x2UL
} RETRIEVE_TARGET_INFO_OPTIONS;


typedef struct {
   BE_UEXACT16_AMAP target_index;
   BE_UEXACT16_AMAP num_of_targets;
   BE_UEXACT32_AMAP portal_count[1];
} SG_PACK BE_PORTAL_COUNT_INFO_AMAP;
typedef struct { u32 dw[2]; } PORTAL_COUNT_INFO_AMAP, *PPORTAL_COUNT_INFO_AMAP;



typedef struct {
   BE_UEXACT16_AMAP target_index;
   BE_UEXACT16_AMAP num_of_targets;
   BE_UEXACT32_AMAP target_inf_flags;
   BE_UEXACT16_AMAP portal_index;
   BE_UEXACT16_AMAP num_of_portals;
} SG_PACK BE_ISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } ISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_IN_AMAP, *PISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_IN_AMAP;



typedef union {
   BE_PORTAL_COUNT_INFO_AMAP portal_count_info;
   BE_SEND_TARGETS_PARSED_DATA_AMAP parsed_data;
} SG_PACK BE_ISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_OUT_AMAP;
typedef struct { u32 dw[66]; } ISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_OUT_AMAP, *PISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_OUT_AMAP;



typedef union {
   BE_ISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_IN_AMAP request;
   BE_ISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_OUT_AMAP response;
} SG_PACK BE_ISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_AMAP;
typedef struct { u32 dw[66]; } ISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_AMAP, *PISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_AMAP;


//  				This IOCTL allows the caller to selectively retrieve parts of the parsed
// information from the previous  				SendTargets Response.Refer to the description of
// [link]IOCTL_ISCSI_INI_DISCOVERY_SEND_TARGETS[/link].                    This Ioctl sent
// by a Management utility                  <br>                 <b>Originator(s)</b> :
// Management applications, BIOS                 <br>                 <b>Implemented
// in</b>: Firmware                 <br>                 <b>Return Values</b> :  <ul>     
//                                        <li>MGMT_STATUS_SUCCESS                         
//                    <li>MGMT_STATUS_INVALID_SESSION (session_handle is invalid)         
//                                    <li>MGMT_STATUS_FAILED - Text Command Failed (Event
// Log is to be checked for exact status)                                            
// <li>MGMT_STATUS_POLL_IOCTL_TIMEOUT - Command Timed out                                 
//        </ul>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_RETRIEVE_PARSED_TARGET_INFO_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_AMAP;
typedef struct { u32 dw[70]; } IOCTL_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_AMAP, *PIOCTL_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_ini_discovery_amap_h__

