/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_stats_amap_h__
#define __ioctl_iscsi_ini_stats_amap_h__
#include "setypes.h"
#include "ioctl_defs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT32_AMAP iscsi_cmd_pdus;
   BE_UEXACT32_AMAP iscsi_rsp_pdus;
   BE_UEXACT64_AMAP iscsi_tx_data_octets;
   BE_UEXACT64_AMAP iscsi_rx_data_octets;
   BE_UEXACT32_AMAP iscsi_digest_errors;
   BE_UEXACT32_AMAP iscsi_cxn_timeout_errors;
   BE_UEXACT32_AMAP iscsi_format_errors;
   BE_BIT rsvd0[32];                              // DWORD 9
} SG_PACK BE_MIB_ISCSI_STATISTICS_AMAP;
typedef struct { u32 dw[10]; } MIB_ISCSI_STATISTICS_AMAP, *PMIB_ISCSI_STATISTICS_AMAP;


// --- MIB_SESSION_FAILURE ---
// Definition of iscsi_ctl_last_ssn_failure_type 
#define MIB_SESSION_FAILURE_OTHER_ERRORS (0)      
#define MIB_SESSION_FAILURE_DIGEST_ERRORS (1)     
#define MIB_SESSION_FAILURE_CXNTIMEOUT_ERRORS (2) 
#define MIB_SESSION_FAILURE_FORMAT_ERRORS (3)     

typedef enum {
   ENUM_MIB_SESSION_FAILURE_OTHER_ERRORS = 0x0UL,
   ENUM_MIB_SESSION_FAILURE_DIGEST_ERRORS = 0x1UL,
   ENUM_MIB_SESSION_FAILURE_CXNTIMEOUT_ERRORS = 0x2UL,
   ENUM_MIB_SESSION_FAILURE_FORMAT_ERRORS = 0x3UL
} MIB_SESSION_FAILURE;

// --- MIB_LOGIN_FAILURE ---
// Define iscsi_intr_last_tgt_failure_type 
#define MIB_LOGIN_FAILURE_UNKNOWN       (0)       
#define MIB_LOGIN_FAILURE_LOGIN_ACCEPT  (1)       
#define MIB_LOGIN_FAILURE_OTHER_FAIL    (2)       
#define MIB_LOGIN_FAILURE_LOGIN_REDIRECT (3)      
#define MIB_LOGIN_FAILURE_LOGIN_AUTHFAIL (4)      
#define MIB_LOGIN_FAILURE_LOGIN_AUTHENTICATE_FAIL (5) 
#define MIB_LOGIN_FAILURE_LOGIN_NEGOTIATE_FAIL (6) 

typedef enum {
   ENUM_MIB_LOGIN_FAILURE_UNKNOWN = 0x0UL,
   ENUM_MIB_LOGIN_FAILURE_LOGIN_ACCEPT = 0x1UL,
   ENUM_MIB_LOGIN_FAILURE_OTHER_FAIL = 0x2UL,
   ENUM_MIB_LOGIN_FAILURE_LOGIN_REDIRECT = 0x3UL,
   ENUM_MIB_LOGIN_FAILURE_LOGIN_AUTHFAIL = 0x4UL,
   ENUM_MIB_LOGIN_FAILURE_LOGIN_AUTHENTICATE_FAIL = 0x5UL,
   ENUM_MIB_LOGIN_FAILURE_LOGIN_NEGOTIATE_FAIL = 0x6UL
} MIB_LOGIN_FAILURE;

// --- MIB_ISCSI_SESSION_DIRECTION ---
// Definition for iscsi_ssn_direction 
#define MIB_INBOUND_SESSION             (1)       // session is established from an
                                                  // external initiator to a target within
                                                  // this iSCSI instance. 
#define MIB_OUTBOUND_SESSION            (2)       // session is established from an
                                                  // initiator within this iSCSI instance
                                                  // to an external target. 

typedef enum {
   ENUM_MIB_INBOUND_SESSION = 0x1UL,
   ENUM_MIB_OUTBOUND_SESSION = 0x2UL
} MIB_ISCSI_SESSION_DIRECTION;


typedef struct {
   BE_UEXACT32_AMAP iscsi_ctl_portal_count;
   BE_UEXACT32_AMAP iscsi_ctl_node_count;
   BE_UEXACT32_AMAP iscsi_ctl_session_count;
   BE_UEXACT32_AMAP iscsi_ctl_ssn_failure_count;
   BE_UEXACT32_AMAP iscsi_ctl_last_ssn_failure_type;
   BE_EXACT8_AMAP iscsi_ctl_last_ssn_rmt_node_name[224];
   BE_UEXACT32_AMAP iscsi_ctl_ssn_digest_errors;
   BE_UEXACT32_AMAP iscsi_ctl_ssn_cxn_timeout_errors;
   BE_UEXACT32_AMAP iscsi_ctl_ssn_format_errors;
   BE_UEXACT32_AMAP iscsi_session_handle;
   BE_BIT rsvd0[32];                              // DWORD 65
} SG_PACK BE_MIB_INITIATOR_INSTANCE_STATISTICS_AMAP;
typedef struct { u32 dw[66]; } MIB_INITIATOR_INSTANCE_STATISTICS_AMAP, *PMIB_INITIATOR_INSTANCE_STATISTICS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MIB_INITIATOR_INSTANCE_STATISTICS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_AMAP;
typedef struct { u32 dw[70]; } IOCTL_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_AMAP, *PIOCTL_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS_AMAP;



typedef struct {
   BE_EXACT8_AMAP iscsi_node_name[224];
   BE_UEXACT32_AMAP iscsi_intr_login_failures;
   BE_UEXACT32_AMAP iscsi_intr_last_failure_time;
   BE_UEXACT32_AMAP iscsi_intr_last_failure_type;
   BE_EXACT8_AMAP iscsi_intr_last_tgt_failure_name[224];
   BE_UEXACT32_AMAP iscsi_intr_last_tgt_failure_type;
   BE_IP_ADDRESS_FORMAT_AMAP iscsi_intr_last_tgt_failure_addr;
   BE_UEXACT32_AMAP iscsi_intr_login_accept_rsps;
   BE_UEXACT32_AMAP iscsi_intr_login_other_fail_rsps;
   BE_UEXACT32_AMAP iscsi_intr_login_redirect_rsps;
   BE_UEXACT32_AMAP iscsi_intr_login_auth_fail_rsps;
   BE_UEXACT32_AMAP iscsi_intr_login_authenticate_fails;
   BE_UEXACT32_AMAP iscsi_intr_login_negotiate_fails;
   BE_UEXACT32_AMAP iscsi_intr_logout_normals;
   BE_UEXACT32_AMAP iscsi_intr_logout_others;
} SG_PACK BE_MIB_INTR_LOGIN_STATISTICS_AMAP;
typedef struct { u32 dw[130]; } MIB_INTR_LOGIN_STATISTICS_AMAP, *PMIB_INTR_LOGIN_STATISTICS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MIB_INTR_LOGIN_STATISTICS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_AMAP;
typedef struct { u32 dw[134]; } IOCTL_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_AMAP, *PIOCTL_ISCSI_INI_STATS_GET_LOGIN_STATISTICS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP magic_number;
   BE_UEXACT32_AMAP session_id_count;
   BE_UEXACT32_AMAP session_id_list[1];
} SG_PACK BE_GET_SESSION_ATTRIBUTES_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } GET_SESSION_ATTRIBUTES_PARAMS_IN_AMAP, *PGET_SESSION_ATTRIBUTES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP iscsi_ssn_direction;
   BE_EXACT8_AMAP iscsi_initiator_alias[32];
   BE_EXACT8_AMAP iscsi_target_alias[32];
   BE_MIB_ISCSI_STATISTICS_AMAP iscsi_ssn_statistics;
   BE_MGMT_SESSION_INFO_AMAP iscsi_ssn_info;
} SG_PACK BE_MIB_SESSION_ATTRIBUTES_AMAP;
typedef struct { u32 dw[319]; } MIB_SESSION_ATTRIBUTES_AMAP, *PMIB_SESSION_ATTRIBUTES_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_UEXACT32_AMAP session_attribs_count;
   BE_MIB_SESSION_ATTRIBUTES_AMAP session_attribs[1];
} SG_PACK BE_GET_SESSION_ATTRIBUTES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[321]; } GET_SESSION_ATTRIBUTES_PARAMS_OUT_AMAP, *PGET_SESSION_ATTRIBUTES_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_SESSION_ATTRIBUTES_PARAMS_IN_AMAP request;
   BE_GET_SESSION_ATTRIBUTES_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_SESSION_ATTRIBUTES_PARAMS_AMAP;
typedef struct { u32 dw[321]; } GET_SESSION_ATTRIBUTES_PARAMS_AMAP, *PGET_SESSION_ATTRIBUTES_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_SESSION_ATTRIBUTES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_AMAP;
typedef struct { u32 dw[325]; } IOCTL_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_AMAP, *PIOCTL_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_GET_A_SESSION_STATISTICS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_A_SESSION_STATISTICS_PARAMS_IN_AMAP, *PGET_A_SESSION_STATISTICS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_UEXACT8_AMAP target_name[224];
   BE_MIB_ISCSI_STATISTICS_AMAP iscsi_ssn_stats;
} SG_PACK BE_MIB_SESSION_STATISTICS_AMAP;
typedef struct { u32 dw[68]; } MIB_SESSION_STATISTICS_AMAP, *PMIB_SESSION_STATISTICS_AMAP;



typedef struct {
   BE_MIB_SESSION_STATISTICS_AMAP session_stats;
} SG_PACK BE_GET_A_SESSION_STATISTICS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[68]; } GET_A_SESSION_STATISTICS_PARAMS_OUT_AMAP, *PGET_A_SESSION_STATISTICS_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_A_SESSION_STATISTICS_PARAMS_IN_AMAP request;
   BE_GET_A_SESSION_STATISTICS_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_A_SESSION_STATISTICS_PARAMS_AMAP;
typedef struct { u32 dw[68]; } GET_A_SESSION_STATISTICS_PARAMS_AMAP, *PGET_A_SESSION_STATISTICS_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_A_SESSION_STATISTICS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_AMAP;
typedef struct { u32 dw[72]; } IOCTL_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_AMAP, *PIOCTL_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_GET_CONN_STATISTICS_PER_SESSION_IN_AMAP;
typedef struct { u32 dw[1]; } GET_CONN_STATISTICS_PER_SESSION_IN_AMAP, *PGET_CONN_STATISTICS_PER_SESSION_IN_AMAP;


//  BE supports maximum 4 connections per session. 
typedef struct {
   BE_UEXACT32_AMAP cid;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MIB_ISCSI_STATISTICS_AMAP iscsi_conn_stats;
} SG_PACK BE_MIB_CONNECTION_STATISTICS_AMAP;
typedef struct { u32 dw[12]; } MIB_CONNECTION_STATISTICS_AMAP, *PMIB_CONNECTION_STATISTICS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP conn_stats_count;
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT8_AMAP target_name[224];
   BE_MIB_CONNECTION_STATISTICS_AMAP conn_stats[4];
} SG_PACK BE_GET_CONN_STATISTICS_PER_SESSION_OUT_AMAP;
typedef struct { u32 dw[106]; } GET_CONN_STATISTICS_PER_SESSION_OUT_AMAP, *PGET_CONN_STATISTICS_PER_SESSION_OUT_AMAP;



typedef union {
   BE_GET_CONN_STATISTICS_PER_SESSION_IN_AMAP params_in;
   BE_GET_CONN_STATISTICS_PER_SESSION_OUT_AMAP params_out;
} SG_PACK BE_GET_CONN_STATISTICS_PER_SESSION_AMAP;
typedef struct { u32 dw[106]; } GET_CONN_STATISTICS_PER_SESSION_AMAP, *PGET_CONN_STATISTICS_PER_SESSION_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_CONN_STATISTICS_PER_SESSION_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_AMAP;
typedef struct { u32 dw[110]; } IOCTL_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_AMAP, *PIOCTL_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION_AMAP;



typedef struct {
   BE_BIT bad_spi_lsd[32];                        // DWORD 0
   BE_BIT bad_spi_msd[32];                        // DWORD 1
   BE_BIT bad_decrypt_lsd[32];                    // DWORD 2
   BE_BIT bad_decrypt_msd[32];                    // DWORD 3
   BE_BIT bad_auth_lsd[32];                       // DWORD 4
   BE_BIT bad_auth_msd[32];                       // DWORD 5
   BE_BIT good_replay_lsd[32];                    // DWORD 6
   BE_BIT good_replay_msd[32];                    // DWORD 7
   BE_BIT rx_esp_bytes_lsd[32];                   // DWORD 8
   BE_BIT rx_esp_bytes_msd[32];                   // DWORD 9
   BE_BIT rx_ah_bytes_lsd[32];                    // DWORD 10
   BE_BIT rx_ah_bytes_msd[32];                    // DWORD 11
   BE_BIT tx_esp_bytes_lsd[32];                   // DWORD 12
   BE_BIT tx_esp_bytes_msd[32];                   // DWORD 13
   BE_BIT tx_ah_bytes_lsd[32];                    // DWORD 14
   BE_BIT tx_ah_bytes_msd[32];                    // DWORD 15
} SG_PACK BE_BE_IPSEC_STATS_AMAP;
typedef struct { u32 dw[16]; } BE_IPSEC_STATS_AMAP, *PBE_IPSEC_STATS_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_AMAP, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_AMAP;



typedef union {
   BE_BE_IPSEC_STATS_AMAP response;
   BE_IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_GET_IPSEC_STATISTICS_PARAMS_AMAP;
typedef struct { u32 dw[16]; } IOCTL_GET_IPSEC_STATISTICS_PARAMS_AMAP, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_GET_IPSEC_STATISTICS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_AMAP;
typedef struct { u32 dw[20]; } IOCTL_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_AMAP, *PIOCTL_ISCSI_INI_STATS_GET_IPSEC_STATISTICS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_ini_stats_amap_h__

