/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_mili_ptl_amap_h__
#define __ioctl_mili_ptl_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT32_AMAP portal_key;
   BE_IP_ADDRESS_FORMAT_AMAP portal_ip_addr;
   BE_UEXACT16_AMAP tcp_port;
   BE_UEXACT16_AMAP phy_port;
   BE_MAC_ADDRESS_FORMAT_AMAP mac_addr;
} SG_PACK BE_IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_AMAP;
typedef struct { u32 dw[10]; } IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_AMAP, *PIOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_AMAP;


//               MILI requests PTL to create a portal with the specified IP address and
// port number and associate it             with the portal_key provided. This key is used
// to refer to this portal in the following IOCTLs-                 <br><ul>              
//       <li>[link]IOCTL_MILI_PTL_DELETE_PORTAL[/link]                    
// <li>[link]IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP[/link]                 </ul>       
//     This IOCTL returns one of the following status values in the response              
//    <ul>                     <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDL_STATUS_DUPLICATE_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link> 	  
// <li><link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 	</ul>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_CREATE_PORTAL_AMAP;
typedef struct { u32 dw[14]; } IOCTL_MILI_PTL_CREATE_PORTAL_AMAP, *PIOCTL_MILI_PTL_CREATE_PORTAL_AMAP;



typedef struct {
   BE_UEXACT32_AMAP portal_key;
} SG_PACK BE_IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_AMAP, *PIOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_AMAP;


//              Delete Portal   PTL removes portal and puts it back into free pool list   
//         - Returns an error if the portal key could not be located in the PTL
// configuration info.    	This IOCTL returns one of the following status values in the
// response                  <ul>                     <li>[link]MGMT_STATUS_SUCCESS[/link]
//                     <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>          
//   This IOCTL returns one of the following additional status values in the response<br> 
// 	<ul> 	   <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link> 	</ul>          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_DELETE_PORTAL_AMAP;
typedef struct { u32 dw[5]; } IOCTL_MILI_PTL_DELETE_PORTAL_AMAP, *PIOCTL_MILI_PTL_DELETE_PORTAL_AMAP;



typedef struct {
   BE_UEXACT32_AMAP portal_group_key;
   BE_UEXACT32_AMAP portal_group_tag;
} SG_PACK BE_IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_AMAP;
typedef struct { u32 dw[2]; } IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_AMAP, *PIOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_AMAP;


//              Create a Portal Group. Add Portals into this Portal Group using           
//   [link]IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP[/link]    	This IOCTL returns one of
// the following status values in the response                  <ul>                    
// <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 	</ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_AMAP;
typedef struct { u32 dw[6]; } IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_AMAP, *PIOCTL_MILI_PTL_CREATE_PORTAL_GROUP_AMAP;



typedef struct {
   BE_UEXACT32_AMAP portal_group_key;
} SG_PACK BE_IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_AMAP, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_AMAP;


//              Delete Portal Group created using
// [link]IOCTL_MILI_PTL_CREATE_PORTAL_GROUP[/link].                 MILI should make sure
// to remove portals and unbind the portal group from target                 before
// deleting the portal group. Otherwise PTL will return errors                  listed
// under IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_STATUS.     	This IOCTL returns one of the
// following status values in the response                  <ul>                    
// <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link> 	</ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_AMAP;
typedef struct { u32 dw[5]; } IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_AMAP, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_AMAP;



typedef struct {
   BE_UEXACT32_AMAP portal_group_key;
   BE_UEXACT32_AMAP portal_count;
   BE_UEXACT32_AMAP portal_key[1];
} SG_PACK BE_IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_AMAP;
typedef struct { u32 dw[3]; } IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_AMAP, *PIOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_AMAP;


//              Add portal to Portal Group  portal key,PG key   status  Adds the portal to
// portal group.    	This IOCTL returns one of the following status values in the response
//                  <ul>                     <li>[link]MGMT_STATUS_SUCCESS[/link]         
//            <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This
// IOCTL returns one of the following additional status values in the response<br>  	<ul>
// 	   <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link> 	  
// <li><link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link> 	  
// <li><link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 	</ul>            
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_AMAP;
typedef struct { u32 dw[7]; } IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_AMAP, *PIOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_AMAP;



typedef struct {
   BE_UEXACT32_AMAP portal_group_key;
   BE_UEXACT32_AMAP portal_count;
   BE_UEXACT32_AMAP portal_key[1];
} SG_PACK BE_IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_AMAP;
typedef struct { u32 dw[3]; } IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_AMAP, *PIOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_AMAP;


//              Remove portal from portal group.    	This IOCTL returns one of the
// following status values in the response                  <ul>                    
// <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_ACTIVE_SESSIONS_PRESENT</link> 	  
// <li><link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link> 	  
// <li><link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link> 	</ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_AMAP;
typedef struct { u32 dw[7]; } IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_AMAP, *PIOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
   BE_UEXACT8_AMAP target_name[224];
   BE_UEXACT8_AMAP target_alias[224];
} SG_PACK BE_IOCTL_MILI_PTL_ADD_TARGET_IN_AMAP;
typedef struct { u32 dw[113]; } IOCTL_MILI_PTL_ADD_TARGET_IN_AMAP, *PIOCTL_MILI_PTL_ADD_TARGET_IN_AMAP;


//              Add Target name and alias. 	    This IOCTL returns one of the following
// status values in the response                  <ul>                    
// <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link> 	  
// <li><link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 	</ul>            
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_ADD_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_ADD_TARGET_AMAP;
typedef struct { u32 dw[117]; } IOCTL_MILI_PTL_ADD_TARGET_AMAP, *PIOCTL_MILI_PTL_ADD_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
} SG_PACK BE_IOCTL_MILI_PTL_DELETE_TARGET_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_MILI_PTL_DELETE_TARGET_IN_AMAP, *PIOCTL_MILI_PTL_DELETE_TARGET_IN_AMAP;


//              Delete Target. MILI should ensure that all Portal Groups bound to this
// target are deleted. 	    This IOCTL returns one of the following status values in the
// response                  <ul>                     <li>[link]MGMT_STATUS_SUCCESS[/link]
//                     <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>          
//   This IOCTL returns one of the following additional status values in the response<br> 
// 	<ul> 	   <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 	</ul>            
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_DELETE_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_DELETE_TARGET_AMAP;
typedef struct { u32 dw[5]; } IOCTL_MILI_PTL_DELETE_TARGET_AMAP, *PIOCTL_MILI_PTL_DELETE_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
   BE_UEXACT32_AMAP portal_group_count;
   BE_UEXACT32_AMAP portal_group_key[1];
} SG_PACK BE_IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_AMAP;
typedef struct { u32 dw[3]; } IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_AMAP, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_AMAP;


//              Add portal group to target. 	    This IOCTL returns one of the following
// status values in the response                  <ul>                    
// <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 	  
// <li><link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link> 	  
// <li><link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 	</ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_AMAP;
typedef struct { u32 dw[7]; } IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_AMAP, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
   BE_UEXACT32_AMAP portal_group_count;
   BE_UEXACT32_AMAP portal_group_key[1];
} SG_PACK BE_IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_AMAP;
typedef struct { u32 dw[3]; } IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_AMAP, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_AMAP;


//              Remove portal group from target. 	 This IOCTL returns one of the following
// status values in the response                  <ul>                    
// <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 	  
// <li><link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link> 	  
// <li><link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link> 	  
// <li><link>MGMT_ADDI_STATUS_ACTIVE_SESSIONS_PRESENT</link> 	</ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_AMAP;
typedef struct { u32 dw[7]; } IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_AMAP, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
   BE_MGMT_LOGIN_OPTIONS_AMAP target_login_options;
   BE_UEXACT8_AMAP auth_method_type;
   BE_UEXACT8_AMAP pad[3];
} SG_PACK BE_IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_AMAP;
typedef struct { u32 dw[152]; } IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_AMAP, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_AMAP;


//              Set Target Login Params and authentication details. 	 This IOCTL returns
// one of the following status values in the response                  <ul>               
//      <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 	</ul>            
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_AMAP;
typedef struct { u32 dw[156]; } IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_AMAP, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP portal_key;
} SG_PACK BE_IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_AMAP, *PIOCTL_MILI_PTL_START_LISTEN_SERVER_IN_AMAP;


//              Start Listen server on the specified portal.              PTL should pass
// this requests to the ARM firmware.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_START_LISTEN_SERVER_AMAP;
typedef struct { u32 dw[5]; } IOCTL_MILI_PTL_START_LISTEN_SERVER_AMAP, *PIOCTL_MILI_PTL_START_LISTEN_SERVER_AMAP;



typedef struct {
   BE_UEXACT32_AMAP portal_key;
} SG_PACK BE_IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_AMAP, *PIOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_AMAP;


//              Stop Listen server on the specified portal.             PTL should request
// ARM to stop listening for TCP connections on this port.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_PTL_STOP_LISTEN_SERVER_AMAP;
typedef struct { u32 dw[5]; } IOCTL_MILI_PTL_STOP_LISTEN_SERVER_AMAP, *PIOCTL_MILI_PTL_STOP_LISTEN_SERVER_AMAP;



typedef struct {
   BE_UEXACT32_AMAP handle;
} SG_PACK BE_ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_AMAP, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP iscsiInstSsnFailures;
   BE_EXACT8_AMAP iscsiInstLastSsnRmtNodeName[255];
   BE_UEXACT32_AMAP iscsiInstDiscontinuityTime;
} SG_PACK BE_ISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[66]; } ISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT_AMAP, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT_AMAP;



typedef union {
   BE_ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_AMAP request;
   BE_ISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT_AMAP response;
} SG_PACK BE_ISCSI_INSTANCE_ATTRIBUTES_PARAMS_AMAP;
typedef struct { u32 dw[66]; } ISCSI_INSTANCE_ATTRIBUTES_PARAMS_AMAP, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_INSTANCE_ATTRIBUTES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_AMAP;
typedef struct { u32 dw[70]; } IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_AMAP, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES_AMAP;



typedef struct {
   BE_UEXACT32_AMAP handle;
} SG_PACK BE_ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_AMAP, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP iscsiInstSsnDigestErrors;
   BE_UEXACT32_AMAP iscsiInstSsnCxnTimeoutErrors;
   BE_UEXACT32_AMAP iscsiInstSsnFormatErrors;
} SG_PACK BE_ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[3]; } ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_AMAP, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_AMAP;



typedef union {
   BE_ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_AMAP request;
   BE_ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_AMAP response;
} SG_PACK BE_ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_AMAP;
typedef struct { u32 dw[3]; } ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_AMAP, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_AMAP;
typedef struct { u32 dw[7]; } IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_AMAP, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS_AMAP;


// --- ISCSIPORTALROLES ---
// "A portal can operate in one or both of two roles: as a target portal and/or an
// initiator portal. If the portal will operate in both roles, both bits must be set. This
// object will define a corresponding row that will exist or must be created in the
// iscsiTgtPortalAttributesTable, the iscsiIntrPortalAttributesTable or both. If the
// targetTypePortal bit is set, one or more corresponding iscsiTgtPortalAttributesEntry
// rows will be found or created. If the initiatorTypePortal bit is set, one or more
// corresponding iscsiIntrPortalAttributesEntry rows will be found or created. If both
// bits are set, one or more corresponding rows will be found or created in one of the
// above tables." 
#define ISCSIPORTALROLES_TARGETTYPEPORTAL (0)     
#define ISCSIPORTALROLES_INITIATORTYPEPORTAL (1)  

typedef enum {
   ENUM_ISCSIPORTALROLES_TARGETTYPEPORTAL = 0x0UL,
   ENUM_ISCSIPORTALROLES_INITIATORTYPEPORTAL = 0x1UL
} ISCSIPORTALROLES;

// --- INETADDRESSTYPE ---
// "A value that represents a type of Internet address. unknown(0) An unknown address
// type. This value MUST be used if the value of the corresponding InetAddress object is a
// zero-length string. It may also be used to indicate an IP address that is not in one of
// the formats defined below. ipv4(1) An IPv4 address as defined by the InetAddressIPv4
// textual convention. ipv6(2) An IPv6 address as defined by the InetAddressIPv6 textual
// convention. ipv4z(3) A non-global IPv4 address including a zone index as defined by the
// InetAddressIPv4z textual convention. ipv6z(4) A non-global IPv6 address including a
// zone index as defined by the InetAddressIPv6z textual convention. dns(16) A DNS domain
// name as defined by the InetAddressDNS textual convention. Each definition of a concrete
// InetAddressType value must be accompanied by a definition of a textual convention for
// use with that InetAddressType. To support future extensions, the InetAddressType
// textual convention SHOULD NOT be sub-typed in object type definitions. It MAY be
// sub-typed in compliance statements in order to require only a subset of these address
// types for a compliant implementation. Implementations must ensure that InetAddressType
// objects and any dependent objects (e.g., InetAddress objects) are consistent. An
// inconsistentValue error must be generated if an attempt to change an InetAddressType
// object would, for example, lead to an undefined InetAddress value. In particular,
// InetAddressType/InetAddress pairs must be changed together if the address type changes
// (e.g., from ipv6(2) to ipv4(1))." 
#define INETADDRESSTYPE_UNKNOWN         (0)       
#define INETADDRESSTYPE_IPV4            (1)       
#define INETADDRESSTYPE_IPV6            (2)       
#define INETADDRESSTYPE_IPV4Z           (3)       
#define INETADDRESSTYPE_IPV6Z           (4)       
#define INETADDRESSTYPE_DNS             (16)      

typedef enum {
   ENUM_INETADDRESSTYPE_UNKNOWN = 0x0UL,
   ENUM_INETADDRESSTYPE_IPV4 = 0x1UL,
   ENUM_INETADDRESSTYPE_IPV6 = 0x2UL,
   ENUM_INETADDRESSTYPE_IPV4Z = 0x3UL,
   ENUM_INETADDRESSTYPE_IPV6Z = 0x4UL,
   ENUM_INETADDRESSTYPE_DNS = 0x10UL
} INETADDRESSTYPE;

// --- ISCSIDIGESTMETHOD ---
// "This data type represents the methods possible for digest negotiation. none - a
// placeholder for a secondary digest method that means only the primary method can be
// used. other - a digest method other than those defined below. noDigest - does not
// support digests (will operate without a digest (Note: implementations must support
// digests to be compliant with the RFC3720). CRC32c - require a CRC32C digest." 
#define ISCSIDIGESTMETHOD_NONE          (1)       
#define ISCSIDIGESTMETHOD_OTHER         (2)       
#define ISCSIDIGESTMETHOD_NODIGEST      (3)       
#define ISCSIDIGESTMETHOD_CRC32C        (4)       

typedef enum {
   ENUM_ISCSIDIGESTMETHOD_NONE = 0x1UL,
   ENUM_ISCSIDIGESTMETHOD_OTHER = 0x2UL,
   ENUM_ISCSIDIGESTMETHOD_NODIGEST = 0x3UL,
   ENUM_ISCSIDIGESTMETHOD_CRC32C = 0x4UL
} ISCSIDIGESTMETHOD;

// --- TRUTHVALUE ---
// "Represents a boolean value." 
#define TRUTHVALUE_TRUE                 (1)       
#define TRUTHVALUE_FALSE                (2)       

typedef enum {
   ENUM_TRUTHVALUE_TRUE = 0x1UL,
   ENUM_TRUTHVALUE_FALSE = 0x2UL
} TRUTHVALUE;

// --- STORAGETYPE ---
// "Describes the memory realization of a conceptual row. A row which is volatile(2) is
// lost upon reboot. A row which is either nonVolatile(3), permanent(4) or readOnly(5), is
// backed up by stable storage. A row which is permanent(4) can be changed but not
// deleted. A row which is readOnly(5) cannot be changed nor deleted. If the value of an
// object with this syntax is either permanent(4) or readOnly(5), it cannot be written.
// Conversely, if the value is either other(1), volatile(2) or nonVolatile(3), it cannot
// be modified to be permanent(4) or readOnly(5). (All illegal modifications result in a
// 'wrongValue' error.) Every usage of this textual convention is required to specify the
// columnar objects which a permanent(4) row must at a minimum allow to be writable." 
#define STORAGETYPE_OTHER               (1)       
#define STORAGETYPE_VOLATILE            (2)       
#define STORAGETYPE_NONVOLATILE         (3)       
#define STORAGETYPE_PERMANENT           (4)       
#define STORAGETYPE_READONLY            (5)       

typedef enum {
   ENUM_STORAGETYPE_OTHER = 0x1UL,
   ENUM_STORAGETYPE_VOLATILE = 0x2UL,
   ENUM_STORAGETYPE_NONVOLATILE = 0x3UL,
   ENUM_STORAGETYPE_PERMANENT = 0x4UL,
   ENUM_STORAGETYPE_READONLY = 0x5UL
} STORAGETYPE;

// --- ISCSINODEROLES ---
// "A node can operate in one or both of two roles: a target role and/or an initiator
// role. If the node will operate in both roles, both bits must be set. This object will
// also define the corresponding rows that will exist in the iscsiTargetAttributesTable,
// the iscsiInitiatorAttributesTable or both. If the targetTypeNode bit is set, there will
// be a corresponding iscsiTargetAttributesEntry. If the initiatorTypeNode bit is set,
// there will be a corresponding iscsiInitiatorAttributesEntry. If both bits are set,
// there will be a corresponding iscsiTgtPortalAttributesEntry and
// iscsiPortalAttributesEntry." 
#define ISCSINODEROLES_TARGETTYPENODE   (0)       
#define ISCSINODEROLES_INITIATORTYPENODE (1)      

typedef enum {
   ENUM_ISCSINODEROLES_TARGETTYPENODE = 0x0UL,
   ENUM_ISCSINODEROLES_INITIATORTYPENODE = 0x1UL
} ISCSINODEROLES;


typedef struct {
   BE_UEXACT32_AMAP tgt_key;
} SG_PACK BE_ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_AMAP, *PISCSI_TARGET_ATTRIBUTES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP iscsiTgtLoginFailures;
   BE_UEXACT32_AMAP iscsiTgtLastFailureTime;
   BE_EXACT8_AMAP iscsiTgtLastIntrFailureName[255];
   BE_UEXACT32_AMAP iscsiTgtLastIntrFailureAddrType;
   BE_IP_ADDRESS_FORMAT_AMAP iscsiTgtLastIntrFailureAddr;
} SG_PACK BE_ISCSI_TARGET_ATTRIBUTES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[73]; } ISCSI_TARGET_ATTRIBUTES_PARAMS_OUT_AMAP, *PISCSI_TARGET_ATTRIBUTES_PARAMS_OUT_AMAP;



typedef union {
   BE_ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_AMAP request;
   BE_ISCSI_TARGET_ATTRIBUTES_PARAMS_OUT_AMAP response;
} SG_PACK BE_ISCSI_TARGET_ATTRIBUTES_PARAMS_AMAP;
typedef struct { u32 dw[73]; } ISCSI_TARGET_ATTRIBUTES_PARAMS_AMAP, *PISCSI_TARGET_ATTRIBUTES_PARAMS_AMAP;


//  		  This IOCTL returns one of the following status values in the response  		  <ul> 		
//  <li>[link]MGMT_STATUS_SUCCESS[/link] 		  <li>[link]MGMT_STATUS_FAILED[/link] 		  </ul>
//  		  This IOCTL returns one of the following additional status values in the
// response<br>  		  <ul> 		  <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 		
//  </ul>   		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_TARGET_ATTRIBUTES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_AMAP;
typedef struct { u32 dw[77]; } IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_AMAP, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES_AMAP;



typedef struct {
   BE_UEXACT32_AMAP tgt_key;
} SG_PACK BE_ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_AMAP, *PISCSI_TARGET_LOGIN_STATS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP iscsiTgtLoginAccepts;
   BE_UEXACT32_AMAP iscsiTgtLoginOtherFails;
   BE_UEXACT32_AMAP iscsiTgtLoginRedirects;
   BE_UEXACT32_AMAP iscsiTgtLoginAuthorizeFails;
   BE_UEXACT32_AMAP iscsiTgtLoginAuthenticateFails;
   BE_UEXACT32_AMAP iscsiTgtLoginNegotiateFails;
   BE_UEXACT32_AMAP iscsiTgtLogoutNormals;
   BE_UEXACT32_AMAP iscsiTgtLogoutOthers;
} SG_PACK BE_ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[8]; } ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_AMAP, *PISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_AMAP;



typedef union {
   BE_ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_AMAP request;
   BE_ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_AMAP response;
} SG_PACK BE_ISCSI_TARGET_LOGIN_STATS_PARAMS_AMAP;
typedef struct { u32 dw[8]; } ISCSI_TARGET_LOGIN_STATS_PARAMS_AMAP, *PISCSI_TARGET_LOGIN_STATS_PARAMS_AMAP;


//  		  This IOCTL returns one of the following status values in the response  		  <ul> 		
//  <li>[link]MGMT_STATUS_SUCCESS[/link] 		  <li>[link]MGMT_STATUS_FAILED[/link] 		  </ul>
//  		  This IOCTL returns one of the following additional status values in the
// response<br>  		  <ul> 		  <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 		
//  </ul>   		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_TARGET_LOGIN_STATS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_AMAP;
typedef struct { u32 dw[12]; } IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_AMAP, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS_AMAP;


// --- ISCSISSNDIRECTION ---
// "Direction of iSCSI session: inboundSession - session is established from an external
// initiator to a target within this iSCSI instance. outboundSession - session is
// established from an initiator within this iSCSI instance to an external target." 
#define ISCSISSNDIRECTION_INBOUNDSESSION (1)      
#define ISCSISSNDIRECTION_OUTBOUNDSESSION (2)     

typedef enum {
   ENUM_ISCSISSNDIRECTION_INBOUNDSESSION = 0x1UL,
   ENUM_ISCSISSNDIRECTION_OUTBOUNDSESSION = 0x2UL
} ISCSISSNDIRECTION;

// --- ISCSISSNTYPE ---
// "Type of iSCSI session: normalSession - session is a normal iSCSI session
// discoverySession - session is being used only for discovery." 
#define ISCSISSNTYPE_NORMALSESSION      (1)       
#define ISCSISSNTYPE_DISCOVERYSESSION   (2)       

typedef enum {
   ENUM_ISCSISSNTYPE_NORMALSESSION = 0x1UL,
   ENUM_ISCSISSNTYPE_DISCOVERYSESSION = 0x2UL
} ISCSISSNTYPE;


typedef struct {
   BE_UEXACT32_AMAP session_id;
} SG_PACK BE_ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_AMAP, *PISCSI_SESSION_ATTRIBUTES_PARAMS_IN_AMAP;



typedef struct {
   BE_EXACT8_AMAP iscsiSsnInitiatorName[255];
   BE_EXACT8_AMAP iscsiSsnTargetName[255];
   BE_UEXACT32_AMAP iscsiSsnTSIH;
   BE_EXACT8_AMAP iscsiSsnISID[6];
   BE_EXACT8_AMAP iscsiSsnInitiatorAlias[255];
   BE_EXACT8_AMAP iscsiSsnTargetAlias[255];
   BE_UEXACT32_AMAP iscsiSsnInitialR2T;
   BE_UEXACT32_AMAP iscsiSsnImmediateData;
   BE_UEXACT32_AMAP iscsiSsnType;
   BE_UEXACT32_AMAP iscsiSsnMaxOutstandingR2T;
   BE_UEXACT32_AMAP iscsiSsnFirstBurstLength;
   BE_UEXACT32_AMAP iscsiSsnMaxBurstLength;
   BE_UEXACT32_AMAP iscsiSsnConnectionNumber;
   BE_UEXACT32_AMAP iscsiSsnDataSequenceInOrder;
   BE_UEXACT32_AMAP iscsiSsnDataPDUInOrder;
   BE_UEXACT32_AMAP iscsiSsnErrorRecoveryLevel;
   BE_UEXACT32_AMAP iscsiSsnDiscontinuityTime;
   BE_UEXACT32_AMAP iscsiSsnCmdPDUs;
   BE_UEXACT32_AMAP iscsiSsnRspPDUs;
   BE_UEXACT32_AMAP iscsiSsnTxDataOctets;
   BE_UEXACT32_AMAP iscsiSsnRxDataOctets;
} SG_PACK BE_ISCSI_SESSION_ATTRIBUTES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[273]; } ISCSI_SESSION_ATTRIBUTES_PARAMS_OUT_AMAP, *PISCSI_SESSION_ATTRIBUTES_PARAMS_OUT_AMAP;



typedef union {
   BE_ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_AMAP request;
   BE_ISCSI_SESSION_ATTRIBUTES_PARAMS_OUT_AMAP response;
} SG_PACK BE_ISCSI_SESSION_ATTRIBUTES_PARAMS_AMAP;
typedef struct { u32 dw[273]; } ISCSI_SESSION_ATTRIBUTES_PARAMS_AMAP, *PISCSI_SESSION_ATTRIBUTES_PARAMS_AMAP;


//  		  This IOCTL returns one of the following status values in the response  		  <ul> 		
//  <li>[link]MGMT_STATUS_SUCCESS[/link] 		  <li>[link]MGMT_STATUS_FAILED[/link] 		  </ul>
//  		  This IOCTL returns one of the following additional status values in the
// response<br>  		  <ul> 		  <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 		
//  </ul>   		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_SESSION_ATTRIBUTES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_AMAP;
typedef struct { u32 dw[277]; } IOCTL_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_AMAP, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS_AMAP;


// --- ISCSICXNSTATE ---
// "The current state of this connection, from an iSCSI negotiation point of view. Here
// are the states: login - The transport protocol connection has been established, but a
// valid iSCSI login response with the final bit set has not been sent or received. full -
// A valid iSCSI login response with the final bit set has been sent or received. logout -
// A valid iSCSI logout command has been sent or received, but the transport protocol
// connection has not yet been closed." 
#define ISCSICXNSTATE_LOGIN             (1)       
#define ISCSICXNSTATE_FULL              (2)       
#define ISCSICXNSTATE_LOGOUT            (3)       

typedef enum {
   ENUM_ISCSICXNSTATE_LOGIN = 0x1UL,
   ENUM_ISCSICXNSTATE_FULL = 0x2UL,
   ENUM_ISCSICXNSTATE_LOGOUT = 0x3UL
} ISCSICXNSTATE;


typedef struct {
   BE_UEXACT32_AMAP session_id;
   BE_UEXACT32_AMAP cid;
} SG_PACK BE_ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_AMAP, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP iscsiCxnCid;
   BE_UEXACT32_AMAP iscsiCxnState;
   BE_UEXACT32_AMAP iscsiCxnAddrType;
   BE_IP_ADDRESS_FORMAT_AMAP iscsiCxnLocalAddr;
   BE_UEXACT16_AMAP iscsiCxnProtocol;
   BE_UEXACT16_AMAP iscsiCxnLocalPort;
   BE_IP_ADDRESS_FORMAT_AMAP iscsiCxnRemoteAddr;
   BE_UEXACT16_AMAP iscsiCxnRemotePort;
   BE_UEXACT32_AMAP iscsiCxnMaxRecvDataSegLength;
   BE_UEXACT32_AMAP iscsiCxnMaxXmitDataSegLength;
   BE_UEXACT32_AMAP iscsiCxnHeaderIntegrity;
   BE_UEXACT32_AMAP iscsiCxnDataIntegrity;
   BE_UEXACT32_AMAP iscsiCxnRecvMarker;
   BE_UEXACT32_AMAP iscsiCxnSendMarker;
   BE_UEXACT32_AMAP iscsiCxnVersionActive;
   BE_UEXACT32_AMAP iscsiSsnCxnDigestErrors;
   BE_UEXACT32_AMAP iscsiSsnCxnTimeoutErrors;
} SG_PACK BE_ISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[26]; } ISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT_AMAP, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT_AMAP;



typedef union {
   BE_ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_AMAP request;
   BE_ISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT_AMAP response;
} SG_PACK BE_ISCSI_CONNECTION_ATTRIBUTES_PARAMS_AMAP;
typedef struct { u32 dw[26]; } ISCSI_CONNECTION_ATTRIBUTES_PARAMS_AMAP, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_CONNECTION_ATTRIBUTES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_AMAP;
typedef struct { u32 dw[30]; } IOCTL_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_AMAP, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
} SG_PACK BE_MILI_GET_SESSION_LIST_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } MILI_GET_SESSION_LIST_PARAMS_IN_AMAP, *PMILI_GET_SESSION_LIST_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_id;
   BE_UEXACT32_AMAP pgtag;
   BE_UEXACT32_AMAP num_cid;
   BE_UEXACT32_AMAP cids[4];
   BE_UEXACT32_AMAP portalkeys[4];
} SG_PACK BE_session_info_AMAP;
typedef struct { u32 dw[11]; } session_info_AMAP, *Psession_info_AMAP;



typedef struct {
   BE_UEXACT32_AMAP num_sessions;
   BE_session_info_AMAP session_list[1024];
} SG_PACK BE_MILI_GET_SESSION_LIST_PARAMS_OUT_AMAP;
typedef struct { u32 dw[11265]; } MILI_GET_SESSION_LIST_PARAMS_OUT_AMAP, *PMILI_GET_SESSION_LIST_PARAMS_OUT_AMAP;



typedef union {
   BE_MILI_GET_SESSION_LIST_PARAMS_IN_AMAP request;
   BE_MILI_GET_SESSION_LIST_PARAMS_OUT_AMAP response;
} SG_PACK BE_MILI_GET_SESSION_LIST_PARAMS_AMAP;
typedef struct { u32 dw[11265]; } MILI_GET_SESSION_LIST_PARAMS_AMAP, *PMILI_GET_SESSION_LIST_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MILI_GET_SESSION_LIST_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_MILI_PTL_GET_ISCSI_SESSION_LIST_AMAP;
typedef struct { u32 dw[11269]; } IOCTL_MILI_PTL_GET_ISCSI_SESSION_LIST_AMAP, *PIOCTL_MILI_PTL_GET_ISCSI_SESSION_LIST_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
   BE_UEXACT32_AMAP session_id;
} SG_PACK BE_MILI_PTL_KILL_SESSION_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } MILI_PTL_KILL_SESSION_PARAMS_IN_AMAP, *PMILI_PTL_KILL_SESSION_PARAMS_IN_AMAP;



typedef union {
   BE_MILI_PTL_KILL_SESSION_PARAMS_IN_AMAP request;
} SG_PACK BE_MILI_PTL_KILL_SESSION_PARAMS_AMAP;
typedef struct { u32 dw[2]; } MILI_PTL_KILL_SESSION_PARAMS_AMAP, *PMILI_PTL_KILL_SESSION_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MILI_PTL_KILL_SESSION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_MILI_PTL_KILL_SESSION_AMAP;
typedef struct { u32 dw[6]; } IOCTL_MILI_PTL_KILL_SESSION_AMAP, *PIOCTL_MILI_PTL_KILL_SESSION_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_mili_ptl_amap_h__

