/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_mili_tmd_amap_h__
#define __ioctl_mili_tmd_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT32_AMAP target_key;
   BE_UEXACT8_AMAP target_name[224];
   BE_UEXACT8_AMAP target_alias[224];
   BE_UEXACT8_AMAP auth_method_type;
   BE_UEXACT8_AMAP pad[3];
   BE_MGMT_CHAP_NAME_SECRET_AMAP target_chap;
} SG_PACK BE_IOCTL_MILI_TMD_ADD_TARGET_IN_AMAP;
typedef struct { u32 dw[183]; } IOCTL_MILI_TMD_ADD_TARGET_IN_AMAP, *PIOCTL_MILI_TMD_ADD_TARGET_IN_AMAP;


//             Add Target instance with specified iSCSI name and alias.            This
// IOCTL returns one of the following status values in the response                  <ul> 
//                    <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	   NOTE:
// these additional status codes are based on reference TMD.<br> 	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDL_STATUS_DUPLICATE_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link> 	  
// <li><link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 	</ul>          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_ADD_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_ADD_TARGET_AMAP;
typedef struct { u32 dw[187]; } IOCTL_MILI_TMD_ADD_TARGET_AMAP, *PIOCTL_MILI_TMD_ADD_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
   BE_UEXACT8_AMAP target_name[224];
} SG_PACK BE_IOCTL_MILI_TMD_DELETE_TARGET_IN_AMAP;
typedef struct { u32 dw[57]; } IOCTL_MILI_TMD_DELETE_TARGET_IN_AMAP, *PIOCTL_MILI_TMD_DELETE_TARGET_IN_AMAP;


//              Removes an iSCSI target instance. MILI should make sure that target is    
//          not bound to initiators or LUN maps.            This IOCTL returns one of the
// following status values in the response                  <ul>                    
// <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	   NOTE:
// these additional status codes are based on reference TMD.<br> 	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 	</ul>          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_DELETE_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_DELETE_TARGET_AMAP;
typedef struct { u32 dw[61]; } IOCTL_MILI_TMD_DELETE_TARGET_AMAP, *PIOCTL_MILI_TMD_DELETE_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
   BE_UEXACT8_AMAP auth_method_type;
   BE_UEXACT8_AMAP pad[3];
   BE_MGMT_CHAP_NAME_SECRET_AMAP target_chap;
} SG_PACK BE_IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_AMAP;
typedef struct { u32 dw[71]; } IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_AMAP, *PIOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_AMAP;


//                  Update the authentication parameters for a Target.             This
// IOCTL returns one of the following status values in the response                  <ul> 
//                    <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	   NOTE:
// these additional status codes are based on reference TMD.<br> 	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 	</ul>               
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_AMAP;
typedef struct { u32 dw[75]; } IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_AMAP, *PIOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP initiator_key;
   BE_UEXACT8_AMAP initiator_name[224];
   BE_UEXACT8_AMAP initiator_alias[224];
   BE_UEXACT32_AMAP initiator_chap_secret_enabled;
   BE_MGMT_CHAP_NAME_SECRET_AMAP initiator_chap;
} SG_PACK BE_IOCTL_MILI_TMD_ADD_INITIATOR_IN_AMAP;
typedef struct { u32 dw[183]; } IOCTL_MILI_TMD_ADD_INITIATOR_IN_AMAP, *PIOCTL_MILI_TMD_ADD_INITIATOR_IN_AMAP;


//             Add an Initiator. Bind this to one or more targets using
// [link]IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET[/link].            This IOCTL returns one
// of the following status values in the response                  <ul>                   
//  <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	   NOTE:
// these additional status codes are based on reference TMD.<br> 	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDL_STATUS_DUPLICATE_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link> 	  
// <li><link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 	</ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_ADD_INITIATOR_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_ADD_INITIATOR_AMAP;
typedef struct { u32 dw[187]; } IOCTL_MILI_TMD_ADD_INITIATOR_AMAP, *PIOCTL_MILI_TMD_ADD_INITIATOR_AMAP;



typedef struct {
   BE_UEXACT32_AMAP initiator_key;
   BE_UEXACT8_AMAP initiator_name[224];
} SG_PACK BE_IOCTL_MILI_TMD_DELETE_INITIATOR_IN_AMAP;
typedef struct { u32 dw[57]; } IOCTL_MILI_TMD_DELETE_INITIATOR_IN_AMAP, *PIOCTL_MILI_TMD_DELETE_INITIATOR_IN_AMAP;


//              Remove Initiator. TMD deletes the initiator.              MILI should make
// sure that no target or LUN maps are bound to the initiator.     	This IOCTL returns one
// of the following status values in the response                  <ul>                   
//  <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	   NOTE:
// these additional status codes are based on reference TMD.<br> 	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_INITIATOR_HANDLE_NOT_FOUND</link> 	</ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_DELETE_INITIATOR_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_DELETE_INITIATOR_AMAP;
typedef struct { u32 dw[61]; } IOCTL_MILI_TMD_DELETE_INITIATOR_AMAP, *PIOCTL_MILI_TMD_DELETE_INITIATOR_AMAP;



typedef struct {
   BE_UEXACT32_AMAP initiator_key;
   BE_UEXACT32_AMAP initiator_chap_secret_enabled;
   BE_MGMT_CHAP_NAME_SECRET_AMAP initiator_chap;
} SG_PACK BE_IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_AMAP;
typedef struct { u32 dw[71]; } IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_AMAP, *PIOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_AMAP;


//             Update the Initiators authentication parameters after an initiator has
// already been added. This IOCTL            may also be used to disable mutual
// authentication between this initiator and a target.    	This IOCTL returns one of the
// following status values in the response                  <ul>                    
// <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	   NOTE:
// these additional status codes are based on reference TMD.<br> 	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_INITIATOR_HANDLE_NOT_FOUND</link> 	</ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_AMAP;
typedef struct { u32 dw[75]; } IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_AMAP, *PIOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_AMAP;


// --- IT_CHAP ---
#define IT_CHAP_DISABLED                (0)       // Initiator-specific secret not
                                                  // required for 1-way CHAP. Use name and
                                                  // secret specified during Target
                                                  // creation IOCTL_MILI_TMD_ADD_TARGET 
#define IT_CHAP_ENABLED                 (1)       // Initiator-specific CHAP name and
                                                  // secret enabled for 1-way CHAP. This
                                                  // flag is effective only when
                                                  // auth_method_type is set to
                                                  // MGMT_AUTH_TYPE_CHAP in
                                                  // IOCTL_MILI_TMD_ADD_TARGET 

typedef enum {
   ENUM_IT_CHAP_DISABLED = 0x0UL,
   ENUM_IT_CHAP_ENABLED = 0x1UL
} IT_CHAP;


typedef struct {
   BE_UEXACT32_AMAP it_nexus_key;
   BE_UEXACT32_AMAP initiator_key;
   BE_UEXACT32_AMAP target_key;
   BE_UEXACT8_AMAP lun_map_name[224];
   BE_UEXACT8_AMAP it_nexus_name[224];
   BE_UEXACT8_AMAP initiator_specific_target_chap;
   BE_UEXACT8_AMAP pad[3];
   BE_MGMT_CHAP_NAME_SECRET_AMAP target_chap;
} SG_PACK BE_IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_AMAP;
typedef struct { u32 dw[185]; } IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_AMAP, *PIOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_AMAP;


//              Create Initiator-Target binding (nexus) and identify the  nexus with a
// key.             Note that 'nexus' in this context refers to             This IOCTL
// returns one of the following status values in the response                  <ul>       
//              <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	   NOTE:
// these additional status codes are based on reference TMD.<br> 	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link> 	  
// <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 	  
// <li><link>MGMT_ADDI_STATUS_INITIATOR_HANDLE_NOT_FOUND</link> 	  
// <li><link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 	</ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_AMAP;
typedef struct { u32 dw[189]; } IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_AMAP, *PIOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP it_nexus_key;
   BE_UEXACT8_AMAP it_nexus_name[224];
} SG_PACK BE_IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_AMAP;
typedef struct { u32 dw[57]; } IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_AMAP, *PIOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_AMAP;


//              Delete IT. MILI should make sure that IT nexus is not bound to any LUN
// map. 	This IOCTL returns one of the following status values in the response            
//      <ul>                     <li>[link]MGMT_STATUS_SUCCESS[/link]                    
// <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	   NOTE:
// these additional status codes are based on reference TMD.<br> 	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_ITBINDING_HANDLE_NOT_FOUND</link> 	</ul>            
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_DELETE_IT_BINDING_AMAP;
typedef struct { u32 dw[61]; } IOCTL_MILI_TMD_DELETE_IT_BINDING_AMAP, *PIOCTL_MILI_TMD_DELETE_IT_BINDING_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
} SG_PACK BE_IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_AMAP, *PIOCTL_MILI_TMD_ACTIVATE_TARGET_IN_AMAP;


//              This IOCTL notifies TMD that configuration for the specified target is
// complete. PTL will             notify the TMD upon receiving Login requests for this
// Target. 	This IOCTL returns one of the following status values in the response         
//         <ul>                     <li>[link]MGMT_STATUS_SUCCESS[/link]                  
//   <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This IOCTL
// returns one of the following additional status values in the response<br>  	   NOTE:
// these additional status codes are based on reference TMD.<br> 	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 	</ul>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_ACTIVATE_TARGET_AMAP;
typedef struct { u32 dw[5]; } IOCTL_MILI_TMD_ACTIVATE_TARGET_AMAP, *PIOCTL_MILI_TMD_ACTIVATE_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_key;
} SG_PACK BE_IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_AMAP, *PIOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_AMAP;


//              Once deactivated, this target will no longer entertain any login requests
// from Initiators. 	This IOCTL returns one of the following status values in the response
//                  <ul>                     <li>[link]MGMT_STATUS_SUCCESS[/link]         
//            <li>[link]MGMT_STATUS_FAILED[/link]                 </ul>             This
// IOCTL returns one of the following additional status values in the response<br>  	  
// NOTE: these additional status codes are based on reference TMD.<br> 	<ul> 	  
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link> 	  
// <li><link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 	</ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_DEACTIVATE_TARGET_AMAP;
typedef struct { u32 dw[5]; } IOCTL_MILI_TMD_DEACTIVATE_TARGET_AMAP, *PIOCTL_MILI_TMD_DEACTIVATE_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP initiator_key;
   BE_UEXACT8_AMAP QoS_category;
   BE_UEXACT8_AMAP pad1[3];
} SG_PACK BE_IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_AMAP;
typedef struct { u32 dw[2]; } IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_AMAP, *PIOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_AMAP;


//              Assigns a QoS category for a specific Initiator. Sessions between this
// Initiator and             any Target instance will share this bandwidth defined by this
// category. The TMD should             communicate this Qos category to PTL through a
// PTL-TMD API. QoS categories can be changed             at run time. By default all
// Initiators and sessions are assigned to QoS category 0.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_AMAP request;
} SG_PACK BE_IOCTL_MILI_TMD_SET_INITIATOR_QOS_AMAP;
typedef struct { u32 dw[6]; } IOCTL_MILI_TMD_SET_INITIATOR_QOS_AMAP, *PIOCTL_MILI_TMD_SET_INITIATOR_QOS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_mili_tmd_amap_h__

