/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_pxe_undi_amap_h__
#define __ioctl_pxe_undi_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- UNDI_OP_TYPE ---
#define UNDI_START                      (0)       // Create an UNDI Task; No other UNDI
                                                  // IOCTLs will be processed until this
                                                  // IOCTL.
#define UNDI_STOP                       (1)       // Kill the UNDI Task. An UNDI_START
                                                  // must be issued after this to process
                                                  // further UNDI IOCTLs. All UNDI
                                                  // parameters (MCAST list, MAC address,
                                                  // Filter and statistics) are cleared 
#define UNDI_INITIALIZE                 (2)       // This call resets the adapter and
                                                  // programs it with default parameters.
                                                  // All settings (MCAST list, MAC
                                                  // address, Filters and statistics) are
                                                  // cleared. 
#define UNDI_SHUTDOWN                   (3)       // This call resets the network adapter
                                                  // and leaves it in a safe state for
                                                  // another driver to program it.
#define UNDI_OPEN                       (4)       // This IOCTL sets the adapter ready to
                                                  // accept packets for transmit and
                                                  // receive. No UNDI_Transmit or
                                                  // UNDI_Receive IOCTLs will be processed
                                                  // until this IOCTL.
#define UNDI_CLOSE                      (5)       // This IOCTL disconnects the network
                                                  // adapter from the network. Packets
                                                  // cannot be transmitted or received
                                                  // until the network adapter is open
                                                  // again. No UNDI_Transmit or
                                                  // UNDI_Receive IOCTLs can be issued
                                                  // after this IOCTL. 
#define UNDI_SET_FILTER                 (6)       // Set the new receive filter. 

typedef enum {
   ENUM_UNDI_START = 0x0UL,
   ENUM_UNDI_STOP = 0x1UL,
   ENUM_UNDI_INITIALIZE = 0x2UL,
   ENUM_UNDI_SHUTDOWN = 0x3UL,
   ENUM_UNDI_OPEN = 0x4UL,
   ENUM_UNDI_CLOSE = 0x5UL,
   ENUM_UNDI_SET_FILTER = 0x6UL
} UNDI_OP_TYPE;

// --- UNDI_FILTER ---
#define FLTR_DIRECTED                   (1)       
#define FLTR_BRDCST                     (2)       
#define FLTR_PRMSCS                     (4)       
#define FLTR_SRC_RTG                    (8)       // Source Routing 

typedef enum {
   ENUM_FLTR_DIRECTED = 0x1UL,
   ENUM_FLTR_BRDCST = 0x2UL,
   ENUM_FLTR_PRMSCS = 0x4UL,
   ENUM_FLTR_SRC_RTG = 0x8UL
} UNDI_FILTER;

// --- UNDI_FILTER_TYPE ---
#define UNDI_FLTR_DIRECTED              (1)       
#define UNDI_FLTR_BRDCST                (2)       
#define UNDI_FLTR_PRMSCS                (4)       
#define UNDI_FLTR_SRC_RTG               (8)       

typedef enum {
   ENUM_UNDI_FLTR_DIRECTED = 0x1UL,
   ENUM_UNDI_FLTR_BRDCST = 0x2UL,
   ENUM_UNDI_FLTR_PRMSCS = 0x4UL,
   ENUM_UNDI_FLTR_SRC_RTG = 0x8UL
} UNDI_FILTER_TYPE;

// --- UNDI_VLAN_STATUS ---
#define UNDI_VLAN_DISABLED              (0)       
#define UNDI_VLAN_ENABLED               (1)       

typedef enum {
   ENUM_UNDI_VLAN_DISABLED = 0x0UL,
   ENUM_UNDI_VLAN_ENABLED = 0x1UL
} UNDI_VLAN_STATUS;


typedef struct {
   BE_UEXACT32_AMAP op_type;
   BE_UEXACT32_AMAP filter;
} SG_PACK BE_UNDI_CONTROL_IN_AMAP;
typedef struct { u32 dw[2]; } UNDI_CONTROL_IN_AMAP, *PUNDI_CONTROL_IN_AMAP;



typedef union {
   BE_UNDI_CONTROL_IN_AMAP request;
} SG_PACK BE_UNDI_CONTROL_PARAMS_AMAP;
typedef struct { u32 dw[2]; } UNDI_CONTROL_PARAMS_AMAP, *PUNDI_CONTROL_PARAMS_AMAP;


//  		    This IOCTL controls the start/stop of UNDI and setting its various filters.
// There are  			no output parameters. The status is available in the IOCTL header. 		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_UNDI_CONTROL_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_PXE_UNDI_CONTROL_AMAP;
typedef struct { u32 dw[6]; } IOCTL_PXE_UNDI_CONTROL_AMAP, *PIOCTL_PXE_UNDI_CONTROL_AMAP;



typedef struct {
   BE_UEXACT16_AMAP transmit_length;
   BE_UEXACT16_AMAP padding;
   BE_UEXACT64_AMAP TBA;
} SG_PACK BE_UNDI_TRANSMIT_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } UNDI_TRANSMIT_PARAMS_IN_AMAP, *PUNDI_TRANSMIT_PARAMS_IN_AMAP;



typedef union {
   BE_UEXACT16_AMAP actual_length;
} SG_PACK BE_UNDI_TRANSMIT_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } UNDI_TRANSMIT_PARAMS_OUT_AMAP, *PUNDI_TRANSMIT_PARAMS_OUT_AMAP;



typedef union {
   BE_UNDI_TRANSMIT_PARAMS_IN_AMAP request;
   BE_UNDI_TRANSMIT_PARAMS_OUT_AMAP response;
} SG_PACK BE_UNDI_TRANSMIT_PARAMS_AMAP;
typedef struct { u32 dw[3]; } UNDI_TRANSMIT_PARAMS_AMAP, *PUNDI_TRANSMIT_PARAMS_AMAP;


//  			The IOCTL will send a NIC packet to a specified port. 			The transmit buffer should
// inlcude MAC headers.  		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_UNDI_TRANSMIT_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_PXE_UNDI_TRANSMIT_AMAP;
typedef struct { u32 dw[7]; } IOCTL_PXE_UNDI_TRANSMIT_AMAP, *PIOCTL_PXE_UNDI_TRANSMIT_AMAP;



typedef struct {
   BE_UEXACT16_AMAP buffer_length;
   BE_UEXACT16_AMAP padding;
   BE_UEXACT64_AMAP RBA;
} SG_PACK BE_UNDI_RECEIVE_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } UNDI_RECEIVE_PARAMS_IN_AMAP, *PUNDI_RECEIVE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT16_AMAP frame_length;
   BE_UEXACT16_AMAP more;
} SG_PACK BE_UNDI_RECEIVE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } UNDI_RECEIVE_PARAMS_OUT_AMAP, *PUNDI_RECEIVE_PARAMS_OUT_AMAP;



typedef union {
   BE_UNDI_RECEIVE_PARAMS_IN_AMAP request;
   BE_UNDI_RECEIVE_PARAMS_OUT_AMAP response;
} SG_PACK BE_UNDI_RECEIVE_PARAMS_AMAP;
typedef struct { u32 dw[3]; } UNDI_RECEIVE_PARAMS_AMAP, *PUNDI_RECEIVE_PARAMS_AMAP;


//  			This IOCTL is used to receive one NIC frame at a time. 			The received buffer
// includes MAC headers.. 		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_UNDI_RECEIVE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_PXE_UNDI_RECEIVE_AMAP;
typedef struct { u32 dw[7]; } IOCTL_PXE_UNDI_RECEIVE_AMAP, *PIOCTL_PXE_UNDI_RECEIVE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP clear_flag;
} SG_PACK BE_UNDI_GET_STATISTICS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } UNDI_GET_STATISTICS_PARAMS_IN_AMAP, *PUNDI_GET_STATISTICS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT64_AMAP transmit_good_frames;
   BE_UEXACT64_AMAP recv_good_frames;
   BE_UEXACT64_AMAP recv_CRC_errors;
   BE_UEXACT64_AMAP recv_resource_errors;
} SG_PACK BE_UNDI_GET_STATISTICS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[8]; } UNDI_GET_STATISTICS_PARAMS_OUT_AMAP, *PUNDI_GET_STATISTICS_PARAMS_OUT_AMAP;



typedef union {
   BE_UNDI_GET_STATISTICS_PARAMS_IN_AMAP request;
   BE_UNDI_GET_STATISTICS_PARAMS_OUT_AMAP response;
} SG_PACK BE_UNDI_GET_STATISTICS_PARAMS_AMAP;
typedef struct { u32 dw[8]; } UNDI_GET_STATISTICS_PARAMS_AMAP, *PUNDI_GET_STATISTICS_PARAMS_AMAP;


//  			The IOCTL will get/clear UNDI statistics. 		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_UNDI_GET_STATISTICS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_PXE_UNDI_GET_STATISTICS_AMAP;
typedef struct { u32 dw[12]; } IOCTL_PXE_UNDI_GET_STATISTICS_AMAP, *PIOCTL_PXE_UNDI_GET_STATISTICS_AMAP;



typedef struct {
   BE_UEXACT8_AMAP vlan_enable;
   BE_UEXACT8_AMAP vlan_priority;
   BE_UEXACT16_AMAP vlan_id;
} SG_PACK BE_UNDI_SET_VLAN_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } UNDI_SET_VLAN_PARAMS_IN_AMAP, *PUNDI_SET_VLAN_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_UNDI_SET_VLAN_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } UNDI_SET_VLAN_PARAMS_OUT_AMAP, *PUNDI_SET_VLAN_PARAMS_OUT_AMAP;



typedef union {
   BE_UNDI_SET_VLAN_PARAMS_IN_AMAP request;
   BE_UNDI_SET_VLAN_PARAMS_OUT_AMAP response;
} SG_PACK BE_UNDI_SET_VLAN_PARAMS_AMAP;
typedef struct { u32 dw[1]; } UNDI_SET_VLAN_PARAMS_AMAP, *PUNDI_SET_VLAN_PARAMS_AMAP;


//  			This IOCTL is used to set the Vlan Status, VLAN Tag  			and Priority for the UNDI
// NIC Function. 		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_UNDI_SET_VLAN_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_PXE_UNDI_SET_VLAN_AMAP;
typedef struct { u32 dw[5]; } IOCTL_PXE_UNDI_SET_VLAN_AMAP, *PIOCTL_PXE_UNDI_SET_VLAN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_UNDI_GET_VLAN_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } UNDI_GET_VLAN_PARAMS_IN_AMAP, *PUNDI_GET_VLAN_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP vlan_enable;
   BE_UEXACT8_AMAP vlan_priority;
   BE_UEXACT16_AMAP vlan_id;
} SG_PACK BE_UNDI_GET_VLAN_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } UNDI_GET_VLAN_PARAMS_OUT_AMAP, *PUNDI_GET_VLAN_PARAMS_OUT_AMAP;



typedef union {
   BE_UNDI_GET_VLAN_PARAMS_IN_AMAP request;
   BE_UNDI_GET_VLAN_PARAMS_OUT_AMAP response;
} SG_PACK BE_UNDI_GET_VLAN_PARAMS_AMAP;
typedef struct { u32 dw[1]; } UNDI_GET_VLAN_PARAMS_AMAP, *PUNDI_GET_VLAN_PARAMS_AMAP;


//  			This IOCTL is used to get the Vlan Status, VLAN Tag  			and Priority for the UNDI
// NIC Function. 		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_UNDI_GET_VLAN_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_PXE_UNDI_GET_VLAN_AMAP;
typedef struct { u32 dw[5]; } IOCTL_PXE_UNDI_GET_VLAN_AMAP, *PIOCTL_PXE_UNDI_GET_VLAN_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_pxe_undi_amap_h__

