/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_toe_amap_h__
#define __ioctl_toe_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"
#include "ioctl_common.h"
#include "fw_exp.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
//              Offloads a connection.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_UEXACT16_AMAP ip_version;
         BE_MPU_TEMPLATE_HEADER_AMAP header;
         BE_TCP_CONTEXT_AMAP tcp;
         BE_TOE_CONTEXT_AMAP context;
         BE_MPU_OFFLOAD_CXN_ENTRY_AMAP filter;
         BE_UEXACT32_AMAP ka_probe_count;
         BE_UEXACT32_AMAP ka_timeout_delta;
         BE_UEXACT16_AMAP dq_id;
         BE_BIT rsvd0[16];                        // DWORD 99
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_TOE_CONNECTION_OFFLOAD_AMAP;
typedef struct { u32 dw[100]; } IOCTL_TOE_CONNECTION_OFFLOAD_AMAP, *PIOCTL_TOE_CONNECTION_OFFLOAD_AMAP;


//              Uploads a given connection. Updates the template header and            
// TCP state for an offloaded connection.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_UEXACT8_AMAP hdr_len;
         BE_BIT rsvd0[8];                         // DWORD 4
         BE_TCP_UPDATE_DATA_AMAP update_data;
         BE_MPU_TEMPLATE_HEADER_AMAP header;
         BE_UEXACT32_AMAP recv_bufsize;
         BE_UEXACT32_AMAP window_reduction;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_TOE_CONNECTION_UPDATE_AMAP;
typedef struct { u32 dw[41]; } IOCTL_TOE_CONNECTION_UPDATE_AMAP, *PIOCTL_TOE_CONNECTION_UPDATE_AMAP;


//              Returns the current TCP state for the offloaded connection.            
// Most likely the caller will disable the offloaded connection before            
// querying the state.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_TCP_CONTEXT_AMAP tcp;
      } response;
   } params;
} SG_PACK BE_IOCTL_TOE_CONNECTION_QUERY_AMAP;
typedef struct { u32 dw[36]; } IOCTL_TOE_CONNECTION_QUERY_AMAP, *PIOCTL_TOE_CONNECTION_QUERY_AMAP;


//  		    This structure has all the IP Fragmentation/Reassembly  		    Stats (per port)
// filled in by the ARM. 		
typedef struct {
   BE_UEXACT32_AMAP ipv4ReassembledPackets;
   BE_UEXACT32_AMAP ipv4Fragmentation;
   BE_UEXACT32_AMAP ipv4FragmentedPduCreates;
   BE_UEXACT32_AMAP ipv4OverlappedFragCount;
   BE_UEXACT32_AMAP ipv4OutOfOrderFragCount;
   BE_UEXACT32_AMAP ipv4ReassemblyTimeout;
   BE_UEXACT32_AMAP ipv6ReassembledPackets;
   BE_UEXACT32_AMAP ipv6Fragmentation;
   BE_UEXACT32_AMAP ipv6FragmentedPduCreates;
   BE_UEXACT32_AMAP ipv6OverlappedFragCount;
   BE_UEXACT32_AMAP ipv6OutofOrderFragCount;
   BE_UEXACT32_AMAP ipv6ReassemblyTimeout;
} SG_PACK BE_BE_TOERX_MISC_STATS_AMAP;
typedef struct { u32 dw[12]; } BE_TOERX_MISC_STATS_AMAP, *PBE_TOERX_MISC_STATS_AMAP;



typedef struct {
   BE_BE_TOERX_STATS_AMAP rx;
   BE_BE_TOETX_STATS_AMAP tx;
} SG_PACK BE_BE_TOE_STATS_AMAP;
typedef struct { u32 dw[512]; } BE_TOE_STATS_AMAP, *PBE_TOE_STATS_AMAP;



typedef union {
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } request;
   struct {
      BE_BE_TOE_STATS_AMAP chute[3];
      BE_UEXACT32_AMAP toe_ulp_mask;
      BE_BE_TOERX_MISC_STATS_AMAP rx_misc[2];
   } response;
} SG_PACK BE_TOE_GET_STATISTICS_PARAMS_AMAP;
typedef struct { u32 dw[1561]; } TOE_GET_STATISTICS_PARAMS_AMAP, *PTOE_GET_STATISTICS_PARAMS_AMAP;


//               Returns TOE-related statistics accross BladeEngine.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_TOE_GET_STATISTICS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_TOE_GET_STATISTICS_AMAP;
typedef struct { u32 dw[1565]; } IOCTL_TOE_GET_STATISTICS_AMAP, *PIOCTL_TOE_GET_STATISTICS_AMAP;


//              IOCTL for creating TOE default buffer ring.              <P>             A
// TOE default buffer queue contains [link]TOE_DEFBUFFER[/link] entries (8 bytes each).   
//          A TOE default buffer ring must be at least 512 entries deep (corresponding to
// 1 page) and             at most 1k entries deep (corresponding to 2 pages).         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_UEXACT8_AMAP ulp_num;
         BE_BIT rsvd0[8];                         // DWORD 4
         BE_TOE_DEFAULT_BUFFER_AMAP context;
         BE_PHYS_ADDR_AMAP pages[8];
      } request;
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_TOE_DEFQ_CREATE_AMAP;
typedef struct { u32 dw[37]; } IOCTL_TOE_DEFQ_CREATE_AMAP, *PIOCTL_TOE_DEFQ_CREATE_AMAP;


//          IOCTL for creating TOE transmit ring.          <P>A TOE transmit ring contains
// [link]TOE_WRB[/link] entries (16 bytes each).         The ring must be at least 256
// entries deep (corresponding to 1 page) and         at most 2k entries deep
// (corresponding to 8 pages). When the connection is offloaded,         the encoded ring
// size in the context must result in a ring fitting within the number of         pages
// posted with this IOCTL.                      <P>The IOCTL may fail with the following
// status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the request parameter at the
// byte offset specified in the additional status response is invalid.         </LI>      
//   <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]              -- the client is not
// authorized to create this ring type.         </LI>        
// <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]              -- this ring type is
// either unavailable or all rings are already created.         </LI>         </UL>       
//  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_UEXACT8_AMAP ulp_num;
         BE_BIT rsvd0[8];                         // DWORD 4
         BE_PHYS_ADDR_AMAP pages[8];
      } request;
      struct {
         BE_UEXACT16_AMAP cid;
         BE_BIT rsvd0[16];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_TOE_WRBQ_CREATE_AMAP;
typedef struct { u32 dw[21]; } IOCTL_TOE_WRBQ_CREATE_AMAP, *PIOCTL_TOE_WRBQ_CREATE_AMAP;


//          IOCTL for creating TOE preposted receive buffer ring for a given connection
// id.          <P>         A TOE preposted buffer receive ring can only be created after
// a TOE transmit ring         is successfuly created.         A TOE receive queue
// contains [link]TOE_PREBUFFER[/link] entries (16 bytes each).         A TOE receive
// queue must be at least 256 entries deep (corresponding to 1 page) and         at most
// 1k entries deep (corresponding to 4 pages). When the connection is offloaded,        
// the encoded ring size in the context must result in a ring fitting within the number of
//         pages posted with this IOCTL.                  <P>The IOCTL may fail with the
// following status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the request parameter at the
// byte offset specified in the additional status response is invalid.         </LI>      
//   <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]              -- the client is not
// authorized to create this ring type.         </LI>        
// <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]              -- this ring type is
// either unavailable or all rings are already created.         </LI>         </UL>       
//  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_UEXACT16_AMAP num_pages;
         BE_PHYS_ADDR_AMAP pages[8];
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_TOE_RQ_CREATE_AMAP;
typedef struct { u32 dw[21]; } IOCTL_TOE_RQ_CREATE_AMAP, *PIOCTL_TOE_RQ_CREATE_AMAP;


//              IOCTL for destroying a TOE transmit ring. The connection must be uploaded
// prior to             destroying the ring. If TOE preposted receive buffer ring was
// created in tandem with the             TOE transmit ring, the receive buffer ring must
// be destroyed first.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_TOE_WRBQ_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_TOE_WRBQ_DESTROY_AMAP, *PIOCTL_TOE_WRBQ_DESTROY_AMAP;


//              IOCTL for destroying a TOE preposted buffer receive ring. The connection
// must be uploaded prior to             destroying the ring.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_TOE_RQ_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_TOE_RQ_DESTROY_AMAP, *PIOCTL_TOE_RQ_DESTROY_AMAP;


//              IOCTL for destroying a TOE default buffer receive ring. All TOE
// connections associated             with the default buffer receive ring must be
// uploaded prior to destroying the ring.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_TOE_DEFQ_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_TOE_DEFQ_DESTROY_AMAP, *PIOCTL_TOE_DEFQ_DESTROY_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_toe_amap_h__

