/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_types_amap_h__
#define __ioctl_types_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_defs.h"
#include "host_struct.h"
#include "ioctl_eventlog.h"
#include "ioctl_flash_types.h"
#include "descriptors.h"
#include "ipc_fw_impl.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- IPTYPE_MASK ---
// ditermine if V4 or V6 from this mask. 
#define IP_TYPE_V4_MASK                 (1)       
#define IP_TYPE_V6_MASK                 (16)      

typedef enum {
   ENUM_IP_TYPE_V4_MASK = 0x1UL,
   ENUM_IP_TYPE_V6_MASK = 0x10UL
} IPTYPE_MASK;

// --- IPTYPE ---
// Defintion for IPVersion in IP_ADDRESS_SUBNET_FORMAT and IP_ADDRESS_FORMAT 
#define IP_TYPE_V4                      (1)       
#define IP_TYPE_STATIC_V4               (3)       
#define IP_TYPE_DHCP_V4                 (5)       
#define IP_TYPE_V6                      (16)      
#define IP_TYPE_ROUTABLE_V6             (48)      
#define IP_TYPE_LINK_LOCAL_V6           (80)      
#define IP_TYPE_AUTO_V6                 (144)     

typedef enum {
   ENUM_IP_TYPE_V4 = 0x1UL,
   ENUM_IP_TYPE_STATIC_V4 = 0x3UL,
   ENUM_IP_TYPE_DHCP_V4 = 0x5UL,
   ENUM_IP_TYPE_V6 = 0x10UL,
   ENUM_IP_TYPE_ROUTABLE_V6 = 0x30UL,
   ENUM_IP_TYPE_LINK_LOCAL_V6 = 0x50UL,
   ENUM_IP_TYPE_AUTO_V6 = 0x90UL
} IPTYPE;

// --- DHCP_STATES ---
// Definitions of dhcp_states in GET_IF_INFO_PARAMS_OUT 
#define MGMT_DHCP_IN_PROGRESS           (1)       
#define MGMT_DHCP_INIT_STATE            (2)       
#define MGMT_DHCP_SELECTING_STATE       (3)       
#define MGMT_DHCP_BOUND_STATE           (4)       
#define MGMT_DHCP_REQUESTING_STATE      (5)       
#define MGMT_DHCP_RENEW_STATE           (6)       
#define MGMT_DHCP_REBIND_STATE          (7)       

typedef enum {
   ENUM_MGMT_DHCP_IN_PROGRESS = 0x1UL,
   ENUM_MGMT_DHCP_INIT_STATE = 0x2UL,
   ENUM_MGMT_DHCP_SELECTING_STATE = 0x3UL,
   ENUM_MGMT_DHCP_BOUND_STATE = 0x4UL,
   ENUM_MGMT_DHCP_REQUESTING_STATE = 0x5UL,
   ENUM_MGMT_DHCP_RENEW_STATE = 0x6UL,
   ENUM_MGMT_DHCP_REBIND_STATE = 0x7UL
} DHCP_STATES;

// --- SUPPORTED_MODES ---
#define TOE_MODE                        (1)       // TCP offload supported. 
#define NIC_MODE                        (2)       // Raw Ethernet supported. 
#define RDMA_MODE                       (4)       // RDMA protocol supported. 
#define VM_MODE                         (8)       // Virtual Machines supported. 
#define ISCSI_INI_MODE                  (16)      // iSCSI initiator supported. 
#define ISCSI_TGT_MODE                  (32)      // iSCSI target plus initiator
                                                  // supported. 
#define FCOE_INI_MODE                   (64)      // FCoE Initiator supported. 
#define FCOE_TGT_MODE                   (128)     // FCoE target supported. 
#define DAL_MODE                        (256)     // DAL supported. 
#define LRO_MODE                        (512)     // LRO supported. 
#define FLEX10_MODE                     (1024)    // Depending on customer code this is
                                                  // either FLEX-10 (HP) or VNIC (IBM). 
#define NCSI_MODE                       (2048)    // NCSI supported. 
#define IPV6_MODE                       (4096)    // Enable IPv6 stack. 
#define BE2_COMPAT_MODE                 (8192)    // Run in BE2 compatibility mode. Do not
                                                  // enable BE3 or higher features 
#define SRIOV_MODE                      (16384)   // SRIOV support is enabled on this
                                                  // board. 
#define INVALID_MODE                    (32768)   // Invalid function/mode. 
#define BE3_COMPAT_MODE                 (65536)   // Enable BE3 features.
#define VNIC_MODE                       (131072)  // Set when IBM vNIC mode is set.
#define VNTAG_MODE                      (262144)  // Set when VNTAG mode is set.
#define UMC_MODE                        (524288)  // Set when UMC mode is set.
#define UMC_DEF_EN                      (1048576) // Set when UMC Default Enabled.
#define ONE_GB_DEF_EN                   (2097152) // Set when 1GB Default Enabled.
#define VNIC_DEF_VALID                  (4194304) // Set when VNIC_DEF_EN is valid.
#define VNIC_DEF_EN                     (8388608) // Set when VNIC Default Enabled.

typedef enum {
   ENUM_TOE_MODE = 0x1UL,
   ENUM_NIC_MODE = 0x2UL,
   ENUM_RDMA_MODE = 0x4UL,
   ENUM_VM_MODE = 0x8UL,
   ENUM_ISCSI_INI_MODE = 0x10UL,
   ENUM_ISCSI_TGT_MODE = 0x20UL,
   ENUM_FCOE_INI_MODE = 0x40UL,
   ENUM_FCOE_TGT_MODE = 0x80UL,
   ENUM_DAL_MODE = 0x100UL,
   ENUM_LRO_MODE = 0x200UL,
   ENUM_FLEX10_MODE = 0x400UL,
   ENUM_NCSI_MODE = 0x800UL,
   ENUM_IPV6_MODE = 0x1000UL,
   ENUM_BE2_COMPAT_MODE = 0x2000UL,
   ENUM_SRIOV_MODE = 0x4000UL,
   ENUM_INVALID_MODE = 0x8000UL,
   ENUM_BE3_COMPAT_MODE = 0x10000UL,
   ENUM_VNIC_MODE = 0x20000UL,
   ENUM_VNTAG_MODE = 0x40000UL,
   ENUM_UMC_MODE = 0x80000UL,
   ENUM_UMC_DEF_EN = 0x100000UL,
   ENUM_ONE_GB_DEF_EN = 0x200000UL,
   ENUM_VNIC_DEF_VALID = 0x400000UL,
   ENUM_VNIC_DEF_EN = 0x800000UL
} SUPPORTED_MODES;

//                  MAC address format                  
typedef struct {
   BE_UEXACT16_AMAP SizeOfStructure;
   BE_UEXACT8_AMAP MACAddress[6];
} SG_PACK BE_MAC_ADDRESS_FORMAT_AMAP;
typedef struct { u32 dw[2]; } MAC_ADDRESS_FORMAT_AMAP, *PMAC_ADDRESS_FORMAT_AMAP;


//  IP address format - handles both IPv4 and IPv6 
typedef struct {
   BE_UEXACT16_AMAP SizeOfStructure;
   BE_UEXACT8_AMAP Reserved;
   BE_UEXACT8_AMAP IPType;
   BE_UEXACT8_AMAP IPAddress[16];
   BE_BIT rsvd0[32];                              // DWORD 5
} SG_PACK BE_IP_ADDRESS_FORMAT_AMAP;
typedef struct { u32 dw[6]; } IP_ADDRESS_FORMAT_AMAP, *PIP_ADDRESS_FORMAT_AMAP;


//  IP address and Subnet Mask format 
typedef struct {
   BE_UEXACT16_AMAP SizeOfStructure;
   BE_UEXACT8_AMAP IPType;
   BE_UEXACT8_AMAP IPv6_Prefix_Length;
   BE_UEXACT8_AMAP IPAddress[16];
   BE_UEXACT8_AMAP SubNetMask[16];
   BE_BIT rsvd0[32];                              // DWORD 9
} SG_PACK BE_IP_ADDRESS_SUBNET_FORMAT_AMAP;
typedef struct { u32 dw[10]; } IP_ADDRESS_SUBNET_FORMAT_AMAP, *PIP_ADDRESS_SUBNET_FORMAT_AMAP;


//  WWN (Fibre Channel) Format 
typedef struct {
   BE_UEXACT16_AMAP SizeOfStructure;
   BE_UEXACT16_AMAP Reserved;
   BE_UEXACT8_AMAP WWN[8];
   BE_BIT rsvd0[32];                              // DWORD 3
} SG_PACK BE_WWN_ADDRESS_FORMAT_AMAP;
typedef struct { u32 dw[4]; } WWN_ADDRESS_FORMAT_AMAP, *PWWN_ADDRESS_FORMAT_AMAP;


//  URL or World Wide Unique ID Format 
typedef struct {
   BE_UEXACT16_AMAP SizeOfStructure;
   BE_UEXACT16_AMAP Reserved;
   BE_EXACT8_AMAP URL[256];
   BE_BIT rsvd0[32];                              // DWORD 65
} SG_PACK BE_URL_ADDRESS_FORMAT_AMAP;
typedef struct { u32 dw[66]; } URL_ADDRESS_FORMAT_AMAP, *PURL_ADDRESS_FORMAT_AMAP;


// --- MGMT_CHAP_FORMAT_FLAG ---
// Bitmap definition of flags in MGMT_CHAP_FORMAT 
#define MGMT_CHAP_FORMAT_FLAG_ONEWAY_CHAP (0)     // One-way CHAP 
#define MGMT_CHAP_FORMAT_FLAG_MUTUALCHAP (1)      // Mutual CHAP 

typedef enum {
   ENUM_MGMT_CHAP_FORMAT_FLAG_ONEWAY_CHAP = 0x0UL,
   ENUM_MGMT_CHAP_FORMAT_FLAG_MUTUALCHAP = 0x1UL
} MGMT_CHAP_FORMAT_FLAG;


typedef struct {
   BE_EXACT8_AMAP chap_name[256];
   BE_EXACT8_AMAP secret[16];
   BE_UEXACT16_AMAP chap_name_length;
   BE_UEXACT16_AMAP secret_length;
} SG_PACK BE_MGMT_CHAP_NAME_SECRET_AMAP;
typedef struct { u32 dw[69]; } MGMT_CHAP_NAME_SECRET_AMAP, *PMGMT_CHAP_NAME_SECRET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP flags;
   BE_EXACT8_AMAP intr_chap_name[256];
   BE_EXACT8_AMAP intr_secret[16];
   BE_EXACT8_AMAP target_chap_name[256];
   BE_EXACT8_AMAP target_secret[16];
   BE_UEXACT16_AMAP intr_chap_name_length;
   BE_UEXACT16_AMAP intr_secret_length;
   BE_UEXACT16_AMAP target_chap_name_length;
   BE_UEXACT16_AMAP target_secret_length;
} SG_PACK BE_MGMT_CHAP_FORMAT_AMAP;
typedef struct { u32 dw[139]; } MGMT_CHAP_FORMAT_AMAP, *PMGMT_CHAP_FORMAT_AMAP;


// --- MGMT_AUTH_METHOD_TYPE ---
#define MGMT_AUTH_TYPE_NONE             (0)       
#define MGMT_AUTH_TYPE_CHAP             (1)       

typedef enum {
   ENUM_MGMT_AUTH_TYPE_NONE = 0x0UL,
   ENUM_MGMT_AUTH_TYPE_CHAP = 0x1UL
} MGMT_AUTH_METHOD_TYPE;


typedef union {
   BE_MGMT_CHAP_FORMAT_AMAP chap;
} SG_PACK BE_MGMT_CHAP_SRP_FORMAT_AMAP;
typedef struct { u32 dw[139]; } MGMT_CHAP_SRP_FORMAT_AMAP, *PMGMT_CHAP_SRP_FORMAT_AMAP;



typedef struct {
   BE_UEXACT8_AMAP auth_method_type;
   BE_UEXACT8_AMAP padding[3];
   BE_MGMT_CHAP_SRP_FORMAT_AMAP chap_srp_format;
} SG_PACK BE_MGMT_AUTH_METHOD_FORMAT_AMAP;
typedef struct { u32 dw[140]; } MGMT_AUTH_METHOD_FORMAT_AMAP, *PMGMT_AUTH_METHOD_FORMAT_AMAP;


// --- MGMT_ISCSI_SECURITY_FLAG ---
// MGMT_ISCSI_SECURITY_FLAG for IKE/IPSEC These values are defined in the iSNS
// specification 
#define MGMT_ISCSI_SECURITY_FLAG_VALID  (1)       // If set then all other
                                                  // ISCSI_SECURITY_FLAGS are valid 
#define MGMT_ISCSI_SECURITY_FLAG_IKE_IPSEC_ENABLED (2) // 1 = IKE/IPSec Enabled; 0 =
                                                       // IKE/IPSec Disabled 
#define MGMT_ISCSI_SECURITY_FLAG_MAIN_MODE_ENABLED (4) // 1 = Main Mode Enabled; 0 = MM
                                                       // Disabled 
#define MGMT_ISCSI_SECURITY_FLAG_AGGRESSIVE_MODE_ENABLED (8) // 1 = Aggressive Mode
                                                             // Enabled; 0 = Disabled 
#define MGMT_ISCSI_SECURITY_FLAG_PFS_ENABLED (16) // 1 = PFS SW_STRUCT_PARAMSEnabled; 0 =
                                                  // PFS Disabled 
#define MGMT_ISCSI_SECURITY_FLAG_TRANSPORT_MODE_PREFERRED (32) // 1 = Transport Mode
                                                               // Preferred; 0 = No
                                                               // Preference 
#define MGMT_ISCSI_SECURITY_FLAG_TUNNEL_MODE_PREFERRED (64) // 1 = Tunnel Mode Preferred;
                                                            // 0 = No Preference 

typedef enum {
   ENUM_MGMT_ISCSI_SECURITY_FLAG_VALID = 0x1UL,
   ENUM_MGMT_ISCSI_SECURITY_FLAG_IKE_IPSEC_ENABLED = 0x2UL,
   ENUM_MGMT_ISCSI_SECURITY_FLAG_MAIN_MODE_ENABLED = 0x4UL,
   ENUM_MGMT_ISCSI_SECURITY_FLAG_AGGRESSIVE_MODE_ENABLED = 0x8UL,
   ENUM_MGMT_ISCSI_SECURITY_FLAG_PFS_ENABLED = 0x10UL,
   ENUM_MGMT_ISCSI_SECURITY_FLAG_TRANSPORT_MODE_PREFERRED = 0x20UL,
   ENUM_MGMT_ISCSI_SECURITY_FLAG_TUNNEL_MODE_PREFERRED = 0x40UL
} MGMT_ISCSI_SECURITY_FLAG;

// --- MGMT_TGT_TMF_METHODS ---
#define MGMT_TMF_METHOD_LU_RESET        (5)       
#define MGMT_TMF_METHOD_TGT_WARM_RESET  (6)       
#define MGMT_TMF_METHOD_TGT_COLD_RESET  (7)       

typedef enum {
   ENUM_MGMT_TMF_METHOD_LU_RESET = 0x5UL,
   ENUM_MGMT_TMF_METHOD_TGT_WARM_RESET = 0x6UL,
   ENUM_MGMT_TMF_METHOD_TGT_COLD_RESET = 0x7UL
} MGMT_TGT_TMF_METHODS;

// --- MGMT_TMF_METHODS ---
// Other TMF methods specified in RFC3720, not currently supported 
#define MGMT_TMF_METHOD_ABORT_TASK      (1)       
#define MGMT_TMF_METHOD_ABORT_TASK_SET  (2)       
#define MGMT_TMF_METHOD_CLEAR_ACA       (3)       
#define MGMT_TMF_METHOD_CLEAR_TASK_SET  (4)       
#define MGMT_TMF_METHOD_TASK_REASSIGN   (8)       

typedef enum {
   ENUM_MGMT_TMF_METHOD_ABORT_TASK = 0x1UL,
   ENUM_MGMT_TMF_METHOD_ABORT_TASK_SET = 0x2UL,
   ENUM_MGMT_TMF_METHOD_CLEAR_ACA = 0x3UL,
   ENUM_MGMT_TMF_METHOD_CLEAR_TASK_SET = 0x4UL,
   ENUM_MGMT_TMF_METHOD_TASK_REASSIGN = 0x8UL
} MGMT_TMF_METHODS;

// --- LOGIN_TARGET_PARAMS_FLAGS ---
// Bit definition of login_flags in LOGIN_TARGET_PARAMS_IN 
#define MGMT_LOGIN_FLAG_NO_IPSEC        (0)       
#define MGMT_LOGIN_FLAG_REQUIRE_IPSEC   (1)       
#define MGMT_LOGIN_FLAG_MULTIPATH_ENABLED (2)     

typedef enum {
   ENUM_MGMT_LOGIN_FLAG_NO_IPSEC = 0x0UL,
   ENUM_MGMT_LOGIN_FLAG_REQUIRE_IPSEC = 0x1UL,
   ENUM_MGMT_LOGIN_FLAG_MULTIPATH_ENABLED = 0x2UL
} LOGIN_TARGET_PARAMS_FLAGS;

// --- MGMT_SESSION_STATUS ---
#define MGMT_SESSION_STATUS_OPENED      (1)       // Session login success 
#define MGMT_SESSION_STATUS_OPENNING    (2)       // Should be ignored by application 
#define MGMT_SESSION_STATUS_LUN_REPORTING (4)     // Should be ignored by application 
#define MGMT_SESSION_STATUS_LUN_REPORTED (8)      // Should be ignored by application 
#define MGMT_SESSION_STATUS_CLOSING     (16)      // Should be ignored by application 
#define MGMT_SESSION_STATUS_CLOSED      (32)      // Session logged out success 
#define MGMT_SESSION_STATUS_CLOSED_IN_RECOVERY (64) // Should be ignored by application 
#define MGMT_SESSION_STATUS_IN_DEVICE_RESET (128) // Should be ignored by application 
#define MGMT_SESSION_STATUS_OPEN_FAILED (256)     // Login failed 
#define MGMT_SESSION_STATUS_SENDTARGET_FAILED (512) // SendTarget command failed 
#define MGMT_SESSION_STATUS_REPORTLUN_FAILED (1024) // REPORT_LUN command failed 
#define MGMT_SESSION_STATUS_CLOSE_FAILED (2048)   // Logout failed 
#define MGMT_SESSION_STATUS_IN_RETRY    (4096)    // This session is in retry queue 
#define MGMT_SESSION_STATUS_DELETED     (8192)    // This session marked as deleted 

typedef enum {
   ENUM_MGMT_SESSION_STATUS_OPENED = 0x1UL,
   ENUM_MGMT_SESSION_STATUS_OPENNING = 0x2UL,
   ENUM_MGMT_SESSION_STATUS_LUN_REPORTING = 0x4UL,
   ENUM_MGMT_SESSION_STATUS_LUN_REPORTED = 0x8UL,
   ENUM_MGMT_SESSION_STATUS_CLOSING = 0x10UL,
   ENUM_MGMT_SESSION_STATUS_CLOSED = 0x20UL,
   ENUM_MGMT_SESSION_STATUS_CLOSED_IN_RECOVERY = 0x40UL,
   ENUM_MGMT_SESSION_STATUS_IN_DEVICE_RESET = 0x80UL,
   ENUM_MGMT_SESSION_STATUS_OPEN_FAILED = 0x100UL,
   ENUM_MGMT_SESSION_STATUS_SENDTARGET_FAILED = 0x200UL,
   ENUM_MGMT_SESSION_STATUS_REPORTLUN_FAILED = 0x400UL,
   ENUM_MGMT_SESSION_STATUS_CLOSE_FAILED = 0x800UL,
   ENUM_MGMT_SESSION_STATUS_IN_RETRY = 0x1000UL,
   ENUM_MGMT_SESSION_STATUS_DELETED = 0x2000UL
} MGMT_SESSION_STATUS;

// --- MGMT_SESSION_FLAGS ---
#define MGMT_SESSION_FLAG_NON_PERSISTENT (1)      
#define MGMT_SESSION_FLAG_PERSISTENT    (2)       
#define MGMT_SESSION_FLAG_DISCOVERY     (16)      
#define MGMT_SESSION_FLAG_INFORMATIONAL (32)      
#define MGMT_SESSION_FLAG_DATA_SESSION  (64)      
#define MGMT_SESSION_FLAG_LIST_SESSION  (128)     // if set to 1, all targets are returned
                                                  // else only logged in targets are
                                                  // returned 
#define MGMT_SESSION_FLAG_MPIO_GROUP    (256)     // This flag is used by MPIO supported
                                                  // drivers, to open redundant sessions 
#define MGMT_SESSION_FLAG_WMI_SESSION   (512)     // This flag is used by WMI code to mark
                                                  // the session as not to be logged-in 
#define MGMT_SESSION_FLAG_CLP_SESSION   (1024)    // This flag is used internally by ARM
                                                  // FW to mark the session which are
                                                  // created by CLP cmds. 

typedef enum {
   ENUM_MGMT_SESSION_FLAG_NON_PERSISTENT = 0x1UL,
   ENUM_MGMT_SESSION_FLAG_PERSISTENT = 0x2UL,
   ENUM_MGMT_SESSION_FLAG_DISCOVERY = 0x10UL,
   ENUM_MGMT_SESSION_FLAG_INFORMATIONAL = 0x20UL,
   ENUM_MGMT_SESSION_FLAG_DATA_SESSION = 0x40UL,
   ENUM_MGMT_SESSION_FLAG_LIST_SESSION = 0x80UL,
   ENUM_MGMT_SESSION_FLAG_MPIO_GROUP = 0x100UL,
   ENUM_MGMT_SESSION_FLAG_WMI_SESSION = 0x200UL,
   ENUM_MGMT_SESSION_FLAG_CLP_SESSION = 0x400UL
} MGMT_SESSION_FLAGS;

// --- MGMT_SESSION_MAGIC_NUMBER ---
#define MGMT_SESSION_MAGIC_NUMBER_WMI_PERSISTENT (170) // Identifier for WMI persistent
                                                       // session 

typedef enum {
   ENUM_MGMT_SESSION_MAGIC_NUMBER_WMI_PERSISTENT = 0xaaUL
} MGMT_SESSION_MAGIC_NUMBER;

// --- SESSION_TYPE ---
// Session Type 
#define MGMT_SESSION_TYPE_DISCOVERY_SESSION (16)  // Discovery session LUNs are NOT
                                                  // exposed to the host OS 
#define MGMT_SESSION_TYPE_INFORMATIONAL_SESSION (32) // Informational session LUNs are NOT
                                                     // exposed to the host OS 
#define MGMT_SESSION_TYPE_DATA_SESSION  (64)      // Data session. LUNs are exposed to the
                                                  // host OS 
#define MGMT_SESSION_TYPE_BOOT_SESSION  (128)     // Boot session 
#define MGMT_SESSION_TYPE_MASK_SESSION_TYPE (240) 

typedef enum {
   ENUM_MGMT_SESSION_TYPE_DISCOVERY_SESSION = 0x10UL,
   ENUM_MGMT_SESSION_TYPE_INFORMATIONAL_SESSION = 0x20UL,
   ENUM_MGMT_SESSION_TYPE_DATA_SESSION = 0x40UL,
   ENUM_MGMT_SESSION_TYPE_BOOT_SESSION = 0x80UL,
   ENUM_MGMT_SESSION_TYPE_MASK_SESSION_TYPE = 0xf0UL
} SESSION_TYPE;

// --- MGMT_SESSION_OWNER ---
// Application should ignore these bits. These bits are used by the host driver. 
#define MGMT_SESSION_FLAG_DRIVER_OWNED  (4096)    // This indicates session owned by the
                                                  // driver 
#define MGMT_SESSION_FLAG_FIRMWARE_OWNED (8192)   // This indicates session owned by the
                                                  // firmware 

typedef enum {
   ENUM_MGMT_SESSION_FLAG_DRIVER_OWNED = 0x1000UL,
   ENUM_MGMT_SESSION_FLAG_FIRMWARE_OWNED = 0x2000UL
} MGMT_SESSION_OWNER;

// --- MGMT_CONN_STATUS ---
// Bit definition in connection_status in MGMT_CONN_INFO 
#define MGMT_CONN_STATUS_OPENED         (1)       // TCP connection is opened. All
                                                  // MGMT_CONN_STATUS_ISCSI_LOGIN_STATE is
                                                  // valid ONLY if MGMT_CONN_STATUS_OPENED
                                                  // is 1 
#define MGMT_CONN_STATUS_OPENNING       (2)       // Should be ignored by application 
#define MGMT_CONN_STATUS_REDIRECTED     (4)       // The iSCSI login is redirected. 
#define MGMT_CONN_STATUS_REDIRECTED_PERM (8)      // Valid only if
                                                  // MGMT_CONN_STATUS_REDIRECTED bit is 1
                                                  // When this bit is set, the iSCSI login
                                                  // is redirected permanently else the
                                                  // iSCSI login is redirected temporarily
#define MGMT_CONN_STATUS_ISCSI_LOGIN_STATE_INI (16) // 1: Initial login state as defined
                                                    // in iSCSI spec 
#define MGMT_CONN_STATUS_ISCSI_LOGIN_STATE_SEC (32) // 1: Security login state as defined
                                                    // in iSCSI spec 
#define MGMT_CONN_STATUS_ISCSI_LOGIN_STATE_OPR (64) // 1: Operational login state as
                                                    // defined in iSCSI spec 
#define MGMT_CONN_STATUS_ISCSI_LOGIN_STATE_FULL (128) // 1: Full login state as defined in
                                                      // iSCSI spec 
#define MGMT_CONN_STATUS_CLOSING        (256)     // Should be ignored by application 
#define MGMT_CONN_STATUS_CLOSED         (512)     // Connection logged out success 
#define MGMT_CONN_STATUS_CLOSED_IN_RECOVERY (1024) // TCP connection is closed for
                                                   // recovery purpose 
#define MGMT_CONN_STATUS_OPEN_FAILED    (2048)    // Login failed 
#define MGMT_CONN_STATUS_CLOSE_FAILED   (4096)    // Logout failed 

typedef enum {
   ENUM_MGMT_CONN_STATUS_OPENED = 0x1UL,
   ENUM_MGMT_CONN_STATUS_OPENNING = 0x2UL,
   ENUM_MGMT_CONN_STATUS_REDIRECTED = 0x4UL,
   ENUM_MGMT_CONN_STATUS_REDIRECTED_PERM = 0x8UL,
   ENUM_MGMT_CONN_STATUS_ISCSI_LOGIN_STATE_INI = 0x10UL,
   ENUM_MGMT_CONN_STATUS_ISCSI_LOGIN_STATE_SEC = 0x20UL,
   ENUM_MGMT_CONN_STATUS_ISCSI_LOGIN_STATE_OPR = 0x40UL,
   ENUM_MGMT_CONN_STATUS_ISCSI_LOGIN_STATE_FULL = 0x80UL,
   ENUM_MGMT_CONN_STATUS_CLOSING = 0x100UL,
   ENUM_MGMT_CONN_STATUS_CLOSED = 0x200UL,
   ENUM_MGMT_CONN_STATUS_CLOSED_IN_RECOVERY = 0x400UL,
   ENUM_MGMT_CONN_STATUS_OPEN_FAILED = 0x800UL,
   ENUM_MGMT_CONN_STATUS_CLOSE_FAILED = 0x1000UL
} MGMT_CONN_STATUS;

// --- MGMT_CONNECTION_OWNER ---
// Application should ignore these bits. These bits are used by the host driver. 
#define MGMT_CONN_FLAG_DRIVER_OWNED     (4096)    // This indicates connection owned by
                                                  // the driver 
#define MGMT_CONN_FLAG_FIRMWARE_OWNED   (8192)    // This indicates connection owned by
                                                  // the firmware 

typedef enum {
   ENUM_MGMT_CONN_FLAG_DRIVER_OWNED = 0x1000UL,
   ENUM_MGMT_CONN_FLAG_FIRMWARE_OWNED = 0x2000UL
} MGMT_CONNECTION_OWNER;

// --- MGMT_CONN_LOGIN_OPTIONS_FLAG ---
// Bitmap definitions for "flags" in MGMT_CONN_LOGIN_OPTIONS 
#define MGMT_CONN_LOGIN_OPTIONS_FLAG_IPSEC_ENABLED (1) 
#define MGMT_CONN_LOGIN_OPTIONS_FLAG_DIGEST_CRC32 (2) 
#define MGMT_CONN_LOGIN_OPTIONS_FLAG_LEADING (4)  

typedef enum {
   ENUM_MGMT_CONN_LOGIN_OPTIONS_FLAG_IPSEC_ENABLED = 0x1UL,
   ENUM_MGMT_CONN_LOGIN_OPTIONS_FLAG_DIGEST_CRC32 = 0x2UL,
   ENUM_MGMT_CONN_LOGIN_OPTIONS_FLAG_LEADING = 0x4UL
} MGMT_CONN_LOGIN_OPTIONS_FLAG;


typedef struct {
   BE_UEXACT8_AMAP flags;
   BE_UEXACT8_AMAP header_digest;
   BE_UEXACT8_AMAP data_digest;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT32_AMAP max_recv_datasegment_len_ini;
   BE_UEXACT32_AMAP max_recv_datasegment_len_tgt;
   BE_UEXACT32_AMAP tcp_mss;
   BE_UEXACT32_AMAP tcp_window_size;
   BE_MGMT_AUTH_METHOD_FORMAT_AMAP auth_data;
} SG_PACK BE_MGMT_CONN_LOGIN_OPTIONS_AMAP;
typedef struct { u32 dw[145]; } MGMT_CONN_LOGIN_OPTIONS_AMAP, *PMGMT_CONN_LOGIN_OPTIONS_AMAP;


// --- MGMT_SESSION_LOGIN_OPTIONS_FLAGS ---
// Bitmap defintions for flags in MGMT_SESSION_LOGIN_OPTIONS 
#define MGMT_SESSION_LOGIN_OPTIONS_FLAG_INIT_R2T (1) // Initial R2T - 0: disabled 1:
                                                     // enabled 
#define MGMT_SESSION_LOGIN_OPTIONS_FLAG_IMMEDIATE_DATA (2) // ImmediateData - 0: disabled
                                                           // 1: enabled 
#define MGMT_SESSION_LOGIN_OPTIONS_FLAG_DPDU_INORDER (4) // Data PDU In order - 0:
                                                         // disabled 1: enabled 
#define MGMT_SESSION_LOGIN_OPTIONS_FLAG_DSEQ_INORDER (8) // Data Sequence In order - 0:
                                                         // disabled 1: enabled 

typedef enum {
   ENUM_MGMT_SESSION_LOGIN_OPTIONS_FLAG_INIT_R2T = 0x1UL,
   ENUM_MGMT_SESSION_LOGIN_OPTIONS_FLAG_IMMEDIATE_DATA = 0x2UL,
   ENUM_MGMT_SESSION_LOGIN_OPTIONS_FLAG_DPDU_INORDER = 0x4UL,
   ENUM_MGMT_SESSION_LOGIN_OPTIONS_FLAG_DSEQ_INORDER = 0x8UL
} MGMT_SESSION_LOGIN_OPTIONS_FLAGS;

// --- DEFAULT_MAX_BURST_LENGTH_DEFINE ---
#define DEFAULT_MAX_BURST_LENGTH        (262144)  

typedef enum {
   ENUM_DEFAULT_MAX_BURST_LENGTH = 0x40000UL
} DEFAULT_MAX_BURST_LENGTH_DEFINE;

// --- DEFAULT_MAX_OUTSTANDING_R2T_DEFINE ---
#define DEFAULT_MAX_OUTSTANDING_R2T     (1)       

typedef enum {
   ENUM_DEFAULT_MAX_OUTSTANDING_R2T = 0x1UL
} DEFAULT_MAX_OUTSTANDING_R2T_DEFINE;


typedef struct {
   BE_UEXACT8_AMAP flags;
   BE_UEXACT8_AMAP error_recovery_level;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT32_AMAP first_burst_length;
   BE_UEXACT32_AMAP max_burst_length;
   BE_UEXACT16_AMAP max_connections;
   BE_UEXACT16_AMAP max_outstanding_r2t;
   BE_UEXACT16_AMAP default_time2wait;
   BE_UEXACT16_AMAP default_time2retain;
} SG_PACK BE_MGMT_SESSION_LOGIN_OPTIONS_AMAP;
typedef struct { u32 dw[5]; } MGMT_SESSION_LOGIN_OPTIONS_AMAP, *PMGMT_SESSION_LOGIN_OPTIONS_AMAP;



typedef struct {
   BE_MGMT_SESSION_LOGIN_OPTIONS_AMAP sess_login_opts;
   BE_UEXACT8_AMAP conn_flags;
   BE_UEXACT8_AMAP data_digest;
   BE_UEXACT8_AMAP header_digest;
   BE_BIT rsvd0[8];                               // DWORD 5
   BE_UEXACT32_AMAP max_recv_datasegment_len_tgt;
} SG_PACK BE_MGMT_TARGET_LOGIN_OPTIONS_AMAP;
typedef struct { u32 dw[7]; } MGMT_TARGET_LOGIN_OPTIONS_AMAP, *PMGMT_TARGET_LOGIN_OPTIONS_AMAP;



typedef struct {
   BE_MGMT_SESSION_LOGIN_OPTIONS_AMAP sess_login_opts;
   BE_MGMT_CONN_LOGIN_OPTIONS_AMAP conn_login_opts;
} SG_PACK BE_MGMT_LOGIN_OPTIONS_AMAP;
typedef struct { u32 dw[150]; } MGMT_LOGIN_OPTIONS_AMAP, *PMGMT_LOGIN_OPTIONS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP connection_handle;
   BE_UEXACT32_AMAP connection_status;
   BE_UEXACT16_AMAP src_port;
   BE_UEXACT16_AMAP dest_port;
   BE_UEXACT16_AMAP dest_port_redirected;
   BE_UEXACT16_AMAP cid;
   BE_UEXACT32_AMAP estimated_throughput;
   BE_IP_ADDRESS_FORMAT_AMAP src_ipaddr;
   BE_IP_ADDRESS_FORMAT_AMAP dest_ipaddr;
   BE_IP_ADDRESS_FORMAT_AMAP dest_ipaddr_redirected;
   BE_MGMT_CONN_LOGIN_OPTIONS_AMAP negotiated_login_options;
} SG_PACK BE_MGMT_CONN_INFO_AMAP;
typedef struct { u32 dw[168]; } MGMT_CONN_INFO_AMAP, *PMGMT_CONN_INFO_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP status;
   BE_UEXACT8_AMAP isid[6];
   BE_UEXACT16_AMAP tsih;
   BE_UEXACT32_AMAP session_flags;
   BE_UEXACT16_AMAP conn_count;
   BE_UEXACT16_AMAP pad;
   BE_EXACT8_AMAP target_name[224];
   BE_EXACT8_AMAP initiator_iscsiname[224];
   BE_MGMT_SESSION_LOGIN_OPTIONS_AMAP negotiated_login_options;
   BE_MGMT_CONN_INFO_AMAP conn_list[1];
} SG_PACK BE_MGMT_SESSION_INFO_AMAP;
typedef struct { u32 dw[291]; } MGMT_SESSION_INFO_AMAP, *PMGMT_SESSION_INFO_AMAP;


// --- MGMT_SESSION_INFO_FIXEDSIZE_ENUM ---
#define MGMT_SESSION_INFO_FIXEDSIZE     (1164)    

typedef enum {
   ENUM_MGMT_SESSION_INFO_FIXEDSIZE = 0x48cUL
} MGMT_SESSION_INFO_FIXEDSIZE_ENUM;


typedef struct {
   BE_UEXACT32_AMAP connection_handle;
   BE_UEXACT32_AMAP conn_status;
   BE_UEXACT32_AMAP conn_iscsi_cid;
   BE_UEXACT32_AMAP estimated_throughput;
   BE_UEXACT32_AMAP header_digest;
   BE_UEXACT32_AMAP data_digest;
} SG_PACK BE_CONNECTION_DATA_AMAP;
typedef struct { u32 dw[6]; } CONNECTION_DATA_AMAP, *PCONNECTION_DATA_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT16_AMAP conn_count;
   BE_UEXACT16_AMAP pad;
   BE_CONNECTION_DATA_AMAP conn_list[1];
} SG_PACK BE_MGMT_CONN_LB_INFO_AMAP;
typedef struct { u32 dw[8]; } MGMT_CONN_LB_INFO_AMAP, *PMGMT_CONN_LB_INFO_AMAP;


// --- MGMT_DEV_ADDR_MODE ---
// Definition of device addressing mode 
#define MGMT_DEV_ADDR_MODE_PERIPHERAL   (0)       
#define MGMT_DEV_ADDR_MODE_FLAT_SPACE   (1)       
#define MGMT_DEV_ADDR_MODE_LOGICAL_UNIT (2)       
#define MGMT_DEV_ADDR_MODE_EXTENDED_LOGICAL_UNIT (3) 
#define MGMT_DEV_ADDR_MODE_CUSTOM       (4)       

typedef enum {
   ENUM_MGMT_DEV_ADDR_MODE_PERIPHERAL = 0x0UL,
   ENUM_MGMT_DEV_ADDR_MODE_FLAT_SPACE = 0x1UL,
   ENUM_MGMT_DEV_ADDR_MODE_LOGICAL_UNIT = 0x2UL,
   ENUM_MGMT_DEV_ADDR_MODE_EXTENDED_LOGICAL_UNIT = 0x3UL,
   ENUM_MGMT_DEV_ADDR_MODE_CUSTOM = 0x4UL
} MGMT_DEV_ADDR_MODE;

// --- MGMT_UNASSIGNED_OS_BTL_VALUE_ENUM ---
#define MGMT_UNASSIGNED_OS_BTL_VALUE    (65535)   // No OS BTL value is assigned

typedef enum {
   ENUM_MGMT_UNASSIGNED_OS_BTL_VALUE = 0xffffUL
} MGMT_UNASSIGNED_OS_BTL_VALUE_ENUM;


typedef struct {
   BE_UEXACT8_AMAP lun[8];
   BE_UEXACT16_AMAP os_lun;
   BE_UEXACT8_AMAP boot_order;
   BE_UEXACT8_AMAP pad1;
   BE_UEXACT32_AMAP pad2;
} SG_PACK BE_MGMT_LUN_MAPPING_AMAP;
typedef struct { u32 dw[4]; } MGMT_LUN_MAPPING_AMAP, *PMGMT_LUN_MAPPING_AMAP;


// --- MGMT_BTL_MAPPING_FLAGS ---
// Bit definitions of flags in MGMT_BTL_MAPPING 
#define MGMT_BTL_MAPPING_FLAG_SESSIONID_VALID (1) 

typedef enum {
   ENUM_MGMT_BTL_MAPPING_FLAG_SESSIONID_VALID = 0x1UL
} MGMT_BTL_MAPPING_FLAGS;


typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP session_status;
   BE_UEXACT32_AMAP session_flags;
   BE_UEXACT8_AMAP dev_addr_mode;
   BE_UEXACT8_AMAP flags;
   BE_UEXACT16_AMAP os_bus;
   BE_UEXACT16_AMAP os_target;
   BE_UEXACT16_AMAP lun_count;
   BE_MGMT_LUN_MAPPING_AMAP lun_mapping[1];
} SG_PACK BE_MGMT_BTL_MAPPING_AMAP;
typedef struct { u32 dw[9]; } MGMT_BTL_MAPPING_AMAP, *PMGMT_BTL_MAPPING_AMAP;



typedef struct {
   BE_UEXACT16_AMAP os_bus;
   BE_UEXACT16_AMAP os_target;
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_MGMT_OS_BT_AMAP;
typedef struct { u32 dw[2]; } MGMT_OS_BT_AMAP, *PMGMT_OS_BT_AMAP;


// --- MGMT_PORTAL_FLAG ---
// MGMT_PORTAL_FLAG_INITIAL_PORTAL 1: This portal is used for initial connection 0: This
// portal is not used for initial connection 
#define MGMT_PORTAL_FLAG_INITIAL_PORTAL (1)       

typedef enum {
   ENUM_MGMT_PORTAL_FLAG_INITIAL_PORTAL = 0x1UL
} MGMT_PORTAL_FLAG;


typedef struct {
   BE_IP_ADDRESS_FORMAT_AMAP ip_address;
   BE_UEXACT16_AMAP port_number;
   BE_UEXACT16_AMAP flags;
} SG_PACK BE_MGMT_PORTAL_AMAP;
typedef struct { u32 dw[7]; } MGMT_PORTAL_AMAP, *PMGMT_PORTAL_AMAP;


// --- MGMT_PERSISTENT_TARGET_FLAG ---
#define MGMT_PERSISTENT_LOGIN_FLAG_DONT_EXPOSE_LUN_TO_OS (0) // Don't expose the LUNs to
                                                             // the OS after login is
                                                             // completed 
#define MGMT_PERSISTENT_LOGIN_FLAG_EXPOSE_LUN_TO_OS (1) // Expose the LUNs to the OS after
                                                        // login is completed 
#define MGMT_PERSISTENT_LOGIN_FLAG_BOOT (2)       // This is a boot target. When set,
                                                  // MGMT_PERSISTENT_LOGIN_FLAG_EXPOSE_LUN
                                                  // _TO_OS bit must be also be set 

typedef enum {
   ENUM_MGMT_PERSISTENT_LOGIN_FLAG_DONT_EXPOSE_LUN_TO_OS = 0x0UL,
   ENUM_MGMT_PERSISTENT_LOGIN_FLAG_EXPOSE_LUN_TO_OS = 0x1UL,
   ENUM_MGMT_PERSISTENT_LOGIN_FLAG_BOOT = 0x2UL
} MGMT_PERSISTENT_TARGET_FLAG;


typedef struct {
   BE_EXACT8_AMAP target_name[224];
   BE_UEXACT32_AMAP target_id;
   BE_UEXACT32_AMAP flags;
   BE_UEXACT32_AMAP iscsi_security_flags;
   BE_MGMT_PORTAL_AMAP portal;
   BE_MGMT_LOGIN_OPTIONS_AMAP specified_login_options;
   BE_MGMT_BTL_MAPPING_AMAP btl_mapping;
} SG_PACK BE_MGMT_PERSISTENT_LOGIN_AMAP;
typedef struct { u32 dw[225]; } MGMT_PERSISTENT_LOGIN_AMAP, *PMGMT_PERSISTENT_LOGIN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_id;
   BE_MGMT_PORTAL_AMAP portal;
} SG_PACK BE_MGMT_TGTID_PORTAL_AMAP;
typedef struct { u32 dw[8]; } MGMT_TGTID_PORTAL_AMAP, *PMGMT_TGTID_PORTAL_AMAP;


// --- MGMT_SLP_PARAMS_FLAG ---
// Bitmap definition for flags in MGMT_SLP_PARAMS 
#define MGMT_SLP_PARAMS_FLAG_DISABLE    (0)       // SLP Discovery disabled 
#define MGMT_SLP_PARAMS_FLAG_MULTICAST  (0)       // Multicast 
#define MGMT_SLP_PARAMS_FLAG_NOSECURITY (0)       // Security disabled
#define MGMT_SLP_PARAMS_FLAG_ENABLE     (1)       // SLP Discovery enabled 
#define MGMT_SLP_PARAMS_FLAG_BROADCAST  (2)       // Broadcast 
#define MGMT_SLP_PARAMS_FLAG_SECURITY   (4)       // Security enabled 

typedef enum {
   ENUM_MGMT_SLP_PARAMS_FLAG_DISABLE = 0x0UL,
   ENUM_MGMT_SLP_PARAMS_FLAG_MULTICAST = 0x0UL,
   ENUM_MGMT_SLP_PARAMS_FLAG_NOSECURITY = 0x0UL,
   ENUM_MGMT_SLP_PARAMS_FLAG_ENABLE = 0x1UL,
   ENUM_MGMT_SLP_PARAMS_FLAG_BROADCAST = 0x2UL,
   ENUM_MGMT_SLP_PARAMS_FLAG_SECURITY = 0x4UL
} MGMT_SLP_PARAMS_FLAG;


typedef struct {
   BE_UEXACT16_AMAP flags;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_EXACT8_AMAP scopes[256];
   BE_EXACT8_AMAP querylist[256];
   BE_UEXACT32_AMAP multicast_maxwait;
   BE_UEXACT32_AMAP multicast_timeout[5];
   BE_UEXACT32_AMAP multicast_ttl;
} SG_PACK BE_MGMT_SLP_PARAMS_AMAP;
typedef struct { u32 dw[136]; } MGMT_SLP_PARAMS_AMAP, *PMGMT_SLP_PARAMS_AMAP;


// --- MGMT_ISNS_FLAG_CONFIG ---
// Definition of flags in MGMT_ISNS_PARAMS 
#define MGMT_ISNS_FLAG_CONFIG_DISABLE   (0)       // iSNS Discovery disabled 
#define MGMT_ISNS_FLAG_CONFIG_ENABLE    (1)       // iSNS Discovery enabled 
#define MGMT_ISNS_FLAG_CONFIG_MANUAL    (16)      // The iSNS server settings are
                                                  // configured manually. If this bit is
                                                  // set, the following must not be set -
                                                  // MGMT_ISNS_FLAG_CONFIG_VIA_HEARTBEAT -
                                                  // MGMT_ISNS_FLAG_CONFIG_VIA_DHCP -
                                                  // MGMT_ISNS_FLAG_CONFIG_VIA_SLP 
#define MGMT_ISNS_FLAG_CONFIG_VIA_HEARTBEAT (32)  // The iSNS server settings are
                                                  // configured via heartbeat mechanism.
                                                  // If this bit is set, the following
                                                  // must not be set -
                                                  // MGMT_ISNS_FLAG_CONFIG_MANUAL -
                                                  // MGMT_ISNS_FLAG_CONFIG_VIA_DHCP -
                                                  // MGMT_ISNS_FLAG_CONFIG_VIA_SLP 
#define MGMT_ISNS_FLAG_CONFIG_VIA_DHCP  (64)      // The iSNS server settings are
                                                  // configured via DHCP If this bit is
                                                  // set, the following must not be set -
                                                  // MGMT_ISNS_FLAG_CONFIG_MANUAL -
                                                  // MGMT_ISNS_FLAG_CONFIG_VIA_HEARTBEAT -
                                                  // MGMT_ISNS_FLAG_CONFIG_VIA_SLP 
#define MGMT_ISNS_FLAG_CONFIG_VIA_SLP   (128)     

typedef enum {
   ENUM_MGMT_ISNS_FLAG_CONFIG_DISABLE = 0x0UL,
   ENUM_MGMT_ISNS_FLAG_CONFIG_ENABLE = 0x1UL,
   ENUM_MGMT_ISNS_FLAG_CONFIG_MANUAL = 0x10UL,
   ENUM_MGMT_ISNS_FLAG_CONFIG_VIA_HEARTBEAT = 0x20UL,
   ENUM_MGMT_ISNS_FLAG_CONFIG_VIA_DHCP = 0x40UL,
   ENUM_MGMT_ISNS_FLAG_CONFIG_VIA_SLP = 0x80UL
} MGMT_ISNS_FLAG_CONFIG;

// --- IOCTL_TYPES_DEFINED_ENUMS ---
#define MGMT_ISNS_MAX_SERVER_COUNT      (4)       
#define MGMT_ISNS_WELL_KNOWN_TCP_PORT   (3205)    
#define MGMT_ISNS_WELL_KNOWN_UDP_PORT   (3205)    

typedef enum {
   ENUM_MGMT_ISNS_MAX_SERVER_COUNT = 0x4UL,
   ENUM_MGMT_ISNS_WELL_KNOWN_TCP_PORT = 0xc85UL,
   ENUM_MGMT_ISNS_WELL_KNOWN_UDP_PORT = 0xc85UL
} IOCTL_TYPES_DEFINED_ENUMS;

// --- ISNS_SERVER_DISCOVERY_MODES ---
#define ISNS_SERVER_DISCOVERY_MODE_DHCP (1)       // Use DHCP to locate iSNS servers 
#define ISNS_SERVER_DISCOVERY_MODE_SLP  (2)       // Use SLP to discover iSNS Servers 

typedef enum {
   ENUM_ISNS_SERVER_DISCOVERY_MODE_DHCP = 0x1UL,
   ENUM_ISNS_SERVER_DISCOVERY_MODE_SLP = 0x2UL
} ISNS_SERVER_DISCOVERY_MODES;


typedef struct {
   BE_IP_ADDRESS_FORMAT_AMAP ipaddr;
   BE_UEXACT16_AMAP tcp_port;
   BE_UEXACT16_AMAP udp_port;
} SG_PACK BE_MGMT_ISNS_SERVER_AMAP;
typedef struct { u32 dw[7]; } MGMT_ISNS_SERVER_AMAP, *PMGMT_ISNS_SERVER_AMAP;



typedef union {
   BE_EXACT8_AMAP initiator_iscsiname[224];
   BE_EXACT8_AMAP isns_entity_name[224];
} SG_PACK BE_MGMT_ISNS_ENTITY_AMAP;
typedef struct { u32 dw[56]; } MGMT_ISNS_ENTITY_AMAP, *PMGMT_ISNS_ENTITY_AMAP;



typedef struct {
   BE_UEXACT16_AMAP flags;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_MGMT_ISNS_ENTITY_AMAP entity;
   BE_UEXACT32_AMAP srv_count;
   BE_MGMT_ISNS_SERVER_AMAP srv_list[4];
} SG_PACK BE_MGMT_ISNS_PARAMS_AMAP;
typedef struct { u32 dw[86]; } MGMT_ISNS_PARAMS_AMAP, *PMGMT_ISNS_PARAMS_AMAP;



typedef struct {
   BE_MGMT_PORTAL_AMAP portal;
   BE_UEXACT32_AMAP iscsi_security_flags;
   BE_UEXACT32_AMAP preshared_keysize;
   BE_UEXACT8_AMAP preshared_key[256];
   BE_UEXACT8_AMAP isns_sym_name[256];
} SG_PACK BE_MGMT_PORTAL_ENTRY_AMAP;
typedef struct { u32 dw[137]; } MGMT_PORTAL_ENTRY_AMAP, *PMGMT_PORTAL_ENTRY_AMAP;



typedef struct {
   BE_UEXACT16_AMAP pg_tag;
   BE_UEXACT16_AMAP portal_count;
   BE_MGMT_PORTAL_ENTRY_AMAP portal_list[1];
} SG_PACK BE_MGMT_PORTAL_GROUP_AMAP;
typedef struct { u32 dw[138]; } MGMT_PORTAL_GROUP_AMAP, *PMGMT_PORTAL_GROUP_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_id;
   BE_EXACT8_AMAP target_name[224];
   BE_EXACT8_AMAP target_alias[32];
   BE_UEXACT32_AMAP pg_count;
   BE_MGMT_PORTAL_GROUP_AMAP pg_list[1];
} SG_PACK BE_MGMT_TARGET_INFO_AMAP;
typedef struct { u32 dw[204]; } MGMT_TARGET_INFO_AMAP, *PMGMT_TARGET_INFO_AMAP;


// --- MGMT_DHCP_FLAGS ---
// Bit field definition of dhcp_flags in MGMT_TCPIP_CONFIGURATION 
#define MGMT_DHCP_FLAG_DISABLE_DHCP     (0)       
#define MGMT_DHCP_FLAG_FORCED_RELEASED  (1)       
#define MGMT_DHCP_FLAG_FORCED_RENEW     (2)       
#define MGMT_DHCP_FLAG_ENABLE_DHCP      (4)       // enable DHCP 

typedef enum {
   ENUM_MGMT_DHCP_FLAG_DISABLE_DHCP = 0x0UL,
   ENUM_MGMT_DHCP_FLAG_FORCED_RELEASED = 0x1UL,
   ENUM_MGMT_DHCP_FLAG_FORCED_RENEW = 0x2UL,
   ENUM_MGMT_DHCP_FLAG_ENABLE_DHCP = 0x4UL
} MGMT_DHCP_FLAGS;

// --- MGMT_SUPPORTED_IPVERSIONS ---
// Bit definition of support_ipversions 
#define MGMT_SUPPORTED_IPVERSION_BIT_V4 (1)       // 0=IPV4 is not supported, 1=IPV4 is
                                                  // supported 
#define MGMT_SUPPORTED_IPVERSION_BIT_V6 (2)       // 0=IPV6 is not supported, 1=IPV6 is
                                                  // supported 

typedef enum {
   ENUM_MGMT_SUPPORTED_IPVERSION_BIT_V4 = 0x1UL,
   ENUM_MGMT_SUPPORTED_IPVERSION_BIT_V6 = 0x2UL
} MGMT_SUPPORTED_IPVERSIONS;

// --- MGMT_TCPIPCONFIG_RSVD_FLAG ---
// Bit definition of reserved_flags in MGMT_TCPIP_CONFIGURATION 
#define MGMT_TCPIPCONFIG_RSVD_FLAG_DONOT_RECONNECT_CLOSED_SESSIONS (0) // When set to 0,
                                                                       // after the
                                                                       // firmware change
                                                                       // the HBA IP
                                                                       // address, the
                                                                       // firmware does
                                                                       // NOT need to
                                                                       // reconnect all
                                                                       // the sessions
                                                                       // that is
                                                                       // currently closed
                                                                       // due to session
                                                                       // recovery. 
#define MGMT_TCPIPCONFIG_RSVD_FLAG_RECONNECT_CLOSED_SESSIONS (1) // Only applicable in
                                                                 // IOCTL_SET_TCPIP_CONFIG
                                                                 // operation. It is not
                                                                 // applicable in
                                                                 // IOCTL_GET_TCPIP_CONFIG
                                                                 // . When set, after the
                                                                 // firmware change the
                                                                 // HBA IP address, the
                                                                 // firmware needs to
                                                                 // reconnect all the
                                                                 // sessions that is
                                                                 // currently closed due
                                                                 // to session recovery.
                                                                 // This only applicable
                                                                 // to sessions that has
                                                                 // the status with
                                                                 // MGMT_SESSION_STATUS_CL
                                                                 // OSED_IN_RECOVERY = 1. 

typedef enum {
   ENUM_MGMT_TCPIPCONFIG_RSVD_FLAG_DONOT_RECONNECT_CLOSED_SESSIONS = 0x0UL,
   ENUM_MGMT_TCPIPCONFIG_RSVD_FLAG_RECONNECT_CLOSED_SESSIONS = 0x1UL
} MGMT_TCPIPCONFIG_RSVD_FLAG;


typedef struct {
   BE_IP_ADDRESS_FORMAT_AMAP preferred_dns_server;
   BE_IP_ADDRESS_FORMAT_AMAP alternate_dns_server;
} SG_PACK BE_MGMT_DNS_SERVERS_AMAP;
typedef struct { u32 dw[12]; } MGMT_DNS_SERVERS_AMAP, *PMGMT_DNS_SERVERS_AMAP;



typedef MGMT_DNS_SERVERS_AMAP DNS_SERVERS_AMAP;
typedef BE_MGMT_DNS_SERVERS_AMAP BE_DNS_SERVERS_AMAP;


typedef struct {
   BE_IP_ADDRESS_SUBNET_FORMAT_AMAP ip_address_subnet;
   BE_UEXACT8_AMAP vlan_priority_valid;
   BE_BIT rsvd0[8];                               // DWORD 10
   BE_UEXACT16_AMAP vlan_priority;
} SG_PACK BE_IP_ADDRESS_VLAN_FORMAT_AMAP;
typedef struct { u32 dw[11]; } IP_ADDRESS_VLAN_FORMAT_AMAP, *PIP_ADDRESS_VLAN_FORMAT_AMAP;



typedef struct {
   BE_DNS_SERVERS_AMAP dns_servers;
   BE_IP_ADDRESS_FORMAT_AMAP default_gateway_address;
   BE_UEXACT8_AMAP use_link_local_address;
   BE_UEXACT8_AMAP dhcp_flags;
   BE_UEXACT8_AMAP use_dhcp_for_dns;
   BE_UEXACT8_AMAP supported_ipversions;
   BE_BIT rsvd0[8];                               // DWORD 19
   BE_BIT rsvd1[8];                               // DWORD 19
   BE_BIT rsvd2[8];                               // DWORD 19
   BE_UEXACT8_AMAP ipaddress_count;
   BE_IP_ADDRESS_VLAN_FORMAT_AMAP ipaddress_vlan_list[1];
} SG_PACK BE_TCPIP_CONFIGURATION_AMAP;
typedef struct { u32 dw[31]; } TCPIP_CONFIGURATION_AMAP, *PTCPIP_CONFIGURATION_AMAP;


// --- MGMT_PORT_SPEED ---
// Definition of speed and max_speed in MGMT_NIC_PORT_INFO 
#define MGMT_PORT_SPEED_NOT_AVAILABLE   (0)       
#define MGMT_PORT_SPEED_TEN_BASE_T      (1)       
#define MGMT_PORT_SPEED_HUNDRED_BASE_T  (2)       
#define MGMT_PORT_SPEED_GIGABIT         (3)       
#define MGMT_PORT_SPEED_TEN_GIGABIT     (4)       
#define MGMT_PORT_SPEED_QOS_SET         (2147483648) // On systems where a per-function
                                                     // QoS setting is applicable, this
                                                     // field is OVERLOADED. The
                                                     // BladeEngine supports QoS settings
                                                     // in multiples of 10Mbps. The 2 LSB
                                                     // bytes should be treated as
                                                     // UEXACT16 with the value indicating
                                                     // the speed in multiples of 10Mbps. 

typedef enum {
   ENUM_MGMT_PORT_SPEED_NOT_AVAILABLE = 0x0UL,
   ENUM_MGMT_PORT_SPEED_TEN_BASE_T = 0x1UL,
   ENUM_MGMT_PORT_SPEED_HUNDRED_BASE_T = 0x2UL,
   ENUM_MGMT_PORT_SPEED_GIGABIT = 0x3UL,
   ENUM_MGMT_PORT_SPEED_TEN_GIGABIT = 0x4UL,
   ENUM_MGMT_PORT_SPEED_QOS_SET = 0x80000000UL
} MGMT_PORT_SPEED;

// --- MGMT_LINK_STATE ---
// Definition of link_state in MGMT_NIC_PORT_INFO 
#define MGMT_LINK_STATE_DOWN            (0)       
#define MGMT_LINK_STATE_UP              (1)       

typedef enum {
   ENUM_MGMT_LINK_STATE_DOWN = 0x0UL,
   ENUM_MGMT_LINK_STATE_UP = 0x1UL
} MGMT_LINK_STATE;


typedef struct {
   BE_UEXACT32_AMAP speed;
   BE_UEXACT32_AMAP max_speed;
   BE_UEXACT32_AMAP link_state;
   BE_UEXACT32_AMAP max_frame_size;
   BE_MAC_ADDRESS_FORMAT_AMAP mac_address;
} SG_PACK BE_MGMT_NIC_PORT_INFO_AMAP;
typedef struct { u32 dw[6]; } MGMT_NIC_PORT_INFO_AMAP, *PMGMT_NIC_PORT_INFO_AMAP;


// --- MGMT_HBA_SUPPORT ---
// Bit map definition for functionalities_supported in MGMT_HBA_ATTRIBUTES 
#define MGMT_HBA_SUPPORT_PRESHARED_KEY_CACHE (1)  
#define MGMT_HBA_SUPPORT_ISCSI_AUTHENTICATION_CACHE (2) 
#define MGMT_HBA_SUPPORT_IPSEC_TUNNEL_MODE (4)    
#define MGMT_HBA_SUPPORT_CHAP_VIA_RADIUS (8)      
#define MGMT_HBA_SUPPORT_ISNS_DISCOVERY (16)      
#define MGMT_HBA_SUPPORT_SLP_DISCOVERY  (32)      
#define MGMT_HBA_SUPPORT_BIDISCSICMDS   (64)      
#define MGMT_HBA_SUPPORT_DNS            (128)     
#define MGMT_HBA_SUPPORT_PHY_LOOPBACK   (256)     

typedef enum {
   ENUM_MGMT_HBA_SUPPORT_PRESHARED_KEY_CACHE = 0x1UL,
   ENUM_MGMT_HBA_SUPPORT_ISCSI_AUTHENTICATION_CACHE = 0x2UL,
   ENUM_MGMT_HBA_SUPPORT_IPSEC_TUNNEL_MODE = 0x4UL,
   ENUM_MGMT_HBA_SUPPORT_CHAP_VIA_RADIUS = 0x8UL,
   ENUM_MGMT_HBA_SUPPORT_ISNS_DISCOVERY = 0x10UL,
   ENUM_MGMT_HBA_SUPPORT_SLP_DISCOVERY = 0x20UL,
   ENUM_MGMT_HBA_SUPPORT_BIDISCSICMDS = 0x40UL,
   ENUM_MGMT_HBA_SUPPORT_DNS = 0x80UL,
   ENUM_MGMT_HBA_SUPPORT_PHY_LOOPBACK = 0x100UL
} MGMT_HBA_SUPPORT;

// --- MGMT_HBA_STATUS ---
// Definitions for hba_status in MGMT_HBA_ATTRIBUTES 
#define MGMT_HBA_STATUS_WORKING         (0)       // The ARM is currently running the
                                                  // primary firmware image 
#define MGMT_HBA_STATUS_DEGRADED        (1)       // The ARM is currently running the
                                                  // secondary firmware image. 
#define MGMT_HBA_STATUS_CRITICAL        (2)       
#define MGMT_HBA_STATUS_FAILED          (3)       

typedef enum {
   ENUM_MGMT_HBA_STATUS_WORKING = 0x0UL,
   ENUM_MGMT_HBA_STATUS_DEGRADED = 0x1UL,
   ENUM_MGMT_HBA_STATUS_CRITICAL = 0x2UL,
   ENUM_MGMT_HBA_STATUS_FAILED = 0x3UL
} MGMT_HBA_STATUS;

// --- ASIC_REV_ENUM ---
// These enumerations define the expected asic revision numbers returned as part of
// adapter information in BE_FW_CFG and MGMT_HBA_ATTRIBUTES structures. 
#define ASIC_REV_A0                     (0)       
#define ASIC_REV_A1                     (1)       
#define ASIC_REV_A2                     (2)       

typedef enum {
   ENUM_ASIC_REV_A0 = 0x0UL,
   ENUM_ASIC_REV_A1 = 0x1UL,
   ENUM_ASIC_REV_A2 = 0x2UL
} ASIC_REV_ENUM;

// --- ASIC_GEN_ENUM ---
// These enumerations define the expected asic generation numbers returned as part of
// adapter information in BE_FW_CFG and MGMT_HBA_ATTRIBUTES structures. 
#define ASIC_GEN_BE2                    (0)       
#define ASIC_GEN_BE3                    (3)       

typedef enum {
   ENUM_ASIC_GEN_BE2 = 0x0UL,
   ENUM_ASIC_GEN_BE3 = 0x3UL
} ASIC_GEN_ENUM;

// --- MGMT_HBA_ISCSI_FEATURES ---
#define ISCSI_FEATURE_LIST_MODE         (0)       
#define ISCSI_FEATURE_RING_MODE         (1)       
#define ISCSI_FEATURE_ICD_ALLOC_ON_CHIP (2)       // ICD allocation is done in hardware 
#define ISCSI_FEATURE_INTRPT_REDIRECT   (4)       // firmware supports per-command
                                                  // interrupt redirection 
#define ISCSI_FEATURE_CMD_TO_ON_CHIP    (8)       // command timeout is done in EP
                                                  // firmware 
#define ISCSI_FEATURE_SET_VALID         (128)     

typedef enum {
   ENUM_ISCSI_FEATURE_LIST_MODE = 0x0UL,
   ENUM_ISCSI_FEATURE_RING_MODE = 0x1UL,
   ENUM_ISCSI_FEATURE_ICD_ALLOC_ON_CHIP = 0x2UL,
   ENUM_ISCSI_FEATURE_INTRPT_REDIRECT = 0x4UL,
   ENUM_ISCSI_FEATURE_CMD_TO_ON_CHIP = 0x8UL,
   ENUM_ISCSI_FEATURE_SET_VALID = 0x80UL
} MGMT_HBA_ISCSI_FEATURES;


typedef struct {
   BE_EXACT8_AMAP flashrom_version_string[32];
   BE_EXACT8_AMAP manufacturer_name[32];
   BE_UEXACT32_AMAP supported_modes;
   BE_EXACT8_AMAP seeprom_version_lo;
   BE_EXACT8_AMAP seeprom_version_hi;
   BE_BIT rsvd0[2][8];                            // DWORD 17
   BE_UEXACT32_AMAP ioctl_data_struct_version;
   BE_UEXACT32_AMAP ep_fw_data_struct_version;
   BE_UEXACT8_AMAP ncsi_version_string[12];
   BE_UEXACT32_AMAP default_extended_timeout;
   BE_EXACT8_AMAP controller_model_number[32];
   BE_EXACT8_AMAP controller_description[64];
   BE_EXACT8_AMAP controller_serial_number[32];
   BE_EXACT8_AMAP ip_version_string[32];
   BE_EXACT8_AMAP firmware_version_string[32];
   BE_EXACT8_AMAP bios_version_string[32];
   BE_EXACT8_AMAP redboot_version_string[32];
   BE_EXACT8_AMAP driver_version_string[32];
   BE_EXACT8_AMAP fw_on_flash_version_string[32];
   BE_UEXACT32_AMAP functionalities_supported;
   BE_UEXACT16_AMAP max_cdblength;
   BE_UEXACT8_AMAP asic_revision;
   BE_UEXACT8_AMAP generational_guid[16];
   BE_UEXACT8_AMAP hba_port_count;
   BE_UEXACT16_AMAP default_link_down_timeout;
   BE_UEXACT8_AMAP iscsi_ver_min_max;
   BE_UEXACT8_AMAP multifunction_device;
   BE_UEXACT8_AMAP cache_valid;
   BE_UEXACT8_AMAP hba_status;
   BE_UEXACT8_AMAP max_domains_supported;
   BE_UEXACT8_AMAP phy_port;
   BE_UEXACT32_AMAP firmware_post_status;
   BE_UEXACT32_AMAP hba_mtu[8];
   BE_UEXACT8_AMAP iSCSI_features;
   BE_UEXACT8_AMAP asic_generation;
   BE_UEXACT8_AMAP future_u8[2];
   BE_UEXACT32_AMAP future_u32[3];
} SG_PACK BE_MGMT_HBA_ATTRIBUTES_AMAP;
typedef struct { u32 dw[125]; } MGMT_HBA_ATTRIBUTES_AMAP, *PMGMT_HBA_ATTRIBUTES_AMAP;


// --- MGMT_HBA_IF_TYPES ---
// Controller Attributes 
#define MGMT_HBA_IF_TYPE_INITIATOR      (1)       
#define MGMT_HBA_IF_TYPE_TARGET         (2)       
#define MGMT_HBA_IF_TYPE_TOE            (4)       

typedef enum {
   ENUM_MGMT_HBA_IF_TYPE_INITIATOR = 0x1UL,
   ENUM_MGMT_HBA_IF_TYPE_TARGET = 0x2UL,
   ENUM_MGMT_HBA_IF_TYPE_TOE = 0x4UL
} MGMT_HBA_IF_TYPES;


typedef struct {
   BE_MGMT_HBA_ATTRIBUTES_AMAP hba_attribs;
   BE_UEXACT16_AMAP pci_vendor_id;
   BE_UEXACT16_AMAP pci_device_id;
   BE_UEXACT16_AMAP pci_sub_vendor_id;
   BE_UEXACT16_AMAP pci_sub_system_id;
   BE_UEXACT8_AMAP pci_bus_number;
   BE_UEXACT8_AMAP pci_device_number;
   BE_UEXACT8_AMAP pci_function_number;
   BE_UEXACT8_AMAP interface_type;
   BE_UEXACT64_AMAP unique_identifier;
   BE_UEXACT8_AMAP netfilters;
   BE_BIT rsvd0[3][8];                            // DWORD 130
   BE_UEXACT32_AMAP future_u32[4];
} SG_PACK BE_MGMT_CONTROLLER_ATTRIBUTES_AMAP;
typedef struct { u32 dw[135]; } MGMT_CONTROLLER_ATTRIBUTES_AMAP, *PMGMT_CONTROLLER_ATTRIBUTES_AMAP;


// --- MGMT_PCIE_LINK_WIDTH_ENUM ---
#define PCIE_LINK_WIDTH_X1              (1)       // x1 width
#define PCIE_LINK_WIDTH_X2              (2)       // x2 width
#define PCIE_LINK_WIDTH_X4              (4)       // x4 width
#define PCIE_LINK_WIDTH_X8              (8)       // x8 width
#define PCIE_LINK_WIDTH_X16             (22)      // x16 width
#define PCIE_LINK_WIDTH_X32             (50)      // x32 width

typedef enum {
   ENUM_PCIE_LINK_WIDTH_X1 = 0x1UL,
   ENUM_PCIE_LINK_WIDTH_X2 = 0x2UL,
   ENUM_PCIE_LINK_WIDTH_X4 = 0x4UL,
   ENUM_PCIE_LINK_WIDTH_X8 = 0x8UL,
   ENUM_PCIE_LINK_WIDTH_X16 = 0x16UL,
   ENUM_PCIE_LINK_WIDTH_X32 = 0x32UL
} MGMT_PCIE_LINK_WIDTH_ENUM;

// --- MGMT_PCIE_LINK_SPEED_ENUM ---
#define PCIE_LINK_SPEED_25              (1)       // 2.5 GT/s
#define PCIE_LINK_WIDTH_50              (2)       // 5.0 GT/s

typedef enum {
   ENUM_PCIE_LINK_SPEED_25 = 0x1UL,
   ENUM_PCIE_LINK_WIDTH_50 = 0x2UL
} MGMT_PCIE_LINK_SPEED_ENUM;


typedef struct {
   BE_UEXACT8_AMAP current_link_width;
   BE_UEXACT8_AMAP max_link_width;
   BE_UEXACT8_AMAP current_link_speed;
   BE_UEXACT8_AMAP max_link_speed;
} SG_PACK BE_MGMT_PCIE_INFO_AMAP;
typedef struct { u32 dw[1]; } MGMT_PCIE_INFO_AMAP, *PMGMT_PCIE_INFO_AMAP;



typedef struct {
   BE_UEXACT32_AMAP address_lo;
   BE_UEXACT32_AMAP address_hi;
} SG_PACK BE_MGMT_BUS_ADDRESS32_AMAP;
typedef struct { u32 dw[2]; } MGMT_BUS_ADDRESS32_AMAP, *PMGMT_BUS_ADDRESS32_AMAP;



typedef struct {
   BE_UEXACT64_AMAP address;
} SG_PACK BE_MGMT_BUS_ADDRESS64_AMAP;
typedef struct { u32 dw[2]; } MGMT_BUS_ADDRESS64_AMAP, *PMGMT_BUS_ADDRESS64_AMAP;



typedef union {
   BE_MGMT_BUS_ADDRESS32_AMAP a32;
   BE_MGMT_BUS_ADDRESS64_AMAP a64;
} SG_PACK BE_MGMT_BUS_ADDRESS_U_AMAP;
typedef struct { u32 dw[2]; } MGMT_BUS_ADDRESS_U_AMAP, *PMGMT_BUS_ADDRESS_U_AMAP;



typedef struct {
   BE_MGMT_BUS_ADDRESS_U_AMAP u;
} SG_PACK BE_MGMT_BUS_ADDRESS_AMAP;
typedef struct { u32 dw[2]; } MGMT_BUS_ADDRESS_AMAP, *PMGMT_BUS_ADDRESS_AMAP;



typedef struct {
   BE_MGMT_BUS_ADDRESS_AMAP address;
   BE_UEXACT32_AMAP length;
   BE_UEXACT32_AMAP offset;
} SG_PACK BE_MGMT_SG_ELEMENT_AMAP;
typedef struct { u32 dw[4]; } MGMT_SG_ELEMENT_AMAP, *PMGMT_SG_ELEMENT_AMAP;



typedef struct {
   BE_UEXACT32_AMAP sg_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MGMT_SG_ELEMENT_AMAP sg_list[1];
} SG_PACK BE_MGMT_SG_TABLE_AMAP;
typedef struct { u32 dw[6]; } MGMT_SG_TABLE_AMAP, *PMGMT_SG_TABLE_AMAP;


// --- MPU_RXFILT_UPLOAD ---
#define MPU_RXFILT_TOE_GRACEFUL         (983042)  
#define MPU_RXFILT_TOE_ABORT_RESET      (983044)  
#define MPU_RXFILT_TOE_RESET_SEQNO      (983046)  
#define MPU_RXFILT_TOE_ABORT            (983048)  

typedef enum {
   ENUM_MPU_RXFILT_TOE_GRACEFUL = 0xf0002UL,
   ENUM_MPU_RXFILT_TOE_ABORT_RESET = 0xf0004UL,
   ENUM_MPU_RXFILT_TOE_RESET_SEQNO = 0xf0006UL,
   ENUM_MPU_RXFILT_TOE_ABORT = 0xf0008UL
} MPU_RXFILT_UPLOAD;

// Template header used in the offload IOCTLs.
typedef union {
   BE_TEMPLATE_HEADER_AMAP ethernetII;
   BE_TEMPLATE_HEADER_TS_AMAP ethernetII_ts;
   BE_TEMPLATE_IPV6_HEADER_AMAP ipv6_ethernetII;
   BE_TEMPLATE_IPV6_HEADER_TS_AMAP ipv6_ethernetII_ts;
   BE_TEMPLATE_VLAN_IPV6_HEADER_AMAP vlan_ipv6_ethernetII;
   BE_TEMPLATE_VLAN_IPV6_HEADER_TS_AMAP vlan_ipv6_ethernetII_ts;
   BE_TEMPLATE_VLAN_HEADER_AMAP vlan_ethernetII;
   BE_TEMPLATE_VLAN_HEADER_TS_AMAP vlan_ethernetII_ts;
   BE_TEMPLATE_SNAP_HEADER_AMAP snap;
   BE_TEMPLATE_VLAN_SNAP_HEADER_AMAP vlan_snap;
   BE_BIT rsvd0[32][32];                          // DWORD 0
   struct {
      BE_BIT rsvd0[92][8];                        // DWORD 0
      BE_RXFILT_D_AMAP filter_template[2];
      BE_UEXACT32_AMAP reset_sequence;
   } extra;
} SG_PACK BE_MPU_TEMPLATE_HEADER_AMAP;
typedef struct { u32 dw[32]; } MPU_TEMPLATE_HEADER_AMAP, *PMPU_TEMPLATE_HEADER_AMAP;


//              This structure defines a single offloaded connection entry in the         
//     Offload Connection Table.         
typedef struct {
   BE_BIT mac_id[6];                              // DWORD 0
   BE_BIT rsvd0[26];                              // DWORD 0
   BE_BIT src_port[16];                           // DWORD 1
   BE_BIT dst_port[16];                           // DWORD 1
   BE_BIT src_addr[32];                           // DWORD 2
   BE_BIT dst_addr[32];                           // DWORD 3
   BE_BIT rsvd1[96];                              // DWORD 4
   BE_BIT ct0[2];                                 // DWORD 7
   BE_BIT rsvd2[6];                               // DWORD 7
   BE_BIT ct1[2];                                 // DWORD 7
   BE_BIT rsvd3[21];                              // DWORD 7
   BE_BIT valid;                                  // DWORD 7
} SG_PACK BE_MPU_IPV4_OFFLOAD_CXN_ENTRY_AMAP;
typedef struct { u32 dw[8]; } MPU_IPV4_OFFLOAD_CXN_ENTRY_AMAP, *PMPU_IPV4_OFFLOAD_CXN_ENTRY_AMAP;


//              This structure defines a single offloaded connection entry in the         
//     Offload Connection Table.         
typedef struct {
   BE_BIT mac_id[6];                              // DWORD 0
   BE_BIT rsvd0[26];                              // DWORD 0
   BE_BIT src_port[16];                           // DWORD 1
   BE_BIT dst_port[16];                           // DWORD 1
   BE_BIT src_addr[128];                          // DWORD 2
   BE_BIT da_id[6];                               // DWORD 6
   BE_BIT rsvd1[26];                              // DWORD 6
   BE_BIT ct0[2];                                 // DWORD 7
   BE_BIT rsvd2[6];                               // DWORD 7
   BE_BIT ct1[2];                                 // DWORD 7
   BE_BIT rsvd3[21];                              // DWORD 7
   BE_BIT valid;                                  // DWORD 7
   BE_BIT dst_addr[128];                          // DWORD 8
} SG_PACK BE_MPU_IPV6_OFFLOAD_CXN_ENTRY_AMAP;
typedef struct { u32 dw[12]; } MPU_IPV6_OFFLOAD_CXN_ENTRY_AMAP, *PMPU_IPV6_OFFLOAD_CXN_ENTRY_AMAP;



typedef union {
   BE_MPU_IPV4_OFFLOAD_CXN_ENTRY_AMAP ipv4;
   BE_MPU_IPV6_OFFLOAD_CXN_ENTRY_AMAP ipv6;
} SG_PACK BE_MPU_OFFLOAD_CXN_ENTRY_AMAP;
typedef struct { u32 dw[12]; } MPU_OFFLOAD_CXN_ENTRY_AMAP, *PMPU_OFFLOAD_CXN_ENTRY_AMAP;


// --- ARP_FLAGS ---
// Definition of arp_flags 
#define ARP_TYPE_DYNAMIC                (0)       
#define ARP_TYPE_STATIC                 (4)       

typedef enum {
   ENUM_ARP_TYPE_DYNAMIC = 0x0UL,
   ENUM_ARP_TYPE_STATIC = 0x4UL
} ARP_FLAGS;


typedef struct {
   BE_IP_ADDRESS_FORMAT_AMAP ip_address;
   BE_MAC_ADDRESS_FORMAT_AMAP mac_address;
   BE_UEXACT32_AMAP arp_flags;
   BE_BIT rsvd0[32];                              // DWORD 9
} SG_PACK BE_ARP_TABLE_ENTRY_AMAP;
typedef struct { u32 dw[10]; } ARP_TABLE_ENTRY_AMAP, *PARP_TABLE_ENTRY_AMAP;



typedef struct {
   BE_IP_ADDRESS_SUBNET_FORMAT_AMAP ip_address_subnet;
   BE_IP_ADDRESS_FORMAT_AMAP next_hop;
} SG_PACK BE_ROUTE_TABLE_ENTRY_AMAP;
typedef struct { u32 dw[16]; } ROUTE_TABLE_ENTRY_AMAP, *PROUTE_TABLE_ENTRY_AMAP;


// --- BE_ULP_NUM ---
#define BE_ULP0_NUM                     (0)       // ULP 0 
#define BE_ULP1_NUM                     (1)       // ULP 1 

typedef enum {
   ENUM_BE_ULP0_NUM = 0x0UL,
   ENUM_BE_ULP1_NUM = 0x1UL
} BE_ULP_NUM;

// --- BE_ULP_MASK ---
#define BE_ULP0_MASK                    (1)       // Mask for ULP 0 
#define BE_ULP1_MASK                    (2)       // Mask for ULP 1 

typedef enum {
   ENUM_BE_ULP0_MASK = 0x1UL,
   ENUM_BE_ULP1_MASK = 0x2UL
} BE_ULP_MASK;

// --- IP_ACTION ---
#define IP_ACTION_ADD                   (1)       
#define IP_ACTION_DEL                   (2)       

typedef enum {
   ENUM_IP_ACTION_ADD = 0x1UL,
   ENUM_IP_ACTION_DEL = 0x2UL
} IP_ACTION;

// --- PING_STATE_ENUM ---
#define PING_ENABLED                    (1)       
#define PING_DISABLED                   (2)       

typedef enum {
   ENUM_PING_ENABLED = 0x1UL,
   ENUM_PING_DISABLED = 0x2UL
} PING_STATE_ENUM;

// --- IOCTL_COMPLETION_TYPE ---
#define NON_BLOCKING                    (0)       
#define BLOCKING                        (1)       // This is a blocking call till DHCP
                                                  // server either returns an IP address
                                                  // or times-out
#define DO_NOT_SAVE_IN_FLASH            (2)       // This bit informs ARM FW that the new
                                                  // settings should not commit to flash

typedef enum {
   ENUM_NON_BLOCKING = 0x0UL,
   ENUM_BLOCKING = 0x1UL,
   ENUM_DO_NOT_SAVE_IN_FLASH = 0x2UL
} IOCTL_COMPLETION_TYPE;

// --- IOCTL_CHUTE_TYPE ---
#define IOCTL_CONNECTION_CHUTE_0        (1)       
#define IOCTL_CONNECTION_CHUTE_1        (2)       
#define IOCTL_CONNECTION_CHUTE_2        (3)       

typedef enum {
   ENUM_IOCTL_CONNECTION_CHUTE_0 = 0x1UL,
   ENUM_IOCTL_CONNECTION_CHUTE_1 = 0x2UL,
   ENUM_IOCTL_CONNECTION_CHUTE_2 = 0x3UL
} IOCTL_CHUTE_TYPE;

// --- FLASHROM_TYPE ---
// Flash ROM type. 
#define FLASHROM_SPI                    (0)       
#define FLASHROM_PARALLEL               (1)       

typedef enum {
   ENUM_FLASHROM_SPI = 0x0UL,
   ENUM_FLASHROM_PARALLEL = 0x1UL
} FLASHROM_TYPE;

// --- VLAN_MODES ---
#define NORMAL_VLAN                     (1)       // Normal VLAN tagging supported. 
#define Q_IN_Q_VLAN                     (2)       // QinQ VLAN tagging supported. 

typedef enum {
   ENUM_NORMAL_VLAN = 0x1UL,
   ENUM_Q_IN_Q_VLAN = 0x2UL
} VLAN_MODES;

// --- IPv6_SUPPORT ---
#define IPv6_SUPPORT_ENABLED            (1)       
#define IPv6_SUPPORT_DISABLED           (2)       

typedef enum {
   ENUM_IPv6_SUPPORT_ENABLED = 0x1UL,
   ENUM_IPv6_SUPPORT_DISABLED = 0x2UL
} IPv6_SUPPORT;

// --- DDR_CAS_TYPE ---
#define CAS_3                           (0)       
#define CAS_4                           (1)       
#define CAS_5                           (2)       

typedef enum {
   ENUM_CAS_3 = 0x0UL,
   ENUM_CAS_4 = 0x1UL,
   ENUM_CAS_5 = 0x2UL
} DDR_CAS_TYPE;

// --- DDR_SIZE_TYPE ---
#define SIZE_256MB                      (0)       
#define SIZE_512MB                      (1)       

typedef enum {
   ENUM_SIZE_256MB = 0x0UL,
   ENUM_SIZE_512MB = 0x1UL
} DDR_SIZE_TYPE;

// --- DDR_MODE_TYPE ---
#define DDR_NO_ECC                      (0)       
#define DDR_ECC                         (1)       

typedef enum {
   ENUM_DDR_NO_ECC = 0x0UL,
   ENUM_DDR_ECC = 0x1UL
} DDR_MODE_TYPE;

// --- INTERFACE_TYPE ---
#define CX4_10GB_TYPE                   (0)       
#define XFP_10GB_TYPE                   (1)       
#define SFP_1GB_TYPE                    (2)       
#define SFP_PLUS_10GB_TYPE              (3)       
#define KR_10GB_TYPE                    (4)       
#define KX4_10GB_TYPE                   (5)       
#define BASET_10GB_TYPE                 (6)       // 10G BaseT
#define BASET_1GB_TYPE                  (7)       
#define INTERFACE_10GB_DISABLED         (255)     // Interface type not supported 

typedef enum {
   ENUM_CX4_10GB_TYPE = 0x0UL,
   ENUM_XFP_10GB_TYPE = 0x1UL,
   ENUM_SFP_1GB_TYPE = 0x2UL,
   ENUM_SFP_PLUS_10GB_TYPE = 0x3UL,
   ENUM_KR_10GB_TYPE = 0x4UL,
   ENUM_KX4_10GB_TYPE = 0x5UL,
   ENUM_BASET_10GB_TYPE = 0x6UL,
   ENUM_BASET_1GB_TYPE = 0x7UL,
   ENUM_INTERFACE_10GB_DISABLED = 0xffUL
} INTERFACE_TYPE;

// --- PHY_TYPE ---
#define XAUI                            (0)       
#define AEL_2020                        (1)       // Aeluris/Netlogic 
#define LSI_BRCM1                       (2)       // Peak pre-production board - needs a
                                                  // workaround for Xaui internal clock 
#define LSI_BRCM2                       (3)       // Peak production board 
#define SOLARFLARE                      (4)       // Dell recommended 
#define AMCC_QT2025                     (5)       // AMCC PHY 
#define AMCC_QT2225                     (6)       // AMCC PHY 
#define BRCM_5931                       (7)       // Broadcom Phy used by HP LOM 
#define BE3_INTERNAL_10GB               (8)       // Internal 10GbPHY in BE3 
#define BE3_INTERNAL_1GB                (9)       // Internal 1Gb PHY in BE3 
#define PHY_TYPE_NOT_SUPPORTED          (255)     // 10Gb PHY not available on this board 

typedef enum {
   ENUM_XAUI = 0x0UL,
   ENUM_AEL_2020 = 0x1UL,
   ENUM_LSI_BRCM1 = 0x2UL,
   ENUM_LSI_BRCM2 = 0x3UL,
   ENUM_SOLARFLARE = 0x4UL,
   ENUM_AMCC_QT2025 = 0x5UL,
   ENUM_AMCC_QT2225 = 0x6UL,
   ENUM_BRCM_5931 = 0x7UL,
   ENUM_BE3_INTERNAL_10GB = 0x8UL,
   ENUM_BE3_INTERNAL_1GB = 0x9UL,
   ENUM_PHY_TYPE_NOT_SUPPORTED = 0xffUL
} PHY_TYPE;

// --- XAUI_STATE_ENUM ---
#define XAUI_STATE_ENABLE               (0)       // XAUI enabled. This MUST be the
                                                  // default value for all requests which
                                                  // set/change equalization parameters. 
#define XAUI_STATE_DISABLE              (255)     // The XAUI for both ports may be
                                                  // disabled for EMI tests. There is no
                                                  // provision for turning off individual
                                                  // ports. 

typedef enum {
   ENUM_XAUI_STATE_ENABLE = 0x0UL,
   ENUM_XAUI_STATE_DISABLE = 0xffUL
} XAUI_STATE_ENUM;

// --- VERIFY_MTU ---
#define VERIFY_MTU_ENABLED              (1)       // Set to enable MTU verification by
                                                  // sending a ping of the size defined. 
#define VERIFY_MTU_DISABLED             (2)       // MTU field is used without any
                                                  // verification. 

typedef enum {
   ENUM_VERIFY_MTU_ENABLED = 0x1UL,
   ENUM_VERIFY_MTU_DISABLED = 0x2UL
} VERIFY_MTU;

// --- ICDS_CONFIG ---
#define ICDS_LLDP                       (1)       // Use LLDP to get XML file from TFTP
                                                  // server. Setting this bit allows this
                                                  // capability to be enabled/disabled -
                                                  // see ICDS_LLDP_DEFAULT_ENABLE
#define ICDS_IBFT                       (2)       // Host (BE-BIOS) will provide
                                                  // configuration information to ARM at
                                                  // boot time. Motherboard BIOS will
                                                  // populate the configuration
                                                  // information in host memory using iBFT
                                                  // format. Setting this bit allows this
                                                  // capability to be enabled/ disabled -
                                                  // see ICDS_IBFT_DEFAULT_ENABLE
#define ICDS_LLDP_DEFAULT_ENABLE        (64)      // IBFT mode is enabled by default when
                                                  // ICDS_LLDP is set. This mode can be
                                                  // disabled/enabled using iSCSISelect
#define ICDS_IBFT_DEFAULT_ENABLE        (128)     // IBFT mode is enabled by default when
                                                  // ICDS_IBFT is set. 

typedef enum {
   ENUM_ICDS_LLDP = 0x1UL,
   ENUM_ICDS_IBFT = 0x2UL,
   ENUM_ICDS_LLDP_DEFAULT_ENABLE = 0x40UL,
   ENUM_ICDS_IBFT_DEFAULT_ENABLE = 0x80UL
} ICDS_CONFIG;

// --- ARM_DEBUG_PRINT_LOG ---
#define DEBUG_PRINT_LINE_SIZE           (80)      // Number of characters that are saved
                                                  // per debug print in ARM, This is the
                                                  // buffer size of each debug print log
#define DEBUG_PRINT_MSG_SIZE            (400)     // Total number of debug print log
                                                  // messages that will be saved in DDR 

typedef enum {
   ENUM_DEBUG_PRINT_LINE_SIZE = 0x50UL,
   ENUM_DEBUG_PRINT_MSG_SIZE = 0x190UL
} ARM_DEBUG_PRINT_LOG;

// --- CLP_COMMAND_SET ---
#define CLP_COMMAND_SET_HP              (1)       // CLP command set specified for HP Mezz
                                                  // and Flex10 
#define CLP_COMMAND_SET_FSC             (2)       // CLP command set as defined by FSC 
#define CLP_COMMAND_SET_DELL            (3)       // CLP command set defined by Dell 
#define CLP_COMMAND_SET_IBM_BOFM        (4)       // CLP command set defined for IBM BOFM 
#define CLP_TYPE_NOT_SUPPORTED          (255)     // CLP not supported 

typedef enum {
   ENUM_CLP_COMMAND_SET_HP = 0x1UL,
   ENUM_CLP_COMMAND_SET_FSC = 0x2UL,
   ENUM_CLP_COMMAND_SET_DELL = 0x3UL,
   ENUM_CLP_COMMAND_SET_IBM_BOFM = 0x4UL,
   ENUM_CLP_TYPE_NOT_SUPPORTED = 0xffUL
} CLP_COMMAND_SET;

// --- PORTSWAP_TYPE ---
#define PORT_NOT_SWAPPED_ON_HBA         (1)       
#define PORT_SWAPPED_ON_HBA             (2)       

typedef enum {
   ENUM_PORT_NOT_SWAPPED_ON_HBA = 0x1UL,
   ENUM_PORT_SWAPPED_ON_HBA = 0x2UL
} PORTSWAP_TYPE;

// --- PF_BANDWIDTH ---
#define PF_BANDWIDTH_MBPS_10            (1)       // 10 Mbps
#define PF_BANDWIDTH_MBPS_100           (10)      // 100 Mbps
#define PF_BANDWIDTH_GBPS_1             (100)     // 1 Gbps
#define PF_BANDWIDTH_GBPS_2_5           (250)     // 2.5 Gbps
#define PF_BANDWIDTH_GBPS_5             (500)     // 5 Gbps
#define PF_BANDWIDTH_GBPS_10            (1000)    // 10 Gbps

typedef enum {
   ENUM_PF_BANDWIDTH_MBPS_10 = 0x1UL,
   ENUM_PF_BANDWIDTH_MBPS_100 = 0xaUL,
   ENUM_PF_BANDWIDTH_GBPS_1 = 0x64UL,
   ENUM_PF_BANDWIDTH_GBPS_2_5 = 0xfaUL,
   ENUM_PF_BANDWIDTH_GBPS_5 = 0x1f4UL,
   ENUM_PF_BANDWIDTH_GBPS_10 = 0x3e8UL
} PF_BANDWIDTH;

// --- BOARD_ID ---
#define RAYWIRE2                        (0)       // BE2 RW (SFP+) 
#define BE2_DEBUG                       (1)       // BE2 Debug board (CX4) 
#define SE_HP_Mezz                      (2)       // HP Mezz Card with QT2225
#define SE_IBM_MEZZ                     (3)       // IBM Mezz designed by SE
#define SE_BX900_MEZZ                   (4)       // BE2 Mezz card CX4 
#define HP_LOM                          (5)       // ELX HP mezz card with BRCM PHY
#define HP_ILO_CNA                      (6)       // ELX CNA with Nemo and QT2025
#define HP_MEZZ                         (7)       // ELX CNA with QT2025
#define IBM_CFFH                        (8)       // IBM Mezz
#define IBM_CFFH_MANUF_TEST             (9)       
#define IBM_MIRAGE                      (10)      // TigerShark for IBM
#define IBM_RAPTOR                      (11)      // IBM Mezz
#define DELL_MEZZ                       (12)      
#define ELX_TIGERSHARK                  (13)      // ELX equivalent of RW uses QT2025
#define LSI_PEAK_TGT                    (14)      // LSI Peak 2 10Gb SFP+ Mezz
#define LSI_SNOWSNAKE_TGT               (15)      // LSI SnowSnake 10GbaseT Mezz
#define LSI_ANDRECHTS_TGT               (16)      // LSI Snowmass with QPGE
#define LSI_GLENCOVE_TGT                (17)      // LSI Pike's Peak 2 X 10 Gb Mezz
#define CISCO_AVENGER                   (18)      // Cisco Avenger Mezz 
#define IBM_HUNTER_COMBO                (19)      // IBM Hunter combo FC+FCoE 4 port card
#define DOTHILL_1                       (20)      // Dothill's proprietary iSCSI Target -
                                                  // model unknown 
#define PROMISE_1                       (21)      // Promise Tech 
#define IBM_ENDEAVOR                    (22)      // IBM Endeavor 
#define FSC_MEZZ                        (23)      // FSC Mezz 
#define SNOWSNAKE                       (24)      // LSI BE2 10G BASE-T generic
#define ELX_TOMCAT                      (25)      // ELX equivalent of TigerShark for BE3 
#define HP_MEZZ_BE3                     (26)      
#define HP_LOM_BE3                      (27)      
#define HP_ILO_CNA_BE3                  (28)      
#define IBM_MEZZ_BE3                    (29)      
#define IBM_MIRAGE_BE3                  (30)      
#define IBM_ENDEAVOR_BE3                (31)      
#define DELL_MEZZ_BE3                   (32)      
#define CISCO_AVENGER_BE3               (33)      
#define FTS_MEZZ_BE3                    (34)      
#define FTS_CNA_BE3                     (35)      
#define IBM_LOM_BE3                     (36)      
#define SNOWSNAKE_DELL                  (37)      // LSI BE2 10G BASE-T Mercury
#define FTS_LOM_BE3                     (38)      
#define BE3_DEBUG                       (39)      // BE3 debug board 2 X 10Gb + 4 X 1Gb 
#define DH_10GBASET_CNA_BE2             (40)      // Dothill BE2 board with 10 GBASET
                                                  // interface 
#define IBM_TIGERSHARK                  (41)      
#define IBM_BLACKTIP                    (42)      
#define IBM_KONG                        (43)      
#define IBM_DABUBE                      (44)      
#define IBM_SHADOWGLEN                  (45)      
#define IBM_WILDCAT                     (46)      
#define IBM_AUGUSTA_BE3                 (47)      // IBM Augusta BE3 
#define IBM_MLOM_ES_BE3                 (48)      // IBM USI MLOM ES BE3 
#define IBM_MLOM_ER_BE3                 (49)      // IBM USI MLOM ER BE3 
#define HP_HARRIER_BE3                  (50)      // HP Harrier BE3 
#define IBM_LOM_CONGO                   (51)      // IBM LOM, CONGO 
#define HITACHI_MEZZ_BE3                (52)      // HITACHI BS2000 MEZZ BE3 
#define HP_LOM_Tiger_BE3                (53)      // HP LOM Tiger BE3 
#define HP_ALOM_BE3                     (54)      // HP ALOM BE3 
#define HP_BLOM_BE3                     (55)      // HP BLOM BE3 
#define IBM_TOPHAT_MEZZ_BE3             (56)      // IBM TOPHAT BE3 MEZZ 
#define HITACHI_BSX_MEZZ_BE3            (57)      // HITACHI BSX BE3 MEZZ 
#define IBM_ROBALO_MEZZ_BE3             (58)      // IBM ROBALO BE3 MEZZ 
#define HITACHI_VOYAGER_LOM_BE3         (59)      // HITACHI VOYAGER LOM BE3 
#define HITACHI_VENTURA_LOM_BE3         (60)      // HITACHI VENTURA LOM BE3 

typedef enum {
   ENUM_RAYWIRE2 = 0x0UL,
   ENUM_BE2_DEBUG = 0x1UL,
   ENUM_SE_HP_Mezz = 0x2UL,
   ENUM_SE_IBM_MEZZ = 0x3UL,
   ENUM_SE_BX900_MEZZ = 0x4UL,
   ENUM_HP_LOM = 0x5UL,
   ENUM_HP_ILO_CNA = 0x6UL,
   ENUM_HP_MEZZ = 0x7UL,
   ENUM_IBM_CFFH = 0x8UL,
   ENUM_IBM_CFFH_MANUF_TEST = 0x9UL,
   ENUM_IBM_MIRAGE = 0xaUL,
   ENUM_IBM_RAPTOR = 0xbUL,
   ENUM_DELL_MEZZ = 0xcUL,
   ENUM_ELX_TIGERSHARK = 0xdUL,
   ENUM_LSI_PEAK_TGT = 0xeUL,
   ENUM_LSI_SNOWSNAKE_TGT = 0xfUL,
   ENUM_LSI_ANDRECHTS_TGT = 0x10UL,
   ENUM_LSI_GLENCOVE_TGT = 0x11UL,
   ENUM_CISCO_AVENGER = 0x12UL,
   ENUM_IBM_HUNTER_COMBO = 0x13UL,
   ENUM_DOTHILL_1 = 0x14UL,
   ENUM_PROMISE_1 = 0x15UL,
   ENUM_IBM_ENDEAVOR = 0x16UL,
   ENUM_FSC_MEZZ = 0x17UL,
   ENUM_SNOWSNAKE = 0x18UL,
   ENUM_ELX_TOMCAT = 0x19UL,
   ENUM_HP_MEZZ_BE3 = 0x1aUL,
   ENUM_HP_LOM_BE3 = 0x1bUL,
   ENUM_HP_ILO_CNA_BE3 = 0x1cUL,
   ENUM_IBM_MEZZ_BE3 = 0x1dUL,
   ENUM_IBM_MIRAGE_BE3 = 0x1eUL,
   ENUM_IBM_ENDEAVOR_BE3 = 0x1fUL,
   ENUM_DELL_MEZZ_BE3 = 0x20UL,
   ENUM_CISCO_AVENGER_BE3 = 0x21UL,
   ENUM_FTS_MEZZ_BE3 = 0x22UL,
   ENUM_FTS_CNA_BE3 = 0x23UL,
   ENUM_IBM_LOM_BE3 = 0x24UL,
   ENUM_SNOWSNAKE_DELL = 0x25UL,
   ENUM_FTS_LOM_BE3 = 0x26UL,
   ENUM_BE3_DEBUG = 0x27UL,
   ENUM_DH_10GBASET_CNA_BE2 = 0x28UL,
   ENUM_IBM_TIGERSHARK = 0x29UL,
   ENUM_IBM_BLACKTIP = 0x2aUL,
   ENUM_IBM_KONG = 0x2bUL,
   ENUM_IBM_DABUBE = 0x2cUL,
   ENUM_IBM_SHADOWGLEN = 0x2dUL,
   ENUM_IBM_WILDCAT = 0x2eUL,
   ENUM_IBM_AUGUSTA_BE3 = 0x2fUL,
   ENUM_IBM_MLOM_ES_BE3 = 0x30UL,
   ENUM_IBM_MLOM_ER_BE3 = 0x31UL,
   ENUM_HP_HARRIER_BE3 = 0x32UL,
   ENUM_IBM_LOM_CONGO = 0x33UL,
   ENUM_HITACHI_MEZZ_BE3 = 0x34UL,
   ENUM_HP_LOM_Tiger_BE3 = 0x35UL,
   ENUM_HP_ALOM_BE3 = 0x36UL,
   ENUM_HP_BLOM_BE3 = 0x37UL,
   ENUM_IBM_TOPHAT_MEZZ_BE3 = 0x38UL,
   ENUM_HITACHI_BSX_MEZZ_BE3 = 0x39UL,
   ENUM_IBM_ROBALO_MEZZ_BE3 = 0x3aUL,
   ENUM_HITACHI_VOYAGER_LOM_BE3 = 0x3bUL,
   ENUM_HITACHI_VENTURA_LOM_BE3 = 0x3cUL
} BOARD_ID;

// --- SEEPROM_PORT_MAP ---
// These values are used to distinguish between 10G and 1G ports. Throughout most of our
// software we represent the 4 physical ports as a number 0-3, inclusive. This does not
// convey any information about 10Gb vs. 1Gb internal MAC. Thus we use these values to
// make that distinction. 
#define SEEPROM_PORT_MAP_10G_0          (0)       // 10Gb MAC port 0 
#define SEEPROM_PORT_MAP_10G_1          (1)       // 10Gb MAC port 1 
#define SEEPROM_PORT_MAP_1G_A           (2)       // 1Gb MAC port A 
#define SEEPROM_PORT_MAP_1G_B           (3)       // 1Gb MAC port B 
#define SEEPROM_PORT_MAP_1G_C           (4)       // 1Gb MAC port C 
#define SEEPROM_PORT_MAP_1G_D           (5)       // 1Gb MAC port D 

typedef enum {
   ENUM_SEEPROM_PORT_MAP_10G_0 = 0x0UL,
   ENUM_SEEPROM_PORT_MAP_10G_1 = 0x1UL,
   ENUM_SEEPROM_PORT_MAP_1G_A = 0x2UL,
   ENUM_SEEPROM_PORT_MAP_1G_B = 0x3UL,
   ENUM_SEEPROM_PORT_MAP_1G_C = 0x4UL,
   ENUM_SEEPROM_PORT_MAP_1G_D = 0x5UL
} SEEPROM_PORT_MAP;

// --- MISC_PARAMS ---
// Various port and board-specific parameters 
#define CLOCK_156_MHZ                   (0)       // 156 Mhz 
#define CLOCK_31_25_MHZ                 (1)       // 31.25 Mhz
#define AN_PARALLEL_EN                  (2)       // Auto Neg parallel enabled 
#define AN_PARALLEL_DIS                 (4)       // Auto Neg disabled 
#define FORCED_10GB                     (8)       // Forced 10 Gb 
#define FORCED_1GB                      (16)      // Forced 1Gb 
#define PAUSE_DIS                       (32)      // Pause disabled 
#define PAUSE_ASYM                      (64)      // Pause asymmetric 
#define PAUSE_SYM                       (128)     // Pause symmetric 
#define AD_ENABLE                       (256)     // Auto detect enabled 
#define AD_DISABLE                      (512)     // Auto detect disabled 
#define FEC_CAPABLE                     (1024)    // Forward Error Correction capable 
#define FEC_REQUEST                     (2048)    // Forward Error Correction requested 
#define FW_DOWNLOAD_FROM_HOST           (4096)    // Redboot waits for firmware to be
                                                  // downloaded from host

typedef enum {
   ENUM_CLOCK_156_MHZ = 0x0UL,
   ENUM_CLOCK_31_25_MHZ = 0x1UL,
   ENUM_AN_PARALLEL_EN = 0x2UL,
   ENUM_AN_PARALLEL_DIS = 0x4UL,
   ENUM_FORCED_10GB = 0x8UL,
   ENUM_FORCED_1GB = 0x10UL,
   ENUM_PAUSE_DIS = 0x20UL,
   ENUM_PAUSE_ASYM = 0x40UL,
   ENUM_PAUSE_SYM = 0x80UL,
   ENUM_AD_ENABLE = 0x100UL,
   ENUM_AD_DISABLE = 0x200UL,
   ENUM_FEC_CAPABLE = 0x400UL,
   ENUM_FEC_REQUEST = 0x800UL,
   ENUM_FW_DOWNLOAD_FROM_HOST = 0x1000UL
} MISC_PARAMS;

// --- WOL_CAPABILITY_ENUM ---
#define WOL_CAPABILITY_PME_D0           (1)       // Wake support from D0. 
#define WOL_CAPABILITY_PME_D1           (2)       // Wake support from D1. 
#define WOL_CAPABILITY_PME_D2           (4)       // Wake support from D2. 
#define WOL_CAPABILITY_PME_D3HOT        (8)       // Wake support from D3hot. 
#define WOL_CAPABILITY_PME_D3COLD       (16)      // Wake support from D3cold. 
#define WOL_CAPABILITY_NCSI_MAGIC_MAC_SUPPORTED (32) // Indicates WoL capability bits are
                                                     // valid. 

typedef enum {
   ENUM_WOL_CAPABILITY_PME_D0 = 0x1UL,
   ENUM_WOL_CAPABILITY_PME_D1 = 0x2UL,
   ENUM_WOL_CAPABILITY_PME_D2 = 0x4UL,
   ENUM_WOL_CAPABILITY_PME_D3HOT = 0x8UL,
   ENUM_WOL_CAPABILITY_PME_D3COLD = 0x10UL,
   ENUM_WOL_CAPABILITY_NCSI_MAGIC_MAC_SUPPORTED = 0x20UL
} WOL_CAPABILITY_ENUM;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_types_amap_h__

