/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_vpd_amap_h__
#define __ioctl_vpd_amap_h__
#include "setypes.h"
#include "defines.h"
#include "nativedefs.h"
#include "ioctl_defs.h"
#include "ioctl_opcodes.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- VPD_FUNCTION_TYPE ---
// Function Type for which VPD is requested. Only functions 2 & 3 in BE3 can have value
// other than 0. 
#define VPD_FUNCTION_TYPE_NIC           (0)       
#define VPD_FUNCTION_TYPE_ISCSI         (1)       
#define VPD_FUNCTION_TYPE_FCOE          (2)       

typedef enum {
   ENUM_VPD_FUNCTION_TYPE_NIC = 0x0UL,
   ENUM_VPD_FUNCTION_TYPE_ISCSI = 0x1UL,
   ENUM_VPD_FUNCTION_TYPE_FCOE = 0x2UL
} VPD_FUNCTION_TYPE;

// --- VPD_VF_TYPE ---
#define VPD_VF_TYPE_PF                  (0)       // This is a Physical function 
#define VPD_VF_TYPE_VF                  (1)       // This is a Virtual Function 

typedef enum {
   ENUM_VPD_VF_TYPE_PF = 0x0UL,
   ENUM_VPD_VF_TYPE_VF = 0x1UL
} VPD_VF_TYPE;

// --- VPD_DATA_STORE_SIZE ---
// VPD data sizes for physical function and virtual functions. 
#define VPD_DATA_STORE_SIZE_VF          (512)     
#define VPD_DATA_STORE_SIZE_PF          (1024)    

typedef enum {
   ENUM_VPD_DATA_STORE_SIZE_VF = 0x200UL,
   ENUM_VPD_DATA_STORE_SIZE_PF = 0x400UL
} VPD_DATA_STORE_SIZE;


typedef struct {
   BE_UEXACT16_AMAP function_num;
   BE_UEXACT8_AMAP function_type;
   BE_UEXACT8_AMAP vf;
   BE_BIT rsvd0[32];                              // DWORD 1
} SG_PACK BE_COMMON_GET_VPD_DATA_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } COMMON_GET_VPD_DATA_PARAMS_IN_AMAP, *PCOMMON_GET_VPD_DATA_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP vpd_data[1];
} SG_PACK BE_COMMON_GET_VPD_DATA_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } COMMON_GET_VPD_DATA_PARAMS_OUT_AMAP, *PCOMMON_GET_VPD_DATA_PARAMS_OUT_AMAP;



typedef union {
   BE_COMMON_GET_VPD_DATA_PARAMS_IN_AMAP request;
   BE_COMMON_GET_VPD_DATA_PARAMS_OUT_AMAP response;
} SG_PACK BE_COMMON_GET_VPD_DATA_PARAMS_AMAP;
typedef struct { u32 dw[2]; } COMMON_GET_VPD_DATA_PARAMS_AMAP, *PCOMMON_GET_VPD_DATA_PARAMS_AMAP;


//              This IOCTL reads VPD data from BE3 flash.             <ol>                
// <li> Set vf field to VPD_VF_TYPE_VF to read VPD data for a virtual function. Set it to 
//                      VPD_VF_TYPE_PF to read VPD data for a physical function.          
//       <li> Check the IOCTL status in the response.                 <ul>                
//     <li> If the status is [link]MGMT_STATUS_SUCCESS[/link],                     <ul>   
//                      <li> The IOCTL returned VPD of requested function.                
//     </ul>                     <li> If the IOCTL status response is
// [link]MGMT_STATUS_VPD_FUNCTION_TYPE_INCORRECT[/link]                            
// Function type passed in type field is not valid for the function number.               
//              Note: Only function 2 & 3 can have type iSCSI or FCoE.                    
// <li> If the IOCTL status response is [link]MGMT_STATUS_VPD_FUNCTION_OUT_OF_RANGE[/link]
//                             Function number is out of range, if vf field is set to
// VPD_VF_TYPE_VF this number                              cannot exceed 255, if vf field
// is VPD_VF_TYPE_PF, then this number cannot exceed 7.                     <li> Ioctl
// status response is [link]MGMT_STATUS_INSUFFICIENT_BUFFER[/link]                        
//     If the vf field is set to VPD_VF_TYPE_VF, then the request size int the IOCTL
// header                             must be greater than or equal to 520 bytes. If vf
// field is VPD_VF_TYPE_PF, then                              the request size in the
// IOCTL header greater than or equal to 1032 bytes.                  </ul>            
// </ol>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_COMMON_GET_VPD_DATA_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_VPD_DATA_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_GET_VPD_DATA_AMAP, *PIOCTL_COMMON_GET_VPD_DATA_AMAP;



typedef struct {
   BE_UEXACT16_AMAP function_num;
   BE_UEXACT8_AMAP function_type;
   BE_UEXACT8_AMAP vf;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_UEXACT8_AMAP vpd_data[1];
} SG_PACK BE_COMMON_SET_VPD_DATA_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } COMMON_SET_VPD_DATA_PARAMS_IN_AMAP, *PCOMMON_SET_VPD_DATA_PARAMS_IN_AMAP;



typedef union {
   BE_COMMON_SET_VPD_DATA_PARAMS_IN_AMAP request;
} SG_PACK BE_COMMON_SET_VPD_DATA_PARAMS_AMAP;
typedef struct { u32 dw[3]; } COMMON_SET_VPD_DATA_PARAMS_AMAP, *PCOMMON_SET_VPD_DATA_PARAMS_AMAP;


//              This IOCTL writes VPD data to BE3 flash.             <ol>                
// <li> If vf field is set the function number is a virtual function number else it is a  
//                    physical function number.                 <li> Check the IOCTL
// status in the response.                 <ul>                     <li> If the status is
// [link]MGMT_STATUS_SUCCESS[/link],                     <ul>                         <li>
// The IOCTL returned VPD of requested function.                     </ul>                
//     <li> If the IOCTL status response is
// [link]MGMT_STATUS_VPD_FUNCTION_TYPE_INCORRECT[/link]                            
// Function type passed in type field is not valid for the function number.               
//              Note: Only function 2 & 3 can have type iSCSI or FCoE.                    
// <li> If the IOCTL status response is [link]MGMT_STATUS_VPD_FUNCTION_OUT_OF_RANGE[/link]
//                             Function number is out of range, if vf field is set to
// VPD_VF_TYPE_VF this number                              cannot exceed 255, if vf field
// is VPD_VF_TYPE_PF, then this number cannot exceed 7.                     <li> Ioctl
// status response is [link]MGMT_STATUS_INSUFFICIENT_BUFFER[/link]                        
//     If the vf field is set to VPD_VF_TYPE_VF, then the request size int the IOCTL
// header                             must be greater than or equal to 520 bytes. If vf
// field is VPD_VF_TYPE_PF, then                              the request size in the
// IOCTL header greater than or equal to 1032 bytes.                  </ul>            
// </ol>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_COMMON_SET_VPD_DATA_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_VPD_DATA_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_SET_VPD_DATA_AMAP, *PIOCTL_COMMON_SET_VPD_DATA_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_vpd_amap_h__

