/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __pcicfg_amap_h__
#define __pcicfg_amap_h__
#include "setypes.h"
#include "defines.h"
#include "mpu_local_mmr.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// Vendor and Device ID Register.
typedef struct {
   BE_BIT vendorid[16];                           // DWORD 0
   BE_BIT deviceid[16];                           // DWORD 0
} SG_PACK BE_PCICFG_ID_F0_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ID_F0_CSR_AMAP, *PPCICFG_ID_F0_CSR_AMAP;


// Vendor and Device ID Register.
typedef struct {
   BE_BIT vendorid[16];                           // DWORD 0
   BE_BIT deviceid[16];                           // DWORD 0
} SG_PACK BE_PCICFG_ID_F1_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ID_F1_CSR_AMAP, *PPCICFG_ID_F1_CSR_AMAP;


// Command and Status Register.
typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT memen;                                  // DWORD 0
   BE_BIT bmen;                                   // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT perrsp;                                 // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT serren;                                 // DWORD 0
   BE_BIT rsvd3;                                  // DWORD 0
   BE_BIT intxdisable;                            // DWORD 0
   BE_BIT rsvd4[5];                               // DWORD 0
   BE_BIT rsvd5[3];                               // DWORD 0
   BE_BIT intstat;                                // DWORD 0
   BE_BIT cap;                                    // DWORD 0
   BE_BIT rsvd6;                                  // DWORD 0
   BE_BIT rsvd7;                                  // DWORD 0
   BE_BIT rsvd8;                                  // DWORD 0
   BE_BIT dpderr;                                 // DWORD 0
   BE_BIT rsvd9[2];                               // DWORD 0
   BE_BIT stabt;                                  // DWORD 0
   BE_BIT rtabt;                                  // DWORD 0
   BE_BIT rmabt;                                  // DWORD 0
   BE_BIT sserr;                                  // DWORD 0
   BE_BIT dperr;                                  // DWORD 0
} SG_PACK BE_PCICFG_COMMAND_STATUS_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_COMMAND_STATUS_CSR_AMAP, *PPCICFG_COMMAND_STATUS_CSR_AMAP;


// Class Code and Revision ID Register. This register identifies the type of Device.
typedef struct {
   BE_BIT rev[8];                                 // DWORD 0
   BE_BIT prgintf[8];                             // DWORD 0
   BE_BIT subclass[8];                            // DWORD 0
   BE_BIT baseclass[8];                           // DWORD 0
} SG_PACK BE_PCICFG_CLASS_REV_F0_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CLASS_REV_F0_CSR_AMAP, *PPCICFG_CLASS_REV_F0_CSR_AMAP;


// Class Code and Revision ID Register. This register identifies the type of Device.
typedef struct {
   BE_BIT rev[8];                                 // DWORD 0
   BE_BIT prgintf[8];                             // DWORD 0
   BE_BIT subclass[8];                            // DWORD 0
   BE_BIT baseclass[8];                           // DWORD 0
} SG_PACK BE_PCICFG_CLASS_REV_F1_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CLASS_REV_F1_CSR_AMAP, *PPCICFG_CLASS_REV_F1_CSR_AMAP;


// Cache Line Size, Latency, PCI Header Type, and BIST Register.
typedef struct {
   BE_BIT cache_size[8];                          // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT rsvd1[5];                               // DWORD 0
   BE_BIT header_type[8];                         // DWORD 0
   BE_BIT bist[8];                                // DWORD 0
} SG_PACK BE_PCICFG_CACHE_TMR_HDR_BIST_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CACHE_TMR_HDR_BIST_CSR_AMAP, *PPCICFG_CACHE_TMR_HDR_BIST_CSR_AMAP;


// IO Bar Register.
typedef struct {
   BE_BIT iospace;                                // DWORD 0
   BE_BIT rsvd0[7];                               // DWORD 0
   BE_BIT iobar[24];                              // DWORD 0
} SG_PACK BE_PCICFG_IOBAR_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IOBAR_CSR_AMAP, *PPCICFG_IOBAR_CSR_AMAP;


// Memory BAR 0 Register.
typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
   BE_BIT membar0[18];                            // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR0_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR0_CSR_AMAP, *PPCICFG_MEMBAR0_CSR_AMAP;


// Memory BAR 1 - Low Address Register.
typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[13];                              // DWORD 0
   BE_BIT membar1lo[15];                          // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR1_LO_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR1_LO_CSR_AMAP, *PPCICFG_MEMBAR1_LO_CSR_AMAP;


// Memory BAR 1 - High Address Register.
typedef struct {
   BE_BIT membar1hi[32];                          // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR1_HI_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR1_HI_CSR_AMAP, *PPCICFG_MEMBAR1_HI_CSR_AMAP;


// Memory BAR 2 - Low Address Register.
typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[13];                              // DWORD 0
   BE_BIT memsp_pgsize_0;                         // DWORD 0
   BE_BIT memsp_pgsize_1;                         // DWORD 0
   BE_BIT memsp_pgsize_2;                         // DWORD 0
   BE_BIT memsp_pgsize_3;                         // DWORD 0
   BE_BIT membar2lo[11];                          // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR2_LO_F0_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR2_LO_F0_CSR_AMAP, *PPCICFG_MEMBAR2_LO_F0_CSR_AMAP;


// Memory BAR 2 - Low Address Register.
typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[18];                              // DWORD 0
   BE_BIT memsp_pgsize_0;                         // DWORD 0
   BE_BIT memsp_pgsize_1;                         // DWORD 0
   BE_BIT memsp_pgsize_2;                         // DWORD 0
   BE_BIT memsp_pgsize_3;                         // DWORD 0
   BE_BIT membar2lo[6];                           // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR2_LO_F1_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR2_LO_F1_CSR_AMAP, *PPCICFG_MEMBAR2_LO_F1_CSR_AMAP;


// Memory BAR 2 - High Address Register.
typedef struct {
   BE_BIT membar2hi[32];                          // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR2_HI_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR2_HI_CSR_AMAP, *PPCICFG_MEMBAR2_HI_CSR_AMAP;


// Subsystem Vendor and ID (Function 0) Register.
typedef struct {
   BE_BIT subsys_vendor_id[16];                   // DWORD 0
   BE_BIT subsys_id[16];                          // DWORD 0
} SG_PACK BE_PCICFG_SUBSYSTEM_ID_F0_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SUBSYSTEM_ID_F0_CSR_AMAP, *PPCICFG_SUBSYSTEM_ID_F0_CSR_AMAP;


// Subsystem Vendor and ID (Function 1) Register.
typedef struct {
   BE_BIT subsys_vendor_id[16];                   // DWORD 0
   BE_BIT subsys_id[16];                          // DWORD 0
} SG_PACK BE_PCICFG_SUBSYSTEM_ID_F1_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SUBSYSTEM_ID_F1_CSR_AMAP, *PPCICFG_SUBSYSTEM_ID_F1_CSR_AMAP;


// Expansion ROM Enable and Base Address Register.
typedef struct {
   BE_BIT exprombarenable;                        // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT exprombar[16];                          // DWORD 0
} SG_PACK BE_PCICFG_EXP_ROM_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_EXP_ROM_CSR_AMAP, *PPCICFG_EXP_ROM_CSR_AMAP;


// Capabilities List Pointer Register.
typedef struct {
   BE_BIT capptr[8];                              // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_PCICFG_CAP_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_CAP_CSR_AMAP, *PPCICFG_CAP_CSR_AMAP;


// Maximum Latency, Minimum Grant, and Interrupt Pins Register.
typedef struct {
   BE_BIT int_line[8];                            // DWORD 0
   BE_BIT int_pin[8];                             // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_PCICFG_LATENCY_INT_F0_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_LATENCY_INT_F0_CSR_AMAP, *PPCICFG_LATENCY_INT_F0_CSR_AMAP;


// Maximum Latency, Minimum Grant, and Interrupt Pins Register.
typedef struct {
   BE_BIT int_line[8];                            // DWORD 0
   BE_BIT int_pin[8];                             // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_PCICFG_LATENCY_INT_F1_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_LATENCY_INT_F1_CSR_AMAP, *PPCICFG_LATENCY_INT_F1_CSR_AMAP;


// Semaphore Register.
typedef struct {
   BE_BIT locked;                                 // DWORD 0
   BE_BIT rsvd0[31];                              // DWORD 0
} SG_PACK BE_PCICFG_SEMAPHORE_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SEMAPHORE_CSR_AMAP, *PPCICFG_SEMAPHORE_CSR_AMAP;


// Soft Reset Register.
typedef struct {
   BE_BIT rsvd0[7];                               // DWORD 0
   BE_BIT softreset;                              // DWORD 0
   BE_BIT exception_oe;                           // DWORD 0
   BE_BIT PCIe_TOP_RST_RSM_B_for_wake_sel;        // DWORD 0
   BE_BIT dbg_all_reqs_62_49[14];                 // DWORD 0
   BE_BIT nec_ll_rcvdetect[8];                    // DWORD 0
} SG_PACK BE_PCICFG_SOFT_RESET_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SOFT_RESET_CSR_AMAP, *PPCICFG_SOFT_RESET_CSR_AMAP;


// Debug Registers.
typedef struct {
   BE_BIT debugselect[8];                         // DWORD 0
   BE_BIT debugblock[8];                          // DWORD 0
   BE_BIT debugchain[4];                          // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
   BE_BIT debugin;                                // DWORD 0
   BE_BIT debugout;                               // DWORD 0
} SG_PACK BE_PCICFG_DEBUG_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_DEBUG_CSR_AMAP, *PPCICFG_DEBUG_CSR_AMAP;


// --- PCICFG_MEMBAR_CONTROL_WINSEL_ENUM ---
#define PCICFG_MEMBAR_CONTROL_WINSEL_DISABLE (0)  // Disabled
#define PCICFG_MEMBAR_CONTROL_WINSEL_MEMBAR0 (1)  // Memory BAR 0
#define PCICFG_MEMBAR_CONTROL_WINSEL_MEMBAR1 (2)  // Memory BAR 1
#define PCICFG_MEMBAR_CONTROL_WINSEL_MEMBAR2 (3)  // Memory BAR 2

typedef enum {
   ENUM_PCICFG_MEMBAR_CONTROL_WINSEL_DISABLE = 0x0UL,
   ENUM_PCICFG_MEMBAR_CONTROL_WINSEL_MEMBAR0 = 0x1UL,
   ENUM_PCICFG_MEMBAR_CONTROL_WINSEL_MEMBAR1 = 0x2UL,
   ENUM_PCICFG_MEMBAR_CONTROL_WINSEL_MEMBAR2 = 0x3UL
} PCICFG_MEMBAR_CONTROL_WINSEL_ENUM;

// Memory BAR Control Register.
typedef struct {
   BE_BIT winmode;                                // DWORD 0
   BE_BIT membarwinen;                            // DWORD 0
   BE_BIT winaddr[23];                            // DWORD 0
   BE_BIT vf_cev_int_line_en;                     // DWORD 0
   BE_BIT PFNUM[3];                               // DWORD 0
   BE_BIT hostintr;                               // DWORD 0
   BE_BIT winselect[2];                           // DWORD 0
} SG_PACK BE_PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_AMAP, *PPCICFG_MEMBAR_CTRL_INT_CTRL_CSR_AMAP;


// General Purpose Input Register.
typedef struct {
   BE_BIT gpi[32];                                // DWORD 0
} SG_PACK BE_PCICFG_GPI_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GPI_CSR_AMAP, *PPCICFG_GPI_CSR_AMAP;


// General Purpose Output Register (Low).
typedef struct {
   BE_BIT gpo[32];                                // DWORD 0
} SG_PACK BE_PCICFG_GPO_LOW_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GPO_LOW_CSR_AMAP, *PPCICFG_GPO_LOW_CSR_AMAP;


// General Purpose Output Register (High).
typedef struct {
   BE_BIT gpo[32];                                // DWORD 0
} SG_PACK BE_PCICFG_GPO_HI_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GPO_HI_CSR_AMAP, *PPCICFG_GPO_HI_CSR_AMAP;


// General Purpose Input Output Register Map.
typedef struct {
   BE_BIT gpomap[32];                             // DWORD 0
} SG_PACK BE_PCICFG_GPIOMAP_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_GPIOMAP_CSR_AMAP, *PPCICFG_GPIOMAP_CSR_AMAP;


// General Purpose Input Output Control Register.
typedef struct {
   BE_BIT exception_oe;                           // DWORD 0
   BE_BIT host_dbg_mux_data_core_46_16[31];       // DWORD 0
} SG_PACK BE_PCIECFG_BE_EXCEPTION_CTRL_CSR_AMAP;
typedef struct { u32 dw[1]; } PCIECFG_BE_EXCEPTION_CTRL_CSR_AMAP, *PPCIECFG_BE_EXCEPTION_CTRL_CSR_AMAP;


// Host Interrupt Status Register.
typedef struct {
   BE_BIT tmr;                                    // DWORD 0
   BE_BIT err;                                    // DWORD 0
   BE_BIT softrst;                                // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT gpiintr;                                // DWORD 0
   BE_BIT pwrstate_change_intr;                   // DWORD 0
   BE_BIT FLR_intr;                               // DWORD 0
   BE_BIT ats_en_change_intr;                     // DWORD 0
   BE_BIT msixtbl_perr_intr;                      // DWORD 0
   BE_BIT link_error_max_intr;                    // DWORD 0
   BE_BIT aspm_change_intr;                       // DWORD 0
   BE_BIT LTSSM_L0_state_change_intr;             // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT rsvd2[16];                              // DWORD 0
} SG_PACK BE_PCICFG_HOST_INT_STATUS_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_INT_STATUS_CSR_AMAP, *PPCICFG_HOST_INT_STATUS_CSR_AMAP;


// Host Interrupt Mask Register.
typedef struct {
   BE_BIT tmr;                                    // DWORD 0
   BE_BIT err;                                    // DWORD 0
   BE_BIT softrst;                                // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT gpiintr;                                // DWORD 0
   BE_BIT pwrstate_change;                        // DWORD 0
   BE_BIT FLR_intr;                               // DWORD 0
   BE_BIT ats_en_change;                          // DWORD 0
   BE_BIT msixtbl_perr;                           // DWORD 0
   BE_BIT link_error_max;                         // DWORD 0
   BE_BIT aspm_change;                            // DWORD 0
   BE_BIT LTSSM_L0_state_change;                  // DWORD 0
   BE_BIT rsvd1[19];                              // DWORD 0
} SG_PACK BE_PCICFG_HOST_INT_MASK_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_INT_MASK_CSR_AMAP, *PPCICFG_HOST_INT_MASK_CSR_AMAP;


//  Unrecoverable Error Status (Low) Register.<BR>                Each bit corresponds to
// an internal Unrecoverable Error.  These                are set by hardware and may be
// cleared by writing a one to the                respective bit(s) to be cleared.  Any
// bit being set that is                also unmasked will result in Unrecoverable Error
// interrupt                notification to the host CPU and/or Server Management chip;
// and                the transitioning of BladeEngine to an Offline state.               
typedef struct {
   BE_BIT cev_ue_status;                          // DWORD 0
   BE_BIT ctx_ue_status;                          // DWORD 0
   BE_BIT dbuf_ue_status;                         // DWORD 0
   BE_BIT erx_ue_status;                          // DWORD 0
   BE_BIT host_ue_status;                         // DWORD 0
   BE_BIT mpu_ue_status;                          // DWORD 0
   BE_BIT ndma_ue_status;                         // DWORD 0
   BE_BIT ptc_ue_status;                          // DWORD 0
   BE_BIT rdma_ue_status;                         // DWORD 0
   BE_BIT rxf_ue_status;                          // DWORD 0
   BE_BIT rxips_ue_status;                        // DWORD 0
   BE_BIT rxulp0_ue_status;                       // DWORD 0
   BE_BIT rxulp1_ue_status;                       // DWORD 0
   BE_BIT rxulp2_ue_status;                       // DWORD 0
   BE_BIT tim_ue_status;                          // DWORD 0
   BE_BIT tpost_ue_status;                        // DWORD 0
   BE_BIT tpre_ue_status;                         // DWORD 0
   BE_BIT txips_ue_status;                        // DWORD 0
   BE_BIT txulp0_ue_status;                       // DWORD 0
   BE_BIT txulp1_ue_status;                       // DWORD 0
   BE_BIT uc_ue_status;                           // DWORD 0
   BE_BIT wdma_ue_status;                         // DWORD 0
   BE_BIT txulp2_ue_status;                       // DWORD 0
   BE_BIT host1_ue_status;                        // DWORD 0
   BE_BIT p0_ob_link_ue_status;                   // DWORD 0
   BE_BIT p1_ob_link_ue_status;                   // DWORD 0
   BE_BIT host_gpio_ue_status;                    // DWORD 0
   BE_BIT mbox_ue_status;                         // DWORD 0
   BE_BIT axgmac0_ue_status;                      // DWORD 0
   BE_BIT axgmac1_ue_status;                      // DWORD 0
   BE_BIT jtag_ue_status;                         // DWORD 0
   BE_BIT mpu_intpend_ue_status;                  // DWORD 0
} SG_PACK BE_PCICFG_UE_STATUS_LOW_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_UE_STATUS_LOW_CSR_AMAP, *PPCICFG_UE_STATUS_LOW_CSR_AMAP;


//  Unrecoverable Error Status (High) Register.<BR>                Each bit corresponds to
// an internal Unrecoverable Error.  These                are set by hardware and may be
// cleared by writing a one to the                respective bit(s) to be cleared.  Any
// bit being set that is                also unmasked will result in Unrecoverable Error
// interrupt                notification to the host CPU and/or Server Management chip;
// and                the transitioning of BladeEngine to an Offline state.               
typedef struct {
   BE_BIT lpcmemhost_ue_status;                   // DWORD 0
   BE_BIT mgmt_mac_ue_status;                     // DWORD 0
   BE_BIT pcs0online_ue_status;                   // DWORD 0
   BE_BIT mpu_iram_ue_status;                     // DWORD 0
   BE_BIT pcs1online_ue_status;                   // DWORD 0
   BE_BIT pctl0_ue_status;                        // DWORD 0
   BE_BIT pctl1_ue_status;                        // DWORD 0
   BE_BIT pmem_ue_status;                         // DWORD 0
   BE_BIT rr_ue_status;                           // DWORD 0
   BE_BIT txpb_ue_status;                         // DWORD 0
   BE_BIT rxpp_ue_status;                         // DWORD 0
   BE_BIT xaui_ue_status;                         // DWORD 0
   BE_BIT txp_ue_status;                          // DWORD 0
   BE_BIT arm_ue_status;                          // DWORD 0
   BE_BIT ipc_ue_status;                          // DWORD 0
   BE_BIT host2_ue_status;                        // DWORD 0
   BE_BIT host3_ue_status;                        // DWORD 0
   BE_BIT host4_ue_status;                        // DWORD 0
   BE_BIT host5_ue_status;                        // DWORD 0
   BE_BIT host6_ue_status;                        // DWORD 0
   BE_BIT host7_ue_status;                        // DWORD 0
   BE_BIT host8_ue_status;                        // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
} SG_PACK BE_PCICFG_UE_STATUS_HI_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_UE_STATUS_HI_CSR_AMAP, *PPCICFG_UE_STATUS_HI_CSR_AMAP;


//  Unrecoverable Error Mask (Low) Register.<BR>             Each bit, when set to one,
// will mask the associated Unrecoverable             Error status bit from notification
// of Unrecoverable Error to the             host CPU and/or Server Managment chip and the
// transitioning of             all BladeEngine units to an Offline state.             
typedef struct {
   BE_BIT cev_ue_mask;                            // DWORD 0
   BE_BIT ctx_ue_mask;                            // DWORD 0
   BE_BIT dbuf_ue_mask;                           // DWORD 0
   BE_BIT erx_ue_mask;                            // DWORD 0
   BE_BIT host_ue_mask;                           // DWORD 0
   BE_BIT mpu_ue_mask;                            // DWORD 0
   BE_BIT ndma_ue_mask;                           // DWORD 0
   BE_BIT ptc_ue_mask;                            // DWORD 0
   BE_BIT rdma_ue_mask;                           // DWORD 0
   BE_BIT rxf_ue_mask;                            // DWORD 0
   BE_BIT rxips_ue_mask;                          // DWORD 0
   BE_BIT rxulp0_ue_mask;                         // DWORD 0
   BE_BIT rxulp1_ue_mask;                         // DWORD 0
   BE_BIT rxulp2_ue_mask;                         // DWORD 0
   BE_BIT tim_ue_mask;                            // DWORD 0
   BE_BIT tpost_ue_mask;                          // DWORD 0
   BE_BIT tpre_ue_mask;                           // DWORD 0
   BE_BIT txips_ue_mask;                          // DWORD 0
   BE_BIT txulp0_ue_mask;                         // DWORD 0
   BE_BIT txulp1_ue_mask;                         // DWORD 0
   BE_BIT uc_ue_mask;                             // DWORD 0
   BE_BIT wdma_ue_mask;                           // DWORD 0
   BE_BIT txulp2_ue_mask;                         // DWORD 0
   BE_BIT host1_ue_mask;                          // DWORD 0
   BE_BIT p0_ob_link_ue_mask;                     // DWORD 0
   BE_BIT p1_ob_link_ue_mask;                     // DWORD 0
   BE_BIT host_gpio_ue_mask;                      // DWORD 0
   BE_BIT mbox_ue_mask;                           // DWORD 0
   BE_BIT axgmac0_ue_mask;                        // DWORD 0
   BE_BIT axgmac1_ue_mask;                        // DWORD 0
   BE_BIT jtag_ue_mask;                           // DWORD 0
   BE_BIT mpu_intpend_ue_mask;                    // DWORD 0
} SG_PACK BE_PCICFG_UE_STATUS_LOW_MASK_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_UE_STATUS_LOW_MASK_CSR_AMAP, *PPCICFG_UE_STATUS_LOW_MASK_CSR_AMAP;


//   Unrecoverable Error Mask (High) Register.<BR>             Each bit, when set to one,
// will mask the associated Unrecoverable             Error status bit from notification
// of Unrecoverable Error to the             host CPU and/or Server Managment chip and the
// transitioning of             all BladeEngine units to an Offline state.             
typedef struct {
   BE_BIT lpcmemhost_ue_mask;                     // DWORD 0
   BE_BIT mgmt_mac_ue_mask;                       // DWORD 0
   BE_BIT pcs0online_ue_mask;                     // DWORD 0
   BE_BIT mpu_iram_ue_mask;                       // DWORD 0
   BE_BIT pcs1online_ue_mask;                     // DWORD 0
   BE_BIT pctl0_ue_mask;                          // DWORD 0
   BE_BIT pctl1_ue_mask;                          // DWORD 0
   BE_BIT pmem_ue_mask;                           // DWORD 0
   BE_BIT rr_ue_mask;                             // DWORD 0
   BE_BIT txpb_ue_mask;                           // DWORD 0
   BE_BIT rxpp_ue_mask;                           // DWORD 0
   BE_BIT xaui_ue_mask;                           // DWORD 0
   BE_BIT txp_ue_mask;                            // DWORD 0
   BE_BIT arm_ue_mask;                            // DWORD 0
   BE_BIT ipc_ue_mask;                            // DWORD 0
   BE_BIT host2_ue_mask;                          // DWORD 0
   BE_BIT host3_ue_mask;                          // DWORD 0
   BE_BIT host4_ue_mask;                          // DWORD 0
   BE_BIT host5_ue_mask;                          // DWORD 0
   BE_BIT host6_ue_mask;                          // DWORD 0
   BE_BIT host7_ue_mask;                          // DWORD 0
   BE_BIT host8_ue_mask;                          // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
} SG_PACK BE_PCICFG_UE_STATUS_HI_MASK_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_UE_STATUS_HI_MASK_CSR_AMAP, *PPCICFG_UE_STATUS_HI_MASK_CSR_AMAP;


// Online Control Register 0. This register controls various units within BladeEngine
// being in an Online or Offline state. 
typedef struct {
   BE_BIT cev_online;                             // DWORD 0
   BE_BIT ctx_online;                             // DWORD 0
   BE_BIT dbuf_online;                            // DWORD 0
   BE_BIT erx_online;                             // DWORD 0
   BE_BIT host_online;                            // DWORD 0
   BE_BIT mpu_online;                             // DWORD 0
   BE_BIT ndma_online;                            // DWORD 0
   BE_BIT ptc_online;                             // DWORD 0
   BE_BIT rdma_online;                            // DWORD 0
   BE_BIT rxf_online;                             // DWORD 0
   BE_BIT rxips_online;                           // DWORD 0
   BE_BIT rxulp0_online;                          // DWORD 0
   BE_BIT rxulp1_online;                          // DWORD 0
   BE_BIT rxulp2_online;                          // DWORD 0
   BE_BIT tim_online;                             // DWORD 0
   BE_BIT tpost_online;                           // DWORD 0
   BE_BIT tpre_online;                            // DWORD 0
   BE_BIT txips_online;                           // DWORD 0
   BE_BIT txulp0_online;                          // DWORD 0
   BE_BIT txulp1_online;                          // DWORD 0
   BE_BIT uc_online;                              // DWORD 0
   BE_BIT wdma_online;                            // DWORD 0
   BE_BIT txulp2_online;                          // DWORD 0
   BE_BIT host1_online;                           // DWORD 0
   BE_BIT p0_ob_link_online;                      // DWORD 0
   BE_BIT p1_ob_link_online;                      // DWORD 0
   BE_BIT host_gpio_online;                       // DWORD 0
   BE_BIT mbox_online;                            // DWORD 0
   BE_BIT axgmac0_online;                         // DWORD 0
   BE_BIT axgmac1_online;                         // DWORD 0
   BE_BIT jtag_online;                            // DWORD 0
   BE_BIT mpu_intpend_online;                     // DWORD 0
} SG_PACK BE_PCICFG_ONLINE0_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ONLINE0_CSR_AMAP, *PPCICFG_ONLINE0_CSR_AMAP;


// Online Control Register 1. This register controls various units within BladeEngine
// being in an Online or Offline state. 
typedef struct {
   BE_BIT lpcmemhost_online;                      // DWORD 0
   BE_BIT mgmt_mac_online;                        // DWORD 0
   BE_BIT pcs0online_online;                      // DWORD 0
   BE_BIT mpu_iram_online;                        // DWORD 0
   BE_BIT pcs1online_online;                      // DWORD 0
   BE_BIT pctl0_online;                           // DWORD 0
   BE_BIT pctl1_online;                           // DWORD 0
   BE_BIT pmem_online;                            // DWORD 0
   BE_BIT rr_online;                              // DWORD 0
   BE_BIT txpb_online;                            // DWORD 0
   BE_BIT rxpp_online;                            // DWORD 0
   BE_BIT xaui_online;                            // DWORD 0
   BE_BIT txp_online;                             // DWORD 0
   BE_BIT arm_online;                             // DWORD 0
   BE_BIT ipc_online;                             // DWORD 0
   BE_BIT host2_online;                           // DWORD 0
   BE_BIT host3_online;                           // DWORD 0
   BE_BIT host4_online;                           // DWORD 0
   BE_BIT host5_online;                           // DWORD 0
   BE_BIT host6_online;                           // DWORD 0
   BE_BIT host7_online;                           // DWORD 0
   BE_BIT host8_online;                           // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
} SG_PACK BE_PCICFG_ONLINE1_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ONLINE1_CSR_AMAP, *PPCICFG_ONLINE1_CSR_AMAP;


// Host Timer Register.
typedef struct {
   BE_BIT hosttimer[24];                          // DWORD 0
   BE_BIT vf_fun_shared_reg_wr_access;            // DWORD 0
   BE_BIT scratchpad0;                            // DWORD 0
   BE_BIT clr_pcie_stats;                         // DWORD 0
   BE_BIT ui_enter_l1;                            // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
} SG_PACK BE_PCICFG_HOST_TIMER_INT_CTRL_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_TIMER_INT_CTRL_CSR_AMAP, *PPCICFG_HOST_TIMER_INT_CTRL_CSR_AMAP;


// --- SYS_PG_SIZE_ENUM ---
// Host system page size
#define SYS_PG_4K                       (0)       // 4096 bytes
#define SYS_PG_8K                       (1)       // 8192 bytes
#define SYS_PG_16K                      (2)       // 16,384 bytes
#define SYS_PG_64K                      (3)       // 65,536 bytes

typedef enum {
   ENUM_SYS_PG_4K = 0x0UL,
   ENUM_SYS_PG_8K = 0x1UL,
   ENUM_SYS_PG_16K = 0x2UL,
   ENUM_SYS_PG_64K = 0x3UL
} SYS_PG_SIZE_ENUM;

// Host Control/Status Register.
typedef struct {
   BE_BIT func4en;                                // DWORD 0
   BE_BIT func5en;                                // DWORD 0
   BE_BIT func6en;                                // DWORD 0
   BE_BIT func7en;                                // DWORD 0
   BE_BIT f3_f0_4MB_db_bar[4];                    // DWORD 0
   BE_BIT hostoqdepth[3];                         // DWORD 0
   BE_BIT hostoqempty;                            // DWORD 0
   BE_BIT hostoqrdpasswren;                       // DWORD 0
   BE_BIT STATE_UPCONFIGURE_CAPABLE;              // DWORD 0
   BE_BIT func3en;                                // DWORD 0
   BE_BIT func2en;                                // DWORD 0
   BE_BIT f5_f4_4MB_db_bar[2];                    // DWORD 0
   BE_BIT iqrdflushoqwren;                        // DWORD 0
   BE_BIT cev_swacken;                            // DWORD 0
   BE_BIT pcie_retry_buf_ecc_ue_source;           // DWORD 0
   BE_BIT pcie_linkdn_ue_source;                  // DWORD 0
   BE_BIT pcie_retry_buf_ecc_ue_mask;             // DWORD 0
   BE_BIT pcie_linkdn_ue_mask;                    // DWORD 0
   BE_BIT lpcismtranserr;                         // DWORD 0
   BE_BIT lpcismstaterr;                          // DWORD 0
   BE_BIT fwbootfail;                             // DWORD 0
   BE_BIT expromdisable;                          // DWORD 0
   BE_BIT ARI_spec_en;                            // DWORD 0
   BE_BIT f7_f6_4MB_db_bar[2];                    // DWORD 0
   BE_BIT func1en;                                // DWORD 0
} SG_PACK BE_PCICFG_HOST_CONTROL_STATUS_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HOST_CONTROL_STATUS_CSR_AMAP, *PPCICFG_HOST_CONTROL_STATUS_CSR_AMAP;


// LPC Address Register.
typedef struct {
   BE_BIT lpc_addr[32];                           // DWORD 0
} SG_PACK BE_PCICFG_LPC_ADDR_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_LPC_ADDR_CSR_AMAP, *PPCICFG_LPC_ADDR_CSR_AMAP;


// LPC Data Register.
typedef struct {
   BE_BIT lpc_data[32];                           // DWORD 0
} SG_PACK BE_PCICFG_LPC_DATA_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_LPC_DATA_CSR_AMAP, *PPCICFG_LPC_DATA_CSR_AMAP;


// LPC Command Register.
typedef struct {
   BE_BIT be[4];                                  // DWORD 0
   BE_BIT wr;                                     // DWORD 0
   BE_BIT req;                                    // DWORD 0
   BE_BIT err;                                    // DWORD 0
   BE_BIT reg;                                    // DWORD 0
   BE_BIT abort;                                  // DWORD 0
   BE_BIT rst;                                    // DWORD 0
   BE_BIT core_d3_lpcism_state[5];                // DWORD 0
   BE_BIT core_d3_lpcismactive;                   // DWORD 0
   BE_BIT core_d3_lpcism_done;                    // DWORD 0
   BE_BIT core_lpcism_state[5];                   // DWORD 0
   BE_BIT core_lpcismactive;                      // DWORD 0
   BE_BIT core_lpcism_done;                       // DWORD 0
   BE_BIT bus_num[8];                             // DWORD 0
} SG_PACK BE_PCICFG_LPC_COMMAND_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_LPC_COMMAND_CSR_AMAP, *PPCICFG_LPC_COMMAND_CSR_AMAP;


// Scratchpad Register (for software use).
typedef struct {
   BE_BIT scratchpad[32];                         // DWORD 0
} SG_PACK BE_PCICFG_SCRATCHPAD_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_SCRATCHPAD_CSR_AMAP, *PPCICFG_SCRATCHPAD_CSR_AMAP;


// PCI Express Capabilities Register.
typedef struct {
   BE_BIT capid[8];                               // DWORD 0
   BE_BIT nextcap[8];                             // DWORD 0
   BE_BIT capver[4];                              // DWORD 0
   BE_BIT devport[4];                             // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
} SG_PACK BE_PCICFG_PCIE_CAP_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_CAP_CSR_AMAP, *PPCICFG_PCIE_CAP_CSR_AMAP;


// PCI Express Device Capabilities Register.
typedef struct {
   BE_BIT payload[3];                             // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT lo_lat[3];                              // DWORD 0
   BE_BIT l1_lat[3];                              // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT ROLE_ERR_REP;                           // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
   BE_BIT pwr_value[8];                           // DWORD 0
   BE_BIT pwr_scale[2];                           // DWORD 0
   BE_BIT FLR;                                    // DWORD 0
   BE_BIT rsvd3[3];                               // DWORD 0
} SG_PACK BE_PCICFG_PCIE_DEVCAP_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_DEVCAP_CSR_AMAP, *PPCICFG_PCIE_DEVCAP_CSR_AMAP;


// PCI Express Device Control/Status Registers.
typedef struct {
   BE_BIT CorrErrReportEn;                        // DWORD 0
   BE_BIT NonFatalErrReportEn;                    // DWORD 0
   BE_BIT FatalErrReportEn;                       // DWORD 0
   BE_BIT UnsuppReqReportEn;                      // DWORD 0
   BE_BIT EnableRelaxOrder;                       // DWORD 0
   BE_BIT Max_Payload_Size[3];                    // DWORD 0
   BE_BIT ExtendTagFieldEnable;                   // DWORD 0
   BE_BIT PhantomFnEnable;                        // DWORD 0
   BE_BIT AuxPwrPMEnable;                         // DWORD 0
   BE_BIT EnableNoSnoop;                          // DWORD 0
   BE_BIT Max_Read_Req_Size[3];                   // DWORD 0
   BE_BIT INITIATE_FLR;                           // DWORD 0
   BE_BIT CorrErrDetect;                          // DWORD 0
   BE_BIT NonFatalErrDetect;                      // DWORD 0
   BE_BIT FatalErrDetect;                         // DWORD 0
   BE_BIT UnsuppReqDetect;                        // DWORD 0
   BE_BIT AuxPwrDetect;                           // DWORD 0
   BE_BIT TransPending;                           // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_CONTROL_STATUS_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_CONTROL_STATUS_CSR_AMAP, *PPCICFG_PCIE_CONTROL_STATUS_CSR_AMAP;


// PCI Express Link Capabilities Register.
typedef struct {
   BE_BIT MaxLinkSpeed[4];                        // DWORD 0
   BE_BIT MaxLinkWidth[6];                        // DWORD 0
   BE_BIT ASPMSupport[2];                         // DWORD 0
   BE_BIT L0sExitLat[3];                          // DWORD 0
   BE_BIT L1ExitLat[3];                           // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT PortNum[8];                             // DWORD 0
} SG_PACK BE_PCICFG_PCIE_LINK_CAP_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_LINK_CAP_CSR_AMAP, *PPCICFG_PCIE_LINK_CAP_CSR_AMAP;


// PCI Express Link Status Register.
typedef struct {
   BE_BIT ASPMCtl[2];                             // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT ReadCmplBndry;                          // DWORD 0
   BE_BIT LinkDisable;                            // DWORD 0
   BE_BIT RetrainLink;                            // DWORD 0
   BE_BIT CommonClkConfig;                        // DWORD 0
   BE_BIT ExtendSync;                             // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT hw_autonomous_width_dis;                // DWORD 0
   BE_BIT rsvd2[6];                               // DWORD 0
   BE_BIT LinkSpeed[4];                           // DWORD 0
   BE_BIT NegLinkWidth[6];                        // DWORD 0
   BE_BIT LinkTrainErr;                           // DWORD 0
   BE_BIT LinkTrain;                              // DWORD 0
   BE_BIT SlotClkConfig;                          // DWORD 0
   BE_BIT rsvd3[3];                               // DWORD 0
} SG_PACK BE_PCICFG_PCIE_LINK_STATUS_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_LINK_STATUS_CSR_AMAP, *PPCICFG_PCIE_LINK_STATUS_CSR_AMAP;


// PCI Express Device Capabilities 2 Register.
typedef struct {
   BE_BIT cmpl_tmout_sup[4];                      // DWORD 0
   BE_BIT cmpl_tmout_dis_sup;                     // DWORD 0
   BE_BIT rsvd0[27];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_DEVCAP2_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_DEVCAP2_CSR_AMAP, *PPCICFG_PCIE_DEVCAP2_CSR_AMAP;


// PCI Express Device Capabilities 2 Register.
typedef struct {
   BE_BIT cmpl_tmout_sup[4];                      // DWORD 0
   BE_BIT cmpl_tmout_dis_sup;                     // DWORD 0
   BE_BIT rsvd0[27];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_CONTROL_STATUS2_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_CONTROL_STATUS2_CSR_AMAP, *PPCICFG_PCIE_CONTROL_STATUS2_CSR_AMAP;


// PCI Express Link Capabilities Register.
typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_LINK_CAP2_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_LINK_CAP2_CSR_AMAP, *PPCICFG_PCIE_LINK_CAP2_CSR_AMAP;


// PCI Express Link Status 2 Register.
typedef struct {
   BE_BIT link_speed[4];                          // DWORD 0
   BE_BIT enter_compliance;                       // DWORD 0
   BE_BIT hw_autonomous_speed_dis;                // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT transmit_margin[3];                     // DWORD 0
   BE_BIT enter_mod_compliance;                   // DWORD 0
   BE_BIT compliance_SOS;                         // DWORD 0
   BE_BIT compliance_de_emphasis;                 // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT current_de_emphasis;                    // DWORD 0
   BE_BIT rsvd2[15];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_LINK_STATUS2_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_LINK_STATUS2_CSR_AMAP, *PPCICFG_PCIE_LINK_STATUS2_CSR_AMAP;


// PCI Express Link Status 2 Register. The Function F1 has all zeros.
typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT current_de_emphasis;                    // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_PCICFG_PCIE_LINK_STATUS2_CSR_F1_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PCIE_LINK_STATUS2_CSR_F1_AMAP, *PPCICFG_PCIE_LINK_STATUS2_CSR_F1_AMAP;


// This register always need to return zeros. This space can't be used for any other
// purposes.
typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_PCICFG_RETURN_ZEROS_AMAP;
typedef struct { u32 dw[1]; } PCICFG_RETURN_ZEROS_AMAP, *PPCICFG_RETURN_ZEROS_AMAP;


// PCI Express MSI-X Configuration Register.
typedef struct {
   BE_BIT capid[8];                               // DWORD 0
   BE_BIT nextptr[8];                             // DWORD 0
   BE_BIT tablesize[11];                          // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT funcmask;                               // DWORD 0
   BE_BIT en;                                     // DWORD 0
} SG_PACK BE_PCICFG_MSIX_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_CSR_AMAP, *PPCICFG_MSIX_CSR_AMAP;


// MSI-X Table Offset Register.
typedef struct {
   BE_BIT tablebir[3];                            // DWORD 0
   BE_BIT offset[29];                             // DWORD 0
} SG_PACK BE_PCICFG_MSIX_TABLE_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_TABLE_CSR_AMAP, *PPCICFG_MSIX_TABLE_CSR_AMAP;


// MSI-X PBA Offset Register.
typedef struct {
   BE_BIT pbabir[3];                              // DWORD 0
   BE_BIT offset[29];                             // DWORD 0
} SG_PACK BE_PCICFG_MSIX_PBA_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_PBA_CSR_AMAP, *PPCICFG_MSIX_PBA_CSR_AMAP;


// PCI Express MSI-X Message Vector Control Register.
typedef struct {
   BE_BIT vector_control;                         // DWORD 0
   BE_BIT rsvd0[31];                              // DWORD 0
} SG_PACK BE_PCICFG_MSIX_VECTOR_CONTROL_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_VECTOR_CONTROL_CSR_AMAP, *PPCICFG_MSIX_VECTOR_CONTROL_CSR_AMAP;


// PCI Express MSI-X Message Data Register.
typedef struct {
   BE_BIT data[16];                               // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_PCICFG_MSIX_MSG_DATA_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_MSG_DATA_CSR_AMAP, *PPCICFG_MSIX_MSG_DATA_CSR_AMAP;


// PCI Express MSI-X Message Address Register - High Part.
typedef struct {
   BE_BIT addr[32];                               // DWORD 0
} SG_PACK BE_PCICFG_MSIX_MSG_ADDR_HI_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_MSG_ADDR_HI_CSR_AMAP, *PPCICFG_MSIX_MSG_ADDR_HI_CSR_AMAP;


// PCI Express MSI-X Message Address Register - Low Part.
typedef struct {
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT addr[30];                               // DWORD 0
} SG_PACK BE_PCICFG_MSIX_MSG_ADDR_LO_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_MSG_ADDR_LO_CSR_AMAP, *PPCICFG_MSIX_MSG_ADDR_LO_CSR_AMAP;


// Pending Bits Register for each MSI-X Message
typedef struct {
   BE_BIT pba[32];                                // DWORD 0
} SG_PACK BE_PCICFG_MSIX_PBA_STRUCT_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_MSIX_PBA_STRUCT_CSR_AMAP, *PPCICFG_MSIX_PBA_STRUCT_CSR_AMAP;


// PCI-E Control/Status 0 Register.
typedef struct {
   BE_BIT mode_loopback_bist_result_7_0[8];       // DWORD 0
   BE_BIT ltssm_state[7];                         // DWORD 0
   BE_BIT wake_on_pme_tmr_expiry_en;              // DWORD 0
   BE_BIT num_fts[8];                             // DWORD 0
   BE_BIT lnum_fmode[2];                          // DWORD 0
   BE_BIT mode_clk_active[2];                     // DWORD 0
   BE_BIT mode_txswing;                           // DWORD 0
   BE_BIT mode_detect_quiet;                      // DWORD 0
   BE_BIT ui_scramble_disable_force;              // DWORD 0
   BE_BIT mode_loopback_slave_exit;               // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_0_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_0_CSR_AMAP, *PPCICFG_IP_CONTROL_STATUS_0_CSR_AMAP;


// PCI-E Control/Status 1 Register
typedef struct {
   BE_BIT mode_tx_drv_en;                         // DWORD 0
   BE_BIT vc0_negotiation_pending;                // DWORD 0
   BE_BIT mode_compliance_receive;                // DWORD 0
   BE_BIT mode_loopback_reset_o;                  // DWORD 0
   BE_BIT mode_loopback_bist_result_15_8[8];      // DWORD 0
   BE_BIT ui_ack_timer[16];                       // DWORD 0
   BE_BIT ack_timer_force;                        // DWORD 0
   BE_BIT mode_loopback_master_enable;            // DWORD 0
   BE_BIT mode_loopback_bist_1;                   // DWORD 0
   BE_BIT mode_loopback_bist_2;                   // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_1_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_1_CSR_AMAP, *PPCICFG_IP_CONTROL_STATUS_1_CSR_AMAP;


//  PCI-E Replay Timer Error Notification signals Register. 
typedef struct {
   BE_BIT ERR_BADDLLP;                            // DWORD 0
   BE_BIT ERR_BADTLP;                             // DWORD 0
   BE_BIT ERR_RECEIVERERROR;                      // DWORD 0
   BE_BIT ERR_DLPERR;                             // DWORD 0
   BE_BIT ERR_NULLTLP;                            // DWORD 0
   BE_BIT ERR_REPLAY;                             // DWORD 0
   BE_BIT ERR_REPLAY_NUM[2];                      // DWORD 0
   BE_BIT ERR_RPC_REPLAY_ROLLOVR;                 // DWORD 0
   BE_BIT ERR_RPC_REPLAY_TIMEOUT;                 // DWORD 0
   BE_BIT ERR_RPC_REPLAYFIFO_PERR;                // DWORD 0
   BE_BIT ERR_REPLAY_UPPER_UNCORRECTABLE_ERROR;   // DWORD 0
   BE_BIT ERR_REPLAY_LOWER_UNCORRECTABLE_ERROR;   // DWORD 0
   BE_BIT ERR_REPLAY_UPPER_CORRECTABLE_ERROR;     // DWORD 0
   BE_BIT ERR_REPLAY_LOWER_CORRECTABLE_ERROR;     // DWORD 0
   BE_BIT REPLAY_SYNDROME_UPPER[8];               // DWORD 0
   BE_BIT REPLAY_SYNDROME_LOWER[8];               // DWORD 0
   BE_BIT TXB_PARITY_ERR;                         // DWORD 0
} SG_PACK BE_PCICFG_ERR_REPLAY_MONITOR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_ERR_REPLAY_MONITOR_AMAP, *PPCICFG_ERR_REPLAY_MONITOR_AMAP;


//  PCI-E Link Speed Width Control Register. 
typedef struct {
   BE_BIT target_link_speed;                      // DWORD 0
   BE_BIT target_link_speed_req;                  // DWORD 0
   BE_BIT target_link_width[8];                   // DWORD 0
   BE_BIT target_link_width_req;                  // DWORD 0
   BE_BIT target_link_autonomous_req;             // DWORD 0
   BE_BIT clr_link_error_count;                   // DWORD 0
   BE_BIT cfg_aspm_l1_dllp_interval_time_limit[3]; // DWORD 0
   BE_BIT target_link_error_cnt[16];              // DWORD 0
} SG_PACK BE_PCICFG_IP_SPEED_WIDTH_CTRL_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_SPEED_WIDTH_CTRL_AMAP, *PPCICFG_IP_SPEED_WIDTH_CTRL_AMAP;


//  PCI-E Control/Status 5 Register. 
typedef struct {
   BE_BIT LINK_STATE[5];                          // DWORD 0
   BE_BIT STATE_EIOS_DETECTED;                    // DWORD 0
   BE_BIT STATE_LANE_ERROR[8];                    // DWORD 0
   BE_BIT MON_PSTATUS[2];                         // DWORD 0
   BE_BIT MON_MASK[2];                            // DWORD 0
   BE_BIT COSPLLOCK;                              // DWORD 0
   BE_BIT TEST_LOOPBACK_SLOT_POWER_MSG_ENABLE;    // DWORD 0
   BE_BIT TEST_LOOPBACK_SLOT_POWER_MSG_SEND;      // DWORD 0
   BE_BIT TEST_LOOPBACK_SLOT_POWER_MSG_PASS;      // DWORD 0
   BE_BIT TEST_LOOPBACK_SLOT_POWER_MSG_FAIL;      // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT LINK_ERROR_MAXED[8];                    // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_5_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_5_CSR_AMAP, *PPCICFG_IP_CONTROL_STATUS_5_CSR_AMAP;


//  PCI-E Control/Status 4 Register. 
typedef struct {
   BE_BIT STATE_NEGOTIATED_LANE_START[4];         // DWORD 0
   BE_BIT STATE_NEGOTIATED_LANE_END[4];           // DWORD 0
   BE_BIT STATE_DATA_RATE_IDENTIFIER_RECEIVED[8]; // DWORD 0
   BE_BIT STATE_RECEIVER_DETECTED[8];             // DWORD 0
   BE_BIT STATE_ELECTRICAL_IDLE_BROKEN[8];        // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_4_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_4_CSR_AMAP, *PPCICFG_IP_CONTROL_STATUS_4_CSR_AMAP;


//  PCI-E Control/Status 2 Register. 
typedef struct {
   BE_BIT EIJ_ERROR_CORRECT_DISABLE;              // DWORD 0
   BE_BIT EIJ_ERROR_REPORT_DISABLE;               // DWORD 0
   BE_BIT EIJ_REPLAY_UPPER_UNCORRECTABLE_INJECT;  // DWORD 0
   BE_BIT EIJ_REPLAY_LOWER_UNCORRECTABLE_INJECT;  // DWORD 0
   BE_BIT EIJ_REPLAY_UPPER_CORRECTABLE_INJECT;    // DWORD 0
   BE_BIT EIJ_REPLAY_LOWER_CORRECTABLE_INJECT;    // DWORD 0
   BE_BIT ui_exit_polling_compliance;             // DWORD 0
   BE_BIT MODE_RX_COMPLETION_ORDERING_DISABLE;    // DWORD 0
   BE_BIT ui_replay_timer_limit[20];              // DWORD 0
   BE_BIT nec_ll_txeberr;                         // DWORD 0
   BE_BIT nec_ll_dmperr_set_i;                    // DWORD 0
   BE_BIT nec_ll_ecc1berr_set_i;                  // DWORD 0
   BE_BIT nec_ll_ecc2berr_set_i;                  // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_2_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_2_CSR_AMAP, *PPCICFG_IP_CONTROL_STATUS_2_CSR_AMAP;


//  PCI-E Control/Status 3 Register. 
typedef struct {
   BE_BIT ui_skp_timer[13];                       // DWORD 0
   BE_BIT cfg_pgsize[3];                          // DWORD 0
   BE_BIT down_stream_write_count[8];             // DWORD 0
   BE_BIT down_stream_read_count[8];              // DWORD 0
} SG_PACK BE_PCICFG_IP_CONTROL_STATUS_3_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_IP_CONTROL_STATUS_3_CSR_AMAP, *PPCICFG_IP_CONTROL_STATUS_3_CSR_AMAP;


// Power Management Capabilities Register.
typedef struct {
   BE_BIT pmcapid[8];                             // DWORD 0
   BE_BIT pmnextptr[8];                           // DWORD 0
   BE_BIT version[3];                             // DWORD 0
   BE_BIT pme_clk;                                // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT dsi;                                    // DWORD 0
   BE_BIT aux_current[3];                         // DWORD 0
   BE_BIT d1;                                     // DWORD 0
   BE_BIT d2;                                     // DWORD 0
   BE_BIT pme[5];                                 // DWORD 0
} SG_PACK BE_PCICFG_PMC_CSR_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PMC_CSR_AMAP, *PPCICFG_PMC_CSR_AMAP;


// Power Managment Control Register.
typedef struct {
   BE_BIT pwr_state[2];                           // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT device_specific;                        // DWORD 0
   BE_BIT rsvd1[4];                               // DWORD 0
   BE_BIT pme_en;                                 // DWORD 0
   BE_BIT data_select[4];                         // DWORD 0
   BE_BIT data_scale[2];                          // DWORD 0
   BE_BIT pme_status;                             // DWORD 0
   BE_BIT rsvd2[6];                               // DWORD 0
   BE_BIT b2_b3;                                  // DWORD 0
   BE_BIT bpcc_en;                                // DWORD 0
   BE_BIT pmdata[8];                              // DWORD 0
} SG_PACK BE_PCICFG_PM_CONTROL_AMAP;
typedef struct { u32 dw[1]; } PCICFG_PM_CONTROL_AMAP, *PPCICFG_PM_CONTROL_AMAP;


// PCI Express Advanced Error Reporting Enhanced Capability Header Register.
typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_ERR_ENHANCED_CAP_AMAP;
typedef struct { u32 dw[1]; } PCIE_ERR_ENHANCED_CAP_AMAP, *PPCIE_ERR_ENHANCED_CAP_AMAP;


// PCI Express Alternative Routing ID Interpretation Extended Capability.
typedef struct {
   BE_BIT mfvc_fg_capability;                     // DWORD 0
   BE_BIT acs_fg_capability;                      // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT next_fun_num[8];                        // DWORD 0
   BE_BIT rsvd1[16];                              // DWORD 0
} SG_PACK BE_PCIE_ARI_CAPABILITY_AMAP;
typedef struct { u32 dw[1]; } PCIE_ARI_CAPABILITY_AMAP, *PPCIE_ARI_CAPABILITY_AMAP;


// PCI Express ARI Enhanced Capability Header Register.
typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_ARI_ENHANCED_CAP_AMAP;
typedef struct { u32 dw[1]; } PCIE_ARI_ENHANCED_CAP_AMAP, *PPCIE_ARI_ENHANCED_CAP_AMAP;


// PCI Express ATS Capability Header Register.
typedef struct {
   BE_BIT ext_cap_id[16];                         // DWORD 0
   BE_BIT cap_version[4];                         // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_ATS_ENHANCED_CAP_AMAP;
typedef struct { u32 dw[1]; } PCIE_ATS_ENHANCED_CAP_AMAP, *PPCIE_ATS_ENHANCED_CAP_AMAP;


// PCI Express ATS Capability Header Register.
typedef struct {
   BE_BIT inval_queue_depth[5];                   // DWORD 0
   BE_BIT rsvd0[11];                              // DWORD 0
   BE_BIT stu[5];                                 // DWORD 0
   BE_BIT rsvd1[10];                              // DWORD 0
   BE_BIT ats_enable;                             // DWORD 0
} SG_PACK BE_PCIE_ATS_CAPABILITY_AMAP;
typedef struct { u32 dw[1]; } PCIE_ATS_CAPABILITY_AMAP, *PPCIE_ATS_CAPABILITY_AMAP;


// PCI Express Uncorrectable Error Status Register.
typedef struct {
   BE_BIT training_err;                           // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT data_link_prot_err;                     // DWORD 0
   BE_BIT rsvd1[7];                               // DWORD 0
   BE_BIT poison_tlp_err;                         // DWORD 0
   BE_BIT flow_ctl_prot_err;                      // DWORD 0
   BE_BIT cpl_timeout_err;                        // DWORD 0
   BE_BIT cmpltr_abort_err;                       // DWORD 0
   BE_BIT unexp_cpl_err;                          // DWORD 0
   BE_BIT rcvr_overflow_err;                      // DWORD 0
   BE_BIT malformed_tlp_err;                      // DWORD 0
   BE_BIT ecrc_err;                               // DWORD 0
   BE_BIT unsupp_req_err;                         // DWORD 0
   BE_BIT rsvd2[11];                              // DWORD 0
} SG_PACK BE_PCIE_UNCORR_ERR_STATUS_AMAP;
typedef struct { u32 dw[1]; } PCIE_UNCORR_ERR_STATUS_AMAP, *PPCIE_UNCORR_ERR_STATUS_AMAP;


// PCI Express Uncorrectable Error Mask Register.
typedef struct {
   BE_BIT training_err;                           // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT data_link_prot_err;                     // DWORD 0
   BE_BIT rsvd1[7];                               // DWORD 0
   BE_BIT poison_tlp_err;                         // DWORD 0
   BE_BIT flow_ctl_prot_err;                      // DWORD 0
   BE_BIT cpl_timeout_err;                        // DWORD 0
   BE_BIT cmpltr_abort_err;                       // DWORD 0
   BE_BIT unexp_cpl_err;                          // DWORD 0
   BE_BIT rcvr_overflow_err;                      // DWORD 0
   BE_BIT malformed_tlp_err;                      // DWORD 0
   BE_BIT ecrc_err;                               // DWORD 0
   BE_BIT unsupp_req_err;                         // DWORD 0
   BE_BIT rsvd2[11];                              // DWORD 0
} SG_PACK BE_PCIE_UNCORR_ERR_MASK_AMAP;
typedef struct { u32 dw[1]; } PCIE_UNCORR_ERR_MASK_AMAP, *PPCIE_UNCORR_ERR_MASK_AMAP;


// PCI Express Uncorrectable Error Severity Register.
typedef struct {
   BE_BIT training_err;                           // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT data_link_prot_err;                     // DWORD 0
   BE_BIT rsvd1[7];                               // DWORD 0
   BE_BIT poison_tlp_err;                         // DWORD 0
   BE_BIT flow_ctl_prot_err;                      // DWORD 0
   BE_BIT cpl_timeout_err;                        // DWORD 0
   BE_BIT cmpltr_abort_err;                       // DWORD 0
   BE_BIT unexp_cpl_err;                          // DWORD 0
   BE_BIT rcvr_overflow_err;                      // DWORD 0
   BE_BIT malformed_tlp_err;                      // DWORD 0
   BE_BIT ecrc_err;                               // DWORD 0
   BE_BIT unsupp_req_err;                         // DWORD 0
   BE_BIT rsvd2[11];                              // DWORD 0
} SG_PACK BE_PCIE_UNCORR_ERR_SEVERITY_AMAP;
typedef struct { u32 dw[1]; } PCIE_UNCORR_ERR_SEVERITY_AMAP, *PPCIE_UNCORR_ERR_SEVERITY_AMAP;


// PCI Express Correctable Error Status Register.
typedef struct {
   BE_BIT rcvr_err;                               // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT bad_tlp_err;                            // DWORD 0
   BE_BIT bad_dllp_err;                           // DWORD 0
   BE_BIT replay_num_rollover_err;                // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT replay_timer_timeout_err;               // DWORD 0
   BE_BIT advisory_no_fatal_error_status;         // DWORD 0
   BE_BIT rsvd2[18];                              // DWORD 0
} SG_PACK BE_PCIE_CORR_ERR_STATUS_AMAP;
typedef struct { u32 dw[1]; } PCIE_CORR_ERR_STATUS_AMAP, *PPCIE_CORR_ERR_STATUS_AMAP;


// PCI Express Correctable Error Mask Register.
typedef struct {
   BE_BIT rcvr_err;                               // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT bad_tlp_err;                            // DWORD 0
   BE_BIT bad_dllp_err;                           // DWORD 0
   BE_BIT replay_num_rollover_err;                // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT replay_timer_timeout_err;               // DWORD 0
   BE_BIT advisory_no_fatal_error_mask;           // DWORD 0
   BE_BIT rsvd2[18];                              // DWORD 0
} SG_PACK BE_PCIE_CORR_ERR_MASK_AMAP;
typedef struct { u32 dw[1]; } PCIE_CORR_ERR_MASK_AMAP, *PPCIE_CORR_ERR_MASK_AMAP;


// PCI Express Advanced Error Capabilities and Control Register.
typedef struct {
   BE_BIT first_uncorr_err_ptr[5];                // DWORD 0
   BE_BIT ecrc_gen_cap;                           // DWORD 0
   BE_BIT ecrc_gen_en;                            // DWORD 0
   BE_BIT ecrc_chk_cap;                           // DWORD 0
   BE_BIT ecrc_chk_en;                            // DWORD 0
   BE_BIT rsvd0[23];                              // DWORD 0
} SG_PACK BE_PCIE_ERR_CAP_CONTROL_AMAP;
typedef struct { u32 dw[1]; } PCIE_ERR_CAP_CONTROL_AMAP, *PPCIE_ERR_CAP_CONTROL_AMAP;


// PCI Express Header Log Register.
typedef struct {
   BE_BIT failheader[32];                         // DWORD 0
} SG_PACK BE_PCIE_HEADER_REGISTER_AMAP;
typedef struct { u32 dw[1]; } PCIE_HEADER_REGISTER_AMAP, *PPCIE_HEADER_REGISTER_AMAP;


// PCI Express SR-IOV Cabability ID Register.
typedef struct {
   BE_BIT sr_iov_capid[16];                       // DWORD 0
   BE_BIT sr_iov_capver[4];                       // DWORD 0
   BE_BIT next_cap_offset[12];                    // DWORD 0
} SG_PACK BE_PCIE_SR_IOV_ENHANCED_CAP_AMAP;
typedef struct { u32 dw[1]; } PCIE_SR_IOV_ENHANCED_CAP_AMAP, *PPCIE_SR_IOV_ENHANCED_CAP_AMAP;


// PCI Express SR-IOV Cababilities Register.
typedef struct {
   BE_BIT vf_migration;                           // DWORD 0
   BE_BIT rsvd0[20];                              // DWORD 0
   BE_BIT vf_migration_intr_msg_no[11];           // DWORD 0
} SG_PACK BE_PCIE_SR_IOV_CAPABILITIES_AMAP;
typedef struct { u32 dw[1]; } PCIE_SR_IOV_CAPABILITIES_AMAP, *PPCIE_SR_IOV_CAPABILITIES_AMAP;


// PCI Express SR-IOV Status Control Register.
typedef struct {
   BE_BIT VF_enable;                              // DWORD 0
   BE_BIT VF_migration_enable;                    // DWORD 0
   BE_BIT VF_migration_intr_enable;               // DWORD 0
   BE_BIT VF_memory_space_enable;                 // DWORD 0
   BE_BIT VF_ARI_enable;                          // DWORD 0
   BE_BIT rsvd0[11];                              // DWORD 0
   BE_BIT VF_migration_status;                    // DWORD 0
   BE_BIT rsvd1[15];                              // DWORD 0
} SG_PACK BE_PCIE_SR_IOV_STATUS_CONTROL_AMAP;
typedef struct { u32 dw[1]; } PCIE_SR_IOV_STATUS_CONTROL_AMAP, *PPCIE_SR_IOV_STATUS_CONTROL_AMAP;


// PCI Express SR-IOV Total No. of VFs and Initial No. of VFs per PF.
typedef struct {
   BE_BIT initial_VFs[16];                        // DWORD 0
   BE_BIT total_VFs[16];                          // DWORD 0
} SG_PACK BE_PCIE_TOTAL_INITIAL_VFs_AMAP;
typedef struct { u32 dw[1]; } PCIE_TOTAL_INITIAL_VFs_AMAP, *PPCIE_TOTAL_INITIAL_VFs_AMAP;


// PCI Express SR-IOV Number of VFs assigned be software to PF.
typedef struct {
   BE_BIT num_VFs[16];                            // DWORD 0
   BE_BIT function_dependency_link[8];            // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_PCIE_NUM_VFs_AMAP;
typedef struct { u32 dw[1]; } PCIE_NUM_VFs_AMAP, *PPCIE_NUM_VFs_AMAP;


// PCI Express VF First Offset and STRIDE.
typedef struct {
   BE_BIT first_VF_offset[16];                    // DWORD 0
   BE_BIT VF_stride[16];                          // DWORD 0
} SG_PACK BE_PCIE_VF_STRIDE_OFFSET_AMAP;
typedef struct { u32 dw[1]; } PCIE_VF_STRIDE_OFFSET_AMAP, *PPCIE_VF_STRIDE_OFFSET_AMAP;


// PCI Express VFs Device ID
typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT VF_device_id[16];                       // DWORD 0
} SG_PACK BE_PCIE_VF_DEVICE_ID_AMAP;
typedef struct { u32 dw[1]; } PCIE_VF_DEVICE_ID_AMAP, *PPCIE_VF_DEVICE_ID_AMAP;


// PCI Express System Pages supported by PF.
typedef struct {
   BE_BIT VF_system_page_size_supported[32];      // DWORD 0
} SG_PACK BE_PCIE_VF_SYSTEM_PAGE_SUPPORTED_AMAP;
typedef struct { u32 dw[1]; } PCIE_VF_SYSTEM_PAGE_SUPPORTED_AMAP, *PPCIE_VF_SYSTEM_PAGE_SUPPORTED_AMAP;


// PCI Express System Page size the system uses.
typedef struct {
   BE_BIT VF_system_page_size[11];                // DWORD 0
   BE_BIT rsvd0[21];                              // DWORD 0
} SG_PACK BE_PCIE_VF_SYSTEM_PAGE_AMAP;
typedef struct { u32 dw[1]; } PCIE_VF_SYSTEM_PAGE_AMAP, *PPCIE_VF_SYSTEM_PAGE_AMAP;


// VF Memory BAR 0 - Low Address Register. This space is for all VFs of corresponding PF.
// Each VF consumes 2 System pages for all system pages, except 4K system page. It
// consumes 4 system pages for 4K system page. Each VF Space is partitioned as follows:
// Page0 0to4K-1 is for DB space, Page0 4Kto8K-1 for Cfg space, Page1 0to4K-1 for MSIX
// Table, Page1 4Kto8K-1 for MSIX PBA.
typedef struct {
   BE_BIT memspace;                               // DWORD 0
   BE_BIT type[2];                                // DWORD 0
   BE_BIT pf;                                     // DWORD 0
   BE_BIT rsvd0[10];                              // DWORD 0
   BE_BIT system_page_decode_0;                   // DWORD 0
   BE_BIT system_page_decode_1;                   // DWORD 0
   BE_BIT system_page_decode_2;                   // DWORD 0
   BE_BIT system_page_decode_3;                   // DWORD 0
   BE_BIT system_page_decode_4;                   // DWORD 0
   BE_BIT system_page_decode_5;                   // DWORD 0
   BE_BIT system_page_decode_6;                   // DWORD 0
   BE_BIT system_page_decode_7;                   // DWORD 0
   BE_BIT system_page_decode_8;                   // DWORD 0
   BE_BIT system_page_decode_9;                   // DWORD 0
   BE_BIT membar1lo[8];                           // DWORD 0
} SG_PACK BE_PCICFG_VF_MEMBAR0_LO_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VF_MEMBAR0_LO_AMAP, *PPCICFG_VF_MEMBAR0_LO_AMAP;


// VF Memory BAR 0 - High Address Register.
typedef struct {
   BE_BIT membar1hi[32];                          // DWORD 0
} SG_PACK BE_PCICFG_VF_MEMBAR0_HI_AMAP;
typedef struct { u32 dw[1]; } PCICFG_VF_MEMBAR0_HI_AMAP, *PPCICFG_VF_MEMBAR0_HI_AMAP;


//  HwDbg SHIFT Selction 
typedef struct {
   BE_BIT pclk[8];                                // DWORD 0
   BE_BIT core_d3[8];                             // DWORD 0
   BE_BIT core[8];                                // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_SHIFT_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_SHIFT_AMAP, *PPCICFG_HWDBG_SHIFT_AMAP;


//  Hardware Debug Mask 0 for LPC Clock Domain Register. 
typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_0_PCLK_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_0_PCLK_AMAP, *PPCICFG_HWDBG_MASK_0_PCLK_AMAP;


//  Hardware Debug Mask 1 for LPC Clock Domain Register.
typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_1_PCLK_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_1_PCLK_AMAP, *PPCICFG_HWDBG_MASK_1_PCLK_AMAP;


//  Hardware Debug Mask 0 for CORE_D3 Clock Domain Register.
typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_0_CORE_D3_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_0_CORE_D3_AMAP, *PPCICFG_HWDBG_MASK_0_CORE_D3_AMAP;


//  Hardware Debug Mask 1 for CORE_D3 Clock Domain Register. 
typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_1_CORE_D3_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_1_CORE_D3_AMAP, *PPCICFG_HWDBG_MASK_1_CORE_D3_AMAP;


//  Hardware Debug Mask 0 for CORE Clock Domain Register. 
typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_0_CORE_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_0_CORE_AMAP, *PPCICFG_HWDBG_MASK_0_CORE_AMAP;


//  Hardware Debug Mask 1 for CORE Clock Domain Register. 
typedef struct {
   BE_BIT value[32];                              // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_MASK_1_CORE_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_MASK_1_CORE_AMAP, *PPCICFG_HWDBG_MASK_1_CORE_AMAP;


//  Hardware Debug Register Select Register. 
typedef struct {
   BE_BIT pclk[8];                                // DWORD 0
   BE_BIT core_d3[8];                             // DWORD 0
   BE_BIT core[8];                                // DWORD 0
   BE_BIT up_stream_write_count[8];               // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_REGSEL_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_REGSEL_AMAP, *PPCICFG_HWDBG_REGSEL_AMAP;


//  Hardware Debug Enable Register. 
typedef struct {
   BE_BIT pclk;                                   // DWORD 0
   BE_BIT rsvd0[7];                               // DWORD 0
   BE_BIT core_d3;                                // DWORD 0
   BE_BIT rsvd1[7];                               // DWORD 0
   BE_BIT core;                                   // DWORD 0
   BE_BIT rsvd2[7];                               // DWORD 0
   BE_BIT up_stream_read_count[8];                // DWORD 0
} SG_PACK BE_PCICFG_HWDBG_ENABLE_AMAP;
typedef struct { u32 dw[1]; } PCICFG_HWDBG_ENABLE_AMAP, *PPCICFG_HWDBG_ENABLE_AMAP;


//  hwdbg_cfgreg_i[31:0]
typedef struct {
   BE_BIT host_dbg_mux_data_core_o_31_0[32];      // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_0_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_0_AMAP, *Phwdbg_cfgreg_i_0_AMAP;


//  hwdbg_cfgreg_i[63:32]
typedef struct {
   BE_BIT host_dbg_mux_data_core_o_63_32[32];     // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_1_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_1_AMAP, *Phwdbg_cfgreg_i_1_AMAP;


//  hwdbg_cfgreg_i[95:64]
typedef struct {
   BE_BIT host_dbg_mux_data_core_d3_o_31_0[32];   // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_2_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_2_AMAP, *Phwdbg_cfgreg_i_2_AMAP;


//  FCP Timer, Beacon Enable, PCI-E Configuration override
typedef struct {
   BE_BIT lbsel;                                  // DWORD 0
   BE_BIT plbsel;                                 // DWORD 0
   BE_BIT lane_rev;                               // DWORD 0
   BE_BIT beacon_en;                              // DWORD 0
   BE_BIT pcicfg_override;                        // DWORD 0
   BE_BIT fcp_timer[13];                          // DWORD 0
   BE_BIT fcp_timer_force;                        // DWORD 0
   BE_BIT mode_link_upcfg_cap_dis_force;          // DWORD 0
   BE_BIT mode_link_upcfg_cap_dis;                // DWORD 0
   BE_BIT mode_electrical_idle_infer_fc_detect;   // DWORD 0
   BE_BIT mode_electrical_idle_infer_skp_detect;  // DWORD 0
   BE_BIT mode_electrical_idle_infer_ts_detect;   // DWORD 0
   BE_BIT nec_ll_ui_enter_txl0s;                  // DWORD 0
   BE_BIT nec_ll_f0_mode_cpld_nonsuccess_malform_enable; // DWORD 0
   BE_BIT nec_ll_f0_mode_ep_ats_ur_enable;        // DWORD 0
   BE_BIT nec_ll_f0_mode_selectable_deemphasis;   // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
} SG_PACK BE_PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_AMAP;
typedef struct { u32 dw[1]; } PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_AMAP, *PPCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_AMAP;


//  Option ROM to Flash Translation Address
typedef struct {
   BE_BIT disable_ecrc;                           // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT exprom_translation_addr[16];            // DWORD 0
} SG_PACK BE_PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_AMAP;
typedef struct { u32 dw[1]; } PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_AMAP, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F0_AMAP;


//  Option ROM to Flash Translation Address
typedef struct {
   BE_BIT disable_ecrc;                           // DWORD 0
   BE_BIT rsvd0[15];                              // DWORD 0
   BE_BIT exprom_translation_addr[16];            // DWORD 0
} SG_PACK BE_PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_AMAP;
typedef struct { u32 dw[1]; } PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_AMAP, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F1_AMAP;



typedef struct {
   BE_BIT pid_wdata[17];                          // DWORD 0
   BE_BIT LTSSM_state_from_L0[7];                 // DWORD 0
   BE_BIT pid_addr[5];                            // DWORD 0
   BE_BIT disable_cfg_retry;                      // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT pid_wr;                                 // DWORD 0
} SG_PACK BE_PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_AMAP;
typedef struct { u32 dw[1]; } PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_AMAP, *PPCIE_LTSSM_CHANGE_CMD_CFG_RETRY_AMAP;



typedef struct {
   BE_BIT ari_next_cap_offset[12];                // DWORD 0
   BE_BIT rsvd0[20];                              // DWORD 0
} SG_PACK BE_PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_AMAP;
typedef struct { u32 dw[1]; } PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_AMAP, *PPCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_AMAP;


// This register is available in PF1
typedef struct {
   BE_BIT TISEMPMA_3_5db[6];                      // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT TISEMPPO_3_5db[5];                      // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT TISEMPMA_6_0db[6];                      // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
   BE_BIT TISEMPPO_6_0db[5];                      // DWORD 0
   BE_BIT rsvd3[2];                               // DWORD 0
   BE_BIT EMPHASIS_CTRL;                          // DWORD 0
} SG_PACK BE_PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_AMAP, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_AMAP;


// This register is available in PF1
typedef struct {
   BE_BIT TISAMP_1[5];                            // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT TISAMP_2[5];                            // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT TISAMP_3[5];                            // DWORD 0
   BE_BIT rsvd2[3];                               // DWORD 0
   BE_BIT TISAMP_4[5];                            // DWORD 0
   BE_BIT rsvd3[3];                               // DWORD 0
} SG_PACK BE_PCIE_SERDES_TISAMP_GEN2_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_TISAMP_GEN2_AMAP, *PPCIE_SERDES_TISAMP_GEN2_AMAP;


// This register is available in PF1
typedef struct {
   BE_BIT TISEMPMA_3_5db[6];                      // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT TISEMPPO_3_5db[5];                      // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT TISEMPMA_6_0db[6];                      // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
   BE_BIT TISEMPPO_6_0db[5];                      // DWORD 0
   BE_BIT rsvd3[3];                               // DWORD 0
} SG_PACK BE_PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_AMAP, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_AMAP;


// This register is available in PF1
typedef struct {
   BE_BIT TISAMP_1[5];                            // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT TISAMP_2[5];                            // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT TISAMP_3[5];                            // DWORD 0
   BE_BIT rsvd2[3];                               // DWORD 0
   BE_BIT TISAMP_4[5];                            // DWORD 0
   BE_BIT rsvd3[3];                               // DWORD 0
} SG_PACK BE_PCIE_SERDES_TISAMP_GEN1_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_TISAMP_GEN1_AMAP, *PPCIE_SERDES_TISAMP_GEN1_AMAP;



typedef struct {
   BE_BIT RISEQC0[3];                             // DWORD 0
   BE_BIT RISEQC1[3];                             // DWORD 0
   BE_BIT RISEQC2[3];                             // DWORD 0
   BE_BIT RISEQC3[3];                             // DWORD 0
   BE_BIT RISEQC4[3];                             // DWORD 0
   BE_BIT RISEQC5[3];                             // DWORD 0
   BE_BIT RISEQC6[3];                             // DWORD 0
   BE_BIT RISEQC7[3];                             // DWORD 0
   BE_BIT BITS_FUTURE[8];                         // DWORD 0
} SG_PACK BE_PCIE_SERDES_RISEQC_AMAP;
typedef struct { u32 dw[1]; } PCIE_SERDES_RISEQC_AMAP, *PPCIE_SERDES_RISEQC_AMAP;



typedef struct {
   BE_BIT LEVSEL[16];                             // DWORD 0
   BE_BIT V0_SEL[3];                              // DWORD 0
   BE_BIT nec_blb0_digest;                        // DWORD 0
   BE_BIT nec_PM_PME_en_D0;                       // DWORD 0
   BE_BIT nec_PM_PME_en_D3;                       // DWORD 0
   BE_BIT nec_ll_MODE_EBMODE[2];                  // DWORD 0
   BE_BIT rxf_wake_l1_l2_trans;                   // DWORD 0
   BE_BIT self_clr_lpcsoftrst;                    // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
} SG_PACK BE_PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_AMAP;
typedef struct { u32 dw[1]; } PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_AMAP, *PPCIE_PM_PME_SERDES_LEVSEL_V0_SEL_AMAP;


//  hwdbg_cfgreg_i[127:96]
typedef struct {
   BE_BIT host_dbg_mux_data_core_d3_o_63_32[32];  // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_3_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_3_AMAP, *Phwdbg_cfgreg_i_3_AMAP;


//  hwdbg_cfgreg_i[159:128]
typedef struct {
   BE_BIT host_dbg_mux_data_pclk_o_31_0[32];      // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_4_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_4_AMAP, *Phwdbg_cfgreg_i_4_AMAP;


//  hwdbg_cfgreg_i[191:160]
typedef struct {
   BE_BIT host_dbg_mux_data_core_d3_o_63_32[32];  // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_5_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_5_AMAP, *Phwdbg_cfgreg_i_5_AMAP;


//  hwdbg_cfgreg_i[255:224]
typedef struct {
   BE_BIT dbg_all_reqs_31_0[32];                  // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_7_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_7_AMAP, *Phwdbg_cfgreg_i_7_AMAP;


//  hwdbg_cfgreg_i[223:192]
typedef struct {
   BE_BIT teslave_state[4];                       // DWORD 0
   BE_BIT te_host_tlb_status_i[4];                // DWORD 0
   BE_BIT te_host_tlb_trans_i;                    // DWORD 0
   BE_BIT te_host_tlb_grdy_i;                     // DWORD 0
   BE_BIT host_te_tlb_ardy_o;                     // DWORD 0
   BE_BIT te_host_tlb_last_i;                     // DWORD 0
   BE_BIT rrm_host_donestatus_i[2];               // DWORD 0
   BE_BIT te_host_tlb_firstbe_i[4];               // DWORD 0
   BE_BIT teslv_nonpostedreqmask_o;               // DWORD 0
   BE_BIT teslv_nonpostedrdreq_o;                 // DWORD 0
   BE_BIT host_rrm_req_o;                         // DWORD 0
   BE_BIT host_rrm_type__o[2];                    // DWORD 0
   BE_BIT rrm_host_reqack_i;                      // DWORD 0
   BE_BIT rrm_host_done_i;                        // DWORD 0
   BE_BIT te_host_tlb_tag_i_6_2[7];               // DWORD 0
} SG_PACK BE_hwdbg_cfgreg_i_6_AMAP;
typedef struct { u32 dw[1]; } hwdbg_cfgreg_i_6_AMAP, *Phwdbg_cfgreg_i_6_AMAP;


//  These PCI Configuration Space registers are for the Storage         Function of
// BladeEngine (Function 0). In the memory map of the registers         below their table,
// registers that are physically common to Functions 0         and 1 are highlighted in
// pink.<BR>         under the mnemonic column.         
typedef struct {
   BE_PCICFG_ID_F0_CSR_AMAP id;
   BE_PCICFG_COMMAND_STATUS_CSR_AMAP cmd_status;
   BE_PCICFG_CLASS_REV_F0_CSR_AMAP class_rev;
   BE_PCICFG_CACHE_TMR_HDR_BIST_CSR_AMAP cache;
   BE_BIT rsvd0[32];                              // DWORD 4
   BE_PCICFG_MEMBAR0_CSR_AMAP membar0;
   BE_PCICFG_MEMBAR1_LO_CSR_AMAP membar1_lo;
   BE_PCICFG_MEMBAR1_HI_CSR_AMAP membar1_hi;
   BE_PCICFG_MEMBAR2_LO_F0_CSR_AMAP membar2_lo;
   BE_PCICFG_MEMBAR2_HI_CSR_AMAP membar2_hi;
   BE_BIT rsvd1[32];                              // DWORD 10
   BE_PCICFG_SUBSYSTEM_ID_F0_CSR_AMAP subsystem_id;
   BE_PCICFG_EXP_ROM_CSR_AMAP exp_rom;
   BE_PCICFG_CAP_CSR_AMAP cap;
   BE_BIT rsvd2[32];                              // DWORD 14
   BE_PCICFG_LATENCY_INT_F0_CSR_AMAP latency_int;
   BE_PCICFG_PMC_CSR_AMAP pmc;
   BE_PCICFG_PM_CONTROL_AMAP pm_control;
   BE_PCICFG_MSIX_CSR_AMAP msix;
   BE_PCICFG_MSIX_TABLE_CSR_AMAP msix_table_offset;
   BE_PCICFG_MSIX_PBA_CSR_AMAP msix_pba_offset;
   BE_PCICFG_HOST_CONTROL_STATUS_CSR_AMAP host_control;
   BE_PCICFG_SCRATCHPAD_CSR_AMAP scratchpad;
   BE_PCICFG_SOFT_RESET_CSR_AMAP soft_reset;
   BE_PCICFG_LPC_ADDR_CSR_AMAP lpc_addr;
   BE_PCICFG_LPC_DATA_CSR_AMAP lpc_data;
   BE_PCICFG_LPC_COMMAND_CSR_AMAP lpc_command;
   BE_PCICFG_IP_CONTROL_STATUS_3_CSR_AMAP ip_control_status_3;
   BE_PCICFG_GPI_CSR_AMAP gpi[2];
   BE_PCICFG_GPO_LOW_CSR_AMAP gpo_low;
   BE_PCICFG_GPO_HI_CSR_AMAP gpo_hi;
   BE_PCICFG_GPIOMAP_CSR_AMAP gpiomap[8];
   BE_PCICFG_UE_STATUS_LOW_CSR_AMAP ue_status_low;
   BE_PCICFG_UE_STATUS_HI_CSR_AMAP ue_status_hi;
   BE_PCICFG_UE_STATUS_LOW_MASK_CSR_AMAP ue_status_low_mask;
   BE_PCICFG_UE_STATUS_HI_MASK_CSR_AMAP ue_status_hi_mask;
   BE_PCICFG_ONLINE0_CSR_AMAP online0;
   BE_PCICFG_ONLINE1_CSR_AMAP online1;
   BE_PCICFG_DEBUG_CSR_AMAP debug;
   BE_PCICFG_SEMAPHORE_CSR_AMAP semaphore;
   BE_PCICFG_PCIE_CAP_CSR_AMAP pcie_cap;
   BE_PCICFG_PCIE_DEVCAP_CSR_AMAP pcie_devcap;
   BE_PCICFG_PCIE_CONTROL_STATUS_CSR_AMAP pcie_control_status;
   BE_PCICFG_PCIE_LINK_CAP_CSR_AMAP pcie_link_cap;
   BE_PCICFG_PCIE_LINK_STATUS_CSR_AMAP pcie_link_status;
   BE_PCICFG_RETURN_ZEROS_AMAP return_zeros[4];
   BE_PCICFG_PCIE_DEVCAP2_CSR_AMAP pcie_devcap2;
   BE_PCICFG_PCIE_CONTROL_STATUS2_CSR_AMAP pcie_control_status2;
   BE_PCICFG_PCIE_LINK_CAP2_CSR_AMAP pcie_link_cap2;
   BE_PCICFG_PCIE_LINK_STATUS2_CSR_AMAP pcie_link_status2;
   BE_PCICFG_RETURN_ZEROS_AMAP return_zeros_1[2];
   BE_PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_AMAP membar_ctrl_intr_ctrl;
   BE_PCIE_ERR_ENHANCED_CAP_AMAP pcie_err_enhanced_cap;
   BE_PCIE_UNCORR_ERR_STATUS_AMAP pcie_uncorr_err_status;
   BE_PCIE_UNCORR_ERR_MASK_AMAP pcie_uncorr_err_mask;
   BE_PCIE_UNCORR_ERR_SEVERITY_AMAP pcie_uncorr_err_severity;
   BE_PCIE_CORR_ERR_STATUS_AMAP pcie_corr_err_status;
   BE_PCIE_CORR_ERR_MASK_AMAP pcie_corr_err_mask;
   BE_PCIE_ERR_CAP_CONTROL_AMAP pcie_err_cap_control;
   BE_PCIE_HEADER_REGISTER_AMAP pcie_header_register0;
   BE_PCIE_HEADER_REGISTER_AMAP pcie_header_register1;
   BE_PCIE_HEADER_REGISTER_AMAP pcie_header_register2;
   BE_PCIE_HEADER_REGISTER_AMAP pcie_header_register3;
   BE_hwdbg_cfgreg_i_4_AMAP host_dbg_mux_data_pclk_d3_o_31_0;
   BE_hwdbg_cfgreg_i_3_AMAP host_dbg_mux_data_core_d3_o_63_32;
   BE_hwdbg_cfgreg_i_2_AMAP host_dbg_mux_data_core_d3_o_31_0;
   BE_PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_AMAP pcie_fcp_timer_beacon_en_pcicfg_override;
   BE_PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_AMAP pcie_option_rom_flash_translation_f0;
   BE_PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_AMAP pcie_ltssm_change_st_cmd_cfg_retry;
   BE_PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_AMAP pcie_pf_vfs_ari_next_cap_off;
   BE_PCIE_SERDES_RISEQC_AMAP pcie_serdes_riseqc;
   BE_PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_AMAP pcie_pm_pme_serdes_levsel_v0_sel;
   BE_hwdbg_cfgreg_i_5_AMAP host_dbg_mux_data_pclk_d3_o_63_32;
   BE_hwdbg_cfgreg_i_6_AMAP dbg_teslave_31_0;
   BE_hwdbg_cfgreg_i_0_AMAP host_dbg_mux_data_core_o_31_0;
   BE_hwdbg_cfgreg_i_1_AMAP host_dbg_mux_data_core_o_63_32;
   BE_PCIE_ARI_ENHANCED_CAP_AMAP pcie_ari_enhanced_hdr;
   BE_PCIE_ARI_CAPABILITY_AMAP pcie_ari_capability;
   BE_PCIE_ATS_ENHANCED_CAP_AMAP pcie_ats_enhanced_hdr;
   BE_PCIE_ATS_CAPABILITY_AMAP pcie_ats_capability;
   BE_hwdbg_cfgreg_i_7_AMAP dbg_all_reqs_31_0;
   BE_PCICFG_HOST_INT_STATUS_CSR_AMAP host_int_status;
   BE_PCICFG_HOST_INT_MASK_CSR_AMAP host_int_mask;
   BE_PCICFG_HOST_TIMER_INT_CTRL_CSR_AMAP host_timer_ctrl;
   BE_PCIE_SR_IOV_ENHANCED_CAP_AMAP SR_IOV_capability_id;
   BE_PCIE_SR_IOV_CAPABILITIES_AMAP SR_IOV_capabilities;
   BE_PCIE_SR_IOV_STATUS_CONTROL_AMAP SR_IOV_status_control;
   BE_PCIE_TOTAL_INITIAL_VFs_AMAP total_initial_VFs;
   BE_PCIE_NUM_VFs_AMAP number_of_VFs;
   BE_PCIE_VF_STRIDE_OFFSET_AMAP VF_stride_offset;
   BE_PCIE_VF_DEVICE_ID_AMAP VF_device_id;
   BE_PCIE_VF_SYSTEM_PAGE_SUPPORTED_AMAP PF_supported_page_size;
   BE_PCIE_VF_SYSTEM_PAGE_AMAP PF_system_page;
   BE_PCICFG_RETURN_ZEROS_AMAP return_zeros_2[2];
   BE_PCICFG_RETURN_ZEROS_AMAP return_zeros_2_1[2];
   BE_PCICFG_VF_MEMBAR0_LO_AMAP VF_membar0_low;
   BE_PCICFG_VF_MEMBAR0_HI_AMAP VF_membar0_high;
   BE_PCICFG_RETURN_ZEROS_AMAP return_zeros_3;
   BE_PCICFG_IP_SPEED_WIDTH_CTRL_AMAP ip_speed_width_control;
   BE_PCICFG_IP_CONTROL_STATUS_5_CSR_AMAP ip_control_status_5;
   BE_PCICFG_IP_CONTROL_STATUS_4_CSR_AMAP ip_control_status_4;
   BE_PCICFG_ERR_REPLAY_MONITOR_AMAP error_replay_monitor;
   BE_PCICFG_IP_CONTROL_STATUS_2_CSR_AMAP ip_control_status_2;
   BE_PCICFG_IP_CONTROL_STATUS_0_CSR_AMAP ip_control_status_0;
   BE_PCICFG_IP_CONTROL_STATUS_1_CSR_AMAP ip_control_status_1;
   BE_PCICFG_HWDBG_SHIFT_AMAP hwdbg_shift;
   BE_PCICFG_HWDBG_MASK_0_PCLK_AMAP hwdbg_mask_0_pclk;
   BE_PCICFG_HWDBG_MASK_1_PCLK_AMAP hwdbg_mask_1_pclk;
   BE_PCICFG_HWDBG_MASK_0_CORE_D3_AMAP hwdbg_mask_0_core_d3;
   BE_PCICFG_HWDBG_MASK_1_CORE_D3_AMAP hwdbg_mask_1_core_d3;
   BE_PCICFG_HWDBG_MASK_0_CORE_AMAP hwdbg_mask_0_core;
   BE_PCICFG_HWDBG_MASK_1_CORE_AMAP hwdbg_mask_1_core;
   BE_PCICFG_HWDBG_REGSEL_AMAP hwdbg_regsel;
   BE_PCICFG_HWDBG_ENABLE_AMAP hwdbg_enable;
   BE_BIT rsvd3[896][32];                         // DWORD 128
} SG_PACK BE_PCICFG_PF0_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } PCICFG_PF0_CSRMAP_AMAP, *PPCICFG_PF0_CSRMAP_AMAP;


//  This PCI configuration space register map is for the          Networking Function of
// BladeEngine (Function 1).         For more detailed descriptions of the fields below
// click the link         under the mnemonic column. Registers highlighted in pink color
// are         physically shared between both Functions (0 and 1).         
typedef struct {
   BE_PCICFG_ID_F1_CSR_AMAP id;
   BE_PCICFG_COMMAND_STATUS_CSR_AMAP cmd_status;
   BE_PCICFG_CLASS_REV_F1_CSR_AMAP class_rev;
   BE_PCICFG_CACHE_TMR_HDR_BIST_CSR_AMAP cache;
   BE_BIT rsvd0[32];                              // DWORD 4
   BE_PCICFG_MEMBAR0_CSR_AMAP membar0;
   BE_PCICFG_MEMBAR1_LO_CSR_AMAP membar1_lo;
   BE_PCICFG_MEMBAR1_HI_CSR_AMAP membar1_hi;
   BE_PCICFG_MEMBAR2_LO_F1_CSR_AMAP membar2_lo;
   BE_PCICFG_MEMBAR2_HI_CSR_AMAP membar2_hi;
   BE_BIT rsvd1[32];                              // DWORD 10
   BE_PCICFG_SUBSYSTEM_ID_F1_CSR_AMAP subsystem_id;
   BE_PCICFG_EXP_ROM_CSR_AMAP exp_rom;
   BE_PCICFG_CAP_CSR_AMAP cap;
   BE_BIT rsvd2[32];                              // DWORD 14
   BE_PCICFG_LATENCY_INT_F1_CSR_AMAP latency_int;
   BE_PCICFG_PMC_CSR_AMAP pmc;
   BE_PCICFG_PM_CONTROL_AMAP pm_control;
   BE_PCICFG_MSIX_CSR_AMAP msix;
   BE_PCICFG_MSIX_TABLE_CSR_AMAP msix_table_offset;
   BE_PCICFG_MSIX_PBA_CSR_AMAP msix_pba_offset;
   BE_PCICFG_HOST_CONTROL_STATUS_CSR_AMAP host_control;
   BE_PCICFG_SCRATCHPAD_CSR_AMAP scratchpad;
   BE_PCICFG_SOFT_RESET_CSR_AMAP soft_reset;
   BE_PCICFG_LPC_ADDR_CSR_AMAP lpc_addr;
   BE_PCICFG_LPC_DATA_CSR_AMAP lpc_data;
   BE_PCICFG_LPC_COMMAND_CSR_AMAP lpc_command;
   BE_PCICFG_IP_CONTROL_STATUS_3_CSR_AMAP ip_control_status_3;
   BE_PCICFG_GPI_CSR_AMAP gpi[2];
   BE_PCICFG_GPO_LOW_CSR_AMAP gpo_low;
   BE_PCICFG_GPO_HI_CSR_AMAP gpo_hi;
   BE_PCICFG_GPIOMAP_CSR_AMAP gpiomap[8];
   BE_PCICFG_UE_STATUS_LOW_CSR_AMAP ue_status_low;
   BE_PCICFG_UE_STATUS_HI_CSR_AMAP ue_status_hi;
   BE_PCICFG_UE_STATUS_LOW_MASK_CSR_AMAP ue_status_low_mask;
   BE_PCICFG_UE_STATUS_HI_MASK_CSR_AMAP ue_status_hi_mask;
   BE_PCICFG_ONLINE0_CSR_AMAP online0;
   BE_PCICFG_ONLINE1_CSR_AMAP online1;
   BE_PCICFG_DEBUG_CSR_AMAP debug;
   BE_PCICFG_SEMAPHORE_CSR_AMAP semaphore;
   BE_PCICFG_PCIE_CAP_CSR_AMAP pcie_cap;
   BE_PCICFG_PCIE_DEVCAP_CSR_AMAP pcie_devcap;
   BE_PCICFG_PCIE_CONTROL_STATUS_CSR_AMAP pcie_control_status;
   BE_PCICFG_PCIE_LINK_CAP_CSR_AMAP pcie_link_cap;
   BE_PCICFG_PCIE_LINK_STATUS_CSR_AMAP pcie_link_status;
   BE_PCICFG_RETURN_ZEROS_AMAP return_zeros[4];
   BE_PCICFG_PCIE_DEVCAP2_CSR_AMAP pcie_devcap2;
   BE_PCICFG_PCIE_CONTROL_STATUS2_CSR_AMAP pcie_control_status2;
   BE_PCICFG_PCIE_LINK_CAP2_CSR_AMAP pcie_link_cap2;
   BE_PCICFG_PCIE_LINK_STATUS2_CSR_F1_AMAP pcie_link_status2;
   BE_PCICFG_RETURN_ZEROS_AMAP return_zeros_1[2];
   BE_PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_AMAP membar_ctrl_intr_ctrl;
   BE_PCIE_ERR_ENHANCED_CAP_AMAP pcie_err_enhanced_cap;
   BE_PCIE_UNCORR_ERR_STATUS_AMAP pcie_uncorr_err_status;
   BE_PCIE_UNCORR_ERR_MASK_AMAP pcie_uncorr_err_mask;
   BE_PCIE_UNCORR_ERR_SEVERITY_AMAP pcie_uncorr_err_severity;
   BE_PCIE_CORR_ERR_STATUS_AMAP pcie_corr_err_status;
   BE_PCIE_CORR_ERR_MASK_AMAP pcie_corr_err_mask;
   BE_PCIE_ERR_CAP_CONTROL_AMAP pcie_err_cap_control;
   BE_PCIE_HEADER_REGISTER_AMAP pcie_header_register0;
   BE_PCIE_HEADER_REGISTER_AMAP pcie_header_register1;
   BE_PCIE_HEADER_REGISTER_AMAP pcie_header_register2;
   BE_PCIE_HEADER_REGISTER_AMAP pcie_header_register3;
   BE_BIT rsvd3[128];                             // DWORD 75
   BE_PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_AMAP pcie_option_rom_flash_translation_f1;
   BE_BIT rsvd4[32];                              // DWORD 80
   BE_PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_AMAP pcie_pf_vfs_ari_next_cap_off;
   BE_BIT rsvd5[192];                             // DWORD 82
   BE_PCIE_ARI_ENHANCED_CAP_AMAP pcie_ari_enhanced_hdr;
   BE_PCIE_ARI_CAPABILITY_AMAP pcie_ari_capability;
   BE_PCIE_ATS_ENHANCED_CAP_AMAP pcie_ats_enhanced_hdr;
   BE_PCIE_ATS_CAPABILITY_AMAP pcie_ats_capability;
   BE_BIT rsvd6[32];                              // DWORD 92
   BE_PCICFG_HOST_INT_STATUS_CSR_AMAP host_int_status;
   BE_PCICFG_HOST_INT_MASK_CSR_AMAP host_int_mask;
   BE_PCICFG_HOST_TIMER_INT_CTRL_CSR_AMAP host_timer_ctrl;
   BE_PCIE_SR_IOV_ENHANCED_CAP_AMAP SR_IOV_capability_id;
   BE_PCIE_SR_IOV_CAPABILITIES_AMAP SR_IOV_capabilities;
   BE_PCIE_SR_IOV_STATUS_CONTROL_AMAP SR_IOV_status_control;
   BE_PCIE_TOTAL_INITIAL_VFs_AMAP total_initial_VFs;
   BE_PCIE_NUM_VFs_AMAP number_of_VFs;
   BE_PCIE_VF_STRIDE_OFFSET_AMAP VF_stride_offset;
   BE_PCIE_VF_DEVICE_ID_AMAP VF_device_id;
   BE_PCIE_VF_SYSTEM_PAGE_SUPPORTED_AMAP PF_supported_page_size;
   BE_PCIE_VF_SYSTEM_PAGE_AMAP PF_system_page;
   BE_PCICFG_RETURN_ZEROS_AMAP return_zeros_2[2];
   BE_PCICFG_RETURN_ZEROS_AMAP return_zeros_2_1[2];
   BE_PCICFG_VF_MEMBAR0_LO_AMAP VF_membar0_low;
   BE_PCICFG_VF_MEMBAR0_HI_AMAP VF_membar0_high;
   BE_PCICFG_RETURN_ZEROS_AMAP return_zeros_3;
   BE_BIT rsvd7[160];                             // DWORD 112
   BE_BIT rsvd8[224];                             // DWORD 117
   BE_PCIE_SERDES_TISAMP_GEN1_AMAP gen1_tisamp;
   BE_PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_AMAP gen1_tisemppo_tisempma;
   BE_PCIE_SERDES_TISAMP_GEN2_AMAP gen2_tisamp;
   BE_PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_AMAP gen2_tisemppo_tisempma;
   BE_BIT rsvd9[896][32];                         // DWORD 128
} SG_PACK BE_PCICFG_PF1_PF7_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } PCICFG_PF1_PF7_CSRMAP_AMAP, *PPCICFG_PF1_PF7_CSRMAP_AMAP;



typedef struct {
   BE_PCICFG_PF0_CSRMAP_AMAP PCICFG_F0_CSRMAP;
} SG_PACK BE_PCICFG0_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } PCICFG0_CSRMAP_AMAP, *PPCICFG0_CSRMAP_AMAP;



typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_AMAP PCICFG_F1_CSRMAP;
} SG_PACK BE_PCICFG1_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } PCICFG1_CSRMAP_AMAP, *PPCICFG1_CSRMAP_AMAP;



typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_AMAP PCICFG_F2_CSRMAP;
} SG_PACK BE_PCICFG2_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } PCICFG2_CSRMAP_AMAP, *PPCICFG2_CSRMAP_AMAP;



typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_AMAP PCICFG_F3_CSRMAP;
} SG_PACK BE_PCICFG3_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } PCICFG3_CSRMAP_AMAP, *PPCICFG3_CSRMAP_AMAP;



typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_AMAP PCICFG_F4_CSRMAP;
} SG_PACK BE_PCICFG4_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } PCICFG4_CSRMAP_AMAP, *PPCICFG4_CSRMAP_AMAP;



typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_AMAP PCICFG_F5_CSRMAP;
} SG_PACK BE_PCICFG5_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } PCICFG5_CSRMAP_AMAP, *PPCICFG5_CSRMAP_AMAP;



typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_AMAP PCICFG_F6_CSRMAP;
} SG_PACK BE_PCICFG6_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } PCICFG6_CSRMAP_AMAP, *PPCICFG6_CSRMAP_AMAP;



typedef struct {
   BE_PCICFG_PF1_PF7_CSRMAP_AMAP PCICFG_F7_CSRMAP;
} SG_PACK BE_PCICFG7_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } PCICFG7_CSRMAP_AMAP, *PPCICFG7_CSRMAP_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __pcicfg_amap_h__

