/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __rxf_amap_h__
#define __rxf_amap_h__
#include "setypes.h"
#include "defines.h"
#include "hwdbg_reg.h"
#include "gencommon.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_BIT rx_bytes_lsd[32];                       // DWORD 0
   BE_BIT rx_bytes_msd[32];                       // DWORD 1
   BE_BIT rx_total_frames[32];                    // DWORD 2
   BE_BIT rx_unicast_frames[32];                  // DWORD 3
   BE_BIT rx_multicast_frames[32];                // DWORD 4
   BE_BIT rx_broadcast_frames[32];                // DWORD 5
   BE_BIT rx_crc_errors[32];                      // DWORD 6
   BE_BIT rx_alignment_symbol_errors[32];         // DWORD 7
   BE_BIT rx_pause_frames[32];                    // DWORD 8
   BE_BIT rx_control_frames[32];                  // DWORD 9
   BE_BIT rx_in_range_errors[32];                 // DWORD 10
   BE_BIT rx_out_range_errors[32];                // DWORD 11
   BE_BIT rx_frame_too_long[32];                  // DWORD 12
   BE_BIT rx_address_match_errors[32];            // DWORD 13
   BE_BIT rx_vlan_mismatch[32];                   // DWORD 14
   BE_BIT rx_dropped_too_small[32];               // DWORD 15
   BE_BIT rx_dropped_too_short[32];               // DWORD 16
   BE_BIT rx_dropped_header_too_small[32];        // DWORD 17
   BE_BIT rx_dropped_tcp_length[32];              // DWORD 18
   BE_BIT rx_dropped_runt[32];                    // DWORD 19
   BE_BIT rx_64_byte_packets[32];                 // DWORD 20
   BE_BIT rx_65_127_byte_packets[32];             // DWORD 21
   BE_BIT rx_128_256_byte_packets[32];            // DWORD 22
   BE_BIT rx_256_511_byte_packets[32];            // DWORD 23
   BE_BIT rx_512_1023_byte_packets[32];           // DWORD 24
   BE_BIT rx_1024_1518_byte_packets[32];          // DWORD 25
   BE_BIT rx_1519_2047_byte_packets[32];          // DWORD 26
   BE_BIT rx_2048_4095_byte_packets[32];          // DWORD 27
   BE_BIT rx_4096_8191_byte_packets[32];          // DWORD 28
   BE_BIT rx_8192_9216_byte_packets[32];          // DWORD 29
   BE_BIT rx_ip_checksum_errs[32];                // DWORD 30
   BE_BIT rx_tcp_checksum_errs[32];               // DWORD 31
   BE_BIT rx_udp_checksum_errs[32];               // DWORD 32
   BE_BIT rx_non_rss_packets[32];                 // DWORD 33
   BE_BIT rx_ipv4_packets[32];                    // DWORD 34
   BE_BIT rx_ipv6_packets[32];                    // DWORD 35
   BE_BIT rx_ipv4_bytes_lsd[32];                  // DWORD 36
   BE_BIT rx_ipv4_bytes_msd[32];                  // DWORD 37
   BE_BIT rx_ipv6_bytes_lsd[32];                  // DWORD 38
   BE_BIT rx_ipv6_bytes_msd[32];                  // DWORD 39
   BE_BIT rx_chute1_packets[32];                  // DWORD 40
   BE_BIT rx_chute2_packets[32];                  // DWORD 41
   BE_BIT rx_chute3_packets[32];                  // DWORD 42
   BE_BIT rx_management_packets[32];              // DWORD 43
   BE_BIT rx_switched_unicast_packets[32];        // DWORD 44
   BE_BIT rx_switched_multicast_packets[32];      // DWORD 45
   BE_BIT rx_switched_broadcast_packets[32];      // DWORD 46
   BE_BIT tx_bytes_lsd[32];                       // DWORD 47
   BE_BIT tx_bytes_msd[32];                       // DWORD 48
   BE_BIT tx_unicastframes[32];                   // DWORD 49
   BE_BIT tx_multicastframes[32];                 // DWORD 50
   BE_BIT tx_broadcastframes[32];                 // DWORD 51
   BE_BIT tx_pauseframes[32];                     // DWORD 52
   BE_BIT tx_controlframes[32];                   // DWORD 53
   BE_BIT tx_64_byte_packets[32];                 // DWORD 54
   BE_BIT tx_65_127_byte_packets[32];             // DWORD 55
   BE_BIT tx_128_256_byte_packets[32];            // DWORD 56
   BE_BIT tx_256_511_byte_packets[32];            // DWORD 57
   BE_BIT tx_512_1023_byte_packets[32];           // DWORD 58
   BE_BIT tx_1024_1518_byte_packets[32];          // DWORD 59
   BE_BIT tx_1519_2047_byte_packets[32];          // DWORD 60
   BE_BIT tx_2048_4095_byte_packets[32];          // DWORD 61
   BE_BIT tx_4096_8191_byte_packets[32];          // DWORD 62
   BE_BIT tx_8192_9216_byte_packets[32];          // DWORD 63
   BE_BIT rx_fifo_overflow[32];                   // DWORD 64
   BE_BIT rx_input_fifo_overflow[32];             // DWORD 65
} SG_PACK BE_BE2_PORT_RXF_STATS_AMAP;
typedef struct { u32 dw[66]; } BE2_PORT_RXF_STATS_AMAP, *PBE2_PORT_RXF_STATS_AMAP;



typedef struct {
   BE_BIT rx_drops_payload_size[32];              // DWORD 0
   BE_BIT rx_drops_crc[32];                       // DWORD 1
   BE_BIT rx_drops_clipped_header[32];            // DWORD 2
} SG_PACK BE_BE2_FCOE_PORT_STATS_AMAP;
typedef struct { u32 dw[3]; } BE2_FCOE_PORT_STATS_AMAP, *PBE2_FCOE_PORT_STATS_AMAP;



typedef struct {
   BE_BE2_PORT_RXF_STATS_AMAP port[2];
   BE_BIT rx_drops_no_pbuf[32];                   // DWORD 132
   BE_BIT rx_drops_no_txpb[32];                   // DWORD 133
   BE_BIT rx_drops_no_erx_descr[32];              // DWORD 134
   BE_BIT rx_drops_no_tpre_descr[32];             // DWORD 135
   BE_BIT management_rx_port_packets[32];         // DWORD 136
   BE_BIT management_rx_port_bytes[32];           // DWORD 137
   BE_BIT management_rx_port_pause_frames[32];    // DWORD 138
   BE_BIT management_rx_port_errors[32];          // DWORD 139
   BE_BIT management_tx_port_packets[32];         // DWORD 140
   BE_BIT management_tx_port_bytes[32];           // DWORD 141
   BE_BIT management_tx_port_pause[32];           // DWORD 142
   BE_BIT management_rx_port_rxfifo_overflow[32]; // DWORD 143
   BE_BIT rx_drops_too_many_frags[32];            // DWORD 144
   BE_BIT rx_drops_invalid_ring[32];              // DWORD 145
   BE_BIT forwarded_packets[32];                  // DWORD 146
   BE_BIT rx_drops_mtu[32];                       // DWORD 147
   BE_BE2_FCOE_PORT_STATS_AMAP fcoe_port[2];
   BE_BIT fcoe_rx_drops_no_pbufs[32];             // DWORD 154
   BE_BIT port0_jabber_events[32];                // DWORD 155
   BE_BIT port1_jabber_events[32];                // DWORD 156
   BE_BIT port0_fcoe_bytes_received_lsd[32];      // DWORD 157
   BE_BIT port0_fcoe_bytes_received_msd[32];      // DWORD 158
   BE_BIT port0_fcoe_frames_received[32];         // DWORD 159
   BE_BIT port1_fcoe_bytes_received_lsd[32];      // DWORD 160
   BE_BIT port1_fcoe_bytes_received_msd[32];      // DWORD 161
   BE_BIT port1_fcoe_frames_received[32];         // DWORD 162
} SG_PACK BE_BE2_RXF_STATS_AMAP;
typedef struct { u32 dw[163]; } BE2_RXF_STATS_AMAP, *PBE2_RXF_STATS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __rxf_amap_h__

