/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __tcp_context_amap_h__
#define __tcp_context_amap_h__
#include "setypes.h"
#include "defines.h"
#include "headers.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- TCP_CONTEXT_CAP_FLAGS ---
// Capabilities for the connection 
#define TCP_CONTEXT_CAP_OOO_DISABLE     (1)       // Disables OOO processing in the TPRE 
#define TCP_CONTEXT_CAP_USE_PUSH_TMR    (2)       // Enables use of push timer 
#define TCP_CONTEXT_CAP_CHECK_CLASSIFICATION (4)  // Enables checking of classification
                                                  // flags, requires USE_CLASSIFICATION to
                                                  // be set 
#define TCP_CONTEXT_CAP_MPA_CRC         (8)       // Enables MPA CRC Check for the
                                                  // connection 
#define TCP_CONTEXT_CAP_RED_DISABLE     (16)      // Disables RED processing in the TPRE 
#define TCP_CONTEXT_CAP_TT_ENABLE       (32)      // Enables or disables Triple tripping 
#define TCP_CONTEXT_CAP_USE_CREDITS     (64)      // Enables use of credits on the tpre 
#define TCP_CONTEXT_CAP_AUTO_WINDOW     (128)     // Automatically manages rcv window 
#define TCP_CONTEXT_CAP_PROBE_DATA      (256)     // Send one byte of data in window probe
                                                  // if possible 

typedef enum {
   ENUM_TCP_CONTEXT_CAP_OOO_DISABLE = 0x1UL,
   ENUM_TCP_CONTEXT_CAP_USE_PUSH_TMR = 0x2UL,
   ENUM_TCP_CONTEXT_CAP_CHECK_CLASSIFICATION = 0x4UL,
   ENUM_TCP_CONTEXT_CAP_MPA_CRC = 0x8UL,
   ENUM_TCP_CONTEXT_CAP_RED_DISABLE = 0x10UL,
   ENUM_TCP_CONTEXT_CAP_TT_ENABLE = 0x20UL,
   ENUM_TCP_CONTEXT_CAP_USE_CREDITS = 0x40UL,
   ENUM_TCP_CONTEXT_CAP_AUTO_WINDOW = 0x80UL,
   ENUM_TCP_CONTEXT_CAP_PROBE_DATA = 0x100UL
} TCP_CONTEXT_CAP_FLAGS;

//         TCP connection context structure           <p> Colour codes used for
// TCP_CONTEXT           <li> Light green : These fields are modified by TPRE and accessed
// by timer, Tcp scheduler or window update HW logic.           <li> Green : These fields
// are modified and used only by TPRE firmware.           <li> Dark green : These fields
// are constants which do not change through out the life time of the connection.         
//  <li> Light blue : These fields are modified by TPOST and accessed by hardware blocks. 
//          <li> Blue : These fields are modified and used only by TPOST firmware.        
//   <li> Dark blue : These fields are constants which do not change through out the life
// time of the connection.     
typedef struct {
   BE_BIT snd_max[32];                            // DWORD 0
   BE_BIT snd_nxt[32];                            // DWORD 1
   BE_BIT t_state[8];                             // DWORD 2
   BE_BIT t_flags[12];                            // DWORD 2
   BE_BIT rxmt_ctr_snap[5];                       // DWORD 2
   BE_BIT journal_in_ddr;                         // DWORD 2
   BE_BIT templ_hdr_in_ddr;                       // DWORD 2
   BE_BIT in_rxmt;                                // DWORD 2
   BE_BIT t_rxtshift[4];                          // DWORD 2
   BE_BIT last_ack_sent[32];                      // DWORD 3
   BE_BIT tcp_rtts[32];                           // DWORD 4
   BE_BIT t_rtseq[32];                            // DWORD 5
   BE_BIT ka_probe_cnt[4];                        // DWORD 6
   BE_BIT ka_probe_max[4];                        // DWORD 6
   BE_BIT ka_interval[8];                         // DWORD 6
   BE_BIT rxmt_ctr[5];                            // DWORD 6
   BE_BIT rexmt_cnt[4];                           // DWORD 6
   BE_BIT persist_cnt[7];                         // DWORD 6
   BE_BIT last_wnd_update_sent[32];               // DWORD 7
   BE_BIT port_id1[2];                            // DWORD 8
   BE_BIT ulp_id[2];                              // DWORD 8
   BE_BIT hdr_len[7];                             // DWORD 8
   BE_BIT max_rt[8];                              // DWORD 8
   BE_BIT timers_cleared;                         // DWORD 8
   BE_BIT is_ipv6;                                // DWORD 8
   BE_BIT ka_timeout[11];                         // DWORD 8
   BE_BIT rcv_last[32];                           // DWORD 9
   BE_BIT rexmt_tmr[8];                           // DWORD 10
   BE_BIT txidle_tmr[8];                          // DWORD 10
   BE_BIT ka_interval_tmr[8];                     // DWORD 10
   BE_BIT persist_tmr[8];                         // DWORD 10
   BE_BIT push_tmr[8];                            // DWORD 11
   BE_BIT delack_tmr[8];                          // DWORD 11
   BE_BIT finwait2_tmr[8];                        // DWORD 11
   BE_BIT ka_tmr[8];                              // DWORD 11
   BE_BIT rcv_nxt[32];                            // DWORD 12
   BE_BIT ts_delta[32];                           // DWORD 13
   BE_BIT cid[16];                                // DWORD 14
   BE_BIT tcp_vlan_id[16];                        // DWORD 14
   BE_BIT recover[32];                            // DWORD 15
   BE_BIT ts_recent_age[32];                      // DWORD 16
   BE_BIT ka_cnt[8];                              // DWORD 17
   BE_BIT snd_scale[5];                           // DWORD 17
   BE_BIT rcv_scale[5];                           // DWORD 17
   BE_BIT cap_flags[9];                           // DWORD 17
   BE_BIT sack_blocks_count[2];                   // DWORD 17
   BE_BIT tpre_uploading;                         // DWORD 17
   BE_BIT num_valid_holes[2];                     // DWORD 17
   BE_BIT max_sndwnd[16];                         // DWORD 18
   BE_BIT delack_count[4];                        // DWORD 18
   BE_BIT pci_func[4];                            // DWORD 18
   BE_BIT t_dupacks[8];                           // DWORD 18
   BE_BIT ts_recent[32];                          // DWORD 19
   BE_BIT snd_una[32];                            // DWORD 20
   BE_BIT t_maxseg[16];                           // DWORD 21
   BE_BIT port_id[2];                             // DWORD 21
   BE_BIT t_dupacks2[2];                          // DWORD 21
   BE_BIT rx_state[4];                            // DWORD 21
   BE_BIT rx_flags[8];                            // DWORD 21
   BE_BIT snd_cwnd[32];                           // DWORD 22
   BE_BIT snd_last[32];                           // DWORD 23
   BE_BIT rcv_ooend[32];                          // DWORD 24
   BE_BIT rcv_oostart[32];                        // DWORD 25
   BE_BIT t_rtt_delta[16];                        // DWORD 26
   BE_BIT rx_rxmt_ctr[5];                         // DWORD 26
   BE_BIT jfree_outstanding[4];                   // DWORD 26
   BE_BIT pd_id[6];                               // DWORD 26
   BE_BIT ooo_rst;                                // DWORD 26
   BE_BIT bytes_acked[32];                        // DWORD 27
   BE_BIT saved_una[32];                          // DWORD 28
   BE_BIT t_srtt[16];                             // DWORD 29
   BE_BIT t_rttvar[16];                           // DWORD 29
   BE_BIT snd_wl1[32];                            // DWORD 30
   BE_BIT snd_ssthresh[32];                       // DWORD 31
} SG_PACK BE_TCP_CONTEXT_AMAP;
typedef struct { u32 dw[32]; } TCP_CONTEXT_AMAP, *PTCP_CONTEXT_AMAP;


// --- TCP_CONTEXT_INTERESTING_OFFSETS ---
#define TCP_CONTEXT_PORT_ID1_BYTE_OFFSET (36)     
#define TCP_CONTEXT_MSS_BYTE_OFFSET     (80)      
#define TCP_CONTEXT_PORT_ID_BYTE_OFFSET (82)      

typedef enum {
   ENUM_TCP_CONTEXT_PORT_ID1_BYTE_OFFSET = 0x24UL,
   ENUM_TCP_CONTEXT_MSS_BYTE_OFFSET = 0x50UL,
   ENUM_TCP_CONTEXT_PORT_ID_BYTE_OFFSET = 0x52UL
} TCP_CONTEXT_INTERESTING_OFFSETS;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __tcp_context_amap_h__

