/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __toe_context_amap_h__
#define __toe_context_amap_h__
#include "setypes.h"
#include "defines.h"
#include "descriptors.h"
#include "ulp_context.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- TOERX_STATE ---
#define TOERX_STATE_UCREQ               (0)       // UC request in progress.
#define TOERX_STATE_DEFAULT_BUFFERS     (1)       // Default buffers in use. 
#define TOERX_STATE_PREPOSTED_BUFFERS   (2)       // Preposted buffers in use.
#define TOERX_STATE_OOO                 (3)       // Out of order packet processing in
                                                  // progress.

typedef enum {
   ENUM_TOERX_STATE_UCREQ = 0x0UL,
   ENUM_TOERX_STATE_DEFAULT_BUFFERS = 0x1UL,
   ENUM_TOERX_STATE_PREPOSTED_BUFFERS = 0x2UL,
   ENUM_TOERX_STATE_OOO = 0x3UL
} TOERX_STATE;

// --- TOERX_DEFAULT_MODE ---
#define TOERX_DEFAULT_COMPL_PACK        (0)       // In this mode every default buffer is
                                                  // completely packed untill push or
                                                  // pushtmr or fin
#define TOERX_DEFAULT_NO_PACKET_SPLIT   (1)       // No packet is split across two buffers
#define TOERX_DEFAULT_NO_PACK           (2)       // In this mode every default buffer is
                                                  // completed with single packed.

typedef enum {
   ENUM_TOERX_DEFAULT_COMPL_PACK = 0x0UL,
   ENUM_TOERX_DEFAULT_NO_PACKET_SPLIT = 0x1UL,
   ENUM_TOERX_DEFAULT_NO_PACK = 0x2UL
} TOERX_DEFAULT_MODE;

// TOE connection context structure.
typedef struct {
   BE_BIT tx_cidx[14];                            // DWORD 0
   BE_BIT del_state_not_vld;                      // DWORD 0
   BE_BIT use_repeat_wrb;                         // DWORD 0
   BE_BIT tx_ring_size[4];                        // DWORD 0
   BE_BIT fetch_wrb;                              // DWORD 0
   BE_BIT fetch_r2t;                              // DWORD 0
   BE_BIT toetx_opaque[8];                        // DWORD 0
   BE_BIT tx_delegated;                           // DWORD 0
   BE_BIT sws_avoid;                              // DWORD 0
   BE_BIT pidx[14];                               // DWORD 1
   BE_BIT pci_func_id[8];                         // DWORD 1
   BE_BIT pd_id[9];                               // DWORD 1
   BE_BIT ctx_valid;                              // DWORD 1
   BE_BIT cq_id_send[10];                         // DWORD 2
   BE_BIT default_ring_rid[3];                    // DWORD 2
   BE_BIT rsvd0;                                  // DWORD 2
   BE_BIT disable_repeat_wrb;                     // DWORD 2
   BE_BIT disable_sws;                            // DWORD 2
   BE_BIT local_flow_id[5];                       // DWORD 2
   BE_BIT global_flow_id[5];                      // DWORD 2
   BE_BIT rsvd1[2];                               // DWORD 2
   BE_BIT yellow_to_red_local;                    // DWORD 2
   BE_BIT yellow_to_red_global;                   // DWORD 2
   BE_BIT no_remain_allowed;                      // DWORD 2
   BE_BIT excess_qos;                             // DWORD 2
   BE_BIT t_maxseg[16];                           // DWORD 3
   BE_BIT sws_timestamp[16];                      // DWORD 3
   BE_BIT window_bleed_bytes[32];                 // DWORD 4
   BE_BIT data_bytes_posted[32];                  // DWORD 5
   BE_BIT rx_preposted_sequence[32];              // DWORD 6
   BE_BIT remaining_sgl_bytes[20];                // DWORD 7
   BE_BIT preposted_push_mode;                    // DWORD 7
   BE_BIT consumed_preposted_window;              // DWORD 7
   BE_BIT last_sgl;                               // DWORD 7
   BE_BIT saved_preposted_cidx[9];                // DWORD 7
   BE_BIT saved_preposted_offset[20];             // DWORD 8
   BE_BIT previous_state[2];                      // DWORD 8
   BE_BIT current_state[2];                       // DWORD 8
   BE_BIT push_preposted_sgl;                     // DWORD 8
   BE_BIT fin_preposted_sgl;                      // DWORD 8
   BE_BIT rx_flush_done;                          // DWORD 8
   BE_BIT scheduler_grant_held;                   // DWORD 8
   BE_BIT tpred_vqueue_disarmed;                  // DWORD 8
   BE_BIT fence_next_wcon_d;                      // DWORD 8
   BE_BIT schedule_ack;                           // DWORD 8
   BE_BIT consume_preposted_bytes;                // DWORD 8
   BE_BIT preposted_dma_bytes[20];                // DWORD 9
   BE_BIT cq_id_def[10];                          // DWORD 9
   BE_BIT ooo_hole_count[2];                      // DWORD 9
   BE_BIT stake_index[14];                        // DWORD 10
   BE_BIT stake_valid;                            // DWORD 10
   BE_BIT tx_flush_done;                          // DWORD 10
   BE_BIT default_buff_offset[14];                // DWORD 10
   BE_BIT fin_indicated;                          // DWORD 10
   BE_BIT skip_preposted_sgl_group;               // DWORD 10
   BE_BIT stake_sequence[32];                     // DWORD 11
   BE_BIT preposted_cidx[14];                     // DWORD 12
   BE_BIT default_mode[2];                        // DWORD 12
   BE_BIT rx_ring_size[4];                        // DWORD 12
   BE_BIT cq_id_recv[10];                         // DWORD 12
   BE_BIT default_buff_size[2];                   // DWORD 12
   BE_BIT preposted_pidx[14];                     // DWORD 13
   BE_BIT rx_pci_func[8];                         // DWORD 13
   BE_BIT rx_pdid[9];                             // DWORD 13
   BE_BIT rx_pdid_valid;                          // DWORD 13
   BE_BIT tx_buf_offset[16];                      // DWORD 14
   BE_BIT last_tx_len[16];                        // DWORD 14
   BE_BIT cur_seq[32];                            // DWORD 15
} SG_PACK BE_TOE_CONTEXT_AMAP;
typedef struct { u32 dw[16]; } TOE_CONTEXT_AMAP, *PTOE_CONTEXT_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_BIT rsvd2[32];                              // DWORD 2
   BE_BIT rsvd3[32];                              // DWORD 3
   BE_BIT rsvd4[32];                              // DWORD 4
   BE_BIT rsvd5[32];                              // DWORD 5
   BE_BIT rsvd6[32];                              // DWORD 6
   BE_BIT rsvd7[32];                              // DWORD 7
   BE_BIT rsvd8[32];                              // DWORD 8
   BE_BIT rsvd9[32];                              // DWORD 9
   BE_BIT rsvd10[32];                             // DWORD 10
   BE_BIT rsvd11[32];                             // DWORD 11
   BE_BIT buff_cidx[14];                          // DWORD 12
   BE_BIT rsvd12[2];                              // DWORD 12
   BE_BIT ring_size[4];                           // DWORD 12
   BE_BIT rsvd13[10];                             // DWORD 12
   BE_BIT reserve_1_dbuffer;                      // DWORD 12
   BE_BIT flush_done;                             // DWORD 12
   BE_BIT buff_pidx[14];                          // DWORD 13
   BE_BIT pci_func[8];                            // DWORD 13
   BE_BIT pdid[9];                                // DWORD 13
   BE_BIT pdid_valid;                             // DWORD 13
   BE_BIT rsvd14[32];                             // DWORD 14
   BE_BIT rsvd15[32];                             // DWORD 15
} SG_PACK BE_TOE_DEFAULT_BUFFER_AMAP;
typedef struct { u32 dw[16]; } TOE_DEFAULT_BUFFER_AMAP, *PTOE_DEFAULT_BUFFER_AMAP;



typedef struct {
   struct {
      BE_BIT high[32];                            // DWORD 0
      BE_BIT low[32];                             // DWORD 1
   } addr[32];
} SG_PACK BE_TOERX_FRAGMENT_BUFFER_AMAP;
typedef struct { u32 dw[64]; } TOERX_FRAGMENT_BUFFER_AMAP, *PTOERX_FRAGMENT_BUFFER_AMAP;


// ETX ring  context structure.
typedef struct {
   BE_BIT tx_cidx[14];                            // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT tx_ring_size[4];                        // DWORD 0
   BE_BIT fetch_wrb;                              // DWORD 0
   BE_BIT fetch_r2t;                              // DWORD 0
   BE_BIT rsvd1[5];                               // DWORD 0
   BE_BIT inner_vtag;                             // DWORD 0
   BE_BIT outer_vtag;                             // DWORD 0
   BE_BIT per_priority_class[3];                  // DWORD 0
   BE_BIT pidx[14];                               // DWORD 1
   BE_BIT pci_func_id[8];                         // DWORD 1
   BE_BIT pd_id[9];                               // DWORD 1
   BE_BIT ctx_valid;                              // DWORD 1
   BE_BIT cq_id_send[16];                         // DWORD 2
   BE_BIT local_flow_id[5];                       // DWORD 2
   BE_BIT global_flow_id[5];                      // DWORD 2
   BE_BIT rsvd2[2];                               // DWORD 2
   BE_BIT yellow_to_red_local;                    // DWORD 2
   BE_BIT yellow_to_red_global;                   // DWORD 2
   BE_BIT no_remain_allowed;                      // DWORD 2
   BE_BIT excess_qos;                             // DWORD 2
   BE_BIT inner_vtag_val[16];                     // DWORD 3
   BE_BIT outer_vtag_val[16];                     // DWORD 3
   BE_BIT tcp_ack_number[32];                     // DWORD 4
   BE_BIT tcp_timestamp_ecr[32];                  // DWORD 5
   BE_BIT tcp_window[16];                         // DWORD 6
   BE_BIT vlan_tag[16];                           // DWORD 6
   BE_BIT pktsize[16];                            // DWORD 7
   BE_BIT dupack_count[2];                        // DWORD 7
   BE_BIT qinq;                                   // DWORD 7
   BE_BIT tsopt;                                  // DWORD 7
   BE_BIT ip_version;                             // DWORD 7
   BE_BIT snap;                                   // DWORD 7
   BE_BIT tcp_push;                               // DWORD 7
   BE_BIT vtp;                                    // DWORD 7
   BE_BIT lro_flush;                              // DWORD 7
   BE_BIT lro_timer_pop;                          // DWORD 7
   BE_BIT cid[5];                                 // DWORD 7
   BE_BIT valid;                                  // DWORD 7
   BE_BIT ctx_addr2_part1[16];                    // DWORD 8
   BE_BIT rsvd3[16];                              // DWORD 8
   BE_BIT ctx_addr1_part1[24];                    // DWORD 9
   BE_BIT ctx_addr2_part2[8];                     // DWORD 9
   BE_BIT lro_page_size[16];                      // DWORD 10
   BE_BIT buff_size_mask[16];                     // DWORD 10
   BE_BIT ring_size_mask[32];                     // DWORD 11
   BE_BIT lro_pidx[14];                           // DWORD 12
   BE_BIT rsvd4;                                  // DWORD 12
   BE_BIT disable_qos;                            // DWORD 12
   BE_BIT rx_ring_size[4];                        // DWORD 12
   BE_BIT rsvd5[12];                              // DWORD 12
   BE_BIT lro_cidx[14];                           // DWORD 13
   BE_BIT rx_pci_func[8];                         // DWORD 13
   BE_BIT lro_pdid[9];                            // DWORD 13
   BE_BIT lro_pdid_valid;                         // DWORD 13
   BE_BIT mrklen[2];                              // DWORD 14
   BE_BIT fence;                                  // DWORD 14
   BE_BIT fenceAll;                               // DWORD 14
   BE_BIT CQid[10];                               // DWORD 14
   BE_BIT SolEvent;                               // DWORD 14
   BE_BIT mrkpreface;                             // DWORD 14
   BE_BIT EPretCargo[8];                          // DWORD 14
   BE_BIT wcon_rsvd[8];                           // DWORD 14
   BE_BIT FID[8];                                 // DWORD 15
   BE_BIT tgtsel;                                 // DWORD 15
   BE_BIT dif_mode[2];                            // DWORD 15
   BE_BIT HoldPyldDBUFs;                          // DWORD 15
   BE_BIT wconPageSize[3];                        // DWORD 15
   BE_BIT msrc;                                   // DWORD 15
   BE_BIT mrkstart[13];                           // DWORD 15
   BE_BIT mrkstride[2];                           // DWORD 15
   BE_BIT mrken;                                  // DWORD 15
} SG_PACK BE_ETX_CONTEXT_AMAP;
typedef struct { u32 dw[16]; } ETX_CONTEXT_AMAP, *PETX_CONTEXT_AMAP;


//            Ethernet Primary shadow rings. Each ring can hold 64 WRBs and is sized      
//     (64*16) = 1024 bytes         
typedef struct {
   BE_BE2_ETH_WRB_AMAP wrbs[64];
} SG_PACK BE_ETX_PRIMARY_SHAD_RING_AMAP;
typedef struct { u32 dw[256]; } ETX_PRIMARY_SHAD_RING_AMAP, *PETX_PRIMARY_SHAD_RING_AMAP;


//            Ethernet Secondary shadow rings. Each ring can hold 32 WRBs and is sized    
//       (32*16) = 512 bytes         
typedef struct {
   BE_BE2_ETH_WRB_AMAP wrbs[32];
} SG_PACK BE_ETX_SECONDARY_SHAD_RING_AMAP;
typedef struct { u32 dw[128]; } ETX_SECONDARY_SHAD_RING_AMAP, *PETX_SECONDARY_SHAD_RING_AMAP;


//            Descriptor format for the ethernet low latency rings. The           
// descriptor is followed by one or more BUFFER Descriptors.          
typedef struct {
   BE_BIT num_writes[7];                          // DWORD 0
   BE_BIT rsvd0[9];                               // DWORD 0
   BE_BIT iq_select;                              // DWORD 0
   BE_BIT rsvd1[7];                               // DWORD 0
   BE_BIT ct[2];                                  // DWORD 0
   BE_BIT rsvd2[6];                               // DWORD 0
   BE_BIT func[8];                                // DWORD 1
   BE_BIT num_bd[4];                              // DWORD 1
   BE_BIT inline_data;                            // DWORD 1
   BE_BIT rsvd3[3];                               // DWORD 1
   BE_BIT wrb_index[16];                          // DWORD 1
   BE_BIT completion;                             // DWORD 2
   BE_BIT event;                                  // DWORD 2
   BE_BIT rsvd4[4];                               // DWORD 2
   BE_BIT ip_checksum;                            // DWORD 2
   BE_BIT udp_checksum;                           // DWORD 2
   BE_BIT tcp_checksum;                           // DWORD 2
   BE_BIT rsvd5[7];                               // DWORD 2
   BE_BIT cq_index[16];                           // DWORD 2
   BE_BIT data_len[16];                           // DWORD 3
   BE_BIT rsvd6[16];                              // DWORD 3
} SG_PACK BE_ETX_LOW_LAT_D_AMAP;
typedef struct { u32 dw[4]; } ETX_LOW_LAT_D_AMAP, *PETX_LOW_LAT_D_AMAP;


// iSCSI OOO replay context structure.
typedef struct {
   BE_BIT dcq_rd_ptr[16];                         // DWORD 0
   BE_BIT dcq_wr_ptr[16];                         // DWORD 0
   BE_BIT tx_pidx[11];                            // DWORD 1
   BE_BIT rsvd0[5];                               // DWORD 1
   BE_BIT pd_id[5];                               // DWORD 1
   BE_BIT pd_id_not_valid;                        // DWORD 1
   BE_BIT rsvd1[10];                              // DWORD 1
   BE_BIT rcq_rd_ptr[16];                         // DWORD 2
   BE_BIT dcq_full;                               // DWORD 2
   BE_BIT rsvd2[15];                              // DWORD 2
   BE_BIT rsvd3[32];                              // DWORD 3
   BE_BIT dcq_window_cid[16][8];                  // DWORD 4
   BE_BIT rcq_window_cid[16][8];                  // DWORD 8
   BE_BIT rsvd4[32];                              // DWORD 12
   BE_BIT preposted_buf_cidx[11];                 // DWORD 13
   BE_BIT rsvd5;                                  // DWORD 13
   BE_BIT window_factor[4];                       // DWORD 13
   BE_BIT rx_pdid[5];                             // DWORD 13
   BE_BIT rx_pdid_not_valid;                      // DWORD 13
   BE_BIT rsvd6[10];                              // DWORD 13
   BE_BIT rcq_wr_ptr[16];                         // DWORD 14
   BE_BIT rsvd7[16];                              // DWORD 14
   BE_BIT rsvd8[32];                              // DWORD 15
} SG_PACK BE_ETX_ISCSI_OOO_CONTEXT_AMAP;
typedef struct { u32 dw[16]; } ETX_ISCSI_OOO_CONTEXT_AMAP, *PETX_ISCSI_OOO_CONTEXT_AMAP;


// iSCSI OOO replay CID data structure managed by TOE TX.
typedef struct {
   BE_BIT last[16];                               // DWORD 0
   BE_BIT num_replayed[15];                       // DWORD 0
   BE_BIT hole_id;                                // DWORD 0
} SG_PACK BE_ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_AMAP;
typedef struct { u32 dw[1]; } ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_AMAP, *PISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_AMAP;


// iSCSI OOO replay CID data structure managed by iSCSI RX.
typedef struct {
   BE_BIT num_ooo[16];                            // DWORD 0
   BE_BIT total_num_ooo[16];                      // DWORD 0
   BE_BIT tail[16];                               // DWORD 1
   BE_BIT hole_id;                                // DWORD 1
   BE_BIT rsvd0[15];                              // DWORD 1
} SG_PACK BE_ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_AMAP;
typedef struct { u32 dw[2]; } ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_AMAP, *PISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_AMAP;


// iSCSI OOO replay CID data structure.
typedef struct {
   BE_ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_AMAP iscsi_ooo_replay_cid_toetx_ctx[4];
   BE_ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_AMAP iscsi_ooo_replay_cid_iscsirx_ctx[4];
} SG_PACK BE_ISCSI_OOO_REPLAY_CID_CONTEXT_AMAP;
typedef struct { u32 dw[12]; } ISCSI_OOO_REPLAY_CID_CONTEXT_AMAP, *PISCSI_OOO_REPLAY_CID_CONTEXT_AMAP;


// iSCSI OOO replay CID data structure and replay queues.
typedef struct {
   BE_BIT dcqueue[512][16];                       // DWORD 0
   BE_BIT rcqueue[512][16];                       // DWORD 256
   BE_ISCSI_OOO_REPLAY_CID_CONTEXT_AMAP iscsi_ooo_replay_cid_ctx[128];
} SG_PACK BE_ISCSI_OOO_REPLAY_CID_CQ_CONTEXT_AMAP;
typedef struct { u32 dw[2048]; } ISCSI_OOO_REPLAY_CID_CQ_CONTEXT_AMAP, *PISCSI_OOO_REPLAY_CID_CQ_CONTEXT_AMAP;


//            Excess QOS counters kept by tpost.          
typedef struct {
   BE_BIT port0_excess_bytes[32];                 // DWORD 0
   BE_BIT port1_excess_bytes[32];                 // DWORD 1
   BE_BIT timer_phase;                            // DWORD 2
   BE_BIT rsvd0[31];                              // DWORD 2
   BE_BIT rsvd1[32];                              // DWORD 3
   BE_BIT port0_ct0_bytes[32];                    // DWORD 4
   BE_BIT port1_ct0_bytes[32];                    // DWORD 5
   BE_BIT port0_ct1_bytes[32];                    // DWORD 6
   BE_BIT port1_ct1_bytes[32];                    // DWORD 7
} SG_PACK BE_EXCESS_QOS_COUNTERS_AMAP;
typedef struct { u32 dw[8]; } EXCESS_QOS_COUNTERS_AMAP, *PEXCESS_QOS_COUNTERS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __toe_context_amap_h__

