/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __txp_amap_h__
#define __txp_amap_h__
#include "setypes.h"
#include "pq.h"
#include "gencommon.h"
#include "hwdbg_reg.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- ETH_TX_COMPL_STATUS_ENUM ---
// Status codes contained in Ethernet TX completion descriptors.
#define ETH_COMP_VALID                  (0)       
#define ETH_COMP_ERROR                  (1)       
#define ETH_COMP_INVALID                (15)      

typedef enum {
   ENUM_ETH_COMP_VALID = 0x0UL,
   ENUM_ETH_COMP_ERROR = 0x1UL,
   ENUM_ETH_COMP_INVALID = 0xfUL
} ETH_TX_COMPL_STATUS_ENUM;

//  Each TXP stat is 64-bits, with the least significant DWORD first. 
typedef struct {
   BE_BIT lsd[32];                                // DWORD 0
   BE_BIT msd[32];                                // DWORD 1
} SG_PACK BE_BE2_TXP_STAT_AMAP;
typedef struct { u32 dw[2]; } BE2_TXP_STAT_AMAP, *PBE2_TXP_STAT_AMAP;


//  Each chute contains port 0 and 1 stats. 
typedef struct {
   BE_BE2_TXP_STAT_AMAP port[2];
} SG_PACK BE_BE2_TXP_CHUTE_STAT_AMAP;
typedef struct { u32 dw[4]; } BE2_TXP_CHUTE_STAT_AMAP, *PBE2_TXP_CHUTE_STAT_AMAP;


//  Each stat is recorded for all transmit chutes. 
typedef struct {
   BE_BE2_TXP_CHUTE_STAT_AMAP chute[3];
} SG_PACK BE_BE2_TXP_STAT_SET_AMAP;
typedef struct { u32 dw[12]; } BE2_TXP_STAT_SET_AMAP, *PBE2_TXP_STAT_SET_AMAP;


//              The stats read using the [link]TXP_STAT_INDEX_CSR[/link] and             
// [link]TXP_STAT_VALUE_CSR[/link].  The 32-bit offset in the struct             matches
// the index in the [link]TX_STAT_INDICES_ENUM[/link] enum.                     
typedef struct {
   BE_BE2_TXP_STAT_SET_AMAP tx_bytes;
   BE_BE2_TXP_STAT_SET_AMAP tx_packets;
   BE_BE2_TXP_STAT_SET_AMAP tx_rexmit_bytes;
   BE_BE2_TXP_STAT_SET_AMAP tx_rexmit_packets;
} SG_PACK BE_BE2_TXP_STATS_AMAP;
typedef struct { u32 dw[48]; } BE2_TXP_STATS_AMAP, *PBE2_TXP_STATS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __txp_amap_h__

