/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __asyncmesg_enum_h__
#define __asyncmesg_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "nativedefs_enum.h"
#include "ioctl_common_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- ASYNC_EVENT_CODES ---
#define ASYNC_EVENT_CODE_LINK_STATE     (1)       
#define ASYNC_EVENT_CODE_FCOE_FIP       (2)       
#define ASYNC_EVENT_CODE_DCBX           (3)       
#define ASYNC_EVENT_CODE_ISCSI          (4)       
#define ASYNC_EVENT_CODE_GRP_5          (5)       
#define ASYNC_EVENT_CODE_DEBUG          (6)       

typedef enum {
   ENUM_ASYNC_EVENT_CODE_LINK_STATE = 0x1UL,
   ENUM_ASYNC_EVENT_CODE_FCOE_FIP = 0x2UL,
   ENUM_ASYNC_EVENT_CODE_DCBX = 0x3UL,
   ENUM_ASYNC_EVENT_CODE_ISCSI = 0x4UL,
   ENUM_ASYNC_EVENT_CODE_GRP_5 = 0x5UL,
   ENUM_ASYNC_EVENT_CODE_DEBUG = 0x6UL
} ASYNC_EVENT_CODES;

// --- ASYNC_LINK_STATES ---
#define ASYNC_EVENT_LINK_DOWN           (0)       // Link Down on a port 
#define ASYNC_EVENT_LINK_UP             (1)       // Link Up on a port 
#define ASYNC_EVENT_LOGICAL             (2)       // This Link up/down event is being
                                                  // reported for a logical port, based on
                                                  // DBCX TLV received from a (DCBX
                                                  // enabled) switch connected to the
                                                  // physical port associated with this
                                                  // PCI function

typedef enum {
   ENUM_ASYNC_EVENT_LINK_DOWN = 0x0UL,
   ENUM_ASYNC_EVENT_LINK_UP = 0x1UL,
   ENUM_ASYNC_EVENT_LOGICAL = 0x2UL
} ASYNC_LINK_STATES;

// --- LINK_EVENT_REASON ---
#define ASYNC_EVENT_REASON_NONE         (0)       
#define ASYNC_EVENT_REASON_DCC          (1)       
#define ASYNC_EVENT_REASON_FIP          (2)       
#define ASYNC_EVENT_REASON_VNIC         (3)       
#define ASYNC_EVENT_REASON_PAUSE_FLOOD  (4)       

typedef enum {
   ENUM_ASYNC_EVENT_REASON_NONE = 0x0UL,
   ENUM_ASYNC_EVENT_REASON_DCC = 0x1UL,
   ENUM_ASYNC_EVENT_REASON_FIP = 0x2UL,
   ENUM_ASYNC_EVENT_REASON_VNIC = 0x3UL,
   ENUM_ASYNC_EVENT_REASON_PAUSE_FLOOD = 0x4UL
} LINK_EVENT_REASON;

// --- ASYNC_GRP_5_EVENTS ---
#define ASYNC_GRP_5_EVENT_QOS_SPEED     (1)       // Event to set the QoS speed 
#define ASYNC_GRP_5_EVENT_COS_PRIORITY  (2)       // Event to set the CoS priority 
#define ASYNC_GRP_5_EVENT_PVID_STATE    (3)       // Event to disable/enable PVID tag 
#define ASYNC_GRP_5_EVENT_PRIORITY_CLASS_QUEUE_MAP (4) // Event to inform driver of
                                                       // class_queue to priority map 

typedef enum {
   ENUM_ASYNC_GRP_5_EVENT_QOS_SPEED = 0x1UL,
   ENUM_ASYNC_GRP_5_EVENT_COS_PRIORITY = 0x2UL,
   ENUM_ASYNC_GRP_5_EVENT_PVID_STATE = 0x3UL,
   ENUM_ASYNC_GRP_5_EVENT_PRIORITY_CLASS_QUEUE_MAP = 0x4UL
} ASYNC_GRP_5_EVENTS;

// --- ASYNC_DEBUG_EVENTTYPE ---
// Enum for event_type when event_code=ASYNC_EVENT_CODE_DEBUG.
#define ASYNC_DEBUG_EVENT_TYPE_QNQ      (1)       // Event to send the driver the outter
                                                  // VLAN tag. 

typedef enum {
   ENUM_ASYNC_DEBUG_EVENT_TYPE_QNQ = 0x1UL
} ASYNC_DEBUG_EVENTTYPE;

// --- ASYNC_ISCSI_EVENTS ---
#define ASYNC_ISCSI_EVENT_NEW_TARGET_DISCOVERED (4) // iSCSI discovery services found a
                                                    // new Target for this Initiator
#define ASYNC_ISCSI_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED (5) // The firmware's
                                                               // background task (re)
                                                               // established a session
                                                               // for this initiator. In
                                                               // VM mode, this is the
                                                               // only mode in which new
                                                               // targets/LUNs can be
                                                               // added to a guest domain
#define ASYNC_ISCSI_EVENT_NEW_TCP_CONNECTION_ESTABLISHED (7) 
#define ASYNC_ISCSI_EVENT_NEW_TCP_CONNECTION_ACCEPTED (16) // Target mode ONLY - an
                                                           // initiator has opened a
                                                           // connection on the listen
                                                           // port 
#define ASYNC_ISCSI_EVENT_IPV4_STATELESS_OPERATION_COMPLETE (32) // Stateless operation on
                                                                 // one of the IPv4 iSCSI
                                                                 // Interfaces has
                                                                 // completed 
#define ASYNC_ISCSI_EVENT_IPV6_STATELESS_OPERATION_COMPLETE (64) // Stateless operation on
                                                                 // one of the IPv6 iSCSI
                                                                 // Interfaces has
                                                                 // completed 
#define ASYNC_ISCSI_EVENT_ISNS_SERVER_DHCP_OPERATION_COMPLETE (128) // DHCP to get iSNS
                                                                    // servers operation
                                                                    // completed. 
#define ASYNC_ISCSI_EVENT_DHCP_LEASE_FAILED_RENEW (129) // DHCP Client failed to renew the
                                                        // lease
#define ASYNC_ISCSI_EVENT_IPV6_DEFAULT_ROUTER_CHANGED (130) // IPv6 default router changed
                                                            // event
#define ASYNC_ISCSI_EVENT_IPV6_ICMP_ERROR_PACKET_RECVD (131) // IPv6 ICMP error packet is
                                                             // recieved
#define ASYNC_ISCSI_EVENT_IPV6_AUTONOMOUS_PREFIX_IGNORED (132) // IPv6 Autonomous prefix
                                                               // ignored
#define ASYNC_ISCSI_EVENT_IPV6_ND_LOCAL_PREFIX_IGNORED (133) // IPv6 ND Local Prefix
                                                             // ignored
#define ASYNC_ISCSI_EVENT_IPV6_LINK_MTU_CHANGED (134) // IPv6 Link MTU Change detected
#define ASYNC_ISCSI_EVENT_IPV6_IP_ADDRESS_EXPIRY (135) // An IPv6 IP Address lease time
                                                       // has expired
#define ASYNC_ISCSI_EVENT_INITIATOR_START_RECOVERY (136) // Driver to start session level
                                                         // recovery on this function 

typedef enum {
   ENUM_ASYNC_ISCSI_EVENT_NEW_TARGET_DISCOVERED = 0x4UL,
   ENUM_ASYNC_ISCSI_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED = 0x5UL,
   ENUM_ASYNC_ISCSI_EVENT_NEW_TCP_CONNECTION_ESTABLISHED = 0x7UL,
   ENUM_ASYNC_ISCSI_EVENT_NEW_TCP_CONNECTION_ACCEPTED = 0x10UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV4_STATELESS_OPERATION_COMPLETE = 0x20UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_STATELESS_OPERATION_COMPLETE = 0x40UL,
   ENUM_ASYNC_ISCSI_EVENT_ISNS_SERVER_DHCP_OPERATION_COMPLETE = 0x80UL,
   ENUM_ASYNC_ISCSI_EVENT_DHCP_LEASE_FAILED_RENEW = 0x81UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_DEFAULT_ROUTER_CHANGED = 0x82UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_ICMP_ERROR_PACKET_RECVD = 0x83UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_AUTONOMOUS_PREFIX_IGNORED = 0x84UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_ND_LOCAL_PREFIX_IGNORED = 0x85UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_LINK_MTU_CHANGED = 0x86UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_IP_ADDRESS_EXPIRY = 0x87UL,
   ENUM_ASYNC_ISCSI_EVENT_INITIATOR_START_RECOVERY = 0x88UL
} ASYNC_ISCSI_EVENTS;

// --- ASYNC_DCBX_EVENTS ---
#define ASYNC_DCBX_EVENT_RX_TTL_EXPIRED (1)       // The TTL in DCBX LLDP TLV expired

typedef enum {
   ENUM_ASYNC_DCBX_EVENT_RX_TTL_EXPIRED = 0x1UL
} ASYNC_DCBX_EVENTS;

// --- ASYNC_FCOE_EVENTS ---
#define ASYNC_FCOE_EVENT_NEW_FCF_DISCOVERED (1)   // An advertisement was received from an
                                                  // FCF which is not present in the table
                                                  // maintained by the ARM f/w 
#define ASYNC_FCOE_EVENT_FCF_TABLE_FULL (2)       // The FCF table has MAX_FCF_ENTRIES and
                                                  // a new FCF has been discovered. Issue
                                                  // one or more IOCTL_FCOE_DELETE_FCF
                                                  // IOCTL to make way for the new FCF
#define ASYNC_FCOE_EVENT_FCF_DEAD       (3)       // An FCF heart beat stopped 
#define ASYNC_FCOE_EVENT_CLEAR_VLINKS_RECVD (4)   // FCF has sent us Clear Virtual Links
                                                  // for a Particular VPI 
#define ASYNC_FCOE_EVENT_FCF_PARAM_MODIFIED (5)   // One or more of FCF Parameters were
                                                  // modified in an FCF Adv. 

typedef enum {
   ENUM_ASYNC_FCOE_EVENT_NEW_FCF_DISCOVERED = 0x1UL,
   ENUM_ASYNC_FCOE_EVENT_FCF_TABLE_FULL = 0x2UL,
   ENUM_ASYNC_FCOE_EVENT_FCF_DEAD = 0x3UL,
   ENUM_ASYNC_FCOE_EVENT_CLEAR_VLINKS_RECVD = 0x4UL,
   ENUM_ASYNC_FCOE_EVENT_FCF_PARAM_MODIFIED = 0x5UL
} ASYNC_FCOE_EVENTS;

#endif // __asyncmesg_enum_h__

