/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ep_enum_h__
#define __ep_enum_h__
#include "setypes.h"
#include "defines_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- EP_QCTRL_SRC_ENUM ---
#define MEM0_SRC                        (0)       // Memory port 0 Interface
#define MEM1_SRC                        (1)       // Memory port 1 Interface
#define MEM2_SRC                        (2)       // Memory port 2 Interface

typedef enum {
   ENUM_MEM0_SRC = 0x0UL,
   ENUM_MEM1_SRC = 0x1UL,
   ENUM_MEM2_SRC = 0x2UL
} EP_QCTRL_SRC_ENUM;

// --- EP_QCTRL_LB_ENUM ---
#define NO_SEARCH                       (0)       // Do not search for Last Bit, single
                                                  // entity descriptors
#define NO_REFETCH                      (1)       // Do not refetch memory for multiple
                                                  // descriptors
#define REFETCH_1                       (2)       // Refetch memory location 1 for
                                                  // multiple descriptors
#define REFETCH_BOTH                    (3)       // Refetch memory location 1 and 2 for
                                                  // multiple descriptors
#define REFETCH_2                       (6)       // Refetch memory location 2 for
                                                  // multiple descriptors

typedef enum {
   ENUM_NO_SEARCH = 0x0UL,
   ENUM_NO_REFETCH = 0x1UL,
   ENUM_REFETCH_1 = 0x2UL,
   ENUM_REFETCH_BOTH = 0x3UL,
   ENUM_REFETCH_2 = 0x6UL
} EP_QCTRL_LB_ENUM;

// --- EP_DEBUG_BANK_STATUS_ENUM ---
#define BANK_IDLE                       (1)       // Idle, waiting to load
#define BANK_LOADING                    (2)       // Loading
#define BANK_WAIT_EP                    (4)       // Waiting for processor to free up
#define BANK_BUSY                       (8)       // Busy, being processed by firmware
#define BANK_UNLOADING                  (16)      // Unloading

typedef enum {
   ENUM_BANK_IDLE = 0x1UL,
   ENUM_BANK_LOADING = 0x2UL,
   ENUM_BANK_WAIT_EP = 0x4UL,
   ENUM_BANK_BUSY = 0x8UL,
   ENUM_BANK_UNLOADING = 0x10UL
} EP_DEBUG_BANK_STATUS_ENUM;

// --- EP_BANK_TYPE_ENUM ---
#define CTX_BANK                        (0)       // Context Bank
#define DESC_BANK                       (1)       // Data/descriptor Bank

typedef enum {
   ENUM_CTX_BANK = 0x0UL,
   ENUM_DESC_BANK = 0x1UL
} EP_BANK_TYPE_ENUM;

// --- EP_BANK_SELECT_ENUM ---
#define BANK_Y                          (0)       // Y Bank
#define BANK_X                          (1)       // X Bank

typedef enum {
   ENUM_BANK_Y = 0x0UL,
   ENUM_BANK_X = 0x1UL
} EP_BANK_SELECT_ENUM;

// --- TXULP_OQ_CREDIT_VALUES ---
// Documented below are the suggested values to be used for programming the TxULP output
// queue credit grant CSRs. 
#define TXULP_EP_QCREDITA_CSR_OQ0       (1)       // Credits for OQ0 
#define TXULP_EP_QCREDITA_CSR_OQ1       (0)       // Credits for OQ1 
#define TXULP_EP_QCREDITA_CSR_OQ2       (8)       // Credits for OQ2 
#define TXULP_EP_QCREDITA_CSR_OQ3       (0)       // Credits for OQ3 
#define TXULP_EP_QCREDITA_CSR_OQ4       (0)       // Credits for OQ4 
#define TXULP_EP_QCREDITA_CSR_OQ5       (0)       // Credits for OQ5 
#define TXULP_EP_QCREDITA_CSR_OQ6       (2)       // Credits for OQ6 
#define TXULP_EP_QCREDITA_CSR_OQ7       (2)       // Credits for OQ7 
#define TXULP_EP_QCREDITA_CSR_OQ8       (8)       // Credits for OQ8 
#define TXULP_EP_QCREDITA_CSR_OQ9       (8)       // Credits for OQ9 
#define TXULP_EP_QCREDITA_CSR_OQ10      (4)       // Credits for OQ10 
#define TXULP_EP_QCREDITA_CSR_OQ11      (4)       // Credits for OQ11 
#define TXULP_EP_QCREDITA_CSR_OQ12      (4)       // Credits for OQ12 

typedef enum {
   ENUM_TXULP_EP_QCREDITA_CSR_OQ0 = 0x1UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ1 = 0x0UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ2 = 0x8UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ3 = 0x0UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ4 = 0x0UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ5 = 0x0UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ6 = 0x2UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ7 = 0x2UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ8 = 0x8UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ9 = 0x8UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ10 = 0x4UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ11 = 0x4UL,
   ENUM_TXULP_EP_QCREDITA_CSR_OQ12 = 0x4UL
} TXULP_OQ_CREDIT_VALUES;

// --- RXULP_OQ_CREDIT_VALUES ---
// Documented below are the suggested values to be used for programming the RxULP output
// queue credit grant CSRs. 
#define RXULP_EP_QCREDITA_CSR_OQ0       (1)       // Credits for OQ0 
#define RXULP_EP_QCREDITA_CSR_OQ1       (4)       // Credits for OQ1 
#define RXULP_EP_QCREDITA_CSR_OQ2       (4)       // Credits for OQ2 
#define RXULP_EP_QCREDITA_CSR_OQ3       (0)       // Credits for OQ3 
#define RXULP_EP_QCREDITA_CSR_OQ4       (4)       // Credits for OQ4 
#define RXULP_EP_QCREDITA_CSR_OQ5       (16)      // Credits for OQ5 
#define RXULP_EP_QCREDITA_CSR_OQ6       (4)       // Credits for OQ6 
#define RXULP_EP_QCREDITA_CSR_OQ7       (4)       // Credits for OQ7 
#define RXULP_EP_QCREDITA_CSR_OQ8       (0)       // Credits for OQ8 
#define RXULP_EP_QCREDITA_CSR_OQ9       (0)       // Credits for OQ9 
#define RXULP_EP_QCREDITA_CSR_OQ10      (1)       // Credits for OQ10 
#define RXULP_EP_QCREDITA_CSR_OQ11      (4)       // Credits for OQ11 
#define RXULP_EP_QCREDITA_CSR_OQ12      (4)       // Credits for OQ12 

typedef enum {
   ENUM_RXULP_EP_QCREDITA_CSR_OQ0 = 0x1UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ1 = 0x4UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ2 = 0x4UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ3 = 0x0UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ4 = 0x4UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ5 = 0x10UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ6 = 0x4UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ7 = 0x4UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ8 = 0x0UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ9 = 0x0UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ10 = 0x1UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ11 = 0x4UL,
   ENUM_RXULP_EP_QCREDITA_CSR_OQ12 = 0x4UL
} RXULP_OQ_CREDIT_VALUES;

// --- TPOST_OQ_CREDIT_VALUES ---
// Documented below are the suggested values to be used for programming the TPost output
// queue credit grant CSRs. 
#define TPOST_EP_QCREDITA_CSR_OQ0       (1)       // Credits for OQ0 
#define TPOST_EP_QCREDITA_CSR_OQ1       (8)       // Credits for OQ1 
#define TPOST_EP_QCREDITA_CSR_OQ2       (8)       // Credits for OQ2 
#define TPOST_EP_QCREDITA_CSR_OQ3       (8)       // Credits for OQ3 
#define TPOST_EP_QCREDITA_CSR_OQ4       (8)       // Credits for OQ4 
#define TPOST_EP_QCREDITA_CSR_OQ5       (8)       // Credits for OQ5 
#define TPOST_EP_QCREDITA_CSR_OQ6       (8)       // Credits for OQ6 
#define TPOST_EP_QCREDITA_CSR_OQ7       (8)       // Credits for OQ7 
#define TPOST_EP_QCREDITA_CSR_OQ8       (4)       // Credits for OQ8 
#define TPOST_EP_QCREDITA_CSR_OQ9       (0)       // Credits for OQ9 
#define TPOST_EP_QCREDITA_CSR_OQ10      (0)       // Credits for OQ10 
#define TPOST_EP_QCREDITA_CSR_OQ11      (2)       // Credits for OQ11 
#define TPOST_EP_QCREDITA_CSR_OQ12      (2)       // Credits for OQ12 

typedef enum {
   ENUM_TPOST_EP_QCREDITA_CSR_OQ0 = 0x1UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ1 = 0x8UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ2 = 0x8UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ3 = 0x8UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ4 = 0x8UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ5 = 0x8UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ6 = 0x8UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ7 = 0x8UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ8 = 0x4UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ9 = 0x0UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ10 = 0x0UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ11 = 0x2UL,
   ENUM_TPOST_EP_QCREDITA_CSR_OQ12 = 0x2UL
} TPOST_OQ_CREDIT_VALUES;

// --- TPRE_OQ_CREDIT_VALUES ---
// Documented below are the suggested values to be used for programming the TPre output
// queue credit grant CSRs. 
#define TPRE_EP_QCREDITA_CSR_OQ0        (1)       // Credits for OQ0 
#define TPRE_EP_QCREDITA_CSR_OQ1        (4)       // Credits for OQ1 
#define TPRE_EP_QCREDITA_CSR_OQ2        (0)       // Credits for OQ2 
#define TPRE_EP_QCREDITA_CSR_OQ3        (0)       // Credits for OQ3 
#define TPRE_EP_QCREDITA_CSR_OQ4        (2)       // Credits for OQ4 
#define TPRE_EP_QCREDITA_CSR_OQ5        (9)       // Credits for OQ5 
#define TPRE_EP_QCREDITA_CSR_OQ6        (4)       // Credits for OQ6 
#define TPRE_EP_QCREDITA_CSR_OQ7        (0)       // Credits for OQ7 
#define TPRE_EP_QCREDITA_CSR_OQ8        (0)       // Credits for OQ8 
#define TPRE_EP_QCREDITA_CSR_OQ9        (0)       // Credits for OQ9 
#define TPRE_EP_QCREDITA_CSR_OQ10       (0)       // Credits for OQ10 
#define TPRE_EP_QCREDITA_CSR_OQ11       (8)       // Credits for OQ11 
#define TPRE_EP_QCREDITA_CSR_OQ12       (8)       // Credits for OQ12 

typedef enum {
   ENUM_TPRE_EP_QCREDITA_CSR_OQ0 = 0x1UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ1 = 0x4UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ2 = 0x0UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ3 = 0x0UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ4 = 0x2UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ5 = 0x9UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ6 = 0x4UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ7 = 0x0UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ8 = 0x0UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ9 = 0x0UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ10 = 0x0UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ11 = 0x8UL,
   ENUM_TPRE_EP_QCREDITA_CSR_OQ12 = 0x8UL
} TPRE_OQ_CREDIT_VALUES;

// --- MPU_OQ_CREDIT_VALUES ---
// Documented below are the suggested values to be used for programming the MPU output
// queue credit grant CSRs. 
#define MPU_EP_QCREDITA_CSR_OQ0         (1)       // Credits for OQ0 
#define MPU_EP_QCREDITA_CSR_OQ1         (4)       // Credits for OQ1 
#define MPU_EP_QCREDITA_CSR_OQ2         (4)       // Credits for OQ2 
#define MPU_EP_QCREDITA_CSR_OQ3         (4)       // Credits for OQ3 
#define MPU_EP_QCREDITA_CSR_OQ4         (4)       // Credits for OQ4 
#define MPU_EP_QCREDITA_CSR_OQ5         (0)       // Credits for OQ5 
#define MPU_EP_QCREDITA_CSR_OQ6         (4)       // Credits for OQ6 
#define MPU_EP_QCREDITA_CSR_OQ7         (0)       // Credits for OQ7 
#define MPU_EP_QCREDITA_CSR_OQ8         (0)       // Credits for OQ8 
#define MPU_EP_QCREDITA_CSR_OQ9         (0)       // Credits for OQ9 
#define MPU_EP_QCREDITA_CSR_OQ10        (1)       // Credits for OQ10 
#define MPU_EP_QCREDITA_CSR_OQ11        (0)       // Credits for OQ11 
#define MPU_EP_QCREDITA_CSR_OQ12        (4)       // Credits for OQ12 

typedef enum {
   ENUM_MPU_EP_QCREDITA_CSR_OQ0 = 0x1UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ1 = 0x4UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ2 = 0x4UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ3 = 0x4UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ4 = 0x4UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ5 = 0x0UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ6 = 0x4UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ7 = 0x0UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ8 = 0x0UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ9 = 0x0UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ10 = 0x1UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ11 = 0x0UL,
   ENUM_MPU_EP_QCREDITA_CSR_OQ12 = 0x4UL
} MPU_OQ_CREDIT_VALUES;

#endif // __ep_enum_h__

