/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ep_queue_enum_h__
#define __ep_queue_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "headers_enum.h"
#include "descriptors_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- EP_UNLOAD_ORDER_SEQ ---
#define EP_ORDER_EOM                    (1)       // Indicates end of order 
#define EP_ORDER_BOM                    (2)       // Indicates beginning of order 

typedef enum {
   ENUM_EP_ORDER_EOM = 0x1UL,
   ENUM_EP_ORDER_BOM = 0x2UL
} EP_UNLOAD_ORDER_SEQ;

// --- RXULP_IQ_ENUM ---
#define RXULP_IQ_IPC                    (0)       // This is the IPC input queue. Common
                                                  // to all processors
#define RXULP_IQ_WDMA                   (1)       // This is the WDMA response queue
#define RXULP_IQ_UC0                    (2)       // This is channel 0 of the Unified
                                                  // Cache response queue
#define RXULP_IQ_UC1                    (3)       // This is channel 1 of the Unified
                                                  // cache response queue
#define RXULP_IQ_TPRE                   (4)       // This Input queue is fed by the TPRE 
#define RXULP_IQ_CXN_SCHED              (5)       // This Input queue is fed by the
                                                  // Connection Selector 
#define RXULP_IQ_SIQ0                   (6)       // This is the self initiate queue
                                                  // linked to RXULP_OQ_SIQ0
#define RXULP_IQ_SIQ1                   (7)       // This is the self initiate queue
                                                  // linked to RXULP_OQ_SIQ1

typedef enum {
   ENUM_RXULP_IQ_IPC = 0x0UL,
   ENUM_RXULP_IQ_WDMA = 0x1UL,
   ENUM_RXULP_IQ_UC0 = 0x2UL,
   ENUM_RXULP_IQ_UC1 = 0x3UL,
   ENUM_RXULP_IQ_TPRE = 0x4UL,
   ENUM_RXULP_IQ_CXN_SCHED = 0x5UL,
   ENUM_RXULP_IQ_SIQ0 = 0x6UL,
   ENUM_RXULP_IQ_SIQ1 = 0x7UL
} RXULP_IQ_ENUM;

// --- RXULP_OQ_ENUM ---
#define RXULP_OQ_IPC                    (0)       // Output Queue to IPC
#define RXULP_OQ_WRDMA                  (1)       // Output Queue to Write DMA
#define RXULP_OQ_UC_REQ                 (2)       // Output Queue to UC Requestor
#define RXULP_OQ_CEV_REQ                (4)       // Output Queue to CEV
#define RXULP_OQ_WCON                   (5)       // Output Queue to WDMA Consolidator
                                                  // (WCON)
#define RXULP_OQ_CHIP_REQ               (6)       // Output Queue to corresponding TxULP
                                                  // for chip request
#define RXULP_OQ_CROSS_CHUTE_CHIP_REQ   (7)       // Output Queue to cross chute TxULP for
                                                  // chip request
#define RXULP_OQ_GRANT_CTRL             (10)      // Output queue to connection scheduler
#define RXULP_OQ_SIQ0                   (11)      // Self inititated output queue
#define RXULP_OQ_SIQ1                   (12)      // Self inititated output queue
#define RXULP_OQ_CTX                    (13)      // Output Queue to Context Writeback
#define RXULP_OQ_RXPB                   (15)      // Reserved

typedef enum {
   ENUM_RXULP_OQ_IPC = 0x0UL,
   ENUM_RXULP_OQ_WRDMA = 0x1UL,
   ENUM_RXULP_OQ_UC_REQ = 0x2UL,
   ENUM_RXULP_OQ_CEV_REQ = 0x4UL,
   ENUM_RXULP_OQ_WCON = 0x5UL,
   ENUM_RXULP_OQ_CHIP_REQ = 0x6UL,
   ENUM_RXULP_OQ_CROSS_CHUTE_CHIP_REQ = 0x7UL,
   ENUM_RXULP_OQ_GRANT_CTRL = 0xaUL,
   ENUM_RXULP_OQ_SIQ0 = 0xbUL,
   ENUM_RXULP_OQ_SIQ1 = 0xcUL,
   ENUM_RXULP_OQ_CTX = 0xdUL,
   ENUM_RXULP_OQ_RXPB = 0xfUL
} RXULP_OQ_ENUM;

// --- TPOST_INPUT_QUEUES_ENUM ---
#define TPOST_IQ_IPC                    (0)       // IPC Input Queue
#define TPOST_IQ_PSEL                   (1)       // Input queue from protocol selector
#define TPOST_IQ_DMARESP                (2)       // DMA Response Queue ID
#define TPOST_IQ_PSEL2                  (3)       // Secondary Input queue from protocol
                                                  // selector
#define TPOST_IQ_TXPP                   (5)       // TXPP Queue ID
#define TPOST_IQ_SIQ1                   (6)       // Self Initiate Queue 1
#define TPOST_IQ_SIQ2                   (7)       // Self Initiate Queue 2

typedef enum {
   ENUM_TPOST_IQ_IPC = 0x0UL,
   ENUM_TPOST_IQ_PSEL = 0x1UL,
   ENUM_TPOST_IQ_DMARESP = 0x2UL,
   ENUM_TPOST_IQ_PSEL2 = 0x3UL,
   ENUM_TPOST_IQ_TXPP = 0x5UL,
   ENUM_TPOST_IQ_SIQ1 = 0x6UL,
   ENUM_TPOST_IQ_SIQ2 = 0x7UL
} TPOST_INPUT_QUEUES_ENUM;

// --- TPOST_TASK_ENUM ---
#define TPOST_TASK_IPC                  (0)       // IPC task id
#define TPOST_TASK_ULP0                 (1)       // Task ID for data frames from ULP0.
                                                  // The flags field of the QTR will
                                                  // contain the output port. 
#define TPOST_TASK_TMR                  (2)       // Task ID for timer events
#define TPOST_TASK_ULP1                 (3)       // Task ID for data frames from ULP1.
                                                  // The flags field of the QTR will
                                                  // contain the output port. 
#define TPOST_TASK_ACK                  (4)       // Task ID for ACK frames
#define TPOST_TASK_ETHTOE               (5)       // Task ID for data frames from
                                                  // Ethernet/TOE ULP. The flags field of
                                                  // the QTR will contain the output port.
#define TPOST_TASK_TXPP                 (6)       // TXPP Task ID
#define TPOST_TASK_PSEL2                (7)       // Task ID for descriptors coming in
                                                  // through the TPOST CSR interface. The
                                                  // flags field of the QTR will contain
                                                  // the output port 
#define TPOST_TASK_SIQ1                 (8)       // Task ID for Self Initiate Queue 1
#define TPOST_TASK_SIQ2                 (9)       // Task ID for Self Initiate Queue 2
#define TPOST_TASK_DMARESP              (10)      // DMA Response Task ID

typedef enum {
   ENUM_TPOST_TASK_IPC = 0x0UL,
   ENUM_TPOST_TASK_ULP0 = 0x1UL,
   ENUM_TPOST_TASK_TMR = 0x2UL,
   ENUM_TPOST_TASK_ULP1 = 0x3UL,
   ENUM_TPOST_TASK_ACK = 0x4UL,
   ENUM_TPOST_TASK_ETHTOE = 0x5UL,
   ENUM_TPOST_TASK_TXPP = 0x6UL,
   ENUM_TPOST_TASK_PSEL2 = 0x7UL,
   ENUM_TPOST_TASK_SIQ1 = 0x8UL,
   ENUM_TPOST_TASK_SIQ2 = 0x9UL,
   ENUM_TPOST_TASK_DMARESP = 0xaUL
} TPOST_TASK_ENUM;

// --- TPOST_OT_ENUM ---
#define TPOST_OT_IPC                    (0)       // The IPC output queue is used to queue
                                                  // an IPC to a set of target processors
                                                  // in the chip. The IPC Descriptor
                                                  // IPC_HEADER_D is queued using the
                                                  // unload order gather list. 
#define TPOST_OT_TXP_ULP0_0             (1)       // Used to send a descriptor TX_D that
                                                  // originated from ULP0 port0 to the TX
                                                  // packet processor. 
#define TPOST_OT_TXP_ULP0_1             (2)       // Used to send a descriptor TX_D that
                                                  // originated from ULP0 port1 to the TX
                                                  // packet processor. 
#define TPOST_OT_TXP_ULP1_0             (3)       // Used to send a descriptor TX_D that
                                                  // originated from ULP1 port0 to the TX
                                                  // packet processor. 
#define TPOST_OT_TXP_ULP1_1             (4)       // Used to send a descriptor TX_D that
                                                  // originated from ULP1 port1 to the TX
                                                  // packet processor. 
#define TPOST_OT_TXP_ETHTOE_0           (5)       // Used to send a descriptor TX_D that
                                                  // originated from ethernet/TOE port0 to
                                                  // the TX packet processor. 
#define TPOST_OT_TXP_ETHTOE_1           (6)       // Used to send a descriptor TX_D that
                                                  // originated from ethernet/TOE port1 to
                                                  // the TX packet processor. 
#define TPOST_OT_GRANT_CTRL             (7)       // Used to serialize the process of
                                                  // stimulating the TXULP Processor using
                                                  // the descriptor GRANT_CTRL_DESC. 
#define TPOST_OT_WRDMA                  (8)       // Used to post write DMA requests. This
                                                  // queue is used to write transmit
                                                  // journals to host memory. 
#define TPOST_OT_SIQ1                   (11)      // Used to post requests to Self
                                                  // Initiate Queue 1 
#define TPOST_OT_SIQ2                   (12)      // Used to post requests to Self
                                                  // Initiate Queue 2 
#define TPOST_OT_CTX_WB                 (13)      // Used to post context writebacks. 
#define TPOST_OT_TXPB_WB                (14)      // Used to write Tx pbufs 

typedef enum {
   ENUM_TPOST_OT_IPC = 0x0UL,
   ENUM_TPOST_OT_TXP_ULP0_0 = 0x1UL,
   ENUM_TPOST_OT_TXP_ULP0_1 = 0x2UL,
   ENUM_TPOST_OT_TXP_ULP1_0 = 0x3UL,
   ENUM_TPOST_OT_TXP_ULP1_1 = 0x4UL,
   ENUM_TPOST_OT_TXP_ETHTOE_0 = 0x5UL,
   ENUM_TPOST_OT_TXP_ETHTOE_1 = 0x6UL,
   ENUM_TPOST_OT_GRANT_CTRL = 0x7UL,
   ENUM_TPOST_OT_WRDMA = 0x8UL,
   ENUM_TPOST_OT_SIQ1 = 0xbUL,
   ENUM_TPOST_OT_SIQ2 = 0xcUL,
   ENUM_TPOST_OT_CTX_WB = 0xdUL,
   ENUM_TPOST_OT_TXPB_WB = 0xeUL
} TPOST_OT_ENUM;

// --- TPRE_CLASS_PREDICATES_ENUM ---
#define ZERO_PKT_LEN                    (0)       
#define P_FLAG_FIN                      (1)       
#define P_FLAG_SYN                      (2)       
#define P_FLAG_RST                      (3)       
#define P_FLAG_PSH                      (4)       
#define P_FLAG_ACK                      (5)       
#define P_FLAG_URG                      (6)       
#define T_FLAG_OOO                      (7)       
#define ZERO_RX_WIN                     (8)       
#define ZERO_SND_WIN                    (9)       
#define T_TX_CLOSED                     (10)      
#define T_RX_CLOSED                     (11)      
#define T_TX_ESTABLISHED                (12)      
#define T_RX_ESTABLISHED                (13)      
#define TS_NOT_FOUND                    (14)      
#define MAX_HDR_LEN                     (15)      
#define EQ_TCP_HDR_MIN                  (16)      
#define GE_ACK_SND_UNAmMAX_SND_WIN      (17)      
#define EQ_MPACRC_MAGNUM                (18)      
#define EQ_SND_WIN_SEG_WIN              (19)      
#define EQ_SND_MAX_SND_NXT              (20)      
#define EQ_SND_NXT_SND_UNA              (21)      
#define EQ_ACK_SND_UNA                  (22)      
#define GT_ACK_SND_UNA                  (23)      
#define GT_SN_RCV_NXT                   (24)      
#define GT_SNpLEN_RCV_NXT               (25)      
#define GE_SNpLENm1_RCV_NXT             (26)      
#define EQ_SN_RCV_NXT                   (27)      
#define LE_ACK_SND_MAX                  (28)      
#define EQ_RX_WIN_SEG_WIN               (29)      
#define LT_SND_CWND_SND_WND             (30)      
#define GT_SNpLEN_OOO_END               (31)      
#define LE_SN_OOO_END                   (32)      
#define LT_SNpLEN_OOO_ST                (33)      
#define LT_SN_OOO_ST                    (34)      
#define LE_SN_LAST_ACK                  (35)      
#define T_FLAG_OOO_FIN                  (36)      
#define LT_SN_RCV_NXTpRX_WIN            (37)      
#define LT_SNpLENm1_RCV_NXTpRX_WIN      (38)      
#define UNCLASSIFIED                    (39)      

typedef enum {
   ENUM_ZERO_PKT_LEN = 0x0UL,
   ENUM_P_FLAG_FIN = 0x1UL,
   ENUM_P_FLAG_SYN = 0x2UL,
   ENUM_P_FLAG_RST = 0x3UL,
   ENUM_P_FLAG_PSH = 0x4UL,
   ENUM_P_FLAG_ACK = 0x5UL,
   ENUM_P_FLAG_URG = 0x6UL,
   ENUM_T_FLAG_OOO = 0x7UL,
   ENUM_ZERO_RX_WIN = 0x8UL,
   ENUM_ZERO_SND_WIN = 0x9UL,
   ENUM_T_TX_CLOSED = 0xaUL,
   ENUM_T_RX_CLOSED = 0xbUL,
   ENUM_T_TX_ESTABLISHED = 0xcUL,
   ENUM_T_RX_ESTABLISHED = 0xdUL,
   ENUM_TS_NOT_FOUND = 0xeUL,
   ENUM_MAX_HDR_LEN = 0xfUL,
   ENUM_EQ_TCP_HDR_MIN = 0x10UL,
   ENUM_GE_ACK_SND_UNAmMAX_SND_WIN = 0x11UL,
   ENUM_EQ_MPACRC_MAGNUM = 0x12UL,
   ENUM_EQ_SND_WIN_SEG_WIN = 0x13UL,
   ENUM_EQ_SND_MAX_SND_NXT = 0x14UL,
   ENUM_EQ_SND_NXT_SND_UNA = 0x15UL,
   ENUM_EQ_ACK_SND_UNA = 0x16UL,
   ENUM_GT_ACK_SND_UNA = 0x17UL,
   ENUM_GT_SN_RCV_NXT = 0x18UL,
   ENUM_GT_SNpLEN_RCV_NXT = 0x19UL,
   ENUM_GE_SNpLENm1_RCV_NXT = 0x1aUL,
   ENUM_EQ_SN_RCV_NXT = 0x1bUL,
   ENUM_LE_ACK_SND_MAX = 0x1cUL,
   ENUM_EQ_RX_WIN_SEG_WIN = 0x1dUL,
   ENUM_LT_SND_CWND_SND_WND = 0x1eUL,
   ENUM_GT_SNpLEN_OOO_END = 0x1fUL,
   ENUM_LE_SN_OOO_END = 0x20UL,
   ENUM_LT_SNpLEN_OOO_ST = 0x21UL,
   ENUM_LT_SN_OOO_ST = 0x22UL,
   ENUM_LE_SN_LAST_ACK = 0x23UL,
   ENUM_T_FLAG_OOO_FIN = 0x24UL,
   ENUM_LT_SN_RCV_NXTpRX_WIN = 0x25UL,
   ENUM_LT_SNpLENm1_RCV_NXTpRX_WIN = 0x26UL,
   ENUM_UNCLASSIFIED = 0x27UL
} TPRE_CLASS_PREDICATES_ENUM;

// --- TPRE_CLASS_VECTOR_ENUM ---
#define ACCEPTABLE_SEQ                  (0)       
#define ACCEPTABLE_ACK                  (1)       
#define ACCEPTABLE_SEQACK               (2)       
#define RECORD_TIMESTAMP                (3)       
#define REPLY_WITH_ACK                  (4)       
#define REPLY_BY_DROPPING               (5)       
#define SYN_SEG                         (6)       
#define IN_LINE                         (7)       
#define PURE_IN_LINE                    (8)       
#define OOO                             (9)       
#define NEW_OOO                         (10)      
#define OOO_APPEND                      (11)      
#define OOO_PREPEND                     (12)      
#define IN_LINE_PLUGS_HOLE              (13)      
#define PURE_ACK                        (14)      
#define DUP_ACK                         (15)      
#define FIN                             (16)      
#define OOO_FIN                         (17)      
#define RST                             (18)      
#define HEADER_PREDICTION               (19)      
#define RED_ULP0                        (20)      
#define RED_ULP1                        (21)      
#define RED_ULP2                        (22)      
#define RED_GLOBAL                      (23)      
#define HOLD_ACK_IMMED_P0               (24)      
#define HOLD_ACK_IMMED_P1               (25)      
#define VALID_ACK                       (26)      
#define TS_FOUND                        (27)      
#define CLASS_RSVD_MIN                  (28)      
#define CLASS_RSVD_MAX                  (30)      
#define NOT_CLASSIFIED                  (31)      

typedef enum {
   ENUM_ACCEPTABLE_SEQ = 0x0UL,
   ENUM_ACCEPTABLE_ACK = 0x1UL,
   ENUM_ACCEPTABLE_SEQACK = 0x2UL,
   ENUM_RECORD_TIMESTAMP = 0x3UL,
   ENUM_REPLY_WITH_ACK = 0x4UL,
   ENUM_REPLY_BY_DROPPING = 0x5UL,
   ENUM_SYN_SEG = 0x6UL,
   ENUM_IN_LINE = 0x7UL,
   ENUM_PURE_IN_LINE = 0x8UL,
   ENUM_OOO = 0x9UL,
   ENUM_NEW_OOO = 0xaUL,
   ENUM_OOO_APPEND = 0xbUL,
   ENUM_OOO_PREPEND = 0xcUL,
   ENUM_IN_LINE_PLUGS_HOLE = 0xdUL,
   ENUM_PURE_ACK = 0xeUL,
   ENUM_DUP_ACK = 0xfUL,
   ENUM_FIN = 0x10UL,
   ENUM_OOO_FIN = 0x11UL,
   ENUM_RST = 0x12UL,
   ENUM_HEADER_PREDICTION = 0x13UL,
   ENUM_RED_ULP0 = 0x14UL,
   ENUM_RED_ULP1 = 0x15UL,
   ENUM_RED_ULP2 = 0x16UL,
   ENUM_RED_GLOBAL = 0x17UL,
   ENUM_HOLD_ACK_IMMED_P0 = 0x18UL,
   ENUM_HOLD_ACK_IMMED_P1 = 0x19UL,
   ENUM_VALID_ACK = 0x1aUL,
   ENUM_TS_FOUND = 0x1bUL,
   ENUM_CLASS_RSVD_MIN = 0x1cUL,
   ENUM_CLASS_RSVD_MAX = 0x1eUL,
   ENUM_NOT_CLASSIFIED = 0x1fUL
} TPRE_CLASS_VECTOR_ENUM;

// --- TPRE_IQ_ENUM ---
#define TPRE_IQ_IPC                     (0)       // This is the IPC input queue. Common
                                                  // to all processors
#define TPRE_IQ_RCV_ULP_0               (1)       // This is the input queue for all -
                                                  // non-pure-ack - frames fromn the rxpp
                                                  // destined for ULP 0
#define TPRE_IQ_RCV_ULP_1               (2)       // This is the input queue for all -
                                                  // non-pure-ack - frames fromn the rxpp
                                                  // destined for ULP 1
#define TPRE_IQ_8021au                  (3)       // This is the input queue for the
                                                  // 802.1au Control frames
#define TPRE_IQ_TIMER                   (4)       // All timer pops get to this queue
#define TPRE_IQ_LRO                     (5)       // This is the input queue for the LRO
                                                  // frames
#define TPRE_IQ_FCoE                    (6)       // This is the input queue for the FCoE
                                                  // frames
#define TPRE_IQ_SIQ                     (7)       // This is the self initiate Q used for
                                                  // JELL Free

typedef enum {
   ENUM_TPRE_IQ_IPC = 0x0UL,
   ENUM_TPRE_IQ_RCV_ULP_0 = 0x1UL,
   ENUM_TPRE_IQ_RCV_ULP_1 = 0x2UL,
   ENUM_TPRE_IQ_8021au = 0x3UL,
   ENUM_TPRE_IQ_TIMER = 0x4UL,
   ENUM_TPRE_IQ_LRO = 0x5UL,
   ENUM_TPRE_IQ_FCoE = 0x6UL,
   ENUM_TPRE_IQ_SIQ = 0x7UL
} TPRE_IQ_ENUM;

// --- TPRE_TASK_ENUM ---
#define TPRE_TASK_ID_IPC                (0)       // Execution context initiated by
                                                  // TPRE_IQ_IPC 
#define TPRE_TASK_ID_RCV                (1)       // Execution context initiated by  -
                                                  // TPRE_IQ_RCV_ULP_0  -
                                                  // TPRE_IQ_RCV_ULP_1  -
                                                  // TPRE_IQ_RCV_ULP_2  - TPRE_IQ_ACK_PROC
#define TPRE_TASK_ID_TIMER              (2)       // Execution Context initiated by a
                                                  // timer pop TPRE_IQ_TIMER

typedef enum {
   ENUM_TPRE_TASK_ID_IPC = 0x0UL,
   ENUM_TPRE_TASK_ID_RCV = 0x1UL,
   ENUM_TPRE_TASK_ID_TIMER = 0x2UL
} TPRE_TASK_ENUM;

// --- TPRE_OQ_ENUM ---
// TPRE Unload Order Types
#define TPRE_OQ_IPC                     (0)       // Output queue fo the IPC
#define TPRE_OQ_ULP_0                   (1)       // Output Queue for ULP0
#define TPRE_OQ_ULP_1                   (2)       // Output Queue for ULP1
#define TPRE_OQ_ULP_2                   (3)       // Output Queue for ULP2
#define TPRE_OQ_ERX                     (4)       // Output Queue to ERX
#define TPRE_OQ_TPOST                   (5)       // Output Queue to TPOST used for
                                                  // immediate acks
#define TPRE_OQ_JELL                    (6)       // Output Queue to free jell entries
#define TPRE_OQ_SIQ0                    (11)      // Self initiate output queue
#define TPRE_OQ_SIQ1                    (12)      // Self initiate output queue
#define TPRE_OQ_CTX                     (13)      // Output Queue to Context Writeback
#define TPRE_OQ_RXPB                    (15)      // Reserved

typedef enum {
   ENUM_TPRE_OQ_IPC = 0x0UL,
   ENUM_TPRE_OQ_ULP_0 = 0x1UL,
   ENUM_TPRE_OQ_ULP_1 = 0x2UL,
   ENUM_TPRE_OQ_ULP_2 = 0x3UL,
   ENUM_TPRE_OQ_ERX = 0x4UL,
   ENUM_TPRE_OQ_TPOST = 0x5UL,
   ENUM_TPRE_OQ_JELL = 0x6UL,
   ENUM_TPRE_OQ_SIQ0 = 0xbUL,
   ENUM_TPRE_OQ_SIQ1 = 0xcUL,
   ENUM_TPRE_OQ_CTX = 0xdUL,
   ENUM_TPRE_OQ_RXPB = 0xfUL
} TPRE_OQ_ENUM;

// --- TXULP_QUEUE_ENUM ---
// Enumeration of the TxULP Input Queues 
#define TXULP_QUEUE_ID_IPC              (0)       // IPC input queue 
#define TXULP_QUEUE_ID_CXN_SCHED        (1)       // Connection scheduler input queue 
#define TXULP_QUEUE_ID_UC_RESP1         (2)       // UC response input queue 1 
#define TXULP_QUEUE_ID_UC_RESP2         (3)       // UC response queue 2 
#define TXULP_QUEUE_ID_SIR1             (6)       // Self initiate queue 1 
#define TXULP_QUEUE_ID_SIR2             (7)       // Self initiate queue 2 

typedef enum {
   ENUM_TXULP_QUEUE_ID_IPC = 0x0UL,
   ENUM_TXULP_QUEUE_ID_CXN_SCHED = 0x1UL,
   ENUM_TXULP_QUEUE_ID_UC_RESP1 = 0x2UL,
   ENUM_TXULP_QUEUE_ID_UC_RESP2 = 0x3UL,
   ENUM_TXULP_QUEUE_ID_SIR1 = 0x6UL,
   ENUM_TXULP_QUEUE_ID_SIR2 = 0x7UL
} TXULP_QUEUE_ENUM;

// --- TXULP_ORDER_ENUM ---
#define TXULP_OT_IPC                    (0)       // The IPC output queue is used to queue
                                                  // an IPC to a set of target processors
                                                  // in the chip. The IPC Descriptor
                                                  // IPC_HEADER_D is queued using the
                                                  // unload order gather list. 
#define TXULP_OT_UC_REQUEST1            (2)       // Output Queue for UC requests 
#define TXULP_OT_GLOBAL_QOS             (6)       // Output Queue for returning bytes to
                                                  // Global QOSS bucket 
#define TXULP_OT_LOCAL_QOS              (7)       // Output Queue for returning bytes to
                                                  // Local QOS bucket 
#define TXULP_OT_TPOST0                 (8)       // Output Queue to TPOST (Port 0) 
#define TXULP_OT_TPOST1                 (9)       // Output Queue to TPOST (Port 1) 
#define TXULP_OT_GRANT_CTRL             (10)      // Used to serialize the process of
                                                  // stimulating the TXULP Processor using
                                                  // the descriptor GRANT_CTRL_DESC 
#define TXULP_OT_SIR1                   (11)      // Output Queue 1 for self-initiate
                                                  // request 
#define TXULP_OT_SIR2                   (12)      // Output Queue 2 for Self-initiate
                                                  // request 
#define TXULP_OT_CTX_WB                 (13)      // Output Queue for Context Writeback 
#define TXULP_OT_TXPB_WB                (14)      // Output Queue for txpb writeback 

typedef enum {
   ENUM_TXULP_OT_IPC = 0x0UL,
   ENUM_TXULP_OT_UC_REQUEST1 = 0x2UL,
   ENUM_TXULP_OT_GLOBAL_QOS = 0x6UL,
   ENUM_TXULP_OT_LOCAL_QOS = 0x7UL,
   ENUM_TXULP_OT_TPOST0 = 0x8UL,
   ENUM_TXULP_OT_TPOST1 = 0x9UL,
   ENUM_TXULP_OT_GRANT_CTRL = 0xaUL,
   ENUM_TXULP_OT_SIR1 = 0xbUL,
   ENUM_TXULP_OT_SIR2 = 0xcUL,
   ENUM_TXULP_OT_CTX_WB = 0xdUL,
   ENUM_TXULP_OT_TXPB_WB = 0xeUL
} TXULP_ORDER_ENUM;

// --- MPU_IQ_ENUM ---
// Enumeration of the MPU Input Queues 
#define MPU_IQ_IPC                      (0)       // IPC input queue 
#define MPU_IQ_WDMA                     (1)       // WDMA response input queue 
#define MPU_IQ_UC                       (2)       // UC respons input queue 
#define MPU_IQ_RDMA                     (3)       // RDMA response input queue 
#define MPU_IQ_INT                      (4)       // Interrupt input queue 
#define MPU_IQ_CXN_SEL                  (5)       // Connection selector input queue 
#define MPU_IQ_NDMA                     (6)       // NDMA response input queue 
#define MPU_IQ_SIQ                      (7)       // Self initiate input queue 

typedef enum {
   ENUM_MPU_IQ_IPC = 0x0UL,
   ENUM_MPU_IQ_WDMA = 0x1UL,
   ENUM_MPU_IQ_UC = 0x2UL,
   ENUM_MPU_IQ_RDMA = 0x3UL,
   ENUM_MPU_IQ_INT = 0x4UL,
   ENUM_MPU_IQ_CXN_SEL = 0x5UL,
   ENUM_MPU_IQ_NDMA = 0x6UL,
   ENUM_MPU_IQ_SIQ = 0x7UL
} MPU_IQ_ENUM;

// --- MPU_OQ_ENUM ---
// Enumeration of the MPU Output Queues 
#define MPU_OQ_IPC                      (0)       // IPC output queue 
#define MPU_OQ_WDMA                     (1)       // WDMA request output queue 
#define MPU_OQ_UC                       (2)       // UC request output queue 
#define MPU_OQ_RDMA                     (3)       // RDMA request output queue 
#define MPU_OQ_CEV                      (4)       // CEV request output queue 
#define MPU_OQ_NDMA                     (6)       // NDMA request output queue 
#define MPU_OQ_CXN_SEL                  (10)      // Cxn selector grant output queue 
#define MPU_OQ_SIQ                      (12)      // Self initiate output queue 
#define MPU_OQ_CTX                      (13)      // Context output queue 
#define MPU_OQ_TXPB                     (14)      // TxPbuf output queue 
#define MPU_OQ_RXPB                     (15)      // Reserved 

typedef enum {
   ENUM_MPU_OQ_IPC = 0x0UL,
   ENUM_MPU_OQ_WDMA = 0x1UL,
   ENUM_MPU_OQ_UC = 0x2UL,
   ENUM_MPU_OQ_RDMA = 0x3UL,
   ENUM_MPU_OQ_CEV = 0x4UL,
   ENUM_MPU_OQ_NDMA = 0x6UL,
   ENUM_MPU_OQ_CXN_SEL = 0xaUL,
   ENUM_MPU_OQ_SIQ = 0xcUL,
   ENUM_MPU_OQ_CTX = 0xdUL,
   ENUM_MPU_OQ_TXPB = 0xeUL,
   ENUM_MPU_OQ_RXPB = 0xfUL
} MPU_OQ_ENUM;

#endif // __ep_queue_enum_h__

