/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __host_struct_enum_h__
#define __host_struct_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "headers_enum.h"
#include "be_cm_enum.h"
#include "rxf_enum.h"
#include "descriptors_enum.h"
#include "iscsi_initiator_host_struct_enum.h"
#include "iscsi_target_host_struct_enum.h"
#include "fc_enums_enum.h"
#include "fc_common_host_struct_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- CRA_QUADRANT_ENUM ---
// This defines the upper constant bits in a CRA, indentifying the correct quadrant of the
// address space.
#define CRA_QUAD_PE                     (0)       
#define CRA_QUAD_TE                     (1)       
#define CRA_QUAD_ISCSI                  (2)       
#define CRA_QUAD_RINGS                  (3)       
#define CRA_QUAD_JELL                   (64)      // Upper bits in JE region. The PEs and
                                                  // JEs share the 0th quadrant.
#define CRA_QUAD_R2T                    (528)     // Upper bits in R2T region. The R2T
                                                  // share the 0th quadrant with PE and
                                                  // JE.
#define CRA_QUAD_JELLOOO                (1040)    // Upper bits in OOO JE region. The PEs
                                                  // and JEs share the 0th quadrant.

typedef enum {
   ENUM_CRA_QUAD_PE = 0x0UL,
   ENUM_CRA_QUAD_TE = 0x1UL,
   ENUM_CRA_QUAD_ISCSI = 0x2UL,
   ENUM_CRA_QUAD_RINGS = 0x3UL,
   ENUM_CRA_QUAD_JELL = 0x40UL,
   ENUM_CRA_QUAD_R2T = 0x210UL,
   ENUM_CRA_QUAD_JELLOOO = 0x410UL
} CRA_QUADRANT_ENUM;

// --- CRA_RING_TYPES ---
// CRA Address Ring types
#define CRA_SEND_TYPE                   (0)       // Send Rings for TOE & RDMA
#define CRA_RECV_TYPE                   (1)       // Receive Rings
#define CRA_MCC_TYPE                    (2)       // MCC Rings
#define CRA_COMP_TYPE                   (3)       // Completion Rings
#define CRA_EVENT_TYPE                  (4)       // Event Rings
#define CRA_DFT_TYPE                    (5)       // Default Rings
#define CRA_RID_TYPE                    (6)       // Ethernet Send queue RID
#define CRA_R2T_TYPE                    (7)       // iSCSI R2T Array

typedef enum {
   ENUM_CRA_SEND_TYPE = 0x0UL,
   ENUM_CRA_RECV_TYPE = 0x1UL,
   ENUM_CRA_MCC_TYPE = 0x2UL,
   ENUM_CRA_COMP_TYPE = 0x3UL,
   ENUM_CRA_EVENT_TYPE = 0x4UL,
   ENUM_CRA_DFT_TYPE = 0x5UL,
   ENUM_CRA_RID_TYPE = 0x6UL,
   ENUM_CRA_R2T_TYPE = 0x7UL
} CRA_RING_TYPES;

// --- CRA_RX_RING_TYPES ---
// RX RING CRA Address Ring types
#define CRA_RSVD_TYPE                   (0)       // Donot use this. If used, may conflict
                                                  // with tx rings
#define CRA_NEW_RECV_TYPE               (1)       // Receive Rings

typedef enum {
   ENUM_CRA_RSVD_TYPE = 0x0UL,
   ENUM_CRA_NEW_RECV_TYPE = 0x1UL
} CRA_RX_RING_TYPES;

// --- ETH_EVENT_CODE ---
// These codes are returned by the MPU when one of these events has occurred, and the
// event is configured to report to an Event Queue when an event is detected.
#define ETH_EQ_LINK_STATUS              (0)       // Link status change event was
                                                  // detected.
#define ETH_EQ_WATERMARK                (1)       // A watermark event was detected.
#define ETH_EQ_MAGIC_PKT                (2)       // A magic packet event was detected.
#define ETH_EQ_ACPI_PKT0                (3)       // An ACPI interesting packet was
                                                  // detected.
#define ETH_EQ_ACPI_PKT1                (3)       // An ACPI interesting packet was
                                                  // detected.
#define ETH_EQ_ACPI_PKT2                (3)       // An ACPI interesting packet was
                                                  // detected.
#define ETH_EQ_ACPI_PKT3                (3)       // An ACPI interesting packet was
                                                  // detected.

typedef enum {
   ENUM_ETH_EQ_LINK_STATUS = 0x0UL,
   ENUM_ETH_EQ_WATERMARK = 0x1UL,
   ENUM_ETH_EQ_MAGIC_PKT = 0x2UL,
   ENUM_ETH_EQ_ACPI_PKT0 = 0x3UL,
   ENUM_ETH_EQ_ACPI_PKT1 = 0x3UL,
   ENUM_ETH_EQ_ACPI_PKT2 = 0x3UL,
   ENUM_ETH_EQ_ACPI_PKT3 = 0x3UL
} ETH_EVENT_CODE;

// --- TOE_EVENT_CODE ---
// These codes are returned by the MPU when one of these events has occurred, and the
// event is configured to report to an Event Queue when an event is detected.
#define TOE_EQ_RST                      (0)       // A reset was detected on an
                                                  // established connection.
#define TOE_EQ_FIN                      (1)       // A FIN segment was detected on an
                                                  // established connection.
#define TOE_EQ_DIS                      (2)       // A DIS segment was detected on an
                                                  // established connection.
#define TOE_EQ_URG                      (3)       // An URG segment was detected on an
                                                  // established connection.
#define TOE_EQ_TRANSL_ERR               (4)       // A memory translation error was
                                                  // detected on an established
                                                  // connection.
#define TOE_EQ_LOOSING                  (5)       // A connection is in the process of
                                                  // timing out. Host software should
                                                  // update path state if possible.

typedef enum {
   ENUM_TOE_EQ_RST = 0x0UL,
   ENUM_TOE_EQ_FIN = 0x1UL,
   ENUM_TOE_EQ_DIS = 0x2UL,
   ENUM_TOE_EQ_URG = 0x3UL,
   ENUM_TOE_EQ_TRANSL_ERR = 0x4UL,
   ENUM_TOE_EQ_LOOSING = 0x5UL
} TOE_EVENT_CODE;

// --- TOE_PREBUFFER_TYPE ---
// The different WRB types posted in the TOE preposted buffer receive queue.
#define TOE_PREBUFFER_TYPE_HDR          (0)       
#define TOE_PREBUFFER_TYPE_DUMMY        (1)       
#define TOE_PREBUFFER_TYPE_SGE          (2)       

typedef enum {
   ENUM_TOE_PREBUFFER_TYPE_HDR = 0x0UL,
   ENUM_TOE_PREBUFFER_TYPE_DUMMY = 0x1UL,
   ENUM_TOE_PREBUFFER_TYPE_SGE = 0x2UL
} TOE_PREBUFFER_TYPE;

// --- TOE_TX_ERROR_CODES ---
// Error codes received in TOE receive completions.
#define TCP_WARN_KEEPALIVE_PROBE        (1)       // Indicates that firmware is starting
                                                  // keepalive probes on account of the
                                                  // connection being idle for ka_timeout
                                                  // time.
#define TCP_ERROR_SYN_IN_WINDOW         (2)       // Indicates the connection was closed
                                                  // because we received a SYN in window.
#define TCP_ERROR_URGENT_RECEIVED       (19)      // Indicates that the connection was
                                                  // closed because an urgent packet was
                                                  // recieved on the connection,
                                                  // connection will transition to
                                                  // TCPS_CLOSED.
#define TCP_WARN_TIMEOUT_BACKOFF        (35)      // Indicates that the toe is backing off
                                                  // on retransmits, happens on every
                                                  // retransmit after the 3rd one for the
                                                  // connection. There will be no state
                                                  // change corresponding to this error
                                                  // code.
#define TCP_ERROR_KA_TIMED_OUT          (45)      // Indicates that the connection timed
                                                  // out. Occurs when we do not get a
                                                  // response to 'ka_probe_max' probes.
#define TCP_ERROR_RESET_RECEIVED        (53)      // Indicates that the connection was
                                                  // closed because a valid reset was
                                                  // received. Connection will transition
                                                  // to TCPS_CLOSED.
#define TCP_ERROR_TIMED_OUT             (60)      // Indicates that the connection timed
                                                  // out. Occurs after 12 retransmit
                                                  // attempts on the connection.
                                                  // Connectinon will transition to
                                                  // TCPS_CLOSED.
#define TCP_FINWAIT2_TIMED_OUT          (61)      // Indicates that the connection timed
                                                  // out in FINWAIT2 state. Connectinon
                                                  // will transition to TCPS_CLOSED.
#define TCP_WARN_MAX_RT_TIMED_OUT       (63)      // Indicates that the connection timed
                                                  // out b'cos of the retransmission time
                                                  // instead of count.

typedef enum {
   ENUM_TCP_WARN_KEEPALIVE_PROBE = 0x1UL,
   ENUM_TCP_ERROR_SYN_IN_WINDOW = 0x2UL,
   ENUM_TCP_ERROR_URGENT_RECEIVED = 0x13UL,
   ENUM_TCP_WARN_TIMEOUT_BACKOFF = 0x23UL,
   ENUM_TCP_ERROR_KA_TIMED_OUT = 0x2dUL,
   ENUM_TCP_ERROR_RESET_RECEIVED = 0x35UL,
   ENUM_TCP_ERROR_TIMED_OUT = 0x3cUL,
   ENUM_TCP_FINWAIT2_TIMED_OUT = 0x3dUL,
   ENUM_TCP_WARN_MAX_RT_TIMED_OUT = 0x3fUL
} TOE_TX_ERROR_CODES;

// --- TOE_COMPL_TYPE_ENUM ---
// Completion types for TOE TX and RX.
#define TX_COMPL_TYPE                   (0)       // Transmit completion.
#define RX_DF_COMPL_TYPE                (1)       // Default buffer completion.
#define RX_PP_COMPL_TYPE                (2)       // Preposted buffer completion.
#define RX_PA_COMPL_TYPE                (3)       // Packed default buffer completion.
#define STATE_CHANGE_TYPE               (4)       // State change notification.
#define TX_FLUSH_TYPE                   (5)       // Flush of transmit CQ after connection
                                                  // upload.
#define RX_FLUSH_TYPE                   (6)       // Flush of default buffer CQ after
                                                  // connection upload.
#define PREPOSTED_FLUSH_TYPE            (7)       // Flush of preposted buffer CQ after
                                                  // connection upload.

typedef enum {
   ENUM_TX_COMPL_TYPE = 0x0UL,
   ENUM_RX_DF_COMPL_TYPE = 0x1UL,
   ENUM_RX_PP_COMPL_TYPE = 0x2UL,
   ENUM_RX_PA_COMPL_TYPE = 0x3UL,
   ENUM_STATE_CHANGE_TYPE = 0x4UL,
   ENUM_TX_FLUSH_TYPE = 0x5UL,
   ENUM_RX_FLUSH_TYPE = 0x6UL,
   ENUM_PREPOSTED_FLUSH_TYPE = 0x7UL
} TOE_COMPL_TYPE_ENUM;

// --- CHIP_ID_TYPES ---
// Enumerations for various controller entities.
#define CHIP_ID_TYPE_EQ_ISCSI           (1)       
#define CHIP_ID_TYPE_EQ_NET             (2)       
#define CHIP_ID_TYPE_CQ                 (3)       
#define CHIP_ID_TYPE_TOE                (4)       
#define CHIP_ID_TYPE_ISCSI              (5)       
#define CHIP_ID_TYPE_ETX                (6)       
#define CHIP_ID_TYPE_ISCSI_DEFQ         (7)       
#define CHIP_ID_TYPE_TOE_DEFQ           (8)       

typedef enum {
   ENUM_CHIP_ID_TYPE_EQ_ISCSI = 0x1UL,
   ENUM_CHIP_ID_TYPE_EQ_NET = 0x2UL,
   ENUM_CHIP_ID_TYPE_CQ = 0x3UL,
   ENUM_CHIP_ID_TYPE_TOE = 0x4UL,
   ENUM_CHIP_ID_TYPE_ISCSI = 0x5UL,
   ENUM_CHIP_ID_TYPE_ETX = 0x6UL,
   ENUM_CHIP_ID_TYPE_ISCSI_DEFQ = 0x7UL,
   ENUM_CHIP_ID_TYPE_TOE_DEFQ = 0x8UL
} CHIP_ID_TYPES;

// --- WQE_OPERATION_ENUM ---
// Operation codes for an RDMA Work Queue Entry
#define WQE_OPERATION_SEND              (1)       // Send, Send with SE, Send with
                                                  // Invalidate, and Send with SE and
                                                  // invalidate
#define WQE_OPERATION_RECEIVE           (2)       // Receive
#define WQE_OPERATION_RDMA_WRITE        (3)       // RDMA Write
#define WQE_OPERATION_RDMA_READ         (4)       // RDMA Read, and RDMA Read with
                                                  // invalidate
#define WQE_OPERATION_RDMA_READ_RESPONSE (5)      // RDMA Read Response
#define WQE_OPERATION_TERMINATE         (6)       // Terminate
#define WQE_OPERATION_BIND              (7)       // Bind
#define WQE_OPERATION_LOCAL_INVALIDATE  (8)       // Invalidate Local STag
#define WQE_OPERATION_FAST_REGISTER     (9)       // Fast Register MR

typedef enum {
   ENUM_WQE_OPERATION_SEND = 0x1UL,
   ENUM_WQE_OPERATION_RECEIVE = 0x2UL,
   ENUM_WQE_OPERATION_RDMA_WRITE = 0x3UL,
   ENUM_WQE_OPERATION_RDMA_READ = 0x4UL,
   ENUM_WQE_OPERATION_RDMA_READ_RESPONSE = 0x5UL,
   ENUM_WQE_OPERATION_TERMINATE = 0x6UL,
   ENUM_WQE_OPERATION_BIND = 0x7UL,
   ENUM_WQE_OPERATION_LOCAL_INVALIDATE = 0x8UL,
   ENUM_WQE_OPERATION_FAST_REGISTER = 0x9UL
} WQE_OPERATION_ENUM;

// --- WQE_FLAGS_ENUM ---
// RDMA WQE flag definitions.
#define WQE_FLAG_SIGNAL                 (1)       // Set value indicates Signaled
                                                  // Completion
#define WQE_FLAG_SOLICITED              (2)       // Set value indicates Solicited Event
#define WQE_FLAG_FENCE                  (4)       // Set value indicates Fence. Send,RDMA
                                                  // Write->Read Fence. Local
                                                  // Invalidate->Local Fence
#define WQE_FLAG_INVALIDATE             (8)       // Set value indicates STAG Invalidate
#define WQE_FLAG_VA_ADDR                (16)      // Set value indicates VA-based
                                                  // addressing
#define WQE_FLAG_LOCAL_READ             (32)      // Set value indicates local read access
                                                  // enable
#define WQE_FLAG_REMOTE_READ            (64)      // Set value indicates remote read
                                                  // access enable
#define WQE_FLAG_LOCAL_WRITE            (128)     // Set value indicates local write
                                                  // access enable
#define WQE_FLAG_REMOTE_WRITE           (256)     // Set value indicates remote write
                                                  // access enable
#define WQE_FLAG_BINDABLE               (512)     // Set value indicates Memory Window
                                                  // Binding enable
#define WQE_FLAG_PBL_STRUCT             (1024)    // Set value indicates Physical Buffer
                                                  // List valid

typedef enum {
   ENUM_WQE_FLAG_SIGNAL = 0x1UL,
   ENUM_WQE_FLAG_SOLICITED = 0x2UL,
   ENUM_WQE_FLAG_FENCE = 0x4UL,
   ENUM_WQE_FLAG_INVALIDATE = 0x8UL,
   ENUM_WQE_FLAG_VA_ADDR = 0x10UL,
   ENUM_WQE_FLAG_LOCAL_READ = 0x20UL,
   ENUM_WQE_FLAG_REMOTE_READ = 0x40UL,
   ENUM_WQE_FLAG_LOCAL_WRITE = 0x80UL,
   ENUM_WQE_FLAG_REMOTE_WRITE = 0x100UL,
   ENUM_WQE_FLAG_BINDABLE = 0x200UL,
   ENUM_WQE_FLAG_PBL_STRUCT = 0x400UL
} WQE_FLAGS_ENUM;

// --- RDMA_EQE_STATUS ---
// Completion codes for an RDMA Event Queue Entry
#define RDMA_EQE_STATUS_LLP_CLOSE_COMPLETE (0)    // The RDMA Stream has completed Closing
                                                  // and no SQ WQEs were flushed.
#define RDMA_EQE_STATUS_TERMINATE_RECEIVED (1)    // Terminate Message Received
#define RDMA_EQE_STATUS_LLP_CONNECTION_RESET (2)  // An incoming LLP Reset (e.g. RST on
                                                  // TCP) was received.
#define RDMA_EQE_STATUS_LLP_CONNECTION_LOST (3)   // The connection was lost
#define RDMA_EQE_STATUS_LLP_INVALID_SEGMENT_SIZE (4) // LLP Integrity Error: Segment size
                                                     // invalid
#define RDMA_EQE_STATUS_INVALID_CRC     (5)       // Invalid CRC
#define RDMA_EQE_STATUS_INVALID_FPDU    (6)       // Received MPA marker and 'Length'
                                                  // fields do not agree on the start of a
                                                  // FPDU 
#define RDMA_EQE_STATUS_INVALID_DDP_VERSION (7)   // Invalid DDP version - caused by an
                                                  // inbound segment
#define RDMA_EQE_STATUS_INVALID_RDMA_VERSION (8)  // Invalid RDMA version - caused by an
                                                  // inbound segment
#define RDMA_EQE_STATUS_INVALID_OPCODE  (9)       // Unexpected Opcode - caused by an
                                                  // inbound segment
#define RDMA_EQE_STATUS_INVALID_DDP_QUEUE_NUMBER (10) // Invalid DDP Queue Number - caused
                                                      // by an inbound segment
#define RDMA_EQE_STATUS_INVALID_RDMA_READ_REQ (11) // Invalid RDMA Read Request Message,
                                                   // RDMA Read not enabled - caused by an
                                                   // inbound segment
#define RDMA_EQE_STATUS_INVALID_RDMA_WRITE_REQ (12) // Invalid RDMA Write or RDMA Read
                                                    // Response Message, RDMA Write & RDMA
                                                    // Read Response not enabled - caused
                                                    // by an inbound segment. 
#define RDMA_EQE_STATUS_INVALID_RDMA_READ_SIZE (13) // Invalid RDMA Read Request Message,
                                                    // message size too small or Offset
                                                    // non-zero - caused by an inbound
                                                    // segment.
#define RDMA_EQE_STATUS_NO_L_BIT        (14)      // No 'L' bit when expected - caused by
                                                  // an inbound segment.
#define RDMA_EQE_STATUS_INVALID_STAG    (15)      // Invalid STag - caused by an inbound
                                                  // Tagged DDP segment not valid for this
                                                  // QP. This includes using the STag of
                                                  // zero, the STag was not associated
                                                  // with the QP or the STag was in the
                                                  // Invalid state.
#define RDMA_EQE_STATUS_BOUNDS_FAILURE  (16)      // Tagged Base and bounds violation -
                                                  // caused by an inbound Tagged segment
                                                  // attempted to access memory outside
                                                  // the limits assigned to the STag.
#define RDMA_EQE_STATUS_RIGHTS_FAILURE  (17)      // Tagged Access Rights violation -
                                                  // caused by an inbound segment
                                                  // referencing a Tagged Buffer which did
                                                  // not have the necessary memory Access
                                                  // Rights for the requested operation.
#define RDMA_EQE_STATUS_INVALID_PD      (18)      // Caused by an inbound segment
                                                  // referencing a Tagged Buffer which was
                                                  // not allowed to be referenced by QP.
#define RDMA_EQE_STATUS_WRAP_ERROR      (19)      // Caused by an inbound segment not
                                                  // targeting the RQ.
#define RDMA_EQE_STATUS_BAD_CLOSE       (20)      // The QP was in the Closing state when
                                                  // a Segment arrived.
#define RDMA_EQE_STATUS_BAD_LLP_CLOSE   (21)      // An attempt was made to close the RDMA
                                                  // Stream with work in progress. 
#define RDMA_EQE_STATUS_INVALID_RQ_MSN_RANGE (22) // MSN range not valid. Caused by an
                                                  // inbound segment targeting the RQ.
                                                  // Possibly due to Receive Queue being
                                                  // empty. 
#define RDMA_EQE_STATUS_RQ_MSN_GAP      (23)      // Invalid MSN - gap in MSN. Caused by
                                                  // an inbound segment targeting the RQ
#define RDMA_EQE_STATUS_IRRQ_NOT_TARGETED (24)    // Invalid MSN - too many RDMA Read
                                                  // Request Messages in progress - caused
                                                  // by an inbound segment not targeting
                                                  // the IRRQ. 
#define RDMA_EQE_STATUS_IRRQ_MSN_GAP    (25)      // Invalid MSN - gap in MSN - caused by
                                                  // an inbound segment not targeting the
                                                  // RQ
#define RDMA_EQE_STATUS_IRRQ_INVALID_MSN_RANGE (26) // Invalid MSN - range is not valid -
                                                    // caused by an inbound segment not
                                                    // targeting the RQ. 
#define RDMA_EQE_STATUS_IRRQ_INVALID_STAG (27)    // Invalid STag - Data Source STag
                                                  // determined to be invalid during RDMA
                                                  // Read Response processing.
#define RDMA_EQE_STATUS_IRRQ_BOUND_FAILURE (28)   // Tagged Base and bounds violation -
                                                  // This includes RDMA Read Request of a
                                                  // message larger than supported by the
                                                  // RNIC. It is detected accessing the
                                                  // Data Source during RDMA Read Response
                                                  // processing. 
#define RDMA_EQE_STATUS_IRRQ_ACCESS_VIOLATION (29) // Tagged Access Rights violation -
                                                   // Data Source Access Rights violation
                                                   // detected during RDMA Read Response
                                                   // processing. 
#define RDMA_EQE_STATUS_IRRQ_INVALID_PD (30)      // Tagged Invalid PD - Data Source PD
                                                  // violation detected during RDMA Read
                                                  // Response process
#define RDMA_EQE_STATUS_IRRQ_WRAP_ERROR (31)      // Wrap error - detected during RDMA
                                                  // Read Response processing. 
#define RDMA_EQE_STATUS_CQ_SQ_ERROR     (32)      // CQ Error - An error occurred on the
                                                  // CQ during a SQ completion
#define RDMA_EQE_STATUS_CQ_RQ_ERROR     (33)      // CQ Operation error - An error
                                                  // occurred on the CQ during a RQ
                                                  // completion.
#define RDMA_EQE_STATUS_CATASTROPHIC_ERROR (35)   // Local QP Catastrophic Error -
                                                  // occurred during processing.
#define RDMA_EQE_STATUS_CQ_OVERFLOW     (36)      // An overflow of the Completion Queue
                                                  // has been detected. This Error Code is
                                                  // OPTIONAL. 
#define RDMA_EQE_STATUS_CQ_OPERATIONAL_ERROR (37) // An error occurred on the CQ unrelated
                                                  // to a specific QP completion. 
#define RDMA_EQE_STATUS_QP_RQ_LIMIT_REACHED (39)  // The Limit value established for the
                                                  // QP's RQ has been reached.
#define RDMA_EQE_STATUS_RNIC_CATASTROPHIC_ERROR (41) // A problem occurred with the RNIC
                                                     // or its driver that renders the
                                                     // RNIC unable to reliably function. 

typedef enum {
   ENUM_RDMA_EQE_STATUS_LLP_CLOSE_COMPLETE = 0x0UL,
   ENUM_RDMA_EQE_STATUS_TERMINATE_RECEIVED = 0x1UL,
   ENUM_RDMA_EQE_STATUS_LLP_CONNECTION_RESET = 0x2UL,
   ENUM_RDMA_EQE_STATUS_LLP_CONNECTION_LOST = 0x3UL,
   ENUM_RDMA_EQE_STATUS_LLP_INVALID_SEGMENT_SIZE = 0x4UL,
   ENUM_RDMA_EQE_STATUS_INVALID_CRC = 0x5UL,
   ENUM_RDMA_EQE_STATUS_INVALID_FPDU = 0x6UL,
   ENUM_RDMA_EQE_STATUS_INVALID_DDP_VERSION = 0x7UL,
   ENUM_RDMA_EQE_STATUS_INVALID_RDMA_VERSION = 0x8UL,
   ENUM_RDMA_EQE_STATUS_INVALID_OPCODE = 0x9UL,
   ENUM_RDMA_EQE_STATUS_INVALID_DDP_QUEUE_NUMBER = 0xaUL,
   ENUM_RDMA_EQE_STATUS_INVALID_RDMA_READ_REQ = 0xbUL,
   ENUM_RDMA_EQE_STATUS_INVALID_RDMA_WRITE_REQ = 0xcUL,
   ENUM_RDMA_EQE_STATUS_INVALID_RDMA_READ_SIZE = 0xdUL,
   ENUM_RDMA_EQE_STATUS_NO_L_BIT = 0xeUL,
   ENUM_RDMA_EQE_STATUS_INVALID_STAG = 0xfUL,
   ENUM_RDMA_EQE_STATUS_BOUNDS_FAILURE = 0x10UL,
   ENUM_RDMA_EQE_STATUS_RIGHTS_FAILURE = 0x11UL,
   ENUM_RDMA_EQE_STATUS_INVALID_PD = 0x12UL,
   ENUM_RDMA_EQE_STATUS_WRAP_ERROR = 0x13UL,
   ENUM_RDMA_EQE_STATUS_BAD_CLOSE = 0x14UL,
   ENUM_RDMA_EQE_STATUS_BAD_LLP_CLOSE = 0x15UL,
   ENUM_RDMA_EQE_STATUS_INVALID_RQ_MSN_RANGE = 0x16UL,
   ENUM_RDMA_EQE_STATUS_RQ_MSN_GAP = 0x17UL,
   ENUM_RDMA_EQE_STATUS_IRRQ_NOT_TARGETED = 0x18UL,
   ENUM_RDMA_EQE_STATUS_IRRQ_MSN_GAP = 0x19UL,
   ENUM_RDMA_EQE_STATUS_IRRQ_INVALID_MSN_RANGE = 0x1aUL,
   ENUM_RDMA_EQE_STATUS_IRRQ_INVALID_STAG = 0x1bUL,
   ENUM_RDMA_EQE_STATUS_IRRQ_BOUND_FAILURE = 0x1cUL,
   ENUM_RDMA_EQE_STATUS_IRRQ_ACCESS_VIOLATION = 0x1dUL,
   ENUM_RDMA_EQE_STATUS_IRRQ_INVALID_PD = 0x1eUL,
   ENUM_RDMA_EQE_STATUS_IRRQ_WRAP_ERROR = 0x1fUL,
   ENUM_RDMA_EQE_STATUS_CQ_SQ_ERROR = 0x20UL,
   ENUM_RDMA_EQE_STATUS_CQ_RQ_ERROR = 0x21UL,
   ENUM_RDMA_EQE_STATUS_CATASTROPHIC_ERROR = 0x23UL,
   ENUM_RDMA_EQE_STATUS_CQ_OVERFLOW = 0x24UL,
   ENUM_RDMA_EQE_STATUS_CQ_OPERATIONAL_ERROR = 0x25UL,
   ENUM_RDMA_EQE_STATUS_QP_RQ_LIMIT_REACHED = 0x27UL,
   ENUM_RDMA_EQE_STATUS_RNIC_CATASTROPHIC_ERROR = 0x29UL
} RDMA_EQE_STATUS;

// --- RDMA_CQE_STATUS ---
// Completion codes for an RDMA Completion Queue Entry
#define RDMA_CQE_STATUS_SUCCESS         (0)       // The RNIC Operation was successful.
#define RDMA_CQE_STATUS_FLUSHED         (1)       // The Work Request was incomplete when
                                                  // the QP entered the Error state
#define RDMA_CQE_STATUS_INVALID_WQE     (2)       // The Work Request Element contained a
                                                  // format error
#define RDMA_CQE_STATUS_LOCAL_CATASTROPHIC_ERROR (3) // An error related to the QP
                                                     // occurred while processing the Work
                                                     // Request.
#define RDMA_CQE_STATUS_REMOTE_TERMINATION_ERROR (4) // A Terminate Message was received
                                                     // from the Remote Peer that appears
                                                     // to be related to the execution of
                                                     // this Work Request. The error type
                                                     // can be examined by looking at the
                                                     // Terminate Message buffer via Query
                                                     // QP.
#define RDMA_CQE_STATUS_INVALID_STAG    (5)       // An invalid STag was found in the
                                                  // local SGL. The STag was either not
                                                  // found allocated, bound, or registered
                                                  // in the RI, or an STag of zero was
                                                  // specified for a QP without Privileged
                                                  // rights, or referred to a Shared
                                                  // Memory Region, or the type of STag
                                                  // supplied was not allowed to be used
                                                  // in the specified operation.
#define RDMA_CQE_STATUS_BASE_AND_BOUNDS_VIOLATION (6) // The local SGL referenced an
                                                      // address beyond the limits
                                                      // specified for the MR or MW. This
                                                      // includes length errors. For a
                                                      // Bind, the MW was not wholly
                                                      // contained in the MR.
#define RDMA_CQE_STATUS_ACCESS_VIOLATION (7)      // The RNIC attempted to read or write
                                                  // to a local SGL MR or MW that did not
                                                  // provide appropriate Access Rights.
                                                  // For a Bind, the MW Access Rights were
                                                  // not compatible with the MR Access
                                                  // Rights
#define RDMA_CQE_STATUS_INVALID_PD      (8)       // For one of the STags specified in the
                                                  // Work Request the PD of the MR STag
                                                  // was not the same as the PD of the QP,
                                                  // or, the QP of the MW STag was not the
                                                  // same as QP.
#define RDMA_CQE_STATUS_WRAP_ERROR      (9)       // The specified Address or offset (TO
                                                  // or MO) added to the length of the
                                                  // operation resulted in a wrap beyond
                                                  // the machine-supported address.
#define RDMA_CQE_STATUS_BAD_INVALIDATE_STAG_ON_RQ (16) // The Invalidate STag on a Receive
                                                       // did not have a PD ID that
                                                       // matched the PD ID of the QP (for
                                                       // a MR) or a QP ID that matched
                                                       // the QP ID of the QP (for a MW).
                                                       // Or the STag did not have Access
                                                       // Rights to be invalidated
                                                       // remotely.
#define RDMA_CQE_STATUS_ZERO_RDMA_READ_RESOURCES (17) // The QP ORD value was set to zero.
#define RDMA_CQE_STATUS_QP_NOT_PRIVILEGED (18)    // The QP is not enabled to perform the
                                                  // Privileged WR.
#define RDMA_CQE_STATUS_INVALID_STAG_REGISTERED (19) // The STag was already registered or
                                                     // bound, when attempting to Register
                                                     // or Bind it.
#define RDMA_CQE_STATUS_INVALID_PAGE_SIZE (20)    // The page size requested was not
                                                  // supported by the RNIC.
#define RDMA_CQE_STATUS_INVALID_BUFFER_SIZE (21)  // Size not supported by the RNIC.
#define RDMA_CQE_STATUS_INVALID_PBL_ENTRY (22)    // for page mode, the entry must start
                                                  // on page size boundaries.
#define RDMA_CQE_STATUS_INVALID_FBO     (23)      // The FBO is larger than the physical
                                                  // buffer size.
#define RDMA_CQE_STATUS_INVALID_LENGTH_FAST_REGISTER (24) // Requested length is larger
                                                          // than supported by the buffer
                                                          // list during a fast register
                                                          // operation.
#define RDMA_CQE_STATUS_INVALID_ACCESS_RIGHTS (25) // Invalid Access Rights specified.
#define RDMA_CQE_STATUS_PBL_TOO_LONG    (32)      // Physical Buffer List too long.
#define RDMA_CQE_STATUS_INVALID_VIRTUAL_ADDRESS (33) // VA and FBO are not consistent.
#define RDMA_CQE_STATUS_INVALID_REGION  (34)      // The STag specified for the MR in the
                                                  // BIND request was invalid.
#define RDMA_CQE_STATUS_INVALID_WINDOW  (35)      // The STag specified for the MW in the
                                                  // BIND request was invalid.
#define RDMA_CQE_STATUS_INVALID_LENGTH  (36)      // The total size of the data to be
                                                  // moved as specified by the sum of the
                                                  // SGL elements, was larger than that
                                                  // supported by the RNIC.

typedef enum {
   ENUM_RDMA_CQE_STATUS_SUCCESS = 0x0UL,
   ENUM_RDMA_CQE_STATUS_FLUSHED = 0x1UL,
   ENUM_RDMA_CQE_STATUS_INVALID_WQE = 0x2UL,
   ENUM_RDMA_CQE_STATUS_LOCAL_CATASTROPHIC_ERROR = 0x3UL,
   ENUM_RDMA_CQE_STATUS_REMOTE_TERMINATION_ERROR = 0x4UL,
   ENUM_RDMA_CQE_STATUS_INVALID_STAG = 0x5UL,
   ENUM_RDMA_CQE_STATUS_BASE_AND_BOUNDS_VIOLATION = 0x6UL,
   ENUM_RDMA_CQE_STATUS_ACCESS_VIOLATION = 0x7UL,
   ENUM_RDMA_CQE_STATUS_INVALID_PD = 0x8UL,
   ENUM_RDMA_CQE_STATUS_WRAP_ERROR = 0x9UL,
   ENUM_RDMA_CQE_STATUS_BAD_INVALIDATE_STAG_ON_RQ = 0x10UL,
   ENUM_RDMA_CQE_STATUS_ZERO_RDMA_READ_RESOURCES = 0x11UL,
   ENUM_RDMA_CQE_STATUS_QP_NOT_PRIVILEGED = 0x12UL,
   ENUM_RDMA_CQE_STATUS_INVALID_STAG_REGISTERED = 0x13UL,
   ENUM_RDMA_CQE_STATUS_INVALID_PAGE_SIZE = 0x14UL,
   ENUM_RDMA_CQE_STATUS_INVALID_BUFFER_SIZE = 0x15UL,
   ENUM_RDMA_CQE_STATUS_INVALID_PBL_ENTRY = 0x16UL,
   ENUM_RDMA_CQE_STATUS_INVALID_FBO = 0x17UL,
   ENUM_RDMA_CQE_STATUS_INVALID_LENGTH_FAST_REGISTER = 0x18UL,
   ENUM_RDMA_CQE_STATUS_INVALID_ACCESS_RIGHTS = 0x19UL,
   ENUM_RDMA_CQE_STATUS_PBL_TOO_LONG = 0x20UL,
   ENUM_RDMA_CQE_STATUS_INVALID_VIRTUAL_ADDRESS = 0x21UL,
   ENUM_RDMA_CQE_STATUS_INVALID_REGION = 0x22UL,
   ENUM_RDMA_CQE_STATUS_INVALID_WINDOW = 0x23UL,
   ENUM_RDMA_CQE_STATUS_INVALID_LENGTH = 0x24UL
} RDMA_CQE_STATUS;

#endif // __host_struct_enum_h__

