/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_common_enum_h__
#define __ioctl_common_enum_h__
#include "setypes.h"
#include "ioctl_types_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_defs_enum.h"
#include "host_struct_enum.h"
#include "fw_exp_enum.h"
#include "erx_enum.h"
#include "ioctl_mcc_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- IOCTL_SIZE_ENUMS ---
#define IOCTL_EMBEDDED_PARAMS_BYTES     (220)     
#define IOCTL_EMBEDDED_PAYLOAD_BYTES    (236)     

typedef enum {
   ENUM_IOCTL_EMBEDDED_PARAMS_BYTES = 0xdcUL,
   ENUM_IOCTL_EMBEDDED_PAYLOAD_BYTES = 0xecUL
} IOCTL_SIZE_ENUMS;

// --- PHY_LINK_DUPLEX_ENUM ---
#define PHY_LINK_DUPLEX_NONE            (0)       
#define PHY_LINK_DUPLEX_HALF            (1)       
#define PHY_LINK_DUPLEX_FULL            (2)       

typedef enum {
   ENUM_PHY_LINK_DUPLEX_NONE = 0x0UL,
   ENUM_PHY_LINK_DUPLEX_HALF = 0x1UL,
   ENUM_PHY_LINK_DUPLEX_FULL = 0x2UL
} PHY_LINK_DUPLEX_ENUM;

// --- PHY_LINK_SPEED_ENUM ---
#define PHY_LINK_SPEED_ZERO             (0)       // No link.
#define PHY_LINK_SPEED_10MBPS           (1)       // 10 Mbps
#define PHY_LINK_SPEED_100MBPS          (2)       // 100 Mbps
#define PHY_LINK_SPEED_1GBPS            (3)       // 1 Gbps
#define PHY_LINK_SPEED_10GBPS           (4)       // 10 Gbps

typedef enum {
   ENUM_PHY_LINK_SPEED_ZERO = 0x0UL,
   ENUM_PHY_LINK_SPEED_10MBPS = 0x1UL,
   ENUM_PHY_LINK_SPEED_100MBPS = 0x2UL,
   ENUM_PHY_LINK_SPEED_1GBPS = 0x3UL,
   ENUM_PHY_LINK_SPEED_10GBPS = 0x4UL
} PHY_LINK_SPEED_ENUM;

// --- PHY_LINK_FAULT_ENUM ---
#define PHY_LINK_FAULT_NONE             (0)       // No fault status available or detected
#define PHY_LINK_FAULT_LOCAL            (1)       // Local fault detected
#define PHY_LINK_FAULT_REMOTE           (2)       // Remote fault detected

typedef enum {
   ENUM_PHY_LINK_FAULT_NONE = 0x0UL,
   ENUM_PHY_LINK_FAULT_LOCAL = 0x1UL,
   ENUM_PHY_LINK_FAULT_REMOTE = 0x2UL
} PHY_LINK_FAULT_ENUM;

// --- BE_OPERATION ---
#define BE_OPERATION_QUERY              (0)       
#define BE_OPERATION_CREATE             (1)       
#define BE_OPERATION_DELETE             (2)       
#define BE_OPERATION_REPLACE            (4)       

typedef enum {
   ENUM_BE_OPERATION_QUERY = 0x0UL,
   ENUM_BE_OPERATION_CREATE = 0x1UL,
   ENUM_BE_OPERATION_DELETE = 0x2UL,
   ENUM_BE_OPERATION_REPLACE = 0x4UL
} BE_OPERATION;

// --- NTWK_PHYS_PORT ---
#define NTWK_PORT_A                     (0)       // Port A
#define NTWK_PORT_B                     (1)       // Port B
#define NTWK_PORT_C                     (2)       // Port C
#define NTWK_PORT_D                     (3)       // Port D

typedef enum {
   ENUM_NTWK_PORT_A = 0x0UL,
   ENUM_NTWK_PORT_B = 0x1UL,
   ENUM_NTWK_PORT_C = 0x2UL,
   ENUM_NTWK_PORT_D = 0x3UL
} NTWK_PHYS_PORT;

// --- NTWK_LINK_TYPE ---
#define NTWK_LINK_TYPE_PHYSICAL         (0)       // The associated link up/down event
                                                  // applies to the BladeEngine's Physical
                                                  // Ports
#define NTWK_LINK_TYPE_LOGICAL          (1)       // The associated link up/down event
                                                  // applies to the BladeEngine's Logical
                                                  // Links

typedef enum {
   ENUM_NTWK_LINK_TYPE_PHYSICAL = 0x0UL,
   ENUM_NTWK_LINK_TYPE_LOGICAL = 0x1UL
} NTWK_LINK_TYPE;

// --- NTWK_LOGICAL_LINK ---
#define NTWK_LOGICAL_LINK_DOWN          (0)       // Logical link is down for the
                                                  // associated function
#define NTWK_LOGICAL_LINK_UP            (1)       // Logical link is up for the associated
                                                  // function

typedef enum {
   ENUM_NTWK_LOGICAL_LINK_DOWN = 0x0UL,
   ENUM_NTWK_LOGICAL_LINK_UP = 0x1UL
} NTWK_LOGICAL_LINK;

// --- IOCTL_MAC_TYPE_ENUM ---
// This enum defines the types of MAC addresses in the RXF MAC Address Table. 
#define MAC_ADDRESS_TYPE_STORAGE        (0)       // Storage MAC Address 
#define MAC_ADDRESS_TYPE_NETWORK        (1)       // Network MAC Address 
#define MAC_ADDRESS_TYPE_PD             (2)       // Protection Domain MAC Address 
#define MAC_ADDRESS_TYPE_MANAGEMENT     (3)       // Managment MAC Address 
#define MAC_ADDRESS_TYPE_FCOE           (4)       // FCoE MAC Address 
#define MAC_ADDRESS_TYPE_STARTING_MAC   (8)       // Starting MAC address for the HBA.
                                                  // This address is stored on SEEPROM.
                                                  // All PCI functions derive their MAC
                                                  // addresses from this starting value by
                                                  // adding the per-function MAC index
                                                  // (also stored on SEEPROM). While all
                                                  // boards/LOMs can be queried for the
                                                  // starting MAC address, the factory-set
                                                  // value stored on SEEPROM can be
                                                  // overwritten only on a limited set of
                                                  // IPLs. 
#define MAC_ADDRESS_TYPE_SEEPROM_DEFAULT (9)      // The board default MAC address which
                                                  // is stored on SEEPROM. The enum can
                                                  // ONLY be used to query the MAC
                                                  // addresses for all the supported PCI
                                                  // functions. 

typedef enum {
   ENUM_MAC_ADDRESS_TYPE_STORAGE = 0x0UL,
   ENUM_MAC_ADDRESS_TYPE_NETWORK = 0x1UL,
   ENUM_MAC_ADDRESS_TYPE_PD = 0x2UL,
   ENUM_MAC_ADDRESS_TYPE_MANAGEMENT = 0x3UL,
   ENUM_MAC_ADDRESS_TYPE_FCOE = 0x4UL,
   ENUM_MAC_ADDRESS_TYPE_STARTING_MAC = 0x8UL,
   ENUM_MAC_ADDRESS_TYPE_SEEPROM_DEFAULT = 0x9UL
} IOCTL_MAC_TYPE_ENUM;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* ioctl_mac_type_enum_get_name (u32 enum_value) {
      switch (enum_value) {
         case MAC_ADDRESS_TYPE_STORAGE:
            return "MAC_ADDRESS_TYPE_STORAGE";
         case MAC_ADDRESS_TYPE_NETWORK:
            return "MAC_ADDRESS_TYPE_NETWORK";
         case MAC_ADDRESS_TYPE_PD:
            return "MAC_ADDRESS_TYPE_PD";
         case MAC_ADDRESS_TYPE_MANAGEMENT:
            return "MAC_ADDRESS_TYPE_MANAGEMENT";
         case MAC_ADDRESS_TYPE_FCOE:
            return "MAC_ADDRESS_TYPE_FCOE";
         case MAC_ADDRESS_TYPE_STARTING_MAC:
            return "MAC_ADDRESS_TYPE_STARTING_MAC";
         case MAC_ADDRESS_TYPE_SEEPROM_DEFAULT:
            return "MAC_ADDRESS_TYPE_SEEPROM_DEFAULT";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- QNQ_INNER_TAG ---
// In the QnQ mode, it is possible for the interface to request ONE tag instead of a
// tag-pair. 
#define QNQ_INNER_INVALID               (65534)   
#define QNQ_OUTER_INVALID               (65535)   

typedef enum {
   ENUM_QNQ_INNER_INVALID = 0xfffeUL,
   ENUM_QNQ_OUTER_INVALID = 0xffffUL
} QNQ_INNER_TAG;

// --- BE2_RXF_IF_FLAGS_ENUM ---
#define BE2_RXF_IF_FLAGS_RSS            (4)       // Set to enable RSS capability. Only 2
                                                  // interfaces per adapter are capable of
                                                  // RSS. Clear to disable RSS capability.
#define BE2_RXF_IF_FLAGS_PROMISCUOUS    (8)       // Set to enable promiscuous reception
                                                  // of all packets. Valid option only if
                                                  // RSS capability is enabled as well.
                                                  // Clear to apply normal filtering rules
                                                  // to all packets. 
#define BE2_RXF_IF_FLAGS_BROADCAST      (16)      // Set to enable reception of broadcast
                                                  // and unfiltered multicast packets.
                                                  // Clear to disable reception of
                                                  // broadcast and unfiltered multicast
                                                  // packets. 
#define BE2_RXF_IF_FLAGS_UNTAGGED       (32)      // Set to enable reception of untagged
                                                  // packets. Clear to disable reception
                                                  // of untagged packets. 
#define BE2_RXF_IF_FLAGS_ULP            (64)      // Interface is for a particular ULP.
                                                  // Currently undefined. 
#define BE2_RXF_IF_FLAGS_VLAN_PROMISCUOUS (128)   // Set to enable VLAN promiscuous mode.
                                                  // Clear to disable VLAN promiscuous
                                                  // mode. 
#define BE2_RXF_IF_FLAGS_VLAN           (256)     // Set to use a VLAN identifier tag.
                                                  // Clear to not use a VLAN identifier
                                                  // tag. 
#define BE2_RXF_IF_FLAGS_MCAST_PROMISCUOUS (512)  // Set to request multicast promiscuous
                                                  // mode. Clear to disable multicast
                                                  // promiscuous mode. 
#define BE2_RXF_IF_FLAGS_PASS_L2_ERRORS (1024)    // Set to request reception of packets
                                                  // which fail L2 checks (ie. ethernet
                                                  // length, CRC32, etc.). Clear to
                                                  // disable reception of packets which
                                                  // fail L2 checks. 
#define BE2_RXF_IF_FLAGS_PASS_L3L4_ERRORS (2048)  // Set to request reception of packets
                                                  // which fail L3/L4 checks (ie. header
                                                  // lengths, checksum, etc.). Clear to
                                                  // disable reception of packets which
                                                  // fail L3/L4 checks. 

typedef enum {
   ENUM_BE2_RXF_IF_FLAGS_RSS = 0x4UL,
   ENUM_BE2_RXF_IF_FLAGS_PROMISCUOUS = 0x8UL,
   ENUM_BE2_RXF_IF_FLAGS_BROADCAST = 0x10UL,
   ENUM_BE2_RXF_IF_FLAGS_UNTAGGED = 0x20UL,
   ENUM_BE2_RXF_IF_FLAGS_ULP = 0x40UL,
   ENUM_BE2_RXF_IF_FLAGS_VLAN_PROMISCUOUS = 0x80UL,
   ENUM_BE2_RXF_IF_FLAGS_VLAN = 0x100UL,
   ENUM_BE2_RXF_IF_FLAGS_MCAST_PROMISCUOUS = 0x200UL,
   ENUM_BE2_RXF_IF_FLAGS_PASS_L2_ERRORS = 0x400UL,
   ENUM_BE2_RXF_IF_FLAGS_PASS_L3L4_ERRORS = 0x800UL,
} BE2_RXF_IF_FLAGS_ENUM;

// --- TEMPLATE_HEADER_TYPE_ENUM ---
#define TEMPLATE_HEADER_TYPE_ISCSI      (1)       
#define TEMPLATE_HEADER_TYPE_TOE        (2)       
#define TEMPLATE_HEADER_TYPE_RDMA       (3)       

typedef enum {
   ENUM_TEMPLATE_HEADER_TYPE_ISCSI = 0x1UL,
   ENUM_TEMPLATE_HEADER_TYPE_TOE = 0x2UL,
   ENUM_TEMPLATE_HEADER_TYPE_RDMA = 0x3UL
} TEMPLATE_HEADER_TYPE_ENUM;

// --- IOCTL_RING_TYPE_ENUM ---
#define IOCTL_RING_TYPE_ETH_RX          (1)       // Ring created with
                                                  // IOCTL_ETH_RX_CREATE.
#define IOCTL_RING_TYPE_ETH_TX          (2)       // Ring created with
                                                  // IOCTL_ETH_TX_CREATE.
#define IOCTL_RING_TYPE_ISCSI_WRBQ      (3)       // Ring created with
                                                  // IOCTL_COMMON_ISCSI_WRBQ_CREATE.
#define IOCTL_RING_TYPE_ISCSI_DEFQ      (4)       // Ring created with
                                                  // IOCTL_COMMON_ISCSI_DEFQ_CREATE.
#define IOCTL_RING_TYPE_TOE_WRBQ        (5)       // Ring created with
                                                  // IOCTL_TOE_WRBQ_CREATE.
#define IOCTL_RING_TYPE_TOE_DEFQ        (6)       // Ring created with
                                                  // IOCTL_TOE_DEFQ_CREATE.
#define IOCTL_RING_TYPE_TOE_RQ          (7)       // Ring created with
                                                  // IOCTL_TOE_RQ_CREATE.
#define IOCTL_RING_TYPE_MCC             (8)       // Ring created with
                                                  // IOCTL_COMMON_MCC_CREATE.
#define IOCTL_RING_TYPE_CQ              (9)       // Ring created with
                                                  // IOCTL_COMMON_CQ_CREATE.
#define IOCTL_RING_TYPE_EQ              (10)      // Ring created with
                                                  // IOCTL_COMMON_EQ_CREATE.
#define IOCTL_RING_TYPE_QP              (11)      // Ring created with
                                                  // IOCTL_RDMA_QP_CREATE.
#define IOCTL_RING_TYPE_FCOE_WRBQ       (12)      // Ring created with
                                                  // IOCTL_FCOE_WRBQ_CREATE.
#define IOCTL_RING_TYPE_LRO             (13)      // Ring created with
                                                  // IOCTL_LRO_RING_CREATE.
#define IOCTL_RING_TYPE_FCOE_DEFQ       (14)      // Ring created with
                                                  // IOCTL_COMMON_FCOE_DEFQ_CREATE.
#define IOCTL_RING_TYPE_DAL             (15)      // Pseudo-ring for DAL BID allocation
#define IOCTL_RING_TYPE_DAL_TX          (16)      // Ring created with
                                                  // IOCTL_DAL_QP_MODIFY_RTS.
#define IOCTL_RING_TYPE_DAL_RX          (17)      // Ring created with
                                                  // IOCTL_DAL_QP_MODIFY_RTR.

typedef enum {
   ENUM_IOCTL_RING_TYPE_ETH_RX = 0x1UL,
   ENUM_IOCTL_RING_TYPE_ETH_TX = 0x2UL,
   ENUM_IOCTL_RING_TYPE_ISCSI_WRBQ = 0x3UL,
   ENUM_IOCTL_RING_TYPE_ISCSI_DEFQ = 0x4UL,
   ENUM_IOCTL_RING_TYPE_TOE_WRBQ = 0x5UL,
   ENUM_IOCTL_RING_TYPE_TOE_DEFQ = 0x6UL,
   ENUM_IOCTL_RING_TYPE_TOE_RQ = 0x7UL,
   ENUM_IOCTL_RING_TYPE_MCC = 0x8UL,
   ENUM_IOCTL_RING_TYPE_CQ = 0x9UL,
   ENUM_IOCTL_RING_TYPE_EQ = 0xaUL,
   ENUM_IOCTL_RING_TYPE_QP = 0xbUL,
   ENUM_IOCTL_RING_TYPE_FCOE_WRBQ = 0xcUL,
   ENUM_IOCTL_RING_TYPE_LRO = 0xdUL,
   ENUM_IOCTL_RING_TYPE_FCOE_DEFQ = 0xeUL,
   ENUM_IOCTL_RING_TYPE_DAL = 0xfUL,
   ENUM_IOCTL_RING_TYPE_DAL_TX = 0x10UL,
   ENUM_IOCTL_RING_TYPE_DAL_RX = 0x11UL
} IOCTL_RING_TYPE_ENUM;

// --- IOCTL_COMMON_QOS_TYPE_ENUM ---
#define QOS_BITS_NIC                    (1)       // The max_bits_per_second_NIC field is
                                                  // valid. 
#define QOS_PKTS_NIC                    (2)       // The max_packets_per_second_NIC field
                                                  // is valid. 
#define QOS_IOPS_ISCSI                  (4)       // The max_ios_per_second_iSCSI field is
                                                  // valid. 
#define QOS_VLAN_TAG                    (8)       // The domain_VLAN_tag field is valid. 
#define QOS_FABRIC_ID                   (16)      // The fabric_domain_ID field is valid. 
#define QOS_OEM_PARAMS                  (32)      // The qos_params_oem field is valid. 
#define QOS_TPUT_ISCSI                  (64)      // The max_bytes_per_second_iSCSI field
                                                  // is valid. 

typedef enum {
   ENUM_QOS_BITS_NIC = 0x1UL,
   ENUM_QOS_PKTS_NIC = 0x2UL,
   ENUM_QOS_IOPS_ISCSI = 0x4UL,
   ENUM_QOS_VLAN_TAG = 0x8UL,
   ENUM_QOS_FABRIC_ID = 0x10UL,
   ENUM_QOS_OEM_PARAMS = 0x20UL,
   ENUM_QOS_TPUT_ISCSI = 0x40UL
} IOCTL_COMMON_QOS_TYPE_ENUM;

// --- MGMT_FLASHROM_OPCODE ---
// Flash ROM operation code 
#define MGMT_FLASHROM_OPCODE_FLASH      (1)       // Commit downloaded data to Flash ROM.
                                                  // Data sent with this IOCTL, if any, is
                                                  // appended to data received so far
                                                  // (could be zero), before issuing a
                                                  // flash to ROM.The offset field in this
                                                  // IOCTL is ignored. 
#define MGMT_FLASHROM_OPCODE_SAVE       (2)       // Save downloaded data to ARM's DDR.
                                                  // The offset field in the IOCTL is
                                                  // ignored. When enough data is
                                                  // collected for one block size of flash
                                                  // then commit it down to Flash. The
                                                  // offset on flash is assumed to be zero
                                                  // for the first call with opcode
                                                  // MGMT_FLASHROM_OPCODE_SAVE (or
                                                  // immediately after a call to
                                                  // MGMT_FLASHROM_OPCODE_FLASH).
                                                  // Successive calls with
                                                  // MGMT_FLASHROM_OPCODE_SAVE advance the
                                                  // offset by the bytes received in the
                                                  // previous call. When the caller is
                                                  // done sending all the data for a
                                                  // MGMT_FLASHROM_OPTYPE, this IOCTL must
                                                  // be issued with the
                                                  // MGMT_FLASHROM_OPCODE_FLASH to flush
                                                  // the last chunk of data to flash. 
#define MGMT_FLASHROM_OPCODE_CLEAR      (3)       // Erase specified component from Flash
                                                  // ROM
#define MGMT_FLASHROM_OPCODE_REPORT     (4)       // Read specified component from Flash
                                                  // ROM
#define MGMT_FLASHROM_OPCODE_IMAGE_INFO (5)       // Returns size of a component
#define MGMT_FLASHROM_OPCODE_IMAGE_CRC  (6)       // Returns the stored CRC and calculated
                                                  // CRC for a component. Also informs the
                                                  // caller whether the calculated and the
                                                  // read CRC matches or not.
#define MGMT_FLASHROM_OPCODE_OFFSET_BASED_FLASH (7) // Commit downloaded data to Flash
                                                    // ROM. Data sent with this IOCTL, if
                                                    // any, is to be written at the
                                                    // specified offset It is the caller's
                                                    // responsibility to specify the
                                                    // correct offset. 
#define MGMT_FLASHROM_OPCODE_OFFSET_BASED_SAVE (8) // Save downloaded data to ARM's DDR.
                                                   // The data is received is intended for
                                                   // the flash offset specified. When one
                                                   // (flash) sector size of data is
                                                   // collected, it may be committed to
                                                   // flash if there's insufficient memory
                                                   // to stage all of the data being sent.
#define MGMT_PHY_FLASHROM_OPCODE_FLASH  (9)       // Commit downloaded data to Flash ROM.
                                                  // Data sent with this IOCTL, if any, is
                                                  // appended to data received so far
                                                  // (could be zero), before issuing a
                                                  // flash to ROM.The offset field in this
                                                  // IOCTL is ignored. 
#define MGMT_PHY_FLASHROM_OPCODE_SAVE   (10)      // Save downloaded data to ARM's DDR.
                                                  // The offset field in the IOCTL is
                                                  // ignored. When enough data is
                                                  // collected for one block size of flash
                                                  // then commit it down to Flash. The
                                                  // offset on flash is assumed to be zero
                                                  // for the first call with opcode
                                                  // MGMT_PHY_FLASHROM_OPCODE_SAVE (or
                                                  // immediately after a call to
                                                  // MGMT_PHY_FLASHROM_OPCODE_FLASH).
                                                  // Successive calls with
                                                  // MGMT_PHY_FLASHROM_OPCODE_SAVE advance
                                                  // the offset by the bytes received in
                                                  // the previous call. When the caller is
                                                  // done sending all the data for a
                                                  // MGMT_FLASHROM_OPTYPE, this IOCTL must
                                                  // be issued with the
                                                  // MGMT_PHY_FLASHROM_OPCODE_FLASH to
                                                  // flush the last chunk of data to
                                                  // flash. 

typedef enum {
   ENUM_MGMT_FLASHROM_OPCODE_FLASH = 0x1UL,
   ENUM_MGMT_FLASHROM_OPCODE_SAVE = 0x2UL,
   ENUM_MGMT_FLASHROM_OPCODE_CLEAR = 0x3UL,
   ENUM_MGMT_FLASHROM_OPCODE_REPORT = 0x4UL,
   ENUM_MGMT_FLASHROM_OPCODE_IMAGE_INFO = 0x5UL,
   ENUM_MGMT_FLASHROM_OPCODE_IMAGE_CRC = 0x6UL,
   ENUM_MGMT_FLASHROM_OPCODE_OFFSET_BASED_FLASH = 0x7UL,
   ENUM_MGMT_FLASHROM_OPCODE_OFFSET_BASED_SAVE = 0x8UL,
   ENUM_MGMT_PHY_FLASHROM_OPCODE_FLASH = 0x9UL,
   ENUM_MGMT_PHY_FLASHROM_OPCODE_SAVE = 0xaUL
} MGMT_FLASHROM_OPCODE;

// --- MGMT_FLASHROM_OPTYPE ---
// Flash ROM operation type 
#define MGMT_FLASHROM_OPTYPE_CODE_iSCSI_FW_ACTIVE (0) // Includes ARM firmware, IPSec
                                                      // (optional) and EP firmware 
#define MGMT_FLASHROM_OPTYPE_CODE_REDBOOT (1)     
#define MGMT_FLASHROM_OPTYPE_CODE_BIOS  (2)       // Implies iSCSI BIOS only 
#define MGMT_FLASHROM_OPTYPE_CODE_PXE_BIOS (3)    
#define MGMT_FLASHROM_OPTYPE_CODE_CTRLS (4)       
#define MGMT_FLASHROM_OPTYPE_CFG_IPSEC  (5)       
#define MGMT_FLASHROM_OPTYPE_CFG_INI    (6)       
#define MGMT_FLASHROM_OPTYPE_ROM_OFFSET_SPECIFIED (7) // TBD 
#define MGMT_FLASHROM_OPTYPE_CODE_FCOE_BIOS (8)   
#define MGMT_FLASHROM_OPTYPE_CODE_iSCSI_FW_BACKUP (9) 
#define MGMT_FLASHROM_OPTYPE_CODE_FCOE_FW_ACTIVE (10) 
#define MGMT_FLASHROM_OPTYPE_CODE_FCOE_FW_BACKUP (11) 
#define MGMT_FLASHROM_OPTYPE_CODE_CTRLP (12)      
#define MGMT_FLASHROM_OPTYPE_CODE_NCSI_FW (13)    
#define MGMT_FLASHROM_OPTYPE_CFG_NIC    (14)      
#define MGMT_FLASHROM_OPTYPE_CFG_DCBX   (15)      
#define MGMT_FLASHROM_OPTYPE_CFG_PXE_BIOS (16)    
#define MGMT_FLASHROM_OPTYPE_CFG_ALL    (17)      
#define MGMT_FLASHROM_OPTYPE_CODE_PHY_FW (18)     

typedef enum {
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_iSCSI_FW_ACTIVE = 0x0UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_REDBOOT = 0x1UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_BIOS = 0x2UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_PXE_BIOS = 0x3UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_CTRLS = 0x4UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_IPSEC = 0x5UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_INI = 0x6UL,
   ENUM_MGMT_FLASHROM_OPTYPE_ROM_OFFSET_SPECIFIED = 0x7UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_FCOE_BIOS = 0x8UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_iSCSI_FW_BACKUP = 0x9UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_FCOE_FW_ACTIVE = 0xaUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_FCOE_FW_BACKUP = 0xbUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_CTRLP = 0xcUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_NCSI_FW = 0xdUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_NIC = 0xeUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_DCBX = 0xfUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_PXE_BIOS = 0x10UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_ALL = 0x11UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_PHY_FW = 0x12UL
} MGMT_FLASHROM_OPTYPE;

// --- NTWK_RX_FILTER_IF_FLAGS_ENUM ---
#define NTWK_RX_FILTER_IF_PROMISCUOUS   (8)       // Set to enable promiscuous mode. Clear
                                                  // to disable promiscuous mode. 
#define NTWK_RX_FILTER_IF_BROADCAST     (16)      // Set to enable broadcast packet
                                                  // reception. Clear to disable broadcast
                                                  // packet reception. 
#define NTWK_RX_FILTER_IF_UNTAGGED      (32)      // Set to enable untagged VLAN matching.
                                                  // Clear to disable untagged VLAN
                                                  // matching. 
#define NTWK_RX_FILTER_IF_VLAN_PROMISCUOUS (128)  // Set to enable VLAN promiscuos mode.
                                                  // Clear to disable VLAN promiscuous
                                                  // mode. 
#define NTWK_RX_FILTER_IF_MCAST_PROMISCUOUS (512) // Set to enable multicast promiscuous
                                                  // mode. Clear to disable multicast
                                                  // promiscuous mode. 
#define NTWK_RX_FILTER_IF_PASS_L2_ERRORS (1024)   // Set to enable passing L2 error
                                                  // packets. Clear to disable passing L2
                                                  // error packets. 
#define NTWK_RX_FILTER_IF_PASS_L3L4_ERRORS (2048) // Set to enable passing L3/L4 errors.
                                                  // Clear to disable passing L3/L4
                                                  // errors. 
#define NTWK_RX_FILTER_IF_MULTICAST     (4096)    // Set to apply the perfect multicast
                                                  // MAC address list. This flag is
                                                  // mutually exclusive with
                                                  // NTWK_RX_FILTER_IF_MULTICAST. 
#define NTWK_RX_FILTER_IF_MULTICAST_HASH (8192)   // Set to apply the perfect multicast
                                                  // MAC address list. This flag is
                                                  // mutually exclusive with
                                                  // NTWK_RX_FILTER_IF_MULTICAST_HASH. 
#define NTWK_RX_FILTER_IF_HEADER_SPLIT  (16384)   // Set to allow header split to operate
                                                  // on all Ethernet RX rings created with
                                                  // header split enabled. Clear this flag
                                                  // to temporarily disable header split,
                                                  // causing all packets to arrive as
                                                  // non-split. 

typedef enum {
   ENUM_NTWK_RX_FILTER_IF_PROMISCUOUS = 0x8UL,
   ENUM_NTWK_RX_FILTER_IF_BROADCAST = 0x10UL,
   ENUM_NTWK_RX_FILTER_IF_UNTAGGED = 0x20UL,
   ENUM_NTWK_RX_FILTER_IF_VLAN_PROMISCUOUS = 0x80UL,
   ENUM_NTWK_RX_FILTER_IF_MCAST_PROMISCUOUS = 0x200UL,
   ENUM_NTWK_RX_FILTER_IF_PASS_L2_ERRORS = 0x400UL,
   ENUM_NTWK_RX_FILTER_IF_PASS_L3L4_ERRORS = 0x800UL,
   ENUM_NTWK_RX_FILTER_IF_MULTICAST = 0x1000UL,
   ENUM_NTWK_RX_FILTER_IF_MULTICAST_HASH = 0x2000UL,
   ENUM_NTWK_RX_FILTER_IF_HEADER_SPLIT = 0x4000UL
} NTWK_RX_FILTER_IF_FLAGS_ENUM;

// --- NTWK_RX_FILTER_FLAGS_ENUM ---
#define NTWK_RX_FILTER_IP_CKSUM         (1)       // Set to enable IP checksum. Clear to
                                                  // disable IP checksum. 
#define NTWK_RX_FILTER_TCP_CKSUM        (2)       // Set to enable TCP checksum. Clear to
                                                  // disable TCP checksum. 
#define NTWK_RX_FILTER_UDP_CKSUM        (4)       // Set to enable UDP checksum. Clear to
                                                  // disable UDP checksum. 
#define NTWK_RX_FILTER_STRIP_CRC        (8)       // Set to strip the Ethernet CRC from
                                                  // packet data. Clear to leave the
                                                  // Ethernt CRC as packet data. 

typedef enum {
   ENUM_NTWK_RX_FILTER_IP_CKSUM = 0x1UL,
   ENUM_NTWK_RX_FILTER_TCP_CKSUM = 0x2UL,
   ENUM_NTWK_RX_FILTER_UDP_CKSUM = 0x4UL,
   ENUM_NTWK_RX_FILTER_STRIP_CRC = 0x8UL
} NTWK_RX_FILTER_FLAGS_ENUM;

// --- MANAGE_FAT ---
#define RETRIEVE_FAT                    (0)       // Previously logged FAT data will
                                                  // returned in data_buffer parameter. 
#define QUERY_FAT                       (1)       // Check for the presence or absence of
                                                  // FAT data logged in the flash memory.
                                                  // The log_size field in the response
                                                  // will advertize the size of FAT data. 
#define CLEAR_FAT                       (2)       // Erase any previously logged FAT data.
#define TRIGGER_FAT                     (3)       // Trigger FAT execution. This operation
                                                  // will result in the adapter being
                                                  // inoperable once FAT execution begins.
                                                  // Expected use case is to trigger a
                                                  // state capture of the adapter. No
                                                  // completion will be sent if this
                                                  // operation is initiated. The issuing
                                                  // driver should poll the POST register.
                                                  // When the POST status code shows
                                                  // POST_STAGE_ARMFW_UE and
                                                  // POST_STAGE_FAT_LOG_END ARMfw has
                                                  // completed the FAT log. The adapter
                                                  // must be reset before it is
                                                  // operational and FAT log may be
                                                  // retrieved. 

typedef enum {
   ENUM_RETRIEVE_FAT = 0x0UL,
   ENUM_QUERY_FAT = 0x1UL,
   ENUM_CLEAR_FAT = 0x2UL,
   ENUM_TRIGGER_FAT = 0x3UL
} MANAGE_FAT;

// --- ENABLE_DISABLE_DOMAINS_ENUM ---
#define DISABLE_DOMAIN                  (0)       // Disable this domain.
#define ENABLE_DOMAIN                   (1)       // Enable this domain

typedef enum {
   ENUM_DISABLE_DOMAIN = 0x0UL,
   ENUM_ENABLE_DOMAIN = 0x1UL
} ENABLE_DISABLE_DOMAINS_ENUM;

// --- DOMAIN_FUNCTION_ENUM ---
#define ISCSI_DOMAIN                    (0)       // This domain's iSCSI functionality.
#define NIC_TOE_DOMAIN                  (1)       // This domain's NIC/TOE functionality.

typedef enum {
   ENUM_ISCSI_DOMAIN = 0x0UL,
   ENUM_NIC_TOE_DOMAIN = 0x1UL
} DOMAIN_FUNCTION_ENUM;

// --- BE_CHIP_REVISION ---
#define BE_REV_A0                       (0)       
#define BE_REV_A1                       (1)       
#define BE_REV_A2                       (2)       

typedef enum {
   ENUM_BE_REV_A0 = 0x0UL,
   ENUM_BE_REV_A1 = 0x1UL,
   ENUM_BE_REV_A2 = 0x2UL
} BE_CHIP_REVISION;

// --- BE_ASIC_REVISION ---
#define BE_ASIC_REV_A0                  (0)       
#define BE_ASIC_REV_A1                  (1)       
#define BE_ASIC_REV_A2                  (2)       

typedef enum {
   ENUM_BE_ASIC_REV_A0 = 0x0UL,
   ENUM_BE_ASIC_REV_A1 = 0x1UL,
   ENUM_BE_ASIC_REV_A2 = 0x2UL
} BE_ASIC_REVISION;

// --- ULP_SUPPORTED_MODES ---
#define ULP_TOE_MODE                    (1)       
#define ULP_NIC_MODE                    (2)       
#define ULP_RDMA_MODE                   (4)       
#define ULP_ISCSI_INI_MODE              (16)      
#define ULP_ISCSI_TGT_MODE              (32)      
#define ULP_FCOE_INI_MODE               (64)      
#define ULP_FCOE_TGT_MODE               (128)     
#define ULP_DAL_MODE                    (256)     
#define ULP_LRO_MODE                    (512)     

typedef enum {
   ENUM_ULP_TOE_MODE = 0x1UL,
   ENUM_ULP_NIC_MODE = 0x2UL,
   ENUM_ULP_RDMA_MODE = 0x4UL,
   ENUM_ULP_ISCSI_INI_MODE = 0x10UL,
   ENUM_ULP_ISCSI_TGT_MODE = 0x20UL,
   ENUM_ULP_FCOE_INI_MODE = 0x40UL,
   ENUM_ULP_FCOE_TGT_MODE = 0x80UL,
   ENUM_ULP_DAL_MODE = 0x100UL,
   ENUM_ULP_LRO_MODE = 0x200UL
} ULP_SUPPORTED_MODES;

// --- BE_FUNCTION_CAPS ---
#define BE_FUNCTION_CAPS_UNCLASSIFIED_STATS (1)   
#define BE_FUNCTION_CAPS_RSS            (2)       
#define BE_FUNCTION_CAPS_PROMISCUOUS    (4)       
#define BE_FUNCTION_CAPS_LEGACY_MODE    (8)       

typedef enum {
   ENUM_BE_FUNCTION_CAPS_UNCLASSIFIED_STATS = 0x1UL,
   ENUM_BE_FUNCTION_CAPS_RSS = 0x2UL,
   ENUM_BE_FUNCTION_CAPS_PROMISCUOUS = 0x4UL,
   ENUM_BE_FUNCTION_CAPS_LEGACY_MODE = 0x8UL
} BE_FUNCTION_CAPS;

// --- BE_PORT_NUM ---
#define BE_PORT0                        (1)       
#define BE_PORT1                        (2)       

typedef enum {
   ENUM_BE_PORT0 = 0x1UL,
   ENUM_BE_PORT1 = 0x2UL
} BE_PORT_NUM;

// --- BE_PORT_CHANNEL_NUM ---
// Each BE port has 4 lanes/channels 
#define BE_PORT_CHANNEL0                (1)       
#define BE_PORT_CHANNEL1                (2)       
#define BE_PORT_CHANNEL2                (4)       
#define BE_PORT_CHANNEL3                (8)       

typedef enum {
   ENUM_BE_PORT_CHANNEL0 = 0x1UL,
   ENUM_BE_PORT_CHANNEL1 = 0x2UL,
   ENUM_BE_PORT_CHANNEL2 = 0x4UL,
   ENUM_BE_PORT_CHANNEL3 = 0x8UL
} BE_PORT_CHANNEL_NUM;

// --- EQ_EMP ---

#define EQUALIZATION                    (1)       
#define EMPHASIS                        (2)       

typedef enum {
   ENUM_EQUALIZATION = 0x1UL,
   ENUM_EMPHASIS = 0x2UL
} EQ_EMP;

// --- RED_BLOCK ---
#define RED_BLOCK_ULP0                  (1)       
#define RED_BLOCK_ULP1                  (2)       
#define RED_BLOCK_ULP2                  (4)       
#define RED_BLOCK_ETH                   (8)       
#define RED_BLOCK_LRO                   (16)      
#define RED_BLOCK_GLOBAL                (32)      

typedef enum {
   ENUM_RED_BLOCK_ULP0 = 0x1UL,
   ENUM_RED_BLOCK_ULP1 = 0x2UL,
   ENUM_RED_BLOCK_ULP2 = 0x4UL,
   ENUM_RED_BLOCK_ETH = 0x8UL,
   ENUM_RED_BLOCK_LRO = 0x10UL,
   ENUM_RED_BLOCK_GLOBAL = 0x20UL
} RED_BLOCK;

// --- CONNECTION_UPLOAD_PARAMS ---
// These parameters are used to define the type of upload desired. 
#define CONNECTION_UPLOAD_GRACEFUL      (1)       // Graceful upload 
#define CONNECTION_UPLOAD_ABORT_RESET   (2)       // Abortive upload with reset 
#define CONNECTION_UPLOAD_ABORT         (3)       // Abortive upload without reset 
#define CONNECTION_UPLOAD_ABORT_WITH_SEQ (4)      // Abortive upload with reset, sequence
                                                  // number by driver 

typedef enum {
   ENUM_CONNECTION_UPLOAD_GRACEFUL = 0x1UL,
   ENUM_CONNECTION_UPLOAD_ABORT_RESET = 0x2UL,
   ENUM_CONNECTION_UPLOAD_ABORT = 0x3UL,
   ENUM_CONNECTION_UPLOAD_ABORT_WITH_SEQ = 0x4UL
} CONNECTION_UPLOAD_PARAMS;

// --- BOOT_STATUS ---
#define BOOT_DISABLED                   (0)       // PXE/iSCSI/FCoE boot on the requested
                                                  // PCI function is disabled /should be
                                                  // disabled
#define BOOT_ENABLED                    (1)       // PXE/iSCSI/FCoE boot on the requested
                                                  // PCI function is enabled / should be
                                                  // enabled

typedef enum {
   ENUM_BOOT_DISABLED = 0x0UL,
   ENUM_BOOT_ENABLED = 0x1UL
} BOOT_STATUS;

// --- BIOS_INSTANCE ---
#define BIOS_INSTANCE_ONE_PER_SYSTEM    (1)       // One instance of expansion BIOS
                                                  // controls all BE functions in the
                                                  // system
#define BIOS_INSTANCE_ONE_PER_FUNC      (1)       // One instance of expansion BIOS loads
                                                  // for each eligible BE function 

typedef enum {
   ENUM_BIOS_INSTANCE_ONE_PER_SYSTEM = 0x1UL,
   ENUM_BIOS_INSTANCE_ONE_PER_FUNC = 0x1UL
} BIOS_INSTANCE;

// --- BEACON_STATE_ENUM ---
#define BEACON_STATE_DISABLED           (0)       
#define BEACON_STATE_ENABLED            (1)       // Enable blinking of LED on HBA bracket

typedef enum {
   ENUM_BEACON_STATE_DISABLED = 0x0UL,
   ENUM_BEACON_STATE_ENABLED = 0x1UL
} BEACON_STATE_ENUM;

// --- TRANS_RECV_PAGE_NUM ---
#define TR_PAGE_A0                      (160)     
#define TR_PAGE_A2                      (162)     

typedef enum {
   ENUM_TR_PAGE_A0 = 0xa0UL,
   ENUM_TR_PAGE_A2 = 0xa2UL
} TRANS_RECV_PAGE_NUM;

// --- PERSONALITY ---
#define PERSONALITY_NIC                 (0)       
#define PERSONALITY_ISCSI               (1)       // At the most two PFs can be assigned
                                                  // as iSCSI functions 
#define PERSONALITY_FCOE                (2)       // At the most two PFs can be assigned
                                                  // as FCoE functions 
#define PERSONALITY_RDMA                (3)       

typedef enum {
   ENUM_PERSONALITY_NIC = 0x0UL,
   ENUM_PERSONALITY_ISCSI = 0x1UL,
   ENUM_PERSONALITY_FCOE = 0x2UL,
   ENUM_PERSONALITY_RDMA = 0x3UL
} PERSONALITY;

// --- CONFIG_CHANGE_SOURCE ---

#define CONFIG_SIGNATURE_ISCSI_SELECT   (0)       // Configuration changes effected by
                                                  // iSCSISelect
#define CONFIG_SIGNATURE_MILI_WINDOWS   (1)       // Configuration changes effected by
                                                  // Windows MILI
#define CONFIG_SIGNATURE_MILI_LINUX     (2)       // Configuration changes effected by
                                                  // Linux MILI
#define CONFIG_SIGNATURE_MILI_ESX       (3)       // Configuration changes effected by ESX
                                                  // MILI
#define CONFIG_SIGNATURE_MILI_SOLARIS   (4)       // Configuration changes effected by
                                                  // Solaris MILI
#define CONFIG_SIGNATURE_MILI_OTHER     (5)       // Configuration changes effected by
                                                  // MILI running on an OS not listed
                                                  // above
#define CONFIG_SIGNATURE_PXE_SELECT     (6)       // Configuration changes effected by
                                                  // PXESelect

typedef enum {
   ENUM_CONFIG_SIGNATURE_ISCSI_SELECT = 0x0UL,
   ENUM_CONFIG_SIGNATURE_MILI_WINDOWS = 0x1UL,
   ENUM_CONFIG_SIGNATURE_MILI_LINUX = 0x2UL,
   ENUM_CONFIG_SIGNATURE_MILI_ESX = 0x3UL,
   ENUM_CONFIG_SIGNATURE_MILI_SOLARIS = 0x4UL,
   ENUM_CONFIG_SIGNATURE_MILI_OTHER = 0x5UL,
   ENUM_CONFIG_SIGNATURE_PXE_SELECT = 0x6UL
} CONFIG_CHANGE_SOURCE;

// --- FUNCTION_STATE ---
#define FUNCTION_STATE_ENABLED          (0)       
#define FUNCTION_STATE_DISABLED         (1)       
#define FUNCTION_STATE_INVALID          (255)     

typedef enum {
   ENUM_FUNCTION_STATE_ENABLED = 0x0UL,
   ENUM_FUNCTION_STATE_DISABLED = 0x1UL,
   ENUM_FUNCTION_STATE_INVALID = 0xffUL
} FUNCTION_STATE;

// --- FUNCTION_TYPE ---
#define FUNCTION_TYPE_NIC               (0)       
#define FUNCTION_TYPE_ISCSI             (1)       // At the most two PFs can be assigned
                                                  // as iSCSI functions 
#define FUNCTION_TYPE_FCOE              (2)       // At the most two PFs can be assigned
                                                  // as FCoE functions 
#define FUNCTION_TYPE_RDMA              (3)       
#define FUNCTION_TYPE_UNEXPECTED        (4)       
#define FUNCTION_TYPE_ILLEGAL           (255)     

typedef enum {
   ENUM_FUNCTION_TYPE_NIC = 0x0UL,
   ENUM_FUNCTION_TYPE_ISCSI = 0x1UL,
   ENUM_FUNCTION_TYPE_FCOE = 0x2UL,
   ENUM_FUNCTION_TYPE_RDMA = 0x3UL,
   ENUM_FUNCTION_TYPE_UNEXPECTED = 0x4UL,
   ENUM_FUNCTION_TYPE_ILLEGAL = 0xffUL
} FUNCTION_TYPE;

// --- SRIOV_STATE ---
#define SRIOV_STATE_DISABLED            (0)       
#define SRIOV_STATE_ENABLED             (1)       
#define SRIOV_STATE_INVALID             (255)     

typedef enum {
   ENUM_SRIOV_STATE_DISABLED = 0x0UL,
   ENUM_SRIOV_STATE_ENABLED = 0x1UL,
   ENUM_SRIOV_STATE_INVALID = 0xffUL
} SRIOV_STATE;

// --- RESOURCE_TYPE ---
#define RESOURCE_TYPE_PCIE              (0)       
#define RESOURCE_TYPE_NIC               (1)       
#define RESOURCE_TYPE_ISCSI             (2)       
#define RESOURCE_TYPE_FCOE              (3)       
#define RESOURCE_TYPE_RDMA              (4)       
#define RESOURCE_TYPE_UNEXPECTED        (5)       

typedef enum {
   ENUM_RESOURCE_TYPE_PCIE = 0x0UL,
   ENUM_RESOURCE_TYPE_NIC = 0x1UL,
   ENUM_RESOURCE_TYPE_ISCSI = 0x2UL,
   ENUM_RESOURCE_TYPE_FCOE = 0x3UL,
   ENUM_RESOURCE_TYPE_RDMA = 0x4UL,
   ENUM_RESOURCE_TYPE_UNEXPECTED = 0x5UL
} RESOURCE_TYPE;

// --- RESOURCE_STATE ---
#define RESOURCE_DATA_INVALID           (0)       // data in this record is invalid 
#define RESOURCE_DATA_VALID             (1)       // data in this record is valid 
#define RESOURCE_STATE_ILLEGAL          (4294967295) 

typedef enum {
   ENUM_RESOURCE_DATA_INVALID = 0x0UL,
   ENUM_RESOURCE_DATA_VALID = 0x1UL,
   ENUM_RESOURCE_STATE_ILLEGAL = 0xffffffffUL
} RESOURCE_STATE;

// --- VF_STATE ---
#define VF_INVALID                      (0)       // VFs are not enabled for this PF 
#define VF_VALID                        (1)       // VFs are enabled for this PF 
#define VF_STATE_ILLEGAL                (4294967295) 

typedef enum {
   ENUM_VF_INVALID = 0x0UL,
   ENUM_VF_VALID = 0x1UL,
   ENUM_VF_STATE_ILLEGAL = 0xffffffffUL
} VF_STATE;

// --- PCIE_VALID_FIELDS ---
#define PCIE_SRIOV_STATE_VALID          (1)       
#define PCIE_LINK_STATUS_VALID          (2)       

typedef enum {
   ENUM_PCIE_SRIOV_STATE_VALID = 0x1UL,
   ENUM_PCIE_LINK_STATUS_VALID = 0x2UL
} PCIE_VALID_FIELDS;

// --- NIC_VALID_FIELDS ---
#define NIC_BW_PERCENT_VALID            (1)       
#define NIC_VLAN_ID_VALID               (2)       

typedef enum {
   ENUM_NIC_BW_PERCENT_VALID = 0x1UL,
   ENUM_NIC_VLAN_ID_VALID = 0x2UL
} NIC_VALID_FIELDS;

// --- ISCSI_VALID_FIELDS ---
#define ISCSI_BW_PERCENT_VALID          (1)       
#define ISCSI_VLAN_ID_VALID             (2)       

typedef enum {
   ENUM_ISCSI_BW_PERCENT_VALID = 0x1UL,
   ENUM_ISCSI_VLAN_ID_VALID = 0x2UL
} ISCSI_VALID_FIELDS;

// --- FCOE_VALID_FIELDS ---
#define FCOE_BW_PERCENT_VALID           (1)       
#define FCOE_VLAN_ID_VALID              (2)       

typedef enum {
   ENUM_FCOE_BW_PERCENT_VALID = 0x1UL,
   ENUM_FCOE_VLAN_ID_VALID = 0x2UL
} FCOE_VALID_FIELDS;

// --- RDMA_VALID_FIELDS ---
#define RDMA_FIELD_1_VALID              (1)       
#define RDMA_FIELD_2_VALID              (2)       

typedef enum {
   ENUM_RDMA_FIELD_1_VALID = 0x1UL,
   ENUM_RDMA_FIELD_2_VALID = 0x2UL
} RDMA_VALID_FIELDS;

// --- CAPABILITIES ---
#define UMC_CAPABLE                     (1)       
#define SRIOV_CAPABLE                   (2)       
#define VNTAG_CAPABLE                   (4)       

typedef enum {
   ENUM_UMC_CAPABLE = 0x1UL,
   ENUM_SRIOV_CAPABLE = 0x2UL,
   ENUM_VNTAG_CAPABLE = 0x4UL
} CAPABILITIES;

// --- SWITCH_TYPE ---
#define ST_Normal                       (0)       
#define ST_VNIC                         (1)       
#define ST_VNTAG                        (2)       
#define ST_QBG                          (3)       

typedef enum {
   ENUM_ST_Normal = 0x0UL,
   ENUM_ST_VNIC = 0x1UL,
   ENUM_ST_VNTAG = 0x2UL,
   ENUM_ST_QBG = 0x3UL
} SWITCH_TYPE;

// --- TX_THROTTLE_SETTING ---
#define TX_THROTTLE_SETTING_UNDEF       (0)       // This is default setting which is same
                                                  // as TX_THROTTLE_SETTING_FAST 
#define TX_THROTTLE_SETTING_SLOW        (1)       // Slow reaction to PFC Pause 
#define TX_THROTTLE_SETTING_FAST        (2)       // Fast reaction to PFC Pause 
#define TX_THROTTLE_SETTING_MAX_ENUM    (3)       

typedef enum {
   ENUM_TX_THROTTLE_SETTING_UNDEF = 0x0UL,
   ENUM_TX_THROTTLE_SETTING_SLOW = 0x1UL,
   ENUM_TX_THROTTLE_SETTING_FAST = 0x2UL,
   ENUM_TX_THROTTLE_SETTING_MAX_ENUM = 0x3UL
} TX_THROTTLE_SETTING;

// --- PCI_FUNCTION_ASSIGNMENT ---
#define PCI_FUNCTION_UNASSIGNED         (0)       // This function is disabled 
#define PCI_FUNCTION_NIC_TOE            (1)       // NIC/TOE function 
#define PCI_FUNCTION_ISCSI_INI          (2)       // iSCSI Initiator 
#define PCI_FUNCTION_ISCSI_TGT          (3)       // iSCSI Target 
#define PCI_FUNCTION_FCOE               (4)       // FCoE Initiator or Target 
#define PCI_FUNCTION_RDMA               (5)       // RDMA function 

typedef enum {
   ENUM_PCI_FUNCTION_UNASSIGNED = 0x0UL,
   ENUM_PCI_FUNCTION_NIC_TOE = 0x1UL,
   ENUM_PCI_FUNCTION_ISCSI_INI = 0x2UL,
   ENUM_PCI_FUNCTION_ISCSI_TGT = 0x3UL,
   ENUM_PCI_FUNCTION_FCOE = 0x4UL,
   ENUM_PCI_FUNCTION_RDMA = 0x5UL
} PCI_FUNCTION_ASSIGNMENT;

// --- PERSONALITY_CHANGE_STATUS ---
#define PERSONALITY_NO_CHANGE           (0)       // A personality change  - Is not
                                                  // applicable to this BladeEngine  - Is
                                                  // applicable but never applied  - was
                                                  // applied earlier - no more reboots
                                                  // required for applying these changes 
#define PERSONALITY_CHANGED_REBOOT_REQUIRED (1)   // A personality change was requested
                                                  // since the last reboot/reset. The
                                                  // system must restarted for the change
                                                  // to take effect. 

typedef enum {
   ENUM_PERSONALITY_NO_CHANGE = 0x0UL,
   ENUM_PERSONALITY_CHANGED_REBOOT_REQUIRED = 0x1UL
} PERSONALITY_CHANGE_STATUS;

// --- NCSI_STATE ---
// NCSI state as reported by SEEPROM IPL data This does not necessarily mean that a 'Nemo'
// was detected on the board. 
#define NCSI_STATE_DISABLED             (0)       
#define NCSI_STATE_ENABLED              (1)       

typedef enum {
   ENUM_NCSI_STATE_DISABLED = 0x0UL,
   ENUM_NCSI_STATE_ENABLED = 0x1UL
} NCSI_STATE;

// --- NCSI_HANDSHAKE_STATUS ---
// At boot time, the ARM firmware attempts a handshake with the Nemo NCSI 8051 processor. 
#define NCSI_HANDSHAKE_SUCCESS          (0)       
#define NCSI_HANDSHAKE_FAILURE          (1)       

typedef enum {
   ENUM_NCSI_HANDSHAKE_SUCCESS = 0x0UL,
   ENUM_NCSI_HANDSHAKE_FAILURE = 0x1UL
} NCSI_HANDSHAKE_STATUS;

// --- NCSI_WOL_STATUS ---
#define NCSI_WOL_DISABLED               (0)       
#define NCSI_WOL_ENABLED                (1)       

typedef enum {
   ENUM_NCSI_WOL_DISABLED = 0x0UL,
   ENUM_NCSI_WOL_ENABLED = 0x1UL
} NCSI_WOL_STATUS;

// --- NCSI_PORT_SWAP ---
#define NCSI_NO_PORT_SWAP               (0)       
#define NCSI_PORT_SWAPPED               (1)       

typedef enum {
   ENUM_NCSI_NO_PORT_SWAP = 0x0UL,
   ENUM_NCSI_PORT_SWAPPED = 0x1UL
} NCSI_PORT_SWAP;

// --- SENSOR_TYPES ---
#define NO_SENSOR                       (0)       // No sensor. 
#define THERMAL_SENSOR_ON_DIE           (1)       // Thermal sensor on die. 
#define THERMOCOUPLE_SENSOR             (2)       // Thermocouple sensor. 
#define BOARD_POWER_SENSOR              (3)       // Board power sensor. 
#define CHIP_POWER_SENSOR               (4)       // Chip power sensor. 

typedef enum {
   ENUM_NO_SENSOR = 0x0UL,
   ENUM_THERMAL_SENSOR_ON_DIE = 0x1UL,
   ENUM_THERMOCOUPLE_SENSOR = 0x2UL,
   ENUM_BOARD_POWER_SENSOR = 0x3UL,
   ENUM_CHIP_POWER_SENSOR = 0x4UL
} SENSOR_TYPES;

// --- SENSOR_LOCATION ---
#define SENSOR_NOT_PRESENT              (0)       // Sensor not present. 
#define SENSOR_ON_ASIC                  (1)       // Sensor present on ASIC. 
#define SENSOR_NEAR_HOTTEST_PART        (2)       // Sensor near hottest part. 
#define SENSOR_ON_BOARD_NEAR_CONNECTOR  (3)       // Sensor on board near connector. 
#define SENSOR_ON_BOARD_NEAR_REAR_CONNECTOR (4)   // Sensor on board near rear connector. 
#define SENSOR_ON_BOARD_AT_OTHER_LOC    (5)       // Sensor on board at other location. 
#define SENSOR_OFFBOARD_SMART_ARRAY     (6)       // Smart array sensor. 

typedef enum {
   ENUM_SENSOR_NOT_PRESENT = 0x0UL,
   ENUM_SENSOR_ON_ASIC = 0x1UL,
   ENUM_SENSOR_NEAR_HOTTEST_PART = 0x2UL,
   ENUM_SENSOR_ON_BOARD_NEAR_CONNECTOR = 0x3UL,
   ENUM_SENSOR_ON_BOARD_NEAR_REAR_CONNECTOR = 0x4UL,
   ENUM_SENSOR_ON_BOARD_AT_OTHER_LOC = 0x5UL,
   ENUM_SENSOR_OFFBOARD_SMART_ARRAY = 0x6UL
} SENSOR_LOCATION;

// --- SENSOR_STATUS ---
#define SENSOR_ENABLED                  (1)       // Sensor is enabled. 
#define SENSOR_PRESENT                  (2)       // Sensor is present. 
#define SENSOR_FAILED                   (4)       // Sensor is failed. 
#define SENSOR_CHECKSUM                 (8)       // Sensor supports checksum. 

typedef enum {
   ENUM_SENSOR_ENABLED = 0x1UL,
   ENUM_SENSOR_PRESENT = 0x2UL,
   ENUM_SENSOR_FAILED = 0x4UL,
   ENUM_SENSOR_CHECKSUM = 0x8UL
} SENSOR_STATUS;

// --- SENSOR_TEMPERATURE_CFG ---
#define SENSOR_BYTE_SIGNED_DEGREES_C    (0)       // Byte signed degrees C -128 to 127. 
#define SENSOR_BYTE_SIGNED_5_DEGREES_C  (1)       // Byte signed .5 degrees C -0 to 127.5.
#define SENSOR_BYTE_UNSIGNED_DEGREES_C  (2)       // Byte unsigned degrees C 0 to 255. 
#define SENSOR_32BIT_SIGNED_DEGREES_C   (3)       // 32 bit signed degrees C -128 to 127. 
#define SENSOR_32BIT_SIGNED_5_DEGREES_C (4)       // 32 bit signed .5 degrees C -128 to
                                                  // 127. 
#define SENSOR_32BIT_UNSIGNED_DEGREES_C (5)       // 32 bit unsigned degrees C -128 to
                                                  // 127. 
#define SENSOR_RELATIVE_HEAT_SCALE      (6)       // Relative heat scale -128 to 127. 

typedef enum {
   ENUM_SENSOR_BYTE_SIGNED_DEGREES_C = 0x0UL,
   ENUM_SENSOR_BYTE_SIGNED_5_DEGREES_C = 0x1UL,
   ENUM_SENSOR_BYTE_UNSIGNED_DEGREES_C = 0x2UL,
   ENUM_SENSOR_32BIT_SIGNED_DEGREES_C = 0x3UL,
   ENUM_SENSOR_32BIT_SIGNED_5_DEGREES_C = 0x4UL,
   ENUM_SENSOR_32BIT_UNSIGNED_DEGREES_C = 0x5UL,
   ENUM_SENSOR_RELATIVE_HEAT_SCALE = 0x6UL
} SENSOR_TEMPERATURE_CFG;

// --- SENSOR_POWER_CFG ---
#define SENSOR_UNSIGNED_WATTS           (0)       
#define SENSOR_UNSIGNED_5_WATTS         (1)       

typedef enum {
   ENUM_SENSOR_UNSIGNED_WATTS = 0x0UL,
   ENUM_SENSOR_UNSIGNED_5_WATTS = 0x1UL
} SENSOR_POWER_CFG;

// --- VF_PRIVILEGE_LEVEL_ENUM ---
#define VF_PRIVILEGE_LEVEL_0            (0)       // Privilege level 0. Full privileges,
                                                  // can act the same as a physical
                                                  // function. 
#define VF_PRIVILEGE_LEVEL_1            (1)       // Privilege level 1. 
#define VF_PRIVILEGE_LEVEL_2            (2)       // Privilege level 2. 
#define VF_PRIVILEGE_LEVEL_3            (3)       // Privilege level 3. 
#define VF_PRIVILEGE_LEVEL_4            (4)       // Privilege level 4. 
#define VF_PRIVILEGE_LEVEL_5            (5)       // Privilege level 5. 
#define VF_PRIVILEGE_LEVEL_6            (6)       // Privilege level 6. 
#define VF_PRIVILEGE_LEVEL_7            (7)       // Privilege level 7. No privileges. 

typedef enum {
   ENUM_VF_PRIVILEGE_LEVEL_0 = 0x0UL,
   ENUM_VF_PRIVILEGE_LEVEL_1 = 0x1UL,
   ENUM_VF_PRIVILEGE_LEVEL_2 = 0x2UL,
   ENUM_VF_PRIVILEGE_LEVEL_3 = 0x3UL,
   ENUM_VF_PRIVILEGE_LEVEL_4 = 0x4UL,
   ENUM_VF_PRIVILEGE_LEVEL_5 = 0x5UL,
   ENUM_VF_PRIVILEGE_LEVEL_6 = 0x6UL,
   ENUM_VF_PRIVILEGE_LEVEL_7 = 0x7UL
} VF_PRIVILEGE_LEVEL_ENUM;

// --- VF_PORT_TYPE ---
#define VF_PORT_TYPE_PASSTHRU           (1)       // Passthru port. 
#define VF_PORT_TYPE_VEB                (2)       // Virtual Ethernet Bridge. 
#define VF_PORT_TYPE_VEPA               (3)       // Virtual Ethernet Port Aggregator. 

typedef enum {
   ENUM_VF_PORT_TYPE_PASSTHRU = 0x1UL,
   ENUM_VF_PORT_TYPE_VEB = 0x2UL,
   ENUM_VF_PORT_TYPE_VEPA = 0x3UL
} VF_PORT_TYPE;

// --- DRIVER_FUNCTION_CAPABILITIES_ENUMS ---
#define DRIVER_FUNCTION_CAPABILITY_SW_TIMESTAMPS (2) // Software TCP timestamps. 
#define DRIVER_FUNCTION_CAPABILITY_BE3_NATIVE_ERX_API (4) // Native BladeEngine3 Ethernet
                                                          // receive completions. 

typedef enum {
   ENUM_DRIVER_FUNCTION_CAPABILITY_SW_TIMESTAMPS = 0x2UL,
   ENUM_DRIVER_FUNCTION_CAPABILITY_BE3_NATIVE_ERX_API = 0x4UL
} DRIVER_FUNCTION_CAPABILITIES_ENUMS;

// --- IOCTL_COMMON_SEND_ACTIVATION_STATUS_CODE_ENUMS ---
// Status code enumerations for IOCTL_COMMON_SEND_ACTIVATION. 
#define SEND_ACTIVATION_STATUS_SUCCESS  (0)       // IOCTL completed successfully. 
#define SEND_ACTIVATION_STATUS_ILLEGAL_REQUEST (2) // Illegal request. Refer to the
                                                   // additional status codes for more
                                                   // information. 
#define SEND_ACTIVATION_STATUS_UNAUTHORIZED_KEY (5) // The activation key failed
                                                    // authorization. 
#define SEND_ACTIVATION_STATUS_UPGRADE_DISALLOWED (6) // Feature upgrade is not allowed on
                                                      // this adapter. 
#define SEND_ACTIVATION_STATUS_FEATURE_DISALLOWED (7) // The requested feature is not
                                                      // allowed on this adapter. 
#define SEND_ACTIVATION_STATUS_FEATURE_FREE (8)   // The requested feature is free on this
                                                  // adapter. 
#define SEND_ACTIVATION_STATUS_FEATURE_ACTIVE (9) // The requested feature is already
                                                  // active on this adapter. 
#define SEND_ACTIVATION_STATUS_FEATURE_INVALID (10) // The requested feature is not a
                                                    // valid feature number. 
#define SEND_ACTIVATION_STATUS_FEATURE_UPGRADED (11) // For an activation, the requested
                                                     // feature is presently upgraded. For
                                                     // a deactivation, the requested
                                                     // feature is not presently upgraded.

typedef enum {
   ENUM_SEND_ACTIVATION_STATUS_SUCCESS = 0x0UL,
   ENUM_SEND_ACTIVATION_STATUS_ILLEGAL_REQUEST = 0x2UL,
   ENUM_SEND_ACTIVATION_STATUS_UNAUTHORIZED_KEY = 0x5UL,
   ENUM_SEND_ACTIVATION_STATUS_UPGRADE_DISALLOWED = 0x6UL,
   ENUM_SEND_ACTIVATION_STATUS_FEATURE_DISALLOWED = 0x7UL,
   ENUM_SEND_ACTIVATION_STATUS_FEATURE_FREE = 0x8UL,
   ENUM_SEND_ACTIVATION_STATUS_FEATURE_ACTIVE = 0x9UL,
   ENUM_SEND_ACTIVATION_STATUS_FEATURE_INVALID = 0xaUL,
   ENUM_SEND_ACTIVATION_STATUS_FEATURE_UPGRADED = 0xbUL
} IOCTL_COMMON_SEND_ACTIVATION_STATUS_CODE_ENUMS;

// --- IOCTL_COMMON_SEND_ACTIVATION_ADDI_STATUS_CODE_ENUMS ---
// Additional status code enumerations for IOCTL_COMMON_SEND_ACTIVATION. 
#define SEND_ACTIVATION_ADDI_STATUS_INVALID_OPCODE (30) // Invalid opcode. 
#define SEND_ACTIVATION_ADDI_STATUS_INVALID_REQUEST (75) // The IOCTL header version field
                                                         // indicates an
                                                         // unknown/unsupported version of
                                                         // the IOCTL. 

typedef enum {
   ENUM_SEND_ACTIVATION_ADDI_STATUS_INVALID_OPCODE = 0x1eUL,
   ENUM_SEND_ACTIVATION_ADDI_STATUS_INVALID_REQUEST = 0x4bUL
} IOCTL_COMMON_SEND_ACTIVATION_ADDI_STATUS_CODE_ENUMS;

// --- RESET_LICENSES_STATUS_CODES ---
// Response status codes for IOCTL_COMMON_RESET_LICENSES. 
#define RESET_LICENSES_STATUS_SUCCESS   (0)       
#define RESET_LICENSES_STATUS_ILLEGAL_REQUEST (2) 
#define RESET_LICENSES_STATUS_UNAUTHORIZED_REQUEST (5) 
#define RESET_LICENSES_STATUS_LICENSE_IN_USE (16) 

typedef enum {
   ENUM_RESET_LICENSES_STATUS_SUCCESS = 0x0UL,
   ENUM_RESET_LICENSES_STATUS_ILLEGAL_REQUEST = 0x2UL,
   ENUM_RESET_LICENSES_STATUS_UNAUTHORIZED_REQUEST = 0x5UL,
   ENUM_RESET_LICENSES_STATUS_LICENSE_IN_USE = 0x10UL
} RESET_LICENSES_STATUS_CODES;

// --- RESET_LICENSES_ADDI_STATUS_CODES ---
// Response additional status codes for IOCTL_COMMON_RESET_LICENSES. 
#define RESET_LICENSES_ADDI_STATUS_INVALID_OPCODE (30) 
#define RESET_LICENSES_ADDI_STATUS_INVALID_REQUEST (75) 

typedef enum {
   ENUM_RESET_LICENSES_ADDI_STATUS_INVALID_OPCODE = 0x1eUL,
   ENUM_RESET_LICENSES_ADDI_STATUS_INVALID_REQUEST = 0x4bUL
} RESET_LICENSES_ADDI_STATUS_CODES;

// --- IPL_FILE_NUMBER ---
// These enums uniquely identify the IPL programmed on the SEEPROM of a given BE
// controller. IPL identification was introduced in BE3. BE2 and earlier products will
// return 0 or 0xffff. 
#define UNKNOWNIPL                      (0)       
#define C32FELX                         (1)       // Tomcat FCoE
#define C32IELX                         (2)       // Tomcat iSCSI
#define C32NELX                         (3)       // Tomcat NIC-only
#define C32FHP                          (4)       // Boxster III 
#define M32FHP                          (5)       // Eastfield 
#define L32FHP                          (6)       // Skipper,Toronto 
#define C32IHP                          (7)       // Boxster III 
#define M32IHP                          (8)       
#define L32IHP                          (9)       
#define C32NHP                          (10)      
#define M32NHP                          (11)      
#define M32FHMN                         (12)      
#define C32FHMN                         (13)      
#define M32FIBM                         (14)      // CFFH 
#define M32IIBM                         (15)      
#define C32NIBM                         (16)      // Mirage3 
#define C32NIBN                         (17)      // Endeavor 3 
#define C32NIBS                         (18)      // Shrike-M 
#define C32NIBX                         (19)      
#define M32NIBM                         (20)      // Eraptor 3
#define M32FIMN                         (21)      
#define M32FDEL                         (22)      
#define M32IDEL                         (23)      
#define M32FCIS                         (24)      
#define C32FFTS                         (25)      
#define M32FFTS                         (26)      
#define L32FHP9                         (27)      
#define L32IHP9                         (28)      
#define L34NIBM                         (29)      // Tigershark
#define L32NIBM                         (30)      // Blacktip
#define UNKNOWN_IPL                     (65535)   

typedef enum {
   ENUM_UNKNOWNIPL = 0x0UL,
   ENUM_C32FELX = 0x1UL,
   ENUM_C32IELX = 0x2UL,
   ENUM_C32NELX = 0x3UL,
   ENUM_C32FHP = 0x4UL,
   ENUM_M32FHP = 0x5UL,
   ENUM_L32FHP = 0x6UL,
   ENUM_C32IHP = 0x7UL,
   ENUM_M32IHP = 0x8UL,
   ENUM_L32IHP = 0x9UL,
   ENUM_C32NHP = 0xaUL,
   ENUM_M32NHP = 0xbUL,
   ENUM_M32FHMN = 0xcUL,
   ENUM_C32FHMN = 0xdUL,
   ENUM_M32FIBM = 0xeUL,
   ENUM_M32IIBM = 0xfUL,
   ENUM_C32NIBM = 0x10UL,
   ENUM_C32NIBN = 0x11UL,
   ENUM_C32NIBS = 0x12UL,
   ENUM_C32NIBX = 0x13UL,
   ENUM_M32NIBM = 0x14UL,
   ENUM_M32FIMN = 0x15UL,
   ENUM_M32FDEL = 0x16UL,
   ENUM_M32IDEL = 0x17UL,
   ENUM_M32FCIS = 0x18UL,
   ENUM_C32FFTS = 0x19UL,
   ENUM_M32FFTS = 0x1aUL,
   ENUM_L32FHP9 = 0x1bUL,
   ENUM_L32IHP9 = 0x1cUL,
   ENUM_L34NIBM = 0x1dUL,
   ENUM_L32NIBM = 0x1eUL,
   ENUM_UNKNOWN_IPL = 0xffffUL
} IPL_FILE_NUMBER;

// --- DRIVER_ADV_FEATURE ---
#define DRIVER_ADV_FEATURE_IFD          (1)       

typedef enum {
   ENUM_DRIVER_ADV_FEATURE_IFD = 0x1UL
} DRIVER_ADV_FEATURE;

// --- HOST_DMA_DIRECTION_CONTROL ---
#define DMA_FROM_HOST_TO_DDR            (1)       // DMA from HOST to DDR 
#define DMA_FROM_DDR_TO_HOST            (2)       // DMA from DDR to HOST 

typedef enum {
   ENUM_DMA_FROM_HOST_TO_DDR = 0x1UL,
   ENUM_DMA_FROM_DDR_TO_HOST = 0x2UL
} HOST_DMA_DIRECTION_CONTROL;

#endif // __ioctl_common_enum_h__

