/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_common_iscsi_enum_h__
#define __ioctl_common_iscsi_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"
#include "ioctl_common_iscsi_ntwk_enum.h"
#include "ioctl_common_iscsi_discovery_enum.h"
#include "ioctl_common_iscsi_ipsec_enum.h"
#include "ioctl_iscsi_tgt_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- MIB_PORTAL_ADDRESS_TYPE ---
// Definition of node_portal_address_type 
#define MIB_PORTAL_ADDR_TYPE_UKNOWN     (0)       
#define MIB_PORTAL_ADDR_TYPE_IPV4       (1)       
#define MIB_PORTAL_ADDR_TYPE_IPV6       (2)       
#define MIB_PORTAL_ADDR_TYPE_DNS        (3)       

typedef enum {
   ENUM_MIB_PORTAL_ADDR_TYPE_UKNOWN = 0x0UL,
   ENUM_MIB_PORTAL_ADDR_TYPE_IPV4 = 0x1UL,
   ENUM_MIB_PORTAL_ADDR_TYPE_IPV6 = 0x2UL,
   ENUM_MIB_PORTAL_ADDR_TYPE_DNS = 0x3UL
} MIB_PORTAL_ADDRESS_TYPE;

// --- MIB_ISCSI_ROLE ---
// Definition of iscsi_node_roles and node_portal_roles 
#define MIB_TARGET_ROLE                 (1)       
#define MIB_INITIATOR_ROLE              (2)       
#define MIB_INI_TGT_ROLE                (3)       

typedef enum {
   ENUM_MIB_TARGET_ROLE = 0x1UL,
   ENUM_MIB_INITIATOR_ROLE = 0x2UL,
   ENUM_MIB_INI_TGT_ROLE = 0x3UL
} MIB_ISCSI_ROLE;

// --- MIB_ISCSI_PORTAL_PROTOCOL ---
// Definition of node_portal_protocol 
#define MIB_NODE_PORTAL_PROTOCOL        (6)       

typedef enum {
   ENUM_MIB_NODE_PORTAL_PROTOCOL = 0x6UL
} MIB_ISCSI_PORTAL_PROTOCOL;

// --- MIB_PORTAL_STATUS ---
// Definition of node_portal_status 
#define MIB_PORTAL_STATUS_ACTIVE        (1)       
#define MIB_PORTAL_STATUS_NOT_READY     (2)       

typedef enum {
   ENUM_MIB_PORTAL_STATUS_ACTIVE = 0x1UL,
   ENUM_MIB_PORTAL_STATUS_NOT_READY = 0x2UL
} MIB_PORTAL_STATUS;

// --- ISCSI_COMMAND_CLEANUP_TYPE ---
#define IOCTL_ISCSI_COMMAND_INVALIDATE  (1)       // Invalidate this command, a TMF abort
                                                  // will follow
#define IOCTL_ISCSI_COMMAND_FREE        (2)       // Free this command, the TCP conn has
                                                  // be closed with commands pending

typedef enum {
   ENUM_IOCTL_ISCSI_COMMAND_INVALIDATE = 0x1UL,
   ENUM_IOCTL_ISCSI_COMMAND_FREE = 0x2UL
} ISCSI_COMMAND_CLEANUP_TYPE;

// --- SGL_ICD_CLEANUP_STATUS ---
#define SGL_ICD_CLEANUP_SUCCESS         (1)       // The invalidation/freeing was
                                                  // successful
#define SGL_ICD_NOT_FOUND               (2)       // This sgl_icd was not found
#define SGL_ICD_INVALIDATION_ERROR      (4)       // Unkown error while invalidating this
                                                  // sgl_icd

typedef enum {
   ENUM_SGL_ICD_CLEANUP_SUCCESS = 0x1UL,
   ENUM_SGL_ICD_NOT_FOUND = 0x2UL,
   ENUM_SGL_ICD_INVALIDATION_ERROR = 0x4UL
} SGL_ICD_CLEANUP_STATUS;

// --- IOCTL_ISCSI_DEFINED_ENUM ---
#define MGMT_MAX_SGL_ICD_INVALIDATE     (128)     

typedef enum {
   ENUM_MGMT_MAX_SGL_ICD_INVALIDATE = 0x80UL
} IOCTL_ISCSI_DEFINED_ENUM;

// --- EVENT_LOG_TABLE_TYPE ---
// Definition of table_type in IOCTL_ISCSI_INI_CFG_READ_EVENT_LOG 
#define MGMT_EVENT_LOG_ALL              (0)       
#define MGMT_EVENT_LOG_FATAL            (1)       

typedef enum {
   ENUM_MGMT_EVENT_LOG_ALL = 0x0UL,
   ENUM_MGMT_EVENT_LOG_FATAL = 0x1UL
} EVENT_LOG_TABLE_TYPE;

// --- CONN_OFFLOAD ---

#define TCP_CONNECT_NO_OFFLOAD          (0)       
#define TCP_CONNECT_AND_OFFLOAD         (1)       

typedef enum {
   ENUM_TCP_CONNECT_NO_OFFLOAD = 0x0UL,
   ENUM_TCP_CONNECT_AND_OFFLOAD = 0x1UL
} CONN_OFFLOAD;

#endif // __ioctl_common_iscsi_enum_h__

