/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_dcbx_enum_h__
#define __ioctl_dcbx_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- DCBX_PROTO_OUI ---
#define DCBX_PROTOCOL_OUI               (6945)    // DCBX protocol OUI defined by Intel 

typedef enum {
   ENUM_DCBX_PROTOCOL_OUI = 0x1b21UL
} DCBX_PROTO_OUI;

// --- DCBX_GLOBAL_STATE ---
#define DCBX_STATE_DISABLED             (0)       // DCBX is disabled. LLDP Tx state m.c
                                                  // is disabled. Rx may be disabled based
                                                  // on ICDS availability 
#define DCBX_STATE_ENABLED              (1)       // DCBX support is enabled in the ARM
                                                  // fw. Both Tx and Rx state are enabled
                                                  // in the LLDP state m/c 

typedef enum {
   ENUM_DCBX_STATE_DISABLED = 0x0UL,
   ENUM_DCBX_STATE_ENABLED = 0x1UL
} DCBX_GLOBAL_STATE;

// --- IOCTL_DCBX_FEATURE_STATE ---
#define IOCTL_DCBX_FEATURE_DISABLED     (0)       // This indicates DCBX feature is
                                                  // disabled 
#define IOCTL_DCBX_FEATURE_ENABLED      (1)       // This indicates DCBX feature is
                                                  // Enabled 
#define IOCTL_DCBX_FEATURE_ADVERTISED   (2)       // This indicates DCBX feature need to
                                                  // be Advertized 
#define IOCTL_DCBX_FEATURE_WILLING      (4)       // This indicates DCBX feature is
                                                  // willing to accept params from peer 
#define IOCTL_DCBX_FEATURE_SYNCED       (8)       // This indicates DCBX feature is Synced
#define IOCTL_DCBX_FEATURE_ERROR        (2147483648) // This indicates DCBX feature is
                                                     // ERROR in negotiation 

typedef enum {
   ENUM_IOCTL_DCBX_FEATURE_DISABLED = 0x0UL,
   ENUM_IOCTL_DCBX_FEATURE_ENABLED = 0x1UL,
   ENUM_IOCTL_DCBX_FEATURE_ADVERTISED = 0x2UL,
   ENUM_IOCTL_DCBX_FEATURE_WILLING = 0x4UL,
   ENUM_IOCTL_DCBX_FEATURE_SYNCED = 0x8UL,
   ENUM_IOCTL_DCBX_FEATURE_ERROR = 0x80000000UL
} IOCTL_DCBX_FEATURE_STATE;

// --- DCBX_MAX_SUPPORTED_TRAFFIC_CLASSES ---
#define DCBX_MAX_TRAFFIC_CLASSES        (8)       // Max Traffic Classes supported 

typedef enum {
   ENUM_DCBX_MAX_TRAFFIC_CLASSES = 0x8UL
} DCBX_MAX_SUPPORTED_TRAFFIC_CLASSES;

// --- DCBX_MAX_SUPPORTED_USER_PRIORITIES ---
#define DCBX_MAX_USER_PRIORITIES        (8)       // Max User Priority supported this
                                                  // limitation came from 3 bit VLAN
                                                  // priority 

typedef enum {
   ENUM_DCBX_MAX_USER_PRIORITIES = 0x8UL
} DCBX_MAX_SUPPORTED_USER_PRIORITIES;

// --- DCBX_MAX_SUPPORTED_BW_GROUPS ---
#define DCBX_MAX_BW_GROUPS              (8)       // Max Bandwidth Groups supported 

typedef enum {
   ENUM_DCBX_MAX_BW_GROUPS = 0x8UL
} DCBX_MAX_SUPPORTED_BW_GROUPS;

// --- DCBX_MAX_SUPPORTED_APP_PROTOCOLS ---
#define DCBX_MAX_APP_PROTOCOLS          (15)      // MAX number of Application protocols
                                                  // supported 

typedef enum {
   ENUM_DCBX_MAX_APP_PROTOCOLS = 0xfUL
} DCBX_MAX_SUPPORTED_APP_PROTOCOLS;

// --- DCBX_APP_PROTOCOL_SELECTORS ---
#define DCBX_APP_PROTOCOL_SELECTOR_ETHER_TYPE (0) // Layer 2 Ether Type 
#define DCBX_APP_PROTOCOL_SELECTOR_TCPUDP_PORT (1) // Layer 4 TCP/UDP Port 

typedef enum {
   ENUM_DCBX_APP_PROTOCOL_SELECTOR_ETHER_TYPE = 0x0UL,
   ENUM_DCBX_APP_PROTOCOL_SELECTOR_TCPUDP_PORT = 0x1UL
} DCBX_APP_PROTOCOL_SELECTORS;

// --- DCBX_APP_PROTOCOL_STATE ---
#define DCBX_APP_PROTOCOL_DISABLED      (0)       
#define DCBX_APP_PROTOCOL_ENABLED       (1)       

typedef enum {
   ENUM_DCBX_APP_PROTOCOL_DISABLED = 0x0UL,
   ENUM_DCBX_APP_PROTOCOL_ENABLED = 0x1UL
} DCBX_APP_PROTOCOL_STATE;

// --- DCBX_PRIORITY_SETTINGS ---
#define DCBX_PRIORITY_SETTINGS_NO_STRICT (0)      // No strict priority 
#define DCBX_PRIORITY_SETTINGS_GROUP_STRICT (1)   // Group Strict Priority (GSP) 
#define DCBX_PRIORITY_SETTINGS_LINK_STRICT (2)    // Link Strict Priority (LSP) 

typedef enum {
   ENUM_DCBX_PRIORITY_SETTINGS_NO_STRICT = 0x0UL,
   ENUM_DCBX_PRIORITY_SETTINGS_GROUP_STRICT = 0x1UL,
   ENUM_DCBX_PRIORITY_SETTINGS_LINK_STRICT = 0x2UL
} DCBX_PRIORITY_SETTINGS;

// --- DCBX_PARAM_TYPE ---
#define DCBX_PARAM_TYPE_ADMIN           (0)       // Parameters set by Admin 
#define DCBX_PARAM_TYPE_OPERATIONAL     (1)       // Operational parameters. 
#define DCBX_PARAM_TYPE_PEER            (2)       // Peer Parameters 

typedef enum {
   ENUM_DCBX_PARAM_TYPE_ADMIN = 0x0UL,
   ENUM_DCBX_PARAM_TYPE_OPERATIONAL = 0x1UL,
   ENUM_DCBX_PARAM_TYPE_PEER = 0x2UL
} DCBX_PARAM_TYPE;

// --- DCBX_OPERATIONAL_PARAMS ---
#define DCBX_OPERATIONAL_PARAMS_INVALID (0)       // A remote dcbx-enabled switch hasn't
                                                  // responde to DCBX TLVs within the
                                                  // timeout period All opertional
                                                  // parameters retrieved with
                                                  // parameter_type =
                                                  // DCBX_PARAM_TYPE_OPERATIONAL are
                                                  // invalid 
#define DCBX_OPERATIONAL_PARAMS_VALID   (1)       // All opertional parameters retrieved
                                                  // with parameter_type =
                                                  // DCBX_PARAM_TYPE_OPERATIONAL are valid

typedef enum {
   ENUM_DCBX_OPERATIONAL_PARAMS_INVALID = 0x0UL,
   ENUM_DCBX_OPERATIONAL_PARAMS_VALID = 0x1UL
} DCBX_OPERATIONAL_PARAMS;

// --- IOCTL_DCBX_LOCAL_OPCODES ---
#define IOCTL_DCBX_PG_FEATURE           (0)       // Priority Group 
#define IOCTL_DCBX_PFC_FEATURE          (1)       // Priority Flow Control 
#define IOCTL_DCBX_BCN_FEATURE          (2)       // Backword Congetion 
#define IOCTL_DCBX_APP_FEATURE          (3)       // Application Feature 
#define IOCTL_DCBX_LLD_FEATURE          (4)       // Logical Link down 
#define IOCTL_DCBX_NV_FEATURE           (5)       // Network virtualization 

typedef enum {
   ENUM_IOCTL_DCBX_PG_FEATURE = 0x0UL,
   ENUM_IOCTL_DCBX_PFC_FEATURE = 0x1UL,
   ENUM_IOCTL_DCBX_BCN_FEATURE = 0x2UL,
   ENUM_IOCTL_DCBX_APP_FEATURE = 0x3UL,
   ENUM_IOCTL_DCBX_LLD_FEATURE = 0x4UL,
   ENUM_IOCTL_DCBX_NV_FEATURE = 0x5UL
} IOCTL_DCBX_LOCAL_OPCODES;

// --- DCBX_MODE ---
#define DCBX_MODE_CEE                   (0)       // This implementation of DCBX follows
                                                  // the (new) CEE author's spec
#define DCBX_MODE_CIN                   (1)       // This implementation of DCBX follows
                                                  // the (old) Cisco/Intel/Nouvo spec 

typedef enum {
   ENUM_DCBX_MODE_CEE = 0x0UL,
   ENUM_DCBX_MODE_CIN = 0x1UL
} DCBX_MODE;

#endif // __ioctl_dcbx_enum_h__

