/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_fcoe_enum_h__
#define __ioctl_fcoe_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"
#include "fc_device_context_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- FCOE_COMMAND_CLEANUP_TYPE ---
#define IOCTL_FCOE_COMMAND_INVALIDATE   (1)       // Invalidate this command, a ABTS will
                                                  // follow 
#define IOCLT_FCOE_COMMAND_FREE         (2)       // Free this command 

typedef enum {
   ENUM_IOCTL_FCOE_COMMAND_INVALIDATE = 0x1UL,
   ENUM_IOCLT_FCOE_COMMAND_FREE = 0x2UL
} FCOE_COMMAND_CLEANUP_TYPE;

// --- IOCTL_FCOE_DEFINED_ENUM ---
#define FCOE_MAX_SGL_ICD_INVALIDATE     (128)     

typedef enum {
   ENUM_FCOE_MAX_SGL_ICD_INVALIDATE = 0x80UL
} IOCTL_FCOE_DEFINED_ENUM;

// --- FCOE_SGL_ICD_CLEANUP_STATUS ---
#define FCOE_SGL_ICD_CLEANUP_SUCCESS    (1)       // Invalidation was successful 
#define FCOE_SGL_ICD_NOT_FOUND          (2)       // Command not found 
#define FCOE_SGL_ICD_INVALIDATION_ERROR (3)       // error in invalidation process 

typedef enum {
   ENUM_FCOE_SGL_ICD_CLEANUP_SUCCESS = 0x1UL,
   ENUM_FCOE_SGL_ICD_NOT_FOUND = 0x2UL,
   ENUM_FCOE_SGL_ICD_INVALIDATION_ERROR = 0x3UL
} FCOE_SGL_ICD_CLEANUP_STATUS;

// --- FCF_ADDRESS_TYPE ---
// An FCF may support both FPMA and SPMA 
#define FCF_ADDRESS_TYPE_FPMA           (1)       // Fabric Provided Mac Address 
#define FCF_ADDRESS_TYPE_SPMA           (2)       // Server Provided Mac Address 

typedef enum {
   ENUM_FCF_ADDRESS_TYPE_FPMA = 0x1UL,
   ENUM_FCF_ADDRESS_TYPE_SPMA = 0x2UL
} FCF_ADDRESS_TYPE;

// --- MBOX_IO_COMPLETION_MODE ---
// Completion type expected by Host/BIOS. 
#define MBOX_IO_COMPLETION_MODE_NON_BLOCKING (1)  // If a CQ is available it will be
                                                  // rported else error code
                                                  // MGMT_STATUS_NO_CQE 
#define MBOX_IO_COMPLETION_MODE_BLOCKING (2)      // Block Ioctl until a CQ is available
                                                  // for ARM Firmware. 

typedef enum {
   ENUM_MBOX_IO_COMPLETION_MODE_NON_BLOCKING = 0x1UL,
   ENUM_MBOX_IO_COMPLETION_MODE_BLOCKING = 0x2UL
} MBOX_IO_COMPLETION_MODE;

// --- MBOX_IO_CQ_TYPE ---
// CQ type being posted to Host/BIOS. 
#define MBOX_IO_CQ_TYPE_NORMAL          (1)       // CQ related to the I/O request. 
#define MBOX_IO_CQ_TYPE_ASYNC           (2)       // Async CQ, can be link, FCF related. 

typedef enum {
   ENUM_MBOX_IO_CQ_TYPE_NORMAL = 0x1UL,
   ENUM_MBOX_IO_CQ_TYPE_ASYNC = 0x2UL
} MBOX_IO_CQ_TYPE;

#endif // __ioctl_fcoe_enum_h__

