/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_flash_types_enum_h__
#define __ioctl_flash_types_enum_h__
#include "setypes.h"
#include "post_codes_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- BE2_FLASHROM_OFFSET ---
// Offsets for all components on Flash. 
#define BE2_FLASH_LPCISM_REGISTERS      (0)       
#define BE2_FLASH_REDBOOT_START         (32768)   
#define BE2_FLASH_FAT_START             (262144)  
#define BE2_FLASH_FCoE_BIOS_START       (524288)  
#define BE2_FLASH_UFI_COPYRIGHT_DIR_START (786432) 
#define BE2_FLASH_DEBUG_PRINT_START     (917504)  
#define BE2_FLASH_iSCSI_PRIMARY_IMAGE_START (1048576) 
#define BE2_FLASH_iSCSI_BACKUP_IMAGE_START (2359296) 
#define BE2_FLASH_FCoE_PRIMARY_IMAGE_START (3670016) 
#define BE2_FLASH_FCoE_BACKUP_IMAGE_START (4980736) 
#define BE2_FLASH_CFG_INI_START         (6291456) 
#define BE2_FLASH_iSCSI_BIOS_START      (7340032) 
#define BE2_FLASH_iSCSI_BIOS_CTRL_S_START (7471104) 
#define BE2_FLASH_EVENTLOG_START        (7602176) 
#define BE2_FLASH_PXE_BIOS_START        (7864320) 
#define BE2_FLASH_PXE_BIOS_START_CNTRL_P_START (8060928) 
#define BE2_FLASH_REDBOOT_CONFIG        (8126464) 
#define BE2_FLASH_REDBOOT_DIRECTORY     (8257536) 

typedef enum {
   ENUM_BE2_FLASH_LPCISM_REGISTERS = 0x0UL,
   ENUM_BE2_FLASH_REDBOOT_START = 0x8000UL,
   ENUM_BE2_FLASH_FAT_START = 0x40000UL,
   ENUM_BE2_FLASH_FCoE_BIOS_START = 0x80000UL,
   ENUM_BE2_FLASH_UFI_COPYRIGHT_DIR_START = 0xc0000UL,
   ENUM_BE2_FLASH_DEBUG_PRINT_START = 0xe0000UL,
   ENUM_BE2_FLASH_iSCSI_PRIMARY_IMAGE_START = 0x100000UL,
   ENUM_BE2_FLASH_iSCSI_BACKUP_IMAGE_START = 0x240000UL,
   ENUM_BE2_FLASH_FCoE_PRIMARY_IMAGE_START = 0x380000UL,
   ENUM_BE2_FLASH_FCoE_BACKUP_IMAGE_START = 0x4c0000UL,
   ENUM_BE2_FLASH_CFG_INI_START = 0x600000UL,
   ENUM_BE2_FLASH_iSCSI_BIOS_START = 0x700000UL,
   ENUM_BE2_FLASH_iSCSI_BIOS_CTRL_S_START = 0x720000UL,
   ENUM_BE2_FLASH_EVENTLOG_START = 0x740000UL,
   ENUM_BE2_FLASH_PXE_BIOS_START = 0x780000UL,
   ENUM_BE2_FLASH_PXE_BIOS_START_CNTRL_P_START = 0x7b0000UL,
   ENUM_BE2_FLASH_REDBOOT_CONFIG = 0x7c0000UL,
   ENUM_BE2_FLASH_REDBOOT_DIRECTORY = 0x7e0000UL
} BE2_FLASHROM_OFFSET;

// --- BE2_FLASHROM_FIRMWARE_DEFINES ---
#define BE2_FLASH_EXTFAT_SIZE           (131072)  // Size of EXT FAT dump 
#define BE2_FLASH_IMAGE_ENTRY           (262144)  // Entry point of firmware image 
#define BE2_FLASH_CFG_INI_CONFIG_SIZE   (1048576) // Initiator Config Size is 1M - 256K
#define BE2_FLASH_IMAGE_MAX_SIZE        (1310720) // Maximum firmware image size 

typedef enum {
   ENUM_BE2_FLASH_EXTFAT_SIZE = 0x20000UL,
   ENUM_BE2_FLASH_IMAGE_ENTRY = 0x40000UL,
   ENUM_BE2_FLASH_CFG_INI_CONFIG_SIZE = 0x100000UL,
   ENUM_BE2_FLASH_IMAGE_MAX_SIZE = 0x140000UL
} BE2_FLASHROM_FIRMWARE_DEFINES;

// --- BE2_FLASHROM_REDBOOT_DEFINES ---
#define BE2_FLASH_REDBOOT_CFG_IMAGE_MAX_SIZE (131072) // Maximum Redboot Config image size
#define BE2_FLASH_REDBOOT_DIR_IMAGE_MAX_SIZE (131072) // Maximum Redboot Directory image
                                                      // size 
#define BE2_FLASH_REDBOOT_ISM_IMAGE_MAX_SIZE (262144) // Maximum ISM+Redbot image size 

typedef enum {
   ENUM_BE2_FLASH_REDBOOT_CFG_IMAGE_MAX_SIZE = 0x20000UL,
   ENUM_BE2_FLASH_REDBOOT_DIR_IMAGE_MAX_SIZE = 0x20000UL,
   ENUM_BE2_FLASH_REDBOOT_ISM_IMAGE_MAX_SIZE = 0x40000UL
} BE2_FLASHROM_REDBOOT_DEFINES;

// --- BE2_FLASHROM_BIOS_DEFINES ---
#define BE2_FLASH_BIOS_IMAGE_MAX_SIZE   (262144)  // Maximum OPTION ROM image size 

typedef enum {
   ENUM_BE2_FLASH_BIOS_IMAGE_MAX_SIZE = 0x40000UL
} BE2_FLASHROM_BIOS_DEFINES;

// --- BE2_FLASHROM_FIS_DEFINES ---
#define BE2_FIS_iSCSI_NIC_PRIMARY_IMAGE_INDEX (3) 
#define BE2_FIS_iSCSI_NIC_BACKUP_IMAGE_INDEX (4)  
#define BE2_FIS_FCoE_PRIMARY_IMAGE_INDEX (5)      
#define BE2_FIS_FCoE_BACKUP_IMAGE_INDEX (6)       
#define BE2_FIS_DIR_ENTRY_SIZE          (256)     
#define BE2_FIS_DIR_SIZE                (1792)    
#define BE2_FIS_CONFIG_SIZE             (4096)    

typedef enum {
   ENUM_BE2_FIS_iSCSI_NIC_PRIMARY_IMAGE_INDEX = 0x3UL,
   ENUM_BE2_FIS_iSCSI_NIC_BACKUP_IMAGE_INDEX = 0x4UL,
   ENUM_BE2_FIS_FCoE_PRIMARY_IMAGE_INDEX = 0x5UL,
   ENUM_BE2_FIS_FCoE_BACKUP_IMAGE_INDEX = 0x6UL,
   ENUM_BE2_FIS_DIR_ENTRY_SIZE = 0x100UL,
   ENUM_BE2_FIS_DIR_SIZE = 0x700UL,
   ENUM_BE2_FIS_CONFIG_SIZE = 0x1000UL
} BE2_FLASHROM_FIS_DEFINES;

// --- BE2_FLASHROM_EVENTLOG_DEFINES ---
#define BE2_FLASH_EVENTLOG_SECTOR_CNT   (2)       

typedef enum {
   ENUM_BE2_FLASH_EVENTLOG_SECTOR_CNT = 0x2UL
} BE2_FLASHROM_EVENTLOG_DEFINES;

// --- BE2_FLASHROM_FAT_DEFINES ---
#define BE2_FLASH_FAT_SIZE              (262144)  

typedef enum {
   ENUM_BE2_FLASH_FAT_SIZE = 0x40000UL
} BE2_FLASHROM_FAT_DEFINES;

// --- BE2_FLASHROM_FLASH_DEFINES ---
#define BE2_FLASH_SECTOR_SIZE           (131072)  

typedef enum {
   ENUM_BE2_FLASH_SECTOR_SIZE = 0x20000UL
} BE2_FLASHROM_FLASH_DEFINES;

// --- BE2_FLASHROM_UFI_DEFINES ---
#define BE2_FLASH_UFI_BUILD_STR_LEN     (24)      
#define BE2_FLASH_UFI_SIGNATURE_SIZE    (32)      
#define BE2_FLASH_UFI_HEADER_SIZE       (96)      
#define BE2_FLASH_UFI_BIN_SIZE          (8388608) 

typedef enum {
   ENUM_BE2_FLASH_UFI_BUILD_STR_LEN = 0x18UL,
   ENUM_BE2_FLASH_UFI_SIGNATURE_SIZE = 0x20UL,
   ENUM_BE2_FLASH_UFI_HEADER_SIZE = 0x60UL,
   ENUM_BE2_FLASH_UFI_BIN_SIZE = 0x800000UL
} BE2_FLASHROM_UFI_DEFINES;

// --- BE2_IMAGE_ENTRY_TYPE ---
#define BE2_IMAGE_OPTION_ROM_PXE        (32)      // contains pxe bios
#define BE2_IMAGE_OPTION_ROM_FCoE       (33)      // contains fcoe bios
#define BE2_IMAGE_OPTION_ROM_ISCSI      (34)      // contains iscsi bios
#define BE2_IMAGE_FIRMWARE_iSCSI        (160)     
#define BE2_IMAGE_FIRMWARE_COMP_iSCSI   (161)     
#define BE2_IMAGE_FIRMWARE_FCoE         (162)     
#define BE2_IMAGE_FIRMWARE_COMP_FCoE    (163)     
#define BE2_IMAGE_FIRMWARE_BACKUP_iSCSI (176)     
#define BE2_IMAGE_FIRMWARE_BACKUP_COMP_iSCSI (177) // contains backup iSCSI/NIC firmware
                                                   // compressed
#define BE2_IMAGE_FIRMWARE_BACKUP_FCoE  (178)     
#define BE2_IMAGE_FIRMWARE_BACKUP_COMP_FCoE (179) // contains backup FCoE/NIC firmware
                                                  // compressed
#define BE2_IMAGE_BOOT_CODE             (224)     

typedef enum {
   ENUM_BE2_IMAGE_OPTION_ROM_PXE = 0x20UL,
   ENUM_BE2_IMAGE_OPTION_ROM_FCoE = 0x21UL,
   ENUM_BE2_IMAGE_OPTION_ROM_ISCSI = 0x22UL,
   ENUM_BE2_IMAGE_FIRMWARE_iSCSI = 0xa0UL,
   ENUM_BE2_IMAGE_FIRMWARE_COMP_iSCSI = 0xa1UL,
   ENUM_BE2_IMAGE_FIRMWARE_FCoE = 0xa2UL,
   ENUM_BE2_IMAGE_FIRMWARE_COMP_FCoE = 0xa3UL,
   ENUM_BE2_IMAGE_FIRMWARE_BACKUP_iSCSI = 0xb0UL,
   ENUM_BE2_IMAGE_FIRMWARE_BACKUP_COMP_iSCSI = 0xb1UL,
   ENUM_BE2_IMAGE_FIRMWARE_BACKUP_FCoE = 0xb2UL,
   ENUM_BE2_IMAGE_FIRMWARE_BACKUP_COMP_FCoE = 0xb3UL,
   ENUM_BE2_IMAGE_BOOT_CODE = 0xe0UL
} BE2_IMAGE_ENTRY_TYPE;

// --- BE2_FLASH_DIR_DEFINES ---
#define BE2_NUMBER_OF_ENTRIES           (32)      // Number of entries in the flash
                                                  // directory 
#define BE2_COOKIE_SIZE                 (32)      // Size of the cookie 

typedef enum {
   ENUM_BE2_NUMBER_OF_ENTRIES = 0x20UL,
   ENUM_BE2_COOKIE_SIZE = 0x20UL
} BE2_FLASH_DIR_DEFINES;

// --- FLASHROM_OFFSET ---
// Offsets for all components on Flash. 
#define FLASH_LPCISM_REGISTERS          (0)       
#define FLASH_JUMP_VECTORS_START        (131072)  
#define FLASH_REDBOOT_START             (262144)  
#define FLASH_PHY_FW_IMAGE_START        (1310720) 
#define FLASH_UFI_DIRECTORY_START       (1572864) 
#define FLASH_DEBUG_PRINT_START         (1835008) 
#define FLASH_iSCSI_PRIMARY_IMAGE_START (2097152) 
#define FLASH_iSCSI_BACKUP_IMAGE_START  (4194304) 
#define FLASH_FCoE_PRIMARY_IMAGE_START  (6291456) 
#define FLASH_FCoE_BACKUP_IMAGE_START   (8388608) 
#define FLASH_CFG_INI_START             (10485760) 
#define FLASH_EXT_FAT_START             (11534336) 
#define FLASH_iSCSI_BIOS_START          (12582912) 
#define FLASH_iSCSI_BIOS_CTRL_S_START   (12713984) 
#define FLASH_PXE_BIOS_START            (13107200) 
#define FLASH_PXE_BIOS_CNTRL_P_START    (13303808) 
#define FLASH_FCoE_BIOS_START           (13631488) 
#define FLASH_FAT_START                 (14155776) 
#define FLASH_EVENTLOG_START            (15204352) 
#define FLASH_VPD_REGION_START          (15466496) 
#define FLASH_VPD_SPARE_START           (15728640) 
#define FLASH_NCSI_IMAGE_START          (15990784) 
#define FLASH_REDBOOT_CONFIG            (16252928) 
#define FLASH_REDBOOT_DIRECTORY         (16515072) 

typedef enum {
   ENUM_FLASH_LPCISM_REGISTERS = 0x0UL,
   ENUM_FLASH_JUMP_VECTORS_START = 0x20000UL,
   ENUM_FLASH_REDBOOT_START = 0x40000UL,
   ENUM_FLASH_PHY_FW_IMAGE_START = 0x140000UL,
   ENUM_FLASH_UFI_DIRECTORY_START = 0x180000UL,
   ENUM_FLASH_DEBUG_PRINT_START = 0x1c0000UL,
   ENUM_FLASH_iSCSI_PRIMARY_IMAGE_START = 0x200000UL,
   ENUM_FLASH_iSCSI_BACKUP_IMAGE_START = 0x400000UL,
   ENUM_FLASH_FCoE_PRIMARY_IMAGE_START = 0x600000UL,
   ENUM_FLASH_FCoE_BACKUP_IMAGE_START = 0x800000UL,
   ENUM_FLASH_CFG_INI_START = 0xa00000UL,
   ENUM_FLASH_EXT_FAT_START = 0xb00000UL,
   ENUM_FLASH_iSCSI_BIOS_START = 0xc00000UL,
   ENUM_FLASH_iSCSI_BIOS_CTRL_S_START = 0xc20000UL,
   ENUM_FLASH_PXE_BIOS_START = 0xc80000UL,
   ENUM_FLASH_PXE_BIOS_CNTRL_P_START = 0xcb0000UL,
   ENUM_FLASH_FCoE_BIOS_START = 0xd00000UL,
   ENUM_FLASH_FAT_START = 0xd80000UL,
   ENUM_FLASH_EVENTLOG_START = 0xe80000UL,
   ENUM_FLASH_VPD_REGION_START = 0xec0000UL,
   ENUM_FLASH_VPD_SPARE_START = 0xf00000UL,
   ENUM_FLASH_NCSI_IMAGE_START = 0xf40000UL,
   ENUM_FLASH_REDBOOT_CONFIG = 0xf80000UL,
   ENUM_FLASH_REDBOOT_DIRECTORY = 0xfc0000UL
} FLASHROM_OFFSET;

// --- FLASHROM_FIRMWARE_DEFINES ---
#define FLASH_FIRMWARE_IMAGE_ENTRY      (262144)  // Entry point of firmware image 
#define FLASH_FIRMWARE_CONFIG_SIZE      (1048576) // Initiator/FCoE Config Size is 1M 
#define FLASH_EXTFAT_SIZE               (1048576) // Size of EXT FAT dump 
#define FLASH_FIRMWARE_IMAGE_MAX_SIZE   (2097152) // Maximum firmware image size 

typedef enum {
   ENUM_FLASH_FIRMWARE_IMAGE_ENTRY = 0x40000UL,
   ENUM_FLASH_FIRMWARE_CONFIG_SIZE = 0x100000UL,
   ENUM_FLASH_EXTFAT_SIZE = 0x100000UL,
   ENUM_FLASH_FIRMWARE_IMAGE_MAX_SIZE = 0x200000UL
} FLASHROM_FIRMWARE_DEFINES;

// --- FLASHROM_ISM_DEFINES ---
#define FLASH_ISM_IMAGE_MAX_SIZE        (131072)  // Maximum ISM image size 
#define FLASH_JUMP_VECTOR_IMAGE_MAX_SIZE (131072) // Maximum Jump Vector image size 
#define FLASH_ISM_JUMPVECTOR_IMAGE_MAX_SIZE (262144) // Maximum ISM+JumpVector image size 

typedef enum {
   ENUM_FLASH_ISM_IMAGE_MAX_SIZE = 0x20000UL,
   ENUM_FLASH_JUMP_VECTOR_IMAGE_MAX_SIZE = 0x20000UL,
   ENUM_FLASH_ISM_JUMPVECTOR_IMAGE_MAX_SIZE = 0x40000UL
} FLASHROM_ISM_DEFINES;

// --- FLASHROM_REDBOOT_DEFINES ---
#define FLASH_REDBOOT_CFG_IMAGE_MAX_SIZE (262144) // Maximum Redboot Config image size 
#define FLASH_REDBOOT_DIR_IMAGE_MAX_SIZE (262144) // Maximum Redboot Directory image size 
#define FLASH_REDBOOT_IMAGE_MAX_SIZE    (1048576) // Maximum Redboot image size 

typedef enum {
   ENUM_FLASH_REDBOOT_CFG_IMAGE_MAX_SIZE = 0x40000UL,
   ENUM_FLASH_REDBOOT_DIR_IMAGE_MAX_SIZE = 0x40000UL,
   ENUM_FLASH_REDBOOT_IMAGE_MAX_SIZE = 0x100000UL
} FLASHROM_REDBOOT_DEFINES;

// --- FLASHROM_BIOS_DEFINES ---
#define FLASH_BIOS_IMAGE_MAX_SIZE       (524288)  // Maximum OPTION ROM image size 

typedef enum {
   ENUM_FLASH_BIOS_IMAGE_MAX_SIZE = 0x80000UL
} FLASHROM_BIOS_DEFINES;

// --- FLASHROM_NCSI_DEFINES ---
#define FLASH_NCSI_IMAGE_MAX_SIZE       (262144)  // Maximum NCSI FW image size 

typedef enum {
   ENUM_FLASH_NCSI_IMAGE_MAX_SIZE = 0x40000UL
} FLASHROM_NCSI_DEFINES;

// --- FLASHROM_FIS_DEFINES ---
#define FIS_iSCSI_NIC_PRIMARY_IMAGE_INDEX (3)     
#define FIS_iSCSI_NIC_BACKUP_IMAGE_INDEX (4)      
#define FIS_FCoE_PRIMARY_IMAGE_INDEX    (5)       
#define FIS_FCoE_BACKUP_IMAGE_INDEX     (6)       
#define FIS_DIR_ENTRY_SIZE              (256)     
#define FIS_DIR_SIZE                    (1792)    
#define FIS_CONFIG_SIZE                 (4096)    

typedef enum {
   ENUM_FIS_iSCSI_NIC_PRIMARY_IMAGE_INDEX = 0x3UL,
   ENUM_FIS_iSCSI_NIC_BACKUP_IMAGE_INDEX = 0x4UL,
   ENUM_FIS_FCoE_PRIMARY_IMAGE_INDEX = 0x5UL,
   ENUM_FIS_FCoE_BACKUP_IMAGE_INDEX = 0x6UL,
   ENUM_FIS_DIR_ENTRY_SIZE = 0x100UL,
   ENUM_FIS_DIR_SIZE = 0x700UL,
   ENUM_FIS_CONFIG_SIZE = 0x1000UL
} FLASHROM_FIS_DEFINES;

// --- FLASHROM_EVENTLOG_DEFINES ---
#define FLASH_EVENTLOG_SIZE             (262144)  

typedef enum {
   ENUM_FLASH_EVENTLOG_SIZE = 0x40000UL
} FLASHROM_EVENTLOG_DEFINES;

// --- FLASHROM_FAT_DEFINES ---
#define FLASH_FAT_SIZE                  (1048576) 

typedef enum {
   ENUM_FLASH_FAT_SIZE = 0x100000UL
} FLASHROM_FAT_DEFINES;

// --- FLASHROM_VPD_DEFINES ---
#define FLASH_VPD_VF_REGION_SIZE        (512)     
#define FLASH_VPD_PF_REGION_SIZE        (1024)    
#define FLASH_VPD_PF_VF_SIZE            (17408)   
#define FLASH_VPD_REGION_SIZE           (262144)  

typedef enum {
   ENUM_FLASH_VPD_VF_REGION_SIZE = 0x200UL,
   ENUM_FLASH_VPD_PF_REGION_SIZE = 0x400UL,
   ENUM_FLASH_VPD_PF_VF_SIZE = 0x4400UL,
   ENUM_FLASH_VPD_REGION_SIZE = 0x40000UL
} FLASHROM_VPD_DEFINES;

// --- FLASHROM_PHY_FW_DEFINES ---
#define FLASH_PHY_FW_IMAGE_MAX_SIZE     (262144)  // Maximum PHY Firmware image size 

typedef enum {
   ENUM_FLASH_PHY_FW_IMAGE_MAX_SIZE = 0x40000UL
} FLASHROM_PHY_FW_DEFINES;

// --- FLASHROM_UFI_DEFINES ---
#define FLASH_UFI_VERSION_SIZE          (4)       
#define FLASH_UFI_BUILD_STR_LEN         (24)      
#define FLASH_UFI_SIGNATURE_SIZE        (52)      
#define FLASH_UFI_HEADER_SIZE           (128)     
#define FLASH_UFI_BIN_SIZE              (16777216) 

typedef enum {
   ENUM_FLASH_UFI_VERSION_SIZE = 0x4UL,
   ENUM_FLASH_UFI_BUILD_STR_LEN = 0x18UL,
   ENUM_FLASH_UFI_SIGNATURE_SIZE = 0x34UL,
   ENUM_FLASH_UFI_HEADER_SIZE = 0x80UL,
   ENUM_FLASH_UFI_BIN_SIZE = 0x1000000UL
} FLASHROM_UFI_DEFINES;

// --- IMAGE_TYPE ---
#define IMAGE_TYPE_BE3                  (1)       // contains BE3 flash image

typedef enum {
   ENUM_IMAGE_TYPE_BE3 = 0x1UL
} IMAGE_TYPE;

// --- IMAGE_HEADER_DEFINES ---
#define IMAGE_HEADER_BUILD_STR_LEN      (32)      
#define IMAGE_HEADER_MAX_IMAGES         (32)      
#define IMAGE_HEADER_SIZE               (48)      

typedef enum {
   ENUM_IMAGE_HEADER_BUILD_STR_LEN = 0x20UL,
   ENUM_IMAGE_HEADER_MAX_IMAGES = 0x20UL,
   ENUM_IMAGE_HEADER_SIZE = 0x30UL
} IMAGE_HEADER_DEFINES;

// --- IMAGE_ENTRY_TYPE ---
#define IMAGE_NCSI                      (16)      
#define IMAGE_OPTION_ROM_PXE            (32)      // contains pxe bios
#define IMAGE_OPTION_ROM_FCoE           (33)      // contains fcoe bios
#define IMAGE_OPTION_ROM_ISCSI          (34)      // contains iscsi bios
#define IMAGE_FLASHISM_JUMPVECTOR       (48)      
#define IMAGE_FLASH_ISM                 (49)      
#define IMAGE_JUMP_VECTOR               (50)      
#define IMAGE_FIRMWARE_iSCSI            (160)     
#define IMAGE_FIRMWARE_COMP_iSCSI       (161)     
#define IMAGE_FIRMWARE_FCoE             (162)     
#define IMAGE_FIRMWARE_COMP_FCoE        (163)     
#define IMAGE_FIRMWARE_BACKUP_iSCSI     (176)     
#define IMAGE_FIRMWARE_BACKUP_COMP_iSCSI (177)    // contains backup iSCSI/NIC firmware
                                                  // compressed
#define IMAGE_FIRMWARE_BACKUP_FCoE      (178)     
#define IMAGE_FIRMWARE_BACKUP_COMP_FCoE (179)     // contains backup FCoE/NIC firmware
                                                  // compressed
#define IMAGE_FIRMWARE_PHY              (192)     
#define IMAGE_BOOT_CODE                 (224)     

typedef enum {
   ENUM_IMAGE_NCSI = 0x10UL,
   ENUM_IMAGE_OPTION_ROM_PXE = 0x20UL,
   ENUM_IMAGE_OPTION_ROM_FCoE = 0x21UL,
   ENUM_IMAGE_OPTION_ROM_ISCSI = 0x22UL,
   ENUM_IMAGE_FLASHISM_JUMPVECTOR = 0x30UL,
   ENUM_IMAGE_FLASH_ISM = 0x31UL,
   ENUM_IMAGE_JUMP_VECTOR = 0x32UL,
   ENUM_IMAGE_FIRMWARE_iSCSI = 0xa0UL,
   ENUM_IMAGE_FIRMWARE_COMP_iSCSI = 0xa1UL,
   ENUM_IMAGE_FIRMWARE_FCoE = 0xa2UL,
   ENUM_IMAGE_FIRMWARE_COMP_FCoE = 0xa3UL,
   ENUM_IMAGE_FIRMWARE_BACKUP_iSCSI = 0xb0UL,
   ENUM_IMAGE_FIRMWARE_BACKUP_COMP_iSCSI = 0xb1UL,
   ENUM_IMAGE_FIRMWARE_BACKUP_FCoE = 0xb2UL,
   ENUM_IMAGE_FIRMWARE_BACKUP_COMP_FCoE = 0xb3UL,
   ENUM_IMAGE_FIRMWARE_PHY = 0xc0UL,
   ENUM_IMAGE_BOOT_CODE = 0xe0UL
} IMAGE_ENTRY_TYPE;

// --- FLASH_DIR_DEFINES ---
#define FLASH_DIR_MAX_CONTROLLER_ID     (8)       
#define FLASH_DIR_NUMBER_OF_ENTRIES     (32)      // Number of entries in the flash
                                                  // directory 
#define FLASH_DIR_COOKIE_SIZE           (32)      // Size of the cookie 

typedef enum {
   ENUM_FLASH_DIR_MAX_CONTROLLER_ID = 0x8UL,
   ENUM_FLASH_DIR_NUMBER_OF_ENTRIES = 0x20UL,
   ENUM_FLASH_DIR_COOKIE_SIZE = 0x20UL
} FLASH_DIR_DEFINES;

#endif // __ioctl_flash_types_enum_h__

