/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_cfg_enum_h__
#define __ioctl_iscsi_ini_cfg_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- ISCSI_HBA_NAME_FLAGS ---
// Bit definition of flags in ISCSI_HBA_NAME_PARAMS 
#define MGMT_ISCSI_HBA_NAME_FLAG_USE_CUSTOM_NAME (0) // User specified name 
#define MGMT_ISCSI_HBA_NAME_FLAG_USE_FACTORY_DEFAULT_NAME (1) // If set, use the factory
                                                              // default name 

typedef enum {
   ENUM_MGMT_ISCSI_HBA_NAME_FLAG_USE_CUSTOM_NAME = 0x0UL,
   ENUM_MGMT_ISCSI_HBA_NAME_FLAG_USE_FACTORY_DEFAULT_NAME = 0x1UL
} ISCSI_HBA_NAME_FLAGS;

// --- ISCSI_HBA_NAME_RSVD_FLAGS ---
// Bit definition of reserved_flags in ISCSI_HBA_NAME_PARAMS
// MGMT_ISCSI_HBA_NAME_RSVD_FLAG_RECONNECT_CLOSED_SESSIONS 
#define MGMT_ISCSI_HBA_NAME_RSVD_FLAG_RECONNECT_CLOSED_SESSIONS (1) // Only applicable in
                                                                    // IOCTL_SET_ISCSI_HBA
                                                                    // _NAME operation. It
                                                                    // is not applicable
                                                                    // in
                                                                    // IOCTL_GET_ISCSI_HBA
                                                                    // _NAME. If set to 1,
                                                                    // after the firmware
                                                                    // changes the HBA's
                                                                    // iSCSI name, the
                                                                    // firmware needs to
                                                                    // reconnect all the
                                                                    // sessions that is
                                                                    // currently closed
                                                                    // due to session
                                                                    // recovery. This only
                                                                    // applicable to
                                                                    // sessions that has
                                                                    // the status with
                                                                    // MGMT_SESSION_STATUS
                                                                    // _CLOSED_IN_RECOVERY
                                                                    // = 1. If set to 0,
                                                                    // after the firmware
                                                                    // change the HBA's
                                                                    // iSCSI name, the
                                                                    // firmware does NOT
                                                                    // need to reconnect
                                                                    // all the sessions
                                                                    // that is currently
                                                                    // closed due to
                                                                    // session recovery. 

typedef enum {
   ENUM_MGMT_ISCSI_HBA_NAME_RSVD_FLAG_RECONNECT_CLOSED_SESSIONS = 0x1UL
} ISCSI_HBA_NAME_RSVD_FLAGS;

#endif // __ioctl_iscsi_ini_cfg_enum_h__

