/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_lowlevel_enum_h__
#define __ioctl_lowlevel_enum_h__
#include "setypes.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_common_enum.h"
#include "host_struct_enum.h"
#include "ioctl_toe_enum.h"
#include "ep_queue_enum.h"
#include "fc_device_context_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- MEMORY_ENUM ---
#define MEMORY_CONTEXT                  (0)       
#define MEMORY_CEV                      (1)       
#define MEMORY_PMEM                     (2)       
#define MEMORY_DBUF                     (3)       
#define MEMORY_DDR                      (4)       
#define MEMORY_CLASSIFICATION_RAM       (6)       
#define MEMORY_TXIPS_RAM                (8)       
#define MEMORY_RXIPS_RAM                (9)       
#define MEMORY_DIRECTORY_TABLE          (10)      

typedef enum {
   ENUM_MEMORY_CONTEXT = 0x0UL,
   ENUM_MEMORY_CEV = 0x1UL,
   ENUM_MEMORY_PMEM = 0x2UL,
   ENUM_MEMORY_DBUF = 0x3UL,
   ENUM_MEMORY_DDR = 0x4UL,
   ENUM_MEMORY_CLASSIFICATION_RAM = 0x6UL,
   ENUM_MEMORY_TXIPS_RAM = 0x8UL,
   ENUM_MEMORY_RXIPS_RAM = 0x9UL,
   ENUM_MEMORY_DIRECTORY_TABLE = 0xaUL
} MEMORY_ENUM;

// --- BE_LOOPBACK_MODE ---
#define MAC_LOOPBACK                    (0)       // MAC loopback mode, transmitted packet
                                                  // is looped back at the MAC.
#define PHY_LOOPBACK                    (1)       // PHY loopback mode, transmitted packet
                                                  // is looped back at the PHY.
#define ONE_PORT_EXT_LOOPBACK           (2)       // External loopback mode, transmitted
                                                  // packet is looped back externally on
                                                  // the same port.
#define TWO_PORT_EXT_LOOPBACK           (3)       // External loopback mode, transmitted
                                                  // packet is looped back externally on
                                                  // different port.
#define NO_LOOPBACK                     (255)     // No loopback mode applied.

typedef enum {
   ENUM_MAC_LOOPBACK = 0x0UL,
   ENUM_PHY_LOOPBACK = 0x1UL,
   ENUM_ONE_PORT_EXT_LOOPBACK = 0x2UL,
   ENUM_TWO_PORT_EXT_LOOPBACK = 0x3UL,
   ENUM_NO_LOOPBACK = 0xffUL
} BE_LOOPBACK_MODE;

// --- BE_LOOPBACK_STATUS ---
#define LOOPBACK_SUCCESS                (0)       // Loopback mode passed successfully.
#define LOOPBACK_TRANSMIT_FAILURE       (1)       // An error occurred in the transmit
                                                  // path of the loopback test.
#define LOOPBACK_RECEIVE_FAILURE        (2)       // An error occurred in the receive path
                                                  // of the loopback test.
#define LOOPBACK_DATA_MISMATCH          (3)       // Data integrity failure in the
                                                  // transmitted vs. received packet.
#define LOOPBACK_TIMEOUT                (4)       // Timed out on loopback IOCTL.
#define LOOPBACK_LINK_DOWN_FAILURE      (5)       // An error occured due to link down on
                                                  // the port.

typedef enum {
   ENUM_LOOPBACK_SUCCESS = 0x0UL,
   ENUM_LOOPBACK_TRANSMIT_FAILURE = 0x1UL,
   ENUM_LOOPBACK_RECEIVE_FAILURE = 0x2UL,
   ENUM_LOOPBACK_DATA_MISMATCH = 0x3UL,
   ENUM_LOOPBACK_TIMEOUT = 0x4UL,
   ENUM_LOOPBACK_LINK_DOWN_FAILURE = 0x5UL
} BE_LOOPBACK_STATUS;

// --- LOOPBACK_STATE_ENUM ---
#define LOOPBACK_STATE_DISABLE          (0)       
#define LOOPBACK_STATE_ENABLE           (1)       // Enable Loopback mode

typedef enum {
   ENUM_LOOPBACK_STATE_DISABLE = 0x0UL,
   ENUM_LOOPBACK_STATE_ENABLE = 0x1UL
} LOOPBACK_STATE_ENUM;

#endif // __ioctl_lowlevel_enum_h__

