/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_mili_ptl_enum_h__
#define __ioctl_mili_ptl_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- ISCSIPORTALROLES ---
// "A portal can operate in one or both of two roles: as a target portal and/or an
// initiator portal. If the portal will operate in both roles, both bits must be set. This
// object will define a corresponding row that will exist or must be created in the
// iscsiTgtPortalAttributesTable, the iscsiIntrPortalAttributesTable or both. If the
// targetTypePortal bit is set, one or more corresponding iscsiTgtPortalAttributesEntry
// rows will be found or created. If the initiatorTypePortal bit is set, one or more
// corresponding iscsiIntrPortalAttributesEntry rows will be found or created. If both
// bits are set, one or more corresponding rows will be found or created in one of the
// above tables." 
#define ISCSIPORTALROLES_TARGETTYPEPORTAL (0)     
#define ISCSIPORTALROLES_INITIATORTYPEPORTAL (1)  

typedef enum {
   ENUM_ISCSIPORTALROLES_TARGETTYPEPORTAL = 0x0UL,
   ENUM_ISCSIPORTALROLES_INITIATORTYPEPORTAL = 0x1UL
} ISCSIPORTALROLES;

// --- INETADDRESSTYPE ---
// "A value that represents a type of Internet address. unknown(0) An unknown address
// type. This value MUST be used if the value of the corresponding InetAddress object is a
// zero-length string. It may also be used to indicate an IP address that is not in one of
// the formats defined below. ipv4(1) An IPv4 address as defined by the InetAddressIPv4
// textual convention. ipv6(2) An IPv6 address as defined by the InetAddressIPv6 textual
// convention. ipv4z(3) A non-global IPv4 address including a zone index as defined by the
// InetAddressIPv4z textual convention. ipv6z(4) A non-global IPv6 address including a
// zone index as defined by the InetAddressIPv6z textual convention. dns(16) A DNS domain
// name as defined by the InetAddressDNS textual convention. Each definition of a concrete
// InetAddressType value must be accompanied by a definition of a textual convention for
// use with that InetAddressType. To support future extensions, the InetAddressType
// textual convention SHOULD NOT be sub-typed in object type definitions. It MAY be
// sub-typed in compliance statements in order to require only a subset of these address
// types for a compliant implementation. Implementations must ensure that InetAddressType
// objects and any dependent objects (e.g., InetAddress objects) are consistent. An
// inconsistentValue error must be generated if an attempt to change an InetAddressType
// object would, for example, lead to an undefined InetAddress value. In particular,
// InetAddressType/InetAddress pairs must be changed together if the address type changes
// (e.g., from ipv6(2) to ipv4(1))." 
#define INETADDRESSTYPE_UNKNOWN         (0)       
#define INETADDRESSTYPE_IPV4            (1)       
#define INETADDRESSTYPE_IPV6            (2)       
#define INETADDRESSTYPE_IPV4Z           (3)       
#define INETADDRESSTYPE_IPV6Z           (4)       
#define INETADDRESSTYPE_DNS             (16)      

typedef enum {
   ENUM_INETADDRESSTYPE_UNKNOWN = 0x0UL,
   ENUM_INETADDRESSTYPE_IPV4 = 0x1UL,
   ENUM_INETADDRESSTYPE_IPV6 = 0x2UL,
   ENUM_INETADDRESSTYPE_IPV4Z = 0x3UL,
   ENUM_INETADDRESSTYPE_IPV6Z = 0x4UL,
   ENUM_INETADDRESSTYPE_DNS = 0x10UL
} INETADDRESSTYPE;

// --- ISCSIDIGESTMETHOD ---
// "This data type represents the methods possible for digest negotiation. none - a
// placeholder for a secondary digest method that means only the primary method can be
// used. other - a digest method other than those defined below. noDigest - does not
// support digests (will operate without a digest (Note: implementations must support
// digests to be compliant with the RFC3720). CRC32c - require a CRC32C digest." 
#define ISCSIDIGESTMETHOD_NONE          (1)       
#define ISCSIDIGESTMETHOD_OTHER         (2)       
#define ISCSIDIGESTMETHOD_NODIGEST      (3)       
#define ISCSIDIGESTMETHOD_CRC32C        (4)       

typedef enum {
   ENUM_ISCSIDIGESTMETHOD_NONE = 0x1UL,
   ENUM_ISCSIDIGESTMETHOD_OTHER = 0x2UL,
   ENUM_ISCSIDIGESTMETHOD_NODIGEST = 0x3UL,
   ENUM_ISCSIDIGESTMETHOD_CRC32C = 0x4UL
} ISCSIDIGESTMETHOD;

// --- TRUTHVALUE ---
// "Represents a boolean value." 
#define TRUTHVALUE_TRUE                 (1)       
#define TRUTHVALUE_FALSE                (2)       

typedef enum {
   ENUM_TRUTHVALUE_TRUE = 0x1UL,
   ENUM_TRUTHVALUE_FALSE = 0x2UL
} TRUTHVALUE;

// --- STORAGETYPE ---
// "Describes the memory realization of a conceptual row. A row which is volatile(2) is
// lost upon reboot. A row which is either nonVolatile(3), permanent(4) or readOnly(5), is
// backed up by stable storage. A row which is permanent(4) can be changed but not
// deleted. A row which is readOnly(5) cannot be changed nor deleted. If the value of an
// object with this syntax is either permanent(4) or readOnly(5), it cannot be written.
// Conversely, if the value is either other(1), volatile(2) or nonVolatile(3), it cannot
// be modified to be permanent(4) or readOnly(5). (All illegal modifications result in a
// 'wrongValue' error.) Every usage of this textual convention is required to specify the
// columnar objects which a permanent(4) row must at a minimum allow to be writable." 
#define STORAGETYPE_OTHER               (1)       
#define STORAGETYPE_VOLATILE            (2)       
#define STORAGETYPE_NONVOLATILE         (3)       
#define STORAGETYPE_PERMANENT           (4)       
#define STORAGETYPE_READONLY            (5)       

typedef enum {
   ENUM_STORAGETYPE_OTHER = 0x1UL,
   ENUM_STORAGETYPE_VOLATILE = 0x2UL,
   ENUM_STORAGETYPE_NONVOLATILE = 0x3UL,
   ENUM_STORAGETYPE_PERMANENT = 0x4UL,
   ENUM_STORAGETYPE_READONLY = 0x5UL
} STORAGETYPE;

// --- ISCSINODEROLES ---
// "A node can operate in one or both of two roles: a target role and/or an initiator
// role. If the node will operate in both roles, both bits must be set. This object will
// also define the corresponding rows that will exist in the iscsiTargetAttributesTable,
// the iscsiInitiatorAttributesTable or both. If the targetTypeNode bit is set, there will
// be a corresponding iscsiTargetAttributesEntry. If the initiatorTypeNode bit is set,
// there will be a corresponding iscsiInitiatorAttributesEntry. If both bits are set,
// there will be a corresponding iscsiTgtPortalAttributesEntry and
// iscsiPortalAttributesEntry." 
#define ISCSINODEROLES_TARGETTYPENODE   (0)       
#define ISCSINODEROLES_INITIATORTYPENODE (1)      

typedef enum {
   ENUM_ISCSINODEROLES_TARGETTYPENODE = 0x0UL,
   ENUM_ISCSINODEROLES_INITIATORTYPENODE = 0x1UL
} ISCSINODEROLES;

// --- ISCSISSNDIRECTION ---
// "Direction of iSCSI session: inboundSession - session is established from an external
// initiator to a target within this iSCSI instance. outboundSession - session is
// established from an initiator within this iSCSI instance to an external target." 
#define ISCSISSNDIRECTION_INBOUNDSESSION (1)      
#define ISCSISSNDIRECTION_OUTBOUNDSESSION (2)     

typedef enum {
   ENUM_ISCSISSNDIRECTION_INBOUNDSESSION = 0x1UL,
   ENUM_ISCSISSNDIRECTION_OUTBOUNDSESSION = 0x2UL
} ISCSISSNDIRECTION;

// --- ISCSISSNTYPE ---
// "Type of iSCSI session: normalSession - session is a normal iSCSI session
// discoverySession - session is being used only for discovery." 
#define ISCSISSNTYPE_NORMALSESSION      (1)       
#define ISCSISSNTYPE_DISCOVERYSESSION   (2)       

typedef enum {
   ENUM_ISCSISSNTYPE_NORMALSESSION = 0x1UL,
   ENUM_ISCSISSNTYPE_DISCOVERYSESSION = 0x2UL
} ISCSISSNTYPE;

// --- ISCSICXNSTATE ---
// "The current state of this connection, from an iSCSI negotiation point of view. Here
// are the states: login - The transport protocol connection has been established, but a
// valid iSCSI login response with the final bit set has not been sent or received. full -
// A valid iSCSI login response with the final bit set has been sent or received. logout -
// A valid iSCSI logout command has been sent or received, but the transport protocol
// connection has not yet been closed." 
#define ISCSICXNSTATE_LOGIN             (1)       
#define ISCSICXNSTATE_FULL              (2)       
#define ISCSICXNSTATE_LOGOUT            (3)       

typedef enum {
   ENUM_ISCSICXNSTATE_LOGIN = 0x1UL,
   ENUM_ISCSICXNSTATE_FULL = 0x2UL,
   ENUM_ISCSICXNSTATE_LOGOUT = 0x3UL
} ISCSICXNSTATE;

#endif // __ioctl_mili_ptl_enum_h__

