/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_pxe_undi_enum_h__
#define __ioctl_pxe_undi_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- UNDI_OP_TYPE ---
#define UNDI_START                      (0)       // Create an UNDI Task; No other UNDI
                                                  // IOCTLs will be processed until this
                                                  // IOCTL.
#define UNDI_STOP                       (1)       // Kill the UNDI Task. An UNDI_START
                                                  // must be issued after this to process
                                                  // further UNDI IOCTLs. All UNDI
                                                  // parameters (MCAST list, MAC address,
                                                  // Filter and statistics) are cleared 
#define UNDI_INITIALIZE                 (2)       // This call resets the adapter and
                                                  // programs it with default parameters.
                                                  // All settings (MCAST list, MAC
                                                  // address, Filters and statistics) are
                                                  // cleared. 
#define UNDI_SHUTDOWN                   (3)       // This call resets the network adapter
                                                  // and leaves it in a safe state for
                                                  // another driver to program it.
#define UNDI_OPEN                       (4)       // This IOCTL sets the adapter ready to
                                                  // accept packets for transmit and
                                                  // receive. No UNDI_Transmit or
                                                  // UNDI_Receive IOCTLs will be processed
                                                  // until this IOCTL.
#define UNDI_CLOSE                      (5)       // This IOCTL disconnects the network
                                                  // adapter from the network. Packets
                                                  // cannot be transmitted or received
                                                  // until the network adapter is open
                                                  // again. No UNDI_Transmit or
                                                  // UNDI_Receive IOCTLs can be issued
                                                  // after this IOCTL. 
#define UNDI_SET_FILTER                 (6)       // Set the new receive filter. 

typedef enum {
   ENUM_UNDI_START = 0x0UL,
   ENUM_UNDI_STOP = 0x1UL,
   ENUM_UNDI_INITIALIZE = 0x2UL,
   ENUM_UNDI_SHUTDOWN = 0x3UL,
   ENUM_UNDI_OPEN = 0x4UL,
   ENUM_UNDI_CLOSE = 0x5UL,
   ENUM_UNDI_SET_FILTER = 0x6UL
} UNDI_OP_TYPE;

// --- UNDI_FILTER ---
#define FLTR_DIRECTED                   (1)       
#define FLTR_BRDCST                     (2)       
#define FLTR_PRMSCS                     (4)       
#define FLTR_SRC_RTG                    (8)       // Source Routing 

typedef enum {
   ENUM_FLTR_DIRECTED = 0x1UL,
   ENUM_FLTR_BRDCST = 0x2UL,
   ENUM_FLTR_PRMSCS = 0x4UL,
   ENUM_FLTR_SRC_RTG = 0x8UL
} UNDI_FILTER;

// --- UNDI_FILTER_TYPE ---
#define UNDI_FLTR_DIRECTED              (1)       
#define UNDI_FLTR_BRDCST                (2)       
#define UNDI_FLTR_PRMSCS                (4)       
#define UNDI_FLTR_SRC_RTG               (8)       

typedef enum {
   ENUM_UNDI_FLTR_DIRECTED = 0x1UL,
   ENUM_UNDI_FLTR_BRDCST = 0x2UL,
   ENUM_UNDI_FLTR_PRMSCS = 0x4UL,
   ENUM_UNDI_FLTR_SRC_RTG = 0x8UL
} UNDI_FILTER_TYPE;

// --- UNDI_VLAN_STATUS ---
#define UNDI_VLAN_DISABLED              (0)       
#define UNDI_VLAN_ENABLED               (1)       

typedef enum {
   ENUM_UNDI_VLAN_DISABLED = 0x0UL,
   ENUM_UNDI_VLAN_ENABLED = 0x1UL
} UNDI_VLAN_STATUS;

#endif // __ioctl_pxe_undi_enum_h__

