/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_vpd_enum_h__
#define __ioctl_vpd_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "nativedefs_enum.h"
#include "ioctl_defs_enum.h"
#include "ioctl_opcodes_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- VPD_FUNCTION_TYPE ---
// Function Type for which VPD is requested. Only functions 2 & 3 in BE3 can have value
// other than 0. 
#define VPD_FUNCTION_TYPE_NIC           (0)       
#define VPD_FUNCTION_TYPE_ISCSI         (1)       
#define VPD_FUNCTION_TYPE_FCOE          (2)       

typedef enum {
   ENUM_VPD_FUNCTION_TYPE_NIC = 0x0UL,
   ENUM_VPD_FUNCTION_TYPE_ISCSI = 0x1UL,
   ENUM_VPD_FUNCTION_TYPE_FCOE = 0x2UL
} VPD_FUNCTION_TYPE;

// --- VPD_VF_TYPE ---
#define VPD_VF_TYPE_PF                  (0)       // This is a Physical function 
#define VPD_VF_TYPE_VF                  (1)       // This is a Virtual Function 

typedef enum {
   ENUM_VPD_VF_TYPE_PF = 0x0UL,
   ENUM_VPD_VF_TYPE_VF = 0x1UL
} VPD_VF_TYPE;

// --- VPD_DATA_STORE_SIZE ---
// VPD data sizes for physical function and virtual functions. 
#define VPD_DATA_STORE_SIZE_VF          (512)     
#define VPD_DATA_STORE_SIZE_PF          (1024)    

typedef enum {
   ENUM_VPD_DATA_STORE_SIZE_VF = 0x200UL,
   ENUM_VPD_DATA_STORE_SIZE_PF = 0x400UL
} VPD_DATA_STORE_SIZE;

#endif // __ioctl_vpd_enum_h__

