/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ipc_fw_impl_enum_h__
#define __ipc_fw_impl_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "descriptors_enum.h"
#include "iscsi_common_host_struct_enum.h"
#include "ep_queue_enum.h"
#include "fw_exp_enum.h"
#include "host_struct_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- IPC_CODES ---
#define IPC_TCP_STATE                   (0)       // IPC used by processors to inform of a
                                                  // state change 
#define IPC_TCP_RETRANSMIT              (1)       // IPC informing TxULP of the need for a
                                                  // retransmit 
#define IPC_PROC_HEARTBEAT              (2)       // Heartbeat message between processors
                                                  // and MPU 
#define IPC_WRB_COMPLETE                (3)       // WRB Complete. Used for TxULP to RxULP
                                                  // WRB completion for WRBs that do not
                                                  // produce a response. Specifically,
                                                  // this message code is sent from iSCSI
                                                  // TxULP to RxULP on NOP-out iSCSI
                                                  // commands since no response is
                                                  // expected. 
#define IPC_RESET_RTT                   (4)       // TPRE sends this IPC to TPOST to reset
                                                  // t_rtt to 0 
#define IPC_TCP_REXMT_COMPLETE          (5)       // TPOST sends this IPC to TPRE to
                                                  // communicate that it needs to get out
                                                  // of retransmit 
#define IPC_SET_REXMT_TIMER             (6)       // Message asking TPRE to set the
                                                  // retransmit timer 
#define IPC_LRO_CREDIT_UPDATE           (7)       // Send by RXULP to TPRE to return LRO
                                                  // receive credits 
#define IPC_SET_PUSH_TIMER              (9)       // Sent by the ulp application to set
                                                  // the push timer 
#define IPC_TOE_UPLOAD_ACCEPT           (10)      // Sent by the txulp2 application to
                                                  // mpu, indicate toe reset/upload accept
#define IPC_TOE_UPLOAD_REJECT           (11)      // Sent by the txulp2 application to
                                                  // mpu, indicate toe upload reject 
#define IPC_TOE_RESET_INITIATE          (12)      // Sent by the tpre application to mpu
                                                  // to start tcp reset 
#define IPC_TOE_FLUSH                   (13)      // Used between txulp2 and tpost, to
                                                  // initiate or indicate completion a
                                                  // flush TX_D 
#define IPC_WINDOW_UPDATE               (14)      // Sent by RXULP to TPRE for a window
                                                  // factor update 
#define IPC_TCP_UPLOAD                  (15)      // Circulates from txulp to tpost to
                                                  // tpre and finally to rxulp. Forces an
                                                  // upload to happen 
#define IPC_ETX_FLUSH                   (16)      // Used between txulp2 and tpost, to
                                                  // initiate or indicate completion a
                                                  // flush TX_D 
#define IPC_TCP_PERSIST                 (17)      // IPC sent by tpre to tpost when send
                                                  // window goes down to zero 
#define IPC_STAT_READ                   (18)      // IPC sent between mpu and other ep
                                                  // when reading the statistics data 
#define IPC_ISCSI_FLUSH                 (19)      // Used between txulp1 and tpost and
                                                  // rxulp1, to initiate or indicate
                                                  // completion an iSCSI flush IPC_TX_D.
                                                  // The original ISCSI_RRMSG is carried
                                                  // through as opaque data
                                                  // (ISCSI_RRMSG.dw[0] in opaque0 and the
                                                  // lower 2 bytes of ISCSI_RRMSG.dw[1] in
                                                  // opaque1) in IPC_TX_D, and TPost will
                                                  // generate IPC_ISCSI_D (rrmsg
                                                  // reconstructed from above opaque data)
                                                  // to rxulp1 on completion of the flush
                                                  // request. 
#define IPC_ISCSI_RST_CONN              (20)      // IPC sent by RXULP1 to TXULP1 when tcp
                                                  // RST is received on the iSCSI
                                                  // connection, or sent from TXULP1 to
                                                  // TPOST to request sending tcp RST on
                                                  // the iSCSI connection 
#define IPC_ISCSI_ICD_INVL_FREE         (21)      // IPC sent by TXULP1 to RXULP1 for the
                                                  // cmd/icd invalidation request received
                                                  // from ARM/driver 
#define IPC_ISCSI_CONN_INVL_FREE        (22)      // IPC sent by TXULP1 to RXULP1 for
                                                  // connection free request received from
                                                  // ARM/driver 
#define IPC_ISCSI_UPLOAD                (23)      // Circulates from txulp1 to tpost to
                                                  // tpre and finally to rxulp1. Forces an
                                                  // upload to happen 
#define IPC_ISCSI_UPLOAD_ACCEPT         (24)      // Sent by the txulp2 to ARM, indicate
                                                  // iscsi reset/upload accept 
#define IPC_ISCSI_UPLOAD_REJECT         (25)      // Sent by the txulp1 to ARM, indicate
                                                  // iscsi upload reject 
#define IPC_HEALTH_CHECK                (26)      // IPC sent by ARM to EP for health
                                                  // checking 
#define IPC_RDMA_UPLOAD_ACCEPT          (27)      // Sent by the txulp2 application to
                                                  // mpu, indicate toe reset/upload accept
#define IPC_RDMA_UPLOAD_REJECT          (28)      // Sent by the txulp2 application to
                                                  // mpu, indicate toe upload reject 
#define IPC_RDMA_RESET_INITIATE         (29)      // Sent by the tpre application to mpu
                                                  // to start tcp reset 
#define IPC_RDMA_FLUSH                  (30)      // Used between txulp2 and tpost, to
                                                  // initiate or indicate completion a
                                                  // flush TX_D 
#define IPC_ETX_FLUSH_MPU               (31)      // Used between txulp2 and tpost, to
                                                  // initiate or indicate completion a
                                                  // flush TX_D. Originates and ends at
                                                  // the MPU. An IPC is sent to MPU on
                                                  // completion to signal status 
#define IPC_DEFQ_FLUSH                  (32)      // Used between mpu and rxulps to
                                                  // initiate a default buffer queue
                                                  // flush. Originates and ends at the
                                                  // MPU. 
#define IPC_TOE_DEFQ_FLUSH              (32)      // Used between mpu and rxulp2 to
                                                  // initiate a TOE default buffer queue
                                                  // flush. Originates and ends at the
                                                  // MPU. 
#define IPC_TCP_PARAMS_CONTROL          (33)      // This is the code to set the tcp
                                                  // parameters in the tpost and the tpre.
                                                  // IPC_TCP_PARAMS_SUBCODES is used to
                                                  // communicate the intent 
#define IPC_RXULP_CREDIT_UPDATE         (34)      // Credit update from the rxulp for
                                                  // chutes that implement buffer credits.
                                                  // the cid will be the protection domain
                                                  // and the subcode will be the number of
                                                  // credits to update 
#define IPC_QOS_UPDATE                  (35)      // This message is sent by the MPU to
                                                  // the ULP via a rr message. The subcode
                                                  // distinguishes between different types
                                                  // of rate control updates. See
                                                  // IPC_QOS_UPDATE_SUBCODES. The second
                                                  // dword of the rr message should
                                                  // contain the new rate control value. 
#define IPC_JELLM_THROTTLE              (36)      // This message is sent by tpost to all
                                                  // the txulps when the JELLM free count
                                                  // drops to the low threshold and
                                                  // subsequently when it gets back to the
                                                  // high threshold 
#define IPC_ISCSI_QOS_UPDATE            (37)      // This message is sent by ARM/MPU to
                                                  // iSCSI TXULP to set the new iSCSI QoS
                                                  // max. counters (IOPS, bytes). 
#define IPC_TCP_UPDATE                  (38)      // Per connection TCP update ipc sent by
                                                  // ARM 
#define IPC_OOO_JELLM_FLUSH             (39)      // IPC to send request to toetx to
                                                  // cleanup the OOO JELLMs 
#define IPC_DEFAULT_PDU_FLUSH           (40)      // IPC to flush the default PDU buffers
                                                  // in iSCSI Rx ULP. 
#define IPC_ISCSI_SGL_SIZE              (41)      // This message is sent by ARM/MPU to
                                                  // iSCSI TXULP and RXULP to tell the
                                                  // size of SGL used. 
#define IPC_EP_NOOP                     (42)      // As the name indicates, the IPC is a
                                                  // noop. EPs should silently discard
                                                  // this IPC. Used for diagnostic
                                                  // purposes. 
#define IPC_TPRE_B2B                    (43)      // Used by tpre to break B2B 
#define IPC_LRO_FLUSH_RXULP_MPU         (44)      // Used by RxULP to indicate flush
                                                  // completion to MPU for LRO Rings 
#define IPC_FC_RELEASE_WRBS             (45)      // Used by FCoE TxULP to RxULP to send
                                                  // WRB release completion status to the
                                                  // host driver 
#define IPC_ISCSI_CTXT_UPDATE           (46)      // Used by iSCSI TxULP to RxULP to send
                                                  // WRB release completion status to the
                                                  // host driver 
#define IPC_FC_TRANSMIT_ABTS            (47)      // Used by FCoE RxULP to request that
                                                  // TxULP transmit an ABTS frame for the
                                                  // given exchange
#define IPC_FC_TRANSMIT_REC             (48)      // Used by FCoE RxULP to request that
                                                  // TxULP transmit an REC frame for the
                                                  // given exchange
#define IPC_FC_TRANSMIT_SRR             (49)      // Used by FCoE RxULP to request that
                                                  // TxULP transmit an SRR frame for the
                                                  // given exchange
#define IPC_FC_HOST_ABORT               (50)      // Used by FCoE TxULP to pass a host
                                                  // ABORT WQE to RxULP.
#define IPC_FC_TRANSMIT_ELS_REPLY       (52)      // Used by FCoE RxULP to request that
                                                  // TxULP transmit an ELS REPLY.
#define IPC_TCP_JRNL_PAGES_INIT         (53)      // IPC from MPU to TPOST indicating that
                                                  // the journal pages are allocated and
                                                  // programmed into the TPOST CSRs 
#define IPC_FC_TRANSMIT_RRQ             (54)      // Used by FCoE RxULP to request that
                                                  // TxULP transmit an RRQ frame for the
                                                  // given exchange
#define IPC_FC_TRANSMIT_CONFIRM_IU      (55)      // Used by FCoE RxULP to request that
                                                  // TxULP transmit an FCP CONFIRM IU for
                                                  // the given exchange
#define IPC_FC_CONFIRM_IU_TRANSMITTED   (56)      // Used by FCoE TxULP to reply to the
                                                  // RxULP that the FCP CONFIRM IU has
                                                  // been transmitted for the given
                                                  // exchange
#define IPC_FC_TRANSMIT_BA_ACC          (57)      // Used by FCoE RxULP to request that
                                                  // TxULP transmit a BA_ACC in reply to
                                                  // ABTS for the given exchange
#define IPC_FC_TRANSMIT_BA_RJT          (58)      // Used by FCoE RxULP to request that
                                                  // TxULP transmit a BA_RJT in reply to
                                                  // ABTS for the given exchange
#define IPC_FC_COMPLETE_WQ              (59)      // Used by FCoE TxULP to request that
                                                  // RxULP post a CQE to complete a WQE
                                                  // when there is an error or no response
                                                  // will be solicited.
#define IPC_FC_HEADER_TEMPLATE_UPDATE   (60)      // Sent by MPU/ARM to TxULP to convey
                                                  // host registered RPI based header
                                                  // template base address.
#define IPC_FC_BLS_RSP_TRANSMITTED      (61)      // Used by FCoE TxULP to request that
                                                  // RxULP post an XRI_ABORTED CQE for the
                                                  // aborted I/O.
#define IPC_FC_SET_PER_PRIORITY_CLASS   (62)      // Sent by MPU/ARM to TxULP to change
                                                  // 'per_priority_class' setting in TX_D
                                                  // for transmitting FCoE frames.
#define IPC_FC_UNREG_RPI_COMPLETE       (63)      // Sent by RxULP to ARM when UNREG_RPI
                                                  // search has completed. NOTE: same code
                                                  // as IPC_FC_ABORT_SCAN_COMPLETE.
#define IPC_FC_ABORT_SCAN_COMPLETE      (63)      // Sent by RxULP to TxULP when ABORT
                                                  // search has completed. NOTE: same code
                                                  // as IPC_FC_UNREG_RPI_COMPLETE.
#define IPC_ISCSI_OOO                   (64)      // IPC sent by iscsi rxulp to iscsi
                                                  // txulp during OOO replay process. 
#define IPC_USE_OUTER_VLAN_TAGS         (65)      // IPC from MPU to TPOST advertising
                                                  // outer vlan tags to use on the 8
                                                  // physical functions. The IPC sent is
                                                  // documented in the structure
                                                  // IPC_OUTER_VLAN_TAGS_D 
#define IPC_DAL_MR_UNREGISTER           (66)      // Used by DAL to flush RXULP and TXULP
                                                  // as part of MR Unregister processing
#define IPC_DAL_QP_DESTROY              (67)      // Used by DAL as part of flush
                                                  // mechanism for QP Destroy processing
#define IPC_ISCSI_GLOBAL_QOS_ENABLE     (68)      // Used by iscsi for global QOS.
#define IPC_ISCSI_GLOBAL_QOS_DISABLE    (69)      // Used by iscsi for global QOS.
#define IPC_PFC_ENABLE                  (70)      // Sent by the ARM to txulp1 to enable
                                                  // generation of Priority-based Flow
                                                  // Control (PFC) frames. 
#define IPC_FC_LINK_STATUS              (71)      // Used by MPU/ARM to report a change in
                                                  // link status to RxULP or TxULP.
#define IPC_DEFQ_CREATE                 (72)      // Sent by MPU/ARM to RxULP when an FCoE
                                                  // RQ is created
#define IPC_FC_INVALIDATE_RING_CONTEXT  (73)      // Sent by MPU/ARM to TxULP to
                                                  // invalidate a FC_WRB_RING_CONTEXT
                                                  // during reset/driver unload
#define IPC_FC_RESUME_RPI               (74)      // Used by MPU/ARM to request that RxULP
                                                  // resume all I/Os associated with the
                                                  // given RPI context.
#define IPC_FC_CONFIG_PFC               (75)      // Used by MPU/ARM to send threshold and
                                                  // timer values to both the RxULP and
                                                  // TPRE to tune the PFC logic.
#define IPC_TCP_WINDOW_SHRINK           (76)      // Per connection TCP window bytes to
                                                  // shrink 
#define IPC_PFC_DISABLE                 (77)      // Sent by the ARM to txulp1 to disable
                                                  // generation of Priority-based Flow
                                                  // Control (PFC) frames. 
#define IPC_TPOST_WR_JRNL               (78)      // Used on a passthru tx_d to txp to
                                                  // write a journal. Valid on BE3 only 
#define IPC_FC_CONFIG_PFC_COS           (79)      // Used by MPU/ARM to the send the class
                                                  // of service on which PFC frames are
                                                  // sent to the TPRE.
#define IPC_FC_CONFIG_PFC_TXD           (80)      // Used by MPU/ARM to send port,
                                                  // num_segs and max_txd_data_len to
                                                  // TxULP0 to tune the PFC logic.
#define IPC_TXULP_EXCESS_DISABLE        (81)      // Sent by tpost to txulp0 and txulp1 to
                                                  // indicate that it has run out of
                                                  // excess bandwidth. The subcode
                                                  // indicates the relevant port number. 
#define IPC_TXULP_EXCESS_ENABLE         (82)      // Sent by tpost to txulp0 and txulp1 to
                                                  // indicate that excess bandwidth is
                                                  // available for both port 0 and port1.
                                                  // The IPC id documented by the
                                                  // descriptor IPC_TXULP_EXCESS_ENABLE_D 
#define IPC_LLDP_SET_MAC_IDS            (83)      // Sent by ARMfw to TPRE to set the
                                                  // MAC_IDs to be used for LLDP punting.
                                                  // The lower 8 bits of the sub_code is
                                                  // the MAC_ID to be used for punting
                                                  // LLDP frames arriving on Port 0. The
                                                  // upper 8 bits of the sub_code is the
                                                  // MAC_ID to be used for punting LLDP
                                                  // frames arriving on Port 1. 
#define IPC_TXULP_EXCESS_SPACING        (84)      // Sent by mpu to txulp to change the
                                                  // excess qos transmit spacing. The IPC
                                                  // id documented by the descriptor
                                                  // IPC_TXULP_EXCESS_SPACING_D. 
#define IPC_TPRE_ADVANCE_PUSH_TMR       (85)      // Sent by rxulp to tpre for advancing
                                                  // push timer 
#define IPC_FC_ARM_DEF_RING             (86)      // This IPC is sent by ARM to RxULP.
                                                  // This IPC contains RQ and CQ ID's of
                                                  // default RQ and CQ rings used by ARM
                                                  // to communicate with RXULP. This IPC
                                                  // should be sent before any RQ is
                                                  // created. 
#define IPC_SET_EP_OPTIONS              (87)      // This IPC is sent by ARM to any EP to
                                                  // enable or disable dynamic options
                                                  // supported by that EP. The sub_code
                                                  // field of the IPC_HEADER specifies
                                                  // which option set is to be set. Used
                                                  // with IPC_SETBIT_D. 
#define IPC_GET_EP_OPTIONS              (88)      // This IPC is sent by ARM to any EP to
                                                  // query dynamic options supported by
                                                  // that EP. The sub_code field of the
                                                  // IPC_HEADER specifies whihc option set
                                                  // is to be retrieved. Used with
                                                  // IPC_GETBIT_D. 
#define IPC_FC_RETURN_CREDIT            (89)      // IPC sent from txulp to rxulp to
                                                  // return credit. 
#define IPC_FC_EP_UNREG_RPI_COMPLETE    (90)      // Sent by RxULP to TxULP when UNREG_RPI
                                                  // search has completed. 

typedef enum {
   ENUM_IPC_TCP_STATE = 0x0UL,
   ENUM_IPC_TCP_RETRANSMIT = 0x1UL,
   ENUM_IPC_PROC_HEARTBEAT = 0x2UL,
   ENUM_IPC_WRB_COMPLETE = 0x3UL,
   ENUM_IPC_RESET_RTT = 0x4UL,
   ENUM_IPC_TCP_REXMT_COMPLETE = 0x5UL,
   ENUM_IPC_SET_REXMT_TIMER = 0x6UL,
   ENUM_IPC_LRO_CREDIT_UPDATE = 0x7UL,
   ENUM_IPC_SET_PUSH_TIMER = 0x9UL,
   ENUM_IPC_TOE_UPLOAD_ACCEPT = 0xaUL,
   ENUM_IPC_TOE_UPLOAD_REJECT = 0xbUL,
   ENUM_IPC_TOE_RESET_INITIATE = 0xcUL,
   ENUM_IPC_TOE_FLUSH = 0xdUL,
   ENUM_IPC_WINDOW_UPDATE = 0xeUL,
   ENUM_IPC_TCP_UPLOAD = 0xfUL,
   ENUM_IPC_ETX_FLUSH = 0x10UL,
   ENUM_IPC_TCP_PERSIST = 0x11UL,
   ENUM_IPC_STAT_READ = 0x12UL,
   ENUM_IPC_ISCSI_FLUSH = 0x13UL,
   ENUM_IPC_ISCSI_RST_CONN = 0x14UL,
   ENUM_IPC_ISCSI_ICD_INVL_FREE = 0x15UL,
   ENUM_IPC_ISCSI_CONN_INVL_FREE = 0x16UL,
   ENUM_IPC_ISCSI_UPLOAD = 0x17UL,
   ENUM_IPC_ISCSI_UPLOAD_ACCEPT = 0x18UL,
   ENUM_IPC_ISCSI_UPLOAD_REJECT = 0x19UL,
   ENUM_IPC_HEALTH_CHECK = 0x1aUL,
   ENUM_IPC_RDMA_UPLOAD_ACCEPT = 0x1bUL,
   ENUM_IPC_RDMA_UPLOAD_REJECT = 0x1cUL,
   ENUM_IPC_RDMA_RESET_INITIATE = 0x1dUL,
   ENUM_IPC_RDMA_FLUSH = 0x1eUL,
   ENUM_IPC_ETX_FLUSH_MPU = 0x1fUL,
   ENUM_IPC_DEFQ_FLUSH = 0x20UL,
   ENUM_IPC_TOE_DEFQ_FLUSH = 0x20UL,
   ENUM_IPC_TCP_PARAMS_CONTROL = 0x21UL,
   ENUM_IPC_RXULP_CREDIT_UPDATE = 0x22UL,
   ENUM_IPC_QOS_UPDATE = 0x23UL,
   ENUM_IPC_JELLM_THROTTLE = 0x24UL,
   ENUM_IPC_ISCSI_QOS_UPDATE = 0x25UL,
   ENUM_IPC_TCP_UPDATE = 0x26UL,
   ENUM_IPC_OOO_JELLM_FLUSH = 0x27UL,
   ENUM_IPC_DEFAULT_PDU_FLUSH = 0x28UL,
   ENUM_IPC_ISCSI_SGL_SIZE = 0x29UL,
   ENUM_IPC_EP_NOOP = 0x2aUL,
   ENUM_IPC_TPRE_B2B = 0x2bUL,
   ENUM_IPC_LRO_FLUSH_RXULP_MPU = 0x2cUL,
   ENUM_IPC_FC_RELEASE_WRBS = 0x2dUL,
   ENUM_IPC_ISCSI_CTXT_UPDATE = 0x2eUL,
   ENUM_IPC_FC_TRANSMIT_ABTS = 0x2fUL,
   ENUM_IPC_FC_TRANSMIT_REC = 0x30UL,
   ENUM_IPC_FC_TRANSMIT_SRR = 0x31UL,
   ENUM_IPC_FC_HOST_ABORT = 0x32UL,
   ENUM_IPC_FC_TRANSMIT_ELS_REPLY = 0x34UL,
   ENUM_IPC_TCP_JRNL_PAGES_INIT = 0x35UL,
   ENUM_IPC_FC_TRANSMIT_RRQ = 0x36UL,
   ENUM_IPC_FC_TRANSMIT_CONFIRM_IU = 0x37UL,
   ENUM_IPC_FC_CONFIRM_IU_TRANSMITTED = 0x38UL,
   ENUM_IPC_FC_TRANSMIT_BA_ACC = 0x39UL,
   ENUM_IPC_FC_TRANSMIT_BA_RJT = 0x3aUL,
   ENUM_IPC_FC_COMPLETE_WQ = 0x3bUL,
   ENUM_IPC_FC_HEADER_TEMPLATE_UPDATE = 0x3cUL,
   ENUM_IPC_FC_BLS_RSP_TRANSMITTED = 0x3dUL,
   ENUM_IPC_FC_SET_PER_PRIORITY_CLASS = 0x3eUL,
   ENUM_IPC_FC_UNREG_RPI_COMPLETE = 0x3fUL,
   ENUM_IPC_FC_ABORT_SCAN_COMPLETE = 0x3fUL,
   ENUM_IPC_ISCSI_OOO = 0x40UL,
   ENUM_IPC_USE_OUTER_VLAN_TAGS = 0x41UL,
   ENUM_IPC_DAL_MR_UNREGISTER = 0x42UL,
   ENUM_IPC_DAL_QP_DESTROY = 0x43UL,
   ENUM_IPC_ISCSI_GLOBAL_QOS_ENABLE = 0x44UL,
   ENUM_IPC_ISCSI_GLOBAL_QOS_DISABLE = 0x45UL,
   ENUM_IPC_PFC_ENABLE = 0x46UL,
   ENUM_IPC_FC_LINK_STATUS = 0x47UL,
   ENUM_IPC_DEFQ_CREATE = 0x48UL,
   ENUM_IPC_FC_INVALIDATE_RING_CONTEXT = 0x49UL,
   ENUM_IPC_FC_RESUME_RPI = 0x4aUL,
   ENUM_IPC_FC_CONFIG_PFC = 0x4bUL,
   ENUM_IPC_TCP_WINDOW_SHRINK = 0x4cUL,
   ENUM_IPC_PFC_DISABLE = 0x4dUL,
   ENUM_IPC_TPOST_WR_JRNL = 0x4eUL,
   ENUM_IPC_FC_CONFIG_PFC_COS = 0x4fUL,
   ENUM_IPC_FC_CONFIG_PFC_TXD = 0x50UL,
   ENUM_IPC_TXULP_EXCESS_DISABLE = 0x51UL,
   ENUM_IPC_TXULP_EXCESS_ENABLE = 0x52UL,
   ENUM_IPC_LLDP_SET_MAC_IDS = 0x53UL,
   ENUM_IPC_TXULP_EXCESS_SPACING = 0x54UL,
   ENUM_IPC_TPRE_ADVANCE_PUSH_TMR = 0x55UL,
   ENUM_IPC_FC_ARM_DEF_RING = 0x56UL,
   ENUM_IPC_SET_EP_OPTIONS = 0x57UL,
   ENUM_IPC_GET_EP_OPTIONS = 0x58UL,
   ENUM_IPC_FC_RETURN_CREDIT = 0x59UL,
   ENUM_IPC_FC_EP_UNREG_RPI_COMPLETE = 0x5aUL
} IPC_CODES;

// --- IPC_QOS_UPDATE_SUBCODES ---
// This enumeration defines subcodes associated with code IPC_QOS_UPDATE for QoS changes. 
#define IPC_QOS_UPDATE_BYTES_NIC        (0)       // QoS update subcode for NIC bytes per
                                                  // second
#define IPC_QOS_UPDATE_PACKETS_NIC      (1)       // QoS update subcode for NIC packets
                                                  // per second

typedef enum {
   ENUM_IPC_QOS_UPDATE_BYTES_NIC = 0x0UL,
   ENUM_IPC_QOS_UPDATE_PACKETS_NIC = 0x1UL
} IPC_QOS_UPDATE_SUBCODES;

// --- IPC_TCP_PARAMS_SUBCODES ---
#define IPC_TCP_PARAMS_CHUTE1           (1)       // tcp parameters for chute 1 
#define IPC_TCP_PARAMS_CHUTE2           (2)       // tcp parameters for chute 2 
#define IPC_TCP_PARAMS_CHUTE3           (3)       // tcp parameters for chute 3 

typedef enum {
   ENUM_IPC_TCP_PARAMS_CHUTE1 = 0x1UL,
   ENUM_IPC_TCP_PARAMS_CHUTE2 = 0x2UL,
   ENUM_IPC_TCP_PARAMS_CHUTE3 = 0x3UL
} IPC_TCP_PARAMS_SUBCODES;

// --- IPC_UPLOAD_SUBCODES ---
#define IPC_SUB_NORMAL                  (0)       // Default sub code 
#define IPC_SUB_TOE_UPLOAD              (1)       // Indicate this IPC message is used for
                                                  // TOE uploading 
#define IPC_SUB_TOE_UPLOAD_MPU          (2)       // UPLOAD indication that squirrels its
                                                  // way to the MPU 
#define IPC_SUB_TOE_RESET               (3)       // Indicate this IPC message is used for
                                                  // tcp reset 
#define IPC_SUB_TOE_RESET_MPU           (4)       // UPLOAD indication that squirrels its
                                                  // way to the MPU 
#define IPC_SUB_TOE_RESET_SEQNO         (5)       // Indicate this IPC message is used for
                                                  // tcp reset. The RRMsg provides the
                                                  // sequence number to use in the reset 
#define IPC_SUB_TOE_RESET_SEQNO_MPU     (6)       // UPLOAD indication that squirrels its
                                                  // way to the MPU. The RRMsg provides
                                                  // the sequence number to use in the
                                                  // reset 
#define IPC_SUB_TOE_ABORT_UPLOAD        (7)       // Abortive UPLOAD with no reset 
#define IPC_SUB_TOE_ABORT_UPLOAD_MPU    (8)       // Abortive UPLOAD with no reset that
                                                  // squirrels its way to the MPU 
#define IPC_SUB_SEND_FLUSH              (9)       // UPLOAD indication to RXULP for
                                                  // flushing its send queue 
#define IPC_SUB_RECV_FLUSH              (10)      // UPLOAD indication to RXULP for
                                                  // flushing its receive queue 
#define IPC_SUB_RDMA_UPLOAD             (11)      // Indicate this IPC message is used for
                                                  // RDMA uploading 
#define IPC_SUB_RDMA_RESET              (12)      // Indicate TCP connection got reset
                                                  // during iSCSI connection upload 
#define IPC_SUB_ISCSI_CONN_RESET        (13)      // Indicate this IPC message is used for
                                                  // tcp reset 

typedef enum {
   ENUM_IPC_SUB_NORMAL = 0x0UL,
   ENUM_IPC_SUB_TOE_UPLOAD = 0x1UL,
   ENUM_IPC_SUB_TOE_UPLOAD_MPU = 0x2UL,
   ENUM_IPC_SUB_TOE_RESET = 0x3UL,
   ENUM_IPC_SUB_TOE_RESET_MPU = 0x4UL,
   ENUM_IPC_SUB_TOE_RESET_SEQNO = 0x5UL,
   ENUM_IPC_SUB_TOE_RESET_SEQNO_MPU = 0x6UL,
   ENUM_IPC_SUB_TOE_ABORT_UPLOAD = 0x7UL,
   ENUM_IPC_SUB_TOE_ABORT_UPLOAD_MPU = 0x8UL,
   ENUM_IPC_SUB_SEND_FLUSH = 0x9UL,
   ENUM_IPC_SUB_RECV_FLUSH = 0xaUL,
   ENUM_IPC_SUB_RDMA_UPLOAD = 0xbUL,
   ENUM_IPC_SUB_RDMA_RESET = 0xcUL,
   ENUM_IPC_SUB_ISCSI_CONN_RESET = 0xdUL
} IPC_UPLOAD_SUBCODES;

// --- IPC_DEFQ_CREATE_SUBCODES ---
#define IPC_SUB_DEFQ_CREATE_REQUEST     (1)       // Sent by the MPU to an rxulp
                                                  // initiating a default buffer queue
                                                  // create request. 
#define IPC_SUB_DEFQ_CREATE_ACCEPT      (2)       // Sent by an rxulp to MPU indicating a
                                                  // default buffer queue create is
                                                  // accepted. 
#define IPC_SUB_DEFQ_CREATE_REJECT      (3)       // Sent by an rxulp to MPU indicating a
                                                  // default buffer queue create is
                                                  // rejected. 

typedef enum {
   ENUM_IPC_SUB_DEFQ_CREATE_REQUEST = 0x1UL,
   ENUM_IPC_SUB_DEFQ_CREATE_ACCEPT = 0x2UL,
   ENUM_IPC_SUB_DEFQ_CREATE_REJECT = 0x3UL
} IPC_DEFQ_CREATE_SUBCODES;

// --- IPC_DEFQ_FLUSH_SUBCODES ---
#define IPC_SUB_DEFQ_FLUSH_REQUEST      (1)       // Sent by the MPU to an rxulp
                                                  // initiating a default buffer queue
                                                  // flush request. 
#define IPC_SUB_DEFQ_FLUSH_ACCEPT       (2)       // Sent by an rxulp to MPU indicating a
                                                  // default buffer queue flush is
                                                  // accepted. 
#define IPC_SUB_DEFQ_FLUSH_REJECT       (3)       // Sent by an rxulp to MPU indicating a
                                                  // default buffer queue flush is
                                                  // rejected. 

typedef enum {
   ENUM_IPC_SUB_DEFQ_FLUSH_REQUEST = 0x1UL,
   ENUM_IPC_SUB_DEFQ_FLUSH_ACCEPT = 0x2UL,
   ENUM_IPC_SUB_DEFQ_FLUSH_REJECT = 0x3UL
} IPC_DEFQ_FLUSH_SUBCODES;

// --- IPC_SUB_TOE_DEFQ_FLUSH_SUBCODES ---
#define IPC_SUB_TOE_DEFQ_FLUSH_REQUEST  (1)       // Sent by the MPU to an rxulp on the
                                                  // toe default buffer queue flush
                                                  // request. 
#define IPC_SUB_TOE_DEFQ_FLUSH_ACCEPT   (2)       // Sent by an rxulp to MPU, indicates a
                                                  // toe default buffer queue flush is
                                                  // accepted. 
#define IPC_SUB_TOE_DEFQ_FLUSH_REJECT   (3)       // Sent by an rxulp to MPU, indicates a
                                                  // toe default buffer queue flush is
                                                  // rejected. 
#define IPC_SUB_DAL_QP_FLUSH_ACCEPT     (4)       // Sent by the rxulp1 to MPU, indicates
                                                  // DAL QP flush accepted 

typedef enum {
   ENUM_IPC_SUB_TOE_DEFQ_FLUSH_REQUEST = 0x1UL,
   ENUM_IPC_SUB_TOE_DEFQ_FLUSH_ACCEPT = 0x2UL,
   ENUM_IPC_SUB_TOE_DEFQ_FLUSH_REJECT = 0x3UL,
   ENUM_IPC_SUB_DAL_QP_FLUSH_ACCEPT = 0x4UL
} IPC_SUB_TOE_DEFQ_FLUSH_SUBCODES;

// --- IPC_STAT_SUBCODES ---
#define IPC_SUB_STAT_ID0                (0)       // Indicate reading statistics data from
                                                  // 0 to 0xFF bytes 
#define IPC_SUB_STAT_ID1                (1)       // Indicate reading statistics data from
                                                  // 0x100 to 0x1FF bytes 
#define IPC_SUB_STAT_ID2                (2)       // Indicate reading statistics data from
                                                  // 0x200 to 0x2FF bytes 
#define IPC_SUB_STAT_ID3                (3)       // Indicate reading statistics data from
                                                  // 0x300 to 0x3FF bytes 

typedef enum {
   ENUM_IPC_SUB_STAT_ID0 = 0x0UL,
   ENUM_IPC_SUB_STAT_ID1 = 0x1UL,
   ENUM_IPC_SUB_STAT_ID2 = 0x2UL,
   ENUM_IPC_SUB_STAT_ID3 = 0x3UL
} IPC_STAT_SUBCODES;

// --- IPC_JELLM_THROTTLE_SUBCODES ---
#define IPC_SUB_JELLM_THROTTLE_ENABLE   (0)       
#define IPC_SUB_JELLM_THROTTLE_DISABLE  (1)       

typedef enum {
   ENUM_IPC_SUB_JELLM_THROTTLE_ENABLE = 0x0UL,
   ENUM_IPC_SUB_JELLM_THROTTLE_DISABLE = 0x1UL
} IPC_JELLM_THROTTLE_SUBCODES;

// --- IPC_ISCSI_SGL_SIZE_SUBCODES ---
#define IPC_SUB_ISCSI_32_SGE            (0)       // 5 bits frag_num (32 SGEs per SGL) in
                                                  // SGL CRA 
#define IPC_SUB_ISCSI_256_SGE           (1)       // 8 bits frag_num (256 SGEs per SGL) in
                                                  // SGL CRA 

typedef enum {
   ENUM_IPC_SUB_ISCSI_32_SGE = 0x0UL,
   ENUM_IPC_SUB_ISCSI_256_SGE = 0x1UL
} IPC_ISCSI_SGL_SIZE_SUBCODES;

// --- IPC_SET_EP_OPTIONS_SUBCODES ---
#define SUBCODE_EP_FEATURES             (0)       // Indicates dynamic features are to be
                                                  // set
#define SUBCODE_EP_TRACE                (1)       // Indicates dynamic trace options are
                                                  // to be set
#define SUBCODE_EP_DEBUG                (2)       // Indicates synamic debug options are
                                                  // to be set

typedef enum {
   ENUM_SUBCODE_EP_FEATURES = 0x0UL,
   ENUM_SUBCODE_EP_TRACE = 0x1UL,
   ENUM_SUBCODE_EP_DEBUG = 0x2UL
} IPC_SET_EP_OPTIONS_SUBCODES;

#endif // __ipc_fw_impl_enum_h__

