/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ipsec_sa_structs_enum_h__
#define __ipsec_sa_structs_enum_h__
#include "setypes.h"
#include "defines_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- IPSEC_AUTHENTICATION_TYPE ---
// Authentication Type Encoding. Used in each Security Association context
#define AUTHENT_NONE                    (0)       // No Authentication used with this SA
#define AUTHENT_SHA_1                   (1)       // Authentication for this SA is SHA-1
#define AUTHENT_SHA_1_96                (2)       // Authentication for this SA is SHA-1,
                                                  // with 96-bit truncation
#define AUTHENT_MD5                     (3)       // Authentication for this SA is MD5
#define AUTHENT_MD5_96                  (4)       // Authentication for this SA is MD5,
                                                  // with 96-bit truncation
#define AUTHENT_AES_XCBC_96             (5)       // Authentication for this SA is
                                                  // AES-XCBC-MAC, with 96-bit truncation

typedef enum {
   ENUM_AUTHENT_NONE = 0x0UL,
   ENUM_AUTHENT_SHA_1 = 0x1UL,
   ENUM_AUTHENT_SHA_1_96 = 0x2UL,
   ENUM_AUTHENT_MD5 = 0x3UL,
   ENUM_AUTHENT_MD5_96 = 0x4UL,
   ENUM_AUTHENT_AES_XCBC_96 = 0x5UL
} IPSEC_AUTHENTICATION_TYPE;

// --- IPSEC_ENCRYPTION_TYPE ---
// Encryption Type Encoding. Used in each Security Association context
#define ENCRYPT_NONE                    (0)       // No Encryption used with this SA
#define ENCRYPT_DES                     (1)       // Encryption for this SA is DES
#define ENCRYPT_3DES                    (2)       // Encryption for this SA is Triple DES
#define ENCRYPT_AES128                  (3)       // Encryption for this SA is 128-bit AES
#define ENCRYPT_AES192                  (4)       // Encryption for this SA is 192-bit AES
#define ENCRYPT_AES256                  (5)       // Encryption for this SA is 256-bit AES
#define ENCRYPT_AES128_CM               (6)       // Encryption for this SA is 128-bit AES
                                                  // Counter mode
#define ENCRYPT_AES192_CM               (7)       // Encryption for this SA is 192-bit AES
                                                  // Counter mode
#define ENCRYPT_AES256_CM               (8)       // Encryption for this SA is 256-bit AES
                                                  // Counter mode

typedef enum {
   ENUM_ENCRYPT_NONE = 0x0UL,
   ENUM_ENCRYPT_DES = 0x1UL,
   ENUM_ENCRYPT_3DES = 0x2UL,
   ENUM_ENCRYPT_AES128 = 0x3UL,
   ENUM_ENCRYPT_AES192 = 0x4UL,
   ENUM_ENCRYPT_AES256 = 0x5UL,
   ENUM_ENCRYPT_AES128_CM = 0x6UL,
   ENUM_ENCRYPT_AES192_CM = 0x7UL,
   ENUM_ENCRYPT_AES256_CM = 0x8UL
} IPSEC_ENCRYPTION_TYPE;

// --- IPSEC_PROTOCOL_TYPE ---
// IPSec Protocol Used by a Security Association
#define AH                              (0)       // Authentication Header
#define ESP                             (1)       // Encapsulating Security Payload

typedef enum {
   ENUM_AH = 0x0UL,
   ENUM_ESP = 0x1UL
} IPSEC_PROTOCOL_TYPE;

#endif // __ipsec_sa_structs_enum_h__

