/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __iscsi_common_host_struct_enum_h__
#define __iscsi_common_host_struct_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "iscsi_enums_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- ISCSI_EVENT_MINOR_CODE ---
// Minor event codes for iSCSI offload. The major event will be set to
// EQ_MAJOR_CODE_ISCSI. The ResourceID in the EQ_ENTRY is set to CID to indicate which
// connection failed.
#define ISCSI_MINOR_CODE_UNDEFINED      (0)       // This minor code should never be
                                                  // issued.
#define ISCSI_MINOR_CODE_CRC_ERROR      (1)       // A bad CRC was received on this
                                                  // connection. 
#define ISCSI_MINOR_CODE_BAD_OPCODE     (2)       // A bad opcode was received on this
                                                  // connection.
#define ISCSI_MINOR_CODE_BAD_DATA_SN    (3)       // A bad data sequence number was
                                                  // received on this connection.
#define ISCSI_MINOR_CODE_BAD_ITT        (4)       // A bad itt was received on this
                                                  // connection.
#define ISCSI_MINOR_CODE_BAD_HEADER     (5)       // Indicates a header parse error.
#define ISCSI_MINOR_CODE_PROTOCOL_ERROR (6)       // Indicates a protocol error.

typedef enum {
   ENUM_ISCSI_MINOR_CODE_UNDEFINED = 0x0UL,
   ENUM_ISCSI_MINOR_CODE_CRC_ERROR = 0x1UL,
   ENUM_ISCSI_MINOR_CODE_BAD_OPCODE = 0x2UL,
   ENUM_ISCSI_MINOR_CODE_BAD_DATA_SN = 0x3UL,
   ENUM_ISCSI_MINOR_CODE_BAD_ITT = 0x4UL,
   ENUM_ISCSI_MINOR_CODE_BAD_HEADER = 0x5UL,
   ENUM_ISCSI_MINOR_CODE_PROTOCOL_ERROR = 0x6UL
} ISCSI_EVENT_MINOR_CODE;

// --- CMD_FLAG ---
// Read/Write command flag.
#define READ_FLAG                       (0)       // iSCSI Read command PDU
#define WRITE_FLAG                      (1)       // iSCSI Write command PDU

typedef enum {
   ENUM_READ_FLAG = 0x0UL,
   ENUM_WRITE_FLAG = 0x1UL
} CMD_FLAG;

// --- ISCSI_ENTRY_SIZE_ENUM ---
#define ENTRY_SIZE_64                   (0)       // 64 bytes
#define ENTRY_SIZE_128                  (1)       // 128 bytes
#define ENTRY_SIZE_256                  (2)       // 256 bytes
#define ENTRY_SIZE_512                  (3)       // 512 bytes

typedef enum {
   ENUM_ENTRY_SIZE_64 = 0x0UL,
   ENUM_ENTRY_SIZE_128 = 0x1UL,
   ENUM_ENTRY_SIZE_256 = 0x2UL,
   ENUM_ENTRY_SIZE_512 = 0x3UL
} ISCSI_ENTRY_SIZE_ENUM;

#endif // __iscsi_common_host_struct_enum_h__

