/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __tcp_context_enum_h__
#define __tcp_context_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "headers_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- TCP_CONTEXT_CAP_FLAGS ---
// Capabilities for the connection 
#define TCP_CONTEXT_CAP_OOO_DISABLE     (1)       // Disables OOO processing in the TPRE 
#define TCP_CONTEXT_CAP_USE_PUSH_TMR    (2)       // Enables use of push timer 
#define TCP_CONTEXT_CAP_CHECK_CLASSIFICATION (4)  // Enables checking of classification
                                                  // flags, requires USE_CLASSIFICATION to
                                                  // be set 
#define TCP_CONTEXT_CAP_MPA_CRC         (8)       // Enables MPA CRC Check for the
                                                  // connection 
#define TCP_CONTEXT_CAP_RED_DISABLE     (16)      // Disables RED processing in the TPRE 
#define TCP_CONTEXT_CAP_TT_ENABLE       (32)      // Enables or disables Triple tripping 
#define TCP_CONTEXT_CAP_USE_CREDITS     (64)      // Enables use of credits on the tpre 
#define TCP_CONTEXT_CAP_AUTO_WINDOW     (128)     // Automatically manages rcv window 
#define TCP_CONTEXT_CAP_PROBE_DATA      (256)     // Send one byte of data in window probe
                                                  // if possible 

typedef enum {
   ENUM_TCP_CONTEXT_CAP_OOO_DISABLE = 0x1UL,
   ENUM_TCP_CONTEXT_CAP_USE_PUSH_TMR = 0x2UL,
   ENUM_TCP_CONTEXT_CAP_CHECK_CLASSIFICATION = 0x4UL,
   ENUM_TCP_CONTEXT_CAP_MPA_CRC = 0x8UL,
   ENUM_TCP_CONTEXT_CAP_RED_DISABLE = 0x10UL,
   ENUM_TCP_CONTEXT_CAP_TT_ENABLE = 0x20UL,
   ENUM_TCP_CONTEXT_CAP_USE_CREDITS = 0x40UL,
   ENUM_TCP_CONTEXT_CAP_AUTO_WINDOW = 0x80UL,
   ENUM_TCP_CONTEXT_CAP_PROBE_DATA = 0x100UL
} TCP_CONTEXT_CAP_FLAGS;

// --- TCP_CONTEXT_INTERESTING_OFFSETS ---
#define TCP_CONTEXT_PORT_ID1_BYTE_OFFSET (36)     
#define TCP_CONTEXT_MSS_BYTE_OFFSET     (80)      
#define TCP_CONTEXT_PORT_ID_BYTE_OFFSET (82)      

typedef enum {
   ENUM_TCP_CONTEXT_PORT_ID1_BYTE_OFFSET = 0x24UL,
   ENUM_TCP_CONTEXT_MSS_BYTE_OFFSET = 0x50UL,
   ENUM_TCP_CONTEXT_PORT_ID_BYTE_OFFSET = 0x52UL
} TCP_CONTEXT_INTERESTING_OFFSETS;

#endif // __tcp_context_enum_h__

