/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __toe_context_enum_h__
#define __toe_context_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "descriptors_enum.h"
#include "ulp_context_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- TOERX_STATE ---
#define TOERX_STATE_UCREQ               (0)       // UC request in progress.
#define TOERX_STATE_DEFAULT_BUFFERS     (1)       // Default buffers in use. 
#define TOERX_STATE_PREPOSTED_BUFFERS   (2)       // Preposted buffers in use.
#define TOERX_STATE_OOO                 (3)       // Out of order packet processing in
                                                  // progress.

typedef enum {
   ENUM_TOERX_STATE_UCREQ = 0x0UL,
   ENUM_TOERX_STATE_DEFAULT_BUFFERS = 0x1UL,
   ENUM_TOERX_STATE_PREPOSTED_BUFFERS = 0x2UL,
   ENUM_TOERX_STATE_OOO = 0x3UL
} TOERX_STATE;

// --- TOERX_DEFAULT_MODE ---
#define TOERX_DEFAULT_COMPL_PACK        (0)       // In this mode every default buffer is
                                                  // completely packed untill push or
                                                  // pushtmr or fin
#define TOERX_DEFAULT_NO_PACKET_SPLIT   (1)       // No packet is split across two buffers
#define TOERX_DEFAULT_NO_PACK           (2)       // In this mode every default buffer is
                                                  // completed with single packed.

typedef enum {
   ENUM_TOERX_DEFAULT_COMPL_PACK = 0x0UL,
   ENUM_TOERX_DEFAULT_NO_PACKET_SPLIT = 0x1UL,
   ENUM_TOERX_DEFAULT_NO_PACK = 0x2UL
} TOERX_DEFAULT_MODE;

#endif // __toe_context_enum_h__

