/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __uc_enum_h__
#define __uc_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "pq_enum.h"
#include "hwdbg_reg_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- UC_STATUS_CODES_ENUM ---
// Unified Cache Status Code enumerations.
#define UC_STATUS_SUCCESS               (0)       
#define UC_DTENTRY_INVALID              (1)       
#define UC_PTENTRY_INVALID              (2)       
#define UC_DT_PARITY_ERROR              (3)       
#define UC_PT_PARITY_ERROR              (4)       
#define UC_DMA_ERROR                    (5)       
#define UC_INVALID_OP                   (6)       
#define UC_TS_PARITY_ERROR              (7)       
#define UC_AM_ON_INV                    (8)       
#define UC_AMI_ON_INV                   (9)       
#define UC_INV_ON_INV                   (10)      

typedef enum {
   ENUM_UC_STATUS_SUCCESS = 0x0UL,
   ENUM_UC_DTENTRY_INVALID = 0x1UL,
   ENUM_UC_PTENTRY_INVALID = 0x2UL,
   ENUM_UC_DT_PARITY_ERROR = 0x3UL,
   ENUM_UC_PT_PARITY_ERROR = 0x4UL,
   ENUM_UC_DMA_ERROR = 0x5UL,
   ENUM_UC_INVALID_OP = 0x6UL,
   ENUM_UC_TS_PARITY_ERROR = 0x7UL,
   ENUM_UC_AM_ON_INV = 0x8UL,
   ENUM_UC_AMI_ON_INV = 0x9UL,
   ENUM_UC_INV_ON_INV = 0xaUL
} UC_STATUS_CODES_ENUM;

// --- UC_REQUEST_TYPE_ENUM ---
// Unified Cache Request Type enumerations.
#define UC_REQUEST_TYPE_NORMAL          (0)       
#define UC_REQUEST_TYPE_IMMEDIATE       (1)       

typedef enum {
   ENUM_UC_REQUEST_TYPE_NORMAL = 0x0UL,
   ENUM_UC_REQUEST_TYPE_IMMEDIATE = 0x1UL
} UC_REQUEST_TYPE_ENUM;

// --- UC_COMMAND_CODES_ENUM ---
// Unified Cache Command Code enumerations.
#define UC_COMMAND_ACCESSPLUS           (0)       
#define UC_COMMAND_ACCESSMINUS          (1)       
#define UC_COMMAND_ACCESSMINUSINVL      (2)       
#define UC_COMMAND_INVL                 (3)       
#define UC_COMMAND_CRA_RANGE_FLUSH      (4)       
#define UC_COMMAND_FLUSH_CACHE          (5)       
#define UC_COMMAND_FLUSH_CACHE_ALL      (6)       

typedef enum {
   ENUM_UC_COMMAND_ACCESSPLUS = 0x0UL,
   ENUM_UC_COMMAND_ACCESSMINUS = 0x1UL,
   ENUM_UC_COMMAND_ACCESSMINUSINVL = 0x2UL,
   ENUM_UC_COMMAND_INVL = 0x3UL,
   ENUM_UC_COMMAND_CRA_RANGE_FLUSH = 0x4UL,
   ENUM_UC_COMMAND_FLUSH_CACHE = 0x5UL,
   ENUM_UC_COMMAND_FLUSH_CACHE_ALL = 0x6UL
} UC_COMMAND_CODES_ENUM;

// --- UC_REQUESTER_ID_ENUM ---
// Unified Cache Requestor Identifier Enumerations.
#define UC_RXULP0                       (0)       
#define UC_RXULP1                       (1)       
#define UC_RXULP2                       (2)       
#define UC_TXULP0                       (3)       
#define UC_TXULP1                       (4)       
#define UC_ETX                          (5)       
#define UC_ERX                          (6)       
#define UC_CEV                          (7)       
#define UC_WDMA                         (8)       
#define UC_RDMA                         (9)       
#define UC_MPU                          (10)      
#define UC_HOST                         (15)      

typedef enum {
   ENUM_UC_RXULP0 = 0x0UL,
   ENUM_UC_RXULP1 = 0x1UL,
   ENUM_UC_RXULP2 = 0x2UL,
   ENUM_UC_TXULP0 = 0x3UL,
   ENUM_UC_TXULP1 = 0x4UL,
   ENUM_UC_ETX = 0x5UL,
   ENUM_UC_ERX = 0x6UL,
   ENUM_UC_CEV = 0x7UL,
   ENUM_UC_WDMA = 0x8UL,
   ENUM_UC_RDMA = 0x9UL,
   ENUM_UC_MPU = 0xaUL,
   ENUM_UC_HOST = 0xfUL
} UC_REQUESTER_ID_ENUM;

// --- UC_STAT_INDICES_ENUM ---
// Unified Cache statistics identifiers.
#define UC_RANGE0_CACHE_HIT_COUNTER     (0)       
#define UC_RANGE0_CACHE_MISS_COUNTER    (1)       
#define UC_RANGE1_CACHE_HIT_COUNTER     (2)       
#define UC_RANGE1_CACHE_MISS_COUNTER    (3)       
#define UC_RANGE2_CACHE_HIT_COUNTER     (4)       
#define UC_RANGE2_CACHE_MISS_COUNTER    (5)       
#define UC_RANGE3_CACHE_HIT_COUNTER     (6)       
#define UC_RANGE3_CACHE_MISS_COUNTER    (7)       
#define UC_RANGE4_CACHE_HIT_COUNTER     (8)       
#define UC_RANGE4_CACHE_MISS_COUNTER    (9)       
#define UC_RANGE5_CACHE_HIT_COUNTER     (10)      
#define UC_RANGE5_CACHE_MISS_COUNTER    (11)      
#define UC_RANGE6_CACHE_HIT_COUNTER     (12)      
#define UC_RANGE6_CACHE_MISS_COUNTER    (13)      
#define UC_RANGE7_CACHE_HIT_COUNTER     (14)      
#define UC_RANGE7_CACHE_MISS_COUNTER    (15)      
#define UC_LAST_MISS_RESOLUTION_TIME    (16)      

typedef enum {
   ENUM_UC_RANGE0_CACHE_HIT_COUNTER = 0x0UL,
   ENUM_UC_RANGE0_CACHE_MISS_COUNTER = 0x1UL,
   ENUM_UC_RANGE1_CACHE_HIT_COUNTER = 0x2UL,
   ENUM_UC_RANGE1_CACHE_MISS_COUNTER = 0x3UL,
   ENUM_UC_RANGE2_CACHE_HIT_COUNTER = 0x4UL,
   ENUM_UC_RANGE2_CACHE_MISS_COUNTER = 0x5UL,
   ENUM_UC_RANGE3_CACHE_HIT_COUNTER = 0x6UL,
   ENUM_UC_RANGE3_CACHE_MISS_COUNTER = 0x7UL,
   ENUM_UC_RANGE4_CACHE_HIT_COUNTER = 0x8UL,
   ENUM_UC_RANGE4_CACHE_MISS_COUNTER = 0x9UL,
   ENUM_UC_RANGE5_CACHE_HIT_COUNTER = 0xaUL,
   ENUM_UC_RANGE5_CACHE_MISS_COUNTER = 0xbUL,
   ENUM_UC_RANGE6_CACHE_HIT_COUNTER = 0xcUL,
   ENUM_UC_RANGE6_CACHE_MISS_COUNTER = 0xdUL,
   ENUM_UC_RANGE7_CACHE_HIT_COUNTER = 0xeUL,
   ENUM_UC_RANGE7_CACHE_MISS_COUNTER = 0xfUL,
   ENUM_UC_LAST_MISS_RESOLUTION_TIME = 0x10UL
} UC_STAT_INDICES_ENUM;

#endif // __uc_enum_h__

