/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __descriptors_bmap_h__
#define __descriptors_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "headers_bmap.h"
#include "uc_bmap.h"
#include "mpu_local_mmr_bmap.h"
#include "reg_enums_bmap.h"
#include "eeprom_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // RxULP WDMA Consolidator Packed Page Mode Command Context. This structure must be
   // aligned to a eight-byte boundary in CTX. 
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_PM_CC {
         union {
            struct { 
               u32 palo;                          // DWORD 0
               u32 pahi;                          // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK WCON_PM_CC, *PWCON_PM_CC;

      SG_C_ASSERT(__sizeof__WCON_PM_CC, sizeof (WCON_PM_CC) == 8);

   #else
      typedef struct _WCON_PM_CC {
         u32 palo;                                // DWORD 0
         u32 pahi;                                // DWORD 1
      } SG_PACK WCON_PM_CC, *PWCON_PM_CC;

      typedef union _WCON_PM_CC_UNION {
         WCON_PM_CC bits;
         u32 dw[2]; // dword union
      } SG_PACK WCON_PM_CC_UNION, *PWCON_PM_CC_UNION;

      SG_C_ASSERT(__sizeof__WCON_PM_CC_UNION, sizeof (WCON_PM_CC_UNION) == 8);
   #endif


#else
   // RxULP WDMA Consolidator Packed Page Mode Command Context. This structure must be
   // aligned to a eight-byte boundary in CTX. 
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_PM_CC {
         union {
            struct { 
               u32 palo;                          // DWORD 0
               u32 pahi;                          // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK WCON_PM_CC, *PWCON_PM_CC;

      SG_C_ASSERT(__sizeof__WCON_PM_CC, sizeof (WCON_PM_CC) == 8);

   #else
      typedef struct _WCON_PM_CC {
         u32 palo;                                // DWORD 0
         u32 pahi;                                // DWORD 1
      } SG_PACK WCON_PM_CC, *PWCON_PM_CC;

      typedef union _WCON_PM_CC_UNION {
         WCON_PM_CC bits;
         u32 dw[2]; // dword union
      } SG_PACK WCON_PM_CC_UNION, *PWCON_PM_CC_UNION;

      SG_C_ASSERT(__sizeof__WCON_PM_CC_UNION, sizeof (WCON_PM_CC_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Entry in the PQs feeding into the DMA block. This defines an indirect entry
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_PQ_D {
         union {
            struct { 
               u32 descrid : 16;                  // DWORD 0
               u32 error : 4;                     // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 stallarc : 4;                  // DWORD 0
               u32 rcra : 1;                      // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DMA_PQ_D, *PDMA_PQ_D;

      SG_C_ASSERT(__sizeof__DMA_PQ_D, sizeof (DMA_PQ_D) == 4);

   #else
      typedef struct _DMA_PQ_D {
         u32 descrid : 16;                        // DWORD 0
         u32 error : 4;                           // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 stallarc : 4;                        // DWORD 0
         u32 rcra : 1;                            // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
      } SG_PACK DMA_PQ_D, *PDMA_PQ_D;

      typedef union _DMA_PQ_D_UNION {
         DMA_PQ_D bits;
         u32 dw; // dword union
      } SG_PACK DMA_PQ_D_UNION, *PDMA_PQ_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_PQ_D_UNION, sizeof (DMA_PQ_D_UNION) == 4);
   #endif


#else
   // Entry in the PQs feeding into the DMA block. This defines an indirect entry
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_PQ_D {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 rcra : 1;                      // DWORD 0
               u32 stallarc : 4;                  // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 error : 4;                     // DWORD 0
               u32 descrid : 16;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DMA_PQ_D, *PDMA_PQ_D;

      SG_C_ASSERT(__sizeof__DMA_PQ_D, sizeof (DMA_PQ_D) == 4);

   #else
      typedef struct _DMA_PQ_D {
         u32 stall : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 rcra : 1;                            // DWORD 0
         u32 stallarc : 4;                        // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 error : 4;                           // DWORD 0
         u32 descrid : 16;                        // DWORD 0
      } SG_PACK DMA_PQ_D, *PDMA_PQ_D;

      typedef union _DMA_PQ_D_UNION {
         DMA_PQ_D bits;
         u32 dw; // dword union
      } SG_PACK DMA_PQ_D_UNION, *PDMA_PQ_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_PQ_D_UNION, sizeof (DMA_PQ_D_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Entry used by UC PQ feeding into the WDMA block. This defines an indirect entry
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_DMA_PQ_D {
         union {
            struct { 
               u32 opaque1 : 6;                   // DWORD 0
               u32 descrid : 10;                  // DWORD 0
               u32 error : 4;                     // DWORD 0
               u32 opaque0 : 4;                   // DWORD 0
               u32 stallarc : 4;                  // DWORD 0
               u32 rcra : 1;                      // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_DMA_PQ_D, *PUC_DMA_PQ_D;

      SG_C_ASSERT(__sizeof__UC_DMA_PQ_D, sizeof (UC_DMA_PQ_D) == 4);

   #else
      typedef struct _UC_DMA_PQ_D {
         u32 opaque1 : 6;                         // DWORD 0
         u32 descrid : 10;                        // DWORD 0
         u32 error : 4;                           // DWORD 0
         u32 opaque0 : 4;                         // DWORD 0
         u32 stallarc : 4;                        // DWORD 0
         u32 rcra : 1;                            // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
      } SG_PACK UC_DMA_PQ_D, *PUC_DMA_PQ_D;

      typedef union _UC_DMA_PQ_D_UNION {
         UC_DMA_PQ_D bits;
         u32 dw; // dword union
      } SG_PACK UC_DMA_PQ_D_UNION, *PUC_DMA_PQ_D_UNION;

      SG_C_ASSERT(__sizeof__UC_DMA_PQ_D_UNION, sizeof (UC_DMA_PQ_D_UNION) == 4);
   #endif


#else
   // Entry used by UC PQ feeding into the WDMA block. This defines an indirect entry
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_DMA_PQ_D {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 rcra : 1;                      // DWORD 0
               u32 stallarc : 4;                  // DWORD 0
               u32 opaque0 : 4;                   // DWORD 0
               u32 error : 4;                     // DWORD 0
               u32 descrid : 10;                  // DWORD 0
               u32 opaque1 : 6;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_DMA_PQ_D, *PUC_DMA_PQ_D;

      SG_C_ASSERT(__sizeof__UC_DMA_PQ_D, sizeof (UC_DMA_PQ_D) == 4);

   #else
      typedef struct _UC_DMA_PQ_D {
         u32 stall : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 rcra : 1;                            // DWORD 0
         u32 stallarc : 4;                        // DWORD 0
         u32 opaque0 : 4;                         // DWORD 0
         u32 error : 4;                           // DWORD 0
         u32 descrid : 10;                        // DWORD 0
         u32 opaque1 : 6;                         // DWORD 0
      } SG_PACK UC_DMA_PQ_D, *PUC_DMA_PQ_D;

      typedef union _UC_DMA_PQ_D_UNION {
         UC_DMA_PQ_D bits;
         u32 dw; // dword union
      } SG_PACK UC_DMA_PQ_D_UNION, *PUC_DMA_PQ_D_UNION;

      SG_C_ASSERT(__sizeof__UC_DMA_PQ_D_UNION, sizeof (UC_DMA_PQ_D_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_DMA_CARGO {
         union {
            struct { 
               u32 rsvd0 : 5;                     // DWORD 0
               u32 rqid : 6;                      // DWORD 0
               u32 dbuf : 9;                      // DWORD 0
               u32 cqid : 12;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_DMA_CARGO, *PERX_DMA_CARGO;

      SG_C_ASSERT(__sizeof__ERX_DMA_CARGO, sizeof (ERX_DMA_CARGO) == 4);

   #else
      typedef struct _ERX_DMA_CARGO {
         u32 rsvd0 : 5;                           // DWORD 0
         u32 rqid : 6;                            // DWORD 0
         u32 dbuf : 9;                            // DWORD 0
         u32 cqid : 12;                           // DWORD 0
      } SG_PACK ERX_DMA_CARGO, *PERX_DMA_CARGO;

      typedef union _ERX_DMA_CARGO_UNION {
         ERX_DMA_CARGO bits;
         u32 dw; // dword union
      } SG_PACK ERX_DMA_CARGO_UNION, *PERX_DMA_CARGO_UNION;

      SG_C_ASSERT(__sizeof__ERX_DMA_CARGO_UNION, sizeof (ERX_DMA_CARGO_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ERX_DMA_CARGO {
         union {
            struct { 
               u32 cqid : 12;                     // DWORD 0
               u32 dbuf : 9;                      // DWORD 0
               u32 rqid : 6;                      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ERX_DMA_CARGO, *PERX_DMA_CARGO;

      SG_C_ASSERT(__sizeof__ERX_DMA_CARGO, sizeof (ERX_DMA_CARGO) == 4);

   #else
      typedef struct _ERX_DMA_CARGO {
         u32 cqid : 12;                           // DWORD 0
         u32 dbuf : 9;                            // DWORD 0
         u32 rqid : 6;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
      } SG_PACK ERX_DMA_CARGO, *PERX_DMA_CARGO;

      typedef union _ERX_DMA_CARGO_UNION {
         ERX_DMA_CARGO bits;
         u32 dw; // dword union
      } SG_PACK ERX_DMA_CARGO_UNION, *PERX_DMA_CARGO_UNION;

      SG_C_ASSERT(__sizeof__ERX_DMA_CARGO_UNION, sizeof (ERX_DMA_CARGO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Normal DMA descriptor (Single Host/ddr address)
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_TYPE0_D {
         union {
            struct { 
               u32 haddr_l;                       // DWORD 0
               u32 dtype : 3;                     // DWORD 1
               u32 dcrd : 1;                      // DWORD 1
               u32 cplid : 4;                     // DWORD 1
               u32 cplvec : 3;                    // DWORD 1
               u32 msrc : 2;                      // DWORD 1
               u32 swap : 2;                      // DWORD 1
               u32 mrken : 1;                     // DWORD 1
               u32 crc_en : 1;                    // DWORD 1
               u32 cra : 1;                       // DWORD 1
               u32 pbfree : 1;                    // DWORD 1
               u32 tgtsel : 1;                    // DWORD 1
               u32 exzero : 1;                    // DWORD 1
               u32 dif_en : 1;                    // DWORD 1
               u32 pciats : 2;                    // DWORD 1
               u32 pcixvf : 8;                    // DWORD 1
               u32 offset : 16;                   // DWORD 2
               u32 len : 16;                      // DWORD 2
               u32 haddr_h;                       // DWORD 3
               u32 crc_start : 1;                 // DWORD 4
               u32 crc_end : 1;                   // DWORD 4
               u32 crc_cnt : 4;                   // DWORD 4
               u32 cid : 10;                      // DWORD 4
               u32 mrkstride : 2;                 // DWORD 4
               u32 mrklen : 2;                    // DWORD 4
               u32 mrkstart : 12;                 // DWORD 4
               u32 maddr;                         // DWORD 5
               u32 cpl_ret3 : 16;                 // DWORD 6
               u32 cpl_ret2 : 16;                 // DWORD 6
               u32 cpl_ret1 : 16;                 // DWORD 7
               u32 cpl_ret0 : 16;                 // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_TYPE0_D, *PDMA_TYPE0_D;

      SG_C_ASSERT(__sizeof__DMA_TYPE0_D, sizeof (DMA_TYPE0_D) == 32);

   #else
      typedef struct _DMA_TYPE0_D {
         u32 haddr_l;                             // DWORD 0
         u32 dtype : 3;                           // DWORD 1
         u32 dcrd : 1;                            // DWORD 1
         u32 cplid : 4;                           // DWORD 1
         u32 cplvec : 3;                          // DWORD 1
         u32 msrc : 2;                            // DWORD 1
         u32 swap : 2;                            // DWORD 1
         u32 mrken : 1;                           // DWORD 1
         u32 crc_en : 1;                          // DWORD 1
         u32 cra : 1;                             // DWORD 1
         u32 pbfree : 1;                          // DWORD 1
         u32 tgtsel : 1;                          // DWORD 1
         u32 exzero : 1;                          // DWORD 1
         u32 dif_en : 1;                          // DWORD 1
         u32 pciats : 2;                          // DWORD 1
         u32 pcixvf : 8;                          // DWORD 1
         u32 offset : 16;                         // DWORD 2
         u32 len : 16;                            // DWORD 2
         u32 haddr_h;                             // DWORD 3
         u32 crc_start : 1;                       // DWORD 4
         u32 crc_end : 1;                         // DWORD 4
         u32 crc_cnt : 4;                         // DWORD 4
         u32 cid : 10;                            // DWORD 4
         u32 mrkstride : 2;                       // DWORD 4
         u32 mrklen : 2;                          // DWORD 4
         u32 mrkstart : 12;                       // DWORD 4
         u32 maddr;                               // DWORD 5
         u32 cpl_ret3 : 16;                       // DWORD 6
         u32 cpl_ret2 : 16;                       // DWORD 6
         u32 cpl_ret1 : 16;                       // DWORD 7
         u32 cpl_ret0 : 16;                       // DWORD 7
      } SG_PACK DMA_TYPE0_D, *PDMA_TYPE0_D;

      typedef union _DMA_TYPE0_D_UNION {
         DMA_TYPE0_D bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_TYPE0_D_UNION, *PDMA_TYPE0_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_TYPE0_D_UNION, sizeof (DMA_TYPE0_D_UNION) == 32);
   #endif


#else
   // Normal DMA descriptor (Single Host/ddr address)
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_TYPE0_D {
         union {
            struct { 
               u32 haddr_l;                       // DWORD 0
               u32 pcixvf : 8;                    // DWORD 1
               u32 pciats : 2;                    // DWORD 1
               u32 dif_en : 1;                    // DWORD 1
               u32 exzero : 1;                    // DWORD 1
               u32 tgtsel : 1;                    // DWORD 1
               u32 pbfree : 1;                    // DWORD 1
               u32 cra : 1;                       // DWORD 1
               u32 crc_en : 1;                    // DWORD 1
               u32 mrken : 1;                     // DWORD 1
               u32 swap : 2;                      // DWORD 1
               u32 msrc : 2;                      // DWORD 1
               u32 cplvec : 3;                    // DWORD 1
               u32 cplid : 4;                     // DWORD 1
               u32 dcrd : 1;                      // DWORD 1
               u32 dtype : 3;                     // DWORD 1
               u32 len : 16;                      // DWORD 2
               u32 offset : 16;                   // DWORD 2
               u32 haddr_h;                       // DWORD 3
               u32 mrkstart : 12;                 // DWORD 4
               u32 mrklen : 2;                    // DWORD 4
               u32 mrkstride : 2;                 // DWORD 4
               u32 cid : 10;                      // DWORD 4
               u32 crc_cnt : 4;                   // DWORD 4
               u32 crc_end : 1;                   // DWORD 4
               u32 crc_start : 1;                 // DWORD 4
               u32 maddr;                         // DWORD 5
               u32 cpl_ret2 : 16;                 // DWORD 6
               u32 cpl_ret3 : 16;                 // DWORD 6
               u32 cpl_ret0 : 16;                 // DWORD 7
               u32 cpl_ret1 : 16;                 // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_TYPE0_D, *PDMA_TYPE0_D;

      SG_C_ASSERT(__sizeof__DMA_TYPE0_D, sizeof (DMA_TYPE0_D) == 32);

   #else
      typedef struct _DMA_TYPE0_D {
         u32 haddr_l;                             // DWORD 0
         u32 pcixvf : 8;                          // DWORD 1
         u32 pciats : 2;                          // DWORD 1
         u32 dif_en : 1;                          // DWORD 1
         u32 exzero : 1;                          // DWORD 1
         u32 tgtsel : 1;                          // DWORD 1
         u32 pbfree : 1;                          // DWORD 1
         u32 cra : 1;                             // DWORD 1
         u32 crc_en : 1;                          // DWORD 1
         u32 mrken : 1;                           // DWORD 1
         u32 swap : 2;                            // DWORD 1
         u32 msrc : 2;                            // DWORD 1
         u32 cplvec : 3;                          // DWORD 1
         u32 cplid : 4;                           // DWORD 1
         u32 dcrd : 1;                            // DWORD 1
         u32 dtype : 3;                           // DWORD 1
         u32 len : 16;                            // DWORD 2
         u32 offset : 16;                         // DWORD 2
         u32 haddr_h;                             // DWORD 3
         u32 mrkstart : 12;                       // DWORD 4
         u32 mrklen : 2;                          // DWORD 4
         u32 mrkstride : 2;                       // DWORD 4
         u32 cid : 10;                            // DWORD 4
         u32 crc_cnt : 4;                         // DWORD 4
         u32 crc_end : 1;                         // DWORD 4
         u32 crc_start : 1;                       // DWORD 4
         u32 maddr;                               // DWORD 5
         u32 cpl_ret2 : 16;                       // DWORD 6
         u32 cpl_ret3 : 16;                       // DWORD 6
         u32 cpl_ret0 : 16;                       // DWORD 7
         u32 cpl_ret1 : 16;                       // DWORD 7
      } SG_PACK DMA_TYPE0_D, *PDMA_TYPE0_D;

      typedef union _DMA_TYPE0_D_UNION {
         DMA_TYPE0_D bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_TYPE0_D_UNION, *PDMA_TYPE0_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_TYPE0_D_UNION, sizeof (DMA_TYPE0_D_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Fraglist DMA descriptor (Multiple Host/ddr fragment addresses)
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_TYPE1_D {
         union {
            struct { 
               u32 rsv1 : 16;                     // DWORD 0
               u32 frag_ring_size : 3;            // DWORD 0
               u32 fcnt : 5;                      // DWORD 0
               u32 rsv0 : 2;                      // DWORD 0
               u32 fsrc : 2;                      // DWORD 0
               u32 ftype : 1;                     // DWORD 0
               u32 fsize : 3;                     // DWORD 0
               u32 dtype : 3;                     // DWORD 1
               u32 dcrd : 1;                      // DWORD 1
               u32 cplid : 4;                     // DWORD 1
               u32 cplvec : 3;                    // DWORD 1
               u32 msrc : 2;                      // DWORD 1
               u32 swap : 2;                      // DWORD 1
               u32 mrken : 1;                     // DWORD 1
               u32 crc_en : 1;                    // DWORD 1
               u32 cra : 1;                       // DWORD 1
               u32 pbfree : 1;                    // DWORD 1
               u32 tgtsel : 1;                    // DWORD 1
               u32 exzero : 1;                    // DWORD 1
               u32 dif_en : 1;                    // DWORD 1
               u32 pciats : 2;                    // DWORD 1
               u32 pcixvf : 8;                    // DWORD 1
               u32 offset : 16;                   // DWORD 2
               u32 len : 16;                      // DWORD 2
               u32 rsv2 : 8;                      // DWORD 3
               u32 faddr : 24;                    // DWORD 3
               u32 crc_start : 1;                 // DWORD 4
               u32 crc_end : 1;                   // DWORD 4
               u32 crc_cnt : 4;                   // DWORD 4
               u32 cid : 10;                      // DWORD 4
               u32 mrkstride : 2;                 // DWORD 4
               u32 mrklen : 2;                    // DWORD 4
               u32 mrkstart : 12;                 // DWORD 4
               u32 maddr;                         // DWORD 5
               u32 cpl_ret3 : 16;                 // DWORD 6
               u32 cpl_ret2 : 16;                 // DWORD 6
               u32 cpl_ret1 : 16;                 // DWORD 7
               u32 cpl_ret0 : 16;                 // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_TYPE1_D, *PDMA_TYPE1_D;

      SG_C_ASSERT(__sizeof__DMA_TYPE1_D, sizeof (DMA_TYPE1_D) == 32);

   #else
      typedef struct _DMA_TYPE1_D {
         u32 rsv1 : 16;                           // DWORD 0
         u32 frag_ring_size : 3;                  // DWORD 0
         u32 fcnt : 5;                            // DWORD 0
         u32 rsv0 : 2;                            // DWORD 0
         u32 fsrc : 2;                            // DWORD 0
         u32 ftype : 1;                           // DWORD 0
         u32 fsize : 3;                           // DWORD 0
         u32 dtype : 3;                           // DWORD 1
         u32 dcrd : 1;                            // DWORD 1
         u32 cplid : 4;                           // DWORD 1
         u32 cplvec : 3;                          // DWORD 1
         u32 msrc : 2;                            // DWORD 1
         u32 swap : 2;                            // DWORD 1
         u32 mrken : 1;                           // DWORD 1
         u32 crc_en : 1;                          // DWORD 1
         u32 cra : 1;                             // DWORD 1
         u32 pbfree : 1;                          // DWORD 1
         u32 tgtsel : 1;                          // DWORD 1
         u32 exzero : 1;                          // DWORD 1
         u32 dif_en : 1;                          // DWORD 1
         u32 pciats : 2;                          // DWORD 1
         u32 pcixvf : 8;                          // DWORD 1
         u32 offset : 16;                         // DWORD 2
         u32 len : 16;                            // DWORD 2
         u32 rsv2 : 8;                            // DWORD 3
         u32 faddr : 24;                          // DWORD 3
         u32 crc_start : 1;                       // DWORD 4
         u32 crc_end : 1;                         // DWORD 4
         u32 crc_cnt : 4;                         // DWORD 4
         u32 cid : 10;                            // DWORD 4
         u32 mrkstride : 2;                       // DWORD 4
         u32 mrklen : 2;                          // DWORD 4
         u32 mrkstart : 12;                       // DWORD 4
         u32 maddr;                               // DWORD 5
         u32 cpl_ret3 : 16;                       // DWORD 6
         u32 cpl_ret2 : 16;                       // DWORD 6
         u32 cpl_ret1 : 16;                       // DWORD 7
         u32 cpl_ret0 : 16;                       // DWORD 7
      } SG_PACK DMA_TYPE1_D, *PDMA_TYPE1_D;

      typedef union _DMA_TYPE1_D_UNION {
         DMA_TYPE1_D bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_TYPE1_D_UNION, *PDMA_TYPE1_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_TYPE1_D_UNION, sizeof (DMA_TYPE1_D_UNION) == 32);
   #endif


#else
   // Fraglist DMA descriptor (Multiple Host/ddr fragment addresses)
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_TYPE1_D {
         union {
            struct { 
               u32 fsize : 3;                     // DWORD 0
               u32 ftype : 1;                     // DWORD 0
               u32 fsrc : 2;                      // DWORD 0
               u32 rsv0 : 2;                      // DWORD 0
               u32 fcnt : 5;                      // DWORD 0
               u32 frag_ring_size : 3;            // DWORD 0
               u32 rsv1 : 16;                     // DWORD 0
               u32 pcixvf : 8;                    // DWORD 1
               u32 pciats : 2;                    // DWORD 1
               u32 dif_en : 1;                    // DWORD 1
               u32 exzero : 1;                    // DWORD 1
               u32 tgtsel : 1;                    // DWORD 1
               u32 pbfree : 1;                    // DWORD 1
               u32 cra : 1;                       // DWORD 1
               u32 crc_en : 1;                    // DWORD 1
               u32 mrken : 1;                     // DWORD 1
               u32 swap : 2;                      // DWORD 1
               u32 msrc : 2;                      // DWORD 1
               u32 cplvec : 3;                    // DWORD 1
               u32 cplid : 4;                     // DWORD 1
               u32 dcrd : 1;                      // DWORD 1
               u32 dtype : 3;                     // DWORD 1
               u32 len : 16;                      // DWORD 2
               u32 offset : 16;                   // DWORD 2
               u32 faddr : 24;                    // DWORD 3
               u32 rsv2 : 8;                      // DWORD 3
               u32 mrkstart : 12;                 // DWORD 4
               u32 mrklen : 2;                    // DWORD 4
               u32 mrkstride : 2;                 // DWORD 4
               u32 cid : 10;                      // DWORD 4
               u32 crc_cnt : 4;                   // DWORD 4
               u32 crc_end : 1;                   // DWORD 4
               u32 crc_start : 1;                 // DWORD 4
               u32 maddr;                         // DWORD 5
               u32 cpl_ret2 : 16;                 // DWORD 6
               u32 cpl_ret3 : 16;                 // DWORD 6
               u32 cpl_ret0 : 16;                 // DWORD 7
               u32 cpl_ret1 : 16;                 // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_TYPE1_D, *PDMA_TYPE1_D;

      SG_C_ASSERT(__sizeof__DMA_TYPE1_D, sizeof (DMA_TYPE1_D) == 32);

   #else
      typedef struct _DMA_TYPE1_D {
         u32 fsize : 3;                           // DWORD 0
         u32 ftype : 1;                           // DWORD 0
         u32 fsrc : 2;                            // DWORD 0
         u32 rsv0 : 2;                            // DWORD 0
         u32 fcnt : 5;                            // DWORD 0
         u32 frag_ring_size : 3;                  // DWORD 0
         u32 rsv1 : 16;                           // DWORD 0
         u32 pcixvf : 8;                          // DWORD 1
         u32 pciats : 2;                          // DWORD 1
         u32 dif_en : 1;                          // DWORD 1
         u32 exzero : 1;                          // DWORD 1
         u32 tgtsel : 1;                          // DWORD 1
         u32 pbfree : 1;                          // DWORD 1
         u32 cra : 1;                             // DWORD 1
         u32 crc_en : 1;                          // DWORD 1
         u32 mrken : 1;                           // DWORD 1
         u32 swap : 2;                            // DWORD 1
         u32 msrc : 2;                            // DWORD 1
         u32 cplvec : 3;                          // DWORD 1
         u32 cplid : 4;                           // DWORD 1
         u32 dcrd : 1;                            // DWORD 1
         u32 dtype : 3;                           // DWORD 1
         u32 len : 16;                            // DWORD 2
         u32 offset : 16;                         // DWORD 2
         u32 faddr : 24;                          // DWORD 3
         u32 rsv2 : 8;                            // DWORD 3
         u32 mrkstart : 12;                       // DWORD 4
         u32 mrklen : 2;                          // DWORD 4
         u32 mrkstride : 2;                       // DWORD 4
         u32 cid : 10;                            // DWORD 4
         u32 crc_cnt : 4;                         // DWORD 4
         u32 crc_end : 1;                         // DWORD 4
         u32 crc_start : 1;                       // DWORD 4
         u32 maddr;                               // DWORD 5
         u32 cpl_ret2 : 16;                       // DWORD 6
         u32 cpl_ret3 : 16;                       // DWORD 6
         u32 cpl_ret0 : 16;                       // DWORD 7
         u32 cpl_ret1 : 16;                       // DWORD 7
      } SG_PACK DMA_TYPE1_D, *PDMA_TYPE1_D;

      typedef union _DMA_TYPE1_D_UNION {
         DMA_TYPE1_D bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_TYPE1_D_UNION, *PDMA_TYPE1_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_TYPE1_D_UNION, sizeof (DMA_TYPE1_D_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Immediate DMA Descriptor (Single Host/ddr address, Immediate data from descriptor)
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_TYPE2_D {
         union {
            struct { 
               u32 haddr_l;                       // DWORD 0
               u32 dtype : 3;                     // DWORD 1
               u32 dcrd : 1;                      // DWORD 1
               u32 cplid : 4;                     // DWORD 1
               u32 cplvec : 3;                    // DWORD 1
               u32 msrc : 2;                      // DWORD 1
               u32 swap : 2;                      // DWORD 1
               u32 mrken : 1;                     // DWORD 1
               u32 crc_en : 1;                    // DWORD 1
               u32 cra : 1;                       // DWORD 1
               u32 pbfree : 1;                    // DWORD 1
               u32 tgtsel : 1;                    // DWORD 1
               u32 exzero : 1;                    // DWORD 1
               u32 dif_en : 1;                    // DWORD 1
               u32 pciats : 2;                    // DWORD 1
               u32 pcixvf : 8;                    // DWORD 1
               u32 offset : 16;                   // DWORD 2
               u32 len : 16;                      // DWORD 2
               u32 haddr_h;                       // DWORD 3
               u32 imm7_6 : 16;                   // DWORD 4
               u32 imm5_4 : 16;                   // DWORD 4
               u32 imm3_2 : 16;                   // DWORD 5
               u32 imm1_0 : 16;                   // DWORD 5
               u32 imm15_14 : 16;                 // DWORD 6
               u32 imm13_12 : 16;                 // DWORD 6
               u32 imm11_10 : 16;                 // DWORD 7
               u32 imm9_8 : 16;                   // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_TYPE2_D, *PDMA_TYPE2_D;

      SG_C_ASSERT(__sizeof__DMA_TYPE2_D, sizeof (DMA_TYPE2_D) == 32);

   #else
      typedef struct _DMA_TYPE2_D {
         u32 haddr_l;                             // DWORD 0
         u32 dtype : 3;                           // DWORD 1
         u32 dcrd : 1;                            // DWORD 1
         u32 cplid : 4;                           // DWORD 1
         u32 cplvec : 3;                          // DWORD 1
         u32 msrc : 2;                            // DWORD 1
         u32 swap : 2;                            // DWORD 1
         u32 mrken : 1;                           // DWORD 1
         u32 crc_en : 1;                          // DWORD 1
         u32 cra : 1;                             // DWORD 1
         u32 pbfree : 1;                          // DWORD 1
         u32 tgtsel : 1;                          // DWORD 1
         u32 exzero : 1;                          // DWORD 1
         u32 dif_en : 1;                          // DWORD 1
         u32 pciats : 2;                          // DWORD 1
         u32 pcixvf : 8;                          // DWORD 1
         u32 offset : 16;                         // DWORD 2
         u32 len : 16;                            // DWORD 2
         u32 haddr_h;                             // DWORD 3
         u32 imm7_6 : 16;                         // DWORD 4
         u32 imm5_4 : 16;                         // DWORD 4
         u32 imm3_2 : 16;                         // DWORD 5
         u32 imm1_0 : 16;                         // DWORD 5
         u32 imm15_14 : 16;                       // DWORD 6
         u32 imm13_12 : 16;                       // DWORD 6
         u32 imm11_10 : 16;                       // DWORD 7
         u32 imm9_8 : 16;                         // DWORD 7
      } SG_PACK DMA_TYPE2_D, *PDMA_TYPE2_D;

      typedef union _DMA_TYPE2_D_UNION {
         DMA_TYPE2_D bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_TYPE2_D_UNION, *PDMA_TYPE2_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_TYPE2_D_UNION, sizeof (DMA_TYPE2_D_UNION) == 32);
   #endif


#else
   // Immediate DMA Descriptor (Single Host/ddr address, Immediate data from descriptor)
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_TYPE2_D {
         union {
            struct { 
               u32 haddr_l;                       // DWORD 0
               u32 pcixvf : 8;                    // DWORD 1
               u32 pciats : 2;                    // DWORD 1
               u32 dif_en : 1;                    // DWORD 1
               u32 exzero : 1;                    // DWORD 1
               u32 tgtsel : 1;                    // DWORD 1
               u32 pbfree : 1;                    // DWORD 1
               u32 cra : 1;                       // DWORD 1
               u32 crc_en : 1;                    // DWORD 1
               u32 mrken : 1;                     // DWORD 1
               u32 swap : 2;                      // DWORD 1
               u32 msrc : 2;                      // DWORD 1
               u32 cplvec : 3;                    // DWORD 1
               u32 cplid : 4;                     // DWORD 1
               u32 dcrd : 1;                      // DWORD 1
               u32 dtype : 3;                     // DWORD 1
               u32 len : 16;                      // DWORD 2
               u32 offset : 16;                   // DWORD 2
               u32 haddr_h;                       // DWORD 3
               u32 imm5_4 : 16;                   // DWORD 4
               u32 imm7_6 : 16;                   // DWORD 4
               u32 imm1_0 : 16;                   // DWORD 5
               u32 imm3_2 : 16;                   // DWORD 5
               u32 imm13_12 : 16;                 // DWORD 6
               u32 imm15_14 : 16;                 // DWORD 6
               u32 imm9_8 : 16;                   // DWORD 7
               u32 imm11_10 : 16;                 // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_TYPE2_D, *PDMA_TYPE2_D;

      SG_C_ASSERT(__sizeof__DMA_TYPE2_D, sizeof (DMA_TYPE2_D) == 32);

   #else
      typedef struct _DMA_TYPE2_D {
         u32 haddr_l;                             // DWORD 0
         u32 pcixvf : 8;                          // DWORD 1
         u32 pciats : 2;                          // DWORD 1
         u32 dif_en : 1;                          // DWORD 1
         u32 exzero : 1;                          // DWORD 1
         u32 tgtsel : 1;                          // DWORD 1
         u32 pbfree : 1;                          // DWORD 1
         u32 cra : 1;                             // DWORD 1
         u32 crc_en : 1;                          // DWORD 1
         u32 mrken : 1;                           // DWORD 1
         u32 swap : 2;                            // DWORD 1
         u32 msrc : 2;                            // DWORD 1
         u32 cplvec : 3;                          // DWORD 1
         u32 cplid : 4;                           // DWORD 1
         u32 dcrd : 1;                            // DWORD 1
         u32 dtype : 3;                           // DWORD 1
         u32 len : 16;                            // DWORD 2
         u32 offset : 16;                         // DWORD 2
         u32 haddr_h;                             // DWORD 3
         u32 imm5_4 : 16;                         // DWORD 4
         u32 imm7_6 : 16;                         // DWORD 4
         u32 imm1_0 : 16;                         // DWORD 5
         u32 imm3_2 : 16;                         // DWORD 5
         u32 imm13_12 : 16;                       // DWORD 6
         u32 imm15_14 : 16;                       // DWORD 6
         u32 imm9_8 : 16;                         // DWORD 7
         u32 imm11_10 : 16;                       // DWORD 7
      } SG_PACK DMA_TYPE2_D, *PDMA_TYPE2_D;

      typedef union _DMA_TYPE2_D_UNION {
         DMA_TYPE2_D bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_TYPE2_D_UNION, *PDMA_TYPE2_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_TYPE2_D_UNION, sizeof (DMA_TYPE2_D_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WRB Dbuf Scatter/Gather DMA descriptor. Single Host/ddr address, immediate data from
   // 1-4 Type2 descriptors. Note that all the address/control information in the
   // associated Type2 descriptors is ignored, and only Immediate data used. Also the
   // Type2 dbuf descriptors are always automatically deallocated by WDMA. Type2
   // descriptors must specify a transfer len in 16-byte multiples, and host address must
   // be 16-byte aligned. 
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_TYPE3_D {
         union {
            struct { 
               u32 haddr_l;                       // DWORD 0
               u32 dtype : 3;                     // DWORD 1
               u32 dcrd : 1;                      // DWORD 1
               u32 cplid : 4;                     // DWORD 1
               u32 cplvec : 3;                    // DWORD 1
               u32 msrc : 2;                      // DWORD 1
               u32 swap : 2;                      // DWORD 1
               u32 mrken : 1;                     // DWORD 1
               u32 crc_en : 1;                    // DWORD 1
               u32 cra : 1;                       // DWORD 1
               u32 pbfree : 1;                    // DWORD 1
               u32 tgtsel : 1;                    // DWORD 1
               u32 exzero : 1;                    // DWORD 1
               u32 dif_en : 1;                    // DWORD 1
               u32 pciats : 2;                    // DWORD 1
               u32 pcixvf : 8;                    // DWORD 1
               u32 offset : 16;                   // DWORD 2
               u32 len : 16;                      // DWORD 2
               u32 haddr_h;                       // DWORD 3
               u32 dbuf3 : 16;                    // DWORD 4
               u32 dbuf2 : 16;                    // DWORD 4
               u32 dbuf1 : 16;                    // DWORD 5
               u32 dbuf0 : 16;                    // DWORD 5
               u32 cpl_ret3 : 16;                 // DWORD 6
               u32 cpl_ret2 : 16;                 // DWORD 6
               u32 cpl_ret1 : 16;                 // DWORD 7
               u32 cpl_ret0 : 16;                 // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_TYPE3_D, *PDMA_TYPE3_D;

      SG_C_ASSERT(__sizeof__DMA_TYPE3_D, sizeof (DMA_TYPE3_D) == 32);

   #else
      typedef struct _DMA_TYPE3_D {
         u32 haddr_l;                             // DWORD 0
         u32 dtype : 3;                           // DWORD 1
         u32 dcrd : 1;                            // DWORD 1
         u32 cplid : 4;                           // DWORD 1
         u32 cplvec : 3;                          // DWORD 1
         u32 msrc : 2;                            // DWORD 1
         u32 swap : 2;                            // DWORD 1
         u32 mrken : 1;                           // DWORD 1
         u32 crc_en : 1;                          // DWORD 1
         u32 cra : 1;                             // DWORD 1
         u32 pbfree : 1;                          // DWORD 1
         u32 tgtsel : 1;                          // DWORD 1
         u32 exzero : 1;                          // DWORD 1
         u32 dif_en : 1;                          // DWORD 1
         u32 pciats : 2;                          // DWORD 1
         u32 pcixvf : 8;                          // DWORD 1
         u32 offset : 16;                         // DWORD 2
         u32 len : 16;                            // DWORD 2
         u32 haddr_h;                             // DWORD 3
         u32 dbuf3 : 16;                          // DWORD 4
         u32 dbuf2 : 16;                          // DWORD 4
         u32 dbuf1 : 16;                          // DWORD 5
         u32 dbuf0 : 16;                          // DWORD 5
         u32 cpl_ret3 : 16;                       // DWORD 6
         u32 cpl_ret2 : 16;                       // DWORD 6
         u32 cpl_ret1 : 16;                       // DWORD 7
         u32 cpl_ret0 : 16;                       // DWORD 7
      } SG_PACK DMA_TYPE3_D, *PDMA_TYPE3_D;

      typedef union _DMA_TYPE3_D_UNION {
         DMA_TYPE3_D bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_TYPE3_D_UNION, *PDMA_TYPE3_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_TYPE3_D_UNION, sizeof (DMA_TYPE3_D_UNION) == 32);
   #endif


#else
   // WRB Dbuf Scatter/Gather DMA descriptor. Single Host/ddr address, immediate data from
   // 1-4 Type2 descriptors. Note that all the address/control information in the
   // associated Type2 descriptors is ignored, and only Immediate data used. Also the
   // Type2 dbuf descriptors are always automatically deallocated by WDMA. Type2
   // descriptors must specify a transfer len in 16-byte multiples, and host address must
   // be 16-byte aligned. 
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_TYPE3_D {
         union {
            struct { 
               u32 haddr_l;                       // DWORD 0
               u32 pcixvf : 8;                    // DWORD 1
               u32 pciats : 2;                    // DWORD 1
               u32 dif_en : 1;                    // DWORD 1
               u32 exzero : 1;                    // DWORD 1
               u32 tgtsel : 1;                    // DWORD 1
               u32 pbfree : 1;                    // DWORD 1
               u32 cra : 1;                       // DWORD 1
               u32 crc_en : 1;                    // DWORD 1
               u32 mrken : 1;                     // DWORD 1
               u32 swap : 2;                      // DWORD 1
               u32 msrc : 2;                      // DWORD 1
               u32 cplvec : 3;                    // DWORD 1
               u32 cplid : 4;                     // DWORD 1
               u32 dcrd : 1;                      // DWORD 1
               u32 dtype : 3;                     // DWORD 1
               u32 len : 16;                      // DWORD 2
               u32 offset : 16;                   // DWORD 2
               u32 haddr_h;                       // DWORD 3
               u32 dbuf2 : 16;                    // DWORD 4
               u32 dbuf3 : 16;                    // DWORD 4
               u32 dbuf0 : 16;                    // DWORD 5
               u32 dbuf1 : 16;                    // DWORD 5
               u32 cpl_ret2 : 16;                 // DWORD 6
               u32 cpl_ret3 : 16;                 // DWORD 6
               u32 cpl_ret0 : 16;                 // DWORD 7
               u32 cpl_ret1 : 16;                 // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_TYPE3_D, *PDMA_TYPE3_D;

      SG_C_ASSERT(__sizeof__DMA_TYPE3_D, sizeof (DMA_TYPE3_D) == 32);

   #else
      typedef struct _DMA_TYPE3_D {
         u32 haddr_l;                             // DWORD 0
         u32 pcixvf : 8;                          // DWORD 1
         u32 pciats : 2;                          // DWORD 1
         u32 dif_en : 1;                          // DWORD 1
         u32 exzero : 1;                          // DWORD 1
         u32 tgtsel : 1;                          // DWORD 1
         u32 pbfree : 1;                          // DWORD 1
         u32 cra : 1;                             // DWORD 1
         u32 crc_en : 1;                          // DWORD 1
         u32 mrken : 1;                           // DWORD 1
         u32 swap : 2;                            // DWORD 1
         u32 msrc : 2;                            // DWORD 1
         u32 cplvec : 3;                          // DWORD 1
         u32 cplid : 4;                           // DWORD 1
         u32 dcrd : 1;                            // DWORD 1
         u32 dtype : 3;                           // DWORD 1
         u32 len : 16;                            // DWORD 2
         u32 offset : 16;                         // DWORD 2
         u32 haddr_h;                             // DWORD 3
         u32 dbuf2 : 16;                          // DWORD 4
         u32 dbuf3 : 16;                          // DWORD 4
         u32 dbuf0 : 16;                          // DWORD 5
         u32 dbuf1 : 16;                          // DWORD 5
         u32 cpl_ret2 : 16;                       // DWORD 6
         u32 cpl_ret3 : 16;                       // DWORD 6
         u32 cpl_ret0 : 16;                       // DWORD 7
         u32 cpl_ret1 : 16;                       // DWORD 7
      } SG_PACK DMA_TYPE3_D, *PDMA_TYPE3_D;

      typedef union _DMA_TYPE3_D_UNION {
         DMA_TYPE3_D bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_TYPE3_D_UNION, *PDMA_TYPE3_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_TYPE3_D_UNION, sizeof (DMA_TYPE3_D_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The real DMA descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_DMA_TYPE1_USAGE {
         union {
            struct { 
               u32 fwd : 1;                       // DWORD 0
               u32 oid : 2;                       // DWORD 0
               u32 lseg : 1;                      // DWORD 0
               u32 lreq : 1;                      // DWORD 0
               u32 stall : 1;                     // DWORD 0
               u32 rcra : 1;                      // DWORD 0
               u32 dcrd : 1;                      // DWORD 0
               u32 pbfree : 1;                    // DWORD 0
               u32 ffout : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 func : 1;                      // DWORD 0
               u32 dqid : 4;                      // DWORD 0
               u32 fgl : 1;                       // DWORD 0
               u32 dsrc : 2;                      // DWORD 0
               u32 fsrc : 2;                      // DWORD 0
               u32 fblk : 1;                      // DWORD 0
               u32 swap : 2;                      // DWORD 0
               u32 pcrc : 8;                      // DWORD 0
               u32 addr1_lo;                      // DWORD 1
               u32 addr1_hi;                      // DWORD 2
               u32 offset : 16;                   // DWORD 3
               u32 len : 16;                      // DWORD 3
               u32 addr0;                         // DWORD 4
               u32 cid : 10;                      // DWORD 5
               u32 pcount : 6;                    // DWORD 5
               u32 numbd : 5;                     // DWORD 5
               u32 ptype : 2;                     // DWORD 5
               u32 ptail : 9;                     // DWORD 5
               u32 retval1 : 16;                  // DWORD 6
               u32 retval0 : 16;                  // DWORD 6
               u32 retval3 : 16;                  // DWORD 7
               u32 retval2 : 16;                  // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK UC_DMA_TYPE1_USAGE, *PUC_DMA_TYPE1_USAGE;

      SG_C_ASSERT(__sizeof__UC_DMA_TYPE1_USAGE, sizeof (UC_DMA_TYPE1_USAGE) == 32);

   #else
      typedef struct _UC_DMA_TYPE1_USAGE {
         u32 fwd : 1;                             // DWORD 0
         u32 oid : 2;                             // DWORD 0
         u32 lseg : 1;                            // DWORD 0
         u32 lreq : 1;                            // DWORD 0
         u32 stall : 1;                           // DWORD 0
         u32 rcra : 1;                            // DWORD 0
         u32 dcrd : 1;                            // DWORD 0
         u32 pbfree : 1;                          // DWORD 0
         u32 ffout : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 func : 1;                            // DWORD 0
         u32 dqid : 4;                            // DWORD 0
         u32 fgl : 1;                             // DWORD 0
         u32 dsrc : 2;                            // DWORD 0
         u32 fsrc : 2;                            // DWORD 0
         u32 fblk : 1;                            // DWORD 0
         u32 swap : 2;                            // DWORD 0
         u32 pcrc : 8;                            // DWORD 0
         u32 addr1_lo;                            // DWORD 1
         u32 addr1_hi;                            // DWORD 2
         u32 offset : 16;                         // DWORD 3
         u32 len : 16;                            // DWORD 3
         u32 addr0;                               // DWORD 4
         u32 cid : 10;                            // DWORD 5
         u32 pcount : 6;                          // DWORD 5
         u32 numbd : 5;                           // DWORD 5
         u32 ptype : 2;                           // DWORD 5
         u32 ptail : 9;                           // DWORD 5
         u32 retval1 : 16;                        // DWORD 6
         u32 retval0 : 16;                        // DWORD 6
         u32 retval3 : 16;                        // DWORD 7
         u32 retval2 : 16;                        // DWORD 7
      } SG_PACK UC_DMA_TYPE1_USAGE, *PUC_DMA_TYPE1_USAGE;

      typedef union _UC_DMA_TYPE1_USAGE_UNION {
         UC_DMA_TYPE1_USAGE bits;
         u32 dw[8]; // dword union
      } SG_PACK UC_DMA_TYPE1_USAGE_UNION, *PUC_DMA_TYPE1_USAGE_UNION;

      SG_C_ASSERT(__sizeof__UC_DMA_TYPE1_USAGE_UNION, sizeof (UC_DMA_TYPE1_USAGE_UNION) == 32);
   #endif


#else
   // The real DMA descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_DMA_TYPE1_USAGE {
         union {
            struct { 
               u32 pcrc : 8;                      // DWORD 0
               u32 swap : 2;                      // DWORD 0
               u32 fblk : 1;                      // DWORD 0
               u32 fsrc : 2;                      // DWORD 0
               u32 dsrc : 2;                      // DWORD 0
               u32 fgl : 1;                       // DWORD 0
               u32 dqid : 4;                      // DWORD 0
               u32 func : 1;                      // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ffout : 1;                     // DWORD 0
               u32 pbfree : 1;                    // DWORD 0
               u32 dcrd : 1;                      // DWORD 0
               u32 rcra : 1;                      // DWORD 0
               u32 stall : 1;                     // DWORD 0
               u32 lreq : 1;                      // DWORD 0
               u32 lseg : 1;                      // DWORD 0
               u32 oid : 2;                       // DWORD 0
               u32 fwd : 1;                       // DWORD 0
               u32 addr1_lo;                      // DWORD 1
               u32 addr1_hi;                      // DWORD 2
               u32 len : 16;                      // DWORD 3
               u32 offset : 16;                   // DWORD 3
               u32 addr0;                         // DWORD 4
               u32 ptail : 9;                     // DWORD 5
               u32 ptype : 2;                     // DWORD 5
               u32 numbd : 5;                     // DWORD 5
               u32 pcount : 6;                    // DWORD 5
               u32 cid : 10;                      // DWORD 5
               u32 retval0 : 16;                  // DWORD 6
               u32 retval1 : 16;                  // DWORD 6
               u32 retval2 : 16;                  // DWORD 7
               u32 retval3 : 16;                  // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK UC_DMA_TYPE1_USAGE, *PUC_DMA_TYPE1_USAGE;

      SG_C_ASSERT(__sizeof__UC_DMA_TYPE1_USAGE, sizeof (UC_DMA_TYPE1_USAGE) == 32);

   #else
      typedef struct _UC_DMA_TYPE1_USAGE {
         u32 pcrc : 8;                            // DWORD 0
         u32 swap : 2;                            // DWORD 0
         u32 fblk : 1;                            // DWORD 0
         u32 fsrc : 2;                            // DWORD 0
         u32 dsrc : 2;                            // DWORD 0
         u32 fgl : 1;                             // DWORD 0
         u32 dqid : 4;                            // DWORD 0
         u32 func : 1;                            // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ffout : 1;                           // DWORD 0
         u32 pbfree : 1;                          // DWORD 0
         u32 dcrd : 1;                            // DWORD 0
         u32 rcra : 1;                            // DWORD 0
         u32 stall : 1;                           // DWORD 0
         u32 lreq : 1;                            // DWORD 0
         u32 lseg : 1;                            // DWORD 0
         u32 oid : 2;                             // DWORD 0
         u32 fwd : 1;                             // DWORD 0
         u32 addr1_lo;                            // DWORD 1
         u32 addr1_hi;                            // DWORD 2
         u32 len : 16;                            // DWORD 3
         u32 offset : 16;                         // DWORD 3
         u32 addr0;                               // DWORD 4
         u32 ptail : 9;                           // DWORD 5
         u32 ptype : 2;                           // DWORD 5
         u32 numbd : 5;                           // DWORD 5
         u32 pcount : 6;                          // DWORD 5
         u32 cid : 10;                            // DWORD 5
         u32 retval0 : 16;                        // DWORD 6
         u32 retval1 : 16;                        // DWORD 6
         u32 retval2 : 16;                        // DWORD 7
         u32 retval3 : 16;                        // DWORD 7
      } SG_PACK UC_DMA_TYPE1_USAGE, *PUC_DMA_TYPE1_USAGE;

      typedef union _UC_DMA_TYPE1_USAGE_UNION {
         UC_DMA_TYPE1_USAGE bits;
         u32 dw[8]; // dword union
      } SG_PACK UC_DMA_TYPE1_USAGE_UNION, *PUC_DMA_TYPE1_USAGE_UNION;

      SG_C_ASSERT(__sizeof__UC_DMA_TYPE1_USAGE_UNION, sizeof (UC_DMA_TYPE1_USAGE_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_DMA_TYPE2_USAGE {
         union {
            struct { 
               u32 fwd : 1;                       // DWORD 0
               u32 oid : 2;                       // DWORD 0
               u32 lseg : 1;                      // DWORD 0
               u32 lreq : 1;                      // DWORD 0
               u32 stall : 1;                     // DWORD 0
               u32 rcra : 1;                      // DWORD 0
               u32 dcrd : 1;                      // DWORD 0
               u32 pbfree : 1;                    // DWORD 0
               u32 ffout : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 func : 1;                      // DWORD 0
               u32 dqid : 4;                      // DWORD 0
               u32 fgl : 1;                       // DWORD 0
               u32 dsrc : 2;                      // DWORD 0
               u32 fsrc : 2;                      // DWORD 0
               u32 fblk : 1;                      // DWORD 0
               u32 swap : 2;                      // DWORD 0
               u32 pcrc : 8;                      // DWORD 0
               u32 addr1_lo;                      // DWORD 1
               u32 addr1_hi;                      // DWORD 2
               u32 rsvd1 : 16;                    // DWORD 3
               u32 len : 16;                      // DWORD 3
               u32 imm0;                          // DWORD 4
               u32 imm1;                          // DWORD 5
               u32 imm2;                          // DWORD 6
               u32 imm3;                          // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK UC_DMA_TYPE2_USAGE, *PUC_DMA_TYPE2_USAGE;

      SG_C_ASSERT(__sizeof__UC_DMA_TYPE2_USAGE, sizeof (UC_DMA_TYPE2_USAGE) == 32);

   #else
      typedef struct _UC_DMA_TYPE2_USAGE {
         u32 fwd : 1;                             // DWORD 0
         u32 oid : 2;                             // DWORD 0
         u32 lseg : 1;                            // DWORD 0
         u32 lreq : 1;                            // DWORD 0
         u32 stall : 1;                           // DWORD 0
         u32 rcra : 1;                            // DWORD 0
         u32 dcrd : 1;                            // DWORD 0
         u32 pbfree : 1;                          // DWORD 0
         u32 ffout : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 func : 1;                            // DWORD 0
         u32 dqid : 4;                            // DWORD 0
         u32 fgl : 1;                             // DWORD 0
         u32 dsrc : 2;                            // DWORD 0
         u32 fsrc : 2;                            // DWORD 0
         u32 fblk : 1;                            // DWORD 0
         u32 swap : 2;                            // DWORD 0
         u32 pcrc : 8;                            // DWORD 0
         u32 addr1_lo;                            // DWORD 1
         u32 addr1_hi;                            // DWORD 2
         u32 rsvd1 : 16;                          // DWORD 3
         u32 len : 16;                            // DWORD 3
         u32 imm0;                                // DWORD 4
         u32 imm1;                                // DWORD 5
         u32 imm2;                                // DWORD 6
         u32 imm3;                                // DWORD 7
      } SG_PACK UC_DMA_TYPE2_USAGE, *PUC_DMA_TYPE2_USAGE;

      typedef union _UC_DMA_TYPE2_USAGE_UNION {
         UC_DMA_TYPE2_USAGE bits;
         u32 dw[8]; // dword union
      } SG_PACK UC_DMA_TYPE2_USAGE_UNION, *PUC_DMA_TYPE2_USAGE_UNION;

      SG_C_ASSERT(__sizeof__UC_DMA_TYPE2_USAGE_UNION, sizeof (UC_DMA_TYPE2_USAGE_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_DMA_TYPE2_USAGE {
         union {
            struct { 
               u32 pcrc : 8;                      // DWORD 0
               u32 swap : 2;                      // DWORD 0
               u32 fblk : 1;                      // DWORD 0
               u32 fsrc : 2;                      // DWORD 0
               u32 dsrc : 2;                      // DWORD 0
               u32 fgl : 1;                       // DWORD 0
               u32 dqid : 4;                      // DWORD 0
               u32 func : 1;                      // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ffout : 1;                     // DWORD 0
               u32 pbfree : 1;                    // DWORD 0
               u32 dcrd : 1;                      // DWORD 0
               u32 rcra : 1;                      // DWORD 0
               u32 stall : 1;                     // DWORD 0
               u32 lreq : 1;                      // DWORD 0
               u32 lseg : 1;                      // DWORD 0
               u32 oid : 2;                       // DWORD 0
               u32 fwd : 1;                       // DWORD 0
               u32 addr1_lo;                      // DWORD 1
               u32 addr1_hi;                      // DWORD 2
               u32 len : 16;                      // DWORD 3
               u32 rsvd1 : 16;                    // DWORD 3
               u32 imm0;                          // DWORD 4
               u32 imm1;                          // DWORD 5
               u32 imm2;                          // DWORD 6
               u32 imm3;                          // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK UC_DMA_TYPE2_USAGE, *PUC_DMA_TYPE2_USAGE;

      SG_C_ASSERT(__sizeof__UC_DMA_TYPE2_USAGE, sizeof (UC_DMA_TYPE2_USAGE) == 32);

   #else
      typedef struct _UC_DMA_TYPE2_USAGE {
         u32 pcrc : 8;                            // DWORD 0
         u32 swap : 2;                            // DWORD 0
         u32 fblk : 1;                            // DWORD 0
         u32 fsrc : 2;                            // DWORD 0
         u32 dsrc : 2;                            // DWORD 0
         u32 fgl : 1;                             // DWORD 0
         u32 dqid : 4;                            // DWORD 0
         u32 func : 1;                            // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ffout : 1;                           // DWORD 0
         u32 pbfree : 1;                          // DWORD 0
         u32 dcrd : 1;                            // DWORD 0
         u32 rcra : 1;                            // DWORD 0
         u32 stall : 1;                           // DWORD 0
         u32 lreq : 1;                            // DWORD 0
         u32 lseg : 1;                            // DWORD 0
         u32 oid : 2;                             // DWORD 0
         u32 fwd : 1;                             // DWORD 0
         u32 addr1_lo;                            // DWORD 1
         u32 addr1_hi;                            // DWORD 2
         u32 len : 16;                            // DWORD 3
         u32 rsvd1 : 16;                          // DWORD 3
         u32 imm0;                                // DWORD 4
         u32 imm1;                                // DWORD 5
         u32 imm2;                                // DWORD 6
         u32 imm3;                                // DWORD 7
      } SG_PACK UC_DMA_TYPE2_USAGE, *PUC_DMA_TYPE2_USAGE;

      typedef union _UC_DMA_TYPE2_USAGE_UNION {
         UC_DMA_TYPE2_USAGE bits;
         u32 dw[8]; // dword union
      } SG_PACK UC_DMA_TYPE2_USAGE_UNION, *PUC_DMA_TYPE2_USAGE_UNION;

      SG_C_ASSERT(__sizeof__UC_DMA_TYPE2_USAGE_UNION, sizeof (UC_DMA_TYPE2_USAGE_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The real DMA descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_DMA_TYPE1_USAGE {
         union {
            struct { 
               u32 fwd : 1;                       // DWORD 0
               u32 oid : 2;                       // DWORD 0
               u32 lseg : 1;                      // DWORD 0
               u32 lreq : 1;                      // DWORD 0
               u32 stall : 1;                     // DWORD 0
               u32 rcra : 1;                      // DWORD 0
               u32 dcrd : 1;                      // DWORD 0
               u32 dqid : 8;                      // DWORD 0
               u32 fgl : 1;                       // DWORD 0
               u32 dsrc : 2;                      // DWORD 0
               u32 fsrc : 2;                      // DWORD 0
               u32 fblk : 1;                      // DWORD 0
               u32 swap : 2;                      // DWORD 0
               u32 pcrc : 8;                      // DWORD 0
               u32 addr1_lo;                      // DWORD 1
               u32 addr1_hi;                      // DWORD 2
               u32 offset : 16;                   // DWORD 3
               u32 len : 16;                      // DWORD 3
               u32 addr0;                         // DWORD 4
               u32 cid : 10;                      // DWORD 5
               u32 pcount : 6;                    // DWORD 5
               u32 numbd : 5;                     // DWORD 5
               u32 ptype : 2;                     // DWORD 5
               u32 ptail : 9;                     // DWORD 5
               u32 retval1 : 16;                  // DWORD 6
               u32 retval0 : 16;                  // DWORD 6
               u32 retval3 : 16;                  // DWORD 7
               u32 retval2 : 16;                  // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK PTC_DMA_TYPE1_USAGE, *PPTC_DMA_TYPE1_USAGE;

      SG_C_ASSERT(__sizeof__PTC_DMA_TYPE1_USAGE, sizeof (PTC_DMA_TYPE1_USAGE) == 32);

   #else
      typedef struct _PTC_DMA_TYPE1_USAGE {
         u32 fwd : 1;                             // DWORD 0
         u32 oid : 2;                             // DWORD 0
         u32 lseg : 1;                            // DWORD 0
         u32 lreq : 1;                            // DWORD 0
         u32 stall : 1;                           // DWORD 0
         u32 rcra : 1;                            // DWORD 0
         u32 dcrd : 1;                            // DWORD 0
         u32 dqid : 8;                            // DWORD 0
         u32 fgl : 1;                             // DWORD 0
         u32 dsrc : 2;                            // DWORD 0
         u32 fsrc : 2;                            // DWORD 0
         u32 fblk : 1;                            // DWORD 0
         u32 swap : 2;                            // DWORD 0
         u32 pcrc : 8;                            // DWORD 0
         u32 addr1_lo;                            // DWORD 1
         u32 addr1_hi;                            // DWORD 2
         u32 offset : 16;                         // DWORD 3
         u32 len : 16;                            // DWORD 3
         u32 addr0;                               // DWORD 4
         u32 cid : 10;                            // DWORD 5
         u32 pcount : 6;                          // DWORD 5
         u32 numbd : 5;                           // DWORD 5
         u32 ptype : 2;                           // DWORD 5
         u32 ptail : 9;                           // DWORD 5
         u32 retval1 : 16;                        // DWORD 6
         u32 retval0 : 16;                        // DWORD 6
         u32 retval3 : 16;                        // DWORD 7
         u32 retval2 : 16;                        // DWORD 7
      } SG_PACK PTC_DMA_TYPE1_USAGE, *PPTC_DMA_TYPE1_USAGE;

      typedef union _PTC_DMA_TYPE1_USAGE_UNION {
         PTC_DMA_TYPE1_USAGE bits;
         u32 dw[8]; // dword union
      } SG_PACK PTC_DMA_TYPE1_USAGE_UNION, *PPTC_DMA_TYPE1_USAGE_UNION;

      SG_C_ASSERT(__sizeof__PTC_DMA_TYPE1_USAGE_UNION, sizeof (PTC_DMA_TYPE1_USAGE_UNION) == 32);
   #endif


#else
   // The real DMA descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_DMA_TYPE1_USAGE {
         union {
            struct { 
               u32 pcrc : 8;                      // DWORD 0
               u32 swap : 2;                      // DWORD 0
               u32 fblk : 1;                      // DWORD 0
               u32 fsrc : 2;                      // DWORD 0
               u32 dsrc : 2;                      // DWORD 0
               u32 fgl : 1;                       // DWORD 0
               u32 dqid : 8;                      // DWORD 0
               u32 dcrd : 1;                      // DWORD 0
               u32 rcra : 1;                      // DWORD 0
               u32 stall : 1;                     // DWORD 0
               u32 lreq : 1;                      // DWORD 0
               u32 lseg : 1;                      // DWORD 0
               u32 oid : 2;                       // DWORD 0
               u32 fwd : 1;                       // DWORD 0
               u32 addr1_lo;                      // DWORD 1
               u32 addr1_hi;                      // DWORD 2
               u32 len : 16;                      // DWORD 3
               u32 offset : 16;                   // DWORD 3
               u32 addr0;                         // DWORD 4
               u32 ptail : 9;                     // DWORD 5
               u32 ptype : 2;                     // DWORD 5
               u32 numbd : 5;                     // DWORD 5
               u32 pcount : 6;                    // DWORD 5
               u32 cid : 10;                      // DWORD 5
               u32 retval0 : 16;                  // DWORD 6
               u32 retval1 : 16;                  // DWORD 6
               u32 retval2 : 16;                  // DWORD 7
               u32 retval3 : 16;                  // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK PTC_DMA_TYPE1_USAGE, *PPTC_DMA_TYPE1_USAGE;

      SG_C_ASSERT(__sizeof__PTC_DMA_TYPE1_USAGE, sizeof (PTC_DMA_TYPE1_USAGE) == 32);

   #else
      typedef struct _PTC_DMA_TYPE1_USAGE {
         u32 pcrc : 8;                            // DWORD 0
         u32 swap : 2;                            // DWORD 0
         u32 fblk : 1;                            // DWORD 0
         u32 fsrc : 2;                            // DWORD 0
         u32 dsrc : 2;                            // DWORD 0
         u32 fgl : 1;                             // DWORD 0
         u32 dqid : 8;                            // DWORD 0
         u32 dcrd : 1;                            // DWORD 0
         u32 rcra : 1;                            // DWORD 0
         u32 stall : 1;                           // DWORD 0
         u32 lreq : 1;                            // DWORD 0
         u32 lseg : 1;                            // DWORD 0
         u32 oid : 2;                             // DWORD 0
         u32 fwd : 1;                             // DWORD 0
         u32 addr1_lo;                            // DWORD 1
         u32 addr1_hi;                            // DWORD 2
         u32 len : 16;                            // DWORD 3
         u32 offset : 16;                         // DWORD 3
         u32 addr0;                               // DWORD 4
         u32 ptail : 9;                           // DWORD 5
         u32 ptype : 2;                           // DWORD 5
         u32 numbd : 5;                           // DWORD 5
         u32 pcount : 6;                          // DWORD 5
         u32 cid : 10;                            // DWORD 5
         u32 retval0 : 16;                        // DWORD 6
         u32 retval1 : 16;                        // DWORD 6
         u32 retval2 : 16;                        // DWORD 7
         u32 retval3 : 16;                        // DWORD 7
      } SG_PACK PTC_DMA_TYPE1_USAGE, *PPTC_DMA_TYPE1_USAGE;

      typedef union _PTC_DMA_TYPE1_USAGE_UNION {
         PTC_DMA_TYPE1_USAGE bits;
         u32 dw[8]; // dword union
      } SG_PACK PTC_DMA_TYPE1_USAGE_UNION, *PPTC_DMA_TYPE1_USAGE_UNION;

      SG_C_ASSERT(__sizeof__PTC_DMA_TYPE1_USAGE_UNION, sizeof (PTC_DMA_TYPE1_USAGE_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_D {
         union {
            union { 
               DMA_TYPE1_D type1;
               DMA_TYPE2_D type2;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_D, *PDMA_D;

      SG_C_ASSERT(__sizeof__DMA_D, sizeof (DMA_D) == 32);

   #else
      typedef union _DMA_D {
         DMA_TYPE1_D type1;
         DMA_TYPE2_D type2;
      } SG_PACK DMA_D, *PDMA_D;

      typedef union _DMA_D_UNION {
         DMA_D bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_D_UNION, *PDMA_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_D_UNION, sizeof (DMA_D_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_D {
         union {
            union { 
               DMA_TYPE1_D type1;
               DMA_TYPE2_D type2;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_D, *PDMA_D;

      SG_C_ASSERT(__sizeof__DMA_D, sizeof (DMA_D) == 32);

   #else
      typedef union _DMA_D {
         DMA_TYPE1_D type1;
         DMA_TYPE2_D type2;
      } SG_PACK DMA_D, *PDMA_D;

      typedef union _DMA_D_UNION {
         DMA_D bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_D_UNION, *PDMA_D_UNION;

      SG_C_ASSERT(__sizeof__DMA_D_UNION, sizeof (DMA_D_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RxULP WDMA Consolidator Request Descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_D {
         union {
            struct { 
               u32 crc_start : 1;                 // DWORD 0
               u32 crc_end : 1;                   // DWORD 0
               u32 Sbytecnt : 14;                 // DWORD 0
               u32 pbfree : 1;                    // DWORD 0
               u32 Event : 1;                     // DWORD 0
               u32 Last : 1;                      // DWORD 0
               u32 CmdID : 13;                    // DWORD 0
               u32 WDMAret2EP : 1;                // DWORD 1
               u32 PageMode : 1;                  // DWORD 1
               u32 CQEpresent : 1;                // DWORD 1
               u32 pyldPresent : 1;               // DWORD 1
               u32 ForceInv : 1;                  // DWORD 1
               u32 newCmd : 1;                    // DWORD 1
               u32 PagePacked : 1;                // DWORD 1
               u32 SeekOffs : 25;                 // DWORD 1
               u32 ErrorCQE : 1;                  // DWORD 2
               u32 fenceTag : 3;                  // DWORD 2
               u32 dbgTag : 5;                    // DWORD 2
               u32 PMEMsrcAddr : 23;              // DWORD 2
               u32 crc_cnt : 4;                   // DWORD 3
               u32 crc_en : 1;                    // DWORD 3
               u32 StartCRA : 27;                 // DWORD 3
               u32 rsvd0 : 8;                     // DWORD 4
               u32 EPretCargo : 8;                // DWORD 4
               u32 mrkpreface : 1;                // DWORD 4
               u32 SolEvent : 1;                  // DWORD 4
               u32 CQid : 10;                     // DWORD 4
               u32 fenceAll : 1;                  // DWORD 4
               u32 fence : 1;                     // DWORD 4
               u32 mrklen : 2;                    // DWORD 4
               u32 mrken : 1;                     // DWORD 5
               u32 mrkstride : 2;                 // DWORD 5
               u32 mrkstart : 13;                 // DWORD 5
               u32 msrc : 1;                      // DWORD 5
               u32 pageSize : 3;                  // DWORD 5
               u32 HoldPyldDBUFs : 1;             // DWORD 5
               u32 dif_mode : 2;                  // DWORD 5
               u32 tgtsel : 1;                    // DWORD 5
               u32 FID : 8;                       // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK WCON_D, *PWCON_D;

      SG_C_ASSERT(__sizeof__WCON_D, sizeof (WCON_D) == 24);

   #else
      typedef struct _WCON_D {
         u32 crc_start : 1;                       // DWORD 0
         u32 crc_end : 1;                         // DWORD 0
         u32 Sbytecnt : 14;                       // DWORD 0
         u32 pbfree : 1;                          // DWORD 0
         u32 Event : 1;                           // DWORD 0
         u32 Last : 1;                            // DWORD 0
         u32 CmdID : 13;                          // DWORD 0
         u32 WDMAret2EP : 1;                      // DWORD 1
         u32 PageMode : 1;                        // DWORD 1
         u32 CQEpresent : 1;                      // DWORD 1
         u32 pyldPresent : 1;                     // DWORD 1
         u32 ForceInv : 1;                        // DWORD 1
         u32 newCmd : 1;                          // DWORD 1
         u32 PagePacked : 1;                      // DWORD 1
         u32 SeekOffs : 25;                       // DWORD 1
         u32 ErrorCQE : 1;                        // DWORD 2
         u32 fenceTag : 3;                        // DWORD 2
         u32 dbgTag : 5;                          // DWORD 2
         u32 PMEMsrcAddr : 23;                    // DWORD 2
         u32 crc_cnt : 4;                         // DWORD 3
         u32 crc_en : 1;                          // DWORD 3
         u32 StartCRA : 27;                       // DWORD 3
         u32 rsvd0 : 8;                           // DWORD 4
         u32 EPretCargo : 8;                      // DWORD 4
         u32 mrkpreface : 1;                      // DWORD 4
         u32 SolEvent : 1;                        // DWORD 4
         u32 CQid : 10;                           // DWORD 4
         u32 fenceAll : 1;                        // DWORD 4
         u32 fence : 1;                           // DWORD 4
         u32 mrklen : 2;                          // DWORD 4
         u32 mrken : 1;                           // DWORD 5
         u32 mrkstride : 2;                       // DWORD 5
         u32 mrkstart : 13;                       // DWORD 5
         u32 msrc : 1;                            // DWORD 5
         u32 pageSize : 3;                        // DWORD 5
         u32 HoldPyldDBUFs : 1;                   // DWORD 5
         u32 dif_mode : 2;                        // DWORD 5
         u32 tgtsel : 1;                          // DWORD 5
         u32 FID : 8;                             // DWORD 5
      } SG_PACK WCON_D, *PWCON_D;

      typedef union _WCON_D_UNION {
         WCON_D bits;
         u32 dw[6]; // dword union
      } SG_PACK WCON_D_UNION, *PWCON_D_UNION;

      SG_C_ASSERT(__sizeof__WCON_D_UNION, sizeof (WCON_D_UNION) == 24);
   #endif


#else
   // RxULP WDMA Consolidator Request Descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_D {
         union {
            struct { 
               u32 CmdID : 13;                    // DWORD 0
               u32 Last : 1;                      // DWORD 0
               u32 Event : 1;                     // DWORD 0
               u32 pbfree : 1;                    // DWORD 0
               u32 Sbytecnt : 14;                 // DWORD 0
               u32 crc_end : 1;                   // DWORD 0
               u32 crc_start : 1;                 // DWORD 0
               u32 SeekOffs : 25;                 // DWORD 1
               u32 PagePacked : 1;                // DWORD 1
               u32 newCmd : 1;                    // DWORD 1
               u32 ForceInv : 1;                  // DWORD 1
               u32 pyldPresent : 1;               // DWORD 1
               u32 CQEpresent : 1;                // DWORD 1
               u32 PageMode : 1;                  // DWORD 1
               u32 WDMAret2EP : 1;                // DWORD 1
               u32 PMEMsrcAddr : 23;              // DWORD 2
               u32 dbgTag : 5;                    // DWORD 2
               u32 fenceTag : 3;                  // DWORD 2
               u32 ErrorCQE : 1;                  // DWORD 2
               u32 StartCRA : 27;                 // DWORD 3
               u32 crc_en : 1;                    // DWORD 3
               u32 crc_cnt : 4;                   // DWORD 3
               u32 mrklen : 2;                    // DWORD 4
               u32 fence : 1;                     // DWORD 4
               u32 fenceAll : 1;                  // DWORD 4
               u32 CQid : 10;                     // DWORD 4
               u32 SolEvent : 1;                  // DWORD 4
               u32 mrkpreface : 1;                // DWORD 4
               u32 EPretCargo : 8;                // DWORD 4
               u32 rsvd0 : 8;                     // DWORD 4
               u32 FID : 8;                       // DWORD 5
               u32 tgtsel : 1;                    // DWORD 5
               u32 dif_mode : 2;                  // DWORD 5
               u32 HoldPyldDBUFs : 1;             // DWORD 5
               u32 pageSize : 3;                  // DWORD 5
               u32 msrc : 1;                      // DWORD 5
               u32 mrkstart : 13;                 // DWORD 5
               u32 mrkstride : 2;                 // DWORD 5
               u32 mrken : 1;                     // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK WCON_D, *PWCON_D;

      SG_C_ASSERT(__sizeof__WCON_D, sizeof (WCON_D) == 24);

   #else
      typedef struct _WCON_D {
         u32 CmdID : 13;                          // DWORD 0
         u32 Last : 1;                            // DWORD 0
         u32 Event : 1;                           // DWORD 0
         u32 pbfree : 1;                          // DWORD 0
         u32 Sbytecnt : 14;                       // DWORD 0
         u32 crc_end : 1;                         // DWORD 0
         u32 crc_start : 1;                       // DWORD 0
         u32 SeekOffs : 25;                       // DWORD 1
         u32 PagePacked : 1;                      // DWORD 1
         u32 newCmd : 1;                          // DWORD 1
         u32 ForceInv : 1;                        // DWORD 1
         u32 pyldPresent : 1;                     // DWORD 1
         u32 CQEpresent : 1;                      // DWORD 1
         u32 PageMode : 1;                        // DWORD 1
         u32 WDMAret2EP : 1;                      // DWORD 1
         u32 PMEMsrcAddr : 23;                    // DWORD 2
         u32 dbgTag : 5;                          // DWORD 2
         u32 fenceTag : 3;                        // DWORD 2
         u32 ErrorCQE : 1;                        // DWORD 2
         u32 StartCRA : 27;                       // DWORD 3
         u32 crc_en : 1;                          // DWORD 3
         u32 crc_cnt : 4;                         // DWORD 3
         u32 mrklen : 2;                          // DWORD 4
         u32 fence : 1;                           // DWORD 4
         u32 fenceAll : 1;                        // DWORD 4
         u32 CQid : 10;                           // DWORD 4
         u32 SolEvent : 1;                        // DWORD 4
         u32 mrkpreface : 1;                      // DWORD 4
         u32 EPretCargo : 8;                      // DWORD 4
         u32 rsvd0 : 8;                           // DWORD 4
         u32 FID : 8;                             // DWORD 5
         u32 tgtsel : 1;                          // DWORD 5
         u32 dif_mode : 2;                        // DWORD 5
         u32 HoldPyldDBUFs : 1;                   // DWORD 5
         u32 pageSize : 3;                        // DWORD 5
         u32 msrc : 1;                            // DWORD 5
         u32 mrkstart : 13;                       // DWORD 5
         u32 mrkstride : 2;                       // DWORD 5
         u32 mrken : 1;                           // DWORD 5
      } SG_PACK WCON_D, *PWCON_D;

      typedef union _WCON_D_UNION {
         WCON_D bits;
         u32 dw[6]; // dword union
      } SG_PACK WCON_D_UNION, *PWCON_D_UNION;

      SG_C_ASSERT(__sizeof__WCON_D_UNION, sizeof (WCON_D_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RxULP WDMA Consolidator Block Mode Command Context. Must be aligned to a four-byte
   // boundary in CTX.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_BM_CC {
         union {
            struct { 
               u32 SGLun : 1;                     // DWORD 0
               u32 SGLov : 1;                     // DWORD 0
               u32 LastPending : 1;               // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 SEidx : 9;                     // DWORD 0
               u32 SEoffs : 16;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_BM_CC, *PWCON_BM_CC;

      SG_C_ASSERT(__sizeof__WCON_BM_CC, sizeof (WCON_BM_CC) == 4);

   #else
      typedef struct _WCON_BM_CC {
         u32 SGLun : 1;                           // DWORD 0
         u32 SGLov : 1;                           // DWORD 0
         u32 LastPending : 1;                     // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 SEidx : 9;                           // DWORD 0
         u32 SEoffs : 16;                         // DWORD 0
      } SG_PACK WCON_BM_CC, *PWCON_BM_CC;

      typedef union _WCON_BM_CC_UNION {
         WCON_BM_CC bits;
         u32 dw; // dword union
      } SG_PACK WCON_BM_CC_UNION, *PWCON_BM_CC_UNION;

      SG_C_ASSERT(__sizeof__WCON_BM_CC_UNION, sizeof (WCON_BM_CC_UNION) == 4);
   #endif


#else
   // RxULP WDMA Consolidator Block Mode Command Context. Must be aligned to a four-byte
   // boundary in CTX.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_BM_CC {
         union {
            struct { 
               u32 SEoffs : 16;                   // DWORD 0
               u32 SEidx : 9;                     // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 LastPending : 1;               // DWORD 0
               u32 SGLov : 1;                     // DWORD 0
               u32 SGLun : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_BM_CC, *PWCON_BM_CC;

      SG_C_ASSERT(__sizeof__WCON_BM_CC, sizeof (WCON_BM_CC) == 4);

   #else
      typedef struct _WCON_BM_CC {
         u32 SEoffs : 16;                         // DWORD 0
         u32 SEidx : 9;                           // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 LastPending : 1;                     // DWORD 0
         u32 SGLov : 1;                           // DWORD 0
         u32 SGLun : 1;                           // DWORD 0
      } SG_PACK WCON_BM_CC, *PWCON_BM_CC;

      typedef union _WCON_BM_CC_UNION {
         WCON_BM_CC bits;
         u32 dw; // dword union
      } SG_PACK WCON_BM_CC_UNION, *PWCON_BM_CC_UNION;

      SG_C_ASSERT(__sizeof__WCON_BM_CC_UNION, sizeof (WCON_BM_CC_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator Block Mode Scatter/Gather Element. 
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_BM_SGE {
         union {
            struct { 
               u32 palo;                          // DWORD 0
               u32 pahi;                          // DWORD 1
               u32 rsvd0 : 15;                    // DWORD 2
               u32 len : 17;                      // DWORD 2
               u32 Last : 1;                      // DWORD 3
               u32 rsvd1 : 31;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK WCON_BM_SGE, *PWCON_BM_SGE;

      SG_C_ASSERT(__sizeof__WCON_BM_SGE, sizeof (WCON_BM_SGE) == 16);

   #else
      typedef struct _WCON_BM_SGE {
         u32 palo;                                // DWORD 0
         u32 pahi;                                // DWORD 1
         u32 rsvd0 : 15;                          // DWORD 2
         u32 len : 17;                            // DWORD 2
         u32 Last : 1;                            // DWORD 3
         u32 rsvd1 : 31;                          // DWORD 3
      } SG_PACK WCON_BM_SGE, *PWCON_BM_SGE;

      typedef union _WCON_BM_SGE_UNION {
         WCON_BM_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK WCON_BM_SGE_UNION, *PWCON_BM_SGE_UNION;

      SG_C_ASSERT(__sizeof__WCON_BM_SGE_UNION, sizeof (WCON_BM_SGE_UNION) == 16);
   #endif


#else
   // WDMA Consolidator Block Mode Scatter/Gather Element. 
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_BM_SGE {
         union {
            struct { 
               u32 palo;                          // DWORD 0
               u32 pahi;                          // DWORD 1
               u32 len : 17;                      // DWORD 2
               u32 rsvd0 : 15;                    // DWORD 2
               u32 rsvd1 : 31;                    // DWORD 3
               u32 Last : 1;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK WCON_BM_SGE, *PWCON_BM_SGE;

      SG_C_ASSERT(__sizeof__WCON_BM_SGE, sizeof (WCON_BM_SGE) == 16);

   #else
      typedef struct _WCON_BM_SGE {
         u32 palo;                                // DWORD 0
         u32 pahi;                                // DWORD 1
         u32 len : 17;                            // DWORD 2
         u32 rsvd0 : 15;                          // DWORD 2
         u32 rsvd1 : 31;                          // DWORD 3
         u32 Last : 1;                            // DWORD 3
      } SG_PACK WCON_BM_SGE, *PWCON_BM_SGE;

      typedef union _WCON_BM_SGE_UNION {
         WCON_BM_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK WCON_BM_SGE_UNION, *PWCON_BM_SGE_UNION;

      SG_C_ASSERT(__sizeof__WCON_BM_SGE_UNION, sizeof (WCON_BM_SGE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WCON DBUF Debug Descriptor. This descriptor is placed in the cpl_ret3 and cpl_ret2
   // fields of every DBUF passed to WDMA by WCON. It contains details of the WCON request
   // that initiated the WDMA operation and is meant for debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_DMADBG_D {
         union {
            struct { 
               u32 newCmd : 1;                    // DWORD 0
               u32 Event : 1;                     // DWORD 0
               u32 dbgTag : 5;                    // DWORD 0
               u32 CmdID : 13;                    // DWORD 0
               u32 pduCQE : 1;                    // DWORD 0
               u32 CQEpresent : 1;                // DWORD 0
               u32 CQID : 10;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_DMADBG_D, *PWCON_DMADBG_D;

      SG_C_ASSERT(__sizeof__WCON_DMADBG_D, sizeof (WCON_DMADBG_D) == 4);

   #else
      typedef struct _WCON_DMADBG_D {
         u32 newCmd : 1;                          // DWORD 0
         u32 Event : 1;                           // DWORD 0
         u32 dbgTag : 5;                          // DWORD 0
         u32 CmdID : 13;                          // DWORD 0
         u32 pduCQE : 1;                          // DWORD 0
         u32 CQEpresent : 1;                      // DWORD 0
         u32 CQID : 10;                           // DWORD 0
      } SG_PACK WCON_DMADBG_D, *PWCON_DMADBG_D;

      typedef union _WCON_DMADBG_D_UNION {
         WCON_DMADBG_D bits;
         u32 dw; // dword union
      } SG_PACK WCON_DMADBG_D_UNION, *PWCON_DMADBG_D_UNION;

      SG_C_ASSERT(__sizeof__WCON_DMADBG_D_UNION, sizeof (WCON_DMADBG_D_UNION) == 4);
   #endif


#else
   // WCON DBUF Debug Descriptor. This descriptor is placed in the cpl_ret3 and cpl_ret2
   // fields of every DBUF passed to WDMA by WCON. It contains details of the WCON request
   // that initiated the WDMA operation and is meant for debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_DMADBG_D {
         union {
            struct { 
               u32 CQID : 10;                     // DWORD 0
               u32 CQEpresent : 1;                // DWORD 0
               u32 pduCQE : 1;                    // DWORD 0
               u32 CmdID : 13;                    // DWORD 0
               u32 dbgTag : 5;                    // DWORD 0
               u32 Event : 1;                     // DWORD 0
               u32 newCmd : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_DMADBG_D, *PWCON_DMADBG_D;

      SG_C_ASSERT(__sizeof__WCON_DMADBG_D, sizeof (WCON_DMADBG_D) == 4);

   #else
      typedef struct _WCON_DMADBG_D {
         u32 CQID : 10;                           // DWORD 0
         u32 CQEpresent : 1;                      // DWORD 0
         u32 pduCQE : 1;                          // DWORD 0
         u32 CmdID : 13;                          // DWORD 0
         u32 dbgTag : 5;                          // DWORD 0
         u32 Event : 1;                           // DWORD 0
         u32 newCmd : 1;                          // DWORD 0
      } SG_PACK WCON_DMADBG_D, *PWCON_DMADBG_D;

      typedef union _WCON_DMADBG_D_UNION {
         WCON_DMADBG_D bits;
         u32 dw; // dword union
      } SG_PACK WCON_DMADBG_D_UNION, *PWCON_DMADBG_D_UNION;

      SG_C_ASSERT(__sizeof__WCON_DMADBG_D_UNION, sizeof (WCON_DMADBG_D_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DMA T10-DIF ICD Context. Must be aligned to a eight-byte boundary in CTX.
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_ICD_C {
         union {
            struct { 
               u32 context_0;                     // DWORD 0
               u32 context_1;                     // DWORD 1
               u32 context_2;                     // DWORD 2
               u32 context_3;                     // DWORD 3
               u32 partialcrc : 16;               // DWORD 4
               u32 metadata : 16;                 // DWORD 4
               u32 expreftag;                     // DWORD 5
               u32 ErrValid : 1;                  // DWORD 6
               u32 rsv2 : 1;                      // DWORD 6
               u32 m : 2;                         // DWORD 6
               u32 bs : 2;                        // DWORD 6
               u32 rsv1 : 6;                      // DWORD 6
               u32 dsbl_ref : 1;                  // DWORD 6
               u32 dsbl_meta : 1;                 // DWORD 6
               u32 dsbl_crc : 1;                  // DWORD 6
               u32 err : 1;                       // DWORD 6
               u32 runlen : 16;                   // DWORD 6
               u32 newreftag;                     // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_ICD_C, *PDMA_ICD_C;

      SG_C_ASSERT(__sizeof__DMA_ICD_C, sizeof (DMA_ICD_C) == 32);

   #else
      typedef struct _DMA_ICD_C {
         u32 context_0;                           // DWORD 0
         u32 context_1;                           // DWORD 1
         u32 context_2;                           // DWORD 2
         u32 context_3;                           // DWORD 3
         u32 partialcrc : 16;                     // DWORD 4
         u32 metadata : 16;                       // DWORD 4
         u32 expreftag;                           // DWORD 5
         u32 ErrValid : 1;                        // DWORD 6
         u32 rsv2 : 1;                            // DWORD 6
         u32 m : 2;                               // DWORD 6
         u32 bs : 2;                              // DWORD 6
         u32 rsv1 : 6;                            // DWORD 6
         u32 dsbl_ref : 1;                        // DWORD 6
         u32 dsbl_meta : 1;                       // DWORD 6
         u32 dsbl_crc : 1;                        // DWORD 6
         u32 err : 1;                             // DWORD 6
         u32 runlen : 16;                         // DWORD 6
         u32 newreftag;                           // DWORD 7
      } SG_PACK DMA_ICD_C, *PDMA_ICD_C;

      typedef union _DMA_ICD_C_UNION {
         DMA_ICD_C bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_ICD_C_UNION, *PDMA_ICD_C_UNION;

      SG_C_ASSERT(__sizeof__DMA_ICD_C_UNION, sizeof (DMA_ICD_C_UNION) == 32);
   #endif


#else
   // DMA T10-DIF ICD Context. Must be aligned to a eight-byte boundary in CTX.
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_ICD_C {
         union {
            struct { 
               u32 context_0;                     // DWORD 0
               u32 context_1;                     // DWORD 1
               u32 context_2;                     // DWORD 2
               u32 context_3;                     // DWORD 3
               u32 metadata : 16;                 // DWORD 4
               u32 partialcrc : 16;               // DWORD 4
               u32 expreftag;                     // DWORD 5
               u32 runlen : 16;                   // DWORD 6
               u32 err : 1;                       // DWORD 6
               u32 dsbl_crc : 1;                  // DWORD 6
               u32 dsbl_meta : 1;                 // DWORD 6
               u32 dsbl_ref : 1;                  // DWORD 6
               u32 rsv1 : 6;                      // DWORD 6
               u32 bs : 2;                        // DWORD 6
               u32 m : 2;                         // DWORD 6
               u32 rsv2 : 1;                      // DWORD 6
               u32 ErrValid : 1;                  // DWORD 6
               u32 newreftag;                     // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DMA_ICD_C, *PDMA_ICD_C;

      SG_C_ASSERT(__sizeof__DMA_ICD_C, sizeof (DMA_ICD_C) == 32);

   #else
      typedef struct _DMA_ICD_C {
         u32 context_0;                           // DWORD 0
         u32 context_1;                           // DWORD 1
         u32 context_2;                           // DWORD 2
         u32 context_3;                           // DWORD 3
         u32 metadata : 16;                       // DWORD 4
         u32 partialcrc : 16;                     // DWORD 4
         u32 expreftag;                           // DWORD 5
         u32 runlen : 16;                         // DWORD 6
         u32 err : 1;                             // DWORD 6
         u32 dsbl_crc : 1;                        // DWORD 6
         u32 dsbl_meta : 1;                       // DWORD 6
         u32 dsbl_ref : 1;                        // DWORD 6
         u32 rsv1 : 6;                            // DWORD 6
         u32 bs : 2;                              // DWORD 6
         u32 m : 2;                               // DWORD 6
         u32 rsv2 : 1;                            // DWORD 6
         u32 ErrValid : 1;                        // DWORD 6
         u32 newreftag;                           // DWORD 7
      } SG_PACK DMA_ICD_C, *PDMA_ICD_C;

      typedef union _DMA_ICD_C_UNION {
         DMA_ICD_C bits;
         u32 dw[8]; // dword union
      } SG_PACK DMA_ICD_C_UNION, *PDMA_ICD_C_UNION;

      SG_C_ASSERT(__sizeof__DMA_ICD_C_UNION, sizeof (DMA_ICD_C_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DT_ENTRY {
         union {
            struct { 
               u32 PA1 : 20;                      // DWORD 0
               u32 RSVD : 8;                      // DWORD 0
               u32 PCIATS : 2;                    // DWORD 0
               u32 TGTSEL : 1;                    // DWORD 0
               u32 DTE_VALID : 1;                 // DWORD 0
               u32 PA2;                           // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK DT_ENTRY, *PDT_ENTRY;

      SG_C_ASSERT(__sizeof__DT_ENTRY, sizeof (DT_ENTRY) == 8);

   #else
      typedef struct _DT_ENTRY {
         u32 PA1 : 20;                            // DWORD 0
         u32 RSVD : 8;                            // DWORD 0
         u32 PCIATS : 2;                          // DWORD 0
         u32 TGTSEL : 1;                          // DWORD 0
         u32 DTE_VALID : 1;                       // DWORD 0
         u32 PA2;                                 // DWORD 1
      } SG_PACK DT_ENTRY, *PDT_ENTRY;

      typedef union _DT_ENTRY_UNION {
         DT_ENTRY bits;
         u32 dw[2]; // dword union
      } SG_PACK DT_ENTRY_UNION, *PDT_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__DT_ENTRY_UNION, sizeof (DT_ENTRY_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DT_ENTRY {
         union {
            struct { 
               u32 DTE_VALID : 1;                 // DWORD 0
               u32 TGTSEL : 1;                    // DWORD 0
               u32 PCIATS : 2;                    // DWORD 0
               u32 RSVD : 8;                      // DWORD 0
               u32 PA1 : 20;                      // DWORD 0
               u32 PA2;                           // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK DT_ENTRY, *PDT_ENTRY;

      SG_C_ASSERT(__sizeof__DT_ENTRY, sizeof (DT_ENTRY) == 8);

   #else
      typedef struct _DT_ENTRY {
         u32 DTE_VALID : 1;                       // DWORD 0
         u32 TGTSEL : 1;                          // DWORD 0
         u32 PCIATS : 2;                          // DWORD 0
         u32 RSVD : 8;                            // DWORD 0
         u32 PA1 : 20;                            // DWORD 0
         u32 PA2;                                 // DWORD 1
      } SG_PACK DT_ENTRY, *PDT_ENTRY;

      typedef union _DT_ENTRY_UNION {
         DT_ENTRY bits;
         u32 dw[2]; // dword union
      } SG_PACK DT_ENTRY_UNION, *PDT_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__DT_ENTRY_UNION, sizeof (DT_ENTRY_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PT_ENTRY {
         union {
            struct { 
               u32 PA1 : 20;                      // DWORD 0
               u32 RSVD : 6;                      // DWORD 0
               u32 MSRC : 2;                      // DWORD 0
               u32 PCIATS : 2;                    // DWORD 0
               u32 TGTSEL : 1;                    // DWORD 0
               u32 PTE_VALID : 1;                 // DWORD 0
               u32 PA2;                           // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK PT_ENTRY, *PPT_ENTRY;

      SG_C_ASSERT(__sizeof__PT_ENTRY, sizeof (PT_ENTRY) == 8);

   #else
      typedef struct _PT_ENTRY {
         u32 PA1 : 20;                            // DWORD 0
         u32 RSVD : 6;                            // DWORD 0
         u32 MSRC : 2;                            // DWORD 0
         u32 PCIATS : 2;                          // DWORD 0
         u32 TGTSEL : 1;                          // DWORD 0
         u32 PTE_VALID : 1;                       // DWORD 0
         u32 PA2;                                 // DWORD 1
      } SG_PACK PT_ENTRY, *PPT_ENTRY;

      typedef union _PT_ENTRY_UNION {
         PT_ENTRY bits;
         u32 dw[2]; // dword union
      } SG_PACK PT_ENTRY_UNION, *PPT_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__PT_ENTRY_UNION, sizeof (PT_ENTRY_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PT_ENTRY {
         union {
            struct { 
               u32 PTE_VALID : 1;                 // DWORD 0
               u32 TGTSEL : 1;                    // DWORD 0
               u32 PCIATS : 2;                    // DWORD 0
               u32 MSRC : 2;                      // DWORD 0
               u32 RSVD : 6;                      // DWORD 0
               u32 PA1 : 20;                      // DWORD 0
               u32 PA2;                           // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK PT_ENTRY, *PPT_ENTRY;

      SG_C_ASSERT(__sizeof__PT_ENTRY, sizeof (PT_ENTRY) == 8);

   #else
      typedef struct _PT_ENTRY {
         u32 PTE_VALID : 1;                       // DWORD 0
         u32 TGTSEL : 1;                          // DWORD 0
         u32 PCIATS : 2;                          // DWORD 0
         u32 MSRC : 2;                            // DWORD 0
         u32 RSVD : 6;                            // DWORD 0
         u32 PA1 : 20;                            // DWORD 0
         u32 PA2;                                 // DWORD 1
      } SG_PACK PT_ENTRY, *PPT_ENTRY;

      typedef union _PT_ENTRY_UNION {
         PT_ENTRY bits;
         u32 dw[2]; // dword union
      } SG_PACK PT_ENTRY_UNION, *PPT_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__PT_ENTRY_UNION, sizeof (PT_ENTRY_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_REQ_D {
         union {
            struct { 
               u32 pq_stall_arc : 4;              // DWORD 0
               u32 cra : 28;                      // DWORD 0
               u32 CARGO : 16;                    // DWORD 1
               u32 rsvd1 : 2;                     // DWORD 1
               u32 cqe : 1;                       // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 VL_ORDER : 4;                  // DWORD 1
               u32 PTC_REQ_OPCODE : 2;            // DWORD 1
               u32 rsvd0 : 3;                     // DWORD 1
               u32 empty : 1;                     // DWORD 1
               u32 discard : 1;                   // DWORD 1
               u32 stall : 1;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK PTC_REQ_D, *PPTC_REQ_D;

      SG_C_ASSERT(__sizeof__PTC_REQ_D, sizeof (PTC_REQ_D) == 8);

   #else
      typedef struct _PTC_REQ_D {
         u32 pq_stall_arc : 4;                    // DWORD 0
         u32 cra : 28;                            // DWORD 0
         u32 CARGO : 16;                          // DWORD 1
         u32 rsvd1 : 2;                           // DWORD 1
         u32 cqe : 1;                             // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 VL_ORDER : 4;                        // DWORD 1
         u32 PTC_REQ_OPCODE : 2;                  // DWORD 1
         u32 rsvd0 : 3;                           // DWORD 1
         u32 empty : 1;                           // DWORD 1
         u32 discard : 1;                         // DWORD 1
         u32 stall : 1;                           // DWORD 1
      } SG_PACK PTC_REQ_D, *PPTC_REQ_D;

      typedef union _PTC_REQ_D_UNION {
         PTC_REQ_D bits;
         u32 dw[2]; // dword union
      } SG_PACK PTC_REQ_D_UNION, *PPTC_REQ_D_UNION;

      SG_C_ASSERT(__sizeof__PTC_REQ_D_UNION, sizeof (PTC_REQ_D_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_REQ_D {
         union {
            struct { 
               u32 cra : 28;                      // DWORD 0
               u32 pq_stall_arc : 4;              // DWORD 0
               u32 stall : 1;                     // DWORD 1
               u32 discard : 1;                   // DWORD 1
               u32 empty : 1;                     // DWORD 1
               u32 rsvd0 : 3;                     // DWORD 1
               u32 PTC_REQ_OPCODE : 2;            // DWORD 1
               u32 VL_ORDER : 4;                  // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 cqe : 1;                       // DWORD 1
               u32 rsvd1 : 2;                     // DWORD 1
               u32 CARGO : 16;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK PTC_REQ_D, *PPTC_REQ_D;

      SG_C_ASSERT(__sizeof__PTC_REQ_D, sizeof (PTC_REQ_D) == 8);

   #else
      typedef struct _PTC_REQ_D {
         u32 cra : 28;                            // DWORD 0
         u32 pq_stall_arc : 4;                    // DWORD 0
         u32 stall : 1;                           // DWORD 1
         u32 discard : 1;                         // DWORD 1
         u32 empty : 1;                           // DWORD 1
         u32 rsvd0 : 3;                           // DWORD 1
         u32 PTC_REQ_OPCODE : 2;                  // DWORD 1
         u32 VL_ORDER : 4;                        // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 cqe : 1;                             // DWORD 1
         u32 rsvd1 : 2;                           // DWORD 1
         u32 CARGO : 16;                          // DWORD 1
      } SG_PACK PTC_REQ_D, *PPTC_REQ_D;

      typedef union _PTC_REQ_D_UNION {
         PTC_REQ_D bits;
         u32 dw[2]; // dword union
      } SG_PACK PTC_REQ_D_UNION, *PPTC_REQ_D_UNION;

      SG_C_ASSERT(__sizeof__PTC_REQ_D_UNION, sizeof (PTC_REQ_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_NEWREQ_D {
         union {
            struct { 
               u32 pci_func : 7;                  // DWORD 0
               u32 cra : 25;                      // DWORD 0
               u32 CARGO : 16;                    // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 pci_function__7 : 1;           // DWORD 1
               u32 cqe : 1;                       // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 VL_ORDER : 4;                  // DWORD 1
               u32 PTC_REQ_OPCODE : 2;            // DWORD 1
               u32 rsvd0 : 3;                     // DWORD 1
               u32 empty : 1;                     // DWORD 1
               u32 discard : 1;                   // DWORD 1
               u32 stall : 1;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK PTC_NEWREQ_D, *PPTC_NEWREQ_D;

      SG_C_ASSERT(__sizeof__PTC_NEWREQ_D, sizeof (PTC_NEWREQ_D) == 8);

   #else
      typedef struct _PTC_NEWREQ_D {
         u32 pci_func : 7;                        // DWORD 0
         u32 cra : 25;                            // DWORD 0
         u32 CARGO : 16;                          // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 pci_function__7 : 1;                 // DWORD 1
         u32 cqe : 1;                             // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 VL_ORDER : 4;                        // DWORD 1
         u32 PTC_REQ_OPCODE : 2;                  // DWORD 1
         u32 rsvd0 : 3;                           // DWORD 1
         u32 empty : 1;                           // DWORD 1
         u32 discard : 1;                         // DWORD 1
         u32 stall : 1;                           // DWORD 1
      } SG_PACK PTC_NEWREQ_D, *PPTC_NEWREQ_D;

      typedef union _PTC_NEWREQ_D_UNION {
         PTC_NEWREQ_D bits;
         u32 dw[2]; // dword union
      } SG_PACK PTC_NEWREQ_D_UNION, *PPTC_NEWREQ_D_UNION;

      SG_C_ASSERT(__sizeof__PTC_NEWREQ_D_UNION, sizeof (PTC_NEWREQ_D_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_NEWREQ_D {
         union {
            struct { 
               u32 cra : 25;                      // DWORD 0
               u32 pci_func : 7;                  // DWORD 0
               u32 stall : 1;                     // DWORD 1
               u32 discard : 1;                   // DWORD 1
               u32 empty : 1;                     // DWORD 1
               u32 rsvd0 : 3;                     // DWORD 1
               u32 PTC_REQ_OPCODE : 2;            // DWORD 1
               u32 VL_ORDER : 4;                  // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 cqe : 1;                       // DWORD 1
               u32 pci_function__7 : 1;           // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 CARGO : 16;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK PTC_NEWREQ_D, *PPTC_NEWREQ_D;

      SG_C_ASSERT(__sizeof__PTC_NEWREQ_D, sizeof (PTC_NEWREQ_D) == 8);

   #else
      typedef struct _PTC_NEWREQ_D {
         u32 cra : 25;                            // DWORD 0
         u32 pci_func : 7;                        // DWORD 0
         u32 stall : 1;                           // DWORD 1
         u32 discard : 1;                         // DWORD 1
         u32 empty : 1;                           // DWORD 1
         u32 rsvd0 : 3;                           // DWORD 1
         u32 PTC_REQ_OPCODE : 2;                  // DWORD 1
         u32 VL_ORDER : 4;                        // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 cqe : 1;                             // DWORD 1
         u32 pci_function__7 : 1;                 // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 CARGO : 16;                          // DWORD 1
      } SG_PACK PTC_NEWREQ_D, *PPTC_NEWREQ_D;

      typedef union _PTC_NEWREQ_D_UNION {
         PTC_NEWREQ_D bits;
         u32 dw[2]; // dword union
      } SG_PACK PTC_NEWREQ_D_UNION, *PPTC_NEWREQ_D_UNION;

      SG_C_ASSERT(__sizeof__PTC_NEWREQ_D_UNION, sizeof (PTC_NEWREQ_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_RESP_D {
         union {
            struct { 
               u32 CARGO : 16;                    // DWORD 0
               u32 STATUS : 4;                    // DWORD 0
               u32 VL_ORDER : 4;                  // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 pci_function__7 : 1;           // DWORD 0
               u32 CQE : 1;                       // DWORD 0
               u32 WR : 1;                        // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 1
               u32 cra : 28;                      // DWORD 1
               u32 PA_LOW;                        // DWORD 2
               u32 PA_HIGH;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK PTC_RESP_D, *PPTC_RESP_D;

      SG_C_ASSERT(__sizeof__PTC_RESP_D, sizeof (PTC_RESP_D) == 16);

   #else
      typedef struct _PTC_RESP_D {
         u32 CARGO : 16;                          // DWORD 0
         u32 STATUS : 4;                          // DWORD 0
         u32 VL_ORDER : 4;                        // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 pci_function__7 : 1;                 // DWORD 0
         u32 CQE : 1;                             // DWORD 0
         u32 WR : 1;                              // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 1
         u32 cra : 28;                            // DWORD 1
         u32 PA_LOW;                              // DWORD 2
         u32 PA_HIGH;                             // DWORD 3
      } SG_PACK PTC_RESP_D, *PPTC_RESP_D;

      typedef union _PTC_RESP_D_UNION {
         PTC_RESP_D bits;
         u32 dw[4]; // dword union
      } SG_PACK PTC_RESP_D_UNION, *PPTC_RESP_D_UNION;

      SG_C_ASSERT(__sizeof__PTC_RESP_D_UNION, sizeof (PTC_RESP_D_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_RESP_D {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 WR : 1;                        // DWORD 0
               u32 CQE : 1;                       // DWORD 0
               u32 pci_function__7 : 1;           // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 VL_ORDER : 4;                  // DWORD 0
               u32 STATUS : 4;                    // DWORD 0
               u32 CARGO : 16;                    // DWORD 0
               u32 cra : 28;                      // DWORD 1
               u32 rsvd2 : 4;                     // DWORD 1
               u32 PA_LOW;                        // DWORD 2
               u32 PA_HIGH;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK PTC_RESP_D, *PPTC_RESP_D;

      SG_C_ASSERT(__sizeof__PTC_RESP_D, sizeof (PTC_RESP_D) == 16);

   #else
      typedef struct _PTC_RESP_D {
         u32 stall : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 WR : 1;                              // DWORD 0
         u32 CQE : 1;                             // DWORD 0
         u32 pci_function__7 : 1;                 // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 VL_ORDER : 4;                        // DWORD 0
         u32 STATUS : 4;                          // DWORD 0
         u32 CARGO : 16;                          // DWORD 0
         u32 cra : 28;                            // DWORD 1
         u32 rsvd2 : 4;                           // DWORD 1
         u32 PA_LOW;                              // DWORD 2
         u32 PA_HIGH;                             // DWORD 3
      } SG_PACK PTC_RESP_D, *PPTC_RESP_D;

      typedef union _PTC_RESP_D_UNION {
         PTC_RESP_D bits;
         u32 dw[4]; // dword union
      } SG_PACK PTC_RESP_D_UNION, *PPTC_RESP_D_UNION;

      SG_C_ASSERT(__sizeof__PTC_RESP_D_UNION, sizeof (PTC_RESP_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_NEWRESP_D {
         union {
            struct { 
               u32 CARGO : 16;                    // DWORD 0
               u32 STATUS : 4;                    // DWORD 0
               u32 VL_ORDER : 4;                  // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 pci_function__7 : 1;           // DWORD 0
               u32 CQE : 1;                       // DWORD 0
               u32 WR : 1;                        // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
               u32 pci_func : 7;                  // DWORD 1
               u32 cra : 25;                      // DWORD 1
               u32 PA_LOW;                        // DWORD 2
               u32 PA_HIGH;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK PTC_NEWRESP_D, *PPTC_NEWRESP_D;

      SG_C_ASSERT(__sizeof__PTC_NEWRESP_D, sizeof (PTC_NEWRESP_D) == 16);

   #else
      typedef struct _PTC_NEWRESP_D {
         u32 CARGO : 16;                          // DWORD 0
         u32 STATUS : 4;                          // DWORD 0
         u32 VL_ORDER : 4;                        // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 pci_function__7 : 1;                 // DWORD 0
         u32 CQE : 1;                             // DWORD 0
         u32 WR : 1;                              // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
         u32 pci_func : 7;                        // DWORD 1
         u32 cra : 25;                            // DWORD 1
         u32 PA_LOW;                              // DWORD 2
         u32 PA_HIGH;                             // DWORD 3
      } SG_PACK PTC_NEWRESP_D, *PPTC_NEWRESP_D;

      typedef union _PTC_NEWRESP_D_UNION {
         PTC_NEWRESP_D bits;
         u32 dw[4]; // dword union
      } SG_PACK PTC_NEWRESP_D_UNION, *PPTC_NEWRESP_D_UNION;

      SG_C_ASSERT(__sizeof__PTC_NEWRESP_D_UNION, sizeof (PTC_NEWRESP_D_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PTC_NEWRESP_D {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 WR : 1;                        // DWORD 0
               u32 CQE : 1;                       // DWORD 0
               u32 pci_function__7 : 1;           // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 VL_ORDER : 4;                  // DWORD 0
               u32 STATUS : 4;                    // DWORD 0
               u32 CARGO : 16;                    // DWORD 0
               u32 cra : 25;                      // DWORD 1
               u32 pci_func : 7;                  // DWORD 1
               u32 PA_LOW;                        // DWORD 2
               u32 PA_HIGH;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK PTC_NEWRESP_D, *PPTC_NEWRESP_D;

      SG_C_ASSERT(__sizeof__PTC_NEWRESP_D, sizeof (PTC_NEWRESP_D) == 16);

   #else
      typedef struct _PTC_NEWRESP_D {
         u32 stall : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 WR : 1;                              // DWORD 0
         u32 CQE : 1;                             // DWORD 0
         u32 pci_function__7 : 1;                 // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 VL_ORDER : 4;                        // DWORD 0
         u32 STATUS : 4;                          // DWORD 0
         u32 CARGO : 16;                          // DWORD 0
         u32 cra : 25;                            // DWORD 1
         u32 pci_func : 7;                        // DWORD 1
         u32 PA_LOW;                              // DWORD 2
         u32 PA_HIGH;                             // DWORD 3
      } SG_PACK PTC_NEWRESP_D, *PPTC_NEWRESP_D;

      typedef union _PTC_NEWRESP_D_UNION {
         PTC_NEWRESP_D bits;
         u32 dw[4]; // dword union
      } SG_PACK PTC_NEWRESP_D_UNION, *PPTC_NEWRESP_D_UNION;

      SG_C_ASSERT(__sizeof__PTC_NEWRESP_D_UNION, sizeof (PTC_NEWRESP_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_REQ_D {
         union {
            struct { 
               u32 pci_func : 7;                  // DWORD 0
               u32 cra : 25;                      // DWORD 0
               u32 cargo : 16;                    // DWORD 1
               u32 rsvd0 : 1;                     // DWORD 1
               u32 pci_function__7 : 1;           // DWORD 1
               u32 subcacheline : 1;              // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 req_opcode : 3;                // DWORD 1
               u32 drop : 1;                      // DWORD 1
               u32 req_type : 1;                  // DWORD 1
               u32 vl : 2;                        // DWORD 1
               u32 p : 1;                         // DWORD 1
               u32 i : 1;                         // DWORD 1
               u32 empty : 1;                     // DWORD 1
               u32 discard : 1;                   // DWORD 1
               u32 stall : 1;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK UC_REQ_D, *PUC_REQ_D;

      SG_C_ASSERT(__sizeof__UC_REQ_D, sizeof (UC_REQ_D) == 8);

   #else
      typedef struct _UC_REQ_D {
         u32 pci_func : 7;                        // DWORD 0
         u32 cra : 25;                            // DWORD 0
         u32 cargo : 16;                          // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 1
         u32 pci_function__7 : 1;                 // DWORD 1
         u32 subcacheline : 1;                    // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 req_opcode : 3;                      // DWORD 1
         u32 drop : 1;                            // DWORD 1
         u32 req_type : 1;                        // DWORD 1
         u32 vl : 2;                              // DWORD 1
         u32 p : 1;                               // DWORD 1
         u32 i : 1;                               // DWORD 1
         u32 empty : 1;                           // DWORD 1
         u32 discard : 1;                         // DWORD 1
         u32 stall : 1;                           // DWORD 1
      } SG_PACK UC_REQ_D, *PUC_REQ_D;

      typedef union _UC_REQ_D_UNION {
         UC_REQ_D bits;
         u32 dw[2]; // dword union
      } SG_PACK UC_REQ_D_UNION, *PUC_REQ_D_UNION;

      SG_C_ASSERT(__sizeof__UC_REQ_D_UNION, sizeof (UC_REQ_D_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_REQ_D {
         union {
            struct { 
               u32 cra : 25;                      // DWORD 0
               u32 pci_func : 7;                  // DWORD 0
               u32 stall : 1;                     // DWORD 1
               u32 discard : 1;                   // DWORD 1
               u32 empty : 1;                     // DWORD 1
               u32 i : 1;                         // DWORD 1
               u32 p : 1;                         // DWORD 1
               u32 vl : 2;                        // DWORD 1
               u32 req_type : 1;                  // DWORD 1
               u32 drop : 1;                      // DWORD 1
               u32 req_opcode : 3;                // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 subcacheline : 1;              // DWORD 1
               u32 pci_function__7 : 1;           // DWORD 1
               u32 rsvd0 : 1;                     // DWORD 1
               u32 cargo : 16;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK UC_REQ_D, *PUC_REQ_D;

      SG_C_ASSERT(__sizeof__UC_REQ_D, sizeof (UC_REQ_D) == 8);

   #else
      typedef struct _UC_REQ_D {
         u32 cra : 25;                            // DWORD 0
         u32 pci_func : 7;                        // DWORD 0
         u32 stall : 1;                           // DWORD 1
         u32 discard : 1;                         // DWORD 1
         u32 empty : 1;                           // DWORD 1
         u32 i : 1;                               // DWORD 1
         u32 p : 1;                               // DWORD 1
         u32 vl : 2;                              // DWORD 1
         u32 req_type : 1;                        // DWORD 1
         u32 drop : 1;                            // DWORD 1
         u32 req_opcode : 3;                      // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 subcacheline : 1;                    // DWORD 1
         u32 pci_function__7 : 1;                 // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 1
         u32 cargo : 16;                          // DWORD 1
      } SG_PACK UC_REQ_D, *PUC_REQ_D;

      typedef union _UC_REQ_D_UNION {
         UC_REQ_D bits;
         u32 dw[2]; // dword union
      } SG_PACK UC_REQ_D_UNION, *PUC_REQ_D_UNION;

      SG_C_ASSERT(__sizeof__UC_REQ_D_UNION, sizeof (UC_REQ_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the UC Request descriptor for range flush
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_FLUSH_REQ_D {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 cra : 18;                      // DWORD 0
               u32 cra_enable_lo : 10;            // DWORD 0
               u32 cargo : 8;                     // DWORD 1
               u32 cra_enable_hi : 8;             // DWORD 1
               u32 rsvd1 : 2;                     // DWORD 1
               u32 subcacheline : 1;              // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 req_opcode : 3;                // DWORD 1
               u32 drop : 1;                      // DWORD 1
               u32 req_type : 1;                  // DWORD 1
               u32 vl : 2;                        // DWORD 1
               u32 p : 1;                         // DWORD 1
               u32 i : 1;                         // DWORD 1
               u32 empty : 1;                     // DWORD 1
               u32 discard : 1;                   // DWORD 1
               u32 stall : 1;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK UC_FLUSH_REQ_D, *PUC_FLUSH_REQ_D;

      SG_C_ASSERT(__sizeof__UC_FLUSH_REQ_D, sizeof (UC_FLUSH_REQ_D) == 8);

   #else
      typedef struct _UC_FLUSH_REQ_D {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 cra : 18;                            // DWORD 0
         u32 cra_enable_lo : 10;                  // DWORD 0
         u32 cargo : 8;                           // DWORD 1
         u32 cra_enable_hi : 8;                   // DWORD 1
         u32 rsvd1 : 2;                           // DWORD 1
         u32 subcacheline : 1;                    // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 req_opcode : 3;                      // DWORD 1
         u32 drop : 1;                            // DWORD 1
         u32 req_type : 1;                        // DWORD 1
         u32 vl : 2;                              // DWORD 1
         u32 p : 1;                               // DWORD 1
         u32 i : 1;                               // DWORD 1
         u32 empty : 1;                           // DWORD 1
         u32 discard : 1;                         // DWORD 1
         u32 stall : 1;                           // DWORD 1
      } SG_PACK UC_FLUSH_REQ_D, *PUC_FLUSH_REQ_D;

      typedef union _UC_FLUSH_REQ_D_UNION {
         UC_FLUSH_REQ_D bits;
         u32 dw[2]; // dword union
      } SG_PACK UC_FLUSH_REQ_D_UNION, *PUC_FLUSH_REQ_D_UNION;

      SG_C_ASSERT(__sizeof__UC_FLUSH_REQ_D_UNION, sizeof (UC_FLUSH_REQ_D_UNION) == 8);
   #endif


#else
   // This is the UC Request descriptor for range flush
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_FLUSH_REQ_D {
         union {
            struct { 
               u32 cra_enable_lo : 10;            // DWORD 0
               u32 cra : 18;                      // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 stall : 1;                     // DWORD 1
               u32 discard : 1;                   // DWORD 1
               u32 empty : 1;                     // DWORD 1
               u32 i : 1;                         // DWORD 1
               u32 p : 1;                         // DWORD 1
               u32 vl : 2;                        // DWORD 1
               u32 req_type : 1;                  // DWORD 1
               u32 drop : 1;                      // DWORD 1
               u32 req_opcode : 3;                // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 subcacheline : 1;              // DWORD 1
               u32 rsvd1 : 2;                     // DWORD 1
               u32 cra_enable_hi : 8;             // DWORD 1
               u32 cargo : 8;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK UC_FLUSH_REQ_D, *PUC_FLUSH_REQ_D;

      SG_C_ASSERT(__sizeof__UC_FLUSH_REQ_D, sizeof (UC_FLUSH_REQ_D) == 8);

   #else
      typedef struct _UC_FLUSH_REQ_D {
         u32 cra_enable_lo : 10;                  // DWORD 0
         u32 cra : 18;                            // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 stall : 1;                           // DWORD 1
         u32 discard : 1;                         // DWORD 1
         u32 empty : 1;                           // DWORD 1
         u32 i : 1;                               // DWORD 1
         u32 p : 1;                               // DWORD 1
         u32 vl : 2;                              // DWORD 1
         u32 req_type : 1;                        // DWORD 1
         u32 drop : 1;                            // DWORD 1
         u32 req_opcode : 3;                      // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 subcacheline : 1;                    // DWORD 1
         u32 rsvd1 : 2;                           // DWORD 1
         u32 cra_enable_hi : 8;                   // DWORD 1
         u32 cargo : 8;                           // DWORD 1
      } SG_PACK UC_FLUSH_REQ_D, *PUC_FLUSH_REQ_D;

      typedef union _UC_FLUSH_REQ_D_UNION {
         UC_FLUSH_REQ_D bits;
         u32 dw[2]; // dword union
      } SG_PACK UC_FLUSH_REQ_D_UNION, *PUC_FLUSH_REQ_D_UNION;

      SG_C_ASSERT(__sizeof__UC_FLUSH_REQ_D_UNION, sizeof (UC_FLUSH_REQ_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RESP_D {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 ctx_address : 16;              // DWORD 0
               u32 cargo : 16;                    // DWORD 1
               u32 status : 4;                    // DWORD 1
               u32 rsvd2 : 5;                     // DWORD 1
               u32 vl : 2;                        // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 i : 1;                         // DWORD 1
               u32 empty : 1;                     // DWORD 1
               u32 discard : 1;                   // DWORD 1
               u32 stall : 1;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK UC_RESP_D, *PUC_RESP_D;

      SG_C_ASSERT(__sizeof__UC_RESP_D, sizeof (UC_RESP_D) == 8);

   #else
      typedef struct _UC_RESP_D {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 ctx_address : 16;                    // DWORD 0
         u32 cargo : 16;                          // DWORD 1
         u32 status : 4;                          // DWORD 1
         u32 rsvd2 : 5;                           // DWORD 1
         u32 vl : 2;                              // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 i : 1;                               // DWORD 1
         u32 empty : 1;                           // DWORD 1
         u32 discard : 1;                         // DWORD 1
         u32 stall : 1;                           // DWORD 1
      } SG_PACK UC_RESP_D, *PUC_RESP_D;

      typedef union _UC_RESP_D_UNION {
         UC_RESP_D bits;
         u32 dw[2]; // dword union
      } SG_PACK UC_RESP_D_UNION, *PUC_RESP_D_UNION;

      SG_C_ASSERT(__sizeof__UC_RESP_D_UNION, sizeof (UC_RESP_D_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RESP_D {
         union {
            struct { 
               u32 ctx_address : 16;              // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 stall : 1;                     // DWORD 1
               u32 discard : 1;                   // DWORD 1
               u32 empty : 1;                     // DWORD 1
               u32 i : 1;                         // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 vl : 2;                        // DWORD 1
               u32 rsvd2 : 5;                     // DWORD 1
               u32 status : 4;                    // DWORD 1
               u32 cargo : 16;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK UC_RESP_D, *PUC_RESP_D;

      SG_C_ASSERT(__sizeof__UC_RESP_D, sizeof (UC_RESP_D) == 8);

   #else
      typedef struct _UC_RESP_D {
         u32 ctx_address : 16;                    // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 stall : 1;                           // DWORD 1
         u32 discard : 1;                         // DWORD 1
         u32 empty : 1;                           // DWORD 1
         u32 i : 1;                               // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 vl : 2;                              // DWORD 1
         u32 rsvd2 : 5;                           // DWORD 1
         u32 status : 4;                          // DWORD 1
         u32 cargo : 16;                          // DWORD 1
      } SG_PACK UC_RESP_D, *PUC_RESP_D;

      typedef union _UC_RESP_D_UNION {
         UC_RESP_D bits;
         u32 dw[2]; // dword union
      } SG_PACK UC_RESP_D_UNION, *PUC_RESP_D_UNION;

      SG_C_ASSERT(__sizeof__UC_RESP_D_UNION, sizeof (UC_RESP_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RESP2_D {
         union {
            struct { 
               u32 cargo : 16;                    // DWORD 0
               u32 status : 4;                    // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 i : 1;                         // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RESP2_D, *PUC_RESP2_D;

      SG_C_ASSERT(__sizeof__UC_RESP2_D, sizeof (UC_RESP2_D) == 4);

   #else
      typedef struct _UC_RESP2_D {
         u32 cargo : 16;                          // DWORD 0
         u32 status : 4;                          // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 i : 1;                               // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
      } SG_PACK UC_RESP2_D, *PUC_RESP2_D;

      typedef union _UC_RESP2_D_UNION {
         UC_RESP2_D bits;
         u32 dw; // dword union
      } SG_PACK UC_RESP2_D_UNION, *PUC_RESP2_D_UNION;

      SG_C_ASSERT(__sizeof__UC_RESP2_D_UNION, sizeof (UC_RESP2_D_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RESP2_D {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 i : 1;                         // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 status : 4;                    // DWORD 0
               u32 cargo : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RESP2_D, *PUC_RESP2_D;

      SG_C_ASSERT(__sizeof__UC_RESP2_D, sizeof (UC_RESP2_D) == 4);

   #else
      typedef struct _UC_RESP2_D {
         u32 stall : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 i : 1;                               // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 status : 4;                          // DWORD 0
         u32 cargo : 16;                          // DWORD 0
      } SG_PACK UC_RESP2_D, *PUC_RESP2_D;

      typedef union _UC_RESP2_D_UNION {
         UC_RESP2_D bits;
         u32 dw; // dword union
      } SG_PACK UC_RESP2_D_UNION, *PUC_RESP2_D_UNION;

      SG_C_ASSERT(__sizeof__UC_RESP2_D_UNION, sizeof (UC_RESP2_D_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Response descriptor, returned from UC to CEV for ALL Completion and Event push
   // requests (solicited or otherwise)
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CEV_RESP_D {
         union {
            struct { 
               u32 frcint : 1;                    // DWORD 0
               u32 dbg_tag : 5;                   // DWORD 0
               u32 dbuf_id : 10;                  // DWORD 0
               u32 status : 4;                    // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 i : 1;                         // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CEV_RESP_D, *PUC_CEV_RESP_D;

      SG_C_ASSERT(__sizeof__UC_CEV_RESP_D, sizeof (UC_CEV_RESP_D) == 4);

   #else
      typedef struct _UC_CEV_RESP_D {
         u32 frcint : 1;                          // DWORD 0
         u32 dbg_tag : 5;                         // DWORD 0
         u32 dbuf_id : 10;                        // DWORD 0
         u32 status : 4;                          // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 i : 1;                               // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
      } SG_PACK UC_CEV_RESP_D, *PUC_CEV_RESP_D;

      typedef union _UC_CEV_RESP_D_UNION {
         UC_CEV_RESP_D bits;
         u32 dw; // dword union
      } SG_PACK UC_CEV_RESP_D_UNION, *PUC_CEV_RESP_D_UNION;

      SG_C_ASSERT(__sizeof__UC_CEV_RESP_D_UNION, sizeof (UC_CEV_RESP_D_UNION) == 4);
   #endif


#else
   // Response descriptor, returned from UC to CEV for ALL Completion and Event push
   // requests (solicited or otherwise)
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CEV_RESP_D {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 i : 1;                         // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 status : 4;                    // DWORD 0
               u32 dbuf_id : 10;                  // DWORD 0
               u32 dbg_tag : 5;                   // DWORD 0
               u32 frcint : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CEV_RESP_D, *PUC_CEV_RESP_D;

      SG_C_ASSERT(__sizeof__UC_CEV_RESP_D, sizeof (UC_CEV_RESP_D) == 4);

   #else
      typedef struct _UC_CEV_RESP_D {
         u32 stall : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 i : 1;                               // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 status : 4;                          // DWORD 0
         u32 dbuf_id : 10;                        // DWORD 0
         u32 dbg_tag : 5;                         // DWORD 0
         u32 frcint : 1;                          // DWORD 0
      } SG_PACK UC_CEV_RESP_D, *PUC_CEV_RESP_D;

      typedef union _UC_CEV_RESP_D_UNION {
         UC_CEV_RESP_D bits;
         u32 dw; // dword union
      } SG_PACK UC_CEV_RESP_D_UNION, *PUC_CEV_RESP_D_UNION;

      SG_C_ASSERT(__sizeof__UC_CEV_RESP_D_UNION, sizeof (UC_CEV_RESP_D_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Completion/Event Request Descriptor. Sent to the central CEV hardware block by its
   // several clients, requesting CEV to post a Completion or Event to the local host
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_PQ_D {
         union {
            struct { 
               u32 evt_bit : 1;                   // DWORD 0
               u32 solicited_evt : 1;             // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 qid : 10;                      // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 desc_id : 10;                  // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_PQ_D, *PCEV_PQ_D;

      SG_C_ASSERT(__sizeof__CEV_PQ_D, sizeof (CEV_PQ_D) == 4);

   #else
      typedef struct _CEV_PQ_D {
         u32 evt_bit : 1;                         // DWORD 0
         u32 solicited_evt : 1;                   // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 qid : 10;                            // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 desc_id : 10;                        // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
      } SG_PACK CEV_PQ_D, *PCEV_PQ_D;

      typedef union _CEV_PQ_D_UNION {
         CEV_PQ_D bits;
         u32 dw; // dword union
      } SG_PACK CEV_PQ_D_UNION, *PCEV_PQ_D_UNION;

      SG_C_ASSERT(__sizeof__CEV_PQ_D_UNION, sizeof (CEV_PQ_D_UNION) == 4);
   #endif


#else
   // Completion/Event Request Descriptor. Sent to the central CEV hardware block by its
   // several clients, requesting CEV to post a Completion or Event to the local host
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_PQ_D {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 desc_id : 10;                  // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 qid : 10;                      // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 solicited_evt : 1;             // DWORD 0
               u32 evt_bit : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_PQ_D, *PCEV_PQ_D;

      SG_C_ASSERT(__sizeof__CEV_PQ_D, sizeof (CEV_PQ_D) == 4);

   #else
      typedef struct _CEV_PQ_D {
         u32 stall : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 desc_id : 10;                        // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 qid : 10;                            // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 solicited_evt : 1;                   // DWORD 0
         u32 evt_bit : 1;                         // DWORD 0
      } SG_PACK CEV_PQ_D, *PCEV_PQ_D;

      typedef union _CEV_PQ_D_UNION {
         CEV_PQ_D bits;
         u32 dw; // dword union
      } SG_PACK CEV_PQ_D_UNION, *PCEV_PQ_D_UNION;

      SG_C_ASSERT(__sizeof__CEV_PQ_D_UNION, sizeof (CEV_PQ_D_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Inter-Processor Communication Header. This is the header that acompanies all ICD
   // messages. Note that there may not be any data that follows the header for some
   // messages. In those cases the length field in the header is the size of just the
   // header. Otherwise, the length field is the size of the entire IPC message (including
   // the header). 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_HEADER_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 cid : 16;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 sub_code : 16;                 // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_HEADER_D, *PIPC_HEADER_D;

      SG_C_ASSERT(__sizeof__IPC_HEADER_D, sizeof (IPC_HEADER_D) == 8);

   #else
      typedef struct _IPC_HEADER_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 cid : 16;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 sub_code : 16;                       // DWORD 1
      } SG_PACK IPC_HEADER_D, *PIPC_HEADER_D;

      typedef union _IPC_HEADER_D_UNION {
         IPC_HEADER_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_HEADER_D_UNION, *PIPC_HEADER_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_HEADER_D_UNION, sizeof (IPC_HEADER_D_UNION) == 8);
   #endif


#else
   // Inter-Processor Communication Header. This is the header that acompanies all ICD
   // messages. Note that there may not be any data that follows the header for some
   // messages. In those cases the length field in the header is the size of just the
   // header. Otherwise, the length field is the size of the entire IPC message (including
   // the header). 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_HEADER_D {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 sub_code : 16;                 // DWORD 1
               u32 code : 16;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_HEADER_D, *PIPC_HEADER_D;

      SG_C_ASSERT(__sizeof__IPC_HEADER_D, sizeof (IPC_HEADER_D) == 8);

   #else
      typedef struct _IPC_HEADER_D {
         u32 cid : 16;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 sub_code : 16;                       // DWORD 1
         u32 code : 16;                           // DWORD 1
      } SG_PACK IPC_HEADER_D, *PIPC_HEADER_D;

      typedef union _IPC_HEADER_D_UNION {
         IPC_HEADER_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_HEADER_D_UNION, *PIPC_HEADER_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_HEADER_D_UNION, sizeof (IPC_HEADER_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_TIMEOUT_D {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd2 : 2;                     // DWORD 1
               u32 TQ : 2;                        // DWORD 1
               u32 rsvd1 : 3;                     // DWORD 1
               u32 DUMMYLOAD : 1;                 // DWORD 1
               u32 PERSIST : 1;                   // DWORD 1
               u32 KAINTERVAL : 1;                // DWORD 1
               u32 TXIDLE : 1;                    // DWORD 1
               u32 REXMT : 1;                     // DWORD 1
               u32 KEEPALIVE : 1;                 // DWORD 1
               u32 FINWAIT2 : 1;                  // DWORD 1
               u32 DELACK : 1;                    // DWORD 1
               u32 PUSH : 1;                      // DWORD 1
               u32 cid : 16;                      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TCP_TIMEOUT_D, *PTCP_TIMEOUT_D;

      SG_C_ASSERT(__sizeof__TCP_TIMEOUT_D, sizeof (TCP_TIMEOUT_D) == 8);

   #else
      typedef struct _TCP_TIMEOUT_D {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd2 : 2;                           // DWORD 1
         u32 TQ : 2;                              // DWORD 1
         u32 rsvd1 : 3;                           // DWORD 1
         u32 DUMMYLOAD : 1;                       // DWORD 1
         u32 PERSIST : 1;                         // DWORD 1
         u32 KAINTERVAL : 1;                      // DWORD 1
         u32 TXIDLE : 1;                          // DWORD 1
         u32 REXMT : 1;                           // DWORD 1
         u32 KEEPALIVE : 1;                       // DWORD 1
         u32 FINWAIT2 : 1;                        // DWORD 1
         u32 DELACK : 1;                          // DWORD 1
         u32 PUSH : 1;                            // DWORD 1
         u32 cid : 16;                            // DWORD 1
      } SG_PACK TCP_TIMEOUT_D, *PTCP_TIMEOUT_D;

      typedef union _TCP_TIMEOUT_D_UNION {
         TCP_TIMEOUT_D bits;
         u32 dw[2]; // dword union
      } SG_PACK TCP_TIMEOUT_D_UNION, *PTCP_TIMEOUT_D_UNION;

      SG_C_ASSERT(__sizeof__TCP_TIMEOUT_D_UNION, sizeof (TCP_TIMEOUT_D_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_TIMEOUT_D {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 cid : 16;                      // DWORD 1
               u32 PUSH : 1;                      // DWORD 1
               u32 DELACK : 1;                    // DWORD 1
               u32 FINWAIT2 : 1;                  // DWORD 1
               u32 KEEPALIVE : 1;                 // DWORD 1
               u32 REXMT : 1;                     // DWORD 1
               u32 TXIDLE : 1;                    // DWORD 1
               u32 KAINTERVAL : 1;                // DWORD 1
               u32 PERSIST : 1;                   // DWORD 1
               u32 DUMMYLOAD : 1;                 // DWORD 1
               u32 rsvd1 : 3;                     // DWORD 1
               u32 TQ : 2;                        // DWORD 1
               u32 rsvd2 : 2;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TCP_TIMEOUT_D, *PTCP_TIMEOUT_D;

      SG_C_ASSERT(__sizeof__TCP_TIMEOUT_D, sizeof (TCP_TIMEOUT_D) == 8);

   #else
      typedef struct _TCP_TIMEOUT_D {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 cid : 16;                            // DWORD 1
         u32 PUSH : 1;                            // DWORD 1
         u32 DELACK : 1;                          // DWORD 1
         u32 FINWAIT2 : 1;                        // DWORD 1
         u32 KEEPALIVE : 1;                       // DWORD 1
         u32 REXMT : 1;                           // DWORD 1
         u32 TXIDLE : 1;                          // DWORD 1
         u32 KAINTERVAL : 1;                      // DWORD 1
         u32 PERSIST : 1;                         // DWORD 1
         u32 DUMMYLOAD : 1;                       // DWORD 1
         u32 rsvd1 : 3;                           // DWORD 1
         u32 TQ : 2;                              // DWORD 1
         u32 rsvd2 : 2;                           // DWORD 1
      } SG_PACK TCP_TIMEOUT_D, *PTCP_TIMEOUT_D;

      typedef union _TCP_TIMEOUT_D_UNION {
         TCP_TIMEOUT_D bits;
         u32 dw[2]; // dword union
      } SG_PACK TCP_TIMEOUT_D_UNION, *PTCP_TIMEOUT_D_UNION;

      SG_C_ASSERT(__sizeof__TCP_TIMEOUT_D_UNION, sizeof (TCP_TIMEOUT_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Format of descriptor for self initiate requests
   #if defined(SG_BMAP_UNION)
      typedef struct _SIR_DESC_D {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 task_id : 4;                   // DWORD 1
               u32 queue_id : 4;                  // DWORD 1
               u32 flag_id : 8;                   // DWORD 1
               u32 cid : 16;                      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SIR_DESC_D, *PSIR_DESC_D;

      SG_C_ASSERT(__sizeof__SIR_DESC_D, sizeof (SIR_DESC_D) == 8);

   #else
      typedef struct _SIR_DESC_D {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 task_id : 4;                         // DWORD 1
         u32 queue_id : 4;                        // DWORD 1
         u32 flag_id : 8;                         // DWORD 1
         u32 cid : 16;                            // DWORD 1
      } SG_PACK SIR_DESC_D, *PSIR_DESC_D;

      typedef union _SIR_DESC_D_UNION {
         SIR_DESC_D bits;
         u32 dw[2]; // dword union
      } SG_PACK SIR_DESC_D_UNION, *PSIR_DESC_D_UNION;

      SG_C_ASSERT(__sizeof__SIR_DESC_D_UNION, sizeof (SIR_DESC_D_UNION) == 8);
   #endif


#else
   // Format of descriptor for self initiate requests
   #if defined(SG_BMAP_UNION)
      typedef struct _SIR_DESC_D {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 cid : 16;                      // DWORD 1
               u32 flag_id : 8;                   // DWORD 1
               u32 queue_id : 4;                  // DWORD 1
               u32 task_id : 4;                   // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SIR_DESC_D, *PSIR_DESC_D;

      SG_C_ASSERT(__sizeof__SIR_DESC_D, sizeof (SIR_DESC_D) == 8);

   #else
      typedef struct _SIR_DESC_D {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 cid : 16;                            // DWORD 1
         u32 flag_id : 8;                         // DWORD 1
         u32 queue_id : 4;                        // DWORD 1
         u32 task_id : 4;                         // DWORD 1
      } SG_PACK SIR_DESC_D, *PSIR_DESC_D;

      typedef union _SIR_DESC_D_UNION {
         SIR_DESC_D bits;
         u32 dw[2]; // dword union
      } SG_PACK SIR_DESC_D_UNION, *PSIR_DESC_D_UNION;

      SG_C_ASSERT(__sizeof__SIR_DESC_D_UNION, sizeof (SIR_DESC_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // One of the input queues that act as a stimulus to the TXULP Processors is the
   // Connection Scheduler. This is a round robin scheduler that round robins among upto
   // 512 active entries. Each entry has a grant bit that is used by the scheduler to
   // determine if the entry can be a candidate for scheduling. Any given entry is a
   // candidate for scheduling if its Grant bit is reset and one of chip request, driver
   // request or retransmit bit is set. The GRANT_CTRL_DESC is available to the TXULP
   // Processors and the TPOST so that they can enable entries processed by the Connection
   // Scheduler in order to serialize the process of stimulating the TXULP Processors. 
   // The bits in the GRANT_CTRL_DESC behave differently from the RxULPs as explained
   // below.  When the Chip Driver bit is set in either RXULP0,1 or 2, this will send a
   // horseshoe request to the corresponding TXULP (0,1, or 2) and set the Chip Request
   // pending on the transmit side.  When the retransmit bit is set in either RXULP0,1 or
   // 2, this is used for the iSCSI OOO path. In typical configurations, TXULP2 will be
   // setup to handle the iSCSI OOO buffers that have been reassembled into raw ethernet
   // style frames for retransmission through the chip and looped back at the ethernet
   // side back into the receive path. In reality, RXULP0, 1 and 2 send their iscsi_postc
   // signals to all three TXULPs, but local CSR registers effectively discard the
   // iscsi_post from TXULP0 and 1. 
   #if defined(SG_BMAP_UNION)
      typedef struct _GRANT_CTRL_DESC {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
               u32 chute : 2;                     // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 p1cred : 1;                    // DWORD 0
               u32 p0cred : 1;                    // DWORD 0
               u32 chipRequest : 1;               // DWORD 0
               u32 driverRequest : 1;             // DWORD 0
               u32 retransmit : 1;                // DWORD 0
               u32 g : 1;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GRANT_CTRL_DESC, *PGRANT_CTRL_DESC;

      SG_C_ASSERT(__sizeof__GRANT_CTRL_DESC, sizeof (GRANT_CTRL_DESC) == 4);

   #else
      typedef struct _GRANT_CTRL_DESC {
         u32 cid : 16;                            // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
         u32 chute : 2;                           // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 p1cred : 1;                          // DWORD 0
         u32 p0cred : 1;                          // DWORD 0
         u32 chipRequest : 1;                     // DWORD 0
         u32 driverRequest : 1;                   // DWORD 0
         u32 retransmit : 1;                      // DWORD 0
         u32 g : 1;                               // DWORD 0
      } SG_PACK GRANT_CTRL_DESC, *PGRANT_CTRL_DESC;

      typedef union _GRANT_CTRL_DESC_UNION {
         GRANT_CTRL_DESC bits;
         u32 dw; // dword union
      } SG_PACK GRANT_CTRL_DESC_UNION, *PGRANT_CTRL_DESC_UNION;

      SG_C_ASSERT(__sizeof__GRANT_CTRL_DESC_UNION, sizeof (GRANT_CTRL_DESC_UNION) == 4);
   #endif


#else
   // One of the input queues that act as a stimulus to the TXULP Processors is the
   // Connection Scheduler. This is a round robin scheduler that round robins among upto
   // 512 active entries. Each entry has a grant bit that is used by the scheduler to
   // determine if the entry can be a candidate for scheduling. Any given entry is a
   // candidate for scheduling if its Grant bit is reset and one of chip request, driver
   // request or retransmit bit is set. The GRANT_CTRL_DESC is available to the TXULP
   // Processors and the TPOST so that they can enable entries processed by the Connection
   // Scheduler in order to serialize the process of stimulating the TXULP Processors. 
   // The bits in the GRANT_CTRL_DESC behave differently from the RxULPs as explained
   // below.  When the Chip Driver bit is set in either RXULP0,1 or 2, this will send a
   // horseshoe request to the corresponding TXULP (0,1, or 2) and set the Chip Request
   // pending on the transmit side.  When the retransmit bit is set in either RXULP0,1 or
   // 2, this is used for the iSCSI OOO path. In typical configurations, TXULP2 will be
   // setup to handle the iSCSI OOO buffers that have been reassembled into raw ethernet
   // style frames for retransmission through the chip and looped back at the ethernet
   // side back into the receive path. In reality, RXULP0, 1 and 2 send their iscsi_postc
   // signals to all three TXULPs, but local CSR registers effectively discard the
   // iscsi_post from TXULP0 and 1. 
   #if defined(SG_BMAP_UNION)
      typedef struct _GRANT_CTRL_DESC {
         union {
            struct { 
               u32 g : 1;                         // DWORD 0
               u32 retransmit : 1;                // DWORD 0
               u32 driverRequest : 1;             // DWORD 0
               u32 chipRequest : 1;               // DWORD 0
               u32 p0cred : 1;                    // DWORD 0
               u32 p1cred : 1;                    // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 chute : 2;                     // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
               u32 cid : 16;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GRANT_CTRL_DESC, *PGRANT_CTRL_DESC;

      SG_C_ASSERT(__sizeof__GRANT_CTRL_DESC, sizeof (GRANT_CTRL_DESC) == 4);

   #else
      typedef struct _GRANT_CTRL_DESC {
         u32 g : 1;                               // DWORD 0
         u32 retransmit : 1;                      // DWORD 0
         u32 driverRequest : 1;                   // DWORD 0
         u32 chipRequest : 1;                     // DWORD 0
         u32 p0cred : 1;                          // DWORD 0
         u32 p1cred : 1;                          // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 chute : 2;                           // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
         u32 cid : 16;                            // DWORD 0
      } SG_PACK GRANT_CTRL_DESC, *PGRANT_CTRL_DESC;

      typedef union _GRANT_CTRL_DESC_UNION {
         GRANT_CTRL_DESC bits;
         u32 dw; // dword union
      } SG_PACK GRANT_CTRL_DESC_UNION, *PGRANT_CTRL_DESC_UNION;

      SG_C_ASSERT(__sizeof__GRANT_CTRL_DESC_UNION, sizeof (GRANT_CTRL_DESC_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Format of the context address for memory writeback 
   #if defined(SG_BMAP_UNION)
      typedef struct _CTXT_ADDR_DESC {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTXT_ADDR_DESC, *PCTXT_ADDR_DESC;

      SG_C_ASSERT(__sizeof__CTXT_ADDR_DESC, sizeof (CTXT_ADDR_DESC) == 4);

   #else
      typedef struct _CTXT_ADDR_DESC {
         u32 addr;                                // DWORD 0
      } SG_PACK CTXT_ADDR_DESC, *PCTXT_ADDR_DESC;

      typedef union _CTXT_ADDR_DESC_UNION {
         CTXT_ADDR_DESC bits;
         u32 dw; // dword union
      } SG_PACK CTXT_ADDR_DESC_UNION, *PCTXT_ADDR_DESC_UNION;

      SG_C_ASSERT(__sizeof__CTXT_ADDR_DESC_UNION, sizeof (CTXT_ADDR_DESC_UNION) == 4);
   #endif


#else
   // Format of the context address for memory writeback 
   #if defined(SG_BMAP_UNION)
      typedef struct _CTXT_ADDR_DESC {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTXT_ADDR_DESC, *PCTXT_ADDR_DESC;

      SG_C_ASSERT(__sizeof__CTXT_ADDR_DESC, sizeof (CTXT_ADDR_DESC) == 4);

   #else
      typedef struct _CTXT_ADDR_DESC {
         u32 addr;                                // DWORD 0
      } SG_PACK CTXT_ADDR_DESC, *PCTXT_ADDR_DESC;

      typedef union _CTXT_ADDR_DESC_UNION {
         CTXT_ADDR_DESC bits;
         u32 dw; // dword union
      } SG_PACK CTXT_ADDR_DESC_UNION, *PCTXT_ADDR_DESC_UNION;

      SG_C_ASSERT(__sizeof__CTXT_ADDR_DESC_UNION, sizeof (CTXT_ADDR_DESC_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Format of the txpb address for memory writeback 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_ADDR_DESC {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 index : 8;                     // DWORD 0
               u32 offset : 14;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_ADDR_DESC, *PTXPB_ADDR_DESC;

      SG_C_ASSERT(__sizeof__TXPB_ADDR_DESC, sizeof (TXPB_ADDR_DESC) == 4);

   #else
      typedef struct _TXPB_ADDR_DESC {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 index : 8;                           // DWORD 0
         u32 offset : 14;                         // DWORD 0
      } SG_PACK TXPB_ADDR_DESC, *PTXPB_ADDR_DESC;

      typedef union _TXPB_ADDR_DESC_UNION {
         TXPB_ADDR_DESC bits;
         u32 dw; // dword union
      } SG_PACK TXPB_ADDR_DESC_UNION, *PTXPB_ADDR_DESC_UNION;

      SG_C_ASSERT(__sizeof__TXPB_ADDR_DESC_UNION, sizeof (TXPB_ADDR_DESC_UNION) == 4);
   #endif


#else
   // Format of the txpb address for memory writeback 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_ADDR_DESC {
         union {
            struct { 
               u32 offset : 14;                   // DWORD 0
               u32 index : 8;                     // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_ADDR_DESC, *PTXPB_ADDR_DESC;

      SG_C_ASSERT(__sizeof__TXPB_ADDR_DESC, sizeof (TXPB_ADDR_DESC) == 4);

   #else
      typedef struct _TXPB_ADDR_DESC {
         u32 offset : 14;                         // DWORD 0
         u32 index : 8;                           // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK TXPB_ADDR_DESC, *PTXPB_ADDR_DESC;

      typedef union _TXPB_ADDR_DESC_UNION {
         TXPB_ADDR_DESC bits;
         u32 dw; // dword union
      } SG_PACK TXPB_ADDR_DESC_UNION, *PTXPB_ADDR_DESC_UNION;

      SG_C_ASSERT(__sizeof__TXPB_ADDR_DESC_UNION, sizeof (TXPB_ADDR_DESC_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Buffer Descriptor Format 
   #if defined(SG_BMAP_UNION)
      typedef struct _BUFFER_DESC {
         union {
            struct { 
               u32 frag_pa_hi;                    // DWORD 0
               u32 frag_pa_lo;                    // DWORD 1
               u32 rsvd0[1];                      // DWORDS 2 to 2
               u32 ddr : 1;                       // DWORD 3
               u32 rsvd1 : 14;                    // DWORD 3
               u32 frag_len : 17;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BUFFER_DESC, *PBUFFER_DESC;

      SG_C_ASSERT(__sizeof__BUFFER_DESC, sizeof (BUFFER_DESC) == 16);

   #else
      typedef struct _BUFFER_DESC {
         u32 frag_pa_hi;                          // DWORD 0
         u32 frag_pa_lo;                          // DWORD 1
         u32 rsvd0[1];                            // DWORDS 2 to 2
         u32 ddr : 1;                             // DWORD 3
         u32 rsvd1 : 14;                          // DWORD 3
         u32 frag_len : 17;                       // DWORD 3
      } SG_PACK BUFFER_DESC, *PBUFFER_DESC;

      typedef union _BUFFER_DESC_UNION {
         BUFFER_DESC bits;
         u32 dw[4]; // dword union
      } SG_PACK BUFFER_DESC_UNION, *PBUFFER_DESC_UNION;

      SG_C_ASSERT(__sizeof__BUFFER_DESC_UNION, sizeof (BUFFER_DESC_UNION) == 16);
   #endif


#else
   // Buffer Descriptor Format 
   #if defined(SG_BMAP_UNION)
      typedef struct _BUFFER_DESC {
         union {
            struct { 
               u32 frag_pa_hi;                    // DWORD 0
               u32 frag_pa_lo;                    // DWORD 1
               u32 rsvd0[1];                      // DWORDS 2 to 2
               u32 frag_len : 17;                 // DWORD 3
               u32 rsvd1 : 14;                    // DWORD 3
               u32 ddr : 1;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BUFFER_DESC, *PBUFFER_DESC;

      SG_C_ASSERT(__sizeof__BUFFER_DESC, sizeof (BUFFER_DESC) == 16);

   #else
      typedef struct _BUFFER_DESC {
         u32 frag_pa_hi;                          // DWORD 0
         u32 frag_pa_lo;                          // DWORD 1
         u32 rsvd0[1];                            // DWORDS 2 to 2
         u32 frag_len : 17;                       // DWORD 3
         u32 rsvd1 : 14;                          // DWORD 3
         u32 ddr : 1;                             // DWORD 3
      } SG_PACK BUFFER_DESC, *PBUFFER_DESC;

      typedef union _BUFFER_DESC_UNION {
         BUFFER_DESC bits;
         u32 dw[4]; // dword union
      } SG_PACK BUFFER_DESC_UNION, *PBUFFER_DESC_UNION;

      SG_C_ASSERT(__sizeof__BUFFER_DESC_UNION, sizeof (BUFFER_DESC_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_ADDR_DESC {
         union {
            struct { 
               u32 addr_lo;                       // DWORD 0
               u32 addr_hi;                       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_ADDR_DESC, *PTEMPLATE_ADDR_DESC;

      SG_C_ASSERT(__sizeof__TEMPLATE_ADDR_DESC, sizeof (TEMPLATE_ADDR_DESC) == 8);

   #else
      typedef struct _TEMPLATE_ADDR_DESC {
         u32 addr_lo;                             // DWORD 0
         u32 addr_hi;                             // DWORD 1
      } SG_PACK TEMPLATE_ADDR_DESC, *PTEMPLATE_ADDR_DESC;

      typedef union _TEMPLATE_ADDR_DESC_UNION {
         TEMPLATE_ADDR_DESC bits;
         u32 dw[2]; // dword union
      } SG_PACK TEMPLATE_ADDR_DESC_UNION, *PTEMPLATE_ADDR_DESC_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_ADDR_DESC_UNION, sizeof (TEMPLATE_ADDR_DESC_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_ADDR_DESC {
         union {
            struct { 
               u32 addr_lo;                       // DWORD 0
               u32 addr_hi;                       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_ADDR_DESC, *PTEMPLATE_ADDR_DESC;

      SG_C_ASSERT(__sizeof__TEMPLATE_ADDR_DESC, sizeof (TEMPLATE_ADDR_DESC) == 8);

   #else
      typedef struct _TEMPLATE_ADDR_DESC {
         u32 addr_lo;                             // DWORD 0
         u32 addr_hi;                             // DWORD 1
      } SG_PACK TEMPLATE_ADDR_DESC, *PTEMPLATE_ADDR_DESC;

      typedef union _TEMPLATE_ADDR_DESC_UNION {
         TEMPLATE_ADDR_DESC bits;
         u32 dw[2]; // dword union
      } SG_PACK TEMPLATE_ADDR_DESC_UNION, *PTEMPLATE_ADDR_DESC_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_ADDR_DESC_UNION, sizeof (TEMPLATE_ADDR_DESC_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data/Descriptor for TxULP Input Queue from TCP scheduler (RRMSG only); 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCPSCH_RRMSG_DESC {
         union {
            struct { 
               u32 rsvd2 : 7;                     // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 alltcpacks : 1;                // DWORD 0
               u32 notcp : 1;                     // DWORD 0
               u32 chipRequest : 1;               // DWORD 0
               u32 driverRequest : 1;             // DWORD 0
               u32 retransmit : 1;                // DWORD 0
               u32 RRMsg : 1;                     // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 cid : 11;                      // DWORD 0
               u32 grant_len;                     // DWORD 1
               IPC_HEADER_D ipc;
               u32 rsvd3[1];                      // DWORDS 4 to 4
               u32 rsvd4[1];                      // DWORDS 5 to 5
               u32 rsvd5[1];                      // DWORDS 6 to 6
               u32 rsvd6[1];                      // DWORDS 7 to 7
               u32 rsvd7[1];                      // DWORDS 8 to 8
               u32 rsvd8[1];                      // DWORDS 9 to 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK TCPSCH_RRMSG_DESC, *PTCPSCH_RRMSG_DESC;

      SG_C_ASSERT(__sizeof__TCPSCH_RRMSG_DESC, sizeof (TCPSCH_RRMSG_DESC) == 40);

   #else
      typedef struct _TCPSCH_RRMSG_DESC {
         u32 rsvd2 : 7;                           // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 alltcpacks : 1;                      // DWORD 0
         u32 notcp : 1;                           // DWORD 0
         u32 chipRequest : 1;                     // DWORD 0
         u32 driverRequest : 1;                   // DWORD 0
         u32 retransmit : 1;                      // DWORD 0
         u32 RRMsg : 1;                           // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 cid : 11;                            // DWORD 0
         u32 grant_len;                           // DWORD 1
         IPC_HEADER_D ipc;
         u32 rsvd3[1];                            // DWORDS 4 to 4
         u32 rsvd4[1];                            // DWORDS 5 to 5
         u32 rsvd5[1];                            // DWORDS 6 to 6
         u32 rsvd6[1];                            // DWORDS 7 to 7
         u32 rsvd7[1];                            // DWORDS 8 to 8
         u32 rsvd8[1];                            // DWORDS 9 to 9
      } SG_PACK TCPSCH_RRMSG_DESC, *PTCPSCH_RRMSG_DESC;

      typedef union _TCPSCH_RRMSG_DESC_UNION {
         TCPSCH_RRMSG_DESC bits;
         u32 dw[10]; // dword union
      } SG_PACK TCPSCH_RRMSG_DESC_UNION, *PTCPSCH_RRMSG_DESC_UNION;

      SG_C_ASSERT(__sizeof__TCPSCH_RRMSG_DESC_UNION, sizeof (TCPSCH_RRMSG_DESC_UNION) == 40);
   #endif


#else
   // Data/Descriptor for TxULP Input Queue from TCP scheduler (RRMSG only); 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCPSCH_RRMSG_DESC {
         union {
            struct { 
               u32 cid : 11;                      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 RRMsg : 1;                     // DWORD 0
               u32 retransmit : 1;                // DWORD 0
               u32 driverRequest : 1;             // DWORD 0
               u32 chipRequest : 1;               // DWORD 0
               u32 notcp : 1;                     // DWORD 0
               u32 alltcpacks : 1;                // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 rsvd2 : 7;                     // DWORD 0
               u32 grant_len;                     // DWORD 1
               IPC_HEADER_D ipc;
               u32 rsvd3[1];                      // DWORDS 4 to 4
               u32 rsvd4[1];                      // DWORDS 5 to 5
               u32 rsvd5[1];                      // DWORDS 6 to 6
               u32 rsvd6[1];                      // DWORDS 7 to 7
               u32 rsvd7[1];                      // DWORDS 8 to 8
               u32 rsvd8[1];                      // DWORDS 9 to 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK TCPSCH_RRMSG_DESC, *PTCPSCH_RRMSG_DESC;

      SG_C_ASSERT(__sizeof__TCPSCH_RRMSG_DESC, sizeof (TCPSCH_RRMSG_DESC) == 40);

   #else
      typedef struct _TCPSCH_RRMSG_DESC {
         u32 cid : 11;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 RRMsg : 1;                           // DWORD 0
         u32 retransmit : 1;                      // DWORD 0
         u32 driverRequest : 1;                   // DWORD 0
         u32 chipRequest : 1;                     // DWORD 0
         u32 notcp : 1;                           // DWORD 0
         u32 alltcpacks : 1;                      // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 rsvd2 : 7;                           // DWORD 0
         u32 grant_len;                           // DWORD 1
         IPC_HEADER_D ipc;
         u32 rsvd3[1];                            // DWORDS 4 to 4
         u32 rsvd4[1];                            // DWORDS 5 to 5
         u32 rsvd5[1];                            // DWORDS 6 to 6
         u32 rsvd6[1];                            // DWORDS 7 to 7
         u32 rsvd7[1];                            // DWORDS 8 to 8
         u32 rsvd8[1];                            // DWORDS 9 to 9
      } SG_PACK TCPSCH_RRMSG_DESC, *PTCPSCH_RRMSG_DESC;

      typedef union _TCPSCH_RRMSG_DESC_UNION {
         TCPSCH_RRMSG_DESC bits;
         u32 dw[10]; // dword union
      } SG_PACK TCPSCH_RRMSG_DESC_UNION, *PTCPSCH_RRMSG_DESC_UNION;

      SG_C_ASSERT(__sizeof__TCPSCH_RRMSG_DESC_UNION, sizeof (TCPSCH_RRMSG_DESC_UNION) == 40);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TX_D with an embedded IPC_HEADER_D
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TX_D {
         union {
            struct { 
               u32 rsvd1 : 15;                    // DWORD 0
               u32 iq_select : 1;                 // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 func : 8;                      // DWORD 1
               u32 rsvd2 : 3;                     // DWORD 1
               u32 msg_type : 3;                  // DWORD 1
               u32 msg_src : 2;                   // DWORD 1
               u32 cid : 16;                      // DWORD 1
               u32 ipc_dst : 4;                   // DWORD 2
               u32 ipc_src : 4;                   // DWORD 2
               u32 ipc_length : 8;                // DWORD 2
               u32 ipc_cid : 16;                  // DWORD 2
               u32 code : 16;                     // DWORD 3
               u32 sub_code : 16;                 // DWORD 3
               u32 opaque0;                       // DWORD 4
               u32 opaque1;                       // DWORD 5
               u32 sch_credit : 1;                // DWORD 6
               u32 scratchaddr_in_ddr : 1;        // DWORD 6
               u32 rsvd3 : 30;                    // DWORD 6
               u32 rsvd4[1];                      // DWORDS 7 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TX_D, *PIPC_TX_D;

      SG_C_ASSERT(__sizeof__IPC_TX_D, sizeof (IPC_TX_D) == 32);

   #else
      typedef struct _IPC_TX_D {
         u32 rsvd1 : 15;                          // DWORD 0
         u32 iq_select : 1;                       // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 func : 8;                            // DWORD 1
         u32 rsvd2 : 3;                           // DWORD 1
         u32 msg_type : 3;                        // DWORD 1
         u32 msg_src : 2;                         // DWORD 1
         u32 cid : 16;                            // DWORD 1
         u32 ipc_dst : 4;                         // DWORD 2
         u32 ipc_src : 4;                         // DWORD 2
         u32 ipc_length : 8;                      // DWORD 2
         u32 ipc_cid : 16;                        // DWORD 2
         u32 code : 16;                           // DWORD 3
         u32 sub_code : 16;                       // DWORD 3
         u32 opaque0;                             // DWORD 4
         u32 opaque1;                             // DWORD 5
         u32 sch_credit : 1;                      // DWORD 6
         u32 scratchaddr_in_ddr : 1;              // DWORD 6
         u32 rsvd3 : 30;                          // DWORD 6
         u32 rsvd4[1];                            // DWORDS 7 to 7
      } SG_PACK IPC_TX_D, *PIPC_TX_D;

      typedef union _IPC_TX_D_UNION {
         IPC_TX_D bits;
         u32 dw[8]; // dword union
      } SG_PACK IPC_TX_D_UNION, *PIPC_TX_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TX_D_UNION, sizeof (IPC_TX_D_UNION) == 32);
   #endif


#else
   // TX_D with an embedded IPC_HEADER_D
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TX_D {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 iq_select : 1;                 // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
               u32 cid : 16;                      // DWORD 1
               u32 msg_src : 2;                   // DWORD 1
               u32 msg_type : 3;                  // DWORD 1
               u32 rsvd2 : 3;                     // DWORD 1
               u32 func : 8;                      // DWORD 1
               u32 ipc_cid : 16;                  // DWORD 2
               u32 ipc_length : 8;                // DWORD 2
               u32 ipc_src : 4;                   // DWORD 2
               u32 ipc_dst : 4;                   // DWORD 2
               u32 sub_code : 16;                 // DWORD 3
               u32 code : 16;                     // DWORD 3
               u32 opaque0;                       // DWORD 4
               u32 opaque1;                       // DWORD 5
               u32 rsvd3 : 30;                    // DWORD 6
               u32 scratchaddr_in_ddr : 1;        // DWORD 6
               u32 sch_credit : 1;                // DWORD 6
               u32 rsvd4[1];                      // DWORDS 7 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TX_D, *PIPC_TX_D;

      SG_C_ASSERT(__sizeof__IPC_TX_D, sizeof (IPC_TX_D) == 32);

   #else
      typedef struct _IPC_TX_D {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 iq_select : 1;                       // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
         u32 cid : 16;                            // DWORD 1
         u32 msg_src : 2;                         // DWORD 1
         u32 msg_type : 3;                        // DWORD 1
         u32 rsvd2 : 3;                           // DWORD 1
         u32 func : 8;                            // DWORD 1
         u32 ipc_cid : 16;                        // DWORD 2
         u32 ipc_length : 8;                      // DWORD 2
         u32 ipc_src : 4;                         // DWORD 2
         u32 ipc_dst : 4;                         // DWORD 2
         u32 sub_code : 16;                       // DWORD 3
         u32 code : 16;                           // DWORD 3
         u32 opaque0;                             // DWORD 4
         u32 opaque1;                             // DWORD 5
         u32 rsvd3 : 30;                          // DWORD 6
         u32 scratchaddr_in_ddr : 1;              // DWORD 6
         u32 sch_credit : 1;                      // DWORD 6
         u32 rsvd4[1];                            // DWORDS 7 to 7
      } SG_PACK IPC_TX_D, *PIPC_TX_D;

      typedef union _IPC_TX_D_UNION {
         IPC_TX_D bits;
         u32 dw[8]; // dword union
      } SG_PACK IPC_TX_D_UNION, *PIPC_TX_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TX_D_UNION, sizeof (IPC_TX_D_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Descriptor passed from De-allocating EP to JELLM.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELL_FREE_D {
         union {
            struct { 
               u32 free_bytes : 16;               // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 Connection : 13;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELL_FREE_D, *PJELL_FREE_D;

      SG_C_ASSERT(__sizeof__JELL_FREE_D, sizeof (JELL_FREE_D) == 4);

   #else
      typedef struct _JELL_FREE_D {
         u32 free_bytes : 16;                     // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 Connection : 13;                     // DWORD 0
      } SG_PACK JELL_FREE_D, *PJELL_FREE_D;

      typedef union _JELL_FREE_D_UNION {
         JELL_FREE_D bits;
         u32 dw; // dword union
      } SG_PACK JELL_FREE_D_UNION, *PJELL_FREE_D_UNION;

      SG_C_ASSERT(__sizeof__JELL_FREE_D_UNION, sizeof (JELL_FREE_D_UNION) == 4);
   #endif


#else
   // Descriptor passed from De-allocating EP to JELLM.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELL_FREE_D {
         union {
            struct { 
               u32 Connection : 13;               // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 free_bytes : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELL_FREE_D, *PJELL_FREE_D;

      SG_C_ASSERT(__sizeof__JELL_FREE_D, sizeof (JELL_FREE_D) == 4);

   #else
      typedef struct _JELL_FREE_D {
         u32 Connection : 13;                     // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 free_bytes : 16;                     // DWORD 0
      } SG_PACK JELL_FREE_D, *PJELL_FREE_D;

      typedef union _JELL_FREE_D_UNION {
         JELL_FREE_D bits;
         u32 dw; // dword union
      } SG_PACK JELL_FREE_D_UNION, *PJELL_FREE_D_UNION;

      SG_C_ASSERT(__sizeof__JELL_FREE_D_UNION, sizeof (JELL_FREE_D_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU Interrupt descriptor 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_D {
         union {
            struct { 
               u32 int_src1;                      // DWORD 0
               u32 int_src0;                      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_D, *PMPU_INT_D;

      SG_C_ASSERT(__sizeof__MPU_INT_D, sizeof (MPU_INT_D) == 8);

   #else
      typedef struct _MPU_INT_D {
         u32 int_src1;                            // DWORD 0
         u32 int_src0;                            // DWORD 1
      } SG_PACK MPU_INT_D, *PMPU_INT_D;

      typedef union _MPU_INT_D_UNION {
         MPU_INT_D bits;
         u32 dw[2]; // dword union
      } SG_PACK MPU_INT_D_UNION, *PMPU_INT_D_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_D_UNION, sizeof (MPU_INT_D_UNION) == 8);
   #endif


#else
   // MPU Interrupt descriptor 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_D {
         union {
            struct { 
               u32 int_src1;                      // DWORD 0
               u32 int_src0;                      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_D, *PMPU_INT_D;

      SG_C_ASSERT(__sizeof__MPU_INT_D, sizeof (MPU_INT_D) == 8);

   #else
      typedef struct _MPU_INT_D {
         u32 int_src1;                            // DWORD 0
         u32 int_src0;                            // DWORD 1
      } SG_PACK MPU_INT_D, *PMPU_INT_D;

      typedef union _MPU_INT_D_UNION {
         MPU_INT_D bits;
         u32 dw[2]; // dword union
      } SG_PACK MPU_INT_D_UNION, *PMPU_INT_D_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_D_UNION, sizeof (MPU_INT_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection selector descriptor when ring manager is disabled. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CXN_SEL_D {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 cid : 16;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CXN_SEL_D, *PCXN_SEL_D;

      SG_C_ASSERT(__sizeof__CXN_SEL_D, sizeof (CXN_SEL_D) == 4);

   #else
      typedef struct _CXN_SEL_D {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 cid : 16;                            // DWORD 0
      } SG_PACK CXN_SEL_D, *PCXN_SEL_D;

      typedef union _CXN_SEL_D_UNION {
         CXN_SEL_D bits;
         u32 dw; // dword union
      } SG_PACK CXN_SEL_D_UNION, *PCXN_SEL_D_UNION;

      SG_C_ASSERT(__sizeof__CXN_SEL_D_UNION, sizeof (CXN_SEL_D_UNION) == 4);
   #endif


#else
   // Connection selector descriptor when ring manager is disabled. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CXN_SEL_D {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CXN_SEL_D, *PCXN_SEL_D;

      SG_C_ASSERT(__sizeof__CXN_SEL_D, sizeof (CXN_SEL_D) == 4);

   #else
      typedef struct _CXN_SEL_D {
         u32 cid : 16;                            // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK CXN_SEL_D, *PCXN_SEL_D;

      typedef union _CXN_SEL_D_UNION {
         CXN_SEL_D bits;
         u32 dw; // dword union
      } SG_PACK CXN_SEL_D_UNION, *PCXN_SEL_D_UNION;

      SG_C_ASSERT(__sizeof__CXN_SEL_D_UNION, sizeof (CXN_SEL_D_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection selector descriptor when ring manager is enabled. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_CXN_SEL_RING_D {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 shdw_ring_size : 8;            // DWORD 0
               u32 no_wrb : 8;                    // DWORD 0
               u32 cid : 8;                       // DWORD 0
               u32 wrb_addr;                      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK MPU_CXN_SEL_RING_D, *PMPU_CXN_SEL_RING_D;

      SG_C_ASSERT(__sizeof__MPU_CXN_SEL_RING_D, sizeof (MPU_CXN_SEL_RING_D) == 8);

   #else
      typedef struct _MPU_CXN_SEL_RING_D {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 shdw_ring_size : 8;                  // DWORD 0
         u32 no_wrb : 8;                          // DWORD 0
         u32 cid : 8;                             // DWORD 0
         u32 wrb_addr;                            // DWORD 1
      } SG_PACK MPU_CXN_SEL_RING_D, *PMPU_CXN_SEL_RING_D;

      typedef union _MPU_CXN_SEL_RING_D_UNION {
         MPU_CXN_SEL_RING_D bits;
         u32 dw[2]; // dword union
      } SG_PACK MPU_CXN_SEL_RING_D_UNION, *PMPU_CXN_SEL_RING_D_UNION;

      SG_C_ASSERT(__sizeof__MPU_CXN_SEL_RING_D_UNION, sizeof (MPU_CXN_SEL_RING_D_UNION) == 8);
   #endif


#else
   // Connection selector descriptor when ring manager is enabled. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_CXN_SEL_RING_D {
         union {
            struct { 
               u32 cid : 8;                       // DWORD 0
               u32 no_wrb : 8;                    // DWORD 0
               u32 shdw_ring_size : 8;            // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 wrb_addr;                      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK MPU_CXN_SEL_RING_D, *PMPU_CXN_SEL_RING_D;

      SG_C_ASSERT(__sizeof__MPU_CXN_SEL_RING_D, sizeof (MPU_CXN_SEL_RING_D) == 8);

   #else
      typedef struct _MPU_CXN_SEL_RING_D {
         u32 cid : 8;                             // DWORD 0
         u32 no_wrb : 8;                          // DWORD 0
         u32 shdw_ring_size : 8;                  // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 wrb_addr;                            // DWORD 1
      } SG_PACK MPU_CXN_SEL_RING_D, *PMPU_CXN_SEL_RING_D;

      typedef union _MPU_CXN_SEL_RING_D_UNION {
         MPU_CXN_SEL_RING_D bits;
         u32 dw[2]; // dword union
      } SG_PACK MPU_CXN_SEL_RING_D_UNION, *PMPU_CXN_SEL_RING_D_UNION;

      SG_C_ASSERT(__sizeof__MPU_CXN_SEL_RING_D_UNION, sizeof (MPU_CXN_SEL_RING_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The transmit descriptor (TX_D) is pushed into the output queues by the TXULP modules
   // and is passed down to TPOST, into TXP and optionally back into TPOST. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_D {
         union {
            struct { 
               u32 num_segs : 3;                  // DWORD 0
               u32 nwh_size : 4;                  // DWORD 0
               u32 parse_hdrs : 3;                // DWORD 0
               u32 pu_wr_back : 1;                // DWORD 0
               u32 pup_prog_0_cached : 3;         // DWORD 0
               u32 pu_id_eth : 1;                 // DWORD 0
               u32 iq_select : 1;                 // DWORD 0
               u32 pup_1_prog_size : 4;           // DWORD 0
               u32 pup_0_prog_size : 4;           // DWORD 0
               u32 pu_id : 8;                     // DWORD 0
               u32 func : 8;                      // DWORD 1
               u32 pup_prog_1_cached : 3;         // DWORD 1
               u32 msg_type : 3;                  // DWORD 1
               u32 msg_src : 2;                   // DWORD 1
               u32 cid : 16;                      // DWORD 1
               u32 fcoe : 2;                      // DWORD 2
               u32 l4plus_hdr_size : 8;           // DWORD 2
               u32 sa_index : 6;                  // DWORD 2
               u32 wrb_index : 16;                // DWORD 2
               u32 txd_segs : 6;                  // DWORD 3
               u32 stat_counter : 5;              // DWORD 3
               u32 num_bd : 5;                    // DWORD 3
               u32 bd_id : 16;                    // DWORD 3
               u32 rsvd0 : 1;                     // DWORD 4
               u32 use_excess : 1;                // DWORD 4
               u32 mss : 14;                      // DWORD 4
               u32 shadow_ring_size : 8;          // DWORD 4
               u32 je_id : 8;                     // DWORD 4
               u32 upload_done : 1;               // DWORD 5
               u32 toe_fw_flags : 1;              // DWORD 5
               u32 journal_in_ddr : 1;            // DWORD 5
               u32 win_probe : 1;                 // DWORD 5
               u32 sack_flag : 1;                 // DWORD 5
               u32 fw_flags : 6;                  // DWORD 5
               u32 iscsi_ooo : 1;                 // DWORD 5
               u32 per_priority_class : 3;        // DWORD 5
               u32 gso : 2;                       // DWORD 5
               u32 se_vlan : 1;                   // DWORD 5
               u32 discard_pu_pbuf : 1;           // DWORD 5
               u32 drop_txd : 1;                  // DWORD 5
               u32 load_crc : 1;                  // DWORD 5
               u32 save_crc : 1;                  // DWORD 5
               u32 last_msg : 1;                  // DWORD 5
               u32 tcp_checksum : 1;              // DWORD 5
               u32 udp_checksum : 1;              // DWORD 5
               u32 ip_checksum : 1;               // DWORD 5
               u32 mgmt : 1;                      // DWORD 5
               u32 ipsec : 1;                     // DWORD 5
               u32 forward : 1;                   // DWORD 5
               u32 crc : 1;                       // DWORD 5
               u32 event : 1;                     // DWORD 5
               u32 completion : 1;                // DWORD 5
               u32 sch_credit : 1;                // DWORD 6
               u32 grant_on_response : 1;         // DWORD 6
               u32 ulp_no : 2;                    // DWORD 6
               u32 tpost_fast_path : 1;           // DWORD 6
               u32 ack : 1;                       // DWORD 6
               u32 jrnl_last : 1;                 // DWORD 6
               u32 fw_cargo : 9;                  // DWORD 6
               u32 cq_index : 16;                 // DWORD 6
               u32 tcp_len_diff : 16;             // DWORD 7
               u32 data_len : 16;                 // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK TX_D, *PTX_D;

      SG_C_ASSERT(__sizeof__TX_D, sizeof (TX_D) == 32);

   #else
      typedef struct _TX_D {
         u32 num_segs : 3;                        // DWORD 0
         u32 nwh_size : 4;                        // DWORD 0
         u32 parse_hdrs : 3;                      // DWORD 0
         u32 pu_wr_back : 1;                      // DWORD 0
         u32 pup_prog_0_cached : 3;               // DWORD 0
         u32 pu_id_eth : 1;                       // DWORD 0
         u32 iq_select : 1;                       // DWORD 0
         u32 pup_1_prog_size : 4;                 // DWORD 0
         u32 pup_0_prog_size : 4;                 // DWORD 0
         u32 pu_id : 8;                           // DWORD 0
         u32 func : 8;                            // DWORD 1
         u32 pup_prog_1_cached : 3;               // DWORD 1
         u32 msg_type : 3;                        // DWORD 1
         u32 msg_src : 2;                         // DWORD 1
         u32 cid : 16;                            // DWORD 1
         u32 fcoe : 2;                            // DWORD 2
         u32 l4plus_hdr_size : 8;                 // DWORD 2
         u32 sa_index : 6;                        // DWORD 2
         u32 wrb_index : 16;                      // DWORD 2
         u32 txd_segs : 6;                        // DWORD 3
         u32 stat_counter : 5;                    // DWORD 3
         u32 num_bd : 5;                          // DWORD 3
         u32 bd_id : 16;                          // DWORD 3
         u32 rsvd0 : 1;                           // DWORD 4
         u32 use_excess : 1;                      // DWORD 4
         u32 mss : 14;                            // DWORD 4
         u32 shadow_ring_size : 8;                // DWORD 4
         u32 je_id : 8;                           // DWORD 4
         u32 upload_done : 1;                     // DWORD 5
         u32 toe_fw_flags : 1;                    // DWORD 5
         u32 journal_in_ddr : 1;                  // DWORD 5
         u32 win_probe : 1;                       // DWORD 5
         u32 sack_flag : 1;                       // DWORD 5
         u32 fw_flags : 6;                        // DWORD 5
         u32 iscsi_ooo : 1;                       // DWORD 5
         u32 per_priority_class : 3;              // DWORD 5
         u32 gso : 2;                             // DWORD 5
         u32 se_vlan : 1;                         // DWORD 5
         u32 discard_pu_pbuf : 1;                 // DWORD 5
         u32 drop_txd : 1;                        // DWORD 5
         u32 load_crc : 1;                        // DWORD 5
         u32 save_crc : 1;                        // DWORD 5
         u32 last_msg : 1;                        // DWORD 5
         u32 tcp_checksum : 1;                    // DWORD 5
         u32 udp_checksum : 1;                    // DWORD 5
         u32 ip_checksum : 1;                     // DWORD 5
         u32 mgmt : 1;                            // DWORD 5
         u32 ipsec : 1;                           // DWORD 5
         u32 forward : 1;                         // DWORD 5
         u32 crc : 1;                             // DWORD 5
         u32 event : 1;                           // DWORD 5
         u32 completion : 1;                      // DWORD 5
         u32 sch_credit : 1;                      // DWORD 6
         u32 grant_on_response : 1;               // DWORD 6
         u32 ulp_no : 2;                          // DWORD 6
         u32 tpost_fast_path : 1;                 // DWORD 6
         u32 ack : 1;                             // DWORD 6
         u32 jrnl_last : 1;                       // DWORD 6
         u32 fw_cargo : 9;                        // DWORD 6
         u32 cq_index : 16;                       // DWORD 6
         u32 tcp_len_diff : 16;                   // DWORD 7
         u32 data_len : 16;                       // DWORD 7
      } SG_PACK TX_D, *PTX_D;

      typedef union _TX_D_UNION {
         TX_D bits;
         u32 dw[8]; // dword union
      } SG_PACK TX_D_UNION, *PTX_D_UNION;

      SG_C_ASSERT(__sizeof__TX_D_UNION, sizeof (TX_D_UNION) == 32);
   #endif


#else
   // The transmit descriptor (TX_D) is pushed into the output queues by the TXULP modules
   // and is passed down to TPOST, into TXP and optionally back into TPOST. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_D {
         union {
            struct { 
               u32 pu_id : 8;                     // DWORD 0
               u32 pup_0_prog_size : 4;           // DWORD 0
               u32 pup_1_prog_size : 4;           // DWORD 0
               u32 iq_select : 1;                 // DWORD 0
               u32 pu_id_eth : 1;                 // DWORD 0
               u32 pup_prog_0_cached : 3;         // DWORD 0
               u32 pu_wr_back : 1;                // DWORD 0
               u32 parse_hdrs : 3;                // DWORD 0
               u32 nwh_size : 4;                  // DWORD 0
               u32 num_segs : 3;                  // DWORD 0
               u32 cid : 16;                      // DWORD 1
               u32 msg_src : 2;                   // DWORD 1
               u32 msg_type : 3;                  // DWORD 1
               u32 pup_prog_1_cached : 3;         // DWORD 1
               u32 func : 8;                      // DWORD 1
               u32 wrb_index : 16;                // DWORD 2
               u32 sa_index : 6;                  // DWORD 2
               u32 l4plus_hdr_size : 8;           // DWORD 2
               u32 fcoe : 2;                      // DWORD 2
               u32 bd_id : 16;                    // DWORD 3
               u32 num_bd : 5;                    // DWORD 3
               u32 stat_counter : 5;              // DWORD 3
               u32 txd_segs : 6;                  // DWORD 3
               u32 je_id : 8;                     // DWORD 4
               u32 shadow_ring_size : 8;          // DWORD 4
               u32 mss : 14;                      // DWORD 4
               u32 use_excess : 1;                // DWORD 4
               u32 rsvd0 : 1;                     // DWORD 4
               u32 completion : 1;                // DWORD 5
               u32 event : 1;                     // DWORD 5
               u32 crc : 1;                       // DWORD 5
               u32 forward : 1;                   // DWORD 5
               u32 ipsec : 1;                     // DWORD 5
               u32 mgmt : 1;                      // DWORD 5
               u32 ip_checksum : 1;               // DWORD 5
               u32 udp_checksum : 1;              // DWORD 5
               u32 tcp_checksum : 1;              // DWORD 5
               u32 last_msg : 1;                  // DWORD 5
               u32 save_crc : 1;                  // DWORD 5
               u32 load_crc : 1;                  // DWORD 5
               u32 drop_txd : 1;                  // DWORD 5
               u32 discard_pu_pbuf : 1;           // DWORD 5
               u32 se_vlan : 1;                   // DWORD 5
               u32 gso : 2;                       // DWORD 5
               u32 per_priority_class : 3;        // DWORD 5
               u32 iscsi_ooo : 1;                 // DWORD 5
               u32 fw_flags : 6;                  // DWORD 5
               u32 sack_flag : 1;                 // DWORD 5
               u32 win_probe : 1;                 // DWORD 5
               u32 journal_in_ddr : 1;            // DWORD 5
               u32 toe_fw_flags : 1;              // DWORD 5
               u32 upload_done : 1;               // DWORD 5
               u32 cq_index : 16;                 // DWORD 6
               u32 fw_cargo : 9;                  // DWORD 6
               u32 jrnl_last : 1;                 // DWORD 6
               u32 ack : 1;                       // DWORD 6
               u32 tpost_fast_path : 1;           // DWORD 6
               u32 ulp_no : 2;                    // DWORD 6
               u32 grant_on_response : 1;         // DWORD 6
               u32 sch_credit : 1;                // DWORD 6
               u32 data_len : 16;                 // DWORD 7
               u32 tcp_len_diff : 16;             // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK TX_D, *PTX_D;

      SG_C_ASSERT(__sizeof__TX_D, sizeof (TX_D) == 32);

   #else
      typedef struct _TX_D {
         u32 pu_id : 8;                           // DWORD 0
         u32 pup_0_prog_size : 4;                 // DWORD 0
         u32 pup_1_prog_size : 4;                 // DWORD 0
         u32 iq_select : 1;                       // DWORD 0
         u32 pu_id_eth : 1;                       // DWORD 0
         u32 pup_prog_0_cached : 3;               // DWORD 0
         u32 pu_wr_back : 1;                      // DWORD 0
         u32 parse_hdrs : 3;                      // DWORD 0
         u32 nwh_size : 4;                        // DWORD 0
         u32 num_segs : 3;                        // DWORD 0
         u32 cid : 16;                            // DWORD 1
         u32 msg_src : 2;                         // DWORD 1
         u32 msg_type : 3;                        // DWORD 1
         u32 pup_prog_1_cached : 3;               // DWORD 1
         u32 func : 8;                            // DWORD 1
         u32 wrb_index : 16;                      // DWORD 2
         u32 sa_index : 6;                        // DWORD 2
         u32 l4plus_hdr_size : 8;                 // DWORD 2
         u32 fcoe : 2;                            // DWORD 2
         u32 bd_id : 16;                          // DWORD 3
         u32 num_bd : 5;                          // DWORD 3
         u32 stat_counter : 5;                    // DWORD 3
         u32 txd_segs : 6;                        // DWORD 3
         u32 je_id : 8;                           // DWORD 4
         u32 shadow_ring_size : 8;                // DWORD 4
         u32 mss : 14;                            // DWORD 4
         u32 use_excess : 1;                      // DWORD 4
         u32 rsvd0 : 1;                           // DWORD 4
         u32 completion : 1;                      // DWORD 5
         u32 event : 1;                           // DWORD 5
         u32 crc : 1;                             // DWORD 5
         u32 forward : 1;                         // DWORD 5
         u32 ipsec : 1;                           // DWORD 5
         u32 mgmt : 1;                            // DWORD 5
         u32 ip_checksum : 1;                     // DWORD 5
         u32 udp_checksum : 1;                    // DWORD 5
         u32 tcp_checksum : 1;                    // DWORD 5
         u32 last_msg : 1;                        // DWORD 5
         u32 save_crc : 1;                        // DWORD 5
         u32 load_crc : 1;                        // DWORD 5
         u32 drop_txd : 1;                        // DWORD 5
         u32 discard_pu_pbuf : 1;                 // DWORD 5
         u32 se_vlan : 1;                         // DWORD 5
         u32 gso : 2;                             // DWORD 5
         u32 per_priority_class : 3;              // DWORD 5
         u32 iscsi_ooo : 1;                       // DWORD 5
         u32 fw_flags : 6;                        // DWORD 5
         u32 sack_flag : 1;                       // DWORD 5
         u32 win_probe : 1;                       // DWORD 5
         u32 journal_in_ddr : 1;                  // DWORD 5
         u32 toe_fw_flags : 1;                    // DWORD 5
         u32 upload_done : 1;                     // DWORD 5
         u32 cq_index : 16;                       // DWORD 6
         u32 fw_cargo : 9;                        // DWORD 6
         u32 jrnl_last : 1;                       // DWORD 6
         u32 ack : 1;                             // DWORD 6
         u32 tpost_fast_path : 1;                 // DWORD 6
         u32 ulp_no : 2;                          // DWORD 6
         u32 grant_on_response : 1;               // DWORD 6
         u32 sch_credit : 1;                      // DWORD 6
         u32 data_len : 16;                       // DWORD 7
         u32 tcp_len_diff : 16;                   // DWORD 7
      } SG_PACK TX_D, *PTX_D;

      typedef union _TX_D_UNION {
         TX_D bits;
         u32 dw[8]; // dword union
      } SG_PACK TX_D_UNION, *PTX_D_UNION;

      SG_C_ASSERT(__sizeof__TX_D_UNION, sizeof (TX_D_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PUP_INSTRUCTION {
         union {
            struct { 
               u32 only : 1;                      // DWORD 0
               u32 last : 1;                      // DWORD 0
               u32 middle : 1;                    // DWORD 0
               u32 first : 1;                     // DWORD 0
               u32 opcode : 3;                    // DWORD 0
               u32 byte_count : 2;                // DWORD 0
               u32 src_register : 4;              // DWORD 0
               u32 imm_mask : 1;                  // DWORD 0
               u32 imme : 1;                      // DWORD 0
               u32 now : 1;                       // DWORD 0
               u32 at_counter : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PUP_INSTRUCTION, *PPUP_INSTRUCTION;

      SG_C_ASSERT(__sizeof__PUP_INSTRUCTION, sizeof (PUP_INSTRUCTION) == 4);

   #else
      typedef struct _PUP_INSTRUCTION {
         u32 only : 1;                            // DWORD 0
         u32 last : 1;                            // DWORD 0
         u32 middle : 1;                          // DWORD 0
         u32 first : 1;                           // DWORD 0
         u32 opcode : 3;                          // DWORD 0
         u32 byte_count : 2;                      // DWORD 0
         u32 src_register : 4;                    // DWORD 0
         u32 imm_mask : 1;                        // DWORD 0
         u32 imme : 1;                            // DWORD 0
         u32 now : 1;                             // DWORD 0
         u32 at_counter : 16;                     // DWORD 0
      } SG_PACK PUP_INSTRUCTION, *PPUP_INSTRUCTION;

      typedef union _PUP_INSTRUCTION_UNION {
         PUP_INSTRUCTION bits;
         u32 dw; // dword union
      } SG_PACK PUP_INSTRUCTION_UNION, *PPUP_INSTRUCTION_UNION;

      SG_C_ASSERT(__sizeof__PUP_INSTRUCTION_UNION, sizeof (PUP_INSTRUCTION_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PUP_INSTRUCTION {
         union {
            struct { 
               u32 at_counter : 16;               // DWORD 0
               u32 now : 1;                       // DWORD 0
               u32 imme : 1;                      // DWORD 0
               u32 imm_mask : 1;                  // DWORD 0
               u32 src_register : 4;              // DWORD 0
               u32 byte_count : 2;                // DWORD 0
               u32 opcode : 3;                    // DWORD 0
               u32 first : 1;                     // DWORD 0
               u32 middle : 1;                    // DWORD 0
               u32 last : 1;                      // DWORD 0
               u32 only : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PUP_INSTRUCTION, *PPUP_INSTRUCTION;

      SG_C_ASSERT(__sizeof__PUP_INSTRUCTION, sizeof (PUP_INSTRUCTION) == 4);

   #else
      typedef struct _PUP_INSTRUCTION {
         u32 at_counter : 16;                     // DWORD 0
         u32 now : 1;                             // DWORD 0
         u32 imme : 1;                            // DWORD 0
         u32 imm_mask : 1;                        // DWORD 0
         u32 src_register : 4;                    // DWORD 0
         u32 byte_count : 2;                      // DWORD 0
         u32 opcode : 3;                          // DWORD 0
         u32 first : 1;                           // DWORD 0
         u32 middle : 1;                          // DWORD 0
         u32 last : 1;                            // DWORD 0
         u32 only : 1;                            // DWORD 0
      } SG_PACK PUP_INSTRUCTION, *PPUP_INSTRUCTION;

      typedef union _PUP_INSTRUCTION_UNION {
         PUP_INSTRUCTION bits;
         u32 dw; // dword union
      } SG_PACK PUP_INSTRUCTION_UNION, *PPUP_INSTRUCTION_UNION;

      SG_C_ASSERT(__sizeof__PUP_INSTRUCTION_UNION, sizeof (PUP_INSTRUCTION_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PUP_PROGRAM_HEADER {
         union {
            struct { 
               u32 rsvd0 : 5;                     // DWORD 0
               u32 brlp_in_progress : 1;          // DWORD 0
               u32 load_reg_set : 14;             // DWORD 0
               u32 prog_valid : 1;                // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 fcoe_on_crc0 : 1;              // DWORD 0
               u32 use_l4plus_hdr_size : 1;       // DWORD 0
               u32 compare_result : 1;            // DWORD 0
               u32 use_nwh : 1;                   // DWORD 0
               u32 i_iptr_saved : 5;              // DWORD 0
               u32 using_header : 1;              // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 1
               u32 constant_mask_reg_set : 7;     // DWORD 1
               u32 hoffset : 8;                   // DWORD 1
               u32 hsize : 8;                     // DWORD 1
               u32 pbuf_id : 8;                   // DWORD 1
               u32 pup_register_dbc1;             // DWORD 2
               u32 pup_register_hbc1;             // DWORD 3
               u32 pup_register_obc0;             // DWORD 4
               u32 pup_register_obc1;             // DWORD 5
               u32 pup_register_odbc0;            // DWORD 6
               u32 pup_register_odbc1;            // DWORD 7
               u32 pup_register_fc;               // DWORD 8
               u32 pup_register_crc0;             // DWORD 9
               u32 pup_register_crc1;             // DWORD 10
               u32 pup_register_gp0;              // DWORD 11
               u32 pup_register_gp1;              // DWORD 12
               u32 pup_register_gp2;              // DWORD 13
               u32 pup_register_ldbc;             // DWORD 14
               u32 pup_register_lodbc;            // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK PUP_PROGRAM_HEADER, *PPUP_PROGRAM_HEADER;

      SG_C_ASSERT(__sizeof__PUP_PROGRAM_HEADER, sizeof (PUP_PROGRAM_HEADER) == 64);

   #else
      typedef struct _PUP_PROGRAM_HEADER {
         u32 rsvd0 : 5;                           // DWORD 0
         u32 brlp_in_progress : 1;                // DWORD 0
         u32 load_reg_set : 14;                   // DWORD 0
         u32 prog_valid : 1;                      // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 fcoe_on_crc0 : 1;                    // DWORD 0
         u32 use_l4plus_hdr_size : 1;             // DWORD 0
         u32 compare_result : 1;                  // DWORD 0
         u32 use_nwh : 1;                         // DWORD 0
         u32 i_iptr_saved : 5;                    // DWORD 0
         u32 using_header : 1;                    // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 1
         u32 constant_mask_reg_set : 7;           // DWORD 1
         u32 hoffset : 8;                         // DWORD 1
         u32 hsize : 8;                           // DWORD 1
         u32 pbuf_id : 8;                         // DWORD 1
         u32 pup_register_dbc1;                   // DWORD 2
         u32 pup_register_hbc1;                   // DWORD 3
         u32 pup_register_obc0;                   // DWORD 4
         u32 pup_register_obc1;                   // DWORD 5
         u32 pup_register_odbc0;                  // DWORD 6
         u32 pup_register_odbc1;                  // DWORD 7
         u32 pup_register_fc;                     // DWORD 8
         u32 pup_register_crc0;                   // DWORD 9
         u32 pup_register_crc1;                   // DWORD 10
         u32 pup_register_gp0;                    // DWORD 11
         u32 pup_register_gp1;                    // DWORD 12
         u32 pup_register_gp2;                    // DWORD 13
         u32 pup_register_ldbc;                   // DWORD 14
         u32 pup_register_lodbc;                  // DWORD 15
      } SG_PACK PUP_PROGRAM_HEADER, *PPUP_PROGRAM_HEADER;

      typedef union _PUP_PROGRAM_HEADER_UNION {
         PUP_PROGRAM_HEADER bits;
         u32 dw[16]; // dword union
      } SG_PACK PUP_PROGRAM_HEADER_UNION, *PPUP_PROGRAM_HEADER_UNION;

      SG_C_ASSERT(__sizeof__PUP_PROGRAM_HEADER_UNION, sizeof (PUP_PROGRAM_HEADER_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PUP_PROGRAM_HEADER {
         union {
            struct { 
               u32 using_header : 1;              // DWORD 0
               u32 i_iptr_saved : 5;              // DWORD 0
               u32 use_nwh : 1;                   // DWORD 0
               u32 compare_result : 1;            // DWORD 0
               u32 use_l4plus_hdr_size : 1;       // DWORD 0
               u32 fcoe_on_crc0 : 1;              // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 prog_valid : 1;                // DWORD 0
               u32 load_reg_set : 14;             // DWORD 0
               u32 brlp_in_progress : 1;          // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 pbuf_id : 8;                   // DWORD 1
               u32 hsize : 8;                     // DWORD 1
               u32 hoffset : 8;                   // DWORD 1
               u32 constant_mask_reg_set : 7;     // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 pup_register_dbc1;             // DWORD 2
               u32 pup_register_hbc1;             // DWORD 3
               u32 pup_register_obc0;             // DWORD 4
               u32 pup_register_obc1;             // DWORD 5
               u32 pup_register_odbc0;            // DWORD 6
               u32 pup_register_odbc1;            // DWORD 7
               u32 pup_register_fc;               // DWORD 8
               u32 pup_register_crc0;             // DWORD 9
               u32 pup_register_crc1;             // DWORD 10
               u32 pup_register_gp0;              // DWORD 11
               u32 pup_register_gp1;              // DWORD 12
               u32 pup_register_gp2;              // DWORD 13
               u32 pup_register_ldbc;             // DWORD 14
               u32 pup_register_lodbc;            // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK PUP_PROGRAM_HEADER, *PPUP_PROGRAM_HEADER;

      SG_C_ASSERT(__sizeof__PUP_PROGRAM_HEADER, sizeof (PUP_PROGRAM_HEADER) == 64);

   #else
      typedef struct _PUP_PROGRAM_HEADER {
         u32 using_header : 1;                    // DWORD 0
         u32 i_iptr_saved : 5;                    // DWORD 0
         u32 use_nwh : 1;                         // DWORD 0
         u32 compare_result : 1;                  // DWORD 0
         u32 use_l4plus_hdr_size : 1;             // DWORD 0
         u32 fcoe_on_crc0 : 1;                    // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 prog_valid : 1;                      // DWORD 0
         u32 load_reg_set : 14;                   // DWORD 0
         u32 brlp_in_progress : 1;                // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 pbuf_id : 8;                         // DWORD 1
         u32 hsize : 8;                           // DWORD 1
         u32 hoffset : 8;                         // DWORD 1
         u32 constant_mask_reg_set : 7;           // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 pup_register_dbc1;                   // DWORD 2
         u32 pup_register_hbc1;                   // DWORD 3
         u32 pup_register_obc0;                   // DWORD 4
         u32 pup_register_obc1;                   // DWORD 5
         u32 pup_register_odbc0;                  // DWORD 6
         u32 pup_register_odbc1;                  // DWORD 7
         u32 pup_register_fc;                     // DWORD 8
         u32 pup_register_crc0;                   // DWORD 9
         u32 pup_register_crc1;                   // DWORD 10
         u32 pup_register_gp0;                    // DWORD 11
         u32 pup_register_gp1;                    // DWORD 12
         u32 pup_register_gp2;                    // DWORD 13
         u32 pup_register_ldbc;                   // DWORD 14
         u32 pup_register_lodbc;                  // DWORD 15
      } SG_PACK PUP_PROGRAM_HEADER, *PPUP_PROGRAM_HEADER;

      typedef union _PUP_PROGRAM_HEADER_UNION {
         PUP_PROGRAM_HEADER bits;
         u32 dw[16]; // dword union
      } SG_PACK PUP_PROGRAM_HEADER_UNION, *PPUP_PROGRAM_HEADER_UNION;

      SG_C_ASSERT(__sizeof__PUP_PROGRAM_HEADER_UNION, sizeof (PUP_PROGRAM_HEADER_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PUP_PROGRAMS {
         union {
            struct { 
               PUP_PROGRAM_HEADER program_hdr0;
               PUP_PROGRAM_HEADER program_hdr1;
               PUP_INSTRUCTION pup0_instructions[40];
               PUP_INSTRUCTION pup1_instructions[40];
            } SG_PACK ; // unnamed struct
            u32 dw[112]; // dword union
         }; // unnamed union
      } SG_PACK PUP_PROGRAMS, *PPUP_PROGRAMS;

      SG_C_ASSERT(__sizeof__PUP_PROGRAMS, sizeof (PUP_PROGRAMS) == 448);

   #else
      typedef struct _PUP_PROGRAMS {
         PUP_PROGRAM_HEADER program_hdr0;
         PUP_PROGRAM_HEADER program_hdr1;
         PUP_INSTRUCTION pup0_instructions[40];
         PUP_INSTRUCTION pup1_instructions[40];
      } SG_PACK PUP_PROGRAMS, *PPUP_PROGRAMS;

      typedef union _PUP_PROGRAMS_UNION {
         PUP_PROGRAMS bits;
         u32 dw[112]; // dword union
      } SG_PACK PUP_PROGRAMS_UNION, *PPUP_PROGRAMS_UNION;

      SG_C_ASSERT(__sizeof__PUP_PROGRAMS_UNION, sizeof (PUP_PROGRAMS_UNION) == 448);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PUP_PROGRAMS {
         union {
            struct { 
               PUP_PROGRAM_HEADER program_hdr0;
               PUP_PROGRAM_HEADER program_hdr1;
               PUP_INSTRUCTION pup0_instructions[40];
               PUP_INSTRUCTION pup1_instructions[40];
            } SG_PACK ; // unnamed struct
            u32 dw[112]; // dword union
         }; // unnamed union
      } SG_PACK PUP_PROGRAMS, *PPUP_PROGRAMS;

      SG_C_ASSERT(__sizeof__PUP_PROGRAMS, sizeof (PUP_PROGRAMS) == 448);

   #else
      typedef struct _PUP_PROGRAMS {
         PUP_PROGRAM_HEADER program_hdr0;
         PUP_PROGRAM_HEADER program_hdr1;
         PUP_INSTRUCTION pup0_instructions[40];
         PUP_INSTRUCTION pup1_instructions[40];
      } SG_PACK PUP_PROGRAMS, *PPUP_PROGRAMS;

      typedef union _PUP_PROGRAMS_UNION {
         PUP_PROGRAMS bits;
         u32 dw[112]; // dword union
      } SG_PACK PUP_PROGRAMS_UNION, *PPUP_PROGRAMS_UNION;

      SG_C_ASSERT(__sizeof__PUP_PROGRAMS_UNION, sizeof (PUP_PROGRAMS_UNION) == 448);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Header for a full packet enqueued to the Transmit FIFOs.
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_FIFO_HDR_D {
         union {
            struct { 
               u32 ah_esp : 1;                    // DWORD 0
               u32 ipv6 : 1;                      // DWORD 0
               u32 sa_index : 6;                  // DWORD 0
               u32 sw : 1;                        // DWORD 0
               u32 ip_hdr_offset : 3;             // DWORD 0
               u32 not_unicast : 1;               // DWORD 0
               u32 ipsec : 1;                     // DWORD 0
               u32 crc : 1;                       // DWORD 0
               u32 len : 14;                      // DWORD 0
               u32 dst : 3;                       // DWORD 0
               u32 rxf_rx_vector0;                // DWORD 1
               u32 rsvd0 : 20;                    // DWORD 2
               u32 rxf_mac_hit_address : 7;       // DWORD 2
               u32 rxf_rx_vector1 : 5;            // DWORD 2
               u32 rsvd1[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TX_FIFO_HDR_D, *PTX_FIFO_HDR_D;

      SG_C_ASSERT(__sizeof__TX_FIFO_HDR_D, sizeof (TX_FIFO_HDR_D) == 16);

   #else
      typedef struct _TX_FIFO_HDR_D {
         u32 ah_esp : 1;                          // DWORD 0
         u32 ipv6 : 1;                            // DWORD 0
         u32 sa_index : 6;                        // DWORD 0
         u32 sw : 1;                              // DWORD 0
         u32 ip_hdr_offset : 3;                   // DWORD 0
         u32 not_unicast : 1;                     // DWORD 0
         u32 ipsec : 1;                           // DWORD 0
         u32 crc : 1;                             // DWORD 0
         u32 len : 14;                            // DWORD 0
         u32 dst : 3;                             // DWORD 0
         u32 rxf_rx_vector0;                      // DWORD 1
         u32 rsvd0 : 20;                          // DWORD 2
         u32 rxf_mac_hit_address : 7;             // DWORD 2
         u32 rxf_rx_vector1 : 5;                  // DWORD 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
      } SG_PACK TX_FIFO_HDR_D, *PTX_FIFO_HDR_D;

      typedef union _TX_FIFO_HDR_D_UNION {
         TX_FIFO_HDR_D bits;
         u32 dw[4]; // dword union
      } SG_PACK TX_FIFO_HDR_D_UNION, *PTX_FIFO_HDR_D_UNION;

      SG_C_ASSERT(__sizeof__TX_FIFO_HDR_D_UNION, sizeof (TX_FIFO_HDR_D_UNION) == 16);
   #endif


#else
   // Header for a full packet enqueued to the Transmit FIFOs.
   #if defined(SG_BMAP_UNION)
      typedef struct _TX_FIFO_HDR_D {
         union {
            struct { 
               u32 dst : 3;                       // DWORD 0
               u32 len : 14;                      // DWORD 0
               u32 crc : 1;                       // DWORD 0
               u32 ipsec : 1;                     // DWORD 0
               u32 not_unicast : 1;               // DWORD 0
               u32 ip_hdr_offset : 3;             // DWORD 0
               u32 sw : 1;                        // DWORD 0
               u32 sa_index : 6;                  // DWORD 0
               u32 ipv6 : 1;                      // DWORD 0
               u32 ah_esp : 1;                    // DWORD 0
               u32 rxf_rx_vector0;                // DWORD 1
               u32 rxf_rx_vector1 : 5;            // DWORD 2
               u32 rxf_mac_hit_address : 7;       // DWORD 2
               u32 rsvd0 : 20;                    // DWORD 2
               u32 rsvd1[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TX_FIFO_HDR_D, *PTX_FIFO_HDR_D;

      SG_C_ASSERT(__sizeof__TX_FIFO_HDR_D, sizeof (TX_FIFO_HDR_D) == 16);

   #else
      typedef struct _TX_FIFO_HDR_D {
         u32 dst : 3;                             // DWORD 0
         u32 len : 14;                            // DWORD 0
         u32 crc : 1;                             // DWORD 0
         u32 ipsec : 1;                           // DWORD 0
         u32 not_unicast : 1;                     // DWORD 0
         u32 ip_hdr_offset : 3;                   // DWORD 0
         u32 sw : 1;                              // DWORD 0
         u32 sa_index : 6;                        // DWORD 0
         u32 ipv6 : 1;                            // DWORD 0
         u32 ah_esp : 1;                          // DWORD 0
         u32 rxf_rx_vector0;                      // DWORD 1
         u32 rxf_rx_vector1 : 5;                  // DWORD 2
         u32 rxf_mac_hit_address : 7;             // DWORD 2
         u32 rsvd0 : 20;                          // DWORD 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
      } SG_PACK TX_FIFO_HDR_D, *PTX_FIFO_HDR_D;

      typedef union _TX_FIFO_HDR_D_UNION {
         TX_FIFO_HDR_D bits;
         u32 dw[4]; // dword union
      } SG_PACK TX_FIFO_HDR_D_UNION, *PTX_FIFO_HDR_D_UNION;

      SG_C_ASSERT(__sizeof__TX_FIFO_HDR_D_UNION, sizeof (TX_FIFO_HDR_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data/Descriptor for TxULP Input Queue from TCP scheduler; 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCPSCH_PROC_DESC {
         union {
            struct { 
               u32 rsvd2 : 7;                     // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 alltcpacks : 1;                // DWORD 0
               u32 notcp : 1;                     // DWORD 0
               u32 chipRequest : 1;               // DWORD 0
               u32 driverRequest : 1;             // DWORD 0
               u32 retransmit : 1;                // DWORD 0
               u32 RRMsg : 1;                     // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 cid : 11;                      // DWORD 0
               u32 grant_len;                     // DWORD 1
               u32 snd_nxt;                       // DWORD 2
               u32 snd_max;                       // DWORD 3
               u32 last_ack_sent;                 // DWORD 4
               u32 t_rxtshift : 4;                // DWORD 5
               u32 rsvd3 : 9;                     // DWORD 5
               u32 t_flags : 11;                  // DWORD 5
               u32 t_state : 8;                   // DWORD 5
               u32 rx_flags : 8;                  // DWORD 6
               u32 rx_state : 4;                  // DWORD 6
               u32 t_dupacks2 : 2;                // DWORD 6
               u32 port_id : 2;                   // DWORD 6
               u32 t_maxseg : 16;                 // DWORD 6
               u32 snd_una;                       // DWORD 7
               u32 snd_last;                      // DWORD 8
               u32 snd_cwnd;                      // DWORD 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK TCPSCH_PROC_DESC, *PTCPSCH_PROC_DESC;

      SG_C_ASSERT(__sizeof__TCPSCH_PROC_DESC, sizeof (TCPSCH_PROC_DESC) == 40);

   #else
      typedef struct _TCPSCH_PROC_DESC {
         u32 rsvd2 : 7;                           // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 alltcpacks : 1;                      // DWORD 0
         u32 notcp : 1;                           // DWORD 0
         u32 chipRequest : 1;                     // DWORD 0
         u32 driverRequest : 1;                   // DWORD 0
         u32 retransmit : 1;                      // DWORD 0
         u32 RRMsg : 1;                           // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 cid : 11;                            // DWORD 0
         u32 grant_len;                           // DWORD 1
         u32 snd_nxt;                             // DWORD 2
         u32 snd_max;                             // DWORD 3
         u32 last_ack_sent;                       // DWORD 4
         u32 t_rxtshift : 4;                      // DWORD 5
         u32 rsvd3 : 9;                           // DWORD 5
         u32 t_flags : 11;                        // DWORD 5
         u32 t_state : 8;                         // DWORD 5
         u32 rx_flags : 8;                        // DWORD 6
         u32 rx_state : 4;                        // DWORD 6
         u32 t_dupacks2 : 2;                      // DWORD 6
         u32 port_id : 2;                         // DWORD 6
         u32 t_maxseg : 16;                       // DWORD 6
         u32 snd_una;                             // DWORD 7
         u32 snd_last;                            // DWORD 8
         u32 snd_cwnd;                            // DWORD 9
      } SG_PACK TCPSCH_PROC_DESC, *PTCPSCH_PROC_DESC;

      typedef union _TCPSCH_PROC_DESC_UNION {
         TCPSCH_PROC_DESC bits;
         u32 dw[10]; // dword union
      } SG_PACK TCPSCH_PROC_DESC_UNION, *PTCPSCH_PROC_DESC_UNION;

      SG_C_ASSERT(__sizeof__TCPSCH_PROC_DESC_UNION, sizeof (TCPSCH_PROC_DESC_UNION) == 40);
   #endif


#else
   // Data/Descriptor for TxULP Input Queue from TCP scheduler; 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCPSCH_PROC_DESC {
         union {
            struct { 
               u32 cid : 11;                      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 RRMsg : 1;                     // DWORD 0
               u32 retransmit : 1;                // DWORD 0
               u32 driverRequest : 1;             // DWORD 0
               u32 chipRequest : 1;               // DWORD 0
               u32 notcp : 1;                     // DWORD 0
               u32 alltcpacks : 1;                // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 rsvd2 : 7;                     // DWORD 0
               u32 grant_len;                     // DWORD 1
               u32 snd_nxt;                       // DWORD 2
               u32 snd_max;                       // DWORD 3
               u32 last_ack_sent;                 // DWORD 4
               u32 t_state : 8;                   // DWORD 5
               u32 t_flags : 11;                  // DWORD 5
               u32 rsvd3 : 9;                     // DWORD 5
               u32 t_rxtshift : 4;                // DWORD 5
               u32 t_maxseg : 16;                 // DWORD 6
               u32 port_id : 2;                   // DWORD 6
               u32 t_dupacks2 : 2;                // DWORD 6
               u32 rx_state : 4;                  // DWORD 6
               u32 rx_flags : 8;                  // DWORD 6
               u32 snd_una;                       // DWORD 7
               u32 snd_last;                      // DWORD 8
               u32 snd_cwnd;                      // DWORD 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK TCPSCH_PROC_DESC, *PTCPSCH_PROC_DESC;

      SG_C_ASSERT(__sizeof__TCPSCH_PROC_DESC, sizeof (TCPSCH_PROC_DESC) == 40);

   #else
      typedef struct _TCPSCH_PROC_DESC {
         u32 cid : 11;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 RRMsg : 1;                           // DWORD 0
         u32 retransmit : 1;                      // DWORD 0
         u32 driverRequest : 1;                   // DWORD 0
         u32 chipRequest : 1;                     // DWORD 0
         u32 notcp : 1;                           // DWORD 0
         u32 alltcpacks : 1;                      // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 rsvd2 : 7;                           // DWORD 0
         u32 grant_len;                           // DWORD 1
         u32 snd_nxt;                             // DWORD 2
         u32 snd_max;                             // DWORD 3
         u32 last_ack_sent;                       // DWORD 4
         u32 t_state : 8;                         // DWORD 5
         u32 t_flags : 11;                        // DWORD 5
         u32 rsvd3 : 9;                           // DWORD 5
         u32 t_rxtshift : 4;                      // DWORD 5
         u32 t_maxseg : 16;                       // DWORD 6
         u32 port_id : 2;                         // DWORD 6
         u32 t_dupacks2 : 2;                      // DWORD 6
         u32 rx_state : 4;                        // DWORD 6
         u32 rx_flags : 8;                        // DWORD 6
         u32 snd_una;                             // DWORD 7
         u32 snd_last;                            // DWORD 8
         u32 snd_cwnd;                            // DWORD 9
      } SG_PACK TCPSCH_PROC_DESC, *PTCPSCH_PROC_DESC;

      typedef union _TCPSCH_PROC_DESC_UNION {
         TCPSCH_PROC_DESC bits;
         u32 dw[10]; // dword union
      } SG_PACK TCPSCH_PROC_DESC_UNION, *PTCPSCH_PROC_DESC_UNION;

      SG_C_ASSERT(__sizeof__TCPSCH_PROC_DESC_UNION, sizeof (TCPSCH_PROC_DESC_UNION) == 40);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Work request block that the driver issues to the chip for Ethernet transmissions.
   // All control fields must be valid in each WRB for a message. The controller, as
   // specified by the flags, optionally writes an entry to the Completion Ring and
   // generate an event. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_ETH_HDR_WRB {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 last_seg_udp_len : 14;         // DWORD 1
               u32 rsvd1 : 18;                    // DWORD 1
               u32 lso_mss : 14;                  // DWORD 2
               u32 num_wrb : 5;                   // DWORD 2
               u32 gso : 2;                       // DWORD 2
               u32 vlan : 1;                      // DWORD 2
               u32 lso : 1;                       // DWORD 2
               u32 tcpcs : 1;                     // DWORD 2
               u32 udpcs : 1;                     // DWORD 2
               u32 ipcs : 1;                      // DWORD 2
               u32 mgmt : 1;                      // DWORD 2
               u32 ipv6_lso : 1;                  // DWORD 2
               u32 forward : 1;                   // DWORD 2
               u32 crc : 1;                       // DWORD 2
               u32 event : 1;                     // DWORD 2
               u32 complete : 1;                  // DWORD 2
               u32 vlan_tag : 16;                 // DWORD 3
               u32 len : 16;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE2_ETH_HDR_WRB, *PBE2_ETH_HDR_WRB;

      SG_C_ASSERT(__sizeof__BE2_ETH_HDR_WRB, sizeof (BE2_ETH_HDR_WRB) == 16);

   #else
      typedef struct _BE2_ETH_HDR_WRB {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 last_seg_udp_len : 14;               // DWORD 1
         u32 rsvd1 : 18;                          // DWORD 1
         u32 lso_mss : 14;                        // DWORD 2
         u32 num_wrb : 5;                         // DWORD 2
         u32 gso : 2;                             // DWORD 2
         u32 vlan : 1;                            // DWORD 2
         u32 lso : 1;                             // DWORD 2
         u32 tcpcs : 1;                           // DWORD 2
         u32 udpcs : 1;                           // DWORD 2
         u32 ipcs : 1;                            // DWORD 2
         u32 mgmt : 1;                            // DWORD 2
         u32 ipv6_lso : 1;                        // DWORD 2
         u32 forward : 1;                         // DWORD 2
         u32 crc : 1;                             // DWORD 2
         u32 event : 1;                           // DWORD 2
         u32 complete : 1;                        // DWORD 2
         u32 vlan_tag : 16;                       // DWORD 3
         u32 len : 16;                            // DWORD 3
      } SG_PACK BE2_ETH_HDR_WRB, *PBE2_ETH_HDR_WRB;

      typedef union _BE2_ETH_HDR_WRB_UNION {
         BE2_ETH_HDR_WRB bits;
         u32 dw[4]; // dword union
      } SG_PACK BE2_ETH_HDR_WRB_UNION, *PBE2_ETH_HDR_WRB_UNION;

      SG_C_ASSERT(__sizeof__BE2_ETH_HDR_WRB_UNION, sizeof (BE2_ETH_HDR_WRB_UNION) == 16);
   #endif


#else
   // Work request block that the driver issues to the chip for Ethernet transmissions.
   // All control fields must be valid in each WRB for a message. The controller, as
   // specified by the flags, optionally writes an entry to the Completion Ring and
   // generate an event. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_ETH_HDR_WRB {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1 : 18;                    // DWORD 1
               u32 last_seg_udp_len : 14;         // DWORD 1
               u32 complete : 1;                  // DWORD 2
               u32 event : 1;                     // DWORD 2
               u32 crc : 1;                       // DWORD 2
               u32 forward : 1;                   // DWORD 2
               u32 ipv6_lso : 1;                  // DWORD 2
               u32 mgmt : 1;                      // DWORD 2
               u32 ipcs : 1;                      // DWORD 2
               u32 udpcs : 1;                     // DWORD 2
               u32 tcpcs : 1;                     // DWORD 2
               u32 lso : 1;                       // DWORD 2
               u32 vlan : 1;                      // DWORD 2
               u32 gso : 2;                       // DWORD 2
               u32 num_wrb : 5;                   // DWORD 2
               u32 lso_mss : 14;                  // DWORD 2
               u32 len : 16;                      // DWORD 3
               u32 vlan_tag : 16;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE2_ETH_HDR_WRB, *PBE2_ETH_HDR_WRB;

      SG_C_ASSERT(__sizeof__BE2_ETH_HDR_WRB, sizeof (BE2_ETH_HDR_WRB) == 16);

   #else
      typedef struct _BE2_ETH_HDR_WRB {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1 : 18;                          // DWORD 1
         u32 last_seg_udp_len : 14;               // DWORD 1
         u32 complete : 1;                        // DWORD 2
         u32 event : 1;                           // DWORD 2
         u32 crc : 1;                             // DWORD 2
         u32 forward : 1;                         // DWORD 2
         u32 ipv6_lso : 1;                        // DWORD 2
         u32 mgmt : 1;                            // DWORD 2
         u32 ipcs : 1;                            // DWORD 2
         u32 udpcs : 1;                           // DWORD 2
         u32 tcpcs : 1;                           // DWORD 2
         u32 lso : 1;                             // DWORD 2
         u32 vlan : 1;                            // DWORD 2
         u32 gso : 2;                             // DWORD 2
         u32 num_wrb : 5;                         // DWORD 2
         u32 lso_mss : 14;                        // DWORD 2
         u32 len : 16;                            // DWORD 3
         u32 vlan_tag : 16;                       // DWORD 3
      } SG_PACK BE2_ETH_HDR_WRB, *PBE2_ETH_HDR_WRB;

      typedef union _BE2_ETH_HDR_WRB_UNION {
         BE2_ETH_HDR_WRB bits;
         u32 dw[4]; // dword union
      } SG_PACK BE2_ETH_HDR_WRB_UNION, *PBE2_ETH_HDR_WRB_UNION;

      SG_C_ASSERT(__sizeof__BE2_ETH_HDR_WRB_UNION, sizeof (BE2_ETH_HDR_WRB_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Work request block that the driver issues to the chip for Ethernet transmissions.
   // All control fields must be valid in each WRB for a message. The controller, as
   // specified by the flags, optionally writes an entry to the Completion Ring and
   // generate an event. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_ETH_WRB {
         union {
            struct { 
               u32 frag_pa_hi;                    // DWORD 0
               u32 frag_pa_lo;                    // DWORD 1
               u32 rsvd0[1];                      // DWORDS 2 to 2
               u32 ddr : 1;                       // DWORD 3
               u32 rsvd1 : 15;                    // DWORD 3
               u32 frag_len : 16;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE2_ETH_WRB, *PBE2_ETH_WRB;

      SG_C_ASSERT(__sizeof__BE2_ETH_WRB, sizeof (BE2_ETH_WRB) == 16);

   #else
      typedef struct _BE2_ETH_WRB {
         u32 frag_pa_hi;                          // DWORD 0
         u32 frag_pa_lo;                          // DWORD 1
         u32 rsvd0[1];                            // DWORDS 2 to 2
         u32 ddr : 1;                             // DWORD 3
         u32 rsvd1 : 15;                          // DWORD 3
         u32 frag_len : 16;                       // DWORD 3
      } SG_PACK BE2_ETH_WRB, *PBE2_ETH_WRB;

      typedef union _BE2_ETH_WRB_UNION {
         BE2_ETH_WRB bits;
         u32 dw[4]; // dword union
      } SG_PACK BE2_ETH_WRB_UNION, *PBE2_ETH_WRB_UNION;

      SG_C_ASSERT(__sizeof__BE2_ETH_WRB_UNION, sizeof (BE2_ETH_WRB_UNION) == 16);
   #endif


#else
   // Work request block that the driver issues to the chip for Ethernet transmissions.
   // All control fields must be valid in each WRB for a message. The controller, as
   // specified by the flags, optionally writes an entry to the Completion Ring and
   // generate an event. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_ETH_WRB {
         union {
            struct { 
               u32 frag_pa_hi;                    // DWORD 0
               u32 frag_pa_lo;                    // DWORD 1
               u32 rsvd0[1];                      // DWORDS 2 to 2
               u32 frag_len : 16;                 // DWORD 3
               u32 rsvd1 : 15;                    // DWORD 3
               u32 ddr : 1;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE2_ETH_WRB, *PBE2_ETH_WRB;

      SG_C_ASSERT(__sizeof__BE2_ETH_WRB, sizeof (BE2_ETH_WRB) == 16);

   #else
      typedef struct _BE2_ETH_WRB {
         u32 frag_pa_hi;                          // DWORD 0
         u32 frag_pa_lo;                          // DWORD 1
         u32 rsvd0[1];                            // DWORDS 2 to 2
         u32 frag_len : 16;                       // DWORD 3
         u32 rsvd1 : 15;                          // DWORD 3
         u32 ddr : 1;                             // DWORD 3
      } SG_PACK BE2_ETH_WRB, *PBE2_ETH_WRB;

      typedef union _BE2_ETH_WRB_UNION {
         BE2_ETH_WRB bits;
         u32 dw[4]; // dword union
      } SG_PACK BE2_ETH_WRB_UNION, *PBE2_ETH_WRB_UNION;

      SG_C_ASSERT(__sizeof__BE2_ETH_WRB_UNION, sizeof (BE2_ETH_WRB_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // REMOVE REMOVE REMOVE THIS DOES NOT BELONG HERE. MOVE TO SOFTWARE AREA TOE WRBs are
   // created by the driver in send rings. A WRB is a 16B structure as defined below. The
   // number of TOE Work Request Blocks for a message depends on the message size. The
   // driver divides a message into multiple WRBs. The message's last WRB has the last
   // flag bit set. The message completes when the last byte is transmitted. The
   // controller, as specified by the flags, optionally writes an entry to the Completion
   // Ring and generate an event. All control fields must be valid in each WRB for a
   // message. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TOE_WRB {
         union {
            struct { 
               u32 frag_addr_hi;                  // DWORD 0
               u32 frag_addr_lo;                  // DWORD 1
               u32 rsvd0 : 1;                     // DWORD 2
               u32 idx : 14;                      // DWORD 2
               u32 cid : 11;                      // DWORD 2
               u32 nodelay : 1;                   // DWORD 2
               u32 jrnl_last : 1;                 // DWORD 2
               u32 jrnl_only : 1;                 // DWORD 2
               u32 push : 1;                      // DWORD 2
               u32 fin : 1;                       // DWORD 2
               u32 complete : 1;                  // DWORD 2
               u32 ddr : 1;                       // DWORD 3
               u32 rsvd1 : 10;                    // DWORD 3
               u32 frag_len : 21;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TOE_WRB, *PBE2_TOE_WRB;

      SG_C_ASSERT(__sizeof__BE2_TOE_WRB, sizeof (BE2_TOE_WRB) == 16);

   #else
      typedef struct _BE2_TOE_WRB {
         u32 frag_addr_hi;                        // DWORD 0
         u32 frag_addr_lo;                        // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 2
         u32 idx : 14;                            // DWORD 2
         u32 cid : 11;                            // DWORD 2
         u32 nodelay : 1;                         // DWORD 2
         u32 jrnl_last : 1;                       // DWORD 2
         u32 jrnl_only : 1;                       // DWORD 2
         u32 push : 1;                            // DWORD 2
         u32 fin : 1;                             // DWORD 2
         u32 complete : 1;                        // DWORD 2
         u32 ddr : 1;                             // DWORD 3
         u32 rsvd1 : 10;                          // DWORD 3
         u32 frag_len : 21;                       // DWORD 3
      } SG_PACK BE2_TOE_WRB, *PBE2_TOE_WRB;

      typedef union _BE2_TOE_WRB_UNION {
         BE2_TOE_WRB bits;
         u32 dw[4]; // dword union
      } SG_PACK BE2_TOE_WRB_UNION, *PBE2_TOE_WRB_UNION;

      SG_C_ASSERT(__sizeof__BE2_TOE_WRB_UNION, sizeof (BE2_TOE_WRB_UNION) == 16);
   #endif


#else
   // REMOVE REMOVE REMOVE THIS DOES NOT BELONG HERE. MOVE TO SOFTWARE AREA TOE WRBs are
   // created by the driver in send rings. A WRB is a 16B structure as defined below. The
   // number of TOE Work Request Blocks for a message depends on the message size. The
   // driver divides a message into multiple WRBs. The message's last WRB has the last
   // flag bit set. The message completes when the last byte is transmitted. The
   // controller, as specified by the flags, optionally writes an entry to the Completion
   // Ring and generate an event. All control fields must be valid in each WRB for a
   // message. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TOE_WRB {
         union {
            struct { 
               u32 frag_addr_hi;                  // DWORD 0
               u32 frag_addr_lo;                  // DWORD 1
               u32 complete : 1;                  // DWORD 2
               u32 fin : 1;                       // DWORD 2
               u32 push : 1;                      // DWORD 2
               u32 jrnl_only : 1;                 // DWORD 2
               u32 jrnl_last : 1;                 // DWORD 2
               u32 nodelay : 1;                   // DWORD 2
               u32 cid : 11;                      // DWORD 2
               u32 idx : 14;                      // DWORD 2
               u32 rsvd0 : 1;                     // DWORD 2
               u32 frag_len : 21;                 // DWORD 3
               u32 rsvd1 : 10;                    // DWORD 3
               u32 ddr : 1;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TOE_WRB, *PBE2_TOE_WRB;

      SG_C_ASSERT(__sizeof__BE2_TOE_WRB, sizeof (BE2_TOE_WRB) == 16);

   #else
      typedef struct _BE2_TOE_WRB {
         u32 frag_addr_hi;                        // DWORD 0
         u32 frag_addr_lo;                        // DWORD 1
         u32 complete : 1;                        // DWORD 2
         u32 fin : 1;                             // DWORD 2
         u32 push : 1;                            // DWORD 2
         u32 jrnl_only : 1;                       // DWORD 2
         u32 jrnl_last : 1;                       // DWORD 2
         u32 nodelay : 1;                         // DWORD 2
         u32 cid : 11;                            // DWORD 2
         u32 idx : 14;                            // DWORD 2
         u32 rsvd0 : 1;                           // DWORD 2
         u32 frag_len : 21;                       // DWORD 3
         u32 rsvd1 : 10;                          // DWORD 3
         u32 ddr : 1;                             // DWORD 3
      } SG_PACK BE2_TOE_WRB, *PBE2_TOE_WRB;

      typedef union _BE2_TOE_WRB_UNION {
         BE2_TOE_WRB bits;
         u32 dw[4]; // dword union
      } SG_PACK BE2_TOE_WRB_UNION, *PBE2_TOE_WRB_UNION;

      SG_C_ASSERT(__sizeof__BE2_TOE_WRB_UNION, sizeof (BE2_TOE_WRB_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data/Descriptor for TxULP Input Queue from TCP scheduler; 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_RRMSG_DESC {
         union {
            struct { 
               u32 rrmsg_data0;                   // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 1
               u32 RRMsg : 1;                     // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 cid : 11;                      // DWORD 1
               u32 rrmsg_data1;                   // DWORD 2
               u32 rsvd2[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE2_RRMSG_DESC, *PBE2_RRMSG_DESC;

      SG_C_ASSERT(__sizeof__BE2_RRMSG_DESC, sizeof (BE2_RRMSG_DESC) == 16);

   #else
      typedef struct _BE2_RRMSG_DESC {
         u32 rrmsg_data0;                         // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 1
         u32 RRMsg : 1;                           // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 cid : 11;                            // DWORD 1
         u32 rrmsg_data1;                         // DWORD 2
         u32 rsvd2[1];                            // DWORDS 3 to 3
      } SG_PACK BE2_RRMSG_DESC, *PBE2_RRMSG_DESC;

      typedef union _BE2_RRMSG_DESC_UNION {
         BE2_RRMSG_DESC bits;
         u32 dw[4]; // dword union
      } SG_PACK BE2_RRMSG_DESC_UNION, *PBE2_RRMSG_DESC_UNION;

      SG_C_ASSERT(__sizeof__BE2_RRMSG_DESC_UNION, sizeof (BE2_RRMSG_DESC_UNION) == 16);
   #endif


#else
   // Data/Descriptor for TxULP Input Queue from TCP scheduler; 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_RRMSG_DESC {
         union {
            struct { 
               u32 rrmsg_data0;                   // DWORD 0
               u32 cid : 11;                      // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 RRMsg : 1;                     // DWORD 1
               u32 rsvd1 : 15;                    // DWORD 1
               u32 rrmsg_data1;                   // DWORD 2
               u32 rsvd2[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE2_RRMSG_DESC, *PBE2_RRMSG_DESC;

      SG_C_ASSERT(__sizeof__BE2_RRMSG_DESC, sizeof (BE2_RRMSG_DESC) == 16);

   #else
      typedef struct _BE2_RRMSG_DESC {
         u32 rrmsg_data0;                         // DWORD 0
         u32 cid : 11;                            // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 RRMsg : 1;                           // DWORD 1
         u32 rsvd1 : 15;                          // DWORD 1
         u32 rrmsg_data1;                         // DWORD 2
         u32 rsvd2[1];                            // DWORDS 3 to 3
      } SG_PACK BE2_RRMSG_DESC, *PBE2_RRMSG_DESC;

      typedef union _BE2_RRMSG_DESC_UNION {
         BE2_RRMSG_DESC bits;
         u32 dw[4]; // dword union
      } SG_PACK BE2_RRMSG_DESC_UNION, *PBE2_RRMSG_DESC_UNION;

      SG_C_ASSERT(__sizeof__BE2_RRMSG_DESC_UNION, sizeof (BE2_RRMSG_DESC_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This documents the raw ethernet descriptor for BE2 with no WRB load. No QOS check is
   // done for this descriptor. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_ETH_TYPE1_DESC {
         union {
            struct { 
               u32 grant_len;                     // DWORD 0
               u32 gp_predicates : 5;             // DWORD 1
               u32 mark_color : 2;                // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 win_probe : 1;                 // DWORD 1
               u32 alltcpacks : 1;                // DWORD 1
               u32 notcp : 1;                     // DWORD 1
               u32 chipRequest : 1;               // DWORD 1
               u32 driverRequest : 1;             // DWORD 1
               u32 retransmit : 1;                // DWORD 1
               u32 RRMsg : 1;                     // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 cid : 11;                      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK BE2_ETH_TYPE1_DESC, *PBE2_ETH_TYPE1_DESC;

      SG_C_ASSERT(__sizeof__BE2_ETH_TYPE1_DESC, sizeof (BE2_ETH_TYPE1_DESC) == 8);

   #else
      typedef struct _BE2_ETH_TYPE1_DESC {
         u32 grant_len;                           // DWORD 0
         u32 gp_predicates : 5;                   // DWORD 1
         u32 mark_color : 2;                      // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 win_probe : 1;                       // DWORD 1
         u32 alltcpacks : 1;                      // DWORD 1
         u32 notcp : 1;                           // DWORD 1
         u32 chipRequest : 1;                     // DWORD 1
         u32 driverRequest : 1;                   // DWORD 1
         u32 retransmit : 1;                      // DWORD 1
         u32 RRMsg : 1;                           // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 cid : 11;                            // DWORD 1
      } SG_PACK BE2_ETH_TYPE1_DESC, *PBE2_ETH_TYPE1_DESC;

      typedef union _BE2_ETH_TYPE1_DESC_UNION {
         BE2_ETH_TYPE1_DESC bits;
         u32 dw[2]; // dword union
      } SG_PACK BE2_ETH_TYPE1_DESC_UNION, *PBE2_ETH_TYPE1_DESC_UNION;

      SG_C_ASSERT(__sizeof__BE2_ETH_TYPE1_DESC_UNION, sizeof (BE2_ETH_TYPE1_DESC_UNION) == 8);
   #endif


#else
   // This documents the raw ethernet descriptor for BE2 with no WRB load. No QOS check is
   // done for this descriptor. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_ETH_TYPE1_DESC {
         union {
            struct { 
               u32 grant_len;                     // DWORD 0
               u32 cid : 11;                      // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 RRMsg : 1;                     // DWORD 1
               u32 retransmit : 1;                // DWORD 1
               u32 driverRequest : 1;             // DWORD 1
               u32 chipRequest : 1;               // DWORD 1
               u32 notcp : 1;                     // DWORD 1
               u32 alltcpacks : 1;                // DWORD 1
               u32 win_probe : 1;                 // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 mark_color : 2;                // DWORD 1
               u32 gp_predicates : 5;             // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK BE2_ETH_TYPE1_DESC, *PBE2_ETH_TYPE1_DESC;

      SG_C_ASSERT(__sizeof__BE2_ETH_TYPE1_DESC, sizeof (BE2_ETH_TYPE1_DESC) == 8);

   #else
      typedef struct _BE2_ETH_TYPE1_DESC {
         u32 grant_len;                           // DWORD 0
         u32 cid : 11;                            // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 RRMsg : 1;                           // DWORD 1
         u32 retransmit : 1;                      // DWORD 1
         u32 driverRequest : 1;                   // DWORD 1
         u32 chipRequest : 1;                     // DWORD 1
         u32 notcp : 1;                           // DWORD 1
         u32 alltcpacks : 1;                      // DWORD 1
         u32 win_probe : 1;                       // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 mark_color : 2;                      // DWORD 1
         u32 gp_predicates : 5;                   // DWORD 1
      } SG_PACK BE2_ETH_TYPE1_DESC, *PBE2_ETH_TYPE1_DESC;

      typedef union _BE2_ETH_TYPE1_DESC_UNION {
         BE2_ETH_TYPE1_DESC bits;
         u32 dw[2]; // dword union
      } SG_PACK BE2_ETH_TYPE1_DESC_UNION, *PBE2_ETH_TYPE1_DESC_UNION;

      SG_C_ASSERT(__sizeof__BE2_ETH_TYPE1_DESC_UNION, sizeof (BE2_ETH_TYPE1_DESC_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This documents the raw ethernet descriptor for BE2 with WRB load. QOS check might be
   // done for this descriptor. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_ETH_TYPE2_DESC {
         union {
            struct { 
               u32 grant_len;                     // DWORD 0
               u32 gp_predicates : 5;             // DWORD 1
               u32 mark_color : 2;                // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 win_probe : 1;                 // DWORD 1
               u32 alltcpacks : 1;                // DWORD 1
               u32 notcp : 1;                     // DWORD 1
               u32 chipRequest : 1;               // DWORD 1
               u32 driverRequest : 1;             // DWORD 1
               u32 retransmit : 1;                // DWORD 1
               u32 RRMsg : 1;                     // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 cid : 11;                      // DWORD 1
               u32 num_segs : 3;                  // DWORD 2
               u32 nwh_size : 4;                  // DWORD 2
               u32 parse_hdrs : 3;                // DWORD 2
               u32 rsvd2 : 22;                    // DWORD 2
               u32 rsvd3 : 21;                    // DWORD 3
               u32 txd_cid : 11;                  // DWORD 3
               u32 rsvd4 : 10;                    // DWORD 4
               u32 sa_index : 6;                  // DWORD 4
               u32 wrb_index : 16;                // DWORD 4
               u32 rsvd5 : 11;                    // DWORD 5
               u32 num_wrb : 5;                   // DWORD 5
               u32 wrb_ctx_addr : 16;             // DWORD 5
               u32 rsvd7 : 2;                     // DWORD 6
               u32 mss : 14;                      // DWORD 6
               u32 shadow_ring_size : 8;          // DWORD 6
               u32 rsvd6 : 8;                     // DWORD 6
               u32 rsvd10 : 15;                   // DWORD 7
               u32 gso : 2;                       // DWORD 7
               u32 rsvd9 : 1;                     // DWORD 7
               u32 discard_pu_pbuf : 1;           // DWORD 7
               u32 drop_txd : 1;                  // DWORD 7
               u32 rsvd8 : 3;                     // DWORD 7
               u32 tcpcs : 1;                     // DWORD 7
               u32 udpcs : 1;                     // DWORD 7
               u32 ipcs : 1;                      // DWORD 7
               u32 mgmt : 1;                      // DWORD 7
               u32 ipv6_lso : 1;                  // DWORD 7
               u32 forward : 1;                   // DWORD 7
               u32 crc : 1;                       // DWORD 7
               u32 event : 1;                     // DWORD 7
               u32 complete : 1;                  // DWORD 7
               u32 sch_credit : 1;                // DWORD 8
               u32 rsvd12 : 13;                   // DWORD 8
               u32 vlan : 1;                      // DWORD 8
               u32 lso : 1;                       // DWORD 8
               u32 rsvd11 : 16;                   // DWORD 8
               u32 vlan_tag : 16;                 // DWORD 9
               u32 len : 16;                      // DWORD 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK BE2_ETH_TYPE2_DESC, *PBE2_ETH_TYPE2_DESC;

      SG_C_ASSERT(__sizeof__BE2_ETH_TYPE2_DESC, sizeof (BE2_ETH_TYPE2_DESC) == 40);

   #else
      typedef struct _BE2_ETH_TYPE2_DESC {
         u32 grant_len;                           // DWORD 0
         u32 gp_predicates : 5;                   // DWORD 1
         u32 mark_color : 2;                      // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 win_probe : 1;                       // DWORD 1
         u32 alltcpacks : 1;                      // DWORD 1
         u32 notcp : 1;                           // DWORD 1
         u32 chipRequest : 1;                     // DWORD 1
         u32 driverRequest : 1;                   // DWORD 1
         u32 retransmit : 1;                      // DWORD 1
         u32 RRMsg : 1;                           // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 cid : 11;                            // DWORD 1
         u32 num_segs : 3;                        // DWORD 2
         u32 nwh_size : 4;                        // DWORD 2
         u32 parse_hdrs : 3;                      // DWORD 2
         u32 rsvd2 : 22;                          // DWORD 2
         u32 rsvd3 : 21;                          // DWORD 3
         u32 txd_cid : 11;                        // DWORD 3
         u32 rsvd4 : 10;                          // DWORD 4
         u32 sa_index : 6;                        // DWORD 4
         u32 wrb_index : 16;                      // DWORD 4
         u32 rsvd5 : 11;                          // DWORD 5
         u32 num_wrb : 5;                         // DWORD 5
         u32 wrb_ctx_addr : 16;                   // DWORD 5
         u32 rsvd7 : 2;                           // DWORD 6
         u32 mss : 14;                            // DWORD 6
         u32 shadow_ring_size : 8;                // DWORD 6
         u32 rsvd6 : 8;                           // DWORD 6
         u32 rsvd10 : 15;                         // DWORD 7
         u32 gso : 2;                             // DWORD 7
         u32 rsvd9 : 1;                           // DWORD 7
         u32 discard_pu_pbuf : 1;                 // DWORD 7
         u32 drop_txd : 1;                        // DWORD 7
         u32 rsvd8 : 3;                           // DWORD 7
         u32 tcpcs : 1;                           // DWORD 7
         u32 udpcs : 1;                           // DWORD 7
         u32 ipcs : 1;                            // DWORD 7
         u32 mgmt : 1;                            // DWORD 7
         u32 ipv6_lso : 1;                        // DWORD 7
         u32 forward : 1;                         // DWORD 7
         u32 crc : 1;                             // DWORD 7
         u32 event : 1;                           // DWORD 7
         u32 complete : 1;                        // DWORD 7
         u32 sch_credit : 1;                      // DWORD 8
         u32 rsvd12 : 13;                         // DWORD 8
         u32 vlan : 1;                            // DWORD 8
         u32 lso : 1;                             // DWORD 8
         u32 rsvd11 : 16;                         // DWORD 8
         u32 vlan_tag : 16;                       // DWORD 9
         u32 len : 16;                            // DWORD 9
      } SG_PACK BE2_ETH_TYPE2_DESC, *PBE2_ETH_TYPE2_DESC;

      typedef union _BE2_ETH_TYPE2_DESC_UNION {
         BE2_ETH_TYPE2_DESC bits;
         u32 dw[10]; // dword union
      } SG_PACK BE2_ETH_TYPE2_DESC_UNION, *PBE2_ETH_TYPE2_DESC_UNION;

      SG_C_ASSERT(__sizeof__BE2_ETH_TYPE2_DESC_UNION, sizeof (BE2_ETH_TYPE2_DESC_UNION) == 40);
   #endif


#else
   // This documents the raw ethernet descriptor for BE2 with WRB load. QOS check might be
   // done for this descriptor. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_ETH_TYPE2_DESC {
         union {
            struct { 
               u32 grant_len;                     // DWORD 0
               u32 cid : 11;                      // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 RRMsg : 1;                     // DWORD 1
               u32 retransmit : 1;                // DWORD 1
               u32 driverRequest : 1;             // DWORD 1
               u32 chipRequest : 1;               // DWORD 1
               u32 notcp : 1;                     // DWORD 1
               u32 alltcpacks : 1;                // DWORD 1
               u32 win_probe : 1;                 // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 mark_color : 2;                // DWORD 1
               u32 gp_predicates : 5;             // DWORD 1
               u32 rsvd2 : 22;                    // DWORD 2
               u32 parse_hdrs : 3;                // DWORD 2
               u32 nwh_size : 4;                  // DWORD 2
               u32 num_segs : 3;                  // DWORD 2
               u32 txd_cid : 11;                  // DWORD 3
               u32 rsvd3 : 21;                    // DWORD 3
               u32 wrb_index : 16;                // DWORD 4
               u32 sa_index : 6;                  // DWORD 4
               u32 rsvd4 : 10;                    // DWORD 4
               u32 wrb_ctx_addr : 16;             // DWORD 5
               u32 num_wrb : 5;                   // DWORD 5
               u32 rsvd5 : 11;                    // DWORD 5
               u32 rsvd6 : 8;                     // DWORD 6
               u32 shadow_ring_size : 8;          // DWORD 6
               u32 mss : 14;                      // DWORD 6
               u32 rsvd7 : 2;                     // DWORD 6
               u32 complete : 1;                  // DWORD 7
               u32 event : 1;                     // DWORD 7
               u32 crc : 1;                       // DWORD 7
               u32 forward : 1;                   // DWORD 7
               u32 ipv6_lso : 1;                  // DWORD 7
               u32 mgmt : 1;                      // DWORD 7
               u32 ipcs : 1;                      // DWORD 7
               u32 udpcs : 1;                     // DWORD 7
               u32 tcpcs : 1;                     // DWORD 7
               u32 rsvd8 : 3;                     // DWORD 7
               u32 drop_txd : 1;                  // DWORD 7
               u32 discard_pu_pbuf : 1;           // DWORD 7
               u32 rsvd9 : 1;                     // DWORD 7
               u32 gso : 2;                       // DWORD 7
               u32 rsvd10 : 15;                   // DWORD 7
               u32 rsvd11 : 16;                   // DWORD 8
               u32 lso : 1;                       // DWORD 8
               u32 vlan : 1;                      // DWORD 8
               u32 rsvd12 : 13;                   // DWORD 8
               u32 sch_credit : 1;                // DWORD 8
               u32 len : 16;                      // DWORD 9
               u32 vlan_tag : 16;                 // DWORD 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK BE2_ETH_TYPE2_DESC, *PBE2_ETH_TYPE2_DESC;

      SG_C_ASSERT(__sizeof__BE2_ETH_TYPE2_DESC, sizeof (BE2_ETH_TYPE2_DESC) == 40);

   #else
      typedef struct _BE2_ETH_TYPE2_DESC {
         u32 grant_len;                           // DWORD 0
         u32 cid : 11;                            // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 RRMsg : 1;                           // DWORD 1
         u32 retransmit : 1;                      // DWORD 1
         u32 driverRequest : 1;                   // DWORD 1
         u32 chipRequest : 1;                     // DWORD 1
         u32 notcp : 1;                           // DWORD 1
         u32 alltcpacks : 1;                      // DWORD 1
         u32 win_probe : 1;                       // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 mark_color : 2;                      // DWORD 1
         u32 gp_predicates : 5;                   // DWORD 1
         u32 rsvd2 : 22;                          // DWORD 2
         u32 parse_hdrs : 3;                      // DWORD 2
         u32 nwh_size : 4;                        // DWORD 2
         u32 num_segs : 3;                        // DWORD 2
         u32 txd_cid : 11;                        // DWORD 3
         u32 rsvd3 : 21;                          // DWORD 3
         u32 wrb_index : 16;                      // DWORD 4
         u32 sa_index : 6;                        // DWORD 4
         u32 rsvd4 : 10;                          // DWORD 4
         u32 wrb_ctx_addr : 16;                   // DWORD 5
         u32 num_wrb : 5;                         // DWORD 5
         u32 rsvd5 : 11;                          // DWORD 5
         u32 rsvd6 : 8;                           // DWORD 6
         u32 shadow_ring_size : 8;                // DWORD 6
         u32 mss : 14;                            // DWORD 6
         u32 rsvd7 : 2;                           // DWORD 6
         u32 complete : 1;                        // DWORD 7
         u32 event : 1;                           // DWORD 7
         u32 crc : 1;                             // DWORD 7
         u32 forward : 1;                         // DWORD 7
         u32 ipv6_lso : 1;                        // DWORD 7
         u32 mgmt : 1;                            // DWORD 7
         u32 ipcs : 1;                            // DWORD 7
         u32 udpcs : 1;                           // DWORD 7
         u32 tcpcs : 1;                           // DWORD 7
         u32 rsvd8 : 3;                           // DWORD 7
         u32 drop_txd : 1;                        // DWORD 7
         u32 discard_pu_pbuf : 1;                 // DWORD 7
         u32 rsvd9 : 1;                           // DWORD 7
         u32 gso : 2;                             // DWORD 7
         u32 rsvd10 : 15;                         // DWORD 7
         u32 rsvd11 : 16;                         // DWORD 8
         u32 lso : 1;                             // DWORD 8
         u32 vlan : 1;                            // DWORD 8
         u32 rsvd12 : 13;                         // DWORD 8
         u32 sch_credit : 1;                      // DWORD 8
         u32 len : 16;                            // DWORD 9
         u32 vlan_tag : 16;                       // DWORD 9
      } SG_PACK BE2_ETH_TYPE2_DESC, *PBE2_ETH_TYPE2_DESC;

      typedef union _BE2_ETH_TYPE2_DESC_UNION {
         BE2_ETH_TYPE2_DESC bits;
         u32 dw[10]; // dword union
      } SG_PACK BE2_ETH_TYPE2_DESC_UNION, *PBE2_ETH_TYPE2_DESC_UNION;

      SG_C_ASSERT(__sizeof__BE2_ETH_TYPE2_DESC_UNION, sizeof (BE2_ETH_TYPE2_DESC_UNION) == 40);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data/Descriptor for TxULP Input Queue from TCP scheduler with no WRB load. QOS check
   // might be done for this descriptor. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TOE_TYPE1_DESC {
         union {
            struct { 
               u32 grant_len;                     // DWORD 0
               u32 gp_predicates : 5;             // DWORD 1
               u32 mark_color : 2;                // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 win_probe : 1;                 // DWORD 1
               u32 alltcpacks : 1;                // DWORD 1
               u32 notcp : 1;                     // DWORD 1
               u32 chipRequest : 1;               // DWORD 1
               u32 driverRequest : 1;             // DWORD 1
               u32 retransmit : 1;                // DWORD 1
               u32 RRMsg : 1;                     // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 cid : 11;                      // DWORD 1
               u32 snd_max;                       // DWORD 2
               u32 snd_nxt;                       // DWORD 3
               u32 t_rxtshift : 4;                // DWORD 4
               u32 rsvd2 : 9;                     // DWORD 4
               u32 t_flags : 11;                  // DWORD 4
               u32 t_state : 8;                   // DWORD 4
               u32 last_ack_sent;                 // DWORD 5
               u32 snd_una;                       // DWORD 6
               u32 rx_flags : 8;                  // DWORD 7
               u32 rx_state : 4;                  // DWORD 7
               u32 t_dupacks2 : 2;                // DWORD 7
               u32 port_id : 2;                   // DWORD 7
               u32 t_maxseg : 16;                 // DWORD 7
               u32 snd_cwnd;                      // DWORD 8
               u32 snd_last;                      // DWORD 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TOE_TYPE1_DESC, *PBE2_TOE_TYPE1_DESC;

      SG_C_ASSERT(__sizeof__BE2_TOE_TYPE1_DESC, sizeof (BE2_TOE_TYPE1_DESC) == 40);

   #else
      typedef struct _BE2_TOE_TYPE1_DESC {
         u32 grant_len;                           // DWORD 0
         u32 gp_predicates : 5;                   // DWORD 1
         u32 mark_color : 2;                      // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 win_probe : 1;                       // DWORD 1
         u32 alltcpacks : 1;                      // DWORD 1
         u32 notcp : 1;                           // DWORD 1
         u32 chipRequest : 1;                     // DWORD 1
         u32 driverRequest : 1;                   // DWORD 1
         u32 retransmit : 1;                      // DWORD 1
         u32 RRMsg : 1;                           // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 cid : 11;                            // DWORD 1
         u32 snd_max;                             // DWORD 2
         u32 snd_nxt;                             // DWORD 3
         u32 t_rxtshift : 4;                      // DWORD 4
         u32 rsvd2 : 9;                           // DWORD 4
         u32 t_flags : 11;                        // DWORD 4
         u32 t_state : 8;                         // DWORD 4
         u32 last_ack_sent;                       // DWORD 5
         u32 snd_una;                             // DWORD 6
         u32 rx_flags : 8;                        // DWORD 7
         u32 rx_state : 4;                        // DWORD 7
         u32 t_dupacks2 : 2;                      // DWORD 7
         u32 port_id : 2;                         // DWORD 7
         u32 t_maxseg : 16;                       // DWORD 7
         u32 snd_cwnd;                            // DWORD 8
         u32 snd_last;                            // DWORD 9
      } SG_PACK BE2_TOE_TYPE1_DESC, *PBE2_TOE_TYPE1_DESC;

      typedef union _BE2_TOE_TYPE1_DESC_UNION {
         BE2_TOE_TYPE1_DESC bits;
         u32 dw[10]; // dword union
      } SG_PACK BE2_TOE_TYPE1_DESC_UNION, *PBE2_TOE_TYPE1_DESC_UNION;

      SG_C_ASSERT(__sizeof__BE2_TOE_TYPE1_DESC_UNION, sizeof (BE2_TOE_TYPE1_DESC_UNION) == 40);
   #endif


#else
   // Data/Descriptor for TxULP Input Queue from TCP scheduler with no WRB load. QOS check
   // might be done for this descriptor. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TOE_TYPE1_DESC {
         union {
            struct { 
               u32 grant_len;                     // DWORD 0
               u32 cid : 11;                      // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 RRMsg : 1;                     // DWORD 1
               u32 retransmit : 1;                // DWORD 1
               u32 driverRequest : 1;             // DWORD 1
               u32 chipRequest : 1;               // DWORD 1
               u32 notcp : 1;                     // DWORD 1
               u32 alltcpacks : 1;                // DWORD 1
               u32 win_probe : 1;                 // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 mark_color : 2;                // DWORD 1
               u32 gp_predicates : 5;             // DWORD 1
               u32 snd_max;                       // DWORD 2
               u32 snd_nxt;                       // DWORD 3
               u32 t_state : 8;                   // DWORD 4
               u32 t_flags : 11;                  // DWORD 4
               u32 rsvd2 : 9;                     // DWORD 4
               u32 t_rxtshift : 4;                // DWORD 4
               u32 last_ack_sent;                 // DWORD 5
               u32 snd_una;                       // DWORD 6
               u32 t_maxseg : 16;                 // DWORD 7
               u32 port_id : 2;                   // DWORD 7
               u32 t_dupacks2 : 2;                // DWORD 7
               u32 rx_state : 4;                  // DWORD 7
               u32 rx_flags : 8;                  // DWORD 7
               u32 snd_cwnd;                      // DWORD 8
               u32 snd_last;                      // DWORD 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TOE_TYPE1_DESC, *PBE2_TOE_TYPE1_DESC;

      SG_C_ASSERT(__sizeof__BE2_TOE_TYPE1_DESC, sizeof (BE2_TOE_TYPE1_DESC) == 40);

   #else
      typedef struct _BE2_TOE_TYPE1_DESC {
         u32 grant_len;                           // DWORD 0
         u32 cid : 11;                            // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 RRMsg : 1;                           // DWORD 1
         u32 retransmit : 1;                      // DWORD 1
         u32 driverRequest : 1;                   // DWORD 1
         u32 chipRequest : 1;                     // DWORD 1
         u32 notcp : 1;                           // DWORD 1
         u32 alltcpacks : 1;                      // DWORD 1
         u32 win_probe : 1;                       // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 mark_color : 2;                      // DWORD 1
         u32 gp_predicates : 5;                   // DWORD 1
         u32 snd_max;                             // DWORD 2
         u32 snd_nxt;                             // DWORD 3
         u32 t_state : 8;                         // DWORD 4
         u32 t_flags : 11;                        // DWORD 4
         u32 rsvd2 : 9;                           // DWORD 4
         u32 t_rxtshift : 4;                      // DWORD 4
         u32 last_ack_sent;                       // DWORD 5
         u32 snd_una;                             // DWORD 6
         u32 t_maxseg : 16;                       // DWORD 7
         u32 port_id : 2;                         // DWORD 7
         u32 t_dupacks2 : 2;                      // DWORD 7
         u32 rx_state : 4;                        // DWORD 7
         u32 rx_flags : 8;                        // DWORD 7
         u32 snd_cwnd;                            // DWORD 8
         u32 snd_last;                            // DWORD 9
      } SG_PACK BE2_TOE_TYPE1_DESC, *PBE2_TOE_TYPE1_DESC;

      typedef union _BE2_TOE_TYPE1_DESC_UNION {
         BE2_TOE_TYPE1_DESC bits;
         u32 dw[10]; // dword union
      } SG_PACK BE2_TOE_TYPE1_DESC_UNION, *PBE2_TOE_TYPE1_DESC_UNION;

      SG_C_ASSERT(__sizeof__BE2_TOE_TYPE1_DESC_UNION, sizeof (BE2_TOE_TYPE1_DESC_UNION) == 40);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data/Descriptor for TxULP Input Queue from TCP scheduler with WRB load. QOS check
   // might be done for this descriptor. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TOE_TYPE2_DESC {
         union {
            struct { 
               u32 grant_len;                     // DWORD 0
               u32 gp_predicates : 5;             // DWORD 1
               u32 mark_color : 2;                // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 win_probe : 1;                 // DWORD 1
               u32 alltcpacks : 1;                // DWORD 1
               u32 notcp : 1;                     // DWORD 1
               u32 chipRequest : 1;               // DWORD 1
               u32 driverRequest : 1;             // DWORD 1
               u32 retransmit : 1;                // DWORD 1
               u32 RRMsg : 1;                     // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 cid : 11;                      // DWORD 1
               u32 snd_max;                       // DWORD 2
               u32 snd_nxt;                       // DWORD 3
               u32 t_rxtshift : 4;                // DWORD 4
               u32 rsvd2 : 9;                     // DWORD 4
               u32 t_flags : 11;                  // DWORD 4
               u32 t_state : 8;                   // DWORD 4
               u32 last_ack_sent;                 // DWORD 5
               u32 snd_una;                       // DWORD 6
               u32 rx_flags : 8;                  // DWORD 7
               u32 rx_state : 4;                  // DWORD 7
               u32 t_dupacks2 : 2;                // DWORD 7
               u32 port_id : 2;                   // DWORD 7
               u32 t_maxseg : 16;                 // DWORD 7
               u32 snd_cwnd;                      // DWORD 8
               u32 snd_last;                      // DWORD 9
               BE2_TOE_WRB toe_wrb[4];
               u32 rsvd3 : 7;                     // DWORD 26
               u32 cra : 25;                      // DWORD 26
               u32 rsvd4[1];                      // DWORDS 27 to 27
            } SG_PACK ; // unnamed struct
            u32 dw[28]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TOE_TYPE2_DESC, *PBE2_TOE_TYPE2_DESC;

      SG_C_ASSERT(__sizeof__BE2_TOE_TYPE2_DESC, sizeof (BE2_TOE_TYPE2_DESC) == 112);

   #else
      typedef struct _BE2_TOE_TYPE2_DESC {
         u32 grant_len;                           // DWORD 0
         u32 gp_predicates : 5;                   // DWORD 1
         u32 mark_color : 2;                      // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 win_probe : 1;                       // DWORD 1
         u32 alltcpacks : 1;                      // DWORD 1
         u32 notcp : 1;                           // DWORD 1
         u32 chipRequest : 1;                     // DWORD 1
         u32 driverRequest : 1;                   // DWORD 1
         u32 retransmit : 1;                      // DWORD 1
         u32 RRMsg : 1;                           // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 cid : 11;                            // DWORD 1
         u32 snd_max;                             // DWORD 2
         u32 snd_nxt;                             // DWORD 3
         u32 t_rxtshift : 4;                      // DWORD 4
         u32 rsvd2 : 9;                           // DWORD 4
         u32 t_flags : 11;                        // DWORD 4
         u32 t_state : 8;                         // DWORD 4
         u32 last_ack_sent;                       // DWORD 5
         u32 snd_una;                             // DWORD 6
         u32 rx_flags : 8;                        // DWORD 7
         u32 rx_state : 4;                        // DWORD 7
         u32 t_dupacks2 : 2;                      // DWORD 7
         u32 port_id : 2;                         // DWORD 7
         u32 t_maxseg : 16;                       // DWORD 7
         u32 snd_cwnd;                            // DWORD 8
         u32 snd_last;                            // DWORD 9
         BE2_TOE_WRB toe_wrb[4];
         u32 rsvd3 : 7;                           // DWORD 26
         u32 cra : 25;                            // DWORD 26
         u32 rsvd4[1];                            // DWORDS 27 to 27
      } SG_PACK BE2_TOE_TYPE2_DESC, *PBE2_TOE_TYPE2_DESC;

      typedef union _BE2_TOE_TYPE2_DESC_UNION {
         BE2_TOE_TYPE2_DESC bits;
         u32 dw[28]; // dword union
      } SG_PACK BE2_TOE_TYPE2_DESC_UNION, *PBE2_TOE_TYPE2_DESC_UNION;

      SG_C_ASSERT(__sizeof__BE2_TOE_TYPE2_DESC_UNION, sizeof (BE2_TOE_TYPE2_DESC_UNION) == 112);
   #endif


#else
   // Data/Descriptor for TxULP Input Queue from TCP scheduler with WRB load. QOS check
   // might be done for this descriptor. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TOE_TYPE2_DESC {
         union {
            struct { 
               u32 grant_len;                     // DWORD 0
               u32 cid : 11;                      // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 RRMsg : 1;                     // DWORD 1
               u32 retransmit : 1;                // DWORD 1
               u32 driverRequest : 1;             // DWORD 1
               u32 chipRequest : 1;               // DWORD 1
               u32 notcp : 1;                     // DWORD 1
               u32 alltcpacks : 1;                // DWORD 1
               u32 win_probe : 1;                 // DWORD 1
               u32 rsvd1 : 1;                     // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 mark_color : 2;                // DWORD 1
               u32 gp_predicates : 5;             // DWORD 1
               u32 snd_max;                       // DWORD 2
               u32 snd_nxt;                       // DWORD 3
               u32 t_state : 8;                   // DWORD 4
               u32 t_flags : 11;                  // DWORD 4
               u32 rsvd2 : 9;                     // DWORD 4
               u32 t_rxtshift : 4;                // DWORD 4
               u32 last_ack_sent;                 // DWORD 5
               u32 snd_una;                       // DWORD 6
               u32 t_maxseg : 16;                 // DWORD 7
               u32 port_id : 2;                   // DWORD 7
               u32 t_dupacks2 : 2;                // DWORD 7
               u32 rx_state : 4;                  // DWORD 7
               u32 rx_flags : 8;                  // DWORD 7
               u32 snd_cwnd;                      // DWORD 8
               u32 snd_last;                      // DWORD 9
               BE2_TOE_WRB toe_wrb[4];
               u32 cra : 25;                      // DWORD 26
               u32 rsvd3 : 7;                     // DWORD 26
               u32 rsvd4[1];                      // DWORDS 27 to 27
            } SG_PACK ; // unnamed struct
            u32 dw[28]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TOE_TYPE2_DESC, *PBE2_TOE_TYPE2_DESC;

      SG_C_ASSERT(__sizeof__BE2_TOE_TYPE2_DESC, sizeof (BE2_TOE_TYPE2_DESC) == 112);

   #else
      typedef struct _BE2_TOE_TYPE2_DESC {
         u32 grant_len;                           // DWORD 0
         u32 cid : 11;                            // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 RRMsg : 1;                           // DWORD 1
         u32 retransmit : 1;                      // DWORD 1
         u32 driverRequest : 1;                   // DWORD 1
         u32 chipRequest : 1;                     // DWORD 1
         u32 notcp : 1;                           // DWORD 1
         u32 alltcpacks : 1;                      // DWORD 1
         u32 win_probe : 1;                       // DWORD 1
         u32 rsvd1 : 1;                           // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 mark_color : 2;                      // DWORD 1
         u32 gp_predicates : 5;                   // DWORD 1
         u32 snd_max;                             // DWORD 2
         u32 snd_nxt;                             // DWORD 3
         u32 t_state : 8;                         // DWORD 4
         u32 t_flags : 11;                        // DWORD 4
         u32 rsvd2 : 9;                           // DWORD 4
         u32 t_rxtshift : 4;                      // DWORD 4
         u32 last_ack_sent;                       // DWORD 5
         u32 snd_una;                             // DWORD 6
         u32 t_maxseg : 16;                       // DWORD 7
         u32 port_id : 2;                         // DWORD 7
         u32 t_dupacks2 : 2;                      // DWORD 7
         u32 rx_state : 4;                        // DWORD 7
         u32 rx_flags : 8;                        // DWORD 7
         u32 snd_cwnd;                            // DWORD 8
         u32 snd_last;                            // DWORD 9
         BE2_TOE_WRB toe_wrb[4];
         u32 cra : 25;                            // DWORD 26
         u32 rsvd3 : 7;                           // DWORD 26
         u32 rsvd4[1];                            // DWORDS 27 to 27
      } SG_PACK BE2_TOE_TYPE2_DESC, *PBE2_TOE_TYPE2_DESC;

      typedef union _BE2_TOE_TYPE2_DESC_UNION {
         BE2_TOE_TYPE2_DESC bits;
         u32 dw[28]; // dword union
      } SG_PACK BE2_TOE_TYPE2_DESC_UNION, *PBE2_TOE_TYPE2_DESC_UNION;

      SG_C_ASSERT(__sizeof__BE2_TOE_TYPE2_DESC_UNION, sizeof (BE2_TOE_TYPE2_DESC_UNION) == 112);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This descriptor is used by the txulp to push bits back into the global QOS bucket. 
   #if defined(SG_BMAP_UNION)
      typedef struct _QOS_GLOBAL_UPDATE_DESC {
         union {
            struct { 
               u32 rsvd2 : 15;                    // DWORD 0
               u32 is_etx : 1;                    // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 flow_id : 5;                   // DWORD 0
               u32 update_value;                  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK QOS_GLOBAL_UPDATE_DESC, *PQOS_GLOBAL_UPDATE_DESC;

      SG_C_ASSERT(__sizeof__QOS_GLOBAL_UPDATE_DESC, sizeof (QOS_GLOBAL_UPDATE_DESC) == 8);

   #else
      typedef struct _QOS_GLOBAL_UPDATE_DESC {
         u32 rsvd2 : 15;                          // DWORD 0
         u32 is_etx : 1;                          // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 flow_id : 5;                         // DWORD 0
         u32 update_value;                        // DWORD 1
      } SG_PACK QOS_GLOBAL_UPDATE_DESC, *PQOS_GLOBAL_UPDATE_DESC;

      typedef union _QOS_GLOBAL_UPDATE_DESC_UNION {
         QOS_GLOBAL_UPDATE_DESC bits;
         u32 dw[2]; // dword union
      } SG_PACK QOS_GLOBAL_UPDATE_DESC_UNION, *PQOS_GLOBAL_UPDATE_DESC_UNION;

      SG_C_ASSERT(__sizeof__QOS_GLOBAL_UPDATE_DESC_UNION, sizeof (QOS_GLOBAL_UPDATE_DESC_UNION) == 8);
   #endif


#else
   // This descriptor is used by the txulp to push bits back into the global QOS bucket. 
   #if defined(SG_BMAP_UNION)
      typedef struct _QOS_GLOBAL_UPDATE_DESC {
         union {
            struct { 
               u32 flow_id : 5;                   // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 is_etx : 1;                    // DWORD 0
               u32 rsvd2 : 15;                    // DWORD 0
               u32 update_value;                  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK QOS_GLOBAL_UPDATE_DESC, *PQOS_GLOBAL_UPDATE_DESC;

      SG_C_ASSERT(__sizeof__QOS_GLOBAL_UPDATE_DESC, sizeof (QOS_GLOBAL_UPDATE_DESC) == 8);

   #else
      typedef struct _QOS_GLOBAL_UPDATE_DESC {
         u32 flow_id : 5;                         // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 is_etx : 1;                          // DWORD 0
         u32 rsvd2 : 15;                          // DWORD 0
         u32 update_value;                        // DWORD 1
      } SG_PACK QOS_GLOBAL_UPDATE_DESC, *PQOS_GLOBAL_UPDATE_DESC;

      typedef union _QOS_GLOBAL_UPDATE_DESC_UNION {
         QOS_GLOBAL_UPDATE_DESC bits;
         u32 dw[2]; // dword union
      } SG_PACK QOS_GLOBAL_UPDATE_DESC_UNION, *PQOS_GLOBAL_UPDATE_DESC_UNION;

      SG_C_ASSERT(__sizeof__QOS_GLOBAL_UPDATE_DESC_UNION, sizeof (QOS_GLOBAL_UPDATE_DESC_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This descriptor is used by the txulp to push bits back into the local QOS bucket. 
   #if defined(SG_BMAP_UNION)
      typedef struct _QOS_LOCAL_UPDATE_DESC {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 flow_id : 5;                   // DWORD 0
               u32 update_value;                  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK QOS_LOCAL_UPDATE_DESC, *PQOS_LOCAL_UPDATE_DESC;

      SG_C_ASSERT(__sizeof__QOS_LOCAL_UPDATE_DESC, sizeof (QOS_LOCAL_UPDATE_DESC) == 8);

   #else
      typedef struct _QOS_LOCAL_UPDATE_DESC {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 flow_id : 5;                         // DWORD 0
         u32 update_value;                        // DWORD 1
      } SG_PACK QOS_LOCAL_UPDATE_DESC, *PQOS_LOCAL_UPDATE_DESC;

      typedef union _QOS_LOCAL_UPDATE_DESC_UNION {
         QOS_LOCAL_UPDATE_DESC bits;
         u32 dw[2]; // dword union
      } SG_PACK QOS_LOCAL_UPDATE_DESC_UNION, *PQOS_LOCAL_UPDATE_DESC_UNION;

      SG_C_ASSERT(__sizeof__QOS_LOCAL_UPDATE_DESC_UNION, sizeof (QOS_LOCAL_UPDATE_DESC_UNION) == 8);
   #endif


#else
   // This descriptor is used by the txulp to push bits back into the local QOS bucket. 
   #if defined(SG_BMAP_UNION)
      typedef struct _QOS_LOCAL_UPDATE_DESC {
         union {
            struct { 
               u32 flow_id : 5;                   // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
               u32 update_value;                  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK QOS_LOCAL_UPDATE_DESC, *PQOS_LOCAL_UPDATE_DESC;

      SG_C_ASSERT(__sizeof__QOS_LOCAL_UPDATE_DESC, sizeof (QOS_LOCAL_UPDATE_DESC) == 8);

   #else
      typedef struct _QOS_LOCAL_UPDATE_DESC {
         u32 flow_id : 5;                         // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
         u32 update_value;                        // DWORD 1
      } SG_PACK QOS_LOCAL_UPDATE_DESC, *PQOS_LOCAL_UPDATE_DESC;

      typedef union _QOS_LOCAL_UPDATE_DESC_UNION {
         QOS_LOCAL_UPDATE_DESC bits;
         u32 dw[2]; // dword union
      } SG_PACK QOS_LOCAL_UPDATE_DESC_UNION, *PQOS_LOCAL_UPDATE_DESC_UNION;

      SG_C_ASSERT(__sizeof__QOS_LOCAL_UPDATE_DESC_UNION, sizeof (QOS_LOCAL_UPDATE_DESC_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RXPP_ETH_D {
         union {
            struct { 
               u32 qinq : 1;                      // DWORD 0
               u32 l2type : 2;                    // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 sw : 1;                        // DWORD 0
               u32 rss_bank : 1;                  // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rxvector_hi : 4;               // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 l4_cksm : 1;                   // DWORD 0
               u32 ipcksm : 1;                    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 l3type : 2;                    // DWORD 0
               u32 snap : 1;                      // DWORD 0
               u32 ip_opt : 1;                    // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 vtp : 1;                       // DWORD 0
               u32 mac_id : 6;                    // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
               u32 ct : 2;                        // DWORD 1
               u32 len : 14;                      // DWORD 1
               u32 vtag : 16;                     // DWORD 1
               u32 rsshash;                       // DWORD 2
               u32 rsvd7 : 2;                     // DWORD 3
               u32 rsvd6 : 6;                     // DWORD 3
               u32 rsvd5 : 3;                     // DWORD 3
               u32 rsvd4 : 9;                     // DWORD 3
               u32 rsvd3 : 3;                     // DWORD 3
               u32 pbuf_head : 9;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RXPP_ETH_D, *PRXPP_ETH_D;

      SG_C_ASSERT(__sizeof__RXPP_ETH_D, sizeof (RXPP_ETH_D) == 16);

   #else
      typedef struct _RXPP_ETH_D {
         u32 qinq : 1;                            // DWORD 0
         u32 l2type : 2;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 sw : 1;                              // DWORD 0
         u32 rss_bank : 1;                        // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rxvector_hi : 4;                     // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 l4_cksm : 1;                         // DWORD 0
         u32 ipcksm : 1;                          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 l3type : 2;                          // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 ip_opt : 1;                          // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 mac_id : 6;                          // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
         u32 ct : 2;                              // DWORD 1
         u32 len : 14;                            // DWORD 1
         u32 vtag : 16;                           // DWORD 1
         u32 rsshash;                             // DWORD 2
         u32 rsvd7 : 2;                           // DWORD 3
         u32 rsvd6 : 6;                           // DWORD 3
         u32 rsvd5 : 3;                           // DWORD 3
         u32 rsvd4 : 9;                           // DWORD 3
         u32 rsvd3 : 3;                           // DWORD 3
         u32 pbuf_head : 9;                       // DWORD 3
      } SG_PACK RXPP_ETH_D, *PRXPP_ETH_D;

      typedef union _RXPP_ETH_D_UNION {
         RXPP_ETH_D bits;
         u32 dw[4]; // dword union
      } SG_PACK RXPP_ETH_D_UNION, *PRXPP_ETH_D_UNION;

      SG_C_ASSERT(__sizeof__RXPP_ETH_D_UNION, sizeof (RXPP_ETH_D_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RXPP_ETH_D {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 mac_id : 6;                    // DWORD 0
               u32 vtp : 1;                       // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 ip_opt : 1;                    // DWORD 0
               u32 snap : 1;                      // DWORD 0
               u32 l3type : 2;                    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ipcksm : 1;                    // DWORD 0
               u32 l4_cksm : 1;                   // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 rxvector_hi : 4;               // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rss_bank : 1;                  // DWORD 0
               u32 sw : 1;                        // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 l2type : 2;                    // DWORD 0
               u32 qinq : 1;                      // DWORD 0
               u32 vtag : 16;                     // DWORD 1
               u32 len : 14;                      // DWORD 1
               u32 ct : 2;                        // DWORD 1
               u32 rsshash;                       // DWORD 2
               u32 pbuf_head : 9;                 // DWORD 3
               u32 rsvd3 : 3;                     // DWORD 3
               u32 rsvd4 : 9;                     // DWORD 3
               u32 rsvd5 : 3;                     // DWORD 3
               u32 rsvd6 : 6;                     // DWORD 3
               u32 rsvd7 : 2;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RXPP_ETH_D, *PRXPP_ETH_D;

      SG_C_ASSERT(__sizeof__RXPP_ETH_D, sizeof (RXPP_ETH_D) == 16);

   #else
      typedef struct _RXPP_ETH_D {
         u32 stall : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 mac_id : 6;                          // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 ip_opt : 1;                          // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 l3type : 2;                          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ipcksm : 1;                          // DWORD 0
         u32 l4_cksm : 1;                         // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 rxvector_hi : 4;                     // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rss_bank : 1;                        // DWORD 0
         u32 sw : 1;                              // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 l2type : 2;                          // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 vtag : 16;                           // DWORD 1
         u32 len : 14;                            // DWORD 1
         u32 ct : 2;                              // DWORD 1
         u32 rsshash;                             // DWORD 2
         u32 pbuf_head : 9;                       // DWORD 3
         u32 rsvd3 : 3;                           // DWORD 3
         u32 rsvd4 : 9;                           // DWORD 3
         u32 rsvd5 : 3;                           // DWORD 3
         u32 rsvd6 : 6;                           // DWORD 3
         u32 rsvd7 : 2;                           // DWORD 3
      } SG_PACK RXPP_ETH_D, *PRXPP_ETH_D;

      typedef union _RXPP_ETH_D_UNION {
         RXPP_ETH_D bits;
         u32 dw[4]; // dword union
      } SG_PACK RXPP_ETH_D_UNION, *PRXPP_ETH_D_UNION;

      SG_C_ASSERT(__sizeof__RXPP_ETH_D_UNION, sizeof (RXPP_ETH_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RXPP_TCP_D {
         union {
            struct { 
               u32 ct : 2;                        // DWORD 0
               u32 rsvd3 : 4;                     // DWORD 0
               u32 lro_timer_pop : 1;             // DWORD 0
               u32 tho : 1;                       // DWORD 0
               u32 sw : 1;                        // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 rss_bank : 1;                  // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 ip_options : 1;                // DWORD 0
               u32 qinq : 1;                      // DWORD 0
               u32 ip_type : 3;                   // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ACKONLY : 1;                   // DWORD 0
               u32 zeropayload : 1;               // DWORD 0
               u32 snap : 1;                      // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vtp : 1;                       // DWORD 0
               u32 pbuf_head : 9;                 // DWORD 0
               u32 fpe : 3;                       // DWORD 1
               u32 rsvd5 : 3;                     // DWORD 1
               u32 mac_id : 6;                    // DWORD 1
               u32 rsvd4 : 3;                     // DWORD 1
               u32 err : 1;                       // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 l2type : 2;                    // DWORD 1
               u32 sid : 10;                      // DWORD 1
               u32 red_discard : 1;               // DWORD 1
               u32 l4_cksm : 1;                   // DWORD 1
               u32 ipcksm : 1;                    // DWORD 1
               u32 vtag : 16;                     // DWORD 2
               u32 rsvd6 : 2;                     // DWORD 2
               u32 len : 14;                      // DWORD 2
               u32 mpacrc;                        // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RXPP_TCP_D, *PRXPP_TCP_D;

      SG_C_ASSERT(__sizeof__RXPP_TCP_D, sizeof (RXPP_TCP_D) == 16);

   #else
      typedef struct _RXPP_TCP_D {
         u32 ct : 2;                              // DWORD 0
         u32 rsvd3 : 4;                           // DWORD 0
         u32 lro_timer_pop : 1;                   // DWORD 0
         u32 tho : 1;                             // DWORD 0
         u32 sw : 1;                              // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rss_bank : 1;                        // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 ip_options : 1;                      // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 ip_type : 3;                         // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ACKONLY : 1;                         // DWORD 0
         u32 zeropayload : 1;                     // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 pbuf_head : 9;                       // DWORD 0
         u32 fpe : 3;                             // DWORD 1
         u32 rsvd5 : 3;                           // DWORD 1
         u32 mac_id : 6;                          // DWORD 1
         u32 rsvd4 : 3;                           // DWORD 1
         u32 err : 1;                             // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 l2type : 2;                          // DWORD 1
         u32 sid : 10;                            // DWORD 1
         u32 red_discard : 1;                     // DWORD 1
         u32 l4_cksm : 1;                         // DWORD 1
         u32 ipcksm : 1;                          // DWORD 1
         u32 vtag : 16;                           // DWORD 2
         u32 rsvd6 : 2;                           // DWORD 2
         u32 len : 14;                            // DWORD 2
         u32 mpacrc;                              // DWORD 3
      } SG_PACK RXPP_TCP_D, *PRXPP_TCP_D;

      typedef union _RXPP_TCP_D_UNION {
         RXPP_TCP_D bits;
         u32 dw[4]; // dword union
      } SG_PACK RXPP_TCP_D_UNION, *PRXPP_TCP_D_UNION;

      SG_C_ASSERT(__sizeof__RXPP_TCP_D_UNION, sizeof (RXPP_TCP_D_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RXPP_TCP_D {
         union {
            struct { 
               u32 pbuf_head : 9;                 // DWORD 0
               u32 vtp : 1;                       // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 snap : 1;                      // DWORD 0
               u32 zeropayload : 1;               // DWORD 0
               u32 ACKONLY : 1;                   // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ip_type : 3;                   // DWORD 0
               u32 qinq : 1;                      // DWORD 0
               u32 ip_options : 1;                // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 rss_bank : 1;                  // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 sw : 1;                        // DWORD 0
               u32 tho : 1;                       // DWORD 0
               u32 lro_timer_pop : 1;             // DWORD 0
               u32 rsvd3 : 4;                     // DWORD 0
               u32 ct : 2;                        // DWORD 0
               u32 ipcksm : 1;                    // DWORD 1
               u32 l4_cksm : 1;                   // DWORD 1
               u32 red_discard : 1;               // DWORD 1
               u32 sid : 10;                      // DWORD 1
               u32 l2type : 2;                    // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 err : 1;                       // DWORD 1
               u32 rsvd4 : 3;                     // DWORD 1
               u32 mac_id : 6;                    // DWORD 1
               u32 rsvd5 : 3;                     // DWORD 1
               u32 fpe : 3;                       // DWORD 1
               u32 len : 14;                      // DWORD 2
               u32 rsvd6 : 2;                     // DWORD 2
               u32 vtag : 16;                     // DWORD 2
               u32 mpacrc;                        // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RXPP_TCP_D, *PRXPP_TCP_D;

      SG_C_ASSERT(__sizeof__RXPP_TCP_D, sizeof (RXPP_TCP_D) == 16);

   #else
      typedef struct _RXPP_TCP_D {
         u32 pbuf_head : 9;                       // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 zeropayload : 1;                     // DWORD 0
         u32 ACKONLY : 1;                         // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ip_type : 3;                         // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 ip_options : 1;                      // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 rss_bank : 1;                        // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 sw : 1;                              // DWORD 0
         u32 tho : 1;                             // DWORD 0
         u32 lro_timer_pop : 1;                   // DWORD 0
         u32 rsvd3 : 4;                           // DWORD 0
         u32 ct : 2;                              // DWORD 0
         u32 ipcksm : 1;                          // DWORD 1
         u32 l4_cksm : 1;                         // DWORD 1
         u32 red_discard : 1;                     // DWORD 1
         u32 sid : 10;                            // DWORD 1
         u32 l2type : 2;                          // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 err : 1;                             // DWORD 1
         u32 rsvd4 : 3;                           // DWORD 1
         u32 mac_id : 6;                          // DWORD 1
         u32 rsvd5 : 3;                           // DWORD 1
         u32 fpe : 3;                             // DWORD 1
         u32 len : 14;                            // DWORD 2
         u32 rsvd6 : 2;                           // DWORD 2
         u32 vtag : 16;                           // DWORD 2
         u32 mpacrc;                              // DWORD 3
      } SG_PACK RXPP_TCP_D, *PRXPP_TCP_D;

      typedef union _RXPP_TCP_D_UNION {
         RXPP_TCP_D bits;
         u32 dw[4]; // dword union
      } SG_PACK RXPP_TCP_D_UNION, *PRXPP_TCP_D_UNION;

      SG_C_ASSERT(__sizeof__RXPP_TCP_D_UNION, sizeof (RXPP_TCP_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RXPP_FCOE_D {
         union {
            struct { 
               u32 ct : 2;                        // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vf_id_hi : 4;                  // DWORD 0
               u32 ox_id : 16;                    // DWORD 0
               u32 pbuf_head : 9;                 // DWORD 0
               u32 d_id_hi : 16;                  // DWORD 1
               u32 r2t : 1;                       // DWORD 1
               u32 vtp : 1;                       // DWORD 1
               u32 vfidp : 1;                     // DWORD 1
               u32 fcoe : 3;                      // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 sid : 6;                       // DWORD 1
               u32 fip : 1;                       // DWORD 1
               u32 eof : 2;                       // DWORD 1
               u32 vtag : 16;                     // DWORD 2
               u32 sof : 2;                       // DWORD 2
               u32 len : 14;                      // DWORD 2
               u32 vf_id_lo : 8;                  // DWORD 3
               u32 d_id_lo : 8;                   // DWORD 3
               u32 rx_id : 16;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RXPP_FCOE_D, *PRXPP_FCOE_D;

      SG_C_ASSERT(__sizeof__RXPP_FCOE_D, sizeof (RXPP_FCOE_D) == 16);

   #else
      typedef struct _RXPP_FCOE_D {
         u32 ct : 2;                              // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vf_id_hi : 4;                        // DWORD 0
         u32 ox_id : 16;                          // DWORD 0
         u32 pbuf_head : 9;                       // DWORD 0
         u32 d_id_hi : 16;                        // DWORD 1
         u32 r2t : 1;                             // DWORD 1
         u32 vtp : 1;                             // DWORD 1
         u32 vfidp : 1;                           // DWORD 1
         u32 fcoe : 3;                            // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 sid : 6;                             // DWORD 1
         u32 fip : 1;                             // DWORD 1
         u32 eof : 2;                             // DWORD 1
         u32 vtag : 16;                           // DWORD 2
         u32 sof : 2;                             // DWORD 2
         u32 len : 14;                            // DWORD 2
         u32 vf_id_lo : 8;                        // DWORD 3
         u32 d_id_lo : 8;                         // DWORD 3
         u32 rx_id : 16;                          // DWORD 3
      } SG_PACK RXPP_FCOE_D, *PRXPP_FCOE_D;

      typedef union _RXPP_FCOE_D_UNION {
         RXPP_FCOE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK RXPP_FCOE_D_UNION, *PRXPP_FCOE_D_UNION;

      SG_C_ASSERT(__sizeof__RXPP_FCOE_D_UNION, sizeof (RXPP_FCOE_D_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RXPP_FCOE_D {
         union {
            struct { 
               u32 pbuf_head : 9;                 // DWORD 0
               u32 ox_id : 16;                    // DWORD 0
               u32 vf_id_hi : 4;                  // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ct : 2;                        // DWORD 0
               u32 eof : 2;                       // DWORD 1
               u32 fip : 1;                       // DWORD 1
               u32 sid : 6;                       // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 fcoe : 3;                      // DWORD 1
               u32 vfidp : 1;                     // DWORD 1
               u32 vtp : 1;                       // DWORD 1
               u32 r2t : 1;                       // DWORD 1
               u32 d_id_hi : 16;                  // DWORD 1
               u32 len : 14;                      // DWORD 2
               u32 sof : 2;                       // DWORD 2
               u32 vtag : 16;                     // DWORD 2
               u32 rx_id : 16;                    // DWORD 3
               u32 d_id_lo : 8;                   // DWORD 3
               u32 vf_id_lo : 8;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RXPP_FCOE_D, *PRXPP_FCOE_D;

      SG_C_ASSERT(__sizeof__RXPP_FCOE_D, sizeof (RXPP_FCOE_D) == 16);

   #else
      typedef struct _RXPP_FCOE_D {
         u32 pbuf_head : 9;                       // DWORD 0
         u32 ox_id : 16;                          // DWORD 0
         u32 vf_id_hi : 4;                        // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ct : 2;                              // DWORD 0
         u32 eof : 2;                             // DWORD 1
         u32 fip : 1;                             // DWORD 1
         u32 sid : 6;                             // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 fcoe : 3;                            // DWORD 1
         u32 vfidp : 1;                           // DWORD 1
         u32 vtp : 1;                             // DWORD 1
         u32 r2t : 1;                             // DWORD 1
         u32 d_id_hi : 16;                        // DWORD 1
         u32 len : 14;                            // DWORD 2
         u32 sof : 2;                             // DWORD 2
         u32 vtag : 16;                           // DWORD 2
         u32 rx_id : 16;                          // DWORD 3
         u32 d_id_lo : 8;                         // DWORD 3
         u32 vf_id_lo : 8;                        // DWORD 3
      } SG_PACK RXPP_FCOE_D, *PRXPP_FCOE_D;

      typedef union _RXPP_FCOE_D_UNION {
         RXPP_FCOE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK RXPP_FCOE_D_UNION, *PRXPP_FCOE_D_UNION;

      SG_C_ASSERT(__sizeof__RXPP_FCOE_D_UNION, sizeof (RXPP_FCOE_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // After a packet is written to the appropriate FCOE FIFO, the receive filter will
   // write an 128bit pseudo-header with the results of the parsing and checking. This
   // pseudo header is used by the Receive Packet Processor to generate RXPP_FCOE_D
   // descriptors, which are sent exclusively to TPRE.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXFILT_FCOE_D {
         union {
            struct { 
               u32 rsvd1 : 3;                     // DWORD 0
               u32 vf_id_hi : 4;                  // DWORD 0
               u32 ox_id : 16;                    // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 0
               u32 d_id_hi : 16;                  // DWORD 1
               u32 r2t : 1;                       // DWORD 1
               u32 vtp : 1;                       // DWORD 1
               u32 vfidp : 1;                     // DWORD 1
               u32 fcoe : 3;                      // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 sid : 6;                       // DWORD 1
               u32 fip : 1;                       // DWORD 1
               u32 eof : 2;                       // DWORD 1
               u32 vtag : 16;                     // DWORD 2
               u32 sof : 2;                       // DWORD 2
               u32 len : 14;                      // DWORD 2
               u32 vf_id_lo : 8;                  // DWORD 3
               u32 d_id_lo : 8;                   // DWORD 3
               u32 rx_id : 16;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RXFILT_FCOE_D, *PRXFILT_FCOE_D;

      SG_C_ASSERT(__sizeof__RXFILT_FCOE_D, sizeof (RXFILT_FCOE_D) == 16);

   #else
      typedef struct _RXFILT_FCOE_D {
         u32 rsvd1 : 3;                           // DWORD 0
         u32 vf_id_hi : 4;                        // DWORD 0
         u32 ox_id : 16;                          // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 0
         u32 d_id_hi : 16;                        // DWORD 1
         u32 r2t : 1;                             // DWORD 1
         u32 vtp : 1;                             // DWORD 1
         u32 vfidp : 1;                           // DWORD 1
         u32 fcoe : 3;                            // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 sid : 6;                             // DWORD 1
         u32 fip : 1;                             // DWORD 1
         u32 eof : 2;                             // DWORD 1
         u32 vtag : 16;                           // DWORD 2
         u32 sof : 2;                             // DWORD 2
         u32 len : 14;                            // DWORD 2
         u32 vf_id_lo : 8;                        // DWORD 3
         u32 d_id_lo : 8;                         // DWORD 3
         u32 rx_id : 16;                          // DWORD 3
      } SG_PACK RXFILT_FCOE_D, *PRXFILT_FCOE_D;

      typedef union _RXFILT_FCOE_D_UNION {
         RXFILT_FCOE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK RXFILT_FCOE_D_UNION, *PRXFILT_FCOE_D_UNION;

      SG_C_ASSERT(__sizeof__RXFILT_FCOE_D_UNION, sizeof (RXFILT_FCOE_D_UNION) == 16);
   #endif


#else
   // After a packet is written to the appropriate FCOE FIFO, the receive filter will
   // write an 128bit pseudo-header with the results of the parsing and checking. This
   // pseudo header is used by the Receive Packet Processor to generate RXPP_FCOE_D
   // descriptors, which are sent exclusively to TPRE.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXFILT_FCOE_D {
         union {
            struct { 
               u32 rsvd0 : 9;                     // DWORD 0
               u32 ox_id : 16;                    // DWORD 0
               u32 vf_id_hi : 4;                  // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 eof : 2;                       // DWORD 1
               u32 fip : 1;                       // DWORD 1
               u32 sid : 6;                       // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 fcoe : 3;                      // DWORD 1
               u32 vfidp : 1;                     // DWORD 1
               u32 vtp : 1;                       // DWORD 1
               u32 r2t : 1;                       // DWORD 1
               u32 d_id_hi : 16;                  // DWORD 1
               u32 len : 14;                      // DWORD 2
               u32 sof : 2;                       // DWORD 2
               u32 vtag : 16;                     // DWORD 2
               u32 rx_id : 16;                    // DWORD 3
               u32 d_id_lo : 8;                   // DWORD 3
               u32 vf_id_lo : 8;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RXFILT_FCOE_D, *PRXFILT_FCOE_D;

      SG_C_ASSERT(__sizeof__RXFILT_FCOE_D, sizeof (RXFILT_FCOE_D) == 16);

   #else
      typedef struct _RXFILT_FCOE_D {
         u32 rsvd0 : 9;                           // DWORD 0
         u32 ox_id : 16;                          // DWORD 0
         u32 vf_id_hi : 4;                        // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 eof : 2;                             // DWORD 1
         u32 fip : 1;                             // DWORD 1
         u32 sid : 6;                             // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 fcoe : 3;                            // DWORD 1
         u32 vfidp : 1;                           // DWORD 1
         u32 vtp : 1;                             // DWORD 1
         u32 r2t : 1;                             // DWORD 1
         u32 d_id_hi : 16;                        // DWORD 1
         u32 len : 14;                            // DWORD 2
         u32 sof : 2;                             // DWORD 2
         u32 vtag : 16;                           // DWORD 2
         u32 rx_id : 16;                          // DWORD 3
         u32 d_id_lo : 8;                         // DWORD 3
         u32 vf_id_lo : 8;                        // DWORD 3
      } SG_PACK RXFILT_FCOE_D, *PRXFILT_FCOE_D;

      typedef union _RXFILT_FCOE_D_UNION {
         RXFILT_FCOE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK RXFILT_FCOE_D_UNION, *PRXFILT_FCOE_D_UNION;

      SG_C_ASSERT(__sizeof__RXFILT_FCOE_D_UNION, sizeof (RXFILT_FCOE_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Header for a full packet enqueued to the Receive (RXIPS) FIFOs.
   #if defined(SG_BMAP_UNION)
      typedef struct _RX_FIFO_HDR_D {
         union {
            struct { 
               u32 rsvd2 : 1;                     // DWORD 0
               u32 sa_index : 7;                  // DWORD 0
               u32 ah_or_esp : 1;                 // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 ip_hdr_offset : 2;             // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 length : 14;                   // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 vlan : 16;                     // DWORD 1
               u32 mac_hit_addr : 7;              // DWORD 1
               u32 vlan_type : 2;                 // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 mac_id : 6;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RX_FIFO_HDR_D, *PRX_FIFO_HDR_D;

      SG_C_ASSERT(__sizeof__RX_FIFO_HDR_D, sizeof (RX_FIFO_HDR_D) == 8);

   #else
      typedef struct _RX_FIFO_HDR_D {
         u32 rsvd2 : 1;                           // DWORD 0
         u32 sa_index : 7;                        // DWORD 0
         u32 ah_or_esp : 1;                       // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 ip_hdr_offset : 2;                   // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 length : 14;                         // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 vlan : 16;                           // DWORD 1
         u32 mac_hit_addr : 7;                    // DWORD 1
         u32 vlan_type : 2;                       // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 mac_id : 6;                          // DWORD 1
      } SG_PACK RX_FIFO_HDR_D, *PRX_FIFO_HDR_D;

      typedef union _RX_FIFO_HDR_D_UNION {
         RX_FIFO_HDR_D bits;
         u32 dw[2]; // dword union
      } SG_PACK RX_FIFO_HDR_D_UNION, *PRX_FIFO_HDR_D_UNION;

      SG_C_ASSERT(__sizeof__RX_FIFO_HDR_D_UNION, sizeof (RX_FIFO_HDR_D_UNION) == 8);
   #endif


#else
   // Header for a full packet enqueued to the Receive (RXIPS) FIFOs.
   #if defined(SG_BMAP_UNION)
      typedef struct _RX_FIFO_HDR_D {
         union {
            struct { 
               u32 rsvd0 : 3;                     // DWORD 0
               u32 length : 14;                   // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 ip_hdr_offset : 2;             // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 ah_or_esp : 1;                 // DWORD 0
               u32 sa_index : 7;                  // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 mac_id : 6;                    // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 vlan_type : 2;                 // DWORD 1
               u32 mac_hit_addr : 7;              // DWORD 1
               u32 vlan : 16;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RX_FIFO_HDR_D, *PRX_FIFO_HDR_D;

      SG_C_ASSERT(__sizeof__RX_FIFO_HDR_D, sizeof (RX_FIFO_HDR_D) == 8);

   #else
      typedef struct _RX_FIFO_HDR_D {
         u32 rsvd0 : 3;                           // DWORD 0
         u32 length : 14;                         // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 ip_hdr_offset : 2;                   // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 ah_or_esp : 1;                       // DWORD 0
         u32 sa_index : 7;                        // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 mac_id : 6;                          // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 vlan_type : 2;                       // DWORD 1
         u32 mac_hit_addr : 7;                    // DWORD 1
         u32 vlan : 16;                           // DWORD 1
      } SG_PACK RX_FIFO_HDR_D, *PRX_FIFO_HDR_D;

      typedef union _RX_FIFO_HDR_D_UNION {
         RX_FIFO_HDR_D bits;
         u32 dw[2]; // dword union
      } SG_PACK RX_FIFO_HDR_D_UNION, *PRX_FIFO_HDR_D_UNION;

      SG_C_ASSERT(__sizeof__RX_FIFO_HDR_D_UNION, sizeof (RX_FIFO_HDR_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Immediate ack descriptor from tpost to tpre 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_TPOST_IMMACK_D {
         union {
            struct { 
               u32 rsvd1 : 15;                    // DWORD 0
               u32 iq_select : 1;                 // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 port_id : 1;                   // DWORD 1
               u32 force : 1;                     // DWORD 1
               u32 rsvd2 : 12;                    // DWORD 1
               u32 src : 2;                       // DWORD 1
               u32 cid : 16;                      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_TPOST_IMMACK_D, *PTPRE_TPOST_IMMACK_D;

      SG_C_ASSERT(__sizeof__TPRE_TPOST_IMMACK_D, sizeof (TPRE_TPOST_IMMACK_D) == 8);

   #else
      typedef struct _TPRE_TPOST_IMMACK_D {
         u32 rsvd1 : 15;                          // DWORD 0
         u32 iq_select : 1;                       // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 port_id : 1;                         // DWORD 1
         u32 force : 1;                           // DWORD 1
         u32 rsvd2 : 12;                          // DWORD 1
         u32 src : 2;                             // DWORD 1
         u32 cid : 16;                            // DWORD 1
      } SG_PACK TPRE_TPOST_IMMACK_D, *PTPRE_TPOST_IMMACK_D;

      typedef union _TPRE_TPOST_IMMACK_D_UNION {
         TPRE_TPOST_IMMACK_D bits;
         u32 dw[2]; // dword union
      } SG_PACK TPRE_TPOST_IMMACK_D_UNION, *PTPRE_TPOST_IMMACK_D_UNION;

      SG_C_ASSERT(__sizeof__TPRE_TPOST_IMMACK_D_UNION, sizeof (TPRE_TPOST_IMMACK_D_UNION) == 8);
   #endif


#else
   // Immediate ack descriptor from tpost to tpre 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_TPOST_IMMACK_D {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 iq_select : 1;                 // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
               u32 cid : 16;                      // DWORD 1
               u32 src : 2;                       // DWORD 1
               u32 rsvd2 : 12;                    // DWORD 1
               u32 force : 1;                     // DWORD 1
               u32 port_id : 1;                   // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_TPOST_IMMACK_D, *PTPRE_TPOST_IMMACK_D;

      SG_C_ASSERT(__sizeof__TPRE_TPOST_IMMACK_D, sizeof (TPRE_TPOST_IMMACK_D) == 8);

   #else
      typedef struct _TPRE_TPOST_IMMACK_D {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 iq_select : 1;                       // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
         u32 cid : 16;                            // DWORD 1
         u32 src : 2;                             // DWORD 1
         u32 rsvd2 : 12;                          // DWORD 1
         u32 force : 1;                           // DWORD 1
         u32 port_id : 1;                         // DWORD 1
      } SG_PACK TPRE_TPOST_IMMACK_D, *PTPRE_TPOST_IMMACK_D;

      typedef union _TPRE_TPOST_IMMACK_D_UNION {
         TPRE_TPOST_IMMACK_D bits;
         u32 dw[2]; // dword union
      } SG_PACK TPRE_TPOST_IMMACK_D_UNION, *PTPRE_TPOST_IMMACK_D_UNION;

      SG_C_ASSERT(__sizeof__TPRE_TPOST_IMMACK_D_UNION, sizeof (TPRE_TPOST_IMMACK_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_D {
         union {
            struct { 
               u32 ulp : 2;                       // DWORD 0
               u32 passthru_desc : 1;             // DWORD 0
               u32 lro_desc : 1;                  // DWORD 0
               u32 piggyback_ack : 1;             // DWORD 0
               u32 push_timer : 1;                // DWORD 0
               u32 schedule_ack : 1;              // DWORD 0
               u32 purge_ooo : 1;                 // DWORD 0
               u32 free_pbuf : 1;                 // DWORD 0
               u32 seg_length : 14;               // DWORD 0
               u32 pbuf_head : 9;                 // DWORD 0
               u32 fbo : 14;                      // DWORD 1
               u32 pure_data : 1;                 // DWORD 1
               u32 i : 1;                         // DWORD 1
               u32 push : 1;                      // DWORD 1
               u32 fin : 1;                       // DWORD 1
               u32 cid : 11;                      // DWORD 1
               u32 order : 3;                     // DWORD 1
               u32 ack;                           // DWORD 2
               u32 seq;                           // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_D, *PTPRE_D;

      SG_C_ASSERT(__sizeof__TPRE_D, sizeof (TPRE_D) == 16);

   #else
      typedef struct _TPRE_D {
         u32 ulp : 2;                             // DWORD 0
         u32 passthru_desc : 1;                   // DWORD 0
         u32 lro_desc : 1;                        // DWORD 0
         u32 piggyback_ack : 1;                   // DWORD 0
         u32 push_timer : 1;                      // DWORD 0
         u32 schedule_ack : 1;                    // DWORD 0
         u32 purge_ooo : 1;                       // DWORD 0
         u32 free_pbuf : 1;                       // DWORD 0
         u32 seg_length : 14;                     // DWORD 0
         u32 pbuf_head : 9;                       // DWORD 0
         u32 fbo : 14;                            // DWORD 1
         u32 pure_data : 1;                       // DWORD 1
         u32 i : 1;                               // DWORD 1
         u32 push : 1;                            // DWORD 1
         u32 fin : 1;                             // DWORD 1
         u32 cid : 11;                            // DWORD 1
         u32 order : 3;                           // DWORD 1
         u32 ack;                                 // DWORD 2
         u32 seq;                                 // DWORD 3
      } SG_PACK TPRE_D, *PTPRE_D;

      typedef union _TPRE_D_UNION {
         TPRE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK TPRE_D_UNION, *PTPRE_D_UNION;

      SG_C_ASSERT(__sizeof__TPRE_D_UNION, sizeof (TPRE_D_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_D {
         union {
            struct { 
               u32 pbuf_head : 9;                 // DWORD 0
               u32 seg_length : 14;               // DWORD 0
               u32 free_pbuf : 1;                 // DWORD 0
               u32 purge_ooo : 1;                 // DWORD 0
               u32 schedule_ack : 1;              // DWORD 0
               u32 push_timer : 1;                // DWORD 0
               u32 piggyback_ack : 1;             // DWORD 0
               u32 lro_desc : 1;                  // DWORD 0
               u32 passthru_desc : 1;             // DWORD 0
               u32 ulp : 2;                       // DWORD 0
               u32 order : 3;                     // DWORD 1
               u32 cid : 11;                      // DWORD 1
               u32 fin : 1;                       // DWORD 1
               u32 push : 1;                      // DWORD 1
               u32 i : 1;                         // DWORD 1
               u32 pure_data : 1;                 // DWORD 1
               u32 fbo : 14;                      // DWORD 1
               u32 ack;                           // DWORD 2
               u32 seq;                           // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_D, *PTPRE_D;

      SG_C_ASSERT(__sizeof__TPRE_D, sizeof (TPRE_D) == 16);

   #else
      typedef struct _TPRE_D {
         u32 pbuf_head : 9;                       // DWORD 0
         u32 seg_length : 14;                     // DWORD 0
         u32 free_pbuf : 1;                       // DWORD 0
         u32 purge_ooo : 1;                       // DWORD 0
         u32 schedule_ack : 1;                    // DWORD 0
         u32 push_timer : 1;                      // DWORD 0
         u32 piggyback_ack : 1;                   // DWORD 0
         u32 lro_desc : 1;                        // DWORD 0
         u32 passthru_desc : 1;                   // DWORD 0
         u32 ulp : 2;                             // DWORD 0
         u32 order : 3;                           // DWORD 1
         u32 cid : 11;                            // DWORD 1
         u32 fin : 1;                             // DWORD 1
         u32 push : 1;                            // DWORD 1
         u32 i : 1;                               // DWORD 1
         u32 pure_data : 1;                       // DWORD 1
         u32 fbo : 14;                            // DWORD 1
         u32 ack;                                 // DWORD 2
         u32 seq;                                 // DWORD 3
      } SG_PACK TPRE_D, *PTPRE_D;

      typedef union _TPRE_D_UNION {
         TPRE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK TPRE_D_UNION, *PTPRE_D_UNION;

      SG_C_ASSERT(__sizeof__TPRE_D_UNION, sizeof (TPRE_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_FCOE_D {
         union {
            struct { 
               u32 ulp : 2;                       // DWORD 0
               u32 passthru_desc : 1;             // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 frame_based_offload : 1;       // DWORD 0
               u32 ox_id : 16;                    // DWORD 0
               u32 pbuf_head : 9;                 // DWORD 0
               u32 fbo : 14;                      // DWORD 1
               u32 rsvd1 : 2;                     // DWORD 1
               u32 r2t : 1;                       // DWORD 1
               u32 r2tArrayflip : 1;              // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 sid : 10;                      // DWORD 1
               u32 fip : 1;                       // DWORD 1
               u32 eof : 2;                       // DWORD 1
               u32 vtag : 16;                     // DWORD 2
               u32 sof : 2;                       // DWORD 2
               u32 seg_length : 14;               // DWORD 2
               u32 cqid : 8;                      // DWORD 3
               u32 R2TPidx : 8;                   // DWORD 3
               u32 rx_id : 16;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_FCOE_D, *PTPRE_FCOE_D;

      SG_C_ASSERT(__sizeof__TPRE_FCOE_D, sizeof (TPRE_FCOE_D) == 16);

   #else
      typedef struct _TPRE_FCOE_D {
         u32 ulp : 2;                             // DWORD 0
         u32 passthru_desc : 1;                   // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 frame_based_offload : 1;             // DWORD 0
         u32 ox_id : 16;                          // DWORD 0
         u32 pbuf_head : 9;                       // DWORD 0
         u32 fbo : 14;                            // DWORD 1
         u32 rsvd1 : 2;                           // DWORD 1
         u32 r2t : 1;                             // DWORD 1
         u32 r2tArrayflip : 1;                    // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 sid : 10;                            // DWORD 1
         u32 fip : 1;                             // DWORD 1
         u32 eof : 2;                             // DWORD 1
         u32 vtag : 16;                           // DWORD 2
         u32 sof : 2;                             // DWORD 2
         u32 seg_length : 14;                     // DWORD 2
         u32 cqid : 8;                            // DWORD 3
         u32 R2TPidx : 8;                         // DWORD 3
         u32 rx_id : 16;                          // DWORD 3
      } SG_PACK TPRE_FCOE_D, *PTPRE_FCOE_D;

      typedef union _TPRE_FCOE_D_UNION {
         TPRE_FCOE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK TPRE_FCOE_D_UNION, *PTPRE_FCOE_D_UNION;

      SG_C_ASSERT(__sizeof__TPRE_FCOE_D_UNION, sizeof (TPRE_FCOE_D_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_FCOE_D {
         union {
            struct { 
               u32 pbuf_head : 9;                 // DWORD 0
               u32 ox_id : 16;                    // DWORD 0
               u32 frame_based_offload : 1;       // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 passthru_desc : 1;             // DWORD 0
               u32 ulp : 2;                       // DWORD 0
               u32 eof : 2;                       // DWORD 1
               u32 fip : 1;                       // DWORD 1
               u32 sid : 10;                      // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 r2tArrayflip : 1;              // DWORD 1
               u32 r2t : 1;                       // DWORD 1
               u32 rsvd1 : 2;                     // DWORD 1
               u32 fbo : 14;                      // DWORD 1
               u32 seg_length : 14;               // DWORD 2
               u32 sof : 2;                       // DWORD 2
               u32 vtag : 16;                     // DWORD 2
               u32 rx_id : 16;                    // DWORD 3
               u32 R2TPidx : 8;                   // DWORD 3
               u32 cqid : 8;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_FCOE_D, *PTPRE_FCOE_D;

      SG_C_ASSERT(__sizeof__TPRE_FCOE_D, sizeof (TPRE_FCOE_D) == 16);

   #else
      typedef struct _TPRE_FCOE_D {
         u32 pbuf_head : 9;                       // DWORD 0
         u32 ox_id : 16;                          // DWORD 0
         u32 frame_based_offload : 1;             // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 passthru_desc : 1;                   // DWORD 0
         u32 ulp : 2;                             // DWORD 0
         u32 eof : 2;                             // DWORD 1
         u32 fip : 1;                             // DWORD 1
         u32 sid : 10;                            // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 r2tArrayflip : 1;                    // DWORD 1
         u32 r2t : 1;                             // DWORD 1
         u32 rsvd1 : 2;                           // DWORD 1
         u32 fbo : 14;                            // DWORD 1
         u32 seg_length : 14;                     // DWORD 2
         u32 sof : 2;                             // DWORD 2
         u32 vtag : 16;                           // DWORD 2
         u32 rx_id : 16;                          // DWORD 3
         u32 R2TPidx : 8;                         // DWORD 3
         u32 cqid : 8;                            // DWORD 3
      } SG_PACK TPRE_FCOE_D, *PTPRE_FCOE_D;

      typedef union _TPRE_FCOE_D_UNION {
         TPRE_FCOE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK TPRE_FCOE_D_UNION, *PTPRE_FCOE_D_UNION;

      SG_C_ASSERT(__sizeof__TPRE_FCOE_D_UNION, sizeof (TPRE_FCOE_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // LRO Mapping for TPRE_D. Use if bit lro_desc = 1.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_OLDLRO_D {
         union {
            struct { 
               u32 ulp : 2;                       // DWORD 0
               u32 passthru_desc : 1;             // DWORD 0
               u32 lro_desc : 1;                  // DWORD 0
               u32 tsopt : 1;                     // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 lro_timer_pop : 1;             // DWORD 0
               u32 segcount_low : 4;              // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 qinq : 1;                      // DWORD 0
               u32 dupack_count : 2;              // DWORD 0
               u32 action : 4;                    // DWORD 0
               u32 snap : 1;                      // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vtp : 1;                       // DWORD 0
               u32 pbuf_head : 9;                 // DWORD 0
               u32 data_offset : 8;               // DWORD 1
               u32 tcp_offset : 8;                // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 rsvd3 : 1;                     // DWORD 1
               u32 cid : 11;                      // DWORD 1
               u32 segcount_hi : 3;               // DWORD 1
               u32 vtag : 16;                     // DWORD 2
               u32 seg_length : 16;               // DWORD 2
               u32 tcp_header_info;               // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_OLDLRO_D, *PTPRE_OLDLRO_D;

      SG_C_ASSERT(__sizeof__TPRE_OLDLRO_D, sizeof (TPRE_OLDLRO_D) == 16);

   #else
      typedef struct _TPRE_OLDLRO_D {
         u32 ulp : 2;                             // DWORD 0
         u32 passthru_desc : 1;                   // DWORD 0
         u32 lro_desc : 1;                        // DWORD 0
         u32 tsopt : 1;                           // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 lro_timer_pop : 1;                   // DWORD 0
         u32 segcount_low : 4;                    // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 dupack_count : 2;                    // DWORD 0
         u32 action : 4;                          // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 pbuf_head : 9;                       // DWORD 0
         u32 data_offset : 8;                     // DWORD 1
         u32 tcp_offset : 8;                      // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 rsvd3 : 1;                           // DWORD 1
         u32 cid : 11;                            // DWORD 1
         u32 segcount_hi : 3;                     // DWORD 1
         u32 vtag : 16;                           // DWORD 2
         u32 seg_length : 16;                     // DWORD 2
         u32 tcp_header_info;                     // DWORD 3
      } SG_PACK TPRE_OLDLRO_D, *PTPRE_OLDLRO_D;

      typedef union _TPRE_OLDLRO_D_UNION {
         TPRE_OLDLRO_D bits;
         u32 dw[4]; // dword union
      } SG_PACK TPRE_OLDLRO_D_UNION, *PTPRE_OLDLRO_D_UNION;

      SG_C_ASSERT(__sizeof__TPRE_OLDLRO_D_UNION, sizeof (TPRE_OLDLRO_D_UNION) == 16);
   #endif


#else
   // LRO Mapping for TPRE_D. Use if bit lro_desc = 1.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_OLDLRO_D {
         union {
            struct { 
               u32 pbuf_head : 9;                 // DWORD 0
               u32 vtp : 1;                       // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 snap : 1;                      // DWORD 0
               u32 action : 4;                    // DWORD 0
               u32 dupack_count : 2;              // DWORD 0
               u32 qinq : 1;                      // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 segcount_low : 4;              // DWORD 0
               u32 lro_timer_pop : 1;             // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 tsopt : 1;                     // DWORD 0
               u32 lro_desc : 1;                  // DWORD 0
               u32 passthru_desc : 1;             // DWORD 0
               u32 ulp : 2;                       // DWORD 0
               u32 segcount_hi : 3;               // DWORD 1
               u32 cid : 11;                      // DWORD 1
               u32 rsvd3 : 1;                     // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 tcp_offset : 8;                // DWORD 1
               u32 data_offset : 8;               // DWORD 1
               u32 seg_length : 16;               // DWORD 2
               u32 vtag : 16;                     // DWORD 2
               u32 tcp_header_info;               // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_OLDLRO_D, *PTPRE_OLDLRO_D;

      SG_C_ASSERT(__sizeof__TPRE_OLDLRO_D, sizeof (TPRE_OLDLRO_D) == 16);

   #else
      typedef struct _TPRE_OLDLRO_D {
         u32 pbuf_head : 9;                       // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 action : 4;                          // DWORD 0
         u32 dupack_count : 2;                    // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 segcount_low : 4;                    // DWORD 0
         u32 lro_timer_pop : 1;                   // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 tsopt : 1;                           // DWORD 0
         u32 lro_desc : 1;                        // DWORD 0
         u32 passthru_desc : 1;                   // DWORD 0
         u32 ulp : 2;                             // DWORD 0
         u32 segcount_hi : 3;                     // DWORD 1
         u32 cid : 11;                            // DWORD 1
         u32 rsvd3 : 1;                           // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 tcp_offset : 8;                      // DWORD 1
         u32 data_offset : 8;                     // DWORD 1
         u32 seg_length : 16;                     // DWORD 2
         u32 vtag : 16;                           // DWORD 2
         u32 tcp_header_info;                     // DWORD 3
      } SG_PACK TPRE_OLDLRO_D, *PTPRE_OLDLRO_D;

      typedef union _TPRE_OLDLRO_D_UNION {
         TPRE_OLDLRO_D bits;
         u32 dw[4]; // dword union
      } SG_PACK TPRE_OLDLRO_D_UNION, *PTPRE_OLDLRO_D_UNION;

      SG_C_ASSERT(__sizeof__TPRE_OLDLRO_D_UNION, sizeof (TPRE_OLDLRO_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // LRO Mapping for TPRE_D. Use if bit lro_desc = 1.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_LRO_D {
         union {
            struct { 
               u32 ulp : 2;                       // DWORD 0
               u32 passthru_desc : 1;             // DWORD 0
               u32 lro_desc : 1;                  // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 lro_timer_pop : 1;             // DWORD 0
               u32 compl_flush : 1;               // DWORD 0
               u32 compl_snap : 1;                // DWORD 0
               u32 compl_push : 1;                // DWORD 0
               u32 compl_vtp : 1;                 // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 tsopt : 1;                     // DWORD 0
               u32 qinq : 1;                      // DWORD 0
               u32 dupack_count : 2;              // DWORD 0
               u32 action : 4;                    // DWORD 0
               u32 snap : 1;                      // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vtp : 1;                       // DWORD 0
               u32 pbuf_head : 9;                 // DWORD 0
               u32 fbo : 14;                      // DWORD 1
               u32 rsvd3 : 4;                     // DWORD 1
               u32 cid : 11;                      // DWORD 1
               u32 rsvd2 : 3;                     // DWORD 1
               u32 vtag : 16;                     // DWORD 2
               u32 data_offset : 8;               // DWORD 2
               u32 tcp_offset : 8;                // DWORD 2
               u32 completion_flags : 16;         // DWORD 3
               u32 seg_length : 16;               // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_LRO_D, *PTPRE_LRO_D;

      SG_C_ASSERT(__sizeof__TPRE_LRO_D, sizeof (TPRE_LRO_D) == 16);

   #else
      typedef struct _TPRE_LRO_D {
         u32 ulp : 2;                             // DWORD 0
         u32 passthru_desc : 1;                   // DWORD 0
         u32 lro_desc : 1;                        // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 lro_timer_pop : 1;                   // DWORD 0
         u32 compl_flush : 1;                     // DWORD 0
         u32 compl_snap : 1;                      // DWORD 0
         u32 compl_push : 1;                      // DWORD 0
         u32 compl_vtp : 1;                       // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 tsopt : 1;                           // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 dupack_count : 2;                    // DWORD 0
         u32 action : 4;                          // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 pbuf_head : 9;                       // DWORD 0
         u32 fbo : 14;                            // DWORD 1
         u32 rsvd3 : 4;                           // DWORD 1
         u32 cid : 11;                            // DWORD 1
         u32 rsvd2 : 3;                           // DWORD 1
         u32 vtag : 16;                           // DWORD 2
         u32 data_offset : 8;                     // DWORD 2
         u32 tcp_offset : 8;                      // DWORD 2
         u32 completion_flags : 16;               // DWORD 3
         u32 seg_length : 16;                     // DWORD 3
      } SG_PACK TPRE_LRO_D, *PTPRE_LRO_D;

      typedef union _TPRE_LRO_D_UNION {
         TPRE_LRO_D bits;
         u32 dw[4]; // dword union
      } SG_PACK TPRE_LRO_D_UNION, *PTPRE_LRO_D_UNION;

      SG_C_ASSERT(__sizeof__TPRE_LRO_D_UNION, sizeof (TPRE_LRO_D_UNION) == 16);
   #endif


#else
   // LRO Mapping for TPRE_D. Use if bit lro_desc = 1.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_LRO_D {
         union {
            struct { 
               u32 pbuf_head : 9;                 // DWORD 0
               u32 vtp : 1;                       // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 snap : 1;                      // DWORD 0
               u32 action : 4;                    // DWORD 0
               u32 dupack_count : 2;              // DWORD 0
               u32 qinq : 1;                      // DWORD 0
               u32 tsopt : 1;                     // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 compl_vtp : 1;                 // DWORD 0
               u32 compl_push : 1;                // DWORD 0
               u32 compl_snap : 1;                // DWORD 0
               u32 compl_flush : 1;               // DWORD 0
               u32 lro_timer_pop : 1;             // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 lro_desc : 1;                  // DWORD 0
               u32 passthru_desc : 1;             // DWORD 0
               u32 ulp : 2;                       // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 1
               u32 cid : 11;                      // DWORD 1
               u32 rsvd3 : 4;                     // DWORD 1
               u32 fbo : 14;                      // DWORD 1
               u32 tcp_offset : 8;                // DWORD 2
               u32 data_offset : 8;               // DWORD 2
               u32 vtag : 16;                     // DWORD 2
               u32 seg_length : 16;               // DWORD 3
               u32 completion_flags : 16;         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_LRO_D, *PTPRE_LRO_D;

      SG_C_ASSERT(__sizeof__TPRE_LRO_D, sizeof (TPRE_LRO_D) == 16);

   #else
      typedef struct _TPRE_LRO_D {
         u32 pbuf_head : 9;                       // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 action : 4;                          // DWORD 0
         u32 dupack_count : 2;                    // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 tsopt : 1;                           // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 compl_vtp : 1;                       // DWORD 0
         u32 compl_push : 1;                      // DWORD 0
         u32 compl_snap : 1;                      // DWORD 0
         u32 compl_flush : 1;                     // DWORD 0
         u32 lro_timer_pop : 1;                   // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 lro_desc : 1;                        // DWORD 0
         u32 passthru_desc : 1;                   // DWORD 0
         u32 ulp : 2;                             // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 1
         u32 cid : 11;                            // DWORD 1
         u32 rsvd3 : 4;                           // DWORD 1
         u32 fbo : 14;                            // DWORD 1
         u32 tcp_offset : 8;                      // DWORD 2
         u32 data_offset : 8;                     // DWORD 2
         u32 vtag : 16;                           // DWORD 2
         u32 seg_length : 16;                     // DWORD 3
         u32 completion_flags : 16;               // DWORD 3
      } SG_PACK TPRE_LRO_D, *PTPRE_LRO_D;

      typedef union _TPRE_LRO_D_UNION {
         TPRE_LRO_D bits;
         u32 dw[4]; // dword union
      } SG_PACK TPRE_LRO_D_UNION, *PTPRE_LRO_D_UNION;

      SG_C_ASSERT(__sizeof__TPRE_LRO_D_UNION, sizeof (TPRE_LRO_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data/Descriptor for TxULP Input Queue from TCP scheduler; 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXSCHD_D {
         union {
            struct { 
               u32 rsvd0 : 22;                    // DWORD 0
               u32 cid : 10;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXSCHD_D, *PRXSCHD_D;

      SG_C_ASSERT(__sizeof__RXSCHD_D, sizeof (RXSCHD_D) == 4);

   #else
      typedef struct _RXSCHD_D {
         u32 rsvd0 : 22;                          // DWORD 0
         u32 cid : 10;                            // DWORD 0
      } SG_PACK RXSCHD_D, *PRXSCHD_D;

      typedef union _RXSCHD_D_UNION {
         RXSCHD_D bits;
         u32 dw; // dword union
      } SG_PACK RXSCHD_D_UNION, *PRXSCHD_D_UNION;

      SG_C_ASSERT(__sizeof__RXSCHD_D_UNION, sizeof (RXSCHD_D_UNION) == 4);
   #endif


#else
   // Data/Descriptor for TxULP Input Queue from TCP scheduler; 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXSCHD_D {
         union {
            struct { 
               u32 cid : 10;                      // DWORD 0
               u32 rsvd0 : 22;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXSCHD_D, *PRXSCHD_D;

      SG_C_ASSERT(__sizeof__RXSCHD_D, sizeof (RXSCHD_D) == 4);

   #else
      typedef struct _RXSCHD_D {
         u32 cid : 10;                            // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
      } SG_PACK RXSCHD_D, *PRXSCHD_D;

      typedef union _RXSCHD_D_UNION {
         RXSCHD_D bits;
         u32 dw; // dword union
      } SG_PACK RXSCHD_D_UNION, *PRXSCHD_D_UNION;

      SG_C_ASSERT(__sizeof__RXSCHD_D_UNION, sizeof (RXSCHD_D_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // After a packet is written to the appropriate FIFO, the receive filter will write an
   // 128bit pseudo-header with the results of the parsing and checking. This pseudo
   // header is used by the Receive Packet Processor to determine what command descriptor
   // to generate, and where to send it. A special case of this descriptor is called a
   // Marble, and is used to flush receive rings. A Marble is defined as having a LEN
   // field of 32 (decimal) or less, a CT filed of 0, and the MAC_ID field is not RXULP
   // (0x2d). A Marble will not consume a pbuf, and will be sent to ERX.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXFILT_D {
         union {
            struct { 
               u32 s : 1;                         // DWORD 0
               u32 sw : 1;                        // DWORD 0
               u32 dest_id : 10;                  // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 l4_cksm : 1;                   // DWORD 0
               u32 ipcksm : 1;                    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 l3type : 2;                    // DWORD 0
               u32 snap : 1;                      // DWORD 0
               u32 tho : 1;                       // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 vtp : 1;                       // DWORD 0
               u32 mac_id : 6;                    // DWORD 0
               u32 qinq : 1;                      // DWORD 0
               u32 l2type : 2;                    // DWORD 0
               u32 ct : 2;                        // DWORD 1
               u32 len : 14;                      // DWORD 1
               u32 vtag : 16;                     // DWORD 1
               u32 mpacrc;                        // DWORD 2
               u32 rss_hash;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RXFILT_D, *PRXFILT_D;

      SG_C_ASSERT(__sizeof__RXFILT_D, sizeof (RXFILT_D) == 16);

   #else
      typedef struct _RXFILT_D {
         u32 s : 1;                               // DWORD 0
         u32 sw : 1;                              // DWORD 0
         u32 dest_id : 10;                        // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 l4_cksm : 1;                         // DWORD 0
         u32 ipcksm : 1;                          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 l3type : 2;                          // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 tho : 1;                             // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 mac_id : 6;                          // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 l2type : 2;                          // DWORD 0
         u32 ct : 2;                              // DWORD 1
         u32 len : 14;                            // DWORD 1
         u32 vtag : 16;                           // DWORD 1
         u32 mpacrc;                              // DWORD 2
         u32 rss_hash;                            // DWORD 3
      } SG_PACK RXFILT_D, *PRXFILT_D;

      typedef union _RXFILT_D_UNION {
         RXFILT_D bits;
         u32 dw[4]; // dword union
      } SG_PACK RXFILT_D_UNION, *PRXFILT_D_UNION;

      SG_C_ASSERT(__sizeof__RXFILT_D_UNION, sizeof (RXFILT_D_UNION) == 16);
   #endif


#else
   // After a packet is written to the appropriate FIFO, the receive filter will write an
   // 128bit pseudo-header with the results of the parsing and checking. This pseudo
   // header is used by the Receive Packet Processor to determine what command descriptor
   // to generate, and where to send it. A special case of this descriptor is called a
   // Marble, and is used to flush receive rings. A Marble is defined as having a LEN
   // field of 32 (decimal) or less, a CT filed of 0, and the MAC_ID field is not RXULP
   // (0x2d). A Marble will not consume a pbuf, and will be sent to ERX.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXFILT_D {
         union {
            struct { 
               u32 l2type : 2;                    // DWORD 0
               u32 qinq : 1;                      // DWORD 0
               u32 mac_id : 6;                    // DWORD 0
               u32 vtp : 1;                       // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 tho : 1;                       // DWORD 0
               u32 snap : 1;                      // DWORD 0
               u32 l3type : 2;                    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ipcksm : 1;                    // DWORD 0
               u32 l4_cksm : 1;                   // DWORD 0
               u32 ip_version : 1;                // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 dest_id : 10;                  // DWORD 0
               u32 sw : 1;                        // DWORD 0
               u32 s : 1;                         // DWORD 0
               u32 vtag : 16;                     // DWORD 1
               u32 len : 14;                      // DWORD 1
               u32 ct : 2;                        // DWORD 1
               u32 mpacrc;                        // DWORD 2
               u32 rss_hash;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RXFILT_D, *PRXFILT_D;

      SG_C_ASSERT(__sizeof__RXFILT_D, sizeof (RXFILT_D) == 16);

   #else
      typedef struct _RXFILT_D {
         u32 l2type : 2;                          // DWORD 0
         u32 qinq : 1;                            // DWORD 0
         u32 mac_id : 6;                          // DWORD 0
         u32 vtp : 1;                             // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 tho : 1;                             // DWORD 0
         u32 snap : 1;                            // DWORD 0
         u32 l3type : 2;                          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ipcksm : 1;                          // DWORD 0
         u32 l4_cksm : 1;                         // DWORD 0
         u32 ip_version : 1;                      // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 dest_id : 10;                        // DWORD 0
         u32 sw : 1;                              // DWORD 0
         u32 s : 1;                               // DWORD 0
         u32 vtag : 16;                           // DWORD 1
         u32 len : 14;                            // DWORD 1
         u32 ct : 2;                              // DWORD 1
         u32 mpacrc;                              // DWORD 2
         u32 rss_hash;                            // DWORD 3
      } SG_PACK RXFILT_D, *PRXFILT_D;

      typedef union _RXFILT_D_UNION {
         RXFILT_D bits;
         u32 dw[4]; // dword union
      } SG_PACK RXFILT_D_UNION, *PRXFILT_D_UNION;

      SG_C_ASSERT(__sizeof__RXFILT_D_UNION, sizeof (RXFILT_D_UNION) == 16);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __descriptors_bmap_h__

