/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __headers_bmap_h__
#define __headers_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Ethernet header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ETH_HEADER {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 dst_hi16 : 16;                 // DWORD 0
               u32 dst_lo32;                      // DWORD 1
               u32 src_hi32;                      // DWORD 2
               u32 src_lo16 : 16;                 // DWORD 3
               u32 type : 16;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ETH_HEADER, *PETH_HEADER;

      SG_C_ASSERT(__sizeof__ETH_HEADER, sizeof (ETH_HEADER) == 16);

   #else
      typedef struct _ETH_HEADER {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 dst_hi16 : 16;                       // DWORD 0
         u32 dst_lo32;                            // DWORD 1
         u32 src_hi32;                            // DWORD 2
         u32 src_lo16 : 16;                       // DWORD 3
         u32 type : 16;                           // DWORD 3
      } SG_PACK ETH_HEADER, *PETH_HEADER;

      typedef union _ETH_HEADER_UNION {
         ETH_HEADER bits;
         u32 dw[4]; // dword union
      } SG_PACK ETH_HEADER_UNION, *PETH_HEADER_UNION;

      SG_C_ASSERT(__sizeof__ETH_HEADER_UNION, sizeof (ETH_HEADER_UNION) == 16);
   #endif


#else
   // Ethernet header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ETH_HEADER {
         union {
            struct { 
               u32 dst_hi16 : 16;                 // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 dst_lo32;                      // DWORD 1
               u32 src_hi32;                      // DWORD 2
               u32 type : 16;                     // DWORD 3
               u32 src_lo16 : 16;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ETH_HEADER, *PETH_HEADER;

      SG_C_ASSERT(__sizeof__ETH_HEADER, sizeof (ETH_HEADER) == 16);

   #else
      typedef struct _ETH_HEADER {
         u32 dst_hi16 : 16;                       // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 dst_lo32;                            // DWORD 1
         u32 src_hi32;                            // DWORD 2
         u32 type : 16;                           // DWORD 3
         u32 src_lo16 : 16;                       // DWORD 3
      } SG_PACK ETH_HEADER, *PETH_HEADER;

      typedef union _ETH_HEADER_UNION {
         ETH_HEADER bits;
         u32 dw[4]; // dword union
      } SG_PACK ETH_HEADER_UNION, *PETH_HEADER_UNION;

      SG_C_ASSERT(__sizeof__ETH_HEADER_UNION, sizeof (ETH_HEADER_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ethernet header with an 802 VLAN tag.
   #if defined(SG_BMAP_UNION)
      typedef struct _ETH_VLAN_HEADER {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 dst_hi16 : 16;                 // DWORD 0
               u32 dst_lo32;                      // DWORD 1
               u32 src_hi32;                      // DWORD 2
               u32 src_lo16 : 16;                 // DWORD 3
               u32 vlan_type : 16;                // DWORD 3
               u32 priority : 3;                  // DWORD 4
               u32 canonical : 1;                 // DWORD 4
               u32 tag : 12;                      // DWORD 4
               u32 ethertype : 16;                // DWORD 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK ETH_VLAN_HEADER, *PETH_VLAN_HEADER;

      SG_C_ASSERT(__sizeof__ETH_VLAN_HEADER, sizeof (ETH_VLAN_HEADER) == 20);

   #else
      typedef struct _ETH_VLAN_HEADER {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 dst_hi16 : 16;                       // DWORD 0
         u32 dst_lo32;                            // DWORD 1
         u32 src_hi32;                            // DWORD 2
         u32 src_lo16 : 16;                       // DWORD 3
         u32 vlan_type : 16;                      // DWORD 3
         u32 priority : 3;                        // DWORD 4
         u32 canonical : 1;                       // DWORD 4
         u32 tag : 12;                            // DWORD 4
         u32 ethertype : 16;                      // DWORD 4
      } SG_PACK ETH_VLAN_HEADER, *PETH_VLAN_HEADER;

      typedef union _ETH_VLAN_HEADER_UNION {
         ETH_VLAN_HEADER bits;
         u32 dw[5]; // dword union
      } SG_PACK ETH_VLAN_HEADER_UNION, *PETH_VLAN_HEADER_UNION;

      SG_C_ASSERT(__sizeof__ETH_VLAN_HEADER_UNION, sizeof (ETH_VLAN_HEADER_UNION) == 20);
   #endif


#else
   // Ethernet header with an 802 VLAN tag.
   #if defined(SG_BMAP_UNION)
      typedef struct _ETH_VLAN_HEADER {
         union {
            struct { 
               u32 dst_hi16 : 16;                 // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 dst_lo32;                      // DWORD 1
               u32 src_hi32;                      // DWORD 2
               u32 vlan_type : 16;                // DWORD 3
               u32 src_lo16 : 16;                 // DWORD 3
               u32 ethertype : 16;                // DWORD 4
               u32 tag : 12;                      // DWORD 4
               u32 canonical : 1;                 // DWORD 4
               u32 priority : 3;                  // DWORD 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK ETH_VLAN_HEADER, *PETH_VLAN_HEADER;

      SG_C_ASSERT(__sizeof__ETH_VLAN_HEADER, sizeof (ETH_VLAN_HEADER) == 20);

   #else
      typedef struct _ETH_VLAN_HEADER {
         u32 dst_hi16 : 16;                       // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 dst_lo32;                            // DWORD 1
         u32 src_hi32;                            // DWORD 2
         u32 vlan_type : 16;                      // DWORD 3
         u32 src_lo16 : 16;                       // DWORD 3
         u32 ethertype : 16;                      // DWORD 4
         u32 tag : 12;                            // DWORD 4
         u32 canonical : 1;                       // DWORD 4
         u32 priority : 3;                        // DWORD 4
      } SG_PACK ETH_VLAN_HEADER, *PETH_VLAN_HEADER;

      typedef union _ETH_VLAN_HEADER_UNION {
         ETH_VLAN_HEADER bits;
         u32 dw[5]; // dword union
      } SG_PACK ETH_VLAN_HEADER_UNION, *PETH_VLAN_HEADER_UNION;

      SG_C_ASSERT(__sizeof__ETH_VLAN_HEADER_UNION, sizeof (ETH_VLAN_HEADER_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the Priority-based Flow Control (PFC) frame format. Destination address is
   // the globally assigned 48-bit multicast address 01-80-C2-00-00-01. The Source Address
   // field of a MAC Control frame contains the 48-bit individual address of the station
   // sending the frame. The Length/Type field of a MAC Control frame is a 2-octet field
   // that shall contain the hexadecimal value: 88-08. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PFC_FRAME {
         union {
            struct { 
               u32 dst_hi32;                      // DWORD 0
               u32 dst_lo16 : 16;                 // DWORD 1
               u32 src_hi16 : 16;                 // DWORD 1
               u32 src_lo32;                      // DWORD 2
               u32 type : 16;                     // DWORD 3
               u32 ctl_opcode : 16;               // DWORD 3
               u32 rsvd0 : 8;                     // DWORD 4
               u32 pr_en7 : 1;                    // DWORD 4
               u32 pr_en6 : 1;                    // DWORD 4
               u32 pr_en5 : 1;                    // DWORD 4
               u32 pr_en4 : 1;                    // DWORD 4
               u32 pr_en3 : 1;                    // DWORD 4
               u32 pr_en2 : 1;                    // DWORD 4
               u32 pr_en1 : 1;                    // DWORD 4
               u32 pr_en0 : 1;                    // DWORD 4
               u32 time_vector0 : 16;             // DWORD 4
               u32 time_vector1 : 16;             // DWORD 5
               u32 time_vector2 : 16;             // DWORD 5
               u32 time_vector3 : 16;             // DWORD 6
               u32 time_vector4 : 16;             // DWORD 6
               u32 time_vector5 : 16;             // DWORD 7
               u32 time_vector6 : 16;             // DWORD 7
               u32 time_vector7 : 16;             // DWORD 8
               u32 rsvd1 : 16;                    // DWORD 8
               u32 rsvd2[6];                      // DWORDS 9 to 14
            } SG_PACK ; // unnamed struct
            u32 dw[15]; // dword union
         }; // unnamed union
      } SG_PACK PFC_FRAME, *PPFC_FRAME;

      SG_C_ASSERT(__sizeof__PFC_FRAME, sizeof (PFC_FRAME) == 60);

   #else
      typedef struct _PFC_FRAME {
         u32 dst_hi32;                            // DWORD 0
         u32 dst_lo16 : 16;                       // DWORD 1
         u32 src_hi16 : 16;                       // DWORD 1
         u32 src_lo32;                            // DWORD 2
         u32 type : 16;                           // DWORD 3
         u32 ctl_opcode : 16;                     // DWORD 3
         u32 rsvd0 : 8;                           // DWORD 4
         u32 pr_en7 : 1;                          // DWORD 4
         u32 pr_en6 : 1;                          // DWORD 4
         u32 pr_en5 : 1;                          // DWORD 4
         u32 pr_en4 : 1;                          // DWORD 4
         u32 pr_en3 : 1;                          // DWORD 4
         u32 pr_en2 : 1;                          // DWORD 4
         u32 pr_en1 : 1;                          // DWORD 4
         u32 pr_en0 : 1;                          // DWORD 4
         u32 time_vector0 : 16;                   // DWORD 4
         u32 time_vector1 : 16;                   // DWORD 5
         u32 time_vector2 : 16;                   // DWORD 5
         u32 time_vector3 : 16;                   // DWORD 6
         u32 time_vector4 : 16;                   // DWORD 6
         u32 time_vector5 : 16;                   // DWORD 7
         u32 time_vector6 : 16;                   // DWORD 7
         u32 time_vector7 : 16;                   // DWORD 8
         u32 rsvd1 : 16;                          // DWORD 8
         u32 rsvd2[6];                            // DWORDS 9 to 14
      } SG_PACK PFC_FRAME, *PPFC_FRAME;

      typedef union _PFC_FRAME_UNION {
         PFC_FRAME bits;
         u32 dw[15]; // dword union
      } SG_PACK PFC_FRAME_UNION, *PPFC_FRAME_UNION;

      SG_C_ASSERT(__sizeof__PFC_FRAME_UNION, sizeof (PFC_FRAME_UNION) == 60);
   #endif


#else
   // This is the Priority-based Flow Control (PFC) frame format. Destination address is
   // the globally assigned 48-bit multicast address 01-80-C2-00-00-01. The Source Address
   // field of a MAC Control frame contains the 48-bit individual address of the station
   // sending the frame. The Length/Type field of a MAC Control frame is a 2-octet field
   // that shall contain the hexadecimal value: 88-08. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PFC_FRAME {
         union {
            struct { 
               u32 dst_hi32;                      // DWORD 0
               u32 src_hi16 : 16;                 // DWORD 1
               u32 dst_lo16 : 16;                 // DWORD 1
               u32 src_lo32;                      // DWORD 2
               u32 ctl_opcode : 16;               // DWORD 3
               u32 type : 16;                     // DWORD 3
               u32 time_vector0 : 16;             // DWORD 4
               u32 pr_en0 : 1;                    // DWORD 4
               u32 pr_en1 : 1;                    // DWORD 4
               u32 pr_en2 : 1;                    // DWORD 4
               u32 pr_en3 : 1;                    // DWORD 4
               u32 pr_en4 : 1;                    // DWORD 4
               u32 pr_en5 : 1;                    // DWORD 4
               u32 pr_en6 : 1;                    // DWORD 4
               u32 pr_en7 : 1;                    // DWORD 4
               u32 rsvd0 : 8;                     // DWORD 4
               u32 time_vector2 : 16;             // DWORD 5
               u32 time_vector1 : 16;             // DWORD 5
               u32 time_vector4 : 16;             // DWORD 6
               u32 time_vector3 : 16;             // DWORD 6
               u32 time_vector6 : 16;             // DWORD 7
               u32 time_vector5 : 16;             // DWORD 7
               u32 rsvd1 : 16;                    // DWORD 8
               u32 time_vector7 : 16;             // DWORD 8
               u32 rsvd2[6];                      // DWORDS 9 to 14
            } SG_PACK ; // unnamed struct
            u32 dw[15]; // dword union
         }; // unnamed union
      } SG_PACK PFC_FRAME, *PPFC_FRAME;

      SG_C_ASSERT(__sizeof__PFC_FRAME, sizeof (PFC_FRAME) == 60);

   #else
      typedef struct _PFC_FRAME {
         u32 dst_hi32;                            // DWORD 0
         u32 src_hi16 : 16;                       // DWORD 1
         u32 dst_lo16 : 16;                       // DWORD 1
         u32 src_lo32;                            // DWORD 2
         u32 ctl_opcode : 16;                     // DWORD 3
         u32 type : 16;                           // DWORD 3
         u32 time_vector0 : 16;                   // DWORD 4
         u32 pr_en0 : 1;                          // DWORD 4
         u32 pr_en1 : 1;                          // DWORD 4
         u32 pr_en2 : 1;                          // DWORD 4
         u32 pr_en3 : 1;                          // DWORD 4
         u32 pr_en4 : 1;                          // DWORD 4
         u32 pr_en5 : 1;                          // DWORD 4
         u32 pr_en6 : 1;                          // DWORD 4
         u32 pr_en7 : 1;                          // DWORD 4
         u32 rsvd0 : 8;                           // DWORD 4
         u32 time_vector2 : 16;                   // DWORD 5
         u32 time_vector1 : 16;                   // DWORD 5
         u32 time_vector4 : 16;                   // DWORD 6
         u32 time_vector3 : 16;                   // DWORD 6
         u32 time_vector6 : 16;                   // DWORD 7
         u32 time_vector5 : 16;                   // DWORD 7
         u32 rsvd1 : 16;                          // DWORD 8
         u32 time_vector7 : 16;                   // DWORD 8
         u32 rsvd2[6];                            // DWORDS 9 to 14
      } SG_PACK PFC_FRAME, *PPFC_FRAME;

      typedef union _PFC_FRAME_UNION {
         PFC_FRAME bits;
         u32 dw[15]; // dword union
      } SG_PACK PFC_FRAME_UNION, *PPFC_FRAME_UNION;

      SG_C_ASSERT(__sizeof__PFC_FRAME_UNION, sizeof (PFC_FRAME_UNION) == 60);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SNAP_HEADER {
         union {
            struct { 
               u32 dsap : 8;                      // DWORD 0
               u32 ssap : 8;                      // DWORD 0
               u32 cntl : 8;                      // DWORD 0
               u32 orgcode_hi : 8;                // DWORD 0
               u32 orgcode_lo : 16;               // DWORD 1
               u32 type : 16;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SNAP_HEADER, *PSNAP_HEADER;

      SG_C_ASSERT(__sizeof__SNAP_HEADER, sizeof (SNAP_HEADER) == 8);

   #else
      typedef struct _SNAP_HEADER {
         u32 dsap : 8;                            // DWORD 0
         u32 ssap : 8;                            // DWORD 0
         u32 cntl : 8;                            // DWORD 0
         u32 orgcode_hi : 8;                      // DWORD 0
         u32 orgcode_lo : 16;                     // DWORD 1
         u32 type : 16;                           // DWORD 1
      } SG_PACK SNAP_HEADER, *PSNAP_HEADER;

      typedef union _SNAP_HEADER_UNION {
         SNAP_HEADER bits;
         u32 dw[2]; // dword union
      } SG_PACK SNAP_HEADER_UNION, *PSNAP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__SNAP_HEADER_UNION, sizeof (SNAP_HEADER_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SNAP_HEADER {
         union {
            struct { 
               u32 orgcode_hi : 8;                // DWORD 0
               u32 cntl : 8;                      // DWORD 0
               u32 ssap : 8;                      // DWORD 0
               u32 dsap : 8;                      // DWORD 0
               u32 type : 16;                     // DWORD 1
               u32 orgcode_lo : 16;               // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SNAP_HEADER, *PSNAP_HEADER;

      SG_C_ASSERT(__sizeof__SNAP_HEADER, sizeof (SNAP_HEADER) == 8);

   #else
      typedef struct _SNAP_HEADER {
         u32 orgcode_hi : 8;                      // DWORD 0
         u32 cntl : 8;                            // DWORD 0
         u32 ssap : 8;                            // DWORD 0
         u32 dsap : 8;                            // DWORD 0
         u32 type : 16;                           // DWORD 1
         u32 orgcode_lo : 16;                     // DWORD 1
      } SG_PACK SNAP_HEADER, *PSNAP_HEADER;

      typedef union _SNAP_HEADER_UNION {
         SNAP_HEADER bits;
         u32 dw[2]; // dword union
      } SG_PACK SNAP_HEADER_UNION, *PSNAP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__SNAP_HEADER_UNION, sizeof (SNAP_HEADER_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IPV4 header.
   #if defined(SG_BMAP_UNION)
      typedef struct _IP_HEADER {
         union {
            struct { 
               u32 version : 4;                   // DWORD 0
               u32 headerLength : 4;              // DWORD 0
               u32 tos : 8;                       // DWORD 0
               u32 length : 16;                   // DWORD 0
               u32 id : 16;                       // DWORD 1
               u32 flags : 3;                     // DWORD 1
               u32 fragOffset : 13;               // DWORD 1
               u32 ttl : 8;                       // DWORD 2
               u32 protocol : 8;                  // DWORD 2
               u32 checksum : 16;                 // DWORD 2
               u32 src;                           // DWORD 3
               u32 dst;                           // DWORD 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IP_HEADER, *PIP_HEADER;

      SG_C_ASSERT(__sizeof__IP_HEADER, sizeof (IP_HEADER) == 20);

   #else
      typedef struct _IP_HEADER {
         u32 version : 4;                         // DWORD 0
         u32 headerLength : 4;                    // DWORD 0
         u32 tos : 8;                             // DWORD 0
         u32 length : 16;                         // DWORD 0
         u32 id : 16;                             // DWORD 1
         u32 flags : 3;                           // DWORD 1
         u32 fragOffset : 13;                     // DWORD 1
         u32 ttl : 8;                             // DWORD 2
         u32 protocol : 8;                        // DWORD 2
         u32 checksum : 16;                       // DWORD 2
         u32 src;                                 // DWORD 3
         u32 dst;                                 // DWORD 4
      } SG_PACK IP_HEADER, *PIP_HEADER;

      typedef union _IP_HEADER_UNION {
         IP_HEADER bits;
         u32 dw[5]; // dword union
      } SG_PACK IP_HEADER_UNION, *PIP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IP_HEADER_UNION, sizeof (IP_HEADER_UNION) == 20);
   #endif


#else
   // IPV4 header.
   #if defined(SG_BMAP_UNION)
      typedef struct _IP_HEADER {
         union {
            struct { 
               u32 length : 16;                   // DWORD 0
               u32 tos : 8;                       // DWORD 0
               u32 headerLength : 4;              // DWORD 0
               u32 version : 4;                   // DWORD 0
               u32 fragOffset : 13;               // DWORD 1
               u32 flags : 3;                     // DWORD 1
               u32 id : 16;                       // DWORD 1
               u32 checksum : 16;                 // DWORD 2
               u32 protocol : 8;                  // DWORD 2
               u32 ttl : 8;                       // DWORD 2
               u32 src;                           // DWORD 3
               u32 dst;                           // DWORD 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IP_HEADER, *PIP_HEADER;

      SG_C_ASSERT(__sizeof__IP_HEADER, sizeof (IP_HEADER) == 20);

   #else
      typedef struct _IP_HEADER {
         u32 length : 16;                         // DWORD 0
         u32 tos : 8;                             // DWORD 0
         u32 headerLength : 4;                    // DWORD 0
         u32 version : 4;                         // DWORD 0
         u32 fragOffset : 13;                     // DWORD 1
         u32 flags : 3;                           // DWORD 1
         u32 id : 16;                             // DWORD 1
         u32 checksum : 16;                       // DWORD 2
         u32 protocol : 8;                        // DWORD 2
         u32 ttl : 8;                             // DWORD 2
         u32 src;                                 // DWORD 3
         u32 dst;                                 // DWORD 4
      } SG_PACK IP_HEADER, *PIP_HEADER;

      typedef union _IP_HEADER_UNION {
         IP_HEADER bits;
         u32 dw[5]; // dword union
      } SG_PACK IP_HEADER_UNION, *PIP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IP_HEADER_UNION, sizeof (IP_HEADER_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IPV6 header.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPV6_HEADER {
         union {
            struct { 
               u32 version : 4;                   // DWORD 0
               u32 trafficClass : 8;              // DWORD 0
               u32 flowLabel : 20;                // DWORD 0
               u32 payloadLength : 16;            // DWORD 1
               u32 nextHeader : 8;                // DWORD 1
               u32 hopLimit : 8;                  // DWORD 1
               u32 src[4];                        // DWORDS 2 to 5
               u32 dst[4];                        // DWORDS 6 to 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK IPV6_HEADER, *PIPV6_HEADER;

      SG_C_ASSERT(__sizeof__IPV6_HEADER, sizeof (IPV6_HEADER) == 40);

   #else
      typedef struct _IPV6_HEADER {
         u32 version : 4;                         // DWORD 0
         u32 trafficClass : 8;                    // DWORD 0
         u32 flowLabel : 20;                      // DWORD 0
         u32 payloadLength : 16;                  // DWORD 1
         u32 nextHeader : 8;                      // DWORD 1
         u32 hopLimit : 8;                        // DWORD 1
         u32 src[4];                              // DWORDS 2 to 5
         u32 dst[4];                              // DWORDS 6 to 9
      } SG_PACK IPV6_HEADER, *PIPV6_HEADER;

      typedef union _IPV6_HEADER_UNION {
         IPV6_HEADER bits;
         u32 dw[10]; // dword union
      } SG_PACK IPV6_HEADER_UNION, *PIPV6_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IPV6_HEADER_UNION, sizeof (IPV6_HEADER_UNION) == 40);
   #endif


#else
   // IPV6 header.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPV6_HEADER {
         union {
            struct { 
               u32 flowLabel : 20;                // DWORD 0
               u32 trafficClass : 8;              // DWORD 0
               u32 version : 4;                   // DWORD 0
               u32 hopLimit : 8;                  // DWORD 1
               u32 nextHeader : 8;                // DWORD 1
               u32 payloadLength : 16;            // DWORD 1
               u32 src[4];                        // DWORDS 2 to 5
               u32 dst[4];                        // DWORDS 6 to 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK IPV6_HEADER, *PIPV6_HEADER;

      SG_C_ASSERT(__sizeof__IPV6_HEADER, sizeof (IPV6_HEADER) == 40);

   #else
      typedef struct _IPV6_HEADER {
         u32 flowLabel : 20;                      // DWORD 0
         u32 trafficClass : 8;                    // DWORD 0
         u32 version : 4;                         // DWORD 0
         u32 hopLimit : 8;                        // DWORD 1
         u32 nextHeader : 8;                      // DWORD 1
         u32 payloadLength : 16;                  // DWORD 1
         u32 src[4];                              // DWORDS 2 to 5
         u32 dst[4];                              // DWORDS 6 to 9
      } SG_PACK IPV6_HEADER, *PIPV6_HEADER;

      typedef union _IPV6_HEADER_UNION {
         IPV6_HEADER bits;
         u32 dw[10]; // dword union
      } SG_PACK IPV6_HEADER_UNION, *PIPV6_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IPV6_HEADER_UNION, sizeof (IPV6_HEADER_UNION) == 40);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UDP_HEADER {
         union {
            struct { 
               u32 srcPort : 16;                  // DWORD 0
               u32 dstPort : 16;                  // DWORD 0
               u32 length : 16;                   // DWORD 1
               u32 checksum : 16;                 // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK UDP_HEADER, *PUDP_HEADER;

      SG_C_ASSERT(__sizeof__UDP_HEADER, sizeof (UDP_HEADER) == 8);

   #else
      typedef struct _UDP_HEADER {
         u32 srcPort : 16;                        // DWORD 0
         u32 dstPort : 16;                        // DWORD 0
         u32 length : 16;                         // DWORD 1
         u32 checksum : 16;                       // DWORD 1
      } SG_PACK UDP_HEADER, *PUDP_HEADER;

      typedef union _UDP_HEADER_UNION {
         UDP_HEADER bits;
         u32 dw[2]; // dword union
      } SG_PACK UDP_HEADER_UNION, *PUDP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__UDP_HEADER_UNION, sizeof (UDP_HEADER_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UDP_HEADER {
         union {
            struct { 
               u32 dstPort : 16;                  // DWORD 0
               u32 srcPort : 16;                  // DWORD 0
               u32 checksum : 16;                 // DWORD 1
               u32 length : 16;                   // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK UDP_HEADER, *PUDP_HEADER;

      SG_C_ASSERT(__sizeof__UDP_HEADER, sizeof (UDP_HEADER) == 8);

   #else
      typedef struct _UDP_HEADER {
         u32 dstPort : 16;                        // DWORD 0
         u32 srcPort : 16;                        // DWORD 0
         u32 checksum : 16;                       // DWORD 1
         u32 length : 16;                         // DWORD 1
      } SG_PACK UDP_HEADER, *PUDP_HEADER;

      typedef union _UDP_HEADER_UNION {
         UDP_HEADER bits;
         u32 dw[2]; // dword union
      } SG_PACK UDP_HEADER_UNION, *PUDP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__UDP_HEADER_UNION, sizeof (UDP_HEADER_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TCP header format. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_HEADER {
         union {
            struct { 
               u32 srcPort : 16;                  // DWORD 0
               u32 dstPort : 16;                  // DWORD 0
               u32 th_seq;                        // DWORD 1
               u32 th_ack;                        // DWORD 2
               u32 th_off : 4;                    // DWORD 3
               u32 rsvd0 : 6;                     // DWORD 3
               u32 th_flags : 6;                  // DWORD 3
               u32 th_win : 16;                   // DWORD 3
               u32 th_sum : 16;                   // DWORD 4
               u32 urgentPtr : 16;                // DWORD 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK TCP_HEADER, *PTCP_HEADER;

      SG_C_ASSERT(__sizeof__TCP_HEADER, sizeof (TCP_HEADER) == 20);

   #else
      typedef struct _TCP_HEADER {
         u32 srcPort : 16;                        // DWORD 0
         u32 dstPort : 16;                        // DWORD 0
         u32 th_seq;                              // DWORD 1
         u32 th_ack;                              // DWORD 2
         u32 th_off : 4;                          // DWORD 3
         u32 rsvd0 : 6;                           // DWORD 3
         u32 th_flags : 6;                        // DWORD 3
         u32 th_win : 16;                         // DWORD 3
         u32 th_sum : 16;                         // DWORD 4
         u32 urgentPtr : 16;                      // DWORD 4
      } SG_PACK TCP_HEADER, *PTCP_HEADER;

      typedef union _TCP_HEADER_UNION {
         TCP_HEADER bits;
         u32 dw[5]; // dword union
      } SG_PACK TCP_HEADER_UNION, *PTCP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TCP_HEADER_UNION, sizeof (TCP_HEADER_UNION) == 20);
   #endif


#else
   // TCP header format. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_HEADER {
         union {
            struct { 
               u32 dstPort : 16;                  // DWORD 0
               u32 srcPort : 16;                  // DWORD 0
               u32 th_seq;                        // DWORD 1
               u32 th_ack;                        // DWORD 2
               u32 th_win : 16;                   // DWORD 3
               u32 th_flags : 6;                  // DWORD 3
               u32 rsvd0 : 6;                     // DWORD 3
               u32 th_off : 4;                    // DWORD 3
               u32 urgentPtr : 16;                // DWORD 4
               u32 th_sum : 16;                   // DWORD 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK TCP_HEADER, *PTCP_HEADER;

      SG_C_ASSERT(__sizeof__TCP_HEADER, sizeof (TCP_HEADER) == 20);

   #else
      typedef struct _TCP_HEADER {
         u32 dstPort : 16;                        // DWORD 0
         u32 srcPort : 16;                        // DWORD 0
         u32 th_seq;                              // DWORD 1
         u32 th_ack;                              // DWORD 2
         u32 th_win : 16;                         // DWORD 3
         u32 th_flags : 6;                        // DWORD 3
         u32 rsvd0 : 6;                           // DWORD 3
         u32 th_off : 4;                          // DWORD 3
         u32 urgentPtr : 16;                      // DWORD 4
         u32 th_sum : 16;                         // DWORD 4
      } SG_PACK TCP_HEADER, *PTCP_HEADER;

      typedef union _TCP_HEADER_UNION {
         TCP_HEADER bits;
         u32 dw[5]; // dword union
      } SG_PACK TCP_HEADER_UNION, *PTCP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TCP_HEADER_UNION, sizeof (TCP_HEADER_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TCP timestamp option format suitable for endian toggling each 32-bit dword. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_TIMESTAMP {
         union {
            struct { 
               u32 nop2 : 8;                      // DWORD 0
               u32 nop1 : 8;                      // DWORD 0
               u32 kind : 8;                      // DWORD 0
               u32 len : 8;                       // DWORD 0
               u32 ts_value;                      // DWORD 1
               u32 ts_echo_reply;                 // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK TCP_TIMESTAMP, *PTCP_TIMESTAMP;

      SG_C_ASSERT(__sizeof__TCP_TIMESTAMP, sizeof (TCP_TIMESTAMP) == 12);

   #else
      typedef struct _TCP_TIMESTAMP {
         u32 nop2 : 8;                            // DWORD 0
         u32 nop1 : 8;                            // DWORD 0
         u32 kind : 8;                            // DWORD 0
         u32 len : 8;                             // DWORD 0
         u32 ts_value;                            // DWORD 1
         u32 ts_echo_reply;                       // DWORD 2
      } SG_PACK TCP_TIMESTAMP, *PTCP_TIMESTAMP;

      typedef union _TCP_TIMESTAMP_UNION {
         TCP_TIMESTAMP bits;
         u32 dw[3]; // dword union
      } SG_PACK TCP_TIMESTAMP_UNION, *PTCP_TIMESTAMP_UNION;

      SG_C_ASSERT(__sizeof__TCP_TIMESTAMP_UNION, sizeof (TCP_TIMESTAMP_UNION) == 12);
   #endif


#else
   // TCP timestamp option format suitable for endian toggling each 32-bit dword. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_TIMESTAMP {
         union {
            struct { 
               u32 len : 8;                       // DWORD 0
               u32 kind : 8;                      // DWORD 0
               u32 nop1 : 8;                      // DWORD 0
               u32 nop2 : 8;                      // DWORD 0
               u32 ts_value;                      // DWORD 1
               u32 ts_echo_reply;                 // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK TCP_TIMESTAMP, *PTCP_TIMESTAMP;

      SG_C_ASSERT(__sizeof__TCP_TIMESTAMP, sizeof (TCP_TIMESTAMP) == 12);

   #else
      typedef struct _TCP_TIMESTAMP {
         u32 len : 8;                             // DWORD 0
         u32 kind : 8;                            // DWORD 0
         u32 nop1 : 8;                            // DWORD 0
         u32 nop2 : 8;                            // DWORD 0
         u32 ts_value;                            // DWORD 1
         u32 ts_echo_reply;                       // DWORD 2
      } SG_PACK TCP_TIMESTAMP, *PTCP_TIMESTAMP;

      typedef union _TCP_TIMESTAMP_UNION {
         TCP_TIMESTAMP bits;
         u32 dw[3]; // dword union
      } SG_PACK TCP_TIMESTAMP_UNION, *PTCP_TIMESTAMP_UNION;

      SG_C_ASSERT(__sizeof__TCP_TIMESTAMP_UNION, sizeof (TCP_TIMESTAMP_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Basic ISCSI header format
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_BHS {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 F : 1;                         // DWORD 0
               u32 opcodeSpecificFields : 23;     // DWORD 0
               u32 totalAHSLength : 8;            // DWORD 1
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 lunOrOpcodeSpecificFields[2];  // DWORDS 2 to 3
               u32 itt;                           // DWORD 4
               u32 opcodeSpecificFields1[7];      // DWORDS 5 to 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_BHS, *PISCSI_BHS;

      SG_C_ASSERT(__sizeof__ISCSI_BHS, sizeof (ISCSI_BHS) == 48);

   #else
      typedef struct _ISCSI_BHS {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 F : 1;                               // DWORD 0
         u32 opcodeSpecificFields : 23;           // DWORD 0
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 lunOrOpcodeSpecificFields[2];        // DWORDS 2 to 3
         u32 itt;                                 // DWORD 4
         u32 opcodeSpecificFields1[7];            // DWORDS 5 to 11
      } SG_PACK ISCSI_BHS, *PISCSI_BHS;

      typedef union _ISCSI_BHS_UNION {
         ISCSI_BHS bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_BHS_UNION, *PISCSI_BHS_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_BHS_UNION, sizeof (ISCSI_BHS_UNION) == 48);
   #endif


#else
   // Basic ISCSI header format
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_BHS {
         union {
            struct { 
               u32 opcodeSpecificFields : 23;     // DWORD 0
               u32 F : 1;                         // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 totalAHSLength : 8;            // DWORD 1
               u32 lunOrOpcodeSpecificFields[2];  // DWORDS 2 to 3
               u32 itt;                           // DWORD 4
               u32 opcodeSpecificFields1[7];      // DWORDS 5 to 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_BHS, *PISCSI_BHS;

      SG_C_ASSERT(__sizeof__ISCSI_BHS, sizeof (ISCSI_BHS) == 48);

   #else
      typedef struct _ISCSI_BHS {
         u32 opcodeSpecificFields : 23;           // DWORD 0
         u32 F : 1;                               // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 lunOrOpcodeSpecificFields[2];        // DWORDS 2 to 3
         u32 itt;                                 // DWORD 4
         u32 opcodeSpecificFields1[7];            // DWORDS 5 to 11
      } SG_PACK ISCSI_BHS, *PISCSI_BHS;

      typedef union _ISCSI_BHS_UNION {
         ISCSI_BHS bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_BHS_UNION, *PISCSI_BHS_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_BHS_UNION, sizeof (ISCSI_BHS_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The iSCSI data in header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_DATA_IN_HDR {
         union {
            struct { 
               u32 rsvd2 : 2;                     // DWORD 0
               u32 opcode : 6;                    // DWORD 0
               u32 F : 1;                         // DWORD 0
               u32 A : 1;                         // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 O : 1;                         // DWORD 0
               u32 U : 1;                         // DWORD 0
               u32 S : 1;                         // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 status : 8;                    // DWORD 0
               u32 totalAHSLength : 8;            // DWORD 1
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 lun[2];                        // DWORDS 2 to 3
               u32 itt;                           // DWORD 4
               u32 ttt;                           // DWORD 5
               u32 statSN;                        // DWORD 6
               u32 expCmdSN;                      // DWORD 7
               u32 maxCmdSN;                      // DWORD 8
               u32 dataSN;                        // DWORD 9
               u32 bufferOffset;                  // DWORD 10
               u32 residualCount;                 // DWORD 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_DATA_IN_HDR, *PISCSI_DATA_IN_HDR;

      SG_C_ASSERT(__sizeof__ISCSI_DATA_IN_HDR, sizeof (ISCSI_DATA_IN_HDR) == 48);

   #else
      typedef struct _ISCSI_DATA_IN_HDR {
         u32 rsvd2 : 2;                           // DWORD 0
         u32 opcode : 6;                          // DWORD 0
         u32 F : 1;                               // DWORD 0
         u32 A : 1;                               // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 O : 1;                               // DWORD 0
         u32 U : 1;                               // DWORD 0
         u32 S : 1;                               // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 status : 8;                          // DWORD 0
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 lun[2];                              // DWORDS 2 to 3
         u32 itt;                                 // DWORD 4
         u32 ttt;                                 // DWORD 5
         u32 statSN;                              // DWORD 6
         u32 expCmdSN;                            // DWORD 7
         u32 maxCmdSN;                            // DWORD 8
         u32 dataSN;                              // DWORD 9
         u32 bufferOffset;                        // DWORD 10
         u32 residualCount;                       // DWORD 11
      } SG_PACK ISCSI_DATA_IN_HDR, *PISCSI_DATA_IN_HDR;

      typedef union _ISCSI_DATA_IN_HDR_UNION {
         ISCSI_DATA_IN_HDR bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_DATA_IN_HDR_UNION, *PISCSI_DATA_IN_HDR_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_DATA_IN_HDR_UNION, sizeof (ISCSI_DATA_IN_HDR_UNION) == 48);
   #endif


#else
   // The iSCSI data in header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_DATA_IN_HDR {
         union {
            struct { 
               u32 status : 8;                    // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 S : 1;                         // DWORD 0
               u32 U : 1;                         // DWORD 0
               u32 O : 1;                         // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 A : 1;                         // DWORD 0
               u32 F : 1;                         // DWORD 0
               u32 opcode : 6;                    // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 totalAHSLength : 8;            // DWORD 1
               u32 lun[2];                        // DWORDS 2 to 3
               u32 itt;                           // DWORD 4
               u32 ttt;                           // DWORD 5
               u32 statSN;                        // DWORD 6
               u32 expCmdSN;                      // DWORD 7
               u32 maxCmdSN;                      // DWORD 8
               u32 dataSN;                        // DWORD 9
               u32 bufferOffset;                  // DWORD 10
               u32 residualCount;                 // DWORD 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_DATA_IN_HDR, *PISCSI_DATA_IN_HDR;

      SG_C_ASSERT(__sizeof__ISCSI_DATA_IN_HDR, sizeof (ISCSI_DATA_IN_HDR) == 48);

   #else
      typedef struct _ISCSI_DATA_IN_HDR {
         u32 status : 8;                          // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 S : 1;                               // DWORD 0
         u32 U : 1;                               // DWORD 0
         u32 O : 1;                               // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 A : 1;                               // DWORD 0
         u32 F : 1;                               // DWORD 0
         u32 opcode : 6;                          // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 lun[2];                              // DWORDS 2 to 3
         u32 itt;                                 // DWORD 4
         u32 ttt;                                 // DWORD 5
         u32 statSN;                              // DWORD 6
         u32 expCmdSN;                            // DWORD 7
         u32 maxCmdSN;                            // DWORD 8
         u32 dataSN;                              // DWORD 9
         u32 bufferOffset;                        // DWORD 10
         u32 residualCount;                       // DWORD 11
      } SG_PACK ISCSI_DATA_IN_HDR, *PISCSI_DATA_IN_HDR;

      typedef union _ISCSI_DATA_IN_HDR_UNION {
         ISCSI_DATA_IN_HDR bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_DATA_IN_HDR_UNION, *PISCSI_DATA_IN_HDR_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_DATA_IN_HDR_UNION, sizeof (ISCSI_DATA_IN_HDR_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The iSCSI data out header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_DATA_OUT_HDR {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 opcode : 6;                    // DWORD 0
               u32 final : 1;                     // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
               u32 totalAHSLength : 8;            // DWORD 1
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 rsvd2[1];                      // DWORDS 2 to 2
               u32 rsvd3[1];                      // DWORDS 3 to 3
               u32 itt;                           // DWORD 4
               u32 ttt;                           // DWORD 5
               u32 rsvd4[1];                      // DWORDS 6 to 6
               u32 ExpStatSN;                     // DWORD 7
               u32 rsvd5[1];                      // DWORDS 8 to 8
               u32 dataSN;                        // DWORD 9
               u32 bufferOffset;                  // DWORD 10
               u32 rsvd6[1];                      // DWORDS 11 to 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_DATA_OUT_HDR, *PISCSI_DATA_OUT_HDR;

      SG_C_ASSERT(__sizeof__ISCSI_DATA_OUT_HDR, sizeof (ISCSI_DATA_OUT_HDR) == 48);

   #else
      typedef struct _ISCSI_DATA_OUT_HDR {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 opcode : 6;                          // DWORD 0
         u32 final : 1;                           // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 rsvd2[1];                            // DWORDS 2 to 2
         u32 rsvd3[1];                            // DWORDS 3 to 3
         u32 itt;                                 // DWORD 4
         u32 ttt;                                 // DWORD 5
         u32 rsvd4[1];                            // DWORDS 6 to 6
         u32 ExpStatSN;                           // DWORD 7
         u32 rsvd5[1];                            // DWORDS 8 to 8
         u32 dataSN;                              // DWORD 9
         u32 bufferOffset;                        // DWORD 10
         u32 rsvd6[1];                            // DWORDS 11 to 11
      } SG_PACK ISCSI_DATA_OUT_HDR, *PISCSI_DATA_OUT_HDR;

      typedef union _ISCSI_DATA_OUT_HDR_UNION {
         ISCSI_DATA_OUT_HDR bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_DATA_OUT_HDR_UNION, *PISCSI_DATA_OUT_HDR_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_DATA_OUT_HDR_UNION, sizeof (ISCSI_DATA_OUT_HDR_UNION) == 48);
   #endif


#else
   // The iSCSI data out header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_DATA_OUT_HDR {
         union {
            struct { 
               u32 rsvd0 : 23;                    // DWORD 0
               u32 final : 1;                     // DWORD 0
               u32 opcode : 6;                    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 totalAHSLength : 8;            // DWORD 1
               u32 rsvd2[1];                      // DWORDS 2 to 2
               u32 rsvd3[1];                      // DWORDS 3 to 3
               u32 itt;                           // DWORD 4
               u32 ttt;                           // DWORD 5
               u32 rsvd4[1];                      // DWORDS 6 to 6
               u32 ExpStatSN;                     // DWORD 7
               u32 rsvd5[1];                      // DWORDS 8 to 8
               u32 dataSN;                        // DWORD 9
               u32 bufferOffset;                  // DWORD 10
               u32 rsvd6[1];                      // DWORDS 11 to 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_DATA_OUT_HDR, *PISCSI_DATA_OUT_HDR;

      SG_C_ASSERT(__sizeof__ISCSI_DATA_OUT_HDR, sizeof (ISCSI_DATA_OUT_HDR) == 48);

   #else
      typedef struct _ISCSI_DATA_OUT_HDR {
         u32 rsvd0 : 23;                          // DWORD 0
         u32 final : 1;                           // DWORD 0
         u32 opcode : 6;                          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 rsvd2[1];                            // DWORDS 2 to 2
         u32 rsvd3[1];                            // DWORDS 3 to 3
         u32 itt;                                 // DWORD 4
         u32 ttt;                                 // DWORD 5
         u32 rsvd4[1];                            // DWORDS 6 to 6
         u32 ExpStatSN;                           // DWORD 7
         u32 rsvd5[1];                            // DWORDS 8 to 8
         u32 dataSN;                              // DWORD 9
         u32 bufferOffset;                        // DWORD 10
         u32 rsvd6[1];                            // DWORDS 11 to 11
      } SG_PACK ISCSI_DATA_OUT_HDR, *PISCSI_DATA_OUT_HDR;

      typedef union _ISCSI_DATA_OUT_HDR_UNION {
         ISCSI_DATA_OUT_HDR bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_DATA_OUT_HDR_UNION, *PISCSI_DATA_OUT_HDR_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_DATA_OUT_HDR_UNION, sizeof (ISCSI_DATA_OUT_HDR_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The iSCSI R2T header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_R2T_HDR {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 opcode : 6;                    // DWORD 0
               u32 final : 1;                     // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
               u32 totalAHSLength : 8;            // DWORD 1
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 lunHi;                         // DWORD 2
               u32 lunLo;                         // DWORD 3
               u32 itt;                           // DWORD 4
               u32 ttt;                           // DWORD 5
               u32 StatSN;                        // DWORD 6
               u32 ExpCmdSN;                      // DWORD 7
               u32 MaxCmdSN;                      // DWORD 8
               u32 R2TSN;                         // DWORD 9
               u32 bufferOffset;                  // DWORD 10
               u32 desiredDataTransferLength;     // DWORD 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_R2T_HDR, *PISCSI_R2T_HDR;

      SG_C_ASSERT(__sizeof__ISCSI_R2T_HDR, sizeof (ISCSI_R2T_HDR) == 48);

   #else
      typedef struct _ISCSI_R2T_HDR {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 opcode : 6;                          // DWORD 0
         u32 final : 1;                           // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 lunHi;                               // DWORD 2
         u32 lunLo;                               // DWORD 3
         u32 itt;                                 // DWORD 4
         u32 ttt;                                 // DWORD 5
         u32 StatSN;                              // DWORD 6
         u32 ExpCmdSN;                            // DWORD 7
         u32 MaxCmdSN;                            // DWORD 8
         u32 R2TSN;                               // DWORD 9
         u32 bufferOffset;                        // DWORD 10
         u32 desiredDataTransferLength;           // DWORD 11
      } SG_PACK ISCSI_R2T_HDR, *PISCSI_R2T_HDR;

      typedef union _ISCSI_R2T_HDR_UNION {
         ISCSI_R2T_HDR bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_R2T_HDR_UNION, *PISCSI_R2T_HDR_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_R2T_HDR_UNION, sizeof (ISCSI_R2T_HDR_UNION) == 48);
   #endif


#else
   // The iSCSI R2T header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_R2T_HDR {
         union {
            struct { 
               u32 rsvd0 : 23;                    // DWORD 0
               u32 final : 1;                     // DWORD 0
               u32 opcode : 6;                    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 totalAHSLength : 8;            // DWORD 1
               u32 lunHi;                         // DWORD 2
               u32 lunLo;                         // DWORD 3
               u32 itt;                           // DWORD 4
               u32 ttt;                           // DWORD 5
               u32 StatSN;                        // DWORD 6
               u32 ExpCmdSN;                      // DWORD 7
               u32 MaxCmdSN;                      // DWORD 8
               u32 R2TSN;                         // DWORD 9
               u32 bufferOffset;                  // DWORD 10
               u32 desiredDataTransferLength;     // DWORD 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_R2T_HDR, *PISCSI_R2T_HDR;

      SG_C_ASSERT(__sizeof__ISCSI_R2T_HDR, sizeof (ISCSI_R2T_HDR) == 48);

   #else
      typedef struct _ISCSI_R2T_HDR {
         u32 rsvd0 : 23;                          // DWORD 0
         u32 final : 1;                           // DWORD 0
         u32 opcode : 6;                          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 lunHi;                               // DWORD 2
         u32 lunLo;                               // DWORD 3
         u32 itt;                                 // DWORD 4
         u32 ttt;                                 // DWORD 5
         u32 StatSN;                              // DWORD 6
         u32 ExpCmdSN;                            // DWORD 7
         u32 MaxCmdSN;                            // DWORD 8
         u32 R2TSN;                               // DWORD 9
         u32 bufferOffset;                        // DWORD 10
         u32 desiredDataTransferLength;           // DWORD 11
      } SG_PACK ISCSI_R2T_HDR, *PISCSI_R2T_HDR;

      typedef union _ISCSI_R2T_HDR_UNION {
         ISCSI_R2T_HDR bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_R2T_HDR_UNION, *PISCSI_R2T_HDR_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_R2T_HDR_UNION, sizeof (ISCSI_R2T_HDR_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The iSCSI command header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CMD_HDR {
         union {
            struct { 
               u32 rsvd2 : 16;                    // DWORD 0
               u32 attributes : 3;                // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 rd : 1;                        // DWORD 0
               u32 final : 1;                     // DWORD 0
               u32 opcode : 6;                    // DWORD 0
               u32 immediate : 1;                 // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 totalAHSLength : 8;            // DWORD 1
               u32 lunHi;                         // DWORD 2
               u32 lunLo;                         // DWORD 3
               u32 itt;                           // DWORD 4
               u32 ExpectedDataTransferLength;    // DWORD 5
               u32 CmdSN;                         // DWORD 6
               u32 ExpStatSN;                     // DWORD 7
               u32 cdb3;                          // DWORD 8
               u32 cdb2;                          // DWORD 9
               u32 cdb1;                          // DWORD 10
               u32 cdb0;                          // DWORD 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CMD_HDR, *PISCSI_CMD_HDR;

      SG_C_ASSERT(__sizeof__ISCSI_CMD_HDR, sizeof (ISCSI_CMD_HDR) == 48);

   #else
      typedef struct _ISCSI_CMD_HDR {
         u32 rsvd2 : 16;                          // DWORD 0
         u32 attributes : 3;                      // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 rd : 1;                              // DWORD 0
         u32 final : 1;                           // DWORD 0
         u32 opcode : 6;                          // DWORD 0
         u32 immediate : 1;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 lunHi;                               // DWORD 2
         u32 lunLo;                               // DWORD 3
         u32 itt;                                 // DWORD 4
         u32 ExpectedDataTransferLength;          // DWORD 5
         u32 CmdSN;                               // DWORD 6
         u32 ExpStatSN;                           // DWORD 7
         u32 cdb3;                                // DWORD 8
         u32 cdb2;                                // DWORD 9
         u32 cdb1;                                // DWORD 10
         u32 cdb0;                                // DWORD 11
      } SG_PACK ISCSI_CMD_HDR, *PISCSI_CMD_HDR;

      typedef union _ISCSI_CMD_HDR_UNION {
         ISCSI_CMD_HDR bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_CMD_HDR_UNION, *PISCSI_CMD_HDR_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CMD_HDR_UNION, sizeof (ISCSI_CMD_HDR_UNION) == 48);
   #endif


#else
   // The iSCSI command header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CMD_HDR {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 immediate : 1;                 // DWORD 0
               u32 opcode : 6;                    // DWORD 0
               u32 final : 1;                     // DWORD 0
               u32 rd : 1;                        // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 attributes : 3;                // DWORD 0
               u32 rsvd2 : 16;                    // DWORD 0
               u32 totalAHSLength : 8;            // DWORD 1
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 lunHi;                         // DWORD 2
               u32 lunLo;                         // DWORD 3
               u32 itt;                           // DWORD 4
               u32 ExpectedDataTransferLength;    // DWORD 5
               u32 CmdSN;                         // DWORD 6
               u32 ExpStatSN;                     // DWORD 7
               u32 cdb3;                          // DWORD 8
               u32 cdb2;                          // DWORD 9
               u32 cdb1;                          // DWORD 10
               u32 cdb0;                          // DWORD 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CMD_HDR, *PISCSI_CMD_HDR;

      SG_C_ASSERT(__sizeof__ISCSI_CMD_HDR, sizeof (ISCSI_CMD_HDR) == 48);

   #else
      typedef struct _ISCSI_CMD_HDR {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 immediate : 1;                       // DWORD 0
         u32 opcode : 6;                          // DWORD 0
         u32 final : 1;                           // DWORD 0
         u32 rd : 1;                              // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 attributes : 3;                      // DWORD 0
         u32 rsvd2 : 16;                          // DWORD 0
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 lunHi;                               // DWORD 2
         u32 lunLo;                               // DWORD 3
         u32 itt;                                 // DWORD 4
         u32 ExpectedDataTransferLength;          // DWORD 5
         u32 CmdSN;                               // DWORD 6
         u32 ExpStatSN;                           // DWORD 7
         u32 cdb3;                                // DWORD 8
         u32 cdb2;                                // DWORD 9
         u32 cdb1;                                // DWORD 10
         u32 cdb0;                                // DWORD 11
      } SG_PACK ISCSI_CMD_HDR, *PISCSI_CMD_HDR;

      typedef union _ISCSI_CMD_HDR_UNION {
         ISCSI_CMD_HDR bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_CMD_HDR_UNION, *PISCSI_CMD_HDR_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CMD_HDR_UNION, sizeof (ISCSI_CMD_HDR_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The iSCSI response header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_RESPONSE_HDR {
         union {
            struct { 
               u32 rsvd2 : 2;                     // DWORD 0
               u32 opcode : 6;                    // DWORD 0
               u32 final : 1;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 bdOverflow : 1;                // DWORD 0
               u32 bdUnderflow : 1;               // DWORD 0
               u32 overflow : 1;                  // DWORD 0
               u32 underflow : 1;                 // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 response : 8;                  // DWORD 0
               u32 status : 8;                    // DWORD 0
               u32 totalAHSLength : 8;            // DWORD 1
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 rsvd3[1];                      // DWORDS 2 to 2
               u32 rsvd4[1];                      // DWORDS 3 to 3
               u32 itt;                           // DWORD 4
               u32 snackTag;                      // DWORD 5
               u32 StatSN;                        // DWORD 6
               u32 ExpCmdSN;                      // DWORD 7
               u32 MaxCmdSN;                      // DWORD 8
               u32 ExpDataSN;                     // DWORD 9
               u32 BidirReadResdiualCnt;          // DWORD 10
               u32 ResidualCnt;                   // DWORD 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_RESPONSE_HDR, *PISCSI_RESPONSE_HDR;

      SG_C_ASSERT(__sizeof__ISCSI_RESPONSE_HDR, sizeof (ISCSI_RESPONSE_HDR) == 48);

   #else
      typedef struct _ISCSI_RESPONSE_HDR {
         u32 rsvd2 : 2;                           // DWORD 0
         u32 opcode : 6;                          // DWORD 0
         u32 final : 1;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 bdOverflow : 1;                      // DWORD 0
         u32 bdUnderflow : 1;                     // DWORD 0
         u32 overflow : 1;                        // DWORD 0
         u32 underflow : 1;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 response : 8;                        // DWORD 0
         u32 status : 8;                          // DWORD 0
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 rsvd3[1];                            // DWORDS 2 to 2
         u32 rsvd4[1];                            // DWORDS 3 to 3
         u32 itt;                                 // DWORD 4
         u32 snackTag;                            // DWORD 5
         u32 StatSN;                              // DWORD 6
         u32 ExpCmdSN;                            // DWORD 7
         u32 MaxCmdSN;                            // DWORD 8
         u32 ExpDataSN;                           // DWORD 9
         u32 BidirReadResdiualCnt;                // DWORD 10
         u32 ResidualCnt;                         // DWORD 11
      } SG_PACK ISCSI_RESPONSE_HDR, *PISCSI_RESPONSE_HDR;

      typedef union _ISCSI_RESPONSE_HDR_UNION {
         ISCSI_RESPONSE_HDR bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_RESPONSE_HDR_UNION, *PISCSI_RESPONSE_HDR_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_RESPONSE_HDR_UNION, sizeof (ISCSI_RESPONSE_HDR_UNION) == 48);
   #endif


#else
   // The iSCSI response header format.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_RESPONSE_HDR {
         union {
            struct { 
               u32 status : 8;                    // DWORD 0
               u32 response : 8;                  // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 underflow : 1;                 // DWORD 0
               u32 overflow : 1;                  // DWORD 0
               u32 bdUnderflow : 1;               // DWORD 0
               u32 bdOverflow : 1;                // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 final : 1;                     // DWORD 0
               u32 opcode : 6;                    // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 dataSegmentLength : 24;        // DWORD 1
               u32 totalAHSLength : 8;            // DWORD 1
               u32 rsvd3[1];                      // DWORDS 2 to 2
               u32 rsvd4[1];                      // DWORDS 3 to 3
               u32 itt;                           // DWORD 4
               u32 snackTag;                      // DWORD 5
               u32 StatSN;                        // DWORD 6
               u32 ExpCmdSN;                      // DWORD 7
               u32 MaxCmdSN;                      // DWORD 8
               u32 ExpDataSN;                     // DWORD 9
               u32 BidirReadResdiualCnt;          // DWORD 10
               u32 ResidualCnt;                   // DWORD 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_RESPONSE_HDR, *PISCSI_RESPONSE_HDR;

      SG_C_ASSERT(__sizeof__ISCSI_RESPONSE_HDR, sizeof (ISCSI_RESPONSE_HDR) == 48);

   #else
      typedef struct _ISCSI_RESPONSE_HDR {
         u32 status : 8;                          // DWORD 0
         u32 response : 8;                        // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 underflow : 1;                       // DWORD 0
         u32 overflow : 1;                        // DWORD 0
         u32 bdUnderflow : 1;                     // DWORD 0
         u32 bdOverflow : 1;                      // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 final : 1;                           // DWORD 0
         u32 opcode : 6;                          // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 dataSegmentLength : 24;              // DWORD 1
         u32 totalAHSLength : 8;                  // DWORD 1
         u32 rsvd3[1];                            // DWORDS 2 to 2
         u32 rsvd4[1];                            // DWORDS 3 to 3
         u32 itt;                                 // DWORD 4
         u32 snackTag;                            // DWORD 5
         u32 StatSN;                              // DWORD 6
         u32 ExpCmdSN;                            // DWORD 7
         u32 MaxCmdSN;                            // DWORD 8
         u32 ExpDataSN;                           // DWORD 9
         u32 BidirReadResdiualCnt;                // DWORD 10
         u32 ResidualCnt;                         // DWORD 11
      } SG_PACK ISCSI_RESPONSE_HDR, *PISCSI_RESPONSE_HDR;

      typedef union _ISCSI_RESPONSE_HDR_UNION {
         ISCSI_RESPONSE_HDR bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_RESPONSE_HDR_UNION, *PISCSI_RESPONSE_HDR_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_RESPONSE_HDR_UNION, sizeof (ISCSI_RESPONSE_HDR_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_D {
         union {
            struct { 
               u32 opcode : 8;                    // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 ulp_length : 16;               // DWORD 0
               u32 dword1;                        // DWORD 1
               u32 dword2;                        // DWORD 2
               u32 dword3;                        // DWORD 3
               u32 dword4;                        // DWORD 4
               u32 dword5;                        // DWORD 5
               u32 dword6;                        // DWORD 6
               u32 dword7;                        // DWORD 7
               u32 dword8;                        // DWORD 8
               u32 dword9;                        // DWORD 9
               u32 dword10;                       // DWORD 10
               u32 dword11;                       // DWORD 11
               u32 dword12;                       // DWORD 12
               u32 dword13;                       // DWORD 13
               u32 dword14;                       // DWORD 14
            } SG_PACK ; // unnamed struct
            u32 dw[15]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_D, *PRDMA_HEADER_D;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_D, sizeof (RDMA_HEADER_D) == 60);

   #else
      typedef struct _RDMA_HEADER_D {
         u32 opcode : 8;                          // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 ulp_length : 16;                     // DWORD 0
         u32 dword1;                              // DWORD 1
         u32 dword2;                              // DWORD 2
         u32 dword3;                              // DWORD 3
         u32 dword4;                              // DWORD 4
         u32 dword5;                              // DWORD 5
         u32 dword6;                              // DWORD 6
         u32 dword7;                              // DWORD 7
         u32 dword8;                              // DWORD 8
         u32 dword9;                              // DWORD 9
         u32 dword10;                             // DWORD 10
         u32 dword11;                             // DWORD 11
         u32 dword12;                             // DWORD 12
         u32 dword13;                             // DWORD 13
         u32 dword14;                             // DWORD 14
      } SG_PACK RDMA_HEADER_D, *PRDMA_HEADER_D;

      typedef union _RDMA_HEADER_D_UNION {
         RDMA_HEADER_D bits;
         u32 dw[15]; // dword union
      } SG_PACK RDMA_HEADER_D_UNION, *PRDMA_HEADER_D_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_D_UNION, sizeof (RDMA_HEADER_D_UNION) == 60);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_D {
         union {
            struct { 
               u32 ulp_length : 16;               // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 opcode : 8;                    // DWORD 0
               u32 dword1;                        // DWORD 1
               u32 dword2;                        // DWORD 2
               u32 dword3;                        // DWORD 3
               u32 dword4;                        // DWORD 4
               u32 dword5;                        // DWORD 5
               u32 dword6;                        // DWORD 6
               u32 dword7;                        // DWORD 7
               u32 dword8;                        // DWORD 8
               u32 dword9;                        // DWORD 9
               u32 dword10;                       // DWORD 10
               u32 dword11;                       // DWORD 11
               u32 dword12;                       // DWORD 12
               u32 dword13;                       // DWORD 13
               u32 dword14;                       // DWORD 14
            } SG_PACK ; // unnamed struct
            u32 dw[15]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_D, *PRDMA_HEADER_D;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_D, sizeof (RDMA_HEADER_D) == 60);

   #else
      typedef struct _RDMA_HEADER_D {
         u32 ulp_length : 16;                     // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 opcode : 8;                          // DWORD 0
         u32 dword1;                              // DWORD 1
         u32 dword2;                              // DWORD 2
         u32 dword3;                              // DWORD 3
         u32 dword4;                              // DWORD 4
         u32 dword5;                              // DWORD 5
         u32 dword6;                              // DWORD 6
         u32 dword7;                              // DWORD 7
         u32 dword8;                              // DWORD 8
         u32 dword9;                              // DWORD 9
         u32 dword10;                             // DWORD 10
         u32 dword11;                             // DWORD 11
         u32 dword12;                             // DWORD 12
         u32 dword13;                             // DWORD 13
         u32 dword14;                             // DWORD 14
      } SG_PACK RDMA_HEADER_D, *PRDMA_HEADER_D;

      typedef union _RDMA_HEADER_D_UNION {
         RDMA_HEADER_D bits;
         u32 dw[15]; // dword union
      } SG_PACK RDMA_HEADER_D_UNION, *PRDMA_HEADER_D_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_D_UNION, sizeof (RDMA_HEADER_D_UNION) == 60);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_SEND {
         union {
            struct { 
               u32 opcode : 8;                    // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 ulp_length : 16;               // DWORD 0
               u32 invalidate_stag;               // DWORD 1
               u32 queue_number;                  // DWORD 2
               u32 msg_sequence_number;           // DWORD 3
               u32 msg_offset;                    // DWORD 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_SEND, *PRDMA_HEADER_SEND;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_SEND, sizeof (RDMA_HEADER_SEND) == 20);

   #else
      typedef struct _RDMA_HEADER_SEND {
         u32 opcode : 8;                          // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 ulp_length : 16;                     // DWORD 0
         u32 invalidate_stag;                     // DWORD 1
         u32 queue_number;                        // DWORD 2
         u32 msg_sequence_number;                 // DWORD 3
         u32 msg_offset;                          // DWORD 4
      } SG_PACK RDMA_HEADER_SEND, *PRDMA_HEADER_SEND;

      typedef union _RDMA_HEADER_SEND_UNION {
         RDMA_HEADER_SEND bits;
         u32 dw[5]; // dword union
      } SG_PACK RDMA_HEADER_SEND_UNION, *PRDMA_HEADER_SEND_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_SEND_UNION, sizeof (RDMA_HEADER_SEND_UNION) == 20);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_SEND {
         union {
            struct { 
               u32 ulp_length : 16;               // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 opcode : 8;                    // DWORD 0
               u32 invalidate_stag;               // DWORD 1
               u32 queue_number;                  // DWORD 2
               u32 msg_sequence_number;           // DWORD 3
               u32 msg_offset;                    // DWORD 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_SEND, *PRDMA_HEADER_SEND;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_SEND, sizeof (RDMA_HEADER_SEND) == 20);

   #else
      typedef struct _RDMA_HEADER_SEND {
         u32 ulp_length : 16;                     // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 opcode : 8;                          // DWORD 0
         u32 invalidate_stag;                     // DWORD 1
         u32 queue_number;                        // DWORD 2
         u32 msg_sequence_number;                 // DWORD 3
         u32 msg_offset;                          // DWORD 4
      } SG_PACK RDMA_HEADER_SEND, *PRDMA_HEADER_SEND;

      typedef union _RDMA_HEADER_SEND_UNION {
         RDMA_HEADER_SEND bits;
         u32 dw[5]; // dword union
      } SG_PACK RDMA_HEADER_SEND_UNION, *PRDMA_HEADER_SEND_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_SEND_UNION, sizeof (RDMA_HEADER_SEND_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_WRITE {
         union {
            struct { 
               u32 opcode : 8;                    // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 ulp_length : 16;               // DWORD 0
               u32 data_sink_stag;                // DWORD 1
               u32 data_sink_tagged_offset_hi;    // DWORD 2
               u32 data_sink_tagged_offset_lo;    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_WRITE, *PRDMA_HEADER_WRITE;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_WRITE, sizeof (RDMA_HEADER_WRITE) == 16);

   #else
      typedef struct _RDMA_HEADER_WRITE {
         u32 opcode : 8;                          // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 ulp_length : 16;                     // DWORD 0
         u32 data_sink_stag;                      // DWORD 1
         u32 data_sink_tagged_offset_hi;          // DWORD 2
         u32 data_sink_tagged_offset_lo;          // DWORD 3
      } SG_PACK RDMA_HEADER_WRITE, *PRDMA_HEADER_WRITE;

      typedef union _RDMA_HEADER_WRITE_UNION {
         RDMA_HEADER_WRITE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_HEADER_WRITE_UNION, *PRDMA_HEADER_WRITE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_WRITE_UNION, sizeof (RDMA_HEADER_WRITE_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_WRITE {
         union {
            struct { 
               u32 ulp_length : 16;               // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 opcode : 8;                    // DWORD 0
               u32 data_sink_stag;                // DWORD 1
               u32 data_sink_tagged_offset_hi;    // DWORD 2
               u32 data_sink_tagged_offset_lo;    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_WRITE, *PRDMA_HEADER_WRITE;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_WRITE, sizeof (RDMA_HEADER_WRITE) == 16);

   #else
      typedef struct _RDMA_HEADER_WRITE {
         u32 ulp_length : 16;                     // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 opcode : 8;                          // DWORD 0
         u32 data_sink_stag;                      // DWORD 1
         u32 data_sink_tagged_offset_hi;          // DWORD 2
         u32 data_sink_tagged_offset_lo;          // DWORD 3
      } SG_PACK RDMA_HEADER_WRITE, *PRDMA_HEADER_WRITE;

      typedef union _RDMA_HEADER_WRITE_UNION {
         RDMA_HEADER_WRITE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_HEADER_WRITE_UNION, *PRDMA_HEADER_WRITE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_WRITE_UNION, sizeof (RDMA_HEADER_WRITE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_RESPONSE {
         union {
            struct { 
               u32 opcode : 8;                    // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 ulp_length : 16;               // DWORD 0
               u32 data_sink_stag;                // DWORD 1
               u32 data_sink_tagged_offset_hi;    // DWORD 2
               u32 data_sink_tagged_offset_lo;    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_RESPONSE, *PRDMA_HEADER_RESPONSE;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_RESPONSE, sizeof (RDMA_HEADER_RESPONSE) == 16);

   #else
      typedef struct _RDMA_HEADER_RESPONSE {
         u32 opcode : 8;                          // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 ulp_length : 16;                     // DWORD 0
         u32 data_sink_stag;                      // DWORD 1
         u32 data_sink_tagged_offset_hi;          // DWORD 2
         u32 data_sink_tagged_offset_lo;          // DWORD 3
      } SG_PACK RDMA_HEADER_RESPONSE, *PRDMA_HEADER_RESPONSE;

      typedef union _RDMA_HEADER_RESPONSE_UNION {
         RDMA_HEADER_RESPONSE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_HEADER_RESPONSE_UNION, *PRDMA_HEADER_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_RESPONSE_UNION, sizeof (RDMA_HEADER_RESPONSE_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_RESPONSE {
         union {
            struct { 
               u32 ulp_length : 16;               // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 opcode : 8;                    // DWORD 0
               u32 data_sink_stag;                // DWORD 1
               u32 data_sink_tagged_offset_hi;    // DWORD 2
               u32 data_sink_tagged_offset_lo;    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_RESPONSE, *PRDMA_HEADER_RESPONSE;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_RESPONSE, sizeof (RDMA_HEADER_RESPONSE) == 16);

   #else
      typedef struct _RDMA_HEADER_RESPONSE {
         u32 ulp_length : 16;                     // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 opcode : 8;                          // DWORD 0
         u32 data_sink_stag;                      // DWORD 1
         u32 data_sink_tagged_offset_hi;          // DWORD 2
         u32 data_sink_tagged_offset_lo;          // DWORD 3
      } SG_PACK RDMA_HEADER_RESPONSE, *PRDMA_HEADER_RESPONSE;

      typedef union _RDMA_HEADER_RESPONSE_UNION {
         RDMA_HEADER_RESPONSE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_HEADER_RESPONSE_UNION, *PRDMA_HEADER_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_RESPONSE_UNION, sizeof (RDMA_HEADER_RESPONSE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_READ_REQUEST {
         union {
            struct { 
               u32 opcode : 8;                    // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 ulp_length : 16;               // DWORD 0
               u32 rsvd0[1];                      // DWORDS 1 to 1
               u32 queue_number;                  // DWORD 2
               u32 msg_sequence_number;           // DWORD 3
               u32 msg_offset;                    // DWORD 4
               u32 data_sink_stag;                // DWORD 5
               u32 data_sink_tagged_offset_hi;    // DWORD 6
               u32 data_sink_tagged_offset_lo;    // DWORD 7
               u32 read_msg_size;                 // DWORD 8
               u32 data_source_stag;              // DWORD 9
               u32 data_source_tagged_offset_hi;  // DWORD 10
               u32 data_source_tagged_offset_lo;  // DWORD 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_READ_REQUEST, *PRDMA_HEADER_READ_REQUEST;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_READ_REQUEST, sizeof (RDMA_HEADER_READ_REQUEST) == 48);

   #else
      typedef struct _RDMA_HEADER_READ_REQUEST {
         u32 opcode : 8;                          // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 ulp_length : 16;                     // DWORD 0
         u32 rsvd0[1];                            // DWORDS 1 to 1
         u32 queue_number;                        // DWORD 2
         u32 msg_sequence_number;                 // DWORD 3
         u32 msg_offset;                          // DWORD 4
         u32 data_sink_stag;                      // DWORD 5
         u32 data_sink_tagged_offset_hi;          // DWORD 6
         u32 data_sink_tagged_offset_lo;          // DWORD 7
         u32 read_msg_size;                       // DWORD 8
         u32 data_source_stag;                    // DWORD 9
         u32 data_source_tagged_offset_hi;        // DWORD 10
         u32 data_source_tagged_offset_lo;        // DWORD 11
      } SG_PACK RDMA_HEADER_READ_REQUEST, *PRDMA_HEADER_READ_REQUEST;

      typedef union _RDMA_HEADER_READ_REQUEST_UNION {
         RDMA_HEADER_READ_REQUEST bits;
         u32 dw[12]; // dword union
      } SG_PACK RDMA_HEADER_READ_REQUEST_UNION, *PRDMA_HEADER_READ_REQUEST_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_READ_REQUEST_UNION, sizeof (RDMA_HEADER_READ_REQUEST_UNION) == 48);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_READ_REQUEST {
         union {
            struct { 
               u32 ulp_length : 16;               // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 opcode : 8;                    // DWORD 0
               u32 rsvd0[1];                      // DWORDS 1 to 1
               u32 queue_number;                  // DWORD 2
               u32 msg_sequence_number;           // DWORD 3
               u32 msg_offset;                    // DWORD 4
               u32 data_sink_stag;                // DWORD 5
               u32 data_sink_tagged_offset_hi;    // DWORD 6
               u32 data_sink_tagged_offset_lo;    // DWORD 7
               u32 read_msg_size;                 // DWORD 8
               u32 data_source_stag;              // DWORD 9
               u32 data_source_tagged_offset_hi;  // DWORD 10
               u32 data_source_tagged_offset_lo;  // DWORD 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_READ_REQUEST, *PRDMA_HEADER_READ_REQUEST;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_READ_REQUEST, sizeof (RDMA_HEADER_READ_REQUEST) == 48);

   #else
      typedef struct _RDMA_HEADER_READ_REQUEST {
         u32 ulp_length : 16;                     // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 opcode : 8;                          // DWORD 0
         u32 rsvd0[1];                            // DWORDS 1 to 1
         u32 queue_number;                        // DWORD 2
         u32 msg_sequence_number;                 // DWORD 3
         u32 msg_offset;                          // DWORD 4
         u32 data_sink_stag;                      // DWORD 5
         u32 data_sink_tagged_offset_hi;          // DWORD 6
         u32 data_sink_tagged_offset_lo;          // DWORD 7
         u32 read_msg_size;                       // DWORD 8
         u32 data_source_stag;                    // DWORD 9
         u32 data_source_tagged_offset_hi;        // DWORD 10
         u32 data_source_tagged_offset_lo;        // DWORD 11
      } SG_PACK RDMA_HEADER_READ_REQUEST, *PRDMA_HEADER_READ_REQUEST;

      typedef union _RDMA_HEADER_READ_REQUEST_UNION {
         RDMA_HEADER_READ_REQUEST bits;
         u32 dw[12]; // dword union
      } SG_PACK RDMA_HEADER_READ_REQUEST_UNION, *PRDMA_HEADER_READ_REQUEST_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_READ_REQUEST_UNION, sizeof (RDMA_HEADER_READ_REQUEST_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_TERMINATE {
         union {
            struct { 
               u32 opcode : 8;                    // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 ulp_length : 16;               // DWORD 0
               u32 rsvd0[1];                      // DWORDS 1 to 1
               u32 queue_number;                  // DWORD 2
               u32 msg_sequence_number;           // DWORD 3
               u32 msg_offset;                    // DWORD 4
               u32 rsvd1 : 16;                    // DWORD 5
               u32 terminate_control : 16;        // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_TERMINATE, *PRDMA_HEADER_TERMINATE;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_TERMINATE, sizeof (RDMA_HEADER_TERMINATE) == 24);

   #else
      typedef struct _RDMA_HEADER_TERMINATE {
         u32 opcode : 8;                          // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 ulp_length : 16;                     // DWORD 0
         u32 rsvd0[1];                            // DWORDS 1 to 1
         u32 queue_number;                        // DWORD 2
         u32 msg_sequence_number;                 // DWORD 3
         u32 msg_offset;                          // DWORD 4
         u32 rsvd1 : 16;                          // DWORD 5
         u32 terminate_control : 16;              // DWORD 5
      } SG_PACK RDMA_HEADER_TERMINATE, *PRDMA_HEADER_TERMINATE;

      typedef union _RDMA_HEADER_TERMINATE_UNION {
         RDMA_HEADER_TERMINATE bits;
         u32 dw[6]; // dword union
      } SG_PACK RDMA_HEADER_TERMINATE_UNION, *PRDMA_HEADER_TERMINATE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_TERMINATE_UNION, sizeof (RDMA_HEADER_TERMINATE_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_HEADER_TERMINATE {
         union {
            struct { 
               u32 ulp_length : 16;               // DWORD 0
               u32 ddp_control : 8;               // DWORD 0
               u32 opcode : 8;                    // DWORD 0
               u32 rsvd0[1];                      // DWORDS 1 to 1
               u32 queue_number;                  // DWORD 2
               u32 msg_sequence_number;           // DWORD 3
               u32 msg_offset;                    // DWORD 4
               u32 terminate_control : 16;        // DWORD 5
               u32 rsvd1 : 16;                    // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_HEADER_TERMINATE, *PRDMA_HEADER_TERMINATE;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_TERMINATE, sizeof (RDMA_HEADER_TERMINATE) == 24);

   #else
      typedef struct _RDMA_HEADER_TERMINATE {
         u32 ulp_length : 16;                     // DWORD 0
         u32 ddp_control : 8;                     // DWORD 0
         u32 opcode : 8;                          // DWORD 0
         u32 rsvd0[1];                            // DWORDS 1 to 1
         u32 queue_number;                        // DWORD 2
         u32 msg_sequence_number;                 // DWORD 3
         u32 msg_offset;                          // DWORD 4
         u32 terminate_control : 16;              // DWORD 5
         u32 rsvd1 : 16;                          // DWORD 5
      } SG_PACK RDMA_HEADER_TERMINATE, *PRDMA_HEADER_TERMINATE;

      typedef union _RDMA_HEADER_TERMINATE_UNION {
         RDMA_HEADER_TERMINATE bits;
         u32 dw[6]; // dword union
      } SG_PACK RDMA_HEADER_TERMINATE_UNION, *PRDMA_HEADER_TERMINATE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_HEADER_TERMINATE_UNION, sizeof (RDMA_HEADER_TERMINATE_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_R_CTL {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 routing : 4;                   // DWORD 0
               u32 information : 4;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FC_R_CTL, *PFC_R_CTL;

      SG_C_ASSERT(__sizeof__FC_R_CTL, sizeof (FC_R_CTL) == 4);

   #else
      typedef struct _FC_R_CTL {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 routing : 4;                         // DWORD 0
         u32 information : 4;                     // DWORD 0
      } SG_PACK FC_R_CTL, *PFC_R_CTL;

      typedef union _FC_R_CTL_UNION {
         FC_R_CTL bits;
         u32 dw; // dword union
      } SG_PACK FC_R_CTL_UNION, *PFC_R_CTL_UNION;

      SG_C_ASSERT(__sizeof__FC_R_CTL_UNION, sizeof (FC_R_CTL_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_R_CTL {
         union {
            struct { 
               u32 information : 4;               // DWORD 0
               u32 routing : 4;                   // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FC_R_CTL, *PFC_R_CTL;

      SG_C_ASSERT(__sizeof__FC_R_CTL, sizeof (FC_R_CTL) == 4);

   #else
      typedef struct _FC_R_CTL {
         u32 information : 4;                     // DWORD 0
         u32 routing : 4;                         // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK FC_R_CTL, *PFC_R_CTL;

      typedef union _FC_R_CTL_UNION {
         FC_R_CTL bits;
         u32 dw; // dword union
      } SG_PACK FC_R_CTL_UNION, *PFC_R_CTL_UNION;

      SG_C_ASSERT(__sizeof__FC_R_CTL_UNION, sizeof (FC_R_CTL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_HEADER {
         union {
            struct { 
               u32 r_ctl : 8;                     // DWORD 0
               u32 d_id : 24;                     // DWORD 0
               u32 cs_ctl_prio : 8;               // DWORD 1
               u32 s_id : 24;                     // DWORD 1
               u32 type : 8;                      // DWORD 2
               u32 f_ctl : 24;                    // DWORD 2
               u32 seq_id : 8;                    // DWORD 3
               u32 df_ctl : 8;                    // DWORD 3
               u32 seq_cnt : 16;                  // DWORD 3
               u32 ox_id : 16;                    // DWORD 4
               u32 rx_id : 16;                    // DWORD 4
               u32 param;                         // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK FC_HEADER, *PFC_HEADER;

      SG_C_ASSERT(__sizeof__FC_HEADER, sizeof (FC_HEADER) == 24);

   #else
      typedef struct _FC_HEADER {
         u32 r_ctl : 8;                           // DWORD 0
         u32 d_id : 24;                           // DWORD 0
         u32 cs_ctl_prio : 8;                     // DWORD 1
         u32 s_id : 24;                           // DWORD 1
         u32 type : 8;                            // DWORD 2
         u32 f_ctl : 24;                          // DWORD 2
         u32 seq_id : 8;                          // DWORD 3
         u32 df_ctl : 8;                          // DWORD 3
         u32 seq_cnt : 16;                        // DWORD 3
         u32 ox_id : 16;                          // DWORD 4
         u32 rx_id : 16;                          // DWORD 4
         u32 param;                               // DWORD 5
      } SG_PACK FC_HEADER, *PFC_HEADER;

      typedef union _FC_HEADER_UNION {
         FC_HEADER bits;
         u32 dw[6]; // dword union
      } SG_PACK FC_HEADER_UNION, *PFC_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FC_HEADER_UNION, sizeof (FC_HEADER_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_HEADER {
         union {
            struct { 
               u32 d_id : 24;                     // DWORD 0
               u32 r_ctl : 8;                     // DWORD 0
               u32 s_id : 24;                     // DWORD 1
               u32 cs_ctl_prio : 8;               // DWORD 1
               u32 f_ctl : 24;                    // DWORD 2
               u32 type : 8;                      // DWORD 2
               u32 seq_cnt : 16;                  // DWORD 3
               u32 df_ctl : 8;                    // DWORD 3
               u32 seq_id : 8;                    // DWORD 3
               u32 rx_id : 16;                    // DWORD 4
               u32 ox_id : 16;                    // DWORD 4
               u32 param;                         // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK FC_HEADER, *PFC_HEADER;

      SG_C_ASSERT(__sizeof__FC_HEADER, sizeof (FC_HEADER) == 24);

   #else
      typedef struct _FC_HEADER {
         u32 d_id : 24;                           // DWORD 0
         u32 r_ctl : 8;                           // DWORD 0
         u32 s_id : 24;                           // DWORD 1
         u32 cs_ctl_prio : 8;                     // DWORD 1
         u32 f_ctl : 24;                          // DWORD 2
         u32 type : 8;                            // DWORD 2
         u32 seq_cnt : 16;                        // DWORD 3
         u32 df_ctl : 8;                          // DWORD 3
         u32 seq_id : 8;                          // DWORD 3
         u32 rx_id : 16;                          // DWORD 4
         u32 ox_id : 16;                          // DWORD 4
         u32 param;                               // DWORD 5
      } SG_PACK FC_HEADER, *PFC_HEADER;

      typedef union _FC_HEADER_UNION {
         FC_HEADER bits;
         u32 dw[6]; // dword union
      } SG_PACK FC_HEADER_UNION, *PFC_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FC_HEADER_UNION, sizeof (FC_HEADER_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_F_CTL {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 exchange_context : 1;          // DWORD 0
               u32 sequence_context : 1;          // DWORD 0
               u32 first_sequence : 1;            // DWORD 0
               u32 last_sequence : 1;             // DWORD 0
               u32 end_sequence : 1;              // DWORD 0
               u32 end_connection : 1;            // DWORD 0
               u32 cs_ctl_priority_enable : 1;    // DWORD 0
               u32 sequence_initiative : 1;       // DWORD 0
               u32 xid_reassigned_obsolete : 1;   // DWORD 0
               u32 invalidate_xid_obsolete : 1;   // DWORD 0
               u32 ack_form : 2;                  // DWORD 0
               u32 data_compression_obsolete : 1; // DWORD 0
               u32 data_encryption_obsolete : 1;  // DWORD 0
               u32 retransmitted_sequence : 1;    // DWORD 0
               u32 unidirectional_transmit : 1;   // DWORD 0
               u32 continue_sequence_condition : 2; // DWORD 0
               u32 abort_sequence_condition : 2;  // DWORD 0
               u32 relative_offset_present : 1;   // DWORD 0
               u32 exchange_reassembly : 1;       // DWORD 0
               u32 fill_bytes : 2;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FC_F_CTL, *PFC_F_CTL;

      SG_C_ASSERT(__sizeof__FC_F_CTL, sizeof (FC_F_CTL) == 4);

   #else
      typedef struct _FC_F_CTL {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 exchange_context : 1;                // DWORD 0
         u32 sequence_context : 1;                // DWORD 0
         u32 first_sequence : 1;                  // DWORD 0
         u32 last_sequence : 1;                   // DWORD 0
         u32 end_sequence : 1;                    // DWORD 0
         u32 end_connection : 1;                  // DWORD 0
         u32 cs_ctl_priority_enable : 1;          // DWORD 0
         u32 sequence_initiative : 1;             // DWORD 0
         u32 xid_reassigned_obsolete : 1;         // DWORD 0
         u32 invalidate_xid_obsolete : 1;         // DWORD 0
         u32 ack_form : 2;                        // DWORD 0
         u32 data_compression_obsolete : 1;       // DWORD 0
         u32 data_encryption_obsolete : 1;        // DWORD 0
         u32 retransmitted_sequence : 1;          // DWORD 0
         u32 unidirectional_transmit : 1;         // DWORD 0
         u32 continue_sequence_condition : 2;     // DWORD 0
         u32 abort_sequence_condition : 2;        // DWORD 0
         u32 relative_offset_present : 1;         // DWORD 0
         u32 exchange_reassembly : 1;             // DWORD 0
         u32 fill_bytes : 2;                      // DWORD 0
      } SG_PACK FC_F_CTL, *PFC_F_CTL;

      typedef union _FC_F_CTL_UNION {
         FC_F_CTL bits;
         u32 dw; // dword union
      } SG_PACK FC_F_CTL_UNION, *PFC_F_CTL_UNION;

      SG_C_ASSERT(__sizeof__FC_F_CTL_UNION, sizeof (FC_F_CTL_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_F_CTL {
         union {
            struct { 
               u32 fill_bytes : 2;                // DWORD 0
               u32 exchange_reassembly : 1;       // DWORD 0
               u32 relative_offset_present : 1;   // DWORD 0
               u32 abort_sequence_condition : 2;  // DWORD 0
               u32 continue_sequence_condition : 2; // DWORD 0
               u32 unidirectional_transmit : 1;   // DWORD 0
               u32 retransmitted_sequence : 1;    // DWORD 0
               u32 data_encryption_obsolete : 1;  // DWORD 0
               u32 data_compression_obsolete : 1; // DWORD 0
               u32 ack_form : 2;                  // DWORD 0
               u32 invalidate_xid_obsolete : 1;   // DWORD 0
               u32 xid_reassigned_obsolete : 1;   // DWORD 0
               u32 sequence_initiative : 1;       // DWORD 0
               u32 cs_ctl_priority_enable : 1;    // DWORD 0
               u32 end_connection : 1;            // DWORD 0
               u32 end_sequence : 1;              // DWORD 0
               u32 last_sequence : 1;             // DWORD 0
               u32 first_sequence : 1;            // DWORD 0
               u32 sequence_context : 1;          // DWORD 0
               u32 exchange_context : 1;          // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FC_F_CTL, *PFC_F_CTL;

      SG_C_ASSERT(__sizeof__FC_F_CTL, sizeof (FC_F_CTL) == 4);

   #else
      typedef struct _FC_F_CTL {
         u32 fill_bytes : 2;                      // DWORD 0
         u32 exchange_reassembly : 1;             // DWORD 0
         u32 relative_offset_present : 1;         // DWORD 0
         u32 abort_sequence_condition : 2;        // DWORD 0
         u32 continue_sequence_condition : 2;     // DWORD 0
         u32 unidirectional_transmit : 1;         // DWORD 0
         u32 retransmitted_sequence : 1;          // DWORD 0
         u32 data_encryption_obsolete : 1;        // DWORD 0
         u32 data_compression_obsolete : 1;       // DWORD 0
         u32 ack_form : 2;                        // DWORD 0
         u32 invalidate_xid_obsolete : 1;         // DWORD 0
         u32 xid_reassigned_obsolete : 1;         // DWORD 0
         u32 sequence_initiative : 1;             // DWORD 0
         u32 cs_ctl_priority_enable : 1;          // DWORD 0
         u32 end_connection : 1;                  // DWORD 0
         u32 end_sequence : 1;                    // DWORD 0
         u32 last_sequence : 1;                   // DWORD 0
         u32 first_sequence : 1;                  // DWORD 0
         u32 sequence_context : 1;                // DWORD 0
         u32 exchange_context : 1;                // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK FC_F_CTL, *PFC_F_CTL;

      typedef union _FC_F_CTL_UNION {
         FC_F_CTL bits;
         u32 dw; // dword union
      } SG_PACK FC_F_CTL_UNION, *PFC_F_CTL_UNION;

      SG_C_ASSERT(__sizeof__FC_F_CTL_UNION, sizeof (FC_F_CTL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_VFT_HEADER {
         union {
            struct { 
               u32 r_ctl : 8;                     // DWORD 0
               u32 ver : 2;                       // DWORD 0
               u32 type : 4;                      // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 priority : 3;                  // DWORD 0
               u32 vf_id : 12;                    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 hopcnt : 8;                    // DWORD 1
               u32 rsvd3 : 24;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FC_VFT_HEADER, *PFC_VFT_HEADER;

      SG_C_ASSERT(__sizeof__FC_VFT_HEADER, sizeof (FC_VFT_HEADER) == 8);

   #else
      typedef struct _FC_VFT_HEADER {
         u32 r_ctl : 8;                           // DWORD 0
         u32 ver : 2;                             // DWORD 0
         u32 type : 4;                            // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 priority : 3;                        // DWORD 0
         u32 vf_id : 12;                          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 hopcnt : 8;                          // DWORD 1
         u32 rsvd3 : 24;                          // DWORD 1
      } SG_PACK FC_VFT_HEADER, *PFC_VFT_HEADER;

      typedef union _FC_VFT_HEADER_UNION {
         FC_VFT_HEADER bits;
         u32 dw[2]; // dword union
      } SG_PACK FC_VFT_HEADER_UNION, *PFC_VFT_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FC_VFT_HEADER_UNION, sizeof (FC_VFT_HEADER_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_VFT_HEADER {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vf_id : 12;                    // DWORD 0
               u32 priority : 3;                  // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 type : 4;                      // DWORD 0
               u32 ver : 2;                       // DWORD 0
               u32 r_ctl : 8;                     // DWORD 0
               u32 rsvd3 : 24;                    // DWORD 1
               u32 hopcnt : 8;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FC_VFT_HEADER, *PFC_VFT_HEADER;

      SG_C_ASSERT(__sizeof__FC_VFT_HEADER, sizeof (FC_VFT_HEADER) == 8);

   #else
      typedef struct _FC_VFT_HEADER {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vf_id : 12;                          // DWORD 0
         u32 priority : 3;                        // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 type : 4;                            // DWORD 0
         u32 ver : 2;                             // DWORD 0
         u32 r_ctl : 8;                           // DWORD 0
         u32 rsvd3 : 24;                          // DWORD 1
         u32 hopcnt : 8;                          // DWORD 1
      } SG_PACK FC_VFT_HEADER, *PFC_VFT_HEADER;

      typedef union _FC_VFT_HEADER_UNION {
         FC_VFT_HEADER bits;
         u32 dw[2]; // dword union
      } SG_PACK FC_VFT_HEADER_UNION, *PFC_VFT_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FC_VFT_HEADER_UNION, sizeof (FC_VFT_HEADER_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_HEADER {
         union {
            struct { 
               u32 dmac_hi_32;                    // DWORD 0
               u32 dmac_lo_16 : 16;               // DWORD 1
               u32 smac_hi_16 : 16;               // DWORD 1
               u32 smac_lo_32;                    // DWORD 2
               u32 type : 16;                     // DWORD 3
               u32 ver : 4;                       // DWORD 3
               u32 rsvd0 : 12;                    // DWORD 3
               u32 rsvd1[1];                      // DWORDS 4 to 4
               u32 rsvd2[1];                      // DWORDS 5 to 5
               u32 rsvd3 : 24;                    // DWORD 6
               u32 sof : 8;                       // DWORD 6
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_HEADER, *PFCOE_HEADER;

      SG_C_ASSERT(__sizeof__FCOE_HEADER, sizeof (FCOE_HEADER) == 28);

   #else
      typedef struct _FCOE_HEADER {
         u32 dmac_hi_32;                          // DWORD 0
         u32 dmac_lo_16 : 16;                     // DWORD 1
         u32 smac_hi_16 : 16;                     // DWORD 1
         u32 smac_lo_32;                          // DWORD 2
         u32 type : 16;                           // DWORD 3
         u32 ver : 4;                             // DWORD 3
         u32 rsvd0 : 12;                          // DWORD 3
         u32 rsvd1[1];                            // DWORDS 4 to 4
         u32 rsvd2[1];                            // DWORDS 5 to 5
         u32 rsvd3 : 24;                          // DWORD 6
         u32 sof : 8;                             // DWORD 6
      } SG_PACK FCOE_HEADER, *PFCOE_HEADER;

      typedef union _FCOE_HEADER_UNION {
         FCOE_HEADER bits;
         u32 dw[7]; // dword union
      } SG_PACK FCOE_HEADER_UNION, *PFCOE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FCOE_HEADER_UNION, sizeof (FCOE_HEADER_UNION) == 28);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_HEADER {
         union {
            struct { 
               u32 dmac_hi_32;                    // DWORD 0
               u32 smac_hi_16 : 16;               // DWORD 1
               u32 dmac_lo_16 : 16;               // DWORD 1
               u32 smac_lo_32;                    // DWORD 2
               u32 rsvd0 : 12;                    // DWORD 3
               u32 ver : 4;                       // DWORD 3
               u32 type : 16;                     // DWORD 3
               u32 rsvd1[1];                      // DWORDS 4 to 4
               u32 rsvd2[1];                      // DWORDS 5 to 5
               u32 sof : 8;                       // DWORD 6
               u32 rsvd3 : 24;                    // DWORD 6
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_HEADER, *PFCOE_HEADER;

      SG_C_ASSERT(__sizeof__FCOE_HEADER, sizeof (FCOE_HEADER) == 28);

   #else
      typedef struct _FCOE_HEADER {
         u32 dmac_hi_32;                          // DWORD 0
         u32 smac_hi_16 : 16;                     // DWORD 1
         u32 dmac_lo_16 : 16;                     // DWORD 1
         u32 smac_lo_32;                          // DWORD 2
         u32 rsvd0 : 12;                          // DWORD 3
         u32 ver : 4;                             // DWORD 3
         u32 type : 16;                           // DWORD 3
         u32 rsvd1[1];                            // DWORDS 4 to 4
         u32 rsvd2[1];                            // DWORDS 5 to 5
         u32 sof : 8;                             // DWORD 6
         u32 rsvd3 : 24;                          // DWORD 6
      } SG_PACK FCOE_HEADER, *PFCOE_HEADER;

      typedef union _FCOE_HEADER_UNION {
         FCOE_HEADER bits;
         u32 dw[7]; // dword union
      } SG_PACK FCOE_HEADER_UNION, *PFCOE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FCOE_HEADER_UNION, sizeof (FCOE_HEADER_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_HEADER_VLAN {
         union {
            struct { 
               u32 dmac_hi_32;                    // DWORD 0
               u32 dmac_lo_16 : 16;               // DWORD 1
               u32 smac_hi_16 : 16;               // DWORD 1
               u32 smac_lo_32;                    // DWORD 2
               u32 ether_type : 16;               // DWORD 3
               u32 pri : 3;                       // DWORD 3
               u32 cannonical : 1;                // DWORD 3
               u32 vlan_id : 12;                  // DWORD 3
               u32 type : 16;                     // DWORD 4
               u32 ver : 4;                       // DWORD 4
               u32 rsvd0 : 12;                    // DWORD 4
               u32 rsvd1[1];                      // DWORDS 5 to 5
               u32 rsvd2[1];                      // DWORDS 6 to 6
               u32 rsvd3 : 24;                    // DWORD 7
               u32 sof : 8;                       // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_HEADER_VLAN, *PFCOE_HEADER_VLAN;

      SG_C_ASSERT(__sizeof__FCOE_HEADER_VLAN, sizeof (FCOE_HEADER_VLAN) == 32);

   #else
      typedef struct _FCOE_HEADER_VLAN {
         u32 dmac_hi_32;                          // DWORD 0
         u32 dmac_lo_16 : 16;                     // DWORD 1
         u32 smac_hi_16 : 16;                     // DWORD 1
         u32 smac_lo_32;                          // DWORD 2
         u32 ether_type : 16;                     // DWORD 3
         u32 pri : 3;                             // DWORD 3
         u32 cannonical : 1;                      // DWORD 3
         u32 vlan_id : 12;                        // DWORD 3
         u32 type : 16;                           // DWORD 4
         u32 ver : 4;                             // DWORD 4
         u32 rsvd0 : 12;                          // DWORD 4
         u32 rsvd1[1];                            // DWORDS 5 to 5
         u32 rsvd2[1];                            // DWORDS 6 to 6
         u32 rsvd3 : 24;                          // DWORD 7
         u32 sof : 8;                             // DWORD 7
      } SG_PACK FCOE_HEADER_VLAN, *PFCOE_HEADER_VLAN;

      typedef union _FCOE_HEADER_VLAN_UNION {
         FCOE_HEADER_VLAN bits;
         u32 dw[8]; // dword union
      } SG_PACK FCOE_HEADER_VLAN_UNION, *PFCOE_HEADER_VLAN_UNION;

      SG_C_ASSERT(__sizeof__FCOE_HEADER_VLAN_UNION, sizeof (FCOE_HEADER_VLAN_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_HEADER_VLAN {
         union {
            struct { 
               u32 dmac_hi_32;                    // DWORD 0
               u32 smac_hi_16 : 16;               // DWORD 1
               u32 dmac_lo_16 : 16;               // DWORD 1
               u32 smac_lo_32;                    // DWORD 2
               u32 vlan_id : 12;                  // DWORD 3
               u32 cannonical : 1;                // DWORD 3
               u32 pri : 3;                       // DWORD 3
               u32 ether_type : 16;               // DWORD 3
               u32 rsvd0 : 12;                    // DWORD 4
               u32 ver : 4;                       // DWORD 4
               u32 type : 16;                     // DWORD 4
               u32 rsvd1[1];                      // DWORDS 5 to 5
               u32 rsvd2[1];                      // DWORDS 6 to 6
               u32 sof : 8;                       // DWORD 7
               u32 rsvd3 : 24;                    // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_HEADER_VLAN, *PFCOE_HEADER_VLAN;

      SG_C_ASSERT(__sizeof__FCOE_HEADER_VLAN, sizeof (FCOE_HEADER_VLAN) == 32);

   #else
      typedef struct _FCOE_HEADER_VLAN {
         u32 dmac_hi_32;                          // DWORD 0
         u32 smac_hi_16 : 16;                     // DWORD 1
         u32 dmac_lo_16 : 16;                     // DWORD 1
         u32 smac_lo_32;                          // DWORD 2
         u32 vlan_id : 12;                        // DWORD 3
         u32 cannonical : 1;                      // DWORD 3
         u32 pri : 3;                             // DWORD 3
         u32 ether_type : 16;                     // DWORD 3
         u32 rsvd0 : 12;                          // DWORD 4
         u32 ver : 4;                             // DWORD 4
         u32 type : 16;                           // DWORD 4
         u32 rsvd1[1];                            // DWORDS 5 to 5
         u32 rsvd2[1];                            // DWORDS 6 to 6
         u32 sof : 8;                             // DWORD 7
         u32 rsvd3 : 24;                          // DWORD 7
      } SG_PACK FCOE_HEADER_VLAN, *PFCOE_HEADER_VLAN;

      typedef union _FCOE_HEADER_VLAN_UNION {
         FCOE_HEADER_VLAN bits;
         u32 dw[8]; // dword union
      } SG_PACK FCOE_HEADER_VLAN_UNION, *PFCOE_HEADER_VLAN_UNION;

      SG_C_ASSERT(__sizeof__FCOE_HEADER_VLAN_UNION, sizeof (FCOE_HEADER_VLAN_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FCP_CMD {
         union {
            struct { 
               u32 lun_hi;                        // DWORD 0
               u32 lun_lo;                        // DWORD 1
               u32 command_reference_number : 8;  // DWORD 2
               u32 rsvd0 : 1;                     // DWORD 2
               u32 priority : 4;                  // DWORD 2
               u32 task_attribute : 3;            // DWORD 2
               u32 task_management_flags : 8;     // DWORD 2
               u32 additional_cdb_len : 6;        // DWORD 2
               u32 rddata : 1;                    // DWORD 2
               u32 wrdata : 1;                    // DWORD 2
               u32 fcp_cdb_dw0;                   // DWORD 3
               u32 fcp_cdb_dw1;                   // DWORD 4
               u32 fcp_cdb_dw2;                   // DWORD 5
               u32 fcp_cdb_dw3;                   // DWORD 6
               u32 fcp_dl;                        // DWORD 7
               u32 fcp_bi_directional_read_len;   // DWORD 8
            } SG_PACK ; // unnamed struct
            u32 dw[9]; // dword union
         }; // unnamed union
      } SG_PACK FCP_CMD, *PFCP_CMD;

      SG_C_ASSERT(__sizeof__FCP_CMD, sizeof (FCP_CMD) == 36);

   #else
      typedef struct _FCP_CMD {
         u32 lun_hi;                              // DWORD 0
         u32 lun_lo;                              // DWORD 1
         u32 command_reference_number : 8;        // DWORD 2
         u32 rsvd0 : 1;                           // DWORD 2
         u32 priority : 4;                        // DWORD 2
         u32 task_attribute : 3;                  // DWORD 2
         u32 task_management_flags : 8;           // DWORD 2
         u32 additional_cdb_len : 6;              // DWORD 2
         u32 rddata : 1;                          // DWORD 2
         u32 wrdata : 1;                          // DWORD 2
         u32 fcp_cdb_dw0;                         // DWORD 3
         u32 fcp_cdb_dw1;                         // DWORD 4
         u32 fcp_cdb_dw2;                         // DWORD 5
         u32 fcp_cdb_dw3;                         // DWORD 6
         u32 fcp_dl;                              // DWORD 7
         u32 fcp_bi_directional_read_len;         // DWORD 8
      } SG_PACK FCP_CMD, *PFCP_CMD;

      typedef union _FCP_CMD_UNION {
         FCP_CMD bits;
         u32 dw[9]; // dword union
      } SG_PACK FCP_CMD_UNION, *PFCP_CMD_UNION;

      SG_C_ASSERT(__sizeof__FCP_CMD_UNION, sizeof (FCP_CMD_UNION) == 36);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FCP_CMD {
         union {
            struct { 
               u32 lun_hi;                        // DWORD 0
               u32 lun_lo;                        // DWORD 1
               u32 wrdata : 1;                    // DWORD 2
               u32 rddata : 1;                    // DWORD 2
               u32 additional_cdb_len : 6;        // DWORD 2
               u32 task_management_flags : 8;     // DWORD 2
               u32 task_attribute : 3;            // DWORD 2
               u32 priority : 4;                  // DWORD 2
               u32 rsvd0 : 1;                     // DWORD 2
               u32 command_reference_number : 8;  // DWORD 2
               u32 fcp_cdb_dw0;                   // DWORD 3
               u32 fcp_cdb_dw1;                   // DWORD 4
               u32 fcp_cdb_dw2;                   // DWORD 5
               u32 fcp_cdb_dw3;                   // DWORD 6
               u32 fcp_dl;                        // DWORD 7
               u32 fcp_bi_directional_read_len;   // DWORD 8
            } SG_PACK ; // unnamed struct
            u32 dw[9]; // dword union
         }; // unnamed union
      } SG_PACK FCP_CMD, *PFCP_CMD;

      SG_C_ASSERT(__sizeof__FCP_CMD, sizeof (FCP_CMD) == 36);

   #else
      typedef struct _FCP_CMD {
         u32 lun_hi;                              // DWORD 0
         u32 lun_lo;                              // DWORD 1
         u32 wrdata : 1;                          // DWORD 2
         u32 rddata : 1;                          // DWORD 2
         u32 additional_cdb_len : 6;              // DWORD 2
         u32 task_management_flags : 8;           // DWORD 2
         u32 task_attribute : 3;                  // DWORD 2
         u32 priority : 4;                        // DWORD 2
         u32 rsvd0 : 1;                           // DWORD 2
         u32 command_reference_number : 8;        // DWORD 2
         u32 fcp_cdb_dw0;                         // DWORD 3
         u32 fcp_cdb_dw1;                         // DWORD 4
         u32 fcp_cdb_dw2;                         // DWORD 5
         u32 fcp_cdb_dw3;                         // DWORD 6
         u32 fcp_dl;                              // DWORD 7
         u32 fcp_bi_directional_read_len;         // DWORD 8
      } SG_PACK FCP_CMD, *PFCP_CMD;

      typedef union _FCP_CMD_UNION {
         FCP_CMD bits;
         u32 dw[9]; // dword union
      } SG_PACK FCP_CMD_UNION, *PFCP_CMD_UNION;

      SG_C_ASSERT(__sizeof__FCP_CMD_UNION, sizeof (FCP_CMD_UNION) == 36);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FCP_XFER_RDY {
         union {
            struct { 
               u32 fcp_data_ro;                   // DWORD 0
               u32 fcp_burst_len;                 // DWORD 1
               u32 rsvd0[1];                      // DWORDS 2 to 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK FCP_XFER_RDY, *PFCP_XFER_RDY;

      SG_C_ASSERT(__sizeof__FCP_XFER_RDY, sizeof (FCP_XFER_RDY) == 12);

   #else
      typedef struct _FCP_XFER_RDY {
         u32 fcp_data_ro;                         // DWORD 0
         u32 fcp_burst_len;                       // DWORD 1
         u32 rsvd0[1];                            // DWORDS 2 to 2
      } SG_PACK FCP_XFER_RDY, *PFCP_XFER_RDY;

      typedef union _FCP_XFER_RDY_UNION {
         FCP_XFER_RDY bits;
         u32 dw[3]; // dword union
      } SG_PACK FCP_XFER_RDY_UNION, *PFCP_XFER_RDY_UNION;

      SG_C_ASSERT(__sizeof__FCP_XFER_RDY_UNION, sizeof (FCP_XFER_RDY_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FCP_XFER_RDY {
         union {
            struct { 
               u32 fcp_data_ro;                   // DWORD 0
               u32 fcp_burst_len;                 // DWORD 1
               u32 rsvd0[1];                      // DWORDS 2 to 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK FCP_XFER_RDY, *PFCP_XFER_RDY;

      SG_C_ASSERT(__sizeof__FCP_XFER_RDY, sizeof (FCP_XFER_RDY) == 12);

   #else
      typedef struct _FCP_XFER_RDY {
         u32 fcp_data_ro;                         // DWORD 0
         u32 fcp_burst_len;                       // DWORD 1
         u32 rsvd0[1];                            // DWORDS 2 to 2
      } SG_PACK FCP_XFER_RDY, *PFCP_XFER_RDY;

      typedef union _FCP_XFER_RDY_UNION {
         FCP_XFER_RDY bits;
         u32 dw[3]; // dword union
      } SG_PACK FCP_XFER_RDY_UNION, *PFCP_XFER_RDY_UNION;

      SG_C_ASSERT(__sizeof__FCP_XFER_RDY_UNION, sizeof (FCP_XFER_RDY_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FCP_RSP {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 retry_delay_timer : 16;        // DWORD 2
               u32 fcp_bidi_rsp : 1;              // DWORD 2
               u32 fcp_bidi_read_resid_under : 1; // DWORD 2
               u32 fcp_bidi_read_resid_over : 1;  // DWORD 2
               u32 fcp_conf_req : 1;              // DWORD 2
               u32 fcp_resid_under : 1;           // DWORD 2
               u32 fcp_resid_over : 1;            // DWORD 2
               u32 fcp_sns_len_valid : 1;         // DWORD 2
               u32 fcp_rsp_len_valid : 1;         // DWORD 2
               u32 scsi_status_code : 8;          // DWORD 2
               u32 fcp_resid;                     // DWORD 3
               u32 fcp_sns_len;                   // DWORD 4
               u32 fcp_rsp_len;                   // DWORD 5
               u32 fcp_rsp_info;                  // DWORD 6
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK FCP_RSP, *PFCP_RSP;

      SG_C_ASSERT(__sizeof__FCP_RSP, sizeof (FCP_RSP) == 28);

   #else
      typedef struct _FCP_RSP {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 retry_delay_timer : 16;              // DWORD 2
         u32 fcp_bidi_rsp : 1;                    // DWORD 2
         u32 fcp_bidi_read_resid_under : 1;       // DWORD 2
         u32 fcp_bidi_read_resid_over : 1;        // DWORD 2
         u32 fcp_conf_req : 1;                    // DWORD 2
         u32 fcp_resid_under : 1;                 // DWORD 2
         u32 fcp_resid_over : 1;                  // DWORD 2
         u32 fcp_sns_len_valid : 1;               // DWORD 2
         u32 fcp_rsp_len_valid : 1;               // DWORD 2
         u32 scsi_status_code : 8;                // DWORD 2
         u32 fcp_resid;                           // DWORD 3
         u32 fcp_sns_len;                         // DWORD 4
         u32 fcp_rsp_len;                         // DWORD 5
         u32 fcp_rsp_info;                        // DWORD 6
      } SG_PACK FCP_RSP, *PFCP_RSP;

      typedef union _FCP_RSP_UNION {
         FCP_RSP bits;
         u32 dw[7]; // dword union
      } SG_PACK FCP_RSP_UNION, *PFCP_RSP_UNION;

      SG_C_ASSERT(__sizeof__FCP_RSP_UNION, sizeof (FCP_RSP_UNION) == 28);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FCP_RSP {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 scsi_status_code : 8;          // DWORD 2
               u32 fcp_rsp_len_valid : 1;         // DWORD 2
               u32 fcp_sns_len_valid : 1;         // DWORD 2
               u32 fcp_resid_over : 1;            // DWORD 2
               u32 fcp_resid_under : 1;           // DWORD 2
               u32 fcp_conf_req : 1;              // DWORD 2
               u32 fcp_bidi_read_resid_over : 1;  // DWORD 2
               u32 fcp_bidi_read_resid_under : 1; // DWORD 2
               u32 fcp_bidi_rsp : 1;              // DWORD 2
               u32 retry_delay_timer : 16;        // DWORD 2
               u32 fcp_resid;                     // DWORD 3
               u32 fcp_sns_len;                   // DWORD 4
               u32 fcp_rsp_len;                   // DWORD 5
               u32 fcp_rsp_info;                  // DWORD 6
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK FCP_RSP, *PFCP_RSP;

      SG_C_ASSERT(__sizeof__FCP_RSP, sizeof (FCP_RSP) == 28);

   #else
      typedef struct _FCP_RSP {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 scsi_status_code : 8;                // DWORD 2
         u32 fcp_rsp_len_valid : 1;               // DWORD 2
         u32 fcp_sns_len_valid : 1;               // DWORD 2
         u32 fcp_resid_over : 1;                  // DWORD 2
         u32 fcp_resid_under : 1;                 // DWORD 2
         u32 fcp_conf_req : 1;                    // DWORD 2
         u32 fcp_bidi_read_resid_over : 1;        // DWORD 2
         u32 fcp_bidi_read_resid_under : 1;       // DWORD 2
         u32 fcp_bidi_rsp : 1;                    // DWORD 2
         u32 retry_delay_timer : 16;              // DWORD 2
         u32 fcp_resid;                           // DWORD 3
         u32 fcp_sns_len;                         // DWORD 4
         u32 fcp_rsp_len;                         // DWORD 5
         u32 fcp_rsp_info;                        // DWORD 6
      } SG_PACK FCP_RSP, *PFCP_RSP;

      typedef union _FCP_RSP_UNION {
         FCP_RSP bits;
         u32 dw[7]; // dword union
      } SG_PACK FCP_RSP_UNION, *PFCP_RSP_UNION;

      SG_C_ASSERT(__sizeof__FCP_RSP_UNION, sizeof (FCP_RSP_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FCP response information
   #if defined(SG_BMAP_UNION)
      typedef struct _FCP_RSP_INFO {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 rsp_code : 8;                  // DWORD 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FCP_RSP_INFO, *PFCP_RSP_INFO;

      SG_C_ASSERT(__sizeof__FCP_RSP_INFO, sizeof (FCP_RSP_INFO) == 8);

   #else
      typedef struct _FCP_RSP_INFO {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 rsp_code : 8;                        // DWORD 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
      } SG_PACK FCP_RSP_INFO, *PFCP_RSP_INFO;

      typedef union _FCP_RSP_INFO_UNION {
         FCP_RSP_INFO bits;
         u32 dw[2]; // dword union
      } SG_PACK FCP_RSP_INFO_UNION, *PFCP_RSP_INFO_UNION;

      SG_C_ASSERT(__sizeof__FCP_RSP_INFO_UNION, sizeof (FCP_RSP_INFO_UNION) == 8);
   #endif


#else
   // FCP response information
   #if defined(SG_BMAP_UNION)
      typedef struct _FCP_RSP_INFO {
         union {
            struct { 
               u32 rsp_code : 8;                  // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FCP_RSP_INFO, *PFCP_RSP_INFO;

      SG_C_ASSERT(__sizeof__FCP_RSP_INFO, sizeof (FCP_RSP_INFO) == 8);

   #else
      typedef struct _FCP_RSP_INFO {
         u32 rsp_code : 8;                        // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
      } SG_PACK FCP_RSP_INFO, *PFCP_RSP_INFO;

      typedef union _FCP_RSP_INFO_UNION {
         FCP_RSP_INFO bits;
         u32 dw[2]; // dword union
      } SG_PACK FCP_RSP_INFO_UNION, *PFCP_RSP_INFO_UNION;

      SG_C_ASSERT(__sizeof__FCP_RSP_INFO_UNION, sizeof (FCP_RSP_INFO_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FC-FS-3 BA_ACC payload (reply to ABTS BLS)
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_BA_ACC_PAYLOAD {
         union {
            struct { 
               u32 seq_id_valid : 8;              // DWORD 0
               u32 last_seq_id : 8;               // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 ox_id : 16;                    // DWORD 1
               u32 rx_id : 16;                    // DWORD 1
               u32 lo_seq_cnt : 16;               // DWORD 2
               u32 hi_seq_cnt : 16;               // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK FC_BA_ACC_PAYLOAD, *PFC_BA_ACC_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_BA_ACC_PAYLOAD, sizeof (FC_BA_ACC_PAYLOAD) == 12);

   #else
      typedef struct _FC_BA_ACC_PAYLOAD {
         u32 seq_id_valid : 8;                    // DWORD 0
         u32 last_seq_id : 8;                     // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 ox_id : 16;                          // DWORD 1
         u32 rx_id : 16;                          // DWORD 1
         u32 lo_seq_cnt : 16;                     // DWORD 2
         u32 hi_seq_cnt : 16;                     // DWORD 2
      } SG_PACK FC_BA_ACC_PAYLOAD, *PFC_BA_ACC_PAYLOAD;

      typedef union _FC_BA_ACC_PAYLOAD_UNION {
         FC_BA_ACC_PAYLOAD bits;
         u32 dw[3]; // dword union
      } SG_PACK FC_BA_ACC_PAYLOAD_UNION, *PFC_BA_ACC_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_BA_ACC_PAYLOAD_UNION, sizeof (FC_BA_ACC_PAYLOAD_UNION) == 12);
   #endif


#else
   // FC-FS-3 BA_ACC payload (reply to ABTS BLS)
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_BA_ACC_PAYLOAD {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 last_seq_id : 8;               // DWORD 0
               u32 seq_id_valid : 8;              // DWORD 0
               u32 rx_id : 16;                    // DWORD 1
               u32 ox_id : 16;                    // DWORD 1
               u32 hi_seq_cnt : 16;               // DWORD 2
               u32 lo_seq_cnt : 16;               // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK FC_BA_ACC_PAYLOAD, *PFC_BA_ACC_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_BA_ACC_PAYLOAD, sizeof (FC_BA_ACC_PAYLOAD) == 12);

   #else
      typedef struct _FC_BA_ACC_PAYLOAD {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 last_seq_id : 8;                     // DWORD 0
         u32 seq_id_valid : 8;                    // DWORD 0
         u32 rx_id : 16;                          // DWORD 1
         u32 ox_id : 16;                          // DWORD 1
         u32 hi_seq_cnt : 16;                     // DWORD 2
         u32 lo_seq_cnt : 16;                     // DWORD 2
      } SG_PACK FC_BA_ACC_PAYLOAD, *PFC_BA_ACC_PAYLOAD;

      typedef union _FC_BA_ACC_PAYLOAD_UNION {
         FC_BA_ACC_PAYLOAD bits;
         u32 dw[3]; // dword union
      } SG_PACK FC_BA_ACC_PAYLOAD_UNION, *PFC_BA_ACC_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_BA_ACC_PAYLOAD_UNION, sizeof (FC_BA_ACC_PAYLOAD_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Generic FC-LS-2 ELS payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ELS_PAYLOAD {
         union {
            struct { 
               u32 els_command_code : 8;          // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
               u32 els_payload;                   // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FC_ELS_PAYLOAD, *PFC_ELS_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_ELS_PAYLOAD, sizeof (FC_ELS_PAYLOAD) == 8);

   #else
      typedef struct _FC_ELS_PAYLOAD {
         u32 els_command_code : 8;                // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
         u32 els_payload;                         // DWORD 1
      } SG_PACK FC_ELS_PAYLOAD, *PFC_ELS_PAYLOAD;

      typedef union _FC_ELS_PAYLOAD_UNION {
         FC_ELS_PAYLOAD bits;
         u32 dw[2]; // dword union
      } SG_PACK FC_ELS_PAYLOAD_UNION, *PFC_ELS_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_ELS_PAYLOAD_UNION, sizeof (FC_ELS_PAYLOAD_UNION) == 8);
   #endif


#else
   // Generic FC-LS-2 ELS payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ELS_PAYLOAD {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 els_command_code : 8;          // DWORD 0
               u32 els_payload;                   // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FC_ELS_PAYLOAD, *PFC_ELS_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_ELS_PAYLOAD, sizeof (FC_ELS_PAYLOAD) == 8);

   #else
      typedef struct _FC_ELS_PAYLOAD {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 els_command_code : 8;                // DWORD 0
         u32 els_payload;                         // DWORD 1
      } SG_PACK FC_ELS_PAYLOAD, *PFC_ELS_PAYLOAD;

      typedef union _FC_ELS_PAYLOAD_UNION {
         FC_ELS_PAYLOAD bits;
         u32 dw[2]; // dword union
      } SG_PACK FC_ELS_PAYLOAD_UNION, *PFC_ELS_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_ELS_PAYLOAD_UNION, sizeof (FC_ELS_PAYLOAD_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FC-FS-3 BA_RJT basic link services payload.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_BA_RJT_PAYLOAD {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 reason_code : 8;               // DWORD 0
               u32 reason_explanation : 8;        // DWORD 0
               u32 vendor_unique_code : 8;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FC_BA_RJT_PAYLOAD, *PFC_BA_RJT_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_BA_RJT_PAYLOAD, sizeof (FC_BA_RJT_PAYLOAD) == 4);

   #else
      typedef struct _FC_BA_RJT_PAYLOAD {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 reason_code : 8;                     // DWORD 0
         u32 reason_explanation : 8;              // DWORD 0
         u32 vendor_unique_code : 8;              // DWORD 0
      } SG_PACK FC_BA_RJT_PAYLOAD, *PFC_BA_RJT_PAYLOAD;

      typedef union _FC_BA_RJT_PAYLOAD_UNION {
         FC_BA_RJT_PAYLOAD bits;
         u32 dw; // dword union
      } SG_PACK FC_BA_RJT_PAYLOAD_UNION, *PFC_BA_RJT_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_BA_RJT_PAYLOAD_UNION, sizeof (FC_BA_RJT_PAYLOAD_UNION) == 4);
   #endif


#else
   // FC-FS-3 BA_RJT basic link services payload.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_BA_RJT_PAYLOAD {
         union {
            struct { 
               u32 vendor_unique_code : 8;        // DWORD 0
               u32 reason_explanation : 8;        // DWORD 0
               u32 reason_code : 8;               // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FC_BA_RJT_PAYLOAD, *PFC_BA_RJT_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_BA_RJT_PAYLOAD, sizeof (FC_BA_RJT_PAYLOAD) == 4);

   #else
      typedef struct _FC_BA_RJT_PAYLOAD {
         u32 vendor_unique_code : 8;              // DWORD 0
         u32 reason_explanation : 8;              // DWORD 0
         u32 reason_code : 8;                     // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK FC_BA_RJT_PAYLOAD, *PFC_BA_RJT_PAYLOAD;

      typedef union _FC_BA_RJT_PAYLOAD_UNION {
         FC_BA_RJT_PAYLOAD bits;
         u32 dw; // dword union
      } SG_PACK FC_BA_RJT_PAYLOAD_UNION, *PFC_BA_RJT_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_BA_RJT_PAYLOAD_UNION, sizeof (FC_BA_RJT_PAYLOAD_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FC-LS-2 LS_RJT basic link services payload. The FCP-3 FCP_RJT payload is identical.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_LS_RJT_PAYLOAD {
         union {
            struct { 
               u32 els_command_code : 8;          // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 1
               u32 reason_code : 8;               // DWORD 1
               u32 reason_explanation : 8;        // DWORD 1
               u32 vendor_unique_code : 8;        // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FC_LS_RJT_PAYLOAD, *PFC_LS_RJT_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_LS_RJT_PAYLOAD, sizeof (FC_LS_RJT_PAYLOAD) == 8);

   #else
      typedef struct _FC_LS_RJT_PAYLOAD {
         u32 els_command_code : 8;                // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 1
         u32 reason_code : 8;                     // DWORD 1
         u32 reason_explanation : 8;              // DWORD 1
         u32 vendor_unique_code : 8;              // DWORD 1
      } SG_PACK FC_LS_RJT_PAYLOAD, *PFC_LS_RJT_PAYLOAD;

      typedef union _FC_LS_RJT_PAYLOAD_UNION {
         FC_LS_RJT_PAYLOAD bits;
         u32 dw[2]; // dword union
      } SG_PACK FC_LS_RJT_PAYLOAD_UNION, *PFC_LS_RJT_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_LS_RJT_PAYLOAD_UNION, sizeof (FC_LS_RJT_PAYLOAD_UNION) == 8);
   #endif


#else
   // FC-LS-2 LS_RJT basic link services payload. The FCP-3 FCP_RJT payload is identical.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_LS_RJT_PAYLOAD {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 els_command_code : 8;          // DWORD 0
               u32 vendor_unique_code : 8;        // DWORD 1
               u32 reason_explanation : 8;        // DWORD 1
               u32 reason_code : 8;               // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FC_LS_RJT_PAYLOAD, *PFC_LS_RJT_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_LS_RJT_PAYLOAD, sizeof (FC_LS_RJT_PAYLOAD) == 8);

   #else
      typedef struct _FC_LS_RJT_PAYLOAD {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 els_command_code : 8;                // DWORD 0
         u32 vendor_unique_code : 8;              // DWORD 1
         u32 reason_explanation : 8;              // DWORD 1
         u32 reason_code : 8;                     // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
      } SG_PACK FC_LS_RJT_PAYLOAD, *PFC_LS_RJT_PAYLOAD;

      typedef union _FC_LS_RJT_PAYLOAD_UNION {
         FC_LS_RJT_PAYLOAD bits;
         u32 dw[2]; // dword union
      } SG_PACK FC_LS_RJT_PAYLOAD_UNION, *PFC_LS_RJT_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_LS_RJT_PAYLOAD_UNION, sizeof (FC_LS_RJT_PAYLOAD_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FC-LS-2 REC extended link services payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_REC_PAYLOAD {
         union {
            struct { 
               u32 els_command_code : 8;          // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 1
               u32 exchange_originator_s_id : 24; // DWORD 1
               u32 ox_id : 16;                    // DWORD 2
               u32 rx_id : 16;                    // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK FC_REC_PAYLOAD, *PFC_REC_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_REC_PAYLOAD, sizeof (FC_REC_PAYLOAD) == 12);

   #else
      typedef struct _FC_REC_PAYLOAD {
         u32 els_command_code : 8;                // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 1
         u32 exchange_originator_s_id : 24;       // DWORD 1
         u32 ox_id : 16;                          // DWORD 2
         u32 rx_id : 16;                          // DWORD 2
      } SG_PACK FC_REC_PAYLOAD, *PFC_REC_PAYLOAD;

      typedef union _FC_REC_PAYLOAD_UNION {
         FC_REC_PAYLOAD bits;
         u32 dw[3]; // dword union
      } SG_PACK FC_REC_PAYLOAD_UNION, *PFC_REC_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_REC_PAYLOAD_UNION, sizeof (FC_REC_PAYLOAD_UNION) == 12);
   #endif


#else
   // FC-LS-2 REC extended link services payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_REC_PAYLOAD {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 els_command_code : 8;          // DWORD 0
               u32 exchange_originator_s_id : 24; // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 1
               u32 rx_id : 16;                    // DWORD 2
               u32 ox_id : 16;                    // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK FC_REC_PAYLOAD, *PFC_REC_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_REC_PAYLOAD, sizeof (FC_REC_PAYLOAD) == 12);

   #else
      typedef struct _FC_REC_PAYLOAD {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 els_command_code : 8;                // DWORD 0
         u32 exchange_originator_s_id : 24;       // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
         u32 rx_id : 16;                          // DWORD 2
         u32 ox_id : 16;                          // DWORD 2
      } SG_PACK FC_REC_PAYLOAD, *PFC_REC_PAYLOAD;

      typedef union _FC_REC_PAYLOAD_UNION {
         FC_REC_PAYLOAD bits;
         u32 dw[3]; // dword union
      } SG_PACK FC_REC_PAYLOAD_UNION, *PFC_REC_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_REC_PAYLOAD_UNION, sizeof (FC_REC_PAYLOAD_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FC-LS-2 REC extended link services LS_ACC reply payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_REC_ACC_PAYLOAD {
         union {
            struct { 
               u32 els_command_code : 8;          // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
               u32 ox_id : 16;                    // DWORD 1
               u32 rx_id : 16;                    // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 2
               u32 originator_address_identifier : 24; // DWORD 2
               u32 rsvd2 : 8;                     // DWORD 3
               u32 responder_address_identifier : 24; // DWORD 3
               u32 fc4value;                      // DWORD 4
               u32 e_stat;                        // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK FC_REC_ACC_PAYLOAD, *PFC_REC_ACC_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_REC_ACC_PAYLOAD, sizeof (FC_REC_ACC_PAYLOAD) == 24);

   #else
      typedef struct _FC_REC_ACC_PAYLOAD {
         u32 els_command_code : 8;                // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
         u32 ox_id : 16;                          // DWORD 1
         u32 rx_id : 16;                          // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 2
         u32 originator_address_identifier : 24;  // DWORD 2
         u32 rsvd2 : 8;                           // DWORD 3
         u32 responder_address_identifier : 24;   // DWORD 3
         u32 fc4value;                            // DWORD 4
         u32 e_stat;                              // DWORD 5
      } SG_PACK FC_REC_ACC_PAYLOAD, *PFC_REC_ACC_PAYLOAD;

      typedef union _FC_REC_ACC_PAYLOAD_UNION {
         FC_REC_ACC_PAYLOAD bits;
         u32 dw[6]; // dword union
      } SG_PACK FC_REC_ACC_PAYLOAD_UNION, *PFC_REC_ACC_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_REC_ACC_PAYLOAD_UNION, sizeof (FC_REC_ACC_PAYLOAD_UNION) == 24);
   #endif


#else
   // FC-LS-2 REC extended link services LS_ACC reply payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_REC_ACC_PAYLOAD {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 els_command_code : 8;          // DWORD 0
               u32 rx_id : 16;                    // DWORD 1
               u32 ox_id : 16;                    // DWORD 1
               u32 originator_address_identifier : 24; // DWORD 2
               u32 rsvd1 : 8;                     // DWORD 2
               u32 responder_address_identifier : 24; // DWORD 3
               u32 rsvd2 : 8;                     // DWORD 3
               u32 fc4value;                      // DWORD 4
               u32 e_stat;                        // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK FC_REC_ACC_PAYLOAD, *PFC_REC_ACC_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_REC_ACC_PAYLOAD, sizeof (FC_REC_ACC_PAYLOAD) == 24);

   #else
      typedef struct _FC_REC_ACC_PAYLOAD {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 els_command_code : 8;                // DWORD 0
         u32 rx_id : 16;                          // DWORD 1
         u32 ox_id : 16;                          // DWORD 1
         u32 originator_address_identifier : 24;  // DWORD 2
         u32 rsvd1 : 8;                           // DWORD 2
         u32 responder_address_identifier : 24;   // DWORD 3
         u32 rsvd2 : 8;                           // DWORD 3
         u32 fc4value;                            // DWORD 4
         u32 e_stat;                              // DWORD 5
      } SG_PACK FC_REC_ACC_PAYLOAD, *PFC_REC_ACC_PAYLOAD;

      typedef union _FC_REC_ACC_PAYLOAD_UNION {
         FC_REC_ACC_PAYLOAD bits;
         u32 dw[6]; // dword union
      } SG_PACK FC_REC_ACC_PAYLOAD_UNION, *PFC_REC_ACC_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_REC_ACC_PAYLOAD_UNION, sizeof (FC_REC_ACC_PAYLOAD_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FCP-3 SRR extended link services payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_SRR_PAYLOAD {
         union {
            struct { 
               u32 els_command_code : 8;          // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
               u32 ox_id : 16;                    // DWORD 1
               u32 rx_id : 16;                    // DWORD 1
               u32 relative_offset;               // DWORD 2
               u32 r_ctl_for_iu : 8;              // DWORD 3
               u32 rsvd1 : 24;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_SRR_PAYLOAD, *PFC_SRR_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_SRR_PAYLOAD, sizeof (FC_SRR_PAYLOAD) == 16);

   #else
      typedef struct _FC_SRR_PAYLOAD {
         u32 els_command_code : 8;                // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
         u32 ox_id : 16;                          // DWORD 1
         u32 rx_id : 16;                          // DWORD 1
         u32 relative_offset;                     // DWORD 2
         u32 r_ctl_for_iu : 8;                    // DWORD 3
         u32 rsvd1 : 24;                          // DWORD 3
      } SG_PACK FC_SRR_PAYLOAD, *PFC_SRR_PAYLOAD;

      typedef union _FC_SRR_PAYLOAD_UNION {
         FC_SRR_PAYLOAD bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_SRR_PAYLOAD_UNION, *PFC_SRR_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_SRR_PAYLOAD_UNION, sizeof (FC_SRR_PAYLOAD_UNION) == 16);
   #endif


#else
   // FCP-3 SRR extended link services payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_SRR_PAYLOAD {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 els_command_code : 8;          // DWORD 0
               u32 rx_id : 16;                    // DWORD 1
               u32 ox_id : 16;                    // DWORD 1
               u32 relative_offset;               // DWORD 2
               u32 rsvd1 : 24;                    // DWORD 3
               u32 r_ctl_for_iu : 8;              // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_SRR_PAYLOAD, *PFC_SRR_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_SRR_PAYLOAD, sizeof (FC_SRR_PAYLOAD) == 16);

   #else
      typedef struct _FC_SRR_PAYLOAD {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 els_command_code : 8;                // DWORD 0
         u32 rx_id : 16;                          // DWORD 1
         u32 ox_id : 16;                          // DWORD 1
         u32 relative_offset;                     // DWORD 2
         u32 rsvd1 : 24;                          // DWORD 3
         u32 r_ctl_for_iu : 8;                    // DWORD 3
      } SG_PACK FC_SRR_PAYLOAD, *PFC_SRR_PAYLOAD;

      typedef union _FC_SRR_PAYLOAD_UNION {
         FC_SRR_PAYLOAD bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_SRR_PAYLOAD_UNION, *PFC_SRR_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_SRR_PAYLOAD_UNION, sizeof (FC_SRR_PAYLOAD_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FC-LS-2 SRR extended link services LS_ACC reply payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_SRR_ACC_PAYLOAD {
         union {
            struct { 
               u32 els_command_code : 8;          // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FC_SRR_ACC_PAYLOAD, *PFC_SRR_ACC_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_SRR_ACC_PAYLOAD, sizeof (FC_SRR_ACC_PAYLOAD) == 4);

   #else
      typedef struct _FC_SRR_ACC_PAYLOAD {
         u32 els_command_code : 8;                // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK FC_SRR_ACC_PAYLOAD, *PFC_SRR_ACC_PAYLOAD;

      typedef union _FC_SRR_ACC_PAYLOAD_UNION {
         FC_SRR_ACC_PAYLOAD bits;
         u32 dw; // dword union
      } SG_PACK FC_SRR_ACC_PAYLOAD_UNION, *PFC_SRR_ACC_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_SRR_ACC_PAYLOAD_UNION, sizeof (FC_SRR_ACC_PAYLOAD_UNION) == 4);
   #endif


#else
   // FC-LS-2 SRR extended link services LS_ACC reply payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_SRR_ACC_PAYLOAD {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 els_command_code : 8;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FC_SRR_ACC_PAYLOAD, *PFC_SRR_ACC_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_SRR_ACC_PAYLOAD, sizeof (FC_SRR_ACC_PAYLOAD) == 4);

   #else
      typedef struct _FC_SRR_ACC_PAYLOAD {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 els_command_code : 8;                // DWORD 0
      } SG_PACK FC_SRR_ACC_PAYLOAD, *PFC_SRR_ACC_PAYLOAD;

      typedef union _FC_SRR_ACC_PAYLOAD_UNION {
         FC_SRR_ACC_PAYLOAD bits;
         u32 dw; // dword union
      } SG_PACK FC_SRR_ACC_PAYLOAD_UNION, *PFC_SRR_ACC_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_SRR_ACC_PAYLOAD_UNION, sizeof (FC_SRR_ACC_PAYLOAD_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Association Header
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ASSOCIATION_HEADER {
         union {
            struct { 
               u32 Originator_Process_Associator_Hi : 24; // DWORD 0
               u32 Multicast_Process_Associator : 1; // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 Responder_Process_Associator_Valid : 1; // DWORD 0
               u32 Originator_Process_Associator_Valid : 1; // DWORD 0
               u32 Originator_Process_Associator_Lo; // DWORD 1
               u32 Responder_Process_Associator_Hi : 24; // DWORD 2
               u32 rsvd1 : 8;                     // DWORD 2
               u32 Responder_Process_Associator_Lo; // DWORD 3
               u32 rsvd2[1];                      // DWORDS 4 to 4
               u32 rsvd3[1];                      // DWORDS 5 to 5
               u32 rsvd4[1];                      // DWORDS 6 to 6
               u32 rsvd5[1];                      // DWORDS 7 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK FC_ASSOCIATION_HEADER, *PFC_ASSOCIATION_HEADER;

      SG_C_ASSERT(__sizeof__FC_ASSOCIATION_HEADER, sizeof (FC_ASSOCIATION_HEADER) == 32);

   #else
      typedef struct _FC_ASSOCIATION_HEADER {
         u32 Originator_Process_Associator_Hi : 24; // DWORD 0
         u32 Multicast_Process_Associator : 1;    // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 Responder_Process_Associator_Valid : 1; // DWORD 0
         u32 Originator_Process_Associator_Valid : 1; // DWORD 0
         u32 Originator_Process_Associator_Lo;    // DWORD 1
         u32 Responder_Process_Associator_Hi : 24; // DWORD 2
         u32 rsvd1 : 8;                           // DWORD 2
         u32 Responder_Process_Associator_Lo;     // DWORD 3
         u32 rsvd2[1];                            // DWORDS 4 to 4
         u32 rsvd3[1];                            // DWORDS 5 to 5
         u32 rsvd4[1];                            // DWORDS 6 to 6
         u32 rsvd5[1];                            // DWORDS 7 to 7
      } SG_PACK FC_ASSOCIATION_HEADER, *PFC_ASSOCIATION_HEADER;

      typedef union _FC_ASSOCIATION_HEADER_UNION {
         FC_ASSOCIATION_HEADER bits;
         u32 dw[8]; // dword union
      } SG_PACK FC_ASSOCIATION_HEADER_UNION, *PFC_ASSOCIATION_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FC_ASSOCIATION_HEADER_UNION, sizeof (FC_ASSOCIATION_HEADER_UNION) == 32);
   #endif


#else
   // Association Header
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ASSOCIATION_HEADER {
         union {
            struct { 
               u32 Originator_Process_Associator_Valid : 1; // DWORD 0
               u32 Responder_Process_Associator_Valid : 1; // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 Multicast_Process_Associator : 1; // DWORD 0
               u32 Originator_Process_Associator_Hi : 24; // DWORD 0
               u32 Originator_Process_Associator_Lo; // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 2
               u32 Responder_Process_Associator_Hi : 24; // DWORD 2
               u32 Responder_Process_Associator_Lo; // DWORD 3
               u32 rsvd2[1];                      // DWORDS 4 to 4
               u32 rsvd3[1];                      // DWORDS 5 to 5
               u32 rsvd4[1];                      // DWORDS 6 to 6
               u32 rsvd5[1];                      // DWORDS 7 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK FC_ASSOCIATION_HEADER, *PFC_ASSOCIATION_HEADER;

      SG_C_ASSERT(__sizeof__FC_ASSOCIATION_HEADER, sizeof (FC_ASSOCIATION_HEADER) == 32);

   #else
      typedef struct _FC_ASSOCIATION_HEADER {
         u32 Originator_Process_Associator_Valid : 1; // DWORD 0
         u32 Responder_Process_Associator_Valid : 1; // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 Multicast_Process_Associator : 1;    // DWORD 0
         u32 Originator_Process_Associator_Hi : 24; // DWORD 0
         u32 Originator_Process_Associator_Lo;    // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 2
         u32 Responder_Process_Associator_Hi : 24; // DWORD 2
         u32 Responder_Process_Associator_Lo;     // DWORD 3
         u32 rsvd2[1];                            // DWORDS 4 to 4
         u32 rsvd3[1];                            // DWORDS 5 to 5
         u32 rsvd4[1];                            // DWORDS 6 to 6
         u32 rsvd5[1];                            // DWORDS 7 to 7
      } SG_PACK FC_ASSOCIATION_HEADER, *PFC_ASSOCIATION_HEADER;

      typedef union _FC_ASSOCIATION_HEADER_UNION {
         FC_ASSOCIATION_HEADER bits;
         u32 dw[8]; // dword union
      } SG_PACK FC_ASSOCIATION_HEADER_UNION, *PFC_ASSOCIATION_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FC_ASSOCIATION_HEADER_UNION, sizeof (FC_ASSOCIATION_HEADER_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FC-LS-2 RRQ extended link services payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_RRQ_PAYLOAD {
         union {
            struct { 
               u32 els_command_code : 8;          // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 1
               u32 exchange_originator_s_id : 24; // DWORD 1
               u32 ox_id : 16;                    // DWORD 2
               u32 rx_id : 16;                    // DWORD 2
               FC_ASSOCIATION_HEADER association_header;
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK FC_RRQ_PAYLOAD, *PFC_RRQ_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_RRQ_PAYLOAD, sizeof (FC_RRQ_PAYLOAD) == 44);

   #else
      typedef struct _FC_RRQ_PAYLOAD {
         u32 els_command_code : 8;                // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 1
         u32 exchange_originator_s_id : 24;       // DWORD 1
         u32 ox_id : 16;                          // DWORD 2
         u32 rx_id : 16;                          // DWORD 2
         FC_ASSOCIATION_HEADER association_header;
      } SG_PACK FC_RRQ_PAYLOAD, *PFC_RRQ_PAYLOAD;

      typedef union _FC_RRQ_PAYLOAD_UNION {
         FC_RRQ_PAYLOAD bits;
         u32 dw[11]; // dword union
      } SG_PACK FC_RRQ_PAYLOAD_UNION, *PFC_RRQ_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_RRQ_PAYLOAD_UNION, sizeof (FC_RRQ_PAYLOAD_UNION) == 44);
   #endif


#else
   // FC-LS-2 RRQ extended link services payload
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_RRQ_PAYLOAD {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 els_command_code : 8;          // DWORD 0
               u32 exchange_originator_s_id : 24; // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 1
               u32 rx_id : 16;                    // DWORD 2
               u32 ox_id : 16;                    // DWORD 2
               FC_ASSOCIATION_HEADER association_header;
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK FC_RRQ_PAYLOAD, *PFC_RRQ_PAYLOAD;

      SG_C_ASSERT(__sizeof__FC_RRQ_PAYLOAD, sizeof (FC_RRQ_PAYLOAD) == 44);

   #else
      typedef struct _FC_RRQ_PAYLOAD {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 els_command_code : 8;                // DWORD 0
         u32 exchange_originator_s_id : 24;       // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
         u32 rx_id : 16;                          // DWORD 2
         u32 ox_id : 16;                          // DWORD 2
         FC_ASSOCIATION_HEADER association_header;
      } SG_PACK FC_RRQ_PAYLOAD, *PFC_RRQ_PAYLOAD;

      typedef union _FC_RRQ_PAYLOAD_UNION {
         FC_RRQ_PAYLOAD bits;
         u32 dw[11]; // dword union
      } SG_PACK FC_RRQ_PAYLOAD_UNION, *PFC_RRQ_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__FC_RRQ_PAYLOAD_UNION, sizeof (FC_RRQ_PAYLOAD_UNION) == 44);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Format of FIP frame and Encapsulated FIP operation
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_FRAME {
         union {
            struct { 
               u32 dmac_hi_32;                    // DWORD 0
               u32 dmac_lo_16 : 16;               // DWORD 1
               u32 smac_hi_16 : 16;               // DWORD 1
               u32 smac_lo_32;                    // DWORD 2
               u32 type : 16;                     // DWORD 3
               u32 ver : 4;                       // DWORD 3
               u32 rsvd0 : 12;                    // DWORD 3
               u32 fip_operation_code : 16;       // DWORD 4
               u32 rsvd1 : 8;                     // DWORD 4
               u32 fip_subcode : 8;               // DWORD 4
               u32 fip_descriptor_list_length : 16; // DWORD 5
               u32 fp : 1;                        // DWORD 5
               u32 sp : 1;                        // DWORD 5
               u32 rsvd2 : 11;                    // DWORD 5
               u32 a : 1;                         // DWORD 5
               u32 s : 1;                         // DWORD 5
               u32 f : 1;                         // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK FIP_FRAME, *PFIP_FRAME;

      SG_C_ASSERT(__sizeof__FIP_FRAME, sizeof (FIP_FRAME) == 24);

   #else
      typedef struct _FIP_FRAME {
         u32 dmac_hi_32;                          // DWORD 0
         u32 dmac_lo_16 : 16;                     // DWORD 1
         u32 smac_hi_16 : 16;                     // DWORD 1
         u32 smac_lo_32;                          // DWORD 2
         u32 type : 16;                           // DWORD 3
         u32 ver : 4;                             // DWORD 3
         u32 rsvd0 : 12;                          // DWORD 3
         u32 fip_operation_code : 16;             // DWORD 4
         u32 rsvd1 : 8;                           // DWORD 4
         u32 fip_subcode : 8;                     // DWORD 4
         u32 fip_descriptor_list_length : 16;     // DWORD 5
         u32 fp : 1;                              // DWORD 5
         u32 sp : 1;                              // DWORD 5
         u32 rsvd2 : 11;                          // DWORD 5
         u32 a : 1;                               // DWORD 5
         u32 s : 1;                               // DWORD 5
         u32 f : 1;                               // DWORD 5
      } SG_PACK FIP_FRAME, *PFIP_FRAME;

      typedef union _FIP_FRAME_UNION {
         FIP_FRAME bits;
         u32 dw[6]; // dword union
      } SG_PACK FIP_FRAME_UNION, *PFIP_FRAME_UNION;

      SG_C_ASSERT(__sizeof__FIP_FRAME_UNION, sizeof (FIP_FRAME_UNION) == 24);
   #endif


#else
   // Format of FIP frame and Encapsulated FIP operation
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_FRAME {
         union {
            struct { 
               u32 dmac_hi_32;                    // DWORD 0
               u32 smac_hi_16 : 16;               // DWORD 1
               u32 dmac_lo_16 : 16;               // DWORD 1
               u32 smac_lo_32;                    // DWORD 2
               u32 rsvd0 : 12;                    // DWORD 3
               u32 ver : 4;                       // DWORD 3
               u32 type : 16;                     // DWORD 3
               u32 fip_subcode : 8;               // DWORD 4
               u32 rsvd1 : 8;                     // DWORD 4
               u32 fip_operation_code : 16;       // DWORD 4
               u32 f : 1;                         // DWORD 5
               u32 s : 1;                         // DWORD 5
               u32 a : 1;                         // DWORD 5
               u32 rsvd2 : 11;                    // DWORD 5
               u32 sp : 1;                        // DWORD 5
               u32 fp : 1;                        // DWORD 5
               u32 fip_descriptor_list_length : 16; // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK FIP_FRAME, *PFIP_FRAME;

      SG_C_ASSERT(__sizeof__FIP_FRAME, sizeof (FIP_FRAME) == 24);

   #else
      typedef struct _FIP_FRAME {
         u32 dmac_hi_32;                          // DWORD 0
         u32 smac_hi_16 : 16;                     // DWORD 1
         u32 dmac_lo_16 : 16;                     // DWORD 1
         u32 smac_lo_32;                          // DWORD 2
         u32 rsvd0 : 12;                          // DWORD 3
         u32 ver : 4;                             // DWORD 3
         u32 type : 16;                           // DWORD 3
         u32 fip_subcode : 8;                     // DWORD 4
         u32 rsvd1 : 8;                           // DWORD 4
         u32 fip_operation_code : 16;             // DWORD 4
         u32 f : 1;                               // DWORD 5
         u32 s : 1;                               // DWORD 5
         u32 a : 1;                               // DWORD 5
         u32 rsvd2 : 11;                          // DWORD 5
         u32 sp : 1;                              // DWORD 5
         u32 fp : 1;                              // DWORD 5
         u32 fip_descriptor_list_length : 16;     // DWORD 5
      } SG_PACK FIP_FRAME, *PFIP_FRAME;

      typedef union _FIP_FRAME_UNION {
         FIP_FRAME bits;
         u32 dw[6]; // dword union
      } SG_PACK FIP_FRAME_UNION, *PFIP_FRAME_UNION;

      SG_C_ASSERT(__sizeof__FIP_FRAME_UNION, sizeof (FIP_FRAME_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Format of FIP frame and Encapsulated FIP operation
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_FRAME_VLAN {
         union {
            struct { 
               u32 dmac_hi_32;                    // DWORD 0
               u32 dmac_lo_16 : 16;               // DWORD 1
               u32 smac_hi_16 : 16;               // DWORD 1
               u32 smac_lo_32;                    // DWORD 2
               u32 ether_type : 16;               // DWORD 3
               u32 pri : 3;                       // DWORD 3
               u32 cannonical : 1;                // DWORD 3
               u32 vlan_id : 12;                  // DWORD 3
               u32 type : 16;                     // DWORD 4
               u32 ver : 4;                       // DWORD 4
               u32 rsvd0 : 12;                    // DWORD 4
               u32 fip_operation_code : 16;       // DWORD 5
               u32 rsvd1 : 8;                     // DWORD 5
               u32 fip_subcode : 8;               // DWORD 5
               u32 fip_descriptor_list_length : 16; // DWORD 6
               u32 fp : 1;                        // DWORD 6
               u32 sp : 1;                        // DWORD 6
               u32 rsvd2 : 11;                    // DWORD 6
               u32 a : 1;                         // DWORD 6
               u32 s : 1;                         // DWORD 6
               u32 f : 1;                         // DWORD 6
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK FIP_FRAME_VLAN, *PFIP_FRAME_VLAN;

      SG_C_ASSERT(__sizeof__FIP_FRAME_VLAN, sizeof (FIP_FRAME_VLAN) == 28);

   #else
      typedef struct _FIP_FRAME_VLAN {
         u32 dmac_hi_32;                          // DWORD 0
         u32 dmac_lo_16 : 16;                     // DWORD 1
         u32 smac_hi_16 : 16;                     // DWORD 1
         u32 smac_lo_32;                          // DWORD 2
         u32 ether_type : 16;                     // DWORD 3
         u32 pri : 3;                             // DWORD 3
         u32 cannonical : 1;                      // DWORD 3
         u32 vlan_id : 12;                        // DWORD 3
         u32 type : 16;                           // DWORD 4
         u32 ver : 4;                             // DWORD 4
         u32 rsvd0 : 12;                          // DWORD 4
         u32 fip_operation_code : 16;             // DWORD 5
         u32 rsvd1 : 8;                           // DWORD 5
         u32 fip_subcode : 8;                     // DWORD 5
         u32 fip_descriptor_list_length : 16;     // DWORD 6
         u32 fp : 1;                              // DWORD 6
         u32 sp : 1;                              // DWORD 6
         u32 rsvd2 : 11;                          // DWORD 6
         u32 a : 1;                               // DWORD 6
         u32 s : 1;                               // DWORD 6
         u32 f : 1;                               // DWORD 6
      } SG_PACK FIP_FRAME_VLAN, *PFIP_FRAME_VLAN;

      typedef union _FIP_FRAME_VLAN_UNION {
         FIP_FRAME_VLAN bits;
         u32 dw[7]; // dword union
      } SG_PACK FIP_FRAME_VLAN_UNION, *PFIP_FRAME_VLAN_UNION;

      SG_C_ASSERT(__sizeof__FIP_FRAME_VLAN_UNION, sizeof (FIP_FRAME_VLAN_UNION) == 28);
   #endif


#else
   // Format of FIP frame and Encapsulated FIP operation
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_FRAME_VLAN {
         union {
            struct { 
               u32 dmac_hi_32;                    // DWORD 0
               u32 smac_hi_16 : 16;               // DWORD 1
               u32 dmac_lo_16 : 16;               // DWORD 1
               u32 smac_lo_32;                    // DWORD 2
               u32 vlan_id : 12;                  // DWORD 3
               u32 cannonical : 1;                // DWORD 3
               u32 pri : 3;                       // DWORD 3
               u32 ether_type : 16;               // DWORD 3
               u32 rsvd0 : 12;                    // DWORD 4
               u32 ver : 4;                       // DWORD 4
               u32 type : 16;                     // DWORD 4
               u32 fip_subcode : 8;               // DWORD 5
               u32 rsvd1 : 8;                     // DWORD 5
               u32 fip_operation_code : 16;       // DWORD 5
               u32 f : 1;                         // DWORD 6
               u32 s : 1;                         // DWORD 6
               u32 a : 1;                         // DWORD 6
               u32 rsvd2 : 11;                    // DWORD 6
               u32 sp : 1;                        // DWORD 6
               u32 fp : 1;                        // DWORD 6
               u32 fip_descriptor_list_length : 16; // DWORD 6
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK FIP_FRAME_VLAN, *PFIP_FRAME_VLAN;

      SG_C_ASSERT(__sizeof__FIP_FRAME_VLAN, sizeof (FIP_FRAME_VLAN) == 28);

   #else
      typedef struct _FIP_FRAME_VLAN {
         u32 dmac_hi_32;                          // DWORD 0
         u32 smac_hi_16 : 16;                     // DWORD 1
         u32 dmac_lo_16 : 16;                     // DWORD 1
         u32 smac_lo_32;                          // DWORD 2
         u32 vlan_id : 12;                        // DWORD 3
         u32 cannonical : 1;                      // DWORD 3
         u32 pri : 3;                             // DWORD 3
         u32 ether_type : 16;                     // DWORD 3
         u32 rsvd0 : 12;                          // DWORD 4
         u32 ver : 4;                             // DWORD 4
         u32 type : 16;                           // DWORD 4
         u32 fip_subcode : 8;                     // DWORD 5
         u32 rsvd1 : 8;                           // DWORD 5
         u32 fip_operation_code : 16;             // DWORD 5
         u32 f : 1;                               // DWORD 6
         u32 s : 1;                               // DWORD 6
         u32 a : 1;                               // DWORD 6
         u32 rsvd2 : 11;                          // DWORD 6
         u32 sp : 1;                              // DWORD 6
         u32 fp : 1;                              // DWORD 6
         u32 fip_descriptor_list_length : 16;     // DWORD 6
      } SG_PACK FIP_FRAME_VLAN, *PFIP_FRAME_VLAN;

      typedef union _FIP_FRAME_VLAN_UNION {
         FIP_FRAME_VLAN bits;
         u32 dw[7]; // dword union
      } SG_PACK FIP_FRAME_VLAN_UNION, *PFIP_FRAME_VLAN_UNION;

      SG_C_ASSERT(__sizeof__FIP_FRAME_VLAN_UNION, sizeof (FIP_FRAME_VLAN_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Format of FIP MAC AddressDescriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_MAC_ADDR_DESCRIPTOR {
         union {
            struct { 
               u32 type : 8;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 mac_hi_16 : 16;                // DWORD 0
               u32 mac_lo_32;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FIP_MAC_ADDR_DESCRIPTOR, *PFIP_MAC_ADDR_DESCRIPTOR;

      SG_C_ASSERT(__sizeof__FIP_MAC_ADDR_DESCRIPTOR, sizeof (FIP_MAC_ADDR_DESCRIPTOR) == 8);

   #else
      typedef struct _FIP_MAC_ADDR_DESCRIPTOR {
         u32 type : 8;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 mac_hi_16 : 16;                      // DWORD 0
         u32 mac_lo_32;                           // DWORD 1
      } SG_PACK FIP_MAC_ADDR_DESCRIPTOR, *PFIP_MAC_ADDR_DESCRIPTOR;

      typedef union _FIP_MAC_ADDR_DESCRIPTOR_UNION {
         FIP_MAC_ADDR_DESCRIPTOR bits;
         u32 dw[2]; // dword union
      } SG_PACK FIP_MAC_ADDR_DESCRIPTOR_UNION, *PFIP_MAC_ADDR_DESCRIPTOR_UNION;

      SG_C_ASSERT(__sizeof__FIP_MAC_ADDR_DESCRIPTOR_UNION, sizeof (FIP_MAC_ADDR_DESCRIPTOR_UNION) == 8);
   #endif


#else
   // Format of FIP MAC AddressDescriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_MAC_ADDR_DESCRIPTOR {
         union {
            struct { 
               u32 mac_hi_16 : 16;                // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 type : 8;                      // DWORD 0
               u32 mac_lo_32;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FIP_MAC_ADDR_DESCRIPTOR, *PFIP_MAC_ADDR_DESCRIPTOR;

      SG_C_ASSERT(__sizeof__FIP_MAC_ADDR_DESCRIPTOR, sizeof (FIP_MAC_ADDR_DESCRIPTOR) == 8);

   #else
      typedef struct _FIP_MAC_ADDR_DESCRIPTOR {
         u32 mac_hi_16 : 16;                      // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 type : 8;                            // DWORD 0
         u32 mac_lo_32;                           // DWORD 1
      } SG_PACK FIP_MAC_ADDR_DESCRIPTOR, *PFIP_MAC_ADDR_DESCRIPTOR;

      typedef union _FIP_MAC_ADDR_DESCRIPTOR_UNION {
         FIP_MAC_ADDR_DESCRIPTOR bits;
         u32 dw[2]; // dword union
      } SG_PACK FIP_MAC_ADDR_DESCRIPTOR_UNION, *PFIP_MAC_ADDR_DESCRIPTOR_UNION;

      SG_C_ASSERT(__sizeof__FIP_MAC_ADDR_DESCRIPTOR_UNION, sizeof (FIP_MAC_ADDR_DESCRIPTOR_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Format of FIP FLOGI or NPIV FDISC descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_FLOGI_DESCRIPTOR {
         union {
            struct { 
               u32 type : 8;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               FC_HEADER fc_header;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK FIP_FLOGI_DESCRIPTOR, *PFIP_FLOGI_DESCRIPTOR;

      SG_C_ASSERT(__sizeof__FIP_FLOGI_DESCRIPTOR, sizeof (FIP_FLOGI_DESCRIPTOR) == 28);

   #else
      typedef struct _FIP_FLOGI_DESCRIPTOR {
         u32 type : 8;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         FC_HEADER fc_header;
      } SG_PACK FIP_FLOGI_DESCRIPTOR, *PFIP_FLOGI_DESCRIPTOR;

      typedef union _FIP_FLOGI_DESCRIPTOR_UNION {
         FIP_FLOGI_DESCRIPTOR bits;
         u32 dw[7]; // dword union
      } SG_PACK FIP_FLOGI_DESCRIPTOR_UNION, *PFIP_FLOGI_DESCRIPTOR_UNION;

      SG_C_ASSERT(__sizeof__FIP_FLOGI_DESCRIPTOR_UNION, sizeof (FIP_FLOGI_DESCRIPTOR_UNION) == 28);
   #endif


#else
   // Format of FIP FLOGI or NPIV FDISC descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_FLOGI_DESCRIPTOR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 type : 8;                      // DWORD 0
               FC_HEADER fc_header;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK FIP_FLOGI_DESCRIPTOR, *PFIP_FLOGI_DESCRIPTOR;

      SG_C_ASSERT(__sizeof__FIP_FLOGI_DESCRIPTOR, sizeof (FIP_FLOGI_DESCRIPTOR) == 28);

   #else
      typedef struct _FIP_FLOGI_DESCRIPTOR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 type : 8;                            // DWORD 0
         FC_HEADER fc_header;
      } SG_PACK FIP_FLOGI_DESCRIPTOR, *PFIP_FLOGI_DESCRIPTOR;

      typedef union _FIP_FLOGI_DESCRIPTOR_UNION {
         FIP_FLOGI_DESCRIPTOR bits;
         u32 dw[7]; // dword union
      } SG_PACK FIP_FLOGI_DESCRIPTOR_UNION, *PFIP_FLOGI_DESCRIPTOR_UNION;

      SG_C_ASSERT(__sizeof__FIP_FLOGI_DESCRIPTOR_UNION, sizeof (FIP_FLOGI_DESCRIPTOR_UNION) == 28);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __headers_bmap_h__

