/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __pcicfg_bmap_h__
#define __pcicfg_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "mpu_local_mmr_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Vendor and Device ID Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_ID_F0_CSR {
         union {
            struct { 
               u32 deviceid : 16;                 // DWORD 0
               u32 vendorid : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_ID_F0_CSR, *PPCICFG_ID_F0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_ID_F0_CSR, sizeof (PCICFG_ID_F0_CSR) == 4);

   #else
      typedef struct _PCICFG_ID_F0_CSR {
         u32 deviceid : 16;                       // DWORD 0
         u32 vendorid : 16;                       // DWORD 0
      } SG_PACK PCICFG_ID_F0_CSR, *PPCICFG_ID_F0_CSR;

      typedef union _PCICFG_ID_F0_CSR_UNION {
         PCICFG_ID_F0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_ID_F0_CSR_UNION, *PPCICFG_ID_F0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_ID_F0_CSR_UNION, sizeof (PCICFG_ID_F0_CSR_UNION) == 4);
   #endif


#else
   // Vendor and Device ID Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_ID_F0_CSR {
         union {
            struct { 
               u32 vendorid : 16;                 // DWORD 0
               u32 deviceid : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_ID_F0_CSR, *PPCICFG_ID_F0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_ID_F0_CSR, sizeof (PCICFG_ID_F0_CSR) == 4);

   #else
      typedef struct _PCICFG_ID_F0_CSR {
         u32 vendorid : 16;                       // DWORD 0
         u32 deviceid : 16;                       // DWORD 0
      } SG_PACK PCICFG_ID_F0_CSR, *PPCICFG_ID_F0_CSR;

      typedef union _PCICFG_ID_F0_CSR_UNION {
         PCICFG_ID_F0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_ID_F0_CSR_UNION, *PPCICFG_ID_F0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_ID_F0_CSR_UNION, sizeof (PCICFG_ID_F0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Vendor and Device ID Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_ID_F1_CSR {
         union {
            struct { 
               u32 deviceid : 16;                 // DWORD 0
               u32 vendorid : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_ID_F1_CSR, *PPCICFG_ID_F1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_ID_F1_CSR, sizeof (PCICFG_ID_F1_CSR) == 4);

   #else
      typedef struct _PCICFG_ID_F1_CSR {
         u32 deviceid : 16;                       // DWORD 0
         u32 vendorid : 16;                       // DWORD 0
      } SG_PACK PCICFG_ID_F1_CSR, *PPCICFG_ID_F1_CSR;

      typedef union _PCICFG_ID_F1_CSR_UNION {
         PCICFG_ID_F1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_ID_F1_CSR_UNION, *PPCICFG_ID_F1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_ID_F1_CSR_UNION, sizeof (PCICFG_ID_F1_CSR_UNION) == 4);
   #endif


#else
   // Vendor and Device ID Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_ID_F1_CSR {
         union {
            struct { 
               u32 vendorid : 16;                 // DWORD 0
               u32 deviceid : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_ID_F1_CSR, *PPCICFG_ID_F1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_ID_F1_CSR, sizeof (PCICFG_ID_F1_CSR) == 4);

   #else
      typedef struct _PCICFG_ID_F1_CSR {
         u32 vendorid : 16;                       // DWORD 0
         u32 deviceid : 16;                       // DWORD 0
      } SG_PACK PCICFG_ID_F1_CSR, *PPCICFG_ID_F1_CSR;

      typedef union _PCICFG_ID_F1_CSR_UNION {
         PCICFG_ID_F1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_ID_F1_CSR_UNION, *PPCICFG_ID_F1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_ID_F1_CSR_UNION, sizeof (PCICFG_ID_F1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Command and Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_COMMAND_STATUS_CSR {
         union {
            struct { 
               u32 dperr : 1;                     // DWORD 0
               u32 sserr : 1;                     // DWORD 0
               u32 rmabt : 1;                     // DWORD 0
               u32 rtabt : 1;                     // DWORD 0
               u32 stabt : 1;                     // DWORD 0
               u32 rsvd9 : 2;                     // DWORD 0
               u32 dpderr : 1;                    // DWORD 0
               u32 rsvd8 : 1;                     // DWORD 0
               u32 rsvd7 : 1;                     // DWORD 0
               u32 rsvd6 : 1;                     // DWORD 0
               u32 cap : 1;                       // DWORD 0
               u32 intstat : 1;                   // DWORD 0
               u32 rsvd5 : 3;                     // DWORD 0
               u32 rsvd4 : 5;                     // DWORD 0
               u32 intxdisable : 1;               // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 serren : 1;                    // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 perrsp : 1;                    // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 bmen : 1;                      // DWORD 0
               u32 memen : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_COMMAND_STATUS_CSR, *PPCICFG_COMMAND_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_COMMAND_STATUS_CSR, sizeof (PCICFG_COMMAND_STATUS_CSR) == 4);

   #else
      typedef struct _PCICFG_COMMAND_STATUS_CSR {
         u32 dperr : 1;                           // DWORD 0
         u32 sserr : 1;                           // DWORD 0
         u32 rmabt : 1;                           // DWORD 0
         u32 rtabt : 1;                           // DWORD 0
         u32 stabt : 1;                           // DWORD 0
         u32 rsvd9 : 2;                           // DWORD 0
         u32 dpderr : 1;                          // DWORD 0
         u32 rsvd8 : 1;                           // DWORD 0
         u32 rsvd7 : 1;                           // DWORD 0
         u32 rsvd6 : 1;                           // DWORD 0
         u32 cap : 1;                             // DWORD 0
         u32 intstat : 1;                         // DWORD 0
         u32 rsvd5 : 3;                           // DWORD 0
         u32 rsvd4 : 5;                           // DWORD 0
         u32 intxdisable : 1;                     // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 serren : 1;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 perrsp : 1;                          // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 bmen : 1;                            // DWORD 0
         u32 memen : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK PCICFG_COMMAND_STATUS_CSR, *PPCICFG_COMMAND_STATUS_CSR;

      typedef union _PCICFG_COMMAND_STATUS_CSR_UNION {
         PCICFG_COMMAND_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_COMMAND_STATUS_CSR_UNION, *PPCICFG_COMMAND_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_COMMAND_STATUS_CSR_UNION, sizeof (PCICFG_COMMAND_STATUS_CSR_UNION) == 4);
   #endif


#else
   // Command and Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_COMMAND_STATUS_CSR {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 memen : 1;                     // DWORD 0
               u32 bmen : 1;                      // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 perrsp : 1;                    // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 serren : 1;                    // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 intxdisable : 1;               // DWORD 0
               u32 rsvd4 : 5;                     // DWORD 0
               u32 rsvd5 : 3;                     // DWORD 0
               u32 intstat : 1;                   // DWORD 0
               u32 cap : 1;                       // DWORD 0
               u32 rsvd6 : 1;                     // DWORD 0
               u32 rsvd7 : 1;                     // DWORD 0
               u32 rsvd8 : 1;                     // DWORD 0
               u32 dpderr : 1;                    // DWORD 0
               u32 rsvd9 : 2;                     // DWORD 0
               u32 stabt : 1;                     // DWORD 0
               u32 rtabt : 1;                     // DWORD 0
               u32 rmabt : 1;                     // DWORD 0
               u32 sserr : 1;                     // DWORD 0
               u32 dperr : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_COMMAND_STATUS_CSR, *PPCICFG_COMMAND_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_COMMAND_STATUS_CSR, sizeof (PCICFG_COMMAND_STATUS_CSR) == 4);

   #else
      typedef struct _PCICFG_COMMAND_STATUS_CSR {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 memen : 1;                           // DWORD 0
         u32 bmen : 1;                            // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 perrsp : 1;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 serren : 1;                          // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 intxdisable : 1;                     // DWORD 0
         u32 rsvd4 : 5;                           // DWORD 0
         u32 rsvd5 : 3;                           // DWORD 0
         u32 intstat : 1;                         // DWORD 0
         u32 cap : 1;                             // DWORD 0
         u32 rsvd6 : 1;                           // DWORD 0
         u32 rsvd7 : 1;                           // DWORD 0
         u32 rsvd8 : 1;                           // DWORD 0
         u32 dpderr : 1;                          // DWORD 0
         u32 rsvd9 : 2;                           // DWORD 0
         u32 stabt : 1;                           // DWORD 0
         u32 rtabt : 1;                           // DWORD 0
         u32 rmabt : 1;                           // DWORD 0
         u32 sserr : 1;                           // DWORD 0
         u32 dperr : 1;                           // DWORD 0
      } SG_PACK PCICFG_COMMAND_STATUS_CSR, *PPCICFG_COMMAND_STATUS_CSR;

      typedef union _PCICFG_COMMAND_STATUS_CSR_UNION {
         PCICFG_COMMAND_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_COMMAND_STATUS_CSR_UNION, *PPCICFG_COMMAND_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_COMMAND_STATUS_CSR_UNION, sizeof (PCICFG_COMMAND_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Class Code and Revision ID Register. This register identifies the type of Device.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_CLASS_REV_F0_CSR {
         union {
            struct { 
               u32 baseclass : 8;                 // DWORD 0
               u32 subclass : 8;                  // DWORD 0
               u32 prgintf : 8;                   // DWORD 0
               u32 rev : 8;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_CLASS_REV_F0_CSR, *PPCICFG_CLASS_REV_F0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_CLASS_REV_F0_CSR, sizeof (PCICFG_CLASS_REV_F0_CSR) == 4);

   #else
      typedef struct _PCICFG_CLASS_REV_F0_CSR {
         u32 baseclass : 8;                       // DWORD 0
         u32 subclass : 8;                        // DWORD 0
         u32 prgintf : 8;                         // DWORD 0
         u32 rev : 8;                             // DWORD 0
      } SG_PACK PCICFG_CLASS_REV_F0_CSR, *PPCICFG_CLASS_REV_F0_CSR;

      typedef union _PCICFG_CLASS_REV_F0_CSR_UNION {
         PCICFG_CLASS_REV_F0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_CLASS_REV_F0_CSR_UNION, *PPCICFG_CLASS_REV_F0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_CLASS_REV_F0_CSR_UNION, sizeof (PCICFG_CLASS_REV_F0_CSR_UNION) == 4);
   #endif


#else
   // Class Code and Revision ID Register. This register identifies the type of Device.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_CLASS_REV_F0_CSR {
         union {
            struct { 
               u32 rev : 8;                       // DWORD 0
               u32 prgintf : 8;                   // DWORD 0
               u32 subclass : 8;                  // DWORD 0
               u32 baseclass : 8;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_CLASS_REV_F0_CSR, *PPCICFG_CLASS_REV_F0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_CLASS_REV_F0_CSR, sizeof (PCICFG_CLASS_REV_F0_CSR) == 4);

   #else
      typedef struct _PCICFG_CLASS_REV_F0_CSR {
         u32 rev : 8;                             // DWORD 0
         u32 prgintf : 8;                         // DWORD 0
         u32 subclass : 8;                        // DWORD 0
         u32 baseclass : 8;                       // DWORD 0
      } SG_PACK PCICFG_CLASS_REV_F0_CSR, *PPCICFG_CLASS_REV_F0_CSR;

      typedef union _PCICFG_CLASS_REV_F0_CSR_UNION {
         PCICFG_CLASS_REV_F0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_CLASS_REV_F0_CSR_UNION, *PPCICFG_CLASS_REV_F0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_CLASS_REV_F0_CSR_UNION, sizeof (PCICFG_CLASS_REV_F0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Class Code and Revision ID Register. This register identifies the type of Device.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_CLASS_REV_F1_CSR {
         union {
            struct { 
               u32 baseclass : 8;                 // DWORD 0
               u32 subclass : 8;                  // DWORD 0
               u32 prgintf : 8;                   // DWORD 0
               u32 rev : 8;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_CLASS_REV_F1_CSR, *PPCICFG_CLASS_REV_F1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_CLASS_REV_F1_CSR, sizeof (PCICFG_CLASS_REV_F1_CSR) == 4);

   #else
      typedef struct _PCICFG_CLASS_REV_F1_CSR {
         u32 baseclass : 8;                       // DWORD 0
         u32 subclass : 8;                        // DWORD 0
         u32 prgintf : 8;                         // DWORD 0
         u32 rev : 8;                             // DWORD 0
      } SG_PACK PCICFG_CLASS_REV_F1_CSR, *PPCICFG_CLASS_REV_F1_CSR;

      typedef union _PCICFG_CLASS_REV_F1_CSR_UNION {
         PCICFG_CLASS_REV_F1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_CLASS_REV_F1_CSR_UNION, *PPCICFG_CLASS_REV_F1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_CLASS_REV_F1_CSR_UNION, sizeof (PCICFG_CLASS_REV_F1_CSR_UNION) == 4);
   #endif


#else
   // Class Code and Revision ID Register. This register identifies the type of Device.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_CLASS_REV_F1_CSR {
         union {
            struct { 
               u32 rev : 8;                       // DWORD 0
               u32 prgintf : 8;                   // DWORD 0
               u32 subclass : 8;                  // DWORD 0
               u32 baseclass : 8;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_CLASS_REV_F1_CSR, *PPCICFG_CLASS_REV_F1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_CLASS_REV_F1_CSR, sizeof (PCICFG_CLASS_REV_F1_CSR) == 4);

   #else
      typedef struct _PCICFG_CLASS_REV_F1_CSR {
         u32 rev : 8;                             // DWORD 0
         u32 prgintf : 8;                         // DWORD 0
         u32 subclass : 8;                        // DWORD 0
         u32 baseclass : 8;                       // DWORD 0
      } SG_PACK PCICFG_CLASS_REV_F1_CSR, *PPCICFG_CLASS_REV_F1_CSR;

      typedef union _PCICFG_CLASS_REV_F1_CSR_UNION {
         PCICFG_CLASS_REV_F1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_CLASS_REV_F1_CSR_UNION, *PPCICFG_CLASS_REV_F1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_CLASS_REV_F1_CSR_UNION, sizeof (PCICFG_CLASS_REV_F1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Cache Line Size, Latency, PCI Header Type, and BIST Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_CACHE_TMR_HDR_BIST_CSR {
         union {
            struct { 
               u32 bist : 8;                      // DWORD 0
               u32 header_type : 8;               // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 cache_size : 8;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_CACHE_TMR_HDR_BIST_CSR, *PPCICFG_CACHE_TMR_HDR_BIST_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_CACHE_TMR_HDR_BIST_CSR, sizeof (PCICFG_CACHE_TMR_HDR_BIST_CSR) == 4);

   #else
      typedef struct _PCICFG_CACHE_TMR_HDR_BIST_CSR {
         u32 bist : 8;                            // DWORD 0
         u32 header_type : 8;                     // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 cache_size : 8;                      // DWORD 0
      } SG_PACK PCICFG_CACHE_TMR_HDR_BIST_CSR, *PPCICFG_CACHE_TMR_HDR_BIST_CSR;

      typedef union _PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION {
         PCICFG_CACHE_TMR_HDR_BIST_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION, *PPCICFG_CACHE_TMR_HDR_BIST_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION, sizeof (PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION) == 4);
   #endif


#else
   // Cache Line Size, Latency, PCI Header Type, and BIST Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_CACHE_TMR_HDR_BIST_CSR {
         union {
            struct { 
               u32 cache_size : 8;                // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 header_type : 8;               // DWORD 0
               u32 bist : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_CACHE_TMR_HDR_BIST_CSR, *PPCICFG_CACHE_TMR_HDR_BIST_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_CACHE_TMR_HDR_BIST_CSR, sizeof (PCICFG_CACHE_TMR_HDR_BIST_CSR) == 4);

   #else
      typedef struct _PCICFG_CACHE_TMR_HDR_BIST_CSR {
         u32 cache_size : 8;                      // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 header_type : 8;                     // DWORD 0
         u32 bist : 8;                            // DWORD 0
      } SG_PACK PCICFG_CACHE_TMR_HDR_BIST_CSR, *PPCICFG_CACHE_TMR_HDR_BIST_CSR;

      typedef union _PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION {
         PCICFG_CACHE_TMR_HDR_BIST_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION, *PPCICFG_CACHE_TMR_HDR_BIST_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION, sizeof (PCICFG_CACHE_TMR_HDR_BIST_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IO Bar Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IOBAR_CSR {
         union {
            struct { 
               u32 iobar : 24;                    // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 iospace : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IOBAR_CSR, *PPCICFG_IOBAR_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IOBAR_CSR, sizeof (PCICFG_IOBAR_CSR) == 4);

   #else
      typedef struct _PCICFG_IOBAR_CSR {
         u32 iobar : 24;                          // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 iospace : 1;                         // DWORD 0
      } SG_PACK PCICFG_IOBAR_CSR, *PPCICFG_IOBAR_CSR;

      typedef union _PCICFG_IOBAR_CSR_UNION {
         PCICFG_IOBAR_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IOBAR_CSR_UNION, *PPCICFG_IOBAR_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IOBAR_CSR_UNION, sizeof (PCICFG_IOBAR_CSR_UNION) == 4);
   #endif


#else
   // IO Bar Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IOBAR_CSR {
         union {
            struct { 
               u32 iospace : 1;                   // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 iobar : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IOBAR_CSR, *PPCICFG_IOBAR_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IOBAR_CSR, sizeof (PCICFG_IOBAR_CSR) == 4);

   #else
      typedef struct _PCICFG_IOBAR_CSR {
         u32 iospace : 1;                         // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 iobar : 24;                          // DWORD 0
      } SG_PACK PCICFG_IOBAR_CSR, *PPCICFG_IOBAR_CSR;

      typedef union _PCICFG_IOBAR_CSR_UNION {
         PCICFG_IOBAR_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IOBAR_CSR_UNION, *PPCICFG_IOBAR_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IOBAR_CSR_UNION, sizeof (PCICFG_IOBAR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Memory BAR 0 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR0_CSR {
         union {
            struct { 
               u32 membar0 : 18;                  // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
               u32 pf : 1;                        // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 memspace : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR0_CSR, *PPCICFG_MEMBAR0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR0_CSR, sizeof (PCICFG_MEMBAR0_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR0_CSR {
         u32 membar0 : 18;                        // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 memspace : 1;                        // DWORD 0
      } SG_PACK PCICFG_MEMBAR0_CSR, *PPCICFG_MEMBAR0_CSR;

      typedef union _PCICFG_MEMBAR0_CSR_UNION {
         PCICFG_MEMBAR0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR0_CSR_UNION, *PPCICFG_MEMBAR0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR0_CSR_UNION, sizeof (PCICFG_MEMBAR0_CSR_UNION) == 4);
   #endif


#else
   // Memory BAR 0 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR0_CSR {
         union {
            struct { 
               u32 memspace : 1;                  // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 pf : 1;                        // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
               u32 membar0 : 18;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR0_CSR, *PPCICFG_MEMBAR0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR0_CSR, sizeof (PCICFG_MEMBAR0_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR0_CSR {
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 membar0 : 18;                        // DWORD 0
      } SG_PACK PCICFG_MEMBAR0_CSR, *PPCICFG_MEMBAR0_CSR;

      typedef union _PCICFG_MEMBAR0_CSR_UNION {
         PCICFG_MEMBAR0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR0_CSR_UNION, *PPCICFG_MEMBAR0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR0_CSR_UNION, sizeof (PCICFG_MEMBAR0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Memory BAR 1 - Low Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR1_LO_CSR {
         union {
            struct { 
               u32 membar1lo : 15;                // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
               u32 pf : 1;                        // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 memspace : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR1_LO_CSR, *PPCICFG_MEMBAR1_LO_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR1_LO_CSR, sizeof (PCICFG_MEMBAR1_LO_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR1_LO_CSR {
         u32 membar1lo : 15;                      // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 memspace : 1;                        // DWORD 0
      } SG_PACK PCICFG_MEMBAR1_LO_CSR, *PPCICFG_MEMBAR1_LO_CSR;

      typedef union _PCICFG_MEMBAR1_LO_CSR_UNION {
         PCICFG_MEMBAR1_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR1_LO_CSR_UNION, *PPCICFG_MEMBAR1_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR1_LO_CSR_UNION, sizeof (PCICFG_MEMBAR1_LO_CSR_UNION) == 4);
   #endif


#else
   // Memory BAR 1 - Low Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR1_LO_CSR {
         union {
            struct { 
               u32 memspace : 1;                  // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 pf : 1;                        // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
               u32 membar1lo : 15;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR1_LO_CSR, *PPCICFG_MEMBAR1_LO_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR1_LO_CSR, sizeof (PCICFG_MEMBAR1_LO_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR1_LO_CSR {
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 membar1lo : 15;                      // DWORD 0
      } SG_PACK PCICFG_MEMBAR1_LO_CSR, *PPCICFG_MEMBAR1_LO_CSR;

      typedef union _PCICFG_MEMBAR1_LO_CSR_UNION {
         PCICFG_MEMBAR1_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR1_LO_CSR_UNION, *PPCICFG_MEMBAR1_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR1_LO_CSR_UNION, sizeof (PCICFG_MEMBAR1_LO_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Memory BAR 1 - High Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR1_HI_CSR {
         union {
            struct { 
               u32 membar1hi;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR1_HI_CSR, *PPCICFG_MEMBAR1_HI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR1_HI_CSR, sizeof (PCICFG_MEMBAR1_HI_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR1_HI_CSR {
         u32 membar1hi;                           // DWORD 0
      } SG_PACK PCICFG_MEMBAR1_HI_CSR, *PPCICFG_MEMBAR1_HI_CSR;

      typedef union _PCICFG_MEMBAR1_HI_CSR_UNION {
         PCICFG_MEMBAR1_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR1_HI_CSR_UNION, *PPCICFG_MEMBAR1_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR1_HI_CSR_UNION, sizeof (PCICFG_MEMBAR1_HI_CSR_UNION) == 4);
   #endif


#else
   // Memory BAR 1 - High Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR1_HI_CSR {
         union {
            struct { 
               u32 membar1hi;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR1_HI_CSR, *PPCICFG_MEMBAR1_HI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR1_HI_CSR, sizeof (PCICFG_MEMBAR1_HI_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR1_HI_CSR {
         u32 membar1hi;                           // DWORD 0
      } SG_PACK PCICFG_MEMBAR1_HI_CSR, *PPCICFG_MEMBAR1_HI_CSR;

      typedef union _PCICFG_MEMBAR1_HI_CSR_UNION {
         PCICFG_MEMBAR1_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR1_HI_CSR_UNION, *PPCICFG_MEMBAR1_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR1_HI_CSR_UNION, sizeof (PCICFG_MEMBAR1_HI_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Memory BAR 2 - Low Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR2_LO_F0_CSR {
         union {
            struct { 
               u32 membar2lo : 11;                // DWORD 0
               u32 memsp_pgsize_3 : 1;            // DWORD 0
               u32 memsp_pgsize_2 : 1;            // DWORD 0
               u32 memsp_pgsize_1 : 1;            // DWORD 0
               u32 memsp_pgsize_0 : 1;            // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
               u32 pf : 1;                        // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 memspace : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR2_LO_F0_CSR, *PPCICFG_MEMBAR2_LO_F0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_LO_F0_CSR, sizeof (PCICFG_MEMBAR2_LO_F0_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR2_LO_F0_CSR {
         u32 membar2lo : 11;                      // DWORD 0
         u32 memsp_pgsize_3 : 1;                  // DWORD 0
         u32 memsp_pgsize_2 : 1;                  // DWORD 0
         u32 memsp_pgsize_1 : 1;                  // DWORD 0
         u32 memsp_pgsize_0 : 1;                  // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 memspace : 1;                        // DWORD 0
      } SG_PACK PCICFG_MEMBAR2_LO_F0_CSR, *PPCICFG_MEMBAR2_LO_F0_CSR;

      typedef union _PCICFG_MEMBAR2_LO_F0_CSR_UNION {
         PCICFG_MEMBAR2_LO_F0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR2_LO_F0_CSR_UNION, *PPCICFG_MEMBAR2_LO_F0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_LO_F0_CSR_UNION, sizeof (PCICFG_MEMBAR2_LO_F0_CSR_UNION) == 4);
   #endif


#else
   // Memory BAR 2 - Low Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR2_LO_F0_CSR {
         union {
            struct { 
               u32 memspace : 1;                  // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 pf : 1;                        // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
               u32 memsp_pgsize_0 : 1;            // DWORD 0
               u32 memsp_pgsize_1 : 1;            // DWORD 0
               u32 memsp_pgsize_2 : 1;            // DWORD 0
               u32 memsp_pgsize_3 : 1;            // DWORD 0
               u32 membar2lo : 11;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR2_LO_F0_CSR, *PPCICFG_MEMBAR2_LO_F0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_LO_F0_CSR, sizeof (PCICFG_MEMBAR2_LO_F0_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR2_LO_F0_CSR {
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 memsp_pgsize_0 : 1;                  // DWORD 0
         u32 memsp_pgsize_1 : 1;                  // DWORD 0
         u32 memsp_pgsize_2 : 1;                  // DWORD 0
         u32 memsp_pgsize_3 : 1;                  // DWORD 0
         u32 membar2lo : 11;                      // DWORD 0
      } SG_PACK PCICFG_MEMBAR2_LO_F0_CSR, *PPCICFG_MEMBAR2_LO_F0_CSR;

      typedef union _PCICFG_MEMBAR2_LO_F0_CSR_UNION {
         PCICFG_MEMBAR2_LO_F0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR2_LO_F0_CSR_UNION, *PPCICFG_MEMBAR2_LO_F0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_LO_F0_CSR_UNION, sizeof (PCICFG_MEMBAR2_LO_F0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Memory BAR 2 - Low Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR2_LO_F1_CSR {
         union {
            struct { 
               u32 membar2lo : 6;                 // DWORD 0
               u32 memsp_pgsize_3 : 1;            // DWORD 0
               u32 memsp_pgsize_2 : 1;            // DWORD 0
               u32 memsp_pgsize_1 : 1;            // DWORD 0
               u32 memsp_pgsize_0 : 1;            // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
               u32 pf : 1;                        // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 memspace : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR2_LO_F1_CSR, *PPCICFG_MEMBAR2_LO_F1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_LO_F1_CSR, sizeof (PCICFG_MEMBAR2_LO_F1_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR2_LO_F1_CSR {
         u32 membar2lo : 6;                       // DWORD 0
         u32 memsp_pgsize_3 : 1;                  // DWORD 0
         u32 memsp_pgsize_2 : 1;                  // DWORD 0
         u32 memsp_pgsize_1 : 1;                  // DWORD 0
         u32 memsp_pgsize_0 : 1;                  // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 memspace : 1;                        // DWORD 0
      } SG_PACK PCICFG_MEMBAR2_LO_F1_CSR, *PPCICFG_MEMBAR2_LO_F1_CSR;

      typedef union _PCICFG_MEMBAR2_LO_F1_CSR_UNION {
         PCICFG_MEMBAR2_LO_F1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR2_LO_F1_CSR_UNION, *PPCICFG_MEMBAR2_LO_F1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_LO_F1_CSR_UNION, sizeof (PCICFG_MEMBAR2_LO_F1_CSR_UNION) == 4);
   #endif


#else
   // Memory BAR 2 - Low Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR2_LO_F1_CSR {
         union {
            struct { 
               u32 memspace : 1;                  // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 pf : 1;                        // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
               u32 memsp_pgsize_0 : 1;            // DWORD 0
               u32 memsp_pgsize_1 : 1;            // DWORD 0
               u32 memsp_pgsize_2 : 1;            // DWORD 0
               u32 memsp_pgsize_3 : 1;            // DWORD 0
               u32 membar2lo : 6;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR2_LO_F1_CSR, *PPCICFG_MEMBAR2_LO_F1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_LO_F1_CSR, sizeof (PCICFG_MEMBAR2_LO_F1_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR2_LO_F1_CSR {
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
         u32 memsp_pgsize_0 : 1;                  // DWORD 0
         u32 memsp_pgsize_1 : 1;                  // DWORD 0
         u32 memsp_pgsize_2 : 1;                  // DWORD 0
         u32 memsp_pgsize_3 : 1;                  // DWORD 0
         u32 membar2lo : 6;                       // DWORD 0
      } SG_PACK PCICFG_MEMBAR2_LO_F1_CSR, *PPCICFG_MEMBAR2_LO_F1_CSR;

      typedef union _PCICFG_MEMBAR2_LO_F1_CSR_UNION {
         PCICFG_MEMBAR2_LO_F1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR2_LO_F1_CSR_UNION, *PPCICFG_MEMBAR2_LO_F1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_LO_F1_CSR_UNION, sizeof (PCICFG_MEMBAR2_LO_F1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Memory BAR 2 - High Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR2_HI_CSR {
         union {
            struct { 
               u32 membar2hi;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR2_HI_CSR, *PPCICFG_MEMBAR2_HI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_HI_CSR, sizeof (PCICFG_MEMBAR2_HI_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR2_HI_CSR {
         u32 membar2hi;                           // DWORD 0
      } SG_PACK PCICFG_MEMBAR2_HI_CSR, *PPCICFG_MEMBAR2_HI_CSR;

      typedef union _PCICFG_MEMBAR2_HI_CSR_UNION {
         PCICFG_MEMBAR2_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR2_HI_CSR_UNION, *PPCICFG_MEMBAR2_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_HI_CSR_UNION, sizeof (PCICFG_MEMBAR2_HI_CSR_UNION) == 4);
   #endif


#else
   // Memory BAR 2 - High Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR2_HI_CSR {
         union {
            struct { 
               u32 membar2hi;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR2_HI_CSR, *PPCICFG_MEMBAR2_HI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_HI_CSR, sizeof (PCICFG_MEMBAR2_HI_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR2_HI_CSR {
         u32 membar2hi;                           // DWORD 0
      } SG_PACK PCICFG_MEMBAR2_HI_CSR, *PPCICFG_MEMBAR2_HI_CSR;

      typedef union _PCICFG_MEMBAR2_HI_CSR_UNION {
         PCICFG_MEMBAR2_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR2_HI_CSR_UNION, *PPCICFG_MEMBAR2_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR2_HI_CSR_UNION, sizeof (PCICFG_MEMBAR2_HI_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Subsystem Vendor and ID (Function 0) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_SUBSYSTEM_ID_F0_CSR {
         union {
            struct { 
               u32 subsys_id : 16;                // DWORD 0
               u32 subsys_vendor_id : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_SUBSYSTEM_ID_F0_CSR, *PPCICFG_SUBSYSTEM_ID_F0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_SUBSYSTEM_ID_F0_CSR, sizeof (PCICFG_SUBSYSTEM_ID_F0_CSR) == 4);

   #else
      typedef struct _PCICFG_SUBSYSTEM_ID_F0_CSR {
         u32 subsys_id : 16;                      // DWORD 0
         u32 subsys_vendor_id : 16;               // DWORD 0
      } SG_PACK PCICFG_SUBSYSTEM_ID_F0_CSR, *PPCICFG_SUBSYSTEM_ID_F0_CSR;

      typedef union _PCICFG_SUBSYSTEM_ID_F0_CSR_UNION {
         PCICFG_SUBSYSTEM_ID_F0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_SUBSYSTEM_ID_F0_CSR_UNION, *PPCICFG_SUBSYSTEM_ID_F0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_SUBSYSTEM_ID_F0_CSR_UNION, sizeof (PCICFG_SUBSYSTEM_ID_F0_CSR_UNION) == 4);
   #endif


#else
   // Subsystem Vendor and ID (Function 0) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_SUBSYSTEM_ID_F0_CSR {
         union {
            struct { 
               u32 subsys_vendor_id : 16;         // DWORD 0
               u32 subsys_id : 16;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_SUBSYSTEM_ID_F0_CSR, *PPCICFG_SUBSYSTEM_ID_F0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_SUBSYSTEM_ID_F0_CSR, sizeof (PCICFG_SUBSYSTEM_ID_F0_CSR) == 4);

   #else
      typedef struct _PCICFG_SUBSYSTEM_ID_F0_CSR {
         u32 subsys_vendor_id : 16;               // DWORD 0
         u32 subsys_id : 16;                      // DWORD 0
      } SG_PACK PCICFG_SUBSYSTEM_ID_F0_CSR, *PPCICFG_SUBSYSTEM_ID_F0_CSR;

      typedef union _PCICFG_SUBSYSTEM_ID_F0_CSR_UNION {
         PCICFG_SUBSYSTEM_ID_F0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_SUBSYSTEM_ID_F0_CSR_UNION, *PPCICFG_SUBSYSTEM_ID_F0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_SUBSYSTEM_ID_F0_CSR_UNION, sizeof (PCICFG_SUBSYSTEM_ID_F0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Subsystem Vendor and ID (Function 1) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_SUBSYSTEM_ID_F1_CSR {
         union {
            struct { 
               u32 subsys_id : 16;                // DWORD 0
               u32 subsys_vendor_id : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_SUBSYSTEM_ID_F1_CSR, *PPCICFG_SUBSYSTEM_ID_F1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_SUBSYSTEM_ID_F1_CSR, sizeof (PCICFG_SUBSYSTEM_ID_F1_CSR) == 4);

   #else
      typedef struct _PCICFG_SUBSYSTEM_ID_F1_CSR {
         u32 subsys_id : 16;                      // DWORD 0
         u32 subsys_vendor_id : 16;               // DWORD 0
      } SG_PACK PCICFG_SUBSYSTEM_ID_F1_CSR, *PPCICFG_SUBSYSTEM_ID_F1_CSR;

      typedef union _PCICFG_SUBSYSTEM_ID_F1_CSR_UNION {
         PCICFG_SUBSYSTEM_ID_F1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_SUBSYSTEM_ID_F1_CSR_UNION, *PPCICFG_SUBSYSTEM_ID_F1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_SUBSYSTEM_ID_F1_CSR_UNION, sizeof (PCICFG_SUBSYSTEM_ID_F1_CSR_UNION) == 4);
   #endif


#else
   // Subsystem Vendor and ID (Function 1) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_SUBSYSTEM_ID_F1_CSR {
         union {
            struct { 
               u32 subsys_vendor_id : 16;         // DWORD 0
               u32 subsys_id : 16;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_SUBSYSTEM_ID_F1_CSR, *PPCICFG_SUBSYSTEM_ID_F1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_SUBSYSTEM_ID_F1_CSR, sizeof (PCICFG_SUBSYSTEM_ID_F1_CSR) == 4);

   #else
      typedef struct _PCICFG_SUBSYSTEM_ID_F1_CSR {
         u32 subsys_vendor_id : 16;               // DWORD 0
         u32 subsys_id : 16;                      // DWORD 0
      } SG_PACK PCICFG_SUBSYSTEM_ID_F1_CSR, *PPCICFG_SUBSYSTEM_ID_F1_CSR;

      typedef union _PCICFG_SUBSYSTEM_ID_F1_CSR_UNION {
         PCICFG_SUBSYSTEM_ID_F1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_SUBSYSTEM_ID_F1_CSR_UNION, *PPCICFG_SUBSYSTEM_ID_F1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_SUBSYSTEM_ID_F1_CSR_UNION, sizeof (PCICFG_SUBSYSTEM_ID_F1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Expansion ROM Enable and Base Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_EXP_ROM_CSR {
         union {
            struct { 
               u32 exprombar : 16;                // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 exprombarenable : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_EXP_ROM_CSR, *PPCICFG_EXP_ROM_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_EXP_ROM_CSR, sizeof (PCICFG_EXP_ROM_CSR) == 4);

   #else
      typedef struct _PCICFG_EXP_ROM_CSR {
         u32 exprombar : 16;                      // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 exprombarenable : 1;                 // DWORD 0
      } SG_PACK PCICFG_EXP_ROM_CSR, *PPCICFG_EXP_ROM_CSR;

      typedef union _PCICFG_EXP_ROM_CSR_UNION {
         PCICFG_EXP_ROM_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_EXP_ROM_CSR_UNION, *PPCICFG_EXP_ROM_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_EXP_ROM_CSR_UNION, sizeof (PCICFG_EXP_ROM_CSR_UNION) == 4);
   #endif


#else
   // Expansion ROM Enable and Base Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_EXP_ROM_CSR {
         union {
            struct { 
               u32 exprombarenable : 1;           // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 exprombar : 16;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_EXP_ROM_CSR, *PPCICFG_EXP_ROM_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_EXP_ROM_CSR, sizeof (PCICFG_EXP_ROM_CSR) == 4);

   #else
      typedef struct _PCICFG_EXP_ROM_CSR {
         u32 exprombarenable : 1;                 // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 exprombar : 16;                      // DWORD 0
      } SG_PACK PCICFG_EXP_ROM_CSR, *PPCICFG_EXP_ROM_CSR;

      typedef union _PCICFG_EXP_ROM_CSR_UNION {
         PCICFG_EXP_ROM_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_EXP_ROM_CSR_UNION, *PPCICFG_EXP_ROM_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_EXP_ROM_CSR_UNION, sizeof (PCICFG_EXP_ROM_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Capabilities List Pointer Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_CAP_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 capptr : 8;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_CAP_CSR, *PPCICFG_CAP_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_CAP_CSR, sizeof (PCICFG_CAP_CSR) == 4);

   #else
      typedef struct _PCICFG_CAP_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 capptr : 8;                          // DWORD 0
      } SG_PACK PCICFG_CAP_CSR, *PPCICFG_CAP_CSR;

      typedef union _PCICFG_CAP_CSR_UNION {
         PCICFG_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_CAP_CSR_UNION, *PPCICFG_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_CAP_CSR_UNION, sizeof (PCICFG_CAP_CSR_UNION) == 4);
   #endif


#else
   // Capabilities List Pointer Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_CAP_CSR {
         union {
            struct { 
               u32 capptr : 8;                    // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_CAP_CSR, *PPCICFG_CAP_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_CAP_CSR, sizeof (PCICFG_CAP_CSR) == 4);

   #else
      typedef struct _PCICFG_CAP_CSR {
         u32 capptr : 8;                          // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK PCICFG_CAP_CSR, *PPCICFG_CAP_CSR;

      typedef union _PCICFG_CAP_CSR_UNION {
         PCICFG_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_CAP_CSR_UNION, *PPCICFG_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_CAP_CSR_UNION, sizeof (PCICFG_CAP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Maximum Latency, Minimum Grant, and Interrupt Pins Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_LATENCY_INT_F0_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 int_pin : 8;                   // DWORD 0
               u32 int_line : 8;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_LATENCY_INT_F0_CSR, *PPCICFG_LATENCY_INT_F0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_LATENCY_INT_F0_CSR, sizeof (PCICFG_LATENCY_INT_F0_CSR) == 4);

   #else
      typedef struct _PCICFG_LATENCY_INT_F0_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 int_pin : 8;                         // DWORD 0
         u32 int_line : 8;                        // DWORD 0
      } SG_PACK PCICFG_LATENCY_INT_F0_CSR, *PPCICFG_LATENCY_INT_F0_CSR;

      typedef union _PCICFG_LATENCY_INT_F0_CSR_UNION {
         PCICFG_LATENCY_INT_F0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_LATENCY_INT_F0_CSR_UNION, *PPCICFG_LATENCY_INT_F0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_LATENCY_INT_F0_CSR_UNION, sizeof (PCICFG_LATENCY_INT_F0_CSR_UNION) == 4);
   #endif


#else
   // Maximum Latency, Minimum Grant, and Interrupt Pins Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_LATENCY_INT_F0_CSR {
         union {
            struct { 
               u32 int_line : 8;                  // DWORD 0
               u32 int_pin : 8;                   // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_LATENCY_INT_F0_CSR, *PPCICFG_LATENCY_INT_F0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_LATENCY_INT_F0_CSR, sizeof (PCICFG_LATENCY_INT_F0_CSR) == 4);

   #else
      typedef struct _PCICFG_LATENCY_INT_F0_CSR {
         u32 int_line : 8;                        // DWORD 0
         u32 int_pin : 8;                         // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK PCICFG_LATENCY_INT_F0_CSR, *PPCICFG_LATENCY_INT_F0_CSR;

      typedef union _PCICFG_LATENCY_INT_F0_CSR_UNION {
         PCICFG_LATENCY_INT_F0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_LATENCY_INT_F0_CSR_UNION, *PPCICFG_LATENCY_INT_F0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_LATENCY_INT_F0_CSR_UNION, sizeof (PCICFG_LATENCY_INT_F0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Maximum Latency, Minimum Grant, and Interrupt Pins Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_LATENCY_INT_F1_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 int_pin : 8;                   // DWORD 0
               u32 int_line : 8;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_LATENCY_INT_F1_CSR, *PPCICFG_LATENCY_INT_F1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_LATENCY_INT_F1_CSR, sizeof (PCICFG_LATENCY_INT_F1_CSR) == 4);

   #else
      typedef struct _PCICFG_LATENCY_INT_F1_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 int_pin : 8;                         // DWORD 0
         u32 int_line : 8;                        // DWORD 0
      } SG_PACK PCICFG_LATENCY_INT_F1_CSR, *PPCICFG_LATENCY_INT_F1_CSR;

      typedef union _PCICFG_LATENCY_INT_F1_CSR_UNION {
         PCICFG_LATENCY_INT_F1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_LATENCY_INT_F1_CSR_UNION, *PPCICFG_LATENCY_INT_F1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_LATENCY_INT_F1_CSR_UNION, sizeof (PCICFG_LATENCY_INT_F1_CSR_UNION) == 4);
   #endif


#else
   // Maximum Latency, Minimum Grant, and Interrupt Pins Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_LATENCY_INT_F1_CSR {
         union {
            struct { 
               u32 int_line : 8;                  // DWORD 0
               u32 int_pin : 8;                   // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_LATENCY_INT_F1_CSR, *PPCICFG_LATENCY_INT_F1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_LATENCY_INT_F1_CSR, sizeof (PCICFG_LATENCY_INT_F1_CSR) == 4);

   #else
      typedef struct _PCICFG_LATENCY_INT_F1_CSR {
         u32 int_line : 8;                        // DWORD 0
         u32 int_pin : 8;                         // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK PCICFG_LATENCY_INT_F1_CSR, *PPCICFG_LATENCY_INT_F1_CSR;

      typedef union _PCICFG_LATENCY_INT_F1_CSR_UNION {
         PCICFG_LATENCY_INT_F1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_LATENCY_INT_F1_CSR_UNION, *PPCICFG_LATENCY_INT_F1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_LATENCY_INT_F1_CSR_UNION, sizeof (PCICFG_LATENCY_INT_F1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Semaphore Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_SEMAPHORE_CSR {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 locked : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_SEMAPHORE_CSR, *PPCICFG_SEMAPHORE_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_SEMAPHORE_CSR, sizeof (PCICFG_SEMAPHORE_CSR) == 4);

   #else
      typedef struct _PCICFG_SEMAPHORE_CSR {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 locked : 1;                          // DWORD 0
      } SG_PACK PCICFG_SEMAPHORE_CSR, *PPCICFG_SEMAPHORE_CSR;

      typedef union _PCICFG_SEMAPHORE_CSR_UNION {
         PCICFG_SEMAPHORE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_SEMAPHORE_CSR_UNION, *PPCICFG_SEMAPHORE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_SEMAPHORE_CSR_UNION, sizeof (PCICFG_SEMAPHORE_CSR_UNION) == 4);
   #endif


#else
   // Semaphore Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_SEMAPHORE_CSR {
         union {
            struct { 
               u32 locked : 1;                    // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_SEMAPHORE_CSR, *PPCICFG_SEMAPHORE_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_SEMAPHORE_CSR, sizeof (PCICFG_SEMAPHORE_CSR) == 4);

   #else
      typedef struct _PCICFG_SEMAPHORE_CSR {
         u32 locked : 1;                          // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK PCICFG_SEMAPHORE_CSR, *PPCICFG_SEMAPHORE_CSR;

      typedef union _PCICFG_SEMAPHORE_CSR_UNION {
         PCICFG_SEMAPHORE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_SEMAPHORE_CSR_UNION, *PPCICFG_SEMAPHORE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_SEMAPHORE_CSR_UNION, sizeof (PCICFG_SEMAPHORE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Soft Reset Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_SOFT_RESET_CSR {
         union {
            struct { 
               u32 nec_ll_rcvdetect : 8;          // DWORD 0
               u32 dbg_all_reqs_62_49 : 14;       // DWORD 0
               u32 PCIe_TOP_RST_RSM_B_for_wake_sel : 1; // DWORD 0
               u32 exception_oe : 1;              // DWORD 0
               u32 softreset : 1;                 // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_SOFT_RESET_CSR, *PPCICFG_SOFT_RESET_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_SOFT_RESET_CSR, sizeof (PCICFG_SOFT_RESET_CSR) == 4);

   #else
      typedef struct _PCICFG_SOFT_RESET_CSR {
         u32 nec_ll_rcvdetect : 8;                // DWORD 0
         u32 dbg_all_reqs_62_49 : 14;             // DWORD 0
         u32 PCIe_TOP_RST_RSM_B_for_wake_sel : 1; // DWORD 0
         u32 exception_oe : 1;                    // DWORD 0
         u32 softreset : 1;                       // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
      } SG_PACK PCICFG_SOFT_RESET_CSR, *PPCICFG_SOFT_RESET_CSR;

      typedef union _PCICFG_SOFT_RESET_CSR_UNION {
         PCICFG_SOFT_RESET_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_SOFT_RESET_CSR_UNION, *PPCICFG_SOFT_RESET_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_SOFT_RESET_CSR_UNION, sizeof (PCICFG_SOFT_RESET_CSR_UNION) == 4);
   #endif


#else
   // Soft Reset Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_SOFT_RESET_CSR {
         union {
            struct { 
               u32 rsvd0 : 7;                     // DWORD 0
               u32 softreset : 1;                 // DWORD 0
               u32 exception_oe : 1;              // DWORD 0
               u32 PCIe_TOP_RST_RSM_B_for_wake_sel : 1; // DWORD 0
               u32 dbg_all_reqs_62_49 : 14;       // DWORD 0
               u32 nec_ll_rcvdetect : 8;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_SOFT_RESET_CSR, *PPCICFG_SOFT_RESET_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_SOFT_RESET_CSR, sizeof (PCICFG_SOFT_RESET_CSR) == 4);

   #else
      typedef struct _PCICFG_SOFT_RESET_CSR {
         u32 rsvd0 : 7;                           // DWORD 0
         u32 softreset : 1;                       // DWORD 0
         u32 exception_oe : 1;                    // DWORD 0
         u32 PCIe_TOP_RST_RSM_B_for_wake_sel : 1; // DWORD 0
         u32 dbg_all_reqs_62_49 : 14;             // DWORD 0
         u32 nec_ll_rcvdetect : 8;                // DWORD 0
      } SG_PACK PCICFG_SOFT_RESET_CSR, *PPCICFG_SOFT_RESET_CSR;

      typedef union _PCICFG_SOFT_RESET_CSR_UNION {
         PCICFG_SOFT_RESET_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_SOFT_RESET_CSR_UNION, *PPCICFG_SOFT_RESET_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_SOFT_RESET_CSR_UNION, sizeof (PCICFG_SOFT_RESET_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_DEBUG_CSR {
         union {
            struct { 
               u32 debugout : 1;                  // DWORD 0
               u32 debugin : 1;                   // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
               u32 debugchain : 4;                // DWORD 0
               u32 debugblock : 8;                // DWORD 0
               u32 debugselect : 8;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_DEBUG_CSR, *PPCICFG_DEBUG_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_DEBUG_CSR, sizeof (PCICFG_DEBUG_CSR) == 4);

   #else
      typedef struct _PCICFG_DEBUG_CSR {
         u32 debugout : 1;                        // DWORD 0
         u32 debugin : 1;                         // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 debugchain : 4;                      // DWORD 0
         u32 debugblock : 8;                      // DWORD 0
         u32 debugselect : 8;                     // DWORD 0
      } SG_PACK PCICFG_DEBUG_CSR, *PPCICFG_DEBUG_CSR;

      typedef union _PCICFG_DEBUG_CSR_UNION {
         PCICFG_DEBUG_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_DEBUG_CSR_UNION, *PPCICFG_DEBUG_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_DEBUG_CSR_UNION, sizeof (PCICFG_DEBUG_CSR_UNION) == 4);
   #endif


#else
   // Debug Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_DEBUG_CSR {
         union {
            struct { 
               u32 debugselect : 8;               // DWORD 0
               u32 debugblock : 8;                // DWORD 0
               u32 debugchain : 4;                // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
               u32 debugin : 1;                   // DWORD 0
               u32 debugout : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_DEBUG_CSR, *PPCICFG_DEBUG_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_DEBUG_CSR, sizeof (PCICFG_DEBUG_CSR) == 4);

   #else
      typedef struct _PCICFG_DEBUG_CSR {
         u32 debugselect : 8;                     // DWORD 0
         u32 debugblock : 8;                      // DWORD 0
         u32 debugchain : 4;                      // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 debugin : 1;                         // DWORD 0
         u32 debugout : 1;                        // DWORD 0
      } SG_PACK PCICFG_DEBUG_CSR, *PPCICFG_DEBUG_CSR;

      typedef union _PCICFG_DEBUG_CSR_UNION {
         PCICFG_DEBUG_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_DEBUG_CSR_UNION, *PPCICFG_DEBUG_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_DEBUG_CSR_UNION, sizeof (PCICFG_DEBUG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Memory BAR Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR_CTRL_INT_CTRL_CSR {
         union {
            struct { 
               u32 winselect : 2;                 // DWORD 0
               u32 hostintr : 1;                  // DWORD 0
               u32 PFNUM : 3;                     // DWORD 0
               u32 vf_cev_int_line_en : 1;        // DWORD 0
               u32 winaddr : 23;                  // DWORD 0
               u32 membarwinen : 1;               // DWORD 0
               u32 winmode : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR_CTRL_INT_CTRL_CSR, *PPCICFG_MEMBAR_CTRL_INT_CTRL_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR_CTRL_INT_CTRL_CSR, sizeof (PCICFG_MEMBAR_CTRL_INT_CTRL_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR_CTRL_INT_CTRL_CSR {
         u32 winselect : 2;                       // DWORD 0
         u32 hostintr : 1;                        // DWORD 0
         u32 PFNUM : 3;                           // DWORD 0
         u32 vf_cev_int_line_en : 1;              // DWORD 0
         u32 winaddr : 23;                        // DWORD 0
         u32 membarwinen : 1;                     // DWORD 0
         u32 winmode : 1;                         // DWORD 0
      } SG_PACK PCICFG_MEMBAR_CTRL_INT_CTRL_CSR, *PPCICFG_MEMBAR_CTRL_INT_CTRL_CSR;

      typedef union _PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_UNION {
         PCICFG_MEMBAR_CTRL_INT_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_UNION, *PPCICFG_MEMBAR_CTRL_INT_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_UNION, sizeof (PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_UNION) == 4);
   #endif


#else
   // Memory BAR Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MEMBAR_CTRL_INT_CTRL_CSR {
         union {
            struct { 
               u32 winmode : 1;                   // DWORD 0
               u32 membarwinen : 1;               // DWORD 0
               u32 winaddr : 23;                  // DWORD 0
               u32 vf_cev_int_line_en : 1;        // DWORD 0
               u32 PFNUM : 3;                     // DWORD 0
               u32 hostintr : 1;                  // DWORD 0
               u32 winselect : 2;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MEMBAR_CTRL_INT_CTRL_CSR, *PPCICFG_MEMBAR_CTRL_INT_CTRL_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR_CTRL_INT_CTRL_CSR, sizeof (PCICFG_MEMBAR_CTRL_INT_CTRL_CSR) == 4);

   #else
      typedef struct _PCICFG_MEMBAR_CTRL_INT_CTRL_CSR {
         u32 winmode : 1;                         // DWORD 0
         u32 membarwinen : 1;                     // DWORD 0
         u32 winaddr : 23;                        // DWORD 0
         u32 vf_cev_int_line_en : 1;              // DWORD 0
         u32 PFNUM : 3;                           // DWORD 0
         u32 hostintr : 1;                        // DWORD 0
         u32 winselect : 2;                       // DWORD 0
      } SG_PACK PCICFG_MEMBAR_CTRL_INT_CTRL_CSR, *PPCICFG_MEMBAR_CTRL_INT_CTRL_CSR;

      typedef union _PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_UNION {
         PCICFG_MEMBAR_CTRL_INT_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_UNION, *PPCICFG_MEMBAR_CTRL_INT_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_UNION, sizeof (PCICFG_MEMBAR_CTRL_INT_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // General Purpose Input Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_GPI_CSR {
         union {
            struct { 
               u32 gpi;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_GPI_CSR, *PPCICFG_GPI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_GPI_CSR, sizeof (PCICFG_GPI_CSR) == 4);

   #else
      typedef struct _PCICFG_GPI_CSR {
         u32 gpi;                                 // DWORD 0
      } SG_PACK PCICFG_GPI_CSR, *PPCICFG_GPI_CSR;

      typedef union _PCICFG_GPI_CSR_UNION {
         PCICFG_GPI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_GPI_CSR_UNION, *PPCICFG_GPI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_GPI_CSR_UNION, sizeof (PCICFG_GPI_CSR_UNION) == 4);
   #endif


#else
   // General Purpose Input Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_GPI_CSR {
         union {
            struct { 
               u32 gpi;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_GPI_CSR, *PPCICFG_GPI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_GPI_CSR, sizeof (PCICFG_GPI_CSR) == 4);

   #else
      typedef struct _PCICFG_GPI_CSR {
         u32 gpi;                                 // DWORD 0
      } SG_PACK PCICFG_GPI_CSR, *PPCICFG_GPI_CSR;

      typedef union _PCICFG_GPI_CSR_UNION {
         PCICFG_GPI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_GPI_CSR_UNION, *PPCICFG_GPI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_GPI_CSR_UNION, sizeof (PCICFG_GPI_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // General Purpose Output Register (Low).
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_GPO_LOW_CSR {
         union {
            struct { 
               u32 gpo;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_GPO_LOW_CSR, *PPCICFG_GPO_LOW_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_GPO_LOW_CSR, sizeof (PCICFG_GPO_LOW_CSR) == 4);

   #else
      typedef struct _PCICFG_GPO_LOW_CSR {
         u32 gpo;                                 // DWORD 0
      } SG_PACK PCICFG_GPO_LOW_CSR, *PPCICFG_GPO_LOW_CSR;

      typedef union _PCICFG_GPO_LOW_CSR_UNION {
         PCICFG_GPO_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_GPO_LOW_CSR_UNION, *PPCICFG_GPO_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_GPO_LOW_CSR_UNION, sizeof (PCICFG_GPO_LOW_CSR_UNION) == 4);
   #endif


#else
   // General Purpose Output Register (Low).
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_GPO_LOW_CSR {
         union {
            struct { 
               u32 gpo;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_GPO_LOW_CSR, *PPCICFG_GPO_LOW_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_GPO_LOW_CSR, sizeof (PCICFG_GPO_LOW_CSR) == 4);

   #else
      typedef struct _PCICFG_GPO_LOW_CSR {
         u32 gpo;                                 // DWORD 0
      } SG_PACK PCICFG_GPO_LOW_CSR, *PPCICFG_GPO_LOW_CSR;

      typedef union _PCICFG_GPO_LOW_CSR_UNION {
         PCICFG_GPO_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_GPO_LOW_CSR_UNION, *PPCICFG_GPO_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_GPO_LOW_CSR_UNION, sizeof (PCICFG_GPO_LOW_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // General Purpose Output Register (High).
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_GPO_HI_CSR {
         union {
            struct { 
               u32 gpo;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_GPO_HI_CSR, *PPCICFG_GPO_HI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_GPO_HI_CSR, sizeof (PCICFG_GPO_HI_CSR) == 4);

   #else
      typedef struct _PCICFG_GPO_HI_CSR {
         u32 gpo;                                 // DWORD 0
      } SG_PACK PCICFG_GPO_HI_CSR, *PPCICFG_GPO_HI_CSR;

      typedef union _PCICFG_GPO_HI_CSR_UNION {
         PCICFG_GPO_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_GPO_HI_CSR_UNION, *PPCICFG_GPO_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_GPO_HI_CSR_UNION, sizeof (PCICFG_GPO_HI_CSR_UNION) == 4);
   #endif


#else
   // General Purpose Output Register (High).
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_GPO_HI_CSR {
         union {
            struct { 
               u32 gpo;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_GPO_HI_CSR, *PPCICFG_GPO_HI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_GPO_HI_CSR, sizeof (PCICFG_GPO_HI_CSR) == 4);

   #else
      typedef struct _PCICFG_GPO_HI_CSR {
         u32 gpo;                                 // DWORD 0
      } SG_PACK PCICFG_GPO_HI_CSR, *PPCICFG_GPO_HI_CSR;

      typedef union _PCICFG_GPO_HI_CSR_UNION {
         PCICFG_GPO_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_GPO_HI_CSR_UNION, *PPCICFG_GPO_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_GPO_HI_CSR_UNION, sizeof (PCICFG_GPO_HI_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // General Purpose Input Output Register Map.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_GPIOMAP_CSR {
         union {
            struct { 
               u32 gpomap;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_GPIOMAP_CSR, *PPCICFG_GPIOMAP_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_GPIOMAP_CSR, sizeof (PCICFG_GPIOMAP_CSR) == 4);

   #else
      typedef struct _PCICFG_GPIOMAP_CSR {
         u32 gpomap;                              // DWORD 0
      } SG_PACK PCICFG_GPIOMAP_CSR, *PPCICFG_GPIOMAP_CSR;

      typedef union _PCICFG_GPIOMAP_CSR_UNION {
         PCICFG_GPIOMAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_GPIOMAP_CSR_UNION, *PPCICFG_GPIOMAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_GPIOMAP_CSR_UNION, sizeof (PCICFG_GPIOMAP_CSR_UNION) == 4);
   #endif


#else
   // General Purpose Input Output Register Map.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_GPIOMAP_CSR {
         union {
            struct { 
               u32 gpomap;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_GPIOMAP_CSR, *PPCICFG_GPIOMAP_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_GPIOMAP_CSR, sizeof (PCICFG_GPIOMAP_CSR) == 4);

   #else
      typedef struct _PCICFG_GPIOMAP_CSR {
         u32 gpomap;                              // DWORD 0
      } SG_PACK PCICFG_GPIOMAP_CSR, *PPCICFG_GPIOMAP_CSR;

      typedef union _PCICFG_GPIOMAP_CSR_UNION {
         PCICFG_GPIOMAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_GPIOMAP_CSR_UNION, *PPCICFG_GPIOMAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_GPIOMAP_CSR_UNION, sizeof (PCICFG_GPIOMAP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // General Purpose Input Output Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIECFG_BE_EXCEPTION_CTRL_CSR {
         union {
            struct { 
               u32 host_dbg_mux_data_core_46_16 : 31; // DWORD 0
               u32 exception_oe : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIECFG_BE_EXCEPTION_CTRL_CSR, *PPCIECFG_BE_EXCEPTION_CTRL_CSR;

      SG_C_ASSERT(__sizeof__PCIECFG_BE_EXCEPTION_CTRL_CSR, sizeof (PCIECFG_BE_EXCEPTION_CTRL_CSR) == 4);

   #else
      typedef struct _PCIECFG_BE_EXCEPTION_CTRL_CSR {
         u32 host_dbg_mux_data_core_46_16 : 31;   // DWORD 0
         u32 exception_oe : 1;                    // DWORD 0
      } SG_PACK PCIECFG_BE_EXCEPTION_CTRL_CSR, *PPCIECFG_BE_EXCEPTION_CTRL_CSR;

      typedef union _PCIECFG_BE_EXCEPTION_CTRL_CSR_UNION {
         PCIECFG_BE_EXCEPTION_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCIECFG_BE_EXCEPTION_CTRL_CSR_UNION, *PPCIECFG_BE_EXCEPTION_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCIECFG_BE_EXCEPTION_CTRL_CSR_UNION, sizeof (PCIECFG_BE_EXCEPTION_CTRL_CSR_UNION) == 4);
   #endif


#else
   // General Purpose Input Output Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIECFG_BE_EXCEPTION_CTRL_CSR {
         union {
            struct { 
               u32 exception_oe : 1;              // DWORD 0
               u32 host_dbg_mux_data_core_46_16 : 31; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIECFG_BE_EXCEPTION_CTRL_CSR, *PPCIECFG_BE_EXCEPTION_CTRL_CSR;

      SG_C_ASSERT(__sizeof__PCIECFG_BE_EXCEPTION_CTRL_CSR, sizeof (PCIECFG_BE_EXCEPTION_CTRL_CSR) == 4);

   #else
      typedef struct _PCIECFG_BE_EXCEPTION_CTRL_CSR {
         u32 exception_oe : 1;                    // DWORD 0
         u32 host_dbg_mux_data_core_46_16 : 31;   // DWORD 0
      } SG_PACK PCIECFG_BE_EXCEPTION_CTRL_CSR, *PPCIECFG_BE_EXCEPTION_CTRL_CSR;

      typedef union _PCIECFG_BE_EXCEPTION_CTRL_CSR_UNION {
         PCIECFG_BE_EXCEPTION_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCIECFG_BE_EXCEPTION_CTRL_CSR_UNION, *PPCIECFG_BE_EXCEPTION_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCIECFG_BE_EXCEPTION_CTRL_CSR_UNION, sizeof (PCIECFG_BE_EXCEPTION_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HOST_INT_STATUS_CSR {
         union {
            struct { 
               u32 rsvd2 : 16;                    // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 LTSSM_L0_state_change_intr : 1; // DWORD 0
               u32 aspm_change_intr : 1;          // DWORD 0
               u32 link_error_max_intr : 1;       // DWORD 0
               u32 msixtbl_perr_intr : 1;         // DWORD 0
               u32 ats_en_change_intr : 1;        // DWORD 0
               u32 FLR_intr : 1;                  // DWORD 0
               u32 pwrstate_change_intr : 1;      // DWORD 0
               u32 gpiintr : 1;                   // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 softrst : 1;                   // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 tmr : 1;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HOST_INT_STATUS_CSR, *PPCICFG_HOST_INT_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_STATUS_CSR, sizeof (PCICFG_HOST_INT_STATUS_CSR) == 4);

   #else
      typedef struct _PCICFG_HOST_INT_STATUS_CSR {
         u32 rsvd2 : 16;                          // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 LTSSM_L0_state_change_intr : 1;      // DWORD 0
         u32 aspm_change_intr : 1;                // DWORD 0
         u32 link_error_max_intr : 1;             // DWORD 0
         u32 msixtbl_perr_intr : 1;               // DWORD 0
         u32 ats_en_change_intr : 1;              // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 pwrstate_change_intr : 1;            // DWORD 0
         u32 gpiintr : 1;                         // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 softrst : 1;                         // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 tmr : 1;                             // DWORD 0
      } SG_PACK PCICFG_HOST_INT_STATUS_CSR, *PPCICFG_HOST_INT_STATUS_CSR;

      typedef union _PCICFG_HOST_INT_STATUS_CSR_UNION {
         PCICFG_HOST_INT_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HOST_INT_STATUS_CSR_UNION, *PPCICFG_HOST_INT_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_STATUS_CSR_UNION, sizeof (PCICFG_HOST_INT_STATUS_CSR_UNION) == 4);
   #endif


#else
   // Host Interrupt Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HOST_INT_STATUS_CSR {
         union {
            struct { 
               u32 tmr : 1;                       // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 softrst : 1;                   // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 gpiintr : 1;                   // DWORD 0
               u32 pwrstate_change_intr : 1;      // DWORD 0
               u32 FLR_intr : 1;                  // DWORD 0
               u32 ats_en_change_intr : 1;        // DWORD 0
               u32 msixtbl_perr_intr : 1;         // DWORD 0
               u32 link_error_max_intr : 1;       // DWORD 0
               u32 aspm_change_intr : 1;          // DWORD 0
               u32 LTSSM_L0_state_change_intr : 1; // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 rsvd2 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HOST_INT_STATUS_CSR, *PPCICFG_HOST_INT_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_STATUS_CSR, sizeof (PCICFG_HOST_INT_STATUS_CSR) == 4);

   #else
      typedef struct _PCICFG_HOST_INT_STATUS_CSR {
         u32 tmr : 1;                             // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 softrst : 1;                         // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 gpiintr : 1;                         // DWORD 0
         u32 pwrstate_change_intr : 1;            // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 ats_en_change_intr : 1;              // DWORD 0
         u32 msixtbl_perr_intr : 1;               // DWORD 0
         u32 link_error_max_intr : 1;             // DWORD 0
         u32 aspm_change_intr : 1;                // DWORD 0
         u32 LTSSM_L0_state_change_intr : 1;      // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 rsvd2 : 16;                          // DWORD 0
      } SG_PACK PCICFG_HOST_INT_STATUS_CSR, *PPCICFG_HOST_INT_STATUS_CSR;

      typedef union _PCICFG_HOST_INT_STATUS_CSR_UNION {
         PCICFG_HOST_INT_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HOST_INT_STATUS_CSR_UNION, *PPCICFG_HOST_INT_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_STATUS_CSR_UNION, sizeof (PCICFG_HOST_INT_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host Interrupt Mask Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HOST_INT_MASK_CSR {
         union {
            struct { 
               u32 rsvd1 : 19;                    // DWORD 0
               u32 LTSSM_L0_state_change : 1;     // DWORD 0
               u32 aspm_change : 1;               // DWORD 0
               u32 link_error_max : 1;            // DWORD 0
               u32 msixtbl_perr : 1;              // DWORD 0
               u32 ats_en_change : 1;             // DWORD 0
               u32 FLR_intr : 1;                  // DWORD 0
               u32 pwrstate_change : 1;           // DWORD 0
               u32 gpiintr : 1;                   // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 softrst : 1;                   // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 tmr : 1;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HOST_INT_MASK_CSR, *PPCICFG_HOST_INT_MASK_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_MASK_CSR, sizeof (PCICFG_HOST_INT_MASK_CSR) == 4);

   #else
      typedef struct _PCICFG_HOST_INT_MASK_CSR {
         u32 rsvd1 : 19;                          // DWORD 0
         u32 LTSSM_L0_state_change : 1;           // DWORD 0
         u32 aspm_change : 1;                     // DWORD 0
         u32 link_error_max : 1;                  // DWORD 0
         u32 msixtbl_perr : 1;                    // DWORD 0
         u32 ats_en_change : 1;                   // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 pwrstate_change : 1;                 // DWORD 0
         u32 gpiintr : 1;                         // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 softrst : 1;                         // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 tmr : 1;                             // DWORD 0
      } SG_PACK PCICFG_HOST_INT_MASK_CSR, *PPCICFG_HOST_INT_MASK_CSR;

      typedef union _PCICFG_HOST_INT_MASK_CSR_UNION {
         PCICFG_HOST_INT_MASK_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HOST_INT_MASK_CSR_UNION, *PPCICFG_HOST_INT_MASK_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_MASK_CSR_UNION, sizeof (PCICFG_HOST_INT_MASK_CSR_UNION) == 4);
   #endif


#else
   // Host Interrupt Mask Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HOST_INT_MASK_CSR {
         union {
            struct { 
               u32 tmr : 1;                       // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 softrst : 1;                   // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 gpiintr : 1;                   // DWORD 0
               u32 pwrstate_change : 1;           // DWORD 0
               u32 FLR_intr : 1;                  // DWORD 0
               u32 ats_en_change : 1;             // DWORD 0
               u32 msixtbl_perr : 1;              // DWORD 0
               u32 link_error_max : 1;            // DWORD 0
               u32 aspm_change : 1;               // DWORD 0
               u32 LTSSM_L0_state_change : 1;     // DWORD 0
               u32 rsvd1 : 19;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HOST_INT_MASK_CSR, *PPCICFG_HOST_INT_MASK_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_MASK_CSR, sizeof (PCICFG_HOST_INT_MASK_CSR) == 4);

   #else
      typedef struct _PCICFG_HOST_INT_MASK_CSR {
         u32 tmr : 1;                             // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 softrst : 1;                         // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 gpiintr : 1;                         // DWORD 0
         u32 pwrstate_change : 1;                 // DWORD 0
         u32 FLR_intr : 1;                        // DWORD 0
         u32 ats_en_change : 1;                   // DWORD 0
         u32 msixtbl_perr : 1;                    // DWORD 0
         u32 link_error_max : 1;                  // DWORD 0
         u32 aspm_change : 1;                     // DWORD 0
         u32 LTSSM_L0_state_change : 1;           // DWORD 0
         u32 rsvd1 : 19;                          // DWORD 0
      } SG_PACK PCICFG_HOST_INT_MASK_CSR, *PPCICFG_HOST_INT_MASK_CSR;

      typedef union _PCICFG_HOST_INT_MASK_CSR_UNION {
         PCICFG_HOST_INT_MASK_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HOST_INT_MASK_CSR_UNION, *PPCICFG_HOST_INT_MASK_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_INT_MASK_CSR_UNION, sizeof (PCICFG_HOST_INT_MASK_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unrecoverable Error Status (Low) Register. Each bit corresponds to an internal
   // Unrecoverable Error. These are set by hardware and may be cleared by writing a one
   // to the respective bit(s) to be cleared. Any bit being set that is also unmasked will
   // result in Unrecoverable Error interrupt notification to the host CPU and/or Server
   // Management chip; and the transitioning of BladeEngine to an Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_UE_STATUS_LOW_CSR {
         union {
            struct { 
               u32 mpu_intpend_ue_status : 1;     // DWORD 0
               u32 jtag_ue_status : 1;            // DWORD 0
               u32 axgmac1_ue_status : 1;         // DWORD 0
               u32 axgmac0_ue_status : 1;         // DWORD 0
               u32 mbox_ue_status : 1;            // DWORD 0
               u32 host_gpio_ue_status : 1;       // DWORD 0
               u32 p1_ob_link_ue_status : 1;      // DWORD 0
               u32 p0_ob_link_ue_status : 1;      // DWORD 0
               u32 host1_ue_status : 1;           // DWORD 0
               u32 txulp2_ue_status : 1;          // DWORD 0
               u32 wdma_ue_status : 1;            // DWORD 0
               u32 uc_ue_status : 1;              // DWORD 0
               u32 txulp1_ue_status : 1;          // DWORD 0
               u32 txulp0_ue_status : 1;          // DWORD 0
               u32 txips_ue_status : 1;           // DWORD 0
               u32 tpre_ue_status : 1;            // DWORD 0
               u32 tpost_ue_status : 1;           // DWORD 0
               u32 tim_ue_status : 1;             // DWORD 0
               u32 rxulp2_ue_status : 1;          // DWORD 0
               u32 rxulp1_ue_status : 1;          // DWORD 0
               u32 rxulp0_ue_status : 1;          // DWORD 0
               u32 rxips_ue_status : 1;           // DWORD 0
               u32 rxf_ue_status : 1;             // DWORD 0
               u32 rdma_ue_status : 1;            // DWORD 0
               u32 ptc_ue_status : 1;             // DWORD 0
               u32 ndma_ue_status : 1;            // DWORD 0
               u32 mpu_ue_status : 1;             // DWORD 0
               u32 host_ue_status : 1;            // DWORD 0
               u32 erx_ue_status : 1;             // DWORD 0
               u32 dbuf_ue_status : 1;            // DWORD 0
               u32 ctx_ue_status : 1;             // DWORD 0
               u32 cev_ue_status : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_UE_STATUS_LOW_CSR, *PPCICFG_UE_STATUS_LOW_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_LOW_CSR, sizeof (PCICFG_UE_STATUS_LOW_CSR) == 4);

   #else
      typedef struct _PCICFG_UE_STATUS_LOW_CSR {
         u32 mpu_intpend_ue_status : 1;           // DWORD 0
         u32 jtag_ue_status : 1;                  // DWORD 0
         u32 axgmac1_ue_status : 1;               // DWORD 0
         u32 axgmac0_ue_status : 1;               // DWORD 0
         u32 mbox_ue_status : 1;                  // DWORD 0
         u32 host_gpio_ue_status : 1;             // DWORD 0
         u32 p1_ob_link_ue_status : 1;            // DWORD 0
         u32 p0_ob_link_ue_status : 1;            // DWORD 0
         u32 host1_ue_status : 1;                 // DWORD 0
         u32 txulp2_ue_status : 1;                // DWORD 0
         u32 wdma_ue_status : 1;                  // DWORD 0
         u32 uc_ue_status : 1;                    // DWORD 0
         u32 txulp1_ue_status : 1;                // DWORD 0
         u32 txulp0_ue_status : 1;                // DWORD 0
         u32 txips_ue_status : 1;                 // DWORD 0
         u32 tpre_ue_status : 1;                  // DWORD 0
         u32 tpost_ue_status : 1;                 // DWORD 0
         u32 tim_ue_status : 1;                   // DWORD 0
         u32 rxulp2_ue_status : 1;                // DWORD 0
         u32 rxulp1_ue_status : 1;                // DWORD 0
         u32 rxulp0_ue_status : 1;                // DWORD 0
         u32 rxips_ue_status : 1;                 // DWORD 0
         u32 rxf_ue_status : 1;                   // DWORD 0
         u32 rdma_ue_status : 1;                  // DWORD 0
         u32 ptc_ue_status : 1;                   // DWORD 0
         u32 ndma_ue_status : 1;                  // DWORD 0
         u32 mpu_ue_status : 1;                   // DWORD 0
         u32 host_ue_status : 1;                  // DWORD 0
         u32 erx_ue_status : 1;                   // DWORD 0
         u32 dbuf_ue_status : 1;                  // DWORD 0
         u32 ctx_ue_status : 1;                   // DWORD 0
         u32 cev_ue_status : 1;                   // DWORD 0
      } SG_PACK PCICFG_UE_STATUS_LOW_CSR, *PPCICFG_UE_STATUS_LOW_CSR;

      typedef union _PCICFG_UE_STATUS_LOW_CSR_UNION {
         PCICFG_UE_STATUS_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_UE_STATUS_LOW_CSR_UNION, *PPCICFG_UE_STATUS_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_LOW_CSR_UNION, sizeof (PCICFG_UE_STATUS_LOW_CSR_UNION) == 4);
   #endif


#else
   // Unrecoverable Error Status (Low) Register. Each bit corresponds to an internal
   // Unrecoverable Error. These are set by hardware and may be cleared by writing a one
   // to the respective bit(s) to be cleared. Any bit being set that is also unmasked will
   // result in Unrecoverable Error interrupt notification to the host CPU and/or Server
   // Management chip; and the transitioning of BladeEngine to an Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_UE_STATUS_LOW_CSR {
         union {
            struct { 
               u32 cev_ue_status : 1;             // DWORD 0
               u32 ctx_ue_status : 1;             // DWORD 0
               u32 dbuf_ue_status : 1;            // DWORD 0
               u32 erx_ue_status : 1;             // DWORD 0
               u32 host_ue_status : 1;            // DWORD 0
               u32 mpu_ue_status : 1;             // DWORD 0
               u32 ndma_ue_status : 1;            // DWORD 0
               u32 ptc_ue_status : 1;             // DWORD 0
               u32 rdma_ue_status : 1;            // DWORD 0
               u32 rxf_ue_status : 1;             // DWORD 0
               u32 rxips_ue_status : 1;           // DWORD 0
               u32 rxulp0_ue_status : 1;          // DWORD 0
               u32 rxulp1_ue_status : 1;          // DWORD 0
               u32 rxulp2_ue_status : 1;          // DWORD 0
               u32 tim_ue_status : 1;             // DWORD 0
               u32 tpost_ue_status : 1;           // DWORD 0
               u32 tpre_ue_status : 1;            // DWORD 0
               u32 txips_ue_status : 1;           // DWORD 0
               u32 txulp0_ue_status : 1;          // DWORD 0
               u32 txulp1_ue_status : 1;          // DWORD 0
               u32 uc_ue_status : 1;              // DWORD 0
               u32 wdma_ue_status : 1;            // DWORD 0
               u32 txulp2_ue_status : 1;          // DWORD 0
               u32 host1_ue_status : 1;           // DWORD 0
               u32 p0_ob_link_ue_status : 1;      // DWORD 0
               u32 p1_ob_link_ue_status : 1;      // DWORD 0
               u32 host_gpio_ue_status : 1;       // DWORD 0
               u32 mbox_ue_status : 1;            // DWORD 0
               u32 axgmac0_ue_status : 1;         // DWORD 0
               u32 axgmac1_ue_status : 1;         // DWORD 0
               u32 jtag_ue_status : 1;            // DWORD 0
               u32 mpu_intpend_ue_status : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_UE_STATUS_LOW_CSR, *PPCICFG_UE_STATUS_LOW_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_LOW_CSR, sizeof (PCICFG_UE_STATUS_LOW_CSR) == 4);

   #else
      typedef struct _PCICFG_UE_STATUS_LOW_CSR {
         u32 cev_ue_status : 1;                   // DWORD 0
         u32 ctx_ue_status : 1;                   // DWORD 0
         u32 dbuf_ue_status : 1;                  // DWORD 0
         u32 erx_ue_status : 1;                   // DWORD 0
         u32 host_ue_status : 1;                  // DWORD 0
         u32 mpu_ue_status : 1;                   // DWORD 0
         u32 ndma_ue_status : 1;                  // DWORD 0
         u32 ptc_ue_status : 1;                   // DWORD 0
         u32 rdma_ue_status : 1;                  // DWORD 0
         u32 rxf_ue_status : 1;                   // DWORD 0
         u32 rxips_ue_status : 1;                 // DWORD 0
         u32 rxulp0_ue_status : 1;                // DWORD 0
         u32 rxulp1_ue_status : 1;                // DWORD 0
         u32 rxulp2_ue_status : 1;                // DWORD 0
         u32 tim_ue_status : 1;                   // DWORD 0
         u32 tpost_ue_status : 1;                 // DWORD 0
         u32 tpre_ue_status : 1;                  // DWORD 0
         u32 txips_ue_status : 1;                 // DWORD 0
         u32 txulp0_ue_status : 1;                // DWORD 0
         u32 txulp1_ue_status : 1;                // DWORD 0
         u32 uc_ue_status : 1;                    // DWORD 0
         u32 wdma_ue_status : 1;                  // DWORD 0
         u32 txulp2_ue_status : 1;                // DWORD 0
         u32 host1_ue_status : 1;                 // DWORD 0
         u32 p0_ob_link_ue_status : 1;            // DWORD 0
         u32 p1_ob_link_ue_status : 1;            // DWORD 0
         u32 host_gpio_ue_status : 1;             // DWORD 0
         u32 mbox_ue_status : 1;                  // DWORD 0
         u32 axgmac0_ue_status : 1;               // DWORD 0
         u32 axgmac1_ue_status : 1;               // DWORD 0
         u32 jtag_ue_status : 1;                  // DWORD 0
         u32 mpu_intpend_ue_status : 1;           // DWORD 0
      } SG_PACK PCICFG_UE_STATUS_LOW_CSR, *PPCICFG_UE_STATUS_LOW_CSR;

      typedef union _PCICFG_UE_STATUS_LOW_CSR_UNION {
         PCICFG_UE_STATUS_LOW_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_UE_STATUS_LOW_CSR_UNION, *PPCICFG_UE_STATUS_LOW_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_LOW_CSR_UNION, sizeof (PCICFG_UE_STATUS_LOW_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unrecoverable Error Status (High) Register. Each bit corresponds to an internal
   // Unrecoverable Error. These are set by hardware and may be cleared by writing a one
   // to the respective bit(s) to be cleared. Any bit being set that is also unmasked will
   // result in Unrecoverable Error interrupt notification to the host CPU and/or Server
   // Management chip; and the transitioning of BladeEngine to an Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_UE_STATUS_HI_CSR {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 host8_ue_status : 1;           // DWORD 0
               u32 host7_ue_status : 1;           // DWORD 0
               u32 host6_ue_status : 1;           // DWORD 0
               u32 host5_ue_status : 1;           // DWORD 0
               u32 host4_ue_status : 1;           // DWORD 0
               u32 host3_ue_status : 1;           // DWORD 0
               u32 host2_ue_status : 1;           // DWORD 0
               u32 ipc_ue_status : 1;             // DWORD 0
               u32 arm_ue_status : 1;             // DWORD 0
               u32 txp_ue_status : 1;             // DWORD 0
               u32 xaui_ue_status : 1;            // DWORD 0
               u32 rxpp_ue_status : 1;            // DWORD 0
               u32 txpb_ue_status : 1;            // DWORD 0
               u32 rr_ue_status : 1;              // DWORD 0
               u32 pmem_ue_status : 1;            // DWORD 0
               u32 pctl1_ue_status : 1;           // DWORD 0
               u32 pctl0_ue_status : 1;           // DWORD 0
               u32 pcs1online_ue_status : 1;      // DWORD 0
               u32 mpu_iram_ue_status : 1;        // DWORD 0
               u32 pcs0online_ue_status : 1;      // DWORD 0
               u32 mgmt_mac_ue_status : 1;        // DWORD 0
               u32 lpcmemhost_ue_status : 1;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_UE_STATUS_HI_CSR, *PPCICFG_UE_STATUS_HI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_HI_CSR, sizeof (PCICFG_UE_STATUS_HI_CSR) == 4);

   #else
      typedef struct _PCICFG_UE_STATUS_HI_CSR {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 host8_ue_status : 1;                 // DWORD 0
         u32 host7_ue_status : 1;                 // DWORD 0
         u32 host6_ue_status : 1;                 // DWORD 0
         u32 host5_ue_status : 1;                 // DWORD 0
         u32 host4_ue_status : 1;                 // DWORD 0
         u32 host3_ue_status : 1;                 // DWORD 0
         u32 host2_ue_status : 1;                 // DWORD 0
         u32 ipc_ue_status : 1;                   // DWORD 0
         u32 arm_ue_status : 1;                   // DWORD 0
         u32 txp_ue_status : 1;                   // DWORD 0
         u32 xaui_ue_status : 1;                  // DWORD 0
         u32 rxpp_ue_status : 1;                  // DWORD 0
         u32 txpb_ue_status : 1;                  // DWORD 0
         u32 rr_ue_status : 1;                    // DWORD 0
         u32 pmem_ue_status : 1;                  // DWORD 0
         u32 pctl1_ue_status : 1;                 // DWORD 0
         u32 pctl0_ue_status : 1;                 // DWORD 0
         u32 pcs1online_ue_status : 1;            // DWORD 0
         u32 mpu_iram_ue_status : 1;              // DWORD 0
         u32 pcs0online_ue_status : 1;            // DWORD 0
         u32 mgmt_mac_ue_status : 1;              // DWORD 0
         u32 lpcmemhost_ue_status : 1;            // DWORD 0
      } SG_PACK PCICFG_UE_STATUS_HI_CSR, *PPCICFG_UE_STATUS_HI_CSR;

      typedef union _PCICFG_UE_STATUS_HI_CSR_UNION {
         PCICFG_UE_STATUS_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_UE_STATUS_HI_CSR_UNION, *PPCICFG_UE_STATUS_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_HI_CSR_UNION, sizeof (PCICFG_UE_STATUS_HI_CSR_UNION) == 4);
   #endif


#else
   // Unrecoverable Error Status (High) Register. Each bit corresponds to an internal
   // Unrecoverable Error. These are set by hardware and may be cleared by writing a one
   // to the respective bit(s) to be cleared. Any bit being set that is also unmasked will
   // result in Unrecoverable Error interrupt notification to the host CPU and/or Server
   // Management chip; and the transitioning of BladeEngine to an Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_UE_STATUS_HI_CSR {
         union {
            struct { 
               u32 lpcmemhost_ue_status : 1;      // DWORD 0
               u32 mgmt_mac_ue_status : 1;        // DWORD 0
               u32 pcs0online_ue_status : 1;      // DWORD 0
               u32 mpu_iram_ue_status : 1;        // DWORD 0
               u32 pcs1online_ue_status : 1;      // DWORD 0
               u32 pctl0_ue_status : 1;           // DWORD 0
               u32 pctl1_ue_status : 1;           // DWORD 0
               u32 pmem_ue_status : 1;            // DWORD 0
               u32 rr_ue_status : 1;              // DWORD 0
               u32 txpb_ue_status : 1;            // DWORD 0
               u32 rxpp_ue_status : 1;            // DWORD 0
               u32 xaui_ue_status : 1;            // DWORD 0
               u32 txp_ue_status : 1;             // DWORD 0
               u32 arm_ue_status : 1;             // DWORD 0
               u32 ipc_ue_status : 1;             // DWORD 0
               u32 host2_ue_status : 1;           // DWORD 0
               u32 host3_ue_status : 1;           // DWORD 0
               u32 host4_ue_status : 1;           // DWORD 0
               u32 host5_ue_status : 1;           // DWORD 0
               u32 host6_ue_status : 1;           // DWORD 0
               u32 host7_ue_status : 1;           // DWORD 0
               u32 host8_ue_status : 1;           // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_UE_STATUS_HI_CSR, *PPCICFG_UE_STATUS_HI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_HI_CSR, sizeof (PCICFG_UE_STATUS_HI_CSR) == 4);

   #else
      typedef struct _PCICFG_UE_STATUS_HI_CSR {
         u32 lpcmemhost_ue_status : 1;            // DWORD 0
         u32 mgmt_mac_ue_status : 1;              // DWORD 0
         u32 pcs0online_ue_status : 1;            // DWORD 0
         u32 mpu_iram_ue_status : 1;              // DWORD 0
         u32 pcs1online_ue_status : 1;            // DWORD 0
         u32 pctl0_ue_status : 1;                 // DWORD 0
         u32 pctl1_ue_status : 1;                 // DWORD 0
         u32 pmem_ue_status : 1;                  // DWORD 0
         u32 rr_ue_status : 1;                    // DWORD 0
         u32 txpb_ue_status : 1;                  // DWORD 0
         u32 rxpp_ue_status : 1;                  // DWORD 0
         u32 xaui_ue_status : 1;                  // DWORD 0
         u32 txp_ue_status : 1;                   // DWORD 0
         u32 arm_ue_status : 1;                   // DWORD 0
         u32 ipc_ue_status : 1;                   // DWORD 0
         u32 host2_ue_status : 1;                 // DWORD 0
         u32 host3_ue_status : 1;                 // DWORD 0
         u32 host4_ue_status : 1;                 // DWORD 0
         u32 host5_ue_status : 1;                 // DWORD 0
         u32 host6_ue_status : 1;                 // DWORD 0
         u32 host7_ue_status : 1;                 // DWORD 0
         u32 host8_ue_status : 1;                 // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK PCICFG_UE_STATUS_HI_CSR, *PPCICFG_UE_STATUS_HI_CSR;

      typedef union _PCICFG_UE_STATUS_HI_CSR_UNION {
         PCICFG_UE_STATUS_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_UE_STATUS_HI_CSR_UNION, *PPCICFG_UE_STATUS_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_HI_CSR_UNION, sizeof (PCICFG_UE_STATUS_HI_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unrecoverable Error Mask (Low) Register. Each bit, when set to one, will mask the
   // associated Unrecoverable Error status bit from notification of Unrecoverable Error
   // to the host CPU and/or Server Managment chip and the transitioning of all
   // BladeEngine units to an Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_UE_STATUS_LOW_MASK_CSR {
         union {
            struct { 
               u32 mpu_intpend_ue_mask : 1;       // DWORD 0
               u32 jtag_ue_mask : 1;              // DWORD 0
               u32 axgmac1_ue_mask : 1;           // DWORD 0
               u32 axgmac0_ue_mask : 1;           // DWORD 0
               u32 mbox_ue_mask : 1;              // DWORD 0
               u32 host_gpio_ue_mask : 1;         // DWORD 0
               u32 p1_ob_link_ue_mask : 1;        // DWORD 0
               u32 p0_ob_link_ue_mask : 1;        // DWORD 0
               u32 host1_ue_mask : 1;             // DWORD 0
               u32 txulp2_ue_mask : 1;            // DWORD 0
               u32 wdma_ue_mask : 1;              // DWORD 0
               u32 uc_ue_mask : 1;                // DWORD 0
               u32 txulp1_ue_mask : 1;            // DWORD 0
               u32 txulp0_ue_mask : 1;            // DWORD 0
               u32 txips_ue_mask : 1;             // DWORD 0
               u32 tpre_ue_mask : 1;              // DWORD 0
               u32 tpost_ue_mask : 1;             // DWORD 0
               u32 tim_ue_mask : 1;               // DWORD 0
               u32 rxulp2_ue_mask : 1;            // DWORD 0
               u32 rxulp1_ue_mask : 1;            // DWORD 0
               u32 rxulp0_ue_mask : 1;            // DWORD 0
               u32 rxips_ue_mask : 1;             // DWORD 0
               u32 rxf_ue_mask : 1;               // DWORD 0
               u32 rdma_ue_mask : 1;              // DWORD 0
               u32 ptc_ue_mask : 1;               // DWORD 0
               u32 ndma_ue_mask : 1;              // DWORD 0
               u32 mpu_ue_mask : 1;               // DWORD 0
               u32 host_ue_mask : 1;              // DWORD 0
               u32 erx_ue_mask : 1;               // DWORD 0
               u32 dbuf_ue_mask : 1;              // DWORD 0
               u32 ctx_ue_mask : 1;               // DWORD 0
               u32 cev_ue_mask : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_UE_STATUS_LOW_MASK_CSR, *PPCICFG_UE_STATUS_LOW_MASK_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_LOW_MASK_CSR, sizeof (PCICFG_UE_STATUS_LOW_MASK_CSR) == 4);

   #else
      typedef struct _PCICFG_UE_STATUS_LOW_MASK_CSR {
         u32 mpu_intpend_ue_mask : 1;             // DWORD 0
         u32 jtag_ue_mask : 1;                    // DWORD 0
         u32 axgmac1_ue_mask : 1;                 // DWORD 0
         u32 axgmac0_ue_mask : 1;                 // DWORD 0
         u32 mbox_ue_mask : 1;                    // DWORD 0
         u32 host_gpio_ue_mask : 1;               // DWORD 0
         u32 p1_ob_link_ue_mask : 1;              // DWORD 0
         u32 p0_ob_link_ue_mask : 1;              // DWORD 0
         u32 host1_ue_mask : 1;                   // DWORD 0
         u32 txulp2_ue_mask : 1;                  // DWORD 0
         u32 wdma_ue_mask : 1;                    // DWORD 0
         u32 uc_ue_mask : 1;                      // DWORD 0
         u32 txulp1_ue_mask : 1;                  // DWORD 0
         u32 txulp0_ue_mask : 1;                  // DWORD 0
         u32 txips_ue_mask : 1;                   // DWORD 0
         u32 tpre_ue_mask : 1;                    // DWORD 0
         u32 tpost_ue_mask : 1;                   // DWORD 0
         u32 tim_ue_mask : 1;                     // DWORD 0
         u32 rxulp2_ue_mask : 1;                  // DWORD 0
         u32 rxulp1_ue_mask : 1;                  // DWORD 0
         u32 rxulp0_ue_mask : 1;                  // DWORD 0
         u32 rxips_ue_mask : 1;                   // DWORD 0
         u32 rxf_ue_mask : 1;                     // DWORD 0
         u32 rdma_ue_mask : 1;                    // DWORD 0
         u32 ptc_ue_mask : 1;                     // DWORD 0
         u32 ndma_ue_mask : 1;                    // DWORD 0
         u32 mpu_ue_mask : 1;                     // DWORD 0
         u32 host_ue_mask : 1;                    // DWORD 0
         u32 erx_ue_mask : 1;                     // DWORD 0
         u32 dbuf_ue_mask : 1;                    // DWORD 0
         u32 ctx_ue_mask : 1;                     // DWORD 0
         u32 cev_ue_mask : 1;                     // DWORD 0
      } SG_PACK PCICFG_UE_STATUS_LOW_MASK_CSR, *PPCICFG_UE_STATUS_LOW_MASK_CSR;

      typedef union _PCICFG_UE_STATUS_LOW_MASK_CSR_UNION {
         PCICFG_UE_STATUS_LOW_MASK_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_UE_STATUS_LOW_MASK_CSR_UNION, *PPCICFG_UE_STATUS_LOW_MASK_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_LOW_MASK_CSR_UNION, sizeof (PCICFG_UE_STATUS_LOW_MASK_CSR_UNION) == 4);
   #endif


#else
   // Unrecoverable Error Mask (Low) Register. Each bit, when set to one, will mask the
   // associated Unrecoverable Error status bit from notification of Unrecoverable Error
   // to the host CPU and/or Server Managment chip and the transitioning of all
   // BladeEngine units to an Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_UE_STATUS_LOW_MASK_CSR {
         union {
            struct { 
               u32 cev_ue_mask : 1;               // DWORD 0
               u32 ctx_ue_mask : 1;               // DWORD 0
               u32 dbuf_ue_mask : 1;              // DWORD 0
               u32 erx_ue_mask : 1;               // DWORD 0
               u32 host_ue_mask : 1;              // DWORD 0
               u32 mpu_ue_mask : 1;               // DWORD 0
               u32 ndma_ue_mask : 1;              // DWORD 0
               u32 ptc_ue_mask : 1;               // DWORD 0
               u32 rdma_ue_mask : 1;              // DWORD 0
               u32 rxf_ue_mask : 1;               // DWORD 0
               u32 rxips_ue_mask : 1;             // DWORD 0
               u32 rxulp0_ue_mask : 1;            // DWORD 0
               u32 rxulp1_ue_mask : 1;            // DWORD 0
               u32 rxulp2_ue_mask : 1;            // DWORD 0
               u32 tim_ue_mask : 1;               // DWORD 0
               u32 tpost_ue_mask : 1;             // DWORD 0
               u32 tpre_ue_mask : 1;              // DWORD 0
               u32 txips_ue_mask : 1;             // DWORD 0
               u32 txulp0_ue_mask : 1;            // DWORD 0
               u32 txulp1_ue_mask : 1;            // DWORD 0
               u32 uc_ue_mask : 1;                // DWORD 0
               u32 wdma_ue_mask : 1;              // DWORD 0
               u32 txulp2_ue_mask : 1;            // DWORD 0
               u32 host1_ue_mask : 1;             // DWORD 0
               u32 p0_ob_link_ue_mask : 1;        // DWORD 0
               u32 p1_ob_link_ue_mask : 1;        // DWORD 0
               u32 host_gpio_ue_mask : 1;         // DWORD 0
               u32 mbox_ue_mask : 1;              // DWORD 0
               u32 axgmac0_ue_mask : 1;           // DWORD 0
               u32 axgmac1_ue_mask : 1;           // DWORD 0
               u32 jtag_ue_mask : 1;              // DWORD 0
               u32 mpu_intpend_ue_mask : 1;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_UE_STATUS_LOW_MASK_CSR, *PPCICFG_UE_STATUS_LOW_MASK_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_LOW_MASK_CSR, sizeof (PCICFG_UE_STATUS_LOW_MASK_CSR) == 4);

   #else
      typedef struct _PCICFG_UE_STATUS_LOW_MASK_CSR {
         u32 cev_ue_mask : 1;                     // DWORD 0
         u32 ctx_ue_mask : 1;                     // DWORD 0
         u32 dbuf_ue_mask : 1;                    // DWORD 0
         u32 erx_ue_mask : 1;                     // DWORD 0
         u32 host_ue_mask : 1;                    // DWORD 0
         u32 mpu_ue_mask : 1;                     // DWORD 0
         u32 ndma_ue_mask : 1;                    // DWORD 0
         u32 ptc_ue_mask : 1;                     // DWORD 0
         u32 rdma_ue_mask : 1;                    // DWORD 0
         u32 rxf_ue_mask : 1;                     // DWORD 0
         u32 rxips_ue_mask : 1;                   // DWORD 0
         u32 rxulp0_ue_mask : 1;                  // DWORD 0
         u32 rxulp1_ue_mask : 1;                  // DWORD 0
         u32 rxulp2_ue_mask : 1;                  // DWORD 0
         u32 tim_ue_mask : 1;                     // DWORD 0
         u32 tpost_ue_mask : 1;                   // DWORD 0
         u32 tpre_ue_mask : 1;                    // DWORD 0
         u32 txips_ue_mask : 1;                   // DWORD 0
         u32 txulp0_ue_mask : 1;                  // DWORD 0
         u32 txulp1_ue_mask : 1;                  // DWORD 0
         u32 uc_ue_mask : 1;                      // DWORD 0
         u32 wdma_ue_mask : 1;                    // DWORD 0
         u32 txulp2_ue_mask : 1;                  // DWORD 0
         u32 host1_ue_mask : 1;                   // DWORD 0
         u32 p0_ob_link_ue_mask : 1;              // DWORD 0
         u32 p1_ob_link_ue_mask : 1;              // DWORD 0
         u32 host_gpio_ue_mask : 1;               // DWORD 0
         u32 mbox_ue_mask : 1;                    // DWORD 0
         u32 axgmac0_ue_mask : 1;                 // DWORD 0
         u32 axgmac1_ue_mask : 1;                 // DWORD 0
         u32 jtag_ue_mask : 1;                    // DWORD 0
         u32 mpu_intpend_ue_mask : 1;             // DWORD 0
      } SG_PACK PCICFG_UE_STATUS_LOW_MASK_CSR, *PPCICFG_UE_STATUS_LOW_MASK_CSR;

      typedef union _PCICFG_UE_STATUS_LOW_MASK_CSR_UNION {
         PCICFG_UE_STATUS_LOW_MASK_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_UE_STATUS_LOW_MASK_CSR_UNION, *PPCICFG_UE_STATUS_LOW_MASK_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_LOW_MASK_CSR_UNION, sizeof (PCICFG_UE_STATUS_LOW_MASK_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unrecoverable Error Mask (High) Register. Each bit, when set to one, will mask the
   // associated Unrecoverable Error status bit from notification of Unrecoverable Error
   // to the host CPU and/or Server Managment chip and the transitioning of all
   // BladeEngine units to an Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_UE_STATUS_HI_MASK_CSR {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 host8_ue_mask : 1;             // DWORD 0
               u32 host7_ue_mask : 1;             // DWORD 0
               u32 host6_ue_mask : 1;             // DWORD 0
               u32 host5_ue_mask : 1;             // DWORD 0
               u32 host4_ue_mask : 1;             // DWORD 0
               u32 host3_ue_mask : 1;             // DWORD 0
               u32 host2_ue_mask : 1;             // DWORD 0
               u32 ipc_ue_mask : 1;               // DWORD 0
               u32 arm_ue_mask : 1;               // DWORD 0
               u32 txp_ue_mask : 1;               // DWORD 0
               u32 xaui_ue_mask : 1;              // DWORD 0
               u32 rxpp_ue_mask : 1;              // DWORD 0
               u32 txpb_ue_mask : 1;              // DWORD 0
               u32 rr_ue_mask : 1;                // DWORD 0
               u32 pmem_ue_mask : 1;              // DWORD 0
               u32 pctl1_ue_mask : 1;             // DWORD 0
               u32 pctl0_ue_mask : 1;             // DWORD 0
               u32 pcs1online_ue_mask : 1;        // DWORD 0
               u32 mpu_iram_ue_mask : 1;          // DWORD 0
               u32 pcs0online_ue_mask : 1;        // DWORD 0
               u32 mgmt_mac_ue_mask : 1;          // DWORD 0
               u32 lpcmemhost_ue_mask : 1;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_UE_STATUS_HI_MASK_CSR, *PPCICFG_UE_STATUS_HI_MASK_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_HI_MASK_CSR, sizeof (PCICFG_UE_STATUS_HI_MASK_CSR) == 4);

   #else
      typedef struct _PCICFG_UE_STATUS_HI_MASK_CSR {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 host8_ue_mask : 1;                   // DWORD 0
         u32 host7_ue_mask : 1;                   // DWORD 0
         u32 host6_ue_mask : 1;                   // DWORD 0
         u32 host5_ue_mask : 1;                   // DWORD 0
         u32 host4_ue_mask : 1;                   // DWORD 0
         u32 host3_ue_mask : 1;                   // DWORD 0
         u32 host2_ue_mask : 1;                   // DWORD 0
         u32 ipc_ue_mask : 1;                     // DWORD 0
         u32 arm_ue_mask : 1;                     // DWORD 0
         u32 txp_ue_mask : 1;                     // DWORD 0
         u32 xaui_ue_mask : 1;                    // DWORD 0
         u32 rxpp_ue_mask : 1;                    // DWORD 0
         u32 txpb_ue_mask : 1;                    // DWORD 0
         u32 rr_ue_mask : 1;                      // DWORD 0
         u32 pmem_ue_mask : 1;                    // DWORD 0
         u32 pctl1_ue_mask : 1;                   // DWORD 0
         u32 pctl0_ue_mask : 1;                   // DWORD 0
         u32 pcs1online_ue_mask : 1;              // DWORD 0
         u32 mpu_iram_ue_mask : 1;                // DWORD 0
         u32 pcs0online_ue_mask : 1;              // DWORD 0
         u32 mgmt_mac_ue_mask : 1;                // DWORD 0
         u32 lpcmemhost_ue_mask : 1;              // DWORD 0
      } SG_PACK PCICFG_UE_STATUS_HI_MASK_CSR, *PPCICFG_UE_STATUS_HI_MASK_CSR;

      typedef union _PCICFG_UE_STATUS_HI_MASK_CSR_UNION {
         PCICFG_UE_STATUS_HI_MASK_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_UE_STATUS_HI_MASK_CSR_UNION, *PPCICFG_UE_STATUS_HI_MASK_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_HI_MASK_CSR_UNION, sizeof (PCICFG_UE_STATUS_HI_MASK_CSR_UNION) == 4);
   #endif


#else
   // Unrecoverable Error Mask (High) Register. Each bit, when set to one, will mask the
   // associated Unrecoverable Error status bit from notification of Unrecoverable Error
   // to the host CPU and/or Server Managment chip and the transitioning of all
   // BladeEngine units to an Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_UE_STATUS_HI_MASK_CSR {
         union {
            struct { 
               u32 lpcmemhost_ue_mask : 1;        // DWORD 0
               u32 mgmt_mac_ue_mask : 1;          // DWORD 0
               u32 pcs0online_ue_mask : 1;        // DWORD 0
               u32 mpu_iram_ue_mask : 1;          // DWORD 0
               u32 pcs1online_ue_mask : 1;        // DWORD 0
               u32 pctl0_ue_mask : 1;             // DWORD 0
               u32 pctl1_ue_mask : 1;             // DWORD 0
               u32 pmem_ue_mask : 1;              // DWORD 0
               u32 rr_ue_mask : 1;                // DWORD 0
               u32 txpb_ue_mask : 1;              // DWORD 0
               u32 rxpp_ue_mask : 1;              // DWORD 0
               u32 xaui_ue_mask : 1;              // DWORD 0
               u32 txp_ue_mask : 1;               // DWORD 0
               u32 arm_ue_mask : 1;               // DWORD 0
               u32 ipc_ue_mask : 1;               // DWORD 0
               u32 host2_ue_mask : 1;             // DWORD 0
               u32 host3_ue_mask : 1;             // DWORD 0
               u32 host4_ue_mask : 1;             // DWORD 0
               u32 host5_ue_mask : 1;             // DWORD 0
               u32 host6_ue_mask : 1;             // DWORD 0
               u32 host7_ue_mask : 1;             // DWORD 0
               u32 host8_ue_mask : 1;             // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_UE_STATUS_HI_MASK_CSR, *PPCICFG_UE_STATUS_HI_MASK_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_HI_MASK_CSR, sizeof (PCICFG_UE_STATUS_HI_MASK_CSR) == 4);

   #else
      typedef struct _PCICFG_UE_STATUS_HI_MASK_CSR {
         u32 lpcmemhost_ue_mask : 1;              // DWORD 0
         u32 mgmt_mac_ue_mask : 1;                // DWORD 0
         u32 pcs0online_ue_mask : 1;              // DWORD 0
         u32 mpu_iram_ue_mask : 1;                // DWORD 0
         u32 pcs1online_ue_mask : 1;              // DWORD 0
         u32 pctl0_ue_mask : 1;                   // DWORD 0
         u32 pctl1_ue_mask : 1;                   // DWORD 0
         u32 pmem_ue_mask : 1;                    // DWORD 0
         u32 rr_ue_mask : 1;                      // DWORD 0
         u32 txpb_ue_mask : 1;                    // DWORD 0
         u32 rxpp_ue_mask : 1;                    // DWORD 0
         u32 xaui_ue_mask : 1;                    // DWORD 0
         u32 txp_ue_mask : 1;                     // DWORD 0
         u32 arm_ue_mask : 1;                     // DWORD 0
         u32 ipc_ue_mask : 1;                     // DWORD 0
         u32 host2_ue_mask : 1;                   // DWORD 0
         u32 host3_ue_mask : 1;                   // DWORD 0
         u32 host4_ue_mask : 1;                   // DWORD 0
         u32 host5_ue_mask : 1;                   // DWORD 0
         u32 host6_ue_mask : 1;                   // DWORD 0
         u32 host7_ue_mask : 1;                   // DWORD 0
         u32 host8_ue_mask : 1;                   // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK PCICFG_UE_STATUS_HI_MASK_CSR, *PPCICFG_UE_STATUS_HI_MASK_CSR;

      typedef union _PCICFG_UE_STATUS_HI_MASK_CSR_UNION {
         PCICFG_UE_STATUS_HI_MASK_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_UE_STATUS_HI_MASK_CSR_UNION, *PPCICFG_UE_STATUS_HI_MASK_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_UE_STATUS_HI_MASK_CSR_UNION, sizeof (PCICFG_UE_STATUS_HI_MASK_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Online Control Register 0. This register controls various units within BladeEngine
   // being in an Online or Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_ONLINE0_CSR {
         union {
            struct { 
               u32 mpu_intpend_online : 1;        // DWORD 0
               u32 jtag_online : 1;               // DWORD 0
               u32 axgmac1_online : 1;            // DWORD 0
               u32 axgmac0_online : 1;            // DWORD 0
               u32 mbox_online : 1;               // DWORD 0
               u32 host_gpio_online : 1;          // DWORD 0
               u32 p1_ob_link_online : 1;         // DWORD 0
               u32 p0_ob_link_online : 1;         // DWORD 0
               u32 host1_online : 1;              // DWORD 0
               u32 txulp2_online : 1;             // DWORD 0
               u32 wdma_online : 1;               // DWORD 0
               u32 uc_online : 1;                 // DWORD 0
               u32 txulp1_online : 1;             // DWORD 0
               u32 txulp0_online : 1;             // DWORD 0
               u32 txips_online : 1;              // DWORD 0
               u32 tpre_online : 1;               // DWORD 0
               u32 tpost_online : 1;              // DWORD 0
               u32 tim_online : 1;                // DWORD 0
               u32 rxulp2_online : 1;             // DWORD 0
               u32 rxulp1_online : 1;             // DWORD 0
               u32 rxulp0_online : 1;             // DWORD 0
               u32 rxips_online : 1;              // DWORD 0
               u32 rxf_online : 1;                // DWORD 0
               u32 rdma_online : 1;               // DWORD 0
               u32 ptc_online : 1;                // DWORD 0
               u32 ndma_online : 1;               // DWORD 0
               u32 mpu_online : 1;                // DWORD 0
               u32 host_online : 1;               // DWORD 0
               u32 erx_online : 1;                // DWORD 0
               u32 dbuf_online : 1;               // DWORD 0
               u32 ctx_online : 1;                // DWORD 0
               u32 cev_online : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_ONLINE0_CSR, *PPCICFG_ONLINE0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_ONLINE0_CSR, sizeof (PCICFG_ONLINE0_CSR) == 4);

   #else
      typedef struct _PCICFG_ONLINE0_CSR {
         u32 mpu_intpend_online : 1;              // DWORD 0
         u32 jtag_online : 1;                     // DWORD 0
         u32 axgmac1_online : 1;                  // DWORD 0
         u32 axgmac0_online : 1;                  // DWORD 0
         u32 mbox_online : 1;                     // DWORD 0
         u32 host_gpio_online : 1;                // DWORD 0
         u32 p1_ob_link_online : 1;               // DWORD 0
         u32 p0_ob_link_online : 1;               // DWORD 0
         u32 host1_online : 1;                    // DWORD 0
         u32 txulp2_online : 1;                   // DWORD 0
         u32 wdma_online : 1;                     // DWORD 0
         u32 uc_online : 1;                       // DWORD 0
         u32 txulp1_online : 1;                   // DWORD 0
         u32 txulp0_online : 1;                   // DWORD 0
         u32 txips_online : 1;                    // DWORD 0
         u32 tpre_online : 1;                     // DWORD 0
         u32 tpost_online : 1;                    // DWORD 0
         u32 tim_online : 1;                      // DWORD 0
         u32 rxulp2_online : 1;                   // DWORD 0
         u32 rxulp1_online : 1;                   // DWORD 0
         u32 rxulp0_online : 1;                   // DWORD 0
         u32 rxips_online : 1;                    // DWORD 0
         u32 rxf_online : 1;                      // DWORD 0
         u32 rdma_online : 1;                     // DWORD 0
         u32 ptc_online : 1;                      // DWORD 0
         u32 ndma_online : 1;                     // DWORD 0
         u32 mpu_online : 1;                      // DWORD 0
         u32 host_online : 1;                     // DWORD 0
         u32 erx_online : 1;                      // DWORD 0
         u32 dbuf_online : 1;                     // DWORD 0
         u32 ctx_online : 1;                      // DWORD 0
         u32 cev_online : 1;                      // DWORD 0
      } SG_PACK PCICFG_ONLINE0_CSR, *PPCICFG_ONLINE0_CSR;

      typedef union _PCICFG_ONLINE0_CSR_UNION {
         PCICFG_ONLINE0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_ONLINE0_CSR_UNION, *PPCICFG_ONLINE0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_ONLINE0_CSR_UNION, sizeof (PCICFG_ONLINE0_CSR_UNION) == 4);
   #endif


#else
   // Online Control Register 0. This register controls various units within BladeEngine
   // being in an Online or Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_ONLINE0_CSR {
         union {
            struct { 
               u32 cev_online : 1;                // DWORD 0
               u32 ctx_online : 1;                // DWORD 0
               u32 dbuf_online : 1;               // DWORD 0
               u32 erx_online : 1;                // DWORD 0
               u32 host_online : 1;               // DWORD 0
               u32 mpu_online : 1;                // DWORD 0
               u32 ndma_online : 1;               // DWORD 0
               u32 ptc_online : 1;                // DWORD 0
               u32 rdma_online : 1;               // DWORD 0
               u32 rxf_online : 1;                // DWORD 0
               u32 rxips_online : 1;              // DWORD 0
               u32 rxulp0_online : 1;             // DWORD 0
               u32 rxulp1_online : 1;             // DWORD 0
               u32 rxulp2_online : 1;             // DWORD 0
               u32 tim_online : 1;                // DWORD 0
               u32 tpost_online : 1;              // DWORD 0
               u32 tpre_online : 1;               // DWORD 0
               u32 txips_online : 1;              // DWORD 0
               u32 txulp0_online : 1;             // DWORD 0
               u32 txulp1_online : 1;             // DWORD 0
               u32 uc_online : 1;                 // DWORD 0
               u32 wdma_online : 1;               // DWORD 0
               u32 txulp2_online : 1;             // DWORD 0
               u32 host1_online : 1;              // DWORD 0
               u32 p0_ob_link_online : 1;         // DWORD 0
               u32 p1_ob_link_online : 1;         // DWORD 0
               u32 host_gpio_online : 1;          // DWORD 0
               u32 mbox_online : 1;               // DWORD 0
               u32 axgmac0_online : 1;            // DWORD 0
               u32 axgmac1_online : 1;            // DWORD 0
               u32 jtag_online : 1;               // DWORD 0
               u32 mpu_intpend_online : 1;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_ONLINE0_CSR, *PPCICFG_ONLINE0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_ONLINE0_CSR, sizeof (PCICFG_ONLINE0_CSR) == 4);

   #else
      typedef struct _PCICFG_ONLINE0_CSR {
         u32 cev_online : 1;                      // DWORD 0
         u32 ctx_online : 1;                      // DWORD 0
         u32 dbuf_online : 1;                     // DWORD 0
         u32 erx_online : 1;                      // DWORD 0
         u32 host_online : 1;                     // DWORD 0
         u32 mpu_online : 1;                      // DWORD 0
         u32 ndma_online : 1;                     // DWORD 0
         u32 ptc_online : 1;                      // DWORD 0
         u32 rdma_online : 1;                     // DWORD 0
         u32 rxf_online : 1;                      // DWORD 0
         u32 rxips_online : 1;                    // DWORD 0
         u32 rxulp0_online : 1;                   // DWORD 0
         u32 rxulp1_online : 1;                   // DWORD 0
         u32 rxulp2_online : 1;                   // DWORD 0
         u32 tim_online : 1;                      // DWORD 0
         u32 tpost_online : 1;                    // DWORD 0
         u32 tpre_online : 1;                     // DWORD 0
         u32 txips_online : 1;                    // DWORD 0
         u32 txulp0_online : 1;                   // DWORD 0
         u32 txulp1_online : 1;                   // DWORD 0
         u32 uc_online : 1;                       // DWORD 0
         u32 wdma_online : 1;                     // DWORD 0
         u32 txulp2_online : 1;                   // DWORD 0
         u32 host1_online : 1;                    // DWORD 0
         u32 p0_ob_link_online : 1;               // DWORD 0
         u32 p1_ob_link_online : 1;               // DWORD 0
         u32 host_gpio_online : 1;                // DWORD 0
         u32 mbox_online : 1;                     // DWORD 0
         u32 axgmac0_online : 1;                  // DWORD 0
         u32 axgmac1_online : 1;                  // DWORD 0
         u32 jtag_online : 1;                     // DWORD 0
         u32 mpu_intpend_online : 1;              // DWORD 0
      } SG_PACK PCICFG_ONLINE0_CSR, *PPCICFG_ONLINE0_CSR;

      typedef union _PCICFG_ONLINE0_CSR_UNION {
         PCICFG_ONLINE0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_ONLINE0_CSR_UNION, *PPCICFG_ONLINE0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_ONLINE0_CSR_UNION, sizeof (PCICFG_ONLINE0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Online Control Register 1. This register controls various units within BladeEngine
   // being in an Online or Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_ONLINE1_CSR {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 host8_online : 1;              // DWORD 0
               u32 host7_online : 1;              // DWORD 0
               u32 host6_online : 1;              // DWORD 0
               u32 host5_online : 1;              // DWORD 0
               u32 host4_online : 1;              // DWORD 0
               u32 host3_online : 1;              // DWORD 0
               u32 host2_online : 1;              // DWORD 0
               u32 ipc_online : 1;                // DWORD 0
               u32 arm_online : 1;                // DWORD 0
               u32 txp_online : 1;                // DWORD 0
               u32 xaui_online : 1;               // DWORD 0
               u32 rxpp_online : 1;               // DWORD 0
               u32 txpb_online : 1;               // DWORD 0
               u32 rr_online : 1;                 // DWORD 0
               u32 pmem_online : 1;               // DWORD 0
               u32 pctl1_online : 1;              // DWORD 0
               u32 pctl0_online : 1;              // DWORD 0
               u32 pcs1online_online : 1;         // DWORD 0
               u32 mpu_iram_online : 1;           // DWORD 0
               u32 pcs0online_online : 1;         // DWORD 0
               u32 mgmt_mac_online : 1;           // DWORD 0
               u32 lpcmemhost_online : 1;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_ONLINE1_CSR, *PPCICFG_ONLINE1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_ONLINE1_CSR, sizeof (PCICFG_ONLINE1_CSR) == 4);

   #else
      typedef struct _PCICFG_ONLINE1_CSR {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 host8_online : 1;                    // DWORD 0
         u32 host7_online : 1;                    // DWORD 0
         u32 host6_online : 1;                    // DWORD 0
         u32 host5_online : 1;                    // DWORD 0
         u32 host4_online : 1;                    // DWORD 0
         u32 host3_online : 1;                    // DWORD 0
         u32 host2_online : 1;                    // DWORD 0
         u32 ipc_online : 1;                      // DWORD 0
         u32 arm_online : 1;                      // DWORD 0
         u32 txp_online : 1;                      // DWORD 0
         u32 xaui_online : 1;                     // DWORD 0
         u32 rxpp_online : 1;                     // DWORD 0
         u32 txpb_online : 1;                     // DWORD 0
         u32 rr_online : 1;                       // DWORD 0
         u32 pmem_online : 1;                     // DWORD 0
         u32 pctl1_online : 1;                    // DWORD 0
         u32 pctl0_online : 1;                    // DWORD 0
         u32 pcs1online_online : 1;               // DWORD 0
         u32 mpu_iram_online : 1;                 // DWORD 0
         u32 pcs0online_online : 1;               // DWORD 0
         u32 mgmt_mac_online : 1;                 // DWORD 0
         u32 lpcmemhost_online : 1;               // DWORD 0
      } SG_PACK PCICFG_ONLINE1_CSR, *PPCICFG_ONLINE1_CSR;

      typedef union _PCICFG_ONLINE1_CSR_UNION {
         PCICFG_ONLINE1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_ONLINE1_CSR_UNION, *PPCICFG_ONLINE1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_ONLINE1_CSR_UNION, sizeof (PCICFG_ONLINE1_CSR_UNION) == 4);
   #endif


#else
   // Online Control Register 1. This register controls various units within BladeEngine
   // being in an Online or Offline state. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_ONLINE1_CSR {
         union {
            struct { 
               u32 lpcmemhost_online : 1;         // DWORD 0
               u32 mgmt_mac_online : 1;           // DWORD 0
               u32 pcs0online_online : 1;         // DWORD 0
               u32 mpu_iram_online : 1;           // DWORD 0
               u32 pcs1online_online : 1;         // DWORD 0
               u32 pctl0_online : 1;              // DWORD 0
               u32 pctl1_online : 1;              // DWORD 0
               u32 pmem_online : 1;               // DWORD 0
               u32 rr_online : 1;                 // DWORD 0
               u32 txpb_online : 1;               // DWORD 0
               u32 rxpp_online : 1;               // DWORD 0
               u32 xaui_online : 1;               // DWORD 0
               u32 txp_online : 1;                // DWORD 0
               u32 arm_online : 1;                // DWORD 0
               u32 ipc_online : 1;                // DWORD 0
               u32 host2_online : 1;              // DWORD 0
               u32 host3_online : 1;              // DWORD 0
               u32 host4_online : 1;              // DWORD 0
               u32 host5_online : 1;              // DWORD 0
               u32 host6_online : 1;              // DWORD 0
               u32 host7_online : 1;              // DWORD 0
               u32 host8_online : 1;              // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_ONLINE1_CSR, *PPCICFG_ONLINE1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_ONLINE1_CSR, sizeof (PCICFG_ONLINE1_CSR) == 4);

   #else
      typedef struct _PCICFG_ONLINE1_CSR {
         u32 lpcmemhost_online : 1;               // DWORD 0
         u32 mgmt_mac_online : 1;                 // DWORD 0
         u32 pcs0online_online : 1;               // DWORD 0
         u32 mpu_iram_online : 1;                 // DWORD 0
         u32 pcs1online_online : 1;               // DWORD 0
         u32 pctl0_online : 1;                    // DWORD 0
         u32 pctl1_online : 1;                    // DWORD 0
         u32 pmem_online : 1;                     // DWORD 0
         u32 rr_online : 1;                       // DWORD 0
         u32 txpb_online : 1;                     // DWORD 0
         u32 rxpp_online : 1;                     // DWORD 0
         u32 xaui_online : 1;                     // DWORD 0
         u32 txp_online : 1;                      // DWORD 0
         u32 arm_online : 1;                      // DWORD 0
         u32 ipc_online : 1;                      // DWORD 0
         u32 host2_online : 1;                    // DWORD 0
         u32 host3_online : 1;                    // DWORD 0
         u32 host4_online : 1;                    // DWORD 0
         u32 host5_online : 1;                    // DWORD 0
         u32 host6_online : 1;                    // DWORD 0
         u32 host7_online : 1;                    // DWORD 0
         u32 host8_online : 1;                    // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK PCICFG_ONLINE1_CSR, *PPCICFG_ONLINE1_CSR;

      typedef union _PCICFG_ONLINE1_CSR_UNION {
         PCICFG_ONLINE1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_ONLINE1_CSR_UNION, *PPCICFG_ONLINE1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_ONLINE1_CSR_UNION, sizeof (PCICFG_ONLINE1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host Timer Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HOST_TIMER_INT_CTRL_CSR {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 ui_enter_l1 : 1;               // DWORD 0
               u32 clr_pcie_stats : 1;            // DWORD 0
               u32 scratchpad0 : 1;               // DWORD 0
               u32 vf_fun_shared_reg_wr_access : 1; // DWORD 0
               u32 hosttimer : 24;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HOST_TIMER_INT_CTRL_CSR, *PPCICFG_HOST_TIMER_INT_CTRL_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_TIMER_INT_CTRL_CSR, sizeof (PCICFG_HOST_TIMER_INT_CTRL_CSR) == 4);

   #else
      typedef struct _PCICFG_HOST_TIMER_INT_CTRL_CSR {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 ui_enter_l1 : 1;                     // DWORD 0
         u32 clr_pcie_stats : 1;                  // DWORD 0
         u32 scratchpad0 : 1;                     // DWORD 0
         u32 vf_fun_shared_reg_wr_access : 1;     // DWORD 0
         u32 hosttimer : 24;                      // DWORD 0
      } SG_PACK PCICFG_HOST_TIMER_INT_CTRL_CSR, *PPCICFG_HOST_TIMER_INT_CTRL_CSR;

      typedef union _PCICFG_HOST_TIMER_INT_CTRL_CSR_UNION {
         PCICFG_HOST_TIMER_INT_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HOST_TIMER_INT_CTRL_CSR_UNION, *PPCICFG_HOST_TIMER_INT_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_TIMER_INT_CTRL_CSR_UNION, sizeof (PCICFG_HOST_TIMER_INT_CTRL_CSR_UNION) == 4);
   #endif


#else
   // Host Timer Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HOST_TIMER_INT_CTRL_CSR {
         union {
            struct { 
               u32 hosttimer : 24;                // DWORD 0
               u32 vf_fun_shared_reg_wr_access : 1; // DWORD 0
               u32 scratchpad0 : 1;               // DWORD 0
               u32 clr_pcie_stats : 1;            // DWORD 0
               u32 ui_enter_l1 : 1;               // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HOST_TIMER_INT_CTRL_CSR, *PPCICFG_HOST_TIMER_INT_CTRL_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_TIMER_INT_CTRL_CSR, sizeof (PCICFG_HOST_TIMER_INT_CTRL_CSR) == 4);

   #else
      typedef struct _PCICFG_HOST_TIMER_INT_CTRL_CSR {
         u32 hosttimer : 24;                      // DWORD 0
         u32 vf_fun_shared_reg_wr_access : 1;     // DWORD 0
         u32 scratchpad0 : 1;                     // DWORD 0
         u32 clr_pcie_stats : 1;                  // DWORD 0
         u32 ui_enter_l1 : 1;                     // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK PCICFG_HOST_TIMER_INT_CTRL_CSR, *PPCICFG_HOST_TIMER_INT_CTRL_CSR;

      typedef union _PCICFG_HOST_TIMER_INT_CTRL_CSR_UNION {
         PCICFG_HOST_TIMER_INT_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HOST_TIMER_INT_CTRL_CSR_UNION, *PPCICFG_HOST_TIMER_INT_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_TIMER_INT_CTRL_CSR_UNION, sizeof (PCICFG_HOST_TIMER_INT_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Host Control/Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HOST_CONTROL_STATUS_CSR {
         union {
            struct { 
               u32 func1en : 1;                   // DWORD 0
               u32 f7_f6_4MB_db_bar : 2;          // DWORD 0
               u32 ARI_spec_en : 1;               // DWORD 0
               u32 expromdisable : 1;             // DWORD 0
               u32 fwbootfail : 1;                // DWORD 0
               u32 lpcismstaterr : 1;             // DWORD 0
               u32 lpcismtranserr : 1;            // DWORD 0
               u32 pcie_linkdn_ue_mask : 1;       // DWORD 0
               u32 pcie_retry_buf_ecc_ue_mask : 1; // DWORD 0
               u32 pcie_linkdn_ue_source : 1;     // DWORD 0
               u32 pcie_retry_buf_ecc_ue_source : 1; // DWORD 0
               u32 cev_swacken : 1;               // DWORD 0
               u32 iqrdflushoqwren : 1;           // DWORD 0
               u32 f5_f4_4MB_db_bar : 2;          // DWORD 0
               u32 func2en : 1;                   // DWORD 0
               u32 func3en : 1;                   // DWORD 0
               u32 STATE_UPCONFIGURE_CAPABLE : 1; // DWORD 0
               u32 hostoqrdpasswren : 1;          // DWORD 0
               u32 hostoqempty : 1;               // DWORD 0
               u32 hostoqdepth : 3;               // DWORD 0
               u32 f3_f0_4MB_db_bar : 4;          // DWORD 0
               u32 func7en : 1;                   // DWORD 0
               u32 func6en : 1;                   // DWORD 0
               u32 func5en : 1;                   // DWORD 0
               u32 func4en : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HOST_CONTROL_STATUS_CSR, *PPCICFG_HOST_CONTROL_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_CONTROL_STATUS_CSR, sizeof (PCICFG_HOST_CONTROL_STATUS_CSR) == 4);

   #else
      typedef struct _PCICFG_HOST_CONTROL_STATUS_CSR {
         u32 func1en : 1;                         // DWORD 0
         u32 f7_f6_4MB_db_bar : 2;                // DWORD 0
         u32 ARI_spec_en : 1;                     // DWORD 0
         u32 expromdisable : 1;                   // DWORD 0
         u32 fwbootfail : 1;                      // DWORD 0
         u32 lpcismstaterr : 1;                   // DWORD 0
         u32 lpcismtranserr : 1;                  // DWORD 0
         u32 pcie_linkdn_ue_mask : 1;             // DWORD 0
         u32 pcie_retry_buf_ecc_ue_mask : 1;      // DWORD 0
         u32 pcie_linkdn_ue_source : 1;           // DWORD 0
         u32 pcie_retry_buf_ecc_ue_source : 1;    // DWORD 0
         u32 cev_swacken : 1;                     // DWORD 0
         u32 iqrdflushoqwren : 1;                 // DWORD 0
         u32 f5_f4_4MB_db_bar : 2;                // DWORD 0
         u32 func2en : 1;                         // DWORD 0
         u32 func3en : 1;                         // DWORD 0
         u32 STATE_UPCONFIGURE_CAPABLE : 1;       // DWORD 0
         u32 hostoqrdpasswren : 1;                // DWORD 0
         u32 hostoqempty : 1;                     // DWORD 0
         u32 hostoqdepth : 3;                     // DWORD 0
         u32 f3_f0_4MB_db_bar : 4;                // DWORD 0
         u32 func7en : 1;                         // DWORD 0
         u32 func6en : 1;                         // DWORD 0
         u32 func5en : 1;                         // DWORD 0
         u32 func4en : 1;                         // DWORD 0
      } SG_PACK PCICFG_HOST_CONTROL_STATUS_CSR, *PPCICFG_HOST_CONTROL_STATUS_CSR;

      typedef union _PCICFG_HOST_CONTROL_STATUS_CSR_UNION {
         PCICFG_HOST_CONTROL_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HOST_CONTROL_STATUS_CSR_UNION, *PPCICFG_HOST_CONTROL_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_CONTROL_STATUS_CSR_UNION, sizeof (PCICFG_HOST_CONTROL_STATUS_CSR_UNION) == 4);
   #endif


#else
   // Host Control/Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HOST_CONTROL_STATUS_CSR {
         union {
            struct { 
               u32 func4en : 1;                   // DWORD 0
               u32 func5en : 1;                   // DWORD 0
               u32 func6en : 1;                   // DWORD 0
               u32 func7en : 1;                   // DWORD 0
               u32 f3_f0_4MB_db_bar : 4;          // DWORD 0
               u32 hostoqdepth : 3;               // DWORD 0
               u32 hostoqempty : 1;               // DWORD 0
               u32 hostoqrdpasswren : 1;          // DWORD 0
               u32 STATE_UPCONFIGURE_CAPABLE : 1; // DWORD 0
               u32 func3en : 1;                   // DWORD 0
               u32 func2en : 1;                   // DWORD 0
               u32 f5_f4_4MB_db_bar : 2;          // DWORD 0
               u32 iqrdflushoqwren : 1;           // DWORD 0
               u32 cev_swacken : 1;               // DWORD 0
               u32 pcie_retry_buf_ecc_ue_source : 1; // DWORD 0
               u32 pcie_linkdn_ue_source : 1;     // DWORD 0
               u32 pcie_retry_buf_ecc_ue_mask : 1; // DWORD 0
               u32 pcie_linkdn_ue_mask : 1;       // DWORD 0
               u32 lpcismtranserr : 1;            // DWORD 0
               u32 lpcismstaterr : 1;             // DWORD 0
               u32 fwbootfail : 1;                // DWORD 0
               u32 expromdisable : 1;             // DWORD 0
               u32 ARI_spec_en : 1;               // DWORD 0
               u32 f7_f6_4MB_db_bar : 2;          // DWORD 0
               u32 func1en : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HOST_CONTROL_STATUS_CSR, *PPCICFG_HOST_CONTROL_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_CONTROL_STATUS_CSR, sizeof (PCICFG_HOST_CONTROL_STATUS_CSR) == 4);

   #else
      typedef struct _PCICFG_HOST_CONTROL_STATUS_CSR {
         u32 func4en : 1;                         // DWORD 0
         u32 func5en : 1;                         // DWORD 0
         u32 func6en : 1;                         // DWORD 0
         u32 func7en : 1;                         // DWORD 0
         u32 f3_f0_4MB_db_bar : 4;                // DWORD 0
         u32 hostoqdepth : 3;                     // DWORD 0
         u32 hostoqempty : 1;                     // DWORD 0
         u32 hostoqrdpasswren : 1;                // DWORD 0
         u32 STATE_UPCONFIGURE_CAPABLE : 1;       // DWORD 0
         u32 func3en : 1;                         // DWORD 0
         u32 func2en : 1;                         // DWORD 0
         u32 f5_f4_4MB_db_bar : 2;                // DWORD 0
         u32 iqrdflushoqwren : 1;                 // DWORD 0
         u32 cev_swacken : 1;                     // DWORD 0
         u32 pcie_retry_buf_ecc_ue_source : 1;    // DWORD 0
         u32 pcie_linkdn_ue_source : 1;           // DWORD 0
         u32 pcie_retry_buf_ecc_ue_mask : 1;      // DWORD 0
         u32 pcie_linkdn_ue_mask : 1;             // DWORD 0
         u32 lpcismtranserr : 1;                  // DWORD 0
         u32 lpcismstaterr : 1;                   // DWORD 0
         u32 fwbootfail : 1;                      // DWORD 0
         u32 expromdisable : 1;                   // DWORD 0
         u32 ARI_spec_en : 1;                     // DWORD 0
         u32 f7_f6_4MB_db_bar : 2;                // DWORD 0
         u32 func1en : 1;                         // DWORD 0
      } SG_PACK PCICFG_HOST_CONTROL_STATUS_CSR, *PPCICFG_HOST_CONTROL_STATUS_CSR;

      typedef union _PCICFG_HOST_CONTROL_STATUS_CSR_UNION {
         PCICFG_HOST_CONTROL_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HOST_CONTROL_STATUS_CSR_UNION, *PPCICFG_HOST_CONTROL_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HOST_CONTROL_STATUS_CSR_UNION, sizeof (PCICFG_HOST_CONTROL_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // LPC Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_LPC_ADDR_CSR {
         union {
            struct { 
               u32 lpc_addr;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_LPC_ADDR_CSR, *PPCICFG_LPC_ADDR_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_ADDR_CSR, sizeof (PCICFG_LPC_ADDR_CSR) == 4);

   #else
      typedef struct _PCICFG_LPC_ADDR_CSR {
         u32 lpc_addr;                            // DWORD 0
      } SG_PACK PCICFG_LPC_ADDR_CSR, *PPCICFG_LPC_ADDR_CSR;

      typedef union _PCICFG_LPC_ADDR_CSR_UNION {
         PCICFG_LPC_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_LPC_ADDR_CSR_UNION, *PPCICFG_LPC_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_ADDR_CSR_UNION, sizeof (PCICFG_LPC_ADDR_CSR_UNION) == 4);
   #endif


#else
   // LPC Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_LPC_ADDR_CSR {
         union {
            struct { 
               u32 lpc_addr;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_LPC_ADDR_CSR, *PPCICFG_LPC_ADDR_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_ADDR_CSR, sizeof (PCICFG_LPC_ADDR_CSR) == 4);

   #else
      typedef struct _PCICFG_LPC_ADDR_CSR {
         u32 lpc_addr;                            // DWORD 0
      } SG_PACK PCICFG_LPC_ADDR_CSR, *PPCICFG_LPC_ADDR_CSR;

      typedef union _PCICFG_LPC_ADDR_CSR_UNION {
         PCICFG_LPC_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_LPC_ADDR_CSR_UNION, *PPCICFG_LPC_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_ADDR_CSR_UNION, sizeof (PCICFG_LPC_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // LPC Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_LPC_DATA_CSR {
         union {
            struct { 
               u32 lpc_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_LPC_DATA_CSR, *PPCICFG_LPC_DATA_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_DATA_CSR, sizeof (PCICFG_LPC_DATA_CSR) == 4);

   #else
      typedef struct _PCICFG_LPC_DATA_CSR {
         u32 lpc_data;                            // DWORD 0
      } SG_PACK PCICFG_LPC_DATA_CSR, *PPCICFG_LPC_DATA_CSR;

      typedef union _PCICFG_LPC_DATA_CSR_UNION {
         PCICFG_LPC_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_LPC_DATA_CSR_UNION, *PPCICFG_LPC_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_DATA_CSR_UNION, sizeof (PCICFG_LPC_DATA_CSR_UNION) == 4);
   #endif


#else
   // LPC Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_LPC_DATA_CSR {
         union {
            struct { 
               u32 lpc_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_LPC_DATA_CSR, *PPCICFG_LPC_DATA_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_DATA_CSR, sizeof (PCICFG_LPC_DATA_CSR) == 4);

   #else
      typedef struct _PCICFG_LPC_DATA_CSR {
         u32 lpc_data;                            // DWORD 0
      } SG_PACK PCICFG_LPC_DATA_CSR, *PPCICFG_LPC_DATA_CSR;

      typedef union _PCICFG_LPC_DATA_CSR_UNION {
         PCICFG_LPC_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_LPC_DATA_CSR_UNION, *PPCICFG_LPC_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_DATA_CSR_UNION, sizeof (PCICFG_LPC_DATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // LPC Command Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_LPC_COMMAND_CSR {
         union {
            struct { 
               u32 bus_num : 8;                   // DWORD 0
               u32 core_lpcism_done : 1;          // DWORD 0
               u32 core_lpcismactive : 1;         // DWORD 0
               u32 core_lpcism_state : 5;         // DWORD 0
               u32 core_d3_lpcism_done : 1;       // DWORD 0
               u32 core_d3_lpcismactive : 1;      // DWORD 0
               u32 core_d3_lpcism_state : 5;      // DWORD 0
               u32 rst : 1;                       // DWORD 0
               u32 abort : 1;                     // DWORD 0
               u32 reg : 1;                       // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 req : 1;                       // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 be : 4;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_LPC_COMMAND_CSR, *PPCICFG_LPC_COMMAND_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_COMMAND_CSR, sizeof (PCICFG_LPC_COMMAND_CSR) == 4);

   #else
      typedef struct _PCICFG_LPC_COMMAND_CSR {
         u32 bus_num : 8;                         // DWORD 0
         u32 core_lpcism_done : 1;                // DWORD 0
         u32 core_lpcismactive : 1;               // DWORD 0
         u32 core_lpcism_state : 5;               // DWORD 0
         u32 core_d3_lpcism_done : 1;             // DWORD 0
         u32 core_d3_lpcismactive : 1;            // DWORD 0
         u32 core_d3_lpcism_state : 5;            // DWORD 0
         u32 rst : 1;                             // DWORD 0
         u32 abort : 1;                           // DWORD 0
         u32 reg : 1;                             // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 req : 1;                             // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 be : 4;                              // DWORD 0
      } SG_PACK PCICFG_LPC_COMMAND_CSR, *PPCICFG_LPC_COMMAND_CSR;

      typedef union _PCICFG_LPC_COMMAND_CSR_UNION {
         PCICFG_LPC_COMMAND_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_LPC_COMMAND_CSR_UNION, *PPCICFG_LPC_COMMAND_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_COMMAND_CSR_UNION, sizeof (PCICFG_LPC_COMMAND_CSR_UNION) == 4);
   #endif


#else
   // LPC Command Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_LPC_COMMAND_CSR {
         union {
            struct { 
               u32 be : 4;                        // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 req : 1;                       // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 reg : 1;                       // DWORD 0
               u32 abort : 1;                     // DWORD 0
               u32 rst : 1;                       // DWORD 0
               u32 core_d3_lpcism_state : 5;      // DWORD 0
               u32 core_d3_lpcismactive : 1;      // DWORD 0
               u32 core_d3_lpcism_done : 1;       // DWORD 0
               u32 core_lpcism_state : 5;         // DWORD 0
               u32 core_lpcismactive : 1;         // DWORD 0
               u32 core_lpcism_done : 1;          // DWORD 0
               u32 bus_num : 8;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_LPC_COMMAND_CSR, *PPCICFG_LPC_COMMAND_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_COMMAND_CSR, sizeof (PCICFG_LPC_COMMAND_CSR) == 4);

   #else
      typedef struct _PCICFG_LPC_COMMAND_CSR {
         u32 be : 4;                              // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 req : 1;                             // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 reg : 1;                             // DWORD 0
         u32 abort : 1;                           // DWORD 0
         u32 rst : 1;                             // DWORD 0
         u32 core_d3_lpcism_state : 5;            // DWORD 0
         u32 core_d3_lpcismactive : 1;            // DWORD 0
         u32 core_d3_lpcism_done : 1;             // DWORD 0
         u32 core_lpcism_state : 5;               // DWORD 0
         u32 core_lpcismactive : 1;               // DWORD 0
         u32 core_lpcism_done : 1;                // DWORD 0
         u32 bus_num : 8;                         // DWORD 0
      } SG_PACK PCICFG_LPC_COMMAND_CSR, *PPCICFG_LPC_COMMAND_CSR;

      typedef union _PCICFG_LPC_COMMAND_CSR_UNION {
         PCICFG_LPC_COMMAND_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_LPC_COMMAND_CSR_UNION, *PPCICFG_LPC_COMMAND_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_LPC_COMMAND_CSR_UNION, sizeof (PCICFG_LPC_COMMAND_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Scratchpad Register (for software use).
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_SCRATCHPAD_CSR {
         union {
            struct { 
               u32 scratchpad;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_SCRATCHPAD_CSR, *PPCICFG_SCRATCHPAD_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_SCRATCHPAD_CSR, sizeof (PCICFG_SCRATCHPAD_CSR) == 4);

   #else
      typedef struct _PCICFG_SCRATCHPAD_CSR {
         u32 scratchpad;                          // DWORD 0
      } SG_PACK PCICFG_SCRATCHPAD_CSR, *PPCICFG_SCRATCHPAD_CSR;

      typedef union _PCICFG_SCRATCHPAD_CSR_UNION {
         PCICFG_SCRATCHPAD_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_SCRATCHPAD_CSR_UNION, *PPCICFG_SCRATCHPAD_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_SCRATCHPAD_CSR_UNION, sizeof (PCICFG_SCRATCHPAD_CSR_UNION) == 4);
   #endif


#else
   // Scratchpad Register (for software use).
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_SCRATCHPAD_CSR {
         union {
            struct { 
               u32 scratchpad;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_SCRATCHPAD_CSR, *PPCICFG_SCRATCHPAD_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_SCRATCHPAD_CSR, sizeof (PCICFG_SCRATCHPAD_CSR) == 4);

   #else
      typedef struct _PCICFG_SCRATCHPAD_CSR {
         u32 scratchpad;                          // DWORD 0
      } SG_PACK PCICFG_SCRATCHPAD_CSR, *PPCICFG_SCRATCHPAD_CSR;

      typedef union _PCICFG_SCRATCHPAD_CSR_UNION {
         PCICFG_SCRATCHPAD_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_SCRATCHPAD_CSR_UNION, *PPCICFG_SCRATCHPAD_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_SCRATCHPAD_CSR_UNION, sizeof (PCICFG_SCRATCHPAD_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_CAP_CSR {
         union {
            struct { 
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 devport : 4;                   // DWORD 0
               u32 capver : 4;                    // DWORD 0
               u32 nextcap : 8;                   // DWORD 0
               u32 capid : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_CAP_CSR, *PPCICFG_PCIE_CAP_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CAP_CSR, sizeof (PCICFG_PCIE_CAP_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_CAP_CSR {
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 devport : 4;                         // DWORD 0
         u32 capver : 4;                          // DWORD 0
         u32 nextcap : 8;                         // DWORD 0
         u32 capid : 8;                           // DWORD 0
      } SG_PACK PCICFG_PCIE_CAP_CSR, *PPCICFG_PCIE_CAP_CSR;

      typedef union _PCICFG_PCIE_CAP_CSR_UNION {
         PCICFG_PCIE_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_CAP_CSR_UNION, *PPCICFG_PCIE_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CAP_CSR_UNION, sizeof (PCICFG_PCIE_CAP_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_CAP_CSR {
         union {
            struct { 
               u32 capid : 8;                     // DWORD 0
               u32 nextcap : 8;                   // DWORD 0
               u32 capver : 4;                    // DWORD 0
               u32 devport : 4;                   // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_CAP_CSR, *PPCICFG_PCIE_CAP_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CAP_CSR, sizeof (PCICFG_PCIE_CAP_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_CAP_CSR {
         u32 capid : 8;                           // DWORD 0
         u32 nextcap : 8;                         // DWORD 0
         u32 capver : 4;                          // DWORD 0
         u32 devport : 4;                         // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
      } SG_PACK PCICFG_PCIE_CAP_CSR, *PPCICFG_PCIE_CAP_CSR;

      typedef union _PCICFG_PCIE_CAP_CSR_UNION {
         PCICFG_PCIE_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_CAP_CSR_UNION, *PPCICFG_PCIE_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CAP_CSR_UNION, sizeof (PCICFG_PCIE_CAP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Device Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_DEVCAP_CSR {
         union {
            struct { 
               u32 rsvd3 : 3;                     // DWORD 0
               u32 FLR : 1;                       // DWORD 0
               u32 pwr_scale : 2;                 // DWORD 0
               u32 pwr_value : 8;                 // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 ROLE_ERR_REP : 1;              // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 l1_lat : 3;                    // DWORD 0
               u32 lo_lat : 3;                    // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 payload : 3;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_DEVCAP_CSR, *PPCICFG_PCIE_DEVCAP_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_DEVCAP_CSR, sizeof (PCICFG_PCIE_DEVCAP_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_DEVCAP_CSR {
         u32 rsvd3 : 3;                           // DWORD 0
         u32 FLR : 1;                             // DWORD 0
         u32 pwr_scale : 2;                       // DWORD 0
         u32 pwr_value : 8;                       // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 ROLE_ERR_REP : 1;                    // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 l1_lat : 3;                          // DWORD 0
         u32 lo_lat : 3;                          // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 payload : 3;                         // DWORD 0
      } SG_PACK PCICFG_PCIE_DEVCAP_CSR, *PPCICFG_PCIE_DEVCAP_CSR;

      typedef union _PCICFG_PCIE_DEVCAP_CSR_UNION {
         PCICFG_PCIE_DEVCAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_DEVCAP_CSR_UNION, *PPCICFG_PCIE_DEVCAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_DEVCAP_CSR_UNION, sizeof (PCICFG_PCIE_DEVCAP_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Device Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_DEVCAP_CSR {
         union {
            struct { 
               u32 payload : 3;                   // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 lo_lat : 3;                    // DWORD 0
               u32 l1_lat : 3;                    // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 ROLE_ERR_REP : 1;              // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 pwr_value : 8;                 // DWORD 0
               u32 pwr_scale : 2;                 // DWORD 0
               u32 FLR : 1;                       // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_DEVCAP_CSR, *PPCICFG_PCIE_DEVCAP_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_DEVCAP_CSR, sizeof (PCICFG_PCIE_DEVCAP_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_DEVCAP_CSR {
         u32 payload : 3;                         // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 lo_lat : 3;                          // DWORD 0
         u32 l1_lat : 3;                          // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 ROLE_ERR_REP : 1;                    // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 pwr_value : 8;                       // DWORD 0
         u32 pwr_scale : 2;                       // DWORD 0
         u32 FLR : 1;                             // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK PCICFG_PCIE_DEVCAP_CSR, *PPCICFG_PCIE_DEVCAP_CSR;

      typedef union _PCICFG_PCIE_DEVCAP_CSR_UNION {
         PCICFG_PCIE_DEVCAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_DEVCAP_CSR_UNION, *PPCICFG_PCIE_DEVCAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_DEVCAP_CSR_UNION, sizeof (PCICFG_PCIE_DEVCAP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Device Control/Status Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_CONTROL_STATUS_CSR {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 TransPending : 1;              // DWORD 0
               u32 AuxPwrDetect : 1;              // DWORD 0
               u32 UnsuppReqDetect : 1;           // DWORD 0
               u32 FatalErrDetect : 1;            // DWORD 0
               u32 NonFatalErrDetect : 1;         // DWORD 0
               u32 CorrErrDetect : 1;             // DWORD 0
               u32 INITIATE_FLR : 1;              // DWORD 0
               u32 Max_Read_Req_Size : 3;         // DWORD 0
               u32 EnableNoSnoop : 1;             // DWORD 0
               u32 AuxPwrPMEnable : 1;            // DWORD 0
               u32 PhantomFnEnable : 1;           // DWORD 0
               u32 ExtendTagFieldEnable : 1;      // DWORD 0
               u32 Max_Payload_Size : 3;          // DWORD 0
               u32 EnableRelaxOrder : 1;          // DWORD 0
               u32 UnsuppReqReportEn : 1;         // DWORD 0
               u32 FatalErrReportEn : 1;          // DWORD 0
               u32 NonFatalErrReportEn : 1;       // DWORD 0
               u32 CorrErrReportEn : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS_CSR, *PPCICFG_PCIE_CONTROL_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CONTROL_STATUS_CSR, sizeof (PCICFG_PCIE_CONTROL_STATUS_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_CONTROL_STATUS_CSR {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 TransPending : 1;                    // DWORD 0
         u32 AuxPwrDetect : 1;                    // DWORD 0
         u32 UnsuppReqDetect : 1;                 // DWORD 0
         u32 FatalErrDetect : 1;                  // DWORD 0
         u32 NonFatalErrDetect : 1;               // DWORD 0
         u32 CorrErrDetect : 1;                   // DWORD 0
         u32 INITIATE_FLR : 1;                    // DWORD 0
         u32 Max_Read_Req_Size : 3;               // DWORD 0
         u32 EnableNoSnoop : 1;                   // DWORD 0
         u32 AuxPwrPMEnable : 1;                  // DWORD 0
         u32 PhantomFnEnable : 1;                 // DWORD 0
         u32 ExtendTagFieldEnable : 1;            // DWORD 0
         u32 Max_Payload_Size : 3;                // DWORD 0
         u32 EnableRelaxOrder : 1;                // DWORD 0
         u32 UnsuppReqReportEn : 1;               // DWORD 0
         u32 FatalErrReportEn : 1;                // DWORD 0
         u32 NonFatalErrReportEn : 1;             // DWORD 0
         u32 CorrErrReportEn : 1;                 // DWORD 0
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS_CSR, *PPCICFG_PCIE_CONTROL_STATUS_CSR;

      typedef union _PCICFG_PCIE_CONTROL_STATUS_CSR_UNION {
         PCICFG_PCIE_CONTROL_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS_CSR_UNION, *PPCICFG_PCIE_CONTROL_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CONTROL_STATUS_CSR_UNION, sizeof (PCICFG_PCIE_CONTROL_STATUS_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Device Control/Status Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_CONTROL_STATUS_CSR {
         union {
            struct { 
               u32 CorrErrReportEn : 1;           // DWORD 0
               u32 NonFatalErrReportEn : 1;       // DWORD 0
               u32 FatalErrReportEn : 1;          // DWORD 0
               u32 UnsuppReqReportEn : 1;         // DWORD 0
               u32 EnableRelaxOrder : 1;          // DWORD 0
               u32 Max_Payload_Size : 3;          // DWORD 0
               u32 ExtendTagFieldEnable : 1;      // DWORD 0
               u32 PhantomFnEnable : 1;           // DWORD 0
               u32 AuxPwrPMEnable : 1;            // DWORD 0
               u32 EnableNoSnoop : 1;             // DWORD 0
               u32 Max_Read_Req_Size : 3;         // DWORD 0
               u32 INITIATE_FLR : 1;              // DWORD 0
               u32 CorrErrDetect : 1;             // DWORD 0
               u32 NonFatalErrDetect : 1;         // DWORD 0
               u32 FatalErrDetect : 1;            // DWORD 0
               u32 UnsuppReqDetect : 1;           // DWORD 0
               u32 AuxPwrDetect : 1;              // DWORD 0
               u32 TransPending : 1;              // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS_CSR, *PPCICFG_PCIE_CONTROL_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CONTROL_STATUS_CSR, sizeof (PCICFG_PCIE_CONTROL_STATUS_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_CONTROL_STATUS_CSR {
         u32 CorrErrReportEn : 1;                 // DWORD 0
         u32 NonFatalErrReportEn : 1;             // DWORD 0
         u32 FatalErrReportEn : 1;                // DWORD 0
         u32 UnsuppReqReportEn : 1;               // DWORD 0
         u32 EnableRelaxOrder : 1;                // DWORD 0
         u32 Max_Payload_Size : 3;                // DWORD 0
         u32 ExtendTagFieldEnable : 1;            // DWORD 0
         u32 PhantomFnEnable : 1;                 // DWORD 0
         u32 AuxPwrPMEnable : 1;                  // DWORD 0
         u32 EnableNoSnoop : 1;                   // DWORD 0
         u32 Max_Read_Req_Size : 3;               // DWORD 0
         u32 INITIATE_FLR : 1;                    // DWORD 0
         u32 CorrErrDetect : 1;                   // DWORD 0
         u32 NonFatalErrDetect : 1;               // DWORD 0
         u32 FatalErrDetect : 1;                  // DWORD 0
         u32 UnsuppReqDetect : 1;                 // DWORD 0
         u32 AuxPwrDetect : 1;                    // DWORD 0
         u32 TransPending : 1;                    // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS_CSR, *PPCICFG_PCIE_CONTROL_STATUS_CSR;

      typedef union _PCICFG_PCIE_CONTROL_STATUS_CSR_UNION {
         PCICFG_PCIE_CONTROL_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS_CSR_UNION, *PPCICFG_PCIE_CONTROL_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CONTROL_STATUS_CSR_UNION, sizeof (PCICFG_PCIE_CONTROL_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Link Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_LINK_CAP_CSR {
         union {
            struct { 
               u32 PortNum : 8;                   // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 L1ExitLat : 3;                 // DWORD 0
               u32 L0sExitLat : 3;                // DWORD 0
               u32 ASPMSupport : 2;               // DWORD 0
               u32 MaxLinkWidth : 6;              // DWORD 0
               u32 MaxLinkSpeed : 4;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_LINK_CAP_CSR, *PPCICFG_PCIE_LINK_CAP_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_CAP_CSR, sizeof (PCICFG_PCIE_LINK_CAP_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_LINK_CAP_CSR {
         u32 PortNum : 8;                         // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 L1ExitLat : 3;                       // DWORD 0
         u32 L0sExitLat : 3;                      // DWORD 0
         u32 ASPMSupport : 2;                     // DWORD 0
         u32 MaxLinkWidth : 6;                    // DWORD 0
         u32 MaxLinkSpeed : 4;                    // DWORD 0
      } SG_PACK PCICFG_PCIE_LINK_CAP_CSR, *PPCICFG_PCIE_LINK_CAP_CSR;

      typedef union _PCICFG_PCIE_LINK_CAP_CSR_UNION {
         PCICFG_PCIE_LINK_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_LINK_CAP_CSR_UNION, *PPCICFG_PCIE_LINK_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_CAP_CSR_UNION, sizeof (PCICFG_PCIE_LINK_CAP_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Link Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_LINK_CAP_CSR {
         union {
            struct { 
               u32 MaxLinkSpeed : 4;              // DWORD 0
               u32 MaxLinkWidth : 6;              // DWORD 0
               u32 ASPMSupport : 2;               // DWORD 0
               u32 L0sExitLat : 3;                // DWORD 0
               u32 L1ExitLat : 3;                 // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 PortNum : 8;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_LINK_CAP_CSR, *PPCICFG_PCIE_LINK_CAP_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_CAP_CSR, sizeof (PCICFG_PCIE_LINK_CAP_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_LINK_CAP_CSR {
         u32 MaxLinkSpeed : 4;                    // DWORD 0
         u32 MaxLinkWidth : 6;                    // DWORD 0
         u32 ASPMSupport : 2;                     // DWORD 0
         u32 L0sExitLat : 3;                      // DWORD 0
         u32 L1ExitLat : 3;                       // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 PortNum : 8;                         // DWORD 0
      } SG_PACK PCICFG_PCIE_LINK_CAP_CSR, *PPCICFG_PCIE_LINK_CAP_CSR;

      typedef union _PCICFG_PCIE_LINK_CAP_CSR_UNION {
         PCICFG_PCIE_LINK_CAP_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_LINK_CAP_CSR_UNION, *PPCICFG_PCIE_LINK_CAP_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_CAP_CSR_UNION, sizeof (PCICFG_PCIE_LINK_CAP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Link Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_LINK_STATUS_CSR {
         union {
            struct { 
               u32 rsvd3 : 3;                     // DWORD 0
               u32 SlotClkConfig : 1;             // DWORD 0
               u32 LinkTrain : 1;                 // DWORD 0
               u32 LinkTrainErr : 1;              // DWORD 0
               u32 NegLinkWidth : 6;              // DWORD 0
               u32 LinkSpeed : 4;                 // DWORD 0
               u32 rsvd2 : 6;                     // DWORD 0
               u32 hw_autonomous_width_dis : 1;   // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ExtendSync : 1;                // DWORD 0
               u32 CommonClkConfig : 1;           // DWORD 0
               u32 RetrainLink : 1;               // DWORD 0
               u32 LinkDisable : 1;               // DWORD 0
               u32 ReadCmplBndry : 1;             // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ASPMCtl : 2;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_LINK_STATUS_CSR, *PPCICFG_PCIE_LINK_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS_CSR, sizeof (PCICFG_PCIE_LINK_STATUS_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_LINK_STATUS_CSR {
         u32 rsvd3 : 3;                           // DWORD 0
         u32 SlotClkConfig : 1;                   // DWORD 0
         u32 LinkTrain : 1;                       // DWORD 0
         u32 LinkTrainErr : 1;                    // DWORD 0
         u32 NegLinkWidth : 6;                    // DWORD 0
         u32 LinkSpeed : 4;                       // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 hw_autonomous_width_dis : 1;         // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ExtendSync : 1;                      // DWORD 0
         u32 CommonClkConfig : 1;                 // DWORD 0
         u32 RetrainLink : 1;                     // DWORD 0
         u32 LinkDisable : 1;                     // DWORD 0
         u32 ReadCmplBndry : 1;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ASPMCtl : 2;                         // DWORD 0
      } SG_PACK PCICFG_PCIE_LINK_STATUS_CSR, *PPCICFG_PCIE_LINK_STATUS_CSR;

      typedef union _PCICFG_PCIE_LINK_STATUS_CSR_UNION {
         PCICFG_PCIE_LINK_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_LINK_STATUS_CSR_UNION, *PPCICFG_PCIE_LINK_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS_CSR_UNION, sizeof (PCICFG_PCIE_LINK_STATUS_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Link Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_LINK_STATUS_CSR {
         union {
            struct { 
               u32 ASPMCtl : 2;                   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ReadCmplBndry : 1;             // DWORD 0
               u32 LinkDisable : 1;               // DWORD 0
               u32 RetrainLink : 1;               // DWORD 0
               u32 CommonClkConfig : 1;           // DWORD 0
               u32 ExtendSync : 1;                // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 hw_autonomous_width_dis : 1;   // DWORD 0
               u32 rsvd2 : 6;                     // DWORD 0
               u32 LinkSpeed : 4;                 // DWORD 0
               u32 NegLinkWidth : 6;              // DWORD 0
               u32 LinkTrainErr : 1;              // DWORD 0
               u32 LinkTrain : 1;                 // DWORD 0
               u32 SlotClkConfig : 1;             // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_LINK_STATUS_CSR, *PPCICFG_PCIE_LINK_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS_CSR, sizeof (PCICFG_PCIE_LINK_STATUS_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_LINK_STATUS_CSR {
         u32 ASPMCtl : 2;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ReadCmplBndry : 1;                   // DWORD 0
         u32 LinkDisable : 1;                     // DWORD 0
         u32 RetrainLink : 1;                     // DWORD 0
         u32 CommonClkConfig : 1;                 // DWORD 0
         u32 ExtendSync : 1;                      // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 hw_autonomous_width_dis : 1;         // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 LinkSpeed : 4;                       // DWORD 0
         u32 NegLinkWidth : 6;                    // DWORD 0
         u32 LinkTrainErr : 1;                    // DWORD 0
         u32 LinkTrain : 1;                       // DWORD 0
         u32 SlotClkConfig : 1;                   // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK PCICFG_PCIE_LINK_STATUS_CSR, *PPCICFG_PCIE_LINK_STATUS_CSR;

      typedef union _PCICFG_PCIE_LINK_STATUS_CSR_UNION {
         PCICFG_PCIE_LINK_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_LINK_STATUS_CSR_UNION, *PPCICFG_PCIE_LINK_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS_CSR_UNION, sizeof (PCICFG_PCIE_LINK_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Device Capabilities 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_DEVCAP2_CSR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 cmpl_tmout_dis_sup : 1;        // DWORD 0
               u32 cmpl_tmout_sup : 4;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_DEVCAP2_CSR, *PPCICFG_PCIE_DEVCAP2_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_DEVCAP2_CSR, sizeof (PCICFG_PCIE_DEVCAP2_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_DEVCAP2_CSR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 cmpl_tmout_dis_sup : 1;              // DWORD 0
         u32 cmpl_tmout_sup : 4;                  // DWORD 0
      } SG_PACK PCICFG_PCIE_DEVCAP2_CSR, *PPCICFG_PCIE_DEVCAP2_CSR;

      typedef union _PCICFG_PCIE_DEVCAP2_CSR_UNION {
         PCICFG_PCIE_DEVCAP2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_DEVCAP2_CSR_UNION, *PPCICFG_PCIE_DEVCAP2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_DEVCAP2_CSR_UNION, sizeof (PCICFG_PCIE_DEVCAP2_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Device Capabilities 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_DEVCAP2_CSR {
         union {
            struct { 
               u32 cmpl_tmout_sup : 4;            // DWORD 0
               u32 cmpl_tmout_dis_sup : 1;        // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_DEVCAP2_CSR, *PPCICFG_PCIE_DEVCAP2_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_DEVCAP2_CSR, sizeof (PCICFG_PCIE_DEVCAP2_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_DEVCAP2_CSR {
         u32 cmpl_tmout_sup : 4;                  // DWORD 0
         u32 cmpl_tmout_dis_sup : 1;              // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK PCICFG_PCIE_DEVCAP2_CSR, *PPCICFG_PCIE_DEVCAP2_CSR;

      typedef union _PCICFG_PCIE_DEVCAP2_CSR_UNION {
         PCICFG_PCIE_DEVCAP2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_DEVCAP2_CSR_UNION, *PPCICFG_PCIE_DEVCAP2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_DEVCAP2_CSR_UNION, sizeof (PCICFG_PCIE_DEVCAP2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Device Capabilities 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_CONTROL_STATUS2_CSR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 cmpl_tmout_dis_sup : 1;        // DWORD 0
               u32 cmpl_tmout_sup : 4;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS2_CSR, *PPCICFG_PCIE_CONTROL_STATUS2_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CONTROL_STATUS2_CSR, sizeof (PCICFG_PCIE_CONTROL_STATUS2_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_CONTROL_STATUS2_CSR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 cmpl_tmout_dis_sup : 1;              // DWORD 0
         u32 cmpl_tmout_sup : 4;                  // DWORD 0
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS2_CSR, *PPCICFG_PCIE_CONTROL_STATUS2_CSR;

      typedef union _PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION {
         PCICFG_PCIE_CONTROL_STATUS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION, *PPCICFG_PCIE_CONTROL_STATUS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION, sizeof (PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Device Capabilities 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_CONTROL_STATUS2_CSR {
         union {
            struct { 
               u32 cmpl_tmout_sup : 4;            // DWORD 0
               u32 cmpl_tmout_dis_sup : 1;        // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS2_CSR, *PPCICFG_PCIE_CONTROL_STATUS2_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CONTROL_STATUS2_CSR, sizeof (PCICFG_PCIE_CONTROL_STATUS2_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_CONTROL_STATUS2_CSR {
         u32 cmpl_tmout_sup : 4;                  // DWORD 0
         u32 cmpl_tmout_dis_sup : 1;              // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS2_CSR, *PPCICFG_PCIE_CONTROL_STATUS2_CSR;

      typedef union _PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION {
         PCICFG_PCIE_CONTROL_STATUS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION, *PPCICFG_PCIE_CONTROL_STATUS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION, sizeof (PCICFG_PCIE_CONTROL_STATUS2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Link Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_LINK_CAP2_CSR {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_LINK_CAP2_CSR, *PPCICFG_PCIE_LINK_CAP2_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_CAP2_CSR, sizeof (PCICFG_PCIE_LINK_CAP2_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_LINK_CAP2_CSR {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK PCICFG_PCIE_LINK_CAP2_CSR, *PPCICFG_PCIE_LINK_CAP2_CSR;

      typedef union _PCICFG_PCIE_LINK_CAP2_CSR_UNION {
         PCICFG_PCIE_LINK_CAP2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_LINK_CAP2_CSR_UNION, *PPCICFG_PCIE_LINK_CAP2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_CAP2_CSR_UNION, sizeof (PCICFG_PCIE_LINK_CAP2_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Link Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_LINK_CAP2_CSR {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_LINK_CAP2_CSR, *PPCICFG_PCIE_LINK_CAP2_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_CAP2_CSR, sizeof (PCICFG_PCIE_LINK_CAP2_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_LINK_CAP2_CSR {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK PCICFG_PCIE_LINK_CAP2_CSR, *PPCICFG_PCIE_LINK_CAP2_CSR;

      typedef union _PCICFG_PCIE_LINK_CAP2_CSR_UNION {
         PCICFG_PCIE_LINK_CAP2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_LINK_CAP2_CSR_UNION, *PPCICFG_PCIE_LINK_CAP2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_CAP2_CSR_UNION, sizeof (PCICFG_PCIE_LINK_CAP2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Link Status 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_LINK_STATUS2_CSR {
         union {
            struct { 
               u32 rsvd2 : 15;                    // DWORD 0
               u32 current_de_emphasis : 1;       // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 compliance_de_emphasis : 1;    // DWORD 0
               u32 compliance_SOS : 1;            // DWORD 0
               u32 enter_mod_compliance : 1;      // DWORD 0
               u32 transmit_margin : 3;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 hw_autonomous_speed_dis : 1;   // DWORD 0
               u32 enter_compliance : 1;          // DWORD 0
               u32 link_speed : 4;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR, *PPCICFG_PCIE_LINK_STATUS2_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS2_CSR, sizeof (PCICFG_PCIE_LINK_STATUS2_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_LINK_STATUS2_CSR {
         u32 rsvd2 : 15;                          // DWORD 0
         u32 current_de_emphasis : 1;             // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 compliance_de_emphasis : 1;          // DWORD 0
         u32 compliance_SOS : 1;                  // DWORD 0
         u32 enter_mod_compliance : 1;            // DWORD 0
         u32 transmit_margin : 3;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 hw_autonomous_speed_dis : 1;         // DWORD 0
         u32 enter_compliance : 1;                // DWORD 0
         u32 link_speed : 4;                      // DWORD 0
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR, *PPCICFG_PCIE_LINK_STATUS2_CSR;

      typedef union _PCICFG_PCIE_LINK_STATUS2_CSR_UNION {
         PCICFG_PCIE_LINK_STATUS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR_UNION, *PPCICFG_PCIE_LINK_STATUS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS2_CSR_UNION, sizeof (PCICFG_PCIE_LINK_STATUS2_CSR_UNION) == 4);
   #endif


#else
   // PCI Express Link Status 2 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_LINK_STATUS2_CSR {
         union {
            struct { 
               u32 link_speed : 4;                // DWORD 0
               u32 enter_compliance : 1;          // DWORD 0
               u32 hw_autonomous_speed_dis : 1;   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 transmit_margin : 3;           // DWORD 0
               u32 enter_mod_compliance : 1;      // DWORD 0
               u32 compliance_SOS : 1;            // DWORD 0
               u32 compliance_de_emphasis : 1;    // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 current_de_emphasis : 1;       // DWORD 0
               u32 rsvd2 : 15;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR, *PPCICFG_PCIE_LINK_STATUS2_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS2_CSR, sizeof (PCICFG_PCIE_LINK_STATUS2_CSR) == 4);

   #else
      typedef struct _PCICFG_PCIE_LINK_STATUS2_CSR {
         u32 link_speed : 4;                      // DWORD 0
         u32 enter_compliance : 1;                // DWORD 0
         u32 hw_autonomous_speed_dis : 1;         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 transmit_margin : 3;                 // DWORD 0
         u32 enter_mod_compliance : 1;            // DWORD 0
         u32 compliance_SOS : 1;                  // DWORD 0
         u32 compliance_de_emphasis : 1;          // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 current_de_emphasis : 1;             // DWORD 0
         u32 rsvd2 : 15;                          // DWORD 0
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR, *PPCICFG_PCIE_LINK_STATUS2_CSR;

      typedef union _PCICFG_PCIE_LINK_STATUS2_CSR_UNION {
         PCICFG_PCIE_LINK_STATUS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR_UNION, *PPCICFG_PCIE_LINK_STATUS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS2_CSR_UNION, sizeof (PCICFG_PCIE_LINK_STATUS2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Link Status 2 Register. The Function F1 has all zeros.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_LINK_STATUS2_CSR_F1 {
         union {
            struct { 
               u32 rsvd1 : 15;                    // DWORD 0
               u32 current_de_emphasis : 1;       // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR_F1, *PPCICFG_PCIE_LINK_STATUS2_CSR_F1;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS2_CSR_F1, sizeof (PCICFG_PCIE_LINK_STATUS2_CSR_F1) == 4);

   #else
      typedef struct _PCICFG_PCIE_LINK_STATUS2_CSR_F1 {
         u32 rsvd1 : 15;                          // DWORD 0
         u32 current_de_emphasis : 1;             // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR_F1, *PPCICFG_PCIE_LINK_STATUS2_CSR_F1;

      typedef union _PCICFG_PCIE_LINK_STATUS2_CSR_F1_UNION {
         PCICFG_PCIE_LINK_STATUS2_CSR_F1 bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR_F1_UNION, *PPCICFG_PCIE_LINK_STATUS2_CSR_F1_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS2_CSR_F1_UNION, sizeof (PCICFG_PCIE_LINK_STATUS2_CSR_F1_UNION) == 4);
   #endif


#else
   // PCI Express Link Status 2 Register. The Function F1 has all zeros.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PCIE_LINK_STATUS2_CSR_F1 {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 current_de_emphasis : 1;       // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR_F1, *PPCICFG_PCIE_LINK_STATUS2_CSR_F1;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS2_CSR_F1, sizeof (PCICFG_PCIE_LINK_STATUS2_CSR_F1) == 4);

   #else
      typedef struct _PCICFG_PCIE_LINK_STATUS2_CSR_F1 {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 current_de_emphasis : 1;             // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR_F1, *PPCICFG_PCIE_LINK_STATUS2_CSR_F1;

      typedef union _PCICFG_PCIE_LINK_STATUS2_CSR_F1_UNION {
         PCICFG_PCIE_LINK_STATUS2_CSR_F1 bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PCIE_LINK_STATUS2_CSR_F1_UNION, *PPCICFG_PCIE_LINK_STATUS2_CSR_F1_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PCIE_LINK_STATUS2_CSR_F1_UNION, sizeof (PCICFG_PCIE_LINK_STATUS2_CSR_F1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register always need to return zeros. This space can't be used for any other
   // purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_RETURN_ZEROS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_RETURN_ZEROS, *PPCICFG_RETURN_ZEROS;

      SG_C_ASSERT(__sizeof__PCICFG_RETURN_ZEROS, sizeof (PCICFG_RETURN_ZEROS) == 4);

   #else
      typedef struct _PCICFG_RETURN_ZEROS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK PCICFG_RETURN_ZEROS, *PPCICFG_RETURN_ZEROS;

      typedef union _PCICFG_RETURN_ZEROS_UNION {
         PCICFG_RETURN_ZEROS bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_RETURN_ZEROS_UNION, *PPCICFG_RETURN_ZEROS_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_RETURN_ZEROS_UNION, sizeof (PCICFG_RETURN_ZEROS_UNION) == 4);
   #endif


#else
   // This register always need to return zeros. This space can't be used for any other
   // purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_RETURN_ZEROS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_RETURN_ZEROS, *PPCICFG_RETURN_ZEROS;

      SG_C_ASSERT(__sizeof__PCICFG_RETURN_ZEROS, sizeof (PCICFG_RETURN_ZEROS) == 4);

   #else
      typedef struct _PCICFG_RETURN_ZEROS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK PCICFG_RETURN_ZEROS, *PPCICFG_RETURN_ZEROS;

      typedef union _PCICFG_RETURN_ZEROS_UNION {
         PCICFG_RETURN_ZEROS bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_RETURN_ZEROS_UNION, *PPCICFG_RETURN_ZEROS_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_RETURN_ZEROS_UNION, sizeof (PCICFG_RETURN_ZEROS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express MSI-X Configuration Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_CSR {
         union {
            struct { 
               u32 en : 1;                        // DWORD 0
               u32 funcmask : 1;                  // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 tablesize : 11;                // DWORD 0
               u32 nextptr : 8;                   // DWORD 0
               u32 capid : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_CSR, *PPCICFG_MSIX_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_CSR, sizeof (PCICFG_MSIX_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_CSR {
         u32 en : 1;                              // DWORD 0
         u32 funcmask : 1;                        // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 tablesize : 11;                      // DWORD 0
         u32 nextptr : 8;                         // DWORD 0
         u32 capid : 8;                           // DWORD 0
      } SG_PACK PCICFG_MSIX_CSR, *PPCICFG_MSIX_CSR;

      typedef union _PCICFG_MSIX_CSR_UNION {
         PCICFG_MSIX_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_CSR_UNION, *PPCICFG_MSIX_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_CSR_UNION, sizeof (PCICFG_MSIX_CSR_UNION) == 4);
   #endif


#else
   // PCI Express MSI-X Configuration Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_CSR {
         union {
            struct { 
               u32 capid : 8;                     // DWORD 0
               u32 nextptr : 8;                   // DWORD 0
               u32 tablesize : 11;                // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 funcmask : 1;                  // DWORD 0
               u32 en : 1;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_CSR, *PPCICFG_MSIX_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_CSR, sizeof (PCICFG_MSIX_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_CSR {
         u32 capid : 8;                           // DWORD 0
         u32 nextptr : 8;                         // DWORD 0
         u32 tablesize : 11;                      // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 funcmask : 1;                        // DWORD 0
         u32 en : 1;                              // DWORD 0
      } SG_PACK PCICFG_MSIX_CSR, *PPCICFG_MSIX_CSR;

      typedef union _PCICFG_MSIX_CSR_UNION {
         PCICFG_MSIX_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_CSR_UNION, *PPCICFG_MSIX_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_CSR_UNION, sizeof (PCICFG_MSIX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MSI-X Table Offset Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_TABLE_CSR {
         union {
            struct { 
               u32 offset : 29;                   // DWORD 0
               u32 tablebir : 3;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_TABLE_CSR, *PPCICFG_MSIX_TABLE_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_TABLE_CSR, sizeof (PCICFG_MSIX_TABLE_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_TABLE_CSR {
         u32 offset : 29;                         // DWORD 0
         u32 tablebir : 3;                        // DWORD 0
      } SG_PACK PCICFG_MSIX_TABLE_CSR, *PPCICFG_MSIX_TABLE_CSR;

      typedef union _PCICFG_MSIX_TABLE_CSR_UNION {
         PCICFG_MSIX_TABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_TABLE_CSR_UNION, *PPCICFG_MSIX_TABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_TABLE_CSR_UNION, sizeof (PCICFG_MSIX_TABLE_CSR_UNION) == 4);
   #endif


#else
   // MSI-X Table Offset Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_TABLE_CSR {
         union {
            struct { 
               u32 tablebir : 3;                  // DWORD 0
               u32 offset : 29;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_TABLE_CSR, *PPCICFG_MSIX_TABLE_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_TABLE_CSR, sizeof (PCICFG_MSIX_TABLE_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_TABLE_CSR {
         u32 tablebir : 3;                        // DWORD 0
         u32 offset : 29;                         // DWORD 0
      } SG_PACK PCICFG_MSIX_TABLE_CSR, *PPCICFG_MSIX_TABLE_CSR;

      typedef union _PCICFG_MSIX_TABLE_CSR_UNION {
         PCICFG_MSIX_TABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_TABLE_CSR_UNION, *PPCICFG_MSIX_TABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_TABLE_CSR_UNION, sizeof (PCICFG_MSIX_TABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MSI-X PBA Offset Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_PBA_CSR {
         union {
            struct { 
               u32 offset : 29;                   // DWORD 0
               u32 pbabir : 3;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_PBA_CSR, *PPCICFG_MSIX_PBA_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_PBA_CSR, sizeof (PCICFG_MSIX_PBA_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_PBA_CSR {
         u32 offset : 29;                         // DWORD 0
         u32 pbabir : 3;                          // DWORD 0
      } SG_PACK PCICFG_MSIX_PBA_CSR, *PPCICFG_MSIX_PBA_CSR;

      typedef union _PCICFG_MSIX_PBA_CSR_UNION {
         PCICFG_MSIX_PBA_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_PBA_CSR_UNION, *PPCICFG_MSIX_PBA_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_PBA_CSR_UNION, sizeof (PCICFG_MSIX_PBA_CSR_UNION) == 4);
   #endif


#else
   // MSI-X PBA Offset Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_PBA_CSR {
         union {
            struct { 
               u32 pbabir : 3;                    // DWORD 0
               u32 offset : 29;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_PBA_CSR, *PPCICFG_MSIX_PBA_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_PBA_CSR, sizeof (PCICFG_MSIX_PBA_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_PBA_CSR {
         u32 pbabir : 3;                          // DWORD 0
         u32 offset : 29;                         // DWORD 0
      } SG_PACK PCICFG_MSIX_PBA_CSR, *PPCICFG_MSIX_PBA_CSR;

      typedef union _PCICFG_MSIX_PBA_CSR_UNION {
         PCICFG_MSIX_PBA_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_PBA_CSR_UNION, *PPCICFG_MSIX_PBA_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_PBA_CSR_UNION, sizeof (PCICFG_MSIX_PBA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express MSI-X Message Vector Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_VECTOR_CONTROL_CSR {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 vector_control : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_VECTOR_CONTROL_CSR, *PPCICFG_MSIX_VECTOR_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_VECTOR_CONTROL_CSR, sizeof (PCICFG_MSIX_VECTOR_CONTROL_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_VECTOR_CONTROL_CSR {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 vector_control : 1;                  // DWORD 0
      } SG_PACK PCICFG_MSIX_VECTOR_CONTROL_CSR, *PPCICFG_MSIX_VECTOR_CONTROL_CSR;

      typedef union _PCICFG_MSIX_VECTOR_CONTROL_CSR_UNION {
         PCICFG_MSIX_VECTOR_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_VECTOR_CONTROL_CSR_UNION, *PPCICFG_MSIX_VECTOR_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_VECTOR_CONTROL_CSR_UNION, sizeof (PCICFG_MSIX_VECTOR_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // PCI Express MSI-X Message Vector Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_VECTOR_CONTROL_CSR {
         union {
            struct { 
               u32 vector_control : 1;            // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_VECTOR_CONTROL_CSR, *PPCICFG_MSIX_VECTOR_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_VECTOR_CONTROL_CSR, sizeof (PCICFG_MSIX_VECTOR_CONTROL_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_VECTOR_CONTROL_CSR {
         u32 vector_control : 1;                  // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK PCICFG_MSIX_VECTOR_CONTROL_CSR, *PPCICFG_MSIX_VECTOR_CONTROL_CSR;

      typedef union _PCICFG_MSIX_VECTOR_CONTROL_CSR_UNION {
         PCICFG_MSIX_VECTOR_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_VECTOR_CONTROL_CSR_UNION, *PPCICFG_MSIX_VECTOR_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_VECTOR_CONTROL_CSR_UNION, sizeof (PCICFG_MSIX_VECTOR_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express MSI-X Message Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_MSG_DATA_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 data : 16;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_MSG_DATA_CSR, *PPCICFG_MSIX_MSG_DATA_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_DATA_CSR, sizeof (PCICFG_MSIX_MSG_DATA_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_MSG_DATA_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 data : 16;                           // DWORD 0
      } SG_PACK PCICFG_MSIX_MSG_DATA_CSR, *PPCICFG_MSIX_MSG_DATA_CSR;

      typedef union _PCICFG_MSIX_MSG_DATA_CSR_UNION {
         PCICFG_MSIX_MSG_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_MSG_DATA_CSR_UNION, *PPCICFG_MSIX_MSG_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_DATA_CSR_UNION, sizeof (PCICFG_MSIX_MSG_DATA_CSR_UNION) == 4);
   #endif


#else
   // PCI Express MSI-X Message Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_MSG_DATA_CSR {
         union {
            struct { 
               u32 data : 16;                     // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_MSG_DATA_CSR, *PPCICFG_MSIX_MSG_DATA_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_DATA_CSR, sizeof (PCICFG_MSIX_MSG_DATA_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_MSG_DATA_CSR {
         u32 data : 16;                           // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK PCICFG_MSIX_MSG_DATA_CSR, *PPCICFG_MSIX_MSG_DATA_CSR;

      typedef union _PCICFG_MSIX_MSG_DATA_CSR_UNION {
         PCICFG_MSIX_MSG_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_MSG_DATA_CSR_UNION, *PPCICFG_MSIX_MSG_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_DATA_CSR_UNION, sizeof (PCICFG_MSIX_MSG_DATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express MSI-X Message Address Register - High Part.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_MSG_ADDR_HI_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_MSG_ADDR_HI_CSR, *PPCICFG_MSIX_MSG_ADDR_HI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_ADDR_HI_CSR, sizeof (PCICFG_MSIX_MSG_ADDR_HI_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_MSG_ADDR_HI_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK PCICFG_MSIX_MSG_ADDR_HI_CSR, *PPCICFG_MSIX_MSG_ADDR_HI_CSR;

      typedef union _PCICFG_MSIX_MSG_ADDR_HI_CSR_UNION {
         PCICFG_MSIX_MSG_ADDR_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_MSG_ADDR_HI_CSR_UNION, *PPCICFG_MSIX_MSG_ADDR_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_ADDR_HI_CSR_UNION, sizeof (PCICFG_MSIX_MSG_ADDR_HI_CSR_UNION) == 4);
   #endif


#else
   // PCI Express MSI-X Message Address Register - High Part.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_MSG_ADDR_HI_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_MSG_ADDR_HI_CSR, *PPCICFG_MSIX_MSG_ADDR_HI_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_ADDR_HI_CSR, sizeof (PCICFG_MSIX_MSG_ADDR_HI_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_MSG_ADDR_HI_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK PCICFG_MSIX_MSG_ADDR_HI_CSR, *PPCICFG_MSIX_MSG_ADDR_HI_CSR;

      typedef union _PCICFG_MSIX_MSG_ADDR_HI_CSR_UNION {
         PCICFG_MSIX_MSG_ADDR_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_MSG_ADDR_HI_CSR_UNION, *PPCICFG_MSIX_MSG_ADDR_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_ADDR_HI_CSR_UNION, sizeof (PCICFG_MSIX_MSG_ADDR_HI_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express MSI-X Message Address Register - Low Part.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_MSG_ADDR_LO_CSR {
         union {
            struct { 
               u32 addr : 30;                     // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_MSG_ADDR_LO_CSR, *PPCICFG_MSIX_MSG_ADDR_LO_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_ADDR_LO_CSR, sizeof (PCICFG_MSIX_MSG_ADDR_LO_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_MSG_ADDR_LO_CSR {
         u32 addr : 30;                           // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK PCICFG_MSIX_MSG_ADDR_LO_CSR, *PPCICFG_MSIX_MSG_ADDR_LO_CSR;

      typedef union _PCICFG_MSIX_MSG_ADDR_LO_CSR_UNION {
         PCICFG_MSIX_MSG_ADDR_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_MSG_ADDR_LO_CSR_UNION, *PPCICFG_MSIX_MSG_ADDR_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_ADDR_LO_CSR_UNION, sizeof (PCICFG_MSIX_MSG_ADDR_LO_CSR_UNION) == 4);
   #endif


#else
   // PCI Express MSI-X Message Address Register - Low Part.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_MSG_ADDR_LO_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 addr : 30;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_MSG_ADDR_LO_CSR, *PPCICFG_MSIX_MSG_ADDR_LO_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_ADDR_LO_CSR, sizeof (PCICFG_MSIX_MSG_ADDR_LO_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_MSG_ADDR_LO_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 addr : 30;                           // DWORD 0
      } SG_PACK PCICFG_MSIX_MSG_ADDR_LO_CSR, *PPCICFG_MSIX_MSG_ADDR_LO_CSR;

      typedef union _PCICFG_MSIX_MSG_ADDR_LO_CSR_UNION {
         PCICFG_MSIX_MSG_ADDR_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_MSG_ADDR_LO_CSR_UNION, *PPCICFG_MSIX_MSG_ADDR_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_MSG_ADDR_LO_CSR_UNION, sizeof (PCICFG_MSIX_MSG_ADDR_LO_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Pending Bits Register for each MSI-X Message
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_PBA_STRUCT_CSR {
         union {
            struct { 
               u32 pba;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_PBA_STRUCT_CSR, *PPCICFG_MSIX_PBA_STRUCT_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_PBA_STRUCT_CSR, sizeof (PCICFG_MSIX_PBA_STRUCT_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_PBA_STRUCT_CSR {
         u32 pba;                                 // DWORD 0
      } SG_PACK PCICFG_MSIX_PBA_STRUCT_CSR, *PPCICFG_MSIX_PBA_STRUCT_CSR;

      typedef union _PCICFG_MSIX_PBA_STRUCT_CSR_UNION {
         PCICFG_MSIX_PBA_STRUCT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_PBA_STRUCT_CSR_UNION, *PPCICFG_MSIX_PBA_STRUCT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_PBA_STRUCT_CSR_UNION, sizeof (PCICFG_MSIX_PBA_STRUCT_CSR_UNION) == 4);
   #endif


#else
   // Pending Bits Register for each MSI-X Message
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_MSIX_PBA_STRUCT_CSR {
         union {
            struct { 
               u32 pba;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_MSIX_PBA_STRUCT_CSR, *PPCICFG_MSIX_PBA_STRUCT_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_PBA_STRUCT_CSR, sizeof (PCICFG_MSIX_PBA_STRUCT_CSR) == 4);

   #else
      typedef struct _PCICFG_MSIX_PBA_STRUCT_CSR {
         u32 pba;                                 // DWORD 0
      } SG_PACK PCICFG_MSIX_PBA_STRUCT_CSR, *PPCICFG_MSIX_PBA_STRUCT_CSR;

      typedef union _PCICFG_MSIX_PBA_STRUCT_CSR_UNION {
         PCICFG_MSIX_PBA_STRUCT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_MSIX_PBA_STRUCT_CSR_UNION, *PPCICFG_MSIX_PBA_STRUCT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_MSIX_PBA_STRUCT_CSR_UNION, sizeof (PCICFG_MSIX_PBA_STRUCT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI-E Control/Status 0 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_0_CSR {
         union {
            struct { 
               u32 mode_loopback_slave_exit : 1;  // DWORD 0
               u32 ui_scramble_disable_force : 1; // DWORD 0
               u32 mode_detect_quiet : 1;         // DWORD 0
               u32 mode_txswing : 1;              // DWORD 0
               u32 mode_clk_active : 2;           // DWORD 0
               u32 lnum_fmode : 2;                // DWORD 0
               u32 num_fts : 8;                   // DWORD 0
               u32 wake_on_pme_tmr_expiry_en : 1; // DWORD 0
               u32 ltssm_state : 7;               // DWORD 0
               u32 mode_loopback_bist_result_7_0 : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_0_CSR, *PPCICFG_IP_CONTROL_STATUS_0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_0_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_0_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_0_CSR {
         u32 mode_loopback_slave_exit : 1;        // DWORD 0
         u32 ui_scramble_disable_force : 1;       // DWORD 0
         u32 mode_detect_quiet : 1;               // DWORD 0
         u32 mode_txswing : 1;                    // DWORD 0
         u32 mode_clk_active : 2;                 // DWORD 0
         u32 lnum_fmode : 2;                      // DWORD 0
         u32 num_fts : 8;                         // DWORD 0
         u32 wake_on_pme_tmr_expiry_en : 1;       // DWORD 0
         u32 ltssm_state : 7;                     // DWORD 0
         u32 mode_loopback_bist_result_7_0 : 8;   // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_0_CSR, *PPCICFG_IP_CONTROL_STATUS_0_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_0_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_0_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_0_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_0_CSR_UNION) == 4);
   #endif


#else
   // PCI-E Control/Status 0 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_0_CSR {
         union {
            struct { 
               u32 mode_loopback_bist_result_7_0 : 8; // DWORD 0
               u32 ltssm_state : 7;               // DWORD 0
               u32 wake_on_pme_tmr_expiry_en : 1; // DWORD 0
               u32 num_fts : 8;                   // DWORD 0
               u32 lnum_fmode : 2;                // DWORD 0
               u32 mode_clk_active : 2;           // DWORD 0
               u32 mode_txswing : 1;              // DWORD 0
               u32 mode_detect_quiet : 1;         // DWORD 0
               u32 ui_scramble_disable_force : 1; // DWORD 0
               u32 mode_loopback_slave_exit : 1;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_0_CSR, *PPCICFG_IP_CONTROL_STATUS_0_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_0_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_0_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_0_CSR {
         u32 mode_loopback_bist_result_7_0 : 8;   // DWORD 0
         u32 ltssm_state : 7;                     // DWORD 0
         u32 wake_on_pme_tmr_expiry_en : 1;       // DWORD 0
         u32 num_fts : 8;                         // DWORD 0
         u32 lnum_fmode : 2;                      // DWORD 0
         u32 mode_clk_active : 2;                 // DWORD 0
         u32 mode_txswing : 1;                    // DWORD 0
         u32 mode_detect_quiet : 1;               // DWORD 0
         u32 ui_scramble_disable_force : 1;       // DWORD 0
         u32 mode_loopback_slave_exit : 1;        // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_0_CSR, *PPCICFG_IP_CONTROL_STATUS_0_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_0_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_0_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_0_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_0_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_0_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI-E Control/Status 1 Register
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_1_CSR {
         union {
            struct { 
               u32 mode_loopback_bist_2 : 1;      // DWORD 0
               u32 mode_loopback_bist_1 : 1;      // DWORD 0
               u32 mode_loopback_master_enable : 1; // DWORD 0
               u32 ack_timer_force : 1;           // DWORD 0
               u32 ui_ack_timer : 16;             // DWORD 0
               u32 mode_loopback_bist_result_15_8 : 8; // DWORD 0
               u32 mode_loopback_reset_o : 1;     // DWORD 0
               u32 mode_compliance_receive : 1;   // DWORD 0
               u32 vc0_negotiation_pending : 1;   // DWORD 0
               u32 mode_tx_drv_en : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_1_CSR, *PPCICFG_IP_CONTROL_STATUS_1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_1_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_1_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_1_CSR {
         u32 mode_loopback_bist_2 : 1;            // DWORD 0
         u32 mode_loopback_bist_1 : 1;            // DWORD 0
         u32 mode_loopback_master_enable : 1;     // DWORD 0
         u32 ack_timer_force : 1;                 // DWORD 0
         u32 ui_ack_timer : 16;                   // DWORD 0
         u32 mode_loopback_bist_result_15_8 : 8;  // DWORD 0
         u32 mode_loopback_reset_o : 1;           // DWORD 0
         u32 mode_compliance_receive : 1;         // DWORD 0
         u32 vc0_negotiation_pending : 1;         // DWORD 0
         u32 mode_tx_drv_en : 1;                  // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_1_CSR, *PPCICFG_IP_CONTROL_STATUS_1_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_1_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_1_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_1_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_1_CSR_UNION) == 4);
   #endif


#else
   // PCI-E Control/Status 1 Register
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_1_CSR {
         union {
            struct { 
               u32 mode_tx_drv_en : 1;            // DWORD 0
               u32 vc0_negotiation_pending : 1;   // DWORD 0
               u32 mode_compliance_receive : 1;   // DWORD 0
               u32 mode_loopback_reset_o : 1;     // DWORD 0
               u32 mode_loopback_bist_result_15_8 : 8; // DWORD 0
               u32 ui_ack_timer : 16;             // DWORD 0
               u32 ack_timer_force : 1;           // DWORD 0
               u32 mode_loopback_master_enable : 1; // DWORD 0
               u32 mode_loopback_bist_1 : 1;      // DWORD 0
               u32 mode_loopback_bist_2 : 1;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_1_CSR, *PPCICFG_IP_CONTROL_STATUS_1_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_1_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_1_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_1_CSR {
         u32 mode_tx_drv_en : 1;                  // DWORD 0
         u32 vc0_negotiation_pending : 1;         // DWORD 0
         u32 mode_compliance_receive : 1;         // DWORD 0
         u32 mode_loopback_reset_o : 1;           // DWORD 0
         u32 mode_loopback_bist_result_15_8 : 8;  // DWORD 0
         u32 ui_ack_timer : 16;                   // DWORD 0
         u32 ack_timer_force : 1;                 // DWORD 0
         u32 mode_loopback_master_enable : 1;     // DWORD 0
         u32 mode_loopback_bist_1 : 1;            // DWORD 0
         u32 mode_loopback_bist_2 : 1;            // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_1_CSR, *PPCICFG_IP_CONTROL_STATUS_1_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_1_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_1_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_1_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI-E Replay Timer Error Notification signals Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_ERR_REPLAY_MONITOR {
         union {
            struct { 
               u32 TXB_PARITY_ERR : 1;            // DWORD 0
               u32 REPLAY_SYNDROME_LOWER : 8;     // DWORD 0
               u32 REPLAY_SYNDROME_UPPER : 8;     // DWORD 0
               u32 ERR_REPLAY_LOWER_CORRECTABLE_ERROR : 1; // DWORD 0
               u32 ERR_REPLAY_UPPER_CORRECTABLE_ERROR : 1; // DWORD 0
               u32 ERR_REPLAY_LOWER_UNCORRECTABLE_ERROR : 1; // DWORD 0
               u32 ERR_REPLAY_UPPER_UNCORRECTABLE_ERROR : 1; // DWORD 0
               u32 ERR_RPC_REPLAYFIFO_PERR : 1;   // DWORD 0
               u32 ERR_RPC_REPLAY_TIMEOUT : 1;    // DWORD 0
               u32 ERR_RPC_REPLAY_ROLLOVR : 1;    // DWORD 0
               u32 ERR_REPLAY_NUM : 2;            // DWORD 0
               u32 ERR_REPLAY : 1;                // DWORD 0
               u32 ERR_NULLTLP : 1;               // DWORD 0
               u32 ERR_DLPERR : 1;                // DWORD 0
               u32 ERR_RECEIVERERROR : 1;         // DWORD 0
               u32 ERR_BADTLP : 1;                // DWORD 0
               u32 ERR_BADDLLP : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_ERR_REPLAY_MONITOR, *PPCICFG_ERR_REPLAY_MONITOR;

      SG_C_ASSERT(__sizeof__PCICFG_ERR_REPLAY_MONITOR, sizeof (PCICFG_ERR_REPLAY_MONITOR) == 4);

   #else
      typedef struct _PCICFG_ERR_REPLAY_MONITOR {
         u32 TXB_PARITY_ERR : 1;                  // DWORD 0
         u32 REPLAY_SYNDROME_LOWER : 8;           // DWORD 0
         u32 REPLAY_SYNDROME_UPPER : 8;           // DWORD 0
         u32 ERR_REPLAY_LOWER_CORRECTABLE_ERROR : 1; // DWORD 0
         u32 ERR_REPLAY_UPPER_CORRECTABLE_ERROR : 1; // DWORD 0
         u32 ERR_REPLAY_LOWER_UNCORRECTABLE_ERROR : 1; // DWORD 0
         u32 ERR_REPLAY_UPPER_UNCORRECTABLE_ERROR : 1; // DWORD 0
         u32 ERR_RPC_REPLAYFIFO_PERR : 1;         // DWORD 0
         u32 ERR_RPC_REPLAY_TIMEOUT : 1;          // DWORD 0
         u32 ERR_RPC_REPLAY_ROLLOVR : 1;          // DWORD 0
         u32 ERR_REPLAY_NUM : 2;                  // DWORD 0
         u32 ERR_REPLAY : 1;                      // DWORD 0
         u32 ERR_NULLTLP : 1;                     // DWORD 0
         u32 ERR_DLPERR : 1;                      // DWORD 0
         u32 ERR_RECEIVERERROR : 1;               // DWORD 0
         u32 ERR_BADTLP : 1;                      // DWORD 0
         u32 ERR_BADDLLP : 1;                     // DWORD 0
      } SG_PACK PCICFG_ERR_REPLAY_MONITOR, *PPCICFG_ERR_REPLAY_MONITOR;

      typedef union _PCICFG_ERR_REPLAY_MONITOR_UNION {
         PCICFG_ERR_REPLAY_MONITOR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_ERR_REPLAY_MONITOR_UNION, *PPCICFG_ERR_REPLAY_MONITOR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_ERR_REPLAY_MONITOR_UNION, sizeof (PCICFG_ERR_REPLAY_MONITOR_UNION) == 4);
   #endif


#else
   // PCI-E Replay Timer Error Notification signals Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_ERR_REPLAY_MONITOR {
         union {
            struct { 
               u32 ERR_BADDLLP : 1;               // DWORD 0
               u32 ERR_BADTLP : 1;                // DWORD 0
               u32 ERR_RECEIVERERROR : 1;         // DWORD 0
               u32 ERR_DLPERR : 1;                // DWORD 0
               u32 ERR_NULLTLP : 1;               // DWORD 0
               u32 ERR_REPLAY : 1;                // DWORD 0
               u32 ERR_REPLAY_NUM : 2;            // DWORD 0
               u32 ERR_RPC_REPLAY_ROLLOVR : 1;    // DWORD 0
               u32 ERR_RPC_REPLAY_TIMEOUT : 1;    // DWORD 0
               u32 ERR_RPC_REPLAYFIFO_PERR : 1;   // DWORD 0
               u32 ERR_REPLAY_UPPER_UNCORRECTABLE_ERROR : 1; // DWORD 0
               u32 ERR_REPLAY_LOWER_UNCORRECTABLE_ERROR : 1; // DWORD 0
               u32 ERR_REPLAY_UPPER_CORRECTABLE_ERROR : 1; // DWORD 0
               u32 ERR_REPLAY_LOWER_CORRECTABLE_ERROR : 1; // DWORD 0
               u32 REPLAY_SYNDROME_UPPER : 8;     // DWORD 0
               u32 REPLAY_SYNDROME_LOWER : 8;     // DWORD 0
               u32 TXB_PARITY_ERR : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_ERR_REPLAY_MONITOR, *PPCICFG_ERR_REPLAY_MONITOR;

      SG_C_ASSERT(__sizeof__PCICFG_ERR_REPLAY_MONITOR, sizeof (PCICFG_ERR_REPLAY_MONITOR) == 4);

   #else
      typedef struct _PCICFG_ERR_REPLAY_MONITOR {
         u32 ERR_BADDLLP : 1;                     // DWORD 0
         u32 ERR_BADTLP : 1;                      // DWORD 0
         u32 ERR_RECEIVERERROR : 1;               // DWORD 0
         u32 ERR_DLPERR : 1;                      // DWORD 0
         u32 ERR_NULLTLP : 1;                     // DWORD 0
         u32 ERR_REPLAY : 1;                      // DWORD 0
         u32 ERR_REPLAY_NUM : 2;                  // DWORD 0
         u32 ERR_RPC_REPLAY_ROLLOVR : 1;          // DWORD 0
         u32 ERR_RPC_REPLAY_TIMEOUT : 1;          // DWORD 0
         u32 ERR_RPC_REPLAYFIFO_PERR : 1;         // DWORD 0
         u32 ERR_REPLAY_UPPER_UNCORRECTABLE_ERROR : 1; // DWORD 0
         u32 ERR_REPLAY_LOWER_UNCORRECTABLE_ERROR : 1; // DWORD 0
         u32 ERR_REPLAY_UPPER_CORRECTABLE_ERROR : 1; // DWORD 0
         u32 ERR_REPLAY_LOWER_CORRECTABLE_ERROR : 1; // DWORD 0
         u32 REPLAY_SYNDROME_UPPER : 8;           // DWORD 0
         u32 REPLAY_SYNDROME_LOWER : 8;           // DWORD 0
         u32 TXB_PARITY_ERR : 1;                  // DWORD 0
      } SG_PACK PCICFG_ERR_REPLAY_MONITOR, *PPCICFG_ERR_REPLAY_MONITOR;

      typedef union _PCICFG_ERR_REPLAY_MONITOR_UNION {
         PCICFG_ERR_REPLAY_MONITOR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_ERR_REPLAY_MONITOR_UNION, *PPCICFG_ERR_REPLAY_MONITOR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_ERR_REPLAY_MONITOR_UNION, sizeof (PCICFG_ERR_REPLAY_MONITOR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI-E Link Speed Width Control Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_SPEED_WIDTH_CTRL {
         union {
            struct { 
               u32 target_link_error_cnt : 16;    // DWORD 0
               u32 cfg_aspm_l1_dllp_interval_time_limit : 3; // DWORD 0
               u32 clr_link_error_count : 1;      // DWORD 0
               u32 target_link_autonomous_req : 1; // DWORD 0
               u32 target_link_width_req : 1;     // DWORD 0
               u32 target_link_width : 8;         // DWORD 0
               u32 target_link_speed_req : 1;     // DWORD 0
               u32 target_link_speed : 1;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_SPEED_WIDTH_CTRL, *PPCICFG_IP_SPEED_WIDTH_CTRL;

      SG_C_ASSERT(__sizeof__PCICFG_IP_SPEED_WIDTH_CTRL, sizeof (PCICFG_IP_SPEED_WIDTH_CTRL) == 4);

   #else
      typedef struct _PCICFG_IP_SPEED_WIDTH_CTRL {
         u32 target_link_error_cnt : 16;          // DWORD 0
         u32 cfg_aspm_l1_dllp_interval_time_limit : 3; // DWORD 0
         u32 clr_link_error_count : 1;            // DWORD 0
         u32 target_link_autonomous_req : 1;      // DWORD 0
         u32 target_link_width_req : 1;           // DWORD 0
         u32 target_link_width : 8;               // DWORD 0
         u32 target_link_speed_req : 1;           // DWORD 0
         u32 target_link_speed : 1;               // DWORD 0
      } SG_PACK PCICFG_IP_SPEED_WIDTH_CTRL, *PPCICFG_IP_SPEED_WIDTH_CTRL;

      typedef union _PCICFG_IP_SPEED_WIDTH_CTRL_UNION {
         PCICFG_IP_SPEED_WIDTH_CTRL bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_SPEED_WIDTH_CTRL_UNION, *PPCICFG_IP_SPEED_WIDTH_CTRL_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_SPEED_WIDTH_CTRL_UNION, sizeof (PCICFG_IP_SPEED_WIDTH_CTRL_UNION) == 4);
   #endif


#else
   // PCI-E Link Speed Width Control Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_SPEED_WIDTH_CTRL {
         union {
            struct { 
               u32 target_link_speed : 1;         // DWORD 0
               u32 target_link_speed_req : 1;     // DWORD 0
               u32 target_link_width : 8;         // DWORD 0
               u32 target_link_width_req : 1;     // DWORD 0
               u32 target_link_autonomous_req : 1; // DWORD 0
               u32 clr_link_error_count : 1;      // DWORD 0
               u32 cfg_aspm_l1_dllp_interval_time_limit : 3; // DWORD 0
               u32 target_link_error_cnt : 16;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_SPEED_WIDTH_CTRL, *PPCICFG_IP_SPEED_WIDTH_CTRL;

      SG_C_ASSERT(__sizeof__PCICFG_IP_SPEED_WIDTH_CTRL, sizeof (PCICFG_IP_SPEED_WIDTH_CTRL) == 4);

   #else
      typedef struct _PCICFG_IP_SPEED_WIDTH_CTRL {
         u32 target_link_speed : 1;               // DWORD 0
         u32 target_link_speed_req : 1;           // DWORD 0
         u32 target_link_width : 8;               // DWORD 0
         u32 target_link_width_req : 1;           // DWORD 0
         u32 target_link_autonomous_req : 1;      // DWORD 0
         u32 clr_link_error_count : 1;            // DWORD 0
         u32 cfg_aspm_l1_dllp_interval_time_limit : 3; // DWORD 0
         u32 target_link_error_cnt : 16;          // DWORD 0
      } SG_PACK PCICFG_IP_SPEED_WIDTH_CTRL, *PPCICFG_IP_SPEED_WIDTH_CTRL;

      typedef union _PCICFG_IP_SPEED_WIDTH_CTRL_UNION {
         PCICFG_IP_SPEED_WIDTH_CTRL bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_SPEED_WIDTH_CTRL_UNION, *PPCICFG_IP_SPEED_WIDTH_CTRL_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_SPEED_WIDTH_CTRL_UNION, sizeof (PCICFG_IP_SPEED_WIDTH_CTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI-E Control/Status 5 Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_5_CSR {
         union {
            struct { 
               u32 LINK_ERROR_MAXED : 8;          // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 TEST_LOOPBACK_SLOT_POWER_MSG_FAIL : 1; // DWORD 0
               u32 TEST_LOOPBACK_SLOT_POWER_MSG_PASS : 1; // DWORD 0
               u32 TEST_LOOPBACK_SLOT_POWER_MSG_SEND : 1; // DWORD 0
               u32 TEST_LOOPBACK_SLOT_POWER_MSG_ENABLE : 1; // DWORD 0
               u32 COSPLLOCK : 1;                 // DWORD 0
               u32 MON_MASK : 2;                  // DWORD 0
               u32 MON_PSTATUS : 2;               // DWORD 0
               u32 STATE_LANE_ERROR : 8;          // DWORD 0
               u32 STATE_EIOS_DETECTED : 1;       // DWORD 0
               u32 LINK_STATE : 5;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_5_CSR, *PPCICFG_IP_CONTROL_STATUS_5_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_5_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_5_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_5_CSR {
         u32 LINK_ERROR_MAXED : 8;                // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 TEST_LOOPBACK_SLOT_POWER_MSG_FAIL : 1; // DWORD 0
         u32 TEST_LOOPBACK_SLOT_POWER_MSG_PASS : 1; // DWORD 0
         u32 TEST_LOOPBACK_SLOT_POWER_MSG_SEND : 1; // DWORD 0
         u32 TEST_LOOPBACK_SLOT_POWER_MSG_ENABLE : 1; // DWORD 0
         u32 COSPLLOCK : 1;                       // DWORD 0
         u32 MON_MASK : 2;                        // DWORD 0
         u32 MON_PSTATUS : 2;                     // DWORD 0
         u32 STATE_LANE_ERROR : 8;                // DWORD 0
         u32 STATE_EIOS_DETECTED : 1;             // DWORD 0
         u32 LINK_STATE : 5;                      // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_5_CSR, *PPCICFG_IP_CONTROL_STATUS_5_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_5_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_5_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_5_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_5_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_5_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_5_CSR_UNION) == 4);
   #endif


#else
   // PCI-E Control/Status 5 Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_5_CSR {
         union {
            struct { 
               u32 LINK_STATE : 5;                // DWORD 0
               u32 STATE_EIOS_DETECTED : 1;       // DWORD 0
               u32 STATE_LANE_ERROR : 8;          // DWORD 0
               u32 MON_PSTATUS : 2;               // DWORD 0
               u32 MON_MASK : 2;                  // DWORD 0
               u32 COSPLLOCK : 1;                 // DWORD 0
               u32 TEST_LOOPBACK_SLOT_POWER_MSG_ENABLE : 1; // DWORD 0
               u32 TEST_LOOPBACK_SLOT_POWER_MSG_SEND : 1; // DWORD 0
               u32 TEST_LOOPBACK_SLOT_POWER_MSG_PASS : 1; // DWORD 0
               u32 TEST_LOOPBACK_SLOT_POWER_MSG_FAIL : 1; // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 LINK_ERROR_MAXED : 8;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_5_CSR, *PPCICFG_IP_CONTROL_STATUS_5_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_5_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_5_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_5_CSR {
         u32 LINK_STATE : 5;                      // DWORD 0
         u32 STATE_EIOS_DETECTED : 1;             // DWORD 0
         u32 STATE_LANE_ERROR : 8;                // DWORD 0
         u32 MON_PSTATUS : 2;                     // DWORD 0
         u32 MON_MASK : 2;                        // DWORD 0
         u32 COSPLLOCK : 1;                       // DWORD 0
         u32 TEST_LOOPBACK_SLOT_POWER_MSG_ENABLE : 1; // DWORD 0
         u32 TEST_LOOPBACK_SLOT_POWER_MSG_SEND : 1; // DWORD 0
         u32 TEST_LOOPBACK_SLOT_POWER_MSG_PASS : 1; // DWORD 0
         u32 TEST_LOOPBACK_SLOT_POWER_MSG_FAIL : 1; // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 LINK_ERROR_MAXED : 8;                // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_5_CSR, *PPCICFG_IP_CONTROL_STATUS_5_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_5_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_5_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_5_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_5_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_5_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_5_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI-E Control/Status 4 Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_4_CSR {
         union {
            struct { 
               u32 STATE_ELECTRICAL_IDLE_BROKEN : 8; // DWORD 0
               u32 STATE_RECEIVER_DETECTED : 8;   // DWORD 0
               u32 STATE_DATA_RATE_IDENTIFIER_RECEIVED : 8; // DWORD 0
               u32 STATE_NEGOTIATED_LANE_END : 4; // DWORD 0
               u32 STATE_NEGOTIATED_LANE_START : 4; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_4_CSR, *PPCICFG_IP_CONTROL_STATUS_4_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_4_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_4_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_4_CSR {
         u32 STATE_ELECTRICAL_IDLE_BROKEN : 8;    // DWORD 0
         u32 STATE_RECEIVER_DETECTED : 8;         // DWORD 0
         u32 STATE_DATA_RATE_IDENTIFIER_RECEIVED : 8; // DWORD 0
         u32 STATE_NEGOTIATED_LANE_END : 4;       // DWORD 0
         u32 STATE_NEGOTIATED_LANE_START : 4;     // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_4_CSR, *PPCICFG_IP_CONTROL_STATUS_4_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_4_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_4_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_4_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_4_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_4_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_4_CSR_UNION) == 4);
   #endif


#else
   // PCI-E Control/Status 4 Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_4_CSR {
         union {
            struct { 
               u32 STATE_NEGOTIATED_LANE_START : 4; // DWORD 0
               u32 STATE_NEGOTIATED_LANE_END : 4; // DWORD 0
               u32 STATE_DATA_RATE_IDENTIFIER_RECEIVED : 8; // DWORD 0
               u32 STATE_RECEIVER_DETECTED : 8;   // DWORD 0
               u32 STATE_ELECTRICAL_IDLE_BROKEN : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_4_CSR, *PPCICFG_IP_CONTROL_STATUS_4_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_4_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_4_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_4_CSR {
         u32 STATE_NEGOTIATED_LANE_START : 4;     // DWORD 0
         u32 STATE_NEGOTIATED_LANE_END : 4;       // DWORD 0
         u32 STATE_DATA_RATE_IDENTIFIER_RECEIVED : 8; // DWORD 0
         u32 STATE_RECEIVER_DETECTED : 8;         // DWORD 0
         u32 STATE_ELECTRICAL_IDLE_BROKEN : 8;    // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_4_CSR, *PPCICFG_IP_CONTROL_STATUS_4_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_4_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_4_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_4_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_4_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_4_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_4_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI-E Control/Status 2 Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_2_CSR {
         union {
            struct { 
               u32 nec_ll_ecc2berr_set_i : 1;     // DWORD 0
               u32 nec_ll_ecc1berr_set_i : 1;     // DWORD 0
               u32 nec_ll_dmperr_set_i : 1;       // DWORD 0
               u32 nec_ll_txeberr : 1;            // DWORD 0
               u32 ui_replay_timer_limit : 20;    // DWORD 0
               u32 MODE_RX_COMPLETION_ORDERING_DISABLE : 1; // DWORD 0
               u32 ui_exit_polling_compliance : 1; // DWORD 0
               u32 EIJ_REPLAY_LOWER_CORRECTABLE_INJECT : 1; // DWORD 0
               u32 EIJ_REPLAY_UPPER_CORRECTABLE_INJECT : 1; // DWORD 0
               u32 EIJ_REPLAY_LOWER_UNCORRECTABLE_INJECT : 1; // DWORD 0
               u32 EIJ_REPLAY_UPPER_UNCORRECTABLE_INJECT : 1; // DWORD 0
               u32 EIJ_ERROR_REPORT_DISABLE : 1;  // DWORD 0
               u32 EIJ_ERROR_CORRECT_DISABLE : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_2_CSR, *PPCICFG_IP_CONTROL_STATUS_2_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_2_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_2_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_2_CSR {
         u32 nec_ll_ecc2berr_set_i : 1;           // DWORD 0
         u32 nec_ll_ecc1berr_set_i : 1;           // DWORD 0
         u32 nec_ll_dmperr_set_i : 1;             // DWORD 0
         u32 nec_ll_txeberr : 1;                  // DWORD 0
         u32 ui_replay_timer_limit : 20;          // DWORD 0
         u32 MODE_RX_COMPLETION_ORDERING_DISABLE : 1; // DWORD 0
         u32 ui_exit_polling_compliance : 1;      // DWORD 0
         u32 EIJ_REPLAY_LOWER_CORRECTABLE_INJECT : 1; // DWORD 0
         u32 EIJ_REPLAY_UPPER_CORRECTABLE_INJECT : 1; // DWORD 0
         u32 EIJ_REPLAY_LOWER_UNCORRECTABLE_INJECT : 1; // DWORD 0
         u32 EIJ_REPLAY_UPPER_UNCORRECTABLE_INJECT : 1; // DWORD 0
         u32 EIJ_ERROR_REPORT_DISABLE : 1;        // DWORD 0
         u32 EIJ_ERROR_CORRECT_DISABLE : 1;       // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_2_CSR, *PPCICFG_IP_CONTROL_STATUS_2_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_2_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_2_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_2_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_2_CSR_UNION) == 4);
   #endif


#else
   // PCI-E Control/Status 2 Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_2_CSR {
         union {
            struct { 
               u32 EIJ_ERROR_CORRECT_DISABLE : 1; // DWORD 0
               u32 EIJ_ERROR_REPORT_DISABLE : 1;  // DWORD 0
               u32 EIJ_REPLAY_UPPER_UNCORRECTABLE_INJECT : 1; // DWORD 0
               u32 EIJ_REPLAY_LOWER_UNCORRECTABLE_INJECT : 1; // DWORD 0
               u32 EIJ_REPLAY_UPPER_CORRECTABLE_INJECT : 1; // DWORD 0
               u32 EIJ_REPLAY_LOWER_CORRECTABLE_INJECT : 1; // DWORD 0
               u32 ui_exit_polling_compliance : 1; // DWORD 0
               u32 MODE_RX_COMPLETION_ORDERING_DISABLE : 1; // DWORD 0
               u32 ui_replay_timer_limit : 20;    // DWORD 0
               u32 nec_ll_txeberr : 1;            // DWORD 0
               u32 nec_ll_dmperr_set_i : 1;       // DWORD 0
               u32 nec_ll_ecc1berr_set_i : 1;     // DWORD 0
               u32 nec_ll_ecc2berr_set_i : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_2_CSR, *PPCICFG_IP_CONTROL_STATUS_2_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_2_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_2_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_2_CSR {
         u32 EIJ_ERROR_CORRECT_DISABLE : 1;       // DWORD 0
         u32 EIJ_ERROR_REPORT_DISABLE : 1;        // DWORD 0
         u32 EIJ_REPLAY_UPPER_UNCORRECTABLE_INJECT : 1; // DWORD 0
         u32 EIJ_REPLAY_LOWER_UNCORRECTABLE_INJECT : 1; // DWORD 0
         u32 EIJ_REPLAY_UPPER_CORRECTABLE_INJECT : 1; // DWORD 0
         u32 EIJ_REPLAY_LOWER_CORRECTABLE_INJECT : 1; // DWORD 0
         u32 ui_exit_polling_compliance : 1;      // DWORD 0
         u32 MODE_RX_COMPLETION_ORDERING_DISABLE : 1; // DWORD 0
         u32 ui_replay_timer_limit : 20;          // DWORD 0
         u32 nec_ll_txeberr : 1;                  // DWORD 0
         u32 nec_ll_dmperr_set_i : 1;             // DWORD 0
         u32 nec_ll_ecc1berr_set_i : 1;           // DWORD 0
         u32 nec_ll_ecc2berr_set_i : 1;           // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_2_CSR, *PPCICFG_IP_CONTROL_STATUS_2_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_2_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_2_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_2_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI-E Control/Status 3 Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_3_CSR {
         union {
            struct { 
               u32 down_stream_read_count : 8;    // DWORD 0
               u32 down_stream_write_count : 8;   // DWORD 0
               u32 cfg_pgsize : 3;                // DWORD 0
               u32 ui_skp_timer : 13;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_3_CSR, *PPCICFG_IP_CONTROL_STATUS_3_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_3_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_3_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_3_CSR {
         u32 down_stream_read_count : 8;          // DWORD 0
         u32 down_stream_write_count : 8;         // DWORD 0
         u32 cfg_pgsize : 3;                      // DWORD 0
         u32 ui_skp_timer : 13;                   // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_3_CSR, *PPCICFG_IP_CONTROL_STATUS_3_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_3_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_3_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_3_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_3_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_3_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_3_CSR_UNION) == 4);
   #endif


#else
   // PCI-E Control/Status 3 Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_IP_CONTROL_STATUS_3_CSR {
         union {
            struct { 
               u32 ui_skp_timer : 13;             // DWORD 0
               u32 cfg_pgsize : 3;                // DWORD 0
               u32 down_stream_write_count : 8;   // DWORD 0
               u32 down_stream_read_count : 8;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_3_CSR, *PPCICFG_IP_CONTROL_STATUS_3_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_3_CSR, sizeof (PCICFG_IP_CONTROL_STATUS_3_CSR) == 4);

   #else
      typedef struct _PCICFG_IP_CONTROL_STATUS_3_CSR {
         u32 ui_skp_timer : 13;                   // DWORD 0
         u32 cfg_pgsize : 3;                      // DWORD 0
         u32 down_stream_write_count : 8;         // DWORD 0
         u32 down_stream_read_count : 8;          // DWORD 0
      } SG_PACK PCICFG_IP_CONTROL_STATUS_3_CSR, *PPCICFG_IP_CONTROL_STATUS_3_CSR;

      typedef union _PCICFG_IP_CONTROL_STATUS_3_CSR_UNION {
         PCICFG_IP_CONTROL_STATUS_3_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_IP_CONTROL_STATUS_3_CSR_UNION, *PPCICFG_IP_CONTROL_STATUS_3_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_IP_CONTROL_STATUS_3_CSR_UNION, sizeof (PCICFG_IP_CONTROL_STATUS_3_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Power Management Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PMC_CSR {
         union {
            struct { 
               u32 pme : 5;                       // DWORD 0
               u32 d2 : 1;                        // DWORD 0
               u32 d1 : 1;                        // DWORD 0
               u32 aux_current : 3;               // DWORD 0
               u32 dsi : 1;                       // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 pme_clk : 1;                   // DWORD 0
               u32 version : 3;                   // DWORD 0
               u32 pmnextptr : 8;                 // DWORD 0
               u32 pmcapid : 8;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PMC_CSR, *PPCICFG_PMC_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PMC_CSR, sizeof (PCICFG_PMC_CSR) == 4);

   #else
      typedef struct _PCICFG_PMC_CSR {
         u32 pme : 5;                             // DWORD 0
         u32 d2 : 1;                              // DWORD 0
         u32 d1 : 1;                              // DWORD 0
         u32 aux_current : 3;                     // DWORD 0
         u32 dsi : 1;                             // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 pme_clk : 1;                         // DWORD 0
         u32 version : 3;                         // DWORD 0
         u32 pmnextptr : 8;                       // DWORD 0
         u32 pmcapid : 8;                         // DWORD 0
      } SG_PACK PCICFG_PMC_CSR, *PPCICFG_PMC_CSR;

      typedef union _PCICFG_PMC_CSR_UNION {
         PCICFG_PMC_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PMC_CSR_UNION, *PPCICFG_PMC_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PMC_CSR_UNION, sizeof (PCICFG_PMC_CSR_UNION) == 4);
   #endif


#else
   // Power Management Capabilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PMC_CSR {
         union {
            struct { 
               u32 pmcapid : 8;                   // DWORD 0
               u32 pmnextptr : 8;                 // DWORD 0
               u32 version : 3;                   // DWORD 0
               u32 pme_clk : 1;                   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 dsi : 1;                       // DWORD 0
               u32 aux_current : 3;               // DWORD 0
               u32 d1 : 1;                        // DWORD 0
               u32 d2 : 1;                        // DWORD 0
               u32 pme : 5;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PMC_CSR, *PPCICFG_PMC_CSR;

      SG_C_ASSERT(__sizeof__PCICFG_PMC_CSR, sizeof (PCICFG_PMC_CSR) == 4);

   #else
      typedef struct _PCICFG_PMC_CSR {
         u32 pmcapid : 8;                         // DWORD 0
         u32 pmnextptr : 8;                       // DWORD 0
         u32 version : 3;                         // DWORD 0
         u32 pme_clk : 1;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 dsi : 1;                             // DWORD 0
         u32 aux_current : 3;                     // DWORD 0
         u32 d1 : 1;                              // DWORD 0
         u32 d2 : 1;                              // DWORD 0
         u32 pme : 5;                             // DWORD 0
      } SG_PACK PCICFG_PMC_CSR, *PPCICFG_PMC_CSR;

      typedef union _PCICFG_PMC_CSR_UNION {
         PCICFG_PMC_CSR bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PMC_CSR_UNION, *PPCICFG_PMC_CSR_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PMC_CSR_UNION, sizeof (PCICFG_PMC_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Power Managment Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PM_CONTROL {
         union {
            struct { 
               u32 pmdata : 8;                    // DWORD 0
               u32 bpcc_en : 1;                   // DWORD 0
               u32 b2_b3 : 1;                     // DWORD 0
               u32 rsvd2 : 6;                     // DWORD 0
               u32 pme_status : 1;                // DWORD 0
               u32 data_scale : 2;                // DWORD 0
               u32 data_select : 4;               // DWORD 0
               u32 pme_en : 1;                    // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 device_specific : 1;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 pwr_state : 2;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PM_CONTROL, *PPCICFG_PM_CONTROL;

      SG_C_ASSERT(__sizeof__PCICFG_PM_CONTROL, sizeof (PCICFG_PM_CONTROL) == 4);

   #else
      typedef struct _PCICFG_PM_CONTROL {
         u32 pmdata : 8;                          // DWORD 0
         u32 bpcc_en : 1;                         // DWORD 0
         u32 b2_b3 : 1;                           // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 pme_status : 1;                      // DWORD 0
         u32 data_scale : 2;                      // DWORD 0
         u32 data_select : 4;                     // DWORD 0
         u32 pme_en : 1;                          // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 device_specific : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 pwr_state : 2;                       // DWORD 0
      } SG_PACK PCICFG_PM_CONTROL, *PPCICFG_PM_CONTROL;

      typedef union _PCICFG_PM_CONTROL_UNION {
         PCICFG_PM_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PM_CONTROL_UNION, *PPCICFG_PM_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PM_CONTROL_UNION, sizeof (PCICFG_PM_CONTROL_UNION) == 4);
   #endif


#else
   // Power Managment Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PM_CONTROL {
         union {
            struct { 
               u32 pwr_state : 2;                 // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 device_specific : 1;           // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 pme_en : 1;                    // DWORD 0
               u32 data_select : 4;               // DWORD 0
               u32 data_scale : 2;                // DWORD 0
               u32 pme_status : 1;                // DWORD 0
               u32 rsvd2 : 6;                     // DWORD 0
               u32 b2_b3 : 1;                     // DWORD 0
               u32 bpcc_en : 1;                   // DWORD 0
               u32 pmdata : 8;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PM_CONTROL, *PPCICFG_PM_CONTROL;

      SG_C_ASSERT(__sizeof__PCICFG_PM_CONTROL, sizeof (PCICFG_PM_CONTROL) == 4);

   #else
      typedef struct _PCICFG_PM_CONTROL {
         u32 pwr_state : 2;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 device_specific : 1;                 // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 pme_en : 1;                          // DWORD 0
         u32 data_select : 4;                     // DWORD 0
         u32 data_scale : 2;                      // DWORD 0
         u32 pme_status : 1;                      // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 b2_b3 : 1;                           // DWORD 0
         u32 bpcc_en : 1;                         // DWORD 0
         u32 pmdata : 8;                          // DWORD 0
      } SG_PACK PCICFG_PM_CONTROL, *PPCICFG_PM_CONTROL;

      typedef union _PCICFG_PM_CONTROL_UNION {
         PCICFG_PM_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_PM_CONTROL_UNION, *PPCICFG_PM_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PM_CONTROL_UNION, sizeof (PCICFG_PM_CONTROL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Advanced Error Reporting Enhanced Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ERR_ENHANCED_CAP {
         union {
            struct { 
               u32 next_cap_offset : 12;          // DWORD 0
               u32 cap_version : 4;               // DWORD 0
               u32 ext_cap_id : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ERR_ENHANCED_CAP, *PPCIE_ERR_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__PCIE_ERR_ENHANCED_CAP, sizeof (PCIE_ERR_ENHANCED_CAP) == 4);

   #else
      typedef struct _PCIE_ERR_ENHANCED_CAP {
         u32 next_cap_offset : 12;                // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 ext_cap_id : 16;                     // DWORD 0
      } SG_PACK PCIE_ERR_ENHANCED_CAP, *PPCIE_ERR_ENHANCED_CAP;

      typedef union _PCIE_ERR_ENHANCED_CAP_UNION {
         PCIE_ERR_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ERR_ENHANCED_CAP_UNION, *PPCIE_ERR_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ERR_ENHANCED_CAP_UNION, sizeof (PCIE_ERR_ENHANCED_CAP_UNION) == 4);
   #endif


#else
   // PCI Express Advanced Error Reporting Enhanced Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ERR_ENHANCED_CAP {
         union {
            struct { 
               u32 ext_cap_id : 16;               // DWORD 0
               u32 cap_version : 4;               // DWORD 0
               u32 next_cap_offset : 12;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ERR_ENHANCED_CAP, *PPCIE_ERR_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__PCIE_ERR_ENHANCED_CAP, sizeof (PCIE_ERR_ENHANCED_CAP) == 4);

   #else
      typedef struct _PCIE_ERR_ENHANCED_CAP {
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK PCIE_ERR_ENHANCED_CAP, *PPCIE_ERR_ENHANCED_CAP;

      typedef union _PCIE_ERR_ENHANCED_CAP_UNION {
         PCIE_ERR_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ERR_ENHANCED_CAP_UNION, *PPCIE_ERR_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ERR_ENHANCED_CAP_UNION, sizeof (PCIE_ERR_ENHANCED_CAP_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Alternative Routing ID Interpretation Extended Capability.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ARI_CAPABILITY {
         union {
            struct { 
               u32 rsvd1 : 16;                    // DWORD 0
               u32 next_fun_num : 8;              // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 acs_fg_capability : 1;         // DWORD 0
               u32 mfvc_fg_capability : 1;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ARI_CAPABILITY, *PPCIE_ARI_CAPABILITY;

      SG_C_ASSERT(__sizeof__PCIE_ARI_CAPABILITY, sizeof (PCIE_ARI_CAPABILITY) == 4);

   #else
      typedef struct _PCIE_ARI_CAPABILITY {
         u32 rsvd1 : 16;                          // DWORD 0
         u32 next_fun_num : 8;                    // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 acs_fg_capability : 1;               // DWORD 0
         u32 mfvc_fg_capability : 1;              // DWORD 0
      } SG_PACK PCIE_ARI_CAPABILITY, *PPCIE_ARI_CAPABILITY;

      typedef union _PCIE_ARI_CAPABILITY_UNION {
         PCIE_ARI_CAPABILITY bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ARI_CAPABILITY_UNION, *PPCIE_ARI_CAPABILITY_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ARI_CAPABILITY_UNION, sizeof (PCIE_ARI_CAPABILITY_UNION) == 4);
   #endif


#else
   // PCI Express Alternative Routing ID Interpretation Extended Capability.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ARI_CAPABILITY {
         union {
            struct { 
               u32 mfvc_fg_capability : 1;        // DWORD 0
               u32 acs_fg_capability : 1;         // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 next_fun_num : 8;              // DWORD 0
               u32 rsvd1 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ARI_CAPABILITY, *PPCIE_ARI_CAPABILITY;

      SG_C_ASSERT(__sizeof__PCIE_ARI_CAPABILITY, sizeof (PCIE_ARI_CAPABILITY) == 4);

   #else
      typedef struct _PCIE_ARI_CAPABILITY {
         u32 mfvc_fg_capability : 1;              // DWORD 0
         u32 acs_fg_capability : 1;               // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 next_fun_num : 8;                    // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 0
      } SG_PACK PCIE_ARI_CAPABILITY, *PPCIE_ARI_CAPABILITY;

      typedef union _PCIE_ARI_CAPABILITY_UNION {
         PCIE_ARI_CAPABILITY bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ARI_CAPABILITY_UNION, *PPCIE_ARI_CAPABILITY_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ARI_CAPABILITY_UNION, sizeof (PCIE_ARI_CAPABILITY_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express ARI Enhanced Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ARI_ENHANCED_CAP {
         union {
            struct { 
               u32 next_cap_offset : 12;          // DWORD 0
               u32 cap_version : 4;               // DWORD 0
               u32 ext_cap_id : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ARI_ENHANCED_CAP, *PPCIE_ARI_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__PCIE_ARI_ENHANCED_CAP, sizeof (PCIE_ARI_ENHANCED_CAP) == 4);

   #else
      typedef struct _PCIE_ARI_ENHANCED_CAP {
         u32 next_cap_offset : 12;                // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 ext_cap_id : 16;                     // DWORD 0
      } SG_PACK PCIE_ARI_ENHANCED_CAP, *PPCIE_ARI_ENHANCED_CAP;

      typedef union _PCIE_ARI_ENHANCED_CAP_UNION {
         PCIE_ARI_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ARI_ENHANCED_CAP_UNION, *PPCIE_ARI_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ARI_ENHANCED_CAP_UNION, sizeof (PCIE_ARI_ENHANCED_CAP_UNION) == 4);
   #endif


#else
   // PCI Express ARI Enhanced Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ARI_ENHANCED_CAP {
         union {
            struct { 
               u32 ext_cap_id : 16;               // DWORD 0
               u32 cap_version : 4;               // DWORD 0
               u32 next_cap_offset : 12;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ARI_ENHANCED_CAP, *PPCIE_ARI_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__PCIE_ARI_ENHANCED_CAP, sizeof (PCIE_ARI_ENHANCED_CAP) == 4);

   #else
      typedef struct _PCIE_ARI_ENHANCED_CAP {
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK PCIE_ARI_ENHANCED_CAP, *PPCIE_ARI_ENHANCED_CAP;

      typedef union _PCIE_ARI_ENHANCED_CAP_UNION {
         PCIE_ARI_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ARI_ENHANCED_CAP_UNION, *PPCIE_ARI_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ARI_ENHANCED_CAP_UNION, sizeof (PCIE_ARI_ENHANCED_CAP_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express ATS Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ATS_ENHANCED_CAP {
         union {
            struct { 
               u32 next_cap_offset : 12;          // DWORD 0
               u32 cap_version : 4;               // DWORD 0
               u32 ext_cap_id : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ATS_ENHANCED_CAP, *PPCIE_ATS_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__PCIE_ATS_ENHANCED_CAP, sizeof (PCIE_ATS_ENHANCED_CAP) == 4);

   #else
      typedef struct _PCIE_ATS_ENHANCED_CAP {
         u32 next_cap_offset : 12;                // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 ext_cap_id : 16;                     // DWORD 0
      } SG_PACK PCIE_ATS_ENHANCED_CAP, *PPCIE_ATS_ENHANCED_CAP;

      typedef union _PCIE_ATS_ENHANCED_CAP_UNION {
         PCIE_ATS_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ATS_ENHANCED_CAP_UNION, *PPCIE_ATS_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ATS_ENHANCED_CAP_UNION, sizeof (PCIE_ATS_ENHANCED_CAP_UNION) == 4);
   #endif


#else
   // PCI Express ATS Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ATS_ENHANCED_CAP {
         union {
            struct { 
               u32 ext_cap_id : 16;               // DWORD 0
               u32 cap_version : 4;               // DWORD 0
               u32 next_cap_offset : 12;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ATS_ENHANCED_CAP, *PPCIE_ATS_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__PCIE_ATS_ENHANCED_CAP, sizeof (PCIE_ATS_ENHANCED_CAP) == 4);

   #else
      typedef struct _PCIE_ATS_ENHANCED_CAP {
         u32 ext_cap_id : 16;                     // DWORD 0
         u32 cap_version : 4;                     // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK PCIE_ATS_ENHANCED_CAP, *PPCIE_ATS_ENHANCED_CAP;

      typedef union _PCIE_ATS_ENHANCED_CAP_UNION {
         PCIE_ATS_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ATS_ENHANCED_CAP_UNION, *PPCIE_ATS_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ATS_ENHANCED_CAP_UNION, sizeof (PCIE_ATS_ENHANCED_CAP_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express ATS Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ATS_CAPABILITY {
         union {
            struct { 
               u32 ats_enable : 1;                // DWORD 0
               u32 rsvd1 : 10;                    // DWORD 0
               u32 stu : 5;                       // DWORD 0
               u32 rsvd0 : 11;                    // DWORD 0
               u32 inval_queue_depth : 5;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ATS_CAPABILITY, *PPCIE_ATS_CAPABILITY;

      SG_C_ASSERT(__sizeof__PCIE_ATS_CAPABILITY, sizeof (PCIE_ATS_CAPABILITY) == 4);

   #else
      typedef struct _PCIE_ATS_CAPABILITY {
         u32 ats_enable : 1;                      // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
         u32 stu : 5;                             // DWORD 0
         u32 rsvd0 : 11;                          // DWORD 0
         u32 inval_queue_depth : 5;               // DWORD 0
      } SG_PACK PCIE_ATS_CAPABILITY, *PPCIE_ATS_CAPABILITY;

      typedef union _PCIE_ATS_CAPABILITY_UNION {
         PCIE_ATS_CAPABILITY bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ATS_CAPABILITY_UNION, *PPCIE_ATS_CAPABILITY_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ATS_CAPABILITY_UNION, sizeof (PCIE_ATS_CAPABILITY_UNION) == 4);
   #endif


#else
   // PCI Express ATS Capability Header Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ATS_CAPABILITY {
         union {
            struct { 
               u32 inval_queue_depth : 5;         // DWORD 0
               u32 rsvd0 : 11;                    // DWORD 0
               u32 stu : 5;                       // DWORD 0
               u32 rsvd1 : 10;                    // DWORD 0
               u32 ats_enable : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ATS_CAPABILITY, *PPCIE_ATS_CAPABILITY;

      SG_C_ASSERT(__sizeof__PCIE_ATS_CAPABILITY, sizeof (PCIE_ATS_CAPABILITY) == 4);

   #else
      typedef struct _PCIE_ATS_CAPABILITY {
         u32 inval_queue_depth : 5;               // DWORD 0
         u32 rsvd0 : 11;                          // DWORD 0
         u32 stu : 5;                             // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 0
         u32 ats_enable : 1;                      // DWORD 0
      } SG_PACK PCIE_ATS_CAPABILITY, *PPCIE_ATS_CAPABILITY;

      typedef union _PCIE_ATS_CAPABILITY_UNION {
         PCIE_ATS_CAPABILITY bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ATS_CAPABILITY_UNION, *PPCIE_ATS_CAPABILITY_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ATS_CAPABILITY_UNION, sizeof (PCIE_ATS_CAPABILITY_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Uncorrectable Error Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_UNCORR_ERR_STATUS {
         union {
            struct { 
               u32 rsvd2 : 11;                    // DWORD 0
               u32 unsupp_req_err : 1;            // DWORD 0
               u32 ecrc_err : 1;                  // DWORD 0
               u32 malformed_tlp_err : 1;         // DWORD 0
               u32 rcvr_overflow_err : 1;         // DWORD 0
               u32 unexp_cpl_err : 1;             // DWORD 0
               u32 cmpltr_abort_err : 1;          // DWORD 0
               u32 cpl_timeout_err : 1;           // DWORD 0
               u32 flow_ctl_prot_err : 1;         // DWORD 0
               u32 poison_tlp_err : 1;            // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 data_link_prot_err : 1;        // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 training_err : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_UNCORR_ERR_STATUS, *PPCIE_UNCORR_ERR_STATUS;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_STATUS, sizeof (PCIE_UNCORR_ERR_STATUS) == 4);

   #else
      typedef struct _PCIE_UNCORR_ERR_STATUS {
         u32 rsvd2 : 11;                          // DWORD 0
         u32 unsupp_req_err : 1;                  // DWORD 0
         u32 ecrc_err : 1;                        // DWORD 0
         u32 malformed_tlp_err : 1;               // DWORD 0
         u32 rcvr_overflow_err : 1;               // DWORD 0
         u32 unexp_cpl_err : 1;                   // DWORD 0
         u32 cmpltr_abort_err : 1;                // DWORD 0
         u32 cpl_timeout_err : 1;                 // DWORD 0
         u32 flow_ctl_prot_err : 1;               // DWORD 0
         u32 poison_tlp_err : 1;                  // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 data_link_prot_err : 1;              // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 training_err : 1;                    // DWORD 0
      } SG_PACK PCIE_UNCORR_ERR_STATUS, *PPCIE_UNCORR_ERR_STATUS;

      typedef union _PCIE_UNCORR_ERR_STATUS_UNION {
         PCIE_UNCORR_ERR_STATUS bits;
         u32 dw; // dword union
      } SG_PACK PCIE_UNCORR_ERR_STATUS_UNION, *PPCIE_UNCORR_ERR_STATUS_UNION;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_STATUS_UNION, sizeof (PCIE_UNCORR_ERR_STATUS_UNION) == 4);
   #endif


#else
   // PCI Express Uncorrectable Error Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_UNCORR_ERR_STATUS {
         union {
            struct { 
               u32 training_err : 1;              // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 data_link_prot_err : 1;        // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 poison_tlp_err : 1;            // DWORD 0
               u32 flow_ctl_prot_err : 1;         // DWORD 0
               u32 cpl_timeout_err : 1;           // DWORD 0
               u32 cmpltr_abort_err : 1;          // DWORD 0
               u32 unexp_cpl_err : 1;             // DWORD 0
               u32 rcvr_overflow_err : 1;         // DWORD 0
               u32 malformed_tlp_err : 1;         // DWORD 0
               u32 ecrc_err : 1;                  // DWORD 0
               u32 unsupp_req_err : 1;            // DWORD 0
               u32 rsvd2 : 11;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_UNCORR_ERR_STATUS, *PPCIE_UNCORR_ERR_STATUS;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_STATUS, sizeof (PCIE_UNCORR_ERR_STATUS) == 4);

   #else
      typedef struct _PCIE_UNCORR_ERR_STATUS {
         u32 training_err : 1;                    // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 data_link_prot_err : 1;              // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 poison_tlp_err : 1;                  // DWORD 0
         u32 flow_ctl_prot_err : 1;               // DWORD 0
         u32 cpl_timeout_err : 1;                 // DWORD 0
         u32 cmpltr_abort_err : 1;                // DWORD 0
         u32 unexp_cpl_err : 1;                   // DWORD 0
         u32 rcvr_overflow_err : 1;               // DWORD 0
         u32 malformed_tlp_err : 1;               // DWORD 0
         u32 ecrc_err : 1;                        // DWORD 0
         u32 unsupp_req_err : 1;                  // DWORD 0
         u32 rsvd2 : 11;                          // DWORD 0
      } SG_PACK PCIE_UNCORR_ERR_STATUS, *PPCIE_UNCORR_ERR_STATUS;

      typedef union _PCIE_UNCORR_ERR_STATUS_UNION {
         PCIE_UNCORR_ERR_STATUS bits;
         u32 dw; // dword union
      } SG_PACK PCIE_UNCORR_ERR_STATUS_UNION, *PPCIE_UNCORR_ERR_STATUS_UNION;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_STATUS_UNION, sizeof (PCIE_UNCORR_ERR_STATUS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Uncorrectable Error Mask Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_UNCORR_ERR_MASK {
         union {
            struct { 
               u32 rsvd2 : 11;                    // DWORD 0
               u32 unsupp_req_err : 1;            // DWORD 0
               u32 ecrc_err : 1;                  // DWORD 0
               u32 malformed_tlp_err : 1;         // DWORD 0
               u32 rcvr_overflow_err : 1;         // DWORD 0
               u32 unexp_cpl_err : 1;             // DWORD 0
               u32 cmpltr_abort_err : 1;          // DWORD 0
               u32 cpl_timeout_err : 1;           // DWORD 0
               u32 flow_ctl_prot_err : 1;         // DWORD 0
               u32 poison_tlp_err : 1;            // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 data_link_prot_err : 1;        // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 training_err : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_UNCORR_ERR_MASK, *PPCIE_UNCORR_ERR_MASK;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_MASK, sizeof (PCIE_UNCORR_ERR_MASK) == 4);

   #else
      typedef struct _PCIE_UNCORR_ERR_MASK {
         u32 rsvd2 : 11;                          // DWORD 0
         u32 unsupp_req_err : 1;                  // DWORD 0
         u32 ecrc_err : 1;                        // DWORD 0
         u32 malformed_tlp_err : 1;               // DWORD 0
         u32 rcvr_overflow_err : 1;               // DWORD 0
         u32 unexp_cpl_err : 1;                   // DWORD 0
         u32 cmpltr_abort_err : 1;                // DWORD 0
         u32 cpl_timeout_err : 1;                 // DWORD 0
         u32 flow_ctl_prot_err : 1;               // DWORD 0
         u32 poison_tlp_err : 1;                  // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 data_link_prot_err : 1;              // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 training_err : 1;                    // DWORD 0
      } SG_PACK PCIE_UNCORR_ERR_MASK, *PPCIE_UNCORR_ERR_MASK;

      typedef union _PCIE_UNCORR_ERR_MASK_UNION {
         PCIE_UNCORR_ERR_MASK bits;
         u32 dw; // dword union
      } SG_PACK PCIE_UNCORR_ERR_MASK_UNION, *PPCIE_UNCORR_ERR_MASK_UNION;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_MASK_UNION, sizeof (PCIE_UNCORR_ERR_MASK_UNION) == 4);
   #endif


#else
   // PCI Express Uncorrectable Error Mask Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_UNCORR_ERR_MASK {
         union {
            struct { 
               u32 training_err : 1;              // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 data_link_prot_err : 1;        // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 poison_tlp_err : 1;            // DWORD 0
               u32 flow_ctl_prot_err : 1;         // DWORD 0
               u32 cpl_timeout_err : 1;           // DWORD 0
               u32 cmpltr_abort_err : 1;          // DWORD 0
               u32 unexp_cpl_err : 1;             // DWORD 0
               u32 rcvr_overflow_err : 1;         // DWORD 0
               u32 malformed_tlp_err : 1;         // DWORD 0
               u32 ecrc_err : 1;                  // DWORD 0
               u32 unsupp_req_err : 1;            // DWORD 0
               u32 rsvd2 : 11;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_UNCORR_ERR_MASK, *PPCIE_UNCORR_ERR_MASK;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_MASK, sizeof (PCIE_UNCORR_ERR_MASK) == 4);

   #else
      typedef struct _PCIE_UNCORR_ERR_MASK {
         u32 training_err : 1;                    // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 data_link_prot_err : 1;              // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 poison_tlp_err : 1;                  // DWORD 0
         u32 flow_ctl_prot_err : 1;               // DWORD 0
         u32 cpl_timeout_err : 1;                 // DWORD 0
         u32 cmpltr_abort_err : 1;                // DWORD 0
         u32 unexp_cpl_err : 1;                   // DWORD 0
         u32 rcvr_overflow_err : 1;               // DWORD 0
         u32 malformed_tlp_err : 1;               // DWORD 0
         u32 ecrc_err : 1;                        // DWORD 0
         u32 unsupp_req_err : 1;                  // DWORD 0
         u32 rsvd2 : 11;                          // DWORD 0
      } SG_PACK PCIE_UNCORR_ERR_MASK, *PPCIE_UNCORR_ERR_MASK;

      typedef union _PCIE_UNCORR_ERR_MASK_UNION {
         PCIE_UNCORR_ERR_MASK bits;
         u32 dw; // dword union
      } SG_PACK PCIE_UNCORR_ERR_MASK_UNION, *PPCIE_UNCORR_ERR_MASK_UNION;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_MASK_UNION, sizeof (PCIE_UNCORR_ERR_MASK_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Uncorrectable Error Severity Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_UNCORR_ERR_SEVERITY {
         union {
            struct { 
               u32 rsvd2 : 11;                    // DWORD 0
               u32 unsupp_req_err : 1;            // DWORD 0
               u32 ecrc_err : 1;                  // DWORD 0
               u32 malformed_tlp_err : 1;         // DWORD 0
               u32 rcvr_overflow_err : 1;         // DWORD 0
               u32 unexp_cpl_err : 1;             // DWORD 0
               u32 cmpltr_abort_err : 1;          // DWORD 0
               u32 cpl_timeout_err : 1;           // DWORD 0
               u32 flow_ctl_prot_err : 1;         // DWORD 0
               u32 poison_tlp_err : 1;            // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 data_link_prot_err : 1;        // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 training_err : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_UNCORR_ERR_SEVERITY, *PPCIE_UNCORR_ERR_SEVERITY;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_SEVERITY, sizeof (PCIE_UNCORR_ERR_SEVERITY) == 4);

   #else
      typedef struct _PCIE_UNCORR_ERR_SEVERITY {
         u32 rsvd2 : 11;                          // DWORD 0
         u32 unsupp_req_err : 1;                  // DWORD 0
         u32 ecrc_err : 1;                        // DWORD 0
         u32 malformed_tlp_err : 1;               // DWORD 0
         u32 rcvr_overflow_err : 1;               // DWORD 0
         u32 unexp_cpl_err : 1;                   // DWORD 0
         u32 cmpltr_abort_err : 1;                // DWORD 0
         u32 cpl_timeout_err : 1;                 // DWORD 0
         u32 flow_ctl_prot_err : 1;               // DWORD 0
         u32 poison_tlp_err : 1;                  // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 data_link_prot_err : 1;              // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 training_err : 1;                    // DWORD 0
      } SG_PACK PCIE_UNCORR_ERR_SEVERITY, *PPCIE_UNCORR_ERR_SEVERITY;

      typedef union _PCIE_UNCORR_ERR_SEVERITY_UNION {
         PCIE_UNCORR_ERR_SEVERITY bits;
         u32 dw; // dword union
      } SG_PACK PCIE_UNCORR_ERR_SEVERITY_UNION, *PPCIE_UNCORR_ERR_SEVERITY_UNION;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_SEVERITY_UNION, sizeof (PCIE_UNCORR_ERR_SEVERITY_UNION) == 4);
   #endif


#else
   // PCI Express Uncorrectable Error Severity Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_UNCORR_ERR_SEVERITY {
         union {
            struct { 
               u32 training_err : 1;              // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 data_link_prot_err : 1;        // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 poison_tlp_err : 1;            // DWORD 0
               u32 flow_ctl_prot_err : 1;         // DWORD 0
               u32 cpl_timeout_err : 1;           // DWORD 0
               u32 cmpltr_abort_err : 1;          // DWORD 0
               u32 unexp_cpl_err : 1;             // DWORD 0
               u32 rcvr_overflow_err : 1;         // DWORD 0
               u32 malformed_tlp_err : 1;         // DWORD 0
               u32 ecrc_err : 1;                  // DWORD 0
               u32 unsupp_req_err : 1;            // DWORD 0
               u32 rsvd2 : 11;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_UNCORR_ERR_SEVERITY, *PPCIE_UNCORR_ERR_SEVERITY;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_SEVERITY, sizeof (PCIE_UNCORR_ERR_SEVERITY) == 4);

   #else
      typedef struct _PCIE_UNCORR_ERR_SEVERITY {
         u32 training_err : 1;                    // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 data_link_prot_err : 1;              // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 poison_tlp_err : 1;                  // DWORD 0
         u32 flow_ctl_prot_err : 1;               // DWORD 0
         u32 cpl_timeout_err : 1;                 // DWORD 0
         u32 cmpltr_abort_err : 1;                // DWORD 0
         u32 unexp_cpl_err : 1;                   // DWORD 0
         u32 rcvr_overflow_err : 1;               // DWORD 0
         u32 malformed_tlp_err : 1;               // DWORD 0
         u32 ecrc_err : 1;                        // DWORD 0
         u32 unsupp_req_err : 1;                  // DWORD 0
         u32 rsvd2 : 11;                          // DWORD 0
      } SG_PACK PCIE_UNCORR_ERR_SEVERITY, *PPCIE_UNCORR_ERR_SEVERITY;

      typedef union _PCIE_UNCORR_ERR_SEVERITY_UNION {
         PCIE_UNCORR_ERR_SEVERITY bits;
         u32 dw; // dword union
      } SG_PACK PCIE_UNCORR_ERR_SEVERITY_UNION, *PPCIE_UNCORR_ERR_SEVERITY_UNION;

      SG_C_ASSERT(__sizeof__PCIE_UNCORR_ERR_SEVERITY_UNION, sizeof (PCIE_UNCORR_ERR_SEVERITY_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Correctable Error Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_CORR_ERR_STATUS {
         union {
            struct { 
               u32 rsvd2 : 18;                    // DWORD 0
               u32 advisory_no_fatal_error_status : 1; // DWORD 0
               u32 replay_timer_timeout_err : 1;  // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 replay_num_rollover_err : 1;   // DWORD 0
               u32 bad_dllp_err : 1;              // DWORD 0
               u32 bad_tlp_err : 1;               // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 rcvr_err : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_CORR_ERR_STATUS, *PPCIE_CORR_ERR_STATUS;

      SG_C_ASSERT(__sizeof__PCIE_CORR_ERR_STATUS, sizeof (PCIE_CORR_ERR_STATUS) == 4);

   #else
      typedef struct _PCIE_CORR_ERR_STATUS {
         u32 rsvd2 : 18;                          // DWORD 0
         u32 advisory_no_fatal_error_status : 1;  // DWORD 0
         u32 replay_timer_timeout_err : 1;        // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 replay_num_rollover_err : 1;         // DWORD 0
         u32 bad_dllp_err : 1;                    // DWORD 0
         u32 bad_tlp_err : 1;                     // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 rcvr_err : 1;                        // DWORD 0
      } SG_PACK PCIE_CORR_ERR_STATUS, *PPCIE_CORR_ERR_STATUS;

      typedef union _PCIE_CORR_ERR_STATUS_UNION {
         PCIE_CORR_ERR_STATUS bits;
         u32 dw; // dword union
      } SG_PACK PCIE_CORR_ERR_STATUS_UNION, *PPCIE_CORR_ERR_STATUS_UNION;

      SG_C_ASSERT(__sizeof__PCIE_CORR_ERR_STATUS_UNION, sizeof (PCIE_CORR_ERR_STATUS_UNION) == 4);
   #endif


#else
   // PCI Express Correctable Error Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_CORR_ERR_STATUS {
         union {
            struct { 
               u32 rcvr_err : 1;                  // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 bad_tlp_err : 1;               // DWORD 0
               u32 bad_dllp_err : 1;              // DWORD 0
               u32 replay_num_rollover_err : 1;   // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 replay_timer_timeout_err : 1;  // DWORD 0
               u32 advisory_no_fatal_error_status : 1; // DWORD 0
               u32 rsvd2 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_CORR_ERR_STATUS, *PPCIE_CORR_ERR_STATUS;

      SG_C_ASSERT(__sizeof__PCIE_CORR_ERR_STATUS, sizeof (PCIE_CORR_ERR_STATUS) == 4);

   #else
      typedef struct _PCIE_CORR_ERR_STATUS {
         u32 rcvr_err : 1;                        // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 bad_tlp_err : 1;                     // DWORD 0
         u32 bad_dllp_err : 1;                    // DWORD 0
         u32 replay_num_rollover_err : 1;         // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 replay_timer_timeout_err : 1;        // DWORD 0
         u32 advisory_no_fatal_error_status : 1;  // DWORD 0
         u32 rsvd2 : 18;                          // DWORD 0
      } SG_PACK PCIE_CORR_ERR_STATUS, *PPCIE_CORR_ERR_STATUS;

      typedef union _PCIE_CORR_ERR_STATUS_UNION {
         PCIE_CORR_ERR_STATUS bits;
         u32 dw; // dword union
      } SG_PACK PCIE_CORR_ERR_STATUS_UNION, *PPCIE_CORR_ERR_STATUS_UNION;

      SG_C_ASSERT(__sizeof__PCIE_CORR_ERR_STATUS_UNION, sizeof (PCIE_CORR_ERR_STATUS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Correctable Error Mask Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_CORR_ERR_MASK {
         union {
            struct { 
               u32 rsvd2 : 18;                    // DWORD 0
               u32 advisory_no_fatal_error_mask : 1; // DWORD 0
               u32 replay_timer_timeout_err : 1;  // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 replay_num_rollover_err : 1;   // DWORD 0
               u32 bad_dllp_err : 1;              // DWORD 0
               u32 bad_tlp_err : 1;               // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 rcvr_err : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_CORR_ERR_MASK, *PPCIE_CORR_ERR_MASK;

      SG_C_ASSERT(__sizeof__PCIE_CORR_ERR_MASK, sizeof (PCIE_CORR_ERR_MASK) == 4);

   #else
      typedef struct _PCIE_CORR_ERR_MASK {
         u32 rsvd2 : 18;                          // DWORD 0
         u32 advisory_no_fatal_error_mask : 1;    // DWORD 0
         u32 replay_timer_timeout_err : 1;        // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 replay_num_rollover_err : 1;         // DWORD 0
         u32 bad_dllp_err : 1;                    // DWORD 0
         u32 bad_tlp_err : 1;                     // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 rcvr_err : 1;                        // DWORD 0
      } SG_PACK PCIE_CORR_ERR_MASK, *PPCIE_CORR_ERR_MASK;

      typedef union _PCIE_CORR_ERR_MASK_UNION {
         PCIE_CORR_ERR_MASK bits;
         u32 dw; // dword union
      } SG_PACK PCIE_CORR_ERR_MASK_UNION, *PPCIE_CORR_ERR_MASK_UNION;

      SG_C_ASSERT(__sizeof__PCIE_CORR_ERR_MASK_UNION, sizeof (PCIE_CORR_ERR_MASK_UNION) == 4);
   #endif


#else
   // PCI Express Correctable Error Mask Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_CORR_ERR_MASK {
         union {
            struct { 
               u32 rcvr_err : 1;                  // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 bad_tlp_err : 1;               // DWORD 0
               u32 bad_dllp_err : 1;              // DWORD 0
               u32 replay_num_rollover_err : 1;   // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 replay_timer_timeout_err : 1;  // DWORD 0
               u32 advisory_no_fatal_error_mask : 1; // DWORD 0
               u32 rsvd2 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_CORR_ERR_MASK, *PPCIE_CORR_ERR_MASK;

      SG_C_ASSERT(__sizeof__PCIE_CORR_ERR_MASK, sizeof (PCIE_CORR_ERR_MASK) == 4);

   #else
      typedef struct _PCIE_CORR_ERR_MASK {
         u32 rcvr_err : 1;                        // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 bad_tlp_err : 1;                     // DWORD 0
         u32 bad_dllp_err : 1;                    // DWORD 0
         u32 replay_num_rollover_err : 1;         // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 replay_timer_timeout_err : 1;        // DWORD 0
         u32 advisory_no_fatal_error_mask : 1;    // DWORD 0
         u32 rsvd2 : 18;                          // DWORD 0
      } SG_PACK PCIE_CORR_ERR_MASK, *PPCIE_CORR_ERR_MASK;

      typedef union _PCIE_CORR_ERR_MASK_UNION {
         PCIE_CORR_ERR_MASK bits;
         u32 dw; // dword union
      } SG_PACK PCIE_CORR_ERR_MASK_UNION, *PPCIE_CORR_ERR_MASK_UNION;

      SG_C_ASSERT(__sizeof__PCIE_CORR_ERR_MASK_UNION, sizeof (PCIE_CORR_ERR_MASK_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Advanced Error Capabilities and Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ERR_CAP_CONTROL {
         union {
            struct { 
               u32 rsvd0 : 23;                    // DWORD 0
               u32 ecrc_chk_en : 1;               // DWORD 0
               u32 ecrc_chk_cap : 1;              // DWORD 0
               u32 ecrc_gen_en : 1;               // DWORD 0
               u32 ecrc_gen_cap : 1;              // DWORD 0
               u32 first_uncorr_err_ptr : 5;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ERR_CAP_CONTROL, *PPCIE_ERR_CAP_CONTROL;

      SG_C_ASSERT(__sizeof__PCIE_ERR_CAP_CONTROL, sizeof (PCIE_ERR_CAP_CONTROL) == 4);

   #else
      typedef struct _PCIE_ERR_CAP_CONTROL {
         u32 rsvd0 : 23;                          // DWORD 0
         u32 ecrc_chk_en : 1;                     // DWORD 0
         u32 ecrc_chk_cap : 1;                    // DWORD 0
         u32 ecrc_gen_en : 1;                     // DWORD 0
         u32 ecrc_gen_cap : 1;                    // DWORD 0
         u32 first_uncorr_err_ptr : 5;            // DWORD 0
      } SG_PACK PCIE_ERR_CAP_CONTROL, *PPCIE_ERR_CAP_CONTROL;

      typedef union _PCIE_ERR_CAP_CONTROL_UNION {
         PCIE_ERR_CAP_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ERR_CAP_CONTROL_UNION, *PPCIE_ERR_CAP_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ERR_CAP_CONTROL_UNION, sizeof (PCIE_ERR_CAP_CONTROL_UNION) == 4);
   #endif


#else
   // PCI Express Advanced Error Capabilities and Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_ERR_CAP_CONTROL {
         union {
            struct { 
               u32 first_uncorr_err_ptr : 5;      // DWORD 0
               u32 ecrc_gen_cap : 1;              // DWORD 0
               u32 ecrc_gen_en : 1;               // DWORD 0
               u32 ecrc_chk_cap : 1;              // DWORD 0
               u32 ecrc_chk_en : 1;               // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_ERR_CAP_CONTROL, *PPCIE_ERR_CAP_CONTROL;

      SG_C_ASSERT(__sizeof__PCIE_ERR_CAP_CONTROL, sizeof (PCIE_ERR_CAP_CONTROL) == 4);

   #else
      typedef struct _PCIE_ERR_CAP_CONTROL {
         u32 first_uncorr_err_ptr : 5;            // DWORD 0
         u32 ecrc_gen_cap : 1;                    // DWORD 0
         u32 ecrc_gen_en : 1;                     // DWORD 0
         u32 ecrc_chk_cap : 1;                    // DWORD 0
         u32 ecrc_chk_en : 1;                     // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
      } SG_PACK PCIE_ERR_CAP_CONTROL, *PPCIE_ERR_CAP_CONTROL;

      typedef union _PCIE_ERR_CAP_CONTROL_UNION {
         PCIE_ERR_CAP_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK PCIE_ERR_CAP_CONTROL_UNION, *PPCIE_ERR_CAP_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__PCIE_ERR_CAP_CONTROL_UNION, sizeof (PCIE_ERR_CAP_CONTROL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express Header Log Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_HEADER_REGISTER {
         union {
            struct { 
               u32 failheader;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_HEADER_REGISTER, *PPCIE_HEADER_REGISTER;

      SG_C_ASSERT(__sizeof__PCIE_HEADER_REGISTER, sizeof (PCIE_HEADER_REGISTER) == 4);

   #else
      typedef struct _PCIE_HEADER_REGISTER {
         u32 failheader;                          // DWORD 0
      } SG_PACK PCIE_HEADER_REGISTER, *PPCIE_HEADER_REGISTER;

      typedef union _PCIE_HEADER_REGISTER_UNION {
         PCIE_HEADER_REGISTER bits;
         u32 dw; // dword union
      } SG_PACK PCIE_HEADER_REGISTER_UNION, *PPCIE_HEADER_REGISTER_UNION;

      SG_C_ASSERT(__sizeof__PCIE_HEADER_REGISTER_UNION, sizeof (PCIE_HEADER_REGISTER_UNION) == 4);
   #endif


#else
   // PCI Express Header Log Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_HEADER_REGISTER {
         union {
            struct { 
               u32 failheader;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_HEADER_REGISTER, *PPCIE_HEADER_REGISTER;

      SG_C_ASSERT(__sizeof__PCIE_HEADER_REGISTER, sizeof (PCIE_HEADER_REGISTER) == 4);

   #else
      typedef struct _PCIE_HEADER_REGISTER {
         u32 failheader;                          // DWORD 0
      } SG_PACK PCIE_HEADER_REGISTER, *PPCIE_HEADER_REGISTER;

      typedef union _PCIE_HEADER_REGISTER_UNION {
         PCIE_HEADER_REGISTER bits;
         u32 dw; // dword union
      } SG_PACK PCIE_HEADER_REGISTER_UNION, *PPCIE_HEADER_REGISTER_UNION;

      SG_C_ASSERT(__sizeof__PCIE_HEADER_REGISTER_UNION, sizeof (PCIE_HEADER_REGISTER_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express SR-IOV Cabability ID Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SR_IOV_ENHANCED_CAP {
         union {
            struct { 
               u32 next_cap_offset : 12;          // DWORD 0
               u32 sr_iov_capver : 4;             // DWORD 0
               u32 sr_iov_capid : 16;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SR_IOV_ENHANCED_CAP, *PPCIE_SR_IOV_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_ENHANCED_CAP, sizeof (PCIE_SR_IOV_ENHANCED_CAP) == 4);

   #else
      typedef struct _PCIE_SR_IOV_ENHANCED_CAP {
         u32 next_cap_offset : 12;                // DWORD 0
         u32 sr_iov_capver : 4;                   // DWORD 0
         u32 sr_iov_capid : 16;                   // DWORD 0
      } SG_PACK PCIE_SR_IOV_ENHANCED_CAP, *PPCIE_SR_IOV_ENHANCED_CAP;

      typedef union _PCIE_SR_IOV_ENHANCED_CAP_UNION {
         PCIE_SR_IOV_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SR_IOV_ENHANCED_CAP_UNION, *PPCIE_SR_IOV_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_ENHANCED_CAP_UNION, sizeof (PCIE_SR_IOV_ENHANCED_CAP_UNION) == 4);
   #endif


#else
   // PCI Express SR-IOV Cabability ID Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SR_IOV_ENHANCED_CAP {
         union {
            struct { 
               u32 sr_iov_capid : 16;             // DWORD 0
               u32 sr_iov_capver : 4;             // DWORD 0
               u32 next_cap_offset : 12;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SR_IOV_ENHANCED_CAP, *PPCIE_SR_IOV_ENHANCED_CAP;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_ENHANCED_CAP, sizeof (PCIE_SR_IOV_ENHANCED_CAP) == 4);

   #else
      typedef struct _PCIE_SR_IOV_ENHANCED_CAP {
         u32 sr_iov_capid : 16;                   // DWORD 0
         u32 sr_iov_capver : 4;                   // DWORD 0
         u32 next_cap_offset : 12;                // DWORD 0
      } SG_PACK PCIE_SR_IOV_ENHANCED_CAP, *PPCIE_SR_IOV_ENHANCED_CAP;

      typedef union _PCIE_SR_IOV_ENHANCED_CAP_UNION {
         PCIE_SR_IOV_ENHANCED_CAP bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SR_IOV_ENHANCED_CAP_UNION, *PPCIE_SR_IOV_ENHANCED_CAP_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_ENHANCED_CAP_UNION, sizeof (PCIE_SR_IOV_ENHANCED_CAP_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express SR-IOV Cababilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SR_IOV_CAPABILITIES {
         union {
            struct { 
               u32 vf_migration_intr_msg_no : 11; // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
               u32 vf_migration : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SR_IOV_CAPABILITIES, *PPCIE_SR_IOV_CAPABILITIES;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_CAPABILITIES, sizeof (PCIE_SR_IOV_CAPABILITIES) == 4);

   #else
      typedef struct _PCIE_SR_IOV_CAPABILITIES {
         u32 vf_migration_intr_msg_no : 11;       // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
         u32 vf_migration : 1;                    // DWORD 0
      } SG_PACK PCIE_SR_IOV_CAPABILITIES, *PPCIE_SR_IOV_CAPABILITIES;

      typedef union _PCIE_SR_IOV_CAPABILITIES_UNION {
         PCIE_SR_IOV_CAPABILITIES bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SR_IOV_CAPABILITIES_UNION, *PPCIE_SR_IOV_CAPABILITIES_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_CAPABILITIES_UNION, sizeof (PCIE_SR_IOV_CAPABILITIES_UNION) == 4);
   #endif


#else
   // PCI Express SR-IOV Cababilities Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SR_IOV_CAPABILITIES {
         union {
            struct { 
               u32 vf_migration : 1;              // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
               u32 vf_migration_intr_msg_no : 11; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SR_IOV_CAPABILITIES, *PPCIE_SR_IOV_CAPABILITIES;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_CAPABILITIES, sizeof (PCIE_SR_IOV_CAPABILITIES) == 4);

   #else
      typedef struct _PCIE_SR_IOV_CAPABILITIES {
         u32 vf_migration : 1;                    // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
         u32 vf_migration_intr_msg_no : 11;       // DWORD 0
      } SG_PACK PCIE_SR_IOV_CAPABILITIES, *PPCIE_SR_IOV_CAPABILITIES;

      typedef union _PCIE_SR_IOV_CAPABILITIES_UNION {
         PCIE_SR_IOV_CAPABILITIES bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SR_IOV_CAPABILITIES_UNION, *PPCIE_SR_IOV_CAPABILITIES_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_CAPABILITIES_UNION, sizeof (PCIE_SR_IOV_CAPABILITIES_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express SR-IOV Status Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SR_IOV_STATUS_CONTROL {
         union {
            struct { 
               u32 rsvd1 : 15;                    // DWORD 0
               u32 VF_migration_status : 1;       // DWORD 0
               u32 rsvd0 : 11;                    // DWORD 0
               u32 VF_ARI_enable : 1;             // DWORD 0
               u32 VF_memory_space_enable : 1;    // DWORD 0
               u32 VF_migration_intr_enable : 1;  // DWORD 0
               u32 VF_migration_enable : 1;       // DWORD 0
               u32 VF_enable : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SR_IOV_STATUS_CONTROL, *PPCIE_SR_IOV_STATUS_CONTROL;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_STATUS_CONTROL, sizeof (PCIE_SR_IOV_STATUS_CONTROL) == 4);

   #else
      typedef struct _PCIE_SR_IOV_STATUS_CONTROL {
         u32 rsvd1 : 15;                          // DWORD 0
         u32 VF_migration_status : 1;             // DWORD 0
         u32 rsvd0 : 11;                          // DWORD 0
         u32 VF_ARI_enable : 1;                   // DWORD 0
         u32 VF_memory_space_enable : 1;          // DWORD 0
         u32 VF_migration_intr_enable : 1;        // DWORD 0
         u32 VF_migration_enable : 1;             // DWORD 0
         u32 VF_enable : 1;                       // DWORD 0
      } SG_PACK PCIE_SR_IOV_STATUS_CONTROL, *PPCIE_SR_IOV_STATUS_CONTROL;

      typedef union _PCIE_SR_IOV_STATUS_CONTROL_UNION {
         PCIE_SR_IOV_STATUS_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SR_IOV_STATUS_CONTROL_UNION, *PPCIE_SR_IOV_STATUS_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_STATUS_CONTROL_UNION, sizeof (PCIE_SR_IOV_STATUS_CONTROL_UNION) == 4);
   #endif


#else
   // PCI Express SR-IOV Status Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SR_IOV_STATUS_CONTROL {
         union {
            struct { 
               u32 VF_enable : 1;                 // DWORD 0
               u32 VF_migration_enable : 1;       // DWORD 0
               u32 VF_migration_intr_enable : 1;  // DWORD 0
               u32 VF_memory_space_enable : 1;    // DWORD 0
               u32 VF_ARI_enable : 1;             // DWORD 0
               u32 rsvd0 : 11;                    // DWORD 0
               u32 VF_migration_status : 1;       // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SR_IOV_STATUS_CONTROL, *PPCIE_SR_IOV_STATUS_CONTROL;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_STATUS_CONTROL, sizeof (PCIE_SR_IOV_STATUS_CONTROL) == 4);

   #else
      typedef struct _PCIE_SR_IOV_STATUS_CONTROL {
         u32 VF_enable : 1;                       // DWORD 0
         u32 VF_migration_enable : 1;             // DWORD 0
         u32 VF_migration_intr_enable : 1;        // DWORD 0
         u32 VF_memory_space_enable : 1;          // DWORD 0
         u32 VF_ARI_enable : 1;                   // DWORD 0
         u32 rsvd0 : 11;                          // DWORD 0
         u32 VF_migration_status : 1;             // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK PCIE_SR_IOV_STATUS_CONTROL, *PPCIE_SR_IOV_STATUS_CONTROL;

      typedef union _PCIE_SR_IOV_STATUS_CONTROL_UNION {
         PCIE_SR_IOV_STATUS_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SR_IOV_STATUS_CONTROL_UNION, *PPCIE_SR_IOV_STATUS_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SR_IOV_STATUS_CONTROL_UNION, sizeof (PCIE_SR_IOV_STATUS_CONTROL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express SR-IOV Total No. of VFs and Initial No. of VFs per PF.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_TOTAL_INITIAL_VFs {
         union {
            struct { 
               u32 total_VFs : 16;                // DWORD 0
               u32 initial_VFs : 16;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_TOTAL_INITIAL_VFs, *PPCIE_TOTAL_INITIAL_VFs;

      SG_C_ASSERT(__sizeof__PCIE_TOTAL_INITIAL_VFs, sizeof (PCIE_TOTAL_INITIAL_VFs) == 4);

   #else
      typedef struct _PCIE_TOTAL_INITIAL_VFs {
         u32 total_VFs : 16;                      // DWORD 0
         u32 initial_VFs : 16;                    // DWORD 0
      } SG_PACK PCIE_TOTAL_INITIAL_VFs, *PPCIE_TOTAL_INITIAL_VFs;

      typedef union _PCIE_TOTAL_INITIAL_VFs_UNION {
         PCIE_TOTAL_INITIAL_VFs bits;
         u32 dw; // dword union
      } SG_PACK PCIE_TOTAL_INITIAL_VFs_UNION, *PPCIE_TOTAL_INITIAL_VFs_UNION;

      SG_C_ASSERT(__sizeof__PCIE_TOTAL_INITIAL_VFs_UNION, sizeof (PCIE_TOTAL_INITIAL_VFs_UNION) == 4);
   #endif


#else
   // PCI Express SR-IOV Total No. of VFs and Initial No. of VFs per PF.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_TOTAL_INITIAL_VFs {
         union {
            struct { 
               u32 initial_VFs : 16;              // DWORD 0
               u32 total_VFs : 16;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_TOTAL_INITIAL_VFs, *PPCIE_TOTAL_INITIAL_VFs;

      SG_C_ASSERT(__sizeof__PCIE_TOTAL_INITIAL_VFs, sizeof (PCIE_TOTAL_INITIAL_VFs) == 4);

   #else
      typedef struct _PCIE_TOTAL_INITIAL_VFs {
         u32 initial_VFs : 16;                    // DWORD 0
         u32 total_VFs : 16;                      // DWORD 0
      } SG_PACK PCIE_TOTAL_INITIAL_VFs, *PPCIE_TOTAL_INITIAL_VFs;

      typedef union _PCIE_TOTAL_INITIAL_VFs_UNION {
         PCIE_TOTAL_INITIAL_VFs bits;
         u32 dw; // dword union
      } SG_PACK PCIE_TOTAL_INITIAL_VFs_UNION, *PPCIE_TOTAL_INITIAL_VFs_UNION;

      SG_C_ASSERT(__sizeof__PCIE_TOTAL_INITIAL_VFs_UNION, sizeof (PCIE_TOTAL_INITIAL_VFs_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express SR-IOV Number of VFs assigned be software to PF.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_NUM_VFs {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 function_dependency_link : 8;  // DWORD 0
               u32 num_VFs : 16;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_NUM_VFs, *PPCIE_NUM_VFs;

      SG_C_ASSERT(__sizeof__PCIE_NUM_VFs, sizeof (PCIE_NUM_VFs) == 4);

   #else
      typedef struct _PCIE_NUM_VFs {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 function_dependency_link : 8;        // DWORD 0
         u32 num_VFs : 16;                        // DWORD 0
      } SG_PACK PCIE_NUM_VFs, *PPCIE_NUM_VFs;

      typedef union _PCIE_NUM_VFs_UNION {
         PCIE_NUM_VFs bits;
         u32 dw; // dword union
      } SG_PACK PCIE_NUM_VFs_UNION, *PPCIE_NUM_VFs_UNION;

      SG_C_ASSERT(__sizeof__PCIE_NUM_VFs_UNION, sizeof (PCIE_NUM_VFs_UNION) == 4);
   #endif


#else
   // PCI Express SR-IOV Number of VFs assigned be software to PF.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_NUM_VFs {
         union {
            struct { 
               u32 num_VFs : 16;                  // DWORD 0
               u32 function_dependency_link : 8;  // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_NUM_VFs, *PPCIE_NUM_VFs;

      SG_C_ASSERT(__sizeof__PCIE_NUM_VFs, sizeof (PCIE_NUM_VFs) == 4);

   #else
      typedef struct _PCIE_NUM_VFs {
         u32 num_VFs : 16;                        // DWORD 0
         u32 function_dependency_link : 8;        // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK PCIE_NUM_VFs, *PPCIE_NUM_VFs;

      typedef union _PCIE_NUM_VFs_UNION {
         PCIE_NUM_VFs bits;
         u32 dw; // dword union
      } SG_PACK PCIE_NUM_VFs_UNION, *PPCIE_NUM_VFs_UNION;

      SG_C_ASSERT(__sizeof__PCIE_NUM_VFs_UNION, sizeof (PCIE_NUM_VFs_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express VF First Offset and STRIDE.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_VF_STRIDE_OFFSET {
         union {
            struct { 
               u32 VF_stride : 16;                // DWORD 0
               u32 first_VF_offset : 16;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_VF_STRIDE_OFFSET, *PPCIE_VF_STRIDE_OFFSET;

      SG_C_ASSERT(__sizeof__PCIE_VF_STRIDE_OFFSET, sizeof (PCIE_VF_STRIDE_OFFSET) == 4);

   #else
      typedef struct _PCIE_VF_STRIDE_OFFSET {
         u32 VF_stride : 16;                      // DWORD 0
         u32 first_VF_offset : 16;                // DWORD 0
      } SG_PACK PCIE_VF_STRIDE_OFFSET, *PPCIE_VF_STRIDE_OFFSET;

      typedef union _PCIE_VF_STRIDE_OFFSET_UNION {
         PCIE_VF_STRIDE_OFFSET bits;
         u32 dw; // dword union
      } SG_PACK PCIE_VF_STRIDE_OFFSET_UNION, *PPCIE_VF_STRIDE_OFFSET_UNION;

      SG_C_ASSERT(__sizeof__PCIE_VF_STRIDE_OFFSET_UNION, sizeof (PCIE_VF_STRIDE_OFFSET_UNION) == 4);
   #endif


#else
   // PCI Express VF First Offset and STRIDE.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_VF_STRIDE_OFFSET {
         union {
            struct { 
               u32 first_VF_offset : 16;          // DWORD 0
               u32 VF_stride : 16;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_VF_STRIDE_OFFSET, *PPCIE_VF_STRIDE_OFFSET;

      SG_C_ASSERT(__sizeof__PCIE_VF_STRIDE_OFFSET, sizeof (PCIE_VF_STRIDE_OFFSET) == 4);

   #else
      typedef struct _PCIE_VF_STRIDE_OFFSET {
         u32 first_VF_offset : 16;                // DWORD 0
         u32 VF_stride : 16;                      // DWORD 0
      } SG_PACK PCIE_VF_STRIDE_OFFSET, *PPCIE_VF_STRIDE_OFFSET;

      typedef union _PCIE_VF_STRIDE_OFFSET_UNION {
         PCIE_VF_STRIDE_OFFSET bits;
         u32 dw; // dword union
      } SG_PACK PCIE_VF_STRIDE_OFFSET_UNION, *PPCIE_VF_STRIDE_OFFSET_UNION;

      SG_C_ASSERT(__sizeof__PCIE_VF_STRIDE_OFFSET_UNION, sizeof (PCIE_VF_STRIDE_OFFSET_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express VFs Device ID
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_VF_DEVICE_ID {
         union {
            struct { 
               u32 VF_device_id : 16;             // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_VF_DEVICE_ID, *PPCIE_VF_DEVICE_ID;

      SG_C_ASSERT(__sizeof__PCIE_VF_DEVICE_ID, sizeof (PCIE_VF_DEVICE_ID) == 4);

   #else
      typedef struct _PCIE_VF_DEVICE_ID {
         u32 VF_device_id : 16;                   // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK PCIE_VF_DEVICE_ID, *PPCIE_VF_DEVICE_ID;

      typedef union _PCIE_VF_DEVICE_ID_UNION {
         PCIE_VF_DEVICE_ID bits;
         u32 dw; // dword union
      } SG_PACK PCIE_VF_DEVICE_ID_UNION, *PPCIE_VF_DEVICE_ID_UNION;

      SG_C_ASSERT(__sizeof__PCIE_VF_DEVICE_ID_UNION, sizeof (PCIE_VF_DEVICE_ID_UNION) == 4);
   #endif


#else
   // PCI Express VFs Device ID
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_VF_DEVICE_ID {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 VF_device_id : 16;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_VF_DEVICE_ID, *PPCIE_VF_DEVICE_ID;

      SG_C_ASSERT(__sizeof__PCIE_VF_DEVICE_ID, sizeof (PCIE_VF_DEVICE_ID) == 4);

   #else
      typedef struct _PCIE_VF_DEVICE_ID {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 VF_device_id : 16;                   // DWORD 0
      } SG_PACK PCIE_VF_DEVICE_ID, *PPCIE_VF_DEVICE_ID;

      typedef union _PCIE_VF_DEVICE_ID_UNION {
         PCIE_VF_DEVICE_ID bits;
         u32 dw; // dword union
      } SG_PACK PCIE_VF_DEVICE_ID_UNION, *PPCIE_VF_DEVICE_ID_UNION;

      SG_C_ASSERT(__sizeof__PCIE_VF_DEVICE_ID_UNION, sizeof (PCIE_VF_DEVICE_ID_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express System Pages supported by PF.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_VF_SYSTEM_PAGE_SUPPORTED {
         union {
            struct { 
               u32 VF_system_page_size_supported; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_VF_SYSTEM_PAGE_SUPPORTED, *PPCIE_VF_SYSTEM_PAGE_SUPPORTED;

      SG_C_ASSERT(__sizeof__PCIE_VF_SYSTEM_PAGE_SUPPORTED, sizeof (PCIE_VF_SYSTEM_PAGE_SUPPORTED) == 4);

   #else
      typedef struct _PCIE_VF_SYSTEM_PAGE_SUPPORTED {
         u32 VF_system_page_size_supported;       // DWORD 0
      } SG_PACK PCIE_VF_SYSTEM_PAGE_SUPPORTED, *PPCIE_VF_SYSTEM_PAGE_SUPPORTED;

      typedef union _PCIE_VF_SYSTEM_PAGE_SUPPORTED_UNION {
         PCIE_VF_SYSTEM_PAGE_SUPPORTED bits;
         u32 dw; // dword union
      } SG_PACK PCIE_VF_SYSTEM_PAGE_SUPPORTED_UNION, *PPCIE_VF_SYSTEM_PAGE_SUPPORTED_UNION;

      SG_C_ASSERT(__sizeof__PCIE_VF_SYSTEM_PAGE_SUPPORTED_UNION, sizeof (PCIE_VF_SYSTEM_PAGE_SUPPORTED_UNION) == 4);
   #endif


#else
   // PCI Express System Pages supported by PF.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_VF_SYSTEM_PAGE_SUPPORTED {
         union {
            struct { 
               u32 VF_system_page_size_supported; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_VF_SYSTEM_PAGE_SUPPORTED, *PPCIE_VF_SYSTEM_PAGE_SUPPORTED;

      SG_C_ASSERT(__sizeof__PCIE_VF_SYSTEM_PAGE_SUPPORTED, sizeof (PCIE_VF_SYSTEM_PAGE_SUPPORTED) == 4);

   #else
      typedef struct _PCIE_VF_SYSTEM_PAGE_SUPPORTED {
         u32 VF_system_page_size_supported;       // DWORD 0
      } SG_PACK PCIE_VF_SYSTEM_PAGE_SUPPORTED, *PPCIE_VF_SYSTEM_PAGE_SUPPORTED;

      typedef union _PCIE_VF_SYSTEM_PAGE_SUPPORTED_UNION {
         PCIE_VF_SYSTEM_PAGE_SUPPORTED bits;
         u32 dw; // dword union
      } SG_PACK PCIE_VF_SYSTEM_PAGE_SUPPORTED_UNION, *PPCIE_VF_SYSTEM_PAGE_SUPPORTED_UNION;

      SG_C_ASSERT(__sizeof__PCIE_VF_SYSTEM_PAGE_SUPPORTED_UNION, sizeof (PCIE_VF_SYSTEM_PAGE_SUPPORTED_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PCI Express System Page size the system uses.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_VF_SYSTEM_PAGE {
         union {
            struct { 
               u32 rsvd0 : 21;                    // DWORD 0
               u32 VF_system_page_size : 11;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_VF_SYSTEM_PAGE, *PPCIE_VF_SYSTEM_PAGE;

      SG_C_ASSERT(__sizeof__PCIE_VF_SYSTEM_PAGE, sizeof (PCIE_VF_SYSTEM_PAGE) == 4);

   #else
      typedef struct _PCIE_VF_SYSTEM_PAGE {
         u32 rsvd0 : 21;                          // DWORD 0
         u32 VF_system_page_size : 11;            // DWORD 0
      } SG_PACK PCIE_VF_SYSTEM_PAGE, *PPCIE_VF_SYSTEM_PAGE;

      typedef union _PCIE_VF_SYSTEM_PAGE_UNION {
         PCIE_VF_SYSTEM_PAGE bits;
         u32 dw; // dword union
      } SG_PACK PCIE_VF_SYSTEM_PAGE_UNION, *PPCIE_VF_SYSTEM_PAGE_UNION;

      SG_C_ASSERT(__sizeof__PCIE_VF_SYSTEM_PAGE_UNION, sizeof (PCIE_VF_SYSTEM_PAGE_UNION) == 4);
   #endif


#else
   // PCI Express System Page size the system uses.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_VF_SYSTEM_PAGE {
         union {
            struct { 
               u32 VF_system_page_size : 11;      // DWORD 0
               u32 rsvd0 : 21;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_VF_SYSTEM_PAGE, *PPCIE_VF_SYSTEM_PAGE;

      SG_C_ASSERT(__sizeof__PCIE_VF_SYSTEM_PAGE, sizeof (PCIE_VF_SYSTEM_PAGE) == 4);

   #else
      typedef struct _PCIE_VF_SYSTEM_PAGE {
         u32 VF_system_page_size : 11;            // DWORD 0
         u32 rsvd0 : 21;                          // DWORD 0
      } SG_PACK PCIE_VF_SYSTEM_PAGE, *PPCIE_VF_SYSTEM_PAGE;

      typedef union _PCIE_VF_SYSTEM_PAGE_UNION {
         PCIE_VF_SYSTEM_PAGE bits;
         u32 dw; // dword union
      } SG_PACK PCIE_VF_SYSTEM_PAGE_UNION, *PPCIE_VF_SYSTEM_PAGE_UNION;

      SG_C_ASSERT(__sizeof__PCIE_VF_SYSTEM_PAGE_UNION, sizeof (PCIE_VF_SYSTEM_PAGE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // VF Memory BAR 0 - Low Address Register. This space is for all VFs of corresponding
   // PF. Each VF consumes 2 System pages for all system pages, except 4K system page. It
   // consumes 4 system pages for 4K system page. Each VF Space is partitioned as follows:
   // Page0 0to4K-1 is for DB space, Page0 4Kto8K-1 for Cfg space, Page1 0to4K-1 for MSIX
   // Table, Page1 4Kto8K-1 for MSIX PBA.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_VF_MEMBAR0_LO {
         union {
            struct { 
               u32 membar1lo : 8;                 // DWORD 0
               u32 system_page_decode_9 : 1;      // DWORD 0
               u32 system_page_decode_8 : 1;      // DWORD 0
               u32 system_page_decode_7 : 1;      // DWORD 0
               u32 system_page_decode_6 : 1;      // DWORD 0
               u32 system_page_decode_5 : 1;      // DWORD 0
               u32 system_page_decode_4 : 1;      // DWORD 0
               u32 system_page_decode_3 : 1;      // DWORD 0
               u32 system_page_decode_2 : 1;      // DWORD 0
               u32 system_page_decode_1 : 1;      // DWORD 0
               u32 system_page_decode_0 : 1;      // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
               u32 pf : 1;                        // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 memspace : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_VF_MEMBAR0_LO, *PPCICFG_VF_MEMBAR0_LO;

      SG_C_ASSERT(__sizeof__PCICFG_VF_MEMBAR0_LO, sizeof (PCICFG_VF_MEMBAR0_LO) == 4);

   #else
      typedef struct _PCICFG_VF_MEMBAR0_LO {
         u32 membar1lo : 8;                       // DWORD 0
         u32 system_page_decode_9 : 1;            // DWORD 0
         u32 system_page_decode_8 : 1;            // DWORD 0
         u32 system_page_decode_7 : 1;            // DWORD 0
         u32 system_page_decode_6 : 1;            // DWORD 0
         u32 system_page_decode_5 : 1;            // DWORD 0
         u32 system_page_decode_4 : 1;            // DWORD 0
         u32 system_page_decode_3 : 1;            // DWORD 0
         u32 system_page_decode_2 : 1;            // DWORD 0
         u32 system_page_decode_1 : 1;            // DWORD 0
         u32 system_page_decode_0 : 1;            // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 memspace : 1;                        // DWORD 0
      } SG_PACK PCICFG_VF_MEMBAR0_LO, *PPCICFG_VF_MEMBAR0_LO;

      typedef union _PCICFG_VF_MEMBAR0_LO_UNION {
         PCICFG_VF_MEMBAR0_LO bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_VF_MEMBAR0_LO_UNION, *PPCICFG_VF_MEMBAR0_LO_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_VF_MEMBAR0_LO_UNION, sizeof (PCICFG_VF_MEMBAR0_LO_UNION) == 4);
   #endif


#else
   // VF Memory BAR 0 - Low Address Register. This space is for all VFs of corresponding
   // PF. Each VF consumes 2 System pages for all system pages, except 4K system page. It
   // consumes 4 system pages for 4K system page. Each VF Space is partitioned as follows:
   // Page0 0to4K-1 is for DB space, Page0 4Kto8K-1 for Cfg space, Page1 0to4K-1 for MSIX
   // Table, Page1 4Kto8K-1 for MSIX PBA.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_VF_MEMBAR0_LO {
         union {
            struct { 
               u32 memspace : 1;                  // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 pf : 1;                        // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
               u32 system_page_decode_0 : 1;      // DWORD 0
               u32 system_page_decode_1 : 1;      // DWORD 0
               u32 system_page_decode_2 : 1;      // DWORD 0
               u32 system_page_decode_3 : 1;      // DWORD 0
               u32 system_page_decode_4 : 1;      // DWORD 0
               u32 system_page_decode_5 : 1;      // DWORD 0
               u32 system_page_decode_6 : 1;      // DWORD 0
               u32 system_page_decode_7 : 1;      // DWORD 0
               u32 system_page_decode_8 : 1;      // DWORD 0
               u32 system_page_decode_9 : 1;      // DWORD 0
               u32 membar1lo : 8;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_VF_MEMBAR0_LO, *PPCICFG_VF_MEMBAR0_LO;

      SG_C_ASSERT(__sizeof__PCICFG_VF_MEMBAR0_LO, sizeof (PCICFG_VF_MEMBAR0_LO) == 4);

   #else
      typedef struct _PCICFG_VF_MEMBAR0_LO {
         u32 memspace : 1;                        // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 pf : 1;                              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 system_page_decode_0 : 1;            // DWORD 0
         u32 system_page_decode_1 : 1;            // DWORD 0
         u32 system_page_decode_2 : 1;            // DWORD 0
         u32 system_page_decode_3 : 1;            // DWORD 0
         u32 system_page_decode_4 : 1;            // DWORD 0
         u32 system_page_decode_5 : 1;            // DWORD 0
         u32 system_page_decode_6 : 1;            // DWORD 0
         u32 system_page_decode_7 : 1;            // DWORD 0
         u32 system_page_decode_8 : 1;            // DWORD 0
         u32 system_page_decode_9 : 1;            // DWORD 0
         u32 membar1lo : 8;                       // DWORD 0
      } SG_PACK PCICFG_VF_MEMBAR0_LO, *PPCICFG_VF_MEMBAR0_LO;

      typedef union _PCICFG_VF_MEMBAR0_LO_UNION {
         PCICFG_VF_MEMBAR0_LO bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_VF_MEMBAR0_LO_UNION, *PPCICFG_VF_MEMBAR0_LO_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_VF_MEMBAR0_LO_UNION, sizeof (PCICFG_VF_MEMBAR0_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // VF Memory BAR 0 - High Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_VF_MEMBAR0_HI {
         union {
            struct { 
               u32 membar1hi;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_VF_MEMBAR0_HI, *PPCICFG_VF_MEMBAR0_HI;

      SG_C_ASSERT(__sizeof__PCICFG_VF_MEMBAR0_HI, sizeof (PCICFG_VF_MEMBAR0_HI) == 4);

   #else
      typedef struct _PCICFG_VF_MEMBAR0_HI {
         u32 membar1hi;                           // DWORD 0
      } SG_PACK PCICFG_VF_MEMBAR0_HI, *PPCICFG_VF_MEMBAR0_HI;

      typedef union _PCICFG_VF_MEMBAR0_HI_UNION {
         PCICFG_VF_MEMBAR0_HI bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_VF_MEMBAR0_HI_UNION, *PPCICFG_VF_MEMBAR0_HI_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_VF_MEMBAR0_HI_UNION, sizeof (PCICFG_VF_MEMBAR0_HI_UNION) == 4);
   #endif


#else
   // VF Memory BAR 0 - High Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_VF_MEMBAR0_HI {
         union {
            struct { 
               u32 membar1hi;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_VF_MEMBAR0_HI, *PPCICFG_VF_MEMBAR0_HI;

      SG_C_ASSERT(__sizeof__PCICFG_VF_MEMBAR0_HI, sizeof (PCICFG_VF_MEMBAR0_HI) == 4);

   #else
      typedef struct _PCICFG_VF_MEMBAR0_HI {
         u32 membar1hi;                           // DWORD 0
      } SG_PACK PCICFG_VF_MEMBAR0_HI, *PPCICFG_VF_MEMBAR0_HI;

      typedef union _PCICFG_VF_MEMBAR0_HI_UNION {
         PCICFG_VF_MEMBAR0_HI bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_VF_MEMBAR0_HI_UNION, *PPCICFG_VF_MEMBAR0_HI_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_VF_MEMBAR0_HI_UNION, sizeof (PCICFG_VF_MEMBAR0_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // HwDbg SHIFT Selction 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_SHIFT {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 core : 8;                      // DWORD 0
               u32 core_d3 : 8;                   // DWORD 0
               u32 pclk : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_SHIFT, *PPCICFG_HWDBG_SHIFT;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_SHIFT, sizeof (PCICFG_HWDBG_SHIFT) == 4);

   #else
      typedef struct _PCICFG_HWDBG_SHIFT {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 core : 8;                            // DWORD 0
         u32 core_d3 : 8;                         // DWORD 0
         u32 pclk : 8;                            // DWORD 0
      } SG_PACK PCICFG_HWDBG_SHIFT, *PPCICFG_HWDBG_SHIFT;

      typedef union _PCICFG_HWDBG_SHIFT_UNION {
         PCICFG_HWDBG_SHIFT bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_SHIFT_UNION, *PPCICFG_HWDBG_SHIFT_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_SHIFT_UNION, sizeof (PCICFG_HWDBG_SHIFT_UNION) == 4);
   #endif


#else
   // HwDbg SHIFT Selction 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_SHIFT {
         union {
            struct { 
               u32 pclk : 8;                      // DWORD 0
               u32 core_d3 : 8;                   // DWORD 0
               u32 core : 8;                      // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_SHIFT, *PPCICFG_HWDBG_SHIFT;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_SHIFT, sizeof (PCICFG_HWDBG_SHIFT) == 4);

   #else
      typedef struct _PCICFG_HWDBG_SHIFT {
         u32 pclk : 8;                            // DWORD 0
         u32 core_d3 : 8;                         // DWORD 0
         u32 core : 8;                            // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK PCICFG_HWDBG_SHIFT, *PPCICFG_HWDBG_SHIFT;

      typedef union _PCICFG_HWDBG_SHIFT_UNION {
         PCICFG_HWDBG_SHIFT bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_SHIFT_UNION, *PPCICFG_HWDBG_SHIFT_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_SHIFT_UNION, sizeof (PCICFG_HWDBG_SHIFT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Hardware Debug Mask 0 for LPC Clock Domain Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_0_PCLK {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_0_PCLK, *PPCICFG_HWDBG_MASK_0_PCLK;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_PCLK, sizeof (PCICFG_HWDBG_MASK_0_PCLK) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_0_PCLK {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_0_PCLK, *PPCICFG_HWDBG_MASK_0_PCLK;

      typedef union _PCICFG_HWDBG_MASK_0_PCLK_UNION {
         PCICFG_HWDBG_MASK_0_PCLK bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_0_PCLK_UNION, *PPCICFG_HWDBG_MASK_0_PCLK_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_PCLK_UNION, sizeof (PCICFG_HWDBG_MASK_0_PCLK_UNION) == 4);
   #endif


#else
   // Hardware Debug Mask 0 for LPC Clock Domain Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_0_PCLK {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_0_PCLK, *PPCICFG_HWDBG_MASK_0_PCLK;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_PCLK, sizeof (PCICFG_HWDBG_MASK_0_PCLK) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_0_PCLK {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_0_PCLK, *PPCICFG_HWDBG_MASK_0_PCLK;

      typedef union _PCICFG_HWDBG_MASK_0_PCLK_UNION {
         PCICFG_HWDBG_MASK_0_PCLK bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_0_PCLK_UNION, *PPCICFG_HWDBG_MASK_0_PCLK_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_PCLK_UNION, sizeof (PCICFG_HWDBG_MASK_0_PCLK_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Hardware Debug Mask 1 for LPC Clock Domain Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_1_PCLK {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_1_PCLK, *PPCICFG_HWDBG_MASK_1_PCLK;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_PCLK, sizeof (PCICFG_HWDBG_MASK_1_PCLK) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_1_PCLK {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_1_PCLK, *PPCICFG_HWDBG_MASK_1_PCLK;

      typedef union _PCICFG_HWDBG_MASK_1_PCLK_UNION {
         PCICFG_HWDBG_MASK_1_PCLK bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_1_PCLK_UNION, *PPCICFG_HWDBG_MASK_1_PCLK_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_PCLK_UNION, sizeof (PCICFG_HWDBG_MASK_1_PCLK_UNION) == 4);
   #endif


#else
   // Hardware Debug Mask 1 for LPC Clock Domain Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_1_PCLK {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_1_PCLK, *PPCICFG_HWDBG_MASK_1_PCLK;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_PCLK, sizeof (PCICFG_HWDBG_MASK_1_PCLK) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_1_PCLK {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_1_PCLK, *PPCICFG_HWDBG_MASK_1_PCLK;

      typedef union _PCICFG_HWDBG_MASK_1_PCLK_UNION {
         PCICFG_HWDBG_MASK_1_PCLK bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_1_PCLK_UNION, *PPCICFG_HWDBG_MASK_1_PCLK_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_PCLK_UNION, sizeof (PCICFG_HWDBG_MASK_1_PCLK_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Hardware Debug Mask 0 for CORE_D3 Clock Domain Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_0_CORE_D3 {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE_D3, *PPCICFG_HWDBG_MASK_0_CORE_D3;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_CORE_D3, sizeof (PCICFG_HWDBG_MASK_0_CORE_D3) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_0_CORE_D3 {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE_D3, *PPCICFG_HWDBG_MASK_0_CORE_D3;

      typedef union _PCICFG_HWDBG_MASK_0_CORE_D3_UNION {
         PCICFG_HWDBG_MASK_0_CORE_D3 bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE_D3_UNION, *PPCICFG_HWDBG_MASK_0_CORE_D3_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_CORE_D3_UNION, sizeof (PCICFG_HWDBG_MASK_0_CORE_D3_UNION) == 4);
   #endif


#else
   // Hardware Debug Mask 0 for CORE_D3 Clock Domain Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_0_CORE_D3 {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE_D3, *PPCICFG_HWDBG_MASK_0_CORE_D3;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_CORE_D3, sizeof (PCICFG_HWDBG_MASK_0_CORE_D3) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_0_CORE_D3 {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE_D3, *PPCICFG_HWDBG_MASK_0_CORE_D3;

      typedef union _PCICFG_HWDBG_MASK_0_CORE_D3_UNION {
         PCICFG_HWDBG_MASK_0_CORE_D3 bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE_D3_UNION, *PPCICFG_HWDBG_MASK_0_CORE_D3_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_CORE_D3_UNION, sizeof (PCICFG_HWDBG_MASK_0_CORE_D3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Hardware Debug Mask 1 for CORE_D3 Clock Domain Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_1_CORE_D3 {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE_D3, *PPCICFG_HWDBG_MASK_1_CORE_D3;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_CORE_D3, sizeof (PCICFG_HWDBG_MASK_1_CORE_D3) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_1_CORE_D3 {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE_D3, *PPCICFG_HWDBG_MASK_1_CORE_D3;

      typedef union _PCICFG_HWDBG_MASK_1_CORE_D3_UNION {
         PCICFG_HWDBG_MASK_1_CORE_D3 bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE_D3_UNION, *PPCICFG_HWDBG_MASK_1_CORE_D3_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_CORE_D3_UNION, sizeof (PCICFG_HWDBG_MASK_1_CORE_D3_UNION) == 4);
   #endif


#else
   // Hardware Debug Mask 1 for CORE_D3 Clock Domain Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_1_CORE_D3 {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE_D3, *PPCICFG_HWDBG_MASK_1_CORE_D3;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_CORE_D3, sizeof (PCICFG_HWDBG_MASK_1_CORE_D3) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_1_CORE_D3 {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE_D3, *PPCICFG_HWDBG_MASK_1_CORE_D3;

      typedef union _PCICFG_HWDBG_MASK_1_CORE_D3_UNION {
         PCICFG_HWDBG_MASK_1_CORE_D3 bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE_D3_UNION, *PPCICFG_HWDBG_MASK_1_CORE_D3_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_CORE_D3_UNION, sizeof (PCICFG_HWDBG_MASK_1_CORE_D3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Hardware Debug Mask 0 for CORE Clock Domain Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_0_CORE {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE, *PPCICFG_HWDBG_MASK_0_CORE;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_CORE, sizeof (PCICFG_HWDBG_MASK_0_CORE) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_0_CORE {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE, *PPCICFG_HWDBG_MASK_0_CORE;

      typedef union _PCICFG_HWDBG_MASK_0_CORE_UNION {
         PCICFG_HWDBG_MASK_0_CORE bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE_UNION, *PPCICFG_HWDBG_MASK_0_CORE_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_CORE_UNION, sizeof (PCICFG_HWDBG_MASK_0_CORE_UNION) == 4);
   #endif


#else
   // Hardware Debug Mask 0 for CORE Clock Domain Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_0_CORE {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE, *PPCICFG_HWDBG_MASK_0_CORE;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_CORE, sizeof (PCICFG_HWDBG_MASK_0_CORE) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_0_CORE {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE, *PPCICFG_HWDBG_MASK_0_CORE;

      typedef union _PCICFG_HWDBG_MASK_0_CORE_UNION {
         PCICFG_HWDBG_MASK_0_CORE bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_0_CORE_UNION, *PPCICFG_HWDBG_MASK_0_CORE_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_0_CORE_UNION, sizeof (PCICFG_HWDBG_MASK_0_CORE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Hardware Debug Mask 1 for CORE Clock Domain Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_1_CORE {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE, *PPCICFG_HWDBG_MASK_1_CORE;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_CORE, sizeof (PCICFG_HWDBG_MASK_1_CORE) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_1_CORE {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE, *PPCICFG_HWDBG_MASK_1_CORE;

      typedef union _PCICFG_HWDBG_MASK_1_CORE_UNION {
         PCICFG_HWDBG_MASK_1_CORE bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE_UNION, *PPCICFG_HWDBG_MASK_1_CORE_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_CORE_UNION, sizeof (PCICFG_HWDBG_MASK_1_CORE_UNION) == 4);
   #endif


#else
   // Hardware Debug Mask 1 for CORE Clock Domain Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_MASK_1_CORE {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE, *PPCICFG_HWDBG_MASK_1_CORE;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_CORE, sizeof (PCICFG_HWDBG_MASK_1_CORE) == 4);

   #else
      typedef struct _PCICFG_HWDBG_MASK_1_CORE {
         u32 value;                               // DWORD 0
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE, *PPCICFG_HWDBG_MASK_1_CORE;

      typedef union _PCICFG_HWDBG_MASK_1_CORE_UNION {
         PCICFG_HWDBG_MASK_1_CORE bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_MASK_1_CORE_UNION, *PPCICFG_HWDBG_MASK_1_CORE_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_MASK_1_CORE_UNION, sizeof (PCICFG_HWDBG_MASK_1_CORE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Hardware Debug Register Select Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_REGSEL {
         union {
            struct { 
               u32 up_stream_write_count : 8;     // DWORD 0
               u32 core : 8;                      // DWORD 0
               u32 core_d3 : 8;                   // DWORD 0
               u32 pclk : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_REGSEL, *PPCICFG_HWDBG_REGSEL;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_REGSEL, sizeof (PCICFG_HWDBG_REGSEL) == 4);

   #else
      typedef struct _PCICFG_HWDBG_REGSEL {
         u32 up_stream_write_count : 8;           // DWORD 0
         u32 core : 8;                            // DWORD 0
         u32 core_d3 : 8;                         // DWORD 0
         u32 pclk : 8;                            // DWORD 0
      } SG_PACK PCICFG_HWDBG_REGSEL, *PPCICFG_HWDBG_REGSEL;

      typedef union _PCICFG_HWDBG_REGSEL_UNION {
         PCICFG_HWDBG_REGSEL bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_REGSEL_UNION, *PPCICFG_HWDBG_REGSEL_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_REGSEL_UNION, sizeof (PCICFG_HWDBG_REGSEL_UNION) == 4);
   #endif


#else
   // Hardware Debug Register Select Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_REGSEL {
         union {
            struct { 
               u32 pclk : 8;                      // DWORD 0
               u32 core_d3 : 8;                   // DWORD 0
               u32 core : 8;                      // DWORD 0
               u32 up_stream_write_count : 8;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_REGSEL, *PPCICFG_HWDBG_REGSEL;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_REGSEL, sizeof (PCICFG_HWDBG_REGSEL) == 4);

   #else
      typedef struct _PCICFG_HWDBG_REGSEL {
         u32 pclk : 8;                            // DWORD 0
         u32 core_d3 : 8;                         // DWORD 0
         u32 core : 8;                            // DWORD 0
         u32 up_stream_write_count : 8;           // DWORD 0
      } SG_PACK PCICFG_HWDBG_REGSEL, *PPCICFG_HWDBG_REGSEL;

      typedef union _PCICFG_HWDBG_REGSEL_UNION {
         PCICFG_HWDBG_REGSEL bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_REGSEL_UNION, *PPCICFG_HWDBG_REGSEL_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_REGSEL_UNION, sizeof (PCICFG_HWDBG_REGSEL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Hardware Debug Enable Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_ENABLE {
         union {
            struct { 
               u32 up_stream_read_count : 8;      // DWORD 0
               u32 rsvd2 : 7;                     // DWORD 0
               u32 core : 1;                      // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 core_d3 : 1;                   // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 pclk : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_ENABLE, *PPCICFG_HWDBG_ENABLE;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_ENABLE, sizeof (PCICFG_HWDBG_ENABLE) == 4);

   #else
      typedef struct _PCICFG_HWDBG_ENABLE {
         u32 up_stream_read_count : 8;            // DWORD 0
         u32 rsvd2 : 7;                           // DWORD 0
         u32 core : 1;                            // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 core_d3 : 1;                         // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 pclk : 1;                            // DWORD 0
      } SG_PACK PCICFG_HWDBG_ENABLE, *PPCICFG_HWDBG_ENABLE;

      typedef union _PCICFG_HWDBG_ENABLE_UNION {
         PCICFG_HWDBG_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_ENABLE_UNION, *PPCICFG_HWDBG_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_ENABLE_UNION, sizeof (PCICFG_HWDBG_ENABLE_UNION) == 4);
   #endif


#else
   // Hardware Debug Enable Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_HWDBG_ENABLE {
         union {
            struct { 
               u32 pclk : 1;                      // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 core_d3 : 1;                   // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 core : 1;                      // DWORD 0
               u32 rsvd2 : 7;                     // DWORD 0
               u32 up_stream_read_count : 8;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_HWDBG_ENABLE, *PPCICFG_HWDBG_ENABLE;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_ENABLE, sizeof (PCICFG_HWDBG_ENABLE) == 4);

   #else
      typedef struct _PCICFG_HWDBG_ENABLE {
         u32 pclk : 1;                            // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 core_d3 : 1;                         // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 core : 1;                            // DWORD 0
         u32 rsvd2 : 7;                           // DWORD 0
         u32 up_stream_read_count : 8;            // DWORD 0
      } SG_PACK PCICFG_HWDBG_ENABLE, *PPCICFG_HWDBG_ENABLE;

      typedef union _PCICFG_HWDBG_ENABLE_UNION {
         PCICFG_HWDBG_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK PCICFG_HWDBG_ENABLE_UNION, *PPCICFG_HWDBG_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_HWDBG_ENABLE_UNION, sizeof (PCICFG_HWDBG_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // hwdbg_cfgreg_i[31:0]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_0 {
         union {
            struct { 
               u32 host_dbg_mux_data_core_o_31_0; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_0, *Phwdbg_cfgreg_i_0;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_0, sizeof (hwdbg_cfgreg_i_0) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_0 {
         u32 host_dbg_mux_data_core_o_31_0;       // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_0, *Phwdbg_cfgreg_i_0;

      typedef union _hwdbg_cfgreg_i_0_UNION {
         hwdbg_cfgreg_i_0 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_0_UNION, *Phwdbg_cfgreg_i_0_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_0_UNION, sizeof (hwdbg_cfgreg_i_0_UNION) == 4);
   #endif


#else
   // hwdbg_cfgreg_i[31:0]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_0 {
         union {
            struct { 
               u32 host_dbg_mux_data_core_o_31_0; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_0, *Phwdbg_cfgreg_i_0;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_0, sizeof (hwdbg_cfgreg_i_0) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_0 {
         u32 host_dbg_mux_data_core_o_31_0;       // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_0, *Phwdbg_cfgreg_i_0;

      typedef union _hwdbg_cfgreg_i_0_UNION {
         hwdbg_cfgreg_i_0 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_0_UNION, *Phwdbg_cfgreg_i_0_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_0_UNION, sizeof (hwdbg_cfgreg_i_0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // hwdbg_cfgreg_i[63:32]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_1 {
         union {
            struct { 
               u32 host_dbg_mux_data_core_o_63_32; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_1, *Phwdbg_cfgreg_i_1;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_1, sizeof (hwdbg_cfgreg_i_1) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_1 {
         u32 host_dbg_mux_data_core_o_63_32;      // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_1, *Phwdbg_cfgreg_i_1;

      typedef union _hwdbg_cfgreg_i_1_UNION {
         hwdbg_cfgreg_i_1 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_1_UNION, *Phwdbg_cfgreg_i_1_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_1_UNION, sizeof (hwdbg_cfgreg_i_1_UNION) == 4);
   #endif


#else
   // hwdbg_cfgreg_i[63:32]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_1 {
         union {
            struct { 
               u32 host_dbg_mux_data_core_o_63_32; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_1, *Phwdbg_cfgreg_i_1;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_1, sizeof (hwdbg_cfgreg_i_1) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_1 {
         u32 host_dbg_mux_data_core_o_63_32;      // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_1, *Phwdbg_cfgreg_i_1;

      typedef union _hwdbg_cfgreg_i_1_UNION {
         hwdbg_cfgreg_i_1 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_1_UNION, *Phwdbg_cfgreg_i_1_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_1_UNION, sizeof (hwdbg_cfgreg_i_1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // hwdbg_cfgreg_i[95:64]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_2 {
         union {
            struct { 
               u32 host_dbg_mux_data_core_d3_o_31_0; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_2, *Phwdbg_cfgreg_i_2;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_2, sizeof (hwdbg_cfgreg_i_2) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_2 {
         u32 host_dbg_mux_data_core_d3_o_31_0;    // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_2, *Phwdbg_cfgreg_i_2;

      typedef union _hwdbg_cfgreg_i_2_UNION {
         hwdbg_cfgreg_i_2 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_2_UNION, *Phwdbg_cfgreg_i_2_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_2_UNION, sizeof (hwdbg_cfgreg_i_2_UNION) == 4);
   #endif


#else
   // hwdbg_cfgreg_i[95:64]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_2 {
         union {
            struct { 
               u32 host_dbg_mux_data_core_d3_o_31_0; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_2, *Phwdbg_cfgreg_i_2;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_2, sizeof (hwdbg_cfgreg_i_2) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_2 {
         u32 host_dbg_mux_data_core_d3_o_31_0;    // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_2, *Phwdbg_cfgreg_i_2;

      typedef union _hwdbg_cfgreg_i_2_UNION {
         hwdbg_cfgreg_i_2 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_2_UNION, *Phwdbg_cfgreg_i_2_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_2_UNION, sizeof (hwdbg_cfgreg_i_2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FCP Timer, Beacon Enable, PCI-E Configuration override
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 nec_ll_f0_mode_selectable_deemphasis : 1; // DWORD 0
               u32 nec_ll_f0_mode_ep_ats_ur_enable : 1; // DWORD 0
               u32 nec_ll_f0_mode_cpld_nonsuccess_malform_enable : 1; // DWORD 0
               u32 nec_ll_ui_enter_txl0s : 1;     // DWORD 0
               u32 mode_electrical_idle_infer_ts_detect : 1; // DWORD 0
               u32 mode_electrical_idle_infer_skp_detect : 1; // DWORD 0
               u32 mode_electrical_idle_infer_fc_detect : 1; // DWORD 0
               u32 mode_link_upcfg_cap_dis : 1;   // DWORD 0
               u32 mode_link_upcfg_cap_dis_force : 1; // DWORD 0
               u32 fcp_timer_force : 1;           // DWORD 0
               u32 fcp_timer : 13;                // DWORD 0
               u32 pcicfg_override : 1;           // DWORD 0
               u32 beacon_en : 1;                 // DWORD 0
               u32 lane_rev : 1;                  // DWORD 0
               u32 plbsel : 1;                    // DWORD 0
               u32 lbsel : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE, *PPCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE;

      SG_C_ASSERT(__sizeof__PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE, sizeof (PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE) == 4);

   #else
      typedef struct _PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 nec_ll_f0_mode_selectable_deemphasis : 1; // DWORD 0
         u32 nec_ll_f0_mode_ep_ats_ur_enable : 1; // DWORD 0
         u32 nec_ll_f0_mode_cpld_nonsuccess_malform_enable : 1; // DWORD 0
         u32 nec_ll_ui_enter_txl0s : 1;           // DWORD 0
         u32 mode_electrical_idle_infer_ts_detect : 1; // DWORD 0
         u32 mode_electrical_idle_infer_skp_detect : 1; // DWORD 0
         u32 mode_electrical_idle_infer_fc_detect : 1; // DWORD 0
         u32 mode_link_upcfg_cap_dis : 1;         // DWORD 0
         u32 mode_link_upcfg_cap_dis_force : 1;   // DWORD 0
         u32 fcp_timer_force : 1;                 // DWORD 0
         u32 fcp_timer : 13;                      // DWORD 0
         u32 pcicfg_override : 1;                 // DWORD 0
         u32 beacon_en : 1;                       // DWORD 0
         u32 lane_rev : 1;                        // DWORD 0
         u32 plbsel : 1;                          // DWORD 0
         u32 lbsel : 1;                           // DWORD 0
      } SG_PACK PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE, *PPCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE;

      typedef union _PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_UNION {
         PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE bits;
         u32 dw; // dword union
      } SG_PACK PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_UNION, *PPCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_UNION;

      SG_C_ASSERT(__sizeof__PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_UNION, sizeof (PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_UNION) == 4);
   #endif


#else
   // FCP Timer, Beacon Enable, PCI-E Configuration override
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE {
         union {
            struct { 
               u32 lbsel : 1;                     // DWORD 0
               u32 plbsel : 1;                    // DWORD 0
               u32 lane_rev : 1;                  // DWORD 0
               u32 beacon_en : 1;                 // DWORD 0
               u32 pcicfg_override : 1;           // DWORD 0
               u32 fcp_timer : 13;                // DWORD 0
               u32 fcp_timer_force : 1;           // DWORD 0
               u32 mode_link_upcfg_cap_dis_force : 1; // DWORD 0
               u32 mode_link_upcfg_cap_dis : 1;   // DWORD 0
               u32 mode_electrical_idle_infer_fc_detect : 1; // DWORD 0
               u32 mode_electrical_idle_infer_skp_detect : 1; // DWORD 0
               u32 mode_electrical_idle_infer_ts_detect : 1; // DWORD 0
               u32 nec_ll_ui_enter_txl0s : 1;     // DWORD 0
               u32 nec_ll_f0_mode_cpld_nonsuccess_malform_enable : 1; // DWORD 0
               u32 nec_ll_f0_mode_ep_ats_ur_enable : 1; // DWORD 0
               u32 nec_ll_f0_mode_selectable_deemphasis : 1; // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE, *PPCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE;

      SG_C_ASSERT(__sizeof__PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE, sizeof (PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE) == 4);

   #else
      typedef struct _PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE {
         u32 lbsel : 1;                           // DWORD 0
         u32 plbsel : 1;                          // DWORD 0
         u32 lane_rev : 1;                        // DWORD 0
         u32 beacon_en : 1;                       // DWORD 0
         u32 pcicfg_override : 1;                 // DWORD 0
         u32 fcp_timer : 13;                      // DWORD 0
         u32 fcp_timer_force : 1;                 // DWORD 0
         u32 mode_link_upcfg_cap_dis_force : 1;   // DWORD 0
         u32 mode_link_upcfg_cap_dis : 1;         // DWORD 0
         u32 mode_electrical_idle_infer_fc_detect : 1; // DWORD 0
         u32 mode_electrical_idle_infer_skp_detect : 1; // DWORD 0
         u32 mode_electrical_idle_infer_ts_detect : 1; // DWORD 0
         u32 nec_ll_ui_enter_txl0s : 1;           // DWORD 0
         u32 nec_ll_f0_mode_cpld_nonsuccess_malform_enable : 1; // DWORD 0
         u32 nec_ll_f0_mode_ep_ats_ur_enable : 1; // DWORD 0
         u32 nec_ll_f0_mode_selectable_deemphasis : 1; // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE, *PPCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE;

      typedef union _PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_UNION {
         PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE bits;
         u32 dw; // dword union
      } SG_PACK PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_UNION, *PPCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_UNION;

      SG_C_ASSERT(__sizeof__PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_UNION, sizeof (PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Option ROM to Flash Translation Address
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_OPTION_ROM_FLASH_TRANSLATION_F0 {
         union {
            struct { 
               u32 exprom_translation_addr : 16;  // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 disable_ecrc : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F0, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F0;

      SG_C_ASSERT(__sizeof__PCIE_OPTION_ROM_FLASH_TRANSLATION_F0, sizeof (PCIE_OPTION_ROM_FLASH_TRANSLATION_F0) == 4);

   #else
      typedef struct _PCIE_OPTION_ROM_FLASH_TRANSLATION_F0 {
         u32 exprom_translation_addr : 16;        // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 disable_ecrc : 1;                    // DWORD 0
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F0, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F0;

      typedef union _PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_UNION {
         PCIE_OPTION_ROM_FLASH_TRANSLATION_F0 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_UNION, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F0_UNION;

      SG_C_ASSERT(__sizeof__PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_UNION, sizeof (PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_UNION) == 4);
   #endif


#else
   // Option ROM to Flash Translation Address
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_OPTION_ROM_FLASH_TRANSLATION_F0 {
         union {
            struct { 
               u32 disable_ecrc : 1;              // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 exprom_translation_addr : 16;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F0, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F0;

      SG_C_ASSERT(__sizeof__PCIE_OPTION_ROM_FLASH_TRANSLATION_F0, sizeof (PCIE_OPTION_ROM_FLASH_TRANSLATION_F0) == 4);

   #else
      typedef struct _PCIE_OPTION_ROM_FLASH_TRANSLATION_F0 {
         u32 disable_ecrc : 1;                    // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 exprom_translation_addr : 16;        // DWORD 0
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F0, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F0;

      typedef union _PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_UNION {
         PCIE_OPTION_ROM_FLASH_TRANSLATION_F0 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_UNION, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F0_UNION;

      SG_C_ASSERT(__sizeof__PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_UNION, sizeof (PCIE_OPTION_ROM_FLASH_TRANSLATION_F0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Option ROM to Flash Translation Address
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_OPTION_ROM_FLASH_TRANSLATION_F1 {
         union {
            struct { 
               u32 exprom_translation_addr : 16;  // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 disable_ecrc : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F1, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F1;

      SG_C_ASSERT(__sizeof__PCIE_OPTION_ROM_FLASH_TRANSLATION_F1, sizeof (PCIE_OPTION_ROM_FLASH_TRANSLATION_F1) == 4);

   #else
      typedef struct _PCIE_OPTION_ROM_FLASH_TRANSLATION_F1 {
         u32 exprom_translation_addr : 16;        // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 disable_ecrc : 1;                    // DWORD 0
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F1, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F1;

      typedef union _PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_UNION {
         PCIE_OPTION_ROM_FLASH_TRANSLATION_F1 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_UNION, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F1_UNION;

      SG_C_ASSERT(__sizeof__PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_UNION, sizeof (PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_UNION) == 4);
   #endif


#else
   // Option ROM to Flash Translation Address
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_OPTION_ROM_FLASH_TRANSLATION_F1 {
         union {
            struct { 
               u32 disable_ecrc : 1;              // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 exprom_translation_addr : 16;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F1, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F1;

      SG_C_ASSERT(__sizeof__PCIE_OPTION_ROM_FLASH_TRANSLATION_F1, sizeof (PCIE_OPTION_ROM_FLASH_TRANSLATION_F1) == 4);

   #else
      typedef struct _PCIE_OPTION_ROM_FLASH_TRANSLATION_F1 {
         u32 disable_ecrc : 1;                    // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 exprom_translation_addr : 16;        // DWORD 0
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F1, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F1;

      typedef union _PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_UNION {
         PCIE_OPTION_ROM_FLASH_TRANSLATION_F1 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_UNION, *PPCIE_OPTION_ROM_FLASH_TRANSLATION_F1_UNION;

      SG_C_ASSERT(__sizeof__PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_UNION, sizeof (PCIE_OPTION_ROM_FLASH_TRANSLATION_F1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_LTSSM_CHANGE_CMD_CFG_RETRY {
         union {
            struct { 
               u32 pid_wr : 1;                    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 disable_cfg_retry : 1;         // DWORD 0
               u32 pid_addr : 5;                  // DWORD 0
               u32 LTSSM_state_from_L0 : 7;       // DWORD 0
               u32 pid_wdata : 17;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_LTSSM_CHANGE_CMD_CFG_RETRY, *PPCIE_LTSSM_CHANGE_CMD_CFG_RETRY;

      SG_C_ASSERT(__sizeof__PCIE_LTSSM_CHANGE_CMD_CFG_RETRY, sizeof (PCIE_LTSSM_CHANGE_CMD_CFG_RETRY) == 4);

   #else
      typedef struct _PCIE_LTSSM_CHANGE_CMD_CFG_RETRY {
         u32 pid_wr : 1;                          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 disable_cfg_retry : 1;               // DWORD 0
         u32 pid_addr : 5;                        // DWORD 0
         u32 LTSSM_state_from_L0 : 7;             // DWORD 0
         u32 pid_wdata : 17;                      // DWORD 0
      } SG_PACK PCIE_LTSSM_CHANGE_CMD_CFG_RETRY, *PPCIE_LTSSM_CHANGE_CMD_CFG_RETRY;

      typedef union _PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_UNION {
         PCIE_LTSSM_CHANGE_CMD_CFG_RETRY bits;
         u32 dw; // dword union
      } SG_PACK PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_UNION, *PPCIE_LTSSM_CHANGE_CMD_CFG_RETRY_UNION;

      SG_C_ASSERT(__sizeof__PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_UNION, sizeof (PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_LTSSM_CHANGE_CMD_CFG_RETRY {
         union {
            struct { 
               u32 pid_wdata : 17;                // DWORD 0
               u32 LTSSM_state_from_L0 : 7;       // DWORD 0
               u32 pid_addr : 5;                  // DWORD 0
               u32 disable_cfg_retry : 1;         // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 pid_wr : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_LTSSM_CHANGE_CMD_CFG_RETRY, *PPCIE_LTSSM_CHANGE_CMD_CFG_RETRY;

      SG_C_ASSERT(__sizeof__PCIE_LTSSM_CHANGE_CMD_CFG_RETRY, sizeof (PCIE_LTSSM_CHANGE_CMD_CFG_RETRY) == 4);

   #else
      typedef struct _PCIE_LTSSM_CHANGE_CMD_CFG_RETRY {
         u32 pid_wdata : 17;                      // DWORD 0
         u32 LTSSM_state_from_L0 : 7;             // DWORD 0
         u32 pid_addr : 5;                        // DWORD 0
         u32 disable_cfg_retry : 1;               // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 pid_wr : 1;                          // DWORD 0
      } SG_PACK PCIE_LTSSM_CHANGE_CMD_CFG_RETRY, *PPCIE_LTSSM_CHANGE_CMD_CFG_RETRY;

      typedef union _PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_UNION {
         PCIE_LTSSM_CHANGE_CMD_CFG_RETRY bits;
         u32 dw; // dword union
      } SG_PACK PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_UNION, *PPCIE_LTSSM_CHANGE_CMD_CFG_RETRY_UNION;

      SG_C_ASSERT(__sizeof__PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_UNION, sizeof (PCIE_LTSSM_CHANGE_CMD_CFG_RETRY_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET {
         union {
            struct { 
               u32 rsvd0 : 20;                    // DWORD 0
               u32 ari_next_cap_offset : 12;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET, *PPCIE_PF_VFS_ARI_NEXT_CAP_OFFSET;

      SG_C_ASSERT(__sizeof__PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET, sizeof (PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET) == 4);

   #else
      typedef struct _PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET {
         u32 rsvd0 : 20;                          // DWORD 0
         u32 ari_next_cap_offset : 12;            // DWORD 0
      } SG_PACK PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET, *PPCIE_PF_VFS_ARI_NEXT_CAP_OFFSET;

      typedef union _PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_UNION {
         PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET bits;
         u32 dw; // dword union
      } SG_PACK PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_UNION, *PPCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_UNION;

      SG_C_ASSERT(__sizeof__PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_UNION, sizeof (PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET {
         union {
            struct { 
               u32 ari_next_cap_offset : 12;      // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET, *PPCIE_PF_VFS_ARI_NEXT_CAP_OFFSET;

      SG_C_ASSERT(__sizeof__PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET, sizeof (PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET) == 4);

   #else
      typedef struct _PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET {
         u32 ari_next_cap_offset : 12;            // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
      } SG_PACK PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET, *PPCIE_PF_VFS_ARI_NEXT_CAP_OFFSET;

      typedef union _PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_UNION {
         PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET bits;
         u32 dw; // dword union
      } SG_PACK PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_UNION, *PPCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_UNION;

      SG_C_ASSERT(__sizeof__PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_UNION, sizeof (PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register is available in PF1
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2 {
         union {
            struct { 
               u32 EMPHASIS_CTRL : 1;             // DWORD 0
               u32 rsvd3 : 2;                     // DWORD 0
               u32 TISEMPPO_6_0db : 5;            // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 TISEMPMA_6_0db : 6;            // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 TISEMPPO_3_5db : 5;            // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 TISEMPMA_3_5db : 6;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN2;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2, sizeof (PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2) == 4);

   #else
      typedef struct _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2 {
         u32 EMPHASIS_CTRL : 1;                   // DWORD 0
         u32 rsvd3 : 2;                           // DWORD 0
         u32 TISEMPPO_6_0db : 5;                  // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 TISEMPMA_6_0db : 6;                  // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 TISEMPPO_3_5db : 5;                  // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 TISEMPMA_3_5db : 6;                  // DWORD 0
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN2;

      typedef union _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_UNION {
         PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_UNION, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_UNION, sizeof (PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_UNION) == 4);
   #endif


#else
   // This register is available in PF1
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2 {
         union {
            struct { 
               u32 TISEMPMA_3_5db : 6;            // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 TISEMPPO_3_5db : 5;            // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 TISEMPMA_6_0db : 6;            // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 TISEMPPO_6_0db : 5;            // DWORD 0
               u32 rsvd3 : 2;                     // DWORD 0
               u32 EMPHASIS_CTRL : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN2;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2, sizeof (PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2) == 4);

   #else
      typedef struct _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2 {
         u32 TISEMPMA_3_5db : 6;                  // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 TISEMPPO_3_5db : 5;                  // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 TISEMPMA_6_0db : 6;                  // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 TISEMPPO_6_0db : 5;                  // DWORD 0
         u32 rsvd3 : 2;                           // DWORD 0
         u32 EMPHASIS_CTRL : 1;                   // DWORD 0
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN2;

      typedef union _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_UNION {
         PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_UNION, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_UNION, sizeof (PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register is available in PF1
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SERDES_TISAMP_GEN2 {
         union {
            struct { 
               u32 rsvd3 : 3;                     // DWORD 0
               u32 TISAMP_4 : 5;                  // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 TISAMP_3 : 5;                  // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 TISAMP_2 : 5;                  // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 TISAMP_1 : 5;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SERDES_TISAMP_GEN2, *PPCIE_SERDES_TISAMP_GEN2;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISAMP_GEN2, sizeof (PCIE_SERDES_TISAMP_GEN2) == 4);

   #else
      typedef struct _PCIE_SERDES_TISAMP_GEN2 {
         u32 rsvd3 : 3;                           // DWORD 0
         u32 TISAMP_4 : 5;                        // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 TISAMP_3 : 5;                        // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 TISAMP_2 : 5;                        // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 TISAMP_1 : 5;                        // DWORD 0
      } SG_PACK PCIE_SERDES_TISAMP_GEN2, *PPCIE_SERDES_TISAMP_GEN2;

      typedef union _PCIE_SERDES_TISAMP_GEN2_UNION {
         PCIE_SERDES_TISAMP_GEN2 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SERDES_TISAMP_GEN2_UNION, *PPCIE_SERDES_TISAMP_GEN2_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISAMP_GEN2_UNION, sizeof (PCIE_SERDES_TISAMP_GEN2_UNION) == 4);
   #endif


#else
   // This register is available in PF1
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SERDES_TISAMP_GEN2 {
         union {
            struct { 
               u32 TISAMP_1 : 5;                  // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 TISAMP_2 : 5;                  // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 TISAMP_3 : 5;                  // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 TISAMP_4 : 5;                  // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SERDES_TISAMP_GEN2, *PPCIE_SERDES_TISAMP_GEN2;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISAMP_GEN2, sizeof (PCIE_SERDES_TISAMP_GEN2) == 4);

   #else
      typedef struct _PCIE_SERDES_TISAMP_GEN2 {
         u32 TISAMP_1 : 5;                        // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 TISAMP_2 : 5;                        // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 TISAMP_3 : 5;                        // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 TISAMP_4 : 5;                        // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK PCIE_SERDES_TISAMP_GEN2, *PPCIE_SERDES_TISAMP_GEN2;

      typedef union _PCIE_SERDES_TISAMP_GEN2_UNION {
         PCIE_SERDES_TISAMP_GEN2 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SERDES_TISAMP_GEN2_UNION, *PPCIE_SERDES_TISAMP_GEN2_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISAMP_GEN2_UNION, sizeof (PCIE_SERDES_TISAMP_GEN2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register is available in PF1
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1 {
         union {
            struct { 
               u32 rsvd3 : 3;                     // DWORD 0
               u32 TISEMPPO_6_0db : 5;            // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 TISEMPMA_6_0db : 6;            // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 TISEMPPO_3_5db : 5;            // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 TISEMPMA_3_5db : 6;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN1;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1, sizeof (PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1) == 4);

   #else
      typedef struct _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1 {
         u32 rsvd3 : 3;                           // DWORD 0
         u32 TISEMPPO_6_0db : 5;                  // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 TISEMPMA_6_0db : 6;                  // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 TISEMPPO_3_5db : 5;                  // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 TISEMPMA_3_5db : 6;                  // DWORD 0
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN1;

      typedef union _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_UNION {
         PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_UNION, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_UNION, sizeof (PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_UNION) == 4);
   #endif


#else
   // This register is available in PF1
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1 {
         union {
            struct { 
               u32 TISEMPMA_3_5db : 6;            // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 TISEMPPO_3_5db : 5;            // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 TISEMPMA_6_0db : 6;            // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 TISEMPPO_6_0db : 5;            // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN1;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1, sizeof (PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1) == 4);

   #else
      typedef struct _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1 {
         u32 TISEMPMA_3_5db : 6;                  // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 TISEMPPO_3_5db : 5;                  // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 TISEMPMA_6_0db : 6;                  // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 TISEMPPO_6_0db : 5;                  // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN1;

      typedef union _PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_UNION {
         PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_UNION, *PPCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_UNION, sizeof (PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register is available in PF1
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SERDES_TISAMP_GEN1 {
         union {
            struct { 
               u32 rsvd3 : 3;                     // DWORD 0
               u32 TISAMP_4 : 5;                  // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 TISAMP_3 : 5;                  // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 TISAMP_2 : 5;                  // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 TISAMP_1 : 5;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SERDES_TISAMP_GEN1, *PPCIE_SERDES_TISAMP_GEN1;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISAMP_GEN1, sizeof (PCIE_SERDES_TISAMP_GEN1) == 4);

   #else
      typedef struct _PCIE_SERDES_TISAMP_GEN1 {
         u32 rsvd3 : 3;                           // DWORD 0
         u32 TISAMP_4 : 5;                        // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 TISAMP_3 : 5;                        // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 TISAMP_2 : 5;                        // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 TISAMP_1 : 5;                        // DWORD 0
      } SG_PACK PCIE_SERDES_TISAMP_GEN1, *PPCIE_SERDES_TISAMP_GEN1;

      typedef union _PCIE_SERDES_TISAMP_GEN1_UNION {
         PCIE_SERDES_TISAMP_GEN1 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SERDES_TISAMP_GEN1_UNION, *PPCIE_SERDES_TISAMP_GEN1_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISAMP_GEN1_UNION, sizeof (PCIE_SERDES_TISAMP_GEN1_UNION) == 4);
   #endif


#else
   // This register is available in PF1
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SERDES_TISAMP_GEN1 {
         union {
            struct { 
               u32 TISAMP_1 : 5;                  // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 TISAMP_2 : 5;                  // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 TISAMP_3 : 5;                  // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 TISAMP_4 : 5;                  // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SERDES_TISAMP_GEN1, *PPCIE_SERDES_TISAMP_GEN1;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISAMP_GEN1, sizeof (PCIE_SERDES_TISAMP_GEN1) == 4);

   #else
      typedef struct _PCIE_SERDES_TISAMP_GEN1 {
         u32 TISAMP_1 : 5;                        // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 TISAMP_2 : 5;                        // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 TISAMP_3 : 5;                        // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 TISAMP_4 : 5;                        // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK PCIE_SERDES_TISAMP_GEN1, *PPCIE_SERDES_TISAMP_GEN1;

      typedef union _PCIE_SERDES_TISAMP_GEN1_UNION {
         PCIE_SERDES_TISAMP_GEN1 bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SERDES_TISAMP_GEN1_UNION, *PPCIE_SERDES_TISAMP_GEN1_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_TISAMP_GEN1_UNION, sizeof (PCIE_SERDES_TISAMP_GEN1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SERDES_RISEQC {
         union {
            struct { 
               u32 BITS_FUTURE : 8;               // DWORD 0
               u32 RISEQC7 : 3;                   // DWORD 0
               u32 RISEQC6 : 3;                   // DWORD 0
               u32 RISEQC5 : 3;                   // DWORD 0
               u32 RISEQC4 : 3;                   // DWORD 0
               u32 RISEQC3 : 3;                   // DWORD 0
               u32 RISEQC2 : 3;                   // DWORD 0
               u32 RISEQC1 : 3;                   // DWORD 0
               u32 RISEQC0 : 3;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SERDES_RISEQC, *PPCIE_SERDES_RISEQC;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_RISEQC, sizeof (PCIE_SERDES_RISEQC) == 4);

   #else
      typedef struct _PCIE_SERDES_RISEQC {
         u32 BITS_FUTURE : 8;                     // DWORD 0
         u32 RISEQC7 : 3;                         // DWORD 0
         u32 RISEQC6 : 3;                         // DWORD 0
         u32 RISEQC5 : 3;                         // DWORD 0
         u32 RISEQC4 : 3;                         // DWORD 0
         u32 RISEQC3 : 3;                         // DWORD 0
         u32 RISEQC2 : 3;                         // DWORD 0
         u32 RISEQC1 : 3;                         // DWORD 0
         u32 RISEQC0 : 3;                         // DWORD 0
      } SG_PACK PCIE_SERDES_RISEQC, *PPCIE_SERDES_RISEQC;

      typedef union _PCIE_SERDES_RISEQC_UNION {
         PCIE_SERDES_RISEQC bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SERDES_RISEQC_UNION, *PPCIE_SERDES_RISEQC_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_RISEQC_UNION, sizeof (PCIE_SERDES_RISEQC_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_SERDES_RISEQC {
         union {
            struct { 
               u32 RISEQC0 : 3;                   // DWORD 0
               u32 RISEQC1 : 3;                   // DWORD 0
               u32 RISEQC2 : 3;                   // DWORD 0
               u32 RISEQC3 : 3;                   // DWORD 0
               u32 RISEQC4 : 3;                   // DWORD 0
               u32 RISEQC5 : 3;                   // DWORD 0
               u32 RISEQC6 : 3;                   // DWORD 0
               u32 RISEQC7 : 3;                   // DWORD 0
               u32 BITS_FUTURE : 8;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_SERDES_RISEQC, *PPCIE_SERDES_RISEQC;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_RISEQC, sizeof (PCIE_SERDES_RISEQC) == 4);

   #else
      typedef struct _PCIE_SERDES_RISEQC {
         u32 RISEQC0 : 3;                         // DWORD 0
         u32 RISEQC1 : 3;                         // DWORD 0
         u32 RISEQC2 : 3;                         // DWORD 0
         u32 RISEQC3 : 3;                         // DWORD 0
         u32 RISEQC4 : 3;                         // DWORD 0
         u32 RISEQC5 : 3;                         // DWORD 0
         u32 RISEQC6 : 3;                         // DWORD 0
         u32 RISEQC7 : 3;                         // DWORD 0
         u32 BITS_FUTURE : 8;                     // DWORD 0
      } SG_PACK PCIE_SERDES_RISEQC, *PPCIE_SERDES_RISEQC;

      typedef union _PCIE_SERDES_RISEQC_UNION {
         PCIE_SERDES_RISEQC bits;
         u32 dw; // dword union
      } SG_PACK PCIE_SERDES_RISEQC_UNION, *PPCIE_SERDES_RISEQC_UNION;

      SG_C_ASSERT(__sizeof__PCIE_SERDES_RISEQC_UNION, sizeof (PCIE_SERDES_RISEQC_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_PM_PME_SERDES_LEVSEL_V0_SEL {
         union {
            struct { 
               u32 rsvd0 : 6;                     // DWORD 0
               u32 self_clr_lpcsoftrst : 1;       // DWORD 0
               u32 rxf_wake_l1_l2_trans : 1;      // DWORD 0
               u32 nec_ll_MODE_EBMODE : 2;        // DWORD 0
               u32 nec_PM_PME_en_D3 : 1;          // DWORD 0
               u32 nec_PM_PME_en_D0 : 1;          // DWORD 0
               u32 nec_blb0_digest : 1;           // DWORD 0
               u32 V0_SEL : 3;                    // DWORD 0
               u32 LEVSEL : 16;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_PM_PME_SERDES_LEVSEL_V0_SEL, *PPCIE_PM_PME_SERDES_LEVSEL_V0_SEL;

      SG_C_ASSERT(__sizeof__PCIE_PM_PME_SERDES_LEVSEL_V0_SEL, sizeof (PCIE_PM_PME_SERDES_LEVSEL_V0_SEL) == 4);

   #else
      typedef struct _PCIE_PM_PME_SERDES_LEVSEL_V0_SEL {
         u32 rsvd0 : 6;                           // DWORD 0
         u32 self_clr_lpcsoftrst : 1;             // DWORD 0
         u32 rxf_wake_l1_l2_trans : 1;            // DWORD 0
         u32 nec_ll_MODE_EBMODE : 2;              // DWORD 0
         u32 nec_PM_PME_en_D3 : 1;                // DWORD 0
         u32 nec_PM_PME_en_D0 : 1;                // DWORD 0
         u32 nec_blb0_digest : 1;                 // DWORD 0
         u32 V0_SEL : 3;                          // DWORD 0
         u32 LEVSEL : 16;                         // DWORD 0
      } SG_PACK PCIE_PM_PME_SERDES_LEVSEL_V0_SEL, *PPCIE_PM_PME_SERDES_LEVSEL_V0_SEL;

      typedef union _PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_UNION {
         PCIE_PM_PME_SERDES_LEVSEL_V0_SEL bits;
         u32 dw; // dword union
      } SG_PACK PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_UNION, *PPCIE_PM_PME_SERDES_LEVSEL_V0_SEL_UNION;

      SG_C_ASSERT(__sizeof__PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_UNION, sizeof (PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCIE_PM_PME_SERDES_LEVSEL_V0_SEL {
         union {
            struct { 
               u32 LEVSEL : 16;                   // DWORD 0
               u32 V0_SEL : 3;                    // DWORD 0
               u32 nec_blb0_digest : 1;           // DWORD 0
               u32 nec_PM_PME_en_D0 : 1;          // DWORD 0
               u32 nec_PM_PME_en_D3 : 1;          // DWORD 0
               u32 nec_ll_MODE_EBMODE : 2;        // DWORD 0
               u32 rxf_wake_l1_l2_trans : 1;      // DWORD 0
               u32 self_clr_lpcsoftrst : 1;       // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PCIE_PM_PME_SERDES_LEVSEL_V0_SEL, *PPCIE_PM_PME_SERDES_LEVSEL_V0_SEL;

      SG_C_ASSERT(__sizeof__PCIE_PM_PME_SERDES_LEVSEL_V0_SEL, sizeof (PCIE_PM_PME_SERDES_LEVSEL_V0_SEL) == 4);

   #else
      typedef struct _PCIE_PM_PME_SERDES_LEVSEL_V0_SEL {
         u32 LEVSEL : 16;                         // DWORD 0
         u32 V0_SEL : 3;                          // DWORD 0
         u32 nec_blb0_digest : 1;                 // DWORD 0
         u32 nec_PM_PME_en_D0 : 1;                // DWORD 0
         u32 nec_PM_PME_en_D3 : 1;                // DWORD 0
         u32 nec_ll_MODE_EBMODE : 2;              // DWORD 0
         u32 rxf_wake_l1_l2_trans : 1;            // DWORD 0
         u32 self_clr_lpcsoftrst : 1;             // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
      } SG_PACK PCIE_PM_PME_SERDES_LEVSEL_V0_SEL, *PPCIE_PM_PME_SERDES_LEVSEL_V0_SEL;

      typedef union _PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_UNION {
         PCIE_PM_PME_SERDES_LEVSEL_V0_SEL bits;
         u32 dw; // dword union
      } SG_PACK PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_UNION, *PPCIE_PM_PME_SERDES_LEVSEL_V0_SEL_UNION;

      SG_C_ASSERT(__sizeof__PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_UNION, sizeof (PCIE_PM_PME_SERDES_LEVSEL_V0_SEL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // hwdbg_cfgreg_i[127:96]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_3 {
         union {
            struct { 
               u32 host_dbg_mux_data_core_d3_o_63_32; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_3, *Phwdbg_cfgreg_i_3;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_3, sizeof (hwdbg_cfgreg_i_3) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_3 {
         u32 host_dbg_mux_data_core_d3_o_63_32;   // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_3, *Phwdbg_cfgreg_i_3;

      typedef union _hwdbg_cfgreg_i_3_UNION {
         hwdbg_cfgreg_i_3 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_3_UNION, *Phwdbg_cfgreg_i_3_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_3_UNION, sizeof (hwdbg_cfgreg_i_3_UNION) == 4);
   #endif


#else
   // hwdbg_cfgreg_i[127:96]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_3 {
         union {
            struct { 
               u32 host_dbg_mux_data_core_d3_o_63_32; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_3, *Phwdbg_cfgreg_i_3;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_3, sizeof (hwdbg_cfgreg_i_3) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_3 {
         u32 host_dbg_mux_data_core_d3_o_63_32;   // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_3, *Phwdbg_cfgreg_i_3;

      typedef union _hwdbg_cfgreg_i_3_UNION {
         hwdbg_cfgreg_i_3 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_3_UNION, *Phwdbg_cfgreg_i_3_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_3_UNION, sizeof (hwdbg_cfgreg_i_3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // hwdbg_cfgreg_i[159:128]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_4 {
         union {
            struct { 
               u32 host_dbg_mux_data_pclk_o_31_0; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_4, *Phwdbg_cfgreg_i_4;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_4, sizeof (hwdbg_cfgreg_i_4) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_4 {
         u32 host_dbg_mux_data_pclk_o_31_0;       // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_4, *Phwdbg_cfgreg_i_4;

      typedef union _hwdbg_cfgreg_i_4_UNION {
         hwdbg_cfgreg_i_4 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_4_UNION, *Phwdbg_cfgreg_i_4_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_4_UNION, sizeof (hwdbg_cfgreg_i_4_UNION) == 4);
   #endif


#else
   // hwdbg_cfgreg_i[159:128]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_4 {
         union {
            struct { 
               u32 host_dbg_mux_data_pclk_o_31_0; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_4, *Phwdbg_cfgreg_i_4;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_4, sizeof (hwdbg_cfgreg_i_4) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_4 {
         u32 host_dbg_mux_data_pclk_o_31_0;       // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_4, *Phwdbg_cfgreg_i_4;

      typedef union _hwdbg_cfgreg_i_4_UNION {
         hwdbg_cfgreg_i_4 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_4_UNION, *Phwdbg_cfgreg_i_4_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_4_UNION, sizeof (hwdbg_cfgreg_i_4_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // hwdbg_cfgreg_i[191:160]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_5 {
         union {
            struct { 
               u32 host_dbg_mux_data_core_d3_o_63_32; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_5, *Phwdbg_cfgreg_i_5;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_5, sizeof (hwdbg_cfgreg_i_5) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_5 {
         u32 host_dbg_mux_data_core_d3_o_63_32;   // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_5, *Phwdbg_cfgreg_i_5;

      typedef union _hwdbg_cfgreg_i_5_UNION {
         hwdbg_cfgreg_i_5 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_5_UNION, *Phwdbg_cfgreg_i_5_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_5_UNION, sizeof (hwdbg_cfgreg_i_5_UNION) == 4);
   #endif


#else
   // hwdbg_cfgreg_i[191:160]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_5 {
         union {
            struct { 
               u32 host_dbg_mux_data_core_d3_o_63_32; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_5, *Phwdbg_cfgreg_i_5;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_5, sizeof (hwdbg_cfgreg_i_5) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_5 {
         u32 host_dbg_mux_data_core_d3_o_63_32;   // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_5, *Phwdbg_cfgreg_i_5;

      typedef union _hwdbg_cfgreg_i_5_UNION {
         hwdbg_cfgreg_i_5 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_5_UNION, *Phwdbg_cfgreg_i_5_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_5_UNION, sizeof (hwdbg_cfgreg_i_5_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // hwdbg_cfgreg_i[255:224]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_7 {
         union {
            struct { 
               u32 dbg_all_reqs_31_0;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_7, *Phwdbg_cfgreg_i_7;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_7, sizeof (hwdbg_cfgreg_i_7) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_7 {
         u32 dbg_all_reqs_31_0;                   // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_7, *Phwdbg_cfgreg_i_7;

      typedef union _hwdbg_cfgreg_i_7_UNION {
         hwdbg_cfgreg_i_7 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_7_UNION, *Phwdbg_cfgreg_i_7_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_7_UNION, sizeof (hwdbg_cfgreg_i_7_UNION) == 4);
   #endif


#else
   // hwdbg_cfgreg_i[255:224]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_7 {
         union {
            struct { 
               u32 dbg_all_reqs_31_0;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_7, *Phwdbg_cfgreg_i_7;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_7, sizeof (hwdbg_cfgreg_i_7) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_7 {
         u32 dbg_all_reqs_31_0;                   // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_7, *Phwdbg_cfgreg_i_7;

      typedef union _hwdbg_cfgreg_i_7_UNION {
         hwdbg_cfgreg_i_7 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_7_UNION, *Phwdbg_cfgreg_i_7_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_7_UNION, sizeof (hwdbg_cfgreg_i_7_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // hwdbg_cfgreg_i[223:192]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_6 {
         union {
            struct { 
               u32 te_host_tlb_tag_i_6_2 : 7;     // DWORD 0
               u32 rrm_host_done_i : 1;           // DWORD 0
               u32 rrm_host_reqack_i : 1;         // DWORD 0
               u32 host_rrm_type__o : 2;          // DWORD 0
               u32 host_rrm_req_o : 1;            // DWORD 0
               u32 teslv_nonpostedrdreq_o : 1;    // DWORD 0
               u32 teslv_nonpostedreqmask_o : 1;  // DWORD 0
               u32 te_host_tlb_firstbe_i : 4;     // DWORD 0
               u32 rrm_host_donestatus_i : 2;     // DWORD 0
               u32 te_host_tlb_last_i : 1;        // DWORD 0
               u32 host_te_tlb_ardy_o : 1;        // DWORD 0
               u32 te_host_tlb_grdy_i : 1;        // DWORD 0
               u32 te_host_tlb_trans_i : 1;       // DWORD 0
               u32 te_host_tlb_status_i : 4;      // DWORD 0
               u32 teslave_state : 4;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_6, *Phwdbg_cfgreg_i_6;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_6, sizeof (hwdbg_cfgreg_i_6) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_6 {
         u32 te_host_tlb_tag_i_6_2 : 7;           // DWORD 0
         u32 rrm_host_done_i : 1;                 // DWORD 0
         u32 rrm_host_reqack_i : 1;               // DWORD 0
         u32 host_rrm_type__o : 2;                // DWORD 0
         u32 host_rrm_req_o : 1;                  // DWORD 0
         u32 teslv_nonpostedrdreq_o : 1;          // DWORD 0
         u32 teslv_nonpostedreqmask_o : 1;        // DWORD 0
         u32 te_host_tlb_firstbe_i : 4;           // DWORD 0
         u32 rrm_host_donestatus_i : 2;           // DWORD 0
         u32 te_host_tlb_last_i : 1;              // DWORD 0
         u32 host_te_tlb_ardy_o : 1;              // DWORD 0
         u32 te_host_tlb_grdy_i : 1;              // DWORD 0
         u32 te_host_tlb_trans_i : 1;             // DWORD 0
         u32 te_host_tlb_status_i : 4;            // DWORD 0
         u32 teslave_state : 4;                   // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_6, *Phwdbg_cfgreg_i_6;

      typedef union _hwdbg_cfgreg_i_6_UNION {
         hwdbg_cfgreg_i_6 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_6_UNION, *Phwdbg_cfgreg_i_6_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_6_UNION, sizeof (hwdbg_cfgreg_i_6_UNION) == 4);
   #endif


#else
   // hwdbg_cfgreg_i[223:192]
   #if defined(SG_BMAP_UNION)
      typedef struct _hwdbg_cfgreg_i_6 {
         union {
            struct { 
               u32 teslave_state : 4;             // DWORD 0
               u32 te_host_tlb_status_i : 4;      // DWORD 0
               u32 te_host_tlb_trans_i : 1;       // DWORD 0
               u32 te_host_tlb_grdy_i : 1;        // DWORD 0
               u32 host_te_tlb_ardy_o : 1;        // DWORD 0
               u32 te_host_tlb_last_i : 1;        // DWORD 0
               u32 rrm_host_donestatus_i : 2;     // DWORD 0
               u32 te_host_tlb_firstbe_i : 4;     // DWORD 0
               u32 teslv_nonpostedreqmask_o : 1;  // DWORD 0
               u32 teslv_nonpostedrdreq_o : 1;    // DWORD 0
               u32 host_rrm_req_o : 1;            // DWORD 0
               u32 host_rrm_type__o : 2;          // DWORD 0
               u32 rrm_host_reqack_i : 1;         // DWORD 0
               u32 rrm_host_done_i : 1;           // DWORD 0
               u32 te_host_tlb_tag_i_6_2 : 7;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK hwdbg_cfgreg_i_6, *Phwdbg_cfgreg_i_6;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_6, sizeof (hwdbg_cfgreg_i_6) == 4);

   #else
      typedef struct _hwdbg_cfgreg_i_6 {
         u32 teslave_state : 4;                   // DWORD 0
         u32 te_host_tlb_status_i : 4;            // DWORD 0
         u32 te_host_tlb_trans_i : 1;             // DWORD 0
         u32 te_host_tlb_grdy_i : 1;              // DWORD 0
         u32 host_te_tlb_ardy_o : 1;              // DWORD 0
         u32 te_host_tlb_last_i : 1;              // DWORD 0
         u32 rrm_host_donestatus_i : 2;           // DWORD 0
         u32 te_host_tlb_firstbe_i : 4;           // DWORD 0
         u32 teslv_nonpostedreqmask_o : 1;        // DWORD 0
         u32 teslv_nonpostedrdreq_o : 1;          // DWORD 0
         u32 host_rrm_req_o : 1;                  // DWORD 0
         u32 host_rrm_type__o : 2;                // DWORD 0
         u32 rrm_host_reqack_i : 1;               // DWORD 0
         u32 rrm_host_done_i : 1;                 // DWORD 0
         u32 te_host_tlb_tag_i_6_2 : 7;           // DWORD 0
      } SG_PACK hwdbg_cfgreg_i_6, *Phwdbg_cfgreg_i_6;

      typedef union _hwdbg_cfgreg_i_6_UNION {
         hwdbg_cfgreg_i_6 bits;
         u32 dw; // dword union
      } SG_PACK hwdbg_cfgreg_i_6_UNION, *Phwdbg_cfgreg_i_6_UNION;

      SG_C_ASSERT(__sizeof__hwdbg_cfgreg_i_6_UNION, sizeof (hwdbg_cfgreg_i_6_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // These PCI Configuration Space registers are for the Storage Function of BladeEngine
   // (Function 0). In the memory map of the registers below their table, registers that
   // are physically common to Functions 0 and 1 are highlighted in pink. under the
   // mnemonic column. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PF0_CSRMAP {
         union {
            struct { 
               PCICFG_ID_F0_CSR id;
               PCICFG_COMMAND_STATUS_CSR cmd_status;
               PCICFG_CLASS_REV_F0_CSR class_rev;
               PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
               u32 rsvd0[1];                      // DWORDS 4 to 4
               PCICFG_MEMBAR0_CSR membar0;
               PCICFG_MEMBAR1_LO_CSR membar1_lo;
               PCICFG_MEMBAR1_HI_CSR membar1_hi;
               PCICFG_MEMBAR2_LO_F0_CSR membar2_lo;
               PCICFG_MEMBAR2_HI_CSR membar2_hi;
               u32 rsvd1[1];                      // DWORDS 10 to 10
               PCICFG_SUBSYSTEM_ID_F0_CSR subsystem_id;
               PCICFG_EXP_ROM_CSR exp_rom;
               PCICFG_CAP_CSR cap;
               u32 rsvd2[1];                      // DWORDS 14 to 14
               PCICFG_LATENCY_INT_F0_CSR latency_int;
               PCICFG_PMC_CSR pmc;
               PCICFG_PM_CONTROL pm_control;
               PCICFG_MSIX_CSR msix;
               PCICFG_MSIX_TABLE_CSR msix_table_offset;
               PCICFG_MSIX_PBA_CSR msix_pba_offset;
               PCICFG_HOST_CONTROL_STATUS_CSR host_control;
               PCICFG_SCRATCHPAD_CSR scratchpad;
               PCICFG_SOFT_RESET_CSR soft_reset;
               PCICFG_LPC_ADDR_CSR lpc_addr;
               PCICFG_LPC_DATA_CSR lpc_data;
               PCICFG_LPC_COMMAND_CSR lpc_command;
               PCICFG_IP_CONTROL_STATUS_3_CSR ip_control_status_3;
               PCICFG_GPI_CSR gpi[2];
               PCICFG_GPO_LOW_CSR gpo_low;
               PCICFG_GPO_HI_CSR gpo_hi;
               PCICFG_GPIOMAP_CSR gpiomap[8];
               PCICFG_UE_STATUS_LOW_CSR ue_status_low;
               PCICFG_UE_STATUS_HI_CSR ue_status_hi;
               PCICFG_UE_STATUS_LOW_MASK_CSR ue_status_low_mask;
               PCICFG_UE_STATUS_HI_MASK_CSR ue_status_hi_mask;
               PCICFG_ONLINE0_CSR online0;
               PCICFG_ONLINE1_CSR online1;
               PCICFG_DEBUG_CSR debug;
               PCICFG_SEMAPHORE_CSR semaphore;
               PCICFG_PCIE_CAP_CSR pcie_cap;
               PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
               PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
               PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
               PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
               PCICFG_RETURN_ZEROS return_zeros[4];
               PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
               PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
               PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
               PCICFG_PCIE_LINK_STATUS2_CSR pcie_link_status2;
               PCICFG_RETURN_ZEROS return_zeros_1[2];
               PCICFG_MEMBAR_CTRL_INT_CTRL_CSR membar_ctrl_intr_ctrl;
               PCIE_ERR_ENHANCED_CAP pcie_err_enhanced_cap;
               PCIE_UNCORR_ERR_STATUS pcie_uncorr_err_status;
               PCIE_UNCORR_ERR_MASK pcie_uncorr_err_mask;
               PCIE_UNCORR_ERR_SEVERITY pcie_uncorr_err_severity;
               PCIE_CORR_ERR_STATUS pcie_corr_err_status;
               PCIE_CORR_ERR_MASK pcie_corr_err_mask;
               PCIE_ERR_CAP_CONTROL pcie_err_cap_control;
               PCIE_HEADER_REGISTER pcie_header_register0;
               PCIE_HEADER_REGISTER pcie_header_register1;
               PCIE_HEADER_REGISTER pcie_header_register2;
               PCIE_HEADER_REGISTER pcie_header_register3;
               hwdbg_cfgreg_i_4 host_dbg_mux_data_pclk_d3_o_31_0;
               hwdbg_cfgreg_i_3 host_dbg_mux_data_core_d3_o_63_32;
               hwdbg_cfgreg_i_2 host_dbg_mux_data_core_d3_o_31_0;
               PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE pcie_fcp_timer_beacon_en_pcicfg_override;
               PCIE_OPTION_ROM_FLASH_TRANSLATION_F0 pcie_option_rom_flash_translation_f0;
               PCIE_LTSSM_CHANGE_CMD_CFG_RETRY pcie_ltssm_change_st_cmd_cfg_retry;
               PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET pcie_pf_vfs_ari_next_cap_off;
               PCIE_SERDES_RISEQC pcie_serdes_riseqc;
               PCIE_PM_PME_SERDES_LEVSEL_V0_SEL pcie_pm_pme_serdes_levsel_v0_sel;
               hwdbg_cfgreg_i_5 host_dbg_mux_data_pclk_d3_o_63_32;
               hwdbg_cfgreg_i_6 dbg_teslave_31_0;
               hwdbg_cfgreg_i_0 host_dbg_mux_data_core_o_31_0;
               hwdbg_cfgreg_i_1 host_dbg_mux_data_core_o_63_32;
               PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
               PCIE_ARI_CAPABILITY pcie_ari_capability;
               PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
               PCIE_ATS_CAPABILITY pcie_ats_capability;
               hwdbg_cfgreg_i_7 dbg_all_reqs_31_0;
               PCICFG_HOST_INT_STATUS_CSR host_int_status;
               PCICFG_HOST_INT_MASK_CSR host_int_mask;
               PCICFG_HOST_TIMER_INT_CTRL_CSR host_timer_ctrl;
               PCIE_SR_IOV_ENHANCED_CAP SR_IOV_capability_id;
               PCIE_SR_IOV_CAPABILITIES SR_IOV_capabilities;
               PCIE_SR_IOV_STATUS_CONTROL SR_IOV_status_control;
               PCIE_TOTAL_INITIAL_VFs total_initial_VFs;
               PCIE_NUM_VFs number_of_VFs;
               PCIE_VF_STRIDE_OFFSET VF_stride_offset;
               PCIE_VF_DEVICE_ID VF_device_id;
               PCIE_VF_SYSTEM_PAGE_SUPPORTED PF_supported_page_size;
               PCIE_VF_SYSTEM_PAGE PF_system_page;
               PCICFG_RETURN_ZEROS return_zeros_2[2];
               PCICFG_RETURN_ZEROS return_zeros_2_1[2];
               PCICFG_VF_MEMBAR0_LO VF_membar0_low;
               PCICFG_VF_MEMBAR0_HI VF_membar0_high;
               PCICFG_RETURN_ZEROS return_zeros_3;
               PCICFG_IP_SPEED_WIDTH_CTRL ip_speed_width_control;
               PCICFG_IP_CONTROL_STATUS_5_CSR ip_control_status_5;
               PCICFG_IP_CONTROL_STATUS_4_CSR ip_control_status_4;
               PCICFG_ERR_REPLAY_MONITOR error_replay_monitor;
               PCICFG_IP_CONTROL_STATUS_2_CSR ip_control_status_2;
               PCICFG_IP_CONTROL_STATUS_0_CSR ip_control_status_0;
               PCICFG_IP_CONTROL_STATUS_1_CSR ip_control_status_1;
               PCICFG_HWDBG_SHIFT hwdbg_shift;
               PCICFG_HWDBG_MASK_0_PCLK hwdbg_mask_0_pclk;
               PCICFG_HWDBG_MASK_1_PCLK hwdbg_mask_1_pclk;
               PCICFG_HWDBG_MASK_0_CORE_D3 hwdbg_mask_0_core_d3;
               PCICFG_HWDBG_MASK_1_CORE_D3 hwdbg_mask_1_core_d3;
               PCICFG_HWDBG_MASK_0_CORE hwdbg_mask_0_core;
               PCICFG_HWDBG_MASK_1_CORE hwdbg_mask_1_core;
               PCICFG_HWDBG_REGSEL hwdbg_regsel;
               PCICFG_HWDBG_ENABLE hwdbg_enable;
               u32 rsvd3[896];                    // DWORDS 128 to 1023
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PF0_CSRMAP, *PPCICFG_PF0_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG_PF0_CSRMAP, sizeof (PCICFG_PF0_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG_PF0_CSRMAP {
         PCICFG_ID_F0_CSR id;
         PCICFG_COMMAND_STATUS_CSR cmd_status;
         PCICFG_CLASS_REV_F0_CSR class_rev;
         PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
         u32 rsvd0[1];                            // DWORDS 4 to 4
         PCICFG_MEMBAR0_CSR membar0;
         PCICFG_MEMBAR1_LO_CSR membar1_lo;
         PCICFG_MEMBAR1_HI_CSR membar1_hi;
         PCICFG_MEMBAR2_LO_F0_CSR membar2_lo;
         PCICFG_MEMBAR2_HI_CSR membar2_hi;
         u32 rsvd1[1];                            // DWORDS 10 to 10
         PCICFG_SUBSYSTEM_ID_F0_CSR subsystem_id;
         PCICFG_EXP_ROM_CSR exp_rom;
         PCICFG_CAP_CSR cap;
         u32 rsvd2[1];                            // DWORDS 14 to 14
         PCICFG_LATENCY_INT_F0_CSR latency_int;
         PCICFG_PMC_CSR pmc;
         PCICFG_PM_CONTROL pm_control;
         PCICFG_MSIX_CSR msix;
         PCICFG_MSIX_TABLE_CSR msix_table_offset;
         PCICFG_MSIX_PBA_CSR msix_pba_offset;
         PCICFG_HOST_CONTROL_STATUS_CSR host_control;
         PCICFG_SCRATCHPAD_CSR scratchpad;
         PCICFG_SOFT_RESET_CSR soft_reset;
         PCICFG_LPC_ADDR_CSR lpc_addr;
         PCICFG_LPC_DATA_CSR lpc_data;
         PCICFG_LPC_COMMAND_CSR lpc_command;
         PCICFG_IP_CONTROL_STATUS_3_CSR ip_control_status_3;
         PCICFG_GPI_CSR gpi[2];
         PCICFG_GPO_LOW_CSR gpo_low;
         PCICFG_GPO_HI_CSR gpo_hi;
         PCICFG_GPIOMAP_CSR gpiomap[8];
         PCICFG_UE_STATUS_LOW_CSR ue_status_low;
         PCICFG_UE_STATUS_HI_CSR ue_status_hi;
         PCICFG_UE_STATUS_LOW_MASK_CSR ue_status_low_mask;
         PCICFG_UE_STATUS_HI_MASK_CSR ue_status_hi_mask;
         PCICFG_ONLINE0_CSR online0;
         PCICFG_ONLINE1_CSR online1;
         PCICFG_DEBUG_CSR debug;
         PCICFG_SEMAPHORE_CSR semaphore;
         PCICFG_PCIE_CAP_CSR pcie_cap;
         PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
         PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
         PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
         PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
         PCICFG_RETURN_ZEROS return_zeros[4];
         PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
         PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
         PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
         PCICFG_PCIE_LINK_STATUS2_CSR pcie_link_status2;
         PCICFG_RETURN_ZEROS return_zeros_1[2];
         PCICFG_MEMBAR_CTRL_INT_CTRL_CSR membar_ctrl_intr_ctrl;
         PCIE_ERR_ENHANCED_CAP pcie_err_enhanced_cap;
         PCIE_UNCORR_ERR_STATUS pcie_uncorr_err_status;
         PCIE_UNCORR_ERR_MASK pcie_uncorr_err_mask;
         PCIE_UNCORR_ERR_SEVERITY pcie_uncorr_err_severity;
         PCIE_CORR_ERR_STATUS pcie_corr_err_status;
         PCIE_CORR_ERR_MASK pcie_corr_err_mask;
         PCIE_ERR_CAP_CONTROL pcie_err_cap_control;
         PCIE_HEADER_REGISTER pcie_header_register0;
         PCIE_HEADER_REGISTER pcie_header_register1;
         PCIE_HEADER_REGISTER pcie_header_register2;
         PCIE_HEADER_REGISTER pcie_header_register3;
         hwdbg_cfgreg_i_4 host_dbg_mux_data_pclk_d3_o_31_0;
         hwdbg_cfgreg_i_3 host_dbg_mux_data_core_d3_o_63_32;
         hwdbg_cfgreg_i_2 host_dbg_mux_data_core_d3_o_31_0;
         PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE pcie_fcp_timer_beacon_en_pcicfg_override;
         PCIE_OPTION_ROM_FLASH_TRANSLATION_F0 pcie_option_rom_flash_translation_f0;
         PCIE_LTSSM_CHANGE_CMD_CFG_RETRY pcie_ltssm_change_st_cmd_cfg_retry;
         PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET pcie_pf_vfs_ari_next_cap_off;
         PCIE_SERDES_RISEQC pcie_serdes_riseqc;
         PCIE_PM_PME_SERDES_LEVSEL_V0_SEL pcie_pm_pme_serdes_levsel_v0_sel;
         hwdbg_cfgreg_i_5 host_dbg_mux_data_pclk_d3_o_63_32;
         hwdbg_cfgreg_i_6 dbg_teslave_31_0;
         hwdbg_cfgreg_i_0 host_dbg_mux_data_core_o_31_0;
         hwdbg_cfgreg_i_1 host_dbg_mux_data_core_o_63_32;
         PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
         PCIE_ARI_CAPABILITY pcie_ari_capability;
         PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
         PCIE_ATS_CAPABILITY pcie_ats_capability;
         hwdbg_cfgreg_i_7 dbg_all_reqs_31_0;
         PCICFG_HOST_INT_STATUS_CSR host_int_status;
         PCICFG_HOST_INT_MASK_CSR host_int_mask;
         PCICFG_HOST_TIMER_INT_CTRL_CSR host_timer_ctrl;
         PCIE_SR_IOV_ENHANCED_CAP SR_IOV_capability_id;
         PCIE_SR_IOV_CAPABILITIES SR_IOV_capabilities;
         PCIE_SR_IOV_STATUS_CONTROL SR_IOV_status_control;
         PCIE_TOTAL_INITIAL_VFs total_initial_VFs;
         PCIE_NUM_VFs number_of_VFs;
         PCIE_VF_STRIDE_OFFSET VF_stride_offset;
         PCIE_VF_DEVICE_ID VF_device_id;
         PCIE_VF_SYSTEM_PAGE_SUPPORTED PF_supported_page_size;
         PCIE_VF_SYSTEM_PAGE PF_system_page;
         PCICFG_RETURN_ZEROS return_zeros_2[2];
         PCICFG_RETURN_ZEROS return_zeros_2_1[2];
         PCICFG_VF_MEMBAR0_LO VF_membar0_low;
         PCICFG_VF_MEMBAR0_HI VF_membar0_high;
         PCICFG_RETURN_ZEROS return_zeros_3;
         PCICFG_IP_SPEED_WIDTH_CTRL ip_speed_width_control;
         PCICFG_IP_CONTROL_STATUS_5_CSR ip_control_status_5;
         PCICFG_IP_CONTROL_STATUS_4_CSR ip_control_status_4;
         PCICFG_ERR_REPLAY_MONITOR error_replay_monitor;
         PCICFG_IP_CONTROL_STATUS_2_CSR ip_control_status_2;
         PCICFG_IP_CONTROL_STATUS_0_CSR ip_control_status_0;
         PCICFG_IP_CONTROL_STATUS_1_CSR ip_control_status_1;
         PCICFG_HWDBG_SHIFT hwdbg_shift;
         PCICFG_HWDBG_MASK_0_PCLK hwdbg_mask_0_pclk;
         PCICFG_HWDBG_MASK_1_PCLK hwdbg_mask_1_pclk;
         PCICFG_HWDBG_MASK_0_CORE_D3 hwdbg_mask_0_core_d3;
         PCICFG_HWDBG_MASK_1_CORE_D3 hwdbg_mask_1_core_d3;
         PCICFG_HWDBG_MASK_0_CORE hwdbg_mask_0_core;
         PCICFG_HWDBG_MASK_1_CORE hwdbg_mask_1_core;
         PCICFG_HWDBG_REGSEL hwdbg_regsel;
         PCICFG_HWDBG_ENABLE hwdbg_enable;
         u32 rsvd3[896];                          // DWORDS 128 to 1023
      } SG_PACK PCICFG_PF0_CSRMAP, *PPCICFG_PF0_CSRMAP;

      typedef union _PCICFG_PF0_CSRMAP_UNION {
         PCICFG_PF0_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG_PF0_CSRMAP_UNION, *PPCICFG_PF0_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PF0_CSRMAP_UNION, sizeof (PCICFG_PF0_CSRMAP_UNION) == 4096);
   #endif


#else
   // These PCI Configuration Space registers are for the Storage Function of BladeEngine
   // (Function 0). In the memory map of the registers below their table, registers that
   // are physically common to Functions 0 and 1 are highlighted in pink. under the
   // mnemonic column. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PF0_CSRMAP {
         union {
            struct { 
               PCICFG_ID_F0_CSR id;
               PCICFG_COMMAND_STATUS_CSR cmd_status;
               PCICFG_CLASS_REV_F0_CSR class_rev;
               PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
               u32 rsvd0[1];                      // DWORDS 4 to 4
               PCICFG_MEMBAR0_CSR membar0;
               PCICFG_MEMBAR1_LO_CSR membar1_lo;
               PCICFG_MEMBAR1_HI_CSR membar1_hi;
               PCICFG_MEMBAR2_LO_F0_CSR membar2_lo;
               PCICFG_MEMBAR2_HI_CSR membar2_hi;
               u32 rsvd1[1];                      // DWORDS 10 to 10
               PCICFG_SUBSYSTEM_ID_F0_CSR subsystem_id;
               PCICFG_EXP_ROM_CSR exp_rom;
               PCICFG_CAP_CSR cap;
               u32 rsvd2[1];                      // DWORDS 14 to 14
               PCICFG_LATENCY_INT_F0_CSR latency_int;
               PCICFG_PMC_CSR pmc;
               PCICFG_PM_CONTROL pm_control;
               PCICFG_MSIX_CSR msix;
               PCICFG_MSIX_TABLE_CSR msix_table_offset;
               PCICFG_MSIX_PBA_CSR msix_pba_offset;
               PCICFG_HOST_CONTROL_STATUS_CSR host_control;
               PCICFG_SCRATCHPAD_CSR scratchpad;
               PCICFG_SOFT_RESET_CSR soft_reset;
               PCICFG_LPC_ADDR_CSR lpc_addr;
               PCICFG_LPC_DATA_CSR lpc_data;
               PCICFG_LPC_COMMAND_CSR lpc_command;
               PCICFG_IP_CONTROL_STATUS_3_CSR ip_control_status_3;
               PCICFG_GPI_CSR gpi[2];
               PCICFG_GPO_LOW_CSR gpo_low;
               PCICFG_GPO_HI_CSR gpo_hi;
               PCICFG_GPIOMAP_CSR gpiomap[8];
               PCICFG_UE_STATUS_LOW_CSR ue_status_low;
               PCICFG_UE_STATUS_HI_CSR ue_status_hi;
               PCICFG_UE_STATUS_LOW_MASK_CSR ue_status_low_mask;
               PCICFG_UE_STATUS_HI_MASK_CSR ue_status_hi_mask;
               PCICFG_ONLINE0_CSR online0;
               PCICFG_ONLINE1_CSR online1;
               PCICFG_DEBUG_CSR debug;
               PCICFG_SEMAPHORE_CSR semaphore;
               PCICFG_PCIE_CAP_CSR pcie_cap;
               PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
               PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
               PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
               PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
               PCICFG_RETURN_ZEROS return_zeros[4];
               PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
               PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
               PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
               PCICFG_PCIE_LINK_STATUS2_CSR pcie_link_status2;
               PCICFG_RETURN_ZEROS return_zeros_1[2];
               PCICFG_MEMBAR_CTRL_INT_CTRL_CSR membar_ctrl_intr_ctrl;
               PCIE_ERR_ENHANCED_CAP pcie_err_enhanced_cap;
               PCIE_UNCORR_ERR_STATUS pcie_uncorr_err_status;
               PCIE_UNCORR_ERR_MASK pcie_uncorr_err_mask;
               PCIE_UNCORR_ERR_SEVERITY pcie_uncorr_err_severity;
               PCIE_CORR_ERR_STATUS pcie_corr_err_status;
               PCIE_CORR_ERR_MASK pcie_corr_err_mask;
               PCIE_ERR_CAP_CONTROL pcie_err_cap_control;
               PCIE_HEADER_REGISTER pcie_header_register0;
               PCIE_HEADER_REGISTER pcie_header_register1;
               PCIE_HEADER_REGISTER pcie_header_register2;
               PCIE_HEADER_REGISTER pcie_header_register3;
               hwdbg_cfgreg_i_4 host_dbg_mux_data_pclk_d3_o_31_0;
               hwdbg_cfgreg_i_3 host_dbg_mux_data_core_d3_o_63_32;
               hwdbg_cfgreg_i_2 host_dbg_mux_data_core_d3_o_31_0;
               PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE pcie_fcp_timer_beacon_en_pcicfg_override;
               PCIE_OPTION_ROM_FLASH_TRANSLATION_F0 pcie_option_rom_flash_translation_f0;
               PCIE_LTSSM_CHANGE_CMD_CFG_RETRY pcie_ltssm_change_st_cmd_cfg_retry;
               PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET pcie_pf_vfs_ari_next_cap_off;
               PCIE_SERDES_RISEQC pcie_serdes_riseqc;
               PCIE_PM_PME_SERDES_LEVSEL_V0_SEL pcie_pm_pme_serdes_levsel_v0_sel;
               hwdbg_cfgreg_i_5 host_dbg_mux_data_pclk_d3_o_63_32;
               hwdbg_cfgreg_i_6 dbg_teslave_31_0;
               hwdbg_cfgreg_i_0 host_dbg_mux_data_core_o_31_0;
               hwdbg_cfgreg_i_1 host_dbg_mux_data_core_o_63_32;
               PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
               PCIE_ARI_CAPABILITY pcie_ari_capability;
               PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
               PCIE_ATS_CAPABILITY pcie_ats_capability;
               hwdbg_cfgreg_i_7 dbg_all_reqs_31_0;
               PCICFG_HOST_INT_STATUS_CSR host_int_status;
               PCICFG_HOST_INT_MASK_CSR host_int_mask;
               PCICFG_HOST_TIMER_INT_CTRL_CSR host_timer_ctrl;
               PCIE_SR_IOV_ENHANCED_CAP SR_IOV_capability_id;
               PCIE_SR_IOV_CAPABILITIES SR_IOV_capabilities;
               PCIE_SR_IOV_STATUS_CONTROL SR_IOV_status_control;
               PCIE_TOTAL_INITIAL_VFs total_initial_VFs;
               PCIE_NUM_VFs number_of_VFs;
               PCIE_VF_STRIDE_OFFSET VF_stride_offset;
               PCIE_VF_DEVICE_ID VF_device_id;
               PCIE_VF_SYSTEM_PAGE_SUPPORTED PF_supported_page_size;
               PCIE_VF_SYSTEM_PAGE PF_system_page;
               PCICFG_RETURN_ZEROS return_zeros_2[2];
               PCICFG_RETURN_ZEROS return_zeros_2_1[2];
               PCICFG_VF_MEMBAR0_LO VF_membar0_low;
               PCICFG_VF_MEMBAR0_HI VF_membar0_high;
               PCICFG_RETURN_ZEROS return_zeros_3;
               PCICFG_IP_SPEED_WIDTH_CTRL ip_speed_width_control;
               PCICFG_IP_CONTROL_STATUS_5_CSR ip_control_status_5;
               PCICFG_IP_CONTROL_STATUS_4_CSR ip_control_status_4;
               PCICFG_ERR_REPLAY_MONITOR error_replay_monitor;
               PCICFG_IP_CONTROL_STATUS_2_CSR ip_control_status_2;
               PCICFG_IP_CONTROL_STATUS_0_CSR ip_control_status_0;
               PCICFG_IP_CONTROL_STATUS_1_CSR ip_control_status_1;
               PCICFG_HWDBG_SHIFT hwdbg_shift;
               PCICFG_HWDBG_MASK_0_PCLK hwdbg_mask_0_pclk;
               PCICFG_HWDBG_MASK_1_PCLK hwdbg_mask_1_pclk;
               PCICFG_HWDBG_MASK_0_CORE_D3 hwdbg_mask_0_core_d3;
               PCICFG_HWDBG_MASK_1_CORE_D3 hwdbg_mask_1_core_d3;
               PCICFG_HWDBG_MASK_0_CORE hwdbg_mask_0_core;
               PCICFG_HWDBG_MASK_1_CORE hwdbg_mask_1_core;
               PCICFG_HWDBG_REGSEL hwdbg_regsel;
               PCICFG_HWDBG_ENABLE hwdbg_enable;
               u32 rsvd3[896];                    // DWORDS 128 to 1023
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PF0_CSRMAP, *PPCICFG_PF0_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG_PF0_CSRMAP, sizeof (PCICFG_PF0_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG_PF0_CSRMAP {
         PCICFG_ID_F0_CSR id;
         PCICFG_COMMAND_STATUS_CSR cmd_status;
         PCICFG_CLASS_REV_F0_CSR class_rev;
         PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
         u32 rsvd0[1];                            // DWORDS 4 to 4
         PCICFG_MEMBAR0_CSR membar0;
         PCICFG_MEMBAR1_LO_CSR membar1_lo;
         PCICFG_MEMBAR1_HI_CSR membar1_hi;
         PCICFG_MEMBAR2_LO_F0_CSR membar2_lo;
         PCICFG_MEMBAR2_HI_CSR membar2_hi;
         u32 rsvd1[1];                            // DWORDS 10 to 10
         PCICFG_SUBSYSTEM_ID_F0_CSR subsystem_id;
         PCICFG_EXP_ROM_CSR exp_rom;
         PCICFG_CAP_CSR cap;
         u32 rsvd2[1];                            // DWORDS 14 to 14
         PCICFG_LATENCY_INT_F0_CSR latency_int;
         PCICFG_PMC_CSR pmc;
         PCICFG_PM_CONTROL pm_control;
         PCICFG_MSIX_CSR msix;
         PCICFG_MSIX_TABLE_CSR msix_table_offset;
         PCICFG_MSIX_PBA_CSR msix_pba_offset;
         PCICFG_HOST_CONTROL_STATUS_CSR host_control;
         PCICFG_SCRATCHPAD_CSR scratchpad;
         PCICFG_SOFT_RESET_CSR soft_reset;
         PCICFG_LPC_ADDR_CSR lpc_addr;
         PCICFG_LPC_DATA_CSR lpc_data;
         PCICFG_LPC_COMMAND_CSR lpc_command;
         PCICFG_IP_CONTROL_STATUS_3_CSR ip_control_status_3;
         PCICFG_GPI_CSR gpi[2];
         PCICFG_GPO_LOW_CSR gpo_low;
         PCICFG_GPO_HI_CSR gpo_hi;
         PCICFG_GPIOMAP_CSR gpiomap[8];
         PCICFG_UE_STATUS_LOW_CSR ue_status_low;
         PCICFG_UE_STATUS_HI_CSR ue_status_hi;
         PCICFG_UE_STATUS_LOW_MASK_CSR ue_status_low_mask;
         PCICFG_UE_STATUS_HI_MASK_CSR ue_status_hi_mask;
         PCICFG_ONLINE0_CSR online0;
         PCICFG_ONLINE1_CSR online1;
         PCICFG_DEBUG_CSR debug;
         PCICFG_SEMAPHORE_CSR semaphore;
         PCICFG_PCIE_CAP_CSR pcie_cap;
         PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
         PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
         PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
         PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
         PCICFG_RETURN_ZEROS return_zeros[4];
         PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
         PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
         PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
         PCICFG_PCIE_LINK_STATUS2_CSR pcie_link_status2;
         PCICFG_RETURN_ZEROS return_zeros_1[2];
         PCICFG_MEMBAR_CTRL_INT_CTRL_CSR membar_ctrl_intr_ctrl;
         PCIE_ERR_ENHANCED_CAP pcie_err_enhanced_cap;
         PCIE_UNCORR_ERR_STATUS pcie_uncorr_err_status;
         PCIE_UNCORR_ERR_MASK pcie_uncorr_err_mask;
         PCIE_UNCORR_ERR_SEVERITY pcie_uncorr_err_severity;
         PCIE_CORR_ERR_STATUS pcie_corr_err_status;
         PCIE_CORR_ERR_MASK pcie_corr_err_mask;
         PCIE_ERR_CAP_CONTROL pcie_err_cap_control;
         PCIE_HEADER_REGISTER pcie_header_register0;
         PCIE_HEADER_REGISTER pcie_header_register1;
         PCIE_HEADER_REGISTER pcie_header_register2;
         PCIE_HEADER_REGISTER pcie_header_register3;
         hwdbg_cfgreg_i_4 host_dbg_mux_data_pclk_d3_o_31_0;
         hwdbg_cfgreg_i_3 host_dbg_mux_data_core_d3_o_63_32;
         hwdbg_cfgreg_i_2 host_dbg_mux_data_core_d3_o_31_0;
         PCIE_FCP_TIMER_BEACON_EN_PCICFG_OVERRIDE pcie_fcp_timer_beacon_en_pcicfg_override;
         PCIE_OPTION_ROM_FLASH_TRANSLATION_F0 pcie_option_rom_flash_translation_f0;
         PCIE_LTSSM_CHANGE_CMD_CFG_RETRY pcie_ltssm_change_st_cmd_cfg_retry;
         PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET pcie_pf_vfs_ari_next_cap_off;
         PCIE_SERDES_RISEQC pcie_serdes_riseqc;
         PCIE_PM_PME_SERDES_LEVSEL_V0_SEL pcie_pm_pme_serdes_levsel_v0_sel;
         hwdbg_cfgreg_i_5 host_dbg_mux_data_pclk_d3_o_63_32;
         hwdbg_cfgreg_i_6 dbg_teslave_31_0;
         hwdbg_cfgreg_i_0 host_dbg_mux_data_core_o_31_0;
         hwdbg_cfgreg_i_1 host_dbg_mux_data_core_o_63_32;
         PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
         PCIE_ARI_CAPABILITY pcie_ari_capability;
         PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
         PCIE_ATS_CAPABILITY pcie_ats_capability;
         hwdbg_cfgreg_i_7 dbg_all_reqs_31_0;
         PCICFG_HOST_INT_STATUS_CSR host_int_status;
         PCICFG_HOST_INT_MASK_CSR host_int_mask;
         PCICFG_HOST_TIMER_INT_CTRL_CSR host_timer_ctrl;
         PCIE_SR_IOV_ENHANCED_CAP SR_IOV_capability_id;
         PCIE_SR_IOV_CAPABILITIES SR_IOV_capabilities;
         PCIE_SR_IOV_STATUS_CONTROL SR_IOV_status_control;
         PCIE_TOTAL_INITIAL_VFs total_initial_VFs;
         PCIE_NUM_VFs number_of_VFs;
         PCIE_VF_STRIDE_OFFSET VF_stride_offset;
         PCIE_VF_DEVICE_ID VF_device_id;
         PCIE_VF_SYSTEM_PAGE_SUPPORTED PF_supported_page_size;
         PCIE_VF_SYSTEM_PAGE PF_system_page;
         PCICFG_RETURN_ZEROS return_zeros_2[2];
         PCICFG_RETURN_ZEROS return_zeros_2_1[2];
         PCICFG_VF_MEMBAR0_LO VF_membar0_low;
         PCICFG_VF_MEMBAR0_HI VF_membar0_high;
         PCICFG_RETURN_ZEROS return_zeros_3;
         PCICFG_IP_SPEED_WIDTH_CTRL ip_speed_width_control;
         PCICFG_IP_CONTROL_STATUS_5_CSR ip_control_status_5;
         PCICFG_IP_CONTROL_STATUS_4_CSR ip_control_status_4;
         PCICFG_ERR_REPLAY_MONITOR error_replay_monitor;
         PCICFG_IP_CONTROL_STATUS_2_CSR ip_control_status_2;
         PCICFG_IP_CONTROL_STATUS_0_CSR ip_control_status_0;
         PCICFG_IP_CONTROL_STATUS_1_CSR ip_control_status_1;
         PCICFG_HWDBG_SHIFT hwdbg_shift;
         PCICFG_HWDBG_MASK_0_PCLK hwdbg_mask_0_pclk;
         PCICFG_HWDBG_MASK_1_PCLK hwdbg_mask_1_pclk;
         PCICFG_HWDBG_MASK_0_CORE_D3 hwdbg_mask_0_core_d3;
         PCICFG_HWDBG_MASK_1_CORE_D3 hwdbg_mask_1_core_d3;
         PCICFG_HWDBG_MASK_0_CORE hwdbg_mask_0_core;
         PCICFG_HWDBG_MASK_1_CORE hwdbg_mask_1_core;
         PCICFG_HWDBG_REGSEL hwdbg_regsel;
         PCICFG_HWDBG_ENABLE hwdbg_enable;
         u32 rsvd3[896];                          // DWORDS 128 to 1023
      } SG_PACK PCICFG_PF0_CSRMAP, *PPCICFG_PF0_CSRMAP;

      typedef union _PCICFG_PF0_CSRMAP_UNION {
         PCICFG_PF0_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG_PF0_CSRMAP_UNION, *PPCICFG_PF0_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PF0_CSRMAP_UNION, sizeof (PCICFG_PF0_CSRMAP_UNION) == 4096);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This PCI configuration space register map is for the Networking Function of
   // BladeEngine (Function 1). For more detailed descriptions of the fields below click
   // the link under the mnemonic column. Registers highlighted in pink color are
   // physically shared between both Functions (0 and 1). 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PF1_PF7_CSRMAP {
         union {
            struct { 
               PCICFG_ID_F1_CSR id;
               PCICFG_COMMAND_STATUS_CSR cmd_status;
               PCICFG_CLASS_REV_F1_CSR class_rev;
               PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
               u32 rsvd0[1];                      // DWORDS 4 to 4
               PCICFG_MEMBAR0_CSR membar0;
               PCICFG_MEMBAR1_LO_CSR membar1_lo;
               PCICFG_MEMBAR1_HI_CSR membar1_hi;
               PCICFG_MEMBAR2_LO_F1_CSR membar2_lo;
               PCICFG_MEMBAR2_HI_CSR membar2_hi;
               u32 rsvd1[1];                      // DWORDS 10 to 10
               PCICFG_SUBSYSTEM_ID_F1_CSR subsystem_id;
               PCICFG_EXP_ROM_CSR exp_rom;
               PCICFG_CAP_CSR cap;
               u32 rsvd2[1];                      // DWORDS 14 to 14
               PCICFG_LATENCY_INT_F1_CSR latency_int;
               PCICFG_PMC_CSR pmc;
               PCICFG_PM_CONTROL pm_control;
               PCICFG_MSIX_CSR msix;
               PCICFG_MSIX_TABLE_CSR msix_table_offset;
               PCICFG_MSIX_PBA_CSR msix_pba_offset;
               PCICFG_HOST_CONTROL_STATUS_CSR host_control;
               PCICFG_SCRATCHPAD_CSR scratchpad;
               PCICFG_SOFT_RESET_CSR soft_reset;
               PCICFG_LPC_ADDR_CSR lpc_addr;
               PCICFG_LPC_DATA_CSR lpc_data;
               PCICFG_LPC_COMMAND_CSR lpc_command;
               PCICFG_IP_CONTROL_STATUS_3_CSR ip_control_status_3;
               PCICFG_GPI_CSR gpi[2];
               PCICFG_GPO_LOW_CSR gpo_low;
               PCICFG_GPO_HI_CSR gpo_hi;
               PCICFG_GPIOMAP_CSR gpiomap[8];
               PCICFG_UE_STATUS_LOW_CSR ue_status_low;
               PCICFG_UE_STATUS_HI_CSR ue_status_hi;
               PCICFG_UE_STATUS_LOW_MASK_CSR ue_status_low_mask;
               PCICFG_UE_STATUS_HI_MASK_CSR ue_status_hi_mask;
               PCICFG_ONLINE0_CSR online0;
               PCICFG_ONLINE1_CSR online1;
               PCICFG_DEBUG_CSR debug;
               PCICFG_SEMAPHORE_CSR semaphore;
               PCICFG_PCIE_CAP_CSR pcie_cap;
               PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
               PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
               PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
               PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
               PCICFG_RETURN_ZEROS return_zeros[4];
               PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
               PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
               PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
               PCICFG_PCIE_LINK_STATUS2_CSR_F1 pcie_link_status2;
               PCICFG_RETURN_ZEROS return_zeros_1[2];
               PCICFG_MEMBAR_CTRL_INT_CTRL_CSR membar_ctrl_intr_ctrl;
               PCIE_ERR_ENHANCED_CAP pcie_err_enhanced_cap;
               PCIE_UNCORR_ERR_STATUS pcie_uncorr_err_status;
               PCIE_UNCORR_ERR_MASK pcie_uncorr_err_mask;
               PCIE_UNCORR_ERR_SEVERITY pcie_uncorr_err_severity;
               PCIE_CORR_ERR_STATUS pcie_corr_err_status;
               PCIE_CORR_ERR_MASK pcie_corr_err_mask;
               PCIE_ERR_CAP_CONTROL pcie_err_cap_control;
               PCIE_HEADER_REGISTER pcie_header_register0;
               PCIE_HEADER_REGISTER pcie_header_register1;
               PCIE_HEADER_REGISTER pcie_header_register2;
               PCIE_HEADER_REGISTER pcie_header_register3;
               u32 rsvd3[4];                      // DWORDS 75 to 78
               PCIE_OPTION_ROM_FLASH_TRANSLATION_F1 pcie_option_rom_flash_translation_f1;
               u32 rsvd4[1];                      // DWORDS 80 to 80
               PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET pcie_pf_vfs_ari_next_cap_off;
               u32 rsvd5[6];                      // DWORDS 82 to 87
               PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
               PCIE_ARI_CAPABILITY pcie_ari_capability;
               PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
               PCIE_ATS_CAPABILITY pcie_ats_capability;
               u32 rsvd6[1];                      // DWORDS 92 to 92
               PCICFG_HOST_INT_STATUS_CSR host_int_status;
               PCICFG_HOST_INT_MASK_CSR host_int_mask;
               PCICFG_HOST_TIMER_INT_CTRL_CSR host_timer_ctrl;
               PCIE_SR_IOV_ENHANCED_CAP SR_IOV_capability_id;
               PCIE_SR_IOV_CAPABILITIES SR_IOV_capabilities;
               PCIE_SR_IOV_STATUS_CONTROL SR_IOV_status_control;
               PCIE_TOTAL_INITIAL_VFs total_initial_VFs;
               PCIE_NUM_VFs number_of_VFs;
               PCIE_VF_STRIDE_OFFSET VF_stride_offset;
               PCIE_VF_DEVICE_ID VF_device_id;
               PCIE_VF_SYSTEM_PAGE_SUPPORTED PF_supported_page_size;
               PCIE_VF_SYSTEM_PAGE PF_system_page;
               PCICFG_RETURN_ZEROS return_zeros_2[2];
               PCICFG_RETURN_ZEROS return_zeros_2_1[2];
               PCICFG_VF_MEMBAR0_LO VF_membar0_low;
               PCICFG_VF_MEMBAR0_HI VF_membar0_high;
               PCICFG_RETURN_ZEROS return_zeros_3;
               u32 rsvd7[5];                      // DWORDS 112 to 116
               u32 rsvd8[7];                      // DWORDS 117 to 123
               PCIE_SERDES_TISAMP_GEN1 gen1_tisamp;
               PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1 gen1_tisemppo_tisempma;
               PCIE_SERDES_TISAMP_GEN2 gen2_tisamp;
               PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2 gen2_tisemppo_tisempma;
               u32 rsvd9[896];                    // DWORDS 128 to 1023
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PF1_PF7_CSRMAP, *PPCICFG_PF1_PF7_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG_PF1_PF7_CSRMAP, sizeof (PCICFG_PF1_PF7_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG_PF1_PF7_CSRMAP {
         PCICFG_ID_F1_CSR id;
         PCICFG_COMMAND_STATUS_CSR cmd_status;
         PCICFG_CLASS_REV_F1_CSR class_rev;
         PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
         u32 rsvd0[1];                            // DWORDS 4 to 4
         PCICFG_MEMBAR0_CSR membar0;
         PCICFG_MEMBAR1_LO_CSR membar1_lo;
         PCICFG_MEMBAR1_HI_CSR membar1_hi;
         PCICFG_MEMBAR2_LO_F1_CSR membar2_lo;
         PCICFG_MEMBAR2_HI_CSR membar2_hi;
         u32 rsvd1[1];                            // DWORDS 10 to 10
         PCICFG_SUBSYSTEM_ID_F1_CSR subsystem_id;
         PCICFG_EXP_ROM_CSR exp_rom;
         PCICFG_CAP_CSR cap;
         u32 rsvd2[1];                            // DWORDS 14 to 14
         PCICFG_LATENCY_INT_F1_CSR latency_int;
         PCICFG_PMC_CSR pmc;
         PCICFG_PM_CONTROL pm_control;
         PCICFG_MSIX_CSR msix;
         PCICFG_MSIX_TABLE_CSR msix_table_offset;
         PCICFG_MSIX_PBA_CSR msix_pba_offset;
         PCICFG_HOST_CONTROL_STATUS_CSR host_control;
         PCICFG_SCRATCHPAD_CSR scratchpad;
         PCICFG_SOFT_RESET_CSR soft_reset;
         PCICFG_LPC_ADDR_CSR lpc_addr;
         PCICFG_LPC_DATA_CSR lpc_data;
         PCICFG_LPC_COMMAND_CSR lpc_command;
         PCICFG_IP_CONTROL_STATUS_3_CSR ip_control_status_3;
         PCICFG_GPI_CSR gpi[2];
         PCICFG_GPO_LOW_CSR gpo_low;
         PCICFG_GPO_HI_CSR gpo_hi;
         PCICFG_GPIOMAP_CSR gpiomap[8];
         PCICFG_UE_STATUS_LOW_CSR ue_status_low;
         PCICFG_UE_STATUS_HI_CSR ue_status_hi;
         PCICFG_UE_STATUS_LOW_MASK_CSR ue_status_low_mask;
         PCICFG_UE_STATUS_HI_MASK_CSR ue_status_hi_mask;
         PCICFG_ONLINE0_CSR online0;
         PCICFG_ONLINE1_CSR online1;
         PCICFG_DEBUG_CSR debug;
         PCICFG_SEMAPHORE_CSR semaphore;
         PCICFG_PCIE_CAP_CSR pcie_cap;
         PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
         PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
         PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
         PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
         PCICFG_RETURN_ZEROS return_zeros[4];
         PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
         PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
         PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
         PCICFG_PCIE_LINK_STATUS2_CSR_F1 pcie_link_status2;
         PCICFG_RETURN_ZEROS return_zeros_1[2];
         PCICFG_MEMBAR_CTRL_INT_CTRL_CSR membar_ctrl_intr_ctrl;
         PCIE_ERR_ENHANCED_CAP pcie_err_enhanced_cap;
         PCIE_UNCORR_ERR_STATUS pcie_uncorr_err_status;
         PCIE_UNCORR_ERR_MASK pcie_uncorr_err_mask;
         PCIE_UNCORR_ERR_SEVERITY pcie_uncorr_err_severity;
         PCIE_CORR_ERR_STATUS pcie_corr_err_status;
         PCIE_CORR_ERR_MASK pcie_corr_err_mask;
         PCIE_ERR_CAP_CONTROL pcie_err_cap_control;
         PCIE_HEADER_REGISTER pcie_header_register0;
         PCIE_HEADER_REGISTER pcie_header_register1;
         PCIE_HEADER_REGISTER pcie_header_register2;
         PCIE_HEADER_REGISTER pcie_header_register3;
         u32 rsvd3[4];                            // DWORDS 75 to 78
         PCIE_OPTION_ROM_FLASH_TRANSLATION_F1 pcie_option_rom_flash_translation_f1;
         u32 rsvd4[1];                            // DWORDS 80 to 80
         PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET pcie_pf_vfs_ari_next_cap_off;
         u32 rsvd5[6];                            // DWORDS 82 to 87
         PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
         PCIE_ARI_CAPABILITY pcie_ari_capability;
         PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
         PCIE_ATS_CAPABILITY pcie_ats_capability;
         u32 rsvd6[1];                            // DWORDS 92 to 92
         PCICFG_HOST_INT_STATUS_CSR host_int_status;
         PCICFG_HOST_INT_MASK_CSR host_int_mask;
         PCICFG_HOST_TIMER_INT_CTRL_CSR host_timer_ctrl;
         PCIE_SR_IOV_ENHANCED_CAP SR_IOV_capability_id;
         PCIE_SR_IOV_CAPABILITIES SR_IOV_capabilities;
         PCIE_SR_IOV_STATUS_CONTROL SR_IOV_status_control;
         PCIE_TOTAL_INITIAL_VFs total_initial_VFs;
         PCIE_NUM_VFs number_of_VFs;
         PCIE_VF_STRIDE_OFFSET VF_stride_offset;
         PCIE_VF_DEVICE_ID VF_device_id;
         PCIE_VF_SYSTEM_PAGE_SUPPORTED PF_supported_page_size;
         PCIE_VF_SYSTEM_PAGE PF_system_page;
         PCICFG_RETURN_ZEROS return_zeros_2[2];
         PCICFG_RETURN_ZEROS return_zeros_2_1[2];
         PCICFG_VF_MEMBAR0_LO VF_membar0_low;
         PCICFG_VF_MEMBAR0_HI VF_membar0_high;
         PCICFG_RETURN_ZEROS return_zeros_3;
         u32 rsvd7[5];                            // DWORDS 112 to 116
         u32 rsvd8[7];                            // DWORDS 117 to 123
         PCIE_SERDES_TISAMP_GEN1 gen1_tisamp;
         PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1 gen1_tisemppo_tisempma;
         PCIE_SERDES_TISAMP_GEN2 gen2_tisamp;
         PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2 gen2_tisemppo_tisempma;
         u32 rsvd9[896];                          // DWORDS 128 to 1023
      } SG_PACK PCICFG_PF1_PF7_CSRMAP, *PPCICFG_PF1_PF7_CSRMAP;

      typedef union _PCICFG_PF1_PF7_CSRMAP_UNION {
         PCICFG_PF1_PF7_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG_PF1_PF7_CSRMAP_UNION, *PPCICFG_PF1_PF7_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PF1_PF7_CSRMAP_UNION, sizeof (PCICFG_PF1_PF7_CSRMAP_UNION) == 4096);
   #endif


#else
   // This PCI configuration space register map is for the Networking Function of
   // BladeEngine (Function 1). For more detailed descriptions of the fields below click
   // the link under the mnemonic column. Registers highlighted in pink color are
   // physically shared between both Functions (0 and 1). 
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG_PF1_PF7_CSRMAP {
         union {
            struct { 
               PCICFG_ID_F1_CSR id;
               PCICFG_COMMAND_STATUS_CSR cmd_status;
               PCICFG_CLASS_REV_F1_CSR class_rev;
               PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
               u32 rsvd0[1];                      // DWORDS 4 to 4
               PCICFG_MEMBAR0_CSR membar0;
               PCICFG_MEMBAR1_LO_CSR membar1_lo;
               PCICFG_MEMBAR1_HI_CSR membar1_hi;
               PCICFG_MEMBAR2_LO_F1_CSR membar2_lo;
               PCICFG_MEMBAR2_HI_CSR membar2_hi;
               u32 rsvd1[1];                      // DWORDS 10 to 10
               PCICFG_SUBSYSTEM_ID_F1_CSR subsystem_id;
               PCICFG_EXP_ROM_CSR exp_rom;
               PCICFG_CAP_CSR cap;
               u32 rsvd2[1];                      // DWORDS 14 to 14
               PCICFG_LATENCY_INT_F1_CSR latency_int;
               PCICFG_PMC_CSR pmc;
               PCICFG_PM_CONTROL pm_control;
               PCICFG_MSIX_CSR msix;
               PCICFG_MSIX_TABLE_CSR msix_table_offset;
               PCICFG_MSIX_PBA_CSR msix_pba_offset;
               PCICFG_HOST_CONTROL_STATUS_CSR host_control;
               PCICFG_SCRATCHPAD_CSR scratchpad;
               PCICFG_SOFT_RESET_CSR soft_reset;
               PCICFG_LPC_ADDR_CSR lpc_addr;
               PCICFG_LPC_DATA_CSR lpc_data;
               PCICFG_LPC_COMMAND_CSR lpc_command;
               PCICFG_IP_CONTROL_STATUS_3_CSR ip_control_status_3;
               PCICFG_GPI_CSR gpi[2];
               PCICFG_GPO_LOW_CSR gpo_low;
               PCICFG_GPO_HI_CSR gpo_hi;
               PCICFG_GPIOMAP_CSR gpiomap[8];
               PCICFG_UE_STATUS_LOW_CSR ue_status_low;
               PCICFG_UE_STATUS_HI_CSR ue_status_hi;
               PCICFG_UE_STATUS_LOW_MASK_CSR ue_status_low_mask;
               PCICFG_UE_STATUS_HI_MASK_CSR ue_status_hi_mask;
               PCICFG_ONLINE0_CSR online0;
               PCICFG_ONLINE1_CSR online1;
               PCICFG_DEBUG_CSR debug;
               PCICFG_SEMAPHORE_CSR semaphore;
               PCICFG_PCIE_CAP_CSR pcie_cap;
               PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
               PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
               PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
               PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
               PCICFG_RETURN_ZEROS return_zeros[4];
               PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
               PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
               PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
               PCICFG_PCIE_LINK_STATUS2_CSR_F1 pcie_link_status2;
               PCICFG_RETURN_ZEROS return_zeros_1[2];
               PCICFG_MEMBAR_CTRL_INT_CTRL_CSR membar_ctrl_intr_ctrl;
               PCIE_ERR_ENHANCED_CAP pcie_err_enhanced_cap;
               PCIE_UNCORR_ERR_STATUS pcie_uncorr_err_status;
               PCIE_UNCORR_ERR_MASK pcie_uncorr_err_mask;
               PCIE_UNCORR_ERR_SEVERITY pcie_uncorr_err_severity;
               PCIE_CORR_ERR_STATUS pcie_corr_err_status;
               PCIE_CORR_ERR_MASK pcie_corr_err_mask;
               PCIE_ERR_CAP_CONTROL pcie_err_cap_control;
               PCIE_HEADER_REGISTER pcie_header_register0;
               PCIE_HEADER_REGISTER pcie_header_register1;
               PCIE_HEADER_REGISTER pcie_header_register2;
               PCIE_HEADER_REGISTER pcie_header_register3;
               u32 rsvd3[4];                      // DWORDS 75 to 78
               PCIE_OPTION_ROM_FLASH_TRANSLATION_F1 pcie_option_rom_flash_translation_f1;
               u32 rsvd4[1];                      // DWORDS 80 to 80
               PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET pcie_pf_vfs_ari_next_cap_off;
               u32 rsvd5[6];                      // DWORDS 82 to 87
               PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
               PCIE_ARI_CAPABILITY pcie_ari_capability;
               PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
               PCIE_ATS_CAPABILITY pcie_ats_capability;
               u32 rsvd6[1];                      // DWORDS 92 to 92
               PCICFG_HOST_INT_STATUS_CSR host_int_status;
               PCICFG_HOST_INT_MASK_CSR host_int_mask;
               PCICFG_HOST_TIMER_INT_CTRL_CSR host_timer_ctrl;
               PCIE_SR_IOV_ENHANCED_CAP SR_IOV_capability_id;
               PCIE_SR_IOV_CAPABILITIES SR_IOV_capabilities;
               PCIE_SR_IOV_STATUS_CONTROL SR_IOV_status_control;
               PCIE_TOTAL_INITIAL_VFs total_initial_VFs;
               PCIE_NUM_VFs number_of_VFs;
               PCIE_VF_STRIDE_OFFSET VF_stride_offset;
               PCIE_VF_DEVICE_ID VF_device_id;
               PCIE_VF_SYSTEM_PAGE_SUPPORTED PF_supported_page_size;
               PCIE_VF_SYSTEM_PAGE PF_system_page;
               PCICFG_RETURN_ZEROS return_zeros_2[2];
               PCICFG_RETURN_ZEROS return_zeros_2_1[2];
               PCICFG_VF_MEMBAR0_LO VF_membar0_low;
               PCICFG_VF_MEMBAR0_HI VF_membar0_high;
               PCICFG_RETURN_ZEROS return_zeros_3;
               u32 rsvd7[5];                      // DWORDS 112 to 116
               u32 rsvd8[7];                      // DWORDS 117 to 123
               PCIE_SERDES_TISAMP_GEN1 gen1_tisamp;
               PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1 gen1_tisemppo_tisempma;
               PCIE_SERDES_TISAMP_GEN2 gen2_tisamp;
               PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2 gen2_tisemppo_tisempma;
               u32 rsvd9[896];                    // DWORDS 128 to 1023
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG_PF1_PF7_CSRMAP, *PPCICFG_PF1_PF7_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG_PF1_PF7_CSRMAP, sizeof (PCICFG_PF1_PF7_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG_PF1_PF7_CSRMAP {
         PCICFG_ID_F1_CSR id;
         PCICFG_COMMAND_STATUS_CSR cmd_status;
         PCICFG_CLASS_REV_F1_CSR class_rev;
         PCICFG_CACHE_TMR_HDR_BIST_CSR cache;
         u32 rsvd0[1];                            // DWORDS 4 to 4
         PCICFG_MEMBAR0_CSR membar0;
         PCICFG_MEMBAR1_LO_CSR membar1_lo;
         PCICFG_MEMBAR1_HI_CSR membar1_hi;
         PCICFG_MEMBAR2_LO_F1_CSR membar2_lo;
         PCICFG_MEMBAR2_HI_CSR membar2_hi;
         u32 rsvd1[1];                            // DWORDS 10 to 10
         PCICFG_SUBSYSTEM_ID_F1_CSR subsystem_id;
         PCICFG_EXP_ROM_CSR exp_rom;
         PCICFG_CAP_CSR cap;
         u32 rsvd2[1];                            // DWORDS 14 to 14
         PCICFG_LATENCY_INT_F1_CSR latency_int;
         PCICFG_PMC_CSR pmc;
         PCICFG_PM_CONTROL pm_control;
         PCICFG_MSIX_CSR msix;
         PCICFG_MSIX_TABLE_CSR msix_table_offset;
         PCICFG_MSIX_PBA_CSR msix_pba_offset;
         PCICFG_HOST_CONTROL_STATUS_CSR host_control;
         PCICFG_SCRATCHPAD_CSR scratchpad;
         PCICFG_SOFT_RESET_CSR soft_reset;
         PCICFG_LPC_ADDR_CSR lpc_addr;
         PCICFG_LPC_DATA_CSR lpc_data;
         PCICFG_LPC_COMMAND_CSR lpc_command;
         PCICFG_IP_CONTROL_STATUS_3_CSR ip_control_status_3;
         PCICFG_GPI_CSR gpi[2];
         PCICFG_GPO_LOW_CSR gpo_low;
         PCICFG_GPO_HI_CSR gpo_hi;
         PCICFG_GPIOMAP_CSR gpiomap[8];
         PCICFG_UE_STATUS_LOW_CSR ue_status_low;
         PCICFG_UE_STATUS_HI_CSR ue_status_hi;
         PCICFG_UE_STATUS_LOW_MASK_CSR ue_status_low_mask;
         PCICFG_UE_STATUS_HI_MASK_CSR ue_status_hi_mask;
         PCICFG_ONLINE0_CSR online0;
         PCICFG_ONLINE1_CSR online1;
         PCICFG_DEBUG_CSR debug;
         PCICFG_SEMAPHORE_CSR semaphore;
         PCICFG_PCIE_CAP_CSR pcie_cap;
         PCICFG_PCIE_DEVCAP_CSR pcie_devcap;
         PCICFG_PCIE_CONTROL_STATUS_CSR pcie_control_status;
         PCICFG_PCIE_LINK_CAP_CSR pcie_link_cap;
         PCICFG_PCIE_LINK_STATUS_CSR pcie_link_status;
         PCICFG_RETURN_ZEROS return_zeros[4];
         PCICFG_PCIE_DEVCAP2_CSR pcie_devcap2;
         PCICFG_PCIE_CONTROL_STATUS2_CSR pcie_control_status2;
         PCICFG_PCIE_LINK_CAP2_CSR pcie_link_cap2;
         PCICFG_PCIE_LINK_STATUS2_CSR_F1 pcie_link_status2;
         PCICFG_RETURN_ZEROS return_zeros_1[2];
         PCICFG_MEMBAR_CTRL_INT_CTRL_CSR membar_ctrl_intr_ctrl;
         PCIE_ERR_ENHANCED_CAP pcie_err_enhanced_cap;
         PCIE_UNCORR_ERR_STATUS pcie_uncorr_err_status;
         PCIE_UNCORR_ERR_MASK pcie_uncorr_err_mask;
         PCIE_UNCORR_ERR_SEVERITY pcie_uncorr_err_severity;
         PCIE_CORR_ERR_STATUS pcie_corr_err_status;
         PCIE_CORR_ERR_MASK pcie_corr_err_mask;
         PCIE_ERR_CAP_CONTROL pcie_err_cap_control;
         PCIE_HEADER_REGISTER pcie_header_register0;
         PCIE_HEADER_REGISTER pcie_header_register1;
         PCIE_HEADER_REGISTER pcie_header_register2;
         PCIE_HEADER_REGISTER pcie_header_register3;
         u32 rsvd3[4];                            // DWORDS 75 to 78
         PCIE_OPTION_ROM_FLASH_TRANSLATION_F1 pcie_option_rom_flash_translation_f1;
         u32 rsvd4[1];                            // DWORDS 80 to 80
         PCIE_PF_VFS_ARI_NEXT_CAP_OFFSET pcie_pf_vfs_ari_next_cap_off;
         u32 rsvd5[6];                            // DWORDS 82 to 87
         PCIE_ARI_ENHANCED_CAP pcie_ari_enhanced_hdr;
         PCIE_ARI_CAPABILITY pcie_ari_capability;
         PCIE_ATS_ENHANCED_CAP pcie_ats_enhanced_hdr;
         PCIE_ATS_CAPABILITY pcie_ats_capability;
         u32 rsvd6[1];                            // DWORDS 92 to 92
         PCICFG_HOST_INT_STATUS_CSR host_int_status;
         PCICFG_HOST_INT_MASK_CSR host_int_mask;
         PCICFG_HOST_TIMER_INT_CTRL_CSR host_timer_ctrl;
         PCIE_SR_IOV_ENHANCED_CAP SR_IOV_capability_id;
         PCIE_SR_IOV_CAPABILITIES SR_IOV_capabilities;
         PCIE_SR_IOV_STATUS_CONTROL SR_IOV_status_control;
         PCIE_TOTAL_INITIAL_VFs total_initial_VFs;
         PCIE_NUM_VFs number_of_VFs;
         PCIE_VF_STRIDE_OFFSET VF_stride_offset;
         PCIE_VF_DEVICE_ID VF_device_id;
         PCIE_VF_SYSTEM_PAGE_SUPPORTED PF_supported_page_size;
         PCIE_VF_SYSTEM_PAGE PF_system_page;
         PCICFG_RETURN_ZEROS return_zeros_2[2];
         PCICFG_RETURN_ZEROS return_zeros_2_1[2];
         PCICFG_VF_MEMBAR0_LO VF_membar0_low;
         PCICFG_VF_MEMBAR0_HI VF_membar0_high;
         PCICFG_RETURN_ZEROS return_zeros_3;
         u32 rsvd7[5];                            // DWORDS 112 to 116
         u32 rsvd8[7];                            // DWORDS 117 to 123
         PCIE_SERDES_TISAMP_GEN1 gen1_tisamp;
         PCIE_SERDES_TISEMPPO_TISEMPMA_GEN1 gen1_tisemppo_tisempma;
         PCIE_SERDES_TISAMP_GEN2 gen2_tisamp;
         PCIE_SERDES_TISEMPPO_TISEMPMA_GEN2 gen2_tisemppo_tisempma;
         u32 rsvd9[896];                          // DWORDS 128 to 1023
      } SG_PACK PCICFG_PF1_PF7_CSRMAP, *PPCICFG_PF1_PF7_CSRMAP;

      typedef union _PCICFG_PF1_PF7_CSRMAP_UNION {
         PCICFG_PF1_PF7_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG_PF1_PF7_CSRMAP_UNION, *PPCICFG_PF1_PF7_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG_PF1_PF7_CSRMAP_UNION, sizeof (PCICFG_PF1_PF7_CSRMAP_UNION) == 4096);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG0_CSRMAP {
         union {
            struct { 
               PCICFG_PF0_CSRMAP PCICFG_F0_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG0_CSRMAP, *PPCICFG0_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG0_CSRMAP, sizeof (PCICFG0_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG0_CSRMAP {
         PCICFG_PF0_CSRMAP PCICFG_F0_CSRMAP;
      } SG_PACK PCICFG0_CSRMAP, *PPCICFG0_CSRMAP;

      typedef union _PCICFG0_CSRMAP_UNION {
         PCICFG0_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG0_CSRMAP_UNION, *PPCICFG0_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG0_CSRMAP_UNION, sizeof (PCICFG0_CSRMAP_UNION) == 4096);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG0_CSRMAP {
         union {
            struct { 
               PCICFG_PF0_CSRMAP PCICFG_F0_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG0_CSRMAP, *PPCICFG0_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG0_CSRMAP, sizeof (PCICFG0_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG0_CSRMAP {
         PCICFG_PF0_CSRMAP PCICFG_F0_CSRMAP;
      } SG_PACK PCICFG0_CSRMAP, *PPCICFG0_CSRMAP;

      typedef union _PCICFG0_CSRMAP_UNION {
         PCICFG0_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG0_CSRMAP_UNION, *PPCICFG0_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG0_CSRMAP_UNION, sizeof (PCICFG0_CSRMAP_UNION) == 4096);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG1_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F1_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG1_CSRMAP, *PPCICFG1_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG1_CSRMAP, sizeof (PCICFG1_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG1_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F1_CSRMAP;
      } SG_PACK PCICFG1_CSRMAP, *PPCICFG1_CSRMAP;

      typedef union _PCICFG1_CSRMAP_UNION {
         PCICFG1_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG1_CSRMAP_UNION, *PPCICFG1_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG1_CSRMAP_UNION, sizeof (PCICFG1_CSRMAP_UNION) == 4096);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG1_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F1_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG1_CSRMAP, *PPCICFG1_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG1_CSRMAP, sizeof (PCICFG1_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG1_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F1_CSRMAP;
      } SG_PACK PCICFG1_CSRMAP, *PPCICFG1_CSRMAP;

      typedef union _PCICFG1_CSRMAP_UNION {
         PCICFG1_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG1_CSRMAP_UNION, *PPCICFG1_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG1_CSRMAP_UNION, sizeof (PCICFG1_CSRMAP_UNION) == 4096);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG2_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F2_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG2_CSRMAP, *PPCICFG2_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG2_CSRMAP, sizeof (PCICFG2_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG2_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F2_CSRMAP;
      } SG_PACK PCICFG2_CSRMAP, *PPCICFG2_CSRMAP;

      typedef union _PCICFG2_CSRMAP_UNION {
         PCICFG2_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG2_CSRMAP_UNION, *PPCICFG2_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG2_CSRMAP_UNION, sizeof (PCICFG2_CSRMAP_UNION) == 4096);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG2_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F2_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG2_CSRMAP, *PPCICFG2_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG2_CSRMAP, sizeof (PCICFG2_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG2_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F2_CSRMAP;
      } SG_PACK PCICFG2_CSRMAP, *PPCICFG2_CSRMAP;

      typedef union _PCICFG2_CSRMAP_UNION {
         PCICFG2_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG2_CSRMAP_UNION, *PPCICFG2_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG2_CSRMAP_UNION, sizeof (PCICFG2_CSRMAP_UNION) == 4096);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG3_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F3_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG3_CSRMAP, *PPCICFG3_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG3_CSRMAP, sizeof (PCICFG3_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG3_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F3_CSRMAP;
      } SG_PACK PCICFG3_CSRMAP, *PPCICFG3_CSRMAP;

      typedef union _PCICFG3_CSRMAP_UNION {
         PCICFG3_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG3_CSRMAP_UNION, *PPCICFG3_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG3_CSRMAP_UNION, sizeof (PCICFG3_CSRMAP_UNION) == 4096);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG3_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F3_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG3_CSRMAP, *PPCICFG3_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG3_CSRMAP, sizeof (PCICFG3_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG3_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F3_CSRMAP;
      } SG_PACK PCICFG3_CSRMAP, *PPCICFG3_CSRMAP;

      typedef union _PCICFG3_CSRMAP_UNION {
         PCICFG3_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG3_CSRMAP_UNION, *PPCICFG3_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG3_CSRMAP_UNION, sizeof (PCICFG3_CSRMAP_UNION) == 4096);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG4_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F4_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG4_CSRMAP, *PPCICFG4_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG4_CSRMAP, sizeof (PCICFG4_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG4_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F4_CSRMAP;
      } SG_PACK PCICFG4_CSRMAP, *PPCICFG4_CSRMAP;

      typedef union _PCICFG4_CSRMAP_UNION {
         PCICFG4_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG4_CSRMAP_UNION, *PPCICFG4_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG4_CSRMAP_UNION, sizeof (PCICFG4_CSRMAP_UNION) == 4096);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG4_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F4_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG4_CSRMAP, *PPCICFG4_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG4_CSRMAP, sizeof (PCICFG4_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG4_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F4_CSRMAP;
      } SG_PACK PCICFG4_CSRMAP, *PPCICFG4_CSRMAP;

      typedef union _PCICFG4_CSRMAP_UNION {
         PCICFG4_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG4_CSRMAP_UNION, *PPCICFG4_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG4_CSRMAP_UNION, sizeof (PCICFG4_CSRMAP_UNION) == 4096);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG5_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F5_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG5_CSRMAP, *PPCICFG5_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG5_CSRMAP, sizeof (PCICFG5_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG5_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F5_CSRMAP;
      } SG_PACK PCICFG5_CSRMAP, *PPCICFG5_CSRMAP;

      typedef union _PCICFG5_CSRMAP_UNION {
         PCICFG5_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG5_CSRMAP_UNION, *PPCICFG5_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG5_CSRMAP_UNION, sizeof (PCICFG5_CSRMAP_UNION) == 4096);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG5_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F5_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG5_CSRMAP, *PPCICFG5_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG5_CSRMAP, sizeof (PCICFG5_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG5_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F5_CSRMAP;
      } SG_PACK PCICFG5_CSRMAP, *PPCICFG5_CSRMAP;

      typedef union _PCICFG5_CSRMAP_UNION {
         PCICFG5_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG5_CSRMAP_UNION, *PPCICFG5_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG5_CSRMAP_UNION, sizeof (PCICFG5_CSRMAP_UNION) == 4096);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG6_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F6_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG6_CSRMAP, *PPCICFG6_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG6_CSRMAP, sizeof (PCICFG6_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG6_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F6_CSRMAP;
      } SG_PACK PCICFG6_CSRMAP, *PPCICFG6_CSRMAP;

      typedef union _PCICFG6_CSRMAP_UNION {
         PCICFG6_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG6_CSRMAP_UNION, *PPCICFG6_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG6_CSRMAP_UNION, sizeof (PCICFG6_CSRMAP_UNION) == 4096);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG6_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F6_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG6_CSRMAP, *PPCICFG6_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG6_CSRMAP, sizeof (PCICFG6_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG6_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F6_CSRMAP;
      } SG_PACK PCICFG6_CSRMAP, *PPCICFG6_CSRMAP;

      typedef union _PCICFG6_CSRMAP_UNION {
         PCICFG6_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG6_CSRMAP_UNION, *PPCICFG6_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG6_CSRMAP_UNION, sizeof (PCICFG6_CSRMAP_UNION) == 4096);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG7_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F7_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG7_CSRMAP, *PPCICFG7_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG7_CSRMAP, sizeof (PCICFG7_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG7_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F7_CSRMAP;
      } SG_PACK PCICFG7_CSRMAP, *PPCICFG7_CSRMAP;

      typedef union _PCICFG7_CSRMAP_UNION {
         PCICFG7_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG7_CSRMAP_UNION, *PPCICFG7_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG7_CSRMAP_UNION, sizeof (PCICFG7_CSRMAP_UNION) == 4096);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _PCICFG7_CSRMAP {
         union {
            struct { 
               PCICFG_PF1_PF7_CSRMAP PCICFG_F7_CSRMAP;
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK PCICFG7_CSRMAP, *PPCICFG7_CSRMAP;

      SG_C_ASSERT(__sizeof__PCICFG7_CSRMAP, sizeof (PCICFG7_CSRMAP) == 4096);

   #else
      typedef struct _PCICFG7_CSRMAP {
         PCICFG_PF1_PF7_CSRMAP PCICFG_F7_CSRMAP;
      } SG_PACK PCICFG7_CSRMAP, *PPCICFG7_CSRMAP;

      typedef union _PCICFG7_CSRMAP_UNION {
         PCICFG7_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK PCICFG7_CSRMAP_UNION, *PPCICFG7_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PCICFG7_CSRMAP_UNION, sizeof (PCICFG7_CSRMAP_UNION) == 4096);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __pcicfg_bmap_h__

