/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __rxf_bmap_h__
#define __rxf_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "hwdbg_reg_bmap.h"
#include "gencommon_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // This register controls miscellaneous enables for the controller, such as port
   // enables, TCP/IP checksum enable, multicast & broadcast packet enables, promiscuous
   // mode controls, etc.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RXCTL_CSR {
         union {
            struct { 
               u32 rsvd1 : 1;                     // DWORD 0
               u32 forcestall : 1;                // DWORD 0
               u32 p1fcoe_must_have_vf_id : 1;    // DWORD 0
               u32 p1fcoe_must_have_vlan : 1;     // DWORD 0
               u32 p0fcoe_must_have_vf_id : 1;    // DWORD 0
               u32 p0fcoe_must_have_vlan : 1;     // DWORD 0
               u32 debugmgmt : 1;                 // DWORD 0
               u32 enmgmtmac : 1;                 // DWORD 0
               u32 enpatred : 1;                  // DWORD 0
               u32 swap_pmem : 1;                 // DWORD 0
               u32 stripcrc : 1;                  // DWORD 0
               u32 enoffload : 1;                 // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 enudpck : 1;                   // DWORD 0
               u32 entcpck : 1;                   // DWORD 0
               u32 enipck : 1;                    // DWORD 0
               u32 enp1pass_l2_err : 1;           // DWORD 0
               u32 enp1fcoe_vf_id_promiscuous : 1; // DWORD 0
               u32 enp1fcoe_vlan_promiscuous : 1; // DWORD 0
               u32 enp1dot1control : 1;           // DWORD 0
               u32 enp1fivetuple : 1;             // DWORD 0
               u32 enp1qinq : 1;                  // DWORD 0
               u32 enp1prom : 1;                  // DWORD 0
               u32 enp1 : 1;                      // DWORD 0
               u32 enp0pass_l2_err : 1;           // DWORD 0
               u32 enp0fcoe_vf_id_promiscuous : 1; // DWORD 0
               u32 enp0fcoe_vlan_promiscuous : 1; // DWORD 0
               u32 enp0dot1control : 1;           // DWORD 0
               u32 enp0fivetuple : 1;             // DWORD 0
               u32 enp0qinq : 1;                  // DWORD 0
               u32 enp0prom : 1;                  // DWORD 0
               u32 enp0 : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RXCTL_CSR, *PRXF_RXCTL_CSR;

      SG_C_ASSERT(__sizeof__RXF_RXCTL_CSR, sizeof (RXF_RXCTL_CSR) == 4);

   #else
      typedef struct _RXF_RXCTL_CSR {
         u32 rsvd1 : 1;                           // DWORD 0
         u32 forcestall : 1;                      // DWORD 0
         u32 p1fcoe_must_have_vf_id : 1;          // DWORD 0
         u32 p1fcoe_must_have_vlan : 1;           // DWORD 0
         u32 p0fcoe_must_have_vf_id : 1;          // DWORD 0
         u32 p0fcoe_must_have_vlan : 1;           // DWORD 0
         u32 debugmgmt : 1;                       // DWORD 0
         u32 enmgmtmac : 1;                       // DWORD 0
         u32 enpatred : 1;                        // DWORD 0
         u32 swap_pmem : 1;                       // DWORD 0
         u32 stripcrc : 1;                        // DWORD 0
         u32 enoffload : 1;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 enudpck : 1;                         // DWORD 0
         u32 entcpck : 1;                         // DWORD 0
         u32 enipck : 1;                          // DWORD 0
         u32 enp1pass_l2_err : 1;                 // DWORD 0
         u32 enp1fcoe_vf_id_promiscuous : 1;      // DWORD 0
         u32 enp1fcoe_vlan_promiscuous : 1;       // DWORD 0
         u32 enp1dot1control : 1;                 // DWORD 0
         u32 enp1fivetuple : 1;                   // DWORD 0
         u32 enp1qinq : 1;                        // DWORD 0
         u32 enp1prom : 1;                        // DWORD 0
         u32 enp1 : 1;                            // DWORD 0
         u32 enp0pass_l2_err : 1;                 // DWORD 0
         u32 enp0fcoe_vf_id_promiscuous : 1;      // DWORD 0
         u32 enp0fcoe_vlan_promiscuous : 1;       // DWORD 0
         u32 enp0dot1control : 1;                 // DWORD 0
         u32 enp0fivetuple : 1;                   // DWORD 0
         u32 enp0qinq : 1;                        // DWORD 0
         u32 enp0prom : 1;                        // DWORD 0
         u32 enp0 : 1;                            // DWORD 0
      } SG_PACK RXF_RXCTL_CSR, *PRXF_RXCTL_CSR;

      typedef union _RXF_RXCTL_CSR_UNION {
         RXF_RXCTL_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RXCTL_CSR_UNION, *PRXF_RXCTL_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RXCTL_CSR_UNION, sizeof (RXF_RXCTL_CSR_UNION) == 4);
   #endif


#else
   // This register controls miscellaneous enables for the controller, such as port
   // enables, TCP/IP checksum enable, multicast & broadcast packet enables, promiscuous
   // mode controls, etc.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RXCTL_CSR {
         union {
            struct { 
               u32 enp0 : 1;                      // DWORD 0
               u32 enp0prom : 1;                  // DWORD 0
               u32 enp0qinq : 1;                  // DWORD 0
               u32 enp0fivetuple : 1;             // DWORD 0
               u32 enp0dot1control : 1;           // DWORD 0
               u32 enp0fcoe_vlan_promiscuous : 1; // DWORD 0
               u32 enp0fcoe_vf_id_promiscuous : 1; // DWORD 0
               u32 enp0pass_l2_err : 1;           // DWORD 0
               u32 enp1 : 1;                      // DWORD 0
               u32 enp1prom : 1;                  // DWORD 0
               u32 enp1qinq : 1;                  // DWORD 0
               u32 enp1fivetuple : 1;             // DWORD 0
               u32 enp1dot1control : 1;           // DWORD 0
               u32 enp1fcoe_vlan_promiscuous : 1; // DWORD 0
               u32 enp1fcoe_vf_id_promiscuous : 1; // DWORD 0
               u32 enp1pass_l2_err : 1;           // DWORD 0
               u32 enipck : 1;                    // DWORD 0
               u32 entcpck : 1;                   // DWORD 0
               u32 enudpck : 1;                   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 enoffload : 1;                 // DWORD 0
               u32 stripcrc : 1;                  // DWORD 0
               u32 swap_pmem : 1;                 // DWORD 0
               u32 enpatred : 1;                  // DWORD 0
               u32 enmgmtmac : 1;                 // DWORD 0
               u32 debugmgmt : 1;                 // DWORD 0
               u32 p0fcoe_must_have_vlan : 1;     // DWORD 0
               u32 p0fcoe_must_have_vf_id : 1;    // DWORD 0
               u32 p1fcoe_must_have_vlan : 1;     // DWORD 0
               u32 p1fcoe_must_have_vf_id : 1;    // DWORD 0
               u32 forcestall : 1;                // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RXCTL_CSR, *PRXF_RXCTL_CSR;

      SG_C_ASSERT(__sizeof__RXF_RXCTL_CSR, sizeof (RXF_RXCTL_CSR) == 4);

   #else
      typedef struct _RXF_RXCTL_CSR {
         u32 enp0 : 1;                            // DWORD 0
         u32 enp0prom : 1;                        // DWORD 0
         u32 enp0qinq : 1;                        // DWORD 0
         u32 enp0fivetuple : 1;                   // DWORD 0
         u32 enp0dot1control : 1;                 // DWORD 0
         u32 enp0fcoe_vlan_promiscuous : 1;       // DWORD 0
         u32 enp0fcoe_vf_id_promiscuous : 1;      // DWORD 0
         u32 enp0pass_l2_err : 1;                 // DWORD 0
         u32 enp1 : 1;                            // DWORD 0
         u32 enp1prom : 1;                        // DWORD 0
         u32 enp1qinq : 1;                        // DWORD 0
         u32 enp1fivetuple : 1;                   // DWORD 0
         u32 enp1dot1control : 1;                 // DWORD 0
         u32 enp1fcoe_vlan_promiscuous : 1;       // DWORD 0
         u32 enp1fcoe_vf_id_promiscuous : 1;      // DWORD 0
         u32 enp1pass_l2_err : 1;                 // DWORD 0
         u32 enipck : 1;                          // DWORD 0
         u32 entcpck : 1;                         // DWORD 0
         u32 enudpck : 1;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 enoffload : 1;                       // DWORD 0
         u32 stripcrc : 1;                        // DWORD 0
         u32 swap_pmem : 1;                       // DWORD 0
         u32 enpatred : 1;                        // DWORD 0
         u32 enmgmtmac : 1;                       // DWORD 0
         u32 debugmgmt : 1;                       // DWORD 0
         u32 p0fcoe_must_have_vlan : 1;           // DWORD 0
         u32 p0fcoe_must_have_vf_id : 1;          // DWORD 0
         u32 p1fcoe_must_have_vlan : 1;           // DWORD 0
         u32 p1fcoe_must_have_vf_id : 1;          // DWORD 0
         u32 forcestall : 1;                      // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
      } SG_PACK RXF_RXCTL_CSR, *PRXF_RXCTL_CSR;

      typedef union _RXF_RXCTL_CSR_UNION {
         RXF_RXCTL_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RXCTL_CSR_UNION, *PRXF_RXCTL_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RXCTL_CSR_UNION, sizeof (RXF_RXCTL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // More miscellaneous control bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RXCTL2_CSR {
         union {
            struct { 
               u32 rsvd0 : 23;                    // DWORD 0
               u32 p1fcoe_passerr : 1;            // DWORD 0
               u32 p0fcoe_passerr : 1;            // DWORD 0
               u32 qinq_vlan_select : 1;          // DWORD 0
               u32 en_line_analyzer1 : 1;         // DWORD 0
               u32 en_line_analyzer0 : 1;         // DWORD 0
               u32 enp1fcoe : 1;                  // DWORD 0
               u32 enp0fcoe : 1;                  // DWORD 0
               u32 ni1_lro : 1;                   // DWORD 0
               u32 ni0_lro : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RXCTL2_CSR, *PRXF_RXCTL2_CSR;

      SG_C_ASSERT(__sizeof__RXF_RXCTL2_CSR, sizeof (RXF_RXCTL2_CSR) == 4);

   #else
      typedef struct _RXF_RXCTL2_CSR {
         u32 rsvd0 : 23;                          // DWORD 0
         u32 p1fcoe_passerr : 1;                  // DWORD 0
         u32 p0fcoe_passerr : 1;                  // DWORD 0
         u32 qinq_vlan_select : 1;                // DWORD 0
         u32 en_line_analyzer1 : 1;               // DWORD 0
         u32 en_line_analyzer0 : 1;               // DWORD 0
         u32 enp1fcoe : 1;                        // DWORD 0
         u32 enp0fcoe : 1;                        // DWORD 0
         u32 ni1_lro : 1;                         // DWORD 0
         u32 ni0_lro : 1;                         // DWORD 0
      } SG_PACK RXF_RXCTL2_CSR, *PRXF_RXCTL2_CSR;

      typedef union _RXF_RXCTL2_CSR_UNION {
         RXF_RXCTL2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RXCTL2_CSR_UNION, *PRXF_RXCTL2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RXCTL2_CSR_UNION, sizeof (RXF_RXCTL2_CSR_UNION) == 4);
   #endif


#else
   // More miscellaneous control bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RXCTL2_CSR {
         union {
            struct { 
               u32 ni0_lro : 1;                   // DWORD 0
               u32 ni1_lro : 1;                   // DWORD 0
               u32 enp0fcoe : 1;                  // DWORD 0
               u32 enp1fcoe : 1;                  // DWORD 0
               u32 en_line_analyzer0 : 1;         // DWORD 0
               u32 en_line_analyzer1 : 1;         // DWORD 0
               u32 qinq_vlan_select : 1;          // DWORD 0
               u32 p0fcoe_passerr : 1;            // DWORD 0
               u32 p1fcoe_passerr : 1;            // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RXCTL2_CSR, *PRXF_RXCTL2_CSR;

      SG_C_ASSERT(__sizeof__RXF_RXCTL2_CSR, sizeof (RXF_RXCTL2_CSR) == 4);

   #else
      typedef struct _RXF_RXCTL2_CSR {
         u32 ni0_lro : 1;                         // DWORD 0
         u32 ni1_lro : 1;                         // DWORD 0
         u32 enp0fcoe : 1;                        // DWORD 0
         u32 enp1fcoe : 1;                        // DWORD 0
         u32 en_line_analyzer0 : 1;               // DWORD 0
         u32 en_line_analyzer1 : 1;               // DWORD 0
         u32 qinq_vlan_select : 1;                // DWORD 0
         u32 p0fcoe_passerr : 1;                  // DWORD 0
         u32 p1fcoe_passerr : 1;                  // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
      } SG_PACK RXF_RXCTL2_CSR, *PRXF_RXCTL2_CSR;

      typedef union _RXF_RXCTL2_CSR_UNION {
         RXF_RXCTL2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RXCTL2_CSR_UNION, *PRXF_RXCTL2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RXCTL2_CSR_UNION, sizeof (RXF_RXCTL2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // To allow for atomic programming of the CPU table, the CPU table is programmed in 2
   // banks, or policies, per interface. This register controls which of the 2 policies
   // each of the 2 Network Interfaces use. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RSS_MASTER_CONTROL_CSR {
         union {
            struct { 
               u32 rsvd1 : 14;                    // DWORD 0
               u32 ni1_gen_marble : 1;            // DWORD 0
               u32 ni1_policy : 1;                // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 ni0_gen_marble : 1;            // DWORD 0
               u32 ni0_policy : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RSS_MASTER_CONTROL_CSR, *PRXF_RSS_MASTER_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__RXF_RSS_MASTER_CONTROL_CSR, sizeof (RXF_RSS_MASTER_CONTROL_CSR) == 4);

   #else
      typedef struct _RXF_RSS_MASTER_CONTROL_CSR {
         u32 rsvd1 : 14;                          // DWORD 0
         u32 ni1_gen_marble : 1;                  // DWORD 0
         u32 ni1_policy : 1;                      // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 ni0_gen_marble : 1;                  // DWORD 0
         u32 ni0_policy : 1;                      // DWORD 0
      } SG_PACK RXF_RSS_MASTER_CONTROL_CSR, *PRXF_RSS_MASTER_CONTROL_CSR;

      typedef union _RXF_RSS_MASTER_CONTROL_CSR_UNION {
         RXF_RSS_MASTER_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RSS_MASTER_CONTROL_CSR_UNION, *PRXF_RSS_MASTER_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RSS_MASTER_CONTROL_CSR_UNION, sizeof (RXF_RSS_MASTER_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // To allow for atomic programming of the CPU table, the CPU table is programmed in 2
   // banks, or policies, per interface. This register controls which of the 2 policies
   // each of the 2 Network Interfaces use. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RSS_MASTER_CONTROL_CSR {
         union {
            struct { 
               u32 ni0_policy : 1;                // DWORD 0
               u32 ni0_gen_marble : 1;            // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 ni1_policy : 1;                // DWORD 0
               u32 ni1_gen_marble : 1;            // DWORD 0
               u32 rsvd1 : 14;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RSS_MASTER_CONTROL_CSR, *PRXF_RSS_MASTER_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__RXF_RSS_MASTER_CONTROL_CSR, sizeof (RXF_RSS_MASTER_CONTROL_CSR) == 4);

   #else
      typedef struct _RXF_RSS_MASTER_CONTROL_CSR {
         u32 ni0_policy : 1;                      // DWORD 0
         u32 ni0_gen_marble : 1;                  // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 ni1_policy : 1;                      // DWORD 0
         u32 ni1_gen_marble : 1;                  // DWORD 0
         u32 rsvd1 : 14;                          // DWORD 0
      } SG_PACK RXF_RSS_MASTER_CONTROL_CSR, *PRXF_RSS_MASTER_CONTROL_CSR;

      typedef union _RXF_RSS_MASTER_CONTROL_CSR_UNION {
         RXF_RSS_MASTER_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RSS_MASTER_CONTROL_CSR_UNION, *PRXF_RSS_MASTER_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RSS_MASTER_CONTROL_CSR_UNION, sizeof (RXF_RSS_MASTER_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is one of two RSS policy configurations for each Network Interface.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RSS_INTERFACE_POLICY_CSR {
         union {
            struct { 
               u32 rsvd1 : 21;                    // DWORD 0
               u32 rss_tbl_size : 3;              // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 ndis_hash_tcp_ipv6 : 1;        // DWORD 0
               u32 ndis_hash_ipv6 : 1;            // DWORD 0
               u32 ndis_hash_tcp_ipv4 : 1;        // DWORD 0
               u32 ndis_hash_ipv4 : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RSS_INTERFACE_POLICY_CSR, *PRXF_RSS_INTERFACE_POLICY_CSR;

      SG_C_ASSERT(__sizeof__RXF_RSS_INTERFACE_POLICY_CSR, sizeof (RXF_RSS_INTERFACE_POLICY_CSR) == 4);

   #else
      typedef struct _RXF_RSS_INTERFACE_POLICY_CSR {
         u32 rsvd1 : 21;                          // DWORD 0
         u32 rss_tbl_size : 3;                    // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 ndis_hash_tcp_ipv6 : 1;              // DWORD 0
         u32 ndis_hash_ipv6 : 1;                  // DWORD 0
         u32 ndis_hash_tcp_ipv4 : 1;              // DWORD 0
         u32 ndis_hash_ipv4 : 1;                  // DWORD 0
      } SG_PACK RXF_RSS_INTERFACE_POLICY_CSR, *PRXF_RSS_INTERFACE_POLICY_CSR;

      typedef union _RXF_RSS_INTERFACE_POLICY_CSR_UNION {
         RXF_RSS_INTERFACE_POLICY_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RSS_INTERFACE_POLICY_CSR_UNION, *PRXF_RSS_INTERFACE_POLICY_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RSS_INTERFACE_POLICY_CSR_UNION, sizeof (RXF_RSS_INTERFACE_POLICY_CSR_UNION) == 4);
   #endif


#else
   // This is one of two RSS policy configurations for each Network Interface.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RSS_INTERFACE_POLICY_CSR {
         union {
            struct { 
               u32 ndis_hash_ipv4 : 1;            // DWORD 0
               u32 ndis_hash_tcp_ipv4 : 1;        // DWORD 0
               u32 ndis_hash_ipv6 : 1;            // DWORD 0
               u32 ndis_hash_tcp_ipv6 : 1;        // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 rss_tbl_size : 3;              // DWORD 0
               u32 rsvd1 : 21;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RSS_INTERFACE_POLICY_CSR, *PRXF_RSS_INTERFACE_POLICY_CSR;

      SG_C_ASSERT(__sizeof__RXF_RSS_INTERFACE_POLICY_CSR, sizeof (RXF_RSS_INTERFACE_POLICY_CSR) == 4);

   #else
      typedef struct _RXF_RSS_INTERFACE_POLICY_CSR {
         u32 ndis_hash_ipv4 : 1;                  // DWORD 0
         u32 ndis_hash_tcp_ipv4 : 1;              // DWORD 0
         u32 ndis_hash_ipv6 : 1;                  // DWORD 0
         u32 ndis_hash_tcp_ipv6 : 1;              // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 rss_tbl_size : 3;                    // DWORD 0
         u32 rsvd1 : 21;                          // DWORD 0
      } SG_PACK RXF_RSS_INTERFACE_POLICY_CSR, *PRXF_RSS_INTERFACE_POLICY_CSR;

      typedef union _RXF_RSS_INTERFACE_POLICY_CSR_UNION {
         RXF_RSS_INTERFACE_POLICY_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RSS_INTERFACE_POLICY_CSR_UNION, *PRXF_RSS_INTERFACE_POLICY_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RSS_INTERFACE_POLICY_CSR_UNION, sizeof (RXF_RSS_INTERFACE_POLICY_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // the lower 32 bits of the per interface pass L3/L4 error vector. When a bit is set,
   // the corresponding interface will receive packets with L3/L4 errors (bad checksum,
   // bad header lengths, etc). Note that erroed packets are never sent to the offload
   // engines.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PASS_L3_L4_ERR_LO {
         union {
            struct { 
               u32 pass_l3_l4_err_lo;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PASS_L3_L4_ERR_LO, *PRXF_PASS_L3_L4_ERR_LO;

      SG_C_ASSERT(__sizeof__RXF_PASS_L3_L4_ERR_LO, sizeof (RXF_PASS_L3_L4_ERR_LO) == 4);

   #else
      typedef struct _RXF_PASS_L3_L4_ERR_LO {
         u32 pass_l3_l4_err_lo;                   // DWORD 0
      } SG_PACK RXF_PASS_L3_L4_ERR_LO, *PRXF_PASS_L3_L4_ERR_LO;

      typedef union _RXF_PASS_L3_L4_ERR_LO_UNION {
         RXF_PASS_L3_L4_ERR_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_PASS_L3_L4_ERR_LO_UNION, *PRXF_PASS_L3_L4_ERR_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_PASS_L3_L4_ERR_LO_UNION, sizeof (RXF_PASS_L3_L4_ERR_LO_UNION) == 4);
   #endif


#else
   // the lower 32 bits of the per interface pass L3/L4 error vector. When a bit is set,
   // the corresponding interface will receive packets with L3/L4 errors (bad checksum,
   // bad header lengths, etc). Note that erroed packets are never sent to the offload
   // engines.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PASS_L3_L4_ERR_LO {
         union {
            struct { 
               u32 pass_l3_l4_err_lo;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PASS_L3_L4_ERR_LO, *PRXF_PASS_L3_L4_ERR_LO;

      SG_C_ASSERT(__sizeof__RXF_PASS_L3_L4_ERR_LO, sizeof (RXF_PASS_L3_L4_ERR_LO) == 4);

   #else
      typedef struct _RXF_PASS_L3_L4_ERR_LO {
         u32 pass_l3_l4_err_lo;                   // DWORD 0
      } SG_PACK RXF_PASS_L3_L4_ERR_LO, *PRXF_PASS_L3_L4_ERR_LO;

      typedef union _RXF_PASS_L3_L4_ERR_LO_UNION {
         RXF_PASS_L3_L4_ERR_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_PASS_L3_L4_ERR_LO_UNION, *PRXF_PASS_L3_L4_ERR_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_PASS_L3_L4_ERR_LO_UNION, sizeof (RXF_PASS_L3_L4_ERR_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // the upper 5 bits of the per interface pass L3/L4 error vector. When a bit is set,
   // the corresponding interface will receive packets with L3/L4 errors (bad checksum,
   // bad header lengths, etc).Note that erroed packets are never sent to the offload
   // engines.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PASS_L3_L4_ERR_HI {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 pass_l3_l4_err_hi : 5;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PASS_L3_L4_ERR_HI, *PRXF_PASS_L3_L4_ERR_HI;

      SG_C_ASSERT(__sizeof__RXF_PASS_L3_L4_ERR_HI, sizeof (RXF_PASS_L3_L4_ERR_HI) == 4);

   #else
      typedef struct _RXF_PASS_L3_L4_ERR_HI {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 pass_l3_l4_err_hi : 5;               // DWORD 0
      } SG_PACK RXF_PASS_L3_L4_ERR_HI, *PRXF_PASS_L3_L4_ERR_HI;

      typedef union _RXF_PASS_L3_L4_ERR_HI_UNION {
         RXF_PASS_L3_L4_ERR_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_PASS_L3_L4_ERR_HI_UNION, *PRXF_PASS_L3_L4_ERR_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_PASS_L3_L4_ERR_HI_UNION, sizeof (RXF_PASS_L3_L4_ERR_HI_UNION) == 4);
   #endif


#else
   // the upper 5 bits of the per interface pass L3/L4 error vector. When a bit is set,
   // the corresponding interface will receive packets with L3/L4 errors (bad checksum,
   // bad header lengths, etc).Note that erroed packets are never sent to the offload
   // engines.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PASS_L3_L4_ERR_HI {
         union {
            struct { 
               u32 pass_l3_l4_err_hi : 5;         // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PASS_L3_L4_ERR_HI, *PRXF_PASS_L3_L4_ERR_HI;

      SG_C_ASSERT(__sizeof__RXF_PASS_L3_L4_ERR_HI, sizeof (RXF_PASS_L3_L4_ERR_HI) == 4);

   #else
      typedef struct _RXF_PASS_L3_L4_ERR_HI {
         u32 pass_l3_l4_err_hi : 5;               // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK RXF_PASS_L3_L4_ERR_HI, *PRXF_PASS_L3_L4_ERR_HI;

      typedef union _RXF_PASS_L3_L4_ERR_HI_UNION {
         RXF_PASS_L3_L4_ERR_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_PASS_L3_L4_ERR_HI_UNION, *PRXF_PASS_L3_L4_ERR_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_PASS_L3_L4_ERR_HI_UNION, sizeof (RXF_PASS_L3_L4_ERR_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port Control Configuration Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PCTL_CFG_CSR {
         union {
            struct { 
               u32 rsvd1 : 12;                    // DWORD 0
               u32 p1rxdcrdrt : 1;                // DWORD 0
               u32 p1cross_wire_loopback : 1;     // DWORD 0
               u32 p1wire_loopback : 1;           // DWORD 0
               u32 p1mac_loopback : 1;            // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 p0rxdcrdrt : 1;                // DWORD 0
               u32 p0cross_wire_loopback : 1;     // DWORD 0
               u32 p0wire_loopback : 1;           // DWORD 0
               u32 p0mac_loopback : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PCTL_CFG_CSR, *PRXF_PCTL_CFG_CSR;

      SG_C_ASSERT(__sizeof__RXF_PCTL_CFG_CSR, sizeof (RXF_PCTL_CFG_CSR) == 4);

   #else
      typedef struct _RXF_PCTL_CFG_CSR {
         u32 rsvd1 : 12;                          // DWORD 0
         u32 p1rxdcrdrt : 1;                      // DWORD 0
         u32 p1cross_wire_loopback : 1;           // DWORD 0
         u32 p1wire_loopback : 1;                 // DWORD 0
         u32 p1mac_loopback : 1;                  // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 p0rxdcrdrt : 1;                      // DWORD 0
         u32 p0cross_wire_loopback : 1;           // DWORD 0
         u32 p0wire_loopback : 1;                 // DWORD 0
         u32 p0mac_loopback : 1;                  // DWORD 0
      } SG_PACK RXF_PCTL_CFG_CSR, *PRXF_PCTL_CFG_CSR;

      typedef union _RXF_PCTL_CFG_CSR_UNION {
         RXF_PCTL_CFG_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_PCTL_CFG_CSR_UNION, *PRXF_PCTL_CFG_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_PCTL_CFG_CSR_UNION, sizeof (RXF_PCTL_CFG_CSR_UNION) == 4);
   #endif


#else
   // Port Control Configuration Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PCTL_CFG_CSR {
         union {
            struct { 
               u32 p0mac_loopback : 1;            // DWORD 0
               u32 p0wire_loopback : 1;           // DWORD 0
               u32 p0cross_wire_loopback : 1;     // DWORD 0
               u32 p0rxdcrdrt : 1;                // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 p1mac_loopback : 1;            // DWORD 0
               u32 p1wire_loopback : 1;           // DWORD 0
               u32 p1cross_wire_loopback : 1;     // DWORD 0
               u32 p1rxdcrdrt : 1;                // DWORD 0
               u32 rsvd1 : 12;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PCTL_CFG_CSR, *PRXF_PCTL_CFG_CSR;

      SG_C_ASSERT(__sizeof__RXF_PCTL_CFG_CSR, sizeof (RXF_PCTL_CFG_CSR) == 4);

   #else
      typedef struct _RXF_PCTL_CFG_CSR {
         u32 p0mac_loopback : 1;                  // DWORD 0
         u32 p0wire_loopback : 1;                 // DWORD 0
         u32 p0cross_wire_loopback : 1;           // DWORD 0
         u32 p0rxdcrdrt : 1;                      // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 p1mac_loopback : 1;                  // DWORD 0
         u32 p1wire_loopback : 1;                 // DWORD 0
         u32 p1cross_wire_loopback : 1;           // DWORD 0
         u32 p1rxdcrdrt : 1;                      // DWORD 0
         u32 rsvd1 : 12;                          // DWORD 0
      } SG_PACK RXF_PCTL_CFG_CSR, *PRXF_PCTL_CFG_CSR;

      typedef union _RXF_PCTL_CFG_CSR_UNION {
         RXF_PCTL_CFG_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_PCTL_CFG_CSR_UNION, *PRXF_PCTL_CFG_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_PCTL_CFG_CSR_UNION, sizeof (RXF_PCTL_CFG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The upper 32 bits of a MagicPacket MAC address and function and valid bits for it.
   // note that the internal address only updates when the upper bits are written
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MAGIC_ADDR_HI {
         union {
            struct { 
               u32 valid : 1;                     // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 function : 3;                  // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 magic_addr_hi : 16;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MAGIC_ADDR_HI, *PRXF_MAGIC_ADDR_HI;

      SG_C_ASSERT(__sizeof__RXF_MAGIC_ADDR_HI, sizeof (RXF_MAGIC_ADDR_HI) == 4);

   #else
      typedef struct _RXF_MAGIC_ADDR_HI {
         u32 valid : 1;                           // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 function : 3;                        // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 magic_addr_hi : 16;                  // DWORD 0
      } SG_PACK RXF_MAGIC_ADDR_HI, *PRXF_MAGIC_ADDR_HI;

      typedef union _RXF_MAGIC_ADDR_HI_UNION {
         RXF_MAGIC_ADDR_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_MAGIC_ADDR_HI_UNION, *PRXF_MAGIC_ADDR_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_MAGIC_ADDR_HI_UNION, sizeof (RXF_MAGIC_ADDR_HI_UNION) == 4);
   #endif


#else
   // The upper 32 bits of a MagicPacket MAC address and function and valid bits for it.
   // note that the internal address only updates when the upper bits are written
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MAGIC_ADDR_HI {
         union {
            struct { 
               u32 magic_addr_hi : 16;            // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 function : 3;                  // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 valid : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MAGIC_ADDR_HI, *PRXF_MAGIC_ADDR_HI;

      SG_C_ASSERT(__sizeof__RXF_MAGIC_ADDR_HI, sizeof (RXF_MAGIC_ADDR_HI) == 4);

   #else
      typedef struct _RXF_MAGIC_ADDR_HI {
         u32 magic_addr_hi : 16;                  // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 function : 3;                        // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 valid : 1;                           // DWORD 0
      } SG_PACK RXF_MAGIC_ADDR_HI, *PRXF_MAGIC_ADDR_HI;

      typedef union _RXF_MAGIC_ADDR_HI_UNION {
         RXF_MAGIC_ADDR_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_MAGIC_ADDR_HI_UNION, *PRXF_MAGIC_ADDR_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_MAGIC_ADDR_HI_UNION, sizeof (RXF_MAGIC_ADDR_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The lower 32 bits of a MagicPacket MAC address. note that the internal address only
   // updates when the upper bits are written
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MAGIC_ADDR_LO {
         union {
            struct { 
               u32 magic_addr_lo;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MAGIC_ADDR_LO, *PRXF_MAGIC_ADDR_LO;

      SG_C_ASSERT(__sizeof__RXF_MAGIC_ADDR_LO, sizeof (RXF_MAGIC_ADDR_LO) == 4);

   #else
      typedef struct _RXF_MAGIC_ADDR_LO {
         u32 magic_addr_lo;                       // DWORD 0
      } SG_PACK RXF_MAGIC_ADDR_LO, *PRXF_MAGIC_ADDR_LO;

      typedef union _RXF_MAGIC_ADDR_LO_UNION {
         RXF_MAGIC_ADDR_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_MAGIC_ADDR_LO_UNION, *PRXF_MAGIC_ADDR_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_MAGIC_ADDR_LO_UNION, sizeof (RXF_MAGIC_ADDR_LO_UNION) == 4);
   #endif


#else
   // The lower 32 bits of a MagicPacket MAC address. note that the internal address only
   // updates when the upper bits are written
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MAGIC_ADDR_LO {
         union {
            struct { 
               u32 magic_addr_lo;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MAGIC_ADDR_LO, *PRXF_MAGIC_ADDR_LO;

      SG_C_ASSERT(__sizeof__RXF_MAGIC_ADDR_LO, sizeof (RXF_MAGIC_ADDR_LO) == 4);

   #else
      typedef struct _RXF_MAGIC_ADDR_LO {
         u32 magic_addr_lo;                       // DWORD 0
      } SG_PACK RXF_MAGIC_ADDR_LO, *PRXF_MAGIC_ADDR_LO;

      typedef union _RXF_MAGIC_ADDR_LO_UNION {
         RXF_MAGIC_ADDR_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_MAGIC_ADDR_LO_UNION, *PRXF_MAGIC_ADDR_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_MAGIC_ADDR_LO_UNION, sizeof (RXF_MAGIC_ADDR_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The lower 32 bits of the Management MAC address. note that the internal address only
   // updates when the upper bits are written
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MGMT_MAC_ADDR_LO {
         union {
            struct { 
               u32 mgmt_addr_lo;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MGMT_MAC_ADDR_LO, *PRXF_MGMT_MAC_ADDR_LO;

      SG_C_ASSERT(__sizeof__RXF_MGMT_MAC_ADDR_LO, sizeof (RXF_MGMT_MAC_ADDR_LO) == 4);

   #else
      typedef struct _RXF_MGMT_MAC_ADDR_LO {
         u32 mgmt_addr_lo;                        // DWORD 0
      } SG_PACK RXF_MGMT_MAC_ADDR_LO, *PRXF_MGMT_MAC_ADDR_LO;

      typedef union _RXF_MGMT_MAC_ADDR_LO_UNION {
         RXF_MGMT_MAC_ADDR_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_MGMT_MAC_ADDR_LO_UNION, *PRXF_MGMT_MAC_ADDR_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_MGMT_MAC_ADDR_LO_UNION, sizeof (RXF_MGMT_MAC_ADDR_LO_UNION) == 4);
   #endif


#else
   // The lower 32 bits of the Management MAC address. note that the internal address only
   // updates when the upper bits are written
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MGMT_MAC_ADDR_LO {
         union {
            struct { 
               u32 mgmt_addr_lo;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MGMT_MAC_ADDR_LO, *PRXF_MGMT_MAC_ADDR_LO;

      SG_C_ASSERT(__sizeof__RXF_MGMT_MAC_ADDR_LO, sizeof (RXF_MGMT_MAC_ADDR_LO) == 4);

   #else
      typedef struct _RXF_MGMT_MAC_ADDR_LO {
         u32 mgmt_addr_lo;                        // DWORD 0
      } SG_PACK RXF_MGMT_MAC_ADDR_LO, *PRXF_MGMT_MAC_ADDR_LO;

      typedef union _RXF_MGMT_MAC_ADDR_LO_UNION {
         RXF_MGMT_MAC_ADDR_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_MGMT_MAC_ADDR_LO_UNION, *PRXF_MGMT_MAC_ADDR_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_MGMT_MAC_ADDR_LO_UNION, sizeof (RXF_MGMT_MAC_ADDR_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The upper 16 bits of the Management MAC address and its valid bitnote that the
   // internal address only updates when the upper bits are written
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MGMT_MAC_ADDR_HI {
         union {
            struct { 
               u32 valid : 1;                     // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 mgmt_addr_hi : 16;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MGMT_MAC_ADDR_HI, *PRXF_MGMT_MAC_ADDR_HI;

      SG_C_ASSERT(__sizeof__RXF_MGMT_MAC_ADDR_HI, sizeof (RXF_MGMT_MAC_ADDR_HI) == 4);

   #else
      typedef struct _RXF_MGMT_MAC_ADDR_HI {
         u32 valid : 1;                           // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 mgmt_addr_hi : 16;                   // DWORD 0
      } SG_PACK RXF_MGMT_MAC_ADDR_HI, *PRXF_MGMT_MAC_ADDR_HI;

      typedef union _RXF_MGMT_MAC_ADDR_HI_UNION {
         RXF_MGMT_MAC_ADDR_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_MGMT_MAC_ADDR_HI_UNION, *PRXF_MGMT_MAC_ADDR_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_MGMT_MAC_ADDR_HI_UNION, sizeof (RXF_MGMT_MAC_ADDR_HI_UNION) == 4);
   #endif


#else
   // The upper 16 bits of the Management MAC address and its valid bitnote that the
   // internal address only updates when the upper bits are written
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MGMT_MAC_ADDR_HI {
         union {
            struct { 
               u32 mgmt_addr_hi : 16;             // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 valid : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MGMT_MAC_ADDR_HI, *PRXF_MGMT_MAC_ADDR_HI;

      SG_C_ASSERT(__sizeof__RXF_MGMT_MAC_ADDR_HI, sizeof (RXF_MGMT_MAC_ADDR_HI) == 4);

   #else
      typedef struct _RXF_MGMT_MAC_ADDR_HI {
         u32 mgmt_addr_hi : 16;                   // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 valid : 1;                           // DWORD 0
      } SG_PACK RXF_MGMT_MAC_ADDR_HI, *PRXF_MGMT_MAC_ADDR_HI;

      typedef union _RXF_MGMT_MAC_ADDR_HI_UNION {
         RXF_MGMT_MAC_ADDR_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_MGMT_MAC_ADDR_HI_UNION, *PRXF_MGMT_MAC_ADDR_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_MGMT_MAC_ADDR_HI_UNION, sizeof (RXF_MGMT_MAC_ADDR_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The lower 32 bits of the interface broadcast enable vector for port 0
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PORT0_BROADCAST_VECTOR_LO {
         union {
            struct { 
               u32 broadcast_vector_lo;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_LO, *PRXF_PORT0_BROADCAST_VECTOR_LO;

      SG_C_ASSERT(__sizeof__RXF_PORT0_BROADCAST_VECTOR_LO, sizeof (RXF_PORT0_BROADCAST_VECTOR_LO) == 4);

   #else
      typedef struct _RXF_PORT0_BROADCAST_VECTOR_LO {
         u32 broadcast_vector_lo;                 // DWORD 0
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_LO, *PRXF_PORT0_BROADCAST_VECTOR_LO;

      typedef union _RXF_PORT0_BROADCAST_VECTOR_LO_UNION {
         RXF_PORT0_BROADCAST_VECTOR_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_LO_UNION, *PRXF_PORT0_BROADCAST_VECTOR_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_PORT0_BROADCAST_VECTOR_LO_UNION, sizeof (RXF_PORT0_BROADCAST_VECTOR_LO_UNION) == 4);
   #endif


#else
   // The lower 32 bits of the interface broadcast enable vector for port 0
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PORT0_BROADCAST_VECTOR_LO {
         union {
            struct { 
               u32 broadcast_vector_lo;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_LO, *PRXF_PORT0_BROADCAST_VECTOR_LO;

      SG_C_ASSERT(__sizeof__RXF_PORT0_BROADCAST_VECTOR_LO, sizeof (RXF_PORT0_BROADCAST_VECTOR_LO) == 4);

   #else
      typedef struct _RXF_PORT0_BROADCAST_VECTOR_LO {
         u32 broadcast_vector_lo;                 // DWORD 0
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_LO, *PRXF_PORT0_BROADCAST_VECTOR_LO;

      typedef union _RXF_PORT0_BROADCAST_VECTOR_LO_UNION {
         RXF_PORT0_BROADCAST_VECTOR_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_LO_UNION, *PRXF_PORT0_BROADCAST_VECTOR_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_PORT0_BROADCAST_VECTOR_LO_UNION, sizeof (RXF_PORT0_BROADCAST_VECTOR_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The upper 5 bits of the interface broadcast enable vector for port 0
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PORT0_BROADCAST_VECTOR_HI {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 broadcast_vector_hi : 5;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_HI, *PRXF_PORT0_BROADCAST_VECTOR_HI;

      SG_C_ASSERT(__sizeof__RXF_PORT0_BROADCAST_VECTOR_HI, sizeof (RXF_PORT0_BROADCAST_VECTOR_HI) == 4);

   #else
      typedef struct _RXF_PORT0_BROADCAST_VECTOR_HI {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 broadcast_vector_hi : 5;             // DWORD 0
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_HI, *PRXF_PORT0_BROADCAST_VECTOR_HI;

      typedef union _RXF_PORT0_BROADCAST_VECTOR_HI_UNION {
         RXF_PORT0_BROADCAST_VECTOR_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_HI_UNION, *PRXF_PORT0_BROADCAST_VECTOR_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_PORT0_BROADCAST_VECTOR_HI_UNION, sizeof (RXF_PORT0_BROADCAST_VECTOR_HI_UNION) == 4);
   #endif


#else
   // The upper 5 bits of the interface broadcast enable vector for port 0
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PORT0_BROADCAST_VECTOR_HI {
         union {
            struct { 
               u32 broadcast_vector_hi : 5;       // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_HI, *PRXF_PORT0_BROADCAST_VECTOR_HI;

      SG_C_ASSERT(__sizeof__RXF_PORT0_BROADCAST_VECTOR_HI, sizeof (RXF_PORT0_BROADCAST_VECTOR_HI) == 4);

   #else
      typedef struct _RXF_PORT0_BROADCAST_VECTOR_HI {
         u32 broadcast_vector_hi : 5;             // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_HI, *PRXF_PORT0_BROADCAST_VECTOR_HI;

      typedef union _RXF_PORT0_BROADCAST_VECTOR_HI_UNION {
         RXF_PORT0_BROADCAST_VECTOR_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_PORT0_BROADCAST_VECTOR_HI_UNION, *PRXF_PORT0_BROADCAST_VECTOR_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_PORT0_BROADCAST_VECTOR_HI_UNION, sizeof (RXF_PORT0_BROADCAST_VECTOR_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The lower 32 bits of the interface broadcast enable vector for port 1
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PORT1_BROADCAST_VECTOR_LO {
         union {
            struct { 
               u32 broadcast_vector_lo;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_LO, *PRXF_PORT1_BROADCAST_VECTOR_LO;

      SG_C_ASSERT(__sizeof__RXF_PORT1_BROADCAST_VECTOR_LO, sizeof (RXF_PORT1_BROADCAST_VECTOR_LO) == 4);

   #else
      typedef struct _RXF_PORT1_BROADCAST_VECTOR_LO {
         u32 broadcast_vector_lo;                 // DWORD 0
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_LO, *PRXF_PORT1_BROADCAST_VECTOR_LO;

      typedef union _RXF_PORT1_BROADCAST_VECTOR_LO_UNION {
         RXF_PORT1_BROADCAST_VECTOR_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_LO_UNION, *PRXF_PORT1_BROADCAST_VECTOR_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_PORT1_BROADCAST_VECTOR_LO_UNION, sizeof (RXF_PORT1_BROADCAST_VECTOR_LO_UNION) == 4);
   #endif


#else
   // The lower 32 bits of the interface broadcast enable vector for port 1
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PORT1_BROADCAST_VECTOR_LO {
         union {
            struct { 
               u32 broadcast_vector_lo;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_LO, *PRXF_PORT1_BROADCAST_VECTOR_LO;

      SG_C_ASSERT(__sizeof__RXF_PORT1_BROADCAST_VECTOR_LO, sizeof (RXF_PORT1_BROADCAST_VECTOR_LO) == 4);

   #else
      typedef struct _RXF_PORT1_BROADCAST_VECTOR_LO {
         u32 broadcast_vector_lo;                 // DWORD 0
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_LO, *PRXF_PORT1_BROADCAST_VECTOR_LO;

      typedef union _RXF_PORT1_BROADCAST_VECTOR_LO_UNION {
         RXF_PORT1_BROADCAST_VECTOR_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_LO_UNION, *PRXF_PORT1_BROADCAST_VECTOR_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_PORT1_BROADCAST_VECTOR_LO_UNION, sizeof (RXF_PORT1_BROADCAST_VECTOR_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The upper 5 bits of the interface broadcast enable vector for port 1
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PORT1_BROADCAST_VECTOR_HI {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 broadcast_vector_hi : 5;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_HI, *PRXF_PORT1_BROADCAST_VECTOR_HI;

      SG_C_ASSERT(__sizeof__RXF_PORT1_BROADCAST_VECTOR_HI, sizeof (RXF_PORT1_BROADCAST_VECTOR_HI) == 4);

   #else
      typedef struct _RXF_PORT1_BROADCAST_VECTOR_HI {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 broadcast_vector_hi : 5;             // DWORD 0
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_HI, *PRXF_PORT1_BROADCAST_VECTOR_HI;

      typedef union _RXF_PORT1_BROADCAST_VECTOR_HI_UNION {
         RXF_PORT1_BROADCAST_VECTOR_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_HI_UNION, *PRXF_PORT1_BROADCAST_VECTOR_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_PORT1_BROADCAST_VECTOR_HI_UNION, sizeof (RXF_PORT1_BROADCAST_VECTOR_HI_UNION) == 4);
   #endif


#else
   // The upper 5 bits of the interface broadcast enable vector for port 1
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PORT1_BROADCAST_VECTOR_HI {
         union {
            struct { 
               u32 broadcast_vector_hi : 5;       // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_HI, *PRXF_PORT1_BROADCAST_VECTOR_HI;

      SG_C_ASSERT(__sizeof__RXF_PORT1_BROADCAST_VECTOR_HI, sizeof (RXF_PORT1_BROADCAST_VECTOR_HI) == 4);

   #else
      typedef struct _RXF_PORT1_BROADCAST_VECTOR_HI {
         u32 broadcast_vector_hi : 5;             // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_HI, *PRXF_PORT1_BROADCAST_VECTOR_HI;

      typedef union _RXF_PORT1_BROADCAST_VECTOR_HI_UNION {
         RXF_PORT1_BROADCAST_VECTOR_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_PORT1_BROADCAST_VECTOR_HI_UNION, *PRXF_PORT1_BROADCAST_VECTOR_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_PORT1_BROADCAST_VECTOR_HI_UNION, sizeof (RXF_PORT1_BROADCAST_VECTOR_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Receive Table Programming Register;  This register is a multi-purpose register used
   // to program the physical MAC and RX filtering module. It contains several
   // programmable tables controlling MAC addresses, multicast addresses, and a VLANs for
   // each physical MAC. There are also tables for IPSEC and, ACPI controls that are
   // independent of which physical MAC a packet comes in on. This register also contains
   // a Connection table for configuring RX filtering for offloaded connections. It is
   // also used for programming the PHYs for MAC0, MAC1 and Management MAC. Finally it is
   // also used to programming the Receive Side Scaling Key and table used by the chip.
   // For more information on how to use this register see the section, Receive Table
   // Programming. </p> 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RTPR_CSR {
         union {
            struct { 
               u32 rsvd1 : 8;                     // DWORD 0
               u32 offset : 16;                   // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 indx : 4;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RTPR_CSR, *PRXF_RTPR_CSR;

      SG_C_ASSERT(__sizeof__RXF_RTPR_CSR, sizeof (RXF_RTPR_CSR) == 4);

   #else
      typedef struct _RXF_RTPR_CSR {
         u32 rsvd1 : 8;                           // DWORD 0
         u32 offset : 16;                         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 indx : 4;                            // DWORD 0
      } SG_PACK RXF_RTPR_CSR, *PRXF_RTPR_CSR;

      typedef union _RXF_RTPR_CSR_UNION {
         RXF_RTPR_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RTPR_CSR_UNION, *PRXF_RTPR_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RTPR_CSR_UNION, sizeof (RXF_RTPR_CSR_UNION) == 4);
   #endif


#else
   // Receive Table Programming Register;  This register is a multi-purpose register used
   // to program the physical MAC and RX filtering module. It contains several
   // programmable tables controlling MAC addresses, multicast addresses, and a VLANs for
   // each physical MAC. There are also tables for IPSEC and, ACPI controls that are
   // independent of which physical MAC a packet comes in on. This register also contains
   // a Connection table for configuring RX filtering for offloaded connections. It is
   // also used for programming the PHYs for MAC0, MAC1 and Management MAC. Finally it is
   // also used to programming the Receive Side Scaling Key and table used by the chip.
   // For more information on how to use this register see the section, Receive Table
   // Programming. </p> 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RTPR_CSR {
         union {
            struct { 
               u32 indx : 4;                      // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 offset : 16;                   // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RTPR_CSR, *PRXF_RTPR_CSR;

      SG_C_ASSERT(__sizeof__RXF_RTPR_CSR, sizeof (RXF_RTPR_CSR) == 4);

   #else
      typedef struct _RXF_RTPR_CSR {
         u32 indx : 4;                            // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 offset : 16;                         // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 0
      } SG_PACK RXF_RTPR_CSR, *PRXF_RTPR_CSR;

      typedef union _RXF_RTPR_CSR_UNION {
         RXF_RTPR_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RTPR_CSR_UNION, *PRXF_RTPR_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RTPR_CSR_UNION, sizeof (RXF_RTPR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Receive Table Data Register; This is the Data Register used in conjunction with the
   // RXF_RTPR_CSR, Receive Table Programming Register. For more information on how to use
   // this register see the section, Receive Table Programming. </p> 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RTDR_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RTDR_CSR, *PRXF_RTDR_CSR;

      SG_C_ASSERT(__sizeof__RXF_RTDR_CSR, sizeof (RXF_RTDR_CSR) == 4);

   #else
      typedef struct _RXF_RTDR_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK RXF_RTDR_CSR, *PRXF_RTDR_CSR;

      typedef union _RXF_RTDR_CSR_UNION {
         RXF_RTDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RTDR_CSR_UNION, *PRXF_RTDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RTDR_CSR_UNION, sizeof (RXF_RTDR_CSR_UNION) == 4);
   #endif


#else
   // Receive Table Data Register; This is the Data Register used in conjunction with the
   // RXF_RTPR_CSR, Receive Table Programming Register. For more information on how to use
   // this register see the section, Receive Table Programming. </p> 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_RTDR_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_RTDR_CSR, *PRXF_RTDR_CSR;

      SG_C_ASSERT(__sizeof__RXF_RTDR_CSR, sizeof (RXF_RTDR_CSR) == 4);

   #else
      typedef struct _RXF_RTDR_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK RXF_RTDR_CSR, *PRXF_RTDR_CSR;

      typedef union _RXF_RTDR_CSR_UNION {
         RXF_RTDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_RTDR_CSR_UNION, *PRXF_RTDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_RTDR_CSR_UNION, sizeof (RXF_RTDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // 10G Transmit Flow Control Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_TXFC_CSR {
         union {
            struct { 
               u32 tmrdebug : 1;                  // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 high_wm : 10;                  // DWORD 0
               u32 p1entxfc : 1;                  // DWORD 0
               u32 p0entxfc : 1;                  // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 low_wm : 10;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_TXFC_CSR, *PRXF_TXFC_CSR;

      SG_C_ASSERT(__sizeof__RXF_TXFC_CSR, sizeof (RXF_TXFC_CSR) == 4);

   #else
      typedef struct _RXF_TXFC_CSR {
         u32 tmrdebug : 1;                        // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 high_wm : 10;                        // DWORD 0
         u32 p1entxfc : 1;                        // DWORD 0
         u32 p0entxfc : 1;                        // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 low_wm : 10;                         // DWORD 0
      } SG_PACK RXF_TXFC_CSR, *PRXF_TXFC_CSR;

      typedef union _RXF_TXFC_CSR_UNION {
         RXF_TXFC_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_TXFC_CSR_UNION, *PRXF_TXFC_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_TXFC_CSR_UNION, sizeof (RXF_TXFC_CSR_UNION) == 4);
   #endif


#else
   // 10G Transmit Flow Control Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_TXFC_CSR {
         union {
            struct { 
               u32 low_wm : 10;                   // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 p0entxfc : 1;                  // DWORD 0
               u32 p1entxfc : 1;                  // DWORD 0
               u32 high_wm : 10;                  // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 tmrdebug : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_TXFC_CSR, *PRXF_TXFC_CSR;

      SG_C_ASSERT(__sizeof__RXF_TXFC_CSR, sizeof (RXF_TXFC_CSR) == 4);

   #else
      typedef struct _RXF_TXFC_CSR {
         u32 low_wm : 10;                         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 p0entxfc : 1;                        // DWORD 0
         u32 p1entxfc : 1;                        // DWORD 0
         u32 high_wm : 10;                        // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 tmrdebug : 1;                        // DWORD 0
      } SG_PACK RXF_TXFC_CSR, *PRXF_TXFC_CSR;

      typedef union _RXF_TXFC_CSR_UNION {
         RXF_TXFC_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_TXFC_CSR_UNION, *PRXF_TXFC_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_TXFC_CSR_UNION, sizeof (RXF_TXFC_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Management Transmit Flow Control Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MGMT_TXFC_CSR {
         union {
            struct { 
               u32 rsvd1 : 6;                     // DWORD 0
               u32 mgmt_high_wm : 10;             // DWORD 0
               u32 mgmtentxfc : 1;                // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 mgmt_low_wm : 10;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MGMT_TXFC_CSR, *PRXF_MGMT_TXFC_CSR;

      SG_C_ASSERT(__sizeof__RXF_MGMT_TXFC_CSR, sizeof (RXF_MGMT_TXFC_CSR) == 4);

   #else
      typedef struct _RXF_MGMT_TXFC_CSR {
         u32 rsvd1 : 6;                           // DWORD 0
         u32 mgmt_high_wm : 10;                   // DWORD 0
         u32 mgmtentxfc : 1;                      // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 mgmt_low_wm : 10;                    // DWORD 0
      } SG_PACK RXF_MGMT_TXFC_CSR, *PRXF_MGMT_TXFC_CSR;

      typedef union _RXF_MGMT_TXFC_CSR_UNION {
         RXF_MGMT_TXFC_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_MGMT_TXFC_CSR_UNION, *PRXF_MGMT_TXFC_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_MGMT_TXFC_CSR_UNION, sizeof (RXF_MGMT_TXFC_CSR_UNION) == 4);
   #endif


#else
   // Management Transmit Flow Control Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MGMT_TXFC_CSR {
         union {
            struct { 
               u32 mgmt_low_wm : 10;              // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 mgmtentxfc : 1;                // DWORD 0
               u32 mgmt_high_wm : 10;             // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MGMT_TXFC_CSR, *PRXF_MGMT_TXFC_CSR;

      SG_C_ASSERT(__sizeof__RXF_MGMT_TXFC_CSR, sizeof (RXF_MGMT_TXFC_CSR) == 4);

   #else
      typedef struct _RXF_MGMT_TXFC_CSR {
         u32 mgmt_low_wm : 10;                    // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 mgmtentxfc : 1;                      // DWORD 0
         u32 mgmt_high_wm : 10;                   // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
      } SG_PACK RXF_MGMT_TXFC_CSR, *PRXF_MGMT_TXFC_CSR;

      typedef union _RXF_MGMT_TXFC_CSR_UNION {
         RXF_MGMT_TXFC_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_MGMT_TXFC_CSR_UNION, *PRXF_MGMT_TXFC_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_MGMT_TXFC_CSR_UNION, sizeof (RXF_MGMT_TXFC_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Management VLAN Control Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MGMT_VLAN_CSR {
         union {
            struct { 
               u32 rsvd1 : 14;                    // DWORD 0
               u32 nonvlandrop : 1;               // DWORD 0
               u32 vfilten : 1;                   // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 vtag : 12;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MGMT_VLAN_CSR, *PRXF_MGMT_VLAN_CSR;

      SG_C_ASSERT(__sizeof__RXF_MGMT_VLAN_CSR, sizeof (RXF_MGMT_VLAN_CSR) == 4);

   #else
      typedef struct _RXF_MGMT_VLAN_CSR {
         u32 rsvd1 : 14;                          // DWORD 0
         u32 nonvlandrop : 1;                     // DWORD 0
         u32 vfilten : 1;                         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 vtag : 12;                           // DWORD 0
      } SG_PACK RXF_MGMT_VLAN_CSR, *PRXF_MGMT_VLAN_CSR;

      typedef union _RXF_MGMT_VLAN_CSR_UNION {
         RXF_MGMT_VLAN_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_MGMT_VLAN_CSR_UNION, *PRXF_MGMT_VLAN_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_MGMT_VLAN_CSR_UNION, sizeof (RXF_MGMT_VLAN_CSR_UNION) == 4);
   #endif


#else
   // Management VLAN Control Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_MGMT_VLAN_CSR {
         union {
            struct { 
               u32 vtag : 12;                     // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 vfilten : 1;                   // DWORD 0
               u32 nonvlandrop : 1;               // DWORD 0
               u32 rsvd1 : 14;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_MGMT_VLAN_CSR, *PRXF_MGMT_VLAN_CSR;

      SG_C_ASSERT(__sizeof__RXF_MGMT_VLAN_CSR, sizeof (RXF_MGMT_VLAN_CSR) == 4);

   #else
      typedef struct _RXF_MGMT_VLAN_CSR {
         u32 vtag : 12;                           // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 vfilten : 1;                         // DWORD 0
         u32 nonvlandrop : 1;                     // DWORD 0
         u32 rsvd1 : 14;                          // DWORD 0
      } SG_PACK RXF_MGMT_VLAN_CSR, *PRXF_MGMT_VLAN_CSR;

      typedef union _RXF_MGMT_VLAN_CSR_UNION {
         RXF_MGMT_VLAN_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_MGMT_VLAN_CSR_UNION, *PRXF_MGMT_VLAN_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_MGMT_VLAN_CSR_UNION, sizeof (RXF_MGMT_VLAN_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The lowest 4 bytes of the MAC address.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_DATA_0 {
         union {
            struct { 
               u32 byte3 : 8;                     // DWORD 0
               u32 byte2 : 8;                     // DWORD 0
               u32 byte1 : 8;                     // DWORD 0
               u32 byte0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MAC_DATA_0, *PMAC_DATA_0;

      SG_C_ASSERT(__sizeof__MAC_DATA_0, sizeof (MAC_DATA_0) == 4);

   #else
      typedef struct _MAC_DATA_0 {
         u32 byte3 : 8;                           // DWORD 0
         u32 byte2 : 8;                           // DWORD 0
         u32 byte1 : 8;                           // DWORD 0
         u32 byte0 : 8;                           // DWORD 0
      } SG_PACK MAC_DATA_0, *PMAC_DATA_0;

      typedef union _MAC_DATA_0_UNION {
         MAC_DATA_0 bits;
         u32 dw; // dword union
      } SG_PACK MAC_DATA_0_UNION, *PMAC_DATA_0_UNION;

      SG_C_ASSERT(__sizeof__MAC_DATA_0_UNION, sizeof (MAC_DATA_0_UNION) == 4);
   #endif


#else
   // The lowest 4 bytes of the MAC address.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_DATA_0 {
         union {
            struct { 
               u32 byte0 : 8;                     // DWORD 0
               u32 byte1 : 8;                     // DWORD 0
               u32 byte2 : 8;                     // DWORD 0
               u32 byte3 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MAC_DATA_0, *PMAC_DATA_0;

      SG_C_ASSERT(__sizeof__MAC_DATA_0, sizeof (MAC_DATA_0) == 4);

   #else
      typedef struct _MAC_DATA_0 {
         u32 byte0 : 8;                           // DWORD 0
         u32 byte1 : 8;                           // DWORD 0
         u32 byte2 : 8;                           // DWORD 0
         u32 byte3 : 8;                           // DWORD 0
      } SG_PACK MAC_DATA_0, *PMAC_DATA_0;

      typedef union _MAC_DATA_0_UNION {
         MAC_DATA_0 bits;
         u32 dw; // dword union
      } SG_PACK MAC_DATA_0_UNION, *PMAC_DATA_0_UNION;

      SG_C_ASSERT(__sizeof__MAC_DATA_0_UNION, sizeof (MAC_DATA_0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The upper 2 bytes of the MAC address and the lwer 16 bits of the port0 ring vector.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_DATA_1 {
         union {
            struct { 
               u32 port0_vector_lo : 16;          // DWORD 0
               u32 byte5 : 8;                     // DWORD 0
               u32 byte4 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MAC_DATA_1, *PMAC_DATA_1;

      SG_C_ASSERT(__sizeof__MAC_DATA_1, sizeof (MAC_DATA_1) == 4);

   #else
      typedef struct _MAC_DATA_1 {
         u32 port0_vector_lo : 16;                // DWORD 0
         u32 byte5 : 8;                           // DWORD 0
         u32 byte4 : 8;                           // DWORD 0
      } SG_PACK MAC_DATA_1, *PMAC_DATA_1;

      typedef union _MAC_DATA_1_UNION {
         MAC_DATA_1 bits;
         u32 dw; // dword union
      } SG_PACK MAC_DATA_1_UNION, *PMAC_DATA_1_UNION;

      SG_C_ASSERT(__sizeof__MAC_DATA_1_UNION, sizeof (MAC_DATA_1_UNION) == 4);
   #endif


#else
   // The upper 2 bytes of the MAC address and the lwer 16 bits of the port0 ring vector.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_DATA_1 {
         union {
            struct { 
               u32 byte4 : 8;                     // DWORD 0
               u32 byte5 : 8;                     // DWORD 0
               u32 port0_vector_lo : 16;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MAC_DATA_1, *PMAC_DATA_1;

      SG_C_ASSERT(__sizeof__MAC_DATA_1, sizeof (MAC_DATA_1) == 4);

   #else
      typedef struct _MAC_DATA_1 {
         u32 byte4 : 8;                           // DWORD 0
         u32 byte5 : 8;                           // DWORD 0
         u32 port0_vector_lo : 16;                // DWORD 0
      } SG_PACK MAC_DATA_1, *PMAC_DATA_1;

      typedef union _MAC_DATA_1_UNION {
         MAC_DATA_1 bits;
         u32 dw; // dword union
      } SG_PACK MAC_DATA_1_UNION, *PMAC_DATA_1_UNION;

      SG_C_ASSERT(__sizeof__MAC_DATA_1_UNION, sizeof (MAC_DATA_1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The upper 21 bits of the port0 ring vector and the lower 11 bits of the port 1 ring
   // vector.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_DATA_2 {
         union {
            struct { 
               u32 port1_vector_lo : 11;          // DWORD 0
               u32 port0_vector_hi : 21;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MAC_DATA_2, *PMAC_DATA_2;

      SG_C_ASSERT(__sizeof__MAC_DATA_2, sizeof (MAC_DATA_2) == 4);

   #else
      typedef struct _MAC_DATA_2 {
         u32 port1_vector_lo : 11;                // DWORD 0
         u32 port0_vector_hi : 21;                // DWORD 0
      } SG_PACK MAC_DATA_2, *PMAC_DATA_2;

      typedef union _MAC_DATA_2_UNION {
         MAC_DATA_2 bits;
         u32 dw; // dword union
      } SG_PACK MAC_DATA_2_UNION, *PMAC_DATA_2_UNION;

      SG_C_ASSERT(__sizeof__MAC_DATA_2_UNION, sizeof (MAC_DATA_2_UNION) == 4);
   #endif


#else
   // The upper 21 bits of the port0 ring vector and the lower 11 bits of the port 1 ring
   // vector.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_DATA_2 {
         union {
            struct { 
               u32 port0_vector_hi : 21;          // DWORD 0
               u32 port1_vector_lo : 11;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MAC_DATA_2, *PMAC_DATA_2;

      SG_C_ASSERT(__sizeof__MAC_DATA_2, sizeof (MAC_DATA_2) == 4);

   #else
      typedef struct _MAC_DATA_2 {
         u32 port0_vector_hi : 21;                // DWORD 0
         u32 port1_vector_lo : 11;                // DWORD 0
      } SG_PACK MAC_DATA_2, *PMAC_DATA_2;

      typedef union _MAC_DATA_2_UNION {
         MAC_DATA_2 bits;
         u32 dw; // dword union
      } SG_PACK MAC_DATA_2_UNION, *PMAC_DATA_2_UNION;

      SG_C_ASSERT(__sizeof__MAC_DATA_2_UNION, sizeof (MAC_DATA_2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The upper 26 bits of the port1 ring vector and a valid bit.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_DATA_3 {
         union {
            struct { 
               u32 valid : 1;                     // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 port1_vector_hi : 26;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MAC_DATA_3, *PMAC_DATA_3;

      SG_C_ASSERT(__sizeof__MAC_DATA_3, sizeof (MAC_DATA_3) == 4);

   #else
      typedef struct _MAC_DATA_3 {
         u32 valid : 1;                           // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 port1_vector_hi : 26;                // DWORD 0
      } SG_PACK MAC_DATA_3, *PMAC_DATA_3;

      typedef union _MAC_DATA_3_UNION {
         MAC_DATA_3 bits;
         u32 dw; // dword union
      } SG_PACK MAC_DATA_3_UNION, *PMAC_DATA_3_UNION;

      SG_C_ASSERT(__sizeof__MAC_DATA_3_UNION, sizeof (MAC_DATA_3_UNION) == 4);
   #endif


#else
   // The upper 26 bits of the port1 ring vector and a valid bit.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_DATA_3 {
         union {
            struct { 
               u32 port1_vector_hi : 26;          // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 valid : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MAC_DATA_3, *PMAC_DATA_3;

      SG_C_ASSERT(__sizeof__MAC_DATA_3, sizeof (MAC_DATA_3) == 4);

   #else
      typedef struct _MAC_DATA_3 {
         u32 port1_vector_hi : 26;                // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 valid : 1;                           // DWORD 0
      } SG_PACK MAC_DATA_3, *PMAC_DATA_3;

      typedef union _MAC_DATA_3_UNION {
         MAC_DATA_3 bits;
         u32 dw; // dword union
      } SG_PACK MAC_DATA_3_UNION, *PMAC_DATA_3_UNION;

      SG_C_ASSERT(__sizeof__MAC_DATA_3_UNION, sizeof (MAC_DATA_3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This constitutes an entry in the MAC_ADDRESS_TABLE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_ADDRESS_TABLE_ENTRY {
         union {
            struct { 
               MAC_DATA_0 mac_0;
               MAC_DATA_1 mac_1;
               MAC_DATA_2 mac_2;
               MAC_DATA_3 mac_3;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK MAC_ADDRESS_TABLE_ENTRY, *PMAC_ADDRESS_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__MAC_ADDRESS_TABLE_ENTRY, sizeof (MAC_ADDRESS_TABLE_ENTRY) == 16);

   #else
      typedef struct _MAC_ADDRESS_TABLE_ENTRY {
         MAC_DATA_0 mac_0;
         MAC_DATA_1 mac_1;
         MAC_DATA_2 mac_2;
         MAC_DATA_3 mac_3;
      } SG_PACK MAC_ADDRESS_TABLE_ENTRY, *PMAC_ADDRESS_TABLE_ENTRY;

      typedef union _MAC_ADDRESS_TABLE_ENTRY_UNION {
         MAC_ADDRESS_TABLE_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK MAC_ADDRESS_TABLE_ENTRY_UNION, *PMAC_ADDRESS_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MAC_ADDRESS_TABLE_ENTRY_UNION, sizeof (MAC_ADDRESS_TABLE_ENTRY_UNION) == 16);
   #endif


#else
   // This constitutes an entry in the MAC_ADDRESS_TABLE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_ADDRESS_TABLE_ENTRY {
         union {
            struct { 
               MAC_DATA_0 mac_0;
               MAC_DATA_1 mac_1;
               MAC_DATA_2 mac_2;
               MAC_DATA_3 mac_3;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK MAC_ADDRESS_TABLE_ENTRY, *PMAC_ADDRESS_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__MAC_ADDRESS_TABLE_ENTRY, sizeof (MAC_ADDRESS_TABLE_ENTRY) == 16);

   #else
      typedef struct _MAC_ADDRESS_TABLE_ENTRY {
         MAC_DATA_0 mac_0;
         MAC_DATA_1 mac_1;
         MAC_DATA_2 mac_2;
         MAC_DATA_3 mac_3;
      } SG_PACK MAC_ADDRESS_TABLE_ENTRY, *PMAC_ADDRESS_TABLE_ENTRY;

      typedef union _MAC_ADDRESS_TABLE_ENTRY_UNION {
         MAC_ADDRESS_TABLE_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK MAC_ADDRESS_TABLE_ENTRY_UNION, *PMAC_ADDRESS_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MAC_ADDRESS_TABLE_ENTRY_UNION, sizeof (MAC_ADDRESS_TABLE_ENTRY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Receive Table Programming Offsets.</p> 
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_ADDRESS_TABLE {
         union {
            struct { 
               struct {
                  MAC_ADDRESS_TABLE_ENTRY network[128];
               } port;
               MAC_ADDRESS_TABLE_ENTRY mgmgt;
            } SG_PACK ; // unnamed struct
            u32 dw[516]; // dword union
         }; // unnamed union
      } SG_PACK MAC_ADDRESS_TABLE, *PMAC_ADDRESS_TABLE;

      SG_C_ASSERT(__sizeof__MAC_ADDRESS_TABLE, sizeof (MAC_ADDRESS_TABLE) == 2064);

   #else
      typedef struct _MAC_ADDRESS_TABLE {
         struct {
            MAC_ADDRESS_TABLE_ENTRY network[128];
         } port;
         MAC_ADDRESS_TABLE_ENTRY mgmgt;
      } SG_PACK MAC_ADDRESS_TABLE, *PMAC_ADDRESS_TABLE;

      typedef union _MAC_ADDRESS_TABLE_UNION {
         MAC_ADDRESS_TABLE bits;
         u32 dw[516]; // dword union
      } SG_PACK MAC_ADDRESS_TABLE_UNION, *PMAC_ADDRESS_TABLE_UNION;

      SG_C_ASSERT(__sizeof__MAC_ADDRESS_TABLE_UNION, sizeof (MAC_ADDRESS_TABLE_UNION) == 2064);
   #endif


#else
   // Receive Table Programming Offsets.</p> 
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_ADDRESS_TABLE {
         union {
            struct { 
               struct {
                  MAC_ADDRESS_TABLE_ENTRY network[128];
               } port;
               MAC_ADDRESS_TABLE_ENTRY mgmgt;
            } SG_PACK ; // unnamed struct
            u32 dw[516]; // dword union
         }; // unnamed union
      } SG_PACK MAC_ADDRESS_TABLE, *PMAC_ADDRESS_TABLE;

      SG_C_ASSERT(__sizeof__MAC_ADDRESS_TABLE, sizeof (MAC_ADDRESS_TABLE) == 2064);

   #else
      typedef struct _MAC_ADDRESS_TABLE {
         struct {
            MAC_ADDRESS_TABLE_ENTRY network[128];
         } port;
         MAC_ADDRESS_TABLE_ENTRY mgmgt;
      } SG_PACK MAC_ADDRESS_TABLE, *PMAC_ADDRESS_TABLE;

      typedef union _MAC_ADDRESS_TABLE_UNION {
         MAC_ADDRESS_TABLE bits;
         u32 dw[516]; // dword union
      } SG_PACK MAC_ADDRESS_TABLE_UNION, *PMAC_ADDRESS_TABLE_UNION;

      SG_C_ASSERT(__sizeof__MAC_ADDRESS_TABLE_UNION, sizeof (MAC_ADDRESS_TABLE_UNION) == 2064);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Defines an entry in the Multicast Table 
   #if defined(SG_BMAP_UNION)
      typedef struct _MULTICAST_TABLE_ENTRY {
         union {
            struct { 
               u32 port0_multicast_vector_lo;     // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 1
               u32 port0_multicast_vector_hi : 5; // DWORD 1
               u32 port1_multicast_vector_lo;     // DWORD 2
               u32 rsvd1 : 27;                    // DWORD 3
               u32 port1_multicast_vector_hi : 5; // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK MULTICAST_TABLE_ENTRY, *PMULTICAST_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__MULTICAST_TABLE_ENTRY, sizeof (MULTICAST_TABLE_ENTRY) == 16);

   #else
      typedef struct _MULTICAST_TABLE_ENTRY {
         u32 port0_multicast_vector_lo;           // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 1
         u32 port0_multicast_vector_hi : 5;       // DWORD 1
         u32 port1_multicast_vector_lo;           // DWORD 2
         u32 rsvd1 : 27;                          // DWORD 3
         u32 port1_multicast_vector_hi : 5;       // DWORD 3
      } SG_PACK MULTICAST_TABLE_ENTRY, *PMULTICAST_TABLE_ENTRY;

      typedef union _MULTICAST_TABLE_ENTRY_UNION {
         MULTICAST_TABLE_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK MULTICAST_TABLE_ENTRY_UNION, *PMULTICAST_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MULTICAST_TABLE_ENTRY_UNION, sizeof (MULTICAST_TABLE_ENTRY_UNION) == 16);
   #endif


#else
   // Defines an entry in the Multicast Table 
   #if defined(SG_BMAP_UNION)
      typedef struct _MULTICAST_TABLE_ENTRY {
         union {
            struct { 
               u32 port0_multicast_vector_lo;     // DWORD 0
               u32 port0_multicast_vector_hi : 5; // DWORD 1
               u32 rsvd0 : 27;                    // DWORD 1
               u32 port1_multicast_vector_lo;     // DWORD 2
               u32 port1_multicast_vector_hi : 5; // DWORD 3
               u32 rsvd1 : 27;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK MULTICAST_TABLE_ENTRY, *PMULTICAST_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__MULTICAST_TABLE_ENTRY, sizeof (MULTICAST_TABLE_ENTRY) == 16);

   #else
      typedef struct _MULTICAST_TABLE_ENTRY {
         u32 port0_multicast_vector_lo;           // DWORD 0
         u32 port0_multicast_vector_hi : 5;       // DWORD 1
         u32 rsvd0 : 27;                          // DWORD 1
         u32 port1_multicast_vector_lo;           // DWORD 2
         u32 port1_multicast_vector_hi : 5;       // DWORD 3
         u32 rsvd1 : 27;                          // DWORD 3
      } SG_PACK MULTICAST_TABLE_ENTRY, *PMULTICAST_TABLE_ENTRY;

      typedef union _MULTICAST_TABLE_ENTRY_UNION {
         MULTICAST_TABLE_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK MULTICAST_TABLE_ENTRY_UNION, *PMULTICAST_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MULTICAST_TABLE_ENTRY_UNION, sizeof (MULTICAST_TABLE_ENTRY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Multicast Hash Table.</p>
   #if defined(SG_BMAP_UNION)
      typedef struct _MULTICAST_TABLE {
         union {
            struct { 
               MULTICAST_TABLE_ENTRY mcast_entry[64];
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK MULTICAST_TABLE, *PMULTICAST_TABLE;

      SG_C_ASSERT(__sizeof__MULTICAST_TABLE, sizeof (MULTICAST_TABLE) == 1024);

   #else
      typedef struct _MULTICAST_TABLE {
         MULTICAST_TABLE_ENTRY mcast_entry[64];
      } SG_PACK MULTICAST_TABLE, *PMULTICAST_TABLE;

      typedef union _MULTICAST_TABLE_UNION {
         MULTICAST_TABLE bits;
         u32 dw[256]; // dword union
      } SG_PACK MULTICAST_TABLE_UNION, *PMULTICAST_TABLE_UNION;

      SG_C_ASSERT(__sizeof__MULTICAST_TABLE_UNION, sizeof (MULTICAST_TABLE_UNION) == 1024);
   #endif


#else
   // Multicast Hash Table.</p>
   #if defined(SG_BMAP_UNION)
      typedef struct _MULTICAST_TABLE {
         union {
            struct { 
               MULTICAST_TABLE_ENTRY mcast_entry[64];
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK MULTICAST_TABLE, *PMULTICAST_TABLE;

      SG_C_ASSERT(__sizeof__MULTICAST_TABLE, sizeof (MULTICAST_TABLE) == 1024);

   #else
      typedef struct _MULTICAST_TABLE {
         MULTICAST_TABLE_ENTRY mcast_entry[64];
      } SG_PACK MULTICAST_TABLE, *PMULTICAST_TABLE;

      typedef union _MULTICAST_TABLE_UNION {
         MULTICAST_TABLE bits;
         u32 dw[256]; // dword union
      } SG_PACK MULTICAST_TABLE_UNION, *PMULTICAST_TABLE_UNION;

      SG_C_ASSERT(__sizeof__MULTICAST_TABLE_UNION, sizeof (MULTICAST_TABLE_UNION) == 1024);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This constitues a single VLAN Table Entry. 
   #if defined(SG_BMAP_UNION)
      typedef struct _VLAN_TABLE_ENTRY {
         union {
            struct { 
               u32 rsvd1 : 4;                     // DWORD 0
               u32 tag0i : 12;                    // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 tag0o : 12;                    // DWORD 0
               u32 rsvd3 : 4;                     // DWORD 1
               u32 tag1i : 12;                    // DWORD 1
               u32 rsvd2 : 4;                     // DWORD 1
               u32 tag1o : 12;                    // DWORD 1
               u32 vector0o[1];                   // DWORDS 2 to 2
               u32 vector0i : 24;                 // DWORD 3
               u32 rsvd4 : 3;                     // DWORD 3
               u32 vector0o_end : 5;              // DWORD 3
               u32 vector1o : 16;                 // DWORD 4
               u32 rsvd5 : 3;                     // DWORD 4
               u32 vector0i_end : 13;             // DWORD 3
               u32 vector1i : 8;                  // DWORD 5
               u32 rsvd6 : 3;                     // DWORD 5
               u32 vector1o_end : 21;             // DWORD 5
               u32 rsvd7 : 3;                     // DWORD 6
               u32 vector1i_end : 29;             // DWORD 6
               u32 inner_valid : 1;               // DWORD 7
               u32 outter_valid : 1;              // DWORD 7
               u32 rsvd8 : 30;                    // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK VLAN_TABLE_ENTRY, *PVLAN_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__VLAN_TABLE_ENTRY, sizeof (VLAN_TABLE_ENTRY) == 32);

   #else
      typedef struct _VLAN_TABLE_ENTRY {
         u32 rsvd1 : 4;                           // DWORD 0
         u32 tag0i : 12;                          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 tag0o : 12;                          // DWORD 0
         u32 rsvd3 : 4;                           // DWORD 1
         u32 tag1i : 12;                          // DWORD 1
         u32 rsvd2 : 4;                           // DWORD 1
         u32 tag1o : 12;                          // DWORD 1
         u32 vector0o[1];                         // DWORDS 2 to 2
         u32 vector0i : 24;                       // DWORD 3
         u32 rsvd4 : 3;                           // DWORD 3
         u32 vector0o_end : 5;                    // DWORD 3
         u32 vector1o : 16;                       // DWORD 4
         u32 rsvd5 : 3;                           // DWORD 4
         u32 vector0i_end : 13;                   // DWORD 3
         u32 vector1i : 8;                        // DWORD 5
         u32 rsvd6 : 3;                           // DWORD 5
         u32 vector1o_end : 21;                   // DWORD 5
         u32 rsvd7 : 3;                           // DWORD 6
         u32 vector1i_end : 29;                   // DWORD 6
         u32 inner_valid : 1;                     // DWORD 7
         u32 outter_valid : 1;                    // DWORD 7
         u32 rsvd8 : 30;                          // DWORD 7
      } SG_PACK VLAN_TABLE_ENTRY, *PVLAN_TABLE_ENTRY;

      typedef union _VLAN_TABLE_ENTRY_UNION {
         VLAN_TABLE_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK VLAN_TABLE_ENTRY_UNION, *PVLAN_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__VLAN_TABLE_ENTRY_UNION, sizeof (VLAN_TABLE_ENTRY_UNION) == 32);
   #endif


#else
   // This constitues a single VLAN Table Entry. 
   #if defined(SG_BMAP_UNION)
      typedef struct _VLAN_TABLE_ENTRY {
         union {
            struct { 
               u32 tag0o : 12;                    // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 tag0i : 12;                    // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 tag1o : 12;                    // DWORD 1
               u32 rsvd2 : 4;                     // DWORD 1
               u32 tag1i : 12;                    // DWORD 1
               u32 rsvd3 : 4;                     // DWORD 1
               u32 vector0o[1];                   // DWORDS 2 to 2
               u32 vector0o_end : 5;              // DWORD 3
               u32 rsvd4 : 3;                     // DWORD 3
               u32 vector0i : 24;                 // DWORD 3
               u32 vector0i_end : 13;             // DWORD 3
               u32 rsvd5 : 3;                     // DWORD 4
               u32 vector1o : 16;                 // DWORD 4
               u32 vector1o_end : 21;             // DWORD 5
               u32 rsvd6 : 3;                     // DWORD 5
               u32 vector1i : 8;                  // DWORD 5
               u32 vector1i_end : 29;             // DWORD 6
               u32 rsvd7 : 3;                     // DWORD 6
               u32 rsvd8 : 30;                    // DWORD 7
               u32 outter_valid : 1;              // DWORD 7
               u32 inner_valid : 1;               // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK VLAN_TABLE_ENTRY, *PVLAN_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__VLAN_TABLE_ENTRY, sizeof (VLAN_TABLE_ENTRY) == 32);

   #else
      typedef struct _VLAN_TABLE_ENTRY {
         u32 tag0o : 12;                          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 tag0i : 12;                          // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 tag1o : 12;                          // DWORD 1
         u32 rsvd2 : 4;                           // DWORD 1
         u32 tag1i : 12;                          // DWORD 1
         u32 rsvd3 : 4;                           // DWORD 1
         u32 vector0o[1];                         // DWORDS 2 to 2
         u32 vector0o_end : 5;                    // DWORD 3
         u32 rsvd4 : 3;                           // DWORD 3
         u32 vector0i : 24;                       // DWORD 3
         u32 vector0i_end : 13;                   // DWORD 3
         u32 rsvd5 : 3;                           // DWORD 4
         u32 vector1o : 16;                       // DWORD 4
         u32 vector1o_end : 21;                   // DWORD 5
         u32 rsvd6 : 3;                           // DWORD 5
         u32 vector1i : 8;                        // DWORD 5
         u32 vector1i_end : 29;                   // DWORD 6
         u32 rsvd7 : 3;                           // DWORD 6
         u32 rsvd8 : 30;                          // DWORD 7
         u32 outter_valid : 1;                    // DWORD 7
         u32 inner_valid : 1;                     // DWORD 7
      } SG_PACK VLAN_TABLE_ENTRY, *PVLAN_TABLE_ENTRY;

      typedef union _VLAN_TABLE_ENTRY_UNION {
         VLAN_TABLE_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK VLAN_TABLE_ENTRY_UNION, *PVLAN_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__VLAN_TABLE_ENTRY_UNION, sizeof (VLAN_TABLE_ENTRY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The VLAN TAG Table contains 64 tag pairs or 128 tags, per port, and their associated
   // receive vectors</p>
   #if defined(SG_BMAP_UNION)
      typedef struct _VLAN_TABLE {
         union {
            struct { 
               VLAN_TABLE_ENTRY TAG[64];
            } SG_PACK ; // unnamed struct
            u32 dw[512]; // dword union
         }; // unnamed union
      } SG_PACK VLAN_TABLE, *PVLAN_TABLE;

      SG_C_ASSERT(__sizeof__VLAN_TABLE, sizeof (VLAN_TABLE) == 2048);

   #else
      typedef struct _VLAN_TABLE {
         VLAN_TABLE_ENTRY TAG[64];
      } SG_PACK VLAN_TABLE, *PVLAN_TABLE;

      typedef union _VLAN_TABLE_UNION {
         VLAN_TABLE bits;
         u32 dw[512]; // dword union
      } SG_PACK VLAN_TABLE_UNION, *PVLAN_TABLE_UNION;

      SG_C_ASSERT(__sizeof__VLAN_TABLE_UNION, sizeof (VLAN_TABLE_UNION) == 2048);
   #endif


#else
   // The VLAN TAG Table contains 64 tag pairs or 128 tags, per port, and their associated
   // receive vectors</p>
   #if defined(SG_BMAP_UNION)
      typedef struct _VLAN_TABLE {
         union {
            struct { 
               VLAN_TABLE_ENTRY TAG[64];
            } SG_PACK ; // unnamed struct
            u32 dw[512]; // dword union
         }; // unnamed union
      } SG_PACK VLAN_TABLE, *PVLAN_TABLE;

      SG_C_ASSERT(__sizeof__VLAN_TABLE, sizeof (VLAN_TABLE) == 2048);

   #else
      typedef struct _VLAN_TABLE {
         VLAN_TABLE_ENTRY TAG[64];
      } SG_PACK VLAN_TABLE, *PVLAN_TABLE;

      typedef union _VLAN_TABLE_UNION {
         VLAN_TABLE bits;
         u32 dw[512]; // dword union
      } SG_PACK VLAN_TABLE_UNION, *PVLAN_TABLE_UNION;

      SG_C_ASSERT(__sizeof__VLAN_TABLE_UNION, sizeof (VLAN_TABLE_UNION) == 2048);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Defines an entry in the FCOE Table 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_TABLE_ENTRY {
         union {
            struct { 
               u32 mac_address[1];                // DWORDS 0 to 0
               u32 rsvd0 : 16;                    // DWORD 1
               u32 mac_address_end : 16;          // DWORD 1
               u32 rsvd2 : 4;                     // DWORD 2
               u32 vf_id : 12;                    // DWORD 2
               u32 rsvd1 : 4;                     // DWORD 2
               u32 vlan : 12;                     // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 port : 1;                      // DWORD 3
               u32 rsvd3 : 30;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_TABLE_ENTRY, *PFCOE_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__FCOE_TABLE_ENTRY, sizeof (FCOE_TABLE_ENTRY) == 16);

   #else
      typedef struct _FCOE_TABLE_ENTRY {
         u32 mac_address[1];                      // DWORDS 0 to 0
         u32 rsvd0 : 16;                          // DWORD 1
         u32 mac_address_end : 16;                // DWORD 1
         u32 rsvd2 : 4;                           // DWORD 2
         u32 vf_id : 12;                          // DWORD 2
         u32 rsvd1 : 4;                           // DWORD 2
         u32 vlan : 12;                           // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 port : 1;                            // DWORD 3
         u32 rsvd3 : 30;                          // DWORD 3
      } SG_PACK FCOE_TABLE_ENTRY, *PFCOE_TABLE_ENTRY;

      typedef union _FCOE_TABLE_ENTRY_UNION {
         FCOE_TABLE_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FCOE_TABLE_ENTRY_UNION, *PFCOE_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FCOE_TABLE_ENTRY_UNION, sizeof (FCOE_TABLE_ENTRY_UNION) == 16);
   #endif


#else
   // Defines an entry in the FCOE Table 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_TABLE_ENTRY {
         union {
            struct { 
               u32 mac_address[1];                // DWORDS 0 to 0
               u32 mac_address_end : 16;          // DWORD 1
               u32 rsvd0 : 16;                    // DWORD 1
               u32 vlan : 12;                     // DWORD 2
               u32 rsvd1 : 4;                     // DWORD 2
               u32 vf_id : 12;                    // DWORD 2
               u32 rsvd2 : 4;                     // DWORD 2
               u32 rsvd3 : 30;                    // DWORD 3
               u32 port : 1;                      // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_TABLE_ENTRY, *PFCOE_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__FCOE_TABLE_ENTRY, sizeof (FCOE_TABLE_ENTRY) == 16);

   #else
      typedef struct _FCOE_TABLE_ENTRY {
         u32 mac_address[1];                      // DWORDS 0 to 0
         u32 mac_address_end : 16;                // DWORD 1
         u32 rsvd0 : 16;                          // DWORD 1
         u32 vlan : 12;                           // DWORD 2
         u32 rsvd1 : 4;                           // DWORD 2
         u32 vf_id : 12;                          // DWORD 2
         u32 rsvd2 : 4;                           // DWORD 2
         u32 rsvd3 : 30;                          // DWORD 3
         u32 port : 1;                            // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK FCOE_TABLE_ENTRY, *PFCOE_TABLE_ENTRY;

      typedef union _FCOE_TABLE_ENTRY_UNION {
         FCOE_TABLE_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FCOE_TABLE_ENTRY_UNION, *PFCOE_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FCOE_TABLE_ENTRY_UNION, sizeof (FCOE_TABLE_ENTRY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FCOE Programming Table.</p>
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_TABLE {
         union {
            struct { 
               FCOE_TABLE_ENTRY fcoe_table_entry[64];
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_TABLE, *PFCOE_TABLE;

      SG_C_ASSERT(__sizeof__FCOE_TABLE, sizeof (FCOE_TABLE) == 1024);

   #else
      typedef struct _FCOE_TABLE {
         FCOE_TABLE_ENTRY fcoe_table_entry[64];
      } SG_PACK FCOE_TABLE, *PFCOE_TABLE;

      typedef union _FCOE_TABLE_UNION {
         FCOE_TABLE bits;
         u32 dw[256]; // dword union
      } SG_PACK FCOE_TABLE_UNION, *PFCOE_TABLE_UNION;

      SG_C_ASSERT(__sizeof__FCOE_TABLE_UNION, sizeof (FCOE_TABLE_UNION) == 1024);
   #endif


#else
   // FCOE Programming Table.</p>
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_TABLE {
         union {
            struct { 
               FCOE_TABLE_ENTRY fcoe_table_entry[64];
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_TABLE, *PFCOE_TABLE;

      SG_C_ASSERT(__sizeof__FCOE_TABLE, sizeof (FCOE_TABLE) == 1024);

   #else
      typedef struct _FCOE_TABLE {
         FCOE_TABLE_ENTRY fcoe_table_entry[64];
      } SG_PACK FCOE_TABLE, *PFCOE_TABLE;

      typedef union _FCOE_TABLE_UNION {
         FCOE_TABLE bits;
         u32 dw[256]; // dword union
      } SG_PACK FCOE_TABLE_UNION, *PFCOE_TABLE_UNION;

      SG_C_ASSERT(__sizeof__FCOE_TABLE_UNION, sizeof (FCOE_TABLE_UNION) == 1024);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Defines an IPv6 entry in the DA Table 
   #if defined(SG_BMAP_UNION)
      typedef struct _DA_TABLE_ENTRY {
         union {
            struct { 
               u32 dstAddr[4];                    // DWORDS 0 to 3
               u32 valid : 1;                     // DWORD 4
               u32 rsvd0 : 31;                    // DWORD 4
               u32 rsvd1[3];                      // DWORDS 5 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DA_TABLE_ENTRY, *PDA_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__DA_TABLE_ENTRY, sizeof (DA_TABLE_ENTRY) == 32);

   #else
      typedef struct _DA_TABLE_ENTRY {
         u32 dstAddr[4];                          // DWORDS 0 to 3
         u32 valid : 1;                           // DWORD 4
         u32 rsvd0 : 31;                          // DWORD 4
         u32 rsvd1[3];                            // DWORDS 5 to 7
      } SG_PACK DA_TABLE_ENTRY, *PDA_TABLE_ENTRY;

      typedef union _DA_TABLE_ENTRY_UNION {
         DA_TABLE_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK DA_TABLE_ENTRY_UNION, *PDA_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__DA_TABLE_ENTRY_UNION, sizeof (DA_TABLE_ENTRY_UNION) == 32);
   #endif


#else
   // Defines an IPv6 entry in the DA Table 
   #if defined(SG_BMAP_UNION)
      typedef struct _DA_TABLE_ENTRY {
         union {
            struct { 
               u32 dstAddr[4];                    // DWORDS 0 to 3
               u32 rsvd0 : 31;                    // DWORD 4
               u32 valid : 1;                     // DWORD 4
               u32 rsvd1[3];                      // DWORDS 5 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DA_TABLE_ENTRY, *PDA_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__DA_TABLE_ENTRY, sizeof (DA_TABLE_ENTRY) == 32);

   #else
      typedef struct _DA_TABLE_ENTRY {
         u32 dstAddr[4];                          // DWORDS 0 to 3
         u32 rsvd0 : 31;                          // DWORD 4
         u32 valid : 1;                           // DWORD 4
         u32 rsvd1[3];                            // DWORDS 5 to 7
      } SG_PACK DA_TABLE_ENTRY, *PDA_TABLE_ENTRY;

      typedef union _DA_TABLE_ENTRY_UNION {
         DA_TABLE_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK DA_TABLE_ENTRY_UNION, *PDA_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__DA_TABLE_ENTRY_UNION, sizeof (DA_TABLE_ENTRY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DA Programming Table.</p>
   #if defined(SG_BMAP_UNION)
      typedef struct _DA_TABLE {
         union {
            struct { 
               DA_TABLE_ENTRY da_table_entry[64];
            } SG_PACK ; // unnamed struct
            u32 dw[512]; // dword union
         }; // unnamed union
      } SG_PACK DA_TABLE, *PDA_TABLE;

      SG_C_ASSERT(__sizeof__DA_TABLE, sizeof (DA_TABLE) == 2048);

   #else
      typedef struct _DA_TABLE {
         DA_TABLE_ENTRY da_table_entry[64];
      } SG_PACK DA_TABLE, *PDA_TABLE;

      typedef union _DA_TABLE_UNION {
         DA_TABLE bits;
         u32 dw[512]; // dword union
      } SG_PACK DA_TABLE_UNION, *PDA_TABLE_UNION;

      SG_C_ASSERT(__sizeof__DA_TABLE_UNION, sizeof (DA_TABLE_UNION) == 2048);
   #endif


#else
   // DA Programming Table.</p>
   #if defined(SG_BMAP_UNION)
      typedef struct _DA_TABLE {
         union {
            struct { 
               DA_TABLE_ENTRY da_table_entry[64];
            } SG_PACK ; // unnamed struct
            u32 dw[512]; // dword union
         }; // unnamed union
      } SG_PACK DA_TABLE, *PDA_TABLE;

      SG_C_ASSERT(__sizeof__DA_TABLE, sizeof (DA_TABLE) == 2048);

   #else
      typedef struct _DA_TABLE {
         DA_TABLE_ENTRY da_table_entry[64];
      } SG_PACK DA_TABLE, *PDA_TABLE;

      typedef union _DA_TABLE_UNION {
         DA_TABLE bits;
         u32 dw[512]; // dword union
      } SG_PACK DA_TABLE_UNION, *PDA_TABLE_UNION;

      SG_C_ASSERT(__sizeof__DA_TABLE_UNION, sizeof (DA_TABLE_UNION) == 2048);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control bits for configuring ACPI.
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_CONTROL {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 la_pattern3_la_en : 1;         // DWORD 0
               u32 la_pattern2_la_en : 1;         // DWORD 0
               u32 la_pattern1_la_en : 1;         // DWORD 0
               u32 la_pattern0_la_en : 1;         // DWORD 0
               u32 wol_pattern3_function : 3;     // DWORD 0
               u32 wol_pattern3_pat_stall : 1;    // DWORD 0
               u32 wol_pattern3_wol : 1;          // DWORD 0
               u32 wol_pattern2_function : 3;     // DWORD 0
               u32 wol_pattern2_pat_stall : 1;    // DWORD 0
               u32 wol_pattern2_wol : 1;          // DWORD 0
               u32 wol_pattern1_function : 3;     // DWORD 0
               u32 wol_pattern1_pat_stall : 1;    // DWORD 0
               u32 wol_pattern1_wol : 1;          // DWORD 0
               u32 wol_pattern0_function : 3;     // DWORD 0
               u32 wol_pattern0_pat_stall : 1;    // DWORD 0
               u32 wol_pattern0_wol : 1;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ACPI_CONTROL, *PACPI_CONTROL;

      SG_C_ASSERT(__sizeof__ACPI_CONTROL, sizeof (ACPI_CONTROL) == 4);

   #else
      typedef struct _ACPI_CONTROL {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 la_pattern3_la_en : 1;               // DWORD 0
         u32 la_pattern2_la_en : 1;               // DWORD 0
         u32 la_pattern1_la_en : 1;               // DWORD 0
         u32 la_pattern0_la_en : 1;               // DWORD 0
         u32 wol_pattern3_function : 3;           // DWORD 0
         u32 wol_pattern3_pat_stall : 1;          // DWORD 0
         u32 wol_pattern3_wol : 1;                // DWORD 0
         u32 wol_pattern2_function : 3;           // DWORD 0
         u32 wol_pattern2_pat_stall : 1;          // DWORD 0
         u32 wol_pattern2_wol : 1;                // DWORD 0
         u32 wol_pattern1_function : 3;           // DWORD 0
         u32 wol_pattern1_pat_stall : 1;          // DWORD 0
         u32 wol_pattern1_wol : 1;                // DWORD 0
         u32 wol_pattern0_function : 3;           // DWORD 0
         u32 wol_pattern0_pat_stall : 1;          // DWORD 0
         u32 wol_pattern0_wol : 1;                // DWORD 0
      } SG_PACK ACPI_CONTROL, *PACPI_CONTROL;

      typedef union _ACPI_CONTROL_UNION {
         ACPI_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK ACPI_CONTROL_UNION, *PACPI_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__ACPI_CONTROL_UNION, sizeof (ACPI_CONTROL_UNION) == 4);
   #endif


#else
   // Control bits for configuring ACPI.
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_CONTROL {
         union {
            struct { 
               u32 wol_pattern0_wol : 1;          // DWORD 0
               u32 wol_pattern0_pat_stall : 1;    // DWORD 0
               u32 wol_pattern0_function : 3;     // DWORD 0
               u32 wol_pattern1_wol : 1;          // DWORD 0
               u32 wol_pattern1_pat_stall : 1;    // DWORD 0
               u32 wol_pattern1_function : 3;     // DWORD 0
               u32 wol_pattern2_wol : 1;          // DWORD 0
               u32 wol_pattern2_pat_stall : 1;    // DWORD 0
               u32 wol_pattern2_function : 3;     // DWORD 0
               u32 wol_pattern3_wol : 1;          // DWORD 0
               u32 wol_pattern3_pat_stall : 1;    // DWORD 0
               u32 wol_pattern3_function : 3;     // DWORD 0
               u32 la_pattern0_la_en : 1;         // DWORD 0
               u32 la_pattern1_la_en : 1;         // DWORD 0
               u32 la_pattern2_la_en : 1;         // DWORD 0
               u32 la_pattern3_la_en : 1;         // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ACPI_CONTROL, *PACPI_CONTROL;

      SG_C_ASSERT(__sizeof__ACPI_CONTROL, sizeof (ACPI_CONTROL) == 4);

   #else
      typedef struct _ACPI_CONTROL {
         u32 wol_pattern0_wol : 1;                // DWORD 0
         u32 wol_pattern0_pat_stall : 1;          // DWORD 0
         u32 wol_pattern0_function : 3;           // DWORD 0
         u32 wol_pattern1_wol : 1;                // DWORD 0
         u32 wol_pattern1_pat_stall : 1;          // DWORD 0
         u32 wol_pattern1_function : 3;           // DWORD 0
         u32 wol_pattern2_wol : 1;                // DWORD 0
         u32 wol_pattern2_pat_stall : 1;          // DWORD 0
         u32 wol_pattern2_function : 3;           // DWORD 0
         u32 wol_pattern3_wol : 1;                // DWORD 0
         u32 wol_pattern3_pat_stall : 1;          // DWORD 0
         u32 wol_pattern3_function : 3;           // DWORD 0
         u32 la_pattern0_la_en : 1;               // DWORD 0
         u32 la_pattern1_la_en : 1;               // DWORD 0
         u32 la_pattern2_la_en : 1;               // DWORD 0
         u32 la_pattern3_la_en : 1;               // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK ACPI_CONTROL, *PACPI_CONTROL;

      typedef union _ACPI_CONTROL_UNION {
         ACPI_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK ACPI_CONTROL_UNION, *PACPI_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__ACPI_CONTROL_UNION, sizeof (ACPI_CONTROL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ACPI Byte Pattern.</p>
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_TABLE {
         union {
            struct { 
               struct {
                  u32 bytes[32];                  // DWORDS 0 to 31
               } byte_pattern[4];
               struct {
                  u32 mask[4];                    // DWORDS 32 to 35
               } bit_pattern[4];
               ACPI_CONTROL control;
            } SG_PACK ; // unnamed struct
            u32 dw[145]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_TABLE, *PACPI_TABLE;

      SG_C_ASSERT(__sizeof__ACPI_TABLE, sizeof (ACPI_TABLE) == 580);

   #else
      typedef struct _ACPI_TABLE {
         struct {
            u32 bytes[32];                        // DWORDS 0 to 31
         } byte_pattern[4];
         struct {
            u32 mask[4];                          // DWORDS 32 to 35
         } bit_pattern[4];
         ACPI_CONTROL control;
      } SG_PACK ACPI_TABLE, *PACPI_TABLE;

      typedef union _ACPI_TABLE_UNION {
         ACPI_TABLE bits;
         u32 dw[145]; // dword union
      } SG_PACK ACPI_TABLE_UNION, *PACPI_TABLE_UNION;

      SG_C_ASSERT(__sizeof__ACPI_TABLE_UNION, sizeof (ACPI_TABLE_UNION) == 580);
   #endif


#else
   // ACPI Byte Pattern.</p>
   #if defined(SG_BMAP_UNION)
      typedef struct _ACPI_TABLE {
         union {
            struct { 
               struct {
                  u32 bytes[32];                  // DWORDS 0 to 31
               } byte_pattern[4];
               struct {
                  u32 mask[4];                    // DWORDS 32 to 35
               } bit_pattern[4];
               ACPI_CONTROL control;
            } SG_PACK ; // unnamed struct
            u32 dw[145]; // dword union
         }; // unnamed union
      } SG_PACK ACPI_TABLE, *PACPI_TABLE;

      SG_C_ASSERT(__sizeof__ACPI_TABLE, sizeof (ACPI_TABLE) == 580);

   #else
      typedef struct _ACPI_TABLE {
         struct {
            u32 bytes[32];                        // DWORDS 0 to 31
         } byte_pattern[4];
         struct {
            u32 mask[4];                          // DWORDS 32 to 35
         } bit_pattern[4];
         ACPI_CONTROL control;
      } SG_PACK ACPI_TABLE, *PACPI_TABLE;

      typedef union _ACPI_TABLE_UNION {
         ACPI_TABLE bits;
         u32 dw[145]; // dword union
      } SG_PACK ACPI_TABLE_UNION, *PACPI_TABLE_UNION;

      SG_C_ASSERT(__sizeof__ACPI_TABLE_UNION, sizeof (ACPI_TABLE_UNION) == 580);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure defines a single offloaded connection entry in the Offload Connection
   // Table for IPv4 packets. 
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOAD_CXN_IPV4_ENTRY {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 mac_id : 6;                    // DWORD 0
               u32 dstPort : 16;                  // DWORD 1
               u32 srcPort : 16;                  // DWORD 1
               u32 srcAddr;                       // DWORD 2
               u32 dstAddr;                       // DWORD 3
               u32 rsvd1[3];                      // DWORDS 4 to 6
               u32 valid : 1;                     // DWORD 7
               u32 rsvd3 : 21;                    // DWORD 7
               u32 ct1 : 2;                       // DWORD 7
               u32 rsvd2 : 6;                     // DWORD 7
               u32 ct0 : 2;                       // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOAD_CXN_IPV4_ENTRY, *POFFLOAD_CXN_IPV4_ENTRY;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_IPV4_ENTRY, sizeof (OFFLOAD_CXN_IPV4_ENTRY) == 32);

   #else
      typedef struct _OFFLOAD_CXN_IPV4_ENTRY {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 mac_id : 6;                          // DWORD 0
         u32 dstPort : 16;                        // DWORD 1
         u32 srcPort : 16;                        // DWORD 1
         u32 srcAddr;                             // DWORD 2
         u32 dstAddr;                             // DWORD 3
         u32 rsvd1[3];                            // DWORDS 4 to 6
         u32 valid : 1;                           // DWORD 7
         u32 rsvd3 : 21;                          // DWORD 7
         u32 ct1 : 2;                             // DWORD 7
         u32 rsvd2 : 6;                           // DWORD 7
         u32 ct0 : 2;                             // DWORD 7
      } SG_PACK OFFLOAD_CXN_IPV4_ENTRY, *POFFLOAD_CXN_IPV4_ENTRY;

      typedef union _OFFLOAD_CXN_IPV4_ENTRY_UNION {
         OFFLOAD_CXN_IPV4_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK OFFLOAD_CXN_IPV4_ENTRY_UNION, *POFFLOAD_CXN_IPV4_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_IPV4_ENTRY_UNION, sizeof (OFFLOAD_CXN_IPV4_ENTRY_UNION) == 32);
   #endif


#else
   // This structure defines a single offloaded connection entry in the Offload Connection
   // Table for IPv4 packets. 
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOAD_CXN_IPV4_ENTRY {
         union {
            struct { 
               u32 mac_id : 6;                    // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
               u32 srcPort : 16;                  // DWORD 1
               u32 dstPort : 16;                  // DWORD 1
               u32 srcAddr;                       // DWORD 2
               u32 dstAddr;                       // DWORD 3
               u32 rsvd1[3];                      // DWORDS 4 to 6
               u32 ct0 : 2;                       // DWORD 7
               u32 rsvd2 : 6;                     // DWORD 7
               u32 ct1 : 2;                       // DWORD 7
               u32 rsvd3 : 21;                    // DWORD 7
               u32 valid : 1;                     // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOAD_CXN_IPV4_ENTRY, *POFFLOAD_CXN_IPV4_ENTRY;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_IPV4_ENTRY, sizeof (OFFLOAD_CXN_IPV4_ENTRY) == 32);

   #else
      typedef struct _OFFLOAD_CXN_IPV4_ENTRY {
         u32 mac_id : 6;                          // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
         u32 srcPort : 16;                        // DWORD 1
         u32 dstPort : 16;                        // DWORD 1
         u32 srcAddr;                             // DWORD 2
         u32 dstAddr;                             // DWORD 3
         u32 rsvd1[3];                            // DWORDS 4 to 6
         u32 ct0 : 2;                             // DWORD 7
         u32 rsvd2 : 6;                           // DWORD 7
         u32 ct1 : 2;                             // DWORD 7
         u32 rsvd3 : 21;                          // DWORD 7
         u32 valid : 1;                           // DWORD 7
      } SG_PACK OFFLOAD_CXN_IPV4_ENTRY, *POFFLOAD_CXN_IPV4_ENTRY;

      typedef union _OFFLOAD_CXN_IPV4_ENTRY_UNION {
         OFFLOAD_CXN_IPV4_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK OFFLOAD_CXN_IPV4_ENTRY_UNION, *POFFLOAD_CXN_IPV4_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_IPV4_ENTRY_UNION, sizeof (OFFLOAD_CXN_IPV4_ENTRY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure defines a single offloaded connection entry in the Offload Connection
   // Table for IPv4 packets. 
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOAD_CXN_IPV6_ENTRY {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 mac_id : 6;                    // DWORD 0
               u32 dstPort : 16;                  // DWORD 1
               u32 srcPort : 16;                  // DWORD 1
               u32 srcAddr[4];                    // DWORDS 2 to 5
               u32 rsvd1 : 26;                    // DWORD 6
               u32 DA_ID : 6;                     // DWORD 6
               u32 valid : 1;                     // DWORD 7
               u32 rsvd3 : 21;                    // DWORD 7
               u32 ct1 : 2;                       // DWORD 7
               u32 rsvd2 : 6;                     // DWORD 7
               u32 ct0 : 2;                       // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOAD_CXN_IPV6_ENTRY, *POFFLOAD_CXN_IPV6_ENTRY;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_IPV6_ENTRY, sizeof (OFFLOAD_CXN_IPV6_ENTRY) == 32);

   #else
      typedef struct _OFFLOAD_CXN_IPV6_ENTRY {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 mac_id : 6;                          // DWORD 0
         u32 dstPort : 16;                        // DWORD 1
         u32 srcPort : 16;                        // DWORD 1
         u32 srcAddr[4];                          // DWORDS 2 to 5
         u32 rsvd1 : 26;                          // DWORD 6
         u32 DA_ID : 6;                           // DWORD 6
         u32 valid : 1;                           // DWORD 7
         u32 rsvd3 : 21;                          // DWORD 7
         u32 ct1 : 2;                             // DWORD 7
         u32 rsvd2 : 6;                           // DWORD 7
         u32 ct0 : 2;                             // DWORD 7
      } SG_PACK OFFLOAD_CXN_IPV6_ENTRY, *POFFLOAD_CXN_IPV6_ENTRY;

      typedef union _OFFLOAD_CXN_IPV6_ENTRY_UNION {
         OFFLOAD_CXN_IPV6_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK OFFLOAD_CXN_IPV6_ENTRY_UNION, *POFFLOAD_CXN_IPV6_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_IPV6_ENTRY_UNION, sizeof (OFFLOAD_CXN_IPV6_ENTRY_UNION) == 32);
   #endif


#else
   // This structure defines a single offloaded connection entry in the Offload Connection
   // Table for IPv4 packets. 
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOAD_CXN_IPV6_ENTRY {
         union {
            struct { 
               u32 mac_id : 6;                    // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
               u32 srcPort : 16;                  // DWORD 1
               u32 dstPort : 16;                  // DWORD 1
               u32 srcAddr[4];                    // DWORDS 2 to 5
               u32 DA_ID : 6;                     // DWORD 6
               u32 rsvd1 : 26;                    // DWORD 6
               u32 ct0 : 2;                       // DWORD 7
               u32 rsvd2 : 6;                     // DWORD 7
               u32 ct1 : 2;                       // DWORD 7
               u32 rsvd3 : 21;                    // DWORD 7
               u32 valid : 1;                     // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOAD_CXN_IPV6_ENTRY, *POFFLOAD_CXN_IPV6_ENTRY;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_IPV6_ENTRY, sizeof (OFFLOAD_CXN_IPV6_ENTRY) == 32);

   #else
      typedef struct _OFFLOAD_CXN_IPV6_ENTRY {
         u32 mac_id : 6;                          // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
         u32 srcPort : 16;                        // DWORD 1
         u32 dstPort : 16;                        // DWORD 1
         u32 srcAddr[4];                          // DWORDS 2 to 5
         u32 DA_ID : 6;                           // DWORD 6
         u32 rsvd1 : 26;                          // DWORD 6
         u32 ct0 : 2;                             // DWORD 7
         u32 rsvd2 : 6;                           // DWORD 7
         u32 ct1 : 2;                             // DWORD 7
         u32 rsvd3 : 21;                          // DWORD 7
         u32 valid : 1;                           // DWORD 7
      } SG_PACK OFFLOAD_CXN_IPV6_ENTRY, *POFFLOAD_CXN_IPV6_ENTRY;

      typedef union _OFFLOAD_CXN_IPV6_ENTRY_UNION {
         OFFLOAD_CXN_IPV6_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK OFFLOAD_CXN_IPV6_ENTRY_UNION, *POFFLOAD_CXN_IPV6_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_IPV6_ENTRY_UNION, sizeof (OFFLOAD_CXN_IPV6_ENTRY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOAD_CXN_ENTRY {
         union {
            union { 
               OFFLOAD_CXN_IPV4_ENTRY ipv4;
               OFFLOAD_CXN_IPV6_ENTRY ipv6;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOAD_CXN_ENTRY, *POFFLOAD_CXN_ENTRY;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_ENTRY, sizeof (OFFLOAD_CXN_ENTRY) == 32);

   #else
      typedef union _OFFLOAD_CXN_ENTRY {
         OFFLOAD_CXN_IPV4_ENTRY ipv4;
         OFFLOAD_CXN_IPV6_ENTRY ipv6;
      } SG_PACK OFFLOAD_CXN_ENTRY, *POFFLOAD_CXN_ENTRY;

      typedef union _OFFLOAD_CXN_ENTRY_UNION {
         OFFLOAD_CXN_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK OFFLOAD_CXN_ENTRY_UNION, *POFFLOAD_CXN_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_ENTRY_UNION, sizeof (OFFLOAD_CXN_ENTRY_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOAD_CXN_ENTRY {
         union {
            union { 
               OFFLOAD_CXN_IPV4_ENTRY ipv4;
               OFFLOAD_CXN_IPV6_ENTRY ipv6;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOAD_CXN_ENTRY, *POFFLOAD_CXN_ENTRY;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_ENTRY, sizeof (OFFLOAD_CXN_ENTRY) == 32);

   #else
      typedef union _OFFLOAD_CXN_ENTRY {
         OFFLOAD_CXN_IPV4_ENTRY ipv4;
         OFFLOAD_CXN_IPV6_ENTRY ipv6;
      } SG_PACK OFFLOAD_CXN_ENTRY, *POFFLOAD_CXN_ENTRY;

      typedef union _OFFLOAD_CXN_ENTRY_UNION {
         OFFLOAD_CXN_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK OFFLOAD_CXN_ENTRY_UNION, *POFFLOAD_CXN_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__OFFLOAD_CXN_ENTRY_UNION, sizeof (OFFLOAD_CXN_ENTRY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXF Offloaded Connection Table.
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOADED_CXN_TABLE {
         union {
            struct { 
               OFFLOAD_CXN_ENTRY cxn[1024];
            } SG_PACK ; // unnamed struct
            u32 dw[8192]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOADED_CXN_TABLE, *POFFLOADED_CXN_TABLE;

      SG_C_ASSERT(__sizeof__OFFLOADED_CXN_TABLE, sizeof (OFFLOADED_CXN_TABLE) == 32768);

   #else
      typedef struct _OFFLOADED_CXN_TABLE {
         OFFLOAD_CXN_ENTRY cxn[1024];
      } SG_PACK OFFLOADED_CXN_TABLE, *POFFLOADED_CXN_TABLE;

      typedef union _OFFLOADED_CXN_TABLE_UNION {
         OFFLOADED_CXN_TABLE bits;
         u32 dw[8192]; // dword union
      } SG_PACK OFFLOADED_CXN_TABLE_UNION, *POFFLOADED_CXN_TABLE_UNION;

      SG_C_ASSERT(__sizeof__OFFLOADED_CXN_TABLE_UNION, sizeof (OFFLOADED_CXN_TABLE_UNION) == 32768);
   #endif


#else
   // RXF Offloaded Connection Table.
   #if defined(SG_BMAP_UNION)
      typedef struct _OFFLOADED_CXN_TABLE {
         union {
            struct { 
               OFFLOAD_CXN_ENTRY cxn[1024];
            } SG_PACK ; // unnamed struct
            u32 dw[8192]; // dword union
         }; // unnamed union
      } SG_PACK OFFLOADED_CXN_TABLE, *POFFLOADED_CXN_TABLE;

      SG_C_ASSERT(__sizeof__OFFLOADED_CXN_TABLE, sizeof (OFFLOADED_CXN_TABLE) == 32768);

   #else
      typedef struct _OFFLOADED_CXN_TABLE {
         OFFLOAD_CXN_ENTRY cxn[1024];
      } SG_PACK OFFLOADED_CXN_TABLE, *POFFLOADED_CXN_TABLE;

      typedef union _OFFLOADED_CXN_TABLE_UNION {
         OFFLOADED_CXN_TABLE bits;
         u32 dw[8192]; // dword union
      } SG_PACK OFFLOADED_CXN_TABLE_UNION, *POFFLOADED_CXN_TABLE_UNION;

      SG_C_ASSERT(__sizeof__OFFLOADED_CXN_TABLE_UNION, sizeof (OFFLOADED_CXN_TABLE_UNION) == 32768);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AXGMAC_CFG1_REG {
         union {
            struct { 
               u32 hsttctlen : 1;                 // DWORD 0
               u32 hsttfen : 1;                   // DWORD 0
               u32 hstrctlen : 1;                 // DWORD 0
               u32 hstrfen : 1;                   // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AXGMAC_CFG1_REG, *PAXGMAC_CFG1_REG;

      SG_C_ASSERT(__sizeof__AXGMAC_CFG1_REG, sizeof (AXGMAC_CFG1_REG) == 4);

   #else
      typedef struct _AXGMAC_CFG1_REG {
         u32 hsttctlen : 1;                       // DWORD 0
         u32 hsttfen : 1;                         // DWORD 0
         u32 hstrctlen : 1;                       // DWORD 0
         u32 hstrfen : 1;                         // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK AXGMAC_CFG1_REG, *PAXGMAC_CFG1_REG;

      typedef union _AXGMAC_CFG1_REG_UNION {
         AXGMAC_CFG1_REG bits;
         u32 dw; // dword union
      } SG_PACK AXGMAC_CFG1_REG_UNION, *PAXGMAC_CFG1_REG_UNION;

      SG_C_ASSERT(__sizeof__AXGMAC_CFG1_REG_UNION, sizeof (AXGMAC_CFG1_REG_UNION) == 4);
   #endif


#else
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AXGMAC_CFG1_REG {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 hstrfen : 1;                   // DWORD 0
               u32 hstrctlen : 1;                 // DWORD 0
               u32 hsttfen : 1;                   // DWORD 0
               u32 hsttctlen : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AXGMAC_CFG1_REG, *PAXGMAC_CFG1_REG;

      SG_C_ASSERT(__sizeof__AXGMAC_CFG1_REG, sizeof (AXGMAC_CFG1_REG) == 4);

   #else
      typedef struct _AXGMAC_CFG1_REG {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 hstrfen : 1;                         // DWORD 0
         u32 hstrctlen : 1;                       // DWORD 0
         u32 hsttfen : 1;                         // DWORD 0
         u32 hsttctlen : 1;                       // DWORD 0
      } SG_PACK AXGMAC_CFG1_REG, *PAXGMAC_CFG1_REG;

      typedef union _AXGMAC_CFG1_REG_UNION {
         AXGMAC_CFG1_REG bits;
         u32 dw; // dword union
      } SG_PACK AXGMAC_CFG1_REG_UNION, *PAXGMAC_CFG1_REG_UNION;

      SG_C_ASSERT(__sizeof__AXGMAC_CFG1_REG_UNION, sizeof (AXGMAC_CFG1_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AXGMAC_CFG2_REG {
         union {
            struct { 
               u32 rsvd1 : 6;                     // DWORD 0
               u32 rflnkflt : 2;                  // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AXGMAC_CFG2_REG, *PAXGMAC_CFG2_REG;

      SG_C_ASSERT(__sizeof__AXGMAC_CFG2_REG, sizeof (AXGMAC_CFG2_REG) == 4);

   #else
      typedef struct _AXGMAC_CFG2_REG {
         u32 rsvd1 : 6;                           // DWORD 0
         u32 rflnkflt : 2;                        // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK AXGMAC_CFG2_REG, *PAXGMAC_CFG2_REG;

      typedef union _AXGMAC_CFG2_REG_UNION {
         AXGMAC_CFG2_REG bits;
         u32 dw; // dword union
      } SG_PACK AXGMAC_CFG2_REG_UNION, *PAXGMAC_CFG2_REG_UNION;

      SG_C_ASSERT(__sizeof__AXGMAC_CFG2_REG_UNION, sizeof (AXGMAC_CFG2_REG_UNION) == 4);
   #endif


#else
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AXGMAC_CFG2_REG {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 rflnkflt : 2;                  // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AXGMAC_CFG2_REG, *PAXGMAC_CFG2_REG;

      SG_C_ASSERT(__sizeof__AXGMAC_CFG2_REG, sizeof (AXGMAC_CFG2_REG) == 4);

   #else
      typedef struct _AXGMAC_CFG2_REG {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 rflnkflt : 2;                        // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
      } SG_PACK AXGMAC_CFG2_REG, *PAXGMAC_CFG2_REG;

      typedef union _AXGMAC_CFG2_REG_UNION {
         AXGMAC_CFG2_REG bits;
         u32 dw; // dword union
      } SG_PACK AXGMAC_CFG2_REG_UNION, *PAXGMAC_CFG2_REG_UNION;

      SG_C_ASSERT(__sizeof__AXGMAC_CFG2_REG_UNION, sizeof (AXGMAC_CFG2_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AXGMAC_FRAME_LENGTH_REG {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 hstmxfrmwctx : 14;             // DWORD 0
               u32 hstmxfrmbcrx : 16;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AXGMAC_FRAME_LENGTH_REG, *PAXGMAC_FRAME_LENGTH_REG;

      SG_C_ASSERT(__sizeof__AXGMAC_FRAME_LENGTH_REG, sizeof (AXGMAC_FRAME_LENGTH_REG) == 4);

   #else
      typedef struct _AXGMAC_FRAME_LENGTH_REG {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 hstmxfrmwctx : 14;                   // DWORD 0
         u32 hstmxfrmbcrx : 16;                   // DWORD 0
      } SG_PACK AXGMAC_FRAME_LENGTH_REG, *PAXGMAC_FRAME_LENGTH_REG;

      typedef union _AXGMAC_FRAME_LENGTH_REG_UNION {
         AXGMAC_FRAME_LENGTH_REG bits;
         u32 dw; // dword union
      } SG_PACK AXGMAC_FRAME_LENGTH_REG_UNION, *PAXGMAC_FRAME_LENGTH_REG_UNION;

      SG_C_ASSERT(__sizeof__AXGMAC_FRAME_LENGTH_REG_UNION, sizeof (AXGMAC_FRAME_LENGTH_REG_UNION) == 4);
   #endif


#else
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AXGMAC_FRAME_LENGTH_REG {
         union {
            struct { 
               u32 hstmxfrmbcrx : 16;             // DWORD 0
               u32 hstmxfrmwctx : 14;             // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AXGMAC_FRAME_LENGTH_REG, *PAXGMAC_FRAME_LENGTH_REG;

      SG_C_ASSERT(__sizeof__AXGMAC_FRAME_LENGTH_REG, sizeof (AXGMAC_FRAME_LENGTH_REG) == 4);

   #else
      typedef struct _AXGMAC_FRAME_LENGTH_REG {
         u32 hstmxfrmbcrx : 16;                   // DWORD 0
         u32 hstmxfrmwctx : 14;                   // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK AXGMAC_FRAME_LENGTH_REG, *PAXGMAC_FRAME_LENGTH_REG;

      typedef union _AXGMAC_FRAME_LENGTH_REG_UNION {
         AXGMAC_FRAME_LENGTH_REG bits;
         u32 dw; // dword union
      } SG_PACK AXGMAC_FRAME_LENGTH_REG_UNION, *PAXGMAC_FRAME_LENGTH_REG_UNION;

      SG_C_ASSERT(__sizeof__AXGMAC_FRAME_LENGTH_REG_UNION, sizeof (AXGMAC_FRAME_LENGTH_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AMIIM_CMD_REG {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 hstldcmd : 1;                  // DWORD 0
               u32 hstmiimcmd : 3;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AMIIM_CMD_REG, *PAMIIM_CMD_REG;

      SG_C_ASSERT(__sizeof__AMIIM_CMD_REG, sizeof (AMIIM_CMD_REG) == 4);

   #else
      typedef struct _AMIIM_CMD_REG {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 hstldcmd : 1;                        // DWORD 0
         u32 hstmiimcmd : 3;                      // DWORD 0
      } SG_PACK AMIIM_CMD_REG, *PAMIIM_CMD_REG;

      typedef union _AMIIM_CMD_REG_UNION {
         AMIIM_CMD_REG bits;
         u32 dw; // dword union
      } SG_PACK AMIIM_CMD_REG_UNION, *PAMIIM_CMD_REG_UNION;

      SG_C_ASSERT(__sizeof__AMIIM_CMD_REG_UNION, sizeof (AMIIM_CMD_REG_UNION) == 4);
   #endif


#else
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AMIIM_CMD_REG {
         union {
            struct { 
               u32 hstmiimcmd : 3;                // DWORD 0
               u32 hstldcmd : 1;                  // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AMIIM_CMD_REG, *PAMIIM_CMD_REG;

      SG_C_ASSERT(__sizeof__AMIIM_CMD_REG, sizeof (AMIIM_CMD_REG) == 4);

   #else
      typedef struct _AMIIM_CMD_REG {
         u32 hstmiimcmd : 3;                      // DWORD 0
         u32 hstldcmd : 1;                        // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK AMIIM_CMD_REG, *PAMIIM_CMD_REG;

      typedef union _AMIIM_CMD_REG_UNION {
         AMIIM_CMD_REG bits;
         u32 dw; // dword union
      } SG_PACK AMIIM_CMD_REG_UNION, *PAMIIM_CMD_REG_UNION;

      SG_C_ASSERT(__sizeof__AMIIM_CMD_REG_UNION, sizeof (AMIIM_CMD_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AMIIM_FIELD_REG {
         union {
            struct { 
               u32 hststfield : 2;                // DWORD 0
               u32 hstopfield : 2;                // DWORD 0
               u32 hstphyadx : 5;                 // DWORD 0
               u32 hstregadx : 5;                 // DWORD 0
               u32 hsttafield : 2;                // DWORD 0
               u32 hstmiimwrdat : 16;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AMIIM_FIELD_REG, *PAMIIM_FIELD_REG;

      SG_C_ASSERT(__sizeof__AMIIM_FIELD_REG, sizeof (AMIIM_FIELD_REG) == 4);

   #else
      typedef struct _AMIIM_FIELD_REG {
         u32 hststfield : 2;                      // DWORD 0
         u32 hstopfield : 2;                      // DWORD 0
         u32 hstphyadx : 5;                       // DWORD 0
         u32 hstregadx : 5;                       // DWORD 0
         u32 hsttafield : 2;                      // DWORD 0
         u32 hstmiimwrdat : 16;                   // DWORD 0
      } SG_PACK AMIIM_FIELD_REG, *PAMIIM_FIELD_REG;

      typedef union _AMIIM_FIELD_REG_UNION {
         AMIIM_FIELD_REG bits;
         u32 dw; // dword union
      } SG_PACK AMIIM_FIELD_REG_UNION, *PAMIIM_FIELD_REG_UNION;

      SG_C_ASSERT(__sizeof__AMIIM_FIELD_REG_UNION, sizeof (AMIIM_FIELD_REG_UNION) == 4);
   #endif


#else
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AMIIM_FIELD_REG {
         union {
            struct { 
               u32 hstmiimwrdat : 16;             // DWORD 0
               u32 hsttafield : 2;                // DWORD 0
               u32 hstregadx : 5;                 // DWORD 0
               u32 hstphyadx : 5;                 // DWORD 0
               u32 hstopfield : 2;                // DWORD 0
               u32 hststfield : 2;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AMIIM_FIELD_REG, *PAMIIM_FIELD_REG;

      SG_C_ASSERT(__sizeof__AMIIM_FIELD_REG, sizeof (AMIIM_FIELD_REG) == 4);

   #else
      typedef struct _AMIIM_FIELD_REG {
         u32 hstmiimwrdat : 16;                   // DWORD 0
         u32 hsttafield : 2;                      // DWORD 0
         u32 hstregadx : 5;                       // DWORD 0
         u32 hstphyadx : 5;                       // DWORD 0
         u32 hstopfield : 2;                      // DWORD 0
         u32 hststfield : 2;                      // DWORD 0
      } SG_PACK AMIIM_FIELD_REG, *PAMIIM_FIELD_REG;

      typedef union _AMIIM_FIELD_REG_UNION {
         AMIIM_FIELD_REG bits;
         u32 dw; // dword union
      } SG_PACK AMIIM_FIELD_REG_UNION, *PAMIIM_FIELD_REG_UNION;

      SG_C_ASSERT(__sizeof__AMIIM_FIELD_REG_UNION, sizeof (AMIIM_FIELD_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AMIIM_INDICATOR_REG {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 miimphylf : 1;                 // DWORD 0
               u32 miimmoncplt : 1;               // DWORD 0
               u32 miimmonvld : 1;                // DWORD 0
               u32 miimmon : 1;                   // DWORD 0
               u32 miimbusy : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AMIIM_INDICATOR_REG, *PAMIIM_INDICATOR_REG;

      SG_C_ASSERT(__sizeof__AMIIM_INDICATOR_REG, sizeof (AMIIM_INDICATOR_REG) == 4);

   #else
      typedef struct _AMIIM_INDICATOR_REG {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 miimphylf : 1;                       // DWORD 0
         u32 miimmoncplt : 1;                     // DWORD 0
         u32 miimmonvld : 1;                      // DWORD 0
         u32 miimmon : 1;                         // DWORD 0
         u32 miimbusy : 1;                        // DWORD 0
      } SG_PACK AMIIM_INDICATOR_REG, *PAMIIM_INDICATOR_REG;

      typedef union _AMIIM_INDICATOR_REG_UNION {
         AMIIM_INDICATOR_REG bits;
         u32 dw; // dword union
      } SG_PACK AMIIM_INDICATOR_REG_UNION, *PAMIIM_INDICATOR_REG_UNION;

      SG_C_ASSERT(__sizeof__AMIIM_INDICATOR_REG_UNION, sizeof (AMIIM_INDICATOR_REG_UNION) == 4);
   #endif


#else
   // See the axgmac.pdf file.
   #if defined(SG_BMAP_UNION)
      typedef struct _AMIIM_INDICATOR_REG {
         union {
            struct { 
               u32 miimbusy : 1;                  // DWORD 0
               u32 miimmon : 1;                   // DWORD 0
               u32 miimmonvld : 1;                // DWORD 0
               u32 miimmoncplt : 1;               // DWORD 0
               u32 miimphylf : 1;                 // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK AMIIM_INDICATOR_REG, *PAMIIM_INDICATOR_REG;

      SG_C_ASSERT(__sizeof__AMIIM_INDICATOR_REG, sizeof (AMIIM_INDICATOR_REG) == 4);

   #else
      typedef struct _AMIIM_INDICATOR_REG {
         u32 miimbusy : 1;                        // DWORD 0
         u32 miimmon : 1;                         // DWORD 0
         u32 miimmonvld : 1;                      // DWORD 0
         u32 miimmoncplt : 1;                     // DWORD 0
         u32 miimphylf : 1;                       // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK AMIIM_INDICATOR_REG, *PAMIIM_INDICATOR_REG;

      typedef union _AMIIM_INDICATOR_REG_UNION {
         AMIIM_INDICATOR_REG bits;
         u32 dw; // dword union
      } SG_PACK AMIIM_INDICATOR_REG_UNION, *PAMIIM_INDICATOR_REG_UNION;

      SG_C_ASSERT(__sizeof__AMIIM_INDICATOR_REG_UNION, sizeof (AMIIM_INDICATOR_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This table lists the valid MAC registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_REGISTER_TABLE {
         union {
            struct { 
               u32 config0;                       // DWORD 0
               u32 config1;                       // DWORD 1
               u32 config2;                       // DWORD 2
               u32 config3;                       // DWORD 3
               u32 mac_lo;                        // DWORD 4
               u32 mac_hi;                        // DWORD 5
               u32 rsvd0[2];                      // DWORDS 6 to 7
               u32 maxFrameSize;                  // DWORD 8
               u32 rsvd1[2];                      // DWORDS 9 to 10
               u32 revision;                      // DWORD 11
               u32 rsvd2[4];                      // DWORDS 12 to 15
               AMIIM_CMD_REG amiim_cmd;
               AMIIM_FIELD_REG amiim_field;
               u32 amiim_config;                  // DWORD 18
               u32 amiim_lnk_fail;                // DWORD 19
               AMIIM_INDICATOR_REG amiim_indicator;
            } SG_PACK ; // unnamed struct
            u32 dw[21]; // dword union
         }; // unnamed union
      } SG_PACK MAC_REGISTER_TABLE, *PMAC_REGISTER_TABLE;

      SG_C_ASSERT(__sizeof__MAC_REGISTER_TABLE, sizeof (MAC_REGISTER_TABLE) == 84);

   #else
      typedef struct _MAC_REGISTER_TABLE {
         u32 config0;                             // DWORD 0
         u32 config1;                             // DWORD 1
         u32 config2;                             // DWORD 2
         u32 config3;                             // DWORD 3
         u32 mac_lo;                              // DWORD 4
         u32 mac_hi;                              // DWORD 5
         u32 rsvd0[2];                            // DWORDS 6 to 7
         u32 maxFrameSize;                        // DWORD 8
         u32 rsvd1[2];                            // DWORDS 9 to 10
         u32 revision;                            // DWORD 11
         u32 rsvd2[4];                            // DWORDS 12 to 15
         AMIIM_CMD_REG amiim_cmd;
         AMIIM_FIELD_REG amiim_field;
         u32 amiim_config;                        // DWORD 18
         u32 amiim_lnk_fail;                      // DWORD 19
         AMIIM_INDICATOR_REG amiim_indicator;
      } SG_PACK MAC_REGISTER_TABLE, *PMAC_REGISTER_TABLE;

      typedef union _MAC_REGISTER_TABLE_UNION {
         MAC_REGISTER_TABLE bits;
         u32 dw[21]; // dword union
      } SG_PACK MAC_REGISTER_TABLE_UNION, *PMAC_REGISTER_TABLE_UNION;

      SG_C_ASSERT(__sizeof__MAC_REGISTER_TABLE_UNION, sizeof (MAC_REGISTER_TABLE_UNION) == 84);
   #endif


#else
   // This table lists the valid MAC registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAC_REGISTER_TABLE {
         union {
            struct { 
               u32 config0;                       // DWORD 0
               u32 config1;                       // DWORD 1
               u32 config2;                       // DWORD 2
               u32 config3;                       // DWORD 3
               u32 mac_lo;                        // DWORD 4
               u32 mac_hi;                        // DWORD 5
               u32 rsvd0[2];                      // DWORDS 6 to 7
               u32 maxFrameSize;                  // DWORD 8
               u32 rsvd1[2];                      // DWORDS 9 to 10
               u32 revision;                      // DWORD 11
               u32 rsvd2[4];                      // DWORDS 12 to 15
               AMIIM_CMD_REG amiim_cmd;
               AMIIM_FIELD_REG amiim_field;
               u32 amiim_config;                  // DWORD 18
               u32 amiim_lnk_fail;                // DWORD 19
               AMIIM_INDICATOR_REG amiim_indicator;
            } SG_PACK ; // unnamed struct
            u32 dw[21]; // dword union
         }; // unnamed union
      } SG_PACK MAC_REGISTER_TABLE, *PMAC_REGISTER_TABLE;

      SG_C_ASSERT(__sizeof__MAC_REGISTER_TABLE, sizeof (MAC_REGISTER_TABLE) == 84);

   #else
      typedef struct _MAC_REGISTER_TABLE {
         u32 config0;                             // DWORD 0
         u32 config1;                             // DWORD 1
         u32 config2;                             // DWORD 2
         u32 config3;                             // DWORD 3
         u32 mac_lo;                              // DWORD 4
         u32 mac_hi;                              // DWORD 5
         u32 rsvd0[2];                            // DWORDS 6 to 7
         u32 maxFrameSize;                        // DWORD 8
         u32 rsvd1[2];                            // DWORDS 9 to 10
         u32 revision;                            // DWORD 11
         u32 rsvd2[4];                            // DWORDS 12 to 15
         AMIIM_CMD_REG amiim_cmd;
         AMIIM_FIELD_REG amiim_field;
         u32 amiim_config;                        // DWORD 18
         u32 amiim_lnk_fail;                      // DWORD 19
         AMIIM_INDICATOR_REG amiim_indicator;
      } SG_PACK MAC_REGISTER_TABLE, *PMAC_REGISTER_TABLE;

      typedef union _MAC_REGISTER_TABLE_UNION {
         MAC_REGISTER_TABLE bits;
         u32 dw[21]; // dword union
      } SG_PACK MAC_REGISTER_TABLE_UNION, *PMAC_REGISTER_TABLE_UNION;

      SG_C_ASSERT(__sizeof__MAC_REGISTER_TABLE_UNION, sizeof (MAC_REGISTER_TABLE_UNION) == 84);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // 10/100 Management MAC Register Interface.
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_MAC_REGISTER_TABLE {
         union {
            struct { 
               u32 config1;                       // DWORD 0
               u32 config2;                       // DWORD 1
               u32 b2b_ipg;                       // DWORD 2
               u32 non_b2b_ipg;                   // DWORD 3
               u32 collision;                     // DWORD 4
               u32 maxPacketLength;               // DWORD 5
               u32 rsvd0[15];                     // DWORDS 6 to 20
               u32 rsvd8 : 1;                     // DWORD 21
               u32 rsvd1 : 15;                    // DWORD 21
               u32 mac_hi : 16;                   // DWORD 21
               u32 mac_lo;                        // DWORD 22
               u32 pause_timer;                   // DWORD 23
               u32 rsvd2[1];                      // DWORDS 24 to 24
               u32 vlan_type;                     // DWORD 25
               u32 rsvd3[6];                      // DWORDS 26 to 31
               u32 mii_config;                    // DWORD 32
               u32 rsvd4[4];                      // DWORDS 33 to 36
               u32 mii_cmd;                       // DWORD 37
               u32 mii_addr;                      // DWORD 38
               u32 mii_write;                     // DWORD 39
               u32 mii_read;                      // DWORD 40
               u32 mii_indicator;                 // DWORD 41
               u32 rsvd5[8];                      // DWORDS 42 to 49
               u32 address_filter;                // DWORD 50
               u32 hash_table1;                   // DWORD 51
               u32 hash_table2;                   // DWORD 52
               u32 rsvd6[2];                      // DWORDS 53 to 54
               u32 carry1;                        // DWORD 55
               u32 carry2;                        // DWORD 56
               u32 rsvd7[19];                     // DWORDS 57 to 75
               u32 carrymask1;                    // DWORD 76
               u32 carrymask2;                    // DWORD 77
            } SG_PACK ; // unnamed struct
            u32 dw[78]; // dword union
         }; // unnamed union
      } SG_PACK MGMT_MAC_REGISTER_TABLE, *PMGMT_MAC_REGISTER_TABLE;

      SG_C_ASSERT(__sizeof__MGMT_MAC_REGISTER_TABLE, sizeof (MGMT_MAC_REGISTER_TABLE) == 312);

   #else
      typedef struct _MGMT_MAC_REGISTER_TABLE {
         u32 config1;                             // DWORD 0
         u32 config2;                             // DWORD 1
         u32 b2b_ipg;                             // DWORD 2
         u32 non_b2b_ipg;                         // DWORD 3
         u32 collision;                           // DWORD 4
         u32 maxPacketLength;                     // DWORD 5
         u32 rsvd0[15];                           // DWORDS 6 to 20
         u32 rsvd8 : 1;                           // DWORD 21
         u32 rsvd1 : 15;                          // DWORD 21
         u32 mac_hi : 16;                         // DWORD 21
         u32 mac_lo;                              // DWORD 22
         u32 pause_timer;                         // DWORD 23
         u32 rsvd2[1];                            // DWORDS 24 to 24
         u32 vlan_type;                           // DWORD 25
         u32 rsvd3[6];                            // DWORDS 26 to 31
         u32 mii_config;                          // DWORD 32
         u32 rsvd4[4];                            // DWORDS 33 to 36
         u32 mii_cmd;                             // DWORD 37
         u32 mii_addr;                            // DWORD 38
         u32 mii_write;                           // DWORD 39
         u32 mii_read;                            // DWORD 40
         u32 mii_indicator;                       // DWORD 41
         u32 rsvd5[8];                            // DWORDS 42 to 49
         u32 address_filter;                      // DWORD 50
         u32 hash_table1;                         // DWORD 51
         u32 hash_table2;                         // DWORD 52
         u32 rsvd6[2];                            // DWORDS 53 to 54
         u32 carry1;                              // DWORD 55
         u32 carry2;                              // DWORD 56
         u32 rsvd7[19];                           // DWORDS 57 to 75
         u32 carrymask1;                          // DWORD 76
         u32 carrymask2;                          // DWORD 77
      } SG_PACK MGMT_MAC_REGISTER_TABLE, *PMGMT_MAC_REGISTER_TABLE;

      typedef union _MGMT_MAC_REGISTER_TABLE_UNION {
         MGMT_MAC_REGISTER_TABLE bits;
         u32 dw[78]; // dword union
      } SG_PACK MGMT_MAC_REGISTER_TABLE_UNION, *PMGMT_MAC_REGISTER_TABLE_UNION;

      SG_C_ASSERT(__sizeof__MGMT_MAC_REGISTER_TABLE_UNION, sizeof (MGMT_MAC_REGISTER_TABLE_UNION) == 312);
   #endif


#else
   // 10/100 Management MAC Register Interface.
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_MAC_REGISTER_TABLE {
         union {
            struct { 
               u32 config1;                       // DWORD 0
               u32 config2;                       // DWORD 1
               u32 b2b_ipg;                       // DWORD 2
               u32 non_b2b_ipg;                   // DWORD 3
               u32 collision;                     // DWORD 4
               u32 maxPacketLength;               // DWORD 5
               u32 rsvd0[15];                     // DWORDS 6 to 20
               u32 mac_hi : 16;                   // DWORD 21
               u32 rsvd1 : 15;                    // DWORD 21
               u32 rsvd8 : 1;                     // DWORD 21
               u32 mac_lo;                        // DWORD 22
               u32 pause_timer;                   // DWORD 23
               u32 rsvd2[1];                      // DWORDS 24 to 24
               u32 vlan_type;                     // DWORD 25
               u32 rsvd3[6];                      // DWORDS 26 to 31
               u32 mii_config;                    // DWORD 32
               u32 rsvd4[4];                      // DWORDS 33 to 36
               u32 mii_cmd;                       // DWORD 37
               u32 mii_addr;                      // DWORD 38
               u32 mii_write;                     // DWORD 39
               u32 mii_read;                      // DWORD 40
               u32 mii_indicator;                 // DWORD 41
               u32 rsvd5[8];                      // DWORDS 42 to 49
               u32 address_filter;                // DWORD 50
               u32 hash_table1;                   // DWORD 51
               u32 hash_table2;                   // DWORD 52
               u32 rsvd6[2];                      // DWORDS 53 to 54
               u32 carry1;                        // DWORD 55
               u32 carry2;                        // DWORD 56
               u32 rsvd7[19];                     // DWORDS 57 to 75
               u32 carrymask1;                    // DWORD 76
               u32 carrymask2;                    // DWORD 77
            } SG_PACK ; // unnamed struct
            u32 dw[78]; // dword union
         }; // unnamed union
      } SG_PACK MGMT_MAC_REGISTER_TABLE, *PMGMT_MAC_REGISTER_TABLE;

      SG_C_ASSERT(__sizeof__MGMT_MAC_REGISTER_TABLE, sizeof (MGMT_MAC_REGISTER_TABLE) == 312);

   #else
      typedef struct _MGMT_MAC_REGISTER_TABLE {
         u32 config1;                             // DWORD 0
         u32 config2;                             // DWORD 1
         u32 b2b_ipg;                             // DWORD 2
         u32 non_b2b_ipg;                         // DWORD 3
         u32 collision;                           // DWORD 4
         u32 maxPacketLength;                     // DWORD 5
         u32 rsvd0[15];                           // DWORDS 6 to 20
         u32 mac_hi : 16;                         // DWORD 21
         u32 rsvd1 : 15;                          // DWORD 21
         u32 rsvd8 : 1;                           // DWORD 21
         u32 mac_lo;                              // DWORD 22
         u32 pause_timer;                         // DWORD 23
         u32 rsvd2[1];                            // DWORDS 24 to 24
         u32 vlan_type;                           // DWORD 25
         u32 rsvd3[6];                            // DWORDS 26 to 31
         u32 mii_config;                          // DWORD 32
         u32 rsvd4[4];                            // DWORDS 33 to 36
         u32 mii_cmd;                             // DWORD 37
         u32 mii_addr;                            // DWORD 38
         u32 mii_write;                           // DWORD 39
         u32 mii_read;                            // DWORD 40
         u32 mii_indicator;                       // DWORD 41
         u32 rsvd5[8];                            // DWORDS 42 to 49
         u32 address_filter;                      // DWORD 50
         u32 hash_table1;                         // DWORD 51
         u32 hash_table2;                         // DWORD 52
         u32 rsvd6[2];                            // DWORDS 53 to 54
         u32 carry1;                              // DWORD 55
         u32 carry2;                              // DWORD 56
         u32 rsvd7[19];                           // DWORDS 57 to 75
         u32 carrymask1;                          // DWORD 76
         u32 carrymask2;                          // DWORD 77
      } SG_PACK MGMT_MAC_REGISTER_TABLE, *PMGMT_MAC_REGISTER_TABLE;

      typedef union _MGMT_MAC_REGISTER_TABLE_UNION {
         MGMT_MAC_REGISTER_TABLE bits;
         u32 dw[78]; // dword union
      } SG_PACK MGMT_MAC_REGISTER_TABLE_UNION, *PMGMT_MAC_REGISTER_TABLE_UNION;

      SG_C_ASSERT(__sizeof__MGMT_MAC_REGISTER_TABLE_UNION, sizeof (MGMT_MAC_REGISTER_TABLE_UNION) == 312);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RSS Secret KEY.
   #if defined(SG_BMAP_UNION)
      typedef struct _RSS_KEY_TABLE_ENTRY {
         union {
            struct { 
               u32 rsskey0;                       // DWORD 0
               u32 rsskey1;                       // DWORD 1
               u32 rsskey2;                       // DWORD 2
               u32 rsskey3;                       // DWORD 3
               u32 rsskey4;                       // DWORD 4
               u32 rsskey5;                       // DWORD 5
               u32 rsskey6;                       // DWORD 6
               u32 rsskey7;                       // DWORD 7
               u32 rsskey8;                       // DWORD 8
               u32 rsskey9;                       // DWORD 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK RSS_KEY_TABLE_ENTRY, *PRSS_KEY_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__RSS_KEY_TABLE_ENTRY, sizeof (RSS_KEY_TABLE_ENTRY) == 40);

   #else
      typedef struct _RSS_KEY_TABLE_ENTRY {
         u32 rsskey0;                             // DWORD 0
         u32 rsskey1;                             // DWORD 1
         u32 rsskey2;                             // DWORD 2
         u32 rsskey3;                             // DWORD 3
         u32 rsskey4;                             // DWORD 4
         u32 rsskey5;                             // DWORD 5
         u32 rsskey6;                             // DWORD 6
         u32 rsskey7;                             // DWORD 7
         u32 rsskey8;                             // DWORD 8
         u32 rsskey9;                             // DWORD 9
      } SG_PACK RSS_KEY_TABLE_ENTRY, *PRSS_KEY_TABLE_ENTRY;

      typedef union _RSS_KEY_TABLE_ENTRY_UNION {
         RSS_KEY_TABLE_ENTRY bits;
         u32 dw[10]; // dword union
      } SG_PACK RSS_KEY_TABLE_ENTRY_UNION, *PRSS_KEY_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__RSS_KEY_TABLE_ENTRY_UNION, sizeof (RSS_KEY_TABLE_ENTRY_UNION) == 40);
   #endif


#else
   // RSS Secret KEY.
   #if defined(SG_BMAP_UNION)
      typedef struct _RSS_KEY_TABLE_ENTRY {
         union {
            struct { 
               u32 rsskey0;                       // DWORD 0
               u32 rsskey1;                       // DWORD 1
               u32 rsskey2;                       // DWORD 2
               u32 rsskey3;                       // DWORD 3
               u32 rsskey4;                       // DWORD 4
               u32 rsskey5;                       // DWORD 5
               u32 rsskey6;                       // DWORD 6
               u32 rsskey7;                       // DWORD 7
               u32 rsskey8;                       // DWORD 8
               u32 rsskey9;                       // DWORD 9
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK RSS_KEY_TABLE_ENTRY, *PRSS_KEY_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__RSS_KEY_TABLE_ENTRY, sizeof (RSS_KEY_TABLE_ENTRY) == 40);

   #else
      typedef struct _RSS_KEY_TABLE_ENTRY {
         u32 rsskey0;                             // DWORD 0
         u32 rsskey1;                             // DWORD 1
         u32 rsskey2;                             // DWORD 2
         u32 rsskey3;                             // DWORD 3
         u32 rsskey4;                             // DWORD 4
         u32 rsskey5;                             // DWORD 5
         u32 rsskey6;                             // DWORD 6
         u32 rsskey7;                             // DWORD 7
         u32 rsskey8;                             // DWORD 8
         u32 rsskey9;                             // DWORD 9
      } SG_PACK RSS_KEY_TABLE_ENTRY, *PRSS_KEY_TABLE_ENTRY;

      typedef union _RSS_KEY_TABLE_ENTRY_UNION {
         RSS_KEY_TABLE_ENTRY bits;
         u32 dw[10]; // dword union
      } SG_PACK RSS_KEY_TABLE_ENTRY_UNION, *PRSS_KEY_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__RSS_KEY_TABLE_ENTRY_UNION, sizeof (RSS_KEY_TABLE_ENTRY_UNION) == 40);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RSS Secret KEY.
   #if defined(SG_BMAP_UNION)
      typedef struct _RSS_KEY_TABLE {
         union {
            struct { 
               RSS_KEY_TABLE_ENTRY ni0_policy;
               RSS_KEY_TABLE_ENTRY ni1_policy;
            } SG_PACK ; // unnamed struct
            u32 dw[20]; // dword union
         }; // unnamed union
      } SG_PACK RSS_KEY_TABLE, *PRSS_KEY_TABLE;

      SG_C_ASSERT(__sizeof__RSS_KEY_TABLE, sizeof (RSS_KEY_TABLE) == 80);

   #else
      typedef struct _RSS_KEY_TABLE {
         RSS_KEY_TABLE_ENTRY ni0_policy;
         RSS_KEY_TABLE_ENTRY ni1_policy;
      } SG_PACK RSS_KEY_TABLE, *PRSS_KEY_TABLE;

      typedef union _RSS_KEY_TABLE_UNION {
         RSS_KEY_TABLE bits;
         u32 dw[20]; // dword union
      } SG_PACK RSS_KEY_TABLE_UNION, *PRSS_KEY_TABLE_UNION;

      SG_C_ASSERT(__sizeof__RSS_KEY_TABLE_UNION, sizeof (RSS_KEY_TABLE_UNION) == 80);
   #endif


#else
   // RSS Secret KEY.
   #if defined(SG_BMAP_UNION)
      typedef struct _RSS_KEY_TABLE {
         union {
            struct { 
               RSS_KEY_TABLE_ENTRY ni0_policy;
               RSS_KEY_TABLE_ENTRY ni1_policy;
            } SG_PACK ; // unnamed struct
            u32 dw[20]; // dword union
         }; // unnamed union
      } SG_PACK RSS_KEY_TABLE, *PRSS_KEY_TABLE;

      SG_C_ASSERT(__sizeof__RSS_KEY_TABLE, sizeof (RSS_KEY_TABLE) == 80);

   #else
      typedef struct _RSS_KEY_TABLE {
         RSS_KEY_TABLE_ENTRY ni0_policy;
         RSS_KEY_TABLE_ENTRY ni1_policy;
      } SG_PACK RSS_KEY_TABLE, *PRSS_KEY_TABLE;

      typedef union _RSS_KEY_TABLE_UNION {
         RSS_KEY_TABLE bits;
         u32 dw[20]; // dword union
      } SG_PACK RSS_KEY_TABLE_UNION, *PRSS_KEY_TABLE_UNION;

      SG_C_ASSERT(__sizeof__RSS_KEY_TABLE_UNION, sizeof (RSS_KEY_TABLE_UNION) == 80);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RSS CPU Table Entry. There are 128 total RSS table entries, 4 per dword.
   #if defined(SG_BMAP_UNION)
      typedef struct _RSS_CPU_TABLE_ENTRY {
         union {
            struct { 
               u32 rsvd3 : 5;                     // DWORD 0
               u32 cpu3 : 3;                      // DWORD 0
               u32 rsvd2 : 5;                     // DWORD 0
               u32 cpu2 : 3;                      // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 cpu1 : 3;                      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 cpu0 : 3;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RSS_CPU_TABLE_ENTRY, *PRSS_CPU_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__RSS_CPU_TABLE_ENTRY, sizeof (RSS_CPU_TABLE_ENTRY) == 4);

   #else
      typedef struct _RSS_CPU_TABLE_ENTRY {
         u32 rsvd3 : 5;                           // DWORD 0
         u32 cpu3 : 3;                            // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
         u32 cpu2 : 3;                            // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 cpu1 : 3;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 cpu0 : 3;                            // DWORD 0
      } SG_PACK RSS_CPU_TABLE_ENTRY, *PRSS_CPU_TABLE_ENTRY;

      typedef union _RSS_CPU_TABLE_ENTRY_UNION {
         RSS_CPU_TABLE_ENTRY bits;
         u32 dw; // dword union
      } SG_PACK RSS_CPU_TABLE_ENTRY_UNION, *PRSS_CPU_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__RSS_CPU_TABLE_ENTRY_UNION, sizeof (RSS_CPU_TABLE_ENTRY_UNION) == 4);
   #endif


#else
   // RSS CPU Table Entry. There are 128 total RSS table entries, 4 per dword.
   #if defined(SG_BMAP_UNION)
      typedef struct _RSS_CPU_TABLE_ENTRY {
         union {
            struct { 
               u32 cpu0 : 3;                      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 cpu1 : 3;                      // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 cpu2 : 3;                      // DWORD 0
               u32 rsvd2 : 5;                     // DWORD 0
               u32 cpu3 : 3;                      // DWORD 0
               u32 rsvd3 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RSS_CPU_TABLE_ENTRY, *PRSS_CPU_TABLE_ENTRY;

      SG_C_ASSERT(__sizeof__RSS_CPU_TABLE_ENTRY, sizeof (RSS_CPU_TABLE_ENTRY) == 4);

   #else
      typedef struct _RSS_CPU_TABLE_ENTRY {
         u32 cpu0 : 3;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 cpu1 : 3;                            // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 cpu2 : 3;                            // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
         u32 cpu3 : 3;                            // DWORD 0
         u32 rsvd3 : 5;                           // DWORD 0
      } SG_PACK RSS_CPU_TABLE_ENTRY, *PRSS_CPU_TABLE_ENTRY;

      typedef union _RSS_CPU_TABLE_ENTRY_UNION {
         RSS_CPU_TABLE_ENTRY bits;
         u32 dw; // dword union
      } SG_PACK RSS_CPU_TABLE_ENTRY_UNION, *PRSS_CPU_TABLE_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__RSS_CPU_TABLE_ENTRY_UNION, sizeof (RSS_CPU_TABLE_ENTRY_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RSS CPU Table for Network Interfaces.
   #if defined(SG_BMAP_UNION)
      typedef struct _RSS_CPU_TABLE {
         union {
            struct { 
               RSS_CPU_TABLE_ENTRY ni0_policy0[32];
               RSS_CPU_TABLE_ENTRY ni0_policy1[32];
               RSS_CPU_TABLE_ENTRY ni1_policy0[32];
               RSS_CPU_TABLE_ENTRY ni1_policy1[32];
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK RSS_CPU_TABLE, *PRSS_CPU_TABLE;

      SG_C_ASSERT(__sizeof__RSS_CPU_TABLE, sizeof (RSS_CPU_TABLE) == 512);

   #else
      typedef struct _RSS_CPU_TABLE {
         RSS_CPU_TABLE_ENTRY ni0_policy0[32];
         RSS_CPU_TABLE_ENTRY ni0_policy1[32];
         RSS_CPU_TABLE_ENTRY ni1_policy0[32];
         RSS_CPU_TABLE_ENTRY ni1_policy1[32];
      } SG_PACK RSS_CPU_TABLE, *PRSS_CPU_TABLE;

      typedef union _RSS_CPU_TABLE_UNION {
         RSS_CPU_TABLE bits;
         u32 dw[128]; // dword union
      } SG_PACK RSS_CPU_TABLE_UNION, *PRSS_CPU_TABLE_UNION;

      SG_C_ASSERT(__sizeof__RSS_CPU_TABLE_UNION, sizeof (RSS_CPU_TABLE_UNION) == 512);
   #endif


#else
   // RSS CPU Table for Network Interfaces.
   #if defined(SG_BMAP_UNION)
      typedef struct _RSS_CPU_TABLE {
         union {
            struct { 
               RSS_CPU_TABLE_ENTRY ni0_policy0[32];
               RSS_CPU_TABLE_ENTRY ni0_policy1[32];
               RSS_CPU_TABLE_ENTRY ni1_policy0[32];
               RSS_CPU_TABLE_ENTRY ni1_policy1[32];
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK RSS_CPU_TABLE, *PRSS_CPU_TABLE;

      SG_C_ASSERT(__sizeof__RSS_CPU_TABLE, sizeof (RSS_CPU_TABLE) == 512);

   #else
      typedef struct _RSS_CPU_TABLE {
         RSS_CPU_TABLE_ENTRY ni0_policy0[32];
         RSS_CPU_TABLE_ENTRY ni0_policy1[32];
         RSS_CPU_TABLE_ENTRY ni1_policy0[32];
         RSS_CPU_TABLE_ENTRY ni1_policy1[32];
      } SG_PACK RSS_CPU_TABLE, *PRSS_CPU_TABLE;

      typedef union _RSS_CPU_TABLE_UNION {
         RSS_CPU_TABLE bits;
         u32 dw[128]; // dword union
      } SG_PACK RSS_CPU_TABLE_UNION, *PRSS_CPU_TABLE_UNION;

      SG_C_ASSERT(__sizeof__RSS_CPU_TABLE_UNION, sizeof (RSS_CPU_TABLE_UNION) == 512);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_PORT_RXF_STATS {
         union {
            struct { 
               u32 rx_bytes_lsd;                  // DWORD 0
               u32 rx_bytes_msd;                  // DWORD 1
               u32 rx_total_frames;               // DWORD 2
               u32 rx_unicast_frames;             // DWORD 3
               u32 rx_multicast_frames;           // DWORD 4
               u32 rx_broadcast_frames;           // DWORD 5
               u32 rx_crc_errors;                 // DWORD 6
               u32 rx_alignment_symbol_errors;    // DWORD 7
               u32 rx_pause_frames;               // DWORD 8
               u32 rx_control_frames;             // DWORD 9
               u32 rx_in_range_errors;            // DWORD 10
               u32 rx_out_range_errors;           // DWORD 11
               u32 rx_frame_too_long;             // DWORD 12
               u32 rx_address_match_errors;       // DWORD 13
               u32 rx_vlan_mismatch;              // DWORD 14
               u32 rx_dropped_too_small;          // DWORD 15
               u32 rx_dropped_too_short;          // DWORD 16
               u32 rx_dropped_header_too_small;   // DWORD 17
               u32 rx_dropped_tcp_length;         // DWORD 18
               u32 rx_dropped_runt;               // DWORD 19
               u32 rx_64_byte_packets;            // DWORD 20
               u32 rx_65_127_byte_packets;        // DWORD 21
               u32 rx_128_256_byte_packets;       // DWORD 22
               u32 rx_256_511_byte_packets;       // DWORD 23
               u32 rx_512_1023_byte_packets;      // DWORD 24
               u32 rx_1024_1518_byte_packets;     // DWORD 25
               u32 rx_1519_2047_byte_packets;     // DWORD 26
               u32 rx_2048_4095_byte_packets;     // DWORD 27
               u32 rx_4096_8191_byte_packets;     // DWORD 28
               u32 rx_8192_9216_byte_packets;     // DWORD 29
               u32 rx_ip_checksum_errs;           // DWORD 30
               u32 rx_tcp_checksum_errs;          // DWORD 31
               u32 rx_udp_checksum_errs;          // DWORD 32
               u32 rx_non_rss_packets;            // DWORD 33
               u32 rx_ipv4_packets;               // DWORD 34
               u32 rx_ipv6_packets;               // DWORD 35
               u32 rx_ipv4_bytes_lsd;             // DWORD 36
               u32 rx_ipv4_bytes_msd;             // DWORD 37
               u32 rx_ipv6_bytes_lsd;             // DWORD 38
               u32 rx_ipv6_bytes_msd;             // DWORD 39
               u32 rx_chute1_packets;             // DWORD 40
               u32 rx_chute2_packets;             // DWORD 41
               u32 rx_chute3_packets;             // DWORD 42
               u32 rx_management_packets;         // DWORD 43
               u32 rx_switched_unicast_packets;   // DWORD 44
               u32 rx_switched_multicast_packets; // DWORD 45
               u32 rx_switched_broadcast_packets; // DWORD 46
               u32 tx_bytes_lsd;                  // DWORD 47
               u32 tx_bytes_msd;                  // DWORD 48
               u32 tx_unicastframes;              // DWORD 49
               u32 tx_multicastframes;            // DWORD 50
               u32 tx_broadcastframes;            // DWORD 51
               u32 tx_pauseframes;                // DWORD 52
               u32 tx_controlframes;              // DWORD 53
               u32 tx_64_byte_packets;            // DWORD 54
               u32 tx_65_127_byte_packets;        // DWORD 55
               u32 tx_128_256_byte_packets;       // DWORD 56
               u32 tx_256_511_byte_packets;       // DWORD 57
               u32 tx_512_1023_byte_packets;      // DWORD 58
               u32 tx_1024_1518_byte_packets;     // DWORD 59
               u32 tx_1519_2047_byte_packets;     // DWORD 60
               u32 tx_2048_4095_byte_packets;     // DWORD 61
               u32 tx_4096_8191_byte_packets;     // DWORD 62
               u32 tx_8192_9216_byte_packets;     // DWORD 63
               u32 rx_fifo_overflow;              // DWORD 64
               u32 rx_input_fifo_overflow;        // DWORD 65
            } SG_PACK ; // unnamed struct
            u32 dw[66]; // dword union
         }; // unnamed union
      } SG_PACK BE2_PORT_RXF_STATS, *PBE2_PORT_RXF_STATS;

      SG_C_ASSERT(__sizeof__BE2_PORT_RXF_STATS, sizeof (BE2_PORT_RXF_STATS) == 264);

   #else
      typedef struct _BE2_PORT_RXF_STATS {
         u32 rx_bytes_lsd;                        // DWORD 0
         u32 rx_bytes_msd;                        // DWORD 1
         u32 rx_total_frames;                     // DWORD 2
         u32 rx_unicast_frames;                   // DWORD 3
         u32 rx_multicast_frames;                 // DWORD 4
         u32 rx_broadcast_frames;                 // DWORD 5
         u32 rx_crc_errors;                       // DWORD 6
         u32 rx_alignment_symbol_errors;          // DWORD 7
         u32 rx_pause_frames;                     // DWORD 8
         u32 rx_control_frames;                   // DWORD 9
         u32 rx_in_range_errors;                  // DWORD 10
         u32 rx_out_range_errors;                 // DWORD 11
         u32 rx_frame_too_long;                   // DWORD 12
         u32 rx_address_match_errors;             // DWORD 13
         u32 rx_vlan_mismatch;                    // DWORD 14
         u32 rx_dropped_too_small;                // DWORD 15
         u32 rx_dropped_too_short;                // DWORD 16
         u32 rx_dropped_header_too_small;         // DWORD 17
         u32 rx_dropped_tcp_length;               // DWORD 18
         u32 rx_dropped_runt;                     // DWORD 19
         u32 rx_64_byte_packets;                  // DWORD 20
         u32 rx_65_127_byte_packets;              // DWORD 21
         u32 rx_128_256_byte_packets;             // DWORD 22
         u32 rx_256_511_byte_packets;             // DWORD 23
         u32 rx_512_1023_byte_packets;            // DWORD 24
         u32 rx_1024_1518_byte_packets;           // DWORD 25
         u32 rx_1519_2047_byte_packets;           // DWORD 26
         u32 rx_2048_4095_byte_packets;           // DWORD 27
         u32 rx_4096_8191_byte_packets;           // DWORD 28
         u32 rx_8192_9216_byte_packets;           // DWORD 29
         u32 rx_ip_checksum_errs;                 // DWORD 30
         u32 rx_tcp_checksum_errs;                // DWORD 31
         u32 rx_udp_checksum_errs;                // DWORD 32
         u32 rx_non_rss_packets;                  // DWORD 33
         u32 rx_ipv4_packets;                     // DWORD 34
         u32 rx_ipv6_packets;                     // DWORD 35
         u32 rx_ipv4_bytes_lsd;                   // DWORD 36
         u32 rx_ipv4_bytes_msd;                   // DWORD 37
         u32 rx_ipv6_bytes_lsd;                   // DWORD 38
         u32 rx_ipv6_bytes_msd;                   // DWORD 39
         u32 rx_chute1_packets;                   // DWORD 40
         u32 rx_chute2_packets;                   // DWORD 41
         u32 rx_chute3_packets;                   // DWORD 42
         u32 rx_management_packets;               // DWORD 43
         u32 rx_switched_unicast_packets;         // DWORD 44
         u32 rx_switched_multicast_packets;       // DWORD 45
         u32 rx_switched_broadcast_packets;       // DWORD 46
         u32 tx_bytes_lsd;                        // DWORD 47
         u32 tx_bytes_msd;                        // DWORD 48
         u32 tx_unicastframes;                    // DWORD 49
         u32 tx_multicastframes;                  // DWORD 50
         u32 tx_broadcastframes;                  // DWORD 51
         u32 tx_pauseframes;                      // DWORD 52
         u32 tx_controlframes;                    // DWORD 53
         u32 tx_64_byte_packets;                  // DWORD 54
         u32 tx_65_127_byte_packets;              // DWORD 55
         u32 tx_128_256_byte_packets;             // DWORD 56
         u32 tx_256_511_byte_packets;             // DWORD 57
         u32 tx_512_1023_byte_packets;            // DWORD 58
         u32 tx_1024_1518_byte_packets;           // DWORD 59
         u32 tx_1519_2047_byte_packets;           // DWORD 60
         u32 tx_2048_4095_byte_packets;           // DWORD 61
         u32 tx_4096_8191_byte_packets;           // DWORD 62
         u32 tx_8192_9216_byte_packets;           // DWORD 63
         u32 rx_fifo_overflow;                    // DWORD 64
         u32 rx_input_fifo_overflow;              // DWORD 65
      } SG_PACK BE2_PORT_RXF_STATS, *PBE2_PORT_RXF_STATS;

      typedef union _BE2_PORT_RXF_STATS_UNION {
         BE2_PORT_RXF_STATS bits;
         u32 dw[66]; // dword union
      } SG_PACK BE2_PORT_RXF_STATS_UNION, *PBE2_PORT_RXF_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_PORT_RXF_STATS_UNION, sizeof (BE2_PORT_RXF_STATS_UNION) == 264);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_PORT_RXF_STATS {
         union {
            struct { 
               u32 rx_bytes_lsd;                  // DWORD 0
               u32 rx_bytes_msd;                  // DWORD 1
               u32 rx_total_frames;               // DWORD 2
               u32 rx_unicast_frames;             // DWORD 3
               u32 rx_multicast_frames;           // DWORD 4
               u32 rx_broadcast_frames;           // DWORD 5
               u32 rx_crc_errors;                 // DWORD 6
               u32 rx_alignment_symbol_errors;    // DWORD 7
               u32 rx_pause_frames;               // DWORD 8
               u32 rx_control_frames;             // DWORD 9
               u32 rx_in_range_errors;            // DWORD 10
               u32 rx_out_range_errors;           // DWORD 11
               u32 rx_frame_too_long;             // DWORD 12
               u32 rx_address_match_errors;       // DWORD 13
               u32 rx_vlan_mismatch;              // DWORD 14
               u32 rx_dropped_too_small;          // DWORD 15
               u32 rx_dropped_too_short;          // DWORD 16
               u32 rx_dropped_header_too_small;   // DWORD 17
               u32 rx_dropped_tcp_length;         // DWORD 18
               u32 rx_dropped_runt;               // DWORD 19
               u32 rx_64_byte_packets;            // DWORD 20
               u32 rx_65_127_byte_packets;        // DWORD 21
               u32 rx_128_256_byte_packets;       // DWORD 22
               u32 rx_256_511_byte_packets;       // DWORD 23
               u32 rx_512_1023_byte_packets;      // DWORD 24
               u32 rx_1024_1518_byte_packets;     // DWORD 25
               u32 rx_1519_2047_byte_packets;     // DWORD 26
               u32 rx_2048_4095_byte_packets;     // DWORD 27
               u32 rx_4096_8191_byte_packets;     // DWORD 28
               u32 rx_8192_9216_byte_packets;     // DWORD 29
               u32 rx_ip_checksum_errs;           // DWORD 30
               u32 rx_tcp_checksum_errs;          // DWORD 31
               u32 rx_udp_checksum_errs;          // DWORD 32
               u32 rx_non_rss_packets;            // DWORD 33
               u32 rx_ipv4_packets;               // DWORD 34
               u32 rx_ipv6_packets;               // DWORD 35
               u32 rx_ipv4_bytes_lsd;             // DWORD 36
               u32 rx_ipv4_bytes_msd;             // DWORD 37
               u32 rx_ipv6_bytes_lsd;             // DWORD 38
               u32 rx_ipv6_bytes_msd;             // DWORD 39
               u32 rx_chute1_packets;             // DWORD 40
               u32 rx_chute2_packets;             // DWORD 41
               u32 rx_chute3_packets;             // DWORD 42
               u32 rx_management_packets;         // DWORD 43
               u32 rx_switched_unicast_packets;   // DWORD 44
               u32 rx_switched_multicast_packets; // DWORD 45
               u32 rx_switched_broadcast_packets; // DWORD 46
               u32 tx_bytes_lsd;                  // DWORD 47
               u32 tx_bytes_msd;                  // DWORD 48
               u32 tx_unicastframes;              // DWORD 49
               u32 tx_multicastframes;            // DWORD 50
               u32 tx_broadcastframes;            // DWORD 51
               u32 tx_pauseframes;                // DWORD 52
               u32 tx_controlframes;              // DWORD 53
               u32 tx_64_byte_packets;            // DWORD 54
               u32 tx_65_127_byte_packets;        // DWORD 55
               u32 tx_128_256_byte_packets;       // DWORD 56
               u32 tx_256_511_byte_packets;       // DWORD 57
               u32 tx_512_1023_byte_packets;      // DWORD 58
               u32 tx_1024_1518_byte_packets;     // DWORD 59
               u32 tx_1519_2047_byte_packets;     // DWORD 60
               u32 tx_2048_4095_byte_packets;     // DWORD 61
               u32 tx_4096_8191_byte_packets;     // DWORD 62
               u32 tx_8192_9216_byte_packets;     // DWORD 63
               u32 rx_fifo_overflow;              // DWORD 64
               u32 rx_input_fifo_overflow;        // DWORD 65
            } SG_PACK ; // unnamed struct
            u32 dw[66]; // dword union
         }; // unnamed union
      } SG_PACK BE2_PORT_RXF_STATS, *PBE2_PORT_RXF_STATS;

      SG_C_ASSERT(__sizeof__BE2_PORT_RXF_STATS, sizeof (BE2_PORT_RXF_STATS) == 264);

   #else
      typedef struct _BE2_PORT_RXF_STATS {
         u32 rx_bytes_lsd;                        // DWORD 0
         u32 rx_bytes_msd;                        // DWORD 1
         u32 rx_total_frames;                     // DWORD 2
         u32 rx_unicast_frames;                   // DWORD 3
         u32 rx_multicast_frames;                 // DWORD 4
         u32 rx_broadcast_frames;                 // DWORD 5
         u32 rx_crc_errors;                       // DWORD 6
         u32 rx_alignment_symbol_errors;          // DWORD 7
         u32 rx_pause_frames;                     // DWORD 8
         u32 rx_control_frames;                   // DWORD 9
         u32 rx_in_range_errors;                  // DWORD 10
         u32 rx_out_range_errors;                 // DWORD 11
         u32 rx_frame_too_long;                   // DWORD 12
         u32 rx_address_match_errors;             // DWORD 13
         u32 rx_vlan_mismatch;                    // DWORD 14
         u32 rx_dropped_too_small;                // DWORD 15
         u32 rx_dropped_too_short;                // DWORD 16
         u32 rx_dropped_header_too_small;         // DWORD 17
         u32 rx_dropped_tcp_length;               // DWORD 18
         u32 rx_dropped_runt;                     // DWORD 19
         u32 rx_64_byte_packets;                  // DWORD 20
         u32 rx_65_127_byte_packets;              // DWORD 21
         u32 rx_128_256_byte_packets;             // DWORD 22
         u32 rx_256_511_byte_packets;             // DWORD 23
         u32 rx_512_1023_byte_packets;            // DWORD 24
         u32 rx_1024_1518_byte_packets;           // DWORD 25
         u32 rx_1519_2047_byte_packets;           // DWORD 26
         u32 rx_2048_4095_byte_packets;           // DWORD 27
         u32 rx_4096_8191_byte_packets;           // DWORD 28
         u32 rx_8192_9216_byte_packets;           // DWORD 29
         u32 rx_ip_checksum_errs;                 // DWORD 30
         u32 rx_tcp_checksum_errs;                // DWORD 31
         u32 rx_udp_checksum_errs;                // DWORD 32
         u32 rx_non_rss_packets;                  // DWORD 33
         u32 rx_ipv4_packets;                     // DWORD 34
         u32 rx_ipv6_packets;                     // DWORD 35
         u32 rx_ipv4_bytes_lsd;                   // DWORD 36
         u32 rx_ipv4_bytes_msd;                   // DWORD 37
         u32 rx_ipv6_bytes_lsd;                   // DWORD 38
         u32 rx_ipv6_bytes_msd;                   // DWORD 39
         u32 rx_chute1_packets;                   // DWORD 40
         u32 rx_chute2_packets;                   // DWORD 41
         u32 rx_chute3_packets;                   // DWORD 42
         u32 rx_management_packets;               // DWORD 43
         u32 rx_switched_unicast_packets;         // DWORD 44
         u32 rx_switched_multicast_packets;       // DWORD 45
         u32 rx_switched_broadcast_packets;       // DWORD 46
         u32 tx_bytes_lsd;                        // DWORD 47
         u32 tx_bytes_msd;                        // DWORD 48
         u32 tx_unicastframes;                    // DWORD 49
         u32 tx_multicastframes;                  // DWORD 50
         u32 tx_broadcastframes;                  // DWORD 51
         u32 tx_pauseframes;                      // DWORD 52
         u32 tx_controlframes;                    // DWORD 53
         u32 tx_64_byte_packets;                  // DWORD 54
         u32 tx_65_127_byte_packets;              // DWORD 55
         u32 tx_128_256_byte_packets;             // DWORD 56
         u32 tx_256_511_byte_packets;             // DWORD 57
         u32 tx_512_1023_byte_packets;            // DWORD 58
         u32 tx_1024_1518_byte_packets;           // DWORD 59
         u32 tx_1519_2047_byte_packets;           // DWORD 60
         u32 tx_2048_4095_byte_packets;           // DWORD 61
         u32 tx_4096_8191_byte_packets;           // DWORD 62
         u32 tx_8192_9216_byte_packets;           // DWORD 63
         u32 rx_fifo_overflow;                    // DWORD 64
         u32 rx_input_fifo_overflow;              // DWORD 65
      } SG_PACK BE2_PORT_RXF_STATS, *PBE2_PORT_RXF_STATS;

      typedef union _BE2_PORT_RXF_STATS_UNION {
         BE2_PORT_RXF_STATS bits;
         u32 dw[66]; // dword union
      } SG_PACK BE2_PORT_RXF_STATS_UNION, *PBE2_PORT_RXF_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_PORT_RXF_STATS_UNION, sizeof (BE2_PORT_RXF_STATS_UNION) == 264);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_FCOE_PORT_STATS {
         union {
            struct { 
               u32 rx_drops_payload_size;         // DWORD 0
               u32 rx_drops_crc;                  // DWORD 1
               u32 rx_drops_clipped_header;       // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK BE2_FCOE_PORT_STATS, *PBE2_FCOE_PORT_STATS;

      SG_C_ASSERT(__sizeof__BE2_FCOE_PORT_STATS, sizeof (BE2_FCOE_PORT_STATS) == 12);

   #else
      typedef struct _BE2_FCOE_PORT_STATS {
         u32 rx_drops_payload_size;               // DWORD 0
         u32 rx_drops_crc;                        // DWORD 1
         u32 rx_drops_clipped_header;             // DWORD 2
      } SG_PACK BE2_FCOE_PORT_STATS, *PBE2_FCOE_PORT_STATS;

      typedef union _BE2_FCOE_PORT_STATS_UNION {
         BE2_FCOE_PORT_STATS bits;
         u32 dw[3]; // dword union
      } SG_PACK BE2_FCOE_PORT_STATS_UNION, *PBE2_FCOE_PORT_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_FCOE_PORT_STATS_UNION, sizeof (BE2_FCOE_PORT_STATS_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_FCOE_PORT_STATS {
         union {
            struct { 
               u32 rx_drops_payload_size;         // DWORD 0
               u32 rx_drops_crc;                  // DWORD 1
               u32 rx_drops_clipped_header;       // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK BE2_FCOE_PORT_STATS, *PBE2_FCOE_PORT_STATS;

      SG_C_ASSERT(__sizeof__BE2_FCOE_PORT_STATS, sizeof (BE2_FCOE_PORT_STATS) == 12);

   #else
      typedef struct _BE2_FCOE_PORT_STATS {
         u32 rx_drops_payload_size;               // DWORD 0
         u32 rx_drops_crc;                        // DWORD 1
         u32 rx_drops_clipped_header;             // DWORD 2
      } SG_PACK BE2_FCOE_PORT_STATS, *PBE2_FCOE_PORT_STATS;

      typedef union _BE2_FCOE_PORT_STATS_UNION {
         BE2_FCOE_PORT_STATS bits;
         u32 dw[3]; // dword union
      } SG_PACK BE2_FCOE_PORT_STATS_UNION, *PBE2_FCOE_PORT_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_FCOE_PORT_STATS_UNION, sizeof (BE2_FCOE_PORT_STATS_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_RXF_STATS {
         union {
            struct { 
               BE2_PORT_RXF_STATS port[2];
               u32 rx_drops_no_pbuf;              // DWORD 132
               u32 rx_drops_no_txpb;              // DWORD 133
               u32 rx_drops_no_erx_descr;         // DWORD 134
               u32 rx_drops_no_tpre_descr;        // DWORD 135
               u32 management_rx_port_packets;    // DWORD 136
               u32 management_rx_port_bytes;      // DWORD 137
               u32 management_rx_port_pause_frames; // DWORD 138
               u32 management_rx_port_errors;     // DWORD 139
               u32 management_tx_port_packets;    // DWORD 140
               u32 management_tx_port_bytes;      // DWORD 141
               u32 management_tx_port_pause;      // DWORD 142
               u32 management_rx_port_rxfifo_overflow; // DWORD 143
               u32 rx_drops_too_many_frags;       // DWORD 144
               u32 rx_drops_invalid_ring;         // DWORD 145
               u32 forwarded_packets;             // DWORD 146
               u32 rx_drops_mtu;                  // DWORD 147
               BE2_FCOE_PORT_STATS fcoe_port[2];
               u32 fcoe_rx_drops_no_pbufs;        // DWORD 154
               u32 port0_jabber_events;           // DWORD 155
               u32 port1_jabber_events;           // DWORD 156
               u32 port0_fcoe_bytes_received_lsd; // DWORD 157
               u32 port0_fcoe_bytes_received_msd; // DWORD 158
               u32 port0_fcoe_frames_received;    // DWORD 159
               u32 port1_fcoe_bytes_received_lsd; // DWORD 160
               u32 port1_fcoe_bytes_received_msd; // DWORD 161
               u32 port1_fcoe_frames_received;    // DWORD 162
            } SG_PACK ; // unnamed struct
            u32 dw[163]; // dword union
         }; // unnamed union
      } SG_PACK BE2_RXF_STATS, *PBE2_RXF_STATS;

      SG_C_ASSERT(__sizeof__BE2_RXF_STATS, sizeof (BE2_RXF_STATS) == 652);

   #else
      typedef struct _BE2_RXF_STATS {
         BE2_PORT_RXF_STATS port[2];
         u32 rx_drops_no_pbuf;                    // DWORD 132
         u32 rx_drops_no_txpb;                    // DWORD 133
         u32 rx_drops_no_erx_descr;               // DWORD 134
         u32 rx_drops_no_tpre_descr;              // DWORD 135
         u32 management_rx_port_packets;          // DWORD 136
         u32 management_rx_port_bytes;            // DWORD 137
         u32 management_rx_port_pause_frames;     // DWORD 138
         u32 management_rx_port_errors;           // DWORD 139
         u32 management_tx_port_packets;          // DWORD 140
         u32 management_tx_port_bytes;            // DWORD 141
         u32 management_tx_port_pause;            // DWORD 142
         u32 management_rx_port_rxfifo_overflow;  // DWORD 143
         u32 rx_drops_too_many_frags;             // DWORD 144
         u32 rx_drops_invalid_ring;               // DWORD 145
         u32 forwarded_packets;                   // DWORD 146
         u32 rx_drops_mtu;                        // DWORD 147
         BE2_FCOE_PORT_STATS fcoe_port[2];
         u32 fcoe_rx_drops_no_pbufs;              // DWORD 154
         u32 port0_jabber_events;                 // DWORD 155
         u32 port1_jabber_events;                 // DWORD 156
         u32 port0_fcoe_bytes_received_lsd;       // DWORD 157
         u32 port0_fcoe_bytes_received_msd;       // DWORD 158
         u32 port0_fcoe_frames_received;          // DWORD 159
         u32 port1_fcoe_bytes_received_lsd;       // DWORD 160
         u32 port1_fcoe_bytes_received_msd;       // DWORD 161
         u32 port1_fcoe_frames_received;          // DWORD 162
      } SG_PACK BE2_RXF_STATS, *PBE2_RXF_STATS;

      typedef union _BE2_RXF_STATS_UNION {
         BE2_RXF_STATS bits;
         u32 dw[163]; // dword union
      } SG_PACK BE2_RXF_STATS_UNION, *PBE2_RXF_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_RXF_STATS_UNION, sizeof (BE2_RXF_STATS_UNION) == 652);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_RXF_STATS {
         union {
            struct { 
               BE2_PORT_RXF_STATS port[2];
               u32 rx_drops_no_pbuf;              // DWORD 132
               u32 rx_drops_no_txpb;              // DWORD 133
               u32 rx_drops_no_erx_descr;         // DWORD 134
               u32 rx_drops_no_tpre_descr;        // DWORD 135
               u32 management_rx_port_packets;    // DWORD 136
               u32 management_rx_port_bytes;      // DWORD 137
               u32 management_rx_port_pause_frames; // DWORD 138
               u32 management_rx_port_errors;     // DWORD 139
               u32 management_tx_port_packets;    // DWORD 140
               u32 management_tx_port_bytes;      // DWORD 141
               u32 management_tx_port_pause;      // DWORD 142
               u32 management_rx_port_rxfifo_overflow; // DWORD 143
               u32 rx_drops_too_many_frags;       // DWORD 144
               u32 rx_drops_invalid_ring;         // DWORD 145
               u32 forwarded_packets;             // DWORD 146
               u32 rx_drops_mtu;                  // DWORD 147
               BE2_FCOE_PORT_STATS fcoe_port[2];
               u32 fcoe_rx_drops_no_pbufs;        // DWORD 154
               u32 port0_jabber_events;           // DWORD 155
               u32 port1_jabber_events;           // DWORD 156
               u32 port0_fcoe_bytes_received_lsd; // DWORD 157
               u32 port0_fcoe_bytes_received_msd; // DWORD 158
               u32 port0_fcoe_frames_received;    // DWORD 159
               u32 port1_fcoe_bytes_received_lsd; // DWORD 160
               u32 port1_fcoe_bytes_received_msd; // DWORD 161
               u32 port1_fcoe_frames_received;    // DWORD 162
            } SG_PACK ; // unnamed struct
            u32 dw[163]; // dword union
         }; // unnamed union
      } SG_PACK BE2_RXF_STATS, *PBE2_RXF_STATS;

      SG_C_ASSERT(__sizeof__BE2_RXF_STATS, sizeof (BE2_RXF_STATS) == 652);

   #else
      typedef struct _BE2_RXF_STATS {
         BE2_PORT_RXF_STATS port[2];
         u32 rx_drops_no_pbuf;                    // DWORD 132
         u32 rx_drops_no_txpb;                    // DWORD 133
         u32 rx_drops_no_erx_descr;               // DWORD 134
         u32 rx_drops_no_tpre_descr;              // DWORD 135
         u32 management_rx_port_packets;          // DWORD 136
         u32 management_rx_port_bytes;            // DWORD 137
         u32 management_rx_port_pause_frames;     // DWORD 138
         u32 management_rx_port_errors;           // DWORD 139
         u32 management_tx_port_packets;          // DWORD 140
         u32 management_tx_port_bytes;            // DWORD 141
         u32 management_tx_port_pause;            // DWORD 142
         u32 management_rx_port_rxfifo_overflow;  // DWORD 143
         u32 rx_drops_too_many_frags;             // DWORD 144
         u32 rx_drops_invalid_ring;               // DWORD 145
         u32 forwarded_packets;                   // DWORD 146
         u32 rx_drops_mtu;                        // DWORD 147
         BE2_FCOE_PORT_STATS fcoe_port[2];
         u32 fcoe_rx_drops_no_pbufs;              // DWORD 154
         u32 port0_jabber_events;                 // DWORD 155
         u32 port1_jabber_events;                 // DWORD 156
         u32 port0_fcoe_bytes_received_lsd;       // DWORD 157
         u32 port0_fcoe_bytes_received_msd;       // DWORD 158
         u32 port0_fcoe_frames_received;          // DWORD 159
         u32 port1_fcoe_bytes_received_lsd;       // DWORD 160
         u32 port1_fcoe_bytes_received_msd;       // DWORD 161
         u32 port1_fcoe_frames_received;          // DWORD 162
      } SG_PACK BE2_RXF_STATS, *PBE2_RXF_STATS;

      typedef union _BE2_RXF_STATS_UNION {
         BE2_RXF_STATS bits;
         u32 dw[163]; // dword union
      } SG_PACK BE2_RXF_STATS_UNION, *PBE2_RXF_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_RXF_STATS_UNION, sizeof (BE2_RXF_STATS_UNION) == 652);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // All statistic counters are 32 bits, except for the transmit and receive byte
   // counters, which are 64 bits. Thus, the minimum time the 32 bit counters (which are
   // packet based) can roll over is 219.9 seconds, and the minimum time the transmit and
   // receive byte counters can roll over is approximately 463 years. The Port 0 and Port
   // 1 receive statistics include both packets received from the wire as well as packets
   // that have been switched from the transmit path.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_STAT_INDEX_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 stat_index : 8;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_STAT_INDEX_CSR, *PRXF_STAT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__RXF_STAT_INDEX_CSR, sizeof (RXF_STAT_INDEX_CSR) == 4);

   #else
      typedef struct _RXF_STAT_INDEX_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 stat_index : 8;                      // DWORD 0
      } SG_PACK RXF_STAT_INDEX_CSR, *PRXF_STAT_INDEX_CSR;

      typedef union _RXF_STAT_INDEX_CSR_UNION {
         RXF_STAT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_STAT_INDEX_CSR_UNION, *PRXF_STAT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_STAT_INDEX_CSR_UNION, sizeof (RXF_STAT_INDEX_CSR_UNION) == 4);
   #endif


#else
   // All statistic counters are 32 bits, except for the transmit and receive byte
   // counters, which are 64 bits. Thus, the minimum time the 32 bit counters (which are
   // packet based) can roll over is 219.9 seconds, and the minimum time the transmit and
   // receive byte counters can roll over is approximately 463 years. The Port 0 and Port
   // 1 receive statistics include both packets received from the wire as well as packets
   // that have been switched from the transmit path.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_STAT_INDEX_CSR {
         union {
            struct { 
               u32 stat_index : 8;                // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_STAT_INDEX_CSR, *PRXF_STAT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__RXF_STAT_INDEX_CSR, sizeof (RXF_STAT_INDEX_CSR) == 4);

   #else
      typedef struct _RXF_STAT_INDEX_CSR {
         u32 stat_index : 8;                      // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK RXF_STAT_INDEX_CSR, *PRXF_STAT_INDEX_CSR;

      typedef union _RXF_STAT_INDEX_CSR_UNION {
         RXF_STAT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_STAT_INDEX_CSR_UNION, *PRXF_STAT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_STAT_INDEX_CSR_UNION, sizeof (RXF_STAT_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // the value of the indexed statistic
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_STAT_DATA_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_STAT_DATA_CSR, *PRXF_STAT_DATA_CSR;

      SG_C_ASSERT(__sizeof__RXF_STAT_DATA_CSR, sizeof (RXF_STAT_DATA_CSR) == 4);

   #else
      typedef struct _RXF_STAT_DATA_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK RXF_STAT_DATA_CSR, *PRXF_STAT_DATA_CSR;

      typedef union _RXF_STAT_DATA_CSR_UNION {
         RXF_STAT_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_STAT_DATA_CSR_UNION, *PRXF_STAT_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_STAT_DATA_CSR_UNION, sizeof (RXF_STAT_DATA_CSR_UNION) == 4);
   #endif


#else
   // the value of the indexed statistic
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_STAT_DATA_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_STAT_DATA_CSR, *PRXF_STAT_DATA_CSR;

      SG_C_ASSERT(__sizeof__RXF_STAT_DATA_CSR, sizeof (RXF_STAT_DATA_CSR) == 4);

   #else
      typedef struct _RXF_STAT_DATA_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK RXF_STAT_DATA_CSR, *PRXF_STAT_DATA_CSR;

      typedef union _RXF_STAT_DATA_CSR_UNION {
         RXF_STAT_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_STAT_DATA_CSR_UNION, *PRXF_STAT_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_STAT_DATA_CSR_UNION, sizeof (RXF_STAT_DATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // XAUI SerDes Configuration
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CFG_CSR {
         union {
            struct { 
               u32 rsvd0 : 13;                    // DWORD 0
               u32 loopback_en : 1;               // DWORD 0
               u32 port1_en : 1;                  // DWORD 0
               u32 port0_en : 1;                  // DWORD 0
               u32 dre : 8;                       // DWORD 0
               u32 rx_en : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CFG_CSR, *PRXF_XAUI_CFG_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG_CSR, sizeof (RXF_XAUI_CFG_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CFG_CSR {
         u32 rsvd0 : 13;                          // DWORD 0
         u32 loopback_en : 1;                     // DWORD 0
         u32 port1_en : 1;                        // DWORD 0
         u32 port0_en : 1;                        // DWORD 0
         u32 dre : 8;                             // DWORD 0
         u32 rx_en : 8;                           // DWORD 0
      } SG_PACK RXF_XAUI_CFG_CSR, *PRXF_XAUI_CFG_CSR;

      typedef union _RXF_XAUI_CFG_CSR_UNION {
         RXF_XAUI_CFG_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CFG_CSR_UNION, *PRXF_XAUI_CFG_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG_CSR_UNION, sizeof (RXF_XAUI_CFG_CSR_UNION) == 4);
   #endif


#else
   // XAUI SerDes Configuration
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CFG_CSR {
         union {
            struct { 
               u32 rx_en : 8;                     // DWORD 0
               u32 dre : 8;                       // DWORD 0
               u32 port0_en : 1;                  // DWORD 0
               u32 port1_en : 1;                  // DWORD 0
               u32 loopback_en : 1;               // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CFG_CSR, *PRXF_XAUI_CFG_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG_CSR, sizeof (RXF_XAUI_CFG_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CFG_CSR {
         u32 rx_en : 8;                           // DWORD 0
         u32 dre : 8;                             // DWORD 0
         u32 port0_en : 1;                        // DWORD 0
         u32 port1_en : 1;                        // DWORD 0
         u32 loopback_en : 1;                     // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
      } SG_PACK RXF_XAUI_CFG_CSR, *PRXF_XAUI_CFG_CSR;

      typedef union _RXF_XAUI_CFG_CSR_UNION {
         RXF_XAUI_CFG_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CFG_CSR_UNION, *PRXF_XAUI_CFG_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG_CSR_UNION, sizeof (RXF_XAUI_CFG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // XAUI SerDes Channel MMD register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_C_MMD_CSR {
         union {
            struct { 
               u32 rsvd7 : 2;                     // DWORD 0
               u32 c7_mmd : 2;                    // DWORD 0
               u32 rsvd6 : 2;                     // DWORD 0
               u32 c6_mmd : 2;                    // DWORD 0
               u32 rsvd5 : 2;                     // DWORD 0
               u32 c5_mmd : 2;                    // DWORD 0
               u32 rsvd4 : 2;                     // DWORD 0
               u32 c4_mmd : 2;                    // DWORD 0
               u32 rsvd3 : 2;                     // DWORD 0
               u32 c3_mmd : 2;                    // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 c2_mmd : 2;                    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 c1_mmd : 2;                    // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 c0_mmd : 2;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_C_MMD_CSR, *PRXF_XAUI_C_MMD_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_C_MMD_CSR, sizeof (RXF_XAUI_C_MMD_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_C_MMD_CSR {
         u32 rsvd7 : 2;                           // DWORD 0
         u32 c7_mmd : 2;                          // DWORD 0
         u32 rsvd6 : 2;                           // DWORD 0
         u32 c6_mmd : 2;                          // DWORD 0
         u32 rsvd5 : 2;                           // DWORD 0
         u32 c5_mmd : 2;                          // DWORD 0
         u32 rsvd4 : 2;                           // DWORD 0
         u32 c4_mmd : 2;                          // DWORD 0
         u32 rsvd3 : 2;                           // DWORD 0
         u32 c3_mmd : 2;                          // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 c2_mmd : 2;                          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 c1_mmd : 2;                          // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 c0_mmd : 2;                          // DWORD 0
      } SG_PACK RXF_XAUI_C_MMD_CSR, *PRXF_XAUI_C_MMD_CSR;

      typedef union _RXF_XAUI_C_MMD_CSR_UNION {
         RXF_XAUI_C_MMD_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_C_MMD_CSR_UNION, *PRXF_XAUI_C_MMD_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_C_MMD_CSR_UNION, sizeof (RXF_XAUI_C_MMD_CSR_UNION) == 4);
   #endif


#else
   // XAUI SerDes Channel MMD register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_C_MMD_CSR {
         union {
            struct { 
               u32 c0_mmd : 2;                    // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 c1_mmd : 2;                    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 c2_mmd : 2;                    // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 c3_mmd : 2;                    // DWORD 0
               u32 rsvd3 : 2;                     // DWORD 0
               u32 c4_mmd : 2;                    // DWORD 0
               u32 rsvd4 : 2;                     // DWORD 0
               u32 c5_mmd : 2;                    // DWORD 0
               u32 rsvd5 : 2;                     // DWORD 0
               u32 c6_mmd : 2;                    // DWORD 0
               u32 rsvd6 : 2;                     // DWORD 0
               u32 c7_mmd : 2;                    // DWORD 0
               u32 rsvd7 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_C_MMD_CSR, *PRXF_XAUI_C_MMD_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_C_MMD_CSR, sizeof (RXF_XAUI_C_MMD_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_C_MMD_CSR {
         u32 c0_mmd : 2;                          // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 c1_mmd : 2;                          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 c2_mmd : 2;                          // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 c3_mmd : 2;                          // DWORD 0
         u32 rsvd3 : 2;                           // DWORD 0
         u32 c4_mmd : 2;                          // DWORD 0
         u32 rsvd4 : 2;                           // DWORD 0
         u32 c5_mmd : 2;                          // DWORD 0
         u32 rsvd5 : 2;                           // DWORD 0
         u32 c6_mmd : 2;                          // DWORD 0
         u32 rsvd6 : 2;                           // DWORD 0
         u32 c7_mmd : 2;                          // DWORD 0
         u32 rsvd7 : 2;                           // DWORD 0
      } SG_PACK RXF_XAUI_C_MMD_CSR, *PRXF_XAUI_C_MMD_CSR;

      typedef union _RXF_XAUI_C_MMD_CSR_UNION {
         RXF_XAUI_C_MMD_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_C_MMD_CSR_UNION, *PRXF_XAUI_C_MMD_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_C_MMD_CSR_UNION, sizeof (RXF_XAUI_C_MMD_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // XAUI SerDes Channel Emphasis register for channels 0 through 3
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CH_EMP_LO_CSR {
         union {
            struct { 
               u32 rsvd3 : 1;                     // DWORD 0
               u32 ch3_emp : 7;                   // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 ch2_emp : 7;                   // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ch1_emp : 7;                   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ch0_emp : 7;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CH_EMP_LO_CSR, *PRXF_XAUI_CH_EMP_LO_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EMP_LO_CSR, sizeof (RXF_XAUI_CH_EMP_LO_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CH_EMP_LO_CSR {
         u32 rsvd3 : 1;                           // DWORD 0
         u32 ch3_emp : 7;                         // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 ch2_emp : 7;                         // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ch1_emp : 7;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ch0_emp : 7;                         // DWORD 0
      } SG_PACK RXF_XAUI_CH_EMP_LO_CSR, *PRXF_XAUI_CH_EMP_LO_CSR;

      typedef union _RXF_XAUI_CH_EMP_LO_CSR_UNION {
         RXF_XAUI_CH_EMP_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CH_EMP_LO_CSR_UNION, *PRXF_XAUI_CH_EMP_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EMP_LO_CSR_UNION, sizeof (RXF_XAUI_CH_EMP_LO_CSR_UNION) == 4);
   #endif


#else
   // XAUI SerDes Channel Emphasis register for channels 0 through 3
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CH_EMP_LO_CSR {
         union {
            struct { 
               u32 ch0_emp : 7;                   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ch1_emp : 7;                   // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ch2_emp : 7;                   // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 ch3_emp : 7;                   // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CH_EMP_LO_CSR, *PRXF_XAUI_CH_EMP_LO_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EMP_LO_CSR, sizeof (RXF_XAUI_CH_EMP_LO_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CH_EMP_LO_CSR {
         u32 ch0_emp : 7;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ch1_emp : 7;                         // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ch2_emp : 7;                         // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 ch3_emp : 7;                         // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK RXF_XAUI_CH_EMP_LO_CSR, *PRXF_XAUI_CH_EMP_LO_CSR;

      typedef union _RXF_XAUI_CH_EMP_LO_CSR_UNION {
         RXF_XAUI_CH_EMP_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CH_EMP_LO_CSR_UNION, *PRXF_XAUI_CH_EMP_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EMP_LO_CSR_UNION, sizeof (RXF_XAUI_CH_EMP_LO_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // XAUI SerDes Channel Emphasis register for channels 4 through 7
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CH_EMP_HI_CSR {
         union {
            struct { 
               u32 rsvd3 : 1;                     // DWORD 0
               u32 ch7_emp : 7;                   // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 ch6_emp : 7;                   // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ch5_emp : 7;                   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ch4_emp : 7;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CH_EMP_HI_CSR, *PRXF_XAUI_CH_EMP_HI_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EMP_HI_CSR, sizeof (RXF_XAUI_CH_EMP_HI_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CH_EMP_HI_CSR {
         u32 rsvd3 : 1;                           // DWORD 0
         u32 ch7_emp : 7;                         // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 ch6_emp : 7;                         // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ch5_emp : 7;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ch4_emp : 7;                         // DWORD 0
      } SG_PACK RXF_XAUI_CH_EMP_HI_CSR, *PRXF_XAUI_CH_EMP_HI_CSR;

      typedef union _RXF_XAUI_CH_EMP_HI_CSR_UNION {
         RXF_XAUI_CH_EMP_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CH_EMP_HI_CSR_UNION, *PRXF_XAUI_CH_EMP_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EMP_HI_CSR_UNION, sizeof (RXF_XAUI_CH_EMP_HI_CSR_UNION) == 4);
   #endif


#else
   // XAUI SerDes Channel Emphasis register for channels 4 through 7
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CH_EMP_HI_CSR {
         union {
            struct { 
               u32 ch4_emp : 7;                   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ch5_emp : 7;                   // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ch6_emp : 7;                   // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 ch7_emp : 7;                   // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CH_EMP_HI_CSR, *PRXF_XAUI_CH_EMP_HI_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EMP_HI_CSR, sizeof (RXF_XAUI_CH_EMP_HI_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CH_EMP_HI_CSR {
         u32 ch4_emp : 7;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ch5_emp : 7;                         // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ch6_emp : 7;                         // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 ch7_emp : 7;                         // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK RXF_XAUI_CH_EMP_HI_CSR, *PRXF_XAUI_CH_EMP_HI_CSR;

      typedef union _RXF_XAUI_CH_EMP_HI_CSR_UNION {
         RXF_XAUI_CH_EMP_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CH_EMP_HI_CSR_UNION, *PRXF_XAUI_CH_EMP_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EMP_HI_CSR_UNION, sizeof (RXF_XAUI_CH_EMP_HI_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // XAUI SerDes Channel Equalization register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CH_EQ_CSR {
         union {
            struct { 
               u32 rsvd7 : 1;                     // DWORD 0
               u32 ch7_eq : 3;                    // DWORD 0
               u32 rsvd6 : 1;                     // DWORD 0
               u32 ch6_eq : 3;                    // DWORD 0
               u32 rsvd5 : 1;                     // DWORD 0
               u32 ch5_eq : 3;                    // DWORD 0
               u32 rsvd4 : 1;                     // DWORD 0
               u32 ch4_eq : 3;                    // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 ch3_eq : 3;                    // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 ch2_eq : 3;                    // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ch1_eq : 3;                    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ch0_eq : 3;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CH_EQ_CSR, *PRXF_XAUI_CH_EQ_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EQ_CSR, sizeof (RXF_XAUI_CH_EQ_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CH_EQ_CSR {
         u32 rsvd7 : 1;                           // DWORD 0
         u32 ch7_eq : 3;                          // DWORD 0
         u32 rsvd6 : 1;                           // DWORD 0
         u32 ch6_eq : 3;                          // DWORD 0
         u32 rsvd5 : 1;                           // DWORD 0
         u32 ch5_eq : 3;                          // DWORD 0
         u32 rsvd4 : 1;                           // DWORD 0
         u32 ch4_eq : 3;                          // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 ch3_eq : 3;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 ch2_eq : 3;                          // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ch1_eq : 3;                          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ch0_eq : 3;                          // DWORD 0
      } SG_PACK RXF_XAUI_CH_EQ_CSR, *PRXF_XAUI_CH_EQ_CSR;

      typedef union _RXF_XAUI_CH_EQ_CSR_UNION {
         RXF_XAUI_CH_EQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CH_EQ_CSR_UNION, *PRXF_XAUI_CH_EQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EQ_CSR_UNION, sizeof (RXF_XAUI_CH_EQ_CSR_UNION) == 4);
   #endif


#else
   // XAUI SerDes Channel Equalization register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CH_EQ_CSR {
         union {
            struct { 
               u32 ch0_eq : 3;                    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ch1_eq : 3;                    // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ch2_eq : 3;                    // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 ch3_eq : 3;                    // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 ch4_eq : 3;                    // DWORD 0
               u32 rsvd4 : 1;                     // DWORD 0
               u32 ch5_eq : 3;                    // DWORD 0
               u32 rsvd5 : 1;                     // DWORD 0
               u32 ch6_eq : 3;                    // DWORD 0
               u32 rsvd6 : 1;                     // DWORD 0
               u32 ch7_eq : 3;                    // DWORD 0
               u32 rsvd7 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CH_EQ_CSR, *PRXF_XAUI_CH_EQ_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EQ_CSR, sizeof (RXF_XAUI_CH_EQ_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CH_EQ_CSR {
         u32 ch0_eq : 3;                          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ch1_eq : 3;                          // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ch2_eq : 3;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 ch3_eq : 3;                          // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 ch4_eq : 3;                          // DWORD 0
         u32 rsvd4 : 1;                           // DWORD 0
         u32 ch5_eq : 3;                          // DWORD 0
         u32 rsvd5 : 1;                           // DWORD 0
         u32 ch6_eq : 3;                          // DWORD 0
         u32 rsvd6 : 1;                           // DWORD 0
         u32 ch7_eq : 3;                          // DWORD 0
         u32 rsvd7 : 1;                           // DWORD 0
      } SG_PACK RXF_XAUI_CH_EQ_CSR, *PRXF_XAUI_CH_EQ_CSR;

      typedef union _RXF_XAUI_CH_EQ_CSR_UNION {
         RXF_XAUI_CH_EQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CH_EQ_CSR_UNION, *PRXF_XAUI_CH_EQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CH_EQ_CSR_UNION, sizeof (RXF_XAUI_CH_EQ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // XAUI SerDes Configuration register 2
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CFG2_CSR {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 cispcen : 1;                   // DWORD 0
               u32 cistcsel : 1;                  // DWORD 0
               u32 cisrcpsen : 1;                 // DWORD 0
               u32 cisrbufsel : 1;                // DWORD 0
               u32 cisdrbco : 1;                  // DWORD 0
               u32 cisbcen : 1;                   // DWORD 0
               u32 cispllen : 1;                  // DWORD 0
               u32 cisrren : 1;                   // DWORD 0
               u32 cisrefcen : 1;                 // DWORD 0
               u32 cisrcren : 1;                  // DWORD 0
               u32 cissdsel : 1;                  // DWORD 0
               u32 cisme : 1;                     // DWORD 0
               u32 c7_tismmd : 2;                 // DWORD 0
               u32 c6_tismmd : 2;                 // DWORD 0
               u32 c5_tismmd : 2;                 // DWORD 0
               u32 c4_tismmd : 2;                 // DWORD 0
               u32 c3_tismmd : 2;                 // DWORD 0
               u32 c2_tismmd : 2;                 // DWORD 0
               u32 c1_tismmd : 2;                 // DWORD 0
               u32 c0_tismmd : 2;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CFG2_CSR, *PRXF_XAUI_CFG2_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG2_CSR, sizeof (RXF_XAUI_CFG2_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CFG2_CSR {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 cispcen : 1;                         // DWORD 0
         u32 cistcsel : 1;                        // DWORD 0
         u32 cisrcpsen : 1;                       // DWORD 0
         u32 cisrbufsel : 1;                      // DWORD 0
         u32 cisdrbco : 1;                        // DWORD 0
         u32 cisbcen : 1;                         // DWORD 0
         u32 cispllen : 1;                        // DWORD 0
         u32 cisrren : 1;                         // DWORD 0
         u32 cisrefcen : 1;                       // DWORD 0
         u32 cisrcren : 1;                        // DWORD 0
         u32 cissdsel : 1;                        // DWORD 0
         u32 cisme : 1;                           // DWORD 0
         u32 c7_tismmd : 2;                       // DWORD 0
         u32 c6_tismmd : 2;                       // DWORD 0
         u32 c5_tismmd : 2;                       // DWORD 0
         u32 c4_tismmd : 2;                       // DWORD 0
         u32 c3_tismmd : 2;                       // DWORD 0
         u32 c2_tismmd : 2;                       // DWORD 0
         u32 c1_tismmd : 2;                       // DWORD 0
         u32 c0_tismmd : 2;                       // DWORD 0
      } SG_PACK RXF_XAUI_CFG2_CSR, *PRXF_XAUI_CFG2_CSR;

      typedef union _RXF_XAUI_CFG2_CSR_UNION {
         RXF_XAUI_CFG2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CFG2_CSR_UNION, *PRXF_XAUI_CFG2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG2_CSR_UNION, sizeof (RXF_XAUI_CFG2_CSR_UNION) == 4);
   #endif


#else
   // XAUI SerDes Configuration register 2
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CFG2_CSR {
         union {
            struct { 
               u32 c0_tismmd : 2;                 // DWORD 0
               u32 c1_tismmd : 2;                 // DWORD 0
               u32 c2_tismmd : 2;                 // DWORD 0
               u32 c3_tismmd : 2;                 // DWORD 0
               u32 c4_tismmd : 2;                 // DWORD 0
               u32 c5_tismmd : 2;                 // DWORD 0
               u32 c6_tismmd : 2;                 // DWORD 0
               u32 c7_tismmd : 2;                 // DWORD 0
               u32 cisme : 1;                     // DWORD 0
               u32 cissdsel : 1;                  // DWORD 0
               u32 cisrcren : 1;                  // DWORD 0
               u32 cisrefcen : 1;                 // DWORD 0
               u32 cisrren : 1;                   // DWORD 0
               u32 cispllen : 1;                  // DWORD 0
               u32 cisbcen : 1;                   // DWORD 0
               u32 cisdrbco : 1;                  // DWORD 0
               u32 cisrbufsel : 1;                // DWORD 0
               u32 cisrcpsen : 1;                 // DWORD 0
               u32 cistcsel : 1;                  // DWORD 0
               u32 cispcen : 1;                   // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CFG2_CSR, *PRXF_XAUI_CFG2_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG2_CSR, sizeof (RXF_XAUI_CFG2_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CFG2_CSR {
         u32 c0_tismmd : 2;                       // DWORD 0
         u32 c1_tismmd : 2;                       // DWORD 0
         u32 c2_tismmd : 2;                       // DWORD 0
         u32 c3_tismmd : 2;                       // DWORD 0
         u32 c4_tismmd : 2;                       // DWORD 0
         u32 c5_tismmd : 2;                       // DWORD 0
         u32 c6_tismmd : 2;                       // DWORD 0
         u32 c7_tismmd : 2;                       // DWORD 0
         u32 cisme : 1;                           // DWORD 0
         u32 cissdsel : 1;                        // DWORD 0
         u32 cisrcren : 1;                        // DWORD 0
         u32 cisrefcen : 1;                       // DWORD 0
         u32 cisrren : 1;                         // DWORD 0
         u32 cispllen : 1;                        // DWORD 0
         u32 cisbcen : 1;                         // DWORD 0
         u32 cisdrbco : 1;                        // DWORD 0
         u32 cisrbufsel : 1;                      // DWORD 0
         u32 cisrcpsen : 1;                       // DWORD 0
         u32 cistcsel : 1;                        // DWORD 0
         u32 cispcen : 1;                         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK RXF_XAUI_CFG2_CSR, *PRXF_XAUI_CFG2_CSR;

      typedef union _RXF_XAUI_CFG2_CSR_UNION {
         RXF_XAUI_CFG2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CFG2_CSR_UNION, *PRXF_XAUI_CFG2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG2_CSR_UNION, sizeof (RXF_XAUI_CFG2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // XAUI SerDes Configuration register 3
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CFG3_CSR {
         union {
            struct { 
               u32 rsvd0 : 20;                    // DWORD 0
               u32 force_cis_enable : 1;          // DWORD 0
               u32 force_cispm : 2;               // DWORD 0
               u32 force_cismmr : 4;              // DWORD 0
               u32 force_cismmc : 5;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CFG3_CSR, *PRXF_XAUI_CFG3_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG3_CSR, sizeof (RXF_XAUI_CFG3_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CFG3_CSR {
         u32 rsvd0 : 20;                          // DWORD 0
         u32 force_cis_enable : 1;                // DWORD 0
         u32 force_cispm : 2;                     // DWORD 0
         u32 force_cismmr : 4;                    // DWORD 0
         u32 force_cismmc : 5;                    // DWORD 0
      } SG_PACK RXF_XAUI_CFG3_CSR, *PRXF_XAUI_CFG3_CSR;

      typedef union _RXF_XAUI_CFG3_CSR_UNION {
         RXF_XAUI_CFG3_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CFG3_CSR_UNION, *PRXF_XAUI_CFG3_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG3_CSR_UNION, sizeof (RXF_XAUI_CFG3_CSR_UNION) == 4);
   #endif


#else
   // XAUI SerDes Configuration register 3
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CFG3_CSR {
         union {
            struct { 
               u32 force_cismmc : 5;              // DWORD 0
               u32 force_cismmr : 4;              // DWORD 0
               u32 force_cispm : 2;               // DWORD 0
               u32 force_cis_enable : 1;          // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CFG3_CSR, *PRXF_XAUI_CFG3_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG3_CSR, sizeof (RXF_XAUI_CFG3_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CFG3_CSR {
         u32 force_cismmc : 5;                    // DWORD 0
         u32 force_cismmr : 4;                    // DWORD 0
         u32 force_cispm : 2;                     // DWORD 0
         u32 force_cis_enable : 1;                // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
      } SG_PACK RXF_XAUI_CFG3_CSR, *PRXF_XAUI_CFG3_CSR;

      typedef union _RXF_XAUI_CFG3_CSR_UNION {
         RXF_XAUI_CFG3_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CFG3_CSR_UNION, *PRXF_XAUI_CFG3_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG3_CSR_UNION, sizeof (RXF_XAUI_CFG3_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // XAUI SerDes Configuration register 4
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CFG4_CSR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 tisrdcnt : 8;                  // DWORD 0
               u32 rissden : 8;                   // DWORD 0
               u32 risbacnt : 8;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CFG4_CSR, *PRXF_XAUI_CFG4_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG4_CSR, sizeof (RXF_XAUI_CFG4_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CFG4_CSR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 tisrdcnt : 8;                        // DWORD 0
         u32 rissden : 8;                         // DWORD 0
         u32 risbacnt : 8;                        // DWORD 0
      } SG_PACK RXF_XAUI_CFG4_CSR, *PRXF_XAUI_CFG4_CSR;

      typedef union _RXF_XAUI_CFG4_CSR_UNION {
         RXF_XAUI_CFG4_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CFG4_CSR_UNION, *PRXF_XAUI_CFG4_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG4_CSR_UNION, sizeof (RXF_XAUI_CFG4_CSR_UNION) == 4);
   #endif


#else
   // XAUI SerDes Configuration register 4
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_XAUI_CFG4_CSR {
         union {
            struct { 
               u32 risbacnt : 8;                  // DWORD 0
               u32 rissden : 8;                   // DWORD 0
               u32 tisrdcnt : 8;                  // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_XAUI_CFG4_CSR, *PRXF_XAUI_CFG4_CSR;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG4_CSR, sizeof (RXF_XAUI_CFG4_CSR) == 4);

   #else
      typedef struct _RXF_XAUI_CFG4_CSR {
         u32 risbacnt : 8;                        // DWORD 0
         u32 rissden : 8;                         // DWORD 0
         u32 tisrdcnt : 8;                        // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK RXF_XAUI_CFG4_CSR, *PRXF_XAUI_CFG4_CSR;

      typedef union _RXF_XAUI_CFG4_CSR_UNION {
         RXF_XAUI_CFG4_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_XAUI_CFG4_CSR_UNION, *PRXF_XAUI_CFG4_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_XAUI_CFG4_CSR_UNION, sizeof (RXF_XAUI_CFG4_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FCoE ethertype
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_FCOE_TYPE_CSR {
         union {
            struct { 
               u32 fip_type : 16;                 // DWORD 0
               u32 fcoe_type : 16;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_FCOE_TYPE_CSR, *PRXF_FCOE_TYPE_CSR;

      SG_C_ASSERT(__sizeof__RXF_FCOE_TYPE_CSR, sizeof (RXF_FCOE_TYPE_CSR) == 4);

   #else
      typedef struct _RXF_FCOE_TYPE_CSR {
         u32 fip_type : 16;                       // DWORD 0
         u32 fcoe_type : 16;                      // DWORD 0
      } SG_PACK RXF_FCOE_TYPE_CSR, *PRXF_FCOE_TYPE_CSR;

      typedef union _RXF_FCOE_TYPE_CSR_UNION {
         RXF_FCOE_TYPE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_FCOE_TYPE_CSR_UNION, *PRXF_FCOE_TYPE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_FCOE_TYPE_CSR_UNION, sizeof (RXF_FCOE_TYPE_CSR_UNION) == 4);
   #endif


#else
   // FCoE ethertype
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_FCOE_TYPE_CSR {
         union {
            struct { 
               u32 fcoe_type : 16;                // DWORD 0
               u32 fip_type : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_FCOE_TYPE_CSR, *PRXF_FCOE_TYPE_CSR;

      SG_C_ASSERT(__sizeof__RXF_FCOE_TYPE_CSR, sizeof (RXF_FCOE_TYPE_CSR) == 4);

   #else
      typedef struct _RXF_FCOE_TYPE_CSR {
         u32 fcoe_type : 16;                      // DWORD 0
         u32 fip_type : 16;                       // DWORD 0
      } SG_PACK RXF_FCOE_TYPE_CSR, *PRXF_FCOE_TYPE_CSR;

      typedef union _RXF_FCOE_TYPE_CSR_UNION {
         RXF_FCOE_TYPE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_FCOE_TYPE_CSR_UNION, *PRXF_FCOE_TYPE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_FCOE_TYPE_CSR_UNION, sizeof (RXF_FCOE_TYPE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // 802.1AU control frame ethertype
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_802_1AU_TYPE_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 dot1au_type : 16;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_802_1AU_TYPE_CSR, *PRXF_802_1AU_TYPE_CSR;

      SG_C_ASSERT(__sizeof__RXF_802_1AU_TYPE_CSR, sizeof (RXF_802_1AU_TYPE_CSR) == 4);

   #else
      typedef struct _RXF_802_1AU_TYPE_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 dot1au_type : 16;                    // DWORD 0
      } SG_PACK RXF_802_1AU_TYPE_CSR, *PRXF_802_1AU_TYPE_CSR;

      typedef union _RXF_802_1AU_TYPE_CSR_UNION {
         RXF_802_1AU_TYPE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_802_1AU_TYPE_CSR_UNION, *PRXF_802_1AU_TYPE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_802_1AU_TYPE_CSR_UNION, sizeof (RXF_802_1AU_TYPE_CSR_UNION) == 4);
   #endif


#else
   // 802.1AU control frame ethertype
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_802_1AU_TYPE_CSR {
         union {
            struct { 
               u32 dot1au_type : 16;              // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_802_1AU_TYPE_CSR, *PRXF_802_1AU_TYPE_CSR;

      SG_C_ASSERT(__sizeof__RXF_802_1AU_TYPE_CSR, sizeof (RXF_802_1AU_TYPE_CSR) == 4);

   #else
      typedef struct _RXF_802_1AU_TYPE_CSR {
         u32 dot1au_type : 16;                    // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK RXF_802_1AU_TYPE_CSR, *PRXF_802_1AU_TYPE_CSR;

      typedef union _RXF_802_1AU_TYPE_CSR_UNION {
         RXF_802_1AU_TYPE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_802_1AU_TYPE_CSR_UNION, *PRXF_802_1AU_TYPE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_802_1AU_TYPE_CSR_UNION, sizeof (RXF_802_1AU_TYPE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Credit Based Flow Control Ethernet Control Frame Opcode
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_CBFC_OPCODE_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 cbfc_opcode : 16;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_CBFC_OPCODE_CSR, *PRXF_CBFC_OPCODE_CSR;

      SG_C_ASSERT(__sizeof__RXF_CBFC_OPCODE_CSR, sizeof (RXF_CBFC_OPCODE_CSR) == 4);

   #else
      typedef struct _RXF_CBFC_OPCODE_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 cbfc_opcode : 16;                    // DWORD 0
      } SG_PACK RXF_CBFC_OPCODE_CSR, *PRXF_CBFC_OPCODE_CSR;

      typedef union _RXF_CBFC_OPCODE_CSR_UNION {
         RXF_CBFC_OPCODE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_CBFC_OPCODE_CSR_UNION, *PRXF_CBFC_OPCODE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_CBFC_OPCODE_CSR_UNION, sizeof (RXF_CBFC_OPCODE_CSR_UNION) == 4);
   #endif


#else
   // Credit Based Flow Control Ethernet Control Frame Opcode
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_CBFC_OPCODE_CSR {
         union {
            struct { 
               u32 cbfc_opcode : 16;              // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_CBFC_OPCODE_CSR, *PRXF_CBFC_OPCODE_CSR;

      SG_C_ASSERT(__sizeof__RXF_CBFC_OPCODE_CSR, sizeof (RXF_CBFC_OPCODE_CSR) == 4);

   #else
      typedef struct _RXF_CBFC_OPCODE_CSR {
         u32 cbfc_opcode : 16;                    // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK RXF_CBFC_OPCODE_CSR, *PRXF_CBFC_OPCODE_CSR;

      typedef union _RXF_CBFC_OPCODE_CSR_UNION {
         RXF_CBFC_OPCODE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_CBFC_OPCODE_CSR_UNION, *PRXF_CBFC_OPCODE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_CBFC_OPCODE_CSR_UNION, sizeof (RXF_CBFC_OPCODE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The interface that DMTF Network Controller Sideband Interface (NC-SI) packets go to
   // when received on the 100Mb management port. These packets should be sent to a ring
   // that the ARM controls, so it may respond to register requests from the management
   // chip to this device.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_DMTF_INTERFACE_CSR {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 dmtf_interface : 6;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_DMTF_INTERFACE_CSR, *PRXF_DMTF_INTERFACE_CSR;

      SG_C_ASSERT(__sizeof__RXF_DMTF_INTERFACE_CSR, sizeof (RXF_DMTF_INTERFACE_CSR) == 4);

   #else
      typedef struct _RXF_DMTF_INTERFACE_CSR {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 dmtf_interface : 6;                  // DWORD 0
      } SG_PACK RXF_DMTF_INTERFACE_CSR, *PRXF_DMTF_INTERFACE_CSR;

      typedef union _RXF_DMTF_INTERFACE_CSR_UNION {
         RXF_DMTF_INTERFACE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_DMTF_INTERFACE_CSR_UNION, *PRXF_DMTF_INTERFACE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_DMTF_INTERFACE_CSR_UNION, sizeof (RXF_DMTF_INTERFACE_CSR_UNION) == 4);
   #endif


#else
   // The interface that DMTF Network Controller Sideband Interface (NC-SI) packets go to
   // when received on the 100Mb management port. These packets should be sent to a ring
   // that the ARM controls, so it may respond to register requests from the management
   // chip to this device.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_DMTF_INTERFACE_CSR {
         union {
            struct { 
               u32 dmtf_interface : 6;            // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_DMTF_INTERFACE_CSR, *PRXF_DMTF_INTERFACE_CSR;

      SG_C_ASSERT(__sizeof__RXF_DMTF_INTERFACE_CSR, sizeof (RXF_DMTF_INTERFACE_CSR) == 4);

   #else
      typedef struct _RXF_DMTF_INTERFACE_CSR {
         u32 dmtf_interface : 6;                  // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
      } SG_PACK RXF_DMTF_INTERFACE_CSR, *PRXF_DMTF_INTERFACE_CSR;

      typedef union _RXF_DMTF_INTERFACE_CSR_UNION {
         RXF_DMTF_INTERFACE_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_DMTF_INTERFACE_CSR_UNION, *PRXF_DMTF_INTERFACE_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_DMTF_INTERFACE_CSR_UNION, sizeof (RXF_DMTF_INTERFACE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port 0 promiscuous VLAN vector (lower 32 bits). This is used when a tagged packet
   // misses the VLAN lookup.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO {
         union {
            struct { 
               u32 vector_lo;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO) == 4);

   #else
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO {
         u32 vector_lo;                           // DWORD 0
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO;

      typedef union _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO_UNION {
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO_UNION, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO_UNION, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO_UNION) == 4);
   #endif


#else
   // Port 0 promiscuous VLAN vector (lower 32 bits). This is used when a tagged packet
   // misses the VLAN lookup.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO {
         union {
            struct { 
               u32 vector_lo;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO) == 4);

   #else
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO {
         u32 vector_lo;                           // DWORD 0
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO;

      typedef union _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO_UNION {
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO_UNION, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO_UNION, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port 0 promiscuous VLAN vector (upper 5 bits). This is used when a tagged packet
   // misses the VLAN lookup.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 vector_hi : 5;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI) == 4);

   #else
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 vector_hi : 5;                       // DWORD 0
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI;

      typedef union _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI_UNION {
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI_UNION, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI_UNION, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI_UNION) == 4);
   #endif


#else
   // Port 0 promiscuous VLAN vector (upper 5 bits). This is used when a tagged packet
   // misses the VLAN lookup.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI {
         union {
            struct { 
               u32 vector_hi : 5;                 // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI) == 4);

   #else
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI {
         u32 vector_hi : 5;                       // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI;

      typedef union _RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI_UNION {
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI_UNION, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI_UNION, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port 1 promiscuous VLAN vector (lower 32 bits). This is used when a tagged packet
   // misses the VLAN lookup.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO {
         union {
            struct { 
               u32 vector_lo;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO) == 4);

   #else
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO {
         u32 vector_lo;                           // DWORD 0
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO;

      typedef union _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO_UNION {
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO_UNION, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO_UNION, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO_UNION) == 4);
   #endif


#else
   // Port 1 promiscuous VLAN vector (lower 32 bits). This is used when a tagged packet
   // misses the VLAN lookup.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO {
         union {
            struct { 
               u32 vector_lo;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO) == 4);

   #else
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO {
         u32 vector_lo;                           // DWORD 0
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO;

      typedef union _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO_UNION {
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO_UNION, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO_UNION, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port 1 promiscuous VLAN vector (upper 5 bits). This is used when a tagged packet
   // misses the VLAN lookup.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 vector_hi : 5;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI) == 4);

   #else
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 vector_hi : 5;                       // DWORD 0
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI;

      typedef union _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI_UNION {
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI_UNION, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI_UNION, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI_UNION) == 4);
   #endif


#else
   // Port 1 promiscuous VLAN vector (upper 5 bits). This is used when a tagged packet
   // misses the VLAN lookup.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI {
         union {
            struct { 
               u32 vector_hi : 5;                 // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI) == 4);

   #else
      typedef struct _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI {
         u32 vector_hi : 5;                       // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI;

      typedef union _RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI_UNION {
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI_UNION, *PRXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI_UNION, sizeof (RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port 0 untagged VLAN vector (lower 32 bits). This is used for untagged packets.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO {
         union {
            struct { 
               u32 vector_lo;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_LO;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO) == 4);

   #else
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO {
         u32 vector_lo;                           // DWORD 0
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_LO;

      typedef union _RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO_UNION {
         RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO_UNION, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO_UNION, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO_UNION) == 4);
   #endif


#else
   // Port 0 untagged VLAN vector (lower 32 bits). This is used for untagged packets.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO {
         union {
            struct { 
               u32 vector_lo;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_LO;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO) == 4);

   #else
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO {
         u32 vector_lo;                           // DWORD 0
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_LO;

      typedef union _RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO_UNION {
         RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO_UNION, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO_UNION, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port 0 untagged VLAN vector (upper 5 bits). This is used for untagged packets.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 vector_hi : 5;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_HI;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI) == 4);

   #else
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 vector_hi : 5;                       // DWORD 0
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_HI;

      typedef union _RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI_UNION {
         RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI_UNION, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI_UNION, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI_UNION) == 4);
   #endif


#else
   // Port 0 untagged VLAN vector (upper 5 bits). This is used for untagged packets.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI {
         union {
            struct { 
               u32 vector_hi : 5;                 // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_HI;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI) == 4);

   #else
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI {
         u32 vector_hi : 5;                       // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_HI;

      typedef union _RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI_UNION {
         RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI_UNION, *PRXF_UNTAGGED_VLAN_VECTOR_PORT0_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI_UNION, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port 1 untagged VLAN vector (lower 32 bits). This is used for untagged packets.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO {
         union {
            struct { 
               u32 vector_lo;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_LO;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO) == 4);

   #else
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO {
         u32 vector_lo;                           // DWORD 0
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_LO;

      typedef union _RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO_UNION {
         RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO_UNION, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO_UNION, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO_UNION) == 4);
   #endif


#else
   // Port 1 untagged VLAN vector (lower 32 bits). This is used for untagged packets.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO {
         union {
            struct { 
               u32 vector_lo;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_LO;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO) == 4);

   #else
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO {
         u32 vector_lo;                           // DWORD 0
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_LO;

      typedef union _RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO_UNION {
         RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO_UNION, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO_UNION, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port 1 untagged VLAN vector (upper 5 bits). This is used for untagged packets.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 vector_hi : 5;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_HI;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI) == 4);

   #else
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 vector_hi : 5;                       // DWORD 0
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_HI;

      typedef union _RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI_UNION {
         RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI_UNION, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI_UNION, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI_UNION) == 4);
   #endif


#else
   // Port 1 untagged VLAN vector (upper 5 bits). This is used for untagged packets.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI {
         union {
            struct { 
               u32 vector_hi : 5;                 // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_HI;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI) == 4);

   #else
      typedef struct _RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI {
         u32 vector_hi : 5;                       // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_HI;

      typedef union _RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI_UNION {
         RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI_UNION, *PRXF_UNTAGGED_VLAN_VECTOR_PORT1_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI_UNION, sizeof (RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // interface enable bits for interfaces 31-0. This vector is ANDed with the final
   // unicast/multicast/broadcast/vlan receive vectors to determine which receive
   // interface(s) the packet will go to. To disable a given interface, simply clear the
   // corresponding bit in this vector.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_INTERFACE_EN_LO {
         union {
            struct { 
               u32 vector_lo;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_INTERFACE_EN_LO, *PRXF_INTERFACE_EN_LO;

      SG_C_ASSERT(__sizeof__RXF_INTERFACE_EN_LO, sizeof (RXF_INTERFACE_EN_LO) == 4);

   #else
      typedef struct _RXF_INTERFACE_EN_LO {
         u32 vector_lo;                           // DWORD 0
      } SG_PACK RXF_INTERFACE_EN_LO, *PRXF_INTERFACE_EN_LO;

      typedef union _RXF_INTERFACE_EN_LO_UNION {
         RXF_INTERFACE_EN_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_INTERFACE_EN_LO_UNION, *PRXF_INTERFACE_EN_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_INTERFACE_EN_LO_UNION, sizeof (RXF_INTERFACE_EN_LO_UNION) == 4);
   #endif


#else
   // interface enable bits for interfaces 31-0. This vector is ANDed with the final
   // unicast/multicast/broadcast/vlan receive vectors to determine which receive
   // interface(s) the packet will go to. To disable a given interface, simply clear the
   // corresponding bit in this vector.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_INTERFACE_EN_LO {
         union {
            struct { 
               u32 vector_lo;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_INTERFACE_EN_LO, *PRXF_INTERFACE_EN_LO;

      SG_C_ASSERT(__sizeof__RXF_INTERFACE_EN_LO, sizeof (RXF_INTERFACE_EN_LO) == 4);

   #else
      typedef struct _RXF_INTERFACE_EN_LO {
         u32 vector_lo;                           // DWORD 0
      } SG_PACK RXF_INTERFACE_EN_LO, *PRXF_INTERFACE_EN_LO;

      typedef union _RXF_INTERFACE_EN_LO_UNION {
         RXF_INTERFACE_EN_LO bits;
         u32 dw; // dword union
      } SG_PACK RXF_INTERFACE_EN_LO_UNION, *PRXF_INTERFACE_EN_LO_UNION;

      SG_C_ASSERT(__sizeof__RXF_INTERFACE_EN_LO_UNION, sizeof (RXF_INTERFACE_EN_LO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // interface enable bits for interfaces 36-32. This vector is ANDed with the final
   // unicast/multicast/broadcast/vlan receive vectors to determine which receive
   // interface(s) the packet will go to. To disable a given interface, simply clear the
   // corresponding bit in this vector.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_INTERFACE_EN_HI {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 vector_hi : 5;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_INTERFACE_EN_HI, *PRXF_INTERFACE_EN_HI;

      SG_C_ASSERT(__sizeof__RXF_INTERFACE_EN_HI, sizeof (RXF_INTERFACE_EN_HI) == 4);

   #else
      typedef struct _RXF_INTERFACE_EN_HI {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 vector_hi : 5;                       // DWORD 0
      } SG_PACK RXF_INTERFACE_EN_HI, *PRXF_INTERFACE_EN_HI;

      typedef union _RXF_INTERFACE_EN_HI_UNION {
         RXF_INTERFACE_EN_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_INTERFACE_EN_HI_UNION, *PRXF_INTERFACE_EN_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_INTERFACE_EN_HI_UNION, sizeof (RXF_INTERFACE_EN_HI_UNION) == 4);
   #endif


#else
   // interface enable bits for interfaces 36-32. This vector is ANDed with the final
   // unicast/multicast/broadcast/vlan receive vectors to determine which receive
   // interface(s) the packet will go to. To disable a given interface, simply clear the
   // corresponding bit in this vector.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_INTERFACE_EN_HI {
         union {
            struct { 
               u32 vector_hi : 5;                 // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_INTERFACE_EN_HI, *PRXF_INTERFACE_EN_HI;

      SG_C_ASSERT(__sizeof__RXF_INTERFACE_EN_HI, sizeof (RXF_INTERFACE_EN_HI) == 4);

   #else
      typedef struct _RXF_INTERFACE_EN_HI {
         u32 vector_hi : 5;                       // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK RXF_INTERFACE_EN_HI, *PRXF_INTERFACE_EN_HI;

      typedef union _RXF_INTERFACE_EN_HI_UNION {
         RXF_INTERFACE_EN_HI bits;
         u32 dw; // dword union
      } SG_PACK RXF_INTERFACE_EN_HI_UNION, *PRXF_INTERFACE_EN_HI_UNION;

      SG_C_ASSERT(__sizeof__RXF_INTERFACE_EN_HI_UNION, sizeof (RXF_INTERFACE_EN_HI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Soft reset command register for the various RXF CAM modules. Writting a 1 to a soft
   // reset bit will clear all the internal valid bits in the associated CAM. The bits are
   // self-clearing, so only 0's will be read
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_CAM_SOFT_RESET {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 fcoe_cam : 1;                  // DWORD 0
               u32 connection_cam : 1;            // DWORD 0
               u32 da_cam : 1;                    // DWORD 0
               u32 vlan_cam : 1;                  // DWORD 0
               u32 mac_cam : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_CAM_SOFT_RESET, *PRXF_CAM_SOFT_RESET;

      SG_C_ASSERT(__sizeof__RXF_CAM_SOFT_RESET, sizeof (RXF_CAM_SOFT_RESET) == 4);

   #else
      typedef struct _RXF_CAM_SOFT_RESET {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 fcoe_cam : 1;                        // DWORD 0
         u32 connection_cam : 1;                  // DWORD 0
         u32 da_cam : 1;                          // DWORD 0
         u32 vlan_cam : 1;                        // DWORD 0
         u32 mac_cam : 1;                         // DWORD 0
      } SG_PACK RXF_CAM_SOFT_RESET, *PRXF_CAM_SOFT_RESET;

      typedef union _RXF_CAM_SOFT_RESET_UNION {
         RXF_CAM_SOFT_RESET bits;
         u32 dw; // dword union
      } SG_PACK RXF_CAM_SOFT_RESET_UNION, *PRXF_CAM_SOFT_RESET_UNION;

      SG_C_ASSERT(__sizeof__RXF_CAM_SOFT_RESET_UNION, sizeof (RXF_CAM_SOFT_RESET_UNION) == 4);
   #endif


#else
   // Soft reset command register for the various RXF CAM modules. Writting a 1 to a soft
   // reset bit will clear all the internal valid bits in the associated CAM. The bits are
   // self-clearing, so only 0's will be read
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_CAM_SOFT_RESET {
         union {
            struct { 
               u32 mac_cam : 1;                   // DWORD 0
               u32 vlan_cam : 1;                  // DWORD 0
               u32 da_cam : 1;                    // DWORD 0
               u32 connection_cam : 1;            // DWORD 0
               u32 fcoe_cam : 1;                  // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_CAM_SOFT_RESET, *PRXF_CAM_SOFT_RESET;

      SG_C_ASSERT(__sizeof__RXF_CAM_SOFT_RESET, sizeof (RXF_CAM_SOFT_RESET) == 4);

   #else
      typedef struct _RXF_CAM_SOFT_RESET {
         u32 mac_cam : 1;                         // DWORD 0
         u32 vlan_cam : 1;                        // DWORD 0
         u32 da_cam : 1;                          // DWORD 0
         u32 connection_cam : 1;                  // DWORD 0
         u32 fcoe_cam : 1;                        // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK RXF_CAM_SOFT_RESET, *PRXF_CAM_SOFT_RESET;

      typedef union _RXF_CAM_SOFT_RESET_UNION {
         RXF_CAM_SOFT_RESET bits;
         u32 dw; // dword union
      } SG_PACK RXF_CAM_SOFT_RESET_UNION, *PRXF_CAM_SOFT_RESET_UNION;

      SG_C_ASSERT(__sizeof__RXF_CAM_SOFT_RESET_UNION, sizeof (RXF_CAM_SOFT_RESET_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw unrecoverable error source bits. Write a 1 to clear 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UE_SOURCE {
         union {
            struct { 
               u32 fifo0_fcoe_perr : 1;           // DWORD 0
               u32 fifo1_fcoe_perr : 1;           // DWORD 0
               u32 perr_rxips_in : 1;             // DWORD 0
               u32 perr_txp_in : 1;               // DWORD 0
               u32 txp_rxf_mac_fifo_overflow : 1; // DWORD 0
               u32 txp_rxf_mac_fifo_underflow : 1; // DWORD 0
               u32 mac0_syncfifo_overflow : 1;    // DWORD 0
               u32 mac0_syncfifo_underflow : 1;   // DWORD 0
               u32 mac1_syncfifo_overflow : 1;    // DWORD 0
               u32 mac1_syncfifo_underflow : 1;   // DWORD 0
               u32 mgmt_syncfifo_overflow : 1;    // DWORD 0
               u32 mgmt_syncfifo_underflow : 1;   // DWORD 0
               u32 mgmt_tx_syncfifo_overflow : 1; // DWORD 0
               u32 mgmt_tx_syncfifo_underflow : 1; // DWORD 0
               u32 tsv0_syncfifo_overflow : 1;    // DWORD 0
               u32 tsv0_syncfifo_underflow : 1;   // DWORD 0
               u32 tsv1_syncfifo_overflow_ue : 1; // DWORD 0
               u32 tsv1_syncfifo_underflow_ue : 1; // DWORD 0
               u32 shared_mac_ue : 1;             // DWORD 0
               u32 mac1_ue : 1;                   // DWORD 0
               u32 mac0_ue : 1;                   // DWORD 0
               u32 pctl1_rxf_err_sync_ue : 1;     // DWORD 0
               u32 pctl0_rxf_err_sync_ue : 1;     // DWORD 0
               u32 txp_fifo_overflow : 1;         // DWORD 0
               u32 fifot_perr_ue : 1;             // DWORD 0
               u32 fifoi_perr_ue : 1;             // DWORD 0
               u32 fifom_perr_ue : 1;             // DWORD 0
               u32 fifo1_perr_ue : 1;             // DWORD 0
               u32 fifo0_perr_ue : 1;             // DWORD 0
               u32 conn_perr_ue : 1;              // DWORD 0
               u32 vlan_perr_ue : 1;              // DWORD 0
               u32 mac_perr_ue : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UE_SOURCE, *PRXF_UE_SOURCE;

      SG_C_ASSERT(__sizeof__RXF_UE_SOURCE, sizeof (RXF_UE_SOURCE) == 4);

   #else
      typedef struct _RXF_UE_SOURCE {
         u32 fifo0_fcoe_perr : 1;                 // DWORD 0
         u32 fifo1_fcoe_perr : 1;                 // DWORD 0
         u32 perr_rxips_in : 1;                   // DWORD 0
         u32 perr_txp_in : 1;                     // DWORD 0
         u32 txp_rxf_mac_fifo_overflow : 1;       // DWORD 0
         u32 txp_rxf_mac_fifo_underflow : 1;      // DWORD 0
         u32 mac0_syncfifo_overflow : 1;          // DWORD 0
         u32 mac0_syncfifo_underflow : 1;         // DWORD 0
         u32 mac1_syncfifo_overflow : 1;          // DWORD 0
         u32 mac1_syncfifo_underflow : 1;         // DWORD 0
         u32 mgmt_syncfifo_overflow : 1;          // DWORD 0
         u32 mgmt_syncfifo_underflow : 1;         // DWORD 0
         u32 mgmt_tx_syncfifo_overflow : 1;       // DWORD 0
         u32 mgmt_tx_syncfifo_underflow : 1;      // DWORD 0
         u32 tsv0_syncfifo_overflow : 1;          // DWORD 0
         u32 tsv0_syncfifo_underflow : 1;         // DWORD 0
         u32 tsv1_syncfifo_overflow_ue : 1;       // DWORD 0
         u32 tsv1_syncfifo_underflow_ue : 1;      // DWORD 0
         u32 shared_mac_ue : 1;                   // DWORD 0
         u32 mac1_ue : 1;                         // DWORD 0
         u32 mac0_ue : 1;                         // DWORD 0
         u32 pctl1_rxf_err_sync_ue : 1;           // DWORD 0
         u32 pctl0_rxf_err_sync_ue : 1;           // DWORD 0
         u32 txp_fifo_overflow : 1;               // DWORD 0
         u32 fifot_perr_ue : 1;                   // DWORD 0
         u32 fifoi_perr_ue : 1;                   // DWORD 0
         u32 fifom_perr_ue : 1;                   // DWORD 0
         u32 fifo1_perr_ue : 1;                   // DWORD 0
         u32 fifo0_perr_ue : 1;                   // DWORD 0
         u32 conn_perr_ue : 1;                    // DWORD 0
         u32 vlan_perr_ue : 1;                    // DWORD 0
         u32 mac_perr_ue : 1;                     // DWORD 0
      } SG_PACK RXF_UE_SOURCE, *PRXF_UE_SOURCE;

      typedef union _RXF_UE_SOURCE_UNION {
         RXF_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK RXF_UE_SOURCE_UNION, *PRXF_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__RXF_UE_SOURCE_UNION, sizeof (RXF_UE_SOURCE_UNION) == 4);
   #endif


#else
   // Raw unrecoverable error source bits. Write a 1 to clear 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UE_SOURCE {
         union {
            struct { 
               u32 mac_perr_ue : 1;               // DWORD 0
               u32 vlan_perr_ue : 1;              // DWORD 0
               u32 conn_perr_ue : 1;              // DWORD 0
               u32 fifo0_perr_ue : 1;             // DWORD 0
               u32 fifo1_perr_ue : 1;             // DWORD 0
               u32 fifom_perr_ue : 1;             // DWORD 0
               u32 fifoi_perr_ue : 1;             // DWORD 0
               u32 fifot_perr_ue : 1;             // DWORD 0
               u32 txp_fifo_overflow : 1;         // DWORD 0
               u32 pctl0_rxf_err_sync_ue : 1;     // DWORD 0
               u32 pctl1_rxf_err_sync_ue : 1;     // DWORD 0
               u32 mac0_ue : 1;                   // DWORD 0
               u32 mac1_ue : 1;                   // DWORD 0
               u32 shared_mac_ue : 1;             // DWORD 0
               u32 tsv1_syncfifo_underflow_ue : 1; // DWORD 0
               u32 tsv1_syncfifo_overflow_ue : 1; // DWORD 0
               u32 tsv0_syncfifo_underflow : 1;   // DWORD 0
               u32 tsv0_syncfifo_overflow : 1;    // DWORD 0
               u32 mgmt_tx_syncfifo_underflow : 1; // DWORD 0
               u32 mgmt_tx_syncfifo_overflow : 1; // DWORD 0
               u32 mgmt_syncfifo_underflow : 1;   // DWORD 0
               u32 mgmt_syncfifo_overflow : 1;    // DWORD 0
               u32 mac1_syncfifo_underflow : 1;   // DWORD 0
               u32 mac1_syncfifo_overflow : 1;    // DWORD 0
               u32 mac0_syncfifo_underflow : 1;   // DWORD 0
               u32 mac0_syncfifo_overflow : 1;    // DWORD 0
               u32 txp_rxf_mac_fifo_underflow : 1; // DWORD 0
               u32 txp_rxf_mac_fifo_overflow : 1; // DWORD 0
               u32 perr_txp_in : 1;               // DWORD 0
               u32 perr_rxips_in : 1;             // DWORD 0
               u32 fifo1_fcoe_perr : 1;           // DWORD 0
               u32 fifo0_fcoe_perr : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UE_SOURCE, *PRXF_UE_SOURCE;

      SG_C_ASSERT(__sizeof__RXF_UE_SOURCE, sizeof (RXF_UE_SOURCE) == 4);

   #else
      typedef struct _RXF_UE_SOURCE {
         u32 mac_perr_ue : 1;                     // DWORD 0
         u32 vlan_perr_ue : 1;                    // DWORD 0
         u32 conn_perr_ue : 1;                    // DWORD 0
         u32 fifo0_perr_ue : 1;                   // DWORD 0
         u32 fifo1_perr_ue : 1;                   // DWORD 0
         u32 fifom_perr_ue : 1;                   // DWORD 0
         u32 fifoi_perr_ue : 1;                   // DWORD 0
         u32 fifot_perr_ue : 1;                   // DWORD 0
         u32 txp_fifo_overflow : 1;               // DWORD 0
         u32 pctl0_rxf_err_sync_ue : 1;           // DWORD 0
         u32 pctl1_rxf_err_sync_ue : 1;           // DWORD 0
         u32 mac0_ue : 1;                         // DWORD 0
         u32 mac1_ue : 1;                         // DWORD 0
         u32 shared_mac_ue : 1;                   // DWORD 0
         u32 tsv1_syncfifo_underflow_ue : 1;      // DWORD 0
         u32 tsv1_syncfifo_overflow_ue : 1;       // DWORD 0
         u32 tsv0_syncfifo_underflow : 1;         // DWORD 0
         u32 tsv0_syncfifo_overflow : 1;          // DWORD 0
         u32 mgmt_tx_syncfifo_underflow : 1;      // DWORD 0
         u32 mgmt_tx_syncfifo_overflow : 1;       // DWORD 0
         u32 mgmt_syncfifo_underflow : 1;         // DWORD 0
         u32 mgmt_syncfifo_overflow : 1;          // DWORD 0
         u32 mac1_syncfifo_underflow : 1;         // DWORD 0
         u32 mac1_syncfifo_overflow : 1;          // DWORD 0
         u32 mac0_syncfifo_underflow : 1;         // DWORD 0
         u32 mac0_syncfifo_overflow : 1;          // DWORD 0
         u32 txp_rxf_mac_fifo_underflow : 1;      // DWORD 0
         u32 txp_rxf_mac_fifo_overflow : 1;       // DWORD 0
         u32 perr_txp_in : 1;                     // DWORD 0
         u32 perr_rxips_in : 1;                   // DWORD 0
         u32 fifo1_fcoe_perr : 1;                 // DWORD 0
         u32 fifo0_fcoe_perr : 1;                 // DWORD 0
      } SG_PACK RXF_UE_SOURCE, *PRXF_UE_SOURCE;

      typedef union _RXF_UE_SOURCE_UNION {
         RXF_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK RXF_UE_SOURCE_UNION, *PRXF_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__RXF_UE_SOURCE_UNION, sizeof (RXF_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for disabling unrecoverable error. Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UE_ENABLE {
         union {
            struct { 
               u32 fifo0_fcoe_perr_ue_en : 1;     // DWORD 0
               u32 fifo1_fcoe_perr_ue_en : 1;     // DWORD 0
               u32 perr_rxips_in_ue_en : 1;       // DWORD 0
               u32 perr_txp_in_ue_en : 1;         // DWORD 0
               u32 txp_rxf_mac_fifo_overflow_ue_en : 1; // DWORD 0
               u32 txp_rxf_mac_fifo_underflow_ue_en : 1; // DWORD 0
               u32 mac0_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 mac0_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 mac1_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 mac1_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 mgmt_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 mgmt_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 mgmt_tx_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 mgmt_tx_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 tsv0_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 tsv0_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 tsv1_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 tsv1_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 shared_mac_ue_en : 1;          // DWORD 0
               u32 mac1_ue_en : 1;                // DWORD 0
               u32 mac0_ue_en : 1;                // DWORD 0
               u32 pctl1_rxf_err_sync_ue_en : 1;  // DWORD 0
               u32 pctl0_rxf_err_sync_ue_en : 1;  // DWORD 0
               u32 txp_fifo_overflow_ue_en : 1;   // DWORD 0
               u32 fifot_perr_ue_en : 1;          // DWORD 0
               u32 fifoi_perr_ue_en : 1;          // DWORD 0
               u32 fifom_perr_ue_en : 1;          // DWORD 0
               u32 fifo1_perr_ue_en : 1;          // DWORD 0
               u32 fifo0_perr_ue_en : 1;          // DWORD 0
               u32 conn_perr_ue_en : 1;           // DWORD 0
               u32 vlan_perr_ue_en : 1;           // DWORD 0
               u32 mac_perr_ue_en : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UE_ENABLE, *PRXF_UE_ENABLE;

      SG_C_ASSERT(__sizeof__RXF_UE_ENABLE, sizeof (RXF_UE_ENABLE) == 4);

   #else
      typedef struct _RXF_UE_ENABLE {
         u32 fifo0_fcoe_perr_ue_en : 1;           // DWORD 0
         u32 fifo1_fcoe_perr_ue_en : 1;           // DWORD 0
         u32 perr_rxips_in_ue_en : 1;             // DWORD 0
         u32 perr_txp_in_ue_en : 1;               // DWORD 0
         u32 txp_rxf_mac_fifo_overflow_ue_en : 1; // DWORD 0
         u32 txp_rxf_mac_fifo_underflow_ue_en : 1; // DWORD 0
         u32 mac0_syncfifo_overflow_ue_en : 1;    // DWORD 0
         u32 mac0_syncfifo_underflow_ue_en : 1;   // DWORD 0
         u32 mac1_syncfifo_overflow_ue_en : 1;    // DWORD 0
         u32 mac1_syncfifo_underflow_ue_en : 1;   // DWORD 0
         u32 mgmt_syncfifo_overflow_ue_en : 1;    // DWORD 0
         u32 mgmt_syncfifo_underflow_ue_en : 1;   // DWORD 0
         u32 mgmt_tx_syncfifo_overflow_ue_en : 1; // DWORD 0
         u32 mgmt_tx_syncfifo_underflow_ue_en : 1; // DWORD 0
         u32 tsv0_syncfifo_overflow_ue_en : 1;    // DWORD 0
         u32 tsv0_syncfifo_underflow_ue_en : 1;   // DWORD 0
         u32 tsv1_syncfifo_overflow_ue_en : 1;    // DWORD 0
         u32 tsv1_syncfifo_underflow_ue_en : 1;   // DWORD 0
         u32 shared_mac_ue_en : 1;                // DWORD 0
         u32 mac1_ue_en : 1;                      // DWORD 0
         u32 mac0_ue_en : 1;                      // DWORD 0
         u32 pctl1_rxf_err_sync_ue_en : 1;        // DWORD 0
         u32 pctl0_rxf_err_sync_ue_en : 1;        // DWORD 0
         u32 txp_fifo_overflow_ue_en : 1;         // DWORD 0
         u32 fifot_perr_ue_en : 1;                // DWORD 0
         u32 fifoi_perr_ue_en : 1;                // DWORD 0
         u32 fifom_perr_ue_en : 1;                // DWORD 0
         u32 fifo1_perr_ue_en : 1;                // DWORD 0
         u32 fifo0_perr_ue_en : 1;                // DWORD 0
         u32 conn_perr_ue_en : 1;                 // DWORD 0
         u32 vlan_perr_ue_en : 1;                 // DWORD 0
         u32 mac_perr_ue_en : 1;                  // DWORD 0
      } SG_PACK RXF_UE_ENABLE, *PRXF_UE_ENABLE;

      typedef union _RXF_UE_ENABLE_UNION {
         RXF_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK RXF_UE_ENABLE_UNION, *PRXF_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__RXF_UE_ENABLE_UNION, sizeof (RXF_UE_ENABLE_UNION) == 4);
   #endif


#else
   // Mask for disabling unrecoverable error. Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_UE_ENABLE {
         union {
            struct { 
               u32 mac_perr_ue_en : 1;            // DWORD 0
               u32 vlan_perr_ue_en : 1;           // DWORD 0
               u32 conn_perr_ue_en : 1;           // DWORD 0
               u32 fifo0_perr_ue_en : 1;          // DWORD 0
               u32 fifo1_perr_ue_en : 1;          // DWORD 0
               u32 fifom_perr_ue_en : 1;          // DWORD 0
               u32 fifoi_perr_ue_en : 1;          // DWORD 0
               u32 fifot_perr_ue_en : 1;          // DWORD 0
               u32 txp_fifo_overflow_ue_en : 1;   // DWORD 0
               u32 pctl0_rxf_err_sync_ue_en : 1;  // DWORD 0
               u32 pctl1_rxf_err_sync_ue_en : 1;  // DWORD 0
               u32 mac0_ue_en : 1;                // DWORD 0
               u32 mac1_ue_en : 1;                // DWORD 0
               u32 shared_mac_ue_en : 1;          // DWORD 0
               u32 tsv1_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 tsv1_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 tsv0_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 tsv0_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 mgmt_tx_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 mgmt_tx_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 mgmt_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 mgmt_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 mac1_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 mac1_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 mac0_syncfifo_underflow_ue_en : 1; // DWORD 0
               u32 mac0_syncfifo_overflow_ue_en : 1; // DWORD 0
               u32 txp_rxf_mac_fifo_underflow_ue_en : 1; // DWORD 0
               u32 txp_rxf_mac_fifo_overflow_ue_en : 1; // DWORD 0
               u32 perr_txp_in_ue_en : 1;         // DWORD 0
               u32 perr_rxips_in_ue_en : 1;       // DWORD 0
               u32 fifo1_fcoe_perr_ue_en : 1;     // DWORD 0
               u32 fifo0_fcoe_perr_ue_en : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_UE_ENABLE, *PRXF_UE_ENABLE;

      SG_C_ASSERT(__sizeof__RXF_UE_ENABLE, sizeof (RXF_UE_ENABLE) == 4);

   #else
      typedef struct _RXF_UE_ENABLE {
         u32 mac_perr_ue_en : 1;                  // DWORD 0
         u32 vlan_perr_ue_en : 1;                 // DWORD 0
         u32 conn_perr_ue_en : 1;                 // DWORD 0
         u32 fifo0_perr_ue_en : 1;                // DWORD 0
         u32 fifo1_perr_ue_en : 1;                // DWORD 0
         u32 fifom_perr_ue_en : 1;                // DWORD 0
         u32 fifoi_perr_ue_en : 1;                // DWORD 0
         u32 fifot_perr_ue_en : 1;                // DWORD 0
         u32 txp_fifo_overflow_ue_en : 1;         // DWORD 0
         u32 pctl0_rxf_err_sync_ue_en : 1;        // DWORD 0
         u32 pctl1_rxf_err_sync_ue_en : 1;        // DWORD 0
         u32 mac0_ue_en : 1;                      // DWORD 0
         u32 mac1_ue_en : 1;                      // DWORD 0
         u32 shared_mac_ue_en : 1;                // DWORD 0
         u32 tsv1_syncfifo_underflow_ue_en : 1;   // DWORD 0
         u32 tsv1_syncfifo_overflow_ue_en : 1;    // DWORD 0
         u32 tsv0_syncfifo_underflow_ue_en : 1;   // DWORD 0
         u32 tsv0_syncfifo_overflow_ue_en : 1;    // DWORD 0
         u32 mgmt_tx_syncfifo_underflow_ue_en : 1; // DWORD 0
         u32 mgmt_tx_syncfifo_overflow_ue_en : 1; // DWORD 0
         u32 mgmt_syncfifo_underflow_ue_en : 1;   // DWORD 0
         u32 mgmt_syncfifo_overflow_ue_en : 1;    // DWORD 0
         u32 mac1_syncfifo_underflow_ue_en : 1;   // DWORD 0
         u32 mac1_syncfifo_overflow_ue_en : 1;    // DWORD 0
         u32 mac0_syncfifo_underflow_ue_en : 1;   // DWORD 0
         u32 mac0_syncfifo_overflow_ue_en : 1;    // DWORD 0
         u32 txp_rxf_mac_fifo_underflow_ue_en : 1; // DWORD 0
         u32 txp_rxf_mac_fifo_overflow_ue_en : 1; // DWORD 0
         u32 perr_txp_in_ue_en : 1;               // DWORD 0
         u32 perr_rxips_in_ue_en : 1;             // DWORD 0
         u32 fifo1_fcoe_perr_ue_en : 1;           // DWORD 0
         u32 fifo0_fcoe_perr_ue_en : 1;           // DWORD 0
      } SG_PACK RXF_UE_ENABLE, *PRXF_UE_ENABLE;

      typedef union _RXF_UE_ENABLE_UNION {
         RXF_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK RXF_UE_ENABLE_UNION, *PRXF_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__RXF_UE_ENABLE_UNION, sizeof (RXF_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Serdes and PCS configuration bits. These are all latched during reset from
   // externally strapped pads
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PHY_CONFIG_CSR {
         union {
            struct { 
               u32 rsvd3 : 7;                     // DWORD 0
               u32 port1_link_up : 1;             // DWORD 0
               u32 rsvd2 : 7;                     // DWORD 0
               u32 port0_link_up : 1;             // DWORD 0
               u32 rsvd1 : 11;                    // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 xaui_coclkasel : 1;            // DWORD 0
               u32 xaui_cisrefsel : 1;            // DWORD 0
               u32 eth_speed : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PHY_CONFIG_CSR, *PRXF_PHY_CONFIG_CSR;

      SG_C_ASSERT(__sizeof__RXF_PHY_CONFIG_CSR, sizeof (RXF_PHY_CONFIG_CSR) == 4);

   #else
      typedef struct _RXF_PHY_CONFIG_CSR {
         u32 rsvd3 : 7;                           // DWORD 0
         u32 port1_link_up : 1;                   // DWORD 0
         u32 rsvd2 : 7;                           // DWORD 0
         u32 port0_link_up : 1;                   // DWORD 0
         u32 rsvd1 : 11;                          // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 xaui_coclkasel : 1;                  // DWORD 0
         u32 xaui_cisrefsel : 1;                  // DWORD 0
         u32 eth_speed : 1;                       // DWORD 0
      } SG_PACK RXF_PHY_CONFIG_CSR, *PRXF_PHY_CONFIG_CSR;

      typedef union _RXF_PHY_CONFIG_CSR_UNION {
         RXF_PHY_CONFIG_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_PHY_CONFIG_CSR_UNION, *PRXF_PHY_CONFIG_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_PHY_CONFIG_CSR_UNION, sizeof (RXF_PHY_CONFIG_CSR_UNION) == 4);
   #endif


#else
   // Serdes and PCS configuration bits. These are all latched during reset from
   // externally strapped pads
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_PHY_CONFIG_CSR {
         union {
            struct { 
               u32 eth_speed : 1;                 // DWORD 0
               u32 xaui_cisrefsel : 1;            // DWORD 0
               u32 xaui_coclkasel : 1;            // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 rsvd1 : 11;                    // DWORD 0
               u32 port0_link_up : 1;             // DWORD 0
               u32 rsvd2 : 7;                     // DWORD 0
               u32 port1_link_up : 1;             // DWORD 0
               u32 rsvd3 : 7;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_PHY_CONFIG_CSR, *PRXF_PHY_CONFIG_CSR;

      SG_C_ASSERT(__sizeof__RXF_PHY_CONFIG_CSR, sizeof (RXF_PHY_CONFIG_CSR) == 4);

   #else
      typedef struct _RXF_PHY_CONFIG_CSR {
         u32 eth_speed : 1;                       // DWORD 0
         u32 xaui_cisrefsel : 1;                  // DWORD 0
         u32 xaui_coclkasel : 1;                  // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 rsvd1 : 11;                          // DWORD 0
         u32 port0_link_up : 1;                   // DWORD 0
         u32 rsvd2 : 7;                           // DWORD 0
         u32 port1_link_up : 1;                   // DWORD 0
         u32 rsvd3 : 7;                           // DWORD 0
      } SG_PACK RXF_PHY_CONFIG_CSR, *PRXF_PHY_CONFIG_CSR;

      typedef union _RXF_PHY_CONFIG_CSR_UNION {
         RXF_PHY_CONFIG_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_PHY_CONFIG_CSR_UNION, *PRXF_PHY_CONFIG_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_PHY_CONFIG_CSR_UNION, sizeof (RXF_PHY_CONFIG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register is used to change the networking interfaces between 10G and 1G speeds
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_ETH_SPEED_CSR {
         union {
            struct { 
               u32 cg_eth_rxf_state : 16;         // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 xaui_pll_lock : 1;             // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 eth_reset : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_ETH_SPEED_CSR, *PRXF_ETH_SPEED_CSR;

      SG_C_ASSERT(__sizeof__RXF_ETH_SPEED_CSR, sizeof (RXF_ETH_SPEED_CSR) == 4);

   #else
      typedef struct _RXF_ETH_SPEED_CSR {
         u32 cg_eth_rxf_state : 16;               // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 xaui_pll_lock : 1;                   // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 eth_reset : 1;                       // DWORD 0
      } SG_PACK RXF_ETH_SPEED_CSR, *PRXF_ETH_SPEED_CSR;

      typedef union _RXF_ETH_SPEED_CSR_UNION {
         RXF_ETH_SPEED_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_ETH_SPEED_CSR_UNION, *PRXF_ETH_SPEED_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_ETH_SPEED_CSR_UNION, sizeof (RXF_ETH_SPEED_CSR_UNION) == 4);
   #endif


#else
   // This register is used to change the networking interfaces between 10G and 1G speeds
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_ETH_SPEED_CSR {
         union {
            struct { 
               u32 eth_reset : 1;                 // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 xaui_pll_lock : 1;             // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 cg_eth_rxf_state : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXF_ETH_SPEED_CSR, *PRXF_ETH_SPEED_CSR;

      SG_C_ASSERT(__sizeof__RXF_ETH_SPEED_CSR, sizeof (RXF_ETH_SPEED_CSR) == 4);

   #else
      typedef struct _RXF_ETH_SPEED_CSR {
         u32 eth_reset : 1;                       // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 xaui_pll_lock : 1;                   // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 cg_eth_rxf_state : 16;               // DWORD 0
      } SG_PACK RXF_ETH_SPEED_CSR, *PRXF_ETH_SPEED_CSR;

      typedef union _RXF_ETH_SPEED_CSR_UNION {
         RXF_ETH_SPEED_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXF_ETH_SPEED_CSR_UNION, *PRXF_ETH_SPEED_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXF_ETH_SPEED_CSR_UNION, sizeof (RXF_ETH_SPEED_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Receive Filter CSRs. The offsets are relative to the start of the Ethernet RX
   // module.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_CSRMAP {
         union {
            struct { 
               RXF_RXCTL_CSR rxctl;
               RXF_RXCTL2_CSR rxctl2;
               RXF_MAGIC_ADDR_LO port0_magic_mac_addr0_lo;
               RXF_MAGIC_ADDR_HI port0_magic_mac_addr0_hi;
               RXF_MAGIC_ADDR_LO port0_magic_mac_addr1_lo;
               RXF_MAGIC_ADDR_HI port0_magic_mac_addr1_hi;
               RXF_MAGIC_ADDR_LO port1_magic_mac_addr0_lo;
               RXF_MAGIC_ADDR_HI port1_magic_mac_addr0_hi;
               RXF_MAGIC_ADDR_LO port1_magic_mac_addr1_lo;
               RXF_MAGIC_ADDR_HI port1_magic_mac_addr1_hi;
               RXF_MGMT_MAC_ADDR_LO mgmt_mac_addr_lo;
               RXF_MGMT_MAC_ADDR_HI mgmt_mac_addr_hi;
               RXF_PORT0_BROADCAST_VECTOR_LO port0_broadcast_vector_lo;
               RXF_PORT0_BROADCAST_VECTOR_HI port0_broadcast_vector_hi;
               RXF_PORT1_BROADCAST_VECTOR_LO port1_broadcast_vector_lo;
               RXF_PORT1_BROADCAST_VECTOR_HI port1_broadcast_vector_hi;
               RXF_RTPR_CSR rtpr;
               RXF_RTDR_CSR rtdr;
               RXF_RTPR_CSR rtpr2;
               RXF_RTDR_CSR rtdr2;
               RXF_TXFC_CSR txfc;
               RXF_MGMT_TXFC_CSR mgmt_txfc;
               RXF_MGMT_VLAN_CSR mgmt_vlan;
               RXF_STAT_INDEX_CSR stat_index;
               RXF_STAT_DATA_CSR stat_data;
               HWDBG_CSRMAP rxpp_hwdbg_core;
               HWDBG_CSRMAP rxf_hwdbg_core;
               HWDBG_CSRMAP rxf_hwdbg_rx;
               HWDBG_CSRMAP rxf_hwdbg_rx_mgmt;
               REV_ID rxf_rev_id;
               RXF_UE_SOURCE ue_source;
               RXF_UE_ENABLE ue_enable;
               RXF_FCOE_TYPE_CSR fcoe_type;
               RXF_802_1AU_TYPE_CSR dot1au_type;
               RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO port0_promiscuous_vlan_vector_lo;
               RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI port0_promiscuous_vlan_vector_hi;
               RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO port1_promiscuous_vlan_vector_lo;
               RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI port1_promiscuous_vlan_vector_hi;
               RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO port0_untagged_vlan_vector_lo;
               RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI port0_untagged_vlan_vector_hi;
               RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO port1_untagged_vlan_vector_lo;
               RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI port1_untagged_vlan_vector_hi;
               RXF_INTERFACE_EN_LO port0_interface_en_lo;
               RXF_INTERFACE_EN_HI port0_interface_en_hi;
               RXF_INTERFACE_EN_LO port1_interface_en_lo;
               RXF_INTERFACE_EN_HI port1_interface_en_hi;
               RXF_CAM_SOFT_RESET cam_soft_reset;
               RXF_RSS_MASTER_CONTROL_CSR rss_master_control;
               RXF_RSS_INTERFACE_POLICY_CSR network_interface0_policy;
               RXF_RSS_INTERFACE_POLICY_CSR network_interface1_policy;
               RXF_PASS_L3_L4_ERR_LO p0_pass_l3_l4_err_lo;
               RXF_PASS_L3_L4_ERR_HI p0_pass_l3_l4_err_hi;
               RXF_PASS_L3_L4_ERR_LO p1_pass_l3_l4_err_lo;
               RXF_PASS_L3_L4_ERR_HI p1_pass_l3_l4_err_hi;
               RXF_CBFC_OPCODE_CSR cbfc_opcode;
               RXF_DMTF_INTERFACE_CSR dmtf_interface;
               RXF_PCTL_CFG_CSR pctl_cfg;
               RXF_XAUI_CFG_CSR xaui_cfg;
               RXF_XAUI_C_MMD_CSR xaui_c_mmd;
               RXF_XAUI_CH_EMP_LO_CSR xaui_ch_emp_lo;
               RXF_XAUI_CH_EMP_HI_CSR xaui_ch_emp_hi;
               RXF_XAUI_CH_EQ_CSR xaui_ch_eq;
               RXF_XAUI_CFG2_CSR xaui_cfg2;
               RXF_XAUI_CFG3_CSR xaui_cfg3;
               RXF_XAUI_CFG4_CSR xaui_cfg4;
               RXF_PHY_CONFIG_CSR phy_config;
               RXF_ETH_SPEED_CSR eth_speed;
               u32 rsvd0[181];                    // DWORDS 75 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK RXF_CSRMAP, *PRXF_CSRMAP;

      SG_C_ASSERT(__sizeof__RXF_CSRMAP, sizeof (RXF_CSRMAP) == 1024);

   #else
      typedef struct _RXF_CSRMAP {
         RXF_RXCTL_CSR rxctl;
         RXF_RXCTL2_CSR rxctl2;
         RXF_MAGIC_ADDR_LO port0_magic_mac_addr0_lo;
         RXF_MAGIC_ADDR_HI port0_magic_mac_addr0_hi;
         RXF_MAGIC_ADDR_LO port0_magic_mac_addr1_lo;
         RXF_MAGIC_ADDR_HI port0_magic_mac_addr1_hi;
         RXF_MAGIC_ADDR_LO port1_magic_mac_addr0_lo;
         RXF_MAGIC_ADDR_HI port1_magic_mac_addr0_hi;
         RXF_MAGIC_ADDR_LO port1_magic_mac_addr1_lo;
         RXF_MAGIC_ADDR_HI port1_magic_mac_addr1_hi;
         RXF_MGMT_MAC_ADDR_LO mgmt_mac_addr_lo;
         RXF_MGMT_MAC_ADDR_HI mgmt_mac_addr_hi;
         RXF_PORT0_BROADCAST_VECTOR_LO port0_broadcast_vector_lo;
         RXF_PORT0_BROADCAST_VECTOR_HI port0_broadcast_vector_hi;
         RXF_PORT1_BROADCAST_VECTOR_LO port1_broadcast_vector_lo;
         RXF_PORT1_BROADCAST_VECTOR_HI port1_broadcast_vector_hi;
         RXF_RTPR_CSR rtpr;
         RXF_RTDR_CSR rtdr;
         RXF_RTPR_CSR rtpr2;
         RXF_RTDR_CSR rtdr2;
         RXF_TXFC_CSR txfc;
         RXF_MGMT_TXFC_CSR mgmt_txfc;
         RXF_MGMT_VLAN_CSR mgmt_vlan;
         RXF_STAT_INDEX_CSR stat_index;
         RXF_STAT_DATA_CSR stat_data;
         HWDBG_CSRMAP rxpp_hwdbg_core;
         HWDBG_CSRMAP rxf_hwdbg_core;
         HWDBG_CSRMAP rxf_hwdbg_rx;
         HWDBG_CSRMAP rxf_hwdbg_rx_mgmt;
         REV_ID rxf_rev_id;
         RXF_UE_SOURCE ue_source;
         RXF_UE_ENABLE ue_enable;
         RXF_FCOE_TYPE_CSR fcoe_type;
         RXF_802_1AU_TYPE_CSR dot1au_type;
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO port0_promiscuous_vlan_vector_lo;
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI port0_promiscuous_vlan_vector_hi;
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO port1_promiscuous_vlan_vector_lo;
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI port1_promiscuous_vlan_vector_hi;
         RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO port0_untagged_vlan_vector_lo;
         RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI port0_untagged_vlan_vector_hi;
         RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO port1_untagged_vlan_vector_lo;
         RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI port1_untagged_vlan_vector_hi;
         RXF_INTERFACE_EN_LO port0_interface_en_lo;
         RXF_INTERFACE_EN_HI port0_interface_en_hi;
         RXF_INTERFACE_EN_LO port1_interface_en_lo;
         RXF_INTERFACE_EN_HI port1_interface_en_hi;
         RXF_CAM_SOFT_RESET cam_soft_reset;
         RXF_RSS_MASTER_CONTROL_CSR rss_master_control;
         RXF_RSS_INTERFACE_POLICY_CSR network_interface0_policy;
         RXF_RSS_INTERFACE_POLICY_CSR network_interface1_policy;
         RXF_PASS_L3_L4_ERR_LO p0_pass_l3_l4_err_lo;
         RXF_PASS_L3_L4_ERR_HI p0_pass_l3_l4_err_hi;
         RXF_PASS_L3_L4_ERR_LO p1_pass_l3_l4_err_lo;
         RXF_PASS_L3_L4_ERR_HI p1_pass_l3_l4_err_hi;
         RXF_CBFC_OPCODE_CSR cbfc_opcode;
         RXF_DMTF_INTERFACE_CSR dmtf_interface;
         RXF_PCTL_CFG_CSR pctl_cfg;
         RXF_XAUI_CFG_CSR xaui_cfg;
         RXF_XAUI_C_MMD_CSR xaui_c_mmd;
         RXF_XAUI_CH_EMP_LO_CSR xaui_ch_emp_lo;
         RXF_XAUI_CH_EMP_HI_CSR xaui_ch_emp_hi;
         RXF_XAUI_CH_EQ_CSR xaui_ch_eq;
         RXF_XAUI_CFG2_CSR xaui_cfg2;
         RXF_XAUI_CFG3_CSR xaui_cfg3;
         RXF_XAUI_CFG4_CSR xaui_cfg4;
         RXF_PHY_CONFIG_CSR phy_config;
         RXF_ETH_SPEED_CSR eth_speed;
         u32 rsvd0[181];                          // DWORDS 75 to 255
      } SG_PACK RXF_CSRMAP, *PRXF_CSRMAP;

      typedef union _RXF_CSRMAP_UNION {
         RXF_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK RXF_CSRMAP_UNION, *PRXF_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__RXF_CSRMAP_UNION, sizeof (RXF_CSRMAP_UNION) == 1024);
   #endif


#else
   // Receive Filter CSRs. The offsets are relative to the start of the Ethernet RX
   // module.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXF_CSRMAP {
         union {
            struct { 
               RXF_RXCTL_CSR rxctl;
               RXF_RXCTL2_CSR rxctl2;
               RXF_MAGIC_ADDR_LO port0_magic_mac_addr0_lo;
               RXF_MAGIC_ADDR_HI port0_magic_mac_addr0_hi;
               RXF_MAGIC_ADDR_LO port0_magic_mac_addr1_lo;
               RXF_MAGIC_ADDR_HI port0_magic_mac_addr1_hi;
               RXF_MAGIC_ADDR_LO port1_magic_mac_addr0_lo;
               RXF_MAGIC_ADDR_HI port1_magic_mac_addr0_hi;
               RXF_MAGIC_ADDR_LO port1_magic_mac_addr1_lo;
               RXF_MAGIC_ADDR_HI port1_magic_mac_addr1_hi;
               RXF_MGMT_MAC_ADDR_LO mgmt_mac_addr_lo;
               RXF_MGMT_MAC_ADDR_HI mgmt_mac_addr_hi;
               RXF_PORT0_BROADCAST_VECTOR_LO port0_broadcast_vector_lo;
               RXF_PORT0_BROADCAST_VECTOR_HI port0_broadcast_vector_hi;
               RXF_PORT1_BROADCAST_VECTOR_LO port1_broadcast_vector_lo;
               RXF_PORT1_BROADCAST_VECTOR_HI port1_broadcast_vector_hi;
               RXF_RTPR_CSR rtpr;
               RXF_RTDR_CSR rtdr;
               RXF_RTPR_CSR rtpr2;
               RXF_RTDR_CSR rtdr2;
               RXF_TXFC_CSR txfc;
               RXF_MGMT_TXFC_CSR mgmt_txfc;
               RXF_MGMT_VLAN_CSR mgmt_vlan;
               RXF_STAT_INDEX_CSR stat_index;
               RXF_STAT_DATA_CSR stat_data;
               HWDBG_CSRMAP rxpp_hwdbg_core;
               HWDBG_CSRMAP rxf_hwdbg_core;
               HWDBG_CSRMAP rxf_hwdbg_rx;
               HWDBG_CSRMAP rxf_hwdbg_rx_mgmt;
               REV_ID rxf_rev_id;
               RXF_UE_SOURCE ue_source;
               RXF_UE_ENABLE ue_enable;
               RXF_FCOE_TYPE_CSR fcoe_type;
               RXF_802_1AU_TYPE_CSR dot1au_type;
               RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO port0_promiscuous_vlan_vector_lo;
               RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI port0_promiscuous_vlan_vector_hi;
               RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO port1_promiscuous_vlan_vector_lo;
               RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI port1_promiscuous_vlan_vector_hi;
               RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO port0_untagged_vlan_vector_lo;
               RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI port0_untagged_vlan_vector_hi;
               RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO port1_untagged_vlan_vector_lo;
               RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI port1_untagged_vlan_vector_hi;
               RXF_INTERFACE_EN_LO port0_interface_en_lo;
               RXF_INTERFACE_EN_HI port0_interface_en_hi;
               RXF_INTERFACE_EN_LO port1_interface_en_lo;
               RXF_INTERFACE_EN_HI port1_interface_en_hi;
               RXF_CAM_SOFT_RESET cam_soft_reset;
               RXF_RSS_MASTER_CONTROL_CSR rss_master_control;
               RXF_RSS_INTERFACE_POLICY_CSR network_interface0_policy;
               RXF_RSS_INTERFACE_POLICY_CSR network_interface1_policy;
               RXF_PASS_L3_L4_ERR_LO p0_pass_l3_l4_err_lo;
               RXF_PASS_L3_L4_ERR_HI p0_pass_l3_l4_err_hi;
               RXF_PASS_L3_L4_ERR_LO p1_pass_l3_l4_err_lo;
               RXF_PASS_L3_L4_ERR_HI p1_pass_l3_l4_err_hi;
               RXF_CBFC_OPCODE_CSR cbfc_opcode;
               RXF_DMTF_INTERFACE_CSR dmtf_interface;
               RXF_PCTL_CFG_CSR pctl_cfg;
               RXF_XAUI_CFG_CSR xaui_cfg;
               RXF_XAUI_C_MMD_CSR xaui_c_mmd;
               RXF_XAUI_CH_EMP_LO_CSR xaui_ch_emp_lo;
               RXF_XAUI_CH_EMP_HI_CSR xaui_ch_emp_hi;
               RXF_XAUI_CH_EQ_CSR xaui_ch_eq;
               RXF_XAUI_CFG2_CSR xaui_cfg2;
               RXF_XAUI_CFG3_CSR xaui_cfg3;
               RXF_XAUI_CFG4_CSR xaui_cfg4;
               RXF_PHY_CONFIG_CSR phy_config;
               RXF_ETH_SPEED_CSR eth_speed;
               u32 rsvd0[181];                    // DWORDS 75 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK RXF_CSRMAP, *PRXF_CSRMAP;

      SG_C_ASSERT(__sizeof__RXF_CSRMAP, sizeof (RXF_CSRMAP) == 1024);

   #else
      typedef struct _RXF_CSRMAP {
         RXF_RXCTL_CSR rxctl;
         RXF_RXCTL2_CSR rxctl2;
         RXF_MAGIC_ADDR_LO port0_magic_mac_addr0_lo;
         RXF_MAGIC_ADDR_HI port0_magic_mac_addr0_hi;
         RXF_MAGIC_ADDR_LO port0_magic_mac_addr1_lo;
         RXF_MAGIC_ADDR_HI port0_magic_mac_addr1_hi;
         RXF_MAGIC_ADDR_LO port1_magic_mac_addr0_lo;
         RXF_MAGIC_ADDR_HI port1_magic_mac_addr0_hi;
         RXF_MAGIC_ADDR_LO port1_magic_mac_addr1_lo;
         RXF_MAGIC_ADDR_HI port1_magic_mac_addr1_hi;
         RXF_MGMT_MAC_ADDR_LO mgmt_mac_addr_lo;
         RXF_MGMT_MAC_ADDR_HI mgmt_mac_addr_hi;
         RXF_PORT0_BROADCAST_VECTOR_LO port0_broadcast_vector_lo;
         RXF_PORT0_BROADCAST_VECTOR_HI port0_broadcast_vector_hi;
         RXF_PORT1_BROADCAST_VECTOR_LO port1_broadcast_vector_lo;
         RXF_PORT1_BROADCAST_VECTOR_HI port1_broadcast_vector_hi;
         RXF_RTPR_CSR rtpr;
         RXF_RTDR_CSR rtdr;
         RXF_RTPR_CSR rtpr2;
         RXF_RTDR_CSR rtdr2;
         RXF_TXFC_CSR txfc;
         RXF_MGMT_TXFC_CSR mgmt_txfc;
         RXF_MGMT_VLAN_CSR mgmt_vlan;
         RXF_STAT_INDEX_CSR stat_index;
         RXF_STAT_DATA_CSR stat_data;
         HWDBG_CSRMAP rxpp_hwdbg_core;
         HWDBG_CSRMAP rxf_hwdbg_core;
         HWDBG_CSRMAP rxf_hwdbg_rx;
         HWDBG_CSRMAP rxf_hwdbg_rx_mgmt;
         REV_ID rxf_rev_id;
         RXF_UE_SOURCE ue_source;
         RXF_UE_ENABLE ue_enable;
         RXF_FCOE_TYPE_CSR fcoe_type;
         RXF_802_1AU_TYPE_CSR dot1au_type;
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_LO port0_promiscuous_vlan_vector_lo;
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT0_HI port0_promiscuous_vlan_vector_hi;
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_LO port1_promiscuous_vlan_vector_lo;
         RXF_PROMISCUOUS_VLAN_VECTOR_PORT1_HI port1_promiscuous_vlan_vector_hi;
         RXF_UNTAGGED_VLAN_VECTOR_PORT0_LO port0_untagged_vlan_vector_lo;
         RXF_UNTAGGED_VLAN_VECTOR_PORT0_HI port0_untagged_vlan_vector_hi;
         RXF_UNTAGGED_VLAN_VECTOR_PORT1_LO port1_untagged_vlan_vector_lo;
         RXF_UNTAGGED_VLAN_VECTOR_PORT1_HI port1_untagged_vlan_vector_hi;
         RXF_INTERFACE_EN_LO port0_interface_en_lo;
         RXF_INTERFACE_EN_HI port0_interface_en_hi;
         RXF_INTERFACE_EN_LO port1_interface_en_lo;
         RXF_INTERFACE_EN_HI port1_interface_en_hi;
         RXF_CAM_SOFT_RESET cam_soft_reset;
         RXF_RSS_MASTER_CONTROL_CSR rss_master_control;
         RXF_RSS_INTERFACE_POLICY_CSR network_interface0_policy;
         RXF_RSS_INTERFACE_POLICY_CSR network_interface1_policy;
         RXF_PASS_L3_L4_ERR_LO p0_pass_l3_l4_err_lo;
         RXF_PASS_L3_L4_ERR_HI p0_pass_l3_l4_err_hi;
         RXF_PASS_L3_L4_ERR_LO p1_pass_l3_l4_err_lo;
         RXF_PASS_L3_L4_ERR_HI p1_pass_l3_l4_err_hi;
         RXF_CBFC_OPCODE_CSR cbfc_opcode;
         RXF_DMTF_INTERFACE_CSR dmtf_interface;
         RXF_PCTL_CFG_CSR pctl_cfg;
         RXF_XAUI_CFG_CSR xaui_cfg;
         RXF_XAUI_C_MMD_CSR xaui_c_mmd;
         RXF_XAUI_CH_EMP_LO_CSR xaui_ch_emp_lo;
         RXF_XAUI_CH_EMP_HI_CSR xaui_ch_emp_hi;
         RXF_XAUI_CH_EQ_CSR xaui_ch_eq;
         RXF_XAUI_CFG2_CSR xaui_cfg2;
         RXF_XAUI_CFG3_CSR xaui_cfg3;
         RXF_XAUI_CFG4_CSR xaui_cfg4;
         RXF_PHY_CONFIG_CSR phy_config;
         RXF_ETH_SPEED_CSR eth_speed;
         u32 rsvd0[181];                          // DWORDS 75 to 255
      } SG_PACK RXF_CSRMAP, *PRXF_CSRMAP;

      typedef union _RXF_CSRMAP_UNION {
         RXF_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK RXF_CSRMAP_UNION, *PRXF_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__RXF_CSRMAP_UNION, sizeof (RXF_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __rxf_bmap_h__

