/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __rxulp_bmap_h__
#define __rxulp_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "ep_bmap.h"
#include "ep_minirom_bmap.h"
#include "btlr_bmap.h"
#include "gencommon_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Controls which upper layer protocols are available for offload.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CONTROL_CSR {
         union {
            struct { 
               u32 rsvd1 : 11;                    // DWORD 0
               u32 iscsi_txulp : 2;               // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 enable_wd : 1;                 // DWORD 0
               u32 cr_halign_queues : 8;          // DWORD 0
               u32 en_iscsi_classification_per_iq : 8; // DWORD 0
               u32 en_iscsi_classification : 1;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CONTROL_CSR, *PRXULP_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CONTROL_CSR, sizeof (RXULP_CONTROL_CSR) == 4);

   #else
      typedef struct _RXULP_CONTROL_CSR {
         u32 rsvd1 : 11;                          // DWORD 0
         u32 iscsi_txulp : 2;                     // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 enable_wd : 1;                       // DWORD 0
         u32 cr_halign_queues : 8;                // DWORD 0
         u32 en_iscsi_classification_per_iq : 8;  // DWORD 0
         u32 en_iscsi_classification : 1;         // DWORD 0
      } SG_PACK RXULP_CONTROL_CSR, *PRXULP_CONTROL_CSR;

      typedef union _RXULP_CONTROL_CSR_UNION {
         RXULP_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CONTROL_CSR_UNION, *PRXULP_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CONTROL_CSR_UNION, sizeof (RXULP_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // Controls which upper layer protocols are available for offload.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CONTROL_CSR {
         union {
            struct { 
               u32 en_iscsi_classification : 1;   // DWORD 0
               u32 en_iscsi_classification_per_iq : 8; // DWORD 0
               u32 cr_halign_queues : 8;          // DWORD 0
               u32 enable_wd : 1;                 // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 iscsi_txulp : 2;               // DWORD 0
               u32 rsvd1 : 11;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CONTROL_CSR, *PRXULP_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CONTROL_CSR, sizeof (RXULP_CONTROL_CSR) == 4);

   #else
      typedef struct _RXULP_CONTROL_CSR {
         u32 en_iscsi_classification : 1;         // DWORD 0
         u32 en_iscsi_classification_per_iq : 8;  // DWORD 0
         u32 cr_halign_queues : 8;                // DWORD 0
         u32 enable_wd : 1;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 iscsi_txulp : 2;                     // DWORD 0
         u32 rsvd1 : 11;                          // DWORD 0
      } SG_PACK RXULP_CONTROL_CSR, *PRXULP_CONTROL_CSR;

      typedef union _RXULP_CONTROL_CSR_UNION {
         RXULP_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CONTROL_CSR_UNION, *PRXULP_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CONTROL_CSR_UNION, sizeof (RXULP_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw interrupt source bits, not masked by MASK.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_INT_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 btlr_violation : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_INT_SOURCE, *PRXULP_INT_SOURCE;

      SG_C_ASSERT(__sizeof__RXULP_INT_SOURCE, sizeof (RXULP_INT_SOURCE) == 4);

   #else
      typedef struct _RXULP_INT_SOURCE {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 btlr_violation : 1;                  // DWORD 0
      } SG_PACK RXULP_INT_SOURCE, *PRXULP_INT_SOURCE;

      typedef union _RXULP_INT_SOURCE_UNION {
         RXULP_INT_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK RXULP_INT_SOURCE_UNION, *PRXULP_INT_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__RXULP_INT_SOURCE_UNION, sizeof (RXULP_INT_SOURCE_UNION) == 4);
   #endif


#else
   // Raw interrupt source bits, not masked by MASK.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_INT_SOURCE {
         union {
            struct { 
               u32 btlr_violation : 1;            // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_INT_SOURCE, *PRXULP_INT_SOURCE;

      SG_C_ASSERT(__sizeof__RXULP_INT_SOURCE, sizeof (RXULP_INT_SOURCE) == 4);

   #else
      typedef struct _RXULP_INT_SOURCE {
         u32 btlr_violation : 1;                  // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK RXULP_INT_SOURCE, *PRXULP_INT_SOURCE;

      typedef union _RXULP_INT_SOURCE_UNION {
         RXULP_INT_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK RXULP_INT_SOURCE_UNION, *PRXULP_INT_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__RXULP_INT_SOURCE_UNION, sizeof (RXULP_INT_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for disabling interrupts. Write a 1 to disable.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_INT_MASK {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 btlr_violation_mask : 1;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_INT_MASK, *PRXULP_INT_MASK;

      SG_C_ASSERT(__sizeof__RXULP_INT_MASK, sizeof (RXULP_INT_MASK) == 4);

   #else
      typedef struct _RXULP_INT_MASK {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 btlr_violation_mask : 1;             // DWORD 0
      } SG_PACK RXULP_INT_MASK, *PRXULP_INT_MASK;

      typedef union _RXULP_INT_MASK_UNION {
         RXULP_INT_MASK bits;
         u32 dw; // dword union
      } SG_PACK RXULP_INT_MASK_UNION, *PRXULP_INT_MASK_UNION;

      SG_C_ASSERT(__sizeof__RXULP_INT_MASK_UNION, sizeof (RXULP_INT_MASK_UNION) == 4);
   #endif


#else
   // Mask for disabling interrupts. Write a 1 to disable.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_INT_MASK {
         union {
            struct { 
               u32 btlr_violation_mask : 1;       // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_INT_MASK, *PRXULP_INT_MASK;

      SG_C_ASSERT(__sizeof__RXULP_INT_MASK, sizeof (RXULP_INT_MASK) == 4);

   #else
      typedef struct _RXULP_INT_MASK {
         u32 btlr_violation_mask : 1;             // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK RXULP_INT_MASK, *PRXULP_INT_MASK;

      typedef union _RXULP_INT_MASK_UNION {
         RXULP_INT_MASK bits;
         u32 dw; // dword union
      } SG_PACK RXULP_INT_MASK_UNION, *PRXULP_INT_MASK_UNION;

      SG_C_ASSERT(__sizeof__RXULP_INT_MASK_UNION, sizeof (RXULP_INT_MASK_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw unrecoverable error source bits, not masked by MASK. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_UE_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 pmem_parity_ue : 1;            // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 fw_ue : 1;                     // DWORD 0
               u32 stats_parity_error : 1;        // DWORD 0
               u32 sram_perror : 5;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_UE_SOURCE, *PRXULP_UE_SOURCE;

      SG_C_ASSERT(__sizeof__RXULP_UE_SOURCE, sizeof (RXULP_UE_SOURCE) == 4);

   #else
      typedef struct _RXULP_UE_SOURCE {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 pmem_parity_ue : 1;                  // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 fw_ue : 1;                           // DWORD 0
         u32 stats_parity_error : 1;              // DWORD 0
         u32 sram_perror : 5;                     // DWORD 0
      } SG_PACK RXULP_UE_SOURCE, *PRXULP_UE_SOURCE;

      typedef union _RXULP_UE_SOURCE_UNION {
         RXULP_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK RXULP_UE_SOURCE_UNION, *PRXULP_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__RXULP_UE_SOURCE_UNION, sizeof (RXULP_UE_SOURCE_UNION) == 4);
   #endif


#else
   // Raw unrecoverable error source bits, not masked by MASK. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_UE_SOURCE {
         union {
            struct { 
               u32 sram_perror : 5;               // DWORD 0
               u32 stats_parity_error : 1;        // DWORD 0
               u32 fw_ue : 1;                     // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 pmem_parity_ue : 1;            // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_UE_SOURCE, *PRXULP_UE_SOURCE;

      SG_C_ASSERT(__sizeof__RXULP_UE_SOURCE, sizeof (RXULP_UE_SOURCE) == 4);

   #else
      typedef struct _RXULP_UE_SOURCE {
         u32 sram_perror : 5;                     // DWORD 0
         u32 stats_parity_error : 1;              // DWORD 0
         u32 fw_ue : 1;                           // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 pmem_parity_ue : 1;                  // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK RXULP_UE_SOURCE, *PRXULP_UE_SOURCE;

      typedef union _RXULP_UE_SOURCE_UNION {
         RXULP_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK RXULP_UE_SOURCE_UNION, *PRXULP_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__RXULP_UE_SOURCE_UNION, sizeof (RXULP_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for disabling unrecoverable error . Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_UE_ENABLE {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 pmem_parity_ue : 1;            // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 fw_ue : 1;                     // DWORD 0
               u32 stats_parity_error : 1;        // DWORD 0
               u32 sram_perror : 5;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_UE_ENABLE, *PRXULP_UE_ENABLE;

      SG_C_ASSERT(__sizeof__RXULP_UE_ENABLE, sizeof (RXULP_UE_ENABLE) == 4);

   #else
      typedef struct _RXULP_UE_ENABLE {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 pmem_parity_ue : 1;                  // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 fw_ue : 1;                           // DWORD 0
         u32 stats_parity_error : 1;              // DWORD 0
         u32 sram_perror : 5;                     // DWORD 0
      } SG_PACK RXULP_UE_ENABLE, *PRXULP_UE_ENABLE;

      typedef union _RXULP_UE_ENABLE_UNION {
         RXULP_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK RXULP_UE_ENABLE_UNION, *PRXULP_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__RXULP_UE_ENABLE_UNION, sizeof (RXULP_UE_ENABLE_UNION) == 4);
   #endif


#else
   // Mask for disabling unrecoverable error . Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_UE_ENABLE {
         union {
            struct { 
               u32 sram_perror : 5;               // DWORD 0
               u32 stats_parity_error : 1;        // DWORD 0
               u32 fw_ue : 1;                     // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 pmem_parity_ue : 1;            // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_UE_ENABLE, *PRXULP_UE_ENABLE;

      SG_C_ASSERT(__sizeof__RXULP_UE_ENABLE, sizeof (RXULP_UE_ENABLE) == 4);

   #else
      typedef struct _RXULP_UE_ENABLE {
         u32 sram_perror : 5;                     // DWORD 0
         u32 stats_parity_error : 1;              // DWORD 0
         u32 fw_ue : 1;                           // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 pmem_parity_ue : 1;                  // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK RXULP_UE_ENABLE, *PRXULP_UE_ENABLE;

      typedef union _RXULP_UE_ENABLE_UNION {
         RXULP_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK RXULP_UE_ENABLE_UNION, *PRXULP_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__RXULP_UE_ENABLE_UNION, sizeof (RXULP_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw unrecoverable error source bits, not masked by MASK. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_UE_SOURCE1 {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 ep_prefetch_un_err : 1;        // DWORD 0
               u32 ep_prefetch_ov_err : 1;        // DWORD 0
               u32 ep_m2_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_m2_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m1_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_m1_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m0_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_m0_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
               u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
               u32 smdebug_ue : 1;                // DWORD 0
               u32 winup_ue : 1;                  // DWORD 0
               u32 btlr_ue : 1;                   // DWORD 0
               u32 pmemif_ue : 1;                 // DWORD 0
               u32 ctxif_ue : 1;                  // DWORD 0
               u32 rxulp_iqoq_ue : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_UE_SOURCE1, *PRXULP_UE_SOURCE1;

      SG_C_ASSERT(__sizeof__RXULP_UE_SOURCE1, sizeof (RXULP_UE_SOURCE1) == 4);

   #else
      typedef struct _RXULP_UE_SOURCE1 {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 ep_prefetch_un_err : 1;              // DWORD 0
         u32 ep_prefetch_ov_err : 1;              // DWORD 0
         u32 ep_m2_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_m2_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m1_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_m1_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m0_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_m0_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m2_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
         u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
         u32 smdebug_ue : 1;                      // DWORD 0
         u32 winup_ue : 1;                        // DWORD 0
         u32 btlr_ue : 1;                         // DWORD 0
         u32 pmemif_ue : 1;                       // DWORD 0
         u32 ctxif_ue : 1;                        // DWORD 0
         u32 rxulp_iqoq_ue : 1;                   // DWORD 0
      } SG_PACK RXULP_UE_SOURCE1, *PRXULP_UE_SOURCE1;

      typedef union _RXULP_UE_SOURCE1_UNION {
         RXULP_UE_SOURCE1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_UE_SOURCE1_UNION, *PRXULP_UE_SOURCE1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_UE_SOURCE1_UNION, sizeof (RXULP_UE_SOURCE1_UNION) == 4);
   #endif


#else
   // Raw unrecoverable error source bits, not masked by MASK. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_UE_SOURCE1 {
         union {
            struct { 
               u32 rxulp_iqoq_ue : 1;             // DWORD 0
               u32 ctxif_ue : 1;                  // DWORD 0
               u32 pmemif_ue : 1;                 // DWORD 0
               u32 btlr_ue : 1;                   // DWORD 0
               u32 winup_ue : 1;                  // DWORD 0
               u32 smdebug_ue : 1;                // DWORD 0
               u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
               u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m0_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m0_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_m1_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m1_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_m2_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m2_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_prefetch_ov_err : 1;        // DWORD 0
               u32 ep_prefetch_un_err : 1;        // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_UE_SOURCE1, *PRXULP_UE_SOURCE1;

      SG_C_ASSERT(__sizeof__RXULP_UE_SOURCE1, sizeof (RXULP_UE_SOURCE1) == 4);

   #else
      typedef struct _RXULP_UE_SOURCE1 {
         u32 rxulp_iqoq_ue : 1;                   // DWORD 0
         u32 ctxif_ue : 1;                        // DWORD 0
         u32 pmemif_ue : 1;                       // DWORD 0
         u32 btlr_ue : 1;                         // DWORD 0
         u32 winup_ue : 1;                        // DWORD 0
         u32 smdebug_ue : 1;                      // DWORD 0
         u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
         u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m0_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m0_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_m1_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m1_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_m2_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m2_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_prefetch_ov_err : 1;              // DWORD 0
         u32 ep_prefetch_un_err : 1;              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK RXULP_UE_SOURCE1, *PRXULP_UE_SOURCE1;

      typedef union _RXULP_UE_SOURCE1_UNION {
         RXULP_UE_SOURCE1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_UE_SOURCE1_UNION, *PRXULP_UE_SOURCE1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_UE_SOURCE1_UNION, sizeof (RXULP_UE_SOURCE1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for disabling unrecoverable error . Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_UE_ENABLE1 {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 ep_prefetch_un_err : 1;        // DWORD 0
               u32 ep_prefetch_ov_err : 1;        // DWORD 0
               u32 ep_m2_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_m2_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 detect_ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
               u32 detect_ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
               u32 smdebug_ue : 1;                // DWORD 0
               u32 winup_ue : 1;                  // DWORD 0
               u32 btlr_ue : 1;                   // DWORD 0
               u32 pmemif_ue : 1;                 // DWORD 0
               u32 ctxif_ue : 1;                  // DWORD 0
               u32 rxulp_iqoq_ue : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_UE_ENABLE1, *PRXULP_UE_ENABLE1;

      SG_C_ASSERT(__sizeof__RXULP_UE_ENABLE1, sizeof (RXULP_UE_ENABLE1) == 4);

   #else
      typedef struct _RXULP_UE_ENABLE1 {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 ep_prefetch_un_err : 1;              // DWORD 0
         u32 ep_prefetch_ov_err : 1;              // DWORD 0
         u32 ep_m2_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_m2_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m1_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_m1_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m0_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_m0_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m2_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 detect_ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
         u32 detect_ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
         u32 smdebug_ue : 1;                      // DWORD 0
         u32 winup_ue : 1;                        // DWORD 0
         u32 btlr_ue : 1;                         // DWORD 0
         u32 pmemif_ue : 1;                       // DWORD 0
         u32 ctxif_ue : 1;                        // DWORD 0
         u32 rxulp_iqoq_ue : 1;                   // DWORD 0
      } SG_PACK RXULP_UE_ENABLE1, *PRXULP_UE_ENABLE1;

      typedef union _RXULP_UE_ENABLE1_UNION {
         RXULP_UE_ENABLE1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_UE_ENABLE1_UNION, *PRXULP_UE_ENABLE1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_UE_ENABLE1_UNION, sizeof (RXULP_UE_ENABLE1_UNION) == 4);
   #endif


#else
   // Mask for disabling unrecoverable error . Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_UE_ENABLE1 {
         union {
            struct { 
               u32 rxulp_iqoq_ue : 1;             // DWORD 0
               u32 ctxif_ue : 1;                  // DWORD 0
               u32 pmemif_ue : 1;                 // DWORD 0
               u32 btlr_ue : 1;                   // DWORD 0
               u32 winup_ue : 1;                  // DWORD 0
               u32 smdebug_ue : 1;                // DWORD 0
               u32 detect_ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
               u32 detect_ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_m2_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m2_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_prefetch_ov_err : 1;        // DWORD 0
               u32 ep_prefetch_un_err : 1;        // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_UE_ENABLE1, *PRXULP_UE_ENABLE1;

      SG_C_ASSERT(__sizeof__RXULP_UE_ENABLE1, sizeof (RXULP_UE_ENABLE1) == 4);

   #else
      typedef struct _RXULP_UE_ENABLE1 {
         u32 rxulp_iqoq_ue : 1;                   // DWORD 0
         u32 ctxif_ue : 1;                        // DWORD 0
         u32 pmemif_ue : 1;                       // DWORD 0
         u32 btlr_ue : 1;                         // DWORD 0
         u32 winup_ue : 1;                        // DWORD 0
         u32 smdebug_ue : 1;                      // DWORD 0
         u32 detect_ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
         u32 detect_ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
         u32 ep_m0_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m0_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m0_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_m1_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m1_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_m2_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m2_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_prefetch_ov_err : 1;              // DWORD 0
         u32 ep_prefetch_un_err : 1;              // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK RXULP_UE_ENABLE1, *PRXULP_UE_ENABLE1;

      typedef union _RXULP_UE_ENABLE1_UNION {
         RXULP_UE_ENABLE1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_UE_ENABLE1_UNION, *PRXULP_UE_ENABLE1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_UE_ENABLE1_UNION, sizeof (RXULP_UE_ENABLE1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of Various IQ. Writing to this registers clears Overflow/Undeflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_IQ_DEBUG0 {
         union {
            struct { 
               u32 rsvd6 : 2;                     // DWORD 0
               u32 uc1_proc_state : 2;            // DWORD 0
               u32 rsvd5 : 2;                     // DWORD 0
               u32 uc0_proc_state : 2;            // DWORD 0
               u32 uc1_proc_numfifo : 4;          // DWORD 0
               u32 uc0_proc_numfifo : 4;          // DWORD 0
               u32 rsvd4 : 2;                     // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 rsvd2 : 5;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 uc1_underflow : 1;             // DWORD 0
               u32 uc1_overflow : 1;              // DWORD 0
               u32 uc0_underflow : 1;             // DWORD 0
               u32 uc0_overflow : 1;              // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_IQ_DEBUG0, *PRXULP_IQ_DEBUG0;

      SG_C_ASSERT(__sizeof__RXULP_IQ_DEBUG0, sizeof (RXULP_IQ_DEBUG0) == 4);

   #else
      typedef struct _RXULP_IQ_DEBUG0 {
         u32 rsvd6 : 2;                           // DWORD 0
         u32 uc1_proc_state : 2;                  // DWORD 0
         u32 rsvd5 : 2;                           // DWORD 0
         u32 uc0_proc_state : 2;                  // DWORD 0
         u32 uc1_proc_numfifo : 4;                // DWORD 0
         u32 uc0_proc_numfifo : 4;                // DWORD 0
         u32 rsvd4 : 2;                           // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 uc1_underflow : 1;                   // DWORD 0
         u32 uc1_overflow : 1;                    // DWORD 0
         u32 uc0_underflow : 1;                   // DWORD 0
         u32 uc0_overflow : 1;                    // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK RXULP_IQ_DEBUG0, *PRXULP_IQ_DEBUG0;

      typedef union _RXULP_IQ_DEBUG0_UNION {
         RXULP_IQ_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_IQ_DEBUG0_UNION, *PRXULP_IQ_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_IQ_DEBUG0_UNION, sizeof (RXULP_IQ_DEBUG0_UNION) == 4);
   #endif


#else
   // Debug of Various IQ. Writing to this registers clears Overflow/Undeflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_IQ_DEBUG0 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 uc0_overflow : 1;              // DWORD 0
               u32 uc0_underflow : 1;             // DWORD 0
               u32 uc1_overflow : 1;              // DWORD 0
               u32 uc1_underflow : 1;             // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rsvd2 : 5;                     // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 rsvd4 : 2;                     // DWORD 0
               u32 uc0_proc_numfifo : 4;          // DWORD 0
               u32 uc1_proc_numfifo : 4;          // DWORD 0
               u32 uc0_proc_state : 2;            // DWORD 0
               u32 rsvd5 : 2;                     // DWORD 0
               u32 uc1_proc_state : 2;            // DWORD 0
               u32 rsvd6 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_IQ_DEBUG0, *PRXULP_IQ_DEBUG0;

      SG_C_ASSERT(__sizeof__RXULP_IQ_DEBUG0, sizeof (RXULP_IQ_DEBUG0) == 4);

   #else
      typedef struct _RXULP_IQ_DEBUG0 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 uc0_overflow : 1;                    // DWORD 0
         u32 uc0_underflow : 1;                   // DWORD 0
         u32 uc1_overflow : 1;                    // DWORD 0
         u32 uc1_underflow : 1;                   // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 rsvd4 : 2;                           // DWORD 0
         u32 uc0_proc_numfifo : 4;                // DWORD 0
         u32 uc1_proc_numfifo : 4;                // DWORD 0
         u32 uc0_proc_state : 2;                  // DWORD 0
         u32 rsvd5 : 2;                           // DWORD 0
         u32 uc1_proc_state : 2;                  // DWORD 0
         u32 rsvd6 : 2;                           // DWORD 0
      } SG_PACK RXULP_IQ_DEBUG0, *PRXULP_IQ_DEBUG0;

      typedef union _RXULP_IQ_DEBUG0_UNION {
         RXULP_IQ_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_IQ_DEBUG0_UNION, *PRXULP_IQ_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_IQ_DEBUG0_UNION, sizeof (RXULP_IQ_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of Various IQ. Writing to this registers clears Overflow/Undeflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_IQ_DEBUG1 {
         union {
            struct { 
               u32 rsvd3 : 8;                     // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 consel_numfifo : 3;            // DWORD 0
               u32 wdma_numfifo : 4;              // DWORD 0
               u32 consel_iqstate : 2;            // DWORD 0
               u32 wdma_state : 2;                // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 consel_underflow : 1;          // DWORD 0
               u32 consel_overflow : 1;           // DWORD 0
               u32 wdma_underflow : 1;            // DWORD 0
               u32 wdma_overflow : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_IQ_DEBUG1, *PRXULP_IQ_DEBUG1;

      SG_C_ASSERT(__sizeof__RXULP_IQ_DEBUG1, sizeof (RXULP_IQ_DEBUG1) == 4);

   #else
      typedef struct _RXULP_IQ_DEBUG1 {
         u32 rsvd3 : 8;                           // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 consel_numfifo : 3;                  // DWORD 0
         u32 wdma_numfifo : 4;                    // DWORD 0
         u32 consel_iqstate : 2;                  // DWORD 0
         u32 wdma_state : 2;                      // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 consel_underflow : 1;                // DWORD 0
         u32 consel_overflow : 1;                 // DWORD 0
         u32 wdma_underflow : 1;                  // DWORD 0
         u32 wdma_overflow : 1;                   // DWORD 0
      } SG_PACK RXULP_IQ_DEBUG1, *PRXULP_IQ_DEBUG1;

      typedef union _RXULP_IQ_DEBUG1_UNION {
         RXULP_IQ_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_IQ_DEBUG1_UNION, *PRXULP_IQ_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_IQ_DEBUG1_UNION, sizeof (RXULP_IQ_DEBUG1_UNION) == 4);
   #endif


#else
   // Debug of Various IQ. Writing to this registers clears Overflow/Undeflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_IQ_DEBUG1 {
         union {
            struct { 
               u32 wdma_overflow : 1;             // DWORD 0
               u32 wdma_underflow : 1;            // DWORD 0
               u32 consel_overflow : 1;           // DWORD 0
               u32 consel_underflow : 1;          // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 wdma_state : 2;                // DWORD 0
               u32 consel_iqstate : 2;            // DWORD 0
               u32 wdma_numfifo : 4;              // DWORD 0
               u32 consel_numfifo : 3;            // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 0
               u32 rsvd3 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_IQ_DEBUG1, *PRXULP_IQ_DEBUG1;

      SG_C_ASSERT(__sizeof__RXULP_IQ_DEBUG1, sizeof (RXULP_IQ_DEBUG1) == 4);

   #else
      typedef struct _RXULP_IQ_DEBUG1 {
         u32 wdma_overflow : 1;                   // DWORD 0
         u32 wdma_underflow : 1;                  // DWORD 0
         u32 consel_overflow : 1;                 // DWORD 0
         u32 consel_underflow : 1;                // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 wdma_state : 2;                      // DWORD 0
         u32 consel_iqstate : 2;                  // DWORD 0
         u32 wdma_numfifo : 4;                    // DWORD 0
         u32 consel_numfifo : 3;                  // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
         u32 rsvd3 : 8;                           // DWORD 0
      } SG_PACK RXULP_IQ_DEBUG1, *PRXULP_IQ_DEBUG1;

      typedef union _RXULP_IQ_DEBUG1_UNION {
         RXULP_IQ_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_IQ_DEBUG1_UNION, *PRXULP_IQ_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_IQ_DEBUG1_UNION, sizeof (RXULP_IQ_DEBUG1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of Various OQ. Writing to this registers clears Overflow/Undeflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_OQ_DEBUG0 {
         union {
            struct { 
               u32 cev_numfifo : 3;               // DWORD 0
               u32 self1_state : 2;               // DWORD 0
               u32 self0_state : 2;               // DWORD 0
               u32 self1_numfifo : 3;             // DWORD 0
               u32 self0_numfifo : 3;             // DWORD 0
               u32 uc_is_release : 1;             // DWORD 0
               u32 uc_numfifo : 3;                // DWORD 0
               u32 wdma_numfifo : 3;              // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 wdma_underflow : 1;            // DWORD 0
               u32 wdma_overflow : 1;             // DWORD 0
               u32 cev_underflow : 1;             // DWORD 0
               u32 cev_overflow : 1;              // DWORD 0
               u32 self1_underflow : 1;           // DWORD 0
               u32 self1_overflow : 1;            // DWORD 0
               u32 self0_underflow : 1;           // DWORD 0
               u32 self0_overflow : 1;            // DWORD 0
               u32 uc_underflow : 1;              // DWORD 0
               u32 uc_overflow : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_OQ_DEBUG0, *PRXULP_OQ_DEBUG0;

      SG_C_ASSERT(__sizeof__RXULP_OQ_DEBUG0, sizeof (RXULP_OQ_DEBUG0) == 4);

   #else
      typedef struct _RXULP_OQ_DEBUG0 {
         u32 cev_numfifo : 3;                     // DWORD 0
         u32 self1_state : 2;                     // DWORD 0
         u32 self0_state : 2;                     // DWORD 0
         u32 self1_numfifo : 3;                   // DWORD 0
         u32 self0_numfifo : 3;                   // DWORD 0
         u32 uc_is_release : 1;                   // DWORD 0
         u32 uc_numfifo : 3;                      // DWORD 0
         u32 wdma_numfifo : 3;                    // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 wdma_underflow : 1;                  // DWORD 0
         u32 wdma_overflow : 1;                   // DWORD 0
         u32 cev_underflow : 1;                   // DWORD 0
         u32 cev_overflow : 1;                    // DWORD 0
         u32 self1_underflow : 1;                 // DWORD 0
         u32 self1_overflow : 1;                  // DWORD 0
         u32 self0_underflow : 1;                 // DWORD 0
         u32 self0_overflow : 1;                  // DWORD 0
         u32 uc_underflow : 1;                    // DWORD 0
         u32 uc_overflow : 1;                     // DWORD 0
      } SG_PACK RXULP_OQ_DEBUG0, *PRXULP_OQ_DEBUG0;

      typedef union _RXULP_OQ_DEBUG0_UNION {
         RXULP_OQ_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_OQ_DEBUG0_UNION, *PRXULP_OQ_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_OQ_DEBUG0_UNION, sizeof (RXULP_OQ_DEBUG0_UNION) == 4);
   #endif


#else
   // Debug of Various OQ. Writing to this registers clears Overflow/Undeflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_OQ_DEBUG0 {
         union {
            struct { 
               u32 uc_overflow : 1;               // DWORD 0
               u32 uc_underflow : 1;              // DWORD 0
               u32 self0_overflow : 1;            // DWORD 0
               u32 self0_underflow : 1;           // DWORD 0
               u32 self1_overflow : 1;            // DWORD 0
               u32 self1_underflow : 1;           // DWORD 0
               u32 cev_overflow : 1;              // DWORD 0
               u32 cev_underflow : 1;             // DWORD 0
               u32 wdma_overflow : 1;             // DWORD 0
               u32 wdma_underflow : 1;            // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 wdma_numfifo : 3;              // DWORD 0
               u32 uc_numfifo : 3;                // DWORD 0
               u32 uc_is_release : 1;             // DWORD 0
               u32 self0_numfifo : 3;             // DWORD 0
               u32 self1_numfifo : 3;             // DWORD 0
               u32 self0_state : 2;               // DWORD 0
               u32 self1_state : 2;               // DWORD 0
               u32 cev_numfifo : 3;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_OQ_DEBUG0, *PRXULP_OQ_DEBUG0;

      SG_C_ASSERT(__sizeof__RXULP_OQ_DEBUG0, sizeof (RXULP_OQ_DEBUG0) == 4);

   #else
      typedef struct _RXULP_OQ_DEBUG0 {
         u32 uc_overflow : 1;                     // DWORD 0
         u32 uc_underflow : 1;                    // DWORD 0
         u32 self0_overflow : 1;                  // DWORD 0
         u32 self0_underflow : 1;                 // DWORD 0
         u32 self1_overflow : 1;                  // DWORD 0
         u32 self1_underflow : 1;                 // DWORD 0
         u32 cev_overflow : 1;                    // DWORD 0
         u32 cev_underflow : 1;                   // DWORD 0
         u32 wdma_overflow : 1;                   // DWORD 0
         u32 wdma_underflow : 1;                  // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 wdma_numfifo : 3;                    // DWORD 0
         u32 uc_numfifo : 3;                      // DWORD 0
         u32 uc_is_release : 1;                   // DWORD 0
         u32 self0_numfifo : 3;                   // DWORD 0
         u32 self1_numfifo : 3;                   // DWORD 0
         u32 self0_state : 2;                     // DWORD 0
         u32 self1_state : 2;                     // DWORD 0
         u32 cev_numfifo : 3;                     // DWORD 0
      } SG_PACK RXULP_OQ_DEBUG0, *PRXULP_OQ_DEBUG0;

      typedef union _RXULP_OQ_DEBUG0_UNION {
         RXULP_OQ_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_OQ_DEBUG0_UNION, *PRXULP_OQ_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_OQ_DEBUG0_UNION, sizeof (RXULP_OQ_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TCP Window Update HW control
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_EP_HW_DEBUG_SELECT_CR {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 rxulp_ep_hw_dbg_sel : 4;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_EP_HW_DEBUG_SELECT_CR, *PRXULP_EP_HW_DEBUG_SELECT_CR;

      SG_C_ASSERT(__sizeof__RXULP_EP_HW_DEBUG_SELECT_CR, sizeof (RXULP_EP_HW_DEBUG_SELECT_CR) == 4);

   #else
      typedef struct _RXULP_EP_HW_DEBUG_SELECT_CR {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 rxulp_ep_hw_dbg_sel : 4;             // DWORD 0
      } SG_PACK RXULP_EP_HW_DEBUG_SELECT_CR, *PRXULP_EP_HW_DEBUG_SELECT_CR;

      typedef union _RXULP_EP_HW_DEBUG_SELECT_CR_UNION {
         RXULP_EP_HW_DEBUG_SELECT_CR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_EP_HW_DEBUG_SELECT_CR_UNION, *PRXULP_EP_HW_DEBUG_SELECT_CR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_EP_HW_DEBUG_SELECT_CR_UNION, sizeof (RXULP_EP_HW_DEBUG_SELECT_CR_UNION) == 4);
   #endif


#else
   // TCP Window Update HW control
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_EP_HW_DEBUG_SELECT_CR {
         union {
            struct { 
               u32 rxulp_ep_hw_dbg_sel : 4;       // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_EP_HW_DEBUG_SELECT_CR, *PRXULP_EP_HW_DEBUG_SELECT_CR;

      SG_C_ASSERT(__sizeof__RXULP_EP_HW_DEBUG_SELECT_CR, sizeof (RXULP_EP_HW_DEBUG_SELECT_CR) == 4);

   #else
      typedef struct _RXULP_EP_HW_DEBUG_SELECT_CR {
         u32 rxulp_ep_hw_dbg_sel : 4;             // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK RXULP_EP_HW_DEBUG_SELECT_CR, *PRXULP_EP_HW_DEBUG_SELECT_CR;

      typedef union _RXULP_EP_HW_DEBUG_SELECT_CR_UNION {
         RXULP_EP_HW_DEBUG_SELECT_CR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_EP_HW_DEBUG_SELECT_CR_UNION, *PRXULP_EP_HW_DEBUG_SELECT_CR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_EP_HW_DEBUG_SELECT_CR_UNION, sizeof (RXULP_EP_HW_DEBUG_SELECT_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXULP Window Update Control Register 0
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WINDOW_UPDATE_CTRL0 {
         union {
            struct { 
               u32 rsvd2 : 4;                     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 en_mmr_notify_on_lt : 1;       // DWORD 0
               u32 en_db_notify_on_lt : 1;        // DWORD 0
               u32 mss_mmr_threshold : 2;         // DWORD 0
               u32 en_mmr_notification : 1;       // DWORD 0
               u32 mss_db_threshold : 2;          // DWORD 0
               u32 en_db_notification : 1;        // DWORD 0
               u32 ctx_addr_stride : 4;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL0, *PRXULP_WINDOW_UPDATE_CTRL0;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_CTRL0, sizeof (RXULP_WINDOW_UPDATE_CTRL0) == 4);

   #else
      typedef struct _RXULP_WINDOW_UPDATE_CTRL0 {
         u32 rsvd2 : 4;                           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 en_mmr_notify_on_lt : 1;             // DWORD 0
         u32 en_db_notify_on_lt : 1;              // DWORD 0
         u32 mss_mmr_threshold : 2;               // DWORD 0
         u32 en_mmr_notification : 1;             // DWORD 0
         u32 mss_db_threshold : 2;                // DWORD 0
         u32 en_db_notification : 1;              // DWORD 0
         u32 ctx_addr_stride : 4;                 // DWORD 0
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL0, *PRXULP_WINDOW_UPDATE_CTRL0;

      typedef union _RXULP_WINDOW_UPDATE_CTRL0_UNION {
         RXULP_WINDOW_UPDATE_CTRL0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL0_UNION, *PRXULP_WINDOW_UPDATE_CTRL0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_CTRL0_UNION, sizeof (RXULP_WINDOW_UPDATE_CTRL0_UNION) == 4);
   #endif


#else
   // RXULP Window Update Control Register 0
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WINDOW_UPDATE_CTRL0 {
         union {
            struct { 
               u32 ctx_addr_stride : 4;           // DWORD 0
               u32 en_db_notification : 1;        // DWORD 0
               u32 mss_db_threshold : 2;          // DWORD 0
               u32 en_mmr_notification : 1;       // DWORD 0
               u32 mss_mmr_threshold : 2;         // DWORD 0
               u32 en_db_notify_on_lt : 1;        // DWORD 0
               u32 en_mmr_notify_on_lt : 1;       // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL0, *PRXULP_WINDOW_UPDATE_CTRL0;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_CTRL0, sizeof (RXULP_WINDOW_UPDATE_CTRL0) == 4);

   #else
      typedef struct _RXULP_WINDOW_UPDATE_CTRL0 {
         u32 ctx_addr_stride : 4;                 // DWORD 0
         u32 en_db_notification : 1;              // DWORD 0
         u32 mss_db_threshold : 2;                // DWORD 0
         u32 en_mmr_notification : 1;             // DWORD 0
         u32 mss_mmr_threshold : 2;               // DWORD 0
         u32 en_db_notify_on_lt : 1;              // DWORD 0
         u32 en_mmr_notify_on_lt : 1;             // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL0, *PRXULP_WINDOW_UPDATE_CTRL0;

      typedef union _RXULP_WINDOW_UPDATE_CTRL0_UNION {
         RXULP_WINDOW_UPDATE_CTRL0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL0_UNION, *PRXULP_WINDOW_UPDATE_CTRL0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_CTRL0_UNION, sizeof (RXULP_WINDOW_UPDATE_CTRL0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXULP Window Update Control Register 1
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WINDOW_UPDATE_CTRL1 {
         union {
            struct { 
               u32 ctx_addr_offset1 : 16;         // DWORD 0
               u32 ctx_addr_offset0 : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL1, *PRXULP_WINDOW_UPDATE_CTRL1;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_CTRL1, sizeof (RXULP_WINDOW_UPDATE_CTRL1) == 4);

   #else
      typedef struct _RXULP_WINDOW_UPDATE_CTRL1 {
         u32 ctx_addr_offset1 : 16;               // DWORD 0
         u32 ctx_addr_offset0 : 16;               // DWORD 0
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL1, *PRXULP_WINDOW_UPDATE_CTRL1;

      typedef union _RXULP_WINDOW_UPDATE_CTRL1_UNION {
         RXULP_WINDOW_UPDATE_CTRL1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL1_UNION, *PRXULP_WINDOW_UPDATE_CTRL1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_CTRL1_UNION, sizeof (RXULP_WINDOW_UPDATE_CTRL1_UNION) == 4);
   #endif


#else
   // RXULP Window Update Control Register 1
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WINDOW_UPDATE_CTRL1 {
         union {
            struct { 
               u32 ctx_addr_offset0 : 16;         // DWORD 0
               u32 ctx_addr_offset1 : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL1, *PRXULP_WINDOW_UPDATE_CTRL1;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_CTRL1, sizeof (RXULP_WINDOW_UPDATE_CTRL1) == 4);

   #else
      typedef struct _RXULP_WINDOW_UPDATE_CTRL1 {
         u32 ctx_addr_offset0 : 16;               // DWORD 0
         u32 ctx_addr_offset1 : 16;               // DWORD 0
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL1, *PRXULP_WINDOW_UPDATE_CTRL1;

      typedef union _RXULP_WINDOW_UPDATE_CTRL1_UNION {
         RXULP_WINDOW_UPDATE_CTRL1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WINDOW_UPDATE_CTRL1_UNION, *PRXULP_WINDOW_UPDATE_CTRL1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_CTRL1_UNION, sizeof (RXULP_WINDOW_UPDATE_CTRL1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of TCP Window Update SM part 0. Writing to this location clears sticky
   // Overflow/Underflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WINDOW_UPDATE_DEBUG0 {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 notifcation_new : 1;           // DWORD 0
               u32 notifcation_cid : 11;          // DWORD 0
               u32 stage2_state : 3;              // DWORD 0
               u32 stage1_state : 2;              // DWORD 0
               u32 stage0_state : 4;              // DWORD 0
               u32 mmrfifo_num : 3;               // DWORD 0
               u32 dbfifo_num : 3;                // DWORD 0
               u32 mmrfifo_underflow_err : 1;     // DWORD 0
               u32 mmrfifo_overflow_err : 1;      // DWORD 0
               u32 dbfifo_underflow_err : 1;      // DWORD 0
               u32 dbfifo_overflow_err : 1;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG0, *PRXULP_WINDOW_UPDATE_DEBUG0;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_DEBUG0, sizeof (RXULP_WINDOW_UPDATE_DEBUG0) == 4);

   #else
      typedef struct _RXULP_WINDOW_UPDATE_DEBUG0 {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 notifcation_new : 1;                 // DWORD 0
         u32 notifcation_cid : 11;                // DWORD 0
         u32 stage2_state : 3;                    // DWORD 0
         u32 stage1_state : 2;                    // DWORD 0
         u32 stage0_state : 4;                    // DWORD 0
         u32 mmrfifo_num : 3;                     // DWORD 0
         u32 dbfifo_num : 3;                      // DWORD 0
         u32 mmrfifo_underflow_err : 1;           // DWORD 0
         u32 mmrfifo_overflow_err : 1;            // DWORD 0
         u32 dbfifo_underflow_err : 1;            // DWORD 0
         u32 dbfifo_overflow_err : 1;             // DWORD 0
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG0, *PRXULP_WINDOW_UPDATE_DEBUG0;

      typedef union _RXULP_WINDOW_UPDATE_DEBUG0_UNION {
         RXULP_WINDOW_UPDATE_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG0_UNION, *PRXULP_WINDOW_UPDATE_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_DEBUG0_UNION, sizeof (RXULP_WINDOW_UPDATE_DEBUG0_UNION) == 4);
   #endif


#else
   // Debug of TCP Window Update SM part 0. Writing to this location clears sticky
   // Overflow/Underflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WINDOW_UPDATE_DEBUG0 {
         union {
            struct { 
               u32 dbfifo_overflow_err : 1;       // DWORD 0
               u32 dbfifo_underflow_err : 1;      // DWORD 0
               u32 mmrfifo_overflow_err : 1;      // DWORD 0
               u32 mmrfifo_underflow_err : 1;     // DWORD 0
               u32 dbfifo_num : 3;                // DWORD 0
               u32 mmrfifo_num : 3;               // DWORD 0
               u32 stage0_state : 4;              // DWORD 0
               u32 stage1_state : 2;              // DWORD 0
               u32 stage2_state : 3;              // DWORD 0
               u32 notifcation_cid : 11;          // DWORD 0
               u32 notifcation_new : 1;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG0, *PRXULP_WINDOW_UPDATE_DEBUG0;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_DEBUG0, sizeof (RXULP_WINDOW_UPDATE_DEBUG0) == 4);

   #else
      typedef struct _RXULP_WINDOW_UPDATE_DEBUG0 {
         u32 dbfifo_overflow_err : 1;             // DWORD 0
         u32 dbfifo_underflow_err : 1;            // DWORD 0
         u32 mmrfifo_overflow_err : 1;            // DWORD 0
         u32 mmrfifo_underflow_err : 1;           // DWORD 0
         u32 dbfifo_num : 3;                      // DWORD 0
         u32 mmrfifo_num : 3;                     // DWORD 0
         u32 stage0_state : 4;                    // DWORD 0
         u32 stage1_state : 2;                    // DWORD 0
         u32 stage2_state : 3;                    // DWORD 0
         u32 notifcation_cid : 11;                // DWORD 0
         u32 notifcation_new : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG0, *PRXULP_WINDOW_UPDATE_DEBUG0;

      typedef union _RXULP_WINDOW_UPDATE_DEBUG0_UNION {
         RXULP_WINDOW_UPDATE_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG0_UNION, *PRXULP_WINDOW_UPDATE_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_DEBUG0_UNION, sizeof (RXULP_WINDOW_UPDATE_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of TCP Window Update SM part 1. Writing to this location clears sticky
   // Overflow/Underflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WINDOW_UPDATE_DEBUG1 {
         union {
            struct { 
               u32 db_new : 1;                    // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 db_cid : 11;                   // DWORD 0
               u32 db_win : 16;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG1, *PRXULP_WINDOW_UPDATE_DEBUG1;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_DEBUG1, sizeof (RXULP_WINDOW_UPDATE_DEBUG1) == 4);

   #else
      typedef struct _RXULP_WINDOW_UPDATE_DEBUG1 {
         u32 db_new : 1;                          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 db_cid : 11;                         // DWORD 0
         u32 db_win : 16;                         // DWORD 0
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG1, *PRXULP_WINDOW_UPDATE_DEBUG1;

      typedef union _RXULP_WINDOW_UPDATE_DEBUG1_UNION {
         RXULP_WINDOW_UPDATE_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG1_UNION, *PRXULP_WINDOW_UPDATE_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_DEBUG1_UNION, sizeof (RXULP_WINDOW_UPDATE_DEBUG1_UNION) == 4);
   #endif


#else
   // Debug of TCP Window Update SM part 1. Writing to this location clears sticky
   // Overflow/Underflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WINDOW_UPDATE_DEBUG1 {
         union {
            struct { 
               u32 db_win : 16;                   // DWORD 0
               u32 db_cid : 11;                   // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 db_new : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG1, *PRXULP_WINDOW_UPDATE_DEBUG1;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_DEBUG1, sizeof (RXULP_WINDOW_UPDATE_DEBUG1) == 4);

   #else
      typedef struct _RXULP_WINDOW_UPDATE_DEBUG1 {
         u32 db_win : 16;                         // DWORD 0
         u32 db_cid : 11;                         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 db_new : 1;                          // DWORD 0
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG1, *PRXULP_WINDOW_UPDATE_DEBUG1;

      typedef union _RXULP_WINDOW_UPDATE_DEBUG1_UNION {
         RXULP_WINDOW_UPDATE_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WINDOW_UPDATE_DEBUG1_UNION, *PRXULP_WINDOW_UPDATE_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WINDOW_UPDATE_DEBUG1_UNION, sizeof (RXULP_WINDOW_UPDATE_DEBUG1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of various local SM. Writing to this location clears sticky Overflow/Underflow
   // indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_SM_DEBUG0 {
         union {
            struct { 
               u32 rsvd3 : 20;                    // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 tpre_cred_state : 3;           // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 tpre_cred_num : 3;             // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 tpre_cred_underflow_err : 1;   // DWORD 0
               u32 tpre_cred_overflow_err : 1;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_SM_DEBUG0, *PRXULP_SM_DEBUG0;

      SG_C_ASSERT(__sizeof__RXULP_SM_DEBUG0, sizeof (RXULP_SM_DEBUG0) == 4);

   #else
      typedef struct _RXULP_SM_DEBUG0 {
         u32 rsvd3 : 20;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 tpre_cred_state : 3;                 // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 tpre_cred_num : 3;                   // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 tpre_cred_underflow_err : 1;         // DWORD 0
         u32 tpre_cred_overflow_err : 1;          // DWORD 0
      } SG_PACK RXULP_SM_DEBUG0, *PRXULP_SM_DEBUG0;

      typedef union _RXULP_SM_DEBUG0_UNION {
         RXULP_SM_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_SM_DEBUG0_UNION, *PRXULP_SM_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_SM_DEBUG0_UNION, sizeof (RXULP_SM_DEBUG0_UNION) == 4);
   #endif


#else
   // Debug of various local SM. Writing to this location clears sticky Overflow/Underflow
   // indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_SM_DEBUG0 {
         union {
            struct { 
               u32 tpre_cred_overflow_err : 1;    // DWORD 0
               u32 tpre_cred_underflow_err : 1;   // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 tpre_cred_num : 3;             // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 tpre_cred_state : 3;           // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 rsvd3 : 20;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_SM_DEBUG0, *PRXULP_SM_DEBUG0;

      SG_C_ASSERT(__sizeof__RXULP_SM_DEBUG0, sizeof (RXULP_SM_DEBUG0) == 4);

   #else
      typedef struct _RXULP_SM_DEBUG0 {
         u32 tpre_cred_overflow_err : 1;          // DWORD 0
         u32 tpre_cred_underflow_err : 1;         // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 tpre_cred_num : 3;                   // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 tpre_cred_state : 3;                 // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd3 : 20;                          // DWORD 0
      } SG_PACK RXULP_SM_DEBUG0, *PRXULP_SM_DEBUG0;

      typedef union _RXULP_SM_DEBUG0_UNION {
         RXULP_SM_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_SM_DEBUG0_UNION, *PRXULP_SM_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_SM_DEBUG0_UNION, sizeof (RXULP_SM_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Virtual queue weights.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUES_WEIGHTS {
         union {
            struct { 
               u32 weight_queue15 : 2;            // DWORD 0
               u32 weight_queue14 : 2;            // DWORD 0
               u32 weight_queue13 : 2;            // DWORD 0
               u32 weight_queue12 : 2;            // DWORD 0
               u32 weight_queue11 : 2;            // DWORD 0
               u32 weight_queue10 : 2;            // DWORD 0
               u32 weight_queue9 : 2;             // DWORD 0
               u32 weight_queue8 : 2;             // DWORD 0
               u32 weight_queue7 : 2;             // DWORD 0
               u32 weight_queue6 : 2;             // DWORD 0
               u32 weight_queue5 : 2;             // DWORD 0
               u32 weight_queue4 : 2;             // DWORD 0
               u32 weight_queue3 : 2;             // DWORD 0
               u32 weight_queue2 : 2;             // DWORD 0
               u32 weight_queue1 : 2;             // DWORD 0
               u32 weight_queue0 : 2;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUES_WEIGHTS, *PRXULP_VQUEUES_WEIGHTS;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUES_WEIGHTS, sizeof (RXULP_VQUEUES_WEIGHTS) == 4);

   #else
      typedef struct _RXULP_VQUEUES_WEIGHTS {
         u32 weight_queue15 : 2;                  // DWORD 0
         u32 weight_queue14 : 2;                  // DWORD 0
         u32 weight_queue13 : 2;                  // DWORD 0
         u32 weight_queue12 : 2;                  // DWORD 0
         u32 weight_queue11 : 2;                  // DWORD 0
         u32 weight_queue10 : 2;                  // DWORD 0
         u32 weight_queue9 : 2;                   // DWORD 0
         u32 weight_queue8 : 2;                   // DWORD 0
         u32 weight_queue7 : 2;                   // DWORD 0
         u32 weight_queue6 : 2;                   // DWORD 0
         u32 weight_queue5 : 2;                   // DWORD 0
         u32 weight_queue4 : 2;                   // DWORD 0
         u32 weight_queue3 : 2;                   // DWORD 0
         u32 weight_queue2 : 2;                   // DWORD 0
         u32 weight_queue1 : 2;                   // DWORD 0
         u32 weight_queue0 : 2;                   // DWORD 0
      } SG_PACK RXULP_VQUEUES_WEIGHTS, *PRXULP_VQUEUES_WEIGHTS;

      typedef union _RXULP_VQUEUES_WEIGHTS_UNION {
         RXULP_VQUEUES_WEIGHTS bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUES_WEIGHTS_UNION, *PRXULP_VQUEUES_WEIGHTS_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUES_WEIGHTS_UNION, sizeof (RXULP_VQUEUES_WEIGHTS_UNION) == 4);
   #endif


#else
   // Virtual queue weights.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUES_WEIGHTS {
         union {
            struct { 
               u32 weight_queue0 : 2;             // DWORD 0
               u32 weight_queue1 : 2;             // DWORD 0
               u32 weight_queue2 : 2;             // DWORD 0
               u32 weight_queue3 : 2;             // DWORD 0
               u32 weight_queue4 : 2;             // DWORD 0
               u32 weight_queue5 : 2;             // DWORD 0
               u32 weight_queue6 : 2;             // DWORD 0
               u32 weight_queue7 : 2;             // DWORD 0
               u32 weight_queue8 : 2;             // DWORD 0
               u32 weight_queue9 : 2;             // DWORD 0
               u32 weight_queue10 : 2;            // DWORD 0
               u32 weight_queue11 : 2;            // DWORD 0
               u32 weight_queue12 : 2;            // DWORD 0
               u32 weight_queue13 : 2;            // DWORD 0
               u32 weight_queue14 : 2;            // DWORD 0
               u32 weight_queue15 : 2;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUES_WEIGHTS, *PRXULP_VQUEUES_WEIGHTS;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUES_WEIGHTS, sizeof (RXULP_VQUEUES_WEIGHTS) == 4);

   #else
      typedef struct _RXULP_VQUEUES_WEIGHTS {
         u32 weight_queue0 : 2;                   // DWORD 0
         u32 weight_queue1 : 2;                   // DWORD 0
         u32 weight_queue2 : 2;                   // DWORD 0
         u32 weight_queue3 : 2;                   // DWORD 0
         u32 weight_queue4 : 2;                   // DWORD 0
         u32 weight_queue5 : 2;                   // DWORD 0
         u32 weight_queue6 : 2;                   // DWORD 0
         u32 weight_queue7 : 2;                   // DWORD 0
         u32 weight_queue8 : 2;                   // DWORD 0
         u32 weight_queue9 : 2;                   // DWORD 0
         u32 weight_queue10 : 2;                  // DWORD 0
         u32 weight_queue11 : 2;                  // DWORD 0
         u32 weight_queue12 : 2;                  // DWORD 0
         u32 weight_queue13 : 2;                  // DWORD 0
         u32 weight_queue14 : 2;                  // DWORD 0
         u32 weight_queue15 : 2;                  // DWORD 0
      } SG_PACK RXULP_VQUEUES_WEIGHTS, *PRXULP_VQUEUES_WEIGHTS;

      typedef union _RXULP_VQUEUES_WEIGHTS_UNION {
         RXULP_VQUEUES_WEIGHTS bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUES_WEIGHTS_UNION, *PRXULP_VQUEUES_WEIGHTS_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUES_WEIGHTS_UNION, sizeof (RXULP_VQUEUES_WEIGHTS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Indicates the individual threshold of each virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_THRESHOLDS {
         union {
            struct { 
               u32 rsvd2 : 2;                     // DWORD 0
               u32 queue_thresh1 : 6;             // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 queue_thresh0 : 6;             // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 flow_id_queue14 : 1;           // DWORD 0
               u32 flow_id_queue13 : 1;           // DWORD 0
               u32 flow_id_queue12 : 1;           // DWORD 0
               u32 flow_id_queue11 : 1;           // DWORD 0
               u32 flow_id_queue10 : 1;           // DWORD 0
               u32 flow_id_queue9 : 1;            // DWORD 0
               u32 flow_id_queue8 : 1;            // DWORD 0
               u32 flow_id_queue7 : 1;            // DWORD 0
               u32 flow_id_queue6 : 1;            // DWORD 0
               u32 flow_id_queue5 : 1;            // DWORD 0
               u32 flow_id_queue4 : 1;            // DWORD 0
               u32 flow_id_queue3 : 1;            // DWORD 0
               u32 flow_id_queue2 : 1;            // DWORD 0
               u32 flow_id_queue1 : 1;            // DWORD 0
               u32 flow_id_queue0 : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_THRESHOLDS, *PRXULP_VQUEUE_THRESHOLDS;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_THRESHOLDS, sizeof (RXULP_VQUEUE_THRESHOLDS) == 4);

   #else
      typedef struct _RXULP_VQUEUE_THRESHOLDS {
         u32 rsvd2 : 2;                           // DWORD 0
         u32 queue_thresh1 : 6;                   // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 queue_thresh0 : 6;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 flow_id_queue14 : 1;                 // DWORD 0
         u32 flow_id_queue13 : 1;                 // DWORD 0
         u32 flow_id_queue12 : 1;                 // DWORD 0
         u32 flow_id_queue11 : 1;                 // DWORD 0
         u32 flow_id_queue10 : 1;                 // DWORD 0
         u32 flow_id_queue9 : 1;                  // DWORD 0
         u32 flow_id_queue8 : 1;                  // DWORD 0
         u32 flow_id_queue7 : 1;                  // DWORD 0
         u32 flow_id_queue6 : 1;                  // DWORD 0
         u32 flow_id_queue5 : 1;                  // DWORD 0
         u32 flow_id_queue4 : 1;                  // DWORD 0
         u32 flow_id_queue3 : 1;                  // DWORD 0
         u32 flow_id_queue2 : 1;                  // DWORD 0
         u32 flow_id_queue1 : 1;                  // DWORD 0
         u32 flow_id_queue0 : 1;                  // DWORD 0
      } SG_PACK RXULP_VQUEUE_THRESHOLDS, *PRXULP_VQUEUE_THRESHOLDS;

      typedef union _RXULP_VQUEUE_THRESHOLDS_UNION {
         RXULP_VQUEUE_THRESHOLDS bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_THRESHOLDS_UNION, *PRXULP_VQUEUE_THRESHOLDS_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_THRESHOLDS_UNION, sizeof (RXULP_VQUEUE_THRESHOLDS_UNION) == 4);
   #endif


#else
   // Indicates the individual threshold of each virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_THRESHOLDS {
         union {
            struct { 
               u32 flow_id_queue0 : 1;            // DWORD 0
               u32 flow_id_queue1 : 1;            // DWORD 0
               u32 flow_id_queue2 : 1;            // DWORD 0
               u32 flow_id_queue3 : 1;            // DWORD 0
               u32 flow_id_queue4 : 1;            // DWORD 0
               u32 flow_id_queue5 : 1;            // DWORD 0
               u32 flow_id_queue6 : 1;            // DWORD 0
               u32 flow_id_queue7 : 1;            // DWORD 0
               u32 flow_id_queue8 : 1;            // DWORD 0
               u32 flow_id_queue9 : 1;            // DWORD 0
               u32 flow_id_queue10 : 1;           // DWORD 0
               u32 flow_id_queue11 : 1;           // DWORD 0
               u32 flow_id_queue12 : 1;           // DWORD 0
               u32 flow_id_queue13 : 1;           // DWORD 0
               u32 flow_id_queue14 : 1;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 queue_thresh0 : 6;             // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 queue_thresh1 : 6;             // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_THRESHOLDS, *PRXULP_VQUEUE_THRESHOLDS;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_THRESHOLDS, sizeof (RXULP_VQUEUE_THRESHOLDS) == 4);

   #else
      typedef struct _RXULP_VQUEUE_THRESHOLDS {
         u32 flow_id_queue0 : 1;                  // DWORD 0
         u32 flow_id_queue1 : 1;                  // DWORD 0
         u32 flow_id_queue2 : 1;                  // DWORD 0
         u32 flow_id_queue3 : 1;                  // DWORD 0
         u32 flow_id_queue4 : 1;                  // DWORD 0
         u32 flow_id_queue5 : 1;                  // DWORD 0
         u32 flow_id_queue6 : 1;                  // DWORD 0
         u32 flow_id_queue7 : 1;                  // DWORD 0
         u32 flow_id_queue8 : 1;                  // DWORD 0
         u32 flow_id_queue9 : 1;                  // DWORD 0
         u32 flow_id_queue10 : 1;                 // DWORD 0
         u32 flow_id_queue11 : 1;                 // DWORD 0
         u32 flow_id_queue12 : 1;                 // DWORD 0
         u32 flow_id_queue13 : 1;                 // DWORD 0
         u32 flow_id_queue14 : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 queue_thresh0 : 6;                   // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 queue_thresh1 : 6;                   // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
      } SG_PACK RXULP_VQUEUE_THRESHOLDS, *PRXULP_VQUEUE_THRESHOLDS;

      typedef union _RXULP_VQUEUE_THRESHOLDS_UNION {
         RXULP_VQUEUE_THRESHOLDS bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_THRESHOLDS_UNION, *PRXULP_VQUEUE_THRESHOLDS_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_THRESHOLDS_UNION, sizeof (RXULP_VQUEUE_THRESHOLDS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Indicates the credits given to the virtual queues 0 to 7 out of reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_CREDITS0 {
         union {
            struct { 
               u32 init_credit_queue7 : 4;        // DWORD 0
               u32 init_credit_queue6 : 4;        // DWORD 0
               u32 init_credit_queue5 : 4;        // DWORD 0
               u32 init_credit_queue4 : 4;        // DWORD 0
               u32 init_credit_queue3 : 4;        // DWORD 0
               u32 init_credit_queue2 : 4;        // DWORD 0
               u32 init_credit_queue1 : 4;        // DWORD 0
               u32 init_credit_queue0 : 4;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_CREDITS0, *PRXULP_VQUEUE_CREDITS0;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_CREDITS0, sizeof (RXULP_VQUEUE_CREDITS0) == 4);

   #else
      typedef struct _RXULP_VQUEUE_CREDITS0 {
         u32 init_credit_queue7 : 4;              // DWORD 0
         u32 init_credit_queue6 : 4;              // DWORD 0
         u32 init_credit_queue5 : 4;              // DWORD 0
         u32 init_credit_queue4 : 4;              // DWORD 0
         u32 init_credit_queue3 : 4;              // DWORD 0
         u32 init_credit_queue2 : 4;              // DWORD 0
         u32 init_credit_queue1 : 4;              // DWORD 0
         u32 init_credit_queue0 : 4;              // DWORD 0
      } SG_PACK RXULP_VQUEUE_CREDITS0, *PRXULP_VQUEUE_CREDITS0;

      typedef union _RXULP_VQUEUE_CREDITS0_UNION {
         RXULP_VQUEUE_CREDITS0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_CREDITS0_UNION, *PRXULP_VQUEUE_CREDITS0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_CREDITS0_UNION, sizeof (RXULP_VQUEUE_CREDITS0_UNION) == 4);
   #endif


#else
   // Indicates the credits given to the virtual queues 0 to 7 out of reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_CREDITS0 {
         union {
            struct { 
               u32 init_credit_queue0 : 4;        // DWORD 0
               u32 init_credit_queue1 : 4;        // DWORD 0
               u32 init_credit_queue2 : 4;        // DWORD 0
               u32 init_credit_queue3 : 4;        // DWORD 0
               u32 init_credit_queue4 : 4;        // DWORD 0
               u32 init_credit_queue5 : 4;        // DWORD 0
               u32 init_credit_queue6 : 4;        // DWORD 0
               u32 init_credit_queue7 : 4;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_CREDITS0, *PRXULP_VQUEUE_CREDITS0;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_CREDITS0, sizeof (RXULP_VQUEUE_CREDITS0) == 4);

   #else
      typedef struct _RXULP_VQUEUE_CREDITS0 {
         u32 init_credit_queue0 : 4;              // DWORD 0
         u32 init_credit_queue1 : 4;              // DWORD 0
         u32 init_credit_queue2 : 4;              // DWORD 0
         u32 init_credit_queue3 : 4;              // DWORD 0
         u32 init_credit_queue4 : 4;              // DWORD 0
         u32 init_credit_queue5 : 4;              // DWORD 0
         u32 init_credit_queue6 : 4;              // DWORD 0
         u32 init_credit_queue7 : 4;              // DWORD 0
      } SG_PACK RXULP_VQUEUE_CREDITS0, *PRXULP_VQUEUE_CREDITS0;

      typedef union _RXULP_VQUEUE_CREDITS0_UNION {
         RXULP_VQUEUE_CREDITS0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_CREDITS0_UNION, *PRXULP_VQUEUE_CREDITS0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_CREDITS0_UNION, sizeof (RXULP_VQUEUE_CREDITS0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Indicates the credits given to the virtual queues 8 to 15 out of reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_CREDITS1 {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 init_credit_queue14 : 4;       // DWORD 0
               u32 init_credit_queue13 : 4;       // DWORD 0
               u32 init_credit_queue12 : 4;       // DWORD 0
               u32 init_credit_queue11 : 4;       // DWORD 0
               u32 init_credit_queue10 : 4;       // DWORD 0
               u32 init_credit_queue9 : 4;        // DWORD 0
               u32 init_credit_queue8 : 4;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_CREDITS1, *PRXULP_VQUEUE_CREDITS1;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_CREDITS1, sizeof (RXULP_VQUEUE_CREDITS1) == 4);

   #else
      typedef struct _RXULP_VQUEUE_CREDITS1 {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 init_credit_queue14 : 4;             // DWORD 0
         u32 init_credit_queue13 : 4;             // DWORD 0
         u32 init_credit_queue12 : 4;             // DWORD 0
         u32 init_credit_queue11 : 4;             // DWORD 0
         u32 init_credit_queue10 : 4;             // DWORD 0
         u32 init_credit_queue9 : 4;              // DWORD 0
         u32 init_credit_queue8 : 4;              // DWORD 0
      } SG_PACK RXULP_VQUEUE_CREDITS1, *PRXULP_VQUEUE_CREDITS1;

      typedef union _RXULP_VQUEUE_CREDITS1_UNION {
         RXULP_VQUEUE_CREDITS1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_CREDITS1_UNION, *PRXULP_VQUEUE_CREDITS1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_CREDITS1_UNION, sizeof (RXULP_VQUEUE_CREDITS1_UNION) == 4);
   #endif


#else
   // Indicates the credits given to the virtual queues 8 to 15 out of reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_CREDITS1 {
         union {
            struct { 
               u32 init_credit_queue8 : 4;        // DWORD 0
               u32 init_credit_queue9 : 4;        // DWORD 0
               u32 init_credit_queue10 : 4;       // DWORD 0
               u32 init_credit_queue11 : 4;       // DWORD 0
               u32 init_credit_queue12 : 4;       // DWORD 0
               u32 init_credit_queue13 : 4;       // DWORD 0
               u32 init_credit_queue14 : 4;       // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_CREDITS1, *PRXULP_VQUEUE_CREDITS1;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_CREDITS1, sizeof (RXULP_VQUEUE_CREDITS1) == 4);

   #else
      typedef struct _RXULP_VQUEUE_CREDITS1 {
         u32 init_credit_queue8 : 4;              // DWORD 0
         u32 init_credit_queue9 : 4;              // DWORD 0
         u32 init_credit_queue10 : 4;             // DWORD 0
         u32 init_credit_queue11 : 4;             // DWORD 0
         u32 init_credit_queue12 : 4;             // DWORD 0
         u32 init_credit_queue13 : 4;             // DWORD 0
         u32 init_credit_queue14 : 4;             // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK RXULP_VQUEUE_CREDITS1, *PRXULP_VQUEUE_CREDITS1;

      typedef union _RXULP_VQUEUE_CREDITS1_UNION {
         RXULP_VQUEUE_CREDITS1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_CREDITS1_UNION, *PRXULP_VQUEUE_CREDITS1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_CREDITS1_UNION, sizeof (RXULP_VQUEUE_CREDITS1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug write data to the virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_RW_LSB {
         union {
            struct { 
               u32 vqueue_dbg_wr_data_lower;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_LSB, *PRXULP_VQUEUE_DEBUG_RW_LSB;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_RW_LSB, sizeof (RXULP_VQUEUE_DEBUG_RW_LSB) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_RW_LSB {
         u32 vqueue_dbg_wr_data_lower;            // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_LSB, *PRXULP_VQUEUE_DEBUG_RW_LSB;

      typedef union _RXULP_VQUEUE_DEBUG_RW_LSB_UNION {
         RXULP_VQUEUE_DEBUG_RW_LSB bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_LSB_UNION, *PRXULP_VQUEUE_DEBUG_RW_LSB_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_RW_LSB_UNION, sizeof (RXULP_VQUEUE_DEBUG_RW_LSB_UNION) == 4);
   #endif


#else
   // Debug write data to the virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_RW_LSB {
         union {
            struct { 
               u32 vqueue_dbg_wr_data_lower;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_LSB, *PRXULP_VQUEUE_DEBUG_RW_LSB;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_RW_LSB, sizeof (RXULP_VQUEUE_DEBUG_RW_LSB) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_RW_LSB {
         u32 vqueue_dbg_wr_data_lower;            // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_LSB, *PRXULP_VQUEUE_DEBUG_RW_LSB;

      typedef union _RXULP_VQUEUE_DEBUG_RW_LSB_UNION {
         RXULP_VQUEUE_DEBUG_RW_LSB bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_LSB_UNION, *PRXULP_VQUEUE_DEBUG_RW_LSB_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_RW_LSB_UNION, sizeof (RXULP_VQUEUE_DEBUG_RW_LSB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug write data to the virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_RW_MSB {
         union {
            struct { 
               u32 vqueue_dbg_wr_data_upper;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_MSB, *PRXULP_VQUEUE_DEBUG_RW_MSB;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_RW_MSB, sizeof (RXULP_VQUEUE_DEBUG_RW_MSB) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_RW_MSB {
         u32 vqueue_dbg_wr_data_upper;            // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_MSB, *PRXULP_VQUEUE_DEBUG_RW_MSB;

      typedef union _RXULP_VQUEUE_DEBUG_RW_MSB_UNION {
         RXULP_VQUEUE_DEBUG_RW_MSB bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_MSB_UNION, *PRXULP_VQUEUE_DEBUG_RW_MSB_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_RW_MSB_UNION, sizeof (RXULP_VQUEUE_DEBUG_RW_MSB_UNION) == 4);
   #endif


#else
   // Debug write data to the virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_RW_MSB {
         union {
            struct { 
               u32 vqueue_dbg_wr_data_upper;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_MSB, *PRXULP_VQUEUE_DEBUG_RW_MSB;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_RW_MSB, sizeof (RXULP_VQUEUE_DEBUG_RW_MSB) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_RW_MSB {
         u32 vqueue_dbg_wr_data_upper;            // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_MSB, *PRXULP_VQUEUE_DEBUG_RW_MSB;

      typedef union _RXULP_VQUEUE_DEBUG_RW_MSB_UNION {
         RXULP_VQUEUE_DEBUG_RW_MSB bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_RW_MSB_UNION, *PRXULP_VQUEUE_DEBUG_RW_MSB_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_RW_MSB_UNION, sizeof (RXULP_VQUEUE_DEBUG_RW_MSB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug write data to the virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_LL_BITS {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 vqueue_dbg_ll_bits : 4;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_LL_BITS, *PRXULP_VQUEUE_DEBUG_LL_BITS;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_LL_BITS, sizeof (RXULP_VQUEUE_DEBUG_LL_BITS) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_LL_BITS {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 vqueue_dbg_ll_bits : 4;              // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_LL_BITS, *PRXULP_VQUEUE_DEBUG_LL_BITS;

      typedef union _RXULP_VQUEUE_DEBUG_LL_BITS_UNION {
         RXULP_VQUEUE_DEBUG_LL_BITS bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_LL_BITS_UNION, *PRXULP_VQUEUE_DEBUG_LL_BITS_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_LL_BITS_UNION, sizeof (RXULP_VQUEUE_DEBUG_LL_BITS_UNION) == 4);
   #endif


#else
   // Debug write data to the virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_LL_BITS {
         union {
            struct { 
               u32 vqueue_dbg_ll_bits : 4;        // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_LL_BITS, *PRXULP_VQUEUE_DEBUG_LL_BITS;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_LL_BITS, sizeof (RXULP_VQUEUE_DEBUG_LL_BITS) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_LL_BITS {
         u32 vqueue_dbg_ll_bits : 4;              // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_LL_BITS, *PRXULP_VQUEUE_DEBUG_LL_BITS;

      typedef union _RXULP_VQUEUE_DEBUG_LL_BITS_UNION {
         RXULP_VQUEUE_DEBUG_LL_BITS bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_LL_BITS_UNION, *PRXULP_VQUEUE_DEBUG_LL_BITS_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_LL_BITS_UNION, sizeof (RXULP_VQUEUE_DEBUG_LL_BITS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug control signals for the virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_CONTROL {
         union {
            struct { 
               u32 rsvd3 : 11;                    // DWORD 0
               u32 dbg_scoreboard_wr : 1;         // DWORD 0
               u32 dbg_scoreboard_qid : 4;        // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 dbg_fme_vqueue : 1;            // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 dbg_wr_vqueue : 1;             // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 dbg_addr_vqueue : 7;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_CONTROL, *PRXULP_VQUEUE_DEBUG_CONTROL;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_CONTROL, sizeof (RXULP_VQUEUE_DEBUG_CONTROL) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_CONTROL {
         u32 rsvd3 : 11;                          // DWORD 0
         u32 dbg_scoreboard_wr : 1;               // DWORD 0
         u32 dbg_scoreboard_qid : 4;              // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 dbg_fme_vqueue : 1;                  // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 dbg_wr_vqueue : 1;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 dbg_addr_vqueue : 7;                 // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_CONTROL, *PRXULP_VQUEUE_DEBUG_CONTROL;

      typedef union _RXULP_VQUEUE_DEBUG_CONTROL_UNION {
         RXULP_VQUEUE_DEBUG_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_CONTROL_UNION, *PRXULP_VQUEUE_DEBUG_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_CONTROL_UNION, sizeof (RXULP_VQUEUE_DEBUG_CONTROL_UNION) == 4);
   #endif


#else
   // Debug control signals for the virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_CONTROL {
         union {
            struct { 
               u32 dbg_addr_vqueue : 7;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 dbg_wr_vqueue : 1;             // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 dbg_fme_vqueue : 1;            // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 dbg_scoreboard_qid : 4;        // DWORD 0
               u32 dbg_scoreboard_wr : 1;         // DWORD 0
               u32 rsvd3 : 11;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_CONTROL, *PRXULP_VQUEUE_DEBUG_CONTROL;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_CONTROL, sizeof (RXULP_VQUEUE_DEBUG_CONTROL) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_CONTROL {
         u32 dbg_addr_vqueue : 7;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 dbg_wr_vqueue : 1;                   // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 dbg_fme_vqueue : 1;                  // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 dbg_scoreboard_qid : 4;              // DWORD 0
         u32 dbg_scoreboard_wr : 1;               // DWORD 0
         u32 rsvd3 : 11;                          // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_CONTROL, *PRXULP_VQUEUE_DEBUG_CONTROL;

      typedef union _RXULP_VQUEUE_DEBUG_CONTROL_UNION {
         RXULP_VQUEUE_DEBUG_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_CONTROL_UNION, *PRXULP_VQUEUE_DEBUG_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_CONTROL_UNION, sizeof (RXULP_VQUEUE_DEBUG_CONTROL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides the free list pointers and state information of the virtual
   // queue .
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_STATS1 {
         union {
            struct { 
               u32 rsvd3 : 3;                     // DWORD 0
               u32 vqueue_dbg_state_machine : 5;  // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 vqueue_dbg_free_list_count : 6; // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 vqueue_dbg_free_list_tail : 5; // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 vqueue_dbg_free_list_head : 5; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS1, *PRXULP_VQUEUE_DEBUG_STATS1;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS1, sizeof (RXULP_VQUEUE_DEBUG_STATS1) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_STATS1 {
         u32 rsvd3 : 3;                           // DWORD 0
         u32 vqueue_dbg_state_machine : 5;        // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 vqueue_dbg_free_list_count : 6;      // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 vqueue_dbg_free_list_tail : 5;       // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 vqueue_dbg_free_list_head : 5;       // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS1, *PRXULP_VQUEUE_DEBUG_STATS1;

      typedef union _RXULP_VQUEUE_DEBUG_STATS1_UNION {
         RXULP_VQUEUE_DEBUG_STATS1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS1_UNION, *PRXULP_VQUEUE_DEBUG_STATS1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS1_UNION, sizeof (RXULP_VQUEUE_DEBUG_STATS1_UNION) == 4);
   #endif


#else
   // This register provides the free list pointers and state information of the virtual
   // queue .
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_STATS1 {
         union {
            struct { 
               u32 vqueue_dbg_free_list_head : 5; // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 vqueue_dbg_free_list_tail : 5; // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 vqueue_dbg_free_list_count : 6; // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 vqueue_dbg_state_machine : 5;  // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS1, *PRXULP_VQUEUE_DEBUG_STATS1;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS1, sizeof (RXULP_VQUEUE_DEBUG_STATS1) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_STATS1 {
         u32 vqueue_dbg_free_list_head : 5;       // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 vqueue_dbg_free_list_tail : 5;       // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 vqueue_dbg_free_list_count : 6;      // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 vqueue_dbg_state_machine : 5;        // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS1, *PRXULP_VQUEUE_DEBUG_STATS1;

      typedef union _RXULP_VQUEUE_DEBUG_STATS1_UNION {
         RXULP_VQUEUE_DEBUG_STATS1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS1_UNION, *PRXULP_VQUEUE_DEBUG_STATS1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS1_UNION, sizeof (RXULP_VQUEUE_DEBUG_STATS1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides the information regarding sram parity error address and other
   // debug stats
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_STATS2 {
         union {
            struct { 
               u32 rsvd3 : 2;                     // DWORD 0
               u32 sram_parity_error_address : 6; // DWORD 0
               u32 sram_init_over : 1;            // DWORD 0
               u32 arbiter_grant_state_machine : 3; // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 vqueue_controller_grant_instr_rd : 3; // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 vqueue_controller_grant_instr_wr : 3; // DWORD 0
               u32 vqueue_controller_scoreboard_grant_fsm : 2; // DWORD 0
               u32 vqueue_controller_rd_instr_fsm : 2; // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vqueue_controller_wr_instr_fsm : 3; // DWORD 0
               u32 vqueue_controller_mmr_read_fsm : 2; // DWORD 0
               u32 vqueue_controller_mmr_write_fsm : 2; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS2, *PRXULP_VQUEUE_DEBUG_STATS2;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS2, sizeof (RXULP_VQUEUE_DEBUG_STATS2) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_STATS2 {
         u32 rsvd3 : 2;                           // DWORD 0
         u32 sram_parity_error_address : 6;       // DWORD 0
         u32 sram_init_over : 1;                  // DWORD 0
         u32 arbiter_grant_state_machine : 3;     // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 vqueue_controller_grant_instr_rd : 3; // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 vqueue_controller_grant_instr_wr : 3; // DWORD 0
         u32 vqueue_controller_scoreboard_grant_fsm : 2; // DWORD 0
         u32 vqueue_controller_rd_instr_fsm : 2;  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vqueue_controller_wr_instr_fsm : 3;  // DWORD 0
         u32 vqueue_controller_mmr_read_fsm : 2;  // DWORD 0
         u32 vqueue_controller_mmr_write_fsm : 2; // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS2, *PRXULP_VQUEUE_DEBUG_STATS2;

      typedef union _RXULP_VQUEUE_DEBUG_STATS2_UNION {
         RXULP_VQUEUE_DEBUG_STATS2 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS2_UNION, *PRXULP_VQUEUE_DEBUG_STATS2_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS2_UNION, sizeof (RXULP_VQUEUE_DEBUG_STATS2_UNION) == 4);
   #endif


#else
   // This register provides the information regarding sram parity error address and other
   // debug stats
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_STATS2 {
         union {
            struct { 
               u32 vqueue_controller_mmr_write_fsm : 2; // DWORD 0
               u32 vqueue_controller_mmr_read_fsm : 2; // DWORD 0
               u32 vqueue_controller_wr_instr_fsm : 3; // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vqueue_controller_rd_instr_fsm : 2; // DWORD 0
               u32 vqueue_controller_scoreboard_grant_fsm : 2; // DWORD 0
               u32 vqueue_controller_grant_instr_wr : 3; // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 vqueue_controller_grant_instr_rd : 3; // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 arbiter_grant_state_machine : 3; // DWORD 0
               u32 sram_init_over : 1;            // DWORD 0
               u32 sram_parity_error_address : 6; // DWORD 0
               u32 rsvd3 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS2, *PRXULP_VQUEUE_DEBUG_STATS2;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS2, sizeof (RXULP_VQUEUE_DEBUG_STATS2) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_STATS2 {
         u32 vqueue_controller_mmr_write_fsm : 2; // DWORD 0
         u32 vqueue_controller_mmr_read_fsm : 2;  // DWORD 0
         u32 vqueue_controller_wr_instr_fsm : 3;  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vqueue_controller_rd_instr_fsm : 2;  // DWORD 0
         u32 vqueue_controller_scoreboard_grant_fsm : 2; // DWORD 0
         u32 vqueue_controller_grant_instr_wr : 3; // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 vqueue_controller_grant_instr_rd : 3; // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 arbiter_grant_state_machine : 3;     // DWORD 0
         u32 sram_init_over : 1;                  // DWORD 0
         u32 sram_parity_error_address : 6;       // DWORD 0
         u32 rsvd3 : 2;                           // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS2, *PRXULP_VQUEUE_DEBUG_STATS2;

      typedef union _RXULP_VQUEUE_DEBUG_STATS2_UNION {
         RXULP_VQUEUE_DEBUG_STATS2 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS2_UNION, *PRXULP_VQUEUE_DEBUG_STATS2_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS2_UNION, sizeof (RXULP_VQUEUE_DEBUG_STATS2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides the number of credits assigned to queues 0-7
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_STATS3 {
         union {
            struct { 
               u32 vqueue7_dbg_credit : 4;        // DWORD 0
               u32 vqueue6_dbg_credit : 4;        // DWORD 0
               u32 vqueue5_dbg_credit : 4;        // DWORD 0
               u32 vqueue4_dbg_credit : 4;        // DWORD 0
               u32 vqueue3_dbg_credit : 4;        // DWORD 0
               u32 vqueue2_dbg_credit : 4;        // DWORD 0
               u32 vqueue1_dbg_credit : 4;        // DWORD 0
               u32 vqueue0_dbg_credit : 4;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS3, *PRXULP_VQUEUE_DEBUG_STATS3;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS3, sizeof (RXULP_VQUEUE_DEBUG_STATS3) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_STATS3 {
         u32 vqueue7_dbg_credit : 4;              // DWORD 0
         u32 vqueue6_dbg_credit : 4;              // DWORD 0
         u32 vqueue5_dbg_credit : 4;              // DWORD 0
         u32 vqueue4_dbg_credit : 4;              // DWORD 0
         u32 vqueue3_dbg_credit : 4;              // DWORD 0
         u32 vqueue2_dbg_credit : 4;              // DWORD 0
         u32 vqueue1_dbg_credit : 4;              // DWORD 0
         u32 vqueue0_dbg_credit : 4;              // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS3, *PRXULP_VQUEUE_DEBUG_STATS3;

      typedef union _RXULP_VQUEUE_DEBUG_STATS3_UNION {
         RXULP_VQUEUE_DEBUG_STATS3 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS3_UNION, *PRXULP_VQUEUE_DEBUG_STATS3_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS3_UNION, sizeof (RXULP_VQUEUE_DEBUG_STATS3_UNION) == 4);
   #endif


#else
   // This register provides the number of credits assigned to queues 0-7
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_STATS3 {
         union {
            struct { 
               u32 vqueue0_dbg_credit : 4;        // DWORD 0
               u32 vqueue1_dbg_credit : 4;        // DWORD 0
               u32 vqueue2_dbg_credit : 4;        // DWORD 0
               u32 vqueue3_dbg_credit : 4;        // DWORD 0
               u32 vqueue4_dbg_credit : 4;        // DWORD 0
               u32 vqueue5_dbg_credit : 4;        // DWORD 0
               u32 vqueue6_dbg_credit : 4;        // DWORD 0
               u32 vqueue7_dbg_credit : 4;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS3, *PRXULP_VQUEUE_DEBUG_STATS3;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS3, sizeof (RXULP_VQUEUE_DEBUG_STATS3) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_STATS3 {
         u32 vqueue0_dbg_credit : 4;              // DWORD 0
         u32 vqueue1_dbg_credit : 4;              // DWORD 0
         u32 vqueue2_dbg_credit : 4;              // DWORD 0
         u32 vqueue3_dbg_credit : 4;              // DWORD 0
         u32 vqueue4_dbg_credit : 4;              // DWORD 0
         u32 vqueue5_dbg_credit : 4;              // DWORD 0
         u32 vqueue6_dbg_credit : 4;              // DWORD 0
         u32 vqueue7_dbg_credit : 4;              // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS3, *PRXULP_VQUEUE_DEBUG_STATS3;

      typedef union _RXULP_VQUEUE_DEBUG_STATS3_UNION {
         RXULP_VQUEUE_DEBUG_STATS3 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS3_UNION, *PRXULP_VQUEUE_DEBUG_STATS3_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS3_UNION, sizeof (RXULP_VQUEUE_DEBUG_STATS3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides the number of credits assigned to queues 8-15
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_STATS4 {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 vqueue14_dbg_credit : 4;       // DWORD 0
               u32 vqueue13_dbg_credit : 4;       // DWORD 0
               u32 vqueue12_dbg_credit : 4;       // DWORD 0
               u32 vqueue11_dbg_credit : 4;       // DWORD 0
               u32 vqueue10_dbg_credit : 4;       // DWORD 0
               u32 vqueue9_dbg_credit : 4;        // DWORD 0
               u32 vqueue8_dbg_credit : 4;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS4, *PRXULP_VQUEUE_DEBUG_STATS4;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS4, sizeof (RXULP_VQUEUE_DEBUG_STATS4) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_STATS4 {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 vqueue14_dbg_credit : 4;             // DWORD 0
         u32 vqueue13_dbg_credit : 4;             // DWORD 0
         u32 vqueue12_dbg_credit : 4;             // DWORD 0
         u32 vqueue11_dbg_credit : 4;             // DWORD 0
         u32 vqueue10_dbg_credit : 4;             // DWORD 0
         u32 vqueue9_dbg_credit : 4;              // DWORD 0
         u32 vqueue8_dbg_credit : 4;              // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS4, *PRXULP_VQUEUE_DEBUG_STATS4;

      typedef union _RXULP_VQUEUE_DEBUG_STATS4_UNION {
         RXULP_VQUEUE_DEBUG_STATS4 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS4_UNION, *PRXULP_VQUEUE_DEBUG_STATS4_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS4_UNION, sizeof (RXULP_VQUEUE_DEBUG_STATS4_UNION) == 4);
   #endif


#else
   // This register provides the number of credits assigned to queues 8-15
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_STATS4 {
         union {
            struct { 
               u32 vqueue8_dbg_credit : 4;        // DWORD 0
               u32 vqueue9_dbg_credit : 4;        // DWORD 0
               u32 vqueue10_dbg_credit : 4;       // DWORD 0
               u32 vqueue11_dbg_credit : 4;       // DWORD 0
               u32 vqueue12_dbg_credit : 4;       // DWORD 0
               u32 vqueue13_dbg_credit : 4;       // DWORD 0
               u32 vqueue14_dbg_credit : 4;       // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS4, *PRXULP_VQUEUE_DEBUG_STATS4;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS4, sizeof (RXULP_VQUEUE_DEBUG_STATS4) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_STATS4 {
         u32 vqueue8_dbg_credit : 4;              // DWORD 0
         u32 vqueue9_dbg_credit : 4;              // DWORD 0
         u32 vqueue10_dbg_credit : 4;             // DWORD 0
         u32 vqueue11_dbg_credit : 4;             // DWORD 0
         u32 vqueue12_dbg_credit : 4;             // DWORD 0
         u32 vqueue13_dbg_credit : 4;             // DWORD 0
         u32 vqueue14_dbg_credit : 4;             // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS4, *PRXULP_VQUEUE_DEBUG_STATS4;

      typedef union _RXULP_VQUEUE_DEBUG_STATS4_UNION {
         RXULP_VQUEUE_DEBUG_STATS4 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS4_UNION, *PRXULP_VQUEUE_DEBUG_STATS4_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS4_UNION, sizeof (RXULP_VQUEUE_DEBUG_STATS4_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides the status and value of the cid based queues
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_STATS5 {
         union {
            struct { 
               u32 vqcontroller_credit_fifo_underflow_id : 2; // DWORD 0
               u32 vqcontroller_credit_fifo_overflow_id : 2; // DWORD 0
               u32 vq_err_id : 4;                 // DWORD 0
               u32 vq_underflow_id : 4;           // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 cid_scoreboard_rd_valid : 1;   // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 cid_scoreboard_status : 2;     // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 cid_scoreboard_value : 10;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS5, *PRXULP_VQUEUE_DEBUG_STATS5;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS5, sizeof (RXULP_VQUEUE_DEBUG_STATS5) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_STATS5 {
         u32 vqcontroller_credit_fifo_underflow_id : 2; // DWORD 0
         u32 vqcontroller_credit_fifo_overflow_id : 2; // DWORD 0
         u32 vq_err_id : 4;                       // DWORD 0
         u32 vq_underflow_id : 4;                 // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 cid_scoreboard_rd_valid : 1;         // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 cid_scoreboard_status : 2;           // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 cid_scoreboard_value : 10;           // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS5, *PRXULP_VQUEUE_DEBUG_STATS5;

      typedef union _RXULP_VQUEUE_DEBUG_STATS5_UNION {
         RXULP_VQUEUE_DEBUG_STATS5 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS5_UNION, *PRXULP_VQUEUE_DEBUG_STATS5_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS5_UNION, sizeof (RXULP_VQUEUE_DEBUG_STATS5_UNION) == 4);
   #endif


#else
   // This register provides the status and value of the cid based queues
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_DEBUG_STATS5 {
         union {
            struct { 
               u32 cid_scoreboard_value : 10;     // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 cid_scoreboard_status : 2;     // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 cid_scoreboard_rd_valid : 1;   // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 vq_underflow_id : 4;           // DWORD 0
               u32 vq_err_id : 4;                 // DWORD 0
               u32 vqcontroller_credit_fifo_overflow_id : 2; // DWORD 0
               u32 vqcontroller_credit_fifo_underflow_id : 2; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS5, *PRXULP_VQUEUE_DEBUG_STATS5;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS5, sizeof (RXULP_VQUEUE_DEBUG_STATS5) == 4);

   #else
      typedef struct _RXULP_VQUEUE_DEBUG_STATS5 {
         u32 cid_scoreboard_value : 10;           // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 cid_scoreboard_status : 2;           // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 cid_scoreboard_rd_valid : 1;         // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 vq_underflow_id : 4;                 // DWORD 0
         u32 vq_err_id : 4;                       // DWORD 0
         u32 vqcontroller_credit_fifo_overflow_id : 2; // DWORD 0
         u32 vqcontroller_credit_fifo_underflow_id : 2; // DWORD 0
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS5, *PRXULP_VQUEUE_DEBUG_STATS5;

      typedef union _RXULP_VQUEUE_DEBUG_STATS5_UNION {
         RXULP_VQUEUE_DEBUG_STATS5 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_DEBUG_STATS5_UNION, *PRXULP_VQUEUE_DEBUG_STATS5_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_DEBUG_STATS5_UNION, sizeof (RXULP_VQUEUE_DEBUG_STATS5_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw unrecoverable error source bits from the vqueue manager, not masked by MASK
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_UE_SOURCE1 {
         union {
            struct { 
               u32 credit_mgmt_fifo_arbiter_underflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_arbiter_overflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_vqueue_underflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_vqueue_overflow_error : 1; // DWORD 0
               u32 vqueue_iq4_desc_fifo_underflow_error : 1; // DWORD 0
               u32 vqueue_iq4_desc_fifo_overflow_error : 1; // DWORD 0
               u32 vqcontroller_credit_fifo_underflow_error : 1; // DWORD 0
               u32 vqcontroller_credit_fifo_overflow_error : 1; // DWORD 0
               u32 vqcontroller_mmr_fifo_underflow_error : 1; // DWORD 0
               u32 vqcontroller_mmr_fifo_overflow_error : 1; // DWORD 0
               u32 vqcontroller_tpre_fifo_underflow_error : 1; // DWORD 0
               u32 vqcontroller_tpre_fifo_overlow_error : 1; // DWORD 0
               u32 vqcontroller_create_mmr_error : 1; // DWORD 0
               u32 vqcontroller_push_mmr_error : 1; // DWORD 0
               u32 vqcontroller_mmr_invalid_instr_error : 1; // DWORD 0
               u32 mmr_vqueue_no_cid_based_queue : 1; // DWORD 0
               u32 mmr_vqueue_create_error : 1;   // DWORD 0
               u32 vq_poke_fifo_underflow_error : 1; // DWORD 0
               u32 vq_poke_fifo_overflow_error : 1; // DWORD 0
               u32 vq_read_fifo_underflow_error : 1; // DWORD 0
               u32 vq_read_fifo_overflow_error : 1; // DWORD 0
               u32 vq_create_fifo_underflow_error : 1; // DWORD 0
               u32 vq_create_fifo_overflow_error : 1; // DWORD 0
               u32 vqueue_poke_error : 1;         // DWORD 0
               u32 vqueue_read_error : 1;         // DWORD 0
               u32 vqueue_write_error : 1;        // DWORD 0
               u32 vqueue_sram_parity_error : 1;  // DWORD 0
               u32 vqueue_overrun_error : 1;      // DWORD 0
               u32 vqueue_underrun_error : 1;     // DWORD 0
               u32 vqueue_dealloc_error : 1;      // DWORD 0
               u32 vqueue_alloc_error : 1;        // DWORD 0
               u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_UE_SOURCE1, *PRXULP_VQUEUE_UE_SOURCE1;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_UE_SOURCE1, sizeof (RXULP_VQUEUE_UE_SOURCE1) == 4);

   #else
      typedef struct _RXULP_VQUEUE_UE_SOURCE1 {
         u32 credit_mgmt_fifo_arbiter_underflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_arbiter_overflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_vqueue_underflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_vqueue_overflow_error : 1; // DWORD 0
         u32 vqueue_iq4_desc_fifo_underflow_error : 1; // DWORD 0
         u32 vqueue_iq4_desc_fifo_overflow_error : 1; // DWORD 0
         u32 vqcontroller_credit_fifo_underflow_error : 1; // DWORD 0
         u32 vqcontroller_credit_fifo_overflow_error : 1; // DWORD 0
         u32 vqcontroller_mmr_fifo_underflow_error : 1; // DWORD 0
         u32 vqcontroller_mmr_fifo_overflow_error : 1; // DWORD 0
         u32 vqcontroller_tpre_fifo_underflow_error : 1; // DWORD 0
         u32 vqcontroller_tpre_fifo_overlow_error : 1; // DWORD 0
         u32 vqcontroller_create_mmr_error : 1;   // DWORD 0
         u32 vqcontroller_push_mmr_error : 1;     // DWORD 0
         u32 vqcontroller_mmr_invalid_instr_error : 1; // DWORD 0
         u32 mmr_vqueue_no_cid_based_queue : 1;   // DWORD 0
         u32 mmr_vqueue_create_error : 1;         // DWORD 0
         u32 vq_poke_fifo_underflow_error : 1;    // DWORD 0
         u32 vq_poke_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_read_fifo_underflow_error : 1;    // DWORD 0
         u32 vq_read_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_create_fifo_underflow_error : 1;  // DWORD 0
         u32 vq_create_fifo_overflow_error : 1;   // DWORD 0
         u32 vqueue_poke_error : 1;               // DWORD 0
         u32 vqueue_read_error : 1;               // DWORD 0
         u32 vqueue_write_error : 1;              // DWORD 0
         u32 vqueue_sram_parity_error : 1;        // DWORD 0
         u32 vqueue_overrun_error : 1;            // DWORD 0
         u32 vqueue_underrun_error : 1;           // DWORD 0
         u32 vqueue_dealloc_error : 1;            // DWORD 0
         u32 vqueue_alloc_error : 1;              // DWORD 0
         u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
      } SG_PACK RXULP_VQUEUE_UE_SOURCE1, *PRXULP_VQUEUE_UE_SOURCE1;

      typedef union _RXULP_VQUEUE_UE_SOURCE1_UNION {
         RXULP_VQUEUE_UE_SOURCE1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_UE_SOURCE1_UNION, *PRXULP_VQUEUE_UE_SOURCE1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_UE_SOURCE1_UNION, sizeof (RXULP_VQUEUE_UE_SOURCE1_UNION) == 4);
   #endif


#else
   // Raw unrecoverable error source bits from the vqueue manager, not masked by MASK
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_UE_SOURCE1 {
         union {
            struct { 
               u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
               u32 vqueue_alloc_error : 1;        // DWORD 0
               u32 vqueue_dealloc_error : 1;      // DWORD 0
               u32 vqueue_underrun_error : 1;     // DWORD 0
               u32 vqueue_overrun_error : 1;      // DWORD 0
               u32 vqueue_sram_parity_error : 1;  // DWORD 0
               u32 vqueue_write_error : 1;        // DWORD 0
               u32 vqueue_read_error : 1;         // DWORD 0
               u32 vqueue_poke_error : 1;         // DWORD 0
               u32 vq_create_fifo_overflow_error : 1; // DWORD 0
               u32 vq_create_fifo_underflow_error : 1; // DWORD 0
               u32 vq_read_fifo_overflow_error : 1; // DWORD 0
               u32 vq_read_fifo_underflow_error : 1; // DWORD 0
               u32 vq_poke_fifo_overflow_error : 1; // DWORD 0
               u32 vq_poke_fifo_underflow_error : 1; // DWORD 0
               u32 mmr_vqueue_create_error : 1;   // DWORD 0
               u32 mmr_vqueue_no_cid_based_queue : 1; // DWORD 0
               u32 vqcontroller_mmr_invalid_instr_error : 1; // DWORD 0
               u32 vqcontroller_push_mmr_error : 1; // DWORD 0
               u32 vqcontroller_create_mmr_error : 1; // DWORD 0
               u32 vqcontroller_tpre_fifo_overlow_error : 1; // DWORD 0
               u32 vqcontroller_tpre_fifo_underflow_error : 1; // DWORD 0
               u32 vqcontroller_mmr_fifo_overflow_error : 1; // DWORD 0
               u32 vqcontroller_mmr_fifo_underflow_error : 1; // DWORD 0
               u32 vqcontroller_credit_fifo_overflow_error : 1; // DWORD 0
               u32 vqcontroller_credit_fifo_underflow_error : 1; // DWORD 0
               u32 vqueue_iq4_desc_fifo_overflow_error : 1; // DWORD 0
               u32 vqueue_iq4_desc_fifo_underflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_vqueue_overflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_vqueue_underflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_arbiter_overflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_arbiter_underflow_error : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_UE_SOURCE1, *PRXULP_VQUEUE_UE_SOURCE1;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_UE_SOURCE1, sizeof (RXULP_VQUEUE_UE_SOURCE1) == 4);

   #else
      typedef struct _RXULP_VQUEUE_UE_SOURCE1 {
         u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
         u32 vqueue_alloc_error : 1;              // DWORD 0
         u32 vqueue_dealloc_error : 1;            // DWORD 0
         u32 vqueue_underrun_error : 1;           // DWORD 0
         u32 vqueue_overrun_error : 1;            // DWORD 0
         u32 vqueue_sram_parity_error : 1;        // DWORD 0
         u32 vqueue_write_error : 1;              // DWORD 0
         u32 vqueue_read_error : 1;               // DWORD 0
         u32 vqueue_poke_error : 1;               // DWORD 0
         u32 vq_create_fifo_overflow_error : 1;   // DWORD 0
         u32 vq_create_fifo_underflow_error : 1;  // DWORD 0
         u32 vq_read_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_read_fifo_underflow_error : 1;    // DWORD 0
         u32 vq_poke_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_poke_fifo_underflow_error : 1;    // DWORD 0
         u32 mmr_vqueue_create_error : 1;         // DWORD 0
         u32 mmr_vqueue_no_cid_based_queue : 1;   // DWORD 0
         u32 vqcontroller_mmr_invalid_instr_error : 1; // DWORD 0
         u32 vqcontroller_push_mmr_error : 1;     // DWORD 0
         u32 vqcontroller_create_mmr_error : 1;   // DWORD 0
         u32 vqcontroller_tpre_fifo_overlow_error : 1; // DWORD 0
         u32 vqcontroller_tpre_fifo_underflow_error : 1; // DWORD 0
         u32 vqcontroller_mmr_fifo_overflow_error : 1; // DWORD 0
         u32 vqcontroller_mmr_fifo_underflow_error : 1; // DWORD 0
         u32 vqcontroller_credit_fifo_overflow_error : 1; // DWORD 0
         u32 vqcontroller_credit_fifo_underflow_error : 1; // DWORD 0
         u32 vqueue_iq4_desc_fifo_overflow_error : 1; // DWORD 0
         u32 vqueue_iq4_desc_fifo_underflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_vqueue_overflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_vqueue_underflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_arbiter_overflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_arbiter_underflow_error : 1; // DWORD 0
      } SG_PACK RXULP_VQUEUE_UE_SOURCE1, *PRXULP_VQUEUE_UE_SOURCE1;

      typedef union _RXULP_VQUEUE_UE_SOURCE1_UNION {
         RXULP_VQUEUE_UE_SOURCE1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_UE_SOURCE1_UNION, *PRXULP_VQUEUE_UE_SOURCE1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_UE_SOURCE1_UNION, sizeof (RXULP_VQUEUE_UE_SOURCE1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for disabling unrecoverable error . Write a 1 to enable
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_UE_ENABLE1 {
         union {
            struct { 
               u32 credit_mgmt_fifo_arbiter_underflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_arbiter_overflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_underflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_overflow_error : 1; // DWORD 0
               u32 vqueue_iq4_desc_fifo_underflow_error : 1; // DWORD 0
               u32 vqueue_iq4_desc_fifo_overflow_error : 1; // DWORD 0
               u32 vqcontroller_credit_fifo_underflow_error : 1; // DWORD 0
               u32 vqcontroller_credit_fifo_overflow_error : 1; // DWORD 0
               u32 vqcontroller_mmr_fifo_underflow_error : 1; // DWORD 0
               u32 vqcontroller_mmr_fifo_overflow_error : 1; // DWORD 0
               u32 vqcontroller_tpre_fifo_underflow_error : 1; // DWORD 0
               u32 vqcontroller_tpre_fifo_overlow_error : 1; // DWORD 0
               u32 vqcontroller_create_mmr_error : 1; // DWORD 0
               u32 vqcontroller_push_mmr_error : 1; // DWORD 0
               u32 vqcontroller_mmr_invalid_instr_error : 1; // DWORD 0
               u32 mmr_vqueue_no_cid_based_queue_error : 1; // DWORD 0
               u32 mmr_vqueue_create_error : 1;   // DWORD 0
               u32 vq_poke_fifo_underflow_error : 1; // DWORD 0
               u32 vq_poke_fifo_overflow_error : 1; // DWORD 0
               u32 vq_read_fifo_underflow_error : 1; // DWORD 0
               u32 vq_read_fifo_overflow_error : 1; // DWORD 0
               u32 vq_create_fifo_underflow_error : 1; // DWORD 0
               u32 vq_create_fifo_overflow_error : 1; // DWORD 0
               u32 vqueue_poke_error : 1;         // DWORD 0
               u32 vqueue_read_error : 1;         // DWORD 0
               u32 vqueue_write_error : 1;        // DWORD 0
               u32 vqueue_sram_parity_error : 1;  // DWORD 0
               u32 vqueue_overrun_error : 1;      // DWORD 0
               u32 vqueue_underrun_error : 1;     // DWORD 0
               u32 vqueue_dealloc_error : 1;      // DWORD 0
               u32 vqueue_alloc_error : 1;        // DWORD 0
               u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_UE_ENABLE1, *PRXULP_VQUEUE_UE_ENABLE1;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_UE_ENABLE1, sizeof (RXULP_VQUEUE_UE_ENABLE1) == 4);

   #else
      typedef struct _RXULP_VQUEUE_UE_ENABLE1 {
         u32 credit_mgmt_fifo_arbiter_underflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_arbiter_overflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_underflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_overflow_error : 1; // DWORD 0
         u32 vqueue_iq4_desc_fifo_underflow_error : 1; // DWORD 0
         u32 vqueue_iq4_desc_fifo_overflow_error : 1; // DWORD 0
         u32 vqcontroller_credit_fifo_underflow_error : 1; // DWORD 0
         u32 vqcontroller_credit_fifo_overflow_error : 1; // DWORD 0
         u32 vqcontroller_mmr_fifo_underflow_error : 1; // DWORD 0
         u32 vqcontroller_mmr_fifo_overflow_error : 1; // DWORD 0
         u32 vqcontroller_tpre_fifo_underflow_error : 1; // DWORD 0
         u32 vqcontroller_tpre_fifo_overlow_error : 1; // DWORD 0
         u32 vqcontroller_create_mmr_error : 1;   // DWORD 0
         u32 vqcontroller_push_mmr_error : 1;     // DWORD 0
         u32 vqcontroller_mmr_invalid_instr_error : 1; // DWORD 0
         u32 mmr_vqueue_no_cid_based_queue_error : 1; // DWORD 0
         u32 mmr_vqueue_create_error : 1;         // DWORD 0
         u32 vq_poke_fifo_underflow_error : 1;    // DWORD 0
         u32 vq_poke_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_read_fifo_underflow_error : 1;    // DWORD 0
         u32 vq_read_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_create_fifo_underflow_error : 1;  // DWORD 0
         u32 vq_create_fifo_overflow_error : 1;   // DWORD 0
         u32 vqueue_poke_error : 1;               // DWORD 0
         u32 vqueue_read_error : 1;               // DWORD 0
         u32 vqueue_write_error : 1;              // DWORD 0
         u32 vqueue_sram_parity_error : 1;        // DWORD 0
         u32 vqueue_overrun_error : 1;            // DWORD 0
         u32 vqueue_underrun_error : 1;           // DWORD 0
         u32 vqueue_dealloc_error : 1;            // DWORD 0
         u32 vqueue_alloc_error : 1;              // DWORD 0
         u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
      } SG_PACK RXULP_VQUEUE_UE_ENABLE1, *PRXULP_VQUEUE_UE_ENABLE1;

      typedef union _RXULP_VQUEUE_UE_ENABLE1_UNION {
         RXULP_VQUEUE_UE_ENABLE1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_UE_ENABLE1_UNION, *PRXULP_VQUEUE_UE_ENABLE1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_UE_ENABLE1_UNION, sizeof (RXULP_VQUEUE_UE_ENABLE1_UNION) == 4);
   #endif


#else
   // Mask for disabling unrecoverable error . Write a 1 to enable
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_VQUEUE_UE_ENABLE1 {
         union {
            struct { 
               u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
               u32 vqueue_alloc_error : 1;        // DWORD 0
               u32 vqueue_dealloc_error : 1;      // DWORD 0
               u32 vqueue_underrun_error : 1;     // DWORD 0
               u32 vqueue_overrun_error : 1;      // DWORD 0
               u32 vqueue_sram_parity_error : 1;  // DWORD 0
               u32 vqueue_write_error : 1;        // DWORD 0
               u32 vqueue_read_error : 1;         // DWORD 0
               u32 vqueue_poke_error : 1;         // DWORD 0
               u32 vq_create_fifo_overflow_error : 1; // DWORD 0
               u32 vq_create_fifo_underflow_error : 1; // DWORD 0
               u32 vq_read_fifo_overflow_error : 1; // DWORD 0
               u32 vq_read_fifo_underflow_error : 1; // DWORD 0
               u32 vq_poke_fifo_overflow_error : 1; // DWORD 0
               u32 vq_poke_fifo_underflow_error : 1; // DWORD 0
               u32 mmr_vqueue_create_error : 1;   // DWORD 0
               u32 mmr_vqueue_no_cid_based_queue_error : 1; // DWORD 0
               u32 vqcontroller_mmr_invalid_instr_error : 1; // DWORD 0
               u32 vqcontroller_push_mmr_error : 1; // DWORD 0
               u32 vqcontroller_create_mmr_error : 1; // DWORD 0
               u32 vqcontroller_tpre_fifo_overlow_error : 1; // DWORD 0
               u32 vqcontroller_tpre_fifo_underflow_error : 1; // DWORD 0
               u32 vqcontroller_mmr_fifo_overflow_error : 1; // DWORD 0
               u32 vqcontroller_mmr_fifo_underflow_error : 1; // DWORD 0
               u32 vqcontroller_credit_fifo_overflow_error : 1; // DWORD 0
               u32 vqcontroller_credit_fifo_underflow_error : 1; // DWORD 0
               u32 vqueue_iq4_desc_fifo_overflow_error : 1; // DWORD 0
               u32 vqueue_iq4_desc_fifo_underflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_overflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_underflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_arbiter_overflow_error : 1; // DWORD 0
               u32 credit_mgmt_fifo_arbiter_underflow_error : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_VQUEUE_UE_ENABLE1, *PRXULP_VQUEUE_UE_ENABLE1;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_UE_ENABLE1, sizeof (RXULP_VQUEUE_UE_ENABLE1) == 4);

   #else
      typedef struct _RXULP_VQUEUE_UE_ENABLE1 {
         u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
         u32 vqueue_alloc_error : 1;              // DWORD 0
         u32 vqueue_dealloc_error : 1;            // DWORD 0
         u32 vqueue_underrun_error : 1;           // DWORD 0
         u32 vqueue_overrun_error : 1;            // DWORD 0
         u32 vqueue_sram_parity_error : 1;        // DWORD 0
         u32 vqueue_write_error : 1;              // DWORD 0
         u32 vqueue_read_error : 1;               // DWORD 0
         u32 vqueue_poke_error : 1;               // DWORD 0
         u32 vq_create_fifo_overflow_error : 1;   // DWORD 0
         u32 vq_create_fifo_underflow_error : 1;  // DWORD 0
         u32 vq_read_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_read_fifo_underflow_error : 1;    // DWORD 0
         u32 vq_poke_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_poke_fifo_underflow_error : 1;    // DWORD 0
         u32 mmr_vqueue_create_error : 1;         // DWORD 0
         u32 mmr_vqueue_no_cid_based_queue_error : 1; // DWORD 0
         u32 vqcontroller_mmr_invalid_instr_error : 1; // DWORD 0
         u32 vqcontroller_push_mmr_error : 1;     // DWORD 0
         u32 vqcontroller_create_mmr_error : 1;   // DWORD 0
         u32 vqcontroller_tpre_fifo_overlow_error : 1; // DWORD 0
         u32 vqcontroller_tpre_fifo_underflow_error : 1; // DWORD 0
         u32 vqcontroller_mmr_fifo_overflow_error : 1; // DWORD 0
         u32 vqcontroller_mmr_fifo_underflow_error : 1; // DWORD 0
         u32 vqcontroller_credit_fifo_overflow_error : 1; // DWORD 0
         u32 vqcontroller_credit_fifo_underflow_error : 1; // DWORD 0
         u32 vqueue_iq4_desc_fifo_overflow_error : 1; // DWORD 0
         u32 vqueue_iq4_desc_fifo_underflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_overflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_underflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_arbiter_overflow_error : 1; // DWORD 0
         u32 credit_mgmt_fifo_arbiter_underflow_error : 1; // DWORD 0
      } SG_PACK RXULP_VQUEUE_UE_ENABLE1, *PRXULP_VQUEUE_UE_ENABLE1;

      typedef union _RXULP_VQUEUE_UE_ENABLE1_UNION {
         RXULP_VQUEUE_UE_ENABLE1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_VQUEUE_UE_ENABLE1_UNION, *PRXULP_VQUEUE_UE_ENABLE1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_VQUEUE_UE_ENABLE1_UNION, sizeof (RXULP_VQUEUE_UE_ENABLE1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXULP Connection Scheduler Debug 0
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CONSEL_DEBUG0 {
         union {
            struct { 
               u32 rsvd1 : 15;                    // DWORD 0
               u32 loc_cid : 9;                   // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 override : 1;                  // DWORD 0
               u32 autoinc : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CONSEL_DEBUG0, *PRXULP_CONSEL_DEBUG0;

      SG_C_ASSERT(__sizeof__RXULP_CONSEL_DEBUG0, sizeof (RXULP_CONSEL_DEBUG0) == 4);

   #else
      typedef struct _RXULP_CONSEL_DEBUG0 {
         u32 rsvd1 : 15;                          // DWORD 0
         u32 loc_cid : 9;                         // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 override : 1;                        // DWORD 0
         u32 autoinc : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
      } SG_PACK RXULP_CONSEL_DEBUG0, *PRXULP_CONSEL_DEBUG0;

      typedef union _RXULP_CONSEL_DEBUG0_UNION {
         RXULP_CONSEL_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CONSEL_DEBUG0_UNION, *PRXULP_CONSEL_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CONSEL_DEBUG0_UNION, sizeof (RXULP_CONSEL_DEBUG0_UNION) == 4);
   #endif


#else
   // RXULP Connection Scheduler Debug 0
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CONSEL_DEBUG0 {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 autoinc : 1;                   // DWORD 0
               u32 override : 1;                  // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 loc_cid : 9;                   // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CONSEL_DEBUG0, *PRXULP_CONSEL_DEBUG0;

      SG_C_ASSERT(__sizeof__RXULP_CONSEL_DEBUG0, sizeof (RXULP_CONSEL_DEBUG0) == 4);

   #else
      typedef struct _RXULP_CONSEL_DEBUG0 {
         u32 stall : 1;                           // DWORD 0
         u32 autoinc : 1;                         // DWORD 0
         u32 override : 1;                        // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 loc_cid : 9;                         // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK RXULP_CONSEL_DEBUG0, *PRXULP_CONSEL_DEBUG0;

      typedef union _RXULP_CONSEL_DEBUG0_UNION {
         RXULP_CONSEL_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CONSEL_DEBUG0_UNION, *PRXULP_CONSEL_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CONSEL_DEBUG0_UNION, sizeof (RXULP_CONSEL_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXULP Connection Scheduler Debug 0
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CONSEL_DEBUG1 {
         union {
            struct { 
               u32 rsvd1 : 14;                    // DWORD 0
               u32 current_g : 1;                 // DWORD 0
               u32 current_d : 1;                 // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 current_loc_cid : 9;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CONSEL_DEBUG1, *PRXULP_CONSEL_DEBUG1;

      SG_C_ASSERT(__sizeof__RXULP_CONSEL_DEBUG1, sizeof (RXULP_CONSEL_DEBUG1) == 4);

   #else
      typedef struct _RXULP_CONSEL_DEBUG1 {
         u32 rsvd1 : 14;                          // DWORD 0
         u32 current_g : 1;                       // DWORD 0
         u32 current_d : 1;                       // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 current_loc_cid : 9;                 // DWORD 0
      } SG_PACK RXULP_CONSEL_DEBUG1, *PRXULP_CONSEL_DEBUG1;

      typedef union _RXULP_CONSEL_DEBUG1_UNION {
         RXULP_CONSEL_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CONSEL_DEBUG1_UNION, *PRXULP_CONSEL_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CONSEL_DEBUG1_UNION, sizeof (RXULP_CONSEL_DEBUG1_UNION) == 4);
   #endif


#else
   // RXULP Connection Scheduler Debug 0
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CONSEL_DEBUG1 {
         union {
            struct { 
               u32 current_loc_cid : 9;           // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 current_d : 1;                 // DWORD 0
               u32 current_g : 1;                 // DWORD 0
               u32 rsvd1 : 14;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CONSEL_DEBUG1, *PRXULP_CONSEL_DEBUG1;

      SG_C_ASSERT(__sizeof__RXULP_CONSEL_DEBUG1, sizeof (RXULP_CONSEL_DEBUG1) == 4);

   #else
      typedef struct _RXULP_CONSEL_DEBUG1 {
         u32 current_loc_cid : 9;                 // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 current_d : 1;                       // DWORD 0
         u32 current_g : 1;                       // DWORD 0
         u32 rsvd1 : 14;                          // DWORD 0
      } SG_PACK RXULP_CONSEL_DEBUG1, *PRXULP_CONSEL_DEBUG1;

      typedef union _RXULP_CONSEL_DEBUG1_UNION {
         RXULP_CONSEL_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CONSEL_DEBUG1_UNION, *PRXULP_CONSEL_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CONSEL_DEBUG1_UNION, sizeof (RXULP_CONSEL_DEBUG1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Upper Layer Protocol Receive Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CSRMAP {
         union {
            struct { 
               EP_CSRMAP ep;
               EP_MINIROM_CSRMAP ep_minirom;
               REV_ID rev_id;
               struct {
                  BTLR_CTRL0 btlr_ctrl0;
                  BTLR_CTRL1 btlr_ctrl1;
                  BTLR_CTRL2 btlr_ctrl2;
                  BTLR_VIOLATION0 btlr_violation0;
                  BTLR_VIOLATION1 btlr_violation1;
                  BTLR_DEBUG btlr_debug;
               } btlr;
               RXULP_CONTROL_CSR rxulp_control;
               RXULP_INT_SOURCE int_source;
               RXULP_INT_MASK int_mask;
               RXULP_UE_SOURCE ue_source;
               RXULP_UE_ENABLE ue_enable;
               TXULP_CONSEL_CID_CSR consel_cid;
               RXULP_IQ_DEBUG0 iq_debug0;
               RXULP_IQ_DEBUG1 iq_debug1;
               RXULP_OQ_DEBUG0 oq_debug0;
               GEN_CTXIF_DEBUG ctxif_debug;
               GEN_CTXIF_DEBUG pmemif_debug;
               HWDBG_CSRMAP hwdbg;
               RXULP_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
               RXULP_UE_SOURCE1 ue_source1;
               RXULP_UE_ENABLE1 ue_enable1;
               GEN_IPC_DEBUG ipc_debug;
               RXULP_WINDOW_UPDATE_CTRL0 winupdate_ctrl0;
               RXULP_WINDOW_UPDATE_CTRL1 winupdate_ctrl1;
               RXULP_WINDOW_UPDATE_DEBUG0 winupdate_debug0;
               RXULP_WINDOW_UPDATE_DEBUG1 winupdate_debug1;
               BTLR_CTRL3 btlr_btlr_ctrl3;
               RXULP_SM_DEBUG0 sm_debug0;
               RXULP_VQUEUES_WEIGHTS vq_weights;
               RXULP_VQUEUE_THRESHOLDS vq_threshold;
               RXULP_VQUEUE_CREDITS0 vq_credits_lower;
               RXULP_VQUEUE_CREDITS1 vq_credits_upper;
               RXULP_VQUEUE_DEBUG_RW_LSB vq_dbg_rw_data_lower;
               RXULP_VQUEUE_DEBUG_RW_MSB vq_dbg_rw_data_upper;
               RXULP_VQUEUE_DEBUG_LL_BITS vq_dbg_rw_ll;
               RXULP_VQUEUE_DEBUG_CONTROL vq_dbg_control;
               RXULP_VQUEUE_DEBUG_STATS1 vq_dbg_info1;
               RXULP_VQUEUE_DEBUG_STATS2 vq_dbg_info2;
               RXULP_VQUEUE_DEBUG_STATS3 vq_credits_queue_lower;
               RXULP_VQUEUE_DEBUG_STATS4 vq_credits_queue_upper;
               RXULP_VQUEUE_DEBUG_STATS5 cid_scoreboard_value;
               RXULP_VQUEUE_UE_SOURCE1 vqueue_ue_source1;
               RXULP_VQUEUE_UE_ENABLE1 vqueue_ue_enable1;
               RXULP_CONSEL_DEBUG0 consel_debug0;
               RXULP_CONSEL_DEBUG1 consel_debug1;
               u32 rsvd0[140];                    // DWORDS 116 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CSRMAP, *PRXULP_CSRMAP;

      SG_C_ASSERT(__sizeof__RXULP_CSRMAP, sizeof (RXULP_CSRMAP) == 1024);

   #else
      typedef struct _RXULP_CSRMAP {
         EP_CSRMAP ep;
         EP_MINIROM_CSRMAP ep_minirom;
         REV_ID rev_id;
         struct {
            BTLR_CTRL0 btlr_ctrl0;
            BTLR_CTRL1 btlr_ctrl1;
            BTLR_CTRL2 btlr_ctrl2;
            BTLR_VIOLATION0 btlr_violation0;
            BTLR_VIOLATION1 btlr_violation1;
            BTLR_DEBUG btlr_debug;
         } btlr;
         RXULP_CONTROL_CSR rxulp_control;
         RXULP_INT_SOURCE int_source;
         RXULP_INT_MASK int_mask;
         RXULP_UE_SOURCE ue_source;
         RXULP_UE_ENABLE ue_enable;
         TXULP_CONSEL_CID_CSR consel_cid;
         RXULP_IQ_DEBUG0 iq_debug0;
         RXULP_IQ_DEBUG1 iq_debug1;
         RXULP_OQ_DEBUG0 oq_debug0;
         GEN_CTXIF_DEBUG ctxif_debug;
         GEN_CTXIF_DEBUG pmemif_debug;
         HWDBG_CSRMAP hwdbg;
         RXULP_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
         RXULP_UE_SOURCE1 ue_source1;
         RXULP_UE_ENABLE1 ue_enable1;
         GEN_IPC_DEBUG ipc_debug;
         RXULP_WINDOW_UPDATE_CTRL0 winupdate_ctrl0;
         RXULP_WINDOW_UPDATE_CTRL1 winupdate_ctrl1;
         RXULP_WINDOW_UPDATE_DEBUG0 winupdate_debug0;
         RXULP_WINDOW_UPDATE_DEBUG1 winupdate_debug1;
         BTLR_CTRL3 btlr_btlr_ctrl3;
         RXULP_SM_DEBUG0 sm_debug0;
         RXULP_VQUEUES_WEIGHTS vq_weights;
         RXULP_VQUEUE_THRESHOLDS vq_threshold;
         RXULP_VQUEUE_CREDITS0 vq_credits_lower;
         RXULP_VQUEUE_CREDITS1 vq_credits_upper;
         RXULP_VQUEUE_DEBUG_RW_LSB vq_dbg_rw_data_lower;
         RXULP_VQUEUE_DEBUG_RW_MSB vq_dbg_rw_data_upper;
         RXULP_VQUEUE_DEBUG_LL_BITS vq_dbg_rw_ll;
         RXULP_VQUEUE_DEBUG_CONTROL vq_dbg_control;
         RXULP_VQUEUE_DEBUG_STATS1 vq_dbg_info1;
         RXULP_VQUEUE_DEBUG_STATS2 vq_dbg_info2;
         RXULP_VQUEUE_DEBUG_STATS3 vq_credits_queue_lower;
         RXULP_VQUEUE_DEBUG_STATS4 vq_credits_queue_upper;
         RXULP_VQUEUE_DEBUG_STATS5 cid_scoreboard_value;
         RXULP_VQUEUE_UE_SOURCE1 vqueue_ue_source1;
         RXULP_VQUEUE_UE_ENABLE1 vqueue_ue_enable1;
         RXULP_CONSEL_DEBUG0 consel_debug0;
         RXULP_CONSEL_DEBUG1 consel_debug1;
         u32 rsvd0[140];                          // DWORDS 116 to 255
      } SG_PACK RXULP_CSRMAP, *PRXULP_CSRMAP;

      typedef union _RXULP_CSRMAP_UNION {
         RXULP_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK RXULP_CSRMAP_UNION, *PRXULP_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CSRMAP_UNION, sizeof (RXULP_CSRMAP_UNION) == 1024);
   #endif


#else
   // Upper Layer Protocol Receive Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CSRMAP {
         union {
            struct { 
               EP_CSRMAP ep;
               EP_MINIROM_CSRMAP ep_minirom;
               REV_ID rev_id;
               struct {
                  BTLR_CTRL0 btlr_ctrl0;
                  BTLR_CTRL1 btlr_ctrl1;
                  BTLR_CTRL2 btlr_ctrl2;
                  BTLR_VIOLATION0 btlr_violation0;
                  BTLR_VIOLATION1 btlr_violation1;
                  BTLR_DEBUG btlr_debug;
               } btlr;
               RXULP_CONTROL_CSR rxulp_control;
               RXULP_INT_SOURCE int_source;
               RXULP_INT_MASK int_mask;
               RXULP_UE_SOURCE ue_source;
               RXULP_UE_ENABLE ue_enable;
               TXULP_CONSEL_CID_CSR consel_cid;
               RXULP_IQ_DEBUG0 iq_debug0;
               RXULP_IQ_DEBUG1 iq_debug1;
               RXULP_OQ_DEBUG0 oq_debug0;
               GEN_CTXIF_DEBUG ctxif_debug;
               GEN_CTXIF_DEBUG pmemif_debug;
               HWDBG_CSRMAP hwdbg;
               RXULP_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
               RXULP_UE_SOURCE1 ue_source1;
               RXULP_UE_ENABLE1 ue_enable1;
               GEN_IPC_DEBUG ipc_debug;
               RXULP_WINDOW_UPDATE_CTRL0 winupdate_ctrl0;
               RXULP_WINDOW_UPDATE_CTRL1 winupdate_ctrl1;
               RXULP_WINDOW_UPDATE_DEBUG0 winupdate_debug0;
               RXULP_WINDOW_UPDATE_DEBUG1 winupdate_debug1;
               BTLR_CTRL3 btlr_btlr_ctrl3;
               RXULP_SM_DEBUG0 sm_debug0;
               RXULP_VQUEUES_WEIGHTS vq_weights;
               RXULP_VQUEUE_THRESHOLDS vq_threshold;
               RXULP_VQUEUE_CREDITS0 vq_credits_lower;
               RXULP_VQUEUE_CREDITS1 vq_credits_upper;
               RXULP_VQUEUE_DEBUG_RW_LSB vq_dbg_rw_data_lower;
               RXULP_VQUEUE_DEBUG_RW_MSB vq_dbg_rw_data_upper;
               RXULP_VQUEUE_DEBUG_LL_BITS vq_dbg_rw_ll;
               RXULP_VQUEUE_DEBUG_CONTROL vq_dbg_control;
               RXULP_VQUEUE_DEBUG_STATS1 vq_dbg_info1;
               RXULP_VQUEUE_DEBUG_STATS2 vq_dbg_info2;
               RXULP_VQUEUE_DEBUG_STATS3 vq_credits_queue_lower;
               RXULP_VQUEUE_DEBUG_STATS4 vq_credits_queue_upper;
               RXULP_VQUEUE_DEBUG_STATS5 cid_scoreboard_value;
               RXULP_VQUEUE_UE_SOURCE1 vqueue_ue_source1;
               RXULP_VQUEUE_UE_ENABLE1 vqueue_ue_enable1;
               RXULP_CONSEL_DEBUG0 consel_debug0;
               RXULP_CONSEL_DEBUG1 consel_debug1;
               u32 rsvd0[140];                    // DWORDS 116 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CSRMAP, *PRXULP_CSRMAP;

      SG_C_ASSERT(__sizeof__RXULP_CSRMAP, sizeof (RXULP_CSRMAP) == 1024);

   #else
      typedef struct _RXULP_CSRMAP {
         EP_CSRMAP ep;
         EP_MINIROM_CSRMAP ep_minirom;
         REV_ID rev_id;
         struct {
            BTLR_CTRL0 btlr_ctrl0;
            BTLR_CTRL1 btlr_ctrl1;
            BTLR_CTRL2 btlr_ctrl2;
            BTLR_VIOLATION0 btlr_violation0;
            BTLR_VIOLATION1 btlr_violation1;
            BTLR_DEBUG btlr_debug;
         } btlr;
         RXULP_CONTROL_CSR rxulp_control;
         RXULP_INT_SOURCE int_source;
         RXULP_INT_MASK int_mask;
         RXULP_UE_SOURCE ue_source;
         RXULP_UE_ENABLE ue_enable;
         TXULP_CONSEL_CID_CSR consel_cid;
         RXULP_IQ_DEBUG0 iq_debug0;
         RXULP_IQ_DEBUG1 iq_debug1;
         RXULP_OQ_DEBUG0 oq_debug0;
         GEN_CTXIF_DEBUG ctxif_debug;
         GEN_CTXIF_DEBUG pmemif_debug;
         HWDBG_CSRMAP hwdbg;
         RXULP_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
         RXULP_UE_SOURCE1 ue_source1;
         RXULP_UE_ENABLE1 ue_enable1;
         GEN_IPC_DEBUG ipc_debug;
         RXULP_WINDOW_UPDATE_CTRL0 winupdate_ctrl0;
         RXULP_WINDOW_UPDATE_CTRL1 winupdate_ctrl1;
         RXULP_WINDOW_UPDATE_DEBUG0 winupdate_debug0;
         RXULP_WINDOW_UPDATE_DEBUG1 winupdate_debug1;
         BTLR_CTRL3 btlr_btlr_ctrl3;
         RXULP_SM_DEBUG0 sm_debug0;
         RXULP_VQUEUES_WEIGHTS vq_weights;
         RXULP_VQUEUE_THRESHOLDS vq_threshold;
         RXULP_VQUEUE_CREDITS0 vq_credits_lower;
         RXULP_VQUEUE_CREDITS1 vq_credits_upper;
         RXULP_VQUEUE_DEBUG_RW_LSB vq_dbg_rw_data_lower;
         RXULP_VQUEUE_DEBUG_RW_MSB vq_dbg_rw_data_upper;
         RXULP_VQUEUE_DEBUG_LL_BITS vq_dbg_rw_ll;
         RXULP_VQUEUE_DEBUG_CONTROL vq_dbg_control;
         RXULP_VQUEUE_DEBUG_STATS1 vq_dbg_info1;
         RXULP_VQUEUE_DEBUG_STATS2 vq_dbg_info2;
         RXULP_VQUEUE_DEBUG_STATS3 vq_credits_queue_lower;
         RXULP_VQUEUE_DEBUG_STATS4 vq_credits_queue_upper;
         RXULP_VQUEUE_DEBUG_STATS5 cid_scoreboard_value;
         RXULP_VQUEUE_UE_SOURCE1 vqueue_ue_source1;
         RXULP_VQUEUE_UE_ENABLE1 vqueue_ue_enable1;
         RXULP_CONSEL_DEBUG0 consel_debug0;
         RXULP_CONSEL_DEBUG1 consel_debug1;
         u32 rsvd0[140];                          // DWORDS 116 to 255
      } SG_PACK RXULP_CSRMAP, *PRXULP_CSRMAP;

      typedef union _RXULP_CSRMAP_UNION {
         RXULP_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK RXULP_CSRMAP_UNION, *PRXULP_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CSRMAP_UNION, sizeof (RXULP_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __rxulp_bmap_h__

