/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __uc_bmap_h__
#define __uc_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "pq_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CONTROL_CSR {
         union {
            struct { 
               u32 uc_wdma_throttle : 4;          // DWORD 0
               u32 uc_rdma_throttle : 4;          // DWORD 0
               u32 uc_ptc_throttle : 4;           // DWORD 0
               u32 wdma_swap_cntl : 2;            // DWORD 0
               u32 rdma_swap_cntl : 2;            // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 en_refage : 1;                 // DWORD 0
               u32 en_uc : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CONTROL_CSR, *PUC_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__UC_CONTROL_CSR, sizeof (UC_CONTROL_CSR) == 4);

   #else
      typedef struct _UC_CONTROL_CSR {
         u32 uc_wdma_throttle : 4;                // DWORD 0
         u32 uc_rdma_throttle : 4;                // DWORD 0
         u32 uc_ptc_throttle : 4;                 // DWORD 0
         u32 wdma_swap_cntl : 2;                  // DWORD 0
         u32 rdma_swap_cntl : 2;                  // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 en_refage : 1;                       // DWORD 0
         u32 en_uc : 1;                           // DWORD 0
      } SG_PACK UC_CONTROL_CSR, *PUC_CONTROL_CSR;

      typedef union _UC_CONTROL_CSR_UNION {
         UC_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CONTROL_CSR_UNION, *PUC_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CONTROL_CSR_UNION, sizeof (UC_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CONTROL_CSR {
         union {
            struct { 
               u32 en_uc : 1;                     // DWORD 0
               u32 en_refage : 1;                 // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 rdma_swap_cntl : 2;            // DWORD 0
               u32 wdma_swap_cntl : 2;            // DWORD 0
               u32 uc_ptc_throttle : 4;           // DWORD 0
               u32 uc_rdma_throttle : 4;          // DWORD 0
               u32 uc_wdma_throttle : 4;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CONTROL_CSR, *PUC_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__UC_CONTROL_CSR, sizeof (UC_CONTROL_CSR) == 4);

   #else
      typedef struct _UC_CONTROL_CSR {
         u32 en_uc : 1;                           // DWORD 0
         u32 en_refage : 1;                       // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 rdma_swap_cntl : 2;                  // DWORD 0
         u32 wdma_swap_cntl : 2;                  // DWORD 0
         u32 uc_ptc_throttle : 4;                 // DWORD 0
         u32 uc_rdma_throttle : 4;                // DWORD 0
         u32 uc_wdma_throttle : 4;                // DWORD 0
      } SG_PACK UC_CONTROL_CSR, *PUC_CONTROL_CSR;

      typedef union _UC_CONTROL_CSR_UNION {
         UC_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CONTROL_CSR_UNION, *PUC_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CONTROL_CSR_UNION, sizeof (UC_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Register Router Command Register. Used in conjunction with the UC_CRA_CSR register
   // for software CSR-based UC DWORD accesses. To initiate a command that applies to a
   // cache line, the Register Router CRA Register is first loaded with the request
   // address followed by the write to this command register. The UC response to the
   // command is contained in the UC_RESP0_CSR and UC_RESP1_CSR registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_COMMAND_CSR {
         union {
            struct { 
               u32 opaque_data : 12;              // DWORD 0
               u32 requester_id : 4;              // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 cqe : 1;                       // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 req_opcode : 3;                // DWORD 0
               u32 drop : 1;                      // DWORD 0
               u32 req_type : 1;                  // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 prefetch : 1;                  // DWORD 0
               u32 iqs : 1;                       // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_COMMAND_CSR, *PUC_COMMAND_CSR;

      SG_C_ASSERT(__sizeof__UC_COMMAND_CSR, sizeof (UC_COMMAND_CSR) == 4);

   #else
      typedef struct _UC_COMMAND_CSR {
         u32 opaque_data : 12;                    // DWORD 0
         u32 requester_id : 4;                    // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 cqe : 1;                             // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 req_opcode : 3;                      // DWORD 0
         u32 drop : 1;                            // DWORD 0
         u32 req_type : 1;                        // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 prefetch : 1;                        // DWORD 0
         u32 iqs : 1;                             // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
      } SG_PACK UC_COMMAND_CSR, *PUC_COMMAND_CSR;

      typedef union _UC_COMMAND_CSR_UNION {
         UC_COMMAND_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_COMMAND_CSR_UNION, *PUC_COMMAND_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_COMMAND_CSR_UNION, sizeof (UC_COMMAND_CSR_UNION) == 4);
   #endif


#else
   // Register Router Command Register. Used in conjunction with the UC_CRA_CSR register
   // for software CSR-based UC DWORD accesses. To initiate a command that applies to a
   // cache line, the Register Router CRA Register is first loaded with the request
   // address followed by the write to this command register. The UC response to the
   // command is contained in the UC_RESP0_CSR and UC_RESP1_CSR registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_COMMAND_CSR {
         union {
            struct { 
               u32 rsvd0 : 3;                     // DWORD 0
               u32 iqs : 1;                       // DWORD 0
               u32 prefetch : 1;                  // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 req_type : 1;                  // DWORD 0
               u32 drop : 1;                      // DWORD 0
               u32 req_opcode : 3;                // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 cqe : 1;                       // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 requester_id : 4;              // DWORD 0
               u32 opaque_data : 12;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_COMMAND_CSR, *PUC_COMMAND_CSR;

      SG_C_ASSERT(__sizeof__UC_COMMAND_CSR, sizeof (UC_COMMAND_CSR) == 4);

   #else
      typedef struct _UC_COMMAND_CSR {
         u32 rsvd0 : 3;                           // DWORD 0
         u32 iqs : 1;                             // DWORD 0
         u32 prefetch : 1;                        // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 req_type : 1;                        // DWORD 0
         u32 drop : 1;                            // DWORD 0
         u32 req_opcode : 3;                      // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 cqe : 1;                             // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 requester_id : 4;                    // DWORD 0
         u32 opaque_data : 12;                    // DWORD 0
      } SG_PACK UC_COMMAND_CSR, *PUC_COMMAND_CSR;

      typedef union _UC_COMMAND_CSR_UNION {
         UC_COMMAND_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_COMMAND_CSR_UNION, *PUC_COMMAND_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_COMMAND_CSR_UNION, sizeof (UC_COMMAND_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Cache Request Address Register. Used with the UC_COMMAND_CSR to initiate
   // software-based (CSR) UC DWORD accesses. Its non-reserved fields are equivalent to
   // CRA[29:2].
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_CSR {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 dt_index : 9;                  // DWORD 0
               u32 pt_index : 9;                  // DWORD 0
               u32 page_offset : 10;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_CSR, *PUC_CRA_CSR;

      SG_C_ASSERT(__sizeof__UC_CRA_CSR, sizeof (UC_CRA_CSR) == 4);

   #else
      typedef struct _UC_CRA_CSR {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 dt_index : 9;                        // DWORD 0
         u32 pt_index : 9;                        // DWORD 0
         u32 page_offset : 10;                    // DWORD 0
      } SG_PACK UC_CRA_CSR, *PUC_CRA_CSR;

      typedef union _UC_CRA_CSR_UNION {
         UC_CRA_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_CSR_UNION, *PUC_CRA_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_CSR_UNION, sizeof (UC_CRA_CSR_UNION) == 4);
   #endif


#else
   // Cache Request Address Register. Used with the UC_COMMAND_CSR to initiate
   // software-based (CSR) UC DWORD accesses. Its non-reserved fields are equivalent to
   // CRA[29:2].
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_CSR {
         union {
            struct { 
               u32 page_offset : 10;              // DWORD 0
               u32 pt_index : 9;                  // DWORD 0
               u32 dt_index : 9;                  // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_CSR, *PUC_CRA_CSR;

      SG_C_ASSERT(__sizeof__UC_CRA_CSR, sizeof (UC_CRA_CSR) == 4);

   #else
      typedef struct _UC_CRA_CSR {
         u32 page_offset : 10;                    // DWORD 0
         u32 pt_index : 9;                        // DWORD 0
         u32 dt_index : 9;                        // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK UC_CRA_CSR, *PUC_CRA_CSR;

      typedef union _UC_CRA_CSR_UNION {
         UC_CRA_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_CSR_UNION, *PUC_CRA_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_CSR_UNION, sizeof (UC_CRA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Error CRA Register. This regsiter captures the CRA when any UE occurs.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_ERRORCRA_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 tag : 16;                      // DWORD 0
               u32 index : 8;                     // DWORD 0
               u32 offset : 6;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_ERRORCRA_CSR, *PUC_ERRORCRA_CSR;

      SG_C_ASSERT(__sizeof__UC_ERRORCRA_CSR, sizeof (UC_ERRORCRA_CSR) == 4);

   #else
      typedef struct _UC_ERRORCRA_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 tag : 16;                            // DWORD 0
         u32 index : 8;                           // DWORD 0
         u32 offset : 6;                          // DWORD 0
      } SG_PACK UC_ERRORCRA_CSR, *PUC_ERRORCRA_CSR;

      typedef union _UC_ERRORCRA_CSR_UNION {
         UC_ERRORCRA_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_ERRORCRA_CSR_UNION, *PUC_ERRORCRA_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_ERRORCRA_CSR_UNION, sizeof (UC_ERRORCRA_CSR_UNION) == 4);
   #endif


#else
   // Error CRA Register. This regsiter captures the CRA when any UE occurs.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_ERRORCRA_CSR {
         union {
            struct { 
               u32 offset : 6;                    // DWORD 0
               u32 index : 8;                     // DWORD 0
               u32 tag : 16;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_ERRORCRA_CSR, *PUC_ERRORCRA_CSR;

      SG_C_ASSERT(__sizeof__UC_ERRORCRA_CSR, sizeof (UC_ERRORCRA_CSR) == 4);

   #else
      typedef struct _UC_ERRORCRA_CSR {
         u32 offset : 6;                          // DWORD 0
         u32 index : 8;                           // DWORD 0
         u32 tag : 16;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK UC_ERRORCRA_CSR, *PUC_ERRORCRA_CSR;

      typedef union _UC_ERRORCRA_CSR_UNION {
         UC_ERRORCRA_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_ERRORCRA_CSR_UNION, *PUC_ERRORCRA_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_ERRORCRA_CSR_UNION, sizeof (UC_ERRORCRA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Register Router Access, UC Response 0 Register. First of two response registers for
   // software-based (CSR) accesses to UC. Such accesses are initiated by writing to the
   // UC_COMMAND_CSR. Upon access completion, the UC will set this register's valid bit to
   // indicate that the response is valid.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RESP0_CSR {
         union {
            struct { 
               u32 opaque_data : 12;              // DWORD 0
               u32 requester_id : 4;              // DWORD 0
               u32 status : 4;                    // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 prefetch : 1;                  // DWORD 0
               u32 iqs : 1;                       // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 valid : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RESP0_CSR, *PUC_RESP0_CSR;

      SG_C_ASSERT(__sizeof__UC_RESP0_CSR, sizeof (UC_RESP0_CSR) == 4);

   #else
      typedef struct _UC_RESP0_CSR {
         u32 opaque_data : 12;                    // DWORD 0
         u32 requester_id : 4;                    // DWORD 0
         u32 status : 4;                          // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 prefetch : 1;                        // DWORD 0
         u32 iqs : 1;                             // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 valid : 1;                           // DWORD 0
      } SG_PACK UC_RESP0_CSR, *PUC_RESP0_CSR;

      typedef union _UC_RESP0_CSR_UNION {
         UC_RESP0_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RESP0_CSR_UNION, *PUC_RESP0_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RESP0_CSR_UNION, sizeof (UC_RESP0_CSR_UNION) == 4);
   #endif


#else
   // Register Router Access, UC Response 0 Register. First of two response registers for
   // software-based (CSR) accesses to UC. Such accesses are initiated by writing to the
   // UC_COMMAND_CSR. Upon access completion, the UC will set this register's valid bit to
   // indicate that the response is valid.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RESP0_CSR {
         union {
            struct { 
               u32 valid : 1;                     // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 iqs : 1;                       // DWORD 0
               u32 prefetch : 1;                  // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 status : 4;                    // DWORD 0
               u32 requester_id : 4;              // DWORD 0
               u32 opaque_data : 12;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RESP0_CSR, *PUC_RESP0_CSR;

      SG_C_ASSERT(__sizeof__UC_RESP0_CSR, sizeof (UC_RESP0_CSR) == 4);

   #else
      typedef struct _UC_RESP0_CSR {
         u32 valid : 1;                           // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 iqs : 1;                             // DWORD 0
         u32 prefetch : 1;                        // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 status : 4;                          // DWORD 0
         u32 requester_id : 4;                    // DWORD 0
         u32 opaque_data : 12;                    // DWORD 0
      } SG_PACK UC_RESP0_CSR, *PUC_RESP0_CSR;

      typedef union _UC_RESP0_CSR_UNION {
         UC_RESP0_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RESP0_CSR_UNION, *PUC_RESP0_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RESP0_CSR_UNION, sizeof (UC_RESP0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Register Router Access, UC Response 1 Register. See UC_RESP0_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RESP1_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 ctx_mem_addr : 16;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RESP1_CSR, *PUC_RESP1_CSR;

      SG_C_ASSERT(__sizeof__UC_RESP1_CSR, sizeof (UC_RESP1_CSR) == 4);

   #else
      typedef struct _UC_RESP1_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 ctx_mem_addr : 16;                   // DWORD 0
      } SG_PACK UC_RESP1_CSR, *PUC_RESP1_CSR;

      typedef union _UC_RESP1_CSR_UNION {
         UC_RESP1_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RESP1_CSR_UNION, *PUC_RESP1_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RESP1_CSR_UNION, sizeof (UC_RESP1_CSR_UNION) == 4);
   #endif


#else
   // Register Router Access, UC Response 1 Register. See UC_RESP0_CSR for details.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RESP1_CSR {
         union {
            struct { 
               u32 ctx_mem_addr : 16;             // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RESP1_CSR, *PUC_RESP1_CSR;

      SG_C_ASSERT(__sizeof__UC_RESP1_CSR, sizeof (UC_RESP1_CSR) == 4);

   #else
      typedef struct _UC_RESP1_CSR {
         u32 ctx_mem_addr : 16;                   // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK UC_RESP1_CSR, *PUC_RESP1_CSR;

      typedef union _UC_RESP1_CSR_UNION {
         UC_RESP1_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RESP1_CSR_UNION, *PUC_RESP1_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RESP1_CSR_UNION, sizeof (UC_RESP1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Tag State Request Register. Used to query the Tag State for a particular Index/Way
   // in UC. The query is initiated by a write to this register. Note that UC must be
   // quiescent at the time the query is initiated (ie, no pending accesses from any
   // clients).
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TS_REQ_CSR {
         union {
            struct { 
               u32 rsvd0 : 21;                    // DWORD 0
               u32 way : 2;                       // DWORD 0
               u32 index : 9;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TS_REQ_CSR, *PUC_TS_REQ_CSR;

      SG_C_ASSERT(__sizeof__UC_TS_REQ_CSR, sizeof (UC_TS_REQ_CSR) == 4);

   #else
      typedef struct _UC_TS_REQ_CSR {
         u32 rsvd0 : 21;                          // DWORD 0
         u32 way : 2;                             // DWORD 0
         u32 index : 9;                           // DWORD 0
      } SG_PACK UC_TS_REQ_CSR, *PUC_TS_REQ_CSR;

      typedef union _UC_TS_REQ_CSR_UNION {
         UC_TS_REQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TS_REQ_CSR_UNION, *PUC_TS_REQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TS_REQ_CSR_UNION, sizeof (UC_TS_REQ_CSR_UNION) == 4);
   #endif


#else
   // Tag State Request Register. Used to query the Tag State for a particular Index/Way
   // in UC. The query is initiated by a write to this register. Note that UC must be
   // quiescent at the time the query is initiated (ie, no pending accesses from any
   // clients).
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TS_REQ_CSR {
         union {
            struct { 
               u32 index : 9;                     // DWORD 0
               u32 way : 2;                       // DWORD 0
               u32 rsvd0 : 21;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TS_REQ_CSR, *PUC_TS_REQ_CSR;

      SG_C_ASSERT(__sizeof__UC_TS_REQ_CSR, sizeof (UC_TS_REQ_CSR) == 4);

   #else
      typedef struct _UC_TS_REQ_CSR {
         u32 index : 9;                           // DWORD 0
         u32 way : 2;                             // DWORD 0
         u32 rsvd0 : 21;                          // DWORD 0
      } SG_PACK UC_TS_REQ_CSR, *PUC_TS_REQ_CSR;

      typedef union _UC_TS_REQ_CSR_UNION {
         UC_TS_REQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TS_REQ_CSR_UNION, *PUC_TS_REQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TS_REQ_CSR_UNION, sizeof (UC_TS_REQ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Tag State Response Register. Used to provide the response to TAG/State query for a
   // particular Index/Way in UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TS_RESP_CSR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 state : 8;                     // DWORD 0
               u32 tag : 16;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TS_RESP_CSR, *PUC_TS_RESP_CSR;

      SG_C_ASSERT(__sizeof__UC_TS_RESP_CSR, sizeof (UC_TS_RESP_CSR) == 4);

   #else
      typedef struct _UC_TS_RESP_CSR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 state : 8;                           // DWORD 0
         u32 tag : 16;                            // DWORD 0
      } SG_PACK UC_TS_RESP_CSR, *PUC_TS_RESP_CSR;

      typedef union _UC_TS_RESP_CSR_UNION {
         UC_TS_RESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TS_RESP_CSR_UNION, *PUC_TS_RESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TS_RESP_CSR_UNION, sizeof (UC_TS_RESP_CSR_UNION) == 4);
   #endif


#else
   // Tag State Response Register. Used to provide the response to TAG/State query for a
   // particular Index/Way in UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TS_RESP_CSR {
         union {
            struct { 
               u32 tag : 16;                      // DWORD 0
               u32 state : 8;                     // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TS_RESP_CSR, *PUC_TS_RESP_CSR;

      SG_C_ASSERT(__sizeof__UC_TS_RESP_CSR, sizeof (UC_TS_RESP_CSR) == 4);

   #else
      typedef struct _UC_TS_RESP_CSR {
         u32 tag : 16;                            // DWORD 0
         u32 state : 8;                           // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK UC_TS_RESP_CSR, *PUC_TS_RESP_CSR;

      typedef union _UC_TS_RESP_CSR_UNION {
         UC_TS_RESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TS_RESP_CSR_UNION, *PUC_TS_RESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TS_RESP_CSR_UNION, sizeof (UC_TS_RESP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Client Weighted Arbitration Control Register. UC's clients are serviced in
   // weighted-round-robin fashion.This register controls client weights. Each weight
   // gives the maximum number of consecutive client accesses serviced by UC before it
   // moves on to service another client.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_WEIGHT_ARB_CSR {
         union {
            struct { 
               u32 w1 : 16;                       // DWORD 0
               u32 w0 : 16;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_WEIGHT_ARB_CSR, *PUC_WEIGHT_ARB_CSR;

      SG_C_ASSERT(__sizeof__UC_WEIGHT_ARB_CSR, sizeof (UC_WEIGHT_ARB_CSR) == 4);

   #else
      typedef struct _UC_WEIGHT_ARB_CSR {
         u32 w1 : 16;                             // DWORD 0
         u32 w0 : 16;                             // DWORD 0
      } SG_PACK UC_WEIGHT_ARB_CSR, *PUC_WEIGHT_ARB_CSR;

      typedef union _UC_WEIGHT_ARB_CSR_UNION {
         UC_WEIGHT_ARB_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_WEIGHT_ARB_CSR_UNION, *PUC_WEIGHT_ARB_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_WEIGHT_ARB_CSR_UNION, sizeof (UC_WEIGHT_ARB_CSR_UNION) == 4);
   #endif


#else
   // Client Weighted Arbitration Control Register. UC's clients are serviced in
   // weighted-round-robin fashion.This register controls client weights. Each weight
   // gives the maximum number of consecutive client accesses serviced by UC before it
   // moves on to service another client.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_WEIGHT_ARB_CSR {
         union {
            struct { 
               u32 w0 : 16;                       // DWORD 0
               u32 w1 : 16;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_WEIGHT_ARB_CSR, *PUC_WEIGHT_ARB_CSR;

      SG_C_ASSERT(__sizeof__UC_WEIGHT_ARB_CSR, sizeof (UC_WEIGHT_ARB_CSR) == 4);

   #else
      typedef struct _UC_WEIGHT_ARB_CSR {
         u32 w0 : 16;                             // DWORD 0
         u32 w1 : 16;                             // DWORD 0
      } SG_PACK UC_WEIGHT_ARB_CSR, *PUC_WEIGHT_ARB_CSR;

      typedef union _UC_WEIGHT_ARB_CSR_UNION {
         UC_WEIGHT_ARB_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_WEIGHT_ARB_CSR_UNION, *PUC_WEIGHT_ARB_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_WEIGHT_ARB_CSR_UNION, sizeof (UC_WEIGHT_ARB_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Client Weighted Arbitration Control Register. UC's clients are serviced in
   // weighted-round-robin fashion.This register controls client weights. Each weight
   // gives the maximum number of consecutive client accesses serviced by UC before it
   // moves on to service another client.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_WEIGHT_ARB_CSR_2 {
         union {
            struct { 
               u32 w1 : 16;                       // DWORD 0
               u32 w0 : 16;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_WEIGHT_ARB_CSR_2, *PUC_WEIGHT_ARB_CSR_2;

      SG_C_ASSERT(__sizeof__UC_WEIGHT_ARB_CSR_2, sizeof (UC_WEIGHT_ARB_CSR_2) == 4);

   #else
      typedef struct _UC_WEIGHT_ARB_CSR_2 {
         u32 w1 : 16;                             // DWORD 0
         u32 w0 : 16;                             // DWORD 0
      } SG_PACK UC_WEIGHT_ARB_CSR_2, *PUC_WEIGHT_ARB_CSR_2;

      typedef union _UC_WEIGHT_ARB_CSR_2_UNION {
         UC_WEIGHT_ARB_CSR_2 bits;
         u32 dw; // dword union
      } SG_PACK UC_WEIGHT_ARB_CSR_2_UNION, *PUC_WEIGHT_ARB_CSR_2_UNION;

      SG_C_ASSERT(__sizeof__UC_WEIGHT_ARB_CSR_2_UNION, sizeof (UC_WEIGHT_ARB_CSR_2_UNION) == 4);
   #endif


#else
   // Client Weighted Arbitration Control Register. UC's clients are serviced in
   // weighted-round-robin fashion.This register controls client weights. Each weight
   // gives the maximum number of consecutive client accesses serviced by UC before it
   // moves on to service another client.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_WEIGHT_ARB_CSR_2 {
         union {
            struct { 
               u32 w0 : 16;                       // DWORD 0
               u32 w1 : 16;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_WEIGHT_ARB_CSR_2, *PUC_WEIGHT_ARB_CSR_2;

      SG_C_ASSERT(__sizeof__UC_WEIGHT_ARB_CSR_2, sizeof (UC_WEIGHT_ARB_CSR_2) == 4);

   #else
      typedef struct _UC_WEIGHT_ARB_CSR_2 {
         u32 w0 : 16;                             // DWORD 0
         u32 w1 : 16;                             // DWORD 0
      } SG_PACK UC_WEIGHT_ARB_CSR_2, *PUC_WEIGHT_ARB_CSR_2;

      typedef union _UC_WEIGHT_ARB_CSR_2_UNION {
         UC_WEIGHT_ARB_CSR_2 bits;
         u32 dw; // dword union
      } SG_PACK UC_WEIGHT_ARB_CSR_2_UNION, *PUC_WEIGHT_ARB_CSR_2_UNION;

      SG_C_ASSERT(__sizeof__UC_WEIGHT_ARB_CSR_2_UNION, sizeof (UC_WEIGHT_ARB_CSR_2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CRA Re-Mapping 0 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. Note that since all UC clients request issue requests
   // with DWORD-length CRAs (see UC_REQ_D), the first two re-mapping fields in this CSR
   // are unused. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR0 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR0, *PUC_CRA_REMAP_CSR0;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR0, sizeof (UC_CRA_REMAP_CSR0) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR0 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR0, *PUC_CRA_REMAP_CSR0;

      typedef union _UC_CRA_REMAP_CSR0_UNION {
         UC_CRA_REMAP_CSR0 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR0_UNION, *PUC_CRA_REMAP_CSR0_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR0_UNION, sizeof (UC_CRA_REMAP_CSR0_UNION) == 4);
   #endif


#else
   // CRA Re-Mapping 0 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. Note that since all UC clients request issue requests
   // with DWORD-length CRAs (see UC_REQ_D), the first two re-mapping fields in this CSR
   // are unused. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR0 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR0, *PUC_CRA_REMAP_CSR0;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR0, sizeof (UC_CRA_REMAP_CSR0) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR0 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR0, *PUC_CRA_REMAP_CSR0;

      typedef union _UC_CRA_REMAP_CSR0_UNION {
         UC_CRA_REMAP_CSR0 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR0_UNION, *PUC_CRA_REMAP_CSR0_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR0_UNION, sizeof (UC_CRA_REMAP_CSR0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CRA Re-Mapping 1 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR1 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR1, *PUC_CRA_REMAP_CSR1;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR1, sizeof (UC_CRA_REMAP_CSR1) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR1 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR1, *PUC_CRA_REMAP_CSR1;

      typedef union _UC_CRA_REMAP_CSR1_UNION {
         UC_CRA_REMAP_CSR1 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR1_UNION, *PUC_CRA_REMAP_CSR1_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR1_UNION, sizeof (UC_CRA_REMAP_CSR1_UNION) == 4);
   #endif


#else
   // CRA Re-Mapping 1 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR1 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR1, *PUC_CRA_REMAP_CSR1;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR1, sizeof (UC_CRA_REMAP_CSR1) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR1 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR1, *PUC_CRA_REMAP_CSR1;

      typedef union _UC_CRA_REMAP_CSR1_UNION {
         UC_CRA_REMAP_CSR1 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR1_UNION, *PUC_CRA_REMAP_CSR1_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR1_UNION, sizeof (UC_CRA_REMAP_CSR1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CRA Re-Mapping 2 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR2 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR2, *PUC_CRA_REMAP_CSR2;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR2, sizeof (UC_CRA_REMAP_CSR2) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR2 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR2, *PUC_CRA_REMAP_CSR2;

      typedef union _UC_CRA_REMAP_CSR2_UNION {
         UC_CRA_REMAP_CSR2 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR2_UNION, *PUC_CRA_REMAP_CSR2_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR2_UNION, sizeof (UC_CRA_REMAP_CSR2_UNION) == 4);
   #endif


#else
   // CRA Re-Mapping 2 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR2 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR2, *PUC_CRA_REMAP_CSR2;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR2, sizeof (UC_CRA_REMAP_CSR2) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR2 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR2, *PUC_CRA_REMAP_CSR2;

      typedef union _UC_CRA_REMAP_CSR2_UNION {
         UC_CRA_REMAP_CSR2 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR2_UNION, *PUC_CRA_REMAP_CSR2_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR2_UNION, sizeof (UC_CRA_REMAP_CSR2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CRA Re-Mapping 3 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR3 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR3, *PUC_CRA_REMAP_CSR3;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR3, sizeof (UC_CRA_REMAP_CSR3) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR3 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR3, *PUC_CRA_REMAP_CSR3;

      typedef union _UC_CRA_REMAP_CSR3_UNION {
         UC_CRA_REMAP_CSR3 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR3_UNION, *PUC_CRA_REMAP_CSR3_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR3_UNION, sizeof (UC_CRA_REMAP_CSR3_UNION) == 4);
   #endif


#else
   // CRA Re-Mapping 3 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR3 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR3, *PUC_CRA_REMAP_CSR3;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR3, sizeof (UC_CRA_REMAP_CSR3) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR3 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR3, *PUC_CRA_REMAP_CSR3;

      typedef union _UC_CRA_REMAP_CSR3_UNION {
         UC_CRA_REMAP_CSR3 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR3_UNION, *PUC_CRA_REMAP_CSR3_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR3_UNION, sizeof (UC_CRA_REMAP_CSR3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CRA Re-Mapping 4 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR4 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR4, *PUC_CRA_REMAP_CSR4;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR4, sizeof (UC_CRA_REMAP_CSR4) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR4 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR4, *PUC_CRA_REMAP_CSR4;

      typedef union _UC_CRA_REMAP_CSR4_UNION {
         UC_CRA_REMAP_CSR4 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR4_UNION, *PUC_CRA_REMAP_CSR4_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR4_UNION, sizeof (UC_CRA_REMAP_CSR4_UNION) == 4);
   #endif


#else
   // CRA Re-Mapping 4 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR4 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR4, *PUC_CRA_REMAP_CSR4;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR4, sizeof (UC_CRA_REMAP_CSR4) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR4 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR4, *PUC_CRA_REMAP_CSR4;

      typedef union _UC_CRA_REMAP_CSR4_UNION {
         UC_CRA_REMAP_CSR4 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR4_UNION, *PUC_CRA_REMAP_CSR4_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR4_UNION, sizeof (UC_CRA_REMAP_CSR4_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CRA Re-Mapping 5 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR5 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc0 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR5, *PUC_CRA_REMAP_CSR5;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR5, sizeof (UC_CRA_REMAP_CSR5) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR5 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc0 : 5;                            // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR5, *PUC_CRA_REMAP_CSR5;

      typedef union _UC_CRA_REMAP_CSR5_UNION {
         UC_CRA_REMAP_CSR5 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR5_UNION, *PUC_CRA_REMAP_CSR5_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR5_UNION, sizeof (UC_CRA_REMAP_CSR5_UNION) == 4);
   #endif


#else
   // CRA Re-Mapping 5 Register. Allows bit-by-bit re-mapping of the CRA of incoming
   // requests from all clients. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CRA_REMAP_CSR5 {
         union {
            struct { 
               u32 loc0 : 5;                      // DWORD 0
               u32 loc1 : 5;                      // DWORD 0
               u32 loc2 : 5;                      // DWORD 0
               u32 loc3 : 5;                      // DWORD 0
               u32 loc4 : 5;                      // DWORD 0
               u32 loc5 : 5;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CRA_REMAP_CSR5, *PUC_CRA_REMAP_CSR5;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR5, sizeof (UC_CRA_REMAP_CSR5) == 4);

   #else
      typedef struct _UC_CRA_REMAP_CSR5 {
         u32 loc0 : 5;                            // DWORD 0
         u32 loc1 : 5;                            // DWORD 0
         u32 loc2 : 5;                            // DWORD 0
         u32 loc3 : 5;                            // DWORD 0
         u32 loc4 : 5;                            // DWORD 0
         u32 loc5 : 5;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK UC_CRA_REMAP_CSR5, *PUC_CRA_REMAP_CSR5;

      typedef union _UC_CRA_REMAP_CSR5_UNION {
         UC_CRA_REMAP_CSR5 bits;
         u32 dw; // dword union
      } SG_PACK UC_CRA_REMAP_CSR5_UNION, *PUC_CRA_REMAP_CSR5_UNION;

      SG_C_ASSERT(__sizeof__UC_CRA_REMAP_CSR5_UNION, sizeof (UC_CRA_REMAP_CSR5_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Statistics Index Register UC allows cache hit and miss statistics to be
   // simultaneously collected for up to eight different CRA ranges. Setting up statistics
   // for a given range involves the following steps: 1) The CRA range is programmed into
   // the UC_STAT_RANGE_START_CSR and UC_STAT_RANGE_END_CSR. 2) The range number and
   // statistic type is programmed into the UC_STAT_RANGE_INDEX_CSR. The above steps start
   // the statistic collection process for a given range. Thereafter statistics for a
   // given CRA range can be read via the following steps: a) The range number and
   // statistic type is programmed into the UC_STAT_INDEX_CSR. b) The statistic of
   // interest is read back from the UC_STAT_VALUE_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_STAT_INDEX_CSR {
         union {
            struct { 
               u32 index;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_STAT_INDEX_CSR, *PUC_STAT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__UC_STAT_INDEX_CSR, sizeof (UC_STAT_INDEX_CSR) == 4);

   #else
      typedef struct _UC_STAT_INDEX_CSR {
         u32 index;                               // DWORD 0
      } SG_PACK UC_STAT_INDEX_CSR, *PUC_STAT_INDEX_CSR;

      typedef union _UC_STAT_INDEX_CSR_UNION {
         UC_STAT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_STAT_INDEX_CSR_UNION, *PUC_STAT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_STAT_INDEX_CSR_UNION, sizeof (UC_STAT_INDEX_CSR_UNION) == 4);
   #endif


#else
   // Statistics Index Register UC allows cache hit and miss statistics to be
   // simultaneously collected for up to eight different CRA ranges. Setting up statistics
   // for a given range involves the following steps: 1) The CRA range is programmed into
   // the UC_STAT_RANGE_START_CSR and UC_STAT_RANGE_END_CSR. 2) The range number and
   // statistic type is programmed into the UC_STAT_RANGE_INDEX_CSR. The above steps start
   // the statistic collection process for a given range. Thereafter statistics for a
   // given CRA range can be read via the following steps: a) The range number and
   // statistic type is programmed into the UC_STAT_INDEX_CSR. b) The statistic of
   // interest is read back from the UC_STAT_VALUE_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_STAT_INDEX_CSR {
         union {
            struct { 
               u32 index;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_STAT_INDEX_CSR, *PUC_STAT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__UC_STAT_INDEX_CSR, sizeof (UC_STAT_INDEX_CSR) == 4);

   #else
      typedef struct _UC_STAT_INDEX_CSR {
         u32 index;                               // DWORD 0
      } SG_PACK UC_STAT_INDEX_CSR, *PUC_STAT_INDEX_CSR;

      typedef union _UC_STAT_INDEX_CSR_UNION {
         UC_STAT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_STAT_INDEX_CSR_UNION, *PUC_STAT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_STAT_INDEX_CSR_UNION, sizeof (UC_STAT_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Statistics Value Register. See UC_STAT_INDEX_CSR for usage.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_STAT_VALUE_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_STAT_VALUE_CSR, *PUC_STAT_VALUE_CSR;

      SG_C_ASSERT(__sizeof__UC_STAT_VALUE_CSR, sizeof (UC_STAT_VALUE_CSR) == 4);

   #else
      typedef struct _UC_STAT_VALUE_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK UC_STAT_VALUE_CSR, *PUC_STAT_VALUE_CSR;

      typedef union _UC_STAT_VALUE_CSR_UNION {
         UC_STAT_VALUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_STAT_VALUE_CSR_UNION, *PUC_STAT_VALUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_STAT_VALUE_CSR_UNION, sizeof (UC_STAT_VALUE_CSR_UNION) == 4);
   #endif


#else
   // Statistics Value Register. See UC_STAT_INDEX_CSR for usage.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_STAT_VALUE_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_STAT_VALUE_CSR, *PUC_STAT_VALUE_CSR;

      SG_C_ASSERT(__sizeof__UC_STAT_VALUE_CSR, sizeof (UC_STAT_VALUE_CSR) == 4);

   #else
      typedef struct _UC_STAT_VALUE_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK UC_STAT_VALUE_CSR, *PUC_STAT_VALUE_CSR;

      typedef union _UC_STAT_VALUE_CSR_UNION {
         UC_STAT_VALUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_STAT_VALUE_CSR_UNION, *PUC_STAT_VALUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_STAT_VALUE_CSR_UNION, sizeof (UC_STAT_VALUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Statistics Range Index Register. The range counter index value to be collected. See
   // UC_STAT_INDEX_CSR for usage.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_STAT_RANGE_INDEX_CSR {
         union {
            struct { 
               u32 range_index;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_STAT_RANGE_INDEX_CSR, *PUC_STAT_RANGE_INDEX_CSR;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_INDEX_CSR, sizeof (UC_STAT_RANGE_INDEX_CSR) == 4);

   #else
      typedef struct _UC_STAT_RANGE_INDEX_CSR {
         u32 range_index;                         // DWORD 0
      } SG_PACK UC_STAT_RANGE_INDEX_CSR, *PUC_STAT_RANGE_INDEX_CSR;

      typedef union _UC_STAT_RANGE_INDEX_CSR_UNION {
         UC_STAT_RANGE_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_STAT_RANGE_INDEX_CSR_UNION, *PUC_STAT_RANGE_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_INDEX_CSR_UNION, sizeof (UC_STAT_RANGE_INDEX_CSR_UNION) == 4);
   #endif


#else
   // Statistics Range Index Register. The range counter index value to be collected. See
   // UC_STAT_INDEX_CSR for usage.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_STAT_RANGE_INDEX_CSR {
         union {
            struct { 
               u32 range_index;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_STAT_RANGE_INDEX_CSR, *PUC_STAT_RANGE_INDEX_CSR;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_INDEX_CSR, sizeof (UC_STAT_RANGE_INDEX_CSR) == 4);

   #else
      typedef struct _UC_STAT_RANGE_INDEX_CSR {
         u32 range_index;                         // DWORD 0
      } SG_PACK UC_STAT_RANGE_INDEX_CSR, *PUC_STAT_RANGE_INDEX_CSR;

      typedef union _UC_STAT_RANGE_INDEX_CSR_UNION {
         UC_STAT_RANGE_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_STAT_RANGE_INDEX_CSR_UNION, *PUC_STAT_RANGE_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_INDEX_CSR_UNION, sizeof (UC_STAT_RANGE_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Statistics CRA Start Register. The starting address of the CRA for range statistics.
   // See UC_STAT_INDEX_CSR for usage.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_STAT_RANGE_START_CSR {
         union {
            struct { 
               u32 start;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_STAT_RANGE_START_CSR, *PUC_STAT_RANGE_START_CSR;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_START_CSR, sizeof (UC_STAT_RANGE_START_CSR) == 4);

   #else
      typedef struct _UC_STAT_RANGE_START_CSR {
         u32 start;                               // DWORD 0
      } SG_PACK UC_STAT_RANGE_START_CSR, *PUC_STAT_RANGE_START_CSR;

      typedef union _UC_STAT_RANGE_START_CSR_UNION {
         UC_STAT_RANGE_START_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_STAT_RANGE_START_CSR_UNION, *PUC_STAT_RANGE_START_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_START_CSR_UNION, sizeof (UC_STAT_RANGE_START_CSR_UNION) == 4);
   #endif


#else
   // Statistics CRA Start Register. The starting address of the CRA for range statistics.
   // See UC_STAT_INDEX_CSR for usage.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_STAT_RANGE_START_CSR {
         union {
            struct { 
               u32 start;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_STAT_RANGE_START_CSR, *PUC_STAT_RANGE_START_CSR;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_START_CSR, sizeof (UC_STAT_RANGE_START_CSR) == 4);

   #else
      typedef struct _UC_STAT_RANGE_START_CSR {
         u32 start;                               // DWORD 0
      } SG_PACK UC_STAT_RANGE_START_CSR, *PUC_STAT_RANGE_START_CSR;

      typedef union _UC_STAT_RANGE_START_CSR_UNION {
         UC_STAT_RANGE_START_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_STAT_RANGE_START_CSR_UNION, *PUC_STAT_RANGE_START_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_START_CSR_UNION, sizeof (UC_STAT_RANGE_START_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Statistics CRA End Register. The end address of the CRA for range statistics. See
   // UC_STAT_INDEX_CSR for usage.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_STAT_RANGE_END_CSR {
         union {
            struct { 
               u32 STAT_RANGE_END;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_STAT_RANGE_END_CSR, *PUC_STAT_RANGE_END_CSR;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_END_CSR, sizeof (UC_STAT_RANGE_END_CSR) == 4);

   #else
      typedef struct _UC_STAT_RANGE_END_CSR {
         u32 STAT_RANGE_END;                      // DWORD 0
      } SG_PACK UC_STAT_RANGE_END_CSR, *PUC_STAT_RANGE_END_CSR;

      typedef union _UC_STAT_RANGE_END_CSR_UNION {
         UC_STAT_RANGE_END_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_STAT_RANGE_END_CSR_UNION, *PUC_STAT_RANGE_END_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_END_CSR_UNION, sizeof (UC_STAT_RANGE_END_CSR_UNION) == 4);
   #endif


#else
   // Statistics CRA End Register. The end address of the CRA for range statistics. See
   // UC_STAT_INDEX_CSR for usage.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_STAT_RANGE_END_CSR {
         union {
            struct { 
               u32 STAT_RANGE_END;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_STAT_RANGE_END_CSR, *PUC_STAT_RANGE_END_CSR;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_END_CSR, sizeof (UC_STAT_RANGE_END_CSR) == 4);

   #else
      typedef struct _UC_STAT_RANGE_END_CSR {
         u32 STAT_RANGE_END;                      // DWORD 0
      } SG_PACK UC_STAT_RANGE_END_CSR, *PUC_STAT_RANGE_END_CSR;

      typedef union _UC_STAT_RANGE_END_CSR_UNION {
         UC_STAT_RANGE_END_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_STAT_RANGE_END_CSR_UNION, *PUC_STAT_RANGE_END_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_STAT_RANGE_END_CSR_UNION, sizeof (UC_STAT_RANGE_END_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data Arrays Base Location Register. UC's data arrays are stored in CTX. This
   // register gives their base location there.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CACHE_START_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CACHE_START_ADDR_CSR, *PUC_CACHE_START_ADDR_CSR;

      SG_C_ASSERT(__sizeof__UC_CACHE_START_ADDR_CSR, sizeof (UC_CACHE_START_ADDR_CSR) == 4);

   #else
      typedef struct _UC_CACHE_START_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK UC_CACHE_START_ADDR_CSR, *PUC_CACHE_START_ADDR_CSR;

      typedef union _UC_CACHE_START_ADDR_CSR_UNION {
         UC_CACHE_START_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CACHE_START_ADDR_CSR_UNION, *PUC_CACHE_START_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CACHE_START_ADDR_CSR_UNION, sizeof (UC_CACHE_START_ADDR_CSR_UNION) == 4);
   #endif


#else
   // Data Arrays Base Location Register. UC's data arrays are stored in CTX. This
   // register gives their base location there.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CACHE_START_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CACHE_START_ADDR_CSR, *PUC_CACHE_START_ADDR_CSR;

      SG_C_ASSERT(__sizeof__UC_CACHE_START_ADDR_CSR, sizeof (UC_CACHE_START_ADDR_CSR) == 4);

   #else
      typedef struct _UC_CACHE_START_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK UC_CACHE_START_ADDR_CSR, *PUC_CACHE_START_ADDR_CSR;

      typedef union _UC_CACHE_START_ADDR_CSR_UNION {
         UC_CACHE_START_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CACHE_START_ADDR_CSR_UNION, *PUC_CACHE_START_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CACHE_START_ADDR_CSR_UNION, sizeof (UC_CACHE_START_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RECOVERABLE_ERROR_CSR {
         union {
            struct { 
               u32 rsvd0 : 30;                    // DWORD 0
               u32 bad_rdma_retval_resp : 1;      // DWORD 0
               u32 bad_wdma_retval_resp : 1;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RECOVERABLE_ERROR_CSR, *PUC_RECOVERABLE_ERROR_CSR;

      SG_C_ASSERT(__sizeof__UC_RECOVERABLE_ERROR_CSR, sizeof (UC_RECOVERABLE_ERROR_CSR) == 4);

   #else
      typedef struct _UC_RECOVERABLE_ERROR_CSR {
         u32 rsvd0 : 30;                          // DWORD 0
         u32 bad_rdma_retval_resp : 1;            // DWORD 0
         u32 bad_wdma_retval_resp : 1;            // DWORD 0
      } SG_PACK UC_RECOVERABLE_ERROR_CSR, *PUC_RECOVERABLE_ERROR_CSR;

      typedef union _UC_RECOVERABLE_ERROR_CSR_UNION {
         UC_RECOVERABLE_ERROR_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RECOVERABLE_ERROR_CSR_UNION, *PUC_RECOVERABLE_ERROR_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RECOVERABLE_ERROR_CSR_UNION, sizeof (UC_RECOVERABLE_ERROR_CSR_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RECOVERABLE_ERROR_CSR {
         union {
            struct { 
               u32 bad_wdma_retval_resp : 1;      // DWORD 0
               u32 bad_rdma_retval_resp : 1;      // DWORD 0
               u32 rsvd0 : 30;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RECOVERABLE_ERROR_CSR, *PUC_RECOVERABLE_ERROR_CSR;

      SG_C_ASSERT(__sizeof__UC_RECOVERABLE_ERROR_CSR, sizeof (UC_RECOVERABLE_ERROR_CSR) == 4);

   #else
      typedef struct _UC_RECOVERABLE_ERROR_CSR {
         u32 bad_wdma_retval_resp : 1;            // DWORD 0
         u32 bad_rdma_retval_resp : 1;            // DWORD 0
         u32 rsvd0 : 30;                          // DWORD 0
      } SG_PACK UC_RECOVERABLE_ERROR_CSR, *PUC_RECOVERABLE_ERROR_CSR;

      typedef union _UC_RECOVERABLE_ERROR_CSR_UNION {
         UC_RECOVERABLE_ERROR_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RECOVERABLE_ERROR_CSR_UNION, *PUC_RECOVERABLE_ERROR_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RECOVERABLE_ERROR_CSR_UNION, sizeof (UC_RECOVERABLE_ERROR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RE_ENABLE_CSR {
         union {
            struct { 
               u32 rsvd0 : 30;                    // DWORD 0
               u32 bad_rdma_retval_resp : 1;      // DWORD 0
               u32 bad_wdma_retval_resp : 1;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RE_ENABLE_CSR, *PUC_RE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__UC_RE_ENABLE_CSR, sizeof (UC_RE_ENABLE_CSR) == 4);

   #else
      typedef struct _UC_RE_ENABLE_CSR {
         u32 rsvd0 : 30;                          // DWORD 0
         u32 bad_rdma_retval_resp : 1;            // DWORD 0
         u32 bad_wdma_retval_resp : 1;            // DWORD 0
      } SG_PACK UC_RE_ENABLE_CSR, *PUC_RE_ENABLE_CSR;

      typedef union _UC_RE_ENABLE_CSR_UNION {
         UC_RE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RE_ENABLE_CSR_UNION, *PUC_RE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RE_ENABLE_CSR_UNION, sizeof (UC_RE_ENABLE_CSR_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RE_ENABLE_CSR {
         union {
            struct { 
               u32 bad_wdma_retval_resp : 1;      // DWORD 0
               u32 bad_rdma_retval_resp : 1;      // DWORD 0
               u32 rsvd0 : 30;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RE_ENABLE_CSR, *PUC_RE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__UC_RE_ENABLE_CSR, sizeof (UC_RE_ENABLE_CSR) == 4);

   #else
      typedef struct _UC_RE_ENABLE_CSR {
         u32 bad_wdma_retval_resp : 1;            // DWORD 0
         u32 bad_rdma_retval_resp : 1;            // DWORD 0
         u32 rsvd0 : 30;                          // DWORD 0
      } SG_PACK UC_RE_ENABLE_CSR, *PUC_RE_ENABLE_CSR;

      typedef union _UC_RE_ENABLE_CSR_UNION {
         UC_RE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RE_ENABLE_CSR_UNION, *PUC_RE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RE_ENABLE_CSR_UNION, sizeof (UC_RE_ENABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unrecoverable Error Cause register. This a debug-only register, providing details of
   // Unrecoverable Error(s) that have occurred within UC. The errors are enabled (to be
   // propagated to shut down the chip) via the adjacent UC_UE_ENABLE_CSR register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_UNRECOVERABLE_ERROR_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 bad_uc_cra_req : 1;            // DWORD 0
               u32 access_minus_on_inv : 1;       // DWORD 0
               u32 ctx_parity : 1;                // DWORD 0
               u32 sram_access_during_init : 1;   // DWORD 0
               u32 fifo_uflow_err : 1;            // DWORD 0
               u32 fifo_oflow_err : 1;            // DWORD 0
               u32 cfiforam_perr : 1;             // DWORD 0
               u32 tagram_perr : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_UNRECOVERABLE_ERROR_CSR, *PUC_UNRECOVERABLE_ERROR_CSR;

      SG_C_ASSERT(__sizeof__UC_UNRECOVERABLE_ERROR_CSR, sizeof (UC_UNRECOVERABLE_ERROR_CSR) == 4);

   #else
      typedef struct _UC_UNRECOVERABLE_ERROR_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 bad_uc_cra_req : 1;                  // DWORD 0
         u32 access_minus_on_inv : 1;             // DWORD 0
         u32 ctx_parity : 1;                      // DWORD 0
         u32 sram_access_during_init : 1;         // DWORD 0
         u32 fifo_uflow_err : 1;                  // DWORD 0
         u32 fifo_oflow_err : 1;                  // DWORD 0
         u32 cfiforam_perr : 1;                   // DWORD 0
         u32 tagram_perr : 1;                     // DWORD 0
      } SG_PACK UC_UNRECOVERABLE_ERROR_CSR, *PUC_UNRECOVERABLE_ERROR_CSR;

      typedef union _UC_UNRECOVERABLE_ERROR_CSR_UNION {
         UC_UNRECOVERABLE_ERROR_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_UNRECOVERABLE_ERROR_CSR_UNION, *PUC_UNRECOVERABLE_ERROR_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_UNRECOVERABLE_ERROR_CSR_UNION, sizeof (UC_UNRECOVERABLE_ERROR_CSR_UNION) == 4);
   #endif


#else
   // Unrecoverable Error Cause register. This a debug-only register, providing details of
   // Unrecoverable Error(s) that have occurred within UC. The errors are enabled (to be
   // propagated to shut down the chip) via the adjacent UC_UE_ENABLE_CSR register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_UNRECOVERABLE_ERROR_CSR {
         union {
            struct { 
               u32 tagram_perr : 1;               // DWORD 0
               u32 cfiforam_perr : 1;             // DWORD 0
               u32 fifo_oflow_err : 1;            // DWORD 0
               u32 fifo_uflow_err : 1;            // DWORD 0
               u32 sram_access_during_init : 1;   // DWORD 0
               u32 ctx_parity : 1;                // DWORD 0
               u32 access_minus_on_inv : 1;       // DWORD 0
               u32 bad_uc_cra_req : 1;            // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_UNRECOVERABLE_ERROR_CSR, *PUC_UNRECOVERABLE_ERROR_CSR;

      SG_C_ASSERT(__sizeof__UC_UNRECOVERABLE_ERROR_CSR, sizeof (UC_UNRECOVERABLE_ERROR_CSR) == 4);

   #else
      typedef struct _UC_UNRECOVERABLE_ERROR_CSR {
         u32 tagram_perr : 1;                     // DWORD 0
         u32 cfiforam_perr : 1;                   // DWORD 0
         u32 fifo_oflow_err : 1;                  // DWORD 0
         u32 fifo_uflow_err : 1;                  // DWORD 0
         u32 sram_access_during_init : 1;         // DWORD 0
         u32 ctx_parity : 1;                      // DWORD 0
         u32 access_minus_on_inv : 1;             // DWORD 0
         u32 bad_uc_cra_req : 1;                  // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK UC_UNRECOVERABLE_ERROR_CSR, *PUC_UNRECOVERABLE_ERROR_CSR;

      typedef union _UC_UNRECOVERABLE_ERROR_CSR_UNION {
         UC_UNRECOVERABLE_ERROR_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_UNRECOVERABLE_ERROR_CSR_UNION, *PUC_UNRECOVERABLE_ERROR_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_UNRECOVERABLE_ERROR_CSR_UNION, sizeof (UC_UNRECOVERABLE_ERROR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unrecoverable Error Enable register. This a debug-only register, enabling reporting
   // of individual Unrecoverable Errors out of UC. The errors are reported in the
   // adjacent UC_UNRECOVERABLE_ERROR_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_UE_ENABLE_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 bad_uc_cra_req_en : 1;         // DWORD 0
               u32 access_minus_on_inv_en : 1;    // DWORD 0
               u32 ctx_parity_en : 1;             // DWORD 0
               u32 sram_access_during_init_en : 1; // DWORD 0
               u32 fifo_uflow_err : 1;            // DWORD 0
               u32 fifo_oflow_err : 1;            // DWORD 0
               u32 cfiforam_perr : 1;             // DWORD 0
               u32 tagram_perr : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_UE_ENABLE_CSR, *PUC_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__UC_UE_ENABLE_CSR, sizeof (UC_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _UC_UE_ENABLE_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 bad_uc_cra_req_en : 1;               // DWORD 0
         u32 access_minus_on_inv_en : 1;          // DWORD 0
         u32 ctx_parity_en : 1;                   // DWORD 0
         u32 sram_access_during_init_en : 1;      // DWORD 0
         u32 fifo_uflow_err : 1;                  // DWORD 0
         u32 fifo_oflow_err : 1;                  // DWORD 0
         u32 cfiforam_perr : 1;                   // DWORD 0
         u32 tagram_perr : 1;                     // DWORD 0
      } SG_PACK UC_UE_ENABLE_CSR, *PUC_UE_ENABLE_CSR;

      typedef union _UC_UE_ENABLE_CSR_UNION {
         UC_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_UE_ENABLE_CSR_UNION, *PUC_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_UE_ENABLE_CSR_UNION, sizeof (UC_UE_ENABLE_CSR_UNION) == 4);
   #endif


#else
   // Unrecoverable Error Enable register. This a debug-only register, enabling reporting
   // of individual Unrecoverable Errors out of UC. The errors are reported in the
   // adjacent UC_UNRECOVERABLE_ERROR_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_UE_ENABLE_CSR {
         union {
            struct { 
               u32 tagram_perr : 1;               // DWORD 0
               u32 cfiforam_perr : 1;             // DWORD 0
               u32 fifo_oflow_err : 1;            // DWORD 0
               u32 fifo_uflow_err : 1;            // DWORD 0
               u32 sram_access_during_init_en : 1; // DWORD 0
               u32 ctx_parity_en : 1;             // DWORD 0
               u32 access_minus_on_inv_en : 1;    // DWORD 0
               u32 bad_uc_cra_req_en : 1;         // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_UE_ENABLE_CSR, *PUC_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__UC_UE_ENABLE_CSR, sizeof (UC_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _UC_UE_ENABLE_CSR {
         u32 tagram_perr : 1;                     // DWORD 0
         u32 cfiforam_perr : 1;                   // DWORD 0
         u32 fifo_oflow_err : 1;                  // DWORD 0
         u32 fifo_uflow_err : 1;                  // DWORD 0
         u32 sram_access_during_init_en : 1;      // DWORD 0
         u32 ctx_parity_en : 1;                   // DWORD 0
         u32 access_minus_on_inv_en : 1;          // DWORD 0
         u32 bad_uc_cra_req_en : 1;               // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK UC_UE_ENABLE_CSR, *PUC_UE_ENABLE_CSR;

      typedef union _UC_UE_ENABLE_CSR_UNION {
         UC_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_UE_ENABLE_CSR_UNION, *PUC_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_UE_ENABLE_CSR_UNION, sizeof (UC_UE_ENABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // State Machine Status 0 Register. Used for debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_SMSTATUS0_CSR {
         union {
            struct { 
               u32 rsvd0 : 7;                     // DWORD 0
               u32 pr_smstate : 4;                // DWORD 0
               u32 pr_stall_ipq_rxulp0 : 1;       // DWORD 0
               u32 pr_stall_ipq_rxulp1 : 1;       // DWORD 0
               u32 pr_stall_ipq_rxulp2 : 1;       // DWORD 0
               u32 pr_stall_ipq_txulp0 : 1;       // DWORD 0
               u32 pr_stall_ipq_txulp1 : 1;       // DWORD 0
               u32 pr_stall_ipq_etx : 1;          // DWORD 0
               u32 pr_stall_ipq_erx : 1;          // DWORD 0
               u32 pr_stall_ipq_mpu : 1;          // DWORD 0
               u32 pr_stall_ipq_prefifo : 1;      // DWORD 0
               u32 rxulp0_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 rxulp1_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 rxulp2_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 txulp0_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 txulp1_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 etx_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 erx_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 mpu_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 prefifo_uc_ipq_data_rdy : 1;   // DWORD 0
               u32 trans0_data_rdy : 1;           // DWORD 0
               u32 trans1_data_rdy : 1;           // DWORD 0
               u32 trans2_data_rdy : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_SMSTATUS0_CSR, *PUC_SMSTATUS0_CSR;

      SG_C_ASSERT(__sizeof__UC_SMSTATUS0_CSR, sizeof (UC_SMSTATUS0_CSR) == 4);

   #else
      typedef struct _UC_SMSTATUS0_CSR {
         u32 rsvd0 : 7;                           // DWORD 0
         u32 pr_smstate : 4;                      // DWORD 0
         u32 pr_stall_ipq_rxulp0 : 1;             // DWORD 0
         u32 pr_stall_ipq_rxulp1 : 1;             // DWORD 0
         u32 pr_stall_ipq_rxulp2 : 1;             // DWORD 0
         u32 pr_stall_ipq_txulp0 : 1;             // DWORD 0
         u32 pr_stall_ipq_txulp1 : 1;             // DWORD 0
         u32 pr_stall_ipq_etx : 1;                // DWORD 0
         u32 pr_stall_ipq_erx : 1;                // DWORD 0
         u32 pr_stall_ipq_mpu : 1;                // DWORD 0
         u32 pr_stall_ipq_prefifo : 1;            // DWORD 0
         u32 rxulp0_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 rxulp1_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 rxulp2_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 txulp0_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 txulp1_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 etx_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 erx_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 mpu_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 prefifo_uc_ipq_data_rdy : 1;         // DWORD 0
         u32 trans0_data_rdy : 1;                 // DWORD 0
         u32 trans1_data_rdy : 1;                 // DWORD 0
         u32 trans2_data_rdy : 1;                 // DWORD 0
      } SG_PACK UC_SMSTATUS0_CSR, *PUC_SMSTATUS0_CSR;

      typedef union _UC_SMSTATUS0_CSR_UNION {
         UC_SMSTATUS0_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_SMSTATUS0_CSR_UNION, *PUC_SMSTATUS0_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_SMSTATUS0_CSR_UNION, sizeof (UC_SMSTATUS0_CSR_UNION) == 4);
   #endif


#else
   // State Machine Status 0 Register. Used for debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_SMSTATUS0_CSR {
         union {
            struct { 
               u32 trans2_data_rdy : 1;           // DWORD 0
               u32 trans1_data_rdy : 1;           // DWORD 0
               u32 trans0_data_rdy : 1;           // DWORD 0
               u32 prefifo_uc_ipq_data_rdy : 1;   // DWORD 0
               u32 mpu_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 erx_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 etx_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 txulp1_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 txulp0_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 rxulp2_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 rxulp1_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 rxulp0_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 pr_stall_ipq_prefifo : 1;      // DWORD 0
               u32 pr_stall_ipq_mpu : 1;          // DWORD 0
               u32 pr_stall_ipq_erx : 1;          // DWORD 0
               u32 pr_stall_ipq_etx : 1;          // DWORD 0
               u32 pr_stall_ipq_txulp1 : 1;       // DWORD 0
               u32 pr_stall_ipq_txulp0 : 1;       // DWORD 0
               u32 pr_stall_ipq_rxulp2 : 1;       // DWORD 0
               u32 pr_stall_ipq_rxulp1 : 1;       // DWORD 0
               u32 pr_stall_ipq_rxulp0 : 1;       // DWORD 0
               u32 pr_smstate : 4;                // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_SMSTATUS0_CSR, *PUC_SMSTATUS0_CSR;

      SG_C_ASSERT(__sizeof__UC_SMSTATUS0_CSR, sizeof (UC_SMSTATUS0_CSR) == 4);

   #else
      typedef struct _UC_SMSTATUS0_CSR {
         u32 trans2_data_rdy : 1;                 // DWORD 0
         u32 trans1_data_rdy : 1;                 // DWORD 0
         u32 trans0_data_rdy : 1;                 // DWORD 0
         u32 prefifo_uc_ipq_data_rdy : 1;         // DWORD 0
         u32 mpu_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 erx_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 etx_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 txulp1_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 txulp0_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 rxulp2_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 rxulp1_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 rxulp0_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 pr_stall_ipq_prefifo : 1;            // DWORD 0
         u32 pr_stall_ipq_mpu : 1;                // DWORD 0
         u32 pr_stall_ipq_erx : 1;                // DWORD 0
         u32 pr_stall_ipq_etx : 1;                // DWORD 0
         u32 pr_stall_ipq_txulp1 : 1;             // DWORD 0
         u32 pr_stall_ipq_txulp0 : 1;             // DWORD 0
         u32 pr_stall_ipq_rxulp2 : 1;             // DWORD 0
         u32 pr_stall_ipq_rxulp1 : 1;             // DWORD 0
         u32 pr_stall_ipq_rxulp0 : 1;             // DWORD 0
         u32 pr_smstate : 4;                      // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
      } SG_PACK UC_SMSTATUS0_CSR, *PUC_SMSTATUS0_CSR;

      typedef union _UC_SMSTATUS0_CSR_UNION {
         UC_SMSTATUS0_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_SMSTATUS0_CSR_UNION, *PUC_SMSTATUS0_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_SMSTATUS0_CSR_UNION, sizeof (UC_SMSTATUS0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // State Machine Status 1 Register. Used for debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_SMSTATUS1_CSR {
         union {
            struct { 
               u32 ram_state : 3;                 // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 tms_pend_dq_state : 4;         // DWORD 0
               u32 tms_ptcnq_state : 2;           // DWORD 0
               u32 tms_ptcdq_state : 2;           // DWORD 0
               u32 rxulp0_uc_cfifo_full : 1;      // DWORD 0
               u32 rxulp1_uc_cfifo_full : 1;      // DWORD 0
               u32 rxulp2_uc_cfifo_full : 1;      // DWORD 0
               u32 txulp0_uc_cfifo_full : 1;      // DWORD 0
               u32 txulp1_uc_cfifo_full : 1;      // DWORD 0
               u32 etx_uc_cfifo_full : 1;         // DWORD 0
               u32 erx_uc_cfifo_full : 1;         // DWORD 0
               u32 cev_uc_cfifo_full : 1;         // DWORD 0
               u32 wdma_uc_cfifo_full : 1;        // DWORD 0
               u32 rdma_uc_cfifo_full : 1;        // DWORD 0
               u32 mpu_uc_cfifo_full : 1;         // DWORD 0
               u32 pr_stall_cfifo_write : 1;      // DWORD 0
               u32 bad_rdma_retval_resp : 1;      // DWORD 0
               u32 bad_wdma_retval_resp : 1;      // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_SMSTATUS1_CSR, *PUC_SMSTATUS1_CSR;

      SG_C_ASSERT(__sizeof__UC_SMSTATUS1_CSR, sizeof (UC_SMSTATUS1_CSR) == 4);

   #else
      typedef struct _UC_SMSTATUS1_CSR {
         u32 ram_state : 3;                       // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 tms_pend_dq_state : 4;               // DWORD 0
         u32 tms_ptcnq_state : 2;                 // DWORD 0
         u32 tms_ptcdq_state : 2;                 // DWORD 0
         u32 rxulp0_uc_cfifo_full : 1;            // DWORD 0
         u32 rxulp1_uc_cfifo_full : 1;            // DWORD 0
         u32 rxulp2_uc_cfifo_full : 1;            // DWORD 0
         u32 txulp0_uc_cfifo_full : 1;            // DWORD 0
         u32 txulp1_uc_cfifo_full : 1;            // DWORD 0
         u32 etx_uc_cfifo_full : 1;               // DWORD 0
         u32 erx_uc_cfifo_full : 1;               // DWORD 0
         u32 cev_uc_cfifo_full : 1;               // DWORD 0
         u32 wdma_uc_cfifo_full : 1;              // DWORD 0
         u32 rdma_uc_cfifo_full : 1;              // DWORD 0
         u32 mpu_uc_cfifo_full : 1;               // DWORD 0
         u32 pr_stall_cfifo_write : 1;            // DWORD 0
         u32 bad_rdma_retval_resp : 1;            // DWORD 0
         u32 bad_wdma_retval_resp : 1;            // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
      } SG_PACK UC_SMSTATUS1_CSR, *PUC_SMSTATUS1_CSR;

      typedef union _UC_SMSTATUS1_CSR_UNION {
         UC_SMSTATUS1_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_SMSTATUS1_CSR_UNION, *PUC_SMSTATUS1_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_SMSTATUS1_CSR_UNION, sizeof (UC_SMSTATUS1_CSR_UNION) == 4);
   #endif


#else
   // State Machine Status 1 Register. Used for debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_SMSTATUS1_CSR {
         union {
            struct { 
               u32 rsvd0 : 6;                     // DWORD 0
               u32 bad_wdma_retval_resp : 1;      // DWORD 0
               u32 bad_rdma_retval_resp : 1;      // DWORD 0
               u32 pr_stall_cfifo_write : 1;      // DWORD 0
               u32 mpu_uc_cfifo_full : 1;         // DWORD 0
               u32 rdma_uc_cfifo_full : 1;        // DWORD 0
               u32 wdma_uc_cfifo_full : 1;        // DWORD 0
               u32 cev_uc_cfifo_full : 1;         // DWORD 0
               u32 erx_uc_cfifo_full : 1;         // DWORD 0
               u32 etx_uc_cfifo_full : 1;         // DWORD 0
               u32 txulp1_uc_cfifo_full : 1;      // DWORD 0
               u32 txulp0_uc_cfifo_full : 1;      // DWORD 0
               u32 rxulp2_uc_cfifo_full : 1;      // DWORD 0
               u32 rxulp1_uc_cfifo_full : 1;      // DWORD 0
               u32 rxulp0_uc_cfifo_full : 1;      // DWORD 0
               u32 tms_ptcdq_state : 2;           // DWORD 0
               u32 tms_ptcnq_state : 2;           // DWORD 0
               u32 tms_pend_dq_state : 4;         // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ram_state : 3;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_SMSTATUS1_CSR, *PUC_SMSTATUS1_CSR;

      SG_C_ASSERT(__sizeof__UC_SMSTATUS1_CSR, sizeof (UC_SMSTATUS1_CSR) == 4);

   #else
      typedef struct _UC_SMSTATUS1_CSR {
         u32 rsvd0 : 6;                           // DWORD 0
         u32 bad_wdma_retval_resp : 1;            // DWORD 0
         u32 bad_rdma_retval_resp : 1;            // DWORD 0
         u32 pr_stall_cfifo_write : 1;            // DWORD 0
         u32 mpu_uc_cfifo_full : 1;               // DWORD 0
         u32 rdma_uc_cfifo_full : 1;              // DWORD 0
         u32 wdma_uc_cfifo_full : 1;              // DWORD 0
         u32 cev_uc_cfifo_full : 1;               // DWORD 0
         u32 erx_uc_cfifo_full : 1;               // DWORD 0
         u32 etx_uc_cfifo_full : 1;               // DWORD 0
         u32 txulp1_uc_cfifo_full : 1;            // DWORD 0
         u32 txulp0_uc_cfifo_full : 1;            // DWORD 0
         u32 rxulp2_uc_cfifo_full : 1;            // DWORD 0
         u32 rxulp1_uc_cfifo_full : 1;            // DWORD 0
         u32 rxulp0_uc_cfifo_full : 1;            // DWORD 0
         u32 tms_ptcdq_state : 2;                 // DWORD 0
         u32 tms_ptcnq_state : 2;                 // DWORD 0
         u32 tms_pend_dq_state : 4;               // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ram_state : 3;                       // DWORD 0
      } SG_PACK UC_SMSTATUS1_CSR, *PUC_SMSTATUS1_CSR;

      typedef union _UC_SMSTATUS1_CSR_UNION {
         UC_SMSTATUS1_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_SMSTATUS1_CSR_UNION, *PUC_SMSTATUS1_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_SMSTATUS1_CSR_UNION, sizeof (UC_SMSTATUS1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Input Release Request Queues Entry Status Register. Each 'rdy' signal indicates
   // entry(ies) in relevant input (Release) request queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_IPQRELRDYSTATUS_CSR {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 valid_intm : 4;                // DWORD 0
               u32 replacement_way_intm : 4;      // DWORD 0
               u32 mpu_uc_rel_data_rdy : 1;       // DWORD 0
               u32 erx_uc_rel_data_rdy : 1;       // DWORD 0
               u32 etx_uc_rel_data_rdy : 1;       // DWORD 0
               u32 txulp1_uc_rel_data_rdy : 1;    // DWORD 0
               u32 txulp0_uc_rel_data_rdy : 1;    // DWORD 0
               u32 rxulp2_uc_rel_data_rdy : 1;    // DWORD 0
               u32 rxulp1_uc_rel_data_rdy : 1;    // DWORD 0
               u32 rxulp0_uc_rel_data_rdy : 1;    // DWORD 0
               u32 trans2_data_rdy : 1;           // DWORD 0
               u32 trans1_data_rdy : 1;           // DWORD 0
               u32 trans0_data_rdy : 1;           // DWORD 0
               u32 prefifo_uc_ipq_data_rdy : 1;   // DWORD 0
               u32 mpu_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 erx_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 etx_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 txulp1_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 txulp0_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 rxulp2_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 rxulp1_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 rxulp0_uc_ipq_data_rdy : 1;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_IPQRELRDYSTATUS_CSR, *PUC_IPQRELRDYSTATUS_CSR;

      SG_C_ASSERT(__sizeof__UC_IPQRELRDYSTATUS_CSR, sizeof (UC_IPQRELRDYSTATUS_CSR) == 4);

   #else
      typedef struct _UC_IPQRELRDYSTATUS_CSR {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 valid_intm : 4;                      // DWORD 0
         u32 replacement_way_intm : 4;            // DWORD 0
         u32 mpu_uc_rel_data_rdy : 1;             // DWORD 0
         u32 erx_uc_rel_data_rdy : 1;             // DWORD 0
         u32 etx_uc_rel_data_rdy : 1;             // DWORD 0
         u32 txulp1_uc_rel_data_rdy : 1;          // DWORD 0
         u32 txulp0_uc_rel_data_rdy : 1;          // DWORD 0
         u32 rxulp2_uc_rel_data_rdy : 1;          // DWORD 0
         u32 rxulp1_uc_rel_data_rdy : 1;          // DWORD 0
         u32 rxulp0_uc_rel_data_rdy : 1;          // DWORD 0
         u32 trans2_data_rdy : 1;                 // DWORD 0
         u32 trans1_data_rdy : 1;                 // DWORD 0
         u32 trans0_data_rdy : 1;                 // DWORD 0
         u32 prefifo_uc_ipq_data_rdy : 1;         // DWORD 0
         u32 mpu_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 erx_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 etx_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 txulp1_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 txulp0_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 rxulp2_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 rxulp1_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 rxulp0_uc_ipq_data_rdy : 1;          // DWORD 0
      } SG_PACK UC_IPQRELRDYSTATUS_CSR, *PUC_IPQRELRDYSTATUS_CSR;

      typedef union _UC_IPQRELRDYSTATUS_CSR_UNION {
         UC_IPQRELRDYSTATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_IPQRELRDYSTATUS_CSR_UNION, *PUC_IPQRELRDYSTATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_IPQRELRDYSTATUS_CSR_UNION, sizeof (UC_IPQRELRDYSTATUS_CSR_UNION) == 4);
   #endif


#else
   // Input Release Request Queues Entry Status Register. Each 'rdy' signal indicates
   // entry(ies) in relevant input (Release) request queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_IPQRELRDYSTATUS_CSR {
         union {
            struct { 
               u32 rxulp0_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 rxulp1_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 rxulp2_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 txulp0_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 txulp1_uc_ipq_data_rdy : 1;    // DWORD 0
               u32 etx_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 erx_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 mpu_uc_ipq_data_rdy : 1;       // DWORD 0
               u32 prefifo_uc_ipq_data_rdy : 1;   // DWORD 0
               u32 trans0_data_rdy : 1;           // DWORD 0
               u32 trans1_data_rdy : 1;           // DWORD 0
               u32 trans2_data_rdy : 1;           // DWORD 0
               u32 rxulp0_uc_rel_data_rdy : 1;    // DWORD 0
               u32 rxulp1_uc_rel_data_rdy : 1;    // DWORD 0
               u32 rxulp2_uc_rel_data_rdy : 1;    // DWORD 0
               u32 txulp0_uc_rel_data_rdy : 1;    // DWORD 0
               u32 txulp1_uc_rel_data_rdy : 1;    // DWORD 0
               u32 etx_uc_rel_data_rdy : 1;       // DWORD 0
               u32 erx_uc_rel_data_rdy : 1;       // DWORD 0
               u32 mpu_uc_rel_data_rdy : 1;       // DWORD 0
               u32 replacement_way_intm : 4;      // DWORD 0
               u32 valid_intm : 4;                // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_IPQRELRDYSTATUS_CSR, *PUC_IPQRELRDYSTATUS_CSR;

      SG_C_ASSERT(__sizeof__UC_IPQRELRDYSTATUS_CSR, sizeof (UC_IPQRELRDYSTATUS_CSR) == 4);

   #else
      typedef struct _UC_IPQRELRDYSTATUS_CSR {
         u32 rxulp0_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 rxulp1_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 rxulp2_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 txulp0_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 txulp1_uc_ipq_data_rdy : 1;          // DWORD 0
         u32 etx_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 erx_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 mpu_uc_ipq_data_rdy : 1;             // DWORD 0
         u32 prefifo_uc_ipq_data_rdy : 1;         // DWORD 0
         u32 trans0_data_rdy : 1;                 // DWORD 0
         u32 trans1_data_rdy : 1;                 // DWORD 0
         u32 trans2_data_rdy : 1;                 // DWORD 0
         u32 rxulp0_uc_rel_data_rdy : 1;          // DWORD 0
         u32 rxulp1_uc_rel_data_rdy : 1;          // DWORD 0
         u32 rxulp2_uc_rel_data_rdy : 1;          // DWORD 0
         u32 txulp0_uc_rel_data_rdy : 1;          // DWORD 0
         u32 txulp1_uc_rel_data_rdy : 1;          // DWORD 0
         u32 etx_uc_rel_data_rdy : 1;             // DWORD 0
         u32 erx_uc_rel_data_rdy : 1;             // DWORD 0
         u32 mpu_uc_rel_data_rdy : 1;             // DWORD 0
         u32 replacement_way_intm : 4;            // DWORD 0
         u32 valid_intm : 4;                      // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK UC_IPQRELRDYSTATUS_CSR, *PUC_IPQRELRDYSTATUS_CSR;

      typedef union _UC_IPQRELRDYSTATUS_CSR_UNION {
         UC_IPQRELRDYSTATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_IPQRELRDYSTATUS_CSR_UNION, *PUC_IPQRELRDYSTATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_IPQRELRDYSTATUS_CSR_UNION, sizeof (UC_IPQRELRDYSTATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Input Release Request Queues Full Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_IPQRELFULLSTATUS_CSR {
         union {
            struct { 
               u32 rsvd2 : 3;                     // DWORD 0
               u32 tms_rdma_throttle : 1;         // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 tms_wdma_throttle : 1;         // DWORD 0
               u32 uc_mpu_rel_data_full : 1;      // DWORD 0
               u32 uc_erx_rel_data_full : 1;      // DWORD 0
               u32 uc_etx_rel_data_full : 1;      // DWORD 0
               u32 uc_txulp1_rel_data_full : 1;   // DWORD 0
               u32 uc_txulp0_rel_data_full : 1;   // DWORD 0
               u32 uc_rxulp2_rel_data_full : 1;   // DWORD 0
               u32 uc_rxulp1_rel_data_full : 1;   // DWORD 0
               u32 uc_rxulp0_rel_data_full : 1;   // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 tms_ptc_throttle : 1;          // DWORD 0
               u32 trans2_data_full : 1;          // DWORD 0
               u32 trans1_data_full : 1;          // DWORD 0
               u32 trans0_data_full : 1;          // DWORD 0
               u32 uc_prefifo_ipq_data_full : 1;  // DWORD 0
               u32 uc_mpu_ipq_data_full : 1;      // DWORD 0
               u32 uc_erx_ipq_data_full : 1;      // DWORD 0
               u32 uc_etx_ipq_data_full : 1;      // DWORD 0
               u32 uc_txulp1_ipq_data_full : 1;   // DWORD 0
               u32 uc_txulp0_ipq_data_full : 1;   // DWORD 0
               u32 uc_rxulp2_ipq_data_full : 1;   // DWORD 0
               u32 uc_rxulp1_ipq_data_full : 1;   // DWORD 0
               u32 uc_rxulp0_ipq_data_full : 1;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_IPQRELFULLSTATUS_CSR, *PUC_IPQRELFULLSTATUS_CSR;

      SG_C_ASSERT(__sizeof__UC_IPQRELFULLSTATUS_CSR, sizeof (UC_IPQRELFULLSTATUS_CSR) == 4);

   #else
      typedef struct _UC_IPQRELFULLSTATUS_CSR {
         u32 rsvd2 : 3;                           // DWORD 0
         u32 tms_rdma_throttle : 1;               // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 tms_wdma_throttle : 1;               // DWORD 0
         u32 uc_mpu_rel_data_full : 1;            // DWORD 0
         u32 uc_erx_rel_data_full : 1;            // DWORD 0
         u32 uc_etx_rel_data_full : 1;            // DWORD 0
         u32 uc_txulp1_rel_data_full : 1;         // DWORD 0
         u32 uc_txulp0_rel_data_full : 1;         // DWORD 0
         u32 uc_rxulp2_rel_data_full : 1;         // DWORD 0
         u32 uc_rxulp1_rel_data_full : 1;         // DWORD 0
         u32 uc_rxulp0_rel_data_full : 1;         // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 tms_ptc_throttle : 1;                // DWORD 0
         u32 trans2_data_full : 1;                // DWORD 0
         u32 trans1_data_full : 1;                // DWORD 0
         u32 trans0_data_full : 1;                // DWORD 0
         u32 uc_prefifo_ipq_data_full : 1;        // DWORD 0
         u32 uc_mpu_ipq_data_full : 1;            // DWORD 0
         u32 uc_erx_ipq_data_full : 1;            // DWORD 0
         u32 uc_etx_ipq_data_full : 1;            // DWORD 0
         u32 uc_txulp1_ipq_data_full : 1;         // DWORD 0
         u32 uc_txulp0_ipq_data_full : 1;         // DWORD 0
         u32 uc_rxulp2_ipq_data_full : 1;         // DWORD 0
         u32 uc_rxulp1_ipq_data_full : 1;         // DWORD 0
         u32 uc_rxulp0_ipq_data_full : 1;         // DWORD 0
      } SG_PACK UC_IPQRELFULLSTATUS_CSR, *PUC_IPQRELFULLSTATUS_CSR;

      typedef union _UC_IPQRELFULLSTATUS_CSR_UNION {
         UC_IPQRELFULLSTATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_IPQRELFULLSTATUS_CSR_UNION, *PUC_IPQRELFULLSTATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_IPQRELFULLSTATUS_CSR_UNION, sizeof (UC_IPQRELFULLSTATUS_CSR_UNION) == 4);
   #endif


#else
   // Input Release Request Queues Full Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_IPQRELFULLSTATUS_CSR {
         union {
            struct { 
               u32 uc_rxulp0_ipq_data_full : 1;   // DWORD 0
               u32 uc_rxulp1_ipq_data_full : 1;   // DWORD 0
               u32 uc_rxulp2_ipq_data_full : 1;   // DWORD 0
               u32 uc_txulp0_ipq_data_full : 1;   // DWORD 0
               u32 uc_txulp1_ipq_data_full : 1;   // DWORD 0
               u32 uc_etx_ipq_data_full : 1;      // DWORD 0
               u32 uc_erx_ipq_data_full : 1;      // DWORD 0
               u32 uc_mpu_ipq_data_full : 1;      // DWORD 0
               u32 uc_prefifo_ipq_data_full : 1;  // DWORD 0
               u32 trans0_data_full : 1;          // DWORD 0
               u32 trans1_data_full : 1;          // DWORD 0
               u32 trans2_data_full : 1;          // DWORD 0
               u32 tms_ptc_throttle : 1;          // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 uc_rxulp0_rel_data_full : 1;   // DWORD 0
               u32 uc_rxulp1_rel_data_full : 1;   // DWORD 0
               u32 uc_rxulp2_rel_data_full : 1;   // DWORD 0
               u32 uc_txulp0_rel_data_full : 1;   // DWORD 0
               u32 uc_txulp1_rel_data_full : 1;   // DWORD 0
               u32 uc_etx_rel_data_full : 1;      // DWORD 0
               u32 uc_erx_rel_data_full : 1;      // DWORD 0
               u32 uc_mpu_rel_data_full : 1;      // DWORD 0
               u32 tms_wdma_throttle : 1;         // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 tms_rdma_throttle : 1;         // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_IPQRELFULLSTATUS_CSR, *PUC_IPQRELFULLSTATUS_CSR;

      SG_C_ASSERT(__sizeof__UC_IPQRELFULLSTATUS_CSR, sizeof (UC_IPQRELFULLSTATUS_CSR) == 4);

   #else
      typedef struct _UC_IPQRELFULLSTATUS_CSR {
         u32 uc_rxulp0_ipq_data_full : 1;         // DWORD 0
         u32 uc_rxulp1_ipq_data_full : 1;         // DWORD 0
         u32 uc_rxulp2_ipq_data_full : 1;         // DWORD 0
         u32 uc_txulp0_ipq_data_full : 1;         // DWORD 0
         u32 uc_txulp1_ipq_data_full : 1;         // DWORD 0
         u32 uc_etx_ipq_data_full : 1;            // DWORD 0
         u32 uc_erx_ipq_data_full : 1;            // DWORD 0
         u32 uc_mpu_ipq_data_full : 1;            // DWORD 0
         u32 uc_prefifo_ipq_data_full : 1;        // DWORD 0
         u32 trans0_data_full : 1;                // DWORD 0
         u32 trans1_data_full : 1;                // DWORD 0
         u32 trans2_data_full : 1;                // DWORD 0
         u32 tms_ptc_throttle : 1;                // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 uc_rxulp0_rel_data_full : 1;         // DWORD 0
         u32 uc_rxulp1_rel_data_full : 1;         // DWORD 0
         u32 uc_rxulp2_rel_data_full : 1;         // DWORD 0
         u32 uc_txulp0_rel_data_full : 1;         // DWORD 0
         u32 uc_txulp1_rel_data_full : 1;         // DWORD 0
         u32 uc_etx_rel_data_full : 1;            // DWORD 0
         u32 uc_erx_rel_data_full : 1;            // DWORD 0
         u32 uc_mpu_rel_data_full : 1;            // DWORD 0
         u32 tms_wdma_throttle : 1;               // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 tms_rdma_throttle : 1;               // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
      } SG_PACK UC_IPQRELFULLSTATUS_CSR, *PUC_IPQRELFULLSTATUS_CSR;

      typedef union _UC_IPQRELFULLSTATUS_CSR_UNION {
         UC_IPQRELFULLSTATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_IPQRELFULLSTATUS_CSR_UNION, *PUC_IPQRELFULLSTATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_IPQRELFULLSTATUS_CSR_UNION, sizeof (UC_IPQRELFULLSTATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Completion Queue Full Status Register. Each 'full' signal indicates completion
   // backpressure from a UC client. These signals are primary inputs to UC from its
   // clients. When asserted, UC cannot return transaction completions to the relevant
   // client. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CPQFULLSTATUS_CSR {
         union {
            struct { 
               u32 rsvd0 : 13;                    // DWORD 0
               u32 cev_uc_cpq_data_full : 1;      // DWORD 0
               u32 mpu_uc_cpq_data_full : 1;      // DWORD 0
               u32 erx_uc_cpq_data_full : 1;      // DWORD 0
               u32 etx_uc_cpq_data_full : 1;      // DWORD 0
               u32 txulp1_uc_cpq_data_full : 1;   // DWORD 0
               u32 txulp0_uc_cpq_data_full : 1;   // DWORD 0
               u32 rxulp2_uc_cpq_data_full : 1;   // DWORD 0
               u32 rxulp1_uc_cpq_data_full : 1;   // DWORD 0
               u32 rxulp0_uc_cpq_data_full : 1;   // DWORD 0
               u32 trans2_data_full : 1;          // DWORD 0
               u32 trans1_data_full : 1;          // DWORD 0
               u32 trans0_data_full : 1;          // DWORD 0
               u32 rdma_uc_idmc_data_full : 1;    // DWORD 0
               u32 wdma_uc_idmc_data_full : 1;    // DWORD 0
               u32 uc_rdma_cdmc_data_full : 1;    // DWORD 0
               u32 uc_wdma_cdmc_data_full : 1;    // DWORD 0
               u32 ptc_uc_ipq_data_full : 1;      // DWORD 0
               u32 uc_ptc_cpq_data_full : 1;      // DWORD 0
               u32 uc_inv_data_full : 1;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CPQFULLSTATUS_CSR, *PUC_CPQFULLSTATUS_CSR;

      SG_C_ASSERT(__sizeof__UC_CPQFULLSTATUS_CSR, sizeof (UC_CPQFULLSTATUS_CSR) == 4);

   #else
      typedef struct _UC_CPQFULLSTATUS_CSR {
         u32 rsvd0 : 13;                          // DWORD 0
         u32 cev_uc_cpq_data_full : 1;            // DWORD 0
         u32 mpu_uc_cpq_data_full : 1;            // DWORD 0
         u32 erx_uc_cpq_data_full : 1;            // DWORD 0
         u32 etx_uc_cpq_data_full : 1;            // DWORD 0
         u32 txulp1_uc_cpq_data_full : 1;         // DWORD 0
         u32 txulp0_uc_cpq_data_full : 1;         // DWORD 0
         u32 rxulp2_uc_cpq_data_full : 1;         // DWORD 0
         u32 rxulp1_uc_cpq_data_full : 1;         // DWORD 0
         u32 rxulp0_uc_cpq_data_full : 1;         // DWORD 0
         u32 trans2_data_full : 1;                // DWORD 0
         u32 trans1_data_full : 1;                // DWORD 0
         u32 trans0_data_full : 1;                // DWORD 0
         u32 rdma_uc_idmc_data_full : 1;          // DWORD 0
         u32 wdma_uc_idmc_data_full : 1;          // DWORD 0
         u32 uc_rdma_cdmc_data_full : 1;          // DWORD 0
         u32 uc_wdma_cdmc_data_full : 1;          // DWORD 0
         u32 ptc_uc_ipq_data_full : 1;            // DWORD 0
         u32 uc_ptc_cpq_data_full : 1;            // DWORD 0
         u32 uc_inv_data_full : 1;                // DWORD 0
      } SG_PACK UC_CPQFULLSTATUS_CSR, *PUC_CPQFULLSTATUS_CSR;

      typedef union _UC_CPQFULLSTATUS_CSR_UNION {
         UC_CPQFULLSTATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CPQFULLSTATUS_CSR_UNION, *PUC_CPQFULLSTATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CPQFULLSTATUS_CSR_UNION, sizeof (UC_CPQFULLSTATUS_CSR_UNION) == 4);
   #endif


#else
   // Completion Queue Full Status Register. Each 'full' signal indicates completion
   // backpressure from a UC client. These signals are primary inputs to UC from its
   // clients. When asserted, UC cannot return transaction completions to the relevant
   // client. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CPQFULLSTATUS_CSR {
         union {
            struct { 
               u32 uc_inv_data_full : 1;          // DWORD 0
               u32 uc_ptc_cpq_data_full : 1;      // DWORD 0
               u32 ptc_uc_ipq_data_full : 1;      // DWORD 0
               u32 uc_wdma_cdmc_data_full : 1;    // DWORD 0
               u32 uc_rdma_cdmc_data_full : 1;    // DWORD 0
               u32 wdma_uc_idmc_data_full : 1;    // DWORD 0
               u32 rdma_uc_idmc_data_full : 1;    // DWORD 0
               u32 trans0_data_full : 1;          // DWORD 0
               u32 trans1_data_full : 1;          // DWORD 0
               u32 trans2_data_full : 1;          // DWORD 0
               u32 rxulp0_uc_cpq_data_full : 1;   // DWORD 0
               u32 rxulp1_uc_cpq_data_full : 1;   // DWORD 0
               u32 rxulp2_uc_cpq_data_full : 1;   // DWORD 0
               u32 txulp0_uc_cpq_data_full : 1;   // DWORD 0
               u32 txulp1_uc_cpq_data_full : 1;   // DWORD 0
               u32 etx_uc_cpq_data_full : 1;      // DWORD 0
               u32 erx_uc_cpq_data_full : 1;      // DWORD 0
               u32 mpu_uc_cpq_data_full : 1;      // DWORD 0
               u32 cev_uc_cpq_data_full : 1;      // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CPQFULLSTATUS_CSR, *PUC_CPQFULLSTATUS_CSR;

      SG_C_ASSERT(__sizeof__UC_CPQFULLSTATUS_CSR, sizeof (UC_CPQFULLSTATUS_CSR) == 4);

   #else
      typedef struct _UC_CPQFULLSTATUS_CSR {
         u32 uc_inv_data_full : 1;                // DWORD 0
         u32 uc_ptc_cpq_data_full : 1;            // DWORD 0
         u32 ptc_uc_ipq_data_full : 1;            // DWORD 0
         u32 uc_wdma_cdmc_data_full : 1;          // DWORD 0
         u32 uc_rdma_cdmc_data_full : 1;          // DWORD 0
         u32 wdma_uc_idmc_data_full : 1;          // DWORD 0
         u32 rdma_uc_idmc_data_full : 1;          // DWORD 0
         u32 trans0_data_full : 1;                // DWORD 0
         u32 trans1_data_full : 1;                // DWORD 0
         u32 trans2_data_full : 1;                // DWORD 0
         u32 rxulp0_uc_cpq_data_full : 1;         // DWORD 0
         u32 rxulp1_uc_cpq_data_full : 1;         // DWORD 0
         u32 rxulp2_uc_cpq_data_full : 1;         // DWORD 0
         u32 txulp0_uc_cpq_data_full : 1;         // DWORD 0
         u32 txulp1_uc_cpq_data_full : 1;         // DWORD 0
         u32 etx_uc_cpq_data_full : 1;            // DWORD 0
         u32 erx_uc_cpq_data_full : 1;            // DWORD 0
         u32 mpu_uc_cpq_data_full : 1;            // DWORD 0
         u32 cev_uc_cpq_data_full : 1;            // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
      } SG_PACK UC_CPQFULLSTATUS_CSR, *PUC_CPQFULLSTATUS_CSR;

      typedef union _UC_CPQFULLSTATUS_CSR_UNION {
         UC_CPQFULLSTATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CPQFULLSTATUS_CSR_UNION, *PUC_CPQFULLSTATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CPQFULLSTATUS_CSR_UNION, sizeof (UC_CPQFULLSTATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CEV_REQ_COUNT_CSR {
         union {
            struct { 
               u32 cev_imm_req_count : 8;         // DWORD 0
               u32 cev_inv_req_count : 8;         // DWORD 0
               u32 cev_acc_minus_req_count : 8;   // DWORD 0
               u32 cev_acc_plus_req_count : 8;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CEV_REQ_COUNT_CSR, *PUC_CEV_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_CEV_REQ_COUNT_CSR, sizeof (UC_CEV_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_CEV_REQ_COUNT_CSR {
         u32 cev_imm_req_count : 8;               // DWORD 0
         u32 cev_inv_req_count : 8;               // DWORD 0
         u32 cev_acc_minus_req_count : 8;         // DWORD 0
         u32 cev_acc_plus_req_count : 8;          // DWORD 0
      } SG_PACK UC_CEV_REQ_COUNT_CSR, *PUC_CEV_REQ_COUNT_CSR;

      typedef union _UC_CEV_REQ_COUNT_CSR_UNION {
         UC_CEV_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CEV_REQ_COUNT_CSR_UNION, *PUC_CEV_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CEV_REQ_COUNT_CSR_UNION, sizeof (UC_CEV_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // CEV Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CEV_REQ_COUNT_CSR {
         union {
            struct { 
               u32 cev_acc_plus_req_count : 8;    // DWORD 0
               u32 cev_acc_minus_req_count : 8;   // DWORD 0
               u32 cev_inv_req_count : 8;         // DWORD 0
               u32 cev_imm_req_count : 8;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CEV_REQ_COUNT_CSR, *PUC_CEV_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_CEV_REQ_COUNT_CSR, sizeof (UC_CEV_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_CEV_REQ_COUNT_CSR {
         u32 cev_acc_plus_req_count : 8;          // DWORD 0
         u32 cev_acc_minus_req_count : 8;         // DWORD 0
         u32 cev_inv_req_count : 8;               // DWORD 0
         u32 cev_imm_req_count : 8;               // DWORD 0
      } SG_PACK UC_CEV_REQ_COUNT_CSR, *PUC_CEV_REQ_COUNT_CSR;

      typedef union _UC_CEV_REQ_COUNT_CSR_UNION {
         UC_CEV_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CEV_REQ_COUNT_CSR_UNION, *PUC_CEV_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CEV_REQ_COUNT_CSR_UNION, sizeof (UC_CEV_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CEV_RESP_COUNT_CSR {
         union {
            struct { 
               u32 cev_imm_resp_count : 8;        // DWORD 0
               u32 cev_inv_resp_count : 8;        // DWORD 0
               u32 cev_acc_minus_resp_count : 8;  // DWORD 0
               u32 cev_acc_plus_resp_count : 8;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CEV_RESP_COUNT_CSR, *PUC_CEV_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_CEV_RESP_COUNT_CSR, sizeof (UC_CEV_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_CEV_RESP_COUNT_CSR {
         u32 cev_imm_resp_count : 8;              // DWORD 0
         u32 cev_inv_resp_count : 8;              // DWORD 0
         u32 cev_acc_minus_resp_count : 8;        // DWORD 0
         u32 cev_acc_plus_resp_count : 8;         // DWORD 0
      } SG_PACK UC_CEV_RESP_COUNT_CSR, *PUC_CEV_RESP_COUNT_CSR;

      typedef union _UC_CEV_RESP_COUNT_CSR_UNION {
         UC_CEV_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CEV_RESP_COUNT_CSR_UNION, *PUC_CEV_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CEV_RESP_COUNT_CSR_UNION, sizeof (UC_CEV_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // CEV Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CEV_RESP_COUNT_CSR {
         union {
            struct { 
               u32 cev_acc_plus_resp_count : 8;   // DWORD 0
               u32 cev_acc_minus_resp_count : 8;  // DWORD 0
               u32 cev_inv_resp_count : 8;        // DWORD 0
               u32 cev_imm_resp_count : 8;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CEV_RESP_COUNT_CSR, *PUC_CEV_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_CEV_RESP_COUNT_CSR, sizeof (UC_CEV_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_CEV_RESP_COUNT_CSR {
         u32 cev_acc_plus_resp_count : 8;         // DWORD 0
         u32 cev_acc_minus_resp_count : 8;        // DWORD 0
         u32 cev_inv_resp_count : 8;              // DWORD 0
         u32 cev_imm_resp_count : 8;              // DWORD 0
      } SG_PACK UC_CEV_RESP_COUNT_CSR, *PUC_CEV_RESP_COUNT_CSR;

      typedef union _UC_CEV_RESP_COUNT_CSR_UNION {
         UC_CEV_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CEV_RESP_COUNT_CSR_UNION, *PUC_CEV_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CEV_RESP_COUNT_CSR_UNION, sizeof (UC_CEV_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_ERX_REQ_COUNT_CSR {
         union {
            struct { 
               u32 erx_imm_req_count : 8;         // DWORD 0
               u32 erx_inv_req_count : 8;         // DWORD 0
               u32 erx_acc_minus_req_count : 8;   // DWORD 0
               u32 erx_acc_plus_req_count : 8;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_ERX_REQ_COUNT_CSR, *PUC_ERX_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_ERX_REQ_COUNT_CSR, sizeof (UC_ERX_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_ERX_REQ_COUNT_CSR {
         u32 erx_imm_req_count : 8;               // DWORD 0
         u32 erx_inv_req_count : 8;               // DWORD 0
         u32 erx_acc_minus_req_count : 8;         // DWORD 0
         u32 erx_acc_plus_req_count : 8;          // DWORD 0
      } SG_PACK UC_ERX_REQ_COUNT_CSR, *PUC_ERX_REQ_COUNT_CSR;

      typedef union _UC_ERX_REQ_COUNT_CSR_UNION {
         UC_ERX_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_ERX_REQ_COUNT_CSR_UNION, *PUC_ERX_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_ERX_REQ_COUNT_CSR_UNION, sizeof (UC_ERX_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // ERX Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_ERX_REQ_COUNT_CSR {
         union {
            struct { 
               u32 erx_acc_plus_req_count : 8;    // DWORD 0
               u32 erx_acc_minus_req_count : 8;   // DWORD 0
               u32 erx_inv_req_count : 8;         // DWORD 0
               u32 erx_imm_req_count : 8;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_ERX_REQ_COUNT_CSR, *PUC_ERX_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_ERX_REQ_COUNT_CSR, sizeof (UC_ERX_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_ERX_REQ_COUNT_CSR {
         u32 erx_acc_plus_req_count : 8;          // DWORD 0
         u32 erx_acc_minus_req_count : 8;         // DWORD 0
         u32 erx_inv_req_count : 8;               // DWORD 0
         u32 erx_imm_req_count : 8;               // DWORD 0
      } SG_PACK UC_ERX_REQ_COUNT_CSR, *PUC_ERX_REQ_COUNT_CSR;

      typedef union _UC_ERX_REQ_COUNT_CSR_UNION {
         UC_ERX_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_ERX_REQ_COUNT_CSR_UNION, *PUC_ERX_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_ERX_REQ_COUNT_CSR_UNION, sizeof (UC_ERX_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ERX Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_ERX_RESP_COUNT_CSR {
         union {
            struct { 
               u32 erx_imm_resp_count : 8;        // DWORD 0
               u32 erx_inv_resp_count : 8;        // DWORD 0
               u32 erx_acc_minus_resp_count : 8;  // DWORD 0
               u32 erx_acc_plus_resp_count : 8;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_ERX_RESP_COUNT_CSR, *PUC_ERX_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_ERX_RESP_COUNT_CSR, sizeof (UC_ERX_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_ERX_RESP_COUNT_CSR {
         u32 erx_imm_resp_count : 8;              // DWORD 0
         u32 erx_inv_resp_count : 8;              // DWORD 0
         u32 erx_acc_minus_resp_count : 8;        // DWORD 0
         u32 erx_acc_plus_resp_count : 8;         // DWORD 0
      } SG_PACK UC_ERX_RESP_COUNT_CSR, *PUC_ERX_RESP_COUNT_CSR;

      typedef union _UC_ERX_RESP_COUNT_CSR_UNION {
         UC_ERX_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_ERX_RESP_COUNT_CSR_UNION, *PUC_ERX_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_ERX_RESP_COUNT_CSR_UNION, sizeof (UC_ERX_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // ERX Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_ERX_RESP_COUNT_CSR {
         union {
            struct { 
               u32 erx_acc_plus_resp_count : 8;   // DWORD 0
               u32 erx_acc_minus_resp_count : 8;  // DWORD 0
               u32 erx_inv_resp_count : 8;        // DWORD 0
               u32 erx_imm_resp_count : 8;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_ERX_RESP_COUNT_CSR, *PUC_ERX_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_ERX_RESP_COUNT_CSR, sizeof (UC_ERX_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_ERX_RESP_COUNT_CSR {
         u32 erx_acc_plus_resp_count : 8;         // DWORD 0
         u32 erx_acc_minus_resp_count : 8;        // DWORD 0
         u32 erx_inv_resp_count : 8;              // DWORD 0
         u32 erx_imm_resp_count : 8;              // DWORD 0
      } SG_PACK UC_ERX_RESP_COUNT_CSR, *PUC_ERX_RESP_COUNT_CSR;

      typedef union _UC_ERX_RESP_COUNT_CSR_UNION {
         UC_ERX_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_ERX_RESP_COUNT_CSR_UNION, *PUC_ERX_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_ERX_RESP_COUNT_CSR_UNION, sizeof (UC_ERX_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Request Count Register. This is a debug register, counting Release requests
   // from WDMA to UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_WDMA_REQ_COUNT_CSR {
         union {
            struct { 
               u32 wdma_acc_minus_req_count;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_WDMA_REQ_COUNT_CSR, *PUC_WDMA_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_WDMA_REQ_COUNT_CSR, sizeof (UC_WDMA_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_WDMA_REQ_COUNT_CSR {
         u32 wdma_acc_minus_req_count;            // DWORD 0
      } SG_PACK UC_WDMA_REQ_COUNT_CSR, *PUC_WDMA_REQ_COUNT_CSR;

      typedef union _UC_WDMA_REQ_COUNT_CSR_UNION {
         UC_WDMA_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_WDMA_REQ_COUNT_CSR_UNION, *PUC_WDMA_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_WDMA_REQ_COUNT_CSR_UNION, sizeof (UC_WDMA_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Request Count Register. This is a debug register, counting Release requests
   // from WDMA to UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_WDMA_REQ_COUNT_CSR {
         union {
            struct { 
               u32 wdma_acc_minus_req_count;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_WDMA_REQ_COUNT_CSR, *PUC_WDMA_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_WDMA_REQ_COUNT_CSR, sizeof (UC_WDMA_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_WDMA_REQ_COUNT_CSR {
         u32 wdma_acc_minus_req_count;            // DWORD 0
      } SG_PACK UC_WDMA_REQ_COUNT_CSR, *PUC_WDMA_REQ_COUNT_CSR;

      typedef union _UC_WDMA_REQ_COUNT_CSR_UNION {
         UC_WDMA_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_WDMA_REQ_COUNT_CSR_UNION, *PUC_WDMA_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_WDMA_REQ_COUNT_CSR_UNION, sizeof (UC_WDMA_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RDMA Request Count Register. This is a debug register, counting Release requests
   // from RDMA to UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RDMA_REQ_COUNT_CSR {
         union {
            struct { 
               u32 rdma_acc_minus_req_count;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RDMA_REQ_COUNT_CSR, *PUC_RDMA_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RDMA_REQ_COUNT_CSR, sizeof (UC_RDMA_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RDMA_REQ_COUNT_CSR {
         u32 rdma_acc_minus_req_count;            // DWORD 0
      } SG_PACK UC_RDMA_REQ_COUNT_CSR, *PUC_RDMA_REQ_COUNT_CSR;

      typedef union _UC_RDMA_REQ_COUNT_CSR_UNION {
         UC_RDMA_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RDMA_REQ_COUNT_CSR_UNION, *PUC_RDMA_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RDMA_REQ_COUNT_CSR_UNION, sizeof (UC_RDMA_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // RDMA Request Count Register. This is a debug register, counting Release requests
   // from RDMA to UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RDMA_REQ_COUNT_CSR {
         union {
            struct { 
               u32 rdma_acc_minus_req_count;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RDMA_REQ_COUNT_CSR, *PUC_RDMA_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RDMA_REQ_COUNT_CSR, sizeof (UC_RDMA_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RDMA_REQ_COUNT_CSR {
         u32 rdma_acc_minus_req_count;            // DWORD 0
      } SG_PACK UC_RDMA_REQ_COUNT_CSR, *PUC_RDMA_REQ_COUNT_CSR;

      typedef union _UC_RDMA_REQ_COUNT_CSR_UNION {
         UC_RDMA_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RDMA_REQ_COUNT_CSR_UNION, *PUC_RDMA_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RDMA_REQ_COUNT_CSR_UNION, sizeof (UC_RDMA_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXULP0 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP0_REQ_COUNT_CSR {
         union {
            struct { 
               u32 rxulp0_imm_req_count : 8;      // DWORD 0
               u32 rxulp0_inv_req_count : 8;      // DWORD 0
               u32 rxulp0_acc_minus_req_count : 8; // DWORD 0
               u32 rxulp0_acc_plus_req_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP0_REQ_COUNT_CSR, *PUC_RXULP0_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP0_REQ_COUNT_CSR, sizeof (UC_RXULP0_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP0_REQ_COUNT_CSR {
         u32 rxulp0_imm_req_count : 8;            // DWORD 0
         u32 rxulp0_inv_req_count : 8;            // DWORD 0
         u32 rxulp0_acc_minus_req_count : 8;      // DWORD 0
         u32 rxulp0_acc_plus_req_count : 8;       // DWORD 0
      } SG_PACK UC_RXULP0_REQ_COUNT_CSR, *PUC_RXULP0_REQ_COUNT_CSR;

      typedef union _UC_RXULP0_REQ_COUNT_CSR_UNION {
         UC_RXULP0_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP0_REQ_COUNT_CSR_UNION, *PUC_RXULP0_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP0_REQ_COUNT_CSR_UNION, sizeof (UC_RXULP0_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // RXULP0 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP0_REQ_COUNT_CSR {
         union {
            struct { 
               u32 rxulp0_acc_plus_req_count : 8; // DWORD 0
               u32 rxulp0_acc_minus_req_count : 8; // DWORD 0
               u32 rxulp0_inv_req_count : 8;      // DWORD 0
               u32 rxulp0_imm_req_count : 8;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP0_REQ_COUNT_CSR, *PUC_RXULP0_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP0_REQ_COUNT_CSR, sizeof (UC_RXULP0_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP0_REQ_COUNT_CSR {
         u32 rxulp0_acc_plus_req_count : 8;       // DWORD 0
         u32 rxulp0_acc_minus_req_count : 8;      // DWORD 0
         u32 rxulp0_inv_req_count : 8;            // DWORD 0
         u32 rxulp0_imm_req_count : 8;            // DWORD 0
      } SG_PACK UC_RXULP0_REQ_COUNT_CSR, *PUC_RXULP0_REQ_COUNT_CSR;

      typedef union _UC_RXULP0_REQ_COUNT_CSR_UNION {
         UC_RXULP0_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP0_REQ_COUNT_CSR_UNION, *PUC_RXULP0_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP0_REQ_COUNT_CSR_UNION, sizeof (UC_RXULP0_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXULP0 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP0_RESP_COUNT_CSR {
         union {
            struct { 
               u32 rxulp0_imm_resp_count : 8;     // DWORD 0
               u32 rxulp0_inv_resp_count : 8;     // DWORD 0
               u32 rxulp0_acc_minus_resp_count : 8; // DWORD 0
               u32 rxulp0_acc_plus_resp_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP0_RESP_COUNT_CSR, *PUC_RXULP0_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP0_RESP_COUNT_CSR, sizeof (UC_RXULP0_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP0_RESP_COUNT_CSR {
         u32 rxulp0_imm_resp_count : 8;           // DWORD 0
         u32 rxulp0_inv_resp_count : 8;           // DWORD 0
         u32 rxulp0_acc_minus_resp_count : 8;     // DWORD 0
         u32 rxulp0_acc_plus_resp_count : 8;      // DWORD 0
      } SG_PACK UC_RXULP0_RESP_COUNT_CSR, *PUC_RXULP0_RESP_COUNT_CSR;

      typedef union _UC_RXULP0_RESP_COUNT_CSR_UNION {
         UC_RXULP0_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP0_RESP_COUNT_CSR_UNION, *PUC_RXULP0_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP0_RESP_COUNT_CSR_UNION, sizeof (UC_RXULP0_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // RXULP0 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP0_RESP_COUNT_CSR {
         union {
            struct { 
               u32 rxulp0_acc_plus_resp_count : 8; // DWORD 0
               u32 rxulp0_acc_minus_resp_count : 8; // DWORD 0
               u32 rxulp0_inv_resp_count : 8;     // DWORD 0
               u32 rxulp0_imm_resp_count : 8;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP0_RESP_COUNT_CSR, *PUC_RXULP0_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP0_RESP_COUNT_CSR, sizeof (UC_RXULP0_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP0_RESP_COUNT_CSR {
         u32 rxulp0_acc_plus_resp_count : 8;      // DWORD 0
         u32 rxulp0_acc_minus_resp_count : 8;     // DWORD 0
         u32 rxulp0_inv_resp_count : 8;           // DWORD 0
         u32 rxulp0_imm_resp_count : 8;           // DWORD 0
      } SG_PACK UC_RXULP0_RESP_COUNT_CSR, *PUC_RXULP0_RESP_COUNT_CSR;

      typedef union _UC_RXULP0_RESP_COUNT_CSR_UNION {
         UC_RXULP0_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP0_RESP_COUNT_CSR_UNION, *PUC_RXULP0_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP0_RESP_COUNT_CSR_UNION, sizeof (UC_RXULP0_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXULP1 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP1_REQ_COUNT_CSR {
         union {
            struct { 
               u32 rxulp1_imm_req_count : 8;      // DWORD 0
               u32 rxulp1_inv_req_count : 8;      // DWORD 0
               u32 rxulp1_acc_minus_req_count : 8; // DWORD 0
               u32 rxulp1_acc_plus_req_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP1_REQ_COUNT_CSR, *PUC_RXULP1_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP1_REQ_COUNT_CSR, sizeof (UC_RXULP1_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP1_REQ_COUNT_CSR {
         u32 rxulp1_imm_req_count : 8;            // DWORD 0
         u32 rxulp1_inv_req_count : 8;            // DWORD 0
         u32 rxulp1_acc_minus_req_count : 8;      // DWORD 0
         u32 rxulp1_acc_plus_req_count : 8;       // DWORD 0
      } SG_PACK UC_RXULP1_REQ_COUNT_CSR, *PUC_RXULP1_REQ_COUNT_CSR;

      typedef union _UC_RXULP1_REQ_COUNT_CSR_UNION {
         UC_RXULP1_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP1_REQ_COUNT_CSR_UNION, *PUC_RXULP1_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP1_REQ_COUNT_CSR_UNION, sizeof (UC_RXULP1_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // RXULP1 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP1_REQ_COUNT_CSR {
         union {
            struct { 
               u32 rxulp1_acc_plus_req_count : 8; // DWORD 0
               u32 rxulp1_acc_minus_req_count : 8; // DWORD 0
               u32 rxulp1_inv_req_count : 8;      // DWORD 0
               u32 rxulp1_imm_req_count : 8;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP1_REQ_COUNT_CSR, *PUC_RXULP1_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP1_REQ_COUNT_CSR, sizeof (UC_RXULP1_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP1_REQ_COUNT_CSR {
         u32 rxulp1_acc_plus_req_count : 8;       // DWORD 0
         u32 rxulp1_acc_minus_req_count : 8;      // DWORD 0
         u32 rxulp1_inv_req_count : 8;            // DWORD 0
         u32 rxulp1_imm_req_count : 8;            // DWORD 0
      } SG_PACK UC_RXULP1_REQ_COUNT_CSR, *PUC_RXULP1_REQ_COUNT_CSR;

      typedef union _UC_RXULP1_REQ_COUNT_CSR_UNION {
         UC_RXULP1_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP1_REQ_COUNT_CSR_UNION, *PUC_RXULP1_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP1_REQ_COUNT_CSR_UNION, sizeof (UC_RXULP1_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXULP1 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP1_RESP_COUNT_CSR {
         union {
            struct { 
               u32 rxulp1_imm_resp_count : 8;     // DWORD 0
               u32 rxulp1_inv_resp_count : 8;     // DWORD 0
               u32 rxulp1_acc_minus_resp_count : 8; // DWORD 0
               u32 rxulp1_acc_plus_resp_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP1_RESP_COUNT_CSR, *PUC_RXULP1_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP1_RESP_COUNT_CSR, sizeof (UC_RXULP1_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP1_RESP_COUNT_CSR {
         u32 rxulp1_imm_resp_count : 8;           // DWORD 0
         u32 rxulp1_inv_resp_count : 8;           // DWORD 0
         u32 rxulp1_acc_minus_resp_count : 8;     // DWORD 0
         u32 rxulp1_acc_plus_resp_count : 8;      // DWORD 0
      } SG_PACK UC_RXULP1_RESP_COUNT_CSR, *PUC_RXULP1_RESP_COUNT_CSR;

      typedef union _UC_RXULP1_RESP_COUNT_CSR_UNION {
         UC_RXULP1_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP1_RESP_COUNT_CSR_UNION, *PUC_RXULP1_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP1_RESP_COUNT_CSR_UNION, sizeof (UC_RXULP1_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // RXULP1 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP1_RESP_COUNT_CSR {
         union {
            struct { 
               u32 rxulp1_acc_plus_resp_count : 8; // DWORD 0
               u32 rxulp1_acc_minus_resp_count : 8; // DWORD 0
               u32 rxulp1_inv_resp_count : 8;     // DWORD 0
               u32 rxulp1_imm_resp_count : 8;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP1_RESP_COUNT_CSR, *PUC_RXULP1_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP1_RESP_COUNT_CSR, sizeof (UC_RXULP1_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP1_RESP_COUNT_CSR {
         u32 rxulp1_acc_plus_resp_count : 8;      // DWORD 0
         u32 rxulp1_acc_minus_resp_count : 8;     // DWORD 0
         u32 rxulp1_inv_resp_count : 8;           // DWORD 0
         u32 rxulp1_imm_resp_count : 8;           // DWORD 0
      } SG_PACK UC_RXULP1_RESP_COUNT_CSR, *PUC_RXULP1_RESP_COUNT_CSR;

      typedef union _UC_RXULP1_RESP_COUNT_CSR_UNION {
         UC_RXULP1_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP1_RESP_COUNT_CSR_UNION, *PUC_RXULP1_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP1_RESP_COUNT_CSR_UNION, sizeof (UC_RXULP1_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXULP2 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP2_REQ_COUNT_CSR {
         union {
            struct { 
               u32 rxulp2_imm_req_count : 8;      // DWORD 0
               u32 rxulp2_inv_req_count : 8;      // DWORD 0
               u32 rxulp2_acc_minus_req_count : 8; // DWORD 0
               u32 rxulp2_acc_plus_req_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP2_REQ_COUNT_CSR, *PUC_RXULP2_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP2_REQ_COUNT_CSR, sizeof (UC_RXULP2_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP2_REQ_COUNT_CSR {
         u32 rxulp2_imm_req_count : 8;            // DWORD 0
         u32 rxulp2_inv_req_count : 8;            // DWORD 0
         u32 rxulp2_acc_minus_req_count : 8;      // DWORD 0
         u32 rxulp2_acc_plus_req_count : 8;       // DWORD 0
      } SG_PACK UC_RXULP2_REQ_COUNT_CSR, *PUC_RXULP2_REQ_COUNT_CSR;

      typedef union _UC_RXULP2_REQ_COUNT_CSR_UNION {
         UC_RXULP2_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP2_REQ_COUNT_CSR_UNION, *PUC_RXULP2_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP2_REQ_COUNT_CSR_UNION, sizeof (UC_RXULP2_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // RXULP2 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP2_REQ_COUNT_CSR {
         union {
            struct { 
               u32 rxulp2_acc_plus_req_count : 8; // DWORD 0
               u32 rxulp2_acc_minus_req_count : 8; // DWORD 0
               u32 rxulp2_inv_req_count : 8;      // DWORD 0
               u32 rxulp2_imm_req_count : 8;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP2_REQ_COUNT_CSR, *PUC_RXULP2_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP2_REQ_COUNT_CSR, sizeof (UC_RXULP2_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP2_REQ_COUNT_CSR {
         u32 rxulp2_acc_plus_req_count : 8;       // DWORD 0
         u32 rxulp2_acc_minus_req_count : 8;      // DWORD 0
         u32 rxulp2_inv_req_count : 8;            // DWORD 0
         u32 rxulp2_imm_req_count : 8;            // DWORD 0
      } SG_PACK UC_RXULP2_REQ_COUNT_CSR, *PUC_RXULP2_REQ_COUNT_CSR;

      typedef union _UC_RXULP2_REQ_COUNT_CSR_UNION {
         UC_RXULP2_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP2_REQ_COUNT_CSR_UNION, *PUC_RXULP2_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP2_REQ_COUNT_CSR_UNION, sizeof (UC_RXULP2_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RXULP2 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP2_RESP_COUNT_CSR {
         union {
            struct { 
               u32 rxulp2_imm_resp_count : 8;     // DWORD 0
               u32 rxulp2_inv_resp_count : 8;     // DWORD 0
               u32 rxulp2_acc_minus_resp_count : 8; // DWORD 0
               u32 rxulp2_acc_plus_resp_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP2_RESP_COUNT_CSR, *PUC_RXULP2_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP2_RESP_COUNT_CSR, sizeof (UC_RXULP2_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP2_RESP_COUNT_CSR {
         u32 rxulp2_imm_resp_count : 8;           // DWORD 0
         u32 rxulp2_inv_resp_count : 8;           // DWORD 0
         u32 rxulp2_acc_minus_resp_count : 8;     // DWORD 0
         u32 rxulp2_acc_plus_resp_count : 8;      // DWORD 0
      } SG_PACK UC_RXULP2_RESP_COUNT_CSR, *PUC_RXULP2_RESP_COUNT_CSR;

      typedef union _UC_RXULP2_RESP_COUNT_CSR_UNION {
         UC_RXULP2_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP2_RESP_COUNT_CSR_UNION, *PUC_RXULP2_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP2_RESP_COUNT_CSR_UNION, sizeof (UC_RXULP2_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // RXULP2 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RXULP2_RESP_COUNT_CSR {
         union {
            struct { 
               u32 rxulp2_acc_plus_resp_count : 8; // DWORD 0
               u32 rxulp2_acc_minus_resp_count : 8; // DWORD 0
               u32 rxulp2_inv_resp_count : 8;     // DWORD 0
               u32 rxulp2_imm_resp_count : 8;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RXULP2_RESP_COUNT_CSR, *PUC_RXULP2_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RXULP2_RESP_COUNT_CSR, sizeof (UC_RXULP2_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RXULP2_RESP_COUNT_CSR {
         u32 rxulp2_acc_plus_resp_count : 8;      // DWORD 0
         u32 rxulp2_acc_minus_resp_count : 8;     // DWORD 0
         u32 rxulp2_inv_resp_count : 8;           // DWORD 0
         u32 rxulp2_imm_resp_count : 8;           // DWORD 0
      } SG_PACK UC_RXULP2_RESP_COUNT_CSR, *PUC_RXULP2_RESP_COUNT_CSR;

      typedef union _UC_RXULP2_RESP_COUNT_CSR_UNION {
         UC_RXULP2_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RXULP2_RESP_COUNT_CSR_UNION, *PUC_RXULP2_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RXULP2_RESP_COUNT_CSR_UNION, sizeof (UC_RXULP2_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXULP0 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP0_REQ_COUNT_CSR {
         union {
            struct { 
               u32 txulp0_imm_req_count : 8;      // DWORD 0
               u32 txulp0_inv_req_count : 8;      // DWORD 0
               u32 txulp0_acc_minus_req_count : 8; // DWORD 0
               u32 txulp0_acc_plus_req_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP0_REQ_COUNT_CSR, *PUC_TXULP0_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP0_REQ_COUNT_CSR, sizeof (UC_TXULP0_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP0_REQ_COUNT_CSR {
         u32 txulp0_imm_req_count : 8;            // DWORD 0
         u32 txulp0_inv_req_count : 8;            // DWORD 0
         u32 txulp0_acc_minus_req_count : 8;      // DWORD 0
         u32 txulp0_acc_plus_req_count : 8;       // DWORD 0
      } SG_PACK UC_TXULP0_REQ_COUNT_CSR, *PUC_TXULP0_REQ_COUNT_CSR;

      typedef union _UC_TXULP0_REQ_COUNT_CSR_UNION {
         UC_TXULP0_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP0_REQ_COUNT_CSR_UNION, *PUC_TXULP0_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP0_REQ_COUNT_CSR_UNION, sizeof (UC_TXULP0_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // TXULP0 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP0_REQ_COUNT_CSR {
         union {
            struct { 
               u32 txulp0_acc_plus_req_count : 8; // DWORD 0
               u32 txulp0_acc_minus_req_count : 8; // DWORD 0
               u32 txulp0_inv_req_count : 8;      // DWORD 0
               u32 txulp0_imm_req_count : 8;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP0_REQ_COUNT_CSR, *PUC_TXULP0_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP0_REQ_COUNT_CSR, sizeof (UC_TXULP0_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP0_REQ_COUNT_CSR {
         u32 txulp0_acc_plus_req_count : 8;       // DWORD 0
         u32 txulp0_acc_minus_req_count : 8;      // DWORD 0
         u32 txulp0_inv_req_count : 8;            // DWORD 0
         u32 txulp0_imm_req_count : 8;            // DWORD 0
      } SG_PACK UC_TXULP0_REQ_COUNT_CSR, *PUC_TXULP0_REQ_COUNT_CSR;

      typedef union _UC_TXULP0_REQ_COUNT_CSR_UNION {
         UC_TXULP0_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP0_REQ_COUNT_CSR_UNION, *PUC_TXULP0_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP0_REQ_COUNT_CSR_UNION, sizeof (UC_TXULP0_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXULP0 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP0_RESP_COUNT_CSR {
         union {
            struct { 
               u32 txulp0_imm_resp_count : 8;     // DWORD 0
               u32 txulp0_inv_resp_count : 8;     // DWORD 0
               u32 txulp0_acc_minus_resp_count : 8; // DWORD 0
               u32 txulp0_acc_plus_resp_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP0_RESP_COUNT_CSR, *PUC_TXULP0_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP0_RESP_COUNT_CSR, sizeof (UC_TXULP0_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP0_RESP_COUNT_CSR {
         u32 txulp0_imm_resp_count : 8;           // DWORD 0
         u32 txulp0_inv_resp_count : 8;           // DWORD 0
         u32 txulp0_acc_minus_resp_count : 8;     // DWORD 0
         u32 txulp0_acc_plus_resp_count : 8;      // DWORD 0
      } SG_PACK UC_TXULP0_RESP_COUNT_CSR, *PUC_TXULP0_RESP_COUNT_CSR;

      typedef union _UC_TXULP0_RESP_COUNT_CSR_UNION {
         UC_TXULP0_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP0_RESP_COUNT_CSR_UNION, *PUC_TXULP0_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP0_RESP_COUNT_CSR_UNION, sizeof (UC_TXULP0_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // TXULP0 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP0_RESP_COUNT_CSR {
         union {
            struct { 
               u32 txulp0_acc_plus_resp_count : 8; // DWORD 0
               u32 txulp0_acc_minus_resp_count : 8; // DWORD 0
               u32 txulp0_inv_resp_count : 8;     // DWORD 0
               u32 txulp0_imm_resp_count : 8;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP0_RESP_COUNT_CSR, *PUC_TXULP0_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP0_RESP_COUNT_CSR, sizeof (UC_TXULP0_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP0_RESP_COUNT_CSR {
         u32 txulp0_acc_plus_resp_count : 8;      // DWORD 0
         u32 txulp0_acc_minus_resp_count : 8;     // DWORD 0
         u32 txulp0_inv_resp_count : 8;           // DWORD 0
         u32 txulp0_imm_resp_count : 8;           // DWORD 0
      } SG_PACK UC_TXULP0_RESP_COUNT_CSR, *PUC_TXULP0_RESP_COUNT_CSR;

      typedef union _UC_TXULP0_RESP_COUNT_CSR_UNION {
         UC_TXULP0_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP0_RESP_COUNT_CSR_UNION, *PUC_TXULP0_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP0_RESP_COUNT_CSR_UNION, sizeof (UC_TXULP0_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXULP1 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP1_REQ_COUNT_CSR {
         union {
            struct { 
               u32 txulp1_imm_req_count : 8;      // DWORD 0
               u32 txulp1_inv_req_count : 8;      // DWORD 0
               u32 txulp1_acc_minus_req_count : 8; // DWORD 0
               u32 txulp1_acc_plus_req_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP1_REQ_COUNT_CSR, *PUC_TXULP1_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP1_REQ_COUNT_CSR, sizeof (UC_TXULP1_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP1_REQ_COUNT_CSR {
         u32 txulp1_imm_req_count : 8;            // DWORD 0
         u32 txulp1_inv_req_count : 8;            // DWORD 0
         u32 txulp1_acc_minus_req_count : 8;      // DWORD 0
         u32 txulp1_acc_plus_req_count : 8;       // DWORD 0
      } SG_PACK UC_TXULP1_REQ_COUNT_CSR, *PUC_TXULP1_REQ_COUNT_CSR;

      typedef union _UC_TXULP1_REQ_COUNT_CSR_UNION {
         UC_TXULP1_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP1_REQ_COUNT_CSR_UNION, *PUC_TXULP1_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP1_REQ_COUNT_CSR_UNION, sizeof (UC_TXULP1_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // TXULP1 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP1_REQ_COUNT_CSR {
         union {
            struct { 
               u32 txulp1_acc_plus_req_count : 8; // DWORD 0
               u32 txulp1_acc_minus_req_count : 8; // DWORD 0
               u32 txulp1_inv_req_count : 8;      // DWORD 0
               u32 txulp1_imm_req_count : 8;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP1_REQ_COUNT_CSR, *PUC_TXULP1_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP1_REQ_COUNT_CSR, sizeof (UC_TXULP1_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP1_REQ_COUNT_CSR {
         u32 txulp1_acc_plus_req_count : 8;       // DWORD 0
         u32 txulp1_acc_minus_req_count : 8;      // DWORD 0
         u32 txulp1_inv_req_count : 8;            // DWORD 0
         u32 txulp1_imm_req_count : 8;            // DWORD 0
      } SG_PACK UC_TXULP1_REQ_COUNT_CSR, *PUC_TXULP1_REQ_COUNT_CSR;

      typedef union _UC_TXULP1_REQ_COUNT_CSR_UNION {
         UC_TXULP1_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP1_REQ_COUNT_CSR_UNION, *PUC_TXULP1_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP1_REQ_COUNT_CSR_UNION, sizeof (UC_TXULP1_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXULP1 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP1_RESP_COUNT_CSR {
         union {
            struct { 
               u32 txulp1_imm_resp_count : 8;     // DWORD 0
               u32 txulp1_inv_resp_count : 8;     // DWORD 0
               u32 txulp1_acc_minus_resp_count : 8; // DWORD 0
               u32 txulp1_acc_plus_resp_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP1_RESP_COUNT_CSR, *PUC_TXULP1_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP1_RESP_COUNT_CSR, sizeof (UC_TXULP1_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP1_RESP_COUNT_CSR {
         u32 txulp1_imm_resp_count : 8;           // DWORD 0
         u32 txulp1_inv_resp_count : 8;           // DWORD 0
         u32 txulp1_acc_minus_resp_count : 8;     // DWORD 0
         u32 txulp1_acc_plus_resp_count : 8;      // DWORD 0
      } SG_PACK UC_TXULP1_RESP_COUNT_CSR, *PUC_TXULP1_RESP_COUNT_CSR;

      typedef union _UC_TXULP1_RESP_COUNT_CSR_UNION {
         UC_TXULP1_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP1_RESP_COUNT_CSR_UNION, *PUC_TXULP1_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP1_RESP_COUNT_CSR_UNION, sizeof (UC_TXULP1_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // TXULP1 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP1_RESP_COUNT_CSR {
         union {
            struct { 
               u32 txulp1_acc_plus_resp_count : 8; // DWORD 0
               u32 txulp1_acc_minus_resp_count : 8; // DWORD 0
               u32 txulp1_inv_resp_count : 8;     // DWORD 0
               u32 txulp1_imm_resp_count : 8;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP1_RESP_COUNT_CSR, *PUC_TXULP1_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP1_RESP_COUNT_CSR, sizeof (UC_TXULP1_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP1_RESP_COUNT_CSR {
         u32 txulp1_acc_plus_resp_count : 8;      // DWORD 0
         u32 txulp1_acc_minus_resp_count : 8;     // DWORD 0
         u32 txulp1_inv_resp_count : 8;           // DWORD 0
         u32 txulp1_imm_resp_count : 8;           // DWORD 0
      } SG_PACK UC_TXULP1_RESP_COUNT_CSR, *PUC_TXULP1_RESP_COUNT_CSR;

      typedef union _UC_TXULP1_RESP_COUNT_CSR_UNION {
         UC_TXULP1_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP1_RESP_COUNT_CSR_UNION, *PUC_TXULP1_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP1_RESP_COUNT_CSR_UNION, sizeof (UC_TXULP1_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXULP2 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP2_REQ_COUNT_CSR {
         union {
            struct { 
               u32 txulp2_imm_req_count : 8;      // DWORD 0
               u32 txulp2_inv_req_count : 8;      // DWORD 0
               u32 txulp2_acc_minus_req_count : 8; // DWORD 0
               u32 txulp2_acc_plus_req_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP2_REQ_COUNT_CSR, *PUC_TXULP2_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP2_REQ_COUNT_CSR, sizeof (UC_TXULP2_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP2_REQ_COUNT_CSR {
         u32 txulp2_imm_req_count : 8;            // DWORD 0
         u32 txulp2_inv_req_count : 8;            // DWORD 0
         u32 txulp2_acc_minus_req_count : 8;      // DWORD 0
         u32 txulp2_acc_plus_req_count : 8;       // DWORD 0
      } SG_PACK UC_TXULP2_REQ_COUNT_CSR, *PUC_TXULP2_REQ_COUNT_CSR;

      typedef union _UC_TXULP2_REQ_COUNT_CSR_UNION {
         UC_TXULP2_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP2_REQ_COUNT_CSR_UNION, *PUC_TXULP2_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP2_REQ_COUNT_CSR_UNION, sizeof (UC_TXULP2_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // TXULP2 Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP2_REQ_COUNT_CSR {
         union {
            struct { 
               u32 txulp2_acc_plus_req_count : 8; // DWORD 0
               u32 txulp2_acc_minus_req_count : 8; // DWORD 0
               u32 txulp2_inv_req_count : 8;      // DWORD 0
               u32 txulp2_imm_req_count : 8;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP2_REQ_COUNT_CSR, *PUC_TXULP2_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP2_REQ_COUNT_CSR, sizeof (UC_TXULP2_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP2_REQ_COUNT_CSR {
         u32 txulp2_acc_plus_req_count : 8;       // DWORD 0
         u32 txulp2_acc_minus_req_count : 8;      // DWORD 0
         u32 txulp2_inv_req_count : 8;            // DWORD 0
         u32 txulp2_imm_req_count : 8;            // DWORD 0
      } SG_PACK UC_TXULP2_REQ_COUNT_CSR, *PUC_TXULP2_REQ_COUNT_CSR;

      typedef union _UC_TXULP2_REQ_COUNT_CSR_UNION {
         UC_TXULP2_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP2_REQ_COUNT_CSR_UNION, *PUC_TXULP2_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP2_REQ_COUNT_CSR_UNION, sizeof (UC_TXULP2_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXULP2 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP2_RESP_COUNT_CSR {
         union {
            struct { 
               u32 txulp2_imm_resp_count : 8;     // DWORD 0
               u32 txulp2_inv_resp_count : 8;     // DWORD 0
               u32 txulp2_acc_minus_resp_count : 8; // DWORD 0
               u32 txulp2_acc_plus_resp_count : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP2_RESP_COUNT_CSR, *PUC_TXULP2_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP2_RESP_COUNT_CSR, sizeof (UC_TXULP2_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP2_RESP_COUNT_CSR {
         u32 txulp2_imm_resp_count : 8;           // DWORD 0
         u32 txulp2_inv_resp_count : 8;           // DWORD 0
         u32 txulp2_acc_minus_resp_count : 8;     // DWORD 0
         u32 txulp2_acc_plus_resp_count : 8;      // DWORD 0
      } SG_PACK UC_TXULP2_RESP_COUNT_CSR, *PUC_TXULP2_RESP_COUNT_CSR;

      typedef union _UC_TXULP2_RESP_COUNT_CSR_UNION {
         UC_TXULP2_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP2_RESP_COUNT_CSR_UNION, *PUC_TXULP2_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP2_RESP_COUNT_CSR_UNION, sizeof (UC_TXULP2_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // TXULP2 Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_TXULP2_RESP_COUNT_CSR {
         union {
            struct { 
               u32 txulp2_acc_plus_resp_count : 8; // DWORD 0
               u32 txulp2_acc_minus_resp_count : 8; // DWORD 0
               u32 txulp2_inv_resp_count : 8;     // DWORD 0
               u32 txulp2_imm_resp_count : 8;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_TXULP2_RESP_COUNT_CSR, *PUC_TXULP2_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_TXULP2_RESP_COUNT_CSR, sizeof (UC_TXULP2_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_TXULP2_RESP_COUNT_CSR {
         u32 txulp2_acc_plus_resp_count : 8;      // DWORD 0
         u32 txulp2_acc_minus_resp_count : 8;     // DWORD 0
         u32 txulp2_inv_resp_count : 8;           // DWORD 0
         u32 txulp2_imm_resp_count : 8;           // DWORD 0
      } SG_PACK UC_TXULP2_RESP_COUNT_CSR, *PUC_TXULP2_RESP_COUNT_CSR;

      typedef union _UC_TXULP2_RESP_COUNT_CSR_UNION {
         UC_TXULP2_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_TXULP2_RESP_COUNT_CSR_UNION, *PUC_TXULP2_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_TXULP2_RESP_COUNT_CSR_UNION, sizeof (UC_TXULP2_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_MPU_REQ_COUNT_CSR {
         union {
            struct { 
               u32 mpu_imm_req_count : 8;         // DWORD 0
               u32 mpu_inv_req_count : 8;         // DWORD 0
               u32 mpu_acc_minus_req_count : 8;   // DWORD 0
               u32 mpu_acc_plus_req_count : 8;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_MPU_REQ_COUNT_CSR, *PUC_MPU_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_MPU_REQ_COUNT_CSR, sizeof (UC_MPU_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_MPU_REQ_COUNT_CSR {
         u32 mpu_imm_req_count : 8;               // DWORD 0
         u32 mpu_inv_req_count : 8;               // DWORD 0
         u32 mpu_acc_minus_req_count : 8;         // DWORD 0
         u32 mpu_acc_plus_req_count : 8;          // DWORD 0
      } SG_PACK UC_MPU_REQ_COUNT_CSR, *PUC_MPU_REQ_COUNT_CSR;

      typedef union _UC_MPU_REQ_COUNT_CSR_UNION {
         UC_MPU_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_MPU_REQ_COUNT_CSR_UNION, *PUC_MPU_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_MPU_REQ_COUNT_CSR_UNION, sizeof (UC_MPU_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // MPU Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_MPU_REQ_COUNT_CSR {
         union {
            struct { 
               u32 mpu_acc_plus_req_count : 8;    // DWORD 0
               u32 mpu_acc_minus_req_count : 8;   // DWORD 0
               u32 mpu_inv_req_count : 8;         // DWORD 0
               u32 mpu_imm_req_count : 8;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_MPU_REQ_COUNT_CSR, *PUC_MPU_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_MPU_REQ_COUNT_CSR, sizeof (UC_MPU_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_MPU_REQ_COUNT_CSR {
         u32 mpu_acc_plus_req_count : 8;          // DWORD 0
         u32 mpu_acc_minus_req_count : 8;         // DWORD 0
         u32 mpu_inv_req_count : 8;               // DWORD 0
         u32 mpu_imm_req_count : 8;               // DWORD 0
      } SG_PACK UC_MPU_REQ_COUNT_CSR, *PUC_MPU_REQ_COUNT_CSR;

      typedef union _UC_MPU_REQ_COUNT_CSR_UNION {
         UC_MPU_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_MPU_REQ_COUNT_CSR_UNION, *PUC_MPU_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_MPU_REQ_COUNT_CSR_UNION, sizeof (UC_MPU_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_MPU_RESP_COUNT_CSR {
         union {
            struct { 
               u32 mpu_imm_resp_count : 8;        // DWORD 0
               u32 mpu_inv_resp_count : 8;        // DWORD 0
               u32 mpu_acc_minus_resp_count : 8;  // DWORD 0
               u32 mpu_acc_plus_resp_count : 8;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_MPU_RESP_COUNT_CSR, *PUC_MPU_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_MPU_RESP_COUNT_CSR, sizeof (UC_MPU_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_MPU_RESP_COUNT_CSR {
         u32 mpu_imm_resp_count : 8;              // DWORD 0
         u32 mpu_inv_resp_count : 8;              // DWORD 0
         u32 mpu_acc_minus_resp_count : 8;        // DWORD 0
         u32 mpu_acc_plus_resp_count : 8;         // DWORD 0
      } SG_PACK UC_MPU_RESP_COUNT_CSR, *PUC_MPU_RESP_COUNT_CSR;

      typedef union _UC_MPU_RESP_COUNT_CSR_UNION {
         UC_MPU_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_MPU_RESP_COUNT_CSR_UNION, *PUC_MPU_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_MPU_RESP_COUNT_CSR_UNION, sizeof (UC_MPU_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // MPU Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_MPU_RESP_COUNT_CSR {
         union {
            struct { 
               u32 mpu_acc_plus_resp_count : 8;   // DWORD 0
               u32 mpu_acc_minus_resp_count : 8;  // DWORD 0
               u32 mpu_inv_resp_count : 8;        // DWORD 0
               u32 mpu_imm_resp_count : 8;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_MPU_RESP_COUNT_CSR, *PUC_MPU_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_MPU_RESP_COUNT_CSR, sizeof (UC_MPU_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_MPU_RESP_COUNT_CSR {
         u32 mpu_acc_plus_resp_count : 8;         // DWORD 0
         u32 mpu_acc_minus_resp_count : 8;        // DWORD 0
         u32 mpu_inv_resp_count : 8;              // DWORD 0
         u32 mpu_imm_resp_count : 8;              // DWORD 0
      } SG_PACK UC_MPU_RESP_COUNT_CSR, *PUC_MPU_RESP_COUNT_CSR;

      typedef union _UC_MPU_RESP_COUNT_CSR_UNION {
         UC_MPU_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_MPU_RESP_COUNT_CSR_UNION, *PUC_MPU_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_MPU_RESP_COUNT_CSR_UNION, sizeof (UC_MPU_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PTC Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_PTC_REQ_COUNT_CSR {
         union {
            struct { 
               u32 ptc_req_count;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_PTC_REQ_COUNT_CSR, *PUC_PTC_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_PTC_REQ_COUNT_CSR, sizeof (UC_PTC_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_PTC_REQ_COUNT_CSR {
         u32 ptc_req_count;                       // DWORD 0
      } SG_PACK UC_PTC_REQ_COUNT_CSR, *PUC_PTC_REQ_COUNT_CSR;

      typedef union _UC_PTC_REQ_COUNT_CSR_UNION {
         UC_PTC_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_PTC_REQ_COUNT_CSR_UNION, *PUC_PTC_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_PTC_REQ_COUNT_CSR_UNION, sizeof (UC_PTC_REQ_COUNT_CSR_UNION) == 4);
   #endif


#else
   // PTC Request Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_PTC_REQ_COUNT_CSR {
         union {
            struct { 
               u32 ptc_req_count;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_PTC_REQ_COUNT_CSR, *PUC_PTC_REQ_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_PTC_REQ_COUNT_CSR, sizeof (UC_PTC_REQ_COUNT_CSR) == 4);

   #else
      typedef struct _UC_PTC_REQ_COUNT_CSR {
         u32 ptc_req_count;                       // DWORD 0
      } SG_PACK UC_PTC_REQ_COUNT_CSR, *PUC_PTC_REQ_COUNT_CSR;

      typedef union _UC_PTC_REQ_COUNT_CSR_UNION {
         UC_PTC_REQ_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_PTC_REQ_COUNT_CSR_UNION, *PUC_PTC_REQ_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_PTC_REQ_COUNT_CSR_UNION, sizeof (UC_PTC_REQ_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // PTC Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_PTC_RESP_COUNT_CSR {
         union {
            struct { 
               u32 ptc_resp_count;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_PTC_RESP_COUNT_CSR, *PUC_PTC_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_PTC_RESP_COUNT_CSR, sizeof (UC_PTC_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_PTC_RESP_COUNT_CSR {
         u32 ptc_resp_count;                      // DWORD 0
      } SG_PACK UC_PTC_RESP_COUNT_CSR, *PUC_PTC_RESP_COUNT_CSR;

      typedef union _UC_PTC_RESP_COUNT_CSR_UNION {
         UC_PTC_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_PTC_RESP_COUNT_CSR_UNION, *PUC_PTC_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_PTC_RESP_COUNT_CSR_UNION, sizeof (UC_PTC_RESP_COUNT_CSR_UNION) == 4);
   #endif


#else
   // PTC Response Count Register. This is a debug register.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_PTC_RESP_COUNT_CSR {
         union {
            struct { 
               u32 ptc_resp_count;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_PTC_RESP_COUNT_CSR, *PUC_PTC_RESP_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_PTC_RESP_COUNT_CSR, sizeof (UC_PTC_RESP_COUNT_CSR) == 4);

   #else
      typedef struct _UC_PTC_RESP_COUNT_CSR {
         u32 ptc_resp_count;                      // DWORD 0
      } SG_PACK UC_PTC_RESP_COUNT_CSR, *PUC_PTC_RESP_COUNT_CSR;

      typedef union _UC_PTC_RESP_COUNT_CSR_UNION {
         UC_PTC_RESP_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_PTC_RESP_COUNT_CSR_UNION, *PUC_PTC_RESP_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_PTC_RESP_COUNT_CSR_UNION, sizeof (UC_PTC_RESP_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Write Request Count Register. This is a debug register, counting UC requests to
   // WDMA.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_WDMA_IDMC_COUNT_CSR {
         union {
            struct { 
               u32 wdma_idmc_count;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_WDMA_IDMC_COUNT_CSR, *PUC_WDMA_IDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_WDMA_IDMC_COUNT_CSR, sizeof (UC_WDMA_IDMC_COUNT_CSR) == 4);

   #else
      typedef struct _UC_WDMA_IDMC_COUNT_CSR {
         u32 wdma_idmc_count;                     // DWORD 0
      } SG_PACK UC_WDMA_IDMC_COUNT_CSR, *PUC_WDMA_IDMC_COUNT_CSR;

      typedef union _UC_WDMA_IDMC_COUNT_CSR_UNION {
         UC_WDMA_IDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_WDMA_IDMC_COUNT_CSR_UNION, *PUC_WDMA_IDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_WDMA_IDMC_COUNT_CSR_UNION, sizeof (UC_WDMA_IDMC_COUNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Write Request Count Register. This is a debug register, counting UC requests to
   // WDMA.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_WDMA_IDMC_COUNT_CSR {
         union {
            struct { 
               u32 wdma_idmc_count;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_WDMA_IDMC_COUNT_CSR, *PUC_WDMA_IDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_WDMA_IDMC_COUNT_CSR, sizeof (UC_WDMA_IDMC_COUNT_CSR) == 4);

   #else
      typedef struct _UC_WDMA_IDMC_COUNT_CSR {
         u32 wdma_idmc_count;                     // DWORD 0
      } SG_PACK UC_WDMA_IDMC_COUNT_CSR, *PUC_WDMA_IDMC_COUNT_CSR;

      typedef union _UC_WDMA_IDMC_COUNT_CSR_UNION {
         UC_WDMA_IDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_WDMA_IDMC_COUNT_CSR_UNION, *PUC_WDMA_IDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_WDMA_IDMC_COUNT_CSR_UNION, sizeof (UC_WDMA_IDMC_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Completion Count Register. This is a debug register, counting WDMA completions
   // back to UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_WDMA_CDMC_COUNT_CSR {
         union {
            struct { 
               u32 wdma_cdmc_count;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_WDMA_CDMC_COUNT_CSR, *PUC_WDMA_CDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_WDMA_CDMC_COUNT_CSR, sizeof (UC_WDMA_CDMC_COUNT_CSR) == 4);

   #else
      typedef struct _UC_WDMA_CDMC_COUNT_CSR {
         u32 wdma_cdmc_count;                     // DWORD 0
      } SG_PACK UC_WDMA_CDMC_COUNT_CSR, *PUC_WDMA_CDMC_COUNT_CSR;

      typedef union _UC_WDMA_CDMC_COUNT_CSR_UNION {
         UC_WDMA_CDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_WDMA_CDMC_COUNT_CSR_UNION, *PUC_WDMA_CDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_WDMA_CDMC_COUNT_CSR_UNION, sizeof (UC_WDMA_CDMC_COUNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Completion Count Register. This is a debug register, counting WDMA completions
   // back to UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_WDMA_CDMC_COUNT_CSR {
         union {
            struct { 
               u32 wdma_cdmc_count;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_WDMA_CDMC_COUNT_CSR, *PUC_WDMA_CDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_WDMA_CDMC_COUNT_CSR, sizeof (UC_WDMA_CDMC_COUNT_CSR) == 4);

   #else
      typedef struct _UC_WDMA_CDMC_COUNT_CSR {
         u32 wdma_cdmc_count;                     // DWORD 0
      } SG_PACK UC_WDMA_CDMC_COUNT_CSR, *PUC_WDMA_CDMC_COUNT_CSR;

      typedef union _UC_WDMA_CDMC_COUNT_CSR_UNION {
         UC_WDMA_CDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_WDMA_CDMC_COUNT_CSR_UNION, *PUC_WDMA_CDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_WDMA_CDMC_COUNT_CSR_UNION, sizeof (UC_WDMA_CDMC_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RDMA Read Request Count Register. This is a debug register, counting UC requests to
   // RDMA.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RDMA_IDMC_COUNT_CSR {
         union {
            struct { 
               u32 rdma_idmc_count;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RDMA_IDMC_COUNT_CSR, *PUC_RDMA_IDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RDMA_IDMC_COUNT_CSR, sizeof (UC_RDMA_IDMC_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RDMA_IDMC_COUNT_CSR {
         u32 rdma_idmc_count;                     // DWORD 0
      } SG_PACK UC_RDMA_IDMC_COUNT_CSR, *PUC_RDMA_IDMC_COUNT_CSR;

      typedef union _UC_RDMA_IDMC_COUNT_CSR_UNION {
         UC_RDMA_IDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RDMA_IDMC_COUNT_CSR_UNION, *PUC_RDMA_IDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RDMA_IDMC_COUNT_CSR_UNION, sizeof (UC_RDMA_IDMC_COUNT_CSR_UNION) == 4);
   #endif


#else
   // RDMA Read Request Count Register. This is a debug register, counting UC requests to
   // RDMA.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RDMA_IDMC_COUNT_CSR {
         union {
            struct { 
               u32 rdma_idmc_count;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RDMA_IDMC_COUNT_CSR, *PUC_RDMA_IDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RDMA_IDMC_COUNT_CSR, sizeof (UC_RDMA_IDMC_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RDMA_IDMC_COUNT_CSR {
         u32 rdma_idmc_count;                     // DWORD 0
      } SG_PACK UC_RDMA_IDMC_COUNT_CSR, *PUC_RDMA_IDMC_COUNT_CSR;

      typedef union _UC_RDMA_IDMC_COUNT_CSR_UNION {
         UC_RDMA_IDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RDMA_IDMC_COUNT_CSR_UNION, *PUC_RDMA_IDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RDMA_IDMC_COUNT_CSR_UNION, sizeof (UC_RDMA_IDMC_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RDMA Completion Count Register. This is a debug register, counting RDMA completions
   // back to UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RDMA_CDMC_COUNT_CSR {
         union {
            struct { 
               u32 rdma_cdmc_count;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RDMA_CDMC_COUNT_CSR, *PUC_RDMA_CDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RDMA_CDMC_COUNT_CSR, sizeof (UC_RDMA_CDMC_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RDMA_CDMC_COUNT_CSR {
         u32 rdma_cdmc_count;                     // DWORD 0
      } SG_PACK UC_RDMA_CDMC_COUNT_CSR, *PUC_RDMA_CDMC_COUNT_CSR;

      typedef union _UC_RDMA_CDMC_COUNT_CSR_UNION {
         UC_RDMA_CDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RDMA_CDMC_COUNT_CSR_UNION, *PUC_RDMA_CDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RDMA_CDMC_COUNT_CSR_UNION, sizeof (UC_RDMA_CDMC_COUNT_CSR_UNION) == 4);
   #endif


#else
   // RDMA Completion Count Register. This is a debug register, counting RDMA completions
   // back to UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_RDMA_CDMC_COUNT_CSR {
         union {
            struct { 
               u32 rdma_cdmc_count;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_RDMA_CDMC_COUNT_CSR, *PUC_RDMA_CDMC_COUNT_CSR;

      SG_C_ASSERT(__sizeof__UC_RDMA_CDMC_COUNT_CSR, sizeof (UC_RDMA_CDMC_COUNT_CSR) == 4);

   #else
      typedef struct _UC_RDMA_CDMC_COUNT_CSR {
         u32 rdma_cdmc_count;                     // DWORD 0
      } SG_PACK UC_RDMA_CDMC_COUNT_CSR, *PUC_RDMA_CDMC_COUNT_CSR;

      typedef union _UC_RDMA_CDMC_COUNT_CSR_UNION {
         UC_RDMA_CDMC_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_RDMA_CDMC_COUNT_CSR_UNION, *PUC_RDMA_CDMC_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_RDMA_CDMC_COUNT_CSR_UNION, sizeof (UC_RDMA_CDMC_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The lower 32 bits of the CFIFO SRAM as a result of a READ operation.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CFIFO_SRAM_LO_CSR {
         union {
            struct { 
               u32 addr_lo;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CFIFO_SRAM_LO_CSR, *PUC_CFIFO_SRAM_LO_CSR;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_LO_CSR, sizeof (UC_CFIFO_SRAM_LO_CSR) == 4);

   #else
      typedef struct _UC_CFIFO_SRAM_LO_CSR {
         u32 addr_lo;                             // DWORD 0
      } SG_PACK UC_CFIFO_SRAM_LO_CSR, *PUC_CFIFO_SRAM_LO_CSR;

      typedef union _UC_CFIFO_SRAM_LO_CSR_UNION {
         UC_CFIFO_SRAM_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CFIFO_SRAM_LO_CSR_UNION, *PUC_CFIFO_SRAM_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_LO_CSR_UNION, sizeof (UC_CFIFO_SRAM_LO_CSR_UNION) == 4);
   #endif


#else
   // The lower 32 bits of the CFIFO SRAM as a result of a READ operation.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CFIFO_SRAM_LO_CSR {
         union {
            struct { 
               u32 addr_lo;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CFIFO_SRAM_LO_CSR, *PUC_CFIFO_SRAM_LO_CSR;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_LO_CSR, sizeof (UC_CFIFO_SRAM_LO_CSR) == 4);

   #else
      typedef struct _UC_CFIFO_SRAM_LO_CSR {
         u32 addr_lo;                             // DWORD 0
      } SG_PACK UC_CFIFO_SRAM_LO_CSR, *PUC_CFIFO_SRAM_LO_CSR;

      typedef union _UC_CFIFO_SRAM_LO_CSR_UNION {
         UC_CFIFO_SRAM_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CFIFO_SRAM_LO_CSR_UNION, *PUC_CFIFO_SRAM_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_LO_CSR_UNION, sizeof (UC_CFIFO_SRAM_LO_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The higher 32 bits of the CFIFO SRAM as a result of a READ operation.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CFIFO_SRAM_HI_CSR {
         union {
            struct { 
               u32 addr_hi;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CFIFO_SRAM_HI_CSR, *PUC_CFIFO_SRAM_HI_CSR;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_HI_CSR, sizeof (UC_CFIFO_SRAM_HI_CSR) == 4);

   #else
      typedef struct _UC_CFIFO_SRAM_HI_CSR {
         u32 addr_hi;                             // DWORD 0
      } SG_PACK UC_CFIFO_SRAM_HI_CSR, *PUC_CFIFO_SRAM_HI_CSR;

      typedef union _UC_CFIFO_SRAM_HI_CSR_UNION {
         UC_CFIFO_SRAM_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CFIFO_SRAM_HI_CSR_UNION, *PUC_CFIFO_SRAM_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_HI_CSR_UNION, sizeof (UC_CFIFO_SRAM_HI_CSR_UNION) == 4);
   #endif


#else
   // The higher 32 bits of the CFIFO SRAM as a result of a READ operation.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CFIFO_SRAM_HI_CSR {
         union {
            struct { 
               u32 addr_hi;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CFIFO_SRAM_HI_CSR, *PUC_CFIFO_SRAM_HI_CSR;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_HI_CSR, sizeof (UC_CFIFO_SRAM_HI_CSR) == 4);

   #else
      typedef struct _UC_CFIFO_SRAM_HI_CSR {
         u32 addr_hi;                             // DWORD 0
      } SG_PACK UC_CFIFO_SRAM_HI_CSR, *PUC_CFIFO_SRAM_HI_CSR;

      typedef union _UC_CFIFO_SRAM_HI_CSR_UNION {
         UC_CFIFO_SRAM_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CFIFO_SRAM_HI_CSR_UNION, *PUC_CFIFO_SRAM_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_HI_CSR_UNION, sizeof (UC_CFIFO_SRAM_HI_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CFIFO SRAM index to access a particular row.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CFIFO_SRAM_INDEX_CSR {
         union {
            struct { 
               u32 idx;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CFIFO_SRAM_INDEX_CSR, *PUC_CFIFO_SRAM_INDEX_CSR;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_INDEX_CSR, sizeof (UC_CFIFO_SRAM_INDEX_CSR) == 4);

   #else
      typedef struct _UC_CFIFO_SRAM_INDEX_CSR {
         u32 idx;                                 // DWORD 0
      } SG_PACK UC_CFIFO_SRAM_INDEX_CSR, *PUC_CFIFO_SRAM_INDEX_CSR;

      typedef union _UC_CFIFO_SRAM_INDEX_CSR_UNION {
         UC_CFIFO_SRAM_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CFIFO_SRAM_INDEX_CSR_UNION, *PUC_CFIFO_SRAM_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_INDEX_CSR_UNION, sizeof (UC_CFIFO_SRAM_INDEX_CSR_UNION) == 4);
   #endif


#else
   // CFIFO SRAM index to access a particular row.
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CFIFO_SRAM_INDEX_CSR {
         union {
            struct { 
               u32 idx;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CFIFO_SRAM_INDEX_CSR, *PUC_CFIFO_SRAM_INDEX_CSR;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_INDEX_CSR, sizeof (UC_CFIFO_SRAM_INDEX_CSR) == 4);

   #else
      typedef struct _UC_CFIFO_SRAM_INDEX_CSR {
         u32 idx;                                 // DWORD 0
      } SG_PACK UC_CFIFO_SRAM_INDEX_CSR, *PUC_CFIFO_SRAM_INDEX_CSR;

      typedef union _UC_CFIFO_SRAM_INDEX_CSR_UNION {
         UC_CFIFO_SRAM_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CFIFO_SRAM_INDEX_CSR_UNION, *PUC_CFIFO_SRAM_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CFIFO_SRAM_INDEX_CSR_UNION, sizeof (UC_CFIFO_SRAM_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register will be used for misc control tuning bits
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CONTROL_2_CSR {
         union {
            struct { 
               u32 enable : 12;                   // DWORD 0
               u32 wdma_hold_request_enable : 1;  // DWORD 0
               u32 wdma_cdmc_full_enable : 1;     // DWORD 0
               u32 rdma_cdmc_full_enable : 1;     // DWORD 0
               u32 ptc_cpq_full_enable : 1;       // DWORD 0
               u32 control : 12;                  // DWORD 0
               u32 pq_full_throttle : 4;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CONTROL_2_CSR, *PUC_CONTROL_2_CSR;

      SG_C_ASSERT(__sizeof__UC_CONTROL_2_CSR, sizeof (UC_CONTROL_2_CSR) == 4);

   #else
      typedef struct _UC_CONTROL_2_CSR {
         u32 enable : 12;                         // DWORD 0
         u32 wdma_hold_request_enable : 1;        // DWORD 0
         u32 wdma_cdmc_full_enable : 1;           // DWORD 0
         u32 rdma_cdmc_full_enable : 1;           // DWORD 0
         u32 ptc_cpq_full_enable : 1;             // DWORD 0
         u32 control : 12;                        // DWORD 0
         u32 pq_full_throttle : 4;                // DWORD 0
      } SG_PACK UC_CONTROL_2_CSR, *PUC_CONTROL_2_CSR;

      typedef union _UC_CONTROL_2_CSR_UNION {
         UC_CONTROL_2_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CONTROL_2_CSR_UNION, *PUC_CONTROL_2_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CONTROL_2_CSR_UNION, sizeof (UC_CONTROL_2_CSR_UNION) == 4);
   #endif


#else
   // This register will be used for misc control tuning bits
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CONTROL_2_CSR {
         union {
            struct { 
               u32 pq_full_throttle : 4;          // DWORD 0
               u32 control : 12;                  // DWORD 0
               u32 ptc_cpq_full_enable : 1;       // DWORD 0
               u32 rdma_cdmc_full_enable : 1;     // DWORD 0
               u32 wdma_cdmc_full_enable : 1;     // DWORD 0
               u32 wdma_hold_request_enable : 1;  // DWORD 0
               u32 enable : 12;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK UC_CONTROL_2_CSR, *PUC_CONTROL_2_CSR;

      SG_C_ASSERT(__sizeof__UC_CONTROL_2_CSR, sizeof (UC_CONTROL_2_CSR) == 4);

   #else
      typedef struct _UC_CONTROL_2_CSR {
         u32 pq_full_throttle : 4;                // DWORD 0
         u32 control : 12;                        // DWORD 0
         u32 ptc_cpq_full_enable : 1;             // DWORD 0
         u32 rdma_cdmc_full_enable : 1;           // DWORD 0
         u32 wdma_cdmc_full_enable : 1;           // DWORD 0
         u32 wdma_hold_request_enable : 1;        // DWORD 0
         u32 enable : 12;                         // DWORD 0
      } SG_PACK UC_CONTROL_2_CSR, *PUC_CONTROL_2_CSR;

      typedef union _UC_CONTROL_2_CSR_UNION {
         UC_CONTROL_2_CSR bits;
         u32 dw; // dword union
      } SG_PACK UC_CONTROL_2_CSR_UNION, *PUC_CONTROL_2_CSR_UNION;

      SG_C_ASSERT(__sizeof__UC_CONTROL_2_CSR_UNION, sizeof (UC_CONTROL_2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unified Cache Registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CSRMAP {
         union {
            struct { 
               UC_CONTROL_CSR control;
               UC_CRA_CSR cra;
               UC_COMMAND_CSR command;
               UC_RESP0_CSR resp0;
               UC_RESP1_CSR resp1;
               UC_TS_REQ_CSR ts_req;
               UC_TS_RESP_CSR ts_resp;
               UC_WEIGHT_ARB_CSR weight0_1;
               UC_WEIGHT_ARB_CSR weight2_3;
               UC_WEIGHT_ARB_CSR weight4_5;
               UC_WEIGHT_ARB_CSR weight6_7;
               UC_WEIGHT_ARB_CSR weight8_9;
               UC_WEIGHT_ARB_CSR_2 weight10_11;
               UC_WEIGHT_ARB_CSR_2 weight12_13;
               UC_WEIGHT_ARB_CSR_2 weight14_15;
               UC_WEIGHT_ARB_CSR weight16;
               UC_CRA_REMAP_CSR0 bit5_0;
               UC_CRA_REMAP_CSR1 bit11_6;
               UC_CRA_REMAP_CSR2 bit17_12;
               UC_CRA_REMAP_CSR3 bit23_18;
               UC_CRA_REMAP_CSR4 bit29_24;
               UC_CRA_REMAP_CSR5 bit31_30;
               UC_STAT_INDEX_CSR stat_index;
               UC_STAT_VALUE_CSR stat_value;
               UC_STAT_RANGE_INDEX_CSR stat_range_index;
               UC_STAT_RANGE_START_CSR stat_range_start;
               UC_STAT_RANGE_END_CSR stat_range_end;
               UC_CACHE_START_ADDR_CSR uc_cache_start_addr;
               UC_RE_ENABLE_CSR re_enable;
               UC_RECOVERABLE_ERROR_CSR re_cause;
               UC_UE_ENABLE_CSR ue_enable;
               UC_UNRECOVERABLE_ERROR_CSR ue_cause;
               UC_SMSTATUS0_CSR smstatus0;
               UC_SMSTATUS1_CSR smstatus1;
               UC_IPQRELRDYSTATUS_CSR ipqrdystatus;
               UC_IPQRELFULLSTATUS_CSR ipqfullstatus;
               UC_CPQFULLSTATUS_CSR cpqfullstatus;
               UC_CEV_REQ_COUNT_CSR cev_req_count;
               UC_CEV_RESP_COUNT_CSR cev_resp_count;
               UC_ERX_REQ_COUNT_CSR erx_req_count;
               UC_ERX_RESP_COUNT_CSR erx_resp_count;
               UC_RDMA_REQ_COUNT_CSR rdma_req_count;
               UC_WDMA_REQ_COUNT_CSR wdma_req_count;
               UC_RXULP0_REQ_COUNT_CSR rxulp0_req_count;
               UC_RXULP0_RESP_COUNT_CSR rxulp0_resp_count;
               UC_RXULP1_REQ_COUNT_CSR rxulp1_req_count;
               UC_RXULP1_RESP_COUNT_CSR rxulp1_resp_count;
               UC_RXULP2_REQ_COUNT_CSR rxulp2_req_count;
               UC_RXULP2_RESP_COUNT_CSR rxulp2_resp_count;
               UC_TXULP0_REQ_COUNT_CSR txulp0_req_count;
               UC_TXULP0_RESP_COUNT_CSR txulp0_resp_count;
               UC_TXULP1_REQ_COUNT_CSR txulp1_req_count;
               UC_TXULP1_RESP_COUNT_CSR txulp1_resp_count;
               UC_TXULP2_REQ_COUNT_CSR txulp2_req_count;
               UC_TXULP2_RESP_COUNT_CSR txulp2_resp_count;
               UC_MPU_REQ_COUNT_CSR mpu_req_count;
               UC_MPU_RESP_COUNT_CSR mpu_resp_count;
               UC_PTC_REQ_COUNT_CSR ptc_req_count;
               UC_PTC_RESP_COUNT_CSR ptc_resp_count;
               UC_WDMA_IDMC_COUNT_CSR wdma_idmc_count;
               UC_WDMA_CDMC_COUNT_CSR wdma_cdmc_count;
               UC_RDMA_IDMC_COUNT_CSR rdma_idmc_count;
               UC_RDMA_CDMC_COUNT_CSR rdma_cdmc_count;
               UC_CFIFO_SRAM_LO_CSR cfifo_sram_lo;
               UC_CFIFO_SRAM_HI_CSR cfifo_sram_hi;
               UC_CFIFO_SRAM_INDEX_CSR cfifo_sram_index;
               UC_CONTROL_2_CSR control_2;
               UC_ERRORCRA_CSR errorcra;
               HWDBG_CSRMAP hwdbg;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp0_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp0_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp1_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp1_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp2_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp2_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp0_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp0_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp1_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp1_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp2_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp2_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } mpu_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } mpu_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } cev_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } erx_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rdma_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } wdma_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
                  PQ_DATA2_WRITE_CSR wrdata2;
                  PQ_DATA2_READ_CSR rddata2;
                  PQ_DATA3_WRITE_CSR wrdata3;
                  PQ_DATA3_READ_CSR rddata3;
               } prefifo_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
                  PQ_DATA2_WRITE_CSR wrdata2;
                  PQ_DATA2_READ_CSR rddata2;
                  PQ_DATA3_WRITE_CSR wrdata3;
                  PQ_DATA3_READ_CSR rddata3;
               } ptc_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } rdma_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } wdma_pq;
               u32 rsvd0[27];                     // DWORDS 229 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK UC_CSRMAP, *PUC_CSRMAP;

      SG_C_ASSERT(__sizeof__UC_CSRMAP, sizeof (UC_CSRMAP) == 1024);

   #else
      typedef struct _UC_CSRMAP {
         UC_CONTROL_CSR control;
         UC_CRA_CSR cra;
         UC_COMMAND_CSR command;
         UC_RESP0_CSR resp0;
         UC_RESP1_CSR resp1;
         UC_TS_REQ_CSR ts_req;
         UC_TS_RESP_CSR ts_resp;
         UC_WEIGHT_ARB_CSR weight0_1;
         UC_WEIGHT_ARB_CSR weight2_3;
         UC_WEIGHT_ARB_CSR weight4_5;
         UC_WEIGHT_ARB_CSR weight6_7;
         UC_WEIGHT_ARB_CSR weight8_9;
         UC_WEIGHT_ARB_CSR_2 weight10_11;
         UC_WEIGHT_ARB_CSR_2 weight12_13;
         UC_WEIGHT_ARB_CSR_2 weight14_15;
         UC_WEIGHT_ARB_CSR weight16;
         UC_CRA_REMAP_CSR0 bit5_0;
         UC_CRA_REMAP_CSR1 bit11_6;
         UC_CRA_REMAP_CSR2 bit17_12;
         UC_CRA_REMAP_CSR3 bit23_18;
         UC_CRA_REMAP_CSR4 bit29_24;
         UC_CRA_REMAP_CSR5 bit31_30;
         UC_STAT_INDEX_CSR stat_index;
         UC_STAT_VALUE_CSR stat_value;
         UC_STAT_RANGE_INDEX_CSR stat_range_index;
         UC_STAT_RANGE_START_CSR stat_range_start;
         UC_STAT_RANGE_END_CSR stat_range_end;
         UC_CACHE_START_ADDR_CSR uc_cache_start_addr;
         UC_RE_ENABLE_CSR re_enable;
         UC_RECOVERABLE_ERROR_CSR re_cause;
         UC_UE_ENABLE_CSR ue_enable;
         UC_UNRECOVERABLE_ERROR_CSR ue_cause;
         UC_SMSTATUS0_CSR smstatus0;
         UC_SMSTATUS1_CSR smstatus1;
         UC_IPQRELRDYSTATUS_CSR ipqrdystatus;
         UC_IPQRELFULLSTATUS_CSR ipqfullstatus;
         UC_CPQFULLSTATUS_CSR cpqfullstatus;
         UC_CEV_REQ_COUNT_CSR cev_req_count;
         UC_CEV_RESP_COUNT_CSR cev_resp_count;
         UC_ERX_REQ_COUNT_CSR erx_req_count;
         UC_ERX_RESP_COUNT_CSR erx_resp_count;
         UC_RDMA_REQ_COUNT_CSR rdma_req_count;
         UC_WDMA_REQ_COUNT_CSR wdma_req_count;
         UC_RXULP0_REQ_COUNT_CSR rxulp0_req_count;
         UC_RXULP0_RESP_COUNT_CSR rxulp0_resp_count;
         UC_RXULP1_REQ_COUNT_CSR rxulp1_req_count;
         UC_RXULP1_RESP_COUNT_CSR rxulp1_resp_count;
         UC_RXULP2_REQ_COUNT_CSR rxulp2_req_count;
         UC_RXULP2_RESP_COUNT_CSR rxulp2_resp_count;
         UC_TXULP0_REQ_COUNT_CSR txulp0_req_count;
         UC_TXULP0_RESP_COUNT_CSR txulp0_resp_count;
         UC_TXULP1_REQ_COUNT_CSR txulp1_req_count;
         UC_TXULP1_RESP_COUNT_CSR txulp1_resp_count;
         UC_TXULP2_REQ_COUNT_CSR txulp2_req_count;
         UC_TXULP2_RESP_COUNT_CSR txulp2_resp_count;
         UC_MPU_REQ_COUNT_CSR mpu_req_count;
         UC_MPU_RESP_COUNT_CSR mpu_resp_count;
         UC_PTC_REQ_COUNT_CSR ptc_req_count;
         UC_PTC_RESP_COUNT_CSR ptc_resp_count;
         UC_WDMA_IDMC_COUNT_CSR wdma_idmc_count;
         UC_WDMA_CDMC_COUNT_CSR wdma_cdmc_count;
         UC_RDMA_IDMC_COUNT_CSR rdma_idmc_count;
         UC_RDMA_CDMC_COUNT_CSR rdma_cdmc_count;
         UC_CFIFO_SRAM_LO_CSR cfifo_sram_lo;
         UC_CFIFO_SRAM_HI_CSR cfifo_sram_hi;
         UC_CFIFO_SRAM_INDEX_CSR cfifo_sram_index;
         UC_CONTROL_2_CSR control_2;
         UC_ERRORCRA_CSR errorcra;
         HWDBG_CSRMAP hwdbg;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp0_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp0_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp1_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp1_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp2_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp2_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp0_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp0_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp1_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp1_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp2_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp2_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } mpu_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } mpu_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } cev_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } erx_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rdma_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } wdma_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
            PQ_DATA2_WRITE_CSR wrdata2;
            PQ_DATA2_READ_CSR rddata2;
            PQ_DATA3_WRITE_CSR wrdata3;
            PQ_DATA3_READ_CSR rddata3;
         } prefifo_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
            PQ_DATA2_WRITE_CSR wrdata2;
            PQ_DATA2_READ_CSR rddata2;
            PQ_DATA3_WRITE_CSR wrdata3;
            PQ_DATA3_READ_CSR rddata3;
         } ptc_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } rdma_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } wdma_pq;
         u32 rsvd0[27];                           // DWORDS 229 to 255
      } SG_PACK UC_CSRMAP, *PUC_CSRMAP;

      typedef union _UC_CSRMAP_UNION {
         UC_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK UC_CSRMAP_UNION, *PUC_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__UC_CSRMAP_UNION, sizeof (UC_CSRMAP_UNION) == 1024);
   #endif


#else
   // Unified Cache Registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _UC_CSRMAP {
         union {
            struct { 
               UC_CONTROL_CSR control;
               UC_CRA_CSR cra;
               UC_COMMAND_CSR command;
               UC_RESP0_CSR resp0;
               UC_RESP1_CSR resp1;
               UC_TS_REQ_CSR ts_req;
               UC_TS_RESP_CSR ts_resp;
               UC_WEIGHT_ARB_CSR weight0_1;
               UC_WEIGHT_ARB_CSR weight2_3;
               UC_WEIGHT_ARB_CSR weight4_5;
               UC_WEIGHT_ARB_CSR weight6_7;
               UC_WEIGHT_ARB_CSR weight8_9;
               UC_WEIGHT_ARB_CSR_2 weight10_11;
               UC_WEIGHT_ARB_CSR_2 weight12_13;
               UC_WEIGHT_ARB_CSR_2 weight14_15;
               UC_WEIGHT_ARB_CSR weight16;
               UC_CRA_REMAP_CSR0 bit5_0;
               UC_CRA_REMAP_CSR1 bit11_6;
               UC_CRA_REMAP_CSR2 bit17_12;
               UC_CRA_REMAP_CSR3 bit23_18;
               UC_CRA_REMAP_CSR4 bit29_24;
               UC_CRA_REMAP_CSR5 bit31_30;
               UC_STAT_INDEX_CSR stat_index;
               UC_STAT_VALUE_CSR stat_value;
               UC_STAT_RANGE_INDEX_CSR stat_range_index;
               UC_STAT_RANGE_START_CSR stat_range_start;
               UC_STAT_RANGE_END_CSR stat_range_end;
               UC_CACHE_START_ADDR_CSR uc_cache_start_addr;
               UC_RE_ENABLE_CSR re_enable;
               UC_RECOVERABLE_ERROR_CSR re_cause;
               UC_UE_ENABLE_CSR ue_enable;
               UC_UNRECOVERABLE_ERROR_CSR ue_cause;
               UC_SMSTATUS0_CSR smstatus0;
               UC_SMSTATUS1_CSR smstatus1;
               UC_IPQRELRDYSTATUS_CSR ipqrdystatus;
               UC_IPQRELFULLSTATUS_CSR ipqfullstatus;
               UC_CPQFULLSTATUS_CSR cpqfullstatus;
               UC_CEV_REQ_COUNT_CSR cev_req_count;
               UC_CEV_RESP_COUNT_CSR cev_resp_count;
               UC_ERX_REQ_COUNT_CSR erx_req_count;
               UC_ERX_RESP_COUNT_CSR erx_resp_count;
               UC_RDMA_REQ_COUNT_CSR rdma_req_count;
               UC_WDMA_REQ_COUNT_CSR wdma_req_count;
               UC_RXULP0_REQ_COUNT_CSR rxulp0_req_count;
               UC_RXULP0_RESP_COUNT_CSR rxulp0_resp_count;
               UC_RXULP1_REQ_COUNT_CSR rxulp1_req_count;
               UC_RXULP1_RESP_COUNT_CSR rxulp1_resp_count;
               UC_RXULP2_REQ_COUNT_CSR rxulp2_req_count;
               UC_RXULP2_RESP_COUNT_CSR rxulp2_resp_count;
               UC_TXULP0_REQ_COUNT_CSR txulp0_req_count;
               UC_TXULP0_RESP_COUNT_CSR txulp0_resp_count;
               UC_TXULP1_REQ_COUNT_CSR txulp1_req_count;
               UC_TXULP1_RESP_COUNT_CSR txulp1_resp_count;
               UC_TXULP2_REQ_COUNT_CSR txulp2_req_count;
               UC_TXULP2_RESP_COUNT_CSR txulp2_resp_count;
               UC_MPU_REQ_COUNT_CSR mpu_req_count;
               UC_MPU_RESP_COUNT_CSR mpu_resp_count;
               UC_PTC_REQ_COUNT_CSR ptc_req_count;
               UC_PTC_RESP_COUNT_CSR ptc_resp_count;
               UC_WDMA_IDMC_COUNT_CSR wdma_idmc_count;
               UC_WDMA_CDMC_COUNT_CSR wdma_cdmc_count;
               UC_RDMA_IDMC_COUNT_CSR rdma_idmc_count;
               UC_RDMA_CDMC_COUNT_CSR rdma_cdmc_count;
               UC_CFIFO_SRAM_LO_CSR cfifo_sram_lo;
               UC_CFIFO_SRAM_HI_CSR cfifo_sram_hi;
               UC_CFIFO_SRAM_INDEX_CSR cfifo_sram_index;
               UC_CONTROL_2_CSR control_2;
               UC_ERRORCRA_CSR errorcra;
               HWDBG_CSRMAP hwdbg;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp0_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp0_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp1_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp1_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp2_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rxulp2_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp0_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp0_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp1_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp1_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp2_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } txulp2_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } mpu_req_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } mpu_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } cev_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } erx_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } rdma_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } wdma_rel_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
                  PQ_DATA2_WRITE_CSR wrdata2;
                  PQ_DATA2_READ_CSR rddata2;
                  PQ_DATA3_WRITE_CSR wrdata3;
                  PQ_DATA3_READ_CSR rddata3;
               } prefifo_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
                  PQ_DATA2_WRITE_CSR wrdata2;
                  PQ_DATA2_READ_CSR rddata2;
                  PQ_DATA3_WRITE_CSR wrdata3;
                  PQ_DATA3_READ_CSR rddata3;
               } ptc_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } rdma_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } wdma_pq;
               u32 rsvd0[27];                     // DWORDS 229 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK UC_CSRMAP, *PUC_CSRMAP;

      SG_C_ASSERT(__sizeof__UC_CSRMAP, sizeof (UC_CSRMAP) == 1024);

   #else
      typedef struct _UC_CSRMAP {
         UC_CONTROL_CSR control;
         UC_CRA_CSR cra;
         UC_COMMAND_CSR command;
         UC_RESP0_CSR resp0;
         UC_RESP1_CSR resp1;
         UC_TS_REQ_CSR ts_req;
         UC_TS_RESP_CSR ts_resp;
         UC_WEIGHT_ARB_CSR weight0_1;
         UC_WEIGHT_ARB_CSR weight2_3;
         UC_WEIGHT_ARB_CSR weight4_5;
         UC_WEIGHT_ARB_CSR weight6_7;
         UC_WEIGHT_ARB_CSR weight8_9;
         UC_WEIGHT_ARB_CSR_2 weight10_11;
         UC_WEIGHT_ARB_CSR_2 weight12_13;
         UC_WEIGHT_ARB_CSR_2 weight14_15;
         UC_WEIGHT_ARB_CSR weight16;
         UC_CRA_REMAP_CSR0 bit5_0;
         UC_CRA_REMAP_CSR1 bit11_6;
         UC_CRA_REMAP_CSR2 bit17_12;
         UC_CRA_REMAP_CSR3 bit23_18;
         UC_CRA_REMAP_CSR4 bit29_24;
         UC_CRA_REMAP_CSR5 bit31_30;
         UC_STAT_INDEX_CSR stat_index;
         UC_STAT_VALUE_CSR stat_value;
         UC_STAT_RANGE_INDEX_CSR stat_range_index;
         UC_STAT_RANGE_START_CSR stat_range_start;
         UC_STAT_RANGE_END_CSR stat_range_end;
         UC_CACHE_START_ADDR_CSR uc_cache_start_addr;
         UC_RE_ENABLE_CSR re_enable;
         UC_RECOVERABLE_ERROR_CSR re_cause;
         UC_UE_ENABLE_CSR ue_enable;
         UC_UNRECOVERABLE_ERROR_CSR ue_cause;
         UC_SMSTATUS0_CSR smstatus0;
         UC_SMSTATUS1_CSR smstatus1;
         UC_IPQRELRDYSTATUS_CSR ipqrdystatus;
         UC_IPQRELFULLSTATUS_CSR ipqfullstatus;
         UC_CPQFULLSTATUS_CSR cpqfullstatus;
         UC_CEV_REQ_COUNT_CSR cev_req_count;
         UC_CEV_RESP_COUNT_CSR cev_resp_count;
         UC_ERX_REQ_COUNT_CSR erx_req_count;
         UC_ERX_RESP_COUNT_CSR erx_resp_count;
         UC_RDMA_REQ_COUNT_CSR rdma_req_count;
         UC_WDMA_REQ_COUNT_CSR wdma_req_count;
         UC_RXULP0_REQ_COUNT_CSR rxulp0_req_count;
         UC_RXULP0_RESP_COUNT_CSR rxulp0_resp_count;
         UC_RXULP1_REQ_COUNT_CSR rxulp1_req_count;
         UC_RXULP1_RESP_COUNT_CSR rxulp1_resp_count;
         UC_RXULP2_REQ_COUNT_CSR rxulp2_req_count;
         UC_RXULP2_RESP_COUNT_CSR rxulp2_resp_count;
         UC_TXULP0_REQ_COUNT_CSR txulp0_req_count;
         UC_TXULP0_RESP_COUNT_CSR txulp0_resp_count;
         UC_TXULP1_REQ_COUNT_CSR txulp1_req_count;
         UC_TXULP1_RESP_COUNT_CSR txulp1_resp_count;
         UC_TXULP2_REQ_COUNT_CSR txulp2_req_count;
         UC_TXULP2_RESP_COUNT_CSR txulp2_resp_count;
         UC_MPU_REQ_COUNT_CSR mpu_req_count;
         UC_MPU_RESP_COUNT_CSR mpu_resp_count;
         UC_PTC_REQ_COUNT_CSR ptc_req_count;
         UC_PTC_RESP_COUNT_CSR ptc_resp_count;
         UC_WDMA_IDMC_COUNT_CSR wdma_idmc_count;
         UC_WDMA_CDMC_COUNT_CSR wdma_cdmc_count;
         UC_RDMA_IDMC_COUNT_CSR rdma_idmc_count;
         UC_RDMA_CDMC_COUNT_CSR rdma_cdmc_count;
         UC_CFIFO_SRAM_LO_CSR cfifo_sram_lo;
         UC_CFIFO_SRAM_HI_CSR cfifo_sram_hi;
         UC_CFIFO_SRAM_INDEX_CSR cfifo_sram_index;
         UC_CONTROL_2_CSR control_2;
         UC_ERRORCRA_CSR errorcra;
         HWDBG_CSRMAP hwdbg;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp0_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp0_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp1_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp1_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp2_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rxulp2_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp0_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp0_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp1_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp1_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp2_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } txulp2_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } mpu_req_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } mpu_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } cev_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } erx_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } rdma_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } wdma_rel_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
            PQ_DATA2_WRITE_CSR wrdata2;
            PQ_DATA2_READ_CSR rddata2;
            PQ_DATA3_WRITE_CSR wrdata3;
            PQ_DATA3_READ_CSR rddata3;
         } prefifo_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
            PQ_DATA2_WRITE_CSR wrdata2;
            PQ_DATA2_READ_CSR rddata2;
            PQ_DATA3_WRITE_CSR wrdata3;
            PQ_DATA3_READ_CSR rddata3;
         } ptc_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } rdma_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } wdma_pq;
         u32 rsvd0[27];                           // DWORDS 229 to 255
      } SG_PACK UC_CSRMAP, *PUC_CSRMAP;

      typedef union _UC_CSRMAP_UNION {
         UC_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK UC_CSRMAP_UNION, *PUC_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__UC_CSRMAP_UNION, sizeof (UC_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __uc_bmap_h__

